#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "DiffractionImage.h"
#include "Peak.h"

using namespace DI;

int main (int argc, char *argv[])
	{
	DiffractionImage* mainImage;
	DiffractionImage* otherImage;
	unsigned int* sqImg;
	int start,nimg;
		
	if(argc< 2)
		{
		printf("Wrong Number of arguments!\n\n");
		printf("Usage is  'automask [-start x y] <filename> ... <filename>' \n");
		return -1;
		}
	else
		{
		if(strcmp(argv[1],"-start")==0)
			start=4;
		else
			start=1;
		mainImage=new DiffractionImage(argv[start]);
		nimg=argc-start;
		if(nimg == 1)
			{
			printf("Warning: Only one image given, results might not be accurate\n");
			printf("         We recommend you use more than one image\n");
			}
		else
			{
			int size=mainImage->getWidth()*mainImage->getHeight();
			sqImg=new unsigned int[size];
			otherImage=new DiffractionImage();
			for(int i=start+1;i<argc;i++)
				{
				otherImage->load(argv[i]);
				mainImage->min(otherImage);
				}
			for(int i=0;i<mainImage->getWidth();i++)
				{
				for(int j=0;j<mainImage->getHeight();j++)
					{
					int value=mainImage->getPixelAt(i,j);
					if(value>65535)
						sqImg[(j*mainImage->getWidth())+i]=65535*65535;
					else
						sqImg[(j*mainImage->getWidth())+i]= value*value;
					}
				}
			mainImage->setImage(sqImg);
		/*	printf("ppm image: %s\n",mainImage->getImage(1,0,0,mainImage->getWidth(),
		                                           mainImage->getHeight()));*/
			delete otherImage;
			}
		if(start == 1)
			printf("%s\n",mainImage->autoMask(-1,-1));
		else
			printf("%s\n",mainImage->autoMask(atoi(argv[2]),atoi(argv[3])));
		delete(mainImage);
		delete [] sqImg;
		return 0;
		}
	}
