/* $Id: FATDEF.H,v 1.5 2008/06/09 17:37:55 mdw Exp $ */

/********************************************************************
* Copyright (c) 1995 - 2004, EMBL, Peter Keller
* 
* CCIF: a library to access and output data conforming to the
* CIF (Crystallographic Information File) and mmCIF (Macromolecular
* CIF) specifications, and other related specifications.
* 
* This library is free software: you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* version 3, modified in accordance with the provisions of the 
* license to address the requirements of UK law.
*
* You should have received a copy of the modified GNU Lesser General 
* Public License along with this library.  If not, copies may be 
* downloaded from http://www.ccp4.ac.uk/ccp4license.php
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
********************************************************************/

/* Hacked up stuff to change file/record attributes.
 * Why there is no FATDEF.H shipped is a mystery which only DEC can
 * answer */

/* This is consistent with the description in the I/O User's Reference
 * Manual part I (ACP QIO Record Attributes Area - exact section number
 * varies with VMS version */
struct FAT {
unsigned            fat$v_rtype     : 4;
unsigned            fat$v_fileorg   : 4;
unsigned char       fat$b_rattrib;
unsigned short int  fat$w_rsize;
unsigned long int   fat$l_hiblk;
unsigned long int   fat$l_efblk;
unsigned short int  fat$w_ffbyte;
unsigned char       fat$b_bktsize;
unsigned char       fat$b_vcfsize;
unsigned short int  fat$w_maxrec;
unsigned short int  fat$w_deftext;
unsigned short int  fat$w_gbc;
unsigned            fat$v_reserved1   : 16;
unsigned            fat$v_reserved2   : 32;
unsigned short int  fat$w_not_used;
unsigned short int  fat$w_versions;
};

/* These definitions are generated as follows:

 $  libr/extract=$fatdef sys$library:lib.mlb

Then delete the first and last two lines of lib.mar, and change each $EQU
to #define.
*/

#define	FAT$C_UNDEFINED	0
#define	FAT$C_FIXED	1
#define	FAT$C_VARIABLE	2
#define	FAT$C_VFC	3
#define	FAT$C_STREAM	4
#define	FAT$C_STREAMLF	5
#define	FAT$C_STREAMCR	6
#define	FAT$C_SEQUENTIAL	0
#define	FAT$C_RELATIVE	1
#define	FAT$C_INDEXED	2
#define	FAT$C_DIRECT	3
#define	FAT$M_FORTRANCC	1
#define	FAT$M_IMPLIEDCC	2
#define	FAT$M_PRINTCC	4
#define	FAT$M_NOSPAN	8
#define	FAT$M_MSBRCW	16
#define	FAT$K_LENGTH	32
#define	FAT$C_LENGTH	32
#define	FAT$S_FATDEF	32
#define	FAT$B_RTYPE	0
#define	FAT$S_RTYPE	4
#define	FAT$V_RTYPE	0
#define	FAT$S_FILEORG	4
#define	FAT$V_FILEORG	4
#define	FAT$B_RATTRIB	1
#define	FAT$V_FORTRANCC	0
#define	FAT$V_IMPLIEDCC	1
#define	FAT$V_PRINTCC	2
#define	FAT$V_NOSPAN	3
#define	FAT$V_MSBRCW	4
#define	FAT$W_RSIZE	2
#define	FAT$L_HIBLK	4
#define	FAT$W_HIBLKH	4
#define	FAT$W_HIBLKL	6
#define	FAT$L_EFBLK	8
#define	FAT$W_EFBLKH	8
#define	FAT$W_EFBLKL	10
#define	FAT$W_FFBYTE	12
#define	FAT$B_BKTSIZE	14
#define	FAT$B_VFCSIZE	15
#define	FAT$W_MAXREC	16
#define	FAT$W_DEFEXT	18
#define	FAT$W_GBC	20
#define	FAT$W_VERSIONS	30
