$ save_ver = f$verify(0)
$! $Id: MAKE.COM,v 1.5 2005/09/08 20:21:39 mdw Exp $
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$! Copyright (c) 1995 - 2004, EMBL, Peter Keller
$! 
$! CCIF: a library to access and output data conforming to the
$! CIF (Crystallographic Information File) and mmCIF (Macromolecular
$! CIF) specifications, and other related specifications.
$! 
$! Where the terms and conditions of the CCP4 licence agreement apply
$! to this code (including, but not limited to, its acquisition as a
$! component of the CCP4 distribution and/or its use in building an
$! executable program that uses other CCP4 components), this code is
$! distributed as a CCP4 Library.
$! 
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$! Possible paramters:
$!    @MAKE [ DEBUG | SCA | SCD ]          ! Makes whole software bundle 
$!    @MAKE <module> [ DEBUG | SCA | SCD ] ! Makes named library module 
$!    @MAKE SYMTAB [ DEBUG | SCA | SCD ]   ! Makes CIFDIC_TO_SYMTAB program 
$!                                         ! and generates symbol table.
$!    @MAKE EG                             ! Builds example programs.
$!
$! Modifiers:  DEBUG - compiles with preprocessor symbol DEBUG defined
$!             SCA   - compiles/links for VMS debugger, and builds 
$!                     Source Code Analyser library
$!             SCD   - combines SCA and DEBUG
$!
$! Define the following logical names:
$!   RX_H : location of rxidspencer header files.
$!   RX_L : location of LIBRX.OLB file.
$! If either header files or olb file are in system default locations,
$! leave them undefined
$
$ on error then $ goto exit_make
$ on control_y then $ goto exit_make
$ RX_H_SAVE = f$trnlnm("RX_H")
$ RX_L_SAVE = f$trnlnm("RX_L")
$
$
$ module = "''p1'"
$ DDEBUG = ""
$ SCA = ""
$ WARN = "/NOWARN"
$ if ("''p1'" .eqs. "SCA"  .or. "''p1'" .eqs. "SCD" )
$     then
$        SCA = "SCA"
$        warn = "/WARN"
$        module = ""
$ endif
$ if ("''p2'" .eqs. "SCA"  .or. "''p2'" .eqs. "SCD" )
$     then 
$       SCA = "SCA"
$        warn = "/WARN"
$ endif
$ if ("''p1'" .eqs. "SCD"  .or. "''p1'" .eqs. "DEBUG" )
$     then
$        DDEBUG = ",DEBUG"
$        warn = "/WARN"
$        module = ""
$ endif
$ if ("''p2'" .eqs. "SCD"  .or. "''p2'" .eqs. "DEBUG")
$    then
$       DDEBUG = ",DEBUG"
$        warn = "/WARN"
$ endif

$! write sys$output "DEBUG = " + "''DDEBUG'" + " WARN = " + "''WARN'"
$! write sys$output "SCA = " + "''SCA'" + "  MODULE = " + "''MODULE'"
$ 
$ gosub set_syms
$
$ if "''module'" .eqs ""
$    then
$       gosub make_lib
$!       gosub link_lib
$       gosub make_sym_table
$    else
$       if "''module'" .eqs. "SYMTAB" 
$          then 
$             gosub make_sym_table
$       else
$          if "''module'" .eqs. "EG"
$             then
$                gosub make_eg
$          else
$             gosub make_module
$          endif
$       endif
$    endif
$
$ save_ver = f$verify(save_ver)
$ goto exit_make
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Set up local symbols for compilation etc.
$! Do GOSUB SET_SYMS
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ set_syms:
$! Include directories
$ cincl = "sys$disk:[]"
$
$! Regular expression package stuff (VMS POSIX is totally
$! unsuitable for our purposes)
$
$ REGEX_H = "no"
$ if ( "''f$trnlnm(""RX_H"")'" .eqs. "" ) 
$    then
$!       REGEX_H = "yes"
$!       on error then $ REGEX_H = "no"
$!       xx = f$parse("POSIX$INCLUDE:REGEX.H","EOF")
$!       on error then $ goto exit_make
$       define RX_H []
$ endif
$
$ write sys$output " "
$ if ( "''REGEX_H'" .eqs. "no" ) 
$    then
$       write sys$output "Using RX regular expression package"
$       cincl = cincl + ",RX_H"
$    else
$       write sys$output "Using OpenVMS POSIX regular expression package"
$ endif
$ write sys$output " "
$
$ set nover
$ if ( "''f$trnlnm(""alpha$library"")'" .nes. "" )
$    then
$       tmplib = "ALPHA$LIBRARY:"
$    else
$       tmplib = "SYS$LIBRARY:"
$ endif
$
$ if ( "''f$trnlnm(""RX_L"")'" .eqs. "" ) 
$    then
$       RXLIB = "," + "''tmplib'" + "librx/l"
$    else
$       RXLIB = ",RX_L:librx/l"
$ endif
$
$ if ( "''REGEX_H'" .eqs. "yes" ) 
$    then 
$       RXLIB = ""
$       DHAVE_REGEX_H = ",HAVE_REGEX_H=1"
$    else
$       write sys$output " "
$       write sys$output "Linking against " + -
                 f$parse("''RXLIB'" - "," - "/l", ".olb")
$       write sys$output " "
$       DHAVE_REGEX_H = ""
$ endif
$    
$
$! allow easy creation of ANA files for source code analyser
$ if "''sca'" .eqs. "SCA"
$    then
$       ccom = "cc/anal/include=(''cincl')/debug/noopt" + "'warn'"
$    else
$       ccom = "cc/include=(''cincl')" + "'warn'"
$    endif
$
$
$! Taken from CPROG:MAKEFILE.COM
$! Need to know whether we are compiling under DEC C or VAX C, since different
$! switches are needed for CC. ANTLR/DLG generated code is in ANSI C (or at
$! least that subset of it which VAX C copes with).
$!
$   write sys$output " "
$   write sys$output "Testing for DEC C..." 
$   ass/nolog nl: sys$output 
$   cc/prep=cc.tmp sys$input 
__DECC 
$   search cc.tmp __DECC 
$   if $severity .eq. 1 
$   then  
$      c = "VAXC"
$      ccmap = "''ccom'/define=(__USE_PROTOS,HAVE_MMAP=1''DDEBUG' ''DHAVE_REGEX_H')"
$      ccom = "''ccom'/define=('cdefs')"
$      cdefs = "__STDC__,HAVE_MMAP=1,OLD_REALLOC" + DDEBUG + DHAVE_REGEX_H
$      define lnk$library sys$library:vaxcrtl
$      lnk$c_rtl = "," + f$trnlnm("lnk$library") + "/l"
$      deass sys$output
$      write sys$output "...no"
$   else  
$      c = "DECC"
$      ccmap = "''ccom'/standard=vaxc/define=(__USE_PROTOS,HAVE_MMAP=1''DDEBUG' ''DHAVE_REGEX_H')/prefix=all"
$ !                  /undefine=(__HIDE_FORBIDDEN_NAMES)"
$      ccom = "''ccom'/standard=ansi89/define=('cdefs')/prefix=all"
$      if "''WARN'" .eqs. "/WARN" then $ warn = warn + "=(disable=textmodule)"
$      cdefs = "HAVE_MMAP=1" + DDEBUG + DHAVE_REGEX_H
$      lnk$c_rtl = " "
$      deass sys$output
$      write sys$output "...yes"
$   endif 
$ del/noconf/nolog cc.tmp;
$
$ ! Shared library stuff.
$ define/nolog libccifshr 'f$trnlnm("sys$disk")''f$directory()'libccifshr.exe;
$
$ ! Need to know whether we are using the VAX or AXP linker, since they
$ ! have different ways of declaring universal symbols
$
$ write sys$output " "
$ write sys$output "Checking for VAX linker..."
$ link/brief/map=temp.map/noexec sys$input
$
$ search/nooutput/match=and temp.map linker,vax
$ if $severity .eq. 1
$ then
$   linker_is := VAX
$   write sys$output "...yes"
$ else
$   linker_is := AXP
$   write sys$output "...no"
$ endif
$
$ write sys$output " "
$ delete/nolog/noconf temp.map;
$
$ ! List of objects to be compiled with 'ccom'. Must be in UPPER CASE!
$ obj_list = "CONDITION,SORLIST,STAR_MAP,SYM,STAR_SCAN,STAR_ERR,VALUE_MANIP"
$ obj_list = obj_list + ",CONTEXT,STRUCT_MANIP,F_INTERFACE,STAR_WALK"
$ obj_list = obj_list + ",SORT,RB,LIST"
$ !write sys$output ccmap
$ !write sys$output ccom
$ !write sys$output obj_list
$
$ return
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Make LIBCCIF-STATIC.OLB
$! Do GOSUB MAKE_LIB
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ make_lib:
$ set nover
$ write sys$output "Building LIBCCIF-STATIC.OLB....."
$ write sys$output " "
$ write sys$output "Module CCIF_VMS:"
$
$!  CCIF_VMS.C requires VAX C/DEC C conventions
$ if c .eqs. "VAXC"
$ then
$!    set ver
$    'ccmap'                       ccif_vms
$!    set nover
$ else
$!    set ver
$    'ccmap'/decc/prefix=all       ccif_vms
$!    set nover
$ endif
$
$ set nover
$ library/crea/log ccp4_lib:libccif-static ccif_vms
$ delete/noconf/nolog ccif_vms.obj;*
$
$ if "''sca'" .eqs. "SCA" 
$   then 
$      sca delete lib [.lib]
$      sca create lib [.lib]
$      sca set lib [.lib]
$      sca load ccif_vms
$      del/noconf/nolog ccif_vms.ana;
$  endif
$
$ write sys$output " "
$ write sys$output "Module STAR_PRINT:"
$ !set ver
$ 'ccom'/define=('cdefs',"_refvar_inits=star_print_refvar_inits") star_print
$ !set nover
$ library/insert/log ccp4_lib:libccif-static star_print
$ delete/noconf/nolog star_print.obj;*
$ if "''sca'" .eqs. "SCA" 
$   then 
$      sca load star_print
$      delete/noconf/nolog star_print.ana;*
$   endif
$
$ write sys$output " "
$ write sys$output "Module STAR_GRAPH:"
$ !set ver
$ 'ccom'/define=('cdefs',"_refvar_inits=star_dot_refvar_inits") star_graph
$ !set nover
$ library/insert/log ccp4_lib:libccif-static star_graph
$ delete/noconf/nolog star_graph.obj;*
$ if "''sca'" .eqs. "SCA" 
$   then 
$      sca load star_graph
$      delete/noconf/nolog star_graph.ana;*
$   endif
$ 
$ write sys$output " "
$ write sys$output "Module LIB_DICT2TAB:"
$ 'ccom'/define=('cdefs',"_refvar_inits=_dict_refvar_inits") -
     LIB_DICT2TAB
$ library/insert/log ccp4_lib:libccif-static LIB_DICT2TAB
$ delete/noconf/nolog LIB_DICT2TAB.obj;*
$ if "''sca'" .eqs. "SCA" 
$   then 
$      sca load LIB_DICT2TAB
$      delete/noconf/nolog LIB_DICT2TAB.ana;*
$   endif
$
$ set noverify
$
$ num_obj = 0
$
$ obj_loop:
$   file = f$element(num_obj,",",obj_list)
$   if file .eqs. "," then goto obj_done
$   write sys$output " "
$   write sys$output "Module ''file':"
$!    set verify
$   'ccom' 'file'
$!    set nover
$   library/insert/log ccp4_lib:libccif-static 'file'
$   if "''sca'" .eqs. "SCA" 
$      then 
$         sca load 'file'
$         delete/noconf/nolog 'file'.ana;*
$   endif
$   delete/noconf/nolog 'file'.obj;*
$   num_obj = num_obj+1
$   goto obj_loop
$
$ obj_done:
$!
$ gosub link_lib
$ write sys$output f$string(num_obj + 4) + " objects inserted into LIBCCIF-STATIC.OLB"
$! save_ver = f$verify(save_ver)
$
$ return
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Link shared library.
$! Do GOSUB LINK_LIB
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ link_lib:
$ set nover
$ if "''sca'" .eqs. "SCA" 
$ then
$    debug="debug"
$ else
$    debug="nodebug"
$endif
$
$ gosub make_opt
$
$ write sys$output " "
$ write sys$output "Building shared image library."
$ link/map=libccif.map/full/share=libccifshr/'debug' -
     libccif/opt, -
     ccp4_lib:libccif-static/include=(f_interface,LIB_DICT2TAB)/l -
     'RXLIB' 'lnk$c_rtl'
$ !         ^                                                      ^
$ ! ... quite right, there should NOT be a comma here! ....... or here 
$
$ libr/share/log/create libccif libccifshr
$ purge/nolog libccif.olb,libccifshr.exe
$
$ write sys$output " "
$ write sys$output "CCIF library in shareable image libccifshr.exe. To link,"
$ write sys$output "use ""LIBCCIF/L"". Do:"
$ write sys$output "  DEFINE LIBCCIFSHR " + -
   f$trnlnm("sys$disk") + f$directory() + "LIBCCIFSHR.EXE"
$ write sys$output "before running any programs which have been linked with it."
$
$ return
$
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$ ! Collect appropriate options for linker to build shared
$ ! library version of LIBCCIF. Do GOSUB MAKE_OPT
$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ make_opt:
$
$ ! First, list of universal (exported) symbols:
$ open/read ulist libccif-universal.lis
$ open/write opts libccif.opt
$
$ if linker_is .eqs. "VAX"
$ ! VAX linker
$ then
$    read ulist line
$    oline = "UNIVERSAL=" + f$element(0,"=",line)
$  ulist_vax:
$    read/end_of_file=elist_vax ulist line
$    write opts oline + " -"
$    oline = "," + f$element(0,"=",line)
$    goto ulist_vax
$
$  elist_vax:
$    write opts oline
$
$ else
$ ! AXP linker
$   write opts "SYMBOL_VECTOR=( -"
$  ulist_axp:
$   read/end_of_file=elist_axp ulist line
$   write opts line + " -"
$   goto ulist_axp
$
$  elist_axp:
$    write opts  ")"
$ endif
$
$ close ulist
$
$ ! Then list of symbols to be marked NOSHR (only needed if VAX C
$ ! is being used, since DEC C's #pragma strict_refdef ensures
$ ! sensible handling of this issue.
$ ! Cannot use APPEND, because VMSTAR unpacks text files as STREAM_LF
$
$ if c .eqs. "VAXC"
$ then
$    open/read noshr libccif-noshr.opt
$  nlist:
$    read/end_of_file=nlist_end noshr line
$    write opts line
$    goto nlist
$  nlist_end:
$    close noshr
$ endif
$
$ close opts
$
$ purge/nolog *.opt
$ return
$
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Make an individual module of the library.
$! Set MODULE, and do GOSUB MAKE_LIB
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$make_module:
$
$
$ !set verify
$
$ if f$locate(module, obj_list) .lt. f$length(obj_list)
$ then
$    set ver
$    'ccom' 'module'
$    set nover
$ else
$
$    if "''module'" .eqs. "CCIF_VMS"
$    then
$       if c .eqs. "VAXC"
$       then
$          set ver
$          'ccmap'                  ccif_vms
$          set nover
$       else
$          set ver
$          'ccmap'/decc/prefix=all   ccif_vms
$          set nover
$       endif
$    endif
$    if "''module'" .eqs. "STAR_PRINT"
$    then
$       set ver
$       'ccom'/define=('cdefs',"_refvar_inits=star_print_refvar_inits") star_print
$       set nover
$    endif
$    if "''module'" .eqs. "LIB_DICT2TAB"
$    then
$       set ver
$       'ccom'/define=('cdefs',"_refvar_inits=_dict_refvar_inits") -
            LIB_DICT2TAB
$       set nover
$    endif
$    if "''module'" .eqs. "STAR_GRAPH"
$    then
$       set ver
$       'ccom'/define=('cdefs',"_refvar_inits=star_dot_refvar_inits") star_graph
$       set nover
$    endif
$ endif
$
$ set nover
$ !purge/nolog 'module'.obj
$   library/replace/log ccp4_lib:libccif-static 'module'
$   if "''sca'" .eqs. "SCA" 
$      then 
$         sca set lib [.lib]
$         sca load 'module'
$         delete/noconf/nolog 'module'.ana;*
$   endif
$   delete/noconf/nolog 'module'.obj;*
$ set nover
$ gosub link_lib
$ return
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Make CIFDIC_TO_SYMTAB program, and run it to generate symbol table
$! Do GOSUB MAKE_SYM_TABLE
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$make_sym_table:
$ save_defs = "''cdefs'"
$ 
$ write sys$output " "
$ write sys$output "Building symbol table:"
$ !set ver
$ 'ccom' cifdic_to_symtab
$ !set nover
$ cdefs = "''save_defs'"
$
$ ! A bug in the VAX C RTL prevents linking cifdic_to_symtab with the
$ ! shareable version of libccif. Other programs seem unaffected.
$ ! This may have something to do with the way in which static data is
$ ! handled in LIB_DICT2TAB.
$ !
$ if "''c'" .eqs. "VAXC"
$    then
$       c_libs = "ccp4_lib:libccif-static/l ''RXLIB'"
$    else
$       c_libs = "sys$disk:[]libccif/l"
$ endif
$
$ if "''sca'" .eqs. "SCA" 
$   then 
$      sca set lib [.lib]
$      sca load cifdic_to_symtab
$      delete/noconf/nolog cifdic_to_symtab.ana;*
$      link/debug cifdic_to_symtab, 'c_libs'
$   else
$      link cifdic_to_symtab, 'c_libs'
$ endif
$ 
$ !delete/noconfirm cifdic_to_symtab.obj;*
$ cifdic_to_symtab = "$sys$disk:[]cifdic_to_symtab"
$ assign mmcifdic.out sys$output
$ cifdic_to_symtab ccp4_master:[ccp4.lib.data]cif_mm.dic -
                   ccp4_lib:cif_mmdic.lib 199
$ deassign sys$output
$ return
$
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Make example programs
$! Do GOSUB MAKE_EG
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ make_eg:
$
$ save_ver = f$verify(1)
$! fortran cifmodi.f
$! link cifmodi,libccif/l,ccp4_lib:libccp4/l
$
$ fortran cifget.f
$ link cifget,libccif/l,ccp4_lib:libccp4/l
$
$ fortran cifsymop.f
$ link cifsymop,libccif/l,ccp4_lib:libccp4/l
$ 
$ fortran cifsearch.f
$ link cifsearch,libccif/l,ccp4_lib:libccp4/l
$
$ fortran cifset_lib.f
$ fortran cifset.f
$ link cifset, cifset_lib,libccif/l,ccp4_lib:libccp4/l
$
$set nover
$ write sys$output "Do the following assignments to use command-line arguments:"
$ write sys$output "cifsearch :== $sys$disk:[]cifsearch"
$ write sys$output "cifget :== $sys$disk:[]cifget"
$ write sys$output "cifsymop :== $sys$disk:[]cifsymop"
$ write sys$output " "
$ write sys$output "Or, if you are feeling clever:"
$ write sys$output -
   "cifsearch :== $'f$trnlnm(""sys$disk"")'" + "'f$directory()'cifsearch"
$ write sys$output -
   "cifget   :== $'f$trnlnm(""sys$disk"")'" + "'f$directory()'cifget"
$ write sys$output -
   "cifsymop :== $'f$trnlnm(""sys$disk"")'" + "'f$directory()'cifsymop"
$ write sys$output "etc..."
$
$ save_ver = f$verify(save_ver)
$ return
$

$ exit_make:
$ exit_status = $status
$ if ( "''RX_H_SAVE'" .nes. "" ) 
$    then 
$    define/nolog RX_H 'RX_H_SAVE'
$ else
$ ! shut up deassign if name wasn't assigned
$    define/nolog RX_H sys$disk
$    deassign RX_H
$ endif
$
$ if ( "''RX_L_SAVE'" .nes. "" ) 
$    then 
$    define/nolog RX_L 'RX_L_SAVE'
$ else
$ ! shut up deassign if name wasn't assigned
$    define/nolog RX_L sys$disk
$    deassign RX_L
$ endif
$ exit exit_status
