/* $Id: cifdicdot.c,v 1.3 2008/06/09 17:38:04 mdw Exp $ */

/********************************************************************
* Copyright (c) 1995 - 2004, EMBL, Peter Keller
* 
* CCIF: a library to access and output data conforming to the
* CIF (Crystallographic Information File) and mmCIF (Macromolecular
* CIF) specifications, and other related specifications.
* 
* This library is free software: you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* version 3, modified in accordance with the provisions of the 
* license to address the requirements of UK law.
*
* You should have received a copy of the modified GNU Lesser General 
* Public License along with this library.  If not, copies may be 
* downloaded from http://www.ccp4.ac.uk/ccp4license.php
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

extern void zzs_undump( const char * const, const char * const, const int);
extern void build_graph(const char * parent_list[], const int exclude);
extern void dot_dump(char  *filename);

static const char *parent_list[]={
  "DATABASE_PDB_REV",
  "CITATION",
  "ENTRY",
  "EXPTL_CRYSTAL",
  "DIFFRN_RADIATION_WAVELENGTH",
  "REFLNS_SCALE",
  "DIFFRN",
  "DIFFRN_STANDARD_REFLN",
  "DIFFRN_SCALE_GROUP",
  "DIFFRN_ATTENUATOR",
  "DIFFRN_DETECTOR",
  ""};


main (int argc, char **argv){

  char * dicname = getenv("CCIFDIC");

  assert(dicname);
  zzs_undump(dicname, "CCIFDIC", 1);

  fprintf(stderr, "Building graph...");
  build_graph(parent_list,1);
  fprintf(stderr,"done\n");
  fflush(stderr);

  fprintf(stderr, "Dumping dot source...");
  dot_dump (argv[1]);
  fflush(stderr);
  fprintf(stderr, "dumped.\n");
}
