/* $Id: cifdickeys.c,v 1.3 2008/06/09 17:38:07 mdw Exp $ */

/********************************************************************
* Copyright (c) 1995 - 2004, EMBL, Peter Keller
* 
* CCIF: a library to access and output data conforming to the
* CIF (Crystallographic Information File) and mmCIF (Macromolecular
* CIF) specifications, and other related specifications.
* 
* This library is free software: you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* version 3, modified in accordance with the provisions of the 
* license to address the requirements of UK law.
*
* You should have received a copy of the modified GNU Lesser General 
* Public License along with this library.  If not, copies may be 
* downloaded from http://www.ccp4.ac.uk/ccp4license.php
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

extern void zzs_undump( const char * const, const char * const, const int);
extern void zzs_print_keys (void);

main (int argc, char **argv){

  char * dicname;

  if ( argc != 2 ) {
    printf ("Usage: %s <varname>\n   where <varname> is the name of an environment variable pointing to the mmCIF dictionary\n", argv[0]);
    exit(1);
  }

  dicname = getenv(argv[1]);
  if ( ! dicname ) {
    printf ("%s not set!\n", argv[1]);
    exit(1);
  }
  zzs_undump(dicname, argv[1], 1);

  zzs_print_keys();
  
}
