# The autogen-clipper script makes all the library makefile.am scripts

set base = $PWD

foreach name (core contrib phs mmdb minimol mmdbold cif ccp4 cctbx mtz)

# general case
cd clipper/$name
set hfiles = *.h
set cfiles = *.cpp
set libnm = "$name"
set am = "Makefile.am"
set sep1 = "-"
set sep2 = "_"

# special cases
test $name = "core" && set libnm = ""

# general output
test -z $libnm && set sep1 = ""
test -z $libnm && set sep2 = ""
echo "#   Copyright 2003" > $am
echo "#   For licence conditions, see the file COPYING.\n" >> $am
echo 'library_includedir=$(pkgincludedir)/'"$name" >> $am
echo "lib_LTLIBRARIES = libclipper${sep1}${libnm}.la\n" >> $am
echo "library_include_HEADERS = ${hfiles}\n" >> $am
echo "libclipper${sep2}${libnm}_la_SOURCES = ${cfiles}\n" >> $am

# special output
test $name = "core"    && echo 'INCLUDES = $(FFTW_CXXFLAGS)' >> $am
test $name = "mmdb"    && echo 'INCLUDES = $(MMDB_CXXFLAGS)' >> $am
test $name = "minimol" && echo 'INCLUDES = $(MMDB_CXXFLAGS)' >> $am
test $name = "mmdbold" && echo 'INCLUDES = $(MMDB_CXXFLAGS)' >> $am
test $name = "cif"     && echo 'INCLUDES = $(MMDB_CXXFLAGS)' >> $am
test $name = "cctbx"   && echo 'INCLUDES = $(CCTBX_CXXFLAGS)' >> $am
test $name = "mtz"     && echo 'INCLUDES = $(MCCP4_CXXFLAGS)' >> $am
test $name = "ccp4"     && echo 'INCLUDES = $(CCP4_CXXFLAGS)' >> $am

# next loop
cd $base
end

# now the traditional autogen.sh stuff

aclocal -I macros

autoconf

automake --add-missing --copy

