(*
 * Copyright (c) 1997-1999, 2003 Massachusetts Institute of Technology
 *
 * See the file COPYING for license information.
 *
 *)

(* $Id: complex.mli,v 1.1 2003/08/18 08:57:29 mdw Exp $ *)

type expr
val two : expr
val one : expr
val zero : expr
val inverse_int : int -> expr
val times : expr -> expr -> expr
val uminus : expr -> expr
val swap_re_im : expr -> expr
val exp : int -> int -> expr
val plus : expr list -> expr
val real : expr -> expr
val imag : expr -> expr
val conj : expr -> expr
val sigma : int -> int -> (int -> expr) -> expr
val wsquare : expr -> expr
val wthree : expr -> expr -> expr -> expr
type variable
val load_var : variable -> expr
val store_var : variable -> expr -> Exprdag.node list
val store_real : variable -> expr -> Exprdag.node list
val store_imag : variable -> expr -> Exprdag.node list
val access_input : int -> variable
val access_output : int -> variable
val access_twiddle : int -> variable
