(*
 * Copyright (c) 1997-1999, 2003 Massachusetts Institute of Technology
 *
 * See the file COPYING for license information.
 *
 *)

type node =
  | Num of Number.number
  | Load of Variable.variable
  | Store of Variable.variable * node
  | Plus of node list
  | Times of node * node
  | Uminus of node
type dag

val algsimp : dag -> dag
val to_assignments : dag -> (Variable.variable * Expr.expr) list
val simplify_to_alist : dag -> Expr.assignment list
val make : node list -> dag
val cvsid : string

module LittleSimplifier :
  sig
    val makeNum : Number.number -> node
    val makeUminus : node -> node
    val makeTimes : node * node -> node
    val makePlus : node list -> node
  end

