(*
 * Copyright (c) 1997-1999, 2003 Massachusetts Institute of Technology
 *
 * See the file COPYING for license information.
 *
 *)

(* $Id: to_c.mli,v 1.1 2003/08/18 08:57:35 mdw Exp $ *)

type c_decl = | Decl of string * string
type c_ast =
  | Asch of Asched.annotated_schedule
  | For of c_ast * c_ast * c_ast * c_ast
  | If of c_ast * c_ast
  | Block of c_decl list * c_ast list
  | Binop of string * Expr.expr * Expr.expr
  | Expr_assign of Expr.expr * Expr.expr
  | Stmt_assign of Expr.expr * Expr.expr
  | Comma of c_ast * c_ast
type c_fcn = | Fcn of string * string * c_decl list * c_ast

val make_c_unparser : (Variable.variable -> string) -> c_fcn -> string
