(*
 * Copyright (c) 1997-1999, 2003 Massachusetts Institute of Technology
 *
 * See the file COPYING for license information.
 *
 *)

(* $Id: variable.mli,v 1.1 2003/08/18 08:57:37 mdw Exp $ *)

type variable 

val make_temporary : unit -> variable
val clobbers : variable -> variable -> bool
val real_imag : variable -> variable -> bool
val increasing_indices : variable -> variable -> bool
val access_input : int -> variable * variable
val access_output : int -> variable * variable
val access_twiddle : int -> variable * variable
val same : 'a -> 'a -> bool
val similar : variable -> variable -> bool
val hash : variable -> int
val is_temporary : variable -> bool
val is_output : variable -> bool
val is_input : variable -> bool
val is_twiddle : variable -> bool
val make_named : string -> variable

val make_unparser :
    string * string option ->
      string * string option ->
	string * string option -> 
	  variable -> string

val make_real2hc_unparser :
    string * string option ->
      string * string option ->
	string * string option -> 
	  variable -> string

val make_realeven_unparser :
    string * string option ->
      string * string option ->
         variable -> string

val make_realodd_unparser :
    string * string option ->
      string * string option ->
         variable -> string

val make_realodd2_unparser :
    string * string option ->
      string * string option ->
         variable -> string

val make_hc2real_unparser :
    string * string option ->
      string * string option ->
	string * string option -> 
	  variable -> string

val make_hc2hc_forward_unparser :
    int ->
      string * string option ->
	string * string option ->
	  string * string option -> 
	    variable -> string

val make_hc2hc_backward_unparser :
    int ->
      string * string option ->
	string * string option ->
	  string * string option -> 
	    variable -> string

