#!/usr/bin/env tclsh

set input_pdb   [lindex $argv 0]
set output_pdb  [lindex $argv 1]

set input [open $input_pdb a+]
set output [open $output_pdb r]
set indata [split [read $output] "\n"]

foreach line  $indata {
    if { [regexp {HETATM.*} $line junk] || [regexp {ATOM.*} $line junk] } {
	scan $line "%6s%5d%*c%2s%*c%*c%*c%*c%2s%*c%*c%*c%*c%*c%*c%*c%*c%*c%*c%8f%8f%8f%6f%6f" label number atom residue x y z occ b 
	if { $atom != "" } {
	    puts $input [format "HETATM %4d %2s   %2s   %4d    %8.3f%8.3f%8.3f%6.2f%6.2f" $number $atom $atom $number $x $y $z $occ $b]
	}
    } 
}
    
close $input
close $output
