C     --- ALIGN_DB.f---
C --------------------------------------------------------------------
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT (IPRROW)
C ----
      CHARACTER NAME_1*256,NAME_2*256 
      CHARACTER NAME_OUT1*256,NAME_OUT2*256
      CHARACTER NAME_OUT*256,CORR*1
      CHARACTER PATH_SCR*256,PATH_OUT*256
C
      CHARACTER LINE*256,PROG*80,JOB*80
      CHARACTER PATH*1,EXT*1
      CHARACTER DIST*1
C ---
      INCLUDE 'align_DB_version.fh'
C --------------------------------------------------------------------
      M = 0
      PATH_OUT = ' '
      MDOC    = 1
      PROG = 'align_DB'
      CALL START(0,MDOC,PROG,PATH_OUT)
C ---------------------------
      LINE = VERSION
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.75) LEN = 75
      LINE = 'Sol_'//LINE(1:LEN)
      CALL MSGDOC(M,'Sol_ ')
      CALL MSGDOC(M,LINE)
      CALL MSGDOC(M,'Sol_ ')
C -------------------------------------------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
c ----------------------------
      JOB  = 'align_DB'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(M,LINE)
        IERR = 9
        GO TO 900
      ENDIF
      CLOSE(IOUT)
C -----------------------
      DO I=1,IPRROW
        RESULT(I) = 0.0
      ENDDO
      NAME_OUT  = ' '
      NAME_OUT1 = ' '
      NAME_OUT2 = ' '

      PO = 0.0
      PE = 0.0
      CALL SET_DEFAULT(' ')
      CALL MSGDOC(MD,' ')
C ---
      DIST = 'N'
      CALL SET_DEFAULT(
     *'FILE_1:  filename - PDB or sequence file')
      CALL SET_DEFAULT(
     *'FILE_2:  filename - PDB or sequence file')
      CALL SET_DEFAULT(
     *'FILE_O:  filename - output PDB file')
      CALL SET_DEFAULT(
     *'DIST:    <N>/D    - ')
      CALL SET_DEFAULT(
     *'CORR:    <N>/Y/2  - Y output rotated full file_2')
      CALL SET_DEFAULT(
     *'                    2 two output aligned files')
      CALL SET_DEFAULT(
     *'                    N output aligned file_2')

      CALL SET_DEFAULT('PO:       - ')
      CALL SET_DEFAULT('PE:       - ')

      CALL SET_DEFAULT(
     *'PATH_SCR:   < >   - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='FILE_1'
      CALL ASK(LINE)
      NAME_1=LINE
      CALL CORR_NAME_ALL(NAME_1)
c ----
      LINE='FILE_O'
      CALL ASK(LINE)
      NAME_OUT=LINE
      CALL CORR_NAME_ALL(NAME_OUT)
c ----
      LINE='FILE_2'
      CALL ASK(LINE)
      NAME_2=LINE
      CALL CORR_NAME_ALL(NAME_2)
c ----
      LINE='PO'
      CALL ASK(LINE)
      READ(LINE,*) PO
      LINE='PE'
      CALL ASK(LINE)
      READ(LINE,*) PE
C ----
      LINE='CORR'
      CALL ASK(LINE)
      CORR=LINE(1:1)
C ----
      LINE='DIST'
      CALL ASK(LINE)
      DIST=LINE(1:1)
c ----
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_ALL(PATH_SCR)
C -----------------------
      CALL CLOSE_BATCH(MDOC)

      CALL ALIGN_DB(MDOC,DIST
     * ,NAME_1,NAME_2,NAME_OUT,NAME_OUT1,NAME_OUT2
     * ,PO,PE,CORR
     * ,PATH_OUT,PATH_SCR,RESULT,IPRROW,IERR)
C -----------------------
      CALL WRITE_ALIGN_DB_XML(MDOC,IERR
     *     ,RESULT,IPRROW,JOB,PATH_OUT,JERR)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE  WRITE_ALIGN_DB_XML(MDOC,IERR_INPUT
     *     ,RESULT,IPRROW
     *     ,JOB,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR,IERR_INPUT
      CHARACTER JOB*(*)
      REAL      RESULT (IPRROW)
      CHARACTER LINE*256,FILE_2*256,MESSAGE*80
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN

C       RESULT(1) = NC
C       RESULT(2) = KC
C       RESULT(3) = NN
C       RESULT(4) = NHOM
C       RESULT(5) = HOM
C       RESULT(6) = SUM_SCORE 

        NAA1 = RESULT(1)
        NAA2 = RESULT(2) 
        NAA_ALIGN = RESULT(3)
        NAA_IDENT = RESULT(4)
        FDENT = RESULT(5)
        SCORE = RESULT(6)

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'naa_1 <naa_1> ',NAA1,' </naa_1>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'naa_2 <naa_2> ',NAA2,' </naa_2>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'naa_align <naa_align> ',NAA_ALIGN,' </naa_align>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *   'naa_ident <naa_ident> ',NAA_IDENT,' </naa_ident>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F8.3,A)',ERR=510) 
     *   'ident <ident> ',FDENT,' </ident>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
 
        WRITE(LINE,'(A,F8.3,A)',ERR=510) 
     *   'score <score> ',SCORE,' </score>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//JOB(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE ALIGN_DB(MDOC,DIST
     * ,NAME_1,NAME_2,NAME_OUT,NAME_OUT1,NAME_OUT2
     * ,PO,PE,CORR
     * ,PATH_OUT,PATH_SCR,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT(IPRROW)    
      CHARACTER NAME_1*(*),NAME_2*(*) 
      CHARACTER NAME_OUT1*(*),NAME_OUT2*(*)
      CHARACTER NAME_OUT*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
C ----
      INTEGER   MDOC,IERR
      CHARACTER LINE*256
      CHARACTER PAR_ALIGN*16
      CHARACTER PATH*1,EXT*1,CHAIN*1,DIST*1,CORR*1

c      PARAMETER ( MEMORY = 8000000 )
c      REAL      POOL(MEMORY)
c      PARAMETER ( IPRSYM = 1 )
c      INTEGER*2 ISYM(5,3,IPRSYM)
c      REAL      RESULT2(21)    

C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C -----------------------
      IF(CORR.EQ.'y') CORR = 'Y'
      IF(CORR.NE.'Y'.AND.CORR.NE.'2') CORR = 'N'

c      IF(MODE.NE.'1'.AND.MODE.NE.'H'.AND.MODE.NE.'B'.AND.
c     *   MODE.NE.'S'.AND.MODE.NE.'K') MODE='G'
c      WRITE(LINE,'('' MATRIX (UNIT-1,GOMOLOGY-<G>,HYDROPHOB-H '')')
c      CALL MSGDOC(MDOC,LINE)

c --
C         MODE    = PAR_ALIGN(1:1) matrix 
cC       2: CORR --> Y output file(pdb) (name with ext) (default: align.pdb)
c          PAR_ALIGN(2:2) = 'Y'
c          CORR = S : output file: sequence with SS and SURF (SS=Y,D3=Y)
cC       3: D3_FLAG (n,c,y) --> ALIGN_with SURF
cC       4: SS_FLAG  use SS
cc       5: remove surf from output
cc       6: OCC_FLAG - set ss_flag to second pdb file

      PAR_ALIGN(1:1) = 'G' 
      PAR_ALIGN(1:1) = 'B' 
c      PAR_ALIGN(1:1) = 'S' 

      PAR_ALIGN(2:2) = 'N' 
      PAR_ALIGN(2:2) = CORR 

      PAR_ALIGN(3:3) = 'Y' 
      PAR_ALIGN(4:4) = 'Y' 

      PAR_ALIGN(5:5) = 'N' 
      PAR_ALIGN(6:6) = 'N' 

      IF(DIST.EQ.'d') DIST = 'D'
      IF(DIST.NE.'D') DIST = 'N'
      IF(DIST.EQ.'D') THEN
        PAR_ALIGN(4:4) = 'N' 
      ENDIF
      PAR_ALIGN(7:7) = DIST  

      OPENR   = 0.462
      PENEXR  = 0.077
      OPENR   = 0.750
      PENEXR  = 0.125

      IF(PAR_ALIGN(1:1).EQ.'G') THEN 
c       'G'
        DPENR   = 0.346
      ELSE
c       'B'
        DPENR   = 0.312
      ENDIF
      
      IF(PO.GT.0.001) OPENR  = PO
      IF(PE.GT.0.001) PENEXR = PE
 
      MODEL    = 1
      CHAIN    = ' '
      IPRINT   = 2
      IPRINT   = 1
c      CALL ALIGN_3(MDOC,NAME_1,NAME_2,NAME_OUT,PATH_SCR
      CALL ALIGN_4(MDOC,NAME_1,NAME_2,NAME_OUT,PATH_SCR
     *    ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     *    ,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: in ALIGN_3')
        GO TO 900
      ENDIF
C -------------------------------------------------
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity
C     RESULT(6) = SUM  score
C     RESULT(7) = NAT  Natom output
C     RESULT(8) = NRES Nres output
C     RESULT(9) = NAT  Natom1 output
C     RESULT(10)= NRES Nres1 output
C     RESULT(11)= NAT  Natom2 output
C     RESULT(12)= NRES Nres2 output
C     RESULT(13) = SCORE1_MAX 
C     RESULT(14) = SCORE_MIN 
C     RESULT(15) = Q_FIN
C     RESULT(16) = DRMS_BEST 
C     RESULT(17) = NPAIR_BEST 
C     RESULT(18) = SCORE_NEW
c     RESULT(19) = FIDENT_NEW
c     RESULT(20) = NGAP
c      IF(IPRROW.GE.41) THEN
C        RESULT(21) = CHI_INI
C        RESULT(22) = DIST_INI
C        RESULT(23) = DRMS_INI
C        RESULT(24) = CHI_BEST
C        RESULT(25) = DIST_BEST
c        RESULT(30) = TR(1)
c        RESULT(31) = TR(2)
c        RESULT(32) = TR(3)
c        RESULT(33) = TRMAT(1,1)
c        RESULT(34) = TRMAT(1,2)
c        RESULT(35) = TRMAT(1,3)
c        RESULT(36) = TRMAT(2,1)
c        RESULT(37) = TRMAT(2,2)
c        RESULT(38) = TRMAT(2,3)
c        RESULT(39) = TRMAT(3,1)
c        RESULT(40) = TRMAT(3,2)
c        RESULT(41) = TRMAT(3,3)
c      ENDIF
C -------------------------------------------------
          N1  = RESULT(1) 
          N2  = RESULT(2) 
          NN  = RESULT(3) 
          NI  = RESULT(4) 
          HID = RESULT(5)
          SCORE = RESULT(18)

  900 CONTINUE
C -----------------------
      RETURN
      END
