C---------------------------------------------------------------
C --- solution_check.f ---
C -----------------------------------
      INCLUDE 'nsym-max.fh'
C -----------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
c------------------------------------------------------------
      PARAMETER ( MEMORY = 4000000 )
      REAL      POOL(MEMORY)
      PARAMETER ( IPRROW = 100      )
      REAL      RESULT (IPRROW)
C ---
      CHARACTER FILE_TEST*256,FILE_SOL*256
      CHARACTER PATH_SCR*256,PATH_OUT*256
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,PATH*1,EXT*3
C==================================================================
      PATH_OUT = ' '
      MDOC=1
      CALL START(0,MDOC,'solution_check',PATH_OUT)
C ---------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '  ---  SOLUTION_CHECK ---  V.31.05.2007/')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------------------------
      IERR = 0
      MD   = 0
      M    = 99
c ----
  200 LINE = 'test PDB file'
      CALL MSGDOC(MD,LINE)
      LINE = 'TEST_IN:'
      CALL ASK(LINE)
      FILE_TEST = LINE
      CALL CORR_NAME_BLC(FILE_TEST)
      MT    = 10
      PATH  = ' '
      EXT   = ' '
      CALL OPENFR(MT,M,PATH,FILE_TEST,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open input test file')
        IERR=0
        GO TO 200
      ENDIF
      CLOSE(MT)
C ---
  300 LINE = 'solution PDB file'
      CALL MSGDOC(MD,LINE)
      LINE='SOL_IN:'
      CALL ASK(LINE)
      FILE_SOL = LINE
      CALL CORR_NAME_BLC(FILE_SOL)
      PATH  = ' '
      EXT   = ' '
      MT = 10
      CALL OPENFR(MT,M,PATH,FILE_SOL,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open input solutuion file')
        IERR=0
        GO TO 300
      ENDIF
      CLOSE(MT)
C ---
      LINE = 'path to scratch file directory'
      CALL MSGDOC(MD,LINE)
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_BLC(PATH_SCR)
C -------------------------------------------
      CALL CLOSE_BATCH(MDOC)
      CALL SOLUTION_CHECK(MDOC
     * ,FILE_TEST,FILE_SOL,PATH_SCR,PATH_OUT
     * ,POOL,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C --------------------------------------------------
  900 CALL FINISH
      END

      SUBROUTINE SOLUTION_CHECK(MDOC
     * ,FILE_TEST,FILE_SOL,PATH_SCR,PATH_OUT
     * ,POOL,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C --------------------------------------------------------
      REAL      POOL(MEMORY)
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
C ----
      CHARACTER FILE_TEST*(*),FILE_SOL*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
C ---
      CHARACTER FILES*256
      CHARACTER FILE_1*256,FILE_2*256
C ----
      REAL        CELL(6),ORIG(3)
      CHARACTER   ID_PDB*4,DATE_PDB*9,CHAIN_INP*1

      PARAMETER ( NCHMAX    = 200 )

      CHARACTER   CHAIN_LIST_TEST(NCHMAX)*1
      INTEGER     NAA_CHAIN_TEST(NCHMAX),IFOUND_SOL(NCHMAX)
      CHARACTER   CHAIN_LIST_SOL(NCHMAX)*1
      INTEGER     NAA_CHAIN_SOL(NCHMAX)
      INTEGER     ICHAIN_NP(NCHMAX),ICHAIN_NPB(NCHMAX)

      REAL        CHAIN_ANG(NCHMAX),CHAIN_DIST(NCHMAX)
      REAL        CHAIN_DRMS(NCHMAX),CHAIN_DMAX(NCHMAX)
      REAL        CHAIN_SHFT(3,NCHMAX),CHAIN_ARMS(NCHMAX)
      REAL        CHAIN_SHFT_BEST(3)

      REAL        ORT_TO_FRAC(3,3),FRAC_TO_ORT(3,3)
      REAL        SHX_BEST(3)
      CHARACTER   CHAIN_TEST*1,CHAIN_SOL*1,FOUND_FLAG*1
      CHARACTER   STR_TITLE*40,STR_DATE*9
      CHARACTER   MESSAGE*80,JOB*80
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ---------------------------------------------------------
      CHARACTER   EXT*3,PATH*1
      CHARACTER   LINE*256
      REAL        FCH4      
      CHARACTER   CH4*4
      EQUIVALENCE (FCH4,CH4)
C --------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
c ------
      DIST_LIM = 3.5
      ANG_LIM  = 10.0
      ARMS_LIM = 2.5
      WRITE(LINE,*) ' Limit Angle,Rms,Dist:'
     *                ,ANG_LIM,ARMS_LIM,DIST_LIM
      CALL MSGDOC(MDOC,LINE)
C ------
      JOB  = 'solution_check'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open output XML file'
        IERR = 9
        RETURN
      ENDIF
      CLOSE(IOUT)
C ------
      FILES = 'temp.seq'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILES,LLL)
      IF(LEN.GT.0) THEN
        FILES = PATH_SCR(1:LEN)//FILES(1:LLL)
      ENDIF
      CHAIN_INP = ' '
      CALL PDB2SEQ(M,FILE_TEST,FILES
     * ,ID_PDB,DATE_PDB
     * ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     * ,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) THEN 
        GO TO 900
      ENDIF

      NCHAIN_TEST = RESULT(1)

      CALL MSGDOC(MDOC,'--------')
      WRITE(LINE,*) 'Number of chains (file_test):',NCHAIN_TEST
      CALL MSGDOC(MDOC,LINE)

      IF(NCHAIN_TEST.LE.0) THEN
        GO TO 900
      ENDIF

      IF(NCHAIN_TEST.GT.NCHMAX) NCHAIN_TEST = NCHMAX

      II = 1      
      DO I=1,NCHAIN_TEST
        II=II+1
        FCH4 = RESULT(II)
        CHAIN_LIST_TEST(I) = CH4(1:1)
        II=II+1
        NAA_CHAIN_TEST(I) = RESULT(II)
        WRITE(LINE,'(A,3X,I6)') CHAIN_LIST_TEST(I),NAA_CHAIN_TEST(I)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
C ------
      CHAIN_INP = ' '
      FILES = 'temp.seq'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILES,LLL)
      IF(LEN.GT.0) THEN
        FILES = PATH_SCR(1:LEN)//FILES(1:LLL)
      ENDIF
      CALL PDB2SEQ(M,FILE_SOL,FILES
     * ,ID_PDB,DATE_PDB
     * ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     * ,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) THEN 
        GO TO 900
      ENDIF

      NCHAIN_SOL = RESULT(1)

      CALL MSGDOC(MDOC,'--------')
      WRITE(LINE,*) 'Number of chains (file_sol):',NCHAIN_SOL
      CALL MSGDOC(MDOC,LINE)

      IF(NCHAIN_SOL.LE.0) THEN
        GO TO 900
      ENDIF
      IF(NCHAIN_SOL.GT.NCHMAX) NCHAIN_SOL = NCHMAX
C ------
      II = 1
      DO I=1,NCHAIN_SOL
        II=II+1
        FCH4 = RESULT(II)
        CHAIN_LIST_SOL(I) = CH4(1:1)
        II=II+1
        NAA_CHAIN_SOL(I) = RESULT(II)
        WRITE(LINE,'(A,3X,I6)') CHAIN_LIST_SOL(I),NAA_CHAIN_SOL(I)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      CALL MSGDOC(MDOC,'--------')
C ------------
      IPRINT = 0
      IFIRST = 0
      NFOUND = 0
      ORIG(1)= 0.0
      ORIG(2)= 0.0
      ORIG(3)= 0.0
      DO I=1,NCHMAX
        IFOUND_SOL(I) = 0.
        CHAIN_ANG(I)  = 0.0
        CHAIN_DIST(I) = 0.0
        CHAIN_DRMS(I) = 0.0
        CHAIN_ARMS(I) = 0.0
        CHAIN_DMAX(I) = 0.0
        CHAIN_SHFT(1,I) = 0.0
        CHAIN_SHFT(2,I) = 0.0
        CHAIN_SHFT(3,I) = 0.0
        ICHAIN_NP(I)    = 0
        ICHAIN_NPB(I)   = 0
      ENDDO

      DO ITEST=1,NCHAIN_TEST

        CHAIN_TEST = CHAIN_LIST_TEST(ITEST)
        FOUND_FLAG = 'N'
        NAA_TEST   = NAA_CHAIN_TEST(ITEST)
        IFOUND_SOL(ITEST) = 0

c        write(*,*) '---------test:',CHAIN_TEST

        IF(CHAIN_TEST.EQ.'_') CHAIN_TEST = ' '
        
        FILE_1 = 'file_test.pdb'
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILE_1,LLL1)
        IF(LEN.GT.0) THEN
          FILE_1 = PATH_SCR(1:LEN)//FILE_1(1:LLL1)
        ENDIF

        CALL GET_PDB_CHAIN(MDOC,CHAIN_TEST
     *          ,FILE_TEST,FILE_1,NRES,LINE,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: CLEAN_PDB (test)')
          GO TO 900
        ENDIF

c        DO I=1,3
c        DO J=1,3
c          ORT_TO_FRAC(I,J) = CR_ORT_TO_FRAC(I,J)
c          FRAC_TO_ORT(I,J) = CR_FRAC_TO_ORT(I,J)
c        ENDDO
c        ENDDO

        CHI_BEST  = 100000.0
        ARMS_BEST = 100000.0
        DST_BEST  = 100000.0
        CHAIN_SHFT_BEST(1) = 0.0
        CHAIN_SHFT_BEST(2) = 0.0
        CHAIN_SHFT_BEST(3) = 0.0
        ICH_NP   = 0
        ICH_NPB  = 0

        DO ISOL=1,NCHAIN_SOL
          CHAIN_SOL = CHAIN_LIST_SOL(ISOL)
          NAA_SOL   = NAA_CHAIN_SOL(ISOL)
          IF(NAA_TEST.LT.20.OR.NAA_SOL.LT.20) GO TO 100


c          write(*,*) '-sol:',CHAIN_SOL,NAA_TEST,NAA_SOL

ccc          F = FLOAT(NAA_TEST)/FLOAT(NAA_SOL)
ccc          IF(F.LT.0.75.OR.F.GT.1.25) GO TO 100

          IF(CHAIN_SOL.EQ.'_') CHAIN_SOL = ' '

          FILE_2 = 'file_sol.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          CALL LENSTR_BL(FILE_2,LLL2)
          IF(LEN.GT.0) THEN
            FILE_2 = PATH_SCR(1:LEN)//FILE_2(1:LLL2)
          ENDIF
          CALL GET_PDB_CHAIN(MDOC,CHAIN_SOL
     *          ,FILE_SOL,FILE_2,NRES,LINE,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERROR: CLEAN_PDB (sol)')
            GO TO 900
          ENDIF

          CALL COMPARE_CHAIN(MDOC,FOUND_FLAG
     *      ,FILE_1,FILE_2,PATH_SCR,PATH_OUT
     *      ,IFIRST,ORIG,IS,CHI,DST,SHX_BEST
     *      ,NPAIR_INI,NPAIR_BEST
     *      ,ARMS,DRMS,DISMAX,IPRINT
     *      ,DIST_LIM,ANG_LIM,ARMS_LIM
     *      ,ORT_TO_FRAC,FRAC_TO_ORT
     *      ,POOL,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)

          IF(IERR.NE.0) THEN 
            IERR = 0
            GO TO 100
c            GO TO 900
          ENDIF

          IF(CHI_BEST.GT.CHI) THEN
            CHI_BEST  = CHI
            ARMS_BEST = ARMS
            DST_BEST  = DST
            ICH_NP    = NPAIR_INI
            ICH_NPB   = NPAIR_BEST
            CHAIN_SHFT_BEST(1) = SHX_BEST(1) 
            CHAIN_SHFT_BEST(2) = SHX_BEST(2)
            CHAIN_SHFT_BEST(3) = SHX_BEST(3)

          ENDIF

c          write(*,*) '--',chi_best,dst_best

          IF(FOUND_FLAG.EQ.'Y') THEN
            IFOUND_SOL(ITEST) = ISOL
            CHAIN_ANG (ITEST) = CHI
            CHAIN_DIST(ITEST) = DST
            CHAIN_DRMS(ITEST) = DRMS
            CHAIN_ARMS(ITEST) = ARMS
            CHAIN_DMAX(ITEST) = DISMAX
            CHAIN_SHFT(1,ITEST) = SHX_BEST(1) 
            CHAIN_SHFT(2,ITEST) = SHX_BEST(2)
            CHAIN_SHFT(3,ITEST) = SHX_BEST(3)
            ICHAIN_NP(ITEST)  = NPAIR_INI
            ICHAIN_NPB(ITEST) = NPAIR_BEST
            GO TO 200
          ENDIF

 100    CONTINUE

        ENDDO
        CHAIN_ANG (ITEST) = CHI_BEST
        CHAIN_DIST(ITEST) = DST_BEST
        CHAIN_ARMS(ITEST) = ARMS_BEST
        CHAIN_SHFT(1,ITEST) = CHAIN_SHFT_BEST(1) 
        CHAIN_SHFT(2,ITEST) = CHAIN_SHFT_BEST(2) 
        CHAIN_SHFT(3,ITEST) = CHAIN_SHFT_BEST(3) 
        ICHAIN_NP(ITEST)  = ICH_NP 
        ICHAIN_NPB(ITEST) = ICH_NPB
 200    CONTINUE

        WRITE(LINE,'(A,1X,A,A,A,5X,F6.2,F6.2)') 
     *  '-- check chain:',CHAIN_TEST,'  found:',FOUND_FLAG
     *   ,CHAIN_ANG(ITEST),CHAIN_DIST(ITEST)
        CALL MSGDOC(MDOC,LINE)

      ENDDO

      CALL MSGDOC(MDOC,'-----')
      WRITE(LINE,'('' Origin:'',3F7.3)') ORIG(1),ORIG(2),ORIG(3)
      CALL MSGDOC(MDOC,LINE)

      CALL MSGDOC(MDOC,'-----')
      LINE = 
     * ' Ch   Naa  Angle  Rms  Dist  Sol_chain  Drms Dmax   Np Np_best'
      CALL MSGDOC(MDOC,LINE)

      NFOUND = 0

      DO I=1,NCHAIN_TEST

        IF(IFOUND_SOL(I).GT.0) THEN
          WRITE(LINE,
     *    '(1X,A,1X,I5,1X,F6.2,F6.2,F6.2,3X,I2,2X,A,2X,2F6.2,2I5)')
     *     CHAIN_LIST_TEST(I),NAA_CHAIN_TEST(I)
     *    ,CHAIN_ANG(I),CHAIN_ARMS(I),CHAIN_DIST(I)
     *    ,IFOUND_SOL(I),CHAIN_LIST_SOL(IFOUND_SOL(I))
     *    ,CHAIN_DRMS(I),CHAIN_DMAX(I)
     *    ,ICHAIN_NP(I),ICHAIN_NPB(I)
          CALL MSGDOC(MDOC,LINE)
          NFOUND = NFOUND + 1


        ELSE
          WRITE(LINE,'(1X,A,1X,I5,1X,2F6.2,F6.2,3F7.3,''  -----'')')
     *     CHAIN_LIST_TEST(I),NAA_CHAIN_TEST(I)
     *    ,CHAIN_ANG(I),CHAIN_ARMS(I),CHAIN_DIST(I)
     *    ,CHAIN_SHFT(1,I),CHAIN_SHFT(2,I),CHAIN_SHFT(3,I)
          CALL MSGDOC(MDOC,LINE)
        ENDIF
      ENDDO
      CALL MSGDOC(MDOC,'-----')
C ------------
      MESSAGE = 'normal termination'
      GO TO 910
C ------------
 900  CONTINUE
      MESSAGE = 'program failed'
      IERR = 1
 910  CONTINUE
      CALL WRITE_SOLUTION_CHECK_XML(MDOC,IERR,MESSAGE,JOB,PATH_OUT
     *                                      ,ORIG,NCHAIN_SOL,NFOUND)

      RETURN
      END

      SUBROUTINE WRITE_SOLUTION_CHECK_XML(MDOC
     *            ,IERR_INPUT,MESSAGE,JOB,PATH_OUT
     *                     ,ORIG,NCHAIN_SOL,NFOUND)
C -------------------------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,MESSAGE*(*),JOB*(*)
      CHARACTER FILE_2*256
      REAL      ORIG(3)
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      IERR = 0
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'n_chain_structure <n_ch_str> ',NCHAIN_SOL,' </n_ch_str>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'n_chain_found <n_ch_found> ',NFOUND,' </n_ch_found>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,3F7.3,A)',ERR=510) 
     *    'origin <orig> ',ORIG(1),ORIG(2),ORIG(3),' </orig>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//JOB(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE COMPARE_CHAIN(MDOC,FOUND_FLAG
     * ,FILE_1,FILE_2,PATH_SCR,PATH_OUT
     * ,IFIRST,ORIG,IS,CHI,DST,SHX_BEST
     * ,NPAIR_INI,NPAIR_BEST
     * ,ARMS,DRMS,DISMAX,IPRINT
     * ,DIST_LIM,ANG_LIM,ARMS_LIM 
     * ,ORT_TO_FRAC,FRAC_TO_ORT
     * ,POOL,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C --------------------------------------------------------
      REAL      POOL(MEMORY)
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW),ORIG(3)
C ----
      CHARACTER FILE_1*(*),FILE_2*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FOUND_FLAG*1
C ---
      CHARACTER FILES*256
      CHARACTER FILE_1A*256,FILE_2A*256,FILE_1AS*256,FILE_1AR*256
      CHARACTER FILE_1AP*256,FILE_2AP*256
C ----
      REAL        AM(3,3),CM(3,3),SM(3,3),SH1(3),SH2(3),SHX(3)
      REAL        AM1(3,3),AM2(3,3),AM3(3,3)
      REAL        SHX_BEST(3),SHY(3)
      REAL        TH1(3),TH2(3),TH(3)
      REAL        ORT_TO_FRAC(3,3),FRAC_TO_ORT(3,3)
      REAL        TALPHA(2),TGAMMA(2),TBETA(2)
      REAL        CNT_FIT(3),CNT_NEW(3),CNT_INI(3) 
      CHARACTER   CHN*1,MODE*1,WEIGHT*1,CH2*1
      CHARACTER   STR_TITLE*40,STR_DATE*9

      CHARACTER   EXT*3,PATH*1,MOD1*1
      CHARACTER   LINE*256
C ---
      PARAMETER ( IPRORG=24)
      REAL      SOR(3,IPRORG)
C ----
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ---------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI    = 4.0*ATAN(1.0)
C ----- 
      NPAIR    = 0
      CHI      = 0.0
      DST      = 0.0
      DRMS     = 0.0
      DISMAX   = 0.0
      SHX(1)   = 0.0
      SHX(2)   = 0.0
      SHX(3)   = 0.0

      SHX_BEST(1)   = 0.0
      SHX_BEST(2)   = 0.0
      SHX_BEST(3)   = 0.0

      NPAIR_INI  = 0
      NPAIR_BEST = 0
      CHI_BEST   = 100000.0
      DST_BEST   = 100000.0
      ARMS_BEST  = 100000.0
C ------

C -----------------------------------
C  IERR = 0 CORR = N  (FILE_OUT) aligned file_2 (not rotated)  
C  IERR =-1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (not rotated)  
C  IERR = 1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (rotated)  
C  IERR =-2 CORR = Y  (FILE_OUT) full file_2 (rotated)  
C  IERR = 3 CORR = P  (FILE_OUT) profile  
C -----------------------------------

      IPR = 1
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILES  = PATH_SCR(1:LEN)//'align.pdb'
      ELSE
        FILES  = PATH_SCR(1:LEN)//'align.pdb'
      ENDIF
      IERR =-1
C      CALL MAKE_ALIGN_D(Mdoc,IPR,FILE_1,FILE_2,FILES

      CALL MAKE_ALIGN_S(Md,IPR,FILE_1,FILE_2,FILES
     *                 ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: ALIGN')
        GO TO 900
      ENDIF

      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILE_1AP = PATH_SCR(1:LEN)//'align_1.pdb'
        FILE_2AP = PATH_SCR(1:LEN)//'align_2.pdb'
        FILE_1A  = PATH_SCR(1:LEN)//'align1.crd'
        FILE_2A  = PATH_SCR(1:LEN)//'align2.crd'
      ELSE
        FILE_1AP = 'align_1.pdb'
        FILE_2AP = 'align_2.pdb'
        FILE_1A  = 'align1.crd'
        FILE_2A  = 'align2.crd'
      ENDIF

      IERR = 0
      CHN  = ' '
      PATH = ' '
      CALL READPDB(M,FILE_1AP,FILE_1A,PATH,ISYM,IPRSYM
     *            ,STR_TITLE,STR_DATE
     *            ,RESULT,IPRROW,CHN,IERR)   
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: READPDB (1)')
        RETURN
      ENDIF
      IERR = 0
      CHN  = ' '
      PATH = ' '
      CALL READPDB(M,FILE_2AP,FILE_2A,PATH,ISYM,IPRSYM
     *            ,STR_TITLE,STR_DATE
     *            ,RESULT,IPRROW,CHN,IERR)   
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: READPDB (2)')
        RETURN
      ENDIF
C ------
      IN = 10
      CALL ORCRD(M,IN,FILE_1A,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: OPEN INPUT_FILE_1')
        RETURN
      ENDIF
      CLOSE(IN) 

      CALL C_AT_CR

      DO I=1,3
      DO J=1,3
        ORT_TO_FRAC(I,J) = CR_ORT_TO_FRAC(I,J)
        FRAC_TO_ORT(I,J) = CR_FRAC_TO_ORT(I,J)
      ENDDO
      ENDDO

c      write(*,*) 'o2f:',(CR_ORT_TO_FRAC(1,i),i=1,3)
c      write(*,*) 'o2f:',(CR_ORT_TO_FRAC(2,i),i=1,3)
c      write(*,*) 'o2f:',(CR_ORT_TO_FRAC(3,i),i=1,3)
c      write(*,*) 'f2o:',(CR_FRAC_TO_ORT(1,i),i=1,3)
c      write(*,*) 'f2o:',(CR_FRAC_TO_ORT(2,i),i=1,3)
c      write(*,*) 'f2o:',(CR_FRAC_TO_ORT(3,i),i=1,3)


      
      CALL CHECK_REF(NSYM,ISYM,IFX,IFY,IFZ)
      IF(IPRINT.LE.0) THEN
        WRITE(LINE,'('' Ifx:'',3I5)') 
     *  IFX,IFY,IFZ
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      IF(IFIRST.EQ.0) THEN
        CALL CALC_ORIG_AV(MDOC,NORIG,SOR,IPRORG
     *   ,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) RETURN      

        IF(IPRINT.LE.0) THEN
        CALL MSGDOC(MDOC,' ')
        CALL MSGDOC(MDOC,' --- List of origins  ---')
        WRITE(LINE,*) ' N_origins = ',NORIG
        CALL MSGDOC(MDOC,LINE)
        ENDIF

        IF(NORIG.GT.0) THEN
          DO I=1,NORIG

            IF(IPRINT.LE.0) THEN
            WRITE(LINE,'('' '',I5,3F8.4)') 
     *      I,SOR(1,I),SOR(2,I),SOR(3,I)
            CALL MSGDOC(MDOC,LINE)
            ENDIF

          ENDDO
        
          IF(IPRINT.LE.0) THEN
          CALL MSGDOC(MDOC,' -----------------------')
          CALL MSGDOC(MDOC,' ')
          ENDIF
          IPRINT = 1

        ELSE
          NORIG=1
          SOR(1,1) = 0.0
          SOR(2,1) = 0.0
          SOR(3,1) = 0.0
        ENDIF
      ELSE
        NORIG=1
        SOR(1,1) = ORIG(1)
        SOR(2,1) = ORIG(2)
        SOR(3,1) = ORIG(3)
      ENDIF

c      write(*,*) '--norig,IFIRST',norig,IFIRST
c      write(*,*) '--sor:',sor(1,1),sor(2,1),sor(3,1)

C ------
C      CALL LENSTR_BL(PATH_SCR,LEN)
C      IF(LEN.GT.0) THEN
C        FILE_1A  = PATH_SCR(1:LEN)//'align1.crd'
C        FILE_1AR = PATH_SCR(1:LEN)//'align1r.crd'
C        FILE_1AS = PATH_SCR(1:LEN)//'align1s.crd'
C        FILE_2A  = PATH_SCR(1:LEN)//'align2.crd'
C      ELSE
C        FILE_1A  = 'align1.crd'
C        FILE_1AR = 'align1r.crd'
C        FILE_1AS = 'align1s.crd'
C        FILE_2A  = 'align2.crd'
C      ENDIF

C ////
      MOD1 = 'Y'
      CALL CALC_INERTIA_MATRIX(MDOC,MOD1,FILE_1A
     *      ,POOL,MEMORY,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: CALC_INERTIA_MATRIX')
        GO TO 900
      ENDIF
C
      FILES    = ' '
      DLIM     = 0.0      
      CALL CHECK_FIT(M,FILE_1A,FILE_2A
     *   ,FILES,FILES,ANG_LIM,DIST_LIM
     *   ,POOL,MEMORY,DLIM,RESULT,IPRROW,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: CHECK_FIT')
        GO TO 900
      ENDIF

      NPAIR_INI = RESULT(1)
      NPAIR_BEST= RESULT(7) 
      DRMS   = RESULT(8)
      DISMAX = RESULT(9) 
      CHI    = RESULT(10)
      CHI_INI= RESULT(5) 
      DIST   = RESULT(11)

      AM(1,1) =  RESULT(21)
      AM(2,1) =  RESULT(22)
      AM(3,1) =  RESULT(23)
      AM(1,2) =  RESULT(24)
      AM(2,2) =  RESULT(25)
      AM(3,2) =  RESULT(26)
      AM(1,3) =  RESULT(27)
      AM(2,3) =  RESULT(28)
      AM(3,3) =  RESULT(29)
      CNT_FIT(1) = RESULT(15)
      CNT_FIT(2) = RESULT(16)
      CNT_FIT(3) = RESULT(17)
      CNT_INI(1) = RESULT(33) 
      CNT_INI(2) = RESULT(34) 
      CNT_INI(3) = RESULT(35) 
      CALL MTOANG(AM,ALPHA_I,BETA_I,GAMMA_I)
      CALL MTOPOL(AM,THETA_I,PHI_I,CHI_I)
      CALL MVMULT(ORT_TO_FRAC,CNT_FIT,SH1)

        write(line,*) '=============================='
        CALL MSGDOC(MD,LINE)
        write(line,*) '-fit-N   :',NPAIR_INI,NPAIR_BEST
        CALL MSGDOC(MD,LINE)
        write(line,*) ' D-fit   :',DIST,DRMS,DISMAX
        CALL MSGDOC(MD,LINE)
c        write(*,*) '-chi_fit :',CHI_INI,CHI
c        write(*,*) '-ang_fitE:',ALPHA_I,BETA_I,GAMMA_I
c        write(*,*) '-ang_fitP:',THETA_I,PHI_I,CHI_I
c        write(*,*) '-CNTR_fit:',CNT_FIT(1),CNT_FIT(2),CNT_FIT(3)
c        write(*,*) '-CNTR_fr :',SH1(1),SH1(2),SH1(3)
c        write(*,*) '-CNTR_ini:',CNT_INI(1),CNT_INI(2),CNT_INI(3)
c        CALL MVMULT(ORT_TO_FRAC,CNT_INI,SH1)
c        write(*,*) '-CNTR_fr :',SH1(1),SH1(2),SH1(3)
        write(line,*) '=============================='
        CALL MSGDOC(MD,LINE)

      TALPHA(2) = ALPHA_I
      TBETA (2) = BETA_I
      TGAMMA(2) = GAMMA_I

      DO IR=1,NORIG

C      write(*,*) '  '
c      write(*,*) 'or ',ir,' =============================='
C      write(*,*) '  '


        TH(1) = SOR(1,IR)
        TH(2) = SOR(2,IR)
        TH(3) = SOR(3,IR)

        CALL MVMULT(FRAC_TO_ORT,TH,SH1)

        CNT_NEW(1) = CNT_INI(1) + SH1(1) 
        CNT_NEW(2) = CNT_INI(2) + SH1(2) 
        CNT_NEW(3) = CNT_INI(3) + SH1(3) 


        DO IS=1,NSYM

C        write(*,*) 'o2f:',(CR_ORT_TO_FRAC(1,j),j=1,3)
C        write(*,*) 'o2f:',(CR_ORT_TO_FRAC(2,j),j=1,3)
C        write(*,*) 'o2f:',(CR_ORT_TO_FRAC(3,j),j=1,3)
C        write(*,*) ' '

          SM(1,1) = REAL(ISYM(1,1,IS))
          SM(2,1) = REAL(ISYM(2,1,IS))
          SM(3,1) = REAL(ISYM(3,1,IS))
          SM(1,2) = REAL(ISYM(1,2,IS))
          SM(2,2) = REAL(ISYM(2,2,IS))
          SM(3,2) = REAL(ISYM(3,2,IS))
          SM(1,3) = REAL(ISYM(1,3,IS))
          SM(2,3) = REAL(ISYM(2,3,IS))
          SM(3,3) = REAL(ISYM(3,3,IS))

          CALL MATMLT(SM,ORT_TO_FRAC,AM)
          CALL MATMLT(FRAC_TO_ORT,AM,CM)
          CALL MTOANG(CM,ALPHA,BETA,GAMMA)

c          write(*,*) '-ang1:',IS,ALPHA,BETA,GAMMA

          TALPHA(1) = ALPHA
          TBETA (1) = BETA
          TGAMMA(1) = GAMMA
          IP = 1
          JP = 2
          NS = 1
          CALL CALC_ORIENTION_RMS(IP,JP,FRAC_TO_ORT,ORT_TO_FRAC
     *        ,TALPHA,TGAMMA,TBETA,NS,ISYM,IPRSYM,ARMS)

          A1 = (ALPHA_I*PI)/180.0
          A2 = (BETA_I *PI)/180.0
          A3 = (GAMMA_I*PI)/180.0
          CALL EULERM(A1,A2,A3,AM1)
          A1 = (ALPHA*PI)/180.0
          A2 = (BETA *PI)/180.0
          A3 = (GAMMA*PI)/180.0
          CALL EULERM(A1,A2,A3,AM2)
          CALL MTRANS(AM1,AM3)
          CALL MATMLT(AM3,AM2,AM1)
          CALL MTOPOL(AM1,THETA,PHI,CHI)

          TH(1) = REAL(ISYM(4,1,IS))/REAL(ISYM(5,1,IS)) 
          TH(2) = REAL(ISYM(4,2,IS))/REAL(ISYM(5,2,IS)) 
          TH(3) = REAL(ISYM(4,3,IS))/REAL(ISYM(5,3,IS))

          CALL MVMULT(FRAC_TO_ORT,TH,SH2)

          CALL MVMULT(CM,CNT_NEW,SH1)

          SHX(1) = SH1(1) + SH2(1)
          SHX(2) = SH1(2) + SH2(2)
          SHX(3) = SH1(3) + SH2(3)

          CALL MVMULT(ORT_TO_FRAC,SHX,SHY)

c        write(*,*) '-CNTR_new:',SHX(1),SHX(2),SHX(3)
c        write(*,*) '-CNTR_fr :',SHY(1),SHY(2),SHY(3)


          SH2(1) = CNT_FIT(1) - SHX(1)
          SH2(2) = CNT_FIT(2) - SHX(2)
          SH2(3) = CNT_FIT(3) - SHX(3)

          CALL MVMULT(ORT_TO_FRAC,SH2,SH1)

C        write(*,*) '-CNTR_del:',SH2(1),SH2(2),SH2(3)
C        write(*,*) '-CNTR_fr :',SH1(1),SH1(2),SH1(3)


          SHX(1) = SH1(1)
          SHX(2) = SH1(2)
          SHX(3) = SH1(3)

          IF(IFIRST.EQ.0) THEN
            IF(IFX.EQ.0) SH1(1) = 0.0
            IF(IFY.EQ.0) SH1(2) = 0.0
            IF(IFZ.EQ.0) SH1(3) = 0.0
          ENDIF

c          write(*,*) '-shx:',shx(1),shx(2),shx(3)
c          write(*,*) '-sh1:',sh1(1),sh1(2),sh1(3)

          CALL CORR_SYMM_PST_VECTORS(SH1)

c          write(*,*) '=sh1:',sh1(1),sh1(2),sh1(3)

          CALL MVMULT(FRAC_TO_ORT,SH1,SH2)


          write(LINE,*) '-t,p,c   :',THETA,PHI,CHI
          CALL MSGDOC(MD,LINE)
          write(LINE,*) '-CNTR_crr:',SH2(1),SH2(2),SH2(3)
          CALL MSGDOC(MD,LINE)
          write(LINE,*) '-CNTR_fr :',SH1(1),SH1(2),SH1(3)
          CALL MSGDOC(MD,LINE)


          D2 = SH2(1)*SH2(1) + SH2(2)*SH2(2) + SH2(3)*SH2(3)
          DST  = SQRT(ABS(D2))

          DD = ABS(CHI_BEST - CHI )
          IF(DD.LT.2.0) THEN
            IF(DST_BEST.GT.DST) THEN
              CHI_BEST  = CHI
              DST_BEST  = DST
              ARMS_BEST = ARMS
              SHX_BEST(1) = SH1(1)
              SHX_BEST(2) = SH1(2)
              SHX_BEST(3) = SH1(3)
            ENDIF
          ELSE IF(CHI_BEST.GT.CHI) THEN
            CHI_BEST  = CHI
            DST_BEST  = DST
            ARMS_BEST = ARMS
            SHX_BEST(1) = SH1(1)
            SHX_BEST(2) = SH1(2)
            SHX_BEST(3) = SH1(3)
          ENDIF
 

          WRITE(LINE,'( A,2I5,3F8.2)') 
     *      '-FIT:',IS,IR,CHI,ARMS,DST
          CALL MSGDOC(MD,LINE)

          if(is.eq.3.and.ir.eq.1) then

          endif

C          IF(ABS(CHI).LT.ANG_LIM.AND.DST.LE.DIST_LIM) THEN
          IF(ARMS.LT.ARMS_LIM.AND.DST.LE.DIST_LIM) THEN
            FOUND_FLAG = 'Y'
            IF(IFIRST.EQ.0) THEN
              IFIRST = 1
              ORIG(1) = SOR(1,IR)
              ORIG(2) = SOR(2,IR)
              ORIG(3) = SOR(3,IR)
              IF(IFX.EQ.0) ORIG(1) = SHX(1)
              IF(IFY.EQ.0) ORIG(2) = SHX(2) 
              IF(IFZ.EQ.0) ORIG(3) = SHX(3)
            ENDIF

            GO TO 100
          ENDIF

 110      CONTINUE

        ENDDO
      ENDDO

      CHI  = CHI_BEST
      DST  = DST_BEST
      ARMS = ARMS_BEST

 100  CONTINUE
C ------
      RETURN
C ------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE CORR_SYMM_PST_VECTORS(XX)
C ----------------------------------------
      REAL  XX(3)
C ----------------------------------------
 10           CONTINUE
              IF(XX(1).GT.0.5)THEN
                XX(1)=XX(1)-1.0
                GO TO 10
              ENDIF
 20           CONTINUE
              IF(XX(1).LE.-0.5)THEN
                XX(1)=XX(1)+1.0
                GO TO 20
              ENDIF
 30           CONTINUE
              IF(XX(2).GT.0.5)THEN
                XX(2)=XX(2)-1.0
                GO TO 30
              ENDIF
 40           CONTINUE
              IF(XX(2).LE.-0.5)THEN
                XX(2)=XX(2)+1.0
                GO TO 40
              ENDIF
 50           CONTINUE
              IF(XX(3).GT.0.5)THEN
                XX(3)=XX(3)-1.0
                GO TO 50
              ENDIF
 60           CONTINUE
              IF(XX(3).LE.-0.5)THEN
                XX(3)=XX(3)+1.0
                GO TO 60
              ENDIF
C ---
        RETURN
        END

      SUBROUTINE CALC_INERTIA_MATRIX(MDOC,MOD,NAMEC
     *      ,POOL,MEMORY,NSYM,ISYM,IPRSYM,IERR)
C==================================================================
      INTEGER     MDOC,IPRSYM,IERR,MEMORY
      INTEGER*2   ISYM(5,3,IPRSYM)
      REAL        POOL(MEMORY)
      CHARACTER   NAMEC*(*),MOD*1
C ---
      COMMON/COM_INERTIA_MATRIX/ MOD_FLAG,AMINER    
      INTEGER    MOD_FLAG
      REAL       AMINER(3,3)
C ---
C==================================================================
      IF(MOD.NE.'Y') THEN
        MOD_FLAG = 0
        RETURN
      ELSE
        MOD_FLAG = 1
      ENDIF
      
      NMAX = MEMORY/3
      CALL CALC_INERTIA_MATRIX_RUN(MDOC,NAMEC
     *      ,AMINER,POOL,NMAX,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        MOD_FLAG = 0
        IERR     = 0
      ENDIF
C --------------------------------------
      RETURN
      END

      SUBROUTINE CALC_INERTIA_MATRIX_RUN(MDOC,NAMEC
     *      ,AMINER,XYZ,NMAX,NSYM,ISYM,IPRSYM,IERR)
C==================================================================
      INTEGER     MDOC,IPRSYM,IERR
      INTEGER*2   ISYM(5,3,IPRSYM)
      REAL        AMINER(3,3),XYZ(3,NMAX)
      CHARACTER   NAMEC*(*)
C --------
      INCLUDE 'mr_crd_com.fh'
C --------
      REAL      XMEAN(3)
      CHARACTER LINE*256
C==================================================================
      IERR = 0
      MD   = -ABS(MDOC)-1
      M    = 99
C --------
      CALL CORR_NAME_BL(NAMEC)
      CALL LENSTR_BL(NAMEC,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input /crd/ file name')
        IERR = 1
        RETURN
      ENDIF
      IN  = 10
      CALL ORCRD(MD,IN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT_FILE/CRD/')
        RETURN
      ENDIF
C --------
      NATOM = 0
      IEND  =-1
C --------------------------------
 200  CONTINUE

      CALL RDCRD(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: READ INPUT_FILE/CRD/')
        CLOSE(IN)
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300

      IF(MODE.EQ.0) THEN

        IF(CR_OCC.GT.0.001) THEN
          IF(NATOM.GE.NMAX) THEN
            WRITE(LINE,'(''ERROR Number of atoms > limit '',I10)')
     *      NMAX
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            RETURN
          ENDIF
          NATOM = NATOM + 1
          XYZ(1,NATOM) = CR_XYZ(1) 
          XYZ(2,NATOM) = CR_XYZ(2) 
          XYZ(3,NATOM) = CR_XYZ(3) 
        ENDIF

      ELSE

C       CR_LINE - string of comments 

      ENDIF      
C ----
      GO TO 200
C --------------------------------------
 300  CONTINUE
      CLOSE(IN)
      IF(NATOM.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: Number of atoms = 0')
        IERR = 1
        RETURN
      ENDIF
C --------------------------------------
      DO I=1,3
        XMEAN(I) = 0.0
      ENDDO
      DO IA=1,NATOM
        DO I=1,3
          XMEAN(I) =  XMEAN(I) + XYZ(I,IA)
        ENDDO
      ENDDO
      DO I=1,3
        XMEAN(I) = XMEAN(I)/FLOAT(NATOM)
      ENDDO
      DO IA=1,NATOM
        DO I=1,3
          DO J=1,3
            AMINER(I,J) = AMINER(I,J) + 
     *        (XYZ(I,IA) - XMEAN(I))*(XYZ(J,IA) - XMEAN(J))
          ENDDO
        ENDDO
      ENDDO
      DO I=1,3
        DO J=1,3
          AMINER(I,J) = AMINER(I,J)/FLOAT(NATOM) 
        ENDDO
      ENDDO
C --------------------------------------
      RETURN
      END

      SUBROUTINE CALC_ORIENTION_RMS(I,J,FRTOCR,CRTOFR
     *      ,TALPHA,TGAMMA,TBETA,NSYM,ISYM,IPRSYM,RMS)
C -------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      TALPHA(*),TGAMMA(*),TBETA(*)
      REAL      AM1(3,3),AM2(3,3)
      REAL      FRTOCR(3,3),CRTOFR(3,3)
      REAL      AM3(3,3),AM4(3,3),SN(3,3),SYM(3,3)
      REAL      AMT(3,3)
C ---
      COMMON/COM_INERTIA_MATRIX/ MOD_FLAG,AMINER    
      INTEGER    MOD_FLAG
      REAL       AMINER(3,3)
C ---
C -------------------------
      RMS = 1001.0
      IF(MOD_FLAG.LE.0) RETURN

      PI    = 4.0*ATAN(1.0)
      A1 = (TALPHA(I)*PI)/180.0
      A2 = (TBETA(I)*PI)/180.0
      A3 = (TGAMMA(I)*PI)/180.0
c      WRITE(*,*) ' ANG1:',TALPHA(I),TBETA(I),TGAMMA(I) 
      B1 = (TALPHA(J)*PI)/180.0
      B2 = (TBETA(J)*PI)/180.0
      B3 = (TGAMMA(J)*PI)/180.0
c      WRITE(*,*) ' ANG2:',TALPHA(J),TBETA(J),TGAMMA(J)

      RMS = 1000.0

      CALL EULERM(A1,A2,A3,AM1)
      CALL EULERM(B1,B2,B3,AM2)
      DO JS=1,NSYM
        SYM(1,1) = REAL(ISYM(1,1,JS))
        SYM(2,1) = REAL(ISYM(2,1,JS))
        SYM(3,1) = REAL(ISYM(3,1,JS))
        SYM(1,2) = REAL(ISYM(1,2,JS))
        SYM(2,2) = REAL(ISYM(2,2,JS))
        SYM(3,2) = REAL(ISYM(3,2,JS))
        SYM(1,3) = REAL(ISYM(1,3,JS))
        SYM(2,3) = REAL(ISYM(2,3,JS))
        SYM(3,3) = REAL(ISYM(3,3,JS))
        CALL MATMLT(SYM,CRTOFR,AM3)
        CALL MATMLT(FRTOCR,AM3,SN)
        CALL MATMLT(SN,AM2,AM3)
        CALL MTRANS(AM1,AMT)
        CALL MATMLT(AMT,AM3,AM4)
        AM4(1,1) = 1.0 - AM4(1,1)
        AM4(2,2) = 1.0 - AM4(2,2)
        AM4(3,3) = 1.0 - AM4(3,3)
        CALL MATMLT(AM4,AMINER,AM3)
        TR = 0.0
        DO II=1,3
          TR = TR + AM3(II,II)
        ENDDO
        IF(TR.LT.0.0) TR = 0.0
        R = SQRT(2.0*TR)
        IF(R.LT.RMS) RMS = R
      ENDDO
C ---
      RETURN
      END

      SUBROUTINE GET_PDB_CHAIN(MDOC,CHAIN_INP
     *          ,FILE_CRD,FILE_REST,NRES,MESSAGE,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_CRD*(*),FILE_REST*(*),MESSAGE*(*)
      CHARACTER PATH*1,EXT*1,CHAIN_INP*1,CHAIN_I*1
      CHARACTER CP_PNUM_OLD*7,CP_PNUM*7,CP_OCC*6
      CHARACTER CHAIN*1,RNAME*3
      CHARACTER LINE*256
      CHARACTER ACODE3(25)*3
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','===' 
     *           ,'---'/
C -------------------------------------------------
C      set '-' in seg_id(76:76) (domains border) 
C ---  
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CP_PNUM_OLD = '???????'
      NRES     = 0
      CHAIN_I  = CHAIN_INP 
      IF(CHAIN_I.EQ.'_') CHAIN_I = ' '
C ----
      EXT  = ' '
      PATH = ' '
      MT   = 16
      CALL OPENFR(MT,M,PATH,FILE_CRD,EXT,IERR)
      IF(IERR.NE.0) THEN
        MESSAGE = 'cannot open input pdb file'
        CALL MSGDOC(MD,
     *       ' ERROR: cannot open input pdb file')
        IERR = 1
        RETURN
      ENDIF
C ---
      IOUT = 0
      CALL CORR_NAME_BLC(FILE_REST)
      CALL LENSTR_BL(FILE_REST,LEN)
      IF(LEN.GT.0) THEN
        EXT  = ' '
        PATH = ' '
        IOUT = 17
        CALL OPENFW(IOUT,M,PATH,FILE_REST,EXT,IERR)
        IF(IERR.NE.0) THEN
          MESSAGE = 'cannot open output pdb file'
          CALL MSGDOC(MD,
     *         ' ERROR: cannot open output pdb file')
          IERR = 1
          CLOSE(MT)
          RETURN
        ENDIF
      ENDIF
C ----------------
 400  CONTINUE
      READ(MT,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)

      IF(LINE(1:6).EQ.'ENDMDL') GO TO 600

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) THEN

        IF(LINE(1:6).EQ.'HEADER'.OR.LINE(1:6).EQ.'COMPND'.OR.
     *     LINE(1:6).EQ.'CRYST1') THEN 
          CALL LENSTR_BL(LINE,LEN)
          IF(IOUT.GT.0) WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
        ENDIF
        GO TO 400
      ENDIF

      CP_PNUM = LINE(21:27)
      CHAIN   = CP_PNUM(2:2)
      RNAME   = LINE(18:20)
      CP_OCC  = LINE(55:60)

      READ(CP_OCC,'(F6.2)') OCC
      IF(OCC.LE.0.0001) GO TO 400

      CALL CORR_RESNAME_BY_SYNONYM(RNAME)
      DO  J=1,23
        IF(RNAME.EQ.ACODE3(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J = 25
  700 CONTINUE

      IF(J.LE.23.AND.CHAIN.EQ.CHAIN_I) THEN
        IF(CP_PNUM_OLD(3:6).NE.CP_PNUM(3:6)) THEN
          NRES = NRES + 1
        ENDIF
        CALL LENSTR_BL(LINE,LEN)
        IF(IOUT.GT.0) WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      ENDIF

      CP_PNUM_OLD = CP_PNUM
      GO TO 400
C --------------
 600  CONTINUE
      IF(IOUT.GT.0) THEN
        END FILE IOUT
        CLOSE(IOUT)
      ENDIF
      CLOSE(MT)
      RETURN
C -------------
 500  CONTINUE
      MESSAGE = 'reading input pdb file'
      CALL MSGDOC(MD,
     *       ' ERROR: reading input pdb file')
      CLOSE(MT)
      IF(IOUT.GT.0) CLOSE(IOUT)
      IERR = 1
      RETURN
 510  CONTINUE
      MESSAGE = 'writting open input pdb file'
      CALL MSGDOC(MD,
     *       ' ERROR: writting output pdb file')
      IF(IOUT.GT.0) CLOSE(IOUT)
      CLOSE(MT)
      IERR = 1
      RETURN
      END

      SUBROUTINE MAKE_ALIGN_S(MDOC,IPRINT,FILE_1,FILE_2,FILE_OUT
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
C  IERR = 0 CORR = N  (FILE_OUT) aligned file_2 (not rotated)  
C  IERR =-1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (not rotated)  
C  IERR = 1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (rotated)  
C  IERR =-2 CORR = Y  (FILE_OUT) full file_2 (rotated)  
C  IERR = 3 CORR = P  (FILE_OUT) profile  
C -----------------------------------
      INTEGER   MDOC,IERR
C     PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_1*(*),FILE_2*(*),FILE_OUT*(*)
C --
c     for alignment
      CHARACTER CHAIN*1,DIST*1,CORR*1
      CHARACTER PAR_ALIGN*16 
C -----------------------------------
      CORR   = 'N'
      ITRANS = 0
      IF(IERR.EQ.-1) THEN
        CORR = '2'
      ELSE IF(IERR.EQ.1) THEN
        CORR   = '2'
        ITRANS = 1
      ELSE IF(IERR.EQ.-2) THEN
        CORR = 'Y'
      ELSE IF(IERR.EQ.3) THEN
        CORR   = 'P'
      ENDIF 
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
c          mode
c          PAR_ALIGN(1:1) = ' '
c ---
C       2: IERR =  0 CORR = N output file(pdb) 
c                    (FILE_OUT) aligned file_2 (not rotated)
C          IERR = -2 CORR --> Y output file(pdb) (FILE_OUT) rotated full file_2 (without alignment)
c          PAR_ALIGN(2:2) = 'Y'
C          IERR = -1 ,CORR --> 2 output fileS(pdb) (FILE_OUT name +_1, +_2)--> FILE_OUT_1, FILE_OUT_2
c          PAR_ALIGN(2:2) = '2'

c molrep   IF(SEQ.EQ.'N') PAR_ALIGN(2:2) = 'N'
c molrep   IF(FOBS.EQ.'N'.AND.MOD2.EQ.'N') PAR_ALIGN(2:2) = 'Y'
c ---
cC       3: D3_FLAG (n,c,y) --> ALIGN_with SURF
c          PAR_ALIGN(3:3) = 'N'
c molrep  IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') PAR_ALIGN(3:3) = SURF
c ---
cC       4: SS_FLAG  use SS
c          PAR_ALIGN(4:4) = 'Y'
c ---
cc       5: remove surf from output
c          PAR_ALIGN(5:5) = 'N'
c ---
cc       6: OCC_FLAG
c          PAR_ALIGN(6:6) = 'N'
      PAR_ALIGN(1:1) = 'G' 
      PAR_ALIGN(1:1) = 'B'
      PAR_ALIGN(2:2) = 'N' 
      IF(CORR.EQ.'2') PAR_ALIGN(2:2) = CORR
      PAR_ALIGN(3:3) = 'Y' 
      PAR_ALIGN(4:4) = 'Y' 
      PAR_ALIGN(5:5) = 'N' 
      PAR_ALIGN(6:6) = 'N' 
      DIST = 'N'
      IF(DIST.EQ.'d') DIST = 'D'
      IF(DIST.NE.'D') DIST = 'N'
      IF(DIST.EQ.'D') THEN
        PAR_ALIGN(4:4) = 'N' 
      ENDIF
      PAR_ALIGN(7:7) = DIST  
      OPENR   = 0.462
      DPENR   = 0.350
      PENEXR  = 0.077

      IF(PAR_ALIGN(1:1).EQ.'G') THEN 
c       'G'
        DPENR   = 0.346
      ELSE
c       'B'
        DPENR   = 0.312
      ENDIF

      OPENR   = 0.462
      PENEXR  = 0.077
      OPENR   = 0.750
      PENEXR  = 0.125
      PENEXR  = 0.01

      MODEL   = 1
      CHAIN   = ' '
      IERR = 0
      IF(ITRANS.EQ.1) IERR = 1
c      CALL ALIGN_3(MDOC,FILE_1,FILE_2,FILE_OUT,PATH_SCR
      CALL ALIGN_4(MDOC,FILE_1,FILE_2,FILE_OUT,PATH_SCR
     *      ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     *      ,RESULT,IPRROW,IERR)
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity
C     RESULT(6) = SUM  score
C     RESULT(7) = NAT  Natom output
C     RESULT(8) = NRES Nres output
C     RESULT(9) = NAT  Natom1 output
C     RESULT(10)= NRES Nres1 output
C     RESULT(11)= NAT  Natom2 output
C     RESULT(12)= NRES Nres2 output
C     RESULT(13) = SCORE1_MAX 
C     RESULT(14) = SCORE_MIN 
C     RESULT(15) = Q_FIN
C     RESULT(16) = DRMS_BEST 
C     RESULT(17) = NPAIR_BEST 
C     RESULT(18) = SCORE_NEW
C     RESULT(19) = FIDENT_NEW
C     RESULT(20) = NGAP
c      IF(IPRROW.GE.41) THEN
C        RESULT(21) = CHI_INI
C        RESULT(22) = DIST_INI
C        RESULT(23) = DRMS_INI
C        RESULT(24) = CHI_BEST
C        RESULT(25) = DIST_BEST
c        RESULT(30) = TR(1)
c        RESULT(31) = TR(2)
c        RESULT(32) = TR(3)
c        RESULT(33) = TRMAT(1,1)
c        RESULT(34) = TRMAT(1,2)
c        RESULT(35) = TRMAT(1,3)
c        RESULT(36) = TRMAT(2,1)
c        RESULT(37) = TRMAT(2,2)
c        RESULT(38) = TRMAT(2,3)
c        RESULT(39) = TRMAT(3,1)
c        RESULT(40) = TRMAT(3,2)
c        RESULT(41) = TRMAT(3,3)
c      ENDIF
      RETURN
      END

