C
C     BAVERAGE
C     Copyright (C) 1992 Eleanor Dodson
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
C                    **********
C                    * BAVERAGE  *
C                    **********
C
C
C       PROGRAM TO AVERAGE B VALUES FOR MAIN AND SIDE CHAIN ATOMS.
C
C     8/8/00 Charles Ballard: O    HOH added
C     1/4/98 Martyn Winn: keyworded version.
C
C     .. Parameters ..
      INTEGER MAXRES
      PARAMETER (MAXRES=800)
C     ..
C     .. Local Scalars ..
      REAL BAVMC, BAVSC, BB, BI, BMAXMC, BMAXSC, BMCTOT, BMINMC, BMINSC,
     +     BR0, BR1, BRANGE, BSCTOT, OCI, RMSBMC, RMSBSC, XI, YI,
     +     ZI, BWCTOT, BAVALL, RMSALL
      INTEGER I, I0, IAI, IBI, IBR, ICHK, ICHN, ICMC, ICSC, IEND, IFAIL,
     +        II, IMCTOT, IOBFAC, IRESN, ISCTOT, IATOM,
     +        ISER, ISYSR, ISYSW, IXYZIN, IXYZOUT, J, JRESN, LDUM, LL,
     +        NATOMS, NHIST, NRESMC, NRESSC, LENT, ICALL
      CHARACTER*1 ALTCOD, INSCOD
      CHARACTER*2 CHNNAM, CHNNM0, CHNOUT
      CHARACTER*4 ATNAM, ID, RESNAM, RESNO, SEGID
      CHARACTER*80 TITLE
C     ..
C     .. Local Arrays ..
      REAL B(MAXRES), BAVB(2), OC(MAXRES), RMSB(2), U(6), X(MAXRES),
     +     Y(MAXRES), Z(MAXRES)
      INTEGER IB(MAXRES), IRES(MAXRES), NBHIST(2, 100)
      CHARACTER*1 ALT(MAXRES), INS(MAXRES)
      CHARACTER*2 CHNNM(MAXRES)
      CHARACTER*4 ATNM(MAXRES), RESNM(MAXRES), ATID(MAXRES), SEG(MAXRES)
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPDPN, CCPERR, CCPFYP, CCPRCS, MTZINI, 
     $         XYZADVANCE, XYZATOM, XYZCLOSE, 
     $         XYZCOORD, XYZINIT, XYZOPEN, XYZREWD
      INTEGER LENSTR
      LOGICAL CCPONL
      EXTERNAL CCPONL, LENSTR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC INT, SQRT

      COMMON /RPARAM/ BMINMC,BMAXMC,BMINSC,BMAXSC,BRANGE
      COMMON /TITLE/ TITLE

      DATA NBHIST /200*0/
C
C     ASSIGN INPUT AND OUTPUT FILES.
C
      CALL CCPFYP
      CALL CCP4H_INIT()
      CALL MTZINI
      CALL XYZINIT
      IOBFAC = 0
      IFAIL = 0
      LDUM = 0
      ISYSW = 6
      ISYSR = 5
      IEND = 0
C
      CALL CCP4H_HEADER('Baverage','baverage',1)
      CALL CCP4H_PRE_BEG()
      CALL CCPRCS(ISYSW, 'BAVERAGE', '$Date: 2007/12/11 17:17:53 $')
      CALL CCP4H_PRE_END() 

      CALL CCP4H_TOC_BEG()
      CALL CCP4H_TOC_ENT('Keywords','#poss_key')
      CALL CCP4H_TOC_ENT('Results','#results')
      CALL CCP4H_TOC_END()

      CALL RCARDS
      CALL CCP4H_HEADER('Results','results',1)
      CALL CCP4H_PRE_BEG()
      LENT = LENSTR(TITLE)
C
      WRITE (ISYSW, FMT=9050) TITLE
 9050 FORMAT (10X, A)
      WRITE (ISYSW, FMT='(A,/,1X,4F9.2)')
     +  ' ** BMIN(mc) BMAX(mc) BMIN(sc) BMAX(sc) for resetting Bs **',
     +  BMINMC, BMAXMC, BMINSC, BMAXSC
C
      WRITE (ISYSW, FMT='(/,A,F6.3)') ' Brange is ', BRANGE
C
      WRITE(ISYSW, 9080)
 9080 FORMAT (' *** HETATM CARDs can cause problems! ***')

      IXYZIN = 0
      IXYZOUT = 0
      CALL XYZOPEN('XYZIN','INPUT',' ',IXYZIN,IFAIL)
      CALL XYZOPEN('XYZOUT','OUTPUT',' ',IXYZOUT,IFAIL)
      CALL CCPDPN(IOBFAC, 'RMSTAB', 'UNKNOWN', 'F', LL, IFAIL)
C
      IRES(1) = 0
      NATOMS = 0
      NATOMC=0
C
C     READ INPUT COORDINATES; ASSUME FIRST RECORD NOT ANISOU
C  find matrix cell etc
C
      CALL XYZADVANCE(IXYZIN,IXYZOUT,0,*90,*90)
      CALL XYZATOM(IXYZIN,ISER, ATNAM, RESNAM, CHNNAM, JRESN, 
     +            RESNO, INSCOD, ALTCOD, SEGID, IAI, ID)
      CALL XYZCOORD(IXYZIN, 'O', 'U', XI, YI, ZI, OCI, BI, U)
      IBI = ISER
      IRESN = JRESN
      WRITE (ISYSW, FMT=9060) IBI, ATNAM, RESNAM, CHNNAM, IRESN,
     +  XI, YI, ZI, OCI, BI, IAI
 9060 FORMAT (' First atom  ', I5, 2X, 2A4, A2, I4, 1X, 3F8.3,
     +       2F6.2, I4)
      CALL XYZREWD(IXYZIN)
C   Write first title:

      CALL CCP4H_GRAPH_BEG(0,0)
      WRITE (ISYSW, FMT=*) ' $$ '
C
C   Write Graph header.
C
      WRITE (ISYSW, FMT=9070) TITLE(1:LENT), CHNNAM, CHNNAM, CHNNAM,
     +  CHNNAM, CHNNAM, CHNNAM, CHNNAM
 9070 FORMAT(/,1X,
     +' $TABLE: Average B v residue  ',A,' CHAIN ',A,':',/,
     +' $GRAPHS',
     $' :Average Bfactors (all atoms) ',
     +' Chain ',A,':N:1,6:',/,
     $' :Average Bfactors (main chain) ',
     +' Chain ',A,':N:1,2:',/,
     +' :Average Bfactors (side chains) ',
     +' Chain ',A,':N:1,4:',/,
     +' : Rms Deviations (all atoms) ',
     +'Chain ',A,':N:1,7:',/,
     +' : Rms Deviations (main chain) ',
     +'Chain ',A,':N:1,3:',/,
     +' : Rms Deviations (side chain) ',
     +'Chain ',A,':N:1,5:',/,
     +' $$',/
     +   '     RES   MC_Bav RMS_MC_B   SC_Bav RMS_SC_B     Bav ',
     $   '   RMS_B   Type Chain $$',/,' $$')
      WRITE (IOBFAC, 9075) CHNNAM
 9075 FORMAT ('#   Chain ',A)
      CHNNM0 = CHNNAM
      ISCTOT=0
      IMCTOT=0
      ISCTOC=0
      IMCTOC=0
      ICSC=0
      ICMC=0
      BAVSC=0
      BAVMC=0
      BWCTOT=0
      BMCTOT=0
      BSCTOT=0
      BWCTOC=0
      BMCTOC=0
      BSCTOC=0
      RMSBMC=0
      RMSBSC=0
      NRESSC=0
      NRESMC=0
      RMSBMT=0
      RMSBST=0
      NRESST=0
      NRESMT=0
      IATOM = 0
C
C     Main loop over coordinates
C
   10 CONTINUE
      CALL XYZADVANCE(IXYZIN, 0, 0, *90, *30)
      CALL XYZCOORD(IXYZIN, 'O', 'U', XI, YI, ZI, OCI, BI, U)
C
C     SKIP ANISOU CARD
C
      IF (U(2).NE.0.0 .OR. U(3).NE.0.0) THEN
        IF (XI.EQ.0.0 .AND. YI.EQ.0.0 .AND. ZI.EQ.0.0) GOTO 10
      ENDIF
      CALL XYZATOM(IXYZIN, IBI, ATNAM, RESNAM, CHNNAM, IRESN, 
     +             RESNO, INSCOD, ALTCOD, SEGID, IAI, ID)

C
      IBR = INT(BI/BRANGE) + 1
      IF (IBR.GT.100) IBR = 100
C
      IF (IATOM.EQ.0) GO TO 20

C     Branch if new residue. Return eventually to 20.
      IF (CHNNM(IATOM).NE.CHNNAM .OR. IRES(IATOM).NE.IRESN) GO TO 40

   20 CONTINUE
C
C    Total no. of atoms
      NATOMS = NATOMS + 1
C    No. of atoms in chain
      NATOMC = NATOMC+1

      IATOM = IATOM + 1
      IF (IATOM.GT.MAXRES)
     $   CALL CCPERR(1, 'Too many atoms in residue: increase MAXRES')
      IB(IATOM) = IBI
      OC(IATOM) = OCI
      ATID(IATOM) = ID
      ATNM(IATOM) = ATNAM
      IRES(IATOM) = IRESN
      RESNM(IATOM) = RESNAM
      CHNNM(IATOM) = CHNNAM
      INS(IATOM) = INSCOD
      ALT(IATOM) = ALTCOD
      SEG(IATOM) = SEGID
      X(IATOM) = XI
      Y(IATOM) = YI
      Z(IATOM) = ZI
      B(IATOM) = BI
C  Side chain or solvent stuff
      IF( (ATNAM.NE.'CA  '.OR.ID.NE.' C  ') .AND. ATNAM.NE.'N   ' .AND. 
     +  (ATNAM.NE.'O   '.OR.RESNAM.EQ.'HOH ').AND. ATNAM.NE.'C   ')
     +  THEN
        NBHIST(2, IBR) = NBHIST(2, IBR) + 1
        ICSC = ICSC + 1
        BAVSC = BAVSC + BI
        ISCTOT = ISCTOT + 1
        BSCTOT = BSCTOT + BI
        ISCTOC=ISCTOC+1
        BSCTOC=BSCTOC+BI
        GO TO 10
      ELSE
C  Main chain stuff
         ICMC = ICMC + 1
         NBHIST(1, IBR) = NBHIST(1, IBR) + 1
         BAVMC = BAVMC + BI
         IMCTOT = IMCTOT + 1
         BMCTOT = BMCTOT + BI
         IMCTOC=IMCTOC+1
         BMCTOC=BMCTOC+BI
         GO TO 10
      ENDIF

C   End of file was reached
   30 CONTINUE
      IEND = 1
C   Found a new residue.
   40 CONTINUE
C
      BAVALL = BAVSC + BAVMC
      ICALL = ICSC + ICMC
      IF (ICALL .GT. 0) THEN
         BAVALL = BAVALL/ICALL
      ELSE
         BAVALL = 0.0
      ENDIF
      IF (ICSC.GT.0) BAVSC = BAVSC/ICSC
      IF (ICMC.GT.0) BAVMC = BAVMC/ICMC
      BAVB(1) = BAVMC
      BAVB(2) = BAVSC
      RMSB(1) = 0.
      RMSB(2) = 0.
      I0 = IATOM - ICMC - ICSC + 1
      DO 50 II = I0, IATOM
        ICHK = 2
        IF ((ATNM(II).EQ.'CA  '.AND.ATID(II).EQ.' C  ') .OR. 
     +      ATNM(II).EQ.'N   ' .OR. ATNM(II).EQ.'O   ' .OR. 
     +      ATNM(II).EQ.'C   ') ICHK = 1
        RMSB(ICHK) = RMSB(ICHK) + (BAVB(ICHK)-B(II))**2
   50 CONTINUE
      RMSALL = RMSB(1) + RMSB(2)
      IF (ICALL .GT. 0) THEN
         RMSALL = SQRT(RMSALL/ICALL)
      ELSE
         RMSALL = 0.0
      ENDIF
      IF (ICSC.GT.0) RMSB(2) = SQRT(RMSB(2)/ICSC)
      IF (ICMC.GT.0) RMSB(1) = SQRT(RMSB(1)/ICMC)
C   INCLUDE RMS VALUES IN MEAN ONLY FOR RESIDUES WITH MORE THAN 1 ATOM!
      IF (ICSC.GT.1.AND.
     *  (RESNM(IATOM).NE.'WAT '.AND.RESNM(IATOM).NE.'HOH ')) THEN
        RMSBSC = RMSBSC + RMSB(2)
        NRESSC = NRESSC + 1
        RMSBST = RMSBST +RMSB(2)
        NRESST = NRESST + 1
      END IF
      IF (ICMC.GT.1) THEN
        RMSBMC = RMSBMC + RMSB(1)
        NRESMC = NRESMC + 1
        RMSBMT = RMSBMT + RMSB(1)
        NRESMT = NRESMT + 1
      END IF
      R1 = 0
      IF (ABS(BAVMC).GT.0.0001) R1 = RMSB(1)/BAVMC
      R2 = 0
      IF (ABS(BAVSC).GT.0.0001) R2 = RMSB(2)/BAVSC
      WRITE (IOBFAC, FMT=9090)
     $   IRES(IATOM), BAVMC, R1, BAVSC, R2, BAVALL, RMSALL
 9090 FORMAT (I5, 6(1X, F9.3))
C LIZ: For unnamed chain write out '_' so loggraph can read it
      IF ( CHNNM(IATOM) .EQ. ' ' ) THEN
        CHNOUT = '_'
      ELSE
        CHNOUT = CHNNM(IATOM)
      ENDIF
      WRITE (ISYSW, FMT=9100) IRES(IATOM), BAVMC, R1, BAVSC, R2,
     +  BAVALL, RMSALL, RESNM(IATOM), CHNOUT
 9100 FORMAT (I8, 3(1X, F8.1, 1X, F8.4), 3X, A4, A2)

C  If we have changed CHAIN ID or have finished the last
C  chain, then write averages for this chain. 
C  If this is not the last chain, write a new header.
      IF (CHNNAM.NE.CHNNM0 .OR. IEND.EQ.1) THEN
C  Write $$ for luck - does no harm!
        WRITE (ISYSW, FMT=*) ' $$ '
        IF (NATOMC.GT.0) BWCTOC=(BMCTOC+BSCTOC)/NATOMC
        IF (IMCTOC.GT.0) BMCTOC=BMCTOC/IMCTOC
        IF (ISCTOC.GT.0) BSCTOC=BSCTOC/ISCTOC
        IF (NRESSC.GT.0) RMSBSC = RMSBSC/NRESSC
        IF (NRESMC.GT.0) RMSBMC = RMSBMC/NRESMC
        WRITE(ISYSW,*)' $$ '
        CALL CCP4H_GRAPH_END()
        WRITE(ISYSW,801) CHNNM0,NATOMC,CHNNM0,BMCTOC,CHNNM0,BSCTOC,
     $     CHNNM0,BWCTOC,NRESMC,RMSBMC,NRESSC,RMSBSC
 801    FORMAT(//,
     $       10X,'Total number of atoms in chain  ',A,I8,/,
     +       10X,'Average B value for main chain  ',A,F8.3,/,
     +       10X,'Average B value for side chain  ',A,F8.3,/,
     +       10X,'Average B value for whole chain ',A,F8.3,//,
     +       10X,'Average rms B for',I6,
     +       ' main chain residues ',F8.3,/,
     +       10X,'Average rms B for',I6,
     +       ' side chain residues ',F8.3)
        CHNNM0 = CHNNAM
        NATOMC = 0
        IMCTOC = 0
        ISCTOC = 0
        BMCTOC = 0
        BSCTOC = 0
        NRESSC = 0
        NRESMC = 0
        RMSBSC = 0
        RMSBMC = 0
        DO 55 I = 1,6
          U(I) = 0.0
  55    CONTINUE
C
C   Write new header: see above for format..
        IF (IEND .EQ. 0) THEN
          CALL CCP4H_GRAPH_BEG(0,0)
           WRITE (ISYSW, FMT=9070)
     $        TITLE(1:LENT), CHNNAM, CHNNAM, CHNNAM, CHNNAM, CHNNAM,
     $        CHNNAM, CHNNAM
           WRITE (IOBFAC, 9075) CHNNAM
        ENDIF 
      END IF

C   Write out residue to XYZOUT, resetting B factors where necessary
      DO 60 J = 1, IATOM
C  Ichn = 1 for main chain, 2 for side chain
        ICHN = 2
C
        IF (ATNM(J).EQ.'CA  ' .OR. ATNM(J).EQ.'N   ' .OR.
     +       ATNM(J).EQ.'O   ' .OR. ATNM(J).EQ.'C   ') THEN
          ICHN = 1
          BB = B(J)
          IF (BB.LT.BMINMC) BB = BMINMC
          IF (BB.GT.BMAXMC) BB = BMAXMC
        ELSE
          BB = B(J)
          IF (BB.LT.BMINSC) BB = BMINSC
          IF (BB.GT.BMAXSC) BB = BMAXSC
        END IF
C
        CALL XYZATOM(IXYZOUT, IB(J), ATNM(J), RESNM(J), CHNNM(J), 
     +          IRES(J), RESNO, INS(J), ALT(J), SEG(J), IAI, ATID(J))
        U(1) = BB
        CALL XYZCOORD(IXYZOUT, 'O', 'U', X(J), Y(J), Z(J), OC(J), 
     +                 BB, U)
        CALL XYZADVANCE(IXYZOUT, 0, 0, *60, *60)
   60 CONTINUE

C     This wasn't last residue, so return upwards.
      IF (IEND.NE.1) THEN
        ICSC = 0
        BAVSC = 0
        ICMC = 0
        BAVMC = 0
        IATOM = 0
        GO TO 20
      END IF

C     End of file, so do final averages.
      IF (NATOMS.GT.0) BWCTOT = (BMCTOT+BSCTOT)/NATOMS
      IF (IMCTOT.GT.0) BMCTOT = BMCTOT/IMCTOT
      IF (ISCTOT.GT.0) BSCTOT = BSCTOT/ISCTOT
      IF (NRESST.GT.0) RMSBST = RMSBST/NRESST
      IF (NRESMT.GT.0) RMSBMT = RMSBMT/NRESMT
      WRITE (ISYSW, FMT=9110) NATOMS, BMCTOT, BSCTOT, BWCTOT, 
     +  NRESMT, RMSBMT, NRESST, RMSBST
 9110 FORMAT (//10X, 'TOTAL NO. OF ATOMS IN FILE = ', I5, /10X,
     +       'AVERAGE B VALUE FOR MAIN CHAINS           ', F8.3, /10X,
     +       'AVERAGE B VALUE FOR SIDE CHAINS AND WATERS', F8.3, /10X,
     +       'AVERAGE B VALUE FOR ALL ATOMS', F8.3, //10X,
     +       'AVERAGE RMS B FOR', I6, ' MAIN CHAIN RESIDUES ', F8.3,
     +       /10X, 'AVERAGE RMS B FOR', I6, ' SIDE CHAIN RESIDUES ',
     +       F8.3)
C
      WRITE (ISYSW, FMT=9120)
 9120 FORMAT (//'  Histogram of Bvalues ',
     +       ' No of ATOMS with Bs within BRANGE(i)-BRANGE(i+1)',
     +       /' NRANGE - BR0 - BR1  MAIN CHAIN  - SIDE CHAIN - TOTAL')
C
      DO 80 IBR = 1, 100
        NHIST = NBHIST(1, IBR) + NBHIST(2, IBR)
C
        IF (NHIST.GT.0) THEN
          BR1 = BRANGE*IBR
          BR0 = BR1 - BRANGE
          WRITE (ISYSW, FMT='(I6,F6.2,A, F6.2,3I10)') IBR, BR0, '-',
     +      BR1, NBHIST(1, IBR), NBHIST(2, IBR), NHIST
        END IF
C
   80 CONTINUE
C
      CALL XYZCLOSE(IXYZIN)
      CALL XYZCLOSE(IXYZOUT)
      CALL CCPERR(0, 'Normal termination')
   90 CONTINUE
      CALL CCPERR(1, ' FILE OPENING ERROR')
      END

      SUBROUTINE RCARDS

      IMPLICIT NONE

      INTEGER NPARM
      PARAMETER  (NPARM=200)

      CHARACTER*80 TITLE
      REAL BMINMC,BMAXMC,BMINSC,BMAXSC,BRANGE
C    
C---- things for parser
C
      CHARACTER KEY*4,LINE*600,CVALUE(NPARM)*4
      REAL      FVALUE(NPARM)
      LOGICAL   LEND,LOGDEBUG
      INTEGER   NTOK,IBEG(NPARM),IEND(NPARM),ITYPE(NPARM),
     +          IDEC(NPARM)

      COMMON /RPARAM/ BMINMC,BMAXMC,BMINSC,BMAXSC,BRANGE
      COMMON /TITLE/ TITLE

C     Set some defaults
      TITLE = 'From baverage.'
      BMINMC = 0.
      BMAXMC = 100.
      BMINSC = 0.
      BMAXSC = 100.
      BRANGE = 5.0

      LOGDEBUG = .TRUE.
      CALL CCP4H_HEADER('Keywords','poss_key',1)
      CALL CCP4H_PRE_BEG()
 10   CONTINUE
      NTOK=NPARM
      LINE=' '
      CALL PARSER (KEY,LINE,IBEG,IEND,ITYPE,FVALUE,CVALUE,IDEC,NTOK,
     +             LEND,LOGDEBUG)
      IF (LEND) GO TO 1000
C
      IF (KEY .EQ. 'END')  THEN
           GO TO 1000
C
      ELSE IF (KEY.EQ.'TITL') THEN
        IF(NTOK.GE.2) TITLE = LINE(IBEG(2) :IEND(NTOK))
C
      ELSE IF (KEY.EQ.'BLIM') THEN
        IF(NTOK.GE.2) CALL GTPREA (2,BMINMC,NTOK,ITYPE,FVALUE)
        IF(NTOK.GE.3) CALL GTPREA (3,BMAXMC,NTOK,ITYPE,FVALUE)
        IF(NTOK.GE.4) CALL GTPREA (4,BMINSC,NTOK,ITYPE,FVALUE)
        IF(NTOK.GE.5) CALL GTPREA (5,BMAXSC,NTOK,ITYPE,FVALUE)
C
      ELSE IF (KEY.EQ.'BRAN') THEN
        IF(NTOK.GE.2) CALL GTPREA (2,BRANGE,NTOK,ITYPE,FVALUE)

      ELSE
C
C----- ????? not understood
C
        WRITE(6,*) ' Keyword ',KEY,' not recognised: ignored!'
        WRITE(6,*) ' N.B. input now keyworded, see documentation.'
      END IF
C
      GO TO 10
C        
1000  CONTINUE
      CALL CCP4H_PRE_END()
      RETURN
      END
