/*
  Copyright (c) Navraj Pannu       1998 - 2005
  Copyright (c) Leiden University  2002 - 2005

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.     
*/

#ifndef AFROINPUT_H
#define AFROINPUT_H	1

#include "crystal.h"
#include "afrolikelihood.h"
#include "input.h"
#include "model.h"
#include "minimizer.h"
#include "ccp4_parser.h"                  // Peter Briggs' parser in c libraries

class Afroinput : public Input
{
 public:
  Afroinput(Model &, Crystal &, Afrolikelihood &, Minimizer &);
  ~Afroinput(){;}
  
 private:
  // references to  model, crystal, likelihood and minimizer classes
  Afrolikelihood &like;
  
  void CCP4parse();
  
  bool afrokeywords();
  void ascikeyword();
  void hirekeyword();
  void evalkeyword();
  void dffekeyword();
  void giackeyword();
  void deltkeyword();
  
  void check();
  void print() const {printf("\nAtomic parameters inputted\n"); mdl.print(true);}
};

#endif
