/*
  Copyright (c) Navraj Pannu       1998 - 2005
  Copyright (c) Leiden University  2002 - 2005

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.     
*/

#ifndef GCXINPUT_H
#define GCXINPUT_H	1

#include "gcxlikelihood.h"
#include "crystal.h"
#include "input.h"
#include "model.h"
#include "minimizer.h"

class Gcxinput : public Input
{
 public:
  Gcxinput(Model &, Crystal &, Gcxlikelihood &, Minimizer &);
  ~Gcxinput(){;}
  
 private:
  Gcxlikelihood &like;
  
  void check();
  void CCP4parse();

  bool gcxkeywords();
  void solvkeyword();
  void nreskeyword();
  void nnuckeyword();
  void nmonkeyword();
  void sadokeyword();
  void diskkeyword();
  void obfakeyword();

  void pipekeyword();
  // individual program keywords
  void prepkeyword();
  void afrokeyword();
  void crunkeyword();
  void bp3keyword();
  void refmkeyword();
  void solokeyword();
  void solhkeyword();
  void dmkeyword();
  void pirakeyword();
  void bucckeyword();
  void redmkeyword();
  void rebukeyword();
  void warpkeyword();
  void shlckeyword();
  void shldkeyword();
  void shlekeyword();
  void checkeyword();
  void shlhkeyword();
  
  void print() const
    { printf("\nAtomic parameters inputted\n"); mdl.print(true);}  
};

#endif
