/*
  Copyright (c) Navraj Pannu       1998 - 2005
  Copyright (c) Leiden University  2002 - 2005

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "misc.h"
#include "gcxinput.h"
#include "crystal.h"
#include "gcxlikelihood.h"
#include "model.h"

// local functions
void Banner(int, char**);
void GetInput(Model &, Crystal &, Gcxlikelihood &, Minimizer &);

int main(int argc, char** argv)
{
  Banner(argc, argv); 
  // initialize classes for our parameters and data
  Model mdl;
  Crystal xtal;
  Gcxlikelihood likelihood(mdl, xtal);
  Minimizer minimizer(likelihood);
  
  GetInput(mdl, xtal, likelihood, minimizer);
  
  likelihood.setup();
  Termination();

}

void Banner(int argc, char** argv)
{
  char version[] = "0.6";
  CCP4Banner(argc,argv,version);
  printf("                           GCX\n");
  printf("    Generate a crank xml file to run crank via scripts\n");
  printf("                  Developmental Version\n");
  printf("                      7 April 2006\n\n");
  printf("        http://www.bfsc.leidenuniv.nl/software/\n\n");
}

void GetInput(Model &mdl, Crystal &xtal,
	      Gcxlikelihood &like, Minimizer &minimizer)
{
  // gets input and stores it in data structures
  Gcxinput input(mdl, xtal, like, minimizer);
}
