/*
     ccp4mapwish_main.c: driver to create custom Tcl/Tk interpreter
     Copyright (C) 2001  CCLRC, Peter Briggs

     This code is distributed under the terms and conditions of the
     CCP4 Program Suite Licence Agreement as a CCP4 Application.
     A copy of the CCP4 licence can be obtained by writing to the
     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
*/

/*******************************************************************/

/* ccp4mapwish_main.c */

/*******************************************************************/

/* CCP4mapwish

   Customised version of Tcl/Tk interpreter - basically this is wish
   plus the ccp4map package preloaded.

*/

/*******************************************************************/

/* Include header file */

/*******************************************************************/

#include "ccp4mapwish.h"

/*******************************************************************/

/* Main program and Tk_AppInit*/

/*******************************************************************/

int main(int argc, char *argv[])
{

  /* Call Tk_Main */
  Tk_Main(argc, argv, Tk_AppInit);
  exit(0);
}

/* This initialises the application-specific commands
   It is called by Tk_Main */

int Tk_AppInit(Tcl_Interp *interp)
{
  /* Initialise packages */
  if (Tcl_Init(interp) == TCL_ERROR) {
    return TCL_ERROR;
  }
  if (Tk_Init(interp) == TCL_ERROR) {
    return TCL_ERROR;
  }
  if (Ccp4map_Init(interp) == TCL_ERROR) {
    return TCL_ERROR;
  }
  return TCL_OK;
}

/*------------------------------------------------------------------------------*/
