/*
     ccp4mapwish_tcl.c: Tcl-specific functions and utilities
     Copyright (C) 2001  CCLRC, Peter Briggs

     This code is distributed under the terms and conditions of the
     CCP4 Program Suite Licence Agreement as a CCP4 Application.
     A copy of the CCP4 licence can be obtained by writing to the
     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
*/
/*
*/

/*******************************************************************/

/* ccp4mapwish_tcl.c */

/*******************************************************************/

/* Tcl-specific functions and utilities */

/*******************************************************************/

/* Include header file */

/*******************************************************************/

#include "ccp4mapwish.h"

/*******************************************************************/

/* Tcl-specific functions */

/*******************************************************************/

/* get_tcl_interp_ptr

   Set or return the pointer to the Tcl interpreter

   Always return a pointer to a Tcl interpreter "object"
   If the argument new_interp_Ptr is not null then set the
   Tcl interpreter pointer to this new value.
*/
Tcl_Interp* get_tcl_interp_ptr(Tcl_Interp* new_interp_Ptr)
{
  static Tcl_Interp *tcl_interp_Ptr=NULL;

  if (new_interp_Ptr) tcl_interp_Ptr = new_interp_Ptr;
  return tcl_interp_Ptr;
}

/*------------------------------------------------------------------------------*/

/* append_tcl_command

   Dynamically allocate memory and append one string to another when
   building a Tcl command

   Returns a pointer to the new command string, or to NULL if there
   is an error.
*/
char* append_tcl_command(char *commandstr, char *appendstr)
{
  int new_strlen;
  char *new_commandstr;
  
  new_strlen = strlen(commandstr) + strlen(appendstr) + 1;
  new_commandstr = (char *) realloc(commandstr,new_strlen*sizeof(char));
  if (!new_commandstr) {
    puts("append_tcl_command: couldn't reallocate memory for new_commandstr");
    return NULL;
  }
  strcat(new_commandstr,appendstr);
  return new_commandstr;
}

/*------------------------------------------------------------------------------*/

