C
C     CIF2MTZ
C     Copyright (C) 2001 Martyn Winn
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C*************************************************************
C
C
C**************************************************************
C

C To add new mmCIF column labels:
C   1. extrend array cifrnames and update cifrcols
C   2. put the corresponding MTZ column labels and
C      types in LSPRGO and CTPRGO, and update nlprgo
C Unless you have special requirements for a particular 
C column, the rest should take care of itself.

      program cif2mtz

      integer maxlab, maxtok
* Max number of labels
      parameter (maxlab = 80)
* Max number of tokens for 'parser'
      parameter (maxtok = 2*maxlab+1)

c_______Returned values for setting up contexts (see value_manip.h)
      integer cat_not_present, loop_context, item_context
      parameter (cat_not_present = 0, loop_context = 1,
     &  item_context = 2)
      
c_______Input status values for data-retrieval routines (see value_manip.h)
      integer start_new_context, keep_context, advance_context,
     & append_row, advance_hold
      parameter (start_new_context=0, keep_context=1,
     &  advance_context=2, append_row=3, advance_hold=4)

c_______Returned status values from data-retrieval routines  (see value_manip.h)
      integer no_value, loop_value, single_value, end_of_context, 
     & single_dict, loop_dict, single_null, loop_null, loop_unknown, 
     & parenthesis_esd
      parameter (no_value=0, loop_unknown=1, single_value=2, 
     &  loop_value=3, single_dict=4, loop_dict=5, single_null=6,
     &  loop_null=7, end_of_context=8, parenthesis_esd=9)

      logical debug, lanom
      integer i, k, ct, ntok, nskip
      integer ibeg(maxtok), iend(maxtok), ityp(maxtok), idec(maxtok)
      integer nsymx, nsympx, nspgrx, NLAUE
      real fvalue(maxtok), cell(6)
      character str*500,date*8,date6*6,errline*200
      character*64 PROJECTNAME,CRYSTALNAME,DATASETNAME
      character*64 XNAME(maxlab),DNAME(maxlab)
      character*4 key, subkey, cvalue(maxtok)
      character freer_convention*4,free_refl*1,work_refl*1
      character spgrnx*20, spgrnx_ns*20, pgnamx*10
      character lsprgo(maxlab)*30, ctprgo(maxlab)
      character labout(maxlab)*30, typout(maxlab), lbolin*400
      integer lbobeg(maxtok), lboend(maxtok), lbotkn
      integer nlabout,lookup(maxlab),ihkl(3),isign,ifirst,ireallyfirst
      real rsymx(4,4,192),adata(maxlab),pdata(maxlab),fdata(maxlab)
      logical qisnan
      external qisnan

C cif variables
      INTEGER blk_id,icontext,istat,IDX,ifail,ival
      real rval
      character*(80) blknam
      logical lcif
      integer btype, sline, lenval
      character*(1) cdata
      character*(80) val,ccode, pcode

c ___ Number of real items which might appear on a CIF REFLN packet
      integer cifrcols, cifsynonyms
      parameter (cifrcols=28, cifsynonyms=2)
      character*80 cifrnames(cifsynonyms,cifrcols)
      data cifrnames / 
     &  '_refln.index_h',' ',
     &  '_refln.index_k',' ',
     &  '_refln.index_l',' ',
     &  '_refln.status',' ',
     &  '_refln.F_meas_au','_refln.F_meas',
     &  '_refln.F_meas_sigma_au','_refln.F_meas_sigma',
     &  '_refln.F_calc_au','_refln.F_calc',
     &  '_refln.phase_calc',' ',
     +  '_refln.phase_meas',' ',
     &  '_refln.fom', '_refln.weight',
     &  '_refln.intensity_meas','_refln.F_squared_meas',
     &  '_refln.intensity_sigma','_refln.F_squared_sigma',
     +  '_refln.F_part_au', ' ',
     +  '_refln.phase_part', ' ',
     +  '_refln.pdbx_F_plus', ' ',
     +  '_refln.pdbx_F_plus_sigma', ' ',
     +  '_refln.pdbx_F_minus', ' ',
     +  '_refln.pdbx_F_minus_sigma', ' ',
     +  '_refln.pdbx_anom_difference', ' ',
     +  '_refln.pdbx_anom_difference_sigma', ' ',
     +  '_refln.pdbx_I_plus', ' ',
     +  '_refln.pdbx_I_plus_sigma', ' ',
     +  '_refln.pdbx_I_minus', ' ',
     +  '_refln.pdbx_I_minus_sigma', ' ',
     +  '_refln.pdbx_HL_A_iso', ' ',
     +  '_refln.pdbx_HL_B_iso', ' ',
     +  '_refln.pdbx_HL_C_iso', ' ',
     +  '_refln.pdbx_HL_D_iso', ' '/

      data freer_convention,free_refl,work_refl /'XPLO','1','0'/

      logical lsymm, lcell, lend, kylabo
      data lsymm, lcell /2*.false./

      DATA nlprgo /28/
      DATA (LSPRGO(J),J=1,28)/'H','K','L','FREE','FP','SIGFP',
     +       'FC','PHIC','PHIB','FOM','I','SIGI','FPART','PHIP',
     +       'F(+)','SIGF(+)','F(-)','SIGF(-)','DP','SIGDP',
     +       'I(+)','SIGI(+)','I(-)','SIGI(-)','HLA','HLB',
     +       'HLC','HLD'/
      DATA (CTPRGO(J),J=1,28)/'H','H','H','I','F','Q',
     +       'F','P','P','W','J','Q','F','P',
     +       'G','L','G','L','D','Q',
     +       'K','M','K','M','A','A','A','A'/

      debug=.false.
      lcif = .true.
      lanom = .false.

      nsymx = 0
      nskip = 0
      DO I = 1,MAXLAB
        LOOKUP(I) = 0.0
      ENDDO

      call ccpfyp
      call mtzini
      CALL CCPRCS(6,'cif2mtz','$Date: 2007/07/27 14:17:53 $')

C Set default PROJECTNAME,CRYSTALNAME and DATASETNAME
      CALL CCPDAT(DATE)
      WRITE(DATE6,'(A2,A2,A2)') DATE(1:2),DATE(4:5),DATE(7:8)
 5    I = INDEX(DATE6,' ')
      IF (I.GT.0) THEN
        WRITE(DATE6(I:I),'(A1)') '0'
        GOTO 5
      ENDIF
      PROJECTNAME   = 'unknown'
      CRYSTALNAME   = 'unknown'
      DATASETNAME   = 'unknown'//DATE6

      kylabo = .false.

* Open mtz file 
      call lwopen(1,'HKLOUT')

* Parse user input
 10   continue

      str = ' '
      ntok = maxtok
      call parser (key, str, ibeg, iend, ityp, fvalue, cvalue,
     $     idec, ntok, lend, .true.)
      if (lend) go to 500

*     TITLE keyword 
      if (key .eq. 'TITL') then
         call lwtitl (1, str(ibeg(2):iend(ntok)), 0)   
         goto 10

*     CELL keyword - read in the cell parameters
      else if (key .eq. 'CELL') then
         call rdcell (2, ityp, fvalue, ntok, cell)
         lcell = .true.
         go to 10

*     LABOUT keyword
      else if (key .eq. 'LABO') then
         if (ntok.gt.maxlab) call ccperr (1, 'Too many labels')
         kylabo = .true.
         lbolin = str(1:400)
         lbotkn = ntok
         do 20 jdo = 1,lbotkn
           lbobeg(jdo) = ibeg(jdo)
           lboend(jdo) = iend(jdo)
 20      continue
         goto 10

*     ANOMALOUS keyword
      else if (key .eq. 'ANOM') then     
         lanom = .true.
         goto 10

*     SYMM keyword
      else if (key .eq. 'SYMM') then
         call rdsymm (2, str, ibeg, iend, ityp, fvalue, ntok,
     $        spgrnx, nspgrx, pgnamx, nsymx, nsympx, rsymx)
         spgrnx_ns = spgrnx
         lsymm = .true.
         goto 10


c     ==========================================
c---- name project <pname> crystal <xname> dataset <dname>
c     ==========================================
c---- assign project/crystal/dataset names for new mtz file

      ELSEIF (KEY.EQ.'NAME') THEN

        if (ntok.lt.7) then
          call ccperr(2,'NAME keyword line incomplete - ignored!')
          goto 10
        endif

        n = 2
 451    if (n .le. ntok) then
         subkey = cvalue(n)(1:4)
         call ccpupc(subkey)
         if (subkey .eq. 'PROJ') then
c  set current pname
            PROJECTNAME = str(ibeg(n+1):iend(n+1))
            n = n+2
         elseif (subkey .eq. 'CRYS') then
c  set current xname
            CRYSTALNAME = str(ibeg(n+1):iend(n+1))
            n = n+2
         elseif (subkey .eq. 'DATA') then
            DATASETNAME = str(ibeg(n+1):iend(n+1))
            n = n+2
         else
            write(errline,'(a,a)') 
     +            'wrong subkeyword after NAME: ',cvalue(n)
            call ccperr(1,errline)
         endif
         go to 451
        endif

        go to 10
C
C     ==========================================
C---- PNAME    >> PROJECTNAME [pname]  <string>
C     ==========================================
C     
      ELSEIF (KEY.EQ.'PNAM') THEN
         if (ntok .ge. 2) PROJECTNAME = str(ibeg(2):iend(2))
         goto 10
C
C     ===========================================
C---- XNAME    >> CRYSTALNAME  [xname]  <string>
C     ===========================================
C     
      ELSEIF (KEY.EQ.'XNAM') THEN
         if (ntok .ge. 2) CRYSTALNAME = str(ibeg(2):iend(2))
         goto 10
C
C     ===========================================
C---- DNAME    >> DATASETNAME  [dname]  <string>
C     ===========================================
C     
      ELSEIF (KEY.EQ.'DNAM') THEN
         if (ntok .ge. 2) DATASETNAME = str(ibeg(2):iend(2))
         goto 10
C
C     STATUS XPLO | CCP4
C
      ELSEIF (KEY.EQ.'STAT') THEN
         if (ntok .ge. 2) freer_convention = str(ibeg(2):ibeg(2)+3)
         call ccpupc(freer_convention)
         if (freer_convention.eq.'XPLO') then
           free_refl = '1'
           work_refl = '0'
         elseif (freer_convention.eq.'CCP4') then
           free_refl = '0'
           work_refl = '1'
         endif
         goto 10

*     END keyword
      else if (key .eq. 'END') then
         goto 500
*     else error
      else
        call ccperr (1, 'Bad keyword: '//key)
      endif

*** End of input parsing.

 500  continue

C  first sweep input file for PDB header lines inserted as mmCIF comments
      if (.not.lcell .or. .not.lsymm) then
        call get_pseudo_pdb_cell_symm(cell, lcell, spgrnx, lsymm)
        if (lsymm) then
          CALL  MSYMLB3(24,nspgrx,spgrnx,spgrnx_ns,pgnamx,NSYMPX,NSYMX,
     +                    RSYMX)
        endif
      endif

      if (lcif) then
       call ccif_init('MMCIFDIC')
       ifail = 0
       call ccif_load_cif('HKLIN',nblock,ifail)
       IDX = 1
       call ccif_block_by_index('HKLIN',IDX,blknam,blk_id,istat)

C  estblish which columns present
       ISTAT = 0
       call ccp4ccif_setup_context('REFLN',blk_id,icontext,istat,' ')
       NCOL = 0
       istat = advance_context
       DO I = 1,cifrcols
        nsyn = 1
 600    continue
        call ccif_item_type(cifrnames(nsyn,i), ccode, pcode, 
     +                 btype, sline)
        if (btype.eq.1) then
           call ccif_get_char(cifrnames(nsyn,i),val,cdata,lenval,
     +                 icontext,istat)
        elseif (btype.eq.2) then
          call ccif_get_int(cifrnames(nsyn,i), val, ival,icontext,istat)
        elseif (btype.eq.3.or.btype.eq.4) then
          call ccif_get_real(cifrnames(nsyn,i), val, rval,
     +                 icontext,istat)
        endif
C  if a column is present but contains some ? then get loop_unknown
C  if a column is completely absent then get no_value
        if (istat.eq.loop_value .or. istat.eq.loop_unknown) then
          ncol = ncol + 1
          lookup(i) = ncol
          labout(ncol) = lsprgo(i)
          typout(ncol) = ctprgo(i)
          cifrnames(1,i) = cifrnames(nsyn,i)
          write(6,*) 'Found column ',ncol,' with label ',labout(ncol),
     +        ' and type ',typout(ncol)
        else
C  if haven't found main mmCIF name, try available synonyms
          if (nsyn.lt.cifsynonyms) then
            nsyn = nsyn + 1
            goto 600
          endif
        endif
        istat = keep_context
       enddo
C  add anomalous columns if requested
       IF (LANOM) THEN
         IF (LOOKUP(5) .NE. 0) THEN
           I_ANOM_COL = 15
           DO I = I_ANOM_COL,I_ANOM_COL+3
             ncol = ncol + 1
             labout(ncol) = lsprgo(i)
             typout(ncol) = ctprgo(i)
           ENDDO
         ELSEIF (LOOKUP(11) .NE. 0) THEN
           I_ANOM_COL = 21
           DO I = I_ANOM_COL,I_ANOM_COL+3
             ncol = ncol + 1
             labout(ncol) = lsprgo(i)
             typout(ncol) = ctprgo(i)
           ENDDO
         ENDIF
       ENDIF
       CALL CCIF_RELEASE_CONTEXT(icontext)
       nlabout = ncol
       if (debug) then
         do i = 1,nlabout
           write(6,*) 'Column ',i,' with label ',labout(i),
     +          ' and type ',typout(i)
         enddo
       endif

C  read in other categories here
       if (.not.lcell) then
         call get_cif_cell(blk_id,cell,ifail)
         if (ifail.ne.0) 
     +     call ccperr(1,'No cell information in keywords or file!')
       endif

       if (.not.lsymm) then
         call get_cif_symm(blk_id,nspgrx,spgrnx,ifail)
         if (ifail.ne.0) 
     +     call ccperr(1,'No symmetry information in keywords or file!')
         CALL  MSYMLB3(24,nspgrx,spgrnx,spgrnx_ns,pgnamx,NSYMPX,NSYMX,
     +                    RSYMX)
       endif

       if (PROJECTNAME.eq.'unknown') then
         call get_cif_entry_id(blk_id,PROJECTNAME)
       endif

       if (CRYSTALNAME.eq.'unknown') then
         CRYSTALNAME = PROJECTNAME
       endif

       if (DATASETNAME(1:7).eq.'unknown') then
         call get_cif_diffrn_id(blk_id,DATASETNAME)
       endif
      endif

      call lwcell(1, cell)

* Store the project name and dataset name in the mtz header:
      if (PROJECTNAME.eq.'unknown')
     +   call ccperr(2,' PROJECTNAME not assigned') 
      if (CRYSTALNAME.eq.'unknown')
     +   call ccperr(2,' CRYSTALNAME not assigned') 
      if (DATASETNAME(1:7).eq.'unknown')
     +   call ccperr(2,' DATASETNAME not assigned') 
      call lwidx(1,PROJECTNAME,CRYSTALNAME,DATASETNAME,CELL,0.0)

* Store the column labels in the mtz header:
      IF (kylabo) 
     +    CALL LKYOUT(1,labout,nlabout,LBOTKN,LBOLIN,LBOBEG,LBOEND)
      CALL LWASSN(1,labout, nlabout, typout,0)

* Associate columns with datasets
      do i=1,nlabout
        xname(i) = CRYSTALNAME
        dname(i) = DATASETNAME
      enddo
      call lwidasx(1, nlabout, xname, dname , 0)

* Store the symmetry in the mtz header:
      call lwsymm (1, nsymx, nsympx, rsymx, spgrnx(1:1), nspgrx,
     +     spgrnx, pgnamx)
      CALL ASUSET(spgrnx,nspgrx,pgnamx,nsymx,rsymx,nsympx,
     +     nlaue,.TRUE.)

* Store a history header:
      call lwhstl (1, ' ')

      ISTAT = 0
      call ccp4ccif_setup_context('REFLN',blk_id,icontext,istat,' ')

      ct = 0
c ifirst controls identification of Friedel pairs
      ifirst = 1
c ireallyfirst controls advance_context/keep_context
      ireallyfirst = 1
      call equal_magic(1,pdata,nlabout)
C loop over reflections
 30   continue

      CALL EQUAL_MAGIC(1,ADATA,nlabout)
      ncol = 0
      istat = advance_context
      if (ireallyfirst .eq. 1) istat = keep_context
      DO I = 1,cifrcols
        if (lookup(i).gt.0) then
         ncol = ncol + 1
         call ccif_item_type(cifrnames(1,i), ccode, pcode, 
     +                 btype, sline)
         if (btype.eq.1) then
          call ccif_get_char(cifrnames(1,i),val,cdata,lenval,
     +                 icontext,istat)
C   is this refln.status (what else?) 
          if (i.eq.4) then

            if (ireallyfirst .eq. 1) then
             if (cdata.eq.work_refl .or. cdata.eq.free_refl) then
              write(6,'(/,a)') 
     +          ' Non-standard ''_refln.status'' column detected.'
              if (freer_convention.eq.'XPLO') write(6,'(a)') 
     +          ' Assuming XPLOR convention for free R flags.'
              if (freer_convention.eq.'CCP4') write(6,'(a)') 
     +          ' Assuming CCP4 convention for free R flags.'
              write(6,'(a,/)') 
     +          ' See documentation on STATUS keyword.'
             endif
            endif

            if (cdata.eq.'o' .or. cdata.eq.work_refl) then
              adata(ncol) = 1.0
            elseif (cdata.eq.'<') then
            elseif (cdata.eq.'-') then
            elseif (cdata.eq.'x') then
            elseif (cdata.eq.'h') then
              adata(ncol) = 1.0
            elseif (cdata.eq.'l') then
              adata(ncol) = 1.0
            elseif (cdata.eq.'f' .or. cdata.eq.free_refl) then
              adata(ncol) = 0.0
            elseif (cdata.eq.'0') then
              adata(ncol) = 0.0
            elseif (cdata.eq.'1') then
              adata(ncol) = 1.0
            endif
          endif
         elseif (btype.eq.2) then
          call ccif_get_int(cifrnames(1,i),val,idata,icontext,istat)
          adata(ncol) = real(idata)
         elseif (btype.eq.3.or.btype.eq.4) then
          call ccif_get_real(cifrnames(1,i),val,adata(ncol),
     +                    icontext,istat)
         endif
         IF (ISTAT.EQ.8) GOTO 50
         istat = keep_context
        endif
      enddo
      ireallyfirst = 0

      if (lanom) then
        ihkl(1) = nint (adata(1))
        ihkl(2) = nint (adata(2))
        ihkl(3) = nint (adata(3))
        isign = INASU(IHKL, NLAUE)
        if (isign .eq. 1) then
C we have reflection in CCP4 asu. 
C transfer previous reflection for output
          if (ifirst .ne. 1) then
            do i = 1,nlabout
              fdata(i) = pdata(i)
            enddo
          endif
          call equal_magic(1,pdata,nlabout)
C save current reflection for possible pair with next reflection.
          do i = 1,ncol
            pdata(i) = adata(i)
          enddo
          IF (LOOKUP(5) .NE. 0) THEN
            pdata(ncol+1) = adata(lookup(5))
            pdata(ncol+2) = adata(lookup(6))
          ELSEIF (LOOKUP(11) .NE. 0) THEN
            pdata(ncol+1) = adata(lookup(11))
            pdata(ncol+2) = adata(lookup(12))
          endif
          if (ifirst .eq. 1) then
            ifirst = 0
            goto 30
          endif
          ifirst = 0
        elseif (isign .eq. -1) then
C we have -h-k-l of reflection in CCP4 asu. 
C if it doesn't pair with previous, give up!
          if (ifirst .eq. 1) goto 30
          if ( -ihkl(1) .ne. nint (pdata(1)) .or.
     +         -ihkl(2) .ne. nint (pdata(2)) .or.
     +         -ihkl(3) .ne. nint (pdata(3))) goto 30
C pair with previous reflection.
          IF (LOOKUP(5) .NE. 0) THEN
            pdata(ncol+3) = adata(lookup(5))
            pdata(ncol+4) = adata(lookup(6))
            pdata(lookup(5)) = 0.5 * (pdata(ncol+1) + pdata(ncol+3))
            pdata(lookup(6)) = 
     +         0.5 * sqrt(pdata(ncol+2)**2 + pdata(ncol+4)**2)
          ELSEIF (LOOKUP(11) .NE. 0) THEN
            pdata(ncol+3) = adata(lookup(11))
            pdata(ncol+4) = adata(lookup(12))
            pdata(lookup(11)) = 0.5 * (pdata(ncol+1) + pdata(ncol+3))
            pdata(lookup(12)) = 
     +         0.5 * sqrt(pdata(ncol+2)**2 + pdata(ncol+4)**2)
          endif
          ifirst = 0
          goto 30
        elseif (isign .eq. 0) then
C reflection not in CCP4 asu. Output as is.
          ifirst = 1
        endif
      endif

      ct = ct+1
      if (lanom .and. ifirst.eq.0) then
        call lwrefl (1, fdata)
      else
        call lwrefl (1, adata)
      endif

C read next reflection
      goto 30

 50   continue
C unfinished business
      if (lanom .and. ifirst.eq.0) then
        ct = ct+1
        call lwrefl (1, pdata)
      endif

C Close mtz file, print full header:
      call ccp4h_summary_beg()
      call lwclos (1, 3)
      write (6,'(i7, '' input reflections processed'')') ct
      call ccp4h_summary_end()
      call ccperr(0,'Normal termination')

      end

C Attempt to get cell and symm parameters from a CRYST1 line
C if they are not yet set.
C Yes, CRYST1 lines really do appear in mmCIF reflection files.

      subroutine get_pseudo_pdb_cell_symm(cell, lcell, spgrnx, lsymm)

      IMPLICIT NONE

      real cell(6)
      character spgrnx*20
      logical lcell, lsymm
 
      integer ifail,i,j
      real cell_file(6)
      character inputline*200,spgrnx_file*20

      IFAIL = 0
      CALL CCPDPN(21, 'HKLIN ', 'READONLY', 'F', 0, IFAIL)

c  search first 1000 lines for CRYST1 line
      do i=1,1000
        READ (21, '(A)', END=100, ERR=100) inputline
        if (index(inputline,'CRYST1').gt.0) then
          read(inputline,'(7X,3F9.3,3F7.2,X,A11)') 
     +           cell_file,spgrnx_file
          if (.not.lcell) then
            do j=1,6
              cell(j) = cell_file(j)
            enddo
            lcell=.true.
          endif
          if (.not.lsymm) then
            spgrnx = spgrnx_file
            lsymm=.true.
          endif
          goto 100
        endif
      enddo

 100  continue

      close(21)

      end

      subroutine get_cif_cell(blk_id,cell,ifail)

      IMPLICIT NONE

c_______Returned values for setting up contexts (see value_manip.h)
      integer cat_not_present, loop_context, item_context
      parameter (cat_not_present = 0, loop_context = 1,
     &  item_context = 2)
      
c_______Input status values for data-retrieval routines (see value_manip.h)
      integer start_new_context, keep_context, advance_context,
     & append_row, advance_hold
      parameter (start_new_context=0, keep_context=1,
     &  advance_context=2, append_row=3, advance_hold=4)

c_______Returned status values from data-retrieval routines  (see value_manip.h)
      integer no_value, loop_value, single_value, end_of_context, 
     & single_dict, loop_dict, single_null, loop_null, loop_unknown, 
     & parenthesis_esd
      parameter (no_value=0, loop_unknown=1, single_value=2, 
     &  loop_value=3, single_dict=4, loop_dict=5, single_null=6,
     &  loop_null=7, end_of_context=8, parenthesis_esd=9)
      
      integer i, blk_id,length_dep,angle_dep,ncntxt,istat,
     & IFAIL,istatus
      character*(80) val, cell_itmnam(7), cell_catnam, itmnam
      real cell(6),rval

      ifail = 0
      length_dep = 0
      angle_dep = 0

      cell_itmnam(1) = '_cell.length_a'
      cell_itmnam(2) = '_cell.length_b'
      cell_itmnam(3) = '_cell.length_c'
      cell_itmnam(4) = '_cell.angle_alpha'
      cell_itmnam(5) = '_cell.angle_beta'
      cell_itmnam(6) = '_cell.angle_gamma'
      cell_itmnam(7) = '_cell.volume'
 
C--- Set-up context for CELL category
      cell_catnam = 'CELL'

      istatus = item_context
      call ccp4ccif_setup_context(cell_catnam,blk_id,ncntxt,istatus,' ')
      IF (ISTATUS.EQ.cat_not_present) THEN
        WRITE(6,*) ' Warning: no cell information in file!'
        IFAIL = 1
        RETURN
      ENDIF

C--- Cell lengths

      DO I=1,3

        itmnam = cell_itmnam(I)

        istat = keep_context
        call ccif_get_real(itmnam, val, rval, ncntxt, istat)
        if (istat.eq.single_value) then
          length_dep = length_dep + 1
          cell(I) = rval
        endif

      ENDDO

      IF (length_dep.EQ.0) THEN
        WRITE(6,*) ' Warning: no cell lengths given in file!'
        cell(1) = 0.0
        cell(2) = 0.0
        cell(3) = 0.0
        IFAIL = 1
        RETURN
      ELSEIF (length_dep.LT.3) THEN
        WRITE(6,*) ' Warning: not all cell lengths given in file!'
        cell(1) = 0.0
        cell(2) = 0.0
        cell(3) = 0.0
        IFAIL = 1
        RETURN
      ENDIF  

C--- Cell angles

      DO I=4,6

        itmnam = cell_itmnam(I)

        istat = keep_context
        call ccif_get_real(itmnam, val, rval, ncntxt, istat)
        if (istat.eq.single_value) then
          angle_dep = angle_dep + 1
          cell(I) = rval
        endif

      ENDDO

      IF (angle_dep.EQ.0) THEN
        WRITE(6,*) ' Warning: no cell angles given in file!'
        WRITE(6,*) ' Warning: cell angles default to 90'
        cell(4) = 90.0
        cell(5) = 90.0
        cell(6) = 90.0
        RETURN
      ELSEIF (angle_dep.LT.3) THEN
        WRITE(6,*) ' Warning: not all cell angles given in file!'
        WRITE(6,*) ' Warning: cell angles default to 90'
        cell(4) = 90.0
        cell(5) = 90.0
        cell(6) = 90.0
        RETURN
      ENDIF  

      CALL CCIF_RELEASE_CONTEXT(NCNTXT)

      return
      end

      subroutine get_cif_symm(blk_id,nspgrx,spgrnx,ifail)

      IMPLICIT NONE

c_______Returned values for setting up contexts (see value_manip.h)
      integer cat_not_present, loop_context, item_context
      parameter (cat_not_present = 0, loop_context = 1,
     &  item_context = 2)
      
c_______Input status values for data-retrieval routines (see value_manip.h)
      integer start_new_context, keep_context, advance_context,
     & append_row, advance_hold
      parameter (start_new_context=0, keep_context=1,
     &  advance_context=2, append_row=3, advance_hold=4)

c_______Returned status values from data-retrieval routines  (see value_manip.h)
      integer no_value, loop_value, single_value, end_of_context, 
     & single_dict, loop_dict, single_null, loop_null, loop_unknown, 
     & parenthesis_esd
      parameter (no_value=0, loop_unknown=1, single_value=2, 
     &  loop_value=3, single_dict=4, loop_dict=5, single_null=6,
     &  loop_null=7, end_of_context=8, parenthesis_esd=9)
      
      integer blk_id,ncntxt,istat,lenval,
     + IFAIL,istatus,ival,nspgrx
      character*(80) val, cval, symm_itmnam(2), symm_catnam, itmnam
      character*(*) spgrnx
      
      IFAIL = 0

      symm_itmnam(1) = '_symmetry.Int_Tables_number'
      symm_itmnam(2) = '_symmetry.space_group_name_H-M'
 
C--- Set-up context for SYMM category
      symm_catnam = 'SYMMETRY'

      nspgrx = 0
      spgrnx = ' '

      istatus = 0
      call ccp4ccif_setup_context(symm_catnam,blk_id,ncntxt,istatus,' ')
      IF (ISTATUS.EQ.cat_not_present) THEN
        WRITE(6,*) ' Warning: no symmetry information in file!'
        IFAIL = 1
        RETURN
      ENDIF

C--- symmetry number

      itmnam = symm_itmnam(1)

      istat = keep_context
      call ccif_get_int(itmnam, val, ival, ncntxt, istat)
      if (istat.eq.single_value) then
        nspgrx = ival
      endif

C--- symmetry name

      itmnam = symm_itmnam(2)

      istat = keep_context
      call ccif_get_char(itmnam, val, cval, lenval,
     &      ncntxt, istat)
      if (istat.eq.single_value) then
        spgrnx = cval
      endif

      CALL CCIF_RELEASE_CONTEXT(NCNTXT)

      return
      end

      subroutine get_cif_entry_id(blk_id,entryid)

      IMPLICIT NONE

c_______Returned values for setting up contexts (see value_manip.h)
      integer cat_not_present, loop_context, item_context
      parameter (cat_not_present = 0, loop_context = 1,
     &  item_context = 2)
      
c_______Input status values for data-retrieval routines (see value_manip.h)
      integer start_new_context, keep_context, advance_context,
     & append_row, advance_hold
      parameter (start_new_context=0, keep_context=1,
     &  advance_context=2, append_row=3, advance_hold=4)

c_______Returned status values from data-retrieval routines  (see value_manip.h)
      integer no_value, loop_value, single_value, end_of_context, 
     & single_dict, loop_dict, single_null, loop_null, loop_unknown, 
     & parenthesis_esd
      parameter (no_value=0, loop_unknown=1, single_value=2, 
     &  loop_value=3, single_dict=4, loop_dict=5, single_null=6,
     &  loop_null=7, end_of_context=8, parenthesis_esd=9)
      
      integer blk_id,ncntxt,istat,lenval,istatus,itmpos,nline
      character*(80) val, cval, entry_itmnam(1), entry_catnam, itmnam
      character*(*) entryid

      entry_itmnam(1) = '_entry.id'
 
C--- Set-up context for ENTRY category
      entry_catnam = 'ENTRY'

      istatus = 0
      call ccp4ccif_setup_context(entry_catnam,blk_id,
     +              ncntxt,istatus,' ')
      IF (ISTATUS.EQ.cat_not_present) THEN
        WRITE(6,*) ' Warning: no entry information in file!'
        RETURN
      ENDIF

C--- entry id

      itmnam = entry_itmnam(1)

      istat = keep_context
      itmpos = 1
      lenval = 1
      call ccif_get_text(itmnam,itmpos,nline,cval,lenval,
     &      ncntxt, istat)
      if (istat.eq.single_value) then
        entryid = cval
      endif

      CALL CCIF_RELEASE_CONTEXT(NCNTXT)

      return
      end

      subroutine get_cif_diffrn_id(blk_id,diffrnid)

      IMPLICIT NONE

c_______Returned values for setting up contexts (see value_manip.h)
      integer cat_not_present, loop_context, item_context
      parameter (cat_not_present = 0, loop_context = 1,
     &  item_context = 2)
      
c_______Input status values for data-retrieval routines (see value_manip.h)
      integer start_new_context, keep_context, advance_context,
     & append_row, advance_hold
      parameter (start_new_context=0, keep_context=1,
     &  advance_context=2, append_row=3, advance_hold=4)

c_______Returned status values from data-retrieval routines  (see value_manip.h)
      integer no_value, loop_value, single_value, end_of_context, 
     & single_dict, loop_dict, single_null, loop_null, loop_unknown, 
     & parenthesis_esd
      parameter (no_value=0, loop_unknown=1, single_value=2, 
     &  loop_value=3, single_dict=4, loop_dict=5, single_null=6,
     &  loop_null=7, end_of_context=8, parenthesis_esd=9)
      
      integer blk_id,ncntxt,istat,lenval,istatus,itmpos,nline
      character*(80) val,cval,diffrn_itmnam(1),diffrn_catnam,itmnam
      character*(*) diffrnid

      diffrn_itmnam(1) = '_diffrn.id'
 
C--- Set-up context for DIFFRN category
      diffrn_catnam = 'DIFFRN'

      istatus = 0
      call ccp4ccif_setup_context(diffrn_catnam,blk_id,
     +              ncntxt,istatus,' ')
      IF (ISTATUS.EQ.cat_not_present) THEN
        WRITE(6,*) ' Warning: no diffrn information in file!'
        RETURN
      ENDIF

C--- diffrn id

      itmnam = diffrn_itmnam(1)

      istat = keep_context
      itmpos = 1
      lenval = 1
      call ccif_get_text(itmnam,itmpos,nline,cval,lenval,
     &      ncntxt, istat)
      if (istat.eq.single_value) then
        diffrnid = cval
      endif

      CALL CCIF_RELEASE_CONTEXT(NCNTXT)

      return
      end
