C
C     COMBAT COnvert to Multi BATch mtz file
C     Copyright (C) 2000-2004 Alun Ashton
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C

      program COMBAT
c     COnvert to Multi BATch mtz file

c Main program  * Function
c -----------------------------------------------------------------------
c Initialise    *   parse and html etc                * Initialise vars 
c     |         *                                     *
cbatchheaderinit*   initialieses orient.fh            *
c     |         *                                     *------------------
c   rcards      *   read in input                     * User input parse
c     |         *                                     * and checking
c  inputchecks  *   check inputs                      *
c     |         *                                     *------------------
c  StartLoop    *                                     *
c     \______>__________ _________<____________       *
c       |               V                      \      *
c       ^               |                       |     *==================
c       |         splitforinput                 |     *
c       |               /\                      |     *
c       | ............./..\..................   |     *  Each seperate
c       | ..   firstloop   subsequentloops ..   |     *   Input takes
c       | .       |              |          .   |     *   a diff line
c       | . openinputfile    readreflection .   |     *  
c       ^ .       |              |          .   ^     * 
c       | .   readacell          |          .   |     *
c       | .       |              |          .   |     *
c       | ..   readsymm          v         ..   |     *
c       | ........|..............|...........   |     *==================
c       |    checkallhdr         |              |     *
c       |         |              |              |     *
c       |     openmtzout         |              |     *   
c       |         +              |              |     *
c       |    writeouthdr         |              |     *   All Input lines
c       |         |              |   _____>____/      *   converged again
c        \___<___/       ___<___/   / |               *
c                        |         /  |               *
c                        checkrange->-writetomtz      *
c                        |                            *
c                     Endloop 
c                        |
c                  wbatchinfotomtz
c                        |
c                  writefilestats
c                        |
c                     closeall
c
c For adding another input it should only be needed to create a subroutine
c as outlined in the dotted box

      include  'parser.fh'
      include  'refandmtz.fh'
      external initialise, rcards, inputchecks
      external ccperr

      call initialise()
      call rcards()
      call inputchecks()
c main loop
 10   continue
      if (.not.endoffile .and. refok) then
c     input is an mtz file
        if     (theinput(1:3).eq.'MTZ') then
          call inputismtz()
c     input is an weis file
        elseif (theinput(1:4).eq.'WEIS') then
          call inputisweis()
c     input is TEX
        elseif (theinput(1:3).eq.'TEX') then
          call inputistex()
c     input is JIMS
        elseif (theinput(1:4).eq.'JIMS') then
          call inputisjims()
c     input is DATR
        elseif (theinput(1:4).eq.'DATR') then
          call inputisdatr()
c     input is MUF/I
        elseif (theinput(1:2).eq.'MU') then
          call inputismu()
c     input is xdsu
        elseif (theinput(1:4).eq.'XDSU') then
          call inputisxdsu()
c     input is xdsa
        elseif (theinput(1:4).eq.'XDSA') then
          call inputisxdsascii()
c     input is raxi
        elseif (theinput(1:4).eq.'RAXI') then
          call inputisraxi()
c     input is scalepack options
        elseif (theinput(1:4).eq.'SCAL') then
          call inputissc()
c     input is saint options
        elseif (theinput(1:4).eq.'SAIN') then
          call inputissaint()
c     input is denzo option
        elseif (theinput(1:4).eq.'DENZ') then
          call inputisdenz()
c     input is user option
        elseif (theinput(1:4).eq.'USER') then
          call inputisuser()
        else          
          call ccperr(1,'Bad input option')
        endif
c     the zero loop - header etc
        if (loop.le.0) then
          call checkallhdr()
          call openmtzout()
c     set up html for reflection info
          call ccp4h_header('Reflection Monitoring', 'refmon',2)
          call ccp4h_pre_beg() 
        else
          if (.not.endoffile) then
            if (refok) call checkrange()
c     if reflection ok then write it out
            if (.not. refrej .and. refok) then
              call writetomtz()
            endif
          endif
          refrej = .false.
        endif
        if (refok) then
          if (.not.endoffile) then
            loop = loop + 1
          else
            loop = loop - 1
          endif
          goto 10
        else 
          goto 20
        endif
      endif
c     close reflection monitoring
      call ccp4h_pre_end() 
      call wbatchinfotomtz ()
      call writefilestats()
 20   call closeall()

C.......................................................................
      if (refok) then
        call ccperr(0,'thats all folks! - normal termination ')
      else 
        call ccperr (1, 'See above errors.')
      endif
      end


c***********************************************************************
      subroutine initialise()

c     purpose : initialise ccp4 and html, read in the data, set up all the 
c     constants which will be needed later.
      character date*8,date6*6
      include 'parser.fh'
      include 'refandmtz.fh'
      integer i, j
      external ccpfyp, ccprcs, mtzini
      external ccp4h_init, ccp4h_header, ccp4h_pre_beg, ccp4h_pre_end, 
     +     ccp4h_toc_beg, ccp4h_toc_ent, ccp4h_toc_end

c.......................................................................
      call ccpfyp()
      call mtzini
      call ccp4h_init()
      call ccp4h_header('combat 1.0.1','combat',1)
      call ccp4h_pre_beg()
      call ccprcs(6,'combat','$Date: 2007/01/17 15:45:04 $')
      call ccp4h_pre_end()

c..
      call ccp4h_toc_beg()
      call ccp4h_toc_ent('Command input','#command')
      call ccp4h_toc_ent('Comments/Checks','#comments')
      call ccp4h_toc_ent('File input','#filein')
      call ccp4h_toc_ent('Header Checking','#headchk')
      call ccp4h_toc_ent('Output File','#fileout')
      call ccp4h_toc_ent('Reflection Monitoring', '#refmon')
      call ccp4h_toc_ent('File stats', '#instats')
      call ccp4h_toc_ent('Output File Header', '#fileouthdr')

      call ccp4h_toc_end()
c..
c..   Variables
      DO 5 I = 1, 3
        DO 6 J = 1, nrej
          hklrej(I, J) = 0
 6      CONTINUE
 5    CONTINUE

      do 15 I = 1, 3
        do 10 J = 1, 3
          amat(i,j) = 0.0
 10     continue
        amat (i,i) = 1.0
 15   continue
c 
c     program controls
      endoffile     = .false.
c
C Set default PROJECTNAME, CRYSTALNAME and DATASETNAME
      call ccpdat(date)
      write(date6,'(A2,A2,A2)') date(1:2),date(4:5),date(7:8)
 16   i = index(date6,' ')
      IF (i.gt.0) then
        write(date6(i:i),'(A1)') '0'
        goto 16
      endif
      projectname   = 'unknown'
      crystalname   = 'unknown'
      datasetname   = 'unknown'//date6
      datwaveout    = 0.0
      bsetid        = 0
      namspg        = ' '
      theinput      = ' '
      frmat         = ' '
c     program counters
      loop = 0
      almbd = 0.0
      SRCE(1) = 0.0
      SRCE(2) = 0.0
      SRCE(3) = 0.0
      NGNX = 0
      EE1(1) = 0.0
      EE1(2) = 0.0
      EE1(3) = 0.0
c     initialise detector
      dxstl = 0.0
      detlim(1,1)   = -100.
      detlim(2,1)   = +100.
      detlim(1,2)   = -100.
      detlim(2,2)   = +100.
      xdet = 0
      ydet = 0
      xdetmn = +1.0E10
      xdetmx = -xdetmn
      ydetmn = +1.0E10
      ydetmx = -ydetmn
c     initialise reso limits
      smin          = 0.00
      smax          = 10000.0
c     initialise cell
      cell (1)      = 0.00
      cell (2)      = 0.00
      cell (3)      = 0.00
      cell (4)      = 90.0
      cell (5)      = 90.0
      cell (6)      = 90.0
c     initialise phir
      nphistp       = 1 
c     initialise phimin/max
      phimin = +1.0e10
      phimax = -phimin
c     initialise nmonitor
      nmonitor      = 1000
c     initialise rein
      reinline      = ' '
c     initialise scale 
      scff          = 1.0
c     initialise first batch number
      nbatch        = 0
      minbat        = 9999
      maxbat        = 0
      numbat        = 0
c Initialise batch number hash table
      call ccp4_hash_zeroit()
c     initialise addbatch
      addbat        = 0
C     initialise labels
      alllabels     = ' '
c     initialise labin
      linesav       = ' '
      do 20 I = 1, mcols
        lsprgi (I) = ' '
        ctprgi (I) = ' '
 20   continue
c lsprgi now initialised proeperly in subroutine inputismtz
c     got sort order
      gotsort = .false.
c     nuber of rejected reflecions
      irej = 0
c     reflection ok?
c     if refok goes to false its fatal to the prog
      refok = .true.
c     if refrej goes to true reflecdtion is just rejected.
      refrej = .false.
      mpart = 0
      fpart = 0.0
c     neg sigs
      negsig = 0
c     need to write pseudo multirecord info
      wpseudomrec = .true.
c     initialise number of writen reflection
      nrefout = 0
c     initialise nuber of rejected reflections
      nrejref = 0

      fplus = 0.0
      fneg  = 0.0

c     used in user option to define Fs
      fin = .false.

      call batchheaderinit()

      return
      end

c***********************************************************************
c     Zeros everything in orient.fh and sets some non-zero defaults.
c     (extracted from hdrrd/rotaprep)

      subroutine batchheaderinit()

      include 'orient.fh'

      REAL E1AXIS(3), S0VEC(3)
      CHARACTER AXSLAB*8
      INTEGER I, J
C
C     .. Data statements ..
C     Rotation axis E1AXIS, X-ray beam S0VEC
      DATA E1AXIS/0.0, 0.0, 1.0/, S0VEC/-1.0, 0.0, 0.0/
C     Axis name
      DATA AXSLAB/'PHI'/

C     Clear arrays
      DO 10 J = 1, MBLENG
        RBATCH(J) = 0.0
   10 CONTINUE
C
      DO 20 J = 1, 94
        CBATCH(J) = ' '
   20 CONTINUE

C     Now set non-zero defaults

C     Set word count for /ORIENT/.
C     positions orientation blocks in output
C     MTZ file, and setup all the orientation block data
C
      NWORDS = MBLENG
      NINTGR = MBLINT
      NREALS = MBLREA
C
C---- Set LDTYPE
C
C    = 0  '*** unknown data type ***'
C    = 1  'oscillation data'
C    = 2   'area detector data'
C    = 3  'Laue data'
C
      LDTYPE = 1
C
C---- Set default batch scale and B factor (set later by ROTA/AGROVATA)
C
      BSCALE = 1.0
C
C---- All beam parameters set
      LBMFLG = 1
C
C---- Set crystal goniostat information (assume single axis)
C
      NGONAX = 1
      DO 30 I = 1, 3
        E1(I) = E1AXIS(I)
C Source vector
        SOURCE(I) = S0VEC(I)
        S0(I) = SOURCE(I)
   30 CONTINUE
      GONLAB(1) = AXSLAB
      JSCAXS = 1

C Single detector
      NDET = 1
cv
c     C. Vonrhein 16.01.2007: set UMAT to identity matrix otherwise REINDEX will complain
c
      UMAT(1,1) = 1.0
      UMAT(1,2) = 0.0
      UMAT(1,3) = 0.0
      UMAT(2,1) = 0.0
      UMAT(2,2) = 1.0
      UMAT(2,3) = 0.0
      UMAT(3,1) = 0.0
      UMAT(3,2) = 0.0
      UMAT(3,3) = 1.0
cv	  
      return
      end

c********************************************************************
c     Changes variables in orient.fh for each output batch, according to values
c     held in /CBATDATA/ and /RBATDATA/

      subroutine editbatchheader(TITLE,PHIST,PHIEN,PHIRNG,
     +      DETLIM, BSETID)
c
      REAL PHIST,PHIEN,PHIRNG
      include 'orient.fh'

c     detlim(2,2)   detector limits
c     bsetid        associated dataset ID (usually 0 or 1)
      CHARACTER*70 TITLE
      INTEGER BSETID
      REAL DETLIM(2,2)

      BTITLE = TITLE
      PHISTT = PHIST
      PHIEND = PHIEN
      PHIRANGE = PHIRNG
C---- Associated dataset ID, usually 0 (none) or 1 (ID of only dataset)
      LBSETID = BSETID
C Set detector limits (detector axes are Xdet, Ydet) mm??
      DETLM1(1,1) = DETLIM(1,1)
      DETLM1(2,1) = DETLIM(2,1) 
      DETLM1(1,2) = DETLIM(1,2)
      DETLM1(2,2) = DETLIM(2,2) 

      return
      end

c**********************************************************************
      subroutine rcards()
c     read in inputs

      logical   addtorej, cont
      character htmlfile*80, label*200
      integer   intx3(3), iref, j
      real      resmin, resmax
      include  'parser.fh'
c..
      integer   lenstr
      external  ccperr, lenstr
      external  ccp4h_header, ccp4h_pre_beg, ccp4h_pre_end
      external  memoparse, parsekeyarg, parsereso, parsecell, parsesymm,
     +     parsenints, parsesubkey, parsekey, parsediagnose 

c..
c     make the link to the doc page
      htmlfile      = 'combat.html'
      label         = htmlfile(1:lenstr(htmlfile))//'#keywords'
c
      addtorej      = .false.
      iref          = 3
      j             = 4
c     j=4 and iref just needed to read in n reals damn g77 in parsenthings
c
      call ccp4h_header('Command Input','command',2)
      call ccp4h_pre_beg()

 10   call memoparse(.false.)
c     Make links to documentation:
      call ccp4h_link_key('TITL', label)
      call ccp4h_link_key('LABI', label)
      call ccp4h_link_key('RESO', label)
      call ccp4h_link_key('CELL', label)
      call ccp4h_link_key('PHIR', label)
      call ccp4h_link_key('MONI', label)
      call ccp4h_link_key('REIN', label)
      call ccp4h_link_key('SYMM', label)
      call ccp4h_link_key('SCAL', label)
      call ccp4h_link_key('BATC', label)
      call ccp4h_link_key('ADDB', label)
      call ccp4h_link_key('FORM', label)
      call ccp4h_link_key('INPU', label)
      call ccp4h_link_key('LABE', label)
      call ccp4h_link_key('REJE', label)
      call ccp4h_link_key('DETE', label)
      call ccp4h_link_key('PNAM', label)
      call ccp4h_link_key('NAME', label)
      call ccp4h_link_key('DNAM', label)
      call ccp4h_link_key('WAVE', label)
c
      call parsekeyarg('TITL', title)
      call parsekeyarg('LABI', linesav)
      call parsereso  (resmin, resmax, smin, smax)
      call parsecell  (cell)
      call parseint   ('PHIR', nphistp)
      call parseint   ('MONI', nmonitor)
      call parsekeyarg('REIN', reinline)
      call parsesymm  (namspg, nspgrp, pgname, nsym, nsymp, rsym)
      call parsereal  ('SCAL', scff)
      call parseint   ('BATC', nbatch)
      call parseint   ('ADDB', addbat)
      call parsekeyarg('FORM', frmat)
      call parsekeyarg('INPU', theinput)
      call parsekeyarg('LABE', alllabels)
      call parsesubchar ('NAME','PROJ',1,.true.,projectname)
      call parsesubchar ('NAME','CRYS',1,.true.,crystalname)
      call parsesubchar ('NAME','DATA',1,.true.,datasetname)
      call parsekeyarg('PNAM', projectname)
      call parsekeyarg('XNAM', crystalname)
      call parsekeyarg('DNAM', datasetname)
      call parsenreals('DETE', j, detlim)
      call parsereal  ('WAVE', datwaveout)

c
      call parsesubkey('REJE','    ', addtorej)
      if (addtorej) then
        addtorej=.false.
        irej = irej + 1
        call parsenints('REJE', iref, intx3)
        if (irej .le. nrej) then
          do 15 J = 1,3
            hklrej (J,irej) = intx3(J)
15        continue
          irej = irej + 1
        else
          call ccperr(2,'Number of rejected reflections exceeded 200')
        endif
        write (6, *) 'INFO: rejecting reflection : ', intx3
      endif
 
      call parsediagnose(cont)
      if (cont) goto 10
      call ccp4h_pre_end()

      return
      end


c***********************************************************************
      subroutine inputchecks()

      logical      ifail
      real         tmpmat(4, 4, 1)
      integer i, j

      character tmpfrmat*80
      integer   lenstr, ii, jj, lenfmt
      external  lenstr

      include  'parser.fh'
      include  'refandmtz.fh'
c
      ifail=.false.

      call ccp4h_header('Comments/Checks','comments',2)
      call ccp4h_pre_beg()


c......
c     checks

      call ccpupc (theinput)

c     check for I descriptors and replace with F
      lenfmt = lenstr(frmat)
      tmpfrmat = ' '
      ii = 1
      jj = 1
 234  continue
      if (frmat(ii:ii).ne.'I' .and. frmat(ii:ii).ne.'i') then
        tmpfrmat(jj:jj) = frmat(ii:ii)
        jj = jj + 1
        ii = ii + 1
      else
        tmpfrmat(jj:jj) = 'F'
        ii = ii + 1
        jj = jj + 1
        tmpfrmat(jj:jj+2) = frmat(ii:ii)//'.0'
        ii = ii + 1
        jj = jj + 3
      endif
      if(ii.le.lenfmt) go to 234
      if (jj.gt.ii) then
        lenfmt = lenstr(tmpfrmat)
        frmat = tmpfrmat(1:lenfmt)
        write (*,FMT='(A)') 
     +       ' *** Format contains Ix.  -     Replaced with Fx.0'
        call ccperr (2, ' Format I replaced with F')
      endif

c     check reinline
      if (reinline.ne. ' ') then
        j = 1
        call symfr2(reinline, 1, j, tmpmat)
        if (j.ne.1) then
        call ccperr(2,
     $         '<blink>ERR</blink>: Illegal REINDEX command'//reinline)
        ifail=.TRUE.
        endif
        if (.not.ifail) then
c       copy to 3x3 matrix - transpose to post multiply indices:
          do 60 i = 1, 3
            do 50 j = 1, 3
              amat(i, j) = tmpmat(j, i, 1)
 50         continue
 60       continue
c     Calculate determinant
          det = amat(1, 1)* (amat(2, 2)*amat(3, 3)-
     $         amat(2, 3)*amat(3, 2)) - amat(1, 2)*
     $         (amat(2, 1)*amat(3, 3)-amat(2, 3)*amat(3, 1)) +
     $         amat(1, 3)* (amat(2, 1)*amat(3, 2)-amat(2, 2)*amat(3, 1))
          write (6, 9000) ((amat(i, j), j=1, 3), i=1, 3)
 9000 FORMAT (///,'<i>INFO:</i>  Conversion matrix: ', 3 (/,5X, 3F10.4))
          if (det.LT.0.0) then
            CALL CCPERR(2, 
     $           '<blink>ERR</blink>: YOU ARE CHANGING YOUR HAND!  ' //
     $           'Reverse all signs in AMAT.' )
            ifail=.true.
          endif
        endif
      endif

c    parse and check labels if USER
       if (theinput.eq.'USER') then
         call checkparselabel (ifail, alllabels, labels, nlabels, fin)
        if (frmat.eq.' ') then
           call ccperr(2,
     $         '<blink>ERR</blink>: You must set format with USER!')
           ifail = .true.
         endif
C If batch is included in the labels then dont expect as keyword
         if (labels(5).NE.0) then
           nbatch = 10000
         endif       
       endif


c...............
c     information

c     reso info
      write (6, *) '<i>INFO</i>: Resolution limits SMIN, SMAX: ', 
     $     smin, smax

c     dname/xname/pname
      if (projectname.ne.'unknown' .or. crystalname.ne.'unknown' .or.
     $    datasetname(1:7).ne.'unknown') then
        write (6,'(A,3x,A)') '<i>INFO</i>: projectname = ', projectname
        write (6,'(A,3x,A)') '<i>INFO</i>: crystalname = ', crystalname
        write (6,'(A,3x,A)') '<i>INFO</i>: datasetname = ', datasetname
        bsetid = 1
      endif

c     phir info
      write (6, *) '<i>INFO</i>: Each "batch" divided into ', nphistp, 
     $     ' ranges for scaling'

c     nmonitor info
      write (6, *) '<i>INFO</i>: Every', nmonitor, 
     $     'th reflection listed.'

c     scale info
      write (6, *) '<i>INFO</i>: Output fsq scaled by ', scff

c     addbatch info
      write (6, *) '<i>INFO</i>: Input batch number advanced by : ',
     $     addbat

c     detector coordinate limits
      write (6, *) '<i>INFO</i>: Detector coordinate limits set to: ',
     $     detlim

      call ccp4h_pre_end()
      if (ifail) then 
        call ccperr (1,'COMBAT needs more information.')
      endif

      return
      end

c 
C     -----------------------------------------------------------------
C     CheckParseLabel (fail, alllabels, labels, fin)
C
      subroutine checkparselabel (fail, alllabels, labels, nlabels, fin)

      logical     fail, fin
      integer     maxlabel
      character   alllabels*80
C     This is also set in the main program
      parameter (maxlabel=200)
      integer   ii, jj, ibeg(maxlabel), iend(maxlabel), ityp(maxlabel), 
     $     idec(maxlabel),
     $     nlabels, labels(maxlabel)
      character alabel*80, cvalue(maxlabel)*4
      real    fvalue(maxlabel)
C
      external ccperr, ccpupc, parse
C     
      if (alllabels.eq. ' ') then
        call ccperr (2, 
     $       '<blink>ERR</blink>: LABEL must be set')
        fail = .true.
        return
      endif

      nlabels = -maxlabel
c     initilaise labels
      do 60 jj=1,maxlabel
        labels(jj) = 0
 60   continue
c
c     parse the alllablels line
      call parse(alllabels,ibeg,iend,ityp,fvalue,cvalue,idec,nlabels)
c     Check to see the maxlabel is not exceeded
      if (nlabels.gt.maxlabel) then
        call ccperr (2, 
     $   '<blink>ERR</blink>: Too many labe. Increase maxlabel/maxcols')
        fail = .TRUE.
      endif
C
      write (6,*) 
     $  '<i>INFO</i>: Number of LABE columns to be read in:', nlabels
      do 65 ii=1, nlabels
C
        alabel=alllabels(ibeg(ii):iend(ii))
        call ccpupc(alabel)
C
        if (alabel.EQ.'H') then
          labels(1) = ii 
        elseif (alabel.EQ.'K') then
          labels(2) = ii 
        elseif (alabel.EQ.'L') then
          labels(3) = ii 
        elseif (alabel.EQ.'M') then
          labels(4) = ii 
        elseif (alabel.EQ.'BATCH') then
          labels(5) = ii 
        elseif (alabel.EQ.'I') then
          labels(6) = ii 
        elseif (alabel.EQ.'SIGI') then
          labels(7) = ii 
        elseif (alabel.EQ.'F') then
          labels(6) = ii
          fin = .true.
        elseif (alabel.EQ.'SIGF') then
          labels(7) = ii
          fin = .true.
        elseif (alabel.EQ.'IPR') then
          labels(8) = ii 
        elseif (alabel.EQ.'SIGIPR') then
          labels(9) = ii 
        elseif (alabel.EQ.'FRACTION') then
          labels(10) = ii 
        else
          CALL ccperr (2,
     $         '<blink>ERR</blink>: Unrecordnisable LABEL: ' // alabel)
          fail=.TRUE.
        endif
C
65    continue
      do 66 ii=1,3
        if (labels(ii).eq.0) then
          call ccperr(2,
     $         '<blink>ERR</blink>: H K or L label not given.')
          fail = .TRUE.
        endif
 66   continue
C
      do 67 ii=6,7
        if (labels(ii).EQ.0) then
          call ccperr(2,
     $      '<blink>ERR</blink>:  F/SIGF or I/SIGI labels not given.')
          fail = .TRUE.
        endif
 67   continue

      if (labels(5).NE.0) write (6,*) 
     $ '<i>INFO</i>: Batch number to be taken from COL: ' , labels(5)
      return
      end

c*****************************************************************
      subroutine checkallhdr()

      logical ifail
      include 'parser.fh'

      ifail = .false.

      call ccp4h_header('Header Checking','headchk',2)
      call ccp4h_pre_beg()

c     final check on batch
      if (nbatch.eq.0) then
        call ccperr(2,
     $       '<blink>ERR</blink>: Batch not set. Set with BATCH')
        ifail = .true.
      endif

c     cell
      if (cell(1).eq.0.0 .and. cell(2).eq.0.0 .and. 
     $     cell(3).eq.0.0 .and. cell(4).eq.90.0 
     $     .and. cell(5).eq.90.0 .and. cell(6).eq.90.0) 
     $     then
        call ccperr(2, 
     $       '<blink>ERR</blink>: you must give a CELL')
        ifail = .true.
      endif

c     summetry
      if (namspg.eq.' ') then
        call ccperr(2, 
     $       '<blink>ERR</blink>: you must give a SYMMETRY')
        ifail = .true.
      endif

      if (ifail) then
        call ccperr(1, 'COMBAT needs more!')
      else
        call ccperr (3, 'All header info for mtzout set')
      endif
      
      call ccp4h_pre_end()

      return
      end

c***************************************************************

      subroutine openmtzout()

      include   'parser.fh'
      include   'refandmtz.fh'
      character datemt*8, hstout(20)*80,
     $     ltype
      integer   nlaue
      integer lenstr
      external lenstr

      call ccp4h_header('Output File','fileout',2)
      call ccp4h_pre_beg()

            
c     call to open mtzout
      call lwopen(mtzout, 'HKLOUT')
c     call to write out title
      call lwtitl(mtzout, title, 0)

      call lwclab(mtzout, lsprgo, nlprgo, ctprgo, 0)
c     bit of history
      call lwhstl(mtzout, 'from : '//theinput(1:lenstr(theinput)))
c     date into history
      call ccpdat(datemt)
      hstout(1)='from COMBAT run on '//datemt
      call lwhist(mtzout, hstout, 1)
c     write out cell
      call lwcell(mtzout, cell)
      call lstrsl(mtzout, cell(1),cell(2),cell(3),
     $     cell(4),cell(5),cell(6))
c     write out symm
      ltype        = namspg (1:1)
      call lwsymm(mtzout, nsym, nsymp, rsym, ltype, 
     $     nspgrp, namspg, pgname)
      call asuset(namspg, nspgrp, pgname, nsym, rsym, nsymp, nlaue, 
     $     .true.)
c     write sort order if available
      if (gotsort) then
        call lwsort(mtzout, isort)
      endif
c     write datasetinfo
      if (projectname.eq.'unknown')
     +     call ccperr(2,' PROJECTNAME not assigned')
      if (crystalname.eq.'unknown')
     +     call ccperr(2,'CRYSTALNAME not assigned')
      if (datasetname(1:7).eq.'unknown')
     +     call ccperr(2,'DATASETNAME not assigned')
      call lwidx(mtzout, projectname, crystalname, datasetname,
     +     cell,datwaveout)

c     assign all output columns to crystalname/datasetname
      do i = 1,nlprgo
        xname_out(i) = crystalname
        dname_out(i) = datasetname
      enddo
      call lwidasx(mtzout,nlprgo,xname_out,dname_out,0)

      call ccp4h_pre_end()

      return
      end

c**********************************************************************
      subroutine checkrange()
      
      implicit none

      integer ism, nchk, jrej, i , ii, ibat
      logical lnew
      include 'parser.fh'
      include 'refandmtz.fh'
c
      external ccp4_hash_lookup
      integer  ccp4_hash_lookup
c
      if (refrej) goto 30
c     batch stuff
      if (nbatch .gt. maxbat) maxbat = nbatch 
      if (nbatch .lt. minbat) minbat = nbatch
c Compile a list of all batch numbers in file
c  Number of batches = numbat, list in ibatlist
c  Have we had this batch before? look it up in the hash table
      ibat = ccp4_hash_lookup(nbatch)
      lnew = .true.
      if (ibat .gt. 0) then
c  If it is "found" in the hash table, because of the way this works
c it may either be a true hit, or an ambiguity in the hashing
c (the hash table only works properly if all possibilities are
c correctly entered before the table is consulted)
         if (ibat .le. numbat .and. ibatlist(ibat) .eq. nbatch) then
c   This batch has been seen before
            lnew = .false.
         else
            lnew = .true.
         endif
      endif
c  If it is new, put it into the list, and into hash table
      if (lnew) then
         numbat = numbat + 1
         ibatlist(numbat) = nbatch
         call ccp4_hash_setup(nbatch, numbat)
      endif
c
      call equal_magic (mtzout, adata, nlprgo)
c     reindex
      khkl(1) = nint(ihkl(1)*amat(1, 1)+ihkl(2)*amat(2, 1)+
     +          ihkl(3)*amat(3, 1))
      khkl(2) = nint(ihkl(1)*amat(1, 2)+ihkl(2)*amat(2, 2)+
     +          ihkl(3)*amat(3, 2))
      khkl(3) = nint(ihkl(1)*amat(1, 3)+ihkl(2)*amat(2, 3)+
     +          ihkl(3)*amat(3, 3))
      call asuput(khkl, jhkl, ism)
      adata(1) = jhkl(1)
      adata(2) = jhkl(2)
      adata(3) = jhkl(3)
C     Build M/ISYM
      adata(4) = ism
      if (mpart.GT.1) adata(4) = adata(4) + 256
      adata(5) = nbatch     
      if (ssq4.lt.smin .or. ssq4.gt.smax) refrej = .true.

      if (iabs(ihkl(1)).ge.999 .or. iabs(ihkl(2)).ge.999
     $       .or. iabs(ihkl(3)).ge.999) refrej = .true.
      if (irej .gt. 0) then
        do 10 jrej = 1, irej
          if (jhkl(1).ne.hklrej(1, jrej)) goto 10
          if (jhkl(2).ne.hklrej(2, jrej)) goto 10
          if (jhkl(3).ne.hklrej(3, jrej)) goto 10
          write(6,'(A,3I4,/,A,3I4,I7,2F12.2)')
     +       '<i>INFO</i>: Rejected - converted indices: ',JHKL,
     +       ' Input indices, "batch" I SIGI:',KHKL,ADATA(5),FSQ,SIGFSQ
         refrej = .true.
 10     continue
      endif

      if (sigfsq.lt.0.00001) then
        refrej = .true.
        goto 30
      endif

      if (sigfsq .ne. 0.0) then
        adata(6) = (scff*fsq)
        adata(8) = (scff*fsqp)
        adata(7) = (scff*sigfsq)
        adata(9) = adata(7)
c     this next bit could be globalised by sigfsqp check to 0?
        IF (theinput(1:4).EQ.'USER') ADATA(9) = (SCFF*SIGFSQP)
      endif

C     Make sure observed reflections have a "sd" of at least 1
      if (adata(7).lt.0.0) then
        write (6, ' (a,I8,/,1X,11F9.0)')
     +    ' Negative SIGMAS - please check data processing ', loop,
     +    (adata(II), II=1, 8)
        negsig = negsig + 1
        adata(7) = 1.0
      endif

      if (adata(7).eq.0) adata(7) = 1.0
      if (adata(9).le.0) adata(9) = 1.0

      if (fpart.eq.0.0) adata(10) = 3.0
      if (mpart.gt.1 .and. fpart.eq.0.0) adata(10) = 0.5
      if (fpart.ne.0.0) adata(10) = fpart
      mpart = 0

      if (xdet.ne.0 .and. ydet.ne.0) then
        xdetmx = max(xdetmx, xdet)
        ydetmx = max(ydetmx, ydet)
        xdetmn = min(xdetmn, xdet)
        ydetmn = min(ydetmn, ydet)
        phimax = max(phimax, fphi)
        phimin = min(phimin, fphi)
        adata(11) = xdet
        adata(12) = ydet
        adata(13) = fphi
      else 
C  set ROT equal to batch.
        adata(13) = adata(5)
      endif

c     write out reflection for monitoring
      nchk = (nrefout+1) - nmonitor*((nrefout+1)/nmonitor)
      if (nchk.eq.0 .or. loop.eq.1) then
        write (6,
     +       ' (a,I8,/,1X,3i4,5x,2f12.2)')
     +       '<i>INFO</i>: nref data in  - h k l fsq sigfsq', nrefout+1,
     +       (ihkl(II), II=1, 3), fsq, sigfsq
        write (6, 
     +       ' (a,I8,/,1X,3i4,2x,2F5.0,5x,3F12.2)') 
     +       '<i>INFO</i>: nref idata out', nrefout+1,
     +       jhkl, (adata(II), II=4, 8)
      endif

 30   continue
      if (refrej) nrejref = nrejref + 1

      return
      end

c**********************************************************************
      subroutine writetomtz()
      
      include 'parser.fh'
      include 'refandmtz.fh'

      if (abs(adata(1)).lt.998 .and.sigfsq.ne.0.0) then
        call lwrefl (mtzout, adata)
        nrefout = nrefout+1
      endif
      end


c**********************************************************************

      subroutine writefilestats()
      include 'parser.fh'
      include 'refandmtz.fh'

      call ccp4h_header('File stats', 'instats',2)
      call ccp4h_pre_beg()
      
      write (6, *) '<i>INFO</i>: Number of reflections read: ', loop
      write (6, *) '<i>INFO</i>: Number of reflections written', nrefout
      write (6, *) '<i>INFO</i>: Number of reflections rejected',
     $     nrejref
c      write (6, *) '<i>INFO</i>: Number of negative sigmas: ', negsig


      call ccp4h_pre_end()
      return
      end


c**********************************************************************

      subroutine wbatchinfotomtz ()

      include 'parser.fh'
      include 'refandmtz.fh'
      include 'orient.fh'
      integer i, ii, jj

C Below are batch header variables that are constant for all batches
C Set these if they haven't been set before

C batch cell dimensions
      if (BCELL(1).LT.0.1 .AND. cell(1).GT.0.1) then
        do i=1,6
          BCELL(I) = cell(i)
        enddo
      endif
C X-ray wavelength (from X-RAY_WAVELENGTH for XDS)
      if (ALAMBD.LT.0.1 .AND. ALMBD.GT.0.1)
     +   ALAMBD = ALMBD
C crystal to detector distance (mm) (from DETECTOR_DISTANCE for XDS)
      if (DX1.LT.0.1 .AND. DXSTL.GT.0.1)
     +   DX1 = DXSTL
C source vector (from INCIDENT_BEAM_DIRECTION (reversed!) for XDS)
      if (SRCE(1).GT.0.1.OR.SRCE(2).GT.0.1.OR.SRCE(3).GT.0.1) then
        SOURCE(1) = SRCE(1)
        SOURCE(2) = SRCE(2)
        SOURCE(3) = SRCE(3)
        S0(1) = SRCE(1)
        S0(2) = SRCE(2)
        S0(3) = SRCE(3)
      endif
C rotation axis (from ROTATION_AXIS for XDS)
      if (EE1(1).GT.0.1.OR.EE1(2).GT.0.1.OR.EE1(3).GT.0.1) then
        NGONAX = NGNX
        E1(1) = EE1(1)
        E1(2) = EE1(2)
        E1(3) = EE1(3)
      endif

c Loop all batches accumulated in ibatlist
      do 10 i = 1, numbat
         ii = ibatlist(i)
         if (wpseudomrec) then
            call lwbtit(mtzout, ii, title)
         else
C    write batch-specific info to batch header
C   battitle etc indexed on batch number - addbat
            jj = ii - addbat
            call editbatchheader(battitle(jj),batphistt(jj),
     +         batphiend(jj),batphirange(jj),detlim, bsetid)
C    write out batch header
            call lwbat(mtzout,ii, rbatch, cbatch)
         endif
         if (crystalname.ne.' '.and.datasetname.ne.' ')
     +      call lwbsetidx(mtzout,ii,crystalname,datasetname)
 10   continue

      return
      end

c********************************************************************

      subroutine closeall()
      include 'parser.fh'
      include 'refandmtz.fh'
      integer iprint
      iprint  = 2

      call ccp4h_header('Output File Header', 'fileouthdr',2)
      call ccp4h_pre_beg() 
      call lwclos(mtzout, iprint)
      call ccp4h_pre_end()
      if (theinput(1:3).eq.'MTZ') then
       call lrclos(mtzin)
      else
        close(unit=21, status='keep') 
      endif
      return
      end



c ***********************************************************************

      subroutine inputismtz()

c     where did idum go?
      integer fail, iprint, ntok, icntrc, i, ncf
      character linesav2*606
      include 'parser.fh'
      include 'refandmtz.fh'
      integer lookup(mcols), ibeg(mcols), iend(mcols), ityp(mcols),
     $   idec(mcols)
      real bdata(mcols)
      character cvalue(mcols)*4, key*4, ltype
      real      fvalue(mcols)
      logical   lend, logmiss(mcols)
      data lookup/-1, -1, -1, -1, -1, 195*0/
      save bdata, icntrc

      fail          = 0
      iprint        = 2
      ntok          = mcols

      minbat        = nbatch
      maxbat        = nbatch

c     first loop
      if (loop .le. 0) then
         call ccp4h_header('File input','filein',2)
         call ccp4h_pre_beg() 
c     open file
         call lropen (mtzin, 'HKLIN', iprint, fail)
         if (fail .eq. 1) call ccperr(1, 'No input no output!')
c
c  Setup up possible input labels for LABIN command
         lsprgi (1)    = 'H'
         lsprgi (2)    = 'K'
         lsprgi (3)    = 'L'
         ctprgi (1)    = 'H'
         ctprgi (2)    = 'H'
         ctprgi (3)    = 'H' 
         if (theinput(1:4) .eq. 'MTZF') then
c  F's input, either F, SIGF or F+,F-, labels are optional to allow
c this choice
            nlprgi        = 9
            lsprgi (4)    = 'F'
            lsprgi (5)    = 'SIGF'
            lsprgi (6)    = 'F(+)'
            lsprgi (7)    = 'SIGF(+)'
            lsprgi (8)    = 'F(-)'
            lsprgi (9)    = 'SIGF(-)'
c
            ctprgi (4)    = 'F'
            ctprgi (5)    = 'Q'
            ctprgi (6)    = 'G'
            ctprgi (7)    = 'Q'
            ctprgi (8)    = 'G'
            ctprgi (9)    = 'Q'
c    Optional column flags
            do i = 4, 9
               lookup(i) = 0
            enddo
         else
c  I's input, all 5 labels compulsory (see data statement above)
            nlprgi        = 9
            lsprgi (4)    = 'I'
            lsprgi (5)    = 'SIGI'
            lsprgi (6)    = 'I(+)'
            lsprgi (7)    = 'SIGI(+)'
            lsprgi (8)    = 'I(-)'
            lsprgi (9)    = 'SIGI(-)'
c
            ctprgi (4)    = 'J'
            ctprgi (5)    = 'Q'
            ctprgi (6)    = 'K'
            ctprgi (7)    = 'M'
            ctprgi (8)    = 'K'
            ctprgi (9)    = 'M'
c    Optional column flags
            do i = 4, 9
               lookup(i) = 0
            enddo
         endif
c     check labin
         write (linesav2, '(a,a)') 'LABIN '//linesav
         linesav = linesav2(1:600)
         call parser(key,linesav,ibeg,iend,ityp,fvalue,cvalue,idec,ntok
     $      , lend, iprint)
         call lkyin(mtzin, lsprgi, nlprgi, ntok, linesav, ibeg, iend)
         
         call lrassn (mtzin, lsprgi, nlprgi, lookup, ctprgi)
c  For MTZI and MTZF option, check whether I or F or I+/- or F+/- have been assigned
         fail = 0
         if (theinput(1:3) .eq. 'MTZ') then
            if (lookup(4) .gt. 0) then
c   'F' or 'I' was assigned
               if (lookup(5) .le. 0) fail = -1
c   kfplfmn = 0 for F or I, for I+/- or F+/- alternates between +1 & -1
               kfplfmn = 0
            else
c   'F' was not assigned
               do i = 6,9
                  if (lookup(i) .le. 0) fail = +1
               enddo
               kfplfmn = +1
            endif
            if (fail .ne. 0) then
               call ccperr(1, '*** LABIN command incomplete ***')
            endif
         endif
c     symmetry
         ltype = pgname (1:1)
         call lrsymi(mtzin, nsymp, ltype, nspgrp, namspg, pgname)
         call lrsymm(mtzin, nsym, rsym)
         call centric(nsym, rsym, 1)
c     read sort order
         call lrsort(mtzin, isort)
         gotsort=.true.

c     Extract single PROJECTNAME/CRYSTALNAME/DATASETNAME from input
c     MTZ file. Lose others and column pointers, since not relevant.
C        Notify available space
         ndatasets = msets
         call lridx(mtzin,pname,xname,dname,isets,
     $                      datcell,datwave,ndatasets)
         if (ndatasets.eq.-1) then
            call ccperr(2,
     $       'Insufficient space assigned for all datasets in file!')
            ndatasets = msets
         endif
         if (ndatasets.ge.1) then
C     Keyworded input has precedence.
            call lrclid(mtzin, csetid, idummy)
            isetout = csetid(lookup(1))
            if(lookup(4).ne.0)isetout = csetid(lookup(4))
            if(lookup(6).ne.0)isetout = csetid(lookup(6))
            do iset = 1, ndatasets
               if (isets(iset) .eq. isetout) then
                  if (projectname.eq.'unknown') 
     $               projectname = pname(iset)
                  if (crystalname.eq.'unknown') 
     $               crystalname = xname(iset)
                  if (datasetname(1:7).eq.'unknown')
     $               datasetname = dname(iset)
                  if (cell(1).eq.0.0) then
                     cell(1)=datcell(1,iset)
                     cell(2)=datcell(2,iset)
                     cell(3)=datcell(3,iset)
                     cell(4)=datcell(4,iset)
                     cell(5)=datcell(5,iset)
                     cell(6)=datcell(6,iset)
                  endif
                  datwaveout = datwave(iset)
                  goto 10
               endif
            enddo
 10         continue
            bsetid = isetout
         endif

c     cell
         if (cell(1).eq.0.0 .and. cell(2).eq.0.0 .and. 
     $      cell(3).eq.0.0 .and. cell(4).eq.90.0 
     $      .and. cell(5).eq.90.0 .and. cell(6).eq.90.0) 
     $      then
            call lrcell(mtzin, cell)
         endif

         call ccp4h_pre_end()
      else
c     read reflections
c  If kfplfmn .ne. 0, split each input line into two, one for I+ or F+ and
c one for I- or F-
 100      if (kfplfmn .ge. 0) then
c   Read if I or I+, or F or F+
            call lrreff(mtzin, ssq4, bdata, endoffile)
            if (endoffile) return
            call lrrefm(mtzin, logmiss)
            ihkl(1) = nint(bdata(1))
            ihkl(2) = nint(bdata(2))
            ihkl(3) = nint(bdata(3))
c  icntrc = 1 centric, = 0 acentric
            call centr(ihkl, icntrc)
            if (icntrc .eq. 0) then
               continue
            endif
c    Columns for I/F = 4, I+/F+ = 6
            if (kfplfmn .eq. 0) then
               ncf = 4
            else
               ncf = 6
            endif
         else
c   I-/F-, just reset column, unlees centric, in which case ignore I-/F-
            if (icntrc .ne. 0) then
c    Centric
               kfplfmn = +1
               go to 100
            endif
            ncf = 8
         endif
c
         if (logmiss(ncf) .or. logmiss(ncf+1)) then 
            refrej = .true.
            go to 200
         endif

         if (bdata(ncf).lt.0.0001 .and. bdata(ncf+1).lt.0.0001) then 
            refrej = .true.
            go to 200
         endif
         
         if (theinput(1:4).eq.'MTZF') then
            fsq = (bdata(ncf)*bdata(ncf))
            sigfsq =
     $         (2.*bdata(ncf+1)*bdata(ncf)+bdata(ncf+1)*bdata(ncf+1))
         else
            fsq = bdata(ncf)
            sigfsq = bdata(ncf+1)
         endif
         fsqp = fsq
c Negate indices  for I-/F-, and reset for  next time I+/F+
 200     if (kfplfmn .lt. 0) then
            ihkl(1) = -ihkl(1)
            ihkl(2) = -ihkl(2)
            ihkl(3) = -ihkl(3)
            kfplfmn = +1
         elseif (kfplfmn .gt. 0) then
            kfplfmn = -1
         endif
         if (refrej) return
      endif
      return
      end

c ***********************************************************************

      subroutine inputisweis()

      integer fail, ident, ldum
      real lstlsq
      include 'parser.fh'
      include 'refandmtz.fh'
      external lstlsq

      fail = 0

c     first loop
      if (loop .le. 0) then
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()
c     batch will be read from data line
        nbatch = 10000
c     read reflections
      else
        if (endoffile) return
        read (21, 9000, END=30, ERR=20) ihkl, mpart, fsq, sigfsq, ident
     
        if (nbatch .eq. 0) then
          nbatch = ident
        endif

        fsqp = fsq
        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))

      endif
        
      return
c     format of weis input
 9000 format (5X, 4I4, 2F8.2, I10)
 20   refok = .false.
      call ccperr(2, 'bad reflection format in weis input file')
 30   endoffile = .true.   
      end
c ***********************************************************************

      subroutine inputistex()

      integer fail, ident, ldum
      real scfac
      real lstlsq
      include 'parser.fh'
      include 'refandmtz.fh'
      external lstlsq

      fail          = 0
      ident         = 0

c     first loop
      if (loop .le. 0) then
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()
c     batch will be read from data line
        nbatch = 10000
c     read reflections
      else
        if (endoffile) return
        if (theinput(1:4) .eq. 'TEXS') then
          read (21, 9000, END=30, ERR=20) ihkl, ident, fsq, sigfsq
        elseif (theinput(1:4) .eq. 'TEXH') then
          read (21, 9100, END=30, ERR=20) ihkl, fsq, sigfsq, scfac
          fsq = fsq*scfac
          sigfsq = sigfsq*scfac
        endif
        
        if (nbatch.eq.0 .and. ident.ne.0) then
          nbatch = ident
        endif

        fsqp = fsq
        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))

      endif

      return

c     format of texs input
 9000 format (3I4, I3, 5X, F8.1, F7.1)

c     format of texh
 9100 format (3X, 3I4, 2F10.2, 29X, F7.4)

 20   refok = .false.
      call ccperr(2, 'bad reflection format in TEX* input file')

 30   endoffile = .true.   
      end

c*****************************************************************
      subroutine inputisjims()

      integer fail, ldum
      real lstlsq
      include 'parser.fh'
      include 'refandmtz.fh'
      external lstlsq

      fail = 0

c     first loop
      if (loop .le. 0) then
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()
c     read reflections
      else
        if (endoffile) return
        read (21, 9000, END=30, ERR=20) ihkl, fsq, sigfsq

        fsqp = fsq
        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))
      endif

      return

c     format of jims input
 9000 format (3I5,2F10.2)
 20   refok = .false.
      call ccperr(2, 'bad reflection format in JIMS input file')

 30   endoffile = .true.   
      end

c*****************************************************************
      subroutine inputismu()
c     subroutine for muf and mui inputs

      integer ldum, iflag, ichk, fail
      real lstlsq
      include 'parser.fh'
      include 'refandmtz.fh'
      external lstlsq

      fail = 0

c     first loop
      if (loop .le. 0) then
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()
c     read reflections
      else
        if (endoffile) return
        read (21, 9000, END=30, ERR=20) ihkl, ssq4, fsq, sigfsq,
     $       fplus, sigfplus, fneg, sigfneg, iflag

        fsqp = fsq
        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))
        ichk = MOD(iflag, 4)
        
C     If ichk = 2 , no I+ measurement
        if (ichk.eq.2) fplus = 0.0
        if (ichk.eq.2) sigfplus = 0.0
        ichk = MOD(iflag, 8)
        
C     If ichk = 1 , no I- measurement
        if (ichk.eq.4) fneg = 0.0
        if (ichk.eq.4) sigfneg = 0.0
        
        if (theinput(1:3).eq.'MUI') then
          fsq = fplus
          sigfsq = sigfplus
        endif
        
        if (theinput(1:3).eq.'MUF') then
          fsq = fplus*fplus
          sigfsq = 2*fplus*sigfplus
        endif

        fsqp = fsq
      endif

      return

c     format of muf/i input
 9000 format (3I4, 1X, F6.4, 6 (1X, F8.2), 1X, I2)
 20   refok = .false.
      call ccperr(2, 'bad reflection format in MUF/I input file')

 30   endoffile = .true.   

      end


c*****************************************************************
      subroutine inputisdatr()

      integer ldum, ifail
      real lstlsq, ff, sigff
      include 'parser.fh'
      include 'refandmtz.fh'
      external lstlsq

      ifail = 0

      ff            = 0.0
      sigff         = 0.0

c     first loop
      if (loop .le. 0) then
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, ifail)
        if (ifail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()
c     read reflections
      else
        if (endoffile) return
        read (21, 9000, END=30, ERR=20) ihkl, ff, sigff
      
        fsq = ff*ff
        sigfsq = 2*ff*sigff + sigff*sigff
        
        fsqp = fsq
        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))
      endif

      return
c     format of datr input
 9000 format (3I4,4F8.0)
 20   refok = .false.
      call ccperr(2, 'bad reflection format in DATR input file')

 30   endoffile = .true.   

      end

c*****************************************************************
      subroutine inputisxdsu()

      integer ldum, fail
      real fdif, sigdif
      real lstlsq
      include 'parser.fh'
      include 'refandmtz.fh'
      external lstlsq

      fail = 0

c     first loop
      if (loop .le. 0) then
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()
c     read reflections
      else
        if (endoffile) return
        read (21, 9000, END=30, ERR=20) ihkl, fsq, sigfsq, fdif, sigdif
        if (ihkl(1).eq.10000) goto 30  
      
        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))

C_FW 2/2/94 sigma correction
        if (sigdif.gt.0.001) sigfsq=1.414*sigfsq
        fplus = fsq + 0.5*fdif
        fneg = fsq - 0.5*fdif
        sigfneg = sigfsq
        fsq = fplus

        fsqp = fsq
        
        if (sigdif.gt.0.01) then
          ihkl(1) = -ihkl(1)
          ihkl(2) = -ihkl(2)
          ihkl(3) = -ihkl(3)
          fsq = fneg
          fsqp = fsq
          if (fsq.eq.0.00) refrej = .true.
        endif
      endif

      return
c     format of xdsu input
 9000 format (3I5, 4E12.4 )
 20   refok = .false.
      call ccperr(2, 'bad reflection format in XDSU input file')

 30   endoffile = .true.   

      end

c*****************************************************************
      subroutine inputisxdsascii()

      integer ldum, fail
      real fdif, sigdif
      real lstlsq
      include 'parser.fh'
      include 'refandmtz.fh'
      external lstlsq
      integer ibeg(mcols),iend(mcols),ityp(mcols),idec(mcols),ntok,
     +   ipos(20),nx,ny,startbat
      character cvalue(mcols)*4, key*4, line*200, namspg_ns*20
      real      fvalue(mcols),orgx,orgy,startphi,delphi
      logical   lend

      save ipos,startbat,startphi,delphi

      fail = 0

c     first loop
      if (loop .le. 0) then

        do i=1,11
          ipos(i) = 0
        enddo

        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()

c     interpret header records of XDS_ASCII.HKL
 10     read(21,'(A)',END=40) line
c     remove leading exclamation mark
        line = line(2:lenstr(line))
        call parser(key,line,ibeg,iend,ityp,fvalue,cvalue,idec,ntok,
     +        lend,0)

        if (line(ibeg(1):iend(1)).eq.'END_OF_HEADER') goto 15

        if (line(ibeg(1):iend(1)).eq.'SPACE_GROUP_NUMBER') then
          nspgrp=fvalue(2)
          call msymlb3(24,nspgrp,namspg,namspg_ns,
     +                         pgname,nsymp,nsym,rsym)
        elseif (line(ibeg(1):iend(1)).eq.'UNIT_CELL_CONSTANTS') then
          do i=1,6
            cell(i) = fvalue(i+1)
          enddo
        elseif (line(ibeg(1):iend(1)).eq.'X-RAY_WAVELENGTH') then
          almbd = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'DETECTOR_DISTANCE') then
          dxstl = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'INCIDENT_BEAM_DIRECTION') then
          SRCE(1) = - fvalue(2)
          SRCE(1) = - fvalue(3)
          SRCE(1) = - fvalue(4)
        elseif (line(ibeg(1):iend(1)).eq.'ROTATION_AXIS') then
          NGNX = 1
          EE1(1) = fvalue(2)
          EE1(1) = fvalue(3)
          EE1(1) = fvalue(4)
        elseif (line(ibeg(1):iend(1)).eq.'OSCILLATION_RANGE') then
          delphi = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'STARTING_ANGLE') then
          startphi = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'STARTING_FRAME') then
          startbat = nint(fvalue(2))
        elseif (line(ibeg(1):iend(1)).eq.'ORGX') then
          orgx = fvalue(2)
          orgy = fvalue(4)
        elseif (line(ibeg(1):iend(1)).eq.'NX') then
          nx = fvalue(2)
          ny = fvalue(4)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_H') then
           ipos(1) = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_K') then
           ipos(2) = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_L') then
           ipos(3) = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_IOBS') then
           ipos(4) = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_SIGMA(IOBS)') then
           ipos(5) = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_XD') then
           ipos(6) = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_YD') then
           ipos(7) = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_ZD') then
           ipos(8) = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_RLP') then
           ipos(9) = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_PEAK') then
           ipos(10) = fvalue(2)
        elseif (line(ibeg(1):iend(1)).eq.'ITEM_CORR') then
           ipos(11) = fvalue(2)
        endif

        goto 10

 40     call ccperr(1,'No END_OF_HEADER record in XDS_ASCII file.')

 15     continue

c check first 8 columns are present
c we also use column 10 but not essential and doesn't appear in XSCALE file
        do i=1,8
          if (ipos(i).eq.0) call ccperr(1,
     +      'Not all ITEM_* records present in XDS_ASCII file.')
        enddo

c check for certain header records
c       X-RAY_WAVELENGTH
        if (almbd.eq.0.0) then
          call ccperr(2,
     +        'WARNING: X-RAY_WAVELENGTH not set in XDS header.')
        endif
c       OSCILLATION_RANGE
        if (delphi.eq.0.0) then
          call ccperr(2,
     +        'WARNING: OSCILLATION_RANGE not set in XDS header.')
        endif

c     batch will be read from data line
        nbatch = 10000

c     detector limits
        detlim(1,1)   = orgx - real(nx/2)
        detlim(2,1)   = orgx + real(nx/2)
        detlim(1,2)   = orgy - real(ny/2)
        detlim(2,2)   = orgy + real(ny/2)

c     read reflections
      else
        if (endoffile) return

        read(21,'(A)',END=30, ERR=20) line
        if (line(2:12).eq.'END_OF_DATA') goto 30

        call parser(key,line,ibeg,iend,ityp,fvalue,cvalue,idec,ntok,
     +        lend,0)

        ihkl(1) = fvalue(ipos(1))
        ihkl(2) = fvalue(ipos(2))
        ihkl(3) = fvalue(ipos(3))
        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))

c batch number from ZD
        nbatch = int(fvalue(ipos(8))) + 1 + addbat
        battitle(nbatch-addbat) = 'From XDS CORRECT'
c this expression for batphistt is that for phi(i) in the XDS documentation
c under parameter STARTING_ANGLE
        batphistt(nbatch-addbat) = startphi + 
     +                               (nbatch-addbat-startbat)*delphi
        batphiend(nbatch-addbat) = batphistt(nbatch-addbat) + delphi
        batphirange(nbatch-addbat) = delphi

        fsq = fvalue(ipos(4))
        sigfsq = fvalue(ipos(5))
c negative sig indicates misfits - we keep these for now
        if (sigfsq.lt.0.0) sigfsq = - sigfsq

CMDW we set profile-fitted intensities to I/SIGI
CMDW would be better to set them unknown, but checkrange messes with them
        fsqp = fsq
        sigfsqp = sigfsq

C fractioncalc is interpreted as 0.01 times "percentage of observed reflection 
C intensity".
        if (ipos(10).gt.0) fpart = fvalue(ipos(10))*0.01

C detector position in pixels
        xdet = fvalue(ipos(6))
        ydet = fvalue(ipos(7))
C ROT is halfway between start and stop angles for batch
        fphi = batphistt(nbatch-addbat) + 0.5*delphi

      endif

      return

 20   refok = .false.
      call ccperr(2, 'bad reflection format in XDSA input file')

 30   endoffile = .true.   

c     write batch information
      wpseudomrec = .false.

      end

c*****************************************************************
      subroutine inputisraxi()

      integer ldum, fail
      real lstlsq
      include 'parser.fh'
      include 'refandmtz.fh'
      external lstlsq

      fail = 0

c     first loop
      if (loop .le. 0) then
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()
c     batch will be read from data line
        nbatch = 10000
c     read reflections
      else
        if (endoffile) return
        read (21, 9000, END=30, ERR=20) mpart, ihkl, fsq, sigfsq, nbatch
      
        nbatch = nbatch + addbat
        if (mpart .ne. 0) mpart = 2
        
        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))
        
        fsqp = fsq
      endif

      return
c     format of raxi input
 9000 format (21X, I4,4X,3I3,8X, 2F10.3, I4 )
 20   refok = .false.
      call ccperr(2, 'bad reflection format in RAXI input file')

 30   endoffile = .true.   

      end

c*****************************************************************
      subroutine inputissaint()
      implicit none
     
      integer ldum, fail, oldaddbat, nbatt
      real phirng,phistt,iphi
      real lstlsq
      logical first
      include 'parser.fh'
      include 'refandmtz.fh'
      external lstlsq

      save phirng
      save phistt
      
      fail = 0

c     first loop
      if (loop .le. 0) then
        first = .true.
        call ccperr (2, 'can you contact ccp4@dl.ac.uk if problems?')
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()
c     batch will be read from data line
        nbatch = 10000
        fphi = 0
        phistt = 0.0
        phirng = 1.0
c     read reflections
      else
        if (endoffile) return
        read (21, 9000, END=30, ERR=20) ihkl, fsq, sigfsq, 
     $       nbatch, xdet, ydet, fphi

c     sort out the batch number
        if (nphistp.eq.1) then
          nbatch = nbatch + addbat
        elseif (nphistp.gt.1) then
          iphi = int((fphi-phistt)*nphistp/phirng)
          if (iphi.lt.0) iphi=0
          if (iphi.ge.nphistp) iphi = nphistp - 1
          nbatch = (nbatch - 1)*nphistp + iphi + 1 + addbat
        else
          call ccperr (2, 'NPHISTP<1')
          refok = .false.
          return
        endif
        
c     in saint from rotaprep the reflection was rejected here if it had
c     a negative sigma
        if (sigfsq .lt. 0.0) then 
          refrej = .true.
          return
        endif

        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))
        fpart = 1.0
        mpart = 0
        fsqp = fsq

      endif

      return
c     format of saint input
 9000 format (3I4,2F8.3,I4,51X,2F7.2,55X,F7.2)
 20   refok = .false.
      call ccperr(2, 'bad reflection format in SAINT input file')
      return
 30   endoffile = .true.   

c     write batch information
      wpseudomrec = .false.
      phistt = phimin
      phirng = phimax - phimin
      oldaddbat = addbat
      addbat = 0
      nbatt = nbatch
      call hdrrd(+1, cell, phistt, phirng, nbatt, first)
      addbat = oldaddbat
      end

c*****************************************************************
      subroutine inputissc()
      implicit none

      integer ldum, fail, nsm, i, isym
      real lstlsq
      logical nofpt
      include 'parser.fh'
      include 'refandmtz.fh'
      external lstlsq

      fail = 0
      nofpt = .true.
      isym = 0

c     first loop
      if (loop .le. 0) then
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
        
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()
        
c     read header info
        if (theinput(1:8).eq.'SCAL_NM2') then
          read (21,*) nsm
          do i=1,nsm
            read (21,'(/)')
          enddo
        else
          if (cell(1).gt.0.0) then
            read (21,'(///)')
            call ccperr(2, 'CELL changed to correspond to keyword')
          else
            read (21, fmt='(//,6F10.3)') cell
          endif
        endif
        
c     fudge so batch is not requred in SCAL_NM* option
        if (theinput(1:7).eq.'SCAL_NM') then
          nbatch = 10000
        endif
        
        return
c     read reflections
      else
        if (endoffile) return
        if (theinput(1:7).ne.'SCAL_NM') then
          read (21, 9000, end=30, err=20) ihkl, fsq, fneg, sigfneg
        elseif (theinput(1:8).eq.'SCAL_NM2') then
          read (21, 9200, end=30, err=20) ihkl, nbatch, fsq, sigfsq
        else
          read (21, 9100, end=30, err=20) ihkl, nbatch, isym, fsq, 
     $         sigfsq, fpart
        endif

        nbatch = nbatch + addbat
        if (mpart .ne. 0) mpart = 2
        
        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))
        
        if (theinput(1:7).ne.'SCAL_NM') goto 10
        
        if (sigfsq.lt.0.0) then
          call ccperr (2, 'Negative Sigma')
          refrej=.true.
          goto 10
        endif
      
        if (fpart.eq.0.0) then
          nofpt = .true.
          fpart = 1.0
        elseif (fpart.lt.0.000000) then
          call ccperr (2, 'Negative fpart?')
          refrej=.true.
          goto 10
        endif
        
        if (fpart.lt.1.0) then
          mpart = 2
        else
          mpart = 0
        endif

        if (isym.gt.nsym) then
          ihkl(1) = -ihkl(1)
          ihkl(2) = -ihkl(2)
          ihkl(3) = -ihkl(3)
        endif

 10     fsqp = fsq
      endif
      return

c     format of scal input
c     SCAL
 9000 format (3I4, 4F8.0)

c     SCAL_NM
 9100 format (4I4, I3, 2F8.0, F7.4)

c     SCAL_NM2
 9200 format (3I4, 12X, I6, 7X, 2F8.0)

 20   refok = .false.
      call ccperr(2, 'bad reflection format in SCAL* input file')

 30   endoffile = .true.   
 
      end

c*****************************************************************
      subroutine inputisdenz()
      implicit none

      integer ldum, fail, i, nbatt, iphi
      real lstlsq, phirng, phistt, celltmp(6)
      logical first

      include 'parser.fh'
      include 'refandmtz.fh'
c      include 'orient.fh'

      save nbatt
      save phirng
      save phistt

      external lstlsq

      fail = 0
      first = .true.

c     first loop
      if (loop .le. 0) then
        fphi = 0
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
c     batch will be read from data line
        nbatch = 10000
c     read cell
        call hdrrd (0, celltmp, phistt, phirng, nbatt, first)
        if (cell(1).eq.0.0) then
          do 5 i=1,6
            cell(i) = celltmp(i)
 5        continue
        else 
          call ccperr(3,'Denzo Cell changed to CELL keyword')
        endif
        call ccp4h_pre_end()

c     read reflections
      else
        if (endoffile) return

        read (21, 9000, end=30, err=20) ihkl, fsqp, fsq,
     +       sigfsq, xdet, ydet, fpart, fphi

        if (abs(ihkl(1)).eq.999 .or. abs(ihkl(2)).eq.999 .or.
     +       abs(IHKL(3)).eq.999) then
          call hdrrd(0,cell, phistt, phirng, nbatt, first)
          return
        endif

C     Shivers - new denzo terminates 0 27 27!!
C     Check if SIGFSQ AND xdet AND YDET all zero..
        if (abs(sigfsq).eq.0.0.and. abs(xdet).eq.0.0 .and.
     +       abs(ydet).eq.0.0) then
          call hdrrd(0,cell, phistt, phirng, nbatt, first)          
          return
        endif
C
        if (sigfsq.lt.0.0) then
           write (6, 9201) nbatch,ihkl,fsqp,fsq,sigfsq,xdet,ydet,fpart,
     +         fphi
 9201      format (' Negative Sigma:',I4,2X,3I4,  2F10.1, F9.1, 6X,
     +          2F7.1,4X, F6.3, F6.1)
           refrej = .true.
           return
        endif 

        ssq4 = 4.0*LSTLSQ(MTZOUT, ihkl(1), ihkl(2), ihkl(3))

        if (fpart.le.0.000001) then
          refrej = .true.
          return
        endif
        mpart = 0
        if (fpart.lt.1.0) mpart = 2
C       Find " batch" number.
        if (nphistp.eq.1) then
          nbatch = nbatt + addbat
        elseif  (nphistp.gt.1) then
          iphi = int((fphi-phistt)*nphistp/phirng)
          if (iphi.lt.0) iphi = 0
          if (iphi.ge.nphistp) iphi = nphistp - 1
          nbatch = (nbatt-1)*nphistp + iphi + 1 + addbat
        else
          call ccperr(1, 'NPHISTP<1')
        endif
      endif

      return
c     format of DEZO input
 9000 format (3I4, 2X, 2F8.0, 7X, F6.0, 6X,2F7.0,14X, F6.0, F6.0)
 20   refok = .false.
      call ccperr(2, 'bad reflection format in DENZO input file')

 30   endoffile = .true.   
      wpseudomrec = .false.
      return
      end

c*****************************************************************
      subroutine inputisuser()
c     
      implicit none
      integer fail, ldum, i
      real lstlsq
      include 'parser.fh'
      include 'refandmtz.fh'
      real rdata(maxlabel)
      external lstlsq

      fail = 0

c     first loop
      if (loop .le. 0) then
        call ccp4h_header('File input','filein',2)
        call ccp4h_pre_beg() 
c     open file
        call ccpdpn(21, 'HKLIN', 'READONLY', 'F', ldum, fail)
        if (fail .eq. 1) call ccperr(1, 'No input no output!')
        call ccp4h_pre_end()
c     read reflections
      else
        if (endoffile) return
        read (21, frmat, END=30, ERR=20) (rdata(i),i=1,nlabels)

c     Need to convert reals to integers
        ihkl(1) = nint(rdata(labels(1)))
        ihkl(2) = nint(rdata(labels(2)))
        ihkl(3) = nint(rdata(labels(3)))
        ssq4 = 4.0*lstlsq(mtzout, ihkl(1), ihkl(2), ihkl(3))

        if (labels(4).gt.0) mpart = rdata(labels(4))
        if (labels(5).gt.0) nbatch = rdata(labels(5)) + addbat

        if (labels(6).gt.0) fsq = rdata(labels(6))
        if (labels(7).gt.0) sigfsq = rdata(labels(7))
C if labels 6 and 7 were F/SIGF then re-create I/SIGI
        if (fin) then
           sigfsq = 2.*fsq*sigfsq + sigfsq*sigfsq
           fsq = fsq*fsq
        endif

cpjx    labels(8) is IPR - documentation says "IPR ... is meant to be
cpjx    corrected profile-fitted intensity ... Here IPR ... is set equal
cpjx    to I and sigI if there is no appropriate information input."
        if (labels(8).gt.0) then
          fsqp = rdata(labels(8))
        else
          fsqp = fsq
        endif
cpjx    labels(9) is SIGIPR - same comments apply as for IPR above
        if (labels(9).gt.0) then
          sigfsqp = rdata(labels(9))
        else
          sigfsqp = sigfsq
        endif

        if (labels(10).gt.0) fpart = rdata(labels(10))

      endif

      return

 20   refok = .false.
      call ccperr(2, 'bad reflection format in USER input file')

 30   endoffile = .true.   
      end


c*************************************************************************
c     denzo extra subroutines from rotaprep.f

      SUBROUTINE HDRRD(KOPTION, CELLCHK, PHIST, PHIRNG, NBATT, FIRST)
C     =================
c
c On entry:
c  koption       set option
c                  =  0 Denzo, full orientation data available
c                  = +1 phi & detector ranges only (eg Saint)
c  phist         starting phi (option +1 only)
c  phirng        range of phi (option +1 only)
c  first         true if first call
c
c On exit:
c  cellchk(6)    copy of cell for checking
c  phist         starting phi
c  phirng        range of phi
c  
c Passed in COMMON blocks
c  nbatch        input: batch number (koption = +1 only)
c  addbat        number to add to Batch  
c  nphistp       number of phi ranges to split initial batch into (usually = 1)


      implicit none
C
      include 'parser.fh'
      include 'refandmtz.fh'
      include 'orient.fh'

C     .. Arguments ..
      INTEGER KOPTION,NBATT
      REAL PHIST, PHIRNG, CELLCHK(6)
      LOGICAL FIRST
C     ..
C     .. Local ..
      REAL VOLCHK, VOL, DENAMAT(3, 3), UDENZO(3, 3)
      INTEGER I, J, ICNT
      INTEGER K, IPHISTP, NBAT
      REAL    WAVE, DIST, XTOFD, PHI1, PHI2, PHI3, PHIEN
      CHARACTER DENTITLE*80,LINE*80
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS, ATAN2, SQRT
C
C---- This equivalence is strictly for convenience in printing
C
      REAL E123(3, 3)
      EQUIVALENCE (E123(1, 1), E1(1))
C
C----  Save it
      SAVE VOLCHK,VOL,DENAMAT,UDENZO,WAVE,DIST,XTOFD,IPHISTP,NBAT,
     +     PHI1,PHI2,PHI3,PHIEN,DENTITLE,LINE
C
      if (koption .eq. 0) then
C     Read this for each block.
C     Read DENZO information.
         ICNT = 0
C     Look for HEADER flag:
 39      CONTINUE
         READ (21, '(A)', END=70) LINE
         IF (LINE(1:6).NE.'HEADER') THEN
            ICNT = ICNT + 1
            IF (ICNT.LE.500) GO TO 39
            CALL CCPERR(1, ' No record beginning HEADER??')
         END IF 
C     Found HEADER flag: read batch number as given in input file
         READ(LINE, '(6X,I6)') NBATT
C     Read batch title as given in input file
         READ (21, 9010) DENTITLE
 9010    FORMAT (a80)
         WRITE (6, 9020) DENTITLE
 9020    FORMAT (/////,1x, a80)
C     Read orientation matrix (gives batch cell and volume) 
C     and udenzo (not used)
         DO 40 J = 1, 3
            READ (21, 9030) 
     $         (DENAMAT(J, K), K=1,3), (UDENZO(J, K), K=1,3)
            WRITE (6, 9040)
     $         (DENAMAT(J, K), K=1,3), (UDENZO(J, K), K=1,3)
 40      CONTINUE
 9030    FORMAT (3f15.0, 3f10.0)
 9040    FORMAT (1x, 3f15.8, 5x, 3f10.6)
         CALL UMATCL(BCELL, VOL, DENAMAT, UMRC)

C     Read phi start, phi end, "xtofd" and wavelength
         READ (21, 9050) PHIST, PHIEN, XTOFD, WAVE
 9050    FORMAT (4f12.0)
         PHIRNG = PHIEN - PHIST
         datwaveout = wave
C     Read PHI1, PHI2, PHI3, detector distance, cell refinement flags
         READ (21, 9060) PHI1, PHI2, PHI3, DIST, LBCELL
 9060    FORMAT (4f10.0, 6i2)
c Fix up LBCELL flags: interchange 0 & -1 for Postref
         DO 41, I=1,6
            IF (LBCELL(I) .EQ. 0) THEN
               LBCELL(I) = -1
            ELSEIF (LBCELL(I) .EQ. -1) THEN
               LBCELL(I) =  0
            ENDIF
 41      CONTINUE
C
C   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      elseif (koption .eq. +1) then
c For this option, the Phi range and detector range are set from arguments
c Everything else is dummy
         write (dentitle, '(a,i6)') 'Rotaprep batch ', nbatch
c Dummy zero cell and setting matrix, etc
c (ie all the things read from the header for Denzo)
         call ccpzr(bcell, 6)
         call ccpzi(lbcell, 6)
         call ccpzr(umrc, 9)
         dist = 0.0
         wave = 0.0
      else
         call ccperr(1,'*** Illegal Koption in HDRRD ***')
      endif
C
C  The following variables are written directly to the orientation
C  block in orient.fh and are assumed to be the same for all input
C  batches
C  Also BCELL, LBCELL, UMRC above

C---- Wavelength
      ALAMBD = WAVE
C Detector distance (mm)
      DX1 = DIST/10.0
C
C  Other variables are written to holding arrays
C
      PHISTT = PHIST
      PHIRANGE = PHIRNG/REAL(NPHISTP)
      DO 50 IPHISTP = 1, NPHISTP
C Derive output batch number from file batch number NBATT and from 
C splitting factor NPHISTP
        NBAT = NPHISTP* (NBATT-1) + IPHISTP + ADDBAT
        PHIEND = PHISTT + PHIRANGE

C   Transfer data from input header to common blocks in refandmtz.fh
C index on batch number - addbat

        BATTITLE(NBAT-ADDBAT) = DENTITLE(1:70)
        BATPHISTT(NBAT-ADDBAT) = PHISTT
        BATPHIEND(NBAT-ADDBAT) = PHIEND
        BATPHIRANGE(NBAT-ADDBAT) = PHIRANGE
        PHISTT = PHIEND
 50   CONTINUE


C  Check subsequent batch cells against first one read
      IF (FIRST) THEN
        DO 60 J = 1, 6
          CELLCHK(J) = BCELL(J)
 60     CONTINUE
        VOLCHK = VOL
      END IF
      IF (.NOT.FIRST) THEN
        IF (ABS(VOLCHK-VOL)/ (VOLCHK+VOL).GT.0.01) THEN
          WRITE (6, *) ' First cell', CELLCHK
          WRITE (6, *) ' Current cell', BCELL
          CALL CCPERR(1,
     $         ' Disagreement between batch cell dimensions')
        END IF
      END IF

 70   CONTINUE
      RETURN
C
      END
C
      SUBROUTINE UMATCL(CELL, VOL, AMAT, UMRC)
      REAL AMRC(3, 3), AMAT(3, 3), TCELL(6), CELL(6), TSIN(3), TCOS(3)
      REAL AORIEN(3, 3), B(3, 3), UMAT(3, 3), AOINV(3, 3), UMRC(3, 3)
      REAL  A13, TAS, A33, DET, VOL, WAVE1
      INTEGER  L, N
      INTEGER LUNSTO, LUNOUT
      EXTERNAL LUNSTO, MATMUL
C
      LUNOUT = LUNSTO(1)
C                 now, change the orientation matrix to the mrc convention:
      DO 10 L = 1, 3
        AMRC(1, L) = AMAT(3, L)
        AMRC(2, L) = AMAT(1, L)
        AMRC(3, L) = AMAT(2, L)
   10 CONTINUE
      WRITE (LUNOUT, *)
      WRITE (LUNOUT, '(a,3(/,3f10.5))') '  amrc',
     +  ((AMRC(L, N), N=1, 3), L=1, 3)

      CALL CAMATC(AMAT, CELL, TCELL, TSIN, TCOS)
      WRITE (LUNOUT, *) ' Denzo Real cell', CELL
      WRITE (LUNOUT, *) ' Denzo Reciprocal cell', TCELL

C   DENZO orthogonalisation matrix
      AORIEN(1, 1) = TCELL(1)*TSIN(3)
      AORIEN(2, 1) = TCELL(1)*TCOS(3)
      AORIEN(3, 1) = 0.
      AORIEN(1, 2) = 0.
      AORIEN(2, 2) = TCELL(2)
      AORIEN(3, 2) = 0.
      A13 = (TCOS(2)-TCOS(3)*TCOS(1))/TSIN(3)
      AORIEN(1, 3) = TCELL(3)*A13
      AORIEN(2, 3) = TCELL(3)*TCOS(1)
      TAS = TSIN(1)**2 - A13**2
      IF (TAS.LE.0.) CALL CCPERR(1, 'TAS.LE.0. in UMATCL')
      A33 = SQRT(TAS)
      AORIEN(3, 3) = TCELL(3)*A33
      WRITE (LUNOUT, '(a,3(/,3f10.5))') ' Denzo aorien matrix:', AORIEN
      CALL MINV3(AOINV, AORIEN, DET)
      WRITE (LUNOUT, '(a,3(/,3f10.5))') ' Denzo aorien**-1 matrix:',
     +     AOINV
      WRITE (LUNOUT, *) ' Determinant', DET
      VOL = 1./DET
C   A=BC
      CALL MATMUL(UMAT, AMAT, AOINV)
      CALL MINV3(AOINV, UMAT, DET)
      WRITE (LUNOUT, '(a,3(/3f10.5))') ' Denzo umat matrix:', UMAT
      WRITE (LUNOUT, '(a,3(/3f10.5))') ' Denzo umat**-1 matrix:', AOINV
      WRITE (LUNOUT, *) ' Determinant', DET
C
C  Mosflm stuff:
C   Put WAVE = 1.0
      WAVE1 = 1.0
C  MOSFLM orthogonalisation matrix
      CALL BMATRX(B, CELL, TCELL, WAVE1)
      WRITE (LUNOUT, '(a,3(/3f10.5))') ' Mosflm B matrix:', B
      CALL MINV3(AOINV, B, DET)
      WRITE (LUNOUT, '(a,3(/3f10.5))') ' Mosflm B**-1 matrix:', AOINV
      WRITE (LUNOUT, *) ' Determinant', DET
C
      CALL MATMUL(UMRC, AMRC, AOINV)
      CALL MINV3(AOINV, UMRC, DET)
      WRITE (LUNOUT, '(a,3(/3f10.5))') ' Mosflm umat matrix:', UMRC
      WRITE (LUNOUT, '(a,3(/3f10.5))') ' Mosflm umat**-1 matrix:', AOINV
      WRITE (LUNOUT, *) ' Determinant', DET
      END
C     ----------------------------------------------------------------------
      SUBROUTINE CAMATC(AMAT, CELL, TCELL, TSIN, TCOS)
C     $                          (amat(i,j),j=1,3),
C
      REAL AMAT(3, 3), TCELL(6), CELL(6), TSIN(3), TCOS(3)
      REAL VST, VST2
C
      TCELL(1) = SQRT(AMAT(1, 1)**2+AMAT(2, 1)**2+AMAT(3, 1)**2)
      TCELL(2) = SQRT(AMAT(1, 2)**2+AMAT(2, 2)**2+AMAT(3, 2)**2)
      TCELL(3) = SQRT(AMAT(1, 3)**2+AMAT(2, 3)**2+AMAT(3, 3)**2)
      TCELL(4) = ACOS((AMAT(1, 2)*AMAT(1, 3)+AMAT(2, 2)*AMAT(2,
     +           3)+AMAT(3, 2)*AMAT(3, 3))/ (TCELL(2)*TCELL(3)))
      TCELL(5) = ACOS((AMAT(1, 1)*AMAT(1, 3)+AMAT(2, 1)*AMAT(2,
     +           3)+AMAT(3, 1)*AMAT(3, 3))/ (TCELL(1)*TCELL(3)))
      TCELL(6) = ACOS((AMAT(1, 1)*AMAT(1, 2)+AMAT(2, 1)*AMAT(2,
     +           2)+AMAT(3, 1)*AMAT(3, 2))/ (TCELL(1)*TCELL(2)))
      TSIN(1) = SIN(TCELL(4))
      TSIN(2) = SIN(TCELL(5))
      TSIN(3) = SIN(TCELL(6))
      TCOS(1) = COS(TCELL(4))
      TCOS(2) = COS(TCELL(5))
      TCOS(3) = COS(TCELL(6))
      TCELL(4) = TCELL(4)*180./3.141592654
      TCELL(5) = TCELL(5)*180./3.141592654
      TCELL(6) = TCELL(6)*180./3.141592654
      VST2 = 1.0 - TCOS(1)**2 - TCOS(2)**2 - TCOS(3)**2 +
     +       2.*TCOS(1)*TCOS(2)*TCOS(3)
      VST = SQRT(VST2)
      CELL(1) = TSIN(1)/TCELL(1)/VST
      CELL(2) = TSIN(2)/TCELL(2)/VST
      CELL(3) = TSIN(3)/TCELL(3)/VST
      CELL(4) = ACOS((TCOS(2)*TCOS(3)-TCOS(1))/ (TSIN(2)*TSIN(3)))*180./
     +          3.141592654
      CELL(5) = ACOS((TCOS(1)*TCOS(3)-TCOS(2))/ (TSIN(1)*TSIN(3)))*180./
     +          3.141592654
      CELL(6) = ACOS((TCOS(1)*TCOS(2)-TCOS(3))/ (TSIN(1)*TSIN(2)))*180./
     +          3.141592654
      END

C  EJD - BEWARE - I have changed this to be GENERAL.
C  R was NOT the reciprocal cell - it was a* b* c* cosalpha* etc..
C     ----------------------------------------------------------------------
C      SUBROUTINE BMATRX(B,R,CA,C)
      SUBROUTINE BMATRX(B, CELL, R, WAVE)
C     ===========================
C      implicit none
C
C        [B] is an orthogonalization matrix to convert indices h,k,l to
C        cartesian crystal axes x,y,z.
C
C        [B] =  ( a*     b* cos gamma*   c* cos beta*            )
C               ( 0      b* sin gamma*  -c* sin beta* cos alpha  )
C               ( 0           0            lambda / c            )
C
C        reciprocal lettice modified by multiplication by lamdba.
C
C
C Build cell orthogonalization matrix B from reciprocal cell dimensions
C R (in rlu), CA = cos alpha
C
C
C
C     .. Scalar Arguments ..
      REAL CA, CBS, SBS, CGS, SGS, WAVE
C     ..
C     .. Array Arguments ..
      REAL B(3, 3), CELL(6), R(6)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C     ..
C
      CA = COS(CELL(4)*3.141592654/180.0)
      CBS = COS(R(5)*3.141592654/180.0)
      CGS = COS(R(6)*3.141592654/180.0)
      SBS = SQRT(ABS(1.0-CBS*CBS))
      SGS = SQRT(ABS(1.0-CGS*CGS))
      B(1, 1) = WAVE*R(1)
      B(1, 2) = WAVE*R(2)*CGS
      B(1, 3) = WAVE*R(3)*CBS
      B(2, 1) = 0.0
      B(2, 2) = WAVE*SGS*R(2)
      B(2, 3) = -WAVE*SBS*R(3)*CA
      B(3, 1) = 0.0
      B(3, 2) = 0.0
      B(3, 3) = WAVE*1.0/CELL(3)
      END
