C  Copyright (c) Rag de Graaff, Leiden University  2004 - 2006   
C
C  This program is free software; you can redistribute it and/or
C  modify it under the terms of the GNU General Public License
C  as published by the Free Software Foundation; either version 2
C  of the License, or (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, 
C  USA.
      PROGRAM CRUNCH2
      REAL*8 R8
      COMPLEX C
      INTEGER SIGNAL
      COMMON C(3200000),R8(1800000),R(20000000),I(20000000)
      INCLUDE 'common/unit.f'
      INCLUDE 'common/comhas.f'
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/const.f'
      INCLUDE 'common/detpar.f'
      INCLUDE 'common/autpar.f'
      INCLUDE 'common/locaut.f'
      CHARACTER BANNER(8)*103,HITS(4,1000)*80,FORM*20
      COMMON /PARAM/ CELL(6),Q(6),PDB(3,3),ISCORING
      COMMON /TOPROW/ LOCMX
      DATA NC/3200000/,NR/20000000/,NI/20000000/,N8/1800000/
      CALL CCPFYP
      CALL CCPRCS(6,'crunch2','$Date: 2007/03/23 16:34:08 $')
C
C IFIRST is the start of next free location for integers
C JFIRST is the same for floats
C KFIRST is the same for the complex numbers
C
C All input except the reflections for construction of the matrix are
C read in subroutine input
C
      IFIRST=1
      BANNER(1)='    ****    *******    ***       ***  ***      ***     
     1****    ***    ***      *******'
      BANNER(2)='  *      *   *     *    *         *    **       *    * 
     1     *   *      *        *   *'
      BANNER(3)=' *           *     *    *         *    * *      *   *  
     1         *      *        *   *'
      BANNER(4)='*            ******     *         *    *  *     *  *   
     1         ********        *   *'
      BANNER(5)='*            *    *     *         *    *   *    *  *   
     1         *      *        *   *'
      BANNER(6)=' *           *     *    *         *    *    *   *   *  
     1         *      *        *   *'
      BANNER(7)='  *      *   *      *    *       *     *     *  *    * 
     1     *   *      *        *   *'
      BANNER(8)='    ****    ***     **     *****      ***      ***     
     1****    ***    ***      *******'
C      CALL CCPDPN(99, 'CRUNCH2SEED', 'READONLY', 'F', 0, 0)
C      READ(99,1237)SEEDD
C1237  FORMAT(I20)
C      CLOSE(99)
C   Use current time in seconds as a seed (old code above)
C     CALL USTIME(SEEDD)
C     RR=RANDOM(SEEDD)
C     RR=RANDOM(65539)
      JFIRST=1
      DO 1230 J=1,NI
      I(J)=0
1230  CONTINUE
      DO 1231 J=1,NR
      R(J)=0
1231  CONTINUE
      DO 1232 J=1,NC
      C(J)=(0.0,0.0)
1232  CONTINUE
      DO 1233 J=1,N8
      R8(J)=0
1233  CONTINUE
      DO 1235 J=1,8
      WRITE(6,1238)BANNER(J)
1238  FORMAT(103A)
1235  CONTINUE
      WRITE(6,2222)
 2222 FORMAT(/,10X,'Version: Crank Spring 2006',//,
     1 10X,'Author: R.A.G. de Graaff    ',/,
     4 10X,'LIC, Gorlaeus Laboratories',/,
     7 10X,'University of Leiden',/,
     5 10X,'PO Box 9502, 2300 RA Leiden',/,
     6 10X,'The Netherlands',///)
      CALL INPUT(I,NI,R,NR,IFIRST,JFIRST,JFAT,NBEGIN,NEIND,RESOLUTION)
      IF (ISCORING.EQ.1) CALL SKOR
C MDW: Open various files
      CALL CCPDPN(IHITS,'HITS','UNKNOWN','F',0,0)
C
C Now construct the matrix
C
      WRITE(LO,10)RESOLUTION
10    FORMAT(' The resolution of the data is: ',F5.3,' Angstroem',/)
      FT=JZ(1)
      CALL DETER(I,NI,R,NR,LOCH,LOCK,LOCL,LOCEMX,LOCPMX,
     1 LOCIJP,LOCIJQ,NIJP,NIJQ,IFIRST,JFIRST,RESOLUTION)
      CM=CELL(1)
      DO 14 K=2,3
      IF(CM.LT.CELL(K))CM=CELL(K)
14    CONTINUE
      XN=DN/CM
      DN=DN*DN
      KFIRST=1
C
C Sofar just the reflections in the matrix are known. NMX is the order
C EMX contains the e-values, LOCH etc. are the indices of the
C independent reflections in the matrix
C LOCIJP describes the independents, LOCIJQ the symmetry equivalents.
C Only the observed reflections are passed on now. this may change.
C
C Now calculate starting models and sort them 
C Coordinates are returned in R(LOCX)
C
      IOP=0
      ICYC=1
      CALL EIGDET(C,NC,R,NR,I,NI,LOCEMX,LOCPMX,LOCH,LOCK,LOCL,
     1 LOCIJP,LOCIJQ,IFIRST,JFIRST,KFIRST,IOP,
     2 NEIND,NTRIAL,NTRUE,NPOINT,NFS,NIJP,NIJQ,LOCP,ICYC,HITS)
      WRITE(LO,26)NEIND-NBEGIN+1
26    FORMAT(/,' MAIN: Phaserefinement is initialized. A maximum of',
     1 I3,' trials is specified',/)
      WRITE(LO,23)
23    FORMAT(/' MAIN: Trials have been read/generated and sorted')
      IST=NBEGIN-1
      DO 1 NTRIAL=NBEGIN,NEIND
      RR=RANDOM(65539+2*NTRIAL)
      SIGNAL=2
      FOM=-10.0
C     IF(ICOOR.EQ.0)THEN
C     NTRIAL=I(LOCP-NT+1+NPOINT-NBEGIN+IST)
      NTRUE=NTRIAL
C     ELSE
C     NTRUE=NT
C     NTRIAL=NT
C     ENDIF
      WRITE(LO,27)NTRUE
27    FORMAT(/,' MAIN: Start trial number',I4)
      WRITE(IHITS,28)NTRUE
      WRITE(HITS(1,1),28)NTRUE
28    FORMAT(' Trial',I5,' cycle number    1')
      IOP=1
C
C  Refine phases
C
      ICYC=1
      CALL EIGDET(C,NC,R,NR,I,NI,LOCEMX,LOCPMX,LOCH,LOCK,LOCL,
     1 LOCIJP,LOCIJQ,IFIRST,JFIRST,KFIRST,IOP,
     2 NEIND,NTRIAL,NTRUE,NPOINT,NFS,NIJP,NIJQ,LOCP,ICYC,HITS)
C
C  Calculate the first map
C
      CALL GETM(I,NI,R,NR,LOCH,LOCK,LOCL,NFS)
      CALL AUTOFOUR(I,NI,R,NR,NTRUE,ICYC,SIGNAL,HITS,FORM,NPRS)
      WRITE(LO,22)NTRUE
22    FORMAT(/,' MAIN: The first cycle of trial',I5,' is finished')
      IOP=2
2     CONTINUE
      IF(SIGNAL.EQ.0.OR.SIGNAL.EQ.1)THEN
C
C 'SMALL MOLECULE' SOLUTION FOUND STOP THE TRIALS
C
      STOP
      ENDIF
      IF(SIGNAL.EQ.3.OR.SIGNAL.EQ.4)THEN  
C
C PUTOUT Final coordinates obtained from this trial
C
      LXYZ=13
      CALL PUTXYZ(R(LOCXC),FT,NPRS,4,NTRUE,SIGNAL,FORM)
      LXYZ=11
      WRITE(IHITS,29)NTRUE,ICYC
29    FORMAT(' Trial number',I5,' is stopped at cycle',I5,/)
      WRITE(LO,25)NTRUE,ICYC
25    FORMAT(' MAIN: Trial number',I5,' is stopped at cycle',I5,/)
      GO TO 1
      ENDIF
      IF(SIGNAL.EQ.2)THEN
      ICYC=ICYC+1
      IF(ICYC.LE.ICMAX)THEN
      WRITE(HITS(1,ICYC),30)NTRUE,ICYC
      WRITE(IHITS,30)NTRUE,ICYC
30    FORMAT('Trial',I5,' cycle number',I5)
      CALL EIGDET(C,NC,R,NR,I,NI,LOCEMX,LOCPMX,LOCH,LOCK,LOCL,
     1 LOCIJP,LOCIJQ,IFIRST,JFIRST,KFIRST,IOP,
     2 NEIND,NTRIAL,NTRUE,NPOINT,NFS,NIJP,NIJQ,LOCP,ICYC,HITS)
      CALL GETM(I,NI,R,NR,LOCH,LOCK,LOCL,NFS)
      CALL AUTOFOUR(I,NI,R,NR,NTRUE,ICYC,SIGNAL,HITS,FORM,NPRS)
      GO TO 2
      ENDIF
      ENDIF
1     CONTINUE
      CLOSE(IHITS)
      CLOSE(ITEMP)
      CALL CCPERR(0,'Normal termination')
      END
      SUBROUTINE SKOR
      COMMON /PARAM/ CELL(6),Q(6),PDB(3,3),ISCORING
 2223 FORMAT('Scoring')
      WRITE(LO,2223)
      CALL EXIT(0)
      END
