C  Copyright (c) Rag de Graaff, Leiden University  2004 - 2006   
C  This program is free software; you can redistribute it and/or
C  modify it under the terms of the GNU General Public License
C  as published by the Free Software Foundation; either version 2
C  of the License, or (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, 
C  USA.
      SUBROUTINE BKGEN(TOPO,IBKDIM,REF,STREX,NREF,NSTREX,HAS,
     1 IP,ICRI,ICRA,ICRB,NN,NOTF)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER REF(NN,NREF),STREX(NSTREX),HAS(2,1),
     1 HKL(2,2),ILOC(2,2)
      DIMENSION TOPO(IBKDIM,IBKDIM)
      WRITE(IP,*)'    '
      WRITE(IP,*)'Fill quality matrix'
      WRITE(IP,*)'    '
      WRITE(IP,300)ICRA,ICRI,ICRB
  300 FORMAT(' Criterion used: ||E -',I2,'|**',I1,' -',I2,'|')
C
C  DETERMINE HKL OF REFLEXION GENERATED BY TWO TOPROW ELEMENTS
C  AND USE PROPERTIES OF THIS REFLEXION WHICH ARE IN REF()
C  USE |E|-VALUES IN REF(1,*)
C
      M128=8421504
      NUL=1
      IF(NOTF.GT.0)THEN
      VALUE=100*NOTF
      ELSE
      VALUE=NUL
      ENDIF
      TOPO(1,1)=NUL
      DO 100 I=2,IBKDIM
      TOPO(I,I)=NUL
      DO 200 J=1,I-1
      HKL(2,1)=STREX(J)-STREX(I)+M128
      HKL(2,2)=STREX(I)-STREX(J)+M128
C
C  DETERMINE LOCATION IN REF()
C
      CALL FINHAS(HAS,HKL,2,ILOC,ITEL,0)
C
C  CHECK IF REFLEXION EXISTS (ILOC=0: REFLEXION NOT PRESENT)
C
C
C  NORMAL AB INITIO DETER RUN
C
      IF (ILOC(2,1).NE.0)THEN
C
C  TAKE AS QUALITY MATRIX ELEMENT THE VALUE CALCULATED FROM THE
C  CRITERION CONSTRUCTED FROM |E|, ICRI, ICRA AND ICRB
C
C  SCALEFACTOR USED AVOIDS ERRORS CAUSED BY MACHINE PRECISION
C
      
      TOPO(I,J)=ABS((ABS(REF(1,ILOC(2,1))/1000.0-ICRA)**ICRI)-ICRB)
     1  *100
      TOPO(J,I)=TOPO(I,J)
      ELSE
C
C  NOT OBSERVED REFLEXIONS GET VALUE NUL
C
      CALL UNPK1(HKL(2,1),IH,IK,IL)
      CALL RSTRC(MK,IH,IK,IL)
      IF(MK.NE.0)THEN
      TOPO(I,J)=NUL
      ELSE
      TOPO(I,J)=VALUE
      ENDIF
      TOPO(J,I)=TOPO(I,J)
      ENDIF
      IF(TOPO(I,J).LT.0.001) THEN
      TOPO(I,J)=NUL
      TOPO(J,I)=NUL
      ENDIF
  200 CONTINUE
  100 CONTINUE
      RETURN
      END
      SUBROUTINE BLOCK(CORE,IFIRST,MCORE,RCORE,JFIRST,NR,REF,
     1 STREX,NREF,NSTREX,HAS,NM,MX,IP,IBK,
     2 ICRI,ICRA,ICRB,NN,NOTF)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER CORE(MCORE)
      INTEGER LOCTO,LOCPO,LOCSR,LOCA,LOCHU,LOCHR
      INTEGER IBKDIM,OPBLOK
      INTEGER REF(NN,NREF),STREX(NSTREX),HAS(2,1)
      REAL*4 MAXBLO
      DIMENSION MX(NM),RCORE(NR)
      INCLUDE '../common/locaut.f'
      INCLUDE '../common/unit.f' 
C  IN- AND OUTPUTPARAMETERS
C
C  IBK  = MAXIMUM DIMENSION OF QUALITY MATRIX
C  ICRI,ICRA,ICRB DEFINE CRITERION
C
C  LOCTO= LOCATION TOPO(*)   IN RCORE
C  LOCPO= LOCATION POINT(*)  IN CORE
C  LOCSR= LOCATION SOMRIJ(*) IN RCORE
C  LOCA = LOCATION A(*)      IN CORE
C  LOCHU= LOCATION HULP(*)   IN CORE
C  LOCHR= LOCATION HULPR(*)  IN RCORE
C
      ISTART=2
      WRITE(IP,*)' '
      WRITE(IP,*)'Construct matrix using quality matrix'
C
C  TAKE IBK = NSTREX IF IBK > NSTREX
C
      IF (NSTREX.LE.IBK)THEN
      IBKDIM=NSTREX
      ELSE
      IBKDIM=IBK
      ENDIF
      WRITE(IP,11)IBKDIM
   11 FORMAT(' Order quality matrix=',I6)
C
C  NM IS TEMPORARELY INCREASED TO THE ORDER OF THE OVERALL MATRIX
C
      NMB=NM-1
      NM=NMB
      WRITE(IP,10)NM
   10 FORMAT(' Order overall matrix=',I5)
      NGRID=NM/(NMB/2)
C
      CALL RESERV(IFIRST,JFIRST,IBKDIM,LOCTO,LOCPO,
     1 LOCSR,LOCA,LOCHU,LOCHR)
      CALL PLAATS(MCORE,IFIRST-1,NR,JFIRST-1,0,LO)
      CALL BKGEN(RCORE(LOCTO),IBKDIM,REF,STREX,NREF,NSTREX,HAS,
     1 IP,ICRI,ICRA,ICRB,NN,NOTF)
      CALL MATTL2(IBKDIM,RCORE(LOCTO),RCORE(LOCSR))
      CALL MATSOR(RCORE(LOCSR),CORE(LOCPO),RCORE(LOCA),IBKDIM)
      CALL SWAPAL(RCORE(LOCSR),IBKDIM,RCORE(LOCTO),CORE(LOCPO),
     1 CORE(LOCHU),RCORE(LOCHR),STREX,NSTREX)
      CALL MAINTL(RCORE(LOCTO),RCORE(LOCSR),NM,IBKDIM)
      CALL BLOKOP(IBKDIM,RCORE(LOCTO),RCORE(LOCSR),MAXBLO,OPBLOK,
     1 NM,STREX,NSTREX,ISTART)
      CALL OPWIS(IBKDIM,RCORE(LOCTO),NM,OPBLOK,RCORE(LOCSR),STREX,
     1 NSTREX)
C
      CALL MXFILL(MX,NM,STREX,NSTREX,NGRID)
C
C  ASSIGN ORDER OF SUBMATRICES TO NM
C
      NM=NMB+1
      RETURN
      END
      SUBROUTINE BLOKOP(IBKDIM,TOPO,SOMRIJ,MAXBLO,OPBLOK,NM,
     1 STREX,NSTREX,ISTART)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER STREX(NSTREX)
      INTEGER MATNUM,NM,KOLPOS,AANIT,STOP,OPBLOK
      REAL*4 TOPO(IBKDIM,IBKDIM),SOMRIJ(IBKDIM*2),MAXBLO,BLOK(50)
      MAXBLO=0
      IORDER=NM
C
C  OPTIMIZE ALL BLOCKS
C
      MATNUM=1
      KOLPOS=1
       DO 50 NM=ISTART,IORDER
      CALL EENTL2(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS)
      STOP=0
      AANIT=0
      CALL RIJSORT(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS,
     1 AANIT,STOP,STREX,NSTREX)
      CALL BLOKTEL(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS,BLOK,MATNUM)
50      CONTINUE
      OPBLOK=1
      NM=IORDER
      RETURN
      END
      SUBROUTINE BLOKTEL(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS,BLOK,MATNUM)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER NM,KOLPOS,MATNUM
      REAL*4 TOPO(IBKDIM,IBKDIM),SOMRIJ(IBKDIM),BLOK(50),BLCH
      BLCH=0
      BLOK(MATNUM)=0
C
C  DENSITY IS CALCULATED IN TWO DIFFERENT WAYS:
C  1: TAKE SUM OF ROWS (IN SOMRIJ())
C  2: TAKE SUM OF INDIVIDUAL ELEMENTS
C  VALUES ARE COMPARED
C
      DO 1200 I=KOLPOS+1,KOLPOS+NM-1
      SOMRIJ(I)=0
      DO 1250 J=KOLPOS,I-1
      SOMRIJ(I)=SOMRIJ(I)+TOPO(I,J)
 1250 CONTINUE
      BLOK(MATNUM)=BLOK(MATNUM)+SOMRIJ(I)
 1200 CONTINUE
      BLOK(MATNUM)=BLOK(MATNUM)*2
      IF(ABS(BLOK(MATNUM)-BLCH)/(NM**2-NM).GT.0.0001) THEN
      ENDIF
C
C  IN A BLOCK OF ORDER NM THERE ARE (NM^2-NM) NON-DIAGONAL ELEMENTS
C
      RETURN
      END
      SUBROUTINE DETER(A,N,B,NR,LOCH,LOCK,LOCL,LOCEMX,LOCPMX,
     1 LOCIJP,LOCIJQ,NIJP,NIJQ,IFIRST,JFIRST,RESO)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER A(N),HMAX,EVEN
      DIMENSION B(NR)
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      INCLUDE '../common/autpar.f'
      INCLUDE '../common/detpar.f'
      INCLUDE '../common/locaut.f'
      COMMON /TOPROW/ LOCMX
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      AAA=RANDOM(0)
C
C  SEED FOR RANDOM GENERATOR
C

C  Open scratch file
      call ccpdpn(ISCRA,'deter.scr','SCRATCH','U',0,0)

C
C  COUNT INPUT REFLEXIONS
C
      LOCMX=IFIRST
      IFIRST=IFIRST+NMX
      LOCREF=IFIRST
      NN=5
      IFIRST=EVEN(LOCREF+NN*NREF)
      LOCWRK=IFIRST
      IFIRST=EVEN(IFIRST+MAX(4*NMX,NREF))
C
C  NN IS THE FIRST DIMENSION OF A(LOCREF)
C
      CALL PLAATS(N,IFIRST-1,NR,JFIRST-1,0,LO)
C
C  STORE REFLECTIONS IN THE RIGHT FORMAT FOR DETER
C
      CALL LEREF(A(LOCREF),NN,NREF,A(LOCWRK),
     1 B(LOCFO),A(LOCAH),A(LOCAK),A(LOCAL))
      IFIRST=EVEN(LOCREF+NN*NREF)
      NW=60
      LOCWW=IFIRST
      IFIRST=EVEN(IFIRST+2*NW)
      LOCKHL=IFIRST
      NKHL=NSYM*12
      NDIK=2*NSYM
      IFIRST=EVEN(LOCKHL+NKHL)
      CALL PLAATS(N,IFIRST-1,NR,JFIRST-1,0,LO)
      CALL EXPA(A(LOCREF),NN,NREF,A(LOCWW),NW,A(LOCKHL),NKHL,NTOT,NDIK)
      REWIND ISCRA
      ITELM=0
      IF(NHAS.EQ.0) NHAS=1.3*NTOT+1
      LOCHAS=IFIRST
      WRITE(LO,5)
    5 FORMAT(/,' Create hashtable')
C
C  THIS SECTION CREATES AND OPTIMIZES THE HASHTABLE
C  USED TO FIND THE LOCATIONS OF REFLEXIONS IN STORAGE
C  NHAS IS THE LENGTH OF THE TABLE
C  IT IS THE NUMBER OF TESTS TO FIND A BETTER VALUE FOR NHAS
C  ITEST IS THE NUMBER OF TESTS MADE BY TEST HAS
C
      IFIRST=LOCHAS+2*NHAS
      CALL PLAATS(N,IFIRST-1,NR,1,0,LO)
      CALL OPTHAS
     1 (A(LOCHAS),NTOT,A(LOCWW),NW,ISCRA,ITEL,ITELM,IFAIL)
      CALL SCHAR(A,N,2*NHAS,LOCHAS,LOCWW)
C
C  FILL IN FREE SPACE
C
      LOCHAS=LOCWW
      IFIRST=LOCHAS+2*NHAS
      CALL TSTHAS(A(LOCREF),NN,NREF,A(LOCHAS),NHAS,ITEST)
      CALL PLAATS(N,IFIRST-1,NR,JFIRST-1,0,LO)
      LOCSTR=IFIRST
      IFIRST=EVEN(LOCSTR+NSTR)
      LOCSEX=IFIRST
      NSTREX=NSYM*NSTR*2
      IFIRST=EVEN(LOCSEX+NSTREX)
      LOCWW=IFIRST
      IFIRST=EVEN(LOCWW+2*NSTR)
      LOCKHL=IFIRST
      NKHL=NSYM*6
      IFIRST=EVEN(LOCKHL+NKHL)
      CALL PLAATS(N,IFIRST-1,NR,JFIRST-1,0,LO)
      CALL LESTR(A(LOCSTR),NSTR,A(LOCREF),NN,NREF)
      CALL EXPA2(A(LOCSTR),NSTR,A(LOCSEX),NSTREX,A(LOCKHL),NTOTS,
     1 NRL,NDIK)
      NSTREX=NTOTS
      LOCW2=IFIRST
      NW2=NMX
      IFIRST=EVEN(LOCW2+NW2)
      LOCW3=IFIRST
      IFIRST=EVEN(LOCW3+2*NSTR)
      CALL PLAATS(N,IFIRST-1,NR,JFIRST-1,0,LO)
C
C  AFTER THE RESERVATION OF  SUITABLE STORAGE LOCATIONS
C  CREATE AND OPTIMIZE MATRICES
C
      JFIRSTO=JFIRST
      CALL OPMATG(A(LOCMX),NMX,A(LOCSTR),A(LOCSEX),A(LOCREF),
     2 NN,A(LOCHAS),A(LOCWW),NSTR,NSTREX,NREF,IFIRST,N,A,
     3 JFIRST,NR,B,IBK,ICRI,ICRA,ICRB,NOTF)
      JFIRST=JFIRSTO
C
C  As we do not have to store the topological matrix anymore
C
      IFIRST=EVEN(LOCSTR+2*NSTR)
      CALL PLAATS(N,IFIRST-1,NR,JFIRST-1,0,LO)
      WRITE(LO,6)
    6 FORMAT(' Construct kh matrix from top row found by opmatg')
      LOCEMX=JFIRST
      NEMX=NMX*NMX
      JFIRST=EVEN(LOCEMX+NEMX)
      LOCPMX=JFIRST
      JFIRST=EVEN(LOCPMX+NEMX)
C
      NIJ=NMX*(NMX-1)/2
C
      LOCIJP=IFIRST
      IFIRST=EVEN(LOCIJP+5*NIJ)
C
      LOCIJQ=IFIRST
      IFIRST=EVEN(LOCIJQ+6*NIJ)
C
      LOCH=IFIRST
      IFIRST=EVEN(LOCH+NIJ)
      LOCK=IFIRST
      IFIRST=EVEN(LOCK+NIJ)
      LOCL=IFIRST
      IFIRST=EVEN(LOCL+NIJ)
      LCIJPN=IFIRST
      IFIRST=EVEN(LCIJPN+5*NIJ)
C
      LCIJQN=IFIRST
      IFIRST=EVEN(LCIJQN+6*NIJ)
C
      LOCHN=IFIRST
      IFIRST=EVEN(LOCHN+NIJ)
      LOCKN=IFIRST
      IFIRST=EVEN(LOCKN+NIJ)
      LOCLN=IFIRST
      IFIRST=EVEN(LOCLN+NIJ)
      LCIJPO=IFIRST
      IFIRST=EVEN(LCIJPO+5*NIJ)
C
      LCIJQO=IFIRST
      IFIRST=EVEN(LCIJQO+6*NIJ)
C
      LOCHO=IFIRST
      IFIRST=EVEN(LOCHO+NIJ)
      LOCKO=IFIRST
      IFIRST=EVEN(LOCKO+NIJ)
      LOCLO=IFIRST
      IFIRST=EVEN(LOCLO+NIJ)
      NW=NMX
      LOCWW=IFIRST
      IFIRST=EVEN(LOCWW+2*NW)
      LOCW1=IFIRST
      NW1=NMX*(NMX-1)
      IFIRST=EVEN(LOCW1+NW1)
      LOCW3=IFIRST
      IFIRST=EVEN(LOCW3+2*NSTR)
      LOCKHL=IFIRST
      NKHL=12*NSYM
      IFIRST=EVEN(LOCKHL+NKHL)
      LOCW2=IFIRST
      IFIRST=EVEN(LOCW2+NIJ)
      NIJP=NIJ
      NIJQ=NIJ
C
      CALL PLAATS(N,IFIRST-1,NR,JFIRST-1,0,LO)
C
C  SUBR MMTRX CONSTRUCTS THE ACTUAL MATRICES FROM THE TOP ROWS
C  FOUND BY OPMATG
C  EVERYTHING IS PUT OUT, THEN WE ARE READY    
C
      CALL CALCE0
C
C  NON OBSERVED REFLECTIONS ARE SET TO ZERO BY MMTRX
C
      EONOB1=0.0
      EONOB2=0.0
      CALL MMTRX(A(LOCMX),B(LOCEMX),
     1 A(LOCIJP),NIJP,A(LOCIJQ),NIJQ,A(LOCH),A(LOCK),A(LOCL),
     2 A(LCIJPN),NIJPN,A(LCIJQN),NIJQN,A(LOCHN),A(LOCKN),A(LOCLN),
     3 A(LCIJPO),NIJPO,A(LCIJQO),NIJQO,A(LOCHO),A(LOCKO),A(LOCLO),
     4 A(LOCREF),NN,NREF,A(LOCHAS),A(LOCWW),A(LOCW1),A(LOCW2)
     5 ,A(LOCKHL),EGEM,RESO,NDIK)
      WRITE(LO,7)
    7 FORMAT(/,' Construction of the matrix is finished')
      WRITE(LO,501) NMX
      WRITE(LO,505 ) NIJP,NIJQ,NIJPO,NIJPN,EGEM
C
C  WRITE MATRIX INFORMATION TO SHORT OUTPUT FILE
C
  501 FORMAT(/,' The order is:',I5)
  505 FORMAT(
     1 ' Number of independent reflexions:                    ',I9,/,
     2 ' Number of sym.relations:                             ',I9,/,
     3 ' Number of independents outside res. sphere:          ',I9,/,
     4 ' Number of independent, not observed, inside sphere:  ',I9,/,
     5 ' Average |E|-value                                    ',F9.2)
      IF(IPRMX.NE.0) WRITE(LO,502)
  502 FORMAT(' The matrix:')
      CALL PRMX2(A(LOCMX),NMX,B(LOCEMX),IPRMX)
      IF(IPRIJP.NE.0) WRITE(LO,503)
  503 FORMAT(' Independent reflexions and relations')
      CALL PRIJPQ(A(LOCIJP),NIJP,A(LOCIJQ),NIJQ,IPRIJP)
      IFIRST=LOCREF
      CALL SCHAR(A,N,5*NIJP,LOCIJP,IFIRST)
      IFIRST=IFIRST+5*NIJP
      CALL SCHAR(A,N,6*NIJQ,LOCIJQ,IFIRST)
      IFIRST=IFIRST+6*NIJQ
      CALL SCHAR(A,N,NIJP,LOCH,IFIRST)
      IFIRST=IFIRST+NIJP
      CALL SCHAR(A,N,NIJP,LOCK,IFIRST)
      IFIRST=IFIRST+NIJP
      CALL SCHAR(A,N,NIJP,LOCL,IFIRST)
      IFIRST=IFIRST+NIJP
      LOCIJP=LOCREF
      LOCIJQ=LOCIJP+5*NIJP
      LOCH=LOCIJQ+6*NIJQ
      LOCK=LOCH+NIJP
      LOCL=LOCK+NIJP
      IFIRST=LOCL+NIJP
      RETURN
      END
      SUBROUTINE EENTL2(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER NM,KOLPOS
      REAL*4 TOPO(IBKDIM,IBKDIM),SOMRIJ(IBKDIM*2)
      REAL*4 SOMH
      DO 1200 I=KOLPOS,IBKDIM
      SOMRIJ(I+IBKDIM)=0.0
      SOMH=1.0
C
C  USE VARIABLE SOMH FOR DOUBLE PRECISION
C
      DO 1250 J=KOLPOS,KOLPOS+NM-1
      SOMRIJ(I+IBKDIM)=SOMRIJ(I+IBKDIM)+TOPO(I,J)
      SOMH=SOMH*((TOPO(I,J)/SOMH)**(1.0/FLOAT(J+1-KOLPOS)))
 1250 CONTINUE
      SOMRIJ(I)=(INT(SOMH*1000))/1000.
C     WRITE(IP,*) SOMRIJ(I)
C      SOMRIJ(I)=SOMRIJ(I)/SOMRIJ(I+IBKDIM)
 1200 CONTINUE
      RETURN
      END
      SUBROUTINE EXP1(N,KHL,MAXI,NDIK)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX
      DIMENSION KHL(6,NDIK),I1(3)
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      EXTERNAL UNPACK
C
C  BASED ON SUBR INPUT OF MULTAN
C
      MAXI=1
      CALL UNPK1(N,I1(1),I1(2),I1(3))
      DO 250 J=1,NSYM
      DO 200 I=1,4
      KHL(I,J)=0
  200 CONTINUE
      DO 220 I=1,3
      KHL(4,J)=KHL(4,J)-I1(I)*INT(TS(I,J)*24.0+0.1)
      DO 210 K=1,2
      M=IABS(IS(K,I,J))
      IF(M.NE.0) KHL(M,J)=KHL(M,J)+I1(I)*ISIGN(1,IS(K,I,J))
  210 CONTINUE
  220 CONTINUE
      DO 230 I=1,3
      IF(KHL(I,J).NE.0)GOTO 235
  230 CONTINUE
  235 KHL(5,J)=ISIGN(1,KHL(I,J))
      DO 240 I=1,4
  240 KHL(I,J)=KHL(I,J)*KHL(5,J)
      KHL(6,J)=IP1*KHL(1,J)+IP2*(KHL(2,J)+IP3)+KHL(3,J)+IP3
      JMO=J-1
      IF(JMO.LT.1) GOTO 247
      DO 245 I=1,JMO
      IF(KHL(6,I).EQ.KHL(6,J)) KHL(6,J)=0
  245 CONTINUE
  247 IF(KHL(6,J).GT.KHL(6,MAXI)) MAXI=J
  250 CONTINUE
      KHLS=KHL(5,MAXI)
      L=KHL(4,MAXI)*KHLS
      DO 360 J=1,NSYM
      KHL(4,J)=MOD(KHL(4,J)-KHL(5,J)*L,24)
      IF(KHL(4,J).LT.0) KHL(4,J)=24+KHL(4,J)
      KHL(5,J)=KHL(5,J)*KHLS
  360 CONTINUE
      CALL UNPACK(KHL(6,MAXI),LH,LK,LL)
      CALL PAK(N,LH,LK,LL)
      RETURN
      END
      SUBROUTINE EXP2(N,KHL,MAXI,NDIK)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX
      DIMENSION KHL(6,NDIK),I1(3)
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      EXTERNAL UNPACK
C
C  BASED ON SUBR INPUT OF MULTAN
C
      MAXI=1
      CALL UNPK1(N,I1(1),I1(2),I1(3))
      DO 250 J=1,2*NSYM
      IF(J.GT.NSYM)THEN
      JJ=J-NSYM
      KHL(5,J)=-1
      ELSE
      JJ=J
      KHL(5,J)=1
      ENDIF
      DO 200 I=1,4
      KHL(I,J)=0
  200 CONTINUE
      DO 220 I=1,3
      KHL(4,J)=KHL(4,J)-I1(I)*INT(TS(I,JJ)*24.0+0.1)
      DO 210 K=1,2
      M=IABS(IS(K,I,JJ))
      IF(M.NE.0) KHL(M,J)=KHL(M,J)+I1(I)*ISIGN(1,IS(K,I,JJ))
  210 CONTINUE
  220 CONTINUE
      DO 240 I=1,4
  240 KHL(I,J)=KHL(I,J)*KHL(5,J)
      KHL(6,J)=IP1*KHL(1,J)+IP2*(KHL(2,J)+IP3)+KHL(3,J)+IP3
      JMO=J-1
      IF(JMO.LT.1) GOTO 247
      DO 245 I=1,JMO
      IF(KHL(6,I).EQ.KHL(6,J)) KHL(6,J)=0
  245 CONTINUE
  247 IF(KHL(6,J).GT.KHL(6,MAXI)) MAXI=J
  250 CONTINUE
      KHLS=KHL(5,MAXI)
      L=KHL(4,MAXI)*KHLS
      DO 360 J=1,2*NSYM
      KHL(4,J)=MOD(KHL(4,J)-KHL(5,J)*L,24)
      IF(KHL(4,J).LT.0) KHL(4,J)=24+KHL(4,J)
      KHL(5,J)=KHL(5,J)*KHLS
  360 CONTINUE
      CALL UNPACK(KHL(6,MAXI),LH,LK,LL)
      CALL PAK(N,LH,LK,LL)
      RETURN
      END
      SUBROUTINE EXPA(A,NN,NREF,W,NWMAX,KHL,NK,NTOT,NDIK)
C
C  EXPAND DATA INTO COMPLETE SPHERE, DUMP ON ISCRA
C  CODED REFLEXIONS IN A ARE TRANSFORMED TO STANDARD FORM (MULTAN)
C  PARENT H,K,L + 128 PACKED IN A(5,*)
C  TYPE IN A(4,*)
C  PHASESHIFT IN A(3,*) AND SIGN IN A(2,*)
C  LAST REFLEXION IS DUMMY, TOTAL NUMBER IS NTOT
C  HMAX, KMAX, LMAX ARE INITIALIZED
C  STMAX IS EQUAL TO MAX(1/D**2) VALUE ON EXIT
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX
      INTEGER A(NN,NREF)
      INTEGER W(2,NWMAX)
      DIMENSION KHL(6,NDIK)
      COMMON /COMHAS/ IHAS,NHAS,ITT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      EXTERNAL UNPACK
      IF(NWMAX.LT.1) GOTO 1000
      IF(NK.LT.NN*NSYM) GOTO 1000
      STMAX=0.0
      HMAX=0
      KMAX=0
      LMAX=0
      NW=0
      NTOT=0
C
C  CALCULATE Q-VALUES
C
      DO 500 IR=1,NREF
C
C  UPDATE STMAX
C
      CALL UNPK1(A(5,IR),LH,LK,LL)
      ST=LH*LH*Q(1)+LK*LK*Q(2)+LL*LL*Q(3)
     1 +LH*LK*Q(4)+LK*LL*Q(5)+LL*LH*Q(6)
      STMAX=AMAX1(ST,STMAX)
C
C  GENERATE SYMMETRY EQUIVALENTS AND PHASESHIFTS
C
      CALL EXP1(A(NN,IR),KHL,MAXI,NDIK)
      DO 450 J=1,NSYM
      IF(KHL(6,J).EQ.0) GOTO 420
      CALL UNPACK(KHL(6,J),LH,LK,LL)
      IF(HMAX.LT.IABS(LH)) HMAX=IABS(LH)
      IF(KMAX.LT.IABS(LK)) KMAX=IABS(LK)
      IF(LMAX.LT.IABS(LL)) LMAX=IABS(LL)
C
C  STORE ONE REFLEXION, DUMP BLOCK IF NECESSARY
C
      IT=0
      IF(KHL(5,J).EQ.-1) IT=1
      CALL STR1(LH,LK,LL,IR,KHL(4,J),IT,W,NWMAX,NW,ISCRA)
      NTOT=NTOT+1
C
C  STORE FRIEDEL REFLEXION
C
      CALL STR1(-LH,-LK,-LL,IR,MOD(24-KHL(4,J),24),1-IT,W,
     1 NWMAX,NW,ISCRA)
      NTOT=NTOT+1
  420 CONTINUE
  450 CONTINUE
  500 CONTINUE
C
C  PUT LAST RECORD
C
      CALL STR1(0,0,0,0,0,0,W,NWMAX,NW,ISCRA)
      GOTO 2000
 1000 WRITE(LO,1) NWMAX,NK
    1 FORMAT(//,' Dimension error in expa: NWMAX=,NK=',2I10)
      STOP
 2000 CONTINUE
      WRITE(LO,2) NTOT,HMAX,KMAX,LMAX,STMAX
    2 FORMAT(/,' Number of symmetry dependent reflexions:',I6,/,
     1 ' HMAX=',I5,' KMAX=',I5,' LMAX=',I5,
     2 ' 1/D**2 MAX=',F10.6)
      RETURN
      END
      SUBROUTINE EXPA2(STR,NSTR,STREX,NMAX,KHL,NTOT,NRL,NDIK)
C
C  EXPAND STR INTO COMPLETE SPHERE, RESULT IN STREX
C  REFLEXIONS IN STR ARE TRANSFORMED TO STANDARD FORM (MULTAN)
C  H,K,L + 128 PACKED IN STR(*)
C  TOTAL NUMBER IS NTOT
C  HMAX, KMAX, LMAX ARE INITIALIZED
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX
      INTEGER STR(NSTR),STREX(NMAX)
      DIMENSION KHL(6,NDIK)
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      EXTERNAL UNPACK
      STMAX=0.0
      HMAX=0
      KMAX=0
      LMAX=0
      NTOT=1
      DO 500 IR=1,NSTR
C
C  CALCULATE LENGTH RECIPROCAL VECTOR AND UPDATE STMAX
C
      CALL UNPK1(STR(IR),LH,LK,LL)
      ST=LH*LH*Q(1)+LK*LK*Q(2)+LL*LL*Q(3)
     1 +LH*LK*Q(4)+LK*LL*Q(5)+LL*LH*Q(6)
      STMAX=MAX(ST,STMAX)
  500 CONTINUE
      IF(NRL.EQ.0) THEN
      NRL=STMAX*43
      ENDIF
      DR=NRL/100.0
      STMAX=0.0
      DO 700 IR=1,NSTR
C
C  CHECK LENGTH RECIPROCAL VECTOR AND ONLY EXPAND REFLEXIONS
C  WITH ACCEPTABLE LENGTH
C
C  CALCULATE LENGTH RECIPROCAL VECTOR AND UPDATE STMAX
C
      CALL UNPK1(STR(IR),LH,LK,LL)
      ST=LH*LH*Q(1)+LK*LK*Q(2)+LL*LL*Q(3)
     1 +LH*LK*Q(4)+LK*LL*Q(5)+LL*LH*Q(6)
      IF(ST.LE.DR) THEN
      STMAX=MAX(ST,STMAX)
C
C  GENERATE SYMMETRY EQUIVALENTS AND PHASESHIFTS
C
      CALL EXP1(STR(IR),KHL,MAXI,NDIK)
      DO 450 J=1,NSYM
      IF(KHL(6,J).NE.0) THEN    
      CALL UNPACK(KHL(6,J),LH,LK,LL)
      IF(HMAX.LT.IABS(LH)) HMAX=IABS(LH)
      IF(KMAX.LT.IABS(LK)) KMAX=IABS(LK)
      IF(LMAX.LT.IABS(LL)) LMAX=IABS(LL)
C
C  STORE ONE REFLEXION IN STREX
C
      CALL PAK(IK,LH,LK,LL)
      STREX(NTOT)=IK
      NTOT=NTOT+1
C
C  STORE FRIEDEL REFLEXION
C
      CALL PAK(IK,-LH,-LK,-LL)
      STREX(NTOT)=IK
      NTOT=NTOT+1
      ENDIF    
  450 CONTINUE
      ENDIF
  700 CONTINUE
      NTOT=NTOT-1
      WRITE(LO,2) NTOT,HMAX,KMAX,LMAX,STMAX
    2 FORMAT(' Number of strong symmetry dependent reflexions ',
     1 'used for top row matrix:',I6,/,
     2 ' HMAX=',I5,' KMAX=',I5,' LMAX=',I5,' 1/D**2 MAX= ',F10.5)
      RETURN
      END
      SUBROUTINE FIJPQ(IJP,NIJP,IJQ,NIJQ,IH,IK,IL,REF)
C
C  THIS ROUTINE IDENTIFIES THE INDEPENDENT VARIABLES AND THEIR
C  DEPENDENTS OF REFLECTIONS NOT PRESENT IN THE DATA
C
      INTEGER REF(6,NIJQ)
      DIMENSION IJP(5,NIJQ),IJQ(6,NIJQ),IH(NIJQ),IK(NIJQ),IL(NIJQ)
      NIP=0
      NIQ=0
      I=0
1     CONTINUE
      I=I+1
      IF(I.LT.NIJQ)THEN
      IB=I
      IPHKL=IJQ(5,IB)
      J=IB
      IE=IB
2     CONTINUE
      J=J+1
      IF(J.LE.NIJQ)THEN
      IF(IJQ(5,J).EQ.IPHKL)THEN
      IE=IE+1
      GOTO 2
      ENDIF
      ENDIF
      NIP=NIP+1
      IF(IB.LT.IE)THEN
      CALL SORTJI(IJQ,NIJQ,IB,IE,6)
      CALL UNPK1(IJQ(6,IB),II,IJ,IN)
      CALL RSTRC(MK,II,IJ,IN)
      IRY=IJQ(1,IB)
      IKO=IJQ(2,IB)
      ITO=IJQ(4,IB)
      ISSP=IJQ(3,IB)
      CALL STOREI(IH,IK,IL,IJP,II,IJ,IN,NIP,IRY,IKO,MK)
      DO 6 JJ=1,6
      IJQ(JJ,IB)=0
6     CONTINUE
      DO 4 J=IB+1,IE
      CALL GETSYM(ITO,ISSP,IJQ(4,J),IJQ(3,J),IT,ISS)
      CALL STORED(REF,J-IB,IT,ISS,IJQ(1,J),IJQ(2,J),IRY,IKO)
4     CONTINUE
      DO 5 J=1,IE-IB
      NIQ=NIQ+1
      DO 51 JJ=1,6
      IJQ(JJ,NIQ)=REF(JJ,J)
51    CONTINUE
5     CONTINUE
      ELSE
      CALL UNPK1(IJQ(6,IB),II,IJ,IN)
      CALL RSTRC(MK,II,IJ,IN)
      IRY=IJQ(1,IB)
      IKO=IJQ(2,IB)
      CALL STOREI(IH,IK,IL,IJP,II,IJ,IN,NIP,IRY,IKO,MK)
      ENDIF
      I=IE
      GOTO 1
      ENDIF
      NIJP=NIP
      NIJQ=NIQ
      RETURN
      END
      SUBROUTINE FINHAS(A,B,IB,C,ITEL,ISWIT)
C
C  LOCATE THE ELEMENTS OF B(IB) IN THE HASHTABLE A
C  ISWIT=0 C(IB) CONTAINS LOCATION IN REF ON EXIT
C  ISWIT=1 C(IB) CONTAINS LOCATION, SHIFT AND SIGN
C  ISWIT=2 C(IB) CONTAINS H, K, L AND SHIFT AND SIGN
C  ITEL = OUTPUT = THE NUMBER OF LOCATIONS CHECKED IN ORDER TO FIND
C  ALL ELEMENTS OF B
C  IF B(I) IS NOT FOUND IN A THEN C(I)=0
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER A,B,AJ1,BI1,C,HMAX
      DIMENSION A(2,NHAS),B(2,IB),C(2,IB)
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      ITEL=0
      DO 200 I=1,IB
      INIT=0
      ITEL=ITEL+1
C
C  BI1 PACKED HKL FROM B(I)
C
      BI1=B(2,I)
C
C  HASHFUNCTION
C
      J=MOD(IABS(BI1*IHAS),NHAS)+1
C
C  AJ1 PACKED HKL IN HASHTABLE
C
   10 CONTINUE
      AJ1=A(1,J)
      IF(AJ1.LT.BI1)GOTO 100
      IF(AJ1.EQ.BI1)GOTO 110
C     IF(AJ1-BI1)100,110,90
C
C  CHECK ONE LOCATION DOWN A
C
      ITEL=ITEL+1
      INIT=INIT+1
C     IF(INIT.GT.100) GOTO 100
      IF(INIT.GT.NHAS) GOTO 100
      J=J-1
      IF(J.EQ.0) J=NHAS
      GOTO 10
C
C  AJ1.LT.BJ1 MEANS B(I) IS NOT PRESENT IN A
C
  100 C(2,I)=0
      GOTO 200
C
C  B(I) FOUND IN LOCATION J
C
  110 IHULP=A(2,J)
      IH1=IHULP/65536
      IH2=IHULP-65536*IH1
      IF(ISWIT.EQ.1)GOTO 130
      IF(ISWIT.LT.1)GOTO 120
      GOTO 140
C     IF(ISWIT-1) 120,130,140
  120 C(2,I)=IH2
      GO TO 200
  130 C(2,I)=IH2
      C(1,I)=IH1
      GO TO 200
  140 C(2,I)=AJ1
      C(1,I)=IH1
  200 CONTINUE
      RETURN
      END
      SUBROUTINE GETSYM(ITI,IPHII,ITD,IPHID,IT,ISS)
C
C GET PHASES SHIFT AND SIGN AS THEY SHOULD BE INCLUDED IN IJPQ
C
      IT=(1-2*ITI)*(1-2*ITD)
      ISS=IPHID-IT*IPHII
      IT=(1-IT)/2
      ISS=MOD(ISS,24)
      IF(ISS.LT.0)ISS=ISS+24
      RETURN
      END
      SUBROUTINE LEREF(REF,NN,NREF,POINT,EE,IH,IK,IL)
      IMPLICIT REAL*4 (A-H,O-Z)
      REAL*4 EE
      INTEGER HMAX,POINT(NREF),REF(NN,NREF)
      DIMENSION EE(NREF),IH(NREF),IK(NREF),IL(NREF)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
C
C  The reflections may not be sorted on E on entry 
C  Reflections are in memory already, leref stores them in REF
C  The matrix can then be built
C  CALL TO SORT4 inserted, POINT is then used to get H,K,L and E
C
      CALL SORT4(EE,1,NREF,POINT,NREF,1,1)
      DO 8 IREF=1,NREF
      DO 9 J=1,NN
      REF(J,IREF)=0
9     CONTINUE
      IE=CED*EE(POINT(IREF))+0.5
      REF(1,IREF)=IE
      CALL PAK(REF(5,IREF),IH(POINT(IREF)),IK(POINT(IREF)),
     1 IL(POINT(IREF)))
  8   CONTINUE
      RETURN
      END
      SUBROUTINE LESTR(A,NSTR,REF,NN,NREF)
C
C  The reflections > 1.0 are stored in A
C  BYTE 2, 3, AND 4 OF A(N) CONTAIN H, K, L + 128
C  REF is sorted already and the first NSTR reflections are used
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER REF(NN,NREF)
      INTEGER A,HMAX
      DIMENSION A(NSTR)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      NUMB=NSTR
      DO 100 J=1,NUMB
      E=REF(1,J)
      IF(E.LT.1000)THEN
      NSTR=J-1
      RETURN
      ELSE
      A(J)=REF(5,J)
      ENDIF
  100 CONTINUE
      RETURN
      END
      SUBROUTINE MAINTL(TOPO,SOMRIJ,NM,IBKDIM)
      IMPLICIT REAL*4 (A-H,O-Z)
      REAL*4 TOPO(IBKDIM,IBKDIM),SOMRIJ(IBKDIM),BLCH
      BLCH=0
      DO 1200 I=2,NM
      SOMRIJ(I)=0
      DO 1250 J=1,I-1
      SOMRIJ(I)=SOMRIJ(I)+TOPO(I,J)
 1250 CONTINUE
      BLCH=BLCH+SOMRIJ(I)
 1200 CONTINUE
      BLCH=BLCH*2
      RETURN
      END
      SUBROUTINE MATSOR(SOMRIJ,POINT,A,IBKDIM)
C
C  QUICKSORT
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER POINT(IBKDIM)
      INTEGER N,I,J,SP,MID,LEFT(20),RIGHT(20)
      REAL*4 SOMRIJ(IBKDIM),A(IBKDIM),PIVOT
      LOGICAL*1 JA,NEE,JAA,NEEE
      N=IBKDIM
      DO 1000 I=1,IBKDIM
      A(I)=SOMRIJ(I)
      POINT(I)=I
 1000 CONTINUE
      LEFT(1)=1
      RIGHT(1)=N
      SP=1
   10 CONTINUE
      IF(LEFT(SP).LT.RIGHT(SP)) THEN
      I=LEFT(SP)
      J=RIGHT(SP)
      PIVOT=A(J)
      MID=(I+J)/2
      IF((J-I).GE.6) THEN
      JA=PIVOT.LT.A(I)
      NEE=PIVOT.GT.A(MID)
      JAA=PIVOT.GT.A(I)
      NEEE=PIVOT.LT.A(MID)
      IF((JA.AND.NEEE).OR.(JAA.AND.NEE)) THEN
      JA=A(I).GT.A(MID)
      NEE=A(I).LT.PIVOT
      JAA=A(I).LT.A(MID)
      NEEE=A(I).GT.PIVOT
      IF((JA.AND.NEEE).OR.(JAA.AND.NEE)) THEN
      CALL SWAP(MID,J,A,POINT,IBKDIM)
      ELSE
      CALL SWAP(I,J,A,POINT,IBKDIM)
      ENDIF
      PIVOT=A(J)
      ENDIF
      ENDIF
   50 CONTINUE
      IF(I.GE.J) GOTO 110
   60 CONTINUE
      IF(A(I).LE.PIVOT) GOTO 70
      I=I+1
      GOTO 60
   70 J=J-1
   80 CONTINUE
      IF(.NOT.((I.LT.J).AND.(PIVOT.GT.A(J)))) GOTO 90
      J=J-1
      GOTO 80
   90 CONTINUE
      IF(I.LT.J) CALL SWAP(I,J,A,POINT,IBKDIM)
      GOTO 50
  110 J=RIGHT(SP)
      CALL SWAP(I,J,A,POINT,IBKDIM)
      IF((I-LEFT(SP)).LT.(RIGHT(SP)-I)) THEN
      LEFT(SP+1)=LEFT(SP)
      RIGHT(SP+1)=I-1
      LEFT(SP)=I+1
      ELSE
      LEFT(SP+1)=I+1
      RIGHT(SP+1)=RIGHT(SP)
      RIGHT(SP)=I-1
      ENDIF
      SP=SP+1
      ELSE
      SP=SP-1
      ENDIF
      IF(SP.GT.0) GOTO 10
      RETURN
      END
      SUBROUTINE MATSUB(A,B,C,D,E,IA,ISWIT)
C
C  ISWIT=-1 SUBTRACT B,C FROM A, STORE IN D,E A IS COMPLEX
C  ISWIT=+1 ADD B,C TO A INSTEAD STORE IN D,E
C  OVERWRITING OF C,D IS ALLOWED
C  ON EXIT A IS UNCHANGED
C
      IMPLICIT REAL*4 (A-H,O-Z)
      COMPLEX A
      DIMENSION A(IA,IA),B(IA,IA),C(IA,IA),D(IA,IA),E(IA,IA)
      DO 10 J=1,IA
      DO 20 I=1,IA
      G=REAL(A(I,J))
      H=AIMAG(A(I,J))
      D(I,J)=G+ISWIT*B(I,J)
      E(I,J)=H+ISWIT*C(I,J)
   20 CONTINUE
   10 CONTINUE
      RETURN
      END
      SUBROUTINE MATTL2(IBKDIM,TOPO,SOMRIJ)
      IMPLICIT REAL*4 (A-H,O-Z)
      REAL*4 TOPO(IBKDIM,IBKDIM),SOMRIJ(IBKDIM*2)
      REAL*4 SOMH
      DO 1200 I=1,IBKDIM
      SOMRIJ(I+IBKDIM)=0.0
      SOMH=1.0
      DO 1250 J=1,IBKDIM
      SOMRIJ(I+IBKDIM)=SOMRIJ(I+IBKDIM)+TOPO(I,J)
      SOMH=SOMH*((TOPO(I,J)/SOMH)**(1.0/FLOAT(J)))
 1250 CONTINUE
      SOMRIJ(I)=(INT(SOMH*1000))/1000
 1200 CONTINUE
      RETURN
      END
      SUBROUTINE MINMA2(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS,KT,JT,MAXEEN,
     1 MINEEN,NEXTMAX,NEXTMIN,VORJT,VORKT,STOP,WISUIT,VORMIN)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER KOLPOS,NM,WISSEL,NEXTMAX,NEXTMIN,VORJT,VORKT,STOP,WISUIT
      REAL*4 TOPO(IBKDIM,IBKDIM),SOMRIJ(IBKDIM),MAXEEN,MINEEN,VORMIN
      INMIN=0
      INMAX=0
      WISUIT=0
C
C  DETERMINE IN BLOCK ROW WITH SMALLEST DENSITY (KT)
C
      MINEEN=1000000
      DO 100 KT=KOLPOS,KOLPOS+NM-1
      IF (SOMRIJ(KT).LT.MINEEN) THEN
      MINEEN=SOMRIJ(KT)
      WISSEL=KT
      END IF
  100 CONTINUE
      KT=WISSEL
C
C  DETERMINE OUTSIDE BLOCK ROW WITH LARGEST DENSITY (JT)
C
      MAXEEN=0
      DO 200 JT=KOLPOS+NM,IBKDIM
      IF (SOMRIJ(JT)/TOPO(JT,KT)**(1.0/FLOAT(NM)).GT.MAXEEN) THEN
      MAXEEN=SOMRIJ(JT)/TOPO(JT,KT)**(1.0/FLOAT(NM))
      WISSEL=JT
      ELSE
C
C  LOOK FOR ROWS WITH SAME MAXIMUM BUT WITH A SMALLER VALUE
C  ON THE CROSSELEMENT
C  IF FOUND TAKE THIS ROW AS SWAP-ROW
C  SWAPPING HIGH CROSSELEMENTS TO THE SCOPE IS CONSIDERED TO
C  BE UNFAVOURABLE FOR THE OPTIMIZATION PROCESS
C
      IF ((SOMRIJ(JT)/TOPO(JT,KT)**(1.0/FLOAT(NM))).EQ.MAXEEN) THEN
      IF (TOPO(JT,KT).LT.TOPO(WISSEL,KT)) THEN
      WISSEL=JT
      END IF
      END IF
      END IF
  200 CONTINUE
      JT=WISSEL
C
C  LOOPING WILL TAKE PLACE IF:
C  1) MAXEEN-MINEEN= 0 (NO INCREASE OF DENSITY IN BLOCK)
C  2) MAXEEN AND MINEEN ARE THE SAME AS LAST TIME
C  (VORMIN HAS THE SAME VALUE)
C  3) KT IS THE SAME AS LAST TIME (VORKT) AND JT IS THE SAME
C  AS ONE ALREADY SWAPPED WITH KT
C  4) JT IS THE SAME AS LAST TIME
C
      IF((MINEEN.EQ.VORMIN).AND.(MAXEEN-MINEEN.EQ.0)
     1 .AND.(((KT.EQ.VORKT).AND.(JT.LE.VORJT))
     2 .OR.(JT.EQ.VORJT))) THEN
C
C  LOOK FOR A DIFFERENT JT TO STOP LOOPING
C
      DO 210 IT=KOLPOS+NM,IBKDIM
      IF((SOMRIJ(IT)/TOPO(JT,KT)**(1.0/FLOAT(NM)).EQ.MAXEEN)
     1 .AND.(IT.GT.VORJT).AND.(INMAX.EQ.0))THEN
      NEXTMAX=IT
      INMAX=1
      END IF
  210 CONTINUE
      IF (INMAX.EQ.1) THEN
      JT=NEXTMAX
      ELSE
C
C  LOOK FOR DIFFERENT KT IN THE CASE A DIFFERENT JT CAN NOT BE FOUND
C  THE NEW KT MUST HAVE THE SAME DENSITY
C  BY TAKING A NEW KT THE CROSSELEMENTS ARE CHANGING
C  MAXEEN MUST STILL BE LARGER THAN MINEEN
C
      DO 110 IT=KOLPOS,KOLPOS+NM-1
      IF ((SOMRIJ(IT).EQ.MINEEN).AND.(IT.GT.NEXTMIN).AND.(IT.NE.KT).
     1 AND.(INMIN.EQ.0).AND.(SOMRIJ(JT)/TOPO(JT,KT)**(1.0/FLOAT(NM))
     2 .EQ.MAXEEN))THEN
      NEXTMIN=IT
      INMIN=1
      END IF
  110 CONTINUE
      ENDIF
      IF (INMIN.EQ.1) THEN
      KT=NEXTMIN
      WISUIT=1
      ELSE
      IF (INMAX.EQ.0) THEN
      STOP=1
C     WRITE(IP,*)'OPTIMALISATIONSTOP BECAUSE OF LOOPING ( NO ERROR!)'
      ENDIF
      ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE MMTRX(A,EMX,
     1 IJP,NIJP,IJQ,NIJQ,IH,IK,IL,
     1 IJPN,NIJPN,IJQN,NIJQN,IHN,IKN,ILN,
     1 IJPO,NIJPO,IJQO,NIJQO,IHO,IKO,ILO,
     2 REF,NN,NREF,HAS,W,W1,POINT,KHL,
     2 EGEM,RESO,NDIK)
C
C  PARAMETERS:
C
C  A(NMX) = INPUT =
C  ARRAY CONTAINING H, K, L + 128 OF TOP ROW IN BYTES 2, 3, 4 IN A(*,I)
C
C  NMX = INPUT = THE ORDER OF ANY MATRIX AS WELL
C  AS THE FIRST DIMENSION OF A
C
C  EMX(NMX,NMX) = OUTPUT =
C  MATRIX OF E-VALUES. NOT OBSERVED REFLEXIONS ARE ZERO
C
C  GEW(NMX,NMX) = OUTPUT =
C  RELIABILTY OF PHASES READ IN LEREF
C
C  IH,IK,IL = OUTPUT = THE INDICES OF THE INDEPENDENT OBSERVED 
C  REFLECTIONS IN THE MATRIX
C
C  IJP = OUTPUT =
C  ARRAY CONTAINING: ROW (IRY) AND  COLUMN (ICO) OF THE
C  INDEPENDENT VARIABLES. IRY > ICO ALWAYS
C  INFORMATION ON THE SYMMETRY DEPENDENTS (IBE AND IEI)
C  AND THE PHASE RESTRICTION (MK) 
C
C  THE ARRAY IJP(I,*) IS CONFIGURATED AS FOLLOWS
C
C  I=1  IRY
C  I=2  ICO
C  I=3  IBE
C  I=4  IEI
C  I=5  MK
C
C  IBE: BEGIN OF RELATIONS OF THIS REFLEXION IN IJQ
C  IEI: LAST OF THE DEPENDENTS OF THIS REFLEXION
C  IEI=0: NO RELATIONS
C  MK: THE PHASE IS RESTRICTED TO 15*(MK-1) (+PI) UNLESS MK=1
C
C  NIJP = OUTPUT = DIMENSION OF IJP
C
C  IJQ  = OUTPUT =
C  ARRAY CONTAINING INFORMATION DESCRIBING THE PHASE-RELATIONS
C
C  THE FORMAT OF IJQ(I,*) IS:
C
C  I=1  I1
C  I=2  J1
C  I=3  I2
C  I=4  J2
C  I=5  IS
C  I=6  IT
C  I1, J1 ARE THE MATRIX COORDINATES OF THE DEPENDENT
C  I2, J2 ARE THE COORDINATES OF THE PARENT REFLEXION
C  IS AND IT DEFINE THE PHASE RELATION
C  NOTE: NOT OBSERVED ARE NOT STORED IN IJP AND IJQ
C
C  NIJQ = OUTPUT = DIMENSION OF IJQ
C
C  THE SAME STRUCTURE IS GENERATED FOR NOT OBSERVED REFLECTIONS
C  WITHIN THE RESOLUTION SPHERE (IJPN, IJQN, ETC.) AND FOR REFLECTIONS
C  OUTSIDE OF IT (IJPO, IJQO ETC.)
C
C  REF = INPUT = PARENT REFLEXION LIST
C
C  NN,NREF = INPUT = DIMENSIONS OF REF
C
C  HAS = INPUT = HASHTABLE
C
C  W(NMX), W1(NMX*(NMX-1)/2) AND KHL(6,NSYM) ARE SCRATCH ARRAYS
C
C  ITAPE = INPUT = SCRATCH TAPE
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX,A(NMX)
      INTEGER EIJP(4),EIJQ(4),POINT(NIJP)
      INTEGER REF(NN,NREF),HAS(2,1),W(2,NMX),W1
      DIMENSION EMX(NMX,NMX),IH(NIJP),IK(NIJP),IL(NIJP),
     1 IJP(5,NIJP),IJQ(6,NIJQ),W1(2,NMX),KHL(6,NDIK)
      DIMENSION IJPN(5,NIJP),IJQN(6,NIJQ),IHN(NIJP),IKN(NIJP),ILN(NIJP)
      DIMENSION IJPO(5,NIJP),IJQO(6,NIJQ),IHO(NIJP),IKO(NIJP),ILO(NIJP)
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      INCLUDE '../common/detpar.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      STLMIT=1.0/(RESO*RESO)
      MAGN=0
      M128=8421504
      PI=3.14159265
      PIR=PI/180.0
      NSTT=0
C
C  LOCATE IDENTITY OPERATION
C
      IEEN=0
      DO 5 I=1,NSYM
      DO 3 J=1,3
      IF(IS(1,J,I).NE.J) GOTO 5
      IF(IS(2,J,I).NE.0) GOTO 5
      IF(ABS(TS(J,I)).GT.0.001) GOTO 5
    3 CONTINUE
      IEEN=I
      GOTO 6
    5 CONTINUE
    6 IF(IEEN.NE.0) GOTO 7
      WRITE(LO,1)
    1 FORMAT(' MMTRX :  NO IDENTITY OPERATION')
      STOP
    7 CONTINUE
      CCED=1.0/CED
C
C  INITIALIZE EMX
C
      EGEMT=0.0
C
C
C  LOOP OVER THE ROWS
C
      EGEM=0.0
      DO 100 I=2,NMX
      JMAX=I-1
C
C  PUT ROW I IN W
C
      DO 10 J=1,JMAX
   10 W(2,J)=A(J)-A(I)+M128
C
C  LOCATE REFLEXIONS IN REF
C
      CALL FINHAS(HAS,W,JMAX,W,ITEL,1)
C
C  INITIALIZE ROW I IN EMX AND PMX
C
      DO 30 J=1,JMAX
      ILOC=W(2,J)
C
C  REFLEXION NOT OBSERVED
C
      IF(ILOC.NE.0) THEN   
C
C  DECODE E-VALUE
C
      EMX(I,J)=CCED*REF(1,ILOC)
      EGEM=EGEM+EMX(I,J)
C      IF(EMX(I,J).LT.1.5)EMX(I,J)=0.0
      EMX(J,I)=EMX(I,J)
      ELSE   
      EMX(I,J)=0.0
      EMX(J,I)=0.0
      ENDIF
   30 CONTINUE
  100 CONTINUE
      EGEM=EGEM/((NMX**2-NMX)/2)
C
C  INITIALIZE IJP AND IJQ
C
      NIJP=0
      NIJQ=0
      NIJPN=0
      NIJQN=0
      NIJPO=0
      NIJQO=0
C
C  CLEAR REF, EXCEPT REFLEXION TYPE, PHASE SHIFT, PHASE AND WEIGHT
C  PUT TYPE IN BYTE 6
C
      DO 110 I=1,NREF
      DO 110 J=1,5
      REF(J,I)=0
110   CONTINUE
C
C  LOOP OVER THE ROWS
C
      DO 200 I=2,NMX
      JMAX=I-1
C
C  DETERMINE ROW J
C
      DO 120 J=1,JMAX
      MN=M128+A(J)-A(I)
  120 W(2,J)=MN
      CALL FINHAS(HAS,W,JMAX,W1,ITEL,1)
      DO 140 J=1,JMAX
C
C  GET LOCATION IN REF
C
      ILOC=W1(2,J)
C
C  CALCULATE PHASE RESTRICTION
C
      CALL UNPK1(W(2,J),II,IJ,IN)
      CALL RSTRC(MK,II,IJ,IN)
C
C  MK=0: FORBIDDEN REFLEXION, SET E=0 AND DO NOT STORE
C
      IF(ILOC.EQ.0) THEN    
      IF(MK.EQ.0)THEN
      EMX(I,J)=0.0
      MAGN=MAGN+1
C
C  FORBIDDEN REFLECTION, INTIALIZED TO ZERO
C
      ELSE
C
C  REFLECTION NOT UNOBSERVED AND NOT FORBIDDEN, DETERMINE RESOLUTION
C
      ST=II*II*Q(1)+IJ*IJ*Q(2)+IN*IN*Q(3)
     1 +II*IJ*Q(4)+IJ*IN*Q(5)+IN*II*Q(6)
C
C  STORE PACKED HKL OF MULTAN PARENT AND ORGINAL, STORE PHASE CHANGE AND
C  SIGN, ROW AND COLUMN IN THE MATRIX (IJQ).
C
      MN=W(2,J)
      CALL EXP2(MN,KHL,MAXI,NDIK)
      IF(ST.GT.STLMIT)THEN
      NIJQO=NIJQO+1
      CALL STOREU(IJQO,NIJQO,I,J,KHL,MN,W(2,J),NDIK)
      ELSE
      NIJQN=NIJQN+1
      CALL STOREU(IJQN,NIJQN,I,J,KHL,MN,W(2,J),NDIK)
      ENDIF
      ENDIF
      ELSE 
      KM=REF(3,ILOC)
C
C  REFLEXION FOUND IN HASHTABLE
C
C  GET ROW AND COLUMN NUMBER
C  GET SIGN AND PHASESHIFT
C  IF KM=0 THEN A NEW INDEPENDENT REFLEXION IS FOUND
C
      JUNP=W1(1,J)
      ITW=JUNP/64
      ISW=JUNP-64*ITW
      IF(KM.NE.0)THEN    
C
C  SYMMETRY DEPENDENT IS FOUND
C  CALCULATE PHASE SHIFT WITH RESPECT TO PARENT
C
      ITR=REF(1,ILOC)
      ISR=REF(2,ILOC)
C
C  GET SIGN AND PHASE SHIFT
C
      CALL GETSYM(ITR,ISR,ITW,ISW,IT,ISS)
      I2=REF(3,ILOC)
      J2=REF(4,ILOC)
      NIJQ=NIJQ+1
C
C  PUT SPECIFICATION OF RELATION IN IJQ
C
      CALL STORED(IJQ,NIJQ,IT,ISS,I,J,I2,J2)
      ELSE    
      NIJP=NIJP+1
C
C  NEW REFLEXION, PUT SPECIFICATION IN REF AND IJP, STORE INDICES
C
      CALL STOREI(IH,IK,IL,IJP,II,IJ,IN,NIJP,I,J,MK)
C
C  STORE ROW, COLUMN, PHASESHIFT AND SIGN IN REF
C
      REF(1,ILOC)=ITW
      REF(2,ILOC)=ISW
      REF(3,ILOC)=I
      REF(4,ILOC)=J
      ENDIF
      ENDIF
  140 CONTINUE
  200 CONTINUE
C
C  SORT IJQ AND STORE IBE AND IEI IN IJP
C
      IF(NIJP.NE.0)THEN
      CALL SIJPQ(IJP,IJQ,NIJP,NIJQ,EIJP,EIJQ,POINT)
      ENDIF
      IF(NIJQO.NE.0)THEN
C
C NOW DEAL WITH IJPO ETC. SORT ON PACKED MULTAN PARENT
C CONSTRUCT IJP AND IJQ FOR BOTH REFLECTIONS OUTSIDE AND INSIDE THE
C RESOLUTION SPHERE.
C
      CALL SORT1(IJQO,6,NIJQO,NIJQO,5)
C
C FIRST IDENTIFY ORGINAL AND ITS DEPENDENTS
C
      CALL FIJPQ(IJPO,NIJPO,IJQO,NIJQO,IHO,IKO,ILO,REF)
C
C NEXT SORT IJPO ON ENTRIES IN THE MATRIX
C
      CALL SORTIJ(IJPO,NIJPO,1,NIJPO,POINT,5)
C
C FINALLY RESORT IHO ETC AND REPEAT THE PROCEDURE FOR THE N REFLECTIONS
C
      CALL SWAPH(IHO,IKO,ILO,POINT,W,NIJPO)
C
C THEN SORT IJQO AS USUAL
C
      CALL SIJPQ(IJPO,IJQO,NIJPO,NIJQO,EIJP,EIJQ,POINT)
      ENDIF
      IF(NIJQN.NE.0)THEN
      CALL SORT1(IJQN,6,NIJQN,NIJQN,5)
      CALL FIJPQ(IJPN,NIJPN,IJQN,NIJQN,IHN,IKN,ILN,REF)
      CALL SORTIJ(IJPN,NIJPN,1,NIJPN,POINT,5)
      CALL SWAPH(IHN,IKN,ILN,POINT,W,NIJPN)
      CALL SIJPQ(IJPN,IJQN,NIJPN,NIJQN,EIJP,EIJQ,POINT)
      ENDIF
C
C  FILL DIAGONAL WITH E0
C
      DO 910 I=1,NMX
      EMX(I,I)=E0
  910 CONTINUE
      RETURN
      END
      SUBROUTINE MXFILL(MX,NM,STREX,NSTREX,NGRID)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER MX(NM+1),STREX(NSTREX)
      M128=8421504
C
C  FIRST ELEMENT IS E000
C
      NHALF=NM/2
      DO 200 J=1,NGRID-1
      DO 300 K=J+1,NGRID
      MX(1)=M128
      DO 250 JL=1,NHALF
      MX(JL+1)=STREX((J-1)*NHALF+JL)
  250 CONTINUE
      DO 350 KL=1,NHALF
      MX(NHALF+KL+1)=STREX((K-1)*NHALF+KL)
  350 CONTINUE
  300 CONTINUE
  200 CONTINUE
      RETURN
      END
      SUBROUTINE OPMATG(MX,NM,STR,STREX,REF,NN,HAS,W,NSTR,NSTREX,
     1 NREF,IFIRST,MCORE,CORE,JFIRST,NR,B,IBK,ICRI,
     2 ICRA,ICRB,NOTF)
C
C  PARAMETERS:
C
C  MX(NM) = INPUT/OUTPUT = FIRST ROW (HKL IN PACKED FORM)
C  H, K, L + 128 IN THREE BYTES
C  NM = INPUT = FIRST DECLARED DIMENSION OF MX = DIMENSION KH-MATRIX
C  STR: MULTAN REFLEXIONS = INPUT = INDEPENDENT STRONG REFLEXIONS
C  NSTR: DIMENSION STR = INPUT = NUMBER OF STRONG REFLEXIONS
C  STREX: ALL SYMMETRY DEPENDENT STRONG REFLEXIONS
C  NSTREX: DIMENSION STREX = INPUT = TOTAL NUMBER OF STRONG REFLEXIONS
C  (TOP ROW QUALITY MATRIX)
C  REF: REFLEXION LIST = INPUT = COMPLETE REFLEXION FILE
C  NREF: DIMENSION OF REF = INPUT = NUMBER OF REFLEXIONS
C  HAS: = INPUT = HASH TABLE
C  MCORE: MAXIMUM AVAILABLE CORE (INTEGER)
C  NR: MAXIMUM AVAILABLE CORE (REAL)
C  LO: PRINTER
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER CORE(MCORE),HMAX
      INTEGER REF(NN,NREF),HAS(2,1)
      INTEGER STR(NSTR),STREX(NSTREX),W(2,NSTR)
      DIMENSION MX(NM),B(NR)
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
C
C  LOCATE STRONG REFLEXIONS
C
      DO 2222 I=1,NSTR
2222  W(2,I)=STR(I)
C
      CALL FINHAS(HAS,W,NSTR,W,ITEL,0)
C
      DO 220 I=1,NSTR
C
C  LOCATION IN REF
C
      ILOC=W(2,I)
      IF(ILOC.NE.0) GOTO 220
      WRITE(LO,214)
      CALL PRIHKL(STR(I),1,LO)
      STOP
  214 FORMAT(' OPMATG: REFLEXION NOT IN HASHTABLE'
     1 /,' FATAL ERROR')
  220 CONTINUE
C
      IP=LO
C
      CALL BLOCK(CORE,IFIRST,MCORE,B,JFIRST,NR,REF,STREX,
     1 NREF,NSTREX,HAS,NM,MX,IP,IBK,ICRI,
     2 ICRA,ICRB,NN,NOTF)
C
      RETURN
      END
      SUBROUTINE OPTHAS(A,N,W,IW,ITAPE,ITEL,ITELM,IFAIL)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER A,W,HMAX
      DIMENSION A(2,NHAS),W(2,IW)
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
C
C  OPTIMIZE HASHTABLE
C  IT = INPUT = NUMBER OF ITERATIONS
C  IFAIL=0: A CONTAINS HASHTABLE
C  IFAIL=1: TRY OTHER VALUES FOR IHAS, NHAS OR IT
C  N = INPUT = NUMBER OF REFLEXIONS ON ITAPE
C  ITAPE MUST HAVE BLOCKS OF LENGTH IW (MULTAN FILE)
C  W: SCRATCH ARRAY
C  ITELM = INPUT = MAXIMUM ALLOWED NUMBER OF CHECKS IN HASHTABLE BEFORE
C  HIT; DEFAULT IS THEORETICAL VALUE
C  ITEL ACTUAL NUMBER OF CHECKS
C  ITEL>ITELM FOR ALL ITERATIONS: IFAIL=1
C  IA = INPUT = MAXIMUM DIMENSION OF A
C  IT=1: NO OPTIMIZATION
C
C  CALCULATE DEFAULTS
C
      IF(IHAS.EQ.0) IHAS=123456789
C
C  CHECK DIMENSION OF A
C
      NHASM=NHAS
      MITEL=ITELM
      MMITEL=ITELM
      MINI=1000*NHAS
      IFAIL=1
      DO 100 I=1,IT
C
C  DEFAULT ITELM
C
      IF(ITELM.EQ.0) MITEL=(1+1.0/(1.0-FLOAT(N)/FLOAT(NHAS)))*N+1
      CALL STOHAS(A,N,W,IW,ITAPE,ITEL,MITEL,IFA)
C     WRITE(LO,3) NHAS,ITEL,ITELM,IFA
      IF(IFA.EQ.0) IFAIL=0
      IF(MINI.LE.ITEL) GOTO 50
      NHASM=NHAS
      MINI=ITEL
      IF(ITELM.EQ.0) MMITEL=MITEL
   50 NHAS=NHAS-1
  100 CONTINUE
C
C  STORE HASH TABLE
C
      IF (NHAS.EQ.NHASM) GOTO 200
      NHAS=NHASM
      CALL STOHAS(A,N,W,IW,ITAPE,ITEL,MMITEL,IFA)
C
C  PRINT RESULT
C  CALCULATE NUMBER OF PROBES/REFLEXION
C  THEORY
C
  200 CONTINUE
      X=(1.0+1.0/(1.0-FLOAT(N)/FLOAT(NHAS)))/2.0
C
C  ACTUAL
C
      Y=FLOAT(ITEL)/FLOAT(N)
      WRITE(LO,2) N,IHAS,NHAS,IT,ITEST,X,Y
    2 FORMAT(' OPTHAS: Hashtable complete for',I7,' reflections',/,
     1 ' Hash constants:',/
     2 ' IHAS=',I10,' NHAS=',I10,' IT=',I5,' ITEST=',I5/,
     3 ' Average number of probes/refl:',/,
     4 ' Theoretical:',F10.4,' Actual:',F10.4)
      IF(IFA.EQ.0) GOTO 999
      WRITE (LO,1)
    1 FORMAT(' OPTHAS : Unsuccessful run')
      STOP
  999 CONTINUE
      RETURN
      END
      SUBROUTINE OPTIMA(IBKDIM,TOPO,SOMRIJ,NM,STREX,NSTREX)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER STREX(NSTREX)
      INTEGER NM,KOLPOS,AANIT,STOP,MATNUM
      REAL*4 TOPO(IBKDIM,IBKDIM),SOMRIJ(IBKDIM*2),BLOK(50)
      KOLPOS=1
      CALL EENTL2(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS)
      STOP=0
      AANIT=0
      CALL RIJSORT(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS,
     1 AANIT,STOP,STREX,NSTREX)
      MATNUM=1
      CALL BLOKTEL(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS,BLOK,MATNUM)
C     WRITE(IP,*) '    '
C     WRITE(IP,11) AANIT
C  11 FORMAT(' NUMDER OF ITERATIONS FOR FINAL OPTIMIZATION= ',I5)
C     WRITE(IP,12) BLOK(1)/(NM**2-NM)
C  12 FORMAT(' BEST BLOCK IN QUALITY MATRIX NOW HAS DENSITY',F10.5)
      RETURN
      END
      SUBROUTINE OPWIS(IBKDIM,TOPO,NM,OPBLOK,SOMRIJ,STREX,
     1 NSTREX)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER STREX(NSTREX)
      INTEGER NM,OPBLOK,HULP
      REAL*4 TOPO(IBKDIM,IBKDIM),SOMRIJ(IBKDIM*2),HULPR
C     WRITE(IP,*) '   '
      IF(OPBLOK.NE.1) THEN
      DO 100 JT=1,NM
      KT=(OPBLOK-1)*NM+JT
      HULP=STREX(KT)
      STREX(KT)=STREX(JT)
      STREX(JT)=HULP
      DO 1500 IT=1,IBKDIM
      HULPR=TOPO(KT,IT)
      TOPO(KT,IT)=TOPO(JT,IT)
      TOPO(JT,IT)=HULPR
 1500 CONTINUE
      DO 1600 IT=1,IBKDIM
      HULPR=TOPO(IT,KT)
      TOPO(IT,KT)=TOPO(IT,JT)
      TOPO(IT,JT)=HULPR
 1600 CONTINUE
  100 CONTINUE
      ENDIF
      CALL OPTIMA(IBKDIM,TOPO,SOMRIJ,NM,STREX,NSTREX)
      RETURN
      END
      SUBROUTINE PRIHKL(A,N,LO)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER A(N)
      DIMENSION LINE(30)
      WRITE(LO,1)
      IEI=0
   10 IF(IEI.EQ.N) GOTO 100
      IBE=IEI+1
      IEI=MIN0(IBE+4,N)
      K=1
      DO 20 I=IBE,IEI
      CALL UNPK1(A(I),LINE(K),LINE(K+1),LINE(K+2))
      K=K+3
   20 CONTINUE
      K=K-1
      WRITE(LO,1) (LINE(I),I=1,K)
      GOTO 10
    1 FORMAT(' ',5(3I3,2X))
  100 RETURN
      END
      SUBROUTINE PRIJPQ(IJP,NIJP,IJQ,NIJQ,IPRIJP)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX
      DIMENSION IJP(5,NIJP),IJQ(6,NIJQ)
      COMMON /COMHAS/ IHAS,NHAS,ITT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      CHARACTER IT,TEKEN(2)
      DATA TEKEN /'+','-'/
      IF(IPRIJP.GT.0) WRITE(LO,1)
    1 FORMAT(10X,'I',3X,'J',
     1 4X,'IB',4X,'IE',3X,'MK',
     2 7X,10X,
     3 'I1',3X,'J1',1X,
     4 2X,'I2',3X,'J2',
     5 3X,'PS',3X,'IT',/)
      I=0
   10 I=I+1
      J=0
      IF(I.GT.NIJP.AND.I.GT.NIJQ) GOTO 100
      IF(I.LE.NIJP) THEN   
      J=J+1
      IP=IJP(1,I)
      JP=IJP(2,I)
      IB=IJP(3,I)
      IE=IJP(4,I)
      MK=IJP(5,I)
      ENDIF
      IF(I.LE.NIJQ) THEN   
      J=J+2
      IQ1=IJQ(1,I)
      JQ1=IJQ(2,I)
      IQ2=IJQ(3,I)
      JQ2=IJQ(4,I)
      ISS=IJQ(5,I)
      ITC=IJQ(6,I)
      IT=TEKEN(1+ITC)
      ENDIF
      If(J.EQ.3)THEN
      IF(IPRIJP.GT.I)THEN
      WRITE(LO,2) I,IP,JP,IB,IE,MK,
     1 IQ1,JQ1,IQ2,JQ2,ISS,IT
    2 FORMAT(1X,I5,')',2I4,2I6,I5,14X,5I5,4X,A1)
      ENDIF
      GOTO 10
      ENDIF
      IF(J.EQ.2)THEN
      IF(IPRIJP.GT.I)THEN
      WRITE(LO,3) I,IQ1,JQ1,IQ2,JQ2,ISS,IT
      ENDIF
      Go TO 10
      ENDIF
    3 FORMAT(1X,I5,')',39X,5I5,4X,A1)
      IF(J.EQ.1)THEN
      IF(IPRIJP.GT.I)THEN
      WRITE(LO,2) I,IP,JP,IB,IE,MK
      ENDIF
      GOTO 10
      ENDIF
  100 CONTINUE
      RETURN
      END
      SUBROUTINE PRIREF(A,N)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER A
      INTEGER H,HMAX
      DIMENSION A(6,N),H(10),K(10),L(10),IE(10)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /COMHAS/ IHAS,NHAS,ITT,ITEST
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      WRITE(LO,1) N
    1 FORMAT(' ',I5,' REFLECTIONS')
      M=0
    5 CONTINUE
      IT=0
      DO 10 I=1,10
      M=M+1
      IF(M.GT.N) GOTO 100
      IT=IT+1
      IE(I)=A(1,M)
      CALL UNPK1(A(5,M),H(J),K(J),L(J))
   10 CONTINUE
  100 CONTINUE
      IF(IT.NE.0)
     1 WRITE(LO,2) (H(J),K(J),L(J),IE(J),J=1,IT)
    2 FORMAT(1X,10(3I3,I4))
      IF(IT.EQ.10) GOTO 5
      RETURN
      END
      SUBROUTINE PRMX2(MX,NM,EMX,IPRINT)
      IMPLICIT REAL*4 (A-H,O-Z)
C
C  PARAMETERS:
C
C  MX(NM) = INPUT = FIRST ROW OF MATRICES
C  H, K, L + 128 IN BYTE 2, 3, 4
C  NM = INPUT = FIRST DECLARED DIMENSION OF MX
C  EMX(NM,NM) = INPUT = E-VALUES, ONLY LOWER TRIANGLE REQUIRED
C  PMX(NM,NM) = INPUT = INPUT PHASES (NHKLF=1)
C  GEW(NM,NM) = INPUT = WEIGHTS OF THE PHASED REFLECTIONS (NHKLF=1)
C  IPRINT     = INPUT = 0 Write file Ifdet only   
C                     > 1 Print Iprint rows of lowertriangle as well
C
      INTEGER HMAX
      DIMENSION LINE(30)
      DIMENSION MX(NM)
      DIMENSION EMX(NM,NM)
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      M128=8421504
      PIR=3.14159265/180
      IF(IPRINT.GE.1)THEN
      WRITE(LO,301) NM
       ENDIF
  301 FORMAT(' MATRIX OF ORDER',I5)
C
C  LOOP OVER ROWS
C
      DO 200 I=1,NM
      IEI=0
      IBE=IEI+1
      IF(IBE.GT.I)GOTO 200
      IEI=MIN0(I,IBE+4)
      K=1
      DO 100 J=IBE,IEI
      IH=M128+MX(J)-MX(I)
      CALL UNPK1(IH,LINE(K),LINE(K+1),LINE(K+2))
      K=K+3
  100 CONTINUE
      K=K-1
      IF(IPRINT.GE.I.AND.IPRINT.NE.0)THEN
      WRITE(LO,1) I,(LINE(J),J=1,K)
      ENDIF
C
C  THE E-VALUES
C
      K=0
      DO 150 J=IBE,IEI
      K=K+1
      IF(J.LT.I) THEN    
      LINE(K)=100*EMX(I,J)+SIGN(0.5,EMX(I,J))
      ELSE
      LINE(K)=100*EMX(J,I)+SIGN(0.5,EMX(J,I))
      ENDIF
  150 CONTINUE
      IF(IPRINT.GE.I.AND.IPRINT.NE.0)THEN
      WRITE(LO,2) (LINE(J),J=1,K)
      ENDIF
  200 CONTINUE
      RETURN
    1 FORMAT(I4,')',5(2x,3I5))
    2 FORMAT(10X,5(I5,6X))
      END
      SUBROUTINE RESERV(IFIRST,JFIRST,IBKDIM,LOCTO,
     1 LOCPO,LOCSR,LOCA,LOCHU,LOCHR)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER LOCTO,LOCPO,LOCSR,LOCA,LOCHU,LOCHR
      INTEGER IBKDIM,TAIL,EVEN
      LOCTO=JFIRST
      JFIRST=EVEN(LOCTO+IBKDIM**2)
      LOCPO=IFIRST
      IFIRST=EVEN(LOCPO+IBKDIM)
      LOCSR=JFIRST
      JFIRST=EVEN(LOCSR+IBKDIM*2)
      LOCA=JFIRST
      JFIRST=EVEN(LOCA+IBKDIM)
      LOCHU=IFIRST
      IFIRST=EVEN(LOCHU+IBKDIM)
      LOCHR=JFIRST
      JFIRST=EVEN(LOCHR+IBKDIM)
      TAIL=IFIRST-1
      RETURN
      END
      SUBROUTINE RIJSORT(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS,AANIT,STOP,
     1 STREX,NSTREX)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER STREX(NSTREX)
      INTEGER KOLPOS,NM,STOP,AANIT,VORJT,VORKT,WISUIT,
     1 NEXTMAX,NEXTMIN,HULP
      REAL*4 TOPO(IBKDIM,IBKDIM),SOMRIJ(IBKDIM*2),HULPR,MAXEEN,
     1 MINEEN,VORMIN
      VORJT=0
      VORKT=0
      NEXTMIN=0
      VORMIN=0.0
      NEXTMAX=0
  123 IF((AANIT.LE.IBKDIM).AND.(STOP.EQ.0)) THEN
      AANIT=AANIT+1
      CALL MINMA2(IBKDIM,TOPO,SOMRIJ,NM,KOLPOS,KT,JT,MAXEEN,MINEEN,
     1 NEXTMAX,NEXTMIN,VORJT,VORKT,STOP,WISUIT,VORMIN)
      VORJT=JT
      VORKT=KT
      VORMIN=MINEEN
C
C  ONLY SWAP IF ROW OUTSIDE BLOCK HAS A LARGER DENSITY
C  CROSS-ELEMENT JT,KT WILL NOT ENTER BLOCK BUT WILL ENTER
C  THE SCOPE. SO DO NOT COUNT THIS ELEMENT
C
      TERM0=SOMRIJ(JT)
      TERM=TERM0/(TOPO(JT,KT)**(1.0/FLOAT(NM)))
      IF(((SOMRIJ(KT).LE.TERM).AND.(STOP.NE.1)).
     1 OR.(WISUIT.EQ.1)) THEN
      HULP=STREX(KT)
      STREX(KT)=STREX(JT)
      STREX(JT)=HULP
      HULPR=SOMRIJ(KT)
      SOMRIJ(KT)=SOMRIJ(JT)
      SOMRIJ(JT)=HULPR
      DO 1500 IT=1,IBKDIM
      HULPR=TOPO(KT,IT)
      TOPO(KT,IT)=TOPO(JT,IT)
      TOPO(JT,IT)=HULPR
 1500 CONTINUE
      DO 1600 IT=1,IBKDIM
      HULPR=TOPO(IT,KT)
      TOPO(IT,KT)=TOPO(IT,JT)
      TOPO(IT,JT)=HULPR
 1600 CONTINUE
      HULPR=SOMRIJ(IBKDIM+KT)
      SOMRIJ(IBKDIM+KT)=SOMRIJ(IBKDIM+JT)
      SOMRIJ(IBKDIM+JT)=HULPR
      DO 1701 IT=KOLPOS,IBKDIM
      SOMRIJ(IT)=SOMRIJ(IT)*(TOPO(IT,KT)/TOPO(IT,JT))**(1/FLOAT(NM))
 1701 CONTINUE
      DO 1702 IT=KOLPOS,IBKDIM
      SOMRIJ(IT+IBKDIM)=SOMRIJ(IT+IBKDIM)+TOPO(IT,KT)-TOPO(IT,JT)
 1702 CONTINUE
      ELSE
      STOP=1
      ENDIF
      ELSE
      GOTO 234
      ENDIF
      GOTO 123
  234 RETURN
      END
      SUBROUTINE SIJPQ(IJP,IJQ,NIJP,NIJQ,EIJP,EIJQ,POINT)
      DIMENSION IJP(5,NIJP),IJQ(6,NIJQ),EIJP(2),EIJQ(2)
      INTEGER EIJP,EIJQ,POINT(NIJQ)
      CALL SORT1(IJQ,6,NIJQ,NIJQ,3)
      IB=1
      DO 250 I=1,NIJP
      DO 231 J=1,2
  231 EIJP(J)=IJP(J,I)
      NUM=0
C
C  IBE : BEGIN ADDRESS OF DEPENDENTS IN IJQ
C  IEI : ADDRESS OF LAST DEPENDENT
C  IEI=0: NO DEPENDENTS
C
      DO 230 J=IB,NIJQ
C
C  LOCATE REFLEXIONS DEPENDENT ON IJP(I)
C
      DO 232 L=1,2
  232 EIJQ(L)=IJQ(L+2,J)
      DO 234 L=1,2
      IF(EIJP(L).NE.EIJQ(L))GOTO 230
234   CONTINUE
      DO 233 L=1,6
      ITEMP=IJQ(L,J)
      IJQ(L,J)=IJQ(L,IB+NUM)
  233 IJQ(L,IB+NUM)=ITEMP
      NUM=NUM+1
  230 CONTINUE
      IE=0
      IF(NUM.NE.0) THEN
      IE=IB+NUM-1
      CALL SORTIJ(IJQ,NIJQ,IB,IE,POINT,6)
      ENDIF
      IJP(3,I)=IB
      IJP(4,I)=IE
      IB=IB+NUM
  250 CONTINUE
      RETURN
      END
      SUBROUTINE SORTIJ(IJP,NIJP,NB,NE,POINT,N)
C
C  Sort IJP(6,NIJP) ON IJP(1,*)*1000+IJP(2,*) FROM NB TO NE 
C  ON COMPLETION IJB(*,NB) WILL CONTAIN THE MINIMUM VALUES OF IRY
C  AND IKO.
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER   IJP(N,NIJP),IHULP(6),POINT(NIJP)
      NAT=NE-NB+1
      DO 1 I=NB,NE
1     POINT(I)=I
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NAT)GOTO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NE-INT
      DO 1200 II=NB,IFIN
      I=II
      J=I+INT
      INDEX1=IJP(1,I)*1000+IJP(2,I)
      INDEX2=IJP(1,J)*1000+IJP(2,J)
      IF(INDEX1.LE.INDEX2)GOTO 1200
      DO 1201 IJK=1,N
      IHULP(IJK)=IJP(IJK,J)
      IJP(IJK,J)=IJP(IJK,I)
1201  CONTINUE
      K=POINT(J)
1080  CONTINUE
      POINT(J)=POINT(I)
      DO 1202 IJK=1,N
      IJP(IJK,J)=IJP(IJK,I)
1202  CONTINUE
      J=I
      I=I-INT
      IF(I+1.LE.NB)GOTO 1140
C     IF(I-NB+1)1140,1140,1120
      INDEX1=IJP(1,I)*1000+IJP(2,I)
      INDEX2=IHULP(1)*1000+IHULP(2)
      IF(INDEX1.GT.INDEX2)GO TO 1080
1140  CONTINUE  
      POINT(J)=K
      DO 1203 K=1,N
      IJP(K,J)=IHULP(K)
1203  CONTINUE
1200  CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE SORTJI(IJP,NIJP,NB,NE,N) 
C
C  Sort IJP(6,NIJP) ON IJP(1,*)*1000+IJP(2,*) FROM NB TO NE 
C  ON COMPLETION IJB(*,NB) WILL CONTAIN THE MINIMUM VALUES OF IRY
C  AND IKO.
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER   IJP(N,NIJP),IHULP(6)
      NAT=NE-NB+1
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NAT)GOTO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NE-INT
      DO 1200 II=NB,IFIN
      I=II
      J=I+INT
      INDEX1=IJP(1,I)*1000+IJP(2,I)
      INDEX2=IJP(1,J)*1000+IJP(2,J)
      IF(INDEX1.LE.INDEX2)GOTO 1200
      DO 1201 IJK=1,N
      IHULP(IJK)=IJP(IJK,J)
      IJP(IJK,J)=IJP(IJK,I)
1201  CONTINUE
1080  CONTINUE
      DO 1202 IJK=1,N
      IJP(IJK,J)=IJP(IJK,I)
1202  CONTINUE
      J=I
      I=I-INT
      IF(I+1.LE.NB)GOTO 1140
C     IF(I-NB+1)1140,1140,1120
      INDEX1=IJP(1,I)*1000+IJP(2,I)
      INDEX2=IHULP(1)*1000+IHULP(2)
      IF(INDEX1.GT.INDEX2)GO TO 1080
1140  CONTINUE  
      DO 1203 K=1,N
      IJP(K,J)=IHULP(K)
1203  CONTINUE
1200  CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE STOHAS(A,N,W,IW,ITAPE,ITEL,ITELM,IFAIL)
C
C  CREATES ORDERED HASHTABLE
C  REF: SCIENTIFIC AMERICAN APRIL 1977
C  INPUT FILE ITAPE MUST CONTAIN BLOCKS OF IW REFLEXIONS
C  THE HASHFUNCTION IS MOD(IHAS*IX,NHAS)+1
C  IX CONTAINS H, K, L + 128 IN BYTE 2, 3, 4
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER A(2,NHAS),W(2,IW),HMAX
      INTEGER AJ1,WI1
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      REWIND ITAPE
C
C  INITIALIZE A
C
      DO 1 I=1,NHAS
      DO 1 J=1,2
    1 A(J,I)=0
      ITEL=0
C
C  NN NUMBER OF REFLEXIONS STORED
C
      NN=0
    5 CONTINUE
C
C  READ BLOCK OF REFLEXIONS
C
      IF(NN.GE.N) GOTO 200
      READ(ITAPE) W
      DO 100 I=1,IW
C
C  KEEP COUNT
C
      NN=NN+1
      IF(NN.GT.N) GOTO 200
      ITEL=ITEL+1
      IF(ITEL.GT.ITELM) GOTO 300
C
C  REFLEXION TO BE STORED
C
C  GET HKL
C
      WI1=W(2,I)
C
C  HASHFUNCTION
C
      J=MOD(IABS(WI1*IHAS),NHAS)+1
   10 CONTINUE
C
C  GET HKL OF A(J)
C
      AJ1=A(1,J)
C
C  STORE WI IF WI1SAJ1
C
      IF(AJ1.EQ.WI1)GO TO 100
      IF(AJ1.GT.WI1)GO TO 50
C     IF(AJ1-WI1) 40,100,50
      CONTINUE
C
C  WI1>AJ1 : EXCHANGE WI AND A(J)
C
      ITEM=A(1,J)
      A(1,J)=WI1
      WI1=ITEM
      ITEM=A(2,J)
      A(2,J)=W(1,I)
      W(1,I)=ITEM
   50 CONTINUE
C
C  IF WI1=0 LOCATION JH FREE: READY
C
      IF(WI1.EQ.0) GOTO 100
C
C  IF NOT STORE WI ONE FURTHER DOWN
C
      ITEL=ITEL+1
      IF(ITEL.GT.ITELM) GOTO 300
      J=J-1
      IF(J.EQ.0) J=NHAS
      GOTO 10
  100 CONTINUE
      GOTO 5
  200 CONTINUE
C
C  SUCCESS AT LAST
C
      IFAIL=0
      GOTO 999
  300 CONTINUE
C
C  EFFICIENCY TO LOW
C
      IFAIL=1
  999 CONTINUE
      RETURN
      END
      SUBROUTINE STORED(IJQ,NIJQ,ITEKEN,IPHASE,IRY1,IKO1,IRY2,IKO2)
C
C  STORE DEPENDENT IN IJQ
C
      DIMENSION IJQ(6,NIJQ)
      IJQ(1,NIJQ)=IRY1
      IJQ(2,NIJQ)=IKO1
      IJQ(3,NIJQ)=IRY2
      IJQ(4,NIJQ)=IKO2
      IJQ(5,NIJQ)=IPHASE
      IJQ(6,NIJQ)=ITEKEN
      RETURN
      END
      SUBROUTINE STOREI(IH,IK,IL,IJP,II,IJ,IN,NIJP,IRY,IKO,MK)
C
C STORE INDEPENDENT REFLECTION IN IJP AND INDICES ARRAYS
C
      DIMENSION IH(NIJP),IK(NIJP),IL(NIJP),IJP(5,NIJP)
      IH(NIJP)=II
      IK(NIJP)=IJ
      IL(NIJP)=IN
      IJP(1,NIJP)=IRY
      IJP(2,NIJP)=IKO
      IJP(3,NIJP)=0
      IJP(4,NIJP)=0
      IJP(5,NIJP)=MK
      RETURN
      END
      SUBROUTINE STOREU(IJP,NIJP,IRY,IKO,KHL,MN,MR,NK)
C
C  STORE UNOBSERVED REFLECTION WITH ALL THE DETAIL
C  IJP(3,NIJP) IS THE PHASE SHIFT FROM THE MULTAN PARENT
C  IJP(4,NIJP) IS THE CORRESPONDING SIGN
C  MN IS THE MULTAN STANDARD HKL, MR IS THE ORIGINAL
C
      DIMENSION IJP(6,NIJP),KHL(6,NK)
      IJP(1,NIJP)=IRY
      IJP(2,NIJP)=IKO
      IJP(3,NIJP)=KHL(4,1)
      IT=0
      IF(KHL(5,1).EQ.-1)IT=1
      IJP(4,NIJP)=IT
      IJP(5,NIJP)=MN
      IJP(6,NIJP)=MR    
      RETURN
      END
      SUBROUTINE STR1(H,K,L,IR,IC,IT,W,NWMAX,NW,ISCRA)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER H,W
      DIMENSION W(2,NWMAX)
C
C  WRITE HKL ETC. ON ISCRA IN BLOCKS
C  H=K=L=0: W IS DUMPED INDEPENDENT OF NW
C  NW=NWMAX: W IS DUMPED
C
      IF(NW.LT.NWMAX) GOTO 10
      WRITE(ISCRA) W
      NW=0
   10 NW=NW+1
      CALL PAK(IK,H,K,L)
      NK=IR
      NK=NK+65536*64*IT+65536*IC
      W(1,NW)=NK
      W(2,NW)=IK
      IF(H.EQ.0.AND.K.EQ.0.AND.L.EQ.0) WRITE(ISCRA) W
      RETURN
      END
      SUBROUTINE STRSOR(A,STR,POINT,NSTR,IP)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER POINT(NSTR)
      INTEGER A(NSTR),STR(NSTR),PIVOT
      INTEGER N,I,J,SP,MID,LEFT(20),RIGHT(20)
      LOGICAL*1 JA,NEE
      WRITE(IP,*) '    '
      WRITE(IP,*) 'SORT STR ACCORDING TO RECIPROCAL VECTOR-LENGTH'
      N=NSTR
      LEFT(1)=1
      RIGHT(1)=N
      SP=1
   10 CONTINUE
      IF(LEFT(SP).LT.RIGHT(SP)) THEN
      I=LEFT(SP)
      J=RIGHT(SP)
      PIVOT=A(J)
      MID=(I+J)/2
      IF((J-I).GE.6) THEN
      JA=PIVOT.GT.A(I)
      NEE=PIVOT.LT.A(MID)
      IF((JA.AND..NOT.NEE).OR.(.NOT.JA.AND.NEE)) THEN
      JA=A(I).LT.A(MID)
      NEE=A(I).GT.PIVOT
      IF((JA.AND..NOT.NEE).OR.(.NOT.JA.AND.NEE)) THEN
      CALL SWAPSR(MID,J,A,STR,POINT,NSTR)
      ELSE
      CALL SWAPSR(I,J,A,STR,POINT,NSTR)
      ENDIF
      PIVOT=A(J)
      ENDIF
      ENDIF
   50 CONTINUE
      IF(I.GE.J) GOTO 110
   60 CONTINUE
      IF(A(I).GE.PIVOT) GOTO 70
      I=I+1
      GOTO 60
   70 J=J-1
   80 CONTINUE
      IF(.NOT.((I.LT.J).AND.(PIVOT.LT.A(J)))) GOTO 90
      J=J-1
      GOTO 80
   90 CONTINUE
      IF(I.LT.J) CALL SWAPSR(I,J,A,STR,POINT,NSTR)
      GOTO 50
  110 J=RIGHT(SP)
      CALL SWAPSR(I,J,A,STR,POINT,NSTR)
      IF((I-LEFT(SP)).LT.(RIGHT(SP)-I)) THEN
      LEFT(SP+1)=LEFT(SP)
      RIGHT(SP+1)=I-1
      LEFT(SP)=I+1
      ELSE
      LEFT(SP+1)=I+1
      RIGHT(SP+1)=RIGHT(SP)
      RIGHT(SP)=I-1
      ENDIF
      SP=SP+1
      ELSE
      SP=SP-1
      ENDIF
      IF(SP.GT.0) GOTO 10
      RETURN
      END
      SUBROUTINE SWAP(KT,JT,A,POINT,IBKDIM)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER KT,JT,POINT(IBKDIM),HULP
      REAL*4 A(IBKDIM),HULPR
      HULPR=A(KT)
      A(KT)=A(JT)
      A(JT)=HULPR
      HULP=POINT(KT)
      POINT(KT)=POINT(JT)
      POINT(JT)=HULP
      RETURN
      END
      SUBROUTINE SWAPAL(SOMRIJ,IBKDIM,TOPO,POINT,HULP,HULPR,STREX,
     1NSTREX)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER STREX(NSTREX)
      INTEGER KT,POINT(IBKDIM),HULP(IBKDIM)
      REAL*4 TOPO(IBKDIM,IBKDIM),SOMRIJ(IBKDIM),HULPR(IBKDIM)
      DO 100 I=1,IBKDIM
      HULP(I)=STREX(POINT(I))
  100 CONTINUE
      DO 110 I=1,IBKDIM
      STREX(I)=HULP(I)
  110 CONTINUE
      DO 400 I=1,IBKDIM
      HULPR(I)=SOMRIJ(POINT(I))
  400 CONTINUE
      DO 410 I=1,IBKDIM
      SOMRIJ(I)=HULPR(I)
  410 CONTINUE
C
C  THE UPPER TRIANGLE OF THE QUALITY MATRIX IS USED AS A BUFFER
C  FOR REARRANGING THE WHOLE MATRIX
C  THIS IS POSSIBLE BECAUSE OF THE SYMMETRY IN THE QUALITY MATRIX
C
      DO 600 J=2,IBKDIM
      I=POINT(J)
      DO 700 KT=1,J-1
      IF (I.GT.POINT(KT))THEN
      TOPO(KT,J)=TOPO(I,POINT(KT))
      ELSE
      TOPO(KT,J)=TOPO(POINT(KT),I)
      ENDIF
  700 CONTINUE
  600 CONTINUE
      DO 610 J=2,IBKDIM
      DO 710 KT=1,J-1
      TOPO(J,KT)=TOPO(KT,J)
  710 CONTINUE
  610 CONTINUE
      RETURN
      END
      SUBROUTINE SWAPH(IH,IK,IL,POINT,IHULP,NIJP)
      INTEGER IH(NIJP),IK(NIJP),IL(NIJP),POINT(NIJP),IHULP(NIJP)
      DO 1 I=1,NIJP
      IHULP(I)=IH(POINT(I))
1     CONTINUE
      DO 2 I=1,NIJP
      IH(I)=IHULP(I)
2     CONTINUE
      DO 3 I=1,NIJP
      IHULP(I)=IK(POINT(I))
3     CONTINUE
      DO 4 I=1,NIJP
      IK(I)=IHULP(I)
4     CONTINUE
      DO 5 I=1,NIJP
      IHULP(I)=IL(POINT(I))
5     CONTINUE
      DO 6 I=1,NIJP
      IL(I)=IHULP(I)
6     CONTINUE
      RETURN
      END
      SUBROUTINE SWAPINT(KT,JT,A,POINT,IBKDIM)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER KT,JT,POINT(IBKDIM),A(IBKDIM),HULP
      HULP=A(KT)
      A(KT)=A(JT)
      A(JT)=HULP
      HULP=POINT(KT)
      POINT(KT)=POINT(JT)
      POINT(JT)=HULP
      RETURN
      END
      SUBROUTINE SWAPSR(KT,JT,A,STR,POINT,NSTR)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER KT,JT,A(NSTR),STR(NSTR),POINT(NSTR),HULP
      HULP=A(KT)
      A(KT)=A(JT)
      A(JT)=HULP
      HULP=STR(KT)
      STR(KT)=STR(JT)
      STR(JT)=HULP
      HULP=POINT(KT)
      POINT(KT)=POINT(JT)
      POINT(JT)=HULP
      RETURN
      END
      SUBROUTINE TSTHAS(A,NN,IA,B,IB,K)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX
      INTEGER X,H,H1
      INTEGER A(NN,IA),W,B
      DIMENSION W(2,10),X(2,10),B(2,IB)
      COMMON /COMHAS/ IHAS,NHAS,IT,ITEST
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING

C  TEST PARENTLIST

      DO 5 L1=1,IA,10
      L2=MIN0(L1+9,IA)
      J=L2-L1+1
      DO 8 I=1,J
    8 W(2,I)=A(5,L1+I-1)
      CALL FINHAS(B,W,J,X,ITEL,2)
      DO 9 I=1,J
      IF(X(2,I).EQ.0) GOTO 900
    9 CONTINUE
    5 CONTINUE
      KK=MAX0(K/10,1)
      KK10=KK*10
      WRITE(LO,7)KK10
    7 FORMAT(' TSTHAS: All parent reflexions are present, ',I3,
     1 ' random tests will be done')
      KTEL=0
      DO 100 I=1,KK
      DO 10 J=1,10

C  GET RANDOM REFLEXION

      H=RANDOM(0)*2.0*HMAX-HMAX
      K=RANDOM(0)*2.0*KMAX-KMAX
      L=RANDOM(0)*2.0*LMAX-LMAX

C  PACK HKL

      CALL PAK(W(2,J),H,K,L)
   10 CONTINUE

C  LOOK UP REFLEXIONS

      CALL FINHAS(B,W,10,X,ITEL,1)
      KTEL=KTEL+ITEL
      DO 20 J=1,10

C  GET RESULTS FROM X

      CALL UNPK1(W(2,J),H,K,L)

C  PRINT RESULTS

      JA=X(2,J)
      IHULP=X(1,J)

C  NOT FOUND

      IF(JA.EQ.0) GOTO 15

C  FASESHIFT:

      KS=IHULP

C  GET SIGN

      KT=KS/64
      KS=KS-KT*64

C  H, K AND L:

      CALL UNPK1(A(5,JA),H1,K1,L1)
c     WRITE(LO,1) H,K,L,H1,K1,L1,KS,KT
C   1 FORMAT(' ',3I5,' =',3I5,' PHASESHIFT',I3,' SIGN',I2)
      GOTO 20
   15 CONTINUE
c     WRITE(LO,2) H,K,L
C   2 FORMAT(' ',3I5,' NOT FOUND')
   20 CONTINUE
  100 CONTINUE

C  EFFICIENCY

      R=KTEL/FLOAT(KK10)
      WRITE(LO,3) R
    3 FORMAT(' TSTHAS: Efficiency:',F10.4)
      RETURN
  900 CONTINUE
      WRITE(LO,6)
    6 FORMAT(' TSTHAS: Error in hashtable')
      STOP
      END

