C  Copyright (c) Rag de Graaff, Leiden University  2004 - 2006   
C
C  This program is free software; you can redistribute it and/or
C  modify it under the terms of the GNU General Public License
C  as published by the Free Software Foundation; either version 2
C  of the License, or (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, 
C  USA.
      SUBROUTINE CFASLO(AM,PM,QM,IA,N)
C
C  COPIES LOWER TRIANGLE AM (COMPLEX) TO LOWER TRIANGLE PM,QM IN MODULI
C  AND PHASES. OVERWRITING IS NOT PERMITTED. PM,QM is filled completely
C
      IMPLICIT REAL*4 (A-H,O-Z)
      COMPLEX AM
      DIMENSION AM(IA,N),PM(IA,N),QM(IA,N)
      PM(1,1)=REAL(AM(1,1))
      QM(1,1)=0.0
      DO 10 I=2,N
      PM(I,I)=REAL(AM(I,I))
      QM(I,I)=0.0
      DO 10 J=1,I-1
      A=REAL(AM(I,J))
      B=AIMAG(AM(I,J))
      PM(I,J)=SQRT(A**2+B**2)
      QM(I,J)=ATAN2(B,A)
      PM(J,I)=PM(I,J)
      QM(J,I)=-QM(I,J)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE DET2(NM,EMX,PMX,AMX,WORK,RWORK,IWORK,DAMX,IJP
     1 ,NIJP,IJQ,NIJQ,FAS,SSNE,NVECT,METHOD,LWORK,LRWORK,LIWORK)
C
C  CALCULATES SSNE OR THE SUM OF THE SQUARES OF THE NEGATIVE
C  EIGENVALUES OF AMX AS A FUCTION OF THE PHASES IN FAS
C  NM: ORDER OF THE MATRIX = INPUT
C  EMX(NM,NM) MODULI OF THE MATRIX ELEMENTS = INPUT
C  PMX(NM,NM) PHASES OF THE MATRIX ELEMENTS IN RADIANS
C  AMX(NM,NM) METHOD 1: CONTAINS EIGENVECTORS ON OUTPUT
C  AMX(NM,NM) METHOD 0: CONTAINS ORIGINAL VALUES ON OUTPUT
C  DAMX(NM) EIGENVALUES OF AMX
C  METHOD: =INPUT= 0 NO EIGENVECTORS, 1 ALL EIGENVECTORS
C  IJP(NIJP) =INPUT, SEE SUBR MMTRX
C  FAS(NIJP) =INPUT, THE INDEPENDENT PHASES
C  NVECT =OUTPUT= NUMBER OF POSITIVE EIGENVALUES OR 1
C
      IMPLICIT REAL*4 (A-H,O-Z)
C     REAL*8 SSNE
      DIMENSION EMX(NM,NM)
      DIMENSION PMX(NM,NM)
      COMPLEX AMX(NM,NM)
      COMPLEX WORK(*)
      DIMENSION DAMX(NM)
      DIMENSION RWORK(*),IWORK(*)
      CHARACTER JOBZ,  UPLO
      DIMENSION IJP(5,NIJP),IJQ(6,NIJQ)
      DIMENSION FAS(NIJP)
      INCLUDE '../common/unit.f'
C
C  STORE INPUT PHASES IN THE MATRICES
C
      CALL VULLER(PMX,NM,IJP,NIJP,IJQ,NIJQ,FAS)
C
C  TRANSFORM FROM MODULES AND PHASES TO REAL AND IMAGINARY IN AMX
C
      CALL VULAMX(AMX,PMX,EMX,NM)
C
C  Calculate the eigenvalues
C
      IF(METHOD.EQ.0)THEN
      JOBZ='N'
      ELSE
      JOBZ='V'
      ENDIF
      UPLO='L'
      CALL CHEEVD(JOBZ,UPLO,NM,AMX,NM,DAMX,WORK,LWORK,RWORK,
     1 LRWORK,IWORK,LIWORK,INFO)
C     CALL CHEEV(JOBZ,UPLO,NM,AMX,NM,DAMX,WORK,LWORK,RWORK,INFO)
      IF(METHOD.EQ.0)CALL VULAMX(AMX,PMX,EMX,NM)
      SSNE=0.0
      DO 190 I=1,NM
      DA=DAMX(I)
      IF(DA.GE.0.0)GOTO 999
      SSNE=SSNE+DA*DA
  190 CONTINUE
C
C  SSNE CONTAINS THE SUM OF THE SQUARES OF THE NEGATIVE
C  EIGENVALUES OF MATRIX AMX
C  PMX CONTAINS THE PHASES AND EMX THE E-VALUES USED TO MAKE AMX
C  PMX IS FILLED FROM FAS
C
999   CONTINUE 
      IF(METHOD.NE.0)THEN
      NVECT=NM+1-I
      ENDIF
      RETURN
      END
      SUBROUTINE EIGDET(C,NC,B,NR,A,NI,LOCEMX,LOCPMX,
     1 LOCH,LOCK,LOCL,LOCIJP,LOCIJQ,IFIRST,JFIRST,KFIRST,
     2 IOP,NEIND,NTRIAL,NTRUE,NPOINT,NFS,NIJP,
     3 NIJQ,LOCW1,ICYCLE,HITS)
      IMPLICIT REAL*4 (A-H,O-Z)
      CHARACTER HITS(4,1000)*80
      INTEGER A(NI),EVEN,JN,JZ
C     REAL*8 SSNE
      DIMENSION B(NR)
      LOGICAL F69
      COMPLEX C(NC)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/detpar.f'
      INCLUDE '../common/const.f'
      INCLUDE '../common/locaut.f'
      COMMON /TOPROW/ LOCMX
      SAVE LCIJPA,LCIJQA,LOCAMX,LOCBMX,LOCCMX,LOCDMX,LCDAMX,
     1 LOCWRK,LOCWRR,LOCWRI,LOCIFA,LOCWWW,LWORK,LRWORK,LIWORK,
     2 NIJQA,LCSTOR,NADIM,LOCFAS,LCSTR1
      IREF=0
      IF(IOP.EQ.0)THEN
      ELIM=MAX(0.0001,IELIM/100.0)
      NW1=NMX*(NMX-1)
      LOCW1=IFIRST
      IFIRST=EVEN(LOCW1+NW1)
      CALL ROOM(NI,IFIRST,NR,JFIRST,NC,KFIRST,0,LO)
C
C  INITIALIZE PHASE REFINEMENT PROCESS, IFIRST POINTS TO INTEGER
C  BUFFER, JFIRST TO REAL AND KFIRST TO COMPLEX
C
      CALL OPINIT(A,NI,NMX,NR,NC,A(LOCIJP),NIJP,A(LOCIJQ),NIJQ,
     1 LCIJPA,LCIJQA,B(LOCEMX),LOCAMX,LOCBMX,LOCCMX,LOCDMX,LCDAMX,
     2 LOCWRK,LOCWRR,LOCWRI,LOCIFA,LOCWWW,
     3 LWORK,LRWORK,LIWORK,LOCFAS,IFIRST,JFIRST
     4 ,KFIRST,NFS,NIJQA,ELIM)
C
C  EITHER NEIND-NBEGIN+1 RANDOM TRIES ARE SORTED ON SSNE OR
C  FOR RANDOM TRY NUMSET THE PHASES ARE REFINED.
C
C  IOP=0: CALCULATE SSNE BUT DO NOT REFINE
C  IOP=1: OPTIMIZE PHASES FROM RANDOM START
C  IOP=2: OPTIMIZE PHASES FROM INPUT ATOMS FROM AUTOFOUR 
C
      NADIM=NATOM
      LOCXC=JFIRST
      JFIRST=JFIRST+6*NADIM
      NPOINT=NEIND
      IF(NEIND.NE.0)NEIO=NEIND
      NEI=0
      IF(ICOOR.NE.0)THEN
C
C  READ COORDINATES 
C
      CALL CCPDPN(68, 'MODELIN', 'READONLY', 'F', 0, 0)
      CALL TELX(NBE,NEI)
      LOCX=JFIRST
      JFIRST=JFIRST+4*NADIM*NEI
      LCSTR1=IFIRST
      IFIRST=IFIRST+NEI
      NPOINT=NEI
      CALL READX(B(LOCX),A(LCSTR1),NADIM,NBE,NEI)
      ELSE     
      LOCX=JFIRST
      JFIRST=JFIRST+4*NADIM*NEIND
      LCSTR1=IFIRST
      IFIRST=IFIRST+NEIND
      ENDIF
C
C  Upon Raj' request we now sort everything
C
      INQUIRE (FILE='sorted.xyz',EXIST=F69)
      LCSTOR=IFIRST
      IFIRST=IFIRST+MAX(NEI,NEIND)
      CALL ROOM(NI,IFIRST-1,NR,JFIRST-1,NC,KFIRST-1,0,LO)
      INMAT=0
      IF(.NOT.F69)THEN
      CALL CCPDPN(69, 'sorted.xyz', 'NEW', 'F', 0, 0)
      DO 1234 JUMSET=1,MAX(NEI,NEIND)
C
C  ALL PHASES HAVE A RANDOM VALUE AT THE START
C
      INMAT=INMAT+1
      IF(ICOOR.EQ.0)THEN
      NATOM=NADIM*0.8
      CALL RANATM(B(LOCX),A(LCSTR1),NADIM,NEI,INMAT)
      ENDIF
C     IF(JUMSET.GE.NBEGIN)THEN
      CALL TEOFAS(B(LOCX),A(LOCH),A(LOCK),A(LOCL),NMX,B(LOCPMX),
     1 B(LOCEMX),A(LCIJPA),NFS,A(LCIJQA),NIJQA,LO,INMAT,JUMSET,
     2 NEI,NADIM,IOP,A(LCSTR1))
      CALL OPDETA(NMX,B(LOCEMX),
     1 B(LOCPMX),C(LOCAMX),C(LOCBMX),B(LOCCMX),B(LOCDMX),
     2 B(LCDAMX),B(LOCW),B(LOCWS),
     3 C(LOCWRK),B(LOCWRR),A(LOCWRI),LWORK,LRWORK,LIWORK,
     4 A(LCIJPA),A(LCIJQA),B(LOCFAS),NFS,NIJQA,SSNE,
     5 IOP,ICYCLE,HITS)
      CALL KEEP(A(LCSTOR),NEI,INMAT,SSNE)
C
C  INIIAL VALUE FOR THIS START IS STORED
C
C     ENDIF
1234  CONTINUE
      CALL SORT5(A(LCSTOR),INMAT,A(LOCW1),INMAT)
      IF(NEIND.NE.NEIO)NEIND=NEIO
      NATOM=NADIM 
      CALL WRITEX(B(LOCX),A(LCSTR1),A(LOCW1),NADIM,INMAT)
      CLOSE (69)
      ENDIF
      GOTO 9999
C
C  THE TRIALS HAVE BEEN SORTED. THE COORDINATES ARE WRITTEN ON 68            
C  THE FORMAT IS STILL THE SAME        )
C
C  WE ARE FINISHED FOR NOW
C
      ELSE 
C
C  INITIALIZE TRY NBEGIN AND REFINE (IOP=1) OR READ COORDINATES GIVEN BY
C  AUTOFOUR, CALCULATE PHASES AND REFINE (IOP=2)
C
C  NEXT  PREPARE INPUT FOR EXFFT
C
      IF(IOP.EQ.1)THEN
      CALL CCPDPN(69, 'sorted.xyz', 'OLD', 'F', 0, 0)
      CALL READXX(B(LOCX),NTRUE,NADIM,INMAT)
      LOO=LOCX
      ELSE
      LOO=LOCXC
      ENDIF
      CALL TEOFAS(B(LOO),A(LOCH),A(LOCK),A(LOCL),NMX,B(LOCPMX),
     1 B(LOCEMX),A(LOCIJP),NIJP,A(LOCIJQ),NIJQ,LO,NTRIAL,NTRUE,
     2 NEIND,NADIM,IOP,A(LCSTR1))
      CALL OPDETA(NMX,B(LOCEMX),
     1 B(LOCPMX),C(LOCAMX),C(LOCBMX),B(LOCCMX),B(LOCDMX),
     2 B(LCDAMX),B(LOCW),B(LOCWS),
     3 C(LOCWRK),B(LOCWRR),A(LOCWRI),LWORK,LRWORK,LIWORK,
     4 A(LCIJPA),A(LCIJQA),B(LOCFAS),NFS,NIJQA,SSNE,
     5 IOP,ICYCLE,HITS)
      IF(IOP.EQ.1)THEN
      NATOM=NADIM
      ENDIF
      CALL WRFOUR(NMX,A(LCIJPA),
     1 NFS,B(LOCCMX),B(LOCPMX),B(LOCAC),B(LOCBC),E0)
      ENDIF
 9999 CONTINUE
      RETURN
      END
      SUBROUTINE JAAP2(AMX,BMX,DAMX,NVECT,CMX,DMX,NM)
C
C  CALCULATES POSITIVE RECONSTRUCTION OF AMX 
C  DET2 MUST HAVE BEEN CALLED
C  THE MATRIX BMX CONTAINS THE EIGENVECTORS OF AMX(METHOD=1)
C  OR THE ORIGINAL MATRIX AMX
C  IN HERE AMX IS SCRATCH
C  DAMX CONTAINS THE EIGENVALUES
C  THE RESULT IS PUT OUT IN MODULI, PHASES IN CMX, DMX
C
      IMPLICIT REAL*4 (A-H,O-Z)
      COMPLEX   AMX(NM,NM)
      COMPLEX   BMX(NM,NM)
      DIMENSION DAMX(NM)
      DIMENSION CMX(NM,NM)
      DIMENSION DMX(NM,NM)
C
C  CALCULATE POSITIVE RECONSTRUCTION
C  MODULI, PHASES IN CMX,DMX
C
      CALL UIT_VER(DAMX,BMX,NM,AMX,NVECT,1)
      CALL CFASLO(AMX,CMX,DMX,NM,NM)
      RETURN
      END
      SUBROUTINE KEEP(SUM,INMAT,NUMMER,SSNE)
      IMPLICIT REAL*4 (A-H,O-Z)
C     REAL*8 SSNE
      INTEGER SUM(INMAT)
      SUM(NUMMER)=SSNE*1000.0
      RETURN
      END
      SUBROUTINE OPDETA(NM,EMX,PMX,AMX,BMX,CMX,DMX,DAMX,
     1 W,WS,WORK,RWORK,IWORK,LWORK,LRWORK,LIWORK,IJPA,
     2 IJQA,FAS,NFS,NIJQA,SSNE,IOPT,ICYCLE,HITS)
C
C  OPDETA MINIMIZES THE SUM OF THE SQUARE OF THE NEGATIVE
C  EIGENVALUES OF AMX
C  SEE ACTA CRYSTALLOGRAPHICA
C
C  ONLY REFLEXIONS WITH E>ELIM ARE CONSIDERED BY OPINIT
C
C  PARAMETERS
C
C  NM = INPUT = ORDER OF THE MATRIX
C
C  EMX(NM,NM) = INPUT =
C  E-VALUES IN THE LOWER TRIANGLE
C
C  PMX(NM,NM) = INPUT, OUTPUT =
C  INPUT: START PHASES IN RADIANS
C  OUTPUT: REFINED PHASES IN RADIANS
C
C  SCRATCH ARRAYS:
C  AMX(NM,NM), BMX(NM,NM), CMX(NM,NM),
C  DMX(NM,NM), DAMX(NM), WORK(LWORK),RWORK(7*NM,
C  IWORK(5*NM),W(NFS),WS(NFS)
C
C  IJPA,IJQA: = INPUT = SEE OPINIT
C  FAS: SCRATCH PHASES
C
      IMPLICIT REAL*4 (A-H,O-Z)
      CHARACTER HITS(4,1000)*80
C     REAL*8 SSNE
      INTEGER HMAX
      DIMENSION EMX(NM,NM),RWORK(7*NM),IWORK(5*NM)
      DIMENSION PMX(NM,NM)
      COMPLEX AMX(NM,NM)
      COMPLEX BMX(NM,NM)
      DIMENSION CMX(NM,NM)
      DIMENSION DMX (NM,NM)
      DIMENSION DAMX(NM)
      COMPLEX WORK(LWORK)
      DIMENSION IJPA(5,NFS),IJQA(6,NIJQA),W(NFS),WS(NFS)
      DIMENSION FAS(NFS)
      DIMENSION DE(10) 
      INCLUDE '../common/unit.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
C
C  DIAG = NUMBER OF TIMES THE DIAGONAL IS INCREASED
C
C  REFINEMENT STOPS AFTER ICYCMX CYCLES
C
      PI=4.0*ATAN(1.0)
      ND=12*NM*NM
      TWOPI=2.0*PI
      PID12=PI/12.0
      PID2=PI/2
      THPID2=3*PID2
C
C  Assign correct values to restricted reflections
C  Store in Fas and Pmx!
C
      CALL REGFAS(PMX,IJPA,IJQA,FAS,NM,NFS,NIJQA)
C
C  INITIALIZE FUDGE FACTOR, ETC.
C
      ICYC=1
C
C  New cycle of refinement, current phases are stored in W(*)
C
      FUD=1
      SSNO=10000
      IF(IOPT.EQ.0)GOTO 900
C
C  CALCULATE SSNE, based on phases in Fas
C
240   CONTINUE
      CALL DET2(NM,EMX,PMX,AMX,WORK,RWORK,IWORK,DAMX,IJPA,
     1 NFS,IJQA,NIJQA,FAS,SSNE,NVECT,1,LWORK,LRWORK,LIWORK)
      IF(ICYC.EQ.1)WRITE(LO,1)SSNE
      DELTA=SSNO-SSNE
      SSNO=SSNE
      DO 280 I=1,NFS
280   W(I)=FAS(I)
    1 FORMAT(/,' OPDETA: Initial value of SSNE=',E12.4)
      CALL JAAP2(BMX,AMX,DAMX,NVECT,CMX,DMX,NM)
      IF(DELTA/SSNE.LT..005)GOTO 900
C
C  CMX AND DMX CONTAIN THE APPROXIMATION OF AMX IN MODULI, PHASES
C  DAMX CONTAINS THE EIGENVECTORS OF AMX
C  NOW CALCULATE THE SHIFTS WITHOUT FUDGE FACTORS SOFAR
C
      CALL SCHUIF(NM,DMX,WS,W,IJPA,
     1 IJQA,NFS,NIJQA,SHIFT)
C     Write(LO,1001)ICYC,FUD,DELTA,SHIFT,SSNE
      IF(SHIFT.LT.1.0E-4)GOTO 900
C1001  Format(' Cycle, FUD, DELTA, SHIFT, SSNE: ',I5,4E12.4)
      IF(ICYC.EQ.1)THEN
      DO 459 JJ=1,3
      DO 457 I=1,NFS
      HOEK=W(I)+WS(I)*FUD
      FAS(I)=ATAN2(SIN(HOEK),COS(HOEK))
  457 CONTINUE
      CALL DET2(NM,EMX,PMX,AMX,WORK,RWORK,IWORK,DAMX,IJPA,
     1 NFS,IJQA,NIJQA,FAS,SSNE,NVECT,0,LWORK,LRWORK,LIWORK)
      DE(JJ)=SSNO-SSNE
      FUD=FUD+JJ*3
459   CONTINUE
      B=-84.0*DE(1)+99.0*DE(2)-15.0*DE(3)
      A=6.0*DE(1)-9.0*DE(2)+3*DE(3)
      FUD=-B/(2.0*A)
      IF(FUD.LT.0.0)FUD=1.0
      ENDIF
      DO 458 I=1,NFS
      HOEK=W(I)+WS(I)*FUD
      FAS(I)=ATAN2(SIN(HOEK),COS(HOEK))
458   CONTINUE
      ICYC=ICYC+1
      IF(ICYC.LT.ICMAX)GOTO 240
  900 CONTINUE
      IF(IOPT.NE.0)THEN
      CALL REGFAS(PMX,IJPA,IJQA,W,NM,NFS,NIJQA)
      CALL DET2(NM,EMX,PMX,AMX,WORK,RWORK,IWORK,DAMX,IJPA,
     1 NFS,IJQA,NIJQA,W,SSNE,NVECT,0,LWORK,LRWORK,LIWORK)
      WRITE(LO,901)ICYC,FUD,SHIFT,SSNE
  901 FORMAT(/,' OPDETA: Final cycle, FUD, SHIFT, SSNE:',I5,3E12.4)
      WRITE(HITS(2,ICYCLE),903)ICYC,FUD,SHIFT,SSNE
      WRITE(IHITS,903)ICYC,FUD,SHIFT,SSNE
  903 FORMAT('OPDETA: Final cycle, FUD, SHIFT, SSNE:',I5,3E12.4)
      ELSE
      CALL DET2(NM,EMX,PMX,AMX,WORK,RWORK,IWORK,DAMX,IJPA,
     1 NFS,IJQA,NIJQA,FAS,SSNE,NVECT,0,LWORK,LRWORK,LIWORK)
      WRITE(LO,902)SSNE
902   FORMAT(' OPDETA: Initial SSNE:',E20.10)
      ENDIF
      RETURN
      END
      SUBROUTINE OPDETI(NM,EMX,IJP,NIJP,IJQ,NIJQ,IJPA,IJQA,
     1 NFS,NIJQA,ELIM)
C
C  PARAMETERS
C
C  NM = INPUT = ORDER OF SUBDETERMINANT
C
C  NHKLF = INPUT =
C  =1 INPUT REFLECTION FILE CONTAINS PHASE INFORMATION
C  =0 AB INITIO PHASING
C
C  EMX(NM,NM) = INPUT =
C  E-VALUES IN THE LOWER TRIANGLE
C
C  IJP,IJQ = INPUT = STRUCTURE OF THE MATRIX
C  IJPA,IJQA = OUTPUT = CONTAINS VARIABLES FOR OPDETA
C  NFS  = OUTPUT = NUMBER OF VARIABLES ACTUALLY REFINED
C  NIJQA = OUTPUT = CORRESPONDING NUMBER OF RELATIONS
C
C  ELIM = INPUT = REFLEXIONS WITH E<ELIM ARE SET TO ZERO
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX
      LOGICAL ENUL,REFINE
      DIMENSION EMX(NM,NM)
      DIMENSION IJP(5,NIJP),IJPA(5,NIJP),IJQ(6,NIJQ),
     1 IJQA(6,NIJQ)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
C
C  IJPA AND IJQA ARE INITIALIZED. ONLY THE INFORMATION
C  PERTAINING TO THE REFLEXIONS TO BE REFINED IS USED
C
      NIJPA=0
      NIJQA=0
      E0=EMX(1,1)
      DO 50 I=1,NIJP
      IRY=IJP(1,I)
      IKO=IJP(2,I)
      IBE=IJP(3,I)
      IEI=IJP(4,I)
C      IF(I/100*100.EQ.I)THEN
C      Write(LO,1235)I,IRY,IKO,EMX(IRY,IKO),IBE,IEI
C1235  Format(' Nummer, rij, kolom, E,',3I5,E12.4,2I5)
C1244  Format(' ',6I5)
C      Write(LO,1244)(IJP(L,I),L=1,5)
C      IF(IEI.NE.0)THEN
C      Write(LO,1244)((IJQ(L,JL),L=1,6),JL=IBE,IEI)
C      ENDIF
C      ENDIF
      ENUL=EMX(IRY,IKO).GT.ELIM
      IF(.NOT.ENUL)EMX(IRY,IKO)=0.0
C
C  SKIP IJP IF REFLEXIONS ARE NOT TO BE REFINED
C
      REFINE=.TRUE.
      REFINE=REFINE.AND.ENUL
C      Write(6,*)REFINE
      IF(REFINE)THEN
      NIJPA=NIJPA+1
      IBEA=NIJQA+1
      DO 551 L=1,5
  551 IJPA(L,NIJPA)=IJP(L,I)
      IF(IEI.GT.0)THEN
      IJPA(3,NIJPA)=IBEA
      IJPA(4,NIJPA)=IBEA+IEI-IBE
      DO 30 J=IBE,IEI
C
C  COPY RELEVANT RELATIONS IN IJQA
C
      NIJQA=NIJQA+1
      DO 570 L=1,6
      IJQA(L,NIJQA)=IJQ(L,J)
  570 CONTINUE
   30 CONTINUE
      ENDIF
      ELSE
      IF(IEI.GT.0.AND.(.NOT.ENUL))THEN
      DO 31 J=IBE,IEI
C
C  ZERO E's IF REQUIRED
C
      IRY=IJQ(1,J)
      IKO=IJQ(2,J)
      EMX(IRY,IKO)=0.0
      EMX(IKO,IRY)=0.0
   31 CONTINUE
      ENDIF
      ENDIF
   50 CONTINUE
C
C  NUMBER OF INDEPENDENT VARIABLES
C
      NFS=NIJPA
C
C  MAXIMUM NUMBER OF ITERATIONS
C
      NFS2=2*NFS
C
C  NORMALIZE E'S
C
      DO 100 I=1,NM
      DO 100 J=1,I
      IF(EMX(I,J).GT.0.001)THEN
      EMX(I,J)=EMX(I,J)/E0
      EMX(J,I)=EMX(I,J)
      ENDIF
  100 CONTINUE
      IF(NFS.EQ.0)THEN
      WRITE(LO,13)
   13 FORMAT(' OPDETI: No phases are to be refined')
      ELSE
      WRITE(LO,14)NFS
14    FORMAT(' OPDETI: ',I5,' Phases will be refined')
      ENDIF
      RETURN
      END
      SUBROUTINE OPINIT(A,N,NM,NR,NC,IJP,NIJP,IJQ,NIJQ,
     1 LCIJPA,LCIJQA,EMX,LOCAMX,LOCBMX,LOCCMX,LOCDMX,LCDAMX,
     2 LOCWRK,LOCWRR,LOCWRI,LOCIFA,LOCWWW,
     3 LWORK,LRWORK,LIWORK,LOCFAS,IFIRST,JFIRST,
     4 KFIRST,NFS,NIJQA,ELIM)
      implicit REAL*4 (A-H,O-Z)
      INTEGER DIARUI
      INTEGER A(N)
C     DIMENSION B(NR)
C     COMPLEX C(NC)
      DIMENSION IJP(5,NIJP),IJQ(6,NIJQ)
      DIMENSION EMX(NM,NM)
      INCLUDE '../common/unit.f'
      KFIRST=1
      LCIJPA=IFIRST
      IFIRST=IFIRST+5*NIJP
      LCIJQA=IFIRST
      IFIRST=IFIRST+6*NIJQ
      MATRUI=NM*NM
      DIARUI=nm
C
C Amx is complex as is Bmx, used for the eigenvectors of Amx
C Work(Lwork)is complex as well
C
      LOCAMX=KFIRST
      KFIRST=KFIRST+MATRUI
      LOCBMX=KFIRST
      KFIRST=KFIRST+MATRUI
      LOCCMX=JFIRST
      JFIRST=JFIRST+MATRUI
      LOCDMX=JFIRST
      JFIRST=JFIRST+MATRUI
      LCDAMX=JFIRST
      JFIRST=JFIRST+DIARUI
      LOCWRK=KFIRST
      LWORK=2*NM+MATRUI
      KFIRST=KFIRST+LWORK
      LOCWRR=JFIRST
      LRWORK=4*NM+1+2*NM*INT(LOG(FLOAT(NM))/LOG(FLOAT(2))+1)+3*MATRUI
      JFIRST=JFIRST+LRWORK
      LOCWRI=IFIRST
      LIWORK=6*NM+3
      IFIRST=IFIRST+LIWORK
      LOCIFA=IFIRST
      IFIRST=IFIRST+NM
      LOCFAS=JFIRST
      JFIRST=JFIRST+NIJP
      LOCWWW=JFIRST
      JFIRST=JFIRST+12*MATRUI
      CALL ROOM(N,IFIRST-1,NR,JFIRST-1,NC,KFIRST-1,0,LO)
      CALL OPDETI(NM,EMX,IJP,NIJP,IJQ,NIJQ,A(LCIJPA),A(LCIJQA),NFS,
     1 NIJQA,ELIM)
      RETURN
      END
      SUBROUTINE RANATM(X,NATO,NADIM,NEIND,NTRIAL)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION X(4,NADIM,NEIND),NATO(NEIND)
      INCLUDE '../common/const.f'
      NA=0
      DO 1 I=1,8
      K=JZ(I)
      IF(K.EQ.0)RETURN
      IF(K.EQ.1)GOTO 1
      J=0
2     CONTINUE 
      NA=NA+1
      IF(NA.GT.NATOM)THEN  
      NATO(NTRIAL)=NA-1
      RETURN
      ENDIF
C     READ(68,123)(X(JJJ,NA,NTRIAL),JJJ=2,4)
C123   FORMAT(11x,3F10.0)
      X(2,NA,NTRIAL)=RANDOM(0)
      X(3,NA,NTRIAL)=RANDOM(0)
      X(4,NA,NTRIAL)=RANDOM(0)
      CALL SMLT(X(2,NA,NTRIAL),BGR)
      IF(BGR.GT.1.01.OR.NOSPC.NE.0)THEN
      NA=NA-1
      GOTO 2
      ENDIF
      X(1,NA,NTRIAL)=K
      J=J+1
      IF(J.LT.JN(I))GOTO 2
1     CONTINUE
      NATO(NTRIAL)=NA
      RETURN
      END
      SUBROUTINE READX(X,NATO,NATOM,IB,IE)
      INCLUDE '../common/unit.f'
      DIMENSION X(4,NATOM,IE),NATO(IE)   
      I=IB-1
1     CONTINUE
      I=I+1
      IF(I.GT.IE)GO TO 3
      READ(68,10)NAT
      NATO(I)=NAT
      IF(NAT.GT.0)THEN
      DO 2 J=1,NAT
      READ(68,11)(X(K,J,I),K=1,4)
2     CONTINUE
      X(1,NAT,I)=-100.0*X(1,NAT,I)
      ELSE
      IE=IE-1
      I=I-1
      ENDIF
      GOTO 1
3     CONTINUE
10    FORMAT(I5)
11    FORMAT(4F10.0)
      RETURN
      END
      SUBROUTINE READXX(X,NTRUE,NATOM,NMAT)
      INCLUDE '../common/unit.f'
      DIMENSION X(4,NATOM,NMAT)
      REWIND 69
      ITEL=1
3     CONTINUE
      READ(69,10)NAT
      IF(NAT.GT.0)THEN
      DO 2 J=1,NAT
      READ(69,11)(X(K,J,ITEL),K=1,4)
2     CONTINUE
      ENDIF
      IF(ITEL.EQ.NTRUE)RETURN
      ITEL=ITEL+1
      GO TO 3
10    FORMAT(I5)
11    FORMAT(4F10.0)
      END
      SUBROUTINE REGFAS(PMX,IJP,IJQ,FAS,NM,NIJP,NIJQ)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION IJP(5,NIJP),IJQ(6,NIJQ),FAS(NIJP),PMX(NM,NM)
C
C  GIVE SPECIAL REFLECTIONS CORRECT VALUES
C
      TWOPI=2.0*3.14159265
      PI=3.14159265
      PID2=TWOPI/4.0
      THPID2=3.0*PID2
      PID12=PID2/6.0
      DO 200 I=1,NIJP
C
C  GET ROW AND COLUMN OF VARIABLE I
C
      IRY=IJP(1,I)
      IKO=IJP(2,I)
C
C  STORE PHASE IN W
C
C  CORRECT RESTRICTED PHASE
C
      Z=PMX(IRY,IKO)
      MK=IJP(5,I)
      IF(MK.EQ.1) GOTO 180
      Y=(MK-1)*PID12
      X=MOD(Z-Y,TWOPI)
      IF(X.LT.0.0) X=X+TWOPI
      IF(X.GT.PID2.AND.X.LT.THPID2) Y=Y+PI
      Z=Y
  180 CONTINUE
      Z=MOD(Z,TWOPI)
      IF(Z.LT.0.0) Z=Z+TWOPI
      FAS(I)=Z
  200 CONTINUE
      CALL VERBA(PMX,NM,IJQ,NIJQ)
      RETURN
      END
      SUBROUTINE ROOM(N,M,NR,MR,NC,MC,IP,LO)
C
C  CHECK WHETHER SUFFICIENT CORE IS AVAILABLE
C
      IMPLICIT REAL*4 (A-H,O-Z)
      IF(IP.EQ.1)WRITE(LO,1)M,MR,MC
1     FORMAT(/,' PLAATS: ',3I10,' integer, floating and complex words '
     1 ,/,38X,'  are necessary')
      IF(M.GT.N.OR.MR.GT.NR.OR.MC.GT.NC)GOTO 1000
      RETURN
 1000 WRITE(LO,2)
      Write(LO,5)N,NR,NC
      WRITE(LO,4)M,MR,MC
4      FORMAT(/,' Necessary: ',3I10)
5      FORMAT(/,' Available: ',3I10)
    2 FORMAT(/,' ***** NOT ENOUGH CORE *****')
      STOP
      END
      SUBROUTINE SCHUIF(NM,D,W,FAS,IJP,IJQ,NFS,NIJQ,SHIFT)
C
C  NM = INPUT =
C  DECLARED DIMENSIONS OF THE MATRICES
C
C  D(NM,NM,NNRM)
C
C  IJP,IJQ: = INPUT = SEE OPINIT
C  W(NFS): = OUTPUT = SHIFTS BEFORE FUDGE
C  FAS: = INPUT = PHASES
C  GRAD: = INPUT = GRADIENTS
C
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION D(NM,NM)
      DIMENSION IJP(5,NFS),IJQ(6,NIJQ),W(NFS)
      DIMENSION FAS(NFS)
      SHIFT=0.0
      PI=4.0*ATAN(1.0)
      TWOPI=2.0*PI
      PID12=PI/12.0
      ITEL=0
      DO 320 I=1,NFS
      W(I)=0.0
C      IF(IJP(6,I).EQ.-1)GOTO 320
      ITEL=ITEL+1
      IRY=IJP(1,I)
      IKO=IJP(2,I)
      IBE=IJP(3,I)
      IEI=IJP(4,I)
      MK=IJP(5,I)
C
C  ALPHA = PHASE IN A
C  BETA = PHASE INDICATION
C
      ALPHA=FAS(I)
      BETA=D(IRY,IKO)
      FU=1
      DPA=SIN(BETA)
      DPB=COS(BETA)
      IF(IEI.EQ.0) GOTO 321
      DO 310 J=IBE,IEI
      JRY=IJQ(1,J)
      JKO=IJQ(2,J)
      ISS=IJQ(5,J)
      IT=IJQ(6,J)
      BETA=D(JRY,JKO)
      F=ISS*PID12
C
C  BETA-F--->(BETA-F)
C
      BETA=(1-2*IT)*(BETA-F)
      DPA=DPA+SIN(BETA)
  310 DPB=DPB+COS(BETA)
      BETA=ATAN2(DPA,DPB)
      FU=SQRT(DPA**2+DPB**2)/(IEI-IBE+2)
  321 CONTINUE
      S=BETA-ALPHA
      CS=COS(S)
      SS=SIN(S)
      S=ATAN2(SS,CS)
      W(I)=S*FU
C      W(I)=0.0
      SHIFT=SHIFT+ABS(S*FU)
  320 CONTINUE
      SHIFT=SHIFT/ITEL
      RETURN
      END
      SUBROUTINE TELX(IB,IE)
      ITEL=0
      IB=1
1     CONTINUE    
      READ(68,10,END=100)NAT
      ITEL=ITEL+1
      DO 2 J=1,NAT
      READ(68,11)
2     CONTINUE
      GO TO 1
10    FORMAT(I5)
11    FORMAT(4F10.0)
100   IE=ITEL
      REWIND 68
      RETURN
      END
      SUBROUTINE TEOFAS(X,H,K,L,NM,PMX,EMX,IJP,NIJP,
     1 IJQ,NIJQ,LO,ISW,NTRUE,NEIND,NADIM,IOP,NATO)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION PMX(NM,NM),EMX(NM,NM)
      DIMENSION IJP(5,NIJP),IJQ(6,NIJQ)
      DIMENSION X(4,NADIM,NEIND),NATO(NEIND)
      INCLUDE '../common/const.f'
      INTEGER H(NIJP),K(NIJP),L(NIJP)
      DO 1 I=1,NM
      DO 2 J=1,NM
      PMX(I,J)=0.0
2     CONTINUE
1     CONTINUE
      WRITE(LO,11)NTRUE
   11 FORMAT(/,' Calculate model phases',I4)
      CALL TEOFS(X,H,K,L,PMX,EMX,NM,IJP,NIJP,
     1 IJQ,NIJQ,ISW,NEIND,NADIM,IOP,NATO)
      WRITE(LO,102)
  102 FORMAT(/,' Calculation finished')
      RETURN
      END
      SUBROUTINE TEOFS(X,IH,IK,IL,PMX,EMX,NM,IJP,NIJP,IJQ,
     1 NIJQ,ISW,NEIND,NADIM,IOP,NATO)
C
C  PUTS CALCULATED PHASES IN PMX
C  GETS NATOM ATOMS FROM X(..,..,NTRUE=ISW)
C  ATOP: MULTIPLICITY*ATOMNUMBER, X, Y, Z
C
      IMPLICIT REAL*4 (A-H,O-Z)
      REAL*8 A,B,ARG
      INTEGER H(3),NATO(NEIND)
      INTEGER IH(NIJP),IK(NIJP),IL(NIJP)
      DIMENSION X(4,NADIM,NEIND),PMX(NM,NM),EMX(NM,NM),
     1 IJP(5,NIJP),IJQ(6,NIJQ)
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      TWOPI=ATAN(1.0)*8.0
C
C  GET ATOMPARAMETERS AND CALCULATE E-calc
C
      IF(IOP.LE.1)THEN
      ISWW=ISW
      NATOM=NATO(ISWW)
      ELSE
      ISWW=1
      ENDIF
      DO 200 J=1,NADIM
      IF(X(1,J,ISWW).LT.-0.01)THEN
      NATOM=J
      X(1,J,ISWW)=-X(1,J,ISWW)/100.0
      GO TO 201
      ENDIF
200   CONTINUE
C
C  LOOP OVER INDEPENDENT PHASES
C    
201   ITEL=0
C      WRITE(LO,1234)((X(I,J,ISWW),I=1,4),J=1,NATOM)
C1234  Format(4F10.3)
      DO 100 I=1,NIJP
C
C  GET HKL
C
      IRY=IJP(1,I)
      IKO=IJP(2,I)
      H(1)=IH(I)
      H(2)=IK(I)
      H(3)=IL(I)
C
C  A=REAL, B=IMAGINARY
C
      A=0.0
      B=0.0
C
C  LOOP OVER ATOMS
C
      DO 90 J=1,NATOM
C     IF(I.EQ.1)THEN
C     WRITE(LO,*)(X(JJJ,J,ISW),JJJ=2,4)
C     ENDIF
C
C  LOOP OVER SYMMETRY OPERATIONS
C
      DO 80 K=1,NSYM
      ARG=0.0
      DO 70 L=1,3
      XX=0.0
      DO 60 LL=1,2
      M=IABS(IS(LL,L,K))
      IF(M.NE.0) XX=XX+X(1+M,J,ISWW)*ISIGN(1,IS(LL,L,K))+TS(L,K)
   60 CONTINUE
      ARG=ARG+H(L)*XX
   70 CONTINUE
      ARG=TWOPI*ARG
      A=A+X(1,J,ISWW)*DCOS(ARG)
      B=B+X(1,J,ISWW)*DSIN(ARG)
   80 CONTINUE
   90 CONTINUE
      W=0.0
      IF(A.NE.0.0.OR.B.NE.0.0) W=ATAN2(B,A)
      E=EMX(IRY,IKO)*E0
      W=AMOD(W,TWOPI)
      PMX(IRY,IKO)=W
      PMX(IKO,IRY)=-W
  100 CONTINUE
C
C  IMPLEMENT SYMMETRY RELATIONS
C
      CALL VERBA(PMX,NM,IJQ,NIJQ)
      RETURN
      END
      SUBROUTINE UIT_VER(W,A,NDIM,B,NATM,ISWIT)
      IMPLICIT REAL*4 (A-H,O-Z)
C
C RECONSTRUCT A MATRIX FROM THE EIGENVECTORS.
C ONLY NATM EIGENVECTORS ARE USED, IN ORDER OF DESCENDING EIGENVALUES
C
C ISWIT<0 AND NATM=NDIM MEANS RESULT IS INVERSE OF AMX IN
C BR, BI AS REAL AND IMAGINARY
C
      DIMENSION W(NDIM)
      COMPLEX A(NDIM,NDIM),B(NDIM,NDIM)
       DO 1 I=1,NDIM
       DO 1 II=1,NDIM
        B(I,II)=CMPLX(0.0,0.0)
1     CONTINUE
      I=NDIM+1
      DO 10 J=1,NATM
      I=I-1
       IF(ISWIT.LT.0)THEN
       WEIGHT=1.0/W(I)
       ELSE
       WEIGHT=W(I)     
       ENDIF
      CALL CHER('L',NDIM,WEIGHT,A(1,I),1,B,NDIM)
10    CONTINUE
      RETURN
      END
      SUBROUTINE VERBA(PMX,IPMX,IJQ,NIJQ)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION PMX(IPMX,IPMX)
      DIMENSION IJQ(6,NIJQ)
      PID12=ATAN(1.0)/3.0
      DO 100 I=1,NIJQ
      IRY=IJQ(1,I)
      IKO=IJQ(2,I)
      JRY=IJQ(3,I)
      JKO=IJQ(4,I)
      ISS=IJQ(5,I)
      IT=IJQ(6,I)
      P=(1-2*IT)*PMX(JRY,JKO)+ISS*PID12
      P=ATAN2(SIN(P),COS(P))
      PMX(IRY,IKO)=P
      PMX(IKO,IRY)=-P
  100 CONTINUE
      RETURN
      END
      SUBROUTINE VULAMX(AMX,PMX,EMX,IA)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION PMX(IA,IA),EMX(IA,IA)
      COMPLEX AMX(IA,IA)
      AMX(1,1)=CMPLX(1.0,0.0)
      DO 8 I=2,IA
      JMAX=I-1
      AMX(I,I)=CMPLX(1.0,0.0)
      DO 5 J=1,JMAX
      IF(EMX(I,J).GT.1.0E-5)THEN
      AMX(I,J)=CMPLX(EMX(I,J)*COS(PMX(I,J)),EMX(I,J)*SIN(PMX(I,J)))
      AMX(J,I)=CONJG(AMX(I,J))
      ELSE
      AMX(I,J)=(0.0,0.0)
      AMX(J,I)=(0.0,0.0)
      ENDIF
   5  CONTINUE
   8  CONTINUE
      RETURN
      END
      SUBROUTINE VULLER(PMX,IPMX,IJP,NIJP,IJQ,NIJQ,FAS)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION PMX(IPMX,IPMX),
     1 IJP(5,NIJP),IJQ(6,NIJQ),FAS(NIJP)
C
C  STORE PHASES
C
      DO 100 I=1,NIJP
C
C  DECODE ROW AND COLUMN
C
      IRY=IJP(1,I)
      IKO=IJP(2,I)
C
C  MATRIX NUMBER
C
      PMX(IRY,IKO)=FAS(I)
      PMX(IKO,IRY)=-FAS(I)
  100 CONTINUE
      CALL VERBA(PMX,IPMX,IJQ,NIJQ)
      RETURN
      END
      SUBROUTINE WRFOUR(NM,IJP,NIJP,EMX,
     1 PMX,A,B,E0)
C
C  GET E AND PHASE FROM THE MATRIX EMX, PMX
C  SET WEAK REFLECTIONS TO ZERO
C
C  IJP, NIJP, AS USUAL
C
      IMPLICIT REAL*4 (A-H,O-Z)
      REAL*4 EMX(NM,NM),PMX(NM,NM)
      DIMENSION IJP(5,NIJP),A(NIJP),B(NIJP)
      DO 2100 I=1,NIJP
      IRY=IJP(1,I)
      KOL=IJP(2,I)
      E=E0*EMX(IRY,KOL)
      IF(E.GE.0.8) THEN 
      P=PMX(IRY,KOL)
      A(I)=E*COS(P)
      B(I)=E*SIN(P)
      ELSE
      A(I)=0
      B(I)=0
      ENDIF
 2100 CONTINUE
      RETURN
      END
      SUBROUTINE WRITEX(X,NATO,POINT,NATOM,INMAT)
      INCLUDE '../common/unit.f'
      DIMENSION X(4,NATOM,INMAT),NATO(INMAT)   
      INTEGER POINT(INMAT)
      DO 3 K=INMAT,1,-1
      IP=POINT(K)
      NAT=NATO(IP)
C     WRITE(6,*)'Aantal',IP,NATO(IP)
      WRITE(69,10)NAT
      DO 4 ITEL=1,NAT
      WRITE(69,11)(X(J,ITEL,IP),J=1,4)
4     CONTINUE
3     CONTINUE
10    FORMAT(I5)
11    FORMAT(4F10.4)
      RETURN
      END
