C  Copyright (c) Rag de Graaff, Leiden University  2004 - 2006   
C
C  This program is free software; you can redistribute it and/or
C  modify it under the terms of the GNU General Public License
C  as published by the Free Software Foundation; either version 2
C  of the License, or (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, 
C  USA.
      SUBROUTINE PMF_CELL(P,Q,V,IOPT)
C
C  CALCULATE RECIPROCAL LATTICE CONSTANTS FROM CELL PARAMETERS (IOPT=0)
C  CALCULATE CONSTANTS Q, 1/D**2=H*H*Q1+K*H*Q2 ETC (IOPT#0)
C
C  P AND Q MAY HAVE THE SAME  ADDRESS
C
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION P(6),Q(6)
      PIR=4.0*ATAN(1.0)/180.0
      CA=COS(PIR*P(4))
      CB=COS(PIR*P(5))
      CC=COS(PIR*P(6))
      SA=SIN(PIR*P(4))
      SB=SIN(PIR*P(5))
      SC=SIN(PIR*P(6))
      V=P(1)*P(2)*P(3)
     1 *SQRT(1.0-CA*CA-CB*CB-CC*CC+2.0*CA*CB*CC)
      AS=P(2)*P(3)*SA/V
      BS=P(1)*P(3)*SB/V
      CS=P(1)*P(2)*SC/V
      CAS=(CB*CC-CA)/(SB*SC)
      CBS=(CC*CA-CB)/(SC*SA)
      CCS=(CA*CB-CC)/(SA*SB)
      IF(IOPT.NE.0) GOTO 10
      Q(1)=AS
      Q(2)=BS
      Q(3)=CS
      Q(4)=ACOS(CAS)/PIR
      Q(5)=ACOS(CBS)/PIR
      Q(6)=ACOS(CCS)/PIR
      GOTO 9999
   10 CONTINUE
      Q(1)=AS**2
      Q(2)=BS**2
      Q(3)=CS**2
      Q(4)=2.0*AS*BS*CCS
      Q(5)=2.0*BS*CS*CAS
      Q(6)=2.0*CS*AS*CBS
 9999 RETURN
      END
      SUBROUTINE CENTRE(J,L,MLAT,TL)
C
C  CF MULTAN80
C
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION TL(3,4),TST(21)
      DATA TST/0.,0.,0., 0.,.5,.5, .5,0.,.5, .5,.5,0., .5,.5,.5,
     1 .333333,.666667,.666667, .666667,.333333,.333333/
      MLAT=J
      M=3*L-2
      TL(1,J)=TST(M)
      TL(2,J)=TST(M+1)
      TL(3,J)=TST(M+2)
      RETURN
      END
      SUBROUTINE CMPLFT(X,Y,NSIZE,N,D)
      REAL X(NSIZE),Y(NSIZE)
      INTEGER D(5),PMAX,PSYM,TWOGRP,FACTOR(15),SYM(15),UNSYM(15)
C
C  COMPLEX FINITE DISCRETE FOURIER TRANSFORM
C  TRANSFORMS ONE DIMENSION OF A MULTIDIMENSIONAL PROBLEM
C  MODIFIED BY L.F. TEN EYCK FROM A ONE DIMENSIONAL VERSION WRITTEN
C  BY G.T. SANDE, 1969
C
C  THIS PROGRAM CALCULATES THE TRANSFORM
C  (X(T)+I*Y(T))*(COS(2*PI*T/N)-I*SIN(2*PI*T/N))
C
      PMAX=5
      TWOGRP=4
      CALL S R FP (N,PMAX,TWOGRP,FACTOR,SYM,PSYM,UNSYM)
      CALL MDFTKD (N,FACTOR,D,X,Y,NSIZE)
      CALL DIPRP  (N,SYM,PSYM,UNSYM,D,X,Y,NSIZE)
      RETURN
      END
      SUBROUTINE DFFR(N1,N2,IDIFF)
      DIMENSION IDIFF(19)
C
C  FILL ARRAY IDIFF WITH NEIGHBOUR CONDITIONS
C
      IDIFF(1)=-N1-1
      IDIFF(2)=-N1-N2
      IDIFF(3)=-N1
      IDIFF(4)=-N1+N2
      IDIFF(5)=-N1+1
      IDIFF(6)=-N2-1
      IDIFF(7)=-1
      IDIFF(8)=N2-1
      IDIFF(9)=-N2
      IDIFF(10)=0
      DO 1 I=1,9
      IDIFF(20-I)=-IDIFF(I)
    1 CONTINUE
      RETURN
      END
      SUBROUTINE DIPRP (PTS, SYM, P SYM, UN SYM, DIM, X, Y, NSIZE)
C**** DOUBLE IN PLACE REORDERING PROGRAM
C****
      REAL X(NSIZE), Y(NSIZE)
      INTEGER SYM(10), UNSYM(10), DIM(5), PTS, PSYM, DK, PUNSYM, TEST
      LOGICAL ONE MOD
      INTEGER SEP, DELTA, P, P0, P1, P2, P3, P4, P5, SIZE
      INTEGER V(14), MODULO(14), S(14), U(14)
C****
      NEST=14
C****
      NT = DIM(1)
      SEP = DIM(2)
      P2 = DIM(3)
      SIZE = DIM(4) - 1
      P4 = DIM(5)
      IF (SYM(1).EQ.0) GO TO 500
      DO 100 J=1,NEST
      U(J)=1
      S(J)=1
  100 CONTINUE
      N=PTS
      DO 200 J=1,NEST
      IF (SYM(J).EQ.0) GO TO 300
      JJ=NEST+1-J
      U(JJ)=N
      N=N/SYM(J)
      S(JJ)=N
  200 CONTINUE
  300 JJ=0
      L=1
      V(1)=1
  310 L=L+1
      V(L)=V(L-1)
  320 IF(L.LT.NEST) GO TO 310
      N=V(NEST)
      JJ=JJ+1
      IF (JJ.GE.N) GO TO 400
      DELTA = (N-JJ)*SEP
      P1 = (JJ-1)*SEP + 1
      DO 350 P0 = P1, NT, P2
      P3 = P0 + SIZE
      DO 350 P = P0, P3, P4
      P5 = P + DELTA
      T = X(P)
      X(P) = X(P5)
      X(P5) = T
      T = Y(P)
      Y(P) = Y(P5)
      Y(P5) = T
  350 CONTINUE
  400 V(L)=V(L)+S(L)
      IF(V(L).LE.U(L)) GO TO 320
      L=L-1
      IF(L.NE.0) GO TO 400
C****
  500 IF (UN SYM(1).EQ.0) GO TO 1900
      P UN SYM=PTS/P SYM**2
      MULT=P UN SYM/UN SYM(1)
      TEST=(UN SYM(1)*UN SYM(2)-1)*MULT*P SYM
      LK=MULT
      DK=MULT
      DO 600 K=2,NEST
      IF (UN SYM(K).EQ.0) GO TO 700
      LK=LK*UN SYM(K-1)
      DK=DK/UN SYM(K)
      U(K)=(LK-DK)*P SYM
      MODS=K
  600 CONTINUE
  700 ONE MOD=MODS.LT.3
      IF (ONE MOD) GO TO 900
      DO 800 J=3,MODS
      JJ=MODS+3-J
      MODULO(JJ)=U(J)
  800 CONTINUE
  900 MODULO(2)=U(2)
      JL=(P UN SYM-3)*P SYM
      MS=P UN SYM*P SYM
C****
      DO 1800 J=P SYM,JL,P SYM
      K=J
C****
 1000 K=K*MULT
      IF (ONE MOD) GO TO 1200
      DO 1100 I=3,MODS
      K=K-(K/MODULO(I))*MODULO(I)
 1100 CONTINUE
 1200 IF (K.GE.TEST) GO TO 1300
      K=K-(K/MODULO(2))*MODULO(2)
      GO TO 1400
 1300 K=K-(K/MODULO(2))*MODULO(2)+MODULO(2)
 1400 IF (K.LT.J) GO TO 1000
C****
      IF (K.EQ.J) GO TO 1800
      DELTA = (K-J)*SEP
      DO 1600 L=1,P SYM
      DO 1500 M=L,PTS,MS
      P1 = (M+J-1)*SEP + 1
      DO 1500 P0 = P1, NT, P2
      P3 = P0 + SIZE
      DO 1500 JJ = P0, P3, P4
      KK = JJ + DELTA
      T=X(JJ)
      X(JJ)=X(KK)
      X(KK)=T
      T=Y(JJ)
      Y(JJ)=Y(KK)
      Y(KK)=T
 1500 CONTINUE
 1600 CONTINUE
 1800 CONTINUE
 1900 RETURN
      END
      SUBROUTINE DSTNCE(X1,ORT,DST)
      DIMENSION X1(3),ORT(3,3)
C
C  CALCULATE LENGTH OF X1
C  ORT IS THE ORTOGONALISATION MATRIX
C
      DST=0.
      DO 10 I=1,3
      XO=0.
      DO 1 II=1,3
    1 XO=XO+X1(II)*ORT(I,II)
   10 DST=DST+XO*XO
      RETURN
      END
       INTEGER FUNCTION EVEN(I)
       K=I/2*2
       IF(K.LT.I)THEN
       EVEN=I
       ELSE
       EVEN=I+1
       ENDIF
       RETURN
       END
      SUBROUTINE EXFFT(AC,LH,LK,LL,X,Y,IY,IH,G)
C
C  ADAPTED FROM EXFFT80 OF THE MULTAN SYSTEM
C  CALCULATES UNSHARPENED PATTERSON
C
      DIMENSION AC(NREF_PMF),LH(NREF_PMF),LK(NREF_PMF),LL(NREF_PMF)
      DIMENSION X(NRX),Y(NRX),IH(NRS),G(2,NRS),I1(3),I2(3),NP(3),
     1 KIND(24),IY(NRX)
      INCLUDE 'common/unit.f'
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/const.f'
      INCLUDE 'common/pack.f'
      INCLUDE 'common/locaut.f'
      COMMON /PARAM/ CELL(6),Q(6)
      COMMON/SCL/SCALE
      INTEGER HMAX
      TWOPI=2.0*3.14159265
      DTOR=TWOPI/360.0
      NEX=0
      DO 1 I=1,NRX
      X(I)=0.0
      Y(I)=0.0
1     CONTINUE
      DO 2 I=1,NRS
      DO 3 K=1,2
      G(K,I)=0.0
3     CONTINUE
      IH(I)=0
2     CONTINUE
      NSIZE=NRX
      NP(1)=NX
      NP(2)=NY
      NP(3)=NZ
      FSUM=0.
      IP5=256*(262144+512+1)
      MH(1)=0
      MH(2)=0
      MH(3)=0
      DO 699 I=1,NREF_PMF
      IF(ABS(AC(I)).GE.1.0E-4)THEN
      I1(1)=LH(I)
      I1(2)=LK(I)
      I1(3)=LL(I)
      IF(MH(1).LT.IABS(I1(1)))MH(1)=IABS(I1(1))
      IF(MH(2).LT.IABS(I1(2)))MH(2)=IABS(I1(2))
      IF(MH(3).LT.IABS(I1(3)))MH(3)=IABS(I1(3))
      DO 701 J=1,3
      IF(I1(J).EQ.0)GOTO 701
      IF(I1(J).GT.0)GOTO 703
C     IF(I1(J))702,701,703
      DO 710 JJ=1,3
710   I1(JJ)=-I1(JJ)
      GO TO 703
701   CONTINUE
703   CONTINUE
      DO 700 J=1,NSYM
      DO 540 JJ=1,3
  540 I2(JJ)=0
      DO 550 JJ=1,3
      DO 550 K=1,2
      M=IABS(IS(K,JJ,J))
      IF(M.GT.0)I2(M)=I2(M)+I1(JJ)*ISIGN(1,IS(K,JJ,J))
  550 CONTINUE
      B1=1.0
      JS=1
      IF(I2(3).GT.0)GOTO 600
      IF(I2(3).LT.0)GOTO 590
C     IF(I2(3))590,570,600
      IF(I2(1).GT.0)GOTO 600
      IF(I2(1).LT.0)GOTO 590
C 570 IF(I2(1))590,580,600
      IF(I2(2).GE.0)GOTO 600
C 580 IF(I2(2))590,600,600
  590 JS=-1
  600 KIND(J)=IP5+JS*(262144*I2(1)+512*I2(2)+I2(3))
      DO 610 KI=1,3
      IF(IABS(I2(KI)).GE.NP(KI)/2)GOTO 700
C
C*****  IF(I2(KI).GT.MH(KI))MH(KI)=I2(KI)
C
 610  CONTINUE
      ND=J-1
      IF(ND.EQ.0)GOTO 630
      DO 620 KI=1,ND
      IF(KIND(J).EQ.KIND(KI))GOTO 700
  620 CONTINUE
  630 NEX=NEX+1
      GR=AC(I)
      FSUM=FSUM+GR
      IH(NEX)=KIND(J)
      G(1,NEX)=GR
  700 CONTINUE
      ENDIF
  699 CONTINUE
      SCALE=3000./FSUM
      CALL PP1(X,Y,IY,NSIZE,IH,G,NEX)
      RETURN
      END
      SUBROUTINE GRID(NX,NY,NZ,DN)
      DIMENSION NGRD(3)
      COMMON /PARAM/ CEL(6),Q(6)
      COMMON/SRCH/IDIFF(19),DX,DY,DZ,NXZ,NXZ3,NXP2
C
C  CALCULATE GRID SPACINGS
C
      DO 100 I=1,3
      IF(DN.GT.0.80)THEN
      NGRD(I)=(2.5/DN)*CEL(I)+0.5
      ELSE
      NGRD(I)=3*CEL(I)+0.5
      ENDIF
      IF(I.EQ.3)NGRD(I)=NGRD(I)+MOD(NGRD(I),2)
C
C  THIRD INDEX MUST BE EVEN
C
   10 NTST=NGRD(I)
      DO 20 II=2,5
   21 IF(NTST.NE.(NTST/II)*II)GOTO 20
      NTST=NTST/II
      IF(NTST.EQ.1)GOTO 100
      GOTO 21
   20 CONTINUE
      NGRD(I)=NGRD(I)+1
      IF(I.EQ.3)NGRD(I)=NGRD(I)+1
      GOTO 10
  100 CONTINUE
      NX=NGRD(1)
      NY=NGRD(2)
      NZ=NGRD(3)
      NXP2=NX+2
      NXZ=NXP2*(NZ+2)
      NXZ3=NXZ*3
      DX=1.0/FLOAT(NX)
      DY=1.0/FLOAT(NY)
      DZ=1.0/FLOAT(NZ)
      RETURN
      END
      SUBROUTINE GRIDP(XYZ,IP,X,IX1,IX2,NPIEK,SS)
      DIMENSION X(3),IX1(3,24),IX2(3,24),XYZ(4,NPIEK),SS(3)
      DIMENSION XK(3),YK(3)
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/group.f'
      COMMON/SRCH/IDIFF(19),DX(3),NXZ,NXZ3,NXP2
      DO 1 I=1,3
      SS(I)=RANDOM(0)
      X(I)=XYZ(I,IP)+SS(I)
1     CONTINUE
C      READ(77,1111)(X(I),I=1,3)
C      READ(77,1111)(SS(I),I=1,3)
C1111  FORMAT(11x,3F10.3)
      DO 3 J=1,NSYM
      DO 2 I=1,3
      XX=0.0
      YY=0.0
      XX=X(1)*FS(1,I,J)+X(2)*FS(2,I,J)+X(3)*FS(3,I,J)
      YY=SS(1)*FS(1,I,J)+SS(2)*FS(2,I,J)+SS(3)*FS(3,I,J)
      XX=XX+TX(I,J)
      YY=YY+TS(I,J)
      XX=MOD(XX,1.0)
      YY=MOD(YY,1.0)
      IF(XX.LT.0.0)XX=XX+1.0
      IF(YY.LT.0.0)YY=YY+1.0
      IX1(I,J)=XX/DX(I)+1.5
      IX2(I,J)=YY/DX(I)+1.5
      XK(I)=XX
      YK(I)=YY
2     CONTINUE
C        WRITE(6,200)(IX1(I,J),I=1,3),(XK(I),I=1,3)
C       WRITE(6,200)(IX2(I,J),I=1,3),(YK(I),I=1,3)
C200   FORMAT(3I5,3F10.4)
3     CONTINUE
      RETURN
      END
      SUBROUTINE HERMFT(X,Y,NSIZE,N,DIM)
      REAL X(NSIZE),Y(NSIZE)
      INTEGER DIM(5),D2,D3,D4,D5
      DATA TWOPI/6.28319/
C
C  HERMITIAN SYMMETRIC FOURIER TRANSFORM
C
      TWON=FLOAT(2*N)
      NT=DIM(1)
      D2=DIM(2)
      D3=DIM(3)
      D4=DIM(4)-1
      D5=DIM(5)
      DO 100 I0=1,NT,D3
      I1=I0+D4
      DO 100 I=I0,I1,D5
      A=X(I)
      B=Y(I)
      X(I)=A+B
      Y(I)=A-B
  100 CONTINUE
      NOVER2=N/2+1
      IF(NOVER2.LT.2)GOTO 500
      DO 200 I0=2,NOVER2
      ANGLE=TWOPI*FLOAT(I0-1)/TWON
      CO=COS(ANGLE)
      SI=SIN(ANGLE)
      K=(N+2-2*I0)*D2
      K1=(I0-1)*D2+1
      DO 200 I1=K1,NT,D3
      I2=I1+D4
      DO 200 I=I1,I2,D5
      J=I+K
      A=X(I)+X(J)
      B=X(I)-X(J)
      C=Y(I)+Y(J)
      D=Y(I)-Y(J)
      E=B*CO+C*SI
      F=B*SI-C*CO
      X(I)=A+F
      X(J)=A-F
      Y(I)=E+D
      Y(J)=E-D
  200 CONTINUE
      CALL CMPLFT(X,Y,NSIZE,N,DIM)
  500 CONTINUE
      RETURN
      END
      SUBROUTINE INPUT(A,NI,R,NR,IFIRST,JFIRST,NBEGIN,NEIND,RESO)
      INTEGER A(NI),EVEN
      DIMENSION R(NR)
      INCLUDE 'common/unit.f'
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/const.f'
      INCLUDE 'common/pack.f'
      INCLUDE 'common/locaut.f'
      COMMON /PARAM/ CELL(6),Q(6)
 
C
C NATOM THE NUMBER TO BE FOUND
C
      CALL SPESIN(NBEGIN,NEIND)
      LOCREF=JFIRST
      REWIND(IREFL)
      JFIRST=EVEN(LOCREF+NREF_PMF)
      CALL PLAATS(NI,IFIRST-1,NR,JFIRST-1,1,LO)
C
C   NREF_PMF IS THE DIMENSION FOR ALL VARIABLES INVOLVING STRUCTUREFACTORS
C
      LOCFO=LOCREF
      JFIRST=EVEN(LOCREF+NREF_PMF)
      LOCAH=IFIRST
      LOCAK=EVEN(LOCAH+NREF_PMF)
      LOCAL=EVEN(LOCAK+NREF_PMF)
      IFIRST=EVEN(LOCAL+NREF_PMF)
      CALL RFLIN1(R(LOCFO),A(LOCAH),A(LOCAK),A(LOCAL),RESO)
      DN=RESO
      MH(1)=MAX(MH(1),MH(2))
      MH(2)=MAX(MH(1),MH(2))
      NRS=2*NSYM*NREF_PMF
      NRS2=2*NRS
      LOCBYM=IFIRST
      LOCSYM=JFIRST
      CALL GRID(NX,NY,NZ,DN)
      NRX=MAX0(2*NY*(MH(3)+1)*(2*MH(1)+1),(NY+2)*(NX+2)*(NZ+2),NRS)
      JFIRST=EVEN(LOCSYM+NRX)
      IFIRST=EVEN(LOCBYM+NRX)
      LSTORE=JFIRST
      JFIRST=EVEN(LSTORE+NRX)
      LBORE=IFIRST
      IFIRST=EVEN(LBORE+NRX)
      CALL PLAATS(NI,IFIRST-1,NR,JFIRST-1,0,LO)
      LOCIH=IFIRST
      LOCG=JFIRST
      IFIRST=EVEN(LOCIH+NRS)
      JFIRST=EVEN(LOCG+NRS2)
      CALL PLAATS(NI,IFIRST-1,NR,JFIRST-1,0,LO)
      NAT6=6*NQV*NATOM
      LOCPO=JFIRST
      JFIRST=EVEN(JFIRST+10*NATOM)
      NATS=(2+3*NSYM)*NQV*NATOM
      CALL PLAATS(NI,IFIRST-1,NR,JFIRST-1,1,LO)
      RETURN
      END
      SUBROUTINE INSPEC(NBEGIN,NEIND,FRAC)
C
C  READ KEYWORDED PARAMETERS
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX,S
      CHARACTER*4 LTC*1,LTT*1
      DIMENSION LTC(7),S(9),T(3)

C Things for CCP4 parser
      integer maxtok,ntok
      parameter (maxtok = 200)
      integer ibeg(maxtok), iend(maxtok), ityp(maxtok), idec(maxtok)
      integer nspgrx, nsymx, nsympx
      real fvalue(maxtok), rsymx(4,4,384)
      logical lsymm, lcell, lend
      character str*500
      character*4 key, cvalue(maxtok)
      character spgrnx*20, pgnamx*10

      INCLUDE 'common/symtry.f'
      INCLUDE 'common/unit.f'
      COMMON /PARAM/ PARA(6),Q(6)
      INCLUDE 'common/const.f'
      INCLUDE 'common/group.f'
      INCLUDE 'common/detpar.f'
      DATA LTC /'P','A','B','C','I','F','H'/

      lsymm=.false.
      lcell=.false.
      NPATT=1
      STLIM=4.0
      TITLE='CCP4 version of PMF '
* Parse user input
 100  continue

      str = ' '
      ntok = maxtok
      call parser (key, str, ibeg, iend, ityp, fvalue, cvalue,
     $     idec, ntok, lend, .true.)
      if (lend) go to 20

*     TITLE keyword 
      if (key .eq. 'TITL') then
         TITLE = str(ibeg(2):iend(ntok))
         goto 100

*     TRY keyword - read in range of trials
      else if (key .eq. 'TRY') then
         IF (NTOK.GE.2) NBEGIN = NINT(FVALUE(2))
         IF (NTOK.GE.3) NEIND = NINT(FVALUE(3))
         go to 100

*     NCOO keyword - read in NCOO
      else if (key .eq. 'NCOO') then
         IF (NTOK.GE.2) THEN
           NCOOR = NINT(FVALUE(2))
           FRAC=NCOOR/10.0
         ENDIF
         go to 100

*     CELL keyword - read in the cell parameters
      else if (key .eq. 'CELL') then
         call rdcell (2, ityp, fvalue, ntok, PARA)
         lcell = .true.
         go to 100

*      keyword - read in number of atoms to look for 
C          (format allows up to 8 ??)
      else if (key .eq. 'NATO') then
         JN(1) = NINT(FVALUE(2))
         go to 100

*      keyword - read in scattering factor of atoms (15 is fine)
C          (format allows up to 8 ??)
      else if (key .eq. 'SCAT') then
         JZ(1) = NINT(FVALUE(2))
         go to 100

*     SYMM keyword
      else if (key .eq. 'SYMM') then
         call rdsymm (2, str, ibeg, iend, ityp, fvalue, ntok,
     $        spgrnx, nspgrx, pgnamx, nsymx, nsympx, rsymx)
         LTT = spgrnx(1:1)
C note, NSYM is interpreted as number of primitive operators
         NSYM = nsympx
         lsymm = .true.
         goto 100

C
C Some keywords that take care of pmf_cdat input
C
      else if (key.eq.'NPAT')then
      NPATT=NINT(FVALUE(2))
      GOTO 100
      else if (key.eq.'ISTL')then
      STLIM=NINT(FVALUE(2))/10.0
      IF(STLIM.LT.0.4)STLIM=0.4
      GO TO 100
*     END keyword
      else if (key .eq. 'END') then
         goto 20
*     else error
      else
        call ccperr (1, 'Bad keyword: '//key)
      endif

C end of keyworded input
 20   continue

      if (.not.lcell) call ccperr (1, 'CELL keyword compulsory.')
      if (.not.lsymm) call ccperr (1, 'SYMM keyword compulsory.')

      DO 10 KKK=1,NSYM
        DO I=1,3
          DO J=1,3
            S(J+(I-1)*3) = RSYMX(I,J,KKK)
          ENDDO
          T(I) = RSYMX(I,4,KKK)
        ENDDO
      CALL MAKES(S,T,TS(1,KKK),IS(1,1,KKK))
10    CONTINUE

      WRITE(LO,1)
    1 FORMAT(' Control parameters:')
      WRITE(LO,2) TITLE,PARA,JN,JZ,LTT,NSYM
    2 FORMAT
     1 (' Title: ',A80,/
     2 ,' Cell:  ',6F10.4,/
     3 ,' JN:    ',8I5,/
     4 ,' JZ:    ',8I5,/
     6 ,' LATT:  ',4X,A1,/
     7 ,' NSYM:  ',I5,/)

      WRITE(LO,6)
6     FORMAT(20X,'Generating Patterson friendly starts for Crunch',/)
C
C Change symmetry to symmetry of the patterson
C
      DO 3 I=1,NSYM
      DO 4 K=1,3
      STS(K,I)=TS(K,I)
      TS(K,I)=0.0
      DO 5 M=1,2
      ISS(M,K,I)=IS(M,K,I)
5     CONTINUE
4     CONTINUE
3     CONTINUE
      WRITE(LO,34)
34    FORMAT(' Spacegroup symmetry:')
      NS = NSYM
      DO 1001 I=1,NS
      WRITE(6,1002)(STS(J,I),(ISS(M,J,I),M=1,2),J=1,3)
1002  FORMAT(3(F7.3,2I3))
1001  CONTINUE
      WRITE(LO,33) ((TS(I,J),(IS(K,I,J),K=1,2),I=1,3),J=1,NSYM)
   33 FORMAT(/,' Symmetry of the Patterson, centre not included:',/
     1 ,(3(F7.3,2I3)))
      LATT=1
      DO 440 I=2,7
      IF(LTC(I).EQ.LTT) LATT=I
  440 CONTINUE
      RETURN
      END
      SUBROUTINE MAKES(S,T,TS,IS)
      INTEGER S(9),IS(2,3)
      DIMENSION T(3),TS(3)
      DO 1 I=1,3
      TS(I)=T(I)
      M=0
      IS(2,I)=0
      DO 2 J=1,3
      INDEX=(I-1)*3+J
      K=S(INDEX)
      IF(K.NE.0)THEN
      M=M+1
      IS(M,I)=ISIGN(J,K)
      ENDIF
2     CONTINUE
1     CONTINUE
      RETURN
      END
      SUBROUTINE MDFTKD (N, FACTOR, DIM, X, Y, NSIZE)
C**** MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL DRIVER
C****
      INTEGER FACTOR(10), DIM(5), F, P, R, S
      REAL X(NSIZE), Y(NSIZE)
C****
      S = DIM(2)
      F = 0
      M = N
  100 F = F + 1
      P = FACTOR(F)
      IF (P.EQ.0) RETURN
      M = M/P
      R = M*S
      NDIM=NSIZE
      GO TO (100, 200, 300, 400, 500), P
C****
  200 CALL R2 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), DIM, NDIM,NDIM-R)
      GO TO 100
C****
  300 CONTINUE
      CALL R3 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     1, DIM,NDIM,NDIM-R,NDIM-2*R)
      GO TO 100
C****
  400 CALL R4 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     1, X(3*R+1), Y(3*R+1), DIM,NDIM,NDIM-R,NDIM-2*R,NDIM-3*R)
      GO TO 100
C****
  500 CALL R5 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     1, X(3*R+1), Y(3*R+1), X(4*R+1), Y(4*R+1), DIM, NDIM, NDIM-R,
     2 NDIM-2*R,NDIM-3*R,NDIM-4*R)
      GO TO 100
C****
      END
      SUBROUTINE MULT(H,K,L,EPS)
      INTEGER H,EPS,HKL(3)
C
C  CALCULATE MULTIPLICITY OF ONE REFLECTION
C
      INCLUDE 'common/symtry.f'
      DIMENSION KHL(3)
      EPS=0
      DO 100 I=1,NSYM
      DO  10 II=1,3
   10 KHL(II)=0
      HKL(1)=H
      HKL(2)=K
      HKL(3)=L
      DO 11 II=1,3
      DO 11 III=1,2
      M=IABS(IS(III,II,I))
      IF(M.NE.0)KHL(M)=KHL(M)+HKL(II)*ISIGN(1,IS(III,II,I))
   11 CONTINUE
      DO 12 II=1,3
      IDIF=HKL(II)-KHL(II)
C     IF(IDIF)100,12,100
      IF(IDIF.NE.0)GOTO 100
   12 CONTINUE
      EPS=EPS+1
  100 CONTINUE
      RETURN
      END
      SUBROUTINE ORTH(CELL,ORT)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION CELL(6),ORT(3,3)
      PIR=3.14159265/180.0
      CA=COS(PIR*CELL(4))
      CB=COS(PIR*CELL(5))
      CG=COS(PIR*CELL(6))
      SA=SQRT(1-CA*CA)
      SG=SQRT(1-CG*CG)
      CBCACG=CA-CB*CG
      CBCASG=CBCACG/SG
      CBSASG=SQRT(SA*SA-CB*CB-CG*CG+2*CA*CB*CG)/SG
      ORT(1,1)=1
      ORT(2,1)=0.
      ORT(3,1)=0.
      ORT(1,2)=CG
      ORT(2,2)=SG
      ORT(3,2)=0
      ORT(1,3)=CB
      ORT(2,3)=CBCASG
      ORT(3,3)=CBSASG
      DO 10 I=1,3
      DO 10 II=1,3
10    ORT(I,II)=CELL(II)*ORT(I,II)
      RETURN
      END
      SUBROUTINE OUTPUT(X,Y,NZ,NX,NY,NSIZE)
      DIMENSION X(NZ,NX,NY)
      INTEGER*4 Y(NSIZE)
      COMMON/SCL/SCALE
C
C  PUT OUT SCALED Y-SECTIONS
C
      INDEX=0
      DO 350 K=1,NY
      DO 350 J=1,NZ
      DO 330 I=1,NX
      X(J,I,K)=X(J,I,K)*SCALE
      XX=X(J,I,K)
      INDEX=INDEX+1
      Y(INDEX)=0
      IF(XX.NE.0.0)Y(INDEX)=XX+SIGN(0.5,XX)
  330 CONTINUE
C      WRITE(LM)(INUT(I),I=1X)
  350 CONTINUE
      RETURN
      END
      SUBROUTINE PLAATS(N,M,NR,MR,IP,LO)
C
C  CHECK WHETHER SUFFICIENT CORE IS AVAILABLE
C
      IMPLICIT REAL*4 (A-H,O-Z)
      IF(IP.EQ.1)WRITE(LO,1)M,MR
1     FORMAT(/,' PLAATS: ',2I10,' integer, floating words'
     1, ' are necessary')
      IF(M.GT.N.OR.MR.GT.NR)GOTO 1000
      RETURN
 1000 WRITE(LO,2)
      Write(LO,5)N,NR
      WRITE(LO,4)M,MR
4      FORMAT(/,' Necessary: ',2I10)
5      FORMAT(/,' Available: ',2I10)
    2 FORMAT(/,28H ***** NOT ENOUGH CORE *****)
      CALL CCPERR(1,'***** NOT ENOUGH CORE *****')
      END

      PROGRAM PMF    
C
C Calculate Patterson. Make models that fit the Patterson, starting
C points for Crunch2
C
      DIMENSION X(3)
      LOGICAL READY
      COMMON R(14000000),I(10000000)
      INCLUDE 'common/unit.f'
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/const.f'
      INCLUDE 'common/pack.f'
      INCLUDE 'common/locaut.f'
      INCLUDE 'common/group.f'
      COMMON /PARAM/ CELL(6),Q(6)
      DATA NR/14000000/,NI/10000000/

      CALL CCPFYP
      CALL CCPRCS(6,'pmf','$Date: 2008/01/16 09:01:19 $')
      ICENT=1
      READY=.FALSE.
      IFIRST=1
C
C Initialize random generator
C
C      CALL CCPDPN(99, 'CRUNCH2SEED', 'READONLY', 'F', 0, 0)
C      READ(99,1237)SEEDD
C1237  FORMAT(I20)
C      CLOSE(99)
C   Use current time in seconds as a seed (old code above)
C     CALL USTIME(SEEDD)
C     RR=RANDOM(SEEDD)
      RR=RANDOM(65539)
      JFIRST=1
      DO 1230 J=1,NI
      I(J)=0
1230  CONTINUE
      DO 1231 J=1,NR
      R(J)=0
1231  CONTINUE
      CALL INPUT(I,NI,R,NR,IFIRST,JFIRST,NBEGIN,NEIND,RESOLUTION)
C
C NOW CALCULATE THE PATTERSON
C
      CM=CELL(1)
      DO 14 K=2,3
      IF(CM.LT.CELL(K))CM=CELL(K)
14    CONTINUE
      XN=DN/CM
      DN=DN*DN
C
C NOW CALCULATE STARTING MODELS 
C
C HERE WE CALCULATE THE PATTERSON, SELECT PEAKS AND GENERATE THE MODELS
C OUTPUT ON ASCII FILE
C
      NB=MAX(30,NSYM,NATOM*(NATOM-1))
      ISWIT=0
      CALL EXFFT(R(LOCFO),I(LOCAH),I(LOCAK),I(LOCAL),R(LOCSYM)
     1 ,R(LSTORE),I(LBORE),I(LOCIH),R(LOCG))
      IFAIL=0
      CALL SEARCH(I(LBORE),I(LOCBYM),NRX,
     1 R(LOCPO),NB,IFAIL,ISWIT)
      IF(IFAIL.LT.0)THEN
      IF(NB.LT.10)THEN
      WRITE(LO,*)'Not enough clear peaks in the Patterson function'
      WRITE(LO,*)'  '
      WRITE(LO,*)'Use random starts in Crunch'
      CALL CCPERR(1,'Not enough clear peaks in the Patterson function')
      ENDIF
      ENDIF
      CALL REMHA(R(LOCPO),NB)
      J=0
C
C Harkers have been removed from the peaklist
C Now generate starts
C First select a vector and calculate the gridpoints
C
      CALL SELECT(R(LOCPO),NB,X,R(LOCSYM),R(LSTORE),NX,NY,NZ,
     1 NBEGIN,NEIND,I(LOCBYM),I(LBORE),NRX,NATOM)

      CALL CCPERR(0,'Normal termination')

      END

      SUBROUTINE PMFC(X,Y,CRIT,RM,NX,NY,NZ)
      INTEGER X(3,48),Y(3,48),IX(3)
      DIMENSION RM(NZ,NX,NY),DUMP(2500),NQ(3)
      INCLUDE 'common/unit.f'
      INCLUDE 'common/symtry.f'
      COMMON/SRCH/IDIFF(19),DX(3),NXZ,NXZ3,NXP2
      NS=NSYM
      NQ(1)=NX
      NQ(2)=NY
      NQ(3)=NZ
      ND=0
      DO 5 I=1,NS
      DO 7 K=1,NS
      DO 6 J=1,3
      IX(J)=Y(J,I)-X(J,K)+1
      IF(IX(J).LT.1)IX(J)=IX(J)+NQ(J)
      IF(IX(J).GT.NQ(J))IX(J)=IX(J)-NQ(J)
6     CONTINUE
      ND=ND+1
      DUMP(ND)=RM(IX(3),IX(1),IX(2))
7     CONTINUE
5     CONTINUE
      NC=MAX(1,NINT(REAL(ND)*0.3))
      CALL SORT(DUMP,2500,ND)
      CRIT=0
      DO 10 I=ND,ND-NC+1,-1
      CRIT=CRIT+DUMP(I)
10    CONTINUE
      CRIT=CRIT/NC
      RETURN
      END
      SUBROUTINE PMFCF(X,Y,RM,PM,NX,NY,NZ)
      INTEGER X(3,24),Y(3,24),IX(3),NP(3)
      DIMENSION RM(NZ,NX,NY),DUMP(500),PM(NZ,NX,NY),NQ(3)
      COMMON/SRCH/IDIFF(19),DX(3),NXZ,NXZ3,NXP2
      INCLUDE 'common/group.f'
      COMMON/SCL/SCALE      
      DMAX=-100000.0
      NQ(1)=NX
      NQ(2)=NY
      NQ(3)=NZ
      DO 10 K=1,NY
      NP(2)=K
      DO 11 L=1,NX
      NP(1)=L
      DO 12 M=1,NZ
      NP(3)=M
      ND=0
      DO 1 I=1,NS
      DO 2 J=1,3
      IX(J)=X(J,I)-NP(J)+1   
      IF(IX(J).LT.1)IX(J)=IX(J)+NQ(J)
      IF(IX(J).GT.NQ(J))IX(J)=IX(J)-NQ(J)
2     CONTINUE
      ND=ND+1
      DUMP(ND)=RM(IX(3),IX(1),IX(2))
1     CONTINUE
      DO 3 I=1,NS
      DO 4 J=1,3
      IX(J)=Y(J,I)-NP(J)+1
      IF(IX(J).LT.1)IX(J)=IX(J)+NQ(J)
      IF(IX(J).GT.NQ(J))IX(J)=IX(J)-NQ(J)
4     CONTINUE
      ND=ND+1
      DUMP(ND)=RM(IX(3),IX(1),IX(2))
3     CONTINUE
      NC=MAX(1,NINT(REAL(ND)*0.3))
      CALL SORT(DUMP,500,ND)
      CRIT=0
      DO 15 I=ND,ND-NC+1,-1
      CRIT=CRIT+DUMP(I)
15    CONTINUE
      CRIT=CRIT/NC
      PM(M,L,K)=CRIT
      IF(CRIT.GT.DMAX)DMAX=CRIT
12    CONTINUE
11    CONTINUE
10    CONTINUE
      SCALE=3000.0/DMAX
      RETURN
      END
      SUBROUTINE PP1(X,Y,IY,NSIZE,IH,G,NEX)
C
C  DRIVER OF FFT SECTION (CF MULTAN80)
C
      REAL X(NSIZE),Y(NSIZE)
      INCLUDE 'common/unit.f'
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/const.f'
      INCLUDE 'common/pack.f'
      INCLUDE 'common/locaut.f'
      COMMON /PARAM/ CELL(6),Q(6)
      DIMENSION IH(NRS),G(2,NRS),IY(NSIZE)
      INTEGER P1,P2,R,D(5)
      CHARACTER*200 ERRLINE
      P1=NSIZE/(2*NY*(MH(3)+1))
      P2=NSIZE/(NX*NZ)
      IF(P1.GE.(2*MH(1)+1).AND.P2.GT.0)THEN
C
C  PASS ONE. TRANSFORM ON K
C
      R=-MH(1)
      P1=MH(1)+1-R
      CALL READ KL(X,NY,MH(3)+1,P1,R,IH,G,NEX)
      D(1)=2*(NY*P1*(MH(3)+1))
      D(2)=2
      D(3)=D(1)
      D(4)=D(1)
      D(5)=2*NY
      CALL CMPLFT(X(1),X(2),NSIZE,NY,D)
      CALL WRITE Y(X,Y,NY,MH(3)+1,P1,NSIZE/2)
C
C  END OF PASS ONE.
C  PASS TWO CALCULATES FINAL FOURIERMAP
C
      P2=NY
      CALL READ HL(X,Y,NX,NZ/2,P2,MH(1),MH(3)+1,NSIZE/2)
C
C  X NOW CONTAINS INTERMEDIATE RESULTS STORED WITH L DOWN
C  THE COLUMNS AND H ACROSS THE ROWS
C
      D(1)=NX*NZ*P2
      D(2)=NZ
      D(3)=NZ*NX
      D(4)=2*(MH(3)+1)
      D(5)=2
      CALL CMPLFT(X(1),X(2),NSIZE,NX,D)
      D(2)=2
      D(3)=D(1)
      D(4)=D(1)
      D(5)=NZ
      CALL HERMFT (X(1),X(2),NSIZE,NZ/2,D)
      CALL OUTPUT(X,IY,NZ,NX,P2,NSIZE)
C
C  END OF JOB
C
      RETURN
      ELSE
      P1=2*NY*(MH(3)+1)*(2*MH(1)+1)
      P2=NX*NZ*NY
      WRITE (ERRLINE,350)NSIZE,P1,P2
  350 FORMAT(' PP1:REQUEST TOO LARGE. AVAILABLE:',I10,'  ',
     1 'REQUESTED: ',I10,' AND',I10)
      CALL CCPERR(1,ERRLINE)
      ENDIF
      END
      SUBROUTINE R2 CFTK (N, M, X0, Y0, X1, Y1, DIM, NDIM, NDIM1)
C**** RADIX 2 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C****
      INTEGER DIM(5), SIZE, SEP
      REAL X0(NDIM),Y0(NDIM),X1(NDIM1),Y1(NDIM1),IS,IU
      LOGICAL FOLD,ZERO
      DATA TWOPI /6.283185/
C****
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M2=M*2
      FM2 = FLOAT(M2)
      M OVER 2=M/2+1
      MM2 = SEP*M2
C****
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM2
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C=COS(ANGLE)
      S=SIN(ANGLE)
      GO TO 200
  100 FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      C=-C
  200 DO 500 KK = K0, NS, MM2
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      RS=X0(K)+X1(K)
      IS=Y0(K)+Y1(K)
      RU=X0(K)-X1(K)
      IU=Y0(K)-Y1(K)
      X0(K)=RS
      Y0(K)=IS
      IF (ZERO) GO TO 300
      X1(K)=RU*C+IU*S
      Y1(K)=IU*C-RU*S
      GO TO 420
  300 X1(K)=RU
      Y1(K)=IU
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
      RETURN
      END
      SUBROUTINE R3 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, DIM,
     1 NDIM,NDIM1,NDIM2)
C**** RADIX 3 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C****
      INTEGER DIM(5), SIZE, SEP
      REAL X0(NDIM),Y0(NDIM),X1(NDIM1),Y1(NDIM1),X2(NDIM2),Y2(NDIM2),
     1 I0,I1,I2,IA,IB,IS
      LOGICAL FOLD,ZERO
      DATA TWOPI /6.283185/
      DATA A/-0.5/, B/0.86602540/
C****
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M3=M*3
      FM3 = FLOAT(M3)
      MM3 = SEP*M3
      M OVER 2=M/2+1
C****
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM3
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      GO TO 200
  100 FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=C1*A+S1*B
      S1=C1*B-S1*A
      C1=T
      T=C2*A-S2*B
      S2=-C2*B-S2*A
      C2=T
  200 DO 500 KK = K0, NS, MM3
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      R0=X0(K)
      I0=Y0(K)
      RS=X1(K)+X2(K)
      IS=Y1(K)+Y2(K)
      X0(K)=R0+RS
      Y0(K)=I0+IS
      RA=R0+RS*A
      IA=I0+IS*A
      RB=(X1(K)-X2(K))*B
      IB=(Y1(K)-Y2(K))*B
      IF (ZERO) GO TO 300
      R1=RA+IB
      I1=IA-RB
      R2=RA-IB
      I2=IA+RB
      X1(K)=R1*C1+I1*S1
      Y1(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      GO TO 420
  300 X1(K)=RA+IB
      Y1(K)=IA-RB
      X2(K)=RA-IB
      Y2(K)=IA+RB
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
      RETURN
      END
      SUBROUTINE R4 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, DIM,
     1 NDIM,NDIM1,NDIM2,NDIM3)
C**** RADIX 4 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C****
      INTEGER DIM(5), SIZE, SEP
      REAL X0(NDIM),Y0(NDIM),X1(NDIM1),Y1(NDIM1),X2(NDIM2),
     1 Y2(NDIM2),X3(NDIM3),Y3(NDIM3)
      LOGICAL FOLD,ZERO
      REAL I1,I2,I3,IS0,IS1,IU0,IU1
      DATA TWOPI /6.283185/
C****
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M4=M*4
      FM4 = FLOAT(M4)
      MM4 = SEP*M4
      M OVER 2=M/2+1
C****
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM4
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      C3=C2*C1-S2*S1
      S3=S2*C1+C2*S1
      GO TO 200
  100 FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=C1
      C1=S1
      S1=T
      C2=-C2
      T=C3
      C3=-S3
      S3=-T
  200 DO 500 KK = K0, NS, MM4
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      RS0=X0(K)+X2(K)
      IS0=Y0(K)+Y2(K)
      RU0=X0(K)-X2(K)
      IU0=Y0(K)-Y2(K)
      RS1=X1(K)+X3(K)
      IS1=Y1(K)+Y3(K)
      RU1=X1(K)-X3(K)
      IU1=Y1(K)-Y3(K)
      X0(K)=RS0+RS1
      Y0(K)=IS0+IS1
      IF (ZERO) GO TO 300
      R1=RU0+IU1
      I1=IU0-RU1
      R2=RS0-RS1
      I2=IS0-IS1
      R3=RU0-IU1
      I3=IU0+RU1
      X2(K)=R1*C1+I1*S1
      Y2(K)=I1*C1-R1*S1
      X1(K)=R2*C2+I2*S2
      Y1(K)=I2*C2-R2*S2
      X3(K)=R3*C3+I3*S3
      Y3(K)=I3*C3-R3*S3
      GO TO 420
  300 X2(K)=RU0+IU1
      Y2(K)=IU0-RU1
      X1(K)=RS0-RS1
      Y1(K)=IS0-IS1
      X3(K)=RU0-IU1
      Y3(K)=IU0+RU1
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
      RETURN
      END
      SUBROUTINE R5 CFTK(N,M,X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4,Y4,DIM,
     1 NDIM,NDIM1,NDIM2,NDIM3,NDIM4)
C**** RADIX 5 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C****
      INTEGER DIM(5), SIZE, SEP
      REAL X0(NDIM),Y0(NDIM),X1(NDIM1),Y1(NDIM1),X2(NDIM2),
     1 Y2(NDIM2),X3(NDIM3),Y3(NDIM3), X4(NDIM4),Y4(NDIM4),
     2 I0,I1,I2,I3,I4,IA1,IA2,IB1,IB2,IS1,IS2,IU1,IU2
      LOGICAL FOLD,ZERO
      DATA TWOPI /6.283185/
      DATA A1/0.30901699/,B1/0.95105652/,A2/-0.80901699/,B2/0.58778525/
C****
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M5=M*5
      FM5 = FLOAT(M5)
      MM5 = SEP*M5
      M OVER 2=M/2+1
C****
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM5
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      C3=C2*C1-S2*S1
      S3=S2*C1+C2*S1
      C4=C2*C2-S2*S2
      S4=S2*C2+C2*S2
      GO TO 200
  100 FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=C1*A1+S1*B1
      S1=C1*B1-S1*A1
      C1=T
      T=C2*A2+S2*B2
      S2=C2*B2-S2*A2
      C2=T
      T=C3*A2-S3*B2
      S3=-C3*B2-S3*A2
      C3=T
      T=C4*A1-S4*B1
      S4=-C4*B1-S4*A1
      C4=T
  200 DO 500 KK = K0, NS, MM5
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      R0=X0(K)
      I0=Y0(K)
      RS1=X1(K)+X4(K)
      IS1=Y1(K)+Y4(K)
      RU1=X1(K)-X4(K)
      IU1=Y1(K)-Y4(K)
      RS2=X2(K)+X3(K)
      IS2=Y2(K)+Y3(K)
      RU2=X2(K)-X3(K)
      IU2=Y2(K)-Y3(K)
      X0(K)=R0+RS1+RS2
      Y0(K)=I0+IS1+IS2
      RA1=R0+RS1*A1+RS2*A2
      IA1=I0+IS1*A1+IS2*A2
      RA2=R0+RS1*A2+RS2*A1
      IA2=I0+IS1*A2+IS2*A1
      RB1=RU1*B1+RU2*B2
      IB1=IU1*B1+IU2*B2
      RB2=RU1*B2-RU2*B1
      IB2=IU1*B2-IU2*B1
      IF (ZERO) GO TO 300
      R1=RA1+IB1
      I1=IA1-RB1
      R2=RA2+IB2
      I2=IA2-RB2
      R3=RA2-IB2
      I3=IA2+RB2
      R4=RA1-IB1
      I4=IA1+RB1
      X1(K)=R1*C1+I1*S1
      Y1(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      X3(K)=R3*C3+I3*S3
      Y3(K)=I3*C3-R3*S3
      X4(K)=R4*C4+I4*S4
      Y4(K)=I4*C4-R4*S4
      GO TO 420
  300 X1(K)=RA1+IB1
      Y1(K)=IA1-RB1
      X2(K)=RA2+IB2
      Y2(K)=IA2-RB2
      X3(K)=RA2-IB2
      Y3(K)=IA2+RB2
      X4(K)=RA1-IB1
      Y4(K)=IA1+RB1
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
      RETURN
      END
      REAL*4 FUNCTION RANDOM(J)
      INTEGER LO,HI,TEST,SEED,A,M,Q,R
      PARAMETER(A=16807,M=2147483647,Q=127773,R=2836)
      SAVE SEED
      IF (J.NE.0) THEN
C      SEED=65539
      SEED=MOD(IABS(J),M)
      ENDIF
      HI=SEED/Q
      LO=SEED-HI*Q
      TEST=A*LO-R*HI
      IF(TEST.GT.0)THEN
      SEED=TEST
      ELSE
      SEED=TEST+M
      ENDIF
      RANDOM=FLOAT(SEED)/M
      RETURN
      END
      SUBROUTINE RDSECT(MAP,NR3D,KUSER2,NZ,NXP2,NXZ3,MAX,MY,INDEX)
      DIMENSION NR3D(KUSER2),MAP(KUSER2)
      IF(MAX.GE.NXZ3)MAX=0
      MX=MAX
      MAX=MAX-2
      DO 1320 IZ=1,NZ
      MIN=MAX+3
      MAX=MAX+NXP2
      MN1=MIN-1
      DO 10 IX=MIN,MAX
      INDEX=INDEX+1
      NR3D(IX)=MAP(INDEX)
10    CONTINUE
C      READ(LM)(NR3D(IX),IX=MIN,MAX)
      NR3D(MAX+1)=NR3D(MIN)
      NR3D(MAX+2)=NR3D(MIN+1)
 1320 CONTINUE
      MIN=MAX+3
      MAX=MAX+NXP2+NXP2+2
      DO 1340 IX=MIN,MAX
      MX=MX+1
      NR3D(IX)=NR3D(MX)
 1340 CONTINUE
      IF(INDEX.EQ.MY)Then
C      Write(6,*)'Ik heb de laatste sectie ingelezen'
      INDEX=0
      Endif
      RETURN
      END
      SUBROUTINE READHL(X,Y,NX,NZ,NY,HMAX,LM,NSIZE)
      INTEGER HMAX,H,HL
      DIMENSION X(2,NZ,NX,NY),Y(2,NSIZE)
C     COMPLEX X(NZ,NX,NY),Y(NSIZE)
C
C  COPY INTERMEDIATE RESULTS FOR ALL H AND L AND K FROM Y INTO X
C  THE INPUT IS STORED WITH L DOWN THE COLUMNS AND H ON THE ROWS
C
      HU=NX-HMAX
      INDX=0
C
C  A SECTION TO READ A RECORD SPANNING H=0
C
      HL=HU+1
      HU=HMAX+1
      DO 10 L=1,LM
      DO 11 K=1,NY
      DO 12 H=HL,NX
      INDX=INDX+1
      DO 12 I=1,2
      X(I,L,H,K)=Y(I,INDX)
12    CONTINUE
      DO 13 H=1,HU
      INDX=INDX+1
      DO 13 I=1,2
      X(I,L,H,K)=Y(I,INDX)
13    CONTINUE
11    CONTINUE
10    CONTINUE
C      READ(LSCRA)(((X(L,H,K),H=HL,NX),(X(L,H,K),H=1,HU),
C     1  K=1,NY),L=1,LM)
C
C  PAD THE ARRAY WITH ZERO WHERE THERE ARE NO DATA, AND FILL IN THE
C  -H K 0 RESULTS BY SYMMETRY
C
      DO 900 H=2,HU
      HL=NX+2-H
      DO 900 K=1,NY
      X(1,1,HL,K)=X(1,1,H,K)
      X(2,1,HL,K)=-X(2,1,H,K)
  900 CONTINUE
      HL=HMAX+2
      HU=NX-HMAX
      IF(HU.LT.HL)GOTO 920
      DO 910 L=1,LM
      DO 910 K=1,NY
      DO 910 H=HL,HU
      X(1,L,H,K)=0.0
      X(2,L,H,K)=0.0
  910 CONTINUE
  920 CONTINUE
      IF(LM.GE.NZ)GOTO 940
      P=LM+1
      DO 930 K=1,NY
      DO 930 L=P,NZ
      DO 930 H=1,NX
      X(1,L,H,K)=0.0
      X(2,L,H,K)=0.0
  930 CONTINUE
  940 CONTINUE
      RETURN
      END
      SUBROUTINE READ KL (X,NY,NZ,NX,HS,IH,G,NEX)
      INTEGER H,HS,HM,HL
      DIMENSION IH(NEX),G(2,NEX),X(2,NY,NZ,NX)
      HM=262144*(HS+NX-1+256)+(512+1)*(2*256-1)
      HL=262144*(HS+256)
      DO 100 H=1,NX
      DO 100 K=1,NY
      DO 100 L=1,NZ
      DO 100 I=1,2
      X(I,K,L,H)=0.0
100   CONTINUE
      DO 500 J=1,NEX
      IHJ=IH(J)
      IF(IHJ.GT.HM.OR.IHJ.LT.HL)GOTO 500
      H=IHJ/262144-256
      L=IHJ-262144*(H+256)
      K=L/512-256
      L=L-512*(K+256)-256
      NOKO=0
      IF(H.EQ.0.AND.L.EQ.0.AND.K.NE.0)NOKO=NY-K+1
      H=H-HS+1
      IF(K.LT.0)K=NY+K
      K=K+1
      L=L+1
      DO 501 I=1,2
501   X(I,K,L,H)=G(I,J)
C     X(K,L,H)=CMPLX(G(1,J),G(2,J))
C     IF(NOKO.NE.0)X(NOKO,L,H)=CONJG(X(K,L,H))
      IF(NOKO.NE.0)THEN
      X(1,NOKO,L,H)=X(1,K,L,H)
      X(2,NOKO,L,H)=-X(2,K,L,H)
      ENDIF
  500 CONTINUE
      RETURN
      END
      SUBROUTINE REMHA(XYZ,NPIEK)
      DIMENSION XYZ(4,NPIEK),XHARK(3,384),JHARK(3,384),X(3)
      INCLUDE 'common/group.f'
      INCLUDE 'common/const.f'
C
C Remove the origin peak
C
C      DO 100 I=1,NPIEK
C      WRITE(6,101)(XYZ(J,I),J=1,4)
C100   CONTINUE
C101   FORMAT(3F10.4,F10.1)
      L=1
      CALL REMOVE(XYZ,NPIEK,L)
      IF(NS.GT.1.AND.NATOM.GT.1)THEN
      DO 1 I=2,NS
      DO 2 J=1,3
      IHA=0
      IS1=ISS(1,J,1)
      IS2=ISS(2,J,1)
      IHA=IHA+IS1-ISS(1,J,I)
      IHA=IHA+IS2-ISS(2,J,I)
      IF(IHA.EQ.0)THEN
C
C HARKER GEVONDEN
C
      JHARK(J,I-1)=1  
      XHARK(J,I-1)=STS(J,I)
      ELSE
      XHARK(J,I-1)=0
      JHARK(J,I-1)=0
      ENDIF
2     CONTINUE
1     CONTINUE
      DO 10 I=1,NPIEK
      IWEG=0
      DO 11 J=1,3
      DO 12 K=1,NS-1
      IF(JHARK(J,K).EQ.1)THEN
      X(J)=ABS(XYZ(J,I)-XHARK(J,K))
      IF(X(J).LT..005)THEN
      IWEG=1
      ELSE
      X(J)=100
      ENDIF
      ENDIF
12    CONTINUE
11    CONTINUE
      IF(IWEG.NE.0)THEN
      XYZ(4,I)=0.0
      ENDIF
10    CONTINUE
      ENDIF
      I=0
20    I=I+1
      IF(I.LE.NPIEK)THEN
      IF(XYZ(4,I).LT.0.5)THEN
      CALL REMOVE(XYZ,NPIEK,I)
      ENDIF
      GO TO 20
      ELSE
      DO 100 I=1,NPIEK
      WRITE(6,101)(XYZ(J,I),J=1,4)
101   FORMAT(3F10.4,F10.1)
100   CONTINUE
      RETURN
      ENDIF
      END
      SUBROUTINE REMOVE(XYZ,NPIEK,L)
      DIMENSION XYZ(4,NPIEK)
      NPIEK=NPIEK-1
      Do 1234 JJ=L,NPIEK  
      Do 1235 jjj=1,4
      XYZ(JJJ,JJ)=XYZ(JJJ,JJ+1)
1235  CONTINUE
1234  CONTINUE
      L=L-1
      RETURN
      END
      SUBROUTINE RFLIN1(FO,IH,IK,IL,RESO)
      DIMENSION FO(NREF_PMF)
      INTEGER H,EPS,IH(NREF_PMF),IK(NREF_PMF),IL(NREF_PMF)
      INCLUDE 'common/unit.f'
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/const.f'
      INCLUDE 'common/pack.f'
      INCLUDE 'common/locaut.f'
      COMMON /PARAM/ CELL(6),Q(6)
C
C  Reflections from SnB output *.DREAR 
C
      STLMAX=0.4     
      STMAX=0
      NREF_PMF=0
      MH(1)=0
      MH(2)=0
      MH(3)=0
100   CONTINUE
      READ(IREFL,102,END=200)H,K,L,F,SFF,E,SE
      STL=SQRT(H*H*Q(1)+K*K*Q(2)+L*L*Q(3)+H*K*Q(4)+K*L*Q(5)+L*H*Q(6))
      DSPA=1.0/STL
102   FORMAT(3I5,4F9.3)
      IF(DSPA.LT.STLMAX.OR.DSPA.LT.STLIM)GOTO 100
      IF(STMAX.LT.STL)STMAX=STL
      CALL MULT(H,K,L,EPS)
      CALL RSTRC(MARC,H,K,L)
      IF(MARC.EQ.0)GOTO 100
      NREF_PMF=NREF_PMF+1
      IF(NPATT.EQ.1)THEN
      FO(NREF_PMF)=F*F
      ELSEIF(NPATT.EQ.2)THEN
      FO(NREF_PMF)=F*E
      ELSEIF(NPATT.EQ.3)THEN
      FO(NREF_PMF)=E*E
      ENDIF
      IF(IABS(H).GT.MH(1))MH(1)=IABS(H)
      IF(IABS(K).GT.MH(2))MH(2)=IABS(K)
      IF(IABS(L).GT.MH(3))MH(3)=IABS(L)
      IH(NREF_PMF)=H
      IK(NREF_PMF)=K
      IL(NREF_PMF)=L
      GOTO 100
  200 CONTINUE
      RESO=1.0/STMAX
      WRITE(LO,3)NREF_PMF
3     FORMAT(/,' RFLIN: ',I7,' Reflections read from code.drear')
      WRITE(LO,4)RESO
4     FORMAT(/,'The resolution of the data used is',F7.2)
      RETURN
      END
      SUBROUTINE RSTRC(MK,IH,IK,IL)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX
      DIMENSION KHL(4),IND(3)
      INCLUDE 'common/unit.f'
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/const.f'
      INCLUDE 'common/pack.f'
      COMMON /PARAM/ PARA(6),Q(6)
C
C  TAKEN FROM SUBROUTINE GROUP (MULTAN)
C  FINDS PHASE RESTRICTION OF REFLEXION IN A (BYTE 2, 3, 4)
C  MK=0: FORBIDDEN REFLEXION
C  MK=1: NO RESTRICTION
C  ELSE PHASE=15*(MK-1)+PI
C
      IND(1)=IH
      IND(2)=IK
      IND(3)=IL
C
C  FORBIDDEN REFL?
C
      GOTO (10,20,30,40,50,60,70),LATT
   10 CONTINUE
C
C  PRIMITIVE LATTICE
C
      GOTO 1000
   20 CONTINUE
C
C  A-LATTICE
C
      IF(MOD(IND(2)+IND(3),2).NE.0) GOTO 2000
      GOTO 1000
   30 CONTINUE
C
C  B-LATTICE
C
      IF(MOD(IND(1)+IND(3),2).NE.0) GOTO 2000
      GOTO 1000
   40 CONTINUE
C
C  C-LATTICE
C
      IF(MOD(IND(1)+IND(2),2).NE.0) GOTO 2000
      GOTO 1000
   50 CONTINUE
C
C  I-LATTICE
C
      IF(MOD(IND(1)+IND(2)+IND(3),2).NE.0) GOTO 2000
      GOTO 1000
   60 CONTINUE
C
C  F-LATTICE
C
      K=MOD(IND(1),2)
      IF(K.NE.MOD(IND(2),2)) GOTO 2000
      IF(K.NE.MOD(IND(3),2)) GOTO 2000
      GOTO 1000
   70 CONTINUE
C
C  R-LATTICE
C
      IF(MOD(IND(2)+IND(3)-IND(1),3).NE.0) GOTO 2000
 1000 CONTINUE
      DO 1180 J=1,NSYM
      DO 1080 K=1,4
      KHL(K)=0
 1080 CONTINUE
      DO 1140 K=1,3
      KHL(4)=KHL(4)+IND(K)*INT(TS(K,J)*24.0+0.01)
      DO 1120 L=1,2
      M=IABS(IS(L,K,J))
      IF(M.NE.0) KHL(M)=KHL(M)+IND(K)*ISIGN(1,IS(L,K,J))
 1120 CONTINUE
 1140 CONTINUE
      DO 1160 K=1,3
      IF(IND(K).NE.KHL(K))GO TO 1180
C     IF(IND(K)-KHL(K)) 1180,1160,1180
 1160 CONTINUE
      IF(MOD(KHL(4),24).NE.0) GOTO 2000
 1180 CONTINUE
      GOTO 2900
 2000 CONTINUE
      MK=0
      GOTO 9001
 2900 CONTINUE
      IF(ICENT.NE.0) GOTO 9000
      MK=1
      DO 2180 J=1,NSYM
      DO 2080 K=1,4
      KHL(K)=0
 2080 CONTINUE
      DO 2140 K=1,3
      KHL(4)=KHL(4)+IND(K)*INT(TS(K,J)*12.0+0.1)
      DO 2120 L=1,2
      M=IABS(IS(L,K,J))
      IF(M.NE.0) KHL(M)=KHL(M)+IND(K)*ISIGN(1,IS(L,K,J))
 2120 CONTINUE
 2140 CONTINUE
      DO 2160 K=1,3
      IF(IND(K).NE.-KHL(K))GOTO 2180
C     IF(IND(K)+KHL(K)) 2180,2160,2180
 2160 CONTINUE
      MK=MOD(KHL(4),12)+1
      IF(MK.LE.1) MK=MK+12
      GOTO 2200
 2180 CONTINUE
 2200 CONTINUE
      GOTO 9001
 9000 MK=13
 9001 RETURN
      END
      SUBROUTINE SEARCH(MAP,NR3D,NRS3,XYZ,NPIK,IFAIL,ISWIT)
C
C  ADAPTED FROM SEARCH80 (CF MULTAN)
C
      DIMENSION XYZ(4,NPIK*2),NR3D(NRS3),XS(3),
     1 X1(3),B(19),MAP(NRS3)
      INCLUDE 'common/unit.f'
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/const.f'
      INCLUDE 'common/pack.f'
      INCLUDE 'common/locaut.f'
      COMMON/SRCH/IDIFF(19),DX,DY,DZ,NXZ,NXZ3,NXP2
      COMMON /PARAM/ CELL(6),Q(6)
C
C  NPIK=NUMBER OF PEAKS TAKEN FROM THE MAP
C
      IHALF=0
      IF(LATT.EQ.2.OR.LATT.EQ.4.OR.LATT.EQ.5.OR.LATT.EQ.6)IHALF=1
      IF(ICENT.EQ.1)IHALF=1
      DO 1 I=1,NQV
      IF(FS(2,2,I).EQ.-1.AND.ABS(TX(2,I)).LT.1.0E-5)IHALF=1
      IF(FS(2,2,I).EQ.1.AND.ABS(ABS(TX(2,I))-0.5).LT.1.0E-5)IHALF=1
1      CONTINUE
       NYOLD=NY
      IF(IHALF.NE.0)NY=NY-NY/2
      LIMIT=NPIK
      LEVEL=100.0
      CALL DFFR(NXZ,NXP2,IDIFF)
      NO=0
      IY=-1
      NNY=0
      MY=NX*NZ*NYOLD
 1200 CONTINUE
      IF(IY+2.EQ.NYOLD)GOTO 1400
      MAX=NXZ
      INDEX=NX*NZ*(NYOLD-1)
      CALL RDSECT(MAP,NR3D,NRS3,NZ,NXP2,NXZ3,MAX,MY,INDEX)
      CALL RDSECT(MAP,NR3D,NRS3,NZ,NXP2,NXZ3,MAX,MY,INDEX)
 1400 MX=MAX-NXZ+NX+1
      CALL RDSECT(MAP,NR3D,NRS3,NZ,NXP2,NXZ3,MAX,MY,INDEX)
      IY=IY+1
      NNY=MOD(NNY+2,3)-1
      KK=NXZ3
      IF(NNY.GT.0)GOTO 1500
      IF(NNY.EQ.0)GOTO 1460
C     IF(NNY)1440,1460,1500
      KK=-NXZ3
 1460 CONTINUE
      DO 1480 I=1,5
 1480 IDIFF(I)=IDIFF(I)-KK
      IF(NNY.EQ.0)GOTO 1540
 1500 CONTINUE
      DO 1520 I=15,19
 1520 IDIFF(I)=IDIFF(I)-KK
 1540 CONTINUE
      DO 2000 IZ=1,NZ
      MN = MX + 3
      MX=MX+NXP2
      DO 1980 IX=MN,MX
      IF (NR3D(IX) .LT. LEVEL) GO TO 1980
C
C  LOCATE GRID POINT WITH MAXIMUM DENSITY
C
      DO 1560 I=1,9
      J = IDIFF(I) + IX
      IF (NR3D(IX) .LE. NR3D(J)) GO TO 1980
 1560 CONTINUE
      DO 1580 I=11,19
      J = IDIFF(I) + IX
      IF (NR3D(IX) .LT. NR3D(J)) GO TO 1980
 1580 CONTINUE
C
C  FIT QUADRATIC FUNCTION TO 19 POINTS
C
C     DENS = A + C*X + D*Y + E*Z - 0.5*F*(X*X + Y*Y + Z*Z)
      DO 1600 I=1,19
      J = IDIFF(I) + IX
      B(I) = NR3D(J)
 1600 CONTINUE
      D=0
      E=0
      B1 = B(3) + B(7) + B(9) + B(11) + B(13) + B(17)
      B2 = B(1) + B(2) + B(4) + B(5) + B(6) + B(8) + B(12) + B(14) +
     1 B(15) + B(16) + B(18) + B(19)
      F = (30.0 * B(10) + 11.0 * B1 - 8.0 * B2) / 63.0
      C = (B(5)+B(12)+B(13)+B(14)+B(19)-B(1)-B(6)-B(7)-B(8)-B(15))/10.0
      DELTAX = C / F
      IF (ABS(DELTAX) .GT. 1.0) GO TO 1620
      D = (B(15)+B(16)+B(17)+B(18)+B(19)-B(1)-B(2)-B(3)-B(4)-B(5))/10.0
      DELTAY = D / F
      IF (ABS(DELTAY) .GT. 1.0) GO TO 1620
      E = (B(4)+B(8)+B(11)+B(14)+B(18)-B(2)-B(6)-B(9)-B(12)-B(16))/10.0
      DELTAZ = E / F
      IF (ABS(DELTAZ) .LE. 1.0) GO TO 1640
 1620 DELTAX = 0.0
      DELTAY = 0.0
      DELTAZ = 0.0
 1640 XX = (FLOAT(IX-MN+1) + DELTAX) * DX
      YY = (FLOAT(IY) + DELTAY) * DY
      ZZ = (FLOAT(IZ) + DELTAZ) * DZ
C
C  PEAK HEIGHT INTERPOLATION - NOT SUITABLE IF PEAK SHAPE IS POOR
C
C     A = (9.0 * B(10) + 4.0 * B1 - B2) / 21.0
C     B(10) = AMAX1(A+0.5*(C*DELTAX+D*DELTAY+E*DELTAZ), B(10))
      NOP1 = NO+1
      XYZ(1,NOP1)=XX
      XYZ(2,NOP1)=YY
      XYZ(3,NOP1)=ZZ
      XYZ(4,NOP1)=B(10)
      IF(ISWIT.EQ.1)THEN
      CALL SMLT(XYZ(1,NOP1),XXX)
      IF(XXX.GT.1)GO TO  1980
      ENDIF
      IF (NO .EQ. 0) GO TO 1820
      IR=0
C
C  IF TWO PEAKS ARE CLOSER THAN DN ANGSTROMS ELIMINATE THE SMALLER
C
      DO 1800 K=1,NQV
      DO 1660 L=1,3
      XS(L)=XX*FS(1,L,K)+YY*FS(2,L,K)+ZZ*FS(3,L,K)+TX(L,K)
 1660 CONTINUE
      DO 1780 I=1,NO
      DO 1720 L=1,3
      X1(L)=XYZ(L,I)-XS(L)
 1680 IF (ABS(X1(L)) .LE. 0.5) GO TO 1700
      X1(L) = X1(L) - SIGN(1.0, X1(L))
      GO TO 1680
 1700 IF(ABS(X1(L)).GT.XN)GOTO 1780
 1720 CONTINUE
      CALL DSTNCE(X1,ORT,DST)
      IF(DST.GT.DN)GOTO 1780
      IF(IR.GT.0)XYZ(4,IR)=0.0
      IR=0
      IF(B(10).LE.XYZ(4,I))GO TO 1980
      XYZ(1,I)=XX
      XYZ(2,I)=YY
      XYZ(3,I)=ZZ
      XYZ(4,I)=B(10)
      IR=I
 1780 CONTINUE
 1800 CONTINUE
      IF(IR.GT.0)GOTO 1980
 1820 NO = NOP1
      IF (NO .LT. LIMIT) GO TO 1980
      CALL SORT6(XYZ,4,2*NPIK,NO,4)
      LEVEL=XYZ(4,NO)+0.5
      NO = NPIK
 1980 CONTINUE
 2000 CONTINUE
      IF(IY.GE.NY)GO TO 2100
      IF(IY+2.NE.NYOLD)GOTO 1400
      GOTO 1200
C     IF(IY-NYOLD+2)1400,1200,1400
 2100 CONTINUE
      CALL SORT6(XYZ,4,2*NPIK,NO,4)
      NNN=MIN0(NO,NPIK)
C      DO 88 JJ=1,NNN 
C      WRITE(6,487)(XYZ(II,JJ),II=1,4)
C487   FORMAT(3F10.4,F10.1)
C88    CONTINUE
      IF(NNN.EQ.NPIK)THEN
      NY=NYOLD
      ELSE
      IFAIL=-1
      NPIK=NO
      NY=NYOLD
      ENDIF
      RETURN
      END
      SUBROUTINE SELECT(XYZ,NPIEK,X,RM,PM,NX,NY,NZ,NBEGIN,NEIND
     1 ,NR3D,MAP,NRS3,NATOM)
      COMMON/SRCH/IDIFF(19),DX(3),NXZ,NXZ3,NXP2
      DIMENSION RM(NZ,NX,NY),X(3),XYZ(4,NPIEK),NNX(3),XO(4,100,1000)
      DIMENSION SS(3),PM(NZ,NX,NY),CMAX(1000)
      INTEGER X1(3,48),X2(3,48),MAP(NRS3),NR3D(NRS3),XSOL(3,48)
     1 ,YSOL(3,48),POINT(1000),NATO(1000)
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/unit.f'
      INCLUDE 'common/group.f'
C 
C Choose a peak
C
      PI2=3.14159265/2.0
      ISWIT=1
C
C Change the symetry operations from Patterson into space group
C
      DO 200 I=1,NS
      DO 201 J=1,3
      TS(J,I)=STS(J,I)
      DO 202 M=1,2
      IS(M,J,I)=ISS(M,J,I)
202   CONTINUE
201   CONTINUE
200   CONTINUE
      NSYM=NS
C
C  We don't do centrosymmetric 
C
      ICENT=0
      CALL SYMEXP
      NNX(1)=NX
      NNX(2)=NY
      NNX(3)=NZ
      NTRIAL=NEIND-NBEGIN+1
      NTRY=MAX(100000,NX*NY*NZ/3)
      DO 19 IJ=1,NTRIAL
      NATO(IJ)=NATOM
      R=RANDOM(0)
      R=ACOS(R)/PI2
      DP=1.0/FLOAT(NPIEK)
      PP=1.0
      DO 18 IK=1,NPIEK
      PP=PP-DP
      IF(R.GT.PP)THEN
      IP=IK
      GO TO 17
      ENDIF
18    CONTINUE
C
C Apply random shift and find maximum of the criterion Cmax
C
17    CMAX(IJ)=-100000
      DO 20 J=1,NTRY  
      CALL GRIDP(XYZ,IP,X,X1,X2,NPIEK,SS)
      CALL PMFC(X1,X2,CRIT,RM,NX,NY,NZ)
      IF(CRIT.GT.CMAX(IJ))THEN
      CMAX(IJ)=CRIT
      DO 22 K=1,NS
      DO 21 I=1,3
      XSOL(I,K)=X1(I,K)
      YSOL(I,K)=X2(I,K)
21    CONTINUE
22    CONTINUE
      ENDIF
20    CONTINUE
C
C  Find more atoms if needed using Paaterson minimum function
C  The user supplies the percentage of the number of atoms to
C  be present in the starts. Default is 30%
C
      CALL PMFCF(XSOL,YSOL,RM,PM,NX,NY,NZ)
      CALL OUTPUT(PM,MAP,NZ,NX,NY,NRS3)
      CALL SEARCH(MAP,NR3D,NRS3,XO(1,1,IJ),NATO(IJ),IFAIL,ISWIT)
19    CONTINUE
      WRITE(LO,1111)
      CALL SORT1(CMAX,NTRIAL,POINT,NTRIAL)

      CALL CCPDPN(15,'XYZOUT', 'UNKNOWN', 'F', 0, 0)
      DO 400 JJ=1,NTRIAL
      IJ=POINT(JJ)
      WRITE(LO,1112)IJ,CMAX(IJ)
1111  FORMAT('In the outputfile the starts are sorted on the Patterson',
     1 ' criterion',/)
1112  FORMAT(I5,3x,F10.1)
      WRITE(15,100)NATO(IJ)
100   FORMAT(I5)
      DO 300 J=1,NATO(IJ)
      WRITE(15,101)(XO(I,J,IJ),I=1,3)
C     WRITE(6,101)(XO(I,J,IJ),I=1,4)
101   FORMAT('15.0',6x,4F10.3)
300   CONTINUE
400   CONTINUE
      CLOSE(15)

      RETURN
      END
      SUBROUTINE SMLT(X,BGR)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION X(3),XS(3),X1(3)
C
C  FIND MULTIPLICITY OF POSITION X
C
      INCLUDE 'common/symtry.f'
      DN=0.6
      K=0
      DO 100 I=1,NQV
      DO  10 II=1,3
C      WRITE(6,*)(FS(III,II,I),III=1,3),TX(II,I)
      XD=0.
      XS(II)=X(1)*FS(1,II,I)+X(2)*FS(2,II,I)+X(3)*FS(3,II,I)+TX(II,I)
    1 IF(XD.NE.0.)XS(II)=XS(II)+SIGN(1.,XD)
      XD=X(II)-XS(II)
      IF(ABS(XD).GT.0.5)GOTO 1
      X1(II)=XD
   10 CONTINUE
      CALL DSTNCE(X1,ORT,DST)
      IF(DST.GT.DN)GOTO 100
      K=K+1
  100 CONTINUE
      BGR=K
      RETURN
      END
      SUBROUTINE SORT(X,KUSER1,NAT)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION X(KUSER1)
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NAT)GOTO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NAT-INT
      DO 1200 II=1,IFIN
      I=II
      J=I+INT
      IF(X(I).GE.X(J))GOTO 1200
      T=X(J)
1080  CONTINUE
      X(J)=X(I)
      J=I
      I=I-INT
      IF(I.LE.0)GOTO 1140
C     IF(I)1140,1140,1120
      IF(X(I).LT.T)GOTO 1080
1140  CONTINUE      
      X(J)=T
1200  CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE SORT1(X,KUSER1,POINT,NAT)
C
C  Sort X(KUSER) on X(N,..) CREATING POINTERS ARRAY POINT
C  ON COMPLETION X(POINT(1)) WILL BE THE LARGEST VALUE OF X(..)
C  ONLY THE FIRST NAT ELEMENTS ARE SORTED
C
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION X(KUSER1)
      INTEGER POINT(NAT)
      DO 1 I=1,NAT
1     POINT(I)=I
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NAT)GOTO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NAT-INT
      DO 1200 II=1,IFIN
      I=II
      J=I+INT
      IF(X(POINT(I)).GE.X(POINT(J)))GOTO 1200
      K=POINT(J)
1080  POINT(J)=POINT(I)
      J=I
      I=I-INT
      IF(I.LE.0)GOTO 1140
C     IF(I)1140,1140,1120
      IF(X(POINT(I)).LT.X(K))GOTO1080
1140  POINT(J)=K
1200  CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE SORT6(X,KU,KUSER1,NAT,N)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION X(KU,KUSER1),T(6)
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NAT)GOTO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NAT-INT
      DO 1200 II=1,IFIN
      I=II
      J=I+INT
      IF(X(N,I).GE.X(N,J))GOTO 1200
      DO 1060 K=1,KU
      T(K)=X(K,J)
1060  CONTINUE
1080  DO 1100 K=1,KU
      X(K,J)=X(K,I)
1100  CONTINUE
      J=I
      I=I-INT
      IF(I.LE.0)GOTO 1140
C     IF(I)1140,1140,1120
      IF(X(N,I).LT.T(N))GOTO1080
1140  CONTINUE
      DO 1160 K=1,KU
      X(K,J)=T(K)
1160  CONTINUE
1200  CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE SPESIN(NBEGIN,NEIND)
      INCLUDE 'common/unit.f'
      INCLUDE 'common/symtry.f'
      INCLUDE 'common/const.f'
      INCLUDE 'common/pack.f'
      INCLUDE 'common/locaut.f'
      COMMON /PARAM/ CEL(6),Q(6)
C
C  INPUTFILE CONTROL PARAMETERS:
C
      LN=10
C
C  PRINTER OUTPUT:
C
      LO=6
C
C  SCRATCH FILE:
C
      ISCRA=8
C
C  FILE OF NORMAL FILE 9 FORMAT, NO REFLECTIONS ON IT THOUGH                    
C
      LNTA=9
      NBITS=32
      LK1=SQRT(2.0**(NBITS-5)/3.0)
      LK2=2*LK1
      LK3=24*LK2
      IP3=256
      IP2=2*IP3
      IP1=IP2*IP2
      IP4=(IP2+1)*IP3
      CALL INSPEC(NBEGIN,NEIND,FRAC)
      NREF_PMF=0
      IREFL=16
      CALL CCPDPN(IREFL,'HKLIN','READONLY','F',0,0)
1111  READ(IREFL,*,END=222)
      NREF_PMF=NREF_PMF+1
      GO TO 1111
222   CONTINUE
      REWIND IREFL
      NAT=0
      DO 70 I=1,8
      IF(JZ(I).NE.1)THEN
      NAT=NAT+JN(I)
      ENDIF
70    CONTINUE
      CALL SYMEXP
      CALL ORTH(CEL,ORT)
      NATOM=MAX(1.0,FRAC*NAT)     
      CALL PMF_CELL(CEL,Q,V,1)
      RETURN
      END
      SUBROUTINE S R FP (PTS,PMAX,TWO GRP,FACTOR,SYM,P SYM,UN SYM)
C**** SYMMETRIZED REORDERING FACTORING PROGRAM
C****
      INTEGER PTS,PMAX,TWO GRP,P SYM, FACTOR(10), SYM(10), UNSYM(10)
      INTEGER PP(14), QQ (7), F,P,P TWO,Q,R
C****
      NEST=14
C****
      N=PTS
      P SYM=1
      F=2
      P=0
      Q=0
  100 IF (N.LE.1) GO TO 500
      DO 200 J=F,PMAX
      IF(N.EQ.(N/J)*J)GOTO 300
200   CONTINUE
300   F=J
      N=N/F
      IF (N.EQ.(N/F)*F) GO TO 400
      Q=Q+1
      QQ(Q)=F
      GO TO 100
  400 N=N/F
      P=P+1
      PP(P)=F
      P SYM=P SYM*F
      GO TO 100
C****
  500 R=1
      IF (Q.EQ.0) R=0
      IF (P.LT.1) GO TO 700
      DO 600 J=1,P
      JJ=P+1-J
      SYM(J)=PP(JJ)
      FACTOR(J)=PP(JJ)
      JJ=P+Q+J
      FACTOR(JJ)=PP(J)
      JJ=P+R+J
      SYM(JJ)=PP(J)
  600 CONTINUE
  700 IF (Q.LT.1) GO TO 900
      DO 800 J=1,Q
      JJ=P+J
      UN SYM(J)=QQ(J)
      FACTOR(JJ)=QQ(J)
  800 CONTINUE
      SYM(P+1)=PTS/P SYM**2
  900 JJ=2*P+Q
      FACTOR(JJ+1)=0
      P TWO=1
      J=0
 1000 J=J+1
      IF (FACTOR(J).EQ.0) GO TO 1200
      IF (FACTOR(J).NE.2) GO TO 1000
      P TWO=P TWO*2
      FACTOR(J)=1
      IF (P TWO.GE.TWO GRP) GO TO 1100
      IF (FACTOR(J+1).EQ.2) GO TO 1000
 1100 FACTOR(J)=P TWO
      P TWO=1
      GO TO 1000
 1200 IF (P.EQ.0) R=0
      JJ=2*P+R
      SYM(JJ+1)=0
      IF (Q.LE.1) Q=0
      UN SYM(Q+1)=0
      RETURN
      END
      SUBROUTINE SYMEXP
C
C  EXPAND TO FULL SPACE GROUP SYMMETRY
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INCLUDE 'common/symtry.f'
      NQV=0
      CALL CENTRE(1,1,MLAT,TL)
C
C  FILL TL(1,XX) WITH 0
C
      GOTO(41,11,11,11,11,21,31),LATT
C
C  A,B,C,I LATTICES
C
   11 CALL CENTRE(2,LATT,MLAT,TL)
      GOTO 41
C
C  F LATTICE
C
   21 CALL CENTRE(2,2,MLAT,TL)
      CALL CENTRE(3,3,MLAT,TL)
      CALL CENTRE(4,4,MLAT,TL)
      GOTO 41
C
C  R LATTICE
C
   31 CALL CENTRE(2,6,MLAT,TL)
      CALL CENTRE(3,7,MLAT,TL)
   41 CONTINUE       
      ICENT=2*ICENT+1
      DO 1000 III=1,ICENT,2
      DO 1001 II=1,MLAT
      DO 1002 I=1,NSYM
      NQV=NQV+1
      ISN=2-III
      DO  100 IIII=1,3
      TX(IIII,NQV)=TS(IIII,I)+TL(IIII,II)
      DO  100 IIIII=1,3
      FS(IIIII,IIII,NQV)=0.
  100 CONTINUE
      DO 1003 IIII=1,3
      DO 1004 IIIII=1,2
      M=IABS(IS(IIIII,IIII,I))
      IF(M.GT.0)FS(M,IIII,NQV)=FLOAT(ISN*ISIGN(1,IS(IIIII,IIII,I)))
 1004 CONTINUE
 1003 CONTINUE
 1002 CONTINUE
 1001 CONTINUE
 1000 CONTINUE
      ICENT=ICENT/2
C      DO 1111 I=1,NQV
C      WRITE(6,*)((FS(J,K,I),K=1,3),TX(J,I),J=1,3)
C1111  CONTINUE
      RETURN
      END
      SUBROUTINE WRITEY(X,Y,NY,NZ,NX,NSIZE)
      INTEGER H
      DIMENSION X(2,NY,NZ,NX),Y(2,NSIZE)
C     COMPLEX X(NY,NZ,NX),Y(NSIZE)
C   COPY ARRAY X INTO Y
      INDEX=0
      DO 10 L=1,NZ
      DO 11 K=1,NY
      DO 12 H=1,NX
      INDEX=INDEX+1
      DO 12 I=1,2
      Y(I,INDEX)=X(I,K,L,H)
12    CONTINUE
11    CONTINUE
10    CONTINUE
      RETURN
      END
