C  Copyright (c) Rag de Graaff, Leiden University  2004 - 2006           
C
C  This program is free software; you can redistribute it and/or
C  modify it under the terms of the GNU General Public License
C  as published by the Free Software Foundation; either version 2
C  of the License, or (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.

C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, 
C  USA.
      SUBROUTINE CALCE0
      INTEGER HMAX
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
C
C  CALCULATION AS IN SUBR. FIRST OF MULTAN
C
      NN=1
      IF(LATT.EQ.2.OR.LATT.EQ.3.OR.LATT.EQ.4.OR.LATT.EQ.5)NN=2
      IF(LATT.EQ.6) NN=4
      IF(LATT.EQ.7) NN=3
C
C  FOR R LATTICES TEST FOR PRIMITIVE OR CENTRED CELL
C
      X=0.
      Y=0.
      DO 100 I=1,8
      IF(JN(I).EQ.0) GOTO 200
      Y=Y+(NQV*JN(I)*JZ(I)**2)/NN
      X=X+NQV*JN(I)*JZ(I)/NN
  100 CONTINUE
  200 CONTINUE
      E0=X/SQRT(Y)
      RETURN
      END
      SUBROUTINE CRUNCH2_CELL(P,Q,V,PDB,IOPT)
C
C  CALCULATE RECIPROCAL LATTICE CONSTANTS FROM CELL PARAMETERS (IOPT=0)
C  CALCULATE CONSTANTS Q, 1/D**2=H*H*Q1+K*H*Q2 ETC (IOPT#0)
C
C  P AND Q MAY HAVE THE SAME PHYSICAL ADRESS
C
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION P(6),Q(6),PDB(3,3)
      PIR=4.0*ATAN(1.0)/180.0
      CA=COS(PIR*P(4))
      CB=COS(PIR*P(5))
      CC=COS(PIR*P(6))
      SA=SIN(PIR*P(4))
      SB=SIN(PIR*P(5))
      SC=SIN(PIR*P(6))
      CAS=(CB*CC-CA)/(SB*SC)
      PDB(1,1)=P(1)
      PDB(1,2)=CC*P(2)
      PDB(1,3)=CB*P(3)
      PDB(2,1)=0.0
      PDB(2,2)=SC*P(2)
      PDB(2,3)=-SB*CAS*P(3)
      PDB(3,1)=0.0    
      PDB(3,2)=0.0            
      PDB(3,3)=SB*SQRT(1.0-CAS**2)*P(3)
      V=P(1)*P(2)*P(3)
     1 *SQRT(1.0-CA*CA-CB*CB-CC*CC+2.0*CA*CB*CC)
      AS=P(2)*P(3)*SA/V
      BS=P(1)*P(3)*SB/V
      CS=P(1)*P(2)*SC/V
      CBS=(CC*CA-CB)/(SC*SA)
      CCS=(CA*CB-CC)/(SA*SB)
      IF(IOPT.NE.0) GOTO 10
      Q(1)=AS
      Q(2)=BS
      Q(3)=CS
      Q(4)=ACOS(CAS)/PIR
      Q(5)=ACOS(CBS)/PIR
      Q(6)=ACOS(CCS)/PIR
      GOTO 9999
   10 CONTINUE
      Q(1)=AS**2
      Q(2)=BS**2
      Q(3)=CS**2
      Q(4)=2.0*AS*BS*CCS
      Q(5)=2.0*BS*CS*CAS
      Q(6)=2.0*CS*AS*CBS
 9999 RETURN
      END
      SUBROUTINE CENTRE(J,L,MLAT,TL)
C
C  CF MULTAN80
C
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION TL(3,4),TST(21)
      DATA TST/0.,0.,0., 0.,.5,.5, .5,0.,.5, .5,.5,0., .5,.5,.5,
     1 .333333,.666667,.666667, .666667,.333333,.333333/
      MLAT=J
      M=3*L-2
      TL(1,J)=TST(M)
      TL(2,J)=TST(M+1)
      TL(3,J)=TST(M+2)
      RETURN
      END
      SUBROUTINE COEFFT(FO,AC,BC,MRC,NREF,IFOUR,PRES)
      DIMENSION FO(NREF),AC(NREF),BC(NREF),MRC(NREF)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/const.f'
C
C  CALCULATE COEFFICIENTS FOR EXFFT
C
      DO 1001 I=1,NREF
      IF(IFOUR.EQ.1)THEN
      IF(I.EQ.1)WRITE(LO,10)
10    FORMAT(/,' COEFFT: Alpha-gen synthesis (Eo**2*Ec)')
      CALL ALGEN(FO(I),AC(I),BC(I))
      ELSEIF(IFOUR.EQ.2)THEN
      IF(I.EQ.1)WRITE(LO,20)
20    FORMAT(/,' COEFFT: Gamma-prime synthesis (Eo*Exp(Phic))')
      CALL GAMPR(FO(I),AC(I),BC(I),MRC(I),PRES)
      ELSEIF(IFOUR.EQ.3)THEN
      IF(I.EQ.1)THEN
      WRITE(LO,30)
30    FORMAT(/,' COEFFT: 2Fo-Fc synthesis ((2*Eo-Ec)*Exp(Phic))')
      ENDIF
      CALL FOFOFC(FO(I),AC(I),BC(I),MRC(I),PRES)
      ENDIF
1001  CONTINUE
      RETURN
      END
      SUBROUTINE DSTNCE(X1,ORT,DST)
      DIMENSION X1(3),ORT(3,3)
C
C  CALCULATE LENGTH OF X1
C  ORT IS THE ORTOGONALISATION MATRIX
C
      DST=0.
      DO 10 I=1,3
      XO=0.
      DO 1 II=1,3
    1 XO=XO+X1(II)*ORT(I,II)
   10 DST=DST+XO*XO
      RETURN
      END
       INTEGER FUNCTION EVEN(I)
       K=I/2*2
       IF(K.LT.I)THEN
       EVEN=I
       ELSE
       EVEN=I+1
       ENDIF
       RETURN
       END
      SUBROUTINE EXFFT(AC,BC,LH,LK,LL,NRF,X,Y,IY,NS,IH,G,NR,NX,NY,NZ)
C
C  ADAPTED FROM EXFFT80 OF THE MULTAN SYSTEM
C
      DIMENSION AC(NRF),BC(NRF),LH(NRF),LK(NRF),LL(NRF)
      DIMENSION X(NS),Y(NS),IH(NR),G(2,NR),I1(3),I2(3),NP(3),
     1 KIND(24),TAB(15),IY(NS)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/const.f'
      INCLUDE '../common/symtry.f'
      COMMON/COS SIN/C(24),S(24)
      COMMON/SCL/SCALE
      INTEGER HMAX
      TWOPI=2.0*3.14159265
      DTOR=TWOPI/360.0
      NEX=0
      DO 1 I=1,NS
      X(I)=0.0
      Y(I)=0.0
1     CONTINUE
      DO 2 I=1,NR
      DO 3 K=1,2
      G(K,I)=0.0
3     CONTINUE
      IH(I)=0
2     CONTINUE
      NSIZE=NS
      NP(1)=NX
      NP(2)=NY
      NP(3)=NZ
      FSUM=0.
      IP5=256*(262144+512+1)
      HMAX=0
      KMAX=0
      LMAX=0
      DO 110 I=1,15
      TAB(I)=SIN(FLOAT(30*I)*DTOR)
  110 CONTINUE
      DO 699 I=1,NRF
      IF(ABS(AC(I)).GE.1.0E-4.OR.ABS(BC(I)).GE.1.0E-4)THEN
      I1(1)=LH(I)
      I1(2)=LK(I)
      I1(3)=LL(I)
      IF(HMAX.LT.IABS(I1(1)))HMAX=IABS(I1(1))
      IF(KMAX.LT.IABS(I1(2)))KMAX=IABS(I1(2))
      IF(LMAX.LT.IABS(I1(3)))LMAX=IABS(I1(3))
      DO 701 J=1,3
      IF(I1(J).GT.0)GOTO 703
      IF(I1(J).LT.0)THEN
C     IF(I1(J))702,701,703
      BC(I)=-BC(I)
      DO 710 JJ=1,3
710   I1(JJ)=-I1(JJ)
      GO TO 703
      ENDIF
701   CONTINUE
703   CONTINUE
      DO 700 J=1,NSYM
      DO 540 JJ=1,3
  540 I2(JJ)=0
      DO 550 JJ=1,3
      DO 550 K=1,2
      M=IABS(IS(K,JJ,J))
      IF(M.GT.0)I2(M)=I2(M)+I1(JJ)*ISIGN(1,IS(K,JJ,J))
  550 CONTINUE
      B1=1.0
      JS=1
      IF(I2(3).GT.0)GOTO 600
      IF(I2(3).LT.0)GOTO 590
      IF(I2(1).GT.0)GOTO 600
      IF(I2(1).LT.0)GOTO 590
      IF(I2(2).GE.0)GOTO 600
C     IF(I2(3))590,570,600
C 570 IF(I2(1))590,580,600
C 580 IF(I2(2))590,600,600
  590 B1=-1.0
      JS=-1
  600 KIND(J)=IP5+JS*(262144*I2(1)+512*I2(2)+I2(3))
      DO 610 KI=1,3
      IF(IABS(I2(KI)).GE.NP(KI)/2)GOTO 700
C
C*****  IF(I2(KI).GT.MH(KI))MH(KI)=I2(KI)
C
 610  CONTINUE
      ND=J-1
      IF(ND.EQ.0)GOTO 630
      DO 620 KI=1,ND
      IF(KIND(J).EQ.KIND(KI))GOTO 700
  620 CONTINUE
  630 NEX=NEX+1
C      U=0.0
      NU=0
      DO 640 KI=1,3
  640 NU=NU-I1(KI)*INT(TS(KI,J)*12.0+0.1)
      NU=MOD(NU,12)
      IF(NU.LE.0)NU=NU+12
      XC=TAB(NU+3)
      XS=TAB(NU)
      ACLC=AC(I)
      BCLC=BC(I)
      GR=XC*ACLC-XS*BCLC
      GI=(XS*ACLC+XC*BCLC)*B1
      FSUM=FSUM+SQRT(GR*GR+GI*GI)
      IH(NEX)=KIND(J)
      G(1,NEX)=GR
      G(2,NEX)=GI
  700 CONTINUE
      ENDIF
  699 CONTINUE
      SCALE=3000./FSUM
C     WRITE(LO,*)'SCALE,NEX:',SCALE,NEX
      CALL PP1(X,Y,IY,NSIZE,NX,NY,NZ,IH,G,NR,NEX)
C      WRITE(LO,*)'NX,NY,NZ',NX,NY,NZ
      RETURN
      END
      SUBROUTINE GETM(A,NI,B,NR,LOCH,LOCK,LOCL,NFS)
      DIMENSION B(NR)
      INTEGER A(NI)
      LOGICAL READY
      INCLUDE '../common/unit.f'
      INCLUDE '../common/const.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/locaut.f'
      READY=.FALSE.
      NPRS=0
      CALL EXFFT(B(LOCAC),B(LOCBC),A(LOCH),A(LOCK),A(LOCL),NFS,
     1 B(LOCSYM),B(LSTORE),A(LBORE),NRX,A(LOCIH),B(LOCG),NRS,NX,NY,NZ)
      CALL SEARCH(A(LBORE),A(LOCBYM),NX,NY,NZ,NRX
     1 ,B(LOCPO),NATOM,NPIEK,IFAIL)
      CALL VULAT(B(LOCPAR),A(LOCIAR),B(LOCPO),NPIEK)
      RETURN
      END
      SUBROUTINE HOOFD(LO)
      IMPLICIT REAL*4 (A-H,O-Z)
      WRITE(LO,1)
    1 FORMAT(//,10X,5('*'),5X,3(7('*'),3X),6('*'),/,
     1 10X,'*',4X,'*',4X,'*',12X,'*',6X,'*',9X,'*',5X,'*',/,
     2 10X,'*',5X,'*',3X,'*',12X,'*',6X,'*',9X,'*',5X,'*',/,
     3 10X,'*',5X,'*',3X,4('*'),9X,'*',6X,4('*'),6X,6('*'),/,
     4 10X,'*',5X,'*',3X,'*',12X,'*',6X,'*',9X,'*',3X,'*',/,
     5 10X,'*',5X,'*',3X,'*',12X,'*',6X,'*',9X,'*',4X,'*',/,
     6 10X,'*',5X,'*',3X,'*',12X,'*',6X,'*',9X,'*',5X,'*',/,
     7 10X,6('*'),4X,7('*'),6X,'*',6X,7('*'),3X,'*',5X,'*',
     8 ///)
      WRITE(LO,2)
    2 FORMAT(10X,'Version: Autumn 2001',//,
     1 10X,'Authors: Dr. R. de Gelder    ',/,
     2 10X,'         Dr. R.A.G. de Graaff',/,
     2 10X,'         Dr. J.L. van der Plas',/,
     3 10X,'         Dr. W.J. Vermin     ',//,
     4 10X,'LIC, Gorlaeus Laboratories',/,
     7 10X,'University of Leiden',/,
     5 10X,'PO Box 9502, 2300 RA Leiden',/,
     6 10X,'The Netherlands',///)
      RETURN
      END
      SUBROUTINE INPUT(A,NI,R,NR,IFIRST,JFIRST,JFAT,NBEGIN,NEIND,RESO)
      INTEGER A(NI),EVEN
      DIMENSION R(NR)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/detpar.f'
      INCLUDE '../common/autpar.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/locaut.f'
      CHARACTER TITLE*80
      COMMON /CONST/ STLMAX,CED,MH(3),JN(8),JZ(8),E0,TITLE,
     1 FT,NAT,NATOM,NDIM,ICMAX,SF,SZ,DN,XN,ICOOR,STLIM,NOSPC
C
C NAT IS THE NUMBER OF ATOMS IN THE CELL, NATOM THE NUMBER TO BE FOUND
C
      ICENT=0
C
C We do not do centrosymmetric spacegroups
C
      CALL SPESIN(NR,NBEGIN,NEIND)
      JFAT=1
      LOCREF=JFIRST
      REWIND(IREFL)
      JFIRST=EVEN(LOCREF+5*NREF)
      CALL PLAATS(NI,IFIRST-1,NR,JFIRST-1,0,LO)
C
C   NREF IS THE DIMENSION FOR ALL VARIABLES INVOLVING STRUCTUREFACTORS
C
      LOCFO=LOCREF
      LOCAC=EVEN(LOCREF+NREF)
      LOCBC=EVEN(LOCAC+NREF)
      LOCSN=EVEN(LOCBC+NREF)
      JFIRST=EVEN(LOCSN+NREF)
      LOCAH=IFIRST
      LOCAK=EVEN(LOCAH+NREF)
      LOCAL=EVEN(LOCAK+NREF)
      LOCMRC=EVEN(LOCAL+NREF)      
      IFIRST=EVEN(LOCMRC+NREF)
      CALL RFLIN1(R(LOCFO),R(LOCAC),R(LOCBC),R(LOCSN),
     1 A(LOCAH),A(LOCAK),A(LOCAL),A(LOCMRC),RESO)
      DN=RESO
      DN=MAX(0.9,DN)
      MH(1)=MAX(MH(1),MH(2))
      MH(2)=MAX(MH(1),MH(2))
      NRS=NSYM*NREF
      NRS2=2*NRS
      LOCBYM=IFIRST
      LOCSYM=JFIRST
      CALL GRID(NX,NY,NZ,DN)
      NRX=MAX0(2*NY*(MH(3)+1)*(2*MH(1)+1),(NY+2)*(NX+2)*(NZ+2),NRS)
      JFIRST=EVEN(LOCSYM+NRX)
      IFIRST=EVEN(LOCBYM+NRX)
      LSTORE=JFIRST
      JFIRST=EVEN(LSTORE+NRX)
      LBORE=IFIRST
      IFIRST=EVEN(LBORE+NRX)
      CALL PLAATS(NI,IFIRST-1,NR,JFIRST-1,0,LO)
      LOCIH=IFIRST
      LOCG=JFIRST
      IFIRST=EVEN(LOCIH+NRS)
      JFIRST=EVEN(LOCG+NRS2)
      CALL PLAATS(NI,IFIRST-1,NR,JFIRST-1,0,LO)
      NAT6=6*NQV*NDIM 
      LOCPAR=JFIRST
      JFIRST=EVEN(LOCPAR+2*NAT6)
      LOCIAR=IFIRST
      IFIRST=EVEN(LOCIAR+4*NQV*NDIM)
      LOCBES=JFIRST
      JFIRST=EVEN(JFIRST+NAT6)
      LOCBIS=IFIRST
      IFIRST=EVEN(IFIRST+NQV*NDIM*2)
      LOCBAS=IFIRST
      IFIRST=EVEN(IFIRST+NQV*NDIM*2)
      LOCS=JFIRST
      JFIRST=EVEN(LOCS+NQV*NDIM*2)
      LOCC=JFIRST
      JFIRST=EVEN(LOCC+NQV*NDIM*2)
      NMXX=NMX*(NMX-1)/2
      LOCW=JFIRST
      NATS=(2+3*NSYM)*NQV*NDIM
      JFIRST=EVEN(LOCW+MAX(NATS,NMXX))
      LOCWS=JFIRST
      JFIRST=EVEN(LOCWS+NMXX)
      CALL PLAATS(NI,IFIRST-1,NR,JFIRST-1,0,LO)
C     CLOSE(IREFL)
      RETURN
      END
      SUBROUTINE INSPEC(NBEGIN,NEIND)
C
C  READ KEYWORDED PARAMETERS
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX,S
      CHARACTER*4 LTC*1,LTT*1
      DIMENSION LTC(7),S(9),T(3)
C
C Things for CCP4 parser
C
      integer maxtok,ntok
      parameter (maxtok = 200)
      integer ibeg(maxtok), iend(maxtok), ityp(maxtok), idec(maxtok)
      integer nspgrx, nsymx, nsympx
      real fvalue(maxtok), rsymx(4,4,384)
      logical lsymm, lcell, lend
      character str*500
      character*4 key, cvalue(maxtok)
      character spgrnx*20, pgnamx*10
C
      INCLUDE '../common/detpar.f'
      INCLUDE '../common/comhas.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/unit.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      INCLUDE '../common/const.f'
      DATA LTC /'P','A','B','C','I','F','H'/

      lsymm=.false.
      lcell=.false.

* Parse user input
 100  continue

      str = ' '
      ntok = maxtok
      call parser (key, str, ibeg, iend, ityp, fvalue, cvalue,
     $     idec, ntok, lend, .true.)
      if (lend) go to 20

*     TITLE keyword 
      if (key .eq. 'TITL') then
         TITLE = str(ibeg(2):iend(ntok))
         goto 100

*     TRY keyword - read in range of trials
      else if (key .eq. 'TRY') then
         IF (NTOK.GE.2) NBEGIN = NINT(FVALUE(2))
         IF (NTOK.GE.3) NEIND = NINT(FVALUE(3))
         Write(LO,*)'NBEGIN,NEIND',NBEGIN,NEIND
         go to 100

*     SKOR keyword - read in range of trials
      else if (key .eq. 'SKOR') then
         ISCORING = 1
         go to 100

*     NCYC keyword - read in maximum number of cycles in a trials
      else if (key .eq. 'NCYC') then
         IF (NTOK.GE.2) ICMAX = NINT(FVALUE(2))
         go to 100

C
C Hash table keywords                 
C
C      NHASkeyword - read in NHAS
      else if(key.eq.'NHAS')then
         IF(NTOK.GE.2)NHAS=NINT(FVALUE(2))
         go to 100
C      IHASkeyword - read in IHAS
      else if(key.eq.'IHAS')then
         IF(NTOK.GE.2)IHAS=NINT(FVALUE(2))
         go to 100
C      IT  keyword - read in IT  
      else if(key.eq.'IT')then
         IF(NTOK.GE.2)IT=NINT(FVALUE(2))
         go to 100
C      ITESTkeyword - read in ITST
      else if(key.eq.'ITST')then
         IF(NTOK.GE.2)ITEST=NINT(FVALUE(2))
         go to 100
*     IBK keyword - read in IBK
      else if (key .eq. 'IBK') then
         IF (NTOK.GE.2) IBK = NINT(FVALUE(2))
         go to 100

*     Sin theta limit keyword - read in STLM
      else if (key.eq. 'STLM') then
         IF(NTOK.GE.2)then
         STLIM=NINT(FVALUE(2))/10.0
         ELSE
         STLIM=0.4
         ENDIF
         go to 100
*     NRL keyword - read in NRL
      else if (key .eq. 'NRL') then
         IF (NTOK.GE.2) NRL = NINT(FVALUE(2))
         go to 100
*      ICRIkeyword - read in ICRI
      else if (key .eq. 'ICRI') then
         IF (NTOK.GE.2) ICRI = NINT(FVALUE(2))
         go to 100
*      ICRAkeyword - read in ICRA
      else if (key .eq. 'ICRA') then
         IF (NTOK.GE.2) ICRA = NINT(FVALUE(2))
         go to 100
*      ICRBkeyword - read in ICRB
      else if (key .eq. 'ICRB') then
         IF (NTOK.GE.2) ICRB = NINT(FVALUE(2))
         go to 100

*      ICOORkeyword - read in ICOOR
      else if (key .eq. 'ICOO') then
         IF (NTOK.GE.2) ICOOR = NINT(FVALUE(2))
         go to 100

C
C     NOSPC keyword - read in NOSPC
C
      else if (key.eq.'NOSP') then
         IF (NTOK.GE.2) NOSPC=1
         go to 100
        
*     NOTF keyword - read in NOTF
      else if (key .eq. 'NOTF') then
         IF (NTOK.GE.2) NOTF = NINT(FVALUE(2))
         go to 100

*     CELL keyword - read in the cell parameters
      else if (key .eq. 'CELL') then
         call rdcell (2, ityp, fvalue, ntok, PARA)
         lcell = .true.
         go to 100

*      keyword - read in number of atoms to look for 
C          (format allows up to 8 ??)
      else if (key .eq. 'NATO') then
         JN(1) = NINT(FVALUE(2))
         go to 100

*      keyword - read in scattering factor of atoms (15 is fine)
C          (format allows up to 8 ??)
      else if (key .eq. 'SCAT') then
         JZ(1) = NINT(FVALUE(2))
         go to 100

*     SYMM keyword
      else if (key .eq. 'SYMM') then
         call rdsymm (2, str, ibeg, iend, ityp, fvalue, ntok,
     $        spgrnx, nspgrx, pgnamx, nsymx, nsympx, rsymx)
         LTT = spgrnx(1:1)
C note, NSYM is interpreted as number of primitive operators
         NSYM = nsympx
         lsymm = .true.
         goto 100

*     END keyword
      else if (key .eq. 'END') then
         goto 20
*     else error
      else
        call ccperr (1, 'Bad keyword: '//key)
      endif

C end of keyworded input
 20   continue

      if (.not.lcell) call ccperr (1, 'CELL keyword compulsory.')
      if (.not.lsymm) call ccperr (1, 'SYMM keyword compulsory.')

      DO 10 KKK=1,NSYM
        DO I=1,3
          DO J=1,3
            S(J+(I-1)*3) = RSYMX(I,J,KKK)
          ENDDO
          T(I) = RSYMX(I,4,KKK)
        ENDDO
      CALL MAKES(S,T,TS(1,KKK),IS(1,1,KKK))
10    CONTINUE

      WRITE(LO,1)
    1 FORMAT(' Control parameters:')
      WRITE(LO,2) TITLE,PARA,JN,JZ,LTT,NSYM
    2 FORMAT
     1 (' Title: ',A80,/
     2 ,' Cell:  ',6F10.4,/
     3 ,' JN:    ',8I5,/
     4 ,' JZ:    ',8I5,/
     6 ,' LATT:  ',4X,A1,/
     7 ,' NSYM:  ',I5,/)
      WRITE(LO,3) ((TS(I,J),(IS(K,I,J),K=1,2),I=1,3),J=1,NSYM)
    3 FORMAT(' Symmetry information:',/
     1 ,(3(F11.8,2I2)))
      LATT=1
      DO 440 I=2,7
      IF(LTC(I).EQ.LTT) LATT=I
  440 CONTINUE
      RETURN
      END
      SUBROUTINE MAKERS
C
C  FILL THE MATRIX RS
C
      COMMON/SYMTRY/MCENTR,NSYM,TS(3,24),IS(2,3,24),LATT,NV,FS(3,3,192)
     1 ,TX(3,192),ORT(3,3),TL(3,4),RS(3,3,24),MLAT
      NQV=0
      MCENTR=2*MCENTR+1
      DO 1000 III=1,MCENTR,2
      II=1
      DO 1000 I=1,NSYM
      NQV=NQV+1
      ISN=2-III
      DO  100 IIII=1,3
      TX(IIII,NQV)=TS(IIII,I)+TL(IIII,II)
      DO  100 IIIII=1,3
      RS(IIIII,IIII,NQV)=0.0
  100 CONTINUE
      DO 1000 IIII=1,3
      DO 1000 IIIII=1,2
      M=IABS(IS(IIIII,IIII,I))
      IF(M.GT.0)RS(IIII,M,NQV)=FLOAT(ISN*ISIGN(1,IS(IIIII,IIII,I)))
 1000 CONTINUE
      MCENTR=(MCENTR-1)/2
C     DO 1111 I=1,NQV
C     WRITE(LO,8)((RS(J,K,I),K=1,3),TX(J,I),J=1,3)
C8    FORMAT(3(3F5.1,2x,F5.1,/))
C1111 CONTINUE
      RETURN
      END
      SUBROUTINE MAKES(S,T,TS,IS)
      INTEGER S(9),IS(2,3)
      DIMENSION T(3),TS(3)
      DO 1 I=1,3
      TS(I)=T(I)
      M=0
      IS(2,I)=0
      DO 2 J=1,3
      INDEX=(I-1)*3+J
      K=S(INDEX)
      IF(K.NE.0)THEN
      M=M+1
      IS(M,I)=ISIGN(J,K)
      ENDIF
2     CONTINUE
1     CONTINUE
      RETURN
      END
      SUBROUTINE MULT(H,K,L,EPS)
      INTEGER H,EPS,HKL(3)
C
C  CALCULATE MULTIPLICITY OF ONE REFLECTION
C
      INCLUDE '../common/symtry.f'
      DIMENSION KHL(3)
      EPS=0
      DO 100 I=1,NSYM
      DO  10 II=1,3
   10 KHL(II)=0
      HKL(1)=H
      HKL(2)=K
      HKL(3)=L
      DO 11 II=1,3
      DO 11 III=1,2
      M=IABS(IS(III,II,I))
      IF(M.NE.0)KHL(M)=KHL(M)+HKL(II)*ISIGN(1,IS(III,II,I))
   11 CONTINUE
      DO 12 II=1,3
      IDIF=HKL(II)-KHL(II)
      IF(IDIF.NE.0)GOTO 100
C     IF(IDIF)100,12,100
   12 CONTINUE
      EPS=EPS+1
  100 CONTINUE
      RETURN
      END
      SUBROUTINE ORTH(CELL,ORT)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION CELL(6),ORT(3,3)
      PIR=3.14159265/180.0
      CA=COS(PIR*CELL(4))
      CB=COS(PIR*CELL(5))
      CG=COS(PIR*CELL(6))
      SA=SQRT(1-CA*CA)
      SG=SQRT(1-CG*CG)
      CBCACG=CA-CB*CG
      CBCASG=CBCACG/SG
      CBSASG=SQRT(SA*SA-CB*CB-CG*CG+2*CA*CB*CG)/SG
      ORT(1,1)=1
      ORT(2,1)=0.
      ORT(3,1)=0.
      ORT(1,2)=CG
      ORT(2,2)=SG
      ORT(3,2)=0
      ORT(1,3)=CB
      ORT(2,3)=CBCASG
      ORT(3,3)=CBSASG
      DO 10 I=1,3
      DO 10 II=1,3
10    ORT(I,II)=CELL(II)*ORT(I,II)
      RETURN
      END
      SUBROUTINE PAK(M,I,J,K)
      IMPLICIT REAL*4 (A-H,O-Z)
      M=((128+I)*256+128+J)*256+128+K
      RETURN
      END
      SUBROUTINE PLAATS(N,M,NR,MR,IP,LO)
C
C  CHECK WHETHER SUFFICIENT CORE IS AVAILABLE
C
      IMPLICIT REAL*4 (A-H,O-Z)
      IF(IP.EQ.1)WRITE(LO,1)M,MR
1     FORMAT(/,' PLAATS: ',2I10,' integer, floating words'
     1, ' are necessary')
      IF(M.GT.N.OR.MR.GT.NR)GOTO 1000
      RETURN
 1000 WRITE(LO,2)
      Write(LO,5)N,NR
      WRITE(LO,4)M,MR
4      FORMAT(/,' Necessary: ',2I10)
5      FORMAT(/,' Available: ',2I10)
    2 FORMAT(/,' ***** NOT ENOUGH CORE *****')
      STOP
      END
      REAL*4 FUNCTION RANDOM(J)
      INTEGER LO,HI,TEST,SEED,A,M,Q,R
      PARAMETER(A=16807,M=2147483647,Q=127773,R=2836)
      SAVE SEED
      IF (J.NE.0) THEN
C     SEED=65539
      SEED=MOD(IABS(J),M)
      ENDIF
      HI=SEED/Q
      LO=SEED-HI*Q
      TEST=A*LO-R*HI
      IF(TEST.GT.0)THEN
      SEED=TEST
      ELSE
      SEED=TEST+M
      ENDIF
      RANDOM=FLOAT(SEED)/M
      RETURN
      END
      SUBROUTINE RFLIN1(FO,AC,BC,SN,IH,IK,IL,MRC,RESO)
      DIMENSION FO(NREF),AC(NREF),BC(NREF),SN(NREF)
      INTEGER H,EPS,IH(NREF),IK(NREF),IL(NREF),MRC(NREF)
      INCLUDE '../common/../common/detpar.f'
C     COMMON /DETPAR/ NMX,IBK,NRL,ICRI,ICRA,ICRB,NSTR,NOTF,IPRMX
C    1 ,IPRIJP,IELIM
C     COMMON/PNTR/IPNT(8),JPNT(8),S(8),KPNT(8),NMO(8),KV(8),
C    1 LPNT(8),ATOM(8),EXCL(8)
      INCLUDE '../common/../common/const.f'
C     CHARACTER TITLE*80
C     COMMON /CONST/ STLMAX,CED,HMAX,KMAX,LMAX,JN(8),JZ(8),E0,TITLE,
C    1 NAT,NATOM,ICMAX,IBLES,NFAT,SF,SZ,DN,XN,DREMPL
      INCLUDE '../common/../common/unit.f'
      INCLUDE '../common/../common/autpar.f'
C     COMMON /AUTPAR/IFOUR1,IFOUR2,NCCH,LTST,NLEES,NWEG,ISTLM,
C    1 IDRMPL,NDIF,PERC,DELR,STOPR,PRW,NREF,FOM
      COMMON /PARAM/ CELL(6),Q(6),PDB(3,3),ISCORING
      INTEGER HMAX
C
C  READ REFLECTIONS FROM Eval Program
C  OR FROM SnB output *.DREAR 
C
      STLMAX=0.4
      STMAX=0
      NREF=0
      HMAX=0
      KMAX=0
      LMAX=0
100   CONTINUE
      READ(IREFL,102,END=200)H,K,L,F,SFF,E,SE
      STL=SQRT(H*H*Q(1)+K*K*Q(2)+L*L*Q(3)+H*K*Q(4)+K*L*Q(5)+L*H*Q(6))
      DSPA=1.0/STL
102   FORMAT(3I5,4F9.3)
      IF(DSPA.LT.STLMAX.OR.DSPA.LT.STLIM)GOTO 100
      IF(STMAX.LT.STL)STMAX=STL
      CALL MULT(H,K,L,EPS)
      CALL RSTRC(MARC,H,K,L)
      IF(MARC.EQ.0)GOTO 100
      NREF=NREF+1
      FO(NREF)=E
      AC(NREF)=0.0
      BC(NREF)=0.0
      SN(NREF)=SQRT(EPS*SF)
C1234  Format(F10.3,3I3,2F10.3)
      IF(IABS(H).GT.HMAX)HMAX=IABS(H)
      IF(IABS(K).GT.KMAX)KMAX=IABS(K)
      IF(IABS(L).GT.LMAX)LMAX=IABS(L)
      IH(NREF)=H
      IK(NREF)=K
      IL(NREF)=L
      MRC(NREF)=MARC
      GOTO 100
  200 CONTINUE
      RESO=1.0/STMAX
      WRITE(LO,3)NREF
3     FORMAT(/,' RFLIN: ',I7,' Reflections read from code.drear')
      RETURN
      END
      SUBROUTINE RSTRC(MK,IH,IK,IL)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX
      DIMENSION KHL(4),IND(3)
      INCLUDE '../common/../common/unit.f'
      INCLUDE '../common/../common/pack.f'
      INCLUDE '../common/../common/symtry.f'
      INCLUDE '../common/../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
C
C  TAKEN FROM SUBROUTINE GROUP (MULTAN)
C  FINDS PHASE RESTRICTION OF REFLEXION IN A (BYTE 2, 3, 4)
C  MK=0: FORBIDDEN REFLEXION
C  MK=1: NO RESTRICTION
C  ELSE PHASE=15*(MK-1)+PI
C
      IND(1)=IH
      IND(2)=IK
      IND(3)=IL
C
C  FORBIDDEN REFL?
C
      GOTO (10,20,30,40,50,60,70),LATT
   10 CONTINUE
C
C  PRIMITIVE LATTICE
C
      GOTO 1000
   20 CONTINUE
C
C  A-LATTICE
C
      IF(MOD(IND(2)+IND(3),2).NE.0) GOTO 2000
      GOTO 1000
   30 CONTINUE
C
C  B-LATTICE
C
      IF(MOD(IND(1)+IND(3),2).NE.0) GOTO 2000
      GOTO 1000
   40 CONTINUE
C
C  C-LATTICE
C
      IF(MOD(IND(1)+IND(2),2).NE.0) GOTO 2000
      GOTO 1000
   50 CONTINUE
C
C  I-LATTICE
C
      IF(MOD(IND(1)+IND(2)+IND(3),2).NE.0) GOTO 2000
      GOTO 1000
   60 CONTINUE
C
C  F-LATTICE
C
      K=MOD(IND(1),2)
      IF(K.NE.MOD(IND(2),2)) GOTO 2000
      IF(K.NE.MOD(IND(3),2)) GOTO 2000
      GOTO 1000
   70 CONTINUE
C
C  R-LATTICE
C
      CRIT=ABS(PARA(1)-PARA(2))
      CRIT=CRIT+ABS(PARA(2)-PARA(3))
      CRIT=CRIT+ABS(PARA(4)-PARA(5))
      CRIT=CRIT+ABS(PARA(5)-PARA(6))
      IF(CRIT.LT.0.5)GOTO 1000
      IF(MOD(IND(2)+IND(3)-IND(1),3).NE.0) GOTO 2000
 1000 CONTINUE
      DO 1180 J=1,NSYM
      DO 1080 K=1,4
      KHL(K)=0
 1080 CONTINUE
      DO 1140 K=1,3
      KHL(4)=KHL(4)+IND(K)*INT(TS(K,J)*24.0+0.01)
      DO 1120 L=1,2
      M=IABS(IS(L,K,J))
      IF(M.NE.0) KHL(M)=KHL(M)+IND(K)*ISIGN(1,IS(L,K,J))
 1120 CONTINUE
 1140 CONTINUE
      DO 1160 K=1,3
      IF(IND(K).NE.KHL(K))GOTO 1180
C     IF(IND(K)-KHL(K)) 1180,1160,1180
 1160 CONTINUE
      IF(MOD(KHL(4),24).NE.0) GOTO 2000
 1180 CONTINUE
      GOTO 2900
 2000 CONTINUE
      MK=0
      GOTO 9001
 2900 CONTINUE
      IF(ICENT.NE.0) GOTO 9000
      MK=1
      DO 2180 J=1,NSYM
      DO 2080 K=1,4
      KHL(K)=0
 2080 CONTINUE
      DO 2140 K=1,3
      KHL(4)=KHL(4)+IND(K)*INT(TS(K,J)*12.0+0.1)
      DO 2120 L=1,2
      M=IABS(IS(L,K,J))
      IF(M.NE.0) KHL(M)=KHL(M)+IND(K)*ISIGN(1,IS(L,K,J))
 2120 CONTINUE
 2140 CONTINUE
      DO 2160 K=1,3
C     IF(IND(K)+KHL(K)) 2180,2160,2180
      IF(IND(K).NE.-KHL(K))GOTO 2180
 2160 CONTINUE
      MK=MOD(KHL(4),12)+1
      IF(MK.LE.1) MK=MK+12
      GOTO 2200
 2180 CONTINUE
 2200 CONTINUE
      GOTO 9001
 9000 MK=13
 9001 RETURN
      END
      SUBROUTINE SCHAR(A,IA,N,J,K)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HMAX
      INTEGER   A(IA)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/pack.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
      COMMON /PARAM/ PARA(6),Q(6),PDB(3,3),ISCORING
      IF(K+N-1.GT.IA.OR.J+N-1.GT.IA) GOTO 200
      IF(J.EQ.K)GOTO 900
      IF(J.GT.K)GOTO 50
C     IF(J-K) 10,900,50
      LOCJ=J+N-1
      LOCK=K+N-1
      ISTAP=-1
      GOTO 30
   50 LOCJ=J
      LOCK=K
      ISTAP=1
   30 DO 40 I=1,N
      A(LOCK)=A(LOCJ)
      LOCK=LOCK+ISTAP
   40 LOCJ=LOCJ+ISTAP
      GOTO 900
  200 WRITE(LO,1) IA,N,J,K
    1 FORMAT(' SCHAR: WRONG DIMENSION; IA, N, J, K=',4I10)
      STOP
  900 RETURN
      END
      SUBROUTINE SEARCH(MAP,NR3D,NX,NY,NZ,NRS3,XYZ
     1 ,NPIC,NPIK,IFAIL)
C
C  ADAPTED FROM SEARCH80 (CF MULTAN)
C
      DIMENSION XYZ(4,NPIC*2),NR3D(NRS3),XS(3),
     1 X1(3),B(19),MAP(NRS3)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/const.f'
      INCLUDE '../common/symtry.f'
      COMMON/SRCH/IDIFF(19),DX,DY,DZ,NXZ,NXZ3,NXP2
C
C  NPIC=NUMBER OF ATOMS IN THE NEXT MODEL
C  NPIK=NUMBER OF PEAKS TAKEN FROM THE MAP
C
      IHALF=0
      IF(LATT.EQ.2.OR.LATT.EQ.4.OR.LATT.EQ.5.OR.LATT.EQ.6)IHALF=1
      DO 1 I=1,NQV
      IF(FS(2,2,I).EQ.-1.AND.ABS(TX(2,I)).LT.1.0E-5)IHALF=1
      IF(FS(2,2,I).EQ.1.AND.ABS(ABS(TX(2,I))-0.5).LT.1.0E-5)IHALF=1
1      CONTINUE
       NYOLD=NY
      IF(IHALF.NE.0)NY=NY-NY/2
      NPIK=MIN0(NINT(1.3*NPIC),NPIC+10)
      NPIK=MAX(2,NPIK)
      LIMIT=NPIK
      LEVEL=0
 1100 CALL DFFR(NXZ,NXP2,IDIFF)
      NO=0
      IY=-1
      NNY=0
      MY=NX*NZ*NYOLD
 1200 CONTINUE
      IF(IY+2.EQ.NYOLD)GOTO 1400
      NMAX=NXZ
      INDEX=NX*NZ*(NYOLD-1)
      CALL RDSECT(MAP,NR3D,NRS3,NZ,NXP2,NXZ3,NMAX,MY,INDEX)
      CALL RDSECT(MAP,NR3D,NRS3,NZ,NXP2,NXZ3,NMAX,MY,INDEX)
 1400 MX=NMAX-NXZ+NX+1
      CALL RDSECT(MAP,NR3D,NRS3,NZ,NXP2,NXZ3,NMAX,MY,INDEX)
      IY=IY+1
      NNY=MOD(NNY+2,3)-1
      KK=NXZ3
      IF(NNY.GT.0)GOTO 1500
      IF(NNY.EQ.0)GOTO 1460
C     IF(NNY)1440,1460,1500
      KK=-NXZ3
C1440 KK=-NXZ3
 1460 CONTINUE
      DO 1480 I=1,5
 1480 IDIFF(I)=IDIFF(I)-KK
      IF(NNY.EQ.0)GOTO 1540
 1500 CONTINUE
      DO 1520 I=15,19
 1520 IDIFF(I)=IDIFF(I)-KK
 1540 CONTINUE
      DO 2000 IZ=1,NZ
      MN = MX + 3
      MX=MX+NXP2
      DO 1980 IX=MN,MX
      IF (NR3D(IX) .LT. LEVEL) GO TO 1980
C
C  LOCATE GRID POINT WITH MAXIMUM DENSITY
C
      DO 1560 I=1,9
      J = IDIFF(I) + IX
      IF (NR3D(IX) .LE. NR3D(J)) GO TO 1980
 1560 CONTINUE
      DO 1580 I=11,19
      J = IDIFF(I) + IX
      IF (NR3D(IX) .LT. NR3D(J)) GO TO 1980
 1580 CONTINUE
C
C  FIT QUADRATIC FUNCTION TO 19 POINTS
C
C     DENS = A + C*X + D*Y + E*Z - 0.5*F*(X*X + Y*Y + Z*Z)
      DO 1600 I=1,19
      J = IDIFF(I) + IX
      B(I) = NR3D(J)
 1600 CONTINUE
      D=0
      E=0
      B1 = B(3) + B(7) + B(9) + B(11) + B(13) + B(17)
      B2 = B(1) + B(2) + B(4) + B(5) + B(6) + B(8) + B(12) + B(14) +
     1 B(15) + B(16) + B(18) + B(19)
      F = (30.0 * B(10) + 11.0 * B1 - 8.0 * B2) / 63.0
      C = (B(5)+B(12)+B(13)+B(14)+B(19)-B(1)-B(6)-B(7)-B(8)-B(15))/10.0
      DELTAX = C / F
      IF (ABS(DELTAX) .GT. 1.0) GO TO 1620
      D = (B(15)+B(16)+B(17)+B(18)+B(19)-B(1)-B(2)-B(3)-B(4)-B(5))/10.0
      DELTAY = D / F
      IF (ABS(DELTAY) .GT. 1.0) GO TO 1620
      E = (B(4)+B(8)+B(11)+B(14)+B(18)-B(2)-B(6)-B(9)-B(12)-B(16))/10.0
      DELTAZ = E / F
      IF (ABS(DELTAZ) .LE. 1.0) GO TO 1640
 1620 DELTAX = 0.0
      DELTAY = 0.0
      DELTAZ = 0.0
 1640 XX = (FLOAT(IX-MN+1) + DELTAX) * DX
      YY = (FLOAT(IY) + DELTAY) * DY
      ZZ = (FLOAT(IZ) + DELTAZ) * DZ
C
C  PEAK HEIGHT INTERPOLATION - NOT SUITABLE IF PEAK SHAPE IS POOR
C
C     A = (9.0 * B(10) + 4.0 * B1 - B2) / 21.0
C     B(10) = AMAX1(A+0.5*(C*DELTAX+D*DELTAY+E*DELTAZ), B(10))
      NOP1 = NO+1
      XYZ(1,NOP1)=XX
      XYZ(2,NOP1)=YY
      XYZ(3,NOP1)=ZZ
      XYZ(4,NOP1)=B(10)
      IF (NO .EQ. 0) GO TO 1820
      IR=0
C
C  IF TWO PEAKS ARE CLOSER THAN DN ANGSTROMS ELIMINATE THE SMALLER
C
      DO 1800 K=1,NQV
      DO 1660 L=1,3
      XS(L)=XX*FS(1,L,K)+YY*FS(2,L,K)+ZZ*FS(3,L,K)+TX(L,K)
 1660 CONTINUE
      DO 1780 I=1,NO
      DO 1720 L=1,3
      X1(L)=XYZ(L,I)-XS(L)
 1680 IF (ABS(X1(L)) .LE. 0.5) GO TO 1700
      X1(L) = X1(L) - SIGN(1.0, X1(L))
      GO TO 1680
 1700 IF(ABS(X1(L)).GT.XN)GOTO 1780
 1720 CONTINUE
      CALL DSTNCE(X1,ORT,DST)
      IF(DST.GT.DN)GOTO 1780
      IF(IR.GT.0)XYZ(4,IR)=0.0
      IR=0
      IF(B(10).LE.XYZ(4,I))GO TO 1980
      XYZ(1,I)=XX
      XYZ(2,I)=YY
      XYZ(3,I)=ZZ
      XYZ(4,I)=B(10)
      IR=I
 1780 CONTINUE
 1800 CONTINUE
      IF(IR.GT.0)GOTO 1980
 1820 NO = NOP1
      IF (NO .LT. LIMIT) GO TO 1980
      CALL SORT6(XYZ,4,2*NPIC,NO,4)
      LEVEL=XYZ(4,NO)+0.5
      NO = NPIK
 1980 CONTINUE
 2000 CONTINUE
      IF(IY.GE.NY)GO TO 2100
      IF(IY+2.EQ.NYOLD)THEN
      GOTO 1200
      ELSE
      GOTO 1400
      ENDIF
C     IF(IY-NYOLD+2)1400,1200,1400
 2100 CONTINUE
      CALL SORT6(XYZ,4,2*NPIC,NO,4)
      NNN=MIN0(NO,NPIK)
      IF(NNN.EQ.NPIK)THEN
      NY=NYOLD
C      DO 88 JJ=1,NPIC
C      WRITE(LO,487)(XYZ(II,JJ),II=1,4)
C487   FORMAT(3F10.4,F10.1)
C88    CONTINUE
      RETURN
      ENDIF
      LEVEL=LEVEL-100
      IF(LEVEL.GE.(-200))GOTO 1100
      IFAIL=-1
      NPIK=NO
      NY=NYOLD
      RETURN
      END
      SUBROUTINE SMLT(X,BGR)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION X(3),XS(3),X1(3)
C
C  FIND MULTIPLICITY OF POSITION X
C
      INCLUDE '../common/symtry.f'
      DN=0.6
      K=0
      DO 100 I=1,NQV
      DO  10 II=1,3
C      WRITE(LO,*)(FS(III,II,I),III=1,3),TX(II,I)
      XD=0.
      XS(II)=X(1)*FS(1,II,I)+X(2)*FS(2,II,I)+X(3)*FS(3,II,I)+TX(II,I)
    1 IF(XD.NE.0.)XS(II)=XS(II)+SIGN(1.,XD)
      XD=X(II)-XS(II)
      IF(ABS(XD).GT.0.5)GOTO 1
      X1(II)=XD
   10 CONTINUE
      CALL DSTNCE(X1,ORT,DST)
      IF(DST.GT.DN)GOTO 100
      K=K+1
  100 CONTINUE
      BGR=K
      RETURN
      END
      SUBROUTINE SORT(X,KU,KUSER1,POINT,NAT,N)
C
C  Sort X(KU,KUSER) on X(N,..) CREATING POINTERS ARRAY POINT
C  ON COMPLETION X(N,POINT(1)) WILL BE THE LARGEST VALUE OF X(N,..)
C  ONLY THE FIRST NAT ELEMENTS ARE SORTED
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER   X(KU,KUSER1)
      INTEGER POINT(NAT)
      DO 1 I=1,NAT
1     POINT(I)=I
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NAT)GOTO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NAT-INT
      DO 1200 II=1,IFIN
      I=II
      J=I+INT
      IF(X(N,POINT(I)).GE.X(N,POINT(J)))GOTO 1200
      K=POINT(J)
1080  POINT(J)=POINT(I)
      J=I
      I=I-INT
      IF(I.LE.0)GOTO 1140
C     IF(I)1140,1140,1120
      IF(X(N,POINT(I)).LT.X(N,K))GOTO1080
1140  POINT(J)=K
1200  CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE SORT1(X,KU,KUSER1,NAT,N)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER X(KU,KUSER1),T(6)
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NAT)GOTO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NAT-INT
      DO 1200 II=1,IFIN
      I=II
      J=I+INT
      IF(X(N,I).LE.X(N,J))GOTO 1200
      DO 1060 K=1,KU
      T(K)=X(K,J)
1060  CONTINUE
1080  DO 1100 K=1,KU
      X(K,J)=X(K,I)
1100  CONTINUE
      J=I
      I=I-INT
      IF(I.LE.0)GOTO 1140
C     IF(I)1140,1140,1120
      IF(X(N,I).GT.T(N))GOTO1080
1140  CONTINUE
      DO 1160 K=1,KU
      X(K,J)=T(K)
1160  CONTINUE
1200  CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE SORT2(X,KU,KUSER1,NAT,N,IX)
C
C Sort X(KU,KUSER1) on X(N,..). On completion X(N,1) will be the
C largest value of X(N,..). IX(2,KUSER1) is changed following X()
C Only the first NAT elements are sorted
C
      DIMENSION X(KU,KUSER1),T(6),S(2),IX(2,KUSER1)
      INTEGER S
      INT=2
 1000 INT=INT+INT
      IF(INT.LT.NAT)GO TO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
 1020 INT=INT/2
      IFIN=NAT-INT
      DO 1200 II=1,IFIN
      I=II
      J=I+INT
      IF(X(N,I).GE.X(N,J))GOTO 1200
      DO 1060 K=1,KU
      T(K)=X(K,J)
 1060 CONTINUE
      DO 1061 K=1,2
1061  S(K)=IX(K,J)
1080  DO 1100 K=1,KU
      X(K,J)=X(K,I)
 1100 CONTINUE
      DO 1101 K=1,2
1101  IX(K,J)=IX(K,I)
      J=I
      I=I-INT
      IF(I.LE.0)GOTO 1140
C     IF(I)1140,1140,1120
      IF(X(N,I).LT.T(N))GOTO 1080
1140  CONTINUE
      DO 1160 K=1,KU
      X(K,J)=T(K)
 1160 CONTINUE
      DO 1161 K=1,2
1161  IX(K,J)=S(K)
 1200 CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE SORT3(IX,KU,KUSER1,NAT,N,X)
C
C  Sort IX(KU,KUSER) on IX(N,..) On completion IX(N,1) will be
C  the largest value of IX(N,..). X(6,KUSER1) is changed following 
C  IX. Only the forst NAT elements are sorted
C
      DIMENSION IX(KU,KUSER1),X(6,KUSER1),T(6)
      INTEGER S(2)
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NAT)GOTO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NAT-INT
      DO 1200 II=1,IFIN
      I=II
      J=I+INT
      IF(IX(N,I).GE.IX(N,J))GOTO 1200
      DO 1060 K=1,KU
      S(K)=IX(K,J)
 1060 CONTINUE
      DO 1061 K=1,6
1061  T(K)=X(K,J)
1080  DO 1100 K=1,KU
      IX(K,J)=IX(K,I)
1100  CONTINUE
      DO 1101 K=1,6
1101  X(K,J)=X(K,I)
      J=I
      I=I-INT
      IF(I.LE.0)GOTO 1140
C     IF(I)1140,1140,1120
      IF(IX(N,I).LT.S(N))GOTO 1080
1140  CONTINUE
      DO 1160 K=1,KU
      IX(K,J)=S(K)
 1160 CONTINUE
      DO 1161 K=1,6
1161  X(K,J)=T(K)
 1200 CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE SORT4(X,KU,KUSER1,POINT,NAT,ISTART,N)
C
C  Sort X(KU,KUSER) on X(N,..) CREATING POINTERS ARRAY POINT
C  ON COMPLETION X(N,POINT(1)) WILL BE THE LARGEST VALUE OF X(N,..)
C  ONLY ELEMENTS ISTART THROUGH TO NAT ARE SORTED
C
      DIMENSION X(KU,KUSER1)
      INTEGER POINT(NAT)
      DO 1 I=ISTART,NAT
1     POINT(I)=I
      NS=NAT-ISTART+1
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NS)GOTO 1000
      INT=MIN0(NS,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NAT-INT
      DO 1200 II=ISTART,IFIN
      I=II
      J=I+INT
      IF(X(N,POINT(I)).GE.X(N,POINT(J)))GOTO 1200
      K=POINT(J)
1080  POINT(J)=POINT(I)
      J=I
      I=I-INT
      IF(I+1.LE.ISTART)GOTO 1140
C     IF(I-ISTART+1)1140,1140,1120
      IF(X(N,POINT(I)).LT.X(N,K))GOTO1080
1140  POINT(J)=K
1200  CONTINUE
      IF(INT.GT.1)GOTO 1020
C      DO 2 I=1,NS 
C2     POINT(I)=POINT(I)+ISTART-1
      RETURN
      END
      SUBROUTINE SORT5(X,KUSER1,POINT,NAT)
C
C  Sort X(KU,KUSER) on X(N,..) CREATING POINTERS ARRAY POINT
C  ON COMPLETION X(N,POINT(1)) WILL BE THE LARGEST VALUE OF X(N,..)
C  ONLY THE FIRST NAT ELEMENTS ARE SORTED
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER   X(KUSER1)
      INTEGER POINT(NAT)
      DO 1 I=1,NAT
1     POINT(I)=I
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NAT)GOTO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NAT-INT
      DO 1200 II=1,IFIN
      I=II
      J=I+INT
      IF(X(POINT(I)).GE.X(POINT(J)))GOTO 1200
      K=POINT(J)
1080  POINT(J)=POINT(I)
      J=I
      I=I-INT
      IF(I.LE.0)GOTO 1140
C     IF(I)1140,1140,1120
      IF(X(POINT(I)).LT.X(K))GOTO1080
1140  POINT(J)=K
1200  CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE SORT6(X,KU,KUSER1,NAT,N)
      IMPLICIT REAL*4 (A-H,O-Z)
      DIMENSION X(KU,KUSER1),T(6)
      INT=2
1000  INT=INT+INT
      IF(INT.LT.NAT)GOTO 1000
      INT=MIN0(NAT,(3*INT)/4-1)
1020  INT=INT/2
      IFIN=NAT-INT
      DO 1200 II=1,IFIN
      I=II
      J=I+INT
      IF(X(N,I).GE.X(N,J))GOTO 1200
      DO 1060 K=1,KU
      T(K)=X(K,J)
1060  CONTINUE
1080  DO 1100 K=1,KU
      X(K,J)=X(K,I)
1100  CONTINUE
      J=I
      I=I-INT
      IF(I.LE.0)GOTO 1140
C     IF(I)1140,1140,1120
      IF(X(N,I).LT.T(N))GOTO1080
1140  CONTINUE
      DO 1160 K=1,KU
      X(K,J)=T(K)
1160  CONTINUE
1200  CONTINUE
      IF(INT.GT.1)GOTO 1020
      RETURN
      END
      SUBROUTINE SORTF(FAT,NUM,NFAT)
      INTEGER FAT
      DIMENSION HULP(8),IHULP(8),H(8)
      COMMON/PNTR/IPNT(8),JPNT(8),S(8),KPNT(8),NMO(8),KV(8),
     1 LPNT(8),ATOM(8),EXCL(8)
      DIMENSION FAT(NFAT),NUM(NFAT)
      REAL MIN
      DO 1 I=1,NFAT
1     HULP(I)=FAT(I)
      DO 3 J=1,NFAT
      MIN=-1.0E6
      DO 2 I=1,NFAT
      IF(HULP(I).GT.MIN)THEN
      MIN=HULP(I)
      IP=I
      ENDIF
2     CONTINUE
      KPNT(J)=IP
      HULP(IP)=0
3     CONTINUE
      DO 5 K=1,NFAT
      H(K)=FAT(KPNT(K))
5     CONTINUE
      DO 6 I=1,NFAT
      IHULP(I)=NUM(KPNT(I))
6     CONTINUE
      DO 7 K=1,NFAT
      FAT(K)=H(K)
7     CONTINUE
      DO 9 I=1,NFAT
      NMO(I)=NUM(I)
      NUM(I)=IHULP(I)
9     CONTINUE
      RETURN
      END
      SUBROUTINE SPESIN(NR,NBEGIN,NEIND)
      include '../common/../common/unit.f'
      include '../common/../common/comhas.f'
      include '../common/../common/symtry.f'
      include '../common/../common/const.f'
      include '../common/../common/detpar.f'
      include '../common/../common/autpar.f'
      include '../common/../common/pack.f'
      COMMON /PARAM/ CEL(6),Q(6),PDB(3,3),ISCORING
C
C  MULTIPLY E'S BY CED BEFORE STORING
C
      CED=1000.
C
C  INPUTFILE CONTROL PARAMETERS:
C
      LN=10
C
C  LXYZ: OUPUT BEST MODEL SOFAR, END OF TRIAL LXYZ=13
C
      LXYZ=11
C
C  PRINTER OUTPUT:
C
      LO=6
C
C  SCRATCH FILE:
C
      ISCRA=8
C
C  IHITS: THE FILE HITS PREPARED BY THE SYSTEM
C
      IHITS=24
C
C  ITEMP: THE BEST FOM, THE CORESPONDING TRIAL AND CYCLE, SUM SQUARE FOM
C        AND THE AVARAGE OF THE LAST 40 FOMS IN RECORD 1. THE LAST 40
C        FOMS IN RECORD 2
C
      ITEMP=35
      NBITS=32
      LK1=SQRT(2.0**(NBITS-5)/3.0)
      LK2=2*LK1
      LK3=24*LK2
      IP3=256
      IP2=2*IP3
      IP1=IP2*IP2
      IP4=(IP2+1)*IP3

C
C  SET DEFAUTS FOR PARAMETERS THA USED TO BE IN CRUNCH.CDAT 
C  ONLY THOSE THAT ARE NOT AVAILABLE AS KEYWORDS
C
      TITLE='CCP4 version of Crunch'
      NBEGIN=1
      NEIND=20
      ICMAX=400
      NHAS=0
      IHAS=127
      IT=20
      ITEST=0
      IBK=1700
      NRL=0
      ICRI=3
      ICRA=0
      ICRB=1
      NSTR=0
      IELIM=0
      NOTF=1
      IPRMX=0
      IPRIJP=0
C
C  CONTROL TYPE OF FOURIER USED
C  1 Alphagen, 2 Gamma prime, 3 2Fo-Fc (Default)
C
      IFOUR=3
C
C  Card 8
C  Sintheta limit and switch to tell the program
C  whether input coordinates are available
C  (ICOOR<>0)
C
      ISTLM=0
      ICOOR=0
      NOSPC=0
C
C  READ KEYWORDED PARAMETERS          
C
      CALL INSPEC(NBEGIN,NEIND)
      CALL SYMEXP
      CALL ORTH(CEL,ORT)
      SZ=0.0
      SF=0.0
      NFAT=1
C
C  CALCULATE SIGMA(FJ(0)**2)
C
      FT=JZ(1)
      SF=SF+NSYM*JN(1)*FT*FT
      SZ=SZ+NSYM*JN(1)*FT
C
C  Calculate number of atoms in the unit cell
C  NAT/NQV = number of atoms to be located
C
      IREFL=16
      CALL CCPDPN(IREFL,'HKLIN','READONLY','F',0,0)
1111  READ(IREFL,*,END=222)CH
      NREF=NREF+1
      GO TO 1111
222   CONTINUE
      REWIND IREFL
      NAT=0
      NAT=NAT+JN(1)
      NATOM=NAT
      NDIM=MAX(NAT+8,2*NAT)
      NAT=NAT*NQV
C
C  INPUT CARD 2: GENERAL PARAMETERS
C
C  NMX:    ORDER OF THE MATRICES
C
C  INPUT CARD 3: HASHTABLE PARAMETERS
C
C  NHAS:   THE LENGTH OF THE TABLE
C  IHAS:   HASHVALUE
C  IT:     THE NUMBER OF TESTS TO FIND A BETTER VALUE FOR NHAS
C  ITEST:  THE NUMBER OF TESTS MADE BY TESTHAS
C
C  INPUT CARD 4: CONSTRUCTION PARAMETERS METHOD DE GELDER
C
C  IBK:    MAXIMUM DIMENSION OF TOP ROW MATRIX IN OPMATG
C  NRL:    =0: CALCULATED UPPER LIMIT FOR 1/D**2 FOR EXPANDING
C              STRONG REFLECTIONS
C          =N: UPPER LIMIT = N/100 FOR EXPANSION OF STRONG
C              REFLECTIONS
C  ICRI |
C  ICRA |  DEFINE CRITERION IN OPMAT2: |||E|-ICRA|**ICRI-ICRB|
C  ICRB |
C
C  INPUT CARD 5: MORE CONSTRUCTION PARAMETERS AND ONE REFINEMENT ONE
C
C  NSTR:   THE  NSTR STRONGEST REFLEXIONS IN REF ARE CONSIDERED STRONG
C          THESE REFLEXIONS ARE USED TO CONSTRUCT THE TOP ROW OF THE
C          MATRIX
C  NOTF:   >0 : FORBIDDEN REFLECTIONS ARE CONSIDERED USEFUL IN MATRIX
C          0: WE RATE FORBIDDEN REFLECTIONS AS NOT OBSERVED (DEFAULT)
C          RANK REDUCTION BY RECONSTRUCTING THE MATRIX USING THE
C          REQUIRED NUMBER OF EIGENVECTORS (CADZOW SORT OF)
C
C  INPUT CARD 5: OUTPUT PARAMETERS
C
C  IPRMX:  #0: PRINT MATRICES
C  IPRIJP: #0: PRINT RELATIONS BETWEEN MATRIX ELEMENTS
C
C  DEFAULTS CARD 2
C  NMX=2*NAT
C
      IF(NMX.EQ.0)NMX=2.0*NAT+1
      IF((NMX/2)*2.EQ.NMX) THEN
      NMX=NMX+1
      ENDIF
      IF(NMX.LT.41)NMX=41
C
C  DEFAULTS CARD 3
C  NHAS=1.3*NTOT+1,IHAS=127,IT=1,ITEST=0
C
      IF(IT.EQ.0) IT=1
      IF(NHAS.EQ.0) IT=20
      IF(IHAS.EQ.0) IHAS=127
C
C  DEFAULTS CARD 3
C  IBK=SQRT(NR/10000)*100-50,NRL IS CALCULATED IN EXPA2 BY DETER
C  ICRI=2,ICRA=0,ICRB=0
C
      IF(IBK.EQ.0)THEN
      NRR=NR*0.8
      IBK=INT(SQRT(FLOAT(NRR/10000)))*100-100
      ENDIF
      IF(ICRI.EQ.0)ICRI=2
C
C  DEFAULTS CARD 4
C
      IF(NSTR.LT.100)THEN
      NSTR=3*IBK/1000.0+0.5
      NSTR=NSTR*1000
      ENDIF
C
C  DEFAULTS CARD 5
C
C DEFAULTS AUTOFOUR
C
      IF(IFOUR.EQ.0)IFOUR=3
      XM=1.0
C
C  WRITE INPUT PARAMETERS ON OUTPUTFILE
C
      WRITE(LO,55)
55    FORMAT(/,'                    Input specifications')
      WRITE(LO,51)NMX
   51 FORMAT(/,' Order of the matrix used: ',I5,/)
      WRITE(LO,52)NHAS,IHAS,IT,ITEST
   52 FORMAT(' Hashtable constants used in the construction: ',/,4I9,/)
      WRITE(LO,53)IBK,NRL,ICRI,ICRA,ICRB
   53 FORMAT(' Parameters governing the construction',/,
     1'       IBK      NRL     ICRI     ICRA     ICRB',/,' ',8I9)
      WRITE(LO,54)NSTR,IELIM,NOTF
   54 FORMAT(/,'      NSTR    IELIM     NOTF',
     1 /,' ',3I9,/)
      WRITE(LO,58)
   58 FORMAT(' Phase refinement using rank reduction based on matrix',
     1 ' reconstruction',/,' from a number of eigenvectors equal to'
     2 ,' the rank desired')
      WRITE(LO,56)IPRMX,IPRIJP
   56 FORMAT(/,' Print control',//,'     IPRMX   IPRIJP',/,' ',4I9,/)
      Write(LO,59)
   59 FORMAT(' Parameters governing Autofour and general data')
      IF(ICOOR.NE.0)THEN
      WRITE(LO,5)IFOUR,NATOM
    5 FORMAT(/,' Ifour: ',I3,
     1 ' Number of atoms to be found: ',I5,/,
     2 ' Starting models are read in from file',/)
      ELSE
      WRITE(LO,10)IFOUR,NATOM
10    FORMAT(/,' Ifour: ',I3,
     1 ' Number of atoms to be found: ',I5,//,
     2 ' Random starts are generated by the program',/)
      ENDIF
      WRITE(LO,6)CEL
6     FORMAT(/,' Cell-parameters:',//,' A: ',F8.3,1X,'B: ',F8.3,
     1 1X,'C: ',F8.3,1X,'Alpha: ',F7.3,1X,'Beta: ',F7.3,1X,'Gamma: ',
     2 F7.3)
      CALL CRUNCH2_CELL(CEL,Q,V,PDB,1)
C     IF(ISTLM.GT.0)THEN
C     STLIM=ISTLM/10.0         
C     ELSE
C     STLIM=0.4
C     ENDIF
      CALL MAKERS
      RETURN
      END
      SUBROUTINE SYMEXP
C
C  EXPAND TO FULL SPACE GROUP SYMMETRY
C
      IMPLICIT REAL*4 (A-H,O-Z)
      INCLUDE '../common/symtry.f'
      NQV=0
      CALL CENTRE(1,1,MLAT,TL)
C
C  FILL TL(1,XX) WITH 0
C
      GOTO(41,11,11,11,11,21,31),LATT
C
C  A,B,C,I LATTICES
C
   11 CALL CENTRE(2,LATT,MLAT,TL)
      GOTO 41
C
C  F LATTICE
C
   21 CALL CENTRE(2,2,MLAT,TL)
      CALL CENTRE(3,3,MLAT,TL)
      CALL CENTRE(4,4,MLAT,TL)
      GOTO 41
C
C  R LATTICE
C
   31 CALL CENTRE(2,6,MLAT,TL)
      CALL CENTRE(3,7,MLAT,TL)
   41 ICENT=2*ICENT+1
      DO 1000 III=1,ICENT,2
      DO 1000 II=1,MLAT
      DO 1000 I=1,NSYM
      NQV=NQV+1
      ISN=2-III
      DO  100 IIII=1,3
      TX(IIII,NQV)=TS(IIII,I)+TL(IIII,II)
      DO  100 IIIII=1,3
      FS(IIIII,IIII,NQV)=0.
  100 CONTINUE
      DO 1000 IIII=1,3
      DO 1000 IIIII=1,2
      M=IABS(IS(IIIII,IIII,I))
      IF(M.GT.0)FS(M,IIII,NQV)=FLOAT(ISN*ISIGN(1,IS(IIIII,IIII,I)))
 1000 CONTINUE
      ICENT=(ICENT-1)/2
C      DO 1111 I=1,NQV
C      WRITE(6,*)((FS(J,K,I),K=1,3),TX(J,I),J=1,3)
C1111  CONTINUE
      RETURN
      END
      CHARACTER*(*) FUNCTION TRIM(STRING)
      CHARACTER H*15
      CHARACTER*(*) STRING
      CHARACTER A,B
      B=' '
      L=LEN(STRING)
      IBEGIN=0
      H='              '
      DO 1 I=1,L
      A=STRING(I:I)
      IF(IBEGIN.EQ.0)THEN
      IF(A.NE.B)THEN  
      IBEGIN=I
      ENDIF
      ENDIF
1      CONTINUE
      IF(IBEGIN.NE.0)THEN
      I=0
      DO 3 J=IBEGIN,L         
      I=I+1
      IF(I.GT.8)GOTO 99
      H(I:I)=STRING(J:J)
3      CONTINUE
99    TRIM=H
      ELSE
      TRIM=' '
      ENDIF
      RETURN
      END
      SUBROUTINE UNPACK(INDEX,IH,IK,IL)
      IMPLICIT REAL*4 (A-H,O-Z)
      INCLUDE '../common/pack.f'
      IH=INDEX/IP1
      IS=INDEX-IP1*IH
      IK=IS/IP2-IP3
      IL=IS-IP2*(IK+IP3)-IP3
      RETURN
      END
      SUBROUTINE UNPK1(HKL,H,K,L)
      IMPLICIT REAL*4 (A-H,O-Z)
      INTEGER HKL,H
      IND=HKL
C
C A TERRIBLE MISTAKE!!!!!! 256**2=65536 AND NOT 65336
C IN OLDER VERSIONS: H=IND/65336
C
      H=IND/65536
      IND=IND-65536*H
      K=IND/256
      L=IND-256*K-128
      K=K-128
      H=H-128
      RETURN
      END
      CHARACTER*80 FUNCTION UPPER(STRING)
      CHARACTER*100 UP,DOWN
      CHARACTER*(*) STRING
      CHARACTER*80 ONDER
      CHARACTER A
      UP  ='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
      DOWN='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
      ONDER=STRING
      LENGTE=LEN(STRING)
      DO 1 I=1,LENGTE
      A=ONDER(I:I)
      DO 2 J=1,26
      IF(A.EQ.DOWN(J:J))THEN
      A=UP(J:J)
      GOTO 3
      ENDIF
2     CONTINUE
3     ONDER(I:I)=A
1     CONTINUE
      UPPER=ONDER
      RETURN
      END
      REAL FUNCTION VAL(ST,IBE,LES)
      CHARACTER*(*) ST
      CHARACTER A
      LOGICAL*4 SE,SM,EP,RE
      INTEGER*4 CH,IEX,LES,I,MAN,IREST,JEX
C     INIT
      SM=.FALSE.
      EP=.FALSE.
      SE=.FALSE.
      RE=.FALSE.
      IEX=0
      JEX=1
      EX=1.0D0
      MAN=0
      IREST=0
      I=IBE-1
 10   I=I+1
      A=ST(I:I)
      CH=ICHAR(A)
      IF((CH.EQ.43).OR.(CH.EQ.45)) THEN
      IF(.NOT.EP)THEN
C-----SIGN MANTISSE
        IF(MAN.EQ.0.AND.CH.EQ.45) SM=.TRUE.           ! +
        IF(MAN.EQ.0.AND.CH.EQ.43) SM=.FALSE.          ! -
      ELSE
C-----SIGN EXPONENT
                IF(CH.EQ.45) SE=.TRUE.
                IF(CH.EQ.43) SE=.FALSE.
      ENDIF
      ELSEIF(CH.EQ.46)THEN
      RE=.TRUE.
      ELSEIF((CH.GE.48).AND.(CH.LE.57)) THEN     !0< CH < 9
      IF(.NOT.EP)THEN
      IF(.NOT.RE)THEN
C-----MANTISSE
      MAN=MAN*10+CH-48
      ELSE
C-----MANTISSE ACHTER DE KOMMA
      JEX=JEX*10
      IREST=IREST*10+CH-48
      ENDIF
      ELSE
C-----EXPONENT
      IEX=IEX*10+CH-48
      ENDIF
      ELSEIF(CH.EQ.69.OR.CH.EQ.101.OR.CH.EQ.68.OR.CH.EQ.100)THEN !D,E,D,E
C     EXPONENT
      EP=.TRUE.
      ENDIF
      IF(I.LT.IBE+LES)GOTO 10
      TISSE=MAN+IREST/FLOAT(JEX)
      IF(EP) THEN
        EX=10.0**IEX
        IF (SE) EX=1.0/EX
      ENDIF
      TISSE=TISSE*EX
      IF(SM)TISSE=-TISSE
      VAL=TISSE
      RETURN
      END
      SUBROUTINE VULAT(ATPR,ITPR,XYZ,NPIEK)
      DIMENSION ATPR(6,NDIM),ITPR(2,NDIM),XYZ(4,NPIEK),X(3)
      INCLUDE '../common/unit.f'
      INCLUDE '../common/symtry.f'
      INCLUDE '../common/const.f'
C      DO 12345 J=1,NPIEK
C      WRITE(LO,*)'VULAT: Coordinaten2:',(XYZ(I,J),I=1,4)
C12345 Continue
      J=0
      I=0
1     I=I+1
      J=J+1
      IF(J.GT.NPIEK)RETURN
      IF(I.GT.NATOM)RETURN
C     WRITE(LO,*)'VULAT: Coordinaten2:',(XYZ(II,J),II=1,4),J
      DO 2 K=1,3
      ATPR(K,I)=XYZ(K,J)
      X(K)=XYZ(K,J)
2     CONTINUE
      CALL SMLT(X,BGR)
      IF(BGR.LT.0.5)STOP
C     IF(NOSPC.NE.0.OR.BGR.LT.1.01.OR.NATOM.EQ.1)THEN
      IF(NOSPC.NE.0.OR.BGR.LT.1.01)THEN
      ATPR(4,I)=1.0/BGR
      ATPR(6,I)=1.0
      ITPR(1,I)=1 
      ITPR(2,I)=XYZ(4,J)
      ELSE
      I=I-1
      ENDIF
      IF(I.GT.0)THEN
C     WRITE(LO,*)'VULAT: Coordinaten1:',(ATPR(II,I),II=1,3),I
      ENDIF
      GOTO 1  
      END
