C
C     DM density modification program
C     Copyright (C) 1994-2004 Kevin Cowtan
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C     DMHARVEST FILE.
C     CREATED BY PRYANK PATEL
C     LAST UPDATED 27-04-2004
      SUBROUTINE DMHARVEST(CELL,rowsize)
C
C     WRITING INFORMATION INTO A HARVESTING FILE FOR DEPOSITION:
C     - CHECK IF HARVEST KEYWORD IS GIVEN (SHOULD PROBABLY BE IMPLEMENTED IN DMMAIN.F)
C     - IF NOHARVEST, SET PROJECT AND DATASET NAMES TO ' '
C     - IF HARVESTHOME NOT SET, SET TO $HOME
C     - CHECK $HARVESTHOME/DepositFiles DIRECTORY EXISTS, PERMISSIONS, AND PROJECT SUBDIRECTORY AND PERMISSIONS
C     - CREATE FILENAME FOR HARVEST FILE: <PROJECTNAME>.dm
C     - OPEN FILE, AND WRITE INFORMATION
C
C
      INCLUDE 'dmharvest.fh'
      real cell(6)

      CALL CCP4_VERSION(VERSION)
      VERSION = 'CCP4_' // VERSION(1:lenstr(VERSION))

      call hinitialise('CCP4','dm',version,projectname,datasetname,
     +     usecwd,private,
     +     ivalnd,valnd,rowsize)

      CALL HSOFTWARE('Density Modification','Kevin Cowtan',
     +     'ccp4@ccp4.ac.uk',
     +     'An automated procedure for density modification')

      CALL HCELL(CELL)
      
      END



      SUBROUTINE DMWRITESTATS()

      implicit none
      INCLUDE 'dmharvest.fh'

      if (noharvest) then
         write(*,*)'NOHARVEST KEYWORD USED'
      else
         
c         do 10 a=1,Hnres
         call Hpdbx_phasing_DM_shell(hrres,hrefls,hsfomn,
     +        hsphicn,hnres,Hmaxbin)

         call hclose()

      endif

      RETURN
      END


