C
C     DM density modification program
C     Copyright (C) 1994-2004 Kevin Cowtan
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c......................................................................
c
c DM - generic density modification program
c
C     See the conditions in the CCP4 manual for a copyright statement.
C
C ADDENDUM
C    If any local or global legislation renders the 'No Warranty'
C    clause illegal or reduces the scope of its content and protection
C    for author(s) in any way, then this whole license shall be null
C    and void, i.e. you may not copy, install any software provided
C    under this license, and any such action will be a breach of
C    the author's copyright.
c
c ......................................................................
c
      program dmprog
      include 'dmheader.fh'
c Please note: this main program simply calculates how much memory the
c program requires, and then calls CCPALC to allocate the storage
c needed by the rest of the program, which is run via DMMAIN.
      integer sizes(9)
      character*1 types(9)
      external dmmain
      data types /3*'R',6*'I'/

cj--
c
c **************** THIS IS THE VERSION MODIFIED BY JAMES *****************
c
cj--

c calculate required array sizes
      call initialise()
      call mallocate(sizes)
c now allocate memory
      call ccpalc(dmmain,9,types,sizes)
      call ccperr(0,' DM - normal termination ')
      end
c
c ----------------------------------------------------------------------
c
      subroutine dmmain(nla,hkls,nlb,rhomap,nlc,rhomod,
     +  nld,l1,nle,l2,nlf,l3,nlg,l4,nlk,solmsk,nll,ncsmsk)
      include 'dmheader.fh'
      include 'io.fh'
      include 'cycl.fh'
      include 'mode.fh'
      include 'params.fh'
      include 'hkllab.fh'
      include 'hkldata.fh'
c DMMAIN - do the main phase extension loop
c
      integer nla,nlb,nlc,nld,nle,nlf,nlg,nlh,nli,nlj,nlk,nll
      real hkls(*),rhomap(*),rhomod(*)
      integer solmsk(*),ncsmsk(*)
      real l1(*),l2(*),l3(*),l4(*)
c
      integer icfr,lfa,lfb,lda,ldb,lfa1,lfb1,lfa2,lfb2
      real reseff,realfree,rave,rstd,rdum
      logical converged,lprint,assigned(nhklc)
      logical newncsmat,newsolmsk,newncsmsk,freestat,freefin
      character*4 t1,t2

      external freestat
c specific column numbers used from this routine
      parameter
     +  (lfa=20,lfb=21,lda=22,ldb=23,lfa1=16,lfb1=17,lfa2=18,lfb2=19)
      data assigned /8*.true.,17*.false./
c
c read in the reflection file and scale
      call ccp4h_header('Data Checking','datachk',3)
      call hklin(hkls,assigned)
      call ccp4h_header('Data Scaling','datascl',3)
      call calcscale(hkls,assigned)
      call readhist()
c initial ncs mask
      if (mncs.eq.1) then
      call ccp4h_header('Initial Averaging Mask','ncsmsk',3)
       if (inputncsmask) then
        call ncsmaskin(ncsmsk,rhomap)
       else
        call ncsautomask(hkls,lfa,lfb,rhomap,rhomod,solmsk,ncsmsk)
       endif
      endif
c initial solvent mask
      call ccp4h_header('Initial Solvent Mask','solmsk',3)
      if (inputsolmask) then
       call solmskin(solmsk,rhomap)
      else
       call wangmask(hkls,lfa,lfb,rhomod,solmsk,.true.)
      endif
c make histograms and terminate?
      call histout(hkls,lfa,lfb,rhomap,solmsk)
c set up for phase extension
      call phextsetup(hkls)
      realfree=1.0e6
c PHASE REFINEMENT LOOP:
c we can do each step several times to cross-validate the sigmaq-estimates
c set up a set of excluded refections
 100   call ccp4h_rule()
       call ccp4h_pre_end()
       write (t1,'(i4.4)')icycl
       write (t2,'(i4)')icycl
       call ccp4h_header('Cycle '//t2,'cyc'//t1,3)
       write (t1,'(i4.4)')icycl+1
       call ccp4h_link('Next cycle','#cyc'//t1)
       call ccp4h_link('Contents','#toc')
       call ccp4h_pre_beg()
c
       call phextstep(hkls,.true.,reseff)
       newncsmat=.false.
       newncsmsk=.false.
       newsolmsk=.false.
       if (ncref.gt.0)    newncsmat=
     +   (mncs.eq.1.and.mod(icycl-1,ncref).eq.0)
       if (ncncsmsk.gt.0) newncsmsk=
     +   (mncs.eq.1.and.icycl.gt.1.and.mod(icycl-1,ncncsmsk).eq.0)
       if (ncsolmsk.gt.0) newsolmsk=
     +   (icycl.gt.1.and.mod(icycl-1,ncsolmsk).eq.0)
       newsolmsk=newsolmsk.or.newncsmsk
c optionally remake averaging mask occasionally, refine averaging ops
       if (mncs.eq.1) then
        if (newncsmsk) call ncsautomask
     +    (hkls,lfa2,lfb2,rhomap,rhomod,solmsk,ncsmsk)
        if (newncsmat) call ncsref(hkls,lfa2,lfb2,rhomod,ncsmsk)
       endif
c optionally remake solvent mask occasionally
       if (newsolmsk) then
        if (inputsolmask.and.ncsolmsk.eq.0) then
         call solmskin(solmsk,rhomap)
        else
         call wangmask(hkls,lfa2,lfb2,rhomod,solmsk,.true.)
        endif
       endif
c make free spheres
       if (mreal.gt.0) then
        call getfreemask(solmsk,rhomod)
        call wfo(hkls,lfa2,lfb2)
        call hklfpab(hkls,lfa2,lfb2)
        call fftlistmap(rhomap,hkls,lfa2,lfb2)
        freefin=freestat(rhomap,rhomod,solmsk,rmax,realfree)
        if (ncycl.lt.0.and.freefin) goto 200
       endif
       lprint=.true.
c COMBINE FREE ------------------------------
       if (mcomb.eq.1) then
c CROSS VALIDATION LOOP:
        call setxfr(hkls)
        do 110 icfr=1,ncfr
         write (t1,'(i4)')icfr
         write (t2,'(i4)')ncfr
         call ccp4h_header('Cross validation step'//t1//' of'//t2,' ',3)
         lprint=(icfr.eq.1)
         call phextstep(hkls,.true.,reseff)
         call setfreer(hkls,icfr,ncfr,icycl)
c generate wFo's
         call wfo(hkls,lfa,lfb)
c generate A,B list and do fft
         call hklfpab(hkls,lfa,lfb)
         call fftlistmap(rhomap,hkls,lfa,lfb)
c do density modification
         if (lprint) call rhostats(rhomap,solmsk)
c SAYRE + DM
         call dms
     +     (rhomap,rhomod,l1,l2,l3,l4,solmsk,ncsmsk,hkls,reseff,lprint)
         if (lprint) call rhostats(rhomod,solmsk)
c do inv fft and generate F,PHI list
         call invfftmaplist(rhomod,hkls,lfa1,lfb1)
         call hklabfp(hkls,lfa1,lfb1)
c combine initial and modified data
         call accxfr(hkls,lfa1,lfb1)
 110    continue
        call combxfr(hkls,lfa1,lfb1)
c COMBINE OMIT ------------------------------
       else if (mcomb.eq.2) then
        call setxfr(hkls)
        ncfr=numbfree+1
        do 111 icfr=1,ncfr
         write (lpt,8020)icfr,ncfr
         lprint=(icfr.eq.1)
         call phextstep(hkls,.true.,reseff)
         call setfreer(hkls,icfr,ncfr,icycl)
         call wfo(hkls,lfa,lfb)
         call hklfpab(hkls,lfa,lfb)
         call fftlistmap(rhomap,hkls,lfa,lfb)
         if (lprint) call rhostats(rhomap,solmsk)
         call dms
     +     (rhomap,rhomod,l1,l2,l3,l4,solmsk,ncsmsk,hkls,reseff,lprint)
         if (lprint) call rhostats(rhomod,solmsk)
         call invfftmaplist(rhomod,hkls,lfa1,lfb1)
         call hklabfp(hkls,lfa1,lfb1)
         call accxfr(hkls,lfa1,lfb1)
 111    continue
        call combsa(hkls,lffree,lpfree)
c COMBINE SIGMAA or EMPIRICAL GAMMA or THEORETICAL GAMMA -----------
       else if (mcomb.eq.3.or.mcomb.eq.4.or.mcomb.eq.5) then
        call wfo(hkls,lfa,lfb)
        call hklfpab(hkls,lfa,lfb)
        call fftlistmap(rhomap,hkls,lfa,lfb)
        if (lprint) call rhostats(rhomap,solmsk)
        call dms
     +    (rhomap,rhomod,l1,l2,l3,l4,solmsk,ncsmsk,hkls,reseff,lprint)
        if (lprint) call rhostats(rhomod,solmsk)
        if (mcomb.eq.5) then
         call fftlistmap(rhomap,hkls,lfa,lfb)
         call empgam(rhomap,rhomod,gammac)
        endif
        call invfftmaplist(rhomod,hkls,lfa1,lfb1)
        call subgam(hkls,lfa,lfb,lfa1,lfb1,gammac)
        call hklabfp(hkls,lfa1,lfb1)
        call hklabfp(hkls,lfa,lfb)
        call combsa(hkls,lfa,lfb)
c PERTURBATION GAMMA--------------------------
       else if (mcomb.eq.6.or.mcomb.eq.7) then
        call setdelta(hkls,lda,ldb,0.10)
        call hklfpab(hkls,lda,ldb)
        call wfo(hkls,lfa,lfb)
        call hklfpab(hkls,lfa,lfb)
c do density modification
        call fftlistmap(rhomap,hkls,lfa,lfb)
        call rhostats(rhomap,solmsk)
        call dms
     +    (rhomap,rhomod,l1,l2,l3,l4,solmsk,ncsmsk,hkls,reseff,lprint)
        call rhostats(rhomod,solmsk)
        call invfftmaplist(rhomod,hkls,lfa1,lfb1)
c add perturbation
        call wfo(hkls,lfa,lfb)
        call hklfpab(hkls,lfa,lfb)
        call hkladd(hkls,lfa,lda,lfa,1.0,1.0)
        call hkladd(hkls,lfb,ldb,lfb,1.0,1.0)
c do density modification
        call fftlistmap(rhomap,hkls,lfa,lfb)
        call rhostats(rhomap,solmsk)
        call dms
     +    (rhomap,rhomod,l1,l2,l3,l4,solmsk,ncsmsk,hkls,reseff,lprint)
        call invfftmaplist(rhomod,hkls,lfa2,lfb2)
c work out adaptive gamma
        call wfo(hkls,lfa,lfb)
        call hklfpab(hkls,lfa,lfb)
        if (mcomb.eq.6)
     +    call rgamma(hkls,lfa,lfb,lda,ldb,lfa1,lfb1,lfa2,lfb2,.false.)
        if (mcomb.eq.7)
     +    call rgamma(hkls,lfa,lfb,lda,ldb,lfa1,lfb1,lfa2,lfb2,.true.)
        call hklabfp(hkls,lfa,lfb)
        call combsa(hkls,lfa,lfb)
       endif
c --------------------------------------------
c end phase refinement loop
      if (.not.converged()) goto 100
c write out mask
 200  call ccp4h_header('Data output','dataout',3)
      if (outputsolmask) call solmskout(solmsk)
      if (outputncsmask) call ncsmskout(ncsmsk)
c write out final stats
      call logout()
c write out the results
      call hklout(hkls)

cj--
c
c write out file *.vu for XtalView
      if(mncs.eq.1)call vuout()
c
cj--

c done
      call ccp4h_pre_end()
c pp54: dmharvest
      call dmwritestats()
      return

 8020 format(/,'<h4>Cross validation step ',i4,' of ',i4,'</h4>')
      end
c
c ----------------------------------------------------------------------
c
      subroutine initialise()
      include 'dmheader.fh'
      include 'io.fh'
c initialise ccp4, read in the data, set up all the constants which will
c be needed later.
c
      integer idum,lunsti,lunsto,ccpnun
      external lunsti,lunsto,ccpnun
c
      idum=0
      lpt=lunsto(idum)
      lcd=lunsti(idum)
      latom=ccpnun()
      lhist=ccpnun()+1
      lmsks=ccpnun()+2
c
      call ccpfyp()
      call ccp4h_init()
ckev      call ccp4h_header('dm 2.0.5','dm',1)
cj--
c
      call ccp4h_header('dm 2.1','dm',1)
c
cj--

ckev      call ccp4h_pre_beg()
      call ccpvrs(lpt,'dm','26/11/98')
      call ccp4h_pre_end()
      write (lpt,11)
 11   format (/,
     +  '<a href="http://www.yorvic.york.ac.uk/~cowtan/dm/refs.html">',
     +  'dm reference:</a>',/,
     +  '<blockquote>',/,'K. Cowtan (1994),',/,2x,
     +  'dm: An automated procedure for phase ',
     +  'improvement by density modification.',/,2x,
     +  'Joint CCP4 and ESF-EACBM Newsletter on ',
     +  'Protein Crystallography, 31, p34-38.',/,'</blockquote><p>',/)
      call ccp4h_toc_beg()
      call ccp4h_toc_ent('Command input','#command')
      call ccp4h_toc_ent('Comments','#comments')
      call ccp4h_toc_ent('MTZ input','#mtzin')
      call ccp4h_toc_ent('Data Checking','#datachk')
      call ccp4h_toc_ent('Data Scaling','#datascl')
      call ccp4h_toc_ent('Solvent Mask','#solmsk')
      call ccp4h_toc_ent('First Cycle','#cyc0001')
      call ccp4h_toc_ent('Output','#dataout')
      call ccp4h_toc_end()
c
      call mtzini()
      call rcards()
      call inicalc()
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine mallocate(sizes)
      include 'dmheader.fh'
      include 'hkldata.fh'
      include 'uvwdata.fh'
      include 'mode.fh'
c mallocate - make a list of sizes for arrays which will form the
c arrays in the main density modification programme.
c
      integer sizes(9)
c
      integer hklsize,syrsize
      integer nus, nvs, nws
c
c calculate required array sizes
      hklsize=(nrflc+1)*nhklc
      syrsize=256
      if (msayr.ne.0.or.mskl.ne.0) syrsize=uvwsize
c
c maptree.f: itskel() needs a big map
      nus=0
      nvs=0
      nws=0
      call gridres(0.67*rmax,nus,nvs,nws)
c

c allocate one reflection array
      sizes(1)=hklsize
c allocate map arrays
      sizes(2)=max(uvwsize,msksize)
      sizes(3)=max(uvwsize,nus*nvs*nws)
      sizes(4)=syrsize
      sizes(5)=syrsize
      sizes(6)=syrsize
      sizes(7)=syrsize
c set the masks
      sizes(8)=uvwsize
      sizes(9)=ncssize
c all done
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine rcards()
      include 'dmheader.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'ncssym.fh'
      include 'params.fh'
      include 'scaleb.fh'
      include 'cycl.fh'
      include 'mode.fh'
      include 'hkldata.fh'
      include 'mtzdata.fh'
      include 'uvwdata.fh'
      include 'dmharvest.fh'
c RCARDS - read in input cards
c
      external lenstr
      integer i,j,k,l,iout,lenstr,pnamelen,dnamelen
      integer iverb,mtzin,iprint,ifail,iappnd,idom,incs,nsets
      real resinit
c
      integer jpoint(mtzcol),nlprgi, csetid(mtzcol),isetid(mtzset)
      real datcell(6,mtzset),datwave(mtzset)
      real alpha,beta,gamma,omega,phi,kappa,symmat(4,4)
      character ctprgi(mtzcol)*1,lsprgi(mtzcol)*30
      character ctprgo(mtzcol)*1,lsprgo(mtzcol)*30
      character*64 pname(mtzset),xname(mtzset),dname(mtzset)
      character*64 xname_out(20),dname_out(20)
      character namspg*10,nampg*10,namlau*10,title*80,
     +          history(1)*80,modes*40,ltype*1,labo*240,line*240
      logical lsolv,lhm1d,lsayr,lncsa,lskel,lmult,
     +        lsall,lsmag,lsres,lsfom,lsaut,
     +        laver,lrefi,leule,lpola,ltran,lomat,
     +        lcyca,lcmbs,lcmbg,lcmbe,lcmbp,lcmbr,lcmbo,lcmbf,lncmb,
     +        lscln,lscls,lovlp,cont,linvm,lnohm,lreal,llabo
c

c
      data namspg,nampg,namlau/3*'          '/
c
c input data
      data nlprgi,lsprgi,ctprgi,jpoint/17,
     +  'H','K','L','FP','SIGFP','PHIO','FOMO','HLA','HLB','HLC','HLD',
     +  'FDM','PHIDM','FOMDM','FCAL','PHICAL','FREE',483*' ',
     +  'H','H','H', 'F',    'Q',   'P',   'W',  'A',  'A',  'A',  'A',
     +  'F',  'P',    'W',   'F',     'P',   'I',483*' ',
     +   -1, -1, -1,  -1,     -0,    -0,    -0,    0,    0,    0,    0,
     +   0,    0,      0,     0,       0,     0,483*0/
c
c some defaults
CCC      data msolv,mhist,msayr,mncs,mmult,ment,mskl,mwarn/8*0/
CCC      data wmag,wres,wfom,fracinit,resinit/5*0.0/
      data lsolv,lhm1d,lsayr,lncsa,lskel,lmult,lsall,lsmag,lsres,lsfom,
     +     lsaut,lcyca,lcmbs,lcmbg,lcmbe,lcmbp,lcmbr,lcmbo,lcmbf,lncmb,
     +     lscln,lscls,lovlp,linvm,lnohm,lreal,llabo/27*.false./
      data reshist/50*-1/
c
      call ccp4h_header('Command Input','command',2)
      call ccp4h_pre_beg()
c initialise the variables
      do 910 l=1,maxdom
      do 910 k=1,maxncs
      do 910 j=1,4
      do 910 i=1,4
       rsymncs(i,j,k,l)=0.0
       if (i.eq.j) rsymncs(i,j,k,l)=1.0
 910  continue
      do 915 k=1,maxdom
       nncsym(k)=0
       refdr(k)  =-1.0
       refdphi(k)=2.5
 915  continue
      do 920 j=1,3
       ncslim(1,j)=-1000.0
       ncslim(2,j)=-1000.0
 920  continue
      do j=1,6
        cell(j)=0.0
      enddo
c
      msolv = 0
      mhist = 1
      msayr = 0
      mncs  = 0
      mmult = 0
      mskl  = 0
      mreal = 0
      wmag = 0.0
      wres = 0.0
      wfom = 0.0
      fracinit = 0.0
      resinit = 0.0
c
      mtzin=1
      mcomb=6
      numbfree=20
      rmin=0.0
      rmax=0.0
      scale=0.0
      bfac=0.0
      solc=-1.0
      scmask=-1.0
      pcmask=-1.0
      aveprt=0.43
      avesol=0.32
      wrstr=0.0
      wangrd=-2.0
      wangmd=131
      wngmin=0.32
      wngmax=2.00
      ncycl=-1
      ncref=3
      ncskl=3
      ncfr=1
      ncncsmsk=0
      ncsolmsk=1
      ncstep=3
      ncsmer=0.0

cj--
c
      ncscomm=0
c
cj--
      nu = 0
      nv = 0
      nw = 0

      ncsbf=20.0
      ncssz=1.0
      ljoin=6.0
      lendp=6.0
      sklbf=45.0
      flpfac=2.0
      flptrn=0.3
      frpx=-1.0e6
      frsx=-1.0e6
      frpr=4.0
      frsr=4.0
      ovlprm=0
      gammac=0.0
      combwt=1.0
      minhist=0.0
      maxhist=0.0
      iverb=0
      modes=' '
c
      ofdm=10
      ofcdm=10
      ophicdm=10
      ohladm=10
      ohlbdm=10
      ohlcdm=10
      ohlddm=10
c pp54: harvest set to .false. as default; rowsize set to 80; usecwd false; private false;
      projectname=' '
      datasetname=' '
      noharvest = .false.
      rowsize = 80
      usecwd = .false.
      private = .false.
c
      ndomain=1
      idom=1
      incs=1
c
c Parse the user input ----------------------------------------
c
 200  call memoparse(.false.)
c
c get mode line if present, then reset flags for keyword checking...
      call parsekeyarg('MODE',modes)
c Make links to documentation:
      call ccp4h_link_key('MODE    ','dm.html#mode')
      call ccp4h_link_key('GRID    ','dm.html#grid')
      call ccp4h_link_key('SOLCONT ','dm.html#solc')
      call ccp4h_link_key('GRID    ','dm.html#grid')
      call ccp4h_link_key('SKELETON','dm.html#skel')
      call ccp4h_link_key('SCALE   ','dm.html#scale')
      call ccp4h_link_key('NCYCLE  ','dm.html#ncycle')
      call ccp4h_link_key('SCHEME  ','dm.html#scheme')
      call ccp4h_link_key('COMBINE ','dm.html#combine')
      call ccp4h_link_key('REALFREE','dm.html#realfree')
      call ccp4h_link_key('NCSMASK ','dm.html#ncsmask')
      call ccp4h_link_key('SOLMASK ','dm.html#solmask')
      call ccp4h_link_key('AVERAGE ','dm.html#average')
      call ccp4h_link_key('ROTATION','dm.html#average')
      call ccp4h_link_key('TRANSLAT','dm.html#average')
      call ccp4h_link_key('RESOLUTI','dm.html#resolution')
      call ccp4h_link_key('LABIN   ','dm.html#labin')
      call ccp4h_link_key('LABOUT  ','dm.html#labout')
      call ccp4h_link_key('TITLE   ','dm.html#title')
c flag all keywords unrecognized
      call parsefail()
c set flags and check for keywords...
      laver=.false.
      lrefi=.false.
      leule=.false.
      lpola=.false.
      ltran=.false.
      lomat=.false.
      llabo=.false.
      call parsesubkey('AVER','    ',laver)
      call parsesubkey('TRAN','    ',ltran)
      call parsesubkey('OMAT','    ',lomat)
      call parsesubkey('LABO','    ',llabo)
c
c MODE
      call parsesubkey('MODE','SOLV',lsolv)
      call parsesubkey('MODE','HIST',lhm1d)
      call parsesubkey('MODE','AVER',lncsa)
      call parsesubkey('MODE','SKEL',lskel)
      call parsesubkey('MODE','SAYR',lsayr)
      call parsesubkey('MODE','MULT',lmult)
      call parsesubkey('MODE','NOHI',lnohm)
c SOLC
      call parsesubreal('SOLC','    ',1,.true.,solc)
      call parsesubreal('SOLC','MEAN',1,.true.,avesol)
      call parsesubreal('SOLC','MEAN',2,.true.,aveprt)
c GRID
      call parsesubint ('GRID','    ',1,.true.,nu)
      call parsesubint ('GRID','    ',2,.true.,nv)
      call parsesubint ('GRID','    ',3,.true.,nw)
c SKEL
      call parsesubreal('SKEL','LENG',1,.true.,ljoin)
      call parsesubreal('SKEL','LENG',2,.true.,lendp)
      call parsesubreal('SKEL','BFAC',1,.true.,sklbf)
      call parsesubint ('SKEL','EVER',1,.true.,ncskl)
c SCAL
      call parsesubkey ('SCAL','NATU',lscln)
      call parsesubkey ('SCAL','SHAR',lscls)
      call parsesubreal('SCAL','    ',1,.false.,scale)
      call parsesubreal('SCAL','    ',2,.false.,bfac)
c NCYCLE
      call parsesubint ('NCYC','    ',1,.false.,ncycl)
      call parsesubkey ('NCYC','AUTO',lcyca)
c SCHEME
      call parsesubkey ('SCHE','AUTO',lsaut)
      call parsesubkey ('SCHE','ALL',lsall)
      call parsesubkey ('SCHE','MAG',lsmag)
      call parsesubkey ('SCHE','FOM',lsfom)
      call parsesubkey ('SCHE','RES',lsres)
      call parsesubreal('SCHE','FRAC',1,.true.,fracinit)
      call parsesubreal('SCHE','FROM',1,.true.,resinit)
c COMBINE
      call parsesubkey ('COMB','SIGM',lcmbs)
      call parsesubkey ('COMB','GAMM',lcmbg)
      call parsesubkey ('COMB','EMPI',lcmbe)
      call parsesubkey ('COMB','PERT',lcmbp)
      call parsesubkey ('COMB','RPER',lcmbr)
      call parsesubkey ('COMB','OMIT',lcmbo)
      call parsesubkey ('COMB','FREE',lcmbf)
      call parsesubkey ('COMB','NOCO',lncmb)
      call parsesubint ('COMB','FREE',1,.false.,ncfr )
      call parsesubint ('COMB','SETS',1,.true.,numbfree)
      call parsesubreal('COMB','REST',1,.true.,wrstr)
      call parsesubreal('COMB','GAMM',1,.true.,gammac)
      call parsesubreal('COMB','WEIG',1,.true.,combwt)
c REAL
      call parsesubkey ('REAL','    ',lreal)
      call parsesubreal('REAL','PROT',1,.true.,frpx)
      call parsesubreal('REAL','PROT',2,.true.,frpy)
      call parsesubreal('REAL','PROT',3,.true.,frpz)
      call parsesubreal('REAL','PROT',4,.true.,frpr)
      call parsesubreal('REAL','SOLV',1,.true.,frsx)
      call parsesubreal('REAL','SOLV',2,.true.,frsy)
      call parsesubreal('REAL','SOLV',3,.true.,frsz)
      call parsesubreal('REAL','SOLV',4,.true.,frsr)
c NCSMASK
      call parsesubreal('NCSM','NMER',1,.true.,ncsmer)
      call parsesubreal('NCSM','BFAC',1,.true.,ncsbf)
      call parsesubreal('NCSM','SIZE',1,.true.,ncssz)
      call parsesubreal('NCSM','ALIM',1,.true.,ncslim(1,1))
      call parsesubreal('NCSM','ALIM',2,.true.,ncslim(2,1))
      call parsesubreal('NCSM','BLIM',1,.true.,ncslim(1,2))
      call parsesubreal('NCSM','BLIM',2,.true.,ncslim(2,2))
      call parsesubreal('NCSM','CLIM',1,.true.,ncslim(1,3))
      call parsesubreal('NCSM','CLIM',2,.true.,ncslim(2,3))
      call parsesubint ('NCSM','STEP',1,.true.,ncstep)
      call parsesubint ('NCSM','UPDA',1,.true.,ncncsmsk)
      call parsesubkey ('NCSM','INVE',linvm)
      call parsesubkey ('NCSM','OVER',lovlp)
c SOLMASK
      call parsesubreal('SOLM','FRAC',1,.true.,scmask)
      call parsesubreal('SOLM','FRAC',2,.true.,pcmask)
      call parsesubreal('SOLM','RADI',1,.true.,wangrd)
      call parsesubint ('SOLM','RADI',2,.false.,wangmd)
      call parsesubreal('SOLM','LIMI',1,.true.,wngmin)
      call parsesubreal('SOLM','LIMI',2,.true.,wngmax)
      call parsesubint ('SOLM','UPDA',1,.true.,ncsolmsk)
c AVER
      call parsesubint ('AVER','DOMA',1,.true.,idom)
      call parsesubint ('AVER','EVER',1,.true.,ncref)
      call parsesubkey ('AVER','REFI',lrefi)
      call parsesubreal('AVER','STEP',1,.true.,refdr  (ndomain))
      call parsesubreal('AVER','STEP',2,.true.,refdphi(ndomain))
c ROTA
      call parsesubkey ('ROTA','EULE',leule)
      call parsesubreal('ROTA','EULE',1,.true.,alpha)
      call parsesubreal('ROTA','EULE',2,.true.,beta)
      call parsesubreal('ROTA','EULE',3,.true.,gamma)
      call parsesubkey ('ROTA','POLA',lpola)
      call parsesubreal('ROTA','POLA',1,.true.,omega)
      call parsesubreal('ROTA','POLA',2,.true.,phi)
      call parsesubreal('ROTA','POLA',3,.true.,kappa)
      call parsesubreal('ROTA','MATR',1,.true.,rsymncs(1,1,incs,idom))
      call parsesubreal('ROTA','MATR',2,.true.,rsymncs(1,2,incs,idom))
      call parsesubreal('ROTA','MATR',3,.true.,rsymncs(1,3,incs,idom))
      call parsesubreal('ROTA','MATR',4,.true.,rsymncs(2,1,incs,idom))
      call parsesubreal('ROTA','MATR',5,.true.,rsymncs(2,2,incs,idom))
      call parsesubreal('ROTA','MATR',6,.true.,rsymncs(2,3,incs,idom))
      call parsesubreal('ROTA','MATR',7,.true.,rsymncs(3,1,incs,idom))
      call parsesubreal('ROTA','MATR',8,.true.,rsymncs(3,2,incs,idom))
      call parsesubreal('ROTA','MATR',9,.true.,rsymncs(3,3,incs,idom))
c TRAN
      call parsesubreal('TRAN','    ',1,.true.,rsymncs(1,4,incs,idom))
      call parsesubreal('TRAN','    ',2,.true.,rsymncs(2,4,incs,idom))
      call parsesubreal('TRAN','    ',3,.true.,rsymncs(3,4,incs,idom))
c pp54: HARVESTING KEYWORDS: NOHA,PNAME,DNAME,PRIVATE,USECWD,RSIZE
      call parsekey('NOHA',noharvest)
      call parsekeyarg('PNAM',projectname)
      call parsekeyarg('DNAM',datasetname)
      call parseint('RSIZ',rowsize)
      call parsekey('USEC',usecwd)
      call parsekey('PRIV',private)
c HIST (for generating histograms only)
      call parsesubreal('HIST','    ',1,.true.,minhist)
      call parsesubreal('HIST','    ',2,.true.,maxhist)
      do 215 i=1,50
       call parsesubreal('HIST','RESO',i,.false.,reshist(i))
 215  continue
c RESO
      call parsereso(rmin,rmax,smin,smax)
c LABI
      call parselabin(mtzin,lsprgi,nlprgi)
c LABO
      if (llabo) then
c allocate output labels
       call parsekeyarg('LABO',labo)
       call ccpupc(labo)
       nlprgo=0
       call addopcol('PHIDM','P',lsprgo,ctprgo,nlprgo,ophidm)
       call addopcol('FOMDM','W',lsprgo,ctprgo,nlprgo,ofomdm)
       if (index(labo,'FDM=').gt.0)
     +   call addopcol('FDM','F',lsprgo,ctprgo,nlprgo,ofdm)
       if (index(labo,'FCDM=').gt.0) then
        call addopcol('FCDM','F',lsprgo,ctprgo,nlprgo,ofcdm)
        call addopcol('PHICDM','P',lsprgo,ctprgo,nlprgo,ophicdm)
       endif
       if (index(labo,'HLADM=').gt.0) then
        call addopcol('HLADM','A',lsprgo,ctprgo,nlprgo,ohladm)
        call addopcol('HLBDM','A',lsprgo,ctprgo,nlprgo,ohlbdm)
        call addopcol('HLCDM','A',lsprgo,ctprgo,nlprgo,ohlcdm)
        call addopcol('HLDDM','A',lsprgo,ctprgo,nlprgo,ohlddm)
       endif
       call parselabout(mtzin,lsprgo,nlprgo)
      endif
c TITL
      call parsekeyarg('TITL',title)
c VERB
      call parseint('VERB',iverb)
c
c now deal with any special input keywords...
      if (laver) then
       nncsym(idom)=nncsym(idom)+1
       ndomain=max(ndomain,idom)
       incs=nncsym(idom)
       if (lrefi) refdr(idom)=0.5
      endif
      if (lomat) read (lcd,*)((rsymncs(i,j,incs,idom),i=1,3),j=1,4)
      if (leule) call eulertomatrix
     +  (alpha,beta,gamma,rsymncs(1,1,incs,idom))
      if (lpola) call polartomatrix
     +  (omega,phi ,kappa,rsymncs(1,1,incs,idom))
c
c next keyword
      call parsediagnose(cont)
      if (cont) goto 200
c
c End of input section ----------------------------------------
c

cj--
c
c compute number of overlapping regions in automatic NCS procedure
      if(ncsmer.lt.0.1)then
       call assignmer
       ncscomm=1
c      write(6,*)'NCSMER',ncsmer
      endif
c
cj--

c set up mode and scheme
c .. free:   defaults scheme auto, ncyc 10
c .. omit:   defaults scheme all, ncyc auto
c .. sigmaa: defaults scheme all, ncyc auto
      if (lcmbf) mcomb=1
      if (lcmbo) mcomb=2
      if (lcmbs) mcomb=3
      if (lcmbg) mcomb=4
      if (lcmbe) mcomb=5
      if (lcmbp) mcomb=6
      if (lcmbr) mcomb=7
      if (lncmb) combwt=0.0
      if (lnohm) mhist=0
      if (lsolv) msolv=1
      if (lhm1d) mhist=1
      if (lmult) mmult=1
      if (lsayr) msayr=1
      if (lncsa) mncs =1
      if (lskel) mskl =1
      if (lreal) mreal=1
      if (lsres) wres=1.0
      if (lsmag) wmag=1.0
      if (lsfom) wfom=1.0
      if (lsres.or.lsall) wres=1.0
      if (lsall) fracinit=1.0
      if (lscln) scale=-1.0
      if (lovlp) ovlprm=1
c set combine defaults
      if (mcomb.eq.1) then
       if (ncycl.eq.-1) ncycl=10
      else
       lsall=.not.(lsmag.or.lsres.or.lsfom.or.lsaut)
      endif
      if (lcyca) ncycl=-1
      if (ncycl.lt.0) mreal=1
c check solvent content
      if (solc.le.0.0.or.solc.ge.1.0) goto 9008
c check ncs operators
      do 300 i=1,ndomain
       if (abs(rsymncs(1,2,1,i))+abs(rsymncs(1,3,1,i))+
     +     abs(rsymncs(2,3,1,i))+abs(rsymncs(1,4,1,i))+
     +     abs(rsymncs(2,4,1,i))+abs(rsymncs(3,4,1,i)).gt.0.0001)
     +   goto 9005
       do 290 j=1,nncsym(i)
        if (linvm) then
         call symcpy(rsymncs(1,1,j,i),symmat)
         call invsym(symmat,rsymncs(1,1,j,i))
        endif
 290   continue
 300  continue
c
c MAKE COMMENTS
      call ccp4h_pre_end()
      call ccp4h_header('Comments','comments',2)
      call comment()
      call ccp4h_pre_beg()
c
c
c open mtz input file and perform column assignments
      call ccp4h_header('MTZ Input','mtzin',3)
      iprint=1
      call lropen(mtzin,'HKLIN',iprint,ifail)
      if (ifail.eq.1) goto 9001
      call lrassn(mtzin,lsprgi,nlprgi,jpoint,ctprgi)
      call lrncol(mtzin,ncols)
C  Get data set ID for each column
      NSETS = mtzset
      CALL LRIDX(MTZIN,PNAME,XNAME,DNAME,ISETID,
     +             DATCELL,DATWAVE,NSETS)
      CALL LRCLID(MTZIN,CSETID,NCOLS)
      do i =1,nsets
         if(csetid(jpoint(4)) .eq. isetid(i)) then
            iout = i
            do j=1,6
              cell(j) = datcell(j,iout)
            enddo
c set projectname pname(i) & datasetname dname(i)
            pnamelen = lenstr(projectname)
            dnamelen = lenstr(datasetname)
            if (pnamelen.eq.0) projectname=pname(i)
            if (dnamelen.eq.0) datasetname=dname(i)
         endif
      end do
c pp54: if noharvest keyword set, set proj and dataset name to ' '
      if (noharvest) then
         projectname=' '
         datasetname=' '
      endif
      call dmharvest(cell,rowsize)
c
c open mtz output file
      iappnd = 1
      call lwopen(mtzin,'HKLOUT')
      call lwassn(mtzin,lsprgo,nlprgo,ctprgo,iappnd)
      do i=1,nlprgo
        xname_out(i) = xname(iout)
        dname_out(i) = dname(iout)
      end do
      CALL LWIDASX(MTZIN,NLPRGO,XNAME_OUT,DNAME_OUT,IAPPND)
c add some appropriate history
      history(1)='From DM on '//'xxxxxxxx'//' with '//modes
      call ccpdat(history(1)(12:19))
      call lwhist(mtzin, history, 1)
c
c read cell, symmetry and resolution range
c Cell is selected from datasets, see above. Just use lrcell in case
c no dataset information.
      if (cell(1).eq.0.0) then
        call lrcell(mtzin,cell)
      endif
c
      call lrsymi(mtzin,nsymp,ltype,nspgrp,namspg,nampg)
      call lrsymm(mtzin,nsym,rsym)
      call pgnlau(nampg,nlaue,namlau)
      if (nsym.gt.96) goto 9002
c
      call lrrsol(mtzin,smin,smax)
      if (rmin.ne.0.0) then
        rmax=max(rmax,sqrt(1.0/smax))
      else
        rmin=sqrt(1.0/max(smin,1.0e-6))
        rmax=sqrt(1.0/smax)
      endif

      if (rmax.lt.1.5) then 
        call ccperr
     + (2,' DM histograms etc NOT available for resolutions past 1.5A')
        call ccperr(2,' Proceed with care!')
      endif

c
c set up initial data set
      if (resinit.ne.0.0) fracinit=min((rmax/resinit)**3,1.0)
c
c check for input files
      call ugtenv('SOLIN',line)
      inputsolmask=(line.ne.' ')
      call ugtenv('SOLOUT',line)
      outputsolmask=(line.ne.' ')
      call ugtenv('NCSIN1',line)
      inputncsmask=(line.ne.' ')
      call ugtenv('NCSOUT',line)
      outputncsmask=(line.ne.' ')
c
      if (lncsa.and..not.inputncsmask.and.ncsmer.eq.0.0) goto 9009
c set up pointers for input columns
      ifo   =jpoint(4)
      isfo  =jpoint(5)
      iphio =jpoint(6)
      ifomo =jpoint(7)
      ihla  =jpoint(8)
      ihlb  =jpoint(9)
      ihlc  =jpoint(10)
      ihld  =jpoint(11)
      ifdm  =jpoint(12)
      iphidm=jpoint(13)
      ifomdm=jpoint(14)
      ifpc  =jpoint(15)
      iphipc=jpoint(16)
      ifree =jpoint(17)
c
      return
 9000 call ccperr(1,' (RCARDS) unknown keyword')
 9001 call ccperr(1,' (RCARDS) input .mtz file absent')
 9002 call ccperr(1,' (RCARDS) too many symmetry operators - limit 96')
 9003 call ccperr(1,' (RCARDS) data resolution too low')
 9005 call ccperr(1,' (RCARDS) AVER: enter indentity matrix first')
 9006 call ccperr(1,' (RCARDS) AVER: wrong number of ncs operators')
 9007 call ccperr(1,' (RCARDS) NCYC: maximum ncyc exceeded')
 9008 call ccperr(1,' (RCARDS) SOLC: content missing or out-of-range')
 9009 call ccperr(1,' (RCARDS) NCSMASK NMER: compulsory for automask')
 9010 call ccperr(1,' (RCARDS) Invalid MODE option')
      end
c
      subroutine addopcol(label,ctype,lsprgo,ctprgo,nlprgo,index)
      include 'dmheader.fh'
      character label*(*),ctype*1,lsprgo(*)*30,ctprgo(*)*1
      integer nlprgo,index
      nlprgo=nlprgo+1
      index=nlprgo
      lsprgo(nlprgo)=label
      ctprgo(nlprgo)=ctype
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine inicalc()
      include 'dmheader.fh'
      include 'crystal.fh'
      include 'params.fh'
      include 'mode.fh'
      include 'cycl.fh'
      include 'hkldata.fh'
      include 'hkllim.fh'
      include 'ncssym.fh'
      include 'uvwdata.fh'
      include 'io.fh'
c INICALC - calculate constants required by the program
c Calculates everything possible based on card input and .mtz header
c some things may be re-calculated later, e.g. F(000) if input mask
c
      integer nu0,nv0,nw0,i,numres,masksize,seed
      character name*10
      external numres,masksize
c
c seed random numbers
      seed=54321
      call rseed(seed)
c
c reciprocal space metric and unit cell volume
      call calcmetric()
c
c setup ncs matrices
      call ncsini()
c
c data resolution and limits
      smin=1.0/rmin**2
      smax=1.0/rmax**2
c
      hmax=int(cell(1)/rmax)
      kmax=int(cell(2)/rmax)
      lmax=int(cell(3)/rmax)
      hmin=-hmax
      kmin=-kmax
      lmin=0
c
c work out grid sizes
      call gridres(rmax,nu,nv,nw)
      if (hmax.ge.nu/2.or.kmax.ge.nv/2.or.lmax.ge.nw/2) goto 9000
c ... map
      uvwsize=nu*nv*(nw+2)
c ... ncs mask
      ncssize=1
      if (mncs.eq.1) then
       if (inputncsmask) call ncsmasksize()
       if (.not.inputncsmask.or.ncncsmsk.gt.0) ncssize=max(ncssize,
     +   int(uvwsize*ncssz*5.0*((1.0-solc)*ncsmer/nsym))+1)
      endif
c ... input mask buffer
      msksize=1
      if (inputsolmask) msksize=masksize('SOLIN')
      if (inputncsmask) then
       do 200 i=1,maxdom
        write (name,100)i
 100    format ('NCSIN',i1)
        msksize=max(msksize,masksize(name))
 200   continue
      endif
      msksize=int(msksize/256+1)*256
c
c F(000) term
      f000=vol*(avesol*solc+aveprt*(1.0-solc))
c
c estimate number of reflections in resolution sphere (with room for error)
      nrflc=100+numres(rmax)
      return
 9000 call ccperr(1,' (INICALC) error GRID too small for HKL data')
      end
c
c ----------------------------------------------------------------------
c
      subroutine comment()
      include 'dmheader.fh'
      include 'mode.fh'
      include 'cycl.fh'
      include 'ncssym.fh'
      include 'io.fh'
c NOW COMMENT ON THE USER INPUT:
      character*80 name1,name2
      integer i
c
      write (lpt,'(a)')'Density modifications selected:<ul>'
      if (msolv.gt.0) write (lpt,'(a)')'<li> Solvent flattening'
      if (mhist.gt.0) write (lpt,'(a)')'<li> Histogram matching'
      if (mncs .gt.0) write (lpt,'(a)')'<li> Averaging'
      if (mmult.gt.0) write (lpt,'(a)')'<li> Multi-res modification'
      if (msayr.gt.0) write (lpt,'(a)')'<li> Sayres equation'
      if (mskl .gt.0) write (lpt,'(a)')'<li> Skeletonisation'
      write (lpt,'(a)')'</ul>'
c
      do 110 i=maxdom,1,-1
       write (name1,100)i
 100   format ('NCSIN',i1)
       call ugtenv(name1,name2)
       if (name2.ne.' ') goto 120
 110  continue
 120  if (mncs.gt.0.and.i.gt.ndomain) then
       write (lpt,891)ndomain,i
 891   format (/,'<h3>WARNING: too many averaging masks</h3>',/,
     + /,'You appear to be performing averaging over ',i2,' domain(s)',
     + /,'but you have given ',i2,' averaging masks.<p>')
       write (lpt,892)
 892   format (
     + /,'The number of masks required is equal to the number of',
     + /,'averaging domains, not the order of the NCS. Thus in the',
     + /,'vast majority of cases only a single averaging mask is',
     + /,'required. For example, a 6-fold averaging calculation only',
     + /,'requires a single averaging mask (independent of whether the',
     + /,'NCS is proper or improper, or whether the mask is a monomer',
     + /,'or a multimer).<p>')
       write (lpt,893)
 893   format (
     + /,'CORRECT THIS PROBLEM BEFORE YOU CONTINUE.<p>')       
      endif
c
      if (msolv.gt.0.and.mhist.eq.0) then
       write (lpt,901)
       write (lpt,902)
       write (lpt,903)
       write (lpt,904)
 901   format (/,'<h3>Histogram Matching</h3>',/,
     + /,'You have turned off histogram matching.<p>')
 902   format (
     + /,'Histogram mapping is an established technique from image',
     + /,'processing which will improve the quality of the electron',
     + /,'density in the protein region in a complementary manner',
     + /,'to solvent flattening outside it. In contrast to solvent',
     + /,'flattening however histogram mapping has considerable power',
     + /,'to extend phases to higher resolution.<p>')
 903   format (
     + /,'Some critics have suggested that the reason histogram',
     + /,'mapping works is not that it is an effective modification',
     + /,'of the map, rather that it compensates for deficiencies',
     + /,'in the weighting of phases for recombination. Indeed the',
     + /,'interaction between the real and reciprocal space portions',
     + /,'of the density modification cycle is very complex, and it is',
     + /,'not necessarily obvious why the technique works so well,',
     + /,'nonetheless, it leads to a dramatic improvement in phases',
     + /,'either alone or with solvent flattening, over a whole range',
     + /,'of test structures.<p>')
 904   format (
     + /,'The only case in which histogram mapping is unwise is when',
     + /,'the distribution of atomic types is strongly skewed away',
     + /,'from the protein norm. DNA and RNA have been improved',
     + /,'succesfully, however very small metalloproteins may cause',
     + /,'problems.<p>',/)
      endif
      if (mncs.gt.0) then
       write (lpt,911)
       call ccp4h_link('initial averaging mask', '#ncsmsk')
       write (lpt,912)
       call ccp4h_link('ncs corrlation matrix', '#ncscorr')
       write (lpt,913)
 911   format(/,'<h3>Averaging</h3>',/,
     + /,'For averaging calculations you should always check that the')
 912   format (
     +   'covers the expected fraction of the unit cell,',
     + /,'and that the values of the')
 913   format (
     +   'for the first cycle are reasonable. If you are using a',
     + /,'monomer mask, check all the off-diagonal elements. If you',
     + /,'are using a multimer mask, check the top row only. Values',
     + /,'over 0.2 usually indicate correct mask and matrices, values',
     + /,'unde 0.1 usually indicate an incorrect mask or matrix.<p>',/)
      endif

cj--
c
      if(mncs.gt.0.and.ncscomm.eq.1)then
       write(lpt,600)
 600  format('<h3>Automatic Determination of NCS Monomers</h3>')
       write(lpt,602)ncsmer
 602  format('<p><U>Number of monomers found</U>:',f10.0,'</p>')
       write(lpt,601)
 601  format(
     + /,'You have left to the program the task to compute the',
     + /,'number of NCS monomers. Be aware that the program''s',
     + /,'assignment could underestimate this number in particular',
     + /,'cases when closed mixed non-crystallographic and',
     + /,'crystallographic symmetry are both present (e.g. 222 NCS',
     + /,'with one NCS 2-fold and one crystallographic 2-fold).',
     + /,'A general rule is to always checking the number before using',
     + /,'it. <p>',/)
        endif
c
cj--

ckev      if (msolv.gt.0.and.mmult.eq.0) then
ckev       write (lpt,921)
ckev 921   format (/,'<h3>Multi-Resolution Modification</h3>',/,
ckev     + /,'You have turned off multi-resolution modification.<p>',
ckev     + /,'Multi-resolution density modification is a new technique',
ckev     + /,'which leads to further map improvement over a wide range',
ckev     + /,'of test structures. I encourage users at least to try the',
ckev     + /,'technique, and report any interesting results.<p>',/)
ckev      endif
      if (ncycl.lt.0) then
       write (lpt,951)
 951   format(/,'<h3>Number of cycles</h3>',/,
     + /,'You have chosen NCYCLE AUTO. This is a cautious mode which',
     + /,'runs few cycles of density modification and terminates at',
     + /,'the first indication of phase bias and FOM overestimation.',
     + /,'This is a good choice when you have weak data and no',
     + /,'averaging. However you must use SCHEME ALL (selected by',
     + /,'default).<p>',/)
      else
       write (lpt,961)
 961   format(/,'<h3>Number of cycles</h3>',/,
     + /,'You have specified a fixed number of cycles. This is a good',
     + /,'choice if you have strong data or averaging, but beware that',
     + /,'after many cycles the FOMs will be overestimated.<p>',/)
      endif
      if (mcomb.lt.6) then
       write (lpt,971)
 971   format (/,'<h3>Perturbation Gamma Correction</h3>',/,
     +  /,'The perturbation gamma-correction is strongly recommended',
     +  /,'for all calculations. It gives better results than',
     +  /,'reflection-omit in a fraction of the time.',/)
      endif
      if (mhist.eq.0.or.mcomb.lt.6) then
       write (lpt,981)
 981   format (/,'<h3>Recommended Mode Warning</h3>',/,
     +  /,'You are using dm in a non-recommended mode.',
     +  /,'If you discuss any results obtained from dm using',
     +  /,'these options, you should state that dm was used in a',
     +  /,'non-recommended mode')
      endif
c
      write (lpt,991)
 991  format (/,'<h3>OK, continuing</h3></b>')
c
      return
      end
c
c ----------------------------------------------------------------------
c
      integer function masksize(name)
      include 'dmheader.fh'
      include 'io.fh'
c
      character name*(*)
c
      integer size,nspgrp,mu,mv,mw,mu1,mv1,mu2,mv2,mw1,mw2,ifail
      real cell(6)
      character line*240
c
      call ugtenv(name,line)
      if (line.ne.' ') then
       ifail=0
       call ccpdpn(lmsks,name,'UNKNOWN','U',0,ifail)
       close(unit=lmsks,status='KEEP')
       call ccpmaphead
     +   (name,nspgrp,cell,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2)
       size=(mu2-mu1+1)*(mv2-mv1+1)*(mw2-mw1+1)
       write (lpt,100)name,size
 100   format (' Input file ',a10,'  Program memory ',i10)
      else
       size=0
      endif
c
      masksize=size
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine hklin(hkls,assigned)
      include 'dmheader.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'hkldata.fh'
      include 'mtzdata.fh'
      include 'hkllab.fh'
      include 'hkllim.fh'
      include 'params.fh'
c HKLIN - read columns from .mtz file
c
      real hkls(nhklc,0:*)
      logical assigned(nhklc)
c
      logical eof,centre,sysabs,logmss(mtzcol)
      real adata(mtzcol),sh(nhklc),sh2(nhklc),hmx(nhklc),hmn(nhklc)
      character colnam(nhklc)*6
c
      integer in(3),nfile,nhires,nsysab,notasu,nunobs,ncen,ncenerr
      integer ih,ik,il,inasu,i
      real s,eps,phicen,fo,sfo,phio,fomo,fdm,phidm,fomdm,fpc,phipc
      real rrand,flag,hla,hlb,hlc,hld,x,atanh,sim,siminv
c
      external inasu,rrand,atanh,sim,siminv
c
      data sh,sh2,hmx,hmn/
     +            nhklc*0.0,nhklc*0.0,nhklc*-1000.0,nhklc*1000.0/
      data colnam/'H','K','L','S','EPS','FO','PHIO','FOMO',
     +            'HL-A','HL-B','HL-C','HL-D','FPC','PHIPC',
     +            'FDM','PHIDM','FOMDM',7*'x','FREE'/
c
      call probsetup()
c
      nfile=0
      nrflo=0
      nhires=0
      nsysab=0
      notasu=0
      nunobs=0
      ncen=0
      ncenerr=0
c
      assigned(lfdm)  =(ifdm.ne.0)  
      assigned(lphidm)=(iphidm.ne.0)
      assigned(lfomdm)=(ifomdm.ne.0)
      assigned(lfpc)  =(ifpc.ne.0)  
      assigned(lphipc)=(iphipc.ne.0)
      assigned(lfree) =(ifree.ne.0)
      assigned(lhla)=.true.
      assigned(lhlb)=.true.
      assigned(lhlc)=.true.
      assigned(lhld)=.true.
      if (ifree.ne.0) numbfree=0
c
      call equal_magic(1,logmss,mtzcol)
c
 100    call lrrefl(1,s,adata,eof)
        if (eof) goto 200
c
        call lrrefm(1,logmss)
        do 101 i=1,mtzcol
         if (logmss(i)) adata(i)=0.0
 101    continue
c
        nfile=nfile+1
c        call rseed(nfile+mod(37*nfile,53))
        ih=nint(adata(1))
        ik=nint(adata(2))
        il=nint(adata(3))
        in(1)=ih
        in(2)=ik
        in(3)=il
c Get epsilon zone and centric flag
        call epscen(ih,ik,il,centre,sysabs,eps,phicen,nsym,rsym)
        if (centre) eps=-eps
c Get standard deviation of F - zero for unobserved
        sfo=1.0
        if (isfo.ne.0) sfo=adata(isfo)
        if (logmss(ifo)) sfo=0.0
        if (sfo.le.0.0.and.wrstr.lt.0.0) goto 100
c reject reflections
        if (s.lt.smin.or.s.gt.smax) then
          nhires=nhires+1
          goto 100
        endif
        if (sysabs) then
          nsysab=nsysab+1
          goto 100
        endif
        if (inasu(in,nlaue).ne.1) then
          notasu=notasu+1
          goto 100
        endif
        if (sfo.eq.0.0) then
         nunobs=nunobs+1
        endif
        nrflo=nrflo+1
        if (nrflo.gt.nrflc) goto 9000
c Get reflection data ....
        fo=adata(ifo)
        phio=0.0
        fomo=0.0
        if (iphio.ne.0) phio=dtor*adata(iphio)
        if (ifomo.ne.0) fomo=adata(ifomo)
c Get H-L coeffs from phases or vice-versa
        if (ihla.ne.0) then
          hla=adata(ihla)
          hlb=adata(ihlb)
          hlc=adata(ihlc)
          hld=adata(ihld)
          if (iphio.eq.0.or.ifomo.eq.0) then
           if (centre) then
            call probcen(hla,hlb,phio,fomo)
           else
            call probhl(hla,hlb,hlc,hld,phio,fomo)
           endif
          endif
        else
          if (centre) then
            x=atanh(fomo)
          else
            x=siminv(fomo)
          endif
          hla=x*cos(phio)
          hlb=x*sin(phio)
          hlc=0.0
          hld=0.0
        endif
c correct centric phases and count erroneous phases, unobs reflections
        if (centre) then
         ncen=ncen+1
          if (iphio.ne.0 .and. (cos(2.0*(phio-phicen)).lt.0.99)) then
              if(.not.logmss(iphio)) ncenerr=ncenerr+1
          endif
          if (iphio.eq.0 .and. ihla.ne.0 .and. 
     +         (cos(2.0*(phio-phicen)).lt.0.99)) then
              if(.not.logmss(ihla)) ncenerr=ncenerr+1
          endif
          phio=nint((phio-phicen)/pi)*pi+phicen
        endif
c get starting points - default is mir data, overridden by cols.
c     BUT if a different f is given, don't use mir weight
        fdm=fo
        phidm=phio
        fomdm=fomo
        if (ifdm.ne.0)   fomdm=1.0
        if (ifdm.ne.0)   fdm=adata(ifdm)
        if (iphidm.ne.0) phidm=dtor*adata(iphidm)
        if (ifomdm.ne.0) fomdm=adata(ifomdm)
c Get free-r flag - 1...20 for 5% free-r sets
c if there is a free-r set on file then those get 1.0
        if (ifree.ne.0) then
         flag=real(nint(adata(ifree))+1)
         numbfree=max(numbfree,nint(flag))
        else
         flag=real(int(rrand()*numbfree)+1)
        endif
c Get partial structure model phase ?OBSOLETE?
        fpc = 0.
        phipc = 0.
        if (ifpc.ne.0)   fpc=adata(ifpc)
        if (iphipc.ne.0) phipc=dtor*adata(iphipc)
c check for FOM errors
        if (fomo .lt.0.0.or.fomo .gt.1.0.or.
     +      fomdm.lt.0.0.or.fomdm.gt.1.0) write(lpt,*)
     +    '(HKLIN) Error in input mtz - must have 0 <= FOM <= 1'
        fomo =max(min(fomo ,1.0),0.0)
        fomdm=max(min(fomdm,1.0),0.0)
c flag unobserved
        if (sfo.eq.0.0) fo=-0.01
c store in reflection array
        hkls(1,nrflo)=adata(1)
        hkls(2,nrflo)=adata(2)
        hkls(3,nrflo)=adata(3)
        hkls(4,nrflo)=s
        hkls(5,nrflo)=eps
        hkls(lfo,nrflo)=fo
        hkls(lphio,nrflo)=phio
        hkls(lfomo,nrflo)=fomo
        hkls(lhla,nrflo)=hla
        hkls(lhlb,nrflo)=hlb
        hkls(lhlc,nrflo)=hlc
        hkls(lhld,nrflo)=hld
        hkls(lfpc,nrflo)=fpc
        hkls(lphipc,nrflo)=phipc
        hkls(lfdm,nrflo)=fdm*fomdm
        hkls(lphidm,nrflo)=phidm
        hkls(lfomdm,nrflo)=fomdm
        hkls(lfree,nrflo)=flag
        hkls(lflag,nrflo)=1
c
c accumulate some stats
        do 190 i=1,nhklc
         if (assigned(i)) then
          sh(i)=sh(i)+hkls(i,nrflo)
          sh2(i)=sh2(i)+hkls(i,nrflo)**2
          hmx(i)=max(hmx(i),hkls(i,nrflo))
          hmn(i)=min(hmn(i),hkls(i,nrflo))
         endif
 190    continue
c next reflection
        goto 100
c
c store F(000) term
 200  hkls(lfo,0)=f000
c write out some information
      do 205 i=1,nhklc
       sh(i)=sh(i)/nrflo
       sh2(i)=sh2(i)/nrflo
 205  continue
c
      write (lpt,210)nfile,nhires,nsysab,notasu,nrflo
 210  format (/' Number of reflections on file:   ',i6
     +        /' Number outside resolution limit: ',i6
     +        /' Number of systematic absences:   ',i6
     +        /' Number outside asymmetric unit:  ',i6
     +        /' Number of reflections used:      ',i6)
c
      write (lpt,215)nunobs,ncen,ncenerr
 215  format (/' Number of unobserved reflections:                ',i6
     +        /' Number of centric reflections:                   ',i6
     +        /' Number of centric phases more than 4 degrees out:',i6)
      if(ncen.gt.0.and.float(ncenerr)/ncen.gt.0.2) call ccperr(3,
     + ' Too many centric reflections differ from the expected value')
c
      write (lpt,220)
 220  format (/' Program data read:'
     +  /' Column:      MIN       MAX       MEAN X    MEAN X^2')
      do 240 i=1,nhklc
       if (assigned(i))
     +   write (lpt,230)colnam(i),hmn(i),hmx(i),sh(i),sh2(i)
 240  continue
 230  format (4x,a6,1x,f9.3,1x,f9.3,1x,f9.3,1x,f11.3)
c
      return
 9000 call ccperr(1,' (HKLIN) Too many reflections - supply only ASU')
      end
c
c ----------------------------------------------------------------------
c
      subroutine hklout(hkls)
      include 'dmheader.fh'
      include 'io.fh'
      include 'scaleb.fh'
      include 'hkldata.fh'
      include 'mtzdata.fh'
      include 'hkllab.fh'
c HKLOUT - write out modified data
c
      real hkls(nhklc,0:*)
c
      real adata(mtzcol)
      logical eof
      integer mtzin,nfile,nlist,i
      real s,sc
c
c rewind the input file
      mtzin=1
      call lrrewd(mtzin)
c
c write modified data to .mtz file
      nfile=1
      nlist=1
 100   call equal_magic(mtzin,adata,nlprgo+ncols)
       call lrrefl(mtzin,s,adata,eof)
       if (eof) goto 200
       if (nint(adata(1)).eq.nint(hkls(1,nlist)).and.
     +     nint(adata(2)).eq.nint(hkls(2,nlist)).and.
     +     nint(adata(3)).eq.nint(hkls(3,nlist))) then
        sc=sqrt(scale)*exp(bfac*s/4.0)
        adata(ncols+ophidm )=hkls(lphidm,nlist)/dtor
        adata(ncols+ofomdm )=hkls(lfomdm,nlist)
        adata(ncols+ofdm   )=hkls(lfdm,nlist)/sc
        adata(ncols+ofcdm  )=hkls(lfpc,nlist)/sc
        adata(ncols+ophicdm)=hkls(lphipc,nlist)/dtor
        adata(ncols+ohladm )=hkls(ladm,nlist)
        adata(ncols+ohlbdm )=hkls(lbdm,nlist)
        adata(ncols+ohlcdm )=hkls(lcdm,nlist)
        adata(ncols+ohlddm )=hkls(lddm,nlist)
        nlist=nlist+1
       endif
       nfile=nfile+1
       call lwrefl(mtzin,adata)
       goto 100
c done write
 200  call lrclos(mtzin)
      call lwclos(mtzin,1)
c
      write (lpt,220)nfile-1,nlist-1
 220  format (/' Number of reflections on file:  ',i6/
     +         ' Number of reflections modified: ',i6)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine logout()
      include 'dmheader.fh'
      include 'io.fh'
      include 'mode.fh'
      include 'cycl.fh'
      include 'output.fh'
      include 'crystal.fh'
      include 'ncssym.fh'
c logout - output final comments to log file
c
      integer i,j,idom,incs,nncs
      real temp(4,4)

cj--
c
      real alpha,beta,gamma
c
cj--

c
c output phase combination graph
      call ccp4h_graph_beg(0,0)
      write (lpt,500)
 500  format (' $TABLE: Phase and weight statistics :',/,
     +' $GRAPHS: Mean change in phase :N:1,2:',/,
     +'        : Mean figures of merit:N:1,3,4:',/,
     +' $$',/,
     +' 1/resol^2   dphi/degrees  FOMobs      FOMdm $$',/,
     +' $$')
      do 520 i=1,nresio
      write (lpt,530)(phcmbst(i,j),j=1,4)
 520  continue
 530  format(1x,4f12.3)
      write (lpt,'(a)')' $$'
      call ccp4h_graph_end()
c
c output Free-R factor graph
      call ccp4h_graph_beg(0,0)
      write (lpt,600)
 600  format (' $TABLE: Density Modification-Free-R factors :',/,
     +' $GRAPHS: Variation of Free-Residuals :N:1,2,3:',/,
     +' $$',/,
     +' Cycle_number  Free_R_factor Real_Space_Free_R $$',/,
     +' $$')
      do 620 i=1,icycl-1
      write (lpt,630)i,freer(i),realr(i)
 620  continue
 630  format(1x,i10,1x,2f10.3)
      write (lpt,'(a)')' $$'
      call ccp4h_graph_end()
c
c output ncs statistics
      if (mncs.eq.1) then
       write (lpt,300)
 300   format (/' NCS correlations between related density regions:'
     +         /'  Domain    Initial   Final')
       do 320 idom=1,ndomain
        if     (ncscrl(idom,1).lt.0.05) then
         write (lpt,330)idom,ncscrl(idom,1),ncscrl(idom,2),
     +   'ERROR: initial value too low - matrices or mask may be wrong'
        elseif (ncscrl(idom,1).lt.0.20) then
         write (lpt,330)idom,ncscrl(idom,1),ncscrl(idom,2),
     +   'WARNING: initial value low - check matrices and mask'
        else
         write (lpt,330)idom,ncscrl(idom,1),ncscrl(idom,2),'OK'
        endif
 320   continue
 330   format (2x,i6,4x,f6.3,4x,f6.3,4x,a)
      endif
c
c output refined ncs matrices
      if (mncs.eq.1.and.ncref.ne.0) then
       write (lpt,400)
 400   format (/' Refined NCS matrices:'/)
       do 491 idom=1,ndomain
        do 481 incs=1,nncsym(idom)
         call symmatmul(rsymncs(1,1,incs,idom),qt,temp)
         call symmatmul(q,temp,rsymncs(1,1,incs,idom))

cj--
c
c the refined ncs matrices output is given as Euler angles and translations
         call matrixtoeuler(rsymncs(1,1,incs,idom),alpha,beta,gamma)
c
cj--

ckev         write (lpt,421)idom,((rsymncs(i,j,incs,idom),j=1,3),i=1,3),
ckev     +     (rsymncs(i,4,incs,idom),i=1,3)

cj--
c
         write (lpt,421)idom,alpha,beta,gamma,
     +         (rsymncs(i,4,incs,idom),i=1,3)
c
cj--

 481     continue
 491    continue
ckev 421    format ('AVER DOMAIN',i2,/,'ROTATION MATRIX ',12x,3f9.5,
ckev     +          '\\',/,1x,6f9.5,/,'TRANSLATION     ',3f9.3)

cj--
c
 421    format ('AVER DOMAIN',i2,/,'ROTATE EULER',3x,3f9.3,/,
     +          'TRANSLATION',4x,3f9.3)
c
cj--

      endif
      write (lpt,'(/)')
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine calcscale(hkls,assigned)
      include 'dmheader.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
      include 'scaleb.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
c SCALEF - calculate the scale of the input data
c uses columns h,k,l,s,eps,fo to calculate bfac,scale
c
c in: if scale > 0.0 no scaling is performed
c     if scale < 0.0 scale is applied but no b-factor
c
      real hkls(nhklc,0:*)
      logical assigned(nhklc)
c
      real res(50),std(50),rres(50),sres(50),rstd(50)
      real ncal(50),f2cal(50),nobs(50),f2obs(50)
      integer ndatares
c
      integer i,j,nr,nres,nrstep,numres
      real srmin,srmax,varprt,varsol,rhoave,rhovar,s,sc
      real x,y1,y2,w,sw,sx,sx2,sdy,sdyx
c
      external numres
c data from ins
      data ndatares/19/
      data res/999.00,10.00, 8.00, 7.00, 6.00, 5.00, 4.50, 4.00, 3.60,
     +     3.30, 3.00, 2.80, 2.60, 2.40, 2.20, 2.00, 1.80, 1.60, 1.50,
     +     31*0.0/
      data std/ 0.000,0.076,0.107,0.121,0.143,0.200,0.248,0.316,0.375,
     +    0.427,0.476,0.512,0.552,0.599,0.654,0.718,0.783,0.850,0.890,
     +     31*0.0/
c
c first pick the resolution ranges
c ================================
      nrstep=25
      rres(1)=0.0
      rstd(1)=0.0
      nres=0
      nr=0
      do 100 i=2,ndatares
        srmin=1.0/res(i-1)**2
        srmax=1.0/res(i)**2
        do 50 j=1,nrflo
          if (hkls(4,j).ge.srmin.and.hkls(4,j).lt.srmax
     +     .and.hkls(lfo,j).ge.0.0) nr=nr+1
 50     continue
        if (nr.gt.nrstep) then
          nr=0
          nres=nres+1
          rres(nres)=res(i)
          rstd(nres)=std(i)
        endif
 100  continue
c
c calculate estimated variances with resolution for this structure
c ================================================================
      do 110 i=1,nres
c pick up varience of protein region (res.dep.) and solvent (almost flat)
      varprt=rstd(i)**2
      varsol=varprt/10.0
c now calc overall mean and variance
      rhoave=aveprt*(1.0-solc)+avesol*solc
      rhovar=(varprt+(aveprt-rhoave)**2)*(1.0-solc) +
     +       (varsol+(avesol-rhoave)**2)*solc
c store expected data sizes
      ncal(i)=numres(rres(i))
      f2cal(i)=rhovar*vol**2/(2.0*nsym)
 110  continue
c now do differences for individual ranges
      do 120 i=nres,2,-1
      ncal(i)=ncal(i)-ncal(i-1)
      f2cal(i)=f2cal(i)-f2cal(i-1)
 120  continue
c
c now produce obs data stats for each resolution range
c ====================================================
      call calcsobs(hkls,nres,rres,sres,nobs,f2obs)
      if (scale.gt.0.0) goto 350
      if (rmax.gt.res(5)) goto 9010
c
c calculate scale and B-factor to produce best fit between obs and calc
c =====================================================================
      sw=0.0
      sx=0.0
      sx2=0.0
      sdy=0.0
      sdyx=0.0
      do 300 i=1,nres
        x=sres(i)/nobs(i)
        y1=log(f2cal(i)/ncal(i))
        y2=log(f2obs(i)/nobs(i))
c Empirical weighting scheme:
c uniform weight gives too little influence to high res data.
c (but there are more ranges at high res)
c weighting with number of reflections give too much influence to high res data.
c (but taking into account the SD's might put it right)
        w=1.0
        sw=sw+w
        sx=sx+w*x
        sx2=sx2+w*x**2
        sdy=sdy+w*(y2-y1)
        sdyx=sdyx+w*(y2-y1)*x
 300  continue
      if (scale.eq.0.0) bfac=(sw*sdyx-sx*sdy)/(sx**2-sw*sx2)*2.0
      scale=exp((sx2*sdy-sx*sdyx)/(sx**2-sw*sx2))
c
c rescale the input data to match the calc distributions
c ======================================================
 350  do 400 i=1,nrflo
        s=hkls(4,i)
        sc=sqrt(scale)*exp(bfac*s/4.0)
        hkls(lfo,i) =sc*hkls(lfo,i)
        hkls(lfdm,i)=sc*hkls(lfdm,i)
        if (assigned(lfpc)) hkls(lfpc,i)=sc*hkls(lfpc,i)
 400  continue
c
c produce stats for rescaled obs data
c ===================================
      call calcsobs(hkls,nres,rres,sres,nobs,f2obs)
c
c output data
c ===========
      write (lpt,500)scale,bfac
 500  format (/,
     +' Input data analysis:',/,
     +'   Estimated intensity scale factor = ',f10.3,/
     +'   Estimated temperature factor     = ',f10.3,/)
      call ccp4h_graph_beg(0,0)
      write (lpt,510)
 510  format (' $TABLE: Analysis of input structure factors :',/,
     +' $GRAPHS: Data completeness with resolution :N:2,4:',/,
     +'        : Mean F^2 with resolution          :N:2,5,6:',/,
     +' $$',/,
     +'  res   1/resol^2  number    %present      expect.   obs. $$',/,
     +' (lim)(4sin2th/l2)(reflns) (completeness)    (mean F^2)   $$')
      do 520 i=1,nres
      write (lpt,530)rres(i),sres(i)/nobs(i),
     +  nobs(i),100.0*nobs(i)/ncal(i),f2cal(i)/ncal(i),f2obs(i)/nobs(i)
 520  continue
 530  format(1x,f5.2,2x,f6.3,4x,f7.0,6x,f6.1,2x,2f9.0)
      write (lpt,'(a)')' $$'
      call ccp4h_graph_end()
c
      return
 9010 call ccperr(1,
     +  ' (CALCSCALE) - insufficent resolution: enter a SCALE card')
      end
c
c ----------------------------------------------------------------------
c
      subroutine calcsobs(hkls,nres,rres,sres,nobs,f2obs)
      include 'dmheader.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
c CALCSOBS - accumulate some statistics on observed data for CALCSCALE
c
      real hkls(nhklc,0:*)
      real rres(*),sres(*),nobs(*),f2obs(*)
c
      integer i,j,ir,nres
      real s,eps,fo
c
      do 140 i=1,nres
      sres(i)=0.0
      nobs(i)=0.0
      f2obs(i)=0.0
 140  continue
c
      do 200 j=1,nrflo
       s=hkls(4,j)
       eps=abs(hkls(5,j))
       fo=hkls(lfo,j)
c check for absent rfls
       if (fo.ge.0.0) then
        do 150 ir=1,nres-1
         if (s.lt.1.0/rres(ir)**2) goto 160
 150    continue
 160    nobs(ir)=nobs(ir)+1.0
        f2obs(ir)=f2obs(ir)+fo**2/eps
        sres(ir)=sres(ir)+s
       endif
 200  continue
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine wfo(hkls,lf,lphi)
      include 'dmheader.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
c calculate initial map coefficients from input data
c and copy into fdm and phidm columns
      real hkls(nhklc,0:*)
      integer lf,lphi
c
      integer i
      real w
c
      w=0.0
      hkls(lf,0)=hkls(lfo,0)
      hkls(lphi,0)=0.0
      do 100 i=1,nrflo
       if (hkls(lflag,i).gt.0.0) then
        hkls(lf,i)=hkls(lfdm,i)
        hkls(lphi,i)=hkls(lphidm,i)
        w=w+hkls(lfomdm,i)
       else
        hkls(lf,i)=0.0
        hkls(lphi,i)=0.0
       endif
 100  continue
c
      if (w.lt.0.1) call ccperr(1,
     +  ' (WFO) No density in map! Check input FOM present and nonzero')
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine setfreer(hkls,icfr,ncfr,icycl)
      include 'dmheader.fh'
      include 'io.fh'
      include 'mode.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
c SETFREER - pick an excluded set of reflections for free R-factor calc
c
      real hkls(nhklc,0:*)
      integer icfr,ncfr,icycl
c
      integer i,ipick,ninc,nexc,nincfr,nexcfr
c
c pick a fraction of the non-centric reflections
      ipick=icfr
      if (ncfr.eq.1) then
       ipick=mod(icycl,numbfree)+1
      else if (icfr.eq.ncfr) then
       return
      endif
      nexc=0
      ninc=0
      nexcfr=0
      nincfr=0
      do 100 i=1,nrflo
c pick a validation set and flag them
       if (hkls(lflag,i).eq.0) nexc=nexc+1
       if (hkls(lflag,i).eq.1) ninc=ninc+1
       if (nint(hkls(lfree,i)).eq.ipick) then
        if (hkls(lflag,i).eq.0) nexcfr=nexcfr+1
        if (hkls(lflag,i).eq.1) nincfr=nincfr+1
        hkls(lflag,i)=-1.0
       endif
c next reflection
 100  continue
c
      write (lpt,200)nincfr,ninc,nexcfr,nexc,nincfr+nexcfr,ninc+nexc
 200  format (
     +  '  Included reflections used for Free-R: ',i7,' of ',i7/
     +  '  Excluded reflections used for Free-R: ',i7,' of ',i7/
     +  '     Total reflections used for Free-R: ',i7,' of ',i7/)
c
      return
      end
c
c ----------------------------------------------------------------------
c

cj--
c
      subroutine vuout()
      include 'dmheader.fh'
      include 'ncssym.fh'
      integer lncs,ifail,i,j,k,ii,ifilename
      real dd,dd1,dd2,dd3
      real xc(200),yc(200),zc(200),xcc(50),ycc(50),zcc(50)
      real x1,y1,z1,x2,y2,z2,x3,y3,z3,x11,y11,z11,x22,y22,z22
      real rsyminv(4,4),xx,yy,zz,v,rc,dt
      character filename*240
      logical outputvuo
      integer ccpnun
      external ccpnun,ccpdpn,ugtenv
c Routine to output symmetry elements in "O" or "XtalView" files
c
c default output, .vu file 
      ifilename=+1
      lncs=ccpnun()
      ifail=0
      call ugtenv('VUOUT',filename)
      outputvuo=(filename.ne.' ')
c      if(index(filename,'.vu').gt.0)ifilename=+1
      if(outputvuo)then
       if(index(filename,'.o').gt.0)ifilename=-1
       call ccpdpn(lncs,filename,'UNKNOWN','F',0,ifail)
      else
       return
cjaf       call ccpdpn(lncs,'VUOUT','UNKNOWN','F',0,ifail)
      endif
c finding out the total number of domains for "O" file
      k=0
      do 200 i=1,ndomain
       do 210 j=1,nncsym(i)
        k=k+1
 210   continue
 200  continue 
      if(ifilename.eq.-1)then
       write(lncs,101)2*k+6,30
       write(lncs,91) 
       write(lncs,81)
       write(lncs,71)1.,1.,1.
      endif
 101  format(' DMNCS t',2i4)
 91   format(' Begin_object dmncs')
 81   format(' Colour white')
 71   format(' Light ',3f6.1)
      do 10 i=1,ndomain
c rsyminv is the inverse of rsymncs
       call invsym(rsymncs(1,1,2,i),rsyminv) 
       do 60 ii=1,nncsym(i)
c initial point
        xc(1)=xyzcen(1,ii,i)
        yc(1)=xyzcen(2,ii,i)
        zc(1)=xyzcen(3,ii,i)
        do 40 j=1,200
c produce two points in opposite verses, related through symmetry
         call symuvw(rsymncs(1,1,2,i),xc(j),yc(j),zc(j),x1,y1,z1)
         call symuvw(rsyminv(1,1),xc(j),yc(j),zc(j),x2,y2,z2)
c find intermediate median points
         x11=(xc(j)+x1)/2.
         y11=(yc(j)+y1)/2.
         z11=(zc(j)+z1)/2.
         x22=(xc(j)+x2)/2.
         y22=(yc(j)+y2)/2.
         z22=(zc(j)+z2)/2.
c find next approximate centre of symmetry as final median point
         xc(j+1)=(x11+x22)/2.
         yc(j+1)=(y11+y22)/2.
         zc(j+1)=(z11+z22)/2.
c distance between two successive approximated centres of symmetry
         dd=sqrt((xc(j+1)-xc(j))**2+(yc(j+1)-yc(j))**2+
     +           (zc(j+1)-zc(j))**2)
         if(dd.lt.0.01)then
          xcc(ii)=xc(j+1)
          ycc(ii)=yc(j+1)
          zcc(ii)=zc(j+1)
          goto 50
         endif
 40     continue      
c 50     write(6,*)'CENTRE OF SYMMETRY',xcc(ii),ycc(ii),zcc(ii)
 50     if(ifilename.eq.1)write(lncs,51)xyzcen(1,ii,i),xyzcen(2,ii,i),
     +                    xyzcen(3,ii,i),xcc(ii),ycc(ii),zcc(ii)
        if(ifilename.eq.-1)then
         write(lncs,111)xyzcen(1,ii,i),xyzcen(2,ii,i),xyzcen(3,ii,i)
         write(lncs,121)xcc(ii),ycc(ii),zcc(ii)
        endif
 60    continue
c if various centres of symmetry are close enough, they are a unique centre
       dd=sqrt((xcc(1)-xcc(2))**2+(ycc(1)-ycc(2))**2+
     +         (zcc(1)-zcc(2))**2)
       if(dd.lt.0.5)then
c        write(6,*)'SINGLE CENTRE',dd
c find direction for the rotation axis
        x1=rsymncs(1,1,2,i)-1
        y1=rsymncs(2,1,2,i)
        z1=rsymncs(3,1,2,i)
        dd1=sqrt(x1**2+y1**2+z1**2)
        x2=rsymncs(1,2,2,i)
        y2=rsymncs(2,2,2,i)-1
        z2=rsymncs(3,2,2,i) 
        dd2=sqrt(x2**2+y2**2+z2**2)
        x3=rsymncs(1,3,2,i)
        y3=rsymncs(2,3,2,i)
        z3=rsymncs(3,3,2,i)-1 
        dd3=sqrt(x3**2+y3**2+z3**2)
        if(dd1.ge.dd3.and.dd2.ge.dd3)then
         xx=y1*z2-z1*y2
         yy=z1*x2-x1*z2
         zz=x1*y2-y1*x2
        elseif(dd1.ge.dd2.and.dd3.ge.dd2)then
         xx=y1*z3-z1*y3
         yy=z1*x3-x1*z3
         zz=x1*y3-y1*x3
        elseif(dd2.ge.dd1.and.dd3.ge.dd1)then
         xx=y2*z3-z2*y3
         yy=z2*x3-x2*z3
         zz=x2*y3-y2*x3
        endif
c find the two ends of the rotation axis to be plotted
        v=sqrt(xx**2+yy**2+zz**2)
        dd=sqrt((xcc(1)-xyzcen(1,1,i))**2+(ycc(1)-xyzcen(2,1,i))**2+
     +          (zcc(1)-xyzcen(3,1,i))**2)
        dt=2.*dd/v
        if(ifilename.eq.1)write(lncs,51)xcc(1)-dt*xx,ycc(1)-dt*yy,
     +        zcc(1)-dt*zz,xcc(1)+dt*xx,ycc(1)+dt*yy,zcc(1)+dt*zz
        if(ifilename.eq.-1)then
         write(lncs,111)xcc(1)-dt*xx,ycc(1)-dt*yy,zcc(1)-dt*zz
         write(lncs,121)xcc(1)+dt*xx,ycc(1)+dt*yy,zcc(1)+dt*zz
        endif
       else
c        write(6,*)'MULTIPLE CENTRES',dd
c        write(6,*)
c the two ends of the rotation axis are the centres of symmetry
        do 70 ii=1,nncsym(i)-1
         if(ifilename.eq.1)write(lncs,51)xcc(ii),ycc(ii),zcc(ii),
     +                 xcc(ii+1),ycc(ii+1),zcc(ii+1)
         if(ifilename.eq.-1)then
          write(lncs,111)xcc(ii),ycc(ii),zcc(ii)
          write(lncs,121)xcc(ii+1),ycc(ii+1),zcc(ii+1)
         endif
 70     continue
       endif
 10   continue
      if(ifilename.eq.-1)write(lncs,131) 
 131  format(' End_object')
 51   format(6f8.2,'   white')
 111  format(' Move ',3f8.3)
 121  format(' Line ',3f8.3)
      close(unit=lncs,status='KEEP')
      return
      end
