C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c
c ----------------------------------------------------------------------
c
      subroutine setdelta(hkls,lf,lphi,df)
      include 'dmheader.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
c
c set up a random permutation across reciprocal space
c
      real hkls(nhklc,0:*),df
      integer lf,lphi
c
      real rres(maxbin),sw(0:maxbin),sfo(0:maxbin),eps,s
      integer nres,i
      logical centre
c
      real rrand,resstat
      external rrand,resstat
c
c set up resolution bins
      call resbins(hkls,lfo,500,maxbin,rres,nres)
c
c set up stats
      do 90 i=0,nres
       sw(i)=0.0
       sfo(i)=0.0
 90   continue
c
c accumulate
      do 100 i=1,nrflo
       s=hkls(4,i)
       eps=abs(hkls(5,i))
       centre=(hkls(5,i).lt.0.0)
       if (.not.centre) then
        call setresstat(s,rres,nres)
        call addresstat(sw,1.0)
        call addresstat(sfo,hkls(lfo,i)**2/eps)
       endif
 100  continue
c
c and calculate
      do 190 i=0,nres
       sfo(i)=sfo(i)/max(sw(i),0.01)
 190  continue
c
c generate new values
      do 200 i=1,nrflo
       eps=abs(hkls(5,i))
       centre=(hkls(5,i).lt.0.0)
       if (.not.centre) then
        s=hkls(4,i)
        call setresstat(s,rres,nres)
        hkls(lf,i)=df*sqrt(resstat(sfo)*eps)
        hkls(lphi,i)=2.0*pi*rrand()
       else
        hkls(lf,i)=0.0
        hkls(lphi,i)=0.0
       endif
 200  continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine rgamma(hkls,lfa,lfb,lda,ldb,lfa1,lfb1,lfa2,lfb2,resdep)
      include 'dmheader.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
      include 'mode.fh'
      include 'io.fh'
c
c set up a random permutation across reciprocal space
c
      real hkls(nhklc,0:*)
      integer lfa,lfb,lda,ldb,lfa1,lfb1,lfa2,lfb2
      logical resdep
c
      real rres(maxbin),d12(0:maxbin),d11(0:maxbin),eps,a,b,a1,b1
      integer nres,ires,i,iresbin
      logical centre
      external iresbin
c
c set up resolution bins
      if (resdep) then
       call resbins(hkls,lfo,500,maxbin,rres,nres)
      else if (mmult.eq.1) then
       nres=2
       rres(1)=1/sqrt(smax*0.5)
       rres(2)=1.0/sqrt(smax)
      else
       nres=1
       rres(1)=1.0/sqrt(smax)   
      endif
c
      do 100 i=0,nres
       d12(i)=0.0
       d11(i)=0.0
 100  continue
c
      do 200 i=1,nrflo
       eps=abs(hkls(5,i))
       centre=(hkls(5,i).lt.0.0)
       if (.not.centre) then
        ires=iresbin(hkls(4,i),rres,nres)
        a=hkls(lda,i)
        b=hkls(ldb,i)
        a1=hkls(lfa2,i)-hkls(lfa1,i)
        b1=hkls(lfb2,i)-hkls(lfb1,i)
c        write (*,*)a,b,a1,b1
        d12(ires)=d12(ires)+a1*a+b1*b
        d11(ires)=d11(ires)+a*a+b*b
        d12(0)=d12(0)+a1*a+b1*b
        d11(0)=d11(0)+a*a+b*b
       endif
 200  continue
c
c      return
c
      do 300 i=1,nrflo
       ires=iresbin(hkls(4,i),rres,nres)
       hkls(lfa,i)=hkls(lfa1,i)-d12(ires)/d11(ires)*hkls(lfa,i)
       hkls(lfb,i)=hkls(lfb1,i)-d12(ires)/d11(ires)*hkls(lfb,i)
 300  continue
c
      write (lpt,910)
      do 900 i=1,nres
       write (lpt,920)rres(i),d12(i)/d11(i)
 900  continue
      write (lpt,930)d12(0)/d11(0)
 910  format(/,' Perturbation gamma correction:',
     +       /,'    Resolution    Gamma')
 920  format(4x,f8.2,4x,f8.4)
 930  format('  Overall value ',f8.4,/)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine hkladd(hkls,lfa,lfb,lfc,s1,s2)
      include 'dmheader.fh'
      include 'hkldata.fh'
c generate F,PHI list from A,B list
      integer lfa,lfb,lfc,i
      real hkls(nhklc,0:*),s1,s2
      do 100 i=0,nrflo
       hkls(lfc,i)=s1*hkls(lfa,i)+s2*hkls(lfb,i)
 100  continue
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine empgam(rhomap,rhomod,gamma)
      include 'dmheader.fh'
      include 'io.fh'
      include 'uvwdata.fh'
      include 'hkldata.fh'
c
      real rhomap(nu,nv,nw),rhomod(nu,nv,nw),gamma
c
      integer iu,iv,iw
      real sx,sy,sx2,sy2,sxy,s
c
      s=0
      sx=0
      sy=0
      sx2=0
      sy2=0
      sxy=0
      do 100 iw=1,nw
      do 100 iv=1,nv
      do 100 iu=1,nu
       s=s+1
       sx=sx+rhomap(iu,iv,iw)
       sy=sy+rhomod(iu,iv,iw)
       sx2=sx2+rhomap(iu,iv,iw)**2
       sy2=sy2+rhomod(iu,iv,iw)**2
       sxy=sxy+rhomap(iu,iv,iw)*rhomod(iu,iv,iw)
 100  continue
c
      sx=sx/s
      sy=sy/s
      sx2=sx2/s
      sy2=sy2/s
      sxy=sxy/s
      gamma=(sxy-sx*sy)/(sx2-sx*sx)
c
      write (lpt,*)'Empirical gamma ',gamma
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine subgam(hkls,lfa,lfb,lfa1,lfb1,gamma)
      include 'dmheader.fh'
      include 'io.fh'
      include 'hkldata.fh'
c
      real hkls(nhklc,*),gamma
      integer lfa,lfb,lfa1,lfb1
c
      integer i
c
      do 200 i=1,nrflo
       hkls(lfa,i)=hkls(lfa1,i)-gamma*hkls(lfa,i)
       hkls(lfb,i)=hkls(lfb1,i)-gamma*hkls(lfb,i)
 200  continue
      write (lpt,*)'Gamma correction ',gamma
c
      return
      end
c
c ----------------------------------------------------------------------
c

