C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c
c ----------------------------------------------------------------------
c
c map averaging routines
c
c ----------------------------------------------------------------------
c
      subroutine ncsautomask(hkls,lfa,lfb,correl,rhospl,msktmp,ncsmsk)
      include 'dmheader.fh'
      include 'uvwdata.fh'
      include 'hkldata.fh'
      include 'crystal.fh'
      include 'ncssym.fh'
      include 'params.fh'
      include 'io.fh'
c NCSAUTOMASK - non-crystallographic symmetry masking
      real hkls(nhklc,0:*)
      real correl(0:nu-1,0:nv-1,0:nw-1),rhospl(0:nu-1,0:nv-1,0:nw-1)
      integer lfa,lfb
      integer msktmp(0:nu-1,0:nv-1,0:nw-1)
      integer ncsmsk(0:*)
c
      real u,v,w,u1,v1,w1,u2,v2,w2,d2,r1,r2,frac,step,cut,cutold,s
      real sn,sx,sy,sx2,sy2,sxy,lim(2,3),newlim(2,3),x(3)
      real ndu(500),ndv(500),ndw(500)
      integer i,j,iu,iv,iw,ju,jv,jw,ku,kv,kw
      integer mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2
      integer iscale,incs,nncs,ndn
c
      real maskcut,bsplinterp
      external maskcut,bsplinterp,ncsplinewt
c
c
c Un-sharpen the data
      call wfo(hkls,lfa,lfb)
      do 50 i=1,nrflo
       hkls(lfa,i)=hkls(lfa,i)*exp(-ncsbf*hkls(4,i)/4.0)
 50   continue
      call hklfpab(hkls,lfa,lfb)
      call copylistmap(hkls,lfa,lfb,rhospl,nu,nv,nw)
      call forallrfl(ncsplinewt,rhospl)
      call fft3hr(rhospl,nu,nv,nw)
c
      nncs=nncsym(1)
c
      do 100 j=1,3
       lim(1,j)=-1.0
       lim(2,j)=2.0
       newlim(1,j)=lim(1,j)
       newlim(2,j)=lim(2,j)
 100  continue
c
c make neighbourhood
c
      step=rmax/1.0
      ndn=0
      do 20 iw=-5,5
      do 20 iv=-5,5
      do 20 iu=-5,5
       d2=(iu**2+iv**2+iw**2)
       if (d2.lt.20) then
        u=real(iu)*rmax/2.0
        v=real(iv)*rmax/2.0
        w=real(iw)*rmax/2.0        
        call symuvw(qt,u,v,w,u1,v1,w1)
        ndn=ndn+1
        ndu(ndn)=u1
        ndv(ndn)=v1
        ndw(ndn)=w1
       endif
 20   continue
      write (lpt,*)' neighbourhood ',ndn
c
c Refinement loop: start on a coarse grid.
c
      cut=0.0
c
      do 800 iscale=1,4
c
       do 320 i=1,3
        lim(1,i)=0.33*lim(1,i)+0.67*newlim(1,i)-0.1
        lim(2,i)=0.33*lim(2,i)+0.67*newlim(2,i)+0.1
        if (ncslim(1,i).gt.-999.0) lim(1,i)=ncslim(1,i)
        if (ncslim(2,i).gt.-999.0) lim(2,i)=ncslim(2,i)
 320   continue
       write (lpt,330)iscale,((lim(i,j),j=1,3),i=1,2)
 330   format (/,' NCSAutomask step',i3,
     +   /,'  Lower uvw limits ',3f9.2,/,'  Upper uvw limits ',3f9.2)
c
       do 350 iw=0,nw-1
       do 350 iv=0,nv-1
       do 350 iu=0,nu-1
        correl(iu,iv,iw)=0.0
 350   continue
c
c now loop through symmetries and make correlated maps
c
       do 400 incs=2,nncs
c
        do 400 kw=0,nw+ncstep-2,ncstep
        iw=min(kw,nw-1)
        w=real(iw)*(lim(2,3)-lim(1,3))/nw+lim(1,3)
        do 400 kv=0,nv+ncstep-2,ncstep
        iv=min(kv,nv-1)
        v=real(iv)*(lim(2,2)-lim(1,2))/nv+lim(1,2)
        do 400 ku=0,nu+ncstep-2,ncstep
        iu=min(ku,nu-1)
        u=real(iu)*(lim(2,1)-lim(1,1))/nu+lim(1,1)
         sn =real(ndn)
         sx =0.0
         sy =0.0
         sx2=0.0
         sy2=0.0
         sxy=0.0
         do 380 i=1,ndn
          u1=u+ndu(i)
          v1=v+ndv(i)
          w1=w+ndw(i)
          call symuvw(rsymncs(1,1,1,1),u1,v1,w1,u2,v2,w2)
          r1=bsplinterp(rhospl,u2,v2,w2)
          call symuvw(rsymncs(1,1,incs,1),u1,v1,w1,u2,v2,w2)
          r2=bsplinterp(rhospl,u2,v2,w2)
          sx=sx+r1
          sy=sy+r2
          sx2=sx2+r1**2
          sy2=sy2+r2**2
          sxy=sxy+r1*r2
 380     continue
c calc correlation
         correl(iu,iv,iw)=correl(iu,iv,iw)+
     +     (sn*sxy-sx*sy)/sqrt((sn*sx2-sx**2)*(sn*sy2-sy**2))
 400   continue
c Interpolate the correlations...
       do 410 iw=0,nw-1,ncstep
       kw=min(iw+ncstep,nw-1)
       do 410 iv=0,nv-1,ncstep
       kv=min(iv+ncstep,nv-1)
       do 410 iu=0,nu-1,ncstep
       ku=min(iu+ncstep,nu-1)
        do 405 jw=iw,kw
        do 405 jv=iv,kv
        do 405 ju=iu,ku
        u=real(ju-iu)/real(max(ku-iu,1))
        v=real(jv-iv)/real(max(kv-iv,1))
        w=real(jw-iw)/real(max(kw-iw,1))
        correl(ju,jv,jw)=
     +   (1.0-w)*((1.0-v)*((1.0-u)*correl(iu,iv,iw)+u*correl(ku,iv,iw))
     +                 +v*((1.0-u)*correl(iu,kv,iw)+u*correl(ku,kv,iw)))
     +        +w*((1.0-v)*((1.0-u)*correl(iu,iv,kw)+u*correl(ku,iv,kw))
     +                 +v*((1.0-u)*correl(iu,kv,kw)+u*correl(ku,kv,kw)))
 405    continue
 410   continue
c Now set a cutoff level
       frac=(((1.0-solc)*ncsmer)/(nsym*nncs))
     +   /((lim(2,1)-lim(1,1))*(lim(2,2)-lim(1,2))*(lim(2,3)-lim(1,3)))
       cutold=cut
       cut=max(0.95*cutold,maskcut(correl,frac))
c
c mark density above cutoff
       do 450 iw=0,nw-1
       do 450 iv=0,nv-1
       do 450 iu=0,nu-1
        if (correl(iu,iv,iw).gt.cut) then
         correl(iu,iv,iw)=1.0
        else
         correl(iu,iv,iw)=0.0
        endif
 450   continue
c
c get biggest peak
       call peak(correl)
c
c now work out limits of peak
       do 540 i=1,3
        newlim(1,i)=1000.0
        newlim(2,i)=-1000.0
 540   continue
       do 550 iw=0,nw-1
       do 550 iv=0,nv-1
       do 550 iu=0,nu-1
        x(3)=real(iw)*(lim(2,3)-lim(1,3))/nw+lim(1,3)
        x(2)=real(iv)*(lim(2,2)-lim(1,2))/nv+lim(1,2)
        x(1)=real(iu)*(lim(2,1)-lim(1,1))/nu+lim(1,1)
        if (correl(iu,iv,iw).gt.0.5) then
         do 545 i=1,3
          newlim(1,i)=min(x(i),newlim(1,i))
          newlim(2,i)=max(x(i),newlim(2,i))
 545     continue
        endif
 550   continue
c
 800  continue
c
c Mask detection complete: now calc grid limits and copy
c
c want an 'effective fractional grid'
      do 850 iw=0,nw-1
      do 850 iv=0,nv-1
      do 850 iu=0,nu-1
       msktmp(iu,iv,iw)=nint(correl(iu,iv,iw))
 850  continue
      mu=nint(real(nu)/(lim(2,1)-lim(1,1)))
      mv=nint(real(nv)/(lim(2,2)-lim(1,2)))
      mw=nint(real(nw)/(lim(2,3)-lim(1,3)))
      mu1=nint(real(mu)*lim(1,1))
      mv1=nint(real(mv)*lim(1,2))
      mw1=nint(real(mw)*lim(1,3))
      mu2=mu1+nu-1
      mv2=mv1+nv-1
      mw2=mw1+nw-1
      msku1=nint(real(nu)*newlim(1,1))-1
      mskv1=nint(real(nv)*newlim(1,2))-1
      mskw1=nint(real(nw)*newlim(1,3))-1
      msku2=nint(real(nu)*newlim(2,1))+1
      mskv2=nint(real(nv)*newlim(2,2))+1
      mskw2=nint(real(nw)*newlim(2,3))+1
c
      if ((msku2-msku1+1)*(mskv2-mskv1+1)*(mskw2-mskw1+1).gt.ncssize)
     +  goto 9000
c
      call ccpzi(ncsmsk,ncssize)
      call maskgrid(msktmp,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,
     +              ncsmsk,nu,nv,nw,msku1,mskv1,mskw1,msku2,mskv2,mskw2)
c
      do 890 i=1,nncs
       nuvwlim(1,i,1)=10000
       nuvwlim(2,i,1)=10000
       nuvwlim(3,i,1)=10000
       nuvwlim(4,i,1)=-10000
       nuvwlim(5,i,1)=-10000
       nuvwlim(6,i,1)=-10000
 890  continue
c set the symmetry limits
      do 950 iw=mskw1,mskw2
      do 950 iv=mskv1,mskv2
      do 950 iu=msku1,msku2
       if (ncsmsk(iu-msku1+(msku2-msku1+1)*
     +   (iv-mskv1+(mskv2-mskv1+1)*(iw-mskw1))).ne.0) then
        do 900 i=1,nncs
         u=real(iu)/real(nu)
         v=real(iv)/real(nv)
         w=real(iw)/real(nw)
         call symuvw(rsymncs(1,1,i,1),u,v,w,u1,v1,w1)
         ju=nint(u1*nu)
         jv=nint(v1*nv)
         jw=nint(w1*nw)
         nuvwlim(1,i,1)=min(nuvwlim(1,i,1),ju)
         nuvwlim(2,i,1)=min(nuvwlim(2,i,1),jv)
         nuvwlim(3,i,1)=min(nuvwlim(3,i,1),jw)
         nuvwlim(4,i,1)=max(nuvwlim(4,i,1),ju)
         nuvwlim(5,i,1)=max(nuvwlim(5,i,1),jv)
         nuvwlim(6,i,1)=max(nuvwlim(6,i,1),jw)
 900    continue
       endif
 950  continue
c
c now remove overlap from mask
      call ncstrim(ncsmsk,msktmp)
c
c and display a section
      call maskstats(ncsmsk,msku2-msku1+1,mskv2-mskv1+1,mskw2-mskw1+1,
     +  (mskw2-mskw1+1)/2)
c
      return
 9000 call ccperr(1,
     +  ' ncsautomask - out of memory: increase NCSMASK SIZE')
      end
c      mu2=nint(real(mu)*lim(2,1))
c      mv2=nint(real(mv)*lim(2,2))
c      mw2=nint(real(mw)*lim(2,3))
c
c ----------------------------------------------------------------------
c
      real function maskcut(map,mskfrc)
      include 'dmheader.fh'
      include 'io.fh'
      include 'uvwdata.fh'
c maskcut - calc cutoff level to mask a certain volume
c
      real map(0:nu-1,0:nv-1,0:nw-1),mskfrc
c
      integer nhist
      parameter (nhist=10000)
      integer iu,iv,iw,ncut
      integer ih,nh,hist(0:nhist)
      real rhomax,rhomin
c
      rhomin=1.0e12
      rhomax=-1.0e12
c
      do 50 ih=0,nhist
       hist(ih)=0
 50   continue
c
      do 100 iw=0,nw-1
      do 100 iv=0,nv-1
      do 100 iu=0,nu-1
       rhomin=min(rhomin,map(iu,iv,iw))
       rhomax=max(rhomax,map(iu,iv,iw))
 100  continue
c
      do 200 iw=0,nw-1
      do 200 iv=0,nv-1
      do 200 iu=0,nu-1
       ih=nint(nhist*(map(iu,iv,iw)-rhomin)/(rhomax-rhomin))
       hist(ih)=hist(ih)+1
 200  continue
c
      ncut=nint((1.0-mskfrc)*nu*nv*nw)
      nh=0
      do 300 ih=0,nhist-1
       nh=nh+hist(ih)
       if (nh.gt.ncut) goto 350
 300  continue
c
 350  maskcut=real(ih)*(rhomax-rhomin)/real(nhist)+rhomin
      write (lpt,500)100.0*mskfrc,maskcut
 500  format (/' Cutoff level to mask ',f6.1,' % of map = ',f6.3/)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine peak(mask)
      include 'dmheader.fh'
      include 'io.fh'
      include 'uvwdata.fh'
c
      real mask(0:nu-1,0:nv-1,0:nw-1)
c
      integer maxpeak,numpks
      parameter (maxpeak=10000,numpks=1)
      integer i,j,k,iu,iv,iw,ju,jv,jw
      integer npeaks,ipeak(0:maxpeak),npeak(0:maxpeak),index(0:maxpeak)
c
      do 10 i=0,maxpeak
       ipeak(i)=0
       npeak(i)=1
       index(i)=i
 10   continue
c
      k=1
      do 100 iw=0,nw-1
      do 100 iv=0,nv-1
      do 100 iu=0,nu-1
       if (mask(iu,iv,iw).gt.0.5) then
        mask(iu,iv,iw)=k
        k=k+1
       endif
 100  continue
c
      do 300 i=1,500
       k=0
       do 200 iw=nw-1,0,-1
       do 200 iv=nv-1,0,-1
       do 200 iu=nu-1,0,-1
        if (mask(iu,iv,iw).gt.0.5) then
         j=0
         do 150 jw=max(iw-1,0),min(iw+1,nw-1)
         do 150 jv=max(iv-1,0),min(iv+1,nv-1)
         do 150 ju=max(iu-1,0),min(iu+1,nu-1)
          j=max(j,nint(mask(ju,jv,jw)))
 150     continue
         if (j.gt.nint(mask(iu,iv,iw))) then
          mask(iu,iv,iw)=j
          k=k+1
         endif
        endif
 200   continue     
       if (k.eq.0) goto 400
 300  continue
      call ccperr(1,' peak - unable to peak-search mask')
c
 400  npeaks=0
      do 500 iw=0,nw-1
      do 500 iv=0,nv-1
      do 500 iu=0,nu-1
       i=nint(mask(iu,iv,iw))
       do 450 k=0,npeaks
        if (i.eq.ipeak(k)) then
         npeak(k)=npeak(k)+1
         goto 500
        endif
 450   continue
       npeaks=npeaks+1
       if (npeaks.gt.maxpeak) call ccperr
     +   (1,' peak - mask is too complex for peak counting')
       ipeak(npeaks)=i
 500  continue
      write (lpt,510)npeaks
 510  format (' Found',i6,' peaks')
c
      do 600 i=1,npeaks-1
       do 600 j=i+1,npeaks
        if (npeak(index(j)).gt.npeak(index(i))) then
         k=index(j)
         index(j)=index(i)
         index(i)=k
        endif
 600  continue
c
      write (lpt,710)npeak(0)
      do 700 i=1,min(npeaks,10)
       write (lpt,720)i,npeak(index(i))
 700  continue
 710  format (' Points outside mask   ',i8)
 720  format ('  Peak ',i6,' size     ',i8)
c
      do 800 iw=0,nw-1
      do 800 iv=0,nv-1
      do 800 iu=0,nu-1
       if (mask(iu,iv,iw).gt.0.5) then
        j=nint(mask(iu,iv,iw))
        mask(iu,iv,iw)=1.0
        do 750 i=1,numpks
         if (j.eq.ipeak(index(i))) goto 800
 750    continue
        mask(iu,iv,iw)=0.0
       endif
 800  continue
c
      return
      end
c
c ----------------------------------------------------------------------
c

cj--
c
      subroutine assignmer
c routine to compute the number of overlapping regions in the 
c NCS sovrapposition of two maps
      include 'dmheader.fh'
      include 'ncssym.fh'
      include 'params.fh'
c
      integer i,nncs
      real rsympro(4,4),rsymprev(4,4)
      logical nmerflag
c
c involved domain number
      nncs=nncsym(1)
c initialise rsympro matrix
      call symcpy(rsymncs(1,1,2,1),rsymprev)
c compute ncsmer
      ncsmer=1.0
      nmerflag=.false.
      do 10 i=2,nncs
       call symmatmul(rsymncs(1,1,2,1),rsymprev,rsympro)
       ncsmer=ncsmer+1.0
c if rsympro = identity matrix -> ncsmer found
       if(abs(rsympro(1,1)-1.0).lt.0.02)nmerflag=.true.
       if(abs(rsympro(2,2)-1.0).lt.0.02)nmerflag=.true.
       if(abs(rsympro(3,3)-1.0).lt.0.02)nmerflag=.true.
       if(abs(rsympro(1,2)).lt.0.02)nmerflag=.true.
       if(abs(rsympro(1,3)).lt.0.02)nmerflag=.true.
       if(abs(rsympro(1,4)).lt.0.02)nmerflag=.true.
       if(abs(rsympro(2,1)).lt.0.02)nmerflag=.true.
       if(abs(rsympro(2,3)).lt.0.02)nmerflag=.true.
       if(abs(rsympro(2,4)).lt.0.02)nmerflag=.true.
       if(abs(rsympro(3,1)).lt.0.02)nmerflag=.true.
       if(abs(rsympro(3,2)).lt.0.02)nmerflag=.true.
       if(abs(rsympro(3,4)).lt.0.02)nmerflag=.true.
       if(nmerflag)goto 11
       call symcpy(rsympro,rsymprev)
 10   continue 
      if(.not.nmerflag)ncsmer=1.0
cjaf 11   if(ncsmer.gt.nncs)call ccperr(1,
cjaf    +'Automatic determination of NCS monomers failed  - Use keyword NME
cjaf     +R')
 11   return
      end
c
cj--

c
c ----------------------------------------------------------------------
c
