C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c
c ----------------------------------------------------------------------
c Kevin's maths library to fix fortran routines.
c a faster way is to call the 'c' routines directly
c
      real function rmod(r,s)
      include 'dmmulti.fh'
c fixed real mod
      real r,s,t
c
      t=mod(r,s)
      if (t.ge.0.0) then
      rmod=t
      else
      rmod=t+s
      endif
      return
      end
c -----------------------------------
      integer function lmod(i,j)
      include 'dmmulti.fh'
c fixed integer mod (optimised for 0<=i<j)
      integer i,j,k
c
      if (i.lt.0) then
       lmod=mod(i+1,j)+j-1
      else if (i.ge.j) then
       lmod=mod(i,j)
      else
       lmod=i
      endif
      return
      end
c -----------------------------------
      real function rint(r)
      include 'dmmulti.fh'
c fixed real int
      real r,s
c
      s=real(int(r))
      if (r.ge.s) then
      rint=s
      else
      rint=s-1.0
      endif
      return
      end
c -----------------------------------
      integer function lint(r)
      include 'dmmulti.fh'
c fixed integer int
      real r
      integer i
c
      i=int(r)
      if (r.ge.real(i)) then
      lint=i
      else
      lint=i-1
      endif
      return
      end
c -----------------------------------
      real function rfrac(r)
      include 'dmmulti.fh'
c fractional part
      real r,s
c
      s=real(int(r))
      if (r.ge.s) then
      rfrac=r-s
      else
      rfrac=r-s+1.0
      endif
      return
      end
c -----------------------------------
      real function rfracp(r)
      include 'dmmulti.fh'
c fractional part range -0.5..0.5
      real r
c
      rfracp=r-real(nint(r))
      return
      end
c -----------------------------------
      subroutine rseed(iseed1)
      include 'dmmulti.fh'
c seed random number
      integer iseed,iseed1
      common /randseed/iseed
      save   /randseed/
c
      iseed=iseed1
      return
      end
c -----------------------------------
      real function rrand()
      include 'dmmulti.fh'
c random number 0..1, sequence length 2**20=10**6
      integer ia,im,ic,iseed
      parameter (ia=2**20,im=2**10+1,ic=61)
      common /randseed/iseed
      save   /randseed/
c
      iseed=mod(iseed*im+ic,ia)
      rrand=real(iseed)/real(ia)
      return
      end
c
c ----------------------------------------------------------------------
c

