C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE CAMATC(AMAT, CELL, TCELL, TSIN, TCOS)
C
      IMPLICIT NONE
C
C     $                          (amat(i,j),j=1,3),
C
      REAL AMAT(3, 3), TCELL(6), CELL(6), TSIN(3), TCOS(3)
      REAL VST, VST2
C
      TCELL(1) = SQRT(AMAT(1, 1)**2+AMAT(2, 1)**2+AMAT(3, 1)**2)
      TCELL(2) = SQRT(AMAT(1, 2)**2+AMAT(2, 2)**2+AMAT(3, 2)**2)
      TCELL(3) = SQRT(AMAT(1, 3)**2+AMAT(2, 3)**2+AMAT(3, 3)**2)
      TCELL(4) = ACOS((AMAT(1, 2)*AMAT(1, 3)+AMAT(2, 2)*AMAT(2,
     +           3)+AMAT(3, 2)*AMAT(3, 3))/ (TCELL(2)*TCELL(3)))
      TCELL(5) = ACOS((AMAT(1, 1)*AMAT(1, 3)+AMAT(2, 1)*AMAT(2,
     +           3)+AMAT(3, 1)*AMAT(3, 3))/ (TCELL(1)*TCELL(3)))
      TCELL(6) = ACOS((AMAT(1, 1)*AMAT(1, 2)+AMAT(2, 1)*AMAT(2,
     +           2)+AMAT(3, 1)*AMAT(3, 2))/ (TCELL(1)*TCELL(2)))
      TSIN(1) = SIN(TCELL(4))
      TSIN(2) = SIN(TCELL(5))
      TSIN(3) = SIN(TCELL(6))
      TCOS(1) = COS(TCELL(4))
      TCOS(2) = COS(TCELL(5))
      TCOS(3) = COS(TCELL(6))
      TCELL(4) = TCELL(4)*180./3.141592654
      TCELL(5) = TCELL(5)*180./3.141592654
      TCELL(6) = TCELL(6)*180./3.141592654
      VST2 = 1.0 - TCOS(1)**2 - TCOS(2)**2 - TCOS(3)**2 +
     +       2.*TCOS(1)*TCOS(2)*TCOS(3)
      VST = SQRT(VST2)
      CELL(1) = TSIN(1)/TCELL(1)/VST
      CELL(2) = TSIN(2)/TCELL(2)/VST
      CELL(3) = TSIN(3)/TCELL(3)/VST
      CELL(4) = ACOS((TCOS(2)*TCOS(3)-TCOS(1))/ (TSIN(2)*TSIN(3)))*180./
     +          3.141592654
      CELL(5) = ACOS((TCOS(1)*TCOS(3)-TCOS(2))/ (TSIN(1)*TSIN(3)))*180./
     +          3.141592654
      CELL(6) = ACOS((TCOS(1)*TCOS(2)-TCOS(3))/ (TSIN(1)*TSIN(2)))*180./
     +          3.141592654
      RETURN
      END
