C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE GETREU(LUN,
     . IHKL,F2,SIGF2,IERROR,YDET,ZDET,PSI,YDETC,ZDETC,PSIC,TIME,ISTAT)
C      ==============================================================
C
C Read one reflection from input file on stream LUN
C
C On exit:
C   IHKL(3)     indices
C   F2          intensity
C   SIGF2       standard deviation
C   IERROR      error flag
C   YDET, ZDET  detector coordinates
C   PSI                 rotation angle (degrees)
C   YDETC, ZDETC  calculated detector coordinates
C   PSIC                calculated rotation angle (degrees)
C   TIME        time in minutes
C   ISTAT       = 0  OK
C               = -1 end of file
C
      IMPLICIT NONE
C
      INTEGER LUN,IHKL(3),IERROR,ISTAT
      REAL F2,SIGF2,YDET,ZDET,PSI,TIME,YDETC,ZDETC,PSIC
C
C Common containing Madnes data
      include 'madsav.fh'
C
      INTEGER I
      INTEGER*2 JHKL(3),FFRM,LFRM,IPEAK,ICORR
      REAL RLP,S0(3),S1(3)
      SAVE /MADSAV/
C
C
      READ (LUN,END=90,ERR=95) JHKL,FFRM,LFRM,IPEAK,ICORR,F2,SIGF2,
     &  RLP,S0,S1,PSIC,YDETC,ZDETC,PSI,YDET,ZDET
      IF (ABS(JHKL(1)).GT.999) GOTO 90
      DO 110 I=1,3
 110    IHKL(I)=JHKL(I)
      IERROR=0
      TIME=60.*EXTIM0+(FFRM+LFRM)*TIMIMG/120.
      ISTAT=0
      RETURN
C
C End of file
90    ISTAT=-1
      RETURN
C
C Error
95    WRITE (6,'(/A,3I5)') ' ERROR READING REFLECTION FILE AT',JHKL
      CALL CCPERR(1,'Error in reflection file')
      END
