C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE HDROPF(
     .        KBATCH,TITLEB,BTIMMIN,BTIMMAX,PSIMIN,PSIMAX,JCRYST,LPRINT)
C             ========================================================
C
C Write batch header & orientation block for batch KBATCH
C
C TITLEB  batch title
C TIMMIN,TIMMAX  range of times
C PSIMIN,PSIMAX  range of psi
C JCRYST  crystal number: if .lt.0, set crystal number = batch number
C LPRINT  if .true., print orientation block
C
      IMPLICIT NONE
C
      INTEGER KBATCH , JCRYST , INDEX
      CHARACTER*(*) TITLEB
      REAL BTIMMIN,BTIMMAX,PSIMIN,PSIMAX
      LOGICAL LPRINT
C
      include 'orient.fh'
      include 'corient.fh'
      include 'harvest.fh'
C
C     *** Note well the following equivalences: these are to allow for
C     alternative definitions of crystal mosaicity, beam parameters, etc
      EQUIVALENCE (ETAD,CRYDAT(1))
      EQUIVALENCE (ETADH,CRYDAT(1)),(ETADV,CRYDAT(2))
      EQUIVALENCE (BEMDAT(1),ALAMBD)
      EQUIVALENCE (BEMDAT(2),DELAMB)
      EQUIVALENCE (BEMDAT(3),DELCOR)
      EQUIVALENCE (BEMDAT(4),DIVHD)
      EQUIVALENCE (BEMDAT(5),DIVVD)
C ***
C This equivalence is strictly for convenience in printing
      REAL E123(3,3)
      EQUIVALENCE (E123(1,1),E1(1))
C     ..
C
C Save it
      SAVE /CORIEN/,/ORIENT/
C
      INDEX = 1
C
      TIME1 = BTIMMIN
      TIME2 = BTIMMAX
      PHISTT = PSIMIN
      PHIEND = PSIMAX
      PHIRANGE = PHIEND - PHISTT
      IF(JCRYST.GE.0) THEN
            NCRYST = JCRYST
      ELSE
            NCRYST = KBATCH
      ENDIF
C
      BTITLE = TITLEB
C
C Store the project name and dataset name for this batch in the mtz header:
C
      CALL LWBAT (INDEX , KBATCH , NWORDS , BTITLE)
C      WRITE(6,'(A/,A)')CRYSTALNAME,DATASETNAME
      CALL LWBSETIDX(INDEX , KBATCH , CRYSTALNAME , DATASETNAME)
      IF (LPRINT) CALL LBPRT(KBATCH , 2 , NWORDS , BTITLE)
C
C Dataset number (this indexes a list of datasets in the file header)
      LBSETID       = 1
C
      RETURN
      END
