C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE MFSD(A,N,EPS,IER)
C     ============================
C
      IMPLICIT NONE
C
      DIMENSION A(*)
      REAL A,EPS
      INTEGER N,IER
      DOUBLE PRECISION DPIV,DSUM
      REAL TOL
      INTEGER KPIV,I,K,L,IND,LEND,LANF,LIND
C
C     TEST ON WRONG INPUT PARAMETER N
      IF(N-1) 12,1,1
    1 IER=0
C     
C     INITIALIZE DIAGONAL-LOOP
      KPIV=0
      DO 11 K=1,N
         KPIV=KPIV+K
         IND=KPIV
         LEND=K-1
C     
C     CALCULATE TOLERANCE
         TOL=ABS(EPS*A(KPIV))
C     
C     START FACTORIZATION-LOOP OVER K-TH ROW
         DO 11 I=K,N
            DSUM=0.D0
            IF(LEND) 2,4,2
C     
C     START INNER LOOP
 2          DO 3 L=1,LEND
               LANF=KPIV-L
               LIND=IND-L
 3             DSUM=DSUM+DBLE(A(LANF)*A(LIND))
C     END OF INNER LOOP
C     
C     TRANSFORM ELEMENT A(IND)
 4             DSUM=DBLE(A(IND))-DSUM
               IF(I-K) 10,5,10
C     
C     TEST FOR NEGATIVE PIVOT ELEMENT AND FOR LOSS OF SIGNIFICANCE
 5             IF(SNGL(DSUM)-TOL) 6,6,9
 6             IF(DSUM) 12,12,7
 7             IF(IER) 8,8,9
 8             IER=K-1
C     
C     COMPUTE PIVOT ELEMENT
 9             DPIV=DSQRT(DSUM)
               A(KPIV)=SNGL ( DPIV )
               DPIV=1.D0/DPIV
               GO TO 11
C     
C     CALCULATE TERMS IN ROW
 10            A(IND)=SNGL ( DSUM * DPIV )
 11            IND=IND+I
C     
C     END OF DIAGONAL-LOOP
               RETURN
 12            IER=-1
               RETURN
               END
