C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE OUTHDR
C     =================
C
C  Write out batch headers for all batches processed so far
C
      IMPLICIT NONE
C
      include 'batch.fh'
      include 'cbatch.fh'
C
      INTEGER KBATCH,I
      LOGICAL LPRINT
C
      DO I = MININC + 1 , MAXINC + 1
C     In a series of SPLIT batches, only print orientation blocks for
C     first & last
C     No, don't print any !!
        LPRINT=.FALSE.
        IF ( I .EQ. MININC + 1 .OR. I .EQ. MAXINC + 1 ) 
     .    LPRINT = .TRUE.
C
        KBATCH=LBATCH+I-1
        IF (LPRINT) WRITE(6,1500) KBATCH,NRFBCH(I),LTITLE
 1500   FORMAT(//1X,20('****')//
     .         '  Header written for batch number',I7/
     .         '  Number of reflections  = ',I8/
     .         '  Title for this batch   = ',A80)
        IF(NRFBCH(I).GT.0) CALL HDROPF(
     .    KBATCH,LTITLE,TIMMIN(I),TIMMAX(I),PSIMIN(I),PSIMAX(I),
     .    LCRYST,LPRINT)
      END DO
C
      IF (MAXINC .GE. 0) THEN
C     Print summary of each batch
        WRITE(6,1600) LTITLE
 1600   FORMAT(//1X,20('****')//' Summary of batches with title:'//
     .    1X,A//' Batch number     Number of reflections'/)
        DO I = 1 , MAXINC + 1
          KBATCH = LBATCH + I - 1
          WRITE(6,'(1X,I10,10X,I10)') KBATCH , NRFBCH(I)
        END DO
        WRITE(6,'(/1X,20a4/)') '****'
      ENDIF
      RETURN
      END
