C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE PRCDTR(LUN,FNAME)
C     ========================
C
      IMPLICIT NONE
C
      INTEGER NBITS
      PARAMETER (NBITS=16)
C
      include 'flags.fh'
C      include 'orient.fh'
      include 'reindx.fh'
      include 'batch.fh'
C
C Storage for recording change of orientation etc during data collection
C  These variables apply to data between 2 successive Save sets in Madnes
C  output.
      INTEGER MAXGRP
      PARAMETER (MAXGRP=200)
C
      include 'grpdat.fh'
      include 'madsav.fh'
C
C Save it
C      SAVE /ORIENT/ , /REINDX/ , /MADSAV/
      SAVE /REINDX/ , /MADSAV/
C
C     Local variables
C
      REAL    F2 , SIGF2 
     .      , YDET  , XDET  , PSI 
     .      , YDETC , XDETC , PSIC 
     .      , TIME , RTIME 
      REAL RESO
      REAL LP , LORENTZ , POLARIZ , PSIREM
      REAL PSIREL
      REAL V(3) , HKL(3)
      REAL ODATA(24)
      INTEGER LUN , LOGUNIT
      INTEGER IHKL(3) , JHKL(3) , IERROR , ISTAT , IFAIL , IMGNUM
     .      , ISYM
      INTEGER I , J , K , II , JJ , III , JJJ , KBATCH
      INTEGER NUMINC
      INTEGER NHEADER , NUMINT , NUMFLT , NUMSTR , NUMCRY
      CHARACTER FNAME*80
C     Synthetic data mode:
      LOGICAL REJ , CNT , LPCALC
C     
C For reading dtprofit.ref file using information in header
      INTEGER NHDKEYS , IHEAD
      PARAMETER (NHDKEYS=24)      
      INTEGER HPOS(NHDKEYS)
      CHARACTER*30 HEAD(NHDKEYS)
      CHARACTER*30 ITEM
C
C Things for PARSER ----
      INTEGER MAXTOK
      PARAMETER (MAXTOK=100)
      CHARACTER CVALUE(MAXTOK)*4,LINE*250
      INTEGER IBEG(MAXTOK),IEND(MAXTOK),ITYP(MAXTOK),
     .     IDEC(MAXTOK),NTOK
      REAL    FVALUE(MAXTOK)
C     Things for getting correct detector orientation (Xd, Yd)
      REAL    DP1 , DP2
      LOGICAL PX0ROT
C     External Functions
      REAL DOT
      EXTERNAL DOT
      SAVE /GRPDAT/
C
C
C Here is a list of some header items and the variables that they
C correspond to in ABSURD
C
C nH             JHKL(1)
C nK             JHKL(2)
C nL             JHKL(3)
C nBadFlag       IERROR 
C nErrorFlag     IERROR 
C fIntensity     F2     
C fSigmaI        SIGF2  
C fOtherInt      
C fOtherSig      
C fObs_pixel0    YDET   
C fObs_pixel1    XDET   
C fObs_rot_mid   PSI    
C fObs_rot_width 
C fCalc_pixel0   YDETC  
C fCalc_pixel1   XDETC  
C fCalc_rot_mid  PSIC   
C fResolution    RESO   
C fLPfactor      LP    
C fCalc_polarz   POLARIZ
C fCalc_lorentz  LORENTZ
C fCorrelation   CORREL
C fSvec0         SV(1)  -
C fSvec1         SV(2)   |
C fSvec2         SV(3)   |- These are the incident and diffracted beam vectors
C fS0vec0        S0V(1)  |
C fS0vec1        S0V(1)  |
C fS0vec2        S0V(1) -
C sBatch
C
C===============================================================
C            *** Notes on detector coordinates ***
C
C     In Cambridge frame Xd || Y' and Yd || Z'. This means that
C     for the typical case of d*trek detector vectors 
C     of (1 0 0) and (0 1 0) thne pixel0 is along X and pixel1
C     is along Y in the d*trek frame.
C     This therefore means that pixel0 ---> Yd
C                               pixel1 ---> Xd
C
C     We reflect this by assigning fObs_pixel0  ---> YDET
C                                  fObs_pixel1  ---> XDET
C     and similary                 fCalc_pixel0 ---> YDETC
C                                  fCalc_pixel1 ---> XDETC
C
C     N.B.: This is not yet generally true. MKORDTR actually does the
C     transformation of detector coodibates and determines which pixel
C     direction should be along Xd in the Cambridge frame and then swaps
C     the values if necessary just before writing to the ODATA array.
C===============================================================
C
C     List of possibly useful values that we could find in the
c     reflection file and their labels which we will look for at the
C     top of the dtprofit.ref file.
C
      DATA HEAD /
     .       'nH'
     .      ,'nK'
     .      ,'nL'
     .      ,'nBadFlag'
     .      ,'nErrorFlag'
     .      ,'fIntensity'
     .      ,'fSigmaI'
     .      ,'fObs_pixel0'
     .      ,'fObs_pixel1'
     .      ,'fObs_rot_mid'
     .      ,'fCalc_pixel0'
     .      ,'fCalc_pixel1'
     .      ,'fCalc_rot_mid'
     .      ,'fResolution'
     .      ,'fLPfactor'
     .      ,'fCalc_polarz'
     .      ,'fCalc_lorentz'
     .      ,'fSvec0'
     .      ,'fSvec1'
     .      ,'fSvec2'
     .      ,'fS0vec0'
     .      ,'fS0vec1'
     .      ,'fS0vec2'
     .      ,'sBatch'
     .      /
C
      KBATCH=IBATCH
C     Reading combined LP correction
      LPCALC = .FALSE.
C
      LOGUNIT = 6
C
C     MININC used for DENZO/SCALEPACK option only - zero otherwise
C
      MININC = 0
C
C
C=========================================================
C     Find the detector vector closest to d*trek rotation axis
C
      DP1 = DOT (DETTRN(1,1) , SCROVC)
      DP2 = DOT (DETTRN(1,2) , SCROVC)
      IF ( ABS(DP1) .GE. ABS(DP2) ) THEN
C     First pixel direction in d*trek reflection file
C     is closest to the rotation axis
         PX0ROT = .TRUE.
      ELSE 
         PX0ROT = .FALSE.
      END IF
C=========================================================
C
      WRITE(LOGUNIT,'(/A,A/)') ' Input reflection file: ' , FNAME
C     Open reflection file for unformatted read
      CALL CCPDPN(LUN,FNAME,'READONLY','F',0,IFAIL)
C
C Set standard Parser delimiters for d*trek reflection files
      CALL PARSDL(' ',0,0)


C=====================================
C   PREPARATION FOR BATCH SPLITTING
C=====================================
C D*trek data so set DELPSI to IMPBAT*WIDINC unless DELPSI
C is defined in ABSURD input file
C No IMPBAT is retrived from the DTP_DTINTEGRATE_OPTIONS(11) header item but we
C cannot rely on this being present and therefore must have a default or a way
C around this.
C
C WIDINC is equal to the oscillation range for a single image whereas DELPSI
C is the width in PSI within which reflection are refined together in dtintegrate
C or is the user input value of how reflections should be batched using the SPLIT 
C option
C Whether we should BATCH according to WIDINC or DELPSI is debatable and should be
C checked. Here the default is to set the number of images per batch IMPBAT = 1
C such that DELPSI = WIDINC unless SPLIT option is used.
C
      IF(IMPBAT.LT.1) IMPBAT=1
C
C If Delpsi is not equal to zero then the SPLIT card has been used
C and we therefore use the SPLIT value of Delpsi otherwise we take
C the WIDINC value from the header and use this as the oscillation 
C range used to determine the BATCHing.
C N.B. We use DELPSI for reBATCHing and WIDINC and IMGNUM for the 
C TIME and RTIME calculation because we have to consider detector 
C dead time and each image exposure time.
C
      IF(DELPSI.EQ.0.0) THEN
         DELPSI=IMPBAT*WIDINC
      ELSE IF (DELPSI.LT.0.0) THEN
         WRITE(LOGUNIT,*)" Error in input DELPSI must be >= 0 "
         STOP
      END IF

C==================================================
C     START HANDLING THE INPUT REFLECTION FILE
C==================================================
      WRITE(LOGUNIT,'(A,A,A/)') 'Reading header of ',FNAME
     .      ,'to determine column positions.'
C
C     Initialise some values
      DO I = 1 , NHDKEYS
         HPOS(I)=-999
      END DO
C     CNT is .FALSE. before we start reading the list of column names
C     CNT is .TRUE.  when we find nH at the start of the list of coumn names
      CNT    = .FALSE.
      J      = 1
C
C==========================       :  Lifted from dtrek2mtz
C DETERMINE D*TREK COLUMNS
C==========================
      READ (LUN, '(A)') LINE
C
C See if there are 3 (pre-v7) or 4 (d*TREK v7 and higher) numbers on the line
C
      READ (LINE, *, IOSTAT=ISTAT) NUMINT, NUMFLT, NUMSTR, NUMCRY
      IF (0 .NE. ISTAT) THEN
         READ (LINE, *, IOSTAT=ISTAT) NUMINT, NUMFLT, NUMSTR
         NUMCRY = 0
      ENDIF
      IF (0 .NE. ISTAT) THEN
         GOTO 99
      ENDIF
C
C Read or skip crystal information lines. Save spacegroup and cell info
C
      DO I = 1, NUMCRY
         READ (LUN, '(A)') LINE
      END DO
C-=========================       :  End of 'lifted' code
C
C     Calculate number of items to read from header before reflection
C     list starts
      NHEADER = NUMINT + NUMFLT + NUMSTR + NUMCRY
C
      DO I = 1 , NHEADER
         READ(LUN,1001,END=90,ERR=95)LINE
         NTOK=-MAXTOK
         CALL PARSE(LINE,IBEG,IEND,ITYP,FVALUE,CVALUE,IDEC,NTOK)
         IF(NTOK.GT.0) THEN
            ITEM=LINE(IBEG(1):IEND(1))
            CALL CHKHDKEY(ITEM,HEAD,NHDKEYS,IHEAD)
C     
C     If we find nH and CNT = .FALSE. then initialise J
C     and set CNT = .TRUE. so that J gets incremented
C
            IF(IHEAD.GT.0) THEN
               IF(IHEAD.EQ.1.AND..NOT.CNT) THEN
                  CNT = .TRUE.
               END IF
C
C     If we have got to the list but something other that nH is the first
C
               IF(IHEAD.GT.1.AND..NOT.CNT) THEN
                  WRITE(LOGUNIT,'(A)')
     .    ' Error nH,nK,nL are not first three items in reflection list' 
                  STOP
               END IF
C     
C     Then we are somewhere in the list and we want to assign the column
C     number
               HPOS(IHEAD)=J
               WRITE(LOGUNIT,*)'Found ', HEAD(IHEAD), '  Position = ', J 
            END IF
         END IF
C     If we have found the list of column labels then increment position
C     in list of items
         IF(CNT) J = J + 1
      END DO
C
C     Quick check and warning printing
      DO I = 1 , NHDKEYS
         IF(HPOS(I).LT.0) THEN
            WRITE(LOGUNIT,'(A,A,A)') '!!! Warning: Item ',HEAD(I)
     .            ,' not found in reflection file !!!'
         END IF
      END DO

C=============================================
C  PREPARE LORENTZ & POLARIZATION CORRECTIONS 
C=============================================
C     Need to allow for presence of either combined Lorentz and Polarization
C     factor or individual correction factors.
C
      IF(HPOS(15).LT.0.AND.HPOS(16).GE.0.AND.HPOS(17).GE.0) THEN
         LPCALC = .TRUE.
         WRITE(LOGUNIT,'(/A,/A,/A/)')
     .      ' *** Lorentz and Polarization corrections *** ',
     .      'Lorentz and polarization correction factors are separate',
     .      'in reflection file so will be combined for output file'
      END IF
C=======================================================================
C     
C
      IF (SCALE.NE.1.0) THEN
         WRITE(LOGUNIT,'(A,F9.3))')
     .         'Reflection intensities will be scaled by ' , SCALE
      ENDIF

C========================================================================
C                            REFLECTION LOOP
C========================================================================
      WRITE(LOGUNIT,'(A/)')' Reading reflection list ...'
C
C     Write out header for list of rejected reflections
C
         WRITE(LOGUNIT,'(A/)') ' *** List of rejected reflections ***'
         WRITE(LOGUNIT,'(A)' ) '    Reduced     Original'
         WRITE(LOGUNIT,'(4A/)')'   H   K   L   H   K   L'
     .                                      ,'    XDET    XDETC '
     .                                      ,'    YDET    YDETC '
     .                                      ,'     PSI     PSIC '

C========================
C     START LOOP HERE
C========================
 1    READ(LUN,1001,END=90,ERR=95)LINE
 1001 FORMAT(A250)
C     
C     Divide line into tokens
      NTOK=-MAXTOK
      CALL PARSE(LINE,IBEG,IEND,ITYP,FVALUE,CVALUE,IDEC,NTOK)
      IF(NTOK.LE.0) GOTO 1

C=======================================================
C                *** MILLER INDICES ***
C=======================================================
      DO I = 1  , 3
         CALL GTPINT(HPOS(I),JHKL(I),NTOK,ITYP,FVALUE)
      END DO

C=======================================================
C                  *** ERROR FLAG ***
C=======================================================
      IF(HPOS(4).GE.0) THEN
C     BadFlag
         CALL GTPINT(HPOS(4),IERROR,NTOK,ITYP,FVALUE)
      ELSE IF(HPOS(5).GE.0) THEN
C     ErrorFlag
         CALL GTPINT(HPOS(5),IERROR,NTOK,ITYP,FVALUE)
      ELSE
C     If no flag then lets assume all is well (otherwise we have no data!)
         IERROR = 0
      END IF
C=======================================================
C              *** INTENSITY AND ITS ERROR ***
C=======================================================
      CALL GTPREA(HPOS(6),F2,NTOK,ITYP,FVALUE)
      CALL GTPREA(HPOS(7),SIGF2,NTOK,ITYP,FVALUE)
C
C=======================================================
C         *** REFLECTION 3-D POSITION (X,Y,PSI) ***
C=======================================================
C
C     This writes both observed and calculated positions 
C
      CALL GTPREA(HPOS(8),YDET,NTOK,ITYP,FVALUE)
      CALL GTPREA(HPOS(9),XDET,NTOK,ITYP,FVALUE)
      CALL GTPREA(HPOS(10),PSI,NTOK,ITYP,FVALUE)
      CALL GTPREA(HPOS(11),YDETC,NTOK,ITYP,FVALUE)
      CALL GTPREA(HPOS(12),XDETC,NTOK,ITYP,FVALUE)
      CALL GTPREA(HPOS(13),PSIC,NTOK,ITYP,FVALUE)
      CALL GTPREA(HPOS(14),RESO,NTOK,ITYP,FVALUE)
C=======================================================
C        *** LORENTZ & POLARIZATION FACTORS ***
C=======================================================
C     Such that
C     I(true) = POLARIZ * LORENTZ * I(obs)
C             =                LP * I(obs)
C
      IF(LPCALC) THEN
C     Separate in input
         CALL GTPREA(HPOS(16),LORENTZ,NTOK,ITYP,FVALUE)
         CALL GTPREA(HPOS(17),POLARIZ,NTOK,ITYP,FVALUE)
         LP = LORENTZ * POLARIZ
      ELSE
C     Combined in input
         CALL GTPREA(HPOS(15),LP,NTOK,ITYP,FVALUE)
      END IF
C=======================================================
C
C      CALL GTPREA(18,CORREL,NTOK,ITYP,FVALUE)

C*************************************************************
C This is not working any more since the output columns in
C D*TREK reflection files were changed (Somehwere around version 7.1)
C=======================================================
C             *** DIFFRACTION VECTORS ***
C=======================================================
C These are the incident and diffraction beam directions
C which are not required yet.
C      DO  I = 1 , 3
C         K = I + 17
C         CALL GTPREA(HPOS(K),SV(I) ,NTOK,ITYP,FVALUE)
C      END DO
C      DO I = 1 , 3
C         K = I + 20
C         CALL GTPREA(HPOS(K),S0V(I),NTOK,ITYP,FVALUE)
C      END DO
C*************************************************************

C=======================================================
C  COPY OVER MILLER INDICES
C=======================================================
      DO I = 1 , 3
         IHKL(I) = JHKL(I)
      END DO
C     
C Calculate a few things for this reflection.
C
C PSI value relative to starting PSI of data set
      PSIREL = PSI - PSIRNG(1)
C Calculate image number - 1
      IMGNUM = INT ( PSIREL / WIDINC ) + 1
C Find psi value of reflection from beginning of the IMGNUMth oscillation
      PSIREM = PSIREL - ( ( FLOAT(IMGNUM) - 1.0 ) * WIDINC )
C Now find TIME at which PSI excited accounting for detector readout
      RTIME = EXPRTIM0 + ( FLOAT(IMGNUM - 1) * ( TIMIMG + TIMDED) ) 
     .               + ( TIMIMG * ( PSIREM / WIDINC) )
C Now find TIME at which PSI excited accounting for detector readout
      TIME = EXPTIM0 + ( FLOAT(IMGNUM - 1) *   TIMIMG  ) 
     .               + ( TIMIMG * ( PSIREM / WIDINC) )
C Convert from secs to mins
C      TIME = TIME
C      RTIME = RTIME
C      write(LOGUNIT,*)"IMGNUM ",IMGNUM," PSIREL ",PSIREL," PSIREM ",PSIREM
C     .     ," TIME ",TIME
C      
      ISTAT=0
      GOTO 92
 90   ISTAT=-1
C     
C     End of file ?
 92   IF(ISTAT.LT.0) THEN
         GOTO 500
      ENDIF
C     
C     OK, we have a reflection
C
      NREF=NREF+1
      REJ=.FALSE.
C
C ******************
C Are we reindexing?
      IF (LRINDX) THEN
C     Yes, so determine new indices
         DO I = 1 , 3
            HKL(I)=IHKL(I)
         END DO
         CALL MATVEC(V,HKLMAT,HKL)
         CALL VSUM(V,V,HKLTRN)
C     We may now have fractional indices: such reflections are rejected
         DO  I = 1 , 3
            J = NINT(V(I))
            IF (ABS(V(I)-FLOAT(J)) .GT. 0.05) THEN
C     Reject
               NREJ5 = NREJ5 + 1
               GO TO 1
            ELSE
               IHKL(I) = J
            ENDIF
         ENDDO
      ENDIF
C End of reindexing section
C *************************
C
C
C Do some reality checks
C
C
C  WE DON'T USE PHI0 here any more (G Evans)
C
C     Record 1st psi value
C      IF(PSI0.LT.-999999.) THEN
C
C Set up initial for producing PHISTT and PSIEND if SPLIT option used
C         IF(DELPSI.GT.0)THEN
C            PSI0=PSIRNG(1)
C         END IF
C
C     Truncate downwards
C         IF(PSI.GE.0.0) THEN
C            PSI0=AINT(PSI)
C         ELSE
C            PSI0=AINT(PSI-1.0)
C         ENDIF
C      END IF
C
      PSIGRP(1,NGROUP) = MIN(PSIGRP(1,NGROUP),PSI)
      PSIGRP(2,NGROUP) = MAX(PSIGRP(2,NGROUP),PSI)
C=======================================================================
C
C     Check for detector limits
C      IF(LIMITS(1,1).GE.0) THEN
C Always check if Y,Z position lies within detector area
      IF   (
     .      YDET.LT.LIMDET(1,1).OR.
     .      YDET.GT.LIMDET(2,1).OR.
     .      XDET.LT.LIMDET(1,2).OR.
     .      XDET.GT.LIMDET(2,2)
     .      )     THEN
         NREJ3=NREJ3+1
         REJ=.TRUE.
         WRITE(LOGUNIT,'(6I4,6F9.2,A)')JHKL(1),JHKL(2),JHKL(3),IHKL(1)
     .         ,IHKL(2),IHKL(3),XDET,XDETC,YDET,YDETC,PSI,PSIC
     .         ,'det. limits'
      ENDIF
C     ENDIF
C=======================================================================
C
C     Check TOOFAR limits
C     
      IF ( PSI.LT.PSIRNG(1) ) THEN
         NREJ6 = NREJ6 + 1
         WRITE(LOGUNIT,'(3I5,2F10.3)')(IHKL(I),I=1,3),PSI
         REJ = .TRUE.
         WRITE(LOGUNIT,'(6I4,6F9.2,A)')JHKL(1),JHKL(2),JHKL(3),IHKL(1)
     .         ,IHKL(2),IHKL(3),XDET,XDETC,YDET,YDETC,PSI,PSIC
     .         ,'Out of PSI range'
      ENDIF
      IF(SHIFT(1).GE.0.0) THEN
         IF( ABS(YDET-YDETC) .GT. SHIFT(1).OR.
     .       ABS(XDET-XDETC) .GT. SHIFT(2).OR.
     .       ABS(PSI-PSIC)   .GT. SHIFT(3))     THEN
            NREJ4=NREJ4+1
            REJ=.TRUE.
         WRITE(LOGUNIT,'(6I4,6F9.2,A)')JHKL(1),JHKL(2),JHKL(3),IHKL(1)
     .         ,IHKL(2),IHKL(3),XDET,XDETC,YDET,YDETC,PSI,PSIC
     .         ,'Too far on X, Y or PSI'
         ENDIF
      ENDIF
C=======================================================================
C     
C     Count errors
C      I=IERROR
C      J=MASK
C      DO K = 1 , NBITS
C         II=I/2
C         JJ=J/2
C         III=I-2*II
C         JJJ=J-2*JJ
C         IF(III.EQ.1) LREJ(K)=LREJ(K)+1
C         IF((III*JJJ).EQ.1) REJ=.TRUE.
C         I=II
C         J=JJ
C      ENDDO
C=======================================================================
C
C....
C     Put reflection into asymmetric unit
      CALL ASUPUT(IHKL,JHKL,ISYM)
C=======================================================================
C
C
C
      IF(REJ) THEN
C     Reject reflection
         NREJ=NREJ+1
         GO TO 1
      ENDIF
C=======================================================================
C     
C     ***********************
C     Batch splitting section
C
C     If splitting into psi ranges (DELPSI>0), check if we want to start
C     a new batch
C     With d*trek option we will always do this because the data still
c     needs to
C     be scaled with SCALA afterwards so need BATCH information
C
      IF(DELPSI.GT.0.) THEN
C
C     NUMINC is the number of the psi range batch no. before adding to
C     IBATCH
         NUMINC = INT ( PSIREL / DELPSI )
         IF(NUMINC.LT.0) NUMINC=0
C
C     KBATCH is output batch number
         KBATCH = IBATCH + NUMINC
C         write(LOGUNIT,'(a9,i5,a10,i5)') 
C     +        'NUMINC = ', NUMINC , ' KBATCH = ' ,  KBATCH
C
C     J is the batch array index corresponding to KBATCH
         J = NUMINC + 1
C
C     If MBATCH is set, use it as a maximum batch number (default = 0)
         IF (MBATCH .GT. 0) THEN
            KBATCH = MIN ( KBATCH , MBATCH )
            NUMINC=KBATCH-IBATCH
         ENDIF
         MAXINC=MAX(MAXINC,NUMINC)
      ENDIF
C     End of Batch splitting section
C     ******************************
C=======================================================================
C     
C  Increment number of reflection in batch J
      NRFBCH(J)=NRFBCH(J)+1
C
C
C**** Absorption Correction code removed from here *****
C
C**** Obliquity Correction code removed from here *****
C
C=======================================================================
C For d*trek we now include the Lorentz-Polarisation factor
C     Store for output
      ODATA(1)  = JHKL(1)
      ODATA(2)  = JHKL(2)
      ODATA(3)  = JHKL(3)
      ODATA(4)  = ISYM
      ODATA(5)  = KBATCH
C
      ODATA(6)  = SCALE*F2
      ODATA(8)  = SCALE*F2
C     Don't allow zero sd's
      ODATA(7)  = MAX(SCALE*SIGF2,0.00001)
      ODATA(9)  = MAX(SCALE*SIGF2,0.00001)
      MAXINT    = MAX(MAXINT,NINT(ODATA(6)))
      ODATA(10) = IERROR
C
C     No TIME column output: This could be changed later
C
C     Here we decide what to put into the TIME column.
C     I will write RTIME to the TIME column here and TIME
C     into the RTIME (real time) column.
C
C      ODATA(11) = TIME
C      ODATA(12) = RTIME
C
      IF (PX0ROT) THEN
C     PX0ROT is .TRUE. => pixel0 is closest to rotation axis 
C     XDET == Xd == pixel1, YDET == Yd == pixel0
         ODATA(11) = XDET
         ODATA(12) = YDET
      ELSE
C     PX0ROT is .FALSE. => pixel1 is closest to rotation axis
C     so we switch XDET and YDET
C     XDET == Xd == pixel0, YDET == Yd == pixel1
         ODATA(11) = YDET
         ODATA(12) = XDET
      END IF
C
      ODATA(13) = PSI
      ODATA(14) = LP
C      ODATA(15) = LORENTZ
C      ODATA(16) = POLARIZ
C      ODATA(17) = SV(1)
C      ODATA(18) = SV(2)
C      ODATA(19) = SV(3)
C      ODATA(20) = S0V(1)
C      ODATA(21) = S0V(2)
C      ODATA(22) = S0V(3)
C
      CALL LWREFL(1,ODATA)
      NOUT=NOUT+1
C
C
C
      GO TO 1
C *** This is the end of the reflection loop ***
C=======================================================================
C
C     End of file, write out batch header & orientation if required
 500  CLOSE(UNIT=LUN)
      IF(NREJ.EQ.0) WRITE(LOGUNIT,'(A)')' ** None rejected **'
      WRITE(LOGUNIT,'(/A/)') ' *** End list of rejected reflections ***'
      WRITE(LOGUNIT,'(A/)')' Done reading reflection file.'
C     
      LBCHDR=.TRUE.
C=======================================================================
C
C     Calculate min and max values of PSI and TIME for each batch J
C     These will be written to BATCH headers of the mtzfile
C
      DO NUMINC = 0 , MAXINC
         J = NUMINC + 1
C     Calculate range of PSI
         PSIMIN(J) = PSIRNG(1) + ( DELPSI * NUMINC )
         PSIMAX(J) = PSIRNG(1) + ( DELPSI * J )
C     Calculate range of TIME
         TIMMIN(J) = EXPTIM0   + ( TIMIMG * NUMINC )
         TIMMAX(J) = EXPTIM0   + ( TIMIMG * J )
C     Calculate range of RTIME
         RTIMMIN(J) = EXPRTIM0 + ( ( TIMIMG + TIMDED ) * NUMINC )
         RTIMMAX(J) = EXPRTIM0 + ( ( TIMIMG + TIMDED ) * J )
      ENDDO
C     
C     We must calculate PSIRNG(2) (PSI at end of data set) again here
C     because with some image formats d*trek writes the SCAN_ROTATION
C     item with only the oscillation range for that image instead of
C     the range for the whole scan. This occurs notably with MAR data.
C      In any case it is easy to calculate here after we have BATCH
C     according to the PSI increment (WIDINC). We just set PSIRNG(2)
C     equal to the PSIMAX for the last BATCH.
C
C
      PSIRNG(2) = PSIMAX(MAXINC+1)
C=======================================================================
C     
C Write out some stuff to logfile
C
      WRITE(LOGUNIT,'(/A,F10.2)')
     .      ' Experimental real time at start (seconds): ', EXPTIM0
      WRITE(LOGUNIT,'(A,F10.2)') 
     .      '    Total exposure time at start (seconds): ', EXPRTIM0
      WRITE(LOGUNIT,'(A,F10.2)')
     .      '               Detector deadtime (seconds): ', TIMDED
      WRITE(LOGUNIT,'(A,F10.2)')
     .      '         Exposure time per image (seconds): ', TIMIMG
      WRITE(LOGUNIT,'(A,F10.2)')
     .      '        Anglular range per image (degrees): ', WIDINC
      WRITE(LOGUNIT,'(A,2F10.2/)')
     .      '      Anglular range of data set (degrees): ', PSIRNG(1) ,
     .      PSIRNG(2)
C=======================================================================
C
C     Reset default values of EXPRTIM0 and EXPTIM0 ready for
C     reading next file if there is one.
C
      EXPRTIM0 = RTIMMAX ( MAXINC + 1 )    
      EXPTIM0  = TIMMAX  ( MAXINC + 1 )
C
C     Write this information to the logfile
C     
      WRITE(LOGUNIT,'(A,F10.2)')
     .      ' Experimental real time at end   (seconds): ', EXPTIM0
      WRITE(LOGUNIT,'(A,F10.2/)')
     .      '    Total exposure time at end   (seconds): ', EXPRTIM0
C
C     Reset value of DELPSI
      DELPSI = 0.0
C
C
C     Output some information for this file
C
      WRITE(LOGUNIT,*)
     .      ' Total number of reflections rejected        : ',NREJ
      WRITE(LOGUNIT,*)
     .      ' Number rejected for frac indices            : ',NREJ5
      WRITE(LOGUNIT,*)
     .      ' Number of rejected for detector limits      : ',NREJ3
      WRITE(LOGUNIT,*)
     .      ' Number of rejected because too far          : ',NREJ4
      WRITE(LOGUNIT,*)
     .      ' Number rejected because outside psi range   : ',NREJ6
      WRITE(LOGUNIT,*)
     .      ' Number of reflections output                : ',NOUT
      RETURN
C=======================================================================
C     Error
 95   WRITE (LOGUNIT,'(/A,3I5)') ' ERROR READING REFLECTION FILE AT'
     .      ,JHKL
      CALL CCPERR(1,'Error in reflection file')
 99   WRITE (LOGUNIT,'(/A)')
     .      ' Invalid reflection file format: trouble reading header'
      CALL CCPERR(1,'Error in reflection file')
      END





