C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE PRTGRP
C     =================
C
C  Print group statistics, calculate average cell
C
      IMPLICIT NONE
C
C Storage for recording change of orientation etc during data collection
C  These variables apply to data between 2 successive Save sets in Madnes
C  output.
      INTEGER MAXGRP
      PARAMETER (MAXGRP=200)
C
      include 'grpdat.fh'
C
C Local
      INTEGER I,J,LASTBT,NAV,INDEX
      REAL AVCELL(6)
      SAVE /GRPDAT/
C
C
      IF (NGROUP .LE. 0) RETURN
C
      DO 1, I=1,6
         AVCELL(I) = 0.0
 1    CONTINUE
      NAV=0
C

      WRITE (6,6001)
 6001 FORMAT(1X,19('====')//
     .     ' Data set parameters as understood by ABSURD (no ',
     .     'correspondence with output batches) '//
     .     '  Crystal data (DelOri is crystal rotation from start)'//
     .'       Phi1   Phi2    a      b      c    alpha   beta  gamma',
     . '    Phix    Phiy    Phiz DelOri  Eps rmsCFD rmsDEG')
C       ffffffffFFFFFFFFffffffffFFFFFFffffffFFFFFFFfffffff     
C
      LASTBT=-1
      DO 10, J=1,NGROUP
         IF (PSIGRP(1,J) .LT. 9999.) THEN
C Put blank line between batch series
            IF (NBTGRP(J) .NE. LASTBT) THEN
               LASTBT = NBTGRP(J)
               WRITE(6, '(1X)')
            ENDIF
            WRITE(6,6002) J,(PSIGRP(I,J),I=1,2),(CELLGR(I,J),I=1,6),
     $           (RPHGRP(I,J),I=1,3),RANGLE(J),EPSGRP(J),
     $           (RMSGRP(I,J),I=1,2)
 6002       FORMAT(1X,I3,2F7.1,3F7.2,3F7.2,3F8.2,F6.2,F6.2,2F7.3)
C Sums for cell average
            DO 15, I=1,6
               AVCELL(I) = AVCELL(I) + CELLGR(I,J)
 15         CONTINUE
            NAV = NAV+1
         ENDIF
 10   CONTINUE
C
C Cell average
      IF (NAV .GT. 0) THEN
         DO 60, I=1,6
            AVCELL(I) = AVCELL(I)/FLOAT(NAV)
 60      CONTINUE
C
         WRITE (6,6060) AVCELL
 6060    FORMAT(/
     $ '           ===>   ',3F7.2,3F7.2,'  average cell dimensions'/
     $ '                   =========================================')
      ENDIF
C
      WRITE (6,6010)
 6010 FORMAT(/' Detector data'//
     $'       Phi1   Phi2   ccx   ccy   Dist   Tau1   Tau2   Tau3')
C      xiiifffffffFFFFFFFffffffFFFFFFfffffffFFFFFFFfffffffFFFFFFF
      LASTBT=-1
      DO 20, J=1,NGROUP
C Put blank line between batch series
         IF (NBTGRP(J) .NE. LASTBT) THEN
            LASTBT = NBTGRP(J)
            WRITE(6, '(1X)')
         ENDIF
         WRITE(6,6012) J,(PSIGRP(I,J),I=1,2),
     $        (DTOGRP(I,J),I=1,2),DXMGRP(J),(TAUGRP(I,J),I=1,3)
 6012    FORMAT(1X,I3,2F7.1,2F6.2,F7.1,3F7.2)
 20   CONTINUE
C
      WRITE (6,'(/)')
C Write average cell to output file
      INDEX=1
      CALL LWCELL(INDEX,AVCELL)
C
      RETURN
      END
