C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE RDREFL(LUN,
     . IHKL,F2,SIGF2,IERROR,YDET,ZDET,PSI,YDETC,ZDETC,PSIC,TIME,ISTAT)
C      ==============================================================
C
C Read one reflection from input file on stream LUN
C
C On entry:
C   ISTAT       reflection format type
C               = 1 or 2  Madnes format 1 or 2 (INTOPT
C               = 0 an old file type similar to INTOPT 1
C
C On exit:
C   IHKL(3)     indices
C   F2          intensity
C   SIGF2       standard deviation
C   IERROR      error flag
C   YDET, ZDET  detector coordinates
C   PSI                 rotation angle (degrees)
C   YDETC, ZDETC  calculated detector coordinates
C   PSIC                calculated rotation angle (degrees)
C   TIME        time in minutes
C   ISTAT       = 0  OK
C               = -1 end of file
C               = +1 format error, probably Save data found
C
      IMPLICIT NONE
C
      INTEGER LUN,IHKL(3),IERROR,ISTAT
      REAL F,F2,SIGF2,YDET,ZDET,PSI,TIME,YDETC,ZDETC,PSIC
C
C
C
      include 'madsav.fh'
      SAVE /MADSAV/
C
C
1     IF(ISTAT.LE.1) THEN
C 'Standard' Madnes output, INTOPT= 0 or 1, F's in file
C
         IF (INTOPT .EQ. 1) THEN
            READ(LUN,1001,END=90,ERR=95)
     .           IHKL,F,SIGF2,IERROR,YDET,ZDET,PSI,
     .           YDETC,ZDETC,PSIC,TIME
 1001       FORMAT(3I5,2F9.2,18X,I6,15X,2F6.1,F9.3,6X,
     .           F6.1,F6.1,F9.3,6X,F9.3)
         ELSE
            READ(LUN,1003,END=90,ERR=95)
     .           IHKL,F,SIGF2,IERROR,YDET,ZDET,PSI,
     .           YDETC,ZDETC,PSIC,TIME
 1003       FORMAT(3I5,2F9.2,18X,I6,15X,2F6.1,F9.3,6X,
     .           2F4.0,F9.3,6X,F9.3)
         ENDIF
C
C   Get intensity from F
         SIGF2=2.*F*SIGF2
         F2=F*F
         IF(F.LT.0.) THEN
            F2=-F2
            SIGF2=-SIGF2
         ENDIF
      ELSE
C INTOPT 2 format, intensities in file
            READ(LUN,1002,END=90,ERR=95)
     .           IHKL,F2,SIGF2,IERROR,YDET,ZDET,PSI,
     .                                 YDETC,ZDETC,PSIC,TIME
1002      FORMAT(3I5,2F9.0,18X,I6,2F6.1,F9.3,6X,
     .                                 F6.1,F6.1,F9.3,6X,F9.3)
      ENDIF
C Trap for blank line
      IF(SIGF2.EQ.0.0) GO TO 1
C Trap for hkl = 0,0,0
      IF (IHKL(1) .EQ. 0 .AND. IHKL(2) .EQ. 0 .AND.
     $     IHKL(3) .EQ. 0) THEN
         CALL CCPERR(1,' *** h = k = l = 0 ***')
      ENDIF
C Convert time to minutes
      TIME=TIME*60.0
      ISTAT=0
      RETURN
C
C End of file
90    ISTAT=-1
      RETURN
C
C Error
95    ISTAT=1
      RETURN
      END
