C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
        SUBROUTINE REDTRE(FNAME,HNAME,BTITLE)
C       =======================================================
C
C     Read in D*TREK header and reflection file.
C     Modified from REMADN subroutine to accomodate d*trek files.
C     G.Evans. 4th November 1998
C
      IMPLICIT NONE
C
C     Variable declaration
      CHARACTER FNAME*80,HNAME*80
      CHARACTER*(*) BTITLE
      INTEGER IFAIL,ISTAT
C     Commons
      INTEGER NBITS
      PARAMETER (NBITS=16)
C
      include 'flags.fh'
      include 'batch.fh'
      include 'cbatch.fh'
C Common block created for REMADN and REDTRE subroutines
C
      include 'subcom.fh'
C
      LOGICAL LABSFT
C
C     Set a logical
C
      LABSFT = .TRUE.
C
C Read d*trek header file
C
      IFAIL=0
C     Open header file for unformatted read
      CALL CCPDPN(1,HNAME,'READONLY','F',0,IFAIL)
C  Read header information
      ISTAT=0
C
      WRITE(6,'(/A,A)') ' d*trek header file : ' , HNAME
C
      CALL READHD(1,ISTAT,HNAME)
C      WRITE(6,*)' Back from READHD .....'
C      IF(ISTAT.GT.0) THEN
C    End-of-file in read save data (shouldn't happen)
C         GO TO 2
      IF(ISTAT.LT.0) THEN
C     No save data found, presumably reflection data: OK if not first
c     file
C     in batch
         IF(NEWBCH) WRITE(6,1101)
 1101    FORMAT(/
     .       ' **** !!! WARNING: this file does not contain ',
     .       'the relevant header data !!! ****'/
     .       '          Orientation data from previous input file',
     .       ' will be used'//)
         REWIND 1
      ELSE
C     
C     Convert Madnes header information into the form required by this
C     program, and for orientation block in MTZ file
         CALL MKORDTR(OCELL)
         LORIENT=.TRUE.
      ENDIF
C     
C     Finish reading header information
C     
C     We must have orientation data before proceeding
      IF(.NOT.LORIENT) THEN
         WRITE(6,1121)
 1121    FORMAT(//
     .       ' **** No orientation (Save) data has been found ****'/
     .       '      This must be present in at least the first 
     .    input file'//)
         CALL CCPERR(1,'No orientation data')
      ENDIF
C
C     Close header file!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
      CLOSE(1)
C   Don't now how to yet!!!
C
C
C**** Absorption Correction code removed from here *****
C
C**** Obliquity Correction code removed from here *****
C
C
      IF(LFIRST) THEN
C     
C     Open output MTZ file on first input file only
C         WRITE(6,*)' Opening output mtzfile....'
 9988    FORMAT(6f8.2)
         CALL OPNDTR(TITLE,OCELL)
         FOPEN=.TRUE.
         CALL INIHDR(JCRYST)
      ENDIF
      LFIRST=.FALSE.
C
      LTITLE=BTITLE
C
C     Read and process d*trek reflection file
C
      CALL PRCDTR(2,FNAME)
      NEWBCH=.FALSE.
C
      RETURN
C
      END
