C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE ROTMAT(ANG, MAT)
C     ===========================
C
C     FORMS ROTATION MATRIX MAT FROM THE THREE ANGLES ANG(1),
C     ANG(2), AND ANG(3) (IN THAT ORDER, ANGLES IN DEGREES).
C     10-JUL-81 WSB
C
      IMPLICIT NONE
C
      REAL DG2RD
      PARAMETER (DG2RD = 3.1415926 / 180.0)
      REAL ANG(3), MAT(3,3), C(3), S(3)
      INTEGER I
C
      DO 100 I = 1, 3
         C(I) = COS(ANG(I) * DG2RD)
         S(I) = SIN(ANG(I) * DG2RD)
100   CONTINUE
      MAT(1,1) =  C(2) * C(3)
      MAT(1,2) = -C(1) * S(3)  +  S(1) * S(2) * C(3)
      MAT(1,3) =  S(1) * S(3)  +  C(1) * S(2) * C(3)
      MAT(2,1) =  C(2) * S(3)
      MAT(2,2) =  C(1) * C(3)  +  S(1) * S(2) * S(3)
      MAT(2,3) = -S(1) * C(3)  +  C(1) * S(2) * S(3)
      MAT(3,1) = -S(2)
      MAT(3,2) =  S(1) * C(2)
      MAT(3,3) =  C(1) * C(2)
      RETURN
      END
