C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE UMATCL(CELL, VOL, AMAT, UMRC)
C
      IMPLICIT NONE
C
      REAL AMRC(3, 3), AMAT(3, 3), TCELL(6), CELL(6), TSIN(3), TCOS(3)
      REAL AORIEN(3, 3), UDENZO(3, 3), AOINV(3, 3), UMRC(3, 3)
      REAL  A13, TAS, A33, DET, VOL, WAVE1
      INTEGER  L , I
      INTEGER LUNSTO, LUNOUT
C
C     Common for passing through to mkordenz
C
C     the B orthogonalization matrix is calulated here
      include 'matrcs.fh'
      SAVE /MATRCS_R/, /MATRCS_I/
C
      EXTERNAL LUNSTO, MATMUL
C
C
      LUNOUT = 6
C                 now, change the orientation matrix to the mrc convention:
      DO 10 L = 1, 3
        AMRC(1, L) = AMAT(3, L)
        AMRC(2, L) = AMAT(1, L)
        AMRC(3, L) = AMAT(2, L)
   10 CONTINUE
c
      WRITE(LUNOUT,'(/,1x,A,$)')
     .  'AMRC matrix                             : '
      write(LUNOUT,'(    3F10.5)') (AMRC(1,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AMRC(2,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5,/)') (AMRC(3,I),I=1,3)
C
      CALL CAMATC(AMAT, CELL, TCELL, TSIN, TCOS)
      WRITE(LUNOUT,'(1x,A,$)')
     .  'DENZO real cell                         : '
      write(LUNOUT,'(6F9.3)') CELL
      WRITE(LUNOUT,'(1x,A,$)')
     .  'DENZO reciprocal cell                   : '
      write(LUNOUT,'(3F9.6,3F9.3,/)') TCELL
c
C     DENZO orthogonalisation matrix
      AORIEN(1, 1) = TCELL(1)*TSIN(3)
      AORIEN(2, 1) = TCELL(1)*TCOS(3)
      AORIEN(3, 1) = 0.
      AORIEN(1, 2) = 0.
      AORIEN(2, 2) = TCELL(2)
      AORIEN(3, 2) = 0.
      A13 = (TCOS(2)-TCOS(3)*TCOS(1))/TSIN(3)
      AORIEN(1, 3) = TCELL(3)*A13
      AORIEN(2, 3) = TCELL(3)*TCOS(1)
      TAS = TSIN(1)**2 - A13**2
      IF (TAS.LE.0.) CALL CCPERR(1, 'TAS.LE.0. in UMATCL')
      A33 = SQRT(TAS)
      AORIEN(3, 3) = TCELL(3)*A33
c
      CALL MINV3(AOINV, AORIEN, DET)
c
      WRITE(LUNOUT,'(1x,A,$)')
     .  'DENZO aorien matrix                     : '
      write(LUNOUT,'(    3F10.5)') (AORIEN(1,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AORIEN(2,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AORIEN(3,I),I=1,3)
      WRITE(LUNOUT,'(1x,A,$)')
     .  'DENZO aorien**-1 matrix                 : '
      write(LUNOUT,'(    3F10.5)') (AOINV(1,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AOINV(2,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AOINV(3,I),I=1,3)
      WRITE(LUNOUT,'(1x,A,$)')
     .  'Determinant                             : '
      WRITE (LUNOUT,'(F10.5,/)') DET
c
      VOL = 1./DET
C     A=BC
      CALL MATMUL(UDENZO, AMAT, AOINV)
      CALL MINV3(AOINV, UDENZO, DET)
c
      WRITE(LUNOUT,'(1x,A,$)')
     .  'DENZO umat matrix                       : '
      write(LUNOUT,'(    3F10.5)') (UDENZO(1,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (UDENZO(2,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (UDENZO(3,I),I=1,3)
      WRITE(LUNOUT,'(1x,A,$)')
     .  'DENZO umat**-1 matrix                   : '
      write(LUNOUT,'(    3F10.5)') (AOINV(1,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AOINV(2,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AOINV(3,I),I=1,3)
      WRITE(LUNOUT,'(1x,A,$)')
     .  'Determinant                             : '
      WRITE (LUNOUT,'(F10.5,/)') DET
C
C     =====================
C     Mosflm stuff:
C     =====================
c
C     Put WAVE = 1.0
      WAVE1 = 1.0
c
C     MOSFLM orthogonalisation matrix
      CALL BMATRX(B, CELL, TCELL, WAVE1)
      CALL MINV3(AOINV, B, DET)
c
      WRITE(LUNOUT,'(1x,A,$)')
     .  'Mosflm B matrix                         : '
      write(LUNOUT,'(    3F10.5)') (B(1,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (B(2,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (B(3,I),I=1,3)
      WRITE(LUNOUT,'(1x,A,$)')
     .  'Mosflm B**-1 matrix                     : '
      write(LUNOUT,'(    3F10.5)') (AOINV(1,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AOINV(2,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AOINV(3,I),I=1,3)
      WRITE(LUNOUT,'(1x,A,$)')
     .  'Determinant                             : '
      WRITE (LUNOUT,'(F10.5,/)') DET
C
      CALL MATMUL(UMRC, AMRC, AOINV)
      CALL MINV3(AOINV, UMRC, DET)
c
      WRITE(LUNOUT,'(1x,A,$)')
     .  'Mosflm umat matrix                      : '
      write(LUNOUT,'(    3F10.5)') (UMRC(1,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (UMRC(2,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (UMRC(3,I),I=1,3)
      WRITE(LUNOUT,'(1x,A,$)')
     .  'Mosflm umat**-1 matrix                  : '
      write(LUNOUT,'(    3F10.5)') (AOINV(1,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AOINV(2,I),I=1,3)
      write(LUNOUT,'(43x,3F10.5)') (AOINV(3,I),I=1,3)
      WRITE(LUNOUT,'(1x,A,$)')
     .  'Determinant                             : '
      WRITE (LUNOUT,'(F10.5,/)') DET
c
      RETURN
      END
