C
C     ECALC
C     Copyright (C) 1992 Ian Tickle
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
      PROGRAM ECALC
C==== CALC NORMALISED STRUCTURE FACTORS AND GRAPH F V. S.
C
C Modified 8/10/92 to include calculation of Fourier coefficients for
C origin removed isomorphous difference Pattersons, using F^2 and E^2 terms
C Laurence Pearl U.C.L.
C
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER MCOLS,MSYM
      PARAMETER (MCOLS=500,MSYM=192)
C
C     .. Scalars in Common ..
      CHARACTER TI1*70, GRAFLAB*42
      INTEGER LO,MQ,NCOL,NSYMP,NLPRGI,NW
      REAL DEL,FPHMAX,FPMAX,RM,SCALE,SIGH,SIGP
C     ..
C     .. Arrays in Common ..
      INTEGER IS,LOOKUP
      REAL CELL
C     ..
C     .. Local Scalars ..
C      CHARACTER*1 BL*1,HO*1,PL*1,TI2*70,ERRMSG*600
      CHARACTER*1 TI2*70,ERRMSG*600
      LOGICAL EOF
      INTEGER I,IC,IFLG,IG,J,K,KE,KQ,M,MR,N,NEAT,NECT,NQ,NR,NZ,NT,
     + NREAD,NSIGFP,NFPMAX,NSIGFPH,NFPHMAX,NTOOBIG,NNEG
      REAL CF,CFA,CFC,DQ,E,EF,EM,F,FF,FF1,FM,FPH,R1,R2,Q,QM,S,SMAX,
     &SMIN,SP,SPH,SQ,T,TFA,TFC
C     ..
C     .. Local Arrays ..
C      CHARACTER G(100)*100
      INTEGER ID(3),IE(3),NF(100),NE(3001),NEA(3001),NEC(3001),
     &NEP(0:7)
      REAL AA(MCOLS),CC(4),SE(100),SE2(100),SEA(9),SEC(9),SF(100),
     &SFS(100),SEP(0:7,2),TEA(9),TEC(9),TEH(9)
      LOGICAL LOGMSS(MCOLS),LSIGM,LCENT
C     ..
C     .. External Functions ..
      REAL FSPLIN
      EXTERNAL FSPLIN
C     ..
C     .. External Routines ..
      EXTERNAL CCPERR,CCPFYP,CCPRCS,EQUAL_MAGIC,GENEQ,GETINP,LRREFF,
     +         LRREFL,LRREFM,LRREWD,LWCLOS,LWREFL,MULEPS
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,IABS,INT,EXP,MAX,MIN,MOD,NINT,REAL,SQRT
C     ..
C     .. Common blocks ..
      COMMON /INCOML/ LSIGM,LCENT
      COMMON /INCOMC/ TI1,GRAFLAB
      COMMON /INCOM/ LO,MQ,NSYMP,NLPRGI,NW,RM,IS(3,3,MSYM),
     +               LOOKUP(MCOLS),
     +               CELL(6),NCOL,SCALE,SIGP,SIGH,DEL,FPMAX,FPHMAX
C     ..
C     .. Data statements ..
C      DATA BL,HO,PL /' ','O','+'/, G /100*' '/
      DATA TI2 /'Produced by E calculation program'/
      DATA NF,NE,NEA,NEC,NEP /9111*0/
      DATA SEC,SEA,SF,SE,SE2,SEP /334*0./
      DATA TEA /.886, 1., 1.329, 2.0,  3.323,  6.0,  .736, 1.0,   2./
      DATA TEC /.798, 1., 1.596, 3.0,  6.383, 15.0,  .968, 2.0,   8./
      DATA TEH /.718, 1., 1.916, 4.5, 12.260, 37.5, 1.145, 3.5,  26./
C     ..
C
      CALL CCPFYP
      CALL CCPRCS(6,'ECALC','$Date: 2005/09/06 11:25:12 $')
      KE = 0
      CALL GETINP(KE)
      IF (KE.GT.0) CALL CCPERR(1,'****** ERROR(S) IN INPUT')
C
      SMIN = 100.
      SMAX = 0.
      FM = 0.
      MR = 0
      NR = 0
C
30    CONTINUE
      F = 0.0
      FPH = 0.0
      SP  = 0.0
      SPH = 0.0
      CALL LRREFF(1,S,AA,EOF)
      IF (EOF) GOTO 80
C   Omit centrics for Ano diffs
        ID(1) = NINT(AA(1))
        ID(2) = NINT(AA(2))
        ID(3) = NINT(AA(3))
        CALL CENTR(ID,IC)
        IF(.NOT.LCENT. AND. IC.EQ.1) GO TO 30
      CALL LRREFM(1,LOGMSS)
C note you may have FP and not SIGFP if it is a calculated F
      IF (LOOKUP(4).GT.0 .AND. LOOKUP(5).GT.0) THEN
       IF (LOGMSS(4) .OR. LOGMSS(5)) THEN
           IF (.NOT.(LOGMSS(4) .AND. LOGMSS(5))) WRITE (6,'(/,A,/,A,/)')
     .    ' *** WARNING: either FP/SIGFP=MNF but other is not.',
     .    ' This must mean that the column pair is inconsistent ***'
         GO TO 30
       ENDIF
       IF (LOOKUP(5).GT.0 )THEN
          IF(AA(5).LE.0 .OR. ABS(AA(4)) .LT. SIGP*AA(5)) GOTO 30
          SP  = AA(5)
       END IF 
       F = AA(4)
          IF(FPMAX.GT.0 .AND.  ABS(AA(4)) .GT. FPMAX) GOTO 30
      ENDIF
C
C  Consider case of isomorphous diff FP and FHP ( or F+ and F-) 
C
      IF (NLPRGI.EQ.7) THEN
        IF (LOGMSS(6) .OR. LOGMSS(7)) THEN
            IF (.NOT.(LOGMSS(6) .AND. LOGMSS(7))) WRITE(6,'(/,A,/,A,/)')
     .      ' *** WARNING: either FPH/SIGFPH=MNF but other is not.',
     .      ' This must mean that the column pair is inconsistent ***'
          GO TO 30
        ENDIF
        IF (LOOKUP(7).GT.0 )THEN
          IF(AA(7).LE.0 .OR. ABS(AA(6)) .LT. SIGH*AA(7)) GOTO 30
          SPH = AA(7)
        END IF
        IF(FPHMAX.GT.0 .AND.  ABS(AA(6)) .GT. FPHMAX) GOTO 30
        FPH = AA(6)
        IF(.NOT.LSIGM) F = ABS(FPH-F)
        IF(LSIGM) F = SQRT(MAX((FPH-F)**2-SP**2-SPH**2,0.))
        IF( DEL.GT.0 .AND. F .GT. DEL) GO TO 30
      ENDIF
C
C   Is DANO set?
C
      IF (NLPRGI.EQ.9) THEN
        IF (LOGMSS(8) .OR. LOGMSS(9)) THEN
            IF (.NOT.(LOGMSS(8) .AND. LOGMSS(9))) WRITE(6,'(/,A,/,A,/)')
     .      ' *** WARNING: either DPH/SIGDPH=MNF but other is not.',
     .      ' This must mean that the column pair is inconsistent ***'
          GO TO 30
        ENDIF
        F = AA(8)
      ENDIF
C       Now take absolute value of F
        F = ABS(F)
        IF(LSIGM) F = SQRT(MAX(F**2-AA(9)**2,0.0))
         IF( DEL.GT.0 .AND. F .GT. DEL) GO TO 30
C
C==== Re-instate SMIN & SMAX, use of LRRSOL won't work, because it's the
C==== limits for the column that's required, not the overall limits !
C
      SMIN = MIN(SMIN,S)
      SMAX = MAX(SMAX,S)
      FM = MAX(FM,F)
      NR = NR + 1
      IF (S.LE.RM) MR = MR + 1
      GOTO 30
C
80    CALL LRREWD(1)
      R1 = 1./SQRT(MAX(SMIN,0.999999E-6))
      R2 = 1./SQRT(SMAX)
      WRITE (6,'(/,A)') 
     &   ' $TEXT:Number and range of reflections: $$ comment $$ '
      WRITE (6,'(I8,A,F10.0,//,A,2F10.4,5X,A,2F10.3)')
     &NR,' REFLNS (Excluding missing ones),  MAX F =',FM,
     &' MIN, MAX S =',SMIN,SMAX,'RESOLUTION LIMITS =',R1,R2
      WRITE (6,'(A,/)') ' $$'
C
      SMAX = MIN(RM,SMAX)
      NREAD = 0
      NSIGFP = 0
      NFPMAX = 0
      NSIGFPH = 0
      NFPHMAX = 0
      NTOOBIG = 0
      NNEG = 0
      NQ = MIN(MAX((MR+MQ/2)/MQ,1),100)
      QM = SMIN*SQRT(ABS(SMIN))
      DQ = (SMAX*SQRT(ABS(SMAX))-QM)/NQ
C      FM = .01*FM
C      SM = .01*(SMAX-SMIN)
C
C
50    CONTINUE
      F = 0.0
      FPH = 0.0
      SP  = 0.0
      SPH = 0.0
      CALL LRREFF(1,S,AA,EOF)
      IF (EOF) GOTO 60
      IF (S.GT.RM) GOTO 50
      ID(1) = NINT(AA(1))
      ID(2) = NINT(AA(2))
      ID(3) = NINT(AA(3))
        CALL CENTR(ID,IC)
        IF(.NOT.LCENT .AND. IC.EQ.1) GO TO 50
       NREAD = NREAD + 1
      CALL LRREFM(1,LOGMSS)
      IF(LOOKUP(4).GT.0 ) THEN
       IF(LOGMSS(4) ) GOTO 50
       IF (LOOKUP(5).GT.0 )THEN
         IF(AA(5).LE.0 .OR. ABS(AA(4)) .LT. SIGP*AA(5))  THEN
           NSIGFP = NSIGFP+1
           GOTO 50
         END IF
         SP  = AA(5)
       END IF
       F = AA(4)
          IF(FPMAX.GT.0 .AND.  ABS(AA(4)) .GT. FPMAX) THEN
             NFPMAX = NFPMAX + 1
             write(6,'(A,3i4,2f10.1,5x,f10.1)') 
     +              ' FP  too large:',id,aa(4),aa(5),fpmax
             GOTO 50
          END IF
      END IF
C
      IF (NLPRGI.EQ.7) THEN
        IF(LOGMSS(6) ) GOTO 50
        IF (LOOKUP(7).GT.0 )THEN
          IF(LOGMSS(7) ) GOTO 50
            IF(AA(7).LE.0 .OR. ABS(AA(6)) .LT. SIGH*AA(7)) THEN
               NSIGFPH=NSIGFPH + 1
               GOTO 50
            END IF
          SPH = AA(7)
        END IF 
        FPH = AA(6)
          IF(FPHMAX.GT.0 .AND.  ABS(AA(6)) .GT. FPHMAX)  THEN
             NFPHMAX = NFPHMAX + 1
             write(6,'(A,3i4,2f10.1,5x,f10.1)') 
     +            ' FPH too large:',id,aa(4),aa(5),fphmax
             GOTO 50
          END IF
C       Now take absolute value of F, either true difference, or diff corrected for Sigma
        IF(.NOT.LSIGM) F = ABS(FPH-F)
        IF(LSIGM) THEN
          IF( ( (FPH-F)**2-SP**2-SPH**2 ) .LE. 0.0) NNEG = NNEG + 1
          F = SQRT(MAX((FPH-F)**2-SP**2-SPH**2,0.))
        END IF
        IF( DEL.GT.0 .AND. F .GT. DEL) THEN
             NTOOBIG = NTOOBIG + 1
             IF(.NOT.LSIGM)write(6,'(A,3i4,4f10.1,f12.1,5x,f10.1)') 
     +     ' Diff too large:',id,aa(4),aa(5),aa(6),aa(7),f,del
             IF(LSIGM)write(6,'(A,3i4,4f10.1,f12.1,5x,f10.1)') 
     +     ' Modified diff too large:',id,aa(4),aa(5),aa(6),aa(7),f,del
             GOTO 50
        END IF
      ENDIF
C
      IF (NLPRGI.EQ.9) THEN
        IF(LOGMSS(8) ) GOTO 50
         IF (LOOKUP(9).GT.0 .AND.LOGMSS(9) ) GOTO 50
        F = ABS(AA(8))
C       Now take absolute value of F
        F = ABS(F)
        IF(LSIGM) F = SQRT(MAX( F**2-AA(9)**2, 0.0))
        IF(LSIGM) THEN
          IF( ( F**2-AA(9)**2) .LE. 0.0) NNEG = NNEG + 1
          F = SQRT(MAX((FPH-F)**2-SP**2-SPH**2,0.))
        END IF
        IF( DEL.GT.0 .AND. F .GT. DEL) THEN
             NTOOBIG = NTOOBIG + 1
             IF(.NOT.LSIGM) write(6,'(A,3i4,2f10.1,5x,f10.1)') 
     +            ' Ano Diff too large:',id,aa(8),aa(9),del
             IF(LSIGM) write(6,'(A,3i4,2f10.1,f12.1,5x,f10.1)') 
     +            ' Mod Ano Diff too large:',id,aa(8),aa(9), f, del
             GOTO 50
        END IF
      ENDIF
C
C
C
      CALL MULEPS(ID,M,E)
      Q = S*SQRT(ABS(S))
      I = MIN(INT((Q-QM)/DQ)+1,NQ)
      NF(I) = NF(I) + M
      SF(I) = SF(I) + M*F*F/E
      GOTO 50
C
60    CONTINUE
       write(6,'(a,5g15.5)')' checking del sigp sigh sigcut',
     +  del,sigp,sigh,fpmax,fphmax
      WRITE(6,'(///,7(/,A,I8))') 
     + ' Number of reflections considered            :',NREAD,
     + ' Number of reflections rejected (> DEL)      :',NTOOBIG,
     + ' Number of reflections rejected (Mod DEL < 0):',NNEG,
     + ' Number of reflections rejected (FP<SIGCUT)  :',NSIGFP,
     + ' Number of reflections rejected (FP>FPMAX)   :',NFPMAX,
     + ' Number of reflections rejected (FPH<SIGCUT) :',NSIGFPH,
     + ' Number of reflections rejected (FPH>FPHMAX) :',NFPHMAX
      CALL LRREWD(1)
      DO 55 I=1,NQ
55      IF (NF(I).GT.0) SF(I) = SF(I)/NF(I)
      SFS(1) = .45*SF(1) + .55*SF(2)
      SFS(NQ) = .45*SF(NQ) + .55*SF(NQ-1)
      DO 56 I=2,NQ-1
56      SFS(I) = .4*SF(I) + .3*(SF(I-1) + SF(I+1))
C
      KQ = 0
      SQ = QM + .5*DQ
      NEAT = 0
      NECT = 0
C
100   CONTINUE
      F = 0.0
      FPH = 0.0
      SP  = 0.0
      SPH = 0.0
      CALL LRREFF(1,S,AA,EOF)
      IF (EOF) GOTO 110
      IF (S.GT.RM) GOTO 100
      ID(1) = NINT(AA(1))
      ID(2) = NINT(AA(2))
      ID(3) = NINT(AA(3))
        CALL CENTR(ID,IC)
        IF(.NOT.LCENT .AND. IC.EQ.1) GO TO 100
      CALL LRREFM(1,LOGMSS)
      IF (LOOKUP(4).GT.0 )THEN
       IF(LOGMSS(4) ) GOTO 100
       IF (LOOKUP(5).GT.0 )THEN
         IF(LOGMSS(5) ) GOTO 100
         IF(AA(5).LE.0 .OR. ABS(AA(4)) .LT. SIGP*AA(5)) GOTO 100
         SP  = AA(5)
       END IF 
       DO 105 I=1,3
105      ID(I) = NINT(AA(I))
       F = AA(4)
          IF(FPMAX.GT.0 .AND.  ABS(AA(4)) .GT. FPMAX) GOTO 100
      END IF 
C
      IF (NLPRGI.EQ.7) THEN
        IF(LOGMSS(6) ) GOTO 100
        IF (LOOKUP(7).GT.0 )THEN
          IF(LOGMSS(7) ) GOTO 100
          IF(AA(7).LE.0 .OR. ABS(AA(6)) .LT. SIGH*AA(7)) GOTO 100
          SPH = AA(7)
        END IF 
        FPH = AA(6)
        IF(FPHMAX.GT.0 .AND.  ABS(AA(6)) .GT. FPHMAX) GOTO 100
        IF(.NOT.LSIGM) F = ABS(FPH-F)
        IF(LSIGM) F = SQRT(MAX((FPH-F)**2-SP**2-SPH**2,0.))
        IF( DEL.GT.0 .AND. F .GT. DEL) GO TO 100
      ENDIF
C
      IF (NLPRGI.EQ.9) THEN
        IF(LOGMSS(8) ) GOTO 100
         IF (LOOKUP(9).GT.0 .AND.LOGMSS(9) ) GOTO 100
        F = ABS(AA(8))
      ENDIF
C       Now take absolute value of F
        F = ABS(F)
        IF(LSIGM) F = SQRT(MAX( F**2-AA(9)**2, 0.0))
        IF( DEL.GT.0 .AND. F .GT. DEL) GO TO 100
C
C
C
C      I = MAX(MIN(INT((S-SMIN)/SM),99),0) + 1
C      J = MAX(MIN(INT(F/FM),99),0) + 1
C      G(J)(I:I) = HO
C
      Q = S*SQRT(ABS(S))
      CALL MULEPS(ID,M,E)
C
      IC = 1
      IF (NSYMP.GT.1) THEN
        CALL GENEQ(IS,ID,IE)
        I = 1048576*IE(1) + 1024*IE(2) + IE(3)
        DO 130 IG=2,NSYMP
          CALL GENEQ(IS(1,1,IG),ID,IE)
          IC = I + 1048576*IE(1) + 1024*IE(2) + IE(3)
130       IF (IC.EQ.0) GOTO 140
      ENDIF
C
140   EF = E*FSPLIN(Q,SQ,DQ,SFS,NQ,KQ,CC)
      FF = F*F/EF
      F = SQRT(ABS(FF))
      FF1 = ABS(FF-1.)
C
      I = MIN(INT((Q-QM)/DQ)+1,NQ)
      SE(I) = SE(I) + M*(FF-1.)
      SE2(I) = SE2(I) + M*FF1**2
      I = MIN(INT(1000.*F+.5),3000) + 1
      NE(I) = NE(I) + 1
      IF (IC.NE.0) THEN
        NEA(I) = NEA(I) + 1
      ELSE
        NEC(I) = NEC(I) + 1
      ENDIF
C
      I = 4*MOD(IABS(ID(1)),2) + 2*MOD(IABS(ID(2)),2) +
     &MOD(IABS(ID(3)),2)
      SEP(I,1) = SEP(I,1) + M*FF
      SEP(I,2) = SEP(I,2) + M*FF1**2
      NEP(I) = NEP(I) + M
C
      IF (IC.NE.0) THEN
        DO 150 I=1,6
150       SEA(I) = SEA(I) + M*F**I
        DO 310 I=7,9
310       SEA(I) = SEA(I) + M*FF1**(I-6)
        NEAT = NEAT + M
      ELSE
        DO 170 I=1,6
170       SEC(I) = SEC(I) + M*F**I
        DO 320 I=7,9
320       SEC(I) = SEC(I) + M*FF1**(I-6)
        NECT = NECT + M
      ENDIF
      GOTO 100
C
110   CALL LRREWD(1)
      WRITE (6,'(///,A,A,/)')
     &'    SHELL   NO OF REFLS   RESOLUTION    MEAN DSTAR^3',
     &'     MEAN F^2    SMOOTHED F^2    MEAN E^2-1     MEAN(E^2-1)^2'
      DO 70 I=1,NQ
        S = (QM+I*DQ)**(-1./3.)
        Q = QM + (I-.5)*DQ
        IF (NF(I).EQ.0) THEN
          CALL CCPERR (1,'**** ERROR - Empty shell - increase NSHELL.')
        ELSE
          SE(I) = SE(I)/NF(I)
          SE2(I) = SE2(I)/NF(I)
          WRITE (6,'(1X,I8,6X,I8,F13.2,F16.6,F13.0,F16.0,F14.3,F18.3)')
     &    I,NF(I),S,Q,SF(I),SFS(I),SE(I),SE2(I)
        ENDIF
70      CONTINUE
C
C      S = SMIN + .5*SM
C      DO 190 I=1,100
C        KF(I) = SQRT(FSPLIN(S*SQRT(S),SQ,DQ,SFS,NQ,KQ,CC))/FM + 1.
C190     S = S + SM
C
C      WRITE (6,'(///,A,A,/)')
C     &'1SCATTER PLOT OF F V. S (O) AND GRAPH OF INTERPOLATED ',
C     &'SMOOTHED RMS F V. MEAN DSTAR**2 (+)'
C      DO 180 L=1,100
C        J = 101-L
C        IF (MOD(J,5).EQ.0) THEN
C          JF = (J-.5)*FM + .5
C          WRITE (6,'(1X,I7,2A)') JF,' *',G(J)
C        ELSE
C          WRITE (6,'(9X,2A)') '*',G(J)
C        ENDIF
C        DO 200 I=1,100
C          IF (J.NE.KF(I)) THEN
C            G(J)(I:I) = BL
C          ELSE
C            G(J)(I:I) = PL
C          ENDIF
C200       CONTINUE
C180     WRITE (6,'(A,9X,A)') '+',G(J)
C
C      WRITE (6,'(9X,101A)') ('*',I=1,101)
C      DO 215 I=1,20
C215     SX(I) = 1./SQRT(SMIN+(5*I-.5)*SM)
C      WRITE (6,'(11X,20F5.1)') SX
C
      DO 330 I=0,7
        IF (NEP(I).GT.0) THEN
          SEP(I,1) = SEP(I,1)/NEP(I)
          SEP(I,2) = SEP(I,2)/NEP(I)
        ENDIF
330   CONTINUE
      WRITE (6,'(/////,A,8(6X,A),2(/,A,8F9.3),/,A,8I9)')
     &' Parity group','EEE','EEO','EOE','EOO','OEE','OEO','OOE','OOO',
     &' <E^2>        ',(SEP(I,1),I=0,7),
     &' <(E^2-1)^2>  ',(SEP(I,2),I=0,7),
     &' Number       ',NEP
C
      DO 220 I=1,9
        IF (NEAT.GT.0) SEA(I) = SEA(I)/NEAT
220     IF (NECT.GT.0) SEC(I) = SEC(I)/NECT
      WRITE (6,'(////,A,/,A,//,A,8X,F9.3,3F10.3,F11.3)')
     &'                 OBSERVED               THEORETICAL',
     &' AVERAGE    ACENTRIC  CENTRIC   ACENTRIC  CENTRIC  HYPERCENTRIC',
     &' E',SEA(1),SEC(1),TEA(1),TEC(1),TEH(1)
      WRITE (6,'(A,I1,6X,F9.3,3F10.3,F11.3)')
     &(' E^',I,SEA(I),SEC(I),TEA(I),TEC(I),TEH(I),I=2,6)
      WRITE (6,'(A,F9.3,3F10.3,F11.3)')
     &' |E^2-1|  ',SEA(7),SEC(7),TEA(7),TEC(7),TEH(7)
      WRITE (6,'(A,F9.3,3F10.3,F11.3)')
     &' |E^2-1|^2',SEA(8),SEC(8),TEA(8),TEC(8),TEH(8)
      WRITE (6,'(A,F9.3,3F10.3,F11.3)')
     &' |E^2-1|^3',SEA(9),SEC(9),TEA(9),TEC(9),TEH(9)
C
      WRITE (6,'(////,A,/,3A,//,A,A)')
     &' $TABLE: Cumulative distribution of Es:',
     &' $GRAPHS: E v Fraction<E; F=',GRAFLAB,':A:1,5,6,7,8: $$',
     &'    E    Number>=E  Number<E  N(E)[All:Obs]  N(E)[Cen:Theor]',
     &'  N(E)[Cen:Obs]  N(E)[Acen:Theor]  N(E)[Acen:Obs]'
      WRITE (6,'(A)') ' $$ $$'
      K = 3001
      DO 230 I=1,3000
        J = 3001-I
        NE(J) = NE(J) + NE(J+1)
        NEA(J) = NEA(J) + NEA(J+1)
        NEC(J) = NEC(J) + NEC(J+1)
230     IF (NE(J).LE.NW) K = J-1
C
      EM = .001*K
        CFA = 0.
        CFC = 0.
      DO 240 I=1,3001,50
        IF (MOD(I,500).EQ.1) WRITE (6,'(A)')
        F = .001*(I-1)
        FF = F*F
        CF = 1.-REAL(NE(I))/NE(1)
        IF (NEA(1).GT.0 .AND.NEA(I).GT.0) CFA = 1.-REAL(NEA(I))/NEA(1)
        IF (NEC(1).GT.0 .AND.NEC(I).GT.0) CFC = 1.-REAL(NEC(I))/NEC(1)
        TFA = 1.-EXP(-FF)
        T = 1./(1.+.47047*SQRT(.5)*F)
        TFC = 1.-((.74786*T-.09588)*T+.34802)*T*EXP(-.5*FF)
240     WRITE (6,'(1X,F6.2,I8,3X,I8,4X,F9.3,3(7X,F9.3),8X,F9.3)')
     &  F,NE(I),NE(1)-NE(I),CF,TFC,CFC,TFA,CFA
      WRITE (6,'(A)') ' $$'
C
C
      NZ = 0
      NT = 0
      N = 0
C  Last time through - output all terms + F E F2OR E2OR
C  Now AA(NCOL+1) = AA(4),AA(NCOL+2) = AA(5);AA(NCOL+3) = AA(6);AA(NCOL+4) = AA(7)
250   CONTINUE
      F = 0.0
      FPH = 0.0
      SP  = 0.0
      SPH = 0.0
C  Set all AA to the "Missing number" flag before starting to prepare 
C  output line
      CALL EQUAL_MAGIC(1,AA,MCOLS)
C Now read actual data
      CALL LRREFL(1,S,AA,EOF)
      IF (EOF) GOTO 260
      IFLG = 0
      IF (S.GT.RM) GOTO 255
      CALL LRREFM(1,LOGMSS)
      ID(1) = NINT(AA(1))
      ID(2) = NINT(AA(2))
      ID(3) = NINT(AA(3))
        CALL CENTR(ID,IC)
        IF(.NOT.LCENT .AND. IC.EQ.1) GO TO 255
C
      IF(LOOKUP(4).GT.0) THEN
       IF(LOGMSS(LOOKUP(4)) ) GOTO 255
       IF(LOOKUP(4).GT.0 .AND.LOGMSS(LOOKUP(4)) ) GOTO 255
       IF (LOOKUP(5).GT.0 )THEN
         IF(LOGMSS(LOOKUP(5)) ) GOTO 255
         IF(AA(LOOKUP(5)).LE.0  .OR. 
     +   ABS(AA(LOOKUP(4))) .LT. SIGP*AA(LOOKUP(5))) GOTO 255
          SP  = AA(LOOKUP(5))
       END IF 
C
       IF(FPMAX.GT.0 .AND.  ABS(AA(LOOKUP(4))) .GT. FPMAX) GOTO 255
       F = AA(LOOKUP(4))
      END IF
C
      IF (NLPRGI.EQ.7) THEN
        IF(LOGMSS(LOOKUP(6)) ) GOTO 255
        IF (LOOKUP(7).GT.0 )THEN
          IF(LOGMSS(LOOKUP(7)) ) GOTO 255
          IF(AA(LOOKUP(7)).LE.0  .OR. 
     +   ABS(AA(LOOKUP(6))) .LT. SIGP*AA(LOOKUP(7))) GOTO 255
          SPH = AA(LOOKUP(7))
        END IF 
        FPH = AA(LOOKUP(6))
        IF(FPHMAX.GT.0 .AND.  ABS(AA(LOOKUP(4))) .GT. FPHMAX) GOTO 255
        SP = SP**2 + SPH**2
        IF(.NOT.LSIGM) F = ABS(FPH-F)
        IF(LSIGM) F = SQRT(MAX((FPH-F)**2-SP,0.))
        SP = SQRT(ABS(SP))
        IF( DEL.GT.0 .AND. F .GT. DEL) GO TO 255
      ENDIF
C
      IF (NLPRGI.EQ.9) THEN
        IF(LOGMSS(LOOKUP(8)) ) GOTO 255
         IF (LOOKUP(9).GT.0 .AND.LOGMSS(LOOKUP(9)) ) GOTO 255
        F = ABS(AA(LOOKUP(8)))
        SP = ABS(AA(LOOKUP(9)))
      ENDIF
C       Now take absolute value of F
        F = ABS(F)
        IF( DEL.GT.0 .AND. F .GT. DEL) GO TO 255
      AA(NCOL+1) = F
C
      IF (F.EQ.0.) NZ = NZ + 1
      Q = S*SQRT(S)
      CALL MULEPS(ID,M,E)
      EF = E*FSPLIN(Q,SQ,DQ,SFS,NQ,KQ,CC)
      AA(NCOL+2) = F/SQRT(ABS(EF))
      AA(NCOL+3) = SP/SQRT(ABS(EF))
      IFLG = 1
      NT = NT + 1
255   CONTINUE
C  LO = 1; mtz output; LO=2 MULTAN output, LO=3 SNB output
      IF (LO.EQ.1) THEN
C
C L.H.P. output of origin removed Patterson coefficients.
C
        IF (IFLG .EQ. 1) THEN
          AA(NCOL+1) = AA(NCOL+1)*SCALE
          AA(NCOL+4) = (F*F-EF)*SCALE
          AA(NCOL+5) = AA(NCOL+2)**2-1.
        ENDIF
C
        CALL LWREFL(1,AA)
        N = N + 1
      ELSEIF (LO.EQ.2) THEN
        IF (IFLG.EQ.1) THEN
         IF (AA(NCOL+2).GE.EM) THEN
          WRITE (7,'(3I4,I6)') (ID(I),I=1,3),NINT(1000.*AA(NCOL+2))
          N = N + 1
         ENDIF
        ENDIF
      ELSEIF (LO.EQ.3) THEN
        IF (IFLG.EQ.1) THEN
         IF (AA(NCOL+2).GE.EM) THEN
          WRITE (7,'(3I5,F9.4,2F9.2)') (ID(I),I=1,3),AA(NCOL+2),F,SP
          N = N + 1
         ENDIF
        ENDIF
      ENDIF
      GOTO 250
C
260   IF (LO .EQ. 1) THEN
        WRITE(ERRMSG,'(A,I6)') ' No of reflns. written out =',N
        CALL CCPERR(3,ERRMSG)
        WRITE(ERRMSG,'(A,I6)') ' No of Es generated =',NT
        CALL CCPERR(3,ERRMSG)
      ELSE
        WRITE (6,'(//,A,F8.3,5X,A,I6,/,20x,A,I6)')
     &    ' E CUTOFF =',EM,'NO OF REFLNS WRITTEN =',N,
     &    ' NO of Es generated',NT
      ENDIF

      IF (LO.NE.2) THEN
        IF (LO.EQ.1) CALL LWCLOS(1,1)
        GOTO 300
      ENDIF
C
      CALL LRREWD(1)
      WRITE (7,'(13X,A)') '-1'
      K = MAX(NZ/100,1)
      M = 0
      N = 0
C
270   CONTINUE
      F = 0.0
      FPH = 0.0
      SP  = 0.0
      SPH = 0.0
      CALL LRREFF(1,S,AA,EOF)
      IF (EOF) GOTO 290
      IF (S.GT.RM) GOTO 270
      ID(1) = NINT(AA(1))
      ID(2) = NINT(AA(2))
      ID(3) = NINT(AA(3))
        CALL CENTR(ID,IC)
        IF(.NOT.LCENT .AND. IC.EQ.1) GO TO 270
      CALL LRREFM(1,LOGMSS)
      IF (LOOKUP(4).GT.0 )THEN
       IF (LOGMSS(4)) GOTO 270
       IF (LOOKUP(5).GT.0 )THEN
         IF(LOGMSS(5) ) GOTO 270
         IF(AA(5).LE.0 .OR. ABS(AA(4)) .LT. SIGP*AA(5)) GOTO 270
         SP  = AA(5)
       END IF 
       F = ABS(AA(4))
          IF(FPMAX.GT.0 .AND.  ABS(AA(4)) .GT. FPMAX) GOTO 270
      END IF 
C
C
      IF (NLPRGI.EQ.7) THEN
        IF (LOOKUP(7).GT.0 )THEN
          IF(LOGMSS(7) ) GOTO 270
          IF(AA(7).LE.0 .OR. ABS(AA(6)) .LT. SIGH*AA(7)) GOTO 270
          IF(AA(7).LE.0) GOTO 270
          SPH = AA(7)
        END IF 
        IF(.NOT.LOGMSS(6)) FPH = AA(6)
        IF(FPHMAX.GT.0 .AND.  ABS(AA(6)) .GT. FPHMAX) GOTO 270
        IF(.NOT.LSIGM) F = ABS(FPH-F)
        IF(LSIGM) F = SQRT(MAX((FPH-F)**2-SP**2-SPH**2,0.))
        IF( DEL.GT.0 .AND. F .GT. DEL) GO TO 270
      ENDIF
C
      IF (NLPRGI.EQ.9) THEN
        IF(LOGMSS(8) ) GOTO 270
         IF (LOOKUP(9).GT.0 .AND.LOGMSS(9) ) GOTO 270
        F = AA(8)
      ENDIF
        F = ABS(F)
        IF(LSIGM) F = SQRT(MAX(F**2-AA(9)**2,0.0))
      IF( DEL.GT.0 .AND. F .GT. DEL) GO TO 270
C
      IF (F.NE.0.) GOTO 270
      M = M + 1
      IF (MOD(M,K).NE.0) GOTO 270
      DO 275 I=1,3
275     ID(I) = NINT(AA(I))
      WRITE (7,'(3I4)') (ID(I),I=1,3)
      N = N + 1
      IF (N.NE.100) GOTO 270
C
290   WRITE (6,'(//,A,I6)') ' NO OF ZERO REFLNS WRITTEN =',N
      WRITE (7,'(13X,A)') '-1'
C
300   CALL CCPERR(0,'**** NORMAL TERMINATION ****')
      END
C
C
      SUBROUTINE GETINP(KE)
C     =================
C
C
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER MKEY,MTOK,MCOLS,MSYM,MSETS
      PARAMETER (MKEY=12,MTOK=20,MCOLS=500,MSYM=192,MSETS=MCOLS)
C     ..
C     .. Scalar Arguments ..
      INTEGER KE
C     ..
C     .. Scalars in Common ..
      CHARACTER TI1*70,GRAFLAB*42
      INTEGER LEN,LO,MQ,NCOL,NSYMP,NSYM,NLPRGI,NW
      REAL DEL,FPHMAX,FPMAX,RM,SCALE,SIGH,SIGP
C     ..
C     .. Arrays in Common ..
      INTEGER IS,LOOKUP
      REAL CELL
C     ..
C     .. Local Scalars ..
      CHARACTER FTITLE*70,KEY*4,LINE*600,PGNAM*10,SPGRNM*10,
     +          LABOUT_SAVE*600,LTYPE*1,ERRMSG*600
      LOGICAL EOF,LSIGM,LCENT
      INTEGER I,IAPPND,IND,IFAIL,IPRINT,ITOK,J,K,MREFL,NLPRGO,
     &NREFLS,NSPGRP,NSTART,NTOK
      REAL RESMAX,RESMIN,SMAX,SMIN
C     ..
C     .. Local Arrays ..
      CHARACTER CV(MTOK)*4,CTPRGI(MCOLS)*1,LSPRGI(MCOLS)*30,KEYS(MKEY)*4
      CHARACTER CTPRGO(5)*1,LSPRGO(5)*30,VERSNX*10,CTYPS(MCOLS)*1,
     +          CLABS(MCOLS)*30
      INTEGER IB(MTOK),IE(MTOK),IT(MTOK),IV(MTOK),NTOKS(MKEY)
      REAL FV(MTOK),RTS(4,4,MSYM),RANGES(2,MCOLS)
      INTEGER NDATASETS,ISETS(MSETS),ISET,CSETID(MCOLS),
     +         IISET,IDUMMY,SETID
      REAL DATCELL(6,MSETS),DATWAVE(MSETS)
      CHARACTER*64 PNAME(MSETS),XNAME(MSETS),DNAME(MSETS),   
     +         XNAME_OUT(MCOLS),DNAME_OUT(MCOLS)
C     ..
C     .. External Routines ..
      INTEGER LENSTR
      EXTERNAL CCPERR,CCPOPN,CCPUPC,GTPINT,GTPREA,LKYIN,LKYOUT,LRASSN,
     +         LRCELL,LRINFO,LRCLAB,LROPEN,LRRSOL,LRSYMI,LRSYMM,LRTITL,
     +         LWASSN,LWHSTL,LWOPEN,LWTITL,MTZINI,MSYMLB,PARSER,RDRESO
C     .. 
C     .. Intrinsic Functions ..
      INTRINSIC MAX,MIN,SQRT
C     ..
C     .. Common blocks ..
      COMMON /INCOMC/ TI1,GRAFLAB
      COMMON /INCOML/ LSIGM,LCENT
      COMMON /INCOM/ LO,MQ,NSYMP,NLPRGI,NW,RM,IS(3,3,MSYM),
     +               LOOKUP(MCOLS),
     +               CELL(6),NCOL,SCALE,SIGP,SIGH,DEL,FPMAX,FPHMAX
C     EG..
C     .. Data statements ..
      DATA IND /1/, IPRINT/2/
      DATA KEYS/'TITL','SPAC','RESO','SHEL','LABI','LABO','MULT','REFL',
     +          'SCAL','SNB','EXCL','MODD'/
      DATA NTOKS /1,    -2,    -2,    -2,    1,    1,    -1,   -2, 
     +           -2,    -1,     2,    -2/
C     ..
      DATA LSPRGI/'H','K','L','FP','SIGFP','FPH','SIGFPH','DPH',
     +  'SIGDPH',491*' '/
      DATA CTPRGI/'H','H','H','F','Q','F','Q','D','Q',491*' '/
      DATA LOOKUP/-1,-1,-1,497*0/
      DATA NLPRGO,LSPRGO/5,'FECALC','E','SIGE','F2OR','E2OR'/
      DATA CTPRGO/'F','E','Q','J','J'/
C
C
      TI1 = ' '
      NSPGRP = 0
      RM = 0.0
      MQ = 200
      NLPRGI = 0
      LO = 1
      MREFL = 0
      LABOUT_SAVE = 'LABO FECALC=F_ecalc '
      SCALE = 1.0
      SIGP=0 
      SIGH=0 
      DEL=0 
      LSIGM=.FALSE.
      LCENT=.TRUE.
      FPMAX=0 
      FPHMAX=0
C
C     ===========
      CALL MTZINI
C     ===========
C
C     =======================================
      CALL LROPEN(IND,'HKLIN',IPRINT,IFAIL)
C     =======================================
C
      IF (IFAIL.NE.0) CALL CCPERR(1,
     &'*** ERROR OPENING INPUT MTZ FILE ***')
C
C     ====================================
      CALL LRSYMI(IND,NSYMP,LTYPE,NSPGRP,SPGRNM,PGNAM)
C     ====================================
C
C     ============================
      CALL LRSYMM(IND,NSYM,RTS)
      CALL CENTRIC(NSYM,RTS,IPRINT)
C     =============================
C
C     ======================
      CALL LRINFO(IND,VERSNX,NCOL,NREFLS,RANGES)
C  reset default number of reflections; can be overwritten
      NW = NREFLS
      IF (NCOL .GT. MCOLS-5) CALL CCPERR(1,
     . '*** ERROR; too many columns in the MTZ file. Reset MCOLS ***')
C
C
10    LINE = ' '
      NTOK = MTOK
      CALL PARSER(KEY,LINE,IB,IE,IT,FV,CV,IV,NTOK,EOF,.TRUE.)
      IF (EOF) GOTO 40
      IF (KEY.EQ.'END') GOTO 40 
C
      DO 20 I=1,MKEY
20      IF (KEY.EQ.KEYS(I)) GOTO 30
      ERRMSG = ' Bad keyword    '//KEY
      CALL CCPERR(2,ERRMSG)
      KE = KE + 1
      GOTO 10
C
30    IF ((NTOKS(I).LT.0 .AND. NTOK.NE.-NTOKS(I)).OR.
     &    NTOK.LT.NTOKS(I)) THEN
        CALL CCPERR(2,' Bad argument count.')
        KE = KE + 1
      ENDIF
      GOTO (1010,1020,1030,1040,1050,1060,1070,1080,1090,1100,
     +      1110,1120),I
C
C==== TITLE
1010  TI1 = LINE(IB(2):)
      GOTO 10
C
C==== SPACEGROUP
1020  IF (IT(2).EQ.1) THEN
        SPGRNM=LINE(IB(2):IE(2))
        CALL CCPUPC(SPGRNM)
        NSPGRP = 0
      ELSE
        CALL GTPINT(2,NSPGRP,NTOK,IT,FV)
        SPGRNM=' '
      ENDIF
      CALL MSYMLB(1,NSPGRP,SPGRNM,PGNAM,NSYMP,NSYM,RTS)
        WRITE(6,*) ' *** Resetting spacegroup from the MTZ one *** '
      WRITE (6,'(//,A,I5,2X,A,//,A,F10.3,//,A,I10,//,A,I10,//)')
     &' SPACE GROUP         =',NSPGRP,SPGRNM
      GOTO 10
C
C==== RESOLUTION
1030  CALL RDRESO(2,IT,FV,NTOK,RESMAX,RESMIN,SMIN,RM)
      GOTO 10
C
C==== SHELL
1040  CALL GTPINT(2,MQ,NTOK,IT,FV)
      MQ = MAX(MQ,25)
      GOTO 10
C
C==== LABI
1050  IF (NLPRGI.NE.0) THEN
        CALL CCPERR(2,' LABI key given already.')
        KE = KE + 1
      ELSE
        NLPRGI = 9
C
C       ============================================
        CALL LKYIN (1,LSPRGI,NLPRGI,NTOK,LINE,IB,IE)
C       ============================================
C
      ENDIF
      GOTO 10
C
C  Unnecessary..
C==== ISODIF
C1060  IF (NLPRGI.NE.0) THEN
C        WRITE (6,'(/,A)') ' **** ERROR: FOBS/ISODIF key given already.'
C        KE = KE + 1
C      ELSE
C        NLPRGI=7
CC
CC       ============================================
C        CALL LKYIN (1,LSPRGI,NLPRGI,NTOK,LINE,IB,IE)
CC       ============================================
CC
C      ENDIF
C      GOTO 10
C
C  Replace with LABOUT
C==== LABO - save analysis for later
1060  CONTINUE
      LABOUT_SAVE = LINE
      GO TO 10
C
C==== MULTAN
1070  LO=2
      GOTO 10
C
C==== REFLECTIONS
1080  CALL GTPINT(2,MREFL,NTOK,IT,FV)
      GOTO 10
C
C==== SCALE
1090  CALL GTPREA(2,SCALE,NTOK,IT,FV)
      GOTO 10
C
C==== SNB
1100  LO=3
      GOTO 10
C
C==== EXCLude - CENTric SIGPH nsigph DIFF dif FPMAx fpmax FPHMax fphmax
1110  CONTINUE
C
         NSTART = 2
C
         ITOK = NSTART
 120     CONTINUE
C        DO 120 ITOK = NSTART,NTOK
C
C                ***********
            CALL CCPUPC(CV(ITOK))
            CALL CCPUPC(LINE)
C                ***********
            KEY = CV(ITOK)(1:4)
C
            IF (KEY.EQ.'CENT') THEN
              LCENT = .FALSE.
              ITOK = ITOK + 1
              IF(ITOK.LT.NTOK) GO TO 120
            END IF
C
            IF (LINE(IB(ITOK):IB(ITOK)+4).EQ.'SIGPH') THEN
                SIGH = FV(ITOK+1)
                ITOK = ITOK + 2
            IF(ITOK.LT.NTOK) GO TO 120
            END IF
            IF (KEY.EQ.'DIFF') THEN
                DEL = FV(ITOK+1)
                ITOK = ITOK + 2
            IF(ITOK.LT.NTOK) GO TO 120
            END IF
            IF (KEY.EQ.'FPMA') THEN
                FPMAX = FV(ITOK+1)
                ITOK = ITOK + 2
            IF(ITOK.LT.NTOK) GO TO 120
            END IF
            IF (KEY.EQ.'FPHM') THEN
                FPHMAX = FV(ITOK+1)
                ITOK = ITOK + 2
            IF(ITOK.LT.NTOK) GO TO 120
            END IF

      GOTO 10
C
C==== MODDIFF - take difference with or without Sigma modification.
1120  CONTINUE
      CALL CCPUPC(CV(2))
      IF(CV(2)(1:3).EQ.'YES') LSIGM = .TRUE.
      IF(CV(2)(1:2).EQ.'NO') LSIGM = .FALSE.
       write(6,*)' at moddiff - cv(2) lsigm(2)',cv(2),lsigm
      GOTO 10
C
C
40    CONTINUE
C
      WRITE(6,'(/,A)') ' *** Program options from keywords: '

      WRITE(6,'(/,A)')
     +        '   Exclude reflections if:'
      IF (SIGP .GT. 0.0) WRITE(6,'(4x,A,f8.0)')
     +     '    FP less than ',SIGP,' SIGFP'
      IF (SIGH .GT. 0.0) WRITE(6,'(4x,A,f8.0)')
     +     '    FPH less than ',SIGH,' SIGFPH'
      IF (DEL .GT. 0.0) WRITE(6,'(4x,A,f8.0)')
     +     '    Difference greater than',DEL
      IF (FPMAX .GT. 0.0) WRITE(6,'(4x,A,f8.0)')
     +     '    FP  greater than ',FPMAX
      IF (FPHMAX .GT. 0.0) WRITE(6,'(4x,A,f8.0)')
     +     '    FPH greater than ',FPHMAX
      IF (.NOT.LCENT) WRITE(6,'(4x,A)')
     +     '    the reflection is centric'
C
      IF( LSIGM) THEN 
         WRITE(6,'(/,A,/,2A,/)')
     +    '   Differences will be reduced to take SIGMA into account',
     +    '   The difference is taken as the ',
     +    'sqrt(DIFF_obs *DIFF_obs - SIG_diff*SIG_diff)'
      ELSE 
         WRITE(6,'(/,A,/,A,/)')
     +    '   Differences are NOT corrected for SIGMA component',
     +    '   i.e. the difference is taken as the abs(DIFF_obs)'
      END IF 
C
      IF (NSYMP.EQ.0) THEN
        CALL CCPERR(2,' Space group not specified.')
        KE = KE + 1
      ENDIF
      IF (NLPRGI.EQ.0) THEN
        CALL CCPERR(2,' LABI key not given.')
        KE = KE + 1
      ELSE
C
C       =============================
        CALL LRTITL(IND,FTITLE,LEN)
C       =============================
C
C       =================================
        CALL LRCLAB(IND,CLABS,CTYPS,NCOL)
C       =================================
C
C       ==============================================
        CALL LRASSN(IND,LSPRGI,NLPRGI,LOOKUP,CTPRGI)
C       ==============================================
        NLPRGI=5
        IF(LOOKUP(4).NE.0) THEN
          GRAFLAB = CLABS(LOOKUP(4))
        END IF
        IF(LOOKUP(6).NE.0) THEN
         NLPRGI=7
         GRAFLAB = 
     +   'Delta;'//CLABS(LOOKUP(6))(1:LENSTR(CLABS(LOOKUP(6))))
         GRAFLAB = 
     +   GRAFLAB(1:LENSTR(GRAFLAB))//'-'//CLABS(LOOKUP(4))
        END IF

        IF(LOOKUP(8).NE.0) THEN
          NLPRGI=9
          IF(LOOKUP(6).NE.0 ) THEN
          Write(6,*) 
     +   ' ***** It is not possible to use BOTH anomalous',
     +   ' and isomorphous differences*****'
          CALL CCPERR(1,   ' Set correct input labels')
          END IF
C   Can only use acentric reflections
          LCENT = .FALSE.
          WRITE(6,'(/,2A)')
     +     ' Anomalous difference used to generate Es',
     +     ' - no centrics included'
          GRAFLAB =    'AnomDiff; '//CLABS(LOOKUP(8))
        END IF

        GRAFLAB = GRAFLAB(1:LENSTR(GRAFLAB))//';'//TI1(1:30)
C
C---- Dataset stuff
C     Notify available space
        NDATASETS = MSETS
        CALL LRIDX(IND,PNAME,XNAME,DNAME,ISETS,
     +              DATCELL,DATWAVE,NDATASETS)
C---- Get dataset IDs for columns.
        IF (NDATASETS.GT.0) THEN
          CALL LRCLID(IND,CSETID,IDUMMY)
        ENDIF

C       =======================
        CALL LRCELL(IND,CELL)
C       =======================
C
C       =======================
        CALL LRRSOL(1,SMIN,SMAX)
C       =======================
C
        IF (RM .EQ. 0.0) THEN
          RM = SMAX
        ELSE
          RM = MIN(RM,SMAX)
        ENDIF
C
        IF (TI1.EQ.' ') TI1 = FTITLE
      ENDIF

      IF (LO.GT.1 .AND. MREFL.NE.0) NW = MREFL
      WRITE (6,'(//,20X,A,//)') TI1
      WRITE (6,'(//,A,I5,2X,A,//,A,F10.3,//,A,I10,//,A,I10,//)')
     &' SPACE GROUP         =',NSPGRP,SPGRNM,
     &' MAX RESOLUTION      =',SQRT(1.0/RM),
     &' REFLNS/SHELL        =',MQ,
     &' NO OF REFLNS WANTED =',NW
C
      DO 50 K = 1,NSYMP
        DO 50 I = 1,3
          DO 50 J = 1,3
50          IS(I,J,K) = NINT(RTS(I,J,K))
      IF (LO.EQ.1) THEN
        CALL LWHSTL (IND, ' ')
C
        IF(LABOUT_SAVE.NE.' ') THEN
          LINE = LABOUT_SAVE
C
C            ******************************************************
          CALL PARSER(KEY,LINE,IB,IE,IT,FV,CV,IV,NTOK,EOF,.TRUE.)
          CALL LKYOUT(IND,LSPRGO,NLPRGO,NTOK,LINE,IB,IE)
C            ******************************************************
        END IF
C
C---- Add to title and labels, update symmetry
C
C            ********************************
        CALL LWOPEN(IND,'HKLOUT')
        CALL LWTITL(IND,TI1,0)
        IAPPND = 1
        CALL LWASSN(IND,LSPRGO,NLPRGO,CTPRGO,IAPPND)
C
C Store the column dataset IDs. Output columns are assigned
C to derivative dataset if appropriate or to native dataset.
        IF (NDATASETS.GT.0) THEN
          IF (LOOKUP(8).GT.0) THEN
            SETID = CSETID(LOOKUP(8))
          ELSE IF (LOOKUP(6).GT.0) THEN
            SETID = CSETID(LOOKUP(6))
          ELSE IF (LOOKUP(4).GT.0) THEN
            SETID = CSETID(LOOKUP(4))
          ELSE
            SETID = 0
          ENDIF
          DO ISET = 1,NDATASETS
            IF (ISETS(ISET).EQ.SETID) THEN
              IISET = ISET
            END IF
          ENDDO
          DO I = 1,NLPRGO
            XNAME_OUT(I) = XNAME(IISET)
            DNAME_OUT(I) = DNAME(IISET)
          ENDDO
          CALL LWIDASX(IND,NLPRGO,XNAME_OUT,DNAME_OUT,IAPPND)
        ENDIF

C      CALL LRSYMI(IND,NSYMP,LINE,NSPGRP,SPGRNM,PGNAM)
C      CALL LRSYMM(IND,NSYM,RTS)
C      SUBROUTINE LWSYMM(MINDX,NSYMX,NSYMPX,RSYMX,LTYPEX,NSPGRX,SPGRNX,
C     +                  PGNAMX)
        CALL LWSYMM(IND,NSYM,NSYMP,RTS,LTYPE,NSPGRP,SPGRNM,PGNAM)
C
C            ********************************
      ELSE
        I = 0
        CALL CCPOPN(7,'HKLOUT',4,1,0,I)
      ENDIF
      END
C
C     ======================================
      REAL FUNCTION FSPLIN(X,XO,XD,YA,N,J,C)
C     ======================================
C
C==== CUBIC SPLINE INTERPOLATION.
C==== X  = INTERPOLATION POINT IN X.
C==== XO = FIRST SAMPLE POINT IN X.
C==== XD = INCREMENT IN X BETWEEN SAMPLE POINTS.
C==== YA = ARRAY OF N SAMPLE POINTS IN Y.
C==== N  = NUMBER OF SAMPLE POINTS.
C==== J  = RETURNED ARRAY INDEX. MUST BE SET TO ZERO BEFORE FIRST CALL.
C==== C  = RETURNED ARRAY OF 4 CUBIC COEFFICIENTS. J AND C MUST NOT BE
C         MODIFIED BETWEEN CALLS.
C==== FSPLIN = INTERPOLATED VALUE IN Y.
C
C
C
      IMPLICIT NONE
C     .. Scalar Arguments ..
      INTEGER J,N
      REAL X,XD,XO
C     ..
C     .. Array Arguments ..
      REAL C(4),YA(N)
C     ..
C     .. Local Scalars ..
      INTEGER I,I1
      REAL G1,G2,S,U0,U1,U2,V0,V1,V2,X1,XD2,YD,YD1
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MIN
C     ..
      IF (N.LE.2) THEN
        J = 1
        IF (N.EQ.1) THEN
          FSPLIN = YA(1)
        ELSE
          FSPLIN = YA(1) + (YA(2)-YA(1))*(X-XO)/XD
        ENDIF
      ELSE
C==== COMPUTE WHICH INTERVAL TO USE.
        I = MIN(MAX(INT((X-XO)/XD),0)+1,N-1)
        X1 = XO + (I-1)*XD
C==== SAME AS LAST CALL ?
        IF (I.NE.J) THEN
C==== NO, RESET FOR NEXT CALL.
          J = I
C
C==== COMPUTE WEIGHTED DISPLACEMENT VECTOR (U1,V1) BETWEEN I AND I+1.
          XD2 = XD*XD
          I1 = I + 1
          YD1 = YA(I1) - YA(I)
          S = XD2 + YD1*YD1
          U1 = XD/S
          V1 = YD1/S
          C(1) = YA(I)
C
          IF (I.GT.1) THEN
C==== COMPUTE VECTOR (U0,V0) BETWEEN I-1 AND I, AND GRADIENT G1 AT I.
            YD = YA(I) - YA(I-1)
            S = XD2 + YD*YD
            U0 = XD/S
            V0 = YD/S
            G1 = (V0+V1)/ (U0+U1)
C
            IF (I1.EQ.N) GOTO 10
          ENDIF
C==== COMPUTE VECTOR (U2,V2) BETWEEN I+1 AND I+2, AND GRADIENT G2 AT I+1.
          YD = YA(I1+1) - YA(I1)
          S = XD2 + YD*YD 
          U2 = XD/S
          V2 = YD/S
          G2 = (V1+V2)/ (U1+U2)
C
          IF (I.EQ.1) THEN
C==== CASE OF FIRST INTERVAL, COMPUTE QUADRATIC COEFFIENTS.
            C(2) = YD1/XD
            C(3) = G2 - C(2)
            C(2) = C(2) - C(3)
            C(3) = C(3)/XD
            C(4) = 0.
          ELSE
C==== GENERAL CASE, COMPUTE CUBIC COEFFICENTS.
            C(2) = G1
            C(3) = YD1/XD
            C(4) = G1 + G2 - 2.*C(3)
            C(3) = (C(3)-C(4)-G1)/XD
            C(4) = C(4)/XD2
          ENDIF
          GOTO 20
C
C==== CASE OF LAST INTERVAL, COMPUTE QUADRATIC COEFFICIENTS.
10        C(2) = G1
          C(3) = (YD1/XD-G1)/XD
          C(4) = 0.
        ENDIF
C
C==== COMPUTE FUNCTION VALUE AND RETURN.
20      S = X - X1
        FSPLIN = C(1) + S*(C(2)+S*(C(3)+S*C(4)))
      ENDIF
      END
C
C
      SUBROUTINE MULEPS(ID,M,E)
C     =================
C
C==== CALC MULTIPLICITY AND EPSILON
C
C
      IMPLICIT NONE
C     ..
C     .. Parameters ..
      INTEGER MCOLS,MSYM
      PARAMETER (MCOLS=500,MSYM=192)
C     ..
C     .. Scalar Arguments ..
      INTEGER M
      REAL E
C     ..
C     .. Array Arguments ..
      INTEGER ID(3)
C     ..
C     .. Scalars in Common ..
      INTEGER LO,MQ,NSYMP,NLPRGI,NCOL,NW
      REAL DEL,FPHMAX,FPMAX,RM,SCALE,SIGH,SIGP
C     ..
C     .. Arrays in Common ..
      INTEGER IS,LOOKUP
      REAL CELL
C     ..
C     .. Local Scalars ..
      INTEGER I,J,K
C     ..
C     .. Local Arrays ..
      INTEGER IE(3)
C     ..
C     .. External Routines ..
      EXTERNAL GENEQ
C     ..
C     .. Common blocks ..
      COMMON /INCOM/ LO,MQ,NSYMP,NLPRGI,NW,RM,IS(3,3,MSYM),
     +               LOOKUP(MCOLS),
     +               CELL(6),NCOL,SCALE,SIGP,SIGH,DEL,FPMAX,FPHMAX
C     ..
C
      E = 1.
      M = 1
      IF (NSYMP.GT.1) THEN
        CALL GENEQ(IS,ID,IE)
        I = 1048576*IE(1) + 1024*IE(2) + IE(3)
        DO 10 K = 2,NSYMP
          CALL GENEQ(IS(1,1,K),ID,IE)
          J = 1048576*IE(1) + 1024*IE(2) + IE(3)
          IF (I.EQ.J .OR. I.EQ.-J) M = M + 1
10        IF (I.EQ.J) E = E + 1.
        M = NSYMP/M
      ENDIF
      END
C
C
      SUBROUTINE GENEQ(IS,ID,IE)
C     ================
C
C==== GENERATE EQUIVALENT REFLN
C
C
      IMPLICIT NONE
C     .. Array Arguments ..
      INTEGER ID(3),IE(3),IS(3,3)
C     ..
C     .. Local Scalars ..
      INTEGER I,J
C     ..
      DO 10 J = 1,3
        IE(J) = 0
        DO 10 I = 1,3
10        IE(J) = IE(J) + ID(I)*IS(I,J)
      END
