C
C     FFFEAR 
C     Copyright (C) 2000-2006 Kevin Cowtan
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c ......................................................................
      program fffearprog
      include 'fffear.fh'
c DM - generic density modification program
c Please note: this main program simply calculates how much memory the
c program requires, and then calls CCPALC to allocate the storage
c needed by the rest of the program, which is run via DMMAIN.
      integer sizes(10)
      character*1 types(10)
      external fffearmain
      data types /3*'R',7*'I'/
c
c calculate required array sizes
      call initialise()
      call mallocate(sizes)
c now allocate memory
      call ccpalc(fffearmain,10,types,sizes)
      call ccperr(0,' FFFEAR - normal termination ')
      end
c
c ----------------------------------------------------------------------
c
      subroutine fffearmain(nla,hkls,nlb,rhomap,nlc,l1,
     +  nld,l2,nle,l3,nlf,l4,nlg,s1,nlk,s2,nll,s3,nlm,solmsk)
      include 'fffear.fh'
      include 'io.fh'
      include 'hkllab.fh'
c DMMAIN - do the main phase extension loop
c
      integer nla,nlb,nlc,nld,nle,nlf,nlg,nlh,nli,nlj,nlk,nll,nlm
      real hkls(*),rhomap(*)
      integer solmsk(*)
      real l1(*),l2(*),l3(*),l4(*),s1(*),s2(*),s3(*)
c
      integer icfr,lfa,lfb,i
      real reseff,realfree,realfreeold
      logical converged,print,assigned(nhklc)
c specific column numbers used from this routine
      parameter (lfa=20,lfb=21)
      data assigned /8*.true.,17*.false./
c
      do i=1,nlm
       solmsk(i)=1
      enddo
c
c read in the reflection file and scale
      call ccp4h_header('Data Checking','datachk',3)
      call hklin(hkls,assigned)
      call ccp4h_header('Data Scaling','datascl',3)
      call calcscale(hkls,assigned)
      if (inputsolmask) then
       call ccp4h_header('User Mask','solmsk',3)
       call solmskin(solmsk,l1)
      endif
c generate wFo's
      call ccp4h_header('Experimental Map Calculation','expmap',3)
      call wfo(hkls,lfa,lfb)
      call searcher(hkls,rhomap,l1,l2,l3,l4,s1,s2,s3,solmsk)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine initialise()
      include 'fffear.fh'
      include 'io.fh'
c initialise ccp4, read in the data, set up all the constants which will
c be needed later.
c
      integer idum,lunsti,lunsto,ccpnun
      external lunsti,lunsto,ccpnun
c
      idum=0
      lpt=lunsto(idum)
      lcd=lunsti(idum)
      latom=ccpnun()
      lhist=ccpnun()+1
      lmsks=ccpnun()+2
c
      call ccpfyp()
      call ccp4h_init()
      call ccp4h_header('fffear 1.9','fffear',1)
      call ccpvrs(lpt,'fffear','25/11/99')
      call ccp4h_pre_end()
      write (lpt,11)
 11   format (/,
     +  '<a href="http://www.ysbl.york.ac.uk/~cowtan/dm/refs.html">',
     +  'fffear reference:</a>',/,
     +  '<blockquote>',/,'K. Cowtan (2001),',/,2x,
     +  'Fast Fourier feature recognition',/,2x,
     +  'Acta Cryst. D57, 1435-1444.',/,'</blockquote><p>',/)
      call ccp4h_toc_beg()
      call ccp4h_toc_ent('Command input','#command')
c      call ccp4h_toc_ent('Comments','#comments')
      call ccp4h_toc_ent('MTZ input','#mtzin')
      call ccp4h_toc_ent('Data Checking','#datachk')
      call ccp4h_toc_ent('Data Scaling','#datascl')
      call ccp4h_toc_ent('Translation Search','#tsearch')
      call ccp4h_toc_ent('Search Results','#tresult')
      call ccp4h_toc_end()
c
      call mtzini()
      call rcards()
      call inicalc()
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine mallocate(sizes)
      include 'fffear.fh'
      include 'hkldata.fh'
      include 'uvwdata.fh'
c mallocate - make a list of sizes for arrays which will form the
c arrays in the main density modification programme.
c
      integer sizes(10)
c
      integer hklsize
c
c calculate required array sizes
      hklsize=(nrflc+1)*nhklc
c
c allocate one reflection array
      sizes(1)=hklsize
c allocate map arrays
      sizes(2)=uvwsize
      sizes(3)=uvwsize
      sizes(4)=uvwsize
      sizes(5)=uvwsize
      sizes(6)=uvwsize
      sizes(7)=uvwsmll
      sizes(8)=uvwsmll
      sizes(9)=uvwsmll
c set the masks
      sizes(10)=uvwsize
c all done
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine rcards()
      include 'fffear.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
      include 'hkldata.fh'
      include 'mtzdata.fh'
      include 'uvwdata.fh'
      include 'srcdata.fh'
c RCARDS - read in input cards
c
      integer i,j,k,l
      integer iverb,mtzin,iprint,ifail,iappnd
      integer mcols
      parameter (mcols=500)
c
      integer jpoint(mcols),nlprgi
      real xcen,ycen,zcen,w1,w2
      character ctprgi(mcols)*1,lsprgi(mcols)*30
      character namspg*10,nampg*10,namlau*10,
     +          title*80,history(1)*80,ltype*1,line*240
      logical lscln,lscls,lstru,lf000,lfmap,lfmdl,lfstd,cont
c
      data namspg,nampg,namlau/3*'          '/
c
c input data
      data nlprgi,lsprgi,ctprgi,jpoint/17,
     +  'H','K','L','FP','SIGFP','PHIO','FOMO','HLA','HLB','HLC','HLD',
     +  'FDM','PHIDM','FOMDM','FCAL','PHICAL','FREE',483*' ',
     +  'H','H','H', 'F',    'Q',   'P',   'W',  'A',  'A',  'A',  'A',
     +  'F',  'P',    'W',   'F',     'P',   'I',483*' ',
     +   -1, -1, -1,  -1,     -0,    -0,    -0,    0,    0,    0,    0,
     +   0,    0,      0,     0,       0,     0,483*0/
c
c some defaults
      data lscln,lscls,lstru,lf000,lfmap,lfmdl,lfstd/7*.false./
c
      call ccp4h_header('Command Input','command',2)
      call ccp4h_pre_beg()
c
c initialise the variables
c
      mtzin=1
      iverb=0
      mskrad=2.5
      mdlrad=2.5
      mdlres=-1.0
      mdlbfc=0.0
      srcstp=10.0
      srcgrd=1.33
      srcrng=999.0
      srcpks=100
      numbfree=20
      rmin=1000.0
      rmax=1.0
      tmin=1000.0
      tmax=1.0
      scale=0.0
      bfac=0.0
      xf000=0.0
      solc=-1.0
      aveprt=0.43
      avesol=0.32
      hscale=0.01
      rscale=0.5
      fltrad=5.0
      fltmap=0
      fltfrg=0
      xcen=-1000000.0
      ycen=0.0
      zcen=0.0
      ucen=0.0
      vcen=0.0
      wcen=0.0
      alpha0=0.0
      beta0 =0.0
      gamma0=0.0
      nu=0
      nv=0
      nw=0
      l=100
c
c Parse the user input ----------------------------------------
c
 200  call memoparse(.false.)
c
c Make links to documentation:
      call ccp4h_link_key('SOLCONT ','fffear.html#solc')
      call ccp4h_link_key('GRID    ','fffear.html#grid')
      call ccp4h_link_key('SEARCH  ','fffear.html#search')
      call ccp4h_link_key('SCALE   ','fffear.html#scale')
      call ccp4h_link_key('CENTRE  ','fffear.html#centre')
      call ccp4h_link_key('MASK    ','fffear.html#mask')
      call ccp4h_link_key('MODEL   ','fffear.html#model')
      call ccp4h_link_key('STRUCFAC','fffear.html#strucfac')
      call ccp4h_link_key('FILTER  ','fffear.html#filter')
      call ccp4h_link_key('FORM    ','fffear.html#form')
      call ccp4h_link_key('RESOLUTI','fffear.html#resolution')
      call ccp4h_link_key('TRUNCATE','fffear.html#truncate')
      call ccp4h_link_key('LABIN   ','fffear.html#labin')
      call ccp4h_link_key('TITLE   ','fffear.html#title')
c flag all keywords unrecognized
      call parsefail()
c set flags and check for keywords...
c
c SOLC
      call parsesubreal('SOLC','    ',1,.true.,solc)
      call parsesubreal('SOLC','MEAN',1,.true.,avesol)
      call parsesubreal('SOLC','MEAN',2,.true.,aveprt)
c GRID
      call parsesubint ('GRID','    ',1,.true.,nu)
      call parsesubint ('GRID','    ',2,.true.,nv)
      call parsesubint ('GRID','    ',3,.true.,nw)
c SEAR
      call parsesubreal('SEAR','STEP',1,.true.,srcstp)
      call parsesubreal('SEAR','GRID',1,.true.,srcgrd)
      call parsesubint ('SEAR','PEAK',1,.true.,srcpks)
      call parsesubreal('SEAR','RANG',1,.true.,srcrng)
c SCAL
      call parsesubkey ('SCAL','NATU',lscln)
      call parsesubkey ('SCAL','SHAR',lscls)
      call parsesubreal('SCAL','    ',1,.false.,scale)
      call parsesubreal('SCAL','    ',2,.false.,bfac)
c CENT
      call parsesubreal('CENT','FRAC',1,.false.,ucen)
      call parsesubreal('CENT','FRAC',2,.false.,vcen)
      call parsesubreal('CENT','FRAC',3,.false.,wcen)
      call parsesubreal('CENT','ORTH',1,.false.,xcen)
      call parsesubreal('CENT','ORTH',2,.false.,ycen)
      call parsesubreal('CENT','ORTH',3,.false.,zcen)
c F000
      call parsekey('F000',lf000)
c FORM
      call parsesubint ('FORM','    ',1,.true.,l)
      call parsesubreal('FORM','    ',2,.true.,fa1(l))
      call parsesubreal('FORM','    ',3,.true.,fb1(l))
      call parsesubreal('FORM','    ',4,.true.,fa2(l))
      call parsesubreal('FORM','    ',5,.true.,fb1(l))
c MASK
      call parsesubreal('MASK','RADI',1,.true.,mskrad)      
c MODEL
      call parsesubreal('MODE','RADI',1,.true.,mdlrad)
      call parsesubreal('MODE','RESO',1,.true.,mdlres)
      call parsesubreal('MODE','BFAC',1,.true.,mdlbfc)
      call parsesubreal('MODE','ROTA',1,.true.,alpha0)
      call parsesubreal('MODE','ROTA',2,.true.,beta0)
      call parsesubreal('MODE','ROTA',3,.true.,gamma0)
c STRUC
      call parsekey('STRU',lstru)
      call parsesubreal('STRU','REAL',1,.true.,rscale)
      call parsesubreal('STRU','RECI',1,.true.,hscale)
c FILT
      call parsesubkey ('FILT','MAP ',lfmap)
      call parsesubkey ('FILT','MODE',lfmdl)
      call parsesubkey ('FILT','VARI',lfstd)
      call parsesubreal('FILT','RADI',1,.true.,fltrad)
c TRUN
      call parsesubreal('TRUN','    ',1,.true.,rmin)
      call parsesubreal('TRUN','    ',2,.true.,rmax)
c RESO
      call parsesubreal('RESO','    ',1,.true.,tmin)
      call parsesubreal('RESO','    ',2,.true.,tmax)
c LABI
      call parselabin(mtzin,lsprgi,nlprgi)
c TITL
      call parsekeyarg('TITL',title)
c VERB
      call parseint('VERB',iverb)
c
c
c next keyword
      call parsediagnose(cont)
      if (cont) goto 200
c
c End of input section ----------------------------------------
c
      if (lscln) scale=-1.0
      if (lf000) xf000=-1.0
      if (lfmap) fltmap=1
      if (lfmdl) fltfrg=1
      if (lfstd) fltmap=2*fltmap
      if (lfstd) fltfrg=2*fltfrg
      if (.not.lstru) rscale=-1.0
      if (solc.lt.0.0.or.solc.gt.1.0) goto 9008
c
c MAKE COMMENTS
c      call ccp4h_header('Comments','comments',2)
c
c open mtz input file and perform column assignments
      call ccp4h_header('MTZ Input','mtzin',3)
      iprint=1
      call lropen(mtzin,'HKLIN',iprint,ifail)
      if (ifail.eq.1) goto 9001
      call lrassn(mtzin,lsprgi,nlprgi,jpoint,ctprgi)
      call lrncol(mtzin,ncols)
c
c read cell, symmetry and resolution range
      call lrcell(mtzin,cell)
c
      call lrsymi(mtzin,nsymp,ltype,nspgrp,namspg,nampg)
      call lrsymm(mtzin,nsym,rsym)
      call pgnlau(nampg,nlaue,namlau)
      if (nsym.gt.96) goto 9002
c
c get resolution limits
c tmin/tmax truncate data, smin/max for search.
      call lrrsol(mtzin,smin,smax)
      smin=max(1.0/rmin**2,smin)
      smax=min(1.0/rmax**2,smax)
      tmin=max(1.0/tmin**2,smin)
      tmax=min(1.0/tmax**2,smax)
      rmin=sqrt(1.0/max(smin,1.0e-6))
      rmax=sqrt(1.0/smax)
c mdlres=model atom resolution
      if (mdlres.gt.0.0) then
       mdlres=1.0/mdlres**2
      else if (mdlres.lt.0.0) then
       mdlres=tmax
      endif
c
c get centre for output fragments
      call calcmetric()
      if (xcen.gt.-999999) call symuvw(qt,xcen,ycen,zcen,ucen,vcen,wcen)
c
c check for input files
      call ugtenv('SOLIN',line)
      inputsolmask=(line.ne.' ')
      call ugtenv('XYZIN',line)
      inputmodel  =(line.ne.' ')
      call ugtenv('MAPIN',line)
      inputmap    =(line.ne.' ')
      call ugtenv('MAXIN',line)
      inputmax    =(line.ne.' ')
c
c set up pointers for input columns
      ifo   =jpoint(4)
      isfo  =jpoint(5)
      iphio =jpoint(6)
      ifomo =jpoint(7)
      ihla  =jpoint(8)
      ihlb  =jpoint(9)
      ihlc  =jpoint(10)
      ihld  =jpoint(11)
      ifdm  =jpoint(12)
      iphidm=jpoint(13)
      ifomdm=jpoint(14)
      ifpc  =jpoint(15)
      iphipc=jpoint(16)
      ifree =jpoint(17)
c
      return
 9000 call ccperr(1,' (RCARDS) unknown keyword')
 9001 call ccperr(1,' (RCARDS) input .mtz file absent')
 9002 call ccperr(1,' (RCARDS) too many symmetry operators - limit 96')
 9003 call ccperr(1,' (RCARDS) data resolution too low')
 9005 call ccperr(1,' (RCARDS) AVER: enter indentity matrix first')
 9006 call ccperr(1,' (RCARDS) AVER: wrong number of ncs operators')
 9007 call ccperr(1,' (RCARDS) NCYC: maximum ncyc exceeded')
 9008 call ccperr(1,' (RCARDS) SOLC: content missing or out-of-range')
 9009 call ccperr(1,' (RCARDS) NCSMASK NMER: compulsory for automask')
 9010 call ccperr(1,' (RCARDS) Invalid MODE option')
      end
c
c ----------------------------------------------------------------------
c
      subroutine inicalc()
      include 'fffear.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
      include 'hkldata.fh'
      include 'hkllim.fh'
      include 'uvwdata.fh'
c INICALC - calculate constants required by the program
c Calculates everything possible based on card input and .mtz header
c some things may be re-calculated later, e.g. F(000) if input mask
c
      integer mspgrp,mu,mv,mm,mu1,mv1,mm1,mu2,mv2,mm2
      real mcell(9)
      integer numres
      external numres
c
c seed random numbers
      call rseed(54321)
c
c data resolution and limits
      hmax=int(cell(1)*sqrt(smax))
      kmax=int(cell(2)*sqrt(smax))
      lmax=int(cell(3)*sqrt(smax))
      hmin=-hmax
      kmin=-kmax
      lmin=0
      hmaxt=int(cell(1)*sqrt(tmax))
      kmaxt=int(cell(2)*sqrt(tmax))
      lmaxt=int(cell(3)*sqrt(tmax))
      hmint=-hmaxt
      kmint=-kmaxt
      lmint=0
c
c work out grid sizes
      nus=nu/2
      nvs=nv/2
      nws=nw/2
      call gridres(1.0/(srcgrd*sqrt(tmax)),nus,nvs,nws)
      nu=2*nus
      nv=2*nvs
      nw=2*nws
      if (hmaxt.ge.nus/2.or.kmaxt.ge.nvs/2.or.lmaxt.ge.nws/2) goto 9000
c ... map
      uvwsize=nu*nv*(nw+2)
      uvwsmll=nus*nvs*(nws+2)
      if (inputmap) then
       call ccpmaphead('MAPIN',
     +   mspgrp,mcell,mu,mv,mm,mu1,mv1,mm1,mu2,mv2,mm2)
       uvwsize=max(uvwsize,2*max(max(mu2-mu1+2,mv2-mv1+2),mm2-mm1+2)**3)
      else if (inputmax) then
       call ccpmaphead('MAXIN',
     +   mspgrp,mcell,mu,mv,mm,mu1,mv1,mm1,mu2,mv2,mm2)
       uvwsize=max(uvwsize,2*max(max(mu2-mu1+2,mv2-mv1+2),mm2-mm1+2)**3)
      endif
c
c F(000) term
      f000=vol*(avesol*solc+aveprt*(1.0-solc))
c
c scattering factors
      call setshapefn()
c
c estimate number of reflections in resolution sphere (with room for error)
      nrflc=100+numres(rmax)
      return
 9000 call ccperr(1,' (INICALC) error GRID too small for HKL data')
      end
c
c ----------------------------------------------------------------------
c
      subroutine hklin(hkls,assigned)
      include 'fffear.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'hkldata.fh'
      include 'mtzdata.fh'
      include 'hkllab.fh'
c HKLIN - read columns from .mtz file
c
      real hkls(nhklc,0:*)
      logical assigned(nhklc)
c
      logical eof,centre,sysabs,logmss(200)
      real adata(200),sh(nhklc),sh2(nhklc),hmx(nhklc),hmn(nhklc)
      character colnam(nhklc)*6
c
      integer in(3),nfile,nres,nhires,nsysab,notasu,nunobs,ncen,ncenerr
      integer ih,ik,il,inasu,i
      real s,eps,phicen,fo,sfo,phio,fomo,fdm,phidm,fomdm,fpc,phipc
      real rrand,flag,hla,hlb,hlc,hld,x,atanh,sim,siminv
c
      external inasu,rrand,atanh,sim,siminv
c
      data sh,sh2,hmx,hmn/
     +            nhklc*0.0,nhklc*0.0,nhklc*-1000.0,nhklc*1000.0/
      data colnam/'H','K','L','S','EPS','FO','PHIO','FOMO',
     +            'HL-A','HL-B','HL-C','HL-D','FPC','PHIPC',
     +            'FDM','PHIDM','FOMDM',7*'x','FREE'/
c
      nfile=0
      nrflo=0
      nres=0
      nhires=0
      nsysab=0
      notasu=0
      nunobs=0
      ncen=0
      ncenerr=0
      do i=1,200
        logmss(i) = .false.
      enddo
c
      assigned(lfdm)  =(ifdm.ne.0)  
      assigned(lphidm)=(iphidm.ne.0)
      assigned(lfomdm)=(ifomdm.ne.0)
      assigned(lfpc)  =(ifpc.ne.0)  
      assigned(lphipc)=(iphipc.ne.0)
      assigned(lfree) =(ifree.ne.0)
      if (ifree.ne.0) numbfree=0
c
 100    call lrrefl(1,s,adata,eof)
        if (eof) goto 200
c
        call lrrefm(1,logmss)
        do 101 i=1,200
         if (logmss(i)) adata(i)=0.0
 101    continue
c
        nfile=nfile+1
c        call rseed(nfile+mod(37*nfile,53))
        ih=nint(adata(1))
        ik=nint(adata(2))
        il=nint(adata(3))
        in(1)=ih
        in(2)=ik
        in(3)=il
c Get epsilon zone and centric flag
        call epscen(ih,ik,il,centre,sysabs,eps,phicen,nsym,rsym)
        if (centre) eps=-eps
c Get standard deviation of F - zero for unobserved
        sfo=1.0
        if (isfo.ne.0) sfo=adata(isfo)
        if (logmss(ifo)) sfo=0.0
c reject reflections
        if (s.lt.smin.or.s.gt.smax) then
          nres=nres+1
          goto 100
        endif
        if (sysabs) then
          nsysab=nsysab+1
          goto 100
        endif
        if (inasu(in,nlaue).ne.1) then
          notasu=notasu+1
          goto 100
        endif
        nrflo=nrflo+1
        if (nrflo.gt.nrflc) goto 9000
c Get reflection data ....
        fo=adata(ifo)
        phio=0.0
        fomo=1.0
        if (iphio.ne.0) phio=dtor*adata(iphio)
        if (ifomo.ne.0) fomo=adata(ifomo)
        hla = 0.0
        if (ihla.ne.0) hla = adata(ihla)
        hlb = 0.0
        if (ihlb.ne.0) hlb = adata(ihlb)
        hlc = 0.0
        if (ihlc.ne.0) hlc = adata(ihlc)
        hld = 0.0
        if (ihld.ne.0) hld = adata(ihld)
c correct centric phases and count erroneous phases, unobs reflections
        if (centre) then
         ncen=ncen+1
         if ((cos(2.0*(phio-phicen)).lt.0.99).and.
     +     (.not.logmss(iphio))) ncenerr=ncenerr+1
         phio=nint((phio-phicen)/pi)*pi+phicen
        endif
        if (sfo.le.0.0) nunobs=nunobs+1
        if (s.gt.tmin.and.s.lt.tmax) nhires=nhires+1
c get starting points - default is mir data, overridden by cols.
c     BUT if a different f is given, don't use mir weight
        fdm=fo
        phidm=phio
        fomdm=fomo
        if (ifdm.ne.0)   fomdm=1.0
        if (ifdm.ne.0)   fdm=adata(ifdm)
        if (iphidm.ne.0) phidm=dtor*adata(iphidm)
        if (ifomdm.ne.0) fomdm=adata(ifomdm)
c Get free-r flag - 1...20 for 5% free-r sets
c if there is a free-r set on file then those get 1.0
        if (ifree.ne.0) then
         flag=real(nint(adata(ifree))+1)
         numbfree=max(numbfree,nint(flag))
        else
         flag=real(int(rrand()*numbfree)+1)
        endif
c Get partial structure model phase ?OBSOLETE?
        if (ifpc.ne.0)   fpc=adata(ifpc)
        if (iphipc.ne.0) phipc=dtor*adata(iphipc)
c check for FOM errors
        if (fomo .lt.0.0.or.fomo .gt.1.0.or.
     +      fomdm.lt.0.0.or.fomdm.gt.1.0) write(lpt,*)
     +    '(HKLIN) Error in input mtz - must have 0 <= FOM <= 1'
        fomo =max(min(fomo ,1.0),0.0)
        fomdm=max(min(fomdm,1.0),0.0)
c flag unobserved
        if (sfo.eq.0.0) fo=-0.01
c store in reflection array
        hkls(1,nrflo)=adata(1)
        hkls(2,nrflo)=adata(2)
        hkls(3,nrflo)=adata(3)
        hkls(4,nrflo)=s
        hkls(5,nrflo)=eps
        hkls(lfo,nrflo)=fo
        hkls(lphio,nrflo)=phio
        hkls(lfomo,nrflo)=fomo
        hkls(lhla,nrflo)=hla
        hkls(lhlb,nrflo)=hlb
        hkls(lhlc,nrflo)=hlc
        hkls(lhld,nrflo)=hld
        hkls(lfpc,nrflo)=fpc
        hkls(lphipc,nrflo)=phipc
        hkls(lfdm,nrflo)=fdm*fomdm
        hkls(lphidm,nrflo)=phidm
        hkls(lfomdm,nrflo)=fomdm
        hkls(lfree,nrflo)=flag
        hkls(lflag,nrflo)=1
c
c accumulate some stats
        do 190 i=1,nhklc
         if (assigned(i)) then
          sh(i)=sh(i)+hkls(i,nrflo)
          sh2(i)=sh2(i)+hkls(i,nrflo)**2
          hmx(i)=max(hmx(i),hkls(i,nrflo))
          hmn(i)=min(hmn(i),hkls(i,nrflo))
         endif
 190    continue
c next reflection
        goto 100
c
c store F(000) term
 200  hkls(lfo,0)=f000
c write out some information
      do 205 i=1,nhklc
       sh(i)=sh(i)/nrflo
       sh2(i)=sh2(i)/nrflo
 205  continue
c
      write (lpt,210)nfile,nres,nsysab,notasu,nrflo
 210  format (/' Number of reflections on file:   ',i6
     +        /' Number outside resolution limit: ',i6
     +        /' Number of systematic absences:   ',i6
     +        /' Number outside asymmetric unit:  ',i6
     +        /' Number of reflections used:      ',i6)
c
      write (lpt,215)nunobs,ncen,ncenerr,nhires
 215  format (/' Number of unobserved reflections:                ',i6
     +        /' Number of centric reflections:                   ',i6
     +        /' Number of centric phases more than 4 degrees out:',i6
     +        /' Number of reflections used for search function:  ',i6)
c
      write (lpt,220)
 220  format (/' Program data read:'
     +  /' Column:      MIN       MAX       MEAN X    MEAN X^2')
      do 240 i=1,nhklc
       if (assigned(i))
     +   write (lpt,230)colnam(i),hmn(i),hmx(i),sh(i),sh2(i)
 240  continue
 230  format (4x,a6,1x,f9.3,1x,f9.3,1x,f9.3,1x,f11.2)
c
      return
 9000 call ccperr(1,' (HKLIN) Too many reflections - supply only ASU')
      end
c
c ----------------------------------------------------------------------
c
      subroutine calcscale(hkls,assigned)
      include 'fffear.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
c SCALEF - calculate the scale of the input data
c uses columns h,k,l,s,eps,fo to calculate bfac,scale
c
c in: if scale > 0.0 no scaling is performed
c     if scale < 0.0 scale is applied but no b-factor
c
      real hkls(nhklc,0:*)
      logical assigned(nhklc)
c
      real res(50),std(50),rres(50),sres(50),rstd(50)
      real ncal(50),f2cal(50),nobs(50),f2obs(50)
      integer ndatares
c
      integer i,j,nr,nres,nrstep,numres
      real srmin,srmax,varprt,varsol,rhoave,rhovar,s,sc
      real x,y1,y2,w,sw,sx,sx2,sdy,sdyx
c
      external numres
c data from ins
      data ndatares/19/
      data res/999.00,10.00, 8.00, 7.00, 6.00, 5.00, 4.50, 4.00, 3.60,
     +     3.30, 3.00, 2.80, 2.60, 2.40, 2.20, 2.00, 1.80, 1.60, 1.50,
     +     31*0.0/
      data std/ 0.000,0.076,0.107,0.121,0.143,0.200,0.248,0.316,0.375,
     +    0.427,0.476,0.512,0.552,0.599,0.654,0.718,0.783,0.850,0.890,
     +     31*0.0/
c
c first pick the resolution ranges
c ================================
      nrstep=25
      rres(1)=0.0
      rstd(1)=0.0
      nres=0
      nr=0
      do 100 i=2,ndatares
        srmin=1.0/res(i-1)**2
        srmax=1.0/res(i)**2
        do 50 j=1,nrflo
          if (hkls(4,j).ge.srmin.and.hkls(4,j).lt.srmax
     +     .and.hkls(lfo,j).ge.0.0) nr=nr+1
 50     continue
        if (nr.gt.nrstep) then
          nr=0
          nres=nres+1
          rres(nres)=res(i)
          rstd(nres)=std(i)
        endif
 100  continue
c
c calculate estimated variances with resolution for this structure
c ================================================================
      do 110 i=1,nres
c pick up varience of protein region (res.dep.) and solvent (almost flat)
      varprt=rstd(i)**2
      varsol=varprt/10.0
c now calc overall mean and variance
      rhoave=aveprt*(1.0-solc)+avesol*solc
      rhovar=(varprt+(aveprt-rhoave)**2)*(1.0-solc) +
     +       (varsol+(avesol-rhoave)**2)*solc
c store expected data sizes
      ncal(i)=numres(rres(i))
      f2cal(i)=rhovar*vol**2/(2.0*nsym)
 110  continue
c now do differences for individual ranges
      do 120 i=nres,2,-1
      ncal(i)=ncal(i)-ncal(i-1)
      f2cal(i)=f2cal(i)-f2cal(i-1)
 120  continue
c
c now produce obs data stats for each resolution range
c ====================================================
      call calcsobs(hkls,nres,rres,sres,nobs,f2obs)
      if (scale.gt.0.0) goto 350
      if (rmax.gt.res(5)) goto 9010
c
c calculate scale and B-factor to produce best fit between obs and calc
c =====================================================================
      sw=0.0
      sx=0.0
      sx2=0.0
      sdy=0.0
      sdyx=0.0
      do 300 i=1,nres
        x=sres(i)/nobs(i)
        y1=log(f2cal(i)/ncal(i))
        y2=log(f2obs(i)/nobs(i))
c Empirical weighting scheme:
c uniform weight gives too little influence to high res data.
c (but there are more ranges at high res)
c weighting with number of reflections give too much influence to high res data.
c (but taking into account the SD's might put it right)
        w=1.0
        sw=sw+w
        sx=sx+w*x
        sx2=sx2+w*x**2
        sdy=sdy+w*(y2-y1)
        sdyx=sdyx+w*(y2-y1)*x
 300  continue
      if (scale.eq.0.0) bfac=(sw*sdyx-sx*sdy)/(sx**2-sw*sx2)*2.0
      scale=exp((sx2*sdy-sx*sdyx)/(sx**2-sw*sx2))
c
c rescale the input data to match the calc distributions
c ======================================================
 350  do 400 i=1,nrflo
        s=hkls(4,i)
        sc=sqrt(scale)*exp(bfac*s/4.0)
        hkls(lfo,i) =sc*hkls(lfo,i)
        hkls(lfdm,i)=sc*hkls(lfdm,i)
        if (assigned(lfpc)) hkls(lfpc,i)=sc*hkls(lfpc,i)
 400  continue
c
c produce stats for rescaled obs data
c ===================================
      call calcsobs(hkls,nres,rres,sres,nobs,f2obs)
c
c output data
c ===========
      write (lpt,500)scale,bfac
 500  format (/,
     +' Input data analysis:',/,
     +'   Estimated intensity scale factor = ',f10.3,/
     +'   Estimated temperature factor     = ',f10.3,/)
      call ccp4h_graph_beg(0,0)
      write (lpt,510)
 510  format (' $TABLE: Analysis of input structure factors :',/,
     +' $GRAPHS: Data completeness with resolution :N:2,4:',/,
     +'        : Mean F^2 with resolution          :N:2,5,6:',/,
     +' $$',/,
     +'  res   1/resol^2  number    %present      expect.   obs. $$',/,
     +' (lim)(4sin2th/l2)(reflns) (completeness)    (mean F^2)   $$')
      do 520 i=1,nres
      write (lpt,530)rres(i),sres(i)/nobs(i),
     +  nobs(i),100.0*nobs(i)/ncal(i),f2cal(i)/ncal(i),f2obs(i)/nobs(i)
 520  continue
 530  format(1x,f5.2,2x,f6.3,4x,f7.0,6x,f6.1,2x,2f9.0)
      write (lpt,'(a)')' $$'
      call ccp4h_graph_end()
c
      return
 9010 call ccperr(1,
     +  ' (CALCSCALE) - insufficent resolution: enter a SCALE card')
      end
c
c ----------------------------------------------------------------------
c
      subroutine calcsobs(hkls,nres,rres,sres,nobs,f2obs)
      include 'fffear.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
c CALCSOBS - accumulate some statistics on observed data for CALCSCALE
c
      real hkls(nhklc,0:*)
      real rres(*),sres(*),nobs(*),f2obs(*)
c
      integer i,j,ir,nres
      real s,eps,fo
c
      do 140 i=1,nres
      sres(i)=0.0
      nobs(i)=0.0
      f2obs(i)=0.0
 140  continue
c
      do 200 j=1,nrflo
       s=hkls(4,j)
       eps=abs(hkls(5,j))
       fo=hkls(lfo,j)
c check for absent rfls
       if (fo.ge.0.0) then
        do 150 ir=1,nres-1
         if (s.lt.1.0/rres(ir)**2) goto 160
 150    continue
 160    nobs(ir)=nobs(ir)+1.0
        f2obs(ir)=f2obs(ir)+fo**2/eps
        sres(ir)=sres(ir)+s
       endif
 200  continue
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine wfo(hkls,lf,lphi)
      include 'fffear.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
c calculate initial map coefficients from input data
c and copy into fdm and phidm columns
      real hkls(nhklc,0:*)
      integer lf,lphi
c
      integer i
      real w
c
      w=0.0
      hkls(lf,0)=hkls(lfo,0)
      hkls(lphi,0)=0.0
      do 100 i=1,nrflo
       if (hkls(lflag,i).gt.0.0) then
        hkls(lf,i)=hkls(lfdm,i)
        hkls(lphi,i)=hkls(lphidm,i)
        w=w+hkls(lfomdm,i)
       else
        hkls(lf,i)=0.0
        hkls(lphi,i)=0.0
       endif
 100  continue
c
      if (w.lt.0.1) call ccperr(1,
     +  ' (WFO) No density in map! Check input FOM present and nonzero')
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine setfreer(hkls,icfr,ncfr,icycl)
      include 'fffear.fh'
      include 'io.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
c SETFREER - pick an excluded set of reflections for free R-factor calc
c
      real hkls(nhklc,0:*)
      integer icfr,ncfr,icycl
c
      integer i,ipick,ninc,nexc,nincfr,nexcfr
c
c pick a fraction of the non-centric reflections
      ipick=icfr
      if (ncfr.eq.1) then
       ipick=mod(icycl,numbfree)+1
      else if (icfr.eq.ncfr) then
       return
      endif
      nexc=0
      ninc=0
      nexcfr=0
      nincfr=0
      do 100 i=1,nrflo
c pick a validation set and flag them
       if (hkls(lflag,i).eq.0) nexc=nexc+1
       if (hkls(lflag,i).eq.1) ninc=ninc+1
       if (nint(hkls(lfree,i)).eq.ipick) then
        if (hkls(lflag,i).eq.0) nexcfr=nexcfr+1
        if (hkls(lflag,i).eq.1) nincfr=nincfr+1
        hkls(lflag,i)=-1.0
       endif
c next reflection
 100  continue
c
      write (lpt,200)nincfr,ninc,nexcfr,nexc,nincfr+nexcfr,ninc+nexc
 200  format (
     +  '  Included reflections used for Free-R: ',i7,' of ',i7/
     +  '  Excluded reflections used for Free-R: ',i7,' of ',i7/
     +  '     Total reflections used for Free-R: ',i7,' of ',i7/)
c
      return
      end
c
c ----------------------------------------------------------------------
c
c
c ----------------------------------------------------------------------
c
      subroutine solmskin(solmsk,lmask)
      include 'fffear.fh'
      include 'uvwdata.fh'
      include 'crystal.fh'
c SOLMSKIN - read in a mask and expand by xtal sym
      integer solmsk(0:nu-1,0:nv-1,0:nw-1),lmask(0:*)
c
      real cell1(6)
      integer iu,iv,iw,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,nspgrp1
      character*600 title
c
      do 50 iw=0,nw-1
      do 50 iv=0,nv-1
      do 50 iu=0,nu-1
       solmsk(iu,iv,iw)=0
 50   continue
c
c read in input mask
      call ccpmaphead('SOLIN',nspgrp1,cell1,
     +                mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2)
      call ccpmskin('SOLIN',title,lmask,mu1,mv1,mw1,mu2,mv2,mw2)
c
c copy onto work grid and expand
      call solmaskgrid(solmsk,lmask,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2)
c
c display the mask
      call maskstats(solmsk,nu,nv,nw,0)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine solmaskgrid(mb,ma,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2)
      include 'fffear.fh'
      include 'uvwdata.fh'
      include 'crystal.fh'
c get solvent mask and expand by cell repeat and symmetry
c
      integer mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2
      integer ma(mu1:mu2,mv1:mv2,mw1:mw2),mb(0:nu-1,0:nv-1,0:nw-1)
c
      integer m,iu,iv,iw,ju,jv,jw
      real u1,v1,w1
c
      integer lmod
      external lmod
c
      do 200 iw=mw1,mw2
      do 200 iv=mv1,mv2
      do 200 iu=mu1,mu2
       if (ma(iu,iv,iw).ne.0) then
        do 100 jw=nint((iw-0.5)/mw*nw+0.48),nint((iw+0.5)/mw*nw-0.48)
        do 100 jv=nint((iv-0.5)/mv*nv+0.48),nint((iv+0.5)/mv*nv-0.48)
        do 100 ju=nint((iu-0.5)/mu*nu+0.48),nint((iu+0.5)/mu*nu-0.48)
         mb(lmod(ju,nu),lmod(jv,nv),lmod(jw,nw))=ma(iu,iv,iw)
 100    continue
       endif
 200  continue
c
c symmetry expand
      do 310 iw=0,nw-1
      do 310 iv=0,nv-1
      do 310 iu=0,nu-1
       if (mb(iu,iv,iw).ne.0) then
        do 305 m=2,nsym
         call symuvw(rsym(1,1,m),
     +               real(iu)/nu,real(iv)/nv,real(iw)/nw,u1,v1,w1)
         mb(lmod(nint(nu*u1),nu),
     +      lmod(nint(nv*v1),nv),
     +      lmod(nint(nw*w1),nw))=mb(iu,iv,iw)
 305    continue
       endif
 310  continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine maskstats(mask,mu,mv,mw,jw)
      include 'fffear.fh'
      include 'io.fh'
      include 'uvwdata.fh'
c MASKSTATS - output a mask section to log file
c
      integer mu,mv,mw,mask(0:mu-1,0:mv-1,0:mw-1),jw
c
      integer iu,iv,iw,ju,jv,lu,lv,nmask,lmod
      real scx,scy
      character str*72
      external lmod
c
c calculate fraction of cell masked
      nmask=0
      do 100 iw=0,mw-1
      do 100 iv=0,mv-1
      do 100 iu=0,mu-1
      if (mask(iu,iv,iw).gt.0) nmask=nmask+1
 100  continue
c
      write (lpt,110)100.0*nmask/(nu*nv*nw)
 110  format (12x,'The masked region occupies ',f5.1,' % of the cell.')
      write (lpt,120)
 120  format (12x,'Maps are x-y sections with the x-axis horizontal'/
     +        12x,'and the origin top left.')
c
c display sections of the mask: width 64, y/x=1.25
      str=' '
      scx=real(max(mu,mv))/64.0
      scy=scx*1.25
      lu=nint(mu/scx)
      lv=nint(mv/scy)
c loop through sections
      write (lpt,220)jw,mw
 220  format(/' Section ',i3,' of ',i3/)
c print a section
      do 300 iv=1,lv
      jv=lmod(nint(scy*real(iv-1)),mv)
      do 290 iu=1,lu
      ju=lmod(nint(scx*real(iu-1)),mu)
      str(iu:iu)=' '
      if (iu.eq.1.or.iu.eq.lu.or.iv.eq.1.or.iv.eq.lv) str(iu:iu)='+'
      if (mask(ju,jv,jw).gt.0) str(iu:iu)='*'
      if (mask(ju,jv,jw).lt.0) str(iu:iu)='?'
 290  continue
      write (lpt,295)str
 295  format (1x,a)
 300  continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine rhostats(map,solmsk)
      include 'fffear.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
      include 'uvwdata.fh'
c RHOSTATS - output some statistics on the electron density
c
      real map(nu,nv,nw)
      integer solmsk(nu,nv,nw)
c
      integer nhist
      real rhomin,rhomax,pmin,pmax
      parameter (nhist=100,rhomin=-5.0,rhomax=20.0,pmin=-0.9,pmax=2.4)
      integer hist(nhist,-10:10)
      integer i,j,k,l,n,ih,imin,imax,nr(-10:10)
      real s(-10:10),s2(-10:10),rmax(-10:10),rmin(-10:10),rho
c
      do 20 i=-10,10
       nr(i)=0
       s(i)=0.0
       s2(i)=0.0
       rmin(i)= 1000.0
       rmax(i)=-1000.0
       do 10 j=1,nhist
        hist(j,i)=0
 10    continue
 20   continue
c
      do 100 k=1,nw
      do 100 j=1,nv
      do 100 i=1,nu
       rho=map(i,j,k)
       ih=int(nhist*(rho-rhomin)/(rhomax-rhomin))
       ih=max(min(ih,nhist),1)
       l=solmsk(i,j,k)
       nr(l)=nr(l)+1
       s(l)=s(l)+rho
       s2(l)=s2(l)+rho**2
       rmax(l)=max(rmax(l),rho)
       rmin(l)=min(rmin(l),rho)
       hist(ih,l)=hist(ih,l)+1
 100  continue
c
      n=nu*nv*nw
      write (lpt,200)
      write (lpt,201)'Protein',(100.0*nr(1))/n,rmin(1),rmax(1),
     +  s(1)/nr(1),sqrt(max(s2(1)*nr(1)-s(1)**2,0.0))/nr(1)
      write (lpt,201)'Solvent',(100.0*nr(0))/n,rmin(0),rmax(0),
     +  s(0)/nr(0),sqrt(max(s2(0)*nr(0)-s(0)**2,0.0))/nr(0)
      if (nr(-1).ne.0) write (lpt,201)'Unknown',(100.0*nr(-1))/n,
     +  rmin(-1),rmax(-1),s(-1)/nr(-1),
     +  sqrt(max(s2(-1)*nr(-1)-s(-1)**2,0.0))/nr(-1)
 200  format(/9x,'% of cell   Min Rho   Max Rho   Mean Rho   Std.Dev.')
 201  format(1x,a7,': ',f8.1,'  ',f8.3,'  ',f8.3,'   ',f8.3,'   ',f8.3)
      imin=int(nhist*(pmin-rhomin)/(rhomax-rhomin))
      imax=int(nhist*(pmax-rhomin)/(rhomax-rhomin))
      write (lpt,205)
 205  format (/' Density       Number of counts:   Number of counts:'
     +        /' Range:        (Protein)           (Solvent)')
      do 220 i=imin,imax
      rho=(i+0.5)*(rhomax-rhomin)/nhist+rhomin
      write (lpt,210)rho,hist(i,1),hist(i,0)
 210  format(1x,f8.3,8x,i10,10x,i10)
 220  continue
      write (lpt,*)
c
c      do 300 i=-10,10
c       if (s(i).gt.0) write (*,*)i,s(i)
c 300  continue
      return
      end
c
c ----------------------------------------------------------------------
c


