C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c
c ----------------------------------------------------------------------
c
      subroutine mapfilter(map,wrk)
c apply real space filtering to map
      include 'fffear.fh'
      include 'crystal.fh'
      include 'params.fh'
      include 'uvwdata.fh'
      include 'srcdata.fh'
      include 'io.fh'
c
      real map(0:nu-1,0:nv-1,0:nw-1)
      real wrk(0:nu-1,0:nv-1,0:nw-1)
c
      integer ndn,ndx(maxfeature),ndy(maxfeature),ndz(maxfeature)
      real ndr(maxfeature)
c
      integer i,iu,iv,iw
      real r,s,sr,sr2
c
      integer lmod
      external lmod
c
      write (lpt,510)
 510  format(/,' EXPERIMENTAL MAP FILTERING')
      call neighbours(fltrad,rlm11/(nu*nu),rlm22/(nv*nv),rlm33/(nw*nw),
     +                       rlm23/(nv*nw),rlm13/(nu*nw),rlm12/(nu*nv),
     +                ndx,ndy,ndz,ndr,ndn)
c
      do iw=0,nw-1
      do iv=0,nv-1
      do iu=0,nu-1
       s  =real(ndn)
       sr =0.0
       sr2=0.0
       do i=1,ndn
        r=map(lmod(iu+ndx(i),nu),lmod(iv+ndy(i),nv),lmod(iw+ndz(i),nw))
        sr =sr +r
        sr2=sr2+r**2
       enddo
       sr2=sqrt(s*sr2-sr*sr)/s
       sr =sr/s
       if (fltmap.eq.2) then
        wrk(iu,iv,iw)=frgave+frgstd*(map(iu,iv,iw)-sr)/sr2
       else
        wrk(iu,iv,iw)=frgave+(map(iu,iv,iw)-sr)
       endif
      enddo
      enddo
      enddo
c
      do iw=0,nw-1
      do iv=0,nv-1
      do iu=0,nu-1
       map(iu,iv,iw)=wrk(iu,iv,iw)
      enddo
      enddo
      enddo
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine frgfilter(map,msk,wrk)
c apply real space filtering to fragment
      include 'fffear.fh'
      include 'params.fh'
      include 'srcdata.fh'
      include 'io.fh'
c
      complex map(0:hgrid-1,0:hgrid-1,0:hgrid-1)
      complex msk(0:hgrid-1,0:hgrid-1,0:hgrid-1)
      real wrk(0:hgrid-1,0:hgrid-1,0:hgrid-1)
c
      integer ndn,ndx(maxfeature),ndy(maxfeature),ndz(maxfeature)
      real ndr(maxfeature)
c
      integer i,iu,iv,iw,ju,jv,jw
      real r,s,sr,sr2
c
      write (lpt,510)
 510  format(/,' SEARCH MODEL FILTERING')
      call neighbours(fltrad,rscale**2,rscale**2,rscale**2,0.0,0.0,0.0,
     +                ndx,ndy,ndz,ndr,ndn)
c
      do iw=0,hgrid-1
      do iv=0,hgrid-1
      do iu=0,hgrid-1
       wrk(iu,iv,iw)=0.0
       if (real(msk(iu,iv,iw)).gt.0.5) then
        s  =0.0
        sr =0.0
        sr2=0.0
        do i=1,ndn
         ju=iu+ndx(i)
         jv=iv+ndy(i)
         jw=iw+ndz(i)
         if (ju.ge.0.and.ju.lt.hgrid.and.jv.ge.0.and.jv.lt.hgrid.and.
     +     jw.ge.0.and.jw.lt.hgrid) then
          if (real(msk(ju,jv,jw)).gt.0.5) then
           r=real(map(ju,jv,jw))
           s  =s  +1.0
           sr =sr +r
           sr2=sr2+r**2
          endif
         endif
        enddo
        sr2=sqrt(s*sr2-sr*sr)/s
        sr =sr/s
        r=real(map(iu,iv,iw))
        if (fltfrg.eq.2) then
         wrk(iu,iv,iw)=frgave+frgstd*(r-sr)/sr2
        else
         wrk(iu,iv,iw)=frgave+(r-sr)
        endif
c        write (*,'(3i4,6f10.4)')iu,iv,iw,s,sr,sr2,frgave,r,wrk(iu,iv,iw)
       endif
      enddo
      enddo
      enddo
c
      do iw=0,hgrid-1
      do iv=0,hgrid-1
      do iu=0,hgrid-1
c       if (real(map(iu,iv,iw)).ne.0.0)
c     +   write (17,'(3i4,2f10.4)')iu,iv,iw,map(iu,iv,iw)
       map(iu,iv,iw)=cmplx(wrk(iu,iv,iw),0.0)
c       if (real(map(iu,iv,iw)).ne.0.0)
c     +   write (18,'(3i4,2f10.4)')iu,iv,iw,map(iu,iv,iw)
      enddo
      enddo
      enddo
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine frgstats(map,msk)
c apply real space filtering to fragment
      include 'fffear.fh'
      include 'params.fh'
      include 'srcdata.fh'
      include 'io.fh'
c
      complex map(0:hgrid-1,0:hgrid-1,0:hgrid-1)
      complex msk(0:hgrid-1,0:hgrid-1,0:hgrid-1)
c
      integer iu,iv,iw
      real r,s,sr,sr2
c
      s  =0.0
      sr =0.0
      sr2=0.0
      do iw=0,hgrid-1
      do iv=0,hgrid-1
      do iu=0,hgrid-1
       if (real(msk(iu,iv,iw)).gt.0.0) then
        r=real(map(iu,iv,iw))
        s  =s  +1.0
        sr =sr +r
        sr2=sr2+r**2
       endif
      enddo
      enddo
      enddo
      sr2=sqrt(s*sr2-sr*sr)/s
      sr =sr/s
      frgave=sr
      frgstd=sr2
c      write (*,*)' Fragment stats ',frgave,frgstd
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine neighbours(rad,m11,m22,m33,m23,m13,m12,
     +                      ndx,ndy,ndz,ndr,ndn)
c get a neighbour list for current grid
      include 'fffear.fh'
      include 'io.fh'
c
      integer ndn,ndx(*),ndy(*),ndz(*)
      real ndr(*),rad,m11,m22,m33,m23,m13,m12
c
      integer nx,ny,nz,dx,dy,dz,sx,sy,sz
      real r
c
c      write (*,*)' metric ',m11,m22,m33,m23,m13,m12
c
      nx=1.5*rad/sqrt(m11)
      ny=1.5*rad/sqrt(m22)
      nz=1.5*rad/sqrt(m33)
      sx=1
      sy=1
      sz=1
 10   ndn=0
      do dz=-nz,nz,sz
      do dy=-ny,ny,sy
      do dx=-nx,nx,sx
       r=sqrt(m11*dx*dx+m22*dy*dy+m33*dz*dz+
     +        m23*dy*dz+m13*dx*dz+m12*dx*dy)
       if (r.lt.rad) then
        if (ndn.gt.1000) then
         if (sz.eq.sx) then
          sx=sx+1
          goto 10
         else if (sy.gt.sz) then
          sz=sz+1
          goto 10
         else if (sx.gt.sy) then
          sy=sy+1
          goto 10
         endif
        endif
        ndn=ndn+1
        ndx(ndn)=dx
        ndy(ndn)=dy
        ndz(ndn)=dz
        ndr(ndn)=r
       endif
      enddo
      enddo
      enddo
c
      write (lpt,510)rad,ndn,sx,sy,sz
 510  format('  Filter radius ',f5.1,'A, neighbourhood ',i4,' points',
     +     /,'  Filter sphere grid steps ',3i3)
      return
 9010 call ccperr(1,' neighbours: filter radius too large.')
      end
c
c ----------------------------------------------------------------------
c
