C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c
c ----------------------------------------------------------------------
c
c fragment searcher
c
c ----------------------------------------------------------------------
c
      subroutine searcher(hkls,rhomap,frgmap,frgenv,
     +                    l1,l2,s1,s2,s3,solmsk)
      include 'fffear.fh'
      include 'params.fh'
      include 'hkldata.fh'
      include 'hkllab.fh'
      include 'uvwdata.fh'
      include 'srcdata.fh'
      include 'crystal.fh'
      include 'io.fh'
c itskel - iterative skeletonisation using core tracing
c NOTE: bigmap must be at least 4 x map in size (overrunning other maps)
c
      integer solmsk(*)
      real hkls(nhklc,0:*),rhomap(*),frgmap(*),frgenv(*)
      real l1(*),l2(*),s1(*),s2(*),s3(*)
c
      integer lfa,lfb,lfca,lfcb
      parameter (lfa=20,lfb=21,lfca=22,lfcb=23)
c
      real euler(3,108000),atoms(6,10000),atomr(6,10000)
      integer atmrs(10000)
      character*4 atmnm(10000),atmty(10000)
      character resnam*4,resno*4,id*4,chnnam*1,altcod*1,inscod*1,segid*4
      integer nused,peaklist(3,maxfeature),npeaks
c
      integer i,j,k,l,ju,jv,jw,nangle,iend,jend,kend
      real matrix(4,4),mattmp(4,4),matoff(4,4),baniso(6)
      real r,s,a,b,g,ht,step,rave,rstd
      real alpha1,beta1,gamma1
      real u,v,w,du,dv,dw,x,y,z,tx0,ty0,tz0,mapscl,mapstd
      real thpl,thmi,spl,smi,opl,omi
      real drot,rfracp
c
      external drot,rfracp
      data resnam,resno,inscod,altcod,segid,id/'ALA',5*' '/
      data baniso/6*0.0/
c
c
c ---- ROTATION ANGLES ----
c
c get rotation ASU
      call ccp4h_header('Prepare search orientations','orient',3)
      call rotasu(alpha1,beta1,gamma1)
c
c prepare angles: add the input orientation
      step=srcstp
      nangle=1
      euler(1,1)=0.0
      euler(2,1)=0.0
      euler(3,1)=0.0
c
c      gamma1=360.0
c      beta1 =180.0
c      alpha1=360.0
c
c      do 50 g=step/2,360.0,step
c      do 50 b=step/2,180.0,step
c      i=nint((180.0/step-1)*sin(b*dtor)+1)
c      s=180.0/real(i)
c      do 50 a=s/2,360.0,s
c
c      s=min(alpha1,gamma1)
c      do 50 b=step/2,180.0,step
c      spl=s/int(cos(0.5*b*dtor)*s/step+1)
c      smi=s/int(sin(0.5*b*dtor)*s/step+1)
c      do 50 thpl=spl/2,720.0,spl
c      do 50 thmi=smi/2,360.0,smi
c       a=mod(0.5*(thpl+thmi)+720.0,360.0)
c       g=mod(0.5*(thpl-thmi)+720.0,360.0)
c
c calculate uniform metric orientation angles
c beta sections, theta+/- planes
c offset along theta+ and theta- to acheive pseudo-hexagonal close packing
      s=min(alpha1,gamma1)
      opl=0.25
c     do 50 b=step/2,180.0,step
      iend=int(180.0/step-0.5)
      do 50 i=0,iend
      b=i*step+step/2.0
      opl=1.0-opl
c step along theta+/-
      spl=s/int(0.9428*cos(0.5*b*dtor)*s/step+1)
      smi=s/int(0.8165*sin(0.5*b*dtor)*s/step+1)
      omi=0.25
c     do 50 thpl=opl*spl,720.0,spl
      jend=int(720.0/spl-opl)
      do 50 j=0,jend
      thpl=j*spl+opl*spl
      omi=1.0-omi
c     do 50 thmi=omi*smi,360.0,smi
      kend=int(360.0/smi-omi)
      do 50 k=0,kend
      thmi=k*smi+omi*smi
c convert to alpha/gamma
       a=mod(0.5*(thpl+thmi)+720.0,360.0)
       g=mod(0.5*(thpl-thmi)+720.0,360.0)
c calculate distance from identity
       call eulertomatrix(0.0,0.0,0.0,matrix)
       call eulertomatrix(a,b,g,mattmp)
       if (a.le.alpha1.and.b.le.beta1.and.g.le.gamma1.and.
     +     drot(matrix,mattmp).lt.srcrng*dtor) then
        nangle=nangle+1
        euler(1,nangle)=a
        euler(2,nangle)=b
        euler(3,nangle)=g
       endif
 50   continue
c      call rottest(euler,nangle)
      write (lpt,120)alpha1,beta1,gamma1,step,nangle
 120  format('  Search range on Euler angles for this symm:',3f6.0,
     +     /,'  Search step ',f5.1,' deg. requires',i6,' orientations.')
c
c and base rotation
      call arryzro(matoff,16)
      matoff(4,4)=1.0
      call eulertomatrix(alpha0,beta0,gamma0,matoff)
c
c
c ---- FRAGMENT DATA ----
c
      call ccp4h_header('Prepare scattering factors','scatter',3)
      call resshapefn(hkls,lfomdm)
c
      tx0=0.0
      ty0=0.0
      tz0=0.0
      if (rscale.le.0.0) then
c
c FAST FOURIER SFCALC
c
c ... we always read a model, for viusalisation purposes
       call xyzin(atoms,atmnm,atmty,atmrs,nused)
       if (inputmap) then
c get input density
        call ccp4h_header('Read map for FFT','mapfft',3)
        call mapdensity(frgmap,frgenv,tx0,ty0,tz0)
       else if (inputmax) then
c get input ml target
        call ccp4h_header('Read MLtarget for FFT','mapfft',3)
        call mlstats(hkls,lfo,lfa,mapstd,mapscl)
        call maxdensity(frgmap,frgenv,tx0,ty0,tz0,mapscl,mapstd)
       else
c make coordinate density
        call ccp4h_header('Read model for FFT','mdlfft',3)
        call atmdensity(frgmap,frgenv,atoms,nused,tx0,ty0,tz0)
       endif
c now filter fft
       call frgstats(frgmap,frgenv)
       if (fltfrg.gt.0) call frgfilter(frgmap,frgenv,l1)
       call fftsf(frgmap,frgenv,l1)
c
c SLOW FOURIER SFCALC
c
      else
       call ccp4h_header('Read map for sfcalc','mdlsfc',3)
       call xyzin(atoms,atmnm,atmty,atmrs,nused)
       call sfcalc(frgmap,frgenv,atoms,nused)
      endif
c
c
c ---- MAP DATA ----
c
      call hklfpab(hkls,lfa,lfb)
c set origin term (obsolete)
      if (xf000.lt.0.0) hkls(lfa,0)=vol*sfrag/senv
c truncate map data
      do i=1,nrflo
       if (hkls(4,i).lt.tmin.or.hkls(4,i).gt.tmax) then
        hkls(lfa,i)=0.0
        hkls(lfb,i)=0.0
       endif
      enddo
c calc map
      call fftlistmap(rhomap,hkls,lfa,lfb)
      if (fltmap.gt.0) call mapfilter(rhomap,l1)
c make fom map
c      call copylistmapn(solmsk,hkls,lfomo,0,nu,nv,nw)
c
c generate normal and squared P1 structure factors
      do i=1,nu*nv*nw
       l1(i)=rhomap(i)
       l2(i)=rhomap(i)**2
      enddo
      call inv3d(l1)
      call gridreduce(l1,s1,nu,nv,nw,nus,nvs,nws)
      call inv3d(l2)
      call gridreduce(l2,s2,nu,nv,nw,nus,nvs,nws)
c
c ---- FEATURE SEARCH ----
c
      call ccp4h_header('Translation Search','tsearch',2)
c
c prepare the result maps
      do i=1,nu*nv*nw
       l1(i)=-1.0e8
       l2(i)=0.0
      enddo
c
c Now start angle search
c      nangle=3
      call ccptim(0,a,b)
      k=1
      do 500 i=1,nangle
c
c now do translation search for fragment in this orientation
c
c make inverse matrix
       call arryzro(matrix,16)
       matrix(4,4)=1.0
       call eulertomatrix(euler(1,i),euler(2,i),euler(3,i),matrix)
       call symmatmul(matrix,matoff,mattmp)
       call invsym(mattmp,matrix)
       call tsearch(frgmap,frgenv,s1,s2,s3,rhomap,solmsk,matrix)
c
       do 420 j=1,nu*nv*nw
        if (-rhomap(j).gt.l1(j)) then
         l1(j)=-rhomap(j)
         l2(j)=real(i)
        endif
 420   continue
c
       if (i.eq.k) then
        call ccptim(1,a,b)
        write (lpt,450)i,nangle,100*i/nangle,a,nint(b)
 450    format('Done',i6,' of',i6,' orientations (',i3,'%) in',
     +    f10.2,'s CPU',i8,'s elapsed')
c        call flush(lpt)
        k=2*k
       endif
c
 500  continue
c
c ---- OUTPUT RESULTS ----
c
      call ccp4h_header('Search Results','tresult',2)
c
      call symuvw(matoff,tx0,ty0,tz0,x,y,z)
      matoff(1,4)=x
      matoff(2,4)=y
      matoff(3,4)=z
c
      call arryzro(rhomap,nu*nv*nw)
      call peaksrch(l1,rhomap,peaklist,npeaks)
c
c write pdb header
      call xyzopen('XYZOUT','OUTPUT',' ',latom,i)
      call wbcell(latom,cell,1)
c write out peaks
       do 600 j=1,npeaks
c Get the translation
        u=real(peaklist(1,j))/nu
        v=real(peaklist(2,j))/nv
        w=real(peaklist(3,j))/nw
c fragment is centred at origin. Rotn has no effect on COM, so
c COM of rotated fragment is at UVW. Find symm which bring COM
c closest to origin.
        s=9999999.
        l=0
        do i=1,nsym
         call symuvw(rsym(1,1,i),u,v,w,du,dv,dw)
         r=rfracp(du-ucen)**2+rfracp(dv-vcen)**2+rfracp(dw-wcen)**2
         if (r.lt.s) then
          l=i
          s=r
         endif
        enddo
        call symuvw(rsym(1,1,l),u,v,w,du,dv,dw)
        du=rfracp(du-ucen)-(du-ucen)
        dv=rfracp(dv-vcen)-(dv-vcen)
        dw=rfracp(dw-wcen)-(dw-wcen)
c and rotation
        b=     l1(1+peaklist(1,j)+nu*(peaklist(2,j)+nv*peaklist(3,j)))
        i=nint(l2(1+peaklist(1,j)+nu*(peaklist(2,j)+nv*peaklist(3,j))))
        s=real(j)
c flag stuff outside mask
        if (solmsk(1+peaklist(1,j)+nu*(peaklist(2,j)+nv*peaklist(3,j)))
     +    .ge.1) b=-b
c make the rotation matrix
        call arryzro(matrix,16)
        matrix(4,4)=1.0
        call eulertomatrix(euler(1,i),euler(2,i),euler(3,i),matrix)
c apply the base offset
        call symmatmul(matrix,matoff,mattmp)
c convert to fractional
        call symmatmul(mattmp,q,matrix)
        call symmatmul(qt,matrix,mattmp)
c add positional offset
        mattmp(1,4)=mattmp(1,4)+u
        mattmp(2,4)=mattmp(2,4)+v
        mattmp(3,4)=mattmp(3,4)+w
cc store total translation component for output table
cc        call symuvw(q,mattmp(1,4),mattmp(2,4),mattmp(3,4),x,y,z)
c apply best xtal symm..
        call symmatmul(rsym(1,1,l),mattmp,matrix)
c add cell shift
        matrix(1,4)=matrix(1,4)+du
        matrix(2,4)=matrix(2,4)+dv
        matrix(3,4)=matrix(3,4)+dw
c convert to orthogonal
        call symmatmul(matrix,qt,mattmp)
        call symmatmul(q,mattmp,matrix)
c rotate
        call rotatoms(atoms,atomr,nused,matrix)
c and output atoms shifted to best symm origin
        do i=1,nused
         chnnam=char(min(j-1,25)+ichar('A'))
         write (segid,'(i3)')j-1
         call xyzatom(latom,i+(j-1)*nused,atmnm(i),resnam,chnnam,
     +     atmrs(i)+(j-1)*(atmrs(nused)+1),resno,inscod,
     +     altcod,segid,k,atmty(i))
         baniso(1)=b/10
         call xyzcoord(latom,'O','U',atomr(1,i),atomr(2,i),atomr(3,i),
     +     1.0,baniso(1),baniso)
         call xyzadvance(latom,0,1,*900,*900)
        enddo
c now get final matrix
        call matrixtoeuler(matrix,x,y,z)
        write (lpt,590)x,y,z,matrix(1,4),matrix(2,4),matrix(3,4),b
 590    format(' EULER',3f7.1,'   TRANS',3f8.2,'   Fit',f12.2)
 600   continue
 900   call xyzclose(latom)
c
      i=1
      call ccpmapout('MAPOUT','feature map',l1,i,cell,
     +  nu,nv,nw,0,0,0,nu-1,nv-1,nw-1)
      return
      end
c
c      call ccpmapout('FRGMAP','fragment map',frgmap,1,cell,
c     +  nu,nv,nw,0,0,0,nu-1,nv-1,nw-1)
c      call ccpmapout('RHOMAP','density  map',rhomap,1,cell,
c     +  nu,nv,nw,0,0,0,nu-1,nv-1,nw-1)
c
c ----------------------------------------------------------------------
c
      subroutine tsearch(fh,eh,r1h,r2h,trh,trf,solmsk,matrix)
      include 'fffear.fh'
      include 'hkldata.fh'
      include 'hkllim.fh'
      include 'uvwdata.fh'
      include 'srcdata.fh'
      include 'crystal.fh'
      include 'params.fh'
c produce translation search map for the fragment.
c Heavily optimised, therefore a bit hard to read.
      complex fh(0:*),eh(0:*)
      real r1h(0:*),r2h(0:*),trh(0:*),trf(0:*),matrix(4,4)
      integer solmsk(0:*)
c
      real s1,s2,fm,fe,sc
      real rh,rk,rl,u0,v0,w0,u1,v1,w1,x1,x2,x3,wt
      complex e,r,rr,ef,er,d
      integer i,iu,iv,iw,ih,ik,il,jh,jk,jl,jh1,nn
      integer lra,lrb,lea,leb,lr2a,lr2b,lfra,lfrb
      integer mh,mk,ml,dh,dk,dl,dcent,dimag,hcent
      integer r000,r001,r010,r011,r100,r101,r110,r111
      real w000,w001,w010,w011,w100,w101,w110,w111
      real newmatrix(4,4)
c
      parameter (lra=22,lrb=23,lea=26,leb=27,
     +           lr2a=28,lr2b=29,lfra=30,lfrb=31)
c
      integer lmod,lint
      external lmod,lint
c
c zero the translation function
      call arryzro(trh,nus*nvs*nws)
c
c modifiy matrix to map from real SF to ortho grid molecular transform
      call symmatmul(matrix,qt,newmatrix)
      do iu=1,4
       do iv=1,4
        newmatrix(iu,iv)=newmatrix(iu,iv)/hscale
       enddo
      enddo
c
c grid indexing constants...
      hcent=hgrid/2
      nn=nus*nvs*nws
      dimag=nus*nvs
      dh=1
      dk=hgrid
      dl=hgrid**2
      dcent=hcent+hgrid*(hcent+hgrid*(hcent))
c
c     loop over all reflations
c         calculate sin^2theta/lambda^2
c          calculate array indices
c           calculate b spline coeffs
      sc=1.0/vol
      do 200 il=lmint,lmaxt
           jl=2*nvs*lmod(il,nws)
           x3=max(pi*abs(il)/real(nws),0.001)
           x3=sin(x3)/x3
      do 200 ik=kmint,kmaxt
           s1 = ik*rcm12 + il*rcm13
           s2 = ik*(ik*rcm22 + il*rcm23) + il**2*rcm33
           jk=nus*(lmod(ik,nvs)+jl)
           x2=max(pi*abs(ik)/real(nvs),0.001)
           x2=x3*sin(x2)/x2
      do 200 ih=hmint,hmaxt
       if (ih*(ih*rcm11+s1)+s2.le.tmax) then
           jh=lmod(ih,nus)+jk
           jh1=jh+dimag
           x1=max(pi*abs(ih)/real(nus),0.001)
           x1=x2*sin(x1)/x1
           wt=sc/x1**3
c rotate the miller indices back
        call symuvw(newmatrix,real(ih),real(ik),real(il),rh,rk,rl)
        mh=lint(rh)
        mk=lint(rk)
        ml=lint(rl)
        u0=rh-real(mh)
        v0=rk-real(mk)
        w0=rl-real(ml)
        u1=1-u0
        v1=1-v0
        w1=1-w0
c get interpolation weights
        w000=u1*v1*w1
        w001=u1*v1*w0
        w010=u1*v0*w1
        w011=u1*v0*w0
        w100=u0*v1*w1
        w101=u0*v1*w0
        w110=u0*v0*w1
        w111=u0*v0*w0
c get indices of reflections
        r000=dh*mh+dk*mk+dl*ml+dcent
        r001=r000+dl
        r010=r000+dk
        r011=r001+dk
        r100=r000+dh
        r101=r001+dh
        r110=r010+dh
        r111=r011+dh
c interpolate mask and map sf
        ef=w000*fh(r000)+w001*fh(r001)+w010*fh(r010)+w011*fh(r011)+
     +     w100*fh(r100)+w101*fh(r101)+w110*fh(r110)+w111*fh(r111)
        e =w000*eh(r000)+w001*eh(r001)+w010*eh(r010)+w011*eh(r011)+
     +     w100*eh(r100)+w101*eh(r101)+w110*eh(r110)+w111*eh(r111)
c form target function and apply b spline sharpening
        r =cmplx(r1h(jh),r1h(jh1))
        rr=cmplx(r2h(jh),r2h(jh1))
        d=-wt*(2.0*conjg(ef)*r-conjg(e)*rr)      
        trh(jh) =real(d)
        trh(jh1)=aimag(d)
c       if (ih.eq.0.or.ik.eq.0.or.il.eq.0)
c     +    write (*,'(3i3,4(2f7.1,3x))')ih,ik,il,ef,e,r,rr
       endif
 200  continue
c
      trh(0)=trh(0)+sfrag2
c
c fft and interpolate to fine grid
      call fft3hr(trh,nus,nvs,nws)
      call fine2(trh,trf,nus,nvs,nws)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine peaksrch(t,asu,peaklist,npeaks)
      include 'fffear.fh'
      include 'hkldata.fh'
      include 'uvwdata.fh'
      include 'params.fh'
      include 'io.fh'
c Find peaks of translation function t lieing in ASU asu
      real t(0:nu-1,0:nv-1,0:nw-1),asu(0:nu-1,0:nv-1,0:nw-1)
      integer peaklist(3,maxfeature),npeaks
c
      double precision s,sr,sr2
      real mx,mn,cut,r
      real peakht(maxfeature)
      integer peaku(maxfeature),peakv(maxfeature),peakw(maxfeature)
      integer peakpt(maxfeature)
      integer i,j,iu,iv,iw,ju,jv,jw
c
      integer lmod
      external lmod
c
      s  =0.0
      sr =0.0
      sr2=0.0
      mx=-999999.0
      mn=999999.0
      do iw=0,nw-1
      do iv=0,nv-1
      do iu=0,nu-1
       s  =s  +1.0
       sr =sr +t(iu,iv,iw)
       sr2=sr2+t(iu,iv,iw)**2
       mx=max(mx,t(iu,iv,iw))
       mn=min(mn,t(iu,iv,iw))
      enddo
      enddo
      enddo
c
      sr2=sqrt(sr2*s-sr**2)/s
      sr =sr/s
      cut=real(sr)
c
      npeaks=0
      do iw=0,nw-1
      do iv=0,nv-1
      do iu=0,nu-1
c correct asu?
       if (asu(iu,iv,iw).lt.0.0) goto 200
c is density above cutoff?
       if (t(iu,iv,iw).lt.cut) goto 200
c is density a peak?
       r=t(iu,iv,iw)
       do jw=-1,1
       do jv=-1,1
       do ju=-1,1
        if ( (t(lmod(iu+ju,nu),lmod(iv+jv,nv),lmod(iw+jw,nw)).gt.r)
     +       .and. (ju.ne.0.or.jv.ne.0.or.jw.ne.0) ) goto 200
       enddo
       enddo
       enddo
c store result
       npeaks=npeaks+1
       peaku(npeaks)=iu
       peakv(npeaks)=iv
       peakw(npeaks)=iw
       peakht(npeaks)=r
c if we run out of space, increase the cutoff and compact the list
       if (npeaks.eq.maxfeature) then
        cut=0.0
        do i=1,maxfeature
         cut=cut+peakht(i)/real(maxfeature)
        enddo
        npeaks=0
        do i=1,maxfeature
         if (peakht(i).gt.cut) then
          npeaks=npeaks+1
          peaku(npeaks)=peaku(i)
          peakv(npeaks)=peakv(i)
          peakw(npeaks)=peakw(i)
          peakht(npeaks)=peakht(i)
         endif
        enddo
c        write (*,*)' Compacting ',maxfeature,npeaks
       endif
c next grid point
 200   continue
      enddo
      enddo
      enddo
c
      call shsort(peakht,peakpt,npeaks)
c
      npeaks=min(npeaks,srcpks)
      do i=1,npeaks
       peaklist(1,i)=0
       peaklist(2,i)=0
       peaklist(3,i)=0
      enddo
      do i=1,npeaks
       j=peakpt(i)
       peaklist(1,i)=peaku(j)
       peaklist(2,i)=peakv(j)
       peaklist(3,i)=peakw(j)
      enddo
c
      write (lpt,210)npeaks
 210  format (' PEAK SEARCH',/,'  Number of peaks found:',i6)
      return
c
 9000 call ccperr(1,' peaksrch - peak list overflow')
      end
c
c ----------------------------------------------------------------------
c
      subroutine mlstats(hkls,lfo,lfw,mapstd,mapscl)
c get relfection stats for ml
      include 'fffear.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'hkldata.fh'
      real hkls(nhklc,*),mapstd,mapscl,sfo2,sfw2,w
      integer lfo,lfw,i
c
      sfo2=0.0
      sfw2=0.0
      do i=1,nrflo
       if (hkls(4,i).ge.tmin.and.hkls(4,i).lt.tmax) then
        w=2.0*nsymp/abs(hkls(5,i))
        sfo2=sfo2+w*(hkls(lfo,i)**2)
        sfw2=sfw2+w*(hkls(lfw,i)**2)
       endif
      enddo
      mapstd=sqrt(sfo2-sfw2)/vol
      mapscl=sqrt(sfw2/sfo2)
      write (lpt,510)mapstd,mapscl
 510  format(/,' Map noise level: ',f8.3,'   ML scale: ',f8.3,/)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine xyzin(atoms,atmnm,atmty,atmrs,nused)
c read input model
      include 'fffear.fh'
      include 'crystal.fh'
      include 'io.fh'
c
      real atoms(6,*)
      character*4 atmnm(*),atmty(*)
      integer atmrs(*)
      integer nused
c
      integer i,ifail,idum,nread,iresn,iser,iz,ireso
      real biso,occ,x,y,z,u,v,w,b(6),s,f,s1,s2
      character atnam*4,resnam*4,resno*4,id*4,chnnam*1,altcod*1,
     +          inscod*1,segid*4
c
      call xyzinit()
c
c open coordinate file
      nread=0
      nused=0
      ireso=0
      latom=0
      ifail=1
      call xyzopen('XYZIN','INPUT',' ',latom,ifail)
      if (ifail.lt.0) goto 500
c
c Read atomic coordinates, convert to fractional
 300    call xyzadvance(latom,0,1,*500,*500)
        call xyzatom(latom,iser,atnam,resnam,chnnam,iresn,resno,
     +             inscod,altcod,segid,iz,id)
        call xyzcoord(latom,'O','U',x,y,z,occ,biso,b)
        nread=nread+1
c ignore solvent atoms (I hope)
        if (resnam.eq.'WAT'.or.resnam.eq.'HOH'.or.resnam.eq.'H2O')
     +    goto 300
c get atom index
c
 330    nused=nused+1
        if (nused.eq.1) ireso=iresn-1
        atoms(1,nused)=x
        atoms(2,nused)=y
        atoms(3,nused)=z
        atoms(4,nused)=biso
        atoms(5,nused)=occ
        atoms(6,nused)=real(iz)
        atmnm(nused)=atnam
        atmty(nused)=id
        atmrs(nused)=iresn-ireso
c next atom
        go to 300
c
c end of .pdb file
c
 500  write (lpt,510)nread,nused
 510  format (' Number of atoms read: ',i6/
     +        ' Number of atoms used: ',i6/)
c
      call xyzclose(latom)
      return
 9000 call ccperr(1,' XYZIN - error reading pdb file')
      end
c
c ----------------------------------------------------------------------
c
      subroutine rotatoms(atoms,atomr,nused,matrix)
      include 'fffear.fh'
      include 'io.fh'
c
      real atoms(6,*),atomr(6,*),matrix(4,4)
      integer nused
c
      integer i
c
      do 200 i=1,nused
       call symuvw(matrix,atoms(1,i),atoms(2,i),atoms(3,i),
     +                    atomr(1,i),atomr(2,i),atomr(3,i))
       atomr(4,i)=atoms(4,i)
       atomr(5,i)=atoms(5,i)
       atomr(6,i)=atoms(6,i)
 200  continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine shsort(key,ptr,n)
      include 'fffear.fh'
c sort pointers ptr into order of sort keys key (ptr type undefined)
c my A-level comp sci shell sort algorithm - n log n < time < n ^ 2
c Test results for random number lists:
c    n       10    20    40    80   160   320   640  1280  2560   5120
c    checks  34   103   284   818  2133  4856 12896 31734 64743 140265
c
      integer n,ptr(n)
      real key(n)
c
      integer i,i1,i2,p1,p2,l,icount
c
      icount=0
c set up ptr list
      do 5 i=1,n
       ptr(i)=i
 5    continue
c use search for start factor: reliable
      l=1
 10    l=2*l
      if (l.lt.n) goto 10
c l=step size for swaping elements, halve after each cycle
 20    l=l/2
       do 40 i=1,n-l
        do 30 i1=i,1,-l
         icount=icount+1
         i2=i1+l
         p1=ptr(i1)
         p2=ptr(i2)
         if (key(p2).lt.key(p1)) goto 40
         ptr(i1)=p2
         ptr(i2)=p1
 30     continue
 40    continue
      if (l.gt.1) goto 20
c done
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmapout
     +  (name,title,map,nspgrp,cell,nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2)
      include 'fffear.fh'
      include 'io.fh'
c CCPMAPIN - read a ccp4 logical map and store in xyz order
c
      integer nspgrp,nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2
      real cell(6),map(nu1:nu2,nv1:nv2,nw1:nw2)
      character name*(*),title*(*)
c
      real lsec(0:maxsec)
c
      integer ifast,imedm,islow,lfast,lmedm,lslow,ierr,ifail,iprint
      integer m1(3),m2(3),ifms(3),jfms(3),juvw(3),mxyz(3)
      integer i,m,iu,iv,iw
      integer nsec,mode,nsym,nsymp
      real rmin,rmax,rmean,rrms,rsym(4,4,192),u,v,w,u1,v1,w1,rho
      character*10 namspg,nampg
c
c
c spacegroups with yxz=1 and zxy=2 axis ordering
      integer axis(230)
      data axis/2,2,2,2,1,1,1,1,1,2,1,1,1,1,1,2,2,2,1,2,2,1,2,207*1/
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
c now open map header and read map, re-ordering it as necessary
c
      if (axis(mod(nspgrp,1000)).eq.1) then
       jfms(1)=2
       jfms(2)=1
       jfms(3)=3
      else
       jfms(1)=3
       jfms(2)=1
       jfms(3)=2
      endif
c
      do 110 i=1,3
       juvw(jfms(i))=i
 110  continue
c
      mxyz(1)=nu
      mxyz(2)=nv
      mxyz(3)=nw
      m1(juvw(1))=nu1
      m2(juvw(1))=nu2
      m1(juvw(2))=nv1
      m2(juvw(2))=nv2
      m1(juvw(3))=nw1
      m2(juvw(3))=nw2
      nsec=m2(3)-m1(3)+1
      mode=2
      namspg=' '
c
      call msymlb(lmsks,nspgrp,namspg,nampg,nsym,nsymp,rsym)
c
      call mwrhdl(lmsks,name,title,nsec,jfms,mxyz,
     +  m1(3),m1(1),m2(1),m1(2),m2(2),cell,nspgrp,mode)
      call msywrt(lmsks,nsym,rsym)
c
c find out the mask grid dimensions
      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
c
      if (lfast*lmedm.gt.maxsec)
     +  call ccperr(1,' ccpmapin - Mask section > lsec: recompile')
c now write the map in the new order
      do 200 islow=0,lslow-1
c sort onto section
       ifms(3)=islow+m1(3)
       do 190 imedm=0,lmedm-1
       ifms(2)=imedm+m1(2)
       do 190 ifast=0,lfast-1
       ifms(1)=ifast+m1(1)
        iu=ifms(juvw(1))
        iv=ifms(juvw(2))
        iw=ifms(juvw(3))
        lsec(ifast+lfast*imedm)=map(iu,iv,iw)
 190   continue
c write the section
       call mspew(lmsks,lsec)
 200  continue
c close the map file
      call mwclose(lmsks)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine rotasu(alpha,beta,gamma)
      include 'fffear.fh'
      include 'crystal.fh'
c Calculate a rotational ASU for the Euler angles.
      real alpha,beta,gamma
c
      real m2(4,4),m3(4,4),m4(4,4),m6(4,4)
      real ma(4,4),mb(4,4),mu(4,4),mv(4,4)
c
      integer i
      real drot
      external drot
c
      data m2/-1, 0, 0, 0, 0,-1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1/
      data m3/ 0, 1, 0, 0,-1,-1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1/
      data m4/ 0, 1, 0, 0,-1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1/
      data m6/ 0,-1, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1/
      data ma/ 1, 0, 0, 0, 0,-1, 0, 0, 0, 0,-1, 0, 0, 0, 0, 1/
      data mb/-1, 0, 0, 0, 0, 1, 0, 0, 0, 0,-1, 0, 0, 0, 0, 1/
      data mu/ 0, 1, 0, 0, 1, 0, 0, 0, 0, 0,-1, 0, 0, 0, 0, 1/
      data mv/ 0,-1, 0, 0,-1, 0, 0, 0, 0, 0,-1, 0, 0, 0, 0, 1/
c
      alpha=360.0
      beta =180.0
      gamma=360.0
      do i=1,nsymp
c rotations about c
       if (drot(rsym(1,1,i),m2).lt.0.01) alpha=min(alpha,180.0)
       if (drot(rsym(1,1,i),m3).lt.0.01) alpha=min(alpha,120.0)
       if (drot(rsym(1,1,i),m4).lt.0.01) alpha=min(alpha,90.0)
       if (drot(rsym(1,1,i),m6).lt.0.01) alpha=min(alpha,60.0)
c rotations prependicular to c
       if (drot(rsym(1,1,i),ma).lt.0.01) beta=90.0
       if (drot(rsym(1,1,i),mb).lt.0.01) beta=90.0
       if (drot(rsym(1,1,i),mu).lt.0.01) beta=90.0
       if (drot(rsym(1,1,i),mv).lt.0.01) beta=90.0
      enddo
c
      return
      end
c
c ----------------------------------------------------------------------
c
      real function drot(mat1,mat2)
c difference between two rotations
      include 'fffear.fh'
      real mat1(4,4),mat2(4,4),r
      integer i,j
      r=0.0
      do i=1,3
       do j=1,3
        r=r+(mat1(i,j)-mat2(i,j))**2
       enddo
      enddo
      drot=sqrt(0.5*r)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine rottest(euler,nangle)
c test that the angle set gives good coverage
      include 'fffear.fh'
      include 'crystal.fh'
      real euler(3,*)
      integer nangle
c
      integer i,j,k,j0
      real a,b,g,d,a0,b0,g0,d0,mat1(4,4),mat2(4,4),mat3(4,4),rrand,drot
      external rrand,drot
c
      write (*,*)nangle
      do k=1,1000
       a=360*rrand()
       b=180*rrand()
       g=360*rrand()
       d0=1000.0
       call arryzro(mat3,16)
       mat3(4,4)=1.0
       call eulertomatrix(a,b,g,mat3)
       do i=1,nangle
        do j=1,nsymp
         call arryzro(mat1,16)
         mat1(4,4)=1.0
         call eulertomatrix(euler(1,i),euler(2,i),euler(3,i),mat1)
c convert to fractional
         call symmatmul(mat1,q,mat2)
         call symmatmul(qt,mat2,mat1)
c apply xtal symm
         call symmatmul(rsym(1,1,j),mat1,mat2)
c convert to orthogonal
         call symmatmul(mat2,qt,mat1)
         call symmatmul(q,mat1,mat2)
         d=drot(mat2,mat3)
         if (d.lt.d0) then
          d0=d
          a0=euler(1,i)
          b0=euler(2,i)
          g0=euler(3,i)
          j0=j
         endif
        enddo
       enddo
       write (*,'(7f9.3,i3)')d0,a,b,g,a0,b0,g0,j0
      enddo
c
      return
      end
c
c ----------------------------------------------------------------------
c
