C
C     FFJOIN
C     Copyright (C) 2000-2004 Kevin Cowtan
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c ----------------------------------------------------------------------
c
      program ffjoin
      include 'ffjoin.fh'
      real atm(3,MAXATM),newatm(3,MAXATM)
      real atmb(MAXATM),newatmb(MAXATM)
      integer atmfrg(MAXATM),newatmfrg(MAXATM)
      integer frgptr(MAXFRG),frgflg(MAXFRG),frgsortpt(MAXFRG)
      real frgsortwt(MAXFRG)
      real wrkatm(3,-MAXLEN:MAXLEN),wrkwgt(-MAXLEN:MAXLEN)
      real addatm(3,MAXLEN),addwgt(MAXLEN)
      integer lpdb
      integer i,j,k,i0,j0,f0,f1,w0,w1,kw,kf
      integer natm,nfrg,nnewatm,nnewfrg,lastres
      integer iser,iresn,iz
      real biso,occ,x,y,z,b(6),s,f,s1,s2
      real minb,maxb,frgwt,wrkwt,ww,wf
      real radjoin,radbump
      integer overlapmin,overlap,shift,dir
      logical nobump,norvrs,cont
      character atnam*4,resnam*4,resno*4,id*4,chnnam*1,altcod*1,
     +          inscod*1,segid*4
      character file(3)*8,line*80
      data file/'XYZIN','XYZIN1','XYZIN2'/
c
      call ccpfyp()
      call ccprcs(6, 'ffjoin', '$Date: 2005/09/06 11:25:12 $') 
      call xyzinit()
c
      radjoin=2.0
      radbump=3.0
      overlapmin=3
      nobump=.false.
      norvrs=.false.
c
c read command input
c
 100  call memoparse(.false.)
      call parsesubkey ('BUMP','NOBU',nobump)
      call parsesubreal('BUMP','RADI',1,.true.,radbump)
      call parsesubkey ('JOIN','NORE',norvrs)
      call parsesubreal('JOIN','RADI',1,.true.,radjoin)
      call parsesubint ('JOIN','OVER',1,.true.,overlapmin)
      call parsediagnose(cont)
      if (cont) goto 100
c
c READ THE PDB FILES
c
      natm=0
      nfrg=0
      minb= 1.0e6
      maxb=-1.0e6
c
      do j=1,3
c
       call ugtenv(file(j),line)
       if (line.eq.' ') goto 500
c
       lpdb=0
       i=0 
       call xyzopen(file(j),'INPUT',' ',lpdb,i)
       lastres=-999999
c
 200    call xyzadvance(lpdb,0,1,*500,*500)
        call xyzatom(lpdb,iser,atnam,resnam,chnnam,iresn,resno,
     +    inscod,altcod,segid,iz,id)
        call xyzcoord(lpdb,'O','U',x,y,z,occ,biso,b)
        if (atnam.eq.'CA') then
         if (iresn.ne.lastres+1) nfrg=nfrg+1
         biso=abs(biso)
         natm=natm+1
         atm(1,natm)=x
         atm(2,natm)=y
         atm(3,natm)=z
         atmb(natm)=biso
         atmfrg(natm)=nfrg
         minb=min(minb,biso)
         maxb=max(maxb,biso)
         lastres=iresn
        endif
       goto 200
c
 500   call xyzclose(lpdb)
      enddo
      x=maxb-minb
      maxb=maxb+0.1*x
      minb=minb-0.1*x
c
c CROSS-REFERENCE THE FRAGMENTS
c
 310  nfrg=0
      do i=1,natm
       if (atmfrg(i).ne.nfrg) then
        nfrg=nfrg+1
        frgptr(nfrg)=i
        frgflg(nfrg)=1
       endif
      enddo
      frgptr(nfrg+1)=natm+1
      do i=1,nfrg
       frgsortwt(i)=atmb(frgptr(i))
       frgsortpt(i)=i
      enddo
      call shsorti(frgsortwt,frgsortpt,nfrg)
c
c SEARCH THROUGH EACH FRAGMENT IN TURN LOOKING FOR MATCHES
c
      nnewatm=0
      nnewfrg=0
c      do i=1,nfrg
      do i0=1,nfrg
       i=frgsortpt(i0)
       if (frgflg(i).eq.0) goto 620
       write (*,350)nnewfrg
 350   format(' Create Fragment ',i3)
       call ccpzr(wrkatm,6*MAXLEN+1)
       call ccpzr(wrkwgt,2*MAXLEN+1)
c copy this fragment
       w0=0
       w1=frgptr(i+1)-frgptr(i)-1
       wrkwt=(atmb(frgptr(i))-maxb)/(minb-maxb)
       wrkwt=wrkwt/(1.0-wrkwt)
       call frgcpy(atm(1,frgptr(i)),wrkatm(1,w0),w1-w0+1)
       call frgwgt(wrkwgt(w0),wrkwt,w1-w0+1)
c search the rest of the fragments for a match
c 410   do j=i+1,nfrg
 410   do j0=i0+1,nfrg
        j=frgsortpt(j0)
        if (frgflg(j).eq.0) goto 610
        f0=frgptr(j)
        f1=frgptr(j+1)-1
        frgwt=(atmb(frgptr(j))-maxb)/(minb-maxb)
        frgwt=frgwt/(1.0-frgwt)
c check for forward overlap
        call frgcpy(atm(1,f0),addatm,f1-f0+1)
        call dooverlap(wrkatm(1,w0),w1-w0+1,addatm,f1-f0+1,
     +    radjoin,overlapmin,overlap,shift)
        if (overlap.ge.overlapmin) then
c merge the fragments...
         call frgwgt(addwgt,frgwt,f1-f0+1)
         call domerge(wrkatm(1,w0-shift),wrkwgt(w0-shift),w1-w0+1,
     +                addatm,addwgt,f1-f0+1)
         w0=min(w0,w0-shift)
         w1=max(w1,w0+f1-f0-shift)
         wrkwt=wrkwt+frgwt
         frgflg(j)=0
         write (*,450)i-1,char(min(i-1,25)+ichar('A')),
     +                j-1,char(min(j-1,25)+ichar('A')),
     +                'f',overlap,shift,w0,w1
         goto 410
        endif
c check for backward overlap
        if (norvrs) goto 610
        call frgflp(atm(1,f0),addatm,f1-f0+1)
        call dooverlap(wrkatm(1,w0),w1-w0+1,addatm,f1-f0+1,
     +    radjoin,overlapmin,overlap,shift)
        if (overlap.ge.overlapmin) then
c merge the fragments...
         call frgwgt(addwgt,frgwt,f1-f0+1)
         call domerge(wrkatm(1,w0-shift),wrkwgt(w0-shift),w1-w0+1,
     +                addatm,addwgt,f1-f0+1)
         w0=min(w0,w0-shift)
         w1=max(w1,w0+f1-f0-shift)
         wrkwt=wrkwt+frgwt
         frgflg(j)=0
         write (*,450)i-1,char(min(i-1,25)+ichar('A')),
     +                j-1,char(min(j-1,25)+ichar('A')),
     +                'b',overlap,shift,w0,w1
         goto 410
        endif
 450    format('  Merge:',i2,'(',a1,')',i2,'(',a1,') Dir:',a1,
     +         ' Overlap:',i2,' Shift:',i2, 4x,2i3)
c done merge
 610    continue
       enddo
c
c save the modified fragment
       wrkwt=wrkwt/(1.0+wrkwt)
       nnewfrg=nnewfrg+1
       do j=w0,w1
        nnewatm=nnewatm+1
        newatm(1,nnewatm)=wrkatm(1,j)
        newatm(2,nnewatm)=wrkatm(2,j)
        newatm(3,nnewatm)=wrkatm(3,j)
        newatmb(nnewatm)=(minb-maxb)*wrkwt+maxb
        newatmfrg(nnewatm)=nnewfrg
c        write (*,*)j,newatm(1,nnewatm),newatm(2,nnewatm),
c     +    newatm(3,nnewatm),newatmb(nnewatm)
       enddo
c       write (*,*)i,minb,maxb,wrkwt,(minb-maxb)*wrkwt+maxb
c
c next fragment
 620   continue
      enddo
      write (*,640)nnewfrg
 640  format(' ------ Joined fragments: ',i3)
c
c SAVE AND LOOP
c
      do i=1,nnewatm
       atm(1,i)=newatm(1,i)
       atm(2,i)=newatm(2,i)
       atm(3,i)=newatm(3,i)
       atmb(i)=newatmb(i)
       atmfrg(i)=newatmfrg(i)
      enddo
      natm=nnewatm
c      if (nfrg.ne.nnewfrg) goto 310
c
c ELIMINATE ANY CLASHING FRAGMENTS
c
      do i=1,nfrg
       frgflg(i)=1
      enddo
c
      k=0
      if (nobump) goto 760
      do i=1,natm
       do j=1,natm
        if (frgflg(atmfrg(i)).eq.0.or.frgflg(atmfrg(j)).eq.0.or.
     +      atmfrg(i).eq.atmfrg(j)) goto 710
        if ((atm(1,i)-atm(1,j))**2+(atm(2,i)-atm(2,j))**2+
     +      (atm(3,i)-atm(3,j))**2.lt.radbump**2) then
         if (atmb(i).lt.atmb(j)) then
          frgflg(atmfrg(j))=0
          write (*,650)atmfrg(j)-1
         else
          frgflg(atmfrg(i))=0
          write (*,650)atmfrg(i)-1
         endif
 650     format(' Delete Fragment ',i3)
         k=k+1
        endif
 710   enddo
      enddo
      write (*,740)k
 740  format(' ------ Bumps eliminated: ',i3)
c
c WRITE OUT THE UPDATED ATOM LIST
c
 760  i=0
      j=-1
      call xyzopen('XYZOUT','OUTPUT',' ',lpdb,i)
      lastres=-999999
      do i=1,natm
       if (frgflg(atmfrg(i)).eq.0) goto 810
       if (atmfrg(i).ne.lastres) j=j+1
       atnam=' CA'
       resnam='ALA'
       resno=' '
       inscod=' '
       altcod=' '
       id=' C'
       chnnam=char(min(j,25)+ichar('A'))
       write (segid,'(i3)')j
       call xyzatom(lpdb,i+j,atnam,resnam,chnnam,i+j,resno,
     +    inscod,altcod,segid,iz,id)
       x=atm(1,i)
       y=atm(2,i)
       z=atm(3,i)
       biso=atmb(i)
       b(1)=biso
       call xyzcoord(lpdb,'O','U',x,y,z,1.0,biso,b)
       call xyzadvance(lpdb,0,1,*900,*900)
       lastres=atmfrg(i)
 810  enddo
 900  call xyzclose(lpdb)
      call ccperr(0,'normal termination')
      end
c
c         do k=w0new,w1new
c          write (*,*)k,wrkwgt(k),wrkatm(1,k),wrkatm(2,k),wrkatm(3,k)
c         enddo
c
c ----------------------------------------------------------------------
c
      subroutine frgcpy(atm1,atm2,n)
      include 'ffjoin.fh'
      integer n,i
      real atm1(3,0:*),atm2(3,0:*)
      do i=0,n-1
       atm2(1,i)=atm1(1,i)
       atm2(2,i)=atm1(2,i)
       atm2(3,i)=atm1(3,i)
      enddo
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine frgflp(atm1,atm2,n)
      include 'ffjoin.fh'
      integer n,i
      real atm1(3,0:*),atm2(3,0:*)
      do i=0,n-1
       atm2(1,n-1-i)=atm1(1,i)
       atm2(2,n-1-i)=atm1(2,i)
       atm2(3,n-1-i)=atm1(3,i)
      enddo
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine frgwgt(wgts,wt,n)
      include 'ffjoin.fh'
      integer n,i
      real wt,wgts(0:*),atomwt
      external atomwt
      do i=0,n-1
       wgts(i)=wt*atomwt(i,n-1)
      enddo
      return
      end
c
c ----------------------------------------------------------------------
c
      real function atomwt(i,n)
      include 'ffjoin.fh'
      integer i,n
      if (i.lt.0.or.i.gt.n) then
       atomwt=0.0
      else
       atomwt=cos(3.1416*(i-0.5*n)/(n+2.0))**2
      endif
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine dooverlap(atm1,n1,atm2,n2,rad,overlapmin,overlap,shift)
c try overlapping two fragments
      include 'ffjoin.fh'
      integer n1,n2,overlapmin,overlap,shift
      real atm1(3,0:*),atm2(3,0:*),rad
      real a1(3),a2(3)
      integer i,i1,i2
c
c check each shift
      do shift=-(n1-overlapmin),(n2-overlapmin)
c try start of fragment
       overlap=0
       do i1=0,n1-1
c check each atom
        i2=i1+shift
        if (i2.ge.0.and.i2.lt.n2) then
c if no match then try next shift
         if ((atm1(1,i1)-atm2(1,i2))**2+(atm1(2,i1)-atm2(2,i2))**2+
     +       (atm1(3,i1)-atm2(3,i2))**2.gt.rad**2) goto 20
         overlap=overlap+1
        endif
       enddo
c found a match
       if (overlap.gt.overlapmin) return
c no match at this shift
 20    continue
      enddo
c
      overlap=0
      return
      end
c debugger stuff
c         a1(1)=atm1(1,i1)
c         a1(2)=atm1(2,i1)
c         a1(3)=atm1(3,i1)
c         a2(1)=atm1(1,i2)
c         a2(2)=atm1(2,i2)
c         a2(3)=atm1(3,i2)
c
c ----------------------------------------------------------------------
c
      subroutine domerge(atm1,w1,n1,atm2,w2,n2)
c merge two fragments
      include 'ffjoin.fh'
      integer n1,n2
      real atm1(3,0:*),atm2(3,0:*),w1(0:*),w2(0:*)
      integer i
c
      do i=0,n2-1
       atm1(1,i)=(w1(i)*atm1(1,i)+w2(i)*atm2(1,i))/(w1(i)+w2(i))
       atm1(2,i)=(w1(i)*atm1(2,i)+w2(i)*atm2(2,i))/(w1(i)+w2(i))
       atm1(3,i)=(w1(i)*atm1(3,i)+w2(i)*atm2(3,i))/(w1(i)+w2(i))
       w1(i)=(w1(i)+w2(i))
      enddo
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine shsorti(key,ptr,n)
      include 'ffjoin.fh'
c shell-sort pointers ptr into order of sort keys key
      integer n,ptr(n)
      real key(*)
      integer i,i1,i2,p1,p2,l
c
      l=1
 10    l=2*l
      if (l.lt.n) goto 10
c l=step size for swaping elements, halve after each cycle
 20    l=l/2
       do 40 i=1,n-l
        do 30 i1=i,1,-l
         i2=i1+l
         p1=ptr(i1)
         p2=ptr(i2)
         if (key(p2).ge.key(p1)) goto 40
         ptr(i1)=p2
         ptr(i2)=p1
 30     continue
 40    continue
      if (l.gt.1) goto 20
c done
      return
      end
c
c ----------------------------------------------------------------------
c
