C
C     FHSCAL
C     Copyright (C) 1992 Ian Tickle
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C**************************************************************
C
C
C**************************************************************
C
C     Modified: 
C               June 200 by CCB.
C
C               Increase maximum number of datasets (Maxsets) to 20.
C               MCOLS4 and MCOLS19 parameters added to aid data
C               assignments.
C
C               Apr 2000 by CCB (based on SCALEIT mods by PJ)
C
C               Added AUTO keyword to allow automatic scaling of
C               related datasets.
C               Gives warning if inconsistent scaling is used for
C               related datesets.
C               Extended group of recognised data types to include
C               intensities (reduced maximum number of datasets to
C               13 to stay under the 200 column limit currently used
C               in mtzlib)
C               Additional parameters added.
C
C**************************************************************
      PROGRAM FHSCAL
C     Ian Tickle
C
      IMPLICIT NONE
C---  Parameter statements
      INTEGER MTOK,NKEY
C     PARAMETER (MTOK=400,NKEY=8)
      PARAMETER (MTOK=400,NKEY=9)
      REAL PI
      PARAMETER (PI=3.141592654)
C...  PARAMETER NLPRGI number of terms in mtzlib routines 
      INTEGER NLPRGI
      PARAMETER (NLPRGI=200)
C...  PARAMETER MaxSets maximum number of datasets
      INTEGER MaxSets,MaxSets1
      PARAMETER (Maxsets=20)
      PARAMETER (Maxsets1=maxsets+1)
C...  PARAMETER NTLRU number of terms in LSPRGI repeat unit
      INTEGER NTLRU
      PARAMETER (NTLRU=14)
C...  PARAMETER MCOLS maximum number of columns
      INTEGER MCOLS
      PARAMETER (MCOLS=Maxsets1*NTLRU+5)
C...  PARAMETER MCOLS4 and MCOLS19 are used in data assigments
      INTEGER MCOLS4,MCOLS19
      PARAMETER (MCOLS4=MCOLS-4,MCOLS19=MCOLS-19)
C
C     CHARACTER TI1*80,TI2*80,KEY*4,KEYA(NKEY)*4,LINE*2000,CVAL(MTOK)*4,
C    &CTPRGI(173)*1,LSPRGI(173)*30,SGN*10,PGN*10,ERRLINE*100
      CHARACTER TI1*80,TI2*80,KEY*4,KEYA(NKEY)*4,LINE*2000,CVAL(MTOK)*4,
     &CTPRGI(MCOLS)*1,LSPRGI(MCOLS)*30,SGN*10,PGN*10,ERRLINE*100
      LOGICAL CENT,EOF
      INTEGER KE,I,LIST,MS,NSG,NGEP,NGEPC,J,K,N,MU,KS,M,IC,NR,NW,
     &IS,JS,NTOK,ND
      REAL BIAS,DENOM,FP,SP,FD,SD,DS,W,T,SC,V,S,F,C,VC,SPST,SDST,SMAX,
     &SMIN,SW,SWX,SWXS,SWY,SWXY,Q,RPS,RDS,RDC,RDA,RMAX,RMIN,X,Y,D,B,
     &SSC,SB,RH,RL
      INTEGER LENSTR,ICENTR,MULTIP
      REAL FSPLIN
      INTEGER NTOKS(NKEY),IB(MTOK),IE(MTOK),IT(MTOK),ID(MTOK),
     &ISR(3,3,24),IH(3),IP(MCOLS),NRC(100,20),NRA(100,20),NRS(100,20),
     &NS(20),NU(20),NRCT(20),NRAT(20),NRST(20),JCD(20)
C
C     REAL FVAL(MTOK),RTS(4,4,96),CELL(6),AA(200),
      REAL FVAL(MTOK),RTS(4,4,96),CELL(6),AA(MCOLS),
     &SWPS(100,20),SWPD(100,20),SWDS(100,20),SS(100,20),SPS(100,20),
     &SDS(100,20),SDC(100,20),SDA(100,20),SCD(100,20),CCD(4,20),
     &Q1(20),Q2(20),R1(20),R2(20),R1C(20),R2C(20),S1(20),S2(20),
     &SDCT(20),SDAT(20),SWPST(20),SWPDT(20),SWDST(20)
C
C     LOGICAL LOGMSS(200)
      LOGICAL LOGMSS(MCOLS)
C
C---  Variables added for dataset testing and automatic scaling
C...  logic for AUTO option
      LOGICAL LAUTO
C...  Added for LRID, LRCLID, LRCLAB
      CHARACTER PNAME(MaxSets)*64,XNAME(MaxSets)*64,DNAME(MaxSets)*64
      CHARACTER CTYPS(MCOLS)*1,CLABS(MCOLS)*30
      REAL DATCELL(6,MaxSets),DATWAVE(MaxSets)
      INTEGER ISETS(MCOLS),NDATASETS,CSETID(MCOLS),NCOLS
C...  Added for LKYSET
      CHARACTER LSUSRJ(MCOLS)*30
C...  Added for tests and automatic scaling section
      INTEGER CLOOKUP, THIS_SET, THIS_DERIV, IFIRST, ILAST
      INTEGER NUNSCALD(MaxSets),IUNSCALD(NTLRU,MaxSets),INSET(MaxSets)
      LOGICAL lintens(MaxSets), lanomal(MaxSets)
      LOGICAL lswitched, lwarn
      CHARACTER*1 this_type,last_type
C---  data statements
      DATA TI1 /' '/
      DATA TI2 /'PRODUCED BY FHSCAL'/
C     DATA KEYA /'TITL','LIST','SHEL','BIAS','RESO','LABI','CENT','END'/
      DATA KEYA /'TITL','LIST','SHEL','BIAS','RESO','LABI','CENT','AUTO'
     &          ,'END'/
C     DATA NTOKS /1, -2, -2, -2, 2, 3, -1, 1/
      DATA NTOKS /1, -2, -2, -2, 2, 3, -1, 1, 1/
C..   include intensities in LSPRGI and CTPRGI (increase array size)
C     DATA LSPRGI /'H','K','L','FP','SIGFP','FPH','SIGFPH',
C    &             'DPH','SIGDPH','FPH(+)','SIGFPH(+)',
C    &             'FPH(-)','SIGFPH(-)',160*' '/
      DATA LSPRGI /'H','K','L','FP','SIGFP','FPH','SIGFPH',
     &             'DPH','SIGDPH','FPH(+)','SIGFPH(+)',
     &             'FPH(-)','SIGFPH(-)',
     &             'IMEAN','SIGIMEAN',
     &             'I(+)','SIGI(+)','I(-)','SIGI(-)',MCOLS19*' '/
C     DATA CTPRGI /3*'H','F','Q','F','Q','D','Q','G','L',
C    &                   'G','L',160*' '/
      DATA CTPRGI /3*'H','F','Q','F','Q','D','Q','G','L',
     &                   'G','L','J','Q','K','M','K','M',MCOLS19*' '/
      DATA CENT /.FALSE./
      DATA MS /20/, BIAS /0./
C     DATA IP /4*-1,169*0/
      DATA IP /4*-1,MCOLS4*0/
      DATA KE /0/, LIST /0/
      DATA NU /20*0/
      DATA SMIN,SMAX /0.,100./
      DATA R1 /20*100./, R2 /20*0./, R1C /20*100./, R2C /20*0./
      DATA LSUSRJ /MCOLS*' '/
C
C     ===========
      call ccp4h_init()    
      call ccp4h_header('FHSCAL','fhscal',2)
      CALL CCPRCS(6,'FHSCAL','$Date: 2005/09/06 11:25:13 $')
      WRITE (6,'(/,3(/,20X,A),//)')
     &' ############################################################',
     &' # F(HEAVY) MULTIPLE ISOMORPHOUS SCALING BY KRAUT''S METHOD. #',
     &' ############################################################'
      CALL CCPFYP
C     ===========
      CALL MTZINI
C     ===========
      call ccp4h_summary_beg()
      call ccp4h_toc_beg()
      call ccp4h_toc_ent('Command Input','#command')
      call ccp4h_toc_ent('Input MTZ File','#inp')
      call ccp4h_toc_ent('Output File','#out')
      call ccp4h_summary_end()
      call ccp4h_toc_ent('Resolution Vs. FPH Scale','#scale')
      call ccp4h_summary_beg()
      call ccp4h_toc_ent('Scale from Wilson Plot','#wilson')
      call ccp4h_toc_end()
      call ccp4h_rule()
      call ccp4h_header('Command Input','command',3)
      call ccp4h_link('TITLE    ','fhscal.html#title')
      call ccp4h_link('BIAS ','fhscal.html#bias')
      call ccp4h_link('CENT ','fhscal.html#cent')
      call ccp4h_link('LABIN ','fhscal.html#labin')
      call ccp4h_link('SHELLS ','fhscal.html#shells')
      call ccp4h_link('LIST ','fhscal.html#list')
      call ccp4h_link('RESO','fhscal.html#resolution')
      call ccp4h_link('END','fhscal.html#end')
      call ccp4h_summary_end()
C
      call ccp4h_summary_beg()
      call ccp4h_header('Input MTZ File','inp',3)   
      call ccp4h_summary_end()   
C     ==========================
      CALL LROPEN(1,'HKLIN',2,I)
C     ==========================
C
      IF (I.NE.0) CALL CCPERR(1,'*** ERROR OPENING INPUT MTZ FILE ***')
C
C--- Initialise 
C... increase number of columns for native and first deriv
C     J=14
      J=20
C
      DO 190 I=1,MaxSets
        IF (I.LE.9) THEN
          WRITE (LSPRGI(J),'(A,I1)') 'FPH',I
          WRITE (LSPRGI(J+1),'(A,I1)') 'SIGFPH',I
          WRITE (LSPRGI(J+2),'(A,I1)') 'DPH',I
          WRITE (LSPRGI(J+3),'(A,I1)') 'SIGDPH',I
          WRITE (LSPRGI(J+4),'(A,I1,A)') 'FPH',I,'(+)'
          WRITE (LSPRGI(J+5),'(A,I1,A)') 'SIGFPH',I,'(+)'
          WRITE (LSPRGI(J+6),'(A,I1,A)') 'FPH',I,'(-)'
          WRITE (LSPRGI(J+7),'(A,I1,A)') 'SIGFPH',I,'(-)'
C...
          WRITE (LSPRGI(J+8),'(A,I1)') 'IMEAN',I
          WRITE (LSPRGI(J+9),'(A,I1)') 'SIGIMEAN',I
          WRITE (LSPRGI(J+10),'(A,I1,A)') 'I',I,'(+)'
          WRITE (LSPRGI(J+11),'(A,I1,A)') 'SIGI',I,'(+)'
          WRITE (LSPRGI(J+12),'(A,I1,A)') 'I',I,'(-)'
          WRITE (LSPRGI(J+13),'(A,I1,A)') 'I',I,'(-)'
C
        ELSE
          WRITE (LSPRGI(J),'(A,I2)') 'FPH',I
          WRITE (LSPRGI(J+1),'(A,I2)') 'SIGFPH',I
          WRITE (LSPRGI(J+2),'(A,I2)') 'DPH',I
          WRITE (LSPRGI(J+3),'(A,I2)') 'SIGDPH',I
          WRITE (LSPRGI(J+4),'(A,I2,A)') 'FPH',I,'(+)'
          WRITE (LSPRGI(J+5),'(A,I2,A)') 'SIGFPH',I,'(+)'
          WRITE (LSPRGI(J+6),'(A,I2,A)') 'FPH',I,'(-)'
          WRITE (LSPRGI(J+7),'(A,I2,A)') 'SIGFPH',I,'(-)'
C...      include intensities
          WRITE (LSPRGI(J+8),'(A,I2)') 'IMEAN',I
          WRITE (LSPRGI(J+9),'(A,I2)') 'SIGIMEAN',I
          WRITE (LSPRGI(J+10),'(A,I2,A)') 'I',I,'(+)'
          WRITE (LSPRGI(J+11),'(A,I2,A)') 'SIGI',I,'(+)'
          WRITE (LSPRGI(J+12),'(A,I2,A)') 'I',I,'(-)'
          WRITE (LSPRGI(J+13),'(A,I2,A)') 'I',I,'(-)'
C
        ENDIF
        CTPRGI(J)='F'
        CTPRGI(J+1)='Q'
        CTPRGI(J+2)='D'
        CTPRGI(J+3)='Q'
        CTPRGI(J+4)='G'
        CTPRGI(J+5)='L'
        CTPRGI(J+6)='G'
        CTPRGI(J+7)='L'
        CTPRGI(J+8)='J'
        CTPRGI(J+9)='Q'
        CTPRGI(J+10)='K'
        CTPRGI(J+11)='M'
        CTPRGI(J+12)='K'
        CTPRGI(J+13)='M'
        INSET(I) = 0
C...  increase number of columns
C190    J=J+8
 190    J=J+NTLRU
C...  additional items for tests.
      LAUTO=.FALSE.
      LWARN=.FALSE.
      LSWITCHED=.FALSE.
      NCOLS=MCOLS
      DO 19 J=1,MAXSETS
        NUNSCALD(J) = 0
        LINTENS(J) = .FALSE.
        LANOMAL(J) = .FALSE.
 19   CONTINUE
C
C
C==== Read control data.
C
200   LINE=' '
      NTOK=MTOK
      CALL PARSER(KEY,LINE,IB,IE,IT,FVAL,CVAL,ID,NTOK,EOF,.TRUE.)
      IF (EOF) GOTO 1008
      IF (NTOK.EQ.0) GOTO 200
      DO 210 I=1,NKEY
210     IF (KEY.EQ.KEYA(I)) GOTO 220
      WRITE (ERRLINE,*) '*** ERROR: Last line has invalid keyword: ',KEY
      CALL CCPERR (2,ERRLINE)
      KE=KE+1
      GOTO 200
220   IF ((NTOKS(I).LT.0 .AND. NTOK.NE.-NTOKS(I)) .OR.
     &NTOK.LT.NTOKS(I)) THEN
        WRITE (ERRLINE,'(/,A)') ' **** ERROR: bad argument count.'
        CALL CCPERR (2,ERRLINE)
        KE=KE+1
      ENDIF
C
C---  add auto option.
C     DATA KEYA /'TITL','LIST','SHEL','BIAS','RESO','LABI','CENT','AUTO'
C                'END'/
C
      GOTO (1001,1002,1003,1004,1005,1006,1007,1009,1008),I
C
C==== Title.
C
1001  IF (IB(2).GT.0) TI1=LINE(IB(2):)
      GOTO 200
C
C==== List.
C
1002  CALL GTPINT(2,LIST,NTOK,IT,FVAL)
      GOTO 200
C
C==== Shells.
C
1003  CALL GTPINT(2,MS,NTOK,IT,FVAL)
      IF (MS.LE.0) KE=KE+1
      IF (MS.GT.100) MS=100
      GOTO 200
C
C==== Bias.
C
1004  CALL GTPREA(2,BIAS,NTOK,IT,FVAL)
      GOTO 200
C
C==== Reso.
C
1005  CALL RDRESO(2,IT,FVAL,NTOK,RMIN,RMAX,SMIN,SMAX)
      GOTO 200
C
C==== Labin.
C
C     ======================================
1006  CALL LKYIN(1,LSPRGI,MCOLS,NTOK,LINE,IB,IE)
C     ======================================
C
C----     this subroutine returns ip(kk) = -1 if label kk is set.
C         required for lauto
C
      CALL LKYSET(LSPRGI,MCOLS,LSUSRJ,IP,2,NTOK,LINE,IB,IE)
C
      GOTO 200
C
C==== Centric.
C
1007  CENT=.TRUE.
      GOTO 200
C
C==== Automatic scaling of additional sets
 1009 LAUTO=.TRUE.
      GOTO 200
C
C==== End.
C
 1008 call ccp4h_summary_beg()
      WRITE (6,'(/////,1X,A,/)') TI1
      WRITE (6,'(A,I5,/,A,I4,/,A,F8.2)')
     &' List =',LIST,' Max no of shells =',MS,' Bias factor =',BIAS
      BIAS=BIAS**2
      call ccp4h_summary_end()
C
C*****
C---- PJX: The next section does some checking to warn the user
C     if the whole dataset has not been scaled together.
C
C---- Get dataset info using LRIDX:
C     Notify available space
      NDATASETS = MaxSets
      CALL LRIDX(1,PNAME,XNAME,DNAME,ISETS,
     +                     DATCELL,DATWAVE,NDATASETS)
C
C have got this far so assume there are datasets in the file
C get column labels and column types.  Return number of columns
C in file (NCOLS)
      CALL LRCLAB(1,CLABS,CTYPS,NCOLS)
C get relationship between columns and datasets
      CALL LRCLID(1,CSETID,NCOLS)
C
C
C---- For each column, get the dataset and then compile a list
C     of the columns in each dataset which are scaleable but
C     which have not been set by LABIN;
C     Set a logical variable for each dataset with columns which
C     were specified by LABIN.
C     Determine which "derivative" each dataset will be.
C
C     LDSCALE(I) is true if dataset I is going to be scaled
C     NUNSCALD(I) holds the number of unspecified scaleable
C                   columns for dataset I
C     IUNSCALD(J,I) holds the pointer to the Jth unspecified
C                   scalable column for dataset I
C
        do 9990 i = 1,ncols
c
C         csetid(i) is dataset ID, want numerical place of this dataset
          do j = 1,NDATASETS
            if (ISETS(j).eq.csetid(i)) then
              this_set = j
            endif
          enddo

C     check against user selection
          do 9991 j = 6,nlprgi
c
            if (clabs(i).eq.lsusrj(j)) then
              if (inset(this_set).eq.0)
     1                inset(this_set) = (j-5)/NTLRU + 1
              go to 9990
            end if
 9991     continue
c
          if (ctyps(i).eq.'F' .or. ctyps(i).eq.'J' .or.
     1        ctyps(i).eq.'D' .or. ctyps(i).eq.'G' .or.
     2        ctyps(i).eq.'L' .or. ctyps(i).eq.'K' .or.
     3        ctyps(i).eq.'M' .or. ctyps(i).eq.'Q') then
            nunscald(this_set) = nunscald(this_set) + 1
            CLookUp = nunscald(this_set)
            iunscald(CLookUp,this_set) = i
            if (ctyps(i).eq.'J') lintens(this_set) = .true.
            if (ctyps(i).eq.'D') lanomal(this_set) = .true.
          end if
 9990   continue
C
C     set nunscald according to use of dataset
        do i = 1,ndatasets
           if (inset(i).eq.0) nunscald(i) = 0
        end do
c
c---- AUTO mode
c     Automatic selection of all scalable columns in each dataset
c
        if (lauto) then
c
          write(6,fmt='(//,2(1x,a,/),/,4(1x,a,/),/,3(1x,a,/))')
     1    'AUTOMATIC COLUMN SELECTION',
     2    '==========================',
     3    'The program will use DATASET information from the MTZ file',
     4    'to identify all scalable columns for each specified',
     5    'derivative i.e. FPH, DPH, IMEAN etc and apply the scale',
     6    'factor to all these columns.',
     7    'This is a new feature and there may be problems -',
     8    'check the information below for warnings or errors',
     9    'and report any problems to ccp4@dl.ac.uk'
c
c---- Try to assign the labels.
c
          do i = 1,ndatasets
            if (nunscald(i).gt.0) then
c
              this_set = inset(i)
C     range for loops over program labels
              ifirst = (this_set-1)*NTLRU + 6
              ilast  = ifirst-1+NTLRU
C     derivatives
              this_deriv = this_set
c     have sets 1 and 1-20 (21 total)
              if (this_deriv .gt. 1) this_deriv = this_deriv - 1
c 
              write (6,fmt='(/,1x,a,i2,a,a,a,a,/,1x,a,i2,/)')
     1           'Dataset ',ISETS(i),' is ',
     1           dname(i)(1:lenstr(dname(i))),
     1           ' in crystal ',xname(i)(1:lenstr(xname(i))),
     2           'and is assigned to be derivative ',this_deriv
c
c---- List the labels specified with LABIN first
c
              write (6,fmt='(3x,a)')
     1           'The following columns were defined by LABIN:'
              do j = ifirst,ilast
                if (ip(j).ne.0)
     1             write(6,fmt='(7x,a20)')lsusrj(j)
              end do
c
c---- For each unspecified label, do the label assignment
c
              write(6,fmt='(2(/,3x,a))')
     1          'The following additional columns will have the same',
     2          'scale factor applied automatically:'
c
              last_type = "?"
              do j = 1,nunscald(i)
                write (6,fmt='(7x,a,1x,a20,5x,3a)')
     1            'Column',clabs(iunscald(j,i)),
     1            '(type ',ctyps(iunscald(j,i)),')'
c
                this_type=ctyps(iunscald(j,i))
c
c             Before looping over all prog labels to look for a match
c             check if this is a sigma of type Q
c             'Q' sigmas need special treatment...
c
                if (this_type.eq.'Q') then
c
                  CLookUp = -1
c
c             First assumption is that the columns have been arranged
c             pairwise, ie. sigmas follow values.
c             Check the last type assigned:
c
                  if (clookup.lt.0) then
c
c             check previous column in the mtz file
c
                    if (j.eq.1 .or.iunscald(j-1,i).ne.(iunscald(j,i)-1))
     1              last_type = ctyps(iunscald(j,i)-1)
c
                    if (last_type.eq.'F') then
                       write(6,fmt='(7x,a,/,7x,2a,/,7x,2a)')
     1                 'The last assigned column was type F',
     2                 'Guessing that this is the sigma of ',
     3                 'FPH','It will be ',
     4                 'multiplied by the calculated scale factor'
                       clookup = ifirst + 1
                       if (ip(clookup).ne.0) then
                         call ccperr(1, 'SIGFPH is already assigned')
                       end if
                    else if (last_type.eq.'D') then
                       write(6,fmt='(7x,a,/,7x,2a,/,7x,2a)')
     1                 'The last assigned column was type D',
     2                 'Guessing that this is the sigma of ',
     3                 'DPH','It will be ',
     4                 'multiplied by the calculated scale factor'
                       clookup = ifirst + 3
                       if (ip(clookup).ne.0) then
                         call ccperr(1, 'SIGDPH is already assigned')
                       end if
                    else if (last_type.eq.'J') then
                       write(6,fmt='(2(7x,a,/),7x,a,/,7x,3a)')
     1                 'The last assigned column was type J',
     2                 'Guessing that this is the sigma of the ',
     3                 'average intensity Imean','It will be ',
     4                 'multiplied by the calculated ',
     5                 'scale factor squared'
                       clookup = ifirst + 9
                       if (ip(clookup).ne.0) then
                         call ccperr(1, 'SIGIMEAN is already assigned')
                       end if
                    endif
                 endif
c
c              Set the label, if assigned - print message otherwise 
c
                  if (clookup.gt.0) then
                     write(6,fmt='(10x,a,a,/)')
     1               'Assigned to label ',lsprgi(clookup)
                     ip(clookup) = -1
                     lsprgi(clookup) = clabs(iunscald(j,i))
                      last_type  = this_type
                     go to 9989
                  else
                     write(6,fmt='(1x,a)')
     1               'What is this the sigma of? I need some clues!'
                     go to 9060
                  end if
c
c             End of dealing with sigmas of type Q
                end if
c
c             For other types of columns:
c             Loop through the prog labels for this derivative until
c             you find an unassigned one of the correct type
c
                lswitched = .false.
 9980           continue
c
                do clookup = ifirst,ilast
c
c             Assign the labels as follows: set the lookup array to
c             -1 (to declare it as a compulsory label) and set the
c             program label to the file label
c
c             This is a bit clumsy but it seems to work!
c
c             Look for an exact match first
c
c                  write(6,*)clookup,' ',lsprgi(clookup),ctprgi(clookup),ipoint(clookup)
                   if ((ip(clookup).eq.0).and.
     1                (this_type.eq.ctprgi(clookup))) then
                      write(6,fmt='(10x,a,a,/)')
     1                  'Ok - assigned to label ',lsprgi(clookup)
                      ip(clookup) = -1
                      lsprgi(clookup) = clabs(iunscald(j,i))
                      last_type  = this_type
                      go to 9989
                   end if
                end do
c
c             Couldn't find an exact match
c
                write(6,fmt='(/,1x,a,a1,a,/,1x,a)')
     1          '** All the labels with column type ',
     2          this_type,' have already',
     3          'been assigned for this derivative'
c
c             What's gone wrong?
c             Could be a dataset with more than one derivative?
c             Could be mis-assigned column types? e.g.
c             Might have an F+/- defined as type F instead of G
c                           I+/- defined as type J instead of K
c                           SIGF+/- or SIGI+/- defined as type Q
c                           instead of L or M respectively.
c
c             Do some simple checking on other types
c             If there are too many of these then something has
c             gone irretrievably wrong
c
                if (this_type.eq.'D') then
                 write(6,fmt='(1x,2a)')'Too many anomalous differences',
     1            ' in this dataset?'
                  go to 9070
                elseif (this_type.eq.'G') then
                  write(6,fmt='(1x,2a)')'Too many F(+) and/or F(-)s in',
     1            ' this dataset?'
                  go to 9070
                elseif (this_type.eq.'L') then
                  write(6,fmt='(1x,a)')'Too many sigma F(+) and/or',
     1            ' sigma F(-)s in this dataset?'
                  go to 9070
                elseif (this_type.eq.'K') then
                  write(6,fmt='(1x,2a)')'Too many I(+) and/or I(-)s',
     1            ' in this dataset?'
                  go to 9070
                elseif (this_type.eq.'M') then
                  write(6,fmt='(1x,2a)')'Too many sigma I(+) and/or',
     1            ' sigma I(-)s in this dataset?'
                  go to 9070
                end if
c
c             Assume it's a mis-labelled column type
c             At this point we're really just guessing.
c
 9060           continue
c
                write(6,fmt='(1x,a)')
     1          'Could it be a misassigned column type?'
                lswitched = .true.
c
                if (this_type.eq.'F') then
                  write(6,fmt='(1x,a,/,1x,a)')
     1            'This might be an FPH(+) or FPH(-) mis-labelled as',
     2            'an FPH - looking for spare labels of type G ...'
                  this_type = 'G'
                  lwarn = .true.
                  go to 9980
                elseif (this_type.eq.'J') then
                  write(6,fmt='(1x,a,/,1x,a)')
     1            'This might be an I(+) or I(-) mis-labelled as an',
     2            ' IMEAN - looking for spare labels of type K ...'
                  this_type = 'K'
                  lwarn = .true.
                  go to 9980
                elseif (this_type.eq.'Q') then
                  if (last_type.eq.'G') then
                    write(6,fmt='(2(1x,a,/),1x,a)')
     1              'The last column I looked at was assigned as an',
     2              'FPH(+) or FPH(-) - maybe this is its sigma?',
     3              'Looking for spare labels of type L ...'
                    this_type = 'L'
                    lwarn = .true.
                    go to 9980
                  elseif (last_type.eq.'K') then
                    write(6,fmt='(2(1x,a,/),1x,a)')
     1              'The last column I looked at was assigned as an',
     2              'I(+) or I(-) - maybe this is its sigma?',
     3              'Looking for spare labels of type M ...'
                    this_type = 'M'
                    lwarn = .true.
                    go to 9980
                  else

                  endif
                end if
c
c             Fatal errors take you here for a last word
c
 9070           write(6,fmt='(5(1x,a,/))')
     1          'The automatic column selection has failed.',
     2          'This may be because some columns in the MTZ file',
     3          'have the wrong type, or because a single dataset',
     4          'contains more than one derivative.',
     5          'Examine the messages above for more information.'
                call ccperr(1, 'Error in AUTOmatic column selection')
c
 9989           continue
c
c             Warning if we have assigned SIGIMEAN automatically
c
                if (clookup.eq.(ifirst + 9)) then
                  write(6,fmt='(2x,a,a20,2(/,2x,a),/)')
     1            '** SIGIMEAN has been assigned to column ',
     2            lsprgi(clookup),
     3            'So it will be multiplied by the SQUARE of', 
     4            'the scale factor - check that this is correct.'
                  lwarn = .true.
                end if
c
              end do
            end if
          end do
c
c     End of automatic column selection
c     Print final warnings if necessary
c
          write(6,fmt='(/,2(1x,a,/))')
     1    '* Automatic column selection completed *',
     2    '* You should check the above output for errors'
c
          if (lwarn) then
             write(6,fmt='(3(1x,a,/))')
     1       'The selection may not be correct - for example, sigmas',
     2       'maybe wrongly assigned, or some columns may have been',
     3       'selected against type.'
             call ccperr (2,
     1       'Check automatic selection output carefully for errors!')
          end if
C
      ELSE
          DO 550  J = 1,NDATASETS
            IF (nunscald(j).gt.0) then
c
               call ccperr(2,
     1          '** INCONSISTENT SCALING WITHIN DATASETS(S)')
                write(6,fmt='(2(1x,a,/),/,3(1x,a,/))')
     1          'You are applying the scale factor to some columns but',
     2          'not to others within the following dataset(s).',
     3          'This is not advised - use the AUTO keyword to',
     4          'automatically scale all the columns in a single',
     5          'dataset, or else specify them explicitly using LABIN.'
c
              write (6,fmt='(1x,a,i2,a,a,a,a,/,1x,a)')
     1          '** Dataset ',ISETS(j),' = ',
     1          dname(j)(1:lenstr(dname(j))),
     1          ' in crystal ',xname(j)(1:lenstr(xname(j))),
     2             'is not being scaled consistently'
              write (6,fmt='(1x,a,/,1x,a)')
     1             'It is recommended that the following columns in',
     2             'this dataset are also scaled:'
c
C----    Print a list of the unspecified (=unscaled) columns
C
              do 555 i = 1,nunscald(j)
                 CLOOKUP=iunscald(i,j)
                 write (6,fmt='(5x,a20,5x,a,a)')clabs(CLOOKUP),
     1              'type ',ctyps(CLOOKUP)
 555          continue
              write (6,fmt='(/)')
            end if
 550     continue

      ENDIF
C
C*****
C
C     =================================
      CALL LRASSN(1,LSPRGI,MCOLS,IP,CTPRGI)
C     =================================
C
C---- Check input viability
C     check input data, IP (lookup table) consistency
C
C     Existance of sigma value, but no main value
C     J=4
C     DO 230 I=1,85
C       IF (IP(J).EQ.0 .AND. IP(J+1).GT.0) THEN
C         WRITE (ERRLINE,'(2A)') ' *** ERROR: F absent - ',LSPRGI(J)
C         CALL CCPERR(2,ERRLINE)
C         KE=KE+1
C       ENDIF
C230    J=J+2
      DO 230 J=4,MCOLS,2
        IF (IP(J).EQ.0 .AND. IP(J+1).GT.0) THEN
          WRITE (ERRLINE,'(2A)') ' *** ERROR: Value absent - ',LSPRGI(J)
          CALL CCPERR(2,ERRLINE)
          KE=KE+1
        ENDIF
 230    CONTINUE
C
C 
C     J=6
C     DO 240 I=1,21
C       IF (IP(J).EQ.0 .AND. IP(J+2).GT.0) THEN
C         WRITE (ERRLINE,'(2A)') ' *** ERROR: F absent - ',LSPRGI(J)
C         CALL CCPERR(2,ERRLINE)
C         KE=KE+1
C       ENDIF
C240    J=J+8
C
C     Existance of deriv FPH(+), but no FPH
C     J=6
C     DO 244 I=1,21
C       IF (IP(J).EQ.0 .AND. IP(J+4).GT.0) THEN
C         WRITE (ERRLINE,'(2A)') ' *** ERROR: F absent - ',LSPRGI(J)
C         CALL CCPERR(2,ERRLINE)
C         KE=KE+1
C       ENDIF
C244    J=J+8
      DO 244 J=6,MCOLS,NTLRU
        IF (IP(J).EQ.0 .AND. IP(J+4).GT.0) THEN
          WRITE (ERRLINE,'(2A)') ' *** ERROR: F absent - ',LSPRGI(J)
          CALL CCPERR(2,ERRLINE)
          KE=KE+1
        ENDIF
 244  CONTINUE
C
C     Existance of deriv FPH(-), but no FPH
C     J=6
C     DO 248 I=1,21
C       IF (IP(J).EQ.0 .AND. IP(J+6).GT.0) THEN
C         WRITE (ERRLINE,'(2A)') ' *** ERROR: F absent - ',LSPRGI(J)
C         CALL CCPERR(2,ERRLINE)
C         KE=KE+1
C       ENDIF
C248    J=J+8
C
      DO 248 J=6,MCOLS,NTLRU
        IF (IP(J).EQ.0 .AND. IP(J+6).GT.0) THEN
          WRITE (ERRLINE,'(2A)') ' *** ERROR: F absent - ',LSPRGI(J)
          CALL CCPERR(2,ERRLINE)
          KE=KE+1
        ENDIF
 248    CONTINUE
C
C     FPH present and FPHn present (when only expect FPH?)
      ND=1
      IF (IP(6).GT.0) THEN
C       J=14
C       DO 250 I=1,20
C         IF (IP(J).GT.0) THEN
C           WRITE (ERRLINE,'(2A)') ' *** ERROR: F present - ',LSPRGI(J)
C           CALL CCPERR(2,ERRLINE)
C           KE=KE+1
C         ENDIF
C250      J=J+8
       ifirst=6+NTLRU
       DO 250 J=ifirst,MCOLS,NTLRU
          IF (IP(J).GT.0) THEN
            WRITE (ERRLINE,'(2A)') ' *** ERROR: F present - ',LSPRGI(J)
            CALL CCPERR(2,ERRLINE)
            KE=KE+1
          ENDIF
 250      CONTINUE
      ELSE
C
C       FPH(n) present but FPH(n-1) is absent
C       J=22
C        IF (IP(J).EQ.0) THEN
C          WRITE (ERRLINE,'(2A)') ' *** ERROR: F absent - ',LSPRGI(J)
C          CALL CCPERR(2,ERRLINE)
C          KE=KE+1
C        ENDIF
C       DO 260 I=2,20
C         IF (IP(J).GT.0) THEN
C           IF (IP(J-8).EQ.0) THEN
C             WRITE (ERRLINE,'(2A)') ' *** ERROR: F absent - ',
C    &        LSPRGI(J-8)
C             CALL CCPERR (2,ERRLINE)
C             KE=KE+1
C           ENDIF
C           ND=I
C         ENDIF
C260      J=J+8
        I=1
        ifirst=6+ntlru+ntlru
        DO 260 J=ifirst,MCOLS,NTLRU
           I=I+1
          IF (IP(J).GT.0) THEN
            IF (IP(J-NTLRU).EQ.0) THEN
              WRITE (ERRLINE,'(2A)') ' *** ERROR: F absent - ',
     &        LSPRGI(J-NTLRU)
              CALL CCPERR (2,ERRLINE)
              KE=KE+1
            ENDIF
            ND=I
          ENDIF
 260      CONTINUE
      ENDIF
C
C
C     ===================
      CALL LRCELL(1,CELL)
C     ===================
C
C     ===================================
      CALL LRSYMI(1,NGEP,LINE,NSG,SGN,PGN)
C     ===================================
C
C     ========================
      CALL LRSYMM(1,NGEPC,RTS)
C     ========================
C
C
      DO 10 I=1,NGEP
        DO 10 J=1,3
          DO 10 K=1,3
10          ISR(K,J,I)=NINT(RTS(J,K,I))
      IF (NGEP.EQ.0) THEN
        WRITE (ERRLINE,*) '*** ERROR: No symmetry info.'
        CALL CCPERR(2,ERRLINE)
        KE=KE+1
      ENDIF
      IF (KE.GT.0) CALL CCPERR(1,'*** Error(s) in data.')
C
C==== PASS 1 - GET RESOLUTION RANGE.
C
40    CALL LRREFF(1,S,AA,EOF)
      IF (EOF) GOTO 50
      IF (S.LE.SMIN .OR. S.GT.SMAX) GOTO 40
      CALL LRREFM(1,LOGMSS)
      IF (LOGMSS(4)) GOTO 40
      IF (IP(5).EQ.0 .OR. LOGMSS(5)) THEN
        IF (AA(4).LE.0.) GOTO 40
      ELSE
        IF (AA(5).LE.0.) GOTO 40
      ENDIF
C
      IC=1
      IF (CENT) THEN
        DO 41 I=1,3
41        IH(I)=NINT(AA(I))
        IC=ICENTR(NGEP,ISR,IH)
      ENDIF
C         
      IF (IP(6).GT.0) THEN
        J=6
      ELSE
C...  change because of increase in columns
C       J=14
C       J=20
        J=6+NTLRU
      ENDIF
C
      DO 270 I=1,ND
        IF (LOGMSS(J)) GOTO 270
        IF (IP(J+1).EQ.0 .OR. LOGMSS(J+1)) THEN
          IF (AA(J).LE.0.) GOTO 270
        ELSE
          IF (AA(J+1).LE.0.) GOTO 270
        ENDIF
        IF (S.LT.R1(I)) R1(I)=S
        IF (S.GT.R2(I)) R2(I)=S
        IF (IC.GT.0) THEN
          NU(I)=NU(I)+1
          IF (CENT) THEN
            IF (S.LT.R1C(I)) R1C(I)=S
            IF (S.GT.R2C(I)) R2C(I)=S
          ENDIF
        ENDIF
C...  change because of increase in columns
C270    J=J+8
270     J=J+NTLRU
      GOTO 40
C
50    CALL LRREWD(1)
C
      J=0
      N=-1
      DO 280 I=1,ND
        IF (NU(I).GT.N) THEN
          J=I
          N=NU(I)
        ENDIF
        IF (.NOT.CENT) THEN
          R1C(I)=R1(I)
          R2C(I)=R2(I)
        ENDIF
280   CONTINUE
C
      MU=2**30
      IF (LIST.GT.0) THEN
        MU=N/LIST
        IF (MU.EQ.0) MU=1
      ENDIF
      NS(J)=MAX(MIN((N+100)/200,MS),3)
      N=(N+NS(J)/2)/NS(J)
      IF (N.LT.50) CALL CCPERR(1,'*** ERROR - TOO FEW REFLECTIONS')
      IF (CENT) THEN
        Q=(R2C(J)-R1C(J))/NS(J)
      ELSE
        Q=(R2C(J)**1.5-R1C(J)**1.5)/NS(J)
      ENDIF
C
      call ccp4h_summary_beg()
      DO 60 I=1,ND
        IF (ND.GT.1) WRITE (6,'(//,A,I4)') ' For derivative',I
        RL=SQRT(1./MAX(R1C(I),1E-6))
        RH=SQRT(1./R2C(I))
        WRITE (6,'(A,I8,//,A,2F8.2/)')
     &  ' NUMBER OF REFLECTIONS USED =',NU(I),
     &  ' COMMON RESOLUTION RANGE    =  ',RL,RH
        IF (NU(I).EQ.0) CALL CCPERR(1,'*** ERROR - NO REFLECTIONS !')
        IF (CENT) THEN
          Q1(I)=R1C(I)
          Q2(I)=R2C(I)-Q1(I)
        ELSE
          Q1(I)=R1C(I)**1.5
          Q2(I)=R2C(I)**1.5-Q1(I)
        ENDIF
        NS(I)=NINT(Q2(I)/Q)
        Q2(I)=Q2(I)/NS(I)
C
C==== INITIALIZE SUMS FOR STATISTICS.
C
        SDCT(I)=0.
        SDAT(I)=0.
        DO 60 KS=1,NS(I)
          SWPS(KS,I)=0.
          SWPD(KS,I)=0.
          SWDS(KS,I)=0.
          NRC(KS,I)=0
          NRA(KS,I)=0
          SS(KS,I)=0.
          SPS(KS,I)=0.
          SDS(KS,I)=0.
          SDC(KS,I)=0.
60        SDA(KS,I)=0.
      call ccp4h_summary_end()
C
C==== PASS 2 - READ STRUCTURE FACTORS, GET FPH/FP SCALES.
C
C read reflection record from mtz file
C S contains resolution, AA contains data
70    CALL LRREFF(1,S,AA,EOF)
      IF (EOF) GOTO 80
      IF (S.LE.SMIN .OR. S.GT.SMAX) GOTO 70
C tags NaN (or equivalent MAGIC_NO) in logical array LOGMSS
      CALL LRREFM(1,LOGMSS)
      IF (LOGMSS(4)) GOTO 70
      IF (IP(5).EQ.0 .OR. LOGMSS(5)) THEN
        IF (AA(4).LE.0.) GOTO 70
        SP=0.
      ELSE
        IF (AA(5).LE.0.) GOTO 70
        SP=AA(5)
      ENDIF
      FP=AA(4)
C
      DO 71 I=1,3
71      IH(I)=NINT(AA(I))
      M=MULTIP(NGEP,ISR,IH)
      IC=ICENTR(NGEP,ISR,IH)
C
C single or multi derivative file
      IF (IP(6).GT.0) THEN
        J=6
      ELSE
C... change because of increase in columns
C       J=14
        J=6+NTLRU
      ENDIF
C
      DO 290 I=1,ND
        IF (LOGMSS(J)) GOTO 290
        IF (IP(J+1).EQ.0 .OR. LOGMSS(J+1)) THEN
          IF (AA(J).LE.0.) GOTO 290
          SD=0.
        ELSE
          IF (AA(J+1).LE.0.) GOTO 290
          SD=AA(J+1)
        ENDIF
        Q=S
        IF (.NOT.CENT) Q=Q**1.5
        KS=MIN(INT((Q-Q1(I))/Q2(I))+1,NS(I))
        FD=AA(J)
        DS=(FD-FP)**2-BIAS*(SP**2+SD**2)
        IF (IC.GT.0) THEN
          SDCT(I)=SDCT(I)+M*DS
          NRC(KS,I)=NRC(KS,I)+M
          W=1.
        ELSE
          SDAT(I)=SDAT(I)+M*DS
          NRA(KS,I)=NRA(KS,I)+M
          W=2.
        ENDIF
        IF (.NOT.CENT .OR. IC.GT.0) THEN
          SWPS(KS,I)=SWPS(KS,I)+M*((W+1.)*FP**2-W*BIAS*SP**2)
          SWPD(KS,I)=SWPD(KS,I)+M*W*FP*FD
          SWDS(KS,I)=SWDS(KS,I)+M*((W-1.)*FD**2-W*BIAS*SD**2)
        ENDIF
C...  change because of increase in columns
C290    J=J+8
 290    J=J+NTLRU
      GOTO 70
C
80    CALL LRREWD(1)
C
C==== CALCULATE SCALE FACTORS.
C
      DO 100 I=1,ND
        NRCT(I)=0
        NRAT(I)=0
        SWPST(I)=0.
        SWPDT(I)=0.
        SWDST(I)=0.
        DO 90 KS=1,NS(I)
          IF (CENT) THEN
            NRS(KS,I)=NRC(KS,I)
          ELSE
            NRS(KS,I)=NRC(KS,I)+NRA(KS,I)
          ENDIF
          IF (NRS(KS,I).EQ.0) THEN
            WRITE (6,'(/,2(A,I4))') ' !!!! NO REFLECTIONS IN SHELL',KS,
     &      ' FOR DERIVATIVE',I
            CALL CCPERR(1,'***ERROR.')
          ENDIF
          NRCT(I)=NRCT(I)+NRC(KS,I)
          NRAT(I)=NRAT(I)+NRA(KS,I)
          SWPST(I)=SWPST(I)+SWPS(KS,I)
          SWPDT(I)=SWPDT(I)+SWPD(KS,I)
          SWDST(I)=SWDST(I)+SWDS(KS,I)
          T=SWPD(KS,I)**2-SWPS(KS,I)*SWDS(KS,I)
          SC=SWPS(KS,I)/(SWPD(KS,I)+SQRT(MAX(T,0.)))
90        SWPS(KS,I)=SC
C
        IF (CENT) THEN
          NRST(I)=NRCT(I)
        ELSE
          NRST(I)=NRCT(I)+NRAT(I)
        ENDIF
        IF (NRCT(I).EQ.0) WRITE (6,'(/,A,I4,A)')
     &  'NO CENTRIC REFLECTIONS FOR DERIVATIVE',I,' : CHECK.'
        IF (NRAT(I).EQ.0) WRITE (6,'(/,A,I4,A)')
     &  'NO ACENTRIC REFLECTIONS FOR DERIVATIVE',I,': CHECK.'
C
C==== SMOOTH
C
        DO 100 KS=1,NS(I)
          IS=KS-1
          JS=KS+1
          IF (KS.EQ.1) THEN
            SCD(KS,I)=.45*SWPS(KS,I)+.55*SWPS(JS,I)
          ELSEIF (KS.EQ.NS(I)) THEN
            SCD(KS,I)=.45*SWPS(KS,I)+.55*SWPS(IS,I)
          ELSE
            SCD(KS,I)=.4*SWPS(KS,I)+.3*(SWPS(IS,I)+SWPS(JS,I))
          ENDIF
100     CONTINUE
C
C==== PASS 3 - OUTPUT SCALED REFLECTIONS.
C
      call ccp4h_summary_beg()
      call ccp4h_header('Output File','out',3)
      call ccp4h_summary_end()
C     =======================
      CALL LWOPEN(1,'HKLOUT')
C     =======================
C
C     ====================
      CALL LWTITL(1,TI1,0)
C     ====================
C
C     ================================
      CALL CCPDAT(TI2(LENSTR(TI2)+3:))
C     ================================
C
C     ==================================
      CALL LWHIST(1,TI2(:LENSTR(TI2)),1)
C     ==================================
C
C==== Get cell volume.
C
      V=1.
      S=1.
      F=2.
      DO 180 I=1,3
        V=V*CELL(I)
        IF (CELL(I+3).EQ.90.) THEN
          C=0.
        ELSE
          C=COS(3.141592654/180.*CELL(I+3))
          S=S-C*C
        ENDIF
180     F=F*C
      IF (S.NE.1.) V=V*SQRT(S+F)
C
      call ccp4h_summary_beg()
      WRITE (6,'(/,A,F12.1)') ' Cell volume =',V
      DO 300 I=1,ND
        VC=1.5*NGEPC*(NRCT(I)+NRAT(I))/(NGEP*PI*(R2(I)**1.5-R1(I)**1.5))
        F=VC/V
        WRITE (6,'(/,A,I4,8X,A,F9.3)')
     &  ' For derivative',I,'Completeness =',F
        DENOM = SDCT(I)+2.*SDAT(I)
        IF (ABS(DENOM) .LT. 0.0001) THEN
          WRITE (6,'(/,A)')
     &  ' V factor in Isomorphous Difference Patterson FFT undetermined'
        ELSE
          F=VC*(SDCT(I)+SDAT(I))/DENOM
          WRITE (6,'(/,A,A,F12.2)')
     &    ' V factor in Isomorphous Difference Patterson FFT',
     &    ' (before applying scale factors) =',F
        ENDIF
C
        S1(I)=Q1(I)+.5*Q2(I)
        S2(I)=Q2(I)
        JCD(I)=0
300     NU(I)=0
      call ccp4h_summary_end()
C
      NR=0
      NW=0
110   CALL LRREFL(1,S,AA,EOF)
      IF (EOF) GOTO 150
      NR=NR+1
C Output reflections in specified resolution range
      IF (S.LE.SMIN .OR. S.GT.SMAX) GOTO 110
      CALL LRREFM(1,LOGMSS)
      DO 120 I=1,3
120     IH(I)=NINT(AA(IP(I)))
      M=MULTIP(NGEP,ISR,IH)
      IC=ICENTR(NGEP,ISR,IH)
      IF (.NOT.LOGMSS(IP(4))) THEN
        FP=AA(IP(4))
        SP=0.
        IF (IP(5).GT.0.) THEN
          IF (.NOT.LOGMSS(IP(5))) SP=AA(IP(5))
        ENDIF
      ENDIF
C
      IF (IP(6).GT.0) THEN
        J=6
      ELSE
C...  change because of increase in columns
C       J=14
        J=6+NTLRU
      ENDIF
C
      DO 130 I=1,ND
        IF (LOGMSS(IP(J))) GOTO 130
        IF (IP(J+1).EQ.0) THEN
          IF (AA(IP(J)).LE.0.) GOTO 130
          SD=0.
        ELSEIF (LOGMSS(IP(J+1))) THEN
          IF (AA(IP(J)).LE.0.) GOTO 130
          SD=0.
        ELSE
          IF (AA(IP(J+1)).LE.0.) GOTO 130
          SD=AA(IP(J+1))
        ENDIF
        Q=S
        IF (.NOT.CENT) Q=Q**1.5
        IF (Q.GT.Q1(I)+(NS(I)+.5)*Q2(I)) GOTO 110
        SC=FSPLIN(Q,S1(I),S2(I),SCD(1,I),NS(I),JCD(I),CCD(1,I))
        FD=SC*AA(IP(J))
        AA(IP(J))=FD
        SD=SC*SD
        IF (SD.GT.0.) AA(IP(J+1))=SD
        IF (IP(J+2).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+2))) AA(IP(J+2))=SC*AA(IP(J+2))
        ENDIF 
        IF (IP(J+3).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+3))) AA(IP(J+3))=SC*AA(IP(J+3))
        ENDIF
        IF (IP(J+4).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+4))) AA(IP(J+4))=SC*AA(IP(J+4))
        ENDIF
        IF (IP(J+5).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+5))) AA(IP(J+5))=SC*AA(IP(J+5))
        ENDIF
        IF (IP(J+6).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+6))) AA(IP(J+6))=SC*AA(IP(J+6))
        ENDIF
        IF (IP(J+7).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+7))) AA(IP(J+7))=SC*AA(IP(J+7))
        ENDIF
C...  add for intensities
        IF (IP(J+8).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+8))) AA(IP(J+8))=SC*SC*AA(IP(J+8))
        ENDIF
        IF (IP(J+9).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+9))) AA(IP(J+9))=SC*SC*AA(IP(J+9))
        ENDIF
        IF (IP(J+10).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+10))) AA(IP(J+10))=SC*SC*AA(IP(J+10))
        ENDIF
        IF (IP(J+11).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+11))) AA(IP(J+11))=SC*SC*AA(IP(J+11))
        ENDIF
        IF (IP(J+12).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+12))) AA(IP(J+12))=SC*SC*AA(IP(J+12))
        ENDIF
        IF (IP(J+13).GT.0) THEN
          IF (.NOT.LOGMSS(IP(J+13))) AA(IP(J+13))=SC*SC*AA(IP(J+13))
        ENDIF
C
        IF (LOGMSS(IP(4))) GOTO 130
        IF (IP(5).EQ.0) THEN
          IF (FP.LE.0.) GOTO 130
        ELSEIF (LOGMSS(IP(5))) THEN
          IF (FP.LE.0.) GOTO 130
        ELSE
          IF (SP.LE.0.) GOTO 130
        ENDIF
        NU(I)=NU(I)+1
        KS=MIN(INT((Q-Q1(I))/Q2(I))+1,NS(I))
        IF (.NOT.CENT .OR. IC.GT.0) THEN
          SS(KS,I)=SS(KS,I)+M*S
          SPS(KS,I)=SPS(KS,I)+M*FP**2
          SDS(KS,I)=SDS(KS,I)+M*FD**2
        ENDIF
        DS=(FD-FP)**2-BIAS*(SP**2+SD**2)
        IF (IC.GT.0) THEN
          SDC(KS,I)=SDC(KS,I)+M*DS
        ELSE
          SDA(KS,I)=SDA(KS,I)+M*DS
        ENDIF
        IF (MOD(NU(I),MU).EQ.0)
     &  WRITE (6,'(1X,I4,I6,3I4,F9.4,4F9.2,3I4,F10.5)')
     &  I,NU(I),IH,S,FP,SP,FD,SD,M,IC,KS,SC
C... change because of increase in columns
C130    J=J+8
 130    J=J+NTLRU
      CALL LWREFL(1,AA)
      NW=NW+1
      GOTO 110
C
150   CALL LWCLOS(1,1)
C
      call ccp4h_header('Resolution Vs. FPH_scale','scale',3)      
C==== STATISTICS.
C
      DO 310 I=1,ND
        IF (ND.GT.1) WRITE (6,'(////,A,I4)')
     &  ' STATISTICS for derivative',I
c        WRITE (6,'(/,A,/)')
c     &  ' SHELL  RESOLUTION  NUMBER   RMS-FP   RMS-FPH   RMS-DF.C'//
c     &  '   RMS-DF.A   FPH-SCALE'
        SPST=0.
        SDST=0.
        SDCT(I)=0.
        SDAT(I)=0.
        SW=0.
        SWX=0.
        SWXS=0.
        SWY=0.
        SWXY=0.
        Q=Q1(I)
        call ccp4h_graph_beg(0,0) 
        write(6,2000)
 2000   FORMAT(//,
     $ ' $TABLE: RESOLUTION Vs. FPH-SCALE :',/,
     $ ' $GRAPHS',/,
     $ ' :Resolution vs. FPH-scale ',/,
     $ ':N:2,8:',/,
     $ ' $$', /
     $ ' SHELL  RESOLUTION  NUMBER   RMS-FP   RMS-FPH   RMS-DF.C',
     $ '   RMS-DF.A   FPH-SCALE',
     $ /,' $$',
     $/,' $$',/)
        DO 160 KS=1,NS(I)
          Q=Q+Q2(I)
          IF (CENT) THEN
            S=1./SQRT(Q)
          ELSE
            S=Q**(-1./3.)
          ENDIF
          RPS=SQRT(SPS(KS,I)/NRS(KS,I))
          RDS=SQRT(SDS(KS,I)/NRS(KS,I))
          SPST=SPST+SPS(KS,I)
          SDST=SDST+SDS(KS,I)
          IF (NRC(KS,I).EQ.0) THEN
            RDC=0.
          ELSE
            RDC=SQRT(MAX(SDC(KS,I)/NRC(KS,I),0.))
            SDCT(I)=SDCT(I)+SDC(KS,I)
          ENDIF
          IF (NRA(KS,I).EQ.0) THEN
            RDA=0.
          ELSE
            RDA=SQRT(MAX(SDA(KS,I)/NRA(KS,I),0.))
            SDAT(I)=SDAT(I)+SDA(KS,I)
          ENDIF
C
          W=NRS(KS,I)
          SS(KS,I)=.25*SS(KS,I)/W
          X=SS(KS,I)
          Y=ALOG(SCD(KS,I))
          SW=SW+W
          SWX=SWX+W*X
          SWXS=SWXS+W*X*X
          SWY=SWY+W*Y
          SWXY=SWXY+W*X*Y
160       WRITE (6,'(1X,I5,F12.2,I8,F9.1,F10.1,2F11.1,F12.5)')
     &    KS,S,NRS(KS,I),RPS,RDS,RDC,RDA,SCD(KS,I)
        WRITE(6,FMT='(/,A,//)') ' $$'
        call ccp4h_graph_end()
C
        RPS=SQRT(SPST/NRST(I))
        RDS=SQRT(SDST/NRST(I))
        IF (NRCT(I).EQ.0) THEN
          RDC=0.
        ELSE
          RDC=SQRT(MAX(SDCT(I),0.)/NRCT(I))
        ENDIF
        IF (NRAT(I).EQ.0) THEN
          RDA=0.
        ELSE
          RDA=SQRT(MAX(SDAT(I),0.)/NRAT(I))
        ENDIF
        SC=SWPST(I)/
     &  (SWPDT(I)+SQRT(MAX(SWPDT(I)**2-SWPST(I)*SWDST(I),0.)))
        WRITE (6,'(A,9X,I10,F9.1,F10.1,2F11.1,F12.5)')
     &  ' Totals',NRST(I),RPS,RDS,RDC,RDA,SC
C
C==== Linear least squares on difference Wilson plot
C     for overall scale and B-factor.
C
        D=SW*SWXS-SWX**2
        B=(SW*SWXY-SWX*SWY)/D
        SC=(SWXS*SWY-SWX*SWXY)/D
        SWX=SWX/SW
        SWY=SWY/SW
        WRITE (6,'(/,A,4F12.5)')
     &  ' Mean x,y; gradient, intercept =',SWX,SWY,B,SC
        B=-B
        SC=EXP(SC)
        S=0.
        call ccp4h_summary_beg()        
        call ccp4h_header('Scale From difference Wilson plot',
     &   'wilson',3)
        DO 170 KS=1,NS(I)
170       S=S+NRS(KS,I)*(ALOG(SCD(KS,I)/SC)+B*SS(KS,I))**2
        S=S/(NS(I)-2)
        SSC=SC*SQRT(S*SWXS/D)
        SB=SQRT(S*SW/D)
        WRITE (6,'(//,A,//,A,2F12.5,/,A,2F12.2)')
     &  ' From difference Wilson plot :',
     &  '    Overall scale and standard deviation =',SC,SSC,
     &  ' Overall B-factor and standard deviation =',B,SB
        VC=1.5*NGEPC*(NRCT(I)+NRAT(I))/(NGEP*PI*(R2(I)**1.5-R1(I)**1.5))
        F=VC*(SDCT(I)+SDAT(I))/(SDCT(I)+2.*SDAT(I))
310     WRITE (6,'(//,A,F12.2,/)')
     &  ' V factor in Isomorphous Difference Patterson FFT'//
     &  ' (for VECREF program) =',F
      WRITE (6,*) 'NUMBER OF REFLECTIONS OUTPUT =',NW
      IF (NW.LT.NR) WRITE (6,'(/,A,I6,A,/)') ' WARNING:',NR-NW,
     &' refls. not copied from input, perhaps because RESO card used.'
      call ccp4h_summary_end()
      CALL CCPERR(0,'*** NORMAL TERMINATION ***')
      END
C
C
      INTEGER FUNCTION ICENTR(NG,ISR,IH)
C--   CHECK FOR CENTRIC ZONE
C
      IMPLICIT NONE
      INTEGER NG
      INTEGER ISR(3,3,24),IH(3)
      INTEGER IC,J
      INTEGER IE(3)
C
      DO 20 IC=1,NG
        CALL GENEQ(ISR(1,1,IC),IH,IE)
        DO 10 J=1,3
10        IF (IE(J).NE.-IH(J)) GOTO 20
        ICENTR=IC
        RETURN
20    CONTINUE
      ICENTR=0
      END
C
C
      INTEGER FUNCTION MULTIP(NG,ISR,IH)
C--   CALC MULTIPLICITY.
C
      IMPLICIT NONE
      INTEGER NG
      INTEGER ISR(3,3,24),IH(3)
      INTEGER M,I,K,J
      INTEGER IE(3)
C
      M=1
      IF (NG.GT.1) THEN
        CALL GENEQ(ISR,IH,IE)
        I=1024*(1024*IE(1)+IE(2))+IE(3)
        DO 10 K=2,NG
          CALL GENEQ(ISR(1,1,K),IH,IE)
          J=1024*(1024*IE(1)+IE(2))+IE(3)
10        IF (I.EQ.J .OR. I.EQ.-J) M=M+1
      ENDIF
      MULTIP=MAX(NG,1)/M
      END
C
C
      SUBROUTINE GENEQ(ISR,IH,IE)
C-- GENERATE EQUIVALENT REFLN
C
      IMPLICIT NONE
      INTEGER ISR(3,3),IH(3),IE(3)
      INTEGER I,J
C
      DO 10 I=1,3
        IE(I)=0
        DO 10 J=1,3
10        IE(I)=IE(I)+ISR(I,J)*IH(J)
      END
C
C
      REAL FUNCTION FSPLIN(X,XO,XD,YA,N,J,C)
C
C==== CUBIC SPLINE INTERPOLATION.
C==== X  = INTERPOLATION POINT IN X.
C==== XO = FIRST SAMPLE POINT IN X.
C==== XD = INCREMENT IN X BETWEEN SAMPLE POINTS.
C==== YA = ARRAY OF N SAMPLE POINTS IN Y.
C==== N  = NUMBER OF SAMPLE POINTS.
C==== J  = RETURNED ARRAY INDEX.  MUST BE SET TO ZERO BEFORE FIRST CALL.
C==== C  = RETURNED ARRAY OF 4 CUBIC COEFFICIENTS.  J AND C MUST NOT BE
C          MODIFIED BETWEEN CALLS.
C==== FSPLIN = INTERPOLATED VALUE IN Y.
C
      IMPLICIT NONE
      INTEGER N,J
      REAL X,XO,XD
      REAL YA(N),C(4)
      INTEGER I,I1
      REAL X1,XD2,YD1,S,U1,V1,YD,U0,V0,G1,U2,V2,G2
      DATA G1 /0./
C
      IF (N.LE.2) THEN
        J=1
        IF (N.EQ.1) THEN
          FSPLIN=YA(1)
        ELSE
          FSPLIN=YA(1)+(YA(2)-YA(1))*(X-XO)/XD
        ENDIF
        RETURN
      ENDIF
C
C==== COMPUTE WHICH INTERVAL TO USE.
      I=MIN(MAX(INT((X-XO)/XD),0)+1,N-1)
      X1=XO+(I-1)*XD
C==== SAME AS LAST CALL ?
      IF (I.NE.J) THEN
C==== NO, RESET FOR NEXT CALL.
        J=I
C
C==== COMPUTE WEIGHTED DISPLACEMENT VECTOR (U1,V1) BETWEEN I AND I+1.
        XD2=XD*XD
        I1=I+1
        YD1=YA(I1)-YA(I)
        S=XD2+YD1*YD1
        U1=XD/S
        V1=YD1/S
        C(1)=YA(I)
C
        IF (I.EQ.1) GOTO 1
C==== COMPUTE VECTOR (U0,V0) BETWEEN I-1 AND I, AND GRADIENT G1 AT I.
        YD=YA(I)-YA(I-1)
        S=XD2+YD*YD
        U0=XD/S
        V0=YD/S
        G1=(V0+V1)/(U0+U1)
C
        IF (I1.EQ.N) GOTO 3
C==== COMPUTE VECTOR (U2,V2) BETWEEN I+1 AND I+2, AND GRADIENT G2 AT I+1.
1       YD=YA(I1+1)-YA(I1)
        S=XD2+YD*YD
        U2=XD/S
        V2=YD/S
        G2=(V1+V2)/(U1+U2)
C
        IF (I.NE.1) GOTO 2
C==== CASE OF FIRST INTERVAL, COMPUTE QUADRATIC COEFFIENTS.
        C(2)=YD1/XD
        C(3)=G2-C(2)
        C(2)=C(2)-C(3)
        C(3)=C(3)/XD
        C(4)=0.
        GOTO 4
C
C==== GENERAL CASE, COMPUTE CUBIC COEFFICENTS.
2       C(2)=G1
        C(3)=YD1/XD
        C(4)=G1+G2-2.*C(3)
        C(3)=(C(3)-C(4)-G1)/XD
        C(4)=C(4)/XD2
        GOTO 4
C
C==== CASE OF LAST INTERVAL, COMPUTE QUADRATIC COEFFICIENTS.
3       C(2)=G1
        C(3)=(YD1/XD-G1)/XD
        C(4)=0.
      ENDIF
C
C==== COMPUTE FUNCTION VALUE AND RETURN.
4     S=X-X1
      FSPLIN=C(1)+S*(C(2)+S*(C(3)+S*C(4)))
      END
