C
C     FINDNCS
C     Copyright (C) 2002 Guoguang Lu
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
c This program reads a cluster of heavy atom sites and tries to find out if there
c is any possible NCS operation between these sites. The heavy atom site number
c has to be more than 6.
c
c 970918 -- Guoguang Lu, Karolinska Institute, Stockholm
c 970923 -- V1.1 add multiple fralim, xyzlim and sphere function
c 971001 -- V1.1 add multiple fralim, xyzlim and sphere function
c
      program findncs
c
      parameter (maxsites=2000,maxncs=5000)
      parameter (maxlim=20)
      character*80 key,file,file1
      character*40 word,symop
      character*4 CDEF,COMP(maxsites),atomname,resname
      character*14 latnam,subkey,filname2
      character*30 latnams,pgname
      character*7 outname
      character*1 blank
      character FILNAME*80,GETNAM*80
      real sxyz(3,maxsites),sfxyz(3,maxsites)
      real sxyz0(3,maxsites),sfxyz0(3,maxsites)
      real sxyz2(3,maxsites),sfxyz3(3,maxsites)
      real xtp1(3,maxsites),xtp2(3,maxsites)
      real gosv(maxncs)
      real dists(maxsites,maxsites)
c	real dspl(maxsites)
      real cell(6),deor(3,3),orth(3,3),orth2(3,3)
      real cells(6),deors(3,3),orths(3,3)
      real p1(3),p2(3)
      real b1(3),b2(3),btr(3)
      real rot(3,3),tr(3),ori(3)
C	real rot(3,3),tr(3),ori(3)/0.,0.,0./
      real rotold(3,3),trold(3)
      real conv(3,3),cinv(3,3),convt(3,3),cinvt(3,3)
      real aat(3,3),buf1(3,3),buf2(3,3)
      real rotsv(3,3,maxncs),trsv(3,maxncs)
      real rmssv(maxncs),radsv(maxncs)
      real csv(3,maxncs)
      real frclim(3,2,maxlim),xlim(3,2,maxlim)
      real cenlim(3,maxlim),radlim(maxlim)
      real angerr,error,ss,ds
      real xyzlim(3,2)
      real*4 rsym(3,4,96),rsymc(4,4,192),centr(3),srad
      logical*1 dump,lim,list
      integer nsym,maxdisp
      integer nxlim,nflim,nslim
      integer im1(maxsites),im2(maxsites)
      integer imf1(maxsites),imf2(maxsites)
      integer iorder(maxncs)
      integer im1save(maxsites,maxncs),im2save(maxsites,maxncs)
      integer im1new(maxsites),im2new(maxsites)
      integer im1old(maxsites),im2old(maxsites)
      integer matsave(maxncs)
      integer id(maxsites),ids(maxsites),idt(maxsites)
      integer minall,monitor
      logical*1 cont,cels,disp
      common/mat/ match,im1,im2
      common/matsv/ matsave,im1save,im2save
      common/rot/ rot,tr,rotsv,trsv
      common/rmsstaff/ rms,rmssv
      common/radstaff/ radsv
      common/gostaff/ gosv
      common/xtp/ ori,csv,xtp1,xtp2
      common/lat/ latnam
c...  data statements.  Separate declaration and init required for f2c
      data file1 /'              '/
      data outname /'NCS    '/
      data cell /10000.,10000.,10000.,90.,90.,90./
      data deor /1.,0.,0.,0.,1.,0.,0.,0.,1./
      data orth /1.,0.,0.,0.,1.,0.,0.,0.,1./
      data orth2 /1.,0.,0.,0.,1.,0.,0.,0.,1./
      data angerr /1./,error /1./,ds /22./
      data xyzlim /-1.,-1.,-1.,1.,1.,1./
      data srad /99999./
      data dump /.false./,lim /.true./,list /.false./
      data nsym /0/,maxdisp /10/
      data nxlim /0/,nflim /0/,nslim /0/
      data minall /3/,monitor /1000/
      data cont /.false./,cels /.false./,disp /.false./
      data blank /' '/
c
c declare functions
      real lgg_radii
      external lgg_radii, acosd
c
        CALL CCPFYP
        CALL CCPRCS(6,'FINDNCS','$Date: 2008/03/25 16:46:15 $')

      call ccpdpn(22,'CHAR.CHA','UNKNOWN','F',0,0)
c
      write(6,*) 
      write(6,*) '================================================'
      write(6,*) '             F  I  N  D  N  C  S' 
      write(6,*) 'Detecting NCS relations from heavy atom sites'
      write(6,*) '           Version 1.1      Sep-30-1997         '
      write(6,*) '================================================'
      write(6,*) 
      write(6,*) 'Author:    Guoguang Lu'
      write(6,*) '           Karolinska Institute, Stockholm, Sweden '
      write(6,*) 'E-mail:    guoguang@alfa.mbb.ki.se                 '
      write(6,*) 
     +        'WWW:       http://gamma.mbb.ki.se/~guoguang/findncs.html'
      write(6,*) 
     + 'Reference: G. Lu, FINDNCS: A program to detect non-crystallograp
     +hic'
      write(6,'(11x,a)') 
     + ' symmetries in protein crystals from heavy-atom sites '
      write(6,'(11x,a)') 
     + ' J. Appl. Cryst. 32, 365 (1999).'
      write(6,*) 
      call explain
      nsite = 0
      nelim = 0
      cont = .false.
      maxshow = maxncs
      minmatch = 300
        DO I=1,maxsites
          DO J=1,maxsites
            dists(j,i) = 0.0
          ENDDO
        ENDDO
        tm0 = 0.0
        CALL UCPUTM(tm0)
c
5	read(5,'(a)',err=4,end=4) key
      if (key(1:1).eq.'!'.or.
     +   key(1:1).eq.'#'.or.
     +   key(1:1).eq.';') goto 5
      ln = lenstr(key)
      if (ln.eq.0) goto 5
c
      isp = index(key,blank)
      if (.not.cont) word(1:isp-1) = key(1:isp-1)
      call up(word(1:isp-1),isp-1)
      if (word(1:3).ne.'PDB'.and.word(1:3).ne.'OUT')
     + call up(key(1:ln),ln)
      if (cont) then
       call lgg_string(22,ln,key(1:ln),npar,cont)
      else
       call lgg_string(22,ln-isp,key(isp+1:ln),npar,cont)
      end if
      if (key(ln:ln).eq.'-') then
       cont = .true.
       goto 5
      else
       cont = .false.
       rewind (22)
      end if
c
      if (word(1:4).eq.'CELL') then
       read(22,*,err=9,end=9) cell
       call lgg_crystal(cell,cells,deor,orth,deors,orths)
       if (dump) then
        write(6,'(a,3f8.2,3f8.1)') 'Cell dimension',cell
        write(6,'(a)') 'Orthogonalization matrix'
        write(6,15) ((orth(i,j),j=1,3),i=1,3)
        write(6,'(a)') 'deorthogonalization matrix'
        write(6,15) ((deor(i,j),j=1,3),i=1,3)
       end if
15	 format(3f10.5)
       goto 5
      end if
c
      if (word(1:4).eq.'DUMP') then
       read(22,'(a1)',err=9,end=9) WORD(1:1)
       if (word(1:1).eq.'Y') then
        write(6,*) 'dump out all the garbage'
        dump = .true.
       end if
       goto 5
      end if
c
      if (word(1:4).eq.'LIST') then
       read(22,'(a1)',err=9,end=9) WORD(1:1)
       if (word(1:1).eq.'Y') then
        write(6,*) 'List detailed information'
        list = .true.
       end if
       goto 5
      end if
c
      if (word(1:4).eq.'MINM') then
       read(22,*,err=9,end=9) minall
       if (dump) write(6,*)
     +    'Minimum site match number for each NCS',minall
       goto 5
      end if
c
      if (word(1:4).eq.'MONI') then
       read(22,*,err=9,end=9) monitor
       if (dump) write(6,*)
     +    'Monitor every',monitor,' possible solutions'
       goto 5
      end if
c
      if (word(1:5).eq.'FSITE') then
       read(22,*,err=9,end=9) (sfxyz0(i,nsite+1),i=1,3)
       NSITE = NSITE + 1
       call matmult(3,3,3,1,orth,sfxyz0(1,nsite),sxyz0(1,nsite))
       read(22,'(a4)',end=92) comp(nsite)
       goto 5
92	 comp(nsite)=cdef
       goto 5
      end if
c
      if (word(1:4).eq.'SITE') then
       read(22,*,err=9,end=9) (sxyz0(i,nsite+1),i=1,3)
       NSITE = NSITE + 1
       read(22,'(a4)',end=91) comp(nsite)	 
       goto 5
91	 comp(nsite)=cdef
       goto 5
      end if
c
      if (word(1:4).eq.'COMP') then
       read(22,'(A4)',err=9,end=9) CDEF
       if (dump) write(6,*)  
     +               'Default name for the following site is ',CDEF
       goto 5
      end if
c
      if (word(1:4).eq.'DISP') then
       disp = .true.
       read(22,*,err=9,end=9) MAXDISP
       if (maxdisp.gt.10) then
        write(6,*) 
     +           'Warning: Maximum number of solutions to display is 10'
        maxdisp = 10
       end if
       if (dump) write(6,*)  
     +           'Number of solutions to be displayed',maxdisp
       read(22,*,err=9,end=9) ds
       if (dump.or.list) write(6,'(a,f6.2)') 
     +           'Length of NCS axis to be displayed on O',ds
       goto 5
      end if
c
      if (word(1:6).eq.'FRCLIM') then
       write(6,*)  'nflim',nflim
       read(22,*,err=9,end=9) ((frclim(i,j,nflim+1),j=1,2),i=1,3)
       nflim = nflim + 1
       if (nflim.eq.1) then
        call arrgive(6,frclim,xyzlim)
       else
        do i = 1, 3
         xyzlim(i,1) = min(frclim(i,1,nflim),xyzlim(i,1))
         xyzlim(i,2) = max(frclim(i,2,nflim),xyzlim(i,2))
        end do
       end if
       lim = .false.
       if (dump.or.list) then
        write(6,*) 'Extended range'
        write(6,'(3f10.5)') xyzlim
        write(6,*) 'Fractional XYZ limit',nflim
        write(6,'(3f10.4)') ((frclim(i,j,nflim),j=1,2),i=1,3)
       end if
       goto 5
      end if
c
      if (word(1:6).eq.'XYZLIM') then
       read(22,*,err=9,end=9) ((xlim(i,j,nxlim+1),j=1,2),i=1,3)
       nxlim = nxlim + 1
       lim = .false.
       if (dump.or.list) then
        write(6,*) 'orthogonal XYZ limit',nxlim
        write(6,'(3f10.4)') ((xlim(i,j,nxlim),j=1,2),i=1,3)
       end if
       goto 5
      end if
c
      if (word(1:4).eq.'MAXN') then
       read(22,*,err=9,end=9) MAXSHOW
       write(6,*) 
     +    'Maximum number of NCS operations to be output',MAXSHOW
       goto 5
      end if
c
      if (word(1:4).eq.'SPHE') then
       read(22,*,err=9,end=9) (cenlim(i,nslim+1),i=1,3),radlim(nslim+1)
       nslim = nslim + 1
       lim = .false.
       if (dump.or.list) then
        write(6,'(a,i3,6x,a,f8.2)') 
     +		'Sphere',nslim,'radius',radlim(nslim)
        write(6,'(3f10.4)') (cenlim(i,nslim),i=1,3)
       end if
       goto 5
      end if
c
      if (word(1:3).eq.'ERR') then
       read(22,*,err=9,end=9) error
       if (dump) write(6,*) 'Allowed distance error is',error
       goto 5
      end if
c
      if (word(1:3).eq.'SPA'.or.word(1:3).eq.'SYM') then

        cels = .true.
        latnam = ' '
        nsp = 0
        read(key(isp+1:ln),*,err=520) nsp
 520    continue
        if (nsp.le.0.or.nsp.ge.360) then
          nsp = 0
          read(key(isp+1:isp+14),'(a)') latnam
        endif

        call  msymlb3(25,nsp,latnam,latnams,pgname,nind,nsym,
     +                    rsymc)
        do i = 1,nsym
          do j = 1,4
            do k = 1,3
              rsym(k,j,i) = rsymc(k,j,i)
            enddo
          enddo
        enddo

        goto 5
      end if
c
      if (word(1:4).eq.'ANGE') then
       read(22,*,err=9,end=9) angerr
       write(6,*) 'Allowed angle error is',angerr
       goto 5
      end if
c
9	continue
      write(6,*) 'Unrecognized command',KEY
      goto 5
c
4	continue
c
      close (22)
      write(6,'(i10,a)') NSITE, ' sites were read in'
      if (nsite.lt.6) then
       write(6,*) 'There must be at least 6 sites for checking NCS'
       write(6,*) 'The program cannot cope with this case'
       stop
      end if
c -- put everything into fractional coordinates
      if (cels) then
      call matmult(3,3,3,nsite,deor,sxyz0,sfxyz0)
      if (dump) then
       do i = 1, nsite
        write(6,*) comp(i),i,(sfxyz0(j,i),j=1,3)
       end do
      end if
c -- give symmetry operation
      if (nsym.eq.0) then
       nsym = 1
       call elize(3,rsym)
       call arrvalue(3,rsym(1,1,4),0.)
      end if
      nsite1 = 0
      if (lim.and.latnam(1:1).ne.'P') then
       nhere=nind
      else
       nhere = nsym
      end if
      do j = 1, nsite
       do i = 1, nhere
        if (dump.and.j.eq.1) then
         write(6,*) 'symmetry',i
         write(6,'(3f12.6)') ((rsym(j1,k,i),j1=1,3),k=1,4)
        end if
        nsite1 = nsite1+1
        call rtmov(1,sfxyz0(1,j),rsym(1,1,i),rsym(1,4,i),
     +                                           sxyz2(1,nsite1))
        ids(nsite1) = j
       end do
      end do
      write(6,*) nsite1,' sites after symmetry operations'
      if (dump) then
       do i = 1, nsite1
        write(6,*) i,(sxyz2(j,i),j=1,3)
       end do
      end if
      nsite = nsite1
c	call arrgive(3*nsite,sxyz2,sfxyz0)	
c get a convert matrix to a primitive cell.
      call latconv(latnam(1:1),conv,cinv,convt,cinvt)
c - if limit is default and lattice is C,R,I or F, 
c   change into a primitive unit cell
      if (lim.and.latnam(1:1).ne.'P') then
 	 if (list.or.dump) then
        write(6,*) 'Lattice ',latnam(1:1),
     +    '   Convert into a primitive lattice with matrix'
        write(6,'(3f8.4)') convt
       end if
       call matmult(3,3,3,nsite,cinvt,sxyz2,sfxyz0)
      else
       call arrgive(3*nsite,sxyz2,sfxyz0)
      end if
c put them in one primitive unit cell
      call fmatin(3*nsite,sfxyz0)
      if (dump) then
       do i = 1, nsite
        write(6,'(a,2i5,3f10.5)') 
     +		comp(ids(i)),i,ids(i),(sfxyz0(j,i),j=1,3)
       end do
      end if
c extend them to xyzlow<->xyzhigh(xyzlim), from fractional coordinates
      call fextend(maxsites,xyzlim,nsite,sfxyz0,nsiteall,sfxyz3,idt)
      write(6,*) nsiteall,' sites are extended to maximum cells'
      if (dump) then
       write(6,'(3f10.5)') xyzlim
      end if
      do i= 1, nsiteall
       id(i) = ids(idt(i))
       if (dump) then
        write(6,'(a,3i5,3f10.5)')
     +    comp(id(i)),i,idt(i),ids(idt(i)),(sfxyz3(j,i),j=1,3)
c     +   comp(id(i)),i,idt(i),ids(idt(i))
c     +  ,(sfxyz(j,i),j=1,3)
       end if
      end do
      nsite0 = nsite
      nsite = nsiteall
c convert back to conventional unit cell
c	if (lim.and.latnam(1:1).ne.'P') then
c	 call matmult(3,3,3,nsite,convt,sfxyz3,sfxyz)
c	else
       call arrgive(3*nsite,sfxyz3,sfxyz)
c	end if
c change into the orthogonal system
      if (lim.and.latnam(1:1).ne.'P') then
       call matmult(3,3,3,3,orth,convt,orth2)
       call matmult(3,3,3,nsite,orth2,sfxyz,sxyz) 
      else
       call matmult(3,3,3,nsite,orth,sfxyz,sxyz) 
      end if
c not apply the xyz, frc and sphere limitation.
      if (.not.lim) then
       nsitec = 0
       do i = 1, nsite
c include sites inside frclim
        if (nflim.gt.0) then
         do iflim = 1, nflim
          if (sfxyz(1,i).ge.frclim(1,1,iflim).and.
     +		sfxyz(1,i).le.frclim(1,2,iflim).and.
     +		sfxyz(2,i).ge.frclim(2,1,iflim).and.
     +		sfxyz(2,i).le.frclim(2,2,iflim).and.
     +		sfxyz(3,i).ge.frclim(3,1,iflim).and.
     +		sfxyz(3,i).le.frclim(3,2,iflim)) then
           nsitec = nsitec + 1
           call arrgive(3,sxyz(1,i),sxyz2(1,nsitec))
           ids(nsitec) = id(i)
           goto 910
          end if
         end do
        end if
c include sites inside xyzlim
        if (nxlim.gt.0) then
         do ixlim = 1, nxlim
          if (sxyz(1,i).ge.xlim(1,1,ixlim).and.
     +		sxyz(1,i).le.xlim(1,2,ixlim).and.
     +		sxyz(2,i).ge.xlim(2,1,ixlim).and.
     +		sxyz(2,i).le.xlim(2,2,ixlim).and.
     +		sxyz(3,i).ge.xlim(3,1,ixlim).and.
     +		sxyz(3,i).le.xlim(3,2,ixlim)) then
           nsitec = nsitec + 1
           call arrgive(3,sxyz(1,i),sxyz2(1,nsitec))
           ids(nsitec) = id(i)
           goto 910
          end if
         end do
        end if
c include the sites inside sphere
        if (nslim.gt.0) then
         do islim = 1, nslim
          if (dist(sxyz(1,i),cenlim(1,islim)).lt.radlim(islim)) then
           nsitec = nsitec + 1
           call arrgive(3,sxyz(1,i),sxyz2(1,nsitec))
           ids(nsitec) = id(i)
           goto 910
          end if
         end do
        end if
910	 end do
       write(6,*) nsitec,' sites are inside the selection ranges'
       nsite = nsitec
       call arrgive(3*nsitec,sxyz2,sxyz)
c turn back to fractional coordinates of a primitive unit cell.
       if (latnam(1:1).ne.'P') then
        call matmult(3,3,3,3,cinvt,deor,buf2)
        call matmult(3,3,3,nsite,buf2,sxyz,sfxyz)
       else
        call matmult(3,3,3,nsite,deor,sxyz,sfxyz)
       end if
       do i = 1, nsite
        id(i) = ids(i)
       end do
      end if
      write(6,*) 
c -- else: no space group is give
      else
      write(6,'(a,/,8x,a)') 'Warning: No space group is given.',
     + ' Crystallographic symmetries are not operated to the sites'
      call arrgive(3*nsite,sxyz0,sxyz)
      do i =1, nsite
       id(i) = i
      end do
      end if
      if (dump) then
       do i = 1, nsite
        write(6,*) i,(sxyz(j,i),j=1,3),id(i)
       end do
      end if
c write out the coordinate
      if (disp) then
       do i = 1, nsite
        imf1(i) = i
       end do
       call putpdbf(3,'ncsall.pdb',nsite,cell,sxyz,comp,imf1,'  ',
     .      nsite,id)
      end if
c
c Calculate a distance matrix first
c
      write(6,*) 'Building a distance matrix......'
      if (cels) then
       do i = 1, nsite-1
        do j = i+1, nsite
         call arrps(3,1,sfxyz(1,i),sfxyz(1,j),b1)
         if (abs(b1(1)).gt.1.0.or.abs(b1(2)).gt.1.0.or.
     +         abs(b1(3)).gt.1.0) then
          dists(i,j) = 10000.
         else
          dists(i,j) = dist(sxyz(1,i),sxyz(1,j))
          if (dists(i,j).lt.error.and.
     +       comp(id(i)).eq.comp(id(j))) then
           write(6,'(a,2(2i4,a))')
     + 'Warning: sites',id(i),id(j),' (',i,j,')  are too close'
           write(6,'(6x, a,f6.1,a)') 
     + 'distance is only',dists(i,j),' A'
          end if
         end if
         dists(j,i) = dists(i,j) 
        end do
       end do
      else
       do i = 1, nsite-1
        do j = i+1, nsite
         dists(i,j) = dist(sxyz(1,i),sxyz(1,j))
         dists(j,i) = dists(i,j) 
         if (dists(i,j).lt.error) then
          write(6,'(a,2(2i4,a))')
     + 'Error: sites',id(i),id(j),' (',i,j,') are too close'
          write(6,'(6x, a,f6.1,a)') 'distance is only',dists(i,j),' A'
          stop '      Remove one of the sites please'
         end if
        end do
       end do
      end if	 
c
      nmatch = 0
      maxtop = 0
c
c Now it implement the searching
C
      NSTART1 = 0
      NSTART2 = 0
      MATCH = 0
      IADD = - 1

      write(6,*) 'Looking for NCS matches......'
5010	DO I1 = 1, NSITE-2
       IM1NEW(1) = I1
5020	 DO I2 = I1+1, NSITE -1
        IF (DISTS(I1,I2).GT.9999.) GOTO 5120
        IF (ID(I2).EQ.ID(I1)) GOTO 5120
c	  IF (DISTS(I1,I2).LT.ERROR) GOTO 5120
c	  IF (DISTS(ID(I1),ID(I2)).LT.ERROR) GOTO 5120
        IM1NEW(2) = I2
5030	  DO I3 = I2+1, NSITE
         IF (DISTS(I1,I3).GT.9999..OR.DISTS(I2,I3).GT.9999.) GOTO 5130
c	   IF (DISTS(I1,I3).LT.ERROR.OR.DISTS(I2,I3).LT.ERROR) GOTO 5130
c	   IF (DISTS(ID(I1),ID(I3)).LT.ERROR.OR.
c     +      DISTS(ID(I2),ID(I3)).LT.ERROR) GOTO 5130
         IF (ID(I3).EQ.ID(I1).or.ID(I3).EQ.ID(I2)) GOTO 5130	   
         IM1NEW(3) = I3
5040	  DO J1 = 1, NSITE
         IF (COMP(ID(J1)).NE.COMP(ID(I1))) GOTO 5140
         IF (ID(J1).EQ.ID(I1).or.ID(J1).EQ.ID(I2).or.ID(J1).EQ.ID(I3)) 
     +	GOTO 5140
         IF (DISTS(J1,I1).GT.9999.0.OR.DISTS(J1,I2).GT.9999.0.OR.
     +          DISTS(J1,I3).GT.9999.0) GOTO 5140
C	   IF (J1.EQ.I1.or.J1.EQ.I2.or.J1.EQ.I3) GOTO 5140
         IM2NEW(1) = J1
5050	   DO J2 = 1, NSITE
          IF (COMP(ID(J2)).NE.COMP(ID(I2))) GOTO 5150
          IF (ID(J2).EQ.ID(I1).or.ID(J2).EQ.ID(I2).or.ID(J2).EQ.ID(I3)
     +      .or.ID(J2).EQ.ID(J1)) GOTO 5150
c	    IF (J2.EQ.I1.or.J2.EQ.I2.or.J2.EQ.I3.or.J3.EQ.J1) GOTO 5150
c	    IF (DISTS(J1,J2).LT.ERROR) GOTO 5150
c	    IF (DISTS(ID(J1),ID(J2)).LT.ERROR) GOTO 5150
          IF (DISTS(J2,I1).GT.9999.0.OR.DISTS(J2,I2).GT.9999.0.OR.
     +          DISTS(J2,I3).GT.9999.0) GOTO 5150
            IF (DISTS(J1,J2).GT.9999.) GOTO 5150
          IF (ABS(DISTS(J1,J2)-DISTS(I1,I2)).GT.ERROR) goto 5150
          IM2NEW(2) = J2
5060	    DO J3 = 1, NSITE
           IF (COMP(ID(J3)).NE.COMP(ID(I3))) GOTO 5160
             IF (ID(J3).EQ.ID(I1).or.ID(J3).EQ.ID(I2).or.
     +           ID(J3).EQ.ID(I3)) GOTO 5160
           IF (ID(J3).EQ.ID(J1).or.ID(J3).EQ.ID(J2)) GOTO 5160
           IF (DISTS(J3,I1).GT.9999.0.OR.DISTS(J3,I2).GT.9999.0.OR.
     +            DISTS(J3,I3).GT.9999.0) GOTO 5160
           IF (DISTS(J1,J3).GT.9999..OR.DISTS(J2,J3).GT.9999.) 
     +    GOTO 5160
c	     IF (DISTS(J1,J3).LT.ERROR.OR.DISTS(J2,J3).LT.ERROR) 
c     +   GOTO 5160
c	     IF (DISTS(ID(J1),ID(J3)).LT.ERROR.OR.
c     +	  DISTS(ID(J2),ID(J3)).LT.ERROR) GOTO 5160
C	     IF (J3.EQ.I1.or.J3.EQ.I2.or.J3.EQ.I3) GOTO 5160
C	     IF (J3.EQ.J1.or.J3.EQ.J2) GOTO 5160
           IF (ABS(DISTS(J1,J3)-DISTS(I1,I3)).GT.ERROR) goto 5160
           IF (ABS(DISTS(J2,J3)-DISTS(I2,I3)).GT.ERROR) goto 5160
           IM2NEW(3) = J3
c -- here a match is found. get the coordinates
           ncycl = 0
           match = 3
           call iarrgive(3,im1new,im1)
           call iarrgive(3,im2new,im2)
1701	     mold = match
           DO I = 1, match
             CALL ARRGIVE(match,SXYZ(1,IM1(I)),XTP1(1,I))
             CALL ARRGIVE(match,SXYZ(1,IM2(I)),XTP2(1,I))
            END DO
c superimpose them and get the ncs and rms so on
            CALL FITCA1(match,XTP2, XTP1, ROT, TR, RMS, SMEAN)
c find out who match who
            call rtmov(nsite,sxyz,rot,tr,sxyz2)
            match = 0
            do k1=1, nsite
             dmin = 1000000.
             do k2= 1,nsite
              if (comp(id(k2)).ne.comp(id(k1))) goto 1720
              d2 = dist(sxyz(1,k1),sxyz2(1,k2))
              dmin = min(dmin,d2)
              if (d2.lt.error.and.(dists(k1,k2).lt.9999.)
     +                    .and.d2.eq.dmin) then
               if (match.eq.0) match = 1
               if (k1.gt.im1(match)) match = match + 1
               im1(match)=k1
               im2(match)=k2
              end if
1720         end do
            end do
c	      write(6,*) 'i1,i2,i3,j1,j2,j3',i1,i2,i3,j1,j2,j3
            if (match.lt.minall) goto 5160
            ncycl = ncycl + 1
            if (match.gt.mold) then
c		WRITE(6,*) 'NCYCL,MATCH,MOLD',NCYCL,MATCH,MOLD
             call arrgive(9,rot,rotold)
             call arrgive(3,tr,trold)
             call iarrgive(match,im1,im1old)
             call iarrgive(match,im2,im2old)
             goto 1701
            else if (match.lt.mold.and.ncycl.gt.1) then
c		write(6,*) 'ncycl,match,mold',ncycl,match,mold
             match = mold
             call arrgive(9,rotold,rot)
             call arrgive(3,trold,tr)
             call iarrgive(match,im1old,im1)
             call iarrgive(match,im2old,im2)
            end if
            if (dump) then
             write(6,*) 'Match pairs:',match,'  Ncycl',ncycl
             write(6,'(35i4)') (im1(i),i=1,match)
             write(6,'(35i4)') (im2(i),i=1,match)
             write(6,'(A,6I5)')
     + 'Real match from i1,i2,i3,j1,j2,j3',i1,i2,i3,j1,j2,j3
             write(6,'(35i3)') (id(im1(i)),i=1,match)
             write(6,'(35i3)') (id(im2(i)),i=1,match)
            end if
c-- truncate the containment.
            imf1(1) = im1(1)
            imf2(1) = im2(1)
c	      dspl(1) = dstplrotr(rot,tr,sxyz(1,im1(1)))
            mreal = 1
            do in1 = 2, match
             if (id(im1(in1)).eq.id(im2(in1))) goto 1510
c	       dss2 = dstplrotr(rot,tr,sxyz(1,im1(in1)))
             do in2 = 1, mreal
              if (id(im1(in1)).eq.id(imf1(in2)).or.
     +		    id(im2(in1)).eq.id(imf2(in2)) ) then
c replace if pair distance is shorter
      	 if (dists(im1(in1),im2(in1)).lt.
     +		     dists(imf1(in2),imf2(in2)) ) then
      	  imf1(in2) = im1(in1)
      	  imf2(in2) = im2(in1)
c		  dspl(in2) = dss2
      	 end if
      	 goto 1510
      	end if
             end do
             mreal = mreal + 1
             imf1(mreal) = im1(in1)
             imf2(mreal) = im2(in1)
c	       dspl(mreal) = dss2
1510	      end do
            if (match.lt.minall) goto 5160
            if(dump) then
             write(6,*) 'truncated match',mreal
             write(6,'(35i4)') (imf1(i),i=1,mreal)
             write(6,'(35i4)') (imf2(i),i=1,mreal)
             write(6,*) 'truncated real match when nmatch=',nmatch
             write(6,'(35i3)') (id(imf1(i)),i=1,mreal)
             write(6,'(35i3)') (id(imf2(i)),i=1,mreal)
            end if
c-- take away the incorrect alignment and replace the match
            im1(1) = imf1(1)
            im2(1) = imf2(1)
            match = 1
            do in1 = 2, mreal
             do in2 = 1, match
      	if ((id(imf1(in1)).eq.id(imf2(in2)).and.
     +            id(imf2(in1)).ne.id(imf1(in2))) .or.
     + 	    (id(imf2(in1)).eq.id(imf1(in2)).and.
     +            id(imf1(in1)).ne.id(imf2(in2))) .or.
     +	     id(imf2(in1)).eq.id(imf2(in2)) ) then
      	 match = match -1
      	 if (match.eq.0) then
      	  im1(1) = imf2(in1+1)
      	  im2(1) = imf2(in1+1)
      	 end if
      	 goto 1710
      	end if
             end do
             match = match + 1
             im1(match) = imf1(in1)
             im2(match) = imf2(in1)
1710	      end do
            if (match.lt.minall) goto 5160
            if(dump) then
             write(6,*) 'final clean match',match
             write(6,'(35i3)') (im1(i),i=1,match)
             write(6,'(35i3)') (im2(i),i=1,match)
             write(6,*) 'Real match'
             write(6,'(35i3)') (id(im1(i)),i=1,match)
             write(6,'(35i3)') (id(im2(i)),i=1,match)
            end if
            if (match.lt.3) goto 5160
            maxtop = max(maxtop,match)
c --- replace the match
c	      match = mreal
c	      do i =1, match
c	       im1(i) = imf1(i)
c	       im2(i) = imf2(i)
c	      end do
c-- check if this is an old match from matching atoms
            if (nmatch.gt.0) then
             DO ICHK = 1, NMATCH
              DO ICHKNEW = 1,MATCH
      	 IF (MATCH.GT.MATSAVE(ICHK)) GOTO 1410
      	 DO ICHKOLD = 1,MATSAVE(ICHK)
                IF (ID(IM1(ICHKNEW)).EQ.ID(IM1SAVE(ICHKOLD,ICHK)).and.
     +             ID(IM2(ICHKNEW)).EQ.ID(IM2SAVE(ICHKOLD,ICHK))) 
     +	      goto 1420
1430		 END DO
      	 GOTO 1410
1420		END DO
              if (dump) write(6,*)
     +        'This match is included in match ',ichk   
c-- Replace the old one if screw distance is smaller or
c center/origin distance is smaller
      	if (match.eq.MATSAVE(ICHK)) then
               go = screw(rot,tr)
               do i = 1, match
                 call arrgive(3,sxyz(1,im1(i)),xtp1(1,i))
                 call arrgive(3,sxyz(1,im2(i)),xtp2(1,i))
               end do
      	 call arrgive(match*3,xtp2,xtp1(1,match+1))
      	 call averg(3,2*match,xtp1,centr)
c -- if screwing is shorter get a new superimposition matrix
      	 if ( int(abs(go)).lt.int(abs(gosv(ichk))) ) then
      	  if(dump) 
     +		   write(6,*) 'go is smaller, this replace save set',ichk
                call fitca1(match,xtp2, xtp1, rot, tr, rms, smean)
      	  call savemt(ichk)
c		  write(6,*) 'rot,tr',rot,tr
c		 else if (int(abs(go)).eq.int(abs(gosv(ichk))).and.
c     +             dstplrotr(rot,tr,ori).lt.dst0sv(ichk) ) then
c -- if center is closer to origin get a new superimposition matrix
      	 else if (int(abs(go)).eq.int(abs(gosv(ichk))).and.
     +			vem(3,centr).lt.vem(3,csv(1,ichk))) then
      	  if(dump) 
     +		  write(6,*) 'center closer to O replace save set',ichk
                call fitca1(match,xtp2, xtp1, rot, tr, rms, smean)
                call savemt(ichk)
c		  write(6,*) 'rot,tr',rot,tr
      	 end if
      	end if
      	goto 5160
1410	       END DO
            end if
1400	      continue
c-- check if this is an reversed old match from the matching atoms
            if (nmatch.gt.0) then
             DO ICHK = 1, NMATCH
              DO ICHKNEW = 1,MATCH
      	 IF (MATCH.GT.MATSAVE(ICHK)) GOTO 2410
      	 DO ICHKOLD = 1,MATSAVE(ICHK)
      	  IF ( IM1(ICHKNEW).EQ.IM2SAVE(ICHKOLD,ICHK) .and.
     +              IM2(ICHKNEW).EQ.IM1SAVE(ICHKOLD,ICHK) ) goto 2420
2430		 END DO
      	 GOTO 2410
2420		END DO
              if (dump) write(6,*) 
     +        'Reverse of this match is included in match ',ichk 
c-- Replace the old one if screw distance is smaller or
c center/axis distance is smaller
      	if (match.eq.MATSAVE(ICHK)) then
               go = screw(rot,tr)
               do i = 1, match
                 call arrgive(3,sxyz(1,im1(i)),xtp1(1,i))
                 call arrgive(3,sxyz(1,im2(i)),xtp2(1,i))
               end do
      	 call arrgive(match*3,xtp2,xtp1(1,match+1))
      	 call averg(3,2*match,xtp1,centr)
c -- if screwing is shorter get a new superimposition matrix
      	 if ( int(abs(go)).lt.int(abs(gosv(ichk))) ) then
      	  if(dump) 
     +		   write(6,*) 'go is smaller, this replace save set',ichk
                call fitca1(match,xtp2, xtp1, rot, tr, rms, smean)
      	  call savemt(ichk)
c		  write(6,*) 'rot,tr',rot,tr
c		 else if (int(abs(go)).eq.int(abs(gosv(ichk))).and.
c     +             dstplrotr(rot,tr,ori).lt.dst0sv(ichk) ) then
c -- if center is closer to origin get a new superimposition matrix
      	 else if (int(abs(go)).eq.int(abs(gosv(ichk))).and.
     +			vem(3,centr).lt.vem(3,csv(1,ichk))) then
      	  if(dump) 
     +		  write(6,*) 'center closer to O replace save set',ichk
                call fitca1(match,xtp2, xtp1, rot, tr, rms, smean)
                call savemt(ichk)
c		  write(6,*) 'rot,tr',rot,tr
      	 end if
      	end if
      	goto 5160
2410	       END DO
            end if
2400	      continue
c -- get a new superimposition matrix
            DO I = 1, MATCH
             CALL ARRGIVE(3,SXYZ(1,IM1(I)),XTP1(1,I))
             CALL ARRGIVE(3,SXYZ(1,IM2(I)),XTP2(1,I))
            END DO
            CALL FITCA1(MATCH,XTP2, XTP1, ROT, TR, RMS, SMEAN)
c-- check if this is an old match from matrix
            if (nmatch.gt.0) then
             DO ICHK = 1, NMATCH
c -- get A1*A2T = A1*A2-1
      	call antiarr(3,3,rotsv(1,1,ichk),buf1)
              call matmult(3,3,3,3,rot,buf1,aat)
              trace =aat(1,1)+aat(2,2)+aat(3,3)
c		write(6,*),' trace ', trace
      	if (trace .gt.3.) then
        	 if ( (trace-3.) .gt. 1e-4) 
     +            write(6,*) 'The trace of the matrix',
     +            trace,' more than 3. I set to 3 here.'
      	  if (dump) write(6,*) 'nmatch',nmatch
         	 trace = 3.
      	else if (trace .lt.-1.) then
                 if (( trace+1 ) .lt. -1e-4)
     +            write(6,*) 'The trace of the matrix',
     +            trace,' less than -1. I set to -1 here.'
         	 trace = -1.
      	  if (dump) write(6,*) 'nmatch',nmatch
      	end if
      	coskapa = (trace - 1.) / 2.
      	vkapa = acosd(coskapa)
      	if (vkapa.lt.angerr) then
c -- now the matrix rotate to the same orientation, check translation
      	 call matmult(3,3,3,1,aat,trsv(1,ichk),b1)
      	 call arrps(3,1,tr,b1,btr)
      	 if (vem(3,btr).lt.error) then
c - the translation turns out to be an old one too, now see
c   which one is to be saved
      	  if (dump) write(6,*) 'This matrix is same as',ichk
      	   if ( (match.gt.matsave(ichk)).or.
     +           (match.eq.matsave(ichk).and.
     +          LGG_RADII(MATCH,XTP1(1,1)).lt.RADSV(ICHK) ) ) then
      	   if (dump) write(6,*) 'Replace the old one'
      	   call savemt(ichk)
      	  end if
      	  goto 5160
      	 end if
      	end if
             END DO
            end if
c----     save this match
            nmatch = nmatch + 1
c- monitor every certain matches
            chkmatch = float(nmatch)/float(monitor)
            chk2 = float(int(chkmatch))
            if (chk2.eq.chkmatch) then
             write(6,'(2(a,i5,4x))') 
     +          'Solution:',nmatch,'Max match:',maxtop
               call ucputm(tm0)
             write(6,'(a,6i4,5x,a,f7.1,a)') 
     +		'i1,i2,i3,j1,j2,j3',i1,i2,i3,j1,j2,j3,
     +		'CPU time: ',tm0,' s'
            end if
            if (nmatch.le.maxncs) then
             minmatch = min(minmatch,match)
             if (minmatch.eq.match) minsave = nmatch
             call savemt(nmatch)
            else if (match.gt.matsave(minsave)) then
             IF(DUMP)
     +  write(6,*) 'Warning, NCS operation number is more than',MAXNCS
             if (dump) write(6,*) 'Save to the last slot',minsave
             call savemt(minsave)
c	       if (dump) write(6,*) 'save to ',minsave
c find a new minsave
             do i =1, maxncs
      	iorder(i) = i
             end do
c now re-order the matrix
             nmatch = maxncs
             do l1= 1, nmatch-1
       	do l2 = l1+1, nmatch
        	 if ( (matsave(iorder(l1)).lt.matsave(iorder(l2))).or.
     +	      ( matsave(iorder(l1)).eq.matsave(iorder(l2)).and.
     +	        rmssv(iorder(l1)).gt.rmssv(iorder(l2)) )
     + 	      ) then
      	    i = iorder(l1)
      	    iorder(l1) = iorder(l2)
      	    iorder(l2) = i
      	 end if
      	end do
             end do
c-----------------
             minsave = iorder(maxncs)
             if (dump) write(6,*) 'new minsave',minsave
            else
             nmatch = maxncs
             goto 5160
            end if
c-- show up
            if (dump.or.list) then
            call mtopolorz(rot,p1,p2)
c	      call screw(rot,tr,b2,go,b1)
            go = screw(rot,tr)
            write(6,'(80a)') ('-',i=1,70)
            write(6,*) 'MATCH #',NMATCH,' with matching pairs',match
            write(6,'(35i4)') (im1(j),j=1,match)
            write(6,'(35i4)') (im2(j),j=1,match)
            write(6,*) 'Real match pairs',match
            write(6,'(35i4)') (id(im1(j)),j=1,match)
            write(6,'(35i4)') (id(im2(j)),j=1,match)
            write(6,*) 'NCS matrix: '
            write(6,'(3f10.5)') rot,tr
            write(6,*) 'RMS of this NCS:',rms
            write(6,*)
     +      'Polar angles: psi1, phi1,kappa1 -- psi2,phi2,kappa2'
            write(6,'(2(8x,3f8.2))') p1,p2
            write(6,'(1x,a,f8.2,a)')
     +      'Screwing along the axis ',go,' Angstrom'
            write(6,*)
            end if
5160	     END DO
5150	    END DO
5140	   END DO
5130	  END DO
5120	 END DO
5110	END DO
c
      IF (NMATCH.GT.0) THEN
       do i =1, nmatch
        iorder(i) = i
       end do
       if (nmatch.eq.1) goto 3700
c now re-order the matrix
       do i1= 1, nmatch-1
        do i2 = i1+1, nmatch
         if ( (matsave(iorder(i1)).lt.matsave(iorder(i2))).or.
     +      ( matsave(iorder(i1)).eq.matsave(iorder(i2)).and.
     +        rmssv(iorder(i1)).gt.rmssv(iorder(i2)) )
     +       ) then
          i = iorder(i1)
          iorder(i1) = iorder(i2)
          iorder(i2) = i
         end if
        end do
       end do
c check the inclusion.
       do i1= 1, nmatch-1
        do i2 = i1+1, nmatch
         if (matsave(iorder(i2)).ge.3) then
          do ichknew = 1,matsave(iorder(i2))
           do ichkold = 1,matsave(iorder(i1))
            if ( id(im1save(ichknew,iorder(i2))).eq.
     +	   id(im1save(ichkold,iorder(i1))).   and.
     +	   id(im2save(ichknew,iorder(i2))).eq.
     +	   id(im2save(ichkold,iorder(i1))) )
     +   goto 3420
3430	     end do
           goto 3410
3420	    end do
          if (dump) write(6,*) 
     +    'Match ',iorder(i2),' is included in match ',iorder(i1)
          matsave(iorder(i2))=0
          nelim = nelim + 1
          goto 3720
3410	    continue
         end if
         if (matsave(iorder(i2)).ge.3) then
          do ichknew = 1,matsave(iorder(i2))
           do ichkold = 1,matsave(iorder(i1))
            if ( id(im1save(ichknew,iorder(i2))).eq.
     +	   id(im2save(ichkold,iorder(i1))).   and.
     +	   id(im2save(ichknew,iorder(i2))).eq.
     +	   id(im1save(ichkold,iorder(i1))) )
     +   goto 3620
3630	     end do
           goto 3610
3620	    end do
          if (dump) write(6,*) 
     +    'Match ',iorder(i2),' is included in match ',iorder(i1)
          matsave(iorder(i2))=0
          nelim = nelim + 1
          goto 3720
3610	    continue
         end if
3720	  end do
       end do
c now re-order the match again after elimination.
       do i1= 1, nmatch-1
        do i2 = i1+1, nmatch
         if ( (matsave(iorder(i1)).lt.matsave(iorder(i2))).or.
     +      ( matsave(iorder(i1)).eq.matsave(iorder(i2)).and.
     +        rmssv(iorder(i1)).gt.rmssv(iorder(i2)) )
     +       ) then
          i = iorder(i1)
          iorder(i1) = iorder(i2)
          iorder(i2) = i
         end if
        end do
       end do
c
3700	 nmreal = nmatch-nelim
       write(6,*)
       WRITE(6,'(A,I4,2A)') ' <<<Total ',nmreal,
     +  ' NCS operations have been found'
       if (dump) write(6,*) nelim,' matches have been eliminated from'
     + ,nmatch
       write(6,*) 'Maximum atom number',maxtop
       nmatch = nmreal
c
       ireal = 0
       nshow = min(nmatch,maxshow)
       if (cels.and.disp) then
        call ccpdpn(1,'ncs.ofm','UNKNOWN','F',0,0)
        call oframe(cell)
c -- also write a startup macro
        call ccpdpn(4,'oncs.mac','UNKNOWN','F',0,0)
        write(4,*) 'menu cen_id ; ; menu dist ; '
        write(4,*) 'read ncs.ofm '
        write(4,*) 'dr .cell '
        write(4,*) 'sa_at_in ncsall.pdb all mol all '
        write(4,*) 'pa_z all ; ; red zone ; zone ; zone ; end'
        nd = min(nshow,maxdisp)
        do i = 1, nd
         write(filname,'(1x,a,i3,a)') 'menu @ncs',i,'.mac ;'
         call spstrunct(filname(8:17))
         write(4,'(a)') filname(1:19)
        end do
        write(4,*) 'on '
        close (4)
       end if
c -- show up
       do il = 1, nshow
        i = iorder(il)
        if (matsave(iorder(il)).lt.3) then
         write(6,*) ' some thing wrong here'
         goto 7010
        end if
        call mtopolorz(rotsv(1,1,i),p1,p2)
c	  go = screw(rotsv(1,1,i),trsv(1,i))
        write(6,'(80a)') ('-',j=1,70)
        write(outname(4:7),'(i4)') il
        call SPSTRUNCT(outname)
        write(6,*) outname,' with matching pairs',matsave(i)
        write(6,'(35i3)') (id(im1save(j,i)),j=1,matsave(i))
        write(6,'(35i3)') (id(im2save(j,i)),j=1,matsave(i))
        if (disp.and.il.le.maxdisp) then
c-- write pdb files
         im1(1) = im1save(1,i)
         im2(1) = im2save(1,i)
         mch = 1
         do j2 = 2,matsave(i)
          do j1 = 1,mch
           if (im1(j1).eq.im2save(j2,i)) goto 7710
          end do
          mch = mch+1
          im1(mch) = im1save(j2,i)
          im2(mch) = im2save(j2,i)
7710	   end do
         if (dump) then
          write(6,*) 'independent real pairs',mch
          write(6,'(35i3)') (im1(j),j=1,mch)
          write(6,'(35i3)') (im2(j),j=1,mch)
         end if
         do j = 1, mch
          call arrgive(3,sxyz(1,im1(j)),xtp1(1,j))
          call arrgive(3,sxyz(1,im2(j)),xtp2(1,j))
         end do
         filname(1:7)=outname
         call down(filname(1:7),7)
         filname(8:11)='.pdb'
         call spstrunct(filname(1:11))
c	   write(6,*) 'output file to ',filname(1:11)
         call putpdbf(3,filname(1:11),mch,cell,xtp1,comp,im1,'A ',
     .        nsite,id)
         call putf2(3,mch,cell,xtp2,comp,im2,'B ',nsite,id)
c--  write oaxis
         call oaxisf(outname,rotsv(1,1,i),trsv(1,i),ds,csv(1,i))
c--  write matrix
         write(1,'(3a)') '.LSQ_RT_',outname,
     + '          R         12 (3f12.6)'
           write (1,'(3f12.6)') ((rotsv(k,j,i),k=1,3),j=1,3)
     + ,(trsv(k,i),k=1,3)
c-- write the omacro files
         filname2(1:7)=outname
         call down(filname2(1:7),7)
         filname2(8:11)='.mac'
         call spstrunct(filname2(1:11))
c	   call omacro(4,filename2,filname)
         call ccpdpn(4,filname2(1:11),'UNKNOWN','F',0,0)
         write(4,*) 'sa_at_in ',filname(1:11),' site'
         write(4,*) 'mol site  zone ; zone ; zone ; end'
         write(4,*) 'sa_at_in ',filname(1:11),' rot'
         write(4,*) 'lsq_mol ',outname,' rot ;'
         write(4,*) 'pa_zone rot ; magenta'
         write(4,*) 'mol rot  zone ; zone ; zone ; end'
         write(4,*) 'dr .',outname
         write(4,*) ' on'
         write(4,'(a,3f8.2)') ' cen_xyz',(csv(j,i),j=1,3)
         close (4)
        end if
        if (dump) then
         write(6,*) 'Real number for the matching atoms in set',i
         write(6,'(35i3)') (im1save(j,i),j=1,matsave(i))
         write(6,'(35i3)') (im2save(j,i),j=1,matsave(i))
        end if
        write(6,*) 'NCS matrix: '
        write(6,'(3f12.5)')
     +  ((rotsv(j,k,i),j=1,3),k=1,3),(trsv(j,i),j=1,3)
        write(6,7311) 
     + 'RMS:',rmssv(i),'Screw:',gosv(i),'Radius:',radsv(i)
7311	  format(a,f6.3,5x,a,f8.2,5x,a,f8.2)
        write(6,'(2(a,3f8.2,4x))') 'Polar angles:',p1,' & ',p2
        write(6,'(a,3f8.2)') 'Center:',(csv(j,i),j=1,3)
c	  write(6,*) 'RMS of this NCS:',rmssv(i)
c	  write(6,*)
c     +  'Polar angles: psi1, phi1,kappa1 -- psi2,phi2,kappa2'
c	  write(6,'(2(8x,3f8.2))') p1,p2
c	  write(6,'(1x,a,f8.2,a))')
c     +  'Screwing along the axis ',go,' Angstrom'
c	  write(6,*) 'Radius of this group',radsv(i)
        write(6,*)
7010	 end do
      else
       write(6,*) 'No NCS has been found'
      end if
c
        CALL CCPERR(0,'Normal termination')
      END
c
      subroutine savemt(nmatch)
      parameter (maxsites=2000,maxncs=5000)
      real rot(3,3),tr(3),ori(3)
      real rotsv(3,3,maxncs),trsv(3,maxncs)
      real rmssv(maxncs),radsv(maxncs)
      real gosv(maxncs)
      real csv(3,maxncs)
      real xtp1(3,maxsites),xtp2(3,maxsites)
      real b1(3),b2(3)
      INTEGER IM1(MAXSITES),IM2(MAXSITES)
      integer in1(maxsites),in2(maxsites)
      INTEGER IM1SAVE(MAXSITES,MAXNCS),IM2SAVE(MAXSITES,MAXNCS)
      INTEGER MATSAVE(MAXNCS)
c
      common/mat/ match,im1,im2
      common/matsv/ matsave,im1save,im2save
      common/rot/ rot,tr,rotsv,trsv
      common/rmsstaff/ rms,rmssv
      common/radstaff/ radsv
      common/gostaff/ gosv
      common/xtp/ ori,csv,xtp1,xtp2
c
c declare functions
      real lgg_radii
      external lgg_radii
c
      MATSAVE(NMATCH) = MATCH
      DO I = 1, MATCH
       IM1SAVE(I,NMATCH) = IM1(I)
       IM2SAVE(I,NMATCH) = IM2(I)
      END DO
      CALL ARRGIVE(9,ROT,ROTSV(1,1,NMATCH))
      CALL ARRGIVE(3,TR,TRSV(1,NMATCH))
      RMSSV(NMATCH)=RMS
      RADSV(NMATCH)=LGG_RADII(MATCH,XTP1(1,1))
      go = screw(rot,tr)
      gosv(nmatch)=go
c	write(6,*) 'go',go
c	write(6,*) 'ori',ori
c	dst0sv(nmatch) = dstplrotr(rot,tr,ori)
      call arrgive(3*match,xtp2,xtp1(1,match+1))
      call averg(3,match*2,xtp1,csv(1,nmatch))
      end
c
      subroutine 
     + fextend(maxsites,xyzlim,nsite,sfxyz0,nsiteall,sfxyz,id)
c put in a fractional 
      real xyzlim(3,2)
      real sfxyz(3,maxsites),sfxyz0(3,nsite)
      real b1(3),b2(3),b3(3)
      integer istart(3),iend(3)
      integer id(maxsites)
c extend the sfxyz0 coordinates to sfxyz according to xyzlim
      nsiteall = 0
      do i = 1, nsite
       call arrps(3,1,xyzlim(1,1),sfxyz0(1,i),b1)
       call arrps(3,1,xyzlim(1,2),sfxyz0(1,i),b2)
       do j =1, 3
        istart(j)= int(b1(j)+1e-4)
        iend(j)  = int(b2(j)-1e-4)
c	  if (istart.lt.iend) stop 'strange istart<iend'
       end do
       do ix = iend(1),istart(1),-1
        do iy = iend(2),istart(2),-1
         do iz = iend(3),istart(3),-1
          nsiteall = nsiteall + 1
          id(nsiteall) = i
          sfxyz(1,nsiteall) = sfxyz0(1,i) + float(ix)
          sfxyz(2,nsiteall) = sfxyz0(2,i) + float(iy)
          sfxyz(3,nsiteall) = sfxyz0(3,i) + float(iz)
c	    write(6,*) 'extend',(sfxyz(j1,nsiteall),j1=1,3),nsiteall
         end do
        end do
       end do
10	end do
      end
c
      SUBROUTINE FITCA1( NATM, XYZ1, XYZ2, A, T ,RMSOUT, SMOUT)
C This subroutine is used in package TOP which only to refine 
c superimposition of  CA in one helix others same with SUPRIMP
c Guoguang 91/12/12
c
      COMMON/RMS/ RMS,SMEAN,NREF,NREF1
      COMMON/SHIFS/ SCALR,SCALS
      COMMON/IAT/ IAT1,IAT2,IAT3,IAT
c	DATA SCALR/1./,SCALS/1./
C	DATA IAT/0/,IAT1/1/,IAT2/2/,IAT3/3/
      PARAMETER (NATM0 = 50000)
c   NATM0 is the largest number of atoms.
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3), T(3)
      DIMENSION X1(3,NATM0),X2(3,NATM0)
      real*4 VT(3*6*NATM0),DIS(3*NATM0)
      DIMENSION CEN1(3),CEN2(3)
      DIMENSION B1(3),B2(3),B3(3),T0(3)
c
c	DEG=180./3.14159265359
c
C Number of atom can not be more than NATM0 or less than 3.
c
c	print*, NATM,' atoms are refined'
      IF (NATM.GT.NATM0) THEN
      WRITE(6,*) 'ERROR> Atom is more than ',NATM0
      STOP 
      ELSE IF (NATM.LT.3) THEN
      STOP 'ERROR> Atom is less than 3.'
      END IF

c Compute the initial matrix.
c	print*, 'xyz1'
c	write(6,'(3f10.4)') ((xyz1(i,j),i=1,3),j=1,natm)
c	print*, 'xyz2'
c	write(6,'(3f10.4)') ((xyz2(i,j),i=1,3),j=1,natm)
      CALL ORIEN(NATM,XYZ1,XYZ2,A)
c	print*,'NATM,a,t',natm,a,t
c	NREF1 = NREF
C
C Refine the orientation by vector method.
C
      CALL REFORN ( NATM, XYZ1, XYZ2, A, VT, DIS)
c	print*,'NATM',natm,a,t
C
C compute the  gravity of mol1 and mol2 to CEN1 and CEN2
      CALL AVERG(3,NATM,XYZ1,CEN1)
      CALL AVERG(3,NATM,XYZ2,CEN2)
C T is the initial translation vector
      CALL ARRPS(3,1,CEN2,CEN1,T0)
c Change the origin to CEN1.
      CALL TMOVE(3,NATM,XYZ1,CEN1,-1.,X1)
      CALL TMOVE(3,NATM,XYZ2,CEN1,-1.,X2)
c
C Refine th1, th2, th3, tx, ty and tz
c
      CALL REFRT( NATM, X1, X2, A, T0, VT, DIS)
c
c	WRITE(6,*)
c	WRITE(6,*) 'R.M.S.'
c	WRITE(6,*) '       natm'
c	WRITE(6,*) 'SQRT( SIGMA (Distance(i)^2)/natm ) = ',RMS
c	WRITE(6,*) '       i=1'
C
c	WRITE(6,*)
c	WRITE(6,*) 'Mean Distance:'
c	WRITE(6,*) ' natm'
c	WRITE(6,*) 'SIGMA (Distance(i)) /natm = ',SMEAN
c	WRITE(6,*) ' i=1'
      RMSOUT = RMS
      SMOUT = SMEAN
C
c	WRITE(6,*)
c	WRITE(6,*) 'Mol1 is superposed to Mol2.'
c	WRITE(6,*) 'The matrix and the vector are:'
c	WRITE(6,*) 
c	WRITE(6,1) (A(1,J),J=1,3),CEN1(1),T0(1)
c	WRITE(6,2) (A(2,J),J=1,3),CEN1(2),T0(2)
c	WRITE(6,1) (A(3,J),J=1,3),CEN1(3),T0(3)
c1	FORMAT(1X,'      (',3F10.6,' )   (     ',f10.5,' )   ('
c     + ,f10.5,' )')
c2	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 -',f10.5,' ) + ('
c     + ,f10.5,' )')
c
      CALL MATMULT(3,3,3,1,A,CEN1,B3)
      CALL ARRPS(3,1,T0,B3,B3)
      CALL ARRAD(3,1,CEN1,B3,T)
cC
c	WRITE(6,*) 
c	WRITE(6,*) 
c	WRITE(6,4) (A(1,J),J=1,3),T(1)
c	WRITE(6,5) (A(2,J),J=1,3),T(2)
c	WRITE(6,4) (A(3,J),J=1,3),T(3)
c4	FORMAT(1X,'      (',3F10.6,' )   (    )   (',f10.5,' )')
c5	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 ) + (',f10.5,' )')
C
      END 

      subroutine oframe(cell)
c
c A program to generate a frame for O
c
      real x(3,8),b1(3),b2(3),b3(3)
      real vec(3,3),trns(3,3),cnew(6)
      real cell(6),deor(3,3), orth(3,3)
      real cells(6),deors(3,3), orths(3,3)
      real x0(3,8), scale(3,8)
      real buf(3,3)
      character*2 out
c...  data statements.  separate declaration and init required for f2c
      data x0 /0.,0.,0.,1.,0.,0.,0.,1.,0.,1.,1.,0.,
     +               0.,0.,1.,1.,0.,1.,0.,1.,1.,1.,1.,1/
      data scale / 1.,1.,1.,  1.,1.,-1.,  1.,-1.,1., 1.,-1.,-1.,
     +                  -1.,1.,1., -1.,1.,-1., -1.,-1.,1.,-1.,-1.,-1./
c
      write(6,*) 'generating unit cell frame for O...'
c	write(6,*) 'cell dimension'
c5	read(5,*) cell
c	write(6,*) 'scale'
c	read(5,*,end=25) scale
c25	continue
      call lgg_crystal(cell,cells,deor,orth,deors,orths)
c	write(6,*) 'Orthogonalization matrix'
c	write(6,10) ((orth(i,j),j=1,3),i=1,3)
10	format(1x,3f10.4)
c
c	call matmult(3,3,3,8,orth,x0,x1)
c	 write(6,'(3f6.1)') x1
c
20	format(a1,3f11.5)
21	format(a4,3f11.5,1x,a)
      WRITE(1,30) 156,40
30	FORMAT('.cell',T26,'t',I8,I3)
      WRITE(1,'(A)') 'begin cell'
      WRITE(1,'(A)') 'colour    255'
      do is = 1, 8
       call arrmc(3,1,orth(1,1),scale(1,is),buf(1,1))
       call arrmc(3,1,orth(1,2),scale(2,is),buf(1,2))
       call arrmc(3,1,orth(1,3),scale(3,is),buf(1,3))
       call matmult(3,3,3,8,buf,x0,x)
       write(1,20) 'M',(x(i,1),i=1,3)
       write(1,20) 'L',(x(i,2),i=1,3)
       write(1,20) 'L',(x(i,4),i=1,3)
       write(1,20) 'L',(x(i,3),i=1,3)
       write(1,20) 'L',(x(i,1),i=1,3)
       write(1,20) 'L',(x(i,5),i=1,3)
       write(1,20) 'L',(x(i,6),i=1,3)
       write(1,20) 'L',(x(i,8),i=1,3)
       write(1,20) 'L',(x(i,7),i=1,3)
       write(1,20) 'L',(x(i,5),i=1,3)
       write(1,20) 'M',(x(i,2),i=1,3)
       write(1,20) 'L',(x(i,6),i=1,3)
       write(1,20) 'M',(x(i,3),i=1,3)
       write(1,20) 'L',(x(i,7),i=1,3)
       write(1,20) 'M',(x(i,4),i=1,3)
       write(1,20) 'L',(x(i,8),i=1,3)
       write(out,'(I2)') int(scale(1,is))
       out(2:2) = 'X'
       write(1,21) 'TEXT',(x(i,2),i=1,3),out
       write(out,'(I2)') int(scale(2,is))
       out(2:2) = 'Y'
       write(1,21) 'TEXT',(x(i,3),i=1,3),out
       write(out,'(I2)') int(scale(3,is))
       out(2:2) = 'Z'
       write(1,21) 'TEXT',(x(i,5),i=1,3),out
      end do
      write(1,21) 'TEXT',(x(i,1),i=1,3),' O'
      write(1,'(a)') 'end_object'
c
      end
c
      subroutine oaxisf(obj,rot,tr,ds,cen)
c a program to transfer an axis direction and position into O file
c The input of this axis could be obtained from fit or pdbsupos program
c Guoguang 95/02/02 Purdue
c 970925 modified for findncs
      real pol(3),xyz(3),v(3),umove(3),xyz0(3)
      real b1(3),b2(3),b3(3),rot(3,3),tr(3)
      real o1(3),o2(3),ax1(3),ax2(3),cen(3)
      character*7 obj
      external cosd, sind
c	write(6,*) 'obj',obj
c	write(6,*) 'rot',rot
c	write(6,*) 'tr',tr
      il = 7
      cmove = 0.
c	write(6,*) 'ds',ds
      call seekaxis2(rot,tr,cen,pol,go,xyz0)
c	write(6,*) 'pol',pol
      v(1) = cosd(pol(2))*sind(pol(1))
      v(2) = sind(pol(2))*sind(pol(1))
      v(3) = cosd(pol(1))
c
c first plot axis
      call arrmc(3,1,v,cmove,umove)
      call arrad(3,1,xyz0,umove,xyz)
      call arrmc(3,1,v,ds,b1)
      call arrad(3,1,b1,xyz,o1)
      call arrps(3,1,xyz,b1,o2)
c
        WRITE(1,30) obj(1:il),6,50
        WRITE(1,'(2A)') 'begin ',obj(1:il)
        WRITE(1,'(A)') 'colour    62500'
30      FORMAT('.',a,T26,'t',I8,I3)
c
      write(1,20) 'M',o1
      write(1,20) 'L',o2
      write(1,21) 'TEXT',xyz0,obj
      write(1,'(a)') 'end_object'

20	format(a1,3f10.3)
21	format(a4,3f11.5,1x,a)
      end
c
      subroutine seekaxis2(a,t,cen1,POL,go,xyz0)
c	dimension a(3,3),t(3),POL(3),xyz0(3)
C this is a routine to calculate how much the movement is along the
c the rotation axis and where is the rotation axis from a rigid movement
c matrix.
c When there is an non-crystallographic rotation and translation
c x2 = A*x1 + t
c where A(3,3) is the 3*3 matrix
c 	t(3) is translation vector.
c cen(3), center of the two mass molecule
c the routine outputs POL(3) (psi, pai and kapa), go and xyz0(3)
c where psi (POL(1))  is the angle between the rotation axis and y axis
c	pia is the angle between X axi and the image of the rotation axis
c	kapa is the rotating angle.
c 	go is the screw amount along the axis direction
c		Guoguang 900927
c	xyz0(3) is one point where the axes pass by. This point should be 
c        a project point of CEN on the axis line, where CEN is center of
c	two input molecules (CEN1+CEN2)/2.
c

      dimension a(3,3),t(3),POL(3),xyz0(3),cen(3),cen1(3),cen2(3)
      dimension b1(3),b2(3),b3(3),cen2a(3)
      dimension rot(3,3), rot1(3,3)
      dimension b4(3),b5(3),cenp1(3),cenp2(3),xyzp(3)
      dimension vec(3)
      logical*1 zax
      external tand
      call arrmc(3,1,t,0.,xyz0)
      call mtopolorz(a,POL,b1)
c	write(6,*) 'rot',a
c	write(6,*) 'pol',pol
      if (abs(POL(3)).lt.1e-6) then
       go = vem(3,t)
      end if
c
      if (vem(3,t).lt.(1.e-6)) then
       go = 0.
       return
      end if
c	call arrad(3,1,cen1,cen2,b4)
c	call arrmc(3,1,b4,0.5,cen)
c
c	b1(2) = cosd(POL(1))	
c	b1(1) = sind(POL(1))*cosd(POL(2))	
c	b1(3) = - sind(POL(1))*sind(POL(2))
      call mtovec(a,vec,vkapa)
      call arrgive(3,vec,b3)
c b1 and vec is the direction of the axis vector.
      go = poimult(3,3,t,b3)
c	write(6,*) 'go',go
c 
      call rtmov(1,cen1,a,t,cen2)
      call arrmc(3,1,vec,go,b2)
      call arrps(3,1,cen2,b2,b4)
      call arrad(3,1,cen1,b4,cen2a)
      call arrmc(3,1,cen2a,0.5,cen)
c -- test if cen1 and cen2 is located on axis
      if (dist(cen,cen1).lt.1.e-3) then
       call arrgive(3,cen,xyz0)
       return
      end if
c
c now define a new coordinate system 
c X0 = rot * X'
c where Z' is the rotating axis.
c and X'is in the Z'/cen2-cen1 plane 
c Y' is perpendicular to X' and Z'
c so b1 is Z' vector.
      call arrps(3,1,cen2,cen1,b4)
      call veccrsmlt(b3,b4,b5)
      temp = vem(3,b5)
      if (temp.gt.(1.e-6)) then
       zax = .false.
 	 call arrmc(3,1,b5,1./temp,b2)
c here b2 is X' vector
       call veccrsmlt(b2,b3,b1)
c b3 is Y' vector
c
       call arrgive(3,b2,rot(1,2))
       call arrgive(3,b3,rot(1,3))
       call arrgive(3,b1,rot(1,1))
      else
       call elize(3,rot)
       zax = .true.
      end if
c
      call antiarr(3,3,rot,rot1)
c rot1 = rot**-1
c
c b1 is the translation in new coordinate system
11	call matmult(3,3,3,1,rot1,t,b1)
      if (abs(b1(3)-go).gt.7e-3) then
       if (zax) then
        rot(3,3) = -1.
        rot(2,2) = -1.
        rot1(3,3) = -1.
        rot1(2,2) = -1.
        zax = .false.
        goto 11
       else
        write(6,*) 'go ', go
        write(6,*) 't ',t
        write(6,*) 'b1 ',b1
        write(6,*) 'rot1'
        write(6,'(3f12.5)') rot1
        stop 'guoguang, you are wrong to get go'
       end if
      end if
c
c take cen as origin. take cen1 cen2 into new coordinates as cenp1,cenp2
      call arrps(3,1,cen1,cen,b1)
      call matmult(3,3,3,1,rot1,b1,cenp1)
      call arrps(3,1,cen2,cen,b2)
      call matmult(3,3,3,1,rot1,b2,cenp2)
c
      if (cenp1(2).gt.1.e-4) print *, 'Warning cenp1',cenp1
      if (cenp2(2).gt.1.e-4) print *, 'Warning cenp2',cenp2
c the passing point in new system
      xyzp(1) = 0.
      xyzp(3) = 0.
      if (abs(180.-vkapa).lt.0.001) then
       xyzp(2) = 0.
      else
       xyzp(2) = -cenp1(1)/tand(vkapa/2.)
      end if
c the passing point in old system
      call matmult(3,3,3,1,rot,xyzp,b4)
      call arrad(3,1,b4,cen,xyz0)
c
      end
c
      subroutine putpdbf(iunit,filename,nsite,cell,sxyz,comp,id1,ch,
     .     idim,id)
      common/lat/ latnam
      real cell(6),deor(3,3),orth(3,3)
      real cells(6),deors(3,3),orths(3,3)
      real sxyz(3,nsite)
      real elz(3,3)
      save atomname
      integer id(idim),id1(nsite)
      character*(*) filename
      character ch*2,latnam*14
      character*4,comp(idim),atomname,resname
c...  data statements.  separate declaration and init required for f2c
      data elz /1.,0.,0.,0.,1.,0.,0.,0.,1./
c
c	 write(6,*) 'All the symmetry-related sites are written to ',filename
       call ccpdpn(iunit,filename,'UNKNOWN','F',0,0)
       call lgg_crystal(cell,cells,deor,orth,deors,orths)
c	 write(6,'(6f10.5)') cell
c	 write(6,'(3f10.5)') deor
       write(iunit,'(a)')
     +    'REMARK ALL THE CRYSTALLOGRAPHIC EQUIVALENT SITES',
     +    'REMARK  residue NAME is same from input file',
     +    'REMARK  residue ID is from the order of input site',
     +    'REMARK  atom name is give as O1 for O to display'
       write(iunit,'(a,3f9.3,3f7.2,1x,a)') 'CRYST1',cell,latnam
       write(iunit,'(a,3f10.6,5x,f10.5)') 'ORIGX1    ',
     +      (elz(j,1),j=1,3),0.
       write(iunit,'(a,3f10.6,5x,f10.5)') 'ORIGX2    ',
     +      (elz(j,2),j=1,3),0.
       write(iunit,'(a,3f10.6,5x,f10.5)') 'ORIGX3    ',
     +      (elz(j,3),j=1,3),0.
       write(iunit,'(a,3f10.6,5x,f10.5)') 'SCALE1    ',
     +      (orths(j,1),j=1,3),0.
       write(iunit,'(a,3f10.6,5x,f10.5)') 'SCALE2    ',
     +      (orths(j,2),j=1,3),0.
       write(iunit,'(a,3f10.6,5x,f10.5)') 'SCALE3    ',
     +      (orths(j,3),j=1,3),0.
       atomname='C   '
       do i = 1,nsite
        write(atomname(2:4),'(i3)') id1(i)
        call spstrunct(atomname)
        resname=comp(id(id1(i)))
        write(iunit,'(a6,i5,2x,a4,a4,a2,i3,4x,3f8.3,2f6.2)')
     +    'HETATM',I,ATOMNAME,RESNAME,CH,ID(ID1(I)),
     +    (sxyz(j,i),j=1,3),1.,20.
       end do
       if (ch.eq.'  ') close (iunit)
       return
      entry putf2(iunit,nsite,cell,sxyz,comp,id1,ch,idim,id)
       do i = 1,nsite
        write(atomname(2:4),'(i3)') id1(i)
        call spstrunct(atomname)
        resname=comp(id(id1(i)))
c	   write(6,*) 'i,id1(i),id(id1(i)))',i,id1(i),id(id1(i))
        write(iunit,'(a6,i5,2x,a4,a4,a2,i3,4x,3f8.3,2f6.2)')
     +    'HETATM',I,ATOMNAME,RESNAME,CH,ID(ID1(I)),
     +    (sxyz(j,i),j=1,3),1.,20.
       end do
       close (iunit)
      end
c
      subroutine latconv(latnam,conv,cinv,convt,cinvt)
      character*1 latnam
      real conv_p(3,3),conv_c(3,3),conv_i(3,3),conv_f(3,3),conv_r(3,3)
      real conv(3,3),cinv(3,3),convt(3,3),cinvt(3,3)
      real b1(3),b2(3)
      integer me(3)
c...  data statements.  separate declaration and init required for f2c
      data conv_p /1.,0.,0., 0.,1.,0., 0.,0.,1./
      data conv_c /0.5,-0.5,0., 0.5,0.5,0., 0.,0.,1./
      data conv_i /0.5,-0.5,0., 0.5,0.5,-1., 0.5,0.5,0./
      data conv_f /0.5,-0.5,0., 0.5,0.5,0.5, 0.,0.,0.5/
      data conv_r /0.666667, -0.333333, -0.333333,
     +			 0.333333,  0.333333, -0.666667,
     +			 0.333333,  0.333333, -0.333333/
c
C	write(6,*) 'Lattice name: ',latnam
      if (latnam.eq.'P') then
       call arrgive(9,conv_p,conv)
      else if (latnam.eq.'C') then
       call arrgive(9,conv_c,conv)
      else if (latnam.eq.'I') then
       call arrgive(9,conv_i,conv)
      else if (latnam.eq.'F') then
       call arrgive(9,conv_f,conv)
      else if (latnam.eq.'R') then
       call arrgive(9,conv_r,conv)
      else 
       write(6,*)  'Error: I do not know what this lattice is: ',latnam
       call arrgive(9,conv_p,conv)
       call arrgive(9,conv_p,convt)
       call arrgive(9,conv_p,cinv)
       call arrgive(9,conv_p,cinvt)
       return
      end if
      call arrgive(9,conv(1,1),cinv(1,1))
c	write(6,*) 'conv',conv
      call ivsn(3,cinv,b1,b2,me,de,1.e-4)
c	write(6,*) 'cinv',cinv
      call antiarr(3,3,conv,convt)
c	write(6,*) 'convt',convt
      call antiarr(3,3,cinv,cinvt)
c	write(6,*) 'cinvt',cinvt
      end
c
      subroutine explain
c
      	write(6,'(a)')
     + ' The program uses following convention for orthogonal system',
     + '                             X is in A direction',
     + '                             Y is in AB plane' ,
     + '                             Z is perpendicular to AB plane' 
      write(6,'(a)') ' '
      write(6,'(a)')
     + ' Each NCS operation can be described as that an object',
     + ' rotate kappa degrees about a certain axis, then move a',
     + '  screwing distance along the direction of this axis'
      write(6,'(a)') ' ',
     + ' In the following for each possible NCS, the program provides:'
      write(6,'(2a)')
     + ' Matching pairs:',
     + ' number of matching pairs by the possible NCS solutions',
     + '                  is ranked by this number'
      write(6,'(2a)')
     + ' Matching members:',
     + ' the ID number of each site (from input order before',
     + '                   crystallographic operation)'
      	write(6,'(a)')
     + ' RMS:  root mean square deviation of the superimposed sites',
     + ' Screw: the screwing distance',
     + ' Radius: average distance between center and all joining sites',
     + ' Polar angles:  they describe the NCS axis as follows',
     + '  psi is the angle between Z and NCS axis',
     + '  phi is the angle between X and image of NCS axis XY plane',
     + '  kappa is the rotation angle. 180=2fold, 90=4-fold ... so on'
      	write(6,'(a)')
     + '  the polar angle definition is same as in the POLARRFN program'
      	write(6,'(a)')
     + ' Center: center position of all the joining sites, this',
     + '        can help to find out if two axes intersect each other' 
      write(6,'(a)') (' ',i=1,2)
      end

