C
C     FREERFLAG
C     Copyright (C) 1993 Eleanor Dodson
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
c     
c     Free R generator.
c     
c     Pick selected reflection types
c     
c     Input:
c     HKLIN    reflection file
c     
c     Output:
c     HKLOUT  
c     
c      implicit none
C     ..
C     .. Parameters ..
      integer MCOLS
      parameter(MCOLS=500)
      integer nrand, nparm,ndiv
      parameter (nrand=1000, nparm=30,ndiv=200)
C     ..
C     .. Local Scalars ..
      integer mtzin,mtzout,ntok,nsmp,nspgrnx,numsymm,nunity,nzero
      integer iprint,ifail,idiv,irand,nabs,ncols,nrefls,ncount,irfrac,
     +       irfrac1,irflag,isysabs,ISEED,ISEED2
      real eps,rfrac,s
      logical eof,LEND,OLDFREE,COMPLETE,LSEED,rflgswap
      character versnx*10, lsprgo (1)*30, ctprgo (1)*1,
     +     KEY*4, LINE*600, FRCSTR*5, ltype*1, spgrnx*10, pgname*10
C     ..
C     .. Local Arrays ..
      integer ih(3),ncntfr(ndiv),lookup(4),ncntfr1(ndiv)
      INTEGER IBEG(NPARM), IEND(NPARM), ITYPE(NPARM), IDEC(NPARM)
      real data(MCOLS), rngmtz(2,MCOLS), rvec(nrand),FVALUE(NPARM)
      real rsym(4,4,192)
      logical logmss(MCOLS)
      character cvalue(nparm)*4,CTPRGI(4)*1,LSPRGI(4)*30
C     ..
C     .. External Routines ..
      external ccperr, ccpfyp, ccprcs, ccpupc, epslon, epsln, gtprea, 
     +         lkyin, lrassn, lropen, lrinfo, lrrefl, lrrefm, lrrewd, 
     +         lrsymi, lrsymm, lwopen, lwclab, lwclos, lwrefl, 
     +         lwhstl, mtzini, parser, ranmar
C     ..
C     .. Intrinsic Functions ..
      intrinsic nint
c     
      call ccpfyp
      call ccprcs (6, 'FREERFLAG', '$Date: 2005/09/06 11:25:13 $')
      call mtzini

      LSPRGI(1) = 'H'
      LSPRGI(2) = 'K'
      LSPRGI(3) = 'L'
      LSPRGI(4) = 'FREE'
C
      CTPRGI(1) = 'H'
      CTPRGI(2) = 'H'
      CTPRGI(3) = 'H'
      CTPRGI(4) = 'I'
C
      LOOKUP(1) = -1
      LOOKUP(2) = -1
      LOOKUP(3) = -1
      LOOKUP(4) =  0

      lsprgo (1) = 'FreeR_flag'
      ctprgo (1) = 'I'

      rfrac = 0.05
      ncount = 0
      nabs = 0
      numsymm = 192
      NLPRGI = 0
      COMPLETE=.false.
      rflgswap = .false.
      oldfree=.false.
      lseed=.false.
      do 10 idiv = 1,ndiv
      ncntfr1(idiv) = 0
10    ncntfr(idiv) = 0

 1    continue
      line = ' '
      NTOK = nparm
      CALL PARSER(KEY, LINE, IBEG, IEND, ITYPE, FVALUE, CVALUE, IDEC,
     +     NTOK, LEND, .TRUE.)
      call ccpupc(key)
      if (lend) go to 2
        if (key.eq.'FREE') then
          call gtprea (2, rfrac, ntok, itype, fvalue)
          if (rfrac.lt.1.0 .and. rfrac.gt.0.0) goto 1
          call ccperr (1, 'Must have 0.0<fraction<1.0')
        else if (key.eq.'COMP') then
          COMPLETE=.true.
          NLPRGI = 4
C
C       ============================================
        IF(ntok.ge.2)CALL LKYIN (1,LSPRGI,NLPRGI,NTOK,LINE,IBEG,IEND)
C       ============================================
C
        else if (key.eq.'OLDF') then
          oldfree=.true.
        else if (key.eq.'SEED') then
          lseed=.true.
        else if (key.eq.'END') then
          go to 2
        else
          call ccperr (1, 'Unrecognised keyword')
        endif
       go to 1
C
C  End of input cards
C
2     continue

C
C  OLDFREE now obsolete
C
      IF (OLDFREE)
     +  CALL CCPERR(2, 'OLDFREE keyword obsolete: see documentation')

C  If keyword SEED specified, seed random number generator based on
C  current time.
      IF (LSEED) THEN
        CALL USTIME(ISEED)
        ISEED2 = ISEED + 100
        ISEED = MOD(ISEED,31329)
        ISEED2 = MOD(ISEED2,30082)
        CALL RMARIN(ISEED,ISEED2)
      ENDIF

C     initial vector of randoms (length NRAND)
C
      call ranmar (rvec, nrand)

      mtzin  = 1
      mtzout = mtzin
      iprint = 1
      ifail  = 0
      call lropen(mtzin,  'HKLIN', iprint, ifail)
      if (ifail .eq. 0) then
        call lrinfo(mtzin,versnx,ncols,nrefls,rngmtz)
      else
        call ccperr (1, 'Error reading HKLIN')
      endif
C
C  Setup bits for checking systematic absences
C
      call lrsymi(mtzin,nsmp,ltype,nspgrnx,spgrnx,pgname)
      call lrsymm(mtzin,numsymm,rsym)
      call epsln(numsymm,nsmp,rsym,iprint)
C
C     ==============================================
      CALL LRASSN(mtzin,LSPRGI,NLPRGI,LOOKUP,CTPRGI)
C     ==============================================
C
C  If COMPLETE is specified then get fraction of data per bin
C
      if (COMPLETE) then
        if (lookup(4).ne.0.and.rngmtz(2,lookup(4)) .gt. 1.0) then
          rfrac = 1.0/(rngmtz(2,lookup(4))+1.0)
          oldfree = .false.
        else
C
C  If have old sytle freeR flag then need to get fraction from data
C
          nzero = 0
          nunity = 0
          oldfree = .true.
  20      call lrrefl(mtzin, s, data, eof)
          if (eof) goto 30
          call lrrefm(mtzin, logmss)
          if (lookup(4).ne.0) then
            if (.not.logmss(lookup(4))) then
              if (nint(data(lookup(4))) .eq. 1) then
                nunity = nunity + 1
              else
                nzero = nzero + 1
              endif
            endif
          endif
          goto 20

  30      call lrrewd(mtzin)
C    Check whether test set labelled 0 or 1
          if ( nzero .lt. nunity) then
            rflgswap = .false.
            rfrac = real(nzero)/(nzero+nunity)
          endif
          if ( nzero .gt. nunity) then
            rflgswap = .true.
            rfrac = real(nunity)/(nzero+nunity)
          endif
        end if 
        if (rfrac .lt. 0.00001) then
          write(6,'(/,A,A,A,F10.6,/,A,/)') ' COMPLETE option: ',
     +        ' the calculated fraction of free reflections',
     +        ' in the specified FREE column is ',rfrac,
     +        ' This is too small - check input file.'
          call ccperr(1,'No free reflections in FREE column.')
        endif
      endif
C       write(6,*) ' oldfree,rflgswap,nzero ,nunity,rfrac',
C     +              oldfree,rflgswap,nzero ,nunity,rfrac
C
C  Set up fraction of refls. per bin
C
      irfrac = nint(1.0/rfrac)
      irfrac1 = irfrac -1
      if(.not.oldfree)
     +  write(6,'(a,i3,a,/,a,i3,a)')
     +  '*****   All Reflections binned into ',irfrac,' segments',
     +  ' *** labelled 0 through to ',irfrac1,' ***** '
      if(oldfree)
     +  write(6,'(2a,/,2a,/,a,i3,a)')'***** All Input Reflections ',
     +    ' expected to be binned into two segments *****',
     +  ' *** labelled 0 or -1 for one segment( test set), ',
     +  'and 1 for all the others (work set) ***',
     +  ' *** The work set will be renumbered 1 through ',irfrac1,' ** '

      call lwopen(mtzout, 'HKLOUT')
C
C  Only add a FREE Column if COMPLETE is FALSE
C
      if(.NOT.COMPLETE)call lwclab(mtzout, lsprgo,1,ctprgo,1)
      write (frcstr, '(F5.3)') rfrac
      call lwhstl (mtzout, 'with fraction '// frcstr)
C     
C  Count of randoms used from supplied vector:
C
      irand = 0
 100  call lrrefl(mtzin, s, data, eof)
      if (eof) then
        call lwclos(mtzout, iprint)
        write(6,'(a,i7,/,a,/,a)')' Number of reflections: ',ncount,
     +       ' Number for flagged reflection for each bin: ',
     +       ' Reflection flag =:      Number:'
C
        do 110 idiv = 1,ndiv
        if(ncntfr(idiv) .gt.0) 
     +  write(6,'(18x,I4,10x,2I8)')idiv-1,ncntfr(idiv),ncntfr1(idiv)
  110   continue
        if (nabs .gt. 0) then
          write(6,fmt='(//,a,a,i7)') ' The no. of systematic absences',
     +    ' is ',nabs
          write(6,fmt='(/,a,/,a,/)')
     +    ' Systematically absent reflections have been assigned',
     +    ' FreeR_flags and written to the output file'
        endif
        call ccperr(0, 'Normal termination')
      endif
      call lrrefm(mtzin, logmss)
C
C  number of reflections
C
      ncount = ncount + 1
C
C  For systematically absent reflections write a warning
C  but keep it and assign a FreeR_flag
C
      ih(1) = nint(data(1))
      ih(2) = nint(data(2))
      ih(3) = nint(data(3))
      call epslon(ih,eps,isysabs)
      if (isysabs .eq. 1) then
        write(6,fmt=9010) ih(1),ih(2),ih(3)
 9010   format (3i5,'   is systematically absent')
        nabs = nabs + 1
      endif
C
        if (irand.ge.nrand) then
C
C  exhausted the vector -- need another
C
          call ranmar (rvec, nrand)
          irand = 1
        else
          irand = irand+1
        endif
C
C  since 0 < rvec[i] < 1.0, this gets us the relevant fraction:
C
        irflag = int(irfrac*rvec(irand))
        if(irflag.lt.0) irflag = 0
        if(irflag.ge.irfrac) irflag = irfrac -1
C
C
        if(.NOT.COMPLETE) data(ncols+1) = irflag
C
C  if you need to preserve existing FreeR flags only assign new ones 
C  if there is nothing set.
C
        if (lookup(4).ne.0) then
          if(COMPLETE .and. logmss(lookup(4)))
     +      data(lookup(4)) = irflag
C
C  Check to see if this is Old style where  FreeR_flag either 0 or 1
C  If  FreeR_flag = 1 then redistribute it as 1 to irfrac -1
C
          if(oldfree .and. COMPLETE .and. .not. logmss(lookup(4)) ) then
C  Q0) Is this a SHELX flag with TEST set 1 or -1?
C      Set all -1 to 0
            if ( data(lookup(4))  .lt. -0.5 ) data(lookup(4)) = 0
C  Q1) Is the TEST set 1 or 0; if test = 1, rflgswap = true
            if(rflgswap)then
              irflagc = 1
              if ( data(lookup(4))  .gt. 0.5 ) irflagc = 0
              data(lookup(4)) = irflagc
            end if
C  Q2) work out out to replace all WORK set flags  with random numbers 
C      ranging 1 to irfrac-1
            irflag = 0
c        if(COMPLETE )     write(6,'(a,3i4,f7.3,i4,f5.1)')
c     +   ' rvec4',ih,rvec(irand),irflag,data(lookup(4))
C
            if( data(lookup(4)) .gt. 0.5 ) then
              irflag = int((irfrac-1) *rvec(irand)) 
C            write(6,'(a,3i4,f7.3,i4)')' rvec2',ih,rvec(irand),irflag
              if(irflag.lt.0) irflag = 0
              if((irflag-1).ge.irfrac-1) irflag = irfrac -2
              irflag = irflag+1
              ncntfr1(irflag+1) = ncntfr1(irflag+1) + 1
              data(lookup(4)) = irflag
            end if
          end if
        end if
C
        ncntfr(irflag+1) = ncntfr(irflag+1) + 1
C
      call lwrefl(mtzout, data)
      go to 100
      end
