#!/usr/bin/env tclsh

set input_pdb   [lindex $argv 0]
set output_pdb  [lindex $argv 1]
set input_atom  [lindex $argv 2]

set input [open $input_pdb r]
set indata [split [read $input] "\n"]
set output [open $output_pdb w]

foreach line  $indata {
    if { [regexp {HETATM.*} $line junk] || [regexp {ATOM.*} $line junk] } {
	scan $line "%6s%5d%*c%2s%*c%*c%*c%*c%3s%*c%*c%*c%*c%*c%*c%*c%*c%*c%*c%*c%8f%8f%8f%6f%6f" label number atom residue x y z occ b 
	if { $atom == $input_atom } {
	    puts $output [format "HETATM %4d %2s    %2s   %3d    %8.3f%8.3f%8.3f%6.2f%6.2f" $number $atom $atom $number $x $y $z $occ $b]
	}
    } 
}
    
close $input
close $output

