C
C     ICOEFL
C     Copyright (C) 1992 Phil Evans
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C*************************************************************
C
C
C**************************************************************
C - ICOEFL - COEFS. FOR JACK-LEVITT REFINEMENT ON DEL(I) or DEL(F)
C     By Judd Fermi, LMB
C - VERSION USING DOUBLE PRECISION LEASQD
C with k,B refinement of several Fcal's
C
C added 5-6-92: subkeyword FPART to keyword OUTPUT: o/p also scaled partial Fc's
C               keyword SFALL: o/p FO is UNSCALED, and 
C                       B's applied toFc's are rel. to FC(KEEP), whose B=0
C
      PROGRAM ICOEFL
C     ==============
C      IMPLICIT NONE
C
C
C 1-11-88: NXPLCT etc, set to 4
      INTEGER NXPLCT1, NLPRGI, MCOLS
      PARAMETER(NXPLCT1=4) 
C! must match value in RDCOMD
      PARAMETER(NLPRGI=2*NXPLCT1+2)
C to hold scaled FCn, PHIn      
      PARAMETER (MCOLS=500)
C! 5-6-92
      REAL OUTK(2,NXPLCT1)
C 
C Common block for all input data
C   these are just as they were for the unkeyowrded version
      COMMON /RINPUT/ NUMFC,NSCAL,JOUT,KEEP,KAI,JUSTD,NORST,JPRNT,
     $     NEXTRA,IFILT,NEIGMX,IEXP,AKAY,PARML,IREF,D1,D2,CSIG1,CSIG2,
     $     LOOKUP,KOUT,KSFALL
C ! ,KOUT(flag to o/p scaled FCj's),KSFALL(to scale rel.to B(KEEP)=0) 5-6-92 
      INTEGER  NUMFC,NSCAL,JOUT,KEEP,KAI,JUSTD,NORST,JPRNT,
     $     NEXTRA,IFILT,NEIGMX,IEXP,KOUT,KSFALL
      REAL AKAY,D1,D2,CSIG1,CSIG2
      INTEGER IREF(18),LOOKUP(NLPRGI)
      REAL PARML(18)
      CHARACTER*70 TITLE
      COMMON /CINPUT/ TITLE
C
C miscellaneous declarations
      REAL FMIN, SMALL, FMAX0
      INTEGER  NFMT2, NFMT1, NFMT,
     $      NXPLCT
      INTEGER  I, JOUTX, KOBS, KSIG, NPBUG,
     $        NPALL, K, J, KKEEP, KEY,
     $        NCYC
      REAL  RTOD, AKEEP, DMIN, DMAX, S2MIN, S2MAX, FACTOR, FMAX
      INTEGER NOIOBS, NOALPH, NORES, NBIG, NUT0,
     $      NIN, NUT, NP, NOBSV, NPRT2, NPRINT, N, NODD,
     $      NPRT, NB, NUSE, NFMTU, NFMTU2 
      REAL  WDMIN, WDMAX, WSTMIN, WSTMAX, FSTMIN, FSTMAX, AOBSMX,
     $     WDSUM, WDSQ, WDWD, WSUM, WCALSQ, S2X, S2N, X, W
      REAL S2, RFAC, DELA, DF, FOBS, S2QT, SIG, FCOS, FSIN,
     $     A, COSA, BCAL, AOBS, SINA, FCAL, ACAL, FINV, WDELA, WST,
     $      FST, WD, WDSQI, BKEEP, FOUT,SIGU 
     $      ,FCOSU,FSINU,COSU,SINU,FCALU
     $      ,A1,A2

C     Hint to linker for block data:
      EXTERNAL ICBLK
C! ,FOUT,SIGU 5-6-92
C
C Max. no. parms=2*max_no._Fc's; MAXPM=2*MAXFC
      INTEGER MAXFC,MAXPM
     1 ,KFCAL(9),KALPH(9)
      REAL FCOSS(9),FSINS(9)
C for LEASQD:
      DOUBLE PRECISION WDSQR
      DOUBLE PRECISION PARM(18)
     1,BLHS(18,18),BLHSV(18,18),BRHS(18),SHIFT(18)
     1,DV(18),PARO(18),VAL(18),VEC(18,18),WK(18,5)
      CHARACTER*8 PNAME(18)
C Following corresp to above but used in main progr. only:
      CHARACTER*8 PNAML(18)
      REAL PAROL(18),SHIFTL(18)
C
C for ANAL2S routine:
      DOUBLE PRECISION SUMW(11,11),SUMA0(11,11),SUMA1(11,11)
     1,SUMA1M(11,11),SUMR0(11,11),SUMR1(11,11)
     1,SUMS2(11,11),SUMDR1(11,11)
      INTEGER NUM0(11,11),NUM1(11,11)
      COMMON/AN/SUMR0,SUMR1,SUMW,SUMA0,SUMA1,SUMA1M
     1,SUMS2,SUMDR1,NUM0,NUM1

      CHARACTER*8 RNAM(8,2)

C 2-11-88 (is format-dep., not NXPLCT)
      PARAMETER(NFMT1=4,NFMT2=2*NFMT1)
      CHARACTER*8 PRTNAM(NFMT2)

      CHARACTER RRNAM(2)*9, IFNAM(2)*1,IFNM*1

      CHARACTER*20 TYPE,TYPS,TYPO

C Things for MTZ reflection file
      REAL HKL(3),ADATA(MCOLS)
      LOGICAL EOF, LOGMSS(MCOLS), LNAN
      INTEGER IFAIL,IPRINT,IMIS

      CHARACTER IBKR*80,DATE*8
      LOGICAL SECOND,MOREIP
C! dimension=MAXFC

      DATA PNAML/ '    lnK1','      B1'
     1,'    lnK2','      B2','    lnK3','      B3'
     1,'    lnK4','      B4','    lnK5','      B5'
     1,'    lnK6','      B6','    lnK7','      B7'
     1,'    lnK8','      B8','    lnK9','      B9'/
      DATA RNAM/'Iobs','Ical','Iobs','W','SQRT(Io)'
     1,'Fcal','SQRT(Io)','Iobs'
     1,'Fobs','Fcal','Fobs','W','Fobs','Fcal','Fobs','Fobs'/
      DATA MAXFC/9/,MAXPM/18/
      DATA PRTNAM
     1 /'K(Fcal1)','B(Fcal1)','K(Fcal2)','B(Fcal2)'
     1 ,'K(Fcal3)','B(Fcal3)','K(Fcal4)','B(Fcal4)'/

      DATA RRNAM/'2F*W*delI','W*delF'/
     1,IFNAM/'I','F'/

      DATA TYPS/'(scaling)'/,TYPO/'(output)'/
      DATA FMIN/0./,FMAX0/32767./,SMALL/1.0E-20/
      DATA LNAN /.TRUE./
      DATA NFMT/NFMT1/
      DATA NXPLCT/NXPLCT1/
C
C--------------------------------------------------------------
      CALL CCPRCS(6,'ICOEFL','$Date: 2005/09/06 11:25:15 $')
      RTOD=45.0/ATAN2(1.,1.)
      DO 7 I=1,MAXPM
         PARML(I)=0
         SHIFTL(I)=0
         PAROL(I)=0
7     CONTINUE

      CALL CCPDAT(DATE)
      WRITE(6,6000)DATE,MAXFC,NXPLCT,NXPLCT,NXPLCT              
C! 2-11-88
6000      FORMAT(/'0ICOEFL - (9/12/91) - Coefs. for refinement'
     1,' on delta(A) A=F or A=I'
     1//' Last modified 22-6-92; run date:',A
     1//2X,'MTZ i/p on unit HKLIN  with:'
     1/3X,'H,K,L,FP,SIGFP,FC1,PHIC1'
     1/3X,'optionally:FC2,PHIC2,FC3,PHIC3,...'
     1,' to be vectorially combined with FC1'
     1/5X,'FP=Fobs or Iobs, SIGFP=sigma(OBS)'
     1/5X,' FCn,PHICn various calc. structure factors'
     1/5X,' max.(n)=',I5,'; for n>',I1,' no i/p column labels '
     1,'expected but must follow on sequentially after '
     1 ,'FC',I1,',PHIC',I1
     1/5X,'K,B scaling to minimize SUM(Wt*(Aobs-Fcal**NA)**2)'
     1,', where NA=1 or 2 as A=F or I;  Wt=1./(C1*SIGMA+C2)**2'
     1/10X,'FC,PHIC='
     1,'VECTOR SUM (Kn*FCn*EXP(-0.25*S**2*Bn),n=1,2,...'
     1/10X,'with either (a) if KEEP=j>0, Kj kept at i/p value,'
     1,'  K(OBS)=1./Kj**NA; Kn=Kn/Kj for n.ne.j'
     1/10X,'or (b) if KEEP.le.0, K(OBS) kept at i/p value')
      WRITE(6,6001)
6001      FORMAT(
     1//2X,'MTZ o/p on unit HKLOUT, with:'
     1,3X,'H,K,L,FP,SIGFP,FC,PHIC,(W,WDEL)'
     1/15X,'H,K,L as i/p;'
     1/15X,'FP=Fobs=scaled F'
     1,' (if A=I F=SQRT(OBS) or -SQRT(-OBS) )'
     1/15X,'SIGFP=scaled SIG (if A=I SIGFP=scaledSIG/(2*Fobs) )'
     1/15X,'FC,PHIC as described above'
     1/15X,'W,WDEL (presence controlled by JOUT {OUTPUT}):'
     1/20X,'A=F: WDEL=(Fobs-Fcal)*Wt, W=Wt*1000'
     1/20X,'A=I: WDEL=2.*Fcal*(Iobs-Ical)*Wt,  W=(4.*Ical*Wt)*1000'
     1//2X,'o/p to BADJ, OPTSHIFT etc on unit RSTATSBKR'
     1,' (ie, to file RSTATSBKR.DAT unless otherwise ASSIGNed)'
     1/15X,'line 1: B1,K1,Rfactor,WDSQ,date'
     1/15X,'line n: Bn,Kn, n=2,3,...)'
     1/15X,'FORMAT(2F10.5,F7.3,E13.6,1X,I2,"/",I2,"/",I2,'
     1,'2(/2F10.5))'
     1//)
C
C  these lines left here for information
C*old*     1//10X,'Card 0: LCF column assignments ##'
C*old*     1/10X,'Card 1:#Fc, #scale_cycles, JOUT, I?, anal_d_only, '
C*old*     1 ,'no_RSTATSBKR, extra_print, KEEP, filter_level,'
C*old*     1/20X,' max_no._eigs, exp(shift)?(vice (1+shif)), read_1a?'
C*old*     1/10X,'(Card 1a(if need per card 1: certain cols set to 0 or 1)'
C*old*     1/10X,'Card 2: K(OBS),(K(FCn),B(FCn),n=1,#Fc)'
C*old*     1/10X,'Card 3: IREF(n),n=1,2*#Fc: refinement control:'
C*old*     1/20X,'IREF(J)=-1:       Jth parameter freely variable'
C*old*     1/20X,'       = 0:       Jth parameter fixed'
C*old*     1/20X,'       = I (I<J): Jth parameter SHIFT tied to '  ! 28-10,4-11-88
C*old*     1 ,'Ith parameter SHIFT (which must be free)'
C*old*     1/40X,' tied parameters keep constant: K-K: ratio; B-B '
C*old*     1, '(and K-B): difference <<<<<<<'
C*old*     1/10X,'Card 4: d1,d2(resol.lims,angstr),C1,C2(for Wt)'
C*old*     1/10X,'Card 5: o/p LCF col. names (if want to change them)'
C*old*     1/15X,'(6A8, one each for FO,SIGFO,FC,PHCAL,W,WDEL'
C*old*     1 ,'; blank-->default; initial "/"=all default'
C*old*     1/10X,'Card 6: o/p title (80A1)'
C*old*     1/15X,'Card 1 thru 4 free format'

      CALL CCPFYP
      CALL MTZINI
C
C**OPEN I/P:
      IPRINT = 1
      IFAIL = 0
      CALL LROPEN(1,'HKLIN',IPRINT,IFAIL)
C
C defaults:
      JOUTX=3
      KOUT=0 
C! 5-6-92
      KSFALL=0 
C! 5-6-92
      KAI=0
      NSCAL=8
      JUSTD=1
      JPRNT=5
      NORST=1
      KEEP=1
      IFILT=8
      NEIGMX=0
      IEXP=0
      JOUT=2
      NUMFC=1
      NEXTRA=0
      DO 17  I=1,MAXFC
       KALPH(I)=0
       KFCAL(I)=0
17    CONTINUE
      KOBS=0
      KSIG=0
      DO 177 I=1,MAXFC
         PARML(2*I)=0
         PARML(2*I-1)=1.
         IREF(2*I)=-1
         IREF(2*I-1)=-1
177   CONTINUE
      AKAY=1.0
C
C Read all input commands  *** AND OPEN O/P hkl file ***
C       if MOREIP=.false. will stop without returning
      MOREIP = .TRUE.
      SECOND=.FALSE.
 5    CALL RDCOMD(MOREIP,SECOND)

      NUMFC=MIN(MAX(1,NUMFC),MAXFC)
      NPALL=2*NUMFC
      JOUT=MIN(JOUT,2)
      KEEP=MAX(0,KEEP)
      WRITE(6,6005)
     1NUMFC,NSCAL,JOUT,KOUT,KEEP,KSFALL,KAI,JUSTD,JPRNT,NORST
     1,NEXTRA
      WRITE(6,6006) IFILT,NEIGMX,IEXP
C! 5-6-92 KOUT,KSFALL in
6005      FORMAT(/' Control data {commands}:'
     1/10X,'NUMFC=Number of Fcalc to be used=',I4,'  {LABIN}'
     1/10X,'NSCAL=Number scaling cycles=',I3,'  {CYCLES}'
     1/10X,'JOUT=',I5,T25,'(0,1,2: omit last JOUT o/p cols;'
     1/,T25,'.lt.0 no o/p, re-read cards 1-3; .le.-2:'
     1,' no NSCAL+1th cycle)','  {OUTPUT,RUN}'
     1/10X,'KOUT=',I2,': Flag to o/p scaled i/p FCs'
     1      ,' (0=no) {OUTPut FPARt}'
     1/10X,'KEEP=no. of Fcal whose scale kept const(.le.0='
     1,' OBS)=',I5,'  {FIX}'
     1/10X,'KSFALL=',I2,': Flag for o/p adapted for program sfall:'
     1/20X,'B-factors are rel.to B(FC(KEEP)); o/p FO is UNSCALED'
     1  ,'{SFALl}'
     1/10X,'KAI=Flag for A=I (if Flag=0 then A=F)=',I3,' {INTENSITIES}'
     1/10X,'JUSTD (>0 for analysis on resolution only'
     1,' (not F or I) if>2 no explanations )=',I3,'  {ANALYSIS}'
     1/10X,'JPRNT=Number o/p lines to print=',I5,'  {PRINT}'
     1/10X,'NORST=Flag for no o/p to RSTATSBKR=',I3,'  {OUTPUT}'
     1/10X,'NEXTRA printing flag (for debug)=',I6,'  {DEBUG}')
 6006     FORMAT(
     1/10X,'IFILT(min. allowed eigenvalue ratio=10**'
     1,'(-ABS(IFILT)))=',I3,'  {FILTER}'
     1/20X,'IFILT<0 means normalize l.sq. matrix by digagonal'
     1,' before inversion'
     1/10X,'NEIGMX(max.no.eigenvals to use, 0=all)=',I5,'  {FILTER}'
     1/10X,'IEXP=',I3
     1/15X,'Calc. shift s theoretically is of lnK,'
     1,' new lnK = X*(old lnK), '
     1/15X,'IEXP=0 or 1 for X= (1+s) or Exp(s)'
     1/)

C find col. numbers & check for enough cols:
      DO 1777 I=1,NUMFC
              KFCAL(I)=LOOKUP(1+2*I)
              KALPH(I)=LOOKUP(2+2*I)
1777  CONTINUE
      KOBS=LOOKUP(1)
      KSIG=LOOKUP(2)
      WRITE(6,6038)KOBS,KSIG
6038      FORMAT(/' Column numbers for OBS SIG=',2I5
     1      /'                for:'
     1/5X,'   n  FCn ALPn','   n  FCn ALPn'
     1,'   n  FCn ALPn','   n  FCn ALPn')                   
C!2-11-88
      WRITE(6,6039)(I,KFCAL(I),KALPH(I),I=1,NUMFC)
6039      FORMAT(5X,4(I3,2I5,'/'))
      WRITE(6,6022)


C NPBUG=no. of debug lines to be printed:
      NPBUG=NEXTRA-1             
C!26-10-88

      DO 1775 K=1,NPALL
         I=NPALL-K+1
         IF(IREF(I).LT.-1)IREF(I)=-1
         IF(IREF(I).GT.0)THEN   
C! 4-11-88
            J=IREF(I)
            IF(MOD(I,2).NE.MOD(J,2))WRITE(6,FMT=
     1           '('' WARNING: K-B tie !!!!!!!!!'')')
            IF(J.GE.I .OR. IREF(J).GE.0)THEN
               WRITE(6,6018)I,IREF(I),J,IREF(J)
               IREF(I)=-1
            ENDIF
         ENDIF
1775     CONTINUE
6018      FORMAT(/' IREF(',I2,')=',I3,' illegal with IREF(',I2,')=',I3
     1  ,'; reset to -1   !!!!!!!')
C ! 4-11-88
      WRITE(6,6020)AKAY
 6020 FORMAT(/' Cards 2 & 3:'/10X,'K(OBS)=',E13.4
     1//' on 2d line: refinement flag IREF'
     1/10X,' / n   K(FCALn)   B(FCALn) '
     1,' / n   K(FCALn)   B(FCALn) '
     1,' / n   K(FCALn)   B(FCALn) '
     1,' / n   K(FCALn)   B(FCALn) ')
      WRITE(6,6021)(I,PARML(2*I-1),PARML(2*I),I=1,NUMFC)
      WRITE(6,6023)(I,IREF(2*I-1),IREF(2*I),I=1,NUMFC)
6021      FORMAT(10X,4('/',I3,E13.4,F10.4))
6023      FORMAT(10X,4('/',I3,5X,I3,9X,I3,3X))
      WRITE(6,6022)
6022      FORMAT(//)

      IF(KEEP.GT.0)THEN
        KKEEP=2*KEEP-1
        AKEEP=PARML(KKEEP)
        WRITE(6,6024)KEEP,AKEEP
6024        FORMAT(/' Final o/p will be scaled so that Fc(',I2
     1 ,') is scaled at (',E13.4,') times value on i/p tape'/)
       ELSE
        AKEEP=AKAY
      ENDIF

      IF(.NOT.SECOND) THEN
         IF(CSIG1.EQ.0. .AND. CSIG2.EQ.0.)CSIG2=1.0
         WRITE(6,6029)D1,D2,CSIG1,CSIG2
 6029    FORMAT(/' Card 4:'
     1/10X,'Resolution limits(angstr.)=',2F7.3
     1/10X,'Weight(Wt) constants C1,C2=',2E12.4/)

         DMIN=AMIN1(D1,D2)
         DMAX=AMAX1(D1,D2)
         S2MIN=1./(DMAX*DMAX)
         S2MAX=1./(DMIN*DMIN)
      ENDIF

      SECOND=.TRUE.

      IF(KAI.NE.0)KEY=1            
C! A=I
      IF(KAI.EQ.0)KEY=2            
C! A=F

      FACTOR=2.
C CHANGES IF KEY=2 

      FMAX=FMAX0

      NCYC=0

C***start of each cycle:
50      NCYC=NCYC+1

      NOIOBS=0
      NOALPH=0
      NORES=0
      NBIG=0
      NUT0=0
      NIN=0
      NUT=0

      WDMIN=1./SMALL
      WDMAX=-WDMIN
      WSTMIN=WDMIN
      WSTMAX=-WSTMIN
      FSTMIN=WDMIN
      FSTMAX=-FSTMIN
      AOBSMX=WDMAX
      WDSUM=0.      
C! Sum[ W*(Aobs-Acal) ]
      WDSQ=0.            
C! Sum[ W*(Aobs-Acal)**2 ]
      WDWD=0.            
C! Sum[ (W*(Aobs-Acal))**2 ]
      WSUM=0.            
C! Sum[ W (=wt) ]
      WCALSQ=0.      
C! Sum[ W*Acal**2 ]
      S2X=S2MIN
      S2N=S2MAX

C NP=number of refined parms; PARM etc hold only refined, PARML etc all
      NP=0
      DO 1774 I=1,NPALL
       IF(IREF(I).LT.0)THEN
         PAROL(I)=PARML(I)             
         NP=NP+1
         PARM(NP)=PARML(I)
         PARO(NP)=PAROL(I)
         SHIFT(NP)=SHIFTL(I)
         PNAME(NP)=PNAML(I)
        ELSE                         
         IF(NCYC.EQ.1)THEN
           PAROL(I)=PARML(I)             
           J=IREF(I)
           IF(J.EQ.0)GOTO 1774
           IF(MOD(I,2).NE.0 .AND. MOD(J,2).NE.0)THEN
              X=1.
              IF(ABS(PARML(J)).GT.SMALL)X=1./PARML(J)
              PAROL(I)=PARML(I)*X
             ELSE
              PAROL(I)=PARML(I)
              IF(J.GT.0)PAROL(I)=PARML(I)-PARML(J)
           ENDIF
         ENDIF
       ENDIF
1774   CONTINUE

C call routines to zero arrays:
      IF(NP.GT.0)CALL LEASQD(0,NP,BLHS,BLHSV,BRHS,DV
     1    ,PARO,PARM,SHIFT,VAL,VEC,WK,PNAME
     1    ,W,AOBS,BCAL
     1    ,NPRINT,NPRT2,WDSQR,NOBSV,IFILT,NEIGMX)

      CALL ANAL2S(0,DMIN,DMAX,FMIN,FMAX,RNAM(1,KEY)
     1    ,S2,W,AOBS,FOBS,A1,DF,DELA,JUSTD,RFAC)
C     1    ,S2,W,AOBS,FOBS,AOBS,DF,DELA,JUSTD,RFAC)
C all arguments are i/p only, so fact that subroutine changes duplicate
C  entries should make no problem -- but we want to keep nitpickers happy

      TYPE=TYPS
      IF(NCYC.GT.NSCAL)TYPE=TYPO
      IF(NCYC.GT.1.AND.NCYC.LT.NSCAL)GOTO 100             
C! 27-10-88
      WRITE(6,6050)NCYC,TYPE
6050      FORMAT(/40(' - ')/' Cycle number',I3,1X,A20/)

C***START HKL LOOP:


 100  CALL LRREFL(1,S2,ADATA,EOF)    
      IF (EOF) GO TO 200
C
      CALL LRREFM(1,LOGMSS)
      NIN=NIN+1
      HKL(1) = ADATA(1)
      HKL(2) = ADATA(2)
      HKL(3) = ADATA(3)
      S2QT=-0.25*S2
      IF (S2.LT.S2MIN .OR. S2.GT.S2MAX) THEN
        NORES=NORES+1
        GOTO 100
      ENDIF
      SIG = 0.0
      IF (LOGMSS(KSIG)) THEN
        IF (LNAN) THEN
          IF (LOGMSS(KSIG) .NEQV. LOGMSS(KOBS)) WRITE(6,'(/,A,/,A,/)')
     .     ' *** Warning: either FP/SIGFP=MNF but other is not.',
     .     ' This must mean the column pair is inconsistent ***'
          LNAN = .FALSE.
        ENDIF
      ELSE
        SIG=ADATA(KSIG)
      ENDIF
      IF (SIG.LE.0.0) THEN
         NOIOBS=NOIOBS+1
         IF (NCYC .LE. NSCAL) GOTO 100
      ENDIF

      SIGU=SIG  
C! 5-6-92 SIGU unscaled for SFALL o/p
      SIG=SIGU*AKAY
      W = 0.0
      IF (SIG*CSIG1.GT.0.00001 .OR. CSIG2.GT.0.0)
     +                          W=1./(SIG*CSIG1+CSIG2)**2

      FOUT = 0.0
      IF(.NOT.LOGMSS(KOBS)) FOUT=ADATA(KOBS)
      IF(SIG.GT.0.00001 .AND. FOUT.LE.0.0) THEN
         NOIOBS=NOIOBS+1
         IF (NCYC .LE. NSCAL) GOTO 100
      ENDIF
C! 5-6-92 FOUT unscaled for SFALL o/p
      AOBS=FOUT*AKAY
      IF(AOBS.GT.AOBSMX)AOBSMX=AOBS
      IF(S2.GT.S2X)S2X=S2
      IF(S2.LT.S2N)S2N=S2
C compute Fcalc in 130-loop  -- FCALU omits Fc(KEEP) (for KSFALL.ne.0 o/p)
      FCOS=0.
      FSIN=0.
      FCOSU=0.
      FSINU=0.
      DO 130 N=1,NUMFC
      IF (LOGMSS(KALPH(N)) .OR. LOGMSS(KFCAL(N))) THEN
        IF (LOGMSS(KALPH(N)) .NEQV. LOGMSS(KFCAL(N))) THEN
          WRITE(6,'(/,A,3F6.0,A,I2,/,A)') 
     +       ' *** ERROR: For reflection ',HKL(1),HKL(2),HKL(3),
     +       ' and partial FC/PHIC number ',N, 
     +       '       One of pair is missing, while the other is set.'
          CALL CCPERR(1,' *** ERROR: inconsistent MNF for FC/PHIC ***')
        ENDIF
        GOTO 130
      ELSE
        NODD=2*N-1
        OUTK(1,N)=ADATA(KFCAL(N))*PARML(NODD)*EXP(PARML(NODD+1)*S2QT)
        OUTK(2,N)=ADATA(KALPH(N))
      ENDIF

      A=OUTK(2,N)/RTOD  
      COSA=COS(A)
      SINA=SIN(A)
      FCAL=OUTK(1,N) 

      FCOSS(N)=FCAL*COSA
      FSINS(N)=FCAL*SINA
      FCOS=FCOS+FCOSS(N)
      FSIN=FSIN+FSINS(N)
      IF(N.EQ.KEEP)GOTO 130
          FCOSU=FCOSU+FCOSS(N)
          FSINU=FSINU+FSINS(N)
130   CONTINUE
      ACAL=FCOS*FCOS+FSIN*FSIN
      FCAL=SQRT(ACAL)
      FINV=0.
      IF(FCAL.GT.0.00001)FINV=1./FCAL
      COSA=FINV*FCOS
      SINA=FINV*FSIN
      IF(FINV.EQ.0.)COSA=1.0
C and omitting KEEP
      FCALU=SQRT(FCOSU**2+FSINU**2)
      IF(FCALU.GT.0.00001)THEN
        COSU=FCOSU/FCALU
        SINU=FSINU/FCALU
      ELSE
        COSU=1.0
        SINU=0.0
      ENDIF
C compute delI or delF as KEY=1 or 2
      IF(KEY.EQ.1)THEN
C                           A=I
        BCAL=ACAL            
C        FACTOR=2 set at start and does not change
       ELSE
C                           A=F
        BCAL=FCAL            
        FACTOR=FINV
      ENDIF
C Remove reflections with NaNs from stats. on last cycle 
      IF (NCYC .GT. NSCAL) THEN
        IMIS = 0
        IF (SIG .LE. 0.00001) THEN
          IMIS = 1
          GOTO 160
        ELSE
          IF(LOGMSS(KOBS) .OR. (FCOS.EQ.0.0 .AND. FSIN.EQ.0.0)) THEN
            IMIS = 1
            GOTO 160
          ENDIF
        ENDIF
      ENDIF
      DELA=AOBS-BCAL
      WDELA=W*DELA
      WDSUM=WDSUM+WDELA
      WDSQ=WDSQ+WDELA*DELA
      WSUM=WSUM+W
      WCALSQ=WCALSQ+W*BCAL*BCAL

      IF(NCYC.GT.NSCAL) GOTO 160
C***SCALING SECTION (compute derivatives into DV):
C     D(Ical)/D(lnKn)= 2*(FCOSS(N)*FCOS+FSINS(N)*FSIN)
C     D(Ical)/D(Bn)=-(S2/4)*2*(FCOSS(N)*FCOS+FSINS(N)*FSIN)
C       REPLACE 2* by (1/F)* if replace Ical by Fcal (FACTOR above)
      
      K=0
      DO 145 N=1,NUMFC
      X=FACTOR*(FCOSS(N)*FCOS+FSINS(N)*FSIN)
      NODD=2*N-1
      IF(IREF(NODD).LT.0)THEN
       K=K+1
       DV(K)=X
      ENDIF
      IF(IREF(NODD+1).LT.0)THEN
       K=K+1
       DV(K)=S2QT*X
      ENDIF
145      CONTINUE

      IF(NP.GT.0)CALL LEASQD(1,NP,BLHS,BLHSV,BRHS,DV
     1,PARO,PARM,SHIFT,VAL,VEC,WK,PNAME
     1,W,AOBS,BCAL
     1,NPRINT,NPRT2,WDSQR,NOBSV,IFILT,NEIGMX)
      IF(NPBUG.GT.0)THEN
        NPBUG=NPBUG-1
        WRITE(6,6145)AOBS,BCAL,W,W*(AOBS-BCAL)
6145        FORMAT(' AOBS,BCAL,W:',3E11.3,',WdF:',E11.3,' DERIVS:')
        WRITE(6,FMT='(1X,11E11.3)')(DV(I),I=1,NP)
      ENDIF

C 10-6-92 !!!      IF(JOUT.LE.-2 .AND. NCYC.GE.NSCAL)GOTO 160
C         !!!   ie, get statistics since there will be no o/p cycle
      GOTO 100

C***STATS & O/P:
160   IF(KEY.EQ.1)THEN
C                              A=I
        WST=4.*ACAL*W                  
        FOBS=SIGN(SQRT(ABS(AOBS)),AOBS)
        FST=FOBS
        DF=FOBS-FCAL
        WD=2.*FCAL*WDELA
        X=2.*ABS(FOBS)
        IF(X.GT. 0.0001)X=1./X
        SIG=SIG*X
        A1=AOBS
        IF (IMIS .EQ. 0) THEN
          CALL ANAL2S(1,DMIN,DMAX,FMIN,FMAX,RNAM(1,KEY)
     1      ,S2,W,AOBS,FOBS,A1,DF,DELA
     1      ,JUSTD,RFAC)
        ENDIF
      ELSE
C                                      A=F
        WST=W                        
        FOBS=AOBS
        IF(KSFALL.NE.0)FOBS=AOBS*EXP(-BKEEP*S2QT)
C ie, for statistics use Fo with scale(Aobs) & B applied
        FST=FOBS
        DF=FOBS-FCAL
        WD=W*DF
        A1=FOBS
        A2=FOBS
        IF (IMIS .EQ. 0) THEN
          CALL ANAL2S(1,DMIN,DMAX,FMIN,FMAX,RNAM(1,KEY)
     1      ,S2,W,FOBS,A1,A2,DF,DF
     1      ,JUSTD,RFAC)
        ENDIF
      ENDIF
      IF (IMIS .EQ. 0) THEN
        WDWD=WDWD+WD*WD
        IF(WD.LT.WDMIN)WDMIN=WD
        IF(WD.GT.WDMAX)WDMAX=WD
        IF(WST.LT.WSTMIN)WSTMIN=WST
        IF(WST.GT.WSTMAX)WSTMAX=WST
        IF(FST.LT.FSTMIN)FSTMIN=FST
        IF(FST.GT.FSTMAX)FSTMAX=FST
      ENDIF
      IF(JOUT.GE.0)THEN
C Write to o/p hkl file:  no o/p if JOUT.LT.0 (modified 5-6-92; see 130 loop)
         NUT=NUT+1
         NPRT=JPRNT-NUT
         IF(KSFALL.EQ.0)THEN
C normal case (scaled Fobs)
            CALL WRTHKL(NPRT,HKL,ADATA,LOGMSS,JOUTX,WD,COSA,SINA,WST
     1     ,FST,FCAL,SIG,NB,KOUT,OUTK,NUMFC,JOUT,KOBS,KSIG,KALPH,KFCAL)
           ELSE                                      
C unscaled Fobs(=FOUT), FCout does not contain FC(KEEP) (FCALU)
            CALL WRTHKL(NPRT,HKL,ADATA,LOGMSS,JOUTX,WD,COSU,SINU,WST
     1  ,FOUT,FCALU,SIGU,NB,KOUT,OUTK,NUMFC,JOUT,KOBS,KSIG,KALPH,KFCAL)
         ENDIF
      ENDIF

      IF(NB.NE.0)THEN
        NBIG=NBIG+1
        GOTO 100
      ENDIF
      NUT0=NUT0+1
      GOTO 100

C***END OF LOOP ON HKL:

200      NUSE=NIN-NOIOBS-NOALPH-NORES
      IF(S2X.GT.0.)DMIN=1./SQRT(S2X)
      IF(S2N.GT.0.)DMAX=1./SQRT(S2N)
      IF(NCYC.GT.1.AND.NCYC.LT.NSCAL)GOTO 210             
C! 27-10-88
      WRITE(6,6200)NIN,NORES,NOIOBS
     1,NOALPH,NUSE,NUT,DMAX,DMIN
6200      FORMAT(/'0NO.HKL: I/P=',I10
     1/5X,'NO.HKL REJ. FOR: RESOL=',I10,', NO IOBS=',I10
     1,', NO PHASE(CALC1,2 OR 3)=',I10
     1/5X,'NO. HKL USED=',I10/5X,'NO. HKL O/P=',I10
     1/5X,'FOR DATA USED, DMAX,DMIN=',2F10.3/)
      
      WDSQI=WDSQ/(AKAY**2)
      IFNM=IFNAM(KEY)
      WRITE(6,6205)IFNM,AKAY,IFNM,IFNM,WDSUM,IFNM,WDSQ,IFNM,WDSQI
     1,WDWD,RRNAM(KEY),IFNM,WCALSQ,WSUM
6205      FORMAT(/'   Following statistics are with ,',A1,'obs=(',E11.4
     1,')*(',A1,'obs i/p)'
     1/' Sum(W*del',A1,')=',T25,E12.4
     1/' Sum(W*del',A1,'**2)=',T25,E12.4
     1,' (with ',A1,'obs unscaled from i/p =',E12.4,')'
     1/' Sum((output)**2)=',T25,E12.4,' (output= ',A9,')'
     1/' Sum(W*',A1,'cal**2)=',T25,E12.4
     1/' Sum(W)=',T25,E12.4, ' (W=Wt=weight)'/)

      IF(NCYC.LE.NSCAL)GOTO 210

      WRITE(6,6206)NBIG,NUT0
6206      FORMAT(/' No. hkl omitted from o/p only because too'
     1,' big=',I8
     1/1X,' No. hkl actually written to o/p file=',I8/)
      WSTMIN=WSTMIN
      WSTMAX=WSTMAX
      WRITE(6,6208)WDMIN,WSTMIN,FSTMIN,WDMAX
     1,WSTMAX,FSTMAX
6208      FORMAT(/'0 Output to HKLOUT:'
     1//T40,'WD',T60,'     WST',T80,'FO'
     1/' MIN:',T40,E12.4,T60,E12.4,T80,E12.4
     1/' MAX:',T40,E12.4,T60,E12.4,T80,E12.4//)


      A1=AOBS
      CALL ANAL2S(2,DMIN,DMAX,FMIN,FMAX,RNAM(1,KEY)
     1,S2,W,AOBS,FOBS,A1,DF,DELA
     1,JUSTD,RFAC)

C if JOUT.lt.0: no o/p, go read cards again (at statemnt 5)
205   IF(JOUT.LT.0)THEN
         CALL LRREWD(1)
         WRITE(6,FMT='(1X,20(''** '')/)')
C JOUT reset to default value (all others default to last setting)
         JOUT=2
         GOTO 5
      ENDIF

      IF(NORST.EQ.0)THEN
        CALL CCPDPN(13,'RSTATSBKR','NEW','F',0,0)
              INQUIRE(UNIT=13,NAME=IBKR)
      CALL CCPDAT(DATE)
C 28/10/88: o/p  WDSQI (ie, on native scale) vice WDSQ (ie, on Fc(KEEP) scale)
        WRITE(13,6174)BKEEP,AKAY,RFAC,WDSQI,DATE
6174        FORMAT(2F10.5,F7.4,E13.6,1X,A8)
        WRITE(6,6176)IBKR,KEEP
6176        FORMAT(/' Lines written to unit ',A40
     1 /'  B(Fc',I2,')  K(Fobs)    R   Sum(w(Fo-Fc)**2) '
     1 ,'day/month/year;'
     1 ,' FORMAT(2F10.5,F7.3,E13.6,1X,A8) :')
        WRITE(6,6174)BKEEP,AKAY,RFAC,WDSQI,DATE
         DO 1773 I=1,NUMFC
          IF(I.NE.KEEP)THEN
            WRITE(13,6174)PARML(2*I),PARML(2*I-1)
            WRITE(6,6178)PARML(2*I),PARML(2*I-1),I
6178            FORMAT(2F10.5,5X,I3)
          ENDIF
1773     CONTINUE
         WRITE(6,6179)
6179         FORMAT('  B(Fc n)  K(Fc n)',5X,'n (n above not written)')
        WRITE(6,6022)
      ENDIF

      IPRINT = 1
      CALL LWCLOS(1,IPRINT)
      WRITE(6,6190)
6190      FORMAT(1X,40('* ')/)
C---------------------------------stmnt 5 CALL RDCOMD(,) normally terminates
      GOTO 5
C ------------------------------------------------------------STOP HERE---
C***SCALE&B:

210   NPRT2=0
      NPRINT=-1            
C! 27-10-88  WAS =2
      IF(NCYC.EQ.1.OR.NCYC.EQ.NSCAL)NPRINT=3

      IF(NEXTRA.GT.0)THEN
         NPRT2=99
         NPRINT=99
      ENDIF
      IF(NP.GT.0)CALL LEASQD(2,NP,BLHS,BLHSV,BRHS,DV
     1,PARO,PARM,SHIFT,VAL,VEC,WK,PNAME
     1,W,AOBS,BCAL
     1,NPRINT,NPRT2,WDSQR,NOBSV,IFILT,NEIGMX)
C***ADJUST PARMS: B's(I even)  have been refined as such but K's(I odd)
C            have been ref. as lnK
      K=0
      DO 235 I=1,NPALL
        IF(IREF(I))232,233,234
232         K=K+1
         PAROL(I)=PARO(K)
         IF(MOD(I,2).EQ.0)THEN
           PARML(I)=PARM(K)
C4-11-88                 SHIFTL(I)=SHIFT(K)
          ELSE
           IF(IEXP.NE.0)PARML(I)=EXP(SHIFT(K))*PAROL(I) 
C!27-10-88 was PAROL(K)
           IF(IEXP.EQ.0)PARML(I)=(1.+SHIFT(K))*PAROL(I) 
C!27-10-88 was PAROL(K)
C4-11-88                 SHIFTL(I)=PARML(I)-PAROL(I)
         ENDIF
         SHIFTL(I)=PARML(I)-PAROL(I) 
C!4-11-88
         GOTO 235
233         SHIFTL(I)=0
         GOTO 235
234         J=IREF(I)
C   4-11-88 shifts tied by ratio (K-K) or difference (B-B & K-B) and
C       for unref. parms PAROL always holds initial ratio or difference
         IF(MOD(I,2).NE.0 .AND. MOD(J,2).NE.0)THEN
            PARML(I)=PAROL(I)*PARML(J)
           ELSE
            PARML(I)=PAROL(I)
            IF(J.GT.0)PARML(I)=PAROL(I)+PARML(J)
         ENDIF
         SHIFTL(I)=0        
C! clearer o/p, though untrue        
235      CONTINUE
C!!!!!!!      NPALL6=MIN(NPALL,6)
      NFMTU=MIN(NUMFC,NFMT)        
C  ! 2-11-88
      NFMTU2=NFMTU*2
      IF(NCYC.GT.1.AND.NCYC.LT.NSCAL)GOTO 240             
C! 27-10-88
      WRITE(6,6240) RNAM(1,KEY),(PRTNAM(I),I=1,NFMTU2)
       IF(NUMFC.GT.NFMTU)WRITE(6,6241)(I,I,I=NFMTU+1,NUMFC)
240      WRITE(6,6242)(SHIFTL(I),I=1,NFMTU2)
      IF(NPALL.GT.NFMTU2)WRITE(6,6243)(SHIFTL(I),I=NFMTU2+1,NPALL)
      IF(NCYC.GT.1.AND.NCYC.LT.NSCAL)GOTO 250
C! 27-10-88

      WRITE(6,6244)AKAY,(PARML(I),I=1,NFMTU2)
      IF(NPALL.GT.NFMTU2)WRITE(6,6245)(PARML(I),I=NFMTU2+1,NPALL)
C 2-11-88 the following assume NFMT1=4 ; 4-11-88: E12.4-->F12.5
6240      FORMAT(/T20,1X,'K(',A8,')',T32,4(2X,A8,4X,A8,2X))      
C! 4=NFMT
6241      FORMAT(T32,4(2X,'K(Fcal',I2,')',3X,'B(Fcal',I2,')',1X))      
C! 4=NFMT
6242      FORMAT(/1X,'Shift',T20,12X,4(F12.5,F12.3))            
C! 4=NFMT
6243      FORMAT(T32,4(F12.5,F12.5))                        
C! 4=NFMT
6244      FORMAT(/1X,'New value',T20,F12.5,4(F12.5,F12.3))      
C! 4=NFMT
6248      FORMAT(/1X,'Final o/p value',T20,F12.5,4(F12.5,F12.3))      
C! 4=NFMT
6245      FORMAT(T32,4(F12.5,F12.3))                        
C! 4=NFMT
6246      FORMAT(/)

250   IF(NCYC.EQ.NSCAL)THEN
C if JOUT.le.-2 & this is last cycle: go read more cards
           IF(JOUT.LE.-2)GOTO 205
           BKEEP=0
C set parameters to final o/p values
           IF(KEEP.GT.0)THEN
             BKEEP=PARML(KKEEP+1)
             X=AKEEP/PARML(KKEEP)
             AKAY=(X**(3-KEY))*AKAY      
C                    X**2*AKAY if A=I(KEY=1), X*AKAY if A=F(KEY=2)
             DO 1772 I=1,NUMFC
               N=2*I-1
               PARML(N)=X*PARML(N)
C 5-6-92: FCkeep keeps B=0 and all others adjusted to it
               IF(KSFALL.NE.0)PARML(N+1)=PARML(N+1)-BKEEP
1772         CONTINUE
           ENDIF
           WRITE(6,6248)AKAY,(PARML(I),I=1,NFMTU2)
           IF(NPALL.GT.NFMTU2)WRITE(6,6245)(PARML(I),I=NFMTU2+1,NPALL)
           WRITE(6,6246)
           IF(KSFALL.NE.0)WRITE(6,FMT='(/1X,A/)')
     1   ' ***  o/p Fobs unsclaled; statistics are for scaled Fobs ***'
      ENDIF

C*REOPEN FILE FOR NEXT CYCLE
      CALL LRREWD(1)
C***FOR STATS:
      FMAX=0.5*AOBSMX
      WRITE(6,6250)
6250      FORMAT(1X,40('- ')/)
      GOTO 50
      END
C   - - - - - - - - - - - - - - - -
      SUBROUTINE ANAL2S(IGO,DMIN,DMAX,AMIN,AMAX,RNAM
     1,S2,W,A,A0,A1,DA0,DA1
     1,JUSTD,RFAC)

C      GIVES A CONVENTIONAL & A WEIGHTED-RMS R-FACTOR
C        IN RES.,AMPLITUDE BINS

      CHARACTER*8 RNAM(8)
      DOUBLE PRECISION SUMW(11,11),SUMA0(11,11),SUMA1(11,11)
     1,SUMA1M(11,11),SUMR0(11,11),SUMR1(11,11),SUM(11,11,8)
     1,SUMS2(11,11),SUMDR1(11,11)
      REAL R1MIN(11,11)
C      RNAM:DA11,DA12,A1,W,DA01,DA02,A0,A
      INTEGER NUM0(11,11),NUM1(11,11),NUM(11,11,2)
      COMMON/AN/SUMR0,SUMR1,SUMW,SUMA0,SUMA1,SUMA1M
     1,SUMS2,SUMDR1,NUM0,NUM1
      EQUIVALENCE(SUM(1,1,1),SUMR0(1,1)),(NUM(1,1,1),NUM0(1,1))
      REAL DLIM(11),ALIM(11),DMIN,DMAX,AMIN
      SAVE
      DATA BIG/1.0E31/,ND/10/,ND1/11/,NA/10/,NA1/11/
     1,JSUM/8/
     1,SMALL/1E-10/

      IF(IGO-1)2,100,200

2      CONTINUE
C***SET UP LIMIT:D IN S**2, A IN LOG UNITS:
      S2MIN=0.
      IF(DMAX.GT.0.)S2MIN=1./DMAX**2
      S2MAX=0.
      IF(DMIN.GT.0.)S2MAX=1./DMIN**2
      D=(S2MAX-S2MIN)/FLOAT(ND)
      DO 10 I=2,ND
10      DLIM(I)=S2MIN+(I-1)*D
      S2MNO=S2MIN
      S2MXO=S2MAX
      S2MIN=BIG
      S2MAX=-S2MIN

C***A BINS:BOTTOM=ALL<AMIN, TOP=ALL>AMAX
C       LOW BINS LINEAR, HIGH IN POWERS OF 2
      NAHF=NA1/2
      DO 20 I=NAHF,NA
20      ALIM(I)=AMAX/(2.**(NA-I))
      D=ALIM(NAHF)/FLOAT(NAHF-2)
      DO 25 I=2,NAHF
25      ALIM(I)=AMIN+D*(I-2)
      ALMIN=BIG
      ALMAX=-ALMIN
C***ZERO ARRAYS:
      DO 30 ID=1,ND1
      DO 30 IA=1,NA1
      DO 28 J=1,JSUM
      R1MIN(IA,ID)=0.
28      SUM(IA,ID,J)=0.0D0
      NUM0(IA,ID)=0
30      NUM1(IA,ID)=0

      RETURN

C                ENTRY ANAL2D(S2,W,A,A0,A1,DA0,DA1)
100      CONTINUE

C USUALLY: W=1./SIG(I)**2, A=I OR F, A0=SQRT(IOBS)(IOBS.GE.0),
C    A1=IOBS, DA0=A0-FCALC, DA1=A1-FCALC**2

      DO 110 I=2,ND
      IF(S2.GE.DLIM(I))GOTO 110
      ID=I-1
      GOTO 120
110      CONTINUE
      ID=ND
120      IF(S2.LT.S2MIN)S2MIN=S2
      IF(S2.GT.S2MAX)S2MAX=S2
      DO 130 I=2,NA
      IF(A.GE.ALIM(I))GOTO 130
      IA=I-1
      GOTO 140
130      CONTINUE
      IA=NA
140      IF(A.LT.ALMIN)ALMIN=A
      IF(A.GT.ALMAX)ALMAX=A

      NUM1(IA,ID)=NUM1(IA,ID)+1
      SUMW(IA,ID)=SUMW(IA,ID)+W
      SUMS2(IA,ID)=SUMS2(IA,ID)+S2
      SUMA1(IA,ID)=SUMA1(IA,ID)+A1*A1*W
      DA1W=DA1*W
      SUMA1M(IA,ID)=SUMA1M(IA,ID)+DA1W
      SUMR1(IA,ID)=SUMR1(IA,ID)+DA1*DA1W
      SUMDR1(IA,ID)=SUMDR1(IA,ID)+W*(A1-DA1)**2      
C                  = Sum(wt*Acal**2)

      IF(A0.LT.0.)RETURN
      NUM0(IA,ID)=NUM0(IA,ID)+1
      SUMA0(IA,ID)=SUMA0(IA,ID)+A0
      SUMR0(IA,ID)=SUMR0(IA,ID)+ABS(DA0)

      RETURN

C                   ENTRY ANAL2E(JUSTD)
200      CONTINUE

C      JUSTD.>.0 MEANS ANALYZE BY D ONLY (NOT BY F)
C      abs(JUSTD).ge.2 means no explanations        3-11-88

C***SET UP LIMS:
      S2MIN=MIN(S2MIN,S2MNO)
      S2MAX=MAX(S2MAX,S2MXO)
      DLIM(1)=S2MIN
      DLIM(ND1)=S2MAX
      DO 210 I=1,ND1
      IF(DLIM(I).GT.0.)DLIM(I)=1./SQRT(DLIM(I))
210      CONTINUE
      ALIM(1)=ALMIN
      ALIM(NA1)=ALMAX
C***CALC.TOTLES:
      DO 230 ID=1,ND
      DO 220 IA=1,NA
      DO 220 J=1,JSUM
      SUM(IA,ND1,J)=SUM(IA,ND1,J)+SUM(IA,ID,J)
      SUM(NA1,ID,J)=SUM(NA1,ID,J)+SUM(IA,ID,J)
      IF(J.GT.2)GOTO 220
      NUM(IA,ND1,J)=NUM(IA,ND1,J)+NUM(IA,ID,J)
      NUM(NA1,ID,J)=NUM(NA1,ID,J)+NUM(IA,ID,J)
220      CONTINUE
      DO 230 K=1,JSUM
      IF(K.GT.2) GOTO 230
      NUM(NA1,ND1,K)=NUM(NA1,ND1,K)+NUM(NA1,ID,K)
230      SUM(NA1,ND1,K)=SUM(NA1,ND1,K)+SUM(NA1,ID,K)
C***CONVERT SUMS TO AVG,RMS ETC:
      DO 250 ID=1,ND1
      DO 250 IA=1,NA1
      N1=NUM1(IA,ID)
      IF(N1.LE.0)GOTO 250
      F=1./FLOAT(N1)
      S2=F*SUMS2(IA,ID)
      IF(S2.GT.0.)SUMS2(IA,ID)=1./SQRT(S2)
      W=SUMW(IA,ID)
      A1=SUMA1(IA,ID)
      SUMW(IA,ID)=F*SUMW(IA,ID)
      WINV=0.
      IF(W.GT.0.)WINV=1./W
      IF(ABS(A1).LE.SMALL)GOTO 240
      SUMA1(IA,ID)=SQRT(WINV*A1)
      X=0.
      IF(ABS(SUMA1(IA,ID)).GT.SMALL)X=1./SUMA1(IA,ID)
      SUMA1M(IA,ID)=SUMA1M(IA,ID)*WINV*X
      RSQ=SUMR1(IA,ID)/A1      
C        =<(Aobs-Acal)**2>/<Aobs**2>
      D=SUMDR1(IA,ID)/A1      
C       =<Acal**2>/<Aobs**2>
      FFOSQ=0.5*(1.+D-RSQ)      
C       =<Aobs*Acal>/<Aobs**2>
C!!!!!!!      FFOSQ=1.-RSQ-2.*D
      X=0.
      IF(ABS(D).GT.SMALL)X=1./D
      AK=FFOSQ*X
      RMSQ=1.-(FFOSQ**2)*X
      SUMDR1(IA,ID)=-99
      IF(ABS(AK).GT.SMALL)SUMDR1(IA,ID)=LOG(ABS(AK))
      R1MIN(IA,ID)=SIGN(SQRT(ABS(RMSQ)),RMSQ)
      SUMR1(IA,ID)=SIGN(SQRT(ABS(RSQ)),RSQ)
240      N0=NUM0(IA,ID)
      IF(N0.LE.0) GOTO 250
      F=1./FLOAT(N0)
      A0=SUMA0(IA,ID)
      SUMA0(IA,ID)=F*A0
      IF(ABS(A0).LE.SMALL)GOTO 250
      SUMR0(IA,ID)=SUMR0(IA,ID)/A0
250      CONTINUE

      IF(ABS(JUSTD).LE.1)WRITE(6,6250)RNAM(8)
6250      FORMAT(//20(' -  - ')/10X,'Analyses of R-factors'
     1,' in resolution/A bins, A=',A8
     1/15X,'Resolution: equal bins of 1./d**2'
     1/15X,'A:  low bins linear, high in powers of 2'/)
6255      FORMAT(/5X,'D-MIN:',T20,10F9.3
     1/5X,'D-MAX:',T20,10F9.3,5X,' ALL D')
6500      FORMAT(
     1//5X,'MIN',4X,'MAX'
     1/4X,A8,1X,A8/)

      IF(ABS(JUSTD).LE.1)WRITE(6,6260)(RNAM(I),I=1,4)
6260      FORMAT(/'0ANAL OF R1=SQRT(SUM(W*DA1**2)/(SUM(W*A1**2)))'
     1/5X,'AVG.D=AVG.RES.=1./AVG(S2)'
     1/5X,'DA1=(',A8,')-(',A8,'), A1=(',A8,'),W=(',A8,')'
     1/5X,'KBIN=ADDL K(APPLIED TO A1) TO MIN. R1 IN BIN'
     1/5X,'R1(KBIN)=CORRESP. MIN. VAL. OF R1'
     1/5X,'N1=NO. IN BINS FOR R1')
      IF(ABS(JUSTD).LE.1)WRITE(6,6270) (RNAM(I),I=5,7)
6270      FORMAT('0 ANAL OF R0=SUM(ABS(DA0))/SUM(A0)'
     1/5X,' DA0=(',A8,')-(',A8,'), A0=(',A8,')'
     1/5X,'N0=NO. IN BINS FOR R0'/)

      WRITE(6,6255)(DLIM(I),I=1,ND),(DLIM(I),I=2,ND1)
      IF(JUSTD.LE.0)WRITE(6,6500)RNAM(8),RNAM(8)

      IAST=1
      IF(JUSTD.GT.0)IAST=NA1
      DO 260 IA=IAST,NA1
      I1=IA
      IF(IA.EQ.NA1)I1=1
      I2=MIN0(IA+1,NA1)
      IF(IA.EQ.NA1.AND.JUSTD.LE.0)THEN             
C! 3-11-88
        WRITE(6,6257)RNAM(8)
6257        FORMAT(/' ALL ',A8,':')
        WRITE(6,6261)ALIM(I1),ALIM(I2)
6261        FORMAT(/1X,1P2D9.2)
      ENDIF
      WRITE(6,6262)(NUM1(IA,I),I=1,ND1)
6262      FORMAT(1X,'N1',T20,10I9,5X,I9)
      WRITE(6,6272)(NUM0(IA,I),I=1,ND1)
6272      FORMAT(1X,'N0',T20,10I9,5X,I9)
      WRITE(6,6263)(SUMS2(IA,I),I=1,ND1)
6263      FORMAT(1X,'AVG.D',T20,10F9.3,5X,F9.3)
      WRITE(6,6264)(SUMW(IA,I),I=1,ND1)
6264      FORMAT(1X,'AVG(W)',T20,1P10D9.2,5X,D9.2)
      WRITE(6,6266)(SUMA1(IA,I),I=1,ND1)
6266      FORMAT(1X,'RMS(A1)',T20,1P10D9.2,5X,D9.2)
      WRITE(6,6267)(SUMA1M(IA,I),I=1,ND1)
6267      FORMAT(1X,'MEAN(DA1)/RMS(A1)',T20,10F9.4,5X,F9.4)
      WRITE(6,6300)(SUMDR1(IA,I),I=1,ND1)
6300      FORMAT(1X,'LN(KBIN)',T20,10F9.4,5X,F9.4)
      WRITE(6,6310)(R1MIN(IA,I),I=1,ND1)
6310      FORMAT(1X,'R1(KBIN)',T20,10F9.4,5X,F9.4)
      WRITE(6,6268)(SUMR1(IA,I),I=1,ND1)
6268      FORMAT(1X,'R1',T20,10F9.4,5X,F9.4)
      WRITE(6,6274)(SUMA0(IA,I),I=1,ND1)
6274      FORMAT(1X,'AVG(A0)',T20,10F9.1,5X,F9.1)
      WRITE(6,6276)(SUMR0(IA,I),I=1,ND1)
6276      FORMAT(1X,'R0',T20,10F9.4,5X,F9.4)
260      CONTINUE

      WRITE(6,6400)
6400      FORMAT(//)

      RFAC=SUMR0(NA1,ND1)
      RETURN
      END
C
      BLOCK DATA ICBLK
      INTEGER NXPLCT1,NLPRGI
      PARAMETER(NXPLCT1=4)
      PARAMETER(NLPRGI=2*NXPLCT1+2)
      INTEGER NOPTL
      PARAMETER (NOPTL=NLPRGI-4)
      COMMON /RINPUT/ NUMFC,NSCAL,JOUT,KEEP,KAI,JUSTD,NORST,JPRNT,
     $     NEXTRA,IFILT,NEIGMX,IEXP,AKAY,PARML,IREF,D1,D2,CSIG1,CSIG2,
     $     LOOKUP,KOUT,KSFALL
      INTEGER  NUMFC,NSCAL,JOUT,KEEP,KAI,JUSTD,NORST,JPRNT,
     $     NEXTRA,IFILT,NEIGMX,IEXP,KOUT,KSFALL
      REAL AKAY,D1,D2,CSIG1,CSIG2
      INTEGER IREF(18),LOOKUP(NLPRGI)
      REAL PARML(18)
      SAVE /RINPUT/
      DATA LOOKUP /4*-1,NOPTL*0/
      END
C - - - - - - - - - - - - - - - - -
      SUBROUTINE EA06D(A,VALUE,VECTOR,M,IA,IV,W)
C     ==========================================
C+ DOUBLE PRECISION from source EA06C in [PUBLIC.PROGS] 22/3/85
C+  only changes are at C+ lines
C
C**  18/03/70 LAST LIBRARY UPDATE
C
C  Given a real mXm symmetric matrix A = {aij} this routine finds all its
C  eigenvalues (lambda)i i=1,2,.....,m and eigenvectors xj i=1,2,...,m.
C  i.e. finds the non-trivial solutions of Ax=(lambda)x
C
C  Argument list
C  -------------
C
C  SUBROUTINE EA06C(A,VALUE,X,M,IA,IX,W)
C
C  Arguments set by the user -
C
C  A  is a REAL 2-dimensional array with first dimension IA. The user must
C     store the lower triangle of matrix A into the lower triangle of the
C     array A. i.e. put a(ij) into A(I,J) for i>=j and I>=J.
C
C  M  is an INTEGER and should be set to the order m of the matrix
C
C  IA is an INTEGER set to the first dimension of the array A, i.e. if the
C     allocation for the array A was specified by
C
C            DIMENSION A(100,50)
C
C     then IA would be set to 100
C
C  IX is an INTEGER set to the first dimension of the 2-dimensional array X
C
C
C  Arguments set by the routine -
C
C  A  the space above the diagonal of the array A is used by the routine as
C     work space, the lower triangle set by the user will remain unchanged
C     on return.
C
C  VALUE is a REAL array in which the routine puts the eigenvalues (lambda)i
C     i=1,2,...,m. These are not necessarily in any order.
C
C  X  is a REAL 2-dimensional array, with first dimension IX, containing the
C     eigenvectors. The components of the eigenvector x(i) corresponding to the
C     eigenvalue (lambda)i (in VALUE(I)) are placed in X(J,I) J=1,2,...,M.
C     The eigenvectors are normalized si that xT(i)x(i)=1 i=1,2,...,m.
C
C  W  is a REAL array used by the routine for work space. It must have
C     dimension at least 5*M.
C
C                                    ------------
C
C+1 the C-1 line below replaced by following 2:
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
Cpe     DIMENSION A(IA,M),VALUE(M),VECTOR(IV,M),W(*)
      DIMENSION A(IA,M),VALUE(M),VECTOR(IV,M),W(*)
C-1      REAL A(IA,M),VALUE(M),VECTOR(IV,M),W(1)
      M1=M+1
      W(1)=A(1,1)
      IF(M-2)30,10,20
   10 W(2)=A(2,2)
      W(4)=A(2,1)
      GO TO 30
C+2 replace followin C-2 lines
   20 CALL MD04B(A,W,W(M1),M,IA,W(M+M1))
   30 CALL EA08D(W,W(M1),VALUE,VECTOR,M,IV,W(M+M1))
C-2   20 CALL MC04B(A,W,W(M1),M,IA,W(M+M1))
C-2   30 CALL EA08C(W,W(M1),VALUE,VECTOR,M,IV,W(M+M1))
      IF(M.LE.2)RETURN
      DO 70 L=1,M
      DO 70 II=3,M
      I=M-II+1
      IF(W(M1+I))40,70,40
C 11-7-92:
   40 PP=0.0D0
      I1=I+1
      DO 50 K=I1,M
   50 PP=PP+A(I,K)*VECTOR(K,L)
      PP=PP/(A(I,I+1)*W(M1+I))
      DO 60 K=I1,M
   60 VECTOR(K,L)=VECTOR(K,L)+PP*A(I,K)
   70 CONTINUE
      RETURN
      END
C
C  *  *  *  *  *  *  *  *  *  *  *  *  *  *
C
C+4 replace C-4 line
      SUBROUTINE EA08D(A,B,VALUE,VEC,M,IV,W)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C-4      SUBROUTINE EA08C(A,B,VALUE,VEC,M,IV,W)
C    19/03/70 LAST LIBRARY UPDATE
C+4A repalce C-4A line
Cpe      DIMENSION A(M),B(M),VALUE(M),VEC(1),W(1)
      DIMENSION A(M),B(M),VALUE(M),VEC(*),W(*)
C 11-6-92 proper double precision:
      DATA EPS/ 1.0D-5/,A34/0.0D0/
C-4A      REAL A(M),B(M),VALUE(M),VEC(1),W(1),EPS/  1E-5/,A34/0./
C  THIS USES QR ITERATION TO FIND THE EIGENVALUES AND EIGENVECTORS
C  OF THE SYMMETRIC TRIDIAGONAL MATRIX WHOSE DIAGONAL ELEMENTS ARE
C  A(I),I=1,M AND OFF-DIAGONAL ELEMENTS ARE B(I),I=2,M.  THE ARRAY
C  W IS USED FOR WORKSPACE AND MUST HAVE DIMENSION AT LEAST 2*M.
C  WE TREAT VEC AS IF IT HAD DIMENSIONS (IV,M).
C+5 repacle C-5 line
      CALL EA09D(A,B,W(M+1),M,W)
C-5      CALL EA09C(A,B,W(M+1),M,W)
C  SET VEC TO THE IDENTITY MATRIX.
      DO 20 I=1,M
      VALUE(I)=A(I)
      W(I)=B(I)
      K=(I-1)*IV+1
      L=K+M-1
      DO 10 J=K,L
C 11-6-92 (next 2 lines)
   10 VEC(J)=0.0D0
   20 VEC(K+I-1)=1.0D0
      ITER=0
      IF(M.EQ.1)RETURN
      N2=M
C  EACH QR ITERATION IS PERFORMED OF ROWS AND COLUMNS N1 TO N2
   30  DO 40II=2,N2
      N1=2+N2-II
      IF(ABS(W(N1)).LE.(ABS(VALUE(N1-1))+ABS(VALUE(N1)))*EPS)GO TO 50
   40 CONTINUE
      N1=1
   50 IF(N2.NE.N1) GO TO 60
      N2=N2-1
      IF(N2-1)90,90,30
   60 ROOT=W(M+N2)
      ITER=ITER+1
      N2M1=N2-1
      A22=VALUE(N1)
      A12=A22-ROOT
      A23=W(N1+1)
      A13=A23
      DO80 I=N1,N2M1
      A33=VALUE(I+1)
      IF(I.NE.N2M1)A34=W  (I+2)
      S=SIGN(SQRT(A12*A12+A13*A13),A12)
      SI=A13/S
      CO=A12/S
      JK=I*IV+1
      J1=JK-IV
      J2=J1+MIN0(M,I+ITER)-1
      DO 70 JI=J1,J2
      V1=VEC(JI)
      V2=VEC(JK)
      VEC(JI)=V1*CO+V2*SI
      VEC(JK)=V2*CO-V1*SI
   70 JK=JK+1
      IF(I.NE.N1)  W(I)=S
      A11=CO*A22+SI*A23
      A12=CO*A23+SI*A33
      A13=SI*A34
      A21=CO*A23-SI*A22
      A22=CO*A33-SI*A23
      A23=CO*A34
      VALUE(I)=A11*CO+A12*SI
      A12=-A11*SI+A12*CO
      W(I+1)=A12
   80 A22=A22*CO-A21*SI
      VALUE(N2)=A22
      GO TO 30
C  RAYLEIGH QUOTIENT
   90 DO 110 J=1,M
      K=(J-1)*IV
      XX=VEC(K+1)**2
      XAX=XX*A(1)
      DO 100 I=2,M
      XX=XX+VEC(K+I)**2
C 11-6-92 proper double precision:
  100 XAX=XAX+VEC(K+I)*(2.0D0*B(I)*VEC(K+I-1)+A(I)*VEC(K+I))
  110 VALUE(J)=XAX/XX
      RETURN
      END
C
C  *  *  *  *  *  *  *  *  *  *  *  *  *  *
C
C+6 replace C-6 line
      SUBROUTINE EA09D(A,B,VALUE,M,OFF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C-6      SUBROUTINE EA09C(A,B,VALUE,M,OFF)
C    18/03/70 LAST LIBRARY UPDATE
C+7 replace C-7 line
      DOUBLE PRECISION A(M),B(M),VALUE(M),OFF(M)
C 11-6-92 proper double precision:
      DATA A34/0.0D0/,EPS/0.6D-7/
C-7      REAL A(M),B(M),VALUE(M),OFF(M),A34/0./,EPS/0.6E-7/
      VALUE(1)=A(1)
      IF(M.EQ.1)RETURN
      DO 10 I=2,M
      VALUE(I)=A(I)
   10 OFF(I)=B(I)
C  EACH QR ITERATION IS PERFORMED OF ROWS AND COLUMNS N1 TO N2
      N2=M
   20 IF(N2.LE.1)RETURN
      DO 30 II=2,N2
      N1=2+N2-II
      IF(ABS(OFF(N1)).LE.(ABS(VALUE(N1-1))+ABS(VALUE(N1)))*EPS)GO TO 40
   30 CONTINUE
      N1=1
   40 IF(N2.NE.N1) GO TO 50
      N2=N2-1
      GO TO 20
C  ROOT  IS THE EIGENVALUE OF THE BOTTOM 2*2 MATRIX THAT IS NEAREST
C  TO THE LAST MATRIX ELEMENT AND IS USED TO ACCELERATE THE
C  CONVERGENCE
C 11-6-92:
   50 BB=(VALUE(N2)-VALUE(N2-1))*0.5D0
      CC=OFF(N2)*OFF(N2)
C 11-6-92 (2):
      SBB=1.0D0
      IF(BB.LT.0.0D0)SBB=-1.0D0
      ROOT=VALUE(N2)+CC/(BB+SBB*SQRT(BB*BB+CC))
      N2M1=N2-1
      A22=VALUE(N1)
      A12=A22-ROOT
      A23=OFF(N1+1)
      A13=A23
      DO 60 I=N1,N2M1
      A33=VALUE(I+1)
      IF(I.NE.N2M1)A34=OFF(I+2)
      S=SQRT(A12*A12+A13*A13)
      SI=A13/S
      CO=A12/S
      IF(I.NE.N1)OFF(I)=S
      A11=CO*A22+SI*A23
      A12=CO*A23+SI*A33
      A13=SI*A34
      A21=CO*A23-SI*A22
      A22=CO*A33-SI*A23
      A23=CO*A34
      VALUE(I)=A11*CO+A12*SI
      A12=-A11*SI+A12*CO
      OFF(I+1)=A12
   60 A22=A22*CO-A21*SI
      VALUE(N2)=A22
      GO TO 20
      END
C   - - - - - - - - - - - - - - - -
      SUBROUTINE LEASQD(IGO,NP,BLHS,BLHSV,BRHS,DV
     *,PARO,PARM,SHIFT,VAL,VEC,WK,PNAME
     *,WT,FOBS,FCAL
     *,NPRINT,NPRT2,WDSQR,NOBSV,JFILT,NEIGM)      
C!->LEASQD 7-4-86
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)      
C!->LEASQD 7-4-86
      REAL WT,FOBS,FCAL                  
C!->LEASQD 7-4-86

      DIMENSION BLHS(NP,NP),BLHSV(NP,NP),BRHS(NP),DV(NP)
     *,PARO(NP),PARM(NP),SHIFT(NP)
     *,VAL(NP),VEC(NP,NP),WK(NP,5)
      CHARACTER*8 PNAME(NP)
      CHARACTER*40 NOTE(2)
      SAVE
      DATA NOTE/' (assuming i/p weight =1/sigma**2(obs))'
     1,' '/
      DATA VSMALL/1.0D-20/      
C! abs.min.for eigenvals

C 11-6-92: Constants to propter double precision
C Made 7-4-86 from LEASQ.FOR of same date:      
C!->LEASQD 7-4-86
C LAST REVISED 28-10-88: change print options 
C LAST REVISED 7-4-86: option for normalizing matrix per JFILT<0
C LAST REVISED 4-2-86 : just add DV(I)=0 at IGO=0; REAL-->DIMENSION; NEIGM(X)
C LAST REVISED 19-12-85 : IFILT NEIGM
C REVISED 16/12/83 FOR VAX, REMOVING ENTRIES:IGO=0,1,2
C
C FILE INCLUDES MATINV
C
C i/p:
C  IGO= 0,initiation; =1,accumulate derivs,etc; =2, solve l.sq.eqs.,etc
C  NP=number variable parameters,DV=derivatives,PARM=parameters
C      PNAME=names of parameters (for headings)
C      JFILT,NEIGM: IFILT=ABS(JFILT), NEIGMX=NP if NEIGM=0, else=NEIGM:
C        smallest eigenvalue used is either the NEIGMX-th,
C             or is .ge. 1st*10**-IFILT (ie, must pass both tests)
C        If JFILT.LT.0 then matrix normalized by dividing each row&col.
C            by SQRT(corresp.diagonal element)
C      NPRINT,NPRT2: print control
C NPRT2:0=DO NOT,1=DO INCL ITEMS IN (PAREN)BELOW:
C  NPRT2.GE.2: Write L.H.S. before & after going into MATINV
C NPRINT:-2=NONE;-1=Nob,Npar,Neigs,WDSQ;0=also eigenvalues;      28-10-88
C    1=also (PARO),SHIFT,SIGMA,(PARM);
C    3=also correl.matrix, 4=also eig.vecs 5=also matrices
C FOBS,FCAL,WT= observed,calculated,weight, for each observation-space point

C o/p:BLHS=L.H.S. matrix, BLHSV=L.H.S.-INVERSE but
C      ultimately returned as correlation matrix
C     BRHS=R.H.S.vector,
C   DV ultimately returned with sigmas
C     PARO returned with i/p PARM
C     PARM returned with (i/p PARM)+SHIFT
C     SHIFT=parameter shifts
C     VAL,VEC=eig.vals,vecs in desc order: VEC(I,J)=Ith component of Jth vector
C     NOBSV=#obs,WDSQR=sum(WT*delta**2)
C WK=workspace

      IF(IGO-1)2,20,200

    2 CONTINUE                                    
C! Initialize !
      DO 10 I=1,NP
      BRHS(I)=0.0D0
      DV(I)=0.0D0
C! 30-1-86
      DO 10 J=1,NP
   10 BLHS(I,J)=0.0D0
      NOBS=0
      WDSQ=0.0D0
      RETURN      
C! ------------------------------------------------------

   20 CONTINUE                                    
C! Accumulate ! 11-6-92 set accumulators DEL,WDEL =0.0D0
      DEL=0.0D0
      WDEL=0.0D0
      DEL=FOBS-FCAL
      WDEL=WT*DEL
      DO 50 I=1,NP
      BRHS(I)=BRHS(I)+WDEL*DV(I)
      X=WT*DV(I)
      DO 50 J=1,I
   50 BLHS(I,J)=BLHS(I,J)+X*DV(J)
      WDSQ=WDSQ+WDEL*DEL
      NOBS=NOBS+1
      RETURN      
C! ------------------------------------------------------

  200 CONTINUE                                    
C! Solve !

      NEIGMX=NEIGM                  
C! 4-2-86
      IF(NEIGMX.LE.0)NEIGMX=NP
      IFILT=ABS(JFILT)            
C! 7-4-86

      IF(NPRT2.GE.2)THEN
        DO 17 I=1,NP
        DO 17 J=1,I
           BLHS(J,I)=BLHS(I,J)
17      CONTINUE
        WRITE(6,6020)
        DO 177 I=1,NP
          WRITE(6,6000)(BLHS(I,JJ),JJ=1,NP)
177     CONTINUE
      ENDIF
C if JFILT<0 normalize BLHS, using SHIFT to hold SQRT(diag)      
C! 7-4-86
      IF(JFILT.LT.0)THEN
        DO 1777 I=1,NP
          SHIFT(I)=1.0D0/MAX(VSMALL,SQRT(BLHS(I,I)))
1777    CONTINUE
        DO 1776 I=1,NP
        DO 1776 J=1,NP
          BLHS(I,J)=BLHS(I,J)*SHIFT(I)*SHIFT(J)
1776    CONTINUE
      ENDIF

      CALL MATIND(NP,BLHS,BLHSV,VAL,VEC,WK,NEIG,IFILT,NEIGMX,VSMALL)
C            ^ was V            above                        !->LEASQD 7-4-86

C if JFILT<0 de-normalize BLHS & BLHSV            ! 7-4-86
      IF(JFILT.LT.0)THEN
        DO 1775 I=1,NP
        DO 1775 J=1,NP
          X=SHIFT(I)*SHIFT(J)
          BLHS(I,J)=BLHS(I,J)/X
          BLHSV(I,J)=BLHSV(I,J)*X
1775    CONTINUE
      ENDIF

      WDSQR=WDSQ
      NOBSV=NOBS
      IF(NPRINT.GE.-1)THEN                  
C! 30/4/86   28/10/88
        WRITE(6,6002)WDSQ,NP,NOBS,NEIG
6002        FORMAT(/' LEASQ',20(': '),' Sum(wt*(obs-calc)**2)=',1PE12.4
     1  /' Number: parameters=',I5
     1  ,', observations=',I8,', eigenvectors:',I4)      
C! 27-10-88
C***PRINT EIGS:
            IF(NPRINT.LE.-1) GO TO 280                    
C! 28-1-88
        WRITE(6,6004)NEIG
6004        FORMAT(/I5,' eigenvalues used from among:')
        WRITE(6,6000) VAL
      ENDIF
C
 6000 FORMAT(1P11E12.4)
 6100 FORMAT(11F12.6)                        
C! 19/12/85
C
      IF(NPRINT.LT.4)GO TO 280
      WRITE(6,6006)
 6006 FORMAT(/' Eigenvectors(rows):')
      DO 270 J=1,NP
  270 WRITE(6,6100)(VEC(I,J),I=1,NP)            
C! 19/12/85
C
C***WRITE HEADINGS:
  280 IF(NPRINT.LE.0) GO TO 450
      WRITE(6,6008)(PNAME(I),I=1,NP)
 6008 FORMAT(11(4X,A8))
C
      IF(NPRINT.LT.5)GO TO 450
C***PRINT MATRICES:
      WRITE(6,6010)
 6010 FORMAT(/' R.H.S.:')
      WRITE(6,6000)BRHS
      WRITE(6,6020)
 6020 FORMAT(/' L.H.S.:')
      DO 400 I=1,NP
  400 WRITE(6,6000)(BLHS(I,JJ),JJ=1,NP)
      WRITE(6,6025)
 6025 FORMAT(/1X,'LHS-inverse:')
      DO 410 I=1,NP
  410 WRITE(6,6000)(BLHSV(I,J),J=1,NP)
      WRITE(6,6040)
 6040 FORMAT(/1X,'LHS*(LHS-inverse)-I:')
      DO 430 I=1,NP
      DO 420 J=1,NP
      WK(J,1)=0.0D0
      DO 420 K=1,NP
  420 WK(J,1)=WK(J,1)+BLHS(I,K)*BLHSV(K,J)
      WK(I,1)=WK(I,1)-1.0D0
  430 WRITE(6,6000)(WK(J,1),J=1,NP)
C
  450 CONTINUE
C***SHIFTS,ETC:
      DO 470 I=1,NP
      SHIFT(I)=0.0D0
      DO 470 J=1,NP
  470 SHIFT(I)=SHIFT(I)+BLHSV(I,J)*BRHS(J)
C***COMPUTE SIGMAS &CORRELATION COEFS:
C    SIGMAS IN DV, COR.MAT IN BLHSV
      IF(NOBS.GT.NP)THEN
        SX=SQRT(WDSQ/FLOAT(NOBS-NP))
        JSIGS=2
       ELSE
        SX=1.0D0
        JSIGS=1
      ENDIF                        
C! 12/12/85
      DO 480 I=1,NP
      X=BLHSV(I,I)
  480 DV(I)=SIGN(SQRT(ABS(X)),X)
      DO 490 I=1,NP
      DO 490 J=1,NP
      X=DV(I)*DV(J)
      IF(X.GT.0.)X=1.0D0/X
  490 BLHSV(I,J)=X*BLHSV(I,J)
      DO 495 I=1,NP
  495 DV(I)=SX*DV(I)
C***NEW PARMS:
      DO 500 I=1,NP
      PARO(I)=PARM(I)
  500 PARM(I)=PARM(I)+SHIFT(I)
C
C
      IF(NPRINT.LE.0)RETURN
      WRITE(6,6334)
 6334 FORMAT(/' Parameters:')
      IF(NPRT2.GT.0)WRITE(6,6336)
 6336 FORMAT(/' Old:')
      IF(NPRT2.GT.0)WRITE(6,6000) PARO
      WRITE(6,6344)
 6344 FORMAT(/' Shifts')
      WRITE(6,6000) SHIFT
      WRITE(6,6495)NOTE(JSIGS)            
C! 12/12/85
 6495 FORMAT(/' Sigmas',1X,A40)            
C! 12/12/85
      WRITE(6,6000)(DV(I),I=1,NP)
      IF(NPRT2.GT.0)WRITE(6,6354)
 6354 FORMAT(/' New:')
      IF(NPRT2.GT.0)WRITE(6,6000) PARM
      PRINT *,' '
C
      IF(NPRINT.LE.2)RETURN
      WRITE(6,6250)
 6250 FORMAT('0Correlation matrix:')
      DO 250 I=1,NP
      WRITE(6,6255)(BLHSV(I,J),J=1,I)
 6255 FORMAT(T15,10F11.3)
  250 CONTINUE
C
      WRITE(6,6500)
 6500 FORMAT(20X,5(': '),' end LEASQ'/)
C
      RETURN
      END
C   - - - - - - - - - - - - - - - -
      SUBROUTINE MATIND(NP,A,B,VAL,VEC,WK,NV,IFILT,NEIGMX,VSMALL)      
C! 12/85
C                  ^ was V      above                        !->LEASQD 7-4-86
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)      
C!->LEASQD 7-4-86
      DIMENSION A(NP,NP),B(NP,NP),VAL(NP),VEC(NP,NP)
     *,WK(NP,5)
      SAVE
C
C I/P: A a symmetric matrix; only lower triangle req.
C           ie, A(I,J) DEFINED FOR I.GE.J
C       NP=order; A singular is OK
C      IFILT,NEIGMX: smallest eigenvalue used is either the NEIGMX-th,
C       or is .ge. 1st*10**-IFILT (ie, must pass both tests)
C O/P: B=A inverse, by eigs, filtered at approx machine accuracy(REAL*4)
C !! POSITIVE EIG.VALS ASSUMED IN FILTERING (ie, A=(M-TRANSP)*M) !!
C       NV=no.eigs used
C    VAL contains eigenvalues (descending order)
C    VEC contains eigenvectors:Jth vector is (VEC(I,J),I=1,NP)
C       EIG.VECS ORTHONORMALIZATION ASSURED
C
C        REQUIRES LIBRARY=HARWELL.FORTLIB FOR EA06C
C
C 11-6-92 Proper double-precision constants

      SMALL=10.0D0**(-IFILT)                              
C! 16/12/18

      CALL EA06D(A,VAL,VEC,NP,NP,NP,WK)
C              ^ was C      above                              !->LEASQD 7-4-86
C***RETURNS VALS & VECS IN ARBITRARY ORDER & SCREWS UP
C  UPPER TRIANGLE (I.LE.J) OF W; REQUIRES ONLY LOWER TIANGLE
C  J-TH VEC IS (VEC(I,J),I=1,NP)
C THE 3 NP'S IN CALL ARE:1)ORDER OF MATRIX A,
C    2)1ST DIM OF ARRAY A, 3)FIRST DIM OF ARRAY VEC
C
C*** B(I,J)=SUM(VEC(I,N)*(1.0D0/VAL(N))*VEC(J,N))
C***ORDER EIGS:
      IF(NP.EQ.1)GO TO 50
      NP1=NP-1
      DO 40 J1=1,NP1
      JM=J1
      J2=J1+1
      DO 20 J=J2,NP
      IF(VAL(J).GT.VAL(JM))JM=J
   20 CONTINUE
      V=VAL(J1)
      VAL(J1)=VAL(JM)
      VAL(JM)=V
      DO 30 I=1,NP
      V=VEC(I,J1)
      VEC(I,J1)=VEC(I,JM)
   30 VEC(I,JM)=V
   40 CONTINUE
C***RE-NORMALIZE VEC (FOR SAFETY)
C     (ALSO IN DESC. ORDER):
   50 DO 100 J1=1,NP
      IF(J1.EQ.1)GO TO 80
C***ORTH.IZE REL TO PREDECESSOR:
      J2=J1-1
      DO 70 J=1,J2
      DOT=0.0D0
      DO 60 I=1,NP
   60 DOT=DOT+VEC(I,J1)*VEC(I,J)
      DO 65 I=1,NP
   65 VEC(I,J1)=VEC(I,J1)-DOT*VEC(I,J)
   70 CONTINUE
C***NORM.IZE:
   80 V=0.0D0
      DO 90 I=1,NP
   90 V=V+VEC(I,J1)*VEC(I,J1)
      V=1.0D0/SQRT(V)
      DO 95 I=1,NP
   95 VEC(I,J1)=V*VEC(I,J1)
  100 CONTINUE
C***LIMIT ON EIGS (INVERSE VALS IN WK(-1)):
C     APPROX. REAL*4 ACCURACY
C
      S=MAX(SMALL*VAL(1),VSMALL)
      NV=0
      DO 110 J=1,NP
      WK(J,1)=0.0D0
      IF(VAL(J).LT.S .OR. J.GT.NEIGMX)GO TO 110            
C! 19/12/85
      NV=NV+1
      WK(J,1)=1.0D0/VAL(J)
  110 CONTINUE
C***B=A-INV (LOWER TRIANGLE):
      DO 120 I=1,NP
      DO 120 J=1,I
      B(I,J)=0.0D0
      DO 120 K=1,NP
  120 B(I,J)=B(I,J)+VEC(I,K)*WK(K,1)*VEC(J,K)
C***RESTORE UPPER TRIANGLES
      DO 130 I=1,NP
      DO 130 J=1,I
      A(J,I)=A(I,J)
  130 B(J,I)=B(I,J)
C
      RETURN
      END
C
C***  *  *  *  *  *  *  *  *  *  *  *  *  *
C
C+3 replace collowing C-3 lin
      SUBROUTINE MD04B(A,ALPHA,BETA,M,IA,Q)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C-3      SUBROUTINE MC04B(A,ALPHA,BETA,M,IA,Q)
Cpe      DIMENSION A(IA,1),ALPHA(1),BETA(1),Q(1)
      DIMENSION A(IA,*),ALPHA(*),BETA(*),Q(*)
      ALPHA(1)=A(1,1)
      DO 20 J=2,M
      J1=J-1
      DO 10 I=1,J1
      A(I,J)=A(J,I)
   10 CONTINUE
      ALPHA(J)=A(J,J)
   20 CONTINUE
      M1=M-1
      M2=M-2
      DO 170 I=1,M2
C 11-6-92:
      PP=0.00D0
      I1=I+1
      DO 30 J=I1,M
      PP=PP+A(I,J)**2
   30 CONTINUE
      PP1=SQRT(PP)
      IF(A(I,I+1))50,40,40
   40 BETA(I+1)=-PP1
      GO TO 60
   50 BETA(I+1)=PP1
   60 IF(PP)170,170,70
   70 H=PP-BETA(I+1)*A(I,I+1)
      A(I,I+1)=A(I,I+1)-BETA(I+1)
      DO 120 KI=I1,M
      QJ=0.00D0
      DO 80 KJ=I1,KI
      QJ=QJ+A(KJ,KI)*A(I,KJ)
   80 CONTINUE
      IF(KI-M)90,110,110
   90 I2=KI+1
      DO 100 KJ=I2,M
      QJ=QJ+A(KI,KJ)*A(I,KJ)
  100 CONTINUE
  110 Q(KI)=QJ/H
  120 CONTINUE
      BIGK=0.00D0
      DO 130 KJ=I1,M
      BIGK=BIGK+A(I,KJ)*Q(KJ)
  130 CONTINUE
      BIGK=BIGK/(2.00D0*H)
      DO 140 KJ=I1,M
      Q(KJ)=Q(KJ)-BIGK*A(I,KJ)
  140 CONTINUE
      DO 160 KI=I1,M
      DO 150 KJ=KI,M
      A(KI,KJ)=A(KI,KJ)-Q(KI)*A(I,KJ)-Q(KJ)*A(I,KI)
  150 CONTINUE
  160 CONTINUE
  170 CONTINUE
      DO 180 I=2,M
      H=ALPHA(I)
      ALPHA(I)=A(I,I)
      A(I,I)=H
  180 CONTINUE
      BETA(M)=A(M-1,M)
      RETURN
      END
C
C

C
      SUBROUTINE RDCOMD(MOREIP,SECOND)
C     =========================
C
C Read all control input  *** AND OPEN O/P hkl file *** 
C  or STOP if MOREIP=.false.  (if SECOND then do not initialize i/p cols etc)
C
C   This is a keyworded version, written to provide the sometimes arcane
C  numbers previously input with Fortran read
C
C      IMPLICIT NONE
C
      LOGICAL MOREIP,SECOND
      INTEGER NXPLCT1,NLPRGI,MCOLS
      PARAMETER(NXPLCT1=4)
      PARAMETER(NLPRGI=2*NXPLCT1+2)
      PARAMETER(MCOLS=500)
C
C Common block for all input data
C   these are just as they were for the unkeyowrded version
      COMMON /RINPUT/ NUMFC,NSCAL,JOUT,KEEP,KAI,JUSTD,NORST,JPRNT,
     $     NEXTRA,IFILT,NEIGMX,IEXP,AKAY,PARML,IREF,D1,D2,CSIG1,CSIG2,
     $     LOOKUP,KOUT,KSFALL
C ! ,KOUT(flag to o/p scaled FCj's),KSFALL(to scale rel.to B(KEEP)=0) 5-6-92 
      INTEGER  NUMFC,NSCAL,JOUT,KEEP,KAI,JUSTD,NORST,JPRNT,
     $     NEXTRA,IFILT,NEIGMX,IEXP,KOUT,KSFALL
      REAL AKAY,D1,D2,CSIG1,CSIG2
      INTEGER IREF(18),LOOKUP(NLPRGI)
      REAL PARML(18)
      CHARACTER*70 TITLE
      COMMON /CINPUT/ TITLE
C
C Things for PARSER ----
      INTEGER MAXTOK
      PARAMETER (MAXTOK=100)
      CHARACTER KEY*4,CVALUE(MAXTOK)*4,LINE*240,SUBKEY*4
      INTEGER IBEG(MAXTOK),IEND(MAXTOK),ITYP(MAXTOK),
     .     IDEC(MAXTOK),NTOK
      REAL    FVALUE(MAXTOK)
      LOGICAL LEND
C
C Locals
      LOGICAL LKRESO,LKTITL
      INTEGER I,J,N,M,NERR,IAPPND
      REAL SMIN,SMAX,RESMIN,RESMAX,SCAL,BB
C
C Input column labels
C
      CHARACTER LSPRGI(NLPRGI)*30,CTPRGI(NLPRGI)*1,LSUSRJ(NLPRGI)*30
      CHARACTER LABOUT_SAVE*240
C
      INTEGER NOPTL
      PARAMETER (NOPTL=NLPRGI-4)
C
C  Labels for SCALE command
      INTEGER NSSCAL
      PARAMETER (NSSCAL=NXPLCT1+1)
      CHARACTER LSSCAL(NSSCAL)*30
C
C Output column labels ! 5-6-92 modified
      INTEGER NLPRGO,NLP0,NLP1,NLPJT,NCUSE,NLPI0
      PARAMETER (NLP0=7,NLPJT=2,NLP1=NLP0+NLPJT,NLPRGO=NLP1+2*NXPLCT1)
      PARAMETER(NLPI0=2) 
C! skip in LSPRGI to get to 'FC1'; NLPJT=JOUTmax
      CHARACTER LSP1(NLP1)*30,CTP1(NLP1)*1
      CHARACTER LSPRGO(NLPRGO)*30,CTPRGO(NLPRGO)*1

      INTEGER MSETS
      PARAMETER (MSETS=NLPRGO)
C 
C----Harvesting stuff
C
      INTEGER NDATASETS,ISETS(MSETS),ISET,CSETID(MCOLS),
     +         CSETOUT(NLPRGO),SETID,IDUMMY
      REAL DATCELL(6,MSETS),DATWAVE(MSETS)
      CHARACTER*64 PNAME(MSETS),XNAME(MSETS),DNAME(MSETS),   
     +         XNAME_OUT(NLPRGO),DNAME_OUT(NLPRGO)
C
      SAVE
      DATA LSPRGI/'FP','SIGFP','FC1','PHIC1','FC2','PHIC2',
     $     'FC3','PHIC3','FC4','PHIC4'/
      DATA LSSCAL/'FP','FC1','FC2','FC3','FC4'/
      DATA CTPRGI/'F','Q','F','P','F','P','F','P','F','P'/
      DATA LSP1/'H','K','L','FP','SIGFP','FC','PHIC','W','WDEL'/
      DATA CTP1/'H','H','H','F','Q','F','P','W','F'/
C--------------------------------------------------
       IF(.NOT.MOREIP)THEN
         CLOSE(UNIT=13,STATUS='KEEP')
         CALL CCPERR(0,'*** Normal termination: ICOEFL ***')
       ENDIF
       MOREIP=.FALSE.
C put all possible o/p labels into LSPRGO 5-6-92   
       DO 17 I=1,NLP1
            LSPRGO(I)=LSP1(I)
            CTPRGO(I)=CTP1(I)
17       CONTINUE
       DO 177 I=1,2*NXPLCT1
             LSPRGO(NLP1+I)=LSPRGI(NLPI0+I)
             CTPRGO(NLP1+I)=CTPRGI(NLPI0+I)
177      CONTINUE
C end set up o/p column labels 5-6-92   
C
       LABOUT_SAVE = ' '
C
      NERR = 0
      LKRESO = .FALSE.
      LKTITL = .FALSE.
C
C ---- Loop to read control input
C
1     LINE=' '
      NTOK=MAXTOK
      CALL PARSER(
     .  KEY,LINE,IBEG,IEND,ITYP,FVALUE,CVALUE,IDEC,NTOK,LEND,.TRUE.)
      IF(LEND) GO TO 1000
      IF(NTOK.EQ.0) GO TO 1
C
C Process keywords
C
      IF (KEY .EQ. 'CYCL') THEN
C
C CYCLE  read number of cycles
C          NSCAL = number of cycles
C
         CALL GTPINT(2,NSCAL,NTOK,ITYP,FVALUE)
C
      ELSEIF (KEY .EQ. 'OUTP') THEN
C
C OUTPUT  controls output
C         NOHKl     no output file (JOUT=-1)
C         NONE      no o/p file and no final statistics (JOUT=-2)
C         FOFC      output contains FP, SIGFP, FC, PHIC  (default) (JOUT=2)
C         WEIGht    output also contains WEIGHT (JOUT=1)
C         WDEL      output also contains WEIGHT WDEL (= w(Fo-Fc)) (JOUT=0)
C         BKR       write output file RSTATSBKR (NORST=0) [default no output]
C 5-6-92  FPART     output also contains scaled component FCn,PHIn
         DO 10, I=2,NTOK
            SUBKEY = CVALUE(I)
            CALL CCPUPC(SUBKEY)
            IF (SUBKEY .EQ. 'NOHK') THEN
               JOUT = -1
            ELSEIF (SUBKEY .EQ. 'NONE') THEN
               JOUT = -2
            ELSEIF (SUBKEY .EQ. 'FOFC') THEN
               JOUT = 2
            ELSEIF (SUBKEY .EQ. 'WEIG') THEN
               JOUT = 1
            ELSEIF (SUBKEY .EQ. 'WDEL') THEN
               JOUT = 0
            ELSEIF (SUBKEY .EQ. 'BKR') THEN
               NORST = 0
            ELSEIF (SUBKEY .EQ. 'FPAR') THEN
               KOUT = 1
            ENDIF
 10      CONTINUE
C
      ELSEIF (KEY .EQ. 'FIX') THEN
C
C FIX   define which F to keep constant
C     FOBS      keep FOBS constant, apply scale to all Fc's (KEEP=0)
C     FC  [n]   keep n'th Fcalc constant. n default = 1, this is the default
C                     (KEEP = n)
         SUBKEY = CVALUE(2)
         CALL CCPUPC(SUBKEY)
         IF (SUBKEY .EQ. 'FOBS') THEN
            KEEP = 0
         ELSEIF (SUBKEY .EQ. 'FC') THEN
            IF (NTOK .GT. 2) THEN
               CALL GTPINT(3, KEEP,NTOK,ITYP,FVALUE)
            ELSE
               KEEP = 1
            ENDIF
         ENDIF
C
      ELSEIF (KEY .EQ. 'INTE') THEN
C
C INTENSITIES   set flag to refine on I rather than F (default = F)
C    KAI = 0 F's, = 1 I's
C
         KAI = 1
C
      ELSEIF (KEY .EQ. 'SFAL') THEN
C
C o/p Fobs is unscaled; Fc's are scaled relative to Fc(keep) has k=1.0,B=0.0
C
         KSFALL=1
C
      ELSEIF (KEY .EQ. 'ANAL') THEN
C
C ANALYSIS  define which analyses are done
C set JUSTD = 0 if keyword "F" present else = 1
         SUBKEY = CVALUE(2)
         CALL CCPUPC(SUBKEY)
         IF (SUBKEY .EQ. 'F') THEN
            JUSTD = 0
         ELSE
            JUSTD = 1
         ENDIF
C
      ELSEIF (KEY .EQ. 'PRIN') THEN
C
C PRINT  n
C    number of output lines to print [default JPRNT=0]
C
         CALL GTPINT(2,JPRNT,NTOK,ITYP,FVALUE)
C
      ELSEIF (KEY .EQ. 'DEBU') THEN
C
C DEBUG n   set debug flag  [default = 0]
C
         CALL GTPINT(2,NEXTRA,NTOK,ITYP,FVALUE)
C
      ELSEIF (KEY .EQ. 'FILT') THEN
C
C FILTER  IFILT, NEIGMX
C     IFILT      filter level = 10**(-IFILT)  [default = 8]
C     NEIGMX     maximum number of eigenvalues to use [default = 0 = all]
C
         CALL GTPINT(2,IFILT,NTOK,ITYP,FVALUE)
         CALL GTPINT(3,NEIGMX,NTOK,ITYP,FVALUE)
C
      ELSEIF (KEY .EQ. 'SCAL') THEN
C
C SCALE read starting scales, B-factors
C     k(Fobs), k(Fc1), B(Fc1), k(Fc2), B(Fc2), etc
C      AKAY    PARML(1) etc
C   
         ITOK = 2
 29      IF (ITOK .LE. NTOK .AND. ITOK .GT. 0) THEN
            J = ITOK
            CALL RDSCAL(ITOK,LINE,IBEG,IEND,ITYP,FVALUE,NTOK,
     .           NSSCAL,LSSCAL,N,SCAL,BB)
            IF (ITOK .GE. 0) THEN
               IF (ITOK .EQ. J) ITOK = ITOK + 3
               IF (N .EQ. 1) THEN
C Fobs scale
                  AKAY = SCAL
               ELSE
                  J = 2*(N-2)+1
                  PARML(J)   = SCAL
                  PARML(J+1) = BB
               ENDIF
               GO TO 29
            ENDIF
         ENDIF
C
      ELSEIF (KEY .EQ. 'REFI') THEN
C
C REFINE refine keys
C  FREE/FIX FC/BFC [n]  to set parameters free or fixed
C  TIE  FC/BFC n m       tie parameters together for n'th & m'th Fc
C
C     IREF(i) for i'th parameter = -1 free
C                                =  0 fixed
C                                =  j tied to j'th parameter (j<i)
         I = 1
 30      I = I+1
         IF (I .LT. NTOK) THEN
            SUBKEY = CVALUE(I)
            CALL CCPUPC(SUBKEY)
            IF (SUBKEY .EQ. 'TIE') THEN
               I = I+1
               IF (I .LT. NTOK) THEN
                  CALL CCPUPC(CVALUE(I))
                  IF (CVALUE(I) .EQ. 'FC') THEN
C                   TIE FC 
                     J = 0
                  ELSEIF (CVALUE(I) .EQ. 'BFC') THEN
C                   TIE BFC 
                     J = 1
                  ELSE
                     WRITE (6,'(A)')
     $             ' *** Unrecognized parameter, REFINE command ***'
                     GO TO 900
                  ENDIF
                  N = 0
                  M = 0
                  CALL GTPINT(I+1,N,NTOK,ITYP,FVALUE)
                  CALL GTPINT(I+2,M,NTOK,ITYP,FVALUE)
                  IF (N.GT.0 .AND. M.GT.0) THEN
C              get parameter numbers
                     N = 2*N + J - 1
                     M = 2*M + J - 1
                     IF (N.EQ.M) THEN
                        WRITE (6,'(A)')
     $                ' *** Equal parameters in REFINE TIE ***'
                        GO TO 900
                     ELSEIF (N.GT.M) THEN
                        IREF(N) = M
                     ELSE
                        IREF(M) = N
                     ENDIF
                     I = I+2
                  ELSE
                     WRITE (6,'(A)')
     $                ' *** Missing parameter number in REFINE TIE ***'
                     GO TO 900
                  ENDIF
               ELSE
                  WRITE (6,'(A)')
     $                 ' *** Missing parameter in REFINE TIE ***'
                  GO TO 900
               ENDIF
               GO TO 30
            ELSE
C  assume FIX or FREE for now, check next field
               I = I+1
               IF (I .LT. NTOK) THEN
                  CALL CCPUPC(CVALUE(I))
                  IF (CVALUE(I) .EQ. 'FC') THEN
C                   FIX/FREE FC 
                     J = 0
                  ELSEIF (CVALUE(I) .EQ. 'BFC') THEN
C                   FIX/FREE BFC 
                     J = 1
                  ELSE
                     WRITE (6,'(A)')
     $             ' *** Unrecognized parameter, REFINE command ***'
                     GO TO 900
                  ENDIF
C  Now check main keyword
                  IF (SUBKEY .EQ. 'FIX') THEN
                     M = 0
                  ELSEIF (SUBKEY .EQ. 'FREE') THEN
                     M = -1
                  ELSE
                     WRITE (6,'(A)')
     $             ' *** Unrecognized keyword, REFINE command ***'
                     GO TO 900
                  ENDIF
                  N = 1
                  CALL GTPINT(I+1,N,NTOK,ITYP,FVALUE)
C              get parameter number
                  N = 2*N + J - 1
                  IREF(N) = M
                  I = I+1
               ELSE
                  WRITE (6,'(A)')
     $                 ' *** Missing parameter in REFINE ***'
                  GO TO 900
               ENDIF
               GO TO 30
            ENDIF
         ENDIF
C
      ELSEIF (KEY .EQ. 'RESO') THEN
C
C RESOLUTION resolution limits, either order
C
C             **************************************************
         CALL RDRESO(2,ITYP,FVALUE,NTOK,RESMIN,RESMAX,SMIN,SMAX)
C             **************************************************
         LKRESO = .TRUE.
C
      ELSEIF (KEY .EQ. 'WEIG') THEN
C
C  WEIGHT  C1, C2
C     read constants defining weight = 1/(C1*SIGMA+C2)**2
         CALL GTPREA(2,CSIG1,NTOK,ITYP,FVALUE)
         CALL GTPREA(3,CSIG2,NTOK,ITYP,FVALUE)
C       
      ELSEIF (KEY .EQ. 'TITL') THEN
C
C TITLE give title for output
C
         LKTITL = .TRUE.
         TITLE = LINE(IBEG(2):)
C
      ELSEIF (KEY .EQ. 'LABI') THEN
C
C LABIN column assignments
C
C Start check at 2nd token
         J = 2
C             ****************************************
         CALL LKYSET(LSPRGI,NLPRGI,LSUSRJ,LOOKUP,J,
     $        NTOK,LINE,IBEG,IEND)
C             ****************************************
C    LOOKUP returns = -1 if column is assigned
C
C             ****************************************
         CALL LKYIN(1,LSPRGI,NLPRGI,NTOK,LINE,IBEG,IEND)
C             ****************************************
C
      ELSEIF (KEY .EQ. 'LABO') THEN
C
C LABOUT column assignments
C
C Save labout assignments for processing at the end of the input
C
         LABOUT_SAVE = LINE
C
      ELSEIF (KEY .EQ. 'RUN') THEN
C
C RUN command: stop reading i/p cards -- refine, then read more cards
         MOREIP = .TRUE.
         WRITE(6,FMT='(1X,A)')'* refine before reading any more cards'
         GOTO 1000
C
      ELSEIF (KEY .EQ. 'END') THEN
          MOREIP = .FALSE.
          WRITE(6,FMT='(1X,A)')'END of control cards --'
          GO TO 1000
C
      ENDIF
      GO TO 1
C
 1000 CONTINUE
C
      IF (NERR .GT. 0) THEN
         CALL CCPERR(1,'*** Syntax error in input ***')
      ENDIF
C
      IF(.NOT.SECOND)THEN
C
C Read input header stuff from hklin
C  Column assignments, set LOOKUP
         CALL LRASSN(1,LSPRGI,NLPRGI,LOOKUP,CTPRGI)
         NDATASETS = MSETS
         CALL LRIDX(1,PNAME,XNAME,DNAME,ISETS,
     +                     DATCELL,DATWAVE,NDATASETS)

C---- Get dataset IDs for columns and set up output IDs.
         IF (NDATASETS.GT.0) THEN
           CALL LRCLID(1,CSETID,IDUMMY)
           DO 18 I=1,5
C      H,K,L,FP,SIGFP have dataset of input FP
             CSETOUT(I)=CSETID(LOOKUP(1))
 18        CONTINUE
           DO 188 I=6,NLP1+2*NXPLCT1
C      Others have dataset of input FC1
             CSETOUT(I)=CSETID(LOOKUP(3))
 188       CONTINUE
         ENDIF
C  Default resolution limits
         IF (.NOT.LKRESO) THEN
            CALL LRRSOL(1,SMIN,SMAX)
            RESMIN = 10000
            RESMAX = 0.5
            IF (SMIN.GT.0.0) RESMIN = 1./SQRT(SMIN)
            IF (SMAX.GT.0.0) RESMAX = 1./SQRT(SMAX)
C            RESMIN = 1./SQRT(SMIN)
C            RESMAX = 1./SQRT(SMAX)
         ENDIF
         D1 = RESMIN
         D2 = RESMAX
C
C Check that FP & SIGFP are assigned
         IF (LOOKUP(1) .LE. 0 .OR. LOOKUP(2) .LE. 0) THEN
            WRITE (6, '(A)') ' *** FP & SIGFP must be assigned ***'
            CALL CCPERR(1, '*** Native F & SD not assigned ***')
         ENDIF
C Count number of FC from lookup table, also check both FC & PHIC assigned
C     for all pairs
         N = 0
         DO 100, I=3,NLPRGI,2
            IF (LOOKUP(I).GT.0) THEN
C   FCn is assigned, is PHICn?
               IF (LOOKUP(I+1) .LE. 0) THEN
C  No, error
                  NERR = NERR+1
               ELSE
C  OK, set number of FC's
                  N = N+1
                  NUMFC = N
C  Check that previous FC's have been assigned
                  IF (NUMFC .NE. (I-1)/2) THEN
                     WRITE (6, '(A,I2,A)')
     $                    ' *** FC',N,' was not assigned ***'
                     CALL CCPERR(1,'*** Missing FC assignment ***')
                  ENDIF
               ENDIF
            ELSEIF (LOOKUP(I+1) .GT. 0) THEN
C  PHICn assigned without FCn, also error
               NERR = NERR+1
            ENDIF
            IF (NERR .GT. 0) THEN
               WRITE (6,'(A)')
     $              ' *** Both FCn & PHICn must be assigned: ',
     $              N,' ***'
               CALL CCPERR(1,
     $              '*** Invalid combination of assignments ***')
            ENDIF
 100     CONTINUE
      ENDIF
C
C Set up output file
C
      IF (JOUT .GE. 0) THEN
C set o/p columns 5-6-92
         NCUSE= NLP1-JOUT
         IF(KOUT.NE.0)NCUSE=NCUSE+2*NUMFC
C remove internal unused labels
         DO 1777 I=NLP1-JOUT+1,NLPRGO-JOUT
C                  N= NLP1+1,NLPRGO
             N=I+JOUT
             LSPRGO(I)=LSPRGO(N)
             CTPRGO(I)=CTPRGO(N)
             IF (NDATASETS.GT.0) 
     +         CSETOUT(I)=CSETOUT(N)
1777    CONTINUE
C end set up o/p column labels 5-6-92   
         CALL LWOPEN(1,'HKLOUT')
C
C process output labels
C
         IF (LABOUT_SAVE.NE.' ') THEN
           LINE = LABOUT_SAVE
           CALL PARSER(KEY,LINE,IBEG,IEND,ITYP,FVALUE,CVALUE,IDEC,
     $                 NTOK,LEND,.TRUE.)
           CALL LKYOUT(1,LSPRGO,NLPRGO,NTOK,LINE,IBEG,IEND)
         ENDIF
C
         IAPPND = 0
         CALL LWASSN(1,LSPRGO,NCUSE,CTPRGO,IAPPND)

C Datasets carried across automatically - no need to call LWIDX
C But use LWIDASX to set column assignments.

         IF (NDATASETS.GT.0) THEN
           DO 115 JDO115 = 1,NCUSE
            SETID = CSETOUT(JDO115)
            DO ISET = 1,NDATASETS
              IF (ISETS(ISET).EQ.SETID) THEN
                XNAME_OUT(JDO115) = XNAME(ISET)
                DNAME_OUT(JDO115) = DNAME(ISET)
              END IF
            ENDDO
 115       CONTINUE

           CALL LWIDASX(1,NCUSE,XNAME_OUT,DNAME_OUT,IAPPND)
         ENDIF
C
C Optional title output
         IF (LKTITL) THEN
            CALL LWTITL(1,TITLE,0)
         ENDIF
         CALL LWHSTL (1, 'Fo,Fc')
      ENDIF
C	PRINT *,'LEAVING RDCOMD SECOND=',SECOND !DEBUG
      RETURN
C
C Syntax error
 900  NERR = NERR+1
      GO TO 1
      END

C - - - - - - - - - - - - - - - - - -- - - -
      SUBROUTINE WRTHKL(NPRT,HKL,ADATA,LOGMSS,JOUTX,WDF,COSA,SINA,
     1  W,FO,FC,SIG,NB,KOUT,OUTK,NUMFC,JOUT,KOBS,KSIG,KALPH,KFCAL)
C  !,KOUT,OUTK,NUMFC,JOUT 5-6-92
C      IMPLICIT NONE
      INTEGER MCOLS
      PARAMETER (MCOLS=500)
      INTEGER NPRT,JOUTX,NB,KOUT,NUMFC,JOUT,KOBS,KSIG,KALPH(9),KFCAL(9)
      REAL HKL(3),ADATA(MCOLS),WDF,COSA,SINA,W,FO,FC,SIG,OUTK(2,NUMFC)
      LOGICAL LOGMSS(MCOLS)
C
C JOUT= 2: FO,FC; =1 add W; =0 add WDF
C KOUT=1: add OUTK
C
      INTEGER I,N,J,ICHECK
      REAL BDATA(MCOLS),DUMMY
      SAVE

      CALL EQUAL_MAGIC(1,ADATA,MCOLS)

      DO 10 I=1,3
        ADATA(I) = HKL(I)
  10  CONTINUE

      IF (.NOT. LOGMSS(KOBS)) ADATA(JOUTX+1)=FO
      IF (.NOT. LOGMSS(KSIG)) ADATA(JOUTX+2)=SIG 
C
C---- Check consistancy of NaN assignments
C
      IF (LOGMSS(KOBS) .OR. LOGMSS(KSIG)) THEN
        IF (.NOT.(LOGMSS(KOBS) .AND. LOGMSS(KSIG))) WRITE(6,
     .  '('' *** Warning; either FP/SIGFP=NaN but other is not ***'')')
      ENDIF
C! 5-6-92; was =MAX(1.,(SIG))
C
C---- Write out combined FC and PHI unless all components are NaN
C     Assumed that if FC=NaN then PHI=NaN
C
      ICHECK = 0
      DO 20 I=1,NUMFC
        IF (KFCAL(I).NE.0) THEN
          IF (LOGMSS(KFCAL(I)) .OR. LOGMSS(KALPH(I))) THEN
            IF (.NOT.(LOGMSS(KFCAL(I)) .AND. LOGMSS(KALPH(I)))) WRITE(6,
     .  '('' *** Warning; either FCn/PHICn=NaN but other is not ***'')')
            ICHECK = ICHECK+1
          ENDIF
        ENDIF
  20  CONTINUE

      IF (ICHECK .NE. NUMFC) THEN
        ADATA(JOUTX+3)=FC
        ADATA(JOUTX+4)=((180/3.1415927)*ATAN2(SINA,COSA))
      ENDIF

      I=JOUTX+5
      IF(JOUT.LE.1)THEN
         IF (.NOT. LOGMSS(KOBS)) ADATA(I)=W
         I=I+1
       ENDIF
      IF(JOUT.EQ.0)THEN
         IF (.NOT. LOGMSS(KOBS)) ADATA(I)=WDF
         I=I+1
      ENDIF
      IF(KOUT.NE.0)THEN
         DO 1776 N=1,NUMFC
         DO 1776 J=1,2
             IF (.NOT. LOGMSS(KFCAL(N))) ADATA(I)=OUTK(J,N)
             I=I+1
1776     CONTINUE
      ENDIF

      CALL LWREFL(1,ADATA)

      NB=0 
      CALL RESET_MAGIC(1,ADATA,BDATA,MCOLS,DUMMY,-999.0)
      IF(NPRT.GE.0)WRITE(6,6000)(BDATA(I),I=1,JOUTX+4),W,WDF
6000      FORMAT(1X,'HKL,FO,SIG,FC,PHI,W,WDF=',3F4.0,11F8.0)
      RETURN

      END
