C
C     LSQKAB
C     Copyright (C) 1978 Wolfgang Kabsch, Eleanor Dodson
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C*************************************************************
C
C
C**************************************************************
C
C   August 2002 : NATOM increased to 40000, NRS increased to 13999
C
C   June 2000 : alterations to output OCC=0.0 atoms.  EJD
C               NRES increased to 6999.  EJD
C               Correction for Biso output.  EJD
c   May 1990 :  I have modified this to use the new libraries.  EJD
c   MOD: Now  the translation vector can be given as 
c                FRACTIONS OF THE WORKING CELL.  See writeup.

c    Ref: Kabsch W.(1978) Acta. Cryst. A32 922-923.

C   Keyworded and tidied up by EJD   28-2-1989
C
C  Keywords are:
c      DATA KEYWRD/'TITL','OUTP',        'RADI','ROTA',
c     +                                 'TRAN','FIT ',
c     +     'MATC','END '/
C  Some documentation available!!
C
C     .. Parameters ..
      INTEGER NATOM,NRS
      PARAMETER (NATOM=40000,NRS=13999)
C     ..
C     .. Scalars in Common ..
      REAL CENFLG,RADCHK
      INTEGER IPRRMS,IPRDEL,LSQOP,NFITAT,NFITRS,IDELTAS,IRMSTAB,
     +        IREF,IWORK,ILSQOP
      CHARACTER TITLE*80
C     ..
C     .. Arrays in Common ..
      REAL RCEN(3),TR(3),TRMAT(3,3),CELLW(6)
      INTEGER IATR1(25),IATR2(25),IATW1(25),IATW2(25),IRESR(NRS),
     +        IRESW(NRS),IRSCD(NRS),NRESR(NATOM),NRESW(NATOM)
      CHARACTER CHAINR(NRS)*1,CHAINW(NRS)*1,CHNNMR(NATOM)*1,
     +          CHNNMW(NATOM)*1,ATNMR(NATOM)*4,ATNMW(NATOM)*4,
     +          RESNMW(NATOM)*4,ALTCDW(NATOM)*1,ALTCDR(NATOM)*1,
     +          INSCDW(NATOM)*1,INSCDR(NATOM)*1
C     ..
C     .. Local Scalars ..
      REAL BISO,OCC,XR,XW,YR,YW,ZR,ZW,OCCRZ,OCCWZ
      INTEGER I,IRES,IOUT,IZZ,J,JRESR,
     +        NATOMS,NJUNK,NOP,NOUT,NR,NRW,NW
      CHARACTER RCHAIN*1,CHNNAM*1,ATNAM*4,RESNAM*4,RESNO*4,ID*4,
     +          INSCOD*1,ALTCOD*1,SEGID*4
C     ..
C     .. Local Arrays ..
      REAL RO(4,4),RF(4,4),RRR(3,3,6)
      REAL B(6),BW(6,NATOM),OCW(NATOM),R(3,NATOM),BRISO(NATOM),
     +       SCR(3),W(3,NATOM),BWISO(NATOM)
      INTEGER IW(NATOM)
      CHARACTER*2 IDW(NATOM)
C     ..
C     .. Needed to deal with TER cards.
      INTEGER COUNTTER, TOTALTER, MAXTER
      PARAMETER (MAXTER=2000)
      INTEGER TERAT(MAXTER)
C     ..
C     .. External Subroutines ..
      EXTERNAL ANGFIX,CCPFYP,CCPRCS,LSKAB,MTZINI,RBRORF,
     +         RCARDSLSQ,XYZADVANCE,XYZATOM,XYZCLOSE,
     +         XYZCOORD,XYZINIT, WREMARK
C     ..
C     .. Common blocks ..
      COMMON /DCS/ DCCXCY(3)
      COMMON /LSQCHR/CHAINR,CHAINW,TITLE
      COMMON /LSQCNTRL/TRMAT,TR,IPRRMS,IPRDEL,LSQOP,NFITAT,NFITRS,
     +       IATR1,IATR2,IATW1,IATW2,IRESR,IRESW,IRSCD,TRFRAC
      COMMON /NAMES1/RADCHK,CENFLG,RCEN,NRESW,NRESR,CELLW
      COMMON /NAMES2/ATNMW,RESNMW,CHNNMW,ATNMR,CHNNMR
      COMMON /UNIT1/ IWORK,IREF,ILSQOP,IRMSTAB,IDELTAS
C     ..
C     ..
C
C
      CALL CCPFYP 
      CALL MTZINI
      CALL XYZINIT
      NATOMS = NATOM
      NOUT = 6
      CALL CCPRCS(NOUT,'LSQKAB','$Date: 2008/04/10 08:58:37 $')
      CALL RCARDSLSQ
C
C     Initilaise TER info
      COUNTTER = 0
      TOTALTER = 0
      DO 5 I=1,MAXTER
        TERAT(I) = 0
 5    CONTINUE
      DO I=1,NATOM
        IW(I) = 0
      END DO
C
C---- lsqop 0 -1 - rotate input cordinates (workcd) only - no fitting..
C
      OCCRZ = 0
      OCCWZ = 0
      IF (LSQOP.NE.-1) THEN
C
C---- read reference coordinates convert to as
C     and store x y z resno and name
C
        NR = 0
        OCC = 0
   10   CONTINUE
        CALL XYZADVANCE(IREF,0,0,*20,*20)
        CALL XYZCOORD(IREF,'O','U',XR,YR,ZR,OCC,BISO,B)
        IF (OCC.EQ.0.0) THEN
          occrz = occrz + 1
C         GO TO 10
        ENDIF
C
C---- Check for ANISO card and skip
C
        IF (B(2).NE.0.0 .OR. B(3).NE.0.0) THEN
          IF (XR.EQ.0.0 .AND. YR.EQ.0.0 .AND. ZR.EQ.0.0) GOTO 10
        ENDIF

        CALL XYZATOM(IREF,NJUNK,ATNAM,RESNAM,CHNNAM,IRES,RESNO,
     +            INSCOD,ALTCOD,SEGID,IZ,ID)
        NR = NR + 1
        IF (NR.GE.NATOMS) WRITE (6,FMT=6002)
        IF (NR.LT.NATOMS) THEN
          R(1,NR) = XR
          R(2,NR) = YR
          R(3,NR) = ZR
          BRISO(NR) = BISO
          NRESR(NR) = IRES
          ATNMR(NR) = ATNAM
          CHNNMR(NR) = CHNNAM
          ALTCDR(NR) = ALTCOD
          INSCDR(NR) = INSCOD
          GO TO 10
        END IF
      END IF
C
C---- read working coordinates convert to as and
C     store x y z resno and name
C
   20 NRW = 0
      NW = 0
      RO(1,1) = 0.0
      RF(1,1) = 0.0
       IF(CELLW(1).LE.0.001)THEN
           CALL RBRORF(RO,RF)
       ELSE 
           write(6,'(A,3F10.3,3F8.3)')
     +     '  Working cell reset to:',cellw
           CALL  RBFRO1(CELLW,VOLL,RRR)
            RO(4,4) = 1.0
            DO JJ = 1,3
             RO(4,JJ) = 0.0
             RO(JJ,4) = 0.0
             DO II = 1,3
               RO(II,JJ) = RRR(II,JJ,1)
             END DO 
            END DO 
           CALL RBRINV(RO,RF)
       END IF
C
C---- Set output ILSQOP if lsqop ne 0.
C     this will ensure the crystl ans scale cards at the head of
C     the working coodinates will be copied to the output coordinates.
C
      IOUT = 0
      OCCWZ = 0
      IF (LSQOP.NE.0) IOUT = ILSQOP
   30 CONTINUE
      
      CALL XYZADVANCE(IWORK,IOUT,1,*135,*140)
      CALL XYZCOORD(IWORK,'O','B',XW,YW,ZW,OCC,BISO,B)
      IF (OCC.EQ.0.0) THEN
        occwz = occwz + 1
C       GO TO 30
      ENDIF

      CALL XYZATOM(IWORK,NJUNK,ATNAM,RESNAM,CHNNAM,IRES,RESNO,
     +              INSCOD,ALTCOD,SEGID,IZZ,ID)

CC   Save ALTCOD here
C        ATNAM = ATNAM(1:3)//ALTCOD
C   Find Aniso Bs
      IF (B(2).NE.0.0 .OR. B(3).NE.0.0) THEN
        IF (XW.EQ.0.0 .AND. YW.EQ.0.0 .AND. ZW.EQ.0.0) THEN
          IF (LSQOP .NE. 0) THEN
            DO 36 I=NW,1,-1
              IF (CHNNAM .EQ. CHNNMW(I)) THEN
                IF (IRES .EQ. NRESW(I)) THEN
C C.Vonrhein 20080220:
C                 make sure to not only check for identical ALTCOD but
C                 also for INSCOD
                  IF (ATNAM .EQ. ATNMW(I).AND.
     +                ALTCOD.EQ.ALTCDW(I).AND.
     +                INSCOD.EQ.INSCDW(I)     ) THEN
                    DO 34 J=1,6
                      BW(J,I) = B(J)
   34               CONTINUE
                    GOTO 30
                  ENDIF
                ENDIF
              ENDIF
   36       CONTINUE
            GOTO 30
          ELSE
            GOTO 30
          ENDIF
        ENDIF
      ENDIF

      NW = NW + 1
      IF (NW.GE.NATOMS) WRITE (6,FMT=6002)
      IF (NW.LT.NATOMS) THEN
        W(1,NW) = XW
        W(2,NW) = YW
        W(3,NW) = ZW
        BWISO(NW) = BISO
        NRESW(NW) = IRES
        ATNMW(NW) = ATNAM
        RESNMW(NW) = RESNAM
        CHNNMW(NW) = CHNNAM
        ALTCDW(NW) = ALTCOD
        INSCDW(NW) = INSCOD
        IW(NW) = 0
        DO 38 I=1,6
          BW(I,NW) = B(I)
   38   CONTINUE
        OCW(NW) = OCC
        IDW(NW) = ID(1:2)
C
C---- Find if this atom is used
C
cd      IF (NFITAT.NE.0) THEN
        IF ( OCC.EQ.0.0) GO TO 30
        IF (NFITAT.NE.0 .AND. OCC.NE.0.0) THEN
          DO 40 I = 1,NFITAT
            IF (NW.EQ.IATW2(I) .OR. NW.EQ.IATW1(I)) THEN
              GO TO 50
            ELSE IF (NW.LE.IATW2(I) .AND. NW.GE.IATW1(I)) THEN
              GO TO 50
            END IF
   40     CONTINUE
C
          GO TO 60
   50     NRW = NRW + 1
          IW(NW) = 1
          IF (LSQOP.NE.-1) IW(NW) = NW - IATW1(I) + IATR1(I)
          GO TO 30
        END IF
C
   60   IF (NFITRS.EQ.0) THEN
          GO TO 30
        ELSE
          DO 90 I = 1,NFITRS
            IF (CHNNAM.EQ.CHAINW(I) .OR. CHAINW(I).EQ.' ') THEN
              IF (IRES.EQ.IRESW(I)) THEN
                JRESR = IRESR(I)
                RCHAIN = CHAINR(I)
                GO TO (70,70,80,100) IRSCD(I)
C
C---- Irscd 1- ca only;  2 - main chain; 3- side chain only;4- all
C
   70           IF (ATNAM.EQ.'CA  '.OR. ATNAM.EQ.'CA A') THEN
                  GO TO 100
                ELSE IF (IRSCD(I).EQ.1) THEN
                  GO TO 90
                ELSE IF (ATNAM.EQ.'C   ' .OR. ATNAM.EQ.'O   ' .OR.
     +                   ATNAM.EQ.'N   ' .OR. ATNAM.EQ.'C  A' .OR.
     +                   ATNAM.EQ.'O  A' .OR. ATNAM.EQ.'N  A')THEN
                  GO TO 100
                ELSE
                  GO TO 90
                END IF
   80             IF (ATNAM(1:3).NE.'CA '.AND.ATNAM(1:3).NE.'C  '.AND.
     +              ATNAM(1:3).NE.'O  '.AND.ATNAM(1:3).NE.'N  ')
     +            GO TO 100
              END IF
            END IF
   90     CONTINUE
C
          GO TO 30
C
C---- We want this atom - now find its match in ref set.
C
  100     IW(NW) = 1
          IF (LSQOP.NE.-1) THEN
            IW(NW) = 0
            DO 110 I = 1,NR
              IF (CHNNMR(I).EQ.RCHAIN .OR. RCHAIN.EQ.' ') THEN
                IF (NRESR(I).EQ.JRESR) THEN
C C.Vonrhein 20080220:
C                 make sure to not only check for identical ALTCOD but
C                 also for INSCOD
                  IF (ATNAM(1:4) .EQ.ATNMR(I)(1:4) .AND.
     +                ALTCOD.EQ.ALTCDR(I).AND.
     +                INSCOD.EQ.INSCDR(I)     ) GO TO 120
                END IF
              END IF
  110       CONTINUE
            GO TO 130
  120       IW(NW) = I
            NRW = NRW + 1
C
  130       IF (IW(NW).EQ.0) WRITE (6,FMT=6006) IRES,ATNAM,CHNNAM
          END IF
          GO TO 30
        END IF
      END IF
      GOTO 140
C
C     Section to deal with ter card - bit sloppy I know
C
 135  CONTINUE
      COUNTTER = COUNTTER + 1
      TOTALTER = COUNTTER
      IF (TOTALTER.GE.MAXTER) 
     +    CALL CCPERR(1, 'Too many TER cards. Increase MAXTER')
      TERAT(COUNTTER) = NW + 1
      GOTO 30
C
C---- Write out arrays to check
C
C---- Write out arrays to check
C
  140   CONTINUE
C     Reset countter
        IF (TOTALTER.GT.0) COUNTTER = 1
        ELSE COUNTTER = 0

        Write (6,'(2(/,a,f9.1))')
     1 '  **  ZERO OCCUPANCIES IN WORKING   SET **',occwz,
     1 '  **  ZERO OCCUPANCIES IN REFERENCE SET **',occrz


        IF (LSQOP.EQ.-1) THEN
C
C---- Come here to rotate workcds by a previously obtained matrix
C
c   Was the translation given in fractional units?
            IF(TRFRAC .NE.0.0) THEN
            TR1 = TR(1)
            TR2 = TR(2)
            TR3 = TR(3)
            TR(1) = RO(1,1)*TR1 +RO(1,2)*TR2 +  RO(1,3)*TR3 + RO(1,4) 
            TR(2) = RO(2,1)*TR1 +RO(2,2)*TR2 +  RO(2,3)*TR3 + RO(2,4) 
            TR(3) = RO(3,1)*TR1 +RO(3,2)*TR2 +  RO(3,3)*TR3 + RO(3,4) 
              Write(6,'(A,3F8.3,/,A,3(/,3F8.3))')
     +      ' Orthogonal translation is:',TR,
     +      ' Orthogonalising matrix from PDB is:',
     +      ((RO(I,J),J=1,3),I=1,3)
            END IF
             
c   Was the translation given in orthogonal units?
            IF(TRFRAC .EQ.0.0) THEN
            TR1 = TR(1)
            TR2 = TR(2)
            TR3 = TR(3)
            TR(1) = RF(1,1)*TR1 +RF(1,2)*TR2 +  RF(1,3)*TR3 + RF(1,4) 
            TR(2) = RF(2,1)*TR1 +RF(2,2)*TR2 +  RF(2,3)*TR3 + RF(2,4) 
            TR(3) = RF(3,1)*TR1 +RF(3,2)*TR2 +  RF(3,3)*TR3 + RF(3,4) 
              Write(6,'(A,3F8.3,/,A,3(/,3F8.3))')
     +      ' Fractional translation is:',TR,
     +      ' Fractionalising matrix from PDB is:',
     +      ((RF(I,J),J=1,3),I=1,3)
            TR(1) = TR1
            TR(2) = TR2
            TR(3) = TR3
            END IF
             
        DO 160 I = 1,NW
            DO 150 J = 1,3
            SCR(J) = TRMAT(J,1)*W(1,I) + TRMAT(J,2)*W(2,I) +
     +                 TRMAT(J,3)*W(3,I) + TR(J)
  150       CONTINUE
            W(1,I) = SCR(1)
            W(2,I) = SCR(2)
            W(3,I) = SCR(3)
  160   CONTINUE
C---- No need to call LSKAB if using previously obtained matrix
      GO TO 168
          END IF
c
C---- Work out rotation etc
165   CONTINUE
      IF (NRW.EQ.0) THEN
        CALL CCPERR(1, 
     +'*** ERROR - YOU HAVE FAILED TO FIND ANY ATOMS TO FIT ***')
      END IF
        CALL LSKAB(W,R,NW,NR,NRW,IW,TRMAT,TR,NATOMS,
     +             LSQOP,IPRRMS,IPRDEL,RO,RF,BWISO,BRISO)
        CALL ANGFIX(TRMAT)

        IF (LSQOP.EQ.0) GO TO 180
          WRITE (6,FMT=6008) TR
            TR1 = TR(1)
            TR2 = TR(2)
            TR3 = TR(3)
           SCR(1) = RF(1,1)*TR1 +RF(1,2)*TR2 +  RF(1,3)*TR3 + RF(1,4) 
           SCR(2) = RF(2,1)*TR1 +RF(2,2)*TR2 +  RF(2,3)*TR3 + RF(2,4) 
           SCR(3) = RF(3,1)*TR1 +RF(3,2)*TR2 +  RF(3,3)*TR3 + RF(3,4) 
          WRITE (6,FMT=6009) SCR

C---- OUTPUT LSQOP COORDINATE FILE
168   CONTINUE
      NOP = 0

      SEGID = ' '
      INSCOD = ' '
      ALTCOD = ' '
      RESNO = ' '
      IZZ = 0
      BISO = 0.0
      DO 170 I = 1,NW
          NOP = NOP + 1
          DO 175 J=1,6
            B(J) = BW(J,I)
  175     CONTINUE
            BISO = BWISO(I)
          IF (TOTALTER.GT.0 .AND. COUNTTER.LE.TOTALTER) THEN
            IF (I.EQ.TERAT(COUNTTER)) THEN
              CALL WREMARK(ILSQOP,'TER')
              COUNTTER = COUNTTER + 1
            ENDIF
          ENDIF
          CALL XYZATOM(ILSQOP,I,ATNMW(I),RESNMW(I),CHNNMW(I),
     +           NRESW(I),RESNO,INSCDW(I),ALTCDW(I),SEGID,IZZ,IDW(I))
          CALL XYZCOORD(ILSQOP,'O','B',W(1,I),W(2,I),W(3,I),
     +                                        OCW(I),BISO,B)
          CALL XYZADVANCE(ILSQOP,0,0,*170,*170)

  170 CONTINUE
      WRITE (6,FMT=6012) NOP
C
C---- Print out deltas between two files w/out rotation etc
C
  180 IF (IREF .NE. 0) CALL XYZCLOSE(IREF)
      IF (IWORK .NE. 0) CALL XYZCLOSE(IWORK)
      IF (ILSQOP .NE. 0) CALL XYZCLOSE(ILSQOP)
      IF (IRMSTAB .NE. 0) THEN
              WRITE(IRMSTAB,*)'$$'
              CLOSE(UNIT=IRMSTAB,STATUS='KEEP')
      END IF 
      IF (IDELTAS .NE. 0) CLOSE(UNIT=IDELTAS,STATUS='KEEP')
      CALL CCPERR(0,' Normal Termination')
 6000 FORMAT (5X,3F10.5,20X,I10,2 (A4,1X))
 6002 FORMAT ('  TOO MANY ATOMS INPUT - INCREASE ARRAY SIZES ')
 6004 FORMAT (5X,4F10.5,F5.2,I5,I10,A4,1X,A4,1X,A1)
 6006 FORMAT ('   - NO MATCH FOR WORKCD ATOM - ',I5,A4,A1,' IN REFRCD ',
     +       'FILE')
 6008 FORMAT (////,'  THE TRANSLATION VECTOR IN ANGSTROMS ALONG THE   ',
     +       '     ORTHONORMAL AXES IS',/,3F12.5)
 6009 FORMAT (////,'  THE TRANSLATION VECTOR IN FRACTIONS of the CELL ',
     +       ' EDGE IS',/,3F12.6)
 6010 FORMAT (I5,4F10.5,F5.2,I5,I10,2A5)
 6012 FORMAT (//,I10,' ATOMS WRITTEN TO "LSQOP" ')
      END

C
C
      SUBROUTINE ANGFIX(TRMAT)
C     ========================
C
C---- This s/r works out various rotation angles corresponding
C     to a given rotation matrix.
C     It could easily be extended to give other sets.
C
C
C     .. Array Arguments ..
      REAL TRMAT(3,3)
C     ..
C     .. Local Scalars ..
      REAL CHI,CHK,CONV,COSCHI,OMEGA,PHI,R13,R23,R31,R32,SINCHI,SOMEGA,
     +     THETA1,THETA2,THETA3,TRACE
      INTEGER I,J
C     ..
C     .. Local Arrays ..
      REAL DC(5)
      COMMON /DCS/ DCCXCY(3)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ACOS,ATAN2,SIGN,SQRT
C     ..
      WRITE (6,FMT=6000) ((TRMAT(I,J),J=1,3),I=1,3)
      CONV = 180.0/3.14159
      WRITE (6,FMT=6002)
      WRITE (6,FMT=6004)
      THETA1 = 0.0
      THETA2 = 0.0
      THETA3 = 0.0
      CHI = 0.0
      DC(1) = 0.0
      DC(2) = 0.0
      DC(3) = 0.0
      OMEGA = 0.0
      PHI = 0.0
      TRACE = TRMAT(1,1) + TRMAT(2,2) + TRMAT(3,3)
C  Check for identity matrix 
       write(6,*) ' trace', trace
      IF (TRACE.GT.2.99999) THEN
        WRITE(6,'(//,a)') 
     + ' No Rotation - Equivalent to ALPHA=BETA=GAMMA=CHI=0.0'
      RETURN
      END IF 
C
C      IF (TRACE.LT.3.00000) THEN
        IF (TRMAT(3,3).LE.1.00000) THEN
          IF (TRMAT(3,3).GE.-1.0000) THEN
            THETA2 = ACOS(TRMAT(3,3))*CONV
C
            R13 = TRMAT(1,3)
            R23 = TRMAT(2,3)
            R31 = TRMAT(3,1)
            R32 = TRMAT(3,2)
            IF (R23.LT.0.0) THEN
              R13 = -R13
              R23 = -R23
              R31 = -R31
              R32 = -R32
              THETA2 = -THETA2
            END IF
            THETA3 = ATAN2(R32,-R31)*CONV
            THETA1 = ATAN2(R23,R13)*CONV
C
C---- Spherical polars ref patterson int tab vol2 p59
C
            CHI = 0.0
            DC(1) = 0.0
            DC(2) = 0.0
            DC(3) = 0.0
            OMEGA = 0.0
            PHI = 0.0
            COSCHI = TRACE/2.0 - 0.5
            SINCHI = SQRT(ABS(1.0-COSCHI*COSCHI))
            CHI = ATAN2(SINCHI,COSCHI)*CONV
            CHK = ABS(CHI)
            IF (CHK.GT.179.5) THEN
              GO TO 10
            ELSE
              DC(1) = (TRMAT(3,2)-TRMAT(2,3))/ (2.0*SINCHI)
              DC(2) = (TRMAT(1,3)-TRMAT(3,1))/ (2.0*SINCHI)
              DC(3) = (TRMAT(2,1)-TRMAT(1,2))/ (2.0*SINCHI)
              CHK = DC(1)**2 + DC(2)**2 + DC(3)**2
             write(6,*) ' not 10- dc(1),dc(2),dc(3),chk', 
     +                        dc(1),dc(2),dc(3),chk
              IF (CHK.GT.0.8) THEN
                GO TO 20
              ELSE
                GO TO 10
              END IF
            END IF
          END IF
        END IF
C
C---- Beta =0 or 180  can only find alpha + or - gamma.
C
        THETA2 = 0.0
        IF (TRMAT(3,3).LT.0.0) THETA2 = 180.0
        THETA3 = ATAN2(TRMAT(2,1),TRMAT(2,2))*CONV
        THETA1 = 0.0
        IF (THETA2.EQ.0) CHI = THETA3
        IF (THETA2.EQ.180.0) CHI = 180.0
C
C---- Special case: pure rotation around Z-axis
C     In this case Beta (=Theta2) is either 0 or 180,
C     Alpha (=Theta1) is zero, and Gamma is any value
C     between 0 and 180deg.
C     i.e. the rotation axis is parallel to the Z-axis
        DC(1) = 0.0
        DC(2) = 0.0
        IF (THETA2.EQ.0.0) THEN
          DC(3) = 1.0
        ELSE
          DC(3) = -1.0
        ENDIF
        GOTO 20
C
C---- IF CHI =180  COSCHI=-1,SINCHI=0
C
   10   DC(1) = SQRT(ABS(TRMAT(1,1)*0.5+0.5))
        DC(2) = SQRT(ABS(TRMAT(2,2)*0.5+0.5))
        DC(3) = SQRT(ABS(TRMAT(3,3)*0.5+0.5))
C
C---- Assume dc(1) positive
C
        IF (DC(1).NE.0.0) THEN
          IF (DC(2).NE.0.0) DC(2) = DC(2)*SIGN(1.0,TRMAT(1,2))
          IF (DC(3).NE.0.0) DC(3) = DC(3)*SIGN(1.0,TRMAT(1,3))
        ELSE IF (DC(2).NE.0.0) THEN
          IF (DC(3).NE.0.0) DC(3) = SIGN(1.0,TRMAT(2,3))*DC(3)
        END IF
   20   DC(4) = DC(1)
        DC(5) = DC(2)
C
        SOMEGA = SQRT(ABS(1.0-DC(3)*DC(3)))
        OMEGA = ATAN2(SOMEGA,DC(3))*CONV
        CHK = DC(2)*DC(2) + DC(1)*DC(1)
        PHI = 0.0
        IF (CHK.GT.0.0) PHI = CONV*ATAN2(DC(2),DC(1))
C      END IF
      WRITE (6,FMT=6006) THETA1,THETA2,THETA3,OMEGA,PHI,CHI,
     +  (DC(I),I=1,3)
       ROTCHK = DC(1)*DCCXCY(1) + DC(2)*DCCXCY(2) + DC(3)*DCCXCY(3)
       PHI = ACOS(ROTCHK)*CONV
       WRITE(6,6008) PHI
       IF( ABS(PHI-90.0) .LT. 5.0) 
     + WRITE(6,'(//,A,A,A)')
     +  ' ***** Note: Since this angle between rotation axis and ',
     +  'Centroid vector is  near to 90.0 this may represent a ',
     +  'pure rotation *** '
C
 6000 FORMAT (//'  ROTATION MATRIX ',3 (/3F10.3))
 6002 FORMAT (////'  PATTERSON SPHERICAL POLARS OMEGA PHI CHI  OMEGA T',
     +       'O AXIS ZO    PHI FROM AXIS  XO  TO AXIS  YO ')
 6004 FORMAT (/' WHEN BETA=0 CAN ONLY DEFINE ALPHA + GAMMA .',/' WHEN ',
     +       'BETA = 180 CAN ONLY DEFINE GAMMA - ALPHA.')
 6006 FORMAT (/' CROWTHER (Euler) ALPHA BETA GAMMA ',3F12.5,
     + /'  SPHERICAL POLARS OMEGA PHI CHI ',3F12.5,
     + /'  DIRECTION COSINES OF ROTATION AXIS ',3F12.5)
 6008 FORMAT (/' Angle between rotation axis and Centroid vector',F12.5)
      END
C
C
      SUBROUTINE LSKAB(X,Y,NX,NY,NRX,IX,TRMAT,TR,NATOMS,
     +             LSQOP,IPRRMS,IPRDEL,RO,RF,BWISO,BRISO)
C     =========================================================
C
C    total no. atoms in working molecule.
C     NY     total no. atoms in reference molecule.
C     X      contains the nx coord. of the working molecule.
C     Y      contains the ny coord. of the reference molecule.
C     NX     the number of atoms to be used to generate the rotation
C            matrix
C     NCY    the number of cycles to be performed.
C     SHFT   the maximum atomic displacement from the ref. molecule
C            which is acceptable.
C     IX(i) =0; the i(th) atom of working molecule will not be included
C               in the refinement;
C           =ii; the i(th) atom of the working molecule will be refined
C               to the position of the ii(th) atom of the ref. molecule.
C
C
C
C
C---- Check value set here
C
C     .. Parameters ..
      INTEGER NATOM,NRS
      PARAMETER (NATOM=40000,NRS=13999)
C     ..
C     .. Scalar Arguments ..
      INTEGER IPRRMS,IPRDEL,NATOMS,NRX,NX,NY
C     ..
C     .. Array Arguments ..
      REAL RF(4,4),RO(4,4),TR(3),TRMAT(3,3),X(3,NATOMS),Y(3,NATOMS),
     +     BWISO(NATOMS),BRISO(NATOMS)
      INTEGER IX(NATOMS)
C     ..
C     .. Scalars in Common ..
      REAL CENFLG,RADCHK
      INTEGER ILSQOP,IREF,IWORK,IRMSTAB,IDELTAS
C     ..
C     .. Arrays in Common ..
      REAL RCEN(3),CELLW(6)
      INTEGER NRESR(NATOM),NRESW(NATOM)
      CHARACTER CHNNMR(NATOM)*1,CHNNMW(NATOM)*1,ATNMR(NATOM)*4,
     +          ATNMW(NATOM)*4,RESNMW(NATOM)*4,RESNM0*4,CHNNM0*1
C     ..
C     .. Local Scalars ..
      REAL D,DCENTR,DCHK,DISMAX,DRMS,EZERO,RMSMC,RMSSC,SUMD2,
     +     SUMDIS,TR1,TR2,TR3
      INTEGER I,IA,II,J,JRES,K,NATMC,NATSC,NOUT,NRAD,NRES0
C     ..
C     .. Local Arrays ..
      REAL CNTRX(3),CNTRY(3),SCR(3),XT(3),SCR1(3)
      DOUBLE PRECISION EE(6),RKTRK(3,3),RK(3,3),VP(3,3),RA(3,3),
     +     XNORM(3),RANR(3,3),TRMM(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL EIGEN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,MAX,SQRT
C     ..
C     .. Common blocks ..
      REAL DCCXCY
      COMMON /NAMES1/RADCHK,CENFLG,RCEN,NRESW,NRESR,CELLW
      COMMON /NAMES2/ATNMW,RESNMW,CHNNMW,ATNMR,CHNNMR
      COMMON /UNIT1/ IWORK,IREF,ILSQOP,IRMSTAB,IDELTAS
      COMMON /DCS/ DCCXCY(3)
C     ..
      DCHK = 9.0
      NOUT = 6
      WRITE (NOUT,FMT=6016) NX,NRX,NY
C
C---- Calculate centroids
C
      DISMAX = 0.0
      SUMB  = 0.0
      SUMB2 = 0.0
      SUMD2 = 0.0
      SUMDIS = 0.0
      DO 20 I = 1,3
        DCCXCY(I) = 0.0
        CNTRX(I) = 0.0
        CNTRY(I) = 0.0
        DO 10 J = 1,3
          TRMM(J,I) = 0.0d0
          TRMAT(J,I) = 0.0
   10   CONTINUE
   20 CONTINUE
      TRMAT(1,1) = 1.0
      TRMAT(2,2) = 1.0
      TRMAT(3,3) = 1.0
      TRMM(1,1) = 1.0d0
      TRMM(2,2) = 1.0d0
      TRMM(3,3) = 1.0d0
      IF (LSQOP.GE.0) THEN
        DO 50 I = 1,NX
          IF (IX(I).NE.0) THEN
            II = IX(I)
C
C---- Working molecule centroid
C
            DO 30 J = 1,3
              CNTRX(J) = CNTRX(J) + X(J,I)
   30       CONTINUE
C
C---- Reference molecule centroid
C
            DO 40 J = 1,3
              CNTRY(J) = CNTRY(J) + Y(J,II)
   40       CONTINUE
          END IF
   50   CONTINUE
C  Get Direction cosines of vector between centroids to check for pure rotation.
        DCCXCYSQ = 0.0
        DO 60 J = 1,3
          CNTRX(J) = CNTRX(J)/NRX
          CNTRY(J) = CNTRY(J)/NRX
          DCCXCY(J) = CNTRX(J) - CNTRY(J) 
          DCCXCYSQ = DCCXCYSQ + DCCXCY(J)*DCCXCY(J)
          IF (CENFLG.NE.0.0) RCEN(J) = CNTRY(J) - RCEN(J)
   60   CONTINUE
C  Get centroids in fractional coordinates too
           SCR(1) = RF(1,1)*CNTRX(1) +RF(1,2)*CNTRX(2) +
     +              RF(1,3)*CNTRX(3) + RF(1,4)
           SCR(2) = RF(2,1)*CNTRX(1) +RF(2,2)*CNTRX(2) + 
     +              RF(2,3)*CNTRX(3) + RF(2,4)
           SCR(3) = RF(3,1)*CNTRX(1) +RF(3,2)*CNTRX(2) +
     +              RF(3,3)*CNTRX(3) + RF(3,4)
           SCR1(1) = RF(1,1)*CNTRY(1) +RF(1,2)*CNTRY(2) +
     +               RF(1,3)*CNTRY(3) + RF(1,4)
           SCR1(2) = RF(2,1)*CNTRY(1) +RF(2,2)*CNTRY(2) + 
     +               RF(2,3)*CNTRY(3) + RF(2,4)
           SCR1(3) = RF(3,1)*CNTRY(1) +RF(3,2)*CNTRY(2) +
     +               RF(3,3)*CNTRY(3) + RF(3,4)
C  If the centroids are identical then DCCXCYSQ will be zero
C  so trap for this:
        IF (DCCXCYSQ .GT. 0.0) THEN
          DCCXCYSQ = SQRT(DCCXCYSQ)
          DCCXCY(1) = DCCXCY(1)/DCCXCYSQ
          DCCXCY(2) = DCCXCY(2)/DCCXCYSQ
          DCCXCY(3) = DCCXCY(3)/DCCXCYSQ
        ELSE
          DCCXCY(1) = 0.0
          DCCXCY(2) = 0.0
          DCCXCY(3) = 0.0
          CALL CCPERR (2,
     1     'Centroids of working and reference molecules are identical')
        END IF
        WRITE (NOUT,FMT=6010) CNTRX,SCR,CNTRY,SCR1,DCCXCYSQ,DCCXCY
        DO 80 I = 1,NX
C
C---- Translate working molecule to origin
C
          DO 70 J = 1,3
            X(J,I) = X(J,I) - CNTRX(J)
   70     CONTINUE
   80   CONTINUE
C
C---- Translate reference molecule to origin
C
        DO 100 I = 1,NY
          DO 90 J = 1,3
            Y(J,I) = Y(J,I) - CNTRY(J)
   90     CONTINUE
  100   CONTINUE
C
C---- Get matrix r = sum(y.x)
C
        DO 120 I = 1,3
          DO 110 J = 1,3
            RK(I,J) = 0.0d0
  110     CONTINUE
  120   CONTINUE
        NRAD = 0
        DO 150 IA = 1,NX
          IF (IX(IA).NE.0) THEN
            II = IX(IA)
C
C---- Insert radius check
C
            IF (RADCHK.NE.0.0) THEN
              DCENTR = (Y(1,II)+RCEN(1))**2 + (Y(2,II)+RCEN(2))**2 +
     +                 (Y(3,II)+RCEN(3))**2
              IF (DCENTR.GT.RADCHK) THEN
                NRAD = NRAD + 1
                IX(IA) = 0
                GO TO 150
              END IF
            END IF
            DO 140 I = 1,3
              DO 130 J = 1,3
                RK(I,J) = DBLE(Y(I,II)*X(J,IA)) + RK(I,J)
  130         CONTINUE
  140       CONTINUE
          END IF
  150   CONTINUE
        WRITE (6,FMT=6000) NRAD
        IF(NRAD.GE.NRX) CALL CCPERR(1,' No atoms left to fit')
C
C---- Ezero value
C
        EZERO = 0.0
        DO 170 IA = 1,NX
          IF (IX(IA).GT.0) THEN
            II = IX(IA)
            DO 160 I = 1,3
              EZERO = X(I,IA)**2 + EZERO + Y(I,II)**2
  160       CONTINUE
          END IF
  170   CONTINUE
        EZERO = EZERO*0.5
C
C---- Get rktrk  =  rktranspsed  *  rk
C
        DO 200 I = 1,3
          DO 190 J = 1,3
            RKTRK(I,J) = 0.0
            DO 180 K = 1,3
              RKTRK(I,J) = RK(K,I)*RK(K,J) + RKTRK(I,J)
  180       CONTINUE
  190     CONTINUE
  200   CONTINUE
        EE(1) = RKTRK(1,1)
        EE(2) = RKTRK(1,2)
        EE(3) = RKTRK(2,2)
        EE(4) = RKTRK(1,3)
        EE(5) = RKTRK(2,3)
        EE(6) = RKTRK(3,3)
C
C---- Call nag routine :  eigenvalues in  r
C                      :  eigenvectors normalized in vp
C                           (sorted in ascending order)
C                           (e   working array)
C
C---- Rreplace with eigen from prjang
C
        CALL EIGEN(EE,VP,3,0)
C
C---- Set vp(.1)=vp(.,3) x vp(.,2)
C
        VP(1,1) = VP(2,3)*VP(3,2) - VP(3,3)*VP(2,2)
        VP(2,1) = VP(3,3)*VP(1,2) - VP(1,3)*VP(3,2)
        VP(3,1) = VP(1,3)*VP(2,2) - VP(2,3)*VP(1,2)
C
C---- Get  ra = r . v
C
        DO 230 K = 1,3
          DO 220 I = 1,3
            RA(I,K) = 0.0d0
            DO 210 J = 1,3
              RA(I,K) = RK(I,J)*VP(J,K) + RA(I,K)
  210       CONTINUE
  220     CONTINUE
  230   CONTINUE
C
C---- Norm.   ra(.,2) & ra(.3)
C
        DO 250 J = 1,3
          XNORM(J) = 0.0d0
          DO 240 I = 1,3
            XNORM(J) = RA(I,J)**2 + XNORM(J)
  240     CONTINUE
          XNORM(J) = 1.0d0/SQRT(XNORM(J))
  250   CONTINUE
        DO 270 J = 1,3
          DO 260 I = 1,3
            RANR(I,J) = RA(I,J)*XNORM(J)
  260     CONTINUE
  270   CONTINUE
C
C---- Set ranr(.,1) = ranr(.,3) x ranr(.,2)
C
        RANR(1,3) = RANR(2,2)*RANR(3,1) - RANR(3,2)*RANR(2,1)
        RANR(2,3) = RANR(3,2)*RANR(1,1) - RANR(1,2)*RANR(3,1)
        RANR(3,3) = RANR(1,2)*RANR(2,1) - RANR(2,2)*RANR(1,1)
C
C---- Transformation matrix
C
        DO 310 I = 1,3
          DO 300 J = 1,3
            TRMM(I,J) = 0.0d0
            DO 290 K = 1,3
              TRMM(I,J) = RANR(I,K)*VP(J,K) + TRMM(I,J)
  290       CONTINUE
            TRMAT(I,J) =  REAL(TRMM(I,J))
  300     CONTINUE
  310   CONTINUE
      END IF
C
C---- Calculate residuals & figures of merit
C
      DO 360 IA = 1,NX
        DO 330 I = 1,3
          XT(I) = 0.0
          DO 320 J = 1,3
            XT(I) = REAL(TRMM(I,J))*X(J,IA) + XT(I)
  320     CONTINUE
  330   CONTINUE
        DO 340 I = 1,3
          X(I,IA) = XT(I)
  340   CONTINUE
        IF (IX(IA).GT.0) THEN
          II = IX(IA)
          D = 0.0
          DO 350 J = 1,3
            D = (X(J,IA)-Y(J,II))**2 + D
  350     CONTINUE
          SUMB  = SUMB  + (BWISO(IA) - BRISO(II))
          SUMB2 = SUMB2 + (BWISO(IA) - BRISO(II))**2
          SUMD2 = SUMD2 + D
          D = SQRT(D)
          SUMDIS = SUMDIS + D
          DISMAX = MAX(DISMAX,D)
        END IF
  360 CONTINUE
      BRMS = SQRT(SUMB2/(NRX -NRAD))
      DRMS = SQRT(SUMD2/(NRX -NRAD))
      BAVE = SUMB/(NRX - NRAD)
      SUMDIS = SUMDIS/(NRX - NRAD)
      WRITE (NOUT,FMT=6012) BRMS,BAVE,DRMS,SUMDIS,DISMAX
C
C
      DO 380 I = 1,NX
C
C---- Add reference molecule centroid to working molecule
C     coords.
C
        DO 370 J = 1,3
          X(J,I) = X(J,I) + CNTRY(J)
  370   CONTINUE
  380 CONTINUE
C
C---- Shift reference molecule to original position
C
      DO 400 II = 1,NY
        DO 390 J = 1,3
          Y(J,II) = Y(J,II) + CNTRY(J)
  390   CONTINUE
  400 CONTINUE
C
C---- Find translation` t = -trmat * ctrx   +cntry
C
      TR(1) = -TRMAT(1,1)*CNTRX(1) - TRMAT(1,2)*CNTRX(2) -
     +        TRMAT(1,3)*CNTRX(3) + CNTRY(1)
      TR(2) = -TRMAT(2,1)*CNTRX(1) - TRMAT(2,2)*CNTRX(2) -
     +        TRMAT(2,3)*CNTRX(3) + CNTRY(2)
      TR(3) = -TRMAT(3,1)*CNTRX(1) - TRMAT(3,2)*CNTRX(2) -
     +        TRMAT(3,3)*CNTRX(3) + CNTRY(3)
C
            TR1 = TR(1)
            TR2 = TR(2)
            TR3 = TR(3)
           SCR(1) = RF(1,1)*TR1 +RF(1,2)*TR2 +  RF(1,3)*TR3 + RF(1,4) 
           SCR(2) = RF(2,1)*TR1 +RF(2,2)*TR2 +  RF(2,3)*TR3 + RF(2,4) 
           SCR(3) = RF(3,1)*TR1 +RF(3,2)*TR2 +  RF(3,3)*TR3 + RF(3,4) 
C
      WRITE (NOUT,FMT=6014) ((TRMAT(J,K),K=1,3),J=1,3), (TR(J),J=1,3)
      WRITE(NOUT,FMT=6015)SCR
      IF (IPRRMS.EQ.1 .OR. IPRDEL.EQ.2) THEN
        WRITE (6,FMT=6002)
        RMSMC = 0.0
        RMSSC = 0.0
        NATSC = 0
        NATMC = 0
        NRES0 = 9999
        JRES = 0

        DO 420 I = 1,NX
          II = IX(I)
          IF (II.GT.0) THEN
            D = 0.0
            DO 410 J = 1,3
              D = (X(J,I)-Y(J,II))**2 + D
  410       CONTINUE
            D = SQRT(D)
            Bdiff = ABS(BWISO(I) - BRISO(II))
C
C---- Get rms error for main chain and side chain for histogram plot
C
            IF (NRESW(I).NE.NRES0 ) THEN
              IF (NATMC.NE.0 .OR. NATSC.NE.0) THEN
                IF (NATMC.NE.0) RMSMC = SQRT(RMSMC/NATMC)
                IF (NATSC.NE.0) RMSSC = SQRT(RMSSC/NATSC)
                JRES = JRES + 1
                IF(IPRRMS.EQ.1) WRITE (IRMSTAB,FMT=6004) JRES,RMSMC,
     +            RMSSC,NRES0,RESNM0,CHNNM0
                RMSMC = 0.0
                RMSSC = 0.0
                NATSC = 0
                NATMC = 0
              END IF
              NRES0 = NRESW(I)
              RESNM0 = RESNMW(I)
              CHNNM0 = CHNNMW(I)
            END IF
C
            IF (ATNMW(I)(1:3).EQ.'CA ' .OR. ATNMW(I)(1:3).EQ.'N  ' .OR.
     +          ATNMW(I)(1:3).EQ.'C  ' .OR. ATNMW(I)(1:3).EQ.'O  ' .OR.
     +          ATNMW(I)(1:3).EQ.'P  ' .OR. ATNMW(I)(1:3).EQ.'O1P' .OR.
     +          ATNMW(I)(1:3).EQ.'O2P' .OR. ATNMW(I)(1:3).EQ.'O5*' .OR.
     +          ATNMW(I)(1:3).EQ.'C5*' .OR. ATNMW(I)(1:3).EQ.'C4*' .OR.
     +          ATNMW(I)(1:3).EQ.'O4*' .OR. ATNMW(I)(1:3).EQ.'C3*' .OR.
     +          ATNMW(I)(1:3).EQ.'O3*' .OR. ATNMW(I)(1:3).EQ.'C2*' .OR.
     +          ATNMW(I)(1:3).EQ.'O2*' .OR. ATNMW(I)(1:3).EQ.'C1*') THEN
              RMSMC = D*D + RMSMC
              NATMC = NATMC + 1
            ELSE
              RMSSC = D*D + RMSSC
              NATSC = NATSC + 1
            END IF
              IF (IPRDEL.EQ.2) WRITE (IDELTAS,FMT=6006) D,NRESW(I),
     +            ATNMW(I),CHNNMW(I),NRESR(II),ATNMR(II),CHNNMR(II)
            IF (D.GE.DRMS .OR. BDIFF.GT.BRMS) THEN
              WRITE (6,FMT=6008) 
     + I,X(1,I),X(2,I),X(3,I),ATNMW(I),RESNMW(I),CHNNMW(I),NRESW(I),
     + II,ATNMR(II),CHNNMR(II),
     +  NRESR(II),BDIFF, D
C     + II,X(1,II),X(2,II),X(3,II),ATNMW(II),RESNMW(II),CHNNMW(II),
C     +  NRESW(II),D
            END IF
          END IF
  420   CONTINUE
C   Write out last residue info

              IF (NATMC.NE.0 .OR. NATSC.NE.0) THEN
                IF (NATMC.NE.0) RMSMC = SQRT(RMSMC/NATMC)
                IF (NATSC.NE.0) RMSSC = SQRT(RMSSC/NATSC)
                JRES = JRES + 1
                IF(IPRRMS.EQ.1) WRITE (IRMSTAB,FMT=6004) JRES,RMSMC,
     +            RMSSC,NRES0,RESNM0,CHNNM0
              END IF



      END IF
 6000 FORMAT (//,'  NUMBER OF ATOMS EXCLUDED BY RADCHK IS ',I5)
C 6002 FORMAT (////,11X,'WORKCDS',20X,'REFATM',21X,
C     +                 'B difference   DISTANCE APART ')
 6002 FORMAT (////,'  Natom2      ROTATED CDS        ATOMId2 ',
     +          '        Natom1    AtomId1    Bdiff   XYZDiff')
 6004 FORMAT (I5,2F10.3,I5,3X,A4,A1)
 6006 FORMAT (F10.3,I5,A4,A1,5X,I5,A4,A1)
C 6008 FORMAT (I5,3F8.3,2A4,A1,I4,2X,I5,3F8.3,2x,A4,A1,I4,2X,F7.3)
 6008 FORMAT (I5,3F8.2,2X,2A4,A1,I4,5X,I5,4x,A4,A1,I4,2X,F7.3,2X,F7.3)

 6010 FORMAT (
     +  '     CENTROID OF "WORKING" MOLECULE  :             ',3F8.3,/,
     +  '     CENTROID OF "WORKING" MOLECULE  :(fractional) ',3F8.3,/,
     +  '     CENTROID OF "REFERENCE" MOLECULE:             ',3F8.3,/,
     +  '     CENTROID OF "REFERENCE" MOLECULE:(fractional) ',3F8.3,/,
     +  '     Distance between CENTROIDS      :             ',F8.3,/,
     +  '     Direction cosines of vector between CENTROIDS:',3F8.3)
 6012 FORMAT ( /,10X,'RMS       B DISPLACEMENT =',F8.3,
     +         /,10X,'AVERAGE   B DISPLACEMENT =',F8.3,
     +         /,10X,'RMS     XYZ DISPLACEMENT =',F8.3,
     +         /,10X,'AVERAGE XYZ DISPLACEMENT =',F8.3,
     +         /,10X,'MAXIMUM XYZ DISPLACEMENT =',F8.3)
 6014 FORMAT (//////,6X,'ROTATION MATRIX:',3 (/,10X,3F9.5),/,
     +       '  TRANSLATION VECTOR IN AS ',3F12.5)
 6015 FORMAT (///,'  TRANSLATION VECTOR IN fractions of cell edge ',
     +                          3F12.6)
 6016 FORMAT (' LSFIT',/,1X,I4,' ATOMS IN WORKING MOLECULE(',I4,
     +       ' TO BE REFINED)',/,1X,I4,' ATOMS IN REFERENCE MOLECULE')
      END
C
C
      SUBROUTINE EIGEN(A,R,N,MV)
C     ==========================
C
      IMPLICIT NONE

C---- Purpose
C     compute eigenvalues and eigenvectors of a real symmetric
C     matrix
C
C---- Usage
C     call eigen(a,r,n,mv)
C
C---- Description of parameters
C           A - original matrix (symmetric), destroyed in computation.
C               resultant eigenvalues are developed in diagonal of
C               matrix a in descending order.
C           R - resultant matrix of eigenvectors (stored columnwise,
C               in same sequence as eigenvalues)
C           N - order of matrices a and r
C           MV- input code
C                   0   compute eigenvalues and eigenvectors
C                   1   compute eigenvalues only (r need not be
C                       dimensioned but must still appear in calling
C                       sequence)
C
C---- Remarks
C     original matrix a must be real symmetric (storage mode=1)
C     matrix a cannot be in the same location as matrix r
C
C---- Subroutines and function subprograms required
C     none
C
C---- Method
C     diagonalization method originated by jacobi and adapted
C     by von neumann for large computers as found in 'mathematical
C     methods for digital computers', edited by a. ralston and
C     h.s. wilf, john wiley and sons, new york, 1962, chapter 7
C
C    if a double precision version of this routine is desired, the
C    c in column 1 should be removed from the double precision
C    statement which follows.
C
      DOUBLE PRECISION ANORM,ANRMX,THR,X,Y,SINX,SINX2,COSX,
     1                 COSX2,SINCS,RANGE
C
C    the c must also be removed from double precision statements
C    appearing in other routines used in conjunction with this
C    routine.
C
C    the double precision version of this subroutine must also
C    contain double precision fortran functions.  sqrt in statements
C    40, 68, 75, and 78 must be changed to dsqrt.  abs in statement
C    62 must be changed to dabs. the constant in statement 5 should
C    be changed to 1.0d-12.
C
C
C
C---- Generate identity matrix
C
C     .. Scalar Arguments ..
      INTEGER MV,N
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION A(*),R(*)
C     ..
C     .. Local Scalars ..
C     REAL ANORM,ANRMX,COSX,COSX2,RANGE,SINCS,SINX,SINX2,THR,X,Y
      INTEGER I,IA,IJ,IL,ILQ,ILR,IM,IMQ,IMR,IND,IQ,J,JQ,K,L,LL,LM,LQ,M,
     +        MM,MQ
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,REAL,SQRT
C     ..
      RANGE = 1.0E-6
      IF (MV-1.NE.0) THEN
        IQ = -N
        DO 20 J = 1,N
          IQ = IQ + N
          DO 10 I = 1,N
            IJ = IQ + I
            R(IJ) = 0.0
            IF (I-J.EQ.0) R(IJ) = 1.0
   10     CONTINUE
   20   CONTINUE
      END IF
C
C---- Compute initial and final norms (anorm and anormx)
C
      ANORM = 0.0
      DO 40 I = 1,N
        DO 30 J = I,N
          IF (I-J.NE.0) THEN
            IA = (J*J-J)/2 + I
            ANORM = A(IA)*A(IA) + ANORM
          END IF
   30   CONTINUE
   40 CONTINUE
      IF (ANORM.GT.0) THEN
        ANORM = SQRT(ANORM)*1.414
        ANRMX = ANORM*RANGE/REAL(N)
C
C---- Initialize indicators and compute threshold, thr
C
        IND = 0
        THR = ANORM
   50   CONTINUE
        THR = THR/REAL(N)
   60   CONTINUE
        L = 1
   70   CONTINUE
        M = L + 1
   80   CONTINUE
C
C---- Compute sin and cos
C
        MQ = (M*M-M)/2
        LQ = (L*L-L)/2
        LM = L + MQ
        IF (ABS(A(LM))-THR.GE.0) THEN
          IND = 1
          LL = L + LQ
          MM = M + MQ
          X = (A(LL)-A(MM))*0.5
          Y = -A(LM)/SQRT(A(LM)*A(LM)+X*X)
C---- Protect against rounding error. C. Flensburg 20080307.
          IF (ABS(Y).GT.1.0D0) Y=SIGN(1.0D0,Y)
          IF (X.LT.0) Y = -Y
          SINX = Y/SQRT(((SQRT(1.0-Y*Y))+1.0)*2.0)
          SINX2 = SINX*SINX
          COSX = SQRT(1.0-SINX2)
          COSX2 = COSX*COSX
          SINCS = SINX*COSX
C
C---- Rotate l and m columns
C
          ILQ = (L-1)*N
          IMQ = (M-1)*N
          DO 130 I = 1,N
            IQ = (I*I-I)/2
            IF (I-L.NE.0) THEN
              IF (I-M) 90,120,100
   90         IM = I + MQ
              GO TO 110
  100         IM = M + IQ
  110         IF (I-L.GE.0) THEN
                IL = L + IQ
              ELSE
                IL = I + LQ
              END IF
              X = A(IL)*COSX - A(IM)*SINX
              A(IM) = A(IL)*SINX + A(IM)*COSX
              A(IL) = X
            END IF
  120       IF (MV-1.NE.0) THEN
              ILR = ILQ + I
              IMR = IMQ + I
              X = R(ILR)*COSX - R(IMR)*SINX
              R(IMR) = R(ILR)*SINX + R(IMR)*COSX
              R(ILR) = X
            END IF
  130     CONTINUE
          X = A(LM)*2.0*SINCS
          Y = A(LL)*COSX2 + A(MM)*SINX2 - X
          X = A(LL)*SINX2 + A(MM)*COSX2 + X
          A(LM) = (A(LL)-A(MM))*SINCS + (COSX2-SINX2)*A(LM)
          A(LL) = Y
          A(MM) = X
        END IF
C
C---- Tests for completion
C
C---- Test for m = last column
C
        IF (M-N.NE.0) THEN
          M = M + 1
          GO TO 80
        END IF
C
C---- Test for l = second from last column
C
        IF (L- (N-1).NE.0) THEN
          L = L + 1
          GO TO 70
        END IF
        IF (IND-1.EQ.0) THEN
          IND = 0
          GO TO 60
        END IF
C
C---- Compare threshold with final norm
C
        IF (THR-ANRMX.GT.0) GO TO 50
      END IF
C
C---- Sort eigenvalues and eigenvectors
C
      IQ = -N
      DO 160 I = 1,N
        IQ = IQ + N
        LL = (I*I-I)/2 + I
        JQ = (I-2)*N
        DO 150 J = I,N
          JQ = JQ + N
          MM = (J*J-J)/2 + J
          IF (A(LL)-A(MM).LT.0) THEN
            X = A(LL)
            A(LL) = A(MM)
            A(MM) = X
            IF (MV-1.NE.0) THEN
              DO 140 K = 1,N
                ILR = IQ + K
                IMR = JQ + K
                X = R(ILR)
                R(ILR) = R(IMR)
                R(IMR) = X
  140         CONTINUE
            END IF
          END IF
  150   CONTINUE
  160 CONTINUE
      END
C
C



      SUBROUTINE RCARDSLSQ
C         ====================
C
C---- Read in the control data
C
C---- Maximum section size
C
C     .. Parameters ..
      INTEGER NL
      PARAMETER (NL=15)
      INTEGER NKEYS
      PARAMETER (NKEYS=9,NPAR=200,NATOM=40000,NRS=13999)

C     ..
C
C     ..
C     .. Scalars in Common ..
      REAL CENFLG,RADCHK
      INTEGER IPRRMS,IPRDEL,LSQOP,NFITAT,NFITRS
      INTEGER IDELTAS,IRMSTAB,ILSQOP,IREF,IWORK
      CHARACTER TITLE*80
C     ..
C     .. Arrays in Common ..
      REAL RCEN(3),TR(3),TRMAT(3,3),CELLW(6)
      INTEGER IATR1(25),IATR2(25),IATW1(25),IATW2(25),
     +        IRESR(NRS),IRESW(NRS),IRSCD(NRS),NRESR(NATOM),NRESW(NATOM)
      CHARACTER CHAINR(NRS)*1,CHAINW(NRS)*1
C     ..
C     .. Local Scalars ..
      REAL AKAPPA,ALPHA,ATMFLG,BETA,CA,CB,CG,COMEG,CONV,COSCH1,COSCHI,
     +     COSPH,DC1,DC2,DC3,GAMMA,OMEGA,PHI,RESFLG,SA,SB,SG,SINCHI,
     +     SINPH,SOMEG
      INTEGER I,IFAIL,IOUT,IRSC,ITOK,J,J1,J2,JCHKR,JCHKW,LL,
     +        MATFLG
      CHARACTER ERRLIN*80,RCHAIN*1,WCHAIN*1
C     ..
C     .. Local Arrays ..
      INTEGER JJ(6)
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR,CCPDPN,CCPUPC,GTPINT,GTPREA,PARSER,XYZOPEN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC COS,SIN
C     ..
C     .. Common blocks ..
      COMMON /LSQCHR/CHAINR,CHAINW,TITLE
      COMMON /LSQCNTRL/TRMAT,TR,IPRRMS,IPRDEL,LSQOP,NFITAT,NFITRS,
     +       IATR1,IATR2,IATW1,IATW2,IRESR,IRESW,IRSCD,TRFRAC
      COMMON /NAMES1/RADCHK,CENFLG,RCEN,NRESW,NRESR,CELLW
      COMMON /UNIT1/ IWORK,IREF,ILSQOP,IRMSTAB,IDELTAS
C     ..
      CHARACTER LINE*400
C     ..
      CHARACTER KEY*4,CVALUE(NPAR)*4
C     ..
      LOGICAL LEND
      REAL     FVALUE(NPAR)
      INTEGER IBEG(NPAR),IDEC(NPAR),IEND(NPAR),ITYP(NPAR)
      CHARACTER KEYWRD(NKEYS)*4


      CHARACTER*8 name1(4),name2(4),name3(4),file1,file2,file3
C     ..
C     ..
      data name1/'WORKCD  ','XYZINM  ','XYZINW  ','XYZIN2  '/
      data name2/'REFRCD  ','XYZINF  ','XYZINR  ','XYZIN1  '/
      data name3/'LSQOP   ','XYZOUT  ','XYZOUT  ','XYZOUT  '/
C
C     ..
C     .. Data statements ..
      DATA KEYWRD/'TITL','OUTP',        'RADI','ROTA',
     +                                 'TRAN','FIT ',
     +     'MATC','CELL','END '/
C     ..
C
C---- Set defaults
C
      CONV = 3.14158/180.0
      TITLE = ' '
C
C---- lsqop set now to 0 not 1
C
C  default for residue fit is ALL 
      IRSC = 4
      IPRRMS = 0
      IPRDEL = 0
      LSQOP = 0
      MATFLG = 0
      NFITAT = 0
      NFITRS = 0
      RADCHK = 0
      CENFLG = 0
      TRFRAC = 0
      TITLE = ' '
      ILSQOP = 0
      IREF = 0
      IWORK = 0
      IDELTAS = 0
      IRMSTAB = 0
C
C---- Set trmat to [I]
C
      DO 20 I = 1,3
        DO 10 J = 1,3
          TRMAT(I,J) = 0.0
   10   CONTINUE
   20 CONTINUE
      DO 30 I = 1,3
        CELLW(I) = 0.0
        CELLW(I+3) = 90.0
        TR(I) = 0.0
        TRMAT(I,I) = 1.0
   30 CONTINUE
   40 CONTINUE
C

      LINE = '   '
      KEY = ' '
      NTOK = NPAR
C
C
C          ***********************************************************
      CALL PARSER(KEY,LINE,IBEG,IEND,ITYP,FVALUE,CVALUE,IDEC,NTOK,LEND,
     +            .TRUE.)
C          ***********************************************************
C
C----  End of file?
C
      IF (LEND)            GO TO 1000
C
C---- extra check for comment line (!)
C
          IF (KEY(1:1).EQ.'!') THEN
              GO TO 40
          ELSE
C
c
C
C  Loop over possible key-words
C
      DO 50 I=1,nkeyS
      IF(KEY.EQ.KEYWRD(I)) GOTO 60
 50   CONTINUE
C
      ERRLIN = ' *** ERROR - UNRECOGNIZED KEYWORD: '//
     +                               LINE(IBEG(1):IEND(1))
      CALL CCPERR(2,ERRLIN)
      GOTO 40
C
C
   60   CONTINUE

        GO TO (  70,  80,                100, 110,
     +                     120, 130,               
     +                                   170, 175,1000) I


C




C---- TITLe  read title
C
   70   IF (NTOK .GT. 1) TITLE = LINE(IBEG(2) :80)
        GO TO 40
C
C---- OUTPUT - must be followed by XYZ or RMS or DELTAS
C
   80   CONTINUE
        IOUT = 0
        DO 90 ITOK = 2,NTOK
          KEY = LINE(IBEG(ITOK) :IEND(ITOK))

C            **********
        CALL CCPUPC(KEY)
C            **********
C
C---- XYZ
C
          IF (KEY.EQ.'XYZ ') THEN
            IOUT = 1
            IF (LSQOP.EQ.0) LSQOP = 1
          END IF
C
C---- RMS
C
          IF (KEY.EQ.'RMS ') THEN
            IOUT = 1
            IPRRMS = 1
          END IF
C
C---- DELTASOUT
C
          IF (KEY.EQ.'DELT') THEN
            IPRDEL = 2
            IOUT = 1
          END IF
   90   CONTINUE
        IF (IOUT.NE.0) THEN
          GO TO 40
        ELSE
          CALL CCPERR(1, ' **** SUB KEYWORD MISSING ON OUTPUT***')
        END IF
C
C---- RADIUS
C
  100   CONTINUE
c
c
          CALL GTPREA(2,RADCHK,NTOK,ITYP,FVALUE)
        CENFLG = 0
        RCEN(1) = 0.0
        RCEN(2) = 0.0
        RCEN(3) = 0.0
        IF (NTOK.GT.2) THEN
          CENFLG = 1
          call gtprea(3,rcen(1),NTOK,ITYP,FVALUE)
          call gtprea(4,rcen(2),NTOK,ITYP,FVALUE)
          call gtprea(5,rcen(3),NTOK,ITYP,FVALUE)
        END IF
        GO TO 40
C
C---- ROTATE
C     Must be followed by EULERIAN or POLAR or DCS(direction cosines)
C     or MATRIX.
C     Generate trmat(3,3) for rotation of workcd
C
  110   CONTINUE
        LSQOP = -1
C
        KEY = LINE(IBEG(2) :IEND(2))
C
C            **********
        CALL CCPUPC(KEY)
C            **********
C---- EULERIAN
C
        IF (KEY.EQ.'EULE') THEN
          IF (NTOK.LT.5) THEN
            GO TO 440
          ELSE
            call gtprea(3,alpha,NTOK,ITYP,FVALUE)
            call gtprea(4, beta,NTOK,ITYP,FVALUE)
            call gtprea(5,gamma,NTOK,ITYP,FVALUE)
C
C---- we have read alpha beta gamma
C
            CA = COS(CONV*ALPHA)
            SA = SIN(CONV*ALPHA)
            CB = COS(CONV*BETA)
            SB = SIN(CONV*BETA)
            CG = COS(CONV*GAMMA)
            SG = SIN(CONV*GAMMA)
            TRMAT(1,1) = CG*CB*CA - SG*SA
            TRMAT(1,2) = -SG*CB*CA - CG*SA
            TRMAT(1,3) = SB*CA
            TRMAT(2,1) = CG*CB*SA + SG*CA
            TRMAT(2,2) = -SG*CB*SA + CG*CA
            TRMAT(2,3) = SB*SA
            TRMAT(3,1) = -CG*SB
            TRMAT(3,2) = SG*SB
            TRMAT(3,3) = CB
C
C
            GO TO 40
          END IF
C
C---- POLAR
C
        ELSE IF (KEY.EQ.'POLA' ) THEN
          IF (NTOK.LT.5) THEN
            GO TO 430
          ELSE
            call gtprea(3,OMEGA,NTOK,ITYP,FVALUE)
            call gtprea(4,  phi,NTOK,ITYP,FVALUE)
            call gtprea(5,akappa,NTOK,ITYP,FVALUE)
C
C---- we have read omeg phi akappa
C
            SOMEG = SIN(OMEGA*CONV)
            COMEG = COS(OMEGA*CONV)
            SINPH = SIN(PHI*CONV)
            COSPH = COS(PHI*CONV)
            DC1 = SOMEG*COSPH
            DC2 = SOMEG*SINPH
            DC3 = COMEG
C
            SINCHI = SIN(AKAPPA*CONV)
            COSCHI = COS(AKAPPA*CONV)
            COSCH1 = 1.0 - COSCHI
            TRMAT(1,1) = DC1*DC1*COSCH1 + COSCHI
            TRMAT(1,2) = DC1*DC2*COSCH1 - DC3*SINCHI
            TRMAT(1,3) = DC3*DC1*COSCH1 + DC2*SINCHI
            TRMAT(2,1) = DC1*DC2*COSCH1 + DC3*SINCHI
            TRMAT(2,2) = DC2*DC2*COSCH1 + COSCHI
            TRMAT(2,3) = -DC1*SINCHI + DC2*DC3*COSCH1
            TRMAT(3,1) = -DC2*SINCHI + DC3*DC1*COSCH1
            TRMAT(3,2) = DC2*DC3*COSCH1 + DC1*SINCHI
            TRMAT(3,3) = DC3*DC3*COSCH1 + COSCHI
            GO TO 40
          END IF
C
C---- direction cosines
C
        ELSE IF (KEY.EQ.'DCS ') THEN
          IF (NTOK.LT.6) THEN
            GO TO 420
          ELSE
            call gtprea(3,dc1,NTOK,ITYP,FVALUE)
            call gtprea(4,dc2,NTOK,ITYP,FVALUE)
            call gtprea(5,dc3,NTOK,ITYP,FVALUE)
            call gtprea(6,akappa,NTOK,ITYP,FVALUE)
            SINCHI = SIN(AKAPPA*CONV)
            COSCHI = COS(AKAPPA*CONV)
            COSCH1 = 1.0 - COSCHI
            TRMAT(1,1) = DC1*DC1*COSCH1 + COSCHI
            TRMAT(1,2) = DC1*DC2*COSCH1 - DC3*SINCHI
            TRMAT(1,3) = DC3*DC1*COSCH1 + DC2*SINCHI
            TRMAT(2,1) = DC1*DC2*COSCH1 + DC3*SINCHI
            TRMAT(2,2) = DC2*DC2*COSCH1 + COSCHI
            TRMAT(2,3) = -DC1*SINCHI + DC2*DC3*COSCH1
            TRMAT(3,1) = -DC2*SINCHI + DC3*DC1*COSCH1
            TRMAT(3,2) = DC2*DC3*COSCH1 + DC1*SINCHI
            TRMAT(3,3) = DC3*DC3*COSCH1 + COSCHI
            GO TO 40
          END IF
C
C
C----  MATRIX
C
        ELSE IF (KEY.NE.'MATR')THEN
          CALL CCPERR(1, '**** KEYWORD MISSING ***')
         ELSE IF (NTOK.LT.11) THEN
          GO TO 410
        ELSE
          call gtprea(3,TRMAT(1,1),NTOK,ITYP,FVALUE)
          call gtprea(4,TRMAT(1,2),NTOK,ITYP,FVALUE)
          call gtprea(5,TRMAT(1,3),NTOK,ITYP,FVALUE)
          call gtprea(6,TRMAT(2,1),NTOK,ITYP,FVALUE)
          call gtprea(7,TRMAT(2,2),NTOK,ITYP,FVALUE)
          call gtprea(8,TRMAT(2,3),NTOK,ITYP,FVALUE)
          call gtprea(9,TRMAT(3,1),NTOK,ITYP,FVALUE)
          call gtprea(10,TRMAT(3,2),NTOK,ITYP,FVALUE)
          call gtprea(11,TRMAT(3,3),NTOK,ITYP,FVALUE)
          GO TO 40
        END IF
C
C---- TRANSLATE - must be followed by t1 t2 t3 in as or FRAC t1 t2 t3 as 
c                     frac
C
  120   CONTINUE
          ITOK = 2
          IF(ITYP(ITOK) .EQ. 1)THEN
             KEY = LINE(IBEG(2) :IEND(2))
C            **********
        CALL CCPUPC(KEY)
C            **********
             IF(KEY.EQ.'FRAC') TRFRAC = 1
             ITOK = 3
             END IF
           END IF

        LSQOP = -1
        call gtprea(ITOK,TR(1),NTOK,ITYP,FVALUE)
        ITOK = ITOK + 1
        call gtprea(ITOK,TR(2),NTOK,ITYP,FVALUE)
        ITOK = ITOK + 1
        call gtprea(ITOK,TR(3),NTOK,ITYP,FVALUE)
        GO TO 40
C
C---- FIT - must be followed by watom or wresidu or atom or residu
C
  130   CONTINUE
C
        ATMFLG = 0
        RESFLG = 0
C
        KEY = LINE(IBEG(2) :IEND(2))
C
C            **********
        CALL CCPUPC(KEY)
C            **********
C---- WATOM
C
        IF (KEY.EQ.'WATO' .OR.KEY.EQ.'ATOM') THEN
          ATMFLG = 1
          NFITAT = NFITAT + 1
          J = 0
          DO 140 ITOK = 3,NTOK
            IF (ITYP(ITOK).EQ.2) THEN
              J = J + 1
              call gtpint(itok,JJ(J),NTOK,ITYP,FVALUE)
            END IF
  140     CONTINUE
          IF (J.LT.2) THEN
            CALL CCPERR(1, ' *****  GARBAGE ON LINE ****')
          ELSE
            IATW1(NFITAT) = JJ(1)
            IATW2(NFITAT) = JJ(2)
            GO TO 40
          END IF
        ELSE
C
C---- WRESIDUE
C
          IF (KEY.EQ.'WRES' .OR. KEY(1:3).eq.'RES') THEN
            RESFLG = 1
            WCHAIN = ' '
            J = 0
            DO 150 ITOK = 3,NTOK
C
C---- found a number
C
              IF (ITYP(ITOK).EQ.2) THEN
                J = J + 1
              call gtpint(itok,JJ(J),NTOK,ITYP,FVALUE)
              END IF
C
C---- Found a character string
C
              IF (ITYP(ITOK).EQ.1) THEN
                KEY = LINE(IBEG(ITOK) :IEND(ITOK))
C
C            **********
        CALL CCPUPC(KEY)
C            **********
C---- CA
C
                IF (KEY.EQ.'CA  ' ) IRSC = 1
C
C---- MAIN
C
                IF (KEY.EQ.'MAIN') IRSC = 2
C
C----  SIDE
C
                IF (KEY.EQ.'SIDE') IRSC = 3
C
C----  ALL
C
                IF (KEY.EQ.'ALL ') IRSC = 4
C
C---- WCHAIN
C
                IF (KEY(1:3).EQ.'WCH'  .OR.KEY(1:2).EQ.'CH')
     +          WCHAIN = LINE(IBEG(ITOK+1) :IEND(ITOK+1))
              END IF
  150       CONTINUE
          END IF
          IF (J.LT.2) THEN
            CALL CCPERR(1, ' *****  GARBAGE ON LINE ****')
          ELSE
            J1 = JJ(1)
            J2 = JJ(2)
            JCHKW = J2 - J1
            DO 160 J = J1,J2
              NFITRS = NFITRS + 1
              IRESW(NFITRS) = J
              IRSCD(NFITRS) = IRSC
              CHAINW(NFITRS) = WCHAIN
  160       CONTINUE
            GO TO 40
          END IF
        END IF
C
C---- Next card must be match
C
  170   CONTINUE
C
C---- MATCHING ATOM CARDS?
C
        MATFLG = 1
        IF (ATMFLG.EQ.1.0) THEN
          J = 0
          DO 180 ITOK = 2,NTOK
            IF (ITYP(ITOK).EQ.2) THEN
              J = J + 1
              call gtpint(itok,JJ(J),NTOK,ITYP,FVALUE)
            END IF
  180     CONTINUE
          IF (J.LT.2) THEN
            GO TO 240
          ELSE
            IATR1(NFITAT) = JJ(1)
            IATR2(NFITAT) = JJ(2)
            ATMFLG = 0
            GO TO 40
          END IF
        ELSE
C
C----  MATCHING RESIDUE CARDS?
C
          IF (RESFLG.EQ.1) THEN
            RCHAIN = ' '
            J = 0
            DO 190 ITOK = 2,NTOK
C
C---- found a number
C
              IF (ITYP(ITOK).EQ.2) THEN
                J = J + 1
                call gtpint(itok,JJ(J),NTOK,ITYP,FVALUE)
              END IF
C
C---- Found a character string
C
              IF (ITYP(ITOK).EQ.1) THEN
                KEY = LINE(IBEG(ITOK) :IEND(ITOK))
C
C            **********
        CALL CCPUPC(KEY)
C            **********
C---- RCHAIN
C
                IF (KEY(1:3).EQ.'RCH' .OR.KEY(1:2).EQ.'CH')
     +          RCHAIN = LINE(IBEG(ITOK+1) :IEND(ITOK+1))
              END IF
              RESFLG = 0
  190       CONTINUE
          END IF
          IF (J.LT.2) THEN
            GO TO 230
          ELSE
            JCHKR = JJ(2) - JJ(1)
            IF (JCHKW.NE.JCHKR) THEN
              WRITE(6,FMT='(a,a,i4,a,/,2a,i4,a)')
     1  '              Number of residues in',
     1 ' reference chain span (',JCHKR,
     1  ')',' does not match number of residues in ',
     1 'working chain span (',JCHKW,')'
              GO TO 220
            ELSE
C
C---- Knock off jchw + 1 from residue counter...
C
              NFITRS = NFITRS - JCHKW - 1
              DO 200 J = JJ(1),JJ(2)
                NFITRS = NFITRS + 1
                IRESR(NFITRS) = J
                CHAINR(NFITRS) = RCHAIN
  200         CONTINUE
              GO TO 40
            END IF
          END IF
        END IF
c      END IF
C
  220 CALL CCPERR(1,
     1   ' **  REQUESTED RESIDUE RANGES DO NOT MATCH **')
  230 CALL CCPERR(1,
     1   ' **** NOT ENOUGH NUMBERS ON MATCH RRESI CARD ***')
  240 CALL CCPERR(1,
     1   ' **** NOT ENOUGH NUMBERS ON MATCH WATOM CARD ***')

  410 CALL CCPERR(1,
     1   ' ** NOT ENOUGH NUMBERS GIVEN for MATRIX**')
  420 CALL CCPERR(1,
     1   ' ** NOT ENOUGH NUMBERS GIVEN for Direction Cosines**')
  430 CALL CCPERR(1,
     1   ' ** NOT ENOUGH ANGLES GIVEN for POLAR ANGLES**')
  440 CALL CCPERR(1,
     1   ' ** NOT ENOUGH ANGLES GIVEN for EULERIAN ANGLES**')
C
C---- DELTAS
C
C
C---- CELL
C
  175   CONTINUE
c
c
        IF(NTOK.LT.4) 
     +   CALL CCPERR(1,' Not enough numbers on CELL line')
          CALL GTPREA(2,CELLW(1),NTOK,ITYP,FVALUE)
          CALL GTPREA(3,CELLW(2),NTOK,ITYP,FVALUE)
          CALL GTPREA(4,CELLW(3),NTOK,ITYP,FVALUE)
          IF(NTOK.GE.5)CALL GTPREA(5,CELLW(4),NTOK,ITYP,FVALUE)
          IF(NTOK.GE.6)CALL GTPREA(6,CELLW(5),NTOK,ITYP,FVALUE)
          IF(NTOK.GE.7)CALL GTPREA(7,CELLW(6),NTOK,ITYP,FVALUE)
        GO TO 40
C
C
C---- End of input
C
C---- Check for errors
C
 1000  CONTINUE
        WRITE (6,FMT=6004) TITLE
        WRITE (6,FMT=*) '     OPEN FILES AS REQUESTED '
C
C---- Open files if requested
C     you will always want a working set ..
       do 950 i=1,4
        call ugtenv(name1(i),line)
        if (line.ne.' ') file1=name1(i)
        call ugtenv(name2(i),line)
        if (line.ne.' ') file2=name2(i)
        call ugtenv(name3(i),line)
        if (line.ne.' ') file3=name3(i)
 950   continue
C        write(6,*)file1,file2,file3
C
        IFAIL = 0
C        CALL XYZOPEN('WORKCD','INPUT',' ',IWORK,IFAIL)
        WRITE(6,*) ' Opening coordinate file of model to be moved'
        CALL XYZOPEN(file1,'INPUT',' ',IWORK,IFAIL)

        IF (LSQOP.NE.0) THEN
          CALL XYZOPEN(file3,'OUTPUT',' ',ILSQOP,IFAIL)
        END IF
C
C---- Open REFRCD if matflg = 1
C
        IF (MATFLG.NE.0) THEN
          WRITE(6,*) ' Opening coordinate file of fixed model.'
          CALL XYZOPEN(file2,'INPUT',' ',IREF,IFAIL)
        ENDIF
C
C---- Open RMSTAB if IPRrms = 1
C
        IF (IPRrms.EQ.1) THEN
          CALL CCPDPN(IRMSTAB,'RMSTAB','UNKNOWN','F',LL,IFAIL)
            WRITE(IRMSTAB,'(4(/,a))')
     +    '$TABLE: Rms difference for residues:',
     +    '$GRAPHS: Main Chain and Side chain deviations:N:4,2,3: $$',
     +    'Nres      MC_RMSD   SC_RMSD  Ires resnam chnnam  $$','$$'
        END IF
C
C---- Open DELTAS if IPRdel = 2
C
        IF (IPRdel.EQ.2) THEN
          CALL CCPDPN(IDELTAS,'DELTAS','UNKNOWN','F',LL,IFAIL)
        END IF
C
        IF (LSQOP.LT.0) then
          WRITE (6,FMT=6006) ((TRMAT(I,J),J=1,3),I=1,
     +        3), (TR(I),I=1,3)
          IF (TRFRAC . GT.0.0) WRITE (6,'(A)') 
     +    '  *** Translation is in FRACTIONAL units *** '
          IF  (NFITAT.GT.0) WRITE (6,FMT=6008) (IATW1(J),IATW2(J),
     +        IATR1(J),IATR2(J),J=1,NFITAT)
          IF (NFITRS.GT.0) THEN


            CALL CCPERR(1,
     +    ' *** Use FIT WATOM 1 to NATOM WITH ROTATION/TRANSLATION ***')
          END IF
        END IF
C
        IF (RADCHK.GT.0.5) THEN
          IF (CENFLG.GT.0) WRITE (6,FMT=6012) RADCHK,RCEN
          IF (CENFLG.EQ.0) WRITE (6,FMT=6014) RADCHK
          RADCHK = RADCHK*RADCHK
        END IF
C
        RETURN
C
 6000 FORMAT (//,' *** ERROR - UNRECOGNIZED KEYWRD: ',A)
 6002 FORMAT (/,1X,I6,' ERRORS IN INPUT, SEE ABOVE !!!!',/)
 6004 FORMAT (/////,' LSQKAB RUN ',/,25X,A80,////)
 6006 FORMAT (//'  INPUT CORDINATES ROTATED BY MATRIX - ',
     +       3 (/,5X,3F10.5),//,' THEN TRANSLATED BY ',3F10.5,/,
     +       ' IE     ','  [XOP] = [R] * [XIP]   + [TR].',////)
 6008 FORMAT (' ATOM RANGES AS ATOM NUMBER',
     +      25 (/,' WORKING COORDS ',2I5,'  REFERENCE COORDINATES',2I5))
 6010 FORMAT (' WORKING CORDINATES ',I5,3X,A1,' REFERENCE COORDINATES ',
     +       I5,3X,A1)
 6012 FORMAT (///,'   ALL ATOMS MORE THAN ',F6.3,' ANGSTROMS FROM ',
     +       'REFERENCE POINT',3F7.3,' EXCLUDED')
 6014 FORMAT (///,'   ALL ATOMS MORE THAN ',F6.3,' ANGSTROMS FROM ',
     +       'REFERENCE CENTROID EXCLUDED')
      END
