C
C     MAP2FS
C     Copyright (C) 2000 Kevin Cowtan
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c
c ----------------------------------------------------------------------
c
C     in the CCP4 manual for a copyright statement.
C
C ADDENDUM
C    If any local or global legislation renders the 'No Warranty'
C    clause illegal or reduces the scope of its content and protection
C    for author(s) in any way, then this whole license shall be null
C    and void, i.e. you may not copy, install any software provided
C    under this license, and any such action will be a breach of
C    the author's copyright.
c
c ----------------------------------------------------------------------
c
      program map2fs
c convert ccp4 map to fsfour map
      integer sizes(12)
      character types(12)*1
      integer nu,nv,nw,nspgrp,mode
      real cell(6),rrms
      common /uvwdata/nu,nv,nw,cell,nspgrp,mode,rrms
      external m2fsmain
c read map header and allocate memory
      call ccpfyp
      call ccprcs (6, 'map2fs', '$Date: 2005/09/06 11:25:16 $')
      call ccpmaphead
     +  ('MAPIN',nspgrp,cell,nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2,mode,rrms)
      sizes(1)=nu*nv*nw
      types(1)='R'
      call ccpalc(m2fsmain,1,types,sizes)
      call ccperr(0,' (map2fs) - normal termination ')
      end
c
c ----------------------------------------------------------------------
c
      subroutine m2fsmain(nmap,map)
      implicit none
      integer nmap
      real map(0:*)
      character title*500
      integer i,idat(2000),izro(20)
      integer nrow,ncol,nplane,irow,icol,iplane,iu,iv,iw,lmap
      real r,rdat(2000),rzro(20),scale
      integer ccpnun
      integer nu,nv,nw,nspgrp,mode
      real cell(6),rrms
      common /uvwdata/nu,nv,nw,cell,nspgrp,mode,rrms
      data izro/20*0/
      data rzro/20*0.0/
      external ccpnun
c
      write (*,*)nu,nv,nw,nspgrp,mode
      write (*,*)cell
c mark map as unknown
      do i=0,nu*nv*nw-1
       map(i)=-1.00e6
      enddo
c
c read map
      call ccpmapin('MAPIN',title,map,nu,nv,nw)
c
c extend map
      call mapextend(map,nu,nv,nw,nspgrp)
c
c smooth masks
      if (mode.eq.0) call mapsmooth(map,nu,nv,nw)
c
c write map
      if (mode.eq.0) then
       scale=100.0
      else
       scale=1.0
       do i=1,4
        if (scale*rrms.lt.10.0) scale=scale*10.0
       enddo
      endif
      nrow=nu
      ncol=nw
      nplane=nv
c
      lmap=ccpnun()
      call qopen(lmap,'MAPOUT','UNKNOWN')
c write header
      call qmode(lmap,6,i)
c .. header start
      idat(1)=(20+1+6+4*1)*4
      call qwrite(lmap,idat,1)
c .. title
      title='Fsfour format map from map2fs'
      title(30:30)=char(0)
      call qwritc(lmap,title(1:80))
c .. noset
      call qwrite(lmap,izro,1)
c .. cell
      call qmode(lmap,2,i)
      call qwrite(lmap,cell,6)
      call qmode(lmap,6,i)
c .. nsym
      idat(1)=1
      call qwrite(lmap,idat,1)
c .. ncent
      call qwrite(lmap,izro,1)
c .. latt
      idat(1)=1
      call qwrite(lmap,idat,1)
c .. npic
      idat(1)=10
      call qwrite(lmap,idat,1)
c .. header end
      idat(1)=(20+1+6+4*1)*4
      call qwrite(lmap,idat,1)
c .. symmetry elements start, elements, end
      idat(1)=9*4
      call qwrite(lmap,idat,1)
      call qmode(lmap,2,i)
      call qwrite(lmap,rzro,9)
      call qmode(lmap,6,i)
      call qwrite(lmap,idat,1)
c .. map stats start
      idat(1)=(7+6)*4
      call qwrite(lmap,idat,1)
c .. nrow, ncol, nplane
      idat(1)=nrow
      call qwrite(lmap,idat,1)
      idat(1)=ncol
      call qwrite(lmap,idat,1)
      idat(1)=nplane
      call qwrite(lmap,idat,1)
c .. scale
      call qmode(lmap,2,i)
      rdat(1)=scale
      call qwrite(lmap,rdat,1)
      call qmode(lmap,6,i)
c .. norn
      call qwrite(lmap,izro,1)
c .. mnx
      call qwrite(lmap,izro,6)
c .. rspmx
      call qmode(lmap,2,i)
      call qwrite(lmap,rzro,1)
      call qmode(lmap,6,i)
c .. nbit
      call qwrite(lmap,izro,1)
c .. map stats end
      idat(1)=(7+6)*4
      call qwrite(lmap,idat,1)
c write data
      do iplane=0,nplane-1
       do icol=0,ncol-1
        idat(1)=4*nrow
        call qwrite(lmap,idat,1)
        do irow=0,nrow-1
         iu=irow
         iv=iplane
         iw=icol
         idat(irow+1)=nint(scale*map(iu+nu*(iv+nv*iw)))
        enddo
        call qwrite(lmap,idat,irow)
        idat(1)=4*nrow
        call qwrite(lmap,idat,1)
       enddo
      enddo
c
      close(lmap)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmaphead
     +  (name,nspgrp,cell,nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2,mode,rrms)
c CCPMAPhead - get limits of mask from file
c
      character name*(*)
      integer nspgrp,nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2
      real cell(6)
c
      integer jfms(3),juvw(3),mxyz(3),m1(3),m2(3),nsec,mode
      integer i,ifail,iprint
      real rmin,rmax,rmean,rrms,qmin,qmax,qmean,qrms,qcell(6)
      character title*80
c
c read the file headers
      ifail=0
      iprint=1
      call mrdhds(10,name,title,nsec,jfms,mxyz,m1(3),m1(1),m2(1),
     +  m1(2),m2(2),cell,nspgrp,mode,rmin,rmax,rmean,rrms,ifail,iprint)
      call mrclos(10)
      m2(3)=m1(3)+nsec-1
      do 110 i=1,3
       juvw(jfms(i))=i
 110  continue
      nu1=m1(juvw(1))
      nu2=m2(juvw(1))
      nv1=m1(juvw(2))
      nv2=m2(juvw(2))
      nw1=m1(juvw(3))
      nw2=m2(juvw(3))
      nu=mxyz(1)
      nv=mxyz(2)
      nw=mxyz(3)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmapin(name,title,map,nu,nv,nw)
c CCPMAPIN - read a ccp4 logical map and store in xyz order
c
      integer nu,nv,nw
      real map(0:nu-1,0:nv-1,0:nw-1)
      character name*(*),title*(*)
c
      integer maxsec
      parameter (maxsec=100000)
      real lsec(0:maxsec)
c
      integer ifast,imedm,islow,lfast,lmedm,lslow,ierr,ifail,iprint
      integer m1(3),m2(3),ifms(3),jfms(3),juvw(3),mxyz(3)
      integer i,iu,iv,iw
      integer nsec,mode,mspgrp
      real cell(6),rmin,rmax,rmean,rrms
c
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
c now open map header and read map, re-ordering it as necessary
c
      ifail=0
      iprint=0
      call mrdhds(10,name,title,nsec,jfms,mxyz,m1(3),m1(1),m2(1),
     +  m1(2),m2(2),cell,mspgrp,mode,rmin,rmax,rmean,rrms,ifail,iprint)
      m2(3)=m1(3)+nsec-1
      do 110 i=1,3
       juvw(jfms(i))=i
 110  continue
c find out the map grid dimensions
      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
c
      if (lfast*lmedm.gt.maxsec)
     +  call ccperr(1,' ccpmapin - Map section > maxsec: recompile')
c now read the map in the order it is on file
      do 200 islow=0,lslow-1
c get a section
       ierr=0
       call mgulpr(10,lsec,ierr)
       if (ierr.ne.0) call ccperr(1,' ccpmapin - ccp4 read error')
c now sort into uvw map
       ifms(3)=islow+m1(3)
       do 190 imedm=0,lmedm-1
       ifms(2)=imedm+m1(2)
       do 190 ifast=0,lfast-1
       ifms(1)=ifast+m1(1)
        iu=lmod(ifms(juvw(1)),nu)
        iv=lmod(ifms(juvw(2)),nv)
        iw=lmod(ifms(juvw(3)),nw)
        map(iu,iv,iw)=lsec(ifast+lfast*imedm)
 190   continue
 200  continue
c close the map file
      call mrclos(10)
c
      write (6,910)
 910  format (/' MAP/MASK READ SUCCESSFUL'/)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine mapextend(map,nu,nv,nw,nspgrp)
      implicit none
c extend to a unit cell
      integer nu,nv,nw,nspgrp
      real map(0:nu-1,0:nv-1,0:nw-1)
c
      integer iu,iv,iw,ju,jv,jw,nsym
      integer i,j,k,isym(4,4,192),ccpnun,lmod
      real r,uvw(4),rsym(4,4,192)
      external ccpnun,lmod
c
      i=ccpnun()
      call msyget(i,nspgrp,nsym,rsym)
c
      uvw(1)=real(nu)
      uvw(2)=real(nv)
      uvw(3)=real(nw)
      uvw(4)=1.0
c make the integer symmetry matrices
      do 60 k=1,nsym
       do 50 j=1,4
        do 40 i=1,4
         r=uvw(i)*rsym(i,j,k)/uvw(j)
         isym(i,j,k)=nint(r)
         if (abs(r-nint(r)).gt.0.01) goto 9000
 40     continue
 50    continue
 60   continue
c apply them to the map
c  the matrix multiplication is factorised, steps are performed
c  by addition, with the origin offset calculated first.
      j=1
      do 150 iw=0,nw-1
       do 140 iv=0,nv-1
        do 130 iu=0,nu-1
c Check identity op first, becuase its easy
         if (map(iu,iv,iw).gt.-0.99e6) goto 130
c If not, try the rest, but start with the one that worked last time (j)
         do i=1,nsym-1
          ju=isym(1,1,j)*iu+isym(1,2,j)*iv+isym(1,3,j)*iw+isym(1,4,j)
          jv=isym(2,1,j)*iu+isym(2,2,j)*iv+isym(2,3,j)*iw+isym(2,4,j)
          jw=isym(3,1,j)*iu+isym(3,2,j)*iv+isym(3,3,j)*iw+isym(3,4,j)
          r=map(lmod(ju,nu),lmod(jv,nv),lmod(jw,nw))
          if (r.gt.-0.99e6) goto 120
          j=mod(j-1,nsym-1)+2
         enddo
         r=0.0
 120     map(iu,iv,iw)=r
 130    continue
 140   continue
 150  continue
c
c
      return
 9000 call ccperr(1,
     +  ' mapextend - grid dimensions incompatible with space group')
      end
c
c ----------------------------------------------------------------------
c
      subroutine mapsmooth(map,nu,nv,nw)
      implicit none
c smooth a mask to make it look better
      integer nu,nv,nw,iu,iv,iw
      real map(0:nu-1,0:nv-1,0:nw-1)
c
      do iw=0,nw-1
       do iv=0,nv-1
        call qsmooth(map(0,iv,iw),1,nu)
       enddo
      enddo
      do iw=0,nw-1
       do iu=0,nu-1
        call qsmooth(map(iu,0,iw),nu,nv)
       enddo
      enddo
      do iv=0,nv-1
       do iu=0,nu-1
        call qsmooth(map(iu,iv,0),nu*nv,nw)
       enddo
      enddo
c
      write (6,910)
 910  format (/' MASK SMOOTH SUCCESSFUL'/)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine qsmooth(r,d,n)
      implicit none
      real r(0:*),r0,r1,r2,rn
      integer i,d,n
c
      r0=r((n-2)*d)
      r1=r((n-1)*d)
      r2=r(0)
      rn=0.125*(r0+6*r1+r2)
      do i=0,n-2
       r0=r1
       r1=r2
       r2=r((i+1)*d)
       r(i*d)=0.125*(r0+6*r1+r2)
      enddo
      r((n-1)*d)=rn
c
      return
      end
c
c ----------------------------------------------------------------------
c
      integer function lmod(i,j)
      implicit none
c fixed integer mod (optimised for 0<=i<j)
      integer i,j,k
c
      if (i.lt.0) then
       lmod=mod(i+1,j)+j-1
      else if (i.ge.j) then
       lmod=mod(i,j)
      else
       lmod=i
      endif
      return
      end
c
c ----------------------------------------------------------------------
c
