C
C     MAPDUMP
C     Copyright (C) 1996 Phil Evans
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
C============================================================
C
C PRINT MAP
C
C   3/5/84  changed to Fortran 77 versions of MSUBS  PRE
C   26/9/86 use MSUBS with Rms level
C
C============================================================
C
      IMPLICIT NONE
C     ..
C     ..Parameters..
      INTEGER NFIELDS
      PARAMETER (NFIELDS=20)
      INTEGER NPTS
      PARAMETER (NPTS=1000000)
C     ..
C     ..Scalars
      CHARACTER*80 TITLE
      REAL SCALE,RHMIN,RHMAX,RHMEAN,RHRMS
      LOGICAL CCPONL, GOTEOF, GOTSECS
      INTEGER MSKGET,JSEC,IZ1,IZ2,IX1,IX2,IEND,NSYM,MX,MZ,IER
      INTEGER ISEC1,ISEC2,NSEC,IW1,IW2,LSPGRP,LMODE,LSKEW,I,J
C     ..
C     ..Arrays
      REAL RHO(NPTS),CELL(6), SKWMAT(3,3),SKWTRN(3),ROT(4,4,96)
      INTEGER IUVW(3),NXYZ(3)
C     ..
C     ..Common Block
      COMMON /MAP/ JSEC,IZ1,IZ2,IX1,IX2,IEND,SCALE
C     ..
C     ..For parser..
      CHARACTER KEY*4, LINE*80, CVALUE(NFIELDS)*4
      REAL FVALUE(NFIELDS)
      INTEGER NTOK
      INTEGER IDEC(NFIELDS),IBEGW(NFIELDS),IENDW(NFIELDS),ITYPE(NFIELDS)
      LOGICAL LEND,LPRINT,IDUM
C     ..
C     ..External subroutines..
      EXTERNAL CCPONL, CCPRCS, MSKGET, CCPFYP, MRDHDR, MSYMOP,
     +     CCPERR, MPOSN, MGULPR, PRMAP, PARSER
C
      CALL CCPFYP
      CALL CCPRCS(6,'MAPDUMP','$Date: 2005/09/06 11:25:16 $')
C
      DO 990 I=1,NPTS
        RHO(I)=0.0
 990  CONTINUE
C
      ISEC1=1
      ISEC2=1
      SCALE=1.0
      GOTEOF = .TRUE.
      GOTSECS = .FALSE.
      IF (CCPONL(IDUM)) WRITE(6,*) 
     $     'Type first, last section numbers & scale ',
     $     '(END/GO/RUN or <EOF> for header only, "/" for defaults)'
C
1     CONTINUE
      NTOK=NFIELDS
      LPRINT=.FALSE.
      LINE=' '
      CALL PARSER (KEY,LINE,IBEGW,IENDW,ITYPE,FVALUE,CVALUE,IDEC,NTOK,
     +             LEND,LPRINT)
      IF (LEND) GO TO 2
      IF (KEY .EQ. 'END' .OR. KEY(1:1) .EQ. 'G' .OR.
     +    KEY .EQ. 'RUN')  THEN
         GO TO 2
      END IF
C
      GOTEOF = .FALSE.
      IF (NTOK .EQ. 3) THEN
         GOTSECS = .TRUE.
         IF (ITYPE(1).EQ.2) THEN
           ISEC1 = FVALUE(1)
           IF (ITYPE(2).EQ.2) THEN
              ISEC2 = FVALUE(2)
              IF (ITYPE(3).EQ.2) THEN
                 SCALE = FVALUE(3)
              END IF
           END IF
         END IF
      END IF
C
      GO TO 1
C
2     IF(SCALE.LT.0.0000001)SCALE=1.0
      IF (GOTEOF) ISEC1 = -10000
      IF (GOTSECS) THEN
         WRITE(6,5) ISEC1,ISEC2,SCALE
 5       FORMAT(' Print sections ',I4,' to',I4,5X,
     .        'Electron density multiplied by',F12.5)
      ENDIF
C
C READ MAP TITLE
      CALL MRDHDR(3,'MAPIN',TITLE,NSEC,IUVW,NXYZ,IW1,IZ1,IZ2,IX1,IX2,
     .  CELL,LSPGRP,LMODE,RHMIN,RHMAX,RHMEAN,RHRMS)

      IF (.NOT.GOTEOF .AND. .NOT.GOTSECS) THEN
         ISEC1 = IW1
         ISEC2 = IW1
         WRITE(6,55) ISEC1,ISEC2,SCALE
 55      FORMAT(' Print sections ',I4,' to',I4,5X,
     .        'Electron density multiplied by',F12.5)
      ENDIF

      WRITE(6,3) TITLE,NSEC,IUVW,NXYZ
3     FORMAT(/' Title from map:  ',A/
     . ' Number of sections ',I6/' Fast, medium, slow axes',3I3/
     . ' Sampling intervals on xyz',3I5/)
C
C Print skew transformation if any
C
      IF (LSPGRP .GT. 256) LSPGRP = 0
      IF (LSPGRP .LE. 0) GOTO 12
      LSKEW=MSKGET(SKWMAT,SKWTRN)
      IF(LSKEW.EQ.0) GO TO 10
      WRITE(6,11) ((SKWMAT(I,J),J=1,3),SKWTRN(I),I=1,3)
11    FORMAT(//' Skew transformation matrix S and vector t :-  ',
     . 'Xo(map) = S * ( Xo(atoms) - t )'//
     . 3(21X,'(',3F10.5,' )',10X,'(',F10.5,' )'/)/)
C
C Print symmetry information
10    CALL MSYMOP(3,NSYM,ROT)
      IF (NSYM .LE. 0) THEN
         WRITE (6, '(/A/)') ' --- No symmetry operations in file ---'
      ENDIF
C
12    IF (ISEC1 .LT. -9999) go to 30
      IF(ISEC1.GT.ISEC2)
     +     call ccperr(1,'last section precedes first')
C
C---- Check that requested sections lie within map
C
      IF(ISEC1.LT.IW1) THEN
        WRITE(6,9011) ISEC1,IW1
 9011   FORMAT(/' !!! First requested section ',I5,' is before ',
     .       'beginning of map ',I5/)
        ISEC1=IW1
      ENDIF
      IW2=IW1+NSEC-1
      IF(ISEC2.GT.IW2) THEN
        WRITE(6,9012) ISEC2,IW2
 9012   FORMAT(/' !!! Last requested section ',I5,' is after',
     .       'end of map ',I5/)
        ISEC2=IW2
      ENDIF
C
C GET MAP SIZE
      MX=IX2-IX1+1
      MZ=IZ2-IZ1+1
      WRITE(6,4) IX1,IX2,IZ1,IZ2
4     FORMAT(/' MAP LIMITS IN SECTION:',2I6,12X,2I6/)
C
      CALL MPOSN(3,ISEC1)
C LOOP SECTIONS
C
      DO 20 JSEC=ISEC1,ISEC2
      CALL MGULPR(3,RHO,IER)
      IF(IER.NE.0) GO TO 50
      CALL PRMAP(RHO,MZ,MX)
20    CONTINUE
C
30    CALL MRCLOS(3)
      CALL CCPERR(0,' Normal Termination')
C
50    CALL MRCLOS(3)
      WRITE(6,51) JSEC
51    FORMAT(//' !!!!!!!!! Unexpected end of file on section',I6,
     .         ' !!!!!!!!!'//)
         CALL CCPERR(1,'Corrupt map?')
C
      END
C
C     ===========================
      SUBROUTINE PRMAP(RHO,MZ,MX)
C     ===========================
C
      IMPLICIT NONE
C
      REAL RHO,SCALE
      INTEGER JSEC,IZ1,IZ2,IX1,IX2,IEND
      INTEGER MZ,MX,I1,I2,NPAGE,K,NI,NI2,I,J,L,LINE
      DIMENSION RHO(MZ,MX),LINE(27)
      COMMON /MAP/ JSEC,IZ1,IZ2,IX1,IX2,IEND,SCALE
C
C PRINT MAP SECTION
C
      I1=0
C
      NPAGE=MZ/25+1
C
      DO 22 K=1,NPAGE
        WRITE(6,21) JSEC,K
21      FORMAT(/////'  SECTION',I6,100X,'PAGE',I5//)
        I2=I1+24
        IF(I2.GT.MZ) I2=MZ-1
        NI=I2-I1+1
        NI2=NI+1
C
        DO 10 I=1,NI
          L=I+I1-1+IZ1
          LINE(I+1)=L
10      CONTINUE
        WRITE(6,11)(LINE(I),I=2,NI2)
11      FORMAT(7X,25I5)
        WRITE(6,11)
C
        DO 23 J=1,MX
          LINE(1)=J-1+IX1
          DO 24 I=1,NI
            L=I+I1
            LINE(I+1)=NINT(RHO(L,J)*SCALE)
24        CONTINUE
          WRITE(6,25)(LINE(I),I=1,NI2)
25        FORMAT(3X,I4,25I5)
23      CONTINUE
C
        I1=I2+1
22    CONTINUE
C
      END
