C
C     MAPMASK in core map extension
C     Copyright (C) 1995-2004 Kevin Cowtan
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c
c ----------------------------------------------------------------------
c
c in core map extension - Kevin Cowtan
c
C     See the conditions in the CCP4 manual for a copyright statement.
C
C ADDENDUM
C    If any local or global legislation renders the 'No Warranty'
C    clause illegal or reduces the scope of its content and protection
C    for author(s) in any way, then this whole license shall be null
C    and void, i.e. you may not copy, install any software provided
C    under this license, and any such action will be a breach of
C    the author's copyright.
C
c ----------------------------------------------------------------------
c
      program mapmask
      include 'mapmask.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
c
      integer size1,size2,sizes(2)
      character types(2)*1
c
      integer lunsto,idum
      external ccpalc,ccperr,ccpfyp,ccprcs,mapmaskmain,lunsto,rcards,
     +         XYZINIT
c
      data types /'R','R'/
c
      call ccpfyp
      call ccprcs (6, 'mapmask', '$Date: 2005/09/06 11:29:33 $')
      call XYZINIT
c
      idum=0
      lpt=lunsto(idum)
c      lcd=lunsti(idum)
      lmap1=1
      lmap2=2
c
      call rcards(size1,size2)
c
      sizes(1)=size1
      sizes(2)=size2
      call ccpalc(mapmaskmain,2,types,sizes)
c
      call ccperr(0,' (mapmask) - normal termination ')
      end
c
c ----------------------------------------------------------------------
c
      subroutine mapmaskmain(nmapin,mapin,nmapout,mapout)
      include 'mapmask.fh'
      include 'params.fh'
c mask array and optional unit cell array
      integer nmapin,nmapout
      real mapin(nmapin),mapout(nmapout)
c
      integer i
      character*240 title,line,file1*8,file2*8
c
      common /filenames/file1,file2
      save   /filenames/
c
      title=' '
c
      do 100 i=1,nmapin
       mapin(i)=0.0
 100  continue
      do 110 i=1,nmapout
       mapout(i)=0.0
 110  continue
c
c read mask
      if (file2.eq.' ') then
       call ccpmapin(mapin,file1,title)
      else
       call ccpmapsin(mapin,file1,file2,title)
      endif
c copy or expand onto new grid
      if (mapext.eq.1) call mapcopy   (mapin,mapout)
      if (mapext.eq.2) call mapextend (mapin,mapout)
      if (mapext.eq.3) call mapoverlap(mapin,mapout)
c calculate mask fraction
      if (mskfrc.gt.0.0) call maskcut(mapin)
c output new mask
      call ugtenv('MAPOUT',line)
      if (line.ne.' ') call ccpmapout(mapout,title)
      call ugtenv('MSKOUT',line)
      if (line.ne.' ') call ccpmskout(mapout,title)
c produce lp output
      if (prtype.ne.0) call lpsec(mapout)
c and comment
c      call comment(map)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine rcards(size1,size2)
      include 'mapmask.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
c rcards - read input cards
c
      integer size1,size2
c
      character namspg*10,nampg*10
      character xyz*4,axisf*20,axism*20,axiss*20,axisp*20
      logical cont,lxyzunt,lxyzasu,lsclsig,lsclmea,lsclrat,lprtmap,
     +     lprtmsk,lmapadd,lmapmul,lsolven,lextcpy,lextxtl,lextovl,
     +     lxyzmtc,lgot_xyzlim
c
      real uvwlim(2,3),mskvol
      integer i,j,k,iu,iv,iw,ntok,ou,ov,ow,xspgrp
      character name1(0:4)*8,name2(0:4)*8,file1*8,file2*8,key*6,line*600
c
      common /filenames/file1,file2
      save   /filenames/
c
c spacegroups with yxz=1 and zxy=2 axis ordering
      integer axis(230)
      data axis/2,2,2,2,1,1,1,1,1,2,1,1,1,1,1,2,2,2,1,2,2,1,2,207*1/
      data name1/'      ','MAPIN ','MSKIN ','MAPIN1','MSKIN1'/
      data name2/'      ','MAPIN2','MSKIN2','MAPIN2','MSKIN2'/
c
      xyz='XYZ'
c
c set defaults
c
      jfmso(1)=-1
      uvwlim(1,1)=-1.0e6
      border=-1.0e6
      mskcut=0.5
      mskfrc=-1.0
      mskvol=-1.0
      mapmul=1.0
      mapadd=0.0
      mapscl=0
      mapcmb=0
      mapext=0
      flipfac=1.0
      meanp=0.433
      means=0.330
      ratio=1.0
      attnu=1.0
      xspgrp=0
      nspgrp=1
      namspg=' '
      axiss=' '
      axism=' '
      axisf=' '
      axisp=' '
      prtype=0
      praxis=0
      prfirst=0
      prlast=0
      prstep=1
      mappad=-1.0e6
      lxyzasu=.false.
      lxyzunt=.false.
      lxyzmtc=.false.
      lsclsig=.false.
      lsclmea=.false.
      lsclrat=.false.
      lprtmap=.false.
      lprtmsk=.false.
      lmapadd=.false.
      lmapmul=.false.
      lsolven=.false.
      lextcpy=.false.
      lextxtl=.false.
      lextovl=.false.
c
      do 920 k=1,192
       do 910 i=1,4
        do 900 j=1,4
         rsym(i,j,k)=0.0
 900    continue
       rsym(i,i,k)=1.0
 910   continue
 920  continue

      file1='AUTO'
      file2=' '
      call ugtenv('XYZIN',line)
      if (line.ne.' ') border=10.0
c
c now parse input --------------------
c
 1000 call memoparse(.true.)
c SYMM
      call parsesymm(namspg,xspgrp,nampg,nsym,nsymp,rsym)
c XYZLIM
      lgot_xyzlim = .false.
      call parsesubkey('XYZL',' ',lgot_xyzlim)
      call parsesubkey('XYZL','ASU ',lxyzasu)
      call parsesubkey('XYZL','CELL',lxyzunt)
      call parsesubkey('XYZL','MATC',lxyzmtc)
      call parsesubreal('XYZL','    ',1,.false.,uvwlim(1,1))
      call parsesubreal('XYZL','    ',2,.false.,uvwlim(2,1))
      call parsesubreal('XYZL','    ',3,.false.,uvwlim(1,2))
      call parsesubreal('XYZL','    ',4,.false.,uvwlim(2,2))
      call parsesubreal('XYZL','    ',5,.false.,uvwlim(1,3))
      call parsesubreal('XYZL','    ',6,.false.,uvwlim(2,3))
      if (lgot_xyzlim) then
        if(.not. (lxyzasu .or.lxyzunt .or.lxyzmtc)
     +       .and. (uvwlim(1,1).eq.-1.0e6) )
     +   call ccperr(1,' You have no parameters for the XYZLIM keyword')
      endif
c AXIS
      call parsesubchar('AXIS','    ',1,.true.,axisf)
      call parsesubchar('AXIS','    ',2,.true.,axism)
      call parsesubchar('AXIS','    ',3,.true.,axiss)
c BORDER
      call parsereal('BORD',border)
c EXTEND
      call parsesubkey('EXTE','COPY',lextcpy)
      call parsesubkey('EXTE','XTAL',lextxtl)
      call parsesubkey('EXTE','OVER',lextovl)
c PAD
      call parsereal('PAD ',mappad)
c MASK
      call parsesubreal('MASK','CUT ',1,.true.,mskcut)
      call parsesubreal('MASK','FRAC',1,.true.,mskfrc)
      call parsesubreal('MASK','VOLU',1,.true.,mskvol)
c SCALE
      call parsesubkey ('SCAL','SIGM',lsclsig)
      call parsesubkey ('SCAL','MEAN',lsclmea)
      call parsesubkey ('SCAL','RATI',lsclrat)
      call parsesubreal('SCAL','FACT',1,.false.,mapmul)
      call parsesubreal('SCAL','FACT',2,.false.,mapadd)
      call parsesubreal('SCAL','SIGM',1,.false.,mapmul)
      call parsesubreal('SCAL','SIGM',2,.false.,mapadd)
      call parsesubreal('SCAL','MEAN',1,.false.,meanp)
      call parsesubreal('SCAL','MEAN',2,.false.,means)
      call parsesubreal('SCAL','RATI',1,.false.,ratio)
c PRINT
      call parsesubkey ('PRIN','MAP ',lprtmap)
      call parsesubkey ('PRIN','MASK',lprtmsk)
      call parsesubchar('PRIN','    ',2,.false.,axisp)
      call parsesubint ('PRIN','    ',3,.false.,prfirst)
      call parsesubint ('PRIN','    ',4,.false.,prlast)
      call parsesubint ('PRIN','    ',5,.false.,prstep)
c MAPS
      call parsesubkey('MAPS','ADD ',lmapadd)
      call parsesubkey('MAPS','MULT',lmapmul)
c SOLV
      call parsesubkey ('SOLV','    ',lsolven)
      call parsesubreal('SOLV','FLIP',1,.true.,flipfac)
      call parsesubreal('SOLV','ATTN',1,.true.,attnu)
c MODE
      call parsesubchar('MODE','    ',1,.true.,file1)
      call parsesubchar('MODE','    ',2,.false.,file2)
c
      call parsediagnose(cont)
      if (cont) goto 1000
c
c NOW SET UP THINGS --------------------
c
      if (lmapadd) mapcmb=1
      if (lmapmul) mapcmb=2
      if (lsolven) mapcmb=3
      if (lsclsig) mapscl=1
      if (lsclmea) mapscl=2
      if (lsclrat) mapscl=3
      if (lprtmap) prtype=1
      if (lprtmsk) prtype=2
      if (lextcpy) mapext=1
      if (lextxtl) mapext=2
      if (lextovl) mapext=3
c
c get map names
      if (file1.eq.'AUTO') then
        do 950 i=1,4
         call ugtenv(name1(i),line)
         if(line.ne.' ') file1=name1(i)
         call ugtenv(name2(i),line)
         if(line.ne.' ') file2=name2(i)
  950   continue
      endif
      if (mapcmb.eq.0.and.mapscl.eq.0) file2=' '
      call ccpupc(file1)
      call ccpupc(file2)
c get map headers
      call ccpmaphead(file1,file2)
      if (axisf.eq.' ') axisf=xyz(jfmsi(1):jfmsi(1))
      if (axism.eq.' ') axism=xyz(jfmsi(2):jfmsi(2))
      if (axiss.eq.' ') axiss=xyz(jfmsi(3):jfmsi(3))
      if (xspgrp.ne.0) nspgrp=xspgrp
      if (lxyzasu) call setlim_zero(nspgrp,uvwlim)
      if (lxyzunt) call setlim(1,uvwlim)
c
c matrics
      call calcmetric()
c
c axis order
      call ccpupc(axisp)
      praxis=index(xyz,axisp(1:1))
      if (prtype.ne.0.and.(praxis.lt.1.or.praxis.gt.3)) goto 9050
      jfmso(1)=index(xyz,axisf(1:1))
      jfmso(2)=index(xyz,axism(1:1))
      jfmso(3)=index(xyz,axiss(1:1))
      if (jfmso(1)+jfmso(2)+jfmso(3).ne.6) goto 9010
c
c spacegroup info
      call msymlb(lmap1,nspgrp,namspg,nampg,nsymp,nsym,rsym)
c
c now work out o/p limits: if border specified then get from coords.
      if (border.ge.0.0) call pdbbox(uvwlim)
      if (uvwlim(1,1).lt.-0.999e6) then
       ouvwlim11=iuvwlim11
       ouvwlim21=iuvwlim21
       ouvwlim12=iuvwlim12
       ouvwlim22=iuvwlim22
       ouvwlim13=iuvwlim13
       ouvwlim23=iuvwlim23
      else
       if (border.ge.0.0.or.
     +   ((uvwlim(2,1)-uvwlim(1,1))*(uvwlim(2,2)-uvwlim(1,2))*
     +   (uvwlim(2,3)-uvwlim(1,3)).lt.8.5.and.
     +   (uvwlim(2,1)-uvwlim(1,1))*(uvwlim(2,2)-uvwlim(1,2))*
     +   (uvwlim(2,3)-uvwlim(1,3)).ne.0.0)) then
        uvwlim(1,1)=uvwlim(1,1)*nu
        uvwlim(2,1)=uvwlim(2,1)*nu
        uvwlim(1,2)=uvwlim(1,2)*nv
        uvwlim(2,2)=uvwlim(2,2)*nv
        uvwlim(1,3)=uvwlim(1,3)*nw
        uvwlim(2,3)=uvwlim(2,3)*nw
       endif
       ouvwlim11=int(uvwlim(1,1))
       ouvwlim21=int(uvwlim(2,1))
       ouvwlim12=int(uvwlim(1,2))
       ouvwlim22=int(uvwlim(2,2))
       ouvwlim13=int(uvwlim(1,3))
       ouvwlim23=int(uvwlim(2,3))
      endif
cmdw argument to ccpmaplim needs to be 8 charcters long, hence spaces
      if (lxyzmtc) call ccpmaplim('MAPLIM  ')
      write (lpt,510)
     +  iuvwlim11,iuvwlim21,iuvwlim12,iuvwlim22,iuvwlim13,iuvwlim23,
     +  ouvwlim11,ouvwlim21,ouvwlim12,ouvwlim22,ouvwlim13,ouvwlim23
 510  format(
     +  /' INPUT  MASK EXTENT'/3(5x,i5,' :',i5)
     +  /' OUTPUT MASK EXTENT'/3(5x,i5,' :',i5)/)
c
      if (mapext.eq.0) then
       mapext=1
       if (ouvwlim11.lt.iuvwlim11.or.ouvwlim21.gt.iuvwlim21.or.
     +     ouvwlim12.lt.iuvwlim12.or.ouvwlim22.gt.iuvwlim22.or.
     +     ouvwlim13.lt.iuvwlim13.or.ouvwlim23.gt.iuvwlim23) mapext=2
      endif
c
      iu=iuvwlim21-iuvwlim11+1
      iv=iuvwlim22-iuvwlim12+1
      iw=iuvwlim23-iuvwlim13+1
      ou=ouvwlim21-ouvwlim11+1
      ov=ouvwlim22-ouvwlim12+1
      ow=ouvwlim23-ouvwlim13+1
c
      if (mskvol.gt.0.0) mskfrc=mskvol*(nu*nv*nw)/(ou*ov*ow)
c
      size1=iu*iv*iw
      size2=ou*ov*ow
      if(size1.le.0 .or. size2.le.0) go to 9060
c
      return
 9000 call ccperr(1,' rcards - error in input cards')
 9010 call ccperr(1,' rcards - error in AXIS card')
 9020 call ccperr(1,' rcards - error in MASK card')
 9030 call ccperr(1,' rcards - error in SCALE card')
 9040 call ccperr(1,' rcards - error in SOLV card')
 9050 call ccperr(1,' rcards - error in PRINT MAP/MASK axis')
 9060 call ccperr(1,' rcards - error in XYZLIM cards')
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmaplim(name)
      include 'mapmask.fh'
      include 'io.fh'
      include 'params.fh'
      include 'crystal.fh'
c CCPMAPlim - get limits of mask from file
      character name*8
c
      integer qxyz(3),qfmsi(3),quvwi(3),qsec,qode,q1(3),q2(3),mspgrp
      integer i,ifail,iprint
      real qmin,qmax,qmean,qrms,qcell(6)
      character qtitle*80
c read the file headers
      ifail=0
      iprint=1
      call mrdhds(lmap1,name,qtitle,qsec,qfmsi,qxyz,q1(3),q1(1),q2(1),
     +  q1(2),q2(2),qcell,mspgrp,qode,qmin,qmax,qmean,qrms,ifail,iprint)
      call mrclos(lmap1)
      q2(3)=q1(3)+qsec-1
      do 110 i=1,3
       quvwi(qfmsi(i))=i
 110  continue
      ouvwlim11=q1(quvwi(1))
      ouvwlim21=q2(quvwi(1))
      ouvwlim12=q1(quvwi(2))
      ouvwlim22=q2(quvwi(2))
      ouvwlim13=q1(quvwi(3))
      ouvwlim23=q2(quvwi(3))
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmaphead(name1,name2)
      include 'mapmask.fh'
      include 'io.fh'
      include 'params.fh'
      include 'crystal.fh'
c CCPMAPhead - get limits of mask from file
c
      character name1*8,name2*8
c
      integer mxyz(3),juvwi(3),msec,mode,m1(3),m2(3)
      integer qxyz(3),qfmsi(3),qsec,qode,q1(3),q2(3),mspgrp
      integer i,ifail,iprint
      real rmin,rmax,rmean,rrms,qmin,qmax,qmean,qrms,qcell(6)
      character title*80,qtitle*80
c
c read the file headers
      ifail=0
      iprint=1
c .. first file
      call mrdhds(lmap1,name1,title,msec,jfmsi,mxyz,m1(3),m1(1),m2(1),
     +  m1(2),m2(2),cell,nspgrp,mode,rmin,rmax,rmean,rrms,ifail,iprint)
      call mrclos(lmap1)
      m2(3)=m1(3)+msec-1
c .. second file - if present
      if (name2.ne.' ') then
       call mrdhds(lmap1,name2,qtitle,qsec,qfmsi,qxyz,q1(3),q1(1),q2(1),
     +  q1(2),q2(2),qcell,mspgrp,qode,qmin,qmax,qmean,qrms,ifail,iprint)
       call mrclos(lmap1)
       q2(3)=q1(3)+qsec-1
       do 100 i=1,3
        if (mxyz(i).ne.qxyz(i).or.jfmsi(i).ne.qfmsi(i).or.
     +        m1(i).ne.q1(i)  .or.   m2(i).ne.q2(i)   ) goto 9000
 100   continue
      endif
c
      do 110 i=1,3
       juvwi(jfmsi(i))=i
 110  continue
c
      nu=mxyz(1)
      nv=mxyz(2)
      nw=mxyz(3)
      iuvwlim11=m1(juvwi(1))
      iuvwlim21=m2(juvwi(1))
      iuvwlim12=m1(juvwi(2))
      iuvwlim22=m2(juvwi(2))
      iuvwlim13=m1(juvwi(3))
      iuvwlim23=m2(juvwi(3))
c
      return
 9000 call ccperr(1,' ccpmaphead - map heads on 1 and 2 do not match')
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmapin(map,name,title)
      include 'mapmask.fh'
      include 'io.fh'
      include 'params.fh'
      include 'crystal.fh'
c CCPMAPIN - read a ccp4 logical map and store in xyz order
c
      real map(iuvwlim11:iuvwlim21,iuvwlim12:iuvwlim22,
     +         iuvwlim13:iuvwlim23)
      character name*(*),title*(*)
      real lsec(0:maxsec)
c
      integer ifast,imedm,islow,lfast,lmedm,lslow,ierr,ifail,iprint
      integer m1(3),m2(3),ifms(3),juvwi(3),mxyz(3)
      integer i,iu,iv,iw,dum(3)
      integer nsec,mode,mspgrp
      real rmin,rmax,rmean,rrms,rho,mul,add,stepfn
c
      external stepfn
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
c now open map header and read map, re-ordering it as necessary
c
      ifail=0
      iprint=0
      call mrdhds(lmap1,name,title,nsec,dum,mxyz,m1(3),m1(1),m2(1),
     +  m1(2),m2(2),cell,mspgrp,mode,rmin,rmax,rmean,rrms,ifail,iprint)
      m2(3)=m1(3)+nsec-1
      do 110 i=1,3
       juvwi(jfmsi(i))=i
 110  continue
c fix the input mode - MAPIN reads as is, MSKIN applies a step function
      mode=index(name,'MAP')
c find out the map grid dimensions
      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
c
c now work out scaling factors
      if (mapscl.eq.0) then
       mul=mapmul
       add=mapadd
      else if (mapscl.eq.1) then
       mul=mapmul/rrms
       add=mapadd-mul*rmean
      else
       goto 9010
      endif
c
      if (lfast*lmedm.gt.maxsec) call ccperr(1,
     + ' ccpmapin - Map section > maxsec: change maxsec and recompile')
c now read the map in the order it is on file
      do 200 islow=0,lslow-1
c get a section
       ierr=0
       call mgulpr(lmap1,lsec,ierr)
       if (ierr.ne.0) call ccperr(1,' ccpmapin - ccp4 read error')
c now sort into uvw map
       ifms(3)=islow+m1(3)
       do 190 imedm=0,lmedm-1
       ifms(2)=imedm+m1(2)
       do 190 ifast=0,lfast-1
       ifms(1)=ifast+m1(1)
        iu=ifms(juvwi(1))
        iv=ifms(juvwi(2))
        iw=ifms(juvwi(3))
        rho=lsec(ifast+lfast*imedm)
        if (mode.eq.0) rho=stepfn(rho,0.5)
        map(iu,iv,iw)=rho*mul+add
 190   continue
 200  continue
c close the map file
      call mrclos(lmap1)
c
      write (lpt,910)
 910  format (/' MAP/MASK READ SUCCESSFUL'//)
c
      return
 9010 call ccperr(1,' ccpmapin - You need a mask for this SCALE option')
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmapsin(map,name1,name2,title)
      include 'mapmask.fh'
      include 'io.fh'
      include 'params.fh'
      include 'crystal.fh'
c CCPMAPSIN - read 2 ccp4 logical maps, combine and store in xyz order
c
      real map(iuvwlim11:iuvwlim21,iuvwlim12:iuvwlim22,
     +         iuvwlim13:iuvwlim23)
      character name1*(*),name2*(*),title*(*)
      real lsec1(0:maxsec),lsec2(0:maxsec)
c
      integer ifast,imedm,islow,lfast,lmedm,lslow,ierr,ifail,iprint
      integer m1(3),m2(3),ifms(3),juvwi(3),mxyz(3)
      integer i,iu,iv,iw,dum(3),mode1,mode2
      integer nsec,mode,mspgrp
      real rmin,rmax,rmean,rrms,rho,rho1,rho2,stepfn
      real ss,ssr,ssr2,sp,spr,spr2,rhop,rhos,stdp,stds,mul,add
c
      external stepfn
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
      ss=0.0
      ssr=0.0
      ssr2=0.0
      sp=0.0
      spr=0.0
      spr2=0.0
c
c now open map header and read map, re-ordering it as necessary
c
      ifail=0
      iprint=0
      call mrdhds(lmap2,name2,title,nsec,dum,mxyz,m1(3),m1(1),m2(1),
     +  m1(2),m2(2),cell,mspgrp,mode2,rmin,rmax,rmean,rrms,ifail,iprint)
      call mrdhds(lmap1,name1,title,nsec,dum,mxyz,m1(3),m1(1),m2(1),
     +  m1(2),m2(2),cell,mspgrp,mode1,rmin,rmax,rmean,rrms,ifail,iprint)
      m2(3)=m1(3)+nsec-1
      do 110 i=1,3
       juvwi(jfmsi(i))=i
 110  continue
c fix the input mode - MAPIN reads as is, MSKIN applies a step function
      mode1=index(name1,'MAP')
      mode2=index(name2,'MAP')
c find out the map grid dimensions
      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
c
      if (lfast*lmedm.gt.maxsec) call ccperr(1,
     + ' ccpmapin - Map section > maxsec: change maxsec and recompile')
c
c first pass - get stats on map
c
      do 200 islow=0,lslow-1
c get a section
       ierr=0
       call mposn(lmap1,islow+m1(3))
       call mgulpr(lmap1,lsec1,ierr)
       if (ierr.ne.0) call ccperr(1,' ccpmapsin - ccp4 read error')
       call mposn(lmap2,islow+m1(3))
       call mgulpr(lmap2,lsec2,ierr)
       if (ierr.ne.0) call ccperr(1,' ccpmapsin - ccp4 read error')
c now sort into uvw map
       ifms(3)=islow+m1(3)
       do 190 imedm=0,lmedm-1
       ifms(2)=imedm+m1(2)
       do 190 ifast=0,lfast-1
       ifms(1)=ifast+m1(1)
        iu=ifms(juvwi(1))
        iv=ifms(juvwi(2))
        iw=ifms(juvwi(3))
        rho1=lsec1(ifast+lfast*imedm)
        if (mode1.eq.0) rho1=stepfn(rho1,0.5)
        rho2=lsec2(ifast+lfast*imedm)
        if (mode2.eq.0) rho2=stepfn(rho2,0.5)
        if (rho2.ge.0.5) then
         sp  =sp  + 1.0
         spr =spr + rho1
         spr2=spr2+ rho1**2
        else
         ss  =ss  + 1.0
         ssr =ssr + rho1
         ssr2=ssr2+ rho1**2
        endif
 190   continue
 200  continue
c and calc stats
      rhop=spr/max(sp,1.0)
      rhos=ssr/max(ss,1.0)
      stdp=sqrt(max(sp*spr2-spr*spr,0.0))/max(sp,1.0)
      stds=sqrt(max(ss*ssr2-ssr*ssr,0.0))/max(ss,1.0)
c these scalings are for the solvent flattening options:
      if (mapscl.eq.0) then
       mul=mapmul
       add=mapadd
      else if (mapscl.eq.1) then
       mul=mapmul/rrms
       add=mapadd-mul*rmean
      else if (mapscl.eq.2) then
       mul=(meanp-means)/(rhop-rhos)
       add=means-mul*rhos
      else if (mapscl.eq.3) then
       mul=1.0
       add=ratio*stdp-rhop
      endif
      rhos=mul*rhos+add
      rhop=mul*rhop+add
      stds=mul*stds
      stdp=mul*stdp
c
c second pass - read and combine maps
c
      do 300 islow=0,lslow-1
c get a section
       ierr=0
       call mposn(lmap1,islow+m1(3))
       call mgulpr(lmap1,lsec1,ierr)
       if (ierr.ne.0) call ccperr(1,' ccpmapsin - ccp4 read error')
       call mposn(lmap2,islow+m1(3))
       call mgulpr(lmap2,lsec2,ierr)
       if (ierr.ne.0) call ccperr(1,' ccpmapsin - ccp4 read error')
c now sort into uvw map
       ifms(3)=islow+m1(3)
       do 290 imedm=0,lmedm-1
       ifms(2)=imedm+m1(2)
       do 290 ifast=0,lfast-1
       ifms(1)=ifast+m1(1)
        iu=ifms(juvwi(1))
        iv=ifms(juvwi(2))
        iw=ifms(juvwi(3))
        rho1=lsec1(ifast+lfast*imedm)
        if (mode1.eq.0) rho1=stepfn(rho1,0.5)
        rho2=lsec2(ifast+lfast*imedm)
        if (mode2.eq.0) rho2=stepfn(rho2,0.5)
c mapcmb mode: add, mult, flatten
        if (mapcmb.eq.1) then
         rho=rho1+rho2
        else if (mapcmb.eq.2) then
         rho=rho1*rho2
        else if (mapcmb.eq.3) then
         rho1=mul*rho1+add
         if (rho2.ge.0.5) then
          rho=max(rho1,rho1*attnu)
         else
          rho=rho1+flipfac*(rhos-rho1)
         endif
        else
         rho=rho1*mul+add
        endif
        map(iu,iv,iw)=rho
 290   continue
 300  continue
c close the map file
      call mrclos(lmap1)
      call mrclos(lmap2)
c
      write (lpt,910)
 910  format (/' MAP/MASK READ SUCCESSFUL')
      if (mapcmb.eq.3) write (lpt,920)mul,add,
     +  sp/(sp+ss),ss/(sp+ss),rhop,rhos,stdp,stds
 920  format (
     +  /' Scaling required during solvent flattening'
     +  /'    new density = ',f6.3,' * old density + ',f6.3
     +  /'                          Protein     Solvent'
     +  /' Cell fraction:     ',2f12.3
     +  /' Mean density :     ',2f12.3
     +  /' Std deviation:     ',2f12.3
     +  //)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      real function stepfn(x,y)
      include 'mapmask.fh'
c STEPFN - step function 0/1
      real x,y
      if (x.lt.y) then
       stepfn=0.0
      else
       stepfn=1.0
      endif
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmapout(map,title)
      include 'mapmask.fh'
      include 'io.fh'
      include 'params.fh'
      include 'crystal.fh'
c CCPMSKOUT - write a ccp4 logical mask and store in xyz order
c
      real map(ouvwlim11:ouvwlim21,ouvwlim12:ouvwlim22,
     +         ouvwlim13:ouvwlim23)
      character title*(*)
c
      real lsec(0:maxsec)
c
      integer ifast,imedm,islow,lfast,lmedm,lslow,ierr
      integer m1(3),m2(3),ifms(3),juvwo(3),mxyz(3)
      integer i,iu,iv,iw
      integer nsec,mode
      character axis(3)*1
c
      data axis/'X','Y','Z'/
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
c now open map header and read map, re-ordering it as necessary
c
      do 110 i=1,3
       juvwo(jfmso(i))=i
 110  continue
c
      mxyz(1)=nu
      mxyz(2)=nv
      mxyz(3)=nw
      m1(juvwo(1))=ouvwlim11
      m2(juvwo(1))=ouvwlim21
      m1(juvwo(2))=ouvwlim12
      m2(juvwo(2))=ouvwlim22
      m1(juvwo(3))=ouvwlim13
      m2(juvwo(3))=ouvwlim23
      nsec=m2(3)-m1(3)+1
      mode=2
c
      call mwrhdl(lmap1,'MAPOUT',title,nsec,jfmso,mxyz,
     +  m1(3),m1(1),m2(1),m1(2),m2(2),cell,nspgrp,mode)
      call msywrt(lmap1,nsym,rsym)
c
c find out the mask grid dimensions
      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
c
      if (lfast*lmedm.gt.maxsec) call ccperr(1,
     + ' ccpmapin - Mask section > maxsec: change maxsec and recompile')
c now write the map in the new order
      do 200 islow=0,lslow-1
c sort onto section
       ifms(3)=islow+m1(3)
       do 190 imedm=0,lmedm-1
       ifms(2)=imedm+m1(2)
       do 190 ifast=0,lfast-1
       ifms(1)=ifast+m1(1)
        iu=ifms(juvwo(1))
        iv=ifms(juvwo(2))
        iw=ifms(juvwo(3))
        lsec(ifast+lfast*imedm)=map(iu,iv,iw)
 190   continue
c write the section
       call mspew(lmap1,lsec)
 200  continue
c close the map file
      call mwclose(lmap1)
c
      write (lpt,800)cell,nspgrp,lfast,lmedm,lslow,
     +  m1(1),m2(1),m1(2),m2(2),m1(3),m2(3),
     +  axis(jfmso(1)),axis(jfmso(2)),axis(jfmso(3)),nu,nv,nw,
     +  ouvwlim11,ouvwlim21,ouvwlim12,ouvwlim22,ouvwlim13,ouvwlim23
 800  format (
     +  '    Cell ..........',6f10.5,/,'    Space group ...',i3,/,
     +  '    Number of columns, rows, sections ........',3i5,/,
     +  '    Start and stop points on cols, rows, secs.',3(i5,':',i4),/,
     +  '    Fast, medium, slow axes ..................',
     +  4x,a1,4x,a1,4x,a1,/,
     +  '    Grid sampling on x, y, z .................',3i5,/,
     +  '    Start and stop points on x, y, z .........',3(i5,':',i4),/)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmskout(mask,title)
      include 'mapmask.fh'
      include 'io.fh'
      include 'params.fh'
      include 'crystal.fh'
c CCPMSKOUT - write a ccp4 logical mask and store in xyz order
c
      real mask(ouvwlim11:ouvwlim21,ouvwlim12:ouvwlim22,
     +          ouvwlim13:ouvwlim23)
      character title*(*)
c
      real lsec(0:maxsec)
c
      integer ifast,imedm,islow,lfast,lmedm,lslow
      integer m1(3),m2(3),ifms(3),juvwo(3),mxyz(3)
      integer i,m,iu,iv,iw,si,sn
      integer nsec,mode
      character axis(3)*1
c
      data axis/'X','Y','Z'/
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
c now open map header and read map, re-ordering it as necessary
c
      do 110 i=1,3
       juvwo(jfmso(i))=i
 110  continue
c
      mxyz(1)=nu
      mxyz(2)=nv
      mxyz(3)=nw
      m1(juvwo(1))=ouvwlim11
      m2(juvwo(1))=ouvwlim21
      m1(juvwo(2))=ouvwlim12
      m2(juvwo(2))=ouvwlim22
      m1(juvwo(3))=ouvwlim13
      m2(juvwo(3))=ouvwlim23
      nsec=m2(3)-m1(3)+1
      mode=0
c
      call mwrhdl(lmap1,'MSKOUT',title,nsec,jfmso,mxyz,
     +  m1(3),m1(1),m2(1),m1(2),m2(2),cell,nspgrp,mode)
      call msywrt(lmap1,nsym,rsym)
c
c find out the mask grid dimensions
      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
c
      if (lfast*lmedm.gt.maxsec) call ccperr(1,
     + ' ccpmapin - Mask section > maxsec: change maxsec and recompile')
c now write the map in the new order
      sn=0
      si=0
      do 200 islow=0,lslow-1
c sort onto section
       ifms(3)=islow+m1(3)
       do 190 imedm=0,lmedm-1
       ifms(2)=imedm+m1(2)
       do 190 ifast=0,lfast-1
       ifms(1)=ifast+m1(1)
        iu=ifms(juvwo(1))
        iv=ifms(juvwo(2))
        iw=ifms(juvwo(3))
        i=0
        if (mask(iu,iv,iw).gt.mskcut) i=1
        call ccpstb(i,lsec,ifast+lfast*imedm+1)
        sn=sn+1
        si=si+i
 190   continue
c write the section
       call mspew(lmap1,lsec)
 200  continue
c close the map file
      call mwclose(lmap1)
c
      write (lpt,550)sn,(100.0*sn)/(nu*nv*nw),si,(100.0*si)/(nu*nv*nw),
     +  (100.0*si)/sn
 550  format (' OUTPUT MASK STATISTICS:',/,
     + ' Mask contains ',i9,' gridpoints,  or ',f6.1,' % of the cell',/,
     +    6x,'of which ',i9,' are set filling ',f6.1,' % of the cell',/,
     +                                38x,'or ',f6.1,' % of the mask',/)
c
      write (lpt,800)cell,nspgrp,lfast,lmedm,lslow,
     +  m1(1),m2(1),m1(2),m2(2),m1(3),m2(3),
     +  axis(jfmso(1)),axis(jfmso(2)),axis(jfmso(3)),nu,nv,nw,
     +  ouvwlim11,ouvwlim21,ouvwlim12,ouvwlim22,ouvwlim13,ouvwlim23
 800  format (
     +  '    Cell ..........',6f10.5,/,'    Space group ...',i3,/,
     +  '    Number of columns, rows, sections ........',3i5,/,
     +  '    Start and stop points on cols, rows, secs.',3(i5,':',i4),/,
     +  '    Fast, medium, slow axes ..................',
     +  4x,a1,4x,a1,4x,a1,/,
     +  '    Grid sampling on x, y, z .................',3i5,/,
     +  '    Start and stop points on x, y, z .........',3(i5,':',i4),/)
c
      if (sn.gt.nu*nv*nw) write (lpt,560)
 560  format (
     +  ' Warning: Box containing mask is bigger than the unit cell.',/)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine pdbbox(uvwlim)
      include 'mapmask.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
c
      real b(6),uvwlim(2,3)
c
      integer ifail,ixyzin,nread
      real biso,x,y,z,u,v,w,umin,vmin,wmin,umax,vmax,wmax,occ
c open coordinate file
      ifail=0
      IXYZIN = 0
      call XYZOPEN('XYZIN','INPUT',' ',IXYZIN,ifail)
      if (ifail.ne.0) goto 9000
c
      umax=-1000.0
      vmax=-1000.0
      wmax=-1000.0
      umin=1000.0
      vmin=1000.0
      wmin=1000.0
      nread=0
c Read atomic coordinates, convert to fractional
 300   continue
       call XYZADVANCE(IXYZIN,0,0,*300,*500)
       call XYZCOORD(IXYZIN,'O','U',x,y,z,occ,biso,b)
       if (b(2).ne.0.0 .or. b(3).ne.0.0) then
         if (x.eq.0.0 .and. y.eq.0.0 .and. z.eq.0.0) goto 300
       endif
       if (occ.le.0.0) goto 300

       nread=nread+1
c convert to fractional coordinates
       call orth2frac(x,y,z,u,v,w)
       umax=max(u,umax)
       vmax=max(v,vmax)
       wmax=max(w,wmax)
       umin=min(u,umin)
       vmin=min(v,vmin)
       wmin=min(w,wmin)
       goto 300
c done
 500  write (lpt,510)nread
 510  format (' Number of atoms read: ',i7)
c
      uvwlim(1,1)=min(u,umin)-border/cell(1)
      uvwlim(2,1)=max(u,umax)+border/cell(1)
      uvwlim(1,2)=min(v,vmin)-border/cell(2)
      uvwlim(2,2)=max(v,vmax)+border/cell(2)
      uvwlim(1,3)=min(w,wmin)-border/cell(3)
      uvwlim(2,3)=max(w,wmax)+border/cell(3)
c
      call XYZCLOSE(IXYZIN)
      return
 9000 call ccperr(1,' pdbbox - XYZIN error')
      end
c
c ----------------------------------------------------------------------
c
      subroutine maskcut(map)
      include 'mapmask.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
c maskcut - calc cutoff level to mask a certain volume
c
      real map(ouvwlim11:ouvwlim21,ouvwlim12:ouvwlim22,
     +         ouvwlim13:ouvwlim23)
c
      integer nhist
      parameter (nhist=10000)
      integer iu,iv,iw,lu,lv,lw,ncut
      integer ih,nh,hist(0:nhist)
      real rhomax,rhomin
c
      lu=ouvwlim21-ouvwlim11+1
      lv=ouvwlim22-ouvwlim12+1
      lw=ouvwlim23-ouvwlim13+1
c
      rhomin=1.0e12
      rhomax=-1.0e12
c
      do 50 ih=0,nhist
       hist(ih)=0
 50   continue
c
      do 100 iw=ouvwlim13,ouvwlim23
      do 100 iv=ouvwlim12,ouvwlim22
      do 100 iu=ouvwlim11,ouvwlim21
       rhomin=min(rhomin,map(iu,iv,iw))
       rhomax=max(rhomax,map(iu,iv,iw))
 100  continue
c
      do 200 iw=ouvwlim13,ouvwlim23
      do 200 iv=ouvwlim12,ouvwlim22
      do 200 iu=ouvwlim11,ouvwlim21
       ih=nint(nhist*(map(iu,iv,iw)-rhomin)/(rhomax-rhomin))
       hist(ih)=hist(ih)+1
 200  continue
c
      ncut=nint((1.0-mskfrc)*lu*lv*lw)
      nh=0
      do 300 ih=0,nhist-1
       nh=nh+hist(ih)
       if (nh.gt.ncut) goto 350
 300  continue
c
 350  mskcut=real(ih)*(rhomax-rhomin)/real(nhist)+rhomin
      write (lpt,500)100.0*mskfrc,mskcut
 500  format (/' Cutoff level to mask ',f6.1,' % of map = ',f6.3/)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine mapcopy(mapin,mapout)
      include 'mapmask.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
c mapcopy - copy map into a smaller or equal map, OR PAD
c
      real  mapin(iuvwlim11:iuvwlim21,iuvwlim12:iuvwlim22,
     +            iuvwlim13:iuvwlim23)
      real mapout(ouvwlim11:ouvwlim21,ouvwlim12:ouvwlim22,
     +            ouvwlim13:ouvwlim23)
c
      integer iu,iv,iw
c
      do 100 iw=ouvwlim13,ouvwlim23
      do 100 iv=ouvwlim12,ouvwlim22
      do 100 iu=ouvwlim11,ouvwlim21
        if (iu.ge.iuvwlim11.and.iu.le.iuvwlim21.and.
     +      iv.ge.iuvwlim12.and.iv.le.iuvwlim22.and.
     +      iw.ge.iuvwlim13.and.iw.le.iuvwlim23) then
          mapout(iu,iv,iw)=mapin(iu,iv,iw)
        else
          mapout(iu,iv,iw)=mappad
        endif
 100  continue
c
      write(lpt,210)
 210  format(
     +  /,' EXTEND COPY  mode',
     +  /,' Spacegroup symmetry and cell repeat will not be imposed',
     +  /,' on the map.',/,/)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine mapextend(mapin,mapout)
      include 'mapmask.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
c mapcopy - copy map into a larger map
c
      real mapin(iuvwlim11:iuvwlim21,iuvwlim12:iuvwlim22,
     +           iuvwlim13:iuvwlim23)
      real mapout(ouvwlim11:ouvwlim21,ouvwlim12:ouvwlim22,
     +            ouvwlim13:ouvwlim23)
c
      integer iu,iv,iw,ju,jv,jw,ku,kv,kw
      integer ju0(192),jv0(192),jw0(192),ju1(192),jv1(192),jw1(192)
      integer ju2(192),jv2(192),jw2(192)
      integer i,j,k,isym(4,4,192),lmod
      real r,uvw(4)
      external lmod
c
      uvw(1)=real(nu)
      uvw(2)=real(nv)
      uvw(3)=real(nw)
      uvw(4)=1.0
c make the integer symmetry matrices
      do 60 k=1,nsym
       do 50 j=1,4
        do 40 i=1,4
         r=uvw(i)*rsym(i,j,k)/uvw(j)
         isym(i,j,k)=nint(r)
         if (abs(r-nint(r)).gt.0.01) goto 9000
 40     continue
 50    continue
 60   continue
c apply them to the map
c  the matrix multiplication is factorised, steps are performed
c  by addition, with the origin offset calculated first.
      j=1
      do 101 k=1,nsym
       ju0(k)=isym(1,4,k)-iuvwlim11
       jv0(k)=isym(2,4,k)-iuvwlim12
       jw0(k)=isym(3,4,k)-iuvwlim13
 101  continue
      do 150 iw=ouvwlim13,ouvwlim23
       do 102 k=1,nsym
        ju1(k)=isym(1,3,k)*iw+ju0(k)
        jv1(k)=isym(2,3,k)*iw+jv0(k)
        jw1(k)=isym(3,3,k)*iw+jw0(k)
 102   continue
       do 140 iv=ouvwlim12,ouvwlim22
        do 103 k=1,nsym
         ju2(k)=isym(1,2,k)*iv+ju1(k)
         jv2(k)=isym(2,2,k)*iv+jv1(k)
         jw2(k)=isym(3,2,k)*iv+jw1(k)
 103    continue
        do 130 iu=ouvwlim11,ouvwlim21
c Note: we try all syms, but start with the one that worked last time
c (j) to save time.
         do 120 i=j,j+nsym-1
          k=mod(i-1,nsym)+1
          ju=isym(1,1,k)*iu+ju2(k)
          jv=isym(2,1,k)*iu+jv2(k)
          jw=isym(3,1,k)*iu+jw2(k)
          ku=lmod(ju,nu)+iuvwlim11
          kv=lmod(jv,nv)+iuvwlim12
          kw=lmod(jw,nw)+iuvwlim13
          if (ku.le.iuvwlim21.and.kv.le.iuvwlim22.and.
     +      kw.le.iuvwlim23) then
           mapout(iu,iv,iw)=mapin(ku,kv,kw)
           j=k
           goto 130
          endif
 120     continue
         if (mappad.lt.-0.99e6) goto 9010
         mapout(iu,iv,iw)=mappad
 130    continue
 140   continue
 150  continue
c
c
      write(lpt,510)
 510  format(
     +  /,' EXTEND XTAL  mode',
     +  /,' Spacegroup symmetry and cell repeat will be used to expand',
     +  /,' the map.',/,/)
c
      return
 9000 call ccperr(1,
     +  ' mapextend - grid dimensions incompatible with space group')
 9010 call ccperr(1,
     +  ' mapextend - input map does not contain a whole ASU')
      end
c
c ----------------------------------------------------------------------
c
      subroutine mapoverlap(mapin,mapout)
      include 'mapmask.fh'
      include 'io.fh'
      include 'crystal.fh'
      include 'params.fh'
c mapcopy - copy map into a larger map
c
      real mapin(iuvwlim11:iuvwlim21,iuvwlim12:iuvwlim22,
     +           iuvwlim13:iuvwlim23)
      real mapout(ouvwlim11:ouvwlim21,ouvwlim12:ouvwlim22,
     +            ouvwlim13:ouvwlim23)
c
      integer iu,iv,iw,ju,jv,jw,ku,kv,kw
      integer ju0(192),jv0(192),jw0(192),ju1(192),jv1(192),jw1(192)
      integer ju2(192),jv2(192),jw2(192)
      integer i,j,k,isym(4,4,192),lmod
      real r,uvw(4)
      external lmod
c
      uvw(1)=real(nu)
      uvw(2)=real(nv)
      uvw(3)=real(nw)
      uvw(4)=1.0
c
      do 20 iw=ouvwlim13,ouvwlim23
      do 20 iv=ouvwlim12,ouvwlim22
      do 20 iu=ouvwlim11,ouvwlim21
       mapout(iu,iv,iw)=-1.0e6
 20   continue
c make the integer symmetry matrices
      do 60 k=1,nsym
       do 50 j=1,4
        do 40 i=1,4
         r=uvw(i)*rsym(i,j,k)/uvw(j)
         isym(i,j,k)=nint(r)
         if (abs(r-nint(r)).gt.0.01) goto 9000
 40     continue
 50    continue
 60   continue
c apply them to the map
c  the matrix multiplication is factorised, steps are performed
c  by addition, with the origin offset calculated first.
      do 101 k=1,nsym
       ju0(k)=isym(1,4,k)-iuvwlim11
       jv0(k)=isym(2,4,k)-iuvwlim12
       jw0(k)=isym(3,4,k)-iuvwlim13
 101  continue
      do 150 iw=ouvwlim13,ouvwlim23
       do 102 k=1,nsym
        ju1(k)=isym(1,3,k)*iw+ju0(k)
        jv1(k)=isym(2,3,k)*iw+jv0(k)
        jw1(k)=isym(3,3,k)*iw+jw0(k)
 102   continue
       do 140 iv=ouvwlim12,ouvwlim22
        do 103 k=1,nsym
         ju2(k)=isym(1,2,k)*iv+ju1(k)
         jv2(k)=isym(2,2,k)*iv+jv1(k)
         jw2(k)=isym(3,2,k)*iv+jw1(k)
 103    continue
        do 130 iu=ouvwlim11,ouvwlim21
         do 120 k=1,nsym
          ju=isym(1,1,k)*iu+ju2(k)
          jv=isym(2,1,k)*iu+jv2(k)
          jw=isym(3,1,k)*iu+jw2(k)
          do 110 ku=lmod(ju,nu)+iuvwlim11,iuvwlim21,nu
          do 110 kv=lmod(jv,nv)+iuvwlim12,iuvwlim22,nv
          do 110 kw=lmod(jw,nw)+iuvwlim13,iuvwlim23,nw
           mapout(iu,iv,iw)=max(mapout(iu,iv,iw),mapin(ku,kv,kw))
 110      continue
 120     continue
         if (mapout(iu,iv,iw).lt.-0.99e6) mapout(iu,iv,iw)=mappad
         if (mapout(iu,iv,iw).lt.-0.99e6) goto 9010
 130    continue
 140   continue
 150  continue
c
c
      write(lpt,510)
 510  format(
     +  /,' EXTEND OVERLAP  mode',
     +  /,' Spacegroup symmetry and cell repeat will be used to expand',
     +  /,' the map, and the maximum of overlapping values taken.',/,/)
c
      return
 9000 call ccperr(1,
     +  ' mapoverlap - grid dimensions incompatible with space group')
 9010 call ccperr(1,
     +  ' mapoverlap - map does not contain a whole ASU')
      end
c
c ----------------------------------------------------------------------
c
      subroutine lpsec(mapout)
      include 'mapmask.fh'
      include 'io.fh'
      include 'params.fh'
      include 'crystal.fh'
c lpmap - print map or mask sections to the log file
      real mapout(ouvwlim11:ouvwlim21,ouvwlim12:ouvwlim22,
     +            ouvwlim13:ouvwlim23)
c
      real sec(0:maxsec)
      integer iu,iv,iw,lu,lv,lw
c
      lu=ouvwlim21-ouvwlim11+1
      lv=ouvwlim22-ouvwlim12+1
      lw=ouvwlim23-ouvwlim13+1
c
      if (praxis.eq.1) then
c X section
       if (prfirst.lt.ouvwlim11.or.prlast.gt.ouvwlim21) goto 910
       do 150 iu=prfirst,prlast,prstep
        do 110 iw=0,lw-1
        do 110 iv=0,lv-1
         sec(iv+lv*iw)=mapout(iu,iv+ouvwlim12,iw+ouvwlim13)
 110    continue
       if (prtype.eq.1) call lpprmap(sec,lv,lw,iu)
       if (prtype.eq.2) call lpenvelope(sec,lv,lw,iu)
 150   continue
c
      else if (praxis.eq.2) then
c Y section
       if (prfirst.lt.ouvwlim12.or.prlast.gt.ouvwlim22) goto 910
       do 250 iv=prfirst,prlast,prstep
        do 210 iu=0,lu-1
        do 210 iw=0,lw-1
         sec(iw+lw*iu)=mapout(iu+ouvwlim11,iv,iw+ouvwlim13)
 210    continue
       if (prtype.eq.1) call lpprmap(sec,lw,lu,iv)
       if (prtype.eq.2) call lpenvelope(sec,lw,lu,iv)
 250   continue
c
      else if (praxis.eq.3) then
c Z section
       if (prfirst.lt.ouvwlim13.or.prlast.gt.ouvwlim23) goto 910
       do 350 iw=prfirst,prlast,prstep
        do 310 iv=0,lv-1
        do 310 iu=0,lu-1
         sec(iu+lu*iv)=mapout(iu+ouvwlim11,iv+ouvwlim12,iw)
 310    continue
       if (prtype.eq.1) call lpprmap(sec,lu,lv,iw)
       if (prtype.eq.2) call lpenvelope(sec,lu,lv,iw)
 350   continue
c
      endif
c
      return
 910  call ccperr(1,'lpmap - attempt to print beyond map limits')
      end
c
c ----------------------------------------------------------------------
c
      subroutine lpprmap(section,mu,mv,mw)
c print map section (from prmap.f)
      include 'mapmask.fh'
      include 'io.fh'
      include 'params.fh'
c
      integer mu,mv,mw
      real section(mu,mv)
c
      integer i1,i2,i,j,k,l,npage,ni
c
c
      i1=0
c
      npage=(mu-1)/25+1
c
      do 22 k=1,npage
       write(6,21)mw,k
 21    format(/////'  section',i6,100x,'page',i5//)
       i2=i1+24
       if (i2.gt.mu) i2=mu-1
       ni=i2-i1+1
c
       write(6,11)(i+i1-1,i=1,ni)
 11    format(7x,25i5)
       write(lpt,11)
c
       do 23 j=1,mv
        write(lpt,25)j-1,(nint(section(i+i1,j)),i=1,ni)
 25     format(3x,i4,25i5)
 23    continue
c
       i1=i2+1
 22   continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine lpenvelope(rhosec,mu,mv,mw)
c print mask sections (Andrew Leslie's envelope program)
      include 'mapmask.fh'
      include 'io.fh'
      include 'params.fh'
c
      integer mu,mv,mw
      real rhosec(mu,mv)
c
      integer ii,i,j,nstep
      character*1 rprt(600)
c
      write(lpt,130)
 130  format(/' NOTE:'/'  IN THE FOLLOWING DIAGRAMS, THE PROTEIN ',
     +   'REGIONS ARE REPRESENTED BY THE'/'  BLANK SPACE WHILE THE',
     +   ' SOLVENT REGIONS ARE INDICATED BY STARS, *'//
     +   '  FIGURES ARE IN U-V SECTIONS WITH U-AXIS HORIZONTAL.',
     +   '  THE UPPER LEFT CORNER'/'  IS THE ORIGIN.'/)
c
      nstep=mu/128+1
c
        write(lpt,140) mw
 140    format('1'//30x,'section',i4/)
        do 52 j=1,mv
          rprt(1)='.'
          if (rhosec(1,j).le.mskcut) rprt(1)='*'
          do 54 i=2,mu
            rprt(i)=' '
            if (rhosec(i,j).le.mskcut) rprt(i)='*'
 54       continue
          write(lpt,150) j,(rprt(ii),ii=1,mu,nstep)
 150      format(1x,i3,1x,600a)
 52     continue
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine frac2orth(u,v,w,x,y,z)
      include 'mapmask.fh'
      include 'crystal.fh'
      real u,v,w,x,y,z
      x=q(1,1)*u+q(1,2)*v+q(1,3)*w+q(1,4)
      y=q(2,1)*u+q(2,2)*v+q(2,3)*w+q(2,4)
      z=q(3,1)*u+q(3,2)*v+q(3,3)*w+q(3,4)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine orth2frac(x,y,z,u,v,w)
      include 'mapmask.fh'
      include 'crystal.fh'
      real u,v,w,x,y,z
      u=qt(1,1)*x+qt(1,2)*y+qt(1,3)*z+qt(1,4)
      v=qt(2,1)*x+qt(2,2)*y+qt(2,3)*z+qt(2,4)
      w=qt(3,1)*x+qt(3,2)*y+qt(3,3)*z+qt(3,4)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine calcmetric()
      include 'mapmask.fh'
      include 'io.fh'
      include 'crystal.fh'
c Calculate the orthonormal - crystallographic transform
c
      integer i,j
      real a,b,c,alph,beta,gamm,sum,cosas,q123
c
      do 10 j=1,4
      do 10 i=1,4
      q(i,j)=0.0
      qt(i,j)=0.0
 10   continue
c
      a=cell(1)
      b=cell(2)
      c=cell(3)
      alph=dtor*cell(4)
      beta=dtor*cell(5)
      gamm=dtor*cell(6)
      sum=0.5*(alph+beta+gamm)
      vol=2.0*a*b*c*
     + sqrt(sin(sum)*sin(sum-alph)*sin(sum-beta)*sin(sum-gamm))
      cosas=(cos(beta)*cos(gamm)-cos(alph))/(sin(beta)*sin(gamm))
c orthogonalisation matrix
      q(1,1)=a
      q(1,2)=b*cos(gamm)
      q(1,3)=c*cos(beta)
      q(2,2)=b*sin(gamm)
      q(2,3)=-c*sin(beta)*cosas
      q(3,3)=c*sin(beta)*sqrt(1.0-cosas**2)
      q(4,4)=1.0
c and its inverse
      q123=q(1,1)*q(2,2)*q(3,3)
      qt(1,1)=1.0/q(1,1)
      qt(1,2)=-q(1,2)*q(3,3)/q123
      qt(1,3)=(q(1,2)*q(2,3)-q(2,2)*q(1,3))/q123
      qt(2,2)=1.0/q(2,2)
      qt(2,3)=-q(1,1)*q(2,3)/q123
      qt(3,3)=1.0/q(3,3)
      qt(4,4)=1.0
c
      write (lpt,4)vol
 4    format (' Unit cell volume:',f10.1)
      write (lpt,1)((q(i,j),j=1,3),(qt(i,j),j=1,3),i=1,3)
 1    format (' Orthogonalisation matrices:',3(/1x,3f8.3,8x,3f8.3))
c Calculate real space metric tensor
      rlm11=q(1,1)*q(1,1)+q(2,1)*q(2,1)+q(3,1)*q(3,1)
      rlm12=2.0*(q(1,1)*q(1,2)+q(2,1)*q(2,2)+q(3,1)*q(3,2))
      rlm13=2.0*(q(1,1)*q(1,3)+q(2,1)*q(2,3)+q(3,1)*q(3,3))
      rlm22=q(1,2)*q(1,2)+q(2,2)*q(2,2)+q(3,2)*q(3,2)
      rlm23=2.0*(q(1,2)*q(1,3)+q(2,2)*q(2,3)+q(3,2)*q(3,3))
      rlm33=q(1,3)*q(1,3)+q(2,3)*q(2,3)+q(3,3)*q(3,3)
      write (lpt,2)rlm11,rlm22,rlm33,rlm12,rlm13,rlm23
 2    format (' Real space metric tensor:      '/1x,6f9.1)
c Calculate reciprocal space metric tensor
      rcm11=qt(1,1)*qt(1,1)+qt(1,2)*qt(1,2)+qt(1,3)*qt(1,3)
      rcm12=2.0*(qt(1,1)*qt(2,1)+qt(1,2)*qt(2,2)+qt(1,3)*qt(2,3))
      rcm13=2.0*(qt(1,1)*qt(3,1)+qt(1,2)*qt(3,2)+qt(1,3)*qt(3,3))
      rcm22=qt(2,1)*qt(2,1)+qt(2,2)*qt(2,2)+qt(2,3)*qt(2,3)
      rcm23=2.0*(qt(2,1)*qt(3,1)+qt(2,2)*qt(3,2)+qt(2,3)*qt(3,3))
      rcm33=qt(3,1)*qt(3,1)+qt(3,2)*qt(3,2)+qt(3,3)*qt(3,3)
      write (lpt,3)rcm11,rcm22,rcm33,rcm12,rcm13,rcm23
 3    format (' Reciprocal space metric tensor:'/1x,6f9.6)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine symmatmul(a,b,c)
      include 'mapmask.fh'
c symmetmaul - 4x4 matrix multiply, c=a*b
      real a(4,4),b(4,4),c(4,4)
      integer i,j,k
c
      do 20 k=1,4
      do 20 i=1,4
      c(i,k)=0.0
      do 20 j=1,4
      c(i,k)=c(i,k)+a(i,j)*b(j,k)
20    continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine symuvw(mat,u,v,w,u1,v1,w1)
      include 'mapmask.fh'
c symuvw - multiply a 4-matrix by a 3-vector
      real mat(4,4),u,v,w,u1,v1,w1
      u1=mat(1,1)*u+mat(1,2)*v+mat(1,3)*w+mat(1,4)
      v1=mat(2,1)*u+mat(2,2)*v+mat(2,3)*w+mat(2,4)
      w1=mat(3,1)*u+mat(3,2)*v+mat(3,3)*w+mat(3,4)
      return
      end
c
c ----------------------------------------------------------------------
c
      real function rfracp(x)
      include 'mapmask.fh'
c fractional part -0.5:0.5
      real x
      rfracp=x-real(nint(x))
      return
      end
c
c ----------------------------------------------------------------------
c
      integer function lmod(i,j)
      include 'mapmask.fh'
c fixed integer mod (optimised for 0<=i<j)
      integer i,j,k
c
      if (i.lt.0) then
       lmod=mod(i+1,j)+j-1
      else if (i.ge.j) then
       lmod=mod(i,j)
      else
       lmod=i
      endif
      return
      end
c
c ----------------------------------------------------------------------
c
