C
C     MAPROT in core map rotation
C     Copyright (C) 1996-2004 Kevin Cowtan
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
c
c ----------------------------------------------------------------------
c
c in core map rotation - Kevin Cowtan
c
C     See the conditions in the CCP4 manual for a copyright statement.
C
C ADDENDUM
C    If any local or global legislation renders the 'No Warranty'
C    clause illegal or reduces the scope of its content and protection
C    for author(s) in any way, then this whole license shall be null
C    and void, i.e. you may not copy, install any software provided
C    under this license, and any such action will be a breach of
C    the author's copyright.
C
c ----------------------------------------------------------------------
c
      program maprot
      include 'maprot.fh'
      include 'io.fh'
      include 'crystals.fh'
      include 'params.fh'
c
      integer size1,size2,size3,sizes(8)
      character types(8)*1
c
      integer lunsto,lunsti,ccpnun,idum
      external maprotmain,lunsto,lunsti,ccpnun
c
      data types /'R','R','R','R','R','R','R','R'/
c
      call ccpfyp
      call ccprcs (6, 'maprot', '$Date: 2005/09/06 11:29:36 $')
c
      idum=0
      lpt=lunsto(idum)
      lcd=lunsti(idum)
      ltmp=ccpnun()
      lmap1=ccpnun()+1
      lmap2=ccpnun()+2
c
      call rcards(size1,size2,size3)
c
      sizes(1)=size1
      sizes(2)=size2
      sizes(3)=size3
      sizes(4)=size3
      call ccpalc(maprotmain,4,types,sizes)
c
      call ccperr(0,' (maprot) - normal termination ')
      end
c
c ----------------------------------------------------------------------
c
      subroutine maprotmain(nmap,map,nwrk,wrk,nwrk1,wrk1,nwrk2,wrk2)
      include 'maprot.fh'
      include 'io.fh'
      include 'crystals.fh'
      include 'params.fh'
      include 'grids.fh'
c maprot main program
      integer nmap,nwrk,nwrk1,nwrk2
      real map(nmap),wrk(nwrk),wrk1(nwrk1),wrk2(nwrk2)
c
      integer i
      integer lu1,lv1,lw1,lu2,lv2,lw2,cutspgrp
      character*240 title,title1
c
      do 100 i=1,nmap
       map(i)=0.0
 100  continue
      do 110 i=1,nwrk
       wrk(i)=0.0
 110  continue
      do 120 i=1,nwrk1
       wrk1(i)=0.0
       wrk2(i)=0.0
 120  continue
c
c read in maps and masks
      title="map from maprot"
      if (lmapin)
     +  call ccpmapin('MAPIN',title,map,mu1,mv1,mw1,mu2,mv2,mw2)
      if (lwrkin)
     +  call ccpmapin('WRKIN',title1,wrk,wu1,wv1,ww1,wu2,wv2,ww2)
      if (lmskin)
     +  call ccpmskin('MSKIN',title1,wrk,wu1,wv1,ww1,wu2,wv2,ww2)
c
c do some skewing/averaging
      if (lfrom) then
       do 200 i=1,ncsym
        write (lpt,220)'from',i
        call doaveragefrom(
     +    map,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,
     +    wrk,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2,
     +    rsymncs(1,1,i))
 200   continue
      endif
      call doscale(wrk,wu1,wv1,ww1,wu2,wv2,ww2,rscale)
      if (lto) then
       do 210 i=1,ncsym
        write (lpt,220)'to',i
        call doaverageto(
     +    map,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,
     +    wrk,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2,
     +    rsymncs(1,1,i),lu1,lv1,lw1,lu2,lv2,lw2)
 210   continue
      endif
      if (lcorr) call mrcorrel(
     +    map,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,
     +    wrk,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2,
     +    wrk1,wrk2)
 220  format ('Mapping density ',a,' cell using operator ',i3)
c
c strip mask flags
      call stripflag(map,mu1,mv1,mw1,mu2,mv2,mw2)
      call stripflag(wrk,wu1,wv1,ww1,wu2,wv2,ww2)
c
c write out maps
      if (lwrkout) call ccpmapout('WRKOUT',title,wrk,wspgrp,wcell,
     +  wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2,wu1,wv1,ww1,wu2,wv2,ww2)
      if (lmapout) call ccpmapout('MAPOUT',title,map,mspgrp,mcell,
     +  mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,mu1,mv1,mw1,mu2,mv2,mw2)
      cutspgrp=1
      if (lcutout) call ccpmapout('CUTOUT',title,map,cutspgrp,mcell,
     +  mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,lu1,lv1,lw1,lu2,lv2,lw2)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine rcards(size1,size2,size3)
      include 'maprot.fh'
      include 'io.fh'
      include 'crystals.fh'
      include 'params.fh'
      include 'grids.fh'
c rcards - read input cards
c
      integer size1,size2,size3
c
      integer i,j,k,ncrot,nctrn
      real alpha,beta,gamma,omega,phi,kappa,u1,v1,w1,u2,v2,w2
      real symmat(4,4)
      logical cont,laver,lrota,ltran,lomat,leule,lpola,lxyzl,linvm,lflag
      character namspg*20,nampg*20,line*600
c
c
c set defaults
c
      rscale=1.0
      radcrm=8.0
      lfrom=.false.
      lto  =.false.
      lcorr=.false.
      lxyzl=.false.
      linvm=.false.
      ncrot=0
      nctrn=0
      ncsym=0
      mcell(3)=-1.0
      wcell(3)=-1.0
      mw=-1
      ww=-1
      mspgrp=1
      wspgrp=1
c
c
      do 920 k=1,200
       do 910 i=1,4
        do 900 j=1,4
         rsymncs(i,j,k)=0.0
 900    continue
        rsymncs(i,i,k)=1.0
 910   continue
 920  continue
      do 930 i=4,6
       mcell(i)=90.0
       wcell(i)=90.0
 930  continue
c
c now try and get cell/symm from file
      call ugtenv('MAPIN',line)
      lmapin=(line.ne.' ')
      call ugtenv('WRKIN',line)
      lwrkin=(line.ne.' ')
      call ugtenv('MSKIN',line)
      lmskin=(line.ne.' ')
      call ugtenv('MAPOUT',line)
      lmapout=(line.ne.' ')
      call ugtenv('WRKOUT',line)
      lwrkout=(line.ne.' ')
      call ugtenv('CUTOUT',line)
      lcutout=(line.ne.' ')
c
      if (lwrkin) call ccpmaphead(
     +  'WRKIN   ',wspgrp,wcell,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2)
      if (lmskin) call ccpmaphead(
     +  'MSKIN   ',wspgrp,wcell,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2)
      if (lmapin) then
       call ccpmaphead(
     +  'MAPIN   ',mspgrp,mcell,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2)
       if (mu1.ne.0.or.mv1.ne.0.or.mw1.ne.0.or.
     +     mu2.ne.mu-1.or.mv2.ne.mv-1.or.mw2.ne.mw-1)
     +  call ccperr(1,' ERROR - input map must cover unit cell')
      endif
c
c now parse input --------------------
c
 1000 call memoparse(.true.)
c
      laver=.false.
      lrota=.false.
      ltran=.false.
      lomat=.false.
      leule=.false.
      lpola=.false.
      call parsesubkey('AVER','    ',laver)
      call parsesubkey('ROTA','    ',lrota)
      call parsesubkey('TRAN','    ',ltran)
      call parsesubkey('OMAT','    ',lomat)
      call parsesubkey('ROTA','EULE',leule)
      call parsesubkey('ROTA','POLA',lpola)
      if (laver) ncsym=ncsym+1
      if (lomat.or.lrota) ncrot=ncrot+1
      if (lomat.or.ltran) nctrn=nctrn+1
c AVER
      call parsesubint('AVER','    ',1,.false.,ncsym)
c MODE
      call parsesubkey('MODE','FROM',lfrom)
      call parsesubkey('MODE','TO'  ,lto  )
      call parsesubkey('MODE','BOTH',lfrom)
      call parsesubkey('MODE','BOTH',lto  )
      call parsesubkey('MODE','CORR',lcorr)
c SCAL
      call parsereal('SCAL',rscale)
c RADI
      call parsereal('RADI',radcrm)
c CELL (Including depracated form)
      lflag=.false.
      call parsesubkey('CELL','WORK',lflag)
      call parsesubkey('CELL','XTAL',lflag)
      do i=1,6
       if(.not.lflag)call parsesubreal('CELL','    ',i,.false.,wcell(i))
       call parsesubreal('CELL','WORK',i,(i.le.3),wcell(i))
       call parsesubreal('CELL','XTAL',i,(i.le.3),mcell(i))
      enddo
c SYMM (Including depracated form)
      lflag=.false.
      call parsesubkey('SYMM','WORK',lflag)
      call parsesubkey('SYMM','XTAL',lflag)
      if(.not.lflag)call parsesymm(namspg,wspgrp,nampg,wsym,wsymp,wrsym)
      call parsesubint('SYMM','WORK',1,.true.,wspgrp)
      call parsesubint('SYMM','XTAL',1,.true.,mspgrp)
c GRID (Including depracated form)
      lflag=.false.
      call parsesubkey('GRID','WORK',lflag)
      call parsesubkey('GRID','XTAL',lflag)
      if(.not.lflag)call parsesubint('GRID','    ',1,.false.,wu)
      if(.not.lflag)call parsesubint('GRID','    ',2,.false.,wv)
      if(.not.lflag)call parsesubint('GRID','    ',3,.false.,ww)
      call parsesubint('GRID','WORK',1,.true.,wu)
      call parsesubint('GRID','WORK',2,.true.,wv)
      call parsesubint('GRID','WORK',3,.true.,ww)
      call parsesubint('GRID','XTAL',1,.true.,mu)
      call parsesubint('GRID','XTAL',2,.true.,mv)
      call parsesubint('GRID','XTAL',3,.true.,mw)
c XYZLIM
      call parsesubkey ('XYZL','    ',lxyzl)
      call parsesubreal('XYZL','    ',1,.true.,u1)
      call parsesubreal('XYZL','    ',2,.true.,u2)
      call parsesubreal('XYZL','    ',3,.true.,v1)
      call parsesubreal('XYZL','    ',4,.true.,v2)
      call parsesubreal('XYZL','    ',5,.true.,w1)
      call parsesubreal('XYZL','    ',6,.true.,w2)
c ROTA
      call parsesubreal('ROTA','EULE',1,.true.,alpha)
      call parsesubreal('ROTA','EULE',2,.true.,beta)
      call parsesubreal('ROTA','EULE',3,.true.,gamma)
      call parsesubreal('ROTA','POLA',1,.true.,omega)
      call parsesubreal('ROTA','POLA',2,.true.,phi)
      call parsesubreal('ROTA','POLA',3,.true.,kappa)
      call parsesubreal('ROTA','MATR',1,.true.,rsymncs(1,1,ncrot))
      call parsesubreal('ROTA','MATR',2,.true.,rsymncs(1,2,ncrot))
      call parsesubreal('ROTA','MATR',3,.true.,rsymncs(1,3,ncrot))
      call parsesubreal('ROTA','MATR',4,.true.,rsymncs(2,1,ncrot))
      call parsesubreal('ROTA','MATR',5,.true.,rsymncs(2,2,ncrot))
      call parsesubreal('ROTA','MATR',6,.true.,rsymncs(2,3,ncrot))
      call parsesubreal('ROTA','MATR',7,.true.,rsymncs(3,1,ncrot))
      call parsesubreal('ROTA','MATR',8,.true.,rsymncs(3,2,ncrot))
      call parsesubreal('ROTA','MATR',9,.true.,rsymncs(3,3,ncrot))
c TRAN
      call parsesubreal('TRAN','    ',1,.true.,rsymncs(1,4,nctrn))
      call parsesubreal('TRAN','    ',2,.true.,rsymncs(2,4,nctrn))
      call parsesubreal('TRAN','    ',3,.true.,rsymncs(3,4,nctrn))
c INVE
      call parsesubkey ('INVE','    ',linvm)
c
c deal with special input keywords
      if (lomat) read (lcd,*)((rsymncs(i,j,ncrot),i=1,3),j=1,4)
      if (leule) call eulertomatrix(alpha,beta,gamma,rsymncs(1,1,ncrot))
      if (lpola) call polartomatrix(omega,phi ,kappa,rsymncs(1,1,ncrot))
c
      call parsediagnose(cont)
      if (cont) goto 1000
c
c NOW SET UP and CHECK THINGS --------------------
c
C   If MODE TO or BOTH must have at least MAPOUT assigned
C   If MODE FROM must have WRKOUT assigned
c MODE
C    LFROM .AND. .NOT.LTO   = MODE FROM
C    LFROM .AND.      LTO   = MODE BOTH
C    LTO .AND. .NOT.LFROM   = MODE TO
      IF ( (lfrom .AND. .NOT.lto  ) .AND. .NOT.(lwrkout) )
     +  CALL CCPERR(1,' MODE FROM requires a WRKOUT assignment')
      IF ( (lto   .AND. .NOT.lfrom) .AND. .NOT.(lmapout.OR.lcutout) )
     +  CALL CCPERR(1,' MODE TO requires a MAPOUT or CUTOUT assignment')
      IF ( (lto   .AND. lfrom     ) .AND. .NOT.(lmapout) )
     +  CALL CCPERR(1,' MODE BOTH requires a MAPOUT assignment')
      IF ( (lcutout) .AND. .NOT.(LTO) )
     +  CALL CCPERR(1,' CUTOUT assignment requires MODE TO')
      if (mcell(3).lt.0.0.or.mw.lt.0) call ccperr
     +  (1,' Missing MAPIN file or cell map CELL/GRID keywords')
      if (wcell(3).lt.0.0.or.ww.lt.0) call ccperr
     +  (1,' Missing WRKIN/MSKIN file or work map CELL/GRID keywords')
      if (ncrot.ne.ncsym.or.nctrn.ne.ncsym) goto 9000
      if (ncsym.eq.0) goto 9010
      if (.not.(lfrom.or.lto.or.lcorr)) goto 9020
c inver matrices if neccessary
      if (linvm) then
       do j=1,ncsym
        call ccpmvr(symmat,rsymncs(1,1,j),16)
        call invsym(symmat,rsymncs(1,1,j))
       enddo
      endif
c limits
      if (lxyzl) then
       if ((u2-u1)*(v2-v1)*(w2-w1).lt.8.5) then
        u1=u1*wu
        v1=v1*wv
        w1=w1*ww
        u2=u2*wu
        v2=v2*wv
        w2=w2*ww
       endif
       wu1=nint(u1)
       wv1=nint(v1)
       ww1=nint(w1)
       wu2=nint(u2)
       wv2=nint(v2)
       ww2=nint(w2)
      endif
      if (.not.lmapin) then
       mu1=0
       mv1=0
       mw1=0
       mu2=mu-1
       mv2=mv-1
       mw2=mw-1
      endif
c
c symmetry
      namspg=' '
      call msymlb(ltmp,mspgrp,namspg,nampg,msym,msymp,mrsym)
      namspg=' '
      call msymlb(ltmp,wspgrp,namspg,nampg,wsym,wsymp,wrsym)
c
c matrics
      call calcmetric(mcell,mvol,mq,mqt,
     +                mrlm11,mrlm12,mrlm13,mrlm22,mrlm23,mrlm33,
     +                mrcm11,mrcm12,mrcm13,mrcm22,mrcm23,mrcm33)
      call calcmetric(wcell,wvol,wq,wqt,
     +                wrlm11,wrlm12,wrlm13,wrlm22,wrlm23,wrlm33,
     +                wrcm11,wrcm12,wrcm13,wrcm22,wrcm23,wrcm33)
c
      size1=(mu2-mu1+1)*(mv2-mv1+1)*(mw2-mw1+1)
      size2=(wu2-wu1+1)*(wv2-wv1+1)*(ww2-ww1+1)
      size3=256
      if (lcorr) size3=size2
c
      return
 9000 call ccperr(1,' rcards - wrong number of operaters entered')
 9010 call ccperr(1,' rcards - no AVER oerations entered')
 9020 call ccperr(1,' rcards - no MODE keyword specified')
      end
c
c ----------------------------------------------------------------------
c
      subroutine doaveragefrom(
     +  map,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,
     +  wrk,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2,
     +  rotncs)
c DOAVERAGEFROM - single step average from unit cell into domain mask
      include 'maprot.fh'
      include 'crystals.fh'
c
      integer mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2
      integer wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2
      real map(mu1:mu2,mv1:mv2,mw1:mw2),wrk(wu1:wu2,wv1:wv2,ww1:ww2)
      real rotncs(4,4)
c
      integer iu,iv,iw
      real du,dv,dw,xu,xv,xw,temp(4,4),dtox(4,4)
c
      real gridinterp
      external gridinterp
c
      call symmatmul(rotncs,wq,temp)
      call symmatmul(mqt,temp,dtox)
c
      do 500 iw=ww1,ww2
      do 500 iv=wv1,wv2
      do 500 iu=wu1,wu2
       if (wrk(iu,iv,iw).gt.-500.0) then
        du=real(iu)/wu
        dv=real(iv)/wv
        dw=real(iw)/ww
        call symuvw(dtox,du,dv,dw,xu,xv,xw)
        wrk(iu,iv,iw)=wrk(iu,iv,iw)+gridinterp
     +    (map,xu*mu,xv*mv,xw*mw,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2)
       endif
 500  continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine doaverageto(
     +  map,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,
     +  wrk,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2,
     +  rotncs,lu1,lv1,lw1,lu2,lv2,lw2)
c DOAVERAGETO - single step average from domain mask into unit cell
      include 'maprot.fh'
      include 'io.fh'
      include 'crystals.fh'
c
      integer mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2
      integer wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2
      integer lu1,lv1,lw1,lu2,lv2,lw2
      real map(mu1:mu2,mv1:mv2,mw1:mw2),wrk(wu1:wu2,wv1:wv2,ww1:ww2)
      real rotncs(4,4)
c
      integer i,j,k,isym(4,4,192)
      integer iu,iv,iw,ju,jv,jw,ku,kv,kw
      real du,dv,dw,xu,xv,xw,temp(4,4),dtox(4,4),xtod(4,4)
      real a,b,s,sa,sb,sa2,sb2,sab,r,uvw(4)
c
      real gridinterp
      integer lmod
      logical gridinside
      external gridinterp,gridinside,lmod
c
c make the integer symmetry matrices
      uvw(1)=real(mu)
      uvw(2)=real(mv)
      uvw(3)=real(mw)
      uvw(4)=1.0
      do 60 k=1,msym
       do 50 j=1,4
        do 40 i=1,4
         r=uvw(i)*mrsym(i,j,k)/uvw(j)
         isym(i,j,k)=nint(r)
         if (abs(r-nint(r)).gt.0.01) goto 9000
 40     continue
 50    continue
 60   continue
c
c make the inverse symmetry operation
      call symmatmul(rotncs,wq,temp)
      call symmatmul(mqt,temp,dtox)
      call invsym(dtox,xtod)
c
c Problem: we can't assume cell repeat on the work map. Therefore we
c have to map the work map onto the cell map, and see where it falls
c in absolute coordinates. We then fill the cell map over that range,
c mapping back to the work map *and* wrapping into the stored part
c of the cell map.
c
c first search for the region of the cell map covered by the work map
      lu1=10000
      lv1=10000
      lw1=10000
      lu2=-10000
      lv2=-10000
      lw2=-10000
      do 300 iw=ww1,ww2
      do 300 iv=wv1,wv2
      do 300 iu=wu1,wu2
       if (wrk(iu,iv,iw).gt.-500.0) then
        du=real(iu)/wu
        dv=real(iv)/wv
        dw=real(iw)/ww
        call symuvw(dtox,du,dv,dw,xu,xv,xw)
        lu1=min(lu1,nint(xu*mu))
        lv1=min(lv1,nint(xv*mv))
        lw1=min(lw1,nint(xw*mw))
        lu2=max(lu2,nint(xu*mu))
        lv2=max(lv2,nint(xv*mv))
        lw2=max(lw2,nint(xw*mw))
       endif
 300  continue
c
c now fill the cell map from the work map
      s  =0.0
      sa =0.0
      sb =0.0
      sa2=0.0
      sb2=0.0
      sab=0.0
      do 520 iw=lw1,lw2
      do 510 iv=lv1,lv2
      do 500 iu=lu1,lu2
       xu=real(iu)/mu
       xv=real(iv)/mv
       xw=real(iw)/mw
       call symuvw(xtod,xu,xv,xw,du,dv,dw)
       if (gridinside
     +   (wrk,du*wu,dv*wv,dw*ww,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2)) then
        jw=lmod(iw-mw1,mw)+mw1
        jv=lmod(iv-mv1,mv)+mv1
        ju=lmod(iu-mu1,mu)+mu1
        if (ju.gt.mu2.or.jv.gt.mv2.or.jw.gt.mw2) goto 500
        a=map(ju,jv,jw)
        b=gridinterp
     +    (wrk,du*wu,dv*wv,dw*ww,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2)
        s  =s  +1.0
        sa =sa +a
        sb =sb +b
        sa2=sa2+a**2
        sb2=sb2+b**2
        sab=sab+a*b
        map(ju,jv,jw)=b
        do 400 k=2,msym
         ku=isym(1,1,k)*iu+isym(1,2,k)*iv+isym(1,3,k)*iw+isym(1,4,k)
         kv=isym(2,1,k)*iu+isym(2,2,k)*iv+isym(2,3,k)*iw+isym(2,4,k)
         kw=isym(3,1,k)*iu+isym(3,2,k)*iv+isym(3,3,k)*iw+isym(3,4,k)
         jw=lmod(kw-mw1,mw)+mw1
         jv=lmod(kv-mv1,mv)+mv1
         ju=lmod(ku-mu1,mu)+mu1
         if (ju.gt.mu2.or.jv.gt.mv2.or.jw.gt.mw2) goto 400
         map(ju,jv,jw)=b
 400    continue
       endif
 500  continue
 510  continue
 520  continue
c
      write (lpt,900)(s*sab-sa*sb)/
     +  sqrt(max((s*sa2-sa**2)*(s*sb2-sb**2),1.0e-12)),
     +  lu1,lu2,lv1,lv2,lw1,lw2
 900  format ('   Density correlation: ',f8.5,'  over ',3(2x,i4,':',i3))
c
      return
 9000 call ccperr(1,
     +  ' doaverageto - grid dimensions incompatible with space group')
      end
c
c ----------------------------------------------------------------------
c
      subroutine mrcorrel(
     +    map,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,
     +    wrk,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2,
     +    wrk2,wrk3)
      include 'maprot.fh'
      include 'io.fh'
      include 'crystals.fh'
      include 'params.fh'
c calc local correlation map
      integer mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2
      integer wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2
      real map(mu1:mu2,mv1:mv2,mw1:mw2),wrk(wu1:wu2,wv1:wv2,ww1:ww2)
      real wrk2(wu1:wu2,wv1:wv2,ww1:ww2),wrk3(wu1:wu2,wv1:wv2,ww1:ww2)
c
      integer i,j,k,iu,iv,iw,ju,jv,jw,ku,kv,kw,idu,idv,idw
      real du,dv,dw,xu,xv,xw,temp(4,4),dtox(4,4,200)
      real sn,sx,sy,sx2,sy2,sxy,r2,d2
c
      integer ndn,ndu(30000),ndv(30000),ndw(30000)
c
      real gridinterp
      external gridinterp
c
c make neighbourhood
c
      r2=radcrm**2
      ndn=0
      do 20 iw=-15,15
      do 20 iv=-15,15
      do 20 iu=-15,15
       du=real(iu)/wu
       dv=real(iv)/wv
       dw=real(iw)/ww
       d2=wrlm11*du**2+wrlm22*dv**2+wrlm33*dw**2+
     +    wrlm12*du*dv+wrlm13*du*dw+wrlm23*dv*dw
       if (d2.lt.r2) then
        ndn=ndn+1
        ndu(ndn)=iu
        ndv(ndn)=iv
        ndw(ndn)=iw
       endif
 20   continue
      write (lpt,*)' neighbourhood ',ndn
c
c generate two rotated maps...
c  (or one may be input)
c
      if (ncsym.eq.1) then
       do 100 iw=ww1,ww2
       do 100 iv=wv1,wv2
       do 100 iu=wu1,wu2
        wrk2(iu,iv,iw)=wrk(iu,iv,iw)
 100   continue
       call doaveragefrom(
     +   map,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,
     +   wrk3,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2,
     +   rsymncs(1,1,1))
      else
       call doaveragefrom(
     +   map,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,
     +   wrk2,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2,
     +   rsymncs(1,1,1))
       call doaveragefrom(
     +   map,mu,mv,mw,mu1,mv1,mw1,mu2,mv2,mw2,
     +   wrk3,wu,wv,ww,wu1,wv1,ww1,wu2,wv2,ww2,
     +   rsymncs(1,1,2))
      endif
      write (lpt,*)' interpolated '
c
c now fill in the correlations on a coarse grid.
c
      idu=max(int(wu*0.5*radcrm/wcell(1)),1)
      idv=max(int(wv*0.5*radcrm/wcell(2)),1)
      idw=max(int(ww*0.5*radcrm/wcell(3)),1)
c
      do 300 kw=ww1,ww2+idw-1,idw
      iw=min(kw,ww2)
      do 300 kv=wv1,wv2+idv-1,idv
      iv=min(kv,wv2)
      do 300 ku=wu1,wu2+idu-1,idu
      iu=min(ku,wu2)
       sn =0.0
       sx =0.0
       sy =0.0
       sx2=0.0
       sy2=0.0
       sxy=0.0
       do 280 i=1,ndn
        ju=iu+ndu(i)
        jv=iv+ndv(i)
        jw=iw+ndw(i)
        if (ju.ge.wu1.and.ju.le.wu2.and.jv.ge.wv1.and.
     +      jv.le.wv2.and.jw.ge.ww1.and.jw.le.ww2) then
         sn=sn+1.0
         sx=sx+wrk2(ju,jv,jw)
         sy=sy+wrk3(ju,jv,jw)
         sx2=sx2+wrk2(ju,jv,jw)**2
         sy2=sy2+wrk3(ju,jv,jw)**2
         sxy=sxy+wrk2(ju,jv,jw)*wrk3(ju,jv,jw)
        endif
 280   continue
c calc correlation
c note: the last term down-weights edges where statistical noise is greater
       wrk(iu,iv,iw)=(sn*sxy-sx*sy)/sqrt(
     +   (sn*sx2-sx**2)*(sn*sy2-sy**2)
     +   *ndn/sn)
 300  continue
      write (lpt,*)' correlated on coarse grid ',idu,idv,idw
c
c interpolate values onto the in-between grid points.
c
      do 500 iw=ww1,ww2-1,idw
      kw=min(iw+idw,ww2)
      do 500 iv=wv1,wv2-1,idv
      kv=min(iv+idv,wv2)
      do 500 iu=wu1,wu2-1,idu
      ku=min(iu+idu,wu2)
       do 400 jw=iw,kw
       do 400 jv=iv,kv
       do 400 ju=iu,ku
        du=real(ju-iu)/real(ku-iu)
        dv=real(jv-iv)/real(kv-iv)
        dw=real(jw-iw)/real(kw-iw)
        wrk(ju,jv,jw)=
     +    (1.0-dw)*((1.0-dv)*((1.0-du)*wrk(iu,iv,iw)+du*wrk(ku,iv,iw))
     +                   +dv*((1.0-du)*wrk(iu,kv,iw)+du*wrk(ku,kv,iw)))
     +         +dw*((1.0-dv)*((1.0-du)*wrk(iu,iv,kw)+du*wrk(ku,iv,kw))
     +                   +dv*((1.0-du)*wrk(iu,kv,kw)+du*wrk(ku,kv,kw)))
 400   continue
 500  continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine doscale(wrk,wu1,wv1,ww1,wu2,wv2,ww2,rscale)
c DOAVERAGEFROM - single step average from unit cell into domain mask
      include 'maprot.fh'
c
      integer wu1,wv1,ww1,wu2,wv2,ww2
      real wrk(wu1:wu2,wv1:wv2,ww1:ww2),rscale
c
      integer iu,iv,iw
c
      do 500 iw=ww1,ww2
      do 500 iv=wv1,wv2
      do 500 iu=wu1,wu2
       if (wrk(iu,iv,iw).gt.-500.0) wrk(iu,iv,iw)=wrk(iu,iv,iw)*rscale
 500  continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      logical function
     +  gridinside(r,x,y,z,nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2)
c GRIDINSIDE - check if all interpolation source points are inside mask
      include 'maprot.fh'
c
      integer nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2
      real r(nu1:nu2,nv1:nv2,nw1:nw2),x,y,z
c
      integer iu,iv,iw,iu0,iv0,iw0,iu1,iv1,iw1,iu2,iv2,iw2,iu3,iv3,iw3
      real u,v,w,du1,dv1,dw1,sum
c
      integer lint,lmod
      external lint,lmod
c
      u=x-nu1
      iu=lint(u)
      iu0=lmod(iu-1,nu)+nu1
      iu1=lmod(iu  ,nu)+nu1
      iu2=lmod(iu+1,nu)+nu1
      iu3=lmod(iu+2,nu)+nu1
      du1=u-iu
      v=y-nv1
      iv=lint(v)
      iv0=lmod(iv-1,nv)+nv1
      iv1=lmod(iv  ,nv)+nv1
      iv2=lmod(iv+1,nv)+nv1
      iv3=lmod(iv+2,nv)+nv1
      dv1=v-iv
      w=z-nw1
      iw=lint(w)
      iw0=lmod(iw-1,nw)+nw1
      iw1=lmod(iw  ,nw)+nw1
      iw2=lmod(iw+1,nw)+nw1
      iw3=lmod(iw+2,nw)+nw1
      dw1=w-iw
c
      if (iu0.gt.nu2.or.iu3.gt.nu2.or.iv0.gt.nv2.or.
     +    iv3.gt.nv2.or.iw0.gt.nw2.or.iw3.gt.nw2) then
       sum=-1000.0
      else
c middle box + u squares + v squares + w squares
       sum=
     +   r(iu1,iv1,iw1)+r(iu1,iv1,iw2)+r(iu1,iv2,iw1)+r(iu1,iv2,iw2)+
     +   r(iu2,iv1,iw1)+r(iu2,iv1,iw2)+r(iu2,iv2,iw1)+r(iu2,iv2,iw2)+
     +   r(iu0,iv1,iw1)+r(iu0,iv1,iw2)+r(iu0,iv2,iw1)+r(iu0,iv2,iw2)+
     +   r(iu3,iv1,iw1)+r(iu3,iv1,iw2)+r(iu3,iv2,iw1)+r(iu3,iv2,iw2)+
     +   r(iu1,iv0,iw1)+r(iu1,iv0,iw2)+r(iu2,iv0,iw1)+r(iu2,iv0,iw2)+
     +   r(iu1,iv3,iw1)+r(iu1,iv3,iw2)+r(iu2,iv3,iw1)+r(iu2,iv3,iw2)+
     +   r(iu1,iv1,iw0)+r(iu1,iv2,iw0)+r(iu2,iv1,iw0)+r(iu2,iv2,iw0)+
     +   r(iu1,iv1,iw3)+r(iu1,iv2,iw3)+r(iu2,iv1,iw3)+r(iu2,iv2,iw3)
      endif
c
      gridinside=(sum.gt.-500.0)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      real function
     +  gridinterp(rho,x,y,z,nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2)
c GRIDINTERP - non-orthogonal grid interpolation
      include 'maprot.fh'
c
      integer nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2
      real rho(nu1:nu2,nv1:nv2,nw1:nw2),x,y,z
c
      integer iu,iv,iw,iu0,iv0,iw0,iu1,iv1,iw1,iu2,iv2,iw2,iu3,iv3,iw3
      real u,v,w,du1,dv1,dw1,du2,dv2,dw2
      real r111,rx111,ry111,rz111,r112,rx112,ry112,rz112
      real r121,rx121,ry121,rz121,r122,rx122,ry122,rz122
      real r211,rx211,ry211,rz211,r212,rx212,ry212,rz212
      real r221,rx221,ry221,rz221,r222,rx222,ry222,rz222
      real ra11,ra12,ra21,ra22,rb1,rb2,rzb1,rzb2
      real rya11,rya12,rya21,rya22,rza11,rza12,rza21,rza22
c
      integer lmod,lint
      real rcubiccub,rcubiclin
      external rcubiccub,rcubiclin,lmod,lint
c
      u=x-nu1
      iu=lint(u)
      iu0=lmod(iu-1,nu)+nu1
      iu1=lmod(iu  ,nu)+nu1
      iu2=lmod(iu+1,nu)+nu1
      iu3=lmod(iu+2,nu)+nu1
      du1=u-iu
      v=y-nv1
      iv=lint(v)
      iv0=lmod(iv-1,nv)+nv1
      iv1=lmod(iv  ,nv)+nv1
      iv2=lmod(iv+1,nv)+nv1
      iv3=lmod(iv+2,nv)+nv1
      dv1=v-iv
      w=z-nw1
      iw=lint(w)
      iw0=lmod(iw-1,nw)+nw1
      iw1=lmod(iw  ,nw)+nw1
      iw2=lmod(iw+1,nw)+nw1
      iw3=lmod(iw+2,nw)+nw1
      dw1=w-iw
c
      if (iu0.gt.nu2.or.iu3.gt.nu2.or.iv0.gt.nv2.or.
     +    iv3.gt.nv2.or.iw0.gt.nw2.or.iw3.gt.nw2)
     +  call ccperr(1,' gridinterp = source map must be expanded')
c
      call rcubicgrad(rho,iu0,iv0,iw0,iu1,iv1,iw1,iu2,iv2,iw2,
     +  nu1,nv1,nw1,nu2,nv2,nw2,r111,rx111,ry111,rz111)
      call rcubicgrad(rho,iu0,iv0,iw1,iu1,iv1,iw2,iu2,iv2,iw3,
     +  nu1,nv1,nw1,nu2,nv2,nw2,r112,rx112,ry112,rz112)
      call rcubicgrad(rho,iu0,iv1,iw0,iu1,iv2,iw1,iu2,iv3,iw2,
     +  nu1,nv1,nw1,nu2,nv2,nw2,r121,rx121,ry121,rz121)
      call rcubicgrad(rho,iu0,iv1,iw1,iu1,iv2,iw2,iu2,iv3,iw3,
     +  nu1,nv1,nw1,nu2,nv2,nw2,r122,rx122,ry122,rz122)
      call rcubicgrad(rho,iu1,iv0,iw0,iu2,iv1,iw1,iu3,iv2,iw2,
     +  nu1,nv1,nw1,nu2,nv2,nw2,r211,rx211,ry211,rz211)
      call rcubicgrad(rho,iu1,iv0,iw1,iu2,iv1,iw2,iu3,iv2,iw3,
     +  nu1,nv1,nw1,nu2,nv2,nw2,r212,rx212,ry212,rz212)
      call rcubicgrad(rho,iu1,iv1,iw0,iu2,iv2,iw1,iu3,iv3,iw2,
     +  nu1,nv1,nw1,nu2,nv2,nw2,r221,rx221,ry221,rz221)
      call rcubicgrad(rho,iu1,iv1,iw1,iu2,iv2,iw2,iu3,iv3,iw3,
     +  nu1,nv1,nw1,nu2,nv2,nw2,r222,rx222,ry222,rz222)
c
      ra11=rcubiccub(du1,r111,r211,rx111,rx211)
      ra12=rcubiccub(du1,r112,r212,rx112,rx212)
      ra21=rcubiccub(du1,r121,r221,rx121,rx221)
      ra22=rcubiccub(du1,r122,r222,rx122,rx222)
      rya11=rcubiclin(du1,ry111,ry211)
      rya12=rcubiclin(du1,ry112,ry212)
      rya21=rcubiclin(du1,ry121,ry221)
      rya22=rcubiclin(du1,ry122,ry222)
      rza11=rcubiclin(du1,rz111,rz211)
      rza12=rcubiclin(du1,rz112,rz212)
      rza21=rcubiclin(du1,rz121,rz221)
      rza22=rcubiclin(du1,rz122,rz222)
c
      rb1=rcubiccub(dv1,ra11,ra21,rya11,rya21)
      rb2=rcubiccub(dv1,ra12,ra22,rya12,rya22)
      rzb1=rcubiclin(dv1,rza11,rza21)
      rzb2=rcubiclin(dv1,rza12,rza22)
c
      gridinterp=rcubiccub(dw1,rb1,rb2,rzb1,rzb2)
      return
      end
c
      subroutine rcubicgrad(rho,iu0,iv0,iw0,iu1,iv1,iw1,iu2,iv2,iw2,
     +  nu1,nv1,nw1,nu2,nv2,nw2,r,rx,ry,rz)
      include 'maprot.fh'
      integer iu0,iv0,iw0,iu1,iv1,iw1,iu2,iv2,iw2
      integer nu1,nv1,nw1,nu2,nv2,nw2,lmod
      real rho(nu1:nu2,nv1:nv2,nw1:nw2),rx,ry,rz,r
      external lmod
      r=rho(iu1,iv1,iw1)
      rx=0.5*(rho(iu2,iv1,iw1)-rho(iu0,iv1,iw1))
      ry=0.5*(rho(iu1,iv2,iw1)-rho(iu1,iv0,iw1))
      rz=0.5*(rho(iu1,iv1,iw2)-rho(iu1,iv1,iw0))
      return
      end
c
      real function rcubiccub(x,y1,y2,dy1,dy2)
      include 'maprot.fh'
      real x,y1,y2,dy1,dy2,a,b,c,d
      a=(dy1+dy2)+2.0*(y1-y2)
      b=3.0*(y2-y1)-2.0*dy1-dy2
      c=dy1
      d=y1
      rcubiccub=d+x*(c+x*(b+x*a))
      return
      end
c
      real function rcubiclin(x,y1,y2)
      include 'maprot.fh'
      real x,y1,y2
      rcubiclin=(1.0-x)*y1+x*y2
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmaphead
     +  (name,nspgrp,cell,nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2)
      include 'maprot.fh'
      include 'io.fh'
c CCPMAPhead - get limits of mask from file
c
      character name*(*)
      integer nspgrp,nu,nv,nw,nu1,nv1,nw1,nu2,nv2,nw2
      real cell(6)
c
      integer jfms(3),juvw(3),mxyz(3),m1(3),m2(3),nsec,mode
      integer i,ifail,iprint
      real rmin,rmax,rmean,rrms,qmin,qmax,qmean,qrms,qcell(6)
      character title*80
c
c read the file headers
      ifail=0
      iprint=1
      call mrdhds(lmap1,name,title,nsec,jfms,mxyz,m1(3),m1(1),m2(1),
     +  m1(2),m2(2),cell,nspgrp,mode,rmin,rmax,rmean,rrms,ifail,iprint)
      call mrclos(lmap1)
      m2(3)=m1(3)+nsec-1
      do 110 i=1,3
       juvw(jfms(i))=i
 110  continue
      nu1=m1(juvw(1))
      nu2=m2(juvw(1))
      nv1=m1(juvw(2))
      nv2=m2(juvw(2))
      nw1=m1(juvw(3))
      nw2=m2(juvw(3))
      nu=mxyz(1)
      nv=mxyz(2)
      nw=mxyz(3)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmapin
     +  (name,title,map,nu1,nv1,nw1,nu2,nv2,nw2)
      include 'maprot.fh'
      include 'io.fh'
c CCPMAPIN - read a ccp4 logical map and store in xyz order
c
      integer nu1,nv1,nw1,nu2,nv2,nw2
      real map(nu1:nu2,nv1:nv2,nw1:nw2)
      character name*(*),title*(*)
c
      real lsec(0:maxsec)
c
      integer ifast,imedm,islow,lfast,lmedm,lslow,ierr,ifail,iprint
      integer m1(3),m2(3),ifms(3),jfms(3),juvw(3),mxyz(3)
      integer i,iu,iv,iw
      integer nsec,mode,mspgrp
      real cell(6),rmin,rmax,rmean,rrms
c
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
c now open map header and read map, re-ordering it as necessary
c
      ifail=0
      iprint=0
      call mrdhds(lmap1,name,title,nsec,jfms,mxyz,m1(3),m1(1),m2(1),
     +  m1(2),m2(2),cell,mspgrp,mode,rmin,rmax,rmean,rrms,ifail,iprint)
      m2(3)=m1(3)+nsec-1
      do 110 i=1,3
       juvw(jfms(i))=i
 110  continue
c check we got the right header info:
      if (nu1.ne.m1(juvw(1)).or.nu2.ne.m2(juvw(1)).or.
     +    nv1.ne.m1(juvw(2)).or.nv2.ne.m2(juvw(2)).or.
     +    nw1.ne.m1(juvw(3)).or.nw2.ne.m2(juvw(3)))
     +  call ccperr(1,'ccpmapin - mask grid sizes are inconsistent')
c find out the map grid dimensions
      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
c
      if (lfast*lmedm.gt.maxsec)
     +  call ccperr(1,' ccpmapin - Map section > lsec: recompile')
c now read the map in the order it is on file
      do 200 islow=0,lslow-1
c get a section
       ierr=0
       call mgulpr(lmap1,lsec,ierr)
       if (ierr.ne.0) call ccperr(1,' ccpmapin - ccp4 read error')
c now sort into uvw map
       ifms(3)=islow+m1(3)
       do 190 imedm=0,lmedm-1
       ifms(2)=imedm+m1(2)
       do 190 ifast=0,lfast-1
       ifms(1)=ifast+m1(1)
        iu=ifms(juvw(1))
        iv=ifms(juvw(2))
        iw=ifms(juvw(3))
        map(iu,iv,iw)=lsec(ifast+lfast*imedm)
 190   continue
 200  continue
c close the map file
      call mrclos(lmap1)
c
      write (lpt,910)
 910  format (/' MAP/MASK READ SUCCESSFUL'//)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmskin
     +  (name,title,map,nu1,nv1,nw1,nu2,nv2,nw2)
      include 'maprot.fh'
      include 'io.fh'
c CCPMAPIN - read a ccp4 logical map and store in xyz order
c
      integer nu1,nv1,nw1,nu2,nv2,nw2
      real map(nu1:nu2,nv1:nv2,nw1:nw2)
      character name*(*),title*(*)
c
      real lsec(0:maxsec)
c
      integer ifast,imedm,islow,lfast,lmedm,lslow,ierr,ifail,iprint
      integer m1(3),m2(3),ifms(3),jfms(3),juvw(3),mxyz(3)
      integer i,iu,iv,iw
      integer nsec,mode,mspgrp
      real cell(6),rmin,rmax,rmean,rrms
c
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
c now open map header and read map, re-ordering it as necessary
c
      ifail=0
      iprint=0
      call mrdhds(lmap1,name,title,nsec,jfms,mxyz,m1(3),m1(1),m2(1),
     +  m1(2),m2(2),cell,mspgrp,mode,rmin,rmax,rmean,rrms,ifail,iprint)
      m2(3)=m1(3)+nsec-1
      do 110 i=1,3
       juvw(jfms(i))=i
 110  continue
c check we got the right header info:
      if (nu1.ne.m1(juvw(1)).or.nu2.ne.m2(juvw(1)).or.
     +    nv1.ne.m1(juvw(2)).or.nv2.ne.m2(juvw(2)).or.
     +    nw1.ne.m1(juvw(3)).or.nw2.ne.m2(juvw(3)))
     +  call ccperr(1,'ccpmskin - mask grid sizes are inconsistent')
c find out the map grid dimensions
      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
c
      if (lfast*lmedm.gt.maxsec)
     +  call ccperr(1,' ccpmapin - Map section > lsec: recompile')
c now read the map in the order it is on file
      do 200 islow=0,lslow-1
c get a section
       ierr=0
       call mgulpr(lmap1,lsec,ierr)
       if (ierr.ne.0) call ccperr(1,' ccpmapin - ccp4 read error')
c now sort into uvw map
       ifms(3)=islow+m1(3)
       do 190 imedm=0,lmedm-1
       ifms(2)=imedm+m1(2)
       do 190 ifast=0,lfast-1
       ifms(1)=ifast+m1(1)
        iu=ifms(juvw(1))
        iv=ifms(juvw(2))
        iw=ifms(juvw(3))
        if (nint(lsec(ifast+lfast*imedm)).eq.0)
     +    map(iu,iv,iw)=map(iu,iv,iw)-1000.0
 190   continue
 200  continue
c close the map file
      call mrclos(lmap1)
c
      write (lpt,910)
 910  format (/' MASK READ SUCCESSFUL'//)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine ccpmapout(name,title,map,nspgrp,cell,nu,nv,nw,
     +  nu1,nv1,nw1,nu2,nv2,nw2,lu1,lv1,lw1,lu2,lv2,lw2)
      include 'maprot.fh'
      include 'io.fh'
c CCPMAPIN - read a ccp4 logical map and store in xyz order
c
      integer nspgrp,nu,nv,nw
      integer nu1,nv1,nw1,nu2,nv2,nw2,lu1,lv1,lw1,lu2,lv2,lw2
      real cell(6),map(nu1:nu2,nv1:nv2,nw1:nw2)
      character name*(*),title*(*)
c
      real lsec(0:maxsec)
c
      integer axis(230)
      integer ifast,imedm,islow,lfast,lmedm,lslow,ierr,ifail,iprint
      integer m1(3),m2(3),ifms(3),jfms(3),juvw(3),mxyz(3)
      integer i,m,iu,iv,iw
      integer nsec,mode,nsym,nsymp
      real rmin,rmax,rmean,rrms,rsym(4,4,192),u,v,w,u1,v1,w1,rho
      character namspg*20,nampg*20
c
      integer lmod
      external lmod
c
c spacegroups with yxz=1 and zxy=2 axis ordering
      data axis/2,2,2,2,1,1,1,1,1,2,1,1,1,1,1,2,2,2,1,2,2,1,2,207*1/
c
c Note: juvw convert from fast/med/slow to u/v/w
c       jfms convert from u/v/w to fast/med/slow
c
c now open map header and read map, re-ordering it as necessary
c
      if (axis(mod(nspgrp,1000)).eq.1) then
       jfms(1)=2
       jfms(2)=1
       jfms(3)=3
      else
       jfms(1)=3
       jfms(2)=1
       jfms(3)=2
      endif
c
      do 110 i=1,3
       juvw(jfms(i))=i
 110  continue
c
      mxyz(1)=nu
      mxyz(2)=nv
      mxyz(3)=nw
      m1(juvw(1))=lu1
      m2(juvw(1))=lu2
      m1(juvw(2))=lv1
      m2(juvw(2))=lv2
      m1(juvw(3))=lw1
      m2(juvw(3))=lw2
      nsec=m2(3)-m1(3)+1
      mode=2
c
c      namspg=' '
c      call msymlb(ltmp,nspgrp,namspg,nampg,nsymp,nsym,rsym)
      call msyget(ltmp,nspgrp,nsym,rsym)
c
      call mwrhdl(lmap1,name,title,nsec,jfms,mxyz,
     +  m1(3),m1(1),m2(1),m1(2),m2(2),cell,nspgrp,mode)
      call msywrt(lmap1,nsym,rsym)
c
c find out the mask grid dimensions
      lfast=m2(1)-m1(1)+1
      lmedm=m2(2)-m1(2)+1
      lslow=m2(3)-m1(3)+1
c
      if (lfast*lmedm.gt.maxsec)
     +  call ccperr(1,' ccpmapin - Mask section > lsec: recompile')
c now write the map in the new order
      do 200 islow=0,lslow-1
c sort onto section
       ifms(3)=islow+m1(3)
       do 190 imedm=0,lmedm-1
       ifms(2)=imedm+m1(2)
       do 190 ifast=0,lfast-1
       ifms(1)=ifast+m1(1)
        iu=lmod(ifms(juvw(1))-nu1,nu)+nu1
        iv=lmod(ifms(juvw(2))-nv1,nv)+nv1
        iw=lmod(ifms(juvw(3))-nw1,nw)+nw1
        lsec(ifast+lfast*imedm)=map(iu,iv,iw)
 190   continue
c write the section
       call mspew(lmap1,lsec)
 200  continue
c close the map file
      call mwclose(lmap1)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine stripflag(map,nu1,nv1,nw1,nu2,nv2,nw2)
      include 'maprot.fh'
      include 'io.fh'
c stipflag - strip -1000 mask flag out of a map
      integer nu1,nv1,nw1,nu2,nv2,nw2
      real map(nu1:nu2,nv1:nv2,nw1:nw2)
c
      integer iu,iv,iw
c
      do 100 iw=nw1,nw2
      do 100 iv=nv1,nv2
      do 100 iu=nu1,nu2
       if (map(iu,iv,iw).lt.-500.0) map(iu,iv,iw)=map(iu,iv,iw)+1000.0
 100  continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine fracorthfrac(u,v,w,x,y,z,q)
      include 'maprot.fh'
c fracorthfrac
c  call with q  for frac -> orth
c  call with qt for orth -> frac
      real u,v,w,x,y,z,q(4,4)
      x=q(1,1)*u+q(1,2)*v+q(1,3)*w+q(1,4)
      y=q(2,1)*u+q(2,2)*v+q(2,3)*w+q(2,4)
      z=q(3,1)*u+q(3,2)*v+q(3,3)*w+q(3,4)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine calcmetric(cell,vol,q,qt,
     +                      rlm11,rlm12,rlm13,rlm22,rlm23,rlm33,
     +                      rcm11,rcm12,rcm13,rcm22,rcm23,rcm33)
      include 'maprot.fh'
      include 'io.fh'
c Calculate the orthonormal - crystallographic transform
      real cell(6),vol,q(4,4),qt(4,4)
      real rlm11,rlm12,rlm13,rlm22,rlm23,rlm33
      real rcm11,rcm12,rcm13,rcm22,rcm23,rcm33
c
      integer i,j
      real a,b,c,alph,beta,gamm,sum,cosas,q123
c
      do 10 j=1,4
      do 10 i=1,4
      q(i,j)=0.0
      qt(i,j)=0.0
 10   continue
c
      a=cell(1)
      b=cell(2)
      c=cell(3)
      alph=dtor*cell(4)
      beta=dtor*cell(5)
      gamm=dtor*cell(6)
      sum=0.5*(alph+beta+gamm)
      vol=2.0*a*b*c*
     + sqrt(sin(sum)*sin(sum-alph)*sin(sum-beta)*sin(sum-gamm))
      cosas=(cos(beta)*cos(gamm)-cos(alph))/(sin(beta)*sin(gamm))
c orthogonalisation matrix
      q(1,1)=a
      q(1,2)=b*cos(gamm)
      q(1,3)=c*cos(beta)
      q(2,2)=b*sin(gamm)
      q(2,3)=-c*sin(beta)*cosas
      q(3,3)=c*sin(beta)*sqrt(1.0-cosas**2)
      q(4,4)=1.0
c and its inverse
      q123=q(1,1)*q(2,2)*q(3,3)
      qt(1,1)=1.0/q(1,1)
      qt(1,2)=-q(1,2)*q(3,3)/q123
      qt(1,3)=(q(1,2)*q(2,3)-q(2,2)*q(1,3))/q123
      qt(2,2)=1.0/q(2,2)
      qt(2,3)=-q(1,1)*q(2,3)/q123
      qt(3,3)=1.0/q(3,3)
      qt(4,4)=1.0
c
      write (lpt,4)vol
 4    format (' Unit cell volume:',f10.1)
      write (lpt,1)((q(i,j),j=1,3),(qt(i,j),j=1,3),i=1,3)
 1    format (' Orthogonalisation matrices:',3(/1x,3f8.3,8x,3f8.3))
c Calculate real space metric tensor
      rlm11=q(1,1)*q(1,1)+q(2,1)*q(2,1)+q(3,1)*q(3,1)
      rlm12=2.0*(q(1,1)*q(1,2)+q(2,1)*q(2,2)+q(3,1)*q(3,2))
      rlm13=2.0*(q(1,1)*q(1,3)+q(2,1)*q(2,3)+q(3,1)*q(3,3))
      rlm22=q(1,2)*q(1,2)+q(2,2)*q(2,2)+q(3,2)*q(3,2)
      rlm23=2.0*(q(1,2)*q(1,3)+q(2,2)*q(2,3)+q(3,2)*q(3,3))
      rlm33=q(1,3)*q(1,3)+q(2,3)*q(2,3)+q(3,3)*q(3,3)
      write (lpt,2)rlm11,rlm22,rlm33,rlm12,rlm13,rlm23
 2    format (' Real space metric tensor:      '/1x,6f9.1)
c Calculate reciprocal space metric tensor
      rcm11=qt(1,1)*qt(1,1)+qt(1,2)*qt(1,2)+qt(1,3)*qt(1,3)
      rcm12=2.0*(qt(1,1)*qt(2,1)+qt(1,2)*qt(2,2)+qt(1,3)*qt(2,3))
      rcm13=2.0*(qt(1,1)*qt(3,1)+qt(1,2)*qt(3,2)+qt(1,3)*qt(3,3))
      rcm22=qt(2,1)*qt(2,1)+qt(2,2)*qt(2,2)+qt(2,3)*qt(2,3)
      rcm23=2.0*(qt(2,1)*qt(3,1)+qt(2,2)*qt(3,2)+qt(2,3)*qt(3,3))
      rcm33=qt(3,1)*qt(3,1)+qt(3,2)*qt(3,2)+qt(3,3)*qt(3,3)
      write (lpt,3)rcm11,rcm22,rcm33,rcm12,rcm13,rcm23
 3    format (' Reciprocal space metric tensor:'/1x,6f9.6)
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine symmatmul(a,b,c)
      include 'maprot.fh'
c symmetmaul - 4x4 matrix multiply, c=a*b
      real a(4,4),b(4,4),c(4,4)
      integer i,j,k
c
      do 20 k=1,4
      do 20 i=1,4
      c(i,k)=0.0
      do 20 j=1,4
      c(i,k)=c(i,k)+a(i,j)*b(j,k)
20    continue
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine symuvw(mat,u,v,w,u1,v1,w1)
      include 'maprot.fh'
c symuvw - multiply a 4-matrix by a 3-vector
      real mat(4,4),u,v,w,u1,v1,w1
      u1=mat(1,1)*u+mat(1,2)*v+mat(1,3)*w+mat(1,4)
      v1=mat(2,1)*u+mat(2,2)*v+mat(2,3)*w+mat(2,4)
      w1=mat(3,1)*u+mat(3,2)*v+mat(3,3)*w+mat(3,4)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine eulertomatrix(alpha,beta,gamma,matrix)
      include 'maprot.fh'
c calculate rotation matrix from Euler angles
      real alpha,beta,gamma,matrix(4,4)
c
      real ca,cb,cg,sa,sb,sg
c
      ca = cos(dtor*alpha)
      sa = sin(dtor*alpha)
      cb = cos(dtor*beta)
      sb = sin(dtor*beta)
      cg = cos(dtor*gamma)
      sg = sin(dtor*gamma)
      matrix(1,1) = cg*cb*ca - sg*sa
      matrix(1,2) = -sg*cb*ca - cg*sa
      matrix(1,3) = sb*ca
      matrix(2,1) = cg*cb*sa + sg*ca
      matrix(2,2) = -sg*cb*sa + cg*ca
      matrix(2,3) = sb*sa
      matrix(3,1) = -cg*sb
      matrix(3,2) = sg*sb
      matrix(3,3) = cb
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine polartomatrix(omega,phi,kappa,matrix)
      include 'maprot.fh'
c calculate rotation matrix from Euler angles
      real omega,phi,kappa,matrix(4,4)
c
      real someg,comeg,sinph,cosph,sinchi,coschi,cosch1,dc1,dc2,dc3
c
      someg = sin(omega*dtor)
      comeg = cos(omega*dtor)
      sinph = sin(phi*dtor)
      cosph = cos(phi*dtor)
      dc1 = someg*cosph
      dc2 = someg*sinph
      dc3 = comeg
      sinchi = sin(kappa*dtor)
      coschi = cos(kappa*dtor)
      cosch1 = 1.0 - coschi
      matrix(1,1) = dc1*dc1*cosch1 + coschi
      matrix(1,2) = dc1*dc2*cosch1 - dc3*sinchi
      matrix(1,3) = dc3*dc1*cosch1 + dc2*sinchi
      matrix(2,1) = dc1*dc2*cosch1 + dc3*sinchi
      matrix(2,2) = dc2*dc2*cosch1 + coschi
      matrix(2,3) = -dc1*sinchi + dc2*dc3*cosch1
      matrix(3,1) = -dc2*sinchi + dc3*dc1*cosch1
      matrix(3,2) = dc2*dc3*cosch1 + dc1*sinchi
      matrix(3,3) = dc3*dc3*cosch1 + coschi
      return
      end
c
c ----------------------------------------------------------------------
c
      real function rfracp(x)
      include 'maprot.fh'
c fractional part -0.5:0.5
      real x
      rfracp=x-real(nint(x))
      return
      end
c
c ----------------------------------------------------------------------
c
      integer function lint(r)
      include 'maprot.fh'
c fixed integer int
      real r
      integer i
c
      i=int(r)
      if (r.ge.real(i)) then
      lint=i
      else
      lint=i-1
      endif
      return
      end
c
c ----------------------------------------------------------------------
c
      integer function lmod(i,j)
      include 'maprot.fh'
c fixed integer mod (optimised for 0<=i<j)
      integer i,j,k
c
      if (i.lt.0) then
       lmod=mod(i+1,j)+j-1
      else if (i.ge.j) then
       lmod=mod(i,j)
      else
       lmod=i
      endif
      return
      end
c
c ----------------------------------------------------------------------
c
