C
C     MAPSIG
C     Copyright (C) 1992 Ian Tickle
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C*************************************************************
C
C
C**************************************************************

C====   MAPSIG.FOR
C====   MAPSIG  Print statistics on signal/noise for translation function map.
C       Also various arithmetic operations on 2 maps (sum, product, ratio).
C       April 1989   Peak search added.
C       July 1994    Keyworded
C====   Ian Tickle
C
C
        PROGRAM MAPSIG
        PARAMETER (MAXR=200000,MAXP=8000,MAXH=200)
        CHARACTER T*80,T2*80
        DIMENSION R1(MAXR),R2(MAXR),L1(3),L2(3),M1(3),M2(3),N1(3),N2(3),
     &  IUVW(3),IUVW2(3),NXYZ(3),NXYZ2(3),NUVW(3),CC(6)
        DATA N2 /3*0/
C
        CALL CCPRCS(6,'MAPSIG','$Date: 2005/09/06 11:25:16 $')
        WRITE (6,'(/3(/20X,A)//)')
     &  ' #############################################',
     &  ' # TRANSLATION FUNCTION MAP SIGNAL ANALYSIS. #',
     &  ' #############################################'
        WRITE (6,*)
     &  'BE WARNED THAT THIS PROGRAM ASSUMES PERIODIC MAP BOUNDARIES,'
        WRITE (6,*)
     &  '(I.E. THE LEFT-HAND EDGE ABUTS ONTO THE RIGHT-HAND EDGE) AND'
        WRITE (6,*)
     &  'THEREFORE MAY NOT LOCATE PEAKS AT THE EDGES OF THE MAP'
        WRITE (6,*)
     &  'CORRECTLY IN OTHER CASES.  IN SUCH CASES THE MAP SHOULD BE'
        WRITE (6,*)
     &  'EXPANDED IN ONE OR MORE DIRECTIONS TO MAKE IT PERIODIC IN ALL'
        WRITE (6,*)
     &  'DIRECTIONS.'
C
        CALL CCPFYP
        KE=0
        CALL MRDHDR(1,'MAPIN',T,N1(3),IUVW,NXYZ,L1(3),L1(1),M1(1),
     &  L1(2),M1(2),CC,NSG,MODE,RL,RU,RM,RR)
C
        DO 1 I=1,3
          NUVW(I)=NXYZ(IUVW(I))
          IF (I.LE.2) N1(I)=M1(I)-L1(I)+1
          N1(I)=MIN(N1(I),NUVW(I))
          DO 6 J=2,6
            IF (J.NE.5 .AND. J*(N1(I)-1).EQ.NUVW(I)) THEN
              N1(I)=N1(I)-1
              GOTO 1
            ENDIF
6         CONTINUE
1         NXYZ2(IUVW(I))=N1(I)
        M1(3)=L1(3)+N1(3)-1
        WRITE (6,'(/A,3I5)') ' Translation modulus =',NXYZ2
        IF (L1(1).NE.0 .OR. L1(2).NE.0 .OR. L1(3).NE.0) THEN
          WRITE (6,*) '*** ERROR - first point must be (0,0,0)'
          KE=KE+1
        ENDIF
C
        IF (NSG.EQ.1) THEN
          DO 2 I=1,3
            J=NUVW(I)/N1(I)
            IF (J*N1(I).NE.NUVW(I) .OR. J.EQ.5 .OR.
     &          (J.GT.6 .AND. J.LT.NUVW(I))) THEN
              WRITE (6,*) '*** ERROR - Translation modulus must be a '//
     &                    'factor 1,2,3,4 or 6 of N'
              KE=KE+1
              GOTO 4
            ENDIF
2         CONTINUE
        ELSE
          DO 3 I=1,3
            IF (N1(I).LT.NUVW(I)) THEN
              WRITE (6,*) '*** ERROR - space group must be P1 if '//
     &                    'whole cell not given.'
              KE=KE+1
              GOTO 4
            ENDIF
3         CONTINUE
        ENDIF
C
4       IF (N1(1)*N1(2).GT.MAXR) THEN
          WRITE (6,*) '*** ERROR - increase PARAMETER MAXR'
          KE=KE+1
        ENDIF
C
        NPM=0
        NHM=10
        SC1=1.
        SC2=1.
        IT=0
        CALL GETINP(NPM,NHM,SC1,SC2,IT,T,KE)
        IF (IT.EQ.0) GO TO 12
C
        IF (IT.NE.0) THEN
          CALL MRDHDR(2,'MAPIN2',T2,N2(3),IUVW2,NXYZ2,L2(3),L2(1),M2(1),
     &    L2(2),M2(2),CC,NSG,MODE,RL,RU,RM,RR)
C
          DO 5 I=1,3
            IF (IUVW(I).NE.IUVW2(I)) THEN
              WRITE (6,'(A,3I8,8X,3I8)')
     &        ' *** ERROR - map axes different.',IUVW,IUVW2
              KE=KE+1
              GOTO 12
            ENDIF
5         CONTINUE
C
          DO 7 I=1,3
            IF (NXYZ(I).NE.NXYZ2(I)) THEN
              WRITE (6,'(A,3I8,8X,3I8)')
     &        ' *** ERROR - map sizes different.',NXYZ,NXYZ2
              KE=KE+1
              GOTO 12
            ENDIF
7         CONTINUE
C
          DO 8 I=1,3
            IF (I.LE.2) N2(I)=M2(I)-L2(I)+1
            N2(I)=MIN(N2(I),NUVW(I))
            IF (2*(N2(I)-1).EQ.NUVW(I)) N2(I)=N2(I)-1
8           NXYZ2(IUVW(I))=N2(I)
          M2(3)=L2(3)+N2(3)-1
          WRITE (6,'(/A,3I5)') ' Translation modulus =',NXYZ2
C
          IF (L2(1).NE.0 .OR. L2(2).NE.0 .OR. L2(3).NE.0) THEN
            WRITE (6,*) '*** ERROR - first point must be (0,0,0)'
            KE=KE+1
          ENDIF
C
          IF (N1(1).GT.N2(1) .OR. N1(2).GT.N2(2) .OR. N1(3).GT.N2(3))
     &    THEN
            WRITE (6,*) '*** ERROR - Smaller map must be MAPIN'
            KE=KE+1
          ENDIF
C
          IF (NSG.EQ.1) THEN
            DO 9 I=1,3
              IF (N2(I).NE.1 .AND. 2*N2(I).NE.NUVW(I) .AND.
     &            N2(I).NE.NUVW(I)) THEN
                WRITE (6,*) '*** ERROR - Translation modulus must be 1,'
     &                      //' N/2 or N'
                KE=KE+1
                GOTO 11
              ENDIF
9           CONTINUE
          ELSE
            DO 10 I=1,3
              IF (N2(I).LT.NUVW(I)) THEN
                WRITE (6,*) '*** ERROR - space group must be P1 if '//
     &                      'whole cell not given.'
                KE=KE+1
                GOTO 11
              ENDIF
10          CONTINUE
          ENDIF
C
11        IF (N2(1)*N2(2).GT.MAXR) THEN
            WRITE (6,*) '*** ERROR - increase PARAMETER MAXR'
            KE=KE+1
          ENDIF
        ENDIF
C
12      NPM=MIN(MAX(NPM,0),MAXP)
        NHM=MIN(MAX(NHM,0),MAXH)
        WRITE (6,110)NPM,NHM,SC1,SC2
110     FORMAT(//' MAX POINTS =',I6,6X,'MAX PEAKS =',I6//
     &  ' MAPS SCALED BY',2F10.2)
        IF (KE.GT.0) CALL CCPERR(1,'*** ERROR(S) IN DATA.')
C
        IF (IT.LT.0) THEN
          MU=MAX(N1(1),N2(1))-1
          MV=MAX(N1(2),N2(2))-1
          NW=MAX(N1(3),N2(3))
          CALL MWRHDL(3,'MAPOUT',T,NW,IUVW,NXYZ,0,0,MU,0,MV,
     &    CC,NSG,MODE)
        ENDIF
        CALL GETMAP(T,L1(1),M1(1),L1(2),M1(2),R1,L2(1),M2(1),
     &  L2(2),M2(2),R2,N1,N2,IUVW,NXYZ,NUVW,NPM,NHM,SC1,SC2,IT)
        CALL CCPERR(0,'NORMAL TERMINATION')
        END
C
C
        SUBROUTINE GETINP(NPM,NHM,SC1,SC2,IT,T,KE)
C
        INTEGER MTOK,NKEY
        PARAMETER (MTOK=20,NKEY=6)
C
        CHARACTER T*80
        INTEGER NPM,NHM,IT,KE
        REAL SC1,SC2
C
        CHARACTER LINE*400,KEY*4,CVAL(MTOK)*4,KEYA(NKEY)*4
        LOGICAL EOF,MAPO
        INTEGER I,NTOK
        INTEGER NTOKS(NKEY),IBEG(MTOK),IEND(MTOK),ITYP(MTOK),IDEC(MTOK)
        REAL FVAL(MTOK)
C
        DATA KEYA /'POIN','PEAK','SCAL','TYPE','MAPO','END'/
        DATA NTOKS /-2, -2, 2, -2, 1, -1/
        DATA MAPO /.FALSE./
C
C====   Read control data.
C
10      LINE = ' '
        NTOK = MTOK
        CALL PARSER(KEY,LINE,IBEG,IEND,ITYP,FVAL,CVAL,IDEC,NTOK,EOF,
     &              .FALSE.)
        IF (EOF) GOTO 1006
        IF (NTOK.EQ.0) GOTO 10
        WRITE (6,'(/2A)') ' >>>> Input line >>>>  ',LINE(:LENSTR(LINE))
        DO 20 I = 1, NKEY
20        IF (KEY.EQ.KEYA(I)) GOTO 30
        WRITE (6,*) '*** ERROR: Last line has invalid keyword.'
        KE = KE + 1
        GOTO 10
30      IF ((NTOKS(I).LT.0 .AND. NTOK.NE.-NTOKS(I)) .OR.
     &  NTOK.LT.NTOKS(I)) THEN
          WRITE (6,'(/A)') ' **** ERROR: bad argument count.'
          KE = KE + 1
        ENDIF
        GOTO (1001,1002,1003,1004,1005,1006),I
C
C====   POINts.
C
1001    CALL GTPINT(2,NPM,NTOK,ITYP,FVAL)
        GOTO 10
C
C====   PEAKs.
C
1002    CALL GTPINT(2,NHM,NTOK,ITYP,FVAL)
        IF (NHM.LE.0) NHM = 1
        GOTO 10
C
C====   SCALes.
C
1003    CALL GTPREA(2,SC1,NTOK,ITYP,FVAL)
        IF (NTOK.GT.2) CALL GTPREA(3,SC2,NTOK,ITYP,FVAL)
        GOTO 10
C
C====   TYPE
C
1004    CALL CCPUPC(LINE(IBEG(2):IBEG(2)))
        IT = INDEX('SPR',LINE(IBEG(2):IBEG(2)))
        IF (IT.EQ.0) THEN
          WRITE (6,'(/A)') ' **** ERROR: Illegal type of combination.'
          KE = KE + 1
        ENDIF
        GOTO 10
C
C====   MAPOut
C
1005    MAPO = .TRUE.
        IF (NTOK.GT.1) T=LINE(IBEG(2):)
        GOTO 10
C
C====   End/EOF
C
1006    IF (NPM.LT.40) NPM = 40*NHM
        IF (MAPO) THEN
          IF (IT.EQ.0) WRITE (6,'(/A)')
     &    ' MAPOUT ignored: no combination type.'
          IT = -IT
        ENDIF
        END
C
C
        SUBROUTINE GETMAP(T,LU1,MU1,LV1,MV1,R1,LU2,MU2,LV2,MV2,
     &  R2,N1,N2,IUVW,NXYZ,NUVW,NPM,NHM,SC1,SC2,IT)
        PARAMETER (MAXP=5000,MAXH=500)
        CHARACTER T*(*),TO(4)*7
        DIMENSION R1(LU1:MU1,LV1:MV1),R2(LU2:MU2,LV2:MV2),
     &   N1(3),N2(3),IUVW(3),NXYZ(3),NUVW(3),IN(3),IXYZ(3),
     &   P1(MAXP),P2(MAXP),P3(MAXP),
     &   L1(250),L2(250),L3(250),MP1(3,MAXP),MP2(3,MAXP),MP3(3,MAXP),
     &   LP(MAXP),MH(3,MAXH),NN(MAXH),NU(MAXH),H(MAXH),CH(3,MAXH)
        LOGICAL F1,F2
        DOUBLEPRECISION S1,SS1,S2,SS2,S3,SS3,T1,TT1,T2,TT2,T3,TT3
        DATA TO/'    SUM','PRODUCT','  RATIO','MINIMUM'/
        DATA T1,TT1,T2,TT2,T3,TT3,Q1,Q2,Q3,L1,L2,L3
     &   /6*0.D0,3*1.E6,750*0/
C
        LU=0
        LV=0
        MU=MAX(N1(1),N2(1))-1
        MV=MAX(N1(2),N2(2))-1
        MW=MAX(N1(3),N2(3))-1
        NS1=N1(1)*N1(2)
        NS2=N2(1)*N2(2)
        JT=IABS(IT)
C
        IW=0
        NP1=0
        NT1=0
        NP2=0
        NT2=0
        NP3=0
        NT3=0
C
1       F1=N1(3).GT.1 .OR. IW.EQ.0
        IF (F1) THEN
          IF (2*N1(3).EQ.NUVW(3) .AND. IW.EQ.N1(3)) THEN
            CALL MPOSN(1,0)
            F1=.FALSE.
          ENDIF
          CALL MGULPR(1,R1,IE)
          IF (IE.NE.0) CALL CCPERR(1,'ERROR IN MGULPR (1)')
          S1=0.
          SS1=0.
        ENDIF
C
        IF (JT.GT.0) THEN
          F2=N2(3).GT.1 .OR. IW.EQ.0
          IF (F2) THEN
            IF (2*N2(3).EQ.NUVW(3) .AND. IW.EQ.N2(3)) THEN
              CALL MPOSN(2,0)
              F2=.FALSE.
            ENDIF
            CALL MGULPR(2,R2,IE)
            IF (IE.NE.0) CALL CCPERR(1,'ERROR IN MGULPR (2)')
            S2=0.
            SS2=0.
            S3=0.
            SS3=0.
            NS3=0
          ENDIF
        ENDIF
C
        IN(3)=IW
        DO 4 IV=LV,MV
          IN(2)=IV
          IV1=MOD(IV,N1(2))
          IF (JT.GT.0) IV2=MOD(IV,N2(2))
          DO 4 IU=LU,MU
            IN(1)=IU
            IU1=MOD(IU,N1(1))
            RS1=SC1*R1(IU1,IV1)
            IF (F1 .AND. IU.LT.N1(1) .AND. IV.LT.N1(2)) THEN
              S1=S1+RS1
              SS1=SS1+RS1**2
              J=RS1+101.5
              IF (J.GT.0 .AND. J.LE.250) L1(J)=L1(J)+1
              Q1=AMIN1(Q1,RS1)
              CALL ORDER(IN,MP1,RS1,NPM,P1,NP1)
            ENDIF
C
            IF (JT.GT.0) THEN
              IU2=MOD(IU,N2(1))
              RS2=SC2*R2(IU2,IV2)
              IF (JT.EQ.1) THEN
                R=RS1+RS2
              ELSEIF (JT.EQ.2) THEN
                R=.01*RS1*RS2
              ELSEIF (JT.EQ.3) THEN
                IF (RS2.LE.0.) GOTO 4
                R=100.*RS1/RS2
              ELSE
                R=MIN(RS1,RS2)
              ENDIF
C
              IF (IT.LT.0) R2(IU,IV)=R
C
              IF (F2 .AND. IU.LT.N2(1) .AND. IV.LT.N2(2)) THEN
                S2=S2+RS2
                SS2=SS2+RS2**2
                J=RS2+101.5
                IF (J.GT.0 .AND. J.LE.250) L2(J)=L2(J)+1
                IF (JT.EQ.3) RS2=-RS2
                Q2=AMIN1(Q2,RS2)
                CALL ORDER(IN,MP2,RS2,NPM,P2,NP2)
              ENDIF
C
              S3=S3+R
              SS3=SS3+R*R
              NS3=NS3+1
              J=R+101.5
              IF (J.GT.0 .AND. J.LE.250) L3(J)=L3(J)+1
              Q3=AMIN1(Q3,R)
              CALL ORDER(IN,MP3,R,NPM,P3,NP3)
           ENDIF
4       CONTINUE
C
        IF (F1) THEN
          T1=T1+S1
          TT1=TT1+SS1
          NT1=NT1+NS1
          S1=S1/NS1
          SS1=SQRT(SS1/NS1-S1*S1)
          WRITE (6,130)IW,S1,SS1,NS1
130       FORMAT(' T-FUNCTION(1)   ,  SECTION',I5,5X,'MEAN =',F10.3,5X,
     &    'RMS =',F10.3,5X,'NO OF POINTS =',I8)
        ENDIF
C
        IF (JT.GT.0) THEN
          IF (F2) THEN
            T2=T2+S2
            TT2=TT2+SS2
            NT2=NT2+NS2
            S2=S2/NS2
            SS2=SQRT(SS2/NS2-S2*S2)
            WRITE (6,140)IW,S2,SS2,NS2
140         FORMAT(' T-FUNCTION(2)   ,  SECTION',I5,5X,'MEAN =',F10.3,
     &      5X,'RMS =',F10.3,5X,'NO OF POINTS =',I8)
          ENDIF
          T3=T3+S3
          TT3=TT3+SS3
          NT3=NT3+NS3
          S3=S3/NS3
          SS3=SQRT(SS3/NS3-S3*S3)
          WRITE (6,150)TO(JT),IW,S3,SS3,NS3
150       FORMAT(1X,A,' FUNCTION,  SECTION',I5,5X,'MEAN =',F10.3,5X,
     &    'RMS =',F10.3,5X,'NO OF POINTS =',I8)
        ENDIF
        IF (IT.LT.0) CALL MSPEW(3,R2)
        IW=IW+1
        IF (IW.LE.MW) GOTO 1
        IF (IT.LT.0) CALL MWCLOSE(3)
C
        T1=T1/NT1
        TT1=SQRT(TT1/NT1-T1*T1)
        WRITE (6,160)T1,TT1,Q1,NT1
160     FORMAT(///' T-FUNCTION(1)',13X,'OVERALL MEAN =',F9.2,5X,
     &   'RMS =',F9.2,5X,'MIN =',F9.2,5X,'NO OF POINTS =',I8)
C        CALL HISTO(L1)
C
        DO 2 I=1,3
          IXYZ(IUVW(I))=I
2         N1(I)=MAX(N1(I),2)
        DO 5 I=1,NP1
5         P1(I)=(P1(I)-T1)/TT1
C
CD        OPEN (2,FILE='M1',STATUS='NEW',CARRIAGECONTROL='LIST')
CD        WRITE (2,'(3I4,F8.2,I6)') N1,P1(NP1),NP1
CD        WRITE (2,'(3I4,F8.2)') ((MP1(J,I),J=1,3),P1(I),I=1,NP1)
CD        CLOSE (2)
C
        CALL PEAKS(N1,NP1,MP1,P1,LP,NHM,NH,MH,NN,NU,H,CH)
C
        NP1=MIN(NP1,100)
        WRITE (6,190) NP1,((MP1(IXYZ(J),I),J=1,3),TT1*P1(I)+T1,I=1,NP1)
190     FORMAT(//' HIGHEST',I4,' VALUES'/5(/1X,5(3I4,F10.3,4X)))
C
        WRITE (6,230)
230     FORMAT(//
     &  ' Columns below are:'/' Peak number, Number of points in peak ',
     &  '(total), Number (used), [x,y,z] (grid), Peak height, [x,y,z] ',
     &  '(fract), Signal/Noise.')
        WRITE (6,210) NH,(I,NN(I),NU(I),(CH(IXYZ(J),I),J=1,3),
     &  TT1*H(I)+T1,(CH(IXYZ(J),I)/NXYZ(J),J=1,3),H(I),I=1,NH)
210     FORMAT(/' HIGHEST',I4,' PEAKS :'
     &  /5(/1X,2I5,I4,6X,3F8.1,F10.2,6X,3F8.3,F8.2))
        IF (JT.EQ.0) THEN
          IF (NH.GT.0) THEN
            I=0
            CALL CCPDPN(7,'PEAK_LIST','NEW','F',0,I)
            WRITE (7,'(A)') T
            WRITE (7,'(I3,I5,I3,3X,3F7.1,F11.3,3X,3F7.3,F8.2)')
     &      (I,NN(I),NU(I),(CH(IXYZ(J),I),J=1,3),TT1*H(I)+T1,
     &      (CH(IXYZ(J),I)/NXYZ(J),J=1,3),H(I),I=1,NH)
            CLOSE (7)
          ENDIF
          RETURN
        ENDIF
C
        T2=T2/NT2
        TT2=SQRT(TT2/NT2-T2*T2)
        T3=T3/NT3
        TT3=SQRT(TT3/NT3-T3*T3)
        IF (JT.NE.3) THEN
          WRITE (6,170)T2,TT2,'MIN =',Q2,NT2
        ELSE
          Q2=-Q2
          WRITE (6,170)T2,TT2,'MAX =',Q2,NT2
170       FORMAT(///' T-FUNCTION(2)',13X,'OVERALL MEAN =',F9.2,5X,
     &    'RMS =',F9.2,5X,A,F9.2,5X,'NO OF POINTS =',I8)
        ENDIF
C        CALL HISTO(L2)
C
        IF (JT.EQ.3) T2=-T2
C
        DO 3 I=1,3
3         N2(I)=MAX(N2(I),2)
        DO 8 I=1,NP2
8         P2(I)=(P2(I)-T2)/TT2
C
CD       OPEN (2,FILE='M2',STATUS='NEW',CARRIAGECONTROL='LIST')
CD       WRITE (2,'(3I4,F8.2,I6)') N2,P2(NP2),NP2
CD       WRITE (2,'(3I4,F8.2)') ((MP2(J,I),J=1,3),P2(I),I=1,NP2)
CD       CLOSE (2)
C
        CALL PEAKS(N2,NP2,MP2,P2,LP,NHM,NH,MH,NN,NU,H,CH)
C
        NP2=MIN(NP2,100)
        IF (JT.NE.3) THEN
          WRITE (6,190)NP2,((MP2(IXYZ(J),I),J=1,3),TT2*P2(I)+T2,I=1,NP2)
        ELSE
          DO 6 I=1,NP2
6           P2(I)=-P2(I)
          WRITE (6,200)NP2,((MP2(IXYZ(J),I),J=1,3),TT2*P2(I)+T2,I=1,NP2)
200       FORMAT(//' LOWEST',I4,' VALUES'/5(/1X,5(3I4,F10.3,4X)))
        ENDIF
C
        IF (JT.NE.3) THEN
          WRITE (6,210) NH,(I,NN(I),NU(I),(CH(IXYZ(J),I),J=1,3),
     &    TT2*H(I)+T2,(CH(IXYZ(J),I)/NXYZ(J),J=1,3),H(I),I=1,NH)
        ELSE
          WRITE (6,220) NH,(I,NN(I),NU(I),(CH(IXYZ(J),I),J=1,3),
     &    TT2*H(I)+T2,(CH(IXYZ(J),I)/NXYZ(J),J=1,3),H(I),I=1,NH)
220       FORMAT(/' LOWEST',I4,' TROUGHS :'
     &    /5(/1X,2I5,I4,6X,3F8.1,F10.2,6X,3F8.3,F8.2))
        ENDIF
C
        WRITE (6,180) TO(JT),T3,TT3,Q3,NT3
180     FORMAT(///1X,A,' FUNCTION',10X,'OVERALL MEAN =',F9.2,5X,
     &   'RMS =',F9.2,5X,'MIN =',F9.2,5X,'NO OF POINTS =',I8)
C        CALL HISTO(L3)
C
        DO 7 I=1,3
7         N1(I)=MAX(N1(I),N2(I))
        DO 9 I=1,NP3
9         P3(I)=(P3(I)-T3)/TT3
C
CD       OPEN (2,FILE='M3',STATUS='NEW',CARRIAGECONTROL='LIST')
CD       WRITE (2,'(3I4,F8.2,I6)') N1,P3(NP3),NP3
CD       WRITE (2,'(3I4,F8.2)') ((MP3(J,I),J=1,3),P3(I),I=1,NP3)
CD       CLOSE (2)
C
        CALL PEAKS(N1,NP3,MP3,P3,LP,NHM,NH,MH,NN,NU,H,CH)
C
        NP3=MIN(NP3,100)
        WRITE (6,190)NP3,((MP3(IXYZ(J),I),J=1,3),TT3*P3(I)+T3,I=1,NP3)
C
        WRITE (6,210)NH,(I,NN(I),NU(I),(CH(IXYZ(J),I),J=1,3),
     &  TT3*H(I)+T3,(CH(IXYZ(J),I)/NXYZ(J),J=1,3),H(I),I=1,NH)
        IF (NH.GT.0) THEN
          I=0
          CALL CCPDPN(7,'PEAK_LIST','NEW','F',0,I)
          WRITE (7,'(A)') T
          WRITE (7,'(I3,I5,I3,3X,3F7.1,F11.3,3X,3F7.3,F8.2)')
     &    (I,NN(I),NU(I),(CH(IXYZ(J),I),J=1,3),TT3*H(I)+T3,
     &    (CH(IXYZ(J),I)/NXYZ(J),J=1,3),H(I),I=1,NH)
          CLOSE(7)
        ENDIF
        END
C
C
        SUBROUTINE ORDER(IN,M,R,NPM,P,NP)
        DIMENSION IN(3),M(3,*),P(*)
        IP=NP
1       IF (IP.EQ.0) GOTO 3
        IF (R.LE.P(IP)) GOTO 2
        IP=IP-1
        GOTO 1
C
2       IF (IP.EQ.NPM)RETURN
3       IP=IP+1
C
        NP=MIN(NPM,NP+1)
        DO 4 I=NP,IP+1,-1
          J=I-1
          P(I)=P(J)
          DO 4 K=1,3
4           M(K,I)=M(K,J)
        P(IP)=R
        DO 5 K=1,3
5         M(K,IP)=IN(K)
        END
C
C
C        SUBROUTINE HISTO(L)
C        DIMENSION L(250),N(250)
C        DO 1 J=1,250
C          IF (L(J).GT.0) GOTO 2
C1       CONTINUE
C        RETURN
C2       DO 3 K=1,250
C          IF (L(251-K).GT.0) GOTO 4
C3       CONTINUE
C        RETURN
C4       K=251-K
C        X=0.
C        DO 5 I=J,K
C          N(I)=I-101
C          IF (L(I).LE.X) GOTO 5
C          X=L(I)
C          M=I
C5       CONTINUE
C        X=N(M)+.5*(L(M+1)-L(M-1))/(2*L(M)-L(M+1)-L(M-1))
C        WRITE (6,100)X,(N(I),L(I),I=J,K)
C100     FORMAT(/' HISTOGRAM OF MAP VALUES.  MODE =',F10.3/
C     &   5(/1X,10(I9,I4)))
C        RETURN
C        END
C
C
        SUBROUTINE PEAKS(NUVW,NP,MP,P,LP,MAXH,NH,MH,NN,NU,H,C)
        DIMENSION NUVW(3),MJ(3),MK(3),IN(3),V(11),VLIM(2,11),
     &            MP(3,*),P(*),LP(*),MH(3,*),NN(*),NU(*),H(*),C(3,*)
        COMMON /OBSDAT/ NUVWC(3),PM,PO(-1:1,-1:1,-1:1)
        DATA VLIM/-9.,9.,-9.,9.,-9.,9.,-9.,9.,-9.,9.,-9.,9.,
     &            -9.,9.,-9.,9.,-9.,9.,-1.E9,1.E9,-1.E9,1.E9/
C
CD        WRITE (6,'(/)')
        DO 21 K=1,3
21        NUVWC(K)=NUVW(K)
        NH=0
        DO 26 IP=1,NP
26        LP(IP)=0
        DO 12 IP=1,NP
          IF (P(IP).LE.1.5 .OR. NH.EQ.MAXH) GOTO 13
          IF (LP(IP).GT.0) GOTO 12
          NH=NH+1
          LP(IP)=NH
          PT=P(IP)
CD          WRITE (6,'(1X,2I5,10X,3I5,5X,F10.2)')
CD     &    NH,IP,(MP(K,IP),K=1,3),P(IP)
C
27        N=0
          DO 6 JP=IP,NP
            IF (LP(JP).NE.NH) GOTO 6
            DO 22 K=1,3
              MJ(K)=MOD(MP(K,JP),NUVW(K))
22            IF (MJ(K).LE.0) MJ(K)=MJ(K)+NUVW(K)
            DO 5 KP=IP+1,NP
              IF (LP(KP).GT.0) GOTO 5
              IF (KP.GT.JP) THEN
                PT=MIN(PT,P(JP)+1.)
                IF (P(KP).GT.PT) GOTO 5
              ENDIF
              DO 23 K=1,3
                MK(K)=MOD(MP(K,KP),NUVW(K))
23              IF (MK(K).LT.0) MK(K)=MK(K)+NUVW(K)
C
C====   TEST FOR NEIGHBOUR
              DO 4 IW=MJ(3)-1,MJ(3)+1
                IF (MOD(IW,NUVW(3)).NE.MK(3)) GOTO 4
                IN(3)=IW
                DO 3 IV=MJ(2)-1,MJ(2)+1
                  IF (MOD(IV,NUVW(2)).NE.MK(2)) GOTO 3
                  IN(2)=IV
                  DO 2 IU=MJ(1)-1,MJ(1)+1
                    IF (MOD(IU,NUVW(1)).EQ.MK(1)) THEN
                      IN(1)=IU
                      LP(KP)=NH
                      DO 1 K=1,3
1                       MP(K,KP)=MP(K,JP)+(IN(K)-MJ(K))
CD                      WRITE (6,'(1X,3I5,5X,3I5,5X,F10.2)')
CD     &                NH,JP,KP,(MP(K,KP),K=1,3),P(KP)
                      N=N+1
                      GOTO 5
                    ENDIF
2                 CONTINUE
3               CONTINUE
4             CONTINUE
5           CONTINUE
6         CONTINUE
          IF (N.GT.0) GOTO 27
12      CONTINUE
C
13      PM=.9999*P(NP)
CD        WRITE (6,'(/)')
        DO 20 IH=1,NH
          NN(IH)=0
          NU(IH)=0
          NOB=0
          DO 14 IW=-1,1
            DO 14 IV=-1,1
              DO 14 IU=-1,1
14              PO(IU,IV,IW)=PM
C
          DO 17 IP=1,NP
            IF (LP(IP).NE.IH) GOTO 17
            IF (NN(IH).EQ.0) THEN
              DO 15 K=1,3
                MH(K,IH)=MP(K,IP)
15              C(K,IH)=MH(K,IH)
              H(IH)=P(IP)
CD              WRITE (6,'(/)')
            ENDIF
C
            NN(IH)=NN(IH)+1
            DO 16 K=1,3
              IN(K)=MP(K,IP)-MH(K,IH)
16            IF (ABS(IN(K)).GT.1) GOTO 17
C
            NU(IH)=NU(IH)+1
            NOB=NOB+1
            PO(IN(1),IN(2),IN(3))=P(IP)
C
CD            WRITE (6,'(1X,4I5,20X,3I5,F10.2,I10)')
CD     &      NOB,IH,JH,IP,(MP(K,IP),K=1,3),P(IP),NN(IH)
17        CONTINUE
C
          IF (NN(IH).GT.1) THEN
            DO 28 IW=-1,1,2
              DO 28 IV=-1,1
                DO 28 IU=-1,1
28                IF (PO(IU,IV,IW).GT.PM) GOTO 30
C
            DO 29 IW=-1,1,2
              DO 29 IV=-1,1
                DO 29 IU=-1,1
29                PO(IU,IV,IW)=PO(IU,IV,0)
C
30          DO 18 K=1,9
18            V(K)=0.
            DO 24 K=1,3
24            IF (NUVW(K).GT.2) V(K+3)=-1.
            V(11)=.5
            V(10)=H(IH)-V(11)
CD            WRITE (6,'(/)')
C IJT: Tighten convergence criterion.
            CALL CONDIR(.01,.001,11,VLIM,V,RMIN,ITER,IERR)
CD            WRITE (6,'(A,6(1PE14.5)/2X,5(1PE14.5))') ' V',V
CD            WRITE (6,*)'RMIN, ITER, IERR =',RMIN,ITER,IERR
C
            S=H(IH)
            IF (IERR.EQ.0) THEN
              DO 19 K=1,3
19              C(K,IH)=C(K,IH)+V(K)
              H(IH)=MAX(H(IH),V(10)+V(11))
            ENDIF
CD            WRITE (6,'(1X,3I5,5X,3I5,5X,3F8.2,2F10.2,2I8)')
CD     &      NOB,IH,JH,(MH(K,IH),K=1,3),(C(K,IH),K=1,3),S,H(IH),
CD     &      NN(IH),NU(IH)
C
CD          LU=MH(1,IH)
CD          LV=MH(2,IH)
CD          LW=MH(3,IH)
CD          DO 53 IW=LW-1,LW+1
CD            IN(3)=IW-LW
CD            V(3)=IW-C(3,IH)
CD            DO 53 IV=LV-1,LV+1
CD              IN(2)=IV-LV
CD              V(2)=IV-C(2,IH)
CD              DO 53 IU=LU-1,LU+1
CD                IN(1)=IU-LU
CD                V(1)=IU-C(1,IH)
CD                S=0.
CD                DO 52 I=1,3
CD                  J=MOD(I,3)+1
CD                  K=MOD(J,3)+1
CD52                S=S+V(I+3)*V(I)**2+V(I+6)*V(J)*V(K)
CD                S=V(10)*EXP(S)+V(11)
CD53              WRITE (6,'(1X,3I5,5X,3F10.2,5X,2F10.2)')
CD     &          IU,IV,IW,V(1),V(2),V(3),PO(IN(1),IN(2),IN(3)),S
C
          ENDIF
20      CONTINUE
        END
C
C
        SUBROUTINE CONDIR(CC1,CC2,N,XLIM,XP,R,ITER,IERR)
C
C====   Given a starting point XP that is a vector of length N,
C       Fletcher-Reeves-Polak-Ribiere conjugate direction minimisation is
C       performed on a function defined by DELVEC(x), using its gradient
C       calculated by SCGRAD(x,g).  The convergence tolerances on the
C       function arguments and function value are input as CC1 and CC2.
C       Limits on the function arguments are specified by XLIM.
C       Returned arguments are XP (location of minimum), R (minimum
C       function value), ITER (number of iterations) and IERR (error
C       status, 0 means no error).
C       The routine LINMIN is called to do line minimisations.
C
C       Note that this is incorrectly called "conjugate gradient", because
C       the function gradient vectors g (GV) are mutually orthogonal:
C       g(i).g(j) = 0.
C       It is the direction vectors h (DV) that are mutually conjugate:
C       h(i).A.h(j) = 0.
C       See Numerical Recipes (Fortran version, 1988),
C       Chap. 10, pp. 303-305.
C
C        IMPLICIT NONE
C
        INTEGER NMAX
        PARAMETER (NMAX=50)
C
        INTEGER I,IERR,ITER,N
        REAL CC1,CC2,F,R,R0,S,T
        REAL XLIM(2,*),XP(*),SV(NMAX)
C
        REAL G
        REAL DV(NMAX),GV(NMAX),XVL(2,NMAX),XV(NMAX)
        COMMON /FACCOM/ G,XVL,XV,GV,DV
C
        REAL DELVEC,SCGRAD
        EXTERNAL DELVEC,SCGRAD
C
        IERR=0
        DO 10 I=1,N
          XVL(1,I)=XLIM(1,I)
          XVL(2,I)=XLIM(2,I)
10        XV(I)=XP(I)
C
        F=0.
        G=0.
        R=DELVEC(F)
        G=SCGRAD(F)
        DO 20 I=1,N
          DV(I)=-GV(I)
20        SV(I)=GV(I)
C
        F=1.
        DO 50 ITER=1,MAX(NMAX,200)
          G=0.
          R0=R
          CALL LINMIN(CC1,DELVEC,SCGRAD,F,R)
C IJT Calculate final gradient for next leg.
          IF (F.NE.G) THEN
            R=DELVEC(F)
            G=SCGRAD(F)
          ENDIF
C
          DO 30 I=1,N
            IF (XV(I).LT.XLIM(1,I) .OR. XV(I).GT.XLIM(2,I)) THEN
              IERR=1
              RETURN
            ENDIF
30        CONTINUE
          IF (2.*ABS(R-R0).LE.CC2*(R+R0+1.E-20)) GOTO 60
C
          S=0.
          T=0.
          DO 40 I=1,N
            S=S+SV(I)**2
40          T=T+(GV(I)-SV(I))*GV(I)
          IF (S.EQ.0.) GOTO 60
          T=T/S
          DO 50 I=1,N
            DV(I)=T*DV(I)-GV(I)
50          SV(I)=GV(I)
C
60      DO 70 I=1,N
70        XP(I)=XV(I)
        END
C
C
        REAL FUNCTION DELVEC(F)
C####   Apply shift vector F*DV to Chi-squared function argument vector.
C####   Get gradient vector GV of function.
C####   DELVEC returns Chi-squared value R.
C####   SCGRAD returns scalar gradient (= GV.DV) for line minimisations.
C
C        IMPLICIT NONE
C
        INTEGER NMAX
        PARAMETER (NMAX=50)
C
        INTEGER I,IU,IV,IW,J,K
        REAL D,DP,DS,F,FS,PE,R,S
        REAL DG(11),DX(3),PC(-1:1,-1:1,-1:1)
C
        INTEGER NUVWC(3)
        REAL G,PM
        REAL DV(NMAX),GV(NMAX),PO(-1:1,-1:1,-1:1),XVL(2,NMAX),XV(NMAX)
        COMMON /OBSDAT/ NUVWC,PM,PO
        COMMON /FACCOM/ G,XVL,XV,GV,DV
C
        REAL SCGRAD
        SAVE FS,PC,PE
C
        FS=F
        D=F-G
        IF (D.NE.0.) THEN
        DO 100 I=1,11
          DG(I)=D*DV(I)
          IF (DG(I).LT.XVL(1,I) .OR. DG(I).GT.XVL(2,I)) THEN
            PE=0.
            DO 110 IW=-1,1
              DO 110 IV=-1,1
                DO 110 IU=-1,1
110               PC(IU,IV,IW)=XV(11)
            DELVEC=1.7E38
            RETURN
          ENDIF
100     CONTINUE
C
          G=F
          DO 10 I=1,11
10          XV(I)=XV(I)+DG(I)
CD          WRITE (6,'(A,6(1PE14.5)/3X,5(1PE14.5))') ' XV',(XV(I),I=1,11)
        ENDIF
C
        R=0.
        DO 30 IW=-1,1
          DX(3)=IW-XV(3)
          DO 30 IV=-1,1
            DX(2)=IV-XV(2)
            DO 30 IU=-1,1
              DX(1)=IU-XV(1)
              S=0.
              DO 20 I=1,3
                J=MOD(I,3)+1
                K=MOD(J,3)+1
20              S=S+XV(I+3)*DX(I)**2+XV(I+6)*DX(J)*DX(K)
              PE=EXP(MIN(MAX(S,-14.),2.3))
              PC(IU,IV,IW)=XV(10)*PE+XV(11)
              DS=PO(IU,IV,IW)*(PC(IU,IV,IW)-PO(IU,IV,IW))**2
              IF (PC(IU,IV,IW).LE.PM .AND. PO(IU,IV,IW).LE.PM)
     &        DS=1.E-6*DS
30            R=R+DS
C
        R=.5*R
        DELVEC=R
CD        WRITE (6,*)' DELVEC',R
        RETURN
C
        ENTRY SCGRAD(F)
        IF (F.NE.FS) CALL CCPERR(1,'*** BUG CALLING SCGRAD.')
        DO 40 I=1,11
40        GV(I)=0.
C
        DO 70 IW=-1,1
          DX(3)=IW-XV(3)
          DO 70 IV=-1,1
            DX(2)=IV-XV(2)
            DO 70 IU=-1,1
              DX(1)=IU-XV(1)
              DP=PO(IU,IV,IW)*(PC(IU,IV,IW)-PO(IU,IV,IW))
              S=DP*(PC(IU,IV,IW)-XV(11))
              DO 50 I=1,3
                J=MOD(I,3)+1
                K=MOD(J,3)+1
                DG(I)=-S*(2.*XV(I+3)*DX(I)+XV(K+6)*DX(J)+XV(J+6)*DX(K))
                DG(I+3)=S*DX(I)**2
50              DG(I+6)=S*DX(J)*DX(K)
              DG(10)=DP*PE
              DG(11)=DP
              IF (PC(IU,IV,IW).LE.PM .AND. PO(IU,IV,IW).LE.PM) THEN
                DO 60 I=1,11
60                DG(I)=1.E-6*DG(I)
              ENDIF
              DO 70 I=1,11
70              GV(I)=GV(I)+DG(I)
C
        DO 80 I=1,3
          IF (NUVWC(I).LE.2) THEN
            GV(I)=0.
            GV(I+3)=0.
            J=MOD(I,3)+1
            K=MOD(J,3)+1
            GV(J+6)=0.
            GV(K+6)=0.
          ENDIF
80      CONTINUE
CD        WRITE (6,'(A,6(1PE14.5)/3X,5(1PE14.5))') ' GV',(GV(I),I=1,11)
C
        R=0.
        DO 90 I=1,11
90        R=R+GV(I)*DV(I)
        SCGRAD=R
        END
C
C
        SUBROUTINE LINMIN(CC,FUNC,GRAD,X,FX)
C####   Minimisation of FX=FUNC(X) by line search along X.
C
C       On input :
C       CC      = Required precision in X (if negative uses absolute
C                 precision, otherwise relative).
C       FUNC    = Function call.
C       GRAD    = Function gradient call.
C       X       = Estimate of X at minimum.
C       FX      = FUNC(0.)
C
C       On output :
C       X       = New estimate of X at minimum.
C       FX      = FUNC(X)
C
C
C        IMPLICIT NONE
        REAL GR
        PARAMETER (GR=1.618034)
        LOGICAL L1,L2
        REAL FUNC,GRAD
        EXTERNAL FUNC, GRAD
        REAL A,AX,B,BX,C1,C2,CC,CX,D,D1,D2,E,ET,FA,FB,FC,FU,FV,FW,FX,GU,
     &  GV,GW,GX,Q,R,U,U1,U2,UM,V,W,X,XM
C
        AX=0.
        FA=FX
        BX=X
        FB=FUNC(BX)
        CX=2.*X
        IF (FB.GT.FA) THEN
          AX=BX
          BX=0.
          CX=BX-CX
          FC=FB
          FB=FA
          FA=FC
        ENDIF
        FC=FUNC(CX)
10      IF (FB.GE.FC) THEN
          R=(BX-AX)*(FB-FC)
          Q=(BX-CX)*(FB-FA)
          U=BX-((BX-CX)*Q-(BX-AX)*R)/(2.*SIGN(MAX(ABS(Q-R),1.E-20),Q-R))
          UM=BX+100.*(CX-BX)
          IF ((BX-U)*(U-CX).GT.0.) THEN
            FU=FUNC(U)
            IF (FU.LT.FC) THEN
              AX=BX
              FA=FB
              BX=U
              FB=FU
              GOTO 10
            ELSEIF (FU.GT.FB) THEN
              CX=U
              FC=FU
              GOTO 10
            ENDIF
            U=CX+GR*(CX-BX)
            FU=FUNC(U)
          ELSEIF ((CX-U)*(U-UM).GT.0.) THEN
            FU=FUNC(U)
            IF (FU.LT.FC) THEN
              BX=CX
              CX=U
              U=CX+GR*(CX-BX)
              FB=FC
              FC=FU
              FU=FUNC(U)
            ENDIF
          ELSEIF ((U-UM)*(UM-CX).GE.0.) THEN
            U=UM
            FU=FUNC(U)
          ELSE
            U=CX+GR*(CX-BX)
            FU=FUNC(U)
          ENDIF
          AX=BX
          BX=CX
          CX=U
          FA=FB
          FB=FC
          FC=FU
          GOTO 10
        ENDIF
C
        A=MIN(AX,CX)
        B=MAX(AX,CX)
        V=BX
        W=V
        X=V
        E=0.
        IF (X.NE.CX) FB=FUNC(X)
        FX=FB
        FV=FX
        FW=FX
        GX=GRAD(X)
        GV=GX
        GW=GX
        IF (CC.LE.0.) THEN
          C1=-CC
          C2=2.*C1
        ENDIF
20      XM=.5*(A+B)
        IF (CC.GT.0.) THEN
          C1=CC*ABS(XM)+1.E-20
          C2=2.*C1
        ENDIF
        IF (ABS(X-XM).LE.C2-.5*(B-A)) RETURN
        IF (ABS(E).GT.C1) THEN
          D1=2.*(B-A)
          D2=D1
          IF (GW.NE.GX) D1=(W-X)*GX/(GX-GW)
          IF (GV.NE.GX) D2=(V-X)*GX/(GX-GV)
          U1=X+D1
          U2=X+D2
          L1=(A-U1)*(U1-B).GT.0. .AND. GX*D1.LE.0.
          L2=(A-U2)*(U2-B).GT.0. .AND. GX*D2.LE.0.
          ET=E
          E=D
          IF (.NOT.(L1 .OR. L2)) THEN
            IF (GX.GE.0.) THEN
              E=A-X
            ELSE
              E=B-X
            ENDIF
            D=.5*E
          ELSEIF (L1 .AND. L2) THEN
            IF (ABS(D1).LT.ABS(D2)) THEN
              D=D1
            ELSE
              D=D2
            ENDIF
          ELSEIF (L1) THEN
            D=D1
          ELSE
            D=D2
          ENDIF
          IF (ABS(D).GT.ABS(.5*ET)) THEN
            IF (GX.GE.0.) THEN
              E=A-X
            ELSE
              E=B-X
            ENDIF
            D=.5*E
          ELSE
            U=X+D
            IF (U-A.LT.C2 .OR. B-U.LT.C2) D=SIGN(C1,XM-X)
          ENDIF
        ELSE
          IF (GX.GE.0.) THEN
            E=A-X
          ELSE
            E=B-X
          ENDIF
          D=.5*E
        ENDIF
        IF (ABS(D).GE.C1) THEN
          U=X+D
          FU=FUNC(U)
        ELSE
          U=X+SIGN(C1,D)
          FU=FUNC(U)
          IF (FU.GT.FX) RETURN
        ENDIF
        GU=GRAD(U)
        IF (FU.LE.FX) THEN
          IF (U.GE.X) THEN
            A=X
          ELSE
            B=X
          ENDIF
          V=W
          FV=FW
          GV=GW
          W=X
          FW=FX
          GW=GX
          X=U
          FX=FU
          GX=GU
        ELSE
          IF (U.LT.X) THEN
            A=U
          ELSE
            B=U
          ENDIF
          IF (FU.LE.FW .OR. W.EQ.X) THEN
            V=W
            FV=FW
            GV=GW
            W=U
            FW=FU
            GW=GU
          ELSEIF (FU.LE.FV .OR. V.EQ.X .OR. V.EQ.W) THEN
            V=U
            FV=FU
            GV=GU
          ENDIF
        ENDIF
        GOTO 20
        END
