//
//
//     This code is distributed under the terms and conditions of the
//     CCP4 Program Suite Licence Agreement as a CCP4 Application.
//     A copy of the CCP4 licence can be obtained by writing to the
//     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
//
// =========================================================================
//
//
//
//  10 September 2001
//
//
// =========================================================================
//

#ifndef  __PCUR_Funcs__
#define  __PCUR_Funcs__


#ifndef  __MMDB_Manager__
#include "mmdb_manager.h"
#endif

#ifndef  __MMDB_Tables__
#include "mmdb_tables.h"
#endif

#define  END_OF_INPUT              111
#define  EMPTY_SELECTION            11

#define  Err_RENCHAIN             -100
#define  Err_RENRESIDUE           -101
#define  Err_RENATOM              -102
#define  Err_RENELEMENT           -103
#define  Err_DELMODEL             -104
#define  Err_DELCHAIN             -105
#define  Err_DELRESIDUE           -106
#define  Err_DELATOM              -107
#define  Err_LVMODEL              -108
#define  Err_LVCHAIN              -109
#define  Err_LVRESIDUE            -110
#define  Err_LVATOM               -111
#define  Err_WRITE                -112
#define  Err_WRITE_TYPE           -113
#define  Err_SYMMETRY             -114
#define  Err_SYMMETRY_NOLIB       -115
#define  Err_SYMMETRY_SPGRP       -116
#define  Err_SYMMETRY_NOSYMOP     -117
#define  Err_GEOMETRY             -118
#define  Err_GEOMETRY_FORMAT      -119
#define  Err_GENUNIT_NOSYMOP      -120
#define  Err_GENUNIT_TRANSFORM    -121
#define  Err_GENUNIT_CELL         -122
#define  Err_SYMOP                -123
#define  Err_SYMCOMMIT_NOSYMOP    -124
#define  Err_SYMCOMMIT_TRANSFORM  -125
#define  Err_SYMCOMMIT_CELL       -126
#define  Err_SYMCOMMIT_UNKNOWN    -127
#define  Err_MKCHAINIDS           -128
#define  Err_ROTATE1              -129
#define  Err_ROTATE2              -130
#define  Err_ROTATE3              -131
#define  Err_ROTATE4              -132
#define  Err_VROTATE1             -133
#define  Err_VROTATE2             -134
#define  Err_VROTATE3             -135
#define  Err_VROTATE4             -136
#define  Err_VROTATE5             -137
#define  Err_TRANSLATE1           -138
#define  Err_TRANSLATE2           -139
#define  Err_DELDIST              -140
#define  Err_LVDIST               -141
#define  Err_KEYWORD              -200



// ------------------- input drivers  -------------------------

extern void summarise ( CCP4PARSERTOKEN * token, int ntok,
			RCMMDBManager MMDB,  int & RC );

extern void delsolvent   ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void delhydrogen  ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void mostprob  ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void cutoffocc  ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void delanisou  ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void renchain   ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void renresidue ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void renatom    ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void renelement ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void delmodel   ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void delchain   ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void delresidue ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void delatom    ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void deldist    ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void lvmodel    ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void lvchain    ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void lvresidue  ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void lvatom     ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void lvdist     ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void genter     ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void sernum     ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void mvsolvent  ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void write      ( CCP4PARSERTOKEN * token, int ntok,
                         int & FType,  int & RC );

extern void symmetry   ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  pstr line, int & RC );

extern void geometry   ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void genunit    ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void symop      ( CCP4PARSERTOKEN * token, int ntok,
                         RCGenSym   GenSym,   int & RC );

extern void symcommit  ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  RCGenSym GenSym, int & RC );

extern void mkchainids ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void rotate     ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void translate  ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );

extern void vrotate    ( CCP4PARSERTOKEN * token, int ntok,
                         RCMMDBManager MMDB,  int & RC );


// -----------------  action functions  -----------------------

extern int summariseModel ( RCMMDBManager MMDB );

extern int selectMostProbable ( RCMMDBManager MMDB, std::string chain_to_keep );

extern int setOccupancyCutoff ( RCMMDBManager MMDB, realtype cutoff );

extern int removeAnisou   ( RCMMDBManager MMDB );

extern int renameChain    ( RCMMDBManager MMDB, pstr oldName, pstr newName );
extern int renameResidue  ( RCMMDBManager MMDB, pstr oldName, pstr newName );
extern int renameAtom     ( RCMMDBManager MMDB, pstr oldName, pstr newName );
extern int renameElement  ( RCMMDBManager MMDB, pstr oldName, pstr newName );

extern int deleteModel    ( RCMMDBManager MMDB, pstr selection );
extern int deleteChain    ( RCMMDBManager MMDB, pstr selection );
extern int deleteResidue  ( RCMMDBManager MMDB, pstr selection );
extern int deleteAtom     ( RCMMDBManager MMDB, pstr selection );
extern int deleteDist     ( RCMMDBManager MMDB, realtype x0, realtype y0, 
                                      realtype z0, realtype R0 );

extern int leaveModel     ( RCMMDBManager MMDB, pstr selection );
extern int leaveChain     ( RCMMDBManager MMDB, pstr selection );
extern int leaveResidue   ( RCMMDBManager MMDB, pstr selection );
extern int leaveAtom      ( RCMMDBManager MMDB, pstr selection );
extern int leaveDist      ( RCMMDBManager MMDB, realtype x0, realtype y0, 
                                      realtype z0, realtype R0 );

extern int EulerRotation  ( RCMMDBManager MMDB, pstr selection,
                            realtype alpha, realtype beta, realtype gamma );
extern int EulerRotation  ( RCMMDBManager MMDB, pstr selection,
                            realtype alpha, realtype beta, realtype gamma,
                            realtype x0,    realtype y0,   realtype z0 );

extern int FracTranslation ( RCMMDBManager MMDB, pstr selection,
			      realtype x, realtype y, realtype z );

extern int OrthTranslation ( RCMMDBManager MMDB, pstr selection,
			      realtype x, realtype y, realtype z );

extern int VectorRotation ( RCMMDBManager MMDB, pstr selection,
                            realtype alpha,
                            realtype vx, realtype vy, realtype vz,
                            realtype x,  realtype y,  realtype z );

extern int VectorRotation ( RCMMDBManager MMDB, pstr selection,
                            realtype alpha,
                            realtype vx, realtype vy, realtype vz );

extern int VectorRotation ( RCMMDBManager MMDB, pstr selection,
                            realtype alpha,
                            pstr atom1, pstr atom2 );

#endif
