C
C     MOLREP molecular replacement program
C     Copyright (C) 1999-2006 Alexei Vagin
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C ******
      SUBROUTINE WBLOCK_MEM(MT,IBLOCK,NW,IPOOL,IERR)
C
C -P- WBLOCK - writes (unformatted) data block to file 
C
C     input : NW - number of wolds(4-bytes) that they will be written to MT
C                  from IBLOCK
C             IBLOCK - integer array
C     output : IERR - 0  normal end
C                     1  error
CMS      : IBLOCK
      PARAMETER ( NWMAX= 512 )
      INTEGER*4 MT,NW,IBLOCK(*),IERR
C ******
      INTEGER*4         IPOOL(*)
      COMMON/COM_DPOOL/ IPOOL_MAX,IPOOL_CURR
C ---------------------------------------------------------------------
      MDOC=0
      IERR=0
      IF(MT.EQ.0) RETURN
      IF(NW.LE.0) THEN
        CALL MSGERR(MDOC,' ERR IN WBLOCK_MEM: WRONG NUMBER WORDS')
        IERR=1
        RETURN
      ENDIF
      NW0=0
      NW1=1
10    NW2=NW0+NWMAX
      IF(NW2.GT.NW) THEN
        NWW=NW-NW0
      ELSE
        NWW=NWMAX
      ENDIF
      NW0=NW0+NWW
C N    CALL WFILE(MT,0,IBLOCK(NW1),-1,NWW)
C N    IF(ERRCODE.NE.0) GO TO 9
C 
      II0=NW1-1
      IF(IPOOL_MAX.GT.0) THEN
        IF((IPOOL_CURR + NWW).GT.IPOOL_MAX) GO TO 8  
        DO II=1,NWW
          IPOOL(IPOOL_CURR + II) = IBLOCK(II0+II) 
        ENDDO
        IPOOL_CURR = IPOOL_CURR + NWW
      ELSE    
        WRITE(MT,ERR=9) (IBLOCK(II0+II),II=1,NWW)
      ENDIF
      NW1=NW1+NWW
      IF(NW1.LE.NW) GO TO 10
      RETURN
C -------------------------
    9 CONTINUE
      CALL MSGERR(MDOC,' ERROR:  in WBLOCK_MEM: WRITE TO OUTPUT-FILE')
      IERR=1
      RETURN
   8  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WBLOCK_MEM: not memory enough')
      WRITE(*,*) 'IPOOL_CURR,IPOOL_MAX:',IPOOL_CURR,IPOOL_MAX
      WRITE(*,*) NW,NWW
      IERR=1
      RETURN
      END

      SUBROUTINE GET_SYMM(MDOC,NOSPGR,ISETT,SGNAME,NSYM,ISYM
     *                              ,MAXNSO,IERR)
C -------------------------------------------------------
C -P- GET_SYMM - generate cryst.symm. oparators from space group name or space
C -P-            group number.
C -------------------------------------------------------
C -------------------------------------------------------
      INTEGER   MDOC,IERR,MAXNSO
C --
      INTEGER*2 ISYM(5,3,MAXNSO)
      INTEGER   NOSPGR,ISETT,NSYM
      CHARACTER SGNAME*(*)
C -----------------------------------
      CHARACTER LINE*80
C -----------------------------------
      INTEGER   L,M,LENS,LEN
      INTEGER   NO_CCP4
C -------------------------------------------------------
      IERR = 0
      M    = 99
C ------------------------------------
      NSYM  = 0
C ------------------------------------
c      write(*,*) 'sgname:',SGNAME,nospgr,isett,nsym

      CALL LENSTR_BL(SGNAME,LENS)
      IF(LENS.LE.0) THEN
        IF(NOSPGR.LE.0) THEN
C         default P1
          GO TO 100
        ELSE
C          --> use space group number
          CALL NSG_STAND_TO_CCP4(NOSPGR,ISETT,NO_CCP4,IERR)
          IF(IERR.NE.0) GO TO 100      
        ENDIF
      ELSE
c        IF(NOSPGR.GT.0) THEN
c          CALL NSG_STAND_TO_CCP4(NOSPGR,ISETT,NO_CCP4,IERR)
c          IF(IERR.NE.0) GO TO 100      
c        ENDIF
        NO_CCP4 = 0
C         use space group name
      ENDIF
C ------------------------------------------
      CALL GET_SYMM_NB_NEW(MDOC,NO_CCP4,SGNAME,NSYM
     *                              ,ISYM,MAXNSO,IERR)
      IF(IERR.NE.0) GO TO 100      
C --
      CALL NSG_CCP4_TO_STAND(NO_CCP4,NOSPGR,ISETT,IERR)
C ------------------------------------------
c
c      write(*,*) '=sgname:',SGNAME,nospgr,isett,nsym,no_ccp4
c

      RETURN
 100  CONTINUE
      NOSPGR      = 1
      ISETT       = 1
      NSYM        = 1
      ISYM(1,1,1) = 1
      ISYM(2,1,1) = 0
      ISYM(3,1,1) = 0
      ISYM(4,1,1) = 0
      ISYM(5,1,1) = 1
      ISYM(1,2,1) = 0
      ISYM(2,2,1) = 1
      ISYM(3,2,1) = 0
      ISYM(4,2,1) = 0
      ISYM(5,2,1) = 1
      ISYM(1,3,1) = 0
      ISYM(2,3,1) = 0
      ISYM(3,3,1) = 1
      ISYM(4,3,1) = 0
      ISYM(5,3,1) = 1

      LINE = ' WARNING: can''t find space group name'
      CALL MSGERR(MDOC,LINE)
      CALL LENSTR_BL(SGNAME,L)
      IF(L.GT.0) THEN
        IF(L.GT.12) L = 12
      ELSE
        L      = 1
        SGNAME = ' '
      ENDIF 
      LINE = '              -->'//SGNAME(1:L)//'<--'
      CALL MSGERR(MDOC,LINE)
      CALL MSGERR(MDOC,'        default space group is "P 1"')

      SGNAME     = 'P 1'
      IERR=-1
      RETURN
      END

      SUBROUTINE GET_SYMM_NB_NEW(MDOC,NOSPGR,SGNAME,NSYM
     *                              ,ISYM,MAXNSO,IERR)
C -------------------------------------------------------
C -P- GET_SYMM - generate cryst.symm. oparators from space group name or space
C -P-            group number.
C
C     input:  NOSPGR,SGNAME
C
C     output: CS_NSYM,SYM,TRANS  
C             IERR
C             NOSPGR        if SGNAME is input
C             SGNAME        if NOSPGR  are input
C -------------------------------------------------------
      IMPLICIT NONE
      INTEGER   MDOC,IERR
      INTEGER   MAXNSO
      INTEGER*2 ISYM(5,3,MAXNSO)
C      REAL      SYM(3,3,MAXNSO)
C      REAL      TRANS(3,MAXNSO)
      INTEGER   NOSPGR,NSYM
      CHARACTER SGNAME*(*)
      
      CHARACTER NAMSPG_CIFS*20,NAMPG*20

      INTEGER ISYM_UNIT,NSYMP,J,I,IS
C
      INTEGER NumSymmetry
      REAL RealSymmMatrx(4,4,192),T
C ---------------------------------------------------------
      IERR = 0
C
C---Read symetry operators and remaining identifiers of the space
C---group
      ISYM_UNIT = 0
      CALL MSYMLB3(ISYM_UNIT,NOSPGR,SGNAME,NAMSPG_CIFS,
     +                   NAMPG,NSYMP,NumSymmetry,RealSymmMatrx)
C
C---Store symmetry operators in SYM and TRANS as Alexei wants
      NSYM = NumSymmetry
      DO    IS=1,NSYM
        DO   J=1,3
          DO   I=1,3
            ISYM(I,J,IS) = NINT(RealSymmMatrx(J,I,IS))
          ENDDO
          T              = RealSymmMatrx(J,4,IS)*24
          ISYM(4,J,IS) = NINT(T)
          ISYM(5,J,IS) = 24
        ENDDO
      ENDDO
C     SGNAME = NAMSPG_CIFS 
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
C     dummy routine
      IERR    = 1
      RETURN
      END
