C
C     MTZ2VARIOUS
C     Copyright (C) 1992 Eleanor Dodson
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C

C*************************************************************
C     
C     
C**************************************************************
C     
      PROGRAM MTZ2VARIOUS
C     ===================
C     
C      This program is really designed to turn mtz files into various ASCII 
C      formats.
C     Options depend to some extend on output choice
C     output F SIGF , I SIGI   for each HKL with an optional FreeR flag
C     if anomalous data  requested, it will output
C     hkl F(+) SIGF(+) I(+) SIGI(+) FREE followed one next line by 
C     hkl F(-) SIGF(-) I(-) SIGI(-) with the same FreeR
C     It can also output phases FCALC etc.
C
C     14/JUL/08 Graeme Winter - fixed output of scalepack format from
C     intensities (I+, I-) which was previously broken. Bug # 3162.
C
C     20/05/03 and before Martyn Winn
C     Extensions to OUTPUT CIF option
C
C     10/6/96 Peter Keller
C     Added OUTPUT CIF option
C     16/6/94 Phil Evans
C     Added TNT option & EXCLUDE FREER
C     28/3/94 Phil Evans
C       Options EXCLUDE FP[H]MAX
C     17/1/93 Phil Evans
C       Option to output -h-k-l for Xplor if DP & SIGDP are assigned
C
C     1-Oct-1993 Phil Evans   MRC LMB Cambridge
C     Made output stream always HKLOUT
C     
C     Altered to make EXCLUDE consistant between FORMATs
C     Jim Raftery 10 September 1993
C     
C     SPECIFICATION STATEMENTS
      INTEGER NPARM,MCOLS,MSETS
      PARAMETER (NPARM=200)
      PARAMETER (MCOLS=500)
      PARAMETER (MSETS=200)
      INTEGER MAX_WARNINGS
      PARAMETER (MAX_WARNINGS=10)
C     
      REAL RESMIN,RESMAX,STEP,SRANG,S,FF,SDFSQ,FSQ,SIGF
      REAL FC,PHIC,FPART,PHIB,FOM,SR0,SR1,FFP,SCAL,DEL,SIGH
      REAL FPMAX,FPHMAX,VAL_MISSING
      INTEGER NSALL(51),NSGOOD(51),NSGOODI(51),IN(3),ISORT(5),IRNG(21)
      INTEGER I,II,IMULT,IXPLO,IFLAG,NMON,MTZIN,NERR,IFREER,KINFRE
      INTEGER NS,NCHK,NSTART,ITOK,NLPRGI,LL,IOSTAT,IOUT,ifreer_main
      INTEGER ICHAR0,ICHAR1,IFAIL,IUN22,ISHEL,ISHELD,NREF,ISCAL,ITNT,
     +        INAN,ICIF,IMAIN
      INTEGER ISCRL,ISUB,JDO290,JDO300,JDO310
      INTEGER num_warnings
C     
C---- Mtz file variables
C     
      REAL ADATA(MCOLS), RSYM(4,4,192),RANGES(2,MCOLS), err(6)
      REAL DATCELL(6,MSETS),DATWAVE(MSETS)
      INTEGER LOOKUP(MCOLS), NSYM, NCOLX, NREFLX , COLOUT(MCOLS)
      LOGICAL LOGMSS(MCOLS)
      CHARACTER FMT*80, VERSNX*10
      integer nsympx,nspgrx,NDATASETS,ISETS(MSETS),CSETID(MCOLS)
      character ltypex*1, spgrnx*10, 
     +          launam*10,pgnamx*10, symchs(196)*80,lattx(8),
     +          PNAME(MSETS)*64,XNAME(MSETS)*64,DNAME(MSETS)*64
C     
C---- things for parser
C     
      CHARACTER KEY*4,CVALUE(NPARM)*4,LINE*600,LINESAV*600,WORD*10
      REAL      FVALUE(NPARM)
      LOGICAL   LEND,LPRINT,EOF,LANOM,lincl,LANFLGP,LANFLGM,LSCAL
      INTEGER   LUNIN,LUNOUT,IFSQ,ISQRT,JANOMF,JANOMP,JANOMI
      INTEGER   NTOK,IBEG(NPARM),IEND(NPARM),ITYPE(NPARM),IDEC(NPARM)
      CHARACTER CTPRGI(MCOLS)*1,LSPRGI(MCOLS)*30,
     +          CTUSRI(MCOLS)*1,LSUSRI(MCOLS)*30

c ___ SOME CIF things
      integer iun23
      character rstat*1, ciflne*80, spgrnx_cif*80, spgrnx_cifs*80
      logical cif_missing

c ___ Number of real items which might appear on a CIF REFLN packet
      integer cifrcols
      parameter (cifrcols=24)

      real cifrec(cifrcols), cell(6)
      character*80 cifrnames(cifrcols), dbhead
      character*10 cifrfmt(cifrcols)
      integer m2ciflkup(cifrcols), cifwdth(cifrcols), nrobs, ldbhead
C
C---- External Routines
C
      LOGICAL CCPONL, SAWOUT,Fs_plus_Is 
      EXTERNAL CCPDPN,CCPERR,CCPFYP,CCPLWC,CCPONL,CCPRCS,CCPUPC,CENTR,
     +         CENTRIC,GTPINT,GTPREA,LKYIN,LRASSN,LRINFO,LROPEN,LRREFF,
     +         LRREFM,LRRSOL,LRSORT,LRSYMI,LRSYMM,MTZINI,PARSER,RDRESO

C     
C---- Common Blocks
C     
      integer ihmin(3), ihmax(3),nrfout,nobs_wrki,nobs_frei,ireso,
     +    nwave,iphid
      real sigp,smax,smin,WAVELENGTH(MSETS)
      COMMON /CIFVARSI/ ihmin, ihmax,nrfout,nobs_wrki,nobs_frei,
     +    ireso,nwave
      COMMON /CIFVARSR/ sigp,smax,smin,WAVELENGTH

      COMMON /PINOUT/ LUNIN,LUNOUT

c ___ equivalences between MTZ columns and CIF data names from
c     the REFLN category:
c
c        CIF data item                MTZ2VARIOUS prog. label
c        _refln.F_meas_au                       FP (mean if anomalous present)
c        _refln.F_meas_sigma_au                 SIGFP 
c        _refln.F_calc                          FC
c        _refln.phase_calc                      PHIC
c        _refln.fom                             FOM
c        _refln.intensity_meas                  I (mean if anomalous present)
c        _refln.intensity_sigma                 SIGI
c        _refln.ebi_F_xplor_bulk_solvent_calc   FPART_BULK_S
c        _refln.ebi_phase_xplor_bulk_solvent_calc PHIPART_BULK_S
c        _refln.phase_meas                      PHIB
c        _refln.pdbx_HL_A_iso                   HLA
c        _refln.pdbx_HL_B_iso                   HLB
c        _refln.pdbx_HL_C_iso                   HLC
c        _refln.pdbx_HL_D_iso                   HLD
c        _refln.pdbx_F_plus                     F(+)
c        _refln.pdbx_F_plus_sigma               SIGF(+)
c        _refln.pdbx_F_minus                    F(-)
c        _refln.pdbx_F_minus_sigma              SIGF(-)
c        _refln.pdbx_anom_difference            DP
c        _refln.pdbx_anom_difference_sigma      SIGDP
c        _refln.pdbx_I_plus                     I(+)
c        _refln.pdbx_I_plus_sigma               SIGI(+)
c        _refln.pdbx_I_minus                    I(-)
c        _refln.pdbx_I_minus_sigma              SIGI(-) 

c ___ N.B. Elements 6 and 7 of this array (corresponding to intensities
c     and sigma(intensities) are modified during the treatment of
c     anomalous data.

C    jcentr   0 1 2 3 4 5 6
C    ltypex = P A B C F I R
C
      data lattx / 'P','A','B','C','F','I','R','H'/
      data cifrnames / '_refln.F_meas_au',
     &  '_refln.F_meas_sigma_au',
     &  '_refln.F_calc',
     &  '_refln.phase_calc',
     &  '_refln.fom', 
     &  '_refln.intensity_meas',
     &  '_refln.intensity_sigma',
     +  '_refln.ebi_F_xplor_bulk_solvent_calc',
     +  '_refln.ebi_phase_xplor_bulk_solvent_calc',
     +  '_refln.phase_meas',
     +  '_refln.pdbx_HL_A_iso',
     +  '_refln.pdbx_HL_B_iso',
     +  '_refln.pdbx_HL_C_iso',
     +  '_refln.pdbx_HL_D_iso',
     +  '_refln.pdbx_F_plus',
     +  '_refln.pdbx_F_plus_sigma',
     +  '_refln.pdbx_F_minus',
     +  '_refln.pdbx_F_minus_sigma',
     +  '_refln.pdbx_anom_difference',
     +  '_refln.pdbx_anom_difference_sigma',
     +  '_refln.pdbx_I_plus ',
     +  '_refln.pdbx_I_plus_sigma ',
     +  '_refln.pdbx_I_minus ',
     +  '_refln.pdbx_I_minus_sigma '/

c ___ KEEP THESE TWO DATA STATEMENTS CONSISTENT!!!
      data cifrfmt / '(1x,f8.1)','(1x,f6.1)','(1x,f8.1)','(1x,f7.1)', 
     +  '(1x,f5.2)','(1x,f13.4)','(1x,f13.4)','(1x,f8.2)','(1x,f8.2)',
     +  '(1x,f7.1)','(1x,f7.2)','(1x,f7.2)','(1x,f7.2)','(1x,f7.2)',
     +  '(1x,f8.1)','(1x,f6.1)','(1x,f8.1)','(1x,f6.1)','(1x,f8.1)',
     +  '(1x,f6.1)','(1x,f13.4)','(1x,f13.4)','(1x,f13.4)',
     +  '(1x,f13.4)'/
c ___ Widths of the above format specifiers
      data cifwdth / 9, 7, 9, 8, 6, 14, 14, 9, 9, 8, 8, 8, 8, 8,
     +  9, 7, 9, 7, 9, 7, 14, 14, 14, 14 /
      
C ___ Default columns corresponding to CIF items in cifrnames
C     Can be changed below.
      data m2ciflkup / 4, 5, 8, 9, 14, 27, 28, 33, 34, 13,
     +   29, 30, 31, 32, 23, 24, 25, 26, 16, 17, 19, 20, 21, 22 /
C     
C---- Data Statements
C     
C     Column labels              4       5     6        7
C           LSPRGI/'H','K','L','FP','SIGFP','FPH','SIGFPH',
C             8      9   10     11        12     13    14
C           'FC','PHIC','W','FPART','PHIPART','PHIB','FOM',
C              15   16      17     18  
C           'FREE','DP','SIGDP','ISYM',
C              19   20      21     22  
C            'I(+)', 'SIGI(+)', 'I(-)', 'SIGI(-)'
C              23   24      25     26  
C            'F(+)', 'SIGF(+)', 'F(-)', 'SIGF(-)'
C             27    28      29     30     31   32 
C           ' I',  'SIGI', 'HLA','HLB','HLC','HLD',
C             33              34
C            'FPART_BULK_S','PHIPART_BULK_S',
C             35 ......         45         54
C            'DUM1' .. 'DUM10','IDUM1' .. 'IDUM10'
C
C MAKE SURE THAT NLPRGI=the ACTUAL NUMBER of labels!!!!!
      DATA NLPRGI/54/,
     +     LSPRGI/'H','K','L','FP','SIGFP','FPH','SIGFPH',
     +     'FC','PHIC', 'W','FPART','PHIPART','PHIB','FOM',
     +     'FREE','DP','SIGDP','ISYM',
     &     'I(+)', 'SIGI(+)', 'I(-)', 'SIGI(-)',
     +     'F(+)', 'SIGF(+)', 'F(-)', 'SIGF(-)',
     +     'I',    'SIGI', 'HLA','HLB','HLC','HLD',
     +     'FPART_BULK_S','PHIPART_BULK_S',
     +     'DUM1','DUM2','DUM3','DUM4','DUM5',
     +     'DUM6','DUM7','DUM8','DUM9','DUM10',
     +     'IDUM1','IDUM2','IDUM3','IDUM4','IDUM5',
     +     'IDUM6','IDUM7','IDUM8','IDUM9','IDUM10',446*' '/
      DATA CTPRGI/'H','H','H','F','Q','F','Q',
     +            'F','P','W','F','P','P','W',
     +            'I','D','Q','Y',
     +            'K','M','K','M',
     +            'G','L','G','L',
     +            'J','Q','A','A','A','A',
     +            'F','P',
     +            10*'R',10*'I',446*' '/
      DATA LOOKUP/-1,-1,-1,0,0,495*0/
      DATA SAWOUT /.FALSE./

      data ihmin,ihmax /3*32767, 3*-32767/

C     
      CALL CCPFYP 
      CALL MTZINI
      LANOM = .FALSE.
      Fs_plus_Is = .FALSE.
      SMAX = 0.0
      SMIN = 0.0
      IFLAG=0
      IXPLO=0
      ICNS=0
      IMULT=0
      ISHEL=0
      ISHELD=0
      ICIF=0
      IUSER=0
      NFREE=0
      MAXFMT=80
      ISCAL=0
      ITNT=0
      IMAIN=0
      IFSQ=0
      ISQRT=0
      JANOMF=0
      JANOMP=0
      JANOMI=0
      JBULKSOLVENT = 0
      SIGP=0
      SIGH=0
      FPMAX  = -1.0
      FPHMAX = -1.0
      LSCAL=.FALSE.
      SCAL=1.0
      SCCHK=1.0
      DEL=0
      KINFRE = -1
      NMON=1000
      MTZIN=1
      LUNIN=5
      LUNOUT=6
      NERR = 0
      nobs_fre = 0        
      nobs_wrk = 0 
      nobs_mis = 0
      nobsexcl = 0
      nobs_frei = 0        
      nobs_wrki = 0 
      nobs_misi = 0
      nobsexcli = 0
      ndelexcl  = 0
      NREF = 0
      nrobs = 0
      NRFOUT = 0
      PHIB= 000.0
      FOM=0.0
      INAN = 0
      VAL_MISSING = 0.0
      iscrl=1
      ireso=0
      lincl = .false.
      lanflgp = .false.
      lanflgm = .false.
      num_warnings = 0
C     
      DO 2 I = 1,51
         NSALL(I) = 0
         NSGOOD(I) = 0
         NSGOODI(I) = 0
 2    CONTINUE
C     
      CALL CCPRCS (LUNOUT,'MTZ2VARIOUS', '$Date: 2008/07/15 08:13:34 $')
      IF (CCPONL (1)) THEN
        WRITE(LUNOUT,1234)
 1234   FORMAT(////,
     $     ' KEYWORDS: Output Labin Exclude Exclude Freeval ',
     $     '  Fsquared Monitor Resolution Scale SqRootI Valm END')
        WRITE(6,'(/,a,a)') 
     +      ' OUTPUT [SHELXD | SHELX | XPLOR/CNS | TNT | SCAL |',
     +      ' MAIN | CIF <data block header> | USER <fmt>] '
        WRITE(LUNOUT,'(/,a,a,/,a,a)')
     +     ' The output is an ASCII file  in various formats, ',
     +     ' see documentation',
     +     ' You may need to rescale the data to fit',
     +     ' the SHELX fixed format ( 3I4,2F8.1,I4)'
        WRITE(LUNOUT,'(a)')
     $     ' Output always goes to the assigned HKLOUT file'
        WRITE(6,'(//,a,/,a,/,a,/,a,/,a,/,a,/,a,a)') 
     +  ' LABIN <program label>=<file label> ...',
     +   ' Valid program labels are: FP, SIGFP, FPH, SIGFPH, I, SIGI',
     +  ' FC, PHIC, W, FPART, PHIPART, PHIB, FOM, HLA HLB HLC HLD FREE',
     +  ' and for bulk solvent corrections FPART_BULK_S PHIPART_BULK_S',
     +  ' Also for OUTPUTs with Is or Anom data F(+), SIGF(+), F(-),',
     +  ' SIGF(-) or I(+), SIGI(+), I(-), SIGI(-) are possible',
     +  ' and for OUTPUT USER dummy columns DUM1,',
     +  ' DUM2 ... DUM10 and IDUM1 ... IDUM10'
C
        WRITE(6,'(//,a,a,/,a)') ' EXCLUDE [SIGP sigcut] [SIGH sigcut]',
     $     ' [FPMAX fpmax] [FPHMAX fphmax]  [DIFF del] [FREER freeR]',
     $     ' Various rejection criteria like FFT.'
        WRITE(6,'(//,a,a,/,a)') ' INCLUDE [FREER freeR]'
      WRITE(LUNOUT,'(//,a,/,a,a)')
     $     ' FREEVAL  nfree',' Reflections flagged with FREE=Nfree are',
     $     ' labelled as the FreeR set. '
        WRITE(LUNOUT,'(//,a,/,a)')
     $     ' FSQUARED: Input F SIGF - Output I SIGI',
     $     ' I is set = F*F, SIGI = 2*SIGF*F + SIGF*SIGF'
        WRITE(LUNOUT,'(//,a,/,a)')
     1     ' MONITOR nmon',' Every nmon-th reflection monitored '
        WRITE(LUNOUT,'(//,a)')
     $     ' RESOLUTION: followed by Resmin RESMAX (As or s)'
      WRITE(LUNOUT,'(//,a,/,a)')
     $     ' SCALE scal',
     $     ' Applied to some output terms like structure factors.'
        WRITE(LUNOUT,'(//,a,/,a)')
     $     ' SqRootI: Input I SIGI - Output F SIGF',
     $     ' F is set = Sqrt(I) for I >=0; 0.0 if I < 0.0', 
     $     ' SIGI = SIGI/2*F'
      WRITE(LUNOUT,'(//,a,/,a,a,/,a,a)')
     +     ' ValM num',' Data flagged as missing will have values set',
     +     ' to <num> (default 0.0).',' If omitted then reflection',
     +     ' will be omitted if any data is flagged as missing.'
      ENDIF
C     
C     Read control data
C     
 1    CONTINUE
      NTOK=NPARM
      LINE=' '
      LPRINT = .TRUE.
      CALL PARSER (KEY,LINE,IBEG,IEND,ITYPE,FVALUE,CVALUE,IDEC,NTOK,
     +     LEND,LPRINT)
C     
      IF (LEND) GO TO 10
C     
C----- Output option 'OUTPUT'
C      ======================
      IF (KEY.EQ.'OUTP') THEN
         KEY = CVALUE(2)
         WORD = LINE(IBEG(2):IEND(2))//' '
C     
C             ***********
         CALL CCPUPC(KEY)
         CALL CCPUPC(WORD)
C             ***********
C     
C   Key word SHELX sets ISHEL = 1; if there is a iso diff requested ( FP & FPH assigned)
C   then ISHELD will be set to 1 later
C
C   Key word SHELXD used to flag anomalous differences; 
C    these can either be asigned by FP=F(+) FPH=F(-) or DP set
C    sets ISHELD = -1
         IF (WORD(1:6).EQ.'SHELX ') THEN
           ISHEL = 1
         ELSEIF (WORD(1:6).EQ.'SHELXD') THEN
            ISHELD = -1
         ELSEIF (KEY.EQ.'MULT') THEN
            IMULT = 1
         ELSEIF (KEY.EQ.'XPLO') THEN
            IXPLO = 1
         ELSEIF (KEY(1:3).EQ.'CNS') THEN
            ICNS = 1
         ELSEIF (KEY.EQ.'USER') THEN
          IF(NTOK.LE.2)THEN
            WRITE(6,'('' USER must have a format string ****!!'')')
            NERR=1
          ELSE
            IF(IEND(NTOK)-IBEG(3).GT.MAXFMT)THEN
             WRITE(6,'('' format string too long ****!!'')')
             NERR=1
            ENDIF
            FMT = LINE(IBEG(3):IEND(NTOK))
            IUSER=1
          ENDIF

         ELSEIF (KEY.EQ.'SCAL') THEN
            ISCAL = 1
         ELSEIF (KEY.EQ.'TNT') THEN
            ITNT = 1
         ELSEIF (KEY.EQ.'MAIN') THEN
            IMAIN = 1
         ELSEIF(KEY(:3).EQ.'CIF') THEN
           
           IF (NTOK.LE.2) THEN
             WRITE(6,'(a)') 
     &       ' CIF output requires data block header "data_..." ****!!'
             NERR=1
           ELSE
             DBHEAD = line(ibeg(3):iend(3))
             ldbhead = iend(3)-ibeg(3) + 1
             IF ( IEND(3) - IBEG(3) .GT. 4 )
     &         CALL CCPLWC(DBHEAD(:4))
             
             IF ( ( IEND(3) - IBEG(3) .LE. 4) .OR.
     &         (DBHEAD(:5) .NE. 'data_') ) THEN
                WRITE(6,'(1X,A,A)') DBHEAD(:ldbhead),
     &            ' is not a valid data block header ****!!'
                NERR=1
             ELSE
                ICIF=1
             ENDIF
           ENDIF

         ELSE
           WRITE(6,'(a)') 
     &   ' Unknown OUTPUT type - check spelling!'
           NERR=1

         ENDIF
           

         SAWOUT = .TRUE.
c     
         GO TO 1
C     
C---- "LABIN"     i.e. set input labels
C     
      ELSE IF (KEY.EQ.'LABI') THEN
C     
C             *********************************************
         CALL LKYIN(MTZIN,LSPRGI,NLPRGI,NTOK,LINE,IBEG,IEND)
C             *********************************************
         IF(NTOK.EQ.1) THEN
           NERR=1
           CALL CCPERR(2, ' No items given on LABIN line')
         END IF
C
         LINESAV = LINE
         GO TO 1
         
C---- Exclude reflections "EXCLUDE"
C     =============================
C     
C     Subsiduary key words SIGP sigp  SIGH sigh DIFF diff
C                          FPMAX fpmax  FPHMAX fphmax
C                          FREER kinfre  default 0
C     
      ELSE IF (KEY.EQ.'EXCL') THEN
C     
         NSTART = 2
         NCHK = MOD(NTOK,2)
C     
C        IF (NCHK.NE.1) CALL CCPERR(1, '** Error on EXCLUDE card **')
C     
         DO 120 ITOK = NSTART,NTOK,2
            KEY = CVALUE(ITOK)
C     
C                ***********
            CALL CCPUPC(KEY)
C                ***********
C     
            IF (KEY.EQ.'SIGP') SIGP = FVALUE(ITOK+1)
            IF (KEY.EQ.'SIGH') SIGH = FVALUE(ITOK+1)
            IF (KEY.EQ.'DIFF') DEL = FVALUE(ITOK+1)
            IF (KEY.EQ.'FPMA') FPMAX = FVALUE(ITOK+1)
            IF (KEY.EQ.'FPHM') FPHMAX = FVALUE(ITOK+1)
            IF (key.eq.'FREE') then
C Assume KINFRE = 0
               KINFRE = 0
               IF(ITOK.LT.NTOK)
     +         CALL GTPINT(ITOK+1,KINFRE,NTOK,ITYPE,FVALUE)
              IF (KINFRE .GT. -1) WRITE(LUNOUT,'(4X,A,I4,A)')
     +         '   FreeR set flagged with ',KINFRE,' rejected'
            ENDIF

 120     CONTINUE
         WRITE(LUNOUT,'(/,A,3(/,4x,A,f6.1,A))')
     +        '   Exclude reflections if:',
     +     '   FP less than ',SIGP,' SIGFP',
     +        '   FPH less than ',SIGH,' SIGFPH',
     +        '   Difference greater than',DEL
         IF (FPMAX .GT. 0.0) WRITE(LUNOUT,'(4x,A,f8.0)')
     +        '   FP  greater than ',FPMAX
         IF (FPHMAX .GT. 0.0) WRITE(LUNOUT,'(4x,A,f8.0)')
     +        '   FPH greater than ',FPHMAX
         GO TO 1
C     
C     
      ELSE IF (KEY.EQ.'INCL') THEN
C---- Inlcude only reflections INCLUDE
c   Subkey FREER kinfre         
C     
         NSTART = 2
         NCHK = MOD(NTOK,2)
C     
C         IF (NCHK.NE.1) CALL CCPERR(1, '** Error on INCLUDE card **')
C     
         DO 110 ITOK = NSTART,NTOK,2
            KEY = CVALUE(ITOK)
C     
C                ***********
            CALL CCPUPC(KEY)
C                ***********
C     
            IF (key.eq.'FREE') then
C Assume KINFRE = 0
               KINFRE = 0
               IF(ITOK.LT.NTOK)
     +         CALL GTPINT(ITOK+1,KINFRE,NTOK,ITYPE,FVALUE)
               lincl = .true.
            ENDIF

 110     CONTINUE

         IF (KINFRE .GT. -1) then
            WRITE(LUNOUT,'(/,A)')
     +         '   Include reflections if:'
            WRITE(LUNOUT,'(4X,A,I4)')
     +         '   Free-R flag equals ',KINFRE
         else
            CALL CCPERR(1, '** Error on INCLUDE card **')
         endif 
         GO TO 1
c     
C---- Free R value
C     
      ELSE IF (KEY.EQ.'FREE') THEN
         CALL GTPINT (2,NFREE,NTOK,ITYPE,FVALUE)
         WRITE (LUNOUT,'(/,A,I8,/)')
     +        ' Reflections treated as "free" if FreeRflag = ',NFREE
         GO TO 1
C     
C---- Set Fsquared flag - useful for SHELX.
C     =============================
C     
C     
      ELSE IF (KEY.EQ.'FSQU') THEN
C     
         IFSQ=1
         WRITE(LUNOUT,'(/,A,A)')
     +   '   Fs are squared on output - better to use ',
     +   'original Is from TRUNCATE output'
        cifrnames(6) =   '_refln.F_squared_meas'
        cifrnames(7) =   '_refln.F_squared_sigma'
         GO TO 1

C     
C---- MONITOR information
C     
      ELSE IF (KEY.EQ.'MONI') THEN
         CALL GTPINT (2,NMON,NTOK,ITYPE,FVALUE)
         WRITE (LUNOUT,'(/,A,I8,a,/)')
     +        ' Every ',nmon,' th reflection listed '
         GO TO 1
C     
      ELSE IF (KEY.EQ.'RESO') THEN
         ITOK = 2
C     
C             *****************************************************
         CALL RDRESO(ITOK,ITYPE,FVALUE,NTOK,RESMIN,RESMAX,SMIN,SMAX)
C             *****************************************************
C     
         srang=(smax-smin)
         step = srang/50.
c ___  CIF output needs to know if this keyword has been specified
         ireso=1
         GO TO 1
C     
C---- Set SCALE - useful for SHELX.
C     =============================
C     
C     
      ELSE IF (KEY.EQ.'SCAL') THEN
C     
         CALL GTPREA (2,SCAL,NTOK,ITYPE,FVALUE)
         WRITE (LUNOUT,'(/,A,F8.2,a,/)')
     +        ' Output F and SIGF (or I and SIGI) scaled by ',SCAL
         LSCAL=.TRUE.
         GO TO 1
C     
C     
C---- Set SqRootI flag - useful for SHELX output.
C     =============================
C     
C     
      ELSE IF (KEY.EQ.'SQRO') THEN
C     
         ISQRT=1
         WRITE(LUNOUT,'(/,3A)')
     + '   Is are square rooted on output - ',
     + ' better to use TRUNCATE output and reset your Fs'
         GO TO 1

C
C---- VALMissing Include reflections with MNFs in record.
C          If argument given, use to represent MNF (default 0.0).
C     =============================
C
      ELSE IF (KEY.EQ.'VALM' .OR.KEY.EQ.'MISS') THEN
         INAN = 1
         IF (NTOK.GE.2) 
     +     CALL GTPREA (2,VAL_MISSING,NTOK,ITYPE,FVALUE)
         WRITE(LUNOUT,'(/,A,F9.3,/)') 
     +  ' *** Reflections including MNFs output using ',VAL_MISSING
         GOTO 1
C---- end of input check for errors
C     
      ELSE IF (KEY.EQ.'END ') THEN
         GO TO 10
         
      ELSE
         WRITE (LUNOUT,'(/,A,3X,A,/)')' Unrecognized keyword :',KEY
         NERR=NERR+1
      ENDIF
      GO TO 1
C     
 10   CONTINUE

      IF (NERR.GT.0) THEN
        WRITE (LUNOUT,9901) NERR
 9901   FORMAT (/,1X,I6,' Errors in input, see above !!!!'/)
        CALL CCPERR(1,' Error in Keyword')
      ENDIF
      IF (.NOT.SAWOUT) CALL CCPERR (1, 'No valid OUTPUT specifed')

C     
C     Open output ASCII file
C     
C      IUN21=21
      IUN22=22
      ifail=0
c Check for later on - SHELXD sHELX and TNT can only output one item
      imst = imult+ishel+abs(isheld)+iscal+itnt
C      CALL CCPDPN(IUN21,'INSOUT','NEW','F',LL,IFAIL)
      CALL CCPDPN(IUN22,'HKLOUT','NEW','F',LL,IFAIL)
C
C Put this information in a summary
C
      call ccp4h_summary_beg()
c
      IF(IUSER.EQ.1)WRITE(6,'(a,//,2a,/,a,/,a,a80)')
     1     ' USER format output to ASCII file. ',
     1     ' *** Better to use mtzutils, and mtzdump with a ',
     1      'defined format. See documentation!***',
     1     ' The format is ',fmt

      IF(imult.eq.1)write(6,'(a,/,a,/,a)') 
     1     ' MULTAN output to ASCII file assigned to HKLOUT',
     1     ' File has h k l "f"  "imt"  where "imt" = 0 ',
     1     ' - format is (3i4,7x,f7.0,i6) '
      
      IF(ishel.eq.1.or. isheld.ne.0)
     +     write(6,'(a,/,a,a,/,a)') 
     1     ' SHELX output to ASCII file assigned to HKLOUT ',
     1     ' File has h k l  "I sigmaI"  or "F sigmaF" "ishelx-free" ',
     1     'where "ishelx-free"= 1 or -1 ',
     1 ' - format(3i4,2f8.2,i4)'
      IF((ishel.eq.1 .or. isheld.ne.0) .and. IFSQ.NE.0)
     +   write(6,'(a,/,a)')
     + ' **** NB Intensities output, made by squaring input F. ***',
     + ' ****    Better to use original intensities. ***'
c     
      IF(ishel.ne.0.or.isheld.ne.0)write(6,'(/,2a,/,a,/,a,/,a,/,a)') 
     1     ' If you are taking a difference (FPH-FP) or (F(+) - F(-))',
     +     ' or using DANO',
     +     ' then the SHELX output to file assigned to HKLOUT ',
     1     ' File has h k l  Diso SIGDiso or Dano SIGDano plus PHID  ',
     1 ' - format(3i4,2f8.2,i4)',
     1 ' where phiD = 90 or 270 for Dano > 0 or < 0 if D is anomalous',
     1 '       phiD =  0 or 180 for Diso > 0 or < 0 if D is isomorphous'
c     
      IF(iscal.eq.1)write(6,'(a,/,a)') 
     1     ' Pseudo-SCALEPACK output used for SOLVE/SHELX package:',
     +     ' An ASCII file assigned to HKLOUT - format(3i4,4F8.1) ',
     =     ' with  h k l I(+) SIGI(+) I(-) SIGI(-)',
     +     ' Output may need to be rescaled to fit the format.'
c     
      IF(ixplo.eq.1 .or. icns.eq.1 )write(6,'(a,/,a)') 
     1     ' XPLOR/CNS output to ASCII file assigned to HKLOUT ',
     1     ' - format(A,3i5,A,f10.1,f10.1,A,f10.2,A,i6)'
      IF (ITNT.EQ.1) WRITE(6,'(A,/,A,A,a,a,/,a)') 
     +     ' TNT output to ASCII file assigned to HKLOUT ',
     +     ' HKL h k l F sigma(F) [Phase] [Fom]  in',
     +     ' format(A4,3I4,3F8.1,F8.4)',
     1 '  If there is a FREE flag set those reflections will also have',
     1 '  the word FREE at the end of the line;',
     1 ' this allows them to be "grepped" out of the file easily.'
      IF (IMAIN.EQ.1) WRITE(6,'(A,/,A,A,/,A,A)') 
     +     ' MAIN output to ASCII file assigned to HKLOUT ',
     +     ' IND <h k l> FOB <F> SIG <sig(F)> in',
     +     ' format(A3,3I4,A4,F9.2,A4,F8.3)',
     +     ' IND <h k l> FOB <F> SIG <sig(F)> PHA <Phase> WE <Fom> in',
     +     ' format(A3,3I4,A4,F8.2,A4,F8.2,A4,F7.1,A3,F7.3)'
      IF (ICIF.EQ.1) 
     &    write (6,'(a,/,a,a)')
     &    ' CIF output to ASCII file assigned to HKLOUT',
     &    ' Data block header is: ',dbhead(:ldbhead)
C
C Close summary
C
      call ccp4h_summary_end()
c
      if ( ixplo.eq.1 .or. icns.eq.1 ) then
        iun23=23
        call ccpdpn(iun23, 'MTZ2VSCR', 'SCRATCH', 'F', 80, 0)
      endif
      if ( icif.eq.1 ) then
        iun23=23
        call ccpdpn(iun23, 'MTZ2VSCR', 'SCRATCH', 'DF', 80, 0)
      endif
      
        

C
      MTZIN = 1
      IFAIL = 0
C          **********************************
       CALL LROPEN(MTZIN,'HKLIN',1,IFAIL)
C          **********************************
C     
      IF (IFAIL.EQ.1) CALL CCPERR(1,' No input file???????')
C     
C
        CALL LRCELL(MTZIN,CELL)
C Get symmetry for centric/systematically absent tests and symm. operators.
c Need this for some outputs
        CALL LRSYMM(MTZIN, NSYM, RSYM)
C
        CALL SYMTR3(NSYM,RSYM,SYMCHS,0)
        CALL CENTRIC(NSYM, RSYM, 0)
        call lrsymi(mtzin,nsympx,ltypex,nspgrx,spgrnx,pgnamx)
        call epsln(nsym,nsympx,rsym,0)
C     
      IF(SMAX.LE.0.001) THEN
         CALL LRRSOL(MTZIN,SMIN,SMAX)
         SRANG=(SMAX-smin)
         step = srang/50
      END IF
C
C   Write some SCALEPACK stuff
       if (ISCAL.GT.0 ) THEN
C    1
C -987
C    22.636    26.022    70.104    90.000    90.000    90.000 i222            
          int1 = 1
          int987 = -987
          call ccplwc(spgrnx)          
          WRITE(iun22,'(I5,/,I5,/,6F10.3,1X,A)')int1,int987,CELL,spgrnx
       end if
C
c
C  Get ranges to check FreeR flag later
        CALL LRINFO(MTZIN,VERSNX,NCOLX,NREFLX,RANGES)
C
C          *****************************************
      CALL LRASSN(MTZIN,LSPRGI,NLPRGI,LOOKUP,CTPRGI)
      CALL LRCLAB(MTZIN,LSUSRI,CTUSRI,NCOLX)
C          *****************************************

C  Get dataset info
C     Notify available space
      NDATASETS = MSETS
      CALL LRIDX(MTZIN,PNAME,XNAME,DNAME,ISETS,
     +              DATCELL,DATWAVE,NDATASETS)
      NWAVE = 0
      DO IWAVE=1,MSETS
        WAVELENGTH(IWAVE) = 0.0
      ENDDO
      IF (NDATASETS.GT.0) THEN
        CALL LRCLID(MTZIN,CSETID,NCOLX)
C  Get dataset for FP
        if (lookup(4) .gt. 0) then
         ISETW = CSETID(LOOKUP(4))
         DO ISET = 1,NDATASETS
          IF (ISETS(ISET).EQ.ISETW) THEN
            WAVELENGTH(1) = DATWAVE(ISET)
            DO I = 1,6
              CELL(I) = DATCELL(I,ISET)
            END DO
          END IF
         ENDDO
        endif
        IF (WAVELENGTH(1).GT.0.0) NWAVE = 1
CMDW This is currently restricted to a single wavelength, but is
CMDW ready to be extended to more i.e. for MAD
CMDW If fill up WAVELENGTH array, DIFFRN_RADIATION_WAVELENGTH category
CMDW will be expanded automatically. Need to change REFLN loop below.
      ENDIF
C
C Now need to check for compatible label assignment
C
C    Can accept the following groupings:
C
C    FP SIGFP & FHP SIGFPH ; 
C           output  h k l DelF SIGDelF ( or SQUARED..)
C
C    DP SIGDP ; 
C           output  h k l DP SIGDP ( or SQUARED..)
C
C    FP SIGFP alone: 
C           output h k l F SIGF ( or h k l I SIGI if FSQUARED flag set)
C
C
C    FP SIGFP & DP SIGDP ;           ( flagged janomp=1)
C or F(+) SIGF(+) & F(-) SIGF(-) ;  ( or FP SIGFP &  F(-) SIGF(-) )( flagged janomf=1)
C or I(+) SIGI(+) & I(-) SIGI(-) ;           ( flagged janomi=1)
C
C  Cant have all these set for all outputs.  All set LANOM flag.
C           output  h k l F(+) SIGF(+) and -h -k -l F(-) SIGF(-)
C
C   Check FreeR flags first - easiest!
C
      IF(LOOKUP(15).GT.0) THEN
        IF (RANGES(2,LOOKUP(15)).LT.NFREE) CALL CCPERR(1,
     +  ' *** Requested FreeRflag value greater than any in file! ***')
        IF (KINFRE .GE. 0) THEN
           IF( RANGES(2,LOOKUP(15)).LT.KINFRE) CALL CCPERR(1,
     +      ' *** Requested KINFRE value greater than any in file! ***')
            IF(KINFRE .NE. NFREE) THEN
            WRITE(6,'(A,A)')
     +      ' ** You seem confused: ',
     +      ' FREE flag on INCLUDE line differs from FREE flag***'
            CALL CCPERR(1, ' Free R flag confusion')
            ENDIF
c
           if (lincl) then
              WRITE (6,'(/,a,I4,a,/)')
     +           ' Only reflections with FREERFLAG = ',KINFRE,
     +           ' will be included in output file'
           else
              WRITE (6,'(/,a,I4,a,/)')
     +           ' Reflections with FREERFLAG = ',KINFRE,
     +           ' will be omitted from output file'
           endif
        ENDIF
      ELSE
         KINFRE = -1
      ENDIF
C
c
c---- bulk solvent o//p
c
      JBULKSOLVENT = 0
      IF (LOOKUP(33).gt.0) JBULKSOLVENT=1
c
c
C   Are you inputting Fs for SCALEPACK? Prepare to SQUARE
      IF((LOOKUP(4).GT.0 .OR. LOOKUP(23).GT.0 .OR. LOOKUP(25).GT.0
     +  .OR. LOOKUP(16).GT.0 ).AND. (ISCAL.EQ.1))  IFSQ = 1
C
CMDW  If SHELX output, and SCALE keyword not set, determine scale
CMDW  factor so that no format overflow
      IF (.NOT.LSCAL .AND. (ISHEL.EQ.1.or.isheld.ne.0)) THEN

C   Shelx format F8.2; largest I <= 99999.99
C input FP
         IF(LOOKUP(4).GT.0 .AND. IFSQ.NE.0)
     +   SCCHK = 99999.00/(RANGES(2,LOOKUP(4))* RANGES(2,LOOKUP(4)))
C input DP
         IF(LOOKUP(4).EQ.0.AND.LOOKUP(16).GT.0 .AND. IFSQ.NE.0)
     +   SCCHK = 99999.00/(RANGES(2,LOOKUP(16))* RANGES(2,LOOKUP(16)))
C input FP(+)
         IF(LOOKUP(23).GT.0 .AND. IFSQ.NE.0)
     +   SCCHK = 99999.00/(RANGES(2,LOOKUP(23))* RANGES(2,LOOKUP(23)))
C input I
         IF(LOOKUP(27).GT.0)
     +   SCCHK = 99999.00/(RANGES(2,LOOKUP(27)))
C input I(+)
         IF(LOOKUP(19).GT.0)
     +   SCCHK = 99999.00/(RANGES(2,LOOKUP(19)))
C
C SCCHK is initialised to 1.0 and we are only here if SCALe keyword not set
         SCAL = SCCHK

         IF (IFSQ.NE.0) THEN
           WRITE(6,'(/,a,/,a,F8.4,/)') 
     +   ' *** You are inputting Fs  and requesting Is to be output.',
     +   ' *** The Fs will be squared and scaled by:',SCAL
         ELSE
           WRITE(6,'(/,a,F8.4,/)') 
     +   ' *** The output will be scaled by:',SCAL
         ENDIF

      END IF
C
C   Are you inputting both Is and Fs?
      IF((LOOKUP(4).GT.0 .OR. LOOKUP(23).GT.0 .OR. LOOKUP(25).GT.0).AND.
     +   (LOOKUP(19).GT.0 .OR. LOOKUP(21).GT.0) ) THEN
              Fs_plus_Is = .TRUE.
              CALL CCPERR(3,
     +   ' *** You are inputting Fs  and Is - do you mean to? **')
      ENDIF
         IF(Fs_plus_Is.AND.(ITNT.EQ.1 .OR. IMULT.EQ.1 
     +                .OR. ISHEL.EQ.1 ))
     +                 CALL CCPERR(1,
     +   ' *** This is incompatible with OUTPUT option***')
C
C---- For the USER keyword determine order and variable type (REAL, INT)
C
      IF (IUSER .EQ. 1) THEN
C
        NTOK=NPARM
C            *******************************************************
        CALL PARSER (KEY,LINESAV,IBEG,IEND,ITYPE,FVALUE,CVALUE,IDEC,
     +       NTOK,LEND,LPRINT)
C            *******************************************************
C
        ISUB = 0
        II = 1
        DO 290 JDO290 = 1,21
          IRNG(JDO290) = 0
  290   CONTINUE
        DO 320 I=2,NTOK,2
C
C---- Check LHS for LABIN assignment
C
          DO 300 JDO300=1,NLPRGI
            IF (LOOKUP(JDO300).NE.0) THEN
              IF (LINESAV(IBEG(I):IEND(I)) .EQ. LSPRGI(JDO300)) THEN
                IF (JDO300 .LE. 3) THEN
                  IF (LINESAV(IBEG(I+1):IEND(I+1)).EQ.'H' .OR.
     .                LINESAV(IBEG(I+1):IEND(I+1)).EQ.'K' .OR.
     .                LINESAV(IBEG(I+1):IEND(I+1)).EQ.'L') THEN
                    ISUB=ISUB+1
                    GOTO 320
                  ENDIF
                ENDIF
                IOUT = I/2 - ISUB
                COLOUT(IOUT) = JDO300
                GOTO 325
              ENDIF
            ENDIF
 300      CONTINUE
C
C---- Check RHS of LABIN assignment.
C
          DO 310 JDO310=1,NLPRGI
            IF (LOOKUP(JDO310).NE.0) THEN
              IF (LINESAV(IBEG(I+1):IEND(I+1)) .EQ. LSPRGI(JDO310)) THEN
                IOUT = I/2 - ISUB
                COLOUT(IOUT) = JDO310
                GOTO 325
              ENDIF
            ENDIF
 310      CONTINUE
C
C If more labels are added then check that COLOUT(IOUT).GE.<N>
C where <N> is position of IDUM1 label in list of labels.
C
 325      IF (MOD(II,2) .EQ. 1) THEN
            IF (COLOUT(IOUT).GE.45) THEN
              IRNG(II) = IRNG(II) + 1
            ELSE
              II = II + 1
              IRNG(II) = IOUT
            ENDIF
          ELSE
C
C If more labels are added then check that COLOUT(IOUT).LT.<N>
C where <N> is position of IDUM1 label in list of labels.
C
            IF (COLOUT(IOUT).LT.45) THEN
              IRNG(II) = IRNG(II) + 1
            ELSE
              II = II + 1
              IRNG(II) = IOUT
            ENDIF
          ENDIF
 320    CONTINUE
         write(6,*)'irng',irng
        IOUT = NTOK/2 - ISUB
      ENDIF
C
C
C     Column labels              4       5     6        7
C           LSPRGI/'H','K','L','FP','SIGFP','FPH','SIGFPH',
C             8      9   10     11        12     13    14
C           'FC','PHIC','W','FPART','PHIPART','PHIB','FOM',
C              15   16      17     18  
C           'FREE','DP','SIGDP','ISYM',
C              19   20      21     22  
C            'I(+)', 'SIGI(+)', 'I(-)', 'SIGI(-)'
C              23   24      25     26  
C            'F(+)', 'SIGF(+)', 'F(-)', 'SIGF(-)'
C             27    28      29     30     31   32 
C           ' I',  'SIGIP', 'HLA','HLB','HLC','HLD',
C             33            34
C            'FPART_BULK_S','PHIPART_BULK_S',
C             35 ......         45         54
C            'DUM1' .. 'DUM10','IDUM1' .. 'IDUM10'
C
      IF (IUSER.NE.1) THEN
C  Check SIGs are assigned
        IF(LOOKUP(4).NE.0 .AND. LOOKUP(5).EQ.0) THEN
          IF (ICIF.EQ.1) THEN
            CALL CCPERR(2,
     +       ' *** FP but not SIGFP set; wrong unless EM data *** ')
          ELSEIF (IMAIN.EQ.1) THEN
            CALL CCPERR(2,
     + ' ** FP but not SIGFP set; wrong unless outputting COMPLEX ** ')
          ELSE
            CALL CCPERR(1,' *** FP set; SIGFP must be assigned ***')
          ENDIF
        ENDIF
        IF(SIGP.GT.0.0001 .AND. LOOKUP(5).EQ.0) SIGP = 0.0
C
        IF(LOOKUP(6).NE.0 .AND. LOOKUP(7).EQ.0)
     +       CALL CCPERR(1,' *** FPH set; SIGFPH must be assigned ***')
        IF(LOOKUP(6).NE.0 .AND. LOOKUP(4).EQ.0)
     +       CALL CCPERR(1,' *** FPH set; FP must be assigned ***')
        IF(SIGH.GT.0.0001 .AND. LOOKUP(7).EQ.0) SIGH = 0.0
C
        IF(LOOKUP(8).NE.0 .AND. LOOKUP(9).EQ.0 .AND. IMAIN.EQ.0)
     +       CALL CCPERR(1,' *** FC set; PHIC must be assigned ***')
        IF(LOOKUP(11).NE.0 .AND. LOOKUP(12).EQ.0) CALL CCPERR
     +       (1,' *** FCpart set; PHIPART must be assigned ***')
        IF(LOOKUP(16).NE.0 .AND. LOOKUP(17).EQ.0)
     +       CALL CCPERR(1,' *** DP set; SIGDP must be assigned ***')
        IF(LOOKUP(19).NE.0 .AND. lookup(20).EQ.0) CALL CCPERR
     +       (1,' *** I(+) set; SIGI(+) must be assigned ***')
        IF(lookup(21).NE.0 .AND. lookup(22).EQ.0) CALL CCPERR
     +       (1,' *** I(-) set; SIGI(-) must be assigned ***')
        IF(lookup(23).NE.0 .AND. lookup(24).EQ.0) CALL CCPERR
     +       (1,' *** F(+) set; SIGF(+) must be assigned ***')
        IF(lookup(25).NE.0 .AND. lookup(26).EQ.0) CALL CCPERR
     +       (1,' *** F(-) set; SIGF(-) must be assigned ***')
        IF(lookup(27).NE.0 .AND. lookup(28).EQ.0) CALL CCPERR
     +       (1,' *** I set; SIGI must be assigned ***')
C  Check isomorphous difference output to SHELX.hkl for SHELXE isheld=1
        IF((LOOKUP(4).NE.0 .AND.LOOKUP(6).NE.0)
     +  .AND. ishel.ne.0.)then
        ishel = 0
        isheld = 1
          write(6,'(//,2a)') 
     + ' The differences output to SHELX.hkl have a phase estimate',
     +  ' needed for SHELXE'
        end IF
        IF((LOOKUP(4).NE.0 .AND.LOOKUP(6).EQ.0) 
     +  .AND. isheld.ne.0 )then
           CALL CCPERR(2,
     + ' The SHELX.hkl has no difference terms - no use for SHELXE')
         isheld = 0
         ishel = 1
        end if
C
C  DP set without FP - want anom diff output
        IF(LOOKUP(4).EQ.0 .AND. LOOKUP(16).NE.0 .AND. ishel.ne.0)then
         ishel = 0
        isheld = -1
          write(6,'(//,2a)') 
     + ' The anom diffs output to SHELX.hkl have a phase estimate',
     +  ' needed for SHELXE'
        end IF
C
C Is there anomalous data to worry about?
        LANOM = .FALSE.
        janomp = 0
C  FP and DP set
        IF (LOOKUP(4).NE.0  .AND. LOOKUP(16).NE.0) THEN
            LANOM = .TRUE.
            janomp = 1
        END IF
C
C  I(+) and I(-) set
        janomi = 0
        IF (LOOKUP(19).NE.0 ) THEN
C  Don't allow I and I(+)/I(-) unless outputing CIF
         IF( icif.NE.1) THEN
            IF (lookup(27).NE.0) CALL CCPERR(1,
     +      ' *** You are inputting I(+) AND  I  - incompatible ***')
         END IF
         IF( lookup(21).NE.0) THEN
              LANOM = .TRUE.
              janomi = 1
              IF(IFSQ.EQ.1) CALL CCPERR
     +       (1,' *** You are inputting Is AND squaring them!***')
         ELSE
            write (6, '(/,a,a,a,a)')
     &        ' Need both I(+) and I(-) to write out intensities  ',
     &        ' allowing for anomalous data. ',
     &        ' They are in the TRUNCATE output.'
             call ccperr(3,' *** label I(-) missing ***')
         END IF
c
        ELSE IF (LookUP(27) .ne. 0) THEN
            IF (IFSQ .eq. 1) CALL ccperr(1,
     +      ' *** You are inputting Is AND squaring them!***')
        END IF

C  F(+)  and F(-) set
        janomf = 0
        IF (lookup(23).NE.0 )THEN 
C  Don't allow FP and F(+)/F(-) unless outputing CIF
         IF( icif.NE.1) THEN
            IF( lookup(4).NE.0) CALL CCPERR(1,
     +      ' *** You are inputting F(+) AND  FP  - incompatible ***')
         END IF
         IF( lookup(25).NE.0) THEN
            LANOM = .TRUE.
            janomf = 1
C  Don't allow FP DP and F(+)/F(-) unless outputing CIF
            IF(janomp.EQ.1 .and. icif.NE.1) CALL CCPERR(1,
     +   ' *** You are inputting F(+) F(-) AND  FP DP - too much! ***')
         ELSE
            write (6, '(/,a,a,a,a)')
     &        ' Need both F(+) and F(-) to write out amplitudes  ',
     &        ' allowing for anomalous data. ',
     &        ' They are in the TRUNCATE output.'
             call ccperr(3,' *** Is a Label missing ***')
         END IF
        END IF
C
        IF(ISQRT.EQ.1 .AND.( janomp .EQ.1 .or. janomf .EQ.1)) 
     +      CALL CCPERR(1,
     +      ' *** You are inputting Fs AND square-rooting them!***')

        IF (LANOM .AND. ICIF.EQ.0) WRITE (6, '(/,a,a,/)')
     $          ' Both hkl and -h-k-l reflections will be written ',
     $           'to  Xplor or CIF or SHELX output file.'
      ENDIF

C
C---- FPH cannot be used with CIF and DP cannot be used without FP
C---- F cutoffs do not apply
C
      IF (ICIF .EQ. 1) THEN
        IF (LOOKUP(4).EQ.0 .AND. LOOKUP(8).EQ.0 .AND. LOOKUP(23).EQ.0) 
     +    CALL CCPERR(2,
     +' *** FP or FC or F(+) should be assigned for OUTPUT CIF ***')
        IF (LOOKUP(6).GT.0 .OR. LOOKUP(7).GT.0) 
     +     call ccperr(1,' *** No FPH assignment possible for CIF***')
        fpmax = 0.0
        fphmax = 0.0
        del = 0.0
      ENDIF
C
C
      IF (ITNT .EQ. 1) THEN
C Files for TNT _must_ be sorted h,k,l
         CALL LRSORT(MTZIN, ISORT)
         IF (ISORT(1) .NE. 1 .OR. ISORT(2) .NE. 2 .OR.
     $       ISORT(3) .NE. 3) THEN
            WRITE (6,'(/,A,/)')
     $           ' **** Files for TNT must be sorted on H K L ****'
            CALL CCPERR(1,'*** Unsorted file - SORT HKLIN!***')
         ENDIF
C  No anomalous for TNT
         LANOM = .FALSE.
      ENDIF
C
      IF (IMAIN .EQ. 1) THEN
C  No anomalous for MAIN
         LANOM = .FALSE.
      ENDIF
C     
C
C     Column labels              4       5     6        7
C           LSPRGI/'H','K','L','FP','SIGFP','FPH','SIGFPH',
C             8      9   10     11        12     13    14
C           'FC','PHIC','W','FPART','PHIPART','PHIB','FOM',
C              15   16      17     18  
C           'FREE','DP','SIGDP','ISYM',
C              19   20      21     22  
C            'I(+)', 'SIGI(+)', 'I(-)', 'SIGI(-)'
C              23   24      25     26  
C            'F(+)', 'SIGF(+)', 'F(-)', 'SIGF(-)'
C             27    28      29     30     31   32 
C           ' I',  'SIGIP', 'HLA','HLB','HLC','HLD',
C             33            34
C            'FPART_BULK_S','PHIPART_BULK_S',
C             35 ......         45         54
C            'DUM1' .. 'DUM10','IDUM1' .. 'IDUM10'
C
      IF (IXPLO .EQ. 1 .OR. ICNS.EQ.1) THEN
C Files for CNS or XPLOR need Header - Add this line at end
C         write(iun22,'(A)')'  NREFlection=     xxxxx'
C Sean McSweeney: need header line for CNS/XPLOR with anomalous data
         if (lanom) then
           write(iun23,'(A)') ' ANOMalous=TRUE'
         else
           write(iun23,'(A)') ' ANOMalous=FALSE'
         endif
C 
         if(LOOKUP(4) .gt. 0.or.LOOKUP(23) .gt. 0) then
          write(iun23,'(A)')
     +    ' DECLare NAME=FOBS         DOMAin=RECIprocal   TYPE=COMP END'
          write(iun23,'(A)')
     +    ' DECLare NAME=SIGMA        DOMAin=RECIprocal   TYPE=REAL END'
C
         if(LOOKUP(8) .gt. 0) then
          write(iun23,'(A)')
     +    ' DECLare NAME=FCALC        DOMAin=RECIprocal   TYPE=COMP END'
         end if
C
         if(LOOKUP(14) .gt. 0) then
          write(iun23,'(A)')
     +    ' DECLare NAME=FOM         DOMAin=RECIprocal   TYPE=REAL END'
         end if
C
         if(LOOKUP(15) .gt. 0) then
          write(iun23,'(A)')
     +    ' DECLare NAME=TEST        DOMAin=RECIprocal   TYPE=INTE END'
         end if
C
         if(LOOKUP(29) .gt. 0) then
          write(iun23,'(A)')
     +    ' DECLare NAME=PA          DOMAin=RECIprocal   TYPE=REAL END'
         end if
C
         if(LOOKUP(30) .gt. 0) then
          write(iun23,'(A)')
     +    ' DECLare NAME=PB          DOMAin=RECIprocal   TYPE=REAL END'
         end if
C
         if(LOOKUP(31) .gt. 0) then
          write(iun23,'(A)')
     +    ' DECLare NAME=PC          DOMAin=RECIprocal   TYPE=REAL END'
         end if
C
         if(LOOKUP(32) .gt. 0) then
          write(iun23,'(A)')
     +    ' DECLare NAME=PD          DOMAin=RECIprocal   TYPE=REAL END'
         end if
C   Check all HLA HLB HLC HLD assigned.
         ICHK = LOOKUP(29)*LOOKUP(30)*LOOKUP(31)*LOOKUP(32)
         IF(ICHK.GT.0) WRITE(IUN23,'(6(A,/))')  ' GROUp TYPE=HL',
     +   '         OBJEct=PA',
     +   '         OBJEct=PB',
     +   '         OBJEct=PC',
     +   '         OBJEct=PD',
     +   '     END'
C
       end if
C
      ENDIF

      write(6,'(/,A,/,A,/,A,/)') 
     +   ' ===================================',
     +   '  READING REFLECTIONS FROM MTZ FILE',
     +   ' ==================================='
C     
C==========================================================================
C     Read input reflection file
C     
 410  CONTINUE
      iout2 = 1
      jff = 0
      ff = 0.0
      sigf = 0.0
c
      jffd = 0
      ffd = 0.0
      sigfd = 0.0
c
      jffp = 0
      ffp = 0.0
      sigfp = 0.0
c
      jffm = 0
      ffm = 0.0
      sigfm = 0.0
c
      jfom = 0
c
      jffsq = 0
      ffsq = 0.0
      sigfsq = 0.0
c
      jffsqp = 0
      ffsqp = 0.0
      sigfsqp = 0.0
c
      jffsqm = 0
      ffsqm = 0.0
      sigfsqm = 0.0

c     FIXME 3162 output in scalepack format - if we have
c     reflections not measured, the sigmas should be -ve
c     to indicate this

      if (iscal .gt. 0) then
         sigfsq = -1.0
         sigfsqp = -1.0
         sigfsqm = -1.0
      end if

c
      jfc = 0
      jphic = 0
      jphib = 0

      jff_fpbs =0
      jff_ppbs =0
      fpart_bulk_s = 0.0
      phipart_bulk_s = 0.0
C
      CALL LRREFF(MTZIN,S,ADATA,EOF)
      IF(EOF) GO TO 370
      CALL LRREFM(MTZIN,LOGMSS)
      nref = nref + 1

c     ==== WARN PEDANTIC ==== 
c     FIXME debugging # 3162 but trying to understand the code - GW 
c     Should this statement below not use the remainder operator?

      NCHK=NREF-nmon*(NREF/nmon) 
C
      ns=NINT(S/step)
      ns = max(min(ns, 51), 1)
      nsall(ns)=nsall(ns)+1

C Include or Exclude FreeR reflections?
C
      IF (KINFRE .GE. 0) THEN
         IFREER = 99
         IF(.NOT.LOGMSS(15))IFREER = NINT(ADATA(15) - KINFRE)
c lincl .true. means include only Free reflections
         IF (IFREER .EQ. 0) then
c  This reflection is flagged Free
            if (.not.lincl) GOTO 410
         else
c  This reflection is not flagged Free
            if (lincl) GOTO 410
         endif
      ENDIF
C
C  Set Free flag; useful for grepping lines from file for Shelx or TNT
       KEY = ' '
       IF ( LOOKUP(15) .GT. 0 .AND. .NOT.LOGMSS(15) ) THEN
          IF (ABS(ADATA(15)-NFREE) .LT.0.0001)  KEY = 'FREE'
       ENDIF
c     
C ignore [or flag - CIF] reflections outside the resolution
C limit or with missing F data

      cif_missing = .true.

c     FIXME bug # 3162 - if we are producing scalepack output
c     from intensity data then all reflections will be flagged as 
c     missing - this is not helpful. Therefore, need to check if
c     we are measuring I+ and I-, and outputting scalepack, and 
c     if so, setting this to be False. Hack warning!

      if (lookup(19) .gt. 0 .and. lookup(21) .gt. 0 .and. 
     +     iscal .gt. 0) cif_missing = .false.

      rstat = 'o'
      IF(S.LT.SMIN) then
        if (icif.eq.1) then
          rstat = 'l'
        else
          GO TO 410
        endif
      endif
        
      IF(S.gt.SMAX) then
        if (icif.eq.1) then
          rstat = 'h'
        else
          go to 410
        endif
      endif

      do 413 ii = 1,3
        IN(ii) = nint(adata(ii))
        if ( in(ii).lt.ihmin(ii) ) ihmin(ii) = in(ii)
        if ( in(ii).gt.ihmax(ii) ) ihmax(ii) = in(ii)
413   continue

      if (icif.eq.1) then
        call sysab(in,isysab)
        if (isysab.eq.1) rstat = '-'
      endif

C Centric test
      call centr(in, icen)
      
C  Check for MNFs in reflection. 
C  In general, we convert to VAL_MISSING (if VALM/MISS keyword) or we
C  omit the reflection. Special cases:
C    1. mmCIF - want to output all reflections using '?' as MNF
C       (dealt with later)
C    2. anomalous data - only one of a pair might be missing

      IF (ICIF.EQ.0) THEN
        DO 420 I=1,NLPRGI
          IF (LOOKUP(I).GT.0 .AND.LOGMSS(I)) THEN
            IF (INAN.EQ.0 .AND. .NOT.LANOM) THEN
              GOTO 410
            ELSE
              ADATA(I) = VAL_MISSING
            ENDIF
          ENDIF
 420    CONTINUE        
      ENDIF
C
C  If LOOKUP(6) and (7) are set the program will take FP - FPH differences
C
      IF (LOOKUP(6).GT.0) THEN
        IF (LOGMSS(4) .OR. LOGMSS(5) .OR. LOGMSS(6).OR. LOGMSS(7)) THEN
          GO TO 410
        ELSE
C apply checks on FHP
         if(fpmax .gt. 0.0) then
            if(abs(adata(4)) .gt. fpmax) then
              ndelexcl = ndelexcl + 1
              go to 410
            end if
         endif
         if(fphmax .gt. 0.0) then
            if(abs(adata(6)) .gt. fphmax) then
              ndelexcl = ndelexcl + 1
              go to 410
            end if
         endif
         IF(SIGP.GT.0.0001)THEN
           IF(ABS(ADATA(4)).Le.SIGP*ADATA(5)) then
             ndelexcl = ndelexcl + 1
             goto 410
           END IF
         END IF
         IF(SIGH.GT.0.0001)THEN
           IF(ABS(ADATA(6)).Le.SIGH*ADATA(7)) then
             ndelexcl = ndelexcl + 1
             goto 410
           END IF
         END IF
C  take difference
          jffd=1
c Find phid for shelxd output - either 0 or 180
           iphid = 0
          ffd=ADATA(6)-ADATA(4)
          if(ffd.lt.0.0) then
           iphid = 180
           ffd = -ffd
          end if
C         check if FP and FPH assigned to F+ F-
          IF(DEL.GT.0.0001) THEN
            IF(ABS(FFD).ge.DEL) THEN
              ndelexcl = ndelexcl + 1
              GO TO 410
            END IF
          END IF
          sigfd = ADATA(5)**2 + ADATA(7)**2
          sigfd=sqrt(sigfd)
c allow FSQUA optin for shelx differences specially
           if(ifsq.eq.1) then
              fsq = ffd*ffd
              sdfsq = 2.0*ffd*sigfd + sigfd*sigfd
              ffd = fsq
              sigfd = sdfsq
           end if
c
        ENDIF
c
c      go to write line - nothing else possible.
        go to 460
      END IF
c     
C   DP included - no FP
      if (lookup(4).eq.0 .and. lookup(16).gt.0) then
        IF ((LOGMSS(16) .OR. LOGMSS(17)) .OR. ICEN.EQ.1 ) THEN
          GO TO 410
        ELSE
          jffd=1
C  Fix phid as 90 or 270 for shelxd output ( add 90 later)
          iphid =  0
          if (ADATA(16) .lt.0.0) iphid = 180
          ffd=ABS(ADATA(16))
          sigfd=ADATA(17)
          IF(DEL.GT.0.0001) THEN
            IF(ABS(FFD).ge.DEL)  then
              ndelexcl = ndelexcl + 1
              GO TO 410
            END IF
          END IF
c            write(6,*)' ffd 1',scal,ffd,sigfd
c allow FSQUA optin for shelx differences specially
           if(ifsq.eq.1) then
              fsq = ffd*ffd
              sdfsq = 2.0*ffd*sigfd + sigfd*sigfd
              ffd = fsq
              sigfd = sdfsq
           end if
c           write(6,*)' ffd 2',ffd,sigfd
c      go to write line - nothing else possible.
        END IF
        go to 460
      endif
C  FP or F(+) specified; Set ff and sigf - if LANOM FALSE this is enough
C CIF - only reflections with LOGMSS true are to be used for CIF
C    ADATA(..) all set to VAL_MISSING
        if (lookup(23).ne.0) then
          if (logmss(23) ) then
            if (inan.eq.1) jff=1
           else
            jff=1
            ff=ADATA(23)
            sigf=ADATA(24)
            cif_missing = .false.
          endif
        end if
        if (lookup(4).ne.0) then
          if (logmss(4) ) then
            if (inan.eq.1) jff=1
           else
            jff=1
            ff=ADATA(4)
            sigf=ADATA(5)
            cif_missing = .false.
          endif
        end if 
C   I or I(+) only specified 
        if (lookup(27).gt.0 .or. 
     +      (lookup(19).gt.0 .and. lookup(21).eq.0)) then
            if ((lookup(19).gt.0 .and. logmss(19))
     +          .or. (lookup(27).gt.0 .and. logmss(27))) then
              if (inan.eq.1) jffsq=1
            else
              jffsq=1
              if(lookup(19).gt.0) then
                ffsq=ADATA(19)
                sigfsq=ADATA(20)
              end if
              if(lookup(27).gt.0) then
                ffsq=ADATA(27)
                sigfsq=ADATA(28)
              end if
              cif_missing = .false.
            endif
        endif
c
c  Reset the rstat flag if the reflection appears to be missing
        if (cif_missing) rstat = 'x'
c
        if (lanom) then
C  Defined as FP DP ( and optionally ISYM)
c ISYM flag (from Truncate, if present):-
c     = 0 if both F(+) & F(-) present
c     = 1 if only F(+) (force this for centric reflections)
c     = 2 if only F(-)
C
        if(janomp.eq.1) then

         if (icif.eq.1) then
           if (.not.logmss(16).and..not.logmss(17) ) then
            ffd = adata(16)
            sigffd = adata(17)
            jffd = 1
           endif
         else

          isym = 0
          if (lookup(18) .gt. 0) then
           if (.not.logmss(18) ) then
            isym = nint(adata(18))
           else
            isym = 0
           endif
          endif
c
          danom = 0.0
          sigdanom = 0.0
c
c
           if (.not.logmss(16).and..not.logmss(17) ) then
            danom = 0.5 * adata(16)
            sigdanom = 0.5 * adata(17)
C acentric refln with an anom diff
            if (sigdanom .ne. 0.0 .and. icen.eq.0) then
             if (isym .eq. 0) then
               jffp = 1
               ffp = ff + danom
               sigfp = sqrt(sigf**2 + sigdanom**2)
               jffm = 1
               ffm = ff - danom
               sigfm = sigfp
             endif
c
             if (isym .eq. 1) then
               jffp = 1
               ffp = ff 
               sigfp = sigf
             endif
c
             if (isym .eq. 2) then
               jffm = 1
               ffm = ff 
               sigfm = sigf
             endif
             jff = 0
             ff = 0
             sigf = 0
            endif
           endif
          endif
         endif
        endif
C
C
C  Defined as F(+) F(-)
c
        if(janomf.eq.1 .or.janomi.eq.1 ) then
C  Fs to consider
         if(janomf.eq.1) then
          if(.not.(logmss(23) .or. logmss(24))) then
             if (icif.ne.1) then
                jff = 0
                ff = 0
                sigf = 0
             endif
            jffp = 1
C  If F(+) set this overrides a setting of FP  - used to set ? flags for cif
            ffp = adata(23)
            sigfp = adata(24)
          endif
          if(.not.(logmss(25) .or. logmss(26))) then
            jffm = 1
            ffm = adata(25)
            sigfm = adata(26)
          endif
         end if
C  Is to consider
         if(janomi.eq.1) then
          if(.not.(logmss(19) .or. logmss(20))) then
            if (icif.ne.1) then
               jffsq = 0
               ffsq = 0
               sigfsq = 0
            endif
            jffsqp = 1
            ffsqp = adata(19)
            sigfsqp = adata(20)
          endif
          if(.not.(logmss(21) .or. logmss(22))) then

c     Also need to remove the IMEAN here as well - not just for I+

            if (icif.ne.1) then
               jffsq = 0
               ffsq = 0
               sigfsq = 0
            endif
            jffsqm = 1
            ffsqm = adata(21)
            sigfsqm = adata(22)
          endif
         end if
C  If reflection centric then convert (+)/(-) pair to single reflection.
C  For CIF option we only write one reflection anyway.
          if ( icen.eq.1 .and. icif.eq.0) then
             nnnf = jffp+jffm
             nnnfsq = jffsqp+jffsqm
             if(nnnf.gt.0) then
               jff = 1
               ff = (ffp+ffm)/nnnf
               sigf = sqrt(sigfp**2+sigfm**2)/nnnf
C    only 'missing' if both missing
               logmss(23) = logmss(23) .and. logmss(25)
               logmss(24) = logmss(24) .and. logmss(26)
c
               jffp = 0
               ffp = 0
               sigfp = 0
               jffm = 0
               ffm = 0
               sigfm = 0
             endif
c
             if(nnnfsq.gt.0) then
               jffsq = 1
               ffsq = (ffsqp+ffsqm)/nnnfsq
               sigfsq = sqrt(sigfsqp**2+sigfsqm**2)/nnnfsq
C    only 'missing' if both missing
               logmss(19) = logmss(19) .and. logmss(21)
               logmss(20) = logmss(20) .and. logmss(22)
c
               jffsqp = 0
               ffsqp = 0
               sigfsqp = 0
               jffsqm = 0
               ffsqm = 0
               sigfsqm = 0
             endif
          endif 
c
         endif
c   End of (lanom) section
c
C   Now flags for anom or not: if jff or jffp > 0 write hkl
C                              if jff  > 0        no anom
C                              if jffm > 0        write -h-k-l
2000  format(3i4,2f8.2,i4,2x,a)
 2001 format(3i4,7x,f7.0,i6)

 460    continue
c
c---- bulk solvent
c
      if (JBULKSOLVENT .eq.1) then
        if(lookup(33).gt.0 .and. lookup(34).gt.0) then
          if (.not. logmss(33) .and. (.not. logmss(34))) then
            jff_fpbs=1
            jff_ppbs=1
            fpart_bulk_s= adata(33)
            phipart_bulk_s = adata(34)
          end if
        end if
      end if

C  Square things if necessary now.
c           write(6,'(A,3i4,7F8.1,/,6I4)')
c     + ' ifsq',in,ff,ffd,ffp,ffm,ffsq,ffsqp,ffsqm,
c     + jff,jffp,jffm,jffsq,jffsqp,jffsqm
           if(ifsq.eq.1) then
             jcheck = jff + jffp + jffm
              if(jcheck.gt.0) then
               jcheck1 = jffsq + jffsqp + jffsqm
               if(jcheck1.gt.0) 
     +       call ccperr(1,' Something wrong - squaring squared input')
               if (jff.eq.1) then
                 ffsq  = ff*ff
                 sigfsq=2.0*abs(ff)*sigf + sigf*sigf
                 jff = 0
                 jffsq = 1
             end if 
               if (jffp.eq.1) then
                 ffsqp  = ffp*ffp
                 sigfsqp=2.0*abs(ffp)*sigfp + sigfp*sigfp
                 jffp = 0
                 jffsqp = 1
               end if 
               if (jffm.eq.1) then
                 ffsqm  = ffm*ffm
                 sigfsqm=2.0*abs(ffm)*sigfm + sigfm*sigfm
                 jffm = 0
                 jffsqm = 1
               end if 
              end if
           end if
c
c  scale things..
c     
C   Pick up other possible variables.
C       Rescale to satisfy format - do everything prob quicker than checking!..
        ff = scal*ff
        sigf = scal*sigf
        ffd = scal*ffd
        sigfd = scal*sigfd
        ffp= scal*ffp
        sigfp= scal*sigfp
        ffm= scal*ffm
        sigfm= scal*sigfm
        ffsq = scal*ffsq
        sigfsq = scal*sigfsq
        ffsqp= scal*ffsqp
        sigfsqp= scal*sigfsqp
        ffsqm= scal*ffsqm
        sigfsqm= scal*sigfsqm
C No LOGMSS now - all rejections done earlier..
        if (lookup(8).gt.0) then
          jfc = 1
          fc = adata(8)
        endif
        if (lookup(9).gt.0) then
          jphic = 1
          phic = adata(9)
        endif
        if(lookup(10).gt.0) w = adata(10)
        if(lookup(11).gt.0) fpart = adata(11)
        if(lookup(12).gt.0) phipart = adata(12)
        if(lookup(13).gt.0) then
          jphib = 1
          phib = adata(13)
        endif
        if(lookup(14).gt.0) then
          jfom = 1
          fom = adata(14)
        endif
        if(lookup(15).gt.0) free = adata(15)
        if(lookup(29).gt.0) hla = adata(29)
        if(lookup(30).gt.0) hlb = adata(30)
        if(lookup(31).gt.0) hlc = adata(31)
        if(lookup(32).gt.0) hld = adata(32)
        iout2 = 1
C
 462    continue

c     FIXME bug # 3162 - if user has specified I+ etc. on the command 
c     line but not F's, these values will be empty. This is also true for
c     the statistics which are printed later on -> will have to check 
c     if we are in "I" mode and then use intensities rather than amplitudes
c     for our printing and stat generating needs.

c     check is as follows: print F's if any F was measured, or if no
c     I's were measured. Otherwise print the I's.

       if(nchk.eq.1) then
          if ((jff .gt. 0 .or. jffp .gt. 0 .or. jffm .gt. 0) .or.
     +         .not. (jffsq .gt. 0 .or. jffsqp .gt. 0 .or. 
     +         jffsqm .gt. 0)) then
             write(6,*)in,FF,SIGF,ffp,sigfp,ffm,sigfm
          else
             write(6,*)in,ffsq,sigfsq,ffsqp,sigfsqp,ffsqm,sigfsqm
          end if
       end if

c
       if(nchk.eq.1)
     +   write(6,'(3i4,7i5,a)')in,jff,jffp,jffm,jffd,jffsq,
     + jffsqp,jffsqm,rstat
      line = ' '
      ciflne = ' '
        jcheck = jff+jffp+jffm+jffd+jffsq+jffsqp+jffsqm+jfc
        jcheck1 = jff+jffp+jffd+jffsq+jffsqp
c  0   0   2    0    0    0    0    0    0    0x
c *** No output for this reflection????***   0   0   2
        if(jcheck.le.0 .and. rstat .ne. 'x' .and. iuser.NE.1 .and.
     +       num_warnings.lt.MAX_WARNINGS ) then
          write(6,'(/,A,3i4)')
     +         ' *** No output for this reflection?***',in
          write(6,'(3i4,7i5,a)')in,jff,jffp,jffm,jffd,jffsq,
     +          jffsqp,jffsqm,rstat
          num_warnings = num_warnings + 1
          if (num_warnings.eq.MAX_WARNINGS ) then
            write(6,'(/,A,/)') 
     +        ' ** No more reflection warnings will be issued ... **'
          endif
        endif 
C Only one output item allowed for MULTAN, SHELX or TNT
        if(jcheck1.gt.1 .and. imst.ge.1) then
         write(6,'(3i4,5i5)')in,jff,jffp,jffd,jffsq,jffsqp
         write(6,'(A,A,3i4)')
     +     ' *** Too many output columns requested ',
     +     'for MULTAN, SHELX or TNT**',in
         call ccperr(1,' *** Too many output columns ***')
        endif

c     FIXME check GW 14/JUL/08 should jffsqm be considered here as well?
c     above and below this Q. Below definately - elsewise no I+ missing
c     reflections come out.

C  First output F or F(+) ( or I or I(+))
      if (icif.eq.1 .or. jff.gt.0.or.jffp  .gt.0.or.jfc.gt.0.or.
     +       jffsq.gt.0.or.jffsqp.gt.0.or.jffsqm.gt.0
     +       .or.jffd.gt.0) then
C EJD Check on magnitudes; do we need to do something about Is?
C
        IF(SIGP.GT.0.0001) THEN
          IF(jff.gt.0 .and. ABS(ff).Le.SIGP*sigf) then
            if ( icif.eq.0 ) then
              goto 410
            else
              if ( rstat.eq.'o' ) rstat = '<'
            endif
          endif
          IF(jffp.gt.0 .and. ABS(ffp).Le.SIGP*sigfp) then
            if ( icif.eq.0 ) then
              goto 410
            else
              if ( rstat.eq.'o' ) rstat = '<'
            endif
          endif
        END IF
        if ( key.eq.'FREE' .and. rstat.eq.'o') rstat='f'
c
c  EJD Should handle cif stuff here..
        if (fpmax .gt. 0.0) then
          if(abs(ff) .gt. fpmax) go to 410
          if(abs(ffp) .gt. fpmax) go to 410
        endif
c
cmdw Start to write line for output to HKLOUT 
cmdw Start write indices
        if(imult.gt.0 .or. isheld.ne.0 .or. ishel.gt.0 .or. iscal.gt.0)
     +     write(line(1:12),'(3I4)')in
        if(itnt.gt.0 ) write(line(1:16),'(A,3I4)')'HKL ',in
        if(imain.eq.1) write(line(1:15),'(A,3I4)')'IND',in
        if(icif.eq.1)  write(line(1:17),'(3i5,1x,a1)') in, rstat
cmdw End write indices
c
        if(imult.gt.0 ) then
           if(jff.gt.0)  write(line(20:32),'(f7.0,i6)')ff,imult
           if(jffp.gt.0)  write(line(20:32),'(f7.0,i6)')ffp,imult
           if(jffd.gt.0)  write(line(20:32),'(f7.0,i6)')ffd,imult
           if(jffsq.gt.0)  write(line(20:32),'(f7.0,i6)')ffsq,imult
           if(jffsqp.gt.0)  write(line(20:32),'(f7.0,i6)')ffsqp,imult
        endif
c
        if(isheld.ne.0 ) then
C  Dont need anom diffs for centric reflections
          if(isheld.lt.0 .and.icen .eq.1) go to 410
          if(isheld.lt.0) iphid = iphid + 90
          if(jffd.gt.0) write(line(13:32),'(2f8.1,i4)')ffd,sigfd,iphid
        endif
c
        if(iscal.gt.0 ) then
           if(jff.gt.0)  write(line(13:28),'(2F8.1)')ff,sigf
           if(jffp.gt.0) write(line(13:44),'(4F8.1)')ffp,sigfp,ffm,sigfm
           if(jffsq.gt.0)  write(line(13:28),'(2F8.1)')ffsq,sigfsq
           if(jffsqp.gt.0 .or. jffsqm .gt. 0) 
     +          write(line(13:44),'(4F8.1)')ffsqp,sigfsqp, ffsqm,sigfsqm
           jffm = 0
           jffsqm = 0
        endif
c
        if(ishel.gt.0 ) then
         if(key.eq.'FREE') then
           if(jff.gt.0)  write(line(13:39),'(2f8.2,i4)')
     +                         ff,sigf,-ishel
           if(jffp.gt.0)  write(line(13:39),'(2f8.2,i4)')
     +                          ffp,sigfp,-ishel
           if(jffd.gt.0)  write(line(13:39),'(2f8.2,i4)')
     +                          ffd,sigfd,-ishel
           if(jffsq.gt.0)  write(line(13:39),'(2f8.2,i4)')
     +                           ffsq,sigfsq,-ishel
           if(jffsqp.gt.0)  write(line(13:39),'(2f8.2,i4)')
     +                            ffsqp,sigfsqp,-ishel
         else
           if(jff.gt.0)  write(line(13:39),'(2f8.2,i4)')
     +                         ff,sigf,ishel
           if(jffp.gt.0)  write(line(13:39),'(2f8.2,i4)')
     +                          ffp,sigfp,ishel
           if(jffd.gt.0)  write(line(13:39),'(2f8.2,i4)')
     +                          ffd,sigfd,ishel
           if(jffsq.gt.0)  write(line(13:39),'(2f8.2,i4)')
     +                           ffsq,sigfsq,ishel
           if(jffsqp.gt.0)  write(line(13:39),'(2f8.2,i4)')
     +                            ffsqp,sigfsqp,ishel
         endif
        endif
C  Must I write out PHI and FOM even if they are not used?
c        frmstr='(4x,3i4,2f8.1,f3.0,f8.1,f8.4)'
        if(itnt.gt.0 ) then
          freetnt=1
          if(KEY.EQ.'FREE')freetnt=0
         if(jff.gt.0)write(line(17:58),'(2f8.1,f8.1,f8.4,f3.0,2x,A)')
     +                         ff,sigf,PHIB,FOM,freetnt,key
         if(jffp.gt.0)write(line(17:58),'(2f8.1,f8.1,f8.4,f3.0,2x,A)')
     +                          ffp,sigfp,PHIB,FOM,freetnt,key
         if(jffsq.gt.0)write(line(17:58),'(2f8.1,f8.1,f8.4,f3.0,2x,A)')
     +                           ffsq,sigfsq,PHIB,FOM,freetnt,key
         if(jffsqp.gt.0)write(line(17:58),'(2f8.1,f8.1,f8.4,f3.0,2x,A)')
     +                            ffsqp,sigfsqp,PHIB,FOM,freetnt,key
        endif

C  MAIN output
        if(imain.eq.1) then
          if (jff.gt.0) then
            if (jphib.gt.0) then
              write(line(16:60),'(A4,F8.2,A4,F8.2,A4,F7.1,A3,F7.3)')
     +            ' FOB',ff,' SIG',sigf,' PHA',PHIB,' WE',FOM
              ichar1 = 61
            else if (jfc.gt.0) then
              write(line(16:43),'(A8,2F10.2)')
     +            ' COMPLEX',ff,fc
              ichar1 = 44
            else
              write(line(16:40),'(A4,F9.2,A4,F8.3)')
     +            ' FOB',ff,' SIG',sigf
              ichar1 = 41
            endif
C           MAIN uses 0 to include; 1 to exclude - reverse of CCP4 freerflag.
            if(lookup(15).gt.0)then
              ifreer_main = 0
              if(key.eq.'FREE') ifreer_main = 1
              write(line(ichar1:ichar1+7),'(A,I2)')' TEST ',ifreer_main
            endif
          endif
        endif

c ---  build up Xplor/CNS line

        jcharxpl1 = 0
        if(ixplo.gt.0  .OR. ICNS.EQ.1) then
         write(line(1:21),'(A,3I5)')' INDE ',in
         if(jff.gt.0)write(line(22:64),'(A,2f10.1,A,f10.2)')
     +                      ' FOBS=',ff,phib,' SIGMA=',sigf
         if(jffp.gt.0)write(line(22:64),'(A,2f10.1,A,f10.2)')
     +                      ' FOBS=',ffp,phib,' SIGMA=',sigfp
         if(jffsq.gt.0)write(line(22:64),'(A,f10.1,A,f10.2)')
     +                      ' IOBS=',ffsq,' SIGMA=',sigfsq
         if(jffsqp.gt.0)write(line(22:64),'(A,f10.1,A,f10.2)')
     +                      ' IOBS=',ffsqp,' SIGMA=',sigfsqp
C         if(jffd.gt.0)write(line(22:64),'(A,2f10.1,A,f10.2)')
C     +                      ' FOBS=',ffd,phib,' SIGMA=',sigfd

          ichar1 = 64
          ichar0 = ichar1 + 1
c     
C     XPLOR uses 0 to include; 1 to exclude - reverse of CCP4 freerflag.
         if(lookup(15).gt.0)then
          ifreer = 0
          if(key.eq.'FREE') ifreer = 1
           if(icns.eq.1) ifreer = free
          ichar0=ichar1 + 1
          ichar1=ichar0 + 13
c            if((ichar1-jcharxpl1).gt.80) jcharxpl2= ichar0
          write(line(65:79),'(A,I6)')' TEST=',ifreer
         endif
        ichar1=80
        jcharxpl1 = ichar1
        jcharxpl2=0
c
         if(lookup(8).gt.0)then
          ichar0=ichar1 + 1
          ichar1=ichar0 + 27
            if((ichar1-jcharxpl1).gt.80) jcharxpl2= ichar0
          write(line(ichar0:ichar1),'(A,f10.1,f10.2)')' FCALC=',fc,phic
         endif
         if(lookup(11).gt.0)then
          ichar0=ichar1 + 1
          ichar1=ichar0 + 27
            if((ichar1-jcharxpl1).gt.80) jcharxpl2= ichar0
          write(line(ichar0:ichar1),'(A,f10.1,f10.2)')
     +          ' FPART=',fpart,phipart
         endif
         if(lookup(13).gt.0.and.lookup(14).gt.0)then
          ichar0=ichar1 + 1
          ichar1=ichar0 + 11
            if((ichar1-jcharxpl1).gt.80) jcharxpl2= ichar0
          write(line(ichar0:ichar1),'(A,f6.3)')
     +          ' FOM=',fom
         endif
C     
         if(lookup(29).gt.0.and.lookup(30).gt.0.and.
     +      lookup(31).gt.0.and.lookup(31).gt.0)then
          ichar0=ichar1 + 1
          ichar1=ichar0 + 56
            if(jcharxpl2.eq.0 .and. (ichar1-jcharxpl1).gt.80) 
     +         jcharxpl2= ichar0
          write(line(ichar0:ichar1),'(A,f10.3,A,f10.3,A,f10.3,A,f10.3)')
     +          ' PA=',hla,' PB=',hlb,' PC=',hlc,' PD=',hld
         endif
C     
         if ( lookup(10).gt.0) then
           ichar0=ichar1 + 1
           ichar1=ichar0 + 16
            if(jcharxpl2.eq.0 .and. (ichar1-jcharxpl1).gt.80) 
     +         jcharxpl2= ichar0
           write(line(ichar0:ichar1),'(A,F10.3)')' WEIG=',w
         endif
        endif

c ---  end of Xplor/CNS 
    
C  Build up cif line
        if(icif.eq.1 ) then
          do ii=1,cifrcols
            cifrec(ii) = 0.0
          enddo
 
          if(jff.gt.0)  cifrec(1) = ff
          if(jff.gt.0)  cifrec(2) = sigf
          if(jfc.gt.0)  cifrec(3) = fc
          if(jphic.gt.0)  cifrec(4) = phic
          if(jfom.gt.0)  cifrec(5) = fom
          if(jffsq.gt.0)  cifrec(6) = ffsq
          if(jffsq.gt.0)  cifrec(7) = sigfsq
          if(jff_fpbs.gt.0)  cifrec(8) = fpart_bulk_s
          if(jff_ppbs.gt.0)  cifrec(9) = phipart_bulk_s
          if(jphib.gt.0)  cifrec(10) = phib
          if(lookup(m2ciflkup(11)).gt.0)  cifrec(11) = hla
          if(lookup(m2ciflkup(12)).gt.0)  cifrec(12) = hlb
          if(lookup(m2ciflkup(13)).gt.0)  cifrec(13) = hlc
          if(lookup(m2ciflkup(14)).gt.0)  cifrec(14) = hld
          if(jffp.gt.0)  cifrec(15) = ffp
          if(jffp.gt.0)  cifrec(16) = sigfp
          if(jffm.gt.0)  cifrec(17) = ffm
          if(jffm.gt.0)  cifrec(18) = sigfm
          if(jffd.gt.0)  cifrec(19) = ffd
          if(jffd.gt.0)  cifrec(20) = sigffd
          if(jffsqp.gt.0)  cifrec(21) = ffsqp
          if(jffsqp.gt.0)  cifrec(22) = sigfsqp
          if(jffsqm.gt.0)  cifrec(23) = ffsqm
          if(jffsqm.gt.0)  cifrec(24) = sigfsqm
          ichar1=18
          jcharcif=0
          do 470 ii = 1,cifrcols
            if ( lookup(m2ciflkup(ii)).le.0 ) goto 470
            ichar0=ichar1 + 1
            ichar1=ichar1 + cifwdth(ii)
c  71 is line of 80 with space for leading "1 1 1"
            if((ichar1-jcharcif).gt.71) jcharcif = ichar0
            if (logmss(m2ciflkup(ii))) then
              line(ichar0+cifwdth(ii)-1:ichar0+cifwdth(ii)-1) = '?'
            else
              write(line(ichar0:ichar1), cifrfmt(ii)) cifrec(ii)
            endif
 470      continue
        endif


C     
C  Sort out line write . only XPLOR and CIF longer than one line
C  CIF output to scratch file..
c
C  Count first occurrence of a reflection
      nrfout = nrfout+1
        if(rstat.eq.'f') nobs_fre = nobs_fre + 1
        if(rstat.eq.'o') nobs_wrk = nobs_wrk + 1
        if(rstat.eq.'x') nobs_mis = nobs_mis + 1
        if(rstat.ne.'f' .and. rstat.ne.'o') nobsexcl = nobsexcl + 1
        if(rstat.eq.'o') nsgood(ns) = nsgood(ns) + 1
C independent reflections
       if(iout2 .eq. 1) then
        if(rstat.eq.'f') nobs_frei = nobs_frei + 1
        if(rstat.eq.'o') nobs_wrki = nobs_wrki + 1
        if(rstat.eq.'x') nobs_misi = nobs_misi + 1
        if(rstat.ne.'f' .and. rstat.ne.'o') nobsexcli = nobsexcli + 1
        if(rstat.eq.'o') nsgoodi(ns) = nsgoodi(ns) + 1
       endif
c
        jchar1 = lenstr(line)
        if(icif.eq.0) then
C          write cns/plor output to iun23 so add the NREF bit afterwards
           ioutscr = iun22
           if(ixplo.eq.1 .or. icns.eq. 1) ioutscr = iun23
c
          if(jcharxpl1 .eq.0) then
c           PJB: Avoid writing blank lines when using OUTPUT USER
            if(iuser .eq.0) then
              ichar1 = jchar1
              write(iun22,'(a)')line(1:ichar1)
c              if(nchk.eq.1) 
c     +        write(6,'(2a)')'bug1',line(1:ichar1)
            endif
          else
c             write(6,*)'ichar1,jcharxpl1,jcharxpl2',ichar1,jcharxpl1,
c     +   jcharxpl2
            if(jcharxpl2 .eq.0)then
                if(jcharxpl1.eq.ichar1)
     +             write(ioutscr,'(a)')line(1:ichar1)
c ichar1,jcharxpl1,jcharxpl2         149          80           0
                if(jcharxpl1.lt.ichar1)
     +             write(ioutscr,'(a,/,a)')line(1:jcharxpl1-1),
     +                             line(jcharxpl1:ichar1)
c              if(nchk.eq.1 ) 
c     +        write(6,'(a,i4,a,/,a)')'bug2',jcharxpl1-ichar1,
c     +         line(1:jcharxpl1-1),
c     +                          line(jcharxpl1:ichar1)
            end if
            if(jcharxpl2 .gt.0) 
     +          write(ioutscr,'(a,/,a,/,a)')line(1:jcharxpl1-1),
     +                             line(jcharxpl1:jcharxpl2-1),
     +                             line(jcharxpl2:ichar1)
c              if(nchk.eq.1 .and. jcharxpl2 .gt.0) 
c     +        write(6,'(2a,/,a,/,a)')'bug3',line(1:jcharxpl1-1),
c     +                          line(jcharxpl1:jcharxpl2-1),
c     +                          line(jcharxpl2:ichar1)
          endif
 1006     format(a)
        else
c  CIF section 
          jcharcif = lenstr(line)
c         Always write at least one line
          if (jcharcif.lt.72) then
            ichar1 = jcharcif
          else
            ichar1 = 71
 9081       continue
            if (line(ichar1:ichar1).ne.' ' .and. 
     +           line(ichar1+1:ichar1+1).ne.' ') then
c             The linebreak is inside a field - step back until we
c             move out of it
              ichar1 = ichar1 - 1
              if (ichar1.lt.0) then
                call ccperr(1,"fatal error: ran out of characters!")
              endif
              goto 9081
            endif
          endif
          write(iun23,rec=iscrl,fmt='('' 1 1 1   '',a)')
     +         line(1:ichar1)
          if (nchk.eq.1) write(6,'(a)') line(1:ichar1)
          iscrl = iscrl+1
c         Write additional lines (80 characters each) until we
c         run out of characters
c         Need also to make sure that we don't "break" a field
c         into two fields
          jchar1 = 71
 9980     continue
          if (jcharcif-jchar1.gt.0) then
            ichar1 = jchar1 + 80
            if (ichar1.ge.jcharcif) then
              ichar1 = jcharcif
            else
 9082         continue
              if (line(ichar1:ichar1).ne.' ' .and. 
     +             line(ichar1+1:ichar1+1).ne.' ') then
c               The linebreak is inside a field - step back until we
c               move out of it
                ichar1 = ichar1 - 1
                if (ichar1.lt.0) then
                  call ccperr(1,"fatal error: ran out of characters!")
                endif
                goto 9082
              endif
            endif
            write(iun23,rec=iscrl,fmt='(a)') line(jchar1+1:ichar1)
            if (nchk.eq.1) write(6,'(a)') line(jchar1+1:ichar1)
            iscrl = iscrl+1
            jchar1 = ichar1
            goto 9980
          endif
        endif
C Time to reverse signs for reflection -h -k -l
         jcheck = jffm + jffsqm
         if (jcheck.gt.0 .and. icif.eq.0) then
            jff = 0
            jffd = 0
            do 465 ii = 1,3
              in(ii) = -in(ii)
              if ( in(ii).lt.ihmin(ii) ) ihmin(ii) = in(ii)
              if ( in(ii).gt.ihmax(ii) ) ihmax(ii) = in(ii)
 465        continue
            iout2 = 2
            jffp = jffm
            jffm = 0
            ffp = ffm
            sigfp = sigfm
            jffsqp = jffsqm
            jffsqm = 0
            ffsqp = ffsqm
            sigfsqp = sigfsqm
            if(lookup(9).gt.0) phic = -phic
            if(lookup(12).gt.0) phipart = -phipart
            if(lookup(13).gt.0) phib = -phib
            if(lookup(30).gt.0) hlb = -hlb
            if(lookup(32).gt.0) hld = -hld
c       return for -h -k -l
            go to 462
         endif
      endif
c
c     
c     
C---- WRITE OUT IN USER FORMAT; MUST HAVE H K L
C
      IF(IUSER.EQ.1)THEN
C FR45: at least Squaring and scaling in output user mode as
C      it seems it was ignoring them in this mode
       IF(IFSQ.EQ.1) THEN
         ADATA(27)=ADATA(4)*ADATA(4)
         ADATA(28)=(2.0*ADATA(5)*ADATA(4))+(ADATA(5)*ADATA(5))
         ADATA(19)=ADATA(23)*ADATA(23)
         ADATA(20)=(2.0*ADATA(24)*ADATA(23))+(ADATA(24)*ADATA(24))
         ADATA(21)=ADATA(25)*ADATA(25)
         ADATA(22)=(2.0*ADATA(26)*ADATA(25))+(ADATA(26)*ADATA(26))
       ENDIF

          ADATA(4)=ADATA(4)*scal
          ADATA(5)=ADATA(5)*scal
          ADATA(6)=ADATA(6)*scal
          ADATA(7)=ADATA(7)*scal
          DO 555 IU = 19,54
             ADATA(IU)=ADATA(IU)*scal
 555      CONTINUE
	   
       IF(FMT.EQ.'*')THEN
         write(iun22,*)(NINT(ADATA(I)),I=1,3),
     +        (NINT(ADATA(COLOUT(I))),I=1,IRNG(1)),
     +        (ADATA(COLOUT(I)),I=IRNG(1)+1,IRNG(2)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(2)+1,IRNG(3)),
     +        (ADATA(COLOUT(I)),I=IRNG(3)+1,IRNG(4)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(4)+1,IRNG(5)),
     +        (ADATA(COLOUT(I)),I=IRNG(5)+1,IRNG(6)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(6)+1,IRNG(7)),
     +        (ADATA(COLOUT(I)),I=IRNG(7)+1,IRNG(8)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(8)+1,IRNG(9)),
     +        (ADATA(COLOUT(I)),I=IRNG(9)+1,IRNG(10)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(10)+1,IRNG(11)),
     +        (ADATA(COLOUT(I)),I=IRNG(11)+1,IRNG(12)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(12)+1,IRNG(13)),
     +        (ADATA(COLOUT(I)),I=IRNG(13)+1,IRNG(14)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(14)+1,IRNG(15)),
     +        (ADATA(COLOUT(I)),I=IRNG(15)+1,IRNG(16)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(16)+1,IRNG(17)),
     +        (ADATA(COLOUT(I)),I=IRNG(17)+1,IRNG(18)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(18)+1,IRNG(19)),
     +        (ADATA(COLOUT(I)),I=IRNG(19)+1,IRNG(20)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(20)+1,IRNG(21))
         IF (NCHK.EQ.1) write(6,*)NINT(ADATA(1)),NINT(ADATA(2)),
     +        NINT(ADATA(3)),(ADATA(COLOUT(I)),I=1,IOUT)    
       ELSE
         WRITE(IUN22,FMT,ERR=431,IOSTAT=IOSTAT) (NINT(ADATA(I)),I=1,3),
     +        (NINT(ADATA(COLOUT(I))),I=1,IRNG(1)),
     +        (ADATA(COLOUT(I)),I=IRNG(1)+1,IRNG(2)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(2)+1,IRNG(3)),
     +        (ADATA(COLOUT(I)),I=IRNG(3)+1,IRNG(4)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(4)+1,IRNG(5)),
     +        (ADATA(COLOUT(I)),I=IRNG(5)+1,IRNG(6)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(6)+1,IRNG(7)),
     +        (ADATA(COLOUT(I)),I=IRNG(7)+1,IRNG(8)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(8)+1,IRNG(9)),
     +        (ADATA(COLOUT(I)),I=IRNG(9)+1,IRNG(10)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(10)+1,IRNG(11)),
     +        (ADATA(COLOUT(I)),I=IRNG(11)+1,IRNG(12)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(12)+1,IRNG(13)),
     +        (ADATA(COLOUT(I)),I=IRNG(13)+1,IRNG(14)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(14)+1,IRNG(15)),
     +        (ADATA(COLOUT(I)),I=IRNG(15)+1,IRNG(16)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(16)+1,IRNG(17)),
     +        (ADATA(COLOUT(I)),I=IRNG(17)+1,IRNG(18)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(18)+1,IRNG(19)),
     +        (ADATA(COLOUT(I)),I=IRNG(19)+1,IRNG(20)),
     +        (NINT(ADATA(COLOUT(I))),I=IRNG(20)+1,IRNG(21))
 431     IF (IOSTAT.NE.0) CALL CCPERR (1,
     +      'Formatted output error -- check supplied format: '//FMT)
         IF (NCHK.EQ.1) write(6,*) NINT(ADATA(1)),NINT(ADATA(2)),
     +        NINT(ADATA(3)),(ADATA(COLOUT(I)),I=1,IOUT)
       ENDIF
      ENDIF
C     
cmdw Back to read next relection from HKLIN
      go to 410
c     
 9875 FORMAT(' NREF ADATA ',I8,/,1X,3i4,10F9.1)
c     ERROR CONDITIONS
C     
 370  continue
      if (ixplo.eq.1 .or. icns.eq.1) then
c   Copy all output to iun22 adding number of reflections
       rewind ioutscr
         write(iun22,'(A,i10)')'  NREFlection=     ',nrfout
         write(6,'(A,i10)')'  NREFlection=     ',nrfout
 371     read(ioutscr,'(A)',end = 372)line(1:80)
         write(iun22,'(A)')line(1:80)
         go to 371
 372     continue
      elseif (ishel.eq.1) then
        write(iun22,'(a)')'   0   0   0 '
      else if (imult.eq.1) then
        ff=-1000
        ADATA(7)=-99
        write(iun22,2002)in(1),in(2),in(3),ff,ADATA(7)
 2002 format(3i4,7x,2f7.0)

c
c ___ Lots to do at the end for CIF's
c
      elseif (icif.eq.1) then

c   write data block header, and header info ..
        call wcifhr(mtzin,iun22,dbhead(:ldbhead))

C   now write out reflections

cloop_
c_refln.wavelength_id
c_refln.crystal_id
c_refln.scale_group_code
c_refln.index_h
c_refln.index_k
c_refln.index_l

        call wccatc(iun22,'REFLN')
        write (IUN22,fmt=6014)
 6014   FORMAT (
     +'loop_',/,
     +'_refln.wavelength_id',/,
     +'_refln.crystal_id',/,
     +'_refln.scale_group_code',/,
     +'_refln.index_h',/,
     +'_refln.index_k',/,
     +'_refln.index_l',/,
     +'_refln.status')
        
        do 375 ii=1,cifrcols
          if ( lookup(m2ciflkup(ii)).gt.0 )
     &      write(iun22,'(a)')
     &      cifrnames(ii)(:index(cifrnames(ii), ' '))
 375    continue
        
        do 380 ii = 1,iscrl-1
          read(unit=iun23,rec=ii,fmt='(a)') ciflne
          write(iun22,fmt='(a)') ciflne(1:lenstr(ciflne))
 380    continue
      endif
         
      write(6,'(/,A,/,A,/,A,/)') 
     +   ' ===================================',
     +   '  FINISHED READING REFLECTIONS ',
     +   ' ==================================='

      WRITE(6,9874) nrfout,nobs_wrki,nobs_frei,nobs_misi,nobsexcli,
     +                nobs_wrk,nobs_fre,nobs_mis,nobsexcl,ndelexcl
 9874 FORMAT(
     +  ' Number of reflections   output = ',i8,//,
     +  ' Number in Working Set (indep)  = ',I8,/,
     +  ' Number in Free    Set (indep)  = ',I8,/,
     +  ' Number  Missing       (indep)  = ',I8,/,
     +  ' Number in Excluded Set (indep) = ',I8,//,
     +  ' Number in Working Set (total)  = ',I8,/,
     +  ' Number in Free    Set (total)  = ',I8,/,
     +  ' Number  Missing       (total)  = ',I8,/,
     +  ' Number in Excluded Set (total) = ',I8,//,
     +  ' Number rejected by EXCLUDE k/w = ',I8)
      sr0=smin
      write(6,9872)
 9872 format(///,' No. of reflections a) altogether b) to output ',
     +  'c) independent   by resolution bins')
      do 500 i=1,50
         sr1=sr0+step
         write(6,9873)sr0,sr1,nsall(i),nsgood(i),nsgoodi(i)
         sr0=sr0+step
 9873    format( f10.5,' -',f10.5,3i10)
 500  continue
      CLOSE(UNIT=IUN22,STATUS='KEEP')
      CALL CCPERR(0,'Normal termination')
      END


c
c ___ Write out data block header and required stuff for a new CIF
c
      subroutine wcifhr(mtzin,iun,dbhead)

      INTEGER MSETS
      PARAMETER (MSETS=200)

      integer mtzin,iun
      character*(*) dbhead

      character caldat*8, cifdat*10, fname*80, cifcel(6)*20
      integer nsympx,nspgrx,nsym
      character ltypex*1, spgrnx*10,pgnamx*10,spgrnx_cif*80, 
     +       spgrnx_cifs*80,symchs(196)*80,ich(3)*1
      real cell(6), RSYM(4,4,192),rMIN,rMAX

      integer ihmin(3), ihmax(3),nrfout,nobs_wrki,nobs_frei,ireso,
     +    nwave
      real sigp,smax,smin,WAVELENGTH(MSETS)
      COMMON /CIFVARSI/ ihmin, ihmax,nrfout,nobs_wrki,nobs_frei,
     +    ireso,nwave
      COMMON /CIFVARSR/ sigp,smax,smin,WAVELENGTH

      data cifcel /'_cell.length_a',
     &  '_cell.length_b',
     &  '_cell.length_c',
     &  '_cell.angle_alpha',
     &  '_cell.angle_beta',
     &  '_cell.angle_gamma'/
      data ich /'h','k','l'/

      ldbhead = lenstr(dbhead)
      
      call ccpdat(caldat)
      if (caldat(1:1).eq.' ') caldat(1:1) = '0'
      if (caldat(4:4).eq.' ') caldat(4:4) = '0'
      cifdat(1:2) = '19'
      read(caldat(7:8),'(i2)')iyear
       if(iyear.lt.70) cifdat(1:2) = '20'
      cifdat(3:4) = caldat(7:8)
      cifdat(3:4) = caldat(7:8)
      cifdat(5:5) = '-'
      cifdat(6:7) = caldat(4:5)
      cifdat(8:8) = '-'
      cifdat(9:10) = caldat(1:2)

      call ugtenv('HKLIN',fname)

      write (iun,'(a)') dbhead
      call wccatc(iun,'ENTRY')
      write (iun,'(''_entry.id   '',a)') dbhead(6:)

      call wccatc(iun,'AUDIT')
      write (iun,'(a)') '_audit.revision_id        1'
      write (iun,'(3a)')  '_audit.creation_date      ''',cifdat,''''
      write (iun,'(a)')   '_audit.creation_method'
      write (iun,'(a)')   '; Created by mtz2various (CCP4) from'
      write (iun,'(a/'';'')') fname
      write (iun,'(a,2(/,'';''))') '_audit.update_record'

        call lrcell(mtzin,cell)
        call wccatc(iun,'CELL')
        write(iun,'(a,5x,a)') '_cell.entry_id',dbhead(6:ldbhead)
        write(iun,'((a,5x,f10.4))') (cifcel(ii),cell(ii),ii=1,6)

        call lrsymi(mtzin,nsympx,ltypex,nspgrx,spgrnx,pgnamx)
        call wccatc(iun,'SYMMETRY')
        write(iun,'(a,5x,a)') '_symmetry.entry_id',dbhead(6:ldbhead)
        if (nspgrx.eq.0) then
          write(iun,'(a,5x,a)') '_symmetry.Int_Tables_number','?'
        else
          write(iun,'(a,i10)')
     &      '_symmetry.Int_Tables_number',nspgrx
        endif
C--- Change short H-M symbol to full CIF-style symbol:
        call MSYMLB3(24,nspgrx,spgrnx_cif,spgrnx_cifs,pgnamx,
     &                  nsympx,nsym,rsym)
        if (spgrnx_cif.eq.' ') spgrnx_cif = '?'
        write(iun,'(a,5x,a)') '_symmetry.space_group_name_H-M', 
     &     ''''//spgrnx_cif(1:LENSTR(spgrnx_cif))//''''

        call wccatc(iun,'SYMMETRY_EQUIV')
        if (nsym.gt.0) then
          write(iun,'(a,/,(1x,a))') 'loop_', '_symmetry_equiv.id',
     &      '_symmetry_equiv.pos_as_xyz'
          call symtr3(nsym,rsym,symchs,0)
          do 373 ii = 1,nsym
            do 374 jj = 80,3,-1
              if ( symchs(ii)(jj:jj) .ne. ' ' ) then
                write (iun,'(i5,a)') ii,' '''//symchs(ii)(:jj)//''''
                goto 373
              endif
 374        continue
            call ccperr(1,' ***Blank symop from symtr3!!!')
 373      continue
        endif
        
        CALL LRRSOL(MTZIN,rMIN,rMAX)
        call wccatc(iun,'REFLNS')
        write(iun,'(a,5x,a)') '_reflns.entry_id',dbhead(6:ldbhead)
        write(iun,'((a,5x,f10.3))')
     &    '_reflns.d_resolution_high',sqrt(1.0/rmax),
     &    '_reflns.d_resolution_low',sqrt(1.0/rmin)
        write(iun,'((3a,5x,i6))')
     &    ('_reflns.limit_',ich(ii),'_max',ihmax(ii),
     &    '_reflns.limit_',ich(ii),'_min',ihmin(ii), ii=1,3)
        write(iun,'(a,5x,i8)') '_reflns.number_all',nrfout
        ichk = nobs_wrki+nobs_frei
        write(iun,'(a,5x,i8)') '_reflns.number_obs',ichk

        if (sigp.gt.0.0001)
     &    write(iun,'(a,5x,a,f5.2,a)')
     &      '_reflns.observed_criterion','''F > ',sigp,'sigma(F)'''


        if (ireso.eq.1) then
          call wccatc(iun,'REFINE')
          write(iun,'(a,5x,a,/,(a,5x,f10.3))')
     &      '_refine.entry_id',dbhead(6:ldbhead),
     &      '_refine.ls_d_res_high',sqrt(1.0/smax),
     &      '_refine.ls_d_res_low',sqrt(1.0/smin)
        endif

        call wccatc(iun,'DIFFRN_RADIATION_WAVELENGTH')
        IF (NWAVE.GT.0) THEN
          write (IUN,fmt=6014)
 6014     FORMAT (
     +'loop_',/,
     +'_diffrn_radiation_wavelength.id',/,
     +'_diffrn_radiation_wavelength.wavelength')
          DO IWAVE = 1,NWAVE
            write(iun,'(I5,F10.5)') IWAVE,WAVELENGTH(IWAVE)
          ENDDO
        ELSE
          write(iun,'(a,5x,''1'')') '_diffrn_radiation_wavelength.id'
        ENDIF

        call wccatc(iun,'EXPTL_CRYSTAL')
        write(iun,'(a,5x,''1'')') '_exptl_crystal.id'

        call wccatc(iun,'REFLNS_SCALE')
        write(iun,'(a,5x,''1'')') '_reflns_scale.group_code'
      
      end

c
c ___ Write out comment box for a CIF category
c
      subroutine wccatc(iun, category)
      integer iun
      character*(*) category

      integer lcat, lbox

      character hash*80, hasha(80)*(1), spaces*80
      equivalence (hash, hasha)
      data hasha, spaces /80*'#', ' '/

      lcat = index(category,' ')
      if ( lcat.eq.0 ) lcat = len(category)
      lbox = lcat + 6

      write(iun,'(//,a,/,''#'',a,''#'')')
     &  hash(:lbox), spaces(:lbox-2)
      write(iun,'(''#  '',a,''  #'')') category(:lcat)
      write(iun,'(''#'',a,''#'',/,a,//)')
     &  spaces(:lbox-2), hash(:lbox)
      end
