C
C     MTZTONA4
C     Copyright (C) 1991 Ian Tickle
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
C PROGRAM MTZTONA4
C ================
C FMY  1-5-91 MTZ WORKSHOP, CAMBRIDGE
C VERSION MODIFIED TO USE CHARACTER*4  IJT, BIRKBECK.
C THIS PROGRAM IS USED TO TRANSLATE REFLECTION DATA BETWEEN 'MTZ' FORMAT
C AND A PACKED ASCII (`NA4') FILE. THE NA4 FORMAT MAY BE
C USED FOR TRANSFERRING REFLECTION DATA BETWEEN DIFFERENT COMPUTERS.
C
C      MTZ --> Ascii
C
C FORTRAN77
C
C
C
C SPECIFICATION STATEMENTS
C ========================
C
C     .. Parameters ..
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
      REAL RBATCH(MBLENG)
      CHARACTER CBATCH(CBLENG)*1
C     ..
      INTEGER MCOLS
      PARAMETER (MCOLS=500)
      INTEGER MSETS
      PARAMETER (MSETS=MCOLS)
      INTEGER MHISTL
      PARAMETER (MHISTL = 30)
      INTEGER MBATCH
      PARAMETER (MBATCH =5000)
C
      INTEGER IUNOUT,INDEX,IPRINT,NCOL,NREFL,JFAIL,
     +        NBATCH,BATCH(MBATCH),LENTITL,ISTAT,SORT(5),
     +        NSPGR,NSYM,NSYMP,NHIST,NDATASETS,JDO25
C
C     .. Local Arrays ..
      INTEGER   IDATA(2,MCOLS),ISETS(MSETS),CSETID(MCOLS)
      REAL      RDATA(MCOLS),RANGES(2,MCOLS),CELL(6),RSYM(4,4,192),
     +         DATCELL(6,MSETS),DATWAVE(MSETS)
C
      CHARACTER BUF*80, SPGRN*10, CTYPS(MCOLS)*1,CLABS(MCOLS)*30,
     +           LTYPE*1, TITLE*70, VERSN*10, SYMCHS(192)*80,
     +           HSCR(MHISTL)*80, PGNAME*10, ADATA*(MCOLS*4),
     +           PNAME(MSETS)*64,XNAME(MSETS)*64,DNAME(MSETS)*64
C
      LOGICAL EOF
C
      CHARACTER A4REAL*4
C
C     .. Common blocks ..
      LOGICAL NAN_FOUND
      COMMON /NANTEST/ NAN_FOUND
C
C
C INITIALISATIONS
C ===============
C
      LUNIN = 5
      LUNOUT = 6
      CALL CCPFYP
      CALL MTZINI
      CALL CCPRCS(6,'MTZTONA4','$Date: 2006/07/31 16:00:16 $')
C
C
C TRANSLATE FROM 'MTZ' TO 'NA4' FORMAT
C =========================================
C
C INITIALISATIONS
C ---------------
C
      NAN_FOUND = .FALSE.
      INDEX = 1
      IUNOUT = 55
      IPRINT = 2
      JFAIL=0
      CALL CCPDPN(IUNOUT,'HKLOUT','NEW','F',LDUM,JFAIL)
C
C  Open MTZ file
C
        CALL LROPEN(INDEX,'HKLIN',IPRINT,JFAIL)
        IF (JFAIL.NE.0)
     +     CALL CCPERR(1,'Error reading HKLIN.')

C read header info from mtz and
C Write header info from to ASCII file for each keyword.
C
        CALL LRINFO (INDEX,VERSN,NCOL,NREFL,RANGES)
        CALL LRCLAB (INDEX,CLABS,CTYPS,NCOL)
        CALL LRBATS (INDEX,NBATCH,BATCH)
C
C VERS
        WRITE(IUNOUT,2010)'VERS',VERSN
 2010   FORMAT (A,1X,A)
C
C NCOL
        WRITE(IUNOUT,2020)'NCOL',NCOL,NREFL,NBATCH
 2020   FORMAT (A,1X,3I8)
C
C COLUMN
C
C--Get dataset IDs. Should be all 0 if no datasets included.
        CALL LRCLID(INDEX,CSETID,NCOL)
        DO 30 JDO30 =1 ,NCOL
C
C--Get index values for REALA4
C
        CALL CVR4A4(RANGES(1,JDO30),IDATA(1,JDO30))
        IF (CSETID(JDO30).GT.0) THEN
         WRITE (IUNOUT,2030)'COLUMN',CLABS(JDO30),CTYPS(JDO30),
     +         RANGES(1,JDO30),RANGES(2,JDO30),
     &         IDATA(1,JDO30),IDATA(2,JDO30),CSETID(JDO30)
        ELSE
         WRITE (IUNOUT,2030)'COLUMN',CLABS(JDO30),CTYPS(JDO30),
     +         RANGES(1,JDO30),RANGES(2,JDO30),
     &         IDATA(1,JDO30),IDATA(2,JDO30)
        ENDIF
 2030   FORMAT (A,1X,A,1X,A,2(1X,1PE13.6),1X,I2,1X,I4,1X,I4)
C
 30     CONTINUE
C
C title
        CALL LRTITL(INDEX,TITLE,LENTITL)
        WRITE (IUNOUT,2040)'TITLE',TITLE(1:LENTITL)
 2040   FORMAT (A5,1X,A)
C
C dataset info
        NDATASETS = MSETS
        CALL LRIDX(INDEX,PNAME,XNAME,DNAME,ISETS,DATCELL,
     +             DATWAVE,NDATASETS)
        IF (NDATASETS.GT.0) THEN
          WRITE (IUNOUT,FMT='(A7,1X,I8)') 
     +      'NDIFFRN',NDATASETS
          DO 25 JDO25 = 1,NDATASETS
            WRITE (IUNOUT,FMT='(A7,1X,I7,1X,A)') 
     +        'PROJECT',ISETS(JDO25),PNAME(JDO25)
            WRITE (IUNOUT,FMT='(A7,1X,I7,1X,A)') 
     +        'CRYSTAL',ISETS(JDO25),XNAME(JDO25)
            WRITE (IUNOUT,FMT='(A7,1X,I7,1X,A)') 
     +        'DATASET',ISETS(JDO25),DNAME(JDO25)
            IF (DATCELL(1,JDO25).GT.0.0) THEN
              WRITE (IUNOUT,FMT='(A5,3X,I7,1X,6F10.4)') 
     +         'DCELL',ISETS(JDO25),(DATCELL(I,JDO25),I=1,6)
            ENDIF
            IF (DATWAVE(JDO25).GT.0.0) THEN
              WRITE (IUNOUT,FMT='(A6,2X,I7,1X,F10.5)') 
     +          'DWAVEL',ISETS(JDO25),DATWAVE(JDO25)
            ENDIF
 25       CONTINUE
        END IF
C
C CELL
        CALL LRCELL(INDEX,CELL)
        WRITE (IUNOUT,2050)'CELL',(CELL(I),I =1,6)
 2050   FORMAT (A,1X,6F10.4)
C
C SORT
        CALL LRSORT(INDEX,SORT)
        WRITE (IUNOUT,2060)'SORT',(SORT(I),I=1,5)
 2060   FORMAT(A,1X,5I4)
C
C SYMINF
        CALL LRSYMI(INDEX,NSYMP,LTYPE,NSPGR,SPGRN,PGNAME)
        CALL LRSYMM(INDEX,NSYM,RSYM)
C
        IF (NSYM.GT.0) THEN
           WRITE (IUNOUT,2070)
     $          'SYMINF',NSYM,NSYMP,LTYPE,NSPGR,'''',SPGRN,'''',PGNAME
 2070      FORMAT(A,1X,2I3,1X,A1,1X,I5,1X,A,A,A,1X,A)
C
C SYMM
           ISTAT = 0
           CALL SYMTR3 (NSYM,RSYM(1,1,1),SYMCHS,ISTAT)
C
           DO 80 JDO80 = 1,NSYM
              WRITE (IUNOUT,2080) 'SYMM',
     +                 SYMCHS(JDO80)(1:LENSTR(SYMCHS(JDO80)))
 80        CONTINUE
 2080         FORMAT (A,1X,A)
       ENDIF
C
C  BATCH serial numbers if multi-record
C
      IF (NBATCH .GT.0) THEN
          IBPRT = 0
C
C
          DO 90 JDO90 = 1, NBATCH
             WRITE (IUNOUT,2090)'BATCH',BATCH(JDO90)
2090         FORMAT (A5,1X,I10)
C
C---- Call lrbat to set up arrays printing everything
C     BUT requires change in library that
C       if IPRINT .gt. 30 then set print = 2
C                and use as unit number in subroutines
C                LBPRT and LBPRTH
C
C      IUNOUT = 55
C
             CALL LRBAT(INDEX,BATCH(JDO90),RBATCH,CBATCH,0)
             CALL MTZTONA4_LBPRT(BATCH(JDO90),IUNOUT,RBATCH,CBATCH)
C
C
90        CONTINUE
      ENDIF
C
C
C END of header:  change to ENDH so file not accepted by old NA4TOMTZ.
        CALL UGTENV('CCP4_RLENA4',BUF)
        IF (BUF(:1).EQ.' ') THEN
          WRITE (IUNOUT,'(A)') 'END'
        ELSE
          WRITE (IUNOUT,'(A)') 'ENDH'
        ENDIF
C
C History headers
C
c Need to set NHIST to max allowed number of history lines on entry to LRHIST
       nhist = mhistl
       CALL LRHIST (INDEX,HSCR,NHIST)
       IF (NHIST.GT.0) THEN
             WRITE (IUNOUT,2100)'MTZHIST',NHIST
 2100        FORMAT (A7,1X,I3)
C
C
             DO 110 JDO110 =1, NHIST
               WRITE (IUNOUT,2110) HSCR (JDO110)
 2110          FORMAT (A)
C
 110         CONTINUE
C
       END IF
C
C
       WRITE (IUNOUT,'(A)') 'MTZENDOFHEADERS'
C END OF ALL HEADERS
CC
C
C--HEADER INFO OUTPUT TO ASCII FILE
C
C
C Loop for all reflections
        NREFL = 0
400     CALL LRREFL (INDEX,S,RDATA,EOF)
        IF (.NOT.EOF) THEN
          LA=0
          DO 390 II=1,NCOL
            LA=LA+4
390         ADATA(LA-3:LA)=A4REAL(IDATA(1,II),RDATA(II))
          IF (BUF(:1).NE.' ') CALL RLENA4(LA,ADATA)
          JA=0
410       IA=JA+1
          JA=MIN(JA+80,LA)
          WRITE (IUNOUT,'(A)') ADATA(IA:JA)
          IF (JA.LT.LA) GOTO 410
          NREFL = NREFL + 1
          GOTO 400
        ENDIF
C
C--- end of MTZ file reached
c
        WRITE(IUNOUT,2190)NREFL
2190   FORMAT ( '*** END ***   Number of Reflections output ...',I8)

       IF (NAN_FOUND) WRITE(6,'(/,A)')
     &   ' Input mtz file contained missing data represented as NaN.'

       IF (BUF(:1).EQ.' ') THEN
         WRITE(6,'(3(/A))')
     &   ' NOTE: This version of MTZTONA4 uses run-length encoding and',
     &   ' may produce a shorter output file if CCP4_RLENA4 is set.',
     &   ' You need the current version of NA4TOMTZ to decode this:'
       ELSE
         WRITE(6,'(2(/A))')
     &   ' NOTE: Run-length encoded format produced - ensure that the',
     &   ' recipient of this file has the current version of NA4TOMTZ:'
       ENDIF
       WRITE(6,'(A)') ' Check the NA4TOMTZ documentation.'
       CLOSE(UNIT=IUNOUT,STATUS='KEEP')
       CALL CCPERR(0,'Normal termination of MTZTONA4')
C
       END
C
C MDW Apr 03
C Local copies of LBPRT and LBPRTH moved here, since writing to
C Fortran unit won't work from new C code.
C
C     =============================================
      SUBROUTINE MTZTONA4_LBPRT(IBATCH,IPRINT,RBATCH,CBATCH)
C     =============================================
C
C---- Internal MTZ subroutine (I think!) which copies the batch header
C     information as it is stored in raw form on the files, into the
C     common blocks MBTHDR and CBTHDR, and then calls LBPRTH to make
C     some sense of these numbers.
C
C---- Arguments :
C
C     IBATCH    (I)	INTEGER         batch number
C
C     IPRINT    (I)	INTEGER         print indicator : meaning :
C                               	=0 no print
C                               	=1 print batch title only
C                               	=2 also print orientation block
C                               	.GT. 30 also print orientation block
C                                    	BUT TO IPRINT UNIT NUMBER
C
C     RBATCH    (I)	REAL(*)         array from which integer and real batch
C                               	info is decoded by subroutine wbathd
C                               	this should be equivalenced onto the
C                               	appropriate COMMON block in the calling
C                               	program. The first item is nwords,ie how
C                               	many items in the array, if nword is 0
C                               	then only the title is written to header
C
C     CBATCH    (I)	CHARACTER*(*)   as RBATCH, but for character items - no
C                               	nwords however; title is 1st 70 chars of
C                               	CBATCH.
C
C     The lengths of the RBATCH & CBATCH arrays are parameters here!
C
C
C     .. Parameters ..
      INTEGER MBLENG,CBLENG
      PARAMETER (MBLENG=185,CBLENG=70+3*8)
C     ..
C     .. Scalar Arguments ..
      INTEGER IBATCH,IPRINT
C     ..
C     .. Array Arguments ..
      REAL RBATCH(MBLENG)
      CHARACTER CBATCH*(*)
C     ..
C     .. Arrays in Common ..
      REAL RARRAY
      CHARACTER CARRAY*1
C     ..
C     .. Local Scalars ..
      INTEGER JDO20,JDO30,NWORDS
C     ..
C     .. External Subroutines ..
      EXTERNAL MTZTONA4_LBPRTH
C     ..
C     .. Common blocks ..
      COMMON /MTZTONA4_CBTHDR/CARRAY(CBLENG)
      COMMON /MTZTONA4_MBTHDR/RARRAY(MBLENG)
C     ..
C     .. Equivalences ..
      EQUIVALENCE (NWORDS,RARRAY(1))
C     ..
C     .. Save statement ..
      SAVE /MTZTONA4_MBTHDR/,/MTZTONA4_CBTHDR/
C     ..
C
C---- Copy from the input arguments to the dummy common block
C     first we have to get NWORDS out
C
      RARRAY(1) = RBATCH(1)
C
      DO 10 JDO20 = 1,NWORDS
        RARRAY(JDO20) = RBATCH(JDO20)
   10 CONTINUE
C
      DO 20 JDO30 = 1,CBLENG
        CARRAY(JDO30) = CBATCH(JDO30:JDO30)
   20 CONTINUE
C
C          *********************
      CALL MTZTONA4_LBPRTH(IBATCH,IPRINT)
C          *********************
C
      END
C     
C     
C     ================================
      SUBROUTINE MTZTONA4_LBPRTH(IBATCH,IPRINT)
C     ================================
C     
C     
C     
C---- Internal Subroutine to print out the batch header information
C     from the MTZ COMMON blocks /MBTHDR/ and /CBTHDR/ (already there)
C     
C---- Arguments :
C     
C     IBATCH	(I)	INTEGER         batch number
C     
C     IPRINT    (I)	INTEGER         print indicator : meaning :
C     					=0 no print
C     					=1 print batch title only
C     					=2 also print orientation block
C     					.GT. 30 also print orientation block 
C					TO UNIT NUMBER IPRINT
C     
C     
C     
C     Orientation block data
C     
C     This contains slots for all information that seems to be essential
C     at present. Each group of parameters is padded at the end for future
C     expansion.
C     
C     Data in the orientation block are referred to the "Cambridge"
C     laboratory axis frame: x along the (idealized) X-ray beam, z along
C     usual rotation axis E1 (omega on 3-axis system). The matrix Q converts
C     a vector in the Madnes frame to the Cambridge frame.  Note that the
C     laboratory frame is essentially defined by the vectors e1,e2,e3 &
C     source. It doesn't really seem necessary to carry through a whole lot
C     of crystal and beam tensors, particularly as we have integrated
C     intensities at this stage, but maybe someone will want to, using the
C     allocated padding
C     
C     The general orientation equation is
C     
C     x  =   R M U B h
C     
C     where x    position in laboratory frame
C     R    goniostat matrix
C     M    missetting angle matrix (if relevant, see MISFLG)
C                 PhiZ PhiY PhiX (PHIXYZ)
C     U    crystal orientation matrix UMAT
C     B    cell orthogonalization matrix, derived from cell dimensions
C     h    reflection indices
C     
C     Note that the description below is NOT is the same order as in the
C     common block, in which all the integers come before all the reals 
C     (flagged as I or R in the description below)
C     
CI    NWORDS       number of words in orientation block
CI    NINTGR       number of integers (first part of block,
C                        includes these counts)
CI    NREALS       number of reals
CI    IORTYP       type of orientation block (for possible future use, now = 0)
CI    INTPAD(8)    padding for future use (integers)
C     
C---  Information for this crystal
C     
CR    CELL(6)      cell dimensions  (A & degrees)
CI    LBCELL(6)    refinement flags for cell dimensions
CR    UMAT(3,3)    orientation matrix U. If MISFLG .gt. 0, U is the
C                   "standard" setting when PhiXYZ ==0 
CI    MISFLG       status of "missetting" angles PHIXYZ
C                   = 0  PHIXYZ not used, all orientation in UMAT
C                   = 1  1 set of missetting angles (PHIXYZ(I,1))
C                   = 2  2 sets PHIXYZ(I,J), J=1,2
CR    PHIXYZ(3,2)  missetting angles at beginning & end of rotation 
CI    JUMPAX       reciprocal axis closest to principle goniostat axis E1
C                       (only used for printing)
CI    NCRYST       crystal number: a crystal may contain several batches
CI    LBSETID      dataset number (this indexes a list of datasets in the
C                  file header)
CI    LCRFLG       type of crystal mosaicity information
C                  (=0 for isotropic, =1 anisotropic)
C     *** CRYDAT(12) equivalenced to following ***
CR    ETAD         reflection width (full width) (degrees)  (if LCRFLG=0)
C      or
CR    ETADH,ETADV  horizontal & vertical reflection width   (if LCRFLG=1)
CR    rest of CRYDAT: padding for crystal information (eg more complicated
C                           mosaicity model)
C     ***
C     
C---  Information for this batch
C
CI    LDTYPE       type of data
C                   = 1    oscillation data   (2D spots)
C                   = 2    area detector data (3D spots)
C                   = 3    Laue data
CR    DATUM(3)     datum values of goniostat axes, from which Phi is measured
C                      (degrees)
CR    PHISTT,PHIEND start & stop values of Phi (degrees) relative to datum
CR    PHIRANGE     range of Phi values: typically this will be PHIEND-PHISTT,
C                    but storing this explicitly allows a distinction 
C                    eg between a rotation of +160 degrees from a rotation
C                    of -200 degrees
CI    JSCAXS       goniostat scan axis number (=1,2,3, or =0 for
C                        multiple axis scan
CR    SCANAX(3)    rotation axis in laboratory frame (not yet implemented:
C                      only relevant if JSCAXS=0)
CR    TIME1, TIME2 start & stop times in minutes
CI    NBSCAL       number of batch scales & Bfactors plus SD's
C                   (4 at present, BSCALE, BBFAC & sd's)
C                  set = 0 if batch scales unset
CR    BSCALE       batch scale
CR    BBFAC        batch temperature factor
C                   corresponding scale is exp(-2 B (sin theta/lambda)**2)
CR    SDBSCL       sd (Bscale)
CR    SDBFAC       sd (BBfac)
CR    BATPAD(11)   padding for batch information
C     
C---  Crystal goniostat information
C     
CI    NGONAX       number of goniostat axes (normally 1 or 3)
CI    E1(3),E2(3),E3(3) vectors (in "Cambridge" laboratory frame, see below)
C                            defining the NGONAX goniostat axes
CC    GONLAB(3)  names of the three goniostat axes
CR    GONPAD(12) padding for goniostat information
C     
C---  Beam information
C     
CR    SOURCE(3)    Idealized (ie excluding tilts) source vector 
C                   (antiparallel to beam), in "Cambridge" laboratory frame
CR    S0(3)        Source vector (antiparallel ! to beam), in
C                   "Cambridge" laboratory frame, including tilts
CI    LBMFLG       flag for type of beam information following 
C                   = 0 for ALAMBD, DELAMB only (laboratory source)
C                   = 1     ALAMBD,DELAMB,DELCOR,DIVHD,DIVVD (synchrotron) 
C                           (other options could include white beam)
C     *** BEMDAT(25) equivalenced to following ***
CR    ALAMBD       Wavelength in Angstroms
CR    DELAMB       dispersion Deltalambda / lambda.
CR    DELCOR       Correlated component of wavelength dispersion.
CR    DIVHD        Horizontal beam divergence in degrees.
CR    DIVVD        Vertical beam divergence (may be 0.0 for isotropic beam
C                        divergence.
CR    rest of BEMDAT: padding for beam information
C                      (*** How much here for Laue? ***)
C     ***
C     
C---  Detector information
C     
CI    NDET         number of detectors (current maximum 2)
C     -- for each detector
CR    DXn          crystal to detector distance (mm)
CR    THETAn       detector tilt angle (=Madnes:tau2) (degrees)
CR    DETLMn(2,2)  minimum & maximum values of detector coordinates (pixels)
C                     (i,j): i = 1 minimum, = 2 maximum
C                            j = 1 Ydet,    = 2 Zdet
CR    DETPAD(34)     padding for detector information
C     
C     
C Lengths: MBLENG is total length of block
C     ..
C     .. Common blocks ..
      INTEGER NWORDS,NINTGR,NREALS,IORTYP,LBCELL,MISFLG,
     .     JUMPAX,NCRYST,LCRFLG,LDTYPE,JSCAXS,NBSCAL,NGONAX,LBMFLG,
     +     NDET,LBSETID,INTPAD
      REAL   CELL,UMAT,PHIXYZ,CRYDAT,ETAD,DATUM,
     +     PHISTT,PHIEND,PHIRANGE,SCANAX,TIME1,TIME2,
     +     BSCALE,BBFAC,SDBSCL,SDBFAC,BATPAD,E1,E2,E3,GONPAD,
     +     SOURCE,S0,BEMDAT,ALAMBD,DELAMB,DELCOR,DIVHD,DIVVD,
     +     DX1,THETA1,DETLM1,DX2,THETA2,DETLM2,DETPAD,ETADH,ETADV
      CHARACTER BTITLE*70, GONLAB*8
C     
      COMMON /MTZTONA4_CBTHDR/BTITLE,GONLAB(3)
C     
      COMMON /MTZTONA4_MBTHDR/ NWORDS,NINTGR,NREALS,IORTYP,LBCELL(6),
     .     MISFLG,JUMPAX,NCRYST,LCRFLG,LDTYPE,JSCAXS,NBSCAL,NGONAX,
     +     LBMFLG,NDET,LBSETID,INTPAD(8),
     +     CELL(6),UMAT(3,3),PHIXYZ(3,2),CRYDAT(12),DATUM(3),
     +     PHISTT,PHIEND,SCANAX(3),TIME1,TIME2,
     +     BSCALE,BBFAC,SDBSCL,SDBFAC,PHIRANGE,BATPAD(11),
     +     E1(3),E2(3),E3(3),
     +     GONPAD(12),SOURCE(3),S0(3),BEMDAT(25),
     +     DX1,THETA1,DETLM1(2,2),DX2,THETA2,DETLM2(2,2),DETPAD(33)
C     
C     *** Note well the following equivalences: these are to allow for
C     alternative definitions of crystal mosaicity, beam parameters, etc
      EQUIVALENCE (ETAD,CRYDAT(1))
      EQUIVALENCE (ETADH,CRYDAT(1)),(ETADV,CRYDAT(2))
      EQUIVALENCE (BEMDAT(1),ALAMBD)
      EQUIVALENCE (BEMDAT(2),DELAMB)
      EQUIVALENCE (BEMDAT(3),DELCOR)
      EQUIVALENCE (BEMDAT(4),DIVHD)
      EQUIVALENCE (BEMDAT(5),DIVVD)
C ***
C This equivalence is strictly for convenience in printing
      REAL E123(3,3)
      EQUIVALENCE (E123(1,1),E1(1))
C     ..
C
C Save it
      SAVE /MTZTONA4_CBTHDR/,/MTZTONA4_MBTHDR/
C
C     .. Parameters ..
      INTEGER MXLLEN,MXLLIN
      PARAMETER (MXLLEN=80,MXLLIN=50)
C     ..                                                     
C     .. Scalar Arguments ..
      INTEGER IBATCH,IPRINT
C     ..
C     .. Local Scalars ..
      INTEGER I,J
      CHARACTER BAXIS*4,STROUT*100
C     ..
C     .. Local Arrays ..
      CHARACTER AXES(4)*4,LINES(MXLLIN)*(MXLLEN),SOMELN(MXLLIN)*(MXLLEN)
      CHARACTER*25 LABTYP(0:3)
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      INTEGER MNEXTLN
      EXTERNAL BLANK,PUTLIN,MNEXTLN,MADDLIN
C     ..
C     ..
C     .. Data statements ..
      DATA AXES/'none','a*','b*','c*'/
C Types of data
      DATA LABTYP/'*** unknown data type ***','oscillation data',
     +     'area detector data','Laue data'/
C     ..
C     
C     
C---- Check IPRINT is OK
C     
      IF (IPRINT.EQ.0) RETURN
C                      ======
C     
      BAXIS = ' '
C     
C     
      BAXIS = AXES(JUMPAX+1)
C     
C---- Print batch number and title for all
C     
      IF (IPRINT.GT.30) THEN
        WRITE (IPRINT,FMT='(A)') ' Batch number: '
C
      ELSE
C     
C            ***********************
        CALL PUTLIN(' Batch number: ','CURWIN')
C            ***********************
C
      END IF
C
      STROUT = ' '
      WRITE (STROUT,FMT='(1X,I6,4X,A)') IBATCH,BTITLE
C
      IF (IPRINT.GT.30) THEN
        WRITE (IPRINT,FMT='(A)') STROUT(1:MIN(130,LENSTR(STROUT)))
C
      ELSE
C     
C            ***********************
        CALL PUTLIN(STROUT,'CURWIN')
C            ***********************
C
      END IF
C
      IF (IPRINT.EQ.1) RETURN
C                      ======
C     
C---- Clear LINES arrays
C     
      DO 10 I = 1,MXLLIN
        LINES(I) = ' '
        SOMELN(I) = ' '
 10   CONTINUE
C     
C     
C *** Print it all here
C
C---- Set type of data = 0 if invalid number
C
      J = LDTYPE
      IF (J .LT. 1 .OR. J .GT. 3) J=0
C
      WRITE (SOMELN, FMT=6000) 
     +    IBATCH,LABTYP(J),NCRYST,LBSETID,CELL,LBCELL
C
      IF (IPRINT.GT.30) WRITE (IPRINT,FMT=6000) 
     +    IBATCH,LABTYP(J),NCRYST,LBSETID,CELL,LBCELL
C
      CALL MADDLIN(SOMELN,LINES,MXLLIN)
C
      IF (MISFLG .EQ. 0) THEN
        WRITE (SOMELN, FMT=6005) UMAT
C
        IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6005) UMAT
C
        CALL MADDLIN(SOMELN,LINES,MXLLIN)
C
      ELSEIF (MISFLG .GT. 0) THEN
C
        WRITE (SOMELN, FMT=6006) UMAT
C
        IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6006) UMAT
C
        CALL MADDLIN(SOMELN,LINES,MXLLIN)
        WRITE (SOMELN, FMT=6010) ((PHIXYZ(I,J),I=1,3),J=1,MISFLG)
C
        IF (IPRINT.GT.30) 
     +     WRITE (IPRINT, FMT=6010) ((PHIXYZ(I,J),I=1,3),J=1,MISFLG)
C
         CALL MADDLIN(SOMELN,LINES,MXLLIN)
      ENDIF
C
      WRITE (SOMELN, FMT=6020) GONLAB(1),BAXIS
C
      IF (IPRINT.GT.30) 
     +  WRITE (IPRINT, FMT=6020) GONLAB(1),BAXIS
C
      CALL MADDLIN(SOMELN,LINES,MXLLIN)
C
      IF (LCRFLG .EQ. 0) THEN
C
C---- Isotropic mosaicity
C
        WRITE (SOMELN, FMT=6030) ETAD
C
        IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6030) ETAD
C
        CALL MADDLIN(SOMELN,LINES,MXLLIN)
C
      ELSEIF (LCRFLG .EQ. 1) THEN
C
C---- Anisotropic mosaicity
C
        WRITE (SOMELN, FMT=6035) ETADH,ETADV
C
        IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6035) ETADH,ETADV
C
        CALL MADDLIN(SOMELN,LINES,MXLLIN)
      END IF
      WRITE (SOMELN, FMT=6040) (DATUM(I),I=1,NGONAX)
C
      IF (IPRINT.GT.30) 
     +    WRITE (IPRINT, FMT=6040) (DATUM(I),I=1,NGONAX)
C
      CALL MADDLIN(SOMELN,LINES,MXLLIN)
C
      IF (JSCAXS .GT. 0 .AND. JSCAXS .LE. NGONAX) THEN
        WRITE (SOMELN, FMT=6050) GONLAB(JSCAXS)
C
        IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6050) GONLAB(JSCAXS)
C
        CALL MADDLIN(SOMELN,LINES,MXLLIN)
      ENDIF
C
      WRITE (SOMELN, FMT=6060) PHISTT,PHIEND,PHIRANGE,TIME1,TIME2
C
      IF (IPRINT.GT.30) 
     +    WRITE (IPRINT, FMT=6060) PHISTT,PHIEND,PHIRANGE,TIME1,TIME2
C
      CALL MADDLIN(SOMELN,LINES,MXLLIN)
C
C---- Batch scale factors (if set)
C
      IF (NBSCAL .GT. 0) THEN
        IF (NBSCAL .EQ. 4) THEN
          WRITE (SOMELN, 6065) BSCALE,SDBSCL,BBFAC,SDBFAC 
          IF (IPRINT.GT.30) 
     +            WRITE (IPRINT, 6065) BSCALE,SDBSCL,BBFAC,SDBFAC 
          CALL MADDLIN(SOMELN,LINES,MXLLIN)
        ENDIF
      ENDIF
C
      WRITE (SOMELN, FMT=6070) NGONAX,
     +     (GONLAB(J),(E123(I,J),I=1,3),J=1,3)
C
      IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6070) NGONAX,
     +     (GONLAB(J),(E123(I,J),I=1,3),J=1,3)
C
      CALL MADDLIN(SOMELN,LINES,MXLLIN)
      WRITE (SOMELN, FMT=6080) SOURCE,S0
      IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6080) SOURCE,S0
      CALL MADDLIN(SOMELN,LINES,MXLLIN)
C
      IF (LBMFLG .EQ. 0) THEN
C
C---- Monochromatic (laboratory) beam
C
        WRITE (SOMELN, FMT=6090) ALAMBD,DELAMB
C
        IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6090)  ALAMBD,DELAMB
C
        CALL MADDLIN(SOMELN,LINES,MXLLIN)
C
      ELSEIF (LBMFLG .EQ. 1) THEN
C
C---- Monochromatic (synchrotron) beam
C
        WRITE (SOMELN, FMT=6095) ALAMBD,DELAMB,DELCOR,DIVHD,DIVVD
        IF (IPRINT.GT.30)
     +     WRITE (IPRINT, FMT=6095) ALAMBD,DELAMB,DELCOR,DIVHD,DIVVD
        CALL MADDLIN(SOMELN,LINES,MXLLIN)
      END IF
C
      WRITE (SOMELN, FMT=6100) NDET
      IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6100) NDET
      CALL MADDLIN(SOMELN,LINES,MXLLIN)
      WRITE (SOMELN, FMT=6110) DX1, THETA1, DETLM1
      IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6110) DX1, THETA1, DETLM1
      CALL MADDLIN(SOMELN,LINES,MXLLIN)
C
      WRITE (SOMELN, FMT=6120)
      IF (IPRINT.GT.30) WRITE (IPRINT, FMT=6120)
      CALL MADDLIN(SOMELN,LINES,MXLLIN)
C
 6000 FORMAT(/1X,19('++++')//
     * ' Orientation data for batch',I8,5X,A//
     . '   Crystal number ...................',I7/
     . '   Associated dataset ID ............',I7/
     . '   Cell dimensions ..................',6F7.2/
     . '   Cell fix flags ...................',6I7)
 6005 FORMAT(
     . '   Orientation matrix U .............',3F10.4/
     . '       (including setting angles)    ',3F10.4/
     .   37X,3F10.4)
 6006 FORMAT(
     . '   Standard orientation matrix U ....',3F10.4,
     .   2(/37X,3F10.4))
 6010 FORMAT(
     . '   Missetting angles PhiX PhiY PhiZ..',6F7.2)
 6020 FORMAT(
     . '   Reciprocal axis nearest ',A8,'..',3X,A4)
 6030 FORMAT(
     . '   Mosaicity ........................',F7.3)
 6035 FORMAT(
     . '   Mosaicity (horizontal, vertical)..',2F7.3)
 6040 FORMAT(
     . '   Datum goniostat angles (degrees)..',F8.3,2F9.3)
 6050 FORMAT(
     . '   Scan axis ........................',2X,A8)
 6060 FORMAT(
     . '   Start & stop Phi angles (degrees).',2F9.3/
     . '   Range of Phi angles (degrees).....',F9.3/
     . '   Start & stop time (minutes).......',2F9.2)
 6065 FORMAT(
     + '   Batch scale & SD .................',2F9.4/
     + '   Batch B-factor & SD ..............',2F9.4)
 6070 FORMAT(
     . ' Crystal goniostat information :-'/
     . '   Number of goniostat axes..........',I7/
     . '   Goniostat vectors.....',A8,'....',3F9.4/
     . '                    .....',A8,'....',3F9.4/
     . '                    .....',A8,'....',3F9.4)
 6080 FORMAT(
     . ' Beam information :-'/
     . '   Idealized X-ray beam vector.......',3F9.4/
     . '   X-ray beam vector with tilts......',3F9.4)
 6090 FORMAT(
     . '   Wavelength and dispersion ........',2F9.5)
 6095 FORMAT(
     . '   Wavelength and dispersion ........',3F9.5/
     . '   Divergence .......................',2F7.3)
 6100 FORMAT(
     . ' Detector information :-'/
     . '   Number of detectors...............',I7)
 6110 FORMAT(
     . '   Crystal to Detector distance (mm).',F9.3/
     . '   Detector swing angle..............',F9.3/
     . '   Pixel limits on detector..........',4F7.1/)
 6120 FORMAT(1X,19('++++')/)
C
C---- Return if IPRINT.gt. 30
C
      IF (IPRINT.GT.30) RETURN
C
C---- Find out how many lines
C
      J = MNEXTLN(LINES,MXLLIN) - 1
      IF (J .LE. 0) RETURN
C                   ======
C     
C     
      DO 40 I = 1,J
C     
C            ***********************
        CALL PUTLIN(LINES(I),'CURWIN')
C            ***********************
C     
 40   CONTINUE
C     
C          *****************
      CALL BLANK('CURWIN',1)
C          *****************
C     
      RETURN
      END 
C
C     ======================================
      SUBROUTINE MADDLIN(NEWLIN,LINES,MAXLIN)
C     ======================================
C
C---- Add newlines from NEWLIN to array LINES
C
C     Input:  NEWLIN(MAXLIN) character array
C
C     Output: LINES(MAXLIN)  character array
C             NEWLIN   cleared on output
C
      INTEGER MAXLIN
      CHARACTER*(*) NEWLIN(MAXLIN),LINES(MAXLIN)
C
      INTEGER I, N, M
C
      INTEGER MNEXTLN
      EXTERNAL MNEXTLN
C
C Get number of lines to add
      N = MNEXTLN(NEWLIN,MAXLIN)-1
      IF (N .LE. 0) RETURN
C Get position to put first line
      M = MAX(1,MNEXTLN(LINES,MAXLIN))
C
      DO 10, I = 1, N
         LINES(M) = NEWLIN(I)
         M = M+1
         NEWLIN(I) = ' '
 10   CONTINUE
      END
C
C     =====================================
      INTEGER FUNCTION MNEXTLN(LINES,MAXLIN)
C     =====================================
C
C---- Find next blank line in character array LINES
C
C     Input: LINES(MAXLIN)  character array
C
C     Returns: MNEXTLN       number of next blank line (= -1 if full)
C
      INTEGER MAXLIN
      CHARACTER*(*) LINES(MAXLIN)
C
      INTEGER I
C
      DO 10, I = MAXLIN,1,-1
         IF (LINES(I) .NE. ' ') THEN
            MNEXTLN = I+1
            RETURN
         END IF
 10   CONTINUE 
C Array full
      MNEXTLN = -1
      END
C
      SUBROUTINE CVR4A4(RANGE, INDXR4)
C
C==== Machine-independent routine to get indices for REAL*4 <--> CHARACTER*4
C==== conversions.
C
C==== REAL array argument    :  Minimum and maximum values of series of
C==== REALs to be converted.
C
C==== INTEGER array argument :  Indices for use by A4REAL and REALA4.
C
C==== Ian Tickle, Birkbeck.
C
C
      INTEGER INDXR4(2)
      REAL RANGE(2)
      INTEGER I, J, N
      REAL A, P
C
      IF (RANGE(1).EQ.0. .AND. RANGE(2).EQ.0.) THEN
        INDXR4(1) = 0
        INDXR4(2) = 999
      ELSE
        A = MAX(ABS(RANGE(1)),ABS(RANGE(2)))
        P = 24. - LOG(DBLE(A))/LOG(2.D0)
        IF (P.LE.0.) THEN
          I = P - 1.
        ELSE
          I = P
        ENDIF
C
        N = A * 2.**I
        IF (N.LT.2**23) THEN
          I = I + 1
        ELSEIF (N.GE.2**24) THEN
          I = I - 1
        ENDIF
C
        N = 0
        DO 10 J = 1, 2
          IF (RANGE(J).LT.0.) THEN
            N = N - 1
          ELSEIF (RANGE(J).GT.0.) THEN
            N = N + 1
          ENDIF
10      CONTINUE
C
        INDXR4(1) = N
        IF (N.EQ.0) THEN
          INDXR4(2) = I - 1
        ELSE
          INDXR4(2) = I
        ENDIF
      ENDIF
      END
C
C
      CHARACTER*4 FUNCTION A4REAL(INDXR4, RVAL)
C
C
C==== Machine-independent routine for REAL*4 --> CHARACTER*4 conversion.
C
C==== INTEGER array argument :  Indices from INDXR4 function call.
C
C==== REAL argument          :  REAL value to be converted.
C
C==== CHARACTER*4 return     :  Converted string.
C====                         A ???? string returned indicates overflow;
C====                         this will happen if the absolute value of
C====                         the REAL falls outside the range specified
C====                         in the call to INDXR4.
C
      INTEGER INDXR4(2)
      REAL RVAL
      CHARACTER*64 CHRTAB
      INTEGER I, J, M, N
      LOGICAL QISNAN
C
C     .. Common blocks ..
      LOGICAL NAN_FOUND
      COMMON /NANTEST/ NAN_FOUND

      DATA CHRTAB/
     &'0123456789-+ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'
     &/
C
C==== First convert REAL to INTEGER in the range 0 to 2**24-1.
C==== Negative numbers are converted to 2's complement.
C
      IF (QISNAN(RVAL)) THEN
        A4REAL = '....'
        NAN_FOUND = .TRUE.
      ELSEIF (RVAL.EQ.0.) THEN
        A4REAL = '0000'
      ELSEIF (INDXR4(2).EQ.999) THEN
        A4REAL = '????'
      ELSEIF (INDXR4(1).NE.0 .AND.
     &        (ISIGN(1, INDXR4(1)).NE.SIGN(1., RVAL))) THEN
        A4REAL = '????'
      ELSE
        N = NINT(ABS(RVAL) * 2.**INDXR4(2))
        IF (INDXR4(1).EQ.0) THEN
          M = 2**23
        ELSE
          M = 2**24
        ENDIF
        IF (N.EQ.M) THEN
          N = M - 1
        ELSEIF (N.GT.M) THEN
          A4REAL = '????'
          RETURN
        ENDIF
C
        IF (INDXR4(1).EQ.0 .AND. RVAL.LT.0.) N = 2**24 - N
C
C==== Then convert INTEGER to CHAR*4 using 64-character translation table.
C
        DO 10 I = 4, 1, -1
          M = N/64
          J = N - 64*M + 1
          A4REAL(I:I) = CHRTAB(J:J)
10        N = M
      ENDIF
      END
C
C
      SUBROUTINE RLENA4(L, A)
C==== Run-length encode "NA4" format.
      CHARACTER A*(*), CHRTAB*64
      LOGICAL FNAN
      INTEGER I, K, L, M, N
      DATA CHRTAB/
     &'0123456789-+ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'
     &/
      N = L
      K = -4
      L = 0
      M = 0
      DO 10 I = 1, N
        IF (A(I:I).EQ.'0') K = K + 1
        IF (MOD(I,4).EQ.1 .AND. I+3.LE.N) THEN
          IF (A(I:I+3).EQ.'????') A(I:I+3)='....'
          FNAN = A(I:I+3).EQ.'....'
          IF (FNAN) M = M + 1
        ENDIF
C
        IF (((A(I:I).NE.'0' .OR. I.EQ.N) .AND. K.GT.-4) .OR. K.EQ.64)
     &  THEN
          IF (K.LE.0) THEN
            L = L + 1
            IF (L.LT.I-1) THEN
              IF (K.EQ.-3) THEN
                A(L:L) = '0'
              ELSE
                A(L:L) = '%'
                IF (K.GT.-2) THEN
                  L=L+1
                  IF (K.LT.0) THEN
                    A(L:L) = '0'
                  ELSE
                    A(L:L) = '%'
                  ENDIF
                ENDIF
              ENDIF
            ENDIF
          ELSE
            L = L + 1
            A(L:L) = '*'
            L = L + 1
            A(L:L) = CHRTAB(K:K)
          ENDIF
          K = -4
        ELSEIF (((.NOT.FNAN .OR. I.EQ.N) .AND. M.GT.0) .OR. M.EQ.64)
     &  THEN
          L = L + 1
          A(L:L) = '.'
          L = L + 1
          A(L:L) = CHRTAB(M:M)
          M = 0
        ENDIF
C
        IF (A(I:I).NE.'0' .AND. .NOT.FNAN) THEN
          L = L + 1
          IF (L.LT.I) A(L:L) = A(I:I)
        ENDIF
10    CONTINUE
      END
