C
C     PHISTATS
C     Copyright (C) 1995 Eleanor Dodson
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C       ===============
      PROGRAM PHISTATS
C       ===============
C
C----  Phase analysis between two sets of weighted phases.
C        (EJD  August 1988)
C        option 4 calls sr phase analysis only which will give
C        statistics for  Phase agreement between two phase sets.
C
C    - REMEMBER
C      It is better to do map Correlation!!!!  using OVERLAPMAP
C
C     .. External Subroutines ..
      EXTERNAL CCPERR, CCPFYP, CCPRCS, LRCLOS, MTZINI,
     +         PHANAL, RCARDS
C     ..
C     .. Common blocks ..
      COMMON /CNTROL/NBIN, ST2MIN, DELST2, NPS, MIR2, IOPT, SMAX, IERR,
     +       SMIN, SMINCB, SMAXCB
      COMMON /IO/ISYSR, ISYSW, NCOL, CONV, NMON
      COMMON /TABS/NSTEP, ARGMAX, DLIM
      REAL ARGMAX, CONV, DELST2, SMAX, SMAXCB, SMIN, SMINCB, ST2MIN
      INTEGER IERR, IOPT, ISYSR, ISYSW, MIR2, NBIN, NCOL,
     +        NMON, NPS, NSTEP
      REAL DLIM(51)
C     ..
C
      CALL CCPFYP
      CALL CCPRCS(6, 'PHISTATS', '$Date: 2005/09/06 11:25:21 $')
      CALL MTZINI
      WRITE (6, FMT=9000)
 9000 FORMAT (//,
     +       ' Phase analysis between two phase sets - Better to do map'
     +       , ' Correlation!!', /)
C
      NSTEP = 120
      CONV = 3.14159/180.0
C
C---- Read input and control cards.
C
      CALL RCARDS
C
      CALL PHANAL
C
C---- Close input and output MTZ files.
C
      CALL LRCLOS(1)
      CALL CCPERR(0, 'Normal termination')
C     
      END
C
C     =================
      SUBROUTINE RCARDS
C     =================
C
C     .. Parameters ..
      INTEGER MCOLS
      PARAMETER (MCOLS=500,MaxSets=50)
      INTEGER NPAR
      PARAMETER (NPAR=200)
C     ..
C     .. Local Scalars ..
      REAL RMAX, RMIN, STMAX, STMIN, STOL2
      INTEGER I, IFAIL, ITOK, LDUM, MTZPRT,
     +        NBIN1, NLPRGI, NMULT, NSMP, NSPGRP, NSYMP, NTOK
      LOGICAL LEND
      CHARACTER LTYPE
      CHARACTER*4 KEY
      CHARACTER*10 NAMSPG, PGNAME
      CHARACTER*80 TITLE
      CHARACTER*600 LINE
C     ..
C     .. Local Arrays ..
      REAL CELL(6), FVALUE(NPAR)
      INTEGER IBEG(NPAR), IDEC(NPAR), IEND(NPAR), ITYP(NPAR),
     +        LOOKUP(MCOLS)
      REAL DATCELL(6,MaxSets),DATWAVE(MaxSets),ranges(2,MCOLS)
      INTEGER ISETS(MaxSets),CSETID(MCOLS),SETID,SET_INDEX
      CHARACTER CTPRGI(MCOLS)
      CHARACTER*10  VERSNX
      CHARACTER PNAME(MaxSets)*64,XNAME(MaxSets)*64,DNAME(MaxSets)*64
      CHARACTER*4 CVALUE(NPAR)
      CHARACTER*30 LSPRGI(MCOLS)
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPDPN, CCPERR, CENTRIC, EPSLN, GTPINT, LKYIN, LRASSN,
     +         LRCELL, LROPEN, LRRSOL, LRSYMI, LRSYMM, PARSER,
     +         RDRESO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS, NINT, REAL, SQRT
C     ..
C     .. Common blocks ..
      COMMON /ATSYM/RSYM, RSYMT, NSYM, PERM, IPRINT, MATOMS, LATOMS, JX,
     +       JY, JZ, LPRINT, LASYM, NSG
      COMMON /CNTROL/NBIN, ST2MIN, DELST2, NPS, MIR2, IOPT, SMAX, IERR,
     +       SMIN, SMINCB, SMAXCB
      COMMON /IO/ISYSR, ISYSW, NCOL, CONV, NMON
      COMMON /POSN/IFO, IFS, IAO, IW, IAO2, IW2,XYZSHIFT,IHAND,CHAND(3),
     +             W1max,W2max
      COMMON /TABSC/TITLE
      COMMON /TABS/NSTEP, ARGMAX, DLIM
      REAL ARGMAX, CONV, DELST2, SMAX, SMAXCB, SMIN, SMINCB, ST2MIN,
     +     XYZSHIFT(3)
      INTEGER IAO, IAO2, IERR, IFO, IFS, IOPT, IPRINT, ISYSR, ISYSW, 
     +        IW, IW2, JX, JY, JZ, LASYM, LATOMS, LPRINT, MATOMS, MIR2, 
     +        NBIN, NCOL, NMON, NPS, NSG, NSTEP, NSYM
      REAL DLIM(51), PERM(4, 4), RSYM(4, 4, 192), RSYMT(4, 4, 192)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA NLPRGI, LSPRGI/9, 'H', 'K', 'L', 'FP', 'SIGFP', 'PHIBP',
     +     'WP', 'PHIB2', 'W2', 491*' '/
C     PHIB2 isn't compulsory -- will get correlation between 2 `weights'
C     if it's not set.
      DATA LOOKUP/7*-1,0,-1, 491*0/
      DATA CTPRGI/'H', 'H', 'H', 'F', 'Q', 'P', 'W', 'P', 'W', 
     .  491*' '/
      DATA TITLE/' '/
C     ..
C
      IOPT = 4
      NBIN = 20
      NPS = 1
      IERR = 0
      NMON = 10000
      ISYSR = 5
      ISYSW = 6
      IFAIL = 0
      SMIN = 0.0
      SMAX = 0.5
      RMAX = 0.0
      SMINCB = -1.0
      SMAXCB = -1.0
      NSMP = 0
      IFO = 0
      IFS = 0
      IAO = 0
      IW = 0
      IAO2 = 0
      IW2 = 0
      W1MAX = 1.0
      W2MAX = 1.0
      XYZSHIFT(1) = 0
      XYZSHIFT(2) = 0
      XYZSHIFT(3) = 0
      IHAND = 0
      CHAND(1) = 0
      CHAND(2) = 0
      CHAND(3) = 0
C
      CALL CCPDPN(ISYSR, 'DATA', 'READONLY', 'F', LDUM, IFAIL)
      CALL CCPDPN(ISYSW, 'PRINTER', 'PRINTER', 'F', LDUM, IFAIL)
C
      SLIM = 0.25
      NSYMB = 6
C----  Loop over possible key-words
   10 CONTINUE
      LINE = ' '
      NTOK = NPAR
C
      CALL PARSER(KEY, LINE, IBEG, IEND, ITYP, FVALUE, CVALUE, IDEC,
     +            NTOK, LEND, .TRUE.)
      IF (LEND .OR. KEY.EQ.'END') GO TO 20
C
C---- TITLE
C
      IF (KEY.EQ.'TITL') THEN
        TITLE = LINE(IBEG(2) :)
C
C---- RESOlution
C     ===========
C
      ELSE IF (KEY.EQ.'RESO') THEN
        ITOK = 2
        CALL RDRESO(ITOK, ITYP, FVALUE, NTOK, RMIN, RMAX, SMIN, SMAX)
        WRITE (ISYSW, FMT=9000) RMIN, RMAX, SMIN, SMAX
 9000   FORMAT (//,'   Resolution limits in As ', 2F10.2, /,11X,
     +         'as  4sinsq/', 'lsq ', 2F10.5, /)
C
C
C---- SHIFt
C     ===========
C
      ELSE IF (KEY.EQ.'SHIF') THEN
        ITOK = 2
        CALL GTPREA(ITOK  ,XYZSHIFT(1),NTOK,ITYP,FVALUE)
        CALL GTPREA(ITOK+1,XYZSHIFT(2),NTOK,ITYP,FVALUE)
        CALL GTPREA(ITOK+2,XYZSHIFT(3),NTOK,ITYP,FVALUE)
        WRITE (ISYSW, FMT=9010) XYZSHIFT
 9010   FORMAT (//,
     +   '   PHI2 phases adjusted to account for fractional Shift:',
     + 3F10.3,/,' PhiDiff is 2PI ( h Xshift +k Yshift + l Zshift)',/)
C
C---- HAND
C     ===========
C
      ELSE IF (KEY.EQ.'HAND') THEN
        IHAND = 1
C
C  RANGes  read number of ranges (bins), monitor interval
C  ======================================================
C
      ELSE IF (KEY.EQ.'RANG') THEN
        CALL GTPINT(2, NBIN, NTOK, ITYP, FVALUE)
        IF (NBIN.GT.50) CALL CCPERR(1,
     +                    'The number of resolution ranges must be <=50'
     +                              )
        IF (NTOK.GT.2) CALL GTPINT(3, NMON, NTOK, ITYP, FVALUE)
C
C   LABI command, read input labels
C   ===============================
C
      ELSE IF (KEY.EQ.'LABI') THEN
        CALL LKYIN(1, LSPRGI, NLPRGI, NTOK, LINE, IBEG, IEND)
      ELSE
        CALL CCPERR(1, 'Unrecognised keyword: '//KEY)
      END IF
      GO TO 10
   20 CONTINUE
C     Move this here - NBIN may be read AFTER reso limits..
      ST2MIN = SMIN/4.0
      DELST2 = (SMAX/4.0-ST2MIN)/NBIN
C
      IF (IOPT.EQ.4) NPS = 0
C
C---- Open MTZ input file, return cell parameters, number of columns
C      and assign column labels.
C
      MTZPRT = 2
      CALL LROPEN(1, 'HKLIN',MTZPRT, IFAIL)
      CALL LRCELL(1, CELL)
      CALL LRASSN(1, LSPRGI, NLPRGI, LOOKUP, CTPRGI)
      CALL LRINFO(1,VERSNX,NCOLS,NREFLX,RANGES)
C
C---- Get dataset info using LRIDX:
C     Notify available space
      NDATASETS = MaxSets
      CALL LRIDX(1,PNAME,XNAME,DNAME,ISETS,
     +                     DATCELL,DATWAVE,NDATASETS)
C
C---- We can only check the datasets if there is dataset
C     information in the mtz file
C
      IF (NDATASETS.GT.0) THEN
C
C---- Get the complete list of labels and types and the
C     datasets to which they belong
C
C
C       ****************************************
        NCOL = MCOLS
        CALL LRCLID(1,CSETID,NCOL)
C       ****************************************
C     Get setid of FP column and use that DATCELL as master 
C     for anisotropic analysis
        SET_INDEX = 0
        SETID = 0
        IF (LOOKUP(4).GT.0) THEN
          SETID = CSETID(LOOKUP(4))
          DO ISET = 1,NDATASETS
            IF (ISETS(ISET).EQ.SETID) THEN
              SET_INDEX = ISET
            END IF
          ENDDO
        ENDIF
C     Set output dataset and correct choice of cell
        IF (SET_INDEX.GT.0) THEN
          DO I=1,6
            CELL(I) = DATCELL(I,SET_INDEX)
          ENDDO
        ENDIF
      ENDIF
C
      IF (RMAX.EQ.0.0) THEN
        CALL LRRSOL(1, SMIN, SMAX)
        ST2MIN = SMIN/4.0
        DELST2 = (SMAX/4.0-ST2MIN)/NBIN
      END IF
C
      ST2MIN = SMIN/4.0
      DELST2 = (SMAX/4.0-ST2MIN)/NBIN
      NBIN1 = NBIN + 1
C
C  Default resolution limits for phase combination equal to overall limits
      IF (SMINCB.LT.0.0) THEN
        SMINCB = SMIN
      END IF
      IF (SMAXCB.LT.0.0) THEN
        SMAXCB = SMAX
      END IF
C
      DO 30 I = 1, NBIN1
        STOL2 = REAL(I-1)*DELST2 + ST2MIN
        IF (STOL2.GT.0.0) DLIM(I) = 0.5/SQRT(STOL2)
        IF (STOL2.LE.0.0 .OR. DLIM(I).GT.1000.0) DLIM(I) = 999.99
   30 CONTINUE
C
C---- To get back to Randy's form
C
      STMIN = SQRT(ABS(ST2MIN))
      STMAX = SQRT(ABS(SMAX/4.0))
      WRITE (ISYSW, FMT=9020) STMIN, STMAX, NBIN
 9020 FORMAT (/,' Data from sin(theta)/lambda of', F8.4, ' to', F8.4,
     +       ' divided into', I4, ' ranges')
C
      CALL LRSYMI(1, NSYMP, LTYPE, NSPGRP, NAMSPG, PGNAME)
      IF (NSMP.GT.0 .AND. NSYMP.NE.NSMP) CALL CCPERR(1,
     +    'Disagreement between symmetry operators')
      CALL LRSYMM(1, NSYM, RSYM)
      NMULT = NSYM/NSYMP
      WRITE (ISYSW, FMT=9030) NMULT
 9030 FORMAT (/,'  Lattice multiplicity', I6)
C
         IF(IHAND.NE.0) THEN
          CALL HANDCHANGE(NSPGRP,CHAND(1),CHAND(2),CHAND(3))
          WRITE (ISYSW, FMT=9012) CHAND
         END IF
 9012   FORMAT (//,
     +   '   PHI2 phases adjusted to account for change of hand:',
     + 3F10.3,/,' Phi is -PHI+2PI ( h CX +k CY + l CZ)',/)
C---- Now I can work out centricity and epsilon classes
C
      CALL CENTRIC(NSYM, RSYM, IPRINT)
      CALL EPSLN(NSYM, NSYMP, RSYM, IPRINT)
C
      IFO = LOOKUP(4)
      IFS = LOOKUP(5)
      IAO = LOOKUP(6)
      IW = LOOKUP(7)
      IAO2 = LOOKUP(8)
      IW2 = LOOKUP(9)
       IF(RANGES(2,LOOKUP(7)).Gt.1.0) W1MAX = RANGES(2,LOOKUP(7))
       IF(RANGES(2,LOOKUP(9)).Gt.1.0) W2MAX = RANGES(2,LOOKUP(9))
C
      END

C     =================
      SUBROUTINE PHANAL
C     =================
C
C     PHASE ANALYSIS PROGRAM _ VERY OLD. 31-8-88
C
C---- Combine phases (0 to 3 partial structures and 0 or 1
C     set of hendrickson-lattman coefficients for non-structural
C     phase information), compute map coefficients to minimize
C     model bias (explained in s/r unbias), and generate an even
C     more excessive quantity of statistics.
C
C---- Initialize reflection indices to something lower than
C     lowest possible.
C
C Ejd - add correlation calculation as well
C     ******************************************************************
C     **                    ave(X*Y) - ave(X)*ave(Y)
C     * corr. coeff.= -------------------------------------------------
C     **           SQRT(ave(X**2)-ave(X)**2)*SQRT(ave(Y**2)-ave(Y)**2)
C     ******************************************************************
C
C Ejd - If IAO2  = 0   Do correlation between ADATA(IAO) and " Weights"
C
C     .. Parameters ..
      INTEGER NBIN, NBINW1, NBINW2
      PARAMETER (NBIN=20, NBINW1=20, NBINW2=20)
      INTEGER MCOLS
      PARAMETER (MCOLS=500)
C     ..
C     .. Local Scalars ..
      REAL AO, AO2, AVEPSN, CCORW1, CCORW2, CEPSLN, CORW1, CORW2, COSAA,
     +     DSQ1, DSQ2, EPSI, ERROR, FO, PERCNT, R1, R2, SINAA,
     +     SSQ, STEP, STOL2, TWOPI, WIR, WIR2
      INTEGER I, IC, ICHECK, IEPSLN, II, ISYSAB, ITOT, J, K, 
     +        NREF, NS, NW1, NW2
      LOGICAL EOF
C     ..
C     .. Local Arrays ..
      REAL ADATA(MCOLS), CCEPS(2, NBIN+1), CCEPSQ(2, NBIN+1),
     +     CCEPSW(2, NBIN+1), CCEPW2(2, NBIN+1), CEPS(2, NBIN+1),
     +     CEPSQ(2, NBIN+1), CEPSW(2, NBIN+1), CEPSW2(2, NBIN+1),
     +     CW(2, NBIN+1), CW2(2, NBIN+1), CW2SQ(2, NBIN+1),
     +     CWSQ(2, NBIN+1)
      INTEGER IACMN(NBINW1+1, NBINW2+1, NBIN+1),
     +        ICMN(NBINW1+1, NBINW2+1, NBIN+1), IH(3),
     +        NACNT(NBINW1+1, NBINW2+1, NBIN+1),
     +        NCOUNT(2, NBINW1+1, NBINW2+1, NBIN+1)
      LOGICAL LOGMSS(MCOLS)
      CHARACTER TITLE*80
C     ..
C     .. External Subroutines ..
      EXTERNAL CENTR, EPSLON, LRREFL, LRREFM
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS, ATAN2, COS, INT, MOD, NINT, REAL, SQRT
C     ..
C     .. Common blocks ..
      COMMON /CNTROL/NBINS, ST2MIN, DELST2, NPS, MIR2, IOPT, SMAX, IERR,
     +       SMIN, SMINCB, SMAXCB
      COMMON /IO/ISYSR, ISYSW, NCOL, CONV, NMON
      COMMON /POSN/IFO, IFS, IAO, IW, IAO2, IW2,XYZSHIFT,IHAND,CHAND(3),
     +             W1max,W2max
      COMMON /TABSC/TITLE
      REAL CONV, DELST2, SMAX, SMAXCB, SMIN, SMINCB, ST2MIN,
     +     XYZSHIFT(3)
      INTEGER IAO, IAO2, IERR, IFO, IFS, IOPT, ISYSR, ISYSW, IW, 
     +IW2, MIR2, NBINS, NCOL, NMON, NPS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA TWOPI/6.283185/
C     ..
C
      SMAX = 4.0*DELST2*NBINS + 4.0*ST2MIN
      NREF = 0
      IF (IAO2.EQ.0)  WRITE(ISYSW,'(//,A,/,A,A)')
     + ' * The program is now equating W2 to the phase difference. *',
     +    ' Most of the output is therefore junk, but you CAN ',
     +    'extract the correlation between WP and W2.'

      WRITE(ISYSW,'(//)')
      WRITE(ISYSW,'(A,F8.3,/,A,F8.3)') ' Maximum first weight',W1MAX,
     +      ' Maximum second weight',W2MAX
      WRITE(ISYSW,'(//)')
      IF (NMON .GT. 0) THEN
        WRITE(ISYSW,'(A,I6,A)') ' Monitor every ',NMON,'th reflections'
        WRITE(ISYSW,9000)
      ENDIF
 9000 FORMAT(
     + '   No.   H   K   L      FO   PHI1   W1/W1MAx   PHI2   W2/W2MAx')
   10 CONTINUE
C
      CALL LRREFL(1, SSQ, ADATA, EOF)
      IF (EOF) GO TO 20
      CALL LRREFM(1, LOGMSS)
C
C---- Check sd(f) and resolution limits
C

        IF(LOGMSS(IFS) .OR.LOGMSS(IFO)
     + .OR.LOGMSS(IAO) .OR.LOGMSS(IW)
     + .OR.LOGMSS(IAO2).OR.LOGMSS(IW2) ) Go to 10
C      IF (.NOT. LOGMSS(IFS) ) THEN
          IF ( ADATA(IFS) .GT. 0.00001 
     +    .AND. SSQ.LE.SMAX .AND. SSQ.GE.SMIN) THEN
          NREF = NREF + 1
C
          IH(1) = NINT(ADATA(1))
          IH(2) = NINT(ADATA(2))
          IH(3) = NINT(ADATA(3))
          STOL2 = SSQ/4.0
          NS = INT((STOL2-ST2MIN)/DELST2) + 1
          IF (NS.LT.1) NS = 1
          IF (NS.GT.NBINS) NS = NBINS
C
          FO = 1.0
          AO = 0.0
          WIR= 0.0
          AO = ADATA(IAO)
          FO = ADATA(IFO)
           WIR = ADATA(IW)/W1MAX
C
          CALL EPSLON(IH, EPSI, ISYSAB)
          CALL CENTR(IH, IC)
C

          WIR2 = 1.0
          IF (IW2.GT.0) WIR2 = ADATA(IW2)/W2MAX
          AO2 = 0.0
          IF (IAO2.GT.0) THEN
          AO2 = ADATA(IAO2)
           DELPHI = (IH(1)*XYZSHIFT(1) + IH(2)*XYZSHIFT(2) 
     +                  +IH(3)*XYZSHIFT(3) + 1000000.0)
           DELPHI = DELPHI - INT(DELPHI)
           AO2 = MOD( (ADATA(IAO2) + 360.0*DELPHI),360.0 )
             IF(IHAND.NE.0) THEN
               DELPHI = IH(1)*CHAND(1)+IH(2)*CHAND(2)+IH(3)*CHAND(3)+
     +                  1000000.0
                DELPHI = DELPHI - INT(DELPHI)
                AO2 = MOD( -AO2 + 360.0*DELPHI+720.0,360.0 )
             END IF
          END IF 
C
C---- Monitor refls.
C
          IF (NMON .GT. 0) THEN

            IF (MOD(NREF,NMON) .EQ. 1) 
     +              WRITE(ISYSW,'(I6,3I4,F9.2,2(F6.1,F6.3),f6.3)')
     +                           NREF,IH,FO,AO,WIR,AO2,WIR2
          ENDIF
C
          IF (ABS(WIR).GT.0.00 .AND. ABS(WIR2).GT.0.00) THEN
C
            NW1 = INT(ABS(WIR)*NBINW1) + 1
            IF (NW1.GT.NBINW1) NW1 = NBINW1

            NW2 = INT(ABS(WIR2)*NBINW2) + 1
            IF (NW2.GT.NBINW2) NW2 = NBINW2
C
C----       If  there is no AO2 then set IEPSLN = 100*WIR2
C
            IEPSLN = 100*WIR2
            CEPSLN = 1.0
            IF (IAO2.NE.0) THEN
              IEPSLN = NINT(ABS(AO-AO2))
              IEPSLN = MOD(IEPSLN, 360)
              IF (IEPSLN.GT.180) IEPSLN = 360 - IEPSLN
C             Correlate Cos (error) with Weights
              CEPSLN = COS(TWOPI*IEPSLN/360.0)
            END IF
            IF (IC.GT.0) THEN
C
C----         Centric reflections: IEPSLN either 0 or 180..
C
              I = 2
              IF (IEPSLN.LT.2) I = 1
              IF (IAO2.EQ.0) I = 1
              ICMN(NW1, NW2, NS) = ICMN(NW1, NW2, NS) + IEPSLN
              CEPS(1, NS) = CEPS(1, NS) + IEPSLN
              CEPSQ(1, NS) = CEPSQ(1, NS) + IEPSLN*IEPSLN
              CW(1, NS) = CW(1, NS) + WIR
              CWSQ(1, NS) = CWSQ(1, NS) + WIR*WIR
              CW2(1, NS) = CW2(1, NS) + WIR2
              CW2SQ(1, NS) = CW2SQ(1, NS) + WIR2*WIR2
              CEPSW(1, NS) = CEPSW(1, NS) + IEPSLN*WIR
              CEPSW2(1, NS) = CEPSW2(1, NS) + IEPSLN*WIR2
              CCEPS(1, NS) = CCEPS(1, NS) + CEPSLN
              CCEPSQ(1, NS) = CCEPSQ(1, NS) + CEPSLN*CEPSLN
              CCEPSW(1, NS) = CCEPSW(1, NS) + CEPSLN*WIR
              CCEPW2(1, NS) = CCEPW2(1, NS) + CEPSLN*WIR2
              NCOUNT(I, NW1, NW2, NS) = NCOUNT(I, NW1, NW2, NS) + 1
            ELSE
              IACMN(NW1, NW2, NS) = IACMN(NW1, NW2, NS) + IEPSLN
              NACNT(NW1, NW2, NS) = NACNT(NW1, NW2, NS) + 1
              CEPS(2, NS) = CEPS(2, NS) + IEPSLN
              CEPSQ(2, NS) = CEPSQ(2, NS) + IEPSLN*IEPSLN
              CCEPS(2, NS) = CCEPS(2, NS) + CEPSLN
              CCEPSQ(2, NS) = CCEPSQ(2, NS) + CEPSLN*CEPSLN
              CW(2, NS) = CW(2, NS) + WIR
              CWSQ(2, NS) = CWSQ(2, NS) + WIR*WIR
              CW2(2, NS) = CW2(2, NS) + WIR2
              CW2SQ(2, NS) = CW2SQ(2, NS) + WIR2*WIR2
              CEPSW(2, NS) = CEPSW(2, NS) + IEPSLN*WIR
              CEPSW2(2, NS) = CEPSW2(2, NS) + IEPSLN*WIR2
              CCEPSW(2, NS) = CCEPSW(2, NS) + CEPSLN*WIR
              CCEPW2(2, NS) = CCEPW2(2, NS) + CEPSLN*WIR2
            END IF
C
          END IF
        END IF
C      END IF
      GO TO 10
C
C     END OF INPUT
C
   20 CONTINUE
      DO 40 K = 1, NBINS
        DO 30 I = 1, 2
          CCEPS(I, NBIN+1) = CCEPS(I, NBIN+1) + CCEPS(I, K)
          CCEPSQ(I, NBIN+1) = CCEPSQ(I, NBIN+1) + CCEPSQ(I, K)
          CEPSQ(I, NBIN+1) = CEPSQ(I, NBIN+1) + CEPSQ(I, K)
          CWSQ(I, NBIN+1) = CWSQ(I, NBIN+1) + CWSQ(I, K)
          CW2SQ(I, NBIN+1) = CW2SQ(I, NBIN+1) + CW2SQ(I, K)
          CEPS(I, NBIN+1) = CEPS(I, NBIN+1) + CEPS(I, K)
          CW(I, NBIN+1) = CW(I, NBIN+1) + CW(I, K)
          CW2(I, NBIN+1) = CW2(I, NBIN+1) + CW2(I, K)
          CEPSW(I, NBIN+1) = CEPSW(I, NBIN+1) + CEPSW(I, K)
          CEPSW2(I, NBIN+1) = CEPSW2(I, NBIN+1) + CEPSW2(I, K)
          CCEPSW(I, NBIN+1) = CCEPSW(I, NBIN+1) + CCEPSW(I, K)
          CCEPW2(I, NBIN+1) = CCEPW2(I, NBIN+1) + CCEPW2(I, K)
   30   CONTINUE
   40 CONTINUE
C
      DO 70 I = 1, NBINW1
        DO 60 J = 1, NBINW2
          DO 50 K = 1, NBINS
            ICHECK = NCOUNT(1, I, J, K) + NCOUNT(2, I, J, K) +
     +               NACNT(I, J, K)
            IF (ICHECK.NE.0) AVEPSN = IACMN(I, J, K)/
     +                                (NACNT(I, J, K)+0.1)
C
            NCOUNT(1, I, J, NBIN+1) = NCOUNT(1, I, J, NBIN+1) +
     +                                NCOUNT(1, I, J, K)
            NCOUNT(2, I, J, NBIN+1) = NCOUNT(2, I, J, NBIN+1) +
     +                                NCOUNT(2, I, J, K)
            NCOUNT(1, I, NBINW2+1, K) = NCOUNT(1, I, NBINW2+1, K) +
     +                                  NCOUNT(1, I, J, K)
            NCOUNT(2, I, NBINW2+1, K) = NCOUNT(2, I, NBINW2+1, K) +
     +                                  NCOUNT(2, I, J, K)
            NCOUNT(1, NBINW1+1, J, K) = NCOUNT(1, NBINW1+1, J, K) +
     +                                  NCOUNT(1, I, J, K)
            NCOUNT(2, NBINW1+1, J, K) = NCOUNT(2, NBINW1+1, J, K) +
     +                                  NCOUNT(2, I, J, K)
            NCOUNT(1, I, NBINW2+1, NBIN+1) = NCOUNT(1, I, NBINW2+1,
     +        NBIN+1) + NCOUNT(1, I, J, K)
            NCOUNT(2, I, NBINW2+1, NBIN+1) = NCOUNT(2, I, NBINW2+1,
     +        NBIN+1) + NCOUNT(2, I, J, K)
            NCOUNT(1, NBINW1+1, J, NBIN+1) = NCOUNT(1, NBINW1+1, J,
     +        NBIN+1) + NCOUNT(1, I, J, K)
            NCOUNT(2, NBINW1+1, J, NBIN+1) = NCOUNT(2, NBINW1+1, J,
     +        NBIN+1) + NCOUNT(2, I, J, K)
            NCOUNT(1, NBINW1+1, NBINW2+1, K) = NCOUNT(1, NBINW1+1,
     +        NBINW2+1, K) + NCOUNT(1, I, J, K)
            NCOUNT(2, NBINW1+1, NBINW2+1, K) = NCOUNT(2, NBINW1+1,
     +        NBINW2+1, K) + NCOUNT(2, I, J, K)
            NCOUNT(1, NBINW1+1, NBINW2+1, NBIN+1) = NCOUNT(1, NBINW1+1,
     +        NBINW2+1, NBIN+1) + NCOUNT(1, I, J, K)
            NCOUNT(2, NBINW1+1, NBINW2+1, NBIN+1) = NCOUNT(2, NBINW1+1,
     +        NBINW2+1, NBIN+1) + NCOUNT(2, I, J, K)
            NACNT(I, J, NBIN+1) = NACNT(I, J, NBIN+1) + NACNT(I, J, K)
            IACMN(I, J, NBIN+1) = IACMN(I, J, NBIN+1) + IACMN(I, J, K)
            NACNT(I, NBINW2+1, K) = NACNT(I, NBINW2+1, K) +
     +                              NACNT(I, J, K)
            IACMN(I, NBINW2+1, K) = IACMN(I, NBINW2+1, K) +
     +                              IACMN(I, J, K)
            NACNT(NBINW1+1, J, K) = NACNT(NBINW1+1, J, K) +
     +                              NACNT(I, J, K)
            IACMN(NBINW1+1, J, K) = IACMN(NBINW1+1, J, K) +
     +                              IACMN(I, J, K)
            NACNT(I, NBINW2+1, NBIN+1) = NACNT(I, NBINW2+1, NBIN+1) +
     +                                   NACNT(I, J, K)
            IACMN(I, NBINW2+1, NBIN+1) = IACMN(I, NBINW2+1, NBIN+1) +
     +                                   IACMN(I, J, K)
            NACNT(NBINW1+1, J, NBIN+1) = NACNT(NBINW1+1, J, NBIN+1) +
     +                                   NACNT(I, J, K)
            IACMN(NBINW1+1, J, NBIN+1) = IACMN(NBINW1+1, J, NBIN+1) +
     +                                   IACMN(I, J, K)
            NACNT(NBINW1+1, NBINW2+1, K) = NACNT(NBINW1+1, NBINW2+1,
     +        K) + NACNT(I, J, K)
            IACMN(NBINW1+1, NBINW2+1, K) = IACMN(NBINW1+1, NBINW2+1,
     +        K) + IACMN(I, J, K)
            NACNT(NBINW1+1, NBINW2+1, NBIN+1) = NACNT(NBINW1+1,
     +        NBINW2+1, NBIN+1) + NACNT(I, J, K)
            IACMN(NBINW1+1, NBINW2+1, NBIN+1) = IACMN(NBINW1+1,
     +        NBINW2+1, NBIN+1) + IACMN(I, J, K)
   50     CONTINUE
   60   CONTINUE
   70 CONTINUE
C   Deal with Centric reflerctions now
C     ******************************************************************
C     **                      ave(X*Y) - ave(X)*ave(Y)
C     * corr. coeff.= -------------------------------------------------
C     **           SQRT(ave(X**2)-ave(X)**2)*SQRT(ave(Y**2)-ave(Y)**2)
C     ******************************************************************
      K = 0
      ITOT = NCOUNT(1, NBINW1+1, NBINW2+1, NBIN+1) +
     +       NCOUNT(2, NBINW1+1, NBINW2+1, NBIN+1)
      IF (ITOT.NE.0) THEN
        CCEPSQ(1, NBIN+1) = CCEPSQ(1, NBIN+1)/ITOT
        CEPSQ(1, NBIN+1) = CEPSQ(1, NBIN+1)/ITOT
        CWSQ(1, NBIN+1) = CWSQ(1, NBIN+1)/ITOT
        CW2SQ(1, NBIN+1) = CW2SQ(1, NBIN+1)/ITOT
        CCEPS(1, NBIN+1) = CCEPS(1, NBIN+1)/ITOT
        CEPS(1, NBIN+1) = CEPS(1, NBIN+1)/ITOT
        CW(1, NBIN+1) = CW(1, NBIN+1)/ITOT
        CW2(1, NBIN+1) = CW2(1, NBIN+1)/ITOT
        CCEPSW(1, NBIN+1) = CCEPSW(1, NBIN+1)/ITOT
        CCEPW2(1, NBIN+1) = CCEPW2(1, NBIN+1)/ITOT
        CEPSW(1, NBIN+1) = CEPSW(1, NBIN+1)/ITOT
        CEPSW2(1, NBIN+1) = CEPSW2(1, NBIN+1)/ITOT
        DSQ1 = CEPSQ(1, NBIN+1) - CEPS(1,NBIN+1)*CEPS(1,NBIN+1)
        IF (DSQ1 .GT. 0.0) THEN
          DSQ1 = SQRT(ABS(DSQ1))
          DSQ2 = CWSQ(1, NBIN+1) - CW(1, NBIN+1)*CW(1, NBIN+1)
          DSQ2 = SQRT(ABS(DSQ2))
          CORW1 = 0.0
          IF (DSQ2 .GT. 0.00001) CORW1 = (CEPSW(1,NBIN+1) -
     +          CEPS(1,NBIN+1)*CW(1,NBIN+1))/(DSQ1*DSQ2)

          DSQ2 = CW2SQ(1, NBIN+1) - CW2(1, NBIN+1)*CW2(1, NBIN+1)
          DSQ2 = SQRT(ABS(DSQ2))
          CORW2 = 0.0
          IF (DSQ2 .GT. 0.00001) CORW2 = (CEPSW2(1, NBIN+1) -
     +          CEPS(1, NBIN+1)*CW2(1, NBIN+1))/(DSQ1*DSQ2)
        ENDIF

        DSQ1 = CCEPSQ(1,NBIN+1) - CCEPS(1, NBIN+1)*CCEPS(1, NBIN+1)
        IF (DSQ1 .GT. 0.0) THEN
          DSQ1 = SQRT(ABS(DSQ1))
          DSQ2 = CWSQ(1, NBIN+1) - CW(1, NBIN+1)*CW(1, NBIN+1)
          DSQ2 = SQRT(ABS(DSQ2))
          CCORW1 = 0.0
          IF (DSQ2 .GT. 0.00001) CCORW1 = (CCEPSW(1, NBIN+1) - 
     +           CCEPS(1, NBIN+1)*CW(1, NBIN+1))/(DSQ1*DSQ2)

          DSQ2 = CW2SQ(1, NBIN+1) - CW2(1, NBIN+1)*CW2(1, NBIN+1)
          DSQ2 = SQRT(ABS(DSQ2))
          CCORW2 = 0.0
          IF (DSQ2 .GT. 0.00001) CCORW2 = (CCEPW2(1, NBIN+1) -
     +           CCEPS(1, NBIN+1)*CW2(1, NBIN+1))/(DSQ1*DSQ2)
        ENDIF

        PERCNT = REAL(NCOUNT(1, NBINW1+1, NBINW2+1, NBIN+1))/REAL(ITOT)
        WRITE (ISYSW, FMT=
     +    '(/,'' ********************************************'')')
        WRITE (ISYSW, FMT=9010)
 9010   FORMAT (/,'   Centric Analysis   ',/,'  Range    Total no. wh',
     +         'ich agree - Disagree Fraction which agree')
        WRITE (ISYSW, FMT=9015) ' TOTAL', ITOT, (NCOUNT(I, NBINW1+1, 
     +    NBINW2+1, NBIN+1), I=1, 2), PERCNT
 9015   FORMAT(A, 3 (I10, 2X), F9.4, 4 (2X, F6.3))
        WRITE (ISYSW, FMT=9020) CORW1, CORW2, CCORW1, CCORW2
 9020   FORMAT(/,'  Correlation  of Phase error, and Cos(Phase error) ',
     +         'with weight 1 and weight 2', /2 (13x, 2f6.3), /,'  ',
     +    'Remember - we want NEGATIVE correlation between phase error '
     +         , 'and weight!', /)
        IF (IAO2.EQ.0) GO TO 81
        WRITE (ISYSW, FMT=9030)
 9030   FORMAT (/,'  Analysis on FIRST Weight ',
     +         /,'  Range    Total  No which agree - ',
     +         'Disagree Fraction which agree')
C
        R1 = 0.0
        STEP = 1.0/NBINW1
        DO 80 II = 1, NBINW1
          R2 = R1 + STEP
          ITOT = NCOUNT(1, II, NBINW2+1, NBIN+1) +
     +           NCOUNT(2, II, NBINW2+1, NBIN+1)
          IF (ITOT.NE.0) THEN
            PERCNT = REAL(NCOUNT(1, II, NBINW2+1, NBIN+1))/ITOT
            WRITE (ISYSW, FMT=9040) R1, R2, ITOT,
     +        (NCOUNT(I, II, NBINW2+1, NBIN+1), I=1, 2), PERCNT
 9040       FORMAT (1X, F4.2, '-', F4.2, I5, 2(I10, 2X), F9.4,
     +                                     2(2X, F6.3, 2X, F6.3))
          END IF
          R1 = R2
 80     CONTINUE
 81     CONTINUE
        WRITE (ISYSW, FMT=9050)
 9050   FORMAT (/,'  Analysis in 4(SNTHR/L)**2 Intervals ',
     +         /,'  Range      Total  No which agree -  ',
     +         'Disagree Fraction  CW1    CW2   CCW1   CCW2')
C
        STEP = SMAX/NBINS
        R1 = 0.0
        DO 90 K = 1, NBINS
          R2 = R1 + STEP
          ITOT = NCOUNT(1, NBINW1+1, NBINW2+1, K) +
     +           NCOUNT(2, NBINW1+1, NBINW2+1, K)
          IF (ITOT.NE.0) THEN
            CEPSQ(1, K) = CEPSQ(1, K)/ITOT
            CWSQ(1, K) = CWSQ(1, K)/ITOT
            CW2SQ(1, K) = CW2SQ(1, K)/ITOT
            CEPS(1, K) = CEPS(1, K)/ITOT
            CW(1, K) = CW(1, K)/ITOT
            CW2(1, K) = CW2(1, K)/ITOT
            CEPSW(1, K) = CEPSW(1, K)/ITOT
            CEPSW2(1, K) = CEPSW2(1, K)/ITOT
C
            DSQ1 = CEPSQ(1, K) - CEPS(1, K)*CEPS(1, K)
            IF (DSQ1 .GT. 0.0) THEN
              DSQ1 = SQRT(ABS(DSQ1))
              DSQ2 = CWSQ(1, K) - CW(1, K)*CW(1, K)
              DSQ2 = SQRT(ABS(DSQ2))
              IF (DSQ2.GE.0.00001) CORW1 = (CEPSW(1, K) -
     +          CEPS(1, K)*CW(1, K))/ (DSQ1*DSQ2)

              DSQ2 = CW2SQ(1, K) - CW2(1, K)*CW2(1, K)
              DSQ2 = SQRT(ABS(DSQ2))
              IF (DSQ2.GE.0.00001) CORW2 = (CEPSW2(1, K)-
     +           CEPS(1, K)*CW2(1, K))/ (DSQ1*DSQ2)
            ENDIF

            DSQ1 = CCEPSQ(1, K) - CCEPS(1, K)*CCEPS(1, K)
            IF (DSQ1 .GT. 0.0) THEN
              DSQ1 = SQRT(ABS(DSQ1))
              DSQ2 = CWSQ(1, K) - CW(1, K)*CW(1, K)
              DSQ2 = SQRT(ABS(DSQ2))
              IF (DSQ2.GE.0.00001) CCORW1 = (CCEPSW(1, K)-
     +          CCEPS(1, K)*CW(1, K))/ (DSQ1*DSQ2)

              DSQ2 = CW2SQ(1, K) - CW2(1, K)*CW2(1, K)
              DSQ2 = SQRT(ABS(DSQ2))
              IF (DSQ2.GE.0.00001) CCORW2 = (CCEPW2(1, K)-
     +          CCEPS(1, K)*CW2(1, K))/ (DSQ1*DSQ2)
            ENDIF

            PERCNT = REAL(NCOUNT(1, NBINW1+1, NBINW2+1, K))/ITOT
            WRITE (ISYSW, FMT=9055) R1, R2, ITOT,
     +        (NCOUNT(I, NBINW2+1, NBINW2+1, K), I=1, 2), PERCNT, CORW1,
     +        CORW2, CCORW1, CCORW2
          END IF
          R1 = R2
   90   CONTINUE
 9055   FORMAT(1X, F5.3, '-', F5.3, I5, 2 (I10, 2X), F9.4, 4 (2X, F6.3))
        IF (IAO2.EQ.0) GO TO 101
        WRITE (ISYSW, FMT=9060)
 9060   FORMAT (/,'  Analysis on Second Weight ',
     +         /,'  Range    Total  No which agree -  ',
     +         'Disagree Fraction which agree')
C
        R1 = 0.0
        STEP = 1.0/NBINW2
        DO 100 J = 1, NBINW2
          R2 = R1 + STEP
          ITOT = NCOUNT(1, NBINW1+1, J, NBIN+1) +
     +           NCOUNT(2, NBINW1+1, J, NBIN+1)
          IF (ITOT.NE.0) THEN
            PERCNT = REAL(NCOUNT(1, NBINW1+1, J, NBIN+1))/ITOT
            WRITE (ISYSW, FMT=9040) R1, R2, ITOT,
     +        (NCOUNT(I, NBINW2+1, J, NBIN+1), I=1, 2), PERCNT
          END IF
          R1 = R2
  100   CONTINUE
 101    CONTINUE
      END IF
      WRITE (ISYSW, FMT=9070)
 9070 FORMAT (//,'***************************************************',
     +       /,'         Acentric Analysis   ',
     +       /,'           DEL = Average Difference in degrees ',
     +       /,'           CW1 = Correlation with weight 1 ',
     +       /,'           CW2 = Correlation with weight 2',
     +       //,'           CWW1 = Correlation of cos(phase error) ',
     +       'with weight 1 ', /,
     +       '           CWW2 = Correlation of cos(phase error) ',
     +       'with weight 2 ')
      WRITE (ISYSW, FMT=9080)
 9080 FORMAT ('  Range  Limits   Total No          DEL       CW1   ',
     +       '   CW2     CCW1     CCW2')
      K = 0
      IF (NACNT(NBINW1+1, NBINW2+1, NBIN+1).GT.0) THEN
        ITOT = NACNT(NBINW1+1, NBINW2+1, NBIN+1)
        AVEPSN = REAL(IACMN(NBINW1+1, NBINW2+1, NBIN+1))/ITOT
        CCEPSQ(2, NBIN+1) = CCEPSQ(2, NBIN+1)/ITOT
        CEPSQ(2, NBIN+1) = CEPSQ(2, NBIN+1)/ITOT
        CWSQ(2, NBIN+1) = CWSQ(2, NBIN+1)/ITOT
        CW2SQ(2, NBIN+1) = CW2SQ(2, NBIN+1)/ITOT
        CCEPS(2, NBIN+1) = CCEPS(2, NBIN+1)/ITOT
        CEPS(2, NBIN+1) = CEPS(2, NBIN+1)/ITOT
        CW(2, NBIN+1) = CW(2, NBIN+1)/ITOT
        CW2(2, NBIN+1) = CW2(2, NBIN+1)/ITOT
        CEPSW(2, NBIN+1) = CEPSW(2, NBIN+1)/ITOT
        CEPSW2(2, NBIN+1) = CEPSW2(2, NBIN+1)/ITOT
        CCEPSW(2, NBIN+1) = CCEPSW(2, NBIN+1)/ITOT
        CCEPW2(2, NBIN+1) = CCEPW2(2, NBIN+1)/ITOT
C
        DSQ1 = CEPSQ(2, NBIN+1) - CEPS(2, NBIN+1)*CEPS(2, NBIN+1)
        IF (DSQ1 .GT. 0.0) THEN
          DSQ1 = SQRT(ABS(DSQ1))
          DSQ2 = CWSQ(2, NBIN+1) - CW(2, NBIN+1)*CW(2, NBIN+1)
          DSQ2 = SQRT(ABS(DSQ2))
          CORW1 = 0.0
          IF (DSQ2 .GT. 0.00001) CORW1 = (CEPSW(2, NBIN+1) -
     +          CEPS(2, NBIN+1)*CW(2, NBIN+1))/(DSQ1*DSQ2)

          DSQ2 = CW2SQ(2, NBIN+1) - CW2(2, NBIN+1)*CW2(2, NBIN+1)
          DSQ2 = SQRT(ABS(DSQ2))
          CORW2 = 0.0
          IF (DSQ2 .GT. 0.00001) CORW2 = (CEPSW2(2, NBIN+1) - 
     +          CEPS(2, NBIN+1)*CW2(2, NBIN+1))/(DSQ1*DSQ2)
        ENDIF

        DSQ1 = CCEPSQ(2,NBIN+1) - CCEPS(2,NBIN+1)*CCEPS(2,NBIN+1)
        IF (DSQ1 .GT. 0.0) THEN
          DSQ1 = SQRT(ABS(DSQ1))
          DSQ2 = CWSQ(2, NBIN+1) - CW(2, NBIN+1)*CW(2, NBIN+1)
          DSQ2 = SQRT(ABS(DSQ2))
          IF (DSQ2 .GT. 0.00001) CCORW1 = (CCEPSW(2, NBIN+1) -
     +           CCEPS(2, NBIN+1)*CW(2, NBIN+1))/(DSQ1*DSQ2)

          DSQ2 = CW2SQ(2, NBIN+1) - CW2(2, NBIN+1)*CW2(2, NBIN+1)
          DSQ2 = SQRT(ABS(DSQ2))
          IF (DSQ2 .GT. 0.00001) CCORW2 = (CCEPW2(2, NBIN+1) - 
     +           CCEPS(2, NBIN+1)*CW2(2, NBIN+1))/(DSQ1*DSQ2)
        ENDIF
      END IF
      WRITE (ISYSW, FMT=9090) ' TOTAL', NACNT(NBINW1+1, NBINW2+1, 
     +  NBIN+1),AVEPSN, CORW1, CORW2, CCORW1, CCORW2
 9090 FORMAT (A,9X, I10, 5X, F10.3, 2 (1X, F8.3, 1X, F8.3))
      WRITE (ISYSW, FMT=9100)
     +         '   $TABLE: Analysis in 4(SNTHR/L)**2  Intervals',
     +                                                TITLE(1:30),':',
     +       '  $GRAPHS',
     +      ' : 4SSLLmax DelPhi:N:2,4:',
     +      ' : 4SSLLmax CORR_obs_error_w1  CORR_obs_error_w2:N:2,7,8:',
     +       ':4SSLLmax  Number of reflections :N:2,3: ',
     +       '  $$ <4SSLLmin> ', 
     +       '     1/resol^2 ',
     +       '  Number_reflections ', 
     +       '  DPHI_e ',
     +       '  Correlation_DPHI_e_(Weight1)',
     +       '  Correlation_DPHI_e_(Weight2)',
     +       '  Correlation_DPHI_e_cos(Weight1)',
     +       '  Correlation_DPHI_e_cos(Weight2) $$',
     +       '  S1 S2 Nref DPHI_e CW1 CW2 CCW1 CCW2  $$ '
 9100 FORMAT (/,A,A,A,12(/,A))
C
      STEP = SMAX/NBINS
      R1 = 0.0
      DO 110 K = 1, NBINS
        R2 = R1 + STEP
        IF (NACNT(NBINW1+1, NBINW2+1, K).NE.0) THEN
          ITOT = NACNT(NBINW1+1, NBINW2+1, K)
          AVEPSN = REAL(IACMN(NBINW1+1, NBINW2+1, K))/ITOT
          CCEPSQ(2, K) = CCEPSQ(2, K)/ITOT
          CEPSQ(2, K) = CEPSQ(2, K)/ITOT
          CWSQ(2, K) = CWSQ(2, K)/ITOT
          CW2SQ(2, K) = CW2SQ(2, K)/ITOT
          CCEPS(2, K) = CCEPS(2, K)/ITOT
          CEPS(2, K) = CEPS(2, K)/ITOT
          CW(2, K) = CW(2, K)/ITOT
          CW2(2, K) = CW2(2, K)/ITOT
          CEPSW(2, K) = CEPSW(2, K)/ITOT
          CEPSW2(2, K) = CEPSW2(2, K)/ITOT
          CCEPSW(2, K) = CCEPSW(2, K)/ITOT
          CCEPW2(2, K) = CCEPW2(2, K)/ITOT
C
          DSQ1 = CEPSQ(2, K) - CEPS(2, K)*CEPS(2, K)
          IF (DSQ1 .GT. 0.0) THEN
            DSQ1 = SQRT(ABS(DSQ1))
            DSQ2 = CWSQ(2, K) - CW(2, K)*CW(2, K)
            DSQ2 = SQRT(ABS(DSQ2))
            CORW1 = 0.0
            IF (DSQ2.GT.0.0000001) CORW1 = (CEPSW(2, K) -
     +             CEPS(2, K)*CW(2, K))/ (DSQ1*DSQ2)

            DSQ2 = CW2SQ(2, K) - CW2(2, K)*CW2(2, K)
            DSQ2 = SQRT(ABS(DSQ2))
            CORW2 = 0.0
            IF (DSQ2.GT.0.0000001) CORW2 = (CEPSW2(2, K) -
     +           CEPS(2, K)*CW2(2, K))/ (DSQ1*DSQ2)
          ENDIF

          DSQ1 = CCEPSQ(2, K) - CCEPS(2, K)*CCEPS(2, K)
          IF (DSQ1 .GT. 0.0) THEN
            DSQ1 = SQRT(ABS(DSQ1))
            DSQ2 = CWSQ(2, K) - CW(2, K)*CW(2, K)
            DSQ2 = SQRT(ABS(DSQ2))
            CCORW1 = 0.0
            IF (DSQ2.GT.0.0000001) CCORW1 = (CCEPSW(2, K) -
     +          CCEPS(2, K)*CW(2, K))/ (DSQ1*DSQ2)

            DSQ2 = CW2SQ(2, K) - CW2(2, K)*CW2(2, K)
            DSQ2 = SQRT(ABS(DSQ2))
            CCORW2 = 0.0
            IF (DSQ2.GT.0.0000001) CCORW2 = (CCEPW2(2, K) -
     +           CCEPS(2, K)*CW2(2, K))/ (DSQ1*DSQ2)
          ENDIF

          WRITE (ISYSW, FMT=9110) R1, R2, NACNT(NBINW1+1, NBINW2+1, K),
     +      AVEPSN, CORW1, CORW2, CCORW1, CCORW2
 9110     FORMAT (1X, F6.4, F7.4, 1X, I10, 5X, F10.3,
     +           2 (1X, F8.3, 1X, F8.3))
        END IF
C
        R1 = R2
  110 CONTINUE
      WRITE (ISYSW, FMT=*) ' $$'
      IF (IAO2.EQ.0) RETURN
      WRITE (ISYSW, FMT=9120)
     +       '   $TABLE: Analysis on First Weight ',TITLE(1:30),':',
     +       '  $GRAPHS',
     +       '  : Weight_1 v Expected and Observed error:N:2,3,5: ',
     +       '  :Weight_1 v Number of reflections :N:2,4: ',
     +       '  $$ <WTmin> ',
     +       '     <WTmax> ',
     +       '  Expected_error ',
     +       '  Number_reflections ', 
     +       '  Observed_error $$ ',
     +       '   <WT0> <WT1>  DPHI_e  Nref_a         DPHI_o  $$'
 9120 FORMAT (/,A,A,A,12(/,A))

      STEP = 1.0/NBINW1
      R1 = 0.0
C
      DO 120 II = 1, NBINW2
        R2 = R1 + STEP
        COSAA = R2
        SINAA = SQRT(ABS(1-COSAA*COSAA))
        ERROR = ATAN2(SINAA, COSAA)/CONV
        IF (NACNT(II, NBINW2+1, NBIN+1).NE.0) THEN
          AVEPSN = REAL(IACMN(II, NBINW2+1, NBIN+1))/
     +             NACNT(II, NBINW2+1, NBIN+1)
          WRITE (ISYSW, FMT=9130) R1, R2, ERROR,
     +      NACNT(II, NBINW2+1, NBIN+1), AVEPSN
 9130     FORMAT (1X, F6.2, F7.2, 1X, F7.1, I7, 5X, F10.3)
        END IF
C
        R1 = R2
  120 CONTINUE
      WRITE (ISYSW, FMT=*) ' $$'
      WRITE (ISYSW, FMT=9140)
     +       '   $TABLE: Analysis on Second Weight ',TITLE(1:30),':',
     +       '  $GRAPHS',
     +       '  : Weight_2 v Expected and Observed error:N:2,3,5: ',
     +       '  :Weight_2 v Number of reflections :N:2,4: ',
     +       '  $$ <WTmin> ',
     +       '     <WTmax> ',
     +       '  Expected_error ',
     +       '  Number_reflections ', 
     +       '  Observed_error $$ ',
     +       '   <WT0> <WT1>  DPHI_e  Nref_a         DPHI_o  $$'
 9140 FORMAT (/,A,A,A,12(/,A))

      STEP = 1.0/NBINW2
      R1 = 0.0
C
      DO 130 II = 1, NBINW2
        R2 = R1 + STEP
        IF (NACNT(NBINW1+1, II, NBIN+1).NE.0) THEN
          COSAA = R2
          SINAA = SQRT(ABS(1-COSAA*COSAA))
          ERROR = ATAN2(SINAA, COSAA)/CONV
          AVEPSN = REAL(IACMN(NBINW1+1, II, NBIN+1))/
     +             NACNT(NBINW1+1, II, NBIN+1)
          WRITE (ISYSW, FMT=9130) R1, R2, ERROR,
     +      NACNT(NBINW1+1, II, NBIN+1), AVEPSN
        END IF
        R1 = R2
  130 CONTINUE
      WRITE (ISYSW, FMT=*) ' $$'
      END
