C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C----------------------------------------------------------------------+--- 
C GFAC2PDB.INC - Include variables for GFAC2PDB.FOR
C----------------------------------------------------------------------+--- 

CVAX      IMPLICIT NONE

      INTEGER       MXATOM, MXRES
      PARAMETER    (
     -              MXATOM  = 100000,
     -              MXRES   =  10000
     -             )

      INTEGER       NAMINO, NCOVAL, NDIHED, NDISTR
      PARAMETER    (
     -              NAMINO  =   20,
     -              NCOVAL =     2,
     -              NDIHED =     5,
     -              NDISTR =    NCOVAL + NDIHED + 3
     -             )

      CHARACTER*1   CHAIN
      CHARACTER*3   AMINO(NAMINO+1), VALRES(MXRES)
      CHARACTER*6   RESDET(MXRES), RESNO(MXATOM)
      CHARACTER*9   VALSNO(MXRES)
      CHARACTER*13  ATOMID(MXATOM)
      CHARACTER*40  TITLE
      CHARACTER*80  FILOUT, FILNEW, FILSDH
      CHARACTER*500 PDBFIL

      COMMON/CHARS/
     -              CHAIN,

     -              AMINO, VALRES,

     -              RESDET, RESNO,

     -              VALSNO,

     -              ATOMID,

     -              TITLE,

     -              FILOUT, FILNEW, FILSDH, PDBFIL

      INTEGER       ACONST, ENASTR, FSTATM(MXRES), FSTRES, INTRLX,
     -              MODEL, NATOMS, NCOUNT(NAMINO+1), NRESID,
     -              RESNUM(MXATOM)

      COMMON/INTS/
     -              ACONST, ENASTR, FSTATM, FSTRES, INTRLX,
     -              MODEL, NATOMS, NCOUNT, NRESID,
     -              RESNUM

      LOGICAL       IFAIL
      COMMON/LOGS/
     -              IFAIL

      REAL          ATMXYZ(3,MXATOM), BVALUE(MXATOM), GFACTR(NDISTR),
     -              SFACT
      COMMON/REALS/
     -              ATMXYZ, BVALUE, GFACTR,
     -              SFACT

      SAVE

C----------------------------------------------------------------------+--- 
C Parameters
C ----------
C
C ACONST - Total number of dihedral angle constraints
C AMINO(NAMINO) - Three-letter residue code
C ATOMID(MXATOM) - Details uniquely identifying each atom in the structure
C          (ie atom name, chain and residue number)
C ATMXYZ(3,MXATOM) - Atomic coords of each atom
C BOTHND - Flag indicating that restraints are only to be included if
C          both ends are on residues that are included in the
C          residue-selection
C BVALUE(MXATOM) - Atomic temperature factors
C CHAIN  - Selected chain (not used here)
C FILOUT - Output PDB format file containing the G-factors translated into
C          atomic G-factors
C FILNEW - File containing cleaned up version of PDB file
C FILSDH - File containing all the residue-by-residue G-factor values
C FSTATM(MXRES) - Starting atom in each residue
C FSTRES - Pointer to the first residue of the sequence
C GFACTR(NDISTR) - G-factors giving measures of the stereochemical quality
C          of different aspects of the protein's structure
C IFAIL  - Failure flag causing program to abort due to some error
C          condition
C MODALL - Flag indicating whether all models in the ensemble are required
C MODEL  - Selected model number, where only a single model to be
C          processed
C MXATOM - Maximum number of atoms allowed for the structure
C MXRCON - Maximum number of distance restraints per residue
C MXRES  - Maximum number of residues allowed for the protein structure
C          being plotted
C MXTORS - Maximum number of torsion-angle restraints per residue
C NATOMS - Number of atoms in the protein
C NDISTR - Total number of log-odds scores in the .sdh file
C NRESID - Number of residues in the protein
C PDBFIL - Name of original file holding the coordinates of the structure
C          being processed
C RESDET(MXRES) - Residue details for each residue
C RESNO(MXATOM) - Residue-number of each atom
C RESNUM(MXATOM) - Sequential residue-number of each atom
C RESOPT - Restraint selection option
C SFACT  - Stereochemical R-factor, as calculated by program TPLOT and
C          held at the end of the .sdh file
C VALRES(MXRES) - Residue name for each residue in the sequence
C VALSNO(MXRES) - Sequence number for each residue in the sequence
C
C---------------------------------------------------------------------------
