C
C     PROFESSS 
C     Copyright (C) 2002 Kevin Cowtan
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
C     Author: Kevin Cowtan, York
C     Original version: January 2002
C     Originally called "eleanorinabox"
C     Minor improvements: MDW February 2002

      program professs
      implicit none

      integer MAXATM, MAXTRI, MAXNOPS, MAXATS
      parameter (MAXATM=10000,MAXTRI=20000,MAXNOPS=10000,MAXATS=40000)
      integer MAXLOOP,MAXLEN,MAXMOPS
      parameter (MAXLOOP=5000, MAXLEN=120, MAXMOPS=2000)
c
c COMMONS
      integer nsym
      real rsym(4,4,192)
      real m11, m22, m33, m12, m13, m23,rrr(3,3,6)
      common /crystal/nsym,rsym,m11,m22,m33,m12,m13,m23
c
      integer natm
      real uvw(3,MAXATM)
      common /atoms/natm,uvw
c
c LOCALS
      integer lpdb,nloop,iloop,loopmx,iatloop,ichk,jchk(MAXATM)
      integer nsymp, numsgp,iser1,iser2,iser3
      real distance,tolerance,dtor,rtod,dc11,dc12,dc13,dc21,dc22,dc23
      logical tidyin, xyzout, verbose,listall
      integer i, j, k, l, n, m, ii,jj,iu, iv, iw,ianiso,i26,i26r,l1,l2
      integer kk
      integer iatm, jatm, katm, isym, jsym, ksym
      integer ntri, nops, nlsq, nlsqn, mlsq,mentries,mops
      logical cont,found,lwrite,lprint,lreject
      real baniso(6)
      real vol, cell(6)
      real uc,ui,uis,ujs,uks,uic,ujc,ukc,du,dx,xr,xs,xrp
      real vc,vi,vis,vjs,vks,vic,vjc,vkc,dv,dy,yr,ys,yrp
      real wc,wi,wis,wjs,wks,wic,wjc,wkc,dw,dz,zr,zs,zrp
      real r1, r2, r3
      real rot(4,4),rchk(4,4,maxnops),prod(4,4)
      character spgnam*20, spgnam_ns*20, pgname*20, line*80, rmrk*80,
     +           lines(maxloop)*80,symchs(192)*80
c
      integer iser(MAXATM),iresn(MAXATM),iz(MAXATM),codepref(MAXATM)
      real bb,biso(MAXATM),occ(MAXATM)
      character atnam(MAXATM)*4,resnam(MAXATM)*4,resno(MAXATM)*4
      character id(MAXATM)*4,chnnam(MAXATM)*1,altcod(MAXATM)*1
      character inscod(MAXATM)*1,segid(MAXATM)*8
c
      integer izz(2,MAXLOOP)
      real bis(2,MAXLOOP),oc(2,MAXLOOP),xss(2,3,MAXLOOP)
      character atnm(2,MAXLOOP)*4,resnm(2,MAXLOOP)*4,resn(2,MAXLOOP)*4
      character idd(2,MAXLOOP)*4,chain(2,MAXLOOP)*1,altcd(2,MAXLOOP)*1
      character inscd(2,MAXLOOP)*1
c
      real u(MAXTRI),v(MAXTRI),w(MAXTRI)
      integer code(MAXTRI), flag(MAXTRI)
      real dist12(MAXTRI),dist23(MAXTRI),dist31(MAXTRI),disttr(MAXTRI)
      integer code1(MAXTRI),code2(MAXTRI),code3(MAXTRI),sorttri(MAXTRI)
      character chainid(MAXTRI)
c
      integer Nat(MAXLEN,MAXLOOP)
C
      real distop(MAXNOPS), xrr(MAXMOPS),yrr(MAXMOPS),zrr(MAXMOPS)
      real atloopr(MAXMOPS),txrr(MAXMOPS),tyrr(MAXMOPS),tzrr(MAXMOPS)
      real cxrr1(MAXMOPS),cyrr1(MAXMOPS),czrr1(MAXMOPS)
      real cxrr2(MAXMOPS),cyrr2(MAXMOPS),czrr2(MAXMOPS)
      real exrr(MAXMOPS),eyrr(MAXMOPS),ezrr(MAXMOPS)
      real ang(MAXMOPS,MAXMOPS)
      integer trig1(MAXNOPS),trig2(MAXNOPS),sortops(MAXMOPS),
     +        nopr(MAXMOPS),natr(MAXMOPS)
c
      integer codex1(MAXATS), codex2(MAXATS)
      integer coden1(MAXATS), coden2(MAXATS)
      integer loop(MAXATS)
      real rmatch(MAXATS)
c
c EXTERNALS
      integer new_atomcode, atomcode_atom, atomcode_symm
      integer atomcode_du, atomcode_dv, atomcode_dw,lenstr
      real fracp, get_dist_frac
      external new_atomcode, atomcode_atom, atomcode_symm
      external atomcode_du, atomcode_dv, atomcode_dw,lenstr
      external fracp, get_dist_frac
c
      call ccpfyp()
      call ccprcs(6, 'professs', '$Date: 2008/06/03 17:16:38 $')
      call xyzinit()
c
      rtod = 45.000/atan(1.00D0)
      dtor = 1.0/rtod
      cell(1) = -1.0
      vol = -1.0
c
      mentries = 0
      lpdb = 0
      i = 0
      call xyzopen('XYZIN','INPUT',' ',lpdb,i)
      call rbcell(cell,vol)
C
      distance = 25.0
      tolerance = 1.0
      nsym = 0
      verbose = .false.
      listall = .false.
      tidyin = .false.
      uc = 0.01
      vc = 0.01
      wc = 0.01
      xr = -1.0e6
      numsgp = 0
c    
      do i=1,MAXMOPS
        natr(i) = 0
      enddo       
c
c ----------------------------------------
c READ COMMAND INPUT
c
 100  call memoparse(.true.)
      call parsereal('DIST',distance)
      call parsereal('TOLE',tolerance)
      call parsekey('VERB',verbose)
      call parsekey('LIST',listall)
      call parsesubkey('TIDY','    ',tidyin)
      call parsesubreal('TIDY','FRAC',1,.true.,uc)
      call parsesubreal('TIDY','FRAC',2,.true.,vc)
      call parsesubreal('TIDY','FRAC',3,.true.,wc)
      call parsesubreal('TIDY','ORTH',1,.true.,xr)
      call parsesubreal('TIDY','ORTH',2,.true.,yr)
      call parsesubreal('TIDY','ORTH',3,.true.,zr)
      call parsecell(cell)
      call parsesymm(spgnam, numsgp, pgname, nsym, nsymp, rsym)
      call parsediagnose(cont)
      if (cont) goto 100
c
      if (cell(1).lt.0.0) call ccperr(1,'No cell in PDB or intput')
C if cell given but not VOL need to set up default orthogonalisations
      if (vol.le.0.0)  then 
       call ccperr(2,' Orthogonalisation set to default')
       call RBFRAC2(cell(1),cell(2),cell(3),cell(4),cell(5),cell(6),1)
      end if 
      if (nsym.eq.0) then
        call rbspgrp(spgnam)
        if (spgnam.ne.' ') 
     +   call msymlb3(24,numsgp,spgnam,spgnam_ns,pgname,nsymp,nsym,rsym)
        if (nsym.eq.0) call ccperr(1,'No spacegroup intput')
      endif
c
c calc matrices and metric
      call calcmetric(cell)
      if (xr.gt.-0.9e6) call cvfrac2(xr,yr,zr,uc,vc,wc,1)
C
C  Write out spacegroup and symmetry operators
        write(6,'(/,a,5x,a)') ' Spacegroup:',spgnam
       call symtr3(nsym,rsym,symchs,1)
C
c
c check for output file
      line = ' '
      call ugtenv('XYZOUT',line)
      xyzout = (line.ne.' ')
c
c ----------------------------------------
c READ THE PDB FILE
c
      natm=0
       if(tidyin) then
       Write(6,'(//,2A,/,2A)')' Input atom list after symmetry',
     + ' shifts to move atoms near to specied point',
     +'   Input_no      Atom_Id   Xortho Yortho Zortho',
     +'    Xfrac  Yfrac  Zfrac   Occ  Bfac'
       else
       Write(6,'(//,A,/,2A)')' Input atom list ',
     +'   Input_no      Atom_Id   Xortho Yortho Zortho',
     +'    Xfrac  Yfrac  Zfrac   Occ  Bfac'
       end if
c
 200  call xyzadvance(lpdb,0,1,*500,*500)
      natm=natm+1
      if (natm.gt.MAXATM) then
        write(6,'(/,A,I8,/,A,/)') 
     +    'Number of input atoms exceeds maximum: ',MAXATM,
     +    ' Change MAXATM and recompile (if really necessary).'
        call ccperr(1,'Parameter MAXATM exceeded.')
      endif
      call xyzatom(lpdb,iser(natm),atnam(natm),resnam(natm),
     +             chnnam(natm),iresn(natm),resno(natm),inscod(natm),
     +             altcod(natm),segid(natm)(1:4),iz(natm),id(natm))
      call xyzcoord(lpdb,'O','U',xr,yr,zr,
     +              occ(natm),biso(natm),baniso)
      call cvfrac2(xr,yr,zr,uvw(1,natm),uvw(2,natm),uvw(3,natm),1)
      codepref(natm) = -1
      iser(natm) = natm
c if 'tidy' is set, then center atoms about some center
      if ( tidyin ) then
       r1 = 1.0e6
       ksym = -1
c ...... loop over symmetry copies
       do jsym = 1, nsym
        call kevmatvec( rsym(1,1,jsym), uvw(1,natm), 
     +         uvw(2,natm),uvw(3,natm), ujs, vjs, wjs )
        r2 = get_dist_frac(fracp(ujs-uc), fracp(vjs-vc), fracp(wjs-wc))
c ....... found one closer to centre?
        if ( r2 .lt. r1 ) then
         r1 = r2
         ksym = jsym
        endif
       enddo
c ...... replace with closest
       call kevmatvec( rsym(1,1,ksym), uvw(1,natm), 
     +      uvw(2,natm),uvw(3,natm), ujs, vjs, wjs )
       uvw(1,natm) = ujs - nint( ujs - uc )
       uvw(2,natm) = vjs - nint( vjs - vc )
       uvw(3,natm) = wjs - nint( wjs - wc )
      endif
      call cvfrac2(uvw(1,natm),uvw(2,natm),uvw(3,natm),xr,yr,zr,0)
      WRITE(6,'(A4,I7,2x,2A4,A1,I4,3F7.2,2x,3F7.3,2F6.2)') 
     +        'ATOM',iser(natm),atnam(natm),resnam(natm),chnnam(natm),
     +        iresn(natm),xr,yr,zr,uvw(1,natm),uvw(2,natm),uvw(3,natm),
     +        occ(natm),biso(natm)
c next atom
      goto 200
c
 500  call xyzclose(lpdb)
      write(*,'(//,a,i5)')' Number of atoms read:',natm
c
c ----------------------------------------
c CALCULATE A LIST OF SMALL TRIANGLES
c
c try 3 atoms at a time, include sym equiv of 2nd and 3rd
c
      ntri = 0
c 1st atom
      do iatm = 1, natm
       call get_frac_from_code( new_atomcode(iatm,1,0,0,0),
     +                          ui, vi, wi)
c 2nd atom
       do jatm = 1, natm
        if (jatm.ne.iatm) then
c .. and symm
         do jsym = 1, nsym
          call get_frac_from_code( new_atomcode(jatm,jsym,0,0,0),
     +                             ujs, vjs, wjs)
          ujc = ( ujs - nint( ujs - ui ) )
          vjc = ( vjs - nint( vjs - vi ) )
          wjc = ( wjs - nint( wjs - wi ) )
          r1 = get_dist_frac(ujc-ui, vjc-vi, wjc-wi)
c in range?
          if (r1.lt.distance) then
c 3rd atom
           do katm = 1, natm
            if (katm.ne.iatm.and.katm.ne.jatm) then
c .. and symm
             do ksym = 1, nsym
              call get_frac_from_code( new_atomcode(katm,ksym,0,0,0),
     +                                 uks, vks, wks)
              ukc = ( uks - nint( uks - ui ) )
              vkc = ( vks - nint( vks - vi ) )
              wkc = ( wks - nint( wks - wi ) )
c calc distances
              r2 = get_dist_frac(ukc-ui, vkc-vi, wkc-wi)
              r3 = get_dist_frac(ukc-ujc, vkc-vjc, wkc-wjc)
c check for all dists valid and in increasing order
              if (r2.le.distance.and.r3.le.distance.and.
     +            r2.gt.r1-tolerance.and.r3.gt.r2-tolerance) then
               ntri = ntri + 1
               if (ntri.gt.MAXTRI) then
                 write(6,'(/,A,I8,/,A,/)') 
     +       ' Number of triangles exceeds maximum: ',MAXTRI,
     +       ' Reduce number of atoms or DISTANCE keyword.'
                 call ccperr(1,'Parameter MAXTRI exceeded.')
               endif
               code1(ntri) = new_atomcode(iatm,1,0,0,0)
               code2(ntri) = new_atomcode(jatm,jsym,
     +              nint(ujc-ujs),nint(vjc-vjs),nint(wjc-wjs))
               code3(ntri) = new_atomcode(katm,ksym,
     +              nint(ukc-uks),nint(vkc-vks),nint(wkc-wks))
               dist12(ntri) = r1
               dist23(ntri) = r2
               dist31(ntri) = r3
               disttr(ntri) = r1*r1 + r2*r2 + r3*r3
              endif
             enddo
            endif
           enddo
          endif
         enddo
        endif
       enddo
      enddo
c
c done triangle calc
c
c ----------------------------------------
c DO SOME INTERMEDIATE OUTPUT
c tabulate the triangles and output atom groups to PDB for lsqkab

      if (ntri.eq.0) then
        write(6,'(/,''No triangles found.'',/, 
     +     ''Try increasing the value of the maximum interatomic '',
     +     ''distance, see the DISTANCE keyword.'',/)')
        call ccperr(1,' Nothing  to match')
      endif
c
      write(6,'(/,A,/,A,/,A)')
     +  ' ############################################',
     +  ' LIST OF TRIANGLES FOUND, SORTED by Distance',
     +  ' ############################################'
      if(xyzout .and. listall) write(6,'(A,/)')
     +   '  All triplets of atoms involved written to XYZOUT'
c
c sort the triangles for output
c
      call shsort(disttr,sorttri,ntri)
c
c write the distance matrix and coordinate file
c
      do i=1,6
        baniso(i)=0.0
      enddo
      if (xyzout) then
       call xyzopen('XYZOUT','OUTPUT',' ',lpdb,i)
       call wbcell(lpdb, cell, 1)
      endif
      if (ntri.gt.0) write (*,509)

 509  format('  Ntr   D12    D23    D31    ',
     +     'Atom1[sym,shft]  Atom2[sym,shft]  Atom3[sym,shft] Segid')
      do i=1,ntri
c write logfile table
        j = sorttri(i)
        i26 = mod(i,26)
        if(i26.eq.0) i26 = 26
        i26r = (i-1)/26 
        chainid(j) = char((i26)-1+ichar('A'))
        if(i26r.eq.0) segid(j) = chainid(j)(1:1)//'      '
        if(i26r.eq.1) segid(j) = 
     + chainid(j)(1:1)//chainid(j)(1:1)//'      '
        if(i26r.eq.2) segid(j) = 
     + chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)(1:1)//' '
        if(i26r.eq.3) segid(j) = 
     + chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)
     +//'   '
        if(i26r.eq.4) segid(j) = 
     + chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)
     +//chainid(j)(1:1)//'   '
        if(i26r.eq.5) segid(j) = 
     + chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)
     +//chainid(j)(1:1)//chainid(j)(1:1)//'   '
        if(i26r.eq.6) segid(j) = 
     + chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)
     +//chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)(1:1)//' '
        if(i26r.gt.6) segid(j) = 
     + chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)
     + //chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)(1:1)//chainid(j)
        write (line,505)
     +    iser(atomcode_atom(code1(j))), atomcode_symm(code1(j)),
     +    atomcode_du(code1(j)), atomcode_dv(code1(j)),
     +    atomcode_dw(code1(j)),
     +    iser(atomcode_atom(code2(j))), atomcode_symm(code2(j)),
     +    atomcode_du(code2(j)), atomcode_dv(code2(j)),
     +    atomcode_dw(code2(j)),
     +    iser(atomcode_atom(code3(j))), atomcode_symm(code3(j)),
     +    atomcode_du(code3(j)), atomcode_dv(code3(j)),
     +    atomcode_dw(code3(j))
 505    format(3(1x,i5,' [',i2,SP,3i2,S,']'))
        write (*,510)j, dist12(j),dist23(j),dist31(j),line,segid(j)
 510    format(i5,3f7.2,1x,a51,2x,a)
c optional pdb output
        if (xyzout .and. listall) then
c write remark
          write (rmrk,520)dist12(j),dist23(j),dist31(j)
 520      format('REMARK     Triangle distances: ',3f8.3)
          call wremark(lpdb,rmrk)
          write (rmrk,530)line
 530      format('REMARK     atoms:     ',a51)
          call wremark(lpdb,rmrk)
          read (line,'(I6,11x,I6,11x,i6)') iser1,iser2,iser3
c 1st atom
          k = code1(j)
          katm = atomcode_atom(k)
          call get_orth_from_code(k,xs,ys,zs)
          call xyzatom(lpdb,iser1,atnam(iser1),resnam(iser1),
     +         chainid(j),100*i26r+1,resno(iser1),inscod(iser1),
     +         altcod(iser1),segid(j)(1:4),iz(iser1),id(iser1))
          bb = biso(iser1)
            baniso(1)=bb
          do ianiso=2,6
            baniso(ianiso)=0.0
          enddo
          call xyzcoord(lpdb,'O','U',xs,ys,zs,
     +         occ(katm),bb,baniso)
          call xyzadvance(lpdb,0,1,*900,*900)
c 2nd atom (inc symm)
          k = code2(j)
          katm = atomcode_atom(k)
          call get_orth_from_code(k,xs,ys,zs)
          call xyzatom(lpdb,iser2,atnam(iser2),resnam(iser2),
     +         chainid(j),100*i26r+2,resno(iser2),inscod(iser2),
     +         altcod(iser2),segid(j)(1:4),iz(iser2),id(iser2))
          bb = biso(iser2)
            baniso(1)=bb
          do ianiso=2,6
            baniso(ianiso)=0.0
          enddo
          call xyzcoord(lpdb,'O','U',xs,ys,zs,
     +         occ(katm),bb,baniso)
          call xyzadvance(lpdb,0,1,*900,*900)
c 3rd atom (inc symm)
          k = code3(j)
          katm = atomcode_atom(k)
          call get_orth_from_code(k,xs,ys,zs)
          call xyzatom(lpdb,iser3,atnam(iser3),resnam(iser3),
     +         chainid(j),100*i26r+3,resno(iser3),inscod(iser3),
     +         altcod(iser3),segid(j)(1:4),iz(iser3),id(iser3))
          bb = biso(iser3)
            baniso(1)=bb
          do ianiso=2,6
            baniso(ianiso)=0.0
          enddo
          call xyzcoord(lpdb,'O','U',xs,ys,zs,
     +         occ(katm),bb,baniso)
          call xyzadvance(lpdb,0,1,*900,*900)
        endif
      enddo
C 900  if (xyzout) then
C        call xyzclose(lpdb)
C      endif
 900  continue
c
c done output
c
c ------------------------------
c LOOK FOR MATCHING TRIANGLES
c
c now make a list of operators relating triangles
c
CMDW clear from here that tolerance = 0.0 will never work.
      nops=0
      do i=1,ntri-1
       do j=i+1,ntri
        r1 = sqrt( (dist12(i)-dist12(j))**2 +
     +             (dist23(i)-dist23(j))**2 +
     +             (dist31(i)-dist31(j))**2 )
        if (r1.lt.tolerance) then
         nops=nops+1
         if (nops.gt.MAXNOPS) then
           write(6,'(/,A,I8,/,A,/)') 
     +       'Number of operators exceeds maximum: ',MAXNOPS,
     +       'Reduce arguments of DISTANCE or TOLERANCE keywords.'
           call ccperr(1,'Parameter MAXNOPS exceeded.')
         endif
         trig1(nops) = i
         trig2(nops) = j
         distop(nops) = r1
        endif
       enddo
      enddo
      write(6,*) 
     + ' number of operators to check between matched triangles',nops

      if (nops.eq.0) then
        write(6,'(/,''No operators found.'',/, 
     +     ''Try increasing the value of the tolerance, '',
     +     ''see the TOLERANCE keyword.'',/)')
      endif
      if (verbose) write(6,'(///,A,/,A,/A)')
     +  ' ###########################################################',
     +  ' LIST OF OPERATORS BETWEEN TRIANGLES plus Extra Related Atoms',
     +  ' ############################################################'
c
c ------------------------------
c DO SOME INTERMEDIATE OUTPUT
c
c sort the triangle pairs by match
c
c      call shsort(distop,sortops,nops)
c
c now write the operators in order of match quality
c
c      do i = 1, nops
c       j = sortops(i)
c       write (*,*)chainid(trig1(j)),chainid(trig2(j)),distop(j)
c      enddo
c
c done triangle output
c
c ------------------------------
c TRY OUT OPS ON REMAINING ATOMS
c
c search for any more matching atoms
c
      mlsq = 0
      mops = 0
c
c now consider each op in turn
      do i = 1, nops
      rchk(1,1,i) = 999.0
c
c CREATE THE INITIAL NCS-RELATED ATOM GROUPS
       nlsq = 3
c get source atoms
       codex1(1) = code1(trig1(i))
       codex1(2) = code2(trig1(i))
       codex1(3) = code3(trig1(i))
c get target atoms, 
       codex2(1) = code1(trig2(i))
       codex2(2) = code2(trig2(i))
       codex2(3) = code3(trig2(i))
         lreject = .false.
         do j = 1,3
          do k = 1,3
           if(codex1(j) .eq. codex2(k)) lreject = .TRUE.
          end do 
         enddo 
         if(lreject) go to 800
c       write (*,190)i,distop(i),chainid(trig1(i)),chainid(trig2(i))
        l1 = lenstr(segid(trig1(i)))
        l2 = lenstr(segid(trig2(i)))
       if (verbose) write (*,190)
     +  i,distop(i),trig1(i),segid(trig1(i))(1:l1),
     +              trig2(i),segid(trig2(i))(1:l2)
 190   format (//,' Operator',i5,'  Initial agreement ',f7.3,
     +           ' Triangle IDs ', I5,2x,A,':',I5,2x,A)
c
c EXPAND THE NCS-RELATED ATOM GROUPS
c now we iterate several times, calculating the ops,
c then adding the new atom which most closely obeys those ops
       do j=1,1000
c find operator mapping 1->2 and cetroid of 1
        call get_match_op(nlsq,codex1,codex2,rot)
        call get_cent_orth(nlsq,codex1,xr,yr,zr)
c find list of atoms matching under the operator
        call get_match_atom(rot,xr,yr,zr,nlsqn,coden2,coden1,
     +                      rmatch,tolerance)
c        if (verbose) write (*,*)'extra atoms j nlsq nlsqn:',j,nlsq,nlsqn
        if (nlsqn .lt. nlsq) goto 220
c now search through new list
        m = -1
        r1 = 1.0e6
        do k = 1, nlsqn
c check if it is already in old list
         do l = 1, nlsq
          if (coden1(k) .eq. codex1(l)) goto 210
         enddo
c if not, it is a candidate for addition
         if ( m .lt. 0 ) m = k
         if ( rmatch(k) .lt. rmatch(m) ) m = k
 210     continue
        enddo
        if ( m .lt. 0 ) goto 220
c add one atom
        nlsq = nlsq + 1
        codex1(nlsq) = coden1(m)
        codex2(nlsq) = coden2(m)
       enddo
c
c if last atom made things worse, get rid of it
 220   if (nlsqn .lt. nlsq) nlsq = nlsq - 1
       if (nlsq .lt. 3) goto 800
c
c PICK A COMMON SET OF ATOMS AND DECONVOLUTE XTAL/NON-XTAL SYMM
c now move the first set of atoms using xtal symm and repeat
c to match the preferred set
       call match_to_pref(codepref,codex1,nlsq)
c
c update the preferred set if necessary
       if ( nlsq .gt. mlsq ) then
        do j = 1, nlsq
         jatm = atomcode_atom(codex1(j))
         codepref(jatm) = codex1(j)
        enddo
       endif
c
c now move the second set of atoms using xtal symm and repeat
c to match the preferred set
       call match_to_pref(codepref,codex2,nlsq)
c
c update the preferred set if necessary
       if ( nlsq .gt. mlsq ) then
        do j = 1, nlsq
         jatm = atomcode_atom(codex2(j))
         codepref(jatm) = codex2(j)
        enddo
       endif
c
c update the best hit
       mlsq = max( mlsq, nlsq )
c find operator mapping 1->2 and centroid of 1
       call get_match_op(nlsq,codex1,codex2,rot)
       call get_cent_orth(nlsq,codex1,xr,yr,zr)
       call get_match_atom(rot,xr,yr,zr,nlsq,codex2,codex1,rmatch,
     +                     tolerance)
c       write (*,*)' CHK ',(chk(j),j=1,10),nlsq
c
c NOW ANALYSE THE RELATED ATOMS if there are any!
       if(nlsq.lt.3) then
         write (*,'(a,i5,a)') ' Operator',i,'  Poor match - ignored'
         go to 800
       end if
c look for loops to get order of NCS
       do j = 1, nlsq
        loop(j) = 0
        n = j
        do k = 1, nlsq
c .. find the next atom in the chain
         do l = 1, nlsq
          if ( codex1(l) .eq. codex2(n) ) goto 110
         enddo
         loop(j) = 0
         goto 120
c .. next step in loop
 110     n = l
         loop(j) = loop(j) + 1
         if ( n .eq. j ) goto 120
        enddo
 120    continue
       enddo
c
c OUTPUT RESULTS
c some output
       loopmx = 0
       nloop = 1
       do iatm = 1,nlsq
        if(verbose) write (*,710)
     +    iser(atomcode_atom(codex1(iatm))),
     +    atomcode_symm(codex1(iatm)), atomcode_du(codex1(iatm)),
     +    atomcode_dv(codex1(iatm)), atomcode_dw(codex1(iatm)),
     +    iser(atomcode_atom(codex2(iatm))),
     +    atomcode_symm(codex2(iatm)), atomcode_du(codex2(iatm)),
     +    atomcode_dv(codex2(iatm)), atomcode_dw(codex2(iatm)),
     +    rmatch(iatm),loop(iatm)
        write (lines(iatm),710)
     +    iser(atomcode_atom(codex1(iatm))),
     +    atomcode_symm(codex1(iatm)), atomcode_du(codex1(iatm)),
     +    atomcode_dv(codex1(iatm)), atomcode_dw(codex1(iatm)),
     +    iser(atomcode_atom(codex2(iatm))),
     +    atomcode_symm(codex2(iatm)), atomcode_du(codex2(iatm)),
     +    atomcode_dv(codex2(iatm)), atomcode_dw(codex2(iatm)),
     +    rmatch(iatm),loop(iatm)
C   Store atom coordinate here:
C
C 1st atom ( chain F for first)
          k = codex1(iatm)
          katm = atomcode_atom(k)
          call get_orth_from_code(k,xs,ys,zs)
           atnm(1,iatm) = atnam(katm) 
           resnm(1,iatm) = resnam(katm) 
           chain(1,iatm) = 'F'
           resn(1,iatm) = resno(katm) 
           inscd(1,iatm) = inscod(katm) 
           altcd(1,iatm) = altcod(katm) 
           izz(1,iatm) = iz(katm) 
           idd(1,iatm) = id(katm) 
           xss(1,1,iatm) = xs
           xss(1,2,iatm) = ys
           xss(1,3,iatm) = zs
           bis(1,iatm) = biso(katm)
           oc(1,iatm) = occ(katm)

C 2nd atom ( chain S for second)
          k = codex2(iatm)
          katm = atomcode_atom(k)
          call get_orth_from_code(k,xs,ys,zs)
           atnm(2,iatm) = atnam(katm) 
           resnm(2,iatm) = resnam(katm) 
           chain(2,iatm) = 'S'
           resn(2,iatm) = resno(katm) 
           inscd(2,iatm) = inscod(katm) 
           altcd(2,iatm) = altcod(katm) 
           izz(2,iatm) = iz(katm) 
           idd(2,iatm) = id(katm) 
           xss(2,1,iatm) = xs
           xss(2,2,iatm) = ys
           xss(2,3,iatm) = zs
           bis(2,iatm) = biso(katm)
           oc(2,iatm) = occ(katm)

C          call xyzatom(lpdb,3*i-2,atnam(katm),resnam(katm),
C     +         chainid(j),1,resno(katm),inscod(katm),
C     +         altcod(katm),chainid(j),iz(katm),id(katm))
C          call xyzcoord(lpdb,'O','U',xs,ys,zs,
C     +         occ(katm),biso(katm),baniso)
C          call xyzadvance(lpdb,0,1,*900,*900)
C
       if(loop(iatm) .gt. loopmx) loopmx = loop(iatm)
         if(loop(iatm).gt.2) then
          if(iatm.eq.1)Nat(1,nloop) = iser(atomcode_atom(codex1(iatm)))
          if(iatm.eq.1)Nat(2,nloop) = iser(atomcode_atom(codex2(iatm)))
          if(iatm.eq.1 .and. verbose)write(6,*)
     +     ' A',nloop,(Nat(ii,nloop),ii=1,2)
           if(iatm.gt.1) then
             do iloop = 1,nloop
              found = .false.
              do iatloop = 2,loop(iatm)
c       write(*,'(A,i4,3x,40i5)')' check',
c     +iloop,iatloop,iser(atomcode_atom(codex1(iatm))),
c     +  (Nat(ii,iloop),ii=1,loop(iatm))
               if(iser(atomcode_atom(codex1(iatm))) 
     +                     .eq. Nat(iatloop,iloop))  then
                Nat(iatloop+1,iloop) = iser(atomcode_atom(codex2(iatm)))
                if(verbose) write(6,'(a,8i4)')' T', 
     +                            iloop,(Nat(ii,iloop),ii=1,iatloop+1)
                found = .true.
                go to 712
               end if
              end do 
             end do 
C No match found
              nloop = nloop + 1
              Nat(1,nloop) = iser(atomcode_atom(codex1(iatm)))
              Nat(2,nloop) = iser(atomcode_atom(codex2(iatm)))
                if(verbose) write(6,'(a,8i4)')' F', 
     +                            nloop,(Nat(ii,nloop),ii=1,iatloop+1)
c
 712       continue
           end if
         end if
 710    format( 2(1x,i5,' [',i2,SP,3i2,S,']'),' Dist',f5.2,' Loop',i3)
       enddo
C
C         write cds if this is list  is at least half as long as the longest so far..
       LWRITE=.FALSE. 
         if( mentries/2.le.nlsq.or.listall) THEN
            LWRITE=.TRUE. 
            if(nlsq.gt.mentries) mentries = nlsq
         end if
c
            LPRINT=.FALSE. 
c  Check if this rotation seen before
           call matrixtopolarkabsch(rot,xr,yr,zr,lprint)
           call rbrinv(rot,rchk(1,1,i))
            if(i.gt.1) then
               do ichk = 1,i-1
                if(rchk(1,1,ichk).ne.999.0) then
                 call matmul4(prod,rot,rchk(1,1,ichk))           
                 call matrixtopolarkabsch(prod,xrp,yrp,zrp,lprint)
C  We have found this solution before
                  if ( abs(zrp).le.2.0) then
                    if (verbose) write(6,'(a,i5,a,i5)')' Operator',i,
     +                               '  duplicates operator', ichk
                     go to 800
                  end if 
c       write (*,195)i,xr*180/3.1416,yr*180/3.1416,zr*180/3.1416,loopmx,
c     +              nlsq
                end if 
               end do 
            end if
       if (verbose) write (*,195)i,xr,yr,zr,loopmx,nlsq
 195   format (/,' Operator',i5,' Polar ',3f8.2,
     +           ' Rotation Order:', i4,
     +           ' Natoms paired',i4)
c
C count number of accepted operators and store info for sorting later
        mops = mops +1
        if (mops.gt.MAXMOPS) then
           write(6,'(/,A,I8,/,A,/)') 
     +       'Number of operators exceeds maximum: ',MAXMOPS,
     +       'Reduce arguments of DISTANCE or TOLERANCE keywords.'
           call ccperr(1,'Parameter MAXMOPS exceeded.')
        endif
        nopr(mops) = i
        xrr(mops) = xr
        yrr(mops) = yr
        zrr(mops) = zr
        txrr(mops) = rot(1,4)
        tyrr(mops) = rot(2,4)
        tzrr(mops) = rot(3,4)
        call matrixtoeuler( rot, exrr(mops), eyrr(mops), ezrr(mops) )
        call get_cent_orth(nlsq,codex1,
     +                     cxrr1(mops),cyrr1(mops),czrr1(mops))
        call kevmatvec(rot,cxrr1(mops),cyrr1(mops),czrr1(mops),
     +                     cxrr2(mops),cyrr2(mops),czrr2(mops))
C  Pack natoms plus loop order into one word for sorting later
        atloopr(mops) = 10*nlsq + loopmx + (1.0 -0.0001*mops)
C  Count how many atoms of the set of involved in this operator?
          do iatm = 1,natm
            jchk(iatm)=0
          end do
          do iatm = 1,nlsq
           read (lines(iatm),'(I6,11x,I6)')iser1,iser2
           jchk(iser1) = 1
           jchk(iser2) = 1
          end do 
          do iatm = 1,natm
            natr(mops) = natr(mops) + jchk(iatm)
          end do
C
       if(xyzout .and. LWRITE)  then
         write (rmrk,'(a,3x,I5,2x,2a,I5,2x,a)')
     +  'REMARK New Set: Triangle IDs ',
     +  trig1(i), segid(trig1(i))(1:l1),':', 
     +  trig2(i), segid(trig2(i))(1:l2)

         call wremark(lpdb,rmrk)
         write (rmrk,295)i,xr,yr,zr,loopmx,nlsq
 295     format ('REMARK Op:',i5,' Polar  ',3f8.2,
     +           ' Rotation Order:', i4,
     +           ' Natoms',i4)
         call wremark(lpdb,rmrk)
       end if
C
       call matrixtoeuler(rot,xr,yr,zr)
       if (verbose) write (*,196)i,xr*rtod,yr*rtod,zr*rtod,loopmx,nlsq
 196   format (' Operator',i5,' Euler ',3f7.1,
     +           ' Rotation Order:', i4,
     +           ' Natoms paired',i4)
       if (verbose) write(*,197)i,rot(1,4),rot(2,4),rot(3,4),natr(mops)
 197   format (' Operator',i5,' Trans in As',3f8.2,
     +           ' Number of input atoms used:', i4)
       if(xyzout .and. LWRITE)  then
         write (rmrk,297)i,rot(1,4),rot(2,4),rot(3,4),natr(mops)

 297     format ('REMARK Op:',i5,' Trans_A',3f8.2,
     +           ' Natoms',i4)
         call wremark(lpdb,rmrk)
C
C  Write atom list
         write (rmrk,'(a,i4,a)')'REMARK  ',nlsq,' Atom Matches'
         call wremark(lpdb,rmrk)
          do iatm = 1,nlsq
           write (rmrk,'(A,1x,i3,5x, A35)')
     +     'REMARK atom pairs labelled F & S',iatm,lines(iatm)
           call wremark(lpdb,rmrk)
          end do 
C 1st atoms ( chain F for first)
          do iatm = 1,nlsq
            call xyzatom(lpdb,iatm,atnm(1,iatm),resnm(1,iatm),
     +           chain(1,iatm),iatm,resn(1,iatm),inscd(1,iatm),
     +           altcd(1,iatm),chain(1,iatm),izz(1,iatm),idd(1,iatm))
            bb = bis(1,iatm)
              baniso(1)=bb
            do ianiso=2,6
              baniso(ianiso)=0.0
            enddo
            call xyzcoord(lpdb,'O','U',xss(1,1,iatm),xss(1,2,iatm),
     +           xss(1,3,iatm),oc(1,iatm),bb,baniso)
            call xyzadvance(lpdb,0,1,*900,*900)
          end do 
C 2nd atoms ( chain S for second)
          do iatm = 1,nlsq
            call xyzatom(lpdb,iatm+1000,atnm(2,iatm),resnm(2,iatm),
     +           chain(2,iatm),iatm,resn(2,iatm),inscd(2,iatm),
     +           altcd(2,iatm),chain(2,iatm),izz(2,iatm),idd(2,iatm))
            bb = bis(2,iatm)
              baniso(1)=bb
            do ianiso=2,6
              baniso(ianiso)=0.0
            enddo
            call xyzcoord(lpdb,'O','U',xss(2,1,iatm),xss(2,2,iatm),
     +                    xss(2,3,iatm),oc(2,iatm),bb,baniso)
            call xyzadvance(lpdb,0,1,*900,*900)
          end do 
cxxx         end if
       end if
C
c next op
 800   continue
      enddo
        if(xyzout) call xyzclose(lpdb)

      write(6,'(//A,/,A,I5,/,A)')  
     +  '##################################',
     +  ' Number of unique operators',mops,
     +  '##################################'
      write(6,'(////A)')
     +' These will now be sorted according to Natoms and rotation loop'

      call shsort(atloopr,sortops,mops)

        do i = mops,1, -1
          j = sortops(i)
C remove the extra flag used to order operators.
          atloopr(j) = int(atloopr(j))
          nlsq = int(atloopr(j)/10.0 + 0.1)
          loopmx = nint(atloopr(j) - 10*nlsq)
          atloopr(j) = loopmx
          write (*,195)nopr(j),xrr(j),yrr(j),zrr(j),loopmx,nlsq
          write (*,197)nopr(j),txrr(j),tyrr(j),tzrr(j),natr(j)
          write (*,199)nopr(j),natr(j),natm
c kdc fix for dm next 2 lines
          write (*,396)nopr(j),exrr(j)*rtod,eyrr(j)*rtod,ezrr(j)*rtod,
     +                         txrr(j),tyrr(j),tzrr(j)
 396      format (' Operator',i5,' Euler+Trans for dm: ',6f8.2)
c kdc fix for parrot next 2 lines
          write (*,397)exrr(j)*rtod,eyrr(j)*rtod,ezrr(j)*rtod,
     +         cxrr1(j),cyrr1(j),czrr1(j),cxrr2(j),cyrr2(j),czrr2(j)
 397      format ('  Euler+src+dst:',3f7.1,2x,3f7.1,2x,3f7.1)
c  Get direction cosines of axis
         if(yrr(j) .gt.999.0) then
            dc11 = 0
            dc12 = 0
            dc13 = 1
          else
            dc11 = sin(xrr(j)*dtor)*cos(yrr(j)*dtor)
            dc12 = sin(xrr(j)*dtor)*sin(yrr(j)*dtor)
            dc13 = cos(xrr(j)*dtor)
          end if
          if(i.lt.mops ) then
            do ii = mops,i+1,-1
              jj = sortops(ii)
               if(yrr(jj) .gt.999.0) then
                 dc21 = 0
                 dc22 = 0
                 dc23 = 1
               else
                 dc21 = sin(xrr(jj)*dtor)*cos(yrr(jj)*dtor)
                 dc22 = sin(xrr(jj)*dtor)*sin(yrr(jj)*dtor)
                 dc23 = cos(xrr(jj)*dtor)
               end if
               bb = dc11*dc21+dc12*dc22+dc13*dc23
               if(bb.lt.-1.0) bb=-1.0
               if(bb.gt. 1.0) bb= 1.0
              ang(ii,i) =  -1.0
c   If this operator has rotation order > 0, then find angle
              if( atloopr(j).gt.0.1 .and. atloopr(jj).gt.0.1) 
     +            ang(ii,i) = acos(bb)*rtod
            end do 
          end if
        end do 
 199   format (' Operator',i5,' Number of input atoms used', 
     +  I4,'  from set of',I4)
c
      write(6,'(//A,/,A,/,A,/,A)')  
     +  '########################################################',
     +  ' Angles between best operators with non-zero rotation order',
     +  ' - check for higher symmetry such as tetramers, hexamers',
     +  '  Angle equal -1.0 indicates zero rotation order',
     +  '########################################################'

          ii = max(1,mops-10)
          iu = max(1,mops-22)
          write(6,'(/A,11I7)')
     +  '    To:', ( nopr(sortops(i)),i=mops,ii,-1)
          write(6,'(A,11I7)')
     +  '  Rotn:',( nint(zrr(sortops(i))),i=mops,ii,-1)
          write(6,'(A,11I7)')
     +  ' Order:',( nint(atloopr(sortops(i))),i=mops,ii,-1)
          write(6,'(A)')' From:'
        do i = mops-1,iu,-1
          l1 = i+1
          if( mops -l1 .le.10 .and. atloopr(sortops(i)) .gt.0.5)
     +   write(6,'(i7,11f7.1)')nopr(sortops(i)),
     +  (ang(ii,i),ii=mops,l1,-1)
          if( mops -l1 .gt.10 .and. atloopr(sortops(i)) .gt.0.5)
     +   write(6,'(i7,11f7.1)')nopr(sortops(i)),
     +  (ang(ii,i),ii=mops,mops-10,-1)
        end do 
C
         if(ii.gt.2) then
          iv = max(1,mops-21)
            ichk = 0
            do i=mops-11,iv,-1
             ichk = ichk + abs(atloopr(sortops(i)))
            end do 
         if(ichk.gt.0) then
          iu = max(1,mops-22)
          write(6,'(/A,11I7)')
     +  '       To:', ( nopr(sortops(i)),i=mops-11,iv,-1)
          write(6,'(A,11I7)')
     +  '     Rotn:',( nint(zrr(sortops(i))),i=mops-11,iv,-1)
          write(6,'(A,11I7)')
     +  '    Order:',( nint(atloopr(sortops(i))),i=mops-11,iv,-1)
          write(6,'(A)')'     From:'
        do i = mops-12,iu,-1
          if( atloopr(sortops(i)) .gt.0.5)
     +       write(6,'(i10,11f7.1)')nopr(sortops(i)),
     +      (ang(ii,i),ii=mops-11,i+1,-1)
        end do 
         end if
         end if
c       do j = 1, 3
c          call kevmatvec(rot,uvw1(1,j),uvw1(2,j),uvw1(3,j),xs,ys,zs)
c          write (*,'(6f12.3)')uvw2(1,j),uvw2(2,j),uvw2(3,j),xs,ys,zs
c       enddo
c       write (*,'(4f13.4)')((rot(j,k),k=1,4),j=1,3)
c
        if(xyzout) call xyzclose(lpdb)
      call ccperr(0,' PROFESSS - normal termination ')      
      stop
      end
c
c ----------------------------------------------------------------------
c
      subroutine match_to_pref(atompref,codex,nlsq)
c find crystal sym and repeat to match codes in codex to atompref
c params
      integer nlsq,atompref(*),codex(*)
c commons
      integer nsym
      real rsym(4,4,192)
      real m11, m22, m33, m12, m13, m23
      common /crystal/nsym,rsym,m11,m22,m33,m12,m13,m23
c locals
      integer i,n,m,iatm,isym,msym,iu,iv,iw
      real u,v,w,us,vs,ws,u0,v0,w0
c externals
      integer new_atomcode,atomcode_atom
      external new_atomcode,atomcode_atom
c
c find symop which matches most atoms onto prefered sym
      msym = 0
      m = -1
      do isym = 1, nsym
       n = 0
       do i = 1, nlsq
        iatm = atomcode_atom(codex(i))
        if ( atompref(iatm) .ge. 0) then
         call get_frac_from_code(codex(i),u,v,w)
         call kevmatvec(rsym(1,1,isym),u,v,w,us,vs,ws)
         call get_frac_from_code(atompref(iatm),u0,v0,w0)
         if ( fracp(us-u0)**2 + fracp(vs-v0)**2 +
     +        fracp(ws-w0)**2 .lt. 1.0e-6 ) n = n + 1
        endif
       enddo
       if ( n .gt. m ) then
        m = n
        msym = isym
       endif
      enddo
c
c now find translation which matches the sym atoms
      iu = 0
      iv = 0
      iw = 0
      n = 0
      do i = 1, nlsq
       iatm = atomcode_atom(codex(i))
       if ( atompref(iatm) .ge. 0 ) then
        call get_frac_from_code(codex(i),u,v,w)
        call kevmatvec(rsym(1,1,msym),u,v,w,us,vs,ws)
        call get_frac_from_code(atompref(iatm),u0,v0,w0)
        iu = iu + nint(u0-us)
        iv = iv + nint(v0-vs)
        iw = iw + nint(w0-ws)
        n = n + 1
       endif
      enddo
      iu = nint( real(iu)/real(max(n,1)) )
      iv = nint( real(iv)/real(max(n,1)) )
      iw = nint( real(iw)/real(max(n,1)) )
c
c now get new atom codes for the transformed atoms
      do i = 1, nlsq
       iatm = atomcode_atom(codex(i))
       call get_frac_from_code(codex(i),u,v,w)
       call kevmatvec(rsym(1,1,msym),u,v,w,us,vs,ws)
       us = us + real(iu)
       vs = vs + real(iv)
       ws = ws + real(iw)
       do isym = 1, nsym
        call get_frac_from_code(new_atomcode(iatm,isym,0,0,0),u0,v0,w0)
        if ( fracp(us-u0)**2 + fracp(vs-v0)**2 + fracp(ws-w0)**2
     +       .lt. 1.0e-6 ) codex(i) =
     +       new_atomcode(iatm,isym,nint(us-u0),nint(vs-v0),nint(ws-w0))
       enddo
      enddo
c
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine get_cent_orth(nlsq,codex1,xc,yc,zc)
      implicit none
c get the centroid of a set of atoms in orthogonals
c params
      integer nlsq,codex1(*)
      real xc,yc,zc
c locals
      real uc,vc,wc
c
      call get_cent_frac(nlsq,codex1,uc,vc,wc)
      call cvfrac2(uc,vc,wc,xc,yc,zc,0)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine get_cent_frac(nlsq,codex1,uc,vc,wc)
      implicit none
c get the centroid of a set of atoms in fractionals
c params
      integer nlsq,codex1(*)
      real uc,vc,wc
c locals
      integer j
      real u,v,w
c
      uc = 0.0
      vc = 0.0
      wc = 0.0
      do j=1,nlsq
       call get_frac_from_code(codex1(j),u,v,w)
       uc = uc + u/nlsq
       vc = vc + v/nlsq
       wc = wc + w/nlsq
      enddo
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine get_match_op(nlsq,codex1,codex2,rot)
      implicit none
c get op relating two groups of atoms
      integer nlsq,codex1(*),codex2(*)
      real rot(4,4)
      integer j
      real xyz1(3,10000),xyz2(3,10000)
c get the two sets of matched atoms
      do j=1,nlsq
       call get_orth_from_code(codex1(j),xyz1(1,j),xyz1(2,j),xyz1(3,j))
       call get_orth_from_code(codex2(j),xyz2(1,j),xyz2(2,j),xyz2(3,j))
      enddo
c get lsq matrices
      call lsqfit(xyz1,xyz2,nlsq,rot)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine get_match_atom(rot,xc,yc,zc,nlsq,codex1,codex2,
     +                          rmatch,dist)
      implicit none
      integer MAXATM, MAXTRI, MAXATS
      parameter (MAXATM=10000,MAXTRI=20000,MAXATS=40000)
c get atoms which match under op
c params
      integer nlsq, codex1(*),codex2(*)
      real rot(4,4), xc, yc, zc, rmatch(*), dist
c commons
      integer nsym
      real rsym(4,4,192)
      real m11, m22, m33, m12, m13, m23
      common /crystal/nsym,rsym,m11,m22,m33,m12,m13,m23
c
      integer natm
      real uvw(3,MAXATM)
      common /atoms/natm,uvw
c locals
      integer codem1(MAXATS),codem2(MAXATS)
      real uvw1(3,MAXATS),uvw2(3,MAXATS)
c
      integer j, iatm, jatm, jsym, nmat
      real xr, yr, zr, xs, ys, zs, du, dv, dw
      real ujc, vjc, wjc, ukc, vkc, wkc
      real ujs, vjs, wjs, uks, vks, wks
      real r
c externals
      integer new_atomcode, atomcode_atom, atomcode_symm
      integer atomcode_du, atomcode_dv, atomcode_dw
      real get_dist_frac
      external new_atomcode, atomcode_atom, atomcode_symm
      external atomcode_du, atomcode_dv, atomcode_dw
      external get_dist_frac
c
c First we make two sets of atoms. The first set a full cell about the
c centroid of the transformed moleucle, and the second is a full cell
c about the centroid of the initial molecuale, rotated to fit on top
c of the transformed atoms.
c
c get centroid of target group
      call kevmatvec(rot, xc, yc, zc, xr, yr, zr)
c convert centroids to frac
      call cvfrac2(xc, yc, zc, ukc, vkc, wkc, 1)
      call cvfrac2(xr, yr, zr, ujc, vjc, wjc, 1)
c now generate centred initial and rotated molecules
      nmat = 0
      do jatm = 1, natm
c make symmetry atoms and centre them
       do jsym = 1, nsym
        call get_frac_from_code( new_atomcode(jatm,jsym,0,0,0),
     +                           ujs, vjs, wjs)
        nmat = nmat + 1
c .. centre on initial mol
        uvw1(1,nmat) = ( ujs - nint( ujs - ujc ) )
        uvw1(2,nmat) = ( vjs - nint( vjs - vjc ) )
        uvw1(3,nmat) = ( wjs - nint( wjs - wjc ) )
c .. and store code
        codem1(nmat) = new_atomcode(jatm,jsym,nint(uvw1(1,nmat)-ujs),
     +    nint(uvw1(2,nmat)-vjs),nint(uvw1(3,nmat)-wjs))
c .. centre rotated mol
        uks = ( ujs - nint( ujs - ukc ) )
        vks = ( vjs - nint( vjs - vkc ) )
        wks = ( wjs - nint( wjs - wkc ) )
c .. rotate back and store
        call cvfrac2(uks, vks, wks, xs, ys, zs, 0)
        call kevmatvec(rot, xs, ys, zs, xr, yr, zr)
        call cvfrac2(xr,yr,zr,uvw2(1,nmat),uvw2(2,nmat),uvw2(3,nmat),1)
c .. and store code
        codem2(nmat) = new_atomcode(jatm,jsym,
     +    nint(uks-ujs),nint(vks-vjs),nint(wks-wjs))
       enddo
      enddo
c
c Secondly, we search the two sets of atoms and count how many are
c superimposed. These will be returned
c
c count how many atoms match under this op
      nlsq = 0
      do iatm = 1, nmat
       do jatm = 1, nmat
        du = uvw1(1,iatm) - uvw2(1,jatm)
        dv = uvw1(2,iatm) - uvw2(2,jatm)
        dw = uvw1(3,iatm) - uvw2(3,jatm)
        r = get_dist_frac(du,dv,dw)
        if (r.lt.dist) then
         nlsq = nlsq + 1
         codex1(nlsq) = codem1(iatm)
         codex2(nlsq) = codem2(jatm)
         rmatch(nlsq) = r
        endif
       enddo
      enddo
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine get_orth_from_code(code,ax,ay,az)
      implicit none
c get orth coords for a given atom code
c params
      real ax,ay,az
      integer code
c locals
      real u,v,w
c
      call get_frac_from_code(code,u,v,w)
      call cvfrac2(u,v,w,ax,ay,az,0)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine get_frac_from_code(code,u,v,w)
      implicit none
c get frac coords for a given atom code
      integer MAXATM, MAXTRI, MAXATS
      parameter (MAXATM=10000,MAXTRI=20000,MAXATS=40000)
c params
      integer code
      real u,v,w
c commons
      integer nsym
      real rsym(4,4,192)
      real m11, m22, m33, m12, m13, m23
      common /crystal/nsym,rsym,m11,m22,m33,m12,m13,m23
c
      integer natm
      real uvw(3,MAXATM)
      common /atoms/natm,uvw
c locals
      integer iatm
      real uks,vks,wks
c externals
      integer atomcode_atom,atomcode_symm
      integer atomcode_du,atomcode_dv,atomcode_dw
      external atomcode_atom,atomcode_symm
      external atomcode_du,atomcode_dv,atomcode_dw
c
      iatm = atomcode_atom(code)
      call kevmatvec(rsym(1,1,atomcode_symm(code)),
     +            uvw(1,iatm), uvw(2,iatm), uvw(3,iatm), uks, vks, wks)
      u = uks + atomcode_du(code)
      v = vks + atomcode_dv(code)
      w = wks + atomcode_dw(code)
      return
      end
c
c ----------------------------------------------------------------------
c
      integer function new_atomcode(atom,symm,du,dv,dw)
      implicit none
      integer atom,symm,du,dv,dw
      new_atomcode = (atom * 192 + symm) * 125
     +             + (du+2)*25 + (dv+2)*5 + (dw+2)
      return
      end
c
      integer function atomcode_atom(atomcode)
      implicit none
      integer atomcode
      atomcode_atom = atomcode / (192*125)
      return
      end
c
      integer function atomcode_symm(atomcode)
      implicit none
      integer atomcode
      atomcode_symm = mod( atomcode / 125, 192 )
      return
      end
c
      integer function atomcode_du(atomcode)
      implicit none
      integer atomcode
      atomcode_du = mod( atomcode/25, 5 ) - 2
      return
      end
c
      integer function atomcode_dv(atomcode)
      implicit none
      integer atomcode
      atomcode_dv = mod( atomcode/5, 5 ) - 2
      return
      end
c
      integer function atomcode_dw(atomcode)
      implicit none
      integer atomcode
      atomcode_dw = mod( atomcode, 5 ) - 2
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine matmat(m1,m2,m3)
      implicit none
      real m1(4,4),m2(4,4),m3(4,4)
      integer i,j,k
      do i=1,4
       do k=1,4
        m3(i,k)=0.0
        do j=1,4
         m3(i,k)=m3(i,k)+m1(i,j)*m2(j,k)
        enddo
       enddo
      enddo
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine matcpy(m1,m2)
      implicit none
      real m1(*),m2(*)
      integer i
      do i = 1, 16
       m2(i)=m1(i)
      enddo
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine kevmatvec(m,u,v,w,x,y,z)
      implicit none
      real m(4,4),u,v,w,x,y,z
      x = m(1,1)*u + m(1,2)*v + m(1,3)*w + m(1,4)
      y = m(2,1)*u + m(2,2)*v + m(2,3)*w + m(2,4)
      z = m(3,1)*u + m(3,2)*v + m(3,3)*w + m(3,4)
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine lsqfit(u,v,nx,rot)
      implicit none
c Kabsch fitting of model in x to model in y.
      integer nx,i,j,k
      real u(3,*),v(3,*),rot(4,4)
      REAL TR(3),TRMAT(3,3),X(3,100),Y(3,100)
c
      REAL CNTRX(3),CNTRY(3),SCR(3),XT(3),SCR1(3),DCCXCY(3)
        REAL D,DCENTR,DCHK,DISMAX,DRMS,EZERO,RMSMC,RMSSC,SUMD2,
     +     SUMDIS,TR1,TR2,TR3,SUMB,SUMB2,DCCXCYSQ
        DOUBLE PRECISION EE(6),RKTRK(3,3),RK(3,3),VP(3,3),RA(3,3),
     +     XNORM(3),RANR(3,3),TRMM(3,3)
      EXTERNAL EIGEN
C
C---- Calculate centroids
C
      DISMAX = 0.0
      SUMB  = 0.0
      SUMB2 = 0.0
      SUMD2 = 0.0
      SUMDIS = 0.0
      DO 20 I = 1,3
        DCCXCY(I) = 0.0
        CNTRX(I) = 0.0
        CNTRY(I) = 0.0
        DO 10 J = 1,3
          TRMM(J,I) = 0.0d0
          TRMAT(J,I) = 0.0
   10   CONTINUE
   20 CONTINUE
      TRMAT(1,1) = 1.0
      TRMAT(2,2) = 1.0
      TRMAT(3,3) = 1.0
      TRMM(1,1) = 1.0d0
      TRMM(2,2) = 1.0d0
      TRMM(3,3) = 1.0d0
c
        DO 50 I = 1,NX
            DO 30 J = 1,3
               x(j,i)=u(j,i)
               y(j,i)=v(j,i)
               CNTRX(J) = CNTRX(J) + X(J,I)
               CNTRY(J) = CNTRY(J) + Y(J,I)
 30        CONTINUE
C
C---- Reference molecule centroid
C
 50      CONTINUE
C           
C  Get Direction cosines of vector between centroids to check for pure rotation.
        DCCXCYSQ = 0.0
        DO 60 J = 1,3
          CNTRX(J) = CNTRX(J)/NX
          CNTRY(J) = CNTRY(J)/NX
          DCCXCY(J) = CNTRX(J) - CNTRY(J) 
          DCCXCYSQ = DCCXCYSQ + DCCXCY(J)*DCCXCY(J)
c          IF (CENFLG.NE.0.0) RCEN(J) = CNTRY(J) - RCEN(J)
   60   CONTINUE
C  If the centroids are identical then DCCXCYSQ will be zero
C  so trap for this:
        DCCXCYSQ = MAX(DCCXCYSQ,1.0e-20)
        DCCXCYSQ = SQRT(DCCXCYSQ)
        DCCXCY(1) = DCCXCY(1)/DCCXCYSQ
        DCCXCY(2) = DCCXCY(2)/DCCXCYSQ
        DCCXCY(3) = DCCXCY(3)/DCCXCYSQ
c        WRITE (*,FMT=6010) CNTRX,SCR,CNTRY,SCR1,DCCXCYSQ,DCCXCY
        DO 80 I = 1,NX
C
C---- Translate working molecule to origin
C
          DO 70 J = 1,3
            X(J,I) = X(J,I) - CNTRX(J)
            Y(J,I) = Y(J,I) - CNTRY(J)
   70     CONTINUE
   80   CONTINUE
C
C---- Get matrix r = sum(y.x)
C
        DO 120 I = 1,3
          DO 110 J = 1,3
            RK(I,J) = 0.0d0
  110     CONTINUE
  120   CONTINUE
        DO 150 K = 1,NX
           DO 140 I = 1,3
              DO 130 J = 1,3
                 RK(I,J) = DBLE(Y(I,K)*X(J,K)) + RK(I,J)
 130          CONTINUE
 140       CONTINUE
 150    CONTINUE
C
C---- Get rktrk  =  rktranspsed  *  rk
C
        DO 200 I = 1,3
          DO 190 J = 1,3
            RKTRK(I,J) = 0.0
            DO 180 K = 1,3
              RKTRK(I,J) = RK(K,I)*RK(K,J) + RKTRK(I,J)
  180       CONTINUE
  190     CONTINUE
  200   CONTINUE
        EE(1) = RKTRK(1,1)
        EE(2) = RKTRK(1,2)
        EE(3) = RKTRK(2,2)
        EE(4) = RKTRK(1,3)
        EE(5) = RKTRK(2,3)
        EE(6) = RKTRK(3,3)
C
C---- Call nag routine :  eigenvalues in  r
C                      :  eigenvectors normalized in vp
C                           (sorted in ascending order)
C                           (e   working array)
C
C---- Rreplace with eigen from prjang
C
        CALL EIGEN(EE,VP,3,0)
C
C---- Set vp(.1)=vp(.,3) x vp(.,2)
C
        VP(1,1) = VP(2,3)*VP(3,2) - VP(3,3)*VP(2,2)
        VP(2,1) = VP(3,3)*VP(1,2) - VP(1,3)*VP(3,2)
        VP(3,1) = VP(1,3)*VP(2,2) - VP(2,3)*VP(1,2)
C
C---- Get  ra = r . v
C
        DO 230 K = 1,3
          DO 220 I = 1,3
            RA(I,K) = 0.0d0
            DO 210 J = 1,3
              RA(I,K) = RK(I,J)*VP(J,K) + RA(I,K)
  210       CONTINUE
  220     CONTINUE
  230   CONTINUE
C
C---- Norm.   ra(.,2) & ra(.3)
C
        DO 250 J = 1,3
          XNORM(J) = 0.0d0
          DO 240 I = 1,3
            XNORM(J) = RA(I,J)**2 + XNORM(J)
  240     CONTINUE
          XNORM(J) = 1.0d0/SQRT(XNORM(J))
  250   CONTINUE
        DO 270 J = 1,3
          DO 260 I = 1,3
            RANR(I,J) = RA(I,J)*XNORM(J)
  260     CONTINUE
  270   CONTINUE
C
C---- Set ranr(.,1) = ranr(.,3) x ranr(.,2)
C
        RANR(1,3) = RANR(2,2)*RANR(3,1) - RANR(3,2)*RANR(2,1)
        RANR(2,3) = RANR(3,2)*RANR(1,1) - RANR(1,2)*RANR(3,1)
        RANR(3,3) = RANR(1,2)*RANR(2,1) - RANR(2,2)*RANR(1,1)
C
C---- Transformation matrix
C
        DO 310 I = 1,3
          DO 300 J = 1,3
            TRMM(I,J) = 0.0d0
            DO 290 K = 1,3
              TRMM(I,J) = RANR(I,K)*VP(J,K) + TRMM(I,J)
  290       CONTINUE
            TRMAT(I,J) =  REAL(TRMM(I,J))
  300     CONTINUE
  310   CONTINUE
      TR(1) = -TRMAT(1,1)*CNTRX(1) - TRMAT(1,2)*CNTRX(2) -
     +        TRMAT(1,3)*CNTRX(3) + CNTRY(1)
      TR(2) = -TRMAT(2,1)*CNTRX(1) - TRMAT(2,2)*CNTRX(2) -
     +        TRMAT(2,3)*CNTRX(3) + CNTRY(2)
      TR(3) = -TRMAT(3,1)*CNTRX(1) - TRMAT(3,2)*CNTRX(2) -
     +        TRMAT(3,3)*CNTRX(3) + CNTRY(3)

      do i=1,3
         do j=1,3
            rot(i,j) = TRMM(I,j)
         enddo
         rot(i,4) = tr(i)
         rot(4,i) = 0.0
      enddo
      rot(4,4)=1.0

      return
      end
C
      SUBROUTINE EIGEN(A,R,N,MV)
C     ==========================
C
      IMPLICIT NONE

C---- Purpose
C     compute eigenvalues and eigenvectors of a real symmetric
C     matrix
C
C---- Usage
C     call eigen(a,r,n,mv)
C
C---- Description of parameters
C           A - original matrix (symmetric), destroyed in computation.
C               resultant eigenvalues are developed in diagonal of
C               matrix a in descending order.
C           R - resultant matrix of eigenvectors (stored columnwise,
C               in same sequence as eigenvalues)
C           N - order of matrices a and r
C           MV- input code
C                   0   compute eigenvalues and eigenvectors
C                   1   compute eigenvalues only (r need not be
C                       dimensioned but must still appear in calling
C                       sequence)
C
C---- Remarks
C     original matrix a must be real symmetric (storage mode=1)
C     matrix a cannot be in the same location as matrix r
C
C---- Subroutines and function subprograms required
C     none
C
C---- Method
C     diagonalization method originated by jacobi and adapted
C     by von neumann for large computers as found in 'mathematical
C     methods for digital computers', edited by a. ralston and
C     h.s. wilf, john wiley and sons, new york, 1962, chapter 7
C
C    if a double precision version of this routine is desired, the
C    c in column 1 should be removed from the double precision
C    statement which follows.
C
      DOUBLE PRECISION ANORM,ANRMX,THR,X,Y,SINX,SINX2,COSX,
     1                 COSX2,SINCS,RANGE
C
C    the c must also be removed from double precision statements
C    appearing in other routines used in conjunction with this
C    routine.
C
C    the double precision version of this subroutine must also
C    contain double precision fortran functions.  sqrt in statements
C    40, 68, 75, and 78 must be changed to dsqrt.  abs in statement
C    62 must be changed to dabs. the constant in statement 5 should
C    be changed to 1.0d-12.
C
C
C
C---- Generate identity matrix
C
C     .. Scalar Arguments ..
      INTEGER MV,N
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION A(*),R(*)
C     ..
C     .. Local Scalars ..
C     REAL ANORM,ANRMX,COSX,COSX2,RANGE,SINCS,SINX,SINX2,THR,X,Y
      INTEGER I,IA,IJ,IL,ILQ,ILR,IM,IMQ,IMR,IND,IQ,J,JQ,K,L,LL,LM,LQ,M,
     +        MM,MQ
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,REAL,SQRT
C     ..
      RANGE = 1.0E-6
      IF (MV-1.NE.0) THEN
        IQ = -N
        DO 20 J = 1,N
          IQ = IQ + N
          DO 10 I = 1,N
            IJ = IQ + I
            R(IJ) = 0.0
            IF (I-J.EQ.0) R(IJ) = 1.0
   10     CONTINUE
   20   CONTINUE
      END IF
C
C---- Compute initial and final norms (anorm and anormx)
C
      ANORM = 0.0
      DO 40 I = 1,N
        DO 30 J = I,N
          IF (I-J.NE.0) THEN
            IA = (J*J-J)/2 + I
            ANORM = A(IA)*A(IA) + ANORM
          END IF
   30   CONTINUE
   40 CONTINUE
      IF (ANORM.GT.0) THEN
        ANORM = SQRT(ANORM)*1.414
        ANRMX = ANORM*RANGE/REAL(N)
C
C---- Initialize indicators and compute threshold, thr
C
        IND = 0
        THR = ANORM
   50   CONTINUE
        THR = THR/REAL(N)
   60   CONTINUE
        L = 1
   70   CONTINUE
        M = L + 1
   80   CONTINUE
C
C---- Compute sin and cos
C
        MQ = (M*M-M)/2
        LQ = (L*L-L)/2
        LM = L + MQ
        IF (ABS(A(LM))-THR.GE.0) THEN
          IND = 1
          LL = L + LQ
          MM = M + MQ
          X = (A(LL)-A(MM))*0.5
          Y = -A(LM)/SQRT(A(LM)*A(LM)+X*X)
C---- Protect against rounding error. C. Flensburg 20080307.
          IF (ABS(Y).GT.1.0D0) Y=SIGN(1.0D0,Y)
          IF (X.LT.0) Y = -Y
          SINX = Y/SQRT(((SQRT(1.0-Y*Y))+1.0)*2.0)
          SINX2 = SINX*SINX
          COSX = SQRT(1.0-SINX2)
          COSX2 = COSX*COSX
          SINCS = SINX*COSX
C
C---- Rotate l and m columns
C
          ILQ = (L-1)*N
          IMQ = (M-1)*N
          DO 130 I = 1,N
            IQ = (I*I-I)/2
            IF (I-L.NE.0) THEN
              IF (I-M) 90,120,100
   90         IM = I + MQ
              GO TO 110
  100         IM = M + IQ
  110         IF (I-L.GE.0) THEN
                IL = L + IQ
              ELSE
                IL = I + LQ
              END IF
              X = A(IL)*COSX - A(IM)*SINX
              A(IM) = A(IL)*SINX + A(IM)*COSX
              A(IL) = X
            END IF
  120       IF (MV-1.NE.0) THEN
              ILR = ILQ + I
              IMR = IMQ + I
              X = R(ILR)*COSX - R(IMR)*SINX
              R(IMR) = R(ILR)*SINX + R(IMR)*COSX
              R(ILR) = X
            END IF
  130     CONTINUE
          X = A(LM)*2.0*SINCS
          Y = A(LL)*COSX2 + A(MM)*SINX2 - X
          X = A(LL)*SINX2 + A(MM)*COSX2 + X
          A(LM) = (A(LL)-A(MM))*SINCS + (COSX2-SINX2)*A(LM)
          A(LL) = Y
          A(MM) = X
        END IF
C
C---- Tests for completion
C
C---- Test for m = last column
C
        IF (M-N.NE.0) THEN
          M = M + 1
          GO TO 80
        END IF
C
C---- Test for l = second from last column
C
        IF (L- (N-1).NE.0) THEN
          L = L + 1
          GO TO 70
        END IF
        IF (IND-1.EQ.0) THEN
          IND = 0
          GO TO 60
        END IF
C
C---- Compare threshold with final norm
C
        IF (THR-ANRMX.GT.0) GO TO 50
      END IF
C
C---- Sort eigenvalues and eigenvectors
C
      IQ = -N
      DO 160 I = 1,N
        IQ = IQ + N
        LL = (I*I-I)/2 + I
        JQ = (I-2)*N
        DO 150 J = I,N
          JQ = JQ + N
          MM = (J*J-J)/2 + J
          IF (A(LL)-A(MM).LT.0) THEN
            X = A(LL)
            A(LL) = A(MM)
            A(MM) = X
            IF (MV-1.NE.0) THEN
              DO 140 K = 1,N
                ILR = IQ + K
                IMR = JQ + K
                X = R(ILR)
                R(ILR) = R(IMR)
                R(IMR) = X
  140         CONTINUE
            END IF
          END IF
  150   CONTINUE
  160 CONTINUE
      END
C
C
c
c ----------------------------------------------------------------------
c
      subroutine shsort(key,ptr,n)
      implicit none
c shell-sort pointers ptr into order of sort keys key
      integer n,ptr(n)
      real key(n)
c
      integer i,i1,i2,p1,p2,l,icount
c
      icount=0
c set up ptr list
      do 5 i=1,n
       ptr(i)=i
 5    continue
c use search for start factor: reliable
      l=1
 10    l=2*l
      if (l.lt.n) goto 10
c l=step size for swaping elements, halve after each cycle
 20    l=l/2
       do 40 i=1,n-l
        do 30 i1=i,1,-l
         icount=icount+1
         i2=i1+l
         p1=ptr(i1)
         p2=ptr(i2)
         if (key(p2).gt.key(p1)) goto 40
         ptr(i1)=p2
         ptr(i2)=p1
 30     continue
 40    continue
      if (l.gt.1) goto 20
c done
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine calcmetric(cell)
      implicit none
c params
      real cell(6)
c commons
      integer nsym
      real rsym(4,4,192)
      real m11, m22, m33, m12, m13, m23
      common /crystal/nsym,rsym,m11,m22,m33,m12,m13,m23
c locals
      real a, b, c, alph, beta, gamm
c
c get metric tensor
      a = cell(1)
      b = cell(2)
      c = cell(3)
      alph = cell(4) * 3.14159265 / 180.0
      beta = cell(5) * 3.14159265 / 180.0
      gamm = cell(6) * 3.14159265 / 180.0
      m11 = a*a
      m22 = b*b
      m33 = c*c
      m12 = 2.0*a*b*cos(gamm)
      m13 = 2.0*a*c*cos(beta)
      m23 = 2.0*b*c*cos(alph)
      write (*,410)cell,m11,m22,m33,m12,m13,m23
 410  format(/,' Cell:',3f10.3,3f8.3,/,
     +         ' Metric tensor: m11,m22,m33,m12,m13,m23',/,6f12.3,/)
      return
      end
c
c ----------------------------------------------------------------------
c
      real function get_dist_frac(du,dv,dw)
      implicit none
c params
      real du,dv,dw
c commons
      integer nsym
      real rsym(4,4,192)
      real m11, m22, m33, m12, m13, m23
      common /crystal/nsym,rsym,m11,m22,m33,m12,m13,m23
c
      get_dist_frac = sqrt( m11*du*du + m22*dv*dv + m33*dw*dw
     +                    + m12*du*dv + m13*du*dw + m23*dv*dw )
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine polartomatrix(omega,phi,kappa,matrix)
      implicit none
c calculate rotation matrix from Polar angles
      real omega,phi,kappa,matrix(4,4)
c
      real someg,comeg,sinph,cosph,sinchi,coschi,cosch1,dc1,dc2,dc3
c
      someg = sin(omega)
      comeg = cos(omega)
      sinph = sin(phi)
      cosph = cos(phi)
      dc1 = someg*cosph
      dc2 = someg*sinph
      dc3 = comeg
      sinchi = sin(kappa)
      coschi = cos(kappa)
      cosch1 = 1.0 - coschi
      matrix(1,1) = dc1*dc1*cosch1 + coschi
      matrix(1,2) = dc1*dc2*cosch1 - dc3*sinchi
      matrix(1,3) = dc3*dc1*cosch1 + dc2*sinchi
      matrix(2,1) = dc1*dc2*cosch1 + dc3*sinchi
      matrix(2,2) = dc2*dc2*cosch1 + coschi
      matrix(2,3) = -dc1*sinchi + dc2*dc3*cosch1
      matrix(3,1) = -dc2*sinchi + dc3*dc1*cosch1
      matrix(3,2) = dc2*dc3*cosch1 + dc1*sinchi
      matrix(3,3) = dc3*dc3*cosch1 + coschi
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine eulertomatrix(alpha,beta,gamma,matrix)
      implicit none
c calculate rotation matrix from Euler angles
      real alpha,beta,gamma,matrix(4,4)
c
      real ca,cb,cg,sa,sb,sg
c
      ca = cos(alpha)
      sa = sin(alpha)
      cb = cos(beta)
      sb = sin(beta)
      cg = cos(gamma)
      sg = sin(gamma)
      matrix(1,1) = cg*cb*ca - sg*sa
      matrix(1,2) = -sg*cb*ca - cg*sa
      matrix(1,3) = sb*ca
      matrix(2,1) = cg*cb*sa + sg*ca
      matrix(2,2) = -sg*cb*sa + cg*ca
      matrix(2,3) = sb*sa
      matrix(3,1) = -cg*sb
      matrix(3,2) = sg*sb
      matrix(3,3) = cb
      return
      end
c
c ----------------------------------------------------------------------
c
C
C     =============================
      SUBROUTINE matrixtopolarkabsch(Rmatrix,Omega,Phi,Kappa,lprint)
C     ==============================
C  Taken from lsqkab
C
         implicit none
C     .. Scalar Arguments ..
      REAL Omega,Phi,Kappa
C     ..
C     .. Array Arguments ..
      REAL Rmatrix(4,4),DC(5)
C     ..
C     .. Scalars in Common ..
      INTEGER KPRT
C     ..
C     .. Local Scalars ..
      REAL COSKappa,SINKappa,CHK,FUZZ,RTOD,TRACE,SOMEGA
      INTEGER I,J,K
      LOGICAL LPRINT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ATAN2,SIGN,SQRT
C     ..
C     .. Common blocks ..
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA FUZZ/0.0005/
C     ..
C
C      Rotation matrices in Polar angles are defined as follows:
C      ( l**2+(m**2+n**2)cos k  lm(1-cos k)-nsin k     nl(1-cos k)+msin k   )
C      ( lm(1-cos k)+nsin k     m**2+(l**2+n**2)cos k  mn(1-cos k)-lsin k   )
C      ( nl(1-cos k)-msin k     mn(1-cos k)+lsin k     n*2+(l**2+m**2)cos k )
C
C      where l m n are the direction cosines of the axis
C      about which the rotation k = kappa takes place.
C     
C       ( l )  = ( sin omega cos phi )
C       ( m )  = ( sin omega sin phi )
C       ( n )  = ( cos omega         )
C
      rtod = 45.000/atan(1.00D0)
      TRACE = 0.0

C
      OMEGA = 0.0
      PHI = 999.0
      KAPPA = 0.0
      DC(1) =0.0
      DC(2) = 0.0
      DC(3) = 1.0
C
      DO I = 1,3
        TRACE = Rmatrix(I,I) + TRACE
      End Do
C
C  Trace = 3.0  this is the identity - no rotation
      IF(TRACE.GT.(3.00 - FUZZ) ) then
        if(lprint) write(6,*)' This is an identity matrix'
        Return
      END IF
C
            COSKappa = (TRACE-1.0)/2.0
            SINKappa = SQRT(ABS(1.0-COSKappa*COSKappa))
            Kappa = ATAN2(SINKappa,COSKappa)*RTOD
            CHK = ABS(Kappa)
            IF (CHK.GT.179.5) THEN
             GO TO 10
            ELSE
              DC(1) = (Rmatrix(3,2)-Rmatrix(2,3))/ (2.0*SINKappa)
              DC(2) = (Rmatrix(1,3)-Rmatrix(3,1))/ (2.0*SINKappa)
              DC(3) = (Rmatrix(2,1)-Rmatrix(1,2))/ (2.0*SINKappa)
C  The sum of direction cosines should be 1.0
C If not - you probably have Kappa near 180
              CHK = DC(1)**2 + DC(2)**2 + DC(3)**2
              IF (CHK.GT.0.8) THEN
                GO TO 20
              ELSE
                GO TO 10
              END IF
            END IF
C
C---- IF Kappa =180  COSKappa=-1,SINKappa=0
C
   10   DC(1) = SQRT(ABS(Rmatrix(1,1)*0.5+0.5))
        DC(2) = SQRT(ABS(Rmatrix(2,2)*0.5+0.5))
        DC(3) = SQRT(ABS(Rmatrix(3,3)*0.5+0.5))
C
C---- Assume dc(1) positive
C
        IF (DC(1).NE.0.0) THEN
          IF (DC(2).NE.0.0) DC(2) = DC(2)*SIGN(1.0,Rmatrix(1,2))
          IF (DC(3).NE.0.0) DC(3) = DC(3)*SIGN(1.0,Rmatrix(1,3))
        ELSE IF (DC(2).NE.0.0) THEN
          IF (DC(3).NE.0.0) DC(3) = SIGN(1.0,Rmatrix(2,3))*DC(3)
        END IF

   20   DC(4) = DC(1)
        DC(5) = DC(2)
        SOMEGA = SQRT(ABS(1.0-DC(3)*DC(3)))
        OMEGA = ATAN2(SOMEGA,DC(3))*RTOD
C  If Omega 0.0 or 180.0 PHI cannot be defined
        CHK = DC(2)*DC(2) + DC(1)*DC(1)
        PHI = 999.0
        IF (CHK.GT.0.0) PHI = RTOD*ATAN2(DC(2),DC(1))
      IF(LPRINT) WRITE (6,FMT=6006) OMEGA,PHI,Kappa,
     +  (DC(I),I=1,3)
 6006 FORMAT (/'  SPHERICAL POLARS OMEGA PHI CHI ',3F12.5,
     +        /'  DIRECTION COSINES OF ROTAION AXIS ',3F12.5)
       END
C

C  This doesnt work always when Kappa near 180.0
      subroutine matrixtopolarold(matrix,omega,phi,kappa)
      implicit none
c calculate Euler angles from rotation matrix
      real matrix(4,4)
      real omega,phi,kappa
c
      real ARG,CXHI,FUZZ,SXHI,TR,VNORM,VN(3)
      INTEGER I,J,K,ii,ianiso
      LOGICAL LPRINT
C     ..
C     .. Local Arrays ..
      real EIJK(3,3,3)
      DATA EIJK/27*0.0/,FUZZ/0.0005/
C     ..
C
      write(6,'(4(/,4f10.4))') ((matrix(ii,ianiso),ianiso =1,4),ii=1,4)
      EIJK(1,2,3) = 1.0
      EIJK(3,1,2) = 1.0
      EIJK(2,3,1) = 1.0
      EIJK(1,3,2) = -1.0
      EIJK(2,1,3) = -1.0
      EIJK(3,2,1) = -1.0
      TR = 0.0
C
      DO 10 I = 1,3
        TR = matrix(I,I) + TR
   10 CONTINUE
C
      CXHI = (TR-1)/2
      ARG = 1 - CXHI**2
C
      IF (ARG.LE.FUZZ) THEN
        CXHI = SIGN(1.0,CXHI)
         WRITE (6,FMT=6000) ARG
 6000 FORMAT (' > S/R RMX2P < ARGUMENT OF SQRT LT.ZERO:',E15.5)
        ARG = 0.0
      END IF
C
      SXHI = SQRT(ABS(ARG))
      KAPPA = ATAN2(SXHI,CXHI)
C
      IF (ARG.NE.0.0) THEN
        DO 40 K = 1,3
          VN(K) = 0.0
          DO 30 J = 1,3
            DO 20 I = 1,3
              VN(K) = (matrix(I,J)-matrix(J,I))*EIJK(I,K,J) + VN(K)
   20       CONTINUE
   30     CONTINUE
          VN(K) = VN(K)/ (4*SXHI)
   40   CONTINUE
      ELSE
        IF (CXHI.GT.0.0) THEN
          VN(1) = 0.0
          VN(2) = 0.0
          VN(3) = 1.0
        ELSE
          DO 50 I = 1,3
            ARG = (matrix(I,I)+1)/2
            IF (ARG.LE.0.0) THEN
               WRITE (6,FMT=6000) ARG
              ARG = 0.0
            END IF
            VN(I) = SQRT(ABS(ARG))
C            VN(I) = SQRT(max(ABS(ARG),0.0))
   50     CONTINUE
          IF (VN(3).NE.0.0) THEN
            VN(1) = SIGN(VN(1),matrix(1,3))
            VN(2) = SIGN(VN(2),matrix(2,3))
          ELSE IF (VN(2).NE.0.0) THEN
            VN(1) = SIGN(VN(1),matrix(1,2))
          END IF
        END IF
      END IF
C   Check if PHI is defined?
      PHI = 0.0
      IF(VN(3).LT. 1.0) PHI = ATAN2(VN(2),VN(1))
      OMEGA = ATAN2( (VN(1)*VN(1)+(VN(2)*VN(2))),VN(3))
C
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine matrixtoeuler(matrix,alpha,beta,gamma)
      implicit none
c calculate Euler angles from rotation matrix
      real alpha,beta,gamma,matrix(4,4)
c
      integer i,j,k,l
      real ca,cb,cg,sa,sb,sg,a(3),dr,r11,r22,r12,mat1(4,4),mat2(4,4)
      parameter (dr=0.001)
c
c get initial estimate
      cb=matrix(3,3)
      sb=sqrt(0.5*(matrix(1,3)**2+matrix(2,3)**2+
     +             matrix(3,1)**2+matrix(3,2)**2))
      if (sb.gt.0.01) then
       ca= matrix(1,3)/sb
       sa= matrix(2,3)/sb
       cg=-matrix(3,1)/sb
       sg= matrix(3,2)/sb
      else
       ca=1.0
       sa=0.0
       cg=matrix(2,2)
       sg=matrix(2,1)
      endif
      a(1)=atan2(sa,ca)
      a(2)=atan2(sb,cb)
      a(3)=atan2(sg,cg)
c refine the estimate
      do k=1,2
       do l=1,3
        call eulertomatrix(a(1),a(2),a(3),mat1)
        a(l)=a(l)+dr
        call eulertomatrix(a(1),a(2),a(3),mat2)
        a(l)=a(l)-dr
        r11=0.0
        r22=0.0
        r12=0.0
        do i=1,3
         do j=1,3
          r11=r11+(mat2(i,j)-mat1(i,j))**2
          r22=r22+(matrix(i,j)-mat1(i,j))**2
          r12=r12+(matrix(i,j)-mat1(i,j))*(mat2(i,j)-mat1(i,j))
         enddo
        enddo
        a(l)=a(l)+r12/r11*dr
       enddo
      enddo
c
      alpha=a(1)
      beta =a(2)
      gamma=a(3)
      return
      end
c
c ----------------------------------------------------------------------
c
      real function fracp(x)
      real x
      fracp = x - real(nint(x))
      return
      end
c
c ----------------------------------------------------------------------
c
