C
C     ROTMAT
C     Copyright (C) 1992 Eleanor Dodson
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
C     =========================
      PROGRAM ROTATIONMATRICES
C     =========================
C
C     .. External Subroutines ..
      EXTERNAL CCPFYP,MTZINI,RCARDS,CCPRCS
C     ..
C
C          ******
      CALL CCPFYP
      CALL CCPRCS(6,'ROTMAT','$Date: 2008/05/06 12:58:46 $')
      CALL MTZINI
C          ******
C
      WRITE (6,FMT=5999)
 5999 FORMAT (//,'    ROTATIONMATRICES',/,
     +           '    ****************',///,
     +' This program converts the CCP4/MERLOT/XPLOR rotation ',/,
     +' angles to any other format, and generates their symmetry',/,
     +' equivalents.',//,
     +'  MERLOT /CCP4 conventions are the same -  ',/,
     +'  XPLOR is very different. ',//,
     +'     see documentation for further details of this.')
C
C          ******
      CALL RCARDS
C          ******
      END
C
C
C     =================
      SUBROUTINE RCARDS
C     =================
C
C    Read keywords and generate matrices for variuos
C  rotation function conventions
c  So  far program messages are:
c    Input/Output MERLOT ALPHA  BETA   GAMMA
c    Input/Output MERLOT THETA1 THETA2 THETA3
c    Input/Output MERLOT PHI    PSI    KAPPA
c    Input/Output MERLOT MATRIX
c    Input/Output CCP4   ALPHA  BETA   GAMMA
c    Input/Output CCP4   PHI    PSI    KAPPA
c    Input/Output CCP4   MATRIX
c    Input/Output XPLOR  THETA1 THETA2 THETA3
c    Input/Output XPLOR  PHI    PSI    KAPPA
c    Input/Output XPLOR  MATRIX
C  Read in the control data
C
C
C     .. Parameters ..
      INTEGER NKEYS,NPAR,NMAT,NTGT
      PARAMETER (NKEYS=7,NPAR=200,NMAT=100,NTGT=10)
C     ..
C     .. Scalars in Common ..
      INTEGER NCRYST
C     ..
C     .. Arrays in Common ..
      REAL ARSYM,CELCRY,F2MAX,F2MIN,F2MINS,RFCRYS,ROCRYS,RSYM,RSYMT,
     +     SCALFO,TFAC,VOLCR
      INTEGER JSYM,LSPGRP,NCODES,NSYMZO
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION DT1,DT2,DT3
      REAL AAA,AKAPPA,ALPHA,AMAX,AMIN,BETA,BTMAX,BTMIN,DEGTOR,ERROR,
     +     GAMMA,GMAX,GMIN,PHI,PSI,T1,T2,T3,THETA1,THETA2,THETA3,VOL,
     +     ATARGT,DET
      INTEGER EULABG,EULLAT,EULTHE,I1,IBACK,II,IKEND,ILEN,IMAT,
     +        INCCP,INF1,INF2,INMER,INPT,INTAR,INXPL,IS,ISYM1,ISYM2,
     +        ISYSW,ITARGT,ITERM,ITOK,IXTL,
     +        JJ,JMAT,JS,JSS,JSYM1,
     +        JSYM2,KS,LIST,M,MATRIX,NCODEM,NCODEX,NCR,NORDER,
     +        NSPGRP,NSYM,NSYMP,NTARGT,NTERM,NTOK,OUTABG,OUTCCP,OUTMAT,
     +        OUTMER,OUTSPH,OUTTHE,OUTXPL,SPHAXI,SPHPOL
      INTEGER JDO10,  JDO20,  JDO40,  JDO80,  JDO200, JDO120, JDO130,
     +        JDO140, JDO150, JDO230,
     +        JDO220, JDO210, JDO250, JDO240, JDO260, JDO320, JDO310,
     +        JDO340, JDO330, JDO350, JDO360, JDO370, JDO380, JDO382,
     +        JDO384, JDO386, JDO388, JDO390, JDO400, JDO410, JDO420, 
     +        JDO430, JDO440, JDO470, JDO480, JDO490, JDO500, JDO510, 
     +        JDO520, JDO530, JDO540, JDO550, JDO560, JDO570, JDO580, 
     +        JDO620, JDO630, JDO640, JDO650, JDO660, JDO670, JDO680, 
     +        JDO690, JDO700, JDO710, JDO730, JDO720, JDO740, JDO750, 
     +        JDO760, JDO770, JDO780, JDO790, JDO810, JDO800
      LOGICAL LEND,VERBOSE,LKEY
      CHARACTER KEY*4,MODE*4,NAMSGP*10,PGNAME*10,LINEI*30,LINEJ*30,
     +          LINE*400
C     ..
C     .. Local Arrays ..
      DOUBLE PRECISION AXIS(3),DRM(3,3)
      REAL AJNKS1(3,3),AJNKS2(3,3),AJNKS3(3,3),AN(3),ANI(3),ANJ(3),
     +     CEL(6),FVALUE(NPAR),RF(4,4),RF1(3,3),RF3(3,3),RM(3,3),
     +     RM1(3,3),RM3(3,3),RM3T(3,3),RMINP(3,3,NMAT),
     +     RMSYM(3,3),RMSYMJ(3,3),RMT(3,3),RMTGT(3,3,NTGT),RO(4,4),
     +     RO1(3,3),RO3(3,3),RR(3,3,6),X(9),RMSYMT(3,3),ATGT(NTGT),
     +     RF5(3,3),RO5(3,3),RM5(3,3),RM5T(3,3),AJNKS5(3,3)
      INTEGER IBEG(NPAR),IDEC(NPAR),IEND(NPAR),INFLG(2,NMAT),ITYP(NPAR)
      CHARACTER CVALUE(NPAR)*4,KEYWRD(NKEYS)*4,NAMSGS(2)*10,CODES(5)*15,
     +      STRTGT(NTGT)*60
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL ANG010,ANG011,ANG018,CCPERR,CCPROT,CCPUPC,GTPINT,GTPREA,
     +         MATMUL,MATROT,PARSER,RBFRO1,RBRINV,RDSYMM,RORDER,
     +         ROT010,ROT011,ROT018,ROTMAT,SYMORT,MINV3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ACOS,ATAN,INT,MAX,MIN,REAL,SQRT
C     ..
C     .. Common blocks ..
      COMMON /CRYSTS/NCRYST,ROCRYS(4,4,2),RFCRYS(4,4,2),CELCRY(6,2),
     +       NCODES(2),LSPGRP(2),VOLCR(2),TFAC(2),NSYMZO(2),F2MIN(2),
     +       SCALFO(2),F2MAX(2),F2MINS(2)
      COMMON /SYMTR/JSYM(2),RSYM(4,4,192,2),RSYMT(4,4,192,2),
     +       ARSYM(3,3,192,2)
C     ..
C     .. Data statements ..
      DATA KEYWRD/'CRYS','ERRO','VERB','INPU','OUTP','TARG','END'/
      DATA CODES/'a,c*xa,c*','b,a*xb,a*','c,b*xc,b*','a+b,c*x(a+b),c*',
     +     'a*,cxa*,c'/
C     ..
C
      DEGTOR = ATAN(1.0)/45.0
      ISYSW = 6
C
C----   Input from Merlot CCP4( almn, POLARrfn and LSQKAB) or XPLOR
C
      ITARGT = 0
      ERROR = 10
      INPT = 0
      IMAT = 0
      LIST = 0
      INMER = 0
      OUTMER = 0
      INCCP = 0
      OUTCCP = 0
      INXPL = 0
      OUTXPL = 0
      VERBOSE  = .FALSE.
      nsym = 0
      nsymp = 0
      outabg = 0   
      outthe = 0
      outsph = 0
C
C----  set ncode for MERLOT and XPLOR - reset NCODEM if monoclinic sg
C
      NCODEM = 5
      NCODEX = 1
      NCRYST = 0
      NCODES(1) = 1
      NCODES(2) = 1
      JSYM(1) = 1
      JSYM(2) = 1
      LSPGRP(1) = 0
      LSPGRP(2) = 0
      CELCRY(1,1) = 0.0
      CELCRY(1,2) = 0.0
      NSYMZO(1) = 0
      NSYMZO(2) = 0
C
      DO 20 JDO20 = 1,4
        DO 10 JDO10 = 1,4
          ROCRYS(JDO10,JDO20,1) = 0.0
          RFCRYS(JDO10,JDO20,1) = 0.0
          RSYM(JDO10,JDO20,1,1) = 0.0
   10   CONTINUE
        RFCRYS(JDO20,JDO20,1) = 1.0
        ROCRYS(JDO20,JDO20,1) = 1.0
        RSYM(JDO20,JDO20,1,1) = 1.0
   20 CONTINUE
C
   30 CONTINUE
      LINE = '   '
      KEY = ' '
      NTOK = NPAR
C
C          ***********************************************************
      CALL PARSER(KEY,LINE,IBEG,IEND,ITYP,FVALUE,CVALUE,IDEC,NTOK,LEND,
     +            .TRUE.)
C          ***********************************************************
C
C----  End of file?
C
      IF (LEND) GO TO 890
C
C----  Loop over possible key-words
C
      DO 40 JDO40 = 1,NKEYS
        IF (KEY.EQ.KEYWRD(JDO40)) GO TO 50
   40 CONTINUE
C
C          ******************************************
      CALL CCPERR(1,' *** UNRECOGNISED KEY WORD ***')
C          ******************************************
C
C      DATA KEYWRD/'CRYSTAL','ERROR','VERB','INPU','OUTP','TARGET','END'/
C
 50   CONTINUE
      GO TO (60,90,95,280,450,270,100) JDO40
C
C---- CRYSTAL   - subsidiary keywords;
C     ========================================
C
C Check command line for
C subsidiary keyword FILE  crystal number
C subsidiary keyword ORTH  - orthogonalisation code NCODE,
C subsidiary keyword CELL  - a b c ( alpha beta  gamma - default = 90.0)
C                      rarely needed - just for peak analysis
C
   60 CONTINUE
C
      ITOK = 1
   70 ITOK = ITOK + 1
C
      IF (ITOK.GT.NTOK) THEN
        GO TO 30
      END IF
C
      IKEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :IKEND)
C
C          ***********
      CALL CCPUPC(KEY)
C          ***********
C
      IF (KEY.EQ.'FILE' .OR. KEY.EQ.'NUMB') THEN
        ITOK = ITOK + 1
C
C            ********************************
        CALL GTPINT(ITOK,IXTL,NTOK,ITYP,FVALUE)
C            ********************************
C
        NCRYST = MAX(IXTL,NCRYST)
C
C---- Check if allowed range of files ... 1 to 2 (is this enough ???)
C
        IF (IXTL.LE.0 .OR. IXTL.GT.2) THEN
          WRITE (ISYSW,FMT='(a,/,a,i4,a,a,/,a)')
     +      ' Key_Word Error, For CRYSTAL FILE_NUMBER line:-',
     +      '  File_Number Given = ',IXTL,
     +      ' Is invalid only files 1 to 2',
     +      ' Allowed, Ignoring this line -',LINE(1:LENSTR(LINE))
        END IF
C
        GO TO 70
      END IF
C
      IF (KEY.EQ.'ORTH') THEN
        ITOK = ITOK + 1
C
C            ******************************************
        CALL GTPINT(ITOK,NCODES(IXTL),NTOK,ITYP,FVALUE)
C            ******************************************
C
        GO TO 70
      END IF
C
      IF (KEY.EQ.'SYMM') THEN
C
C----- SYMMetry    read crystal number or  space group
C
        ITOK = ITOK + 1
C
C            **********************************************************
        CALL RDSYMM(ITOK,LINE,IBEG,IEND,ITYP,FVALUE,ITOK,NAMSGP,NSPGRP,
     +              PGNAME,NSYM,NSYMP,RSYM(1,1,1,IXTL))
C            **********************************************************
C
C----   Only need primitive symmetry operators
C
        JSYM(IXTL) = NSYMP
        LSPGRP(IXTL) = NSPGRP
        NAMSGS(IXTL) = NAMSGP
C
C----   Reset NCODEM to 3 for monoclinic spacegroups.
C
        ILEN = LENSTR(PGNAME)
        IF (PGNAME(1:ILEN).EQ.'PG2' .OR.
     +      PGNAME(1:ILEN).EQ.'2') NCODEM = 3
        GO TO 70
      END IF
C
C---- CELL    read cell dimensions
C     ============================
C
      IF (KEY.EQ.'CELL') THEN
C
        DO 80 JDO80 = 4,6
          CELCRY(JDO80,IXTL) = 90.0
   80   CONTINUE
C
        ITOK = ITOK + 1
C
C            ********************************************
        CALL GTPREA(ITOK,CELCRY(1,IXTL),NTOK,ITYP,FVALUE)
        CALL GTPREA(ITOK+1,CELCRY(2,IXTL),NTOK,ITYP,FVALUE)
        CALL GTPREA(ITOK+2,CELCRY(3,IXTL),NTOK,ITYP,FVALUE)
C            **********************************************
C
          ITOK = ITOK + 2
C
        IF (ITOK.LT.NTOK) THEN
          ITOK = ITOK + 1
C
C              *********************************************
          CALL GTPREA(ITOK,CELCRY(4,IXTL),NTOK,ITYP,FVALUE)
          CALL GTPREA(ITOK+1,CELCRY(5,IXTL),NTOK,ITYP,FVALUE)
          CALL GTPREA(ITOK+2,CELCRY(6,IXTL),NTOK,ITYP,FVALUE)
C              *********************************************
C
        END IF
C
          WRITE (6,8888) (CELCRY(JJ,IXTL),JJ=1,6)
8888      FORMAT(
     +' Cell dimensions:',/,
     +'        angstrom:',3(2X,F15.6),/,
     +'         degrees:',3(2X,F15.6))
          ITOK = ITOK + 2
        GO TO 70
      END IF
C
      WRITE (ISYSW,'(A,A)')' Subkeyword Not recognised: ',KEY
      CALL CCPERR(1,' *** Unrecognised sub-keyword for CRYSTAL ***')
C
C---- ERROR    - error angle tolerated for match: default = 10
C     =========================================================
C
   90 CONTINUE
C
C          ********************************
      CALL GTPREA(2,ERROR,NTOK,ITYP,FVALUE)
C          ********************************
C
      GO TO 30
C
C---- VERBOSE    - lots more output
C     =========================================================
C
   95 CONTINUE
C
      VERBOSE = .TRUE.
C
      GO TO 30
C

  100 CONTINUE
      IF (LIST.EQ.1 .AND. KEY.EQ.'INPU') GO TO 280
      IF (LIST.EQ.1 .AND. KEY.EQ.'OUTP') GO TO 450
C
C                    *********************************
      IF (LIST.EQ.1) CALL CCPERR(0,' Normal Termination')
C                    *********************************
C
C   setting up matrices for diferent crystals.
C  Need ROCRYS and RFCRYS - the orthogonalisation matrices,
C  Plus those for NCODE = 1, and NCODE =3 to fit Merlot and XPLOR conventions
  110 CONTINUE
      LIST = 1
C
      DO 200 JDO200 = 1,NCRYST
            NCR = JDO200
        IF (CELCRY(1,NCR).LE.1.0) 
C
C         *********************************************
     +    CALL CCPERR(1,'   No cell information given')
C         *********************************************
C
        IF (LSPGRP(NCR) .EQ. 0)
C
C         *************************************************
     +    CALL CCPERR(1,'   No symmetry information given')
C         *************************************************
C
C
C---- Check orthogonalisation code
C     Keep orthogonalistions 1 and 3 for 
C     possible MERLOT/XPLOR transformations
C
        CEL(1) = CELCRY(1,NCR)
        CEL(2) = CELCRY(2,NCR)
        CEL(3) = CELCRY(3,NCR)
        CEL(4) = CELCRY(4,NCR)
        CEL(5) = CELCRY(5,NCR)
        CEL(6) = CELCRY(6,NCR)
C
C            ******************
        CALL RBFRO1(CEL,VOL,RR)
C            ******************
C
        RO(4,4) = 1.0
C
        DO 130 JDO130 = 1,3
          RO(4,JDO130) = 0
          RO(JDO130,4) = 0
C
          DO 120 JDO120 = 1,3
            RO(JDO120,JDO130) = RR(JDO120,JDO130,NCODES(NCR))
  120     CONTINUE
  130   CONTINUE
C
C---- invert ro...
C
C            *************
        CALL RBRINV(RO,RF)
C            *************
C
        DO 150 JDO150 = 1,3
          RO(4,JDO150) = 0
          RO(JDO150,4) = 0
C
          DO 140 JDO140 = 1,3
            RFCRYS(JDO140,JDO150,NCR) = RF(JDO140,JDO150)
            ROCRYS(JDO140,JDO150,NCR) = RO(JDO140,JDO150)
            IF(NCR.EQ.1)RO1(JDO140,JDO150) = RR(JDO140,JDO150,1)
            IF(NCR.EQ.1)RO3(JDO140,JDO150) = RR(JDO140,JDO150,3)
            IF(NCR.EQ.1)RO5(JDO140,JDO150) = RR(JDO140,JDO150,5)
  140     CONTINUE
  150   CONTINUE
C
C   Build NCODE 1 NCODE 3 NCODE 5 for messy Merlot and XPLOR conversions
C---- invert ro1...
C
C              *************
          IF(NCR.EQ.1)CALL MINV3(RF1,RO1,DET)
          IF(NCR.EQ.1)CALL MINV3(RF3,RO3,DET)
          IF(NCR.EQ.1)CALL MINV3(RF5,RO5,DET)
C              *************
  200 CONTINUE
C
C---- If 1 crystal, copy symmetry etc to crystal 2
C
      IF (NCRYST.EQ.1) THEN
C
C---- If single hkl set set 2nd set of symm operations equal to first
C
        JSYM(2) = JSYM(1)
C
        DO 230 JDO230 = 1,4
         DO 220 JDO220 = 1,4
           RFCRYS(JDO220,JDO230,2) = RFCRYS(JDO220,JDO230,1)
           ROCRYS(JDO220,JDO230,2) = ROCRYS(JDO220,JDO230,1)
           DO 210 JDO210 = 1,JSYM(1)
           RSYM(JDO220,JDO230,JDO210,2) = RSYM(JDO220,JDO230,JDO210,1)
  210       CONTINUE
  220     CONTINUE
  230   CONTINUE
C
        NSYMZO(2) = NSYMZO(1)
        NCODES(2) = NCODES(1)
        LSPGRP(2) = LSPGRP(1)
      END IF
C
C---- Calculate orthogonal-space symmetry operations
C
C          ******
      CALL SYMORT
C          ******
C
      DO 250 JDO250 = 1,NCRYST
        IF (NSYMZO(JDO250).LE.0) THEN
C
C---- Work out rotational symmetry around Zortho if NSYMZO
C     has not been input
C
          M = 0
C
          DO 240 JDO240 = 1,JSYM(JDO250)
C
C                *****************************************            
            CALL RORDER(ARSYM(1,1,JDO240,JDO250),3,NORDER)
C                *****************************************            
C
            M = MAX(M,NORDER)
  240     CONTINUE
C
          WRITE (ISYSW,FMT=6002) M,JDO250
 6002 FORMAT (//,
     + '  Rotational symmetry about Zortho set to ',I4,/,
     + '    for crystal ',I3,/)
          NSYMZO(JDO250) = M
        END IF
  250 CONTINUE
C
cc      if (JDO250.eq.1) nsymzo(2) = nsymzo(1)
      IF (NCRYST.EQ.1) NSYMZO(2) = NSYMZO(1)
C
C---- Find limits for ALPHA BETA gamma
C    Set alpha and gamma limits NALPHA AND NGAMMA SET IN RCARDSALMN
C
      AMIN = 0.0
      AMAX = 360.0/REAL(NSYMZO(1))
      GMIN = 0.0
      GMAX = 360.0/REAL(NSYMZO(2))
C
      BTMIN = 0.0
      BTMAX = 180.0
C
C----   If pointgroup is n2... or PGn2.. BTMAX = 90.0
C       is pgname = pg??? OR ???
C
      I1 = 2
      IF (PGNAME(I1:I1).EQ.'2') BTMAX = 90.0
C
      WRITE (ISYSW,FMT=6006) AMIN,AMAX,BTMIN,BTMAX,GMIN,GMAX
 6006 FORMAT (9X,'Range of alpha  ',2F10.2,/,
     +        9X,'Range of Beta   ',2F10.2,/,
     +        9X,'Range of Gamma  ',2F10.2,/,
     +           '  Step Sizes ',3F10.2,'  Degrees',/)
C
C---- Must have some information about spacegroup etC
      DO 260 JDO260 = 1,NCRYST
        WRITE (ISYSW,FMT=6008) JDO260,NCODES(JDO260),
     +    CODES(NCODES(JDO260))(1:LENSTR(CODES(NCODES(JDO260))))
 6008 FORMAT (///,
     +' Crystal',I3,':',/,
     +'       orthogonalisation code (NCODE) = ',I4,/,
     +'       x y z axes along ',A)
        WRITE (ISYSW,FMT=6010) ((RFCRYS(IS,JS,JDO260),JS=1,4),
     +    (ROCRYS(IS,JSS,JDO260),JSS=1,4),IS=1,4)
 6010 FORMAT (
     +'  RF_crystal:                             RO_crystal:',/,
     + 4 (/4F9.4,2X,4F9.4),/)
        WRITE (ISYSW,FMT=6012) 
     +       LSPGRP(JDO260),
     +       NAMSGS(JDO260)(1:LENSTR(NAMSGS(JDO260))),
     +       JSYM(JDO260)
 6012 FORMAT (
     +'   Space group_number ',I4,/,
     +'   Space group_name   ',A,/,
     +'   Number primitive symmetry operations = ',I6)
        WRITE (ISYSW,FMT=6014) (KS, ((RSYM(IS,JS,KS,JDO260),JS=1,4),
     +    IS=1,4),KS=1,JSYM(JDO260))
 6014 FORMAT (/48 (/' Symmetry',I3,4 (/4F10.3),/))
  260 CONTINUE
C
C  Iback=290 - Input line; IBACK = 460 - Output LIN
      IF (IBACK.EQ.290) GO TO 290
      IF (IBACK.EQ.460) GO TO 460
C
C------ TARGET
C       =================================
C
  270 CONTINUE
      IF (NCRYST.LT.2)
     +     CALL CCPERR (1, 'Supply 2 CRYSTALs before TARGET')
      ITARGT = ITARGT + 1
      IF(ITARGT.GT.NTGT) CALL CCPERR(1,
     +     ' Too many target values - reset Parameter NTGT')
      STRTGT(ITARGT) = '  : '//LINE(IBEG(2):IEND(2) + 55)
      INTAR = 1
      INPT = 0
      INMER = 0
      INCCP = 0
      INXPL = 0
      EULABG = 0
      EULTHE = 0
      EULLAT = 0
      SPHPOL = 0
      SPHAXI = 0
      MATRIX = 0
      GO TO 290
C
C------ INPUT [MERLOT | CCP4 | XPLOR]
C       ======================================
C
  280 CONTINUE
      IF (NCRYST.LT.1)
     +     CALL CCPERR (1, 'Supply CRYSTAL information first')
      IMAT = IMAT + 1
        IF(IMAT.GT.NMAT) CALL CCPERR
     +  (1,' Too many input rotations - reset Parameter NMAT')
      INPT = 1
      INTAR = 0
      INMER = 0
      INCCP = 0
      INXPL = 0
      EULABG = 0
      EULTHE = 0
      EULLAT = 0
      SPHPOL = 0
      SPHAXI = 0
      MATRIX = 0
      IBACK = 290
      IF (LIST.EQ.0) GO TO 110
  290 CONTINUE
      WRITE (6,FMT='(//,a/)')
     +  ' **********************************************************'
C
C  Difference in rotation desired..
      ATARGT = 0.0
C          ************
      CALL CCPUPC(LINE)
C          ************
C
      KEY = LINE(IBEG(2) :IBEG(2)+3)
      WRITE (6,FMT=8899) LINE(1:70)
8899  FORMAT(//,' Input_Line:',/,1X,A)
C
C----   Which program has generated input?
C
      IF (KEY.EQ.'MERL') INMER = 1
      IF (KEY.EQ.'MERL') INF1 = 0
      IF (KEY.EQ.'CCP4') INCCP = 1
      IF (KEY.EQ.'CCP4') INF1 = 1
      IF (KEY.EQ.'XPLO') INXPL = 1
      IF (KEY.EQ.'XPLO') INF1 = 2
C    Only target a rotation difference.
      IF (KEY.EQ.'KAPP') THEN
       INCCP = 1
       INF1  = 1
        SPHPOL = 1
        CALL GTPREA(3,ATARGT,NTOK,ITYP,FVALUE)
        AKAPPA = 0
        PHI = 0
        PSI = 0
         Write(6,'(a,f8.2)')
     +   '  Target rotation difference between Solns',ATARGT
        GO TO 291
      END IF
C
C----   Which convention for input information?
C
      KEY = LINE(IBEG(3) :IBEG(3)+2)
      LKEY = .FALSE.
C
C----  Alpha betagamma
C
      IF (KEY.EQ.'ALP') THEN
        NTERM = 3
        EULABG = 1
        INF2 = 1
        LKEY = .TRUE.
      END IF
C
C----  Theta1 Theta2 Theta3
C
      IF (KEY.EQ.'THE') THEN
        NTERM = 3
        EULTHE = 1
        INF2 = 2
        LKEY = .TRUE.
      END IF
C
C----  Theta+ Theta2 Theta-
C
      IF (KEY.EQ.'LAT') THEN
        NTERM = 3
        EULLAT = 1
        INF2 = 3
        LKEY = .TRUE.
      END IF
C
C----  Sherical polars Psi Phi Kappa or Omega Phi Kappa
C
      IF (KEY.EQ.'OME' .OR. KEY.EQ.'PSI' .OR. KEY.EQ.'PHI') THEN
        NTERM = 3
        SPHPOL = 1
        INF2 = 4
        LKEY = .TRUE.
      END IF
C
C----  Sherical polars given with AXIS and Kappa
C
      IF (KEY.EQ.'AXI') THEN
        NTERM = 4
        SPHAXI = 1
        INF2 = 5
        LKEY = .TRUE.
      END IF
C
C----  Matrix terms - R11 R12 R13  R21 R22 R23 .. be careful!
C
      IF (KEY.EQ.'MAT') THEN
        NTERM = 9
        MATRIX = 1
        INMER = 0
        INCCP = 0
        INXPL = 0
        INF2 = 6
        LKEY = .TRUE.
      END IF
C
      IF (.NOT. LKEY) THEN
        WRITE (ISYSW,'(A,A)')' Subkeyword Not recognised: ',
     +  LINE(IBEG(3) :IEND(3))
        CALL CCPERR
     +  (1,' *** Unrecognised sub-keyword for INPUT/TARGET ***')
      END IF
C
      IF (INPT.EQ.1) INFLG(1,IMAT) = 10*INF1 + INF2
C
C  INF1 : 0 = inmer, 1=inccp,2=inxpl
C  INF2 : 1 = EULABG; 2=THE; 3=LAT, 4=SPH.POL,5=AXI,6=MAT
C
      IF (INTAR.EQ.1) INFLG(2,IMAT) = 10*INF1 + INF2
      ITOK = 4
      ITERM = 1
  300 CONTINUE
C
      IF (ITYP(ITOK).EQ.2) THEN
C
C            **************************************
        CALL GTPREA(ITOK,X(ITERM),NTOK,ITYP,FVALUE)
C            **************************************
C
        ITERM = ITERM + 1
      END IF
C
      ITOK = ITOK + 1
      IF (ITOK.LE.NTOK .AND. ITERM.LE.NTERM) GO TO 300
C
      IF (EULABG.EQ.1) THEN
        ALPHA = X(1)
        BETA = X(2)
        GAMMA = X(3)
      END IF
C
      IF (EULTHE.EQ.1) THEN
        THETA1 = X(1)
        THETA2 = X(2)
        THETA3 = X(3)
      END IF
C
      IF (EULLAT.EQ.1) THEN
        THETA1 = (X(1)+X(3))/2.0
        THETA3 = (X(1)-X(3))/2.0
        THETA2 = X(2)
        EULTHE = 1
      END IF
C
C----  There is confusion over input order of Spherical polar angles.
C     If KEY = PSI or OMEga swap AN(1) and AN(2)
C
      IF (SPHPOL.EQ.1) THEN
        AKAPPA = X(3)
        PHI = X(1)
        PSI = X(2)
        IF (KEY.NE.'PHI') THEN
          PSI = X(1)
          PHI = X(2)
        END IF
      END IF
C
C----   Special cases of XPLOR input.
C
      IF (SPHAXI.EQ.1) THEN
        AKAPPA = X(4)
        AXIS(1) = X(1)
        AXIS(2) = X(2)
        AXIS(3) = X(1)
        AAA = SQRT(AXIS(1)**2+AXIS(2)**2+AXIS(3)**2)
        IF (AAA.LT.0.0001) 
C
C             *******************************************
     +   CALL CCPERR(1,' Rotation vector has 0.0 length')
C             *******************************************
C
        PSI = 0.0
        PHI = 0.0
        AXIS(1) = AXIS(1)/AAA
        AXIS(2) = AXIS(2)/AAA
        AXIS(3) = AXIS(3)/AAA
        PSI = ACOS(AXIS(2))/DEGTOR
C
        IF (AXIS(1)**2+AXIS(3)**2.LT.0.00001) THEN
          PHI = 0.0
        ELSE
          PHI = ACOS(MAX(-1.0D0,MIN(1.0D0,
     +          AXIS(1)/SQRT(AXIS(1)**2+AXIS(3)**2))))/DEGTOR
          IF (AXIS(3).GT.0.0) PHI = -PHI
          SPHPOL = 1
          AXIS(1) = 0.0
          AXIS(2) = 0.0
          AXIS(3) = 0.0
        END IF
      END IF
C
291   CONTINUE
C----  Merlot input  -  Matrix is transpose of CCP4 and XPLOR ones
C
      IF (INMER.EQ.1) THEN
        IF (EULABG.EQ.1) THEN
          AN(1) = ALPHA
          AN(2) = BETA
          AN(3) = GAMMA
C
C              **************
          CALL ROT011(RMT,AN)
C              **************
C
        END IF
C
        IF (EULTHE.EQ.1) THEN
          AN(1) = THETA1
          AN(2) = THETA2
          AN(3) = THETA3
C
C              **************
          CALL ROT010(RMT,AN)
C              **************
C
        END IF
C
        IF (SPHPOL.EQ.1) THEN
          AN(1) = PHI
          AN(2) = PSI
          AN(3) = AKAPPA
C
C              **************
          CALL ROT018(RMT,AN)
C              **************
C
        END IF

        DO 320 JDO320 = 1,3
          DO 310 JDO310 = 1,3
            RM(JDO320,JDO310) = RMT(JDO310,JDO320)
  310     CONTINUE
  320   CONTINUE
      END IF
C
      IF (INCCP.EQ.1) THEN
        IF (EULTHE.EQ.1) CALL CCPERR(1,
     +            ' *** INPUT CCP4 does not support THETA1 etc. ***')
        IF (SPHPOL.EQ.1) THEN
          MODE = 'SPHE'
          T1 = PSI
          T2 = PHI
          T3 = AKAPPA
        END IF
C
        IF (EULABG.EQ.1) THEN
          MODE = 'EULE'
          T1 = ALPHA
          T2 = BETA
          T3 = GAMMA
        END IF
C
C            ************************
        CALL CCPROT(RM,T1,T2,T3,MODE)
C            ************************
C
        DO 340 JDO340 = 1,3
          DO 330 JDO330 = 1,3
            RMT(JDO340,JDO330) = RM(JDO330,JDO340)
  330     CONTINUE
  340   CONTINUE
      END IF
C
      IF (INXPL.EQ.1) THEN
        IF (EULABG.EQ.1) CALL CCPERR(1,
     +         ' *** INPUT XPLOR does not support ALPHA etc. ***')
        IF (SPHPOL.EQ.1) THEN
          MODE = 'SPHE'
          DT1 = PSI
          DT2 = PHI
          DT3 = AKAPPA
        END IF
C
        IF (EULTHE.EQ.1) THEN
          MODE = 'EULE'
          DT1 = THETA1
          DT2 = THETA2
          DT3 = THETA3
        END IF
C
C            *********************************
        CALL ROTMAT(DRM,DT1,DT2,DT3,AXIS,MODE)
C            *********************************
C
        DO 360 JDO360 = 1,3
          DO 350 JDO350 = 1,3
            RMT(JDO350,JDO360) = DRM(JDO360,JDO350)
            RM(JDO360,JDO350) = DRM(JDO360,JDO350)
  350     CONTINUE
  360   CONTINUE
      END IF
C
      IF (MATRIX.EQ.1) THEN
        ITERM = 0
C
        DO 380 JDO380 = 1,3
          DO 370 JDO370 = 1,3
            ITERM = 1 + ITERM
            RM(JDO380,JDO370) = X(ITERM)
            RMT(JDO370,JDO380) = X(ITERM)
  370     CONTINUE
  380   CONTINUE
      END IF
C
C---- The matrices need to be converted if crystal ncode is different from
C     standard for MERLOT and XPLOR.
C
      IF ((INXPL.EQ.1 .AND. NCODES(1).NE.NCODEX) .OR. 
     +                      (INMER.EQ.1 .AND. NCODES(1).NE.NCODEM)) THEN
        DO 384 JDO384=1,3
          DO 382 JDO382=1,3
            AJNKS1(JDO382,JDO384) = ROCRYS(JDO382,JDO384,1)
  382     CONTINUE
  384   CONTINUE

        IF (INXPL.EQ.1) THEN
          CALL MATMUL(AJNKS2,RF1,RM)
          CALL MATMUL(RM,AJNKS1,AJNKS2)
        ELSE
          IF (NCODEM .EQ. 3) THEN
            CALL MATMUL(AJNKS2,RF3,RM)
            CALL MATMUL(RM,AJNKS1,AJNKS2)
          ENDIF
          IF (NCODEM .EQ. 5) THEN
            CALL MATMUL(AJNKS2,RF5,RM)
            CALL MATMUL(RM,AJNKS1,AJNKS2)
          ENDIF
        ENDIF
        DO 388 JDO388=1,3
          DO 386 JDO386=1,3
            RMT(JDO388,JDO386) = RM(JDO386,JDO388)
  386     CONTINUE
  388   CONTINUE
      ENDIF
C
C
C
      DO 400 JDO400 = 1,3
        DO 390 JDO390 = 1,3
          AJNKS1(JDO400,JDO390) = RFCRYS(JDO400,JDO390,1)
  390   CONTINUE
  400 CONTINUE
C
C          ************************
      CALL MATMUL(AJNKS2,AJNKS1,RM)
      CALL MATMUL(AJNKS1,RO1,AJNKS2)
      CALL MATMUL(AJNKS3,RO3,AJNKS2)
      CALL MATMUL(AJNKS5,RO5,AJNKS2)
C          ************************
C
      DO 420 JDO420 = 1,3
        DO 410 JDO410 = 1,3
          RM1(JDO420,JDO410) = AJNKS1(JDO420,JDO410)
          RM3(JDO420,JDO410) = AJNKS3(JDO420,JDO410)
          RM3T(JDO410,JDO420) = RM3(JDO420,JDO410)
          RM5(JDO420,JDO410) = AJNKS5(JDO420,JDO410)
          RM5T(JDO410,JDO420) = RM5(JDO420,JDO410)
          DRM(JDO420,JDO410) = RM1(JDO420,JDO410)
  410   CONTINUE
  420 CONTINUE
C
C          **************
c      CALL ANG010(AN,RMT)
C          **************
C
c      WRITE (6,FMT='(//,2(a,i3),a,3f7.1)')
c     +  ' Soln',IMAT,': CCP4 theta1 theta2 theta3  (orth. code',
c     +  NCODES(1),') - ',AN
C
C          **************
      CALL ANG011(AN,RMT)
C          **************
C
      WRITE (6,FMT='(2(a,i3),a,3f7.1)')
     +  ' Soln',IMAT,': CCP4 alpha beta gamma      (orth. code',
     +  NCODES(1),') - ',AN
C
C          **************
      CALL ANG018(AN,RMT)
C          **************
C
      WRITE (6,FMT='(2(a,i3),a,3f7.1)')
     +  ' Soln',IMAT,': CCP4 Phi psi kappa         (orth. code',
     +  NCODES(1),') - ',AN
C
C----  Merlot ncodem = 5 or 3
C
      IF (NCODEM.EQ.5) THEN
C
C            **************
        CALL ANG010(AN,RM5T)
C            **************
C
        WRITE (6,FMT='(//,2(a,i3),a,3f7.1)')
     +    ' Soln',IMAT,': Merlot theta1 theta2 theta3(orth. code',
     +  NCODEM,') - ',AN
C
C            **************
        CALL ANG011(AN,RM5T)
C            **************
C
        WRITE (6,FMT='(2(a,i3),a,3f7.1)')
     +    ' Soln',IMAT,': Merlot alpha beta gamma    (orth. code',
     +  NCODEM,') - ',AN
C
C            **************
        CALL ANG018(AN,RM5T)
C            **************
C
        WRITE (6,FMT='(2(a,i3),a,3f7.1)')
     +    ' Soln',IMAT,': Merlot Phi psi kappa       (orth. code',
     +  NCODEM,') - ',AN
      END IF
C
C----  Merlot ncodem = 3
C
      IF (NCODEM.EQ.3) THEN
C
C            **************
        CALL ANG010(AN,RM3T)
C            **************
C
        WRITE (6,FMT='(//,2(a,i3),a,3f7.1)')
     +    ' Soln',IMAT,': Merlot theta1 theta2 theta3 - (orth. code',
     +  NCODEM,') - ',AN
C
C            **************
        CALL ANG011(AN,RM3T)
C            **************
C
        WRITE (6,FMT='(2(a,i3),a,3f7.1)')
     +    ' Soln',IMAT,': Merlot alpha beta gamma    (orth. code',
     +  NCODEM,') - ',AN
C
C            **************
        CALL ANG018(AN,RM3T)
C            **************
C
        WRITE (6,FMT='(2(a,i3),a,3f7.1)')
     +    ' Soln',IMAT,': Merlot Phi psi kappa       (orth. code',
     +  NCODEM,') - ',AN
      END IF
C
      AXIS(1) = 0.0
      AXIS(2) = 0.0
      AXIS(3) = 0.0
      MODE = 'EULE'
C
C          *********************************
      CALL MATROT(DRM,DT1,DT2,DT3,AXIS,MODE)
C          *********************************
C
      WRITE (6,FMT='(//,2(a,i3),a,3f7.1)')
     +  ' Soln',IMAT,': Xplor theta1 theta2 theta3 (orth. code',
     +  NCODEX,') - ',DT1,
     +  DT2,DT3
      MODE = 'SPHE'
C
C          *********************************
      CALL MATROT(DRM,DT1,DT2,DT3,AXIS,MODE)
C          *********************************
C
      WRITE (6,FMT='(2(a,i3),a,3f7.1)')
     +  ' Soln',IMAT,': Xplor Psi phi kappa        (orth. code',
     +  NCODEX,') - ',DT1,
     +  DT2,DT3
      IF(VERBOSE)WRITE (6,FMT=8877)  NCODES(1),
     +                    ((RM(II,JJ),JJ=1,3),II=1,3)
8877  FORMAT(//,
     +'  Rotation matrix  to PREMULTIPLY Coordinate Vectors',/,
     +' (orth. code = ',I4,'):',/, 
     +3(/, 15X,3F12.5),// )
C
C----  Store input or target matrices
C
      DO 440 JDO440 = 1,3
        DO 430 JDO430 = 1,3
       IF (INPT.EQ.1) RMINP(JDO440,JDO430,IMAT) = RM(JDO440,JDO430)
       IF (INTAR.EQ.1) RMTGT(JDO440,JDO430,ITARGT) = RM(JDO440,JDO430)
  430   CONTINUE
  440 CONTINUE
       IF (INTAR.EQ.1) ATGT(ITARGT) = ATARGT
      GO TO 30
C
C------ OUTPUT [ MERLOT | CCP4 | XPLOR]
C       ====================================
C
  450 CONTINUE
      IF (NCRYST.LT.1)
     +     CALL CCPERR (1, 'Supply CRYSTAL information first')
      WRITE (6,FMT='(//,a/)')
     +  ' **********************************************************'
      NTARGT = ITARGT
      IBACK = 460
      IF (LIST.EQ.0) GO TO 110
  460 CONTINUE
C
C          ************
      CALL CCPUPC(LINE)
C          ************
C
      KEY = LINE(IBEG(2) :IBEG(2)+3)
C
C----   Which sort of program output?
C
      IF (KEY.EQ.'MERL') OUTMER = 1
      IF (KEY.EQ.'CCP4') OUTCCP = 1
      IF (KEY.EQ.'XPLO') OUTXPL = 1
C
C----   Which convention for input information?
C
      KEY = LINE(IBEG(3) :IBEG(3)+2)
      LKEY = .FALSE.
C
C----  Alpha beta gamma
C
      IF (KEY.EQ.'ALP') THEN
        OUTABG = 1
        LKEY = .TRUE.
      END IF
C
C----  Theta1 Theta2 Theta3
C
      IF (KEY.EQ.'THE') THEN
        MODE = 'EULE'
        OUTTHE = 1
        LKEY = .TRUE.
      END IF
C
C----  Sherical polars Psi Phi Kappa or Omega Phi Kappa
C
      IF (KEY.EQ.'PHI' .OR. KEY.EQ.'OME' .OR. KEY.EQ.'PSI') THEN
        MODE = 'SPHE'
        OUTSPH = 1
        LKEY = .TRUE.
      END IF
C
C----  Matrix terms - R11 R12 R13  R21 R22 R23 .. be carefulof transpose!
C
      IF (KEY.EQ.'MAT') THEN
        OUTMAT = 1
        VERBOSE = .TRUE.
        LKEY = .TRUE.
      END IF
C
      IF (.NOT. LKEY) THEN
        WRITE (ISYSW,'(A,A)')' Subkeyword Not recognised: ',
     +  LINE(IBEG(3) :IEND(3))
        CALL CCPERR(1,' *** Unrecognised sub-keyword for OUTPUT ***')
      END IF
C
C----  Merlot output
C      Generate symmetry equivalents 
C      R(isym1,isym2) = [S1(isym1)] [R] [S2(isym2)]
C
      WRITE (6,FMT='(//,a,a,//,a,//,a,/,a,/,a,///,a,a)')
     +  ' Generate symmetry equivalent matrices and rotation angles ',
     +  ' for input rotations:',
     +  '        [R(isym1,isym2)] = [S1(isym1)] [R] [S2(isym2)]',
     +  ' Alpha, Beta, Gamma = Euler (CCP4) ',
     +  ' Phi, Psi, Kappa = polar (CCP4) ',
     +  ' Dc1, Dc2, Dc3 = direction cosines of rotation axis ',
     +  ' X_1 Sym X_2 Sym  Alpha  Beta  Gamma   ',
     +  '  Phi     Psi   Kappa      Dc1     Dc2    Dc3 '

C
      DO 610 IIMAT = 1,IMAT
        DO 480 JDO480 = 1,3
          DO 470 JDO470 = 1,3
            RM(JDO480,JDO470) = RMINP(JDO480,JDO470,IIMAT)
  470     CONTINUE
  480   CONTINUE
C
        WRITE (6,FMT='(/,a,i3,/,a)')' Solution:',IIMAT,
     +    ' **********************************************************'
C
        DO 600 ISYM1 = 1,JSYM(1)
C
          DO 590 ISYM2 = 1,JSYM(2)
C
C---- use AJNKS1 and AJNKS2 as arrays as temporary store...
C
            DO 500 JDO500 = 1,3
              DO 490 JDO490 = 1,3
                AJNKS1(JDO500,JDO490) = ARSYM(JDO500,JDO490,ISYM1,1)
  490         CONTINUE
  500       CONTINUE
            DO 520 JDO520 = 1,3
              DO 510 JDO510 = 1,3
                AJNKS2(JDO520,JDO510) = ARSYM(JDO520,JDO510,ISYM2,2)
  510         CONTINUE
  520       CONTINUE
C
C                ***************************
            CALL MATMUL(AJNKS3,RM,AJNKS2)
            CALL MATMUL(RMSYM,AJNKS1,AJNKS3)
C                ***************************
C
            IF(VERBOSE)WRITE (6,FMT=8866) ((RMSYM(II,JJ),JJ=1,3),II=1,3)
8866  FORMAT(
     +'  Rotation matrix  to PREMULTIPLY Coordinate Vectors',/,
     +3(/, 15X,3F12.5) )
C
C  Wrong way??
c           DO 540 JDO540 = 1,3
c             DO 530 JDO530 = 1,3
c               AJNKS1(JDO540,JDO530) = ROCRYS(JDO540,JDO530,1)
c 530         CONTINUE
c 540       CONTINUE
c
c                ***************************
c           CALL MATMUL(AJNKS2,RMSYM,AJNKS1)
c           CALL MATMUL(AJNKS1,AJNKS2,RF1)
c           CALL MATMUL(AJNKS3,AJNKS2,RF3)
C
            DO 540 JDO540 = 1,3
              DO 530 JDO530 = 1,3
                AJNKS1(JDO540,JDO530) = RFCRYS(JDO540,JDO530,1)
  530         CONTINUE
  540       CONTINUE
C
C                ***************************
            CALL MATMUL(AJNKS2,AJNKS1,RMSYM)
            CALL MATMUL(AJNKS1,RO1,AJNKS2)
            CALL MATMUL(AJNKS3,RO3,AJNKS2)
            CALL MATMUL(AJNKS5,RO5,AJNKS2)
C                ***************************
C
            DO 560 JDO560 = 1,3
              DO 550 JDO550 = 1,3
                RMSYMT(JDO560,JDO550) = RMSYM(JDO550,JDO560)
                RM1(JDO560,JDO550) = AJNKS1(JDO560,JDO550)
                RM3(JDO560,JDO550) = AJNKS3(JDO560,JDO550)
                RM3T(JDO550,JDO560) = RM3(JDO560,JDO550)
                RM5(JDO560,JDO550) = AJNKS5(JDO560,JDO550)
                RM5T(JDO550,JDO560) = RM5(JDO560,JDO550)
                DRM(JDO560,JDO550) = RM1(JDO560,JDO550)
  550         CONTINUE
  560       CONTINUE
C
C  Always want Alpha beta gamma, and Phi Psi Kappa
               CALL ANG011(ANI,RMSYMT)
               CALL ANG018(ANJ,RMSYMT)
               DC1 = SIN(DEGTOR*ANJ(2)) * COS(DEGTOR*ANJ(1))
               DC2 = SIN(DEGTOR*ANJ(2)) * SIN(DEGTOR*ANJ(1))
               DC3 = COS(DEGTOR*ANJ(2))
               WRITE(6,FMT='(2I6,2(3x,3F7.1),3x,3F7.2)')
     +         ISYM1,ISYM2,ANI,ANJ,DC1,DC2,DC3
C
            IF (OUTCCP.EQ.1) THEN
C
C                              *********************
              IF (OUTABG.EQ.1) CALL ANG011(AN,RMSYMT)
              IF (OUTTHE.EQ.1) CALL ANG010(AN,RMSYMT)
              IF (OUTSPH.EQ.1) CALL ANG018(AN,RMSYMT)
C                              *********************
C
              IF (OUTTHE.EQ.1) WRITE (6,FMT='(/,a,3f7.1)')
     +            ' CCP4 theta1 theta2 theta3',AN
              IF (OUTABG.EQ.1) WRITE (6,FMT='(/,a,3f7.1)')
     +            ' CCP4 alpha beta gamma    ',AN
              IF (OUTSPH.EQ.1) WRITE (6,FMT='(/,a,3f7.1)')
     +            ' CCP4 Phi psi kappa       ',AN
            END IF
C
            IF (OUTMER.EQ.1 .AND. NCODEM.EQ.5) THEN
C
C                              *********************
              IF (OUTABG.EQ.1) CALL ANG011(AN,RM5T)
              IF (OUTTHE.EQ.1) CALL ANG010(AN,RM5T)
              IF (OUTSPH.EQ.1) CALL ANG018(AN,RM5T)
C                              *********************
C
              IF (OUTTHE.EQ.1) WRITE (6,FMT='(/,a,3f7.1)')
     +            ' Merlot theta1 theta2 theta3',AN
              IF (OUTABG.EQ.1) WRITE (6,FMT='(/,a,3f7.1)')
     +            ' Merlot alpha beta gamma    ',AN
              IF (OUTSPH.EQ.1) WRITE (6,FMT='(/,a,3f7.1)') 
     +            ' Merlot Phi psi kappa       ',AN
            END IF
C
            IF (OUTMER.EQ.1 .AND. NCODEM.EQ.3) THEN
C
C                              *********************
              IF (OUTABG.EQ.1) CALL ANG011(AN,RM3T)
              IF (OUTTHE.EQ.1) CALL ANG010(AN,RM3T)
              IF (OUTSPH.EQ.1) CALL ANG018(AN,RM3T)
C                              *********************
C
              IF (OUTTHE.EQ.1) WRITE (6,FMT='(/,a,3f7.1)')
     +            ' Merlot theta1 theta2 theta3',AN
              IF (OUTABG.EQ.1) WRITE (6,FMT='(/,a,3f7.1)')
     +            ' Merlot alpha beta gamma    ',AN
              IF (OUTSPH.EQ.1) WRITE (6,FMT='(/,a,3f7.1)') 
     +            ' Merlot Phi psi kappa       ',AN
            END IF
C
            IF (OUTXPL.EQ.1) THEN
              AXIS(1) = 0.0
              AXIS(2) = 0.0
              AXIS(3) = 0.0
C
              DO 580 JDO580 = 1,3
                DO 570 JDO570 = 1,3
                  DRM(JDO580,JDO570) = RM1(JDO580,JDO570)
  570           CONTINUE
  580         CONTINUE
C
C                  *********************************
              CALL MATROT(DRM,DT1,DT2,DT3,AXIS,MODE)
C                  *********************************
C
              IF (MODE.EQ.'EULE') WRITE (6,FMT='(/,a,3f7.1)')
     +            ' Xplor theta1 theta2 theta3      ',DT1,DT2,DT3
              IF (MODE.EQ.'SPHE') WRITE (6,FMT='(/,a,3f7.1)') 
     +            ' Xplor Psi phi kappa             ',DT1,DT2,DT3
            END IF
C
  590     CONTINUE
  600   CONTINUE
  610 CONTINUE
C 
C----  Check self rotation targets:
C
      IF (NTARGT.GT.0) THEN
        WRITE (6,FMT='(//,a/)')
     +    ' **********************************************************'
        WRITE (6,FMT='(///,a,/,a,//,a,/,a,//,a,f6.2,a)')
     +    '  Also check matrix pairs to see if they fit self rotation ',
     +    '  defined by TARGET rotation angles:',
     +    '  This  requires [Rj]*[Ri]**(-1) be near [Rself] ',
     +    '  ie             [Rj]*[Ri]**(-1)*[Rself]**(-1) near [I]?',
     +   '  Check if Kappa of this matrix is less than acceptable error'
     +    ,ERROR,
     +    ' from Target rotation'
C
        DO 880 IIMAT = 1,IMAT
          DO 630 JDO630 = 1,3
            DO 620 JDO620 = 1,3
              RM1(JDO630,JDO620) = RMINP(JDO630,JDO620,IIMAT)
  620       CONTINUE
  630     CONTINUE
C
          DO 870 ISYM1 = 1,JSYM(1)
            DO 650 JDO650 = 1,3
              DO 640 JDO640 = 1,3
                AJNKS1(JDO650,JDO640) = ARSYM(JDO650,JDO640,ISYM1,1)
  640         CONTINUE
  650       CONTINUE
C
            DO 860 ISYM2 = 1,JSYM(2)
C
C---- use AJNKS2 and AJNKS2 as arrays as temporary store...
C
              DO 670 JDO670 = 1,3
                DO 660 JDO660 = 1,3
                  AJNKS2(JDO670,JDO660) = ARSYM(JDO670,JDO660,ISYM2,2)
  660           CONTINUE
  670         CONTINUE
C
C                  ***************************
              CALL MATMUL(AJNKS3,RM1,AJNKS2)
              CALL MATMUL(RMSYM,AJNKS1,AJNKS3)
C                  ***************************
            DO 671 JDO560 = 1,3
              DO 672 JDO550 = 1,3
                RMSYMT(JDO560,JDO550) = RMSYM(JDO550,JDO560)
  672         CONTINUE
  671       CONTINUE
C
C----  find symmetry equivaent in INPUT form
C      Find INMER etc for this matrix
C
              INF1 = INT(INFLG(1,IIMAT)/10)
              INF2 = (INFLG(1,IIMAT)-10*INF1)
C
C  INF1 : 0 = inmer, 1=inccp,2=inxpl
C  INF2 : 1 = EULABG; 2=THE; 3=LAT, 4=SPH.POL,5=AXI,6=MAT
C
              IF (INF1.EQ.0) THEN
C
C                              **********************
                IF (INF2.EQ.1) CALL ANG011(ANI,RMSYMT)
                IF (INF2.EQ.2) CALL ANG010(ANI,RMSYMT)
                IF (INF2.EQ.3) CALL ANG018(ANI,RMSYMT)
C                              **********************
C
                IF (INF2.EQ.1) LINEI = '( Merlot alpha beta gamma)    '
                IF (INF2.EQ.2) LINEI = '( Merlot theta1 theta2 theta3)'
                IF (INF2.EQ.3) LINEI = '( Merlot Phi psi kappa)       '
C
              END IF
              IF (INF1.EQ.1) THEN
C
C                              **********************
                IF (INF2.EQ.1) CALL ANG011(ANI,RMSYMT)
                IF (INF2.EQ.2) CALL ANG010(ANI,RMSYMT)
                IF (INF2.EQ.3) CALL ANG018(ANI,RMSYMT)
C                              **********************
C
                IF (INF2.EQ.1) LINEI = '( CCP4 alpha beta gamma)    '
                IF (INF2.EQ.2) LINEI = '( CCP4 theta1 theta2 theta3)'
                IF (INF2.EQ.3) LINEI = '( CCP4 Phi psi kappa)       '
              END IF
C
              IF (INF1.EQ.2) THEN
                IF (INF2.EQ.1) MODE = 'EULE'
                IF (INF2.EQ.2) MODE = 'SPHE'
                AXIS(1) = 0.0
                AXIS(2) = 0.0
                AXIS(3) = 0.0
C
                DO 690 JDO690 = 1,3
                  DO 680 JDO680 = 1,3
                    DRM(JDO690,JDO680) = RMSYM(JDO690,JDO680)
  680             CONTINUE
  690           CONTINUE
C
C                    *********************************
                CALL MATROT(DRM,DT1,DT2,DT3,AXIS,MODE)
C                    *********************************
C
                ANI(1) = DT1
                ANI(2) = DT2
                ANI(3) = DT3
C
                IF (MODE.EQ.'EULE') LINEI =
     +              '( Xplor theta1 theta2 theta3)'
                IF (MODE.EQ.'SPHE') LINEI =
     +              '( Xplor Psi phi kappa)'
              END IF
C
              DO 850 JMAT = 1,IMAT
                IF (JMAT.EQ.IIMAT) GO TO 850
C
                DO 710 JDO710 = 1,3
                  DO 700 JDO700 = 1,3
                    RM3(JDO710,JDO700) = RMINP(JDO710,JDO700,JMAT)
  700             CONTINUE
  710           CONTINUE
C
                DO 840 JSYM1 = 1,JSYM(1)
                  DO 730 JDO730 = 1,3
                    DO 720 JDO720 = 1,3
               AJNKS1(JDO730,JDO720) = ARSYM(JDO730,JDO720,JSYM1,1)
  720               CONTINUE
  730             CONTINUE
C
                  DO 830 JSYM2 = 1,JSYM(2)
C
C---- use AJNKS2 and AJNKS2 as arrays as temporary store...
C
                    DO 750 JDO750 = 1,3
                      DO 740 JDO740 = 1,3
               AJNKS2(JDO750,JDO740) = ARSYM(JDO750,JDO740,JSYM2,2)
  740                 CONTINUE
  750               CONTINUE
C
C                        ***************************
                    CALL MATMUL(AJNKS3,RM3,AJNKS2)
                    CALL MATMUL(RMSYMJ,AJNKS1,AJNKS3)
C                        ***************************
            DO 751 JDO560 = 1,3
              DO 752 JDO550 = 1,3
                RMSYMT(JDO560,JDO550) = RMSYMJ(JDO550,JDO560)
  752         CONTINUE
  751       CONTINUE
C
C----  find symmetry equivaent in INPUT form
C      Find INMER etc for this matrix
C
                    INF1 = INT(INFLG(1,JMAT)/10)
                    INF2 = (INFLG(1,JMAT)-10*INF1)
C
C  INF1 : 0 = inmer, 1=inccp,2=inxpl
C  INF2 : 1 = EULABG; 2=THE; 3=LAT, 4=SPH.POL,5=AXI,6=MAT
C
                    IF (INF1.EQ.0) THEN
C
C                                    ***********************
                      IF (INF2.EQ.1) CALL ANG011(ANJ,RMSYMT)
                      IF (INF2.EQ.2) CALL ANG010(ANJ,RMSYMT)
                      IF (INF2.EQ.3) CALL ANG018(ANJ,RMSYMT)
C                                    ***********************
C
                      IF (INF2.EQ.1) LINEJ =
     +                                  '( Merlot alpha beta gamma)    '
                      IF (INF2.EQ.2) LINEJ =
     +                                  '( Merlot theta1 theta2 theta3)'
                      IF (INF2.EQ.3) LINEJ =
     +                                  '( Merlot Phi psi kappa)       '
                    END IF
C
                    IF (INF1.EQ.1) THEN
C
C                                    ***********************
                      IF (INF2.EQ.1) CALL ANG011(ANJ,RMSYMT)
                      IF (INF2.EQ.2) CALL ANG010(ANJ,RMSYMT)
                      IF (INF2.EQ.3) CALL ANG018(ANJ,RMSYMT)
C                                    ***********************
C
                      IF (INF2.EQ.1) LINEJ =
     +                                    '( CCP4 alpha beta gamma)    '
                      IF (INF2.EQ.2) LINEJ =
     +                                    '( CCP4 theta1 theta2 theta3)'
                      IF (INF2.EQ.3) LINEJ =
     +                                    '( CCP4 Phi psi kappa)       '
                    END IF
C
                    IF (INF1.EQ.1) THEN
C
C----  Do I need to transpose matrix??
C
                    END IF
C
                    IF (INF1.EQ.2) THEN
                      AXIS(1) = 0.0
                      AXIS(2) = 0.0
                      AXIS(3) = 0.0
C
                      DO 770 JDO770 = 1,3
                        DO 760 JDO760 = 1,3
                          DRM(JDO770,JDO760) = RMSYMJ(JDO770,JDO760)
  760                   CONTINUE
  770                 CONTINUE
C
                      IF (INF2.EQ.1) MODE = 'EULE'
                      IF (INF2.EQ.2) MODE = 'SPHE'
C
C                                    ***********************
                      IF (INF2.EQ.3) CALL ANG018(ANJ,RMSYMT)
                      CALL MATROT(DRM,DT1,DT2,DT3,AXIS,MODE)
C                          *********************************
C
                      ANJ(1) = DT1
                      ANJ(2) = DT2
                      ANJ(3) = DT3
C
                      IF (MODE.EQ.'EULE') LINEJ =
     +                    '( Xplor theta1 theta2 theta3)'
                      IF (MODE.EQ.'SPHE') LINEJ =
     +                    '( Xplor Psi phi kappa)'
                    END IF
C
C---- RMSYMJ(inverse) = RMSYMJ(transpose) - true for Rotation matrices..
C 
                    DO 790 JDO790 = 1,3
                      DO 780 JDO780 = 1,3
                        RMT(JDO780,JDO790) = RMSYMJ(JDO790,JDO780)
  780                 CONTINUE
  790               CONTINUE
C
C                        ************************
                    CALL MATMUL(AJNKS3,RMSYM,RMT)
C                        ************************
C
C---- Check all products with Rtarget if product kappa < error say its close
C
                    DO 820 ITARGT = 1,NTARGT
                      DO 810 JDO810 = 1,3
                        DO 800 JDO800 = 1,3
                AJNKS2(JDO810,JDO800) = RMTGT(JDO810,JDO800,ITARGT)
  800                   CONTINUE
  810                 CONTINUE
C
C                          ****************************
                      CALL MATMUL(AJNKS1,AJNKS2,AJNKS3)
                      CALL ANG018(AN,AJNKS1)
C                          ****************************
C
                      IF (AN(3).GT.180.0) AN(3) = AN(3) - 360.0
C
                      IF (ABS(AN(3)-ATGT(ITARGT)).LT.ERROR) THEN
                        WRITE (6,FMT='(//,a/,a,/,a)')
     +     ' **********************************************************'
     +                    ,'                      a hit!!',
     +     ' **********************************************************'
                        WRITE (6,FMT=
     +                    '(2(a,i3,a,3f7.1,a,i2,a,i2,a,/),a,i3,a)')
     +                    '             Soln:',IIMAT,LINEI,ANI,
     +                    ' ( X_1 Sym',ISYM1,' X_2 Sym',ISYM2,')',
     +                    ' paired with Soln:',JMAT,LINEJ,ANJ,
     +                    ' ( X_1 Sym',JSYM1,' X_2 Sym',JSYM2,')',
     +                    ' matches target rotation.',ITARGT,
     +                    STRTGT(ITARGT)
C
                        WRITE (6,FMT=
     +                  '(//,a,3f7.1,a,I3,a,2I3,a,I3,a,2I3,a,i3)')
     +                  ' Hit: Product Phi psi kappa  ',AN,
     +                  ' - Solns:',IIMAT,'(XSyms',ISYM1,ISYM2,') -',
     +                  JMAT,'(XSyms',JSYM1,JSYM2,') - Target:',ITARGT

                        WRITE(6,'(2a,F7.2,a,F7.1)')
     +                     ' Hit: Angle between direction cosines of ',
     +                     '2 rotations is',AN(3),
     +                     ' - Target angle:',ATGT(ITARGT)
                      END IF
C     DO 820 ITARGT = 1,NTARGT
  820               CONTINUE
C     DO 830 JSYM1 = 1,JSYM(1)
  830             CONTINUE
C     DO 840 JSYM1 = 1,JSYM(1)
  840           CONTINUE
C     DO 850 JMAT = 1,IMAT
  850         CONTINUE
C     DO 860 ISYM2 = 1,JSYM(1)
  860       CONTINUE
C     DO 870 ISYM1 = 1,JSYM(1)
  870     CONTINUE
C     DO 880 IIMAT = 1,IMAT
  880   CONTINUE
      END IF
C
       GO TO 30
C
C----  EOF  (NTOK = -1)
C
  890 CONTINUE
C
      END
C
C     ========================
      SUBROUTINE ANG010(V2,XI)
C     ========================
C
C    INPUT Matrix XI
C    Output V2(1) = THETA1   V2(2) = THETA2   V2(3) = THETA3
C
C---- to extract the angles from a matrix based on
C
C    euler angles theta1, theta2 and theta3
C      rotation 1 (theta1) about x3
C      rotation 2 (theta2) about x1
C      rotation 3 (theta3) about x3
C  
C    r = theta3 * theta2 * theta1
C        x3     * x2     * x1
C    convention of: notes.010
C  
C    version 1.0 xxx xx, 19xx
C      many version existed in an undocumented form
C    version 1.1 mar 20, 1988
C      moved error reporting to this routine
C  
C
C     .. Array Arguments ..
      REAL V2(3),XI(3,3)
C     ..
C     .. Scalars in Common ..
      INTEGER IERR,IPRO
C     ..
C     .. Local Scalars ..
      REAL COS2,DEGTOR,DIF,T1,T2
      INTEGER I,J,K
C     ..
C     .. Local Arrays ..
      REAL AN(3),SI(3,8),X2(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL ROT010
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ACOS,ATAN,ATAN2
C     ..
C     .. Common blocks ..
      COMMON /MLOA01/IERR,IPRO
      SAVE /MLOA01/
C     ..
C     .. Data statements ..
      DATA SI/1.0,1.0,1.0,-1.0,1.0,1.0,-1.0,-1.0,1.0,-1.0,-1.0,-1.0,1.0,
     +     -1.0,-1.0,1.0,1.0,-1.0,1.0,-1.0,1.0,-1.0,1.0,-1.0/
C     ..
C
C----  initialize
C
      DEGTOR = ATAN(1.0)/45.0
C
      AN(1) = 0.0
      AN(2) = 0.0
      AN(3) = 0.0
C
C---- get second angle (theta2)
C
      COS2 = XI(3,3)
      IF (COS2.LT.-1.0) COS2 = -1.0
      IF (COS2.GT.1.0) COS2 = 1.0
      AN(2) = ACOS(COS2)
      IF (ABS(COS2-1.0).LT.1.0E-6) GO TO 20
      IF (ABS(COS2+1.0).LT.1.0E-6) GO TO 20
C
C----  get first angles (theta1)
C
      T1 = XI(3,1)
      T2 = -XI(3,2)
      IF (ABS(T1).LT.1.0E-6 .AND. ABS(T2).LT.1.0E-6) GO TO 10
      AN(1) = ATAN2(T1,T2)
C
C---- get third angle (theta3)
C
   10 CONTINUE
      T1 = XI(1,3)
      T2 = XI(2,3)
      IF (ABS(T1).LT.1.0E-6 .AND. ABS(T2).LT.1.0E-6) GO TO 30
      AN(3) = ATAN2(T1,T2)
      GO TO 30
C
C---- special case: theta2 = 0.0 or 180.0
C
   20 CONTINUE
      T1 = XI(1,2)
      T2 = XI(1,1)
      IF (ABS(T1).LT.1.0E-6 .AND. ABS(T2).LT.1.0E-6) GO TO 30
      AN(1) = ATAN2(T1,T2)
C
C----  find proper signs for angles
C
   30 CONTINUE
      AN(1) = AN(1)/DEGTOR
      AN(2) = AN(2)/DEGTOR
      AN(3) = AN(3)/DEGTOR
C
      DO 70 I = 1,8
        DO 40 J = 1,3
          V2(J) = AN(J)*SI(J,I)
   40   CONTINUE
C
        CALL ROT010(X2,V2)
        DIF = 0.0
C
        DO 60 J = 1,3
          DO 50 K = 1,3
            DIF = ABS(XI(K,J)-X2(K,J)) + DIF
   50     CONTINUE
   60   CONTINUE
C
        IF (DIF.LT.0.05) GO TO 80
   70 CONTINUE
C
C----  here for trouble point 1
C
      WRITE (6,FMT=6000) XI
 6000 FORMAT (/' *** ERROR *** MERLOT *** GROUP1 *** ANG010 ***',/'   ',
     +       '  FAILURE AT TROUBLE POINT 1',/5X,'MATRIX',3F10.5,
     +       2 (/11X,3F10.5))
      IERR = 1
      RETURN
C
C---- here if all is well after trouble point 1
C
   80 CONTINUE
C
      DO 90 I = 1,3
        IF (V2(I).LT.0.0) V2(I) = V2(I) + 360.0
        IF (V2(I).GT.360.0) V2(I) = V2(I) - 360.0
   90 CONTINUE
C
      IF (V2(2).GT.180.0) THEN
        V2(1) = V2(1) + 180.0
        V2(2) = 360.0 - V2(2)
        V2(3) = V2(3) + 180.0
        GO TO 80
      END IF
C
C---- final test of angles against matrix
C
      CALL ROT010(X2,V2)
      DIF = 0.0
C
      DO 110 J = 1,3
        DO 100 K = 1,3
          DIF = ABS(XI(K,J)-X2(K,J)) + DIF
  100   CONTINUE
  110 CONTINUE
C
C---- test for trouble point 2
C
      IF (DIF.GE.0.05) THEN
        WRITE (6,FMT=6002) XI
 6002   FORMAT (/' *** ERROR *** MERLOT *** GROUP1 *** ANG010 ***',
     +         /'     FAILURE AT TROUBLE POINT 2',/5X,'MATRIX',3F10.5,
     +         2 (/11X,3F10.5))
        IERR = 1
        RETURN
      END IF
C
C---- here when d1.0
C
      RETURN
      END
C
C     ========================
      SUBROUTINE ANG011(V2,XI)
C     ========================
C
C    INPUT Matrix XI
C    Output V2(1) = ALPHA   V2(2) = BETA   V2(3) = GAMMA
C
C----  to extract the angles from a matrix based on
C
C    euler angles alpha, beta and gamma
C      rotation 1 (alpha) about x3
C      rotation 2 (beta ) about x1
C      rotation 3 (gamma) about x3
C  
C    r = gamma * beta * alpha
C        x3    * x2   * x1
C    convention of: notes.011
C  
C    version 1.0 xxx xx, 19xx
C      many version existed in an undocumented form
C    version 1.1 mar 20, 1988
C      moved error reporting to this routine
C
C
C  
C     .. Array Arguments ..
      REAL V2(3),XI(3,3)
C     ..
C     .. Scalars in Common ..
      INTEGER IERR,IPRO
C     ..
C     .. Local Scalars ..
      REAL COS2,DEGTOR,DIF,T1,T2
      INTEGER I,J,K
C     ..
C     .. Local Arrays ..
      REAL AN(3),SI(3,8),X2(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL ROT011
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ACOS,ATAN,ATAN2
C     ..
C     .. Common blocks ..
      COMMON /MLOA01/IERR,IPRO
      SAVE /MLOA01/
C     ..
C     .. Data statements ..
      DATA SI/1.0,1.0,1.0,-1.0,1.0,1.0,-1.0,-1.0,1.0,-1.0,-1.0,-1.0,1.0,
     +     -1.0,-1.0,1.0,1.0,-1.0,1.0,-1.0,1.0,-1.0,1.0,-1.0/
C     ..
C
C---- initialize
C
      DEGTOR = ATAN(1.0)/45.0
C
      AN(1) = 0.0
      AN(2) = 0.0
      AN(3) = 0.0
C
C----  get second angle (beta)
C
      COS2 = XI(3,3)
      IF (COS2.LT.-1.0) COS2 = -1.0
      IF (COS2.GT.1.0) COS2 = 1.0
      AN(2) = ACOS(COS2)
      IF (ABS(COS2-1.0).LT.1.0E-6) GO TO 20
      IF (ABS(COS2+1.0).LT.1.0E-6) GO TO 30
C
C---- get first angles (alpha)
C
      T1 = XI(3,2)
      T2 = XI(3,1)
      IF (ABS(T1).LT.1.0E-6 .AND. ABS(T2).LT.1.0E-6) GO TO 10
      AN(1) = ATAN2(T1,T2)
C
C---- get third angle (gamma)
C
   10 CONTINUE
      T1 = XI(2,3)
      T2 = -XI(1,3)
      IF (ABS(T1).LT.1.0E-6 .AND. ABS(T2).LT.1.0E-6) GO TO 40
      AN(3) = ATAN2(T1,T2)
      GO TO 40
C
C---- special case: beta = 0.0
C
   20 CONTINUE
      T1 = XI(1,2)
      T2 = XI(1,1)
      IF (ABS(T1).LT.1.0E-6 .AND. ABS(T2).LT.1.0E-6) GO TO 40
      AN(1) = ATAN2(T1,T2)
      GO TO 40
C
C---- special case: beta = 180.0
C
   30 CONTINUE
      T1 = -XI(1,2)
      T2 = -XI(1,1)
      IF (ABS(T1).LT.1.0E-6 .AND. ABS(T2).LT.1.0E-6) GO TO 40
      AN(1) = ATAN2(T1,T2)
      GO TO 40
C
C---- find proper signs for angles
C
   40 CONTINUE
      AN(1) = AN(1)/DEGTOR
      AN(2) = AN(2)/DEGTOR
      AN(3) = AN(3)/DEGTOR
C
      DO 80 I = 1,8
        DO 50 J = 1,3
          V2(J) = AN(J)*SI(J,I)
   50   CONTINUE
C
        CALL ROT011(X2,V2)
        DIF = 0.0
C
        DO 70 J = 1,3
          DO 60 K = 1,3
            DIF = ABS(XI(K,J)-X2(K,J)) + DIF
   60     CONTINUE
   70   CONTINUE
C
        IF (DIF.LT.0.05) GO TO 90
   80 CONTINUE
C
C---- here for trouble point 1
C
      WRITE (6,FMT=6000) XI
 6000 FORMAT (/' *** ERROR *** MERLOT *** GROUP1 *** ANG011 ***',/'   ',
     +       '  FAILURE AT TROUBLE POINT 1',/5X,'MATRIX',3F10.5,
     +       2 (/11X,3F10.5))
      IERR = 1
      RETURN
C
C---- here if all is well after trouble point 1
C
   90 CONTINUE
C
      DO 100 I = 1,3
        IF (V2(I).LT.0.0) V2(I) = V2(I) + 360.0
        IF (V2(I).GT.360.0) V2(I) = V2(I) - 360.0
  100 CONTINUE
C
      IF (V2(2).GT.180.0) THEN
        V2(1) = V2(1) + 180.0
        V2(2) = 360.0 - V2(2)
        V2(3) = V2(3) + 180.0
        GO TO 90
      END IF
C
C---- final test of angles against matrix
C
      CALL ROT011(X2,V2)
      DIF = 0.0
C
      DO 120 J = 1,3
        DO 110 K = 1,3
          DIF = ABS(XI(K,J)-X2(K,J)) + DIF
  110   CONTINUE
  120 CONTINUE
C
C---- test for trouble point 2
C
      IF (DIF.GE.0.05) THEN
        WRITE (6,FMT=6002) XI
 6002   FORMAT (/' *** ERROR *** MERLOT *** GROUP1 *** ANG011 ***',
     +         /'     FAILURE AT TROUBLE POINT 2',/5X,'MATRIX',3F10.5,
     +         2 (/11X,3F10.5))
        IERR = 1
        RETURN
      END IF
C
C---- here when d1.0
C
      RETURN
      END
C
C     ========================
      SUBROUTINE ANG018(V2,XI)
C     ========================
C
C    INPUT Matrix XI
C    Output V2(1) = PHI   V2(2) = PSI   V2(3) = KAPPA
C
C----  to extract the angles from a matrix based on
C
C    spherical polar angles phi, psi and kappa
C      rotation 1 (phi  ) about x3
C      rotation 2 (psi  ) about x2
C      rotation 3 (kappa) about x3
C  
C    r = phi-1 * psi-1 * kappa * psi * phi
C    convention of: notes.018
C  
C    version 1.0 xxx xx, 19xx
C      many version existed in an undocumented form
C    version 1.1 nov 19, 1981
C      recoded handling of special cases
C      provided explicitly for
C        kappa = 180
C        kappa = 180, psi = 90
C        kappa = 0
C    version 1.2 nov 23, 1981
C      fixed floating divide by 0.0 error in general case code
C    version 1.3 mar 20, 1988
C      moved error reporting to this routine
C
C
C     .. Array Arguments ..
      REAL V2(3),XI(3,3)
C     ..
C     .. Scalars in Common ..
      INTEGER IERR,IPRO
C     ..
C     .. Local Scalars ..
      REAL COS1,COS2,COS3,DEGTOR,DIF,T1,T2
      INTEGER I,J,K
C     ..
C     .. Local Arrays ..
      REAL AN(3),SI(3,8),X2(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL ROT018
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ACOS,ATAN,ATAN2,SQRT
C     ..
C     .. Common blocks ..
      COMMON /MLOA01/IERR,IPRO
      SAVE /MLOA01/
C     ..
C     .. Data statements ..
      DATA SI/1.0,1.0,1.0,-1.0,1.0,1.0,-1.0,-1.0,1.0,-1.0,-1.0,-1.0,1.0,
     +     -1.0,-1.0,1.0,1.0,-1.0,1.0,-1.0,1.0,-1.0,1.0,-1.0/
C     ..
C
C---- initialize
C
      DEGTOR = ATAN(1.0)/45.0
C
      AN(1) = 0.0
      AN(2) = 0.0
      AN(3) = 0.0
C
C----  assume that this is the general case
C    the matrix is:
C
C      +CK                 +CP*SK              -SF*SP*SK
C      +CF*CF*SP*SP(1-CK)  +CF*SF*SP*SP(1-CK)  +CF*CP*SP(1-CK)
C
C      -CP*SK              +CK                 +CF*SP*SK
C      +CF*SF*SP*SP(1-CK)  +SF*SF*SP*SP(1-CK)  +SF*CP*SP(1-CK)
C
C      +SF*SP*SK           -CF*SP*SK           +CK
C      +CF*CP*SP(1-CK)     +SF*CP*SP(1-CK)     +CP*CP(1-CK)
C
      T1 = XI(1,1) + XI(2,2) + XI(3,3)
      COS3 = (T1-1.0)/2.0
      IF (COS3.LT.-1.0) COS3 = -1.0
      IF (COS3.GT.1.0) COS3 = 1.0
      AN(3) = ACOS(COS3)
C
      IF ((1.0-COS3).NE.0.0) T1 = (XI(3,3)-COS3)/ (1.0-COS3)
      IF (T1.LT.0.0) T1 = 0.0
      COS2 = SQRT(T1)
      IF (COS2.LT.-1.0) COS2 = -1.0
      IF (COS2.GT.1.0) COS2 = 1.0
      AN(2) = ACOS(COS2)
C
      T1 = XI(3,1) - XI(1,3)
      T2 = XI(2,3) - XI(3,2)
      IF (T1.NE.0.0 .OR. T2.NE.0.0) AN(1) = ATAN2(T1,T2)
C
      AN(1) = AN(1)/DEGTOR
      AN(2) = AN(2)/DEGTOR
      AN(3) = AN(3)/DEGTOR
C
      DO 40 I = 1,8
C
        DO 10 J = 1,3
          V2(J) = AN(J)*SI(J,I)
   10   CONTINUE
C
        CALL ROT018(X2,V2)
        DIF = 0.0
C
        DO 30 J = 1,3
          DO 20 K = 1,3
            DIF = ABS(XI(K,J)-X2(K,J)) + DIF
   20     CONTINUE
   30   CONTINUE
C
        IF (DIF.LT.0.05) GO TO 150
   40 CONTINUE
C
C----  try special case 1: kappa = 180
C    the matrix is:
C      -1
C      +CF*CF*SP*SP*2      +CF*SF*SP*SP*2      +CF*CP*SP*2
C
C                          -1
C      +CF*SF*SP*SP*2      +SF*SF*SP*SP*2      +SF*CP*SP*2
C
C                                              -1
C      +CF*CP*SP*2         +SF*CP*SP*2         +CP*CP*2
C
      AN(3) = 180.0*DEGTOR
C
      T1 = (XI(3,3)-COS3)/ (1.0-COS3)
      IF (T1.LT.0.0) T1 = 0.0
      COS2 = SQRT(T1)
      IF (COS2.LT.-1.0) COS2 = -1.0
      IF (COS2.GT.1.0) COS2 = 1.0
      AN(2) = ACOS(COS2)
C
      T1 = XI(3,2)
      T2 = XI(3,1)
      IF (T1.NE.0.0 .OR. T2.NE.0.0) AN(1) = ATAN2(T1,T2)
C
      AN(1) = AN(1)/DEGTOR
      AN(2) = AN(2)/DEGTOR
      AN(3) = AN(3)/DEGTOR
C
      DO 80 I = 1,8
        DO 50 J = 1,3
          V2(J) = AN(J)*SI(J,I)
   50   CONTINUE
C
        CALL ROT018(X2,V2)
        DIF = 0.0
C
        DO 70 J = 1,3
          DO 60 K = 1,3
            DIF = ABS(XI(K,J)-X2(K,J)) + DIF
   60     CONTINUE
   70   CONTINUE
C
        IF (DIF.LT.0.05) GO TO 150
   80 CONTINUE
C
C----  try special case 2: kappa = 180, psi = 90
C    the matrix is:
C
C      -1
C      +CF*CF*2            +CF*SF*2            +0
C
C                          -1
C      +CF*SF*2            +SF*SF*2            +0
C
C      +0                  +0                  -1
C
      AN(3) = 180.0*DEGTOR
C
      AN(2) = 90.0*DEGTOR
C
      T1 = (XI(1,1)+1.0)/2.0
      IF (T1.LT.0.0) T1 = 0.0
      COS1 = SQRT(T1)
      IF (COS1.LT.-1.0) COS1 = -1.0
      IF (COS1.GT.1.0) COS1 = 1.0
      AN(1) = ACOS(COS1)
C
      AN(1) = AN(1)/DEGTOR
      AN(2) = AN(2)/DEGTOR
      AN(3) = AN(3)/DEGTOR
C
      DO 120 I = 1,8
        DO 90 J = 1,3
          V2(J) = AN(J)*SI(J,I)
   90   CONTINUE
C
        CALL ROT018(X2,V2)
        DIF = 0.0
C
        DO 110 J = 1,3
          DO 100 K = 1,3
            DIF = ABS(XI(K,J)-X2(K,J)) + DIF
  100     CONTINUE
  110   CONTINUE
C
        IF (DIF.LT.0.05) GO TO 150
  120 CONTINUE
C
C----  try special case 3: kappa = 0
C    the matrix is:
C
C      +1                  +0                  +0
C
C      +0                  +1                  +0
C
C      +0                  +0                  +1
C
      AN(3) = 0.0
      AN(2) = 0.0
      AN(1) = 0.0
C
      V2(3) = AN(3)
      V2(2) = AN(2)
      V2(1) = AN(1)
C
      CALL ROT018(X2,V2)
      DIF = 0.0
C
      DO 140 J = 1,3
        DO 130 K = 1,3
          DIF = ABS(XI(K,J)-X2(K,J)) + DIF
  130   CONTINUE
  140 CONTINUE
C
C----  test for trouble point 1
C
      IF (DIF.GE.0.05) THEN
        WRITE (6,FMT=6000) XI,X2
 6000   FORMAT (/' *** ERROR *** MERLOT *** GROUP1 *** ANG018 ***',
     +         /'     FAILURE AT TROUBLE POINT 1',
     +         /5X,' INPUT MATRIX',3F10.5,
     +         2 (/11X,3F10.5),
     +         /5X,' CALC  MATRIX',3F10.5,
     +         2 (/11X,3F10.5))
        IERR = 1
        RETURN
      END IF
C
C----  impose range limits on angles
C
  150 CONTINUE
C
      DO 160 I = 1,3
        IF (V2(I).LT.0.0) V2(I) = V2(I) + 360.0
        IF (V2(I).GT.360.0) V2(I) = V2(I) - 360.0
  160 CONTINUE
C
      IF (V2(2).GT.180.0) THEN
        V2(2) = V2(2) - 180.0
        V2(3) = 360.0 - V2(3)
        GO TO 150
      END IF
C
      IF (V2(2).GT.90.0) THEN
        V2(1) = V2(1) + 180.0
        V2(2) = 180.0 - V2(2)
        V2(3) = 360.0 - V2(3)
        GO TO 150
      END IF
C
C---- final test of angles against matrix
C
      CALL ROT018(X2,V2)
      DIF = 0.0
C
      DO 180 J = 1,3
        DO 170 K = 1,3
          DIF = ABS(XI(K,J)-X2(K,J)) + DIF
  170   CONTINUE
  180 CONTINUE
C
C---- test for trouble point 2
C
      IF (DIF.GE.0.05) THEN
        WRITE (6,FMT=6002) XI
 6002   FORMAT (/' *** ERROR *** MERLOT *** GROUP1 *** ANG018 ***',
     +         /'     FAILURE AT TROUBLE POINT 2',/5X,'MATRIX',3F10.5,
     +         2 (/11X,3F10.5))
        IERR = 1
        RETURN
      END IF
C
C  .  HERE WHEN D1.0
C
      RETURN
      END
C
C     ==============================================
      SUBROUTINE CCPROT(TRMAT,ALPHA,BETA,GAMMA,MODE)
C     ==============================================
C
C
C     .. Scalar Arguments ..
      REAL ALPHA,BETA,GAMMA
      CHARACTER MODE*4
C     ..
C     .. Array Arguments ..
      REAL TRMAT(3,3)
C     ..
C     .. Local Scalars ..
      REAL AKAPPA,COSA,COSB,COSG,COSK,DEGTOR,PHI,PSI,SINA,SINB,SING,SINK
C     ..
C     .. Local Arrays ..
      REAL DC(3)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ATAN,COS,SIN
C     ..
C
      DEGTOR = ATAN(1.0)/45.0
C
      IF (MODE.EQ.'EULE') THEN
        COSB = COS(BETA*DEGTOR)
        SINB = SIN(BETA*DEGTOR)
        COSA = COS(ALPHA*DEGTOR)
        SINA = SIN(ALPHA*DEGTOR)
        COSG = COS(GAMMA*DEGTOR)
        SING = SIN(GAMMA*DEGTOR)
C
        TRMAT(1,1) = COSG*COSB*COSA - SING*SINA
        TRMAT(2,1) = COSG*COSB*SINA + SING*COSA
        TRMAT(3,1) = -COSG*SINB
        TRMAT(1,2) = -SING*COSB*COSA - COSG*SINA
        TRMAT(2,2) = -SING*COSB*SINA + COSG*COSA
        TRMAT(3,2) = SING*SINB
        TRMAT(1,3) = SINB*COSA
        TRMAT(2,3) = SINB*SINA
        TRMAT(3,3) = COSB
      END IF
C
      IF (MODE.EQ.'SPHE') THEN
        PSI = ALPHA*DEGTOR
        PHI = BETA*DEGTOR
        AKAPPA = GAMMA*DEGTOR
        DC(1) = COS(PHI)*SIN(PSI)
        DC(2) = SIN(PHI)*SIN(PSI)
        DC(3) = COS(PSI)
        COSK = COS(AKAPPA)
        SINK = SIN(AKAPPA)
C
        TRMAT(1,1) = DC(1)*DC(1)* (1.0-COSK) + COSK
        TRMAT(1,2) = -DC(3)*SINK + DC(1)*DC(2)* (1.0-COSK)
        TRMAT(1,3) = +DC(2)*SINK + DC(3)*DC(1)* (1.0-COSK)
        TRMAT(2,1) = +DC(3)*SINK + DC(1)*DC(2)* (1.0-COSK)
        TRMAT(2,2) = DC(2)*DC(2)* (1.0-COSK) + COSK
        TRMAT(2,3) = -DC(1)*SINK + DC(2)*DC(3)* (1.0-COSK)
        TRMAT(3,1) = -DC(2)*SINK + DC(3)*DC(1)* (1.0-COSK)
        TRMAT(3,2) = +DC(1)*SINK + DC(2)*DC(3)* (1.0-COSK)
        TRMAT(3,3) = DC(3)*DC(3)* (1.0-COSK) + COSK
      END IF
      RETURN
C
      END
C
C
C
C     ===========================
      SUBROUTINE M1TIM2(X3,X1,X2)
C     ===========================
C
C  -  matrix3  = matrix1 * matrix2
C
C
C     .. Array Arguments ..
      REAL X1(3,3),X2(3,3),X3(3,3)
C     ..
C
      X3(1,1) = X1(1,1)*X2(1,1) + X1(1,2)*X2(2,1) + X1(1,3)*X2(3,1)
      X3(1,2) = X1(1,1)*X2(1,2) + X1(1,2)*X2(2,2) + X1(1,3)*X2(3,2)
      X3(1,3) = X1(1,1)*X2(1,3) + X1(1,2)*X2(2,3) + X1(1,3)*X2(3,3)
      X3(2,1) = X1(2,1)*X2(1,1) + X1(2,2)*X2(2,1) + X1(2,3)*X2(3,1)
      X3(2,2) = X1(2,1)*X2(1,2) + X1(2,2)*X2(2,2) + X1(2,3)*X2(3,2)
      X3(2,3) = X1(2,1)*X2(1,3) + X1(2,2)*X2(2,3) + X1(2,3)*X2(3,3)
      X3(3,1) = X1(3,1)*X2(1,1) + X1(3,2)*X2(2,1) + X1(3,3)*X2(3,1)
      X3(3,2) = X1(3,1)*X2(1,2) + X1(3,2)*X2(2,2) + X1(3,3)*X2(3,2)
      X3(3,3) = X1(3,1)*X2(1,3) + X1(3,2)*X2(2,3) + X1(3,3)*X2(3,3)
C
      RETURN
      END
C
C     =========================================
      SUBROUTINE MATROT(ROT,T1,T2,T3,AXIS,MODE)
C     =========================================
C
C Routine computes Eulerian angles (MODE="EULE"), Lattman angles
C (MODE="LATT"), spherical polar angles (MODE="SPHE"), or rotation
C axis and angle (MODE="AXIS") from unitary matrix ROT.  The angular
C definitions are described in routine ROTMAT.
C
C Restrictions:
C    Matrix ROT has to be unitary, i.e., det(ROT)=+1 otherwise a fatal
C    warning will be issued.
C
C Conventions:
C    In Eulerian angle mode T2 can be forced without restriction of generality
C   to be located in the interval 0<= T2 <= pi (this is a consequence of
C   the identity operation 
C     t1,t2,t3 -> pi+t1,-t2,pi+t3 in Eulerian angle space).
C
C   T1 is forced into 0 <= t1 < 2*pi and T3 is forced into
C   0<=T3< 2*pi.  If T2 is 0 or PI we set T3 to 0.0 without restriction
C   of generality.
C
C   Lattman angles are forced into the intervals (0 <= theta- <= 2*pi,
C   0<= theta2 <= pi, 0 <= theta+ < 4*pi).
C
C   For spherical polar angles we force psi (=t1) into 0<= t1 < pi and
C   phi (=t2) into 0<= t2 < pi, kappa (=t3) into 0 <= t3 < 2*pi
C   without restriction of generality.  If kappa is equal to 0.0,
C    all angles will be 0.0.  If psi is equal to 0.0, phi will be set to 0.0.
C
C  Spherical polar angles are used to compute the rotation axis in AXIS mode.
C  Without restriction of generality, kappa is forced into 0 <= kappa <= pi.
C
C Input:
C    MODE specifies angle mode
C    ROT(3,3) contains the rotation matrix.  The matrix is defines
C    the rotation according to r'(i)=sum_j ROT(i,j)*r(j)
C
C Ouput:
C  T1,T2,T3 are theta1 (z), theta2 (x'), theta3 (z') for MODE="EULE"
C  T1,T2,T3 are theta+, theta2, theta- for MODE="LATT"
C  T1,T2,T3 are psi (incl. vs. y), phi (azimuthal), kappa for MODE="SPHE"
C             and MODE="AXIS"
C  T3, AXIS(3) are kappa and a 3-D vector specifying the axis for MODE="AXIS"
C Note: all rotations are counter-clockwise
C
C Author: Axel T. Brunger
C =======================
C
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION T1,T2,T3
      CHARACTER MODE*4
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION AXIS(3),ROT(3,3)
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION C1,C12,C2,C22,C3,DET,PII,RAD,S1,S2,S3,TM,TP
      INTEGER I,J
      LOGICAL COND
C     ..
C     .. Local Arrays ..
      DOUBLE PRECISION ROT2(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR,ROTMAT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ACOS,ATAN,COS,MAX,MIN,SIGN,SQRT
C     ..
C
      PII = ATAN(1.0D0)*4.0D0
      RAD = ATAN(1.0D0)/45.0D0
C
C---- test to make sure that the matrix is unitary
C
      DET = (ROT(1,1)*ROT(2,2)-ROT(1,2)*ROT(2,1))*ROT(3,3) +
     +      (ROT(2,1)*ROT(3,2)-ROT(2,2)*ROT(3,1))*ROT(1,3) +
     +      (ROT(3,1)*ROT(1,2)-ROT(3,2)*ROT(1,1))*ROT(2,3)
      IF (ABS(DET-1.0).GT.0.0001) THEN
C
C            *************************************
        CALL CCPERR(1,'matrix ROT is not unitary')
C            *************************************
C
      ELSE
C
        IF (MODE.EQ.'EULE' .OR. MODE.EQ.'LATT') THEN
C
C---- first, let's get t2:
C
          C2 = MAX(-1.0D0,MIN(1.0D0,ROT(3,3)))
          T2 = ACOS(C2)/RAD
C
C---- second, let's compute SIN(T2) (OE positive)
C
          S2 = SQRT(MAX(0.0D0,1.0D0-ROT(3,3)**2))
C
C---- if COS(T2) not equal +-1 then T1 and T3 are uniquely determined
C
          IF (ABS(ABS(C2)-1.0D0).GT.0.0001D0) THEN
            S3 = ROT(1,3)/S2
            C3 = ROT(2,3)/S2
            C3 = MAX(-1.0D0,MIN(1.0D0,C3))
            T3 = ACOS(C3)
            IF (S3.LT.0.0D0) T3 = 2.0D0*PII - T3
            T3 = T3/RAD
            S1 = ROT(3,1)/S2
            C1 = -ROT(3,2)/S2
            C1 = MAX(-1.0D0,MIN(1.0D0,C1))
            T1 = ACOS(C1)
            IF (S1.LT.0.0D0) T1 = 2.0D0*PII - T1
            T1 = T1/RAD
          ELSE
C
C---- without restriction T3 can be set to 0.0
C
            T3 = 0.0
            C1 = ROT(1,1)
            S1 = ROT(1,2)
            C1 = MAX(-1.0D0,MIN(1.0D0,C1))
            T1 = ACOS(C1)
            IF (S1.LT.0.0D0) T1 = 2.0D0*PII - T1
            T1 = T1/RAD
          END IF
C
          IF (MODE.EQ.'LATT') THEN
C
C---- in "Lattman" mode compute theta+, theta- from theta1, theta3
C
            TP = T1 + T3
            TM = T1 - T3
            T1 = TP
            T3 = TM
C
C---- we know that 0 <= theta1 < 2*pi and 0 <= theta3 < 2*pi.
C     We have to project this into the Lattman space
C     asymmetric unit (0<= theta+ < 4*pi,
C      0 <= theta- < 2*pi).
C
            IF (T3.LT.0.0D0) THEN
              IF (T1.LT.360.0D0) THEN
                T1 = T1 + 360.0D0
                T3 = T3 + 360.0D0
              ELSE
                T1 = T1 - 360.0D0
                T3 = T3 + 360.0D0
              END IF
            END IF
C
          END IF
C
        ELSE IF (MODE.EQ.'SPHE' .OR. MODE.EQ.'AXIS') THEN
C
C---- first lets get COS (kappa)
C
          C3 = (ROT(1,1)+ROT(2,2)+ROT(3,3)-1.0D0)/2.0D0
          C3 = MAX(-1.0D0,MIN(1.0D0,C3))
C
C---- special case COS(kappa)=1
C
          IF (ABS(C3-1.0D0).LT.0.0001D0) THEN
            T1 = 0.0D0
            T2 = 0.0D0
            T3 = 0.0D0
          ELSE
C
C---- determine COS^2(psi)
C
            C12 = MAX(0.0D0, (ROT(2,2)-C3)/ (1.0D0-C3))
C
C---- special case COS(psi)=+-1
C
            IF (ABS(C12-1.0D0).LT.0.0001D0) THEN
              T1 = 0.0D0
              T2 = 0.0D0
              T3 = ACOS(C3)
              IF (ROT(3,1).LT.0.0D0) T3 = 2.0D0*PII - T3
              T3 = T3/RAD
            ELSE
C
C---- determine COS^2(phi)
C
              C22 = MAX(0.0D0, (ROT(1,1)-C3)/ ((1.0D0-C3)* (1.0D0-C12)))
C
C---- special case COS(phi)=+-1
C
              IF (ABS(C22-1.0D0).LT.0.0001D0) THEN
                C1 = SIGN(1.0D0, (ROT(1,2)+ROT(2,1))/ (1.0D0-C3))*
     +               SQRT(C12)
                C1 = MAX(-1.0D0,MIN(1.0D0,C1))
                T1 = ACOS(C1)/RAD
                T2 = 0.0D0
                T3 = ACOS(C3)
                IF (ROT(2,3)-ROT(3,2).LT.0.0D0) T3 = 2.0D0*PII - T3
                T3 = T3/RAD
              ELSE
C
C---- determine sign of COS(psi) and then determine psi
C
                C1 = SIGN(1.0D0, (-ROT(2,3)-ROT(3,2))/ (1.0D0-C3))*
     +               SQRT(C12)
                C1 = MAX(-1.0D0,MIN(1.0D0,C1))
                T1 = ACOS(C1)/RAD
C
C---- determine sign of COS(phi) and then determine phi
C
                C2 = SIGN(1.0D0, (-ROT(1,3)-ROT(3,1))/ (1.0D0-C3))*
     +               SQRT(C22)
                C2 = MAX(-1.0D0,MIN(1.0D0,C2))
                T2 = ACOS(C2)/RAD
C
C---- determine kappa
C
                T3 = ACOS(C3)
                IF (ABS(C2-1.0D0).LT.0.0001D0) THEN
                  IF (ROT(2,3)-ROT(3,2).LT.0.0D0) T3 = 2.0D0*PII - T3
                ELSE
                  IF (ROT(1,2)-ROT(2,1).GT.0.0D0) T3 = 2.0D0*PII - T3
                END IF
                T3 = T3/RAD
              END IF
            END IF
          END IF
C
          IF (MODE.EQ.'AXIS') THEN
            AXIS(2) = COS(T1*RAD)
            AXIS(1) = SQRT(MAX(0.0D0,1.0D0-AXIS(2)**2))*COS(T2*RAD)
            AXIS(3) = -SQRT(MAX(0.0D0,1.0D0-AXIS(1)**2-AXIS(2)**2))
C
C---- without restriction of generality we force T3 in 0 <= T3 <= pi
C
            IF (T3.GT.180.0D0) THEN
              T3 = 2.0D0*180.0D0 - T3
              AXIS(1) = -AXIS(1)
              AXIS(2) = -AXIS(2)
              AXIS(3) = -AXIS(3)
            END IF
          END IF
        END IF
C
C---- now back-compute the matrix as an internal consistency check
C
C            ******************************
        CALL ROTMAT(ROT2,T1,T2,T3,AXIS,MODE)
C            ******************************
C
        COND = ABS(ROT(1,1)-ROT2(1,1)) .GT. 0.01D0 .OR.
     +         ABS(ROT(1,2)-ROT2(1,2)) .GT. 0.01D0 .OR.
     +         ABS(ROT(1,3)-ROT2(1,3)) .GT. 0.01D0 .OR.
     +         ABS(ROT(2,1)-ROT2(2,1)) .GT. 0.01D0 .OR.
     +         ABS(ROT(2,2)-ROT2(2,2)) .GT. 0.01D0 .OR.
     +         ABS(ROT(2,3)-ROT2(2,3)) .GT. 0.01D0 .OR.
     +         ABS(ROT(3,1)-ROT2(3,1)) .GT. 0.01D0 .OR.
     +         ABS(ROT(3,2)-ROT2(3,2)) .GT. 0.01D0 .OR.
     +         ABS(ROT(3,3)-ROT2(3,3)) .GT. 0.01D0
C
        IF (COND) THEN
          WRITE (6,FMT='(A,3G12.4)')
     +      ' %ROTMAT-ERR: inconsistent T1,T2,T3=',T1,T2,T3
          WRITE (6,FMT='(/A,3(/3F12.6))') ' ROT =',
     +      ((ROT(I,J),J=1,3),I=1,3)
          WRITE (6,FMT='(/A,3(/3F12.6))') ' ROT2 =',
     +      ((ROT2(I,J),J=1,3),I=1,3)
C              ***********************************************
          CALL CCPERR(1,'Error in internal consistency check')
C              ***********************************************
        END IF
      END IF
      END
C
C     ====================================
      SUBROUTINE RORDER(SYMMAT,NAX,NORDER)
C     ====================================
C
C---- Determine rotational order of matrix SYMMAT about
C     the NAX'th axis
C
C On entry:
C  SYMMAT(3,3) symmetry matrix acting on orthogonal coordinates
C  NAX         axis to test
C
C On exit:
C  NORDER      order of axis if valid (2,3,4,6 only),
C              else = 1
C
C
C     .. Scalar Arguments ..
      INTEGER NAX,NORDER
C     ..
C     .. Array Arguments ..
      REAL SYMMAT(3,3)
C     ..
C     .. Local Scalars ..
      REAL COSKAP,DET,KAPPA,ORDER,RTODEG,TRACE
      INTEGER I
C     ..
C     .. External Subroutines ..
      EXTERNAL DETMAT
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ACOS,ATAN,MAX,MIN,NINT
C     ..
C
      RTODEG = 45.0/ATAN(1.0)
C
C---- First check that determinant = +1
C
C          ******************
      CALL DETMAT(SYMMAT,DET)
C          ******************
C
      IF (DET.GE.0.999) THEN
C
C---- Check for pure rotation (ie rotation leaves value of NAX'th
C     axis unchanged). Check NAX'th row of matrix
C
        TRACE = 0.0
C
        DO 10 I = 1,3
          IF (I.EQ.NAX) THEN
            IF (ABS(SYMMAT(NAX,I)-1.0).GT.0.001) GO TO 30
          ELSE IF (ABS(SYMMAT(NAX,I)).GT.0.001) THEN
            GO TO 20
          END IF
          TRACE = SYMMAT(I,I) + TRACE
   10   CONTINUE
C
C---- Success, this is a rotation about NAX
C     Get rotation angle Kappa:  Trace = 1 + 2 cos Kappa
C
        COSKAP = MIN(MAX((TRACE-1.0)*0.5,-1.0),+1.0)
        KAPPA = ACOS(COSKAP)*RTODEG
C
        IF (ABS(KAPPA).LT.0.01) THEN
          GO TO 40
        ELSE
          ORDER = 360.0/KAPPA
          NORDER = NINT(ORDER)
C
          IF (ABS(ORDER-NORDER).GT.0.001) THEN
C
C---- Not close enough to integral
C
            GO TO 40
C
          ELSE IF (NORDER.NE.2 .AND. NORDER.NE.3 .AND. NORDER.NE.4 .AND.
     +             NORDER.NE.6) THEN
C
C---- Not acceptable order
C
            GO TO 40
          ELSE
C
C---- Order .gt. 0 found
C
            RETURN
          END IF
        END IF
C
C---- Failed
C
   20   CONTINUE
        GO TO 40
C
C---- Failed
C
   30   CONTINUE
      END IF
C
C---- Failed to find acceptable order
C
   40 NORDER = 1
C
      END
C
C     ========================
      SUBROUTINE ROT010(XO,AN)
C     ========================
C
C   Input AN(1) = THETA1   AN(2) = THETA2   AN(3) = THETA3
C    Return Matrix XO
C
C----  to calculate the rotation matrix associated with euler angles
C
C    theta1, theta2 and theta3
C      rotation 1 (theta1) about x3
C      rotation 2 (theta2) about x1
C      rotation 3 (theta3) about x3
C  
C    r = theta3 * theta2 * theta1
C        x3     * x2     * x1
C    convention of:  notes.010
C  
C
C     .. Array Arguments ..
      REAL AN(3),XO(3,3)
C     ..
C     .. Local Scalars ..
      REAL AN1,AN2,AN3,DEGTOR
C     ..
C     .. Local Arrays ..
      REAL X1(3,3),X2(3,3),X21(3,3),X3(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL M1TIM2
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ATAN,COS,SIN
C     ..
C
C---- convert angles from degrees to radians
C
      DEGTOR = ATAN(1.0)/45.0
C
      AN1 = AN(1)*DEGTOR
      AN2 = AN(2)*DEGTOR
      AN3 = AN(3)*DEGTOR
C
C----  load matrix 1
C    theta1
C
      X1(1,1) = COS(AN1)
      X1(1,2) = SIN(AN1)
      X1(1,3) = 0.0
      X1(2,1) = -SIN(AN1)
      X1(2,2) = COS(AN1)
      X1(2,3) = 0.0
      X1(3,1) = 0.0
      X1(3,2) = 0.0
      X1(3,3) = 1.0
C
C----   load matrix 2
C      theta2
C
      X2(1,1) = 1.0
      X2(1,2) = 0.0
      X2(1,3) = 0.0
      X2(2,1) = 0.0
      X2(2,2) = COS(AN2)
      X2(2,3) = SIN(AN2)
      X2(3,1) = 0.0
      X2(3,2) = -SIN(AN2)
      X2(3,3) = COS(AN2)
C
C----  load matrix 3
C       theta3
C
      X3(1,1) = COS(AN3)
      X3(1,2) = SIN(AN3)
      X3(1,3) = 0.0
      X3(2,1) = -SIN(AN3)
      X3(2,2) = COS(AN3)
      X3(2,3) = 0.0
      X3(3,1) = 0.0
      X3(3,2) = 0.0
      X3(3,3) = 1.0
C
C---- form product matrix: theta3 x theta2 x theta1
C
C          *****************
      CALL M1TIM2(X21,X2,X1)
      CALL M1TIM2(XO,X3,X21)
C          *****************
C
      RETURN
      END
C
C     ========================
      SUBROUTINE ROT011(XO,AN)
C     ========================
C
C   Input AN(1) = ALPHA   AN(2) = BETA   AN(3) = GAMMA
C    Return Matrix XO
C
C----  to calculate the rotation matrix associated with euler angles
C    alpha, beta and gamma
C      rotation 1 (alpha) about x3
C      rotation 2 (beta ) about x2
C      rotation 3 (gamma) about x3
C  
C    r = gamma * beta * alpha
C        x3    * x2   * x1
C    convention of:  crowther rotation function
C                    appendix f
C
C
C     .. Array Arguments ..
      REAL AN(3),XO(3,3)
C     ..
C     .. Local Scalars ..
      REAL AN1,AN2,AN3,DEGTOR
C     ..
C     .. Local Arrays ..
      REAL X1(3,3),X2(3,3),X21(3,3),X3(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL M1TIM2
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ATAN,COS,SIN
C     ..
C
C----  initialize
C
      DEGTOR = ATAN(1.0)/45.0
C
C----  convert angles from degrees to radians
C
      AN1 = AN(1)*DEGTOR
      AN2 = AN(2)*DEGTOR
      AN3 = AN(3)*DEGTOR
C
C----  load matrix 1
C       alpha
C
      X1(1,1) = COS(AN1)
      X1(1,2) = SIN(AN1)
      X1(1,3) = 0.0
      X1(2,1) = -SIN(AN1)
      X1(2,2) = COS(AN1)
      X1(2,3) = 0.0
      X1(3,1) = 0.0
      X1(3,2) = 0.0
      X1(3,3) = 1.0
C
C----  load matrix 2
C       beta
C
      X2(1,1) = COS(AN2)
      X2(1,2) = 0.0
      X2(1,3) = -SIN(AN2)
      X2(2,1) = 0.0
      X2(2,2) = 1.0
      X2(2,3) = 0.0
      X2(3,1) = SIN(AN2)
      X2(3,2) = 0.0
      X2(3,3) = COS(AN2)
C
C----  load matrix 3
C      gamma
C
      X3(1,1) = COS(AN3)
      X3(1,2) = SIN(AN3)
      X3(1,3) = 0.0
      X3(2,1) = -SIN(AN3)
      X3(2,2) = COS(AN3)
      X3(2,3) = 0.0
      X3(3,1) = 0.0
      X3(3,2) = 0.0
      X3(3,3) = 1.0
C
C---- form product matrix: gamma x beta x alpha
C
C          *****************
      CALL M1TIM2(X21,X2,X1)
      CALL M1TIM2(XO,X3,X21)
C          *****************
C
      RETURN
      END
C
C     ========================
      SUBROUTINE ROT018(XO,AN)
C     ========================
C
C   Input AN(1) = PHI   AN(2) = PSI   AN(3) = KAPPA
C    Return Matrix XO
C
C----  to calculate the rotation matrix associated with
C
C    spherical polar angles psi, phi and kappa
C      rotation 1 (phi  ) about x3
C      rotation 2 (psi  ) about x2
C      rotation 3 (kappa) about x3
C  
C    r  = phi * psi * kappa * (psi)INV * (phi)INV
C         x5    x4    x3      x2      x1
C    convention of: notes.018
C  
C
C     .. Array Arguments ..
      REAL AN(3),XO(3,3)
C     ..
C     .. Local Scalars ..
      REAL AN1,AN2,AN3,DEGTOR
C     ..
C     .. Local Arrays ..
      REAL X1(3,3),X2(3,3),X21(3,3),X3(3,3),X31(3,3),X4(3,3),X41(3,3),
     +     X5(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL M1TIM2
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ATAN,COS,SIN
C     ..
C
      DEGTOR = ATAN(1.0)/45.0
      AN1 = AN(1)*DEGTOR
      AN2 = AN(2)*DEGTOR
      AN3 = AN(3)*DEGTOR
C
C----  load matrix 1
C           phi-1
C
      X1(1,1) = COS(AN1)
      X1(1,2) = SIN(AN1)
      X1(1,3) = 0.0
      X1(2,1) = -SIN(AN1)
      X1(2,2) = COS(AN1)
      X1(2,3) = 0.0
      X1(3,1) = 0.0
      X1(3,2) = 0.0
      X1(3,3) = 1.0
C
C----  load matrix 2
C             psi-1
C
      X2(1,1) = COS(AN2)
      X2(1,2) = 0.0
      X2(1,3) = -SIN(AN2)
      X2(2,1) = 0.0
      X2(2,2) = 1.0
      X2(2,3) = 0.0
      X2(3,1) = SIN(AN2)
      X2(3,2) = 0.0
      X2(3,3) = COS(AN2)
C
C----  load matrix 3
C         kappa
C
      X3(1,1) = COS(AN3)
      X3(1,2) = -SIN(AN3)
      X3(1,3) = 0.0
      X3(2,1) = SIN(AN3)
      X3(2,2) = COS(AN3)
      X3(2,3) = 0.0
      X3(3,1) = 0.0
      X3(3,2) = 0.0
      X3(3,3) = 1.0
C
C----   load matrix 4
C    psi
C
      X4(1,1) = COS(AN2)
      X4(1,2) = 0.0
      X4(1,3) = SIN(AN2)
      X4(2,1) = 0.0
      X4(2,2) = 1.0
      X4(2,3) = 0.0
      X4(3,1) = -SIN(AN2)
      X4(3,2) = 0.0
      X4(3,3) = COS(AN2)
C
C----   load matrix 5
C    phi
C
      X5(1,1) = COS(AN1)
      X5(1,2) = -SIN(AN1)
      X5(1,3) = 0.0
      X5(2,1) = SIN(AN1)
      X5(2,2) = COS(AN1)
      X5(2,3) = 0.0
      X5(3,1) = 0.0
      X5(3,2) = 0.0
      X5(3,3) = 1.0
C
C----  form product matrix: phi * psi * kappa * psi-1 * phi-1
C
C          *****************
      CALL M1TIM2(X21,X2,X1)
      CALL M1TIM2(X31,X3,X21)
      CALL M1TIM2(X41,X4,X31)
      CALL M1TIM2(XO,X5,X41)
C          *****************
C
      RETURN
      END
C
C     =========================================
      SUBROUTINE ROTMAT(ROT,T1,T2,T3,AXIS,MODE)
C     =========================================
C
C Routine computes unitary rotation matrix ROT using Eulerian angles
C (MODE="EULE"), Lattman angles (MODE="LATT"), spherical polar angles
C (MODE="SPHE") or a rotation about the specified axis (MODE="AXIS").
C
C Input:
C    MODE specifies angle mode
C    T1,T2,T3 are theta1 (z), theta2 (x'), theta3 (z') for MODE="EULE"
C    T1,T2,T3 are theta+, theta2, theta- for MODE="LATT"
C    T1,T2,T3 are psi (incl. vs. y), phi (azimuthal angle, that is,
C             the angle between the x-axis and the projection of the
C             axis into the x,z plane ), kappa for MODE="SPHE"
C T3, AXIS(3) are kappa and a 3-D vector specifying the axis for MODE="AXIS"
C  Note: all rotations are counter-clockwise
C
C Output:
C    ROT(3,3) contains the rotation matrix.  Should be applied as
C    r'(i)=sum_j ROT(i,j)*r(j)
C
C    AXIS contains the normalized input AXIS vector and T1,T2,T3 will
C    contain the spherical polar angles for MODE="SPHE"
C
C Author: Axel T. Brunger
C =======================
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION T1,T2,T3
      CHARACTER MODE*4
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION AXIS(3),ROT(3,3)
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION C1,C2,C3,C3C,DTEMP1,DTEMP2,DTEMP3,DTEMP4,NN,RAD,
     +                 S1,S1SQ,S2,S3,TM,TP,TT1,TT3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ACOS,ATAN,COS,MAX,MIN,SIN,SQRT
C     ..
C
      RAD = ATAN(1.0D0)/45.0D0
C
      IF (MODE.EQ.'EULE' .OR. MODE.EQ.'LATT') THEN
C
C Computes rotation matrix corresponding to the three
C Eulerian angles theta1=T1, theta2=T2, theta3=T3.  This uses
C the Rossmann and Blow convention, i.e., a theta1 rotation
C around the Z axis, followed by
C a theta2 rotation around the moved X axis, and followed by a
C theta3 rotation around the moved Z axis.  These angles are positive
C if they are anti-clockwise when looking down the relevant axis.
C
        IF (MODE.EQ.'LATT') THEN
C
C---- In "Lattman" mode, theta+=theta1+theta3=T1, theta2=T2,
C     theta-=theta1-theta3=T3
C
          TP = T1
          TM = T3
          TT1 = (TP+TM)/2.0D0
          TT3 = (TP-TM)/2.0D0
        ELSE
          TT1 = T1
          TT3 = T3
        END IF
C
        S1 = SIN(RAD*TT1)
        S2 = SIN(RAD*T2)
        S3 = SIN(RAD*TT3)
        C1 = COS(RAD*TT1)
        C2 = COS(RAD*T2)
        C3 = COS(RAD*TT3)
        ROT(1,1) = -S1*C2*S3 + C1*C3
        ROT(1,2) = C1*C2*S3 + S1*C3
        ROT(1,3) = S2*S3
        ROT(2,1) = -S1*C2*C3 - C1*S3
        ROT(2,2) = C1*C2*C3 - S1*S3
        ROT(2,3) = S2*C3
        ROT(3,1) = S1*S2
        ROT(3,2) = -C1*S2
        ROT(3,3) = C2
C
      ELSE IF (MODE.EQ.'SPHE' .OR. MODE.EQ.'AXIS') THEN
C
        IF (MODE.EQ.'AXIS') THEN
C
C In axis mode we obtain the psi, phi spherical polar angles from
C the AXIS vector.
C The rotation kappa corresonds to an anticlockwise rotation (t3) about
C the specified axis. The axis is desribed as a vector (AXIS).
C
          NN = SQRT(AXIS(1)**2+AXIS(2)**2+AXIS(3)**2)
C
          IF (NN.LT.0.0001D0) THEN
            WRITE (6,FMT=*) 'rotation vector has 0.0 length'
            T1 = 0.0D0
            T2 = 0.0D0
            T3 = 0.0D0
          ELSE
            AXIS(1) = AXIS(1)/NN
            AXIS(2) = AXIS(2)/NN
            AXIS(3) = AXIS(3)/NN
            T1 = ACOS(AXIS(2))/RAD
C
            IF (AXIS(1)**2+AXIS(3)**2.LT.0.0001D0) THEN
              T2 = 0.0D0
            ELSE
cc
cc-- alliant change intrinsics need to match args
cc
cc      T2=ACOS(MAX(-1.0,MIN(1.0,AXIS(1)/SQRT(AXIS(1)**2+AXIS(3)**2))))
cc     &    /RAD
cc
              DTEMP1 = SQRT(AXIS(1)**2+AXIS(3)**2)
              DTEMP2 = AXIS(1)/DTEMP1
              DTEMP3 = MIN(1.0D0,DTEMP2)
              DTEMP4 = MAX(-1.0D0,DTEMP3)
              T2 = ACOS(DTEMP4)/RAD
cc
cc
              IF (AXIS(3).GT.0.0D0) T2 = -T2
            END IF
          END IF
        END IF
C
C compute rotation matrix corresponding to the three
C spherical polar angles psi=t1, phi=t2 and kappa=t3.  The rotation is
C described by specification of the direction of an axis through
C phi (azimutal angle between the x axis and the projection of the
C rotation axis on the x-z plane) and psi (inclination versus y axis).
C The angle kappa specifies the rotation around the specified axis.
C  The kappa angle is anti-clockwise when looking along the rotation axis.
C The phi angle is anti-clockwise when looking along y.
C
        S1 = SIN(RAD*T1)
        S2 = SIN(RAD*T2)
        S3 = SIN(RAD*T3)
        C1 = COS(RAD*T1)
        C2 = COS(RAD*T2)
        C3 = COS(RAD*T3)
        S1SQ = S1*S1
        C3C = 1.0D0 - C3
        ROT(1,1) = S1SQ*C2*C2*C3C + C3
        ROT(1,2) = S1*C1*C2*C3C - S1*S2*S3
        ROT(1,3) = -S1SQ*C2*S2*C3C - C1*S3
        ROT(2,1) = S1*C1*C2*C3C + S1*S2*S3
        ROT(2,2) = C1*C1*C3C + C3
        ROT(2,3) = -S1*C1*S2*C3C + S1*C2*S3
        ROT(3,1) = -S1SQ*S2*C2*C3C + C1*S3
        ROT(3,2) = -S1*C1*S2*C3C - S1*C2*S3
        ROT(3,3) = S1SQ*S2*S2*C3C + C3
C
      END IF
C
      RETURN
      END

C
C     =================
      SUBROUTINE SYMORT
C     =================
C
C---- Generate symmetry operations ARSYM which
C     operate on orthogonal coordinates
C
C On entry:
C  RSYM(4,4,24,2)  symmetry operations
C  RFCRYS(4,4,2)       orthogonal to fractional matrices
C  ROCRYS(4,4,2)       fractional to orthogonal matrices
C
C On exit:
C  ARSYM        =  ROCRYS * RSYM * RFCRYS
C
C
C     .. Scalars in Common ..
      INTEGER NCRYST
C     ..
C     .. Arrays in Common ..
      REAL ARSYM,CELCRY,F2MAX,F2MIN,F2MINS,RFCRYS,ROCRYS,RSYM,RSYMT,
     +     SCALFO,TFAC,VOLCR
      INTEGER JSYM,LSPGRP,NCODES,NSYMZO
C     ..
C     .. Local Scalars ..
      INTEGER I,IR,ISYM1,IXL,J,JR,K
C     ..
C     .. Local Arrays ..
      REAL AJNKS1(3,3),AJNKS2(3,3),AJUNK4(3,3),AJUNKO(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL MATMUL
C     ..
C     .. Common blocks ..
      COMMON /CRYSTS/NCRYST,ROCRYS(4,4,2),RFCRYS(4,4,2),CELCRY(6,2),
     +       NCODES(2),LSPGRP(2),VOLCR(2),TFAC(2),NSYMZO(2),F2MIN(2),
     +       SCALFO(2),F2MAX(2),F2MINS(2)
      COMMON /SYMTR/JSYM(2),RSYM(4,4,192,2),RSYMT(4,4,192,2),
     +       ARSYM(3,3,192,2)
C     ..
C
      DO 40 IXL = 1,2
        DO 30 K = 1,192
          DO 20 J = 1,3
            DO 10 I = 1,3
              ARSYM(I,J,K,IXL) = RSYM(I,J,K,IXL)
   10       CONTINUE
   20     CONTINUE
   30   CONTINUE
   40 CONTINUE
C
C---- rationalise symmetry - here we are multiplying real space
C     symmetry ops by orthogonalising and fractionalising matrices...
C
C     arsym(4,4,isym,ixl) = ro(ixl) s(isym,ixl) rf(ixl)
C
C     remember s(j)**(-1) will equal some s(i) -
C     they form a symmetry GROUP!
C
C---- information pointed out by Ian Tickle...
C
      DO 120 IXL = 1,2
        IF (JSYM(IXL).NE.1) THEN
          DO 60 IR = 1,3
            DO 50 JR = 1,3
              AJNKS2(JR,IR) = RFCRYS(JR,IR,IXL)
              AJUNKO(JR,IR) = ROCRYS(JR,IR,IXL)
   50       CONTINUE
   60     CONTINUE
C
          DO 110 ISYM1 = 2,JSYM(IXL)
            DO 80 I = 1,3
              DO 70 J = 1,3
                AJNKS1(I,J) = RSYM(I,J,ISYM1,IXL)
   70         CONTINUE
   80       CONTINUE
C
C                ****************************
            CALL MATMUL(AJUNK4,AJNKS1,AJNKS2)
            CALL MATMUL(AJNKS1,AJUNKO,AJUNK4)
C                ****************************
C
            DO 100 I = 1,3
              DO 90 J = 1,3
                ARSYM(I,J,ISYM1,IXL) = AJNKS1(I,J)
   90         CONTINUE
  100       CONTINUE
  110     CONTINUE
        END IF
  120 CONTINUE
C
      END
