C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
************************************************************************
*
*
*       RSPSDEF.INC for rsps04.
*       Default values for user defniable parameters.
*
*       October 31 1995 S. Knight
*       Modified for version 4.0 (df_mode --> df_vecset)
*       November 6 1991 S. Knight
************************************************************************
*       Title for scoremap
        character*80    df_titut
        parameter       ( df_titut = 'Real Space Patterson Search Map' )

*       Patterson map format
        character*8     df_pattyp
        parameter       ( df_pattyp = 'CCP4' )

*       Vectorset switch
        character*20    df_vecset
        parameter       ( df_vecset = 'SINGLE ATOMS' )

*       Patterson map scale
        real            df_patscl1
        real            df_patscl2
        parameter       ( df_patscl1 = 1.0 )
        parameter       ( df_patscl2 = 0.0 )

*       Origin reset radius and level
        real            df_origin , df_origin_reset
        parameter       ( df_origin = 0.0 )
        parameter       ( df_origin_reset = 0.0 )

*       Sectioning of output map
        integer         df_scraxo( 3 )
        data            df_scraxo / 2 , 1 , 3 /

*       Rejection level in standard deviations
        real            df_rej
        logical         df_sigrej
        parameter       ( df_rej = 1.0 )
        parameter       ( df_sigrej = .true. )

*       Number of grid points added on each side of vector when
*       looking for peak max
        integer         df_pektol
        parameter       ( df_pektol = 0 )

*       Maximum number of low peaks
        integer         df_maxlow
        parameter       ( df_maxlow = 0 )

*       Minimum distance between heavy atom/molecule positions 
        real            df_bump
        real            df_molbmp
        parameter       ( df_bump = 3.5 )
        parameter       ( df_molbmp = 20.0 )

*       Scoring function
        integer         df_scrtyp
        integer         df_nuse
        logical         df_minfun
        parameter       ( df_scrtyp = 1 )
        parameter       ( df_nuse = 1 )
        parameter       ( df_minfun = .false. )


*       Printing level
        integer         df_iprt          
        parameter       ( df_iprt = 1 )

*       Special positions switch
        logical         df_spec
        parameter       ( df_spec = .false. )

*       Peak weighting switch
        logical         df_usemult               
        parameter       ( df_usemult = .false. )

*       Number of peaks to pick
        integer         df_npick         
        parameter       ( df_npick = 50 )

*       Pick level (if 0 level is set internally)
        real            df_pick_level            
        parameter       ( df_pick_level = 0.0 )

*       Minimum number of positions/getset set
        integer         df_minset 
        parameter       ( df_minset = 3 )

*       Truncate flag and level
        integer         df_dotrnc
        real            df_dens_max      
        parameter       ( df_dotrnc = 0 )
        parameter       ( df_dens_max = 0. )

*       Orthogonalization code
        integer         df_ortcod
        parameter       ( df_ortcod = 1 )
************************************************************************
