C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
************************************************************************
*
*
*       RSPSDIM.INC for rsps04
*       Dimensioning parameters.
*
*       June 31 1991 SDK
************************************************************************
        integer         mxpatp
        integer         mxfast
        integer         mxslow
        integer         mxisct
        integer         mxosct
        integer         mxpick
        integer         mxpik1
        integer         mxgmem
        integer         mxgset
        integer         mxsgs 
        integer         mxncs 
        integer         mxsym 
        integer         mxvec 
        integer         mxipsn
        integer         mxtpsn
        integer         mxexcl
        integer         mxreset
*
*       MXPATP          maximum number of points in patterson map
*       MXFAST          max layout along fast axis in scoremap section
*       MXSLOW          max layout along slow axis in scoremap section
*       MXISCT          max number of pps in input map
*       MXOSCT          max number of pps in output map
        parameter       ( mxpatp  = 2000000 )
        parameter       ( mxfast  = 400    )
        parameter       ( mxslow  = 400    )
        parameter       ( mxisct  = mxfast*mxslow )    
        parameter       ( mxosct  = mxfast*mxslow )

*
*       MXPICK          maximum number of peaks for pick and getsets
*       MXPIK1          max number of peaks in pick1
        parameter       ( mxpick  = 400    )
        parameter       ( mxpik1  = 20000  )
*
*       MXGMEM          maximum number of members of a getsets set
*       MXGSET          maximum number of getsets sets
        parameter       ( mxgmem  = 20     )
        parameter       ( mxgset  = 50     )
*
*       MXSGS           max number of space group symmetry (sgs)
*                       operations
*       MXNCS           max number of noncrystallographic symmetry (ncs)
*                       operations
*       MXSYM           max total number symmetry operations (generated
*                       by combination of sgs and ncs)
*       MXVEC           max number of harker or cross vectors
        parameter       ( mxsgs   = 48     )
        parameter       ( mxncs   = 60     )
        parameter       ( mxsym   = 180    )
        parameter       ( mxvec   = 240    )
*
*       MXIPSN          maximum number of vlist or fixed positions 
*       MXTPSN          maximum total number of such positions after
*                       apllication of symmetry
        parameter       ( mxipsn  = 30     )
        parameter       ( mxtpsn  = mxsym * mxipsn )
*
*       MXEXCL          max number of exclude regions
        parameter       ( mxexcl  = 30 )
*
*       MXRESET         max number of peaks that may be reset
        parameter       ( mxreset = 10 )

************************************************************************








