C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
************************************************************************
*
*
*       RSPSMAP.INC
*       RSPS04 (patterson) map related stuff.
*
*       History:
*       Included scoremap statistics August 17 1993 SDK
*       Created July 8 1991 SDK
************************************************************************
*       PATMAP          patterson map values
*       PATMIN          minimum value of patterson map
*       PATMAX          maximum value of patterson map
*       PATAVE          average value of patterson map
*       PATSIG          standard deviation of patterson map
*       PATFAS          number of points in fast direction of P'son
*       PATSLO          number of points in slow direction of P'son
*       PATSEC          number of sections in P'son
*       PATTOT          total number of points in P'son
*       PPNUM           number of stored P'son peaks
*       PPUVW           coordinates of stored P'son peaks
*       PPVAL           peak values of stored P'son peaks
*       PPTYP           Patterson peak type (1 = Harker, 2 = non Harker)
*       SCOMIN          minimum value of scoremap
*       SCOMAX          maximum value of scoremap
*       SCOAVE          average value of scoremap
*       SCOSIG          standard deviation of scoremap
        real            patmap( mxpatp )
        real            patmin , patmax , patave , patsig
        integer         patfas , patslo , patsec , pattot
        integer         ppnum
        integer         pptyp( mxpick )
        real            ppuvw( 3,mxpick ) , ppval( mxpick )
        real            scomin , scomax , scoave , scosig

        common          / patson / 
     &                  patmap ,
     &                  patmin , patmax , patave , patsig ,
     &                  patfas , patslo , patsec , pattot ,
     &                  ppnum ,  ppuvw ,  ppval ,  pptyp ,
     &                  scomin , scomax , scoave , scosig
************************************************************************



