C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
************************************************************************
*
*
*       RSPSPOS.INC
*       RSPS position coordinates for rsps04.
*
*       October 31 1991 SDK
************************************************************************
*       Positions from pick or read, position pointers and counts
*       XPICK           coordinates and site number
*       VALUE           scores
*       XINTOT          number of stored positions
*       SITBEG          pointer from site number to first position
*       SITEND          pointer from site number to final position
*       SITPNT          pointer from position nr to site nr
*       SITTOT          number of stored sites
*       NTRNPS          number of positions in translate array
*       XSCAN           translate array
        integer         xintot
        integer         sitbeg( mxpick ) , sitend( mxpick )
        integer         sitpnt( mxpick )
        integer         sittot
        integer         ntrnps
        real            xpick( 3,mxpick ) , value( mxpick )
        real            xscan( 3,mxpick )
        common/ xyz /   xintot , sitbeg , sitend , sitpnt , sittot ,
     &                  ntrnps , xpick , value , xscan


*       Getset sets
*       NPGUSE          number of positions to use in getsets
*       SETTOT          number of getsets sets stored
*       SETSCR          overall score for sets
*       SETPOS          pointers to position nr of members
*       SETSIZ          number of set members
        integer         npguse 
        integer         settot
        integer         setpos( mxgmem,mxgset )
        integer         setsiz( mxgset )
        real            setscr( mxgset )
        common/ sets /  npguse , settot , setsiz , setpos , setscr


*       Positions for vlist
        real            xyz1( 3,mxipsn )
        integer         nxyz1
        common/ vlpsn / xyz1 , nxyz1


*       Positions for more (cross) scan (fixed positions)
        real            xyz2( 3,mxipsn )
        integer         nxyz2
        common/ crpsn / xyz2 , nxyz2
************************************************************************


