C
C     RWCONTENTS
C     Copyright (C) 1992 Eleanor Dodson
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
      PROGRAM RWCONTENTS
C   This program reads a pdb file and returns an approximate molecular weight.
C Atomno = arom id*2
C
      IMPLICIT NONE
      integer mres
      parameter(mres=27)
C
      REAL ATNO(101),B(6),BISO,CELL(6),RSYM(4,4,96)
      REAL WWW,WMOLW,WMOLWW,ATMSP,ATMS,ATNOHP,ATNOHW,WSIG,WSIGW,
     +     WFSIG,WFSIGW
      REAL X,Y,Z,VOL,OCC,PER1,CMATH,RO1,RO2,RO3,RESO,FHOH,SEFHOH
      INTEGER I,JJ,HYDRO(mres),IHYDRO,NSYM,NSYMP,NMOL,NRES
      INTEGER IFAIL,IXYZIN,LSPGRP,IST,ISER,IZ,JRESN,NHOH,NSEHOH,NSE26
      CHARACTER*4 ATNAM,RESNO,RESNAM,ACID(mres),SEGID,ID,CTEMP
      CHARACTER*1 INSCOD,ALTCOD,CHNNAM,ACID1(mres)
      CHARACTER SPGRP*10, NAMPG*10,IATM(101)*2,NAMSPG_CIFS*20
      LOGICAL LHOHESTIMATE

C     things for parser ----
      integer maxtok
      parameter (maxtok=100)
      character key*4,cvalue(maxtok)*4,line*256
      integer ibeg(maxtok),iend(maxtok),ityp(maxtok),
     .   idec(maxtok),ntok,lflag
      real    fvalue(maxtok)
      logical lend

      EXTERNAL XYZADVANCE,XYZATOM,XYZCOORD,XYZINIT,
     +         XYZOPEN,XYZCLOSE

      DATA ACID/'ALA ','ARG ','ASN ','ABA ','ASP ','CYS ','CSH ','GLN ',
     +          'GLU ','GLY ','HIS ','ILE ','LEU ','LYS ','MET ','MSE ',
     +          'ORN ','PHE ','PRO ','SER ','THR ','TRP ','TYR ','VAL ',
     +          'HEM ','HOH ','SO4 '/

      DATA ACID1/'A','R','N','N','D','C','C','Q',
     1 'E','G','H','I','L','K','M','M',
     1 'O','F','P','S','T','W','Y','V',' ',' ',' '/

      DATA HYDRO/ 5,13, 6, 7, 4, 4, 5, 8,
     +            6, 3, 8,11,11,13, 9, 9,
     +           10, 9, 7, 5, 7,10, 9, 9,
     +           30, 2, 0/
C
C
      DATA IATM/' H','HE','LI','BE',' B',' C',' N',' O',' F','NE',
     *          'NA','MG','AL','SI',' P',' S','CL','AR',' K','CA',
     *          'SC','TI',' V','CR','MN','FE','CO','NI','CU','ZN',
     *          'GA','GE','AS','SE','BR','KR','RB','SR',' Y','ZR',
     *          'NB','MO','TC','RU','RH','PD','AG','CD','IN','SN',
     *          'SB','TE',' I','XE','CS','BA','LA','CE','PR','ND',
     *          'PM','SM','EU','GD','TB','DY','HO','ER','TM','YB',
     *          'LU','HF','TA',' W','RE','OS','IR','PT','AU','HG',
     *          'TL','PB','BI','PO','AT','RN','FR','RA','AC','TH',
     *          'PA',' U','NP','PU','AM','CM','BK','CF','ES','FM',
     *          'AN'/
C
      CALL CCPFYP
      CALL CCPRCS (6, 'RWCONTENTS', '$Date: 2005/09/06 11:25:24 $')
      CALL XYZINIT
         LSPGRP = 0
         SPGRP =' '
         NAMSPG_CIFS =' '
         NAMPG = ' '
C
C---- Number of H atoms at PH 6.0 to 7.0
C Assumed to be in polypeptides, i.e. have taken into account
C peptide bond formation.  Will be a bit off at the NT; a bit
C off if there are disulfides; etc, etc.
C

      DO 2 I=1,101
        ATNO(I)=0
2     CONTINUE
      WMOLWW = 0
      WMOLW = 0
      WSIGW = 0
      WSIG = 0
      WFSIGW = 0
      WFSIG = 0
      ATMSP = 0
      ATMS = 0
      ATNOHP = 0
      ATNOHW = 0
      IHYDRO = 0
      NRES=0
      IFAIL = 0
      IXYZIN = 0
      LSPGRP = 0
      IST = 0

C  Defaults for NHOH keyword.
      LHOHESTIMATE = .FALSE.
      RESO = 0.0
      CTEMP = 'ROOM'

C  Read keyworded input

      WRITE(6,'(/,A,/,A,/,A,/)') 
     +    ' RWCONTENTS now takes keyworded input.',
     +    ' Type END of <EOF> to get default output.',
     +    ' See documentation for available keywords.'

 100  line=' '
      ntok=maxtok
      call parser(
     .   key,line,ibeg,iend,ityp,fvalue,cvalue,idec,ntok,lend,.true.)
      if(lend) go to 200
      if(ntok.eq.0) go to 100
      CALL CCPUPC(KEY)

      if (key .eq. 'END') then
         go to 200

      elseif (key .eq. 'NHOH') then
         IF (NTOK.GE.2) THEN
           LHOHESTIMATE = .TRUE.
           call gttrea(2,RESO,lflag,ntok,ityp,fvalue)
         ELSE
           CALL CCPERR(2,'Resolution required for NHOH keyword.')
           GOTO 100
         ENDIF
         IF (NTOK.GE.3) THEN
           CTEMP = CVALUE(3)
           CALL CCPUPC(CTEMP)
           IF (CTEMP.NE.'ROOM'.AND.CTEMP.NE.'LOWT') THEN
             CALL CCPERR(2,'Incorrect subkeyword for NHOH keyword.')
             CTEMP = 'ROOM'
             GOTO 100
           ENDIF
         ENDIF

      ENDIF
      GOTO 100

 200  CONTINUE

      call XYZOPEN('XYZIN','INPUT',' ',IXYZIN,ifail)
      CALL RBCELL(CELL,VOL)
C  Get symmetry information
      CALL RBSPGRP(SPGRP)
        write(6,'(A,3x,A)')' Spacegroup',spgrp
C
      IF(SPGRP.EQ.' ') THEN
         NSYM = -1
         SPGRP = 'P1'
       ELSE
C         CALL MSYMLB(IST,LSPGRP,SPGRP,NAMPG,NSYMP,NSYM,RSYM)
         CALL MSYMLB3(IST,LSPGRP,SPGRP,NAMSPG_CIFS,
     +                   NAMPG,NSYMP,NSYM,RSym)
         write(6,'(a,i4,3(A10,3x),2i5)')
     +        ' in rw',LSPGRP,SPGRP,NAMSPG_CIFS,
     +        NAMPG,NSYMP,NSYM
C
       END IF

C Loop over ATOM/HETA records
 1    CONTINUE
      CALL XYZADVANCE(IXYZIN,0,0,*9990,*99)
      CALL XYZATOM(IXYZIN,ISER,ATNAM,RESNAM,CHNNAM,JRESN,RESNO,
     +         INSCOD,ALTCOD,SEGID,IZ,ID)
      CALL XYZCOORD(IXYZIN,'O','U',X,Y,Z,OCC,BISO,B)
C
c Skip ANISOU cards
      if (b(2).ne.0.0 .or. b(3).ne.0.0) then
        if (x.eq.0.0 .and. y.eq.0.0 .and. z.eq.0.0) goto 1
      endif
C   Dont count hydrogens
      IF (IZ.LE.1) GO TO 1
C   Grand totals:
      ATMS = ATMS + OCC
      WSIG = WSIG +(IZ*OCC)**2
      WFSIG = WFSIG +(IZ*OCC)
      WMOLW = WMOLW +2*IZ*OCC
      IF (RESNAM.EQ.'WAT '.OR.RESNAM.EQ.'HOH ')  THEN
         WSIGW  = WSIGW  +(IZ*OCC)**2
         WFSIGW  = WFSIGW  +IZ*OCC
         WMOLW  = WMOLW  +2*OCC
         ATMS = ATMS + 2*OCC
c
         WMOLWW = WMOLWW +18*OCC
         ATNOHW =HYDRO(26)*OCC +ATNOHW
         IZ = 101
      END IF 
      ATNO(IZ) = ATNO(IZ) + OCC
C
C---- Find no. of Hydrogens - check CA only Hem(25) HOH(26) and SO4 done seperately
C
      IF (RESNAM.EQ.'SUL')RESNAM = 'SO4'
      IF (RESNAM.EQ.'HEM'.AND.ATNAM(1:2).EQ.'FE') 
     +    ATNOHP=ATNOHP+HYDRO(25)
C Count atoms and residues (protein only)
      DO 10 JJ=1,mres-3
        IF ( RESNAM.EQ.ACID(JJ)) THEN
          ATMSP=ATMSP+OCC
          IF (ATNAM.EQ.'CA') THEN
            WRITE(*,*) 
     +           'Matched ',RESNAM,' ',ATNAM,' #H = ',HYDRO(JJ)
             NRES=NRES+1
C  Add expected attributes of Hydrogens to everything
             ATNOHP =HYDRO(JJ)+ATNOHP
             WMOLW = WMOLW +HYDRO(JJ)
             ATMS  = ATMS  + HYDRO(JJ)
             ATMSP = ATMSP + HYDRO(JJ)
             GO TO 11
           ENDIF
        ENDIF
 10   CONTINUE
 11   CONTINUE
      GO TO 1
C
99    CONTINUE

      call XYZCLOSE(IXYZIN)
C
      WRITE(6,'(//,A,I6)')
     $     ' Number of amino-acids residues = ',NRES
      IF (ATNOHP.GT.0)  WRITE(6,'(/,2A,F10.0,/,A)')
     + ' A rough estimate of the  theoretical number of Hydrogens',
     + ' for the protein is', ATNOHP,
     + ' (including Haems).'
      IF (ATNOHW.GT.0)  WRITE(6,'(/,2A,F10.0,/,A)')
     + ' A rough estimate of the  theoretical number of Hydrogens',
     + ' for the waters is', ATNOHW
      WRITE(6,'(//,A,/,A,/)')
     $  ' Number of atoms of each type in PDB file (except hydrogens).',
     $  ' (Partial occupancies are taken into account.)'
      DO 98 I = 1,100
        IF (ATNO(I).EQ.0.0) GO TO 98
        WRITE(6,'(A,3X,I5,3X,A,F10.2,3X,A)')
     +          ' Atom number and type - number of atoms ',
     +        I,IATM(I),ATNO(I)
98    CONTINUE
      WRITE(6,'(22X,A,F9.2,/)')'- number of waters              ',
     +      ATNO(101)

      WRITE(6,'(2(/,A,F10.2))')
     + ' Total number of protein atoms (including hydrogens)',ATMSP,
     + ' Total number of         atoms (including hydrogens)',ATMS

C  If NHOH keyword given, estimate the number of water
C  molecules expected to be determined by PX using the statistical 
C  analysis of Carugo & Bordo
      IF (LHOHESTIMATE) THEN
        CALL NUM_EXPECTED_WATERS(RESO,CTEMP,FHOH,SEFHOH)
        NHOH = NINT(FHOH*(ATMSP - ATNOHP))
        NSEHOH = NINT(SEFHOH*(ATMSP - ATNOHP))
        NSE26 = NINT(2.6*SEFHOH*(ATMSP - ATNOHP))

        WRITE(6,'(/,A,/,A)') 
     + ' ESTIMATION OF THE NUMBER OF WATER MOLECULES THAT CAN ',
     + ' BE DETERMINED BY PX (CARUGO AND BORDO)'

        WRITE(6,'(/,A,F9.1)')
     +    ' Total number of protein atoms (excluding H) = ',
     +   ATMSP - ATNOHP
        WRITE(6,'(A,I7)')
     +    ' Expected number of crystallographic waters  = ',
     +    NHOH
        WRITE(6,'(A,I7)')
     +    ' Associated standard error of this estimate  = ',
     +    NSEHOH
        WRITE(6,'(A,I7,A,I7)')
     +    ' Expected range at 99% confidence level:       ',
     +    NHOH - NSE26,'  to ',NHOH + NSE26
        WRITE(6,'(A,F9.1)')
     +    ' Actual number of waters in model            = ',
     +    ATNO(101)
      ENDIF
      WRITE(6,'(/,A,37X,f15.3)')' Cell volume:', VOL
      WWW =  WMOLW-WMOLWW
      WRITE(6,'(/,A,18X,f15.3)')' Molecular Weight of protein:   ', 
     +                            WWW
      WRITE(6,'(/,A,16X,f15.3)')' Molecular Weight of all atoms:   ', 
     +                            WMOLW
      WRITE(6,'(/,2A,4X,f15.3)')' I000 - SIGMA - Sum(fi_squared) ',
     +                          ' Protein only:', WSIG-WSIGW
      WRITE(6,'(/,2A,7X,f15.3)')' I000 - SIGMA - Sum(fi_squared) ',
     +                          ' All Atoms:', WSIG
      WRITE(6,'(/,2A,4X,f15.3)')' F000  - Sum(fi) ',
     +                          ' Protein only:', WFSIG-WFSIGW
      WRITE(6,'(/,2A,7X,f15.3)')' F000 - Sum(fi) ',
     +                          ' All Atoms:', WFSIG
C
C      Taken from mathews_coef code
      NMOL = 1
C
      IF(NSYM .LT. 0) WRITE(6,'(A,/,A)')
     + ' *** Warning - Space group not given in coordinate file - ***',
     + '               Matthews  coefficient should be divided by NSYM',
     + '               Solvent % etc unreliable'
      CMATH=VOL/(WWW*NMOL*ABS(NSYM))
      RO1=WWW*NMOL*ABS(NSYM)/(0.602*VOL)
      RO2=( VOL - 10*ATMSP*ABS(NSYM)) *100.0 / VOL
      RO3=( VOL - 10*ATMS*ABS(NSYM)) *100.0 / VOL

      PER1=(1-RO1/1.34)*100.0
      WRITE(6,'(//,A,26X,F8.2)') ' The Matthews Coefficient is :',CMATH
      WRITE(6,'(A,F12.2)') 
     + ' Assuming protein density is 1.34, the solvent % is:',PER1

      WRITE(6,'(A,F11.2)') 
     + ' If atom volume ~ 10,  % of cell without protein is: ',RO2

      WRITE(6,'(A,F14.2)') 
     + ' If atom volume ~ 10,  % of cell without atoms is:',RO3


      call ccperr(0,'Normal termination')
9990  call ccperr(1, 'Failure reading XYZIN')
      END
