C
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C

c maxref = maximum number of reflections
c maxcol = maximum number of data columns (excluding h k l and resolution)
c maxdat = upper limit to (nr. of columns) * (nr. of reflections)
      integer maxref,maxcol,maxdat
      parameter (maxref=1000000, maxcol=200, maxdat=8000000)

c map parameters. maxa, maxb & maxc are the maximum number of grid points
c along the a, b and c axes. maxw must be >= max( maxa, maxb, maxc)
      integer maxa, maxb, maxc, maxw
      parameter (maxa=350, maxb=350, maxc=350, maxw=350)

c maxfil = maximum number of files that may be read
c maxshl = maximum number of resolution shells in tables
      integer maxfil,maxshl
      parameter (maxfil=10, maxshl=100)

c structure factor related data
      character info(31)*80,label(maxcol)*80,type(maxcol)*1
      character spgrnam*10,pgrnam*10,centr*1
      integer ihkl(maxref),isort(5),ncol,nsym,nprim
      integer klass,nspgrp,nref
      real ref(maxdat),cell(6),symop(4,4,96)
      logical active(maxref)
c variables related to MTZ batch and dataset information
      integer maxbat,maxsets
      parameter (maxbat=5000,maxsets=200)
      integer numbat(maxbat),nbatno, nbatch, ndatasets
      character cbatch(94,maxbat)*1,pname(maxsets)*64,
     $            xname(maxsets)*64,dname(maxsets)*64,
     $            colxname(maxcol)*64,coldname(maxcol)*64
      real rbatch(185,maxbat),dcell(6,maxsets),dwavel(maxsets)
c sfn contains Numerical variables and logicals
      common /sfn/ihkl,isort,ncol,nsym,nprim,klass,nspgrp,nref,
     $            ref,cell,symop,nbatch,numbat,nbatno,
     $            rbatch,active,ndatasets,dcell,dwavel
c sfc contains Character variables
      common /sfc/info,label,type,spgrnam,pgrnam,centr,cbatch,
     $            pname,xname,dname,colxname,coldname

c map related data
      integer mapori, ori000(3), ngrd(3), ndiv(3)
      real grdsiz(3)
      character maptitl*80
      common /mappar/ mapori, ori000, ngrd, ndiv, grdsiz,
     $  maptitl

c useful constants
      real toostrong, tooweak, mnf
      real cyc2rad, rad2cyc, deg2rad, rad2deg, pi, twopi
      real a11, a21, a31, a22, a32, a33
      logical absent, present, error
      logical changed, interactive, noheader
      common /const/toostrong, tooweak, mnf,
     $              cyc2rad, rad2cyc, deg2rad, rad2deg, pi, twopi,
     $              a11, a21, a31, a22, a32, a33,
     $              absent, present, error,
     $              changed, interactive, noheader
