/*

     This code is distributed under the terms and conditions of the
     CCP4 Program Suite Licence Agreement as a CCP4 Application.
     A copy of the CCP4 licence can be obtained by writing to the
     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
*/
#if defined (PROTOTYPE)

MASK *ReadOMask(char *filename);
/* Reads header of an O-style to determine format type. */

MASK *ReadCCP4Mask(char *maskname);
/* Read a CCP4 mask as 'maskname'. */

void Compressed(MASK *mask, FILE *file);
/* Read compressed data from O-style mask */

void Uncompressed(MASK *mask, FILE *file);
/* Read uncompressed data from O-style mask */

void WriteOMask(MASK *mask);
/* Writes a mask to disk as an O-type mask-file. */

void WriteNewOMask(MASK *mask);
/* Writes new style mask with compressed data */

void WriteCCP4Mask(MASK *mask);
/* Writes 'mask' as CCP4 mask 'maskname'. */

#else

MASK *ReadOMask();
/* Reads header of an O-style to determine format type. */

MASK *ReadCCP4Mask();
/* Read a CCP4 mask as 'maskname'. */

void Compressed();
/* Read compressed data from O-style mask */

void Uncompressed();
/* Read uncompressed data from O-style mask */

void WriteOMask();
/* Writes a mask to disk as an O-type mask-file. */

void WriteNewOMask();
/* Writes new style mask with compressed data */

void WriteCCP4Mask();
/* Writes 'mask' as CCP4 mask 'maskname'. */

#endif
