/*

     This code is distributed under the terms and conditions of the
     CCP4 Program Suite Licence Agreement as a CCP4 Application.
     A copy of the CCP4 licence can be obtained by writing to the
     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
*/
#if defined (PROTOTYPE)
float **invert_matrix(float **a, int n);
/* Returns a pointer to the inverse of matrix 'a[1..n][1..n]'. When the 
   inversed matrix is not used anymore, its location should be freed with
   free_matrix(inv, 1, n, 1, n). */

float **matrix(int nrl, int nrh, int ncl, int nch);
/* Returns a pointer to a matrix which has valid indices ranging from 
   [nrl..nrh][ncl..nch]. */

void free_matrix(float **m, int nrl, int nrh, int ncl, int nch);
/* Frees a matrix generated by "matrix". */
#else
float **invert_matrix();
float **matrix();
void free_matrix();
#endif
