C
C     STEREO
C     Copyright (C) 1979 M. G. Rossmann
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C*************************************************************
C
C
C   The development of the MTZ files and associated software mark 1
C   is part of the masterplan of the ESF/EACBM Working Group 2.1 for
C   better Protein Crystallographic software for Europe.
C
C**************************************************************
C
      program astereo
c
c     Three-dimensional coordinates from stereo diagrams
c     Author: M. G. Rossmann, March 1979
c             Modified by J.B. Dai, b4x@mace.cc.Purdue.edu, August 1994
c             Dept. of Biological Sciences
c             Purdue University
c             West Lafayette, Indiana 47907
c
      common dtr,num,um,konst,coord(350,2,2),xyz(350,3),const(4,100),
     1dkeep(350)
      common /work/ zkeep(350),x(350),y(350),z(350),d(350),
     1filler(13300),crit
      character*80 title
      character*4 resnam (350), atnam (350)
      character id*4, chnnam*1, segid*4, resno*4, altcod*1, inscod*1
      integer resnum (350), IXYZOUT, iz, nreals
      logical flag
      integer ibeg (8), iend (8), ityp (8), idec (8), ntok
      logical ok
      character line*200
      character*4 cvalue (8)
      real bb (6), fvalue (8)
      integer ccpnun
      logical qisnan
      external ccpnun,qisnan
      data viewset /10.0/, title /' '/, fiset /0.0/, resnam/350*'ZZZ'/,
     +     atnam/350*'ZZ'/,resnum /350*1/
c -----
C     in lieu of block data:
      id = ' '
      chnnam = ' '
      resno = ' '
      altcod = ' '
      inscod = ' '
      segid = ' ' 
      iz = 0
      biso = 0.0
      crit = 1.5
      konst = 1
      do 2 j=1,4
        do 1 i=1,100
          call qnan(const (j,i))
 1      continue
 2    continue
      do 20 i=1,6
        bb(i) = 0.0
 20   continue

      call ccpfyp
      call ccprcs (6, 'STEREO', '$Date: 2008/05/06 09:47:41 $')
      call XYZINIT
      IFAIL = 0
      IXYZOUT = 0
      call XYZOPEN('XYZOUT','OUTPUT',' ',IXYZOUT,IFAIL)
C
      write (6,3)
    3 format ('1',/,
     *   ' *********************************************************',/,
     *   ' * Obtaining Coordinates from Stereo Diagrams'/
     *   ' * Author : M.G. Rossmann ',/,
     *   ' *          Modified by J.B. Dai, b4x@mace.cc.purdue.edu'/
     *   ' *********************************************************'/)
c
      pi=4.0*atan2(1.0,1.0)
      dtr=pi/180.0
 5    call memoparse (.true.)
      call parsekeyarg ('TITL', title)
      call parsereal ('PHI', fiset)
      call parsereal ('VIEW', viewset)
      call parsereal ('CRIT', crit)
      nreals = 4
      call parsenreals ('CONS', nreals, const (1,konst))
      flag = qisnan(const(1,konst))
      if (.not.flag) then
        konst = konst + 1
        if (konst.gt.100) call ccperr (1, 'Too many CONSTRAINTs')
      endif
      call parsediagnose (flag)
      if (flag) go to 5
c
c---- End of Input
c
      konst = konst - 1
      write (6, '(/,'' Title: '', A,/)') title
      do 26 k=1,konst
      if(const(2,k).eq.0.0) call helix(k)
 26   continue
      mt = 0
      call ccpdpn (mt, 'XYZIN', 'READONLY', 'F', 0, IFAIL)
 98   format(19x,'left',16x,'right'/,5x,2(9x,'x',9x,'y'))
      do 10 i=1,351
        read (mt, fmt='(a200)', end=11) line
        ntok = -8
        call parse(line,ibeg,iend,ityp,fvalue,cvalue,idec,ntok)
        if (i.gt.350) call ccperr (1, 'Too many input coordinates')
        ok = ntok.ge.4 .and. ntok.le.7
        do 6 j=1,4
          ok = ok .and. ityp (j).eq.2
 6      continue
        if (ntok.gt.4) atnam (i) = cvalue (5)
        if (ntok.gt.5) resnam (i) = cvalue (6)
        if (ntok.gt.6) then
          ok = ok .and. ityp(7).eq.2 .and.
     +         idec(7).eq.(iend(7)-ibeg(7)+1)
          resnum (i) = nint (fvalue (7))
        end if
        if (.not.ok) then
          write (6,'(1X,A79)') line
          call ccperr (1, 'Bad input coordinate line (as above)')
        end if
        coord(i,1,1) = fvalue(1)
        coord(i,1,2) = fvalue(2)
        coord(i,2,1) = fvalue(3)
        coord(i,2,2) = fvalue(4)
        write(6,97) i,((coord(i,k,j),j=1,2),k=1,2)
 97     format(1x,i4,4f10.2,5x,f10.2)
 10   continue
 11   num=i-1
      if (num.lt.1) call ccperr (1, 'No coordinates input')
      um=num
      do 50 n=1,2
      rs=0.0
      rr=0.0
      ss=0.0
      do 51 i=1,num
      ds=coord(i,1,1)-coord(i,2,1)
      dr=coord(i,1,2)-coord(i,2,2)
      rs=rs+dr*ds
      rr=rr+dr*dr
      ss=ss+ds*ds
 51   continue
      b=2.0*rs
      a=ss-rr
      psi=atan2(b,a)
      psi=-psi/2.0
      degpsi=psi/dtr
      r=sqrt(rr/um)
      s=sqrt(ss/um)
      write(6,52) r,s,degpsi
 52   format(///,' rms dy',f8.1,', rms dx',f8.1,', psi',f8.1,/)
      cp=cos(psi)
      sp=sin(psi)
      do 53 i=1,num
      do 54 k=1,2
      r=coord(i,k,1)*sp+coord(i,k,2)*cp
      s=coord(i,k,1)*cp-coord(i,k,2)*sp
      coord(i,k,1)=s
      coord(i,k,2)=r
 54   continue
 53   continue
 50   continue
      if(konst.ne.0) go to 37
      const(1,1)=1.0
      const(2,1)=2.0
      const(3,1)=um-1.0
      const(4,1)=3.84
      konst=1
 37   write(6,87) ((const(j,k),j=1,4),k=1,konst)
 87   format(1x,3f5.0,f6.2,//)
      sxl=0.0
      syl=0.0
      sxr=0.0
      syr=0.0
      do 13 i=1,num
      sxl=sxl+coord(i,1,1)
      syl=syl+coord(i,1,2)
      sxr=sxr+coord(i,2,1)
      syr=syr+coord(i,2,2)
 13   continue
      sxl=sxl/um
      syl=syl/um
      sxr=sxr/um
      syr=syr/um
      xerr=0.0
      yerr=0.0
      write(6,98)
      do 14 i=1,num
      coord(i,1,1)=coord(i,1,1)-sxl
      coord(i,1,2)=coord(i,1,2)-syl
      coord(i,2,1)=coord(i,2,1)-sxr
      coord(i,2,2)=coord(i,2,2)-syr
      del=coord(i,1,1)-coord(i,2,1)
      write(6,97) i, ((coord(i,k,j),j=1,2),k=1,2),del
      xerr=xerr+del**2
      yerr=yerr+(coord(i,1,2)-coord(i,2,2))**2
 14   continue
      xerr=sqrt(xerr/um)
      yerr=sqrt(yerr/um)
      write(6,89) xerr,yerr
 89   format('0 rms x,y',2f10.2)
      dxsq=0.0
      dysq=0.0
      dzsq=0.0
      do 30 i=2,num
      j=i-1
      dxsq=dxsq+(coord(j,1,1)-coord(i,1,1))**2
      dysq=dysq+(coord(j,1,2)-coord(i,1,2))**2
      delj=coord(j,1,1)-coord(j,2,1)
      deli=coord(i,1,1)-coord(i,2,1)
      dzsq=dzsq+(delj-deli)**2
 30   continue
      dsq=(dxsq+dysq)/2.0
      fieq=0.5*asin(sqrt(dzsq/dsq))/dtr
      write(6,90) fieq
 90   format(' fi based on equivalencing dxsq,dysq,dzsq',f10.2)
      write(6,85)
 85   format(///,' set up reasonable scale factor to permit'
     # ,' elimination of gross errors')
      rmsmin=0.0
      dist=0.0
      do 39 i=1,10
      call central(3.0,50.0,dist,rmsmin,fimin,vmin)
 39   continue
      fi=1.0
      do 15 k=1,20
      write(6,92)
 92   format(///,6x,'fi',6x,'v   drms(a.)')
      fi=fi+0.25
      v=-50.0
      do 22 l=1,20
      v=v+5.0
      if(v.eq.0.0) go to 22
      dist=-1.0
      call central(fi,v,dist,rmsmin,fimin,vmin)
 22   continue
 15   continue
      if(fiset) 31,23,32
 31   fi=fieq
      go to 33
 32   fi=fiset
 33   v=viewset
      rmsmin=0.0
      go to 34
 23   fi=fimin
      v=vmin
 34   rmsmin=0.0
      cay=-1.0
      call central(fi,v,cay,rmsmin,fimin,vmin)
      yerr=yerr*cay
      rmsmin=rmsmin*cay
      write(6,94) fimin,v,yerr
 94   format(' fimin',f7.3,', viewing dist(inch)',f6.1
     # ,', yerr(a.)',f6.2)
      write(6,93)
 93   format(///,'  num',3x,'x(a.)',3x,'y(a.)',3x,'z(a.)',8x,'d(a.)')
      do 27 i=1,num
      do 25 j=1,3
      xyz(i,j)=xyz(i,j)*cay
 25   continue
      zkeep(i)=zkeep(i)*cay
      dkeep(i)=dkeep(i)*cay
 27   continue
      do 29 i=1,num
      write(6,95) i,(xyz(i,j),j=1,3),dkeep(i)
 29   continue
      do 40 k=1,3
      kr=4-k
      do 41 i=1,num
      zkeep(i)=xyz(i,kr)
 41   continue
      do 28 n=1,3
      call refine(kr)
      write(6,86) n,kr
 86   format(////,' after cycle',i2
     # ,' while refining coordinate(',i1,')')
      write(6,93)
      do 21 i=1,num
      write(6,95) i,(xyz(i,j),j=1,3),dkeep(i)
 95   format(1x,i4,3f8.1,5x,f8.1)
C     output PDB record on appropriate loop iteration
      if (k.eq.3 .and. n.eq.3) then
        call XYZATOM(IXYZOUT, i, atnam(i), resnam(i), chnnam, 
     +    resnum(i), resno, inscod, altcod, segid, iz, id)
        call XYZCOORD(IXYZOUT, 'O', 'U', xyz(i,1), xyz(i,2), 
     +    xyz(i,3), 1.0, biso, bb)
        call XYZADVANCE(IXYZOUT, 0, 0, *21, *21)
      endif
 21   continue
 28   continue
 40   continue
      call XYZCLOSE(IXYZOUT)
      close (unit=mt, status='keep')
      call ccperr (0, 'Normal termination')
      end
