C
C     STNET
C     Copyright (C) 1994 Ian Tickle
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
      PROGRAM STENET
C
C#######################################################################
C####
C#### Generation of Stereographic Net.
C####
C#### Ian J. Tickle, Birkbeck, July '94.
C####
C#### Installation & usage instructions.
C####
C#### 1. Compile and link with PLOT84 & CCP4 routines, e.g.:
C####    f77 stenet.f $CLIB/libccp4.a -o stenet
C####
C#### 2. Run the program:
C####    stenet
C####
C#### 3. Convert the output file to PostScript (resetting line width):
C####    pltdev -i PLOT -lnw .2
C####
C#### 4. Print the PostScript file plot84.ps on your laser printer.
C####
C#### 5. Copy the stereographic net onto a transparent sheet.
C####
C#######################################################################
C
      IMPLICIT NONE
      REAL DR,PI
      PARAMETER (PI=3.141592654,DR=PI/180.)
      CHARACTER T*2
      INTEGER IP,IQ,IT,JP,KP
      REAL CP,CQ,SP,SQ,P,Q,R,V(2,2),W(2,2),X1,Y1
      DATA V/.05,.05,.95,.95/
      DATA W/-1.3,-1.3,1.3,1.3/
C
      CALL CCPFYP
C#### Commented out calls are for SIMPLEPLOT.
C      CALL NEWPIC
C      CALL PICSIZ(14.,14.)
C      CALL EQSCAL(-1.,1.,-1.,1.,0)
C      CALL TITLE7('H','C','Stereographic net.')
C
C#### Plot calls for PLOT84 (CCP4).
      CALL PLTINI
      CALL PLTWIN(V,W)
      CALL PLTTNF(-1.12,0.,X1,Y1)
      CALL PLTCTX('+',X1,Y1,.5,3,0.)
      CALL PLTTNF(1.12,0.,X1,Y1)
      CALL PLTCTX('+',X1,Y1,.5,1,0.)
      CALL PLTTNF(0.,-1.24,X1,Y1)
      CALL PLTCTX('Stereographic net.',X1,Y1,1.1,2,0.)
C
      DO 1 IQ=-90,90,2
        Q=DR*IQ
        CQ=COS(Q)
        SQ=SIN(Q)
        IF (MOD(IQ,90).EQ.0) THEN
          JP=0
          KP=180
          IT=2
        ELSEIF (MOD(IQ,10).EQ.0) THEN
          JP=2
          KP=178
          IT=2
        ELSE
          JP=10
          KP=170
          IT=1
        ENDIF
        DO 1 IP=JP,KP
          P=DR*IP
          CP=COS(P)
          SP=SIN(P)
          R=1.+SP*CQ
1         CALL MOVETOB(CP/R,SP*SQ/R,IP.GT.JP,IT)
C
      DO 2 IP=2,178,2
        P=DR*IP
        CP=COS(P)
        SP=SIN(P)
        IF (MOD(IP,10).EQ.0) THEN
          IT=2
        ELSE
          IT=1
        ENDIF
        DO 2 IQ=-90,90
          Q=DR*IQ
          CQ=COS(Q)
          SQ=SIN(Q)
          R=1.+SP*CQ
2         CALL MOVETOB(CP/R,SP*SQ/R,IQ.GT.-90,IT)
C
      DO 3 IP=0,350,10
        P=DR*IP
        CALL PLTTNF(1.04*COS(P),1.04*SIN(P),X1,Y1)
        IT=IABS(IABS(IP-180)-90)
        IF (IT.EQ.0) THEN
C          CALL NUMBLB(-.0125,1.04*SIN(P)-.025,0)
          CALL PLTCTX('0',X1,Y1,.5,2,0.)
        ELSE
C          CALL NUMBLB(1.04*COS(P)-.025,1.04*SIN(P)-.025,IT)
          WRITE (T,'(I2)') IT
          CALL PLTCTX(T,X1,Y1,.5,2,0.)
        ENDIF
3     CONTINUE
C
C      CALL ENDPLT
      CALL PLTSTP
      END
C
C
      SUBROUTINE MOVETOB(X,Y,L,N)
      IMPLICIT NONE
      LOGICAL L
      INTEGER I,N
      REAL D,DX,DY,X,Y,X0,Y0,X1,Y1
      SAVE X0,Y0
      DATA X0,Y0 /2*0./
C
      D=(X-X0)**2+(Y-Y0)**2
      IF (D.GT.0.) THEN
        IF (.NOT.L .OR. N.LE.0) THEN
C          CALL BREAK
C          CALL JOINPT(X,Y)
          CALL PLTTNF(X,Y,X1,Y1)
          CALL PLTMOV(X1,Y1)
        ELSEIF (N.EQ.1) THEN
C          CALL JOINPT(X,Y)
          CALL PLTTNF(X,Y,X1,Y1)
          CALL PLTDRW(X1,Y1)
        ELSE
          D=.001*SQRT(1./D)
          DX=-D*(Y-Y0)
          DY=D*(X-X0)
          DO 1 I=1-N,N-1
C            CALL BREAK
C            CALL JOINPT(X0+I*DX,Y0+I*DY)
C1           CALL JOINPT(X+I*DX,Y+I*DY)
            CALL PLTTNF(X0+I*DX,Y0+I*DY,X1,Y1)
            CALL PLTMOV(X1,Y1)
            CALL PLTTNF(X+I*DX,Y+I*DY,X1,Y1)
1           CALL PLTDRW(X1,Y1)
        ENDIF
      ENDIF
      X0=X
      Y0=Y
      END
