C
C     TFFC
C     Copyright (C) 1989 Ian Tickle
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
      PROGRAM TFFC
C     ============
C
C TFFC
C----SPACE GROUP GENERAL TRANSLATION FUNCTION FOURIER COEFFICIENT CALCULATION.
C
C----Modified to remove F000 terms for TO and O functions 18-Jun-89 IJT
C----Modified for partial structure information 6-Jul-89 IJT
C----Modified for MTZ format I/O 10-Sep-91 IJT
C----Modified for keyworded input 10-Oct-91 IJT
C----Merged TFSGEN and TFPART into one program TFFC; added PART keyword.
C    (Some variable names changed to avoid clashes, but functionally identical.)
C    IJT Aug 92.
C----Parameterised maximum no of subunits & increased it from 8 to 14.
C    IJT Jun 98.
C
C    Note that for tri/tetra/hexagonal unique axis must be c,
C    for monoclinic may be a, b or c.
C  Ian Tickle
C
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER NA
      PARAMETER (NA=250000)
C     ..
C     .. Local Arrays ..
      COMPLEX A(NA)
C     ..
      CALL CCPFYP
      CALL CCPRCS(6,'TFFC','$Date: 2005/09/06 11:25:28 $')
      WRITE (6,'(/3(/20X,A)//)')
     &' ##############################################',
     &' # TRANSLATION FUNCTION FOURIER COEFFICIENTS. #',
     &' ##############################################'
      CALL TFMAIN(NA,A)
      CALL CCPERR(0,'**** NORMAL TERMINATION ****')
      END
C
C
      BLOCK DATA TFSBLD
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER MCOLS,MNC
      PARAMETER (MCOLS=500,MNC=14)
C     ..
C     .. Scalars in Common ..
      CHARACTER TI3*70
      LOGICAL LFP,LFS,LSP
      INTEGER ICP,IDP,IU,LG,LIST,MU,NC,NG,NMC,NNC,NS,NW
      REAL AM1,AM2,BM1,BM2,Q1,Q2,SFF1,SFF2,T1,T2
C     ..
C     .. Arrays in Common ..
      CHARACTER TI2*70
      LOGICAL LTEST
      INTEGER IC,IM1,IM2,IPG,IS,ITV,KC,LC
      REAL AI,CELL,D,SFC,SFP,RTS,TV
C     ..
C     .. Common blocks ..
      COMMON /TFCOMC/ TI2(11),TI3
      COMMON /INCOM/ IS(3,3,24),ITV(MNC),
     &       CELL(6),D(3,24),RTS(4,4,96),TV(3,MNC),
     &       ICP,IDP,LFP,LFS,LG,LIST,LSP,NC,NG,NMC,NNC,NS,T1,T2
      COMMON /TFCOM/ LTEST(15,11),IC(15),IM1(3),IM2(3),IPG(24,24),
     &       KC(15),LC(15),AI(MCOLS),SFC(400),SFP(400),
     &       IU,MU,NW,AM1,BM1,AM2,BM2,Q1,Q2,SFF1,SFF2
      SAVE /TFCOMC/
C     ..
C     .. Data statements ..
      DATA TI2(1)/'Produced by polar (2) translation function'/
      DATA TI2(2)/'Produced by orthorhombic (222) translation function'/
      DATA TI2(3)/'Produced by polar (3) translation function'/
      DATA TI2(4)/'Produced by trigonal (312) translation function'/
      DATA TI2(5)/'Produced by trigonal (321) translation function'/
      DATA TI2(6)/'Produced by polar (4) translation function'/
      DATA TI2(7)/'Produced by tetragonal (422) translation function'/
      DATA TI2(8)/'Produced by polar (6) translation function'/
      DATA TI2(9)/'Produced by hexagonal (622) translation function'/
      DATA TI2(10)/'Produced by cubic (23) translation function'/
      DATA TI2(11)/'Produced by cubic (432) translation function'/
      DATA TI3 /'Produced by partial structure translation function'/
      DATA LTEST/
     &  15*.FALSE.,
     &  .TRUE.,.TRUE.,.TRUE.,12*.FALSE.,
     &  .TRUE.,14*.FALSE.,
     &  .TRUE.,.FALSE.,.FALSE.,.TRUE.,.FALSE.,.TRUE.,.TRUE.,8*.FALSE.,
     &  .TRUE.,.TRUE.,.TRUE.,.FALSE.,.TRUE.,10*.FALSE.,
     &  .TRUE.,14*.FALSE.,
     &  5*.TRUE.,10*.FALSE.,
     &  .TRUE.,14*.FALSE.,
     &  7*.TRUE.,8*.FALSE.,
     &  3*.TRUE.,8*.FALSE.,4*.TRUE.,
     &  5*.TRUE.,.FALSE.,.FALSE.,8*.TRUE./
      DATA SFP,SFC/800*0./
C     ..
      END
C
C
      SUBROUTINE TFMAIN(N,CA)
C     =================
C
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER MCOLS,MNC
      PARAMETER (MCOLS=500,MNC=14)
      REAL PI,PI2,DTR
      PARAMETER (PI=3.141592654, PI2=2.*PI, DTR=PI/180.)
C     ..
C     .. Scalar Arguments ..
      INTEGER N
C     ..
C     .. Array Arguments ..
      COMPLEX CA(N)
C     ..
C     .. Scalars in Common ..
      LOGICAL LFP,LFS,LSP
      INTEGER ICP,IDP,IU,LG,LIST,MU,NC,NG,NMC,NNC,NS,NW
      REAL AM1,AM2,BM1,BM2,Q1,Q2,SFF1,SFF2,T1,T2
C     ..
C     .. Arrays in Common ..
      LOGICAL LTEST
      INTEGER IC,IM1,IM2,IPG,IS,ITV,KC,LC
      REAL AI,CELL,D,SFC,SFP,RTS,TV
C     ..
C     .. Local Scalars ..
      LOGICAL EOF
      INTEGER I,INC,J,K,KE,L,M,NU
      REAL E,F,FP,PCP,Q,R1,R2,SS,S1,S2
      COMPLEX C
C     ..
C     .. Local Arrays ..
      INTEGER IA(MCOLS),ID(3),IM(3),MC(16),NR(200)
      LOGICAL LOGMSS(MCOLS)
C     ..
C     .. Common blocks ..
      COMMON /INCOM/ IS(3,3,24),ITV(MNC),
     &       CELL(6),D(3,24),RTS(4,4,96),TV(3,MNC),
     &       ICP,IDP,LFP,LFS,LG,LIST,LSP,NC,NG,NMC,NNC,NS,T1,T2
      COMMON /TFCOM/ LTEST(15,11),IC(15),IM1(3),IM2(3),IPG(24,24),
     &       KC(15),LC(15),AI(MCOLS),SFC(400),SFP(400),
     &       IU,MU,NW,AM1,BM1,AM2,BM2,Q1,Q2,SFF1,SFF2
C     ..
C     .. Data statements ..
      DATA NR/200*0/
C     ..
C
      KE = 0
      CALL GETINP(KE)
      IF (.NOT.LFP) THEN
        LG = LG - 1
        IF (NG.LT.2) THEN
          WRITE (6,'(/A)') ' **** ERROR: Number of gep''s is < 2.'
          KE = KE + 1
        ENDIF
        IF (.NOT.LFS) THEN
          WRITE (6,'(/A)') ' **** ERROR: T1 option not available.'
          KE = KE + 1
        ENDIF
C
        IU = 1
        IF (KE.EQ.0 .AND. LG.EQ.1) THEN
          DO 300 L = 1,3
            J = MOD(L,3) + 1
            K = MOD(J,3) + 1
            DO 290 I = 1,NG
290           IF (IS(L,L,I).NE.1 .OR. IS(J,L,I).NE.0 .OR.
     &            IS(K,L,I).NE.0 .OR. IS(L,J,I).NE.0 .OR.
     &            IS(L,K,I).NE.0) GOTO 300
            GOTO 310
300         CONTINUE
          WRITE (6,*) '*** ERROR: g.e.p.s not polar.'
          L = 1
          KE = KE + 1
310       IU = 4 - L
          LTEST(IU,1) = .TRUE.
        ENDIF
      ELSE
        IF (NNC.LT.2) THEN
          WRITE (6,'(/A)') ' **** ERROR: NNC not valid ( < 2 ).'
          KE = KE + 1
        ENDIF
        IF (NC.EQ.0) THEN
          WRITE (6,'(/A)') ' **** ERROR: no known translation vectors.'
          KE = KE + 1
        ENDIF
C
        IF (.NOT.LFS) CALL GENPGT(NG,IS,IPG,KE)
      ENDIF
C
      IF (KE.GT.0) CALL CCPERR(1,'Error(s) in data: RUN TERMINATED.')
C
      S1 = 1.
      S2 = 0.
      NU = 0
C
C----PASS 1 - GET RESOLUTION RANGE
110   CALL LRREFF(1,SS,AI,EOF)
      IF (EOF) GOTO 140
      IF (SS.LE.T1 .OR. SS.GT.T2) GOTO 110
      CALL LRREFM(1,LOGMSS)
      IF (LOGMSS(4).OR.LOGMSS(5)) GOTO 110
      IF (AI(5).EQ.0.) GOTO 110
      IA(1) = NINT(AI(1))
      IA(2) = NINT(AI(2))
      IA(3) = NINT(AI(3))
      J = 6
      DO 120 I = 1,NMC
        IF ((LOGMSS(J).OR.LOGMSS(J+1))) THEN
           WRITE (6,'(/A,3I4,A)') 
     +         ' **** WARNING 1*** Reflection ',
     +         IA(1),IA(2),IA(3),' has some FC PC missing!'
           GO TO 110
        ENDIF
        J = J + 2
120   CONTINUE

      IF (SS.LT.S1) S1 = SS
      IF (SS.GT.S2) S2 = SS
      NU = NU + 1
      GOTO 110

140   CALL LRREWD(1)
      R1 = SQRT(1./MAX(S1,1.E-6))
      R2 = SQRT(1./MAX(S2,1.E-6))
      WRITE (6,'(/A,2F8.2)') ' RESOLUTION RANGE =',R1,R2
      DO 150 J = 1,3
150     IM(J) = CELL(J)/R2
      NS = MIN(MAX((NU+NS/2)/NS,1),200)
      Q1 = S1**1.5
      Q2 = (S2**1.5-Q1)/NS
      NU = 0
C
C----PASS 2 - READ STRUCTURE FACTORS, GET MAX INDICES AND FC/FP SCALE.
C
160   CALL LRREFF(1,SS,AI,EOF)
      IF (EOF) GOTO 230
      IF (SS.LE.T1 .OR. SS.GT.T2) GOTO 160
      CALL LRREFM(1,LOGMSS)
      IF (LOGMSS(4).OR.LOGMSS(5)) GOTO 160
      IF (AI(5).EQ.0.) GOTO 160
      DO 190 J = 1,3
        IA(J) = NINT(AI(J))
190     IM(J) = MAX(ABS(IA(J)),IM(J))
      J = 6
      DO 170 I = 1,NMC
        IF ((LOGMSS(J).OR.LOGMSS(J+1))) THEN
           WRITE (6,'(/A,3I4,A)') 
     +        ' **** WARNING 2*** Reflection ',
     +        IA(1),IA(2),IA(3),' has some FC PC missing!'
           GO TO 160
        ENDIF
        J = J + 2
170   CONTINUE

      NU = NU + 1
      K = MIN(INT((SS**1.5-Q1)/Q2)+1,NS)
      CALL MULEPS(IA,M,E)
      NR(K) = NR(K) + M
      IF (.NOT.LFS) E = 1.
      F = M/E
      FP = AI(4)
      SFP(K) = SFP(K) + F*FP**2
      C = (0.,0.)
      J = 6
      DO 220 INC = 1,NNC
        DO 215 I = 1,NG
            IF (LFS .AND. ITV(INC).LT.0) THEN
C
C==== Calculate structure factor for known part.
C
              CALL GENEQ(IS(1,1,I),IA,ID)
              PCP = DTR*AI(J+1)
              DO 200 L = 1,3
200             PCP = PCP + ID(L)*TV(L,INC) + IA(L)*D(L,I)
              PCP = MOD(PCP,PI2)
              C = C + AI(J)*CMPLX(COS(PCP),SIN(PCP))
            ELSE
              SFC(K) = SFC(K) + M*AI(J)**2
            ENDIF
215       J = J + 2
220   CONTINUE
      IF (LFS) SFC(K) = SFC(K) + F*ABS(C)**2
      GOTO 160
C
  230 CALL LRREWD(1)
      WRITE (6,'(/A)')
     &' SHELL  RESOLUTION  NUMBER  MEAN FP**2  MEAN FC**2     SCALE'
      Q = Q1
      DO 270 K = 1,NS
        Q = Q + Q2
        SS = Q**(-1./3.)
        SFF1 = 0.
        IF (NR(K).GT.0) THEN
          SFP(K) = SFP(K)/NR(K)
          SFC(K) = SFC(K)/NR(K)
          SFF1 = SFC(K)/SFP(K)
        ENDIF
        WRITE (6,'(1X,I5,F10.2,I10,2F12.0,F10.4)')
     &  K,SS,NR(K),SFP(K),SFC(K),SFF1
        SFP(K+NS) = SFP(K)
        SFC(K+NS) = SFC(K)
  270   CONTINUE
      DO 280 K = 1,NS
        IF (NR(K).EQ.0) CALL CCPERR(1,'!!!!! Empty Shell: reduce NS')
        I = K - 1
        J = K + 1
        IF (K.EQ.1) THEN
          SFP(K) = .45*SFP(K+NS) + .55*SFP(J+NS)
          SFC(K) = .45*SFC(K+NS) + .55*SFC(J+NS)
        ELSEIF (K.EQ.NS) THEN
          SFP(K) = .45*SFP(K+NS) + .55*SFP(I+NS)
          SFC(K) = .45*SFC(K+NS) + .55*SFC(I+NS)
        ELSE
          SFP(K) = .3*(SFP(I+NS)+SFP(J+NS)) + .4*SFP(K+NS)
          SFC(K) = .3*(SFC(I+NS)+SFC(J+NS)) + .4*SFC(K+NS)
        ENDIF
  280   CONTINUE
      WRITE (6,'(/A,I5,5X,A,3I4)')
     &' NO OF REFLNS USED =',NU,'MAX HKL =',IM
      MU = 1000000000
      IF (LIST.GT.0) MU = NU/LIST
C
      NW = 0
      AM1 = 0.
      BM1 = 0.
      SFF1 = 0.
      AM2 = 0.
      BM2 = 0.
      SFF2 = 0.
      Q1 = Q1 + .5*Q2
C
      IF (.NOT.LFP) THEN
        IF (LG.GE.3) THEN
          IM(1) = MAX(IM(1),IM(2))
          IM(2) = IM(1)
        ENDIF
C
        IF (LG.GE.10) THEN
          IM(1) = MAX(IM(1),IM(3))
          IM(2) = IM(1)
          IM(3) = IM(1)
        ENDIF
C
        IF (LG.LE.2 .OR. LG.EQ.10) THEN
          IC(1) = IM(1) + 1
          LC(1) = IM(2) + 1
        ELSE
          IC(1) = 2*IM(1) + 1
          LC(1) = IC(1)
        ENDIF
C
        IF (LG.EQ.4 .OR. LG.EQ.5 .OR. LG.EQ.9) THEN
          IC(2) = SQRT(3.)*(IM(1)+1) + 1
          IC(3) = IC(2)
          IC(4) = IM(1) + 1
          IC(5) = IC(2)
          LC(2) = IM(3) + 1
          LC(4) = LC(2)
        ELSE
          IF (LG.EQ.11) THEN
            IC(2) = IC(1)
            IC(3) = IC(1)
            LC(2) = IC(1)
            LC(4) = IM(1) + 1
          ELSE
            IC(2) = IM(1) + 1
            IC(3) = IM(2) + 1
            LC(2) = IM(3) + 1
            LC(4) = LC(2)
          ENDIF
          IC(4) = SQRT(2.)*(IM(1)+1) + 1
          IC(5) = IC(4)
        ENDIF
C
        IC(6) = IC(4)
        IC(7) = IC(4)
        DO 320 I = 8,11
320       IC(I) = LC(4)
        DO 330 I = 12,15
330       IC(I) = IC(4)
        DO 340 I = 1,15
340       KC(I) = 2*IC(I) - 1
        LC(3) = LC(2)
        LC(5) = LC(4)
        LC(6) = LC(2)
        LC(7) = LC(2)
        DO 350 I = 8,15
350       LC(I) = IC(4)
C
        IF (LIST.NE.0) WRITE (6,'(//A)') ' ARRAY BOUND INFORMATION:'
        MC(1) = 1
        DO 360 I = 1,15
          M = 0
          IF (LTEST(I,LG)) THEN
            M = KC(I)*LC(I)
            IF (LIST.NE.0) WRITE (6,'(1X,5I6)') I,KC(I),LC(I),M,MC(I)
          ENDIF
360       MC(I+1) = MC(I) + M
        M = 2*(MC(16)-1)
        WRITE (6,'(/A,I8,5X,A,I8)')
     &  ' ARRAY SIZE SUPPLIED =',N,'USED =',M
        IF (M.GT.N) CALL CCPERR(1,
     &  '*** ERROR - increase dimension of array A (PARAMETER NA).')
        DO 370 L = 1,M
370       CA(L) = (0.,0.)
        M = M/2
        CALL TFSGEN(
     &  CA(MC(1)),CA(MC(2)),CA(MC(3)),CA(MC(4)),CA(MC(5)),
     &  CA(MC(6)),CA(MC(7)),CA(MC(8)),CA(MC(9)),CA(MC(10)),
     &  CA(MC(11)),CA(MC(12)),CA(MC(13)),CA(MC(14)),CA(MC(15)),
     &  CA(M+MC(1)),CA(M+MC(2)),CA(M+MC(3)),CA(M+MC(4)),CA(M+MC(5)),
     &  CA(M+MC(6)),CA(M+MC(7)),CA(M+MC(8)),CA(M+MC(9)),CA(M+MC(10)),
     &  CA(M+MC(11)),CA(M+MC(12)),CA(M+MC(13)),CA(M+MC(14)),CA(M+MC(15))
     &  )
      ELSE
        CALL TFPART
      ENDIF
      END
C
C
      SUBROUTINE GETINP(KE)
C     =================
C
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER MCOLS,MKEY,MNC,MTOK
      PARAMETER (MCOLS=500,MKEY=13,MNC=14,MTOK=200)
      REAL PI,PI2
      PARAMETER (PI=3.141592654, PI2=2.*PI)
C     ..
C     .. Scalar Arguments ..
      INTEGER KE,NCOL
C     ..
C     .. Scalars in Common ..
      CHARACTER TI1*70,XNAME*64,DNAME*64
      LOGICAL LFP,LFS,LSP
      INTEGER ICP,IDP,LG,LIST,NC,NG,NMC,NNC,NS
      REAL T1,T2
C     ..
C     .. Arrays in Common ..
      INTEGER IS,ITV
      REAL CELL,D,RTS,TV
C     ..
C     .. Local Scalars ..
      CHARACTER C*1,CNC*(MNC),FTITLE*70,KEY*4,LABI*2000,LINE*2000,
     &          PGN*10,SGN*10
      LOGICAL EOF
      INTEGER I,IFAIL,IG,INC,IND,IPRINT,ITD,J,KF,L,
     &        ND,NGI,NPG,NSG,NSGI,NLPRGI,NTOK
      REAL R,R1,R2
C     ..
C     .. Local Arrays ..
      CHARACTER CV(MTOK)*4,CTPRGI(MCOLS)*1,LSPRGI(MCOLS)*30,KEYS(MKEY)*4
      INTEGER LGT(12),LOOKUP(MCOLS),NGT(12)
      INTEGER IB(MTOK),IE(MTOK),IT(MTOK),IV(MTOK),NTOKS(MKEY)
      REAL FV(MTOK),RTSI(4,4,96)
C     ..
C     .. Common blocks ..
      COMMON /INCOMC/ TI1,XNAME,DNAME
      COMMON /INCOM/ IS(3,3,24),ITV(MNC),
     &       CELL(6),D(3,24),RTS(4,4,96),TV(3,MNC),
     &       ICP,IDP,LFP,LFS,LG,LIST,LSP,NC,NG,NMC,NNC,NS,T1,T2
      SAVE /INCOMC/
C     ..
C     .. External functions ..
      INTEGER LENSTR
C     ..
C     .. Data statements ..
      DATA IND /1/, IPRINT/3/
      DATA KEYS/'TITL','SPAC','POIN','SYMM','NONC','SELF','SHEL','RESO',
     &          'LIST','VECT','FIND','PART','LABI'/
      DATA NTOKS/1,-2,-2,2,-2,-1,-2,-3,-2,-5,-2,-1,1/
      DATA LGT /1,2,222,3,312,321,4,422,6,622,23,432/
      DATA NGT /1,2,  4,3,  6,  6,4,  8,6, 12,12, 24/
      DATA LOOKUP /MCOLS*-1/
C     ..
C
C     ===========
      CALL MTZINI
C     ===========
C
C     =======================================
      CALL LROPEN(IND,'HKLIN',IPRINT,IFAIL)
C     =======================================
C
      IF (IFAIL.NE.0) CALL CCPERR(1,
     &'*** ERROR OPENING INPUT MTZ FILE ***')
C
C     ==================================
      CALL LRSYMI(IND,NGI,C,NSGI,SGN,PGN)
C     ==================================
C
C     ==========================
      CALL LRSYMM(IND,IG,RTSI)
C     ==========================
      NPG = 0
      IF (PGN.NE.' ') READ (PGN(:LENSTR(PGN)),'(2X,I3)',ERR=1) NPG
C
1     TI1 = ' '
      ICP = 0
      IDP = 1
      ITD = 0
      DO 2 I=1,MNC
        CNC(I:I)=CHAR(64+I)
2       ITV(I)=0
      KE = 0
      LIST = 0
      LFP = .FALSE.
      LFS = .TRUE.
      LSP = .FALSE.
      NC = 0
      ND = 0
      NG = 0
      NMC = 0
      NNC = 0
      NS = 100
      NSG = 0
      R1 = 20.
      R2 = 0.
      XNAME = ' '
      DNAME = ' '
C
10    LINE = ' '
      NTOK = MTOK
      CALL PARSER(KEY,LINE,IB,IE,IT,FV,CV,IV,NTOK,EOF,.TRUE.)
      IF (EOF) GOTO 40
C      WRITE (6,'(1X,5I5,F10.3,2X,A)')
C     &(I,IB(I),IE(I),IT(I),IV(I),FV(I),CV(I),I=1,NTOK)
C
      DO 20 I=1,MKEY
20      IF (KEY.EQ.KEYS(I)) GOTO 30
      WRITE (6,'(/2A)') ' **** ERROR: bad keyword: ',KEY
      KE = KE + 1
      GOTO 10
C
30    IF ((NTOKS(I).LT.0 .AND. NTOK.NE.-NTOKS(I)).OR.
     &    NTOK.LT.NTOKS(I)) THEN
        WRITE (6,'(/A)') ' **** ERROR: bad argument count.'
        KE = KE + 1
      ENDIF
      GOTO (1010,1020,1030,1040,1050,1060,1070,1080,1090,1100,1110,1120,
     &      2000),I
C
C==== TITLE
1010  TI1 = LINE(IB(2):)
      GOTO 10
C
C==== SPACEGROUP
1020  IF (NG.GT.0) THEN
        WRITE (6,'(/A)') ' **** ERROR: space group already defined.'
        KE = KE + 1
      ELSE
        IF (IT(2).EQ.1) THEN
          SGN=LINE(IB(2):IE(2))
          CALL CCPUPC(SGN)
        ELSE
          CALL GTPINT(2,NSG,NTOK,IT,FV)
        ENDIF
        CALL MSYMLB(1,NSG,SGN,PGN,NG,I,RTS)
        IF (NSG.LE.0 .OR. NG.LE.0) GOTO 1021
        IF (PGN.NE.' ') READ (PGN(:LENSTR(PGN)),'(2X,I3)',ERR=1021) I
        IF (NPG.EQ.0) THEN
          NPG=I
          IF (NPG.LE.0) GOTO 1031
        ELSEIF (NPG.NE.I) THEN
          WRITE (6,'(/A)') ' **** ERROR: point group already defined.'
          KE = KE + 1
        ENDIF
      ENDIF
      GOTO 10
1021  WRITE (6,'(/2A)') ' **** ERROR: Point group not valid: ',PGN
      NPG = 1
      KE = KE + 1
      GOTO 10
C
C==== POINTGROUP
1030  IF (IT(2).EQ.1) THEN
        PGN=LINE(IB(2):IE(2))
        IF (PGN.NE.' ') READ (PGN(:LENSTR(PGN)),'(2X,I3)',ERR=1021) I
      ELSE
        CALL GTPINT(2,I,NTOK,IT,FV)
      ENDIF
      IF (NPG.EQ.0) THEN
        NPG=I
        IF (NPG.LE.0) GOTO 1031
      ELSEIF (NPG.NE.I) THEN
        WRITE (6,'(/A)') ' **** ERROR: point group already defined.'
        KE = KE + 1
      ENDIF
      GOTO 10
1031  WRITE (6,'(/2A)') ' **** ERROR: Point group not valid: ',NPG
      NPG = 1
      KE = KE + 1
      GOTO 10
C
C==== SYMMETRY
1040  IF (NSG.NE.0) THEN
        WRITE (6,'(/A)') ' **** ERROR: SPACEGROUP and SYMMETRY '//
     &  'keywords are mutually exclusive.'
        KE = KE + 1
      ENDIF
      NG = NG + 1
      IF (NG.GT.24) GOTO 10
      CALL SYMFR3(LINE,IB(2),NG,RTS,KF)
      IF (KF.GT.0) KE = KE + 1
      GOTO 10
C
C==== NONCRYSTALLOGRAPHIC
1050  CALL GTPINT(2,NNC,NTOK,IT,FV)
      IF (NNC.LT.0 .OR. NNC.GT.MNC) THEN
        WRITE (6,'(/A)') ' **** ERROR: NNC not valid.'
        NNC = MIN(MAX(NNC,0),MNC)
        KE = KE + 1
      ENDIF
      GOTO 10
C
C==== SELF
1060  LSP = .TRUE.
      GOTO 10
C
C==== SHELL
1070  CALL GTPINT(2,NS,NTOK,IT,FV)
      NS = MAX(NS,25)
      GOTO 10
C
C==== RESOLUTION
1080  CALL GTPREA(2,R1,NTOK,IT,FV)
      CALL GTPREA(3,R2,NTOK,IT,FV)
      GOTO 10
C
C==== LIST
1090  CALL GTPINT(2,LIST,NTOK,IT,FV)
      GOTO 10
C
C==== VECTOR
1100  IF (IT(2).NE.1 .OR. IV(2).EQ.0) GOTO 1111
      C = CV(2)(:1)
      CALL CCPUPC(C)
      I = INDEX(CNC,C)
      IF (I.EQ.0) THEN
        WRITE (6,'(/2A)') ' **** ERROR: subunit not valid: ',CV(2)
        KE = KE + 1
      ELSE
        NMC = MAX(I,NMC)
        CALL GTNREA(3,3,TV(1,I),NTOK,IT,FV)
      ENDIF
C
      IF (IV(2).EQ.1) THEN
        IF (ITV(I).NE.0 .OR. (NC+ND.GT.0 .AND..NOT.LFS)) THEN
          WRITE (6,'(/2A)') ' **** ERROR: subunit not valid: ',CV(2)
          KE = KE + 1
        ENDIF
        ITV(I) = -1
      ELSE
        IF (ITV(I).NE.0 .OR. (NC+ND.GT.0 .AND.LFS)) THEN
          WRITE (6,'(/2A)') ' **** ERROR: subunit not valid: ',CV(2)
          KE = KE + 1
        ENDIF
        IF (NC.EQ.1) THEN
          WRITE (6,'(/A)') ' **** ERROR: More than one VECTOR.'
          KE = KE + 1
        ENDIF
        READ (CV(2)(2:IV(2)),'(I2)',ERR=1111) ICP
        IF (ICP.LE.0) GOTO 1111
        ITV(I) = -ICP
        LFS = .FALSE.
      ENDIF
      NC = NC + 1
      GOTO 10
C
C==== FIND
1110  IF (ND.EQ.1) THEN
        WRITE (6,'(/A)') ' **** ERROR: More than one FIND.'
        KE = KE + 1
      ENDIF
      ND = ND + 1
      IF (IT(2).NE.1 .OR. IV(2).EQ.0) GOTO 1111
      C = CV(2)(:1)
      CALL CCPUPC(C)
      ITD = INDEX(CNC,C)
      IF (ITD.EQ.0) THEN
        WRITE (6,'(/2A)') ' **** ERROR: subunit not valid: ',CV(2)
        KE = KE + 1
      ELSE
        ITV(ITD) = 1
        NMC = MAX(ITD,NMC)
      ENDIF
C
      IF (IV(2).EQ.1) THEN
        IF (NC+ND.GT.0 .AND..NOT.LFS) THEN
          WRITE (6,'(/2A)') ' **** ERROR: subunit not valid: ',CV(2)
          KE = KE + 1
        ENDIF
      ELSE
        IF (NC+ND.GT.0 .AND.LFS) THEN
          WRITE (6,'(/2A)') ' **** ERROR: subunit not valid: ',CV(2)
          KE = KE + 1
        ENDIF
        READ (CV(2)(2:IV(2)),'(I2)',ERR=1111) IDP
        IF (IDP.LE.0) GOTO 1111
        LFS = .FALSE.
      ENDIF
      GOTO 10
1111  WRITE (6,'(/2A)') ' **** ERROR: subunit not valid: ',CV(2)
      KE = KE + 1
      GOTO 10
C
C==== PART
1120  LFP = .TRUE.
      GOTO 10
C
C==== LABIN
2000  LABI = LINE
      GOTO 10
C
40    CLOSE (5)
      IF (R1.LT.R2) THEN
        R = R1
        R1 = R2
        R2 = R
      ENDIF
      T1 = 0.
      IF (R1.GT.0.) T1 = 1./R1**2
      T2 = 1./MAX(R2,.1)**2
C
      IF (NPG.EQ.0) THEN
        WRITE (6,'(/A)') ' **** ERROR: Point group not specified.'
      ELSE
        IF (NPG.EQ.32) NPG = 321
        DO 50 LG = 1,12
50        IF (LGT(LG).EQ.NPG) GOTO 60
        WRITE (6,'(/A,I5)') ' **** ERROR: Point group not valid: ',NPG
      ENDIF
      LG = 1
      KE = KE + 1
C
60    IF (NG.EQ.0) THEN
        NG = NGI
        NGI = 0
        NSG = NSGI
C
        DO 140 IG=1,NG
          DO 140 I=1,4
            DO 140 J=1,4
140           RTS(I,J,IG) = RTSI(I,J,IG)
      ENDIF
C
      IF (NG.NE.NGT(LG)) THEN
        WRITE (6,'(/A)') ' **** ERROR: Number of gep''s is not valid.'
        KE = KE + 1
        NG = MIN(NG,NGT(LG))
      ENDIF
C
      IF (NGI.GT.0) THEN
        IF (NG.NE.NGI) THEN
          WRITE (6,'(/A)')
     &    ' **** ERROR: Inconsistent number of gep''s.'
          KE = KE + 1
          GOTO 80
        ENDIF
C
        DO 70 IG=1,NG
          DO 70 I=1,3
            DO 70 J=1,3
              IF (RTS(I,J,IG).NE.RTSI(I,J,IG)) THEN
                WRITE (6,'(/A,3I3)')
     +             ' *** ERROR: Inconsistent rotation matrix, element ',
     +               IG,I,J
                KE = KE + 1
                GOTO 80
              ENDIF
70      CONTINUE
      ENDIF
C
80    DO 90 IG = 1,NG
        DO 90 I = 1,3
          D(I,IG) = PI2*RTS(I,4,IG)
          DO 90 J = 1,3
90          IS(I,J,IG) = NINT(RTS(I,J,IG))
C
      DO 100 I=NNC+1,NMC
        IF (ITV(I).NE.0) THEN
          WRITE (6,'(/2A)') ' **** ERROR: subunit not valid: ',CNC(I:I)
          KE = KE + 1
        ENDIF
100   CONTINUE
C
      LSPRGI(1) = 'H'
      LSPRGI(2) = 'K'
      LSPRGI(3) = 'L'
      LSPRGI(4) = 'FP'
      LSPRGI(5) = 'SIGFP'
      CTPRGI(1) = 'H'
      CTPRGI(2) = 'H'
      CTPRGI(3) = 'H'
      CTPRGI(4) = 'F'
      CTPRGI(5) = 'Q'
C
      J = 6
      IF (NNC.EQ.0) THEN
        IF (ITD.GT.1) THEN
          WRITE (6,'(/2A)')
     &    ' **** ERROR: subunit not valid: ',CNC(ITD:ITD)
          KE = KE + 1
        ENDIF
        NNC = 1
        ITD = 1
        ITV(1) = 1
        DO 110 I = 1,NG
          IF (I.LE.9) THEN
            WRITE (LSPRGI(J),'(A,I1)') 'FC',I
            WRITE (LSPRGI(J+1),'(A,I1)') 'PC',I
          ELSE
            WRITE (LSPRGI(J),'(A,I2)') 'FC',I
            WRITE (LSPRGI(J+1),'(A,I2)') 'PC',I
          ENDIF
          CTPRGI(J) = 'F'
          CTPRGI(J+1) = 'P'
110       J=J+2
      ELSE
        IF (NC.GT.0) WRITE (6,'(/A)') ' TRANSLATION VECTORS'
        DO 130 INC = 1,NNC
          IF (ITV(INC).LT.0) THEN
            IF (ICP.GT.NG) THEN
              WRITE (6,'(/2A,I3)')
     &        ' **** ERROR: subunit not valid: ',CNC(INC:INC),ICP
              KE = KE + 1
            ELSE
              WRITE (6,'(2A,I3,3F10.4)') ' NON-CRYST SUBUNIT  ',
     &        CNC(INC:INC),-ITV(INC),(TV(L,INC),L=1,3)
              DO 120 L = 1,3
120             TV(L,INC) = PI2*TV(L,INC)
            ENDIF
          ELSEIF (ITV(INC).EQ.0 .AND. ITD.EQ.0 .AND. NC.EQ.NNC-1 .AND.
     &            (LFS .OR. NG.EQ.1)) THEN
            ITD = INC
            ITV(ITD) = 1
          ENDIF
C
C==== Set up labels.
C
          DO 130 I = 1,NG
            IF (I.LE.9) THEN
              WRITE (LSPRGI(J),'(2A,I1)') 'FC',CNC(INC:INC),I
              WRITE (LSPRGI(J+1),'(2A,I1)') 'PC',CNC(INC:INC),I
            ELSE
              WRITE (LSPRGI(J),'(2A,I2)') 'FC',CNC(INC:INC),I
              WRITE (LSPRGI(J+1),'(2A,I2)') 'PC',CNC(INC:INC),I
            ENDIF
            CTPRGI(J) = 'F'
            CTPRGI(J+1) = 'P'
130         J = J + 2
      ENDIF
C
      IF (ITD.EQ.0) THEN
        WRITE (6,'(/A)')
     &  ' **** ERROR: subunit to be determined not specified.'
        KE = KE + 1
      ELSEIF (IDP.GT.NG) THEN
        WRITE (6,'(/2A,I3)')
     &  ' **** ERROR: subunit not valid: ',CNC(ITD:ITD),IDP
        KE = KE + 1
      ELSE
        WRITE (6,'(/2A,I3,A)') ' TRANSLATION FOR SUBUNIT  ',
     &  CNC(ITD:ITD),IDP,'  TO BE DETERMINED.'
      ENDIF
C
      NMC = NG*NNC
      NLPRGI = 5 + 2*NMC
      IF (NLPRGI.GT.MCOLS) THEN
        WRITE (6,'(/A)') ' **** ERROR: Too many labels.'
        KE = KE + 1
      ENDIF
C
      NTOK = MTOK
      CALL PARSER(KEY,LABI,IB,IE,IT,FV,CV,IV,NTOK,EOF,.FALSE.)
C
C     ============================================
      CALL LKYIN (1,LSPRGI,NLPRGI,NTOK,LABI,IB,IE)
C     ============================================
C
C     =======================================================
      CALL GRASSN(NLPRGI,LSPRGI,CTPRGI,XNAME,DNAME,
     +                                FTITLE,NCOL,LOOKUP,CELL)
C     =======================================================
C
      IF (TI1.EQ.' ') TI1 = FTITLE
      WRITE (6,'(/1X,A/)') TI1
      IF (NSG.NE.0) WRITE (6,'(/A,I4,3X,A)')
     &  ' SPACE GROUP                   =',NSG,SGN
      WRITE (6,'(/A,I4)')
     &  ' POINT GROUP                   =',NPG
      WRITE (6,'(/A,I4//A,3X,L1//A,I4//A,2F8.2)')
     &' NUMBER OF NON-CRYST SUBUNITS  =',NNC,
     &' SELF-PATTERSON INCLUSION FLAG =',LSP,
     &' NO OF REFLNS/SHELL            =',NS,
     &' RESOLUTION LIMITS             =',R1,R2
      IF (.NOT.LFP) THEN
        WRITE (6,'(/A)')
     &  ' FULL CRYSTALLOGRAPHIC SYMMETRY TRANSLATION FUNCTION.'
      ELSE
        WRITE (6,'(/A)')
     &  ' PARTIAL (NON-CRYSTALLOGRAPHIC SYMMETRY) TRANSLATION FUNCTION.'
      ENDIF
      IF (.NOT.LFS) WRITE (6,'(/A)') ' USING T1 OPTION.'
      END
C
C
      SUBROUTINE GRASSN(NLPRGI,LSPRGI,CTPRGI,XNAME,DNAME,
     +                                FTITLE,NCOL,LOOKUP,CELL)
C     =================
C
      IMPLICIT NONE
C     .. Scalar Arguments ..
      CHARACTER FTITLE*(*),XNAME*(*),DNAME*(*)
      INTEGER NLPRGI,NCOL
C     ..
C     .. Array Arguments ..
      CHARACTER LSPRGI(*)*(*),CTPRGI(*)*(*)
      INTEGER LOOKUP(*)
      REAL CELL(6)
C     ..
C     .. Local Scalars ..
      INTEGER IND,LEN

      INTEGER MCOLS
      PARAMETER (MCOLS=500)
      INTEGER MSETS
      PARAMETER (MSETS=MCOLS)
C 
C----Harvesting stuff
C
      INTEGER NDATASETS,ISETS(MSETS),IDUMMY,CSETID(MCOLS),
     +         CSETOUT,ISET
      REAL DATCELL(6,MSETS),DATWAVE(MSETS)
      CHARACTER*64 PNAME_IN(MSETS),XNAME_IN(MSETS),DNAME_IN(MSETS)
C     ..
C     .. Data statements ..
      DATA IND /1/
C     ..
C
C     =============================
      CALL LRTITL(IND,FTITLE,LEN)
C     =============================
C
C     =======================
      CALL LRNCOL(IND,NCOL)
C     =======================
C
C     ==============================================
      CALL LRASSN(IND,LSPRGI,NLPRGI,LOOKUP,CTPRGI)
C     ==============================================

C     Notify available space
      NDATASETS = MSETS
      CALL LRIDX(IND,PNAME_IN,XNAME_IN,DNAME_IN,ISETS,
     +                     DATCELL,DATWAVE,NDATASETS)

C---- Get dataset IDs for columns and set up output ID.
      IF (NDATASETS.GT.0) THEN
        CALL LRCLID(IND,CSETID,IDUMMY)
C      output columns have dataset of input FP
        CSETOUT=CSETID(LOOKUP(4))
        DO ISET = 1,NDATASETS
          IF (ISETS(ISET).EQ.CSETOUT) THEN
            XNAME = XNAME_IN(ISET)
            DNAME = DNAME_IN(ISET)
          END IF
        ENDDO
      ENDIF
C
C     =======================
      CALL LRCELL(IND,CELL)
C     =======================
C
      END
C
C
      SUBROUTINE GENPGT(NG,IS,IPG,KE)
C     =================
C-- GENERATE POINT GROUP MULTIPLICATION TABLE.
C
      IMPLICIT NONE
C     .. Scalar Arguments ..
      INTEGER KE,NG
C     ..
C     .. Array Arguments ..
      INTEGER IPG(24,24),IS(3,3,24)
C     ..
C     .. Local Scalars ..
      INTEGER I,I1,I2,I3,J,K,M,N
C     ..
C
      N = 0
      DO 5 I1 = 1,NG
        DO 4 I2 = 1,NG
          DO 3 I3 = 1,NG
            DO 2 I = 1,3
              DO 2 J = 1,3
                M = 0
                DO 1 K = 1,3
1                 M = M + IS(I,K,I1)*IS(K,J,I2)
                IF (M.NE.IS(I,J,I3)) GOTO 3
2           CONTINUE
            IPG(I2,I1) = I3
            GOTO 4
3         CONTINUE
          IF (N.EQ.0) THEN
            WRITE (6,'(/A)') ' **** ERROR in point symmetry.'
            KE = KE + 1
          ENDIF
          IPG(I2,I1) = 0
          N = N + 1
4       CONTINUE
5       WRITE (6,'(1X,24I4)') (IPG(I2,I1),I2=1,NG)
      END
C
C
      SUBROUTINE MULEPS(IH,M,E)
C     =================
C
C-- CALC MULTIPLICITY AND EPSILON
C
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER MNC
      PARAMETER (MNC=14)
C     ..
C     .. Scalar Arguments ..
      INTEGER M
      REAL E
C     ..
C     .. Array Arguments ..
      INTEGER IH(3)
C     ..
C     .. Scalars in Common ..
      LOGICAL LFP,LFS,LSP
      INTEGER ICP,IDP,LG,LIST,NC,NG,NMC,NNC,NS
      REAL T1,T2
C     ..
C     .. Arrays in Common ..
      INTEGER IS,ITV
      REAL CELL,D,RTS,TV
C     ..
C     .. Local Scalars ..
      INTEGER I,J,K
C     ..
C     .. Local Arrays ..
      INTEGER IE(3)
C     ..
C     .. Common blocks ..
      COMMON /INCOM/ IS(3,3,24),ITV(MNC),
     &       CELL(6),D(3,24),RTS(4,4,96),TV(3,MNC),
     &       ICP,IDP,LFP,LFS,LG,LIST,LSP,NC,NG,NMC,NNC,NS,T1,T2
C     ..
      E = 1.
      M = 1
      IF (NG.GT.1) THEN
        CALL GENEQ(IS,IH,IE)
        I = 1048576*IE(1) + 1024*IE(2) + IE(3)
        DO 10 K = 2,NG
          CALL GENEQ(IS(1,1,K),IH,IE)
          J = 1048576*IE(1) + 1024*IE(2) + IE(3)
          IF (I.EQ.J .OR. I.EQ.-J) M = M + 1
10        IF (I.EQ.J) E = E + 1.
        M = NG/M
      ENDIF
      END
C
C
      SUBROUTINE GENEQ(IS,IH,IE)
C     ================
C
C-- GENERATE EQUIVALENT REFLN
C
      IMPLICIT NONE
C     .. Array Arguments ..
      INTEGER IH(3),IE(3),IS(3,3)
C     ..
C     .. Local Scalars ..
      INTEGER I,J
C     ..
      DO 10 J = 1,3
        IE(J) = 0
        DO 10 I = 1,3
10        IE(J) = IE(J) + IH(I)*IS(I,J)
      END
C
C
      SUBROUTINE TFSGEN(C11,C21,C31,C41,C51,C61,C71,
     &                  C81,C91,C101,C111,C121,C131,C141,C151,
     &                  C12,C22,C32,C42,C52,C62,C72,
     &                  C82,C92,C102,C112,C122,C132,C142,C152)
C     =================
C
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER MCOLS,MNC
      PARAMETER (MCOLS=500,MNC=14)
      REAL PI,PI2,DTR
      PARAMETER (PI=3.141592654, PI2=2.*PI, DTR=PI/180.)
C     ..
C     .. Scalars in Common ..
      CHARACTER TI1*70,TI3*70,XNAME*64,DNAME*64
      LOGICAL LFP,LFS,LSP
      INTEGER ICP,IDP,IU,K1,K10,K11,K12,K13,K14,K15,K2,K3,K4,K5,K6,K7,
     &        K8,K9,L1,L10,L11,L12,L13,L14,L15,L2,L3,L4,L5,L6,L7,L8,L9,
     &        LG,LIST,MU,NC,NG,NMC,NNC,NS,NW
      REAL AM1,AM2,BM1,BM2,Q1,Q2,SFF1,SFF2,T1,T2
C     ..
C     .. Array Arguments ..
      COMPLEX C11(K1,L1),C21(K2,L2),C31(K3,L3),
     &        C41(K4,L4),C51(K5,L5),C61(K6,L6),C71(K7,L7),
     &        C81(K8,L8),C91(K9,L9),C101(K10,L10),C111(K11,L11),
     &        C121(K12,L12),C131(K13,L13),C141(K14,L14),C151(K15,L15)
      COMPLEX C12(K1,L1),C22(K2,L2),C32(K3,L3),
     &        C42(K4,L4),C52(K5,L5),C62(K6,L6),C72(K7,L7),
     &        C82(K8,L8),C92(K9,L9),C102(K10,L10),C112(K11,L11),
     &        C122(K12,L12),C132(K13,L13),C142(K14,L14),C152(K15,L15)
C     ..
C     .. Arrays in Common ..
      CHARACTER TI2*70
      LOGICAL LTEST
      INTEGER IC,IM1,IM2,IPG,IS,ITV
      REAL AI,CELL,D,SFC,SFP,RTS,TV
C     ..
C     .. Local Scalars ..
      CHARACTER SGN*10,PGN*10
      LOGICAL EOF,LD1,LD2,LD3
      INTEGER I,I1,I2,INC,J,JC,JP,K,KE,L,M,NLPRGI,NLPRGO,NR,NU
      REAL DP,E,EP,F,F01,F02,PCP,Q,SC,SCC,SCP,SE,SF,SP,SS
      COMPLEX C,C1,C2
C     ..
C     .. Local Arrays ..
      CHARACTER LSPRGO(7)*30,CTPRGO(7)*1,ZONE(15)*8
      INTEGER IA(MCOLS),ID(3,24),IH(3),KC(15),KM(15),LC(15),LM(15),
     &NCA(15)
      REAL CC(4),CP(4),FD(24),PH(24)
      LOGICAL LOGMSS(MCOLS)
C     ..
C     .. External functions ..
      REAL FSPLIN
C     ..
C     .. Common blocks ..
      COMMON /INCOMC/ TI1,XNAME,DNAME
      COMMON /TFCOMC/ TI2(11),TI3
      COMMON /INCOM/ IS(3,3,24),ITV(MNC),
     &       CELL(6),D(3,24),RTS(4,4,96),TV(3,MNC),
     &       ICP,IDP,LFP,LFS,LG,LIST,LSP,NC,NG,NMC,NNC,NS,T1,T2
      COMMON /TFCOM/ LTEST(15,11),IC(15),IM1(3),IM2(3),IPG(24,24),
     &       K1,K2,K3,K4,K5,K6,K7,K8,K9,K10,K11,K12,K13,K14,K15,
     &       L1,L2,L3,L4,L5,L6,L7,L8,L9,L10,L11,L12,L13,L14,L15,
     &       AI(MCOLS),SFC(400),SFP(400),
     &       IU,MU,NW,AM1,BM1,AM2,BM2,Q1,Q2,SFF1,SFF2
      SAVE /INCOMC/, /TFCOMC/
C     ..
C     .. Equivalences ..
      EQUIVALENCE (K1,KC)
      EQUIVALENCE (L1,LC)
C     ..
C     .. Data statements ..
      DATA KM,LM/30*0/
      DATA ZONE/'hk0','h0l','0kl','h,h,l','h,-h,l','2h,-h,l','-h,2h,l',
     &     'hkh','-h,k,h','h,k,k','h,-k,k','h,k,-h-k','h,k,h+k',
     &     'h,k,-h+k','h,k,h-k'/
      DATA NLPRGO /7/
      DATA LSPRGO /'H','K','L','A','B','AO','BO'/
      DATA CTPRGO /'H','H','H','R','R','R','R'/
      DATA SGN,PGN /'P1','PG1'/
C     ..
C
      LD1 = LG.LE.2 .OR. LG.EQ.10
      LD2 = LD1 .OR. LG.EQ.7
      LD3 = LG.NE.11
C
C----PASS 3 - READ STRUCTURE FACTORS AGAIN, SCALE AND
C----         CALC TRANSLATION FUNCTION COEFFS, ACCUMULATING
C----         IN ARRAYS.
      NU = 0
      JP = 0
      JC = 0
      SCP = 0.
      SCC = 0.
      F01 = 0.
      F02 = 0.
      NR = 0
      NLPRGI = 5 + 2*NMC
C
10    CALL LRREFF(1,SS,AI,EOF)
      IF (EOF) GOTO 210
      IF (SS.LE.T1 .OR. SS.GT.T2) GOTO 10
      CALL LRREFM(1,LOGMSS)
      IF (LOGMSS(4).OR.LOGMSS(5)) GOTO 10
      IF (AI(5).EQ.0.) GOTO 10
      IA(1) = NINT(AI(1))
      IA(2) = NINT(AI(2))
      IA(3) = NINT(AI(3))
      J = 6
      DO 20 I = 1,NMC
        IF ((LOGMSS(J).OR.LOGMSS(J+1))) THEN
           WRITE (6,'(/A,3I4,A)') 
     +        ' **** WARNING 3*** Reflection ',
     +        IA(1),IA(2),IA(3),' has some FC PC missing!'
           GO TO 10
        ENDIF
        J = J + 2
20    CONTINUE

      NU = NU + 1
      DO 35 J=4,NLPRGI
         IA(J) = NINT(AI(J))
35    CONTINUE
      CALL MULEPS(IA,M,E)
      IF (MOD(NU,MU).EQ.0) THEN
        IF (NMC.LE.6) THEN
          WRITE (6,'(1X,3I4,17I6)')
     &         (IA(I),I=1,3),NINT(10000.*SS),(IA(I),I=4,NLPRGI),M,NU
        ELSEIF (NMC.LE.12) THEN
          WRITE (6,'(1X,3I4,15I6/31X,14I6)')
     &         (IA(I),I=1,3),NINT(10000.*SS),(IA(I),I=4,NLPRGI),M,NU
        ELSE
          WRITE (6,'(1X,3I4,15I6,3(/31X,12I6),2I6)')
     &         (IA(I),I=1,3),NINT(10000.*SS),(IA(I),I=4,NLPRGI),M,NU
        ENDIF
      ENDIF
C
      F = REAL(M)/NG
      Q = SS*SQRT(SS)
      EP = AI(4)
      SP = FSPLIN(Q,Q1,Q2,SFP,NS,JP,CP)
      EP = EP*EP/ (E*SP)
      SCP = SCP + F*EP
      NR = NR + M
C
C==== Calculate structure factor for known part.
C
      C = (0.,0.)
      SF = 0.
      J = 6
      DO 70 INC = 1,NNC
        DO 65 I = 1,NG
            IF (ITV(INC).LT.0) THEN
              CALL GENEQ(IS(1,1,I),IA,IH)
              PCP = DTR*AI(J+1)
              DO 40 L = 1,3
40              PCP = PCP + IH(L)*TV(L,INC) + IA(L)*D(L,I)
              PCP = MOD(PCP,PI2)
              C = C + AI(J)*CMPLX(COS(PCP),SIN(PCP))
            ELSEIF (ITV(INC).EQ.0) THEN
              SF = SF + AI(J)**2
            ELSE
              CALL GENEQ(IS(1,1,I),IA,ID(1,I))
              FD(I) = AI(J)
              SF = SF + FD(I)**2
              PH(I) = DTR*AI(J+1)
              DO 50 L = 1,3
50              PH(I) = PH(I) + IA(L)*D(L,I)
              PH(I) = MOD(PH(I),PI2)
            ENDIF
65        J = J + 2
70    CONTINUE
C
      SC = FSPLIN(Q,Q1,Q2,SFC,NS,JC,CC)
      SE = (SF+ABS(C)**2/E)/SC
      IF (.NOT.LSP) EP = EP - SE
      SCC = SCC + F*SE
      IF (MOD(NU,MU).EQ.0) WRITE (6,'(1X,2I4,9(1PE12.3))')
     &JP,JC,SFP(JP),SFC(JC),Q,SP,SC,E,EP,SF,SE
      IF (LSP) F01 = F01 + 1000.*F*EP*SE
      F02 = F02 + .001*F*SF
C
      DO 180 K = 2,NG
        DO 180 L = 1,K-1
          DO 80 J = 1,3
80          IH(J) = ID(J,L) - ID(J,K)
          DP = PH(K) - PH(L)
          C2 = .001*F*FD(K)*FD(L)*CMPLX(COS(DP),SIN(DP))
          C1 = 1.E6*EP*C2/SC
C
          DO 90 J = 3,1,-1
            IF (IH(J).GT.0) GOTO 120
90          IF (IH(J).LT.0) GOTO 100
          F01 = F01 + 2.*REAL(C1)
          F02 = F02 + 2.*REAL(C2)
          I = 0
          I1 = 0
          I2 = 0
          GOTO 170
C
  100     DO 110 I = 1,J
110         IH(I) = -IH(I)
          C1 = CONJG(C1)
          C2 = CONJG(C2)
C
C--  H,K,0
C
  120     IF (LTEST(1,LG) .AND. IH(3).EQ.0) THEN
            I1 = IH(1)
            I2 = IH(2)
            IF (LD1) THEN
              IF (MOD(I1,2).NE.0 .OR. MOD(I2,2).NE.0) GOTO 130
              I1 = I1/2
              I2 = I2/2
            ENDIF
            I1 = I1 + IC(1)
            I2 = I2 + 1
            KM(1) = MAX(I1,KM(1))
            LM(1) = MAX(I2,LM(1))
            I = 1
            IF (I1.LE.0 .OR. I1.GT.KC(1) .OR. I2.GT.LC(1)) GOTO 200
            C11(I1,I2) = C11(I1,I2) + C1
            C12(I1,I2) = C12(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  H,0,L
C
  130     IF (LTEST(2,LG) .AND. IH(2).EQ.0) THEN
            I1 = IH(1)
            I2 = IH(3)
            IF (LD2) THEN
              IF (MOD(I1,2).NE.0) GOTO 140
              I1 = I1/2
            ENDIF
            IF (LD3) THEN
              IF (MOD(I2,2).NE.0) GOTO 140
              I2 = I2/2
            ENDIF
            I1 = I1 + IC(2)
            I2 = I2 + 1
            KM(2) = MAX(I1,KM(2))
            LM(2) = MAX(I2,LM(2))
            I = 2
            IF (I1.LE.0 .OR. I1.GT.KC(2) .OR. I2.GT.LC(2)) GOTO 200
            C21(I1,I2) = C21(I1,I2) + C1
            C22(I1,I2) = C22(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  0,K,L
C
140       IF (LTEST(3,LG) .AND. IH(1).EQ.0) THEN
            I1 = IH(2)
            I2 = IH(3)
            IF (LD2) THEN
              IF (MOD(I1,2).NE.0) GOTO 160
              I1 = I1/2
            ENDIF
            IF (LD3) THEN
              IF (MOD(I2,2).NE.0) GOTO 160
              I2 = I2/2
            ENDIF
            I1 = I1 + IC(3)
            I2 = I2 + 1
            KM(3) = MAX(I1,KM(3))
            LM(3) = MAX(I2,LM(3))
            I = 3
            IF (I1.LE.0 .OR. I1.GT.KC(3) .OR. I2.GT.LC(3)) GOTO 200
            C31(I1,I2) = C31(I1,I2) + C1
            C32(I1,I2) = C32(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  H,H,2L
C
  160     IF (LTEST(4,LG) .AND. IH(1)-IH(2).EQ.0 .AND.
     &        MOD(IH(3),2).EQ.0) THEN
            I1 = IH(1) + IC(4)
            I2 = IH(3)/2 + 1
            KM(4) = MAX(I1,KM(4))
            LM(4) = MAX(I2,LM(4))
            I = 4
            IF (I1.LE.0 .OR. I1.GT.KC(4) .OR. I2.GT.LC(4)) GOTO 200
            C41(I1,I2) = C41(I1,I2) + C1
            C42(I1,I2) = C42(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  H,-H,2L
C
          IF (LTEST(5,LG) .AND. IH(1)+IH(2).EQ.0 .AND.
     &             MOD(IH(3),2).EQ.0) THEN
            I1 = IH(1) + IC(5)
            I2 = IH(3)/2 + 1
            KM(5) = MAX(I1,KM(5))
            LM(5) = MAX(I2,LM(5))
            I = 5
            IF (I1.LE.0 .OR. I1.GT.KC(5) .OR. I2.GT.LC(5)) GOTO 200
            C51(I1,I2) = C51(I1,I2) + C1
            C52(I1,I2) = C52(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  2H,-H,2L
C
          IF (LTEST(6,LG) .AND. IH(1)+2*IH(2).EQ.0 .AND.
     &             MOD(IH(3),2).EQ.0) THEN
            I1 = IH(2) + IC(6)
            I2 = IH(3)/2 + 1
            KM(6) = MAX(I1,KM(6))
            LM(6) = MAX(I2,LM(6))
            I = 6
            IF (I1.LE.0 .OR. I1.GT.KC(6) .OR. I2.GT.LC(6)) GOTO 200
            C61(I1,I2) = C61(I1,I2) + C1
            C62(I1,I2) = C62(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  -H,2H,2L
C
          IF (LTEST(7,LG) .AND. 2*IH(1)+IH(2).EQ.0 .AND.
     &             MOD(IH(3),2).EQ.0) THEN
            I1 = IH(1) + IC(7)
            I2 = IH(3)/2 + 1
            KM(7) = MAX(I1,KM(7))
            LM(7) = MAX(I2,LM(7))
            I = 7
            IF (I1.LE.0 .OR. I1.GT.KC(7) .OR. I2.GT.LC(7)) GOTO 200
            C71(I1,I2) = C71(I1,I2) + C1
            C72(I1,I2) = C72(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  H,2K,H
C
          IF (LTEST(8,LG) .AND. IH(1)-IH(3).EQ.0 .AND.
     &             MOD(IH(2),2).EQ.0) THEN
            I1 = IH(2)/2 + IC(8)
            I2 = IH(3) + 1
            KM(8) = MAX(I1,KM(8))
            LM(8) = MAX(I2,LM(8))
            I = 8
            IF (I1.LE.0 .OR. I1.GT.KC(8) .OR. I2.GT.LC(8)) GOTO 200
            C81(I1,I2) = C81(I1,I2) + C1
            C82(I1,I2) = C82(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  -H,2K,H
C
          IF (LTEST(9,LG) .AND. IH(1)+IH(3).EQ.0 .AND.
     &             MOD(IH(2),2).EQ.0) THEN
            I1 = IH(2)/2 + IC(9)
            I2 = IH(3) + 1
            KM(9) = MAX(I1,KM(9))
            LM(9) = MAX(I2,LM(9))
            I = 9
            IF (I1.LE.0 .OR. I1.GT.KC(9) .OR. I2.GT.LC(9)) GOTO 200
            C91(I1,I2) = C91(I1,I2) + C1
            C92(I1,I2) = C92(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  2H,K,K
C
          IF (LTEST(10,LG) .AND. IH(2)-IH(3).EQ.0 .AND.
     &             MOD(IH(1),2).EQ.0) THEN
            I1 = IH(1)/2 + IC(10)
            I2 = IH(3) + 1
            KM(10) = MAX(I1,KM(10))
            LM(10) = MAX(I2,LM(10))
            I = 10
            IF (I1.LE.0 .OR. I1.GT.KC(10) .OR. I2.GT.LC(10)) GOTO 200
            C101(I1,I2) = C101(I1,I2) + C1
            C102(I1,I2) = C102(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  2H,-K,K
C
          IF (LTEST(11,LG) .AND. IH(2)+IH(3).EQ.0 .AND.
     &             MOD(IH(1),2).EQ.0) THEN
            I1 = IH(1)/2 + IC(11)
            I2 = IH(3) + 1
            KM(11) = MAX(I1,KM(11))
            LM(11) = MAX(I2,LM(11))
            I = 11
            IF (I1.LE.0 .OR. I1.GT.KC(11) .OR. I2.GT.LC(11)) GOTO 200
            C111(I1,I2) = C111(I1,I2) + C1
            C112(I1,I2) = C112(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  H,K,-H-K
C
          IF (LTEST(12,LG) .AND. IH(1)+IH(2)+IH(3).EQ.0) THEN
            I1 = IH(1) + IC(12)
            I2 = IH(3) + 1
            KM(12) = MAX(I1,KM(12))
            LM(12) = MAX(I2,LM(12))
            I = 12
            IF (I1.LE.0 .OR. I1.GT.KC(12) .OR. I2.GT.LC(12)) GOTO 200
            C121(I1,I2) = C121(I1,I2) + C1
            C122(I1,I2) = C122(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  H,K,H+K
C
          IF (LTEST(13,LG) .AND. IH(1)+IH(2)-IH(3).EQ.0) THEN
            I1 = IH(1) + IC(13)
            I2 = IH(3) + 1
            KM(13) = MAX(I1,KM(13))
            LM(13) = MAX(I2,LM(13))
            I = 13
            IF (I1.LE.0 .OR. I1.GT.KC(13) .OR. I2.GT.LC(13)) GOTO 200
            C131(I1,I2) = C131(I1,I2) + C1
            C132(I1,I2) = C132(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  H,K,-H+K
C
          IF (LTEST(14,LG) .AND. IH(1)-IH(2)+IH(3).EQ.0) THEN
            I1 = IH(1) + IC(14)
            I2 = IH(3) + 1
            KM(14) = MAX(I1,KM(14))
            LM(14) = MAX(I2,LM(14))
            I = 14
            IF (I1.LE.0 .OR. I1.GT.KC(14) .OR. I2.GT.LC(14)) GOTO 200
            C141(I1,I2) = C141(I1,I2) + C1
            C142(I1,I2) = C142(I1,I2) + C2
            GOTO 170
          ENDIF
C
C--  H,K,H-K
C
          IF (LTEST(15,LG) .AND. -IH(1)+IH(2)+IH(3).EQ.0) THEN
            I1 = IH(1) + IC(15)
            I2 = IH(3) + 1
            KM(15) = MAX(I1,KM(15))
            LM(15) = MAX(I2,LM(15))
            I = 15
            IF (I1.LE.0 .OR. I1.GT.KC(15) .OR. I2.GT.LC(15)) GOTO 200
            C151(I1,I2) = C151(I1,I2) + C1
            C152(I1,I2) = C152(I1,I2) + C2
            GOTO 170
          ENDIF
          WRITE (6,'(A,3(3I5,5X))')
     &    ' ****** ERROR GENERATING EQUIVALENT REFL.',
     &    (IA(I),I=1,3),IH,K,L
          CALL CCPERR(1,'*** ERROR ***')
C
  170     IF (MOD(NU,MU).EQ.0) THEN
            DP = MOD(DP/DTR,360.)
            IF (ABS(DP).GT.180.) DP = DP - SIGN(360.,DP)
            WRITE (6,'(1X,3I4,5X,3I4,5X,2I4,5X,F8.1,5X,4F10.1)')
     &      K,L,I,IH,I1,I2,DP,C1,C2
          ENDIF
  180     CONTINUE
      GOTO 10
C
  200 WRITE (6,'(A,4(3I4,5X))')
     &' ***** PROGRAMMING ERROR - ARRAY BOUNDS:',
     &(IA(I),I=1,3),IH,K,L,I,I1,I2
      GOTO 10
C
210   SCC = SQRT(SCC/SCP)
      WRITE (6,'(/A,F10.6)') ' CHECK SCALE =',SCC
      IF (.NOT.LSP) F01 = 0.
C      IF (IU.EQ.1) THEN
C        C11(IC(1),1)=CMPLX(F01,0.)
C        C12(IC(1),1)=CMPLX(F02,0.)
C      ELSEIF (IU.EQ.2) THEN
C        C21(IC(2),1)=CMPLX(F01,0.)
C        C22(IC(2),1)=CMPLX(F02,0.)
C      ELSE
C        C31(IC(3),1)=CMPLX(F01,0.)
C        C32(IC(3),1)=CMPLX(F02,0.)
C      ENDIF
C
      WRITE (6,'(///A/)') ' ARRAY NO    ARRAY BOUNDS            USED'
      KE = 0
      DO 220 I = 1,15
        IF (LTEST(I,LG)) THEN
          WRITE (6,'(1X,I8,4X,2I6,4X,2I6)') I,KC(I),LC(I),KM(I),LM(I)
          IF (KM(I).GT.KC(I) .OR. LM(I).GT.LC(I)) KE = KE + 1
        ENDIF
  220 CONTINUE
      IF (KE.GT.0) CALL CCPERR(1,
     &'*** ERROR: Array bound check - RUN TERMINATED')
C
C----PASS 4 - PUT NON-ZERO ARRAY ELEMENTS OUT TO DISC FOR FFT.
C
C     ================================================
      CALL GWOPEN(NLPRGO,LSPRGO,CTPRGO,XNAME,DNAME,TI1,TI2(LG),CELL,0)
C     ================================================
C
C     ================================================
      CALL LRCLOS(1)
C     ================================================
C
C     ================================================
      CALL LWSYMM(1,1,1,RTS,SGN(:1),1,SGN,PGN)
C     ================================================
C
      DO 390 J = 1,3
        IM1(J) = 0
390     IM2(J) = 0
C
C--  H,K,0
C
      IF (LTEST(1,LG)) THEN
        NC = 0
        IA(3) = 0
        DO 400 I = 1,KC(1)
          IA(1) = I - IC(1)
          IF (LD1) IA(1) = 2*IA(1)
          DO 400 J = 1,LC(1)
            IA(2) = J - 1
            IF (LD1) IA(2) = 2*IA(2)
400         CALL PUTREF(IA,C11(I,J),C12(I,J))
        NCA(1) = NC
      ENDIF
C
C--  H,0,L
C
      IF (LTEST(2,LG)) THEN
        NC = 0
        IA(2) = 0
        DO 420 I = 1,KC(2)
          IA(1) = I - IC(2)
          IF (LD2) IA(1) = 2*IA(1)
          DO 420 J = 1,LC(2)
            IA(3) = J - 1
            IF (LD3) IA(3) = 2*IA(3)
420         CALL PUTREF(IA,C21(I,J),C22(I,J))
        NCA(2) = NC
      ENDIF
C
C--  0,K,L
C
      IF (LTEST(3,LG)) THEN
        NC = 0
        IA(1) = 0
        DO 440 I = 1,KC(3)
          IA(2) = I - IC(3)
          IF (LD2) IA(2) = 2*IA(2)
          DO 440 J = 1,LC(3)
            IA(3) = J - 1
            IF (LD3) IA(3) = 2*IA(3)
440         CALL PUTREF(IA,C31(I,J),C32(I,J))
        NCA(3) = NC
      ENDIF
C
C--  H,H,2L
C
      IF (LTEST(4,LG)) THEN
        NC = 0
        DO 460 I = 1,KC(4)
          IA(1) = I - IC(4)
          IA(2) = IA(1)
          DO 460 J = 1,LC(4)
            IA(3) = 2*(J-1)
460         CALL PUTREF(IA,C41(I,J),C42(I,J))
        NCA(4) = NC
      ENDIF
C
C--  H,-H,2L
C
      IF (LTEST(5,LG)) THEN
        NC = 0
        DO 480 I = 1,KC(5)
          IA(1) = I - IC(5)
          IA(2) = -IA(1)
          DO 480 J = 1,LC(5)
            IA(3) = 2*(J-1)
480         CALL PUTREF(IA,C51(I,J),C52(I,J))
        NCA(5) = NC
      ENDIF
C
C--2H,-H,2L
C
      IF (LTEST(6,LG)) THEN
        NC = 0
        DO 500 I = 1,KC(6)
          IA(2) = I - IC(6)
          IA(1) = -2*IA(2)
          DO 500 J = 1,LC(6)
            IA(3) = 2*(J-1)
500         CALL PUTREF(IA,C61(I,J),C62(I,J))
        NCA(6) = NC
      ENDIF
C
C--  -H,2H,2L
C
      IF (LTEST(7,LG)) THEN
        NC = 0
        DO 520 I = 1,KC(7)
          IA(1) = I - IC(7)
          IA(2) = -2*IA(1)
          DO 520 J = 1,LC(7)
            IA(3) = 2*(J-1)
520         CALL PUTREF(IA,C71(I,J),C72(I,J))
        NCA(7) = NC
      ENDIF
C
C--  H,2K,H
C
      IF (LTEST(8,LG)) THEN
        NC = 0
        DO 540 I = 1,KC(8)
          IA(2) = 2*(I-IC(8))
          DO 540 J = 1,LC(8)
            IA(3) = J - 1
            IA(1) = IA(3)
540         CALL PUTREF(IA,C81(I,J),C82(I,J))
        NCA(8) = NC
      ENDIF
C
C--  -H,2K,H
C
      IF (LTEST(9,LG)) THEN
        NC = 0
        DO 560 I = 1,KC(9)
          IA(2) = 2*(I-IC(9))
          DO 560 J = 1,LC(9)
            IA(3) = J - 1
            IA(1) = -IA(3)
560         CALL PUTREF(IA,C91(I,J),C92(I,J))
        NCA(9) = NC
      ENDIF
C
C--  2H,K,K
C
      IF (LTEST(10,LG)) THEN
        NC = 0
        DO 580 I = 1,KC(10)
          IA(1) = 2*(I-IC(10))
          DO 580 J = 1,LC(10)
            IA(3) = J - 1
            IA(2) = IA(3)
580         CALL PUTREF(IA,C101(I,J),C102(I,J))
        NCA(10) = NC
      ENDIF
C
C--  2H,-K,K
C
      IF (LTEST(11,LG)) THEN
        NC = 0
        DO 600 I = 1,KC(11)
          IA(1) = 2*(I-IC(11))
          DO 600 J = 1,LC(11)
            IA(3) = J - 1
            IA(2) = -IA(3)
600         CALL PUTREF(IA,C111(I,J),C112(I,J))
        NCA(11) = NC
      ENDIF
C
C--  H,K,-H-K
C
      IF (LTEST(12,LG)) THEN
        NC = 0
        DO 620 I = 1,KC(12)
          IA(1) = I - IC(12)
          DO 620 J = 1,LC(12)
            IA(3) = J - 1
            IA(2) = -IA(1) - IA(3)
620         CALL PUTREF(IA,C121(I,J),C122(I,J))
        NCA(12) = NC
      ENDIF
C
C--  H,K,H+K
C
      IF (LTEST(13,LG)) THEN
        NC = 0
        DO 640 I = 1,KC(13)
          IA(1) = I - IC(13)
          DO 640 J = 1,LC(13)
            IA(3) = J - 1
            IA(2) = -IA(1) + IA(3)
640         CALL PUTREF(IA,C131(I,J),C132(I,J))
        NCA(13) = NC
      ENDIF
C
C--  H,K,-H+K
C
      IF (LTEST(14,LG)) THEN
        NC = 0
        DO 660 I = 1,KC(14)
          IA(1) = I - IC(14)
          DO 660 J = 1,LC(14)
            IA(3) = J - 1
            IA(2) = IA(1) + IA(3)
660         CALL PUTREF(IA,C141(I,J),C142(I,J))
        NCA(14) = NC
      ENDIF
C
C--  H,K,H-K
C
      IF (LTEST(15,LG)) THEN
        NC = 0
        DO 680 I = 1,KC(15)
          IA(1) = I - IC(15)
          DO 680 J = 1,LC(15)
            IA(3) = J - 1
            IA(2) = IA(1) - IA(3)
680         CALL PUTREF(IA,C151(I,J),C152(I,J))
        NCA(15) = NC
      ENDIF
C
      CALL LWCLOS(1,1)
      WRITE (6,'(//A)') ' NUMBER OF REFLECTIONS BY ZONES'
      DO 700 I = 1,15
700     IF (LTEST(I,LG)) WRITE (6,'(A,I3,2X,A,I8)')
     &  ' ZONE',I,ZONE(I),NCA(I)
      SFF1 = SQRT(2.*SFF1)
      SFF2 = SQRT(2.*SFF2)
      WRITE (6,'(//A,I8,2(/A,3I4,5X,A,2(1PE12.3),5X,A,1PE12.3))')
     &' NO OF REFLNS OUTPUT =',NW,
     &' T-FUNCTION MAX HKL =',IM1,'MAX A,B =',AM1,BM1,
     &'SQRT(SUM F**2) =',SFF1,
     &' O-FUNCTION MAX HKL =',IM2,'MAX A,B =',AM2,BM2,
     &'SQRT(SUM F**2) =',SFF2
      WRITE (6,'(//A,2(1PE12.3))') ' F000 TERMS :',F01,F02
      END
C
C
      REAL FUNCTION FSPLIN(X,XO,XD,YA,N,J,C)
C     ====================
C
C----CUBIC SPLINE INTERPOLATION.
C----X  = INTERPOLATION POINT IN X.
C----XO = FIRST SAMPLE POINT IN X.
C----XD = INCREMENT IN X BETWEEN SAMPLE POINTS.
C----YA = ARRAY OF N SAMPLE POINTS IN Y.
C----N  = NUMBER OF SAMPLE POINTS.
C----J  = RETURNED ARRAY INDEX. MUST BE SET TO ZERO BEFORE FIRST CALL.
C----C  = RETURNED ARRAY OF 4 CUBIC COEFFICIENTS. J AND C MUST NOT BE
C         MODIFIED BETWEEN CALLS.
C----FSPLIN = INTERPOLATED VALUE IN Y.
C
C
      IMPLICIT NONE
C     .. Scalar Arguments ..
      INTEGER J,N
      REAL X,XD,XO
C     ..
C     .. Array Arguments ..
      REAL C(4),YA(N)
C     ..
C     .. Local Scalars ..
      INTEGER I,I1
      REAL G1,G2,S,U0,U1,U2,V0,V1,V2,X1,XD2,YD,YD1
C     ..
      IF (N.LE.2) THEN
        J = 1
        IF (N.EQ.1) THEN
          FSPLIN = YA(1)
        ELSE
          FSPLIN = YA(1) + (YA(2)-YA(1))*(X-XO)/XD
        ENDIF
      ELSE
C----COMPUTE WHICH INTERVAL TO USE.
        I = MIN(MAX(INT((X-XO)/XD),0)+1,N-1)
        X1 = XO + (I-1)*XD
C----SAME AS LAST CALL ?
        IF (I.NE.J) THEN
C----NO, RESET FOR NEXT CALL.
          J = I
C
C----COMPUTE WEIGHTED DISPLACEMENT VECTOR (U1,V1) BETWEEN I AND I+1.
          XD2 = XD*XD
          I1 = I + 1
          YD1 = YA(I1) - YA(I)
          S = XD2 + YD1*YD1
          U1 = XD/S
          V1 = YD1/S
          C(1) = YA(I)
C
          IF (I.GT.1) THEN
C----COMPUTE VECTOR (U0,V0) BETWEEN I-1 AND I, AND GRADIENT G1 AT I.
            YD = YA(I) - YA(I-1)
            S = XD2 + YD*YD
            U0 = XD/S
            V0 = YD/S
            G1 = (V0+V1)/ (U0+U1)
C
            IF (I1.EQ.N) GOTO 10
          ENDIF
C----COMPUTE VECTOR (U2,V2) BETWEEN I+1 AND I+2, AND GRADIENT G2 AT I+1.
          YD = YA(I1+1) - YA(I1)
          S = XD2 + YD*YD 
          U2 = XD/S
          V2 = YD/S
          G2 = (V1+V2)/ (U1+U2)
C
          IF (I.EQ.1) THEN
C----CASE OF FIRST INTERVAL, COMPUTE QUADRATIC COEFFIENTS.
            C(2) = YD1/XD
            C(3) = G2 - C(2)
            C(2) = C(2) - C(3)
            C(3) = C(3)/XD
            C(4) = 0.
          ELSE
C----GENERAL CASE, COMPUTE CUBIC COEFFICENTS.
            C(2) = G1
            C(3) = YD1/XD
            C(4) = G1 + G2 - 2.*C(3)
            C(3) = (C(3)-C(4)-G1)/XD
            C(4) = C(4)/XD2
          ENDIF
          GOTO 20
C
C----CASE OF LAST INTERVAL, COMPUTE QUADRATIC COEFFICIENTS.
10        C(2) = G1
          C(3) = (YD1/XD-G1)/XD
          C(4) = 0.
        ENDIF
C
C----COMPUTE FUNCTION VALUE AND RETURN.
20      S = X - X1
        FSPLIN = C(1) + S*(C(2)+S*(C(3)+S*C(4)))
      ENDIF
      END
C
C
      SUBROUTINE GWOPEN(NLPRGO,LSPRGO,CTPRGO,XNAME,DNAME,
     +                               FTITLE,HTITLE,CELL,IFLAB)
C     =================
C
      IMPLICIT NONE
C     .. Scalar Arguments ..
      INTEGER IFLAB,NLPRGO
      CHARACTER XNAME*(*),DNAME*(*)
C     ..
C     .. Array Arguments ..
      CHARACTER LSPRGO(NLPRGO)*(*),CTPRGO(NLPRGO)*(*),
     +          FTITLE*(*),HTITLE*(*)
      REAL CELL(*)
C     ..
C     .. Local Scalars ..
      INTEGER IND,IFTIT,I
C     ..
C     .. Local Arrays ..
      INTEGER MCOLS
      PARAMETER (MCOLS=500)
      CHARACTER*64 XNAME_OUT(MCOLS),DNAME_OUT(MCOLS)
C     ..
C     .. Data statements ..
      DATA IND /1/, IFTIT/0/
C     ..
C
      DO I = 1,NLPRGO
        XNAME_OUT(I) = XNAME
        DNAME_OUT(I) = DNAME
      ENDDO

C     ===========================
      CALL LWOPEN(IND,'HKLOUT')
C     ===========================
C
      IF (IFLAB.EQ.0) THEN
C
C       =========================================
        CALL LWCLAB(IND,LSPRGO,NLPRGO,CTPRGO,0)
C       =========================================
C
        CALL LWIDASX(IND,NLPRGO,XNAME_OUT,DNAME_OUT,0)

C       =======================
        CALL LWCELL(IND,CELL)
C       =======================
C
      ELSE
C
C       =========================================
        CALL LWASSN(IND,LSPRGO,NLPRGO,CTPRGO,1)
C       =========================================

        CALL LWIDASX(IND,NLPRGO,XNAME_OUT,DNAME_OUT,1)
C
      ENDIF
C
C     ===============================
      CALL LWTITL(IND,FTITLE,IFTIT)
C     ===============================
C
      CALL LWHSTL (IND, HTITLE)
C
      END
C
C
      SUBROUTINE PUTREF(IH,C1,C2)
C     =================
C
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER MCOLS,MNC
      PARAMETER (MCOLS=500,MNC=14)
C     ..
C     .. Scalar Arguments ..
      COMPLEX C1,C2
C     ..
C     .. Array Arguments ..
      INTEGER IH(3)
C     ..
C     .. Scalars in Common ..
      LOGICAL LFP,LFS,LSP
      INTEGER ICP,IDP,IU,LG,LIST,MU,NC,NG,NMC,NNC,NS,NW
      REAL AM1,AM2,BM1,BM2,Q1,Q2,SFF1,SFF2,T1,T2
C     ..
C     .. Arrays in Common ..
      LOGICAL LTEST
      INTEGER IC,IM1,IM2,IPG,IS,ITV,KC,LC
      REAL AI,CELL,D,SFC,SFP,RTS,TV
C     ..
C     .. Local Scalars ..
      INTEGER I
C     ..
C     .. Local Arrays ..
      REAL AO(7)
C     ..
C     .. Common blocks ..
      COMMON /INCOM/ IS(3,3,24),ITV(MNC),
     &       CELL(6),D(3,24),RTS(4,4,96),TV(3,MNC),
     &       ICP,IDP,LFP,LFS,LG,LIST,LSP,NC,NG,NMC,NNC,NS,T1,T2
      COMMON /TFCOM/ LTEST(15,11),IC(15),IM1(3),IM2(3),IPG(24,24),
     &       KC(15),LC(15),AI(MCOLS),SFC(400),SFP(400),
     &       IU,MU,NW,AM1,BM1,AM2,BM2,Q1,Q2,SFF1,SFF2
C     ..
      AO(4) = REAL(C1)
      AO(5) = AIMAG(C1)
      AO(6) = REAL(C2)
      AO(7) = AIMAG(C2)
      IF (AO(4).EQ.0. .AND. AO(5).EQ.0. .AND. AO(6).EQ.0. .AND.
     &    AO(7).EQ.0.) RETURN
      DO 5 I=1,3
5       AO(I) = IH(I)
      CALL LWREFL(1,AO)
      IF (LIST.GT.0 .AND. NC.EQ.0) WRITE(6,'(////)')
      NC = NC + 1
      IF (NC.LE.LIST)
     &WRITE (6,'(1X,3I4,4F8.0)') IH,(AO(I),I=4,7)
      NW = NW + 1
      IF (AO(4).NE.0. .OR. AO(5).NE.0.) THEN
        DO 10 I = 1,3
10        IM1(I) = MAX(ABS(IH(I)),IM1(I))
        AM1 = MAX(ABS(AO(4)),AM1)
        BM1 = MAX(ABS(AO(5)),BM1)
        SFF1 = SFF1 + ABS(C1)**2
      ENDIF
      IF (AO(6).NE.0. .OR. AO(7).NE.0.) THEN
        DO 20 I = 1,3
20        IM2(I) = MAX(ABS(IH(I)),IM2(I))
        AM2 = MAX(ABS(AO(6)),AM2)
        BM2 = MAX(ABS(AO(7)),BM2)
        SFF2 = SFF2 + ABS(C2)**2
      ENDIF
      END
C
C
      SUBROUTINE TFPART
C     =================
C
      IMPLICIT NONE
C     .. Parameters ..
      INTEGER MCOLS,MNC
      PARAMETER (MCOLS=500,MNC=14)
      REAL PI,PI2,DTR
      PARAMETER (PI=3.141592654, PI2=2.*PI, DTR=PI/180.)
C     ..
C     .. Scalars in Common ..
      CHARACTER TI1*70,TI3*70,XNAME*64,DNAME*64
      LOGICAL LFP,LFS,LSP
      INTEGER ICP,IDP,IU,LG,LIST,MU,NC,NG,NMC,NNC,NS,NW
      REAL AM1,AM2,BM1,BM2,Q1,Q2,SFF1,SFF2,T1,T2
C     ..
C     .. Arrays in Common ..
      CHARACTER TI2*70
      LOGICAL LTEST
      INTEGER IC,IM1,IM2,IPG,IS,ITV,KC,LC
      REAL AI,CELL,D,SFC,SFP,RTS,TV
C     ..
C     .. Local Scalars ..
      CHARACTER SGN*10,PGN*10
      LOGICAL EOF
      INTEGER I,INC,J,JC,JCP,JDP,JP,K,L,M,NLPRGI,NLPRGO,NR,NU
      REAL DP,E,EP,F,F01,F02,FCP,PCP,Q,SC,SE,SF,SP,SS
      COMPLEX C,C1,C2
C     ..
C     .. Local Arrays ..
      CHARACTER LSPRGO(7)*30,CTPRGO(7)*1
      INTEGER IA(MCOLS),IH(3)
      REAL CC(4),CP(4),FC(24),FD(24),PC(24),PD(24)
      LOGICAL LOGMSS(MCOLS)
C     ..
C     .. External functions ..
      REAL FSPLIN
C     ..
C     .. Common blocks ..
      COMMON /INCOMC/ TI1,XNAME,DNAME
      COMMON /TFCOMC/ TI2(11),TI3
      COMMON /INCOM/ IS(3,3,24),ITV(MNC),
     &       CELL(6),D(3,24),RTS(4,4,96),TV(3,MNC),
     &       ICP,IDP,LFP,LFS,LG,LIST,LSP,NC,NG,NMC,NNC,NS,T1,T2
      COMMON /TFCOM/ LTEST(15,11),IC(15),IM1(3),IM2(3),IPG(24,24),
     &       KC(15),LC(15),AI(MCOLS),SFC(400),SFP(400),
     &       IU,MU,NW,AM1,BM1,AM2,BM2,Q1,Q2,SFF1,SFF2
      SAVE /INCOMC/, /TFCOMC/
C     ..
C     .. Data statements ..
      DATA NLPRGO /7/
      DATA LSPRGO /'H','K','L','A','B','AO','BO'/
      DATA CTPRGO /'H','H','H','R','R','R','R'/
      DATA SGN,PGN /'P1','PG1'/
C     ..
C
C====  READ STRUCTURE FACTORS AGAIN, CALC TRANSLATION FUNCTION COEFFS.
C
      NC = 0
      NU = 0
      JP = 0
      JC = 0
      F01 = 0.
      F02 = 0.
      NR = 0
      NLPRGI = 5 + 2*NMC
C
C     ================================================
      CALL GWOPEN(NLPRGO,LSPRGO,CTPRGO,XNAME,DNAME,TI1,TI3,CELL,0)
C     ================================================
C
C     ================================================
      CALL LWSYMM(1,1,1,RTS,SGN(:1),1,SGN,PGN)
C     ================================================
C
C     ========================
10    CALL LRREFF(1,SS,AI,EOF)
C     ========================
C
      IF (EOF) GOTO 140
      IF (SS.LE.T1 .OR. SS.GT.T2) GOTO 10
      CALL LRREFM(1,LOGMSS)
      IF (LOGMSS(4).OR.LOGMSS(5)) GOTO 10
      IF (AI(5).EQ.0.) GOTO 10
      IA(1) = NINT(AI(1))
      IA(2) = NINT(AI(2))
      IA(3) = NINT(AI(3))
      J = 6
      DO 20 I = 1,NMC
        IF ((LOGMSS(J).OR.LOGMSS(J+1))) THEN
           WRITE (6,'(/A,3I4,A)') 
     +        ' **** WARNING 4*** Reflection ',
     +        IA(1),IA(2),IA(3),' has some FC PC missing!'
           GO TO 10
        ENDIF
        J = J + 2
20    CONTINUE

      NU = NU + 1
      DO 35 J = 4,NLPRGI
         IA(J) = NINT(AI(J))
35    CONTINUE
      CALL MULEPS(IA,M,E)
      IF (MOD(NU,MU).EQ.0) THEN
        J = 5 + 2*NMC
        IF (NMC.LE.6) THEN
          WRITE (6,'(1X,3I4,17I6)')
     &         (IA(I),I=1,3),NINT(10000.*SS),(IA(I),I=4,NLPRGI),M,NU
        ELSEIF (NMC.LE.12) THEN
          WRITE (6,'(1X,3I4,15I6/31X,14I6)')
     &         (IA(I),I=1,3),NINT(10000.*SS),(IA(I),I=4,NLPRGI),M,NU
        ELSE
          WRITE (6,'(1X,3I4,15I6,3(/31X,12I6),2I6)')
     &         (IA(I),I=1,3),NINT(10000.*SS),(IA(I),I=4,NLPRGI),M,NU
        ENDIF
      ENDIF
C
      F = REAL(M)/NG
      Q = SS*SQRT(SS)
      EP = AI(4)
      SP = FSPLIN(Q,Q1,Q2,SFP,NS,JP,CP)
      SC = FSPLIN(Q,Q1,Q2,SFC,NS,JC,CC)
      IF (.NOT.LFS) E = 1.
      EP = EP*EP/ (E*SP)
      NR = NR + M
C
C==== Calculate structure factor for known part.
C
      C = (0.,0.)
      SF = 0.
      J = 6
      DO 70 INC = 1,NNC
        DO 60 I = 1,NG
            IF (LFS) THEN
              IF (ITV(INC).LT.0) THEN
                CALL GENEQ(IS(1,1,I),IA,IH)
                PCP = DTR*AI(J+1)
                DO 40 L = 1,3
40                PCP = PCP + IH(L)*TV(L,INC) + IA(L)*D(L,I)
                PCP = MOD(PCP,PI2)
                C = C + AI(J)*CMPLX(COS(PCP),SIN(PCP))
              ELSEIF (ITV(INC).GT.0) THEN
                FD(I) = IA(J)
                SF = SF + FD(I)**2
                PD(I) = DTR*IA(J+1)
                DO 50 K = 1,3
50                PD(I) = PD(I) + IA(K)*D(K,I)
                PD(I) = MOD(PD(I),PI2)
              ELSE
                SF = SF + AI(J)**2
              ENDIF
            ELSE
              IF (ITV(INC).LT.0) THEN
                FC(I) = IA(J)
                PC(I) = DTR*IA(J+1)
              ELSEIF (ITV(INC).GT.0) THEN
                FD(I) = IA(J)
                PD(I) = DTR*IA(J+1)
              ENDIF
              SF = SF + AI(J)**2
            ENDIF
60        J = J + 2
70    CONTINUE
C
      IF (LFS) THEN
        FCP = CABS(C)
        PCP = 0.
        IF (FCP.GT.0.) PCP = ATAN2(AIMAG(C),REAL(C))
        SE = (SF+FCP**2/E)/SC
      ELSE
        SE = SF/SC
      ENDIF
      IF (.NOT.LSP) EP = EP - SE
      IF (LFS) THEN
        IF (LSP) F01 = F01 + 1000.*F*EP*FCP**2/(E*SC)
        F02 = F02 + .001*F*FCP**2
        IF (MOD(NU,MU).EQ.0) WRITE (6,'(1X,2I4,11(1PE11.3))')
     &  JP,JC,SFP(JP),SFC(JC),Q,SP,SC,E,EP,SF,SE,FCP,PCP
      ELSE
        IF (MOD(NU,MU).EQ.0) WRITE (6,'(1X,2I4,9(1PE11.3))')
     &  JP,JC,SFP(JP),SFC(JC),Q,SP,SC,E,EP,SF,SE
      ENDIF
C
C==== Compute translation function structure factor.
C
      DO 130 I = 1,NG
        CALL GENEQ(IS(1,1,I),IA,IH)
        IF (LFS) THEN
          DP = MOD(PCP-PD(I),PI2)
          C2 = .001*F*FCP*FD(I)*CMPLX(COS(DP),SIN(DP))
        ELSE
          JCP = IPG(I,ICP)
          JDP = IPG(I,IDP)
          FCP = FC(JCP)
          DP = PC(JCP) - PD(JDP)
          DO 75 K = 1,3
75          DP = DP + IH(K)*(TV(K,1)+D(K,ICP)-D(K,IDP))
          DP = MOD(DP,PI2)
          IF (MOD(NU,MU).EQ.0) WRITE (6,'(1X,3I4,4F10.3)')
     &    I,JCP,JDP,FCP,PC(JCP),FD(JDP),PD(JDP)
          C2 = .001*F*FCP*FD(JDP)*CMPLX(COS(DP),SIN(DP))
          IF (LSP) F01 = F01 + 1000.*F*EP*FCP**2/(E*SC)
          F02 = F02 + .001*F*FCP**2
        ENDIF
        C1 = 1.E6*EP*C2/(SC*SQRT(E))
C
        DO 80 K = 3,1,-1
          IF (IH(K).GT.0) GOTO 110
          IF (IH(K).LT.0) GOTO 90
80      CONTINUE
        F01 = F01 + 2.*REAL(C1)
        F02 = F02 + 2.*REAL(C2)
        GOTO 120
C
90      DO 100 J = 1,K
100       IH(J) = -IH(J)
        C1 = CONJG(C1)
        C2 = CONJG(C2)
C
110     CALL PUTREF(IH,C1,C2)
120     IF (MOD(NU,MU).EQ.0) THEN
          DP = DP/DTR
          IF (ABS(DP).GT.180.) DP = DP-SIGN(360.,DP)
          WRITE (6,'(1X,I4,5X,3I4,5X,F8.1,5X,4F10.1)')
     &    I,IH,DP,C1,C2
        ENDIF
130     CONTINUE
      GOTO 10
C
C     ================
140   CALL LWCLOS(1,1)
C     ================
C
      SFF1 = SQRT(2.*SFF1)
      SFF2 = SQRT(2.*SFF2)
      WRITE (6,'(//A,I8,2(/A,2(1PE12.3),8X,A,1PE12.3))')
     &' NO OF REFLNS OUTPUT =',NW,
     &' MAX A,B =',AM1,BM1,'SQRT(SUM F**2) =',SFF1,
     &' MAX A,B =',AM2,BM2,'SQRT(SUM F**2) =',SFF2
      IF (.NOT.LSP) F01 = 0.
      WRITE (6,'(//A,2(1PE12.3))') ' F000 TERMS :',F01,F02
      END
