C
C     WATNCS
C     Copyright (C) 1995 Guoguang Lu
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
c This program is to find out which peaks are non-crystallographic
c symmetric related in a peak list (put in a PDB file). It could be
c useful when you have patterson peaks or difference fourier peaks
c and want to check them if they are non-crystallographic symmetric each other.
c
c Guoguang Lu 7-jan-1995 Purdue Univ
c version wat 1.0 --- write out the chain name of NCS for restraint.
c 971019
c
c
      PROGRAM WATNCS
c
      parameter (maxwat = 10000)
      parameter (maxpro = 50000)
      real psu(3,4,48)
      real cell(6),deor(3,3),orth(3,3)
      real cells(6),deors(3,3),orths(3,3)
      logical*1 cont,wout(maxwat),check
      character*80 key,file,file1,file2
      character*40 fileloss
      character*40 word,symop
      character*4 atout,resout
      real xyz(3,MAXWAT),bfac(MAXWAT),occ(MAXWAT)
      real xyzp(3,MAXPRO),bfacp(MAXPRO),occp(MAXPRO)
      real sym(3,4,48)
      real b1(3),b2(3),b3(3),x1(3),x2(3),xxx(3,48)
      real err,xyzout(3,maxwat),cut(48)
      integer ieq(48),ieqatm(48),irem(48),next(48)
      logical cutoff
      character atmnam(MAXWAT)*4,resnam(MAXWAT)*4,seqnam(MAXWAT)*4
      character atmnamp(MAXPRO)*4,resnamp(MAXPRO)*4,seqnamp(MAXPRO)*4
      character ch2(maxpro)*1,cw*1,gr(48)*1,ftmp(48)*80,ch0(MAXWAT)*1
      character*1 ch(48)
      common/xclose/ xyzp
      common/nclose/ natomp
c...  data statements.  required after declarations by f2c
      data cell /1., 1., 1., 90., 90., 90./
      data cont /.false./,wout /maxwat*.false./,check /.false./
      data file1/'              '/,file2/'  '/
      data fileloss/'lost.pdb                                '/
      data atout/'    '/,resout/'    '/
      data sym /576*0./,err/0.60/
      data cutoff/.false./
      data ch /'W','U','V','X','Y','Z','S','T',40*' '/
C
        CALL CCPFYP
        CALL CCPRCS(6,'WATNCS','$Date: 2007/09/17 09:13:16 $')

      call ccpdpn(9,'CHAR.CHA','SCRATCH','F',0,0)

      cont = .false.
      inst = 0
      inst2 = 0
      il2 = 0
      ich = 0
      inon = 0
      npseu = 0
      temp = 0.
      occu = 0.
      nout = 0
      iext = 0
      nunse = 0
      write(6,*) 'Pick the non-crystallographic symmetric atoms in',
     1 ' the coordinate.'
c
5	read(5,'(a)',err=4,end=4) key
      if (key(1:1).eq.'!'.or.
     1   key(1:1).eq.'#'.or.
     2   key(1:1).eq.';') goto 5
      ln = lenstr(key)
      if (ln.eq.0) goto 5
c
      isp = index(key,' ')
      if (.not.cont) word(1:isp-1) = key(1:isp-1)
      call up(word(1:isp-1),isp-1)
      if (word(1:3).ne.'PDB'.and.word(1:3).ne.'OUT'.and.
     1   word(1:3).ne.'MOL'.and.word(1:3).ne.'LOS')
     2 call up(key(1:ln),ln)
      if (cont) then
       call lgg_string(9,ln,key(1:ln),npar,cont)
      else
       call lgg_string(9,ln-isp,key(isp+1:ln),npar,cont)
      end if
      if (key(ln:ln).eq.'-') then
       cont = .true.
       goto 5
      else
       cont = .false.
       rewind (9)
      end if
c
c
      if (word(1:4).eq.'CELL') then
       read(9,*) cell
       call lgg_crystal(cell,cells,deor,orth,deors,orths)
       write(6,'(a,3f8.2,3f8.1)') 'Cell dimension',cell
       write(6,'(a)') 'Orthogonalization matrix'
       write(6,15) ((orth(i,j),j=1,3),i=1,3)
       write(6,'(a)') 'deorthogonalization matrix'
       write(6,15) ((deor(i,j),j=1,3),i=1,3)
       goto 5
      end if
c
      if (word(1:3).eq.'PDB') then
       read(9,'(a)') file
c	 open(1,file=file,status='old',form='formatted')
       write(6,'(a,a)') ' Open file: ',file(1:ln-isp)
       goto 5
      end if
c
      if (word(1:3).eq.'OUT') then
       read(9,'(a)') file1
       call ccpdpn(10,file1,'unknown','F',0,0)
       write(6,'(a,a)') ' Open file: ',file1(1:ln-isp)
       goto 5
      end if
c
      if (word(1:3).eq.'LOS') then
       read(9,'(a)') fileloss
c	 open(10,file=fileloss,status='unknown',form='formatted')
       write(6,'(a,a)') ' Write unselected waters to: ',
     +    fileloss(1:ln-isp)
       goto 5
      end if
c
      if (word(1:3).eq.'MOL') then
       read(9,'(a)') file2
       il2 = lenstr(file2)
       write(6,'(a,a)') ' Open file: ',file2(1:il2),' for protein'
       goto 5
      end if
c
        if (word(1:3).eq.'GRO') then
       if (npar.lt.2) goto 9
       ngroup = ngroup + 1
       read(9,'(a)') CH(ngroup)
       read(9,'(a)') gr(ngroup)
       write(6,*) 'Water which belong to chain ',gr(ngroup),
     1 ' of the protein will have a chain name ',ch(ngroup)
       goto 5
      end if
c
      if (word(1:4).eq.'CHAI') then
24	 read(9,'(a)',end=25) CH(ich+1)
       ich = ich + 1
       goto 24
25	 continue
       write(6,*) ich,' chain names: ',(ch(i),' ',i=1,ich)
       goto 5
      end if
c
      if (word(1:4).eq.'TEMP') then
       read(9,*) temp
       write(6,*) 'Set B-factor of all atoms to ',temp
       goto 5
      end if
c
      if (word(1:4).eq.'OCCU') then
       read(9,*) occu
       write(6,*) 'Set occupancy of all atoms to ',occu
       goto 5
      end if
c
      if (word(1:4).eq.'NUMB') then
       read(9,*) inst
       write(6,*) 'Number start after ',inst
       goto 5
      end if
c
      if (word(1:4).eq.'NUM2') then
       read(9,*) inst2
       write(6,*) 'Number start after ',inst2
       goto 5
      end if
c
      if (word(1:4).eq.'ATOM') then
       read(9,'(a)') atout
       write(6,'(a,a)') 'Set all atom names to ',atout
       goto 5
      end if
c
      if (word(1:4).eq.'RESI') then
       read(9,'(a)') resout
       write(6,'(a,a)') 'Set all residue names to ',resout
       goto 5
      end if
c
      if (word(1:4).eq.'RELA') then
       npseu = npseu + 1
c	 read(9,*) ((psu(i,j,npseu),i=1,3),j=1,4)
       read(5,*) ((psu(i,j,npseu),i=1,3),j=1,4)
       write(6,*) 'Symmetry Operation:',npseu
       write(6,*) 'rotation'
       write(6,15) ((psu(i,j,npseu),j=1,3),i=1,3)
       write(6,*) 'Translation'
       write(6,15) (psu(i,4,npseu),i=1,3)
15	 format(5x,3f10.4)
       inleast = npseu
       goto 5 
      end if
c
      if (word(1:4).eq.'LEAS') then
       read(9,*) inleast
       write(6,*)
     +   'Water molecules will be output if NCS fit # is more than',
     +   inleast
       goto 5
      end if
c
      if (word(1:3).eq.'ERR') then
       read(9,*) err
       write(6,'(a,1x,f5.2,a)') 'Allowed error:',err,'A' 
       goto 5
      end if
c
      if (word(1:3).eq.'CUT') then
       ncut = npar
       cutoff = .true.
       write(6,'(2a)') 'New waters will be selected according to both',
     +   'peak height and number of satisfied NCS operations'
       write(6,*) 
     +       'This only applies to those which occ.ne.1.00 (new waters)'
       do i = 1, ncut
        read(9,*) cut(i)
        write(6,*) 'If a water satisfies',i,
     +    ' NCSs, its height must be higher than',cut(i)
       end do
       goto 5
      end if
c
c	IF (KEY(1:4).EQ.'SYMM') THEN
c	 SYMOP = KEY(I+1:I+40)
c	 NSYM=NSYM+1
c	 IF (MATSYM(SYM(1,1,NSYM),%REF(SYMOP),ICOL).EQ.0) GOTO 5
c	 WRITE(6,*) 'Error in symop after colunm ',ICOL
c	 stop
c	END IF
c
9	 continue
       write(6,*) 'Unrecognized command',KEY
      goto 5
c
4	continue
c
c	call invrt(npseu,psu(1,1,1),psu(1,1,npseu))
      write(6,*) npseu,' operations have been applied'
c	npold = npseu
c	npseu = npseu*2
c	do ipseu = 1, npseu
c	 write(6,*) 'NDS symmetry',ipseu
c	 write(6,'(3f10.4)') ((psu(i,j,ipseu),i=1,3),j=1,3)
c	end do
c
      call getpdb3(xyz,atmnam,resnam,ch0,seqnam,bfac,occ,natom,file)
      write(6,*) natom,' water molecules read in'
      if (il2.gt.0) then
       call getpdb3(xyzp,atmnamp,resnamp,
     1 ch2,seqnamp,bfacp,occp,natomp,file2)
       write(6,*) natomp,' protein atoms read in'
      end if
c
c -- use npseu-1 cycles, 1st check waters which satisfy all NCSs completely
c 			 2... check waters which satisfy only NPSEU-1
c 		         3... check waters which satisfy only NPSEU-2
      write(6,*) npseu - inleast + 1, ' cycles for checking out....'
      do ncycl = 1, npseu - inleast + 1
        next(ncycl) = 0
        nsat = npseu - ncycl + 1
      do iatom = 1, natom
       if (wout(iatom)) goto 30
c-- here it get rid of the weak peaks 
       if (cutoff.and.abs(occ(iatom)-1.).gt.0.1.and.
     +       bfac(iatom).lt.cut(nsat)) goto 30
c	 write(6,*)  'iatom,x1',iatom,x1
       ini = 0
       do ipseu = 1, npseu
        call rtmov(1,xyz(1,iatom),psu(1,1,ipseu),psu(1,4,ipseu),x2)
        do jatom = 1, natom
c-- here it get rid of the weak peaks 
         if (cutoff.and.abs(occ(jatom)-1.).gt.0.1.and.
     +         bfac(jatom).lt.cut(nsat)) goto 40
         call arrgive(3,xyz(1,jatom),x1)
         derr = dist(x1,x2)
         if (wout(jatom)) goto 40
         if (iatom.eq.jatom) goto 40
         if (derr.lt.err) then
      write(6,21) resnam(iatom),seqnam(iatom),atmnam(iatom),bfac(iatom),
     1 ' - ',  resnam(jatom),seqnam(jatom),atmnam(jatom),bfac(jatom)
     2     ,' related by Matrix',ipseu,' err=',derr
           ini = ini + 1
c	     if (ini.gt.0) inon = inon + 1
           ieq(ini) = ipseu
           ieqatm(ini) = jatom
c	write(6,*)  'x1',x1
c	write(6,*)  'x2',x2
21	    format(2(1x,A,1x,A,A,f7.2,a),i3,a,f7.2)
         end if
40	  end do 
       end do
       il20 = il2
29	 if (file1(1:1).ne.' ') then
        if (ini.eq.npseu) then
        inon = inon + 1
        wout(iatom) = .true.
        write(seqnam(iatom)(1:4),'(i4)') inon+inst
        write(6,*) ' Atom written out with',ini,' NCSs as',seqnam(iatom)
        if (il20.eq.0) then
         cw = ch(1)
         ig = 1
         write(10+ig,120) 'ATOM  ',inon,atmnam(iatom),resnam(iatom),
     2  cw,seqnam(iatom),(xyz(k,iatom),k=1,3),occ(iatom),bfac(iatom)
        else
         id = iclose(xyz(1,iatom),dstmin)
         do ig = 1, ngroup
          if (gr(ig).eq.ch2(id)) then
           cw = ch(ig)
           goto 351
          end if
         end do
         write(6,*) 'Error stop: ',ch2(id)
     1  ,' is not found in the keyword input'
351	  continue
        write(ftmp(ig),120) 'ATOM  ',inon,atmnam(iatom),resnam(iatom),
     2  cw,seqnam(iatom),(xyz(k,iatom),k=1,3),occ(iatom),bfac(iatom)
         call arrgive(3,xyz(1,iatom),xxx(1,1))
         irem(1) = ig
        end if
        do i = 1, ini
        irem(i+1) = 0
        jatom = ieqatm(i)
        wout(jatom) = .true.
        ipseu = ieq(i)
        write(seqnam(jatom)(1:4),'(i4)') inon+inst
        if (il20.eq.0) then
         cw = ch(ipseu+1)
         ig = ipseu + 1
         write(10+ig,120) 'ATOM  ',inon,atmnam(jatom),resnam(jatom),
     +     cw,seqnam(jatom),(xyz(k,jatom),k=1,3),occ(jatom),
     +     bfac(jatom)
        else
         id = iclose(xyz(1,jatom),dstmin)
         do ig = 1, ngroup
          if (gr(ig).eq.ch2(id)) then
           cw = ch(ig)
           goto 352
          end if
         end do
         write(6,*) 'Error stop: ',ch2(id)
     1  ,' is not found in the keyword input'
         stop
352	  continue
         write(ftmp(ig),120) 'ATOM  ',inon,atmnam(jatom),resnam(jatom),
     +     cw,seqnam(jatom),(xyz(k,jatom),k=1,3),occ(jatom),
     +     bfac(jatom)
         call arrgive(3,xyz(1,jatom),xxx(1,i+1))
         irem(i+1) = ig
        end if
120	  format(a6,i5,2x,a,a,a,a,4x,3f8.3,2f6.2)
        end do
        if (il20.gt.0) then
         do i = 1, npseu
          if (irem(i) .eq.0) then
           write(6,*) 'Warning irem=0, use original alignment'
           il20 = 0
           inon = inon -1
           goto 29
          end if
          call rtmov(1,xxx(1,irem(1)),psu(1,1,i),psu(1,4,i),b1)
          write(6,*)  ' what is happening?'
          if (dist(b1,xxx(1,irem(i+1))).gt.err) then
           write(6,*) 'Warning, use original alignment'
           il20 = 0
           inon = inon -1
           goto 29
          end if
         end do
         do i = 1, npseu + 1
          ln = lenstr(ftmp(irem(i)))
          write(10+irem(i),'(a)') ftmp(irem(i))(1:ln)
         end do
        end if
        else if (ini.ge.inleast.and.ncycl.ge.(npseu-ini+1)) then
        iext = iext + 1
        next(ncycl) = next(ncycl) + 1
        wout(iatom) = .true.
        write(seqnam(iatom)(1:4),'(i4)') next(ncycl)+inst2
        write(6,'(4a,i5,a,i5)') ' output as chain ',
     + ch(npseu+ncycl),seqnam(iatom),
     + ' with',ini,' NCSs but not for NCS restraint'
        write(12+npseu,120)
     +     'ATOM  ',next(ncycl),atmnam(iatom),resnam(iatom),
     +  ch(npseu+ncycl),seqnam(iatom),(xyz(k,iatom),k=1,3),occ(iatom),
     +     bfac(iatom)
        do i = 1, ini
         jatom = ieqatm(i)
         if (wout(jatom)) then
          write(6,*) 'Warning: repeated output ',
     +       atmnam(jatom),resnam(jatom),seqnam(jatom),' ignored'
          goto 28
         end if
         iext = iext + 1
         next(ncycl) = next(ncycl) + 1
         wout(jatom) = .true.
         ipseu = ieq(i)
         write(seqnam(jatom)(1:4),'(i4)') next(ncycl)+inst2
        write(6,'(4a,i5,a)') ' output as chain ',
     + ch(npseu+ncycl),seqnam(iatom),
     + ' with',ini,' NCSs but not for NCS restraint'
c	  write(6,*) 'output as chain ',ch(npseu+ncycl),seqnam(jatom),
c     + ' with',ini,' NCSs',' but not for NCS restraint'
         write(12+npseu,120) 'ATOM  ',iext,atmnam(jatom),resnam(jatom),
     +  ch(npseu+ncycl),seqnam(jatom),(xyz(k,jatom),k=1,3),occ(jatom),
     +     bfac(jatom)
28	  end do
        else if (ini.gt.0.and.ini.lt.inleast.and.
     +             ncycl.eq.npseu-inleast+1) then
         write(6,*) 'found NCS but not enough for writing out'
        end if
       end if
30	end do
      write(6,*) 'Cycle',ncycl,'  full NCS',inon,'  part NCS',iext
      write(6,*) 
      end do 		
c end of check cycle
c
      write(6,*) 'Total',inon,' independent atoms with all NCSs found'
      do i = 0,npseu
       rewind (11+i)
       do j = 1, inon
        read(11+i,'(a)') key
        ln = lenstr(key)
        nout = nout + 1
        if (cutoff) then
         read (key(55:60),'(f6.2)') ojunk
         if (temp.ne.0.and.abs(ojunk-1.).gt.0.1) then
          if (temp.ne.0.) then
           write(key(61:66),'(f6.2)') temp
          end if
          if (occu.ne.0.) then
           write(key(55:60),'(f6.2)') occu
          end if
         end if
        else
         if (temp.ne.0.) then
          write(key(61:66),'(f6.2)') temp
         end if
         if (occu.ne.0.) then
          write(key(55:60),'(f6.2)') occu
         end if
        end if
        if (atout.ne.'    ') then
         key(14:17) = atout
        end if
        if (resout.ne.'    ') then
         key(18:20) = resout(1:3)
        end if
        write(key(7:11),'(i5)') nout
        write(10,'(a)') key(1:ln)
        if (check) read(key(31:54),'(3f8.3)') (xyzout(k,nout),k=1,3)
       end do
      end do
      write(6,*) 'Total',nout,' atoms with all NCS',
     + ' written out with chain ID'
      write(6,*) (' ',ch(k+1),k=0,npseu),'  for each NCS subunit'
      if (inleast.lt.npseu) then
       rewind (12+npseu)
       do j = 1, iext
        read(11+i,'(a)') key
        ln = lenstr(key)
        nout = nout + 1
        if (cutoff) then
         read (key(55:60),'(f6.2)') ojunk
         if (temp.ne.0.and.abs(ojunk-1.).gt.0.1) then
          if (temp.ne.0.) then
           write(key(61:66),'(f6.2)') temp
          end if
          if (occu.ne.0.) then
           write(key(55:60),'(f6.2)') occu
          end if
         end if
        else
         if (temp.ne.0.) then
          write(key(61:66),'(f6.2)') temp
         end if
         if (occu.ne.0.) then
          write(key(55:60),'(f6.2)') occu
         end if
        end if
        if (atout.ne.'    ') then
         key(14:17) = atout
        end if
        if (resout.ne.'    ') then
         key(18:20) = resout(1:3)
        end if
        write(key(7:11),'(i5)') nout
        write(10,'(a)') key(1:ln)
        if (check) read(key(31:54),'(3f8.3)') (xyzout(k,nout),k=1,3)
       end do
      end if
      write(6,*) 
     + '     ',iext,' atoms written out with chain ID ',
     +  (' ',ch(npseu+ic),ic=2,npseu-inleast+1)
      if (npseu.gt.inleast) then
       write(6,*) 'Among them'
       do i = 2, npseu-inleast+1
        write(6,'(3(i6,a))') next(i), ' waters satisfy',
     +              npseu-i+1,' NCS operations'
       end do
      end if
      write(6,*) 
     + 'Total',nout,' atoms have been written out'
c
c write out the un-selected waters
c
      call ccpdpn(8,fileloss,'unknown','F',0,0)
      do iatom = 1, natom
       if (.not.wout(iatom)) then
        write(8,120)
     +     'ATOM  ',iext,atmnam(iatom),resnam(iatom),
     +     ch0(iatom),seqnam(iatom),(xyz(k,iatom),k=1,3),occ(iatom),
     +     bfac(iatom)
       nunse = nunse + 1
       end if
      end do
      if (nunse.gt.0) then
       write(6,*) 'Total',nunse,' waters are not selected'
      end if
c
      if (check) then
       dsmin = dist(xyzout(1,1),xyzout(1,2))
       do i = 1, nout-1
        do j = i+1, nout
         ds = dist(xyzout(1,i),xyzout(1,j))
         if (ds.lt.2.0) then
          write(6,*) 'Warning: atom',i,' and atom',j,' dist=',ds
         end if
         dsmin = min(ds,dsmin)
        end do
       end do
       write(6,'(a,f8.2)') ' Minimum distance between output atoms',
     .   dsmin
      end if
        CALL CCPERR(0,'Normal termination')
      end
c
      function iclose(xyz,dstmin)
      parameter (maxpro = 50000)
      common/xclose/ xyzp
      common/nclose/ natomp
      real xyz(3),xyzp(3,maxpro)
c
      dstmin = dist(xyz,xyzp(1,1))
      iclose = 1
      do i = 2, natomp
       ds = dist(xyz,xyzp(1,i))
       dstmin = min(dstmin,ds)
       if (dstmin.eq.ds) iclose = i
      end do
      end
