c     model.f
c     
c     Copyright (C) 2008 STFC, Graeme Winter
c     
c     This code is distributed under the BSD license, a copy of which
c     is included in the root directory if this package.
c     
c     25th March, 2008

c     
c     model the behaviour of <S>/<R> as a function of I/sigma, Nu and Nm.
c     
c     this is:
c
c     <S>/<R> = 1.298 * Nm ^ -0.289 * nu ^ -0.49 * 
c               (1 + 2.807 * fn)
c     
c     where:
c     
c     fn = 0.5 * (1 + erf(isigma / sqrt(2)))
c     
c     is the fraction of negative observations (trivial for I/sigma > 5)
c

      function model(isigma, nm, nu)

      implicit none

      real model, isigma, nm, nu, erf

c     internally used variables

      real fn

      fn = 0.5 * (1 + erf(- isigma / sqrt(2.0)))

      model = 1.298 * (nm ** (-0.289)) * 
     +     nu ** (-0.49) * (1 + 2.807 * fn)

      return

      end
      
