c     chef - mean and standard deviation subroutines
c     
c     Copyright (C) 2008 STFC, Graeme Winter
c     
c     This code is distributed under the BSD license, a copy of which
c     is included in the root directory if this package.
c     
c     14th January, 2008
c

c     subroutine meansd - compute mean and standard deviation of a list
c     of real values

      subroutine meansd(values, count, ignore, mean, sd)

      implicit none

c     in

      real values(*)
      integer count, ignore

c     out
      real mean, sd

c     local
      real total
      integer i, ct

      if (count .eq. 0) return

      if (count .eq. 1) then
         mean = values(1)
         sd = 0.0
         return 
      end if

      total = 0.0

      ct = 0
      do i = 1, count
         if (i .ne. ignore) then
            total = total + values(i)
            ct = ct + 1
         end if
      end do

      total = total / real(ct)

      mean = total

      total = 0.0
      ct = 0

      do i = 1, count
         if (i .ne. ignore) then
            total = total + (values(i) - mean) ** 2
            ct = ct + 1
         end if
      end do

      total = total / real(ct)

      sd = sqrt(total)

      end
