c     chef - merging functions
c     
c     Copyright (C) 2008 STFC, Graeme Winter
c     
c     This code is distributed under the BSD license, a copy of which
c     is included in the root directory if this package.
c     
c     14th January, 2008
c

c     subroutine merge - merge the values coming in to give an 
c     average value and error on this mean. weights by 1/s^2.

      subroutine merge(values, errors, count, ignore, mean, sd)

      implicit none

c     in

      real values(*), errors(*)
      integer count, ignore

c     out

      real mean, sd

c     local

      integer i
      real weight, sumw, sumv

c     compute the weighted mean

      sumw = 0.0
      sumv = 0.0

      do i = 1, count

         if (i .ne. ignore) then

            weight = (1.0 / errors(i)) ** 2
            sumw = sumw + weight
            sumv = sumv + weight * values(i)

         end if

      end do

      mean = sumv / sumw
      sd = 1.0 / sqrt(sumw)

      end

      

      

            

      

