c     chef - rmerge subroutines
c     
c     Copyright (C) 2008 STFC, Graeme Winter
c     
c     This code is distributed under the BSD license, a copy of which
c     is included in the root directory if this package.
c     
c     14th January, 2008
c

c     subroutine rmerge - compute the numerator and denominator
c     contributions for a set of reflections

      subroutine rmerge(ivalues, nvalues, num, den)

      implicit none

c     in

      real ivalues(*)
      integer nvalues

c     in / out (accumulated)
      
      real num, den
      
c     local

      integer i
      real imean
      real lnum, lden

c     calculation

      if (nvalues .le. 1) return

      imean = 0.0
      lnum = 0.0
      lden = 0.0

      do i = 1, nvalues
         imean = imean + ivalues(i)
      end do

      imean = imean / real(nvalues)

      do i = 1, nvalues
         lnum = lnum + abs(ivalues(i) - imean)
         lden = lden + ivalues(i)
      end do

      num = num + lnum
      den = den + lden
      
      end

c     subroutine rmerge2 - compute rmerge values but assign e.g. by batch
c     according to index. assert: that max(indices) is smaller than or 
c     equal to size of num, den arrays. in use indices could be batch 
c     number or dose bin.

      subroutine rmerge2(ivalues, indices, nvalues, num, den)

      implicit none

c     in

      real ivalues(*)
      integer indices(*)
      integer nvalues

c     in / out (accumulated)
      
      real num(*), den(*)
      
c     local

      integer i, j
      real imean

c     calculation

      if (nvalues .le. 1) return

      imean = 0.0

      do i = 1, nvalues
         imean = imean + ivalues(i)
      end do

      imean = imean / real(nvalues)

      do i = 1, nvalues
         j = indices(i)
         num(j) = num(j) + abs(ivalues(i) - imean)
         den(j) = den(j) + ivalues(i)
      end do

      end



