      program test

      implicit none
      
c     things to test rmerge, rmerge2

      external rmerge, rmerge2, chisq, chisq2, meansd, merge

      integer i, j, nvalues, indices(100), chi_count(10)
      real values(100), num(10), den(10), r, n, d, mean, sd
      real errors(100), chi(10), c

c     test meansd

      nvalues = 10
      
      do i = 1, 10
         values(i) = rand(0) + 10.0
      end do

      call meansd(values, nvalues, 0, mean, sd)

      if (mean .lt. 10.0) write(*, *) 'meansd error'
      if (mean .gt. 11.0) write(*, *) 'meansd error'

      if (sd .lt. 0.1) write(*, *) 'meansd error'
      if (sd .gt. 1.0) write(*, *) 'meansd error'

c     test rmerge

      n = 0.0
      d = 0.0

      nvalues = 10
      
      do i = 1, 10
         values(i) = rand(0) + 10.0
      end do

      call rmerge(values, nvalues, n, d)

      r = n / d

      if (r .lt. 0.01) write(*, *) 'rmerge error'
      if (r .gt. 0.04) write(*, *) 'rmerge error'

c     test chisq
      
      do i = 1, 10
         errors(i) = 0.5
      end do

      mean = 10.5
      c = 0.0

      call chisq(values, errors, mean, 0.0, 0, 10, c)

      c = c / 10.0

      if (c .gt. 1.0) write(*, *) 'chisq error'

c     test merging

      call merge(values, errors, 10, 0, mean, sd)

      if (mean .lt. 10.0) write(*, *) 'merge error'
      if (mean .gt. 11.0) write(*, *) 'merge error'

      if (sd .lt. 0.1) write(*, *) 'merge error'
      if (sd .gt. 1.0) write(*, *) 'merge error'

c     test rmerge2

      do i = 1, 10
         num(i) = 0.0
         den(i) = 0.0
      end do

      nvalues = 100
      
      do i = 1, 10
         do j = 1, 10
            indices((i - 1) * 10 + j) = i
            values((i - 1) * 10 + j) = rand(0) + 10.0
         end do
      end do
      
      call rmerge2(values, indices, nvalues, num, den)
      
      do i = 1, 10
         r = num(i) / den(i)
         if (r .lt. 0.01) write(*, *) 'rmerge2 error'
         if (r .gt. 0.04) write(*, *) 'rmerge2 error'
      end do

c     test chisq2

      do i = 1, 100
         errors(i) = 0.5
      end do

      do i = 1, 10
         chi_count(i) = 0
         chi(i) = 0.0
      end do
      
      call chisq2(values, errors, mean, 0.0, indices, 0, nvalues, 
     +     chi, chi_count)
         
      do i = 1, 10
         c = chi(i) / real(chi_count(i))
         if (c .gt. 1.0) write(*, *) 'chisq2 error'
      end do

      stop
      end

      
