      program testnref

c     a program to test the nref subroutines

      implicit none

c     external subroutines in ccp4 library

      external ccpfyp, ccperr, mtzini, lropen, lrrsol, lstlsq

c     types for functions

      real lstlsq

c     external subroutines in other files

      external nref, nref_init, nref1

c     maximum number of columns

      integer mcol
      parameter (mcol = 200)
     
c     local variables

      integer hklin, mtzprt, mtzerr, nrefl, nsymop, nrefl1
      real smin, smax, dmin, dmax
      
c     call ccp4 initialisation

      call ccpfyp
      call mtzini

      hklin = 1

      mtzprt = 0
      mtzerr = 0

      call lropen(hklin, 'HKLIN', mtzprt, mtzerr)
      
c     call subroutines to test then

      call lrrsol(hklin, smin, smax)

      dmin = 1.0 / sqrt(smax)
      dmax = 1.0 / sqrt(smin)

      call nref_init(hklin, nsymop)
      call nref1(hklin, nsymop, dmin, dmax, nrefl1)

      call nref(hklin, dmin, dmax, nrefl)

      if (nrefl .ne. nrefl1) write (*, *) 'nref error'

      call lrclos(hklin)

      call ccperr(0, 'Normal termination')

      end
