c     mat2symop
c     
c     a jiffy program to write out a symmetry operation from a matrix
c     input as a single record (e.g. the output of symop2mat)
c     
c     run as
c     
c     mat2symop MAT '1 0 0 0 1 0 0 0 1'

      program mat2symop

      implicit none

c     input and output variables
      character*80 symop(1), mat
      
c     parsing variables

      real matrix(4,4,1)
      real values(10)
      integer ibeg(10), iend(10), ityp(10), idec(10)
      character*4 token(10)

      integer i, j, ntok

c     external ccp4 subroutines
      external symtr4, ccpfyp, parse

c     initialise
      call ccpfyp

c     get the matrix token from the command line
      call ugtenv('MAT', mat)

      if (mat .eq. '') then
         call ccperr(1, 'No matrix provided')
      end if

c     read the matrix from the input record...

      do i = 1, 4
         do j = 1, 4
            matrix(i, j, 1) = 0.0
         end do
      end do

c     interpret the matrix token
      ntok = -10

      call parse(mat, ibeg, iend, ityp, values, token, idec, ntok)

      if (ntok .ne. 9) then
         call ccperr(1, 'MAT not 9 tokens')
      end if

      do j = 1, 9
         if (ityp(j) .ne. 2) then
            call ccperr(1, 'Token not number')
         end if

         matrix(((j - 1) / 3) + 1, mod((j - 1), 3) + 1, 1) = values(j)
      end do

c     do i = 1, 3
c     write(*, *) (matrix(i, j, 1), j = 1, 3) 
c     end do

      call symtr4(1, matrix, symop)

      write(*, *) 'OPERATION ', symop(1)

      call ccperr(0,'normal termination')
      end

      
      
