#!/bin/sh

#
# crank - Automated macromolecular structure solution
#
# Copyright (C) 2004 Steven Ness
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# Convert SHELX .hkl format file to .mtz format
#

#
# Usage:
#
#  mtz2hkl.sh code input.hkl output.drear a b c alpha beta gamma spacegroup
#
#

# Check for correct usage
if [ "$9" = "" ];
    then
    echo "Usage:"
    echo "mtz2hkl.sh input.hkl output.drear a b c alpha beta gamma spacegroup"
    exit
fi

f2mtz HKLIN $1 HKLOUT $2 <<EOF
END
TITLE DREAR to MTZ
NAME drear convert
LABOUT H  K  L  FA SIGFA PHI
CTYPE  H  H  H  F     Q    P
FORMAT '(3I4,2F8.2,I4)'
CELL $3 $4 $5 $6 $7 $8
SYMM $9
END


