#!/bin/sh

#
# crank - Automated macromolecular structure solution
#
# Copyright (C) 2004 Steven Ness
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# merge_dm_hands.sh
#

# 
# Now, take the columns FDMOH PHIDMOH FOMDMOH from "hand1" and put
# them in the .mtz file generated from "hand0"
#

#
# Usage:
#
#  merge_dm_hands.sh hand0input.mtz hand1input.mtz output.mtz FDMOH PHIDMOH FOMDMOH
#
# Where:
# $1 - Input .mtz file - "hand0"
# $2 - Input .mtz file - "hand1"
# $3 - Output .mtz file
# $4 - FDMOH columnn from "hand1"
# $5 - PHIDMOH columnn from "hand1"
# $6 - FOMDMOH columnn from "hand1"
#

# Check for correct usage
if [ "$6" = "" ];
    then
	echo "Usage:"
	echo ""
	echo " merge_dm_hands.sh hand0input.mtz hand1input.mtz output.mtz FDMOH PHIDMOH FOMDMOH"
	echo "Where:"
	echo "hand0input.mtz - Input .mtz file - hand0"
	echo "hand1input.mtz - Input .mtz file - hand1"
	echo "output.mtz - Output .mtz file"
	echo "FDMOH - FDMOH columnn from hand1"
	echo "PHIDMOH - PHIDMOH columnn from hand1"
	echo "FOMDMOH - FOMDMOH columnn from hand1"
	echo ""
	echo "Steven Ness - (c) 2004"
    exit
fi

#
# Read both files into sftools and output the 
# DANO and SIGDANO columns 
#
sftools <<END
read $1
read $2 col $4 $5 $6
write $3
exit
END



