#!/usr/bin/env tclsh

#
# Take a coordinaten file from CRUNCH2 and separate into
# multiple single trials
#
# Usage:
#   separate-coordinaten.tcl coordinaten prefix
#

if { [lindex $argv 1] == "" } {
	puts "Usage:"
	puts ""
	puts "separate-coordinaten.tcl coordinaten prefix"
	puts ""
	puts "Written by Steven Ness - Jan 2004 - (s.ness@chem.leidenuniv.nl)"
	exit
}

set inputfile [open [lindex $argv 0]]
set prefix [lindex $argv 1]

gets $inputfile line

set outputfilenum 1
set outputfile [open "$prefix$outputfilenum" w+]

while { [gets $inputfile line] >= 0 } {
	# Check if we are looking at a "number of atoms" line
	if { [string length $line] < 10 } {
		close $outputfile
		incr outputfilenum
		set outputfile [open "$prefix$outputfilenum" w+]
	} else {
		puts $outputfile $line
	}
}

close $outputfile
