#!/usr/bin/env tclsh

#
# shelxe2mtz.tcl
#
# Convert a shelxe file to .mtz format using F2MTZ from CCP4.
#
# The approximate script to be used will be something like:
#
# F2MTZ HKLIN junk.phs HKLOUT tmp.mtz <<EOF
# CELL ----- 
# SYMM XXXXX 
# LABOUT H K L IP FOMS PHIS 
# CTYP H H H I W P 
# END 
# EOF
#

#
# Usage:
#    shelxe2mtz.tcl shelxe.phs mtzxml outputmtz
#
#


proc convert_shelxe_to_mtz { shelxe outputmtz } {
	global XMLParse

	
}


if { [lindex $argv 2] == "" } {
	puts "Usage:"
	puts ""
    puts "shelxe2mtz.tcl shelxe.phs mtzxml outputmtz"
    puts ""
	puts "Where:"
	puts "   shelxe.phs -> Name of SHELXE output file"
	puts "   mtzxml     -> Name of Crank MTZ XML file"
	puts "   outputmtz  -> Name of MTZ file to be output"
	puts ""
	puts "Copyright (c) Steven Ness 2005"
    exit
}

set shelxe [lindex $argv 0]
set mtzxml [lindex $argv 1]
set outputmtz [lindex $argv 2]

XMLParsefile $mtzxml

convert_shelxe_to_mtz $shelxe $outputmtz


