#!/usr/bin/env tclsh

#
# crank - Automated macromolecular structure solution
#
# Copyright (C) 2004 Steven Ness
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

#
# sortdrear
#
# sort a .drear file on E and SIGE
#

set filein [open [lindex $argv 0] r]

# Read in .drear file
while { [gets $filein line] >= 0 } {
	if { [regexp { *([-0-9]*) *([-0-9]*) *([-0-9]*) *([0-9.-]*) *([0-9.-]*) *([0-9.-]*) *([0-9.-]*) *} \
			  $line full h k l f sigf e sige] } {
		set tmp {}
		lappend tmp $h $k $l $f $sigf $e $sige
		lappend big $tmp
	}
}

# sort the list.  Ah, gentle tcl so nice.  
# (treat as reals, sort on index 5, decreasing order)
set sbig [lsort -decreasing -real -index 5 $big]

for {set i 0} { $i < [llength $sbig] } { incr i } {
#	puts [lindex $sbig $i]
# From mtz2drear.sh 
#OUTPUT USER '(3I5, 2F9.2, 2F9.3)'

	set line [split [lindex $sbig $i]]

 	set output [format "%5i%5i%5i%9.2f%9.2f%9.3f%9.3f" \
					[lindex $line 0] \
					[lindex $line 1] \
					[lindex $line 2] \
					[lindex $line 3] \
					[lindex $line 4] \
					[lindex $line 5] \
					[lindex $line 6]]
	puts $output
}


# DEBUGGING
# puts "before\tafter"
# for {set i 0} { $i < [llength $sbig] } { incr i } {
# 	puts "[lindex $big $i]\t[lindex $sbig $i]"	
# }



