#!/usr/bin/env tclsh

#
# crank - Automated macromolecular structure solution
#
# Copyright (C) 2004 Steven Ness
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

#
# xmloutputlastcoordinatedata.tcl
#
# Simple Tcl script to output the very last
# <coordinate_data></coordinate_data> section in a CRANK XML
# coordinates file "coords.xml"
#  
# Usage:
#  xmloutputlastcoordinatedata.tcl coords.xml
#
#

set input_filename [lindex $argv 0]
set input_fileid [open $input_filename] 

#
# Count how many <coordinate_data> in the file
#
set num_match 0
while { [gets $input_fileid line] >= 0 } {
	if { [regexp {.*<coordinate_data>.*} $line] } {
		incr num_match
	}
}
close $input_fileid


#
# Now, find n-1 <coordinate_data> sections
#
set input_fileid [open $input_filename] 
set curr_match 0
while { [gets $input_fileid line] >= 0 } {
	if { [regexp {.*<coordinate_data>.*} $line] } {
		incr curr_match
		if { $curr_match == $num_match } {
			break;
		}
	}
}

#
# Output the rest of the file, until final </coordinate_data> to
# stdout.
#
puts $line
while { [gets $input_fileid line] >= 0 } {
	puts $line
	if { [regexp {.*<\coordinate_data>.*} $line] } {
		break
	}
}
