C
C     AMORE
C     Copyright (C) 1993 Jorge Navaza, Eleanor Dodson
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C     amore - Jorge Navaza's Molecular replacement package.
C     ====================================================
C
C     J. Navaza (1994).  Acta. Cryst. A50, 157--163
C
C   Radial quadrature instead of bessel expansion,
C      J. NAVAZA (1987). ACTA CRYST. A43, 645-653 
C   Stable recurrence relationship for rotation matrices
C      J. NAVAZA (1990). ACTA CRYST. A46, 619-620
C
C This file contains the routines:
C
C AMORE.f     DIMSS.f     INTERP.f    PKFITP.f    RS.f        TQL2.f
C ANGULO.f    DIRAHX.f    INV3.f      PKMMAX.f    RZ1.f       TQLRAT.f
C ASSYMU.f    DIRAXH.f    KTOY.f      PKSETM.f    SBES1D.f    TRAFO.f
C BZERO.f     DLMMS.f     LECATC.f    PRO2MX.f    SBES3D.f    TRAFP.f
C CARNDO.f    ERRFN.f     LECFOQ.f    PRO3MX.f    SCRF.f      TRAING.f
C CARTAX.f    EXSECT.f    LECFOR.f    PYTHAG.f    SETMAT.f    TRANDO1.f
C CELDA.f     FILLIN.f    LECFOS.f    PZ1.f       SETSCA.f    TRANS.f
C HKLCELLIN.f FITING.f    LECTAB.f    PZC.f       TRED1.f
C CHESH.f     FITNDO.f    QMAX.f      SORNDO.f    TRED2.f
C CHESHI.f    FIXMOL.f    LQTERM.f    QTERM.f     SORT1.f     TRIP.f
C CHKEQL.f    FORMDA.f    MDHFT.f     QUADRA.f    SORT3.f     UNPAC3.f
C CHOLER.f    FORMFA.f    MINTAB.f    QUADRO.f    SORT5.f     UNPAC4.f
C CLMMS.f     FSYM.f      RCARDS.f    SORTING.f   UNPAKG.f
C CLMNS.f     FTL.f       MR2IC.f     READSF.f    SPHARS.f    XFFTH.f
C CLOSEIT.f   FUORI.f     MR2NDO.f    RECNDO.f    SPHBES.f    XYTOHY.f
C CONTRG.f    GAULEG.f    MULTES.f    REFFO.f     SPHHAR.f    YTOK.f
C CONTRR.f    GENDD.f     NUMERO.f    REFFT.f     STFNDO.f    ZEROA.f
C CORIN.f     GENRED.f    ORTHO.f     RHKL1.f     SYMPAC.f    ZIN.f
C DATAMF.f    GENREF.f    OUTTRA.f    RLINE.f     TABLING.f   ZOUT.f
C DET3.f      GMPRD.f     PAC3.f      RMX2E.f     TABLNDO.f   ZTOZ.f
C DFTL.f      HFFTX.f     PAC4.f      RMX2P.f     TABMOD.f
C DIMCS.f     HIN.f       PAKG.f      RMXE.f      TABNDO.f
C DIMFS.f     HOUT.f      PEAKPK.f    ROTATS.f    TCLMN.f
C DIMMS.f     HTOX.f      PHKL1.f     ROTING.f    TDLMM.f
C DIMRS.f     INDEXM.f    PIKNDO.f    ROTNDO.f    TLLIM.f
C
C The original multi program set for a convex used :
C
C              hkl:   input reflections (h,k,l,fob,sig) 
C              udi:   sorted reflections                
C              clm:   xal. harmonic expansion           
C              xyz:   model input coords (pdb)          
C              tab:   model continuous fourier coeffs.  
C              clm:   model harmonic expansion          
C              $out:  outputs   REMOVED NOW TO UNIT 6
C
C======================== ****** ===========================
C
C   Currently open files as:
C
C   fitndo.f:      CALL CCPDPN(UDI,FILNAM,'OLD','U',LREC,IFAIL)
C                  CALL CCPDPN(ITAB,FILNAM,'READONLY','U',0,IFAIL)
C
C   hfftx.f:       CALL CCPDPN(T0,'FFTHKLSCR','SCRATCH','DU',NWDS,0)
C
C   hklcellin.f:   CALL CCPDPN(UDI,'HKLPCK0','OLD','U',LREC,IFAIL)
C
C   rotats.f:      CALL CCPDPN(T1,'TEMP1','SCRATCH','U',80,0)
C                  CALL CCPDPN(T2,'TEMP2','SCRATCH','U',80,0)
C
C   rotndo.f:      CALL CCPDPN(ITAB,FILNAM,'READONLY','U',0,IFAIL)
C                  CALL CCPDPN(UDI,FILNAM,'NEW','U',LREC,IFAIL)
C                  CALL CCPDPN(UDI,FILNAM,'READONLY','U',LREC,IFAIL)
C                  CALL CCPDPN(UHE,FILNAM,'UNKNOWN','U',LREC,IFAIL)
C                  CALL CCPDPN(XHE,'CLMN0','READONLY','U',LREC,IFAIL)
C                  CALL CCPDPN(T3,'TEMPI','SCRATCH','U',80,0)
C                  'MAPOUT' Opened by the maplib routines
C                  CALL CCPDPN(MHE,FILNAM,'READONLY','U',LREC,IFAIL)
C
C   sorndo.f:      CALL CCPDPN(UDI,'HKLPCK0','NEW','U',LREC,IFAIL)
C
C   tablndo.f:     CALL XYZOPEN(IXYZLOG,'INPUT,IXYZIN,IFAIL)
C                  CALL XYZOPEN(JXYZLOG,'OUTPUT',JXYZOUT,IFAIL)
C                  CALL CCPDPN(ITAB,FILNAM,'NEW','U',0,IFAIL)
C                  CALL CCPDPN(T2,'TEMP2','SCRATCH','U',80,0)
C
C   trando1.f:     CALL CCPDPN(UDI,FILNAM,'OLD','U',LREC,IFAIL)
C                   UMP = T3  = O1
C                   UFC = T3 or T4
C                  CALL CCPDPN(T4,'TEMPJ','SCRATCH','U',80,0)
C                  CALL CCPDPN(ITAB,FILNAM,'READONLY','U',0,IFAIL)
C
C   xffth.f:       CALL CCPDPN(T0,'FFTHKLSCR','SCRATCH','DU',NWDS,0)
C
C    ################## WHAT FILES ARE KEPT AND WHAT ARE TO BE DELETED
C
C      see for example line 253 this file
C
C----------------------------------------------------------------------
C
C     =============
      PROGRAM AMORE
C     =============
C
C     .. Scalars in Common ..
      INTEGER IFIT,IMR,IROT,ISORT,ITAB,ITRA,HM,KM,LM,NH,NK,NL,NM
      REAL PI,TWOPI,DTOR,RTOD
C     ..
C     .. Local Scalars ..
      INTEGER IFAIL
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR,CCPFYP,CCPRCS,FITING,MR2IC,MTZINI,
     +         RCARDS,ROTING,SORTING,TABLING,TRAING,XYZINIT
C     block data hint to linker:
      EXTERNAL NUMERO, FORMDA
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /CNTRL/ISORT,ITAB,IROT,ITRA,IFIT,IMR,JSFO
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
C     ..
      INTRINSIC ATAN
C
C---- Open main read and write files.
C      and  Read control data
C
      IFAIL = 0
      PI = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      DTOR = PI/180.0
      RTOD = 180.0/PI
C
C---- Default H,K,L Limits
C
c      N.B. (((IL+LM)*NK+IK+KM)*NH+IH+HM)*NM + IM
c            must be less than INT_MAX
c i.e. (((NL-1)*NK+NK-1)*NH+NH-1)*NM + NM-1
c    INT_MAX         2147483647   max decimal value of an "int"

c  H,K,L index maximum 
      HM = 219
      KM = 219
      LM = 219
cc  H,K,L index max + min + 2 
      NH = 440
      NK = 440
      NL = 440
cc  Max number of primitive equiv + 1 
      NM = 25
C      HM = 139
C      KM = 139
C      LM = 139
c  H,K,L index max + min + 2 
C      NH = 280
C      NK = 280
C      NL = 280
c  Max number of primitive equiv + 1 
C      NM = 97
C          ********************************************
      CALL CCPFYP
      CALL CCPRCS(6,'AMORE','$Date: 2008/04/29 13:02:04 $')
      WRITE (6, 6000)
 6000 FORMAT (/,
     +     ' $TEXT:Reference1: $$ comment $$ ',
     +     ' "AMoRe: an Automated Package for Molecular Replacement",'/
     +     ' J. Navaza (1994).  Acta. Cryst. 50, 157-163.',//' $$',/,
     +     ' $SUMMARY :Reference1:  $$ Amore: $$',/
     +     ' :TEXT:Reference1: $$')
      CALL MTZINI
      CALL XYZINIT
      CALL RCARDS
C          *********************************************
C
      IF (ISORT.EQ.1) THEN
C
C            ***********************************************
        CALL SORTING
        WRITE(6,'(A)') ' Normal Termination of SORTFUN'
C            ***********************************************
      END IF
C
C
      IF (ISORT.LE.-1) THEN
C
C            ***********************************************
        CALL HKLTABLING
        WRITE(6,'(A)') ' Normal Termination of HKLTABLFUN'
C            ***********************************************
C
      END IF
C
      IF (ITAB.NE.0) THEN
C
C            ***********************************************
        CALL TABLING
        WRITE(6,'(A)') ' Normal Termination of TABFUN'
C            ***********************************************
C
      END IF
C
      IF (IROT.EQ.1) THEN
C
C            ***********************************************
        CALL ROTING
        WRITE(6,'(A)') ' Normal Termination of ROTFUN'
C            ***********************************************
C
      END IF
C
      IF (ITRA.EQ.1) THEN
C
C            ***********************************************
        CALL TRAING
        WRITE(6,'(A)') ' Normal Termination of TRAFUN'
C            ***********************************************
C
      END IF
C
      IF (IFIT.EQ.1) THEN
C
C            ***********************************************
        CALL FITING
        WRITE(6,'(A)') ' Normal Termination of FITFUN'
C            ***********************************************
C
      END IF
C
      IF (IMR.EQ.1) THEN
C
C            ***********************************************
        CALL MR2IC
        WRITE(6,'(A)') ' Normal Termination of MR2IC'
C            ***********************************************
C
      END IF
C
C          ****************************************
      CALL CCPERR(0,'Normal termination')
C          ****************************************
C
      END
C
C
C     ==========================
      SUBROUTINE ANGULO(MB,BETA)
C     ==========================
C
      PARAMETER (MSR1R=6)
C     .. Scalar Arguments ..
      INTEGER MB
C     ..
C     .. Array Arguments ..
      REAL BETA(MB)
C     ..
C     .. Scalars in Common ..
      INTEGER NA,NB,NG,
     +IROTG,IROTC,IROTR,ISELF, NCODC, LMINR,LSUPR, NSR1R,NSR2R, NPICR
C
      REAL DRMAXG,DRMING, CELLM, DRMAXC,DRMINC,RMINC,RMAXC, 
     +       DANGR,BMAXR, RPTSR,DELTAR
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1,IBID2
C     ..
C     .. Local Scalars ..
      REAL BMAX,BMIN,DTOR,STEP
      INTEGER N
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /DROTT/IBID1(4),NA,NB,NG,IBID2(5)
      COMMON /ROTFUN/IROTG(4),IROTC(5),IROTR,ISELF,DRMAXG(4),DRMING(4),
     +       CELLM(6,4),NCODC,DRMAXC,DRMINC,RMINC,RMAXC,LMINR,LSUPR,
     +       DANGR,BMAXR,NSR1R,NSR2R,RPTSR,DELTAR,NPICR,ANGNSR(3,MSR1R)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     ..
C
      BMIN = 0.0
CEJD: trouble when I change BMAX from 180 to input BMAX..
C      BMAX = 180.0
      BMAX = BMAXR
      STEP = (BMAX-BMIN)/ (NB-1)
C
      DO 10 N = 1,NB
        BETA(N) = ((N-1)*STEP+BMIN)*DTOR
   10 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE ASSYMU(H,K,L,PHI,TEST)
C     =============================
C
C     .. Scalar Arguments ..
      INTEGER H,K,L
      REAL PHI
      LOGICAL TEST
C     ..
C     .. Scalars in Common ..
      INTEGER HM,KM,LM,NEQP
C     ..
C     .. Arrays in Common ..
      REAL TSS
      INTEGER IBID1,MSS
C     ..
C     .. Local Scalars ..
      REAL PR
      INTEGER HH,IIND,IND,IR,KK,LL,N
C     ..
C     .. External Subroutines ..
      EXTERNAL PAC3,UNPAC3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD,NINT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /PACO/HM,KM,LM,IBID1(4)
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      TEST = .TRUE.
C
C  Check  non-primitive reflections ARE missing where they should be
       if(nts.gt.0) then
      do it=1,nts
      pr=-amod(h*tts(1,it)+k*tts(2,it)+l*tts(3,it),1.)
      ir=mod(12+nint(12*pr),12)
      if(ir.ne.0) go to 80
       enddo
       end if

C          ******************
      CALL PAC3(HM,KM,LM,IND)
C          ******************
C
C   Error in input for external phases
C Need to use PHII and PHIII
      PHII = PHI
      DO 70 N = 1,NEQP
        HH = MSS(1,1,N)*H + MSS(2,1,N)*K + MSS(3,1,N)*L
        KK = MSS(1,2,N)*H + MSS(2,2,N)*K + MSS(3,2,N)*L
        LL = MSS(1,3,N)*H + MSS(2,3,N)*K + MSS(3,3,N)*L
        PR = -MOD(TSS(1,N)*H+TSS(2,N)*K+TSS(3,N)*L + 1000000.0,1.0)
C Check centrics etc have sensible phases
        if(hh.eq.h.and.kk.eq.k.and.ll.eq.l) then
          ir=mod(12+nint(12*pr),12)
          if(ir.ne.0) go to 80
        endif
C
        PHIII = PHII + TWOPI*PR
C
        IF (HH) 30,10,60
   10   IF (LL) 60,20,40
   20   IF (KK) 60,60,50
   30   HH = -HH
   40   LL = -LL
   50   KK = -KK
        PHIII = -PHIII
   60   CONTINUE
c pacote
C
C            *******************
        CALL PAC3(HH,KK,LL,IIND)
C            *******************
C
        IF (IIND.GE.IND) GO TO 70
        IND = IIND
        PHI = PHIII
   70   CONTINUE
C
C          *****************
      CALL UNPAC3(H,K,L,IND)
C          *****************
C  Change PHI to lie between 0 and TWOPI
      PHI = AMOD(PHI + 100.0*TWOPI,TWOPI)
C
      RETURN
   80 WRITE (6,FMT=6000) H,K,L
      TEST = .FALSE.
      RETURN
 6000 FORMAT (' > WARNING < SYSTEMATIC EXTINCTION FOUND:',3I5)
      END
C
C
C     =============================
      SUBROUTINE BZERO(ML,ZBES,XMAX)
C     ==============================
C
C     .. Scalar Arguments ..
      REAL XMAX
      INTEGER ML
C     ..
C     .. Array Arguments ..
      REAL ZBES(ML)
C     ..
C     .. Scalars in Common ..
      INTEGER LMAX
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1
C     ..
C     .. Local Scalars ..
      REAL ARGM,ARGP,DIV,FLEV,PAS,PI,SBL,SBLS,X,XS
      INTEGER J,JS,L,LSUP,MSP
      LOGICAL LAST
C     ..
C     .. External Subroutines ..
      EXTERNAL SBES1D,ZEROA
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /DSPH/IBID1(5),LMAX
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA DIV,MSP/10.0,1455/,FLEV/0.0/
C     ..
C
      LAST = .FALSE.
      PAS = 1/DIV
C
      DO 10 L = 1,ML
        ZBES(L) = 1.0E3
   10 CONTINUE
C
      LSUP = 0
      XS = PI
C
      DO 40 L = 1,ML
C
C            *****************
        CALL SBES1D(L,XS,SBLS)
C            *****************
C
        JS = NINT(XS*DIV)
C
        DO 20 J = JS,MSP
          X = PAS*J
C
C              ***************
          CALL SBES1D(L,X,SBL)
C              ***************
C
          IF (SBL*SBLS.LT.0.0) THEN
            XS = X
            GO TO 30
          END IF
   20   CONTINUE
C
        IF (J.GE.MSP) GO TO 60
   30   ARGM = XS - PAS
        ARGP = XS + PAS
C
C            *******************************
        CALL ZEROA(SBES1D,FLEV,L,ARGM,ARGP,X)
C            *******************************
C
        ZBES(L) = X
        IF (X.GT.XMAX .AND. MOD(L,2).EQ.0) LAST = .TRUE.
        LSUP = L
        IF (LAST .AND. LSUP.GE.LMAX) GO TO 50
   40 CONTINUE
   50 IF (LMAX.LT.LSUP) LMAX = LSUP
      RETURN
   60 CONTINUE
C
C          *****************************************************
      WRITE(6,'(a,a)')
     + ' > S/R BZERO < Sampling of bessel functions too small',
     + ' Increase MSP DATA stt in S/R BZERO'
      CALL CCPERR(1,
     + ' > S/R BZERO < Sampling of bessel functions too small')
C          *****************************************************
C
      END
C
C
C     ==============================================================
      SUBROUTINE CARNDO(IXYZIN,JXYZLOG,JXYZOUT,IXYZ,T2,T3,IOPT,MA,MI,
     +                  MR,CH,II,RR)
C     ==============================================================
C
C  Beginning read of coordinate file:
C

C     .. Scalar Arguments ..
      INTEGER IOPT,IXYZ,IXYZIN,JXYZOUT,MA,MI,MR,T2,T3
      CHARACTER*(*) JXYZLOG
C     ..
C     .. Array Arguments ..
      REAL RR(MR)
      INTEGER II(MI)
      CHARACTER CH(MA)*18
C     ..
C     .. Scalars in Common ..
      INTEGER KPRT,NX,NY,NZ
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1
C     ..
C     .. Local Scalars ..
      INTEGER J1,J2,J3,K1,K2,K3,K4,K5,K6,K7,K8,K9,MAT,MATS,N1,N2,JTAB
C     ..
C     .. External Subroutines ..
      EXTERNAL CARTAX,CORIN,DIMCS
C     ..
C     .. Common blocks ..
      COMMON /GRID/IBID1(3),NX,NY,NZ
      COMMON /IOPRG/KPRT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      JTAB = 1
      IF (IXYZ .LT. 0) JTAB = 0
      IXYZ = ABS(IXYZ)
      CALL CCPZR (RR, MR)
      CALL CCPZI (II, MI)
      DO 10 I=1,MA
        CH(I) = ' '
 10   CONTINUE
      IF(KPRT.NE.0)WRITE (6,FMT=6000)
      MAT = MA
C
C          *******************************************
      CALL CORIN(IXYZIN,JXYZOUT,IOPT,MAT,CH,RR(1),RR(1+3*MAT),II(1))
C  Clear II again
      CALL CCPZI (II, MI)
      IF (JTAB.EQ.0) RETURN
      CALL DIMCS(MI,MR,MAT,MATS)
C          *******************************************
C
      N1 = NX*NY + 1
      N2 = 4*MAT + N1
      J1 = 1
      J2 = 1+MAT
      J3 = 1+MAT+MATS
      K1 = 1
      K2 = N1
      K3 = N1+MAT
      K4 = N1+2*MAT
      K5 = N1+3*MAT
      K6 = N2
      K7 = N2+MATS
      K8 = N2+2*MATS
      K9 = N2+3*MATS
C
C          *******************************************************
      CALL CARTAX(JXYZLOG,T2,T3,MAT,MATS,NZ,NX*NY,II(J1),II(J2),II(J3),
     +            RR(K1),RR(K2),RR(K3),RR(K4),RR(K5),RR(K6),RR(K7),
     +            RR(K8),RR(K9))
C          *******************************************************
C
      RETURN
 6000 FORMAT (/' ****** S/R CARNDO ******')
      END
C
C
C     =================================================================
      SUBROUTINE CARTAX(JXYZLOG,T2,T3,MAT,MATS,MZ,NXY,TSAVE,TTSAV,IATOS,
     +           RHO,XSAVE,YSAVE,ZSAVE,BSAVE,XXSAV,YYSAV,ZZSAV,BBSAV)
C     ==================================================================
C
C     .. Scalar Arguments ..
      INTEGER MAT,MATS,MZ,NXY,T2,T3
      CHARACTER*(*) JXYZLOG
C     ..
C     .. Array Arguments ..
      REAL BBSAV(MATS),BSAVE(MAT),RHO(NXY),XSAVE(MAT),XXSAV(MATS),
     +     YSAVE(MAT),YYSAV(MATS),ZSAVE(MAT),ZZSAV(MATS)
      INTEGER IATOS(MZ),TSAVE(MAT),TTSAV(MATS)
C     ..
C     .. Scalars in Common ..
      REAL AD,AST,BD,BID2,BST,BTISO,CA,CAST,CB,CBST,CD,CG,CGST,CST,DB,
     +     RMIN,SA,SAST,SB,SBST,SG,SGST,VOL
      INTEGER IBID2,KISO,KPRT,NCODE,NEQP,NFORM,NTYP,NX,NY,
     +        NZ
C     ..
C     .. Arrays in Common ..
      REAL BID1,BID3,FORM,RF,RO,TSS,XLOW,XSUP,TRA
      INTEGER IBID1,IXLW,IXUP,MSS
      CHARACTER KEYID*4
C     ..
C     .. Local Scalars ..
      REAL ASG,B1,BISO,BSG,DM,DX,DY,DZ,ELIM,G11,G12,G13,G22,
     +     G23,G33,PI,R,R1,R2,R3,R4,R5,RECIPX,RECIPY,RMAX,RSQ,RSQMAX,RZ,
     +     S,T,TWOPI,X,XC,XHI,XL,XLO,XMAX,XMIN,XP,XPP,XSHIFT,XU,Y,YC,
     +     YHI,YL,YLO,YMAX,YMIN,YP,YPP,YSHIFT,YU,Z,ZHI,ZLO,ZMAX,ZMIN,ZP,
     +     ZPP,ZTEST
      REAL BAVV,OC
      INTEGER I,IFAIL,II,IL,IRES,IU,IX,IXL,IXU,IY,IYL,IYU,IZ,IZL,IZU,J,
     +        JJ,JL,JTYP,JU,JXYZIN,K,KK,L,N,NAS,NAT,NATS,NFORN,ZS
      CHARACTER ATNAM*4,CHNNAM*1,ID*4,RESNAM*4,RESNO*4,INSCOD*1,
     +          ALTCOD*1,SEGID*4
C     ..
C     .. Local Arrays ..
      REAL B(6),BE(5),ETAB(514),FE(5),XMOIN(3),XPLUS(3)
      INTEGER NGRID(3)
C     ..
C     .. External Subroutines ..
      EXTERNAL FORMFA,PZC,SORT5,XYZADVANCE,XYZATOM,
     +         XYZCLOSE,XYZCOORD,XYZOPEN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,EXP,MAX,MIN,MOD,NINT,REAL,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /ATYPE/FORM(10,100),NFORM,NTYP
      COMMON /CELD/AD,BD,CD,CA,CB,CG,SA,SB,SG,AST,BST,CST,CAST,CBST,
     +       CGST,SAST,SBST,SGST,VOL
      COMMON /CTYPE/KEYID(100)
      COMMON /DFFTTX/XLOW(3),XSUP(3),IXLW(3),IXUP(3)
      COMMON /FOZO/BID3(2),DB,IBID2,KISO,BTISO,BTABCORRN
      COMMON /GRID/IBID1(3),NX,NY,NZ
      COMMON /IOPRG/KPRT
      COMMON /ORTM/RO(3,3),RF(3,3),NCODE
      COMMON /RESO/BID1(4),RMIN,BID2
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /TRAA/TRA(3)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA ELIM/7.0/
C     ..
C
C          ******
      CALL FORMFA
C          ******
C
      NFORN = (NFORM+1)/2
C
      DO 10 I = 1,514
        ETAB(I) = EXP(- (I-1)*ELIM/512.0)
   10 CONTINUE

      IFAIL = 0
      JXYZIN = 0
C
C  Do I need this again??
      CALL XYZINIT
C          *****************************************
       IFAIL = 1
      CALL XYZOPEN(JXYZLOG,'INPUT',' ',JXYZIN,IFAIL)
C          *****************************************
C
      IF (KPRT.NE.0) WRITE (6,FMT=6000) RMIN/2.0,NX,NY,NZ
      IF (KISO.NE.0 .AND. KPRT.NE.0) WRITE (6,FMT=6002) BTISO
      IF (KISO.NE.0 .AND. BTISO.LE.0.0 .AND. DB.LE.0.0) DB = 0.1
      IF (KPRT.NE.0) WRITE (6,FMT=6004) DB
C
      IXL = 0
      IXU = NX-1
      IYL = 0
      IYU = NY-1
      IZL = 0
      IZU = NZ-1
      XLO = REAL(IXL)/NX
      XHI = REAL(IXU)/NX
      YLO = REAL(IYL)/NY
      YHI = REAL(IYU)/NY
      ZLO = REAL(IZL)/NZ
      ZHI = REAL(IZU)/NZ
      G11 = AD*AD
      G22 = BD*BD
      G33 = CD*CD
      G12 = 2.0*AD*BD*CG
      G13 = 2.0*AD*CD*CB
      G23 = 2.0*BD*CD*CA
      L   = 0
      K   = 0
C
      BAVV = 0.0
      RMAX = 0.0
   20 CALL XYZADVANCE(JXYZIN,0,0,*130,*130)
      CALL XYZATOM(JXYZIN,ISER,ATNAM,RESNAM,CHNNAM,IRES,RESNO,
     +               INSCOD,ALTCOD,SEGID,IZ,ID)
      CALL XYZCOORD(JXYZIN,'O','U',XP,YP,ZP,OC,BISO,B)
C
C---- SKIP if ALTCOD not blank or A
C
      IF(ALTCOD.NE.' ' .AND. ALTCOD.NE.'A') GO TO 20
C
C---- SKIP if OC==0.0
      IF(OC.EQ.0.0) GO TO 20
C
C---- Check if anisotropic B
C
      IF (B(2).NE.0.0 .OR. B(3).NE.0.0) THEN
        IF (XP.EQ.0.0 .AND. YP.EQ.0.0 .AND. ZP.EQ.0.0) GOTO 20
      ENDIF

      XP = XP + TRA(1)
      YP = YP + TRA(2)
      ZP = ZP + TRA(3)
      IF (KISO.NE.0) BISO = BTISO
C
      DO 40 I = 1,NTYP
         IF (ID .EQ. KEYID(I)) GO TO 50
   40 CONTINUE
C
      GO TO 310
   50 JTYP = I
      BAVV = BAVV + BISO
      L = L + 1
      R = SQRT(ABS((BISO+DB+FORM(2,JTYP))*ELIM)/TWOPI)
      IF (R.GT.RMAX) RMAX = R
C
      XMIN = XLO-R*AST
      XMAX = XHI+R*AST
      YMIN = YLO-R*BST
      YMAX = YHI+R*BST
      ZMIN = ZLO-R*CST
      ZMAX = ZHI+R*CST
C
      X = RF(1,1)*XP + RF(1,2)*YP + RF(1,3)*ZP
      Y = RF(2,1)*XP + RF(2,2)*YP + RF(2,3)*ZP
      Z = RF(3,1)*XP + RF(3,2)*YP + RF(3,3)*ZP
C
      DO 120 N = 1,NEQP
        XP = MSS(1,1,N)*X + MSS(1,2,N)*Y + MSS(1,3,N)*Z + TSS(1,N)
        YP = MSS(2,1,N)*X + MSS(2,2,N)*Y + MSS(2,3,N)*Z + TSS(2,N)
        ZP = MSS(3,1,N)*X + MSS(3,2,N)*Y + MSS(3,3,N)*Z + TSS(3,N)
        XP = MOD(XP,1.0)
        YP = MOD(YP,1.0)
        ZP = MOD(ZP,1.0)
        IF (XP.LT.0.0) XP = XP + 1.0
        IF (YP.LT.0.0) YP = YP + 1.0
        IF (ZP.LT.0.0) ZP = ZP + 1.0
        ZPP = ZP - 1.0
C
        DO 100 IZ = 1,3
          IF (ZPP.LT.ZMIN) GO TO 99
          IF (ZPP.GT.ZMAX) GO TO 99
          YPP = YP - 1.0
C
          DO 80 IY = 1,3
            IF (YPP.LT.YMIN) GO TO 79
            IF (YPP.GT.YMAX) GO TO 79
            XPP = XP - 1.0
C
            DO 60 IX = 1,3
              IF (XPP.LT.XMIN) GO TO 59
              IF (XPP.GT.XMAX) GO TO 59
              K = K + 1
              IF (K.GT.MAT) GO TO 320
              XSAVE(K) = XPP
              YSAVE(K) = YPP
              ZSAVE(K) = ZPP
              BSAVE(K) = BISO + DB 
              TSAVE(K) = 1000*JTYP  + NINT(100.0*OC)
              GOTO 120

   59         XPP = XPP + 1.0
   60         CONTINUE
   79       YPP = YPP + 1.0
   80         CONTINUE
   99     ZPP = ZPP + 1.0
  100         CONTINUE
  120 CONTINUE
C
      GO TO 20
C
C          ****************
  130 CALL XYZCLOSE(JXYZIN)
C          ****************
C
      NAT = K
         IF(L.NE.0) BAVV = BAVV/L
          BTABCORRN = BTABCORRN -BAVV
      WRITE (6,FMT=6006) L,NAT,RMAX,BAVV,BTABCORRN
      IF(BAVV.LT.10.0) THEN
        WRITE(6,'(A,A/6X,A)')
     +     ' **** Average B less than 10.00 means that',
     +     ' Inverse FFT less accurate ****',
     +       ' Resetting Bs internally - Target B reset for output'
               BISO = 10.0 -BAVV
               BTABCORRN = BTABCORRN - BISO 
               DO K = 1,NAT
                BSAVE(K) = BSAVE(K) + BISO
               END DO
      END IF
C
C          ****************************************
      CALL SORT5(NAT,ZSAVE,XSAVE,YSAVE,BSAVE,TSAVE)
C          ****************************************
C
      iF(T2.NE.0) REWIND (T2)
      ZTEST = RMAX*CST
      NATS = 0
C
      DO 180 IZ = 1,NZ
        L = 0
        NAS = 0
        Z = (IZL+IZ-1.0)/NZ
  140   L = L + 1
        IF (L.GT.NAT) GO TO 170
        DZ = ABS(Z-ZSAVE(L))
        IF (DZ.GE.ZTEST) GO TO 140
  150   IF (DZ.GE.ZTEST) GO TO 170
C  TSAVE = 1000*JTYP + NINT(100*OC)
        JTYP   = TSAVE(L)/1000
        OC =  0.01*(TSAVE(L) - 1000*JTYP)
        BISO = BSAVE(L) 
        R = SQRT(ABS((FORM(2,JTYP)+BISO)*ELIM)/TWOPI)
        IF (DZ/CST.GT.R) GO TO 160
        NAS = NAS + 1
        IF (NAS.GT.MATS) GO TO 330
        XXSAV(NAS) = XSAVE(L)
        YYSAV(NAS) = YSAVE(L)
        ZZSAV(NAS) = ZSAVE(L)
        BBSAV(NAS) = BSAVE(L)
        TTSAV(NAS) = TSAVE(L)
  160   L = L + 1
        IF (L.GT.NAT) GO TO 170
        DZ = ABS(Z-ZSAVE(L))
        GO TO 150
  170   IATOS(IZ) = NAS
        IF (NAS.NE.0) WRITE (T2) XXSAV,YYSAV,ZZSAV,BBSAV,TTSAV
        IF (NAS.GT.NATS) NATS = NAS
  180 CONTINUE
C
      IF (KPRT.NE.0) WRITE (6,FMT=6008) NATS
C
      RECIPX = 1.0/NX
      RECIPY = 1.0/NY
      ASG    = AD*SG
      BSG    = BD*SG
      XSHIFT = AST*CBST/CST
      YSHIFT = BST*CAST/CST
      NGRID(1) = NX
      NGRID(2) = NY
      NGRID(3) = NZ
C
      DO 200 I = 1,3
        XMOIN(I) = 0.0
        XPLUS(I) = 0.0
C
        DO 190 J = 1,3
          XMOIN(I) = (XLOW(J)-RMAX)*RF(I,J) + XMOIN(I)
          XPLUS(I) = (XSUP(J)+RMAX)*RF(I,J) + XPLUS(I)
  190   CONTINUE
  200 CONTINUE
C
      DO 210 I = 1,3
        XLOW(I) = XMOIN(I)
        XSUP(I) = XPLUS(I)
        IXLW(I) = NINT(NGRID(I)*XLOW(I))
        IXUP(I) = NINT(NGRID(I)*XSUP(I))
        IF (IXLW(I).LT.0) IXLW(I) = 0
        IF (IXUP(I).GE.NGRID(I)) IXUP(I) = NGRID(I) - 1
  210 CONTINUE
C
      iF(T2.NE.0) REWIND (T2)
C
      DO 300 IZ = 1,NZ
        Z = (IZL+IZ-1.0)/NZ
        DO 220 I = 1,NXY
          RHO(I) = 0.0
  220   CONTINUE
C
        NAS = IATOS(IZ)
        IF (NAS.EQ.0) GO TO 290
        READ (T2) XXSAV,YYSAV,ZZSAV,BBSAV,TTSAV
C
        DO 280 I = 1,NAS
          X = XXSAV(I)
          Y = YYSAV(I)
          DZ = ZZSAV(I)
          DZ = Z - DZ
C  TTSAV = 1000*JTYP + NINT(100*OC)
          JTYP   = TTSAV(I)/1000
          OC =  0.01*(TTSAV(I) - 1000*JTYP)
          R = BBSAV(I) 
C
          DO 230 II = 1,NFORN
            B1 = 2.0*TWOPI/ (FORM(2*II,JTYP)+R)
            FE(II) = OC*FORM(2*II-1,JTYP)*B1*SQRT(ABS(B1))
            BE(II) = 512.0*B1*PI/ELIM
  230     CONTINUE
C
          IF (JTYP.EQ.6) THEN
          END IF
C
          RSQMAX = 512.0/BE(1)
          RZ = SQRT(ABS(RSQMAX- (DZ/CST)**2))
          XC = XSHIFT*DZ + X
          DX = RZ/ASG
          XL = (XC-DX)*NX
          IL = NINT(XL)
          IF (XL.GT.0.0) IL = IL + 1
          XU = (XC+DX)*NX
          IU = NINT(XU)
          IF (XU.LT.0.0) IU = IU - 1
          IL = MAX(IL,IXL)
          IU = MIN(IU,IXU)
          IF (IL.GT.IU) GO TO 280
          YC = YSHIFT*DZ + Y
          DY = RZ/BSG
          YL = (YC-DY)*NY
          JL = NINT(YL)
          IF (YL.GT.0.0) JL = JL + 1
          YU = (YC+DY)*NY
          JU = NINT(YU)
          IF (YU.LT.0.0) JU = JU - 1
          JL = MAX(JL,IYL)
          JU = MIN(JU,IYU)
          IF (JL.GT.JU) GO TO 280
          IX = IU - IL + 1
          IY = JU - JL + 1
          JJ = (JL-IYL)*NX + IL - IXL + 1
          R1 = DZ**2*G33
          R2 = G13*DZ
          R3 = G23*DZ
          DX = REAL(IL)/NX - X
          DM = REAL(JL)/NY - Y
C
          DO 270 J = 1,IX
            R4 = (G11*DX+R2)*DX + R1
            R5 = G12*DX + R3
            KK = JJ
            DY = DM
C
            DO 260 K = 1,IY
              RSQ = (G22*DY+R5)*DY + R4
              IF (RSQ.GE.RSQMAX) GO TO 250
              T = 0.0
C
              DO 240 II = 1,NFORN
                S = BE(II)*RSQ
                L = NINT(S)
                IF (L.GE.1 .AND. L.LE.512) T = T + FE(II)*
     +                 (ETAB(L+1)+ (S-L)* (ETAB(L+2)-ETAB(L+1)))
  240         CONTINUE
C
              RHO(KK) = RHO(KK) + T
  250         DY = DY + RECIPY
              KK = KK + NX
  260       CONTINUE
C
            DX = DX + RECIPX
            JJ = JJ + 1
  270     CONTINUE
  280   CONTINUE
C
  290   ZS = IZL + IZ - 1
C
C            **************************
        CALL PZC(T3,NX,NY,NZ,ZS,RHO(1))
C            **************************
C
  300 CONTINUE
      RETURN
  310 WRITE (6,FMT=6010)
C
C          ****************************************************
      CALL CCPERR(1,' s/r cartax < atom type not recognised')
C          ****************************************************
C
C  Instruction not accessible.)
  315 WRITE (6,FMT=6010)
C
C          ****************************************************
      CALL CCPERR(1,' s/r cartax  - error in rotated atom file')
C          ****************************************************
C
  320 WRITE (6,FMT=6012)MAT
C
C          ****************************************************
      CALL CCPERR(1,' Reset parameter MA in S/R TABLNDO ')
C
  330 WRITE (6,FMT=6014)MATS
C          ****************************************************
      CALL CCPERR(1, '> s/r cartax < max. nb. of atoms per section'//
     +     ' exceeded - reset parameters in TABLING')
C          ****************************************************
C
 6000 FORMAT (/,
     +'             Z-Section Map',/,
     +'       ============================',//,
     +'            Sampling Interval:',F10.3,/,
     +' Divisions of unit cell edges:',3I10)
 6002 FORMAT (' Temperature Factors set to      ',F10.3)
 6004 FORMAT (' Temperature Factors Increased by',F10.3)
 6006 FORMAT (
     +'  Atoms in input list  :',I10,/,
     +'  Atoms in Model volume:',I10,/,
     +'  Max. Atomic Radius   :',F10.3,/,
     +'  Average B factor     :',F10.3,/,
     +'  Required B factor modification to reach target     :',F10.3,/)
 6008 FORMAT (
     +' Max. Atoms per Section:',I10)
 6010 FORMAT (' > S/R CARTAX < FORM FACTOR NOT AVAILABLE')
 6012 FORMAT (' > S/R CARTAX < MAX. NB. OF ATOMS EXCEEDED - LIMIT is',
     +        I7)
 6014 FORMAT (
     +' > S/R CARTAX < MAX. NB. OF ATOMS per section EXCEEDED',
     + ' - LIMIT is',I7)
      END
C
C
C     ========================================
      SUBROUTINE CELDA(A,B,C,ALPHA,BETA,GAMMA)
C     ========================================
C
C     .. Scalars in Common ..
      REAL A,A11,A21,A22,A31,A32,A33,AD,ALPHA,AST,B,BD,BETA,BST,C,CA,
     +     CAST,CB,CBST,CD,CG,CGST,CST,GAMMA,SA,SAST,SB,SBST,SG,SGST,VOL
      INTEGER KPRT
C     ..
C     .. Local Scalars ..
      REAL DTOR,R
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC COS,SIN,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /CELD/AD,BD,CD,CA,CB,CG,SA,SB,SG,AST,BST,CST,CAST,CBST,
     +       CGST,SAST,SBST,SGST,VOL
      COMMON /IOPRG/KPRT
      COMMON /STAR/A11,A21,A22,A31,A32,A33
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     ..
C
      AD = A
      BD = B
      CD = C
      R  = ALPHA*DTOR
      CA = COS(R)
      SA = SIN(R)
      R  = BETA*DTOR
      CB = COS(R)
      SB = SIN(R)
      R  = GAMMA*DTOR
      CG = COS(R)
      SG = SIN(R)
C
      VOL  = A*B*C*SQRT(ABS(2.0*CA*CB*CG+1.0-CA*CA-CB*CB-CG*CG))
C
      CAST = (CB*CG-CA)/ (SB*SG)
      CBST = (CG*CA-CB)/ (SG*SA)
      CGST = (CA*CB-CG)/ (SA*SB)
      SAST = SQRT(ABS(1.0-CAST*CAST))
      SBST = SQRT(ABS(1.0-CBST*CBST))
      SGST = SQRT(ABS(1.0-CGST*CGST))
C
      AST = 1/ (A*SB*SGST)
      BST = 1/ (B*SG*SAST)
      CST = 1/ (C*SA*SBST)
      A11 = AST*SBST*SG
      A21 = -AST*SBST*CG
      A22 = BST*SAST
      A31 = AST*CBST
      A32 = BST*CAST
      A33 = CST
C
      IF (KPRT.NE.0) WRITE (6,FMT=6000) A,B,C,ALPHA,BETA,GAMMA,VOL
      RETURN
 6000 FORMAT (/
     +   ' Cell Parameters:',6F10.3,/,
     +   '          Volume:',E15.5)
      END
C
C
C     =================================
      SUBROUTINE HKLCELLIN(UDI,DMINUDI)
C     =================================
C
C     .. Scalar Arguments..
      INTEGER UDI,HCK2,KCK2,LCK2,NCKH2,NCKK2,NCKL2,NCKM2
C     .. Scalars in Common..
      REAL A,B,C,ALPHA,BETA,GAMMA
      INTEGER NEQ,NEQP,IVERB,NSYM,NSYMP,
     +        HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1
C     .. Arrays in Common..
      REAL TSS,FMINC,FMAXC,TFACC
      INTEGER ITABB,MSS
C     .. Common blocks ..
      COMMON /CELOBS/AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS(3,3),NCDOBS
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /ALLFUN/IVERB,ITABB(5),FMINC(5),FMAXC(5),TFACC(5),NSYM,
     +       NSYMP,RSYM(4,4,96)
      COMMON /PACO/HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1
C
C     ..Local Scalars..
      INTEGER LREC,IFAIL,JDO20,JDO30,ISYM
      CHARACTER FILNAM*10
C
C     .. Save statement ..
      SAVE
C     .. External Subroutines
      EXTERNAL CELDA,ORTHO,CCPERR
      INTRINSIC NINT
C
C
C----  read Cell and symmetry from HKLPCK file:
C
      READ (UDI) A,B,C,ALPHA,BETA,GAMMA
      AOBS  = A
      BOBS  = B
      COBS  = C
      ALPOBS  = ALPHA
      BETOBS  = BETA
      GAMOBS  = GAMMA
C
C          *****
      CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
C          *****
C
      READ (UDI) NTS,NEQP,(((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
      IF(NTS.GT.0) READ(UDI) ((TTS(I,ITS),I=1,3),ITS=1,NTS)
C  Read packing constants to put into COMMON PACO
      READ (UDI) HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1,DMINUDI,
     +           NRUDI

C
C----  Reset symmetry if set on input.
C
      IF (NSYM.GT.1) THEN
        IF (NEQP*(NTS+1).NE.NSYM) THEN
          WRITE (6,FMT='(//,a)') ' Incompatible symmetry??'
          WRITE (6,FMT='(/,i3,A,I3,A)')NEQP, 
     +    ' symmetry operators listed with',nts,' centring operators.'
C
C              ************************
          CALL CCPERR(1,' Fatal error involving symmetry')
C              ************************
C
        END IF
C
        NEQ = NSYM
        NEQP = NSYMP
C
        DO 30 ISYM = 1,NSYM
         IF(ISYM.LE.NSYMP) THEN
          DO 20 JDO30 = 1,3
           TSS(JDO30,ISYM) = RSYM(JDO30,4,ISYM)
            DO 10 JDO20 = 1,3
              MSS(JDO30,JDO20,ISYM) = NINT(RSYM(JDO30,JDO20,ISYM))
   10       CONTINUE
   20     CONTINUE
         END IF
         IF(ISYM.GT.NSYMP) THEN
          NTS = INT((ISYM-1)/NSYMP)
          DO J = 1,3
           tts(j,NTS) =   RSYM(j,4,ISYM) - RSYM(j,4,ISYM-NTS*NSYMP)
          END DO 
         END IF
   30   CONTINUE
C
      END IF
C
C          *****
      CALL ORTHO
C          *****
      WRITE (6,FMT='(A,6F9.3)') 
     + ' HKLCELLIN: Observed Cell read from HKLPCK0:',
     + AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS
      WRITE (6,FMT='(A,I5,48(//,A,I4,/,3(/,3i4,F9.3) ))') 
     +  ' Symmetry - primitive operators:',neqp,
     + ('Symmetry:',N,((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
       IF(NTS.GT.0) THEN
          WRITE (6,FMT='(4(/A,I5,3F9.3) )')
     +  (' Centring operator:',N,(TTS(I,N),I=1,3),N=1,NTS)
       END IF
C
      RETURN
C
      END
C
C     ================
      SUBROUTINE CHESH
C     ================
C
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,AD,BD,CA,CB,CD,CG,DMIN
      INTEGER HMAX,KMAX,LMAX,NEQP,NX,NY,NZ
C     ..
C     .. Arrays in Common ..
      REAL BID1,BID2,BID3,CEL,RM,TSS
      INTEGER LXYZ,MD,MSS
C     ..
C     .. Local Scalars ..
      REAL CAC,CBC,CGC,DET,RTOD,VOL
      INTEGER H,I,IDET,IDOT,IND,IT,IU,IV,IVT,IW,IWT,J,K,L,M,MULT,N,N1,N2
C     ..
C     .. Local Arrays ..
      REAL GI(3,3),GO(3,3),NOR(72)
      INTEGER HKL(72),IO(72),MR(3,3),U(3),V(3),W(3)
C     ..
C     .. External Subroutines ..
      EXTERNAL INDEXM,
     +         INV3,PAC3,SORT1,TRIP,UNPAC3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ACOS,MOD,REAL,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /CELD/AD,BD,CD,CA,CB,CG,BID1(13)
      COMMON /CELL/CEL(6)
      COMMON /CHES/RM(3,3),MD(3,3),LXYZ(3)
      COMMON /GRID/HMAX,KMAX,LMAX,NX,NY,NZ
      COMMON /RESO/BID2(3),DMIN,BID3(2)
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /STAR/A11,A21,A22,A31,A32,A33
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     ..
C
      MULT = 0
C
      DO 110 N = 1,NEQP
        DO 100 I = 1,3
C
          U(1) = 0
          U(2) = 0
          U(3) = 0
C
          U(I) = -1
C
          DO 10 J = 1,3
            U(J) = U(J) + MSS(I,J,N)
   10     CONTINUE
C
          H = U(1)
          K = U(2)
          L = U(3)
C
          IF (L) 40,20,70
   20     IF (K) 50,30,70
   30     IF (H) 60,100,70
   40     L = -L
   50     K = -K
   60     H = -H
C
C              ***************
   70     CALL PAC3(H,K,L,IND)
C              ***************
C
          IF (MULT.EQ.0) GO TO 90
C
          DO 80 M = 1,MULT
            IF (HKL(M).EQ.IND) GO TO 100
   80     CONTINUE
C
   90     MULT = MULT + 1
          HKL(MULT) = IND
          NOR(MULT) = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 +
     +                (A11*H)**2
          IO(MULT) = MULT
  100   CONTINUE
  110 CONTINUE
C
      IF (MULT.LT.1) GO TO 310
C
C          ************************
      CALL SORT1(MULT,IO(1),NOR(1))
C          ************************
C
      LXYZ(1) = 0
      LXYZ(2) = 0
      LXYZ(3) = 0
      IU = 1
      IV = 2
      IW = 3
C
  120 DO 130 M = 1,MULT
        N = IO(M)
C
C            *****************************
        CALL UNPAC3(U(1),U(2),U(3),HKL(N))
C            *****************************
C
        IF (U(IU).LE.0) GO TO 130
C
        N1 = U(1)**2+U(2)**2+U(3)**2
        LXYZ(1) = 1
C
        GO TO 140
  130 CONTINUE
C
      IU = 1+MOD(IU,3)
      IV = 1+MOD(IV,3)
      IW = 1+MOD(IW,3)
C
      IF (IU.EQ.1) GO TO 310
      GO TO 120
C
  140 IVT = IV
      IWT = IW
C
  150 DO 160 M = 1,MULT
        N = IO(M)
C
C            *****************************
        CALL UNPAC3(V(1),V(2),V(3),HKL(N))
C            *****************************
C
        IF (V(IV).LE.0) GO TO 160
        N2 = V(1)**2 + V(2)**2 + V(3)**2
        IDOT = U(1)*V(1) + U(2)*V(2) + U(3)*V(3)
        IF (IDOT*IDOT.EQ.N1*N2) GO TO 160
        LXYZ(2) = 1
        GO TO 170
  160 CONTINUE
C
      IT = IV
      IV = IW
      IW = IT
      IF (IV.NE.IVT) GO TO 150
C
      V(1) = 0
      V(2) = 0
      V(3) = 0
      IV   = IVT
      IW   = IWT
C
      V(IV) = 1
      GO TO 190
C
  170 DO 180 M = 1,MULT
        N = IO(M)
C
C            *****************************
        CALL UNPAC3(W(1),W(2),W(3),HKL(N))
        CALL TRIP(U,V,W,IDET)
C            *****************************
C
        IF (IDET.EQ.0) GO TO 180
        LXYZ(3) = 1
        GO TO 200
  180 CONTINUE
C
  190 W(1) = 0
      W(2) = 0
      W(3) = 0
C
      W(IW) = 1
C
C          ****************
  200 CALL TRIP(U,V,W,IDET)
C          ****************
C
      IF (IDET.LT.0) THEN
          W(1) = -W(1)
          W(2) = -W(2)
          W(3) = -W(3)
          IDET = -IDET
      END IF
C
      DO 210 J = 1,3
        MD(1,J) = U(J)
        MD(2,J) = V(J)
        MD(3,J) = W(J)
  210 CONTINUE
C
C          ***********
      CALL INV3(MD,MR)
C          ***********
C
      DO 240 M = 1,MULT
C
C            *****************************
        CALL UNPAC3(U(1),U(2),U(3),HKL(M))
C            *****************************
C
        DO 230 I = 1,3
C
          V(I) = 0
          W(I) = 0
C
          DO 220 J = 1,3
            V(I) = U(J)*MR(J,I) + V(I)
  220     CONTINUE
C
          W(I) = V(I)/IDET
          IF (V(I).NE.W(I)*IDET .OR. (LXYZ(I).EQ.0.AND.
     +        W(I).NE.0)) GO TO 320
  230   CONTINUE
  240 CONTINUE
C
      DET = REAL(IDET)
C
      DO 260 J = 1,3
        DO 250 I = 1,3
          RM(I,J) = MR(I,J)/DET
  250   CONTINUE
  260 CONTINUE
C
      GI(1,1) = AD*AD
      GI(1,2) = AD*BD*CG
      GI(1,3) = AD*CD*CB
      GI(2,2) = BD*BD
      GI(2,3) = BD*CD*CA
      GI(3,3) = CD*CD
      GI(2,1) = GI(1,2)
      GI(3,1) = GI(1,3)
      GI(3,2) = GI(2,3)
C
      DO 300 I = 1,3
        DO 290 J = 1,3
          GO(I,J) = 0.0
          DO 280 K = 1,3
            DO 270 L = 1,3
              GO(I,J) = RM(K,I)*GI(K,L)*RM(L,J) + GO(I,J)
  270       CONTINUE
  280     CONTINUE
  290   CONTINUE
  300 CONTINUE
C
      AD=SQRT(ABS(GO(1,1)))
      BD=SQRT(ABS(GO(2,2)))
      CD=SQRT(ABS(GO(3,3)))
C
      CAC = GO(2,3)/ (BD*CD)
      CBC = GO(1,3)/ (AD*CD)
      CGC = GO(1,2)/ (AD*BD)
C
      VOL = 
     + AD*BD*CD*SQRT(ABS(2.0*CAC*CBC*CGC+1.0-CAC*CAC-CBC*CBC-CGC*CGC))
C
      CEL(1) = AD
      CEL(2) = BD
      CEL(3) = CD
      CEL(4) = RTOD*ACOS(CAC)
      CEL(5) = RTOD*ACOS(CBC)
      CEL(6) = RTOD*ACOS(CGC)
C
      IF (LXYZ(3).EQ.0) THEN
          CEL(3) = 0.0
          CEL(4) = 0.0
          CEL(5) = 0.0
          VOL    = AD*BD*SQRT(ABS(1.0-CGC*CGC) )
      END IF
C
      IF (LXYZ(2).EQ.0) THEN
          CEL(2) = 0.0
          CEL(6) = 0.0
          VOL    = AD
      END IF
C
      WRITE (6,FMT=6000) CEL,VOL,
     +    ((RM(I,J),J=1,3),I=1,3), ((MD(I,J),J=1,3),I=1,3)
C
      AD = CEL(1)
      BD = CEL(2)
      CD = CEL(3)
C
C          ***************************
      CALL INDEXM(DMIN,AD,BD,CD,HMAX,KMAX,LMAX)
C          ***************************
C
      RETURN
C
C          ********************************************
  310 CALL CCPERR(1,' > s/r chesh < no selected basis')
  320 CALL CCPERR(1,' > s/r chesh < wrong basis') 
C          ********************************************
C
 6000 FORMAT (/,
     +' Cheshire Cell:',6F10.3,/,
     +'        Volume:',E15.5,/,
     +  3 (/3F10.6),/,
     +  3 (/3I5))
C
      END
C
C
C     =============================
      SUBROUTINE CHESHI(NT,HKLT,FT)
C     ==========================
C
C     .. Scalar Arguments ..
      INTEGER NT
C     ..
C     .. Array Arguments ..
      INTEGER HKLT(NT)
C     ..
      COMPLEX FT(NT)
C     ..
C     .. Scalars in Common ..
      INTEGER HLW,HUP,KLW,KPRT,KUP,LLW,LUP,LX,LY,LZ,NR,
     +        NXYZ
C     ..
C     .. Arrays in Common ..
      REAL RM
      INTEGER MD
C     ..
C     .. Local Scalars ..
      INTEGER H,HT,K,KT,L,LT,MULT,N
C     ..
C     .. External Subroutines ..
      EXTERNAL PAC4,UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC NINT
C     ..
C     .. Common blocks ..
      COMMON /CHES/RM(3,3),MD(3,3),LX,LY,LZ
      COMMON /DFFTT/HLW,HUP,KLW,KUP,LLW,LUP,NR,NXYZ
      COMMON /IOPRG/KPRT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      HLW = 0
      HUP = 0
      KLW = 0
      KUP = 0
      LLW = 0
      LUP = 0
C
      DO 70 N = 1,NT
C
C            *****************************
        CALL UNPAC4(HT,KT,LT,MULT,HKLT(N))
C            *****************************
C
        H = NINT(RM(1,1)*HT+RM(2,1)*KT+RM(3,1)*LT)
        K = NINT(RM(1,2)*HT+RM(2,2)*KT+RM(3,2)*LT)
        L = NINT(RM(1,3)*HT+RM(2,3)*KT+RM(3,3)*LT)
        IF (H) 30,10,60
   10   IF (K) 60,20,40
   20   IF (L) 60,60,50
   30   H = -H
   40   K = -K
   50   L = -L
        FT(N) = CONJG( FT(N))
C
C            ************************
   60   CALL PAC4(H,K,L,MULT,HKLT(N))
C            ************************
C
        IF (H.LT.HLW) HLW = H
        IF (H.GT.HUP) HUP = H
        IF (K.LT.KLW) KLW = K
        IF (K.GT.KUP) KUP = K
        IF (L.LT.LLW) LLW = L
        IF (L.GT.LUP) LUP = L
   70 CONTINUE
      IF (KPRT.NE.0) WRITE (6,FMT=6000) HLW,HUP,KLW,KUP,LLW,LUP
      RETURN
 6000 FORMAT (/,
     +' CHESHIRE cell: Maximal Indices',/,
     +' Hmin, Hmax:',2I5,', Kmin, Kmax:',2I5,', Lmin, Lmax:',2I5)
      END
C
C
C     =============================
      LOGICAL FUNCTION CHKEQL(PKPOS,PKPOS2,ABGSTP)
C     ============================================
C
C---- Returns .True. if two peaks PKPOS & PKPOS and the same within
C     the limits ABGSTP
C
C     .. Array Arguments ..
      REAL ABGSTP(3),PKPOS(3),PKPOS2(3)
C     ..
C     .. Local Scalars ..
      INTEGER I
      LOGICAL A(3)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C     ..
C
      CHKEQL = .FALSE.
      A(1) = .FALSE.
      A(2) = .FALSE.
      A(3) = .FALSE.
C
      DO 10 I = 1,3
        IF (ABS(PKPOS(I)-PKPOS2(I)).LT.ABGSTP(I)) A(I)=.TRUE.
   10 CONTINUE
      IF (A(1).AND.A(2).AND.A(3)) CHKEQL = .TRUE.
      RETURN
C
      END
C
C
C     =============================
      SUBROUTINE CHOLER(N,RMAT,RV,KSIS,KINV)
C     ======================================
C
C     .. Scalar Arguments ..
      INTEGER KINV,KSIS,N
C     ..
C     .. Array Arguments ..
      REAL RMAT(N,N),RV(N)
C     ..
C     .. Local Scalars ..
      REAL X,XMIN,Y,ZR
      INTEGER I,IM1,IP1,J,JM1,K,L
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      XMIN = RMAT(1,1)
C
      DO 80 I = 1,N
        IM1 = I - 1
C
        DO 70 J = I,N
          ZR = -RMAT(I,J)
          IF (IM1) 270,30,10
C
   10     DO 20 K = 1,IM1
            ZR = RMAT(K,I)*RMAT(K,J) + ZR
   20     CONTINUE
C
   30     X = -ZR
          IF (J-I) 270,40,60
   40     IF (X) 280,280,50
   50     Y = SQRT(ABS(X) )
          RMAT(I,I) = Y
          IF (X.LT.XMIN) XMIN = X
          GO TO 70
   60     RMAT(I,J) = X/Y
   70   CONTINUE
   80 CONTINUE
C
      IF (KSIS.EQ.0) GO TO 170
C
      DO 120 J = 1,N
        JM1 = J - 1
        ZR = -RV(J)
        IF (JM1) 270,110,90
   90   DO 100 I = 1,JM1
          ZR = RMAT(I,J)*RV(I) + ZR
  100   CONTINUE
  110   RV(J) = -ZR/RMAT(J,J)
  120 CONTINUE
C
      DO 160 L = 1,N
        I = N - L + 1
        IP1 = I + 1
        ZR = -RV(I)
        IF (N-I) 270,150,130
C
  130   DO 140 J = IP1,N
          ZR = RMAT(I,J)*RV(J) + ZR
  140   CONTINUE
C
  150   RV(I) = -ZR/RMAT(I,I)
  160 CONTINUE
C
  170 IF (KINV.EQ.0) GO TO 260
C
      DO 220 I = 1,N
        DO 210 J = I,N
          IF (J-I) 270,180,190
  180     RMAT(I,I) = 1/RMAT(I,I)
          GO TO 210
  190     ZR = 0.0
          JM1 = J - 1
C
          DO 200 K = I,JM1
            ZR = RMAT(I,K)*RMAT(K,J) + ZR
  200     CONTINUE
          RMAT(I,J) = -ZR/RMAT(J,J)
  210   CONTINUE
  220 CONTINUE
C
      DO 250 I = 1,N
        DO 240 J = I,N
          ZR = 0.0
          DO 230 K = J,N
            ZR = RMAT(I,K)*RMAT(J,K) + ZR
  230     CONTINUE
          RMAT(I,J) = ZR
          RMAT(J,I) = RMAT(I,J)
  240   CONTINUE
  250 CONTINUE
C
  260 RETURN
C
C          *****************************************
  270 CALL CCPERR(1,' > s/r choler < wrong indices')
C          *****************************************
C
  280 WRITE (6,FMT=6002) X
C
C          ***************************************************
      CALL CCPERR(2,' > s/r choler < non-positive matrix. x:')
C          ***************************************************
       N = -N
      RETURN
C
 6002 FORMAT (' > S/R CHOLER < NON-POSITIVE MATRIX. X:',E15.5)
C
      END
C
C
C
C     ==================================================
      SUBROUTINE CLMMS(XHE,MHE,LMAX,NQ,CLMM,ELMN1,ELMN2)
C     ==================================================
C
C     .. Scalar Arguments ..
      INTEGER LMAX,MHE,NQ,XHE
C     ..
C     .. Array Arguments ..
      COMPLEX CLMM(*),ELMN1(0:LMAX,NQ),ELMN2(0:LMAX,NQ)
C     ..
C     .. Scalars in Common ..
      REAL XNOR1,XNOR2
      INTEGER KPRT,LMIN,LSUP,NDIMT,NSYM1,NSYM2,NXLS
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1,IBID2,IBID3
C     ..
C     .. Local Scalars ..
      COMPLEX C1,C12,C2
      REAL NORSQ1,NORSQ2,PSUM1,PSUM2
      INTEGER IT,L,L1,L2,M,M1,M2,MM2,N,NN,NN2
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,CONJG,MOD,SQRT
C     ..
C     .. Common blocks ..
      COMMON /DROTT/NXLS,IBID1(6),LMIN,LSUP,NDIMT,IBID2(2)
      COMMON /IOPRG/KPRT
      COMMON /XALS/XNOR1,XNOR2,NSYM1,NSYM2,IBID3(4)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      XNOR1 = 0.0
      XNOR2 = 0.0
C
      IF (KPRT.NE.0) WRITE (6,FMT=6000)
      IT = 0
C
      DO 100 L = 2,LSUP,2
        READ (XHE) L1,NN,MM
        IF (L1.NE.L) GO TO 110
C
        IF (NXLS.NE.1) THEN
          READ (MHE) L2,NN2,MM2
          IF (L2.NE.L .OR. NN2.NE.NN .OR. MM2.NE.MM ) GO TO 110
        END IF
C
        IF (L.LT.LMIN) THEN
          READ (XHE)
          IF (NXLS.NE.1) READ (MHE)
          GO TO 100
        END IF
C
        DO 20 M = 0,L
          DO 10 N = 1,NN+MM
            ELMN1(M,N) = (0.0,0.0)
            ELMN2(M,N) = (0.0,0.0)
   10     CONTINUE
   20   CONTINUE
C
        READ (XHE) ((ELMN1(M,N),N=1,NN+MM),M=0,L,NSYM1)
C
        IF (NXLS.NE.1) THEN
          READ (MHE) ((ELMN2(M,N),N=1,NN+MM),M=0,L,NSYM2)
        ELSE
          DO 40 M = 0,L
            DO 30 N = 1,NN+MM
              ELMN2(M,N) = ELMN1(M,N)
   30       CONTINUE
   40     CONTINUE
        END IF
C
        NORSQ1 = 0.0
        NORSQ2 = 0.0
C
        DO 60 M = 0,L
          DO 50 N = 1,NN
            PSUM1 = ABS(ELMN1(M,N))**2
            PSUM2 = ABS(ELMN2(M,N))**2
C
            IF (M.EQ.0) THEN
                PSUM1 = PSUM1/2.0
                PSUM2 = PSUM2/2.0
            END IF
C
            NORSQ1 = NORSQ1 + PSUM1
            NORSQ2 = NORSQ2 + PSUM2
   50     CONTINUE
            IF (MM.NE.0) THEN
              DO 55 N = 1+NN,NN+MM
                PSUM1 = ABS(ELMN1(M,N))**2
                PSUM2 = ABS(ELMN2(M,N))**2
C
                IF (M.EQ.0) THEN
                    PSUM1 = PSUM1/2.0
                    PSUM2 = PSUM2/2.0
                END IF
C
                NORSQ1 = NORSQ1 - PSUM1
                NORSQ2 = NORSQ2 - PSUM2
   55         CONTINUE
            END IF 
   60   CONTINUE
C
        NORSQ1 = 2*NORSQ1
        NORSQ2 = 2*NORSQ2
C
        IF (KPRT.NE.0) WRITE (6,FMT=6002) L,NORSQ1,NORSQ2
        XNOR1 = XNOR1 + NORSQ1
        XNOR2 = XNOR2 + NORSQ2
C
        DO 90 M1 = 0,L,NSYM1
          DO 80 M2 = -L,L
            IF (MOD(M2,NSYM2).NE.0) GO TO 80
            MM2 = ABS(M2)
            C12 = (0.0,0.0)
C
            DO 70 N = 1,NN
              C1 = ELMN1(M1,N)
              C2 = ELMN2(MM2,N)
              IF (M2.LT.0) C2 = CONJG(C2)* (-1)**MOD(M2,2)
              C12 = CONJG(C2)*C1 + C12
   70       CONTINUE
C
            IF (MM.NE.0) THEN
              DO 75 N = 1+NN,NN+MM
              C1 = ELMN1(M1,N)
              C2 = ELMN2(MM2,N)
              IF (M2.LT.0) C2 = CONJG(C2)* (-1)**MOD(M2,2)
              C12 = - CONJG(C2)*C1 + C12
   75         CONTINUE
            END IF 
C
            IT = IT + 1
            CLMM(IT) = C12
   80     CONTINUE
   90   CONTINUE
  100 CONTINUE
C
      IF (IT.NE.NDIMT) GO TO 120
      XNOR1 = SQRT(ABS(XNOR1) )
      XNOR2 = SQRT(ABS(XNOR2) )
      IF (KPRT.NE.0) WRITE (6,FMT=6004) XNOR1,XNOR2
      RETURN
C
C          **********************************************************
  110 CALL CCPERR(1,' > s/r CLMMs < incoherent harmonic coefficients')
C          **********************************************************
C
  120 WRITE (6,FMT=6008) IT,NDIMT
C
C          ***********************************************
      CALL CCPERR(1,' > s/r CLMMs < mismatch. it, ndimt:')
C          ***********************************************
C
 6000 FORMAT (/' Squared L-Components')
 6002 FORMAT (I5,2E15.5)
 6004 FORMAT (' Truncated Patterson Norms:',2E15.5)
 6008 FORMAT (' > S/R CLMMS < MISMATCH.',/,
     + ' Different resolution limits ELMNs? IT, NDIMT:',2I10)
      END
C
C PJX 27-01-00: S/R CLMNS (below) commented out
C It isn't called anywhere and the call to SPHBES inside is bad
C (wrong number and type of arguments)
C
cxC     =============================
cx      SUBROUTINE CLMNS(UDI,UHE,ND,NL,NQ,NR,NSP,NPR,NPA,LMAX,HKLO,NMAX,
cx     +                 HKL,MFO,STL,NORSQ,COOR,PESO,AUXN,MFS,RH,SBL,YLM,
cx     +                 CLMN,CEX,DD)
cxC     ================================================================
cxC
cxC     .. Scalar Arguments ..
cx      INTEGER LMAX,ND,NL,NPA,NPR,NQ,NR,NSP,UDI,UHE
cxC     ..
cxC     .. Array Arguments ..
cx      DOUBLE PRECISION DD(2* (LMAX+1+NQ))
cx      COMPLEX CEX(0:2*NPA),CLMN(0:LMAX,NQ)
cx      REAL AUXN(NQ),COOR(NQ),MFO(ND),MFS(NR),NORSQ(NL),PESO(NQ),RH(NR),
cx     +     SBL(0:NPR),STL(NL),YLM(0:NPA,0:LMAX)
cx      INTEGER HKL(NR,1+2*NSP),HKLO(ND),NMAX(NL)
cxC     ..
cxC     .. Scalars in Common ..
cx      REAL A,A11,A21,A22,A31,A32,A33,ALPHA,B,BETA,C,DIVB,DIVH,DMAX,DMIN,
cx     +     DRMAX,DRMIN,FMAX,FMIN,GAMMA,RMAX,RMIN,TFAC,VOL
cx      INTEGER KPRT,NCODE,NEQP,NSYM
cxC     ..
cxC     .. Arrays in Common ..
cx      REAL BID1,TSS,RF,RO
cx      INTEGER MSS
cxC     ..
cxC     .. Local Scalars ..
cx      COMPLEX FYLM
cx      REAL A2PI,COST,FF,NORME,PHI,PI,PSUM,RHMAX,RHMIN,RSQH,SCALE,SH,SQH,
cx     +     TETA,TWOPI,XH,XK,XL
cx      INTEGER H,HH,I,IAB,IAP,IAT,ID2,ID3,IM,INDD,INDI,INDO,INDO2,IR,IS,
cx     +        K,KK,L,LL,M,MIAP,MUL,N,NN,NPA2
cx      LOGICAL FIRST
cxC     ..
cxC     .. Local Arrays ..
cx      INTEGER IND(48)
cxC     ..
cxC     .. External Subroutines ..
cx      EXTERNAL PAC3,SPHBES,SPHHAR,UNPAC4
cxC     ..
cxC     .. Intrinsic Functions ..
cx      INTRINSIC ABS,ACOS,ATAN2,EXP,MOD,NINT,SIGN,SQRT
cxC     ..
cxC     .. Common blocks ..
cx      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
cx      COMMON /CELD/Ajnk,Bjnk,Cjnk,BID1(15),VOL
cx      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
cx      COMMON /CTLF/DIVB,DIVH
cx      COMMON /CTLX/NSYM,FMIN,FMAX,TFAC
cx      COMMON /IOPRG/KPRT
cx      COMMON /ORTM/RO(3,3),RF(3,3),NCODE
cx      COMMON /RESO/DRMAX,DRMIN,DMAX,DMIN,RMIN,RMAX
cx      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
cx      COMMON /STAR/A11,A21,A22,A31,A32,A33
cxC     ..
cxC     .. Save statement ..
cx      SAVE
cxC     ..
cxC     ..
cxC
cxC          ****************
cx      CALL PAC3(0,0,0,INDO)
cxC          ****************
cxC
cx      INDO2 = 2*INDO
cx      NPA2  = 2*NPA
cx      IR    = 0
cx      RHMIN = 1/DRMAX
cx      RHMAX = 1/DRMIN
cx      A2PI  = TWOPI*RMAX
cx      SCALE = SQRT(2*TWOPI)/VOL
cxC
cx      REWIND (UDI)
cxC
cxC----  Skip first 3 records
cxC
cx
cx      READ (UDI)AA,BB,CC,AALL,BBEE,GGAA
cx      READ (UDI)NTTTSSS,NNEEQQPP
cx      IF(NTTTSSS.GT.0) READ (UDI)TTTSSS
cx      READ (UDI)HMM,KMM,LMM,NHH,NKK,NLL,NMM,DDmiNN
cx   10 READ (UDI,END=60) M, (HKLO(I),I=1,M), (MFO(I),I=1,M)
cxC
cx      DO 50 I = 1,M
cxC
cxC            *************************
cx        CALL UNPAC4(H,K,L,MUL,HKLO(I))
cxC            *************************
cxC
cx        IF (MUL.EQ.1) GO TO 50
cx        SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
cx        RSQH = SQRT(ABS(SQH) )
cx        IF (RSQH.LT.RHMIN .OR. RSQH.GT.RHMAX) GO TO 50
cx        FF = MFO(I)
cx        IF (TFAC.NE.0.0) FF = FF*EXP(-TFAC*SQH/4)
cx        IF (FF.LT.FMIN .OR. FF.GT.FMAX) GO TO 50
cx        FF = FF*FF
cx        IR = IR + 1
cx        IF (IR.GT.NR) GO TO 180
cx        MFS(IR) = FF
cx        RH(IR) = RSQH*A2PI
cxC
cx        HH = H
cx        KK = K
cx        LL = L
cx        MUL = 1
cxC
cxC            *********************
cx        CALL PAC3(HH,KK,LL,IND(1))
cxC            *********************
cxC
cx        DO 40 IS = 1,NEQP
cx          IF (IS.EQ.1) GO TO 30
cx          HH = MSS(1,1,IS)*H + MSS(2,1,IS)*K + MSS(3,1,IS)*L
cx          KK = MSS(1,2,IS)*H + MSS(2,2,IS)*K + MSS(3,2,IS)*L
cx          LL = MSS(1,3,IS)*H + MSS(2,3,IS)*K + MSS(3,3,IS)*L
cxC
cxC              *******************
cx          CALL PAC3(HH,KK,LL,INDD)
cxC              *******************
cxC
cx          INDI = INDO2 - INDD
cxC
cx          DO 20 IM = 1,MUL
cx            IF (IND(IM).EQ.INDD .OR. IND(IM).EQ.INDI) GO TO 40
cx   20     CONTINUE
cxC
cx          MUL = MUL + 1
cx          IND(MUL) = INDD
cxC
cx   30     XH = RF(1,1)*HH + RF(2,1)*KK + RF(3,1)*LL
cx          XK = RF(1,2)*HH + RF(2,2)*KK + RF(3,2)*LL
cx          XL = RF(1,3)*HH + RF(2,3)*KK + RF(3,3)*LL
cxC
cx          COST = XL/RSQH
cx          IF (ABS(COST).GT.1.0) COST = SIGN(1.0,XL)
cx          TETA = ACOS(COST)
cx          IAT = NINT(NPA*TETA/PI)
cx          PHI = 0.0
cx          IF (XK.NE.0.0 .OR. XH.NE.0.0) PHI = ATAN2(XK,XH)
cx          PHI = MOD(PHI+TWOPI,TWOPI)
cx          IAP = NINT(NPA2*PHI/TWOPI)
cx          HKL(IR,2*MUL) = IAT
cx          HKL(IR,2*MUL+1) = IAP
cx   40   CONTINUE
cx        HKL(IR,1) = MUL
cx   50 CONTINUE
cxC
cx      GO TO 10
cx   60 IF (IR.NE.NR) GO TO 180
cx      IF (KPRT.NE.0) WRITE (6,FMT=6000) NR
cx      REWIND (UHE)
cx      WRITE (UHE) A,B,C,ALPHA,BETA,GAMMA,LMAX,NQ,NSYM,NCODE,FMIN,FMAX,
cx     +  TFAC,DRMAX,DRMIN,DMAX,DMIN,RMIN,RMAX
cx      FIRST = .TRUE.
cxC
cx      ID2 = 1+NQ
cx      ID3 = 1+2*NQ
cxC
cx      DO 160 L = 2,NL,2
cx        NN = NMAX(L)
cxC
cxC            *************************************
cxc        CALL QUADRA(NQ,COOR,PESO,NN,DD(1),DD(ID2))
cx        CALL SPHBES(L,NPR,SBL)
cx        CALL SPHHAR(L,NPA,LMAX,YLM,CEX,DD(ID3),FIRST)
cxC            *************************************
cxC
cx        DO 80 N = 1,NN
cx          AUXN(N) = 0.0
cx          DO 70 M = 0,L
cx            CLMN(M,N) = 0.0
cx   70     CONTINUE
cx   80   CONTINUE
cxC
cx        DO 130 IR = 1,NR
cx          IF (RH(IR).LT.STL(L)) GO TO 130
cx          SH = RH(IR)*DIVB
cxC
cx          DO 90 N = 1,NN
cx            IAB = NINT(COOR(N)*SH)
cx            AUXN(N) = PESO(N)*SBL(IAB)
cx   90     CONTINUE
cxC
cx          MUL = HKL(IR,1)
cxC
cx          DO 120 IS = 2,2*MUL,2
cx            IAT = HKL(IR,IS)
cx            IAP = HKL(IR,IS+1)
cxC
cx            DO 110 M = 0,L,NSYM
cx              MIAP = MOD(M*IAP,NPA2)
cx              FYLM = MFS(IR)*YLM(IAT,M)*CEX(MIAP)
cxC
cx              DO 100 N = 1,NN
cx                CLMN(M,N) = AUXN(N)*FYLM + CLMN(M,N)
cx  100         CONTINUE
cx  110       CONTINUE
cx  120     CONTINUE
cx  130   CONTINUE
cxC
cx        NORSQ(L) = 0.0
cxC
cx        DO 150 N = 1,NN
cx          AUXN(N) = 0.0
cx          DO 140 M = 0,L,NSYM
cx            CLMN(M,N) = CLMN(M,N)*SCALE
cx            PSUM = ABS(CLMN(M,N))**2
cx            IF (M.NE.0) PSUM = PSUM*2
cx            AUXN(N) = AUXN(N) + PSUM
cx  140     CONTINUE
cx          NORSQ(L) = NORSQ(L) + AUXN(N)
cx  150   CONTINUE
cxC
cx        IF (KPRT.NE.0) WRITE (6,FMT=6002) L,NORSQ(L)
cx        WRITE (UHE) L,NN, (RMAX*COOR(N),AUXN(N),N=1,NN)
cx        WRITE (UHE) ((CLMN(M,N),N=1,NN),M=0,L,NSYM)
cx  160 CONTINUE
cxC
cx      NORME = 0.0
cxC
cx      DO 170 L = 2,NL,2
cx        NORME = NORSQ(L) + NORME
cx  170 CONTINUE
cxC
cx      NORME = SQRT(ABS(NORME) )
cx      IF (KPRT.NE.0) WRITE (6,FMT=6004) NORME
cx      RETURN
cxC
cxC          ********************************************************
cx  180 CALL CCPERR(1,' > s/r clmns < incoherent nb. of reflections')
cxC          ********************************************************
cxC
cx 6000 FORMAT (
cx     +' NB. of Reflections:',I10,/,
cx     +'   Squared L-Components')
cx 6002 FORMAT (I5,E15.5)
cx 6004 FORMAT (' Truncated Patterson Norm:',E15.5)
cx      END
C
C
C     ========================
      SUBROUTINE CONTRG(NA,IA)
C     ========================
C
C     .. Scalar Arguments ..
      INTEGER IA,NA
C     ..
C     .. Scalars in Common ..
      INTEGER NEQ,NEQP
C     ..
C     .. Arrays in Common ..
      REAL TSS
      INTEGER MSS
C     ..
C     .. Local Scalars ..
      INTEGER I,J,MAXWW,MCD,MDIV,MI,MIN,MP1,N,NBA,NDIV
C     ..
C     .. Local Arrays ..
      INTEGER IBA(5),INTA(48),P1(81)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MAX,MOD,NINT
C     ..
C     .. Common blocks ..
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA P1/46,58,62,74,82,86,92,94,106,116,118,122,124,134,138,142,
     +     146,148,158,164,166,172,174,178,184,186,188,194,202,206,212,
     +     214,218,222,226,230,232,236,244,246,248,254,258,262,268,274,
     +     276,278,282,284,290,292,296,298,302,310,314,316,318,322,326,
     +     328,332,334,344,346,348,354,356,358,362,366,368,370,372,376,
     +     382,386,388,394,398/,MP1/81/,MAXWW/400/,IBA/6,4,3,2,1/,NBA/5/
C     ..
C
      MI = 0
C
      DO 20 N = 1,NEQP
        MIN = NINT(MOD(TSS(IA,N)+1.0,1.0)*12.0)
C
        IF (MIN.NE.0) THEN
          IF (MI.EQ.0) THEN
            MI = MI + 1
            INTA(MI) = MIN
          END IF
C
          DO 10 I = 1,MI
            IF (INTA(I).EQ.MIN) GO TO 20
   10     CONTINUE
C
          MI = MI + 1
          INTA(MI) = MIN
        END IF
   20 CONTINUE
C
      MCD = 1
      IF (MI.EQ.0) GO TO 50
C
      DO 40 J = 1,NBA
        MCD = IBA(J)
        DO 30 I = 1,MI
          IF ((INTA(I)/MCD)*MCD.NE.INTA(I)) GO TO 40
   30   CONTINUE
        MCD = 12/MCD
        GO TO 50
   40 CONTINUE
C
   50 IF ((MCD/2)*2.NE.MCD) MCD = MCD*2
C
      NDIV = MAX(MCD,2)
      MDIV = 0
C
   60 IF (NA.GT.MAXWW) THEN
        NA = NA/NDIV
        MDIV = MDIV + 1
      END IF
      IF(NA.GT.MAXWW) GO TO 60
C
      NA = ((NA+MCD-1)/MCD)*MCD
C
      DO 70 I = 1,MP1
        IF (NA.EQ.P1(I)) THEN
          NA = NA + MCD
          GO TO 60
        END IF
   70 CONTINUE
C
      IF (MDIV.NE.0) NA = NA*NDIV*MDIV
      RETURN
      END
C
C
C     =============================
      SUBROUTINE CONTRR(N,NSY)
C     ========================
C
C     .. Scalar Arguments ..
      INTEGER N,NSY
C     ..
C     .. Local Scalars ..
      INTEGER I,MAXWW,MCD,MDIV,MP1,NDIV
C     ..
C     .. Local Arrays ..
      INTEGER P1(81)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MAX
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA P1/46,58,62,74,82,86,92,94,106,116,118,122,124,134,138,142,
     +     146,148,158,164,166,172,174,178,184,186,188,194,202,206,212,
     +     214,218,222,226,230,232,236,244,246,248,254,258,262,268,274,
     +     276,278,282,284,290,292,296,298,302,310,314,316,318,322,326,
     +     328,332,334,344,346,348,354,356,358,362,366,368,370,372,376,
     +     382,386,388,394,398/,MP1/81/,MAXWW/400/
C     ..
C
      MCD = NSY
C
      IF ((MCD/2)*2.NE.MCD) MCD = MCD*2
C
      NDIV = MAX(MCD,2)
      MDIV = 0
C
   10 IF (N.GT.MAXWW) THEN
        N = N/NDIV
        MDIV = MDIV + 1
      END IF
      IF(N.GT.MAXWW) GO TO 10
C
      N = ((N+MCD-1)/MCD)*MCD
C
      DO 20 I = 1,MP1
        IF (N.EQ.P1(I)) THEN
          N = N + MCD
          GO TO 10
        END IF
   20 CONTINUE
C
      IF (MDIV.NE.0) N = N*NDIV*MDIV
      RETURN
      END
C
C
C     =========================================================
      SUBROUTINE CORIN(IXYZIN,JXYZOUT,IOPT,MAT,CXYZ,AXYZ,BXYZ,IZZ)
C     =========================================================
C
C      CHARACTER*5 OPTION,SMALL
C      DATA SMALL/'SMALL'/
C     .. Scalar Arguments ..
      INTEGER IOPT,IXYZIN,JXYZOUT,MAT
C     ..
C     .. Array Arguments ..
      REAL AXYZ(MAT,3),BXYZ(MAT)
      INTEGER IZZ(MAT)
      CHARACTER CXYZ(MAT)*18
C     ..
C     .. Scalars in Common ..
      REAL A,AL,ALPHA,B,BE,BETA,BID1,BOXSC,C,GA,GAMMA,RMAX
      INTEGER KPRT,NAT,NCODE,NEQ,NEQP,NFORM,NTYP,BID2
C     ..
C     .. Arrays in Common ..
      REAL BOXM,CM,FORM,RF,RO,TSS,XLOW,XSUP,TRA
      INTEGER IBID1,MSS
      CHARACTER KEYID*4
C     ..
C     .. Local Scalars ..
      REAL BISO,DET,OC,R,T,XHI
      INTEGER I,IERR,IRES,IZ,J,KPRTP,N,NIZ,TMI,TMR,TMC
      LOGICAL FIRST,LAST,IFILFF
      CHARACTER ATNAM*4,CARAT*18,CHNNAM*1,ID*4,LINE*80,RESNAM*4,RESNO*4,
     +          INSCOD*1,ALTCOD*1,SEGID*4
C     ..
C     .. Local Arrays ..
      REAL BOUT(6),CELTMP(6),QM(3,3),ROTA(3,3),RR(18),VAL,
     +     VER(3),XI(3),XO(3),XXO(3)
      INTEGER TEMPIZ(10)
C     ..
C     .. External Subroutines ..
      EXTERNAL CELDA,DET3,LECATC,ORTHO,RMX2E,RMX2P,RMXE,RS,
     +         XYZADVANCE,XYZATOM,XYZCLOSE,
     +         XYZCOORD,WBCELL,WREMARK
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /ATYPE/FORM(10,100),NFORM,NTYP
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /CELOBS/AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS(3,3),NCDOBS
      COMMON /CTYPE/KEYID(100)
      COMMON /DFFTTX/XLOW(3),XSUP(3),IBID1(6)
      COMMON /IOPRG/KPRT
      COMMON /ORTM/RO(3,3),RF(3,3),NCODE
      COMMON /OUTAB/BOXM(3),RMAX,CM(3),AL,BE,GA,VAL(3),BID1,NAT,IBID2,
     +              BOXSC
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /TABLFUN/ITABS(4),ITABT(4),BOXSCT(4),BTISOT(4),DRMNT(4),
     +       SHARTT(4),BTABCORR(4)
      COMMON /TRAA/TRA(3)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      NIZ = 0
      FIRST = .TRUE.
      LAST = .FALSE.
      IFILFF = .TRUE.
      SEGID = ' '
      INSCOD = ' '
      ALTCOD = ' '
      IZ = 0
C
      DO 20 I = 1,3
        TSS(I,1) = 0.0
        CM(I) = 0.0
        XLOW(I) = 1.0E5
        XSUP(I) = -1.0E5
C
        DO 10 J = 1,3
          MSS(I,J,1) = 0
          QM(I,J) = 0.0
   10   CONTINUE
   20 CONTINUE
C
      CALL READSF(ID,IFILFF)
C
      NAT = 0
   30 IF (NAT.GT.MAT) GO TO 220
C
C  LECATC actually reads the file _ JZ returns IZ and OCC
C          **********************************************
      CALL LECATC(IXYZIN,CARAT,JZ,ID,XI,BISO,FIRST,LAST)
C          **********************************************
C
      IF (LAST) GO TO 80
C
C --- Check for atom types with form-factors already read in
C  JZ = 1000*IZtrue + NINT(100*OC)
          IZ  = JZ/1000
          OC =  0.01*(JZ - 1000*I)
      IF(NIZ.GT.0) THEN
        DO 101 I = 1,NIZ
          IF (IZ.EQ.TEMPIZ(I)) GO TO 50
  101   CONTINUE
      END IF
C
C --- Check for atom types H,C,N,O,S
      IF (IZ.EQ.1 .OR. IZ.EQ.6 .OR. IZ.EQ.7 .OR. IZ.EQ.8 .OR. IZ.EQ.16)
     +          GO TO 50
C
      CALL READSF(ID,IFILFF)
C
      NIZ = NIZ + 1
      TEMPIZ(NIZ) = IZ
C
   50 NAT = NAT + 1
      CXYZ(NAT) = CARAT
      AXYZ(NAT,1) = XI(1)
      AXYZ(NAT,2) = XI(2)
      AXYZ(NAT,3) = XI(3)
      BXYZ(NAT) = BISO
      IZZ(NAT) = JZ
C
      DO 70 I = 1,3
        CM(I) = CM(I) + XI(I)
        DO 60 J = 1,3
          QM(I,J) = XI(I)*XI(J) + QM(I,J)
   60   CONTINUE
   70 CONTINUE
C
      GO TO 30
C
   80 CLOSE(45)
      DO 90 I = 1,3
        CM(I) = CM(I)/NAT
   90 CONTINUE
C
      DO 110 I = 1,3
        DO 100 J = 1,3
          QM(I,J) = QM(I,J)/NAT - CM(I)*CM(J)
  100   CONTINUE
  110 CONTINUE
C
C          ***************************************
      CALL RS(3,3,QM,VAL,ROTA,RR(1),RR(10),1,IERR)
C          ***************************************
C
      KPRTP = KPRT
      KPRT = 0
      T = VAL(1)
      VAL(1) = VAL(3)
      VAL(3) = T
C
C          **************
      CALL DET3(ROTA,DET)
C          **************
C
      T = -SIGN(1.0,DET)
C_1999    Taken from navaza'a amore
      do  i=1,3
      ver(i)=0.
       do  j=1,3
       ver(i)=ver(i)+(axyz(1,j)-cm(j))*rota(j,i)
       end do
      end do
      tt1=sign(1.,ver(1))
      tt2=sign(1.,ver(2))
      tt3=sign(1.,ver(3))
      tt1=t*tt2*tt3
C
      DO 120 I = 1,3
        QM(I,1) = ROTA(I,3)*TT3
        QM(I,2) = ROTA(I,2)*TT2
        QM(I,3) = ROTA(I,1)*TT1
  120 CONTINUE
C
C          ***************************
      CALL RMX2E(QM,AL,BE,GA,.FALSE.)
      CALL RMXE(180-GA,BE,180-AL,ROTA,.FALSE.)
C          ***************************
C
      KPRT = KPRTP
      IF (KPRT.NE.0) WRITE (6,FMT=6000) NAT,CM,VAL
C
C          ********************
      CALL RMX2E(ROTA,AL,BE,GA,.FALSE.)
      CALL RMX2P(ROTA,XHI,VER,.FALSE.)
C          ********************
C
C----  Iopt = 1 equiv to OPTION=SMALL  - rotate and translate to CM
C----  Iopt = 2   do not rotate but translate to CM
C----  Iopt = 3   do not rotate or translate to CM
C    
      IF (IOPT.NE.1) THEN
        KPRT = 0
C
        AL = 0.0
        BE = 0.0
        GA = 0.0
C
C            *******************
        CALL RMXE(AL,BE,GA,ROTA,.FALSE.)
C            *******************
C
        KPRT = KPRTP
          IF (IOPT.EQ.3) THEN
            CM(1) = 0.0
            CM(2) = 0.0
            CM(3) = 0.0
          END IF
      END IF
C
      DO 150 N = 1,NAT
        XI(1) = AXYZ(N,1) - CM(1)
        XI(2) = AXYZ(N,2) - CM(2)
        XI(3) = AXYZ(N,3) - CM(3)
C
        DO 140 I = 1,3
          XO(I) = 0.0
          DO 130 J = 1,3
            XO(I) = ROTA(I,J)*XI(J) + XO(I)
  130     CONTINUE
C
          IF (XO(I).LT.XLOW(I)) XLOW(I) = XO(I)
          IF (XO(I).GT.XSUP(I)) XSUP(I) = XO(I)
  140   CONTINUE
  150 CONTINUE
C
      A = XSUP(1)-XLOW(1)
      B = XSUP(2)-XLOW(2)
      C = XSUP(3)-XLOW(3)
      ALPHA = 90.0
      BETA  = 90.0
      GAMMA = 90.0
      BOXM(1) = A
      BOXM(2) = B
      BOXM(3) = C
      IF (KPRT.NE.0) WRITE (6,FMT=6006) A,B,C
      A = A*BOXSC
      B = B*BOXSC
      C = C*BOXSC
      NTS    = 1
      NEQP   = 1
      WRITE(6,FMT=6007) A,B,C,ALPHA,BETA,GAMMA
CXXX      CALL INDEXM(DMIN,A,B,C,HMAX.KMAX,LMAX)
C
C          *****
      CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
C          *****
      CALL SETPAK(A,B,C,NEQP,0.95*DRMNT(1))
C
      NCODE = 1
C
C          ******
      CALL ORTHO
C          ******
C
      XI(1) = 0.5
      XI(2) = 0.5
      XI(3) = 0.5
C
      DO 170 I = 1,3
        MSS(I,I,1) = 1
        TRA(I) = 0.0
        XLOW(I) = 1.0E5
        XSUP(I) = -1.0E5
        DO 160 J = 1,3
          TRA(I) = RO(I,J)*XI(J) + TRA(I)
  160   CONTINUE
  170 CONTINUE
C
      WRITE (6,FMT=6002)
C
C---- writes out ALPHA BETA GAMMA
C
C          *******************
      CALL RMXE(AL,BE,GA,ROTA,.FALSE.)
C          *******************
C
      IF (KPRT.NE.0) WRITE (6,FMT=6004) XI,TRA
      RMAX = 0.0
C
      WRITE (LINE,FMT='(A,6F10.3)') 'REMARK - BOX = ',BOXSC
C
C          ********************
      CALL WREMARK(JXYZOUT,LINE)
C          ********************
C
C---- Output "box" cell if no input cell - otherwise output new cell
C
      IF (AOBS.EQ.0.0) THEN
        CELTMP(1) = A
        CELTMP(2) = B
        CELTMP(3) = C
        CELTMP(4) = ALPHA
        CELTMP(5) = BETA
        CELTMP(6) = GAMMA
C
C            ***************************
        CALL WBCELL(JXYZOUT,CELTMP,NCODE)
C            ***************************
C
      END IF
C
      IF (AOBS.NE.0.0) THEN
        CELTMP(1) = AOBS
        CELTMP(2) = BOBS
        CELTMP(3) = COBS
        CELTMP(4) = ALPOBS
        CELTMP(5) = BETOBS
        CELTMP(6) = GAMOBS
C
C            ****************************
        CALL WBCELL(JXYZOUT,CELTMP,NCDOBS)
C            ****************************
C
      END IF
C      OC = 1.0
C
      DO 210 N = 1,NAT
        CARAT = CXYZ(N)
        XI(1) = AXYZ(N,1) - CM(1)
        XI(2) = AXYZ(N,2) - CM(2)
        XI(3) = AXYZ(N,3) - CM(3)
        BISO = BXYZ(N)
        IZ = IZZ(N)/1000
        OC = 0.01*(IZZ(N) -1000*IZ)
C
        DO 190 I = 1,3
          XO(I) = 0.0
          DO 180 J = 1,3
            XO(I) = ROTA(I,J)*XI(J) + XO(I)
  180     CONTINUE
C
          XXO(I)=XO(I)
C
          XO(I) = XO(I) + TRA(I)
          IF (XO(I).LT.XLOW(I)) XLOW(I) = XO(I)
          IF (XO(I).GT.XSUP(I)) XSUP(I) = XO(I)
  190   CONTINUE

        READ(CARAT,FMT='(A4,1X,A4,A1,A4,A4)') ATNAM,RESNAM,CHNNAM,
     +                                                      RESNO,ID
        READ(RESNO,FMT='(I4)') IRES
        BOUT(1) = BISO
        DO 195 I=2,5
          BOUT(I) = 0.0
  195   CONTINUE
C
C            ***********************************************************
        CALL XYZATOM(JXYZOUT,N,ATNAM,RESNAM,CHNNAM,IRES,RESNO,
     +                       INSCOD,ALTCOD,SEGID,IZ,ID)
        CALL XYZCOORD(JXYZOUT,'O','U',XXO(1),XXO(2),XXO(3),OC,BISO,
     +                       BOUT)
        CALL XYZADVANCE(JXYZOUT,0,0,*210,*210)
C            ***********************************************************
C
C
        R = 0.0
C
        DO 200 I = 1,3
          R = XI(I)**2 + R
  200   CONTINUE
C
        IF (R.GT.RMAX) RMAX = R
  210 CONTINUE
C
C          ****************
      CALL XYZCLOSE(JXYZOUT)
C          ****************
C
      MAT = NAT
      RMAX = SQRT(ABS(RMAX) )
C
      IF (KPRT.NE.0) WRITE (6,FMT=6006) ((XSUP(I)-XLOW(I)),I=1,3)
      IF (KPRT.NE.0) WRITE (6,FMT=6008) RMAX
      RETURN
C
C          *****************************************************
  220 WRITE(6,6014) MAT
      CALL CCPERR(1,' > s/r corin < max. nb. of atoms exceeded')
C          *****************************************************
C
C  Instruction not accessible
      WRITE (6,FMT=6012) CARAT(1:14)
C
C          *****************************************************
      CALL CCPERR(1,' > s/r corin < form factor not available:')
C          *****************************************************
C
 6000 FORMAT (/,
     +' Center of Mass of the',I10,' Input Atoms:',3F10.3,/,
     +' Inertia Axes of Input Coords.:',3E15.5)
 6002 FORMAT (/' The C. of M. is first set to zero')
 6004 FORMAT (
     +' Translation after Rotation :',/,
     +'   Fractional:  ',3F10.6,/,
     +'   Orthogonal:  ',3F10.3)
 6006 FORMAT (' Minimal Rectangular Box of output coordinates:',3F10.3)
 6007 FORMAT (' TABLING CELL:',3F10.3,3F8.2)
 6008 FORMAT (' Max. Distance from C. of M.:',F10.3)
 6012 FORMAT (' > S/R CORIN < FORM FACTOR NOT AVAILABLE:',A14)
 6014 FORMAT (' > S/R CORIN < MAX. NB. OF ATOMS EXCEEDED - LIMIT is',
     +        I7)
      END
C
C
C     =======================================
      SUBROUTINE DATAMF(UMP,T2,ND,MI,MR,MC,II)
C     ========================================
C
C     .. Scalar Arguments ..
      INTEGER MC,MI,MR,ND,T2,UMP
C     ..
C     .. Array Arguments ..
      INTEGER II(MI)
C     ..
C     .. Scalars in Common ..
      REAL A,ALPHA,B,BETA,C,DMAX,DMIN,GAMMA
      INTEGER HMAX,KMAX,KPRT,LMAX,NX,NY,NZ
C     ..
C     .. Arrays in Common ..
      REAL BID1,BID2
C     ..
C     .. Local Scalars ..
      REAL AA,AL,BB,BE,CC,GA
      INTEGER NG
C     ..
C     .. External Subroutines ..
      EXTERNAL DIMFS,GENREF,INDEXM,REFFO
C     ..
C     .. Common blocks ..
      COMMON /CELD/AD,BD,CD,BID3(16)
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /GRID/HMAX,KMAX,LMAX,NX,NY,NZ
      COMMON /IOPRG/KPRT
      COMMON /RESO/BID1(2),DMAX,DMIN,BID2(2)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      iF(UMP.NE.0) REWIND (UMP)
      READ (UMP) NX,NY,NZ,AA,BB,CC,AL,BE,GA
      IF (AA.NE.A .OR. BB.NE.B .OR. CC.NE.C .OR. AL.NE.ALPHA .OR.
     +    BE.NE.BETA .OR. GA.NE.GAMMA)
     +     CALL CCPERR(1,' > s/r datamf < incompatible cells')
C
C          *******************
C      CALL GENREF(T2,ND,II(1))
      CALL REFFO(T2,ND,II(1))
C          *******************
C
Cejd      NG = MI - ND
Cejd      IF (NG.LE.0)
Cejd     +    CALL CCPERR(1, '> s/r datamf < insufficient memory for reffo')
C
C          ******************************
Cejd      CALL REFFO(T2,NG,ND,II(1),II(1+NG))
      CALL INDEXM(DMIN,AD,BD,CD,HMAX,KMAX,LMAX)
C
      CALL DIMFS(ND,MI,MR,MC)
C          *******************************
C
      IF (KPRT.NE.0) WRITE (6,FMT=6000) NX,NY,NZ,DMIN,HMAX,KMAX,LMAX
C
 6000 FORMAT (/,
     +'              Z-Section Map',/,
     +'        ================================',//,
     +'                 Divisions of unit cell edges:',3I10,/,
     +'                              Data Resolution:',F10.3,/,
     +' Maximal indices according to data resolution:',3I5)
      END
C
C
C     =============================
      SUBROUTINE DET3(R,D)
C     ====================
C
C     .. Scalar Arguments ..
      REAL D
C     ..
C     .. Array Arguments ..
      REAL R(3,3)
C     ..
C     .. Local Scalars ..
      REAL A,B
C     ..
C
      A = R(1,1)*R(2,2)*R(3,3) + R(1,2)*R(2,3)*R(3,1) +
     +    R(3,2)*R(2,1)*R(1,3)
      B = R(1,3)*R(2,2)*R(3,1) + R(2,1)*R(1,2)*R(3,3) +
     +    R(2,3)*R(3,2)*R(1,1)
      D = A - B
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE DFTL(L,X,DTL)
C     ========================
C
C     .. Scalar Arguments ..
      REAL DTL,X
      INTEGER L
C     ..
C     .. Local Scalars ..
      REAL SBL,SBLM,SBLP
C     ..
C     .. External Subroutines ..
      EXTERNAL SBES3D
C     ..
C
C          *************************
      CALL SBES3D(L,X,SBLM,SBL,SBLP)
C          *************************
C
      DTL = (SBLM+SBLP)*SBL - SBLM*SBLP* (6*L+3)/X
      RETURN
      END
C
C
C     =============================
      SUBROUTINE DIMCS(MI,MR,MAT,MATS)
C     ================================
C
C     .. Scalar Arguments ..
      INTEGER MAT,MATS,MI,MR
C     ..
C     .. Scalars in Common ..
      REAL AD,BD,BID2,BID4,CD,DRMIN,RMIN
      INTEGER KPRT,NX,NY,NZ
C     ..
C     .. Arrays in Common ..
      REAL BID1,BID3
      INTEGER IBID1
C     ..
C     .. Local Scalars ..
      INTEGER MIC,MRC
C     ..
C     .. External Subroutines ..
      EXTERNAL CONTRG
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MIN
C     ..
C     .. Common blocks ..
      COMMON /CELD/AD,BD,CD,BID1(16)
      COMMON /GRID/IBID1(3),NX,NY,NZ
      COMMON /IOPRG/KPRT
      COMMON /RESO/BID2,DRMIN,BID3(2),RMIN,BID4
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      NX = NINT((AD/RMIN+1.0)*2.0)
      NY = NINT((BD/RMIN+1.0)*2.0)
      NZ = NINT((CD/RMIN+1.0)*2.0)
C
C          ************
      CALL CONTRG(NX,1)
      CALL CONTRG(NY,2)
      CALL CONTRG(NZ,3)
C          ************
C
      MATS = MIN(MI- (MAT+NZ), (MR-NX*NY)/4-MAT)
      IF (MATS.LE.0) MATS = MAT
      MATS = MIN(MATS,MAT)
      MIC = MAT + MATS + NZ
      MRC = (MAT+MATS)*4 + NX*NY
      IF (KPRT.NE.0) WRITE (6,FMT=6000) MIC,MI,MRC,MR
      IF (MIC.GT.MI .OR. MRC.GT.MR) THEN
        WRITE (6,FMT=6000) MIC,MI,MRC,MR
        WRITE(6,6100)
 6100   FORMAT(' > s/r dimcs < Reset TABLING_MI or TABLING_MR ')
        CALL CCPERR(1, ' > s/r dimcs < insufficient memory for dimcs')
      ENDIF
C
 6000 FORMAT (/,
     +' Dimensions for DIMCS',/,
     +' (INTEGER) TABLING_MI(required) MI(set):',2I10,/,
     +' (REAL)    TABLING_MR(required) MR(set):',2I10)
      END
C
C
C     =============================
      SUBROUTINE DIMFS(ND,MI,MR,MC)
C     =============================
C
C     .. Scalar Arguments ..
      INTEGER MC,MI,MR,ND
C     ..
C     .. Scalars in Common ..
      INTEGER HLW,HMAX,HUP,KLW,KMAX,KPRT,KUP,LLW,LMAX,
     +        LUP,NRA,NWDS,NX,NXYZ,NY,NZ,PH,PZ,T0,XLW,XUP,YLW,YUP,ZLW,
     +        ZUP
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      INTEGER MCC,MIC,MRC,MXY,MY,NH,NK,NXP2
C     ..
C     .. External Subroutines ..
      EXTERNAL DIRAXH
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MAX
C     ..
C     .. Common blocks ..
      COMMON /DFFTT/HLW,HUP,KLW,KUP,LLW,LUP,NRA,NXYZ
      COMMON /DFFTTD/PH,PZ,T0,NWDS
      COMMON /DFFTTX/BID1(6),XLW,YLW,ZLW,XUP,YUP,ZUP
      COMMON /GRID/HMAX,KMAX,LMAX,NX,NY,NZ
      COMMON /IOPRG/KPRT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF (NX.LT.2* (HMAX+1) .OR. NY.LT.2* (KMAX+1) .OR.
     +     NZ.LT.2* (LMAX+1)) THEN
        WRITE (6,6001) NX, HMAX, NY, KMAX, NZ, LMAX
        CALL CCPERR(1, 
     + ' > s/r dimfs < incompatible grid - resolution inconsistency?.') 
      END IF
C
      NXYZ = NX*NY*NZ
      NH   = HUP-HLW+1
      NK   = KUP-KLW+1
      MY   = YUP-YLW+1
      NXP2 = NX + 2
C
C          **********
      CALL DIRAXH(MR)
C          **********
C
      MIC = NRA + ND
      MXY = MAX(NXP2*MY,2*NH*NY)
      MRC = MAX(MXY*PZ,2*PH*NK*NZ)
      MCC = ND
C
         IF (KPRT.NE.0)WRITE (6,FMT=6000) MIC,MI,MRC,MR,MCC,MC
      IF (MIC.GT.MI .OR. MRC.GT.MR .OR. MCC.GT.MC) THEN
        WRITE (6,FMT=6000) MIC,MI,MRC,MR,MCC,MC
        CALL CCPERR(1,' > s/r dimfs < insufficient memory for stfndo')
      END IF 
C
 6000 FORMAT (/,
     +' Dimensions for STFNDO',/,
     +'  TABLING_MI(required)  is no_model_SFS + 100000',/,
     +' (INTEGER) TABLING_MI(required) MI(set):',2I10,/,
     +' (REAL)    TABLING_MR(required) MR(set):',2I10,/,
     +' (COMPLEX) TABLING_MC(required) MC(set):',2I10)
 6001 FORMAT (/' Resolution/grid conditions not satisfied.  Must have',
     +     ' N[xyz] >= 2([HKL]max+1),'/' but N[xyz]=', 3(I5,1X)/
     +     ' and [HKL]max=',3(I5,1X)/ ' at this resolution.')
      END
C
C
C     =============================
      SUBROUTINE DIMMS(MI,MR,MC)
C     ==========================
C
C     .. Scalar Arguments ..
      INTEGER MC,MI,MR
C     ..
C     .. Scalars in Common ..
      REAL AD,BD,BID3,CD,DMIN,RMIN
      INTEGER HMAX,KMAX,KPRT,LMAX,LX,LY,LZ,NRA,NWDS,NX,
     +        NXYZ,NY,NZ,PH,PZ,T0
C     ..
C     .. Arrays in Common ..
      REAL BID1,BID2,BID4
      INTEGER IBID1,IBID2
C     ..
C     .. Local Scalars ..
      INTEGER MCC,MIC,MRC,NK
C     ..
C     .. External Subroutines ..
      EXTERNAL CONTRG,DIRAHX
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MAX
C     ..
C     .. Common blocks ..
      COMMON /CELD/AD,BD,CD,BID1(16)
      COMMON /CHES/BID4(9),IBID2(9),LX,LY,LZ
      COMMON /DFFTT/IBID1(6),NRA,NXYZ
      COMMON /DFFTTD/PH,PZ,T0,NWDS
      COMMON /GRID/HMAX,KMAX,LMAX,NX,NY,NZ
      COMMON /IOPRG/KPRT
      COMMON /RESO/BID2(3),DMIN,RMIN,BID3
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF (RMIN.GT.DMIN) GO TO 10
      NX = NINT((AD/RMIN+1.0)*2.0)
      NY = NINT((BD/RMIN+1.0)*2.0)
      NZ = NINT((CD/RMIN+1.0)*2.0)
C
C          ************
      CALL CONTRG(NX,1)
      CALL CONTRG(NY,2)
      CALL CONTRG(NZ,3)
C          ************
C
      IF (LX.EQ.0) NX = 2
      IF (LY.EQ.0) NY = 1
      IF (LZ.EQ.0) NZ = 1
      WRITE (6,FMT=6000) RMIN,NX,NY,NZ,DMIN,HMAX,KMAX,LMAX
C
      NXYZ = NX*NY*NZ
      NK   = 2*KMAX+1
C
C          **********
      CALL DIRAHX(MR)
C          **********
C
      MIC = NRA
      MRC = MAX(2*PH*NK*NZ,NX*NY*PZ)
      MCC = NRA
      IF (KPRT.NE.0) WRITE (6,FMT=6002) MIC,MI,MRC,MR,MCC,MC
      IF (MIC.GT.MI .OR. MRC.GT.MR .OR. MCC.GT.MC)THEN
       WRITE (6,FMT=6002) MIC,MI,MRC,MR,MCC,MC
       CALL CCPERR(1,' > s/r dimms < insufficient memory ')
      END IF 
      RETURN
   10 WRITE (6,FMT=6004) DMIN,RMIN
      CALL CCPERR
     +  (1,' > s/r dimms < incompatible resolution. dmin, rmin:')
C
 6000 FORMAT (/,
     +'               Z-Section Map',/,
     +'          ===========================',//,
     +'                              Grid Resolution:',F10.3,/,
     +'                 Divisions of unit cell edges:',3I10,/,
     +'                              Data Resolution:',F10.3,/,
     +' Maximal Indices according to data resolution:',3I5)
 6002 FORMAT (
     +' Dimensions for DIMMS',/,
     +' (INTEGER) TABLING_MI(required) MI(set):',2I10,/,
     +' (REAL)    TABLING_MR(required) MR(set):',2I10,/,
     +' (COMPLEX) TABLING_MC(required) MC(set):',2I10)
 6004 FORMAT (' > S/R DIMMS < INCOMPATIBLE RES. DMIN, RMIN:',2F10.3)
      END
C
C
C
C     ========================================
      SUBROUTINE DIMRS(UHE,MHE,MI,MR,MC,MD,RR)
C     ========================================
C
C     .. Scalar Arguments ..
      INTEGER MC,MD,MHE,MI,MR,UHE
C     ..
C     .. Array Arguments ..
      REAL RR(*)
C     ..
C     .. Scalars in Common ..
      INTEGER KPRT,LMIN,LSUP,NA,NB,NDIM01,NDIM1,NDIM10,
     +        NDIM2,NDIMT,NG,NL,NLT,NQ,NSR1,NSR2,NSYM1,NSYM2,NXLS
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      REAL A,ALPHA,B,BETA,C,DMAX1,DMAX2,DMIN1,DMIN2,DRMAX1,DRMAX2,
     +     DRMIN1,DRMIN2,FMAX,FMIN,GAMMA,RCHECK,RMAX1,RMAX2,RMIN1,RMIN2,
     +     TFAC
      INTEGER ICHECK,IP1,IP2,IXL,L,LMAX,LMAX1,LMAX2,LS1,LS2,MB,MCC,MDC,
     +        MIC,MRC,N,NCODE,NDIM00,NDIM11,NQ1,NQ2,NSY1,NSY2,NSYM
C     ..
C     .. External Subroutines ..
      EXTERNAL ANGULO,CONTRR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,MAX,MIN,NINT
C     ..
C     .. Common blocks ..
      COMMON /DROTT/NXLS,NL,NQ,NLT,NA,NB,NG,LMIN,LSUP,NDIMT,NDIM10,NDIM01
      COMMON /IOPRG/KPRT
      COMMON /XALS/BID1(2),NSYM1,NSYM2,NSR1,NSR2,NDIM1,NDIM2
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IXL = 1
      IF(UHE.NE.0) REWIND (UHE)
      READ (UHE) A,B,C,ALPHA,BETA,GAMMA,LMAX1,NQ1,NSYM1,NCODE,
     +  DRMAX1,DRMIN1,RMIN1,RMAX1,TFAC,DMAX1,DMIN1
      IF (KPRT.NE.0) WRITE (6,FMT=6000) IXL,A,B,C,ALPHA,BETA,GAMMA,
     +    NCODE,NSYM1,DRMAX1,DRMIN1,RMIN1,RMAX1,TFAC,DMAX1,DMIN1
C
      IF (NXLS.NE.1) THEN
        IXL = 2
        IF(MHE.NE.0) REWIND (MHE)
        READ (MHE) A,B,C,ALPHA,BETA,GAMMA,LMAX2,NQ2,NSYM2,NCODE,
     +    DRMAX2,DRMIN2,RMIN2,RMAX2,TFAC,DMAX2,DMIN2
C
        IF (KPRT.NE.0) WRITE (6,FMT=6000) IXL,A,B,C,ALPHA,BETA,
     +      GAMMA,NCODE,NSYM2,DRMAX2,DRMIN2,RMIN2,RMAX2,TFAC,
     +      DMAX2,DMIN2
        ICHECK = ABS(LMAX2-LMAX1) + ABS(NQ2-NQ1)
        RCHECK = (ABS(DRMIN2-DRMIN1)+ABS(RMIN2-RMIN1)+ABS(RMAX2-RMAX1))*
     +           1000
        IF (ICHECK+NINT(RCHECK).NE.0) GO TO 60
      ELSE
        NSYM2 = NSYM1
      END IF
C
      LMAX = LMAX1
      NQ   = NQ1
      LMIN = 2* (LMIN/2)
      LSUP = 2* (LSUP/2)
C
      LMIN = MAX(LMIN,2)
      LSUP = MIN(LSUP,LMAX)
      IF(LSUP.LT.LMAX) THEN
        CALL CCPERR(2,' Upper Bessel limit truncated')
        WRITE(6,6002)  LMAX,LMIN,LSUP
      END IF
      IF (KPRT.NE.0) WRITE (6,FMT=6002) LMAX,LMIN,LSUP
      IF (LMIN.GT.LSUP) GO TO 70
      NSYM = MAX(NSYM1,NSYM2)
C
      IF (NSYM.GT.1) THEN
C
        IP1 = 0
        IP2 = 0
        NSY1 = NSYM1
        NSY2 = NSYM2
C
   10   IF ((NSY1/2)*2.EQ.NSY1) THEN
          IP1 = IP1 + 1
          NSY1 = NSY1/2
          GO TO 10
        END IF
C
   20   IF ((NSY2/2)*2.EQ.NSY2) THEN
          IP2 = IP2 + 1
          NSY2 = NSY2/2
          GO TO 20
        END IF
C
        NSYM = 2**MAX(IP1,IP2)
C
        IP1 = 0
        IP2 = 0
C
   30   IF ((NSY1/3)*3.EQ.NSY1) THEN
          IP1 = IP1 + 1
          NSY1 = NSY1/3
          GO TO 30
        END IF
C
   40   IF ((NSY2/3)*3.EQ.NSY2) THEN
          IP2 = IP2 + 1
          NSY2 = NSY2/3
          GO TO 40
        END IF
        NSYM = 3**MAX(IP1,IP2)*NSYM
      END IF
C
      N = MAX(NA, (LSUP+1)*2)/NSYM1
C
C          **************
      CALL CONTRR(N,NSYM)
C          **************
C
      NA = N*NSYM1
      NG = ((N*NSYM1)/NSYM2)*NSYM2
C
      IF (NA.NE.NG) GO TO 80
      MB = ABS(NB)
      IF (MB.EQ.0) MB = LSUP + 1
      IF (MR.LT.5*MB .OR. MD.LT.2*MB) GO TO 90
C
C          *********************
      CALL ANGULO(MB,RR(1+4*MB))
C          *********************
C
      NDIM1 = 0
      NDIM2 = 0
      NDIM00 = 0
      NDIM10 = 0
      NDIM01 = 0
      NDIM11 = 0
C
      DO 50 L = LMIN,LSUP,2
        LS1 = L/NSYM1
        LS2 = L/NSYM2
        NDIM1 = (2*LS1+1)* (L+1) + NDIM1
        NDIM2 = (2*LS2+1)* (L+1) + NDIM2
        NDIM00 = (2*LS2+1)* (LS1+1) + NDIM00
        NDIM10 = (2*LS2+1)* (L+1) + NDIM10
        NDIM01 = (2*L+1)* (LS1+1) + NDIM01
        NDIM11 = (2*L+1)* (L+1) + NDIM11
   50 CONTINUE
C
      IF (NSR1.EQ.0 .AND. NSR2.EQ.0) NDIMT = NDIM00
      IF (NSR1.NE.0 .AND. NSR2.EQ.0) NDIMT = MAX(NDIM1,NDIM10)
      IF (NSR1.EQ.0 .AND. NSR2.NE.0) NDIMT = MAX(NDIM2,NDIM01)
      IF (NSR1.NE.0 .AND. NSR2.NE.0) NDIMT = NDIM11
C
      NL = LSUP+1
      NLT = 2*LSUP+1
C
      IF (NSR1.EQ.0) NA = NA/NSYM1
      IF (NSR2.EQ.0) NG = NG/NSYM2
      MIC = NL*NLT
      MRC = NDIMT + NG + NA + 5*NB
      MCC = MAX(2*NL*NQ,NG*NA/2) + NDIMT
      MDC = (NL+3)*NLT
      IF (KPRT.NE.0) WRITE (6,FMT=6004) MIC,MI,MRC,MR,MCC,MC,MDC,MD
      IF (MI.LT.MIC .OR. MR.LT.MRC .OR. MC.LT.MCC .OR.
     +    MD.LT.MDC) THEN
       WRITE (6,FMT=6004) MIC,MI,MRC,MR,MCC,MC,MDC,MD
      CALL CCPERR(1,' > s/r dimrs < insufficient memory for rotats')
      END IF 
      RETURN
C
C          *********************************************************
   60 CALL CCPERR(1,' > s/r dimrs < incoherent harmonic coefficients')
   70 CALL CCPERR(1,' > s/r dimrs < impossible l-limits')
C          *********************************************************
C
   80 WRITE (6,FMT=6010) NA,NG
C
C          **************************************************
      CALL CCPERR(1,' > s/r dimrs < different nb. of pixels:')
C          ***************************************************
C
   90 WRITE (6,FMT=6012) 5*MB,MR,2*MB,MD
C
C          *****************************************************
      CALL CCPERR(1,
     +  ' > s/r dimrs < insufficient memory for angulo. mr, md:')
C          *********************************************************
C
 6000 FORMAT (/,
     +' Parameters of ELMN for XTAL:',I5,/,
     +'   Cell parameters:',6F10.3,/,
     +'   Z-Axis orientation (NCODE) and symmetry (NSYM):',
     +       I5,' and',I5,/,
     +'   Requested Resolution between   ',F10.3,' and',F10.3,/,
     +'            Inner and Outer radii:',F10.3,' and',F10.3,/,
     +'   Temperature B-Factor:',F10.3,/,
     +'   Experimental Resolution between',F10.3,' and',f10.3)
 6002 FORMAT (/,
     +' Angular Resolution of COEFF. (LMAX):',I5,/,
     +' Requested limits. LMIN:',I5,', LSUP:',I5)
 
 6004 FORMAT (
     +' Dimensions set in DIMRS for ROTATS',/,
     +' (INTEGER)          ROTING_MI(required) MI(set):',2I10,/,
     +' (REAL)             ROTING_MR(required) MR(set):',2I10,/,
     +' (COMPLEX)          ROTING_MC(required) MC(set):',2I10,/,
     +' (DOUBLE PRECISION) ROTING_MD(required) MD(set):',2I10)
 6010 FORMAT (' > S/R DIMRS < DIFFERENT NB. OF PIXELS:',2I10)
 6012 FORMAT (
     +' Dimensions set in DIMRS for ANGULO',/,
     +' (REAL)             ROTING_MR(required) MR(set):',2I10,/,
     +' (DOUBLE PRECISION) ROTING_MD(required) MD(set):',2I10)
      END
C
      subroutine dimss(UDI,nd,mi,mr,mc,md,ii,rr)
      implicit none
      integer j,mi,mr,lsup,ml,nd,kprt,i,ncode,nsym,neqp,kprtp,is,
     & ij,mss,itr,isym,npr,npa,ii2,ir2,ir3,ir4,ir5,lmax,kprtt,l,nl,udi,
     & lx,mic,nr,mrc,nq,mcc,mdc,mc,md,iout,nts,ii(mi),mii,mrr
      real twopi,fuzz,xsup,divb,divh,a,b,c,alpha,beta,gamma,det,ro,rf,
     & xhi,pctr,tfac,drmax,drmin,rmin,rmax,t,xmax,xmin,dmax,dmin,rbid1,
     & fmin,fmax,rr(mr),rota(9),ver(3),rots(3,3),pi,dtor,rtod,tss,tts
      character cbid1*1,title(72)*1
      common/oprt/ kprtt(20)
      common/ioprg/ kprt
      common/cell/ a,b,c,alpha,beta,gamma
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      common/ortm/ ro(9),rf(9),ncode
      common/reso/ drmax,drmin,dmax,dmin,rmin,rmax
      common/dsph/ nr,nl,nq,npr,npa,lmax
      common/ctlx/ nsym,fmin,fmax,tfac
      common/ctlf/ divb,divh
      common/angkte/ pi,twopi,dtor,rtod
      pctr=100
      lsup=212
      xsup=200.
      fuzz=0.0001
      ml=lsup
      divb=30.
      divh=10.
      if(mi.lt.nd+2*ml.or.mr.lt.nd+4*ml) go to 901
c      read(ilec,fmt='(72a1)') title
c      if(kprt.ne.0) write(6,2010) (title(i),i=1,71)
c      read(ilec,*) a,b,c,alpha,beta,gamma
c      call celda
c      call lecsim
c      call setpak
c      read(ilec,*) nort
c      call ortho
      nsym=1
         if(neqp.gt.1) then
      kprtp=kprt
      kprt=0
      do 20 is=2,neqp
      do 10 i=1,3
      do 10 j=1,3
      rots(i,j)=mss(i,j,is)
10    continue
      call det3(rots,det)
      itr=mss(1,1,is)+mss(2,2,is)+mss(3,3,is)
      if(nint(det).ne.1.or.itr.gt.2) go to 20
      call pro3mx(rota,ro,rots,rf)
      call rmx2p(rota,xhi,ver,.FALSE.)
      if(abs(1-abs(ver(3))).ge.fuzz) go to 20
      isym=360/nint(abs(xhi))
      nsym=max(nsym,isym)
20    continue
      kprt=kprtp
         endif
      if(kprt.ne.0) write(6,2020) nsym
c      read(ilec,*) pctr,tfac
c      read(ilec,*) drmax,drmin,rmin,rmax
c         if(drmax.lt.drmin) then
c      t=drmax
c      drmax=drmin
c      drmin=t
c         endif
c         if(rmax.lt.rmin) then
c      t=rmax
c      rmax=rmin
c      rmin=t
c         endif
      xmax=twopi*rmax/drmin
      xmin=twopi*rmin/drmin
      if(xmax.gt.xsup) go to 902
      if(kprt.ne.0) write(6,2030) drmax,drmin,rmin,rmax,xmin,xmax,
     . xsup
      npr=nint(xmax*divb)
      npa=nint(180*divh)
      npa=2*(npa/2)
      ii2=1+nd
      ir2=1+nd
      ir3=1+nd+ml
      ir4=1+nd+2*ml
      ir5=1+nd+3*ml
      lmax=0
      call tllim(ml,rr(ir2),rr(ir3),rr(ir4),rr(ir5))
      call lqmax(ml,ii(ii2),rr(ir2),rr(ir3))
      kprt=kprtt(2)
      if(kprt.ne.0) write(6,2040) (l,rr(nd+l),rr(nd+ml+l),
     . rr(nd+2*ml+l),rr(nd+3*ml+l),ii(nd+l),ii(nd+nl+l),l=2,lmax,2)
      dmax=drmax
      dmin=drmin
      call lecfor(UDI,nd,mr-nd-nl,ii(1),rr(1),rr(ir2+nl),dmax,dmin)
      if(kprt.ne.0) write(6,2050) pctr,tfac,dmax,dmin
      if(dmax.le.dmin) go to 903
      lx=lmax+1
      mic=nd+2*nl+nr*(1+2*neqp)
      mrc=nd+2*nl+2*nr+nq*(npr+4)+(npa+1)*lx
      mcc=2*lx*nq+(2*npa+1)
      mdc=2*lx
      if(kprt.ne.0) write(6,2060) mic,mi,mrc,mr,mcc,mc,mdc,md,
     . nl,nq,nr,npr+1, npa+1
      if(mic.gt.mi.or.mrc.gt.mr.or.mcc.gt.mc.or.mdc.gt.md) go to 904
      return
901   continue
       mii = nd+2*ml
       mrr = nd+4*ml
       write(6,3010)mii,mi,mrr,mr
      call ccperr(1,' dimss << insufficient memory')
902   write(6,3020)
      call ccperr(1,' Failure in s/r DIMSS')
903   write(6,3030)
      call ccperr(1,' Failure in s/r DIMSS')
904   write(6,3040) mic,mi,mrc,mr,mcc,mc,mdc,md
      call ccperr(1,' dimss << insufficient memory for sphars')
2010  format(/' crystal ',71a1)
2020  format(/' z-axis rotation symmetry =',i5)
2030  format(/' requested resolution between',f10.3,' and',f10.3/
     . ' inner radius =',f10.3,', outer radius =',f10.3/
     . ' 2*pi*radii/resolution =',f10.3,'-',f10.3,
     . ', tested maximum =',f10.3)
2040  format(' l-order, arguments of (1e-4, 75e-2, 1e0)tl-max, tl-max,',
     . ' nb. of terms'/100(/i5,3f10.3,e15.5,2i5))
2050  format(' percentage of reflections =',f10.3/
     . ' temperature b-factor =',f10.3/
     . ' experimental resolution between',f10.3,' and',f10.3)
2060  FORMAT (
     +' Dimensions set in DIMSS for SPHARS',/,
     +' (INTEGER)          ROTING_MI(required) MI(set):',2I10,/,
     +' (REAL)             ROTING_MR(required) MR(set):',2I10,/,
     +' (COMPLEX)          ROTING_MC(required) MC(set):',2I10,/,
     +' (DOUBLE PRECISION) ROTING_MD(required) MD(set):',2I10,/,
     . ' max-l term =',i5,/
     . ' max-n term =',i5,/
     . ' nb. of ref. =',i6/
     . ' tab. val. of sph. bess. =',i5,/
     . ' tab. val. of sph. harm. =',i5)
 3010 FORMAT (
     +' Dimensions set in DIMSS',/,
     +' (INTEGER)          ROTING_MI(required) MI(set):',2I10,/,
     +' (REAL)             ROTING_MR(required) MR(set):',2I10)
3020  format('stop >> dimss << rmax/max-res too big')
3030  format('stop >> dimss << resolution limits not found in data')
3040  FORMAT (
     +' Dimensions set in DIMSS for SPHARS',/,
     +' (INTEGER)          ROTING_MI(required) MI(set):',2I10,/,
     +' (REAL)             ROTING_MR(required) MR(set):',2I10,/,
     +' (COMPLEX)          ROTING_MC(required) MC(set):',2I10,/,
     +' (DOUBLE PRECISION) ROTING_MD(required) MD(set):',2I10)
      end
C     =============================
      SUBROUTINE DIRAHX(MR)
C     =====================
C
C     .. Scalar Arguments ..
      INTEGER MR
C     ..
C     .. Scalars in Common ..
      INTEGER HMAX,KMAX,KPRT,LMAX,NWDS,NX,NXYZ,NY,NZ,PH,
     +        PZ,T0
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1
C     ..
C     .. Local Scalars ..
      INTEGER MAXR,MINR,NH,NK,NREC,NWDSM
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MAX,MIN,REAL,SQRT
C     ..
C     .. Common blocks ..
      COMMON /DFFTT/IBID1(7),NXYZ
      COMMON /DFFTTD/PH,PZ,T0,NWDS
      COMMON /GRID/HMAX,KMAX,LMAX,NX,NY,NZ
      COMMON /IOPRG/KPRT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      NH = HMAX+1
      NK = 2*KMAX+1
      NWDSM = 1000000
      T0 = 0
C
      IF (MR.GE.NXYZ) THEN
        PH = NH
        PZ = NZ
        RETURN
      END IF
C
      MINR = MAX(2*NK*NZ,NX*NY)
      IF (MR.LT.MINR) GO TO 10
      MAXR = NINT(SQRT(ABS(REAL(NWDSM))) *SQRT(ABS(REAL(NXYZ))) )
C
      IF (MR.GT.MAXR) THEN
        PH = MIN(MAXR/ (2*NK*NZ),NH)
        PZ = MIN(MAXR/ (NX*NY),NZ)
      ELSE
        PH = MIN(MR/ (2*NK*NZ),NH)
        PZ = MIN(MR/ (NX*NY),NZ)
      END IF
C
      NWDS = 2*PH*NK*PZ
      NREC = ((NH-1)/PH+1)* ((NZ-1)/PZ+1)
      IF (KPRT.NE.0) WRITE (6,FMT=6000) PH,PZ,NWDS,NREC
      RETURN
   10 WRITE (6,FMT=6002) MINR,MR
C
C          ****************************************************
      CALL CCPERR(1,
     +     ' > s/r dirahx < insufficient memory. Reset mr:')
C          ****************************************************
C
 6000 FORMAT (/,
     +' Direct access. pages(PH,PZ):',2I5,', WORDS:',I10,', R',
     +       'ECDS:',I5)
 6002 FORMAT (
     +' Dimensions set in DIRAHX ',/,
     +' (REAL)             ROTING_MR(required) MR(set):',2I10)
C
      END
C
C
C     =============================
      SUBROUTINE DIRAXH(MR)
C     =====================
C
C     .. Scalar Arguments ..
      INTEGER MR
C     ..
C     .. Scalars in Common ..
      INTEGER HLW,HUP,KLW,KPRT,KUP,NWDS,NX,NXYZ,NY,NZ,PH,
     +        PZ,T0,XLW,XUP,YLW,YUP,ZLW,ZUP
C     ..
C     .. Arrays in Common ..
      REAL BID1
      INTEGER IBID1,IBID2
C     ..
C     .. Local Scalars ..
      INTEGER MAXR,MINR,MXY,MXYZ,MY,MZ,NH,NK,NREC,NWDSM,NXP2
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MAX,MIN,REAL,SQRT
C     ..
C     .. Common blocks ..
      COMMON /DFFTT/HLW,HUP,KLW,KUP,IBID2(3),NXYZ
      COMMON /DFFTTD/PH,PZ,T0,NWDS
      COMMON /DFFTTX/BID1(6),XLW,YLW,ZLW,XUP,YUP,ZUP
      COMMON /GRID/IBID1(3),NX,NY,NZ
      COMMON /IOPRG/KPRT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      NH = HUP-HLW+1
      NK = KUP-KLW+1
      MY = YUP-YLW+1
      MZ = ZUP-ZLW+1
      NWDSM = 1000000
      T0 = 0
      NXP2 = NX + 2
C
      MXY = MAX(NXP2*MY,2*NH*NY)
      MXYZ = MAX(MXY*MZ,2*NH*NK*NZ)
C
      IF (MR.GE.MXYZ) THEN
        PH = NH
        PZ = MZ
        RETURN
      END IF
C
      MINR = MAX(MXY,2*NK*NZ)
      IF (MR.LT.MINR) GO TO 10
      MAXR = NINT(SQRT(ABS(REAL(MXY*NZ))) *SQRT(ABS(REAL(NWDSM))) )
C
      IF (MR.GT.MAXR) THEN
        PZ = MIN(MAXR/MXY,MZ)
        PH = MIN(MAXR/ (2*NK*NZ),NH)
      ELSE
        PZ = MIN(MR/MXY,MZ)
        PH = MIN(MR/ (2*NK*NZ),NH)
      END IF
C
      NWDS = 2*PH*NK*PZ
      NREC = ((NH-1)/PH+1)* ((MZ-1)/PZ+1)
      IF (KPRT.NE.0) WRITE (6,FMT=6000) PH,PZ,NWDS,NREC
      RETURN
   10 WRITE (6,FMT=6002) MINR,MR
C
C          ****************************************************
      CALL CCPERR(1,
     +     ' > s/r diraxh < insufficient memory. Reset mr:')
C          ****************************************************
C
 6000 FORMAT (/,
     +' Direct access. pages(PH,PZ):',2I5,', WORDS:',I10,', R',
     +       'ECDS:',I5)
 6002 FORMAT (
     +' Dimensions set in DIRAXH ',/,
     +' (REAL)             ROTING_MR(required) MR(set):',2I10)
      END
C
C
C     =============================
      SUBROUTINE DLMMS(BETA,NDIMT,LMAX,IEX,DLMM,FACT,PSIN,PCOS,DMM)
C     =============================================================
Cejd - Jorge has most of this as double precision.. DSIN DLOG etc
C
C     =============================
C
C     .. Scalar Arguments ..
      REAL BETA
      INTEGER LMAX,NDIMT
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION DMM(0:LMAX,-LMAX:LMAX),FACT(0:2*LMAX),
     +                 PCOS(0:2*LMAX),PSIN(0:2*LMAX)
      REAL DLMM(NDIMT)
      INTEGER IEX(0:LMAX,-LMAX:LMAX)
C     ..
C     .. Scalars in Common ..
      INTEGER LMIN,LSUP,NSYM1,NSYM2
C     ..
C     .. Arrays in Common ..
      REAL BID1
      INTEGER IBID1,IBID2,IBID3
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION ANG,COSD,E0,E1,LCOS,LSIN,SIND,V0,V1,VSIN,W0,W1
      REAL PI
      INTEGER I,IT,K0,K1,KSIN,L,M1,M2
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,COS,DBLE,EXP,INT,LOG,MOD,SIGN,SIN,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /DROTT/IBID1(7),LMIN,LSUP,IBID2(3)
      COMMON /XALS/BID1(2),NSYM1,NSYM2,IBID3(4)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA E0/0.2718281828459045D1/,
     +     E1/0.3678794411714423D0/
C     ..
C
      FUZZ = 0.00001
       if(abs(beta).LE.FUZZ ) beta = 0.0
       if(abs(beta-PI).LE.FUZZ ) beta = PI
      IF (BETA.LT.0.0 .OR. BETA.GT.PI) GO TO 230
      IF (ABS(BETA).LE.FUZZ .OR. ABS(BETA-PI).LE.FUZZ) GO TO 20
      ANG = DBLE(BETA)
      LSIN = LOG(SIN(ANG/2))
      LCOS = LOG(COS(ANG/2))
      SIND = SIN(ANG)
      COSD = COS(ANG)
      PSIN(0) = 0.0D0
      PCOS(0) = 0.0D0
      FACT(0) = 0.0D0
C
      DO 10 I = 1,2*LSUP
        PSIN(I) = PSIN(I-1) + LSIN
        PCOS(I) = PCOS(I-1) + LCOS
        FACT(I) = FACT(I-1) + LOG(DBLE(I))
   10 CONTINUE
C
      W0 = -LOG(SIND/2)
      K0 = INT(W0)
      W0 = MOD(W0,1.0D0)
C
      IF (W0.GT.0.0D0) THEN
        K0 = K0 + 1
        W0 = W0 - 1
      END IF
C
      KSIN = K0
      VSIN = EXP(W0)
   20 IT = 0
C
      DO 220 L = LMIN,LSUP,2
        DO 40 M1 = 0,L
          DO 30 M2 = -L,L
            IEX(M1,M2) = 0
            DMM(M1,M2) = 0.0D0
   30     CONTINUE
   40   CONTINUE
C
      IF (ABS(BETA).LE.FUZZ)GO TO 150
      IF (ABS(BETA-PI).LE.FUZZ) GO TO 170
C
        DO 50 M2 = -L,L
          W0 = (FACT(2*L)-FACT(L+M2)-FACT(L-M2))/2 + PSIN(L-M2) +
     +         PCOS(L+M2)
          K0 = INT(W0)
          W0 = MOD(W0,1.0D0)
C
          IF (W0.GT.0.0D0) THEN
            K0 = K0 + 1
            W0 = W0 - 1
          END IF
C
          IEX(L,M2) = K0
          DMM(L,M2) = (-1)**MOD(L-M2,2)*EXP(W0)
   50   CONTINUE
C
        W0 = VSIN/SQRT(ABS(DBLE(2*L)) )
C
        DO 80 M2 = - (L-1),L - 1
          K0 = IEX(L,M2) + KSIN
          V0 = DMM(L,M2)
          V1 = (M2-L*COSD)*W0*V0
          V0 = ABS(V1)
C
          IF (V0.GT.1.0D0) THEN
   60       K0 = K0 + 1
            V0 = V0*E1
            IF (V0.GT.1.0D0) GO TO 60
          END IF
C
          IF (V0.LT.E1) THEN
   70       K0 = K0 - 1
            V0 = V0*E0
            IF (V0.LT.E1) GO TO 70
          END IF
C
          IEX(L-1,M2) = K0
          DMM(L-1,M2) = SIGN(V0,V1)
   80   CONTINUE
C
        DO 120 M1 = L - 1,1,-1
          W1 = -SQRT(ABS((L+M1+1)* (L-M1)/DBLE((L-M1+1)* (L+M1))) )
          W0 = VSIN/SQRT(ABS(DBLE((L-M1+1)* (L+M1))) )
C
          DO 110 M2 = - (M1-1),M1 - 1
            K1 = IEX(M1+1,M2)
            V1 = DMM(M1+1,M2)
            K0 = IEX(M1,M2) + KSIN
            V0 = DMM(M1,M2)
C
            IF (K0.GT.K1) THEN
              V1 = EXP(DBLE(K1-K0))*V1
            ELSE IF (K1.GT.K0) THEN
              V0 = EXP(DBLE(K0-K1))*V0
              K0 = K1
            END IF
C
            V1 = (M2-M1*COSD)*W0*V0 + W1*V1
            V0 = ABS(V1)
C
            IF (V0.GT.1.0D0) THEN
   90         K0 = K0 + 1
              V0 = V0*E1
              IF (V0.GT.1.0D0) GO TO 90
            END IF
C
            IF (V0.LT.E1) THEN
  100         K0 = K0 - 1
              V0 = V0*E0
              IF (V0.LT.E1) GO TO 100
            END IF
C
            IEX(M1-1,M2) = K0
            DMM(M1-1,M2) = SIGN(V0,V1)
  110     CONTINUE
  120   CONTINUE
C
        DO 140 M1 = 1,L
          DO 130 M2 = 0,M1 - 1
            IEX(M2,M1) = IEX(M1,M2)
            DMM(M2,M1) = (-1)**MOD(M1-M2,2)*DMM(M1,M2)
            IEX(M2,-M1) = IEX(M1,-M2)
            DMM(M2,-M1) = DMM(M1,-M2)
  130     CONTINUE
  140   CONTINUE
C
        GO TO 190
C
  150   DO 160 M1 = 0,L
          DMM(M1,M1) = 1
  160   CONTINUE
C
        GO TO 190
C
  170   DO 180 M1 = 0,L
          DMM(M1,-M1) = (-1)**MOD(L-M1,2)
  180   CONTINUE
C
  190   DO 210 M1 = 0,L,NSYM1
          DO 200 M2 = -L,L
            IF (MOD(M2,NSYM2).NE.0) GO TO 200
            K0 = IEX(M1,M2)
            V0 = DMM(M1,M2)
            IT = IT + 1
C
            IF (K0.LT.-37) THEN
              DLMM(IT) = 0.0
            ELSE
              DLMM(IT) = REAL(EXP(DBLE(K0))*V0)
            END IF
  200     CONTINUE
  210   CONTINUE
  220 CONTINUE
C
      IF (IT.NE.NDIMT) GO TO 240
      RETURN
C
C          ****************************************************
  230 CALL CCPERR(1,' > s/r dlmms < domain of beta is (0-180)')
C          ****************************************************
C
  240 WRITE (6,FMT=6002) IT,NDIMT
C
C          ***********************************************
      CALL CCPERR(1,' > s/r dlmms < mismatch. it, ndimt:')
C          ***********************************************
C
 6002 FORMAT (' > S/R DLMMS < MISMATCH. IT, NDIMT:',2I10)
      END
C     ======================
      REAL FUNCTION ERRFN(X)
C     ======================
C
C     .. Scalar Arguments ..
      REAL X
C     ..
C     .. Local Scalars ..
      REAL A,B,C,EPS
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C     ..
C
      A = 4.0/3.0
   10 B = A - 1.0
      C = B + B + B
      EPS = ABS(C-1.0)
      IF (EPS.EQ.0.0) GO TO 10
C
C     *******************
      ERRFN = ABS(X)*EPS
C     *******************
C
      RETURN
      END
C
C
      subroutine elmns(UDI,UHE,nd,nl,nr,nq,ns,npr,npa,lmax,hklo,nmax,
     & nmin,hkl,mfo,atl2,mfs,rh,sbl,buxn,auxn,norsq,ylm,aux,eblmn,ealmn,
     & cex,dd)
C      implicit none
      integer nd,nl,nr,ns,nq,npr,npa,lmax,indo,indo2,npa2,ir,UDI,m,i,k,
     & h,l,mul,kk,ll,is,neqp,mss,indd,indi,im,iat,iap,kprt,nqt,nsym,
     & nort,nts,nn,mm,nin,n,iab,miap,iout,ilec,UHE,hklo(nd),nmax(nl),
     & nmin(nl),hkl(nr,1+2*ns),hh,ind(48)
      real pi,twopi,rhmin,drmax,rhmax,drmin,rap,rmin,rmax,a2pi,scale,
     & vol,sqh,a31,a32,a33,a21,a22,a11,rsqh,ff,tfac,fmin,fmax,xh,rf,xk,
     & xl,cost,teta,phi,a,b,c,alpha,beta,gamma,pctr,dmax,dmin,tss,tts,
     & scale3,sh,divb,psum,rbid1,ro,divh,mfo(nd),atl2(nl),mfs(nr),
     & rh(nr),sbl(nq,0:npr),buxn(nq),auxn(nq),norsq(nl),ylm(0:npa,
     & 0:lmax),aux(2*nq+2),norme,dtor,rtod,aa,TTTSSS(3,3)
      complex eblmn(0:lmax,nq),ealmn(0:lmax,nq),cex(0:2*npa),fylm
      double precision dd(*)
      logical first,inn
      character cbid1*1
      common/ioprg/ kprt
      common/cell/ a,b,c,alpha,beta,gamma
      common/celd/ rbid1(18),vol
      common/simt/ tss(3,48),tts(3,3),mss(3,3,48),neqp,nts
      common/ortm/ ro(3,3),rf(3,3),nort
      common/star/ a11,a21,a22,a31,a32,a33
      common/reso/ drmax,drmin,dmax,dmin,rmin,rmax
      common/ctlx/ nsym,fmin,fmax,tfac
      common/ctlf/ divb,divh
      common/angkte/ pi,twopi,dtor,rtod
      call pac3(0,0,0,indo)
      indo2=2*indo
      npa2=2*npa
      ir=0
      rhmin=1/drmax
      rhmax=1/drmin
      rap=rmin/rmax
      a2pi=twopi*rmax
      scale=sqrt(2*twopi)/vol
      if(udi.ne.0) rewind(unit=UDI)
      READ (UDI)AA,BB,CC,AALL,BBEE,GGAA
      READ (UDI)NTTTSSS,NNEEQQPP
      IF(NTTTSSS.GT.0) READ(UDI) AA
      READ (UDI)HMM,KMM,LMM,NHH,NKK,NLL,NMM,DMMiNN
 10   READ (UDI,END=60) M, (HKLO(I),I=1,M), (MFO(I),I=1,M)
      do 50 i=1,m
      call unpac4(h,k,l,mul,hklo(i))
      if(mul.eq.1) go to 50
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      rsqh=sqrt(sqh)
      if(rsqh.lt.rhmin.or.rsqh.gt.rhmax) go to 50
      ff=mfo(i)
      if(tfac.ne.0.) ff=ff*exp(-tfac*sqh/4)
      if(ff.lt.fmin.or.ff.gt.fmax) go to 50
      ff=ff*ff
      ir=ir+1
      if(ir.gt.nr) go to 901
      mfs(ir)=ff
      rh(ir)=rsqh*a2pi
      hh=h
      kk=k
      ll=l
      mul=1
      call pac3(hh,kk,ll,ind(1))
      do 40 is=1,neqp
      if(is.eq.1) go to 30
      hh=h*mss(1,1,is)+k*mss(2,1,is)+l*mss(3,1,is)
      kk=h*mss(1,2,is)+k*mss(2,2,is)+l*mss(3,2,is)
      ll=h*mss(1,3,is)+k*mss(2,3,is)+l*mss(3,3,is)
      call pac3(hh,kk,ll,indd)
      indi=indo2-indd
      do 20 im=1,mul
      if(ind(im).eq.indd.or.ind(im).eq.indi) go to 40
20    continue
      mul=mul+1
      ind(mul)=indd
30    xh=hh*rf(1,1)+kk*rf(2,1)+ll*rf(3,1)
      xk=hh*rf(1,2)+kk*rf(2,2)+ll*rf(3,2)
      xl=hh*rf(1,3)+kk*rf(2,3)+ll*rf(3,3)
      cost=xl/rsqh
      if(abs(cost).gt.1.) cost=sign(1.,xl)
      teta=acos(cost)
      iat=nint(npa*teta/pi)
      phi=0.
      if(xk.ne.0..or.xh.ne.0.) phi=atan2(xk,xh)
      phi=amod(phi+twopi,twopi)
      iap=nint(npa2*phi/twopi)
      hkl(ir,2*mul)=iat
      hkl(ir,2*mul+1)=iap
40    continue
      hkl(ir,1)=mul
50    continue
      go to 10
60    if(ir.ne.nr) go to 901
      if(kprt.ne.0) write(6,2010) nr
      nqt=nmax(2)+nmin(2)
      if(uhe.ne.0) rewind(unit=uhe)
      write(uhe) a,b,c,alpha,beta,gamma,
     . lmax,nqt,nsym,nort,drmax,drmin,rmin,rmax,
     . tfac,dmax,dmin,tss,tts,mss,neqp,nts
      first=.true.
      scale3=scale*rap**(3./2.)
      call sphbes(nq,npr,sbl,aux,buxn)
      do 190 l=2,nl,2
      call sphhar(l,npa,lmax,ylm,cex,dd(1),first)
      nn=nmax(l)
      mm=nmin(l)
      nin=l/2-1
      do 80 n=1,nn
      buxn(n)=0.
      auxn(n)=0.
      do 70 m=0,l
      eblmn(m,n)=0.
      ealmn(m,n)=0.
70    continue
80    continue
      do 150 ir=1,nr
      inn=mm.ne.0
      if(rh(ir).lt.atl2(l)) go to 150
      if(rh(ir)*rap.lt.atl2(l)) inn=.false.
      sh=rh(ir)*divb
      iab=nint(sh)
      do 90 n=1,nn
      buxn(n)=mfs(ir)*sbl(nin+n,iab)
90    continue
         if(inn) then
      iab=nint(sh*rap)
      do 100 n=1,mm
      auxn(n)=mfs(ir)*sbl(nin+n,iab)
100   continue
         endif
      mul=hkl(ir,1)
      do 140 is=2,2*mul,2
      iat=hkl(ir,is)
      iap=hkl(ir,is+1)
      do 130 m=0,l,nsym
      miap=mod(m*iap,npa2)
      fylm=ylm(iat,m)*cex(miap)
      do 110 n=1,nn
      eblmn(m,n)=eblmn(m,n)+buxn(n)*fylm
110   continue
         if(inn) then
      do 120 n=1,mm
      ealmn(m,n)=ealmn(m,n)+auxn(n)*fylm
120   continue
         endif
130   continue
140   continue
150   continue
      inn=mm.ne.0
      norsq(l)=0.
      do 180 n=1,nn
      aux(n)=0.
      do 160 m=0,l,nsym
      eblmn(m,n)=eblmn(m,n)*scale
      psum=cabs(eblmn(m,n))**2
      if(m.ne.0) psum=psum*2
      aux(n)=aux(n)+psum
160   continue
         if(n.le.mm) then
      do 170 m=0,l,nsym
      ealmn(m,n)=ealmn(m,n)*scale3
      psum=cabs(ealmn(m,n))**2
      if(m.ne.0) psum=psum*2
      aux(n)=aux(n)-psum
170   continue
         endif
      norsq(l)=norsq(l)+aux(n)
180   continue
      if(kprt.ne.0) write(6,2020) l,norsq(l)
      write(uhe) l,nn,mm
         if(mm.eq.0) then
      write(uhe) ((eblmn(m,n),n=1,nn),m=0,l,nsym)
         else
      write(uhe) ((eblmn(m,n),n=1,nn),(ealmn(m,n),n=1,mm),m=0,l,nsym)
         endif
190   continue
      norme=0.
      do 200 l=2,nl,2
      norme=norme+norsq(l)
200   continue
      norme=sqrt(norme)
      if(kprt.ne.0) write(6,2030) norme
      return
901   write(6,3010)
      CALL CCPERR(1,'Fatal error in routine elmns of ROTFUN')
2010  format(' nb. of reflections =',i10/' squared l-components')
2020  format(i5,e15.5)
2030  format(' truncated patterson norm =',e15.5)
3010  format('stop >> elmns << incoherent nb. of reflections')
      end
C     =============================
      SUBROUTINE EXSECT(RMAP,LA,LB)
C     ===============================
C
C---- Extend section by 1 row & column all round, assuming mirror plane
C     on edge. This is likely not to be true, but at least will force
C     edge peaks to lie on the edge
C
C     .. Scalar Arguments ..
      INTEGER LA,LB
C     ..
C     .. Array Arguments ..
      REAL RMAP(0:LA+1,0:LB+1)
C     ..
C     .. Local Scalars ..
      INTEGER I
C     ..
C
      DO 10 I = 1,LA
        RMAP(I,0) = RMAP(I,LB)
        RMAP(I,LB+1) = RMAP(I,1)
c        RMAP(I,0) = RMAP(I,2)
c        RMAP(I,LB+1) = RMAP(I,LB-1)
   10 CONTINUE
C
      DO 20 I = 0,LB + 1
        RMAP(0,I) = RMAP(LA,I)
        RMAP(LA+1,I) = RMAP(1,I)
c        RMAP(0,I) = RMAP(2,I)
c        RMAP(LA+1,I) = RMAP(LA-1,I)
   20 CONTINUE
C
      END
C
C
C     =============================
      SUBROUTINE FILLIN(NDIMT,NG,NA,DLMM,CLMM,FMM)
C     ============================================
C
C     .. Scalar Arguments ..
      INTEGER NA,NDIMT,NG
C     ..
C     .. Array Arguments ..
      COMPLEX CLMM(NDIMT),FMM(NA/2,NG)
      REAL DLMM(NDIMT)
C     ..
C     .. Scalars in Common ..
      INTEGER LMIN,LSUP,NSYM1,NSYM2
C     ..
C     .. Arrays in Common ..
      REAL BID1
      INTEGER IBID1,IBID2,IBID3
C     ..
C     .. Local Scalars ..
      INTEGER I,IT,J,L,LS1,LS2,M1,M2,MS1,MS2
C     ..
C     .. Common blocks ..
      COMMON /DROTT/IBID1(7),LMIN,LSUP,IBID2(3)
      COMMON /XALS/BID1(2),NSYM1,NSYM2,IBID3(4)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      DO 20 J = 1,NG
        DO 10 I = 1,NA/2
          FMM(I,J) = (0.0,0.0)
   10   CONTINUE
   20 CONTINUE
C
      IT = 0
C
      DO 50 L = LMIN,LSUP,2
        LS1 = L/NSYM1
        LS2 = L/NSYM2
C
        DO 40 MS1 = 0,LS1
          M1 = MS1 + 1
          DO 30 MS2 = -LS2,LS2
            M2 = MS2 + 1
            IF (M2.LE.0) M2 = M2 + NG
            IT = IT + 1
            FMM(M1,M2) = CLMM(IT)*DLMM(IT) + FMM(M1,M2)
   30     CONTINUE
   40   CONTINUE
   50 CONTINUE
C
      IF (IT.NE.NDIMT) GO TO 60
      RETURN
   60 WRITE (6,FMT=6000) IT,NDIMT
C
C          ***********************************************
      CALL CCPERR(1,' > s/r fillin < mismatch. it, ndimt:')
C          ***********************************************
C
 6000 FORMAT (' > S/R FILLIN < MISMATCH. IT, NDIMT:',2I10)
      END
C
C
C     =============================
      SUBROUTINE FITING
C     =================
C
C     EJD re, dimensions: No real problem here
C
C NR =max(nb. reflections,nd)
C ND=1000
C MEQ=nb. of symmetry cards
C MT =dimension of interpolation array
c      has to be > (hmax+2)*(2*lmax+1)*(2*kmax+1)
C NP =nb. variables (6).
C
C     .. Parameters ..
      INTEGER DNR,DMEQ,DMT,DNP
CBIG      PARAMETER (NR=500000,MEQ=24,MT=2200000,NP=6)
C      PARAMETER (DNR=50000,DMEQ=24,DMT=2200000,DNP=6)
C     ..
C     .. External Subroutines ..
      EXTERNAL FITNDO, CCPALC, CCPE2I
      INTEGER CCPE2I
C     ..
crgd   Required memory 
c lecfoq : rr(nr+nd+nr)
c          ii(nr+nd+neqP*nr)
c lectab : cc(nra+ mt)
c fixmol : cc(nra+ mt)
c          ii(nra+nra*neqP)
c interp : rr(2*nra+np*nra+nra)
C
      CHARACTER TYPE (5), LENENV (4)*10
      INTEGER LENG (5), VALS (4), DEFS (4)
C     extra values formerly args to FITNDO:
      INTEGER MEQ,MT,NR,NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB
C  NRC NEQPC - no of reflns and no of primitive sym ops for crystal
C  MITAB MCTAB needed for tabling
C  MCTAB set = 100000
C  NRH1  no of reflns for HKLPCK1 
C  MHKLTAB - the big array from the table: (2*KMAX+1)* (IHMAX+2)* (2*LMAX+1)
      COMMON /SETSIZE/ NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB 
C     ..
      COMMON /FITNXX/ MEQ,MT,NR,NP
      SAVE /FITNXX/
C     Associate MEQ,MT,NR,NP with VALS:
      EQUIVALENCE (MEQ, VALS (1))
      DATA TYPE /'I', 'R', 'C', 'R', 'R'/,
C     +     DEFS /DMEQ, DMT, DNR, DNP/,
     +     LENENV /'FITING_MEQ', 'FITING_MT', 'FITING_NR', 'FITING_NP'/
C      DATA TYPE /'I', 'R', 'C', 'R', 'R'/
C     The array lengths for FITNDO need to be calculated specially --
C     we can't use CCPALE; thus (maybe) read numerical values from the
C     environment with names from LENENV:
C      DO 10 I=1,4
CC       Gets values for MEQ,MT,NR,NP:
C        VALS (I) = CCPE2I (LENENV (I), DEFS (I))
C 10   CONTINUE
C     These are the lengths of array args to trando1 (II, RR, CC):
      NR = NRC
      MEQ = NEQPC
      MT = MHKLTAB
      NP = 6
      LENG (1) = (NR* (2+MEQ))
      LENG (2) = (9*NR)
      LENG (3) = (NR+MT)
      LENG (4) = NP
      LENG (5) = (NP*NP)
      WRITE (6,FMT=6000)
 6000 FORMAT (/,
     +' ****** PROGRAMME FITING ******',///,
     +  ' $TEXT:Reference: $$ comment $$ ',
     +' *** FAST RIGID BODY REFINEMENT,',/,
     +' E.E. CASTELLANO, G. OLIVA AND J. NAVAZA (1992). ',/,
     +'   JNL. APPL. CRYST. 25, 281-284 ***',
     +     ' $$'/
     +' $SUMMARY :Reference:  $$ Amore: $$',/,
     + ' :TEXT:Reference: $$')
      WRITE (6, '(/'' Memory allocation (logical name, elements):'')')
      WRITE (6, '(1X, A, 3X, I10)') (LENENV (I), VALS (I), I=1,4)
      CALL CCPALC (FITNDO, 5, TYPE, LENG)
      END
C
C     =============================
      SUBROUTINE FITNDO(NII,II,NRR,RR,NCC,CC,NP,GRAD,NQUAD,QUAD)
C     ==================================================
C
      INTEGER NSOL
      PARAMETER (NSOL=499)
C
C     .. Scalars in Common..
      INTEGER UDI,HCK2,KCK2,LCK2,NCKH2,NCKK2,NCKL2,NCKM2
      INTEGER NEQ,NEQP,IVERB,NSYM,NSYMP,
     +        HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1
C     .. Arrays in Common..
      REAL TSS,FMINC,FMAXC,TFACC
      INTEGER ITABB,MSS
C     .. Common blocks ..
C
C     ..Local Scalars..
      INTEGER LREC,IFAIL,JDO20,JDO30,ISYM
      CHARACTER FILNAM*10,NAMPG*10,LAUNAM*10
C
C     .. Scalar Arguments ..
      INTEGER NCC, NII, NQUAD, NRR
      INTEGER MEQ,MT,NP,NR,JUNK
C     ..
C     .. Array Arguments ..
      COMPLEX CC (NCC)
      REAL GRAD(NP),QUAD(NQUAD),RR(NRR)
      INTEGER II (NII)
C     ..
C     .. Scalars in Common ..
      REAL A,ALPHA,B,BETA,BFACT,C,CORF,CORI,CORP,DELTAT,DMINTT,DRMAX,
     +     DRMAXT,DRMIN,DRMINT,EPSNF,FMAX,FMIN,GAMMA,RFLI,RFSQ,RPTST,
     +     SCALE,SFLI,SFSQ,SHRTTR,TFAC
      INTEGER IAF,IBF,IBID2,IGF,ISF,ITMAXF,
     +        IXF,IYF,IZF,KPRT,NCODE,NCODT,NMOLT,NPICT
      CHARACTER TITLE*72
C     ..
C     .. Arrays in Common ..
      REAL ALT,BET,BID2,GAT,RF,RO,RSYM,
     +     TXT,TYT,TZT,CRT,RFT
      INTEGER ITBT,KPRTT
      CHARACTER TRATYP*3
C     ..
C     .. Local Scalars ..
      REAL AL,BE,EPSN,FUNC,GA,PASA,PASX,RI2,RTOD,SGRAD,SQHMAX,T,TO,TX,
     +     TY,TZ
      INTEGER HMAX,I,IA,IACTUAL,IB,ICM,IG,IJ,IM,IMOL,IP,IPN,IR0,
     +        IS,ISOL,IT,ITAB,ITABT,ITMAX,IX,IY,IZ,J,J0,J1,J2,
     +        J3,J4,J5,J6,J7,KINV,KMAX,KSIS,LMAX,MP,
     +        MTA,N,ND,NMOL,NRA
      LOGICAL FIRST
C     ..
C     .. Local Arrays ..
      REAL RM(11,100),RXF(9),RXO(9)
C     ..
C     .. External Subroutines ..
      EXTERNAL CELDA,ORTHO,CCPDPN,CCPERR,CHOLER,
     +         FIXMOL,INTERP,LECFOQ,LECTAB,QUADRO,SETMAT,SETSCA
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,MIN,MOD,NINT,REAL,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /ALLFNC/TITLE
      COMMON /ALLFUN/IVERB,ITABB(5),FMINC(5),FMAXC(5),TFACC(5),NSYM,
     +       NSYMP,RSYM(4,4,96)
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /CELOBS/AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS(3,3),NCDOBS
      COMMON /CTLX/IBID2,FMIN,FMAX,TFAC
      COMMON /FITNXX/ MEQ,MT,NR,JUNK
      COMMON /IOPRG/KPRT
      COMMON /OPRT/KPRTT(20)
      COMMON /ORTM/RO(9),RF(9),NCODE
      COMMON /PACO/HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1
      COMMON /POTE/SFLI,SFSQ,SFQU,RFLI,RFSQ,CORF,CORI,CORP,SCALE,BFACT
      COMMON /RESO/DRMAX,DRMIN,BID2(4)
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /TRAFITC/TRATYP
      COMMON /TRAFIT/NCODT,DRMAXT,DRMINT,DMINTT,SHRTTR,NMOLT,
     +       RPTST,DELTAT,NPICT,ITBT(NSOL),ALT(NSOL),BET(NSOL),
     +       GAT(NSOL),TXT(NSOL),TYT(NSOL),TZT(NSOL),CRT(NSOL),
     +       RFT(NSOL),ITMAXF,EPSNF,ISF,IAF,IBF,IGF,IXF,IYF,IZF,SCDT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     ..
C
      DO  I=1,NCC
        CC(I) = CMPLX (0.0, 0.0)
      END DO
      CALL CCPZR (GRAD, NP)
      CALL CCPZR (QUAD, NQUAD)
      CALL CCPZR (RR, NRR)
      CALL CCPZI (II, NII)
      KPRT = 0
      IACTUAL = 0
      KSIS = 1
      KINV = 0
      IR0 = 1+NR
C
      KPRTT(1) = IVERB
      KPRTT(2) = IVERB
      KPRTT(3) = IVERB
      KPRTT(4) = IVERB
      KPRTT(5) = IVERB
      KPRTT(6) = IVERB
C
      KPRT = KPRTT(1)
C
C
      FILNAM = 'HKLPCK0'
      UDI = 0
C
C          ***************************************
      CALL CCPDPN(UDI,FILNAM,'OLD','U',LREC,IFAIL)
C          ***************************************
C
C     =================================
C      SUBROUTINE HKLCELLIN(UDI,DMINUDI)
C     =================================
C
C     .. Scalar Arguments..
C
C
C----  read Cell and symmetry from HKLPCK file:
C
      READ (UDI) A,B,C,ALPHA,BETA,GAMMA
      AOBS  = A
      BOBS  = B
      COBS  = C
      ALPOBS  = ALPHA
      BETOBS  = BETA
      GAMOBS  = GAMMA
C
C          *****
      CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
C          *****
C
      READ (UDI) NTS,NEQP,(((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
      IF(NTS.GT.0) READ(UDI) ((TTS(I,ITS),I=1,3),ITS=1,NTS)
C  Read packing constants to put into COMMON PACO
      READ (UDI) HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1,DMINUDI
C
C
C----  Reset symmetry if set on input.
C
      IF (NSYM.GT.1) THEN
        IF (NEQP*(NTS+1).NE.NSYM) THEN
          WRITE (6,FMT='(//,a)') ' Incompatible symmetry??'
          WRITE (6,FMT='(/,i3,A,I3,A)')NEQP, 
     +    ' symmetry operators listed with',NTS,' centring operators.'
C
C              ************************
          CALL CCPERR(1,' Fatal error in symmetry')
C              ************************
C
        END IF
C
        NEQ = NSYM
        NEQP = NSYMP
C
        DO 30 ISYM = 1,NSYM
         IF(ISYM.LE.NSYMP) THEN
          DO 20 JDO30 = 1,3
           TSS(JDO30,ISYM) = RSYM(JDO30,4,ISYM)
            DO 10 JDO20 = 1,3
              MSS(JDO30,JDO20,ISYM) = NINT(RSYM(JDO30,JDO20,ISYM))
   10       CONTINUE
   20     CONTINUE
         END IF
         IF(ISYM.GT.NSYMP) THEN
          NTS = INT((ISYM-1)/NSYMP)
          DO J = 1,3
           tts(j,NTS) =   RSYM(j,4,ISYM) - RSYM(j,4,ISYM-NTS*NSYMP)
          END DO 
         END IF
   30   CONTINUE
C          *****
      WRITE (6,FMT='(A,6F9.3)')
     + ' FITNDO: Observed Cell read from HKLPCK0:',
     + AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS
      WRITE (6,FMT='(A,I5,48(//,A,I4,/,3(/,3i4,F9.3) ))')
     +  ' Symmetry - primitive operators:',neqp,
     + ('Symmetry:',N,((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
       IF(NTS.GT.0) THEN
          WRITE (6,FMT='(4(/A,I5,3F9.3) )')
     +  (' Centring operator:',N,(TTS(I,N),I=1,3),N=1,NTS)
      END IF
C
      END IF
C
C   Now choose a sensible set of refinement flags when NMOL = 1
C   no X Y or Z for triclinic ( P1)
C   X & Z only for Monoclinic B unique
C   X & Y only for polar P3 P4 P6
C   use PGNLAU to decide
C    need only look at primitive sym ops
       IF( NMOLT .EQ.1 ) THEN
           DO N = 1,NEQP
              RSYM(4,4,N) = 1.0
            DO I = 1,3
              RSYM(4,I,N) = 0.0
              RSYM(I,4,N) = TSS(I,N)
               DO J = 1,3
                 RSYM(J,I,N) = MSS(J,I,N)
               END DO
            END DO
           END DO
         nampg = ' '
         neqq = neqp
         CALL PGDEFN(NAMPG,NEQQ,NEQP,RSYM,.FALSE.)
         CALL PGNLAU(NAMPG,NLAUE,LAUNAM)
C  Triclinic 
         IF (NLAUE.EQ.3 ) IXF = 0
         IF (NLAUE.EQ.3 ) IYF = 0
         IF (NLAUE.EQ.3 ) IZF = 0
C  Monoclinic B unique - 
         IF (NLAUE.EQ.4 ) IYF = 0
C  Monoclinic A unique ?? not considered
C  Any other polar space group P2-c unique, P4 P3 or P6 - set IZF = 0
         IF (NLAUE.EQ.5 .OR. NLAUE.EQ.7 .OR. 
     +       NLAUE.EQ.9 .OR. NLAUE.EQ.12) IZF = 0
       END IF
C          *****
      CALL ORTHO
C          *****
      WRITE (6,FMT='(A,6F9.3)') 
     + ' Observed Cell read from HKLPCK0:',
     + AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS
      WRITE (6,FMT='(A,I5,48(//,A,I4,/,3(/,3i4,F9.3) ))') 
     +  ' Symmetry - primitive operators:',neqp,
     + ('Symmetry:',N,((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
       IF(NTS.GT.0) THEN
          WRITE (6,FMT='(4(/A,I5,3F9.3) )')
     +  (' Centring operator:',N,(TTS(I,N),I=1,3),N=1,NTS)
       END IF
C
C      RETURN
C
C      END

C      CALL HKLCELLIN(UDI)
C
C      IF(IVERB.GT.0)
C     +WRITE (*,FMT='(35(/,3i4,f10.4))') (((MSS(I,J,N),J=1,3),TSS(I,N),
C     +  I=1,3),N=1,NEQ)
C
      DO 40 I = 1,9
        RXF(I) = RF(I)
        RXO(I) = RO(I)
   40 CONTINUE
C
      FMIN = FMINC(1)
      FMAX = FMAXC(1)
      TFAC = TFACC(1)
C
      IF (FMAX.LT.FMIN) THEN
        T = FMAX
        FMAX = FMIN
        FMIN = T
      END IF
C
      DRMAX = DRMAXT
      DRMIN = DRMINT
C
      IF (DRMAX.LT.DRMIN) THEN
        TO = DRMAX
        DRMAX = DRMIN
        DRMIN = TO
      END IF
C
      IF(UDI.NE.0) REWIND (UDI)
C
C----  Skip first 3 records:
C
      READ (UDI)AC,BC,C,ALC,BEC,GAC
      READ (UDI)NTSC,NEQPC
      IF(NTSC.GT.0) READ(UDI) TSSC
      READ (UDI)HMM,KMM,LMM,NHH,NKK,NLL,NMM,DMMINN
      READ (UDI) ND
      IF (ND.GT.NR .OR. NEQP.GT.MEQ) GO TO 160
C
C          *********************************************************
      CALL LECFOQ(UDI,ND,NR,NRA,NEQP,II(IR0),II(1),II(IR0+ND),RR(IR0),
     +            RR(IR0+ND),RR(1),RR(IR0+2*ND),'h')
C          *********************************************************
C
      IF (UDI.NE.0) CLOSE (UDI)
      WRITE (6,FMT='(A8,A)') ' FITING:',TITLE
C      ISOL = 0
   50 CONTINUE
C
      NMOL = NMOLT
      IF (NMOL.GT.100) GO TO 170
      FIRST = .TRUE.
      KPRT = KPRTT(2)
C
      IS = ISF
      IA = IAF
      IB = IBF
      IG = IGF
      IX = IXF
      IY = IYF
      IZ = IZF
      MP = IA + IB + IG + IX + IY + IZ
C
      ITMAX = ITMAXF
      EPSN = EPSNF
C
      IF (KPRT.NE.0) THEN
        WRITE (6,FMT=*) ' PARAMETERS OF FIT'
        WRITE (6,FMT=*) ' B-FACTOR     :',IS
        WRITE (6,FMT=*) ' ANGLE ALFA  :',IA
        WRITE (6,FMT=*) ' ANGLE BETA  :',IB
        WRITE (6,FMT=*) ' ANGLE GAMA  :',IG
        WRITE (6,FMT=*) ' TRANSLATION X:',IX
        WRITE (6,FMT=*) ' TRANSLATION Y:',IY
        WRITE (6,FMT=*) ' TRANSLATION Z:',IZ
      END IF
C
      IP = 0
      IPN = MP
      IJ= 0
C
      IF (IA.NE.0) THEN
        IP = IP + 1
        IA = IP
      ELSE
        IPN = IPN + 1
        IA = IPN
      END IF
C
      IF (IB.NE.0) THEN
        IP = IP + 1
        IB = IP
      ELSE
        IPN = IPN + 1
        IB = IPN
      END IF
C
      IF (IG.NE.0) THEN
        IP = IP + 1
        IG = IP
      ELSE
        IPN = IPN + 1
        IG = IPN
      END IF
C
      IF (IX.NE.0) THEN
        IP = IP + 1
        IX = IP
      ELSE
        IPN = IPN + 1
        IX = IPN
      END IF
C
      IF (IY.NE.0) THEN
        IP = IP + 1
        IY = IP
      ELSE
        IPN = IPN + 1
        IY = IPN
      END IF
C
      IF (IZ.NE.0) THEN
        IP = IP + 1
        IZ = IP
      ELSE
        IPN = IPN + 1
        IZ = IPN
      END IF
C
      J0 = 1 + NRA
      J1 = J0 + NRA
      J2 = NRA*IA + J1
      J3 = NRA*IB + J1
      J4 = NRA*IG + J1
      J5 = NRA*IX + J1
      J6 = NRA*IY + J1
      J7 = NRA*IZ + J1
C
      DO 60 I = 1,NRA
        CC(I) = (0.0,0.0)
   60 CONTINUE
C
      WRITE (6,FMT=*)
      WRITE (6,FMT=*) 'INITIAL POSITIONS'
      KPRT = KPRTT(3)
      IMOL = 1
   70 CONTINUE
C
      IF ( (ISOL + IMOL) .GT.NSOL) GO TO 150
      ITABT = ITBT(ISOL+IMOL)
      IF (ITABT.EQ.0) GO TO 150
      AL = ALT(ISOL+IMOL)
      BE = BET(ISOL+IMOL)
      GA = GAT(ISOL+IMOL)
      TX = TXT(ISOL+IMOL)
      TY = TYT(ISOL+IMOL)
      TZ = TZT(ISOL+IMOL)
      WRITE (6,FMT='(A,I4,3F8.2,3F8.4,2F5.1)')' Input posn:',
     +            ITABT,AL,BE,GA,TX,TY,TZ,CRT(ISOL+IMOL),RFT(ISOL+IMOL)
C
      RM(1,IMOL) = REAL(ITABT)
      RM(2,IMOL) = AL
      RM(3,IMOL) = BE
      RM(4,IMOL) = GA
      RM(5,IMOL) = TX
      RM(6,IMOL) = TY
      RM(7,IMOL) = TZ
C
      IF (ITABT.NE.IACTUAL) THEN
        IF (IACTUAL.NE.0 .AND. ITAB.NE.0) CLOSE (UNIT=ITAB)
        FILNAM = ' '
        WRITE (FILNAM,FMT='(A5,I1)') 'TABLE',ITABT
C
C ---- modtab ???
       ITAB = 0
C
C            ***************************************
        IFAIL = 0
        CALL CCPDPN(ITAB,FILNAM,'READONLY','U',0,IFAIL)
C            ***************************************
C
        IACTUAL = ITABT
        IF(ITAB.NE.0) REWIND (ITAB)
        READ (ITAB) A,B,C,ALPHA,BETA,GAMMA,NCODE,HMAX,KMAX,LMAX,SQHMAX
        MTA = (2*KMAX+1)* (HMAX+2)* (2*LMAX+1)
        IF (NRA+MTA.GT.NR+MT) GO TO 180
C
C            *************************************
        CALL LECTAB(ITAB,HMAX,KMAX,LMAX,CC(1+NRA))
C            *************************************
C
        DO 80 I = 1,9
          RF(I) = RXF(I)
   80   CONTINUE
C
      END IF
C
      IF (IMOL.LT.NMOL) THEN
C
C            ********************************************************
        CALL SETMAT(AL,BE,GA,TX,TY,TZ)
        SIGNF = 1.0
        CALL FIXMOL(HMAX,KMAX,LMAX,NRA,NEQP,II(1+NRA),CC(1),CC(1+NRA),
     +              SIGNF)
C            ********************************************************
C
      END IF
C
      IMOL = IMOL + 1
      IF (IMOL.LE.NMOL) GO TO 70
C
      PASA = -1.0
      PASX = -1.0
      IT   =  0
      ICM  =  0
C
      KPRT = KPRTT(4)
C
C          *************************************************************
   90 CALL SETMAT(AL,BE,GA,TX,TY,TZ)
      CALL INTERP(HMAX,KMAX,LMAX,NRA,NEQP,II(1+NRA),RR(J1),RR(J2),
     +            RR(J3),RR(J4),RR(J5),RR(J6),RR(J7),CC(1),CC(1+NRA))
      CALL SETSCA(IS,NRA,II(1),RR(1),RR(J0),RR(J1),FIRST)
C          *************************************************************
C
      IF (IG.LE.MP .AND. IA.LE.MP .AND.
     +    (ABS(BE).LT.0.5.OR.ABS(BE-180).LT.0.5)) IJ = MIN(IA,IG)
C
C          *************************************************************
      CALL QUADRO(IS,IJ,NRA,MP,II(1),RR(1),RR(J0),RR(J1),GRAD,QUAD,FUNC)
C          *************************************************************
C
      IJ = 0
      SGRAD = 0.0
C
      DO 100 I = 1,MP
        SGRAD = GRAD(I)**2 + SGRAD
  100 CONTINUE
C
      SGRAD = SQRT(ABS(SGRAD/MP) )
C
      IF (KPRT.NE.0) THEN
        WRITE (6,FMT=*) ' ITERATION:',IT,', FUNCTION:',FUNC
        WRITE (6,FMT=*) ' ANGLES (DEGREES):',AL,BE,GA
        WRITE (6,FMT=*) ' DISPLACEMENTS (FRACC):',TX,TY,TZ
        WRITE (6,FMT=*) ' NORMA DEL GRADIENTE:',SGRAD
      END IF
C
      IT = IT + 1
C
      IF (IT.LE.ITMAX .AND. SGRAD.GE.EPSN) THEN
C
C            ******************************
        CALL CHOLER(MP,QUAD,GRAD,KSIS,KINV)
C            ******************************
C   CHOLER failure:
        IF(MP.LT.0) THEN
          WRITE(6,*)' No refinement possible for this position:'
          MP = -MP
          GO TO 90
        END IF
C
        IF(IA.NE.0) AL = GRAD(IA)*PASA*RTOD + AL
        IF(IB.NE.0) BE = GRAD(IB)*PASA*RTOD + BE
        IF(IG.NE.0) GA = GRAD(IG)*PASA*RTOD + GA
        IF(IX.NE.0) TX = GRAD(IX)*PASX + TX
        IF(IY.NE.0) TY = GRAD(IY)*PASX + TY
        IF(IZ.NE.0) TZ = GRAD(IZ)*PASX + TZ
        GO TO 90
      END IF
C
      IM = MOD(NMOL+ICM-1,NMOL) + 1
C
      RM(1,IM) = REAL(ITABT)
      RM(2,IM) = AL
      RM(3,IM) = BE
      RM(4,IM) = GA
      RM(5,IM) = TX
      RM(6,IM) = TY
      RM(7,IM) = TZ
C
      WRITE (6,FMT=*)
     +  ' Scale, B-Fact, Correlation Coefficient, R-Fact'
      WRITE (6,FMT='(E15.5,4F10.3)') SCALE,BFACT*4,CORF*100,RFLI*100,
     +                                             CORI*100
      ICM = ICM + 1
C
      IF (ICM.LT.NMOL) THEN
        DO 110 I = 1,NRA
          CC(I) = (0.0,0.0)
  110   CONTINUE
C
        KPRT = KPRTT(3)
        IMOL = 1
  120   IM = MOD(IMOL+ICM-1,NMOL) + 1
C
        RI2 = RM(1,IM)
        AL  = RM(2,IM)
        BE  = RM(3,IM)
        GA  = RM(4,IM)
        TX  = RM(5,IM)
        TY  = RM(6,IM)
        TZ  = RM(7,IM)
        ITABT = NINT(RI2)
C
        IF (ITABT.NE.IACTUAL) THEN
          IACTUAL = ITABT
          IF(ITAB.NE.0) CLOSE (UNIT=ITAB)
          FILNAM = ' '
          WRITE (FILNAM,FMT='(A5,I1)') 'TABLE',ITABT
C
C            ***************************************
          IFAIL = 0
          ITAB = 0
          CALL CCPDPN(ITAB,FILNAM,'READONLY','U',0,IFAIL)
C            ***************************************
          IF(ITAB.NE.0) REWIND (ITAB)
          READ (ITAB) A,B,C,ALPHA,BETA,GAMMA,NCODE,HMAX,KMAX,LMAX,SQHMAX
C
C              **********************************
          CALL LECTAB(ITAB,HMAX,KMAX,LMAX,CC(1+NRA))
C              **********************************
C
          DO 130 I = 1,9
            RF(I) = RXF(I)
  130     CONTINUE
C
        END IF
C
        IF (IMOL.LT.NMOL) THEN
C
C              *******************************************************
          CALL SETMAT(AL,BE,GA,TX,TY,TZ)
          SIGNF = 1.0
          CALL FIXMOL(HMAX,KMAX,LMAX,NRA,NEQP,II(1+NRA),CC(1),CC(1+NRA),
     +                SIGNF)
C              *******************************************************
C
        END IF
C
        IMOL = IMOL + 1
        IF (IMOL.LE.NMOL) GO TO 120
        IT = 0
        KPRT = KPRTT(4)
        GO TO 90
      ELSE
        WRITE (6,FMT=*) 'FINAL POSITIONS'
        WRITE (6,'(/,A,/,A,A)')
     +  ' Fitting solutions ',
     +  '          TABLE   Alpha    Beta   Gamma   ',
     +  ' Tx      Ty      Tz Corr_F Rfac Corr_I Pkcount'
C
        DO 140 IMOL = 1,NMOL
C
          RI2 = RM(1,IMOL)
          ITABT = NINT(RI2)
          IF(IA.NE.0) AL  = RM(2,IMOL)
          IF(IB.NE.0) BE  = RM(3,IMOL)
          IF(IG.NE.0) GA  = RM(4,IMOL)
          IF(IX.NE.0) TX  = RM(5,IMOL)
          IF(IY.NE.0) TY  = RM(6,IMOL)
          IF(IZ.NE.0) TZ  = RM(7,IMOL)
C  Replace original solution with refined one.
          ISOL = ISOL + 1
          ITBT(ISOL) = ITABT
          ALT(ISOL) = AL
          BET(ISOL) = BE
          GAT(ISOL) = GA
          TXT(ISOL) = TX
          TYT(ISOL) = TY
          TZT(ISOL) = TZ
          CRT(ISOL) = CORF*100.0
          RFT(ISOL) = RFLI*100.0
C
        WRITE (6,FMT='(A,I4,3F8.2,3F8.4,3F5.1,I4)') ' SOLUTIONF  ',
     +  ITABT,AL,BE,GA,TX,TY,TZ,CORF*100.0,RFLI*100.0,CORI*100.0,ISOL
C
C----   Insert here call to generate final rotation angles.
C
  140   CONTINUE
      END IF
C
       GO TO 50
  150 CONTINUE
      DO 151 I = 1,9
        RO(I) = RXO(I)
  151 CONTINUE
      RETURN
  160 WRITE (6,FMT=6002) ND,NR,NEQP,MEQ
C
C          ********************************************
      CALL CCPERR(1, 'Change FITING_NR or  FITING_MEQ')
C          ********************************************
C
  170 WRITE (6,FMT=6004) NMOL
C
C          ***********************************************************
      CALL CCPERR(1,' > s/r fitndo < nb. molecules greater than 100:')
C          ***********************************************************
C
  180 WRITE (6,FMT=6006) NRA,NR,MTA,MT
C
C          *****************************************
      CALL CCPERR(1,'Change FITING_NR or  FITING_MT')
C          *****************************************
C
 6002 FORMAT 
     + (' > S/R FITNDO     FITING_NR(required)',I10,' NR(set)',I10,/,
     + '                  FITING_MEQ(required)',I10,'MEQ(set)',I10)
 6004 FORMAT (' > S/R FITNDO < NB. MOLECULES GREATER THAN 100:',I5)
 6006 FORMAT 
     + (' > S/R FITNDO   FITING_NR(required)',I10,'  NR(set)',I10,/,
     +  '                FITING_MT(required)',I10,'  MT(set)',I10)
      END
C
C     =============================
      SUBROUTINE FIXMOL(HMAX,KMAX,LMAX,NRA,MEQ,HKLS,FF,FT,SIGNF)
C     ====================================================
C
C     .. Scalar Arguments ..
      INTEGER HMAX,KMAX,LMAX,MEQ,NRA
C     ..
C     .. Array Arguments ..
      COMPLEX FF(NRA),FT(-1:HMAX,-KMAX:KMAX,-LMAX:LMAX)
      INTEGER HKLS(NRA,MEQ)
C     ..
C     .. Scalars in Common ..
      REAL TX,TY,TZ,SIGNF
      INTEGER NEQP
C     ..
C     .. Arrays in Common ..
      REAL DM,DMD,TSS
      INTEGER MSS
C     ..
C     .. Local Scalars ..
      COMPLEX DFH,DFK,DFL,F,FCR,PHASE,TWOPII
      REAL DH,DK,DL,PHI,XH,XK,XL
      INTEGER H,HH,HS,IH,IK,IL,IR,IS,K,KK,KS,L,LL,LS
      LOGICAL FRIDEL
C     ..
C     .. External Subroutines ..
      EXTERNAL UNPAC3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC CONJG,EXP,MOD,NINT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /ROTRA/DM(3,3),DMD(3,3,3),TX,TY,TZ
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA TWOPII/ (0.0,6.2831853)/
C     ..
C
c       write(6,'(2A,/,2I15)') ' dimension for CC array in FIXMOL',
c     + ' CC(1) matches FF(NRA); CC(NRA+1) matches FT',
c     +  nra,2*(hmax+2)*(2*kmax+1)*(2*lmax+1)
      DO 20 IR = 1,NRA
        FCR = FF(IR)
C
C            ************************
C    Isn't this pointless? NEQP = 1 anyway..
         CALL UNPAC3(H,K,L,HKLS(IR,1))
C            ************************
C
        DO 10 IS = 1,NEQP
C
C              ****************************
          CALL UNPAC3(HS,KS,LS,HKLS(IR,IS))
C              ****************************
C
          PHI = MOD(TSS(1,IS)*H+TSS(2,IS)*K+TSS(3,IS)*L+HS*TX+KS*TY+
     +          LS*TZ,1.0)
          PHASE = EXP(TWOPII*PHI)
C  interpolate..
          XH = DM(1,1)*HS + DM(2,1)*KS + DM(3,1)*LS
          XK = DM(1,2)*HS + DM(2,2)*KS + DM(3,2)*LS
          XL = DM(1,3)*HS + DM(2,3)*KS + DM(3,3)*LS
C
          FRIDEL = .FALSE.
C
          IF (XH.LT.0.0) THEN
            XH = -XH
            XK = -XK
            XL = -XL
            FRIDEL = .TRUE.
          END IF
C
          HH = NINT(XH)
          DH = XH - HH
          IH = 1
          IF (DH.LT.0.0) IH = -1
          KK = NINT(XK)
          DK = XK - KK
          IK = 1
          IF (DK.LT.0.0) IK = -1
          LL = NINT(XL)
          DL = XL - LL
          IL = 1
          IF (DL.LT.0.0) IL = -1
          DFH = (FT(HH+IH,KK,LL)-FT(HH,KK,LL))/IH
          DFK = (FT(HH,KK+IK,LL)-FT(HH,KK,LL))/IK
          DFL = (FT(HH,KK,LL+IL)-FT(HH,KK,LL))/IL
          F = FT(HH,KK,LL) + DFH*DH + DFK*DK + DFL*DL
          IF (FRIDEL) F = CONJG(F)
          F = F*PHASE
          FCR = FCR + SIGNF*F
   10   CONTINUE
        FF(IR) = FCR
   20 CONTINUE
      RETURN
      END
C
C
C     =================
      BLOCK DATA FORMDA
C     =================
C
C los coeficientes estan escritos por pares (a(n),b(n)), y corresponden
C a la formula: f(s) = sum(n) (a(n)*exp(-b(n)*s***2)).
C el termino constante (si hay) debe ser el ultimo.
C     The coefficients are written in pairs (a(n),b(n)), and correspond
C     to the equation: f(s) = sum(n) (a(n)*exp(-b(n)*s***2)).
C     The constant term (if any) has to be the last one.
C
C     .. Scalars in Common ..
      INTEGER NFORM,NTYP
C     ..
C     .. Arrays in Common ..
      REAL FORM
      CHARACTER KEYID*4
C     ..
C     .. Common blocks ..
      COMMON /ATYPE/FORM(10,100),NFORM,NTYP
      COMMON /CTYPE/KEYID(100)
C     ..
      SAVE
C     .. Data statements ..
      DATA NTYP/0/,NFORM/9/
      data keyid/100*' '/
      DATA FORM/1000*0.0/
c     ..
C
      END
C
C
C     =============================
      SUBROUTINE FORMFA
C     =================
C
C     .. Scalars in Common ..
      INTEGER NFORM,NTYP
C     ..
C     .. Arrays in Common ..
      REAL FORM
C     ..
C     .. Local Scalars ..
      REAL CT,EMAX,ET
      INTEGER I,IE,N,NFORN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C     ..
C     .. Common blocks ..
      COMMON /ATYPE/FORM(10,100),NFORM,NTYP
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF (MOD(NFORM,2).NE.0) THEN
        DO 10 N = 1,NTYP
          FORM(NFORM+1,N) = 0.0
   10   CONTINUE
      END IF
C
      NFORN = (NFORM+1)/2
C
      DO 30 N = 1,NTYP
        IE = 1
        EMAX = FORM(2,N)
C
        DO 20 I = 1,NFORN
          IF (FORM(2*I,N).LE.EMAX) GO TO 20
          IE = I
          EMAX = FORM(2*IE,N)
   20   CONTINUE
C
        IF (IE.EQ.1) GO TO 30
        CT = FORM(1,N)
        ET = FORM(2,N)
        FORM(1,N) = FORM(2*IE-1,N)
        FORM(2,N) = FORM(2*IE,N)
        FORM(2*IE-1,N) = CT
        FORM(2*IE,N) = ET
   30 CONTINUE
C
      RETURN
      END
C
c      call fsym(hmax,kmax,lmax,      nra,neqP,ii(1),ii(1+nra),rr(1),
c     . cc(1+nra),cc(ic3))
C     ======================================================
      SUBROUTINE FSYM(HMAX,KMAX,LMAX,NRA,MEQ,  HKL,  HKLS,  FOB,FS,FT)
C     ======================================================
C
C     .. Scalar Arguments ..
      INTEGER HMAX,KMAX,LMAX,MEQ,NRA
C     ..
C     .. Array Arguments ..
      COMPLEX FS(NRA,MEQ),FT(-1:HMAX,-KMAX:KMAX,-LMAX:LMAX)
      REAL FOB(NRA)
      INTEGER HKL(NRA),HKLS(NRA,MEQ)
C     ..
C     .. Scalars in Common ..
      REAL BFACT,CORF,CORI,CORP,RFLI,RFSQ,SCALE,SFLI,SFSQ
      INTEGER KPRT,NEQ,NEQP
C     ..
C     .. Arrays in Common ..
      REAL BID1,DM,TSS
      INTEGER MSS
C     ..
C     .. Local Scalars ..
      COMPLEX DFH,DFK,DFL,F,PHASE,TWOPII
      REAL C0,D0,DH,DK,DL,FO,MF,PHI,SF,SQ,XH,XK,XL
      INTEGER H,HH,HS,IH,IK,IL,IR,IS,K,KK,KS,L,LL,LS
      LOGICAL FRIDEL
C     ..
C     .. External Subroutines ..
      EXTERNAL UNPAC3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,CONJG,EXP,MOD,NINT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /IOPRG/KPRT
      COMMON /NCSTRA/Nncs,TXncs(10),TYncs(10),TZncs(10)
      COMMON /POTE/SFLI,SFSQ,SFQU,RFLI,RFSQ,CORF,CORI,CORP,SCALE,BFACT
      COMMON /ROTRA/DM(3,3),BID1(30)
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA TWOPII/ (0.0,6.2831853)/
C     ..
C
C  Add Nncs translation
      DO 30 Incs1 = 1,Nncs+1
       Incs = Incs1 -1
        IF (Incs .EQ.0) THEN
         TX = 0.0
         TY = 0.0
         TZ = 0.0
        ELSE
         TX = TXncs(Incs)
         TY = TYncs(Incs)
         TZ = TZncs(Incs)
        END IF 
       D0 = 0.0
       C0 = 0.0
C
       DO 20 IR = 1,NRA
C
C            ************************
        CALL UNPAC4(H,K,L,MULT,HKL(IR))
C            ************************
C
        FO = FOB(IR)
        SF = 0.0
        SQ = 0.0
C
Cejd        DO 10 IS = 1,NEQ
        DO 10 IS = 1,NEQP
C
C              ****************************
          CALL UNPAC3(HS,KS,LS,HKLS(IR,IS))
C              ****************************
C
          PHI = MOD(TSS(1,IS)*H + TSS(2,IS)*K + TSS(3,IS)*L 
     +             +HS*TX +KS*TY +Ls*TZ,1.0)
          PHASE = EXP(TWOPII*PHI)
C
          XH = DM(1,1)*HS + DM(2,1)*KS + DM(3,1)*LS
          XK = DM(1,2)*HS + DM(2,2)*KS + DM(3,2)*LS
          XL = DM(1,3)*HS + DM(2,3)*KS + DM(3,3)*LS
C
          FRIDEL = .FALSE.
C
          IF (XH.LT.0.0) THEN
            XH = -XH
            XK = -XK
            XL = -XL
            FRIDEL = .TRUE.
          END IF
C
          HH = NINT(XH)
          DH = XH - HH
          IH = 1
          IF (DH.LT.0.0) IH = -1
          KK = NINT(XK)
          DK = XK - KK
          IK = 1
          IF (DK.LT.0.0) IK = -1
          LL = NINT(XL)
          DL = XL - LL
          IL = 1
          IF (DL.LT.0.0) IL = -1
          DFH = (FT(HH+IH,KK,LL)-FT(HH,KK,LL))/IH
          DFK = (FT(HH,KK+IK,LL)-FT(HH,KK,LL))/IK
          DFL = (FT(HH,KK,LL+IL)-FT(HH,KK,LL))/IL
          F = FT(HH,KK,LL) + DFH*DH + DFK*DK + DFL*DL
          IF (FRIDEL) F = CONJG(F)
          F = FS(IR,IS) + F*PHASE
          MF = ABS(F)
          SF = SF + MF
          SQ = SQ + MF*MF
          FS(IR,IS) = F
   10   CONTINUE
        C0 = MULT*SQ +C0
        D0 = MULT*FO*SF + D0
   20 CONTINUE
C
      SCALE = C0/D0
      IF (KPRT.NE.0) WRITE (6,FMT=6000) SCALE
   30 CONTINUE
      RETURN
 6000 FORMAT (/' SCALE FACTOR BETWEEN DATA AND FMOD IN P1:',E15.5)
      END
C
C     =============================
      SUBROUTINE FTL(L,X,TL)
C     ======================
C
C     .. Scalar Arguments ..
      REAL TL,X
      INTEGER L
C     ..
C     .. Local Scalars ..
      REAL SBL,SBLM,SBLP
C     ..
C     .. External Subroutines ..
      EXTERNAL SBES3D
C     ..
      CALL SBES3D(L,X,SBLM,SBL,SBLP)
      TL = (SBL*SBL-SBLM*SBLP)/2
      RETURN
      END
C
C
      subroutine fun(hmax,kmax,lmax,nra,neqp,hkl,hkls,fob,fs,ft)
      implicit none
      integer nra,neqp,kmax,lmax,ntot,ir,k,l,mult,is,ks,ls,ih,kk,ik,ll,
     & il,n,ilec,iecr,kprt,iout,ibid1,hmax,hkl(nra),hkls(nra,neqp),h,hs,
     & hh
      real xnorm,sfsq,sfli,ynorm,sfqu,d0,c0,s0,fo,sf,sq,xh,dm,xk,xl,dh,
     & dk,dl,fc,corf,scale,escala,rfli,fo2,sd,cori,rfsq,corp,bfact,
     & rbid1,fob(nra),fs(nra,neqp)
      complex ft(-1:hmax,-kmax:kmax,-lmax:lmax),f,dfh,dfk,dfl
      character cbid1*1
      common/ioprg/ kprt
      common /pote/sfli,sfsq,sfqu,rfli,rfsq,corf,cori,corp,scale,bfact
      common/numo/ ntot,ibid1(6)
      common/rotra/ dm(3,3),rbid1(30)
      xnorm=1./sqrt(sfsq-sfli**2/ntot)
      ynorm=1./sqrt(sfqu-sfsq**2/ntot)
      d0=0.
      c0=0.
      s0=0.
      do 20 ir=1,nra
      call unpac4(h,k,l,mult,hkl(ir))
      fo=fob(ir)
      sf=0.
      sq=0.
      do 10 is=1,neqp
      call unpac3(hs,ks,ls,hkls(ir,is))
      xh=hs*dm(1,1)+ks*dm(2,1)+ls*dm(3,1)
      xk=hs*dm(1,2)+ks*dm(2,2)+ls*dm(3,2)
      xl=hs*dm(1,3)+ks*dm(2,3)+ls*dm(3,3)
         if(xh.lt.0.) then
      xh=-xh
      xk=-xk
      xl=-xl
         endif
      hh=nint(xh)
      dh=xh-hh
      ih=1
      if(dh.lt.0.) ih=-1
      kk=nint(xk)
      dk=xk-kk
      ik=1
      if(dk.lt.0.) ik=-1
      ll=nint(xl)
      dl=xl-ll
      il=1
      if(dl.lt.0.) il=-1
      dfh=(ft(hh+ih,kk,ll)-ft(hh,kk,ll))/ih
      dfk=(ft(hh,kk+ik,ll)-ft(hh,kk,ll))/ik
      dfl=(ft(hh,kk,ll+il)-ft(hh,kk,ll))/il
      f=ft(hh,kk,ll)+dfh*dh+dfk*dk+dfl*dl
      fc=cabs(f)
      fs(ir,is)=fc
      sf=sf+fc
      sq=sq+fc*fc
10    continue
      sf=sf/neqp
      sq=sq/neqp
      d0=d0+mult*sf*fo
      c0=c0+mult*sq
      s0=s0+mult*sf
20    continue
      corf=xnorm*(d0-s0*sfli/ntot)/sqrt(c0-s0*s0/ntot)
      scale=c0/d0
      escala=d0/c0
      d0=0.
      c0=0.
      s0=0.
      rfli=0.
      do 40 n=1,nra
      call unpac4(h,k,l,mult,hkl(n))
      fo=fob(n)
      fo2=fo**2
      sd=0.
      sf=0.
      do 30 is=1,neqp
      fc=fs(n,is)
      sd=sd+abs(fc*escala-fo)
      sf=sf+fc*fc
30    continue
      sd=sd/neqp
      rfli=rfli+mult*sd
      d0=d0+mult*sf*fo2
      c0=c0+mult*sf*sf
      s0=s0+mult*sf
40    continue
      cori=ynorm*(d0-s0*sfsq/ntot)/sqrt(c0-s0*s0/ntot)
      corf=100.*corf
      rfli=100.*rfli/sfli
      cori=100.*cori
      return
      end
C
C     =========================================================
      SUBROUTINE FUORI(NG,NA,NB,RFM,BETA,ANGG,ANGA,FMM,FIRST)
C     =========================================================
C
      PARAMETER (MSR1R=6)
C     .. Scalar Arguments ..
      INTEGER NA,NB,NG
      LOGICAL FIRST
C     ..
C     .. Array Arguments ..
      REAL ANGA(NA),ANGG(NG),BETA(NB),FMM(NA,NG),RFM(4,NB)
C     ..
C     .. Scalars in Common ..
      REAL DELTA,SEUIL,XNOR1,XNOR2
      INTEGER KPRT,NPIC,NSYM1,NSYM2
      REAL DRMAXC,DRMINC,RMINC,RMAXC,DANGR,BMAXR,RPTSR
      INTEGER IROTR,ISELF,NCODC,LMINR,LSUPR,NSR1R,NSR2R,NPICR
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1,iuvw,mxyz,IROTG,IROTC
      REAL DRMAXG,DRMING,CELLM
C     ..
C     .. Local Scalars ..
      REAL AMAX,AT,GMAX,RTOD,SCALE,STEP,SUM,SUMSQ,SUMW,WSEC
      real  cell(6),value,rhmin,rhmax,rhmean,rhrms
      character title*80
      INTEGER i,j,n,imap
C     ..
C     .. Local Arrays ..
      REAL RFS(4)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /IOPRG/KPRT
      COMMON /MAP/IUVW(3),MXYZ(3)
      COMMON /PIK/SEUIL,DELTA,NPIC
      COMMON /XALS/XNOR1,XNOR2,NSYM1,NSYM2,IBID1(4)
      COMMON /ROTFUN/IROTG(4),IROTC(5),IROTR,ISELF,DRMAXG(4),DRMING(4),
     +       CELLM(6,4),NCODC,DRMAXC,DRMINC,RMINC,RMAXC,LMINR,LSUPR,
     +       DANGR,BMAXR,NSR1R,NSR2R,RPTSR,DELTAR,NPICR,ANGNSR(3,MSR1R)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
       data imap/1/
      data cell/360.0,360.0,360.0,90.0,90.0,90.0/

C     ..
C
      IF (FIRST) THEN
        GMAX = 360.0/NSYM2
        AMAX = 360.0/NSYM1
        STEP = GMAX/NG
        IF (ABS(STEP-AMAX/NA) .GE.0.01) GO TO 80
C
        DO 10 I = 1,NG
          AT = (I-1)*STEP + GMAX
          ANGG(I) = MOD(AT,GMAX)
   10   CONTINUE
C
        DO 20 I = 1,NA
          AT = (I-1)*STEP + AMAX
          ANGA(I) = MOD(AT,AMAX)
   20   CONTINUE
C
        SCALE = 100.0/ (XNOR1*XNOR2)
        IF (KPRT.NE.0) WRITE (6,FMT=6000) SCALE,NA,NG,STEP,AMAX,GMAX
C

        title = 'Map of the Rotation function from amore'
        rhmax = -10000
        rhmin =  10000
        SUMW = 0.
        rhmean=  0
        rhrms =  0

C  ejd
        mxyz(1) = INT(cell(1)/step)
        mxyz(2) = INT(cell(2)/dangr)
        mxyz(3) = INT(cell(3)/step)
        diff = abs(step - dangr)
        if (diff.gt.0.001) write(6,'(//,a,/,a,f6.3,a,/,a,//)')
     +  ' *************************************************************'
     +  ,'  **********  NB - Angular step on Alpha and Gamma reset to ',
     +  step,' *********',
     +  ' *************************************************************'
C        mxyz(1) = na
C        mxyz(2) = nb
C        mxyz(3) = ng

C        cell(1) = amax
C        cell(2) =(beta(nb)-beta(1))*rtod
c        cell(3) = gmax
       call MWRHDR(imap,TITLE,nb,IUVW,MXYZ,0,0,
     +              na-1,0,ng-1,CELL,1,2)
C
C  Reset these: used to carry info about in COMMON/MAP..
         mxyz(1) = na
         mxyz(2) = nb
         mxyz(3) = ng
C
        N = 0
        RFS(4) = 0.0
        FIRST = .FALSE.
        IF (KPRT.NE.0) WRITE (6,FMT=6002)
      END IF
C
      N = N + 1
      RFM(4,N) = FMM(1,1)
C
      DO 40 J = 1,NG
        DO 30 I = 1,NA
          IF (FMM(I,J).LT.RFM(4,N)) GO TO 30
          RFM(1,N) = ANGA(I)
          RFM(2,N) = BETA(N)*RTOD
          RFM(3,N) = ANGG(J)
          RFM(4,N) = FMM(I,J)
   30   CONTINUE
   40 CONTINUE
C
      RFM(4,N) = RFM(4,N)*SCALE
C
      IF (RFM(4,N).GT.RFS(4)) THEN
        DO 50 I = 1,4
          RFS(I) = RFM(I,N)
   50   CONTINUE
      END IF
C
      IF (KPRT.NE.0) WRITE (6,FMT=6004) (RFM(I,N),I=1,4)
      IF (N.EQ.NB .AND. KPRT.NE.0) WRITE (6,FMT=6006) RFS
C
      SUM = 0.
      SUMSQ = 0.
        DO 70 J = 1,NG
          DO 60 I = 1,NA
            FMM(I,J) = FMM(I,J)*SCALE
            value = FMM(I,J)
            if (value.gt.rhmax) rhmax=value
            if (value.lt.rhmin) rhmin=value
            SUM = SUM + value
            SUMSQ = SUMSQ + value*value
   60     CONTINUE
   70   CONTINUE
C
      IF (N.LT.NB .OR. NINT((N-1)*DANGR).NE.90) THEN
        WSEC = SIN(BETA(N))
      ELSE
        WSEC = .5
      ENDIF
      SUMW = SUMW + WSEC
      RHMEAN = RHMEAN + WSEC*SUM
      RHRMS = RHRMS + WSEC*SUMSQ
C
C     Write section to map
      call mwrsec(imap,fmm,na,ng,1,na,1,ng)
C
      SEUIL = RFS(4)

      if (n.eq.nb) then
           SUMW = NA*NG*SUMW
           RHMEAN = RHMEAN/SUMW
           RHRMS = SQRT(ABS(MAX(RHRMS/SUMW-RHMEAN**2,0.)) )
c           call mclosc(imap,rhmin,rhmax,rhmean,rhrms)
           call mwclose(imap)
      endif

      RETURN
C
   80 WRITE (6,FMT=6008) GMAX/NG,AMAX/NA
C
C          *****************************************
      CALL CCPERR(1,' > s/r fuori < step mismatch:')
C          *****************************************
C
 6000 FORMAT (/,
     +' Rotation Function Output',/,
     +' Rotation Convention:',/,
     +' Alpha around Z, Beta around new Y, Gamma around new Z',/,
     +' Beta Sections, Gamma Fast, Alpha Slow',/,
     +' Multiplying Scale Factor in the RF output:',E15.5,/,
     +' Points in Alpha and Gamma. ;',I10,' and ',I10,/,
     +' Step: ',F10.3,' Degrees',/,
     +' (Independent) Alpha ranges from 0. to ',F10.3,/,
     +' (Independent) Gamma ranges from 0. to ',F10.3)
 6002 FORMAT (
     +' Maximum value of the rotation function for each ',
     +' BETA Section',/' ALPHA, BETA, GAMMA, RF VALUE',/)
 6004 FORMAT (3F10.3,E15.5)
 6006 FORMAT (/,
     +' Maximum value of 100.*Correlation Coefficient',/' !',
     +       3F10.3,E15.5)
 6008 FORMAT (' > S/R FUORI < STEP MISMATCH:',2F10.3)
      END
C
C
C     =============================
      SUBROUTINE GAULEG(N,X,W)
C     ========================
C
C     .. Scalar Arguments ..
      INTEGER N
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION W(N),X(N)
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION EPS,PP,V0,V1,V2,Z,Z1
      REAL PI
      INTEGER I,J,M
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,COS
C     ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA EPS/1.0D-15/
C     ..
C
      M = (N+1)/2
C
      DO 30 J = 1,M
        Z = DBLE(COS((J-0.25)*PI/ (N+0.5)))
   10   V1 = 0.0D0
        V2 = 1.0D0
C
        DO 20 I = 1,N
          V0 = V1
          V1 = V2
          V2 = ((2*I-1)*Z*V1- (I-1)*V0)/I
   20   CONTINUE
C
        PP = (Z*V2-V1)*N/ (Z*Z-1)
        Z1 = Z
        Z = Z1 - V2/PP
        IF (ABS(Z-Z1).GT.EPS) GO TO 10
        X(J) = -Z
        X(N+1-J) = Z
        W(J) = 2.0D0/ ((1-Z*Z)*PP*PP)
        W(N+1-J) = W(J)
   30 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE GENDD(UDI,NRA,ND,HKL,HKLO,MFO,PHFO,FC)
C     =================================================
C
C     .. Scalar Arguments ..
      INTEGER ND,NRA,UDI
C     ..
C     .. Array Arguments ..
      COMPLEX FC(NRA)
      REAL MFO(ND),PHFO(ND)
      INTEGER HKL(NRA),HKLO(ND)
C     ..
C     .. Scalars in Common ..
      REAL ALPHAM,AM,BETAM,BM,CM,GAMMAM
      INTEGER KPRT,NEQ,NEQP,HM,KM,LM,NH,NK,NL,NM
C     ..
C     .. Arrays in Common ..
      REAL TSS
      INTEGER MSS
C     ..
C     .. Local Scalars ..
      REAL MF,PHI,RTOD
      INTEGER H,I,IND,J,K,L,MULT,N,NTOT
C     ..
C     .. External Subroutines ..
      EXTERNAL PAC4,UNPAC3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,AIMAG,LOG
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /CELLM/AM,BM,CM,ALPHAM,BETAM,GAMMAM
      COMMON /IOPRG/KPRT
      COMMON /RESO/DRMAX,DRMIN,DMAX,DMIN,RMIN,RMAX
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     ..
C
      MULT = 2
      NTOT = 0
      J    = 0
C
      IF(UDI.NE.0) REWIND (UDI)
      WRITE (UDI) AM,BM,CM,ALPHAM,BETAM,GAMMAM
      WRITE (UDI) NTS,NEQP,
     +   (((MSS(I,K,N),K=1,3),TSS(I,N),I=1,3),N=1,NEQP)
      IF(NTS.GT.0) WRITE(UDI) ((TTS(I,ITS),I=1,3),ITS=1,NTS)
      WRITE (UDI) HM,KM,LM,NH,NK,NL,NM,DRMIN
C
      DO 10 I = 1,NRA
C
C            ********************
        CALL UNPAC3(H,K,L,HKL(I))
        CALL PAC4(H,K,L,MULT,IND)
C            ********************
C
        MF = ABS(FC(I))
C
        IF (MF.GT.0.0) THEN
          PHI = AIMAG(LOG(FC(I)))
        ELSE
          PHI = 0.0
        END IF
C
        J = J + 1
        HKLO(J) = IND
        MFO(J) = MF
        PHFO(J) = PHI*RTOD
C
        IF (J.EQ.ND) THEN
          WRITE (UDI) J,HKLO,MFO,PHFO
          NTOT = NTOT + J
          J = 0
        END IF
C
   10 CONTINUE
C
      IF (NTOT.NE.0) THEN
        IF (J.NE.0) WRITE (UDI) J, (HKLO(I),I=1,J), (MFO(I),I=1,J),
     +      (PHFO(I),I=1,J)
      ELSE
        WRITE (UDI) J, (HKLO(I),I=1,J), (MFO(I),I=1,J), (PHFO(I),I=1,J)
      END IF
C
      NTOT = NTOT + J
      IF (KPRT.NE.0) WRITE (6,FMT=6000) NTOT
      RETURN
 6000 FORMAT (/' GENDD.',I10,' Coefficients written')
      END
C
C
C     =============================
      SUBROUTINE GENRED(NR,NRA,HKL)
C     =============================
C
C     .. Scalar Arguments ..
      INTEGER NR,NRA
C     ..
C     .. Array Arguments ..
      INTEGER HKL(NR)
C     ..
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,DRMAX,DRMIN
      INTEGER KPRT
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      REAL FUZZM,FUZZP,SQH,SQHMAX,SQHMIN
      INTEGER H,HMAX,HMIN,INDEX,K,KMAX,KMIN,L,LMAX,LMIN
      LOGICAL TEST
C     ..
C     .. External Subroutines ..
      EXTERNAL INDEXM,PAC3,SYMPAC
C     ..
C     .. Common blocks ..
      COMMON /IOPRG/KPRT
      COMMON /RESO/DRMAX,DRMIN,BID1(4)
      COMMON /CELD/AD,BD,CD,BID2(16)
      COMMON /STAR/A11,A21,A22,A31,A32,A33
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA FUZZM,FUZZP/0.9999,1.0001/
C     ..
C
      SQHMIN = FUZZM/DRMAX**2
      SQHMAX = FUZZP/DRMIN**2
C
C          ****************************
      CALL INDEXM(DRMIN,AD,BD,CD,HMAX,KMAX,LMAX)
C          ****************************
C
      HMIN = 0
      KMIN = -KMAX
      LMIN = -LMAX
      INDEX = 0
      NRA = 0
C
      if (kprt.ne.0)
     +write(*,'(/,12x,a,/)')'H           K           L      Index'
C
      DO 30 L = LMIN,LMAX
        DO 20 K = KMIN,KMAX
          DO 10 H = HMIN,HMAX
C
C                ************************
            CALL SYMPAC(H,K,L,INDEX,TEST)
C                ************************
C
            IF (.NOT.TEST) GO TO 10
            SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + 
     +            (A11*H)**2
            IF (SQH.LT.SQHMIN .OR. SQH.GT.SQHMAX) GO TO 10
C
C                *****************
            CALL PAC3(H,K,L,INDEX)
C                *****************
C
            NRA = NRA + 1
            IF (NRA.GT.NR) GO TO 40
            IF (NRA.LT.10 .AND. KPRT.NE.0)
     +         WRITE (*,FMT=*) H,K,L,INDEX
            HKL(NRA) = INDEX
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
      RETURN
   40 WRITE (6,FMT=6000) NRA,NR
C
C          *************************************************
      CALL CCPERR(1, 'Reset ROTING_MI and ROTING_MC')
C          *************************************************
C
 6000 FORMAT 
     + (' > S/R GENRED   ROTING_MI(required)',I10,'  NR(set)',I10)
      END
C
C
C     =============================
      SUBROUTINE GENREF(T2,ND,HKLO)
C     =============================
C
C     .. Scalar Arguments ..
      INTEGER ND,T2
C     ..
C     .. Array Arguments ..
      INTEGER HKLO(ND)
C     ..
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,BID1,DRMIN
C     ..
C     .. Arrays in Common ..
      REAL BID2
C     ..
C     .. Local Scalars ..
      REAL FUZZP,SQH,SQHMAX
      INTEGER H,HMAX,HMIN,I,IND,INDEX,IRES,J,K,KMAX,KMIN,L,LMAX,LMIN,
     +        MULT,NTOT
      LOGICAL TEST
C     ..
C     .. External Subroutines ..
      EXTERNAL INDEXM,MULTES,PAC3,PAC4,SYMPAC
C     ..
C     .. Common blocks ..
      COMMON /CELD/AD,BD,CD,BID2(16)
      COMMON /RESO/BID1,DRMIN,BID3(4)
      COMMON /STAR/A11,A21,A22,A31,A32,A33
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA FUZZP/1.0001/
C     ..
C
      SQHMAX = FUZZP/DRMIN**2
C
C          ****************************
      CALL INDEXM(DRMIN,AD,BD,CD,HMAX,KMAX,LMAX)
C          ****************************
C
      HMIN = 0
      KMIN = -KMAX
      LMIN = -LMAX
      INDEX = 0
      J = 0
      NTOT = 0
C
      IF(T2.NE.0) REWIND (T2)
C
C---- pacote
C
      DO 30 L = LMIN,LMAX
        DO 20 K = KMIN,KMAX
          DO 10 H = HMIN,HMAX
C
C                ************************
            CALL SYMPAC(H,K,L,INDEX,TEST)
C                ************************
C
            IF (.NOT.TEST) GO TO 10
            SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 
     +         + (A11*H)**2
            IF (SQH.GT.SQHMAX) GO TO 10
C
C                ***********************
            CALL PAC3(H,K,L,INDEX)
            CALL MULTES(H,K,L,MULT,IRES)
            CALL PAC4(H,K,L,MULT,IND)
C                ***********************
C
            J = J + 1
            HKLO(J) = IND
C
            IF (J.EQ.ND) THEN
              WRITE (T2) J,HKLO
              NTOT = NTOT + J
              J = 0
            END IF
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
      IF (NTOT.NE.0) THEN
        IF (J.NE.0) WRITE (T2) J,HKLO
      ELSE
        WRITE (T2) J, (HKLO(I),I=1,J)
        ND = J
      END IF
C
      NTOT = NTOT + J
      WRITE(*,*) 'Total of',NTOT,' items written to TEMP2'
C
      RETURN
      END
C
C
C     ====================================
      SUBROUTINE HFFTX(RHKL,PXYZ,II,RR,CC)
C     ====================================
C
C     .. Array Arguments ..
      COMPLEX CC(*)
      REAL RR(*)
      INTEGER II(*)
C     ..
C     .. Subroutine Arguments ..
      EXTERNAL PXYZ,RHKL
C     ..
C     .. Scalars in Common ..
      INTEGER HMAX,KMAX,LMAX,NRA,NWDS,NX,NXYZ,NY,NZ,PH,PZ,T0
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1
C     ..
C     .. Local Scalars ..
      INTEGER HS,NH,NK,NX2,PHT,ZS
      LOGICAL SKIP
C     ..
C     .. Local Arrays ..
      INTEGER DIM(5)
C     ..
C     .. External Subroutines ..
      EXTERNAL CMPLFT,HERMFT,HIN,HTOX,KTOY,ZOUT
C     ..
C     .. Common blocks ..
      COMMON /DFFTT/IBID1(6),NRA,NXYZ
      COMMON /DFFTTD/PH,PZ,T0,NWDS
      COMMON /GRID/HMAX,KMAX,LMAX,NX,NY,NZ
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      NX2 = NX/2
      NH  = HMAX+1
      NK  = 2*KMAX+1
      HS  = 0
      ZS  = 0
      PHT = PH
C
      SKIP = .TRUE.
C
      IF (PH.LT.NH .OR. PZ.LT.NZ) THEN
        SKIP = .FALSE.
C
C               ********************************************
        IFAIL = 0
        CALL CCPDPN(T0,'FFTHKLSCR','SCRATCH','DU',NWDS,IFAIL)
C               ********************************************
      END IF
C
   10 IF (HS+PHT.GT.NH) PHT = NH - HS
C
C          ****************************************
      CALL RHKL(NRA,PHT,NK,NZ,HS,II(1),RR(1),CC(1))
C          ****************************************
C
      DIM(1) = 2*PHT*NK*NZ
      DIM(2) = 2*PHT*NK
      DIM(3) = 2*PHT*NK*NZ
      DIM(4) = DIM(2)
      DIM(5) = 2
C
C          **************************
      CALL CMPLFT(RR(1),RR(2),NZ,DIM)
C          **************************
C
      IF (.NOT.SKIP) CALL ZOUT(T0,PHT,NK,NZ,PZ,HS,RR(1))
      HS = HS + PHT
      IF (HS.LT.NH) GO TO 10
   20 IF (ZS+PZ.GT.NZ) PZ = NZ - ZS
      IF (.NOT.SKIP) CALL HIN(T0,NH,NK,PZ,PH,ZS,NZ,RR(1))
C
C          *****************************
      CALL KTOY(NH,NK,PZ,NY,RR(1),RR(1))
C          *****************************
C
      DIM(1) = 2*NH*NY*PZ
      DIM(2) = 2*NH
      DIM(3) = 2*NH*NY
      DIM(4) = DIM(2)
      DIM(5) = 2
C
C          ******************************
      CALL CMPLFT(RR(1),RR(2),NY,DIM)
ccx from dave love
ccx * there is illegal argument aliasing.  e.g., htox is called as
ccx   call htox(...,rr(1),rr(1)) and the dummy args are (...,ww,vv).  
ccx this   statement then is illegal:
      CALL HTOX(NH,NY,PZ,NX2,RR(1),RR(1))
C          ******************************
C
      DIM(1) = NX*NY*PZ
      DIM(2) = 2
      DIM(3) = DIM(1)
      DIM(4) = DIM(1)
      DIM(5) = NX
C
C     Again The subroutine runs on na/2
      NX2 = NX/2
C          **************************
      CALL HERMFT(RR(1),RR(2),NX2,DIM)
      CALL PXYZ(NX,NY,PZ,ZS,RR(1))
C          **************************
C
      ZS = ZS + PZ
      IF (ZS.LT.NZ) GO TO 20
      IF (.NOT.SKIP .AND. T0.NE.0 ) CLOSE (UNIT=T0)
      RETURN
      END
C
C
C     =======================================
      SUBROUTINE HIN(T0,NH,NK,PZ,PH,ZS,NZ,WW)
C     =======================================
C
C     .. Scalar Arguments ..
      INTEGER NH,NK,NZ,PH,PZ,T0,ZS
C     ..
C     .. Array Arguments ..
      COMPLEX WW(NH,NK*PZ)
C     ..
C     .. Local Scalars ..
      INTEGER HF,HS,IH,IKZ,IREC,PZT,ZREC
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF (ZS.EQ.0) THEN
          ZREC =  (NZ-1)/PZ+1
          PZT  = PZ
      END IF
C
      HF = 0
      IREC = ZS/PZT+1
C
   10 HS = HF + 1
      HF = HF + PH
      IF (HF.GT.NH) HF = NH
      READ (T0,REC=IREC) ((WW(IH,IKZ),IH=HS,HF),IKZ=1,NK*PZ)
      IREC = IREC + ZREC
      IF (HF.LT.NH) GO TO 10
      RETURN
      END
C
C
C     =============================
      SUBROUTINE HOUT(T0,NH,NK,PZ,PH,ZS,WW)
C     =====================================
C
C     .. Scalar Arguments ..
      INTEGER NH,NK,PH,PZ,T0,ZS
C     ..
C     .. Array Arguments ..
      COMPLEX WW(NH,NK*PZ)
C     ..
C     .. Scalars in Common ..
      INTEGER XLW,XUP,YLW,YUP,ZLW,ZUP
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      INTEGER HF,HS,IH,IKZ,IREC
C     ..
C     .. Common blocks ..
      COMMON /DFFTTX/BID1(6),XLW,YLW,ZLW,XUP,YUP,ZUP
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF (ZS.EQ.ZLW) IREC = 0
      HF = 0
   10 HS = HF + 1
      HF = HF + PH
      IF (HF.GT.NH) HF = NH
      IREC = IREC + 1
      WRITE (T0,REC=IREC) ((WW(IH,IKZ),IH=HS,HF),IKZ=1,NK*PZ)
      IF (HF.LT.NH) GO TO 10
      END
C
C
C     =============================
      SUBROUTINE HTOX(NH,NY,NZ,NX2,WW,VV)
C     ===================================
C
C     .. Scalar Arguments ..
      INTEGER NH,NX2,NY,NZ
C     ..
C     .. Array Arguments ..
      COMPLEX VV(NX2,NY,NZ),WW(NH,NY,NZ)
C     ..
C     .. Scalars in Common ..
      INTEGER HMAX,KMAX,LMAX
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1
C     ..
C     .. Local Scalars ..
      INTEGER IH,IY,IZ
C     ..
C     .. Common blocks ..
      COMMON /GRID/HMAX,KMAX,LMAX,IBID1(3)
C     ..
      SAVE /GRID/
C
      DO 40 IZ = NZ,1,-1
        DO 30 IY = NY,1,-1
          DO 10 IH = NX2,HMAX + 2,-1
            VV(IH,IY,IZ) = CMPLX(0.0,0.0)
   10     CONTINUE
          DO 20 IH = HMAX + 1,1,-1
            VV(IH,IY,IZ) = WW(IH,IY,IZ)
   20     CONTINUE
   30   CONTINUE
   40 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE INDEXM(DMIN,AD,BD,CD,HMAX,KMAX,LMAX)
C     ======================================
C
C     .. Scalar Arguments ..
      REAL DMIN
      INTEGER HMAX,KMAX,LMAX,HM,KM,LM,NH,NK,NL,NM
C     ..
C     .. Scalars in Common ..
      REAL AD,BD,CD
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      REAL FUZZP
C     ..
C     .. Common blocks ..
C      COMMON /CELD/AD,BD,CD,BID1(16)
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
C     ..
      SAVE
C     .. Data statements ..
      DATA FUZZP/1.0001/
C     ..
C
      HMAX = NINT(FUZZP*AD/DMIN)
      KMAX = NINT(FUZZP*BD/DMIN)
      LMAX = NINT(FUZZP*CD/DMIN)
C  There is a fudge factor in INDEXM - aagghh - don't get bigger than HM if set
C
      IF(HMAX.GT.HM) HMAX  = HM
      IF(KMAX.GT.KM) KMAX  = KM
      IF(LMAX.GT.LM) LMAX  = LM

      RETURN
      END
C
C
C     =============================
      SUBROUTINE INTERP(HMAX,KMAX,LMAX,NRA,MEQ,HKLS,FC,FCA,FCB,FCG,FCX,
     +                  FCY,FCZ,FF,FT)
C     =================================================================
C
C     .. Parameters ..
      INTEGER NPHI
      PARAMETER (NPHI=720)
C     ..
C     .. Scalar Arguments ..
      INTEGER HMAX,KMAX,LMAX,MEQ,NRA
C     ..
C     .. Array Arguments ..
      COMPLEX FF(NRA),FT(-1:HMAX,-KMAX:KMAX,-LMAX:LMAX)
      REAL FC(NRA),FCA(NRA),FCB(NRA),FCG(NRA),FCX(NRA),FCY(NRA),FCZ(NRA)
      INTEGER HKLS(NRA,MEQ)
C     ..
C     .. Scalars in Common ..
      REAL TX,TY,TZ
      INTEGER NEQ,NEQP
C     ..
C     .. Arrays in Common ..
      REAL DM,DMD,TSS
      INTEGER MSS
C     ..
C     .. Local Scalars ..
      COMPLEX DFH,DFK,DFL,F,FCAR,FCBR,FCGR,FCR,FCXR,FCYR,FCZR,PHASE,
     +        TWOPII,UNOI
      REAL DH,DK,DL,FMOD,PHI,XH,XHA,XK,XKA,XL,XLA
      INTEGER H,HH,HS,IA,IH,IK,IL,IP,IR,IS,K,KK,KS,L,LL,LS,N
      LOGICAL FRIDEL
C     ..
C     .. Local Arrays ..
      COMPLEX CEX(-NPHI:NPHI),FAD(3)
C     ..
C     .. External Subroutines ..
      EXTERNAL UNPAC3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,AIMAG,CONJG,EXP,LOG,MOD,NINT,REAL
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /ROTRA/DM(3,3),DMD(3,3,3),TX,TY,TZ
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA UNOI/ (0.0,1.0)/,TWOPII/ (0.0,6.2831853)/
C     ..
C
      DO 10 N = -NPHI,NPHI
        CEX(N) = EXP(N*TWOPII/NPHI)
   10 CONTINUE
C
      DO 40 IR = 1,NRA
        FCR = FF(IR)
        FCAR = (0.0,0.0)
        FCBR = (0.0,0.0)
        FCGR = (0.0,0.0)
        FCXR = (0.0,0.0)
        FCYR = (0.0,0.0)
        FCZR = (0.0,0.0)
C
C            ************************
        CALL UNPAC3(H,K,L,HKLS(IR,1))
C            ************************
C
        DO 30 IS = 1,NEQP
C
C              ****************************
          CALL UNPAC3(HS,KS,LS,HKLS(IR,IS))
C              ****************************
C
          PHI = MOD(TSS(1,IS)*H+TSS(2,IS)*K+TSS(3,IS)*L+HS*TX+KS*TY+
     +          LS*TZ,1.0)
          IP = NINT(PHI*NPHI)
          PHASE = CEX(IP)
C
          XH = DM(1,1)*HS + DM(2,1)*KS + DM(3,1)*LS
          XK = DM(1,2)*HS + DM(2,2)*KS + DM(3,2)*LS
          XL = DM(1,3)*HS + DM(2,3)*KS + DM(3,3)*LS
C
          FRIDEL = .FALSE.
C
          IF (XH.LT.0.0) THEN
            XH = -XH
            XK = -XK
            XL = -XL
            FRIDEL = .TRUE.
          END IF
C
          HH = NINT(XH)
          DH = XH - HH
          IH = 1
          IF (DH.LT.0.0) IH = -1
          KK = NINT(XK)
          DK = XK - KK
          IK = 1
          IF (DK.LT.0.0) IK = -1
          LL = NINT(XL)
          DL = XL - LL
          IL = 1
          IF (DL.LT.0.0) IL = -1
          DFH = (FT(HH+IH,KK,LL)-FT(HH,KK,LL))/IH
          DFK = (FT(HH,KK+IK,LL)-FT(HH,KK,LL))/IK
          DFL = (FT(HH,KK,LL+IL)-FT(HH,KK,LL))/IL
          F = FT(HH,KK,LL) + DFH*DH + DFK*DK + DFL*DL
          IF (FRIDEL) F = CONJG(F)
          IF (FRIDEL) DFH = -CONJG(DFH)
          IF (FRIDEL) DFK = -CONJG(DFK)
          IF (FRIDEL) DFL = -CONJG(DFL)
          F = F*PHASE
          DFH = DFH*PHASE
          DFK = DFK*PHASE
          DFL = DFL*PHASE
C
          DO 20 IA = 1,3
            XHA = DMD(1,1,IA)*HS + DMD(2,1,IA)*KS + DMD(3,1,IA)*LS
            XKA = DMD(1,2,IA)*HS + DMD(2,2,IA)*KS + DMD(3,2,IA)*LS
            XLA = DMD(1,3,IA)*HS + DMD(2,3,IA)*KS + DMD(3,3,IA)*LS
            FAD(IA) = XHA*DFH + XKA*DFK + XLA*DFL
   20     CONTINUE
C
          FCR = FCR + F
          FCAR = FAD(1) + FCAR
          FCBR = FAD(2) + FCBR
          FCGR = FAD(3) + FCGR
          FCXR = F*HS + FCXR
          FCYR = F*KS + FCYR
          FCZR = F*LS + FCZR
   30   CONTINUE
C
        FMOD = ABS(FCR)
C
        IF (FMOD.GT.0.0) THEN
          PHI = AIMAG(LOG(FCR))
        ELSE
          PHI = 0.0
        END IF
C
        PHASE = EXP(-UNOI*PHI)
        FC(IR) = FMOD
        FCA(IR) = REAL(FCAR*PHASE)
        FCB(IR) = REAL(FCBR*PHASE)
        FCG(IR) = REAL(FCGR*PHASE)
        FCX(IR) = REAL(FCXR*TWOPII*PHASE)
        FCY(IR) = REAL(FCYR*TWOPII*PHASE)
        FCZ(IR) = REAL(FCZR*TWOPII*PHASE)
   40 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE INV3(R,S)
C     ====================
C
C     .. Array Arguments ..
      INTEGER R(3,3),S(3,3)
C     ..
C
      S(1,1) = R(2,2)*R(3,3) - R(2,3)*R(3,2)
      S(1,2) = R(1,3)*R(3,2) - R(1,2)*R(3,3)
      S(1,3) = R(1,2)*R(2,3) - R(1,3)*R(2,2)
      S(2,1) = R(2,3)*R(3,1) - R(2,1)*R(3,3)
      S(2,2) = R(1,1)*R(3,3) - R(1,3)*R(3,1)
      S(2,3) = R(1,3)*R(2,1) - R(1,1)*R(2,3)
      S(3,1) = R(2,1)*R(3,2) - R(2,2)*R(3,1)
      S(3,2) = R(1,2)*R(3,1) - R(1,1)*R(3,2)
      S(3,3) = R(1,1)*R(2,2) - R(1,2)*R(2,1)
      RETURN
      END
C
C
C     =============================
      SUBROUTINE KTOY(NH,NK,NZ,NY,WW,VV)
C     ==================================
C
C     .. Scalar Arguments ..
      INTEGER NH,NK,NY,NZ
C     ..
C     .. Array Arguments ..
      COMPLEX VV(NH,NY,NZ),WW(NH,NK,NZ)
C     ..
C     .. Scalars in Common ..
      INTEGER HMAX,KMAX,LMAX
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1
C     ..
C     .. Local Scalars ..
      INTEGER IH,IK,IZ
C     ..
C     .. Common blocks ..
      COMMON /GRID/HMAX,KMAX,LMAX,IBID1(3)
C     ..
      SAVE
C
      DO 70 IZ = NZ,1,-1
        DO 20 IK = 0,-KMAX + 1,-1
          DO 10 IH = NH,1,-1
            VV(IH,NY+IK,IZ) = WW(IH,NK+IK,IZ)
   10     CONTINUE
   20   CONTINUE
C
        DO 40 IK = NY - KMAX,KMAX + 2,-1
          DO 30 IH = NH,1,-1
            VV(IH,IK,IZ) = (0.0,0.0)
   30     CONTINUE
   40   CONTINUE
C
        DO 60 IK = KMAX + 1,1,-1
          DO 50 IH = NH,1,-1
            VV(IH,IK,IZ) = WW(IH,IK,IZ)
   50     CONTINUE
   60   CONTINUE
   70 CONTINUE
C
      RETURN
      END
C
C
C     =========================================================
      SUBROUTINE LECATC(IXYZIN,CARAT,IZ,ID,XI,BISO,FIRST,LAST)
C     =========================================================
C
C     .. Scalar Arguments ..
      REAL BISO
      INTEGER IXYZIN,IZ
      LOGICAL FIRST,LAST
      CHARACTER CARAT*18,ID*4
C     ..
C     .. Array Arguments ..
      REAL XI(3)
C     ..
C     .. Scalars in Common ..
      REAL A,ALPHA,B,BETA,C,GAMMA
      INTEGER NCODE
C     ..
C     .. Arrays in Common ..
      REAL RF,RO
C     ..
C     .. Locals ..
      REAL BIN(6),PCELL(6),OCC,NBZERO,VOL,X,Y,Z
      INTEGER ISER
      CHARACTER ATNAM*4,CHNNAM*1,RESNAM*4,RESNO*4,INSCOD*1,ALTCOD*1,
     +          SEGID*4
C     ..
C     .. External Subroutines ..
      EXTERNAL CELDA,ORTHO,RBCELL,XYZADVANCE,XYZATOM,
     +         XYZCOORD,XYZREWD
C     ..
C     .. Common blocks ..
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /ORTM/RO(3,3),RF(3,3),NCODE
C     ..
C     .. Save statement ..
      SAVE
C
C----   Default format Brookhaven.
C       Default Input type set to ORTO
C       Should skip all default lines:
C
      CARAT = ' '
      NBZERO = 0
C
      IF (FIRST) CALL XYZREWD (IXYZIN)
C
C          **********************************************************
20    CALL XYZADVANCE(IXYZIN,0,0,*70,*70)
      CALL XYZATOM(IXYZIN,ISER,ATNAM,RESNAM,CHNNAM,IRESN,RESNO,
     +                INSCOD,ALTCOD,SEGID,IZ,ID)
      CALL XYZCOORD(IXYZIN,'O','U',X,Y,Z,OCC,BISO,BIN)
C          **********************************************************
C---- SKIP if ALTCOD not blank or A
C
      IF(ALTCOD.NE.' ' .AND. ALTCOD.NE.'A') GO TO 20
C            ***********************************************************
C
C---- Check for anisotropic Bs, skip ANISOU
C
      IF (BIN(2).NE.0.0 .OR. BIN(3).NE.0.0) THEN
        IF (X.EQ.0.0 .AND. Y.EQ.0.0 .AND. Z.EQ.0.0) GOTO 20
      ENDIF

      IF (FIRST) THEN
C
C        *****************
        CALL RBCELL(PCELL,VOL)
C        *****************
C
        FIRST = .FALSE.
        IF (PCELL(1) * PCELL(2) * PCELL(3) .NE. 0) THEN

          A     = PCELL(1)
          B     = PCELL(2)
          C     = PCELL(3)
          ALPHA = PCELL(4)
          BETA  = PCELL(5)
          GAMMA = PCELL(6)
C
C              *****
          CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
C              *****
C
          NCODE = 1
C
C              *****
          CALL ORTHO
C              *****
C
        ENDIF
      ENDIF
C
C
      CARAT = ATNAM//' '//RESNAM//CHNNAM//RESNO//ID
      IF (ABS(OCC).LT.0.001) GO TO 20
      IF (IZ .EQ. 1) GO TO 20
C
      IF (BISO .LT. 0.001) THEN
        BISO = 20.0
        NBZERO = NBZERO + 1
      ENDIF

      XI(1) = X
      XI(2) = Y
      XI(3) = Z
      IZ  = 1000*IZ + NINT(100.0*OCC)
C
      RETURN
   70 CONTINUE
      IF(NBZERO.GT.0) WRITE(6,'(//,I4,A)')
     +     NBZERO,' ATOMS HAVE Bfactor reset from 0.0 to 20.0'
      LAST = .TRUE.
      RETURN
      END
C
C
C     ==============================================================
      SUBROUTINE LECFOQ(UDI,ND,NR,NRA,MEQ,HKLO,HKL,HKLS,MFO,PHO,FOB,HSQ,
     +                  PHASFLG)
C     ==============================================================
C
C   ND - number of reflections in a block ( 1000 at present)
C   NR - maximum permitted number of reflections.
C   NRA - number of reflections: summed in this SR
C   MEQ - number of symmetry operators
C   HKLO(ND),MFO(ND)
C   HKL( MEQ*NR),HKLS(NR,MEQ)  - why both needed???
C   FOB(2*NR)
C   PHO(ND)
C
C  FOB(..) can be larger than NR. Try dimension FOB(2*NR)
C  FOB(IR+NRA)  = HSQ(IR) which is either 4SSQ OR PHIobs
C   Ditto HKL - needs dimensioning HKL(MEQ*NR)
C For some obscure reason HKL(IR+NRA*(IEQ -1))  = HKLS(IR,IEQ)
C
C     .. Scalar Arguments ..
      INTEGER MEQ,ND,NR,NRA,UDI
C     ..
C     .. Array Arguments ..
C     These adjustable array dimensions lose with bounds checking --
C     they need investigating, but this routine is doing nasty things...
CCC      REAL FOB(2*NR),HSQ(NR),MFO(ND)
CCC      INTEGER HKL(MEQ*NR),HKLO(ND),HKLS(NR,MEQ)
      REAL FOB(*),HSQ(*),MFO(*),PHO(ND)
      INTEGER HKL(*),HKLO(*),HKLS(NR,*),HMM
      CHARACTER PHASFLG*1
C     ..
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,BFACT,CORF,CORI,CORP,DMAX,DMIN,
     +     DRMAX,DRMIN,FMAX,FMIN,RFLI,RFSQ,SCALE,SFLI,SFSQ,TFAC
      INTEGER IBID1,NEQ,NEQP,NTOT
C     ..
C     .. Arrays in Common ..
      REAL BID1,TSS
      INTEGER IBID2,MSS
C     ..
C     .. Local Scalars ..
      REAL FO,SQH,SQHMAX,SQHMIN,SQHSUP
      INTEGER H,HS,I,IR,IS,ISC,K,KS,L,LS,M,MULT
C     ..
C     .. External Subroutines ..
      EXTERNAL PAC3,UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC EXP,SQRT
C     ..
C     .. Common blocks ..
      COMMON /CTLX/IBID1,FMIN,FMAX,TFAC
      COMMON /NUMO/NTOT,IBID2(6)
      COMMON /POTE/SFLI,SFSQ,SFQU,RFLI,RFSQ,CORF,CORI,CORP,SCALE,BFACT
      COMMON /RESO/DRMAX,DRMIN,DMAX,DMIN,BID1(2)
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /STAR/A11,A21,A22,A31,A32,A33
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      NRA = 0
      NTOT = 0
      SQHMIN =  (1/DRMAX)**2
      SQHMAX =  (1/DRMIN)**2
      SFLI   = 0.0
      SFSQ   = 0.0
      SFQU   = 0.0
      SQHSUP = 0.0
C
      IF(UDI.NE.0) REWIND (UDI)
C
C----  Read first 3 records
C
      READ (UDI)AA,BB,CC,AALL,BBEE,GGAA
      READ (UDI)NTTTSSS,NNEEQQPP
      IF(NTTTSSS.GT.0) READ(UDI) TTTSSS
      READ (UDI)HMM,KMM,LMM,NHH,NKK,NLL,NMM,DMMiNN
c      WRITE (6,FMT='(A,I4,35(/,3i4,f10.4))') ' in lecfoq',neqp,
c     +  (((MSS(I,J,N),J=1,3),TSS(I,N),
c     +  I=1,3),N=1,NEQP)

   10 CONTINUE
      READ (UDI,END=40) M, (HKLO(I),I=1,M), (MFO(I),I=1,M),
     +                                      (PHO(I),I=1,M)
      IF (M.GT.ND) GO TO 80
C
      DO 30 I = 1,M
C
C            **************************
        CALL UNPAC4(H,K,L,MULT,HKLO(I))
C            **************************
C
        SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
        IF (SQH.LT.SQHMIN .OR. SQH.GT.SQHMAX) GO TO 30
        FO = MFO(I)
        IF (TFAC.NE.0.0) FO = FO*EXP(-TFAC*SQH/4.0)
        IF (FO.LT.FMIN .OR. FO.GT.FMAX) GO TO 30
        NRA = NRA + 1
        IF (NRA.GT.NR) GO TO 90
        NTOT = NTOT + MULT
        SFLI = MULT*FO + SFLI
        SFSQ = MULT*FO*FO + SFSQ
        SFQU = MULT*FO*FO*FO*FO + SFQU
        IF (SQH.GT.SQHSUP) SQHSUP = SQH
        HKL(NRA) = HKLO(I)
        FOB(NRA) = FO
C
        DO 20 IS = 1,NEQP
          HS = H*MSS(1,1,IS) + K*MSS(2,1,IS) + L*MSS(3,1,IS)
          KS = H*MSS(1,2,IS) + K*MSS(2,2,IS) + L*MSS(3,2,IS)
          LS = H*MSS(1,3,IS) + K*MSS(2,3,IS) + L*MSS(3,3,IS)
C
C              ***************************
          CALL PAC3(HS,KS,LS,HKLS(NRA,IS))
C              ***************************
C
   20   CONTINUE
C
        HSQ(NRA) = SQH
        IF(PHASFLG.EQ.'P' .OR. PHASFLG.EQ.'p')HSQ(NRA) = PHO(I)
   30 CONTINUE
      GO TO 10
   40 DRMIN = SQRT(ABS(1/SQHSUP) )
      WRITE (6,FMT=6000) NRA,DRMAX,DRMIN,TFAC,SFLI,SFSQ
C
      DO 50 IR = 1,NRA
        FOB(NRA+IR) = HSQ(IR)
   50 CONTINUE
C
      DO 70 IS = 1,NEQP
        ISC = (IS-1)*NRA
        DO 60 IR = 1,NRA
          HKL(NRA+ISC+IR) = HKLS(IR,IS)
   60   CONTINUE
   70 CONTINUE
C
      RETURN
   80 WRITE (6,FMT=6002) M,ND
C
C          ***********************************
      CALL CCPERR(1,' > s/r lecfoq < m > nd:')
C          ***********************************
C
   90 WRITE (6,FMT=6004) NRA,NR
C
C          *************************************
      CALL CCPERR(1,'Reset dimension TRAING_NR or FITING_NR')
C          *************************************
C
 6000 FORMAT (/,
     +' LECFOQ.',I10,' Reflections between',F10.3,' and',F10.3,/,
     +' FO = FOB*EXP(-B*HSQ/4). B:',E15.5,/,
     +' SUM FO:',E15.5,', SUM FOSQ:',E15.5)
 6002 FORMAT (' ** S/R LECFOQ **  M > ND - inconsistent Amores:',2I10)
 6004 FORMAT 
     + (' > S/R LECFOQ   TRA/FITING_NR(required)',I10,'  NR(set)',I10)
      END
C     =============================
      SUBROUTINE LECFOR(UDI,ND,MR,HKLO,MFO,MF,DMAX,DMIN)
C     ============================================
C
C     .. Scalar Arguments ..
      REAL DMAX,DMIN
      INTEGER ND,UDI
C     ..
C     .. Array Arguments ..
      REAL MFO(ND),MF(MR)
      INTEGER HKLO(ND)
C     ..
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,FMAX,FMIN,TFAC
      INTEGER NR,NSYM
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1,IBID2
C     ..
C     .. Local Scalars ..
      REAL FF,RH,RHL,RHMAX,RHMIN,RHU,SQH
      INTEGER H,I,K,L,M,MULT
C     ..
C     .. External Subroutines ..
      EXTERNAL UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC EXP,SQRT
C     ..
C     .. Common blocks ..
      COMMON /CTLX/NSYM,FMIN,FMAX,TFAC
      common/dsph/ nr,nl,nq,npr,npa,lmax
C      COMMON /DSPH/IBID1(2),NR,IBID2(3)
      COMMON /STAR/A11,A21,A22,A31,A32,A33
      COMMON /PACO/HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      RHMIN = 1/DMAX
      RHMAX = 1/DMIN
      RHL   = 1/DMIN
      RHU   = 1/DMAX
C
      NR = 0
      IF(UDI.NE.0) REWIND (UDI)
C
C---- Do I need to build STAR, prob done from ROTNDO when UDI opened..
C
      READ (UDI)AA,BB,CC,AALL,BBEE,GGAA
      READ (UDI)NTTTSSS,NNEEQQPP
      IF(NTTTSSS.GT.0) READ(UDI) TTTSSS
      READ (UDI)HMM,KMM,LMM,NHH,NKK,NLL,NMM,DMMiNN
   10 CONTINUE
      READ (UDI,END=40) M, (HKLO(I),I=1,M), (MFO(I),I=1,M)
      IF (M.GT.ND)
     +     CALL CCPERR(1,' > s/r lecfor < wrong format of input file')
C
      DO 30 I = 1,M
C
C            **************************
        CALL UNPAC4(H,K,L,MULT,HKLO(I))
C            **************************
C
        IF (MULT.EQ.1) GO TO 20
        SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
        RH = SQRT(ABS(SQH) )
        IF (RH.LT.RHMIN .OR. RH.GT.RHMAX) GO TO 20
        FF = MFO(I)
        IF (TFAC.NE.0.0) FF = FF*EXP(-TFAC*SQH/4.0)
        IF (FF.LT.FMIN .OR. FF.GT.FMAX) GO TO 20
        NR = NR + 1
        IF (RH.LT.RHL) RHL = RH
        IF (RH.GT.RHU) RHU = RH
        MF(NR) = FF
   20   CONTINUE
C
   30 CONTINUE
      GO TO 10
   40 IF (NR.LE.0)
     +     CALL CCPERR(1,' > s/r lecfor < no reflection selected')
      DMAX = 1/RHL
      DMIN = 1/RHU
      RETURN
C
      END
C
C
C     =============================
      SUBROUTINE LECFOS(H,K,L,FO,SIG,PHI,FIRST,LAST)
C     ==============================================
C
C     .. Scalar Arguments ..
      REAL FO,SIG
      INTEGER H,K,L
      LOGICAL FIRST,LAST
C     ..
C     .. Scalars in Common ..
      REAL DRMAXS,DRMINS,SMIN,SMAX
      INTEGER KPRT,NEQ,NEQP
      LOGICAL HAVSIG,HAVPHI,HAVFOM
C     ..
C     .. Arrays in Common ..
      REAL TSS,CELLS
      INTEGER MSS
C     ..
C     .. Local Scalars ..
      REAL RESL
      INTEGER I,J,N
      LOGICAL EOF
C     ..
C     .. Local Arrays ..
      REAL ADATA(200)
      LOGICAL LOGMSS(200)
C     ..
C     .. External Subroutines ..
      EXTERNAL LRREFF
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC NINT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /IOPRG/KPRT
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /SORTFUN/CELLS(6),DRMAXS,DRMINS,SMIN,SMAX,
     + IHMINS,IHMAXS,IKMINS,IKMAXS,ILMINS,ILMAXS,HAVSIG,HAVPHI,HAVFOM
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      FO = 0.0
      SIG = 0.0
      PHI = 0.0
      IF (FIRST) THEN
        FIRST = .FALSE.
        IF (KPRT.NE.0) WRITE (6,FMT=6000) NEQP
C
        DO 10 N = 1,NEQP
          IF (KPRT.NE.0) WRITE (6,FMT=6002) ((MSS(I,J,N),J=1,3),
     +        TSS(I,N),I=1,3)
   10   CONTINUE
        IF(NTS.GT.0 .AND. KPRT.NE.0 ) WRITE (6,FMT=6004)
     +  ((TTS(I,ITS),I=1,3),ITS=1,NTS)
C
 6000   FORMAT (/' SPACE GROUP.',I5,' Primitive EQUIVALENT POSITIONS')
 6002   FORMAT (3 (/3I5,F10.6))
 6004   FORMAT (/' Centring operators',3(/,3F8.3))
        GO TO 20
      END IF
   20 CONTINUE
C
C          ************************
      CALL LRREFF(1,RESL,ADATA,EOF)
C          ************************
C
      IF (EOF) GO TO 30
      CALL LRREFM(1,LOGMSS)
C   Don't keep reflections outside highest resolution cut off.
      IF(RESL.GT.SMAX) GO TO 20
      H = NINT(ADATA(1))
      K = NINT(ADATA(2))
      L = NINT(ADATA(3))
      W = 1.0
      IF (LOGMSS(4)) GO TO 20
      FO = ADATA(4)
      IF (FO.LE.0.0) GO TO 20
      IF (HAVSIG) THEN
C       SIGFP assigned
        IF (LOGMSS(5)) GO TO 20
        SIG = ADATA(5)
        IF (SIG.LE.0.0) GO TO 20
      ELSE
        SIG = 0.0
      END IF
      IF (HAVPHI) THEN
C       PHI assigned
        PHI = 0.0
        IF (LOGMSS(10)) GO TO 20
        PHI = ADATA(10)*DTOR
          IF(HAVFOM)THEN
           IF(LOGMSS(11)) GO TO 20
           IF(ADATA(11).LE.0.000001) GO TO 20
C           W=ADATA(11)
           FO = ADATA(11)*FO
          END IF
      END IF
       SIG = SIG/FO
      RETURN
   30 LAST = .TRUE.
      END
C
C
C     =============================
      SUBROUTINE LECTAB(ITAB,HMAX,KMAX,LMAX,FT)
C     =========================================
C
C     .. Scalar Arguments ..
      INTEGER HMAX,ITAB,KMAX,LMAX
C     ..
C     .. Array Arguments ..
      COMPLEX FT(-1:HMAX,-KMAX:KMAX,-LMAX:LMAX)
C     ..
C     .. Scalars in Common ..
      REAL A,A11,A21,A22,A31,A32,A33,ALPHA,B,BETA,C,DMAX,DMIN,DRMAX,
     +     DRMIN,GAMMA
      INTEGER KPRT,NCODE
C     ..
C     .. Arrays in Common ..
      REAL BID1,RF,RO
C     ..
C     .. Local Scalars ..
      REAL DSQ,SQH,SQHSUP
      INTEGER H,HSUP,K,KSUP,L,LSUP
C     ..
C     .. External Subroutines ..
      EXTERNAL CELDA,ORTHO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C     ..
C     .. Common blocks ..
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /IOPRG/KPRT
      COMMON /ORTM/RO(9),RF(9),NCODE
      COMMON /RESO/DRMAX,DRMIN,DMAX,DMIN,BID1(2)
      COMMON /STAR/A11,A21,A22,A31,A32,A33
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF(ITAB.NE.0) REWIND (ITAB)
      READ (ITAB) A,B,C,ALPHA,BETA,GAMMA,NCODE,HSUP,KSUP,LSUP,SQHSUP
C
C          *****
      CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
      CALL ORTHO
C          *****
C
      DSQ = 0.0
C
      DO 30 H = -1,1
        DO 20 K = -1,1
          DO 10 L = -1,1
            SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 
     +          + (A11*H)**2
            IF (SQH.GT.DSQ) DSQ = SQH
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
      DMIN = 1/ (SQRT(ABS(SQHSUP) ) -SQRT(ABS(DSQ)) )
C
      IF (KPRT.NE.0) THEN
        WRITE (6,FMT=*) ' In LECTAB '
        WRITE (6,FMT=*) ' H,K,L Limits for array:',HSUP,KSUP,LSUP
        WRITE (6,FMT=*) ' Resolution Limit for Interpolation:',DMIN
        WRITE (6,FMT=*) 
     +   ' Dimension of complex array must be more than:',
     +    (HSUP+2)* (2*KSUP+1)* (2*LSUP+1)
      END IF
C
      IF (DMIN.GE.DRMIN) GO TO 40
      READ (ITAB) FT
      RETURN
C
   40 WRITE (6,FMT=6000) DMIN,DRMIN
C
C          ************************************************
      CALL CCPERR(1,' > s/r lectab < resolution mismatch:')
C          ************************************************
C
 6000 FORMAT (' > S/R LECTAB < RESOLUTION MISTMACH:',2F10.3)
      END
C
C
      subroutine lqmax(ml,nmix,atl2,atl1)
      implicit none
      integer ml,l,lmin,lmax,nl,nq,nr,ibid1,nmix(2*ml)
      real twopi,xmax,rmax,drmin,xmin,rmin,drmax,rbid1,atl2(ml),
     & atl1(ml),pi,dtor,rtod
      common/reso/ drmax,drmin,rbid1(2),rmin,rmax
      common/dsph/ nr,nl,nq,ibid1(2),lmax
      common/angkte/ pi,twopi,dtor,rtod
      xmax=twopi*rmax/drmin
      xmin=twopi*rmin/drmin
      do 10 l=1,2*ml
      nmix(l)=0
10    continue
      lmin=0
      do 20 l=2,lmax,2
      if(atl2(l).le.xmin) lmin=l
      if(atl1(l).gt.xmax) go to 30
      nmix(l)=(lmax-l)/2
20    continue
30    nl=l-2
      lmax=l-2
      lmin=lmin+2
      do 40 l=2,lmin,2
      nmix(lmax+l)=(lmin-l)/2
40    continue
      nq=nmix(2)
      return
      end
C     =============================
      SUBROUTINE LQTERM(ML,ZBES,ZTLM,XMAX)
C     ====================================
C
C     .. Scalar Arguments ..
      REAL XMAX
      INTEGER ML
C     ..
C     .. Array Arguments ..
      REAL ZBES(ML),ZTLM(ML)
C     ..
C     .. Scalars in Common ..
      INTEGER IBID1,LMAX,NQ
C     ..
C     .. Arrays in Common ..
      INTEGER IBID2
C     ..
C     .. Local Scalars ..
      INTEGER L,MQ
C     ..
C     .. External Subroutines ..
      EXTERNAL QTERM
C     ..
C     .. Common blocks ..
      COMMON /DSPH/IBID1,NQ,IBID2(3),LMAX
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      LMAX = 0
      NQ   = 0
C
      DO 10 L = 2,ML,2
        IF (ZBES(L).GT.XMAX .AND. ZTLM(L).GT.XMAX) GO TO 20
        LMAX = L
C
C            ****************
        CALL QTERM(L,XMAX,MQ)
C            ****************
C
        IF (NQ.LT.MQ) NQ = MQ
   10 CONTINUE
C
   20 RETURN
      END
C
C
C     =============================
      SUBROUTINE MDHFT(W,NA,NG)
C     =========================
C
C     .. Scalar Arguments ..
      INTEGER NA,NG
C     ..
C     .. Array Arguments ..
      REAL W(NA*NG)
C     ..
C     .. Local Arrays ..
      INTEGER DIM(5)
C     ..
C     .. External Subroutines ..
      EXTERNAL CMPLFT,HERMFT
C     ..
C
      DIM(1) = NA*NG
      DIM(2) = NA
      DIM(3) = NA*NG
      DIM(4) = DIM(2)
      DIM(5) = 2
C
C          ************************
      CALL CMPLFT(W(1),W(2),NG,DIM)
C          ************************
C
      DIM(1) = NA*NG
      DIM(2) = 2
      DIM(3) = DIM(1)
      DIM(4) = DIM(1)
      DIM(5) = NA
C
C     Again The subroutine runs on na/2
      NA2 = NA/2
C          ************************
      CALL HERMFT(W(1),W(2),NA2,DIM)
C          ************************
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE MINTAB(JTAB,HMAX,KMAX,LMAX,HSUP,KSUP,LSUP,SQHSUP,FTI,
     +                  FTO)
C     ===============================================================
C
C  Add ASCII structure factor output to CHANNEL JSFO if requested.
C     .. Scalar Arguments ..
      REAL SQHSUP,G(2),FC,PHIC
      INTEGER HMAX,HSUP,JTAB,KMAX,KSUP,LMAX,LSUP,
     +        ISORT,ITAB,IROT,ITRA,IFIT,IMR
      COMPLEX FF
C     ..
C     .. Array Arguments ..
      COMPLEX FTI(-1:HMAX,-KMAX:KMAX,-LMAX:LMAX),
     +        FTO(-1:HSUP,-KSUP:KSUP,-LSUP:LSUP)
C     ..
C     .. Scalars in Common ..
      REAL A,ALPHA,B,BETA,C,GAMMA
      INTEGER NCODE
C     ..
C     .. Arrays in Common ..
      REAL RF,RO
C     ..
C     .. Local Scalars ..
      INTEGER H,K,L
C     ..
C     .. Common blocks ..
      COMMON /CNTRL/ISORT,ITAB,IROT,ITRA,IFIT,IMR,JSFO
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /ORTM/RO(9),RF(9),NCODE
C
C     .. Equivalences ..
      EQUIVALENCE (FF,G(1))
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF (HSUP.EQ.HMAX .AND. KSUP.EQ.KMAX .AND.
     +    LSUP.EQ.LMAX) GO TO 40
C
      IF(ITAB.EQ.2)WRITE (JSFO,'(6f8.3,4i5,f8.4)') 
     + A,B,C,ALPHA,BETA,GAMMA,NCODE,HSUP,KSUP,LSUP,SQHSUP
      DO 30 L = -LSUP,LSUP
        DO 20 K = -KSUP,KSUP
          DO 10 H = -1,HSUP
            FTO(H,K,L) = FTI(H,K,L)
             IF(ITAB.EQ.2) THEN
C   Use equiv FF G(2)
                FF = FTI(H,K,L)
                FC = SQRT( ABS(G(1)*G(1) + G(2)*G(2)))
                PHIC = 0.0
                 IF( FC.GT.0.0000001) THEN
                  PHIC = 57.29578*ATAN2(G(2),G(1))
                  write(JSFO,'(3i5,E18.8,F10.3)')H,K,L,FC,PHIC
                 END IF
               END IF
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
   40 IF(JTAB.NE.0) REWIND (JTAB)
      WRITE (JTAB) A,B,C,ALPHA,BETA,GAMMA,NCODE,HSUP,KSUP,LSUP,SQHSUP
      WRITE (JTAB) FTO
      RETURN
      END
C
C
C     =============================
C
      SUBROUTINE MR2IC
C     ================
C
C     .. Scalars in Common ..
      INTEGER KPRT,IVERB
C     ..
C     .. Local Scalars ..
      INTEGER IUNIT
C     ..
C     .. External Subroutines ..
      EXTERNAL MR2NDO
C     ..
C     .. Common blocks ..
      COMMON /IOPRG/KPRT
      COMMON /ALLFUN/IVERB,ITABB(5),FMINC(5),FMAXC(5),TFACC(5),NSYM,
     +       NSYMP,RSYM(4,4,96)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
           KPRT = IVERB
           IUNIT = 0
C
C          **********
      CALL MR2NDO(IUNIT)
C          **********
C
      IF(IUNIT.NE.0) CLOSE (UNIT=IUNIT,STATUS='KEEP')
      RETURN
      END
C
C
C     =============================
      SUBROUTINE MR2NDO(IUNIT)
C     =====================
C
      INTEGER NSOL
      PARAMETER (NSOL=499)
C     ..
C     .. Arguments ..
      INTEGER IUNIT
C     ..
C     .. Scalar Arguments..
      INTEGER UDI,HCK2,KCK2,LCK2,NCKH2,NCKK2,NCKL2,NCKM2
C     .. Scalars in Common..
      REAL A,B,C,ALPHA,BETA,GAMMA
      INTEGER NEQ,NEQP,IVERB,NSYM,NSYMP,
     +        HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1
C     .. Arrays in Common..
      REAL TSS,FMINC,FMAXC,TFACC
      INTEGER ITABB,MSS
       CHARACTER TRATYP*3
C     .. Common blocks ..
C
C     ..Local Scalars..
      INTEGER LREC,IFAIL,JDO20,JDO30,ISYM
      CHARACTER FILNAM*10
C
C     .. Save statement ..
      SAVE
C     .. External Subroutines
      EXTERNAL CELDA,ORTHO,CCPERR
      INTRINSIC NINT
C     .. Scalars in Common ..
      REAL DRMAXT,DRMINT,DMINTT,SHRTTR, RPTST,DELTAT,EPSNF
      INTEGER KPRT,NCODE,ISORT,ITAB,IROT,ITRA,IFIT,IMR,
     + NPICT,ITMAXF,ISF,IAF,IBF,IGF,IXF,IYF,IZF
C     ..
C     .. Arrays in Common ..
      REAL RF,RO,CMASS,EULER,
     +     ALT,BET,GAT,TXT,TYT,TZT,CRT,RFT

      INTEGER ISHIFT,ITBT
C     ..
C     .. Local Scalars ..
      REAL AL,AL0,BE,BE0,GA,GA0
C     ..
C     .. Local Arrays ..
      REAL CM(3),PF(8,100),R(3,3),R0(9,100),RFO(3,3),RX(3,3),
     +     TX(3),V(3),TRA(3)
      INTEGER I0(100),TF(100)
C     ..
C     .. External Subroutines ..
      EXTERNAL PRO2MX,PRO3MX,RMX2E,RMXE
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC INDEX
C     ..
C     .. Common blocks ..
      COMMON /ALLFUN/IVERB,ITABB(5),FMINC(5),FMAXC(5),TFACC(5),NSYM,
     +       NSYMP,RSYM(4,4,96)
      COMMON /CELOBS/AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS(3,3),NCDOBS
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /CNTRL/ISORT,ITAB,IROT,ITRA,IFIT,IMR,JSFO
      COMMON /IOPRG/KPRT
      COMMON /ORTM/RO(3,3),RF(3,3),NCODE
      COMMON /INTAB/ISHIFT(4),CMASS(3,4),EULER(3,4)
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /TRAFITC/TRATYP
      COMMON /TRAFIT/NCODT,DRMAXT,DRMINT,DMINTT,SHRTTR,NMOLT,
     +       RPTST,DELTAT,NPICT,ITBT(NSOL),ALT(NSOL),BET(NSOL),
     +       GAT(NSOL),TXT(NSOL),TYT(NSOL),TZT(NSOL),CRT(NSOL),
     +       RFT(NSOL),ITMAXF,EPSNF,ISF,IAF,IBF,IGF,IXF,IYF,IZF,SCDT
c      COMMON /TRAFIT/NCODT,BID3(4),NMOLT,BID2(5),
c     +       ITBT(NSOL),ALT(NSOL),BET(NSOL),GAT(NSOL),TXT(NSOL),
c     +       TYT(NSOL),TZT(NSOL),BID4(2*NSOL + 9)
      COMMON /PACO/HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1
C     SAVE /CELOBS/, /CNTRL/, /IOPRG/, /ORTM/, /INTAB/, /TRAFIT/
C     ..
C     .. Data statements ..
      DATA I0/100*0/,R0/900*0.0/,TF/100*0/,PF/800*0.0/
C     ..
C
      NCODE = NCODT
      WRITE (6,'(//,A,/,A)') 
     = '   ****************************************************',
     + '  MR2IC - converting solutions to apply to original model'
      WRITE (6,FMT=6000)
C
       IF (AOBS*BOBS*COBS.EQ.0.0) THEN
C          ***************************************
           FILNAM = 'HKLPCK0'
           UDI = 0
           CALL CCPDPN(UDI,FILNAM,'OLD','U',LREC,IFAIL)
C          ***************************************
C
C     =================================
c      SUBROUTINE HKLCELLIN(UDI,DMINUDI)
C     =================================
C
C
C
C----  read Cell and symmetry from HKLPCK file:
C
      READ (UDI) A,B,C,ALPHA,BETA,GAMMA
      AOBS  = A
      BOBS  = B
      COBS  = C
      ALPOBS  = ALPHA
      BETOBS  = BETA
      GAMOBS  = GAMMA
C
C          *****
      CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
C          *****
C
      READ (UDI) NTS,NEQP,(((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
      IF(NTS.GT.0) READ(UDI) ((TTS(I,ITS),I=1,3),ITS=1,NTS)
C  Read packing constants to put into COMMON PACO
      READ (UDI) HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1,DMINUDI

C
C----  Reset symmetry if set on input.
C
      IF (NSYM.GT.1) THEN
        IF (NEQP*(NTS+1).NE.NSYM) THEN
          WRITE (6,FMT='(//,a)') ' Incompatible symmetry??'
          WRITE (6,FMT='(/,i3,A,I3,A)')NEQP, 
     +    ' symmetry operators listed with',NTS,' centring operators.'
C
C              ************************
          CALL CCPERR(1,' Fatal error')
C              ************************
C
        END IF
C
        NEQ = NSYM
        NEQP = NSYMP
C
        DO 30 ISYM = 1,NSYM
         IF(ISYM.LE.NSYMP) THEN
          DO 20 JDO30 = 1,3
           TSS(JDO30,ISYM) = RSYM(JDO30,4,ISYM)
            DO 10 JDO20 = 1,3
              MSS(JDO30,JDO20,ISYM) = NINT(RSYM(JDO30,JDO20,ISYM))
   10       CONTINUE
   20     CONTINUE
         END IF
         IF(ISYM.GT.NSYMP) THEN
          NTS = INT((ISYM-1)/NSYMP)
          DO J = 1,3
           tts(j,NTS) =   RSYM(j,4,ISYM) - RSYM(j,4,ISYM-NTS*NSYMP)
          END DO 
         END IF
   30   CONTINUE
C
      END IF
C
C          *****
      CALL ORTHO
C          *****
      WRITE (6,FMT='(A,6F9.3)') 
     + ' Observed Cell read from HKLPCK0:',
     + AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS
      WRITE (6,FMT='(A,I5,48(//,A,I4,/,3(/,3i4,F9.3) ))') 
     +  ' Symmetry - primitive operators:',neqp,
     + ('Symmetry:',N,((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
       IF(NTS.GT.0) THEN
          WRITE (6,FMT='(4(/A,I5,3F9.3) )')
     +  (' Centring operator:',N,(TTS(I,N),I=1,3),N=1,NTS)
       END IF
C          *****
      WRITE (6,FMT='(A,6F9.3)')
     + ' MRNDO: Observed Cell read from HKLPCK0:',
     + AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS
      WRITE (6,FMT='(A,I5,48(//,A,I4,/,3(/,3i4,F9.3) ))')
     +  ' Symmetry - primitive operators:',neqp,
     + ('Symmetry:',N,((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
       IF(NTS.GT.0) THEN
          WRITE (6,FMT='(4(/A,I5,3F9.3) )')
     +  (' Centring operator:',N,(TTS(I,N),I=1,3),N=1,NTS)
       END IF
C
c            CALL HKLCELLIN(UDI)
       END IF 
c       ***************
      WRITE (6,FMT='(A,6F9.3)') ' Observed Cell:',
     + AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS

      IF (ISHIFT(1).EQ.0.AND.ISHIFT(2).EQ.0.AND.
     +    ISHIFT(3).EQ.0.AND.ISHIFT(4).EQ.0)
     +     CALL CCPERR(1,'No Euler Angles to solve')
C
        DO IS = 1,4
        IF(ISHIFT(IS).NE.0)THEN
          CM(1)=CMASS(1,IS)/AOBS 
          CM(2)=CMASS(2,IS)/BOBS 
          CM(3)=CMASS(3,IS)/COBS 
          WRITE(6,11)IS,(CMASS(J,IS),J=1,3),CM,(EULER(J,IS),J=1,3)
        END IF
11    FORMAT(//,  '  MODEL:',I3,/,
     +'                         Center of Mass:',3F9.2,/,
     +'                   Center of Mass(frac):',3F9.4,/,
     +'                         Rotation      :',3F9.2)
        END DO
C
      IF (NCODE.NE.1) THEN
C
        DO  I = 1,3
          DO J = 1,3
            RFO(I,J) = RF(I,J)
          END DO
        END DO
C
        N = NCODE
        NCODE = 1
C            *****
        CALL ORTHO
C            *****
        NCODE = N
      END IF
C
      WRITE (6,FMT='(/A,/,A,I3,A,/,A)') 
     + '++++++++++++++++++++++++++++++++++++++++',
     + ' SOLUTION(S) WITH ',NMOLT, ' FRAGMENT(S):',
     + '++++++++++++++++++++++++++++++++++++++++'
C
      ICYCLE = 0
 141  CONTINUE
      IF (ICYCLE.GE.NSOL) GOTO 142
      IF (ITBT(ICYCLE+1).EQ.0) GOTO 142
C
      DO 140 IM = 1,NMOLT
C
          ITAB = ITBT(IM+ICYCLE)
          IF(ITAB.EQ.0) GO TO 142
          I0(ITAB) = I0(ITAB) + 1
C
              AL0 = EULER(1,ITAB)
              BE0 = EULER(2,ITAB)
              GA0 = EULER(3,ITAB)
C
              AL  = ALT(IM+ICYCLE)
              BE  = BET(IM+ICYCLE)
              GA  = GAT(IM+ICYCLE)
              TRA(1) = TXT(ICYCLE+IM)
              TRA(2) = TYT(ICYCLE+IM)
              TRA(3) = TZT(ICYCLE+IM)
              PF(7,IM) = CRT(IM+ICYCLE)
              PF(8,IM) = RFT(IM+ICYCLE)

C
C              **********************
          CALL RMXE(AL0,BE0,GA0,R0(1,ITAB),.FALSE.)
C              **********************
C
C            ***********************
        CALL RMXE(AL,BE,GA,R,.FALSE.)
        CALL PRO2MX(RX,R,R0(1,ITAB))
        CALL RMX2E(RX,AL,BE,GA,.FALSE.)
C            ***********************
C
        DO 70 I = 1,3
          TX(I) = 0.0
          DO 60 J = 1,3
            TX(I) = RO(I,J)*TRA(J) + TX(I)
   60     CONTINUE
   70   CONTINUE
C
        DO 90 I = 1,3
          DO 80 J = 1,3
            TX(I) = TX(I) - RX(I,J)*CMASS(J,ITAB)
   80     CONTINUE
   90   CONTINUE
C
        IF (NCODE.NE.1) THEN
C
          DO 110 I = 1,3
            V(I) = TX(I)
            DO 100 J = 1,3
              R(I,J) = RX(I,J)
  100       CONTINUE
  110     CONTINUE
C
C              *******************
          CALL PRO3MX(RX,RO,RFO,R)
          CALL RMX2E(RX,AL,BE,GA,.FALSE.)
          CALL PRO2MX(R,RO,RFO)
C              *******************
C
          DO 130 I = 1,3
            TX(I) = 0.0
            DO 120 J = 1,3
              TX(I) = R(I,J)*V(J) + TX(I)
  120       CONTINUE
  130     CONTINUE
C
        END IF
        TF(IM) = ITAB
C
C   For IROT set all Translation components back to 0.0
              IF(IROT.EQ.1) THEN
              TX(1) = 0
              TX(2) = 0
              TX(3) = 0
              END IF
C
        PF(1,IM) = AL
        PF(2,IM) = BE
        PF(3,IM) = GA
        PF(4,IM) = TX(1)
        PF(5,IM) = TX(2)
        PF(6,IM) = TX(3)
C
         IF(KPRT.NE.0)THEN
        WRITE (6,FMT='(/A15,3F9.5,A16,F9.2)') '               ',
     +    (RX(1,J),J=1,3),'                ',TX(1)
        WRITE (6,FMT='(A10,I2,A3,3F9.5,A11,I2,A3,F9.2)')
     +    ' XOUT(MOD=',ITAB,') =', (RX(2,J),J=1,3),' * XIN(MOD=',ITAB,
     +    ') +',TX(2)
        WRITE (6,FMT='(A15,3F9.5,A16,F9.2)') '               ',
     +    (RX(3,J),J=1,3),'                ',TX(3)
         END IF
  140 CONTINUE
C
        IF(KPRT.NE.0) WRITE(6,'(//)')
      DO 150 IM = 1,NMOLT
        WRITE (6,FMT='(A,I5,6F9.2,2F5.1)') 
     +    ' SOLUTION_SHIFT ',TF(IM),PF(1,IM),PF(2,IM),
     +    PF(3,IM),PF(4,IM),PF(5,IM),PF(6,IM),PF(7,IM),PF(8,IM)
  150 CONTINUE
C    Cycle over solutions until itbt() = 0 (No more solutions)
      ICYCLE = ICYCLE + NMOLT
      GOTO 141
  142 CONTINUE
C
 6000 FORMAT (/,
     +' Rotation and Translation to be applied ',/,
     +'   to the input coordinates',/,
     +'   to be used with NCODE = 1',/,
     +'    XOUT(MOD) = Rotation * XIN(MOD) + Translation')
C
      END
C
C
C     =============================
      SUBROUTINE MULTES(H,K,L,MULT,IRES)
C     ==================================
C
C     .. Scalar Arguments ..
      INTEGER H,IRES,K,L,MULT
C     ..
C     .. Scalars in Common ..
      INTEGER KPRT,NEQ,NEQP
C     ..
C     .. Arrays in Common ..
      REAL TSS
      INTEGER MSS
C     ..
C     .. Local Scalars ..
      REAL PR
      INTEGER HH,IIND,IND,INDO,KK,LL,M,N
      LOGICAL FIRST,PRIMO
C     ..
C     .. Local Arrays ..
      INTEGER HKL(48)
C     ..
C     .. External Subroutines ..
      EXTERNAL PAC3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD,NINT
C     ..
C     .. Common blocks ..
      COMMON /IOPRG/KPRT
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA FIRST/.TRUE./
C     ..
C
      IF (FIRST) THEN
C
C            ****************
        CALL PAC3(0,0,0,INDO)
C            ****************
C
        FIRST = .FALSE.
        PRIMO = .TRUE.
      END IF
C
      IF (H.LT.0) GO TO 110
C
C          ***************
      CALL PAC3(H,K,L,IND)
C          ***************
C
      IF (IND.EQ.INDO) THEN
        MULT = 1
        IRES = 1
        GO TO 100
      END IF
C
      MULT = 0
      IRES = 0
C
      DO 90 N = 1,NEQP
        HH = MSS(1,1,N)*H + MSS(2,1,N)*K + MSS(3,1,N)*L
        KK = MSS(1,2,N)*H + MSS(2,2,N)*K + MSS(3,2,N)*L
        LL = MSS(1,3,N)*H + MSS(2,3,N)*K + MSS(3,3,N)*L
C
        IF (HH.EQ.-H .AND. KK.EQ.-K .AND. LL.EQ.-L) THEN
          PR = MOD(TSS(1,N)*H+TSS(2,N)*K+TSS(3,N)*L,1.0)
          IRES = MOD(NINT(12*PR)+12,12) + 1
        END IF
C
        IF (HH) 30,10,60
   10   IF (LL) 60,20,40
   20   IF (KK) 60,60,50
   30   HH = -HH
   40   LL = -LL
   50   KK = -KK
C
C            *******************
   60   CALL PAC3(HH,KK,LL,IIND)
C            *******************
C
        IF (PRIMO .AND. IIND.LT.IND) THEN
          IF (KPRT.NE.0) WRITE (6,FMT=6000)
          PRIMO = .FALSE.
        END IF
C
        IF (N.EQ.1) GO TO 80
C
        DO 70 M = 1,MULT
          IF (HKL(M).EQ.IIND) GO TO 90
   70   CONTINUE
C
   80   MULT = MULT + 1
        HKL(MULT) = IIND
   90 CONTINUE
      MULT = MULT*2
  100 RETURN
C
C          ***************************************************
  110 CALL CCPERR(1,' > s/r multes < reflection out of order')
C          ***************************************************
C
 6000 FORMAT (' > WARNING < DATA IS NOT OPTIMALLY SORTED')
      END
C
C
C     =============================
      BLOCK DATA NUMERO
C     =================
C
C     .. Scalars in Common ..
      INTEGER IUVW, MXYZ
      CHARACTER FIT*3,ROT*3,TRA*3
C     ..
C     .. Common blocks ..
      COMMON /DATO/ROT,TRA,FIT
      COMMON /MAP/IUVW(3),MXYZ(3)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA ROT,TRA,FIT/'ROT','TRA','FIT'/
C   Alpha fast, beta slow
      data iuvw/1,3,2/
C     ..
C
      END
C
C
C     =============================
      SUBROUTINE ORTHO
C     ================
C
C     .. Scalars in Common ..
      REAL AD,AST,BD,BST,CA,CAST,CB,CBST,CD,CG,CGST,CST,SA,SAST,SB,SBST,
     +     SG,SGST,VOL
      INTEGER KPRT,NCODE
C     ..
C     .. Arrays in Common ..
      REAL RF,RO
C     ..
C     .. Local Scalars ..
      INTEGER I,J
C     ..
C     .. Common blocks ..
      COMMON /CELD/AD,BD,CD,CA,CB,CG,SA,SB,SG,AST,BST,CST,CAST,CBST,
     +       CGST,SAST,SBST,SGST,VOL
      COMMON /IOPRG/KPRT
      COMMON /ORTM/RO(3,3),RF(3,3),NCODE
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C  Choose a sensible NCODE ; 3 possible for Monoclinic B unique , all others 1
      if(neqp.eq.1 .or. neqp.ne.2) ncode=1

      IF(NCODE.LE.0 .OR. NCODE .GT.3) NCODE = 1
      IF (KPRT.NE.0) WRITE (6,FMT=6000) NCODE
C
      DO 20 J = 1,3
        DO 10 I = 1,3
          RO(I,J) = 0.0
          RF(I,J) = 0.0
   10   CONTINUE
   20 CONTINUE
C
      GO TO (30,40,50) NCODE
   30 RO(1,1) = AD
      RO(1,2) = BD*CG
      RO(1,3) = CD*CB
      RO(2,2) = BD*SG
      RO(2,3) = -CD*SB*CAST
      RO(3,3) = CD*SA*SBST
      RF(1,1) = AST*SBST*SG
      RF(1,2) = -AST*SBST*CG
      RF(1,3) = AST*CBST
      RF(2,2) = BST*SAST
      RF(2,3) = BST*CAST
      RF(3,3) = CST
      GO TO 60
   40 RO(1,2) = BD
      RO(1,3) = CD*CA
      RO(1,1) = AD*CG
      RO(2,3) = CD*SA
      RO(2,1) = -AD*SG*CBST
      RO(3,1) = AD*SB*SGST
      RF(2,1) = BST*SGST*SA
      RF(2,2) = -BST*SGST*CA
      RF(2,3) = BST*CGST
      RF(3,2) = CST*SBST
      RF(3,3) = CST*CBST
      RF(1,3) = AST
      GO TO 60
   50 RO(1,3) = CD
      RO(1,1) = AD*CB
      RO(1,2) = BD*CA
      RO(2,1) = AD*SB
      RO(2,2) = -BD*SA*CGST
      RO(3,2) = BD*SG*SAST
      RF(3,1) = CST*SAST*SB
      RF(3,2) = -CST*SAST*CB
      RF(3,3) = CST*CAST
      RF(1,2) = AST*SGST
      RF(1,3) = AST*CGST
      RF(2,3) = BST
   60 IF (KPRT.NE.0) WRITE (6,FMT=6002) ((RO(I,J),J=1,3),I=1,3),
     +    ((RF(I,J),J=1,3),I=1,3)
      RETURN
 6000 FORMAT (/' Transformation of Coordinates (Direct or Reciprocal)',
     +       /' NCODE=1, orthog axes have X along A, Z along Cstar',
     +       /' NCODE=2, orthog axes have X along B, Z along Astar',
     +       /' NCODE=3, orthog axes have X along C, Z along Bstar',
     +       /' HERE NCODE IS',I5)
 6002 FORMAT (' Orientation matrix for XYZ',/,
     +        3 (/3F10.3),//,
     +        ' Orientation Matrix for HKL',/,
     +        3 (/3F10.6))
      END
C
C
C     =====================================
c        CALL OUTTRA1(NPIC,II(IC3),RR(1+2*NRA+6*NPIC),RR(1+2*NRA),N1)
      SUBROUTINE OUTTRA1(NPIC,IO,PO,XYZ,N1)
C     =====================================
C
C     ..
C     .. Scalar Arguments ..
      INTEGER NPIC,N1
C     ..
C     .. Array Arguments ..
      REAL PO(NPIC),XYZ(7,NPIC)
      INTEGER IO(NPIC)
C     ..
C     .. Scalars in Common ..
      REAL AL,BE,GA,SCD,TX,TY,TZ
      INTEGER IACTUAL,ISOL
C     ..
C     .. Local Scalars ..
      INTEGER IX,NPK
C     ..
C     .. External Subroutines ..
      EXTERNAL SORT1
C     ..
C     .. Common blocks ..
      COMMON /OUTRA/AL,BE,GA,TX,TY,TZ,SCD,IACTUAL,ISOL
C     ..
C     .. Save statement ..
      SAVE
C     ..

c      NPK = 0
C
      DO 20 IX = 1,NPIC
c        IF( XYZ(4,IX) .LE. 0.0) GO TO 20
c        NPK = NPK + 1
        IO(IX) = IX
        PO(IX) = XYZ(4,IX)
   20 CONTINUE
C
       NPK = NPIC
C
C          **********************
      CALL SORT1(NPK,IO(1),PO(1))
C          **********************
C
      N1 = IO(NPK)
C
      RETURN
      END
C
C
C
C  Extended to output distance between centres of mass
c      call outtra(npic,rxo,mss,tss,tts,neqpp,nttss,
C     =============================
      SUBROUTINE OUTTRA(NPIC,rxo,mss,tss,tts,neqpp,nttss,IO,PO,XYZ)
C     ================================
C
C     ..
C     .. Arguments ..
      INTEGER NPIC
C     ..
C     .. Array Arguments ..
      REAL PO(NPIC),XYZ(7,NPIC)
      INTEGER IO(NPIC)
C     ..
C     .. Scalars in Common ..
      REAL AL,BE,GA,SCD,TX,TY,TZ
      INTEGER IACTUAL,ISOL
C     ..
C     .. Local Scalars ..
      REAL CR,RF,txs(3),distx(3),txyz(3),rxo(9),tss(3,48),tts(3,3)
      INTEGER I,IP,IX,J,K,N,NPK,mss(3,3,48)
      CHARACTER LABEL*12
C     ..
C     .. External Subroutines ..
      EXTERNAL SORT1
C     ..
C     .. Common blocks ..
      COMMON /OUTRA/AL,BE,GA,TX,TY,TZ,SCD,IACTUAL,ISOL
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C   Design output flag to include ISOL
      I = 0
       IF(ISOL.LT.10) then
        WRITE(LABEL,'(A7,I1,A2)')' SOLUT_',ISOL,' '
       else IF(ISOL.lt.100) then
        WRITE(LABEL,'(A7,I2,A1)')' SOLUT_',ISOL
       else
        WRITE(LABEL,'(A7,I3)')' SOLUT_',ISOL
       endif
C
      DO 20 IX = 1,NPIC
        IF(XYZ(4,IX).LE.0.0) GO TO 20
        I = I + 1
        IO(I) = I
        PO(I) = XYZ(4,IX)
        DO 10 J = 1,6
          XYZ(J,I) = XYZ(J,IX)
   10   CONTINUE
   20 CONTINUE
C

C
      NPK = I
C
C          **********************
      CALL SORT1(NPK,IO(1),PO(1))
C          **********************
C
      DO 30 IP = 1,NPK
        K = NPK - IP + 1
        N = IO(K)
        TX = XYZ(1,N)
        TY = XYZ(2,N)
        TZ = XYZ(3,N)
        txyz(1)=tx
        txyz(2)=ty
        txyz(3)=tz
        CRF = XYZ(4,N)
        RF = XYZ(5,N)
        CRI= XYZ(6,N)
C  Sort to get peak position in map too.
C  Check separation of centre of mass 
       dstmin = 10000000.0
       do nn = 2,neqpp
         do i = 1,3
          txs(i) = mss(i,1,nn)*tx + mss(i,2,nn)*ty + mss(i,3,nn)*tz 
     +           + TSS(I,nN)
c          distx(i) = tx -txs(i)  
          distx(i) = txyz(i) -txs(i)  
          shift = real( int( abs(distx(i)) + 0.5))
          distx(i) = distx(i) - sign(shift,distx(i)) 
         end do
c
         dist = 0.0
         do i = 1,3
          dorth = rxo(i)*distx(1) + rxo(i+3)*distx(2) 
     +          + rxo(i+6)*distx(3)
          dist = dist + dorth**2 
         end do
         if( abs(dist).lt.dstmin) dstmin = abs(dist)
C
C  Check non-primitives
        if(nttss.ne.0) then
         do nt = 1,nttss
          do i = 1,3
c          txs(i) = mss(i,1,n)*tx + mss(i,2,n)*ty + mss(i,3,n)*tz
c     +           + TSS(I,N) + tts(i,nt)
c          distx(i) = tx -txs(i)
          distx(i) = txyz(i) -txs(i)  -tts(i,nt)
          shift = real( int( abs(distx(i)) + 0.5))
          distx(i) = distx(i) - sign(shift,distx(i))
          end do
          dist = 0.0
          do i = 1,3
           dorth = rxo(i)*distx(1) + rxo(i+3)*distx(2)
     +          + rxo(i+6)*distx(3)
           dist = dist + dorth**2
          end do
        if( abs(dist).lt.dstmin) dstmin = abs(dist)
         end do 
        end if
       end do                                                                                         
        dist = sqrt(dstmin)
c
        WRITE (6,FMT='(A,I3,3F8.2,3F8.4,3F7.1,I4,2x,F7.1)') LABEL,
     +  IACTUAL,AL,BE,GA,TX,TY,TZ,CRF*100.0,RF*100.0,CRI*100,N,Dist
   30 CONTINUE
      RETURN
      END
C
C     =============================
      SUBROUTINE PAC3(IH,IK,IL,IND)
C     =============================
C
C     .. Scalar Arguments ..
      INTEGER IH,IK,IL,IND
C     ..
C     .. Scalars in Common ..
      INTEGER HM,KM,LM,NH,NK,NL,NM
C     ..
C     .. Common blocks ..
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
C     ..
      SAVE
C
      IND = ((IL+LM)*NK+IK+KM)*NH + IH + HM
      IF (IH+HM.LT.0 .OR. IH+HM.GE.NH .OR. IK+KM.LT.0 .OR.
     +    IK+KM.GE.NK .OR. IL+LM.LT.0 .OR. IL+LM.GE.NL) GO TO 10
      IF (IND.LT.0) GOTO 10
      RETURN
   10 WRITE (6,FMT=6000) IH,IK,IL,HM,KM,LM,NH,NK,NL,IND
C
C          **************************************************
      CALL CCPERR(1,' > s/r pac3 < maximal indices exceeded:')
C          **************************************************
C
 6000 FORMAT (' > S/R PAC3 < MAXIMAL INDICES EXCEEDED:',
     + / '   Indices are         :',3i5,
     + / '   Limits are(hm km lm):',3i5,
     + / '   Adding    (nh nk nl):',3I5,
     + /' Generated Packed number ( should be > 0..)',I20)
      END
C
C
C     =============================
      SUBROUTINE PAC4(IH,IK,IL,IM,IND)
C     ===============================
C
C     .. Scalar Arguments ..
      INTEGER IH,IK,IL,IM,IND
C     ..
C     .. Scalars in Common ..
      INTEGER HM,KM,LM,NH,NK,NL,NM
C     ..
C     .. Common blocks ..
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
C     ..
      SAVE
C
      IND = (((IL+LM)*NK+IK+KM)*NH+IH+HM)*NM + IM
      IF (IH+HM.LT.0 .OR. IH+HM.GE.NH .OR. IK+KM.LT.0 .OR.
     +    IK+KM.GE.NK .OR. IL+LM.LT.0 .OR. IL+LM.GE.NL .OR. IM.LT.0 .OR.
     +    IM.GE.NM) GO TO 10
      IF (IND.LT.0) GOTO 10
      RETURN
   10 WRITE (6,FMT=6000) IH,IK,IL,HM,KM,LM,NH,NK,Nl,IM,NM,IND
C
C          ***************************************************
      CALL CCPERR(1,' > s/r pac4 < maximal indices exceeded:')
C          ***************************************************
C
 6000 FORMAT (' > S/R PAC4 < MAXIMAL INDICES EXCEEDED:',
     + / '  Indices are:',3i4,'   Limits are:',3i4,' Adding:',3I4,
     + / ' Number of symmetry equivalent:',I4,' Limit is:',i3,
     + / ' Generated Packed number ( should be > 0..)',I20)
      END
C
C
C     =============================
      SUBROUTINE PAKG(IH,IK,IL,IND)
C     =============================
C
C     .. Scalar Arguments ..
      INTEGER IH,IK,IL,IND
C     ..
C     .. Scalars in Common ..
      INTEGER HLOW,KLOW,LLOW,NH,NK,NL
C     ..
C     .. Common blocks ..
      COMMON /PAKO/HLOW,KLOW,LLOW,NH,NK,NL
C     ..
      SAVE
C
      IND = ((IL-LLOW)*NK+IK-KLOW)*NH + 1 + IH - HLOW
      RETURN
      END
C
C
C
C     ======================================================
      SUBROUTINE PEAKPK(RI2,NANG,RMAP,nfast,nmed,PKPOS,NPEAK,
     +           PKHT,PKABG,IPK,opt)
C     ======================================================
C
C---- Find peaks in previous section
C
C rmap is used as a rotating buffer, rmap(,,I1), rmap(,,I2), rmap(,,I3),
C      contain 3 sections, I2 is the one to be searched
C
      INTEGER NSOL
      PARAMETER (MSR1R=6)
      PARAMETER (NSOL=499)
C---- For this routine, equivalence A/B/GSTEP == ABGSTP
C
C     ..
C     .. Scalar Arguments ..
      INTEGER nfast,NANG,nmed,NPEAK,opt
c    opt should equal 6 or 4 depending with called in TRAing or ROTing
C     ..
C     .. Array Arguments ..
      REAL RI2(NANG),RMAP(0:nfast+1,0:nmed+1,3),PKPOS(OPT,NPEAK),
     +  PKHT(NPEAK),PKABG(3,NPEAK)
      INTEGER IPK(NPEAK)
C     ..
C     .. Scalars in Common ..
      REAL ASTEP,BSTEP,BTMAX,BTMIN,GSTEP
      INTEGER IRSYGP,LSEC2,NALPHA,NBETA,NGAMMA
C     ..
C     .. Local Scalars ..
      REAL A,BCHCK,OFFMAX,PKTHRD,R,RHMAX,RHMEAN,RHMIN,RMAX,RMS,RPTS
      INTEGER I,I1,I2,I3,IA1,IA2,IB1,IEND,IER,IG1,IG2,IMAP,
     +        INDJ,IPEAK,ISTAT,J,K,L1,L2,L3,MODE,N,
     +        nfast1,nfast2,NB,nmed1,nmed2
      CHARACTER MAPTIT*80
C     ..
C     .. Local Arrays ..
      REAL ABGSTP(3),CELL(6),OFFSET(3),PEAKMX(-1:+1,-1:+1,-1:+1)
      INTEGER IUVW(3),NXYZ(3)
C     ..
C     .. External Functions ..
      LOGICAL CHKEQL
      EXTERNAL CHKEQL
C     ..
C     .. External Subroutines ..
      EXTERNAL EXSECT,MGULPR,MPOSN,MRDHDR,PKFITP,PKSETM
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,MAX
C     ..
C     .. Common blocks ..
      COMMON /TRAFIT/NCODT,DRMAXT,DRMINT,DMINTT,SHRTTR,NMOLT,
     +       RPTST,DELTAT,NPICT,ITBT(NSOL),ALT(NSOL),BET(NSOL),
     +       GAT(NSOL),TXT(NSOL),TYT(NSOL),TZT(NSOL),CRT(NSOL),
     +       RFT(NSOL),ITMAXF,EPSNF,ISF,IAF,IBF,IGF,IXF,IYF,IZF,SCDT
      COMMON /ROTFUN/IROTG(4),IROTC(5),IROTR,ISELF,DRMAXG(4),DRMING(4),
     +       CELLM(6,4),NCODC,DRMAXC,DRMINC,RMINC,RMAXC,LMINR,LSUPR,
     +       DANGR,BMAXR,NSR1R,NSR2R,RPTSR,DELTAR,NPICR,ANGNSR(3,MSR1R)
c     COMMON /PARAMS/L2RINT,LMAP,LPLOT,LRDMP,LRDAL,PEAK,MAXPEK,LSAVE,
c    +       LPKRMS,LREFMX(2)
      COMMON /RANGE/BTMIN,BTMAX,ASTEP,BSTEP,GSTEP,NALPHA,NBETA,NGAMMA,
     +       IRSYGP,LSEC1,LSEC2
      COMMON /IOPRG/KPRT
C     ..
C     .. Equivalences ..
      EQUIVALENCE (ASTEP,ABGSTP(1)), (BSTEP,ABGSTP(2)),
     +            (GSTEP,ABGSTP(3))
C     ..
C     .. Save statement ..
      SAVE 
C     ..
C     .. Data statements ..
C
C---- OFFMAX is maximum allowed offset from grid position
C
      DATA OFFMAX/0.6/
C
C---- search 3*3*3 box for peak
C
C  OPT = 4 ; ROTFUN; opt = 7 ; TRAFUN
      IF ( OPT.EQ.4) RPTS = RPTSR
      IF ( OPT.EQ.7) RPTS = RPTST
c      write(6,'(a,8i5,a)')
c     + ' in peakpk nang,nfast,nmed,npeak,opt',
c     +  nang,nfast,nmed,npeak,opt
C     ======================================================
c      SUBROUTINE PEAKPK(RI2,NANG,RMAP,nfast,nmed,PKPOS,NPEAK,
c     +           PKHT,PKABG,IPK,opt)
C     ======================================================

      N = 0
C
C---- set up paraboloid fit
C
      CALL PKSETM
C
      DO 10 I = 1,NPEAK
      IPK(I) = I
      PKPOS(4,I) = 0.00
   10 CONTINUE
C
      IEND = 1
      IMAP = 1
      MODE = 2
C
      WRITE (6,FMT=6000)
C
C---- reopen map to search for peaks
C
      CALL MRDHDR(IMAP,'MAPOUT',MAPTIT,NBETA,IUVW,NXYZ,IB1,IA1,IA2,IG1,
     +            IG2,CELL,IRSYGP,MODE,RHMIN,RHMAX,RHMEAN,RMS)
C
C---- set astep bstep gstep if you are just
C     reading map to search for peaks
C
C  cell(1 2 3 ) set = 360.
C  nxyz(1 2 3) = grid
C
      nfast1 = 1
      nfast2 = IA2 - IA1 + 1
      NALPHA = nfast2
      IF(NALPHA.NE.nfast) CALL CCPERR(1,'Map misalingment in PEAKPK') 
      nmed1 = 1
      nmed2 = IG2 - IG1 + 1
      NGAMMA = nmed2
      IF(NGAMMA.NE.nmed) CALL CCPERR(1,'Map misalingment in PEAKPK') 
      BTMIN = 0.0
      BTMAX = CELL(iuvw(3))
      LSEC1 = IB1
      LSEC2 = NBETA +IB1 -1
      IF (nfast2 .eq. 0) THEN
        ABGSTP(iuvw(1)) = 0.0
      ELSE
Cejd        ABGSTP(iuvw(1)) = CELL(iuvw(1))/nfast2
      ABGSTP(iuvw(1)) = CELL(iuvw(1))/nxyz(iuvw(1))
      ENDIF 
      IF (nmed2 .eq. 0) THEN
        ABGSTP(iuvw(2)) = 0.0
      ELSE
Cejd        ABGSTP(iuvw(2)) = CELL(iuvw(2))/nmed2
      ABGSTP(iuvw(2)) = CELL(iuvw(2))/nxyz(iuvw(2))
      ENDIF 
      IF (lsec2 .eq. 0) THEN
        ABGSTP(iuvw(3)) = 0.0
      ELSE
Cejd        ABGSTP(iuvw(3)) = CELL(iuvw(3))/lsec2
      ABGSTP(iuvw(3)) = CELL(iuvw(3))/nxyz(iuvw(3))
      ENDIF 
C
C---- Peak threshold
C             If the PEAKLIM keyword value is > 1 use PEAKLIM*RMS
C             else as a fraction of max peak
      IF(RPTS.GT.1.0) THEN
        PKTHRD = RMS*RPTS
      ELSE
        PKTHRD = RHMAX*RPTS
      ENDIF
        WRITE (6,FMT=6002) PKTHRD
C
C  OK to here..

C---- To handle edge effects, each section is extended by copying the
C     2nd & penultimate rows and columns to give a extra row & column
C     all round. This is equivalent to assuming each edge is a mirror
C     plane, which is unlikely to be true, however it will force all
C     edge peaks to lie on the edge plane. Similarly, sandwich the 1st
C     section, between 2 copies of the 2nd section, and the last section
C     between 2 copies of the penultimate
C
      IEND = 1
      IF ( LSEC2.EQ.LSEC1 ) IEND = -1
      I1 = 1
      I2 = 2
      I3 = 3
      CALL MPOSN(IMAP,LSEC1)
      CALL MGULPR(IMAP,RI2,IER)
       IF(IER.GT.0) CALL CCPERR(1, '  error in map input')
C  Alpha is the fast axis
        DO 30 J = nmed1,nmed2
          INDJ = (J-1)*nfast2
          DO 20 I = nfast1,nfast2
            RMAP(I,J,I2) = RI2(I+INDJ)
C   Fill all 3 search sections - this is helpful when there is only
C   one section.
            RMAP(I,J,I1) = -100.0
            RMAP(I,J,I3) = -100.0
   20     CONTINUE
   30   CONTINUE
C
C---- Extend section around edges
C
        CALL EXSECT(RMAP(0,0,I1),nfast,nmed)
        CALL EXSECT(RMAP(0,0,I2),nfast,nmed)
        CALL EXSECT(RMAP(0,0,I3),nfast,nmed)
C
        DO 220 NB = LSEC1 + 1,LSEC2 + 1
C
C---- read next section  - except for last section flagged by iend=-1
C
          IF (IEND.GT.0) THEN
            CALL MGULPR(IMAP,RI2,IER)
            IF(IER.GT.0) CALL CCPERR(1, '  error in map input')
C
             DO 50 J = nmed1,nmed2
               INDJ = (J-1)*nfast2
               DO 40 I = nfast1,nfast2
                 RMAP(I,J,I3) = RI2(I+INDJ)
   40           CONTINUE
   50         CONTINUE
C
C---- Extend section around edges
C
              CALL EXSECT(RMAP(0,0,I3),nfast,nmed)
          END IF
C
C---- Special for 2nd & penultimate sections
C
          IF (NB.EQ.LSEC1+1) THEN
C
C---- 2nd section, copy slot 3 to 1
C
            DO 70 J = nmed1 - 1,nmed2 + 1
              DO 60 I = nfast1 - 1,nfast2 + 1
                RMAP(I,J,I1) = RMAP(I,J,I3)
   60         CONTINUE
   70       CONTINUE
          ELSE IF (NB.EQ.LSEC2+1) THEN
C
C---- Last section, copy slot 1 to 3
C
            DO 90 J = nmed1 - 1,nmed2 + 1
              DO 80 I = nfast1 - 1,nfast2 + 1
C
C---- If only one section, fill with dummy values
C
                IF (LSEC1.EQ.LSEC2) RMAP(I,J,I1) = -100.0
                RMAP(I,J,I3) = RMAP(I,J,I1)
   80         CONTINUE
   90       CONTINUE
          END IF
C
C---- Now we have a section  in slot I2,
C     and maybe in slots I1 and I3 if slot
C     numbers are .gt. 0, so search section I2
C
C---- Search for peaks above threshold PKTHRD
C
          DO 210 I = nfast1,nfast2
            DO 200 J = nmed1,nmed2
              R = RMAP(I,J,I2)
C
C---- Is this point above PKTHRD?
C
              IF (R.LT.PKTHRD) GO TO 200
C
C---- Yes, are there any larger neighbours?
C     Build array PEAKMX(-1:+1,-1:+1,-1:+1) centred on RMAP(I,J,I2);
C      ie PEAKMX(0,0,0)=RMAP(I,J,I2)
C
                RMAX = -1000.0
                DO 120 L2 = -1,1
                  DO 110 L1 = -1,1
                    PEAKMX(L1,L2,-1) = RMAP(I+L1,J+L2,I1)
                    PEAKMX(L1,L2,0) = RMAP(I+L1,J+L2,I2)
                    PEAKMX(L1,L2,+1) = RMAP(I+L1,J+L2,I3)
                    DO 100 L3 = -1,1
                      RMAX = MAX(RMAX,PEAKMX(L1,L2,L3))
  100               CONTINUE
  110             CONTINUE
  120           CONTINUE
C
C---- Is central point the highest? If not junk out
C
                IF (RMAX.GT.R) GO TO 200
c     Monitor things:
C
C---- No neighbours higher, so we have a peak
C
                  N = N + 1
                  IPEAK = N
C
C---- We've already got enough peaks,
C     so find smallest if smaller than the new one
C
                  IF (N.GT.npeak) THEN
                    N = N - 1
                    A = R
                    DO 130 K = 1,NPEAK
                      IF (PKHT(K).LT.A) THEN
                        IPEAK = K
                        A = PKHT(K)
                      END IF
  130               CONTINUE
                    IF (IPEAK.GT.N) GO TO 200
                  END IF
C
C---- Append to list
C
C---- Store peak in slot ipeak
C
                  pkht(ipeak) = r
                  offset(1) =  0.0
                  offset(2) =  0.0
                  offset(3) =  0.0
C
C---- Interpolate point
C     Note that a peak on a degenerate ridge can cause PKFITP to
C     give a singular matrix (ISTAT = -1) but this doesn't matter,
C     since we just put the peak on the central grid point (OFFSET = 0)
C
                IF (LSEC1.NE.LSEC2) 
     +          CALL PKFITP(PEAKMX,OFFMAX,OFFSET,ISTAT)
C
C---- Store angles
C
C  Angles in RMAP are (a,g,b) 
                  PKABG(iuvw(1),IPEAK) = I - 1 + IA1 + OFFSET(1)
                  PKABG(iuvw(2),IPEAK) = J - 1 + IG1 + OFFSET(2)
                  PKABG(iuvw(3),IPEAK) = NB - 1 + OFFSET(3)
C
C---- Convert coordinates to angles (degrees)
C     multiply peak positions by angular step
C
                  PKABG(1,IPEAK) = PKABG(1,IPEAK)*ABGSTP(1)
                  PKABG(2,IPEAK) = PKABG(2,IPEAK)*ABGSTP(2)
                  PKABG(3,IPEAK) = PKABG(3,IPEAK)*ABGSTP(3)
C
C---- Skip beta checks if rotation peaks
            if (opt .eq. 4) THEN
C---- check section beta = 0
C
                  BCHCK = PKABG(2,IPEAK)
                  IF (ABS(BCHCK).LE.0.001) THEN
C
C---- set pkpos(1,..)= Alpha + gamma, pkpos(3,..)=0.
C
                    PKABG(1,IPEAK) = PKABG(1,IPEAK) + PKABG(3,IPEAK)
                    PKABG(3,IPEAK) = 0.0
                  END IF
C
C---- bangl ne 0
C
C---- check beta = 180.
C
                  IF (ABS(BCHCK-180.0).LT.0.001) THEN
C
C---- set pkpos(3,..)= Gamma - alpha, pkpos(1,..)=0.
C
                    PKABG(3,IPEAK) = PKABG(3,IPEAK) - PKABG(1,IPEAK)
                    PKABG(1,IPEAK) = 0.0
                  END IF
C
C---- bchck ne 0 or 180
C        opt = 4 endif
            end if 
C
C---- is this the same peak as we have already found?
                  IF (N.GT.1) THEN
C                    DO 140 K = 1,N - 1
                    DO 140 K = 1,N 
C---- has it equal angles within step limits NB ABGSTP === A/B/GSTEP
C
                      IF(K.EQ.IPEAK) GO TO 160
                      IF (CHKEQL(PKABG(1,K),PKABG(1,IPEAK),
     +                    ABGSTP)) GO TO 150
  140               CONTINUE
C
                    GO TO 160
  150               CONTINUE
C  Either replace PKHT(K) with this new one or discard it altogether.
C  Set PKHT negative so next peak will fill this slot
                    IF (PKHT(K).LT.PKHT(IPEAK)) THEN
                     DO 170 IDO170 = 1,3
                     PKABG(IDO170,K) = PKABG(IDO170,IPEAK)
  170                CONTINUE
                     PKHT(K) = PKHT(IPEAK)
                     PKHT(IPEAK) = -999
                    ELSE
                     PKHT(K) = -999
                    END IF
C  Reshuffle peaks to remove extra one.
                    IPEAK = 0
                    DO 145 K = 1,N 
                     IF(PKHT(K) .EQ. -999) GO TO 145
                     IPEAK = IPEAK + 1
                     PKABG(1,IPEAK) = PKABG(1,K)
                     PKABG(2,IPEAK) = PKABG(2,K)
                     PKABG(3,IPEAK) = PKABG(3,K)
                     PKHT(IPEAK) = PKHT(K)
  145               CONTINUE
                    N = N - 1
C
  160               CONTINUE
                  END IF 
C
  200       CONTINUE
C   I loop 
  210     CONTINUE
C   J loop 
C
C---- Set pointers for next section
C     we have passed the first section
C
          I1 = I2
          I2 = I3
          I3 = I2 + 1
          IF (I3.GT.3) I3 = 1
C
C---- don't reset i3 here - build array peakmx then reset bits = -1000
C     if this is the last section.
C
          IF (NB.EQ. LSEC2) IEND = -1
C       DO 220 NB = LSEC1 + 1,LSEC2 + 1
  220   CONTINUE

c
        CALL MRCLOS(IMAP)
        NPEAK = N
C
c--- Sort the array on peak heights and then store for return to pikndo
c
C            ****************
        CALL SORT1(NPEAK,IPK,PKHT)
C            ****************
C
        IF (KPRT.NE.0) THEN
         IF (opt .eq. 4) THEN
           WRITE (6,FMT=6004) NPEAK
         ELSE
           WRITE (6,FMT=6008) NPEAK
         END IF
        END IF
C
        DO 240 IP = 1,NPEAK
          K = NPEAK -IP +1
          N = IPK(K)
          PKPOS(1,IP) = PKABG(1,N)
          PKPOS(2,IP) = PKABG(2,N)
          PKPOS(3,IP) = PKABG(3,N)
C  Translation Map
                IF(OPT.EQ.7)THEN
                  PKPOS(1,IP) = PKPOS(1,IP)/CELL(1)
                  PKPOS(2,IP) = PKPOS(2,IP)/CELL(2)
                  PKPOS(3,IP) = PKPOS(3,IP)/CELL(3)
                END IF
          PKPOS(4,IP) = PKHT(K)
          IF (KPRT.NE.0) WRITE (6,FMT='(3F10.4,E15.5,I5)')
     +              (PKPOS(I,IP),I=1,4),IP
  240   CONTINUE
        WRITE(6,6006) (PKPOS(I,1),I=1,4)
        RETURN
C
C---- Format statements
C
 6000 FORMAT ('1',21X,'P E A K   S E A R C H',//)
 6002 FORMAT(//' Peaks must be greater than ',F8.2)
 6004 FORMAT (' The top',I4,' are selected for output',/' euler angle',
     +       's, height, order')
 6006 FORMAT(//' Best Solution:',4F10.3)
 6008 FORMAT (' The top',I4,' are selected for output',/' X,Y,Z tran',
     +       'slation,                  height, order')
C
      END
C

C
C     ================================================
      SUBROUTINE PHKL1(T2,NRA,PH,NK,NZ,HS,HKL,HKLO,WW,FO)
C     ================================================
C
C      INTEGER HKL(ND),HKLO(ND)
C     .. Scalar Arguments ..
      INTEGER HS,NK,NRA,NZ,PH
C     ..
C     .. Array Arguments ..
      COMPLEX FO(ND),WW(PH,NK,NZ)
      INTEGER HKL(ND),HKLO(ND)
C     ..
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,BID3,DB,FOOO,VOL,ZN
      INTEGER HM,HLW,HUP,KPRT,KREP,ND,NXYZ,T2,UFC,BID2,UMP
C     ..
C     .. Arrays in Common ..
      REAL BID1
      INTEGER IBID1
C     ..
C     .. Local Scalars ..
      COMPLEX F,UNO
      REAL SCALE,SQH
      INTEGER H,HF,HH,I,J,K,KK,L,LL,MULT,NTOT,hlww,hupp
C     ..
C     .. External Subroutines ..
      EXTERNAL UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC CONJG,EXP,REAL
C     ..
C     .. Common blocks ..
      COMMON /CELD/BID1(18),VOL
      COMMON /DFFTT/HLW,HUP,IBID1(5),NXYZ
      COMMON /FOZO/FOOO,ZN,DB,KREP,BID2,BID3,BTABCORRN
      COMMON /IOPRG/KPRT
      COMMON /STAR/A11,A21,A22,A31,A32,A33
      COMMON /TAPES/UMP,UFC,ND
      COMMON /PACO/HM,KM,LM,NH,NKK,NL,NM
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA UNO/ (1.0,0.0)/
C     ..
C
      SCALE = VOL/NXYZ
C
      IF (HS.EQ.HLW) THEN
         hlww = 0
         hupp = 0
         klww = 0
         kupp = 0
         llww = 0
         lupp = 0
        CALL PAC3(0,0,0,indo)
        IF(UFC.NE.0) REWIND (UFC)
        J = 0
        NTOT = 0
      END IF
C
      HF = HS + PH - 1
        IF(T2.NE.0) REWIND (T2)
C
   10 READ(T2,END=30) M,HKL
      DO 20 I = 1,M
c      DO 10 I = 1,NRA
C
C            *************************
        CALL UNPAC3(H,K,L,HKL(I))
C            *************************
         if (h.lt.hlww)hlww=h
         if (h.gt.hupp)hupp=h
         if (k.lt.klww)klww=k
         if (k.gt.kupp)kupp=k
         if (l.lt.llww)llww=l
         if (l.gt.lupp)lupp=l
C
        IF (H.LT.HS .OR. H.GT.HF) GO TO 20
        SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
        HH = H - HS + 1
        KK = K + 1
        IF (KK.LE.0) KK = KK + NK
        LL = L + 1
        IF (LL.LE.0) LL = LL + NZ
        F = CONJG(WW(HH,KK,LL))*SCALE*EXP(-DB*SQH/4.0)
        IF (HKL(I).EQ.INDO) F = REAL(F)*UNO
        J = J + 1
        HKLO(J) = HKL(I)
        FO(J) = F
C
        IF (J.EQ.ND) THEN
          WRITE (UFC) J,HKLO,FO
          NTOT = NTOT + J
          J = 0
        END IF
   20 CONTINUE
      GO TO 10
C
   30 CONTINUE
      IF (HF.EQ.HUP) THEN
        IF (J.NE.0) WRITE (UFC) J,HKLO,FO
        NTOT = NTOT + J
        IF (KPRT.NE.0) WRITE (6,FMT=6000) NTOT,DB
      END IF
C
      RETURN
 6000 FORMAT (/,
     +' PHKL1.',I10,' Coefficients written',/,
     +' FO = F*EXP(-DB*HSQ/4)*VOL. DB:',F10.3)
      END
C

C     ================================================
c      SUBROUTINE PHKL1(NRA,PH,NK,NZ,HS,HKL,HKLO,WW,FO)
cC     ================================================
cC
cC      INTEGER HKL(ND),HKLO(ND)
cC     .. Scalar Arguments ..
c      INTEGER HS,NK,NRA,NZ,PH
cC     ..
cC     .. Array Arguments ..
c      COMPLEX FO(ND),WW(PH,NK,NZ)
c      INTEGER HKL(NRA),HKLO(ND)
cC     ..
cC     .. Scalars in Common ..
c      REAL A11,A21,A22,A31,A32,A33,BID3,DB,FOOO,VOL,ZN
c      INTEGER HLW,HUP,KPRT,KREP,ND,NXYZ,UFC,BID2,UMP
cC     ..
cC     .. Arrays in Common ..
c      REAL BID1
c      INTEGER IBID1
cC     ..
cC     .. Local Scalars ..
c      COMPLEX F,UNO
c      REAL SCALE,SQH
c      INTEGER H,HF,HH,I,J,K,KK,L,LL,MULT,NTOT
ccC     ..
cC     .. External Subroutines ..
c      EXTERNAL UNPAC4
cC     ..
cC     .. Intrinsic Functions ..
c      INTRINSIC CONJG,EXP,REAL
cC     ..
cC     .. Common blocks ..
c      COMMON /CELD/BID1(18),VOL
cc      COMMON /DFFTT/HLW,HUP,IBID1(5),NXYZ
c      COMMON /FOZO/FOOO,ZN,DB,KREP,BID2,BID3,BTABCORRN
c      COMMON /IOPRG/KPRT
c      COMMON /STAR/A11,A21,A22,A31,A32,A33
c      COMMON /TAPES/UMP,UFC,ND
cC     ..
ccC     .. Save statement ..
c      SAVE
cC     ..
cC     .. Data statements ..
c      DATA UNO/ (1.0,0.0)/
cC     ..
cC
c      SCALE = VOL/NXYZ
ccC
c      IF (HS.EQ.HLW) THEN
c        REWIND (UFC)
c        J = 0
c        NTOT = 0
c      END IF
cC
c      HF = HS + PH - 1
ccC
c      DO 10 I = 1,NRA
cC
cC            *************************
c        CALL UNPAC4(H,K,L,MULT,HKL(I))
cC            *************************
ccC
c        IF (H.LT.HS .OR. H.GT.HF) GO TO 10
c        SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
c        HH = H - HS + 1
c        KK = K + 1
c        IF (KK.LE.0) KK = KK + NK
c        LL = L + 1
c        IF (LL.LE.0) LL = LL + NZ
c        F = CONJG(WW(HH,KK,LL))*SCALE*EXP(-DB*SQH/4.0)
c        IF (MULT.EQ.1) F = REAL(F)*UNO
c        J = J + 1
cc        HKLO(J) = HKL(I)
c        FO(J) = F
cC
c        IF (J.EQ.ND) THEN
c          WRITE (UFC) J,HKLO,FO
c          NTOT = NTOT + J
cc          J = 0
c        END IF
c   10 CONTINUE
cC
c      IF (HF.EQ.HUP) THEN
cc        IF (J.NE.0) WRITE (UFC) J,HKLO,FO
c        NTOT = NTOT + J
c        IF (KPRT.NE.0) WRITE (6,FMT=6000) NTOT,DB
c      END IF
cC
c      RETURN
c 6000 FORMAT (/,
c     +' PHKL1.',I10,' Coefficients written',/,
c     +' FO = F*EXP(-DB*HSQ/4)*VOL. DB:',F10.3)
c      END
C
C
C     ========================================
      SUBROUTINE PIKNDO(MI,MR,II,RR,OPTION)
C     ========================================
C
C     .. Scalar Arguments ..
      INTEGER MI,MR
      CHARACTER OPTION*4
C     ..
C     .. Array Arguments ..
      REAL RR(MR)
      INTEGER II(MI)
C     ..
C     .. Scalars in Common ..
      REAL DELTA,SEUIL
      INTEGER NPIC,KPRT
C     ..
C     .. Local Scalars ..
      integer iopt
      INTEGER MP,MS,NU,NV
      CHARACTER TRAMAP*4,ROTA*4
C     ..
C     .. External Subroutines ..
      EXTERNAL PEAKPK
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MIN
C     ..
C     .. Common blocks ..
      COMMON /IOPRG/KPRT
      COMMON /MAP/IUVW(3),MXYZ(3)
      COMMON /PIK/SEUIL,DELTA,NPIC
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA TRAMAP,ROTA/'TRAM','ROTA'/
C     ..
C
      IF (KPRT.NE.0) WRITE (6,FMT=6000)
C
      NU = MXYZ(IUVW(1))
      NV = MXYZ(IUVW(2))
C
      MS = (NU+2)* (NV+2)
      MP = MIN(MI, (MR-3*MS)/4)
      IF (MP.LE.0) GO TO 10
C
      IF (OPTION.EQ.TRAMAP) THEN
c        iopt = 5
        iopt = 7
      ELSE IF (OPTION.EQ.ROTA) THEN
        iopt = 4
      endif
      IF (iopt*NPIC.GT.3*MS) NPIC = 3*MS/iopt
C
        jump = iopt*npic+1
        nang = nu*nv
        iscratch = jump + nang + (nu+2)*(nv+2)*3
C
c         write(6,6002)iscratch +3*npic,mr 
        if (mr.lt.iscratch +3*npic) then
         write(6,6002)iscratch +3*npic,mr 
          call ccperr(1,
     +  ' Out of space in pikndo: reset ROTING_MR or TRAING_MR')
        end if
C
         mpic = npic
c  Call peakpk (pinched from ALMN)
c            returning the sorted peaks in rr(iopt,1->npic)
C     ======================================================
c      SUBROUTINE PEAKPK(RI2,NANG,RMAP,nfast,nmed,PKPOS,NPEAK,
c     +           PKHT,PKABG,IPK,opt)
C     ======================================================
C
c       ********************************************************
           call peakpk(rr(jump),nang,rr(jump+nang),nu,nv,rr(1),mpic,
     +         rr(iscratch),rr(iscratch +npic),ii(1),iopt)
c       ********************************************************
      npic = mpic
c     END IF
      RETURN
C
   10 WRITE (6,FMT=6002) 3*MS+1,MR
C
C          ************************************
          call ccperr(1,
     +  ' Out of space in pikndo: reset ROTING_MR or TRAING_MR')
C          ************************************
C
 6000 FORMAT (/' ****** S/R PIKNDO ******')
 6002 FORMAT 
     + (' > S/R PIKNDO   ROT/TRAING_MR(required)',I10,'  MR(set)',I10)
      END
C
C     ===============================================
      SUBROUTINE PKFITP(PEAKMX,OFFMAX,OFFSET,ISTAT)
C     =================================================
C
C---- Fit paraboloid to 3 x 3 x 3 grid in PEAKMX (central point
C     assumed to be maximum), return position of
C     maximum in OFFSET (grid units)
C
C Subroutine PKSETM must have been called first to calculate solution
C matrix SMAT
C
C On entry:
C  PEAKMX       values of peak  (3 x 3 x 3 grid)
C  OFFMAX       maximum value of offset
C
C On exit:
C  OFFSET(3)    offsets in grid units
C  ISTAT        = 1 if offset reset to maximum, else = 0
C               = -1 if failed to fit peak
C
C Solve for parameters P(1)->P(10), = a,b,c,d,e,f,g,h,i,j
C
C    p  = [ (AT A)**-1 AT ]  r
C where  (AT A)**-1 AT = SMAT is calculated in PKSETM
C        r = PEAKMX, observation vector
C
C  Note that in PKSETM,
C   the order of grid points corresponding to the rows
C   of matrix A must correspond to the order of values
C   in PEAKMX, ie x fast, y medium, z slow
C
C     .. Parameters ..
      INTEGER NP,NE,NG
      PARAMETER (NP=10,NE=3,NG=NE*NE*NE)
C     ..
C     .. Scalar Arguments ..
      REAL OFFMAX
      INTEGER ISTAT
C     ..
C     .. Array Arguments ..
      REAL OFFSET(3),PEAKMX(-1:+1,-1:+1,-1:+1)
C     ..
C     .. Arrays in Common ..
      REAL A,SMAT
C     ..
C     .. Local Scalars ..
      REAL DET
      INTEGER I
C     ..
C     .. Local Arrays ..
      REAL B(3,3),G(3),P(NP)
      INTEGER W1(3),W2(3)
C     ..
C     .. External Subroutines ..
      EXTERNAL GMPRD,MINVN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,SIGN
C     ..
C     .. Common blocks ..
      COMMON /PKFIT/SMAT(NP,NG),A(NG,NP)
C     ..
C     .. Save statement ..
      SAVE 
C     ..
C
      CALL GMPRD(SMAT,PEAKMX,P,NP,NG,1)
C
C Set up matrix B and vector g for solving position of maximum from the
C paraboloid parameters
C
C           (  2a   d   f  )                    (  -g  )
C     B  =  (   d  2b   e  )              g  =  (  -h  )
C           (   f   e  2c  )                    (  -i  )
C
C   Then position of maximum  OFFSET  =  x  =  B**-1 g
C
      B(1,1) = P(1)*2.0
      B(1,2) = P(4)
      B(2,1) = P(4)
      B(1,3) = P(6)
      B(3,1) = P(6)
      B(2,2) = P(2)*2.0
      B(2,3) = P(5)
      B(3,2) = P(5)
      B(3,3) = P(3)*2.0
C
      G(1) = -P(7)
      G(2) = -P(8)
      G(3) = -P(9)
C
C---- Invert B
C
      CALL MINVN(B,3,DET,W1,W2)
      IF (ABS(DET).LT.0.000001) THEN
        WRITE (6, '(/A/)') 'WARNING: PKFITP: singular matrix'
        ISTAT = -1
        RETURN
      ELSE
C
        CALL GMPRD(B,G,OFFSET,3,3,1)
C
        ISTAT = 0
        DO 10 I = 1,3
          IF (ABS(OFFSET(I)).GT.OFFMAX) THEN
C
C---- Reset to maximum, set flag
C
            ISTAT = 1
            OFFSET(I) = SIGN(OFFMAX,OFFSET(I))
          END IF
   10   CONTINUE
C
      END IF
      END
CC
C
C     =============================
      SUBROUTINE PKSETM
C     =================
C
C---- Set up normal matrix etc for 3D paraboloid fit
C
C Observational equation is
C  r(calc) = a x**2 + b y**2 + c z**2 + d xy + e yz + f zx +
C            g x + h y + i z + j
C
C Observation vector
C  xT = ( x**2  y**2  z**2  xy  yz  zx   x   y   z   1 )
C
C Observation matrix
C
C  A  =  (  x(1)T  )          for each point on 3 x 3 x 3 grid
C        (  x(2)T  )
C        ( . . . . )
C        (  x(n)T  )
C
C---- Loop points on 3 x 3 x 3 grid
C
C     .. Parameters ..
      INTEGER NP,NE,NG
      PARAMETER (NP=10,NE=3,NG=NE*NE*NE)
C     ..
C     .. Arrays in Common ..
      REAL A,SMAT
C     ..
C     .. Local Scalars ..
      REAL DET,X,Y,Z
      INTEGER I,IX,IY,IZ,J
C     ..
C     .. Local Arrays ..
      REAL AT(NP,NG),ATA(NP,NP)
      INTEGER W1(NP),W2(NP)
C     ..
C     .. External Subroutines ..
      EXTERNAL GMPRD,MINVN
C     ..
C     .. Common blocks ..
      COMMON /PKFIT/SMAT(NP,NG),A(NG,NP)
C     ..
C     .. Save statement ..
      SAVE 
C     ..
C
      I = 0
      DO 30 IZ = -1,+1
        Z = IZ
        DO 20 IY = -1,+1
          Y = IY
          DO 10 IX = -1,+1
            X = IX
            I = I + 1
C
C---- Matrix elements
C
            A(I,1) = X**2
            A(I,2) = Y**2
            A(I,3) = Z**2
            A(I,4) = X*Y
            A(I,5) = Y*Z
            A(I,6) = Z*X
            A(I,7) = X
            A(I,8) = Y
            A(I,9) = Z
            A(I,10) = 1.0
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
C---- Form A(transpose)
C
      DO 50 I = 1,NG
        DO 40 J = 1,NP
          AT(J,I) = A(I,J)
   40   CONTINUE
   50 CONTINUE
C
C---- A(transpose) * A
C
      CALL GMPRD(AT,A,ATA,NP,NG,NP)
C
C---- Invert in place
C
      CALL MINVN(ATA,NP,DET,W1,W2)
      IF (ABS(DET).LT.0.0000001)
     +     CALL CCPERR(1, 'PKSETM: singular matrix')
        CALL GMPRD(ATA,AT,SMAT,NP,NP,NG)
      END
C
C
C     =============================
      SUBROUTINE PRO2MX(RO,R2,R1)
C     ===========================
C
C     .. Array Arguments ..
      REAL R1(3,3),R2(3,3),RO(3,3)
C     ..
C     .. Local Scalars ..
      INTEGER I,J,K
C     ..
C
      DO 30 I = 1,3
        DO 20 J = 1,3
          RO(I,J) = 0.0
          DO 10 K = 1,3
            RO(I,J) = R2(I,K)*R1(K,J) + RO(I,J)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE PRO3MX(RO,R3,R2,R1)
C     ==============================
C
C     .. Array Arguments ..
      REAL R1(3,3),R2(3,3),R3(3,3),RO(3,3)
C     ..
C     .. Local Scalars ..
      INTEGER I,J,K,L
C     ..
C
      DO 40 I = 1,3
        DO 30 J = 1,3
          RO(I,J) = 0.0
          DO 20 K = 1,3
            DO 10 L = 1,3
              RO(I,J) = R3(I,K)*R2(K,L)*R1(L,J) + RO(I,J)
   10       CONTINUE
   20     CONTINUE
   30   CONTINUE
   40 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      REAL FUNCTION PYTHAG(A,B)
C     =========================
C
C     .. Scalar Arguments ..
      REAL A,B
C     ..
C     .. Local Scalars ..
      REAL P,R,S,T,U
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,MAX,MIN
C     ..
C
      P = MAX(ABS(A),ABS(B))
      IF (P.EQ.0.0) GO TO 20
      R = (MIN(ABS(A),ABS(B))/P)**2
   10 CONTINUE
      T = 4.0 + R
      IF (T.EQ.4.0) GO TO 20
      S = R/T
      U = 2.0*S + 1.0
      P = U*P
      R = (S/U)**2*R
      GO TO 10
C
C     **********
   20 PYTHAG = P
C     **********
C
      RETURN
      END
C
C
C     ==============================
      SUBROUTINE PZ1(NX,NY,PZ,ZS,RR)
C     ==============================
C
C     .. Scalar Arguments ..
      INTEGER NX,NY,PZ,ZS
      CHARACTER MAPNAM*10
C     ..
C     .. Array Arguments ..
      REAL RR(NX*NY,PZ)
C     ..
C     .. Scalars in Common ..
      REAL BID1,SEUIL,AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS
      INTEGER KPRT,NPIC,NZ,NCDOBS
C     ..
C     .. Arrays in Common ..
       REAL  RFOBS
      INTEGER IBID1,IMAP,MXYZ
C     ..
C     .. Local Scalars ..
C      REAL AMAX,AMIN,AVGE,MAP,MAX,MIN
      DOUBLE PRECISION AMAX,AMIN,AVGE,MAP,MAX,MIN
      INTEGER IJ,K
      CHARACTER*80 TITLE
      DOUBLE PRECISION RHMIN,RHMAX,RHMEAN,RHRMS
      REAL CELL(6)
C     ..
C     .. Common blocks ..
      COMMON /CELOBS/AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS(3,3),NCDOBS
      COMMON /GRID/IBID1(5),NZ
      COMMON /IOPRG/KPRT
      COMMON /PIK/SEUIL,BID1,NPIC
      COMMON /MAPNM/MAPNAM
      COMMON /MAP/IUVW(3),MXYZ(3)
C     ..
C     .. Save statement ..
      SAVE
C     ..
      DATA imap/1/
C
      IF (ZS.EQ.0) THEN
        title = 'Map of the Translation function from amore'
        rhmean=  0
        rhrms =  0

        mxyz(1) = nx
        mxyz(2) = ny
        mxyz(3) = nz
        iuvw(1) = 1
        iuvw(2) = 2
        iuvw(3) = 3

Cejd        cell(1) = 1.0
Cejd        cell(2) = 1.0
Cejd        cell(3) = 1.0
Cejd        cell(4) = alpha
Cejd        cell(5) = beta
Cejd        cell(6) = gamma

        cell(1) = AOBS
        cell(2) = BOBS
        cell(3) = COBS
        cell(4) = alpobs
        cell(5) = betobs
        cell(6) = gamobs

c       REWIND (UFC)
c       WRITE (UFC) NX,NY,NZ,A,B,C,ALPHA,BETA,GAMMA

       call MWRHDL(imap,MAPNAM,TITLE,nz,IUVW,MXYZ,0,0,
     +              nx-1,0,ny-1,CELL,1,2)

        IF (KPRT.NE.0) WRITE (6,FMT=6000)
        rhmin = 1.0E20
        rhmax = -1.0E20
        AMIN = 0.0
        AMAX = 0.0
      END IF
C
      DO 20 K = 1,PZ
        MIN = 10E20
        MAX = -1.0E20
        AVGE = 0.0
C
        DO 10 IJ = 1,NX*NY
          MAP = RR(IJ,K)
          IF (MAP.LT.MIN) MIN = MAP
          IF (MAP.GT.MAX) MAX = MAP
          AVGE = AVGE + MAP
          rhrms = rhrms + map*map
   10   CONTINUE
C
        rhmean = rhmean + avge
        AVGE = AVGE/ (NX*NY)
        IF (KPRT.NE.0) WRITE (6,FMT='(I10,3E15.5)') ZS + K - 1,MIN,
     +      MAX,AVGE
        IF (MIN.LT.rhmin) rhmin = MIN
        IF (MAX.GT.rhmax) rhmax = MAX
        AMIN = AMIN + MIN
        AMAX = AMAX + MAX
c       WRITE (UFC) (RR(IJ,K),IJ=1,NX*NY)
C     Write section to map
        call mwrsec(imap,rr(1,k),nx,ny,1,nx,1,ny)
   20 CONTINUE
C
      IF (ZS+PZ.LT.NZ) RETURN
      AMIN = AMIN/NZ
      AMAX = AMAX/NZ
      IF (KPRT.NE.0) WRITE (6,FMT=6002) rhmin,rhmax,AMIN,AMAX
      SEUIL = rhmax
c      call mclose(imap,rhmin,rhmax,rhmean,rhrms)
      call mwclose(imap)
      RETURN
 6000 FORMAT (/,
     +'   Z-Sect.        Minimum        Maximum     Avg. Value')
 6002 FORMAT (/,
     +' Absolute Min and Max:',2E15.5,/,
     +' Average  Min and Max:', 2E15.5)
      END
C     =============================
      SUBROUTINE PZC(T3,NX,NY,NZ,ZS,RR)
C     =================================
C
C     .. Scalar Arguments ..
      INTEGER NX,NY,NZ,T3,ZS
C     ..
C     .. Array Arguments ..
      REAL RR(NX,NY)
C     ..
C     .. Scalars in Common ..
      REAL A,ALPHA,AMAX,AMIN,B,BETA,C,GAMMA,SMAX,SMIN
      INTEGER KPRT,XLW,XUP,YLW,YUP,ZLW,ZUP
C     ..
C     .. Arrays in Common ..
      REAL BID1
      INTEGER KPRTT
C     ..
C     .. Local Scalars ..
      REAL AVGE,MAP,MAX,MIN
      INTEGER I,J
C     ..
C     .. Common blocks ..
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /DFFTTX/BID1(6),XLW,YLW,ZLW,XUP,YUP,ZUP
      COMMON /IOPRG/KPRT
      COMMON /MRHO/SMIN,SMAX,AMIN,AMAX
      COMMON /OPRT/KPRTT(20)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF (ZS.EQ.0) THEN
        IF(T3.NE.0) REWIND (T3)
        WRITE (T3) NX,NY,NZ,A,B,C,ALPHA,BETA,GAMMA
        IF (KPRT.NE.0) WRITE (6,FMT=6000)
        SMIN = 1.0E10
        SMAX = -1.0E10
        AMIN = 0.0
        AMAX = 0.0
      END IF
C
      IF (ZS.LT.ZLW .OR. ZS.GT.ZUP) GO TO 30
      KPRT = KPRTT(1)
      MIN  = 1.0E10
      MAX  = -1.0E10
      AVGE = 0.0
C
      DO 20 J = YLW + 1,YUP + 1
        DO 10 I = XLW + 1,XUP + 1
          MAP = RR(I,J)
          IF (MAP.LT.MIN) MIN = MAP
          IF (MAP.GT.MAX) MAX = MAP
          AVGE = AVGE + MAP
   10   CONTINUE
   20 CONTINUE
C
      AVGE = AVGE/ (NX*NY)
      IF (KPRT.NE.0) WRITE (6,FMT='(I10,3E15.5)') ZS,MIN,MAX,AVGE
      IF (MIN.LT.SMIN) SMIN = MIN
      IF (MAX.GT.SMAX) SMAX = MAX
      AMIN = AMIN + MIN
      AMAX = AMAX + MAX
      WRITE (T3) ((RR(I,J),I=XLW+1,XUP+1),J=YLW+1,YUP+1)
      KPRT = KPRTT(2)
C
      IF (ZS.EQ.ZUP) THEN
        AMIN = AMIN/NZ
        AMAX = AMAX/NZ
        IF (KPRT.NE.0) WRITE (6,FMT=6002) SMIN,SMAX,AMIN,AMAX
      END IF
C
   30 RETURN
 6000 FORMAT (/'   Z-SECT.        MINIMUM        MAXIMUM     AVG. VALUE'
     +       )
 6002 FORMAT (/' ABSOLUTE MIN AND MAX:',2E15.5,/' AVERAGE MIN AND MAX:',
     +       2E15.5)
      END
C
C
C     =============================
      SUBROUTINE QMAX(NL,NMAX,XMAX)
C     =============================
C
C     .. Scalar Arguments ..
      REAL XMAX
      INTEGER NL
C     ..
C     .. Array Arguments ..
      INTEGER NMAX(NL)
C     ..
C     .. Local Scalars ..
      INTEGER L,MQ
C     ..
C     .. External Subroutines ..
      EXTERNAL QTERM
C     ..
C
      DO 10 L = 1,NL
        NMAX(L) = 0
   10 CONTINUE
C
      DO 20 L = 2,NL,2
C
C            ****************
        CALL QTERM(L,XMAX,MQ)
C            ****************
C
        NMAX(L) = MQ
   20 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE QTERM(L,XMAX,MQ)
C     ===========================
C
C     .. Scalar Arguments ..
      REAL XMAX
      INTEGER L,MQ
C     ..
C     .. Local Scalars ..
      REAL AA,BB,C11,C12,C21,C22,C23
C     ..
C     .. Data statements ..
      DATA C11,C12,C21,C22,C23/0.00193,0.53943,-0.00245,-0.40296,
     +     6.26018/
C     ..
C
      AA = C11*L + C12
      BB = L**2*C21 + C22*L + C23
      MQ = NINT(AA*XMAX + BB)
      RETURN
      END
C
C
C     =============================
      SUBROUTINE QUADRO(IS,IJ,NRA,NP,HKL,FOB,HSQ,FCD,GRAD,QUAD,FUNC)
C     ==============================================================
C
C     .. Scalar Arguments ..
      REAL FUNC
      INTEGER IJ,IS,NP,NRA
C     ..
C     .. Array Arguments ..
      REAL FCD(NRA,0:NP),FOB(NRA),GRAD(NP),HSQ(NRA),QUAD(NP,NP)
      INTEGER HKL(NRA)
C     ..
C     .. Scalars in Common ..
      REAL BFACT,CORF,CORI,CORP,RFLI,RFSQ,SCALE,SFLI,SFSQ
C     ..
C     .. Local Scalars ..
      REAL DF,SEX
      INTEGER H,I,J,K,L,MULT,N
C     ..
C     .. External Subroutines ..
      EXTERNAL UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC EXP
C     ..
C     .. Common blocks ..
      COMMON /POTE/SFLI,SFSQ,SFQU,RFLI,RFSQ,CORF,CORI,CORP,SCALE,BFACT
C     ..
      SAVE
C
      DO 20 I = 1,NP
        GRAD(I) = 0.0
        DO 10 J = 1,NP
          QUAD(I,J) = 0.0
   10   CONTINUE
   20 CONTINUE
C
      FUNC = 0.0
      SEX  = SCALE
C
      DO 50 N = 1,NRA
C
C            *************************
        CALL UNPAC4(H,K,L,MULT,HKL(N))
C            *************************
C
        IF (IS.NE.0) SEX = SCALE*EXP(-BFACT*HSQ(N))
        DF = FCD(N,0) - FOB(N)*SEX
        FUNC = MULT*DF*DF + FUNC
        DO 40 I = 1,NP
          GRAD(I) = MULT*DF*FCD(N,I) + GRAD(I)
          DO 30 J = I,NP
            QUAD(I,J) = FCD(N,I)*MULT*FCD(N,J) + QUAD(I,J)
   30     CONTINUE
   40   CONTINUE
   50 CONTINUE
C
      FUNC = FUNC/ (2*SFSQ)
C
      DO 70 I = 1,NP
        GRAD(I) = GRAD(I)/SFSQ
        DO 60 J = I,NP
          QUAD(I,J) = QUAD(I,J)/SFSQ
          QUAD(J,I) = QUAD(I,J)
   60   CONTINUE
   70 CONTINUE
C
      IF (IJ.NE.0) THEN
        DO 80 I = 1,NP
          IF (I.EQ.IJ) GO TO 80
          QUAD(I,IJ) = 0.0
          QUAD(IJ,I) = 0.0
   80   CONTINUE
      END IF
C
      RETURN
      END

C
C     =================
      SUBROUTINE RCARDS
C     =================
C
C---- Read in the control data
C
C     .. Parameters ..
      INTEGER NCOL,MaxSets
      PARAMETER (NCOL=200,MaxSets=50)
      INTEGER NPARM
      PARAMETER (NPARM=200)
      INTEGER NSOL
      PARAMETER (NSOL=499)
      INTEGER NFIX
      PARAMETER (NFIX=64,MSR1R=6)
C     ..
C     .. Scalars in Common ..
      REAL DANGR,BMAXR,DELTAR,DELTAT,DMINTT,DRMAXC,DRMAXS,DRMAXT,DRMINC,
     +     DRMINS,DRMINT,EPSNF,RMAXC,RMINC,RPTSR,RPTST,SHRTTR,SMIN,SMAX
      INTEGER HM,KM,LM,NH,NK,NL,NM,UDI,
     +        IAF,IBF,IFIT,IGF,IMR,IROT,IROTR,ISELF,ISF,ISORT,ITAB,
     +        ITMAXF,ITRA,IVERB,IXF,IYF,IZF,LMINR,LSUPR,
     +        NCODC,NCODT,NMOLT,NPICR,NPICT,NSR1R,NSR2R,NSYM,
     +                IHMINS,IHMAXS,IKMINS,IKMAXS,ILMINS,ILMAXS,NCDOBS
      REAL AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS
      CHARACTER TITLE*72
      LOGICAL HAVSIG,HAVPHI,HAVFOM
C     ..
C     .. Arrays in Common ..
      REAL ALT,BET,BOXSCT,BTISOT,CELLM,CELLS,DRMAXG,DRMING,DRMNT,FMAXC,
     +     FMINC,GAT,RSYM,SHARTT,TFACC,TXT,TYT,TZT,CRT,RFT,EULER,CMASS
      INTEGER IROTC,IROTG,ITABB,ITABS,ITABT,ITBT,KPRTT,ISHIFT
C     ..
C     .. Local Scalars ..
      REAL AL,BE,BOXSC,BTISO,DB,DRMAX,DRMIN,
     +   FMAX,FMIN,GA,RMAX,RMIN,SHARAT,SMIN1,SMAX1,TX,TY,TZ,VOL,VOLSPH,
     +   q,biso,anisou(6),AX,BX,CX,ALX,BETX,GAMX,DMX,TXncs,TYncs,TZncs
      INTEGER I,ICEND,IERR,II,IMODEL,IPRINT,IRTC,ISOL,ISYM,ITB,ITOK,J,
     +        JDO20,JDO30,JJ,JUNK,LP,NLPRGI,IFIX,
     +        NMODEL,NSPGRP,NSYMP,NSYMS,NTOK,NTOKS,ISHTML,ISHIF,
     +        ixyzin, iser,ires,iz,HX,KX,LX,NXX,NYX,NZX,NMX,NRX,NCOLS
      LOGICAL LEND
      CHARACTER LTYPE*1,KEY*4,NAMSGP*10,PGNAME*10,LINE*600,TRATYP*3,
     +          FILNAM*10,
     +          atnam*4,restyp*4,idch*1,resno*4,insert*1,
     +          segid*4, atmtyp*8, altcod*1
c      call    xyzatom(ixyzin, iser, atnam, restyp, idch, ires,
c     *   resno, insert, altcod, segid, iz, atmtyp)
c      call   xyzcoord(ixyzin, 'O', 'O', x, y, z, q, biso, anisou)
C     ..
C     .. Local Arrays ..
      REAL FVALUE(NPARM),RSYMS(4,4,96),ALF(NFIX),BEF(NFIX),GAF(NFIX),
     +     TXF(NFIX),TYF(NFIX),TZF(NFIX),CRF(NFIX),RFF(NFIX),RR(3,3,6),
     +     RANGES(2,NCOL),CELLSAS(6),RMX(7),MSX(3,3,48),TSX(3,48),
     +     TTX(3,3),ANGNSRP(3,MSR1R)
      INTEGER IBEG(NPARM),IDEC(NPARM),IEND(NPARM),ITYP(NPARM),
C    +        ITBF(NFIX),LOOKUP(NCOL),TABF(2), MITAB,MRTAB,MCTAB,
     +        ITBF(NFIX),LOOKUP(NCOL),TABF(2), MITAB, MCTAB,
     +        HMaprox,kMaprox,LMaprox,LANGTYP
      CHARACTER CTPRGI(NCOL)*1,CVALUE(NPARM)*4, LSPRGI(NCOL)*30
C
      CHARACTER PNAME(MaxSets)*64,XNAME(MaxSets)*64,DNAME(MaxSets)*64
      CHARACTER CTYPS(NCOL)*1,CLABS(NCOL)*30
      REAL DATCELL(6,MaxSets),DATWAVE(MaxSets)
      INTEGER ISETS(MaxSets),CSETID(NCOL),SETID,SET_INDEX
C
      CHARACTER VERSNX*10
C     .. Local Arrays ..
      REAL ADATA(200)
      LOGICAL LOGMSS(200),EOF,LPRINT
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR,CCPUPC,GTPINT,GTPREA,LKYIN,LRASSN,LRCELL,LROPEN,
     +         LRSYMI,LRSYMM,PARSER,RDSYMM
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MIN
C     ..
C     .. Common blocks ..
      COMMON /ALLFNC/TITLE
      COMMON /ALLFUN/IVERB,ITABB(5),FMINC(5),FMAXC(5),TFACC(5),NSYM,
     +       NSYMP,RSYM(4,4,96)
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /CELOBS/AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS(3,3),NCDOBS
      COMMON /CNTRL/ISORT,ITAB,IROT,ITRA,IFIT,IMR,JSFO
      COMMON /INTAB/ISHIFT(4),CMASS(3,4),EULER(3,4)
      COMMON /NCSTRA/Nncs,TXncs(10),TYncs(10),TZncs(10)
      COMMON /OPRT/KPRTT(20)
      COMMON /ORTM/RO(3,3),RF(3,3),NCODE
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
      COMMON /ROTFUN/IROTG(4),IROTC(5),IROTR,ISELF,DRMAXG(4),DRMING(4),
     +       CELLM(6,4),NCODC,DRMAXC,DRMINC,RMINC,RMAXC,LMINR,LSUPR,
     +       DANGR,BMAXR,NSR1R,NSR2R,RPTSR,DELTAR,NPICR,ANGNSR(3,MSR1R)
      COMMON /SORTFUN/CELLS(6),DRMAXS,DRMINS,SMIN,SMAX,
     +  IHMINS,IHMAXS,IKMINS,IKMAXS,ILMINS,ILMAXS,HAVSIG,HAVPHI,HAVFOM

      COMMON /TABLFUN/ITABS(4),ITABT(4),BOXSCT(4),BTISOT(4),DRMNT(4),
     +       SHARTT(4),BTABCORR(4)
      COMMON /TRAFITC/TRATYP
      COMMON /TRAFIT/NCODT,DRMAXT,DRMINT,DMINTT,SHRTTR,NMOLT,
     +       RPTST,DELTAT,NPICT,ITBT(NSOL),ALT(NSOL),BET(NSOL),
     +       GAT(NSOL),TXT(NSOL),TYT(NSOL),TZT(NSOL),CRT(NSOL),
     +       RFT(NSOL),ITMAXF,EPSNF,ISF,IAF,IBF,IGF,IXF,IYF,IZF,SCDT
C  NRC NEQPC - no of reflns and no of primitive sym ops for crystal
C  MITAB MCTAB needed for tabling
C  MCTAB set = 100000
C  NRH1  no of reflns for HKLPCK1 
C  MHKLTAB - the big array from the table: (2*KMAX+1)* (IHMAX+2)* (2*LMAX+1)
      COMMON /SETSIZE/ NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB 
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
C
C  Keywords to describe options
C    SORTFUN  
C    TABFUN (SHIFT  TABULATE REBUILD ) 
C    ROTFUN ( GENERATE CLMN ROTATE)
C    TRAFUN ( C_B P_T)  FITFUN
C
C  File assignments.
C    HKLIN HKLPCK HKLOUT1
C    XYZIN1 XYZOUT1 TABLE1  HKLPCK1 CLMN1
C    XYZIN2 XYZOUT2 TABLE2  HKLPCK2 CLMN2
C    ROTOUT TRAOUT FITOUT
C      channel nos replaced by file assignment.
C
C---- NLPRGI  =  number of input labels
C
C---- This code signs which input columns are essential (LOOKUP)
      DATA NLPRGI, (LSPRGI(JJ),JJ=1,200)/11,'H','K','L','FP','SIGFP',
     +     'FC','PHIC','A','B','PHI','W',189*' '/
      DATA CTPRGI/'H','H','H','F','Q','F','P','A','B','P','W',189*' '/
      DATA LOOKUP/-1,-1,-1,197*0/
      DATA LP/6/
C     ..
C
C---- Set defaults
C
      TITLE = ' '
      ISORT = 0
      ITAB = 0
      IROT = 0
      ITRA = 0
      IFIT = 0
      JSFO = 0
      AOBS = 0.0
      BOBS = 0.0
      COBS = 0.0
      ALPOBS = 0.0
      BETOBS = 0.0
      GAMOBS = 0.0
      NCDOBS = 1
      Nncs = 0
C
C----  set parameters for common/ALLFUN
C      model properties.
C
        TABF(1)=0
        TABF(2)=0
      DO 10 I = 1,4
        ITABS(I) = 0
        BOXSCT(I) = 4
        BTISOT(I) = 0
        BTABCORR(I) = 20
        DRMNT(I) = 1000
        DRMING(I) = 1000
        DRMAXG(I) = 2.0
        DRMNT(I)  = 2.0
        CELLM(1,I) = 0.0
        CELLM (4, I) = 90.0
        CELLM (5, I) = 90.0
        CELLM (6, I) = 90.0
        SHARTT(I) = 2.5
        ITABB(I) = 0
        IROTG(I) = 0
        IROTC(I) = 0
        FMINC(I+1) = 0
        FMAXC(I+1) = 100000.0
        ISHIFT(I) = 0
C
C----   set with BFAC  or on MODEL line - 
C            use TFAC to set "DB" or "TFAC"
C       DB added to atoms - TFAC used to "sharpen" data
C
        TFACC(I+1) = 0
   10 CONTINUE
C
      IROTC(5) = 0
C
C----  limits for CRYSTAL
C
      ITABB(1) = 0
C
C----   Set on LIMITS FLIM keyword -
C
      FMINC(1) = 0
      FMAXC(1) = 100000.0
      TFACC(1) = 0
C
C   Limits for solutions used for TRAFUN or FITFUN.
      DO 20 ISOL = 1,NSOL
        ITBT(ISOL) = 0
        ALT(ISOL) = 0
        BET(ISOL) = 0
        GAT(ISOL) = 0
        TXT(ISOL) = 0
        TYT(ISOL) = 0
        TZT(ISOL) = 0
        CRT(ISOL) = 0
        RFT(ISOL) = 0
   20 CONTINUE
C
      DO 21 IFIX = 1,NFIX
        ITBF(IFIX) = 0
        ALF(IFIX) = 0
        BEF(IFIX) = 0
        GAF(IFIX) = 0
        TXF(IFIX) = 0
        TYF(IFIX) = 0
        TZF(IFIX) = 0
        CRF(IFIX) = 0
        RFF(IFIX) = 0
   21 CONTINUE
      IFIX = 0
      ISHIF = 0
C
C  - - These 7 set to 1 so ALL variables are minimized by default
      ISF = 1
      IAF = 1
      IBF = 1
      IGF = 1
      IXF = 1
      IYF = 1
      IZF = 1
C
      ISOL = 0
      IROTR = 0
      ITRA = 0
      TRATYP = 'PT '
      SCDT = 1.0
      IFIT = 0
      ISOL = 0
      NMOLT = 1
      NCODC = 1
      NCODT = 1
C
C----  resolution limits for ROTNDO, TRANDO FITNDO
C
      DRMINS = 1000.0
      DRMAXS = 0.1
      SMIN   = 0.0001
      SMAX   = 1.0
      IHMINS = -1
      IHMAXS = 0
      IKMINS = 0
      IKMAXS = 0
      ILMINS = 0
      ILMAXS = 0
      DRMINC = 1000
      DRMAXC = 1.0
      DRMINT = 1000
      DRMAXT = 1.0
      DMINTT = 0.0
      SHRTTR = 1.0
C
C----  sphere limits
C
      RMINC = 0.0
      RMAXC = 30.0
C
C----   set with BREPLACE on MODEL line.
C       Set on LIMIT BESSEL keyword -
C
      LMINR = 2
      LSUPR = 500
C
C----   Set on Anglestep Beta_max keyword
C
      DANGR = 2.5
      BMAXR = 180.0
C
C----   Set on LOCK keyword -
C
      NSR1R = 0
      NSR2R = 0
C
C----   Set on PEAK keyword -
C
      RPTSR = 0.5
      DELTAR = 0.001
      NPICR = 499
      RPTST = 0.5
      DELTAT = 0.001
      NPICT = 10
C
C----   Set on CONVERGENCE keyword -
C
      ITMAXF = 10
      EPSNF = 0.001
      NMODEL = 4
      CELLS(1) = 0.0
      CELLS(2) = 0.0
      CELLS(3) = 0.0
C
C---- Default cell angles to 90.0
C
      CELLS(4) = 90.0
      CELLS(5) = 90.0
      CELLS(6) = 90.0
C
      DO 40 JDO30 = 1,4
        DO 30 JDO20 = 1,4
          RSYM(JDO20,JDO30,1) = 0.0
   30   CONTINUE
   40 CONTINUE
C
      RSYM(1,1,1) = 1.0
      RSYM(2,2,1) = 1.0
      RSYM(3,3,1) = 1.0
      RSYM(4,4,1) = 1.0
      NSYM  = 1
      NSYMP = 1
C
   50 CONTINUE
C
      NTOK = NPARM
      LINE = ' '
C
C          ***********************************************************
      CALL PARSER(KEY,LINE,IBEG,IEND,ITYP,FVALUE,CVALUE,IDEC,NTOK,LEND,
     +            .TRUE.)
C          ***********************************************************
C
      IF (LEND .OR. KEY.EQ.'END') GO TO 350
C
C   use ITABB(1) to flag if CRYSTAL data will be used.
      IF (KEY.EQ.'SORT') THEN
C
C---- SORTFUN  set sort function flag; 
C----- if key word MODEL given prepare a TABLE from input 
C----- structure factors. These may have been generated from a map - 
C-----  or a list of Es - or whatever..

C     =====
C
      ISORT = 1
      IF (NTOK.EQ.1) GO TO 50
      
      ITOK = 2
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)
      CALL CCPUPC(KEY)
C  FP compulsory unless FC PHIC set
      LOOKUP(4) = -1
      IF (KEY.EQ.'RESO') THEN
        CALL RDRESO(ITOK+1,ITYP,FVALUE,NTOK,DRMINS,DRMAXS,SMIN,SMAX)
      ELSE IF (KEY.EQ.'MODE') THEN
C  FC PHIC  or A B compulsory 
      LOOKUP(4) =  0
        ISORT = -1
          if(NTOK.GT.2) THEN
            ITOK = 3
            ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
            KEY = LINE(IBEG(ITOK) :ICEND)
            CALL CCPUPC(KEY)
            IF (KEY.EQ.'HKLO') JSFO = 1
          END IF
      ELSE 
        CALL CCPERR (1, 'Invalid keyword: ' // KEY)
      END IF
C
      ELSE IF (KEY.EQ.'LABI') THEN
C
C---- LABIN   (File_Number)  "a=b c=d ---"
C     ==========
C
      ITOK = 2
      CALL LKYIN(1,LSPRGI,NLPRGI,NTOK,LINE,IBEG,IEND)
C
      ELSE IF (KEY.EQ.'TABF') THEN
C
C---- TABFUN  set model_tabulate function flag
C    =====
C
      ITAB = 1
      TABF(1) = 1
      TABF(2) = 1
      DO 110 ITOK = 1,NTOK
        ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
        KEY = LINE(IBEG(ITOK) :ICEND)
        CALL CCPUPC(KEY)
C   Turn off ROTATION
        IF (KEY.EQ.'NORO') TABF(1) = 0
C   Turn off TRANSLATION
        IF (KEY.EQ.'NOTR' .OR. KEY.EQ.'NOSH') TABF(2) = -1
C   Turn on OUTPUT of structure factor list as an ASCII file
        IF (KEY.EQ.'SFOU'.OR.KEY.EQ.'HKLO'  ) ITAB = 2
C   Turn off OUTPUT of TABLEi NOTABOUT
        IF (KEY.EQ.'NOTA') ITAB = -1
  110 CONTINUE
C
      ELSE IF (KEY.EQ.'MODE') THEN
C
C---- MODEL   - subsidiary keywords;  BREPLACE BADD BTARGET
C    =====
C
      ITOK = 2
      CALL GTPINT(ITOK,IMODEL,NTOK,ITYP,FVALUE)
      IF (TABF(1).NE.0) ITABS(IMODEL) = 1
      IF (TABF(2).NE.0) ITABT(IMODEL) = TABF(2)
      IF (IMODEL.LE.0 .OR. IMODEL.GT.NMODEL) THEN
        WRITE (LP, FMT='(A,I3,A,I3)') ' *** Model number (', IMODEL,
     +    ') not between 1 and ', NMODEL
        CALL CCPERR(1, 'Bad model number')
      END IF

  130 ITOK = ITOK + 1
      IF (ITOK.GT.NTOK) GO TO 50
C
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)
      CALL CCPUPC(KEY)
      IF (KEY.EQ.'BADD') THEN
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,DB,NTOK,ITYP,FVALUE)
        TFACC(IMODEL+1) = DB
      ELSE IF (KEY.EQ.'BTAR') THEN
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,BTABCORRN,NTOK,ITYP,FVALUE)
        BTABCORR(IMODEL) = BTABCORRN
      ELSE IF (KEY.EQ.'NORM') THEN
        BTABCORRN = -4
        BTABCORR(IMODEL) = BTABCORRN
      ELSE IF (KEY.EQ.'BREP') THEN
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,BTISO,NTOK,ITYP,FVALUE)
        BTISOT(IMODEL) = BTISO
      ELSE
        CALL CCPERR (1, 'Bad keyword: ' // KEY)
      END IF
      GO TO 130
C
      ELSE IF (KEY.EQ.'SAMP') THEN
C
C---- SAMPLE   - subsidiary keywords;  NUMBER  DMIN SHANN SCALE
C    =====
C
      ITOK = 2
      CALL GTPINT(ITOK,IMODEL,NTOK,ITYP,FVALUE)
      IF (IMODEL.LE.0 .OR. IMODEL.GT.NMODEL) THEN
        WRITE (LP, FMT='(A,I3,A,I3)') ' *** Model number (', IMODEL,
     +    ') not between 1 and ', NMODEL
        CALL CCPERR(1, 'Bad model number')
      END IF

  150 ITOK = ITOK + 1
      IF (ITOK.GT.NTOK) GO TO 50
C
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)
      CALL CCPUPC(KEY)
      ITOK = ITOK + 1
      IF (KEY.EQ.'SCAL') THEN
        CALL GTPREA(ITOK,BOXSC,NTOK,ITYP,FVALUE)
        BOXSCT(IMODEL) = BOXSC
      ELSE IF (KEY.EQ.'RESO'.OR.KEY.EQ.'DMIN'.OR.KEY.EQ.'TMIN') THEN
        CALL GTPREA(ITOK,DRMIN,NTOK,ITYP,FVALUE)
        DRMNT(IMODEL) = DRMIN
      ELSE IF (KEY.EQ.'SHAN') THEN
        CALL GTPREA(ITOK,SHARAT,NTOK,ITYP,FVALUE)
        SHARTT(IMODEL) = SHARAT
      ELSE
        CALL CCPERR (1, 'Bad keyword: ' // KEY)
      END IF
      GO TO 150
C
      ELSE IF (KEY.EQ.'ROTF') THEN
C
C---- ROTFUN  set rotation function flag
C     =====
C
      IROT = 1
      ITOK = 1
C     
      ELSE IF (KEY.EQ.'GENE') THEN
C
C----GENERATE - Subsidiary keywords: CELL RESOLUTION
C     =====
C
      ITOK = 2
      CALL GTPINT(ITOK,IMODEL,NTOK,ITYP,FVALUE)
      IROTG(IMODEL) = 1
      IF (IMODEL.LE.0 .OR. IMODEL.GT.NMODEL) THEN
        WRITE (LP, FMT='(A,I3,A,I3)') ' *** Model number (', IMODEL,
     +    ') not between 1 and ', NMODEL
        CALL CCPERR(1, 'Bad model number')
      END IF
  180 ITOK = ITOK + 1
      IF (ITOK.GT.NTOK) GO TO 50
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)
      CALL CCPUPC(KEY)
      ITOK = ITOK + 1
      IF (KEY.EQ.'RESO') THEN
        CALL RDRESO(ITOK,ITYP,FVALUE,NTOK,DRMING(IMODEL),
     +       DRMAXG(IMODEL),SMIN,SMAX)
C       advance if 2 numbers
        IF (ITYP (ITOK+1) .EQ. 2) ITOK = ITOK + 1
      ELSE IF (KEY.EQ.'CELL') THEN
        CALL GTPREA(ITOK,CELLM(1,IMODEL),NTOK,ITYP,FVALUE)
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,CELLM(2,IMODEL),NTOK,ITYP,FVALUE)
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,CELLM(3,IMODEL),NTOK,ITYP,FVALUE)
        ITOK = ITOK + 1
C       cell angles should always be 90 degrees, says EJD -- don't allow
C       them to be specified
        CELLM (4, IMODEL) = 90.0
        CELLM (5, IMODEL) = 90.0
        CELLM (6, IMODEL) = 90.0
C
      ELSE
        CALL CCPERR(1, 'Invalid keyword: '// KEY)
      END IF
      GO TO 180
C
      ELSE IF (KEY.EQ.'CLMN' .OR. KEY.EQ.'ELMN') THEN
C
C----CLMN - Subsidiary keywords MODEL or CRYSTAL, ORTHOG FLIM RESO SHARPEn
C-------------------------------SPHERE
C     =====
C
C----  either get MODEL number or if CLMN CRYSTAL set IROTC(1) = -1
C
      ITOK = 2
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)
      CALL CCPUPC(KEY)
      IF (KEY.EQ.'CRYS') THEN
        IRTC = -1
        IROTC(1) = IRTC
      ELSE IF (KEY.EQ.'MODE') THEN
        ITOK = ITOK + 1
        CALL GTPINT(ITOK,IRTC,NTOK,ITYP,FVALUE)
        IF (IRTC.LE.0 .OR. IRTC.GT.NMODEL) THEN
          WRITE (LP, FMT='(A,I3,A,I3)') ' *** Model number (', IMODEL,
     +       ') not between 1 and ', NMODEL
          CALL CCPERR(1, 'Bad model number')
        END IF
        IROTC(IRTC+1) = IRTC
      END IF
C
  210 ITOK = ITOK + 1
      IF (ITOK.GT.NTOK) GO TO 50
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)
      CALL CCPUPC(KEY)
      ITOK = ITOK + 1
      IF (KEY.EQ.'ORTH') THEN
        CALL GTPINT(ITOK,JUNK,NTOK,ITYP,FVALUE)
        IF (IRTC.LT.0) NCODC = JUNK
        IF (IRTC.GT.0) WRITE (6,FMT='(a)')
     +  ' **ORTHOGONALISATION cannot be set for MODELS - default to 1**'
      ELSE IF (KEY.EQ.'SPHE') THEN
        RMIN = 0
        RMAX = 0
C    RMIN should be always = 0
        CALL GTPREA(ITOK,RMIN,NTOK,ITYP,FVALUE)
        IF(ITOK.LT.NTOK .AND. ITYP(ITOK+1).EQ.2) THEN
          ITOK = ITOK + 1
          CALL GTPREA(ITOK,RMAX,NTOK,ITYP,FVALUE)
        END IF
        IF(RMIN.GT.RMAX) RMAX = RMIN
        RMAXC = RMAX
        RMINC = 0
      ELSE IF (KEY.EQ.'RESO') THEN
        CALL RDRESO(ITOK,ITYP,FVALUE,NTOK,DRMIN,DRMAX,SMIN,SMAX)
C       advance if 2 numbers
        IF (ITYP (ITOK+1).EQ.2) ITOK = ITOK + 1
        IF (DRMINC.NE.1000) THEN
C         Check resolution limits
           IF(DRMIN.NE.DRMINC .OR. DRMAX.NE.DRMAXC) CALL CCPERR
     +    (1,'  Inconsistent resolution limits for CLMNs in ROTFUN')
        END IF
        DRMINC = DRMIN
        DRMAXC = DRMAX
      ELSE IF (KEY.EQ.'SHAR'.OR.KEY.EQ.'BADD') THEN
        CALL GTPREA(ITOK,DB,NTOK,ITYP,FVALUE)
        IF (IRTC.LT.0) TFACC(1) = DB
        IF (IRTC.GT.0) TFACC(IRTC+1) = DB
      ELSE IF (KEY.EQ.'FLIM') THEN
        CALL GTPREA(ITOK,FMIN,NTOK,ITYP,FVALUE)
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,FMAX,NTOK,ITYP,FVALUE)
        IF (IRTC.LT.0) FMINC(1) = FMIN
        IF (IRTC.LT.0) FMAXC(1) = FMAX
        IF (IRTC.GT.0) FMINC(IRTC+1) = FMIN
        IF (IRTC.GT.0) FMAXC(IRTC+1) = FMAX
      ELSE
        CALL CCPERR(1,'Invalid keyword:' // KEY)
      END IF
      GO TO 210
C
      ELSE IF (KEY.EQ.'ROTA') THEN
C
C----ROTA - Subsidiary keywords: SELF or CROSS,MODEL,BESLIM,STEP,BMAX,PKLIM,
C            NSR. DELTA, NPIC
C     =====
C
      IROTR = 1
      ITOK = 2
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)
      CALL CCPUPC(KEY)
      IF (KEY.EQ.'CROS') THEN
        ISELF = 0
      ELSE IF (KEY.EQ.'SELF') THEN
        RPTSR = 0.2
        ISELF = 1
      ELSE
        CALL CCPERR(1, 'Either ROTATE CROSS or ROTATE SELF please!!')
      END IF
C
  230 CONTINUE
      ITOK = ITOK + 1
      IF (ITOK.GT.NTOK) GO TO 50
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)
      CALL CCPUPC(KEY)
      ITOK = ITOK + 1
      IF (KEY.EQ.'MODE') THEN
        CALL GTPINT(ITOK,IROTR,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'BESL') THEN
        CALL GTPINT(ITOK,LMINR,NTOK,ITYP,FVALUE)
        ITOK = ITOK + 1
        CALL GTPINT(ITOK,LSUPR,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'STEP') THEN
        CALL GTPREA(ITOK,DANGR,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'BMAX') THEN
        CALL GTPREA(ITOK,BMAXR,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'LOCK' .OR. KEY(1:3).EQ.'NSR') THEN
C     locked rotation function input. 
        CALL GTPINT(ITOK,NSR1R,NTOK,ITYP,FVALUE)
           IF(NSR1R.GT.MSR1R) Call CCPERR(1,
     + ' Too many Locked rotation functions requested - reset MSR1R**')
           IF(NTOK .LT. ITOK + 3*NSR1R) THEN
              IERR = 1
              WRITE(6,'(A,I4,A)') 
     +  ' **** Not enough Euler angle sets given for ',NSR1R,
     +  ' locked rotations **** '
              CALL CCPERR(1,' Locked rotation problem')
           END IF
       ITOK = ITOK + 1
C  Check if next string is a character string - eg  POLAR
C   LANGTYP = 0, input angles Eulerian ( default)
C   LANGTYP = 1, input angles Polar
      LANGTYP = 0
      IF(ITYP(ITOK).EQ.1) THEN
         ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
         KEY = LINE(IBEG(ITOK) :ICEND)
         CALL CCPUPC(KEY)
         IF(KEY(1:3).EQ.'POL') LANGTYP = 1
         IF(KEY(1:3).EQ.'EUL') LANGTYP = 0
         ITOK = ITOK + 1
      END IF
C       DO ISR1R = 1,NSR1R
C   Always need identity matrix - advance NSR1R by 1 and set ANGNSR(1,1) =0
        LPRINT = .FALSE.
        NSR1R = NSR1R + 1
        ANGNSR(1,1) = 0.0
        ANGNSR(2,1) = 0.0
        ANGNSR(3,1) = 0.0
       DO ISR1R = 2,NSR1R
C  Input angles Eulerian
            IF(LANGTYP.EQ.0) THEN
              CALL GTPREA(ITOK  ,ALPHA,NTOK,ITYP,FVALUE)
              CALL GTPREA(ITOK+1,BETA,NTOK,ITYP,FVALUE)
              CALL GTPREA(ITOK+2,GAMMA,NTOK,ITYP,FVALUE)
C  Get rotation matrix
              CALL RMXE(ALPHA,BETA,GAMMA,ROTE,LPRINT)
C  Convert matrix to Polar angles
              CALL RMX2PP(ROTE,CHI,OMEGA, PHI,VN,LPRINT)
               ANGNSR(1,ISR1R) = ALPHA
               ANGNSR(2,ISR1R) = BETA
               ANGNSR(3,ISR1R) = GAMMA
               ANGNSRP(1,ISR1R) = OMEGA
               ANGNSRP(2,ISR1R) = PHI
               ANGNSRP(3,ISR1R) = CHI
            END IF
C  Input Angles Polar
            IF(LANGTYP.EQ.1) THEN
              CALL GTPREA(ITOK  ,OMEGA,NTOK,ITYP,FVALUE)
              CALL GTPREA(ITOK+1,PHI,NTOK,ITYP,FVALUE)
              CALL GTPREA(ITOK+2,CHI,NTOK,ITYP,FVALUE)
C  Get rotation matrix
              LPRINT = .TRUE.
              CALL RMXP(OMEGA,PHI,CHI,ROTE,LPRINT)
C  Convert matrix to Euler angles
              CALL RMX2E(ROTE,ALPHA,BETA,GAMMA,LPRINT)
               ANGNSR(1,ISR1R) = ALPHA
               ANGNSR(2,ISR1R) = BETA
               ANGNSR(3,ISR1R) = GAMMA
               ANGNSRP(1,ISR1R) = OMEGA
               ANGNSRP(2,ISR1R) = PHI
               ANGNSRP(3,ISR1R) = CHI
            END IF
        ITOK = ITOK + 3
       END DO 
C
      ELSE IF (KEY.EQ.'PKLI') THEN
        CALL GTPREA(ITOK,RPTSR,NTOK,ITYP,FVALUE)
C     doesn't appear to do anything - mdw
      ELSE IF (KEY.EQ.'DELT') THEN
        CALL GTPREA(ITOK,DELTAR,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'NPIC') THEN
        CALL GTPINT(ITOK,NPICR,NTOK,ITYP,FVALUE)
        IF(NPICR.GT.NSOL) NPICR = NSOL
      ELSE
        CALL CCPERR (1, 'Invalid keyword: ' // KEY)
      END IF
      GO TO 230
C
      ELSE IF (KEY.EQ.'TRAF' .OR. KEY.EQ.'FITF') THEN
C
C---- TRAFUN  or FITFUN
C     =====      ======
C----       set translation function and rigid body refinement flags
C  Default Crowther_Blow translation fn; 
C
      ITRA = 0
      IFIT = 0
      IF (KEY.EQ.'TRAF') ITRA = 1
      IF (KEY.EQ.'FITF') IFIT = 1
      ISOL = 0
      ITOK = 1
  250 CONTINUE
      ITOK = ITOK + 1
      IF (ITOK.GT.NTOK) GO TO 50
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)//'  '
      CALL CCPUPC(KEY)
      IF (KEY(1:3).EQ.'CB '.OR.KEY(1:3).EQ.'CO '.OR.KEY(1:3).EQ.'C-O') 
     +    THEN
        TRATYP='CO'
        SCDT = 0.0
      ELSE IF (KEY(1:3).EQ.'PTF') THEN
        TRATYP='PTF'
        SCDT = 1.0
      ELSE IF (KEY(1:3).EQ.'PT ') THEN
        TRATYP='PT '
        SCDT = 1.0
      ELSE IF (KEY(1:2).EQ.'HL'.OR.KEY(1:3).EQ.'H-L') THEN
        TRATYP='HL '
        SCDT = 0.0
      ELSE IF (KEY(1:2).EQ.'CC'.OR.KEY(1:3).EQ.'C-C') THEN
        TRATYP='CC '
        SCDT = 0.0
      ELSE IF (KEY.EQ.'NMOL') THEN
        ITOK = ITOK + 1
        CALL GTPINT(ITOK,NMOLT,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'RESO') THEN
        ITOK = ITOK + 1
        CALL RDRESO(ITOK,ITYP,FVALUE,NTOK,DRMINT,DRMAXT,SMIN,SMAX)
        IF (ABS(DMINTT).LT.0.00001) DMINTT = DRMAXT/2.0
        IF (ITYP (ITOK+1) .EQ. 2) ITOK = ITOK + 1
      ELSE IF (KEY.EQ.'SCAL') THEN
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,SCD,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'TMIN') THEN
C       fixme:  not documented
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,DMINTT,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'SHAN') THEN
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,SHRTTR,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'PKLI') THEN
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,RPTST,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'DELT') THEN
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,DELTAT,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'NPIC') THEN
        ITOK = ITOK + 1
        CALL GTPINT(ITOK,NPICT,NTOK,ITYP,FVALUE)
        IF(NPICT.GT.NSOL) NPICT = NSOL
      ELSE IF (KEY.EQ.'NCST') THEN
        ITOK = ITOK + 1
        Nncs = Nncs + 1
        CALL GTPREA(ITOK,TXncs(Nncs),NTOK,ITYP,FVALUE)
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,TYncs(Nncs),NTOK,ITYP,FVALUE)
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,TZncs(Nncs),NTOK,ITYP,FVALUE)
C
C----   FITFUN variables.
C
      ELSE IF (KEY.EQ.'ITER') THEN
        ITOK = ITOK + 1
        CALL GTPINT(ITOK,ITMAXF,NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'CONV') THEN
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,EPSNF,NTOK,ITYP,FVALUE)
      ELSE
        CALL CCPERR(1, 'Invalid keyword: ' // KEY)
      END IF
      GO TO 250
C
      ELSE IF (KEY.EQ.'CRYS' .OR.KEY.EQ.'CELL') THEN
C
C---- CRYSTAL  set fitting function flag - ORTH + CELL
C     =====
C
      ITOK = 1
C
C  If there is no keyword assume the cell follows
C  Input CRYSTAL CELL ( usually read from MTZ file)
  270 ITOK = ITOK + 1
      KEY = '    '
        IF(ITYP(ITOK) .EQ. 2) THEN
          CALL GTPREA(ITOK,AOBS,NTOK,ITYP,FVALUE)
          ITOK = ITOK + 1
          CALL GTPREA(ITOK,BOBS,NTOK,ITYP,FVALUE)
          ITOK = ITOK + 1
          CALL GTPREA(ITOK,COBS,NTOK,ITYP,FVALUE)
          IF(ITOK.LT.NTOK .AND. ITYP(ITOK+1).EQ.2) THEN
            ITOK = ITOK + 1
            CALL GTPREA(ITOK,ALPOBS,NTOK,ITYP,FVALUE)
          END IF
          IF(ITOK.LT.NTOK .AND. ITYP(ITOK+1).EQ.2 )THEN
            ITOK = ITOK + 1
            CALL GTPREA(ITOK,BETOBS,NTOK,ITYP,FVALUE)
          END IF
          IF(ITOK.LT.NTOK .AND. ITYP(ITOK+1).EQ.2) THEN
            ITOK = ITOK + 1
            CALL GTPREA(ITOK,GAMOBS,NTOK,ITYP,FVALUE)
          END IF
          ITOK = ITOK + 1
        END IF
      IF (ITOK.GT.NTOK) GO TO 50
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)
      CALL CCPUPC(KEY)
      IF (KEY.EQ.'ORTH') THEN
      ITOK = ITOK + 1
        CALL GTPINT(ITOK,NCODT,NTOK,ITYP,FVALUE)
        NCDOBS = NCODT
      ELSE IF (KEY.EQ.'SHAR'.OR.KEY.EQ.'BADD') THEN
      ITOK = ITOK + 1
        CALL GTPREA(ITOK,TFACC(1),NTOK,ITYP,FVALUE)
      ELSE IF (KEY.EQ.'FLIM') THEN
      ITOK = ITOK + 1
        CALL GTPREA(ITOK,FMIN,NTOK,ITYP,FVALUE)
        ITOK = ITOK + 1
        CALL GTPREA(ITOK,FMAX,NTOK,ITYP,FVALUE)
        FMINC(1) = FMIN
        FMAXC(1) = FMAX
      ELSE
        CALL CCPERR(1,'Invalid keyword: ' // KEY)
      END IF
      IF(ITOK.LT.NTOK) GO TO 270
C
      ELSE IF (KEY.EQ.'SOLU') THEN
C
C---- SOLUTION
C     =====
C     read itab al be ga tx ty tz
C
      ITOK = 1
C  Check if this is a "FIX"ed position. - then set ISHIF = 0, IFIX = n
      ICEND = MIN(IBEG(2)+3,IEND(2))
      KEY = LINE(IBEG(2) :ICEND)
      CALL CCPUPC(KEY)
      IF (KEY.EQ.'FIX') THEN
        ITOK = 2
C       Is this the first of a new set of "FIX" cards - ie ISHIF = 1?
        IF( ISHIF .EQ. 1) IFIX = 0
        ISHIF = 0
        IFIX = IFIX + 1
        if(ifix.gt.nfix) call ccperr(1,
     +   'Too many FIXed solutions - increase nfix and recompile')  
        IF(IFIX.GE.NMOLT) CALL CCPERR(1, 'Too many FIXed solutions')
      END IF 
C
      IF (KEY.NE.'FIX') ISHIF = 1
      CALL GTPINT(ITOK+1,ITB,NTOK,ITYP,FVALUE)
      CALL GTPREA(ITOK+2,AL,NTOK,ITYP,FVALUE)
      CALL GTPREA(ITOK+3,BE,NTOK,ITYP,FVALUE)
      CALL GTPREA(ITOK+4,GA,NTOK,ITYP,FVALUE)
      TX = 0.0
      TY = 0.0
      TZ = 0.0
      CR = 0.0
      RRF = 0.0
      IF (NTOK.GT.ITOK+4) CALL GTPREA(ITOK+5,TX,NTOK,ITYP,FVALUE)
      IF (NTOK.GT.ITOK+5) CALL GTPREA(ITOK+6,TY,NTOK,ITYP,FVALUE)
      IF (NTOK.GT.ITOK+6) CALL GTPREA(ITOK+7,TZ,NTOK,ITYP,FVALUE)
      IF (NTOK.GT.ITOK+7) CALL GTPREA(ITOK+8,CR,NTOK,ITYP,FVALUE)
      IF (NTOK.GT.ITOK+8) CALL GTPREA(ITOK+9,RRF,NTOK,ITYP,FVALUE)
c     write(*,*)' check ',isol, ishif,ifix,itb,al,be,ga,tx,ty,tz,cr,rf
      IF(ISHIF.EQ.0) THEN
        ITBF(IFIX) = ITB
        ALF(IFIX) = AL
        BEF(IFIX) = BE
        GAF(IFIX) = GA
        TXF(IFIX) = TX
        TYF(IFIX) = TY
        TZF(IFIX) = TZ
        CRF(IFIX) = CR
        RFF(IFIX) = RRF
        GO TO 50
      END IF
C    Build up table of solutions. Need FIX1, FIX2,.. SOL in table.
      IF(ISHIF.EQ.1) THEN
         IF(IFIX.GT.0) THEN
            IF(IFIX.NE.NMOLT - 1 )
     +          CALL CCPERR(1, 'Wrong number of FIXed solutions')
          DO 281 I = 1,IFIX
          ISOL = ISOL + 1
          IF (ISOL.GT.NSOL) CALL CCPERR(1,'Too many solutions ')
          ITBT(ISOL) = ITBF(I)
          ALT(ISOL) = ALF(I)
          BET(ISOL) = BEF(I)
          GAT(ISOL) = GAF(I)
          TXT(ISOL) = TXF(I)
          TYT(ISOL) = TYF(I)
          TZT(ISOL) = TZF(I)
          CRT(ISOL) = CRF(I)
          RFT(ISOL) = RFF(I)
281       CONTINUE
         END IF
C  Now append this solution
       ISOL = ISOL + 1
       IF (ISOL.GT.NSOL) CALL CCPERR(1,' Too many solution ')
       ITBT(ISOL) = ITB
       ALT(ISOL) = AL
       BET(ISOL) = BE
       GAT(ISOL) = GA
       TXT(ISOL) = TX
       TYT(ISOL) = TY
       TZT(ISOL) = TZ
       CRT(ISOL) = CR
       RFT(ISOL) = RRF
      END IF
c     write(*,*)'check ',isol,ishif,ifix,itb,al,be,ga,tx,ty,tz,cr,rf
C
      ELSE IF (KEY.EQ.'REFS') THEN
C
C---- REFSOLUTION
C     =====
C      read nmolecules
C
      ISF = 0
      IAF = 1
      IBF = 1
      IGF = 1
      IXF = 0
      IYF = 0
      IZF = 0
      DO 300 ITOK = 2,NTOK
        CALL CCPUPC(LINE)
        IF (LINE(IBEG(ITOK) :IBEG(ITOK)+1).EQ.'BF') ISF = 1
        IF (LINE(IBEG(ITOK) :IBEG(ITOK)+1).EQ.'BE') IBF = 1
        IF (LINE(IBEG(ITOK) :IBEG(ITOK)).EQ.'A') IAF = 1
        IF (LINE(IBEG(ITOK) :IBEG(ITOK)).EQ.'G') IGF = 1
        IF (LINE(IBEG(ITOK) :IBEG(ITOK)).EQ.'X') IXF = 1
        IF (LINE(IBEG(ITOK) :IBEG(ITOK)).EQ.'Y') IYF = 1
        IF (LINE(IBEG(ITOK) :IBEG(ITOK)).EQ.'Z') IZF = 1
  300 CONTINUE
C
      ELSE IF (KEY.EQ.'SHIF') THEN
C
C     SHIFT -- MR2IC Keyword +
C     ===== COM (Center of Mass) EULE (Euler ang.)
      IMR = 1
      ITOK = 2
      CALL GTPINT(ITOK,ISHTML,NTOK,ITYP,FVALUE)
C     Easiest way to set NMOLT - No. fragments
      NMOLT = MAX(ISHTML,NMOLT)
      ITOK = ITOK + 1
      IF (ISHTML.LE.0 .OR. ISHTML.GT.NMODEL) THEN
        WRITE (LP, FMT='(A,I3,A,I3)') ' *** Model number (', IMODEL,
     +    ') not between 1 and ', NMODEL
        CALL CCPERR(1, 'Bad model number')
      END IF
      ISHIFT(ISHTML) = ISHTML
      CMASS(1,ISHTML)  = 0.0
      CMASS(2,ISHTML)  = 0.0
      CMASS(3,ISHTML)  = 0.0
      EULER(1,ISHTML) = 0.0
      EULER(2,ISHTML) = 0.0
      EULER(3,ISHTML) = 0.0
  304 IF (ITOK.GE.NTOK) GO TO 50
      ICEND = MIN(IBEG(ITOK)+3,IEND(ITOK))
      KEY = LINE(IBEG(ITOK) :ICEND)
      CALL CCPUPC(KEY)
      IF (KEY.EQ.'COM ') THEN
       DO 302 I = 1,3
       ITOK = ITOK + 1
        CALL GTPREA(ITOK,CMASS(I,ISHTML),NTOK,ITYP,FVALUE)
  302  CONTINUE
      ELSE IF (KEY.EQ.'EULE') THEN
        DO 303 I = 1,3
          ITOK = ITOK + 1
          CALL GTPREA(ITOK,EULER(I,ISHTML),NTOK,ITYP,FVALUE)
 303    CONTINUE
      ELSE
        CALL CCPERR (1, 'Invalid keyword')
      ENDIF
      ITOK = ITOK + 1
      GOTO 304
C
C---- HKLM can be reset here (secret keyword)
C     =====
C
      ELSE IF (KEY .EQ. 'HKLM') THEN
        CALL GTPINT(2,hm,NTOK,ITYP,FVALUE)
        CALL GTPINT(3,km,NTOK,ITYP,FVALUE)
        CALL GTPINT(4,lm,NTOK,ITYP,FVALUE)
        CALL GTPINT(5,nm,NTOK,ITYP,FVALUE)
         NH = 2*(HM+1)
         NK = 2*(KM+1)
         NL = 2*(LM+1)
         WRITE(6,'(///,A,3i5,/,A,I8)')
     +   '  **** Maximal H K L Reset to:',HM,KM,LM,
     +   '  ****Symmetry limit(2*NSYMP+1):', NM
C
      ELSE IF (KEY.EQ.'TITL') THEN
C
C---- TITLe  read title
C     =====
C
        TITLE = LINE(IBEG(2) :)
C
      ELSE IF (KEY.EQ.'VERB') THEN
C
C---- VERB,
C     =====
C      set flag for verbose
C
      ICEND = MIN(IBEG(2)+3,IEND(2))
      KEY = LINE(IBEG(2) :ICEND)
      CALL CCPUPC(KEY)
      IVERB = 1
      IF (KEY.EQ.'OFF') IVERB = 0
      DO 330 I = 1,20
        KPRTT(I) = IVERB
  330 CONTINUE
C     
      ELSE IF (KEY.EQ.'SYMM') THEN
C
C---- SYMMETRY
C     ==========
C     read symmetry
C
C--- SYMMetry    read crystal number or  space group
C
      ITOK = 2
C----   Only interested in checking next token
      NTOKS = ITOK
      CALL RDSYMM(ITOK,LINE,IBEG,IEND,ITYP,FVALUE,NTOKS,NAMSGP,NSPGRP,
     +            PGNAME,NSYM,NSYMP,RSYM)
      IF( ( 2*NSYMP+1) .GT. NM)    CALL CCPERR
     +  (2,'Symmetry limit(2*NSYMP+1) must be =< NM - reset with HKLM')
C
      ELSE
        CALL CCPERR (1, 'Invalid keyword: '//KEY)
      END IF
      GO TO 50
C
C---- End of input
C
  350 CONTINUE
C
C  Check resolution limits for rotfun with gene and clmn are consistent
      IF(IROT.EQ.1 .AND.IROTG(1) .NE.0) THEN
        IF( DRMAXG(1) .NE. DRMAXC .AND. DRMING(1).NE.DRMINC) THEN
          WRITE(6,*) 
     +  ' Inconsistent resolution limits for GENERATE and CLMN'
          DD = MAX(DRMAXG(1),DRMAXC)
          DRMAXG(1) = DD
          DRMAXC    = DD
          DD = MIN(DRMING(1),DRMINC)
          DRMING(1) = DD
          DRMINC    = DD
          WRITE(6,'(//,A,2F8.3)') 
     +  ' Resetting resolution limits to:', DRMAXC,DRMINC
        CALL CCPERR(2,
     + '  Resetting inconsistent resln limits for GENERATE and CLMN')
       END IF
      END IF
C   Open MTZ files if SORTFUN requested
C---- Open input file for Read; print header
C
      IF (ISORT.NE.0) THEN
        WRITE (6,FMT='(///,a,/,a,/a)')
     +  ' **********************************************',
     +  ' ***** SORT FUNCTION REQUESTED -INPUT HKLs*****',
     +  ' **********************************************'
        WRITE (6,FMT='(A,F12.5,1X,F12.5)')
     +  ' Resolution limits are:', DRMAXS, DRMINS
        IF (ISORT.LT.0) WRITE (6,FMT='(///,a,/,a,/a)')
     +  ' ******************************************',
     +  ' ***** HKLIN used to generate a TABLE *****',
     +  ' ******************************************'
C Checking mtz HKLIN below, and XYZINi for TABLEs above
C
       GO TO 395
      END IF
C
      IF (ITAB.NE.0) THEN
        WRITE (6,FMT='(///,a,/,a,/a)')
     +  ' *************************************************',
     +  ' ***** TABLING FUNCTION GENERATED FROM MODEL *****',
     +  ' *************************************************'
C
C   Check if CRYSTAL CELL input
          XMAX = -1000.0
          YMAX = -1000.0
          ZMAX = -1000.0
          XMIN =  1000.0
          YMIN =  1000.0
          ZMIN =  1000.0
        IF(AOBS.NE.0.0) THEN
            A = AOBS
            B = BOBS 
            C = COBS  
            ALPHA = ALPOBS
            BETA =BETOBS  
            GAMMA = GAMOBS  
C            *****
        CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
        NCODE = NCDOBS
        CALL ORTHO
C            *****
           RFOBS(1,1) = RF(1,1)
           RFOBS(1,2) = RF(1,2)
           RFOBS(1,3) = RF(1,3)
           RFOBS(2,1) = RF(2,1)
           RFOBS(2,2) = RF(2,2)
           RFOBS(2,3) = RF(2,3)
           RFOBS(3,1) = RF(3,1)
           RFOBS(3,2) = RF(3,2)
           RFOBS(3,3) = RF(3,3)
        END IF
C
        MITAB = 0
        MCTAB = 100000

        DO 360 IMODEL = 1,4
C  Check model size to get  rough TABLING dimensions
          IF (ITABS(IMODEL).NE.0 .OR. ITABT(IMODEL).NE.0) THEN
          WRITE (FILNAM,FMT='(A5,I1)') 'XYZIN',IMODEL
          IFAIL = 1
          IXYZIN = 0
C
C              *****************************************
          CALL XYZOPEN(filnam,'INPUT',' ',IXYZIN,IFAIL)
C              *****************************************
          nat = 0
 499       continue
      call xyzadvance(IXYZin, 0,0, *499, *500)
C  read PEB atom card from buffer
      call    xyzatom(ixyzin, iser, atnam, restyp, idch, ires,
     *   resno, insert, altcod, segid, iz, atmtyp)
      call   xyzcoord(ixyzin, 'O', 'O', x, y, z, q, biso, anisou)
C
C---- SKIP if ALTCOD not blank or A
C
      IF(ALTCOD.NE.' ' .AND. ALTCOD.NE.'A') GO TO 499
C            ***********************************************************
C
C---- Check for anisotropic Bs, skip ANISOU
C
      IF (anisou(2).NE.0.0 .OR. anisou(3).NE.0.0) THEN
        IF (X.EQ.0.0 .AND. Y.EQ.0.0 .AND. Z.EQ.0.0) GOTO 499
      ENDIF
          nat = nat + 1
          if(x.lt.xmin) xmin = x
          if(x.gt.xmax) xmax = x
          if(y.lt.ymin) ymin = y
          if(y.gt.ymax) ymax = y
          if(z.lt.zmin) zmin = z
          if(z.gt.zmax) zmax = z
          go to 499
 500      CONTINUE
          WRITE(6,'(a,i3,a,i5,/,a,3(3x,2F10.3))')
     + ' model',imodel,' Natoms',nat,
     + ' xyzrange', xmin,xmax, ymin,ymax,zmin,zmax
C  Check likely HMAX KMAX LMAX for model cell.
            Aaprox = (xmax -xmin)*BOXSCT(IMODEL)
            Baprox = (ymax -ymin)*BOXSCT(IMODEL)
            Caprox = (zmax -zmin)*BOXSCT(IMODEL)
             CALL INDEXM(DRMNT(IMODEL),Aaprox,Baprox,Caprox,
     +                                HMaprox,kMaprox,LMaprox)
C     ' TABLING_MR is 2*(HMAX+2)*(2*KMAX+1)*(2*LMAX+1)+2*ND',/,
C  Add in 150000 for luck..
C  Nudge up estimates:
              HMaprox =  HMaprox + 2
              KMaprox =  KMaprox + 2
              LMaprox =  LMaprox + 2
C             II =(HMaprox+2)*(2*KMaprox+1)*(2*LMaprox+1)+150000
             II =nint( ( 1.1*(HMaprox+2)*(2*KMaprox+1)*(2*LMaprox+1)))
     +           + 150000
             IF(II.GT.MITAB) MITAB = II
c             MRTAB = 2*MITAB
            WRITE (6,FMT='(A)')' Coordinates output after modification'
            IF(ITAB.GT.0)WRITE (6,FMT='(A,i3,A)') ' Model ',IMODEL,
     +        ' tabulated:'
            IF (ITABS(IMODEL).NE.0) WRITE (6,FMT=*) ' Model rotated.'
            IF (ITABT(IMODEL).GT.0) WRITE (6,FMT=*) ' Model moved',
     +      ' to have centre of mass at origin.'
            IF (ITABT(IMODEL).LT.0) WRITE (6,FMT=*) ' Model fixed',
     +      ' - useful for rigid body fitting with FITFUN.'
            WRITE (6,FMT='(a,2f8.3)') ' Box scale is:',BOXSCT(IMODEL)
            WRITE (6,FMT='(a,2f8.3)') ' Shannon factor is:',
     +        SHARTT(IMODEL)
            IF (TFACC(IMODEL+1).NE.0.0) WRITE (6,
     +          FMT='(a,2f8.3)') ' Addition to B factors:',
     +          TFACC(IMODEL+1)
            IF (BTABCORR(IMODEL).NE.0.0) WRITE (6,FMT='(a,2f8.3)') 
     +          '  Model B factors will be modified to an average of:',
     +             BTABCORR(IMODEL)
            IF (BTABCORR(IMODEL).EQ.-4.0) WRITE (6,FMT='(a,2f8.3)') 
     +   '  This is equivalent to normalising the model amplitudes'
            IF (BTISOT(IMODEL).NE.0.0) WRITE (6,
     +          FMT='(a,2f8.3)') '  B factors reset to:',BTISOT(IMODEL)
            WRITE (6,FMT='(a,2f8.3)') ' Resolution limit is:',
     +        DRMNT(IMODEL)
C           WRITE (6,FMT='(a,3(/,I12)/,A,3F10.3,3I5)') 
C    + ' Current estimates TABLING_MI TABLING_MR and TABLING_MC are:',
C    +       MITAB,MRTAB,MCTAB,
C    +  ' Cell estimate and HMAX KMAX LMAX',Aaprox,Baprox,Caprox,
C    +                                HMaprox,kMaprox,LMaprox
            WRITE (6,FMT='(a,2(/,I12)/,A,3F10.3,3I5)') 
     + ' Current estimates TABLING_MI and TABLING_MC are:',
     +       MITAB,MCTAB,
     +  ' Cell estimate and HMAX KMAX LMAX',Aaprox,Baprox,Caprox,
     +                                HMaprox,kMaprox,LMaprox
            WRITE (6,FMT='(a,///)')
     +        ' ***********************************'
          END IF
  360   CONTINUE
C  No further checking required
       RETURN
      END IF
C
      IF (IROT.NE.0) THEN
        WRITE (6,FMT='(///,a,/,a,/a)')
     +  ' ***************************************',
     +  ' ***** ROTATION FUNCTION REQUESTED *****',
     +  ' ***************************************'
C
        NRH1 = 0
        DO 370 IMODEL = 1,4
          IF (IROTG(IMODEL).NE.0) THEN
            WRITE (6,FMT='(//,A,i3,A,i2,a)') ' Generate MODEL '
     +        ,IMODEL,' in ',irotg(imodel),' part(s)'
            WRITE (6,FMT='(a,2f8.3)') ' Resolution limits are:',
     +        DRMING(IMODEL),DRMAXG(IMODEL)
C   Set CELLM automatically if not set on command line..
            IF(CELLM(1,IMODEL).LT.1.0) THEN
               CELLM(1,IMODEL) = 2*RMAXC + 20
               CELLM(2,IMODEL) = 2*RMAXC + 20
               CELLM(3,IMODEL) = 2*RMAXC + 20
            END IF
                 WRITE (6,FMT='(a,6f8.3)') ' Model cell is:',
     +        (CELLM(II,IMODEL),II=1,6)
C  Set number of likely reflections for ROTFUN model
          RVOL = 1.0/(CELLM(1,IMODEL)*CELLM(2,IMODEL)*CELLM(3,IMODEL))
          NSYM = 1
          NRX = NINT(0.6667*PI*(1.0/DRMAXG(IMODEL))**3.0 /( RVOL*NSYM))
          IF(NRX.GT.NRH1) NRH1 = NRX
          END IF
  370   CONTINUE
C        NRH1 = NRH1 + 1000
        NRH1 = nint(1.1*NRH1 ) + 1000
        WRITE(6,*) ' possible NRH1 for hklpck1',NRH1
C
        IF (IRTC.NE.0) THEN
C
          MTAA = 0
          DO 380 IMODEL = 1,5
            IF (IROTC(IMODEL).NE.0) THEN
              IF (IMODEL.EQ.1) THEN
                WRITE (6,FMT='(//,A,i3,A)')
     +            ' CLMN requested for CRYSTAL '
                WRITE (6,FMT='(a,i3)') ' Orthogonalisation code is:',
     +            NCODC
              END IF
C
              IF (IMODEL.GT.1) THEN
                WRITE (6,FMT='(//,A,i3,A)')
     +            ' CLMN requested for Model ',IROTC(IMODEL)
C  Check largest dimensions of TABLEi
c                IMM = IMODEL -1
c                WRITE (FILNAM,FMT='(A5,I1)') 'TABLE',IMM
c                write(6,*)' check filnam imm:',imm,filnam
c                CALL CCPDPN(ITAB,FILNAM,'READONLY','U',0,IFAIL)
c                READ (ITAB) (RMX(II),II=1,7),IHMAX,KMAX,LMAX,SQHMAX
c                write(6,*) (RMX(II),II=1,7),IHMAX,KMAX,LMAX,SQHMAX
c                MTX = (2*KMAX+1)* (IHMAX+2)* (2*LMAX+1)
c                write(6,*)
c     +    ' mtx = (2*KMAX+1)* (IHMAX+2)* (2*LMAX+1) mtaa1',mtx,mtaa
c                IF(MTX.GT.MTAA) MTAA = MTX
c                write(6,*)' mtx mtaa2',mtx,mtaa
c                CLOSE (UNIT=ITAB)
              END IF 
C
              WRITE (6,FMT='(a,f8.3,f12.1)') ' F limits are:',
     +          FMINC(IMODEL),FMAXC(IMODEL)
              WRITE (6,FMT='(a,2f8.3)') ' Sharpening factor is:',
     +          TFACC(IMODEL)
            END IF
  380     CONTINUE
          WRITE (6,FMT='(a,2f8.3)') ' Resolution limits are:',DRMINC,
     +      DRMAXC
C---- check sphere volume against crystal asymmetric unit volume.
C
            VOLSPH =  ( REAL(1.33333*3.14159) )*RMAXC*RMAXC*RMAXC
          WRITE (6,FMT='(2(/a,f10.3))') ' Sphere limits is:',RMAXC,
     +    ' Sphere volume is:', VOLSPH

        END IF
C
        IF (IROTR.NE.0) THEN
          IF (ISELF.EQ.1) WRITE (6,FMT='(///,A)') ' Self ROTATION'
          IF (ISELF.EQ.0) WRITE (6,FMT='(///,A,I3)')
     +        ' Cross ROTATION To model:',IROTR
          WRITE (6,FMT='(/,A,2I5)') ' Default Bessel limits are:',
     +      LMINR,LSUPR
          WRITE (6,FMT='(/,A)')
     +      ' Range of lower Bessel limits from 2 to 10 tested'
          WRITE (6,FMT='(/,A,F8.3)') ' Angular step is:',DANGR
          IF(NSR1R.GT.1) WRITE (6,'(/,A,6(/,I4,3x,3F8.3,3x,3F8.3))') 
     +' LOCKed rotations: Polar and Eulerian angles', (ISR1R,
     +     (ANGNSRP(I,ISR1R),I=1,3), (ANGNSR(I,ISR1R),I=1,3),
     +                                         ISR1R=1,NSR1R)

          WRITE (6,FMT='(/,A,F8.3,A)') ' Peaks greater than ',RPTSR,
     +                                '* maximum peak height listed.'
C          WRITE (6,FMT='(/,A,F8.3)') 
C     +                       ' DELTA limit for new peak',DELTAR
          WRITE (6,FMT='(/,A,2I5)') ' Number of peaks:',NPICR
        END IF
        WRITE (6,FMT='(a,///)') ' ***********************************'
      END IF
C
      IF (ITRA.NE.0 .OR. IFIT.NE.0) THEN
        IF (ITRA.NE.0) WRITE (6,FMT='(///,a,/,a,/a)')
     +  ' ******************************************',
     +  ' ***** TRANSLATION FUNCTION REQUESTED *****',
     +  ' ******************************************'
        IF (IFIT.NE.0) WRITE (6,FMT='(///,a,/,a,/a)')
     +  ' *************************************************',
     +  ' ***** RIGID BODY FITTING FUNCTION REQUESTED *****',
     +  ' *************************************************'
        IF (TRATYP(1:2).EQ.'CO') WRITE (6,FMT='(/,A)') 
     +      ' Centred Overlap function'
        IF (TRATYP.EQ.'PT ') WRITE (6,FMT='(/,A)')
     +      ' Phased translation function without external phases'
        IF (TRATYP.EQ.'PTF') WRITE (6,FMT='(/,A)')
     +      ' Phased translation function with external phases'
        IF (TRATYP.EQ.'HL ') WRITE (6,FMT='(/,A)')
     +      ' Harada Lifchitz translation function'
        IF (TRATYP.EQ.'CC ') WRITE (6,FMT='(/,A)')
     +      ' Correlation Coefficient ( slow but effective)'
        WRITE (6,FMT='(/,a,i8)') ' Numbers of molecules to find',NMOLT
        IF(Nncs.NE.0) THEN
          WRITE (6,FMT='(/,a,10(/,25x,I3,3F8.3))') 
     +                        ' Non crystallographic translation:',
     +                      (I,TXncs(I),TYncs(I),TZncs(I),I=1,Nncs)
        END IF
C
        IF (ITRA.NE.0) THEN
          WRITE (6,FMT='(a,2f8.3)') ' Extension Resolution limit is:',
     +      DMINTT
          WRITE (6,FMT='(a,2f8.3)') ' Shannon factor is:',SHRTTR
        END IF
C
        IF (IFIT.NE.0) THEN
          WRITE (6,FMT='(a,I8)') ' Number of iterations is:',ITMAXF
          WRITE (6,FMT='(a,2f8.3)') ' Convergence limit is:',EPSNF
        END IF
C
          WRITE (6,FMT='(/,A,F8.3,A)') ' Peaks greater than ',RPTST,
     +                                '* maximum peak height listed.'
C         WRITE (6,FMT='(/,A,F8.3)') 
C    +                       ' DELTA limit for new peak(??)',DELTAR
        WRITE (6,FMT='(/,A,2I5)') ' Number of rotation peaks to check:',
     +    NPICT
        WRITE (6,FMT='(/,A)') ' Crystal Information'
        WRITE (6,FMT='(a,2f8.3)') ' Resolution limits are:',DRMINT,
     +    DRMAXT
        WRITE (6,FMT='(a,i3)') ' Orthogonalisation code is:',NCODT

        WRITE (6,FMT='(a,f8.3,f12.1)') ' F limits are:',FMINC(1),
     +    FMAXC(1)
        WRITE (6,FMT='(a,2f8.3)') ' Sharpening factor is:',TFACC(1)
C
C----    Solutions to search:
C
        WRITE (6,FMT='(//,2A)')
     +    ' Solution  Model_no   ALPHA    BETA   GAMMA      ',
     +    'TX      TY      TZ   CorrF    RFac'
        DO 390 I = 1,ISOL
          WRITE (6,FMT='(2(i4,5x),1X,8F8.3)') I,ITBT(I),ALT(I),BET(I),
     +      GAT(I),TXT(I),TYT(I),TZT(I),CRT(I),RFT(I)
  390   CONTINUE
C
        IF (IFIT.NE.0) THEN
          IF (ISF.NE.0) WRITE (6,FMT='(A)') '  Refine B factor'
          IF (IAF.NE.0) WRITE (6,FMT='(A)') '  Refine ALPHA '
          IF (IBF.NE.0) WRITE (6,FMT='(A)') '  Refine BETA '
          IF (IGF.NE.0) WRITE (6,FMT='(A)') '  Refine GAMMA '
          IF (IXF.NE.0) WRITE (6,FMT='(A)') '  Refine TX '
          IF (IYF.NE.0) WRITE (6,FMT='(A)') '  Refine TY '
          IF (IZF.NE.0) WRITE (6,FMT='(A)') '  Refine TZ '
        END IF
      END IF
C
C  ie any function where input is HKLPCK0 or TABLEi
C
C      Is HKLPCK0 set for ROTFUN TRAFUN OR FITFUN? 
C      Read NSYM and Nreflns
       call ugtenv('HKLPCK0',line)
       if (line.ne.' ') then
         UDI = 0
C            ********************************************
           CALL CCPDPN(UDI,'HKLPCK0','READONLY','U',LREC,IFAIL)
C            ********************************************
           IF(UDI.NE.0) REWIND (UDI)
           READ (UDI) AX,BX,CX,ALX,BETX,GAMX
C           write(6,*)' AX,BX,CX,ALX,BETX,GAMX',AX,BX,CX,ALX,BETX,GAMX
C
           READ (UDI) NTS,NEQPC,
     +        (((MSX(I,J,N),J=1,3),TSX(I,N),I=1,3),N=1,NEQPC)
C           write(6,*)' nts,neqpC',nts,neqpC
           IF(NTS.GT.0) READ(UDI) 
     +        ((TTX(I,ITS),I=1,3),ITS=1,NTS)
            READ (UDI) 
     +        HX,KX,LX,NXX,NYX,NZX,NMX,DMX,NRC
C            write(6,*)' HX,KX,LX,NXX,NYX,NZX,NMX,DMX,NRC',
C     +      HX,KX,LX,NXX,NYX,NZX,NMX,DMX,NRC
            IF(UDI.NE.0) CLOSE (UNIT=UDI)
C            WRITE(6,*)' nrC neqpC frpm hklpck0',nrC,neqpC
       end if 
C
C  Is TABLEi set
C
C      Is TABLEi set for ROTFUN TRAFUN OR FITFUN? 
C  Find the size of the array: (2*KMAX+1)* (IHMAX+2)* (2*LMAX+1)
       MHKLTAB = 0
       DO IMODEL = 1,4
         WRITE (FILNAM,FMT='(A5,I1)') 'TABLE',IMODEL
         call ugtenv(FILNAM,line)
         if (line.ne.' ') then
C          write(6,*)' line',line

           UDI = 0
C            ******************************************
          CALL CCPDPN(UDI,FILNAM,'READONLY','U',0,IFAIL)
C            ******************************************
C
C---- Check array sizes.
          ND = 1000
          IF(UDI.NE.0) REWIND (UDI)
                READ (UDI) (RMX(II),II=1,7),IHMAX,KMAX,LMAX,SQHMAX
c                write(6,*) ' TABLE',
c     +                     (RMX(II),II=1,7),IHMAX,KMAX,LMAX,SQHMAX
                MTX = (2*KMAX+1)* (IHMAX+2)* (2*LMAX+1)
c                write(6,*)
cc     +    ' mtx = (2*KMAX+1)* (IHMAX+2)* (2*LMAX+1) mtaa1',mtx,mtaa
c                IF(MTX.GT.MHKLTAB) MHKLTAB = MTX
                IF(MTX.GT.MHKLTAB) MHKLTAB = nint(1.1*MTX)
c                write(6,*)' mtx mhkltab',mtx,mhkltab
                IF(UDI.NE.0) CLOSE (UNIT=UDI)
         end if 
       END DO 
       RETURN
C
C  Check mtz input now
C
 395  continue
      IPRINT = 1
      IERR = -1
C
C          *****************************
      CALL LROPEN(1,'HKLIN',IPRINT,IERR)
C          *****************************
C
C          *************************************
      CALL LRASSN(1,LSPRGI,NLPRGI,LOOKUP,CTPRGI)
C  Check on labels
C if data input must set FP
        IF (ISORT .EQ.1 .AND. LOOKUP(4).LE.0) 
     +  CALL CCPERR(1,'  Program Label FP was not assigned')
C if model SFs input must set F,PHIC or A,B
        IF (ISORT .EQ.-1 
     + .AND. LOOKUP(6)* LOOKUP(7).EQ.0 
     + .AND. LOOKUP(8)* LOOKUP(9).EQ.0 ) 
     +  CALL CCPERR(1,
     + '  Neither Program Label FC/PHIC or A/B were assigned')
C 
       CELLS(1) = 0.0
C---- Get dataset info using LRIDX:
C     Notify available space
      NDATASETS = MaxSets
      CALL LRIDX(1,PNAME,XNAME,DNAME,ISETS,
     +                     DATCELL,DATWAVE,NDATASETS)
C
C---- We can only check the datasets if there is dataset
C     information in the mtz file
C
      IF (NDATASETS.GT.0) THEN
C
C---- Get the complete list of labels and types and the
C     datasets to which they belong
C
        NCOLS = NCOL
C
C       ****************************************
        CALL LRCLAB(1,CLABS,CTYPS,NCOLS)
        CALL LRCLID(1,CSETID,NCOLS)
C       ****************************************
C     Get setid of FP column and use that DATCELL as master for anisotropic analysis
        SET_INDEX = 0
        SETID = 0
        IF (LOOKUP(4).GT.0) THEN
          SETID = CSETID(LOOKUP(4))
          DO ISET = 1,NDATASETS
            IF (ISETS(ISET).EQ.SETID) THEN
              SET_INDEX = ISET
            END IF
          ENDDO
        ENDIF
C     Set output dataset and correct choice of cell
        IF (SET_INDEX.GT.0) THEN
          DO I=1,6
            CELLS(I) = DATCELL(I,SET_INDEX)
          ENDDO
        ENDIF
      ENDIF
C
      IF(CELLS(1).EQ.0) CALL LRCELL(1,CELLS)
      CALL RBFRO1(CELLS,VOL,RR)
      CALL RBRCEL(CELLAS,RVOL)
      CALL LRRSOL(1,SMIN1,SMAX1)
c        write(6,*)' SMIN,SMAX',SMIN,SMAX
c        write(6,*)' SMIN1,SMAX1',SMIN1,SMAX1
c        write(6,*)' DRMINS,DRMAXS',DRMINS,DRMAXS
       IF(SMAX.GT.SMAX1) SMAX = SMAX1
       IF(SMIN.LT.SMIN1) SMIN = SMIN1
          DRMINS = SQRT(1.0/SMAX)
          DRMAXS = SQRT(1.0/SMIN)
c        write(6,*)' CELLS',CELLS, VOL
c        write(6,*)' DRMINS,DRMAXS',DRMINS,DRMAXS
c        write(6,*)' SMIN,SMAX',SMIN,SMAX
C
C          *************************************
C
C----    Read symmetry and check
C
C          ******************************************
      CALL LRSYMI(1,NSYMP,LTYPE,NSPGRP,NAMSGP,PGNAME)
      CALL LRSYMM(1,NSYMS,RSYMS)
C          ******************************************
       NSYM = NSYMS
C----  put in some symmetry check
         IF( ( 2*NSYMP+1) .GT. NM)  WRITE(6,'(a,i4,a,i4)')
     +     ' NSYMP:',NSYMP,' -- NM (set on HKLM):',NM

         IF( ( 2*NSYMP+1) .GT. NM)  CALL CCPERR
     + (2,'Symmetry limit(2*NSYMP+1) must be =< NM - resetting it')
         NM = 2*NSYMP + 2
C
C
      NC = 1
      DO 420 ISYM = 1,NSYM
C  check for centric spacegroups.. more reflections than expected..
       IF(ABS(RSYM(1,1,ISYM) + 1.0) .LE. 0.01 .AND.
     +    ABS(RSYM(2,2,ISYM) + 1.0) .LE. 0.01 .AND.
     +    ABS(RSYM(3,3,ISYM) + 1.0) .LE. 0.01 ) NC = 2
        DO 410 I = 1,4
          DO 400 J = 1,4
            RSYM(J,I,ISYM) = RSYMS(J,I,ISYM)
  400     CONTINUE
  410   CONTINUE
  420 CONTINUE
C   Are we preparing list of crystal hkl or inputting a TABLE
       IF(ISORT.GT.0) THEN
         IF(LOOKUP(4).EQ.0) CALL CCPERR(1, 'You MUST assign FP')
         HAVSIG = LOOKUP(5).NE.0
         HAVPHI = LOOKUP(10).NE.0
         HAVFOM = LOOKUP(11).NE.0
         VOL = VOL/NSYMS
         WRITE(6,'(a,f12.1)')'  Asymmetric crystal volume:',VOL
         IF(VOLSPH .GT.VOL) 
     +   WRITE(6,*)'  Integration volume greater than this.'
C
C
       END IF
       IF(ISORT.LT.0) THEN
           ICHK1 = LOOKUP(6) + LOOKUP(7)
           ICHK2 = LOOKUP(8) + LOOKUP(9)
         IF(ICHK1.EQ.0 .AND. ICHK2.EQ.0) CALL CCPERR(1,
     +    ' You MUST assign  EITHER FC and PHIC  OR A and B ')
           IF(ICHK1.NE.0) ISORT = -1
           IF(ICHK2.NE.0) ISORT = -2
C
C            ************************************
        CALL LRINFO(1,VERSNX,NCOLS,NREFLX,RANGES)
        write(6,'(a,3(/,5x,i3,2f10.2))') ' Range of H K L',
     +  (i,ranges(1,i),ranges(2,i),i=1,3)
C            ************************************
C
         IHMAXS = NINT(RANGES(2,1))
           IF(IHMINS .NE.-1)THEN 
           IERR = 1
           WRITE(6,'(a)')' H indices must begin at H=-1'
           END IF
         IKMINS = NINT(RANGES(1,2))
         IKMAXS = NINT(RANGES(2,2))
        IKMAXS = MAX(IKMAXS,-IKMINS)
        IKMINS = -IKMAXS
         ILMINS = NINT(RANGES(1,3))
         ILMAXS = NINT(RANGES(2,3))
        ILMAXS = MAX(ILMAXS,-ILMINS)
        ILMINS = -ILMAXS
        WRITE (6,FMT='(a,///)') ' ***********************************'
         WRITE (6,FMT='(A,3(I6,I4))')
     +  ' HKL limits are:', IHMINS,IHMAXS,IKMINS,IKMAXS,ILMINS,ILMAXS
        WRITE (6,FMT='(a,///)') ' ***********************************'
       END IF
C  count number of likely reflections for SORTFUN dimension
      NRC = 0
   25 CONTINUE
C
C          ************************
      CALL LRREFF(1,RESL,ADATA,EOF)
C          ************************
C
      IF (EOF) GO TO 35
      CALL LRREFM(1,LOGMSS)
C   Don't keep reflections outside highest resolution cut off.
      IF(RESL.GT.SMAX) GO TO 25
      IF (LOGMSS(4)) GO TO 25
      IF (adata(4).LE.0.0) GO TO 25
      IF (HAVSIG) THEN
C       SIGFP assigned
        IF (LOGMSS(5)) GO TO 25
        IF (ADATA(5).LE.0.0) GO TO 25
      END IF
      IF (HAVPHI) THEN
C       PHI assigned
        PHI = 0.0
        IF (LOGMSS(10)) GO TO 25
      END IF
      NRC = NRC + 1
      GO TO 25
   35 CONTINUE
      CALL LRREWD(1)
         NRCC = NINT(0.6667*PI*SMAX**1.5 /( RVOL*NSYM)) + 1000
C         NRC = NC* NRC + 1000
C         NRCC = NC* NRCC + 1000
         NRC = nint(1.1*NC* NRC) + 1000 
         NRCC = nint(1.1*NC* NRCC) + 1000 
c         WRITE(6,*) ' Reflection count+ and estimate',NRC,NRCC
C
      END
C     ================================================
      SUBROUTINE RECNDO(ITAB,NTAB,UDI,ND,NR,MT,II,RR,CC)
C     =============================================
C        CALL RECNDO(itab,ntab,UDI,ND,NR,MT,II(1),RR(1),CC(1))
C
C     .. Scalar Arguments ..
      INTEGER ITAB,NTAB,MT,ND,NR,UDI
C     ..
C     .. Array Arguments ..
      COMPLEX CC(NR+MT)
      REAL RR(2*ND)
      INTEGER II(ND+NR)
C     ..
C     .. Scalars in Common ..
      REAL A,ALPHA,B,BETA,C,GAMMA
      INTEGER KPRT,NCODE,NEQ,NEQP
C     ..
C     .. Arrays in Common ..
      REAL TSS,RF,RO
      INTEGER MSS
C     ..
C     .. Local Scalars ..
      REAL AL,BE,GA,SQHMAX,TX,TY,TZ
      INTEGER HMAX,I,IACTUAL,IMOL,KMAX,LMAX,MTA,NMOL,NRA
C     ..
C     .. Local Arrays ..
      REAL RX(9)
C     ..
C     .. External Subroutines ..
      EXTERNAL FIXMOL,GENDD,GENRED,LECTAB,SETMAT
C     ..
C     .. Common blocks ..
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /IOPRG/KPRT
      COMMON /ORTM/RO(9),RF(9),NCODE
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IACTUAL = 0
      IF (KPRT.NE.0) WRITE (6,FMT=6000)
C
      DO 10 I = 1,9
        RX(I) = RF(I)
   10 CONTINUE
C
C          ********************
      CALL GENRED(NR,NRA,II(1))
C          ********************
C
      IF (ND.GT.NRA) ND = NRA
C The number of tables to be output into a single HKLPCKi file
      NMOL = NTAB
C     NMOL=NTAB always = 1
C
      DO 20 I = 1,NRA
        CC(I) = (0.0,0.0)
   20 CONTINUE
C
      IF (KPRT.NE.0) WRITE (6,FMT=*)
      IF (KPRT.NE.0) WRITE (6,FMT=*) ' POSITIONAL PARAMETERS'
C
      IMOL = 1
C
   30  AL = 0.0
       BE = 0.0
       GA = 0.0
       TX = 0.0
       TY = 0.0
       TZ = 0.0
C
      IF (KPRT.NE.0) WRITE (6,FMT='(I5,3F10.3,3F10.6)') ITAB,AL,BE,
     +    GA,TX,TY,TZ
C
C Here imol = 1 so iactual = itab - if several models
C are being put into one HKLPCKi file we loop around 30
       IF (ITAB.NE.IACTUAL) THEN
C
        IACTUAL = ITAB - 1 + IMOL
        IF(IACTUAL.NE.0) REWIND (IACTUAL)
        READ (IACTUAL) A,B,C,ALPHA,BETA,GAMMA,NCODE,HMAX,KMAX,LMAX,
     +       SQHMAX
        MTA = (2*KMAX+1)* (HMAX+2)* (2*LMAX+1)
C        IF (NRA+MTA.GT.NR+MT) GO TO 50
        IF (NRA.GT.NR .OR. MTA.GT.MT) GO TO 50
C
C            *************************************
        CALL LECTAB(IACTUAL,HMAX,KMAX,LMAX,CC(1+NRA))
C            *************************************
C
        DO 40 I = 1,9
          RF(I) = RX(I)
   40   CONTINUE
       END IF
C
C   No way to set AL,BE,etc Ne 0, so this is a complicated way to get unit matrices!
C          ****************************************************
      CALL SETMAT(AL,BE,GA,TX,TY,TZ)
      SIGNF = 1.0
c      SUBROUTINE FIXMOL(HMAX,KMAX,LMAX,NRA,MEQ,HKLS,FF,FT,SIGNF)
      CALL FIXMOL(HMAX,KMAX,LMAX,NRA,NEQP,II(1),CC(1),CC(1+NRA),SIGNF)
C          ****************************************************
C
      IMOL = IMOL + 1
      IF (IMOL.LE.NMOL) GO TO 30
C
C          ******************************************************
      CALL GENDD(UDI,NRA,ND,II(1),II(1+NRA),RR(1),RR(1+ND),CC(1))
C          ******************************************************
C
      RETURN
C
   50 WRITE (6,FMT=6002) NRA,NR,MTA+NRA,MT+NR
C
C          ******************************************
      CALL CCPERR(1,'Reset ROTING_NR, ROTING_MC')
C          ******************************************
C
 6000 FORMAT (/' ****** S/R RECNDO ******')
 6002 FORMAT
     + (' > S/R RECNDO   ROTING_MR(required)',I10,'  NR(set)',I10,/,
     +  '                ROTING_MC(required)',I10,' ?MC(set)',I10)
      END
C
C

C     ===================================
       SUBROUTINE REFFO(T2,ND,HKLO)
C     ===================================
C
C     .. Scalar Arguments ..
      INTEGER ND,NG,T2
C     ..
C     .. Array Arguments ..
      INTEGER HKLO(ND)
      LOGICAL TEST
C     ..
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,DMAX,DMIN,DRMAX,DRMIN
      INTEGER HLW,HUP,KLW,KPRT,KUP,LLW,LUP,NRA,NXYZ
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      REAL FUZZP,SQH,SQHMAX,SQHSUP
      INTEGER HM,H,HMIN,HMAX,HRMAX,I,K,KRMAX,L,LRMAX,M,MULT,NRT,NTOT
C     ..
C     .. External Subroutines ..
      EXTERNAL INDEXM,UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD,SQRT
C     ..
C     .. Common blocks ..
      COMMON /CELD/AD,BD,CD,BID2(16)
      COMMON /DFFTT/HLW,HUP,KLW,KUP,LLW,LUP,NRA,NXYZ
      COMMON /IOPRG/KPRT
      COMMON /RESO/DRMAX,DRMIN,DMAX,DMIN,BID1(2)
      COMMON /STAR/A11,A21,A22,A31,A32,A33
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA FUZZP/1.0001/
C     ..
C
C
      HLW = 0
      HUP = 0
      KLW = 0
      KUP = 0
      LLW = 0
      LUP = 0
      NRA = 0
      NTOT = 0
      NRT  = 0
      SQHMAX = FUZZP/DRMIN**2
C
C          ****************************
      CALL INDEXM(DRMIN,AD,BD,CD,HMAX,KMAX,LMAX)
C          ****************************
C
      HMIN = 0
      KMIN = -KMAX
      LMIN = -LMAX
      INDEX = 0
      J = 0
      NTOT = 0
CC
C  Re-use the scratch file T2..
C
      IF(T2.NE.0) REWIND (T2)
C
C---- pacote
C
      DO 30 L = LMIN,LMAX
        DO 20 K = KMIN,KMAX
          DO 10 H = HMIN,HMAX
C
C                ************************
            CALL SYMPAC(H,K,L,INDEX,TEST)
C                ************************
C
            IF (.NOT.TEST) GO TO 10
            SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 
     +         + (A11*H)**2
            IF (SQH.GT.SQHMAX) GO TO 10
C
C                ***********************
            CALL PAC3(H,K,L,INDEX)
            CALL MULTES(H,K,L,MULT,IRES)
C            CALL PAC4(H,K,L,MULT,IND)
C                ***********************
        NRT = NRT + MULT
        IF (H.LT.HLW) HLW = H
        IF (H.GT.HUP) HUP = H
        IF (K.LT.KLW) KLW = K
        IF (K.GT.KUP) KUP = K
        IF (L.LT.LLW) LLW = L
        IF (L.GT.LUP) LUP = L
        IF (SQH.GT.SQHSUP) SQHSUP = SQH
        NRA = NRA + 1
c        IF (NRA.GT.NG) GO TO 50
c        HKL(NRA) = HKLO(I)
C
            J = J + 1
            HKLO(J) = INDEX
C
            IF (J.EQ.ND) THEN
              WRITE (T2) J,HKLO
              NTOT = NTOT + J
              J = 0
            END IF
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
      IF (NTOT.NE.0) THEN
        IF (J.NE.0) WRITE (T2) J,HKLO
      ELSE
        WRITE (T2) J, (HKLO(I),I=1,J)
        ND = J
      END IF
C
      NTOT = NTOT + J
      WRITE(*,*) 'Total of',NTOT,' items written to TEMP2'
C
      NRT = NRT/2 + MOD(NRT,2)
      DMIN = 1/SQRT(ABS(SQHSUP))
C          *******************************
      CALL INDEXM(DRMIN,AD,BD,CD,HRMAX,KRMAX,LRMAX)
C          *******************************
      IF (KPRT.NE.0) WRITE (6,FMT=6000) NRA,NTOT,NRT
      IF (KPRT.NE.0) WRITE (6,FMT=6002) DRMIN,HRMAX,KRMAX,LRMAX
      IF (KPRT.NE.0) WRITE (6,FMT=6004) DMIN,HLW,HUP,KLW,KUP,LLW,LUP
      RETURN
C
C 
 6000 FORMAT (/,
     +' Coefficients used (',I10,') out of',I10,
     +' on the Input file',/,
     +' Number of Reflections when extended to P1:',I10)
 6002 FORMAT (
     +' Requested Resolution:',F10.3,/,
     +' Maximal Indices according to requested resolution:',3I5)
 6004 FORMAT (
     +' Data Resolution:',F10.3,/,
     +' Maximal indices in data',/,
     +' Hmin, Hmax:',2I5,', Kmin, Kmax:',2I5,', Lmin, Lmax:',2I5)
 6006 FORMAT (' > S/R REFFO < INCOMPATIBLE DIMENSIONS. M, ND:',2I10)
 6008 FORMAT (' > S/R REFFO < No. of reflections exceeds',I10,/,
     + ' The limit equals TABLING_MI - TABLING_MC; reset TABLING_MI')
      END
C
C======================
C
C          *******************************
c      CALL INDEXM(DRMIN,HRMAX,KRMAX,LRMAX)
cC          *******************************
cC
c      HLW = 0
c      HUP = 0
c      KLW = 0
c      KUP = 0
c      LLW = 0
c      LUP = 0
c      NRA = 0
c      NTOT = 0
c      NRT  = 0
c      SQHMAX = FUZZP/DRMIN**2
c      SQHSUP = 0.0
cC
c      REWIND (T2)
c   10 READ (T2,END=30) M,HKLO
c      IF (M.GT.ND) GO TO 40
c      NTOT = NTOT + M
cC
c      DO 20 I = 1,M
cC
cC            **************************
c        CALL UNPAC4(H,K,L,MULT,HKLO(I))
cC            **************************
cC
c        SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
c        IF (SQH.GT.SQHMAX) GO TO 20
c        NRT = NRT + MULT
c        IF (H.LT.HLW) HLW = H
c        IF (H.GT.HUP) HUP = H
c        IF (K.LT.KLW) KLW = K
c        IF (K.GT.KUP) KUP = K
c        IF (L.LT.LLW) LLW = L
c        IF (L.GT.LUP) LUP = L
c        IF (SQH.GT.SQHSUP) SQHSUP = SQH
c        NRA = NRA + 1
c        IF (NRA.GT.NG) GO TO 50
c        HKL(NRA) = HKLO(I)
c   20 CONTINUE
cC
c      GO TO 10
c   30 IF (NRA.EQ.0) GO TO 60
c      NRT = NRT/2 + MOD(NRT,2)
cc      DMIN = 1/SQRT(ABS(SQHSUP))
c      IF (KPRT.NE.0) WRITE (6,FMT=6000) NRA,NTOT,NRT
c      IF (KPRT.NE.0) WRITE (6,FMT=6002) DRMIN,HRMAX,KRMAX,LRMAX
c      IF (KPRT.NE.0) WRITE (6,FMT=6004) DMIN,HLW,HUP,KLW,KUP,LLW,LUP
c      RETURN
cC
c   40 WRITE (6,FMT=6006) M,ND
cC
cC          **********************************************************
c      CALL CCPERR(1,' > s/r reffo < incompatible dimensions. m, nd:')
cC          **********************************************************
cC
c   50 WRITE (6,FMT=6008) NG
cC
cC          ****************************************************
c      CALL CCPERR(1,' > s/r reffo < no. of reflections too large')
c   60 CALL CCPERR(1,' > s/r reffo < no reflection selected')
cC          ****************************************************
cC 
c 6000 FORMAT (/,
c     +' Coefficients used (',I10,') out of',I10,
c     +' on the Input file',/,
c     +' Number of Reflections when extended to P1:',I10)
c 6002 FORMAT (
c     +' Requested Resolution:',F10.3,/,
c     +' Maximal Indices according to requested resolution:',3I5)
c 6004 FORMAT (
c     +' Data Resolution:',F10.3,/,
c     +' Maximal indices in data',/,
c     +' Hmin, Hmax:',2I5,', Kmin, Kmax:',2I5,', Lmin, Lmax:',2I5)
c 6006 FORMAT (' > S/R REFFO < INCOMPATIBLE DIMENSIONS. M, ND:',2I10)
c 6008 FORMAT (' > S/R REFFO < No. of reflections exceeds',I10,/,
c     + ' The limit equals TABLING_MI - TABLING_MC; reset TABLING_MI')
c      END
c
C     =============================
c      SUBROUTINE REFFT(NT,NRA,MEQ,HKLS)
cC     =================================
cC
cC     .. Scalar Arguments ..
c      INTEGER MEQ,NRA,NT
cC     ..
cC     .. Array Arguments ..
c      INTEGER HKLS(NRA,MEQ)
cC     ..
cC     .. Scalars in Common ..
c      REAL A11,A21,A22,A31,A32,A33,BID2,DMIN,DRMAX,DRMIN
c      INTEGER HLOW,KLOW,KPRT,LLOW,NEQ,NEQP,NH,NK,NL
cC     ..
cC     .. Arrays in Common ..
c      REAL TSS,BID3
c      INTEGER MSS
cC     ..
cC     .. Local Scalars ..
c      REAL FUZZP,SQH,SQHMAX,SQHSUP
c      INTEGER H,HLW,HS,HU,HUP,IND,INDX,IR,IS,IU,K,KLW,KS,KU,KUP,L,LLW,
c     +        LS,LU,LUP,MT
c      LOGICAL FRIDEL
cC     ..
cC     .. External Subroutines ..
c      EXTERNAL PAC3,PAKG,UNPAC3
cC     ..
cC     .. Intrinsic Functions ..
cc      INTRINSIC SQRT
cC     ..
cC     .. Common blocks ..
c      COMMON /IOPRG/KPRT
c      COMMON /PAKO/HLOW,KLOW,LLOW,NH,NK,NL
cc      COMMON /RESO/DRMAX,DRMIN,BID2,DMIN,BID3(2)
cc      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
c      COMMON /STAR/A11,A21,A22,A31,A32,A33
cC     ..
cC     .. Save statement ..
c      SAVE
cC     ..
cC     .. Data statements ..
c      DATA FUZZP/1.0001/
cC     ..
cC
c      HLW = 0
c      HUP = 0
c      KLW = 0
c      KUP = 0
c      LLW = 0
cc      LUP = 0
c      INDX = 0
c      SQHMAX = FUZZP/DMIN**2
c      SQHSUP = 0.0
cC
c      DO 30 IR = 1,NRA
c        DO 20 IS = 1,NEQP
cC
cC              ****************************
c          CALL UNPAC3(HS,KS,LS,HKLS(IR,IS))
cC              ****************************
cC
c          H = HS
c          K = KS
c          L = LS
c          SQH = (A31*H+A32*K+A33*L)**2 + 
c     +          (A21*H+A22*K)**2 + (A11*H)**2
c          IF (SQH.GT.SQHMAX) GO TO 20
cC
cC---- pacote
cC
c          FRIDEL = .FALSE.
cC
c          IF (H.LT.0) THEN
c            FRIDEL = .TRUE.
c          ELSE IF (H.EQ.0) THEN
c            IF (L.GT.0) THEN
c              FRIDEL = .TRUE.
c            ELSE IF (L.EQ.0) THEN
c              IF (K.GT.0) FRIDEL = .TRUE.
c            END IF
c          END IF
cC
c          IF (FRIDEL) THEN
c              H = -H
c              K = -K
c              L = -L
c          END IF
cC
cC              ***************
c          CALL PAC3(H,K,L,IND)
cC              ***************
cC
c          IF (IND.GT.INDX) INDX = IND
c          IF (H.LT.HLW) HLW = H
c          IF (H.GT.HUP) HUP = H
c          IF (K.LT.KLW) KLW = K
c          IF (K.GT.KUP) KUP = K
c          IF (L.LT.LLW) LLW = L
c          IF (L.GT.LUP) LUP = L
c          IF (SQH.GT.SQHSUP) SQHSUP = SQH
c          IF (IS.EQ.NEQP) GO TO 20
cC
c          DO 10 IU = IS + 1,NEQP
cC
cC                ****************************
c            CALL UNPAC3(HU,KU,LU,HKLS(IR,IU))
cC                ****************************
cC
c            H = HS-HU
c            K = KS-KU
c            L = LS-LU
c            SQH = (A31*H+A32*K+A33*L)**2 + 
c     +            (A21*H+A22*K)**2 + (A11*H)**2
c            IF (SQH.GT.SQHMAX) GO TO 10
c            FRIDEL = .FALSE.
cC
c            IF (H.LT.0) THEN
cc              FRIDEL = .TRUE.
c            ELSE IF (H.EQ.0) THEN
cC
c              IF (L.GT.0) THEN
c                FRIDEL = .TRUE.
c              ELSE IF (L.EQ.0) THEN
c                IF (K.GT.0) FRIDEL = .TRUE.
c              END IF
c            END IF
cC
c            IF (FRIDEL) THEN
c                H = -H
c                K = -K
c                L = -L
c            END IF
cC
cC                ***************
c            CALL PAC3(H,K,L,IND)
cC                ***************
cC
c            IF (IND.GT.INDX) INDX = IND
c            IF (H.LT.HLW) HLW = H
c            IF (H.GT.HUP) HUP = H
c            IF (K.LT.KLW) KLW = K
c            IF (K.GT.KUP) KUP = K
c            IF (L.LT.LLW) LLW = L
c            IF (L.GT.LUP) LUP = L
c            IF (SQH.GT.SQHSUP) SQHSUP = SQH
c   10     CONTINUE
c   20   CONTINUE
c   30 CONTINUE
cC
c      HLOW = HLW
c      KLOW = KLW
c      LLOW  = LLW
c      NH   = HUP-HLW+1
c      NK   = KUP-KLW+1
c      NL   = LUP-LLW+1
C
C          ******************
c      CALL UNPAC3(H,K,L,INDX)
c      CALL PAKG(H,K,L,MT)
cC          ******************
cC
c      DMIN = 1/SQRT(ABS(SQHSUP))
c      IF (KPRT.NE.0) 
c     +    WRITE (6,FMT=6000) MT,HLW,HUP,KLW,KUP,LLW,LUP,DMIN
c      IF (MT.GT.NT) GO TO 40
c      NT = MT
c      RETURN
cC
c   40 WRITE (6,FMT=6002) MT
cC
cC          ***************************************
c      CALL CCPERR(1, 'Reset TRAING_MT, TRAING_MRT')
cC          ***************************************
cC
c 6000 FORMAT (/' THERE ARE',I10,' COEFFICIENTS. MAXIMAL INDICES',/' HM',
c     +       'IN, HMAX:',2I5,', KMIN, KMAX:',2I5,', LMIN, LMAX:',2I5,
c     +       /' RESOLUTION:',F10.3)
c 6002 FORMAT (' > S/R REFFT < SET MRT/MT >',I10)
c      END
C
C
C     =============================
      SUBROUTINE RHKL1(NRA,PH,NK,NZ,HS,HKLO,WW,FC)
C     ============================================
C
C     .. Scalar Arguments ..
      INTEGER HS,NK,NRA,NZ,PH
C     ..
C     .. Array Arguments ..
      COMPLEX FC(NRA),WW(PH,NK,NZ)
      INTEGER HKLO(NRA)
C     ..
C     .. Scalars in Common ..
      INTEGER HMAX,KMAX,LMAX,NEQ,NEQP
C     ..
C     .. Arrays in Common ..
      REAL TSS
      INTEGER IBID1,MSS
C     ..
C     .. Local Scalars ..
      COMPLEX F,FF,TWOPII,UNO
      REAL PR
      INTEGER H,HF,HH,I,IIND,K,KK,KL,KM,L,LL,LM,MULT,N,NN
      LOGICAL FRIDEL
C     ..
C     .. Local Arrays ..
      INTEGER HKL(48)
C     ..
C     .. External Subroutines ..
      EXTERNAL PAC3,UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC CONJG,EXP,MOD,REAL
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /GRID/HMAX,KMAX,LMAX,IBID1(3)
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA TWOPII/ (0.0,6.2831853)/,UNO/ (1.0,0.0)/
C     ..
C
      DO 30 L = 1,NZ
        DO 20 K = 1,NK
          DO 10 H = 1,PH
            WW(H,K,L) = (0.0,0.0)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
      HF = HS + PH - 1
C
      DO 130 I = 1,NRA
C
C            **************************
        CALL UNPAC4(H,K,L,MULT,HKLO(I))
C            **************************
C
        F = FC(I)
        IF (MULT.EQ.1) F = REAL(F)*UNO
        FC(I) = F
        MULT = 0
C
        DO 120 N = 1,NEQP
          FRIDEL = .FALSE.
          HH = MSS(1,1,N)*H + MSS(2,1,N)*K + MSS(3,1,N)*L
          KK = MSS(1,2,N)*H + MSS(2,2,N)*K + MSS(3,2,N)*L
          LL = MSS(1,3,N)*H + MSS(2,3,N)*K + MSS(3,3,N)*L
C
C---- pacote
C
          IF (HH) 60,40,90
   40     IF (LL) 90,50,70
   50     IF (KK) 90,90,80
   60     HH = -HH
   70     LL = -LL
   80     KK = -KK
          FRIDEL = .TRUE.
   90     IF (HH.LT.HS .OR. HH.GT.HF) GO TO 120
C
C              *******************
          CALL PAC3(HH,KK,LL,IIND)
C              *******************
C
          IF (N.EQ.1) GO TO 110
C
          DO 100 NN = 1,MULT
            IF (HKL(NN).EQ.IIND) GO TO 120
  100     CONTINUE
C
  110     MULT = MULT + 1
          HKL(MULT) = IIND
          PR = -MOD(TSS(1,N)*H+TSS(2,N)*K+TSS(3,N)*L,1.0)
          FF = EXP(TWOPII*PR)*F
          IF (FRIDEL) FF = CONJG(FF)
          HH = HH - HS + 1
          KK = KK + 1
          IF (KK.LE.0) KK = KK + NK
          LL = LL + 1
          IF (LL.LE.0) LL = LL + NZ
          WW(HH,KK,LL) = FF
  120   CONTINUE
  130 CONTINUE
C
      IF (HS.GT.0) RETURN
      KM = KMAX + 1
C
      DO 140 K = 2,KM
        KL = NK + 2 - K
        WW(1,K,1) = CONJG(WW(1,KL,1))
  140 CONTINUE
C
      LM = LMAX + 1
C
      DO 150 L = 2,LM
        LL = NZ + 2 - L
        WW(1,1,L) = CONJG(WW(1,1,LL))
  150 CONTINUE
C
C---- pacote
C
      DO 170 L = 2,LM
        LL = NZ + 2 - L
        DO 160 K = 2,KM
          KL = NK + 2 - K
          WW(1,K,L) = CONJG(WW(1,KL,LL))
          WW(1,KL,L) = CONJG(WW(1,K,LL))
  160   CONTINUE
  170 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE RMX2E(ROTX,ALPHA,BETA,GAMMA,LPRINT)
C     =======================================
C
C     .. Scalar Arguments ..
      REAL ALPHA,BETA,GAMMA
C     ..
C     .. Array Arguments ..
      REAL ROTX(3,3)
C     ..
C     .. Scalars in Common ..
      INTEGER KPRT
      LOGICAL LPRINT
C     ..
C     .. Local Scalars ..
      REAL ARG,COSA,COSB,COSG,COSU,FUZZ,RTOD,SINA,SINB,SING,SINU,U
      LOGICAL PLUS,ZERO
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ATAN2,MOD,SIGN,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /IOPRG/KPRT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA FUZZ/0.0005/
C     ..
C
      ZERO = .FALSE.
      PLUS = .FALSE.
      COSB = ROTX(3,3)
      ARG = 1 - COSB**2
C
      IF (ARG.LE.FUZZ) THEN
        COSB = SIGN(1.0,COSB)
        ARG = 0.0
        IF (LPRINT) WRITE (6,FMT=6000) ARG
      END IF
C
      SINB = SQRT(ABS(ARG))
      BETA = ATAN2(SINB,COSB)*RTOD
C
      IF (ARG.EQ.0.0) THEN
        COSU = ROTX(1,1)*COSB
        SINU = -ROTX(1,2)
        U = ATAN2(SINU,COSU)*RTOD
        U = MOD(U+360,360.0)
        ALPHA = U
        GAMMA = 0.0
        ZERO = .TRUE.
        IF (COSB.GT.0.0) PLUS = .TRUE.
      ELSE
        COSA = ROTX(1,3)/SINB
        SINA = ROTX(2,3)/SINB
        ALPHA = ATAN2(SINA,COSA)*RTOD
        ALPHA = MOD(ALPHA+360,360.0)
        COSG = -ROTX(3,1)/SINB
        SING = ROTX(3,2)/SINB
        GAMMA = ATAN2(SING,COSG)*RTOD
        GAMMA = MOD(GAMMA+360,360.0)
      END IF
C
      IF (LPRINT) WRITE (6,FMT=*) 
     +  ' Euler Representation: Alpha,Beta,Gamma'
      IF (ZERO) THEN
        IF (PLUS) THEN
          IF (LPRINT) WRITE (6,FMT=*) 
     +     ' Only ALPHA+GAMMA is independent'
        ELSE
          IF (LPRINT) WRITE (6,FMT=*)
     +     ' Only ALPHA-GAMMA is independent'
        END IF
      END IF
C
      IF (LPRINT) WRITE (6,FMT='(3F10.3)') ALPHA,BETA,GAMMA
      RETURN
 6000 FORMAT (' > S/R RMX2E < ARGUMENT OF SQRT LT.ZERO:',E15.5)
      END
C
C
C     =============================
      SUBROUTINE RMX2P(ROTX,XHID,VN,LPRINT)
C     ==============================
C
C     .. Scalar Arguments ..
      REAL XHID
C     ..
C     .. Array Arguments ..
      REAL ROTX(3,3),VN(3)
C     ..
C     .. Scalars in Common ..
      INTEGER KPRT
C     ..
C     .. Local Scalars ..
      REAL ARG,CXHI,FUZZ,RTOD,SXHI,TR,VNORM
      INTEGER I,J,K
      LOGICAL LPRINT
C     ..
C     .. Local Arrays ..
      REAL EIJK(3,3,3)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ATAN2,SIGN,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /IOPRG/KPRT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA EIJK/27*0.0/,FUZZ/0.0005/
C     ..
C
      EIJK(1,2,3) = 1.0
      EIJK(3,1,2) = 1.0
      EIJK(2,3,1) = 1.0
      EIJK(1,3,2) = -1.0
      EIJK(2,1,3) = -1.0
      EIJK(3,2,1) = -1.0
      TR = 0.0
C
      DO 10 I = 1,3
        TR = ROTX(I,I) + TR
   10 CONTINUE
C
      CXHI = (TR-1)/2
      ARG = 1 - CXHI**2
C
      IF (ARG.LE.FUZZ) THEN
        CXHI = SIGN(1.0,CXHI)
        IF (LPRINT) WRITE (6,FMT=6000) ARG
        ARG = 0.0
      END IF
C
      SXHI = SQRT(ABS(ARG))
      XHID = ATAN2(SXHI,CXHI)*RTOD
C
      IF (ARG.NE.0.0) THEN
        DO 40 K = 1,3
          VN(K) = 0.0
          DO 30 J = 1,3
            DO 20 I = 1,3
              VN(K) = (ROTX(I,J)-ROTX(J,I))*EIJK(I,K,J) + VN(K)
   20       CONTINUE
   30     CONTINUE
          VN(K) = VN(K)/ (4*SXHI)
   40   CONTINUE
      ELSE
        IF (CXHI.GT.0.0) THEN
          VN(1) = 0.0
          VN(2) = 0.0
          VN(3) = 1.0
        ELSE
          DO 50 I = 1,3
            ARG = (ROTX(I,I)+1)/2
            IF (ARG.LE.0.0) THEN
              IF (LPRINT) WRITE (6,FMT=6000) ARG
              ARG = 0.0
            END IF
            VN(I) = SQRT(ABS(ARG))
   50     CONTINUE
          IF (VN(3).NE.0.0) THEN
            VN(1) = SIGN(VN(1),ROTX(1,3))
            VN(2) = SIGN(VN(2),ROTX(2,3))
          ELSE IF (VN(2).NE.0.0) THEN
            VN(1) = SIGN(VN(1),ROTX(1,2))
          END IF
        END IF
      END IF
C   Check if PHI is defined?
      PHI = 999.0
      IF(VN(3).LT. 1.0-FUZZ) PHI = ATAN2(VN(2),VN(1))*RTOD
      OMEGA = ATAN2(SQRT(VN(1)*VN(1)+(VN(2)*VN(2))),VN(3))*RTOD
C
      VNORM = SQRT(ABS(VN(1)**2+VN(2)**2+VN(3)**2))
      IF (LPRINT) THEN
       WRITE (6,FMT='(A,3(/,3F10.3))')
     + ' Rotation Matrix',ROTX
       WRITE (6,FMT='(A,3F10.3,3E15.5,F10.6)') 
     + ' Polar angles Chi Omega Phi', XHID,OMEGA, PHI
       WRITE (6,FMT='(A,3E15.5,F10.6)') 
     +  ' Versor and Norm??',vn,VNORM
       END IF
      RETURN
 6000 FORMAT (' > S/R RMX2P < ARGUMENT OF SQRT LT.ZERO:',E15.5)
      END
C
C
C     =============================
      SUBROUTINE RMX2PP(ROTX,XHID,OMEGA, PHI,VN,LPRINT)
C     ==============================
C
C     .. Scalar Arguments ..
      REAL XHID,OMEGA, PHI
C     ..
C     .. Array Arguments ..
      REAL ROTX(3,3),VN(3)
C     ..
C     .. Scalars in Common ..
      INTEGER KPRT
C     ..
C     .. Local Scalars ..
      REAL ARG,CXHI,FUZZ,RTOD,SXHI,TR,VNORM
      INTEGER I,J,K
      LOGICAL LPRINT
C     ..
C     .. Local Arrays ..
      REAL EIJK(3,3,3)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ATAN2,SIGN,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /IOPRG/KPRT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA EIJK/27*0.0/,FUZZ/0.0005/
C     ..
C
      EIJK(1,2,3) = 1.0
      EIJK(3,1,2) = 1.0
      EIJK(2,3,1) = 1.0
      EIJK(1,3,2) = -1.0
      EIJK(2,1,3) = -1.0
      EIJK(3,2,1) = -1.0
      TR = 0.0
C
      DO 10 I = 1,3
        TR = ROTX(I,I) + TR
   10 CONTINUE
C
      CXHI = (TR-1)/2
      ARG = 1 - CXHI**2
C
      IF (ARG.LE.FUZZ) THEN
        CXHI = SIGN(1.0,CXHI)
        IF (LPRINT) WRITE (6,FMT=6000) ARG
        ARG = 0.0
      END IF
C
      SXHI = SQRT(ABS(ARG))
      XHID = ATAN2(SXHI,CXHI)*RTOD
C
      IF (ARG.NE.0.0) THEN
        DO 40 K = 1,3
          VN(K) = 0.0
          DO 30 J = 1,3
            DO 20 I = 1,3
              VN(K) = (ROTX(I,J)-ROTX(J,I))*EIJK(I,K,J) + VN(K)
   20       CONTINUE
   30     CONTINUE
          VN(K) = VN(K)/ (4*SXHI)
   40   CONTINUE
      ELSE
        IF (CXHI.GT.0.0) THEN
          VN(1) = 0.0
          VN(2) = 0.0
          VN(3) = 1.0
        ELSE
          DO 50 I = 1,3
            ARG = (ROTX(I,I)+1)/2
            IF (ARG.LE.0.0) THEN
              IF (LPRINT) WRITE (6,FMT=6000) ARG
              ARG = 0.0
            END IF
            VN(I) = SQRT(ABS(ARG))
   50     CONTINUE
          IF (VN(3).NE.0.0) THEN
            VN(1) = SIGN(VN(1),ROTX(1,3))
            VN(2) = SIGN(VN(2),ROTX(2,3))
          ELSE IF (VN(2).NE.0.0) THEN
            VN(1) = SIGN(VN(1),ROTX(1,2))
          END IF
        END IF
      END IF
C   Check if PHI is defined?
      PHI = 999.0
      IF(VN(3).LT. 1.0-FUZZ) PHI = ATAN2(VN(2),VN(1))*RTOD
      OMEGA = ATAN2(SQRT(VN(1)*VN(1)+(VN(2)*VN(2))),VN(3))*RTOD
C
      VNORM = SQRT(ABS(VN(1)**2+VN(2)**2+VN(3)**2))
      IF (LPRINT) THEN
       WRITE (6,FMT='(A,3(/,3F10.3))')
     + ' Rotation Matrix',ROTX
       WRITE (6,FMT='(A,3F10.3,3E15.5,F10.6)') 
     + ' Polar angles Chi Omega Phi', XHID,OMEGA, PHI
       WRITE (6,FMT='(A,3E15.5,F10.6)') 
     +  ' Versor and Norm??',vn,VNORM
       END IF
      RETURN
 6000 FORMAT (' > S/R RMX2P < ARGUMENT OF SQRT LT.ZERO:',E15.5)
      END
C     =============================
      SUBROUTINE RMXE(ALPHA,BETA,GAMMA,ROTE,LPRINT)
C     ======================================
C
C     .. Scalar Arguments ..
      REAL ALPHA,BETA,GAMMA
C     ..
C     .. Array Arguments ..
      REAL ROTE(3,3)
C     ..
C     .. Scalars in Common ..
      INTEGER KPRT
      LOGICAL LPRINT
C     ..
C     .. Local Scalars ..
      REAL ALF,BET,DTOR,GAM
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC COS,SIN
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /IOPRG/KPRT
C     ..
      SAVE
C     ..
C
      IF (LPRINT) WRITE (6,FMT='(A,3F10.3)') 
     +   ' EULER MATRIX: ALPHA,BETA,GAMMA: ',ALPHA,BETA,GAMMA
C
      ALF = DTOR*ALPHA
      BET = DTOR*BETA
      GAM = DTOR*GAMMA
C
      COSA = COS(ALF)
      COSB = COS(BET)
      COSG = COS(GAM)
      SINA = SIN(ALF)
      SINB = SIN(BET)
      SING = SIN(GAM)
C
      ROTE(1,1) = COSA*COSB*COSG - SINA*SING
      ROTE(1,2) = -COSA*COSB*SING - SINA*COSG
      ROTE(1,3) = COSA*SINB
      ROTE(2,1) = SINA*COSB*COSG + COSA*SING
      ROTE(2,2) = -SINA*COSB*SING + COSA*COSG
      ROTE(2,3) = SINA*SINB
      ROTE(3,1) = -SINB*COSG
      ROTE(3,2) = SINB*SING
      ROTE(3,3) = COSB
      RETURN
      END
C
C     =============================
      SUBROUTINE RMXP(OMEGA,PHI,CHI,ROTE,LPRINT)
C     ======================================
C
C    Generate rotation matrix from Polar angles
C     .. Scalar Arguments ..
      REAL OMEGA,PHI,CHI
C     ..
C     .. Array Arguments ..
      REAL ROTE(3,3)
C     ..
C     .. Scalars in Common ..
      INTEGER KPRT
      LOGICAL LPRINT
C     ..
C     .. Local Scalars ..
      REAL OMEGAR,PHIR,DTOR,CHIR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC COS,SIN
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /IOPRG/KPRT
C     ..
      SAVE
C     ..
C
      OMEGAR = DTOR*OMEGA
      PHIR = DTOR*PHI
      CHIR = DTOR*CHI

      IF (LPRINT) WRITE (6,FMT='(A,3F10.3)') 
     +   ' Polar MATRIX: Omega, Phi, Chi: ', OMEGA,PHI,CHI
C
C ( l**2+(m**2+n**2)cos k     lm(1-cos k)-nsin k        nl(1-cos k)+msin k   )
C ( lm(1-cos k)+nsin k        m**2+(l**2+n**2)cos k     mn(1-cos k)-lsin k   )
C ( nl(1-cos k)-msin k        mn(1-cos k)+lsin k        n*2+(l**2+m**2)cos k )

C
      COSK = COS(CHIR)
      SINK = SIN(CHIR)
      DCL  = SIN(OMEGAR)*COS(PHIR)
      DCM  = SIN(OMEGAR)*SIN(PHIR)
      DCN  = COS(OMEGAR)
C
      ROTE(1,1) = DCL*DCL + (DCM*DCM +DCN*DCN)*COSK
      ROTE(2,2) = DCM*DCM + (DCN*DCN +DCL*DCL)*COSK
      ROTE(3,3) = DCN*DCN + (DCL*DCL +DCM*DCM)*COSK
      ROTE(1,2) = DCL*DCM*(1.0-COSK) -DCN*SINK
      ROTE(1,3) = DCN*DCL*(1.0-COSK) +DCM*SINK
      ROTE(2,1) = DCL*DCM*(1.0-COSK) +DCN*SINK
      ROTE(2,3) = DCM*DCN*(1.0-COSK) -DCL*SINK
      ROTE(3,1) = DCN*DCL*(1.0-COSK) -DCM*SINK
      ROTE(3,2) = DCM*DCN*(1.0-COSK) +DCL*SINK
      RETURN
      END
C
C
C
C     =====================================================
      SUBROUTINE ROTATS(XHE,MHE,MI,MR,MC,MD,II,RR,CC,DD)
C     =====================================================
C
C     .. Scalar Arguments ..
      INTEGER MC,MD,MHE,MI,MR,XHE
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION DD(MD)
      COMPLEX CC(MC)
      REAL RR(MR)
      INTEGER II(MI)
C     ..
C     .. Scalars in Common ..
      INTEGER LMIN,LSUP,NA,NB,NDIM01,NDIM1,NDIM10,NDIM2,NDIMT,NG,NL,NLT,
     +        NQ,NSR1,NSR2,NSYM1,NSYM2,NXLS
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      REAL B
      INTEGER IC2,IC3,ID2,ID3,ID4,IR2,IR3,IR4,IR5,IXL,N,T1,T2
      LOGICAL FIRST
C     ..
C     .. External Subroutines ..
      EXTERNAL CLMMS,DIMRS,DLMMS,FILLIN,FUORI,MDHFT,TELMN,TDLMM
C     ..
C     .. Common blocks ..
      COMMON /DROTT/NXLS,NL,NQ,NLT,NA,NB,NG,LMIN,LSUP,NDIMT,NDIM10,NDIM01
      COMMON /XALS/BID1(2),NSYM1,NSYM2,NSR1,NSR2,NDIM1,NDIM2
C     ..
      SAVE
C     .. Data statements ..
      DATA T1,T2/0,0/
C     ..
C
C          *****************************
      CALL DIMRS(XHE,MHE,MI,MR,MC,MD,RR)
C          *****************************
C
      IR2 = 4*NB + 1
      IR3 = IR2 + NB
      IR4 = IR3 + NG
      IR5 = IR4 + NA
      ID2 = 1 + NLT
      ID3 = ID2 + NLT
      ID4 = ID3 + NLT
C
      IF (NSR1.GT.0) THEN
C
C               ***************************************
        IFAIL = 0
        CALL CCPDPN(T1,'TEMP1','SCRATCH','U',80,IFAIL)
C               ***************************************
C
cpjx: I don't think setting nxls = 2 is correct?
cpjx        NXLS = 2
        IXL  = 1
        IC2  = 1+NDIM1
        IC3 = NL*NQ + IC2
C
C            ***********************************************
        CALL TDLMM(IXL,II(1),RR(IR5),CC(1),DD(1))
        CALL TELMN(IXL,XHE,T1,LSUP,NQ,CC(1),CC(IC2),CC(IC3))
C            ***********************************************
C
        IF(XHE.NE.0) CLOSE (UNIT=XHE)
        XHE = T1
        IF (NSR2.EQ.0) NDIMT = NDIM10
      END IF
C
      IF (NSR2.GT.0) THEN
C
C            **************************************
        IFAIL = 0
        CALL CCPDPN(T2,'TEMP2','SCRATCH','U',80,IFAIL)
C            **************************************
C
        NXLS = 2
        IXL  = 2
        IC2  = 1+NDIM2
        IC3 = NL*NQ + IC2
C
C            ***********************************************
        CALL TDLMM(IXL,II(1),RR(IR5),CC(1),DD(1))
        CALL TELMN(IXL,MHE,T2,LSUP,NQ,CC(1),CC(IC2),CC(IC3))
C            ***********************************************
C
        IF(MHE.NE.0) CLOSE (UNIT=MHE)
        MHE = T2
        IF (NSR1.EQ.0) NDIMT = NDIM01
      END IF
C
      IC2 = 1 + NDIMT
      IC3 = NL*NQ + IC2
C
C          ********************************************
      CALL CLMMS(XHE,MHE,LSUP,NQ,CC(1),CC(IC2),CC(IC3))
C          ********************************************
C
      FIRST = .TRUE.
C
      DO 10 N = IR2,IR2 + NB - 1
        B = RR(N)
C
C            ******************************************************
        CALL DLMMS(B,NDIMT,LSUP,II(1),RR(IR5),DD(1),DD(ID2),DD(ID3),
     +             DD(ID4))
        CALL FILLIN(NDIMT,NG,NA,RR(IR5),CC(1),CC(IC2))
        CALL MDHFT(CC(IC2),NA,NG)
        CALL FUORI(NG,NA,NB,RR,RR(IR2),RR(IR3),RR(IR4),CC(IC2),FIRST)
C            ******************************************************
C
   10 CONTINUE
C
      RETURN
      END
C
C     =================
      SUBROUTINE ROTING
C     =================
C
C  nraa is a rough estimate of the number of reflections needed for HKLPCK1
C  mtaa is ~  [hmax+2)*(2*lmax+1)*(2*kmax+1) for the TABLE list
C
C   if option=gene
C   NR=min(mi-nd,mc-mt)
C    where nd=1000
C       MT=dimension of interpolation array
C
C     .. Parameters ..
      INTEGER MI,MR,MC,MD,NRAA,MTAA,NFIX,MSR1R
CBIG      PARAMETER (MI=600000,MR=600000,MC=2900000,MD=20000)
C      These dimensions don't normally overflow (says EJD)
C       PARAMETER (MI=500000,MR=600000,MC=2200000,MD=20000)
C     ..
      PARAMETER (NFIX=64,MSR1R=6)
C
C     ..
       CHARACTER TYPE(4), LENG(4)*10
       INTEGER LENDEF(4)
      COMMON /SETSIZE/ NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB 
C
C     .. External Subroutines ..
      EXTERNAL ROTNDO, CCPE2I
C      DATA TYPE /'I', 'R', 'C', 'D'/, LENDEF /MI, MR, MC, MD/
C     +     LENG /'ROTING_MI', 'ROTING_MR', 'ROTING_MC', 'ROTING_MD'/
      DATA TYPE /'I', 'R', 'C', 'D'/ 
      DATA LENG /'ROTING_MI', 'ROTING_MR', 'ROTING_MC', 'ROTING_MD'/
C

        NREF = MAX(NRC,NRH1)
c      MI = CCPE2I ('ROTING_MI', 4*NREF + 10000)
c      MR = CCPE2I ('ROTING_MR', 4*NREF + 10000)
c      MC = CCPE2I ('ROTING_MC', NREF +MHKLTAB + 20000)
c      MD = CCPE2I ('ROTING_MD', 40000)
C      MI =  4*NRAA + 10000
C      MR =  4*NRAA + 10000
C      MC =  NRAA +MTAA + 20000
C      MD =  40000
c      write(6,'(a,/8i12)')
c     + ' In ROTING: setsize NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB ',
c     + NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB
      MI =  (1+2*NEQPC)*NREF + 2*MHKLTAB + 10000
      MR =  MAX(4*NREF + 10000,4*MHKLTAB + 50000)
      MC =  NREF +MHKLTAB + 20000
      MD =  40000
      write(6,'(/,A)')' Subroutine ROTING'
      write(6,'(A,I12)')' MI= (1+2*NEQPC)*NREF + 2*MHKLTAB + 10000 ',MI
      write(6,'(A,I12)')' MR= MAX(4*NREF + 10000,4*MHKLTAB + 50000)',MR
      write(6,'(A,I12)')' MC=  NREF +MHKLTAB + 20000               ',MC
      write(6,'(A,I12)')' MD=  40000                               ',MD
      LENDEF (1) = MI
      LENDEF (2) = MR
      LENDEF (3) = MC
      LENDEF (4) = MD
C      CALL CCPALC (ROTNDO, 4, TYPE, LENDEF)
      CALL CCPALE (ROTNDO, 4, TYPE, LENG, LENDEF,.TRUE.)
      END
C
C
C
C     ==========================================
      SUBROUTINE ROTNDO(MI,II,MR,RR,MC,CC,MD,DD)
C     ==========================================
C
      INTEGER NSOL,MSR1R
      PARAMETER (NSOL=499,MSR1R=6)
C
C     .. Scalar Arguments ..
      INTEGER MC,MD,MI,MR
      INTEGER HCK2,KCK2,LCK2,NCKH2,NCKK2,NCKL2,NCKM2
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION DD(MD)
      COMPLEX CC(MC)
      REAL RR(MR)
      INTEGER II(MI)
C     ..
C     .. Scalars in Common ..
      REAL A,ALPHA,ALPHAM,AM,B,BETA,BETAM,BM,C,CM,DANGR,BMAXR,DELTA,
     +    DELTAR, DMAX,DMIN,DRMAX,DRMAXC,DRMIN,DRMINC,FMAX,FMIN,GAMMA,
     +    GAMMAM,RMAX,RMAXC,RMIN,RMINC,RPTSR,SEUIL,TFAC,
     +    DRMAXT,DRMINT,SHRTTR,RPTST,DELTAT,EPSNF
      INTEGER IROTR,ISELF,IVERB,KPRT,LMIN,LMINR,LSUP,NEQP,NSYMP,
     +        LSUPR,NA,NB,NCODC,NCODE,NDIM1,NDIM2,NEQ,NG,NPIC,NPICR,NR1,
     +        NR2,NSM,NSR1,NSR1R,NSR2,NSR2R,NSYM,NSYM1,NSYM2,NXLS,NCODT,
     +        NMOLT,NPICT,ITMAXF,ISF,IAF,IBF,IGF,IYF,IZF,
     +        HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1
      CHARACTER TITLE*72
C     ..
C     .. Arrays in Common ..
      REAL BID1,CELLM,DRMAXG,DRMING,FMAXC,FMINC,RF,RO,RSYM,RX1,RX2,
     +     TFACC,TSS,ALT,BET,GAT,TXT,TYT,TZT,CRT,RFT
      INTEGER IBID1,IBID2,IROTC,IROTG,ITABB,KPRTT,MSS,ITBT
C     ..
C     .. Local Scalars ..
      REAL AL,AL1,AL2,BE,BE1,BE2,CORR,DANG,GA,GA1,GA2,RFLI,RPTS,T,TO,TX,
     +     TY,TZ,XHI
      INTEGER HMAX,I,IFAIL,IP,IR,IRTC,IRTG,IS,ITAB,J,KMAX,LMAX,LREC,MHE,
     +        MT,N,ND,NR,T3,UDI,UHE,XHE
      LOGICAL FLAG
      CHARACTER ROTA*4,FILNAM*10,NAMPG*10,LAUNAM*10
C     ..
C     .. Local Arrays ..
      REAL RMX(9),RMX1(9),RMX2(9),RMX3(9),VER(3),RS(9,48),DM(9),
     +     ROC(9),RFC(9)
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPDPN,CELDA,ORTHO,PIKNDO,PRO3MX,
     +         RECNDO,RMX2E,RMX2P,RMXE,ROTATS,SPHARS
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MAX,MIN,NINT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /ALLFNC/TITLE
      COMMON /ALLFUN/IVERB,ITABB(5),FMINC(5),FMAXC(5),TFACC(5),NSM,
     +       NSYMP,RSYM(4,4,96)
      COMMON /CELOBS/AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS(3,3),NCDOBS
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /CELLM/AM,BM,CM,ALPHAM,BETAM,GAMMAM
      COMMON /CTLX/NSYM,FMIN,FMAX,TFAC
      COMMON /DROTT/NXLS,IBID1(3),NA,NB,NG,LMIN,LSUP,IBID2(3)
      COMMON /IOPRG/KPRT
      COMMON /OPRT/KPRTT(20)
      COMMON /ORTM/RO(9),RF(9),NCODE
      COMMON /PACO/HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1
      COMMON /POTE/SFLI,SFSQ,SFQU,RFLI,RFSQ,CORF,CORI,CORP,SCALE,BFACT
      COMMON /PIK/SEUIL,DELTA,NPIC
      COMMON /RESO/DRMAX,DRMIN,DMAX,DMIN,RMIN,RMAX
      common /rotra/ dm,rbid5(30)
      COMMON /ROTFUN/IROTG(4),IROTC(5),IROTR,ISELF,DRMAXG(4),DRMING(4),
     +       CELLM(6,4),NCODC,DRMAXC,DRMINC,RMINC,RMAXC,LMINR,LSUPR,
     +       DANGR,BMAXR,NSR1R,NSR2R,RPTSR,DELTAR,NPICR,ANGNSR(3,MSR1R)
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /SROTT/RX1(3),RX2(3),NR1,NR2
      COMMON /TRAFIT/NCODT,DRMAXT,DRMINT,DMINTT,SHRTTR,NMOLT,
     +       RPTST,DELTAT,NPICT,ITBT(NSOL),ALT(NSOL),BET(NSOL),
     +       GAT(NSOL),TXT(NSOL),TYT(NSOL),TZT(NSOL),CRT(NSOL),
     +       RFT(NSOL),ITMAXF,EPSNF,ISF,IAF,IBF,IGF,IXF,IYF,IZF,SCDT
      COMMON /XALS/BID1(2),NSYM1,NSYM2,NSR1,NSR2,NDIM1,NDIM2
C     ..
      SAVE
C     .. Data statements ..
      DATA ROTA/'ROTA'/,T3/0/
C     ..
C
      DRMAX = 1000
      KPRTT(1) = IVERB
      KPRTT(2) = IVERB
      KPRTT(3) = IVERB
      KPRTT(4) = IVERB
      KPRTT(5) = IVERB
      KPRTT(6) = IVERB
      WRITE (6,FMT=6000)
      IFAIL = 0
      ITAB = 0
C
      KPRT = KPRTT(1)
C
C----   Generate option - input 
C                         continuous transform of coordinate density:
C                         output calculated "structure factors"
C
C     Loop around opening up to four tables for the HKLPCKi  output.
C
      DO 20 IRTG = 1,4
C    IROTG(irtg) either 0 or 1
        IF (IROTG(IRTG).EQ.0) GO TO 20
        KPRTT(1) = IVERB
        KPRT = KPRTT(1)
        WRITE (6,FMT='(//,A,I3)') ' GENERATING HKLPCK FOR MODEL',IRTG
C
C----    itab = irtg ; udi = 'hklpckI'
C
        FILNAM = ' '
        I = 0
C
C----  how to set IROTG? - in SR ROTING?
C
        WRITE (FILNAM,FMT='(A5,I1)') 'TABLE',irtg
C
C            ******************************************
        CALL CCPDPN(I,FILNAM,'READONLY','U',0,IFAIL)
C            ******************************************
C
        ITAB = I
C 
        UDI = 0
        FILNAM = ' '
        WRITE (FILNAM,FMT='(A6,I1)') 'HKLPCK',IRTG
C
C            ***************************************
        CALL CCPDPN(UDI,FILNAM,'NEW','U',LREC,IFAIL)
C            ***************************************
C
C
        DRMAX = DRMAXG(IRTG)
        DRMIN = DRMING(IRTG)
C
        IF (DRMAX.LT.DRMIN) THEN
          TO = DRMAX
          DRMAX = DRMIN
          DRMIN = TO
        END IF
C
C---- Check array sizes.
        ND = 1000
        IF(ITAB.NE.0) REWIND (ITAB)
C       READ (ITAB) A,B,C,ALPHA,BETA,GAMMA,NCODE,HMAX,KMAX,LMAX,SQHMAX
        READ (ITAB) (RMX(I),I=1,7),HMAX,KMAX,LMAX
        MT = (HMAX+2)*(2*KMAX+1)*(2*LMAX+1)
         NR = MIN(MI-ND,MC-MT)
        IF(KPRT.GT.0) WRITE(6,'(a,i10,/,a,/,a,4i10,/,a,3i5)')
     +  ' Maximum number of reflections < ',nr,
     +  ' Calculated as: MIN(MI-ND,MC-MT)' ,
     +  '  mi,nd,mc,mt(defined as (HMAX+2)*(2*KMAX+1)*(2*LMAX+1))',
     +    mi,nd,mc,mt,
     +  '  hmax,kmax,lmax',
     +    hmax,kmax,lmax
        IF (NR.LE.0) GO TO 901
C
C  Set CELLM to Table cell if Model cell not given
          AM = CELLM(1,IRTG)
          BM = CELLM(2,IRTG)
          CM = CELLM(3,IRTG)
          ALPHAM = CELLM(4,IRTG)
          BETAM = CELLM(5,IRTG)
          GAMMAM = CELLM(6,IRTG)
C
        IF(CELLM(1,IRTG).LT. 10.0) THEN
          AM = RMX(1)
          BM = RMX(2)
          CM = RMX(3)
          ALPHAM = RMX(4)
          BETAM = RMX(5)
          GAMMAM = RMX(6)
           WRITE(6,'(A,3F10.3,3F9.3)')
     +      'Model cell not set: Input TABLE cell used:',
     +      AM,BM,CM,ALPHAM,BETAM,GAMMAM
        END IF
C            *****
        CALL CELDA(AM,BM,CM,ALPHAM,BETAM,GAMMAM)
          CALL ORTHO
C            *****
C
C----   Initially set A, B etc = AModel etc -
C            will be reset later to ITAB cell
C
        A = AM
        B = BM
        C = CM
        ALPHA = ALPHAM
        BETA = BETAM
        GAMMA = GAMMAM
C
C----  Set "symmetry" = identity - model...
C
        NTS = 0
        NEQ = 1
        NEQP = 1
        NCODE = 1
C
C
        TSS(1,1) = 0.0
        TSS(2,1) = 0.0
        TSS(3,1) = 0.0
        MSS(1,1,1) = 1
        MSS(1,2,1) = 0
        MSS(1,3,1) = 0
        MSS(2,1,1) = 0
        MSS(2,2,1) = 1
        MSS(2,3,1) = 0
        MSS(3,1,1) = 0
        MSS(3,2,1) = 0
        MSS(3,3,1) = 1
C
C  ntab always 1 !
C            *******************************************
c      COMPLEX CC(NR+MT)
c      REAL RR(2*ND)
c      INTEGER II(ND+NR)
        CALL RECNDO(itab,ntab,UDI,ND,NR,MT,II(1),RR(1),CC(1))
C            *******************************************
C
        KPRT = KPRTT(2)
        IF(ITAB.NE.0) CLOSE (UNIT=ITAB)
        IF (UDI.NE.ITAB) CLOSE (UNIT=UDI)
   20 CONTINUE
C
C----   Clmn option:
C
      DO 30 IRTC = 1,5
        IF (IROTC(IRTC).EQ.0) GO TO 30
        FILNAM = ' '
        IR = IROTC(IRTC)
C
C----  use IROTC < 0 to flag CRYSTAL CLMN
C
        IF (IRTC.EQ.1) IR = 0
        IF (IR.EQ.0) WRITE (6,FMT='(//,A,I3)')
     +      '   Calculating CLMN FOR CRYSTAL'
        IF (IR.GT.0) WRITE (6,FMT='(//,A,I3)')
     +      '   Calculating CLMN FOR MODEL',IR
C
C----   all model NCODE set = 1 ; CRYSTAL NCODE = NCODC
        NCODE = 1
        IF (IRTC.EQ.1) NCODE = NCODC
        WRITE (FILNAM,FMT='(A6,I1)') 'HKLPCK',IR
        UDI = 0
C
C            ********************************************
        CALL CCPDPN(UDI,FILNAM,'READONLY','U',LREC,IFAIL)
C            ********************************************
C
        FILNAM = ' '
        WRITE (FILNAM,FMT='(A4,I1)') 'CLMN',IR
        UHE = 0
C
C            *******************************************
        CALL CCPDPN(UHE,FILNAM,'UNKNOWN','U',LREC,IFAIL)
C            *******************************************
C
        IF(UDI.NE.0) REWIND (UDI)
        READ (UDI) A,B,C,ALPHA,BETA,GAMMA
        IF(IR.EQ.0)THEN 
          AOBS  = A
          BOBS  = B
          COBS  = C
          ALPOBS  = ALPHA
          BETOBS  = BETA
          GAMOBS  = GAMMA
        END IF
C  Calculate volume
        ALPH = ALPOBS*DTOR
        BETT = BETOBS*DTOR
        GAMM = GAMOBS*DTOR
        SUM = (ALPH+BETT+GAMM)*0.5
        V = 
     + SQRT(ABS(SIN(SUM-ALPH)*SIN(SUM-BETT)*SIN(SUM-GAMM)*SIN(SUM)))
        VOL = AOBS*2.0*BOBS*COBS*V

C
C            *****
        CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
C
      READ (UDI) NTS,NEQP,(((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
      IF(NTS.GT.0) READ(UDI) ((TTS(I,ITS),I=1,3),ITS=1,NTS)
C
C   Now choose a sensible Beta_MAX - use PGNLAU to decide 
C                              - need only look at primitive sym ops
           DO N = 1,NEQP
              RSYM(4,4,N) = 1.0
            DO I = 1,3
              RSYM(4,I,N) = 0.0
              RSYM(I,4,N) = TSS(I,N)
               DO J = 1,3
                 RSYM(J,I,N) = MSS(J,I,N)
               END DO 
            END DO 
           END DO 
         nampg = ' '
         neqq = neqp
         CALL PGDEFN(NAMPG,NEQQ,NEQP,RSYM,.FALSE.)
         CALL PGNLAU(NAMPG,NLAUE,LAUNAM)
          BMAXSET = 180.0
C  Monoclinic B unique - only place where NCODC may not = 1.0
         IF (NLAUE.EQ.4 )THEN
           IF(NCODC.NE.1 .AND. NCODC.NE.3) THEN
             NCODC = 1
             WRITE( 6,*) 
     + ' ** Warning - Resetting Orthogonalisation code to standard **'
           END IF
          IF(NCODC.EQ.1) BMAXSET = 90.0
         END IF 
C  Not monoclinic B unique - set NCODC = 1
         IF (NLAUE.NE.4 .AND. NCODC.NE.1) THEN
             NCODC = 1
             WRITE( 6,*) 
     + ' ** Warning - Resetting Orthogonalisation code to standard **'
         END IF 
C   Is there a 2-fold perp to c to consider?
C   6 pg222 ;  8 pg422 ; 10 pg312; 11 pg321 ; 13 pg622 ;  14 pg23 ; 15 pg432 
C
         IF( NLAUE.EQ. 6 .OR. NLAUE.EQ. 8 .OR. NLAUE.EQ.10 
     +  .OR. NLAUE.EQ.11 .OR. NLAUE.GE.13 ) BMAXSET = 90.0
C
        IF (BMAXR.GT.BMAXSET ) BMAXR = BMAXSET
        CALL ORTHO
C            *****
C  Get info for packing
      READ (UDI) HCK2,KCK2,LCK2,NCKH2,NCKK2,NCKL2,NCKM2,DMMiNN
      ICHK =
     +      IABS(HCK2-HCK1) + IABS(KCK2-KCK1) + IABS(LCK2-LCK1)
     +  +   IABS(NCKH2-NCKH1) + IABS(NCKK2-NCKK1)
     +  +   IABS(NCKL2-NCKL1) + IABS(NCKM2-NCKM1)
      IF(ICHK.NE.0 .AND.KPRT.GT.0) 
     +   WRITE(6,'(a,/,2(/a,3i4,a,3i4),/a,i4,a,i4)')
     +   '  ***  - your HKLM are being reset ***',
     +   ' Input    HM KM LM',HCK1,KCK1,LCK1,
     +   '      Previous HM KM LM',HCK2,KCK2,LCK2,
     +   ' Input    NH NK NL',NCKH1,NCKK1,NCKL1,
     +   '      Previous NH NK NL',NCKH2,NCKK2,NCKL2,
     +   ' Input    NM     ',NCKM1,
     +   '      Previous NM     ',NCKM2
      HCK1=HCK2
      KCK1=KCK2
      LCK1=LCK2
      NCKH1=NCKH2
      NCKK1=NCKK2
      NCKL1=NCKL2
      NCKM1=NCKM2

c        IF(ICHK.NE.0) CALL CCPERR(1,'  Fatal error')
C
      READ (UDI) ND
C
C----  Move reading input data from DIMSS to here.
C    
      FMAX = FMAXC(IR+1)
      FMIN = FMINC(IR+1)
      TFAC = TFACC(IR+1)
C
      IF (FMAX.LT.FMIN) THEN
        T = FMAX
        FMAX = FMIN
        FMIN = T
      END IF
C
      IF (DRMAXC.LT.DRMINC) THEN
        T = DRMAXC
        DRMAXC = DRMINC
        DRMINC = T
      END IF
C
      DRMAX = DRMAXC
      DRMIN = DRMINC
      RMAX = RMAXC
      RMIN = RMINC
      IF (RMAX.LT.RMIN) THEN
        T = RMAX
        RMAX = RMIN
        RMIN = T
      END IF
C
C       Check Sphere volume

      VOLSPH = 1.3333*3.14159*RMAX*RMAX*RMAX
      IF(VOLSPH.GT.1.2*VOL/(NEQP*(NTS+1))) 
     +  WRITE(6,'(//,a,/a,/,a,/,a,f12.1,a,f12.1,/,a,/,a)')
     +  ' ****************************************************',
     +  ' ****************************************************',
     +  '  ****  PROBLEM? - SPHERE VOLUME > ASYMM_UNIT_VOL ***',
     +  '  SPHERE VOLUME',VOLSPH,' ASYMM_UNIT_VOL',VOL/(NEQP*(NTS+1)),
     +  ' ****************************************************',
     +  ' ****************************************************'
      IF(VOLSPH.GT.1.5*VOL/(NEQP*(NTS+1))) 
     +     CALL CCPERR(2,' Does this matter?')
C
C       Check CELL edges v Sphere radius
      IF ( RMAX.GT. AOBS/2.0 .OR. RMAX .GT. BOBS/2.0 
     +       .OR. RMAX.GT.COBS/2.0) THEN
C         EJD thinks this is important; other opinions differ DL 12/1/95
        WRITE (6,*) 'Radius: ',RMAX, '  Cell: ', AOBS,BOBS,COBS
        WRITE(6,'(//,a,/,a,/,a,/,a,/,a)')
     +       ' ****************************************************'
     +       ,' ****************************************************'
     +       ,'  **** Sphere Radius > 0.5*CELL EDGE - Take CARE **'
     +       ,' ****************************************************'
     +       ,' ****************************************************'
      ELSE IF (RMAX.GT. AOBS .OR. RMAX .GT. BOBS.OR. RMAX.GT.COBS)
     +         THEN
        WRITE (6,*) 'Radius: ',RMAX, '  Cell: ', AOBS,BOBS,COBS
        CALL CCPERR(1,'Sphere radius > cell edge')
      END IF
C
C----  End of insert.
C
C            ******************************************************
      CALL SPHARS(UDI,UHE,ND,MI,MR,MC,MD,II(1),RR(1),CC(1),DD(1))
C            ******************************************************
C
      IF (UDI.NE.0)  CLOSE (UNIT=UDI)
      IF (UHE.NE.UDI)  THEN
           CLOSE (UNIT=UHE)
           UHE = 0
         END IF 
           UDI = 0
   30 CONTINUE
C
C----   Rotation option:
C    
      IF (IROTR.EQ.0) RETURN
C
C----  open  spherical-harmonics expansion for crystal.
        IKEEP = 1
C
      XHE = 0
C
C          *********************************************
      CALL CCPDPN(XHE,'CLMN0','READONLY','U',LREC,IFAIL)
C      CALL CCPDPN(T3,'TEMPI','SCRATCH','U',80,IFAIL)
C          *********************************************
C
      IF (ISELF.EQ.0) THEN
C
C----  open  spherical-harmonics expansion for model.
C
        MHE = 0
        FILNAM = ' '
        WRITE (FILNAM,FMT='(A4,I1)') 'CLMN',IROTR
C
C            ********************************************
        CALL CCPDPN(MHE,FILNAM,'READONLY','U',LREC,IFAIL)
C            ********************************************
C
C   Make sure cell and symmetry information OK; need to (re)open hklpck0 and TABLEi
        WRITE (FILNAM,FMT='(A7)') 'HKLPCK0'
        UDI = 0
C
C            ********************************************
        CALL CCPDPN(UDI,FILNAM,'READONLY','U',LREC,IFAIL)
C            ********************************************
      END IF
C   Store solutions from NSOL down for later sorting
C
         DO 65 LMINN = 2,10,2
         if(XHE.NE.0) rewind(xhe)
         if(MHE.NE.0) rewind(mhe)
         if(UDI.NE.0) rewind(udi)
C
         LMIN = LMINN
C
C----  Iself = 0 - CROSS ROTATION.
C
C
      IF (ISELF.NE.0) THEN
        FLAG = .FALSE.
        NXLS = 1
        MHE  = XHE
        NR1  = 0
        NR2  = 0
        RX1(1) = 0.0
        RX1(2) = 0.0
        RX1(3) = 0.0
        RX2(1) = 0.0
        RX2(2) = 0.0
        RX2(3) = 0.0
      ELSE
        NXLS = 2
      END IF
C
C      LMIN = LMINR
      LSUP = LSUPR
      DANG = DANGR
      NA = NINT(360/DANG)
      NB = NINT(BMAXR/DANG) + 1
C
      NSR1 = NSR1R
      NSR2 = NSR2R
      IF (NSR1.EQ.0 .AND. NSR2.EQ.0) FLAG = .FALSE.
C
C  Jorge says: test range of BESLIM..
c         rewind(t3)
C          ******************************************************
      CALL ROTATS(XHE,MHE,MI,MR,MC,MD,II(1),RR(1),CC(1),DD(1))
C          ******************************************************
C
      RPTS = RPTSR
      DELTA = DELTAR
      NPIC = NPICR
      SEUIL = RPTS*SEUIL
C
C          *********************************
      CALL PIKNDO(MI,MR,II(1),RR(1),ROTA)
C          *********************************
C
C----   Set RMX1 RMX2 as identity matrices.
C
      AL1 = 180-RX1(3)
      BE1 = RX1(2)
      GA1 = 180-RX1(1)
      AL2 = RX2(1)
      BE2 = RX2(2)
      GA2 = RX2(3)
C
C          **********************
      CALL RMXE(AL1,BE1,GA1,RMX1,.FALSE.)
      CALL RMXE(AL2,BE2,GA2,RMX2,.FALSE.)
C          **********************
C
C----  For locked rotation function will need to reset these.
C       RX1 RX2 will be reset.
C     
C----  Iself = 0 - CROSS ROTATION.
C
      IF (NR1+NR2.NE.0 .AND. NR1.LE.1 .AND. NR2.LE.1 .AND.
     +    ISELF.NE.0) THEN
        NPIC = NPICR
        FLAG = .TRUE.
        KPRT = 0
        AL1 = 180-RX1(3)
        BE1 = RX1(2)
        GA1 = 180-RX1(1)
        AL2 = RX2(1)
        BE2 = RX2(2)
        GA2 = RX2(3)
C
C            **********************
        CALL RMXE(AL1,BE1,GA1,RMX1,.FALSE.)
        CALL RMXE(AL2,BE2,GA2,RMX2,.FALSE.)
C            **********************
C
      END IF
C
      IF ( ISELF.NE.0 ) GO TO 777
C
      IF(UDI.NE.0) REWIND (UDI)
      READ (UDI) A,B,C,ALPHA,BETA,GAMMA
      AOBS  = A
      BOBS  = B
      COBS  = C
      ALPOBS  = ALPHA
      BETOBS  = BETA
      GAMOBS  = GAMMA
      NCODE = NCODC
C
C            *****
      CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
      CALL ORTHO
C            *****
C
      READ (UDI) NTS,NEQP,(((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
      IF(NTS.GT.0) READ(UDI) ((TTS(I,ITS),I=1,3),ITS=1,NTS)
      READ (UDI) HCK2,KCK2,LCK2,NCKH2,NCKK2,NCKL2,NCKM2,DMMiNN
      ICHK =
     +      IABS(HCK2-HCK1) + IABS(KCK2-KCK1) + IABS(LCK2-LCK1)
     +  +   IABS(NCKH2-NCKH1) + IABS(NCKK2-NCKK1)
     +  +   IABS(NCKL2-NCKL1) + IABS(NCKM2-NCKM1)
      IF(ICHK.NE.0) WRITE(6,'(a,/,2(/a,3i4,a,3i4),/a,i4,a,i4)')
     +   '  ***  - your HKLM are being reset ***',
     +   ' Input    HM KM LM',HCK1,KCK1,LCK1,
     +   '      Previous HM KM LM',HCK2,KCK2,LCK2,
     +   ' Input    NH NK NL',NCKH1,NCKK1,NCKL1,
     +   '      Previous NH NK NL',NCKH2,NCKK2,NCKL2,
     +   ' Input    NM     ',NCKM1,
     +   '      Previous NM     ',NCKM2
      HCK1=HCK2
      KCK1=KCK2
      LCK1=LCK2
      NCKH1=NCKH2
      NCKK1=NCKK2
      NCKL1=NCKL2
      NCKM1=NCKM2

c        IF(ICHK.NE.0) CALL CCPERR(1,'  Fatal error')
C  Save Crystal Ro rc 
       do is=1,9
         ROC(is) = ro(is)
         RFC(is) = rf(is)
       enddo
C
       READ (UDI) ND
      nr=min((mi-nd)/(1+neqp),(mr-2*nd-13*npic)/2)
      if(nr.le.0) go to 902
      ii0=1+nr
      ir0=1+13*npic+nr
      k0=1+13*npic
      call lecfoq(udi,nd,nr,nra,neqp,ii(ii0),ii(1),ii(ii0+nd),
     . rr(ir0),rr(ir0+nd),rr(k0),rr(ir0+2*nd),'h')
c      SUBROUTINE LECFOQ(UDI,ND,NR,NRA,MEQ,HKLO,HKL,HKLS,MFO,PHO,FOB,HSQ,
c     +                  PHASFLG)
      if(13*npic+(1+neqp)*nra.gt.mr) go to 903
      j1=1+nra
      k1=k0+nra
C
C   Open TABLE again
        WRITE (FILNAM,FMT='(A6)') 'TABLE1'
C
        ITAB = 0
C            ******************************************
        CALL CCPDPN(ITAB,FILNAM,'READONLY','U',0,IFAIL)
C            ******************************************
C 
      read(itab) (xx,i=1,7),hmax,kmax,lmax
      mt=(hmax+2)*(2*kmax+1)*(2*lmax+1)
      if(mt.gt.mc) go to 904
      call lectab(itab,hmax,kmax,lmax,cc(1))
       do i=1,9
        rf(i)=rfc(i)
       enddo
       IF(ITAB.NE.0) CLOSE(UNIT=ITAB)
C
      TX = 0.0
      TY = 0.0
      TZ = 0.0
      RFLI = 0.0
C
 777  CONTINUE
      IF (ISELF.NE.0) THEN
        WRITE (6,FMT='(A6,A/17X,2A)') ' SELF:',TITLE,
     +' ALPHA    BETA   GAMMA     Omega     Phi   Kappa  ',
     +'    DC_X   DC_Y   DC_Z  CC_P'
      ELSE
        WRITE (6,FMT='(//,A,F6.2,A,//,A8,A/,10X,2A)') 
     +'  All Solutions separated by more than ',DANGR,' degrees output',
     +' CROSS:',TITLE,
     +'  ITAB  ALPHA    BETA   GAMMA    TX      TY      TZ   ',
     +' CC_F RF_F CC_I CC_P Icp'
      END IF
c
c
      tx=0.
      ty=0.
      tz=0.
      rfli=0.
C
      do 60 ip=1,npic
      ir=4*(ip-1)
      al=mod( rr(ir+1) + 7200.0,360.0)
      be=mod( rr(ir+2) + 7200.0,360.0)
      ga=mod( rr(ir+3) + 7200.0,360.0)
      corp=rr(ir+4)
C----  Iself = 0 - CROSS ROTATION.
c            if(type.eq.self) then
            if(ISELF.NE.0) then
               if(flag) then
                 call rmxe(al,be,ga,rmx3,.FALSE.)
                 call pro3mx(rmx,rmx1,rmx3,rmx2)
                 call rmx2e(rmx,al,be,ga,.FALSE.)
               endif
              call rmxe(al,be,ga,rmx,.FALSE.)
              call rmx2p(rmx,xhi,ver,.FALSE.)

C   Check if PHI is defined?
              PHI = 999.0
              IF(VER(3).LT. 0.999) PHI = ATAN2(VER(2),VER(1))*RTOD
              OMEGA = 
     +     ATAN2( sqrt(VER(1)*VER(1)+VER(2)*VER(2)),VER(3))*RTOD

              WRITE (6,FMT='(A,3F8.2,2x,3F8.2,3x,3F7.3,F6.1)') 
     +        ' SOLUTIONRS    ', AL,BE,GA,OMEGA,PHI,XHI,VER,CORP
            else
              if(nr1+nr2.eq.0.and.udi.ne.0) then
                call rmxe(al,be,ga,rmx,.FALSE.)
                call pro3mx(dm,rf,rmx,ro)

                call fun(hmax,kmax,lmax,nra,neqp,
     +                   ii(1),ii(j1),rr(k0),rr(k1),cc(1))
                ITBT(IP) = IP
                ALT(IP) = AL
                BET(IP) = BE
                GAT(IP) = GA
                TXT(IP) = corf
                TYT(IP) = rfli
                TZT(IP) = cori
                CRT(IP) = corp
c      write(6,'(A,i4,10F8.3)') '#',itab,al,be,ga,tx,ty,tz,
c     +                             corf,rfli,cori, corp
              else
                WRITE (6,FMT='(A,I4,3F8.2,3F8.4,4F5.1,I4)')
     +          ' SOLUTIONRC ',
     +         IROTR, AL,BE,GA,TX,TY,TZ,CORP,0.0,0.0,CORP,IP
              endif
            endif
60    continue
C
      if(nr1+nr2.eq.0.and.udi.ne.0) then
C          **********************
         CALL SORT1(NPIC,ITBT(1),TXT(1))
C          **********************
C  Only write out first NPICR
C      DO Ip = NPIC,1,-1
          if(ISELF.EQ.0 .and.nr1+nr2.eq.0.and.udi.ne.0) then
            IPP = NPIC-NPICR+1
            IF(IPP.LT.1) IPP = 1
            DO Ip = NPIC,IPP,-1
              AL =     ALT(ITBT(IP)) 
              BE =     BET(ITBT(IP)) 
              GA =     GAT(ITBT(IP)) 
              CORF =     TXT(IP) 
              RFLI =     TYT(ITBT(IP)) 
              CORI =     TZT(ITBT(IP)) 
              CORP =     CRT(ITBT(IP)) 
              IF(KPRT.GT.0)WRITE (6,FMT='(A,I4,3F8.2,3F8.4,4F5.1,I4)')
     +        ' SOLUTIONRC ',
     +        IROTR, AL,BE,GA,TX,TY,TZ,CORF,RFLI,CORI,CORP,NPIC-IP + 1
C  Store the peak
              ALT(NSOL - IKEEP + 1) = AL
              BET(NSOL - IKEEP + 1) = BE
              GAT(NSOL - IKEEP + 1) = GA
              TXT(NSOL - IKEEP + 1) = CORF
              TYT(NSOL - IKEEP + 1) = RFLI
              TZT(NSOL - IKEEP + 1) = CORI
              CRT(NSOL - IKEEP + 1) = CORP
              ITBT(NSOL - IKEEP + 1) = NSOL - IKEEP + 1
              IKEEP = IKEEP + 1
              IF(NSOL - IKEEP + 1 .LE. IP) 
     +           CALL CCPERR(1,' NSOL set too small')
            END DO 
          END IF
      endif
C  End of BESSLIM loop
 65     CONTINUE
C Now sort them all
        IKEEP = IKEEP - 1
        CALL SORT1(IKEEP,ITBT(NSOL - IKEEP + 1),TXT(NSOL - IKEEP + 1))
            IPP = 0
            DO Ip = NSOL,NSOL - IKEEP + 1, -1
              RR(10*IPP + 1) =     ALT(ITBT(IP)) 
              RR(10*IPP + 2) =     BET(ITBT(IP)) 
              RR(10*IPP + 3) =     GAT(ITBT(IP)) 
              RR(10*IPP + 4) =     TXT(IP) 
              RR(10*IPP + 5) =     TYT(ITBT(IP)) 
              RR(10*IPP + 6) =     TZT(ITBT(IP)) 
              RR(10*IPP + 7) =     CRT(ITBT(IP)) 
              II(IPP+1) =     IPP+1
              IF(KPRT.GT.0) WRITE (6,FMT='(A,I4,3F8.2,3F8.4,4F5.1,I4)')
     +        ' SOLUTIONRCC',
     + IROTR, RR(10*IPP + 1),RR(10*IPP + 2),RR(10*IPP + 3),TX,TY,TZ,
     + RR(10*IPP + 4),RR(10*IPP + 5),RR(10*IPP + 6),RR(10*IPP + 7),IPP+1
              IPP = IPP + 1
C  Use RR and II to store these results, ready for checking
            END DO 
              IPP = IPP - 1
C              XHIERR = DANGR/2.0
              XHIERR = DANGR/2.0
            CALL ROTCHECK( IPP,XHIERR,II,RR)        
            DO IPPP = 1,IPP
              IP = IPPP-1
              IF(RR(10*IP + 1).GT. -9998.0) THEN
                AL   = RR(10*IP + 1)
                BE   = RR(10*IP + 2) 
                GA   = RR(10*IP + 3)
                CORF = RR(10*IP + 4) 
                RFLI = RR(10*IP + 5)
                CORI = RR(10*IP + 6) 
                CORP = RR(10*IP + 7)
                WRITE (6,FMT='(A,I4,3F8.2,3F8.4,4F5.1,I4)')
     +          ' SOLUTIONRCD',
     +          IROTR, AL,BE,GA,TX,TY,TZ,CORF,RFLI,CORI,CORP,IPPP
              END IF
            END DO 
        
      return

C
  901 WRITE (6,FMT=6002) ND,MI,MT,MC
C
C          ******************************************
      CALL CCPERR(1, 'Reset ROTING_MI, ROTING_MC')
C          ******************************************
902   write(6,6004) nd,mi,2*nd-13*npic,mr
C
C          ******************************************
      CALL CCPERR(1, 'Reset ROTING_MI, ROTING_MR')
C          ******************************************
903   write(6,6006) 13*npic+(1+neqp)*nra
      call ccperr (1, ' Fatal error in s/r ROTNDO')
904   write(6,6008) mt
      call ccperr (1, ' Fatal error in s/r ROTNDO')
C3010  format('stop >> rotndo << set mi >>',i10,' and mc >>',i10)
C3020  format('stop >> rotndo << set mi >>',i10,' and mr >>',i10)
C3030  format('stop >> rotndo << set mr >=',i10)
C3040  format('stop >> rotndo << set mc >=',i10)
C
 6000 FORMAT (/,
     +' ****** PROGRAMME ROTING ******',/,
     +' *** RADIAL QUADRATURE INSTEAD OF BESSEL EXPANSION,',/,
     +' J. NAVAZA (1987). ACTA CRYST. A43, 645-653 ***',/,
     +' *** STABLE RECURRENCE RELATIONSHIP FOR ROTATION MATRICES,',/,
     +' J. NAVAZA (1990). ACTA CRYST. A46, 619-620 ***')
 6002 FORMAT
     + (' > S/R ROTNDO   ROTING_MI(required)',I10,'  MI(set)',I10,/,
     +  '                ROTING_MC(required)',I10,'  MC(set)',I10)
 6004 FORMAT
     + (' > S/R ROTNDO   ROTING_MI(required)',I10,'  MI(set)',I10,/,
     +  '                ROTING_MR(required)',I10,'  MR(set)',I10)
 6006 FORMAT
     + (' > S/R ROTNDO   ROTING_MR(required)',I10,'  MR(set)',I10)
 6008 FORMAT
     + (' > S/R ROTNDO   ROTING_MC(required)',I10,'  MC(set)',I10)

      END

c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ROTCHECK( IKEEP,XHIERR,II,RR)
      INTEGER NSOL
      PARAMETER (NSOL=499)
      DIMENSION ROTI(3,3),ROTJ(3,3),ROTIJ(3,3),VN(3)
      DIMENSION II(*),RR(*),AL(NSOL),BE(NSOL),GA(NSOL)
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
C     .. Data statements ..
      DATA FUZZ/0.0005/
C
C     ..

      DO 10 IROT = 1,IKEEP-1
        IP = IROT -1
        AL(IROT)   = RR(10*IP + 1)
        BE(IROT)   = RR(10*IP + 2) 
        GA(IROT)   = RR(10*IP + 3)
        IF(AL(IROT) .EQ. -9999.0) GO TO 10
C   Check ROT(I) and ROT(J) are not the same.
C  If so  ROT(I)*ROT(J)**-1 gives the identity - ie Kappa (XHId) very small
        CALL RMXE(AL(IROT),BE(IROT),GA(IROT),ROTI,.FALSE.)
        DO JROT = IROT + 1, IKEEP
         JP = JROT -1
         AL(JROT)   = RR(10*JP + 1)
         BE(JROT)   = RR(10*JP + 2) 
         GA(JROT)   = RR(10*JP + 3)
         IF(AL(JROT) .NE. -9999.0) THEN
          CALL RMXE(-GA(JROT),-BE(JROT),-AL(JROT),ROTJ,.FALSE.)
          CALL PRO2MX(ROTIJ,ROTJ,ROTI)
C  Check Kappa
           TR = ROTIJ(1,1) + ROTIJ(2,2) + ROTIJ(3,3)
           CosXHID = (TR-1.0)/2.0
           ARG = 1.0 - CosXHID*CosXHID
             IF(ARG.LE.FUZZ) THEN
C  XHID = 0 if CosXHId = 1,    XHID = 180 if CXosXHId = -1 
               XHID = 90.0*(1.0 - CosXHID) 
             ELSE
               SinXHID = SQRT(ABS(ARG))
               XHID = ATAN2(SinXHID,CosXHID)*RTOD
             END IF
          IF(ABS(XHID).LT.ABS(XHIERR)) RR(10*JP + 1) = -9999.0
         END IF
        END DO 
 10   CONTINUE
      RETURN
      END


C     ===========================================
      SUBROUTINE RS(NM,N,A,W,Z,FV1,FV2,MATZ,IERR)
C     ===========================================
C
C     .. Scalar Arguments ..
      INTEGER IERR,MATZ,N,NM
C     ..
C     .. Array Arguments ..
      REAL A(NM,N),FV1(N),FV2(N),W(N),Z(NM,N)
C     ..
C     .. External Subroutines ..
      EXTERNAL TQL2,TQLRAT,TRED1,TRED2
C     ..
C
      IF (N.LE.NM) GO TO 10
      IERR = 10*N
      GO TO 30
   10 IF (MATZ.NE.0) GO TO 20
C
C          ***********************
      CALL TRED1(NM,N,A,W,FV1,FV2)
      CALL TQLRAT(N,W,FV2,IERR)
C          ***********************
C
      GO TO 30
C
C          ***********************
   20 CALL TRED2(NM,N,A,W,FV1,Z)
      CALL TQL2(NM,N,W,FV1,Z,IERR)
C          ***********************
C
   30 RETURN
      END
C
C
C     =============================
      SUBROUTINE RZ1(NXP2,NY,PZ,ZS,RR)
C     ==============================
C
C     .. Scalar Arguments ..
      INTEGER NXP2,NY,PZ,ZS
C     ..
C     .. Array Arguments ..
      REAL RR(NXP2,NY,PZ)
C     ..
C     .. Scalars in Common ..
      INTEGER ND,UFC,UMP,XLW,XUP,YLW,YUP,ZLW,ZUP
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      REAL AA,AALPHA,BB,BBETA,CC,GGAMMA
      INTEGER I,J,K,NNX,NNY,NNZ
C     ..
C     .. Common blocks ..
      COMMON /DFFTTX/BID1(6),XLW,YLW,ZLW,XUP,YUP,ZUP
      COMMON /TAPES/UMP,UFC,ND
C     ..
      SAVE
C
      IF (ZS.EQ.ZLW) THEN
        IF(UMP.NE.0) REWIND (UMP)
        READ (UMP) NNX,NNY,NNZ,AA,BB,CC,AALPHA,BBETA,GGAMMA
      END IF
C
      DO 30 K = 1,PZ
        DO 20 J = 1,NY
          DO 10 I = 1,NXP2
            RR(I,J,K) = 0.0
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
      DO 40 K = 1,PZ
        READ (UMP) ((RR(I,J,K),I=XLW+1,XUP+1),J=1,NY)
   40 CONTINUE
      RETURN
      END
C
C
C     =============================
      SUBROUTINE SBES1D(L,X,SBL)
C     ==========================
C
C     .. Scalar Arguments ..
      REAL SBL,X
      INTEGER L
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION ARG,V0,V1,V2
      INTEGER LL
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,COS,SIN
C     ..
      SAVE
C
      IF (L.LT.0) GO TO 20
C
      IF (X.LT.1.0E-6) THEN
        SBL = 0.0
        IF (L.EQ.0) SBL = 1.0
        RETURN
      END IF
C
      ARG = X
      V0 = SIN(ARG)/ARG
      SBL = REAL(V0)
      IF (L.EQ.0) RETURN
      V1 = (V0-COS(ARG))/ARG
      SBL = REAL(V1)
      IF (L.EQ.1) RETURN
      SBL = 0.0
C
      DO 10 LL = 2,L
        V2 = (2*LL-1)*V1/ARG - V0
        IF (ABS(V1).LE.1.0D-6 .AND. ABS(V2).LE.1.0D-6) RETURN
        V0 = V1
        V1 = V2
   10 CONTINUE
C
      SBL = REAL(V1)
      RETURN
C
   20 WRITE (6,FMT=6000) L
C
C          *****************************************
      CALL CCPERR(1,' > s/r sbes1d < wrong l-order:')
C          *****************************************
C
 6000 FORMAT (' > S/R SBES1D < WRONG L-ORDER:',I5)
      END
C
C
C     =============================
      SUBROUTINE SBES3D(L,X,SBLM,SBL,SBLP)
C     ====================================
C
C     .. Scalar Arguments ..
      REAL SBL,SBLM,SBLP,X
      INTEGER L
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION ARG,U1,V0,V1,V2
      INTEGER LL
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,DCOS,DSIN
C     ..
      SAVE
C
      IF (L.LT.1) GO TO 20
C
      IF (X.LT.1.0E-6) THEN
        SBLM = 0.0
        SBL  = 0.0
        SBLP = 0.0
        IF (L.EQ.1) SBLM = 1.0
        RETURN
      END IF
C
      ARG = DBLE(X)
      V0 = DSIN(ARG)/ARG
      V1 = (V0-DCOS(ARG))/ARG
      SBLM = 0.0
      SBL = 0.0
      SBLP = 0.0
C
      DO 10 LL = 2,L + 1
        V2 = (2*LL-1)*V1/ARG - V0
        IF (ABS(V1).LE.1.0D-6 .AND. ABS(V2).LE.1.0D-6) RETURN
        U1 = V0
        V0 = V1
        V1 = V2
   10 CONTINUE
C
      SBLM = REAL(U1)
      SBL = REAL(V0)
      SBLP = REAL(V1)
      RETURN
C
   20 WRITE (6,FMT=6000) L
C
C          ******************************************
      CALL CCPERR(1,' > s/r sbes3d < wrong l-order:')
C          ******************************************
C
 6000 FORMAT (' > S/R SBES3D < WRONG L-ORDER:',I5)
      END
C
C
C      call scrf(nra,neqP,npic,ii(1),ii(1+nra),rr(1),rr(1+2*nra),
C     . cc(1),cc(1+nra))
C     =============================
      SUBROUTINE SCRF(NRA,NEQP,NPIC,HKL,HKLS,FOB,XYZ,FF,FS)
C     ===================================================
c        CALL OUTTRA1(NPIC,II(IC3),RR(1+2*NRA+6*NPIC),RR(1+2*NRA),N1)
C
C     .. Parameters ..
      INTEGER NPHI
      PARAMETER (NPHI=720)
C     ..
C     .. Scalar Arguments ..
      INTEGER NEQP,NRA,NPIC
C     ..
C     .. Array Arguments ..
      COMPLEX FF(NRA),FS(NRA,NEQP)
      REAL FOB(NRA),XYZ(7,NPIC),XYZS(7,1000),CF(1000)
      INTEGER HKL(NRA),HKLS(NRA,NEQP),NPEAK(1000)
C     ..
C     .. Scalars in Common ..
      REAL AL,BE,BFACT,CORF,CORI,CORP,GA,RFLI,RFSQ,SCALE,SCD,SFLI,SFSQ,
     +     TX,TY,TZ
      INTEGER IACTUAL,KPRT,NTOT,ISOL
C     ..
C     .. Arrays in Common ..
      REAL RM
      INTEGER IBID1,IBID2,MD
C     ..
C     .. Local Scalars ..
      COMPLEX FCR,TWOPII
      REAL A1,A2,A3,A4,A5,C0,CORRO,D0,ESCALA,F,FO,MF,MFO,PHI,S0,X,Y,Z
      INTEGER H,HS,IP,IR,IS,IX,K,KS,L,LS,MULT,N
C     ..
C     .. Local Arrays ..
      COMPLEX CEX(-NPHI:NPHI)
C     ..
C     .. External Subroutines ..
      EXTERNAL UNPAC3,UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,EXP,MOD,NINT,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      common/cell/ a,b,c,alpha,beta,gamma
      COMMON /CHES/RM(3,3),MD(3,3),IBID1(3)
      COMMON /IOPRG/KPRT
      COMMON /NUMO/NTOT,IBID2(6)
      COMMON /OUTRA/AL,BE,GA,TX,TY,TZ,SCD,IACTUAL,ISOL
      COMMON /POTE/SFLI,SFSQ,SFQU,RFLI,RFSQ,CORF,CORI,CORP,SCALE,BFACT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA TWOPII/ (0.0,6.2831853)/
C     ..
      xnorm=1./sqrt(sfsq-sfli**2/ntot)
      ynorm=1./sqrt(sfqu-sfsq**2/ntot)
C
      DO 10 N = -NPHI,NPHI
        CEX(N) = EXP(N*TWOPII/NPHI)
   10 CONTINUE
C
      IF (KPRT.NE.0) WRITE (6,FMT=*)
     . ' scale, corr-amplitudes, r-factor, corr-intensities sol_nb.'
      CORRO = 0.0
C
      DO 60 IX = 1,NPIC
        X = XYZ(1,IX)
        Y = XYZ(2,IX)
        Z = XYZ(3,IX)
        TX = RM(1,1)*X + RM(1,2)*Y + RM(1,3)*Z
        TY = RM(2,1)*X + RM(2,2)*Y + RM(2,3)*Z
        TZ = RM(3,1)*X + RM(3,2)*Y + RM(3,3)*Z
        TX = MOD(TX+3.0,1.0)
        TY = MOD(TY+3.0,1.0)
        TZ = MOD(TZ+3.0,1.0)
        XYZS(1,IX) = TX
        XYZS(2,IX) = TY
        XYZS(3,IX) = TZ
C
        D0 = 0.0
        C0 = 0.0
        S0 = 0.0
C
        DO 30 IR = 1,NRA
C
C              **************************
          CALL UNPAC4(H,K,L,MULT,HKL(IR))
C              **************************
C
          FCR = FF(IR)
C
          DO 20 IS = 1,NEQP
C
C                ****************************
            CALL UNPAC3(HS,KS,LS,HKLS(IR,IS))
C                ****************************
C
            PHI = MOD(HS*TX+KS*TY+LS*TZ,1.0)
            IP = NINT(PHI*NPHI)
            FCR = FS(IR,IS)*CEX(IP) + FCR
   20     CONTINUE
C
          F = ABS(FCR)
          MF = MULT*F
          D0 = FOB(IR)*MF + D0
          C0 = MF*F + C0
          S0 = S0 + MF
   30   CONTINUE
C
        CORF = xnorm*(D0-S0*SFLI/NTOT)/SQRT(ABS(C0-S0*S0/NTOT))
C
        SCALE  = C0/D0
        ESCALA = D0/C0
        D0 = 0.0
        C0 = 0.0
        S0 = 0.0
        RFLI = 0.0
C
        DO 50 IR = 1,NRA
C
C              **************************
          CALL UNPAC4(H,K,L,MULT,HKL(IR))
C              **************************
C
          FO = FOB(IR)
          FCR = FF(IR)
C
          DO 40 IS = 1,NEQP
C
C                ****************************
            CALL UNPAC3(HS,KS,LS,HKLS(IR,IS))
C                ****************************
C
            PHI = MOD(HS*TX+KS*TY+LS*TZ,1.0)
            IP = NINT(PHI*NPHI)
            FCR = FS(IR,IS)*CEX(IP) + FCR
   40     CONTINUE
C
          F = ABS(FCR)*ESCALA
          MFO = MULT*FO
          MF = MULT*F
          D0 = MF*F*FO*FO + D0
          C0 = MF*F*F*F + C0
          S0 = S0 + MF*F
          RFLI = ABS(MF-MFO) + RFLI
   50   CONTINUE
C
        RFLI = RFLI/SFLI
        CORI = ynorm*(d0-s0*sfsq/ntot)/sqrt(c0-s0*s0/ntot)
C       CORR = (D0-S0*SFLI/NTOT)/SQRT(ABS((C0-S0*S0/NTOT))*
C     +         (SFSQ-SFLI**2/NTOT))
        XYZS(4,IX) = CORF
        XYZS(5,IX) = RFLI
        XYZS(6,IX) = CORI
C  prepare to sort
        CF(IX)    = CORF
        NPEAK(IX) = IX
C
        IF (CORF.GT.CORRO) THEN
            CORRO = CORF
            A1    = TX
            A2    = TY
            A3    = TZ
            A4    = CORF
            A5    = RFLI
            A6    = CORI
        END IF
C
        IF (KPRT.NE.0) WRITE (6,FMT='(E15.5,3F10.3,I10)') SCALE,
     +      CORF*100,RFLI*100,CORI*100,IX
   60 CONTINUE
C
      TX = A1
      TY = A2
      TZ = A3
      CORF = A4
      RFLI = A5
      CORI = A6
C
      CALL SORT1(NPIC,NPEAK(1),CF(1))

      DO IP = 1,NPIC
        K = NPIC  - IP + 1
        N = NPEAK(K)
        XYZ(1,IP) = XYZS(1,N)
        XYZ(2,IP) = XYZS(2,N)
        XYZ(3,IP) = XYZS(3,N)
        XYZ(4,IP) = XYZS(4,N)
        XYZ(5,IP) = XYZS(5,N)
        XYZ(6,IP) = XYZS(6,N)
        XYZ(7,IP) = NPEAK(K)
        write(6,'(i3,7f10.3)')ip,(XYZ(ii,IP),ii=1,7)
      END DO 
C
C
      RETURN
      END
C
C     =============================
      SUBROUTINE SETMAT(ALPHA,BETA,GAMMA,TX,TY,TZ)
C     ============================================
C
C     .. Scalar Arguments ..
      REAL ALPHA,BETA,GAMMA,TX,TY,TZ
C     ..
C     .. Scalars in Common ..
      INTEGER NCODE
C     ..
C     .. Arrays in Common ..
      REAL DM,DMD,RF,RO,TR
C     ..
C     .. Local Scalars ..
      REAL ALF,BET,DTOR,GAM
C     ..
C     .. Local Arrays ..
      REAL RX(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL PRO3MX
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC COS,SIN
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /ORTM/RO(9),RF(9),NCODE
      COMMON /ROTRA/DM(3,3),DMD(3,3,3),TR(3)
C     ..
      SAVE
C     ..
C
      TR(1) = TX
      TR(2) = TY
      TR(3) = TZ
      ALF = DTOR*ALPHA
      BET = DTOR*BETA
      GAM = DTOR*GAMMA
C
      RX(1,1) = COS(ALF)*COS(BET)*COS(GAM) - SIN(ALF)*SIN(GAM)
      RX(1,2) = -COS(ALF)*COS(BET)*SIN(GAM) - SIN(ALF)*COS(GAM)
      RX(1,3) = COS(ALF)*SIN(BET)
      RX(2,1) = SIN(ALF)*COS(BET)*COS(GAM) + COS(ALF)*SIN(GAM)
      RX(2,2) = -SIN(ALF)*COS(BET)*SIN(GAM) + COS(ALF)*COS(GAM)
      RX(2,3) = SIN(ALF)*SIN(BET)
      RX(3,1) = -SIN(BET)*COS(GAM)
      RX(3,2) = SIN(BET)*SIN(GAM)
      RX(3,3) = COS(BET)
C
C          ************************
      CALL PRO3MX(DM(1,1),RF,RX,RO)
C          ************************
C
      RX(1,1) = -SIN(ALF)*COS(BET)*COS(GAM) - COS(ALF)*SIN(GAM)
      RX(1,2) = SIN(ALF)*COS(BET)*SIN(GAM) - COS(ALF)*COS(GAM)
      RX(1,3) = -SIN(ALF)*SIN(BET)
      RX(2,1) = COS(ALF)*COS(BET)*COS(GAM) - SIN(ALF)*SIN(GAM)
      RX(2,2) = -COS(ALF)*COS(BET)*SIN(GAM) - SIN(ALF)*COS(GAM)
      RX(2,3) = COS(ALF)*SIN(BET)
      RX(3,1) = 0.0
      RX(3,2) = 0.0
      RX(3,3) = 0.0
C
C          ***************************
      CALL PRO3MX(DMD(1,1,1),RF,RX,RO)
C          ***************************
C
      RX(1,1) = -COS(ALF)*SIN(BET)*COS(GAM)
      RX(1,2) = COS(ALF)*SIN(BET)*SIN(GAM)
      RX(1,3) = COS(ALF)*COS(BET)
      RX(2,1) = -SIN(ALF)*SIN(BET)*COS(GAM)
      RX(2,2) = SIN(ALF)*SIN(BET)*SIN(GAM)
      RX(2,3) = SIN(ALF)*COS(BET)
      RX(3,1) = -COS(BET)*COS(GAM)
      RX(3,2) = COS(BET)*SIN(GAM)
      RX(3,3) = -SIN(BET)
C
C          ***************************
      CALL PRO3MX(DMD(1,1,2),RF,RX,RO)
C          ***************************
C
      RX(1,1) = -COS(ALF)*COS(BET)*SIN(GAM) - SIN(ALF)*COS(GAM)
      RX(1,2) = -COS(ALF)*COS(BET)*COS(GAM) + SIN(ALF)*SIN(GAM)
      RX(1,3) = 0.0
      RX(2,1) = -SIN(ALF)*COS(BET)*SIN(GAM) + COS(ALF)*COS(GAM)
      RX(2,2) = -SIN(ALF)*COS(BET)*COS(GAM) - COS(ALF)*SIN(GAM)
      RX(2,3) = 0.0
      RX(3,1) = SIN(BET)*SIN(GAM)
      RX(3,2) = SIN(BET)*COS(GAM)
      RX(3,3) = 0.0
C
C          ***************************
      CALL PRO3MX(DMD(1,1,3),RF,RX,RO)
C          ***************************
C
      RETURN
      END
C
C
C
C     =============================
      SUBROUTINE SETSCA(IS,NRA,HKL,FOB,HSQ,FC,FIRST)
C     ==============================================
C
C     .. Scalar Arguments ..
      INTEGER IS,NRA
      LOGICAL FIRST
C     ..
C     .. Array Arguments ..
      REAL FC(NRA),FOB(NRA),HSQ(NRA)
      INTEGER HKL(NRA)
C     ..
C     .. Scalars in Common ..
      REAL BFACT,CORF,CORI,RFLI,RFSQ,SCALE,SFLI,SFSQ
      INTEGER KPRT,NTOT
C     ..
C     .. Arrays in Common ..
      INTEGER IBID1
C     ..
C     .. Local Scalars ..
      REAL C0,C2,C4,CC,D0,D2,D4,DB,DBO,DC,DESC,F,FO,HESS,MF,MFO,Q,QDH,
     +     SF,SFSQ0,SQH
      INTEGER H,K,L,MULT,N
C     ..
C     .. External Subroutines ..
      EXTERNAL UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,EXP,SIGN,SQRT
C     ..
C     .. Common blocks ..
      COMMON /IOPRG/KPRT
      COMMON /NUMO/NTOT,IBID1(6)
      COMMON /POTE/SFLI,SFSQ,SFQU,RFLI,RFSQ,CORF,CORI,CORP,SCALE,BFACT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF (FIRST) THEN
        SFSQ0 = SFSQ
        BFACT = 0.0
        FIRST = .FALSE.
      END IF
C
      RFSQ = 1.0E5
C
   10 D0 = 0.0
      D2 = 0.0
      D4 = 0.0
      C0 = 0.0
      C2 = 0.0
      C4 = 0.0
C
      DO 20 N = 1,NRA
C
C            *************************
        CALL UNPAC4(H,K,L,MULT,HKL(N))
C            *************************
C
        F = FC(N)
        IF (IS.NE.0) F = F*EXP(BFACT*HSQ(N))
        MF = MULT*F
        DC = FOB(N)*MF
        CC = MF*F
C
        IF (IS.NE.0) THEN
          SQH = HSQ(N)
          QDH = SQH*SQH
          D2 = DC*SQH + D2
          C2 = CC*SQH + C2
          D4 = DC*QDH + D4
          C4 = CC*QDH + C4
        END IF
C
        D0 = D0 + DC
        C0 = C0 + CC
   20 CONTINUE
C
      IF (IS.NE.0) THEN
        Q = 1.0 - D0*D0/ (C0*SFSQ0)
C
        IF (Q.LT.RFSQ) THEN
          RFSQ = Q
          DESC = D2*C0 - D0*C2
          HESS = - (D4*C0+D2*C2-2*D0*C4)
          IF (HESS.LT.0.0) HESS = -HESS
          DB = DESC/HESS
          IF (ABS(DB).GT.0.625) DB = SIGN(0.625,DB)
          DBO = DB
        ELSE
          DB = -DBO/2.0
          DBO = -DB
        END IF
C
        BFACT = BFACT + DB
        IF (ABS(DB).GT.0.025) GO TO 10
      END IF
C
      SCALE = C0/D0
      D0 = 0.0
      C0 = 0.0
      D2 = 0.0
      C2 = 0.0
      SF = 0.0
      RFLI = 0.0
      SFLI = 0.0
      SFSQ = 0.0
      SFQU = 0.0
C
      DO 30 N = 1,NRA
C
C            *************************
        CALL UNPAC4(H,K,L,MULT,HKL(N))
C            *************************
C
        FO = FOB(N)
        IF (IS.NE.0) FO = FO*EXP(-BFACT*HSQ(N))
        FO2 = FO*FO
        F = FC(N)
        F2 = F*F
        MFO = MULT*FO
        MF = MULT*F
        RFLI = ABS(F-FO*SCALE)*MULT + RFLI
        D0 = MF*FO + D0
        C0 = MF*F + C0
        SF = SF + MF
        D2 = MF*FO2*F + D2
        C2 = MF*F*F2 + C2
        SFLI = SFLI + MFO
        SFSQ = MFO*FO + SFSQ
        SFQU = MFO*FO*FO2 + SFQU
   30 CONTINUE
C
      xnorm=1./sqrt(sfsq-sfli**2/ntot)
      ynorm=1./sqrt(sfqu-sfsq**2/ntot)
      corf=xnorm*(d0-sf*sfli/ntot)/sqrt(c0-sf**2/ntot)
      cori=ynorm*(d2-c0*sfsq/ntot)/sqrt(c2-c0**2/ntot)
      sfli=sfli*scale
      sfsq=sfsq*scale*scale
      rfli=rfli/sfli
C
      IF (KPRT.NE.0) THEN
        WRITE (6,FMT=*)
        WRITE (6,FMT=*) ' CALCULATED SCALE AND B-FACTOR:',SCALE,
     +    BFACT*4
        WRITE (6,FMT=*) ' CORRELATION COEFFICIENT AND R-FACTOR:',
     +    CORF*100,RFLI*100,CORI*100
      END IF
C
      RETURN
      END
C
C     =============================
      SUBROUTINE HKLTABLING
C     ==================
C
C     The dimensions here are 2*(hmx+2)*(kmax-kmin+1)*(lmax=lmin+1)
C  Will read table entries from previously prepared HKLIN
C
C
C     .. Parameters ..
      INTEGER MC
      PARAMETER (MC=4400000)
C     ..
C     .. External Subroutines ..
      EXTERNAL HKLTABLNDO, CCPALE
C     ..
      CHARACTER TYPE (1), LENG (1)*13
      INTEGER LENDEF (1)
      DATA TYPE /'C'/,
     +     LENG/'HKLTABLING_MC'/,
     +     LENDEF /MC/
C
      CALL CCPALE (HKLTABLNDO, 1, TYPE, LENG, LENDEF, .TRUE.)
      END
C^L
C
C     =============================
      SUBROUTINE HKLTABLNDO(MC,CC)
C     ==================================
C
C     ..
C     .. Scalar Arguments ..
      INTEGER MC
C     ..
C     .. Array Arguments ..
      COMPLEX CC(MC)
C     ..
      LOGICAL HAVSIG,HAVPHI,HAVFOM
      COMMON /CNTRL/ISORT,ITAB,IROT,ITRA,IFIT,IMR,JSFO
      COMMON /SORTFUN/CELLS(6),DRMAXS,DRMINS,SMIN,SMAX,
     + IHMINS,IHMAXS,IKMINS,IKMAXS,ILMINS,ILMAXS,HAVSIG,HAVPHI,HAVFOM
      SAVE /SORTFUN/
C
C----  replaced by HKLIN
C   
      IFAIL = 0
      JTAB = 1
C
C          ******************************************
      IFAIL = 0
      CALL CCPDPN(JTAB,'TABLE1','NEW','U',0,IFAIL)
C          ******************************************
C
C----  Do you want a structure factor list? output
          IF(JSFO.NE.0) THEN
C  ccpdpn will assign a number to jsfo now
           JSFO = 0
C              ************************************
           CALL CCPDPN(JSFO,'HKLOUT1','NEW','F',0,IFAIL)
C              ************************************
          END IF

C    Can I assume CC(....) cleared to 0.0
C     =============================
       IDIM = (2+IHMAXS)*(1+2*IKMAXS)*(1+2*ILMAXS)
       IF(IDIM.GT.MC) THEN
        WRITE(6,'(A,i12,A,I12)')
     +      ' > S/R HKLTABLNDO   HKLTABLING_MC(required)',IDIM,
     +      '  MC(set)',MC
        CALL CCPERR(1,' Fatal Error - redimension HKLTABLING_MC')
       END IF
      CALL READTAB(JTAB,CELLS,IHMAXS,IKMAXS,ILMAXS,SMAX,CC)
      RETURN
      END
C
C
      SUBROUTINE READTAB(JTAB,CELLS,IHMAXS,IKMAXS,ILMAXS,SMAX,FTO)

C     .. Scalar Arguments ..
      REAL SMAX,G(2),ADATA(200),CELLS(6)
      INTEGER IHMAXS,IKMAXS,ILMAXS,H,K,L
      COMPLEX FF
      LOGICAL LOGMSS(200),EOF
C     ..
C     .. Array Arguments ..
      COMPLEX FTO(-1:IHMAXS,-IKMAXS:IKMAXS,-ILMAXS:ILMAXS)
C     ..
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /CNTRL/ISORT,ITAB,IROT,ITRA,IFIT,IMR,JSFO
      EQUIVALENCE (FF,G(1))
C
C     .. Equivalences ..
C     ..
C     .. Save statement ..
      SAVE
C     ..
      NCODE = 1
C
   20 CONTINUE
C
C          ************************
      CALL LRREFF(1,RESL,ADATA,EOF)
C          ************************
C
      IF (EOF) GO TO 30
      CALL LRREFM(1,LOGMSS)
C   Don't keep reflections outside highest resolution cut off.
      IF(RESL.GT.SMAX) GO TO 20
C   ISORT = -1 means input FC and PHIC
C   ISORT = -2 means input AC and BC
       H = NINT(ADATA(1))
       K = NINT(ADATA(2))
       L = NINT(ADATA(3))
       IF(ISORT.EQ.-1)THEN 
         IF (LOGMSS(6) .OR. LOGMSS(7)) GO TO 20
         G(1) = ADATA(6)*COS(ADATA(7)*DTOR)
         G(2) = ADATA(6)*SIN(ADATA(7)*DTOR)
       END IF
       IF(ISORT.EQ.-2)THEN 
         IF (LOGMSS(8) .OR. LOGMSS(9)) GO TO 20
         G(1) = ADATA(8)
         G(2) = ADATA(9)
       END IF
C   Change sign of indices if necessary
       IF( H.LT.0) THEN 
         H = -H
         K = -K
         L = -L
         G(2) = -G(2)
       END IF
       FTO(H,K,L) = CMPLX(G(1),G(2))
       IF( H.LE.1) THEN 
C      Add -h,-k,0 as well as h,k,0, and -1,-k,-l as well as 1,k,1
         H = -H
         K = -K
         L = -L
         G(2) = -G(2)
         FTO(H,K,L) = CMPLX(G(1),G(2))
       END IF
      GO TO 20
   30 CONTINUE
      WRITE (JTAB) CELLS,NCODE,IHMAXS,IKMAXS,ILMAXS,SMAX
      WRITE (JTAB) FTO

      IF(JSFO.gt.0) THEN
       WRITE (JSFO,'(6f8.3,4i5,f8.4)')
     +                     CELLS,NCODE,IHMAXS,IKMAXS,ILMAXS,SMAX
       DO  L = -ILMAXS,ILMAXS
         DO  K = -IKMAXS,IKMAXS
           DO  H = -1,IHMAXS
C   Use equiv F to G(2)
                 FF = FTO(H,K,L)
                 FC = SQRT( ABS(G(1)*G(1) + G(2)*G(2)))
                 PHIC = 0.0
                  IF( ABS(FC).GT.0.0000001) THEN
                   PHIC = 57.29578*ATAN2(G(2),G(1))
                   write(JSFO,'(3i5,E18.8,F10.3)')H,K,L,FC,PHIC
                  END IF
           END DO  
         END DO  
       END DO  
      END IF

      RETURN
      END
C
C     =============================
      subroutine setpak(ASP,BSP,CSP,NSMP,drmins)
C     =============================
C   This resets the PACO common block 
      integer id,neq,km,lm,nh,nk,nl,nm,kprt,iecr,ilec,iout,hmm,nts,hm,
     +        klmax
      real xlam,a,b,c,rbid1,rbid2
c      COMMON /ALLFUN/IVERB,ITABB(5),FMINC(5),FMAXC(5),TFACC(5),NSYM,
c     +       NSYMP,RSYM(4,4,96)
      COMMON /IOPRG/KPRT
C      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
C      common/simt/ rbid2(153),ibid1(432),neq,nts
      common/paco/ hm,km,lm,nh,nk,nl,nm
C
      id=((2**30)+(2**30-1))/(2*nsmp+1)
c      id=((2**30)+(2**30-1))/(2*neq+1)
C   Need to allow a packing in TRAFUN of half the data resolution.
C ie - if RESOL is 2A, then indices for TRAFUN could need 1A grid
C  drmins is maximum resolution of data; 
       xlamchk = 2.0/(drmins/2.0)
      xlammax=(id/(asp*bsp*csp))**(1./3)
      xlam = xlammax
C  Resmax = d; check if resmax > 1/sqrt(smax)
      if (xlammax.gt.xlamchk) then
        Write(6,'(2a,F10.4)') ' Maximum data resolution ', 
     + 'allowing for packing TRANSLATION fn could be', 2.0/xlammax
        xlam = xlamchk
      end if 
      hmm= int(xlam*asp/2) +1
      kmm= int(xlam*bsp/2) +1
      lmm= int(xlam*csp/2) +1
C   Need a bit of cunning to handle translation limits for monoclinic spacegroups.
C  Here k and l will be swapped! 
C recognise them because nsmp = 2
      if(nsmp.eq. 2) then
       klmax = max(kmm,lmm) 
       kmm = klmax
       lmm = klmax
      end if
C  Choose a grid divisible by 4
      nhh= 2*hmm+1
      nkk= 2*kmm+1
      nll= 2*lmm+1
      nhh = 4*(1+ int(nhh/4))
      nkk = 4*(1+ int(nkk/4))
      nll = 4*(1+ int(nll/4))
      nmm=2*nsmp+1
      write(6,2010) 
     + ' Setpak: max resn in As allowed with 32 bit arithmetic=', 
     +   4/xlam,
     +  ' Current "cell" = ', asp,bsp,csp,
     +  ' Symmetry counter set to 2NSMP + 1: =', nmm,
     +  ' Maximum required H K L',hmm,kmm,lmm,
     +  ' Maximum required Grid ',nhh,nkk,nll
      IF( HM.LT.HMM .OR. KM.LT.KMM .OR. LM.LT.LMM .OR. 
     +    NH.LT.NHH .OR. NK.LT.NKK .OR.NL.LT.NLL.OR.NM.LT.NMM) then
       write(6,'(a,/,a,7I5,/,a,7i5)') 
     +  ' Need to reset H K L NM limits',
     +   ' hm  km  lm  nh  nk  nl  nm ',hm,km,lm,nh,nk,nl,nm,
     +   ' hmm kmm lmm nhh nkk nll nmm',hmm,kmm,lmm,nhh,nkk,nll,nmm
c       call ccperr(1,' Error: Need to reset H K L NM limits')
       end if
       HM = HMM
       KM = KMM
       LM = LMM
       NH = NHH
       NK = NKK
       NL = NLL
       NM = NMM
      return
2010  format(/,a,f10.6,/,a,3F10.3,/,a,I5,/,a,3I5,/,a,3I5)
      end
C
C
C
C     =============================
      SUBROUTINE SORNDO(NR,HKL,NR2,MF,NR3,SG)
C     ==================================
C
C     .. Parameters ..
      INTEGER NC, ND
      PARAMETER (NC=100,ND=1000)
C     ..
C     .. Scalar Arguments ..
C  Call passed by CCPALC which allows flexible assignment of array lengths
C     The call should have NR=NR2=NR3
      INTEGER NR,NR2,NR3
C     ..
C     .. Array Arguments ..
      REAL MF(NR),SG(NR)
      INTEGER HKL(NR)
C     ..
C     .. Scalars in Common ..
      REAL A,A11,A21,A22,A31,A32,A33,ALPHA,B,BETA,C,DRMAXS,DRMINS,
     +     GAMMA,SMIN,SMAX
      INTEGER IVERB,KPRT,NEQ,NEQP,NSYM,NSYMP,
     +       HM,KM,LM,NH,NK,NL,NM
      CHARACTER TITLE*72
      LOGICAL HAVSIG,HAVPHI,HAVFOM
C     ..
C     .. Arrays in Common ..
      REAL CELLS,FMAXC,FMINC,RSYM,TFACC,TSS
      INTEGER ITABB,MSS
C     ..
C     .. Local Scalars ..
      REAL CPCT,DEMAX,DEMIN,DINF,DMAX,DMIN,DSUP,FMAX,FO,FOOO,FUZZM,
     +     FUZZP,PAS,PCT,SIG,SIGO,SPCT,SQH,SQHMAX,SQHMIN,T
      INTEGER H,HLW,HMAX,HMIN,HT,HUP,I,IFAIL,II,IND,INDEX,INDO,IR,IRES,
     +        IS,ISYM,J,JDO20,JDO30,K,KLW,KMAX,KMIN,KT,KUP,L,LLW,LMAX,
     +        LMIN,LREC,LT,LUP,MR,MULT,MULTT,N,NRA,NSHE,NT,SUM1,SUM2,
     +        UDI
      LOGICAL FIRST,FOUND,LAST,TEST
C     ..
C     .. Local Arrays ..
      REAL SHE(NC)
      INTEGER HIS(NC,2)
C     ..
C     .. External Subroutines ..
      EXTERNAL ASSYMU,CCPDPN,CELDA,INDEXM,
     +         LECFOS,MULTES,PAC3,PAC4,SORT3,SYMPAC,UNPAC3,UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC NINT,SQRT
C     ..
      COMPLEX cc(0:11),CPHI,unoi
C
C     .. Common blocks ..
      COMMON /ALLFNC/TITLE
      COMMON /ALLFUN/IVERB,ITABB(5),FMINC(5),FMAXC(5),TFACC(5),NSYM,
     +       NSYMP,RSYM(4,4,96)
      COMMON /CELD/AD,BD,CD,BID2(16)
      COMMON /CELOBS/AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS(3,3),NCDOBS
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /IOPRG/KPRT
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /SORTFUN/CELLS(6),DRMAXS,DRMINS,SMIN,SMAX,
     + IHMINS,IHMAXS,IKMINS,IKMAXS,ILMINS,ILMAXS,HAVSIG,HAVPHI,HAVFOM
      COMMON /STAR/A11,A21,A22,A31,A32,A33
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA FUZZM,FUZZP/0.9999,1.0001/
c   cc(ii) = exp(i*(ii-1)*360/24)
      data cc/
     . ( 1.       , 0.)       ,( 0.96592583, 0.25881905),
     . ( 0.8660254, 0.5)      ,( 0.70710678, 0.70710678),
     . ( 0.5      , 0.8660254),( 0.25881905, 0.96592583),
     . ( 0.       , 1.)       ,(-0.25881905, 0.96592583),
     . (-0.5      , 0.8660254),(-0.70710678, 0.70710678),
     . (-0.8660254, 0.5)      ,(-0.96592583, 0.25881905)/
C     ..
C
      unoi=(0.,1.)
      KPRT = IVERB
C
C----  replaced by HKLIN
C    
      NCHK = 0
      LREC = 0
      IFAIL = 0
      UDI = 0
C
C          ******************************************
      IFAIL = 0
      CALL CCPDPN(UDI,'HKLPCK0','NEW','U',LREC,IFAIL)
C          ******************************************
C
      AOBS = CELLS(1)
      BOBS = CELLS(2)
      COBS = CELLS(3)
      ALPOBS = CELLS(4)
      BETOBS = CELLS(5)
      GAMOBS = CELLS(6)
C      WRITE (6,FMT='(A,6F9.3)') ' Observed Cell in SORNDO:',
C     + AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS
C
      A = CELLS(1)
      B = CELLS(2)
      C = CELLS(3)
      ALPHA = CELLS(4)
      BETA = CELLS(5)
      GAMMA = CELLS(6)
C
C          *****
      CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
C          *****
      CALL SETPAK(A,B,C,NSYMP,drmins)
C
        NEQ = NSYM
        NEQP = NSYMP
C
        DO 30 ISYM = 1,NSYM
         IF(ISYM.LE.NSYMP) THEN
          DO 20 JDO30 = 1,3
           TSS(JDO30,ISYM) = RSYM(JDO30,4,ISYM)
            DO 10 JDO20 = 1,3
              MSS(JDO30,JDO20,ISYM) = NINT(RSYM(JDO30,JDO20,ISYM))
   10       CONTINUE
   20     CONTINUE
         END IF
         IF(ISYM.GT.NSYMP) THEN
          NTS = INT((ISYM-1)/NSYMP)
          DO J = 1,3
           tts(j,NTS) =   RSYM(j,4,ISYM) - RSYM(j,4,ISYM-NTS*NSYMP)
          END DO
         END IF
   30   CONTINUE

C
C
      DSUP = DRMAXS
      DINF = DRMINS
C
C          ****************
      CALL PAC3(0,0,0,INDO)
C          ****************
C
      HLW = 0
      HUP = 0
      KLW = 0
      KUP = 0
      LLW = 0
      LUP = 0
      IR  = 0
      SQHMIN = 1.0E10
      SQHMAX = 0.0
      FOOO   = 0.0
      SIGO   = 0.0
      FMAX   = 0.0
      FOUND = .FALSE.
      FIRST = .TRUE.
      LAST = .FALSE.
C
C          ***********************************
   40 CALL LECFOS(H,K,L,FO,SIG,PHI,FIRST,LAST)
C          ***********************************
      ichk = mod(ir,1000)
C
      IF (LAST) GO TO 50
C
      IF (H.LT.0) THEN
        H = -H
        K = -K
        L = -L
        PHI = -PHI
      END IF
C
C  PHI in radians
C          ******************
      CALL ASSYMU(H,K,L,PHI,TEST)
C          ******************
C
      IF (.NOT.TEST) GO TO 40
C
C          ***************
      CALL PAC3(H,K,L,IND)
C          ***************
C
      IF (H.LT.HLW) HLW = H
      IF (H.GT.HUP) HUP = H
      IF (K.LT.KLW) KLW = K
      IF (K.GT.KUP) KUP = K
      IF (L.LT.LLW) LLW = L
      IF (L.GT.LUP) LUP = L
C
      SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
C
      IF (IND.NE.INDO .AND. SQH.LT.SQHMIN) SQHMIN = SQH
      IF (SQH.GT.SQHMAX) SQHMAX = SQH
      IF (FO.GT.FMAX) FMAX = FO
C
      IF (IND.EQ.INDO) THEN
        IF (KPRT.NE.0) WRITE (6,FMT=6002) FO
        FOUND = .TRUE.
      END IF
C
      IR = IR + 1
      IF (IR.GT.NR) GO TO 140
      HKL(IR) = IND
      MF(IR) = FO
      IF(HAVSIG) SG(IR) = SIG
      IF(HAVPHI) SG(IR) = PHI
      GO TO 40
   50 CONTINUE
       IF (KPRT.NE.0) WRITE (6,FMT=6004) IR
C
      IF (.NOT.FOUND) THEN
        IF (KPRT.NE.0) WRITE (6,FMT=6003) 
        IR = IR + 1
        IF (IR.GT.NR) GO TO 140
        HKL(IR) = INDO
        MF(IR) = FOOO
        SG(IR) = SIGO
      END IF
C
      MR = IR
      NRA = 0
      INDEX = 0
      I = 0
C
C          *******************
      CALL SORT3(MR,HKL,MF,SG)
C          *******************
C
      DMAX = SQRT(ABS(1/SQHMIN))
      DMIN = SQRT(ABS(1/SQHMAX))
C
      IF (DSUP.LT.DINF) THEN
        T = DSUP
        DSUP = DINF
        DINF = T
      END IF
C
      IF (DMAX.GT.DSUP) DMAX = DSUP
      IF (DMIN.LT.DINF) DMIN = DINF
      NSHE = NINT((DMAX-DMIN)*2)
      IF (NSHE+1.GT.NC) NSHE = NC - 1
      PAS = (DMAX-DMIN)/NSHE
C
      DO 60 IS = 1,NSHE + 1
        SHE(IS) = (1/ (DMAX- (IS-1)*PAS))**2
        HIS(IS,1) = 0
        HIS(IS,2) = 0
   60 CONTINUE
C  Sheila - reset SHE(NSHE+1) for safety
      SHE(NSHE+1)=SQHMAX+0.0001
C
      IF(UDI.NE.0) REWIND (UDI)
C
C----   Write out symmetry information and cell to UDI.
C
      WRITE (UDI) A,B,C,ALPHA,BETA,GAMMA
      WRITE (UDI) NTS,NEQP,
     +   (((MSS(II,K,N),K=1,3),TSS(II,N),II=1,3),N=1,NEQP)
      IF(NTS.GT.0) WRITE(UDI) ((TTS(II,ITS),II=1,3),ITS=1,NTS)
      WRITE(UDI) HM,KM,LM,NH,NK,NL,NM,dmin,ir
C
      WRITE (6,'(A,6F8.2)') 'SORNDO ',A,B,C,ALPHA,BETA,GAMMA
      WRITE (6,'(2I5)') NTS,NEQP

      WRITE (6,'(10(/(3(/,3i5,f12.3))))') 
     +   (((MSS(II,K,N),K=1,3),TSS(II,N),II=1,3),N=1,NEQP)

      IF(NTS.GT.0) WRITE(6,'(4(/,3f8.3))') 
     +                    ((TTS(II,ITS),II=1,3),ITS=1,NTS)
c      WRITE(6,'(7i6)') HM,KM,LM,NH,NK,NL,NM
C
      DO 80 IR = 1,MR
      ichk = mod(ir,1000)
        IND = HKL(IR)
        FO = MF(IR)
        IF(HAVSIG) SIG = SG(IR) 
        IF(HAVPHI) PHI = SG(IR)
C
C            ************************
        CALL UNPAC3(H,K,L,IND)
        CALL SYMPAC(H,K,L,INDEX,TEST)
C            ************************
C
        IF (.NOT.TEST) THEN
          IF (KPRT.NE.0) WRITE (6,FMT=6014) H,K,L,FO,IND,INDEX
          GO TO 80
        END IF
C
        INDEX = IND
C
C            ***********************
        CALL MULTES(H,K,L,MULT,IRES)
C  Check phases for centricity if set
C  April 2002 - Jorge corrects cphi 
c   cc(ires) = exp(i*(ires-1)*360/24)
        IF ( IRES.NE.0 .AND. HAVPHI) THEN
C             cc(ii) = exp(i*(ii-1)360/24)
c cphi = cos(phi) + i sin(phi)
              cphi=cexp(unoi*phi)
c             cphi=sign(1.,real(cphi*cc(ires-1)))*cc(ires-1)
              cphi=sign(1.,real(cphi*conjg(cc(ires-1))))*cc(ires-1)
              phi=aimag(clog(cphi))
        endif
       if(ichk.eq.1) write(6,'(3i4,3f10.3)')H,K,L,FO,SIG,PHI
C
       CALL PAC4(H,K,L,MULT,IND)
       CALL UNPAC4(HT,KT,LT,MULTT,IND)
C            ***********************
C
       IF (HT.NE.H .OR. KT.NE.K .OR. LT.NE.L .OR. MULTT.NE.MULT .OR.
     +      IND.LE.0) GO TO 150
C
       SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
C
       DO 70 IS = 1,NSHE
         IF (SQH.GE.SHE(IS) .AND. SQH.LT.SHE(IS+1)) HIS(IS,1) = HIS(IS,
     +        1) + 1
   70   CONTINUE
C
        I = I + 1
        HKL(I) = IND
        MF(I) = FO
        IF(HAVSIG) SG(I) = SIG
        IF(HAVPHI) SG(I) = PHI
        IF (I.LT.ND) GO TO 80
        WRITE (UDI) I, (HKL(J),J=1,ND), (MF(J),J=1,ND), (SG(J),J=1,ND)
        NRA = NRA + I
        I = 0
   80 CONTINUE
C
      IF (NRA.NE.0) THEN
        IF (I.NE.0) WRITE (UDI) I, (HKL(J),J=1,I), (MF(J),J=1,I),
     +      (SG(J),J=1,I)
      ELSE
        WRITE (UDI) I, (HKL(J),J=1,I), (MF(J),J=1,I), (SG(J),J=1,I)
      END IF
C
      NRA = NRA + I
      IF (UDI.NE.0) CLOSE (UDI)
C   Check completeness
      DEMAX = SQRT(ABS(1/SQHMIN))
      DEMIN = SQRT(ABS(1/SQHMAX))
C
      SQHMIN = FUZZM/DEMAX**2
      SQHMAX = FUZZP/DEMIN**2
C
C          ****************************
      CALL INDEXM(DEMIN,AD,BD,CD,HMAX,KMAX,LMAX)
C          ****************************
C
      HMIN = 0
      KMIN = -KMAX
      LMIN = -LMAX
      INDEX = 0
      NT = 0
C
C---- pacote
C
      DO 120 L = LMIN,LMAX
        DO 110 K = KMIN,KMAX
          DO 100 H = HMIN,HMAX
C
C                ************************
            CALL SYMPAC(H,K,L,INDEX,TEST)
C                ************************
C
            IF (.NOT.TEST) GO TO 100
            SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
            IF (SQH.LT.SQHMIN .OR. SQH.GT.SQHMAX) GO TO 100
C
            DO 90 IS = 1,NSHE
              IF (SQH.GE.SHE(IS) .AND. SQH.LT.SHE(IS+1)) HIS(IS,
     +            2) = HIS(IS,2) + 1
   90       CONTINUE
C
C                *****************
            CALL PAC3(H,K,L,INDEX)
C                *****************
C
            NT = NT + 1
  100     CONTINUE
  110   CONTINUE
  120 CONTINUE
C
      IF(.NOT.FOUND) NRA=NRA-1
      PCT = NRA*100.0/NT
C
      IF (KPRT.NE.0) WRITE (6,FMT=6006) NRA,DEMAX,DEMIN,PCT,HLW,HUP,
     +    KLW,KUP,LLW,LUP,FMAX
C
      WRITE (6,FMT=6008) TITLE,PCT,NRA,DEMAX,DEMIN
      WRITE (6,FMT='(A)')
     +  '  Resolution    Obs    Exp        %   Cumul%'
      SUM1 = 0
      SUM2 = 0
C
      DO 130 IS = 1,NSHE

        SUM1 = HIS(IS,1) + SUM1
        SUM2 = HIS(IS,2) + SUM2
        SPCT = 0.0
        IF (HIS(IS,2).NE.0) SPCT = (100.0*HIS(IS,1))/HIS(IS,2)
        CPCT = 0.0
        IF (SUM2.NE.0) CPCT = (100.0*SUM1)/SUM2
        WRITE (6,FMT='(F5.1,A2,F5.1,2I7,2F9.2)') SQRT(ABS(1/SHE(IS))),
     +    ' -',SQRT(ABS(1/SHE(IS+1))),HIS(IS,1),HIS(IS,2),SPCT,CPCT
  130 CONTINUE
C
      RETURN
C
  140 WRITE (6,FMT=6010) IR,NR
C
C          ********************************************************
      CALL CCPERR(1, 'SORTNDO - Reset SORTING_NR')
  150 CALL CCPERR(1,' > s/r sorndo < wrong packing. change setpak')
C          ********************************************************
C
 6002 FORMAT (' FOOO in input data:',E15.5)
 6003 FORMAT (' FOOO not in input data:')
 6004 FORMAT (
     +' Reflections Read:   ',I10)
 6006 FORMAT (
     +' Reflections Written:',I10,/,
     +' Data Resolution between',F10.3,' and',F10.3,/,
     +' Data Completeness      ',F10.3,/,
     +' Maximal Indices in data',/,
     +' Hmin, Hmax:',2I5,', Kmin, Kmax:',2I5,', Lmin, Lmax:',2I5,/,
     +' Fob Max:               ',E15.5)
 6008 FORMAT (
     +' SORTING:',A,/,
     +' Reflections (',F5.1,'% of Total) :',I10,/,
     +' Resolution :',F10.3,' to',F10.3)
 6010 FORMAT
     + (' > S/R SORTNDO   SORTING_NR(required)',I10,'  NR(set)',I10)
 6014 FORMAT (' > WARNING < MULTIPLE REFLECTION:',3I5,E15.5,/,2I15)
      END
C
C
C     =============================
      SUBROUTINE SORT1(N,K1,A0)
C     =========================
C
C     .. Scalar Arguments ..
      INTEGER N
C     ..
C     .. Array Arguments ..
      REAL A0(N)
      INTEGER K1(N)
C     ..
C     .. Local Scalars ..
      REAL A,C,D
      INTEGER I,IH,IP1,J,K,L,NO2,NP1
C     ..
C
      NO2 = N/2
C
      DO 40 I = 1,NO2
        C = A0(I)
        D = C
        IH = I
        K = I
        IP1 = I + 1
        NP1 = N + 1 - I
C
        DO 20 J = IP1,NP1
          A = A0(J)
          IF (A.GE.C) GO TO 10
          IH = J
          C = A
          GO TO 20
   10     IF (D.GE.A) GO TO 20
          D = A
          K = J
   20   CONTINUE
C
        IF (C.EQ.D) GO TO 50
        IF (IH.EQ.I) GO TO 30
        L = K1(IH)
        K1(IH) = K1(I)
        K1(I) = L
        C = A0(IH)
        A0(IH) = A0(I)
        A0(I) = C
   30   IF (K.EQ.I) K = IH
        IF (K.EQ.NP1) GO TO 40
        L = K1(K)
        K1(K) = K1(NP1)
        K1(NP1) = L
        D = A0(K)
        A0(K) = A0(NP1)
        A0(NP1) = D
   40 CONTINUE
   50 RETURN
      END
C
C
C     =============================
      SUBROUTINE SORT3(N,K0,A1,A2)
C     ============================
C
C     .. Scalar Arguments ..
      INTEGER N
C     ..
C     .. Array Arguments ..
      REAL A1(N),A2(N)
      INTEGER K0(N)
C     ..
C     .. Local Scalars ..
      REAL U,V,W
      INTEGER I,II,IJ,J,K,KT,KU,L,M
C     ..
C     .. Local Arrays ..
      INTEGER IL(16),IU(16)
C     ..
C
      II = 1
      I = II
      J = N
      M = 1
   10 IF (I.GE.J) GO TO 100
   20 K = I
      IJ = (I+J)/2
      KT = K0(IJ)
      IF (K0(I).LE.KT) GO TO 30
      K0(IJ) = K0(I)
      K0(I) = KT
      KT = K0(IJ)
      U = A1(I)
      A1(I) = A1(IJ)
      A1(IJ) = U
      U = A2(I)
      A2(I) = A2(IJ)
      A2(IJ) = U
   30 L = J
      IF (K0(J).GE.KT) GO TO 50
      K0(IJ) = K0(J)
      K0(J) = KT
      KT = K0(IJ)
      U = A1(IJ)
      A1(IJ) = A1(J)
      A1(J) = U
      U = A2(IJ)
      A2(IJ) = A2(J)
      A2(J) = U
      IF (K0(I).LE.KT) GO TO 50
      K0(IJ) = K0(I)
      K0(I) = KT
      KT = K0(IJ)
      U = A1(IJ)
      A1(IJ) = A1(I)
      A1(I) = U
      U = A2(IJ)
      A2(IJ) = A2(I)
      A2(I) = U
      GO TO 50
   40 KU = K0(L)
      K0(L) = K0(K)
      K0(K) = KU
      U = A1(L)
      A1(L) = A1(K)
      A1(K) = U
      U = A2(L)
      A2(L) = A2(K)
      A2(K) = U
   50 L = L - 1
      IF (K0(L).GT.KT) GO TO 50
   60 K = K + 1
      IF (K0(K).LT.KT) GO TO 60
      IF (K-L) 40,70,80
   70 K = K + 1
      L = L - 1
   80 IF (L-I.LE.J-K) GO TO 90
      IL(M) = I
      IU(M) = L
      M = M + 1
      I = K
      GO TO 110
   90 IL(M) = K
      IU(M) = J
      M = M + 1
      J = L
      GO TO 110
  100 M = M - 1
      IF (M.EQ.0) GO TO 140
      I = IL(M)
      J = IU(M)
  110 IF (J-I.GE.11) GO TO 20
      IF (I.EQ.II) GO TO 10
      I = I - 1
  120 I = I + 1
      IF (I.EQ.J) GO TO 100
      IF (K0(I).LE.K0(I+1)) GO TO 120
      KT = K0(I+1)
      V = A1(I+1)
      W = A2(I+1)
      K = I
  130 K0(K+1) = K0(K)
      A1(K+1) = A1(K)
      A2(K+1) = A2(K)
      K = K - 1
      IF (K0(K).GT.KT) GO TO 130
      K0(K+1) = KT
      A1(K+1) = V
      A2(K+1) = W
      GO TO 120
  140 RETURN
      END
C
C
C     =============================
      SUBROUTINE SORT5(N,A0,B,C,D,E)
C     ==============================
C
C     .. Scalar Arguments ..
      INTEGER N
C     ..
C     .. Array Arguments ..
      REAL A0(N),B(N),C(N),D(N)
      INTEGER E(N)
C     ..
C     .. Local Scalars ..
      REAL T,U,V,W
      INTEGER I,II,IJ,J,K,L,M,X
C     ..
C     .. Local Arrays ..
      INTEGER IL(16),IU(16)
C     ..
C
      II = 1
      I = II
      J = N
      M = 1
   10 IF (I.GE.J) GO TO 100
   20 K = I
      IJ = (I+J)/2
      T = A0(IJ)
      IF (A0(I).LE.T) GO TO 30
      A0(IJ) = A0(I)
      A0(I) = T
      T = A0(IJ)
      U = B(I)
      B(I) = B(IJ)
      B(IJ) = U
      U = C(I)
      C(I) = C(IJ)
      C(IJ) = U
      U = D(I)
      D(I) = D(IJ)
      D(IJ) = U
      ITEMP = E(I)
      E(I) = E(IJ)
      E(IJ) = ITEMP
   30 L = J
      IF (A0(J).GE.T) GO TO 50
      A0(IJ) = A0(J)
      A0(J) = T
      T = A0(IJ)
      U = B(IJ)
      B(IJ) = B(J)
      B(J) = U
      U = C(IJ)
      C(IJ) = C(J)
      C(J) = U
      U = D(IJ)
      D(IJ) = D(J)
      D(J) = U
      ITEMP = E(IJ)
      E(IJ) = E(J)
      E(J) = ITEMP
      IF (A0(I).LE.T) GO TO 50
      A0(IJ) = A0(I)
      A0(I) = T
      T = A0(IJ)
      U = B(IJ)
      B(IJ) = B(I)
      B(I) = U
      U = C(IJ)
      C(IJ) = C(I)
      C(I) = U
      U = D(IJ)
      D(IJ) = D(I)
      D(I) = U
      ITEMP = E(IJ)
      E(IJ) = E(I)
      E(I) = ITEMP
      GO TO 50
   40 U = A0(L)
      A0(L) = A0(K)
      A0(K) = U
      U = B(L)
      B(L) = B(K)
      B(K) = U
      U = C(L)
      C(L) = C(K)
      C(K) = U
      U = D(L)
      D(L) = D(K)
      D(K) = U
      ITEMP = E(L)
      E(L) = E(K)
      E(K) = ITEMP
   50 L = L - 1
      IF (A0(L).GT.T) GO TO 50
   60 K = K + 1
      IF (A0(K).LT.T) GO TO 60
      IF (K-L) 40,70,80
   70 K = K + 1
      L = L - 1
   80 IF (L-I.LE.J-K) GO TO 90
      IL(M) = I
      IU(M) = L
      M = M + 1
      I = K
      GO TO 110
   90 IL(M) = K
      IU(M) = J
      M = M + 1
      J = L
      GO TO 110
  100 M = M - 1
      IF (M.EQ.0) GO TO 140
      I = IL(M)
      J = IU(M)
  110 IF (J-I.GE.11) GO TO 20
      IF (I.EQ.II) GO TO 10
      I = I - 1
  120 I = I + 1
      IF (I.EQ.J) GO TO 100
      IF (A0(I).LE.A0(I+1)) GO TO 120
      T = A0(I+1)
      U = B(I+1)
      V = C(I+1)
      W = D(I+1)
      X = E(I+1)
      K = I
  130 A0(K+1) = A0(K)
      B(K+1) = B(K)
      C(K+1) = C(K)
      D(K+1) = D(K)
      E(K+1) = E(K)
      K = K - 1
      IF (A0(K).GT.T) GO TO 130
      A0(K+1) = T
      B(K+1) = U
      C(K+1) = V
      D(K+1) = W
      E(K+1) = X
      GO TO 120
  140 END
C
C
C     =============================
      SUBROUTINE SORTING
C     ==================
C
C     ..
      CHARACTER TYPE(3)
      INTEGER LENG(3), NR
      EXTERNAL SORNDO, CCPALC, CCPE2I
      INTEGER CCPE2I
      DATA TYPE /'I', 2*'R'/
C  NRC NEQPC - no of reflns and no of primitive sym ops for crystal
C  MITAB MCTAB needed for tabling
C  MCTAB set = 100000
C  NRH1  no of reflns for HKLPCK1 
C  MHKLTAB - the big array from the table: (2*KMAX+1)* (IHMAX+2)* (2*LMAX+1)
      COMMON /SETSIZE/ NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB 
C
C     NRU has been estimated from CELL and resolution
      NR = CCPE2I ('SORTING_NR', NRC)
       IF(NR.LT.NRC) THEN
         write(6,'(A,I8)') ' SORTING_NR set too small - reset to:',NRC
         NR = NRC
       END IF
C
      LENG (1) = NR
      LENG (2) = NR
      LENG (3) = NR
      WRITE (6, '(/'' Memory allocation (logical name, elements):'')')
      WRITE (6, '(1X, A, 3X, I10)') 'SORTING_NR', NR
      CALL CCPALC (SORNDO, 3, TYPE, LENG)
      END
C
C
C
      subroutine sphars(UDI,UHE,nd,mi,mr,mc,md,ii,rr,cc,dd)
      implicit none
      integer mi,mr,mc,md,UDI,nd,ii2,ir2,lx,lmax,ii3,nl,ii4,ir3,ir4,nr,
     & ir5,ir6,nq,npr,ir7,ir8,ir9,ic2,ic3,kprt,neqp,npa,iout,
     & ibid1,UHE,ii(mi),mss,ncode,nts
      real rbid1,rr(mr),tss,tts
      complex cc(mc)
      double precision dd(md)
      character cbid1*1
      common/ioprg/ kprt
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      common/dsph/ nr,nl,nq,npr,npa,lmax
      call dimss(UDI,nd,mi,mr,mc,md,ii(1),rr(1))
      ii2=1+nd
      ir2=1+nd
      lx=lmax+1
      ii3=ii2+nl
      ii4=ii3+nl
      ir3=ir2+nl
      ir4=ir3+nr
      ir5=ir4+nr
      ir6=ir5+nq*(npr+1)
      ir7=ir6+nq
      ir8=ir7+nq
      ir9=ir8+nl
      ic2=1+lx*nq
      ic3=ic2+lx*nq
      if(kprt.ne.0) write(6,2010)
      call elmns(UDI,UHE,nd,nl,nr,nq,neqp,npr,npa,lmax,
     . ii(1),ii(ii2),ii(ii3),ii(ii4),rr(1),rr(ir2),rr(ir3),rr(ir4),
     . rr(ir5),rr(ir6),rr(ir7),rr(ir8),rr(ir9),rr(ir7),cc(1),cc(ic2),
     . cc(ic3),dd(1))
      return
2010  format(/' spherical harmonics coefficients')
      end
      subroutine sphbes(nq,npr,fun,sbes,sqr)
      implicit none
      integer nq,npr,n,l,lmax,j
      real divb,divh,fun,sbes,sqr
      double precision darg,arg,v2,v1,v0
      dimension fun(nq,0:npr),sbes(2*nq+2),sqr(nq)
      common/ctlf/ divb,divh
      do 10 n=1,nq
      l=2*n
      sqr(n)=dsqrt(1.d0/(2*l+3))
      fun(n,0)=0.
10    continue
      lmax=2*nq+2
      arg=0.d0
      darg=1/divb
      do 60 j=1,npr
      do 20 l=1,lmax
      sbes(l)=0.
20    continue
      arg=arg+darg
      v2=dsin(arg)/arg
      v1=(v2-dcos(arg))/arg
      do 30 l=2,lmax
      v0=(2*l-1)*v1/arg-v2
      if(mod(l,2).eq.0) sbes(l)=v0
      if(dabs(v1).le.1.d-6.and.dabs(v0).le.1.d-6) go to 40
      v2=v1
      v1=v0
30    continue
40    do 50 n=1,nq
      l=2*n
      fun(n,j)=(sbes(l)+sbes(l+2))*sqr(n)
50    continue
60    continue
      return
      end
C     =============================
      SUBROUTINE SPHHAR(L,NPA,LMAX,YLM,CEX,FACT,FIRST)
C     ================================================
C
C     .. Scalar Arguments ..
      INTEGER L,LMAX,NPA
      LOGICAL FIRST
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION FACT(0:2*LMAX+1)
      COMPLEX CEX(0:2*NPA)
      REAL YLM(0:NPA,0:L)
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION ANG,COSA,E0,E1,SINA,U0,V0,V1,VCOT,W0,W1
      COMPLEX TWOPII
      INTEGER J0,K0,K1,KCOT,LL,M,N,NPA2,NPAS2
      LOGICAL ZAXE
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ATAN2,COS,DBLE,EXP,INT,LOG,MOD,SIGN,SIN,SQRT
C     ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA TWOPII/ (0.0,6.2831853)/,E0/0.2718281828459045D1/,
     +     E1/0.3678794411714423D0/
C     ..
C
      IF (FIRST) THEN
        FACT(0) = 0.0D0
C
        DO 10 LL = 1,2*LMAX + 1
          FACT(LL) = FACT(LL-1) + LOG(DBLE(LL))
   10   CONTINUE
C
        W0 = -LOG(2.0D0)
C
        DO 20 LL = 0,LMAX
          FACT(LL) = FACT(2*LL+1)/2 - FACT(LL) + LL*W0
   20   CONTINUE
C
        NPAS2 = NPA/2
        NPA2  = 2*NPA
C
        DO 30 M = 0,NPA2
          CEX(M) = EXP(M*TWOPII/NPA2)
   30   CONTINUE
C
C Reported as failing in some compliers
C        ANG = ATAN2(1.0D0,0.0D0)/NPAS2
        ANG = 2 * ATAN2(1.0D0,1.0D0) / NPAS2
        FIRST = .FALSE.
      END IF
C
      DO 80 N = 0,NPAS2
        ZAXE = N .EQ. 0
        IF (ZAXE) THEN
          K0 = 0
          V0 = SQRT(ABS(DBLE(2*L+1)))
        ELSE
          COSA = COS(N*ANG)
          SINA = SIN(N*ANG)
          IF (N.EQ.NPAS2) THEN
            KCOT = 0
            VCOT = 0.0D0
          ELSE
            V0 = COSA/SINA
            W0 = LOG(ABS(V0))
            K0 = INT(W0)
            W0 = MOD(W0,1.0D0)
            IF (W0.GT.0.0D0) THEN
              K0 = K0 + 1
              W0 = W0 - 1
            END IF
            KCOT = K0
            VCOT = SIGN(EXP(W0),V0)
          END IF
C
          W0 = LOG(SINA)*L + FACT(L)
          K0 = INT(W0)
          W0 = MOD(W0,1.0D0)
C
          IF (W0.GT.0.0D0) THEN
            K0 = K0 + 1
            W0 = W0 - 1
          END IF
C
          V0 = EXP(W0)
          K1 = K0 + KCOT
          V1 = 0.0D0
        END IF
C
        DO 70 M = L,0,-1
          YLM(N,M) = 0.0
          YLM(NPA-N,M) = 0.0
C
          IF (ZAXE) THEN
            IF (M.NE.0) GO TO 70
            GO TO 60
          END IF
C
          IF (M.EQ.L) GO TO 60
          W0 = - (M+1)*2/SQRT(ABS(DBLE((L+M+1)* (L-M))))
          W1 = -SQRT(ABS((L-M-1)* (L+M+2)/DBLE((L+M+1)* (L-M))))
          J0 = K0
          U0 = V0
          K0 = K0 + KCOT
C
          IF (K0.GT.K1) THEN
            V1 = EXP(DBLE(K1-K0))*V1
          ELSE IF (K1.GT.K0) THEN
            V0 = EXP(DBLE(K0-K1))*V0
            K0 = K1
          END IF
C
          W0 = W0*VCOT*V0 + W1*V1
          K1 = J0
          V1 = U0
          V0 = ABS(W0)
          IF (V0.EQ.0.0D0) GO TO 60
C
          IF (V0.GT.1.0D0) THEN
   40       K0 = K0 + 1
            V0 = V0*E1
            IF (V0.GT.1.0D0) GO TO 40
          END IF
C
          IF (V0.LT.E1) THEN
   50       K0 = K0 - 1
            V0 = V0*E0
            IF (V0.LT.E1) GO TO 50
          END IF
C
          V0 = SIGN(V0,W0)
   60     W0 = 0.0D0
          IF (K0.GT.-37) W0 = V0*EXP(DBLE(K0))
          YLM(N,M) = REAL(W0)
          YLM(NPA-N,M) = (-1)**MOD(L-M,2)*REAL(W0)
   70   CONTINUE
   80 CONTINUE
      RETURN
      END
C
C
C     =============================
      SUBROUTINE STFNDO(T3,T2,O1,ND,MI,MR,MC,II,RR,CC)
C     ================================================
C
C     .. Scalar Arguments ..
      INTEGER MC,MI,MR,ND,O1,T2,T3
C     ..
C     .. Array Arguments ..
      COMPLEX CC(MC)
      REAL RR(MR)
      INTEGER II(MI)
C     ..
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,BID1,BID5,DB,DRMIN
      INTEGER IBID1,KPRT,NDT,UFC,UMP,BID4
C     ..
C     .. Arrays in Common ..
      REAL BID2,BID3
C     ..
C     .. Local Scalars ..
      REAL DSQ,FUZZM,SQH
      INTEGER H,K,L
C     ..
C     .. External Subroutines ..
      EXTERNAL DATAMF,XFFTH
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C     ..
C     .. Common blocks ..
      COMMON /FOZO/BID3(2),DB,IBID1,BID4,BID5,BTABCORRN
      COMMON /IOPRG/KPRT
      COMMON /RESO/BID1,DRMIN,BID2(4)
      COMMON /STAR/A11,A21,A22,A31,A32,A33
      COMMON /TAPES/UMP,UFC,NDT
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA FUZZM/0.9999/
C     ..
C
      UMP = T3
      UFC = O1
      IF(KPRT.NE.0) WRITE (6,FMT=6000)
      DSQ = 0.0
C
      DO 30 H = -1,1
        DO 20 K = -1,1
          DO 10 L = -1,1
            SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
            IF (SQH.GT.DSQ) DSQ = SQH
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
      DRMIN = FUZZM/ (1.0/DRMIN+SQRT(ABS(DSQ)))
      DB = -DB
C
C          ********************************
      CALL DATAMF(UMP,T2,ND,MI,MR,MC,II(1))
C          ********************************
C
      NDT = ND
C
C          *******************************************
      CALL XFFTH(T2,MI,MR,MC,II(1),RR(1),CC(1))
C          *******************************************
C
      RETURN
 6000 FORMAT (/' ****** S/R STFNDO ******')
      END
C
C
C     =============================
      SUBROUTINE SYMPAC(H,K,L,INDEX,TEST)
C     ===================================
C
C     .. Scalar Arguments ..
      INTEGER H,INDEX,K,L
      LOGICAL TEST
C     ..
C     .. Scalars in Common ..
      INTEGER NEQ,NEQP
C     ..
C     .. Arrays in Common ..
      REAL TSS
      INTEGER MSS
C     ..
C     .. Local Scalars ..
      REAL PR
      INTEGER HH,IIND,IR,KK,LL,N
C     ..
C     .. External Subroutines ..
      EXTERNAL PAC3
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD,NINT
C     ..
C     .. Common blocks ..
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      TEST = .TRUE.
C
C ejd - I think this should use ALL sym ops; not finding C centred absences
C  New Check for sys abs
        IF(NTS.GT.0) THEN
          DO ITS = 1,NTS
            PR = MOD(TTS(1,ITS)*H+TTS(2,ITS)*K+TTS(3,ITS)*L,1.0)
            IR = MOD(NINT(12*PR)+12,12)
            IF (IR.NE.0) GO TO 80
          END DO 
        END IF
C
      DO 70 N = 1,NEQP
C
        HH = MSS(1,1,N)*H + MSS(2,1,N)*K + MSS(3,1,N)*L
        KK = MSS(1,2,N)*H + MSS(2,2,N)*K + MSS(3,2,N)*L
        LL = MSS(1,3,N)*H + MSS(2,3,N)*K + MSS(3,3,N)*L
C
C
        IF (HH) 30,10,60
   10   IF (LL) 60,20,40
   20   IF (KK) 60,60,50
   30   HH = -HH
   40   LL = -LL
   50   KK = -KK
C
C       ************************
   60   CALL PAC3(HH,KK,LL,IIND)
C       ************************
C
        IF (IIND.LE.INDEX) GO TO 80
   70 CONTINUE
C
      RETURN
   80 TEST = .FALSE.
      RETURN
      END
C
C
C     =============================
      SUBROUTINE TABLING
C     ================== 
C
C     The dimensions here are influenced by the SCALE and resolution and
C     molecular shape, and are very hard to predict
C
C MA=nat
C MI=max(nat+nats+nz,nr+nd)
C MR=max(nx*ny+4*(nat+nats),2*mt+2*nd)
C MC=nd
C    NAT     =nb. atoms in PDB file
C    NATS    =nb. atoms per section
C    NX,NY,NZ=cell divisions
C    ND      =100000
C    NR      =nb. reflections, 500,000
C    MT      =dimension of interpolation array (h+2)*(2*k+1)*(2*l+1)
C         = 2,200,000
C
C     .. Parameters ..
      INTEGER MI,MR,MC
CBIG      PARAMETER (MI=1500000,MR=5400000,MC=100000)
C      PARAMETER (MI=5000000,MR=4400000,MC=100000,MA=50000)
C     ..
C     .. External Subroutines ..
      EXTERNAL TABLNDO, CCPALE
      INTEGER NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB
C  NRC NEQPC - no of reflns and no of primitive sym ops for crystal
C  MITAB MCTAB needed for tabling
C  MCTAB set = 100000
C  NRH1  no of reflns for HKLPCK1 
C  MHKLTAB - the big array from the table: (2*KMAX+1)* (IHMAX+2)* (2*LMAX+1)
      COMMON /SETSIZE/ NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB 
C     ..
C      CHARACTER TYPE (4), LENG (4)*10
C      INTEGER LENDEF (4)
C      DATA TYPE /'I', 'R', 'C', 'R'/,
C     +     LENG/'TABLING_MI', 'TABLING_MR', 'TABLING_MC','TABLING_MA'/,
c     +     LENDEF /MI, MR, MC, MA/
cC
c      CALL CCPALE (TABLNDO, 4, TYPE, LENG, LENDEF, .TRUE.)
      CHARACTER TYPE (3), LENG (3)*10
      INTEGER LENDEF (3)
       DATA TYPE /'I', 'R', 'C'/
       DATA LENG/'TABLING_MI', 'TABLING_MR', 'TABLING_MC'/
C
C      CALL CCPALE (TABLNDO, 3, TYPE, LENG, LENDEF, .TRUE.)
      MI =  MITAB/2 + MCTAB
      MR =  2*MITAB
      MC =  MCTAB
      LENDEF (1) = MI
      LENDEF (2) = MR
      LENDEF (3) = MC
      CALL CCPALE (TABLNDO, 3, TYPE, LENG, LENDEF, .TRUE.)
C      CALL CCPALC (TABLNDO, 3, TYPE, LENDEF)
      END
C
C
C     =============================
      SUBROUTINE TABLNDO(MI,II,MR,RR,MC,CC)
C     ===========================================
C
      INTEGER MA
C     MA is number of atoms in PDB file
      PARAMETER (MA=50000)
C     .. Scalar Arguments ..
      INTEGER MC,MI,MR
C     ..
C     .. Array Arguments .. Array XXX a dummy used to pass 
C        MA(number of atoms) into SR
      COMPLEX CC(MC)
      REAL RR(MR)
      INTEGER II(MI)
C     ..
C     .. Scalars in Common ..
      REAL BID2,BID4,BOXSC,BTISO,DB,DRMIN,RMIN
      INTEGER HMAX,IBID2,IVERB,KISO,KMAX,KPRT,LMAX,MTAB,
     +        NAT,NSYM,NSYMP,NX,NY,NZ
      CHARACTER TITLE*72
C     ..
C     .. Arrays in Common ..
      REAL BCRD,BID3,BID5,BOXSCT,BTISOT,DRMNT,FMAXC,FMINC,RSYM,SHARTT,
     +     TFACC,CMASS,EULER
      INTEGER HM,ITABB,ITABS,ITABT,KPRTT,ISHIFT
C     ..
C     .. Local Scalars ..
      REAL SHARAT
      INTEGER IFAIL,IOPT,IT,ITAB,IXYZIN,JXYZOUT,MRR,ND,T2,T3,IXYZ,
     +        TMI,TMR,TMC
      CHARACTER FILNAM*10,IXYZLOG*10,JXYZLOG*10
C     ..
C     .. Local Arrays ..
      CHARACTER CH(MA)*18
C     ..
C     .. External Subroutines ..
      EXTERNAL CARNDO,CCPDPN,CCPERR,STFNDO,TABNDO,XYZCLOSE,
     +         XYZOPEN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MIN
C     ..
c      COMMON /OUTAB/BOXM(3),RMAX,CM(3),AL,BE,GA,VAL(3),BID1,NAT,IBID2,
c     +              BOXSC
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
C     .. Common blocks ..
      COMMON /ALLFNC/TITLE
      COMMON /ALLFUN/IVERB,ITABB(5),FMINC(5),FMAXC(5),TFACC(5),NSYM,
     +       NSYMP,RSYM(4,4,96)
      COMMON /CELOBS/AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS(3,3),NCDOBS
      COMMON /CNTRL/ISORT,ITAB,IROT,ITRA,IFIT,IMR,JSFO
      COMMON /FOZO/BID5(2),DB,IBID2,KISO,BTISO,BTABCORRN
      COMMON /GRID/HMAX,KMAX,LMAX,NX,NY,NZ
      COMMON /IOPRG/KPRT
      COMMON /OPRT/KPRTT(20)
      COMMON /INTAB/ISHIFT(4),CMASS(3,4),EULER(3,4)
      COMMON /OUTAB/BCRD(14),NAT,MTAB,BOXSC
      COMMON /RESO/BID2,DRMIN,BID3(2),RMIN,BID4
      COMMON /TABLFUN/ITABS(4),ITABT(4),BOXSCT(4),BTISOT(4),DRMNT(4),
     +       SHARTT(4),BTABCORR(4)
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA T2/0/
C     ..
C
      KPRT = IVERB
      KPRTT(1) = IVERB
      KPRTT(2) = IVERB
      KPRTT(3) = IVERB
      KPRTT(4) = IVERB
      KPRTT(5) = IVERB
      KPRTT(6) = IVERB
      KPRTT(7) = IVERB
C
C----  IXYZ - xyzin ; itab - ??? - iout(=9) in calling prog
C
      IXYZ = 0
      JSFO = 0
C  No output of a table.
      JTAB = 0
       IF(ITAB.GT.0) JTAB = 1
C  Prepare for ASCII structure factor list
       IF(ITAB.GT.1) JSFO = 67
C
C----  Can prepare several TABLES at once. - assign XYZIN1,XYZIN2..
C             (ITABS(..) > 0           output XYZOUT1.. (optional)
C             (ITABT(..) NE 0           output TABLE1..  (optional)
C
      DO 10 IT = 1,4
        IXYZLOG = ' '
        JXYZLOG = ' '
C
C----  Want to rotate molecule.
C
        IF (ITABS(IT).EQ.0 .AND. ITABT(IT).EQ.0) GO TO 10
C
C----   open XYZIN? - PDB formatted file of model cds
C
C  IOPT flag for outputting XYZOUT - =1 ROT and SHIFT; =2 SHIFT only
          IOPT = 1 
          IF (ITABS(IT).EQ.0) IOPT = 2
          IF (ITABT(IT).LT.0) IOPT = 3
          WRITE (IXYZLOG,FMT='(A5,I1)') 'XYZIN',IT
          IXYZ = 1
          IFAIL = 1
          IXYZIN = 0
          JXYZOUT = 0
C
C              *****************************************
          CALL XYZOPEN(IXYZLOG,'INPUT',' ',IXYZIN,IFAIL)
C              *****************************************
C
C----   open XYZOUT - PDB formatted file of rotated cds
C
          WRITE (JXYZLOG,FMT='(A6,I1)') 'XYZOUT',IT
C
C              ******************************************
          CALL XYZOPEN(JXYZLOG,'OUTPUT',' ',JXYZOUT,IFAIL)
C              ******************************************
          CALL WBSPGRP('P 1')
C
C        END IF
C
C----  Do you want a table? Actually this file is used FIRST as a scratch file
C----        then for the TABLE
C
          FILNAM = ' '
          WRITE (FILNAM,FMT='(A5,I1)') 'TABLE',IT
C
C              **********************************
          CALL CCPDPN(1,FILNAM,'NEW','U',0,IFAIL)
C              **********************************
C
C----  Do you want a structure factor list? output 
          IF(JSFO.NE.0) THEN
           FILNAM = ' '
           WRITE (FILNAM,FMT='(A6,I1)') 'HKLOUT',IT
C              ************************************
           CALL CCPDPN(JSFO,FILNAM,'NEW','F',0,IFAIL)
C              ************************************
          END IF
C
C----  JXYZ will contain rotated molecule.
C      Set input
C
        BOXSC = BOXSCT(IT)
        DRMIN = DRMNT(IT)
        SHARAT = SHARTT(IT)
        KISO = 0
        BTISO = 0
        DB = 0
        IF (BTISOT(IT).NE.0) KISO = 1
        IF (BTISOT(IT).NE.0) BTISO = BTISOT(IT)
        IF (BTABCORR(IT).NE.0) BTABCORRN = BTABCORR(IT)
        IF (TFACC(IT+1).NE.0.0) DB = TFACC(IT+1)
C
C----  T2 a scratch file. used for storing sorted XYZs
C
C               ***************************************
        IFAIL = 0
        CALL CCPDPN(T2,'TEMP2','SCRATCH','U',80,IFAIL)
C               ***************************************
C
        WRITE (6,FMT=6000) TITLE
        IF (IOPT.EQ.1) WRITE (6,FMT=*)
     +   ' Rotate model to smallest box and move to origin'
        IF (IOPT.EQ.2) WRITE (6,FMT=*)
     +   ' Move model coordinates to origin'
        IF (IOPT.EQ.3) WRITE (6,FMT=*)
     +   ' Do not move model coordinates at all '
        IF (SHARAT.LT.1.0) SHARAT = 1.0
        RMIN = DRMIN/SHARAT
        IF (MR.LT.4*MA) GO TO 20
C        WRITE (6,FMT=8801) IOPT,BOXSC,DRMIN,SHARAT,KISO,BTISO,DB
C8801    FORMAT(
C     +         ' Debug Checks for Subroutine : TABLNDO',/,
C     +         ' IOPT   = ',I6,/,
C     +         ' BOXSC  = ',F6.2,/,
C     +         ' DRMIN  = ',F6.2,/,
C     +         ' SHARAT = ',F6.2,/,
C     +         ' KISO   = ',I6,/,
C     +         ' BTISO  = ',F6.2,/,
C     +         ' DB     = ',F6.2)
C
C---- Set T3 = JTAB
C
        T3   = 1
        ND   = 100000
C
C----  Reads coordinates - 
C         moves to origin, works out ppl axes of inertia,
C         and rotates if required.
C
        IF (JTAB .EQ. 0) IXYZ = -IXYZ
C
C            *********************************************************
        CALL CARNDO(IXYZIN,JXYZLOG,JXYZOUT,IXYZ,T2,T3,IOPT,MA,MI,MR,CH,
     +                                                           II,RR)
C            *********************************************************
C
        MRR = MIN(1000000,MR)
        IF (JTAB.EQ.0) RETURN
C
C   We are going on; ie JTAB = T3 = 1
C                              T3 now contains a SCRATCH file, but will be 
C                               rewritten as the TABLE ( JTAB)
C
C----  prepares the table.
C
C            **************************************
        CALL STFNDO(T3,T2,T3,ND,MI,MRR,MC,II,RR,CC)
C            **************************************
C
        IF (KPRT.NE.0)
     + WRITE(6,6004) 2* (HMAX+2)* (2*KMAX+1)* (2*LMAX+1)+2*ND,MR
        IF (2* (HMAX+2)* (2*KMAX+1)* (2*LMAX+1)+2*ND.GT.MR) GO TO 30
C
C            *****************************************************
        CALL TABNDO(T3,JTAB,ND,HMAX,KMAX,LMAX,II,RR(1),RR(1+2*ND))
C            *****************************************************
C
        WRITE (6,FMT=6002) NAT,(BCRD(JDO11),JDO11=1,14)
        IF(AOBS*BOBS*COBS.GT.0.0)
     +       WRITE (6,'(A,3F9.4)')
     +'                         Frac. CoM     :',
     +       BCRD(5)/AOBS,BCRD(6)/BOBS,BCRD(7)/COBS
        WRITE (6,'(A,I12)') 
     +'          Dimension of array (Complex) :',MTAB
       ISHIFT(IT) = IT
      DO 11 JDO11=1,3
        CMASS(JDO11,IT) = BCRD(JDO11+4)
        EULER(JDO11,IT) = BCRD(JDO11+7)
 11   CONTINUE
      IF(T2.NE.0) CLOSE (T2)
      IF (IXYZIN .NE. 0) CALL XYZCLOSE(IXYZIN)
   10 CONTINUE
C
      RETURN
C
   20 WRITE (6,FMT=6004) 4*MA,MR
C
C          *************************************
      CALL CCPERR(1,'Reset TABLING_MR')
   30 WRITE (6,FMT=6004) 2* (HMAX+2)* (2*KMAX+1)* (2*LMAX+1)+2*ND,MR
      CALL CCPERR(1,
     + 'Reset TABLING_MR to 2* (HMAX+2)* (2*KMAX+1)* (2*LMAX+1)+2*ND')
C          ***********************************
C
 6000 FORMAT (/' ****** PROGRAMME TABLING ******',//A)
 6002 FORMAT (
     +' TABLING: ',/,
     +' =========',//,
     +'  The Center of Mass of the',I10,' Input Coordinates',/,
     +'  (Orthogonalized if necessary with NCODE=1)',/,
     +'  Have been Translated to the Origin and then Rotated',//,
     +'                         Minimal Box   :',3F9.2,/,
     +'                         Minimal Sphere:', F9.2,/,
     +'                         Center of Mass:',3F9.2,/,
     +'                         Rotation      :',3F9.2,/,
     +'                        Inertia Moments:',3F9.2,/,
     +'   Resolution Limit for Interpolation  :',F9.2)

 6004 FORMAT (
     +' Dimensions for TABLNDO',/,
     +' TABLING_MR is 2*(HMAX+2)*(2*KMAX+1)*(2*LMAX+1)+2*ND',/,
     +' (REAL)    TABLING_MR(required) MR(set):',2I10)
C
C          *********************************************
      CALL CCPERR(1, 'Failure in XYZIN or XYZOUT open')
C          *********************************************
C
      END
C
C
C     =============================
      SUBROUTINE TABMOD(T3,ND,HMAX,KMAX,LMAX,HSUP,KSUP,LSUP,SQHSUP,HKLO,
     +                  FO,FT)
C     =================================================================
C
C     .. Scalar Arguments ..
      REAL SQHSUP
      INTEGER HMAX,HSUP,KMAX,KSUP,LMAX,LSUP,ND,T3
C     ..
C     .. Array Arguments ..
      COMPLEX FO(ND),FT(-1:HMAX,-KMAX:KMAX,-LMAX:LMAX)
      INTEGER HKLO(ND)
C     ..
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,BID2,DMIN,BID5
      INTEGER KPRT,MTAB,NAT
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      COMPLEX F,FF
      REAL DSQ,SQH,FC1,PHIC1,FC2,PHIC2,G(2)
      INTEGER H,I,IX1,K,L,M
C     ..
C     .. External Subroutines ..
      EXTERNAL UNPAC4
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,CONJG,MOD,SQRT
C     ..
C     .. Common blocks ..
c      COMMON /FOZO/BID5(2),DB,IBID2,KISO,BTISO,BTABCORRN
      COMMON /FOZO/BID5(6),BTABCORRN
      COMMON /IOPRG/KPRT
      COMMON /OUTAB/BID1(13),DMIN,NAT,MTAB,BID2
      COMMON /STAR/A11,A21,A22,A31,A32,A33
      COMMON /paco/hm,KM,LM,NH,NKK,NL,NM
C     ..
C     .. Equivalences ..
      EQUIVALENCE (FF,G(1))
C     ..
C     .. Save statement ..
      SAVE
C     ..
c      TFAC = -14
C
      HSUP = 0
      KSUP = 0
      LSUP = 0
      SQHSUP = 0.0
C
      DO 30 L = -LMAX,LMAX
        DO 20 K = -KMAX,KMAX
          DO 10 H = -1,HMAX
            FT(H,K,L) = (0.0,0.0)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
      IF(T3.NE.0) REWIND (T3)
   40 READ (T3,END=60) M,HKLO,FO
      IF (M.GT.ND) GO TO 130
C
      DO 50 I = 1,M
C
C            *************************
c        CALL UNPAC4(H,K,L,IX1,HKLO(I))
        CALL UNPAC3(H,K,L,HKLO(I))
C            *************************
C
        SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
C
        IF (SQH.GT.SQHSUP) SQHSUP = SQH
        IF (ABS(H).GT.HSUP) HSUP = ABS(H)
        IF (ABS(K).GT.KSUP) KSUP = ABS(K)
        IF (ABS(L).GT.LSUP) LSUP = ABS(L)
C
        IF (HSUP.GT.HMAX .OR. KSUP.GT.KMAX .OR.
     +      LSUP.GT.LMAX) GO TO 140
C        F = FO(I)
        F = FO(I)*EXP(-BTABCORRN*SQH/4)
        IF (MOD(H+K+L,2).NE.0) F = -F
        FT(H,K,L) = F
c            FF = FO(I)
c            FC1= SQRT( ABS(G(1)*G(1) + G(2)*G(2)))
c            PHIC1= 0.0
c            IF( FC1.GT.0.0000001) PHIC1= 57.29578*ATAN2(G(2),G(1))
c            FF = F
c            FC2= SQRT( ABS(G(1)*G(1) + G(2)*G(2)))
c            PHIC2= 0.0
c            IF( FC2.GT.0.0000002) PHIC2= 57.29578*ATAN2(G(2),G(1))
c        write(20,'(3i4,2(F15.3,F8.2))')H,K,L,FC1,PHIC1,FC2,PHIC2
   50 CONTINUE
C
      GO TO 40
C
C---- pacote
C
   60 CONTINUE
C
      DO 90 L = -LMAX,LMAX
        DO 80 K = -KMAX,KMAX
          DO 70 H = 0,1
            FT(-H,-K,-L) = CONJG(FT(H,K,L))
   70     CONTINUE
   80   CONTINUE
   90 CONTINUE
C
      DSQ = 0.0
C
      DO 120 H = -1,1
        DO 110 K = -1,1
          DO 100 L = -1,1
            SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
            IF (SQH.GT.DSQ) DSQ = SQH
  100     CONTINUE
  110   CONTINUE
  120 CONTINUE
C
      DMIN = 1/ (SQRT(ABS(SQHSUP))-SQRT(ABS(DSQ)))
      MTAB = (2*KSUP+1)* (HSUP+2)* (2*LSUP+1)
      IF (KPRT.NE.0) THEN
       WRITE (6,FMT=*) ' TABMOD:'
       WRITE (6,FMT=*) ' H,K,L limits for array:',HSUP,KSUP,LSUP
       WRITE (6,FMT=*) ' Resolution Limit:',SQRT(ABS(1/SQHSUP))
       WRITE (6,FMT=*) ' Resolution Limit for interpolation:',DMIN
       WRITE (6,FMT=*) 
     + ' Dimension of Array:( (2*KLIM+1)* (HLIM+2)* (2*LLIM+1)',MTAB
      ENDIF
      RETURN
C
  130 WRITE (6,FMT=6000) M,ND
C
C          ***********************************
      CALL CCPERR(1,' > s/r tabmod < m > nd:')
C          ***********************************
C
  140 WRITE (6,FMT=6002) H,K,L
C
C          *********************************************
      CALL CCPERR(1,' > s/r tabmod < h k l out of box:')
C          *********************************************
C
 6000 FORMAT (' > S/R TABMOD < M > ND:',2I10)
 6004 FORMAT (
     +' Problem in TABMOD',/,
     +' (REAL)    M(required) ND(set):',2I10)
 6002 FORMAT (' > S/R TABMOD < H,K,L OUT OF BOX:',3I5)
      END
C
C
C     =============================
      SUBROUTINE TABNDO(T3,JTAB,NR,HMAX,KMAX,LMAX,II,RR,CC)
C     =====================================================
C
C     .. Scalar Arguments ..
      INTEGER HMAX,JTAB,KMAX,LMAX,NR,T3
C     ..
C     .. Array Arguments ..
      COMPLEX CC((HMAX+2)* (2*KMAX+1)* (2*LMAX+1))
      REAL RR(2*NR)
      INTEGER II(NR)
C     ..
C     .. Local Scalars ..
      REAL SQHSUP 
      INTEGER HSUP,KSUP,LSUP,ND
C     ..
C     .. External Subroutines ..
      EXTERNAL MINTAB,TABMOD
C     ..
C
      WRITE (6,FMT=6000)
      IF(T3.NE.0) REWIND (T3)
      READ (T3) ND
      IF (ND.NE.NR) GO TO 10
C
C          ***********************************************************
      CALL TABMOD(T3,ND,HMAX,KMAX,LMAX,HSUP,KSUP,LSUP,SQHSUP,II(1),
     +            RR(1),CC(1))
      CALL MINTAB(JTAB,HMAX,KMAX,LMAX,HSUP,KSUP,LSUP,SQHSUP,CC(1),CC(1))
C          ***********************************************************
C
      RETURN
C
   10 WRITE (6,FMT=6002) ND,NR
C
C          ************************************
      CALL CCPERR(1,'Inconsistent dimensions in TABLE /TABLNDO')
C          ************************************
C
 6000 FORMAT (/' ****** S/R TABNDO ******')
 6002 FORMAT (
     +' Dimensions for TABNDO',/,
     +' (REAL)    ND(required) ND(set in TABLNDO):',2I10)
      END
C
C
C     =============================
      SUBROUTINE TCLMN(IXL,UHE,T1,LMAX,NQ,DLMM,CLMN,CLM)
C     ==================================================
C
C     .. Scalar Arguments ..
      INTEGER IXL,LMAX,NQ,T1,UHE
C     ..
C     .. Array Arguments ..
      COMPLEX CLM(0:LMAX),CLMN(0:LMAX,NQ),DLMM(*)
C     ..
C     .. Scalars in Common ..
      INTEGER LMIN,LSUP
C     ..
C     .. Arrays in Common ..
      REAL BID1
      INTEGER IBID1,IBID2,IBID3,NDIM,NSYM
C     ..
C     .. Local Scalars ..
      COMPLEX C1,CLMS
      INTEGER IT,ITD,L,L1,M,M1,M1P,N,NN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,CONJG,MOD
C     ..
C     .. Common blocks ..
      COMMON /DROTT/IBID1(7),LMIN,LSUP,IBID2(3)
      COMMON /XALS/BID1(2),NSYM(2),IBID3(2),NDIM(2)
C     ..
      SAVE
C
      IF(T1.NE.0) REWIND (T1)
      IT = 0
C
      DO 80 L = 2,LSUP,2
        READ (UHE) L1,NN
        IF (L1.NE.L) GO TO 90
C
        DO 20 M = 0,L
          DO 10 N = 1,NN
            CLMN(M,N) = (0.0,0.0)
   10     CONTINUE
   20   CONTINUE
C
        READ (UHE) ((CLMN(M,N),N=1,NN),M=0,L,NSYM(IXL))
        IF (L.LT.LMIN) GO TO 70
C
        DO 60 N = 1,NN
          ITD = IT
          DO 30 M1 = 0,L,NSYM(IXL)
            CLM(M1) = CLMN(M1,N)
   30     CONTINUE
C
          DO 50 M1 = 0,L
            CLMS = (0.0,0.0)
            DO 40 M1P = -L,L
              IF (MOD(M1P,NSYM(IXL)).NE.0) GO TO 40
              C1 = CLM(ABS(M1P))
              IF (M1P.LT.0) C1 = CONJG(C1)* (-1)**MOD(M1P,2)
              ITD = ITD + 1
              CLMS = DLMM(ITD)*C1 + CLMS
   40       CONTINUE
            CLMN(M1,N) = CLMS
   50     CONTINUE
   60   CONTINUE
C
        IT = ITD
   70   WRITE (T1) L1,NN
        WRITE (T1) ((CLMN(M,N),N=1,NN),M=0,L)
   80 CONTINUE
C
      IF (IT.NE.NDIM(IXL)) GO TO 100
      IF(T1.NE.0) REWIND (T1)
      NSYM(IXL) = 1
      IF(UHE.NE.0) REWIND (UHE)
      READ (UHE)
      RETURN
C
   90 WRITE (6,FMT=6000) IXL
C
C          ************************************************************
      CALL CCPERR(1,' > s/r tclmn < incoherent harmonic coefficients.')
C          ************************************************************
C
  100 WRITE (6,FMT=6002) IT,NDIM(IXL)
C
C          **********************************************
      CALL CCPERR(1,' > s/r tclmn < mismatch. it, ndim:')
C          **********************************************
C
 6000 FORMAT (' > S/R TCLMN < INCOHERENT HARMONIC COEFFICIENTS. XAL:',
     +       I5)
 6002 FORMAT (' > S/R TCLMN < MISMATCH. IT, NDIM:',2I10)
      END
C
C
C     =============================
      SUBROUTINE TDLMM(IXL,II,DLMMR,DLMM,DD)
C     ======================================
C
C     .. Scalar Arguments ..
       PARAMETER (MSR1R=6)
      INTEGER IXL
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION DD(*)
      COMPLEX DLMM(*)
      REAL DLMMR(*)
      INTEGER II(*)
C     ..
C     .. Scalars in Common ..
      INTEGER KPRT,LMIN,LSUP,NLT
C     ..
C     .. Arrays in Common ..
      REAL BID1,RX
      INTEGER IBID1,IBID2,IBID3,NDIM,NR,NSR,NSYM
C     ..
C     .. Local Scalars ..
      REAL ALFA,BETA,DTOR,GAMA,PHI,PHIA
      INTEGER ID2,ID3,ID4,IT,L,M1,M1P,N
C     ..
C     .. Local Arrays ..
      INTEGER NSIM(2)
C     ..
C     .. External Subroutines ..
      EXTERNAL DLMMS
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC EXP,MOD
C     ..
C     .. Common blocks ..
      COMMON /ANGKTE/ PI,TWOPI,DTOR,RTOD
      COMMON /DROTT/IBID1(3),NLT,IBID2(3),LMIN,LSUP,IBID3(3)
      COMMON /IOPRG/KPRT
      COMMON /ROTFUN/IROTG(4),IROTC(5),IROTR,ISELF,DRMAXG(4),DRMING(4),
     +       CELLM(6,4),NCODC,DRMAXC,DRMINC,RMINC,RMAXC,LMINR,LSUPR,
     +       DANGR,BMAXR,NSR1R,NSR2R,RPTSR,DELTAR,NPICR,ANGNSR(3,MSR1R)
      COMMON /SROTT/RX(3,2),NR(2)
      COMMON /XALS/BID1(2),NSYM(2),NSR(2),NDIM(2)
C     ..
      SAVE
C     ..
C
C   Note NSR(1) =NSR1 =NSR1R NSR(2) = NSR2 = NSRS2
      IF (KPRT.NE.0) WRITE (6,FMT=6000) IXL
      NSIM(1) = NSYM(1)
      NSIM(2) = NSYM(2)
      NSYM(1) = 1
      NSYM(2) = NSIM(IXL)
      NR(1)   = NSR(1)
      NR(2)   = NSR(2)
      ID2 = 1 + NLT
      ID3 = ID2 + NLT
      ID4 = ID3 + NLT
C
      DO 10 IT = 1,NDIM(IXL)
        DLMM(IT) = (0.0,0.0)
   10 CONTINUE
C
      DO 50 N = 1,NSR(IXL)
C        READ (5,FMT=*) ALFA,BETA,GAMA
        ALFA = ANGNSR(1,N)
        BETA = ANGNSR(2,N)
        GAMA = ANGNSR(3,N)
        RX(1,IXL) = ALFA
        RX(2,IXL) = BETA
        RX(3,IXL) = GAMA
        IF (KPRT.NE.0) WRITE (6,FMT=6002) ALFA,BETA,GAMA
        ALFA = ALFA*DTOR
        BETA = BETA*DTOR
        GAMA = GAMA*DTOR
C
C            *******************************************************
        CALL DLMMS(BETA,NDIM(IXL),LSUP,II(1),DLMMR(1),DD(1),DD(ID2),
     +             DD(ID3),DD(ID4))
C            *******************************************************
C
        IT = 0
C
        DO 40 L = LMIN,LSUP,2
          DO 30 M1 = 0,L
            PHIA = M1*ALFA
            DO 20 M1P = -L,L
              IF (MOD(M1P,NSYM(2)).NE.0) GO TO 20
              PHI = M1P*GAMA + PHIA
              IT = IT + 1
              DLMM(IT) = EXP((0.0,1.0)*PHI)*DLMMR(IT) + DLMM(IT)
   20       CONTINUE
   30     CONTINUE
   40   CONTINUE
C
        IF (IT.NE.NDIM(IXL)) GO TO 60
   50 CONTINUE
C
      NSYM(1) = NSIM(1)
      NSYM(2) = NSIM(2)
      RETURN
C
   60 WRITE (6,FMT=6004) IT,NDIM(IXL)
C
C          **********************************************
      CALL CCPERR(1,' > s/r tdlmm < mismatch. it, ndim:')
C          **********************************************
C
 6000 FORMAT (/' Shifts of XAL:',I5)
 6002 FORMAT (' Euler Angles:',3F10.3)
 6004 FORMAT (' > S/R TDLMM < MISMATCH. IT, NDIM:',2I10)
      END

C     ==================================================
      SUBROUTINE TELMN(IXL,UHE,T1,LMAX,NQ,DLMM,ELMN,ELM)
C     ==================================================
C
C     .. Scalar Arguments ..
      INTEGER IXL,LMAX,NQ,T1,UHE
C     ..
C     .. Array Arguments ..
      COMPLEX ELM(0:LMAX),ELMN(0:LMAX,NQ),DLMM(*)
C     ..
C     .. Scalars in Common ..
      INTEGER LMIN,LSUP
C     ..
C     .. Arrays in Common ..
      REAL BID1
      INTEGER IBID1,IBID2,IBID3,NDIM,NSYM
C     ..
C     .. Local Scalars ..
      COMPLEX C1,ELMS
      INTEGER IT,ITD,L,L1,M,M1,M1P,N,NN,MM
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,CONJG,MOD
C     ..
C     .. Common blocks ..
      COMMON /DROTT/IBID1(7),LMIN,LSUP,IBID2(3)
      COMMON /XALS/BID1(2),NSYM(2),IBID3(2),NDIM(2)
C     ..
      SAVE
C
      IF(T1.NE.0) REWIND (T1)
      IT = 0
C
      DO 80 L = 2,LSUP,2
        READ (UHE) L1,NN,MM
        NM = NN + MM
        IF (L1.NE.L) GO TO 90
C
        DO 20 M = 0,L
          DO 10 N = 1,NM
            ELMN(M,N) = (0.0,0.0)
   10     CONTINUE
   20   CONTINUE
C
        READ (UHE) ((ELMN(M,N),N=1,NM),M=0,L,NSYM(IXL))
        IF (L.LT.LMIN) GO TO 70
C
        DO 60 N = 1,NM
          ITD = IT
          DO 30 M1 = 0,L,NSYM(IXL)
            ELM(M1) = ELMN(M1,N)
   30     CONTINUE
C
          DO 50 M1 = 0,L
            ELMS = (0.0,0.0)
            DO 40 M1P = -L,L
              IF (MOD(M1P,NSYM(IXL)).NE.0) GO TO 40
              C1 = ELM(ABS(M1P))
              IF (M1P.LT.0) C1 = CONJG(C1)* (-1)**MOD(M1P,2)
              ITD = ITD + 1
              ELMS = DLMM(ITD)*C1 + ELMS
   40       CONTINUE
            ELMN(M1,N) = ELMS
   50     CONTINUE
   60   CONTINUE
C
        IT = ITD
   70   WRITE (T1) L1,NN,MM
        WRITE (T1) ((ELMN(M,N),N=1,NM),M=0,L)
   80 CONTINUE
C
      IF (IT.NE.NDIM(IXL)) GO TO 100
      IF(T1.NE.0) REWIND (T1)
      NSYM(IXL) = 1
      IF(UHE.NE.0) REWIND (UHE)
      READ (UHE)
      RETURN
C
   90 WRITE (6,FMT=6000) IXL
C
C          ************************************************************
      CALL CCPERR(1,' > s/r telmn < incoherent harmonic coefficients.')
C          ************************************************************
C
  100 WRITE (6,FMT=6002) IT,NDIM(IXL)
C
C          **********************************************
      CALL CCPERR(1,' > s/r telmn < mismatch. it, ndim:')
C          **********************************************
C
 6000 FORMAT (' > S/R TELMN < INCOHERENT HARMONIC COEFFICIENTS. XAL:',
     +       I5)
 6002 FORMAT (' > S/R TELMN < MISMATCH. IT, NDIM:',2I10)
      END

C
      subroutine tllim(ml,atl2,atl1,atl0,tlm)
      implicit none
      integer ml,l,j0,j2,msp,j,lmax,iout,kprt,ibid1
      real twopi,div,pct2,pct1,xmax,rmax,drmin,xmin,rmin,pas,tsup,x,tl,
     & xs,argm,argp,dlev,tlev,drmax,rbid1,atl2(ml),atl1(ml),atl0(ml),
     & tlm(ml),pi,dtor,rtod
      logical last
      character cbid1*1
      external ftl,dftl
      common/ioprg/ kprt
      common/reso/ drmax,drmin,rbid1(2),rmin,rmax
      common/dsph/ ibid1(5),lmax
      common/angkte/ pi,twopi,dtor,rtod
      data div,pct2,pct1/10.,1.e-4,75.e-2/
      xmax=twopi*rmax/drmin
      xmin=twopi*rmin/drmin
      last=.false.
      pas=1/div
      do 10 l=1,ml
      atl2(l)=1.e3
      atl1(l)=1.e3
      atl0(l)=1.e3
      tlm(l)=0.
10    continue
      j0=1
      j2=1
      msp=nint(ml*1.5*div)
      do 70 l=2,ml,2
      tsup=0.
      do 20 j=j0,msp
      x=pas*j
      call ftl(l,x,tl)
         if(tl.gt.tsup) then
      j0=j
      xs=x
      tsup=tl
         endif
20    continue
      if(j0.gt.msp) go to 901
      argm=xs-pas
      argp=xs+pas
      dlev=0.
      call zeroa(dftl,dlev,l,argm,argp,x)
      call ftl(l,x,tl)
      tlm(l)=tl
      atl0(l)=x
      do 30 j=j2,msp
      x=pas*j
      call ftl(l,x,tl)
         if(tl/tlm(l).gt.pct2) then
      argm=x-pas
      argp=x+pas
      tlev=pct2*tlm(l)
      call zeroa(ftl,tlev,l,argm,argp,x)
      atl2(l)=x
      j2=j
      go to 40
         endif
30    continue
40    if(j2.gt.msp) go to 901
      do 50 j=j2,msp
      x=pas*j
      call ftl(l,x,tl)
         if(tl/tlm(l).gt.pct1) then
      argm=x-pas
      argp=x+pas
      tlev=pct1*tlm(l)
      call zeroa(ftl,tlev,l,argm,argp,x)
      atl1(l)=x
      go to 60
         endif
50    continue
60    if(atl2(l).gt.xmax) go to 80
70    continue
      go to 902
80    lmax=l
      return
901   write(6,3010)
      call ccperr (1, ' Fatal error in s/r TLLIM')
902   write(6,3020)
      call ccperr (1, ' Fatal error in s/r TLLIM')
3010  format('stop >> tllim << sampling of bessel functions too small')
3020  format('stop >> tllim << lmax not found')
      end
C     =============================
      SUBROUTINE TQL2(NM,N,D,E,Z,IERR)
C     ================================
C
C     .. Scalar Arguments ..
      INTEGER IERR,N,NM
C     ..
C     .. Array Arguments ..
      REAL D(N),E(N),Z(NM,N)
C     ..
C     .. Local Scalars ..
      REAL C,C2,C3,DL1,EL1,F,G,H,P,R,S,S2,TST1,TST2
      INTEGER I,II,J,K,L,L1,L2,M,MML
C     ..
C     .. External Functions ..
      REAL PYTHAG
      EXTERNAL PYTHAG
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,SIGN
C     ..
C
      IERR = 0
      IF (N.EQ.1) GO TO 150
C
      DO 10 I = 2,N
        E(I-1) = E(I)
   10 CONTINUE
C
      F = 0.0
      TST1 = 0.0
      E(N) = 0.0
C
      DO 100 L = 1,N
        J = 0
        H = ABS(D(L)) + ABS(E(L))
        IF (TST1.LT.H) TST1 = H
        DO 20 M = L,N
          TST2 = ABS(E(M)) + TST1
          IF (TST2.EQ.TST1) GO TO 30
   20   CONTINUE
C
   30   IF (M.EQ.L) GO TO 90
   40   IF (J.EQ.30) GO TO 140
        J = J + 1
        L1 = L + 1
        L2 = L1 + 1
        G = D(L)
        P = (D(L1)-G)/ (E(L)*2.0)
        R = PYTHAG(P,1.0)
        D(L) = E(L)/ (SIGN(R,P)+P)
        D(L1) = (SIGN(R,P)+P)*E(L)
        DL1 = D(L1)
        H = G - D(L)
        IF (L2.GT.N) GO TO 60
C
        DO 50 I = L2,N
          D(I) = D(I) - H
   50   CONTINUE
C
   60   F = F + H
        P = D(M)
        C = 1.0
        C2 = C
        EL1 = E(L1)
        S = 0.0
        MML = M - L
C
        DO 80 II = 1,MML
          C3 = C2
          C2 = C
          S2 = S
          I = M - II
          G = E(I)*C
          H = C*P
          R = PYTHAG(P,E(I))
          E(I+1) = S*R
          S = E(I)/R
          C = P/R
          P = D(I)*C - S*G
          D(I+1) = (D(I)*S+C*G)*S + H
C
          DO 70 K = 1,N
            H = Z(K,I+1)
            Z(K,I+1) = Z(K,I)*S + C*H
            Z(K,I) = Z(K,I)*C - S*H
   70     CONTINUE
   80   CONTINUE
C
        P = -S*S2*C3*EL1*E(L)/DL1
        E(L) = S*P
        D(L) = C*P
        TST2 = ABS(E(L)) + TST1
        IF (TST2.GT.TST1) GO TO 40
   90   D(L) = D(L) + F
  100 CONTINUE
C
      DO 130 II = 2,N
        I = II - 1
        K = I
        P = D(I)
C
        DO 110 J = II,N
          IF (D(J).GE.P) GO TO 110
          K = J
          P = D(J)
  110   CONTINUE
C
        IF (K.EQ.I) GO TO 130
        D(K) = D(I)
        D(I) = P
C
        DO 120 J = 1,N
          P = Z(J,I)
          Z(J,I) = Z(J,K)
          Z(J,K) = P
  120   CONTINUE
  130 CONTINUE
C
      GO TO 150
  140 IERR = L
  150 RETURN
      END
C
C
C     =============================
      SUBROUTINE TQLRAT(N,D,E2,IERR)
C     ==============================
C
C     .. Scalar Arguments ..
      INTEGER IERR,N
C     ..
C     .. Array Arguments ..
      REAL D(N),E2(N)
C     ..
C     .. Local Scalars ..
      REAL B,C,F,G,H,P,R,S,T
      INTEGER I,II,J,L,L1,M,MML
C     ..
C     .. External Functions ..
      REAL ERRFN,PYTHAG
      EXTERNAL ERRFN,PYTHAG
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,SIGN,SQRT
C     ..
C
      IERR = 0
      IF (N.EQ.1) GO TO 140
C
      DO 10 I = 2,N
        E2(I-1) = E2(I)
   10 CONTINUE
C
      F = 0.0
      T = 0.0
      E2(N) = 0.0
C
      DO 120 L = 1,N
        J = 0
        H = ABS(D(L)) + SQRT(ABS(E2(L)))
        IF (T.GT.H) GO TO 20
        T = H
        B = ERRFN(T)
        C = B*B
C
   20   DO 30 M = L,N
          IF (E2(M).LE.C) GO TO 40
   30   CONTINUE
C
   40   IF (M.EQ.L) GO TO 80
   50   IF (J.EQ.30) GO TO 130
        J = J + 1
        L1 = L + 1
        S = SQRT(ABS(E2(L)))
        G = D(L)
        P = (D(L1)-G)/ (2.0*S)
        R = PYTHAG(P,1.0)
        D(L) = S/ (SIGN(R,P)+P)
        H = G - D(L)
C
        DO 60 I = L1,N
          D(I) = D(I) - H
   60   CONTINUE
C
        F = F + H
        G = D(M)
        IF (G.EQ.0.0) G = B
        H = G
        S = 0.0
        MML = M - L
C
        DO 70 II = 1,MML
          I = M - II
          P = G*H
          R = E2(I) + P
          E2(I+1) = S*R
          S = E2(I)/R
          D(I+1) = (D(I)+H)*S + H
          G = D(I) - E2(I)/G
          IF (G.EQ.0.0) G = B
          H = G*P/R
   70   CONTINUE
C
        E2(L) = S*G
        D(L) = H
        IF (H.EQ.0.0) GO TO 80
        IF (ABS(E2(L)).LE.ABS(C/H)) GO TO 80
        E2(L) = E2(L)*H
        IF (E2(L).NE.0.0) GO TO 50
   80   P = D(L) + F
        IF (L.EQ.1) GO TO 100
C
        DO 90 II = 2,L
          I = L + 2 - II
          IF (P.GE.D(I-1)) GO TO 110
          D(I) = D(I-1)
   90   CONTINUE
C
  100   I = 1
  110   D(I) = P
  120 CONTINUE
      GO TO 140
  130 IERR = L
  140 RETURN
      END
C
C
C     =============================
      SUBROUTINE TRAFO(NRA,NEQP,NT,HKL,HKLS,HKLT,FOB,FF,FS,FT)
C     =======================================================
C
C     .. Scalar Arguments ..
      INTEGER NEQP,NRA,NT
C     ..
C     .. Array Arguments ..
      COMPLEX FF(NRA),FS(NRA,NEQP),FT(NT)
      REAL FOB(NRA)
      INTEGER HKL(NRA),HKLS(NRA,NEQP),HKLT(NT)
C     ..
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,BFACT,CORF,CORI,CORP,DMIN,RFLI,RFSQ,
     +     SCALE,SFLI,SFSQ
      INTEGER HLW,HMAX,HUP,KLW,KMAX,KPRT,KUP,LLW,LMAX,
     +        LUP,LX,LY,LZ,NRT,NTOT,NX,NXYZ,NY,NZ
C     ..
C     .. Arrays in Common ..
      REAL BID1,BID2,BID3,BID4
      INTEGER IBID1,IBID2
C     ..
C     .. Local Scalars ..
      COMPLEX CS,CSU,CSX,CU,MFX
      REAL AVSQFO,FO,FUZZP,MFO2,SFTSQ,SQH,SQHMAX,SQHSUP
      INTEGER H,HS,HT,HU,I,IND,IR,IS,IU,K,KS,KT,KU,L,LS,LT,LU,MULT,N
      LOGICAL FRIDEL
C     ..
C     .. External Subroutines ..
      EXTERNAL INDEXM,PAC4,PAKG,UNPAC3,UNPAC4,UNPAKG
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,CONJG,SQRT
C     ..
C     .. Common blocks ..
      COMMON /CELD/AD,BD,CD,BID4(16)
      COMMON /CHES/BID3(9),IBID1(9),LX,LY,LZ
      COMMON /DFFTT/HLW,HUP,KLW,KUP,LLW,LUP,NRT,NXYZ
      COMMON /GRID/HMAX,KMAX,LMAX,NX,NY,NZ
      COMMON /IOPRG/KPRT
      COMMON /NUMO/NTOT,IBID2(6)
      COMMON /POTE/SFLI,SFSQ,SFQU,RFLI,RFSQ,CORF,CORI,CORP,SCALE,BFACT
      COMMON /RESO/BID1(3),DMIN,BID2(2)
      COMMON /STAR/A11,A21,A22,A31,A32,A33
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA FUZZP/1.0001/
C     ..
C
      DO 10 I = 1,NT
        FT(I) = (0.0,0.0)
   10 CONTINUE
C
      SQHMAX = FUZZP/DMIN**2
      AVSQFO = SFSQ/NTOT
C
      DO 40 IR = 1,NRA
C
C            **************************
        CALL UNPAC4(H,K,L,MULT,HKL(IR))
C            **************************
C
        FO = FOB(IR)
        MFO2 = (FO*FO-AVSQFO)*MULT
        MFX = FF(IR)*MFO2
C
        DO 30 IS = 1,NEQP
C
C              ****************************
          CALL UNPAC3(HS,KS,LS,HKLS(IR,IS))
C              ****************************
C
          CS = CONJG(FS(IR,IS))
          H = HS
          K = KS
          L = LS
          CSX = MFX*CS
          FRIDEL = .FALSE.
C
          IF (H.LT.0) THEN
            FRIDEL = .TRUE.
          ELSE IF (H.EQ.0) THEN
            IF (L.GT.0) THEN
              FRIDEL = .TRUE.
            ELSE IF (L.EQ.0) THEN
              IF (K.GT.0) FRIDEL = .TRUE.
            END IF
          END IF
C
          IF (FRIDEL) THEN
            H = -H
            K = -K
            L = -L
            CSX = CONJG(CSX)
          END IF
C
C              ********************
          CALL PAKG(H,K,L,IND)
          CALL UNPAKG(HT,KT,LT,IND)
C              ********************
C
          IF (IND.GT.NT .OR. IND.LE.0 .OR. HT.NE.H .OR. KT.NE.K .OR.
     +        LT.NE.L) GO TO 70
C
          FT(IND) = FT(IND) + CSX
          CS = MFO2*CS
C
          DO 20 IU = IS,NEQP
C
C                ****************************
            CALL UNPAC3(HU,KU,LU,HKLS(IR,IU))
C                ****************************
C
            H = HS-HU
            K = KS-KU
            L = LS-LU
            SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 
     +                                   + (A11*H)**2
C
            IF (SQH.GT.SQHMAX) GO TO 20
            CU = FS(IR,IU)
            CSU = CS*CU
            FRIDEL = .FALSE.
C
            IF (H.LT.0) THEN
              FRIDEL = .TRUE.
            ELSE IF (H.EQ.0) THEN
              IF (L.GT.0) THEN
                FRIDEL = .TRUE.
              ELSE IF (L.EQ.0) THEN
                IF (K.GT.0) FRIDEL = .TRUE.
              END IF
            END IF
C
            IF (FRIDEL) THEN
              H = -H
              K = -K
              L = -L
              CSU = CONJG(CSU)
            END IF
C
C                ********************
            CALL PAKG(H,K,L,IND)
            CALL UNPAKG(HT,KT,LT,IND)
C                ********************
C
            IF (IND.GT.NT .OR. IND.LE.0 .OR. HT.NE.H .OR. KT.NE.K .OR.
     +          LT.NE.L) GO TO 70
C
            FT(IND) = FT(IND) + CSU
   20     CONTINUE
   30   CONTINUE
   40 CONTINUE
C
      HLW = 0
      HUP = 0
      KLW = 0
      KUP = 0
      LLW = 0
      LUP = 0
      N   = 0
      MULT = 2
      SQHSUP = 0.0
      SFTSQ  = 0.0
C
      DO 50 I = 1,NT
        IF (FT(I).EQ. CMPLX(0.0,0.0)) GO TO 50
C
C            ***************
        CALL UNPAKG(H,K,L,I)
C            ***************
C
        N = N + 1
        SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
C
        IF (H.LT.HLW) HLW = H
        IF (H.GT.HUP) HUP = H
        IF (K.LT.KLW) KLW = K
        IF (K.GT.KUP) KUP = K
        IF (L.LT.LLW) LLW = L
        IF (L.GT.LUP) LUP = L
        IF (SQH.GT.SQHSUP) SQHSUP = SQH
C
C            ************************
        CALL PAC4(H,K,L,MULT,HKLT(N))
C            ************************
C
        FT(N) = FT(I)
C
        IF (H.EQ.0 .AND. K.EQ.0 .AND. L.EQ.0) THEN
C
C              *********************
          CALL PAC4(H,K,L,1,HKLT(N))
C              *********************
C
          FT(N) = (0.0,0.0)
        END IF
C
        SFTSQ = ABS(FT(N))**2 + SFTSQ
   50 CONTINUE
C
      NRT = N
C-ejd      DMIN = 2/SQRT(ABS(SQHSUP)
      DMIN = 1/SQRT(ABS(SQHSUP))
      IF (KPRT.NE.0) WRITE (6,FMT=6000) NRT,HLW,HUP,KLW,KUP,LLW,LUP,
     +    DMIN
      IF (NRT.EQ.0) GO TO 80
C
C          ***************************
      CALL INDEXM(DMIN,AD,BD,CD,HMAX,KMAX,LMAX)
C          ***************************
C
      LX = HUP-HLW
      LY = KUP-KLW
      LZ = LUP-LLW
      IF (LX.EQ.0) HMAX = 0
      IF (LY.EQ.0) KMAX = 0
      IF (LZ.EQ.0) LMAX = 0
      SFTSQ = SQRT(ABS(SFTSQ))
C
      DO 60 I = 1,NRT
        FT(I) = FT(I)/SFTSQ
   60 CONTINUE
C
      RETURN
C
C          *************************************************
   70 CALL CCPERR(1,' > s/r trafo < wrong packing')
   80 CALL CCPERR(1,' > s/r trafo < no reflection selected')
C          *************************************************
C
 6000 FORMAT (/,
     +' There are',I10,' Coefficients. Maximal Indices',/,
     +' Hmin, Hmax:',2I5,', Kmin, Kmax:',2I5,', Lmin, Lmax:',2I5,/,
     +' Resolution:',F10.3)
      END
C
C
C     =============================
      SUBROUTINE TRAFP(NRA,NEQP,NT,HKL,HKLS,HKLT,FOB,FS,FT)
C     =======================================================
C
C     .. Scalar Arguments ..
      INTEGER NEQP,NRA,NT
C     ..
C     .. Array Arguments ..
      COMPLEX FS(NRA,NEQP),FT(NT)
      REAL FOB(NRA)
      INTEGER HKL(NRA),HKLS(NRA,NEQP),HKLT(NT)
C     ..
C     .. Scalars in Common ..
      REAL A11,A21,A22,A31,A32,A33,AL,BE,DMIN,GA,
     +     SCD,TX,TY,TZ
      INTEGER HLW,HMAX,HUP,IACTUAL,KLW,KMAX,KPRT,KUP,LLW,
     +        LMAX,LUP,LX,LY,LZ,NRT,NX,NXYZ,NY,NZ,ISOL
C     ..
C     .. Arrays in Common ..
      REAL BID1,BID2,BID3
      INTEGER IBID1
C     ..
C     .. Local Scalars ..
      COMPLEX CS,CSU,CU
      REAL FO,FUZZP,MCS,MCU,PCT,RPS,RPU,SCDH,SFTSQ,SQH,SQHMAX,SQHSUP
      INTEGER H,HS,HT,HU,I,IND,IR,IS,IU,K,KS,KT,KU,L,LS,LT,LU,MULT,N
      LOGICAL FRIDEL
C     ..
C     .. External Subroutines ..
      EXTERNAL INDEXM,PAC4,PAKG,UNPAC3,UNPAC4,
     +         UNPAKG
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,CONJG,SQRT
C     ..
C     .. Common blocks ..
      COMMON /CELD/AD,BD,CD,BID4(16)
      COMMON /CHES/BID3(9),IBID1(9),LX,LY,LZ
      COMMON /DFFTT/HLW,HUP,KLW,KUP,LLW,LUP,NRT,NXYZ
      COMMON /GRID/HMAX,KMAX,LMAX,NX,NY,NZ
      COMMON /IOPRG/KPRT
      COMMON /OUTRA/AL,BE,GA,TX,TY,TZ,SCD,IACTUAL,ISOL
      COMMON /RESO/BID1(3),DMIN,BID2(2)
      COMMON /STAR/A11,A21,A22,A31,A32,A33
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
      DATA FUZZP/1.0001/,PCT/0.001/
C     ..
C
      DO 10 I = 1,NT
        FT(I) = (0.0,0.0)
   10 CONTINUE
C
      SQHMAX = FUZZP/DMIN**2
      RPS    = 0.0
      RPU    = 0.0
C
      DO 40 IR = 1,NRA
C
C            **************************
        CALL UNPAC4(H,K,L,MULT,HKL(IR))
C            **************************
C
        FO = FOB(IR)*MULT
        SCDH = -2*MULT*SCD
C
        DO 30 IS = 1,NEQP
C
C              ****************************
          CALL UNPAC3(HS,KS,LS,HKLS(IR,IS))
C              ****************************
C
          CS = CONJG(FS(IR,IS))
          MCS = ABS(CS)
          IF (MCS.GT.PCT*FO) RPS = FO/MCS + SCDH
C
          DO 20 IU = IS,NEQP
C
C                ******************************
            CALL UNPAC3(HU,KU,LU,HKLS(IR,IU))
C                ******************************
C
            H = HS-HU
            K = KS-KU
            L = LS-LU
            SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 
     +                                   + (A11*H)**2
C
            IF (SQH.GT.SQHMAX) GO TO 20
            CU = FS(IR,IU)
            MCU = ABS(CU)
            IF (MCU.GT.PCT*FO) RPU = FO/MCU
            CSU = CS*CU* (RPS+RPU)
            FRIDEL = .FALSE.
C
            IF (H.LT.0) THEN
              FRIDEL = .TRUE.
            ELSE IF (H.EQ.0) THEN
              IF (L.GT.0) THEN
                FRIDEL = .TRUE.
              ELSE IF (L.EQ.0) THEN
                IF (K.GT.0) FRIDEL = .TRUE.
              END IF
            END IF
C
            IF (FRIDEL) THEN
              H = -H
              K = -K
              L = -L
              CSU = CONJG(CSU)
            END IF
C
C                ********************
            CALL PAKG(H,K,L,IND)
            CALL UNPAKG(HT,KT,LT,IND)
C                ********************
C
            IF (IND.GT.NT .OR. IND.LE.0 .OR. HT.NE.H .OR. KT.NE.K .OR.
     +          LT.NE.L) GO TO 70
C
            FT(IND) = FT(IND) + CSU
   20     CONTINUE
   30   CONTINUE
   40 CONTINUE
C
      HLW = 0
      HUP = 0
      KLW = 0
      KUP = 0
      LLW = 0
      LUP = 0
      N   = 0
      MULT = 2
      SQHSUP = 0.0
      SFTSQ  = 0.0
C
      DO 50 I = 1,NT
        IF (FT(I).EQ. (0.0,0.0)) GO TO 50
C
C            ***************
        CALL UNPAKG(H,K,L,I)
C            ***************
C
        N = N + 1
        SQH = (A31*H+A32*K+A33*L)**2 + (A21*H+A22*K)**2 + (A11*H)**2
C
        IF (H.LT.HLW) HLW = H
        IF (H.GT.HUP) HUP = H
        IF (K.LT.KLW) KLW = K
        IF (K.GT.KUP) KUP = K
        IF (L.LT.LLW) LLW = L
        IF (L.GT.LUP) LUP = L
        IF (SQH.GT.SQHSUP) SQHSUP = SQH
C
C            ************************
        CALL PAC4(H,K,L,MULT,HKLT(N))
C            ************************
C
        FT(N) = FT(I)
C
        IF (H.EQ.0 .AND. K.EQ.0 .AND. L.EQ.0) THEN
C
C              *********************
          CALL PAC4(H,K,L,1,HKLT(N))
C              *********************
C
          FT(N) = (0.0,0.0)
        END IF
C
        SFTSQ = ABS(FT(N))**2 + SFTSQ
   50 CONTINUE
C
      NRT = N
C-ejd      DMIN = 2/SQRT(ABS(SQHSUP)
      DMIN = 1/SQRT(ABS(SQHSUP))
C
      IF (KPRT.NE.0) WRITE (6,FMT=6000) NRT,HLW,HUP,KLW,KUP,LLW,LUP,
     +    DMIN
      IF (NRT.EQ.0) GO TO 80
C
C          ***************************
      CALL INDEXM(DMIN,AD,BD,CD,HMAX,KMAX,LMAX)
C          ***************************
C
      LX = HUP-HLW
      LY = KUP-KLW
      LZ = LUP-LLW
      IF (LX.EQ.0) HMAX = 0
      IF (LY.EQ.0) KMAX = 0
      IF (LZ.EQ.0) LMAX = 0
      SFTSQ = SQRT(ABS(SFTSQ))
C
      DO 60 I = 1,NRT
        FT(I) = FT(I)/SFTSQ
   60 CONTINUE
C
      RETURN
C
C          *************************************************
   70 CALL CCPERR(1,' > s/r trafp < wrong packing')
   80 CALL CCPERR(1,' > s/r trafp < no reflection selected')
C          *************************************************
C
 6000 FORMAT (/,
     +' There are',I10,' Coefficients. Maximal indices',/,
     +' Hmin, Hmax:',2I5,', Kmin, Kmax:',2I5,', Lmin, Lmax:',2I5,/,
     +' Resolution:',F10.3)
      END
C
C
C     =============================
      SUBROUTINE TRAING
C     =================
C
C     EJD re. dimensions:
C     This is the true disaster - does whole fft in core, and needs to
C     possibly deal with a cell equiv to double the real one.
C     Usually when it falls over I find people have very asymmetric cell
C
C NR =nb. reflections
C MEQ=nb. equivalent positions
C MRT=nb. coefficients translation function
C MR =dimension of fft array
C MT =dimension of interpolation array ( > mrt )
C         = 2,200,000
C
C     .. Parameters ..
      INTEGER DNR,DMEQ,DMRT,DMR,DMT
CBIG      PARAMETER (NR=500000,MEQ=24,MRT=2000000,MR=1000000,MT=2200000)
c      PARAMETER (DNR=50000, DMEQ=24, DMRT=2000000, DMT=2200000,
c     +     DMR=1000000)
       parameter (NSOL = 499)
      INTEGER DEFS (5)
      INTEGER NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB
C  NRC NEQPC - no of reflns and no of primitive sym ops for crystal
C  MITAB MCTAB needed for tabling
C  MCTAB set = 100000
C  NRH1  no of reflns for HKLPCK1 
C  MHKLTAB - the big array from the table: (2*KMAX+1)* (IHMAX+2)* (2*LMAX+1)
      COMMON /SETSIZE/ NEQPC,NRC, MITAB,MCTAB, NRH1,MHKLTAB 
C     ..
C     .. External Subroutines ..
      EXTERNAL TRANDO1, CCPE2I
      INTEGER CCPE2I
C     ..
crgd RR[2*nd + nr] nd must be > 2*nr
crgd II[2*nd + neqP*nr] nd must be > neqP*nr
crgd     or
crgd II[nr*(1+neqP) + nt] nt is a scratch space
crgd CC[nr*(1+neqP) + mrf]
crgd the mrf space is also used as a scratch space in some of the
crgd  ffts
C  lecfoq:  rr(nr+nd+nr)
C           ii(nr+nd+neqP*nr)
C  refft :  ii(nra+nra*neqP)
C  lectab:  cc(nra*(1+neqP)+hkl)
C  fixmol:  cc()
C           ii(nra+nra*neqP)
C  fsym  :  rr(nra)
C  trafo :  ii(nra*(1+neqP)+nt)
C           cc(nra*(1+neqP)+nt)
C  outtra:  ii(nra*(1+neqP)+npic)
C           rr(nra+6*npic)
C
      CHARACTER TYPE (3), LENENV (5)*10
      INTEGER LENG (3), VALS (5)
      COMMON /TRANXX/ NR,MEQ,MRT,MT,MR
      SAVE /TRANXX/
C   Equivalence NR,MEQ,MRT,MT,MR to DNR, DMEQ, DMRT, DMT, DMR
      EQUIVALENCE (NR, VALS (1))
C
C      DATA TYPE /'I', 'R', 'C'/
c      PARAMETER (DNR=50000, DMEQ=24, DMRT=2000000, DMT=2200000,
c     +     DMR=1000000)
      DATA TYPE /'I', 'R', 'C'/,
c     +          DEFS /DNR,         DMEQ,         DMRT,         DMT, 
c     +        DMR/,
     +     LENENV /'TRAING_NR', 'TRAING_MEQ', 'TRAING_MRT', 'TRAING_MT',
     +     'TRAING_MR'/
C      Default values 20000          24          2000000      2200000,
C            1000000 
c
C     These are the lengths of array args to trando1 (II, RR, CC):
C  ie NNI,NNR,NNC  equated to  mi mr (= mrr) mc -  
C    NNI = mr      = TRAING_NR ( 1+ TRAING_MEQ) + TRAING_MRT 
C    NNR = mr=mrr  = TRAING_NR + TRAING_MR 
C    NNc = mc      = TRAING_NR ( 1+ TRAING_MEQ) + TRAING_MT

      NR = NRC
      MEQ = NEQPC
C     MRT = 500000
      MRT = MHKLTAB/8 + 2
C     MT = MHKLTAB 
      MT = MHKLTAB  + NR*(1+MEQ)
C     MR = 1000000
      MR = MHKLTAB/4
       DEFS (1) = NR
       DEFS (2) = MEQ
       DEFS (3) = MRT
       DEFS (4) = MT
       DEFS (5) = MR
C  Keep option to reset if necessary
C     The array lengths for TRANDO1 need to be calculated specially --
C     we can't use CCPALE; thus (maybe) read numerical values from the
C     environment with names from LENENV:
      DO 10 I=1,5
        VALS (I) = CCPE2I (LENENV (I), DEFS (I))
 10   CONTINUE
      WRITE (6, '(/'' Memory allocation (logical name, elements):'')')
      WRITE (6, '(1X, A, 3X, I10)') (LENENV (I), VALS (I), I=1,5)
      LENG (1) = NR+NR*MEQ+MRT
      LENG (2) = NR+MR
      LENG (3) = NR+NR*MEQ+MT
       write(6,'(a,5I15,/,a,3I15)') 
     + ' NR,MEQ,MRT,MT,MR,LENG',NR,MEQ,MRT,MT,MR,
     +   ' Memory allocation ',LENG
      CALL CCPALC (TRANDO1, 3, TYPE, LENG)
      END
C
C
      SUBROUTINE TRANDO1(NNI,II,NNR,RR,NNC,CC)
       parameter (NSOL = 499)
c      implicit none
      integer nni,nnr,nnc,mi,mr,mc,iactual,nprt,kprtt,ipr,kprt,nort,
     & i,nd,nr,neq,ir0,nra,ic3,mim,mrm,mcm,nt,mt,mtx,mtr,nrt,nmol,molt,
     & npic,mtc,imol,i2,kmax,lmax,mta,ibid1,ibid5,nts,nx,ny,nz,ibid2,
     & ibid3,ibid4,ibid6,i1,io1,ii,o1,udi,ump,hmax,ump1,ump2,ump3,iii
      real a,b,c,alpha,beta,gamma,rf,pctr,tfac,dmaxo,dmino,dmint,sharat,
     & to,dminm,dminx,xmol,scd,rpts,delta,dminc,al,be,ga,tx,ty,tz,cof,
     & rfl,coi,dist,sqhmax,rbid6,dsmin,seuil,corf,rfli,cori,rbid1,ro,
     & rbid2,rbid3,rbid4,rfsq,corp,rbid5,fmin,fmax,rr,rx,rm
      INTEGER MEQ,MRT,iverb,itabb,nsym,nsymp,T4,hck1
      complex cc
      logical first,primo
      character zn*1,yn*1,title*1,mapa*4,formr*40,forme*40,card*80,
     & tcar*80,TRATYP*3,filnam*10,MAPNAM*10,TRAMAP*4
      external rhkl1,pz1
c      dimension ii(mi),rr(mr),rx(9),pf(11,100),cc(mc),title(72)
      dimension ii(NNI),rr(NNR),rx(9),rxo(9),pf(11,100),cc(NNC),
     +          title(72), distx(3),txs(3)
c      common/simt/ rbid1(153),ibid1(432),neq,nts
c      common/ortm/ ro(9),rf(9),nort
c      common/reso/ dmaxo,dmino,rbid2,dmint,dsmin,rbid3
c      common/dfftt/ ibid2(6),nrt,ibid3
c      common/pote/ rbid4(3),rfli,rfsq,corf,cori,corp,rbid5(2)
c      common/ctlx/ pctr,fmin,fmax,tfac,ibid4
c      common/tapes/ i1,io1,o1
      COMMON /ALLFNC/TITLE
      COMMON /ALLFUN/IVERB,ITABB(5),FMINC(5),FMAXC(5),TFACC(5),NSYM,
     +       NSYMP,RSYM(4,4,96)
      COMMON /CELD/AD(6),BID1(12),VOL
      COMMON /CELL/A,B,C,ALPHA,BETA,GAMMA
      COMMON /CELOBS/AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS,
     +  RFOBS(3,3),NCDOBS
c      common/ches/ rbid6(9),ibid5(12)
      COMMON /CHES/RM(3,3),MD(3,3),LXYZ(3)
      COMMON /CNTRL/ISORT,ITAB,IROT,ITRA,IFIT,IMR,JSFO
      COMMON /CTLX/IBID4,FMIN,FMAX,TFAC
      COMMON /DFFTT/IBID2(6),NRT,IBID3
      common /grid/ ibid6(3),nx,ny,nz
      COMMON /MAPNM/MAPNAM
      COMMON /IOPRG/KPRT
      COMMON /NCSTRA/Nncs,TXncs(10),TYncs(10),TZncs(10)
      COMMON /OPRT/KPRTT(20)
      COMMON /ORTM/RO(9),RF(9),NCODE
      COMMON /OUTRA/AL,BE,GA,TX,TY,TZ,SCD,IACTUAL,ISOL
      COMMON /PACO/HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1
      COMMON /PIK/SEUIL,DELTA,NPIC
      COMMON /POTE/BID5(3),RFLI,RFSQ,CORF,CORI,CORP,BID6(2)
      COMMON /RESO/DRMAX,DRMIN,BID3,DMINT,DSMIN,BID4
      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
      COMMON /STAR/AS(6)
      COMMON /TAPES/UMP,UFC,ND
      COMMON /TRAFITC/TRATYP
      COMMON /TRAFIT/NCODT,DRMAXT,DRMINT,DMINTT,SHRTTR,NMOLT,
     +       RPTST,DELTAT,NPICT,ITBT(NSOL),ALT(NSOL),BET(NSOL),
     +       GAT(NSOL),TXT(NSOL),TYT(NSOL),TZT(NSOL),CRT(NSOL),
     +       RFT(NSOL),ITMAXF,EPSNF,ISF,IAF,IBF,IGF,IXF,IYF,IZF,SCDT
      COMMON /TRANXX/ NR,MEQ,MRT,MT,MRR
C     .. Data statements ..
      DATA TRAMAP/'TRAM'/,T4/0/

C      LENG (1) = NR+NR*MEQ+MRT = NNI = MI
C      LENG (2) = NR+MR = NNR = MR = MRR
C      LENG (3) = NR+NR*MEQ+MT = NNC = MC
        mi = NNI
        mr = NNR
        mc = NNC
        MRR = MR
C     ..
C
      NTTSS = 0.0
      DSMIN = 0.0
      IACTUAL = 0
      UFC     = T4
      IR0     = 1+NR
      KPRTT(1) = IVERB
      KPRTT(2) = IVERB
      KPRTT(3) = IVERB
      KPRTT(4) = IVERB
      KPRTT(5) = IVERB
      KPRTT(6) = IVERB
C
      KPRT = KPRTT(1)
C
C
      FILNAM = 'HKLPCK0'
      UDI = 0
      ifail = 0
C          ***************************************
      CALL CCPDPN(UDI,FILNAM,'OLD','U',LREC,IFAIL)
C          ***************************************
C
C----  read Cell and symmetry from HKLPCK file:
C
      READ (UDI) A,B,C,ALPHA,BETA,GAMMA
c          ***********
c      CALL HKLCELLIN(UDI)
c          ***********
      AOBS = A
      BOBS = B
      COBS = C
      ALPOBS = ALPHA
      BETOBS = BETA
      GAMOBS = GAMMA
C
C          *****
      CALL CELDA(A,B,C,ALPHA,BETA,GAMMA)
C          *****
C
      READ (UDI) NTS,NEQP,(((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
      neq = neqp*(1+NTS)
      NEQPP = NEQP
      IF(NTS.GT.0) THEN
        READ(UDI) ((TTS(I,ITS),I=1,3),ITS=1,NTS)
        NTTSS = NTS        
      END IF
C  Read packing constants to put into COMMON PACO
      READ (UDI) HCK1,KCK1,LCK1,NCKH1,NCKK1,NCKL1,NCKM1,DMINUDI

C
C----  Reset symmetry if set on input.
C
      IF (NSYM.GT.1) THEN
        IF (NEQP*(NTS+1).NE.NSYM) THEN
          WRITE (6,FMT='(//,a)') ' Incompatible symmetry??'
          WRITE (6,FMT='(/,i3,A,I3,A)')NEQP,
     +    ' symmetry operators listed with',NTS,' centring operators.'
C
C              ************************
          CALL CCPERR(1,' Fatal error - symmetry inconsistency')
C              ************************
C
        END IF
C
        NEQ = NSYM
        NEQP = NSYMP
        NEQPP = NEQP
C
        DO  ISYM = 1,NSYM
         IF(ISYM.LE.NSYMP) THEN
          DO  JDO30 = 1,3
           TSS(JDO30,ISYM) = RSYM(JDO30,4,ISYM)
            DO  JDO20 = 1,3
              MSS(JDO30,JDO20,ISYM) = NINT(RSYM(JDO30,JDO20,ISYM))
            END DO
          END DO
         END IF
         IF(ISYM.GT.NSYMP) THEN
          NTS = INT((ISYM-1)/NSYMP)
          NTTSS = NTS
          DO J = 1,3
           tts(j,NTS) =   RSYM(j,4,ISYM) - RSYM(j,4,ISYM-NTS*NSYMP)
          END DO
         END IF
        END DO
C
      END IF
C
C   Need external phases to search for one molecule in P1
C   All Rfactors and correlation coefficients the same so only find one peak
      IF(NEQP.EQ.1.AND.TRATYP.NE.'PTF'.AND.NMOLT.EQ.1) THEN
       CALL CCPERR(2,
     +' Unphased translation search meaningless for one molecule in P1')
       DO ISOL = 1,NSOL
        IF(ITBT(ISOL).GT.0) THEN
         AL = ALT(ISOL)
         BE = BET(ISOL)
         GA = GAT(ISOL)
         TX = TXT(ISOL)
         TY = TYT(ISOL)
         TZ = TZT(ISOL)
       WRITE (6,FMT='(A,I3,3F8.2,3F8.4,2F5.1)') '  SOLUTIONTF1', 
     +         ITBT(ISOL),AL,BE,GA,TX,TY,TZ,CRT(ISOL),RFT(ISOL)
        END IF
       END DO
       CALL CCPERR(0,' No more translation search')
      END IF
C
      IF(NEQP.EQ.1.AND.TRATYP.EQ.'PTF'.AND.NMOLT.EQ.1) NPICT = 1
C          *****
      CALL ORTHO
C          *****
      WRITE (6,FMT='(A,6F9.3)')
     + ' TRANDO: Observed Cell read from HKLPCK0:',
     + AOBS,BOBS,COBS,ALPOBS,BETOBS,GAMOBS
      WRITE (6,FMT='(A,I5,48(//,A,I4,/,3(/,3i4,F9.3) ))')
     +  ' Symmetry - primitive operators:',neqp,
     + ('Symmetry:',N,((MSS(I,J,N),J=1,3),TSS(I,N),I=1,3),N=1,NEQP)
       IF(NTS.GT.0) THEN
          WRITE (6,FMT='(4(/A,I5,3F9.3) )')
     +  (' Centring operator:',N,(TTS(I,N),I=1,3),N=1,NTS)
       END IF
C
C
      NCODE = NCODT
C
      DO I = 1,9
        RX(I) = RF(I)
        RXO(I) = RO(I)
      END DO
C
      FMIN = FMINC(1)
      FMAX = FMAXC(1)
      TFAC = TFACC(1)
c      WRITE (*,FMT=*) FMIN,FMAX,TFAC
      IF (FMAX.LT.FMIN) THEN
        T = FMAX
        FMAX = FMIN
        FMIN = T
      END IF
C
      DRMAX = DRMAXT
      DRMIN = DRMINT
      DMINT = DMINTT
      SHARAT = SHRTTR
      IF (SHARAT.LT.1.0) SHARAT = 1.0
C
         if(DRMAX.lt.DRMIN) then
      to=DRMAX
      DRMAX=DRMIN
      DRMIN=to
         endif
      if(dmint.gt.DRMIN) dmint=DRMIN
      IF (DRMAX.LT.DRMIN) THEN
        TO = DRMAX
        DRMAX = DRMIN
        DRMIN = TO
      END IF
      IF (DMINT.EQ.0.0) DMINT = DRMIN/2.0

C
C   If DMINT ( resolution limit of translation function)
C   not DMINT/2 then data will be lost.
      IF (DMINT.GT.DRMIN/2.0) THEN
       WRITE(6,'(///,a,/,a,/,a,//,a,f6.1,a,f6.1,///)')
     +  '  ******************** PROBLEM ************************',
     +  '  ** TMIN ( resolution of translation function"map") **',
     +  '  ********* Should equal data_resolution / 2 *********',
     +  '  ****** Here TMIN = ',DMINT,' Resolution = ',DRMIN
      END IF
      IF (DMINT.GT.DRMIN) 
     +  CALL CCPERR(1,' Fatal Error in Resolution limit')
C
      IF(UDI.NE.0) REWIND (UDI)
C
C----  Skip first 3 records, cell and symmetry and paco information..
C
      READ (UDI)AA,BB,CCC,AALL,BBEE,GGAA
      READ (UDI)NTTTSSS,NNEEQQPP
      IF(NTTTSSS.GT.0) READ(UDI) TTTSSS
      READ (UDI)HMM,KMM,LMM,NHH,NKK,NLL,NMM,DMMiNN
      READ (UDI) ND

        IF(NTS.GT.0) THEN
        WRITE(6,*) '  ********************************************'
        WRITE(6,*) '  ********************************************'
        WRITE(6,*)' Amore has problems defining Cheshire cells for',
     +   ' non primitive spacegroups.'
        WRITE(6,*) ' It is correct for NMOL = 1 in C_centred cells',
     +  ' It is an overestimate for NMOL = 1 in rhombohedral cells'
        WRITE(6,*)
     +  ' There will be 2 or 3 identical solutions'
        WRITE(6,*)
     +   ' For NMOL > 1 it will search the whole unit cell instead of',
     +   ' a fraction of it'
        WRITE(6,*) '  ********************************************'
        WRITE(6,*) '  ********************************************'
        END IF
c      IF (NR+ND.GT.MR .OR. NR*NEQP+ND.GT.NR*MEQ+MRT) GO TO 150
C
      nr=min((mi-nd)/(1+neqP),(mr-2*nd)/2)
      if(nr.le.0) go to 901
      nra = 0
      ir0=1+nr
C
c      SUBROUTINE LECFOQ(UDI,ND,NR,NRA,MEQ,
c                                    HKLO,   HKL,     HKLS,
C      MFO,    PHO,       FOB,      HSQ,        PHASFLG)
      call lecfoq(udi,nd,nr,nra,neqP,ii(ir0),ii(1),ii(ir0+nd),
     . rr(ir0),rr(ir0+nd),rr(1),rr(ir0+2*nd),'p')
      call tshift('w','g')
      ic3=1+nra*(1+neqP)
      mim=mi-nra*(1+neqP)
      mrm=mr-2*nra
      mcm=mc-nra*(1+neqP)
      dminm=dmint
      nt=mcm
      call refft(mt,nra,neqP,nt,ii(1+nra),cc(ic3))
      call tshift('w','t')
      dminx=dmint
      mtx=mt
C  I THINK NRT = NRA - number of crst. reflns
      mtr=nrt
      if(mim.lt.mtr) go to 902
      write(6,fmt='(a8,72a1)') 'traing: ',title
      first=.true.
      primo=.true.
c      COMMON /TRAFIT/NCODT,DRMAXT,DRMINT,DMINTT,SHRTTR,NMOLT,
c     +       RPTST,DELTAT,NPICT,ITBT(NSOL),ALT(NSOL),BET(NSOL),
c     +       GAT(NSOL),TXT(NSOL),TYT(NSOL),TZT(NSOL),CRT(NSOL),
c     +       RFT(NSOL),ITMAXF,EPSNF,ISF,IAF,IBF,IGF,IXF,IYF,IZF
       NMOL = NMOLT
       MOLT = NMOL + Nncs
      if(molt.gt.100) go to 903
c      read(ilec,fmt='(a80)') card
c      tcar(1:75)=card(6:80)
c lecturainterna
c      read(tcar,*) scd
c      read(ilec,*) rpts,npic,delta
C  SCDT is set to 1.0 for phased translation (PTF or PT); 0.0 for everything else
       SCD = SCDT
       RPTS = RPTST
       NPIC = NPICT
C
         if(TRATYP.EQ.'CC '.and.first) then
           first=.false.
            if(primo) then
                primo=.false.
            endif
           dmint=dminm
           nt=mcm
           call reffc(mt,nra,neqP,nt,ii(1+nra),cc(ic3))
           call tshift('w','c')
           dminc=dmint
           mtc=mt
           mtr=nrt
           if(mim.lt.mtr) go to 902
         endif
C
         if(TRATYP.EQ.'HL '.and.primo) then
                primo=.false.
         endif
c
         do i=1,nra*(1+neqP)
          cc(i)=(0.,0.)
         enddo
      isol=0
      imol=1
C  Solutions come in sets of NMOL
C  First NMOL -1 solutions are "fixed" - ie already positioned. NMOLth TX TY TZ to be found
10    continue
      ISOL = ISOL + 1
      ITABT = ITBT(ISOL)
      IF (ITABT.EQ.0) GO TO 40
c
      if(imol.eq.1) then
         WRITE (6,FMT=*)
         WRITE (6,FMT=*) '*********************************************'
         WRITE (6,FMT=*) 'Solution ',isol+nmol-1
         WRITE (6,FMT=*) '*********************************************'
         WRITE (6,FMT=*)
C  Starting a new pass: Clear arrays
       do i=1,nra*(1+neqP)
         cc(i)=(0.,0.)
       enddo
      end if
c
      AL = ALT(ISOL)
      BE = BET(ISOL)
      GA = GAT(ISOL)
      TX = TXT(ISOL)
      TY = TYT(ISOL)
      TZ = TZT(ISOL)
C
      IF (IMOL.EQ.NMOL) THEN
          TX = 0.0
          TY = 0.0
          TZ = 0.0
       END IF
C
      WRITE (6,FMT='(A,I5,3F10.3,3F10.6,2F5.1)') ' Input position:', 
     +            ITABT,AL,BE,GA,TX,TY,TZ,CRT(ISOL),RFT(ISOL)
C
      cof=0.
      rfl=0.
      coi=0.
      dist=0.
      pf(1,imol)=ITABT
      pf(2,imol)=al
      pf(3,imol)=be
      pf(4,imol)=ga
      pf(5,imol)=tx
      pf(6,imol)=ty
      pf(7,imol)=tz
      pf(8,imol)=CRT(ISOL)
      pf(9,imol)=RFT(ISOL)
      pf(10,imol)=coi
      pf(11,imol)=dist
c        write(6,'(a,/,2I3,11f8.2)')' isol,imol,pf',
c     +  isol,imol,(pf(iii,imol),iii=1,11)
C
      IF (ITABT.NE.IACTUAL) THEN
c        IF (IACTUAL.NE.0) CLOSE (UNIT=ITAB)
        IF(ITAB.NE.0) CLOSE (UNIT=ITAB)
        FILNAM = ' '
        WRITE (FILNAM,FMT='(A5,I1)') 'TABLE',ITABT
C
C            ******************************************
        IFAIL = 0
        ITAB = 0
        CALL CCPDPN(ITAB,FILNAM,'READONLY','U',0,IFAIL)
C            ******************************************
C
        IACTUAL = ITABT
C
C----  Read all input from unit ITAB.
C
        IF(ITAB.NE.0) REWIND (ITAB)
        READ (ITAB) A,B,C,ALPHA,BETA,GAMMA,NCODE,HMAX,KMAX,LMAX,SQHMAX

      mta=(hmax+2)*(2*kmax+1)*(2*lmax+1)
c      write(6,3040) mta,mt,nra*(1+neqP)+mta,nnc
      if(nra*(1+neqP)+mta.gt.mc) go to 904
c       IF (NRA+NRA*NEQP.GT.NR+NR*MEQ .OR.
c    +      NRA+NRA*NEQP+MTA.GT.NR+NR*MEQ+MT) GO TO 170
C
C            ***********************************
        CALL LECTAB(ITAB,HMAX,KMAX,LMAX,CC(IC3))
C            ***********************************
C
        DO 90 I = 1,9
          RF(I) = RX(I)
   90   CONTINUE
      END IF
C
C          *************************
      CALL SETMAT(AL,BE,GA,TX,TY,TZ)
C          *************************
C
C                       *********************************************
      SIGNF = 1.0
c      SUBROUTINE FIXMOL(HMAX,KMAX,LMAX,NRA,MEQ,HKLS,FF,FT,SIGNF)
C      ic3=1+nra*(1+neqP)
      IF (IMOL.LT.NMOL) THEN
       CALL FIXMOL(HMAX,KMAX,LMAX,NRA,NEQP,
     +                            II(1+NRA),CC(1),CC(IC3),SIGNF)
       IMOL = IMOL + 1
       GO TO 10
      END IF 
C                       *********************************************
C
      DMIN = DMINX
      RMIN = DMIN/SHARAT
C
C  Interpolates calculated SFS for model - repeats it if NCS > 0
      call fsym(hmax,kmax,lmax,nra,neqP,ii(1),ii(1+nra),rr(1),
     . cc(1+nra),cc(ic3))
c
C   Get ready for maps.., close TEMPJ if it has been opened already
C          ***************************************
      IFAIL = 0
      IF (T4.NE.0) CLOSE (UNIT=T4)
      CALL CCPDPN(T4,'TEMPJ','SCRATCH','U',80,IFAIL)
C          ***************************************
C
C  CC TRAFUN
         if(TRATYP.EQ.'CC ') then
            write(6,fmt='(/a24)') ' correlation-coefficient'
            call tshift('r','c')
            dmint=dminc
            mt=mtc
            call trafc(mt,nra,neqP,mtr,nt,ii(1),ii(1+nra),ii(ic3),
     .                 cc(1),cc(1+nra),cc(ic3))
               if(nmol.eq.1) then
                 call chesh
                 call cheshi(nrt,ii(ic3),cc(ic3))
               else
                 do j=1,3
                  do i=1,3
                   RM(i,j)=MSS(i,j,1)
                   MD(i,j)=MSS(i,j,1)
                  enddo
                 enddo
               endif
            dsmin=dmint/sharat
            call dimms(nt,mrm,nt)
            neqP=1
            nts=0
            MAPNAM = 'MAPTMP1'
            call HFFTX(rhkl1,pz1,ii(ic3),rr(1+2*nra),cc(ic3))
            call tshift('r','t')
            dmint=dminx
            mt=mtx
            call traft(mt,nra,neqP,mtr,nt,ii(1),ii(1+nra),ii(ic3),rr(1),
     .                cc(1),cc(1+nra),cc(ic3),1)
              if(nmol.eq.1) then
                call chesh
                call cheshi(nrt,ii(ic3),cc(ic3))
              else
                do j=1,3
                 do i=1,3
                  RM(i,j)=MSS(i,j,1)
                  MD(i,j)=MSS(i,j,1)
                 enddo
                enddo
              endif
            call dimms(nt,mrm,nt)
            neqP=1
            nts=0
            MAPNAM = 'MAPTMP2'
             call HFFTX(rhkl1,pz1,ii(ic3),rr(1+2*nra),cc(ic3))
             call tshift('r','t')
             dmint=dminx
             mt=mtx
             call traft(mt,nra,neqP,mtr,nt,ii(1),ii(1+nra),ii(ic3),
     .                rr(1),cc(1),cc(1+nra),cc(ic3),2)
             if(nmol.eq.1) then
              call chesh
              call cheshi(nrt,ii(ic3),cc(ic3))
             else
               do j=1,3
                 do i=1,3
                  RM(i,j)=MSS(i,j,1)
                  MD(i,j)=MSS(i,j,1)
                 enddo
               enddo
             endif
             call dimms(nt,mrm,nt)
             neqP=1
             nts=0
              MAPNAM = 'MAPTMP3'
             call HFFTX(rhkl1,pz1,ii(ic3),rr(1+2*nra),cc(ic3))
             write(6,3050) nra+3*nx*ny,nnr
             if(3*nx*ny.gt.mrm) go to 905
               mxyz = (mr-2*nra)/3
             call correl(mxyz,rr(1+2*nra))
C    End of CC option
C
c        else if(card(1:5).eq.'h-l  ') then
CC  HL option
         else if(TRATYP.EQ.'HL ')then
             write(6,fmt='(/a16)') ' harada-lifchitz'
             call tshift('r','t')
             dmint=dminx
             mt=mtx
             call traft(mt,nra,neqP,mtr,nt,ii(1),ii(1+nra),ii(ic3),
     .                  rr(1),cc(1),cc(1+nra),cc(ic3),1)
             if(nmol.eq.1) then
               call chesh
               call cheshi(nrt,ii(ic3),cc(ic3))
             else
               do j=1,3
                do i=1,3
                  RM(i,j)=MSS(i,j,1)
                  MD(i,j)=MSS(i,j,1)
                enddo
               enddo
             endif
             dsmin=dmint/sharat
             call dimms(nt,mrm,nt)
             neqP=1
             nts=0
              MAPNAM = 'MAPTMP1'
             call HFFTX(rhkl1,pz1,ii(ic3),rr(1+2*nra),cc(ic3))
             call tshift('r','t')
             dmint=dminx
             mt=mtx
             call traft(mt,nra,neqP,mtr,nt,ii(1),ii(1+nra),ii(ic3),
     .               rr(1),cc(1),cc(1+nra),cc(ic3),2)
                if(nmol.eq.1) then
                    call chesh
                    call cheshi(nrt,ii(ic3),cc(ic3))
                else
                  do j=1,3
                   do i=1,3
                    RM(i,j)=MSS(i,j,1)
                    MD(i,j)=MSS(i,j,1)
                   enddo
                  enddo
                endif
             call dimms(nt,mrm,nt)
             neqP=1
             nts=0
             MAPNAM = 'MAPTMP2'
             call HFFTX(rhkl1,pz1,ii(ic3),rr(1+2*nra),cc(ic3))
             o1=ump
             write(6,3060) nra+2*nx*ny,nnr
             if(2*nx*ny.gt.mrm) go to 906
              MAPNAM = 'MAPOUT'
               mxyz = (mr-2*nra)/2
             call harada(mxyz,rr(1+2*nra))
C    End of HL option
C  Either CO or PT
         else
           call tshift('r','t')
           dmint=dminx
           mt=mtx
C   CO option
            if(TRATYP.EQ.'CO ')then
               write(6,fmt='(/a16)') ' centred-overlap'
               call traft(mt,nra,neqP,mtr,nt,ii(1),ii(1+nra),ii(ic3),
     .                   rr(1),cc(1),cc(1+nra),cc(ic3),0)
C  PT option
            else if(TRATYP.EQ.'PT ' ) THEN
               if(nmol.eq.1) then
                 write(6,fmt='(//a,f5.2)') 
     +             ' Single body-phased-translation:',scd
                 call trafp1(mt,nra,neqP,mtr,nt,ii(1),ii(1+nra),ii(ic3),
     .                       rr(1), cc(1),cc(1+nra),cc(ic3))
               else
                 write(6,fmt='(//a,f5.2)') 
     +             ' Many body-phased-translation:',scd
                 call trafp2(mt,nra,neqP,mtr,nt,ii(1),ii(1+nra),ii(ic3),
     .                       rr(1), cc(1),cc(1+nra),cc(ic3))
               endif
C  PTF option
            else if(TRATYP.EQ.'PTF' ) THEN
                write(6,fmt='(//,a)') 
     +            ' Phased-translation using external phases'
c
c      subroutine trafp3(mt,nra,neq,mtr,nt,    hkl,  hkls,     hklt,
c                           fob,  phob,    ff,   fs,       ft)
c
                call trafp3(mt,nra,neqP,mtr,nt,ii(1),ii(1+nra),ii(ic3),
     .                      rr(1),rr(1+nra),cc(1),cc(1+nra),cc(ic3))
            else
C   not a valid TRAFUN option
                 go to 907
            endif
             if(nmol.eq.1.and.TRATYP.NE.'PTF') THEN
               call chesh
               call cheshi(nrt,ii(ic3),cc(ic3))
             else
               do j=1,3
                do i=1,3
                 RM(i,j)=MSS(i,j,1)
                 MD(i,j)=MSS(i,j,1)
                enddo
               enddo
             endif
           dsmin=dmint/sharat
           call dimms(nt,mrm,nt)
           neqP=1
           nts=0
           MAPNAM = 'MAPOUT'
           call HFFTX(rhkl1,pz1,ii(ic3),rr(1+2*nra),cc(ic3))
         endif
CC dealt with all possible TRAFUNS
C
      npic = npict
      seuil=rptst*seuil
C     xyz(7,npic) returned in rr(1+2*nra) space
C          ******************************************
      CALL PIKNDO(MIM,MRM,II(IC3),RR(1+2*NRA),TRAMAP)
C          ******************************************
      call tshift('r','g')
c      sr  scrf(nra, meq, ntx,hkl,  hkls,     fob,  xyz,
c      ff,   fs)
C    Get the CorF RFL etc 
      call scrf(nra,neqP,npic,ii(1),ii(1+nra),rr(1),rr(1+2*nra),
     . cc(1),cc(1+nra))
C       MOLT = NMOL + Nncs
       do imol=nmol,molt
        if(imol.eq.nmol) then
         tx = rr(1+2*nra)
         ty = rr(2+2*nra)
         tz = rr(3+2*nra)
         corf = rr(4+2*nra)
         rfli = rr(5+2*nra)
         cori = rr(6+2*nra)
         n1 = rr(7+2*nra)
         pf(5,imol)=amod(tx,1.)
         pf(6,imol)=amod(ty,1.)
         pf(7,imol)=amod(tz,1.)
        else
         pf(1,imol)=pf(1,nmol) 
         pf(2,imol)=pf(2,nmol) 
         pf(3,imol)=pf(3,nmol)
         pf(4,imol)=pf(4,nmol) 
         pf(5,imol)=amod(TXncs(imol-nmol)+ tx,1.)
         pf(6,imol)=amod(TYncs(imol-nmol)+ ty,1.)
         pf(7,imol)=amod(TZncs(imol-nmol)+ tz,1.)
        end if
         pf(8,imol)=corf*100
         pf(9,imol)=rfli*100
         pf(10,imol)=  cori*100
       enddo
c      write(6,*)
c      write(6,*) ' posiciones finales'
        WRITE (6,'(/,A,/,A,A)')
     +  ' Translation solutions sorted by correlation coefficients',
     +  '          TABLE   Alpha    Beta   Gamma   ',
     +  ' Tx      Ty      Tz Corr_F Rfac Corr_I Pkcount  Dmin'
        do 30 imol=1,molt
          i2=nint(pf(1,imol))
          al=pf(2,imol)
          be=pf(3,imol)
          ga=pf(4,imol)
          tx=pf(5,imol)
          ty=pf(6,imol)
          tz=pf(7,imol)
          cof=pf(8,imol)
          rfl=pf(9,imol)
          coi=pf(10,imol)
          dist=pf(11,imol)
C
C  Sort to get peak position in map too.
C  Check separation of centre of mass 
C  TRAFUN only useful for P1 if PTF used
      if(neqpp.ge.2) then
       dstmin = 10000000.0
       do n = 2,neqpp
        do i = 1,3
         txs(i) = mss(i,1,n)*tx + mss(i,2,n)*ty + mss(i,3,n)*tz 
     +          + TSS(I,N)
c         distx(i) = tx -txs(i)  
         distx(i) = pf(4+i,imol) -txs(i)  
         shift = real( int( abs(distx(i)) + 0.5))
         distx(i) = distx(i) - sign(shift,distx(i)) 
        end do
        dist = 0.0
        do i = 1,3
         dorth = rxo(i)*distx(1) + rxo(i+3)*distx(2) 
     +         + rxo(i+6)*distx(3)
         dist = dist + dorth**2 
        end do
        if( abs(dist).lt.dstmin) dstmin = abs(dist)
C
C  Check non-primitives
        if(nttss.ne.0) then
         do nnt = 1,nttss
          do i = 1,3
c          txs(i) = mss(i,1,n)*tx + mss(i,2,n)*ty + mss(i,3,n)*tz
c     +           + TSS(I,N) + tts(i,nt)
c          distx(i) = tx -txs(i)
          distx(i) = pf(4+i,imol) -txs(i)   -tts(i,nnt)
          shift = real( int( abs(distx(i)) + 0.5))
          distx(i) = distx(i) - sign(shift,distx(i))
          end do
          dist = 0.0
          do i = 1,3
           dorth = rxo(i)*distx(1) + rxo(i+3)*distx(2)
     +          + rxo(i+6)*distx(3)
           dist = dist + dorth**2
          end do
        if( abs(dist).lt.dstmin) dstmin = abs(dist)
         end do
        end if
c      do n = 2,neqpp
       end do
c     if(neqpp.ge.2) then
       end if
c
       if(neqpp.eq.1)write(6,*)
     + ' Spacegroup P1: Correlations all equal -',
     + ' Only  Phased translation peak height significant'
        dstmin = sqrt(dstmin)
C
C  Sort to get peak position in map too.
C  Set all angles to lie between 0 and 360
        PF(2,IMOL) = MOD(  PF(2,IMOL) + 7200.0,360.0)
        PF(3,IMOL) = MOD(  PF(3,IMOL) + 7200.0,360.0)
        PF(4,IMOL) = MOD(  PF(4,IMOL) + 7200.0,360.0)
        IF(PF(5,IMOL).GT.0.5)PF(5,IMOL) = PF(5,IMOL) -1.0
        IF(PF(6,IMOL).GT.0.5)PF(6,IMOL) = PF(6,IMOL) -1.0
        IF(PF(7,IMOL).GT.0.5)PF(7,IMOL) = PF(7,IMOL) -1.0
C        CALL OUTTRA1(NPIC,II(IC3),RR(1+2*NRA+7*NPIC),RR(1+2*NRA),N1)
        if(imol.lt.10) then
         WRITE (6,FMT='(A,I1,2X,I3,3F8.2,3F8.4,3F5.1,I4,F7.1)') 
     +   ' SOLUTIONTF', IMOL,I2,(PF(I,IMOL),I=2,10),N1,DstMIN
        else
        WRITE (6,FMT='(A,I2,1X,I3,3F8.2,3F8.4,3F5.1,I4,F7.1)') 
     +  ' SOLUTIONTF', IMOL,I2,(PF(I,IMOL),I=2,10),N1,DstMIN
        endif
30    continue
        IF(neqpp.gt.1)
     +    call outtra(npic,rxo,mss,tss,tts,neqpp,nttss,
     +                ii(ic3),rr(1+2*nra+7*npic),rr(1+2*nra))
      imol = 1
      iactual=0
      go to 10
40    return

C     These are the lengths of array args to trando1 (II, RR, CC):
C  ie NNI,NNR,NNC  equated to  mi mr (= mrr) mc 
C    NNI = mr      = TRAING_NR ( 1+ TRAING_MEQ) + TRAING_MRT
C    NNR = mr=mrr  = TRAING_NR + TRAING_MR
C    NNc = mc      = TRAING_NR ( 1+ TRAING_MEQ) + TRAING_MT


C     These are the lengths of array args to trando1 (II, RR, CC):
C  ie NNI,NNR,NNC  equated to  mi mr (= mrr) mc 
C    NNI = mr      = TRAING_NR ( 1+ TRAING_MEQ) + TRAING_MRT
C    NNR = mr=mrr  = TRAING_NR + TRAING_MR
C    NNc = mc      = TRAING_NR ( 1+ TRAING_MEQ) + TRAING_MT

C      LENG (1) = NR+NR*MEQ+MRT = NNI = MI
C      LENG (2) = NR+MR = NNR = MR = MRR
C      LENG (3) = NR+NR*MEQ+MT = NNC = MC
C       mi = NNI
C       mr = NNR
C       mc = NNC
C       MRR = MR
901   write(6,3010)ND,NNI,2*ND,NNR
      CALL CCPERR(1, 'Reset TRAING_MRT,TRAING_MR')
902   write(6,3020) nra*(1+neqP)+nrt,nni,nra,neqp,nrt
      CALL CCPERR(1, 'Reset TRAING_MRT - etc')
903   write(6,3030) molt
      CALL CCPERR(1, ' Split list of solutions into smaller blocks')
904   write(6,3040) mta,mt,nra*(1+neqP)+mta,nnc
      CALL CCPERR(1, 'Reset TRAING_MT - etc')
905   write(6,3050) nra+3*nx*ny,nnr
      CALL CCPERR(1, 'Reset TRAING_MR - etc')
906   write(6,3060) nra+2*nx*ny,nnr
      CALL CCPERR(1, 'Reset TRAING_MR - etc')
907   write(6,3070) TRATYP
      CALL CCPERR(1, ' Wrong Option - try : CC CO HL PT  or PTF')
2010  format(/' ****** programme traing ******'/
     . ' *** fast translation functions ***'/
     . ' *** j. navaza and e. vernoslova (1995),'/
     . ' acta cryst. a51, 445-449 ***')
 3010 FORMAT
     + (' > S/R TRANDO1 ~TRAING_MRT(required)',I10,'  MRTset)',I10,/,
     +  '               ~TRAING_MR (required)',I10,'  MR(set)',I10)
c3010  format(
c     + ' >> trando << increase TRAING_MRT,TRAING_MT - Current values',
c     +  2I10)
3020  format(' > S/R TRANDO2  ',/,
     + 'TRAING_NR(1+ TRAING_MEQ) +TRAING_MRT: Required',I10, 
     +                                      ' TRAING_NNI Set', I10,
     +  /,' TRAING_NR',I10,'  TRAING_MEQ',I10,
     +  ' TRAING_MRT',I10)
c3020  format(' >> trando << increase TRAING_NR(1+ TRAING_MEQ)',
c     +                            ' +TRAING_MRT: Required',I10, 
c     +                                             ' Set', I10)
3030  format(' >> trando << nb. molecules greater than 100 =',i5)
c3040  format(' >> trando << increase TRAING_NR(1+ TRAING_MEQ)',
c     +          ' +TRAING_MT:  Required',I10, ' Set', I10)
 3040 FORMAT (' > S/R TRANDO4',
     + ' TRAING_MT(required)',I10,'  MT(set)',I10,/,
     +  ' TRAING_NR(1+ TRAING_MEQ) +TRAING_MT:  Required',I10, 
     +  ' Set', I10)
3050  format(' >> trando << increase TRAING_NR + TRAING_MR)',
     +          '              Required',I10, ' Set', I10)
3060  format(' >> trando6 << increase TRAING_NR + TRAING_MR)',
     +          '   Required(nra+2*nx*ny)',I10, ' Set', I10)
3070  format(' >> trando << wrong option =',a5)
      end

C     =============================
      SUBROUTINE TRED1(NM,N,A,D,E,E2)
C     ===============================
C
C     .. Scalar Arguments ..
      INTEGER N,NM
C     ..
C     .. Array Arguments ..
      REAL A(NM,N),D(N),E(N),E2(N)
C     ..
C     .. Local Scalars ..
      REAL F,G,H,SCALE
      INTEGER I,II,J,JP1,K,L
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,SIGN,SQRT
C     ..
C
      DO 10 I = 1,N
        D(I) = A(N,I)
        A(N,I) = A(I,I)
   10 CONTINUE
C
      DO 170 II = 1,N
        I = N + 1 - II
        L = I - 1
        H = 0.0
        SCALE = 0.0
        IF (L.LT.1) GO TO 40
C
        DO 20 K = 1,L
          SCALE = ABS(D(K)) + SCALE
   20   CONTINUE
C
        IF (SCALE.NE.0.0) GO TO 50
C
        DO 30 J = 1,L
          D(J) = A(L,J)
          A(L,J) = A(I,J)
          A(I,J) = 0.0
   30   CONTINUE
C
   40   E(I) = 0.0
        E2(I) = 0.0
        GO TO 170
C
   50   DO 60 K = 1,L
          D(K) = D(K)/SCALE
          H = D(K)*D(K) + H
   60   CONTINUE
C
        E2(I) = SCALE*SCALE*H
        F = D(L)
        G = -SIGN(SQRT(ABS(H)),F)
        E(I) = SCALE*G
        H = H - F*G
        D(L) = F - G
        IF (L.EQ.1) GO TO 150
C
        DO 70 J = 1,L
          E(J) = 0.0
   70   CONTINUE
C
        DO 100 J = 1,L
          F = D(J)
          G = A(J,J)*F + E(J)
          JP1 = J + 1
          IF (L.LT.JP1) GO TO 90
C
          DO 80 K = JP1,L
            G = A(K,J)*D(K) + G
            E(K) = A(K,J)*F + E(K)
   80     CONTINUE
C
   90     E(J) = G
  100   CONTINUE
C
        F = 0.0
C
        DO 110 J = 1,L
          E(J) = E(J)/H
          F = E(J)*D(J) + F
  110   CONTINUE
C
        H = F/ (H+H)
C
        DO 120 J = 1,L
          E(J) = E(J) - D(J)*H
  120   CONTINUE
C
        DO 140 J = 1,L
          F = D(J)
          G = E(J)
          DO 130 K = J,L
            A(K,J) = A(K,J) - E(K)*F - D(K)*G
  130     CONTINUE
  140   CONTINUE
C
  150   DO 160 J = 1,L
          F = D(J)
          D(J) = A(L,J)
          A(L,J) = A(I,J)
          A(I,J) = F*SCALE
  160   CONTINUE
  170 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE TRED2(NM,N,A,D,E,Z)
C     ==============================
C
C     .. Scalar Arguments ..
      INTEGER N,NM
C     ..
C     .. Array Arguments ..
      REAL A(NM,N),D(N),E(N),Z(NM,N)
C     ..
C     .. Local Scalars ..
      REAL F,G,H,HH,SCALE
      INTEGER I,II,J,JP1,K,L
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,SIGN,SQRT
C     ..
C
      DO 20 I = 1,N
        DO 10 J = I,N
          Z(J,I) = A(J,I)
   10   CONTINUE
        D(I) = A(N,I)
   20 CONTINUE
C
      IF (N.EQ.1) GO TO 250
C
      DO 170 II = 2,N
        I = N + 2 - II
        L = I - 1
        H = 0.0
        SCALE = 0.0
        IF (L.LT.2) GO TO 40
C
        DO 30 K = 1,L
          SCALE = ABS(D(K)) + SCALE
   30   CONTINUE
C
        IF (SCALE.NE.0.0) GO TO 60
   40   E(I) = D(L)
C
        DO 50 J = 1,L
          D(J) = Z(L,J)
          Z(I,J) = 0.0
          Z(J,I) = 0.0
   50   CONTINUE
C
        GO TO 160
C
   60   DO 70 K = 1,L
          D(K) = D(K)/SCALE
          H = D(K)*D(K) + H
   70   CONTINUE
C
        F = D(L)
        G = -SIGN(SQRT(ABS(H)),F)
        E(I) = SCALE*G
        H = H - F*G
        D(L) = F - G
C
        DO 80 J = 1,L
          E(J) = 0.0
   80   CONTINUE
C
        DO 110 J = 1,L
          F = D(J)
          Z(J,I) = F
          G = Z(J,J)*F + E(J)
          JP1 = J + 1
          IF (L.LT.JP1) GO TO 100
C
          DO 90 K = JP1,L
            G = Z(K,J)*D(K) + G
            E(K) = Z(K,J)*F + E(K)
   90     CONTINUE
  100     E(J) = G
  110   CONTINUE
C
        F = 0.0
C
        DO 120 J = 1,L
          E(J) = E(J)/H
          F = E(J)*D(J) + F
  120   CONTINUE
C
        HH = F/ (H+H)
C
        DO 130 J = 1,L
          E(J) = E(J) - D(J)*HH
  130   CONTINUE
C
        DO 150 J = 1,L
          F = D(J)
          G = E(J)
          DO 140 K = J,L
            Z(K,J) = Z(K,J) - E(K)*F - D(K)*G
  140     CONTINUE
          D(J) = Z(L,J)
          Z(I,J) = 0.0
  150   CONTINUE
  160   D(I) = H
  170 CONTINUE
C
      DO 240 I = 2,N
        L = I - 1
        Z(N,L) = Z(L,L)
        Z(L,L) = 1.0
        H = D(I)
        IF (H.EQ.0.0) GO TO 220
C
        DO 180 K = 1,L
          D(K) = Z(K,I)/H
  180   CONTINUE
C
        DO 210 J = 1,L
          G = 0.0
          DO 190 K = 1,L
            G = Z(K,I)*Z(K,J) + G
  190     CONTINUE
C
          DO 200 K = 1,L
            Z(K,J) = Z(K,J) - D(K)*G
  200     CONTINUE
  210   CONTINUE
C
  220   DO 230 K = 1,L
          Z(K,I) = 0.0
  230   CONTINUE
  240 CONTINUE
C
  250 DO 260 I = 1,N
        D(I) = Z(N,I)
        Z(N,I) = 0.0
  260 CONTINUE
C
      Z(N,N) = 1.0
      E(1) = 0.0
C
      RETURN
      END
C
C
C     =========================
      SUBROUTINE TRIP(U,V,W,ID)
C     =========================
C
C     .. Scalar Arguments ..
      INTEGER ID
C     ..
C     .. Array Arguments ..
      INTEGER U(3),V(3),W(3)
C     ..
C     .. Local Scalars ..
      INTEGER IA,IB
C     ..
C
      IA = U(1)*V(2)*W(3) + V(1)*W(2)*U(3) + V(3)*U(2)*W(1)
      IB = W(1)*V(2)*U(3) + U(2)*V(1)*W(3) + W(2)*V(3)*U(1)
      ID = IA - IB
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE UNPAC3(IH,IK,IL,IND3)
C     ================================
C
C     .. Scalar Arguments ..
      INTEGER IH,IK,IL,IND3
C     ..
C     .. Scalars in Common ..
      INTEGER HM,KM,LM,NH,NK,NL,NM
C     ..
C     .. Local Scalars ..
      INTEGER IND1,IND2
C     ..
C     .. Common blocks ..
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
C     ..
      SAVE
C
      IND2 = IND3/NH
      IND1 = IND2/NK
      IL = IND1 - LM
      IK = IND2 - IND1*NK - KM
      IH = IND3 - IND2*NH - HM
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE UNPAC4(IH,IK,IL,IM,IND4)
C     ===================================
C
C     .. Scalar Arguments ..
      INTEGER IH,IK,IL,IM,IND4
C     ..
C     .. Scalars in Common ..
      INTEGER HM,KM,LM,NH,NK,NL,NM
C     ..
C     .. Local Scalars ..
      INTEGER IND1,IND2,IND3
C     ..
C     .. Common blocks ..
      COMMON /PACO/HM,KM,LM,NH,NK,NL,NM
C     ..
      SAVE
C
      IND3 = IND4/NM
      IND2 = IND3/NH
      IND1 = IND2/NK
      IL = IND1 - LM
      IK = IND2 - IND1*NK - KM
      IH = IND3 - IND2*NH - HM
      IM = IND4 - IND3*NM
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE UNPAKG(IH,IK,IL,IND)
C     ===============================
C
C     .. Scalar Arguments ..
      INTEGER IH,IK,IL,IND
C     ..
C     .. Scalars in Common ..
      INTEGER HLOW,KLOW,LLOW,NH,NK,NL
C     ..
C     .. Local Scalars ..
      INTEGER IND1,IND2,IND3
C     ..
C     .. Common blocks ..
      COMMON /PAKO/HLOW,KLOW,LLOW,NH,NK,NL
C     ..
      SAVE
C
      IND3 = IND - 1
      IND2 = IND3/NH
      IND1 = IND2/NK
      IL = IND1 + LLOW
      IK = IND2 - IND1*NK + KLOW
      IH = IND3 - IND2*NH + HLOW
C
      RETURN
      END
C
C
C     =============================================
      SUBROUTINE XFFTH(T2,MI,MR,MC,II,RR,CC)
C     =============================================
C
C  RXYZ matches RZ1; PHKL matches PHKL1
C
C     .. Scalar Arguments ..
      INTEGER T2,MC,MI,MR
C     ..
C     .. Array Arguments ..
      COMPLEX CC(MC)
      REAL RR(MR)
      INTEGER II(MI)
C     ..
C     .. Scalars in Common ..
      INTEGER HLW,HMAX,HUP,KLW,KMAX,KUP,LLW,LMAX,LUP,NRA,NWDS,NX,NXYZ,
     +        NY,NZ,PH,PZ,T0,XLW,XUP,YLW,YUP,ZLW,ZUP
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      INTEGER HS,HST,MY,MZ,NH,NK,NX2,PZT,ZS
      LOGICAL SKIP
C     ..
C     .. Local Arrays ..
      INTEGER DIM(5)
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPDPN,CMPLFT,HOUT,PHKL1,REALFT,RZ1,XYTOHY,YTOK,ZIN,ZTOZ
C     ..
C     .. Common blocks ..
      COMMON /DFFTT/HLW,HUP,KLW,KUP,LLW,LUP,NRA,NXYZ
      COMMON /DFFTTD/PH,PZ,T0,NWDS
      COMMON /DFFTTX/BID1(6),XLW,YLW,ZLW,XUP,YUP,ZUP
      COMMON /GRID/HMAX,KMAX,LMAX,NX,NY,NZ
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      NXP2 = NX+2
      NX2 = NX/2
      NX21 = NX/2 + 1
      NH  = HUP-HLW+1
      NK  = KUP-KLW+1
      MY  = YUP-YLW+1
      MZ  = ZUP-ZLW+1
      HS  = 0
      ZS  = ZLW
      PZT = PZ
      SKIP = .TRUE.
C
      IF (PH.LT.NH .OR. PZ.LT.MZ) THEN
        SKIP = .FALSE.
C
C            ********************************************
        IFAIL = 0
        CALL CCPDPN(T0,'FFTHKLSCR','SCRATCH','DU',NWDS,IFAIL)
C            ********************************************
C
      END IF
C
   10 IF (ZS+PZT.GT.ZUP+1) PZT = ZUP + 1 - ZS
C
C          ************************
      CALL RZ1(NXP2,MY,PZT,ZS,RR(1))
C          ************************
C
      DIM(1) = NXP2*MY*PZT
      DIM(2) = 2
      DIM(3) = DIM(1)
      DIM(4) = DIM(1)
      DIM(5) = NXP2
C
C     I hope this is the prob -- NX is the dimension but REALFT requires
      NX2 = NX/2
C          ******************************************
      CALL REALFT(RR(1),RR(2),NX2,DIM)
C  Cunning rewriting of array..
      CALL XYTOHY(NX21,MY,PZT,NH,NY,RR(1),RR(1),RR(1))
C          ******************************************
C
      DIM(1) = 2*NH*NY*PZT
      DIM(2) = 2*NH
      DIM(3) = 2*NH*NY
      DIM(4) = DIM(2)
      DIM(5) = 2
C
C          *****************************
      CALL CMPLFT(RR(1),RR(2),NY,DIM)
      CALL YTOK(NH,NY,PZT,NK,RR(1),RR(1))
C          *****************************
C
C                    ***********************************
      IF (.NOT.SKIP) CALL HOUT(T0,NH,NK,PZT,PH,ZS,RR(1))
C                    ***********************************
C
      ZS = ZS + PZT
      IF (ZS.LT.ZUP+1) GO TO 10
   20 continue
      IF (HS+PH.GT.NH) PH = NH - HS
      HST = HS + HLW
C
C                    ************************************
      IF (.NOT.SKIP) CALL ZIN(T0,PH,NK,MZ,PZ,HS,NH,RR(1))
C                    ************************************
C
C          *****************************
      CALL ZTOZ(PH,NK,MZ,NZ,RR(1),RR(1))
C          *****************************
C
      DIM(1) = 2*PH*NK*NZ
      DIM(2) = 2*PH*NK
      DIM(3) = 2*PH*NK*NZ
      DIM(4) = DIM(2)
      DIM(5) = 2
C
C          **************************************************
      CALL CMPLFT(RR(1),RR(2),NZ,DIM)
      CALL PHKL1(T2,NRA,PH,NK,NZ,HST,II(1),II(1+NRA),RR(1),CC(1))
c      CALL PHKL1(NRA,PH,NK,NZ,HST,II(1),II(1+NRA),RR(1),CC(1))
C          **************************************************
C
      HS = HS + PH
      IF (HS.LT.NH) GO TO 20
      IF (.NOT.SKIP .AND. T0.NE.0) CLOSE (UNIT=T0)
      RETURN
      END
C
C
C     ===========================================
      SUBROUTINE XYTOHY(NX2,MY,NZ,NH,NY,WW,VV,UU)
C     ===========================================
C
C     .. Scalar Arguments ..
      INTEGER MY,NH,NX2,NY,NZ
C     ..  Array UU only covers "NY" = YUP-YLW+1
C     ..  Must expand the Y range to cover 0 to NYgrid -1
C     ..  But we only need  NH  = HUP-HLW+1 elents along X
C     ..
C     ..
C     .. Array Arguments ..
      COMPLEX UU(NH,NY,NZ),VV(NH,MY,NZ),WW(NX2,MY,NZ)
C     ..
C     .. Scalars in Common ..
      INTEGER XLW,XUP,YLW,YUP,ZLW,ZUP
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      INTEGER IH,IY,IZ
C     ..
C     .. Common blocks ..
      COMMON /DFFTTX/BID1(6),XLW,YLW,ZLW,XUP,YUP,ZUP
C     ..
      SAVE
C
      DO 30 IZ = 1,NZ
        DO 20 IY = 1,MY
          DO 10 IH = 1,NH
            VV(IH,IY,IZ) = WW(IH,IY,IZ)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
      DO 60 IZ = NZ,1,-1
        DO 50 IY = MY,1,-1
          DO 40 IH = NH,1,-1
            UU(IH,YLW+IY,IZ) = VV(IH,IY,IZ)
   40     CONTINUE
   50   CONTINUE
   60 CONTINUE
C
      DO 100 IZ = 1,NZ
        DO 90 IH = 1,NH
          DO 70 IY = 1,YLW
            UU(IH,IY,IZ) = (0.0,0.0)
   70     CONTINUE
          DO 80 IY = YLW + MY + 1,NY
            UU(IH,IY,IZ) = (0.0,0.0)
   80     CONTINUE
   90   CONTINUE
  100 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE YTOK(NH,NY,NZ,NK,WW,VV)
C     ==================================
C
C     .. Scalar Arguments ..
      INTEGER NH,NK,NY,NZ
C     ..
C     .. Array Arguments ..
      COMPLEX VV(NH,NK,NZ),WW(NH,NY,NZ)
C     ..
C     .. Scalars in Common ..
      INTEGER HLW,HUP,KLW,KUP,LLW,LUP,NRA,NXYZ
C     ..
C     .. Local Scalars ..
      INTEGER IH,IK,IZ
C     ..
C     .. Common blocks ..
      COMMON /DFFTT/HLW,HUP,KLW,KUP,LLW,LUP,NRA,NXYZ
C     ..
      SAVE
C
      DO 50 IZ = 1,NZ
        DO 20 IK = 1,KUP + 1
          DO 10 IH = 1,NH
            VV(IH,IK,IZ) = WW(IH,IK,IZ)
   10     CONTINUE
   20   CONTINUE
C
        DO 40 IK = KLW + 1,0
          DO 30 IH = 1,NH
            VV(IH,NK+IK,IZ) = WW(IH,NY+IK,IZ)
   30     CONTINUE
   40   CONTINUE
   50 CONTINUE
C
      RETURN
      END
C
C
C     =============================
      SUBROUTINE ZEROA(FUNTIO,FLEV,N,XL,XU,X)
C     ======================================
C
C     .. Scalar Arguments ..
      REAL FLEV,X,XL,XU
      INTEGER N
C     ..
C     .. Subroutine Arguments ..
      EXTERNAL FUNTIO
C     ..
C     .. Local Scalars ..
      REAL FL,FS,FU,XS
      INTEGER J,NIT
C     ..
      SAVE
C     .. Data statements ..
      DATA NIT/100/
C     ..
C
C          ***************
      CALL FUNTIO(N,XL,FL)
C          ***************
C
      FL = FL - FLEV
C
C          ***************
      CALL FUNTIO(N,XU,FU)
C          ***************
C
      FU = FU - FLEV
      IF (FL*FU.GT.0.0) GO TO 20
C
      DO 10 J = 1,NIT
        XS = (XL+XU)/2.0
C
C            ***************
        CALL FUNTIO(N,XS,FS)
C            ***************
C
        FS = FS - FLEV
C
        IF (FS*FL.GT.0.0) THEN
          XL = XS
          FL = FS
        ELSE
          XU = XS
          FU = FS
        END IF
   10 CONTINUE
C
      X = (XL+XU)/2.0
      RETURN
C
C          ******************************************************
   20 CALL CCPERR(1,' > s/r zeroa < equal signs for regula falsi')
C          ******************************************************
C
      END
C
C
C     =============================
      SUBROUTINE ZIN(T0,PH,NK,NZ,PZ,HS,NH,WW)
C     =======================================
C
C     .. Scalar Arguments ..
      INTEGER HS,NH,NK,NZ,PH,PZ,T0
C     ..
C     .. Array Arguments ..
      COMPLEX WW(PH*NK,NZ)
C     ..
C     .. Local Scalars ..
      INTEGER HREC,IHK,IREC,IZ,PHT,ZF,ZS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF (HS.EQ.0) THEN
          HREC = (NH-1)/PH+1
          PHT  = PH
      END IF
C
      ZF = 0
      IREC= HS/PHT+1
C
   10 ZS = ZF + 1
      ZF = ZF + PZ
      IF (ZF.GT.NZ) ZF = NZ
      READ (T0,REC=IREC) ((WW(IHK,IZ),IHK=1,PH*NK),IZ=ZS,ZF)
      IREC = IREC + HREC
      IF (ZF.LT.NZ) GO TO 10
      END
C
C
C     =============================
      SUBROUTINE ZOUT(T0,PH,NK,NZ,PZ,HS,WW)
C     =====================================
C
C     .. Scalar Arguments ..
      INTEGER HS,NK,NZ,PH,PZ,T0
C     ..
C     .. Array Arguments ..
      COMPLEX WW(PH*NK,NZ)
C     ..
C     .. Local Scalars ..
      INTEGER IHK,IREC,IZ,ZF,ZS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IF (HS.EQ.0) IREC = 0
      ZF = 0
   10 ZS = ZF + 1
      ZF = ZF + PZ
      IF (ZF.GT.NZ) ZF = NZ
      IREC = IREC + 1
      WRITE (T0,REC=IREC) ((WW(IHK,IZ),IHK=1,PH*NK),IZ=ZS,ZF)
      IF (ZF.LT.NZ) GO TO 10
      END
C
C
C     =============================
      SUBROUTINE ZTOZ(NH,NK,MZ,NZ,WW,VV)
C     ==================================
C
C     .. Scalar Arguments ..
      INTEGER MZ,NH,NK,NZ
C     ..
C     .. Array Arguments ..
      COMPLEX VV(NH,NK,NZ),WW(NH,NK,MZ)
C     ..
C     .. Scalars in Common ..
      INTEGER XLW,XUP,YLW,YUP,ZLW,ZUP
C     ..
C     .. Arrays in Common ..
      REAL BID1
C     ..
C     .. Local Scalars ..
      INTEGER IH,IK,IZ
C     ..
C     .. Common blocks ..
      COMMON /DFFTTX/BID1(6),XLW,YLW,ZLW,XUP,YUP,ZUP
C     ..
      SAVE
C
      DO 30 IZ = MZ,1,-1
        DO 20 IK = NK,1,-1
          DO 10 IH = NH,1,-1
            VV(IH,IK,ZLW+IZ) = WW(IH,IK,IZ)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
      DO 70 IK = 1,NK
        DO 60 IH = 1,NH
          DO 40 IZ = 1,ZLW
            VV(IH,IK,IZ) = CMPLX(0.0,0.0)
   40     CONTINUE
          DO 50 IZ = ZLW + MZ + 1,NZ
            VV(IH,IK,IZ) = CMPLX(0.0,0.0)
   50     CONTINUE
   60   CONTINUE
   70 CONTINUE
C
      END
C
C
C     ===========================
      SUBROUTINE READSF(ID,IFIFF)
C     ===========================
C
C     ..
C     .. Arguments ..
      CHARACTER*4 ID
      LOGICAL IFIFF
C     .. Locals ..
      REAL              A(4),B(4),C,CU(2),MO(2)
      INTEGER           IELEC,IFAIL,IWT,NG
      CHARACTER IDD*4
C     ..
C     .. Commons ..
      CHARACTER KEYID*4
      REAL FORM
      INTEGER NFORM, NTYP
C     ..
C     .. Common Blocks ..
      COMMON /CTYPE/KEYID(100)
      COMMON /ATYPE/FORM(10,100),NFORM,NTYP
C     ..
C     .. Save Statement ..
      SAVE /CTYPE/,/ATYPE/
C     ..
C     Number of Gaussians
      NG = 5
C
C      If this is the first pass, put H,C,N,O,S into KEYID & FORM
      IF (NTYP.EQ.0) THEN
        KEYID(1) = ' H  '
        KEYID(2) = ' C  '
        KEYID(3) = ' N  '
        KEYID(4) = ' O  '
        KEYID(5) = ' S  '

        DO 10 I = 1,5
         IDD = KEYID(I)(2:4)//' '
         CALL SFREAD2(IDD,NG,A,B,C,IWT,IELEC,CU,MO,IFAIL)
         IF (IFAIL.EQ.-1) CALL CCPERR(1,'No structure factor found')
C
         DO 20 J = 1,4
          FORM(2*J-1,I) = A(J)
          FORM(2*J,I) = B(J)
   20    CONTINUE
         FORM(9,I) = C
         FORM(10,I) = C
         Write(6,'(a,i4,2x,a,2x,10f8.3)')
     + ' Form factor',i,keyid(i),(form(j,i),j=1,10)
C
   10   CONTINUE
        NTYP = 5
        RETURN
      END IF

      NTYP = NTYP + 1
      IF(NTYP.GT.100) CALL CCPERR
     +   (1,'  Too many formfactors needed - limit is 100')
      IF (ID(1:1) .EQ. ' ') THEN
        IDD = ID(2:4)//' '
      ELSE
        IDD = ID
      ENDIF
C
      CALL SFREAD2(IDD,NG,A,B,C,IWT,IELEC,CU,MO,IFAIL)
      IF (IFAIL.EQ.-1) CALL CCPERR(1,'No structure factor found')
C
      DO 30 J=1,4
         FORM(2*J-1,NTYP) = A(J)
         FORM(2*J,NTYP) = B(J)
   30 CONTINUE
C
      FORM(9,NTYP) = C
      FORM(10,NTYP) = C
      KEYID(NTYP) = ID
      Write(*,'(a,i4,2x,a,2x,10f8.3)')
     +' Form factor',ntyp,keyid(ntyp),(form(j,ntyp),j=1,10)

      RETURN
      END
C
C
      subroutine correl(mxyz,rr)
c      implicit none
      character*10 mapnam
      character*80 maptit
      integer iuvw(3),nxyz(3)
      integer nx,ny,nxy,nsec,nz,ij,i,npic,ibid1,o1
      real smax,a,b,c,al,be,ga,seuil,rbid1,rr,cell(6)
      dimension rr(mxyz,3)
      common/pik/ seuil,npic,rbid1
      common/tapes/ ibid1(2),o1
C
C---- reopen map to search for peaks
C
      IMAP1 = 1
      IMAP2 = 2
      IMAP3 = 3
      MODE = 2
       mapnam = 'MAPTMP1'
      CALL MRDHDR(IMAP1,MAPNAM,MAPTIT,NSEC,IUVW,NXYZ,JSEC,JU1,JU2,JV1,
     +            JV2,CELL,IRSYGP,MODE,RHMIN,RHMAX,RHMEAN,RMS)
       mapnam = 'MAPTMP2'
      CALL MRDHDR(IMAP2,MAPNAM,MAPTIT,NSEC,IUVW,NXYZ,JSEC,JU1,JU2,JV1,
     +            JV2,CELL,IRSYGP,MODE,RHMIN,RHMAX,RHMEAN,RMS)
       mapnam = 'MAPTMP3'
      CALL MRDHDR(IMAP3,MAPNAM,MAPTIT,NSEC,IUVW,NXYZ,JSEC,JU1,JU2,JV1,
     +            JV2,CELL,IRSYGP,MODE,RHMIN,RHMAX,RHMEAN,RMS)
C
      IMAP = 4
       mapnam = 'MAPOUT    '
      CALL MWRHDL(IMAP,MAPNAM,MAPTIT,NSEC,IUVW,NXYZ,JSEC,JU1,JU2,JV1,
     +            JV2,CELL,IRSYGP,MODE)
C
      nx=ju2-ju1+1
      ny=jv2-jv1+1
      nxy=nx*ny
      smin= 1.e20
      smax=-1.e20
c      rewind(unit=i1)
c      rewind(unit=i2)
c      rewind(unit=i3)
c      rewind(unit=o1)
       do lsec = jsec,jsec+nsec-1
C
C     CORRECT SECTION, GENERATE OUTPUT SECTION
         call mposn(IMAP1,lsec)
         call mgulpr(IMAP1,rr(1,1),ier)
            if(ier.ne.0) call ccperr(1,' Error in MAPTMP1')
         call mposn(IMAP2,lsec)
         call mgulpr(IMAP2,rr(1,2),ier)
            if(ier.ne.0) call ccperr(1,' Error in MAPTMP2')
            call mposn(IMAP3,lsec)
            call mgulpr(IMAP3,rr(1,3),ier)
            if(ier.ne.0) call ccperr(1,' Error in MAPTMP3')


c      read(i1) nx,ny,nz,a,b,c,al,be,ga
c      read(i2) nx,ny,nz,a,b,c,al,be,ga
c      read(i3) nx,ny,nz,a,b,c,al,be,ga
c     write(o1) nx,ny,nz,a,b,c,al,be,ga
c10    continue
c     read(i1) (rr(ij,1),ij=1,nxy)
c     read(i2) (rr(ij,2),ij=1,nxy)
c     read(i3) (rr(ij,3),ij=1,nxy)
      do 20 i=1,nxy
c      write(6,'(i3,3E15.5)')i,rr(i,1),rr(i,2),rr(1,3)
      rr(i,1)=rr(i,2)/sqrt(rr(i,1)-rr(i,3)*rr(i,3))
      if(smin.gt.rr(i,1)) smin=rr(i,1)
      if(smax.lt.rr(i,1)) smax=rr(i,1)
20    continue
            call mspew(iMAP,rr(1,1))
      end do
         call mwclose(IMAP)
c      write(o1) (rr(ij,1),ij=1,nxy)
c      if(nsec.lt.nz) go to 10
      seuil=smax
         call mrclos(IMAP1)
         call mrclos(IMAP2)
         call mrclos(IMAP3)
      return
      end
      subroutine harada(mxyz,rr)
      implicit none
      character*10 mapnam
      character*80 maptit
      integer iuvw(3),nxyz(3),nxy,nsec,nz,ij,i,npic,JSEC,JU1,JU2,JV1,
     + JV2,IRSYGP,MODE,LSEC,mxyz,imap1,imap2,imaps,imap,ier
      real smax,smin,al,be,ga,seuil,rbid1,rr,cell(6),
     +  RHMIN,RHMAX,RHMEAN,RMS
      dimension rr(mxyz,3)

      common/pik/ seuil,npic,rbid1
      IMAP1 = 1
      IMAP2 = 2
      MODE = 2
       mapnam = 'MAPTMP1'
      CALL MRDHDR(IMAP1,MAPNAM,MAPTIT,NSEC,IUVW,NXYZ,JSEC,JU1,JU2,JV1,
     +            JV2,CELL,IRSYGP,MODE,RHMIN,RHMAX,RHMEAN,RMS)
       mapnam = 'MAPTMP2'
      CALL MRDHDR(IMAP2,MAPNAM,MAPTIT,NSEC,IUVW,NXYZ,JSEC,JU1,JU2,JV1,
     +            JV2,CELL,IRSYGP,MODE,RHMIN,RHMAX,RHMEAN,RMS)
C
      IMAP = 3
       mapnam = 'MAPOUT    '
      CALL MWRHDL(IMAP,MAPNAM,MAPTIT,NSEC,IUVW,NXYZ,JSEC,JU1,JU2,JV1,
     +            JV2,CELL,IRSYGP,MODE)
C
c      nx=ju2-ju1+1
c      ny=jv2-jv1+1
      nxy=(ju2-ju1+1)*(jv2-jv1+1)
      smin= 1.e20
      smax=-1.e20
c      nxy=nx*ny
c      nsec=0
c      smax=-1.e20
c      rewind(unit=i1)
c      rewind(unit=i2)
c      rewind(unit=o1)
c      read(i1) nx,ny,nz,a,b,c,al,be,ga
c      read(i2) nx,ny,nz,a,b,c,al,be,ga
c      write(o1) nx,ny,nz,a,b,c,al,be,ga
c10    read(i1) (rr(ij,1),ij=1,nxy)
c      read(i2) (rr(ij,2),ij=1,nxy)
c      nsec=nsec+1
c      do 20 i=1,nxy
c      rr(i,1)=rr(i,1)/rr(i,2)
c      if(smax.lt.rr(i,1)) smax=rr(i,1)
c20    continue
c      write(o1) (rr(ij,1),ij=1,nxy)
c      if(nsec.lt.nz) go to 10
C
       do lsec = jsec,jsec+nsec-1
C
C     CORRECT SECTION, GENERATE OUTPUT SECTION
         call mposn(IMAP1,lsec)
         call mgulpr(IMAP1,rr(1,1),ier)
            if(ier.ne.0) call ccperr(1,' Error in MAPTMP1')
         call mposn(IMAP2,lsec)
         call mgulpr(IMAP2,rr(1,2),ier)
            if(ier.ne.0) call ccperr(1,' Error in MAPTMP2')
      do 20 i=1,nxy
c      write(6,'(i3,3E15.5)')i,rr(i,1),rr(i,2),rr(1,3)
        rr(i,1)=rr(i,1)/rr(i,2)
        if(smin.gt.rr(i,1)) smin=rr(i,1)
        if(smax.lt.rr(i,1)) smax=rr(i,1)
20    continue
            call mspew(iMAP,rr(1,1))
      end do
         call mwclose(IMAP)
      seuil=smax
         call mrclos(IMAP1)
         call mrclos(IMAP2)
      return
      end
      subroutine reffc(mt,nra,meq,nt,hkls,hklt)
      implicit none
      integer nra,meq,nt,klw,kup,llw,lup,indx,ir,is1,neq,ks1,ls1,k,l,
     & ind,is2,ks2,ls2,jh1,jk1,jl1,is3,ks3,ls3,jh2,jk2,jl2,is4,ks4,ls4,
     & klow,llow,nh,nk,nl,mt,kprt,n,indl,ni,inds,indh,i,kt,lt,nrt,
     & ilec,ibid1,nts,nxyz,hkls,hklt,hlw,hup,hlow,h,ht,hs1,hs2,hs3,
     & hs4
      real fuzz,sqhmax,dmint,sqhsup,sqh,a31,a32,a33,a21,a22,a11,rbid1,
     & dmaxo,dmino,rbid2,rbid3
      character cbid1*1
      dimension hkls(nra,meq),hklt(nt)
      COMMON /IOPRG/KPRT
      common/simt/ rbid1(153),ibid1(432),neq,nts
      common/star/ a11,a21,a22,a31,a32,a33
      common/reso/ dmaxo,dmino,rbid2,dmint,rbid3(2)
      common/dfftt/ hlw,hup,klw,kup,llw,lup,nrt,nxyz
      common/pako/ hlow,klow,llow,nh,nk,nl
      fuzz=1.0001
      sqhmax=(fuzz/dmint)**2
      hlw=0
      hup=0
      klw=0
      kup=0
      llw=0
      lup=0
      indx=0
      sqhsup=0.
      do 80 ir=1,nra
      do 70 is1=1,neq
      call unpac3(hs1,ks1,ls1,hkls(ir,is1))
      h=hs1
      k=ks1
      l=ls1
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
         endif
      call pac3(h,k,l,ind)
      if(ind.gt.indx) indx=ind
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
      do 60 is2=1,neq
      call unpac3(hs2,ks2,ls2,hkls(ir,is2))
      jh1=hs1-hs2
      jk1=ks1-ks2
      jl1=ls1-ls2
      h=jh1
      k=jk1
      l=jl1
      if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) goto 10
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 10
      call pac3(h,k,l,ind)
      if(ind.gt.indx) indx=ind
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
10    h=hs1+hs2
      k=ks1+ks2
      l=ls1+ls2
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 20
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
         endif
      call pac3(h,k,l,ind)
      if(ind.gt.indx) indx=ind
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
20    do 50 is3=1,neq
      call unpac3(hs3,ks3,ls3,hkls(ir,is3))
      jh2=jh1+hs3
      jk2=jk1+ks3
      jl2=jl1+ls3
      h=jh2
      k=jk2
      l=jl2
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 30
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
         endif
      call pac3(h,k,l,ind)
      if(ind.gt.indx) indx=ind
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
30    do 40 is4=1,neq
      call unpac3(hs4,ks4,ls4,hkls(ir,is4))
      h=jh2-hs4
      k=jk2-ks4
      l=jl2-ls4
      if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) goto 40
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 40
      call pac3(h,k,l,ind)
      if(ind.gt.indx) indx=ind
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
40    continue
50    continue
60    continue
70    continue
80    continue
      hlow=hlw
      klow=klw
      llow=llw
      nh=hup-hlw+1
      nk=kup-klw+1
      nl=lup-llw+1
      dmint=1/sqrt(sqhsup)
      call unpac3(h,k,l,indx)
      call pakg(h,k,l,mt)
      if(kprt.ne.0) write(6,2010) mt,hlw,hup,klw,kup,llw,lup,dmint
      if(mt.gt.nt) go to 90
      nt=mt
90    n=0
      indl=0
100   ni=n+1
      inds=indl-n
      indh=inds+nt
      if(indh.gt.mt) indh=mt
      if(nt-n.lt.neq*nra) go to 901
      do 110 i=ni,nt
      hklt(i)=0
110   continue
      do 190 ir=1,nra
      do 180 is1=1,neq
      call unpac3(hs1,ks1,ls1,hkls(ir,is1))
      h=hs1
      k=ks1
      l=ls1
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
         endif
      call pakg(h,k,l,ind)
      call unpakg(ht,kt,lt,ind)
      if(ind.gt.mt.or.ind.le.0.or.ht.ne.h.or.kt.ne.k.or.lt.ne.l)
     . go to 902
      if(ind.gt.indl.and.ind.le.indh) hklt(ind-inds)=1
      do 170 is2=1,neq
      call unpac3(hs2,ks2,ls2,hkls(ir,is2))
      jh1=hs1-hs2
      jk1=ks1-ks2
      jl1=ls1-ls2
      h=jh1
      k=jk1
      l=jl1
      if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0))))goto 120
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 120
      call pakg(h,k,l,ind)
      call unpakg(ht,kt,lt,ind)
      if(ind.gt.mt.or.ind.le.0.or.ht.ne.h.or.kt.ne.k.or.lt.ne.l)
     . go to 902
      if(ind.gt.indl.and.ind.le.indh) hklt(ind-inds)=1
120   h=hs1+hs2
      k=ks1+ks2
      l=ls1+ls2
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 130
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
         endif
      call pakg(h,k,l,ind)
      call unpakg(ht,kt,lt,ind)
      if(ind.gt.mt.or.ind.le.0.or.ht.ne.h.or.kt.ne.k.or.lt.ne.l)
     . go to 902
      if(ind.gt.indl.and.ind.le.indh) hklt(ind-inds)=1
130   do 160 is3=1,neq
      call unpac3(hs3,ks3,ls3,hkls(ir,is3))
      jh2=jh1+hs3
      jk2=jk1+ks3
      jl2=jl1+ls3
      h=jh2
      k=jk2
      l=jl2
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 140
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
         endif
      call pakg(h,k,l,ind)
      call unpakg(ht,kt,lt,ind)
      if(ind.gt.mt.or.ind.le.0.or.ht.ne.h.or.kt.ne.k.or.lt.ne.l)
     . go to 902
      if(ind.gt.indl.and.ind.le.indh) hklt(ind-inds)=1
140   do 150 is4=1,neq
      call unpac3(hs4,ks4,ls4,hkls(ir,is4))
      h=jh2-hs4
      k=jk2-ks4
      l=jl2-ls4
      if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0))))
     . go to 150
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 150
      call pakg(h,k,l,ind)
      call unpakg(ht,kt,lt,ind)
      if(ind.gt.mt.or.ind.le.0.or.ht.ne.h.or.kt.ne.k.or.lt.ne.l)
     . go to 902
      if(ind.gt.indl.and.ind.le.indh) hklt(ind-inds)=1
150   continue
160   continue
170   continue
180   continue
190   continue
      do 200 i=ni,nt
      if(hklt(i).eq.0) go to 200
      n=n+1
200   continue
      indl=indh
      if(indl.lt.mt) go to 100
      nrt=n
      if(kprt.ne.0) write(6,2020) nrt
      if(nrt.eq.0) go to 903
      return
901   write(6,3010) neq*nra,MT
      call ccperr (1, ' Fatal error in s/r REFFC')
902   write(6,3020)
      call ccperr (1, ' Fatal error in unpacking SFS in s/r REFFC')
903   write(6,3030)
      call ccperr (1, ' Fatal error in s/r REFFC - no reflns')
2010  format(/' there are',i10,' coefficients. maximal indices'/
     . ' hmin, hmax =',2i5,', kmin, kmax =',2i5,', lmin, lmax =',2i5/
     . ' resolution =',f10.3)
2020  format(' there are',i10,' t-f coefficients')
C3010  format('stop >> reffc << increase mc by at least',i10)
3010  format(' >> reffo from trando ',
     + '<< increase TRAING_MT by at least',I10, 
     + ' Set', I10)
3020  format('stop >> reffc << wrong packing')
3030  format('stop >> reffc << no reflection selected')
      end
C
C      call refft(mt,nra,neqP,nt,ii(1+nra),cc(ic3))
      subroutine refft(mt,nra,meq,nt,hkls,hklt)
      implicit none
      integer nra,meq,nt,klw,kup,llw,lup,indx,ir,is,neq,ks,ls,k,l,ind,
     & iu,ku,lu,klow,llow,nh,nk,nl,mt,kprt,n,indl,ni,inds,indh,i,
     & kt,lt,nrt,ibid1,nts,nxyz,hkls,hklt,hlw,hup,hlow,h,ht,
     & hs,hu,ichk,mtt
      real fuzz,sqhmax,dmint,sqhsup,sqh,a31,a32,a33,a21,a22,a11,rbid1,
     & dmaxo,dmino,rbid2,rbid3
      character cbid1*1
      dimension hkls(nra,meq),hklt(nt)
      common/ioprg/ kprt
      common/simt/ rbid1(153),ibid1(432),neq,nts
      common/star/ a11,a21,a22,a31,a32,a33
      common/reso/ dmaxo,dmino,rbid2,dmint,rbid3(2)
      common/dfftt/ hlw,hup,klw,kup,llw,lup,nrt,nxyz
      common/pako/ hlow,klow,llow,nh,nk,nl
      if(kprt.ne.0) write(6,'(a,4i12)') ' in refft mt,nra,meq,nt',
     +    mt,nra,meq,nt
      mtt = mt
      fuzz=1.0001
      sqhmax=(fuzz/dmint)**2
      hlw=0
      hup=0
      klw=0
      kup=0
      llw=0
      lup=0
      indx=0
      sqhsup=0.
      do 30 ir=1,nra
      do 20 is=1,neq
      call unpac3(hs,ks,ls,hkls(ir,is))
      h=hs
      k=ks
      l=ls
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
c pacote
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
         endif
      call pac3(h,k,l,ind)
      if(ind.gt.indx) indx=ind
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
      do 10 iu=1,neq
      call unpac3(hu,ku,lu,hkls(ir,iu))
      h=hs-hu
      k=ks-ku
      l=ls-lu
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 10
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
         endif
      call pac3(h,k,l,ind)
      if(ind.gt.indx) indx=ind
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
10    continue
20    continue
30    continue
      hlow=hlw
      klow=klw
      llow=llw
      nh=hup-hlw+1
      nk=kup-klw+1
      nl=lup-llw+1
      dmint=1/sqrt(sqhsup)
      call unpac3(h,k,l,indx)
      call pakg(h,k,l,mt)
      if(kprt.ne.0) write(6,2010) mt,hlw,hup,klw,kup,llw,lup,dmint
CX      if(mt.gt.nt) go to 40
CX      nt=mt
40    n=0
      indl=0
50    ni=n+1
      inds=indl-n
      indh=inds+nt
      if(indh.gt.mt) indh=mt
c      write(6,3010) neq*nra,MT,nt-n
      if(nt-n.lt.neq*nra) then
       end if
      do 60 i=ni,nt
      hklt(i)=0
60    continue
      do 90 ir=1,nra
      do 80 is=1,neq
      call unpac3(hs,ks,ls,hkls(ir,is))
      h=hs
      k=ks
      l=ls
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
         endif
      call pakg(h,k,l,ind)
      call unpakg(ht,kt,lt,ind)
      if(ind.gt.mt.or.ind.le.0.or.ht.ne.h.or.kt.ne.k.or.lt.ne.l)
     . go to 902
      if(ind.gt.indl.and.ind.le.indh) hklt(ind-inds)=1
      do 70 iu=1,neq
      call unpac3(hu,ku,lu,hkls(ir,iu))
      h=hs-hu
      k=ks-ku
      l=ls-lu
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 70
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
         endif
      call pakg(h,k,l,ind)
      call unpakg(ht,kt,lt,ind)
      if(ind.gt.mt.or.ind.le.0.or.ht.ne.h.or.kt.ne.k.or.lt.ne.l)
     . go to 902
      if(ind.gt.indl.and.ind.le.indh) hklt(ind-inds)=1
70    continue
80    continue
90    continue
      do 100 i=ni,nt
      if(hklt(i).eq.0) go to 100
      n=n+1
       if(n.gt.mtt) go to 901
100   continue
      indl=indh
      if(indl.lt.mt) go to 50
      nrt=n
      if(kprt.ne.0) write(6,2020) nrt
      if(nrt.eq.0) go to 903
      return
901   write(6,3010) neq*nra,MTT
      call ccperr (1, ' Fatal error in s/r REFFT')
902   write(6,3020)
      call ccperr (1, ' Fatal error in unpacking SFS in s/r REFFT')
903   write(6,3030)
      call ccperr (1, ' Fatal error in s/r REFFT - no reflns')
2010  format(/' there are',i10,' coefficients. maximal indices'/
     . ' hmin, hmax =',2i5,', kmin, kmax =',2i5,', lmin, lmax =',2i5/
     . ' resolution =',f10.3)
2020  format(' there are',i10,' t-f coefficients')
C3010  format('stop >> reffc << increase mc by at least',i10)
3010  format(' >> refft trando << increase TRAING_MT by at least',
     +  I10,
     + ' Set', I10)
3020  format('stop >> refft << wrong packing')
3030  format('stop >> refft << no reflection selected')
      end
C
      subroutine trafc(mt,nra,neq,mtr,nt,hkl,hkls,hklt,ff,fs,ft)
      implicit none
      integer nra,neq,mtr,nt,klw,kup,llw,lup,nult,n,indl,ni,inds,indh,
     & mt,i,ir,k,l,mult,is1,ks1,ls1,ind,is2,ks2,ls2,jh1,jk1,jl1,is3,ks3,
     & ls3,jh2,jk2,jl2,is4,ks4,ls4,nrt,kprt,kmax,lmax,lx,ly,lz,
     & ilec,nx,ny,nz,nxyz,ibid1,ntot,ibid2,hkl(nra),hkls(nra,neq),
     & hklt(mtr),hmax,hlw,hup,h,hs1,hs2,hs3,hs4
      real fuzz,sqhmax,dmint,sqhsup,sfmsq,sqh,a31,a32,a33,a21,a22,a11,
     & rbid1,rbid2,sfli,sfsq,sfqu,rfli,rfsq,corf,cori,corp,scale,bfact,
     & rbid3,AD,BD,CD,BID4
      complex ff(nra),fs(nra,neq),ft(nt),mfx,mfxa,mfxb,mfxab,mfxa2,
     & mfxa2b,cu1,cs2,cu3,csx,csx1,csx2,csx3,csx4
      character cbid1*1
      COMMON /CELD/AD,BD,CD,BID4(16)
      COMMON /IOPRG/KPRT
      common/star/ a11,a21,a22,a31,a32,a33
      common/reso/ rbid1(3),dmint,rbid2(2)
      common/grid/ hmax,kmax,lmax,nx,ny,nz
      common/dfftt/ hlw,hup,klw,kup,llw,lup,nrt,nxyz
      common/pote/ sfli,sfsq,sfqu,rfli,rfsq,corf,cori,corp,scale,bfact
      common/ches/ rbid3(9),ibid1(9),lx,ly,lz
      common/numo/ ntot,ibid2(6)
      fuzz=1.0001
      sqhmax=(fuzz/dmint)**2
      hlw=0
      hup=0
      klw=0
      kup=0
      llw=0
      lup=0
      nult=2
      sqhsup=0.
      n=0
      indl=0
10    ni=n+1
      inds=indl-n
      indh=inds+nt
      if(indh.gt.mt) indh=mt
      do 20 i=ni,nt
      ft(i)=(0.,0.)
20    continue
      sfmsq=0.
      do 100 ir=1,nra
      call unpac4(h,k,l,mult,hkl(ir))
      mfxa=ff(ir)
      mfxb=conjg(mfxa)
      mfx=2.*mult*mfxa
      mfxab=2.*mfx*mfxb
      mfxa2=mult*mfxa*mfxa
      mfxa2b=2.*mfxa2*mfxb
      sfmsq=sfmsq+mfxa2*mfxb*mfxb
      do 90 is1=1,neq
      call unpac3(hs1,ks1,ls1,hkls(ir,is1))
      h=hs1
      k=ks1
      l=ls1
      cu1=conjg(fs(ir,is1))
      csx1=mfxa2*cu1
      csx2=mfxab*cu1
      csx=mfxa2b*cu1
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
      csx=conjg(csx)
         endif
      if(h.eq.0.and.k.eq.0.and.l.eq.0) csx=2.*csx
      call pakg(h,k,l,ind)
      if(ind.gt.indl.and.ind.le.indh) ft(ind-inds)=ft(ind-inds)+csx
      do 80 is2=1,neq
      call unpac3(hs2,ks2,ls2,hkls(ir,is2))
      jh1=hs1-hs2
      jk1=ks1-ks2
      jl1=ls1-ls2
      h=jh1
      k=jk1
      l=jl1
      cs2=fs(ir,is2)
      if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) goto 30
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 30
      csx=csx2*cs2
      call pakg(h,k,l,ind)
      if(ind.gt.indl.and.ind.le.indh) ft(ind-inds)=ft(ind-inds)+csx
30    h=hs1+hs2
      k=ks1+ks2
      l=ls1+ls2
      csx3=mfx*cu1*cs2
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 40
      csx=csx1*conjg(cs2)
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
      csx=conjg(csx)
         endif
      if(h.eq.0.and.k.eq.0.and.l.eq.0) csx=2.*csx
      call pakg(h,k,l,ind)
      if(ind.gt.indl.and.ind.le.indh) ft(ind-inds)=ft(ind-inds)+csx
40    do 70 is3=1,neq
      call unpac3(hs3,ks3,ls3,hkls(ir,is3))
      jh2=jh1+hs3
      jk2=jk1+ks3
      jl2=jl1+ls3
      h=jh2
      k=jk2
      l=jl2
      cu3=conjg(fs(ir,is3))
      csx4=mult*cu1*cs2*cu3
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 50
      csx=csx3*cu3
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
      csx=conjg(csx)
         endif
      if(h.eq.0.and.k.eq.0.and.l.eq.0) csx=2.*csx
      call pakg(h,k,l,ind)
      if(ind.gt.indl.and.ind.le.indh) ft(ind-inds)=ft(ind-inds)+csx
50    do 60 is4=1,neq
      call unpac3(hs4,ks4,ls4,hkls(ir,is4))
      h=jh2-hs4
      k=jk2-ks4
      l=jl2-ls4
      if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) goto 60
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 60
      csx=csx4*fs(ir,is4)
      call pakg(h,k,l,ind)
      if(ind.gt.indl.and.ind.le.indh) ft(ind-inds)=ft(ind-inds)+csx
60    continue
70    continue
80    continue
90    continue
100   continue
      do 110 i=ni,nt
      if(ft(i).eq.(0.,0.)) go to 110
      n=n+1
      call unpakg(h,k,l,i+inds)
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
      call pac4(h,k,l,nult,hklt(n))
      ft(n)=ft(i)
         if(h.eq.0.and.k.eq.0.and.l.eq.0) then
      call pac4(h,k,l,1,hklt(n))
      ft(n)=ft(n)+sfmsq
         endif
110   continue
      indl=indh
      if(indl.lt.mt) go to 10
      if(n.eq.0) go to 901
      nrt=n
      dmint=1/sqrt(sqhsup)
      if(kprt.ne.0) write(6,2010) nrt,hlw,hup,klw,kup,llw,lup,dmint
      call indexm(dmint,AD,BD,CD,hmax,kmax,lmax)
      lx=hup-hlw
      ly=kup-klw
      lz=lup-llw
      if(lx.eq.0) hmax=0
      if(ly.eq.0) kmax=0
      if(lz.eq.0) lmax=0
      return
901   write(6,3010)
      call ccperr (1, ' Fatal error in s/r TRAFC')
2010  format(/' there are',i10,' coefficients. maximal indices'/
     . ' hmin, hmax =',2i5,', kmin, kmax =',2i5,', lmin, lmax =',2i5/
     . ' resolution =',f10.3)
3010  format('stop >> trafc << no reflection selected')
      end
      subroutine trafp1(mt,nra,neq,mtr,nt,hkl,hkls,hklt,fob,ff,fs,ft)
      implicit none
      integer nra,neq,mtr,nt,klw,kup,llw,lup,nult,n,indl,ni,inds,indh,
     & mt,i,ir,k,l,mult,nts,is,ks,ls,iu,ku,lu,ind,nrt,kprt,kmax,
     & lmax,lx,ly,lz,ilec,ibid1,nx,ny,nz,nxyz,ibid2,iactual,ntot,
     & ibid3,hkl(nra),hkls(nra,neq),hklt(mtr),hmax,hlw,hup,h,hs,hu,isol
      real fuzz,pct,sqhmax,dmint,sqhsup,sftsq,fo,scale,scdh,scd,rps,sqh,
     & a31,a32,a33,a21,a22,a11,rpu,rbid1,rbid2,rbid3,sfli,sfsq,sfqu,
     & rfli,rfsq,corf,cori,corp,bfact,rbid4,al,be,ga,tx,ty,tz,fob(nra),
     & mcs,mcu,AD,BD,CD,BID4
      complex ff(nra),fs(nra,neq),ft(nt),cs,cu,csu
      character cbid1*1
      COMMON /CELD/AD,BD,CD,BID4(16)
      COMMON /IOPRG/KPRT
      common/star/ a11,a21,a22,a31,a32,a33
      common/simt/ rbid1(153),ibid1(433),nts
      common/reso/ rbid2(3),dmint,rbid3(2)
      common/grid/ hmax,kmax,lmax,nx,ny,nz
      common/dfftt/ hlw,hup,klw,kup,llw,lup,nrt,nxyz
      common/pote/ sfli,sfsq,sfqu,rfli,rfsq,corf,cori,corp,scale,bfact
      common/ches/ rbid4(9),ibid2(9),lx,ly,lz
      common/outra/ al,be,ga,tx,ty,tz,scd,iactual,isol
      common/numo/ ntot,ibid3(6)
      pct=0.0001
      fuzz=1.0001
      sqhmax=(fuzz/dmint)**2
      hlw=0
      hup=0
      klw=0
      kup=0
      llw=0
      lup=0
      nult=2
      sqhsup=0.
      sftsq=0.
      n=0
      indl=0
10    ni=n+1
      inds=indl-n
      indh=inds+nt
      if(indh.gt.mt) indh=mt
      do 20 i=ni,nt
      ft(i)=(0.,0.)
20    continue
      do 50 ir=1,nra
      call unpac4(h,k,l,mult,hkl(ir))
      fo=mult*fob(ir)*scale
      scdh=-2*mult*scd/(1+nts)
      do 40 is=1,neq
      call unpac3(hs,ks,ls,hkls(ir,is))
      cs=conjg(fs(ir,is))
      mcs=cabs(cs)
      rps=0.
      if(mcs.gt.pct*fo) rps=fo/mcs+scdh
      do 30 iu=is+1,neq
      call unpac3(hu,ku,lu,hkls(ir,iu))
      h=hs-hu
      k=ks-ku
      l=ls-lu
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 30
      cu=fs(ir,iu)
      mcu=cabs(cu)
      rpu=0.
      if(mcu.gt.pct*fo) rpu=fo/mcu
      csu=cs*cu*(rps+rpu)
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
      csu=conjg(csu)
         endif
      call pakg(h,k,l,ind)
      if(ind.gt.indl.and.ind.le.indh) ft(ind-inds)=ft(ind-inds)+csu
30    continue
40    continue
50    continue
      do 60 i=ni,nt
      if(ft(i).eq.(0.,0.)) go to 60
      n=n+1
      call unpakg(h,k,l,i+inds)
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
      call pac4(h,k,l,nult,hklt(n))
      ft(n)=ft(i)
         if(h.eq.0.and.k.eq.0.and.l.eq.0) then
      call pac4(h,k,l,1,hklt(n))
      ft(n)=(0.,0.)
         endif
      sftsq=sftsq+cabs(ft(n))**2
60    continue
      indl=indh
      if(indl.lt.mt) go to 10
      nrt=n
      dmint=1/sqrt(sqhsup)
      if(kprt.ne.0) write(6,2010) nrt,hlw,hup,klw,kup,llw,lup,dmint
      if(nrt.eq.0) go to 901
      call indexm(dmint,AD,BD,CD,hmax,kmax,lmax)
      lx=hup-hlw
      ly=kup-klw
      lz=lup-llw
      if(lx.eq.0) hmax=0
      if(ly.eq.0) kmax=0
      if(lz.eq.0) lmax=0
      sftsq=sqrt(2.*sftsq)
      do 70 i=1,nrt
      ft(i)=ft(i)/sftsq
70    continue
      return
901   write(6,3010)
      call ccperr (1, ' Fatal error in s/r TRAFP1')
2010  format(/' there are',i10,' coefficients. maximal indices'/
     . ' hmin, hmax =',2i5,', kmin, kmax =',2i5,', lmin, lmax =',2i5/
     . ' resolution =',f10.3)
3010  format('stop >> trafp1 << no reflection selected')
      end
      subroutine trafp2(mt,nra,neq,mtr,nt,hkl,hkls,hklt,fob,ff,fs,ft)
      implicit none
      integer nra,neq,mtr,nt,ir,k,l,mult,klw,kup,llw,lup,nult,n,indl,ni,
     & inds,indh,mt,i,is,ind,nrt,kprt,kmax,lmax,lx,ly,lz,ilec,
     & nx,ny,nz,nxyz,ibid1,iactual,hkl(nra),hkls(nra,neq),hklt(mtr),
     & hmax,hlw,hup,h,isol
      real pct,d0,c0,fm,scale,sqhsup,sftsq,fo,rps,scd,sqh,a31,a32,a33,
     & a21,a22,a11,dmint,rbid1,rbid2,sfli,sfsq,sfqu,rfli,rfsq,corf,cori,
     & corp,bfact,rbid3,al,be,ga,tx,ty,tz,fob(nra),mfm,AD,BD,CD,BID4
      complex ff(nra),fs(nra,neq),ft(nt),fc,cs,fcs
      character cbid1*1
      COMMON /CELD/AD,BD,CD,BID4(16)
      COMMON /IOPRG/KPRT
      common/star/ a11,a21,a22,a31,a32,a33
      common/reso/ rbid1(3),dmint,rbid2(2)
      common/grid/ hmax,kmax,lmax,nx,ny,nz
      common/dfftt/ hlw,hup,klw,kup,llw,lup,nrt,nxyz
      common/pote/ sfli,sfsq,sfqu,rfli,rfsq,corf,cori,corp,scale,bfact
      common/ches/ rbid3(9),ibid1(9),lx,ly,lz
      common/outra/ al,be,ga,tx,ty,tz,scd,iactual,isol
      pct=0.0001
      d0=0.
      c0=0.
      do 10 ir=1,nra
      call unpac4(h,k,l,mult,hkl(ir))
      fm=cabs(ff(ir))
      mfm=mult*fm
      d0=d0+mfm*fob(ir)
      c0=c0+mfm*fm
10    continue
      scale=c0/d0
      hlw=0
      hup=0
      klw=0
      kup=0
      llw=0
      lup=0
      nult=2
      sqhsup=0.
      sftsq=0.
      n=0
      indl=0
20    ni=n+1
      inds=indl-n
      indh=inds+nt
      if(indh.gt.mt) indh=mt
      do 30 i=ni,nt
      ft(i)=(0.,0.)
30    continue
      do 50 ir=1,nra
      call unpac4(h,k,l,mult,hkl(ir))
      fo=fob(ir)*scale
      fc=ff(ir)
      mfm=cabs(fc)
      rps=0.
      if(mfm.gt.pct*fo) rps=mult*(fo/mfm-scd)
      fc=rps*fc
      do 40 is=1,neq
      call unpac3(h,k,l,hkls(ir,is))
      cs=conjg(fs(ir,is))
      fcs=fc*cs
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
      fcs=conjg(fcs)
         endif
      call pakg(h,k,l,ind)
      if(ind.gt.indl.and.ind.le.indh) ft(ind-inds)=ft(ind-inds)+fcs
40    continue
50    continue
      do 60 i=ni,nt
      if(ft(i).eq.(0.,0.)) go to 60
      n=n+1
      call unpakg(h,k,l,i+inds)
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
      call pac4(h,k,l,nult,hklt(n))
      ft(n)=ft(i)
         if(h.eq.0.and.k.eq.0.and.l.eq.0) then
      call pac4(h,k,l,1,hklt(n))
      ft(n)=(0.,0.)
         endif
      sftsq=sftsq+cabs(ft(n))**2
60    continue
      indl=indh
      if(indl.lt.mt) go to 20
      nrt=n
      dmint=1/sqrt(sqhsup)
      if(kprt.ne.0) write(6,2010) nrt,hlw,hup,klw,kup,llw,lup,dmint
      if(nrt.eq.0) go to 901
      call indexm(dmint,AD,BD,CD,hmax,kmax,lmax)
      lx=hup-hlw
      ly=kup-klw
      lz=lup-llw
      if(lx.eq.0) hmax=0
      if(ly.eq.0) kmax=0
      if(lz.eq.0) lmax=0
      sftsq=sqrt(2.*sftsq)
      do 70 i=1,nrt
      ft(i)=ft(i)/sftsq
70    continue
      return
901   write(6,3010)
      call ccperr (1, ' Fatal error in s/r TRAFP2')
2010  format(/' there are',i10,' coefficients. maximal indices'/
     . ' hmin, hmax =',2i5,', kmin, kmax =',2i5,', lmin, lmax =',2i5/
     . ' resolution =',f10.3)
3010  format('stop >> trafp2 << no reflection selected')
      end
      subroutine trafp3(mt,nra,neq,mtr,nt,hkl,hkls,hklt,fob,phob,ff,fs,
     & ft)
      implicit none
      integer nra,neq,mtr,nt,klw,kup,llw,lup,nult,n,indl,ni,inds,indh,
     & mt,i,ir,k,l,mult,is,ind,nrt,kprt,kmax,lmax,lx,ly,lz,
     & ilec,nx,ny,nz,nxyz,ibid1,iactual,hkl(nra),hkls(nra,neq),
     & hklt(mtr),hmax,hlw,hup,h,isol
      real scale,sqhsup,sftsq,sqh,a31,a32,a33,a21,a22,a11,dmint,rbid1,
     & rbid2,sfli,sfsq,sfqu,rfli,rfsq,corf,cori,corp,bfact,rbid3,al,be,
     & ga,tx,ty,tz,scd,fob(nra),phob(nra),AD,BD,CD,BID4
      complex ff(nra),fs(nra,neq),ft(nt),unoi,fc,cs,fcs
      character cbid1*1
      COMMON /CELD/AD,BD,CD,BID4(16)
      COMMON /IOPRG/KPRT
      common/star/ a11,a21,a22,a31,a32,a33
      common/reso/ rbid1(3),dmint,rbid2(2)
      common/grid/ hmax,kmax,lmax,nx,ny,nz
      common/dfftt/ hlw,hup,klw,kup,llw,lup,nrt,nxyz
      common/pote/ sfli,sfsq,sfqu,rfli,rfsq,corf,cori,corp,scale,bfact
      common/ches/ rbid3(9),ibid1(9),lx,ly,lz
      common/outra/ al,be,ga,tx,ty,tz,scd,iactual,isol
      unoi=(0.,1.)
      scale=1.
      hlw=0
      hup=0
      klw=0
      kup=0
      llw=0
      lup=0
      nult=2
      sqhsup=0.
      sftsq=0.
      n=0
      indl=0
10    ni=n+1
      inds=indl-n
      indh=inds+nt
      if(indh.gt.mt) indh=mt
      do 20 i=ni,nt
      ft(i)=(0.,0.)
20    continue
      do 40 ir=1,nra
      call unpac4(h,k,l,mult,hkl(ir))
      fc=mult*fob(ir)*cexp(unoi*phob(ir))
      do 30 is=1,neq
      call unpac3(h,k,l,hkls(ir,is))
      cs=conjg(fs(ir,is))
      fcs=fc*cs
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
      fcs=conjg(fcs)
         endif
      call pakg(h,k,l,ind)
      if(ind.gt.indl.and.ind.le.indh) ft(ind-inds)=ft(ind-inds)+fcs
30    continue
40    continue
      do 50 i=ni,nt
      if(ft(i).eq.(0.,0.)) go to 50
      n=n+1
      call unpakg(h,k,l,i+inds)
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
      call pac4(h,k,l,nult,hklt(n))
      ft(n)=ft(i)
         if(h.eq.0.and.k.eq.0.and.l.eq.0) then
      call pac4(h,k,l,1,hklt(n))
      ft(n)=(0.,0.)
         endif
      sftsq=sftsq+cabs(ft(n))**2
50    continue
      indl=indh
      if(indl.lt.mt) go to 10
      nrt=n
      dmint=1/sqrt(sqhsup)
      if(kprt.ne.0) write(6,2010) nrt,hlw,hup,klw,kup,llw,lup,dmint
      if(nrt.eq.0) go to 901
      call indexm(dmint,AD,BD,CD,hmax,kmax,lmax)
      lx=hup-hlw
      ly=kup-klw
      lz=lup-llw
      if(lx.eq.0) hmax=0
      if(ly.eq.0) kmax=0
      if(lz.eq.0) lmax=0
      sftsq=sqrt(2.*sftsq)
      do 60 i=1,nrt
      ft(i)=ft(i)/sftsq
60    continue
      return
901   write(6,3010)
      call ccperr (1, ' Fatal error in s/r TRAFP3')
2010  format(/' there are',i10,' coefficients. maximal indices'/
     . ' hmin, hmax =',2i5,', kmin, kmax =',2i5,', lmin, lmax =',2i5/
     . ' resolution =',f10.3)
3010  format('stop >> trafp3 << no reflection selected')
      end
      subroutine traft(mt,nra,neq,mtr,nt,hkl,hkls,hklt,fob,ff,fs,ft,nv)
      implicit none
      integer nra,neq,mtr,nt,ntot,klw,kup,llw,lup,nult,n,indl,ni,inds,
     & indh,mt,i,ir,k,l,mult,nv,is,ks,ls,ind,iu,ku,lu,nrt,kprt,
     & kmax,lmax,lx,ly,lz,ilec,nx,ny,nz,nxyz,ibid1,ibid2,hkl,hkls,
     & hklt,hmax,hlw,hup,h,hs,hu
      real fuzz,sqhmax,dmint,avsfsq,sfsq,rmsfsq,sfqu,rsntot,sqhsup,
     & sftsq,smfsq,fo,sqh,a31,a32,a33,a21,a22,a11,rbid1,rbid2,sfli,rfli,
     & rfsq,corf,cori,corp,scale,bfact,rbid3,fob,mfo2,AD,BD,CD,BID4
      complex ff,fs,ft,mfx,cs,csx,cu,csu
      character cbid1*1
      dimension hkl(nra),hkls(nra,neq),hklt(mtr),fob(nra),ff(nra),
     & fs(nra,neq),ft(nt)
      COMMON /CELD/AD,BD,CD,BID4(16)
      COMMON /IOPRG/KPRT
      common/star/ a11,a21,a22,a31,a32,a33
      common/reso/ rbid1(3),dmint,rbid2(2)
      common/grid/ hmax,kmax,lmax,nx,ny,nz
      common/dfftt/ hlw,hup,klw,kup,llw,lup,nrt,nxyz
      common/pote/ sfli,sfsq,sfqu,rfli,rfsq,corf,cori,corp,scale,bfact
      common/ches/ rbid3(9),ibid1(9),lx,ly,lz
      common/numo/ ntot,ibid2(6)
      fuzz=1.0001
      sqhmax=(fuzz/dmint)**2
      avsfsq=sfsq/ntot
      rmsfsq=sqrt(sfqu-sfsq*avsfsq)
      rsntot=sqrt(real(ntot))
      hlw=0
      hup=0
      klw=0
      kup=0
      llw=0
      lup=0
      nult=2
      sqhsup=0.
      sftsq=0.
      n=0
      indl=0
10    ni=n+1
      inds=indl-n
      indh=inds+nt
      if(indh.gt.mt) indh=mt
      do 20 i=ni,nt
      ft(i)=(0.,0.)
20    continue
      smfsq=0.
      do 50 ir=1,nra
      call unpac4(h,k,l,mult,hkl(ir))
      fo=fob(ir)
      if(nv.eq.0) mfo2=mult*(fo*fo-avsfsq)/rmsfsq
      if(nv.eq.1) mfo2=mult*(fo*fo-avsfsq)/rmsfsq
      if(nv.eq.2) mfo2=mult/rsntot
      mfx=mfo2*ff(ir)
      smfsq=smfsq+mfx*conjg(ff(ir))
      do 40 is=1,neq
      call unpac3(hs,ks,ls,hkls(ir,is))
      cs=conjg(fs(ir,is))
      h=hs
      k=ks
      l=ls
      csx=mfx*cs
         if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) then
      h=-h
      k=-k
      l=-l
      csx=conjg(csx)
         endif
      if(h.eq.0.and.k.eq.0.and.l.eq.0) csx=2.*csx
      call pakg(h,k,l,ind)
      if(ind.gt.indl.and.ind.le.indh) ft(ind-inds)=ft(ind-inds)+csx
      cs=mfo2*cs
      do 30 iu=1,neq
      call unpac3(hu,ku,lu,hkls(ir,iu))
      h=hs-hu
      k=ks-ku
      l=ls-lu
      if(h.lt.0.or.(h.eq.0.and.(l.gt.0.or.(l.eq.0.and.k.gt.0)))) goto 30
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(sqh.gt.sqhmax) go to 30
      cu=fs(ir,iu)
      csu=cs*cu
      call pakg(h,k,l,ind)
      if(ind.gt.indl.and.ind.le.indh) ft(ind-inds)=ft(ind-inds)+csu
30    continue
40    continue
50    continue
      do 60 i=ni,nt
      if(ft(i).eq.(0.,0.)) go to 60
      n=n+1
      call unpakg(h,k,l,i+inds)
      sqh=(a31*h+a32*k+a33*l)**2+(a21*h+a22*k)**2+(a11*h)**2
      if(h.lt.hlw) hlw=h
      if(h.gt.hup) hup=h
      if(k.lt.klw) klw=k
      if(k.gt.kup) kup=k
      if(l.lt.llw) llw=l
      if(l.gt.lup) lup=l
      if(sqh.gt.sqhsup) sqhsup=sqh
      call pac4(h,k,l,nult,hklt(n))
      ft(n)=ft(i)
         if(h.eq.0.and.k.eq.0.and.l.eq.0) then
      call pac4(h,k,l,1,hklt(n))
      ft(n)=ft(n)+smfsq
         else
      sftsq=sftsq+cabs(ft(n))**2
         endif
60    continue
      indl=indh
      if(indl.lt.mt) go to 10
      if(n.eq.0) go to 901
      nrt=n
         if(nv.eq.0) then
      sftsq=sqrt(2.*sftsq)
      do 70 i=1,nrt
      call unpac4(h,k,l,mult,hklt(i))
      if(mult.eq.1) ft(i)=(0.,0.)
      ft(i)=ft(i)/sftsq
70    continue
         endif
      dmint=1/sqrt(sqhsup)
      if(kprt.ne.0) write(6,2010) nrt,hlw,hup,klw,kup,llw,lup,dmint
      call indexm(dmint,AD,BD,CD,hmax,kmax,lmax)
      lx=hup-hlw
      ly=kup-klw
      lz=lup-llw
      if(lx.eq.0) hmax=0
      if(ly.eq.0) kmax=0
      if(lz.eq.0) lmax=0
      return
901   write(6,3010)
      call ccperr (1, ' Fatal error in s/r TRAFT')
2010  format(/' there are',i10,' coefficients. maximal indices'/
     . ' hmin, hmax =',2i5,', kmin, kmax =',2i5,', lmin, lmax =',2i5/
     . ' resolution =',f10.3)
3010  format('stop >> traft << no reflection selected')
      end
      subroutine tshift(rec,option)
      implicit none
      integer neqpt,neqp,ntst,nts,i,ibid2,ibid4,ilec,kprt,
     & ibid1,nrt,ibid3,ibid2x(6),ibid2c(6),ibid4x(6),ibid4c(6),
     &  hlw,hup,klw,kup,llw,lup,nxyz
      real a,b,c,alpha,beta,gamma,ad,as,rbid1,vol,rbid2,cel(6),adx(6),
     & asx(6)
      character rec*1,option*1,cbid1*1
      common/ioprg/ kprt
      common/cell/ a,b,c,alpha,beta,gamma
      common/celd/ ad(6),rbid1(12),vol
C      COMMON /CELD/AD,BD,CD,CA,CB,CG,BID1(13)
      common/star/ as(6)
c      common/star/ A11,A21,A22,A31,A32,A33
      common/simt/ rbid2(153),ibid1(432),neqp,nts
C      COMMON /SIMT/TSS(3,48),TTS(3,3),MSS(3,3,48),NEQP,NTS
c      common/dfftt/  hlw,hup,klw,kup,llw,lup,nrt,nxyz
       common/dfftt/ ibid2(6),nrt,ibid3
       common/pako/ ibid4(6)
C      COMMON /PAKO/HLOW,KLOW,LLOW,NH,NK,NL
      save cel,NEQPt,ntst,adx,asx,ibid2x,ibid4x,ibid2c,ibid4c
C
C   Resets cell info, plus hlw,hup,klw,kup,llw,lup
C  Cell is reset in CHESH , hlw, etc in various fft preps.
         if(rec.eq.'w') then
      cel(1)=a
      cel(2)=b
      cel(3)=c
      cel(4)=alpha
      cel(5)=beta
      cel(6)=gamma
      NEQPT=NEQP
      ntst=nts
       do i=1,6
      adx(i)=ad(i)
      asx(i)=as(i)
       enddo
            if(option.eq.'g') then
C     First call
C   go to 10 === return
      go to 10
            else if(option.eq.'t') then
c  after refft call
       do i=1,6
      ibid2x(i)=ibid2(i)
      ibid4x(i)=ibid4(i)
C     ibid2x(i) = hlw...
C     ibid4x(i) = HLOW...
       enddo
            else if(option.eq.'c') then
c  after reffc call; c-c trans
       do i=1,6
      ibid2c(i)=ibid2(i)
      ibid4c(i)=ibid4(i)
C     ibid2c(i) = hlw...
C     ibid4c(i) = HLOW...
       enddo
            else
      go to 901
            endif
C  rec = "restore"
         else if(rec.eq.'r') then
      a=cel(1)
      b=cel(2)
      c=cel(3)
      alpha=cel(4)
      beta=cel(5)
      gamma=cel(6)
      NEQP=NEQPt
      nts=ntst
       do i=1,6
      ad(i)=adx(i)
      as(i)=asx(i)
       enddo
            if(option.eq.'g') then
C after pikndo; restores cell
      go to 10
            else if(option.eq.'t') then
C   Trans is c-c, after hfftx, before first,second, traft,dimms
C   Trans is h-l before anything
       do i=1,6
      ibid2(i)=ibid2x(i)
      ibid4(i)=ibid4x(i)
       enddo
            else if(option.eq.'c') then
C   Trans is c-c, before trafc, chesh,hfftx
       do i=1,6
      ibid2(i)=ibid2c(i)
      ibid4(i)=ibid4c(i)
       enddo
            else
      go to 901
            endif
         else
      go to 901
         endif
10    return
901   write(6,3010) rec,option
      call ccperr (1, ' Fatal error in s/r TSHIFT')
3010  format('stop >> tshift << wrong options>',2(1x,a1))
      end

