C
C     DYNDOM 
C     Copyright (C) 1998 Steve Hayward
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C VERSION 1.5
C
      PROGRAM DynDom 
C
C-------------------------------------------------------------
C
C SEE http://www.sys.uea.ac.uk/~sjh/DynDom/dyndom.home.html
C
C------------------------------------------------------------
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C 
      INTEGER NCLUSTER,ITER,DOMIN,WINDLEN
      INTEGER NATOT1,NATOT2,IAT,I,J
      INTEGER NRES,NBB,NRES1,NRES2,NBB1,NBB2
      INTEGER NI(NRESMX),CA(NRESMX),CB(NRESMX),CP(NRESMX)
      INTEGER IER,DOMA,DOMB,DOMSIZE(NDOMX)
      INTEGER NWIND,IDOM
      INTEGER IB,IWIND,NBBWIND
      INTEGER IRES,IAT1,IAT2,IAT3,IAT4
      INTEGER MM,NDIM
      INTEGER DMSUM1,DMSUM2,IWORK(NRESMX)
      INTEGER DOMORD(NDOMX),NDOMO,NDOM
      INTEGER NCON(NDOMX),DOMCON(NDOMX,NDOMX)
      INTEGER NSEG(NDOMX),ND(NDOMX),NND,ISEG
      INTEGER IRESBEG(NDOMX,NSEGMX),IRESEND(NDOMX,NSEGMX)
      INTEGER NAAT1(NRESMX),NAAT2(NRESMX)
      INTEGER ATLIST1(NRESMX,NAATMX),ATLIST2(NRESMX,NAATMX)
      INTEGER IN1,IN2,IOUT1,IOUT3,IOUT4,IOUT6,IOUT7
      INTEGER IEND1,IEND2  
      REAL*8 EXTCRIT,AMPTHETAV,SCALE
      REAL*8 COO1(3,NUMATMX),COO2(3,NUMATMX)
      REAL*8 COOBB1(3,NBBMX),COOBB2(3,NBBMX)
      REAL*8 COOBB1F(3,NBBMX),COOBB2F(3,NBBMX)
      REAL*8 MASS(NUMATMX),R(3,3),AC1(3),RC1(3),RMSD
      REAL*8 COBB1(3,NBBMX),COBB2(3,NBBMX)
      REAL*8 VEXT(12),VEXTMSF,VINTMSF,VMSF
      REAL*8 WORK(NARB),SUM(7,NRESMX,NDOMX)
      REAL*8 UNTHX,UNTHY,UNTHZ,AMPTHET(NRESMX),AMP,AMPTR,XAX,YAX,ZAX
      REAL*8 ROT(NRESMX,3),TRACER
      REAL*8 EXTINT(NDOMX,NDOMX)
      CHARACTER*4 ATYP1(NUMATMX),ATYP2(NUMATMX)
      CHARACTER*4 RESTYP1(NUMATMX),RESTYP2(NUMATMX)
      CHARACTER*5 RESNUM1(NUMATMX),RESNUM2(NUMATMX)
      CHARACTER*1 CHAINID1,CHAINID2
      CHARACTER*5 RESPDBNUM1(NRESMX),RESPDBNUM2(NRESMX)
      CHARACTER*4 RESPDBTYP1(NRESMX),RESPDBTYP2(NRESMX)
      CHARACTER*200 FILEIN1,FILEIN2 
C
      DATA MASS/NUMATMX*1.0/
C 
C READ INPUT AND INITIALIZE OUTPUT
C
      CALL INOUTPUTR(IN1,IN2,IOUT1,IOUT3,IOUT4,IOUT6,
     &   IOUT7,CHAINID1,CHAINID2,NCLUSTER,ITER,DOMIN,WINDLEN,
     &   EXTCRIT,FILEIN1,IEND1,FILEIN2,IEND2)
C
C READ IN PDB FILE OF FIRST CONFORMATION
C
      CALL READPDB(IN1,NATOT1,CHAINID1,ATYP1,RESTYP1,
     &   RESNUM1,COO1)
C
C READ IN PDB FILE OF SECOND CONFORMATION
C
      CALL READPDB(IN2,NATOT2,CHAINID2,ATYP2,RESTYP2,
     &   RESNUM2,COO2)
C
C IDENTIFY RESIDUES OF FIRST CONFORMATION
C
      CALL RESIDEN(NATOT1,RESTYP1,RESNUM1,NRES1,
     &   RESPDBNUM1,RESPDBTYP1,NAAT1,ATLIST1)
C
C IDENTIFY RESIDUES OF SECOND CONFORMATION
C
      CALL RESIDEN(NATOT2,RESTYP2,RESNUM2,NRES2,
     &   RESPDBNUM2,RESPDBTYP2,NAAT2,ATLIST2)
C
      IF(NRES1.EQ.0) THEN
        WRITE(6,'(A)')'NO RESIDUES FOUND IN 1ST CHAIN: CHECK FILE NAME A
     &ND CHAIN IDENTIFIER'
        WRITE(6,'(A)')
        STOP
      ENDIF
C
      IF(NRES2.EQ.0) THEN
        WRITE(6,'(A)')'NO RESIDUES FOUND IN 2ND CHAIN: CHECK FILE NAME A
     &ND CHAIN IDENTIFIER'
        WRITE(6,'(A)')
        STOP
      ENDIF
C
      IF(NRES1.NE.NRES2) THEN
        WRITE(6,'(A,I4,I4)')'WARNING NUMBER OF RESIDUES IN CHAINS IS DIF
     &FERENT',NRES1,NRES2
        WRITE(6,'(A)')
      ENDIF
C
      WRITE(6,'(A)')'determining backbone atoms of first conformer'
      WRITE(6,'(A)')
C
      CALL BACKBONE(ATYP1,COO1,NRES1,NAAT1,ATLIST1,
     & RESPDBNUM1,RESPDBTYP1,NBB1,COOBB1,NI,CA,CB,CP)
C
      WRITE(6,'(A)')'determining backbone atoms of second conformer'
      WRITE(6,'(A)')
C
      CALL BACKBONE(ATYP2,COO2,NRES2,NAAT2,ATLIST2,
     & RESPDBNUM2,RESPDBTYP2,NBB2,COOBB2,NI,CA,CB,CP)
C
C KEEP OLD BACKBONE COORDINATES
C
      DO 201 IB=1,NBB1
        COOBB1F(1,IB)=COOBB1(1,IB)
        COOBB1F(2,IB)=COOBB1(2,IB)
        COOBB1F(3,IB)=COOBB1(3,IB)
201   CONTINUE
C
      DO 202 IB=1,NBB2
        COOBB2F(1,IB)=COOBB2(1,IB)
        COOBB2F(2,IB)=COOBB2(2,IB)
        COOBB2F(3,IB)=COOBB2(3,IB)
202   CONTINUE
C
      IF(NBB1.LE.NBB2) THEN
        NRES=NRES1
        NBB=NBB1
      ELSE
        NRES=NRES2
        NBB=NBB2
      END IF
C
      WRITE(6,'(A,I4)')'number of residues used for analysis: ',NRES
      WRITE(6,'(A)')
C
      IF(WINDLEN.GT.NRES) THEN
        WRITE(6,'(A)')'YOUR WINDOW LENGTH IS MUCH TOO LONG'
        WRITE(6,'(A)')'THE WHOLE PROTEIN IS A DOMAIN!'
        STOP
      ENDIF
C
      IF(DOMIN.GT.NRES) THEN
        WRITE(6,'(A)')'YOUR MINIMUM DOMAIN SIZE IS MUCH TOO LONG'
        WRITE(6,'(A)')'THE WHOLE PROTEIN IS A DOMAIN!'
        STOP
      ENDIF
C
C START OFF WITH THE WHOLE PROTEIN AS A DOMAIN
C
      NDOM=1
      IDOM=1
      NSEG(1)=1
      IRESBEG(1,1)=1
      IRESEND(1,1)=NRES
C
C BEST FIT BACKBONE ATOMS FROM TWO CONFORMATIONS
C
      CALL ROTVECFIELD(NBB,NRES,IDOM,NSEG,IRESBEG,IRESEND,NI,CA,CP,CB,
     & WINDLEN,COOBB1,COOBB2,ROT,AMPTHET,AMPTHETAV,MASS,RMSD)
C
      WRITE (6,'(A,F8.3,A)') 'rmsd of whole protein best fit: ',RMSD,'A'
C
      NWIND=NRES-WINDLEN+1 
C
      DMSUM1=7
      DMSUM2=3
      MM=NRESMX
      NDIM=3
C
C DETERMINE CLUSTERS OF ROTATION VECTORS AND CORRESPONDING 
C DOMAINS THAT SATISFY CRITERIA TO BE ANALYZED FOR THE INTERDOMAIN
C MOTION
C
      CALL CLUSTER2(MM,NWIND,NDIM,ROT,NCLUSTER,
     & ITER,DMSUM1,DMSUM2,SUM,IWORK,WORK,NDOM,
     & DOMIN,NRES,WINDLEN,NAAT1,NAAT2,ATLIST1,ATLIST2,
     & COO1,COO2,IRESBEG,IRESEND,NSEG,
     & NI,CA,CP,CB,COOBB1,COOBB2,MASS,NDOMO,NCON,
     & DOMCON,DOMORD,EXTCRIT,EXTINT)
C
       IF(NDOMO.EQ.0) THEN
         WRITE(6,'(A)')'NO DYNAMIC DOMAINS FOUND'
         WRITE(6,'(A)')'IT COULD BE YOUR PROTEIN DOESNT HAVE A DOMAIN'
         WRITE(6,'(A)')'MOTION. BUT,TRY ALTERING VALUES OF PARAMETERS wi
     &ndow AND domain'
         WRITE(6,'(A)')
         GOTO 999
       ENDIF
C
C OUTPUT BOTH CONFORMERS SUPERIMPOSED ON THEIR FIXED DOMAIN IF
C THERE IS ONLY ONE FIXED DOMAIN OTHERWISE JUST OUTPUT 1ST CONFORMER
C
      IF(NDOMO.EQ.1) THEN
        DOMA=DOMORD(1) 
C
        CALL FITCONFORMERS(NBB,DOMA,NSEG,IRESBEG,IRESEND,NATOT1,NATOT2,
     &   ATYP1,ATYP2,RESTYP1,RESTYP2,FILEIN1,IEND1,FILEIN2,IEND2,
     &   CHAINID1,CHAINID2,RESNUM1,RESNUM2,NI,CA,CP,CB,COOBB1F,COOBB2F,
     &   COO1,COO2,MASS,NRES1,NAAT1,NRES,ATLIST1,WINDLEN,IOUT6)
C
      ELSEIF(NDOMO.GT.1) THEN
C
        WRITE(IOUT6,'(A10,A,A1,A1)')'Chain is: ',FILEIN1(1:IEND1),
     &'_',CHAINID1 
C
        DO 72 IAT=1,NATOT1
          WRITE(IOUT6,3000)'ATOM',IAT,ATYP1(IAT),RESTYP1(IAT),CHAINID1,
     &     RESNUM1(IAT),COO1(1,IAT),COO1(2,IAT),COO1(3,IAT)
72      CONTINUE
        WRITE(IOUT6,'(A)')'TER'
C
      ENDIF
C
C FOLLOWING COUNTS THE NUMBER OF DOMAINS AND DETERMINES THEIR SIZE
C
      DO 100 I=1,NDOMX
        ND(I)=0
100   CONTINUE
C
      DO 80 I=1,NDOMO
        DOMA=DOMORD(I)
        DOMSIZE(DOMA)=0
        DO 89 ISEG=1,NSEG(DOMA)
          DOMSIZE(DOMA)=DOMSIZE(DOMA)+IRESEND(DOMA,ISEG)-
     &IRESBEG(DOMA,ISEG)+1
89      CONTINUE
        DO 70 J=1,NCON(DOMA)
          DOMB=DOMCON(DOMA,J)
          DOMSIZE(DOMB)=0
          DO 79 ISEG=1,NSEG(DOMB)
            DOMSIZE(DOMB)=DOMSIZE(DOMB)+IRESEND(DOMB,ISEG)-
     &IRESBEG(DOMB,ISEG)+1
79        CONTINUE
          IF(EXTINT(DOMA,DOMB).GE.EXTCRIT) THEN
            ND(DOMA)=ND(DOMA)+1
            ND(DOMB)=ND(DOMB)+1
          ENDIF
70      CONTINUE
80    CONTINUE
C
      NND=0
      DO 90 I=1,NDOM
        IF(ND(I).GE.1) THEN
          NND=NND+1
        ENDIF
90    CONTINUE
C
      WRITE(IOUT1,'(A10,I3,A8)')'THERE ARE ',NND,' DOMAINS' 
C
C DETERMINE INTERDOMAIN SCREW AXES
C
      CALL HINGEAXES2(NDOM,WINDLEN,NRES,NBB,RESPDBNUM1,RESPDBTYP1,
     & NI,CA,CP,CB,NSEG,IRESBEG,IRESEND,COOBB1F,COOBB2F,
     & MASS,NDOMO,NCON,DOMCON,DOMORD,EXTINT,EXTCRIT,NRES1,CHAINID1,
     & DOMSIZE,IOUT1,IOUT3,IOUT6,IOUT7)
C
      IF(NDOMO.EQ.1) THEN
        WRITE(IOUT3,'(A7,A4,A1,A4,A1)')'select ',RESPDBNUM2(1),'-',
     &  RESPDBNUM2(NRES2),CHAINID2
        WRITE(IOUT3,'(A)')'backbone 50'
        WRITE(IOUT3,'(A)')'colour white'
        WRITE(IOUT3,'(A)')'select all'
      ENDIF
C
      WRITE(IOUT3,'(A)')'echo IF DISPLAYING "rotvecs" FILE USE SPACEFILL
     &'
C
999   CONTINUE
C
C OUTPUT OF ROTATION VECTORS
C
      SCALE=20.0/AMPTHETAV
      DO 51 IWIND=1,NWIND
        WRITE(IOUT4,2000)'ATOM','CA  ',RESPDBTYP1(IWIND+(WINDLEN/2)),
     &  CHAINID1,RESPDBNUM1(IWIND+(WINDLEN/2)),ROT(IWIND,1)*SCALE,
     &  ROT(IWIND,2)*SCALE,ROT(IWIND,3)*SCALE
51    CONTINUE
C
2000  FORMAT(A4,9X,A4,A4,A1,A5,3X,3F8.3)
3000  FORMAT(A4,2X,I5,2X,A4,A4,A1,A5,3X,3F8.3)
C
      CLOSE (IN1)
      CLOSE (IN2)
      CLOSE (IOUT1)
      CLOSE (IOUT3)
      CLOSE (IOUT4)
      CLOSE (IOUT6)
      CLOSE (IOUT7)
C 
      STOP
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward 2002
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C SUBROUTINE TO MAKE ROTATION VECTOR FOR DISPLAY ON RASMOL
C
       SUBROUTINE ARROW(NBB,COOBB1,UNTHX,UNTHY,UNTHZ,
     &         XL,YL,ZL,RESPDBNUM,NRES,IPAIR,
     &         CHAINID,IOUT6,IOUT3,COLORA,COLORB)
C
       IMPLICIT NONE
C
       include 'DynDom.param'
C
       REAL*8 MASS(2),RMSD
       REAL*8 UNTHX,UNTHY,UNTHZ                       
       REAL*8 XL,YL,ZL                       
       REAL*8 X(100),Y(100),Z(100)
       REAL*8 COOBB1(3,*)
       REAL*8 COA(3,2)
       REAL*8 CO(3,2)
       REAL*8 COOA(3,6)
       REAL*8 TMAX,TMIN,ARRWIDTH,FITLGH,SHARP,T,T1,ARC
       INTEGER NBB,NARR,NFIT,N,I,M,L
       INTEGER NRES,IPAIR,LASTRES
       INTEGER IOUT6,IOUT3
       CHARACTER*5 RESPDBNUM(*)
       CHARACTER*19 COLORA,COLORB
       CHARACTER*1 CHAINID
C
 	SAVE LASTRES
C
        MASS(1)=1.0
        MASS(2)=1.0
C
        ARRWIDTH=1.0
        SHARP=3.0
        FITLGH=3.0
        NFIT=2
        NARR=6
C                                                                       
C CALL ROUTINE TO DETERMINE LENGTH OF AXIS
C
        CALL AXLENG(NBB,COOBB1,UNTHX,UNTHY,UNTHZ,XL,YL,ZL,TMAX,TMIN)
C
        T=FITLGH
        T1=TMIN
        N=(TMAX-TMIN)/FITLGH
101     CONTINUE
        IF(N.LT.2) THEN
          TMIN=TMIN-(TMAX-TMIN)/10.0
          TMAX=TMAX+(TMAX-TMIN)/10.0
          N=(TMAX-TMIN)/FITLGH
          GOTO 101
        ENDIF
C
        DO 10 I=1,N
          X(I)=UNTHX*T1+XL
          Y(I)=UNTHY*T1+YL
          Z(I)=UNTHZ*T1+ZL
          T1=T1+T
10      CONTINUE
C
        CO(1,1)=X(N)
        CO(2,1)=Y(N)
        CO(3,1)=Z(N)
        CO(1,2)=X(N-1)
        CO(2,2)=Y(N-1)
        CO(3,2)=Z(N-1)
C
        COA(1,1)=0.01
        COA(2,1)=0.01 
        COA(3,1)=0.01
        COA(1,2)=0.0
        COA(2,2)=FITLGH 
        COA(3,2)=0.0
C
        COOA(1,1)=0.01
        COOA(2,1)=0.01 
        COOA(3,1)=0.01
        COOA(1,2)=0.0
        COOA(2,2)=FITLGH 
        COOA(3,2)=0.0
C
        ARC=2*PI/4 
        M=0
        DO 112 I=3,6
          M=M+1
          COOA(1,I)=ARRWIDTH*COS(ARC*M)
          COOA(2,I)=SHARP
          COOA(3,I)=ARRWIDTH*SIN(ARC*M)
112     CONTINUE
C
        CALL FITPART(NFIT,NARR,CO,COA,COOA,MASS,RMSD)
C
C WRITE OUT "ARROW MOLECULE" TO BE APPENDED TO PDB FILE OF CHAIN 1
C
        IF(IPAIR.EQ.1) THEN
          READ(RESPDBNUM(NRES)(1:),*)LASTRES
        ENDIF
C
        L=LASTRES
        WRITE(IOUT6,'(A)')'TER arrow molecule that represents hinge axis
     & for movement from conformer 1 to 2'
        DO 11 I=1,N
          L=L+1
          WRITE(IOUT6,2000)'ATOM','CA  ','GLY ',CHAINID,L,
     &                   X(I),Y(I),Z(I)
11      CONTINUE
C
        WRITE(IOUT6,3000)'TER ARROW SHAFT '
C
        DO 12 I=3,NARR
          L=L+1
          WRITE(IOUT6,2000)'ATOM','CA  ','GLY ',CHAINID,L,
     &                   COOA(1,I),COOA(2,I),COOA(3,I)
          L=L+1
          WRITE(IOUT6,2000)'ATOM','CA  ','GLY ',CHAINID,L,
     &                   X(N),Y(N),Z(N)
          L=L+1
          WRITE(IOUT6,2000)'ATOM','CA  ','GLY ',CHAINID,L,
     &                   COOA(1,I),COOA(2,I),COOA(3,I)
12      CONTINUE
        L=L+1
        WRITE(IOUT6,2000)'ATOM','CA  ','GLY ',CHAINID,L,
     &                 COOA(1,3),COOA(2,3),COOA(3,3)
C
        WRITE(IOUT6,3000)'TER ARROW HEAD '
C
C WRITE OUT SCRIPT FOR RASMOL DISPLAY
C
        WRITE(IOUT3,'(A)')'# select and colour arrow'
        WRITE(IOUT3,5000)'select ',LASTRES+1,'-',LASTRES+N-1,CHAINID
        WRITE(IOUT3,6000)COLORA
        WRITE(IOUT3,5000)'select ',LASTRES+N,'-',L,CHAINID
        WRITE(IOUT3,6000)COLORB
C
        LASTRES=L
C
2000    FORMAT(A4,9X,A4,A4,A1,I4,4X,3F8.3) 
3000    FORMAT(A15) 
5000    FORMAT(A7,I4,A1,I4,A1) 
6000    FORMAT(A19)
C
        RETURN
        END
C
C-------------------------------------------------------------
C
C                       
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C ROUTINE TO FIND GOOD LENGTH OF AXIS FOR DISPLAY
C
       SUBROUTINE AXLENG(N,COO,UNTHX,UNTHY,UNTHZ,XL,YL,ZL,TMAX,TMIN)
C
       IMPLICIT NONE
C
       include 'DynDom.param'
C
       REAL*8 UNTHX,UNTHY,UNTHZ                       
       REAL*8 XL,YL,ZL                       
       REAL*8 COO(3,*),VEC(3,NUMATMX)
       REAL*8 TMAX,TMIN,T(NUMATMX)
       INTEGER N,I
C                                                                       
       DO 1 I=1,N
         VEC(1,I)=COO(1,I)-XL
         VEC(2,I)=COO(2,I)-YL
         VEC(3,I)=COO(3,I)-ZL
1      CONTINUE
C
       TMAX=-1.0E08
       TMIN=1.0E08
       DO 2 I=1,N
         T(I)=UNTHX*VEC(1,I)+UNTHY*VEC(2,I)+UNTHZ*VEC(3,I)
       IF(T(I).GT.TMAX) THEN
         TMAX=T(I)
       ENDIF
       IF(T(I).LT.TMIN) THEN
         TMIN=T(I)
       ENDIF
2      CONTINUE
C
       TMIN=TMIN-(TMAX-TMIN)/10.0
       TMAX=TMAX+(TMAX-TMIN)/10.0
C
       RETURN
       END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C SUBROUTINE TO FIND RESIDUES THAT LINE PASSES NEAR
C
       SUBROUTINE AXRES(NRES,RESPDBNUM,RESPDBTYP,UTX,UTY,UTZ,
     &  XL,YL,Zl,CA,COOBB1,MSEG,SEGB,SEGE,IOUT1)
C
       IMPLICIT NONE
C
       include 'DynDom.param'
C
       REAL*8 COOBB1(3,*)                     
       REAL*8 UTX,UTY,UTZ,XL,YL,ZL,XP,YP,ZP,DIST
       INTEGER NRES,IRES,ICAT,CA(*),ISEG,IIRES 
       INTEGER MSEG,SEGB(*),SEGE(*),IOUT1
       CHARACTER*5 RESPDBNUM(*)
       CHARACTER*4 RESPDBTYP(*)
       LOGICAL EFFHING
C
       EFFHING=.FALSE.
C
       WRITE(IOUT1,'(A)')
C
       DO 1 IRES=1,NRES
           ICAT=CA(IRES)
           XP=COOBB1(1,ICAT)
           YP=COOBB1(2,ICAT)
           ZP=COOBB1(3,ICAT)
           CALL DISTLINP(UTX,UTY,UTZ,XL,YL,ZL,XP,YP,ZP,DIST)
           IF(DIST.LE.EFFCUT) THEN
             DO 2 ISEG=1,MSEG
               IF(SEGB(ISEG).EQ.0.AND.SEGE(ISEG).EQ.0) GOTO 2
               DO 3 IIRES=SEGB(ISEG),SEGE(ISEG)
                 IF(IIRES.EQ.IRES) THEN
                   EFFHING=.TRUE.
                   WRITE(IOUT1,'(A4,1X,A5,A,F6.1,A)')RESPDBTYP(IRES),
     &RESPDBNUM(IRES),' ACTS AS A MECHANICAL HINGE, ITS C-ALPHA IS ',
     &DIST,' A FROM AXIS'
                 ENDIF
3              CONTINUE
2            CONTINUE
           ENDIF
1      CONTINUE
C
       IF(EFFHING) THEN
         WRITE(IOUT1,'(A)')
         WRITE(IOUT1,'(A)')'AXIS IS AN -- EFFECTIVE HINGE AXIS-- '
         WRITE(IOUT1,'(A)')
       ELSE
         WRITE(IOUT1,'(A)')'NO MECHANICAL HINGES FOUND' 
         WRITE(IOUT1,'(A)')
         WRITE(IOUT1,'(A)')'AXIS IS NOT AN EFFECTIVE HINGE AXIS'
         WRITE(IOUT1,'(A)')
       ENDIF
C
       RETURN
       END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C SUBROUTINE TO DETERMINE BACKBONE ATOMS
C
      SUBROUTINE BACKBONE(ATYP,COO,NRES,NAAT,ATLIST,
     & RESPDBNUM,RESPDBTYP,NBB,COOBB,NI,CA,CB,CP)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER IRES,IAT,IAA,IBB,IBBN,NRES,NBB,IBEF
      INTEGER NI(*),CA(*),CB(*),CP(*),NAAT(*),ATLIST(NRESMX,*)
      CHARACTER*2 ATYP2
      CHARACTER*4 ATYP(*)
      CHARACTER*5 RESPDBNUM(*)
      CHARACTER*4 RESPDBTYP(*)
      REAL*8 COO(3,*),COOBB(3,*)
      LOGICAL NON,NOCA,NOC,NOCB
C
      IBB=0
      IBEF=0
      DO 1 IRES=1,NRES
        NON=.TRUE.
        NOCA=.TRUE.
        NOC=.TRUE.
        NOCB=.TRUE.
        DO 2 IAA=1,NAAT(IRES)
          IAT=ATLIST(IRES,IAA)
          READ(ATYP(IAT)(1:),'(A)')ATYP2
          IF(ATYP2.EQ.'N '.AND.NON) THEN
            NON=.FALSE.
            IBB=IBEF+1
            NI(IRES)=IBB
            COOBB(1,IBB)=COO(1,IAT)
            COOBB(2,IBB)=COO(2,IAT)
            COOBB(3,IBB)=COO(3,IAT)
          ELSEIF (ATYP2.EQ.'CA'.AND.NOCA) THEN
            NOCA=.FALSE.
            IBB=IBEF+2
	    CA(IRES)=IBB
            COOBB(1,IBB)=COO(1,IAT)
            COOBB(2,IBB)=COO(2,IAT)
            COOBB(3,IBB)=COO(3,IAT)
          ELSEIF (ATYP2.EQ.'C '.AND.NOC) THEN
            NOC=.FALSE.
            IBB=IBEF+3
            CP(IRES)=IBB
            COOBB(1,IBB)=COO(1,IAT)
            COOBB(2,IBB)=COO(2,IAT)
            COOBB(3,IBB)=COO(3,IAT)
          ELSEIF (ATYP2.EQ.'CB'.AND.NOCB) THEN
            NOCB=.FALSE.
            IBB=IBEF+4
            CB(IRES)=IBB
            COOBB(1,IBB)=COO(1,IAT)
            COOBB(2,IBB)=COO(2,IAT)
            COOBB(3,IBB)=COO(3,IAT)
          ENDIF
2       CONTINUE
C
        IF(NON) THEN
          WRITE(6,'(A,A5)')'BACKBONE NITROGEN MISSING; RESIDUE:',
     &     RESPDBNUM(IRES)
          STOP
        ENDIF
C
        IF(NOCA) THEN
          WRITE(6,'(A,A5)')'BACKBONE ALPHA CARBON MISSING; RESIDUE:',
     &     RESPDBNUM(IRES)
          STOP
        ENDIF
C
        IF(NOC) THEN
          WRITE(6,'(A,A5)')'BACKBONE CARBONYL CARBON MISSING; RESIDUE:',
     &     RESPDBNUM(IRES)
          STOP
        ENDIF
C
C MODEL MISSING C-BETA ATOM, ALSO FOR GLYCINE
C
        IF(NOCB) THEN
          IBBN=IBEF+1
          CALL MODCBETA(COOBB(1,IBBN))
          IBB=IBEF+4
          CB(IRES)=IBB
        ENDIF
C
        IBEF=IBEF+4
C
1     CONTINUE
      NBB=IBB
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C     FOR MASS WEIGHTED BEST FIT
C
      SUBROUTINE BSTFT (N,CO1,CB2,RMSD,XC1,XC2,R,IER,MASS)
C 
      IMPLICIT NONE
C
      REAL*8 DA(3,3), DU(3,3), DV(3,3), DD(3), DWK(3)
      REAL*8 R(3,*)
      REAL*8 CO1(3,*), CB2(3,*)
      REAL*8 XC1(*), XC2(*), C(3)
      REAL*8 MASS(*),MASSTOT,RMSD,DELTA
      REAL*8 B13,B23,B33,S     
      REAL*8 A13,A23,A33   
      REAL*8 TEMP(3)
      INTEGER I,J,K,N,NA,II,I1,J1,IER,LIST(3)
      LOGICAL MATU,MATV
C
      MATU=.TRUE.
      MATV=.TRUE.
C 
      DO 10 K=1,3
        XC1(K)=0.
        XC2(K)=0.
10    CONTINUE
      DO 30 NA=1,N
        DO 20 K=1,3
          XC1(K)=XC1(K)+CO1(K,NA)*MASS(NA)
          XC2(K)=XC2(K)+CB2(K,NA)*MASS(NA)
20      CONTINUE
30    CONTINUE
C
      MASSTOT=0.D0
C 
      DO 40 II=1,N
        MASSTOT=MASSTOT+MASS(II)
40    CONTINUE
C
      DO 50 K=1,3
        XC1(K)=XC1(K)/MASSTOT
        XC2(K)=XC2(K)/MASSTOT
50    CONTINUE
C 
      DO 70 NA=1,N
        DO 60 K=1,3
          CO1(K,NA)=CO1(K,NA)-XC1(K)
          CB2(K,NA)=CB2(K,NA)-XC2(K)
60      CONTINUE
70    CONTINUE
C
      DO 80 I=1,3
        DO 80 J=1,3
        DA(I,J)=0.0
80    CONTINUE
C 
      DO 100 NA=1,N
C 
        DO 90 I=1,3
          DO 90 J=1,3
          DA(I,J)=DA(I,J)+CO1(I,NA)*CB2(J,NA)*MASS(NA)
90      CONTINUE
100   CONTINUE
C
      CALL SVD(3,3,3,DA,DD,MATU,DU,MATV,DV,IER,DWK)
C
      LIST(1)=1
      LIST(2)=2
      LIST(3)=3
      TEMP(1)=DD(1)
      TEMP(2)=DD(2)
      TEMP(3)=DD(3)
      CALL SORTR(3,TEMP,LIST)
C
      A13=DV(2,LIST(1))*DV(3,LIST(2))-DV(3,LIST(1))*DV(2,LIST(2))
      A23=DV(3,LIST(1))*DV(1,LIST(2))-DV(1,LIST(1))*DV(3,LIST(2))
      A33=DV(1,LIST(1))*DV(2,LIST(2))-DV(2,LIST(1))*DV(1,LIST(2))
      S=A13*DV(1,LIST(3))+A23*DV(2,LIST(3))+A33*DV(3,LIST(3))
      DV(1,LIST(3))=A13
      DV(2,LIST(3))=A23
      DV(3,LIST(3))=A33
C----
      B13=DU(2,LIST(1))*DU(3,LIST(2))-DU(3,LIST(1))*DU(2,LIST(2))
      B23=DU(3,LIST(1))*DU(1,LIST(2))-DU(1,LIST(1))*DU(3,LIST(2))
      B33=DU(1,LIST(1))*DU(2,LIST(2))-DU(2,LIST(1))*DU(1,LIST(2))
      S=B13*DU(1,LIST(3))+B23*DU(2,LIST(3))+B33*DU(3,LIST(3))
      DU(1,LIST(3))=B13
      DU(2,LIST(3))=B23
      DU(3,LIST(3))=B33
C
      DO 120 I=1,3
        DO 120 J=1,3
        R(I,J)=DU(I,LIST(1))*DV(J,LIST(1))+DU(I,LIST(2))*DV(J,LIST(2))
     &   +DU(I,LIST(3))*DV(J,LIST(3))
120   CONTINUE
C
      RMSD=0
      DO 170 NA=1,N
        DO 140 I1=1,3
          C(I1)=0.0
          DO 130 J1=1,3
            C(I1)=C(I1)+R(I1,J1)*CB2(J1,NA)
130       CONTINUE
140     CONTINUE
C
        DO 150 I1=1,3
          CB2(I1,NA)=C(I1)
150     CONTINUE
C
        DO 160 I1=1,3
          DELTA=C(I1)-CO1(I1,NA)
          RMSD=RMSD+DELTA*DELTA
160     CONTINUE
170   CONTINUE
C
      RMSD=SQRT(RMSD/N)
C
      RETURN
      END
C                                                                       
C THIS FINDS THE DISTANCE BETWEEN THE CLOSURE AXIS AND THE LINE
C JOINING THE CENTRES OF MASS OF THE TWO DOMAINS.  IT ALSO FINDS 
C THE ANGLE BETWEEN THESE TWO LINES AND THE COMPONENTS OF THE ROTATION
C ABOUT THE INTERDOMAIN ROTATION AXIS THAT ARE THE TWIST AND CLOSURE MOTION
C
       SUBROUTINE CLOSURE(DOMA,DOMB,NSEG,IRESBEG,IRESEND,CA,
     &  COOBB1,UNTHX,UNTHY,UNTHZ,XL,YL,ZL,IOUT1)
C
       IMPLICIT NONE
C
       include 'DynDom.param'
C
       INTEGER DOMA,DOMB,CA(*),IA,IB,ISEG,IRES
       INTEGER IRESBEG(NDOMX,*),IRESEND(NDOMX,*),NSEG(*)
       INTEGER IOUT1
       REAL*8 COOBB1(3,*)
       REAL*8 UNTHX,UNTHY,UNTHZ,AXAN,AXDIST,CLOSEPER
       REAL*8 CLOSX,CLOSY,CLOSZ 
       REAL*8 XD,YD,ZD,RL,UNCMX,UNCMY,UNCMZ,GTW                       
       REAL*8 XL,YL,ZL,XCMA,YCMA,ZCMA,XCMB,YCMB,ZCMB
C                                                                       
C CALCULATE APPROXIMATE LOCATIONS OF CENTRES OF MASS OF THE TWO DOMAINS 
C JUST USING C-ALPHA ATOMS
C
        XCMA=0.0
        YCMA=0.0
        ZCMA=0.0
        IA=0
        DO 20 ISEG=1,NSEG(DOMA)
          DO 10 IRES=IRESBEG(DOMA,ISEG),IRESEND(DOMA,ISEG)
            IA=IA+1
            XCMA=XCMA+COOBB1(1,CA(IRES))
            YCMA=YCMA+COOBB1(2,CA(IRES))
            ZCMA=ZCMA+COOBB1(3,CA(IRES))
10        CONTINUE
20      CONTINUE
C
        XCMA=XCMA/IA
        YCMA=YCMA/IA
        ZCMA=ZCMA/IA
C
        XCMB=0.0
        YCMB=0.0
        ZCMB=0.0
        IB=0
        DO 21 ISEG=1,NSEG(DOMB)
          DO 11 IRES=IRESBEG(DOMB,ISEG),IRESEND(DOMB,ISEG)
            IB=IB+1
            XCMB=XCMB+COOBB1(1,CA(IRES))
            YCMB=YCMB+COOBB1(2,CA(IRES))
            ZCMB=ZCMB+COOBB1(3,CA(IRES))
11        CONTINUE
21      CONTINUE
C
        XCMB=XCMB/IB
        YCMB=YCMB/IB
        ZCMB=ZCMB/IB
C 
C DETERMINE UNIT VECTOR OF LINE JOINING CENTRES OF MASS OF TWO DOMAINS
C
        XD=XCMB-XCMA
        YD=YCMB-YCMA
        ZD=ZCMB-ZCMA
        RL=SQRT(XD**2+YD**2+ZD**2)
        UNCMX=XD/RL
        UNCMY=YD/RL
        UNCMZ=ZD/RL
C 
C DETERMINE ANGLE BETWEEN AXIS AND LINE JOINING CENTRES OF MASS
C
        GTW=UNTHX*UNCMX+UNTHY*UNCMY+UNTHZ*UNCMZ
        AXAN=ACOS(GTW)  
        AXAN=AXAN*180.0/PI
        IF (AXAN.GT.90.0) AXAN=180.0-AXAN
C
C DETERMINE COMPONENT OF INTERDOMAIN ROTATION ALONG LINE JOINING 
C CENTRES OF MASS, I.E. THE TWIST; AND LINE PERPENDICULAR, I.E
C CLOSURE MOTION
C
        CLOSX=UNTHX-GTW*UNCMX
        CLOSY=UNTHY-GTW*UNCMY
        CLOSZ=UNTHZ-GTW*UNCMZ
        CLOSEPER=CLOSX**2+CLOSY**2+CLOSZ**2
        CLOSEPER=CLOSEPER*100
C
C DETERMINE DISTANCE BETWEEN AXIS AND LINE JOINING CENTRES OF MASS
C
        CALL LINEDIST(UNTHX,UNTHY,UNTHZ,UNCMX,UNCMY,UNCMZ,XL,YL,ZL
     &,XCMA,YCMA,ZCMA,AXDIST)
C
       WRITE (IOUT1,'(A58,F8.3)') 'ANGLE BETWEEN SCREW AXIS AND LINE JOI
     &NING CENTRES OF MASS:',AXAN
       WRITE (IOUT1,'(A61,F8.3,A2)') 'DISTANCE BETWEEN SCREW AXIS AND LI
     &NE JOINING CENTRES OF MASS:',AXDIST,' A'
       WRITE (IOUT1,'(A26,F8.3)') 'PERCENTAGE CLOSURE MOTION:',CLOSEPER
C
        RETURN
        END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C K-MEANS CLUSTERING ROUTINE.
C
C ADAPTED FROM PROGRAM IN BOOK OF HARTIGAN, J.A. "CLUSTERING ALGORITHMS"
C NEW YORK: WILEY, 1975
C
C STOPS WHEN A CLUSTER DOESN'T POSSESS ANY DOMAINS WITH AT 
C LEAST AS MANY RESIDUES AS THE MINIMUM SPECIFIED 
C
C RETURNED IS THE MAXIMUM NUMBER OF DOMAINS (PROVIDED NCLUSTER IS SET HIGH ENOUGH)
C FOR WHICH ALL DOMAIN PAIRS SATISFY THE CRITERION FOR THE RATIO OF
C EXTERNAL TO INTERNAL MOTION OR IF NOT AT LEAST ONE DOMAIN PAIR
C                                    
C
      SUBROUTINE CLUSTER2(MM, M, N, A,  K, ITER,
     &           DMSUM1, DMSUM2, SUM, IWORK, WORK, 
     &           NDOMM,DOMIN,NRES,WINDLEN,NAAT1,NAAT2,ATLIST1,
     &           ATLIST2,COO1,COO2,IRESBEGM,
     &           IRESENDM,NSEGM,NI,CA,CP,CB,COOBB1,COOBB2,
     &           MASS,NDOMOM,NCONM,DOMCONM,
     &           DOMORDM,EXTCRIT,EXTINTM)
C
      IMPLICIT NONE
      include 'DynDom.param'
C
      INTEGER N,M,MM,I,J,JJ,K,KK,KKK,KM,KN,ITER,NC,id,is
      INTEGER DMSUM1, DMSUM2, DCLUS , CLUSIZE(NDOMX)
      INTEGER NSEG(NDOMX),IRESBEG(NDOMX,NSEGMX)
      INTEGER IRESEND(NDOMX,NSEGMX)
      INTEGER DOMIN,NRES,WINDLEN
      INTEGER NONSEG(NDOMX),NONRESBEG(NDOMX,NSEGMX)
      INTEGER NONDOM,NONRESEND(NDOMX,NSEGMX)
      INTEGER NDOM,NDOMM,NSEGM(*)
      INTEGER IRESBEGM(NDOMX,*),IRESENDM(NDOMX,*)
      INTEGER NI(*),CA(*),CB(*),CP(*)
      INTEGER DOMORDM(*),NDOMO
      INTEGER NCONM(*),DOMCONM(NDOMX,*)
      INTEGER DOMORD(NDOMX),NDOMOM
      INTEGER NCON(NDOMX),DOMCON(NDOMX,NDOMX)
      INTEGER NAAT1(*),NAAT2(*)
      INTEGER ATLIST1(NRESMX,*),ATLIST2(NRESMX,*)
      INTEGER IWORK(*),CLUSNO,NOTBEEN,CLUSYESBEF,CLUSYES 
      REAL*8 COOBB1(3,*),COOBB2(3,*),MASS(*),EXTCRIT
      REAL*8 EXTINT(NDOMX,NDOMX),EXTINTM(NDOMX,*)
      REAL*8 COO1(3,*),COO2(3,*)
      REAL*8 SUM(DMSUM1,DMSUM2,*),A(MM,*),WORK(*),ERR,SM
      LOGICAL STOPCLUS,OK,ALLOK,ALLOKDONE,BEEN
C
      BEEN=.FALSE.
      NOTBEEN=0
      CLUSYES=1
      CLUSYESBEF=1
C
      ALLOKDONE=.FALSE.
      DCLUS = 2*N + M
      DO 10 I=1,7
         DO 10 J=1,N
            DO 10 KK=1,K+1
   10          SUM(I,J,KK)=0.
C
C     LOOP ONCE FOR EACH DESIRED CLUSTER
C
      DO 130 KK=1,K
C
         IF(KK.GT.NDOMX) THEN  
           WRITE(6,'(A,I4,I4)')
     &       'ARRAY BOUNDARY FOR NUMBER OF DOMAINS HAS BEEN EXCEEDED: ',
     &       NDOMX,KK
           WRITE(6,'(A)')'CHANGE VALUE FOR "NDOMX" IN "DynDom.param"'
           STOP
         ENDIF
C
         WRITE(6,'(A)')
         WRITE(6,'(A,I4)')'number of clusters:',KK
C
         DO 60 NC=1,ITER
            ERR=0.
            DO 20 KKK=1,KK
               DO 20 J=1,N
                  IF(NC.EQ.1.OR.SUM(1,J,KKK).NE.SUM(3,J,KKK)) ERR=1.
   20       CONTINUE
C
C     IF NO CHANGES HAVE BEEN MADE, OUTPUT THE CLUSTER
C
            IF(ERR.EQ.0.) GO TO 70
            DO 30 KKK=1,KK
               DO 30 J=1,N
                  SUM(2,J,KKK)=0.
   30       SUM(1,J,KKK)=SUM(3,J,KKK)
            DO 50 I=1,M
               DO 40 J=1,N
   40             WORK(J)=A(I,J)
               IWORK(I)=NC
C
C     FIND BEST CLUSTER FOR CASE I
C
               CALL KMEANS(N, WORK, KK,  DMSUM1, DMSUM2, SUM,
     &                     IWORK(I), WORK(DCLUS+I))
   50       CONTINUE
   60    CONTINUE
C
   70    CONTINUE 
C
         IF(KK.EQ.1) GOTO 16
C
         CALL SEGLENG(M,KK,IWORK,NSEG,IRESBEG,IRESEND,CLUSIZE)
C
C ROTATION OF WINDOW IS ASSIGNED TO THE RESIDUE AT ITS CENTRE
C
         DO 337 I=1,KK
           DO 338 J=1,NSEG(I)
             IRESBEG(I,J)=IRESBEG(I,J)+(WINDLEN/2)
             IRESEND(I,J)=IRESEND(I,J)+(WINDLEN/2)
338        CONTINUE
337      CONTINUE
C
C CREATE NEW DOMAINS IF CLUSTERS DO NOT FORM A CONNECTED STRUCTURE
C DISREGARD DOMAINS WITH FEWER RESIDUES THAN "DOMIN"
C STOP CLUSTERING ALGORITHM IF ANY CLUSTER DOESN'T HAVE A DOMAIN
C WITH AT LEAST "DOMIN" RESIDUES
C
         CLUSYESBEF=CLUSYES 
         NDOM=KK
         CALL SEGCONNECT2(DOMIN,NDOM,NAAT1,NAAT2,
     &    ATLIST1,ATLIST2,COO1,COO2,IRESBEG,IRESEND,NSEG,NONDOM,
     &    NONRESBEG,NONRESEND,NONSEG,CLUSNO)
C
          CLUSYES=KK-CLUSNO
C         
C
C THIS IS A NEW ROUTINE TO MAKE OUTPUT A BIT CLEANER 
C IT JOINS ELIMINATED SEGMENTS THAT ARE SEPARATED BY A DISTANCE LESS THAN 
C DOMIN TO THE DOMAINS THEY ARE EMBEDDED IN
C
         CALL JOINSEG(NDOM,NSEG,IRESBEG,IRESEND,NONDOM,NONSEG,
     &    NONRESBEG,NONRESEND,DOMIN)
C
C
C THE FOLLOWING CONDITIONAL ALLOWS IT TO LOOK FOR CLUSTERS
C WITH DOMAINS LARGER THAN DOMIN EVEN IF AT THE OUTSET IT
C FINDS ONLY CLUSTERS THAT GIVE DOMAINS SMALLER THAN DOMIN
C
         IF(CLUSYES.GT.CLUSYESBEF) THEN
C
           IF(NDOM.GE.2) THEN
             BEEN=.TRUE.
           ENDIF
C
           WRITE(6,'(A,I4)')'number of domains equal to or larger than m
     &inimum domain size:',NDOM
C
C DETERMINES MOST CONNECTED DOMAIN, AND THEN SECOND MOST CONNECTED
C DOMAIN AND SO ON.
C
           CALL DOMCONNECT (NRES,NDOM,NSEG,IRESBEG,IRESEND,NDOMO,
     &  DOMORD,DOMCON,NCON)
C
C CALCULATE RATIO OF INTERDOMAIN TO INTRADOMAIN DISPLACEMENT FOR ALL
C CONNECTED DOMAIN PAIRS
C
           CALL EXTSTOP2(NRES,NDOM,NSEG,IRESBEG,IRESEND,
     &      NI,CA,CP,CB,COOBB1,COOBB2,MASS,OK,ALLOK,
     &      NDOMO,NCON,DOMCON,DOMORD,EXTCRIT,EXTINT)
C
C REMEMBER DOMAIN INFO IF ALL DOMAIN PAIRS SATISFY THE CRITERION FOR 
C THE RATIO OF INTERDOMAIN TO INTRADOMAIN DISPLACEMENT
C
           IF(ALLOK) THEN
C
             ALLOKDONE=.TRUE.
C
             NDOMM=NDOM
             DO 11 I=1,NDOMM
               NSEGM(I)=NSEG(I)
               DO 12 J=1,NSEGM(I)
                 IRESBEGM(I,J)=IRESBEG(I,J)
                 IRESENDM(I,J)=IRESEND(I,J)
12             CONTINUE
11           CONTINUE
             NDOMOM=NDOMO
             DO 13 I=1,NDOMOM
               DOMORDM(I)=DOMORD(I)
               NCONM(DOMORDM(I))=NCON(DOMORD(I))
               DO 14 J=1,NCONM(DOMORDM(I))
                 DOMCONM(DOMORDM(I),J)=DOMCON(DOMORD(I),J)
                 EXTINTM(DOMORDM(I), DOMCONM(DOMORDM(I),J))=
     &           EXTINT(DOMORD(I), DOMCON(DOMORD(I),J))
14             CONTINUE
13           CONTINUE
C
           ELSEIF(.NOT.ALLOKDONE.AND.OK) THEN
C
             NDOMM=NDOM
             DO 21 I=1,NDOMM
               NSEGM(I)=NSEG(I)
               DO 22 J=1,NSEGM(I)
                 IRESBEGM(I,J)=IRESBEG(I,J)
                 IRESENDM(I,J)=IRESEND(I,J)
22             CONTINUE
21           CONTINUE
             NDOMOM=NDOMO
             DO 23 I=1,NDOMOM
               DOMORDM(I)=DOMORD(I)
               NCONM(DOMORDM(I))=NCON(DOMORD(I))
               DO 24 J=1,NCONM(DOMORDM(I))
                 DOMCONM(DOMORDM(I),J)=DOMCON(DOMORD(I),J)
                 EXTINTM(DOMORDM(I), DOMCONM(DOMORDM(I),J))=
     &           EXTINT(DOMORD(I), DOMCON(DOMORD(I),J))
24             CONTINUE
23           CONTINUE
C
           ENDIF
C
         ELSEIF(.NOT.BEEN.AND.NOTBEEN.LE.3) THEN
           NOTBEEN=NOTBEEN+1
           WRITE(6,'(A)')'found cluster for which all domains are less t
     &han minimum domain size'
           WRITE(6,'(A)')
         ELSE
           WRITE(6,'(A)')'found cluster for which all domains are less t
     &han minimum domain size'
           WRITE(6,'(A)')'exiting clustering routine'
           WRITE(6,'(A)')
           RETURN
         ENDIF
C
C CREATE A NEW CLUSTER BY SPLITTING VARIABLE WITH LARGEST WITHIN-
C CLUSTER VARIANCE AT THAT VALUE OF THAT VARIABLE AT THE CENTER
C OF THE CLUSTER
C
16       CONTINUE
C
         SM=0.
         DO 80 J=1,N
            DO 80 KKK=1,KK
               IF(SUM(4,J,KKK).GE.SM) THEN
                  SM=SUM(4,J,KKK)
                  KM=KKK
               ENDIF
   80    CONTINUE
         KN=KK+1
         DO 90 JJ=1,N
            SUM(2,JJ,KM)=0.
            SUM(3,JJ,KM)=0.
            SUM(2,JJ,KN)=0.
   90       SUM(3,JJ,KN)=0.
         DO 110 I=1,M
            IF(IWORK(I).EQ.KM) THEN
               DO 100 JJ=1,N
                  IF(A(I,JJ).GE.SUM(1,JJ,KM)) THEN
                     SUM(2,JJ,KN)=SUM(2,JJ,KN)+1
                     SUM(3,JJ,KN)=SUM(3,JJ,KN)+A(I,JJ)
                  ELSE
                     SUM(2,JJ,KM)=SUM(2,JJ,KM)+1
                     SUM(3,JJ,KM)=SUM(3,JJ,KM)+A(I,JJ)
                  ENDIF
  100          CONTINUE
            ENDIF
  110    CONTINUE
         DO 120 JJ=1,N
            IF(SUM(2,JJ,KN).NE.0.)SUM(3,JJ,KN)=SUM(3,JJ,KN)/SUM(2,JJ,KN)
            IF(SUM(2,JJ,KM).NE.0.)SUM(3,JJ,KM)=SUM(3,JJ,KM)/SUM(2,JJ,KM)
  120    CONTINUE
  130 CONTINUE
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C SETS COLOURS
C
      SUBROUTINE COLOURS(COLOR,COLOUR)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER I
      CHARACTER*19 COLOR(NDOMX)
      CHARACTER*16 COLOUR(NDOMX)
C
      COLOR(1)='color [0  ,0  ,255]'
      COLOUR(1)='blue'
      COLOR(2)='color [255,0  ,0  ]'
      COLOUR(2)='red'
      COLOR(3)='color [255,255,0  ]'
      COLOUR(3)='yellow'
      COLOR(4)='color [238,130,238]'
      COLOUR(4)='violet'
      COLOR(5)='color [0  ,255,255]'
      COLOUR(5)='cyan'
      COLOR(6)='color [0  ,0  ,0  ]'
      COLOUR(6)='black'
      COLOR(7)='color [255,0  ,255]'
      COLOUR(7)='magenta'
      COLOR(8)='color [160,32 ,240]'
      COLOUR(8)='purple'
      COLOR(9)='color [79 ,148,205]'
      COLOUR(9)='steel blue'
      COLOR(10)='color [255,69 ,0  ]'
      COLOUR(10)='orange red'
      COLOR(11)='color [255,165,0  ]'
      COLOUR(11)='orange'
      COLOR(12)='color [50 ,205,50 ]'
      COLOUR(12)='lime green'
      COLOR(13)='color [255,192,203]'
      COLOUR(13)='pink'
      COLOR(14)='color [255,127,80 ]'
      COLOUR(14)='coral'
      COLOR(15)='color [87 , 87, 87]'
      COLOUR(15)='dark grey'
      COLOR(16)='color [139,69 ,19 ]'
      COLOUR(16)='saddle brown'
      COLOR(17)='color [238,18 ,137]'
      COLOUR(17)='deep pink'
      COLOR(18)='color [238,216,174]'
      COLOUR(18)='wheat'
      COLOR(19)='color [255,228,196]'
      COLOUR(19)='bisque'
      COLOR(20)='color [245,255,250]'
      COLOUR(20)='mint cream'
      COLOR(21)='color [230,230,250]'
      COLOUR(21)='lavender'
      COLOR(22)='color [85 ,107,47 ]'
      COLOUR(22)='dark olive green' 
      COLOR(23)='color [100,149,237]'
      COLOUR(23)='cornflower blue' 
      COLOR(24)='color [187,255,255]'
      COLOUR(24)='pale turquoise' 
      COLOR(25)='color [255,182,193]'
      COLOUR(25)='light pink' 
      COLOR(26)='color [ 72,209,204]'
      COLOUR(26)='medium turquoise' 
C
      DO 1 I=27,NDOMX
        COLOR(I)=COLOR(I-26)
        COLOUR(I)=COLOUR(I-26)
1     CONTINUE
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
      SUBROUTINE DET (A,ADET)
  
      IMPLICIT NONE
C 
      REAL*8 A(3,3),ADET
  
      ADET=A(1,1)*(A(2,2)*A(3,3)-A(3,2)*A(2,3))-A(2,1)*(A(1,2)*A(3,3)-
     &A(3,2)*A(1,3))+A(3,1)*(A(1,2)*A(2,3)-A(2,2)*A(1,3))
  
      RETURN
      END
C
C ROUTINE TO DETERMINE DIHEDRAL ANGLE CHANGES OF BENDING RESIDUES
C
      SUBROUTINE DIHEDR(IPAIR,ICONA,BEGA,ENDA,ICONB,BEGB,ENDB,
     & RESPDBNUM,RESPDBTYP,UX,UY,UZ,XL,YL,ZL,AMPROT,MASS,COOBB1,
     & COOBB2,NI,CA,CP,CB,IOUT7,NRES)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER ICONA(*),ICONB(*),ISEG,ICON,I,IOUT7
      INTEGER BEGA(NPAIRMX,*),ENDA(NPAIRMX,*)
      INTEGER BEGB(NPAIRMX,*),ENDB(NPAIRMX,*)
      INTEGER NI(*),CA(*),CP(*),CB(*),IPAIR,IRES,NRES
      INTEGER NSEG,SEGB(NPAIRMX),SEGE(NPAIRMX)
      REAL*8 COOBB1(3,*),COOBB2(3,*),UX,UY,UZ,XL,YL,ZL,AMPROT
      REAL*8 PRO,PROB,PROA
      REAL*8 ANGLE,UNX,UNY,UNZ
      REAL*8 VEXT(12),VEXTMSF,VINTMSF,VMSF,MASS(*),TRACER,RMSD
      REAL*8 PERCA,PERCB,PERC
      CHARACTER*5 RESPDBNUM(*)
      CHARACTER*4 RESPDBTYP(*)
C
      WRITE (IOUT7,'(A80)') '===========================================
     &====================================='
C
      IF(IPAIR.EQ.1.OR.IPAIR.EQ.21.OR.IPAIR.EQ.31) THEN
        WRITE(IOUT7,'(A,I3,A)')'ANALYSING DIHEDRALS IN BENDING RESIDUES 
     &FOR',IPAIR,'ST PAIR'
      ELSEIF(IPAIR.EQ.2.OR.IPAIR.EQ.22.OR.IPAIR.EQ.32) THEN
        WRITE(IOUT7,'(A,I3,A)')'ANALYSING DIHEDRALS IN BENDING RESIDUES 
     &FOR',IPAIR,'ND PAIR'
      ELSEIF(IPAIR.EQ.3.OR.IPAIR.EQ.23.OR.IPAIR.EQ.33) THEN
        WRITE(IOUT7,'(A,I3,A)')'ANALYSING DIHEDRALS IN BENDING RESIDUES 
     &FOR',IPAIR,'RD PAIR'
      ELSE
        WRITE(IOUT7,'(A,I3,A)')'ANALYSING DIHEDRALS IN BENDING RESIDUES 
     &FOR',IPAIR,'TH PAIR'
      ENDIF
      WRITE(IOUT7,'(A,F6.1,A)')'ANGULAR ROTATION OF DOMAINS:',AMPROT,
     &' DEGREES'
C
C FROM FIXED TO MOVING DOMAIN
C
      DO 4 ICON=1,ICONA(IPAIR)
C
        IF(BEGA(IPAIR,ICON).EQ.0.AND.ENDA(IPAIR,ICON).EQ.0) GOTO 4
      WRITE (IOUT7,'(A80)') '-------------------------------------------
     &--------------------------------------'
        WRITE(IOUT7,'(A,A5,A,A5,A)')'ANALYSING RESIDUES',RESPDBNUM(BEGA(
     &IPAIR,ICON)),'-',RESPDBNUM(ENDA(IPAIR,ICON)),' FIXED TO MOVING DOM
     &AIN'
C
        DO 5 IRES=BEGA(IPAIR,ICON)-1,ENDA(IPAIR,ICON)-1+1
          IF(IRES.LT.1.OR.IRES.GT.NRES) GOTO 5
C
C DETERMINE ROTATION VECTOR OF TETRAHEDRON OF CURRENT RESIDUE,IRES
C
          CALL EXTCOMP2(4,1,2,3,4,MASS,COOBB1(1,NI(IRES)),
     &     COOBB2(1,NI(IRES)),VEXT,VEXTMSF,VINTMSF,VMSF,TRACER,RMSD)
C
          CALL ROTVEC(1,2,3,4,COOBB1(1,NI(IRES)),VEXT,TRACER,
     &     ANGLE,UNX,UNY,UNZ)
C
          PROB=UX*UNX+UY*UNY+UZ*UNZ
          PROB=ANGLE*PROB
          PROB=PROB*180.0/PI
          PERCB=PROB*100.0/AMPROT
C
C DETERMINE ROTATION VECTOR OF TETRAHEDRON OF NEXT RESIDUE, IRES+1
C
          CALL EXTCOMP2(4,1,2,3,4,MASS,COOBB1(1,NI(IRES+1)),
     &     COOBB2(1,NI(IRES+1)),VEXT,VEXTMSF,VINTMSF,VMSF,TRACER,RMSD)
C
          CALL ROTVEC(1,2,3,4,COOBB1(1,NI(IRES+1)),VEXT,TRACER,
     &     ANGLE,UNX,UNY,UNZ)
C
          PROA=UX*UNX+UY*UNY+UZ*UNZ
          PROA=ANGLE*PROA
          PROA=PROA*180.0/PI
          PERCA=PROA*100.0/AMPROT
          PRO=PROA-PROB
          PERC=PERCA-PERCB
C
          WRITE(IOUT7,'(A)') 
          WRITE(IOUT7,'(A4,1X,A5,A1,A4,1X,A5)')RESPDBTYP(IRES),
     &     RESPDBNUM(IRES),'-',RESPDBTYP(IRES+1),RESPDBNUM(IRES+1)
          WRITE(IOUT7,'(A)') 
C
          WRITE(IOUT7,'(A5,A,F6.1,A)')RESPDBNUM(IRES+1),':',
     &     PERCA,' percent of total'
          WRITE(IOUT7,'(A,F6.1,A,F6.1,A)')'progress in direction of axis
     &:',PRO,' degrees,',PERC,' percentage increase'    
C
          CALL TORDIFF(IRES,NI,CA,CP,CB,MASS,COOBB1,COOBB2,
     &     UX,UY,UZ,IOUT7)
C
      WRITE (IOUT7,'(A80)') '-------------------------------------------
     &--------------------------------------'
5       CONTINUE
4     CONTINUE
C
C FROM MOVING TO FIXED DOMAIN
C 
      DO 6 ICON=1,ICONB(IPAIR)
C
        IF(BEGB(IPAIR,ICON).EQ.0.AND.ENDB(IPAIR,ICON).EQ.0) GOTO 6
      WRITE (IOUT7,'(A80)') '-------------------------------------------
     &--------------------------------------'
        WRITE(IOUT7,'(A,A5,A,A5,A)')'ANALYSING RESIDUES',
     &  RESPDBNUM(BEGB(IPAIR,ICON)),'-',RESPDBNUM(ENDB(IPAIR,ICON)),
     &  ' MOVING TO FIXED DOMAIN'
C
        DO 7 IRES=BEGB(IPAIR,ICON)-1,ENDB(IPAIR,ICON)-1+1
          IF(IRES.LT.1.OR.IRES.GT.NRES) GOTO 7
C
C DETERMINE ROTATION VECTOR OF TETRAHEDRON OF CURRENT RESIDUE,IRES
C
          CALL EXTCOMP2(4,1,2,3,4,MASS,COOBB1(1,NI(IRES)),
     &     COOBB2(1,NI(IRES)),VEXT,VEXTMSF,VINTMSF,VMSF,TRACER,RMSD)
C
          CALL ROTVEC(1,2,3,4,COOBB1(1,NI(IRES)),VEXT,TRACER,
     &     ANGLE,UNX,UNY,UNZ)
C
          PROB=UX*UNX+UY*UNY+UZ*UNZ
          PROB=AMPROT-PROB*ANGLE*180.0/PI
          PERCB=PROB*100.0/AMPROT
C
C DETERMINE ROTATION VECTOR OF TETRAHEDRON OF NEXT RESIDUE, IRES+1
C
          CALL EXTCOMP2(4,1,2,3,4,MASS,COOBB1(1,NI(IRES+1)),
     &     COOBB2(1,NI(IRES+1)),VEXT,VEXTMSF,VINTMSF,VMSF,TRACER,RMSD)
C
          CALL ROTVEC(1,2,3,4,COOBB1(1,NI(IRES+1)),VEXT,TRACER,
     &     ANGLE,UNX,UNY,UNZ)
C
          PROA=UX*UNX+UY*UNY+UZ*UNZ
          PROA=AMPROT-PROA*ANGLE*180.0/PI
          PERCA=PROA*100.0/AMPROT
          PRO=PROA-PROB
          PERC=PERCA-PERCB
C
          WRITE(IOUT7,'(A)') 
          WRITE(IOUT7,'(A4,1X,A5,A1,A4,1X,A5)')RESPDBTYP(IRES),
     &     RESPDBNUM(IRES),'-',RESPDBTYP(IRES+1),RESPDBNUM(IRES+1)
          WRITE(IOUT7,'(A)') 
C
          WRITE(IOUT7,'(A5,A,F6.1,A)')RESPDBNUM(IRES+1),':',
     &     PERCA,' percent of total'
          WRITE(IOUT7,'(A,F6.1,A,F6.1,A)')'progress in direction of axis
     &:',PRO,' degrees,',PERC,' percentage increase'
C
          CALL TORDIFF(IRES,NI,CA,CP,CB,MASS,COOBB1,COOBB2,
     &     UX,UY,UZ,IOUT7)
C
      WRITE (IOUT7,'(A80)') '-------------------------------------------
     &--------------------------------------'
7       CONTINUE
6     CONTINUE
C
      RETURN
      END
C
C ROUTINE TO CALCULATE DISTANCE BETWEEN LINE AND POINT
C
        SUBROUTINE DISTLINP(UX,UY,UZ,XL,YL,ZL,XP,YP,ZP,DIST)
C
        IMPLICIT NONE
C
        REAL*8 UX,UY,UZ,XL,YL,ZL,XP,YP,ZP
        REAL*8 DISTX,DISTY,DISTZ,DIST
        REAL*8 XR,YR,ZR
C
        XR=XP-XL
        YR=YP-YL
        ZR=ZP-ZL
        CALL VECPROD(UX,UY,UZ,XR,YR,ZR,DISTX,DISTY,DISTZ)
        DIST=SQRT(DISTX**2+DISTY**2+DISTZ**2)
C
        RETURN
        END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C

C
C DETERMINES CONNECTIVITY OF DOMAINS, STARTING WITH THE MOST 
C CONNECTED DOMAIN, AND THEN THE SECOND MOST CONNECTED DOMAIN
C AND SO ON
C
       SUBROUTINE DOMCONNECT(NRES,NDOM,NSEG,IRESBEG,IRESEND,
     &NDOMO,DOMORD,DOMCON,NCON)
C
       IMPLICIT NONE
C
       include 'DynDom.param'
C
       INTEGER NRES,NDOM,I,J,M,IMX,IDOM,JDOM,NMX,N(NDOMX)  
       INTEGER NCON(NDOMX),IDOMX,DOMCON(NDOMX,*),NDOMO
       INTEGER IRESBEG(NDOMX,*),IRESEND(NDOMX,*),NSEG(*)
       INTEGER IRES,ISEG,DOMORD(*)
       LOGICAL SEENBEG
C
       NDOMO=0
       DO 55 I=1,NDOM
         N(I)=0
         DO 66 J=1,NDOM
           DOMCON(I,J)=0
66       CONTINUE
55     CONTINUE
C
       JDOM=0
       SEENBEG=.FALSE.
       DO 11 IRES=1,NRES
         DO 22 IDOM=1,NDOM
           DO 33 ISEG=1,NSEG(IDOM)
             IF(IRESEND(IDOM,ISEG).EQ.IRES) THEN
               IF(IRESEND(IDOM,ISEG).EQ.IRESBEG(IDOM,ISEG)) THEN
                 IF(.NOT.SEENBEG) THEN
                   JDOM=IDOM
                   SEENBEG=.TRUE.
                   GOTO 11
                 ENDIF
                 GOTO 12
               ENDIF
               SEENBEG=.TRUE.
               JDOM=IDOM
               GOTO 11
             ENDIF
12           CONTINUE
             IF(JDOM.NE.0.AND.IRES.EQ.IRESBEG(IDOM,ISEG)) THEN
               IF(IDOM.NE.JDOM) THEN
                 DO 44 I=1,N(IDOM)
                   IF(DOMCON(IDOM,I).EQ.JDOM) GOTO 11
44               CONTINUE
                 N(IDOM)=N(IDOM)+1
                 N(JDOM)=N(JDOM)+1
                 DOMCON(JDOM,N(JDOM))=IDOM
                 DOMCON(IDOM,N(IDOM))=JDOM
                 IF(IRESEND(IDOM,ISEG).EQ.IRESBEG(IDOM,ISEG))
     &              JDOM=IDOM
                 GOTO 11
               ENDIF
             ENDIF
33         CONTINUE
22       CONTINUE
11     CONTINUE
C
7      CONTINUE
       NMX=0
       DO 3 I=1,NDOM
         IF(N(I).GT.NMX) THEN
           NMX=N(I)
           IDOMX=I
         ENDIF
3      CONTINUE
C
       IF(NMX.EQ.0) GOTO 10
       NDOMO=NDOMO+1
       DOMORD(NDOMO)=IDOMX
       NCON(IDOMX)=N(IDOMX)
C
       DO 6 J=1,N(IDOMX)
         M=DOMCON(IDOMX,J)
         DO 21 I=1,N(M)
           IF(DOMCON(M,I).EQ.IDOMX) THEN
             IMX=I
             GOTO 23
           ENDIF
21       CONTINUE
C
23       CONTINUE
C
         DO 8 I=1,N(M)
           IF(I.GE.IMX) THEN
             DOMCON(M,I)=DOMCON(M,I+1)
           ENDIF
8        CONTINUE
         N(M)=N(M)-1
6      CONTINUE
C
       N(IDOMX)=0
       GOTO 7
10     CONTINUE
C
       RETURN
       END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C 
C SUBROUTINE TO CALCULATE EXTERNAL COMPONENT TO DISPLACEMENT
C 
      SUBROUTINE EXTCOMP2(N,IAT1,IAT2,IAT3,IAT4,MASS,CO1,CO2,VEXT,
     &VEXTMSF,VINTMSF,VMSF,TRACER,RMSD)
C 
      IMPLICIT NONE
C
      include 'DynDom.param'
C 
      INTEGER I,N,IER,IAT1,IAT2,IAT3,IAT4
      REAL*8 MASS(*),R(3,3),RC1(3),RC2(3),RMSD
      REAL*8 CO1(3,*),CO2(3,*),COSAV(3,NUMATMX)
      REAL*8 VEXT(*),VEXTX,VEXTY,VEXTZ,VEXTMSF
      REAL*8 VINTMSF,TRACER
      REAL*8 VX,VY,VZ,VMSF
C 
      VMSF=0.0
      DO 8 I=1,N
        VX=CO2(1,I)-CO1(1,I)
        VY=CO2(2,I)-CO1(2,I)
        VZ=CO2(3,I)-CO1(3,I)
        VMSF=VMSF+(VX**2+VY**2+VZ**2)
8     CONTINUE
C
      DO 10 I=1,N
        COSAV(1,I)=CO1(1,I)
        COSAV(2,I)=CO1(2,I)
        COSAV(3,I)=CO1(3,I)
10    CONTINUE
C 
      CALL BSTFT(N,CO2,CO1,RMSD,RC2,RC1,R,IER,MASS)
C
      TRACER=R(1,1)+R(2,2)+R(3,3)
      VINTMSF=(RMSD**2)*N
C
      VEXTMSF=0.0
      DO 9 I=1,N
        CO2(1,I)=CO2(1,I)+RC2(1)
        CO2(2,I)=CO2(2,I)+RC2(2)
        CO2(3,I)=CO2(3,I)+RC2(3)
        VEXTX=CO1(1,I)-COSAV(1,I)+RC2(1)
        VEXTY=CO1(2,I)-COSAV(2,I)+RC2(2)
        VEXTZ=CO1(3,I)-COSAV(3,I)+RC2(3)
        VEXTMSF=VEXTMSF+(VEXTX**2+VEXTY**2+VEXTZ**2)
9     CONTINUE
C
C DETERMINE EXTERNAL CONTRIBUTION TO CONFORMATIONAL CHANGE
C 
      VEXT(1*3-2)=CO1(1,IAT1)-COSAV(1,IAT1)+RC2(1)
      VEXT(1*3-1)=CO1(2,IAT1)-COSAV(2,IAT1)+RC2(2)
      VEXT(1*3  )=CO1(3,IAT1)-COSAV(3,IAT1)+RC2(3)
C 
      VEXT(2*3-2)=CO1(1,IAT2)-COSAV(1,IAT2)+RC2(1)
      VEXT(2*3-1)=CO1(2,IAT2)-COSAV(2,IAT2)+RC2(2)
      VEXT(2*3  )=CO1(3,IAT2)-COSAV(3,IAT2)+RC2(3)
C 
      VEXT(3*3-2)=CO1(1,IAT3)-COSAV(1,IAT3)+RC2(1)
      VEXT(3*3-1)=CO1(2,IAT3)-COSAV(2,IAT3)+RC2(2)
      VEXT(3*3  )=CO1(3,IAT3)-COSAV(3,IAT3)+RC2(3)
C 
      VEXT(4*3-2)=CO1(1,IAT4)-COSAV(1,IAT4)+RC2(1)
      VEXT(4*3-1)=CO1(2,IAT4)-COSAV(2,IAT4)+RC2(2)
      VEXT(4*3  )=CO1(3,IAT4)-COSAV(3,IAT4)+RC2(3)
C 
      DO 30 I=1,N
        CO1(1,I)=COSAV(1,I)
        CO1(2,I)=COSAV(2,I)
        CO1(3,I)=COSAV(3,I)
30    CONTINUE
C 
      RETURN
      END
C
C-------------------------------------------------------------
C
C                       
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C 
C SUBROUTINE TO CALCULATE EXTERNAL AND INTERNAL MSF'S
C 
      SUBROUTINE EXTMSF (N,MASS,CO1,CO2,VEXTMSF,VINTMSF,VMSF)
C 
      IMPLICIT NONE
C
      include 'DynDom.param'
C 
      INTEGER I,N,IER
      REAL*8 MASS(*),R(3,3),RC1(3),RC2(3),RMSD
      REAL*8 CO1(3,*),CO2(3,*)
      REAL*8 COSAV1(3,NUMATMX)
      REAL*8 VEXTX,VEXTY,VEXTZ,VEXTMSF
      REAL*8 VINTMSF
      REAL*8 VX,VY,VZ,VMSF
C 
      VMSF=0.0
      DO 8 I=1,N
        VX=CO2(1,I)-CO1(1,I)
        VY=CO2(2,I)-CO1(2,I)
        VZ=CO2(3,I)-CO1(3,I)
        VMSF=VMSF+(VX**2+VY**2+VZ**2)
8     CONTINUE
C
      DO 10 I=1,N
        COSAV1(1,I)=CO1(1,I)
        COSAV1(2,I)=CO1(2,I)
        COSAV1(3,I)=CO1(3,I)
10    CONTINUE
C 
      CALL BSTFT(N,CO2,CO1,RMSD,RC2,RC1,R,IER,MASS)
C
      VINTMSF=(RMSD**2)*N
C
      VEXTMSF=0.0
      DO 9 I=1,N
        VEXTX=CO1(1,I)-COSAV1(1,I)+RC2(1)
        VEXTY=CO1(2,I)-COSAV1(2,I)+RC2(2)
        VEXTZ=CO1(3,I)-COSAV1(3,I)+RC2(3)
        VEXTMSF=VEXTMSF+(VEXTX**2+VEXTY**2+VEXTZ**2)
9     CONTINUE
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C RATIO OF EXTERNAL TO INTERNAL MOTION FOR A PAIR OF DOMAINS
C INDEPENDENT OF RELATIVE SIZE OF DOMAINS. CALCULATED BY 
C "MASS" WEIGHTING BY INVERSE OF NUMBER OF RESIDUES IN DOMAIN
C
      SUBROUTINE EXTSTOP2 (NRES,NDOM,NSEG,IRESBEG,IRESEND,
     &NI,CA,CP,CB,COOBB1,COOBB2,MASS,ONEOK,ALLOK,
     &NDOMO,NCON,DOMCON,DOMORD,EXTCRIT,EXTINT)
C 
      IMPLICIT NONE
C 
      include 'DynDom.param'
C 
      INTEGER NDOM,DOMORD(*),NDOMO,IRES
      INTEGER NCON(*),DOMCON(NDOMX,*)
      INTEGER NRES,NTOT,IER
      INTEGER I,M,NDOMA,NDOMB,ISEG,NSEG(*)
      INTEGER IDOM,JDOM,IORD,JORD,NOCONDOM
      INTEGER IRESBEG(NDOMX,*),IRESEND(NDOMX,*)
      INTEGER NI(*),CA(*),CB(*),CP(*)
      REAL*8 MASS(*),R(3,3),RC1(3),AC1(3),RMSD
      REAL*8 COOBB1(3,*),COOBB2(3,*)
      REAL*8 CO1(3,NBBMX),CO2(3,NBBMX)
      REAL*8 VEXTMSFA,VINTMSFA,VMSFA
      REAL*8 VEXTMSFB,VINTMSFB,VMSFB
      REAL*8 VEXT,VINT,EXTCRIT
      REAL*8 EXTINT(NDOMX,*)
      LOGICAL ONEOK,ALLOK
C 
      ONEOK=.FALSE.
      ALLOK=.TRUE.
C 
      DO 80 IORD=1,NDOMO
        IDOM=DOMORD(IORD)
C
C DOMAIN A
C 
        NOCONDOM=0 
        M=0
        DO 20 ISEG=1,NSEG(IDOM)
          DO 10 IRES=IRESBEG(IDOM,ISEG),IRESEND(IDOM,ISEG)
            M=M+1
            CO1(1,M)=COOBB1(1,NI(IRES))
            CO1(2,M)=COOBB1(2,NI(IRES))
            CO1(3,M)=COOBB1(3,NI(IRES))
            CO2(1,M)=COOBB2(1,NI(IRES))
            CO2(2,M)=COOBB2(2,NI(IRES))
            CO2(3,M)=COOBB2(3,NI(IRES))
            M=M+1
            CO1(1,M)=COOBB1(1,CA(IRES))
            CO1(2,M)=COOBB1(2,CA(IRES))
            CO1(3,M)=COOBB1(3,CA(IRES))
            CO2(1,M)=COOBB2(1,CA(IRES))
            CO2(2,M)=COOBB2(2,CA(IRES))
            CO2(3,M)=COOBB2(3,CA(IRES))
            M=M+1
            CO1(1,M)=COOBB1(1,CP(IRES))
            CO1(2,M)=COOBB1(2,CP(IRES))
            CO1(3,M)=COOBB1(3,CP(IRES))
            CO2(1,M)=COOBB2(1,CP(IRES))
            CO2(2,M)=COOBB2(2,CP(IRES))
            CO2(3,M)=COOBB2(3,CP(IRES))
            M=M+1
            CO1(1,M)=COOBB1(1,CB(IRES))
            CO1(2,M)=COOBB1(2,CB(IRES))
            CO1(3,M)=COOBB1(3,CB(IRES))
            CO2(1,M)=COOBB2(1,CB(IRES))
            CO2(2,M)=COOBB2(2,CB(IRES))
            CO2(3,M)=COOBB2(3,CB(IRES))
10        CONTINUE
20      CONTINUE
        NDOMA=M
C 
C DOMAINS B
C 
        DO 70 JORD=1,NCON(IDOM)
          JDOM=DOMCON(IDOM,JORD)
          NOCONDOM=NOCONDOM+1
C
          NDOMB=0
          M=NDOMA
          DO 40 ISEG=1,NSEG(JDOM)
            DO 30 IRES=IRESBEG(JDOM,ISEG),IRESEND(JDOM,ISEG)
              M=M+1
              NDOMB=NDOMB+1
              CO1(1,M)=COOBB1(1,NI(IRES))
              CO1(2,M)=COOBB1(2,NI(IRES))
              CO1(3,M)=COOBB1(3,NI(IRES))
              CO2(1,M)=COOBB2(1,NI(IRES))
              CO2(2,M)=COOBB2(2,NI(IRES))
              CO2(3,M)=COOBB2(3,NI(IRES))
              M=M+1
              NDOMB=NDOMB+1
              CO1(1,M)=COOBB1(1,CA(IRES))
              CO1(2,M)=COOBB1(2,CA(IRES))
              CO1(3,M)=COOBB1(3,CA(IRES))
              CO2(1,M)=COOBB2(1,CA(IRES))
              CO2(2,M)=COOBB2(2,CA(IRES))
              CO2(3,M)=COOBB2(3,CA(IRES))
              M=M+1
              NDOMB=NDOMB+1
              CO1(1,M)=COOBB1(1,CP(IRES))
              CO1(2,M)=COOBB1(2,CP(IRES))
              CO1(3,M)=COOBB1(3,CP(IRES))
              CO2(1,M)=COOBB2(1,CP(IRES))
              CO2(2,M)=COOBB2(2,CP(IRES))
              CO2(3,M)=COOBB2(3,CP(IRES))
              M=M+1
              NDOMB=NDOMB+1
              CO1(1,M)=COOBB1(1,CB(IRES))
              CO1(2,M)=COOBB1(2,CB(IRES))
              CO1(3,M)=COOBB1(3,CB(IRES))
              CO2(1,M)=COOBB2(1,CB(IRES))
              CO2(2,M)=COOBB2(2,CB(IRES))
              CO2(3,M)=COOBB2(3,CB(IRES))
30          CONTINUE
40        CONTINUE
          NTOT=NDOMA+NDOMB
C
C BEST FIT BACKBONE ATOMS FROM TWO CONFORMATIONS SO THAT IT IS INDEPENDENT
C OF NUMBER OF ATOMS IN THE DOMAINS
C
          DO 100 I=1,NDOMA
            MASS(I)=1.0/REAL(NDOMA)
100       CONTINUE
C
          DO 101 I=NDOMA+1,NTOT
            MASS(I)=1.0/REAL(NDOMB)
101       CONTINUE
C
          CALL BSTFT(NTOT,CO1,CO2,RMSD,RC1,AC1,R,IER,MASS)
C 
C RESET MASSES TO 1.0
C
          DO 102 I=1,NTOT
            MASS(I)=1.0
102       CONTINUE
C
          CALL EXTMSF (NDOMA,MASS,CO1,CO2,VEXTMSFA,VINTMSFA,VMSFA)
C 
          CALL EXTMSF (NDOMB,MASS(NDOMA+1),CO1(1,NDOMA+1),
     &                 CO2(1,NDOMA+1),VEXTMSFB,VINTMSFB,VMSFB)
C
          VEXT=(VEXTMSFA)/NDOMA+(VEXTMSFB)/NDOMB
          VINT=(VINTMSFA)/NDOMA+(VINTMSFB)/NDOMB
          EXTINT(IDOM,JDOM)=SQRT(VEXT/VINT)
          WRITE(6,'(A,F8.3)')'ratio of interdomain to intradomain displa
     &cement:',EXTINT(IDOM,JDOM)
          IF(EXTINT(IDOM,JDOM).GE.EXTCRIT) THEN
            ONEOK=.TRUE.
            WRITE(6,'(A)')'domain pair accepted'
          ELSE
            ALLOK=.FALSE.
            WRITE(6,'(A)')'domain pair not accepted'
          ENDIF
C
C RESET DOMAIN A COORDINATES
C
          M=0
          DO 21 ISEG=1,NSEG(IDOM)
            DO 11 IRES=IRESBEG(IDOM,ISEG),IRESEND(IDOM,ISEG)
              M=M+1
              CO1(1,M)=COOBB1(1,NI(IRES))
              CO1(2,M)=COOBB1(2,NI(IRES))
              CO1(3,M)=COOBB1(3,NI(IRES))
              CO2(1,M)=COOBB2(1,NI(IRES))
              CO2(2,M)=COOBB2(2,NI(IRES))
              CO2(3,M)=COOBB2(3,NI(IRES))
              M=M+1
              CO1(1,M)=COOBB1(1,CA(IRES))
              CO1(2,M)=COOBB1(2,CA(IRES))
              CO1(3,M)=COOBB1(3,CA(IRES))
              CO2(1,M)=COOBB2(1,CA(IRES))
              CO2(2,M)=COOBB2(2,CA(IRES))
              CO2(3,M)=COOBB2(3,CA(IRES))
              M=M+1
              CO1(1,M)=COOBB1(1,CP(IRES))
              CO1(2,M)=COOBB1(2,CP(IRES))
              CO1(3,M)=COOBB1(3,CP(IRES))
              CO2(1,M)=COOBB2(1,CP(IRES))
              CO2(2,M)=COOBB2(2,CP(IRES))
              CO2(3,M)=COOBB2(3,CP(IRES))
              M=M+1
              CO1(1,M)=COOBB1(1,CB(IRES))
              CO1(2,M)=COOBB1(2,CB(IRES))
              CO1(3,M)=COOBB1(3,CB(IRES))
              CO2(1,M)=COOBB2(1,CB(IRES))
              CO2(2,M)=COOBB2(2,CB(IRES))
              CO2(3,M)=COOBB2(3,CB(IRES))
11          CONTINUE
21        CONTINUE
C
70      CONTINUE
80    CONTINUE
C
      IF(NOCONDOM.EQ.0) ALLOK=.FALSE. 
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C ROUTINE TO FIT THE FIXED DOMAIN CONFORMER 1 TO CONFORMER 2 
C FOR DISPLAY
C

      SUBROUTINE FITCONFORMERS(NBB,DOMA,NSEG,IRESBEG,IRESEND,NATOT1,
     &   NATOT2,ATYP1,ATYP2,RESTYP1,RESTYP2,FILEIN1,IEND1,FILEIN2,
     &   IEND2,CHAINID1,CHAINID2,RESNUM1,RESNUM2,NI,CA,CP,CB,COOBB1,
     &   COOBB2,COO1,COO2,MASS,NRES1,NAAT1,NRES,ATLIST1,WINDLEN,IOUT6)  
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER DOMA,IOUT6,NATOT1,NATOT2,ISEG,IAT,M,I,IB
      INTEGER NSEG(*),IRESBEG(NDOMX,*),IRESEND(NDOMX,*),IRES,IAAT
      INTEGER NI(*),CA(*),CB(*),CP(*),WINDLEN,NBB,NRES
      INTEGER NRES1,NAAT1(*),ATLIST1(NRESMX,*),NDOM,IWIND  
      INTEGER IEND1,IEND2  
      REAL*8 COOBB1(3,*),COOBB2(3,*),COOBB2F(3,NBBMX),MASS(*),RMSD
      REAL*8 CO1(3,NBBMX),CO2(3,NBBMX),ROT(NRESMX,3)    
      REAL*8 COO1(3,*),COO2(3,*),AMPTHET(NRESMX),AMPTHETAV,AMP
      CHARACTER*4 ATYP1(*),ATYP2(*)
      CHARACTER*4 RESTYP1(*),RESTYP2(*)
      CHARACTER*5 RESNUM1(*),RESNUM2(*)
      CHARACTER*1 CHAINID1,CHAINID2
      CHARACTER*200 FILEIN1,FILEIN2
C
      DO 12 IB=1,NBB
        COOBB2F(1,IB)=COOBB2(1,IB)
        COOBB2F(2,IB)=COOBB2(2,IB)
        COOBB2F(3,IB)=COOBB2(3,IB)
12    CONTINUE
C
C FIT CONFORMERS AT DOMAIN A AND DETERMINE ROTATION VECTORS
C
        CALL ROTVECFIELD(NBB,NRES,DOMA,NSEG,IRESBEG,IRESEND,NI,CA,
     & CP,CB,WINDLEN,COOBB1,COOBB2,ROT,AMPTHET,AMPTHETAV,MASS,RMSD) 
C
      M=0
      DO 20 ISEG=1,NSEG(DOMA)
        DO 10 IRES=IRESBEG(DOMA,ISEG),IRESEND(DOMA,ISEG)
          M=M+1
          CO1(1,M)=COOBB1(1,NI(IRES))
          CO1(2,M)=COOBB1(2,NI(IRES))
          CO1(3,M)=COOBB1(3,NI(IRES))
          CO2(1,M)=COOBB2F(1,NI(IRES))
          CO2(2,M)=COOBB2F(2,NI(IRES))
          CO2(3,M)=COOBB2F(3,NI(IRES))
          M=M+1
          CO1(1,M)=COOBB1(1,CA(IRES))
          CO1(2,M)=COOBB1(2,CA(IRES))
          CO1(3,M)=COOBB1(3,CA(IRES))
          CO2(1,M)=COOBB2F(1,CA(IRES))
          CO2(2,M)=COOBB2F(2,CA(IRES))
          CO2(3,M)=COOBB2F(3,CA(IRES))
          M=M+1
          CO1(1,M)=COOBB1(1,CP(IRES))
          CO1(2,M)=COOBB1(2,CP(IRES))
          CO1(3,M)=COOBB1(3,CP(IRES))
          CO2(1,M)=COOBB2F(1,CP(IRES))
          CO2(2,M)=COOBB2F(2,CP(IRES))
          CO2(3,M)=COOBB2F(3,CP(IRES))
          M=M+1
          CO1(1,M)=COOBB1(1,CB(IRES))
          CO1(2,M)=COOBB1(2,CB(IRES))
          CO1(3,M)=COOBB1(3,CB(IRES))
          CO2(1,M)=COOBB2F(1,CB(IRES))
          CO2(2,M)=COOBB2F(2,CB(IRES))
          CO2(3,M)=COOBB2F(3,CB(IRES))
10      CONTINUE
20    CONTINUE
      NDOM=M
C 
C FIT DOMAIN A OF CONFORMATION 2 TO DOMAIN A OF CONFORMATION 1 RELOCATING
C WHOLE OF CONFORMATION 2 ACCORDINGLY
C 
       CALL FITPART (NDOM,NATOT2,CO1,CO2,COO2,MASS,RMSD)
C
C OUTPUT BOTH CONFORMERS SUPERIMPOSED ON THEIR FIXED DOMAIN IF
C THERE IS ONLY ONE FIXED DOMAIN
C
        WRITE(IOUT6,'(A18,A,A1,A1)')'1st chain (A) is: ',
     &   FILEIN1(1:IEND1),'_',CHAINID1 
        WRITE(IOUT6,'(A18,A,A1,A1)')'2nd chain (B) is: ',
     &   FILEIN2(1:IEND2),'_',CHAINID2 
        CHAINID1='A'
        CHAINID2='B'
        IWIND=0
        DO 71 IRES=1,NRES1
          IF(IRES.LE.WINDLEN/2.OR.IRES.GT.NRES-(WINDLEN/2)) THEN
            AMP=0
          ELSE
            IWIND=IWIND+1
            AMP=AMPTHET(IWIND)
          ENDIF
          DO 73 IAAT=1,NAAT1(IRES)
            IAT=ATLIST1(IRES,IAAT)
            WRITE(IOUT6,2000)'ATOM',IAT,ATYP1(IAT),RESTYP1(IAT),CHAINID1
     &       ,RESNUM1(IAT),COO1(1,IAT),COO1(2,IAT),COO1(3,IAT),
     &       AMP
73        CONTINUE
71      CONTINUE
        WRITE(IOUT6,'(A)')'TER'
C
        DO 72 IAT=1,NATOT2
          WRITE(IOUT6,2000)'ATOM',IAT,ATYP2(IAT),RESTYP2(IAT),CHAINID2,
     &     RESNUM2(IAT),COO2(1,IAT),COO2(2,IAT),COO2(3,IAT)
72      CONTINUE
        WRITE(IOUT6,'(A)')'TER'
C
2000  FORMAT(A4,2X,I5,2X,A4,A4,A1,A5,3X,3F8.3,6X,F6.2) 
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------

C
C ROUTINE TO FIT TWO CONFORMATIONS AT A DOMAIN
C
      SUBROUTINE FITDOM(NBB,IDOM,NSEG,IRESBEG,IRESEND,NI,CA,CP,CB,
     & COOBB1,COOBB2,MASS,RMSD)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER IDOM,NSEG(*),IRESBEG(NDOMX,*),IRESEND(NDOMX,*)
      INTEGER NBB,NI(*),CA(*),CP(*),CB(*),M,IRES,ISEG,NDOM
      REAL*8 COOBB1(3,*),COOBB2(3,*),MASS(*),RMSD
      REAL*8 CO1(3,NBBMX),CO2(3,NBBMX) 
C

      M=0
      DO 20 ISEG=1,NSEG(IDOM)
        DO 10 IRES=IRESBEG(IDOM,ISEG),IRESEND(IDOM,ISEG)
          M=M+1
          CO1(1,M)=COOBB1(1,NI(IRES))
          CO1(2,M)=COOBB1(2,NI(IRES))
          CO1(3,M)=COOBB1(3,NI(IRES))
          CO2(1,M)=COOBB2(1,NI(IRES))
          CO2(2,M)=COOBB2(2,NI(IRES))
          CO2(3,M)=COOBB2(3,NI(IRES))
          M=M+1
          CO1(1,M)=COOBB1(1,CA(IRES))
          CO1(2,M)=COOBB1(2,CA(IRES))
          CO1(3,M)=COOBB1(3,CA(IRES))
          CO2(1,M)=COOBB2(1,CA(IRES))
          CO2(2,M)=COOBB2(2,CA(IRES))
          CO2(3,M)=COOBB2(3,CA(IRES))
          M=M+1
          CO1(1,M)=COOBB1(1,CP(IRES))
          CO1(2,M)=COOBB1(2,CP(IRES))
          CO1(3,M)=COOBB1(3,CP(IRES))
          CO2(1,M)=COOBB2(1,CP(IRES))
          CO2(2,M)=COOBB2(2,CP(IRES))
          CO2(3,M)=COOBB2(3,CP(IRES))
          M=M+1
          CO1(1,M)=COOBB1(1,CB(IRES))
          CO1(2,M)=COOBB1(2,CB(IRES))
          CO1(3,M)=COOBB1(3,CB(IRES))
          CO2(1,M)=COOBB2(1,CB(IRES))
          CO2(2,M)=COOBB2(2,CB(IRES))
          CO2(3,M)=COOBB2(3,CB(IRES))
10      CONTINUE
20    CONTINUE
      NDOM=M
C 
C FIT DOMAIN A OF CONFORMATION 2 TO DOMAIN A OF CONFORMATION 1 RELOCATING
C WHOLE OF CONFORMATION 2 ACCORDINGLY
C 
      CALL FITPART (NDOM,NBB,CO1,CO2,COOBB2,MASS,RMSD)
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------

C
C ROUTINE TO FIT CORRESPONDING PARTS OF PROTEIN AND REPOSITION REST
C
       SUBROUTINE FITPART(NA,NTOT,CO1,CO2,COO2,MASS,RMSD)
C
       IMPLICIT NONE
C
       REAL*8 MASS(*),R(3,3),AC(3),RC(3),RMSD
       REAL*8 COO2(3,*),X,Y,Z
       REAL*8 CO1(3,*),CO2(3,*)
       INTEGER I,IER,NA,NTOT
C
       CALL BSTFT(NA,CO1,CO2,RMSD,RC,AC,R,IER,MASS)
C
C PUT CO1 COORDINATES BACK TO ORIGINAL PLACE
C
        DO 7 I=1,NA
          CO1(1,I)=CO1(1,I)+RC(1)
          CO1(2,I)=CO1(2,I)+RC(2)
          CO1(3,I)=CO1(3,I)+RC(3)
7       CONTINUE
C
C RELOCATE COO2 TO CO1 PLACE
C
        DO 8 I=1,NTOT
          COO2(1,I)=COO2(1,I)-AC(1)
          COO2(2,I)=COO2(2,I)-AC(2)
          COO2(3,I)=COO2(3,I)-AC(3)
          X=COO2(1,I)
          Y=COO2(2,I)
          Z=COO2(3,I)
          COO2(1,I)=R(1,1)*X+R(1,2)*Y+R(1,3)*Z
          COO2(2,I)=R(2,1)*X+R(2,2)*Y+R(2,3)*Z
          COO2(3,I)=R(3,1)*X+R(3,2)*Y+R(3,3)*Z
          COO2(1,I)=COO2(1,I)+RC(1)
          COO2(2,I)=COO2(2,I)+RC(2)
          COO2(3,I)=COO2(3,I)+RC(3)
8       CONTINUE
C
        RETURN
        END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C DETERMINES INTERDOMAIN SCREW-AXES OR HINGE AXES
C
      SUBROUTINE HINGEAXES2 (NDOM,WINDLEN,NRES,NBB,RESPDBNUM,
     & RESPDBTYP,NI,CA,CP,CB,NSEG,IRESBEG,IRESEND,COOBB1,COOBB2,
     & MASS,NDOMO,NCON,DOMCON,DOMORD,EXTINT,EXTCRIT,NRES1,CHAINID1,
     & DOMSIZE,IOUT1,IOUT3,IOUT6,IOUT7)
C 
      IMPLICIT NONE
C 
      include 'DynDom.param'
C 
      INTEGER DOMORD(*),NDOMO,NDOM,K
      INTEGER NCON(*),DOMCON(NDOMX,*)
      INTEGER NBB,NRES,IAT1,IAT2,IAT3,IAT4
      INTEGER I,J,M,N,NDOMA,NDOMB,ISEG,NSEG(*)
      INTEGER DOMA,DOMB,WINDLEN,DOMSIZE(*)
      INTEGER IRESBEG(NDOMX,*),IRESEND(NDOMX,*),IRES
      INTEGER NI(*),CA(*),CB(*),CP(*),IPAIR,NRES1,NPAIR
      INTEGER NCONA(NPAIRMX),NCONB(NPAIRMX)
      INTEGER BEGCONA(NPAIRMX,NCONPMX),ENDCONA(NPAIRMX,NCONPMX)
      INTEGER BEGCONB(NPAIRMX,NCONPMX),ENDCONB(NPAIRMX,NCONPMX)
      INTEGER MSEG,SEGB(NPAIRMX),SEGE(NPAIRMX)
      INTEGER IOUT1,IOUT3,IOUT6,IOUT7,LENGTH,IEND
      REAL*8 UNTHX,UNTHY,UNTHZ,AMPROT,AMPTR,XL,YL,ZL
      REAL*8 MASS(*),RMSD,TRACER 
      REAL*8 COOBB1(3,*),COOBB2(3,*)
      REAL*8 CO1(3,NBBMX),CO2(3,NBBMX)
      REAL*8 VEXT(12),VEXTMSF,VINTMSF,VMSF
      REAL*8 EXTINT(NDOMX,*),EXTCRIT,PERCEXT
      CHARACTER*5 RESPDBNUM(*)
      CHARACTER*4 RESPDBTYP(*)
      CHARACTER*1 CHAINID1 
      CHARACTER*19 COLOR(NDOMX),COLORA,COLORB,COLORCON
      CHARACTER*16 COLOUR(NDOMX)
      LOGICAL DONEDOMA
C 
      CALL COLOURS(COLOR,COLOUR)
C
      WRITE(IOUT3,'(A)')'select all'
      WRITE(IOUT3,'(A)')'color grey'
      WRITE(IOUT3,'(A)')'background grey'
C
      IPAIR=0
      DO 80 I=1,NDOMO
C
        DONEDOMA=.FALSE.
        DOMA=DOMORD(I)
C 
C DOMAINS B
C 
        DO 70 J=1,NCON(DOMA)
C 
          DOMB=DOMCON(DOMA,J)
C
          IF(EXTINT(DOMA,DOMB).GE.EXTCRIT) THEN
            IF(.NOT.DONEDOMA) THEN
C
              IF(DOMA.GT.26) THEN
                WRITE(6,'(A)')'WARNING COLOURS WILL NOT BE UNIQUE'
              ENDIF
C
              WRITE (IOUT1,'(A80)') '===================================
     &============================================='
              WRITE(IOUT1,'(A)')'FIXED  DOMAIN'
              LENGTH=LEN(COLOUR(DOMA))
              CALL STRINGLENGTH(COLOUR(DOMA),LENGTH,IEND)
              WRITE(IOUT1,'(A,I3,A,A,A)')'DOMAIN NUMBER: ',DOMA,
     &' (coloured ',COLOUR(DOMA)(1:IEND),' for rasmol)'
              WRITE(IOUT1,'(A,10(A5,A1,A5,A1))')'RESIDUE NUMBERS : ',
     &(RESPDBNUM(IRESBEG(DOMA,N)),'-',
     &RESPDBNUM(IRESEND(DOMA,N)),',',N=1,NSEG(DOMA)-1),
     &RESPDBNUM(IRESBEG(DOMA,NSEG(DOMA))),
     &'-',RESPDBNUM(IRESEND(DOMA,NSEG(DOMA)))
C             WRITE(IOUT1,'(A,10(I4,A1,I4,A1))')'RESIDUE NUMBERS : ',
C    &(IRESBEG(DOMA,N),'-',IRESEND(DOMA,N),',',N=1,NSEG(DOMA)-1),
C    &IRESBEG(DOMA,NSEG(DOMA)),'-',IRESEND(DOMA,NSEG(DOMA))
              WRITE(IOUT1,'(A,I5,A)')'SIZE: ',DOMSIZE(DOMA),' RESIDUES'
C
C WRITE IN RASMOL SCRIPT FILE
C
              WRITE(IOUT3,'(A,A)')'# select fixed domain residues and co
     &lour ',COLOUR(DOMA)(1:IEND)
C
              COLORA=COLOR(DOMA)
              CALL WRITEDOM_RAS(DOMA,NSEG,IRESBEG,IRESEND,RESPDBNUM,
     &   CHAINID1,IOUT3,COLORA)
C
C
C FIT DOMAIN A OF CONFORMATION 2 TO DOMAIN A OF CONFORMATION 1 RELOCATING
C WHOLE OF CONFORMATION 2 ACCORDINGLY
C
              CALL FITDOM(NBB,DOMA,NSEG,IRESBEG,IRESEND,NI,CA,CP,CB,
     &         COOBB1,COOBB2,MASS,RMSD)
C
              WRITE (6,'(A,F8.3,A)') 'rmsd of fixed domain best fit: ',
     &RMSD,'A'
              WRITE (IOUT1,'(A,F8.3,A)') 'BACKBONE RMSD ON THIS DOMAIN: 
     &',RMSD,'A'
C
              DONEDOMA=.TRUE.
            ENDIF
C
C END OF OUTPUT FOR DOMAIN A
C
            IF(DOMB.GT.26) THEN
              WRITE(6,'(A)')'WARNING COLOURS WILL NOT BE UNIQUE'
            ENDIF
C
            IPAIR=IPAIR+1
C
            IF(IPAIR.GT.NPAIRMX) THEN
              WRITE(6,'(A,I4,I4)')'ARRAY BOUNDARY FOR NUMBER OF PAIRS HA
     &S BEEN EXCEEDED: ',NPAIRMX,IPAIR
              WRITE(6,'(A)')'CHANGE VALUE FOR "NPAIRMX" IN "DynDom.param
     &"'
              STOP
            ENDIF
C
            WRITE (IOUT1,'(A80)') '-------------------------------------
     &-------------------------------------------'
C
            IF(IPAIR.EQ.1.OR.IPAIR.EQ.21.OR.IPAIR.EQ.31) THEN
              WRITE(IOUT1,'(A,I3,A)')'MOVING DOMAIN (RELATIVE TO FIXED D
     &OMAIN), ',IPAIR,'ST PAIR' 
            ELSEIF(IPAIR.EQ.2.OR.IPAIR.EQ.22.OR.IPAIR.EQ.32) THEN
              WRITE(IOUT1,'(A,I3,A)')'MOVING DOMAIN (RELATIVE TO FIXED D
     &OMAIN), ',IPAIR,'ND PAIR' 
            ELSEIF(IPAIR.EQ.3.OR.IPAIR.EQ.23.OR.IPAIR.EQ.33) THEN
              WRITE(IOUT1,'(A,I3,A)')'MOVING DOMAIN (RELATIVE TO FIXED D
     &OMAIN), ',IPAIR,'RD PAIR' 
            ELSE 
              WRITE(IOUT1,'(A,I3,A)')'MOVING DOMAIN (RELATIVE TO FIXED D
     &OMAIN), ',IPAIR,'TH PAIR' 
C
            ENDIF
C
            LENGTH=LEN(COLOUR(DOMB))
            CALL STRINGLENGTH(COLOUR(DOMB),LENGTH,IEND)
            WRITE(IOUT1,'(A,I3,A,A,A)')'DOMAIN NUMBER: ',DOMB,
     &' (coloured ',COLOUR(DOMB)(1:IEND),' for rasmol)'
            WRITE(IOUT1,'(A,10(A5,A1,A5,A1))')'RESIDUE NUMBERS : ',
     &(RESPDBNUM(IRESBEG(DOMB,N)),'-',
     &RESPDBNUM(IRESEND(DOMB,N)),',',N=1,NSEG(DOMB)-1),
     &RESPDBNUM(IRESBEG(DOMB,NSEG(DOMB))),'-',
     &RESPDBNUM(IRESEND(DOMB,NSEG(DOMB)))
C           WRITE(IOUT1,'(A,10(I4,A1,I4,A1))')'RESIDUE NUMBERS : ',
C    &(IRESBEG(DOMB,N),'-',IRESEND(DOMB,N),',',N=1,NSEG(DOMB)-1),
C    &IRESBEG(DOMB,NSEG(DOMB)),'-',IRESEND(DOMB,NSEG(DOMB))
            WRITE(IOUT1,'(A,I5,A)')'SIZE: ',DOMSIZE(DOMB),' RESIDUES'
C
C WRITE IN RASMOL SCRIPT FILE
C
            WRITE(IOUT3,'(A,A)')
     &        '# select moving domain residues and colour ',
     &        COLOUR(DOMB)(1:IEND)
C
            COLORB=COLOR(DOMB)
            CALL WRITEDOM_RAS(DOMB,NSEG,IRESBEG,IRESEND,RESPDBNUM,
     &  CHAINID1,IOUT3,COLORB)
C
            M=0
            DO 40 ISEG=1,NSEG(DOMB)
              DO 30 IRES=IRESBEG(DOMB,ISEG),IRESEND(DOMB,ISEG)
              M=M+1
              IAT1=M
              CO1(1,M)=COOBB1(1,NI(IRES))
              CO1(2,M)=COOBB1(2,NI(IRES))
              CO1(3,M)=COOBB1(3,NI(IRES))
              CO2(1,M)=COOBB2(1,NI(IRES))
              CO2(2,M)=COOBB2(2,NI(IRES))
              CO2(3,M)=COOBB2(3,NI(IRES))
              M=M+1
              IAT2=M
              CO1(1,M)=COOBB1(1,CA(IRES))
              CO1(2,M)=COOBB1(2,CA(IRES))
              CO1(3,M)=COOBB1(3,CA(IRES))
              CO2(1,M)=COOBB2(1,CA(IRES))
              CO2(2,M)=COOBB2(2,CA(IRES))
              CO2(3,M)=COOBB2(3,CA(IRES))
              M=M+1
              IAT3=M
              CO1(1,M)=COOBB1(1,CP(IRES))
              CO1(2,M)=COOBB1(2,CP(IRES))
              CO1(3,M)=COOBB1(3,CP(IRES))
              CO2(1,M)=COOBB2(1,CP(IRES))
              CO2(2,M)=COOBB2(2,CP(IRES))
              CO2(3,M)=COOBB2(3,CP(IRES))
              M=M+1
              IAT4=M
              CO1(1,M)=COOBB1(1,CB(IRES))
              CO1(2,M)=COOBB1(2,CB(IRES))
              CO1(3,M)=COOBB1(3,CB(IRES))
              CO2(1,M)=COOBB2(1,CB(IRES))
              CO2(2,M)=COOBB2(2,CB(IRES))
              CO2(3,M)=COOBB2(3,CB(IRES))
30            CONTINUE
40          CONTINUE
            NDOMB=M
C 
C CALL SUBROUTINE TO DETERMINE EXTERNAL COMPONENT TO MOTION OF DOMAIN
C B IN CONFORMATION 1 TO DOMAIN B IN CONFORMATION 2
C 
            CALL EXTCOMP2(NDOMB,IAT1,IAT2,IAT3,IAT4,MASS,CO1,CO2,VEXT,
     &     VEXTMSF,VINTMSF,VMSF,TRACER,RMSD)
C 
            WRITE (IOUT1,'(A,F8.3,A)') 'BACKBONE RMSD ON THIS DOMAIN: ',
     &RMSD,'A'
            WRITE(IOUT1,'(A)') 
            WRITE(IOUT1,'(A,F8.3)')'RATIO INTERDOMAIN TO INTRADOMAIN DIS
     &PLACEMENT: ',EXTINT(DOMA,DOMB)
            PERCEXT=VEXTMSF*100.0/VMSF
            IF(PERCEXT.GT.100.0) PERCEXT=100.0
              WRITE (IOUT1,'(A,F8.3)') 'PERCENTAGE EXTERNAL DISPLACEMENT
     & IN MOVING DOMAIN:',PERCEXT
C           WRITE (IOUT1,'(A17,F8.3)') 'PERCENTAGE ERROR:',
C    &      (100.0-(VEXTMSF+VINTMSF)*100.0/VMSF)
C 
C CALL ROUTINE TO LOCATE SCREW AXIS
C 
            CALL ROTVEC(IAT1,IAT2,IAT3,IAT4,CO1,VEXT,TRACER,AMPROT,
     &                UNTHX,UNTHY,UNTHZ)
C
            CALL SCREWAX(IAT1,IAT2,IAT3,IAT4,CO1,VEXT,AMPROT,
     &                     UNTHX,UNTHY,UNTHZ,AMPTR,XL,YL,ZL)
C
            AMPROT=AMPROT*180.0/PI
            WRITE (IOUT1,'(A18,F8.3,A8)') 'ANGLE OF ROTATION:',
     &     AMPROT,' DEGREES'
            WRITE (IOUT1,'(A23,F8.3,A2)') 'TRANSLATION ALONG AXIS:',
     &     AMPTR,' A'
C           WRITE (IOUT1,'(A17,6(F8.3,1X))')'AXIS PARAMETERS: ',
C    &     UNTHX,UNTHY,UNTHZ,XL,YL,ZL
C 
C DETERMINE BENDING RESIDUES 
C
            CALL HINGERES3D(NDOM,NRES,WINDLEN,DOMA,DOMB,NSEG,IRESBEG,
     &     IRESEND,NI,CA,CP,CB,COOBB1,COOBB2,MASS,UNTHX,UNTHY,UNTHZ,
     &     XL,YL,ZL,AMPROT,IPAIR,NCONA,NCONB,BEGCONA,ENDCONA,BEGCONB,
     &     ENDCONB,RESPDBNUM,RESPDBTYP,MSEG,SEGB,SEGE,IOUT1,IOUT7)
C
C CALL ROUTINE TO FIND RESIDUES NEAR AXIS
C 
            CALL AXRES(NRES,RESPDBNUM,RESPDBTYP,UNTHX,UNTHY,UNTHZ,
     &XL,YL,ZL,CA,COOBB1,MSEG,SEGB,SEGE,IOUT1)
C 
C CALL ROUTINE TO DETERMINE DEGREE OF CLOSURE MOTION
C 
            CALL CLOSURE(DOMA,DOMB,NSEG,IRESBEG,IRESEND,CA,
     &     COOBB1,UNTHX,UNTHY,UNTHZ,XL,YL,ZL,IOUT1)
C 
C CALL ROUTINE TO WRITE OUT SCREW AXIS AND SCRIPT FOR DISPLAY ON RASMOL
C 
            CALL ARROW(NBB,COOBB1,UNTHX,UNTHY,UNTHZ,
     &     XL,YL,ZL,RESPDBNUM,NRES1,IPAIR,
     &     CHAINID1,IOUT6,IOUT3,COLORA,COLORB)
C
          ENDIF
70      CONTINUE
80    CONTINUE
C
C SELECT AND COLOUR CONNECTING REGIONS GREEN
C
        COLORCON='color [0  ,255,0  ]'
C
        WRITE(IOUT3,'(A)')'# select and colour green residues involved i
     &n interdomain bending'
C
        NPAIR=IPAIR
        DO 1 IPAIR=1,NPAIR
C
          WRITE(IOUT3,'(A,I4)')'# interdomain residues for pair ',IPAIR
          IF(NCONA(IPAIR).NE.0) THEN
C
            CALL WRITECON_RAS(IPAIR,NCONA,BEGCONA,ENDCONA,RESPDBNUM,
     &       CHAINID1,IOUT3,COLORCON)
C
          ENDIF
C
          IF(NCONB(IPAIR).NE.0) THEN
C
            CALL WRITECON_RAS(IPAIR,NCONB,BEGCONB,ENDCONB,RESPDBNUM,
     &       CHAINID1,IOUT3,COLORCON)
C
          ENDIF
C
1       CONTINUE
C
      WRITE(IOUT3,'(A)')'select all'
      WRITE(IOUT3,'(A)')'wireframe off'
      WRITE(IOUT3,'(A)')'backbone 100'
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C 
C TO DETERMINE BENDING RESIDUES
C THE PAIR OF DOMAINS A AND B.  THE ROTATION VECTOR OF EACH WINDOW
C SEGMENT IS PROJECTED ONTO THE INTERDOMAIN SCREW AXIS FOR THAT 
C PAIR.  THE AVERAGE AND STANDARD DEVIATION IS CALCULATED FOR A AND
C B.  INTERDOMAIN RESIDUES ARE THOSE AT THE CONNECTIONS
C BETWEEN THE DOMAINS PLUS ANY OF THOSE THAT HAVE PROJECTED ROTATION
C ANGLES ABOVE THE AVERAGE PLUS ONE STANDARD DEVIATION FOR DOMAIN A
C (THE ONE FIXED IN SPACE) FROM A CONNECTING POINT WITH B, AND THOSE 
C THAT HAVE PROJECTED ROTATION ANGLES BELOW THE AVERAGE MINUS ONE
C STANDARD DEVIATION FROM A CONNECTING POINT WITH A.
C
      SUBROUTINE HINGERES3D(NDOM,NRES,WINDLEN,DOMA,DOMB,NSEG,IRESBEG,
     & IRESEND,NI,CA,CP,CB,COOBB1,COOBB2,MASS,UX,UY,UZ,XL,YL,ZL,AMPROT,
     & IPAIR,ICONA,ICONB,BEGA,ENDA,BEGB,ENDB,RESPDBNUM,RESPDBTYP,
     & MSEG,SEGB,SEGE,IOUT1,IOUT7)
C
      IMPLICIT NONE
C 
      include 'DynDom.param'
C
      INTEGER IC,IRESWIND
      INTEGER IRESBEG(NDOMX,*),IRESEND(NDOMX,*),NSEG(*)
      INTEGER NRES,IAT1,IAT2,IAT3,IAT4,ISEG,IRES	  
      INTEGER I,N,WINDLEN,DOMA,DOMB,NA,NB,NMAX
      INTEGER AEND,BEND,IDOM,NDOM
      INTEGER SEGBEGA(NCONPMX),SEGENDA(NCONPMX)
      INTEGER SEGBEGB(NCONPMX),SEGENDB(NCONPMX)
      INTEGER ICONA(*),ICONB(*)
      INTEGER BEGA(NPAIRMX,*),ENDA(NPAIRMX,*)
      INTEGER BEGB(NPAIRMX,*),ENDB(NPAIRMX,*)
      INTEGER MSEG,SEGB(*),SEGE(*)
      INTEGER NI(*),CA(*),CB(*),CP(*),IPAIR
      INTEGER IOUT1,IOUT7
      REAL*8 UNTHX,UNTHY,UNTHZ,XL,YL,ZL,AMPROT,AMPTHET
      REAL*8 AMPTR,XAX,YAX,ZAX,TRACER
      REAL*8 AMPX(NRESMX),AMPY(NRESMX),AMPZ(NRESMX)
      REAL*8 XAVA,YAVA,ZAVA,XAVB,YAVB,ZAVB
      REAL*8 XXCORA,XYCORA,XZCORA,YYCORA,YZCORA,ZZCORA
      REAL*8 XXCORB,XYCORB,XZCORB,YYCORB,YZCORB,ZZCORB
      REAL*8 UX,UY,UZ,PRO,AVA,VARA,SDA,AVB,VARB,SDB
      REAL*8 VEXT(12),VEXTMSF,VINTMSF,VMSF,RMSD
      REAL*8 MASS(*),PROJ(NRESMX)
      REAL*8 COOBB1(3,*),COOBB2(3,*)
      REAL*8 CO1(3,NUMATMX),CO2(3,NUMATMX)
      REAL*8 SIGMA(3,3),SIGMB(3,3),INVSIGMA(3,3),INVSIGMB(3,3),QA,QB
      CHARACTER*5 RESPDBNUM(*)
      CHARACTER*4 RESPDBTYP(*)
C 
C THREAD WINDOW THROUGH FIRST DOMAIN TO DETERMINE COMPONENTS
C OF ROTATION VECTORS ALONG INTERDOMAIN SCREW AXIS. CALCULATE AVERAGE 
C AND STANDARD DEVIATION
C
      DO 55 I=1,NCONPMX
        SEGBEGA(I)=0
        SEGENDA(I)=0
        SEGBEGB(I)=0
        SEGENDB(I)=0
        BEGA(IPAIR,I)=0
        ENDA(IPAIR,I)=0
        BEGB(IPAIR,I)=0
        ENDB(IPAIR,I)=0
55    CONTINUE
C
      AVA=0.0
      VARA=0.0
      SDA=0.0
C
      NA=0
      XAVA=0.0
      YAVA=0.0
      ZAVA=0.0
      XXCORA=0.0
      XYCORA=0.0
      XZCORA=0.0
      YYCORA=0.0
      YZCORA=0.0
      ZZCORA=0.0
      DO 40 ISEG=1,NSEG(DOMA)
        DO 42 IRES=IRESBEG(DOMA,ISEG),IRESEND(DOMA,ISEG)
          N=0
C
C FOLLOWING CONDITION IS NEEDED BECAUSE DOMAIN A CONFORMATIONS
C ARE ALREADY BEST FITTED
C
          IF(NSEG(DOMA).EQ.1.AND.(WINDLEN/2).EQ.0) GOTO 40
C 
          DO 30 IRESWIND=IRES-WINDLEN/2,IRES+WINDLEN/2
            N=N+1
            IAT1=N
            CO1(1,N)=COOBB1(1,NI(IRESWIND))
            CO1(2,N)=COOBB1(2,NI(IRESWIND))
            CO1(3,N)=COOBB1(3,NI(IRESWIND))
            CO2(1,N)=COOBB2(1,NI(IRESWIND))
            CO2(2,N)=COOBB2(2,NI(IRESWIND))
            CO2(3,N)=COOBB2(3,NI(IRESWIND))
            N=N+1
            IAT2=N
            CO1(1,N)=COOBB1(1,CA(IRESWIND))
            CO1(2,N)=COOBB1(2,CA(IRESWIND))
            CO1(3,N)=COOBB1(3,CA(IRESWIND))
            CO2(1,N)=COOBB2(1,CA(IRESWIND))
            CO2(2,N)=COOBB2(2,CA(IRESWIND))
            CO2(3,N)=COOBB2(3,CA(IRESWIND))
            N=N+1
            IAT3=N
            CO1(1,N)=COOBB1(1,CP(IRESWIND))
            CO1(2,N)=COOBB1(2,CP(IRESWIND))
            CO1(3,N)=COOBB1(3,CP(IRESWIND))
            CO2(1,N)=COOBB2(1,CP(IRESWIND))
            CO2(2,N)=COOBB2(2,CP(IRESWIND))
            CO2(3,N)=COOBB2(3,CP(IRESWIND))
            N=N+1
            IAT4=N
            CO1(1,N)=COOBB1(1,CB(IRESWIND))
            CO1(2,N)=COOBB1(2,CB(IRESWIND))
            CO1(3,N)=COOBB1(3,CB(IRESWIND))
            CO2(1,N)=COOBB2(1,CB(IRESWIND))
            CO2(2,N)=COOBB2(2,CB(IRESWIND))
            CO2(3,N)=COOBB2(3,CB(IRESWIND))
30        CONTINUE
C
          NMAX=N
C
          CALL EXTCOMP2(NMAX,IAT1,IAT2,IAT3,IAT4,MASS,CO1,CO2,VEXT,
     &     VEXTMSF,VINTMSF,VMSF,TRACER,RMSD)
C
C CALL SUBROUTINE TO CALCULATE THE ROTATION VECTOR AT EACH
C SEGMENT
C
          CALL ROTVEC(IAT1,IAT2,IAT3,IAT4,CO1,VEXT,TRACER,AMPTHET,
     &                UNTHX,UNTHY,UNTHZ)
C
          PRO=UX*UNTHX+UY*UNTHY+UZ*UNTHZ
          PRO=AMPTHET*PRO
          PRO=PRO*180.0/PI
          PROJ(IRES)=PRO
C
          AVA=AVA+PRO
          VARA=VARA+(PRO**2)

          AMPX(IRES)=AMPTHET*UNTHX*180.0/PI
          AMPY(IRES)=AMPTHET*UNTHY*180.0/PI
          AMPZ(IRES)=AMPTHET*UNTHZ*180.0/PI
C
          XAVA=XAVA+AMPX(IRES)
          YAVA=YAVA+AMPY(IRES)
          ZAVA=ZAVA+AMPZ(IRES)
C
          XXCORA=XXCORA+AMPX(IRES)*AMPX(IRES)
          YYCORA=YYCORA+AMPY(IRES)*AMPY(IRES)
          ZZCORA=ZZCORA+AMPZ(IRES)*AMPZ(IRES)
          XYCORA=XYCORA+AMPX(IRES)*AMPY(IRES)
          XZCORA=XZCORA+AMPX(IRES)*AMPZ(IRES)
          YZCORA=YZCORA+AMPY(IRES)*AMPZ(IRES)
C
          NA=NA+1
C
42      CONTINUE
40    CONTINUE
C
      AVA=AVA/NA
      VARA=(VARA/NA)-(AVA**2)
      SDA=SQRT(VARA)
C
      XAVA=XAVA/NA
      YAVA=YAVA/NA
      ZAVA=ZAVA/NA
      XXCORA=XXCORA/NA-(XAVA*XAVA)
      YYCORA=YYCORA/NA-(YAVA*YAVA)
      ZZCORA=ZZCORA/NA-(ZAVA*ZAVA)
      XYCORA=XYCORA/NA-(XAVA*YAVA)
      XZCORA=XZCORA/NA-(XAVA*ZAVA)
      YZCORA=YZCORA/NA-(YAVA*ZAVA)
C
      SIGMA(1,1)=XXCORA
      SIGMA(1,2)=XYCORA
      SIGMA(1,3)=XZCORA
      SIGMA(2,1)=XYCORA
      SIGMA(2,2)=YYCORA
      SIGMA(2,3)=YZCORA
      SIGMA(3,1)=XZCORA
      SIGMA(3,2)=YZCORA
      SIGMA(3,3)=ZZCORA
      CALL M_INV (SIGMA,INVSIGMA) 
C
C DO SAME FOR SECOND DOMAIN
C
      AVB=0.0
      VARB=0.0
      SDB=0.0
C
      NB=0
      XAVB=0.0
      YAVB=0.0
      ZAVB=0.0
      XXCORB=0.0
      XYCORB=0.0
      XZCORB=0.0
      YYCORB=0.0
      YZCORB=0.0
      ZZCORB=0.0
      DO 41 ISEG=1,NSEG(DOMB)
        DO 43 IRES=IRESBEG(DOMB,ISEG),IRESEND(DOMB,ISEG)
          N=0
          DO 31 IRESWIND=IRES-WINDLEN/2,IRES+WINDLEN/2
            N=N+1
            IAT1=N
            CO1(1,N)=COOBB1(1,NI(IRESWIND))
            CO1(2,N)=COOBB1(2,NI(IRESWIND))
            CO1(3,N)=COOBB1(3,NI(IRESWIND))
            CO2(1,N)=COOBB2(1,NI(IRESWIND))
            CO2(2,N)=COOBB2(2,NI(IRESWIND))
            CO2(3,N)=COOBB2(3,NI(IRESWIND))
            N=N+1
            IAT2=N
            CO1(1,N)=COOBB1(1,CA(IRESWIND))
            CO1(2,N)=COOBB1(2,CA(IRESWIND))
            CO1(3,N)=COOBB1(3,CA(IRESWIND))
            CO2(1,N)=COOBB2(1,CA(IRESWIND))
            CO2(2,N)=COOBB2(2,CA(IRESWIND))
            CO2(3,N)=COOBB2(3,CA(IRESWIND))
            N=N+1
            IAT3=N
            CO1(1,N)=COOBB1(1,CP(IRESWIND))
            CO1(2,N)=COOBB1(2,CP(IRESWIND))
            CO1(3,N)=COOBB1(3,CP(IRESWIND))
            CO2(1,N)=COOBB2(1,CP(IRESWIND))
            CO2(2,N)=COOBB2(2,CP(IRESWIND))
            CO2(3,N)=COOBB2(3,CP(IRESWIND))
            N=N+1
            IAT4=N
            CO1(1,N)=COOBB1(1,CB(IRESWIND))
            CO1(2,N)=COOBB1(2,CB(IRESWIND))
            CO1(3,N)=COOBB1(3,CB(IRESWIND))
            CO2(1,N)=COOBB2(1,CB(IRESWIND))
            CO2(2,N)=COOBB2(2,CB(IRESWIND))
            CO2(3,N)=COOBB2(3,CB(IRESWIND))
31        CONTINUE
C
          NMAX=N
C
          CALL EXTCOMP2(NMAX,IAT1,IAT2,IAT3,IAT4,MASS,CO1,CO2,VEXT,
     &     VEXTMSF,VINTMSF,VMSF,TRACER,RMSD)
C
C CALL SUBROUTINE TO CALCULATE THE ROTATION VECTOR AT EACH
C SEGMENT
C
          CALL ROTVEC(IAT1,IAT2,IAT3,IAT4,CO1,VEXT,TRACER,AMPTHET,
     &                UNTHX,UNTHY,UNTHZ)
C
          PRO=UX*UNTHX+UY*UNTHY+UZ*UNTHZ
          PRO=AMPTHET*PRO
          PRO=PRO*180.0/PI
          PROJ(IRES)=PRO
C
          AVB=AVB+PRO
          VARB=VARB+(PRO**2)
C
          AMPX(IRES)=AMPTHET*UNTHX*180.0/PI
          AMPY(IRES)=AMPTHET*UNTHY*180.0/PI
          AMPZ(IRES)=AMPTHET*UNTHZ*180.0/PI
C
          XAVB=XAVB+AMPX(IRES)
          YAVB=YAVB+AMPY(IRES)
          ZAVB=ZAVB+AMPZ(IRES)
C
          XXCORB=XXCORB+AMPX(IRES)*AMPX(IRES)
          YYCORB=YYCORB+AMPY(IRES)*AMPY(IRES)
          ZZCORB=ZZCORB+AMPZ(IRES)*AMPZ(IRES)
          XYCORB=XYCORB+AMPX(IRES)*AMPY(IRES)
          XZCORB=XZCORB+AMPX(IRES)*AMPZ(IRES)
          YZCORB=YZCORB+AMPY(IRES)*AMPZ(IRES)
C
          NB=NB+1
43      CONTINUE
41    CONTINUE
C
      AVB=AVB/NB
      VARB=(VARB/NB)-(AVB**2)
      SDB=SQRT(VARB)
C
      XAVB=XAVB/NB
      YAVB=YAVB/NB
      ZAVB=ZAVB/NB
      XXCORB=XXCORB/NB-(XAVB*XAVB)
      YYCORB=YYCORB/NB-(YAVB*YAVB)
      ZZCORB=ZZCORB/NB-(ZAVB*ZAVB)
      XYCORB=XYCORB/NB-(XAVB*YAVB)
      XZCORB=XZCORB/NB-(XAVB*ZAVB)
      YZCORB=YZCORB/NB-(YAVB*ZAVB)
C
      SIGMB(1,1)=XXCORB
      SIGMB(1,2)=XYCORB
      SIGMB(1,3)=XZCORB
      SIGMB(2,1)=XYCORB
      SIGMB(2,2)=YYCORB
      SIGMB(2,3)=YZCORB
      SIGMB(3,1)=XZCORB
      SIGMB(3,2)=YZCORB
      SIGMB(3,3)=ZZCORB
      CALL M_INV (SIGMB,INVSIGMB) 
C
C DETERMINE THE CONNECTIONS BETWEEN DOMAIN A AND B
C
      ICONA(IPAIR)=0
      ICONB(IPAIR)=0
      AEND=0
      BEND=0
      DO 11 IRES=1,NRES
        DO 22 IDOM=1,NDOM
          DO 33 ISEG=1,NSEG(IDOM)
            IF(IRESEND(IDOM,ISEG).EQ.IRES) THEN
              IF(IDOM.EQ.DOMA) AEND=ISEG
              IF(IDOM.EQ.DOMB) BEND=ISEG
C
C FOR ONE RESIDUE SEGMENTS
C
              IF(AEND.NE.0.AND.BEND.NE.0) THEN
C
C DETERMINE CONNECTING REGION FROM B TO A
C
                IF(IRESEND(DOMA,AEND).GT.IRESEND(DOMB,BEND)) THEN
                  ICONB(IPAIR)=ICONB(IPAIR)+1
C
                  IF(ICONB(IPAIR).GT.NCONPMX) THEN
                    WRITE(6,'(2A,I4,I4)')
     &                'ARRAY BOUNDARY FOR NUMBER OF CONNECTIONS BETWEEN'
     &                ,' DOMAINS HAS BEEN EXCEEDED: ',ICONB(IPAIR)
     *                ,NCONPMX
                    WRITE(6,'(A)')'CHANGE VALUE FOR "NCONPMX" IN "DynDom
     &.param"'
                    STOP
                  ENDIF
C
                  SEGENDB(ICONB(IPAIR))=BEND
                  SEGBEGA(ICONB(IPAIR))=AEND
                  BEND=0
                  GOTO 11
C
C DETERMINE CONNECTING REGION FROM A TO B
C
                ELSEIF(IRESEND(DOMB,BEND).GT.IRESEND(DOMA,AEND)) THEN
                  ICONA(IPAIR)=ICONA(IPAIR)+1
C
                  IF(ICONA(IPAIR).GT.NCONPMX) THEN
                    WRITE(6,'(2A,I4,I4)')
     &                'ARRAY BOUNDARY FOR NUMBER OF CONNECTIONS BETWEEN'
     &                ,' DOMAINS HAS BEEN EXCEEDED: ',ICONA(IPAIR)
     &                ,NCONPMX
                    WRITE(6,'(A)')'CHANGE VALUE FOR "NCONPMX" IN "DynDom
     &.param"'
                    STOP
                  ENDIF
C
                  SEGENDA(ICONA(IPAIR))=AEND
                  SEGBEGB(ICONA(IPAIR))=BEND
                  AEND=0
                  GOTO 11
                ENDIF
              ENDIF
              GOTO 11
            ENDIF
C
C DETERMINE CONNECTING REGION FROM B TO A
C
            IF(IRESBEG(IDOM,ISEG).EQ.IRES) THEN
              IF(IDOM.EQ.DOMA.AND.BEND.NE.0) THEN
                ICONB(IPAIR)=ICONB(IPAIR)+1
C
                  IF(ICONB(IPAIR).GT.NCONPMX) THEN
                    WRITE(6,'(2A,I4,I4)')
     &                'ARRAY BOUNDARY FOR NUMBER OF CONNECTIONS'
     &                ,' BETWEEN DOMAINS HAS BEEN EXCEEDED: '
     &                ,ICONB(IPAIR),NCONPMX
                    WRITE(6,'(A)')'CHANGE VALUE FOR "NCONPMX" IN "DynDom
     &.param"'
                    STOP
                  ENDIF
C
                SEGENDB(ICONB(IPAIR))=BEND
                SEGBEGA(ICONB(IPAIR))=ISEG
                AEND=0
                BEND=0
                GOTO 11
C
C DETERMINE CONNECTING REGION FROM A TO B
C
              ELSEIF(IDOM.EQ.DOMB.AND.AEND.NE.0) THEN
                ICONA(IPAIR)=ICONA(IPAIR)+1
C
                  IF(ICONA(IPAIR).GT.NCONPMX) THEN
                    WRITE(6,'(2A,I4,I4)')
     &                'ARRAY BOUNDARY FOR NUMBER OF CONNECTIONS BETWEEN'
     &                ,' DOMAINS HAS BEEN EXCEEDED: ',ICONA(IPAIR)
     &                ,NCONPMX
                    WRITE(6,'(A)')'CHANGE VALUE FOR "NCONPMX" IN "DynDom
     &.param"'
                    STOP
                  ENDIF
C
                SEGENDA(ICONA(IPAIR))=AEND
                SEGBEGB(ICONA(IPAIR))=ISEG
                AEND=0
                BEND=0
                GOTO 11
              ENDIF
              AEND=0
              BEND=0
            ENDIF
33        CONTINUE
22      CONTINUE
11    CONTINUE
C
C DETERMINE BEGINNING AND END RESIDUES FOR THE CROSSINGS FROM A TO B
C
      DO 66 IC=1,ICONA(IPAIR)
        BEGA(IPAIR,IC)=IRESEND(DOMA,SEGENDA(IC))
        DO 77 IRES=IRESEND(DOMA,SEGENDA(IC)),IRESBEG(DOMA,SEGENDA(IC))
     & ,-1
C
C CALCULATION OF Q
C
          QA=0.0
          AMPX(IRES)=AMPX(IRES)-XAVA
          AMPY(IRES)=AMPY(IRES)-YAVA
          AMPZ(IRES)=AMPZ(IRES)-ZAVA
          QA=QA+AMPX(IRES)*INVSIGMA(1,1)*AMPX(IRES)
          QA=QA+AMPX(IRES)*INVSIGMA(1,2)*AMPY(IRES)
          QA=QA+AMPX(IRES)*INVSIGMA(1,3)*AMPZ(IRES)
          QA=QA+AMPY(IRES)*INVSIGMA(2,1)*AMPX(IRES)
          QA=QA+AMPY(IRES)*INVSIGMA(2,2)*AMPY(IRES)
          QA=QA+AMPY(IRES)*INVSIGMA(2,3)*AMPZ(IRES)
          QA=QA+AMPZ(IRES)*INVSIGMA(3,1)*AMPX(IRES)
          QA=QA+AMPZ(IRES)*INVSIGMA(3,2)*AMPY(IRES)
          QA=QA+AMPZ(IRES)*INVSIGMA(3,3)*AMPZ(IRES)

          IF(QA.GE.4.6) THEN
            BEGA(IPAIR,IC)=IRES
          ELSE
            GOTO 67
          ENDIF
C
c         IF(PROJ(IRES).GE.(AVA+SDA)) THEN
c           BEGA(IPAIR,IC)=IRES
c         ELSE
c           GOTO 67
c         ENDIF
77      CONTINUE
67      CONTINUE
        ENDA(IPAIR,IC)=IRESBEG(DOMB,SEGBEGB(IC))
        DO 88 IRES=IRESBEG(DOMB,SEGBEGB(IC)),IRESEND(DOMB,SEGBEGB(IC))
C
C CALCULATION OF Q
C
          QB=0.0
          AMPX(IRES)=AMPX(IRES)-XAVB
          AMPY(IRES)=AMPY(IRES)-YAVB
          AMPZ(IRES)=AMPZ(IRES)-ZAVB
          QB=QB+AMPX(IRES)*INVSIGMB(1,1)*AMPX(IRES)
          QB=QB+AMPX(IRES)*INVSIGMB(1,2)*AMPY(IRES)
          QB=QB+AMPX(IRES)*INVSIGMB(1,3)*AMPZ(IRES)
          QB=QB+AMPY(IRES)*INVSIGMB(2,1)*AMPX(IRES)
          QB=QB+AMPY(IRES)*INVSIGMB(2,2)*AMPY(IRES)
          QB=QB+AMPY(IRES)*INVSIGMB(2,3)*AMPZ(IRES)
          QB=QB+AMPZ(IRES)*INVSIGMB(3,1)*AMPX(IRES)
          QB=QB+AMPZ(IRES)*INVSIGMB(3,2)*AMPY(IRES)
          QB=QB+AMPZ(IRES)*INVSIGMB(3,3)*AMPZ(IRES)
C
          IF(QB.GE.4.6) THEN
            ENDA(IPAIR,IC)=IRES
          ELSE
            GOTO 66
          ENDIF
C
c         IF(PROJ(IRES).LE.(AVB-SDB)) THEN
c           ENDA(IPAIR,IC)=IRES
c         ELSE
c           GOTO 66
c         ENDIF
88      CONTINUE
66    CONTINUE
C
C DETERMINE BEGINNING AND END RESIDUES FOR THE CROSSINGS FROM B TO A
C
      DO 16 IC=1,ICONB(IPAIR)
        BEGB(IPAIR,IC)=IRESEND(DOMB,SEGENDB(IC))
        DO 17 IRES=IRESEND(DOMB,SEGENDB(IC)),IRESBEG(DOMB,SEGENDB(IC))
     & ,-1
          QB=0.0
          AMPX(IRES)=AMPX(IRES)-XAVB
          AMPY(IRES)=AMPY(IRES)-YAVB
          AMPZ(IRES)=AMPZ(IRES)-ZAVB
          QB=QB+AMPX(IRES)*INVSIGMB(1,1)*AMPX(IRES)
          QB=QB+AMPX(IRES)*INVSIGMB(1,2)*AMPY(IRES)
          QB=QB+AMPX(IRES)*INVSIGMB(1,3)*AMPZ(IRES)
          QB=QB+AMPY(IRES)*INVSIGMB(2,1)*AMPX(IRES)
          QB=QB+AMPY(IRES)*INVSIGMB(2,2)*AMPY(IRES)
          QB=QB+AMPY(IRES)*INVSIGMB(2,3)*AMPZ(IRES)
          QB=QB+AMPZ(IRES)*INVSIGMB(3,1)*AMPX(IRES)
          QB=QB+AMPZ(IRES)*INVSIGMB(3,2)*AMPY(IRES)
          QB=QB+AMPZ(IRES)*INVSIGMB(3,3)*AMPZ(IRES)
C
          IF(QB.GE.4.6) THEN
            BEGB(IPAIR,IC)=IRES
          ELSE
            GOTO 27
          ENDIF
C
c         IF(PROJ(IRES).LE.(AVB-SDB)) THEN
c           BEGB(IPAIR,IC)=IRES
c         ELSE
c           GOTO 27
c         ENDIF
17      CONTINUE
27      CONTINUE
        ENDB(IPAIR,IC)=IRESBEG(DOMA,SEGBEGA(IC))
        DO 18 IRES=IRESBEG(DOMA,SEGBEGA(IC)),IRESEND(DOMA,SEGBEGA(IC))
C
C CALCULATION OF Q
C
          QA=0.0
          AMPX(IRES)=AMPX(IRES)-XAVA
          AMPY(IRES)=AMPY(IRES)-YAVA
          AMPZ(IRES)=AMPZ(IRES)-ZAVA
          QA=QA+AMPX(IRES)*INVSIGMA(1,1)*AMPX(IRES)
          QA=QA+AMPX(IRES)*INVSIGMA(1,2)*AMPY(IRES)
          QA=QA+AMPX(IRES)*INVSIGMA(1,3)*AMPZ(IRES)
          QA=QA+AMPY(IRES)*INVSIGMA(2,1)*AMPX(IRES)
          QA=QA+AMPY(IRES)*INVSIGMA(2,2)*AMPY(IRES)
          QA=QA+AMPY(IRES)*INVSIGMA(2,3)*AMPZ(IRES)
          QA=QA+AMPZ(IRES)*INVSIGMA(3,1)*AMPX(IRES)
          QA=QA+AMPZ(IRES)*INVSIGMA(3,2)*AMPY(IRES)
          QA=QA+AMPZ(IRES)*INVSIGMA(3,3)*AMPZ(IRES)
C
          IF(QA.GE.4.6) THEN
            ENDB(IPAIR,IC)=IRES
          ELSE
            GOTO 16
          ENDIF
C
c         IF(PROJ(IRES).GE.(AVA+SDA)) THEN
c           ENDB(IPAIR,IC)=IRES
c         ELSE
c           GOTO 16
c         ENDIF
18      CONTINUE
16    CONTINUE
C
C FOLLOWING IS PURELY TO MAKE OUTPUT LOOK NICE
C
      MSEG=0
      DO 1 I=1,ICONA(IPAIR)
        MSEG=MSEG+1
        SEGB(MSEG)=BEGA(IPAIR,I)
        SEGE(MSEG)=ENDA(IPAIR,I)
1     CONTINUE
C
      DO 2 I=1,ICONB(IPAIR)
        MSEG=MSEG+1
        SEGB(MSEG)=BEGB(IPAIR,I)
        SEGE(MSEG)=ENDB(IPAIR,I)
2     CONTINUE
C
      CALL SORT(MSEG,SEGB,SEGE)
C
      DO 3 ISEG=1,MSEG-1
        IF(SEGB(ISEG+1).LE.(SEGE(ISEG)+1)) THEN
          SEGB(ISEG+1)=SEGB(ISEG)
          SEGB(ISEG)=0
          SEGE(ISEG)=0
        ENDIF
3     CONTINUE
C
      WRITE(IOUT1,'(A)')'BENDING RESIDUES (coloured green for rasmol):'
      WRITE(IOUT1,'(A)')
C
      DO 48 ISEG=1,MSEG
        IF(SEGB(ISEG).EQ.0.AND.SEGE(ISEG).EQ.0) GOTO 48
        WRITE(IOUT1,'(A18,A5,A1,A5)')'BENDING RESIDUES: ',
     &   RESPDBNUM(SEGB(ISEG)),'-',RESPDBNUM(SEGE(ISEG))
48    CONTINUE
C
C CALL ROUTINE TO DETERMINE DIHEDRAL CONTRIBUTIONS
C
C     CALL DIHEDET5(IPAIR,ICONA,BEGA,ENDA,ICONB,BEGB,ENDB,RESPDBNUM,
C    & RESPDBTYP,UX,UY,UZ,XL,YL,ZL,AMPROT,MASS,COOBB1,COOBB2,NI,CA,CP,CB
C    & ,IOUT7,NRES)
C
      CALL DIHEDR(IPAIR,ICONA,BEGA,ENDA,ICONB,BEGB,ENDB,RESPDBNUM,
     & RESPDBTYP,UX,UY,UZ,XL,YL,ZL,AMPROT,MASS,COOBB1,COOBB2,NI,CA,CP,CB
     & ,IOUT7,NRES)
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C SUBROUTINE TO READ INPUT FILE AND INITIALIZE OUTPUT
C
      SUBROUTINE INOUTPUTR(IN1,IN2,IOUT1,IOUT3,IOUT4,IOUT6,
     &  IOUT7,CHAINID1,CHAINID2,NCLUSTER,ITER,DOMIN,WINDLEN,
     &   EXTCRIT,FILEIN1,IEND1,FILEIN2,IEND2)
C
      IMPLICIT NONE
C 
      include 'DynDom.param'
C
      INTEGER NCLUSTER,ITER,DOMIN,WINDLEN,J
      INTEGER IN,IN1,IN2,IOUT1,IOUT3,IOUT4,IOUT5,IOUT6,IOUT7
      INTEGER LENGTH,IEND,IEND1,IEND2,IEND4,IEND6
      INTEGER KEYEND,IARGC,ODDY
      REAL*8 EXTCRIT
      CHARACTER*200 INPO
      CHARACTER*1 CHAINID1,CHAINID2
      CHARACTER*200 TITLE,COMMAND 
      CHARACTER*200 FILEI,FILEIN1,FILEIN2
      CHARACTER*200 FILEO1,FILEO3,FILEO4,FILEO5,FILEO6,FILEO7
      LOGICAL NOTHING,TITLEY,FILE1Y,FILE2Y,CLUSY,ITERY,WINDLENY
      LOGICAL DOMINY,RATIOY
C
      IN=11
      IN1=12
      IN2=13
      IOUT1=14
      IOUT3=16
      IOUT4=17
      IOUT6=19
      IOUT7=20
C
      TITLEY=.FALSE.
      FILE1Y=.FALSE.
      FILE2Y=.FALSE.
      CLUSY=.FALSE.
      ITERY=.FALSE.
      WINDLENY=.FALSE.
      DOMINY=.FALSE.
      RATIOY=.FALSE.
C
      J=IARGC()
      CALL GETARG(J,FILEI)
C
      IF(J.EQ.0) THEN
        WRITE(6,'(A)')'command file name?'
        READ(5,'(A)')FILEI
      ELSEIF(J.EQ.1) THEN
      	CALL GETARG(1,FILEI)
      ELSE
        WRITE(6,*)'ONLY ARGUMENT REQUIRED IS THE COMMAND FILE NAME'
        STOP
      ENDIF
C
      WRITE(6,'(A)')'***************************************************
     &*****'
      WRITE(6,'(A)')'DynDom Reference:'
      WRITE(6,'(A)')
      WRITE(6,'(A)')'Hayward, S. and Berendsen, H.J.C.'
      WRITE(6,'(A)')'"Systematic Analysis of Domain Motions in Proteins'
      WRITE(6,'(A)')'from Conformational Change: New Results on Citrate'
      WRITE(6,'(A)')'Synthase and T4 Lysozyme."'
      WRITE(6,'(A)')'Proteins, Vol 30 144-154,1998'
      WRITE(6,'(A)')
      WRITE(6,'(A)')'***************************************************
     &*****'
      WRITE(6,'(A)')
      WRITE(6,'(A)')'Info on DynDom can be found at the DynDom HOME PAGE
     &'
      WRITE(6,'(A)')
      WRITE(6,'(A)')'http://www.sys.uea.ac.uk/~sjh/DynDom/dyndom.home.ht
     &ml'
      WRITE(6,'(A)')
      WRITE(6,'(A)')'***************************************************
     &*****'
C
      OPEN (IN,FILE=FILEI,STATUS='OLD',FORM='FORMATTED')
C
10    READ(IN,'(A)',END=20)INPO
      KEYEND=1
      CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
C
      IF(INPO((KEYEND):(KEYEND+4)).EQ.'title') THEN
        KEYEND=KEYEND+5
        CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
        IF(.NOT.NOTHING) THEN
          TITLEY=.TRUE.
          TITLE=INPO(KEYEND:)
        ENDIF
C
      ELSEIF(INPO((KEYEND):(KEYEND+8)).EQ.'filename1') THEN
        KEYEND=KEYEND+9
        CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
        IF(.NOT.NOTHING) THEN
          FILE1Y=.TRUE.
          FILEIN1=INPO(KEYEND:)
        ENDIF
C
      ELSEIF(INPO((KEYEND):(KEYEND+7)).EQ.'chain1id') THEN
        KEYEND=KEYEND+8
        CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
        CHAINID1=INPO(KEYEND:)
C
      ELSEIF(INPO((KEYEND):(KEYEND+8)).EQ.'filename2') THEN
        KEYEND=KEYEND+9
        CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
        IF(.NOT.NOTHING) THEN
          FILE2Y=.TRUE.
          FILEIN2=INPO(KEYEND:)
        ENDIF
C
      ELSEIF(INPO((KEYEND):(KEYEND+7)).EQ.'chain2id') THEN
        KEYEND=KEYEND+8
        CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
        CHAINID2=INPO(KEYEND:)
C
      ELSEIF(INPO((KEYEND):(KEYEND+7)).EQ.'clusters') THEN
        KEYEND=KEYEND+8
        CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
        IF(.NOT.NOTHING) THEN
          CLUSY=.TRUE.
          READ(INPO(KEYEND:),*)NCLUSTER
          IF(NCLUSTER.LE.0) CLUSY=.FALSE.
        ENDIF
C
      ELSEIF(INPO((KEYEND):(KEYEND+9)).EQ.'iterations') THEN
        KEYEND=KEYEND+10
        CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
        IF(.NOT.NOTHING) THEN
          ITERY=.TRUE.
          READ(INPO(KEYEND:),*)ITER
          IF(ITER.LE.0) ITERY=.FALSE.
        ENDIF
C
      ELSEIF(INPO((KEYEND):(KEYEND+5)).EQ.'window') THEN
        KEYEND=KEYEND+6
        CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
        IF(.NOT.NOTHING) THEN
          WINDLENY=.TRUE.
          READ(INPO(KEYEND:),*)WINDLEN
          ODDY=(WINDLEN/2)*2
          IF(WINDLEN.EQ.ODDY.AND.WINDLEN.GT.0) THEN
            WRITE(6,'(A,I3)')'SORRY WINDOW LENGTH MUST BE ODD AS CENTRAL
     & RESIDUE MUST BE DEFINED; SET TO: ',WINDLEN-1
            WINDLEN=WINDLEN-1
          ENDIF
          IF(WINDLEN.LE.0) WINDLENY=.FALSE.
        ENDIF
C
      ELSEIF(INPO((KEYEND):(KEYEND+4)).EQ.'ratio') THEN
        KEYEND=KEYEND+5
        CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
        IF(.NOT.NOTHING) THEN
          RATIOY=.TRUE.
          READ(INPO(KEYEND:),*)EXTCRIT
          IF(EXTCRIT.LE.0) RATIOY=.FALSE.
          IF(EXTCRIT.LT.1.0) THEN
             WRITE(6,'(A)')
             WRITE(6,'(A)')'WARNING "ratio" < 1.0'
             WRITE(6,'(A)')'THE LOWER THE VALUE OF "ratio",THE LESS'
             WRITE(6,'(A)')'MEANINGFUL YOUR RESULTS WILL BECOME'
             WRITE(6,'(A)')
          ENDIF
        ENDIF
C
      ELSEIF(INPO((KEYEND):(KEYEND+5)).EQ.'domain') THEN
        KEYEND=KEYEND+6
        CALL SPACEREMOVE(INPO,KEYEND,NOTHING)
        IF(.NOT.NOTHING) THEN
          DOMINY=.TRUE.
          READ(INPO(KEYEND:),*)DOMIN
          IF(DOMIN.LE.0) THEN
            DOMINY=.FALSE.
          ENDIF
        ENDIF
C
      ENDIF
C
      GOTO 10  
C
20    CONTINUE
C
      IF(.NOT.TITLEY) THEN
        WRITE(6,'(A)')'WARNING NO TITLE; PLEASE GIVE ONE'
        READ(5,'(A)')TITLE
      ENDIF
C
      IF(.NOT.FILE1Y) THEN
        WRITE(6,'(A)')'NO FILENAME FOR CONFORMER 1'
        STOP
      ENDIF
C
      IF(.NOT.FILE2Y) THEN
        WRITE(6,'(A)')'NO FILENAME FOR CONFORMER 2'
        STOP
      ENDIF
C
      IF(.NOT.CLUSY) THEN
CC      WRITE(6,'(A)')'SETTING DEFAULT VALUE FOR NO OF CLUSTERS=20'
        NCLUSTER=20
      ENDIF
C
      IF(.NOT.ITERY) THEN
CC      WRITE(6,'(A)')'SETTING DEFAULT VALUE FOR NO OF ITERATIONS=100'
        ITER=100
      ENDIF
C
      IF(.NOT.WINDLENY) THEN
        WRITE(6,'(A)')'SETTING DEFAULT VALUE FOR WINDOW LENGTH=5'
        WINDLEN=5
      ENDIF
C
      IF(.NOT.RATIOY) THEN
        WRITE(6,'(A)')'SETTING DEFAULT VALUE FOR RATIO=1.0'
        EXTCRIT=1.0
      ENDIF
C
      IF(.NOT.DOMINY) THEN
        WRITE(6,'(A)')'MINIMUM DOMAIN SIZE WILL BE SET TO 20 RESIDUES'
        DOMIN=20
      ENDIF
C
C OPEN PDB FILES
C
      OPEN (IN1,FILE=FILEIN1,STATUS='OLD',FORM='FORMATTED')
      IF(FILEIN1.NE.FILEIN2) THEN  
        OPEN(IN2,FILE=FILEIN2,STATUS='OLD',FORM='FORMATTED')
      ELSE
        IN2=IN1
      ENDIF
C
      LENGTH=LEN(TITLE)
      CALL STRINGLENGTH(TITLE,LENGTH,IEND)
      FILEO1=TITLE(1:IEND)//'_info'
      FILEO3=TITLE(1:IEND)//'_rasscript'
      FILEO4=TITLE(1:IEND)//'_rotvecs'
      FILEO6=TITLE(1:IEND)//'_pdb'
      FILEO7=TITLE(1:IEND)//'_dihedral'
C
C OPEN OUTPUT FILES
C
      OPEN (IOUT1,FILE=FILEO1,STATUS='UNKNOWN',FORM='FORMATTED')
      WRITE(IOUT1,'(A)')'DynDom Version 1.5'
      WRITE(IOUT1,'(A)')TITLE(1:IEND)
C
      WRITE(IOUT1,'(A,F5.1,A)')'cutoff for definition for effective hing
     &e axis and mechanical hinge: ',EFFCUT,' A'
C
      WRITE(IOUT1,'(A,F5.1,A)')'distance criterion for a pair of atoms t
     &o be in contact: ',DISTCRIT,' A'
C
      LENGTH=LEN(FILEIN1)
      CALL STRINGLENGTH(FILEIN1,LENGTH,IEND1)
      WRITE(IOUT1,'(A26,A)')'file name of conformer 1: ',
     & FILEIN1(1:IEND1)
      WRITE(IOUT1,'(A10,A)')'chain id: ',CHAINID1
C
      LENGTH=LEN(FILEIN2)
      CALL STRINGLENGTH(FILEIN2,LENGTH,IEND2)
      WRITE(IOUT1,'(A26,A)')'file name of conformer 2: ',
     & FILEIN2(1:IEND2)
      WRITE(IOUT1,'(A10,A)')'chain id: ',CHAINID2
C
      WRITE(IOUT1,'(A15,I4)')'window length: ',WINDLEN
      WRITE(IOUT1,'(A45,F8.3)')'minimum ratio of external to internal mo
     &tion: ',EXTCRIT
      WRITE(IOUT1,'(A20,I4)')'minimum domain size: ',DOMIN
C
      OPEN (IOUT3,FILE=FILEO3,STATUS='UNKNOWN',FORM='FORMATTED')
      WRITE(IOUT3,'(A)')'#DynDom Version 1.5'
      WRITE(IOUT3,'(A)')'#'//TITLE(1:IEND)
C
      OPEN (IOUT4,FILE=FILEO4,STATUS='UNKNOWN',FORM='FORMATTED')
      WRITE(IOUT4,'(A)')'DynDom Version 1.5'
      WRITE(IOUT4,'(A)')TITLE(1:IEND)
C
      OPEN (IOUT6,FILE=FILEO6,STATUS='UNKNOWN',FORM='FORMATTED')
      WRITE(IOUT6,'(A)')'DynDom Version 1.5'
      WRITE(IOUT6,'(A)')TITLE(1:IEND)
C
      OPEN (IOUT7,FILE=FILEO7,STATUS='UNKNOWN',FORM='FORMATTED')
      WRITE(IOUT7,'(A)')'DynDom Version 1.5'
      WRITE(IOUT7,'(A)')TITLE(1:IEND)
C
      WRITE(IOUT7,'(A)')'A: rotation of psi dihedral at 1st residue'
      WRITE(IOUT7,'(A)')'B: rotation of phi dihedral at 2nd residue'
      WRITE(IOUT7,'(A)')'F: scalar product of psi dihedral axis of 1st r
     &esidue in 1st conformation with screw axis'
      WRITE(IOUT7,'(A)')'G: scalar product of phi dihedral axis of 2nd r
     &esidue in 1st conformation with screw axis'
      WRITE(IOUT7,'(A)')'H: scalar product of psi dihedral axis of 1st r
     &esidue in 2nd conformation with screw axis'
      WRITE(IOUT7,'(A)')'I: scalar product of phi dihedral axis of 2nd r
     &esidue in 2nd conformation with screw axis'
      WRITE(IOUT7,'(A)')'all angles in degrees'
C
      CLOSE(IN)
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C SUBROUTINE TO JOIN SEGMENTS IF THEY ARE CLOSER THAN 
C GAPLEN
C
           SUBROUTINE JOINSEG(NDOM,NSEG,IRESBEG,IRESEND,NONDOM,
     &     NONSEG,NONRESBEG,NONRESEND,GAPLEN)
C
           IMPLICIT NONE
C
           include 'DynDom.param'
C
           INTEGER IRESBEG(NDOMX,*),IRESEND(NDOMX,*),NSEG(NDOMX)
           INTEGER NONRESBEG(NDOMX,*),NONRESEND(NDOMX,*),NONSEG(NDOMX)
           INTEGER IRESBEGN(NSEGMX),IRESENDN(NSEGMX)
           INTEGER NONDOM,NDOM,NSEGN(NDOMX),MDOM,MSEG
           INTEGER IDOM,ISEG,ENDPTR(0:NSEGMX),I,J,K,IGAP,GAPLEN
           INTEGER KSEG,SEGB(NRESMX),SEGE(NRESMX)
           INTEGER PTR(0:NSEGMX)
           LOGICAL NON
C
C JOIN UP THE SEGMENTS OF DOMAINS ELIMINATED BY SEGCONNET
C
           KSEG=0
           DO 301 MDOM=1,NONDOM
             DO 302 MSEG=1,NONSEG(MDOM)       
               KSEG=KSEG+1
               SEGB(KSEG)=NONRESBEG(MDOM,MSEG)
               SEGE(KSEG)=NONRESEND(MDOM,MSEG)
302          CONTINUE
301        CONTINUE
C
           CALL SORT(KSEG,SEGB,SEGE)
C
           DO 5 ISEG=1,KSEG-1
             IF(SEGB(ISEG+1).LE.(SEGE(ISEG)+1)) THEN
               SEGB(ISEG+1)=SEGB(ISEG)
               SEGB(ISEG)=0
               SEGE(ISEG)=0
             ENDIF
5          CONTINUE
C
           DO 100 IDOM=1,NDOM
C
             ENDPTR(0)=0
             PTR(0)=0
             DO 7 I=1,NSEGMX
               ENDPTR(I)=0
               PTR(I)=I
               IRESBEGN(I)=0
               IRESENDN(I)=0
7            CONTINUE
C
C FOLLOWING CONVERTS THOSE REGIONS LESS THAN GAPLEN TO THE
C DOMAIN THEY ARE EMBEDDED IN ONLY IF THEY ARE REGIONS ELIMINATED 
C BY SEGCONNECT, I.E. THEY ARE REGIONS LESS THAN GAPLEN
C
             DO 102 ISEG=1,NSEG(IDOM)-1
               NON=.FALSE.
               DO 201 MSEG=1,KSEG
                 IF(SEGB(MSEG).EQ.(IRESEND(IDOM,ISEG)+1).
     &AND.(SEGE(MSEG)+1).EQ.IRESBEG(IDOM,ISEG+1)) THEN
                     NON=.TRUE.
                     GOTO 99
                   ENDIF
201            CONTINUE 
99             CONTINUE
C
               IGAP=IRESBEG(IDOM,ISEG+1)-IRESEND(IDOM,ISEG)-1
               IF(IGAP.LE.GAPLEN.AND.NON) THEN
                 ENDPTR(ISEG+1)=ISEG
	       ENDIF
               K=ISEG+1
1              CONTINUE
               K=ENDPTR(K)
               IF(K.NE.0) THEN
                 PTR(K)=ISEG+1
                 GOTO 1
               ENDIF
102          CONTINUE
C
             I=0
             J=0
2            CONTINUE
             I=I+1
             J=J+1
             IRESBEGN(J)=IRESBEG(IDOM,I)
             I=PTR(I)
             IRESENDN(J)=IRESEND(IDOM,I)
             IF(I.LT.NSEG(IDOM)) GOTO 2
             NSEG(IDOM)=J
C
             DO 3 I=1,NSEG(IDOM)
               IRESBEG(IDOM,I)=IRESBEGN(I)
               IRESEND(IDOM,I)=IRESENDN(I)
3            CONTINUE
C
100        CONTINUE
C
         RETURN         
         END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C

      SUBROUTINE KMEANS(N, X, K, DMSUM1, DMSUM2, SUM, JMIN, DMIN)
C
      IMPLICIT NONE
C
      INTEGER DMSUM1,DMSUM2,N,K,JMIN,J,I
      REAL*8 SUM(DMSUM1,DMSUM2,*),X(*),DMIN,DD
C
      JMIN=1
      DMIN=1.0D08
C
C     CALCULATE DISTANCE TO EACH CLUSTER CENTER
C
      DO 20 J=1,K
         DD=0.
         DO 10 I=1,N
            DD=DD+(X(I)-SUM(1,I,J))**2
   10    CONTINUE
         DD=(DD)**0.5
         IF(DD.LE.DMIN) THEN
            DMIN=DD
            JMIN=J
         ENDIF
   20 CONTINUE
C
C     UPDATE SUMMARY STATISTICS FOR CHOSEN CLUSTER
C
      DO 30 I=1,N
         CALL SINGLE(X(I),SUM(2,I,JMIN),SUM(3,I,JMIN),
     *      SUM(4,I,JMIN),SUM(5,I,JMIN),SUM(6,I,JMIN),SUM(7,I,JMIN))
   30 CONTINUE
      RETURN
      END
C
C ROUTINE TO CALCULATE THE DISTANCE BETWEEN TWO LINES
C
        SUBROUTINE LINEDIST(UX1,UY1,UZ1,UX2,UY2,UZ2,X1,Y1,Z1
     &,X2,Y2,Z2,DIST)
C
        IMPLICIT NONE
C
        REAL*8 UX1,UY1,UZ1,UX2,UY2,UZ2,X1,Y1,Z1,X2,Y2,Z2,DIST
        REAL*8 P,PX,PY,PZ,DX,DY,DZ
C
        PX=UY1*UZ2-UZ1*UY2
        PY=UZ1*UX2-UX1*UZ2
        PZ=UX1*UY2-UY1*UX2
        P=SQRT(PX**2+PY**2+PZ**2)
        PX=PX/P
        PY=PY/P
        PZ=PZ/P
        DX=X1-X2
        DY=Y1-Y2
        DZ=Z1-Z2
        DIST=DX*PX+DY*PY+DZ*PZ
        DIST=ABS(DIST)
C
        RETURN
        END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
      SUBROUTINE M_INV (SRC,DEST)
  
      IMPLICIT NONE
C 
      REAL*8 SRC(3,3),DEST(3,3)
      REAL*8 SMALLREAL,LARGEREAL
      REAL*8 DETER,C,FC
  
      SMALLREAL=1.0D-90
      LARGEREAL=1.0D90
  
      CALL DET (SRC,DETER)
      C=1.0/DETER
      FC=ABS(C)
  
      IF ((FC.LE.SMALLREAL).OR.(FC.GE.LARGEREAL)) THEN
        WRITE(6,'(A,E12.5)')'FATAL ERROR: DETERMINANT IS WEIRD: ',DETE
     &R
        STOP
      END IF
  
      DEST(1,1)=C*(SRC(2,2)*SRC(3,3)-SRC(3,2)*SRC(2,3))
      DEST(1,2)=-C*(SRC(1,2)*SRC(3,3)-SRC(3,2)*SRC(1,3))
      DEST(1,3)=C*(SRC(1,2)*SRC(2,3)-SRC(2,2)*SRC(1,3))
      DEST(2,1)=-C*(SRC(2,1)*SRC(3,3)-SRC(3,1)*SRC(2,3))
      DEST(2,2)=C*(SRC(1,1)*SRC(3,3)-SRC(3,1)*SRC(1,3))
      DEST(2,3)=-C*(SRC(1,1)*SRC(2,3)-SRC(2,1)*SRC(1,3))
      DEST(3,1)=C*(SRC(2,1)*SRC(3,2)-SRC(3,1)*SRC(2,2))
      DEST(3,2)=-C*(SRC(1,1)*SRC(3,2)-SRC(3,1)*SRC(1,2))
      DEST(3,3)=C*(SRC(1,1)*SRC(2,2)-SRC(2,1)*SRC(1,2))
  
      RETURN
      END
C 
C ROUTINE TO MODEL CB ATOM ON A GLYCINE
C
      SUBROUTINE MODCBETA(COO)
C
      IMPLICIT NONE
C
      REAL*8 COO(3,*),XX,XY,XZ,YX,YY,YZ,ZX,ZY,ZZ
      REAL*8 DIST,CACX,CACY,CACZ,CBX,CBY,CBZ
C
      XX=COO(1,1)-COO(1,2)
      XY=COO(2,1)-COO(2,2)
      XZ=COO(3,1)-COO(3,2)
C
      DIST=XX**2+XY**2+XZ**2
      DIST=SQRT(DIST)
C
      XX=XX/DIST
      XY=XY/DIST
      XZ=XZ/DIST
C
      CACX=COO(1,3)-COO(1,2)
      CACY=COO(2,3)-COO(2,2)
      CACZ=COO(3,3)-COO(3,2)
C
      CALL VECPROD(XX,XY,XZ,CACX,CACY,CACZ,ZX,ZY,ZZ)
C
      DIST=ZX**2+ZY**2+ZZ**2
      DIST=SQRT(DIST)
C
      ZX=ZX/DIST
      ZY=ZY/DIST
      ZZ=ZZ/DIST
C
      CALL VECPROD(ZX,ZY,ZZ,XX,XY,XZ,YX,YY,YZ)
C
      CBX=-0.4634449489765239
      CBY=-0.7956993679322285
      CBZ=1.224484501796736
C
      COO(1,4)=COO(1,2)+(CBX*XX+CBY*YX+CBZ*ZX)
      COO(2,4)=COO(2,2)+(CBX*XY+CBY*YY+CBZ*ZY)
      COO(3,4)=COO(3,2)+(CBX*XZ+CBY*YZ+CBZ*ZZ)
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C ROUTINE TO READ PDB FILE
C 
      SUBROUTINE READPDB(IN,NATOT,CHAINID,ATYP,RESTYP,
     1RESNUM,COO)
C 
      IMPLICIT NONE
C
      include 'DynDom.param'
C 
      INTEGER IN,IAT,NATOT
      CHARACTER*54 WHOLINE
      CHARACTER*4 INIR
      CHARACTER*3 INI
      CHARACTER*1 CHAINIDR
      CHARACTER*4 ATYP(*)
      CHARACTER*4 RESTYP(*)
      CHARACTER*1 CHAINID
      CHARACTER*5 RESNUM(*)
      REAL*8 COO(3,*)
C 
      IAT=0
      NATOT=0
10    READ (IN,'(A)',END=20) WHOLINE
      READ(WHOLINE(1:),'(A)')INIR
      READ(INIR,'(A)')INI
      READ(WHOLINE(22:),'(A)')CHAINIDR	 
      IF(INI.EQ.'TER'.AND.IAT.NE.0) GOTO 20 
      IF (INIR.EQ.'ATOM'.AND.CHAINIDR.EQ.CHAINID) THEN
        IAT=IAT+1
        IF(IAT.GT.NUMATMX) THEN
          WRITE(6,'(A54,I4,I4)')'ARRAY BOUNDARY FOR NUMBER OF ATOMS HAS 
     &BEEN EXCEEDED: ',NUMATMX,IAT
          WRITE(6,'(A)')'CHANGE VALUE OF " NUMATMX" IN "DynDom.param"'
          STOP
        ENDIF
        READ(WHOLINE(14:),'(A)')ATYP(IAT)
        READ(WHOLINE(18:),'(A)')RESTYP(IAT)
        READ(WHOLINE(23:),'(A)')RESNUM(IAT)
        READ(WHOLINE(31:),40)COO(1,IAT),COO(2,IAT),COO(3,IAT)
      END IF
      GOTO 10
C 
20    CONTINUE
C
      NATOT=IAT
C
      REWIND(IN)
C
      RETURN
40    FORMAT (3F8.3)
      END
C
C-------------------------------------------------------------
C
C                       
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
      SUBROUTINE RESIDEN(NATOT,RESTYP,RESNUM,NRES,
     & RESPDBNUM,RESPDBTYP,NAAT,ATLIST)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER IRES,IAT,NATOT,NRES,IAAT
      INTEGER NAAT(*),ATLIST(NRESMX,*)
      CHARACTER*5 RESN
      CHARACTER*4 RESTYP(*)
      CHARACTER*4 RESPDBTYP(*)
      CHARACTER*5 RESNUM(*)
      CHARACTER*5 RESPDBNUM(*)
      CHARACTER*1 LETTER
C
      IRES=0
      IAAT=0
      DO 1 IAT=1,NATOT
        IF(IAT.EQ.1) THEN
          RESN='    '
        ELSE
          RESN=RESNUM(IAT-1)
        ENDIF
        IF(RESNUM(IAT).NE.RESN) THEN
          IF(IAAT.NE.0) NAAT(IRES)=IAAT
          IAAT=1
          IRES=IRES+1
          READ(RESNUM(IAT)(5:5),'(A)')LETTER
          IF(LETTER.NE.' ') THEN
            WRITE(6,'(A,A5)')'WARNING RESIDUE NUMBERS HAVE LETTERS; CANN
     &OT COLOUR CORRECTLY WITH RASMOL',RESNUM(IAT)
          ENDIF
C
          IF(IRES.GT.NRESMX) THEN
            WRITE(6,'(A57,I4,I4)')'ARRAY BOUNDARY FOR NUMBER OF RESIDUES
     & HAS BEEN EXCEEDED: ',NRESMX,IRES
            WRITE(6,'(A)')'CHANGE VALUE OF "NRESMX" IN "DynDom.param"' 
            STOP
          ENDIF
C
          RESPDBTYP(IRES)=RESTYP(IAT)
          RESPDBNUM(IRES)=RESNUM(IAT)
          ATLIST(IRES,IAAT)=IAT
        ELSE
          IAAT=IAAT+1
          IF(IAAT.GT.NAATMX) THEN
            WRITE(6,'(A66,I4,I4)')'ARRAY BOUNDARY FOR NUMBER OF ATOMS IN
     & A RESIDUE HAS BEEN EXCEEDED: ',NAATMX,IAAT
            WRITE(6,'(A9,A4)')'RESIDUE: ',RESNUM(IAT)
            WRITE(6,'(A)')'CHANGE VALUE OF "NAATMX" IN "DynDom.param"'
            STOP
          ENDIF
          ATLIST(IRES,IAAT)=IAT
        ENDIF
1     CONTINUE
C
      NAAT(IRES)=IAAT
      NRES=IRES
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C SUBROUTINE TO CALCULATE ROTATION VECTOR AT RESIDUE BY
C CALCUALTING CURL AT N-CA-CB-C TETRAHEDRON
C 
      SUBROUTINE ROTVEC (IAT1,IAT2,IAT3,IAT4,CO,V,TRACER,AMPTHET,
     &                    UNTHX,UNTHY,UNTHZ)
C 
      IMPLICIT NONE
C 
      INTEGER I,J,IAT1,IAT2,IAT3,IAT4
      REAL*8 V(*)
      REAL*8 CO(3,*),CURLX,CURLY,CURLZ
      REAL*8 THEX,THEY,THEZ
      REAL*8 DMATRIX(3,3),DINV(3,3)
      REAL*8 DVX(3),DVY(3),DVZ(3)
      REAL*8 DX(3),DY(3),DZ(3)
      REAL*8 TRACER,COSINE,AMPTHET,UNTHX,UNTHY,UNTHZ
C 
      DMATRIX(1,1)=CO(1,IAT2)-CO(1,IAT1)
      DMATRIX(1,2)=CO(2,IAT2)-CO(2,IAT1)
      DMATRIX(1,3)=CO(3,IAT2)-CO(3,IAT1)
      DMATRIX(2,1)=CO(1,IAT3)-CO(1,IAT1)
      DMATRIX(2,2)=CO(2,IAT3)-CO(2,IAT1)
      DMATRIX(2,3)=CO(3,IAT3)-CO(3,IAT1)
      DMATRIX(3,1)=CO(1,IAT4)-CO(1,IAT1)
      DMATRIX(3,2)=CO(2,IAT4)-CO(2,IAT1)
      DMATRIX(3,3)=CO(3,IAT4)-CO(3,IAT1)
      CALL M_INV (DMATRIX,DINV)
C 
C CHANGE IN X-COMPONENT
C 
      DVX(1)=V(2*3-2)-V(1*3-2)
      DVX(2)=V(3*3-2)-V(1*3-2)
      DVX(3)=V(4*3-2)-V(1*3-2)
C 
      DX(1)=0.0
      DX(2)=0.0
      DX(3)=0.0
      DO 20 I=1,3
        DO 10 J=1,3
          DX(I)=DX(I)+DINV(I,J)*DVX(J)
10      CONTINUE
20    CONTINUE
C 
C CHANGE IN Y-COMPONENT
C 
      DVY(1)=V(2*3-1)-V(1*3-1)
      DVY(2)=V(3*3-1)-V(1*3-1)
      DVY(3)=V(4*3-1)-V(1*3-1)
C 
      DY(1)=0.0
      DY(2)=0.0
      DY(3)=0.0
      DO 40 I=1,3
        DO 30 J=1,3
          DY(I)=DY(I)+DINV(I,J)*DVY(J)
30      CONTINUE
40    CONTINUE
C 
C CHANGE IN Z-COMPONENT
C 
      DVZ(1)=V(2*3)-V(1*3)
      DVZ(2)=V(3*3)-V(1*3)
      DVZ(3)=V(4*3)-V(1*3)
C 
      DZ(1)=0.0
      DZ(2)=0.0
      DZ(3)=0.0
      DO 60 I=1,3
        DO 50 J=1,3
          DZ(I)=DZ(I)+DINV(I,J)*DVZ(J)
50      CONTINUE
60    CONTINUE
C 
C CALCULATE CURL
C 
      CURLX=DZ(2)-DY(3)
      CURLY=DX(3)-DZ(1)
      CURLZ=DY(1)-DX(2)
C 
      THEX=CURLX/2.0
      THEY=CURLY/2.0
      THEZ=CURLZ/2.0
C 
      AMPTHET=SQRT(THEX**2+THEY**2+THEZ**2)
      UNTHX=THEX/AMPTHET
      UNTHY=THEY/AMPTHET
      UNTHZ=THEZ/AMPTHET
      COSINE=(TRACER-1)*0.5
      AMPTHET=ACOS(COSINE)
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C ROUTINE TO FIT TWO CONFORMATIONS AND CALCULATE ROTATION VECTORS 
C FOR EACH WINDOW SEGMENT
C
      SUBROUTINE ROTVECFIELD(NBB,NRES,IDOM,NSEG,IRESBEG,IRESEND,NI,CA,
     & CP,CB,WINDLEN,COOBB1,COOBB2,ROT,AMPTHET,AMPTHETAV,MASS,RMSDW) 
C
      IMPLICIT NONE
C
      include 'DynDom.param'           
C
      INTEGER WINDLEN,IDOM,NSEG(*),IRESBEG(NDOMX,*),IRESEND(NDOMX,*)
      INTEGER NBB,NRES,NI(*),CA(*),CP(*),CB(*),IRES
      INTEGER NWIND,IWIND,IB,IAT1,IAT2,IAT3,IAT4,NBBWIND
      REAL*8 COOBB1(3,*),COOBB2(3,*),MASS(*) 
      REAL*8 ROT(NRESMX,*),AMP,AMPTHET(*),AMPTHETAV
      REAL*8 COBB1(3,NBBMX),COBB2(3,NBBMX)
      REAL*8 VEXT(12),VEXTMSF,VINTMSF,VMSF,TRACER  
      REAL*8 UNTHX,UNTHY,UNTHZ,RMSD,RMSDW  
C
      CALL FITDOM(NBB,IDOM,NSEG,IRESBEG,IRESEND,NI,CA,CP,CB,
     & COOBB1,COOBB2,MASS,RMSDW)
C
      NWIND=NRES-WINDLEN+1
C
      AMPTHETAV=0.0
      DO 50 IWIND=1,NWIND
C
C DETERMINE BACKBONE ATOMS FOR EACH WINDOW
C
        IB=0
        DO 20 IRES=IWIND,IWIND+WINDLEN-1
          IB=IB+1
          IAT1=IB
          COBB1(1,IB)=COOBB1(1,NI(IRES))
          COBB1(2,IB)=COOBB1(2,NI(IRES))
          COBB1(3,IB)=COOBB1(3,NI(IRES))
          COBB2(1,IB)=COOBB2(1,NI(IRES))
          COBB2(2,IB)=COOBB2(2,NI(IRES))
          COBB2(3,IB)=COOBB2(3,NI(IRES))
          IB=IB+1
          IAT2=IB
          COBB1(1,IB)=COOBB1(1,CA(IRES))
          COBB1(2,IB)=COOBB1(2,CA(IRES))
          COBB1(3,IB)=COOBB1(3,CA(IRES))
          COBB2(1,IB)=COOBB2(1,CA(IRES))
          COBB2(2,IB)=COOBB2(2,CA(IRES))
          COBB2(3,IB)=COOBB2(3,CA(IRES))
          IB=IB+1
          IAT3=IB
          COBB1(1,IB)=COOBB1(1,CP(IRES))
          COBB1(2,IB)=COOBB1(2,CP(IRES))
          COBB1(3,IB)=COOBB1(3,CP(IRES))
          COBB2(1,IB)=COOBB2(1,CP(IRES))
          COBB2(2,IB)=COOBB2(2,CP(IRES))
          COBB2(3,IB)=COOBB2(3,CP(IRES))
          IB=IB+1
          IAT4=IB
          COBB1(1,IB)=COOBB1(1,CB(IRES))
          COBB1(2,IB)=COOBB1(2,CB(IRES))
          COBB1(3,IB)=COOBB1(3,CB(IRES))
          COBB2(1,IB)=COOBB2(1,CB(IRES))
          COBB2(2,IB)=COOBB2(2,CB(IRES))
          COBB2(3,IB)=COOBB2(3,CB(IRES))
20      CONTINUE
C
        NBBWIND=IB
C
C DETERMINE EXTERNAL COMPONENT TO MOTION
C
        CALL EXTCOMP2(NBBWIND,IAT1,IAT2,IAT3,IAT4,MASS,COBB1,COBB2,
     & VEXT,VEXTMSF,VINTMSF,VMSF,TRACER,RMSD)
C
C DETERMINE ROTATION VECTOR
C
        CALL ROTVEC(IAT1,IAT2,IAT3,IAT4,COBB1,VEXT,TRACER,AMP,
     &              UNTHX,UNTHY,UNTHZ)
C
        AMPTHET(IWIND)=AMP
        ROT(IWIND,1)=UNTHX*AMP
        ROT(IWIND,2)=UNTHY*AMP
        ROT(IWIND,3)=UNTHZ*AMP
C
        AMPTHETAV=AMPTHETAV+AMP
C
50    CONTINUE
C
      AMPTHETAV=AMPTHETAV/NWIND
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------

C
C ROUTINE TO DETERMINE SCREW AXES OF DYNAMICAL DOMAINS
C
        SUBROUTINE SCREWAX(IAT1,IAT2,IAT3,IAT4,CO,V,AMPTHET,
     &                     UNTHX,UNTHY,UNTHZ,AMPTR,XAX1,YAX1,ZAX1)
C
       IMPLICIT NONE
C
       include 'DynDom.param'
C
       INTEGER IAT1,IAT2,IAT3,IAT4,M
       REAL*8 V(*),COMP1,COMP2,COMP3,COMP4
       REAL*8 TRPARX1,TRPARY1,TRPARZ1,TRPARX2,TRPARY2,TRPARZ2
       REAL*8 TRPARX3,TRPARY3,TRPARZ3,TRPARX4,TRPARY4,TRPARZ4
       REAL*8 ROTX1,ROTY1,ROTZ1,ROTX2,ROTY2,ROTZ2,ROTX3,ROTY3,ROTZ3
       REAL*8 ROTX4,ROTY4,ROTZ4,AMPROT1,AMPROT2,AMPROT3,AMPROT4
       REAL*8 UNROTX1,UNROTY1,UNROTZ1,UNROTX2,UNROTY2,UNROTZ2
       REAL*8 UNROTX3,UNROTY3,UNROTZ3,UNROTX4,UNROTY4,UNROTZ4
       REAL*8 AXIX1,AXIY1,AXIZ1,AXIX2,AXIY2,AXIZ2
       REAL*8 AXIX3,AXIY3,AXIZ3,AXIX4,AXIY4,AXIZ4
       REAL*8 RAXIX1,RAXIY1,RAXIZ1,RAXIX2,RAXIY2,RAXIZ2
       REAL*8 RAXIX3,RAXIY3,RAXIZ3,RAXIX4,RAXIY4,RAXIZ4
       REAL*8 XAX1,YAX1,ZAX1,XAX2,YAX2,ZAX2
       REAL*8 XAX3,YAX3,ZAX3,XAX4,YAX4,ZAX4
       REAL*8 CO(3,*),HTAN,DIST,AMPTR
       REAL*8 UNTHX,UNTHY,UNTHZ,AMPTHET 
C
          M=0
C
          COMP1=V(1*3-2)*UNTHX+V(1*3-1)*UNTHY+V(1*3)*UNTHZ
          COMP2=V(2*3-2)*UNTHX+V(2*3-1)*UNTHY+V(2*3)*UNTHZ
          COMP3=V(3*3-2)*UNTHX+V(3*3-1)*UNTHY+V(3*3)*UNTHZ
          COMP4=V(4*3-2)*UNTHX+V(4*3-1)*UNTHY+V(4*3)*UNTHZ
          TRPARX1=COMP1*UNTHX
          TRPARY1=COMP1*UNTHY
          TRPARZ1=COMP1*UNTHZ
          TRPARX2=COMP2*UNTHX
          TRPARY2=COMP2*UNTHY
          TRPARZ2=COMP2*UNTHZ
          TRPARX3=COMP3*UNTHX
          TRPARY3=COMP3*UNTHY
          TRPARZ3=COMP3*UNTHZ
          TRPARX4=COMP4*UNTHX
          TRPARY4=COMP4*UNTHY
          TRPARZ4=COMP4*UNTHZ
          AMPTR=(COMP1+COMP2+COMP3+COMP4)/4.0
C
C NOW CALCULATE DIFFERENCE BETWEEN DISPLACEMENTS AND PARALLEL TRANSLATIONS
C TO GIVE ROTATIONAL PARTS
C
          ROTX1=V(1*3-2)-TRPARX1
          ROTY1=V(1*3-1)-TRPARY1
          ROTZ1=V(1*3  )-TRPARZ1
          ROTX2=V(2*3-2)-TRPARX2
          ROTY2=V(2*3-1)-TRPARY2
          ROTZ2=V(2*3  )-TRPARZ2
          ROTX3=V(3*3-2)-TRPARX3
          ROTY3=V(3*3-1)-TRPARY3
          ROTZ3=V(3*3  )-TRPARZ3
          ROTX4=V(4*3-2)-TRPARX4
          ROTY4=V(4*3-1)-TRPARY4
          ROTZ4=V(4*3  )-TRPARZ4
          AMPROT1=SQRT(ROTX1**2+ROTY1**2+ROTZ1**2)
          AMPROT2=SQRT(ROTX2**2+ROTY2**2+ROTZ2**2)
          AMPROT3=SQRT(ROTX3**2+ROTY3**2+ROTZ3**2)
          AMPROT4=SQRT(ROTX4**2+ROTY4**2+ROTZ4**2)
C
C CALCULATE UNIT VECTORS IN DIRECTION OF ROTATIONAL PARTS
C
          UNROTX1=ROTX1/AMPROT1
          UNROTY1=ROTY1/AMPROT1
          UNROTZ1=ROTZ1/AMPROT1
          UNROTX2=ROTX2/AMPROT2
          UNROTY2=ROTY2/AMPROT2
          UNROTZ2=ROTZ2/AMPROT2
          UNROTX3=ROTX3/AMPROT3
          UNROTY3=ROTY3/AMPROT3
          UNROTZ3=ROTZ3/AMPROT3
          UNROTX4=ROTX4/AMPROT4
          UNROTY4=ROTY4/AMPROT4
          UNROTZ4=ROTZ4/AMPROT4
C
C CALCULATE VECTORS IN DIRECTION FROM ATOMS TO AXIS (PERPENDICULARLY)
C
          AXIX1=(UNROTY1*UNTHZ-UNROTZ1*UNTHY)
          AXIY1=(UNROTZ1*UNTHX-UNROTX1*UNTHZ)
          AXIZ1=(UNROTX1*UNTHY-UNROTY1*UNTHX)
          AXIX2=(UNROTY2*UNTHZ-UNROTZ2*UNTHY)
          AXIY2=(UNROTZ2*UNTHX-UNROTX2*UNTHZ)
          AXIZ2=(UNROTX2*UNTHY-UNROTY2*UNTHX)
          AXIX3=(UNROTY3*UNTHZ-UNROTZ3*UNTHY)
          AXIY3=(UNROTZ3*UNTHX-UNROTX3*UNTHZ)
          AXIZ3=(UNROTX3*UNTHY-UNROTY3*UNTHX)
          AXIX4=(UNROTY4*UNTHZ-UNROTZ4*UNTHY)
          AXIY4=(UNROTZ4*UNTHX-UNROTX4*UNTHZ)
          AXIZ4=(UNROTX4*UNTHY-UNROTY4*UNTHX)
C
          HTAN=2*TAN(0.5*AMPTHET)
          RAXIX1=AMPROT1*AXIX1/HTAN
          RAXIY1=AMPROT1*AXIY1/HTAN
          RAXIZ1=AMPROT1*AXIZ1/HTAN
          RAXIX2=AMPROT2*AXIX2/HTAN
          RAXIY2=AMPROT2*AXIY2/HTAN
          RAXIZ2=AMPROT2*AXIZ2/HTAN
          RAXIX3=AMPROT3*AXIX3/HTAN
          RAXIY3=AMPROT3*AXIY3/HTAN
          RAXIZ3=AMPROT3*AXIZ3/HTAN
          RAXIX4=AMPROT4*AXIX4/HTAN
          RAXIY4=AMPROT4*AXIY4/HTAN
          RAXIZ4=AMPROT4*AXIZ4/HTAN
C
C SUBSTRACT THESE VECTORS FROM POSITION VECTORS TO GET POINTS ON AXIS
C
          XAX1=CO(1,IAT1)+(0.5*ROTX1)-RAXIX1
          YAX1=CO(2,IAT1)+(0.5*ROTY1)-RAXIY1
          ZAX1=CO(3,IAT1)+(0.5*ROTZ1)-RAXIZ1
          XAX2=CO(1,IAT2)+(0.5*ROTX2)-RAXIX2
          YAX2=CO(2,IAT2)+(0.5*ROTY2)-RAXIY2
          ZAX2=CO(3,IAT2)+(0.5*ROTZ2)-RAXIZ2
          XAX3=CO(1,IAT3)+(0.5*ROTX3)-RAXIX3
          YAX3=CO(2,IAT3)+(0.5*ROTY3)-RAXIY3
          ZAX3=CO(3,IAT3)+(0.5*ROTZ3)-RAXIZ3
          XAX4=CO(1,IAT4)+(0.5*ROTX4)-RAXIX4
          YAX4=CO(2,IAT4)+(0.5*ROTY4)-RAXIY4
          ZAX4=CO(3,IAT4)+(0.5*ROTZ4)-RAXIZ4
C
        RETURN
        END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C CHECKS THAT SEGMENTS CONNECT IN SPACE TO FORM A SINGLE DOMAIN
C USING A DISTANCE CRITERION "DISTCRIT", IF NOT A NEW DOMAIN IS CREATED
C
C THIS VERSION (2) COUNTS NUMBER OF TIMES CLUSTERS DO NOT 
C RESULT IN ANY DOMAINS AND PASSES THIS NUMBER (ISTOP) BACK 
C TO CLUSTER2 ROUTINE
C
      SUBROUTINE SEGCONNECT2(DOMIN,NDOM,NAAT1,NAAT2,ATLIST1,
     & ATLIST2,COO1,COO2,IRESBEG,IRESEND,NSEG,NONDOM,NONRESBEG,NONRESEND
     & ,NONSEG,CLUSNO)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER IDOM,NDOM,NDOMI,NEWDOM,NSEG(*),NONDOM
      INTEGER IRESBEG(NDOMX,*),IRESEND(NDOMX,*),NEWSEG(NDOMX)
      INTEGER NONRESBEG(NDOMX,*),NONRESEND(NDOMX,*),NONSEG(NDOMX)
      INTEGER IRESBEGN(NDOMX,NSEGMX),IRESENDN(NDOMX,NSEGMX),I,J
      INTEGER ISEG,JSEG,STORESEG(NSEGMX),DROPN(NSEGMX),IC(NSEGMX)
      INTEGER DROP(NSEGMX),DROPNUM(NSEGMX,NSEGMX),DROPMIN,K,L,M,N
      INTEGER DOMIN,DOMSIZE(NDOMX),CLUSNO
      INTEGER NAAT1(*),NAAT2(*)
      INTEGER ATLIST1(NRESMX,*),ATLIST2(NRESMX,*)
      REAL*8 COO1(3,*),COO2(3,*)
      LOGICAL CONTACTOK,CON1,CON2,FLAG,STOPCLUSN,STOPCLUS,STOPCLUS2
C
      CLUSNO=0
C
      DO 100 I=1,NDOMX 
        DOMSIZE(I)=0
100   CONTINUE
C
      NDOMI=NDOM
      STOPCLUS=.FALSE.
C
C LOOP OVER CLUSTERS
C
      DO 1 IDOM=1,NDOM
C
        STOPCLUS2=.FALSE.
C
        IF(NSEG(IDOM).EQ.0) GOTO 1
C
        DO 31 ISEG=1,NSEG(IDOM)
          DROP(ISEG)=0
          DROPN(ISEG)=0
31      CONTINUE
C
C LOOK FOR CONTACTING SEGMENTS WITHIN A DOMAIN AND GIVE
C ALL CONTACTING SEGMENTS, JSEG, A DROP VALUE OF THE CURRENT SEGMENT 
C ISEG
C
        DO 2 ISEG=1,NSEG(IDOM)
          K=0
          DO 3 JSEG=1,NSEG(IDOM)
            CON1=CONTACTOK(IDOM,JSEG,ISEG,IRESBEG,IRESEND,
     &NAAT1,ATLIST1,COO1)
            CON2=CONTACTOK(IDOM,JSEG,ISEG,IRESBEG,IRESEND,
     &NAAT2,ATLIST2,COO2)
            IF(CON1.AND.CON2) THEN
              K=K+1
              DROPN(JSEG)=ISEG
              STORESEG(K)=JSEG
            ENDIF
3         CONTINUE
C
C IF CONNECTING SEGMENTS ARE ALSO CONNECTING SEGMENTS OF A PREVIOUS
C SEGMENT, THEN DETERMINE MINIMUM DROP NUMBER FOR THESE CONNECTING 
C SEGMENTS
C
          FLAG=.TRUE.
          DROPMIN=NSEG(IDOM)+1
          DO 5 L=1,K
            IF(DROP(STORESEG(L)).NE.0) THEN
              FLAG=.FALSE.
              IF(DROP(STORESEG(L)).LT.DROPMIN) THEN
                DROPMIN=DROP(STORESEG(L))
              ENDIF
            ENDIF
5         CONTINUE
C
C IF THE CONNECTING SEGMENTS WITH CURRENT SEGMENT DO NOT CONNECT
C TO ANY CONNECTING SEGMENTS OF A PREVIOUS SEGMENT, THEN STORE THESE
C SEGMENTS IN DROP WITH CURRENT SEGMENT NUMBER
C 
          IF(FLAG) THEN
            DO 10 L=1,K
              DROP(STORESEG(L))=DROPN(STORESEG(L))
10          CONTINUE
            GOTO 2
          ENDIF
C
C GIVE ALL THOSE PREVIOUS SEGMENTS THAT HAVE CONNECTION WITH
C SEGMENTS OF CURRENT SEGMENT, MINIMUM DROP VALUE
C
          DO 6 M=1,K
            DO 7 N=1,NSEG(IDOM)
              IF(DROP(N).EQ.DROP(STORESEG(M)).AND.DROP(N).NE.0)
     & THEN
                DROP(N)=DROPMIN
              ENDIF
7           CONTINUE
6         CONTINUE
C
          DO 8 L=1,K
            DROP(STORESEG(L))=DROPMIN
8         CONTINUE
C
2       CONTINUE
C
        DO 13 I=1,NSEG(IDOM)
          IC(I)=0
13      CONTINUE
C
C IC COUNTS NUMBER OF SEGMENTS WITH SAME DROP NUMBER
C DROPNUM GIVES SEGMENT NUMBERS IN EACH DROP 
C
        DO 12 I=1,NSEG(IDOM)
          IC(DROP(I))=IC(DROP(I))+1
          DROPNUM(IC(DROP(I)),DROP(I))=I
12      CONTINUE
C
        STOPCLUSN=.TRUE.
        NEWDOM=0
        DO 14 I=1,NSEG(IDOM)
          IF(IC(I).EQ.0) GOTO 14
          NEWDOM=NEWDOM+1
          IF(NEWDOM.EQ.1) THEN
            NEWSEG(IDOM)=IC(I)
            DO 15 J=1,IC(I)
              IRESBEGN(IDOM,J)=IRESBEG(IDOM,DROPNUM(J,I))
              IRESENDN(IDOM,J)=IRESEND(IDOM,DROPNUM(J,I))
              DOMSIZE(IDOM)=DOMSIZE(IDOM)+(IRESENDN(IDOM,J)
     &-IRESBEGN(IDOM,J)+1)
15          CONTINUE
C
C CREATE NEW CLUSTER
C
C STOP CLUSTERING ALGORITHM IF ANY CLUSTER DOESN'T HAVE A DOMAIN 
C WITH AT LEAST "DOMIN" RESIDUES
C
            IF(DOMSIZE(IDOM).GE.DOMIN) STOPCLUSN=.FALSE.
          ELSE
            NDOMI=NDOMI+1
C
            IF(NDOMI.GT.NDOMX) THEN
              WRITE(6,'(A,I4,I4)')'ARRAY BOUNDARY FOR NUMBER OF DOMAINS 
     &HAS BEEN EXCEEDED: ',NDOMX,NDOMI
              WRITE(6,'(A)')'CHANGE VALUE OF "NDOMX" IN "DynDom.param"'
              STOP
            ENDIF
C
            NEWSEG(NDOMI)=IC(I)
            DO 16 J=1,IC(I)
              IRESBEGN(NDOMI,J)=IRESBEG(IDOM,DROPNUM(J,I))
              IRESENDN(NDOMI,J)=IRESEND(IDOM,DROPNUM(J,I))
              DOMSIZE(NDOMI)=DOMSIZE(NDOMI)+(IRESENDN(NDOMI,J)
     &-IRESBEGN(NDOMI,J)+1)
16          CONTINUE
            IF(DOMSIZE(NDOMI).GE.DOMIN) STOPCLUSN=.FALSE.
          ENDIF
14      CONTINUE
C
        IF(STOPCLUSN) STOPCLUS=.TRUE.
        IF(STOPCLUSN) STOPCLUS2=.TRUE.
C
        IF(STOPCLUS2) THEN
          CLUSNO=CLUSNO+1
        ENDIF
C
1     CONTINUE
C
C DOMAINS OF SIZE LESS THAN DOMIN ARE NOT INCLUDED
C
      M=0
      N=0
      DO 18 I=1,NDOMI
        IF(DOMSIZE(I).LT.DOMIN) THEN
          N=N+1
          NONSEG(N)=NEWSEG(I)
          DO 21 K=1,NONSEG(N)
            NONRESBEG(N,K)=IRESBEGN(I,K)
            NONRESEND(N,K)=IRESENDN(I,K)
21        CONTINUE
          GOTO 18
        ENDIF
        M=M+1
        NSEG(M)=NEWSEG(I)
        DO 19 J=1,NSEG(M)
          IRESBEG(M,J)=IRESBEGN(I,J)
          IRESEND(M,J)=IRESENDN(I,J)
19      CONTINUE
18    CONTINUE
      NDOM=M
      NONDOM=N
C
      RETURN
      END
C
C
      FUNCTION CONTACTOK(IDOM,JSEG,ISEG,IRESBEG,IRESEND,
     &NAAT,ATLIST,COO)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      LOGICAL CONTACTOK
      INTEGER IRESBEG(NDOMX,*),IRESEND(NDOMX,*)
      INTEGER IDOM,ISEG,JSEG,IRESI,IRESJ,IAAI,IAAJ
      INTEGER IATI,IATJ
      INTEGER NAAT(*),ATLIST(NRESMX,*)
      REAL*8 COO(3,*),DIST,DISTX,DISTY,DISTZ
C
      CONTACTOK=.FALSE.
C
      DO 1 IRESI=IRESBEG(IDOM,ISEG),IRESEND(IDOM,ISEG)
        DO 2 IRESJ=IRESBEG(IDOM,JSEG),IRESEND(IDOM,JSEG)
          DO 3 IAAI=1,NAAT(IRESI)
            IATI=ATLIST(IRESI,IAAI)
            DO 4 IAAJ=1,NAAT(IRESJ)
              IATJ=ATLIST(IRESJ,IAAJ)
              DISTX=COO(1,IATI)-COO(1,IATJ)
              DISTY=COO(2,IATI)-COO(2,IATJ)
              DISTZ=COO(3,IATI)-COO(3,IATJ)
              DIST=SQRT(DISTX**2+DISTY**2+DISTZ**2)
              IF(DIST.LE.DISTCRIT) THEN
                CONTACTOK=.TRUE.
                RETURN
              ENDIF
4           CONTINUE
3         CONTINUE
2       CONTINUE
1     CONTINUE
C 
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
        SUBROUTINE SEGLENG(M,NCLUS,IWORK,NSEG,BEG,END,CLUSIZE)
C
        IMPLICIT NONE
C
        include 'DynDom.param'
C
        INTEGER IWORK(*),NSEG(*),BEG(NDOMX,*)
        INTEGER END(NDOMX,*),I,J,M,A,B,CLUS,NCLUS 
        INTEGER CLUSIZE(NDOMX)
C
        DO 2 I=1,NDOMX
          NSEG(I)=0
2       CONTINUE
C
        A=1
        B=A
        CLUS=IWORK(1)
        DO 1 I=1,M
          IF(IWORK(I).NE.CLUS) THEN
            NSEG(CLUS)=NSEG(CLUS)+1
C
            IF(NSEG(CLUS).GT.NSEGMX) THEN
              WRITE(6,'(A,I4,I4)')'ARRAY BOUNDARY FOR NUMBER OF SEGMENTS
     & HAS BEEN EXCEEDED: ',NSEGMX,NSEG(CLUS)
              WRITE(6,'(A)')'CHANGE VALUE OF "NSEGMX" IN "DynDom.param"'
              STOP
            ENDIF
C
            BEG(CLUS,NSEG(CLUS))=A
            END(CLUS,NSEG(CLUS))=B
            A=I
            B=A
            CLUS=IWORK(I)
          ELSE
            B=I
          ENDIF
1       CONTINUE
        NSEG(CLUS)=NSEG(CLUS)+1 
C
        IF(NSEG(CLUS).GT.NSEGMX) THEN
          WRITE(6,'(A,I4,I4)')'ARRAY BOUNDARY FOR NUMBER OF SEGMENTS HAS
     & BEEN EXCEEDED: ',NSEG(CLUS),NSEGMX
          WRITE(6,'(A)')'CHANGE VALUE OF "NSEGMX" IN "DynDom.param"'
          STOP
        ENDIF
C
        BEG(CLUS,NSEG(CLUS))=A
        END(CLUS,NSEG(CLUS))=B
C
        DO 3 I=1,NCLUS
          CLUSIZE(I)=0
          DO 4 J=1,NSEG(I)
            CLUSIZE(I)=CLUSIZE(I)+END(I,J)-BEG(I,J)+1
4         CONTINUE
3       CONTINUE
C         
        RETURN
        END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
      SUBROUTINE SINGLE(X, COUNT, AVE, SD, XMIN, XMAX, SSQ)
C
      IMPLICIT NONE
C
      REAL*8 COUNT,AVE,X,SD,XMIN,XMAX,SSQ
C
      IF(COUNT.EQ.0.) THEN
         AVE=0.
         SD=0.
         XMIN=1.0D08
         XMAX=-1.0D08
         SSQ=0.
      ENDIF
      COUNT=COUNT+1.
      AVE=AVE+(X-AVE)/COUNT
      IF(COUNT.NE.1.) SSQ=SSQ+COUNT*(X-AVE)**2/(COUNT-1.)
      SD=(SSQ/COUNT)**0.5
      IF(XMIN.GT.X) XMIN=X
      IF(XMAX.LT.X) XMAX=X
      RETURN
      END
C
       SUBROUTINE SORT(N,LL,MM)
C
       INTEGER N,I,J,L,M,LL(N),MM(N)
C
C SORT USING STRAIGHT INSERTION METHOD
C
       DO 3 J=2,N
         L=LL(J)
         M=MM(J)
         DO 4 I=J-1,1,-1
           IF(LL(I).LE.L) GOTO 5
           LL(I+1)=LL(I)
           MM(I+1)=MM(I)
4        CONTINUE
         I=0
5        CONTINUE
         LL(I+1)=L
         MM(I+1)=M
3      CONTINUE
C
       RETURN
       END
C
       SUBROUTINE SORTR(N,ARR,LIST)
C
       INTEGER N,I,J,LIST(*),M
       REAL*8 ARR(*),A
C
C SORT USING STRAIGHT INSERTION METHOD
C
       DO 3 J=2,N
         A=ARR(J)
         M=LIST(J)
         DO 4 I=J-1,1,-1
           IF(ARR(I).GE.A) GOTO 5
           ARR(I+1)=ARR(I)
           LIST(I+1)=LIST(I)
4        CONTINUE
         I=0
5        CONTINUE
         ARR(I+1)=A
         LIST(I+1)=M
3      CONTINUE
C
       RETURN
       END
C
C REMOVES SPACES IN INPUT LINE
C
	SUBROUTINE SPACEREMOVE(INPO,KEYEND,NOTHING)
C
        IMPLICIT NONE
C
        INTEGER KEYEND
        CHARACTER*200 INPO
        LOGICAL NOTHING
C
        NOTHING=.FALSE.
1       CONTINUE
        IF(INPO(KEYEND:KEYEND).EQ.' '.OR.INPO(KEYEND:KEYEND).EQ.'='
     &     .OR.INPO(KEYEND:KEYEND).EQ.':' ) THEN
          IF(KEYEND.EQ.200) GOTO 2
          KEYEND=KEYEND+1
          GOTO 1
        ELSE
          RETURN
        ENDIF
C
2       CONTINUE
        NOTHING=.TRUE.
C
        RETURN
        END 
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
      SUBROUTINE STRINGLENGTH(STRINGY,LENGTH,I)
C
      IMPLICIT NONE
C
      INTEGER I,LENGTH
      CHARACTER*(*) STRINGY
      CHARACTER*1 BLANK
C
      DO 1 I=LENGTH,1,-1
        READ(STRINGY(I:I),'(A)')BLANK
        IF(BLANK.NE.' ') THEN
          RETURN
        ENDIF
1     CONTINUE
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
      SUBROUTINE SVD(NM,M,N,A,W,MATU,U,MATV,V,IERR,RV1)
C
      INTEGER I,J,K,L,M,N,II,I1,KK,K1,LL,L1,MN,NM,ITS,IERR
      REAL*8 A(NM,N),W(N),U(NM,N),V(NM,N),RV1(N)
      REAL*8 C,F,G,H,S,X,Y,Z,SCALE,ANORM
      LOGICAL MATU,MATV
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE SVD,
C     NUM. MATH. 14, 403-420(1970) BY GOLUB AND REINSCH.
C     HANDBOOK FOR AUTO. COMP., VOL II-LINEAR ALGEBRA, 134-151(1971).
C
C     THIS SUBROUTINE DETERMINES THE SINGULAR VALUE DECOMPOSITION
C          T
C     A=USV  OF A REAL M BY N RECTANGULAR MATRIX.  HOUSEHOLDER
C     BIDIAGONALIZATION AND A VARIANT OF THE QR ALGORITHM ARE USED.
C
C     ON INPUT.
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT.  NOTE THAT NM MUST BE AT LEAST
C          AS LARGE AS THE MAXIMUM OF M AND N.
C
C        M IS THE NUMBER OF ROWS OF A (AND U).
C
C        N IS THE NUMBER OF COLUMNS OF A (AND U) AND THE ORDER OF V.
C
C        A CONTAINS THE RECTANGULAR INPUT MATRIX TO BE DECOMPOSED.
C
C        MATU SHOULD BE SET TO .TRUE. IF THE U MATRIX IN THE
C          DECOMPOSITION IS DESIRED, AND TO .FALSE. OTHERWISE.
C
C        MATV SHOULD BE SET TO .TRUE. IF THE V MATRIX IN THE
C          DECOMPOSITION IS DESIRED, AND TO .FALSE. OTHERWISE.
C
C     ON OUTPUT.
C
C        A IS UNALTERED (UNLESS OVERWRITTEN BY U OR V).
C
C        W CONTAINS THE N (NON-NEGATIVE) SINGULAR VALUES OF A (THE
C          DIAGONAL ELEMENTS OF S).  THEY ARE UNORDERED.  IF AN
C          ERROR EXIT IS MADE, THE SINGULAR VALUES SHOULD BE CORRECT
C          FOR INDICES IERR+1,IERR+2,...,N.
C
C        U CONTAINS THE MATRIX U (ORTHOGONAL COLUMN VECTORS) OF THE
C          DECOMPOSITION IF MATU HAS BEEN SET TO .TRUE.  OTHERWISE
C          U IS USED AS A TEMPORARY ARRAY.  U MAY COINCIDE WITH A.
C          IF AN ERROR EXIT IS MADE, THE COLUMNS OF U CORRESPONDING
C          TO INDICES OF CORRECT SINGULAR VALUES SHOULD BE CORRECT.
C
C        V CONTAINS THE MATRIX V (ORTHOGONAL) OF THE DECOMPOSITION IF
C          MATV HAS BEEN SET TO .TRUE.  OTHERWISE V IS NOT REFERENCED.
C          V MAY ALSO COINCIDE WITH A IF U IS NOT NEEDED.  IF AN ERROR
C          EXIT IS MADE, THE COLUMNS OF V CORRESPONDING TO INDICES OF
C          CORRECT SINGULAR VALUES SHOULD BE CORRECT.
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          K          IF THE K-TH SINGULAR VALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C        RV1 IS A TEMPORARY STORAGE ARRAY.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     MODIFIED TO ELIMINATE MACHEP
C
      IERR = 0
C
      DO 100 I = 1, M
C
         DO 100 J = 1, N
            U(I,J) = A(I,J)
  100 CONTINUE
C     .......... HOUSEHOLDER REDUCTION TO BIDIAGONAL FORM ..........
      G = 0.0
      SCALE = 0.0
      ANORM = 0.0
C
      DO 300 I = 1, N
         L = I + 1
         RV1(I) = SCALE * G
         G = 0.0
         S = 0.0
         SCALE = 0.0
         IF (I .GT. M) GO TO 210
C
         DO 120 K = I, M
  120    SCALE = SCALE + ABS(U(K,I))
C
         IF (SCALE .EQ. 0.0) GO TO 210
C
         DO 130 K = I, M
            U(K,I) = U(K,I) / SCALE
            S = S + U(K,I)**2
  130    CONTINUE
C
         F = U(I,I)
         G = -SIGN(SQRT(S),F)
         H = F * G - S
         U(I,I) = F - G
         IF (I .EQ. N) GO TO 190
C
         DO 150 J = L, N
            S = 0.0
C
            DO 140 K = I, M
  140       S = S + U(K,I) * U(K,J)
C
            F = S / H
C
            DO 150 K = I, M
               U(K,J) = U(K,J) + F * U(K,I)
  150    CONTINUE
C
  190    DO 200 K = I, M
  200    U(K,I) = SCALE * U(K,I)
C
  210    W(I) = SCALE * G
         G = 0.0
         S = 0.0
         SCALE = 0.0
         IF (I .GT. M .OR. I .EQ. N) GO TO 290
C
         DO 220 K = L, N
  220    SCALE = SCALE + ABS(U(I,K))
C
         IF (SCALE .EQ. 0.0) GO TO 290
C
         DO 230 K = L, N
            U(I,K) = U(I,K) / SCALE
            S = S + U(I,K)**2
  230    CONTINUE
C
         F = U(I,L)
         G = -SIGN(SQRT(S),F)
         H = F * G - S
         U(I,L) = F - G
C
         DO 240 K = L, N
  240    RV1(K) = U(I,K) / H
C
         IF (I .EQ. M) GO TO 270
C
         DO 260 J = L, M
            S = 0.0
C
            DO 250 K = L, N
  250       S = S + U(J,K) * U(I,K)
C
            DO 260 K = L, N
               U(J,K) = U(J,K) + S * RV1(K)
  260    CONTINUE
C
  270    DO 280 K = L, N
  280    U(I,K) = SCALE * U(I,K)
C
  290    ANORM = DMAX1(ANORM,ABS(W(I))+ABS(RV1(I)))
  300 CONTINUE
C     .......... ACCUMULATION OF RIGHT-HAND TRANSFORMATIONS ..........
      IF (.NOT. MATV) GO TO 410
C     .......... FOR I=N STEP -1 UNTIL 1 DO -- ..........
      DO 400 II = 1, N
         I = N + 1 - II
         IF (I .EQ. N) GO TO 390
         IF (G .EQ. 0.0) GO TO 360
C
         DO 320 J = L, N
C     .......... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
  320    V(J,I) = (U(I,J) / U(I,L)) / G
C
         DO 350 J = L, N
            S = 0.0
C
            DO 340 K = L, N
  340       S = S + U(I,K) * V(K,J)
C
            DO 350 K = L, N
               V(K,J) = V(K,J) + S * V(K,I)
  350    CONTINUE
C
  360    DO 380 J = L, N
            V(I,J) = 0.0
            V(J,I) = 0.0
  380    CONTINUE
C
  390    V(I,I) = 1.0
         G = RV1(I)
         L = I
  400 CONTINUE
C     .......... ACCUMULATION OF LEFT-HAND TRANSFORMATIONS ..........
  410 IF (.NOT. MATU) GO TO 510
C     ..........FOR I=MIN(M,N) STEP -1 UNTIL 1 DO -- ..........
      MN = N
      IF (M .LT. N) MN = M
C
      DO 500 II = 1, MN
         I = MN + 1 - II
         L = I + 1
         G = W(I)
         IF (I .EQ. N) GO TO 430
C
         DO 420 J = L, N
  420    U(I,J) = 0.0
C
  430    IF (G .EQ. 0.0) GO TO 475
         IF (I .EQ. MN) GO TO 460
C
         DO 450 J = L, N
            S = 0.0
C
            DO 440 K = L, M
  440       S = S + U(K,I) * U(K,J)
C     .......... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
            F = (S / U(I,I)) / G
C
            DO 450 K = I, M
               U(K,J) = U(K,J) + F * U(K,I)
  450    CONTINUE
C
  460    DO 470 J = I, M
  470    U(J,I) = U(J,I) / G
C
         GO TO 490
C
  475    DO 480 J = I, M
  480    U(J,I) = 0.0
C
  490    U(I,I) = U(I,I) + 1.0
  500 CONTINUE
C     .......... DIAGONALIZATION OF THE BIDIAGONAL FORM ..........
C     .......... FOR K=N STEP -1 UNTIL 1 DO -- ..........
  510 DO 700 KK = 1, N
         K1 = N - KK
         K = K1 + 1
         ITS = 0
C     .......... TEST FOR SPLITTING.
C                FOR L=K STEP -1 UNTIL 1 DO -- ..........
  520    DO 530 LL = 1, K
            L1 = K - LL
            L = L1 + 1
            IF (ABS(RV1(L)) + ANORM .EQ. ANORM) GO TO 565
C     .......... RV1(1) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP ..........
            IF (ABS(W(L1)) + ANORM .EQ. ANORM) GO TO 540
  530    CONTINUE
C     .......... CANCELLATION OF RV1(L) IF L GREATER THAN 1 ..........
  540    C = 0.0
         S = 1.0
C
         DO 560 I = L, K
            F = S * RV1(I)
            RV1(I) = C * RV1(I)
            IF (ABS(F) + ANORM .EQ. ANORM) GO TO 565
            G = W(I)
            H = SQRT(F*F+G*G)
            W(I) = H
            C = G / H
            S = -F / H
            IF (.NOT. MATU) GO TO 560
C
            DO 550 J = 1, M
               Y = U(J,L1)
               Z = U(J,I)
               U(J,L1) = Y * C + Z * S
               U(J,I) = -Y * S + Z * C
  550       CONTINUE
C
  560    CONTINUE
C     .......... TEST FOR CONVERGENCE ..........
  565    Z = W(K)
         IF (L .EQ. K) GO TO 650
C     .......... SHIFT FROM BOTTOM 2 BY 2 MINOR ..........
         IF (ITS .EQ. 30) GO TO 1000
         ITS = ITS + 1
         X = W(L)
         Y = W(K1)
         G = RV1(K1)
         H = RV1(K)
         F = ((Y - Z) * (Y + Z) + (G - H) * (G + H)) / (2.0 * H * Y)
         G = SQRT(F*F+1.0)
         F = ((X - Z) * (X + Z) + H * (Y / (F + SIGN(G,F)) - H)) / X
C     .......... NEXT QR TRANSFORMATION ..........
         C = 1.0
         S = 1.0
C
         DO 600 I1 = L, K1
            I = I1 + 1
            G = RV1(I)
            Y = W(I)
            H = S * G
            G = C * G
            Z = SQRT(F*F+H*H)
            RV1(I1) = Z
            C = F / Z
            S = H / Z
            F = X * C + G * S
            G = -X * S + G * C
            H = Y * S
            Y = Y * C
            IF (.NOT. MATV) GO TO 575
C
            DO 570 J = 1, N
               X = V(J,I1)
               Z = V(J,I)
               V(J,I1) = X * C + Z * S
               V(J,I) = -X * S + Z * C
  570       CONTINUE
C
  575       Z = SQRT(F*F+H*H)
            W(I1) = Z
C     .......... ROTATION CAN BE ARBITRARY IF Z IS ZERO ..........
            IF (Z .EQ. 0.0) GO TO 580
            C = F / Z
            S = H / Z
  580       F = C * G + S * Y
            X = -S * G + C * Y
            IF (.NOT. MATU) GO TO 600
C
            DO 590 J = 1, M
               Y = U(J,I1)
               Z = U(J,I)
               U(J,I1) = Y * C + Z * S
               U(J,I) = -Y * S + Z * C
  590       CONTINUE
C
  600    CONTINUE
C
         RV1(L) = 0.0
         RV1(K) = F
         W(K) = X
         GO TO 520
C     .......... CONVERGENCE ..........
  650    IF (Z .GE. 0.0) GO TO 700
C     .......... W(K) IS MADE NON-NEGATIVE ..........
         W(K) = -Z
         IF (.NOT. MATV) GO TO 700
C
         DO 690 J = 1, N
  690    V(J,K) = -V(J,K)
C
  700 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO A
C                SINGULAR VALUE AFTER 30 ITERATIONS ..........
 1000 IERR = K
 1001 RETURN
      END
C
C SUBROUTINE TO DETERMINE DIHEDRALS
C
      SUBROUTINE TORDET(COO,I,J,K,L,TOR)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER I,J,K,L
      REAL*8 COO(3,*),LENGTH,TOR
      REAL*8 XKJ,YKJ,ZKJ,XIJ,YIJ,ZIJ,XKL,YKL,ZKL 
      REAL*8 SCALAR,XIM,YIM,ZIM,XLN,YLN,ZLN
      REAL*8 LENGTHIM,LENGTHLN,X,Y,Z,CS
C
      XKJ=COO(1,J)-COO(1,K)
      YKJ=COO(2,J)-COO(2,K)
      ZKJ=COO(3,J)-COO(3,K)
C
      XIJ=COO(1,J)-COO(1,I)
      YIJ=COO(2,J)-COO(2,I)
      ZIJ=COO(3,J)-COO(3,I)
C
      XKL=COO(1,L)-COO(1,K)
      YKL=COO(2,L)-COO(2,K)
      ZKL=COO(3,L)-COO(3,K) 
C
      LENGTH=XKJ**2+YKJ**2+ZKJ**2
C
      SCALAR=XIJ*XKJ+YIJ*YKJ+ZIJ*ZKJ
      SCALAR=SCALAR/LENGTH
      XIM=XIJ-SCALAR*XKJ
      YIM=YIJ-SCALAR*YKJ
      ZIM=ZIJ-SCALAR*ZKJ
C
      SCALAR=XKL*XKJ+YKL*YKJ+ZKL*ZKJ
      SCALAR=SCALAR/LENGTH
      XLN=-XKL+SCALAR*XKJ
      YLN=-YKL+SCALAR*YKJ
      ZLN=-ZKL+SCALAR*ZKJ
C
      LENGTHIM=SQRT(XIM**2+YIM**2+ZIM**2)
      LENGTHLN=SQRT(XLN**2+YLN**2+ZLN**2)
      SCALAR=XIM*XLN+YIM*YLN+ZIM*ZLN
      CS=SCALAR/(LENGTHIM*LENGTHLN)
C
      CALL VECPROD(XKJ,YKJ,ZKJ,XKL,YKL,ZKL,X,Y,Z)      
C
      SCALAR=XIJ*X+YIJ*Y+ZIJ*Z
      TOR=-SIGN(1.D0,SCALAR)*ACOS(CS)*180/PI
C
      RETURN
      END
C
C ROUTINE TO DETERMINE DIHEDRAL ANGLE CHANGES AND SCALAR PRODUCTS 
C OF AXES WITH SCREW AXIS
C
      SUBROUTINE TORDIFF(IRES,NI,CA,CP,CB,MASS,COOBB1,COOBB2,
     & UX,UY,UZ,IOUT7)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER NI(*),CA(*),CP(*),CB(*),IRES,IOUT7
      REAL*8 COOBB1(3,*),COOBB2(3,*) 
      REAL*8 UNTHX,UNTHY,UNTHZ
      REAL*8 UPHIX1,UPHIY1,UPHIZ1,UPSIX1,UPSIY1,UPSIZ1,LENGTH
      REAL*8 UPHIX2,UPHIY2,UPHIZ2,UPSIX2,UPSIY2,UPSIZ2
      REAL*8 PHI1,PSI1,PHI2,PSI2
      REAL*8 PHIDIFF,PSIDIFF
      REAL*8 SCALARPS1,SCALARPH1,SCALARPS2,SCALARPH2
      REAL*8 MASS(*)
      REAL*8 UX,UY,UZ
C
C DETERMINE MAIN-CHAIN DIHEDRAL ANGLE CHANGES
C
      CALL TORDET(COOBB1,NI(IRES),CA(IRES),CP(IRES),NI(IRES+1),PSI1)
      CALL TORDET(COOBB1,CP(IRES),NI(IRES+1),CA(IRES+1),CP(IRES+1)
     & ,PHI1)
C
      CALL TORDET(COOBB2,NI(IRES),CA(IRES),CP(IRES),NI(IRES+1),PSI2)
      CALL TORDET(COOBB2,CP(IRES),NI(IRES+1),CA(IRES+1),CP(IRES+1)
     & ,PHI2)
C
      UPSIX1=COOBB1(1,CP(IRES))-COOBB1(1,CA(IRES))
      UPSIY1=COOBB1(2,CP(IRES))-COOBB1(2,CA(IRES))
      UPSIZ1=COOBB1(3,CP(IRES))-COOBB1(3,CA(IRES))
      LENGTH=SQRT(UPSIX1**2+UPSIY1**2+UPSIZ1**2)
      UPSIX1=UPSIX1/LENGTH
      UPSIY1=UPSIY1/LENGTH
      UPSIZ1=UPSIZ1/LENGTH
C
      UPHIX1=COOBB1(1,CA(IRES+1))-COOBB1(1,NI(IRES+1))
      UPHIY1=COOBB1(2,CA(IRES+1))-COOBB1(2,NI(IRES+1))
      UPHIZ1=COOBB1(3,CA(IRES+1))-COOBB1(3,NI(IRES+1))
      LENGTH=SQRT(UPHIX1**2+UPHIY1**2+UPHIZ1**2)
      UPHIX1=UPHIX1/LENGTH
      UPHIY1=UPHIY1/LENGTH
      UPHIZ1=UPHIZ1/LENGTH
C
      UPSIX2=COOBB2(1,CP(IRES))-COOBB2(1,CA(IRES))
      UPSIY2=COOBB2(2,CP(IRES))-COOBB2(2,CA(IRES))
      UPSIZ2=COOBB2(3,CP(IRES))-COOBB2(3,CA(IRES))
      LENGTH=SQRT(UPSIX2**2+UPSIY2**2+UPSIZ2**2)
      UPSIX2=UPSIX2/LENGTH
      UPSIY2=UPSIY2/LENGTH
      UPSIZ2=UPSIZ2/LENGTH
C
      UPHIX2=COOBB2(1,CA(IRES+1))-COOBB2(1,NI(IRES+1))
      UPHIY2=COOBB2(2,CA(IRES+1))-COOBB2(2,NI(IRES+1))
      UPHIZ2=COOBB2(3,CA(IRES+1))-COOBB2(3,NI(IRES+1))
      LENGTH=SQRT(UPHIX2**2+UPHIY2**2+UPHIZ2**2)
      UPHIX2=UPHIX2/LENGTH
      UPHIY2=UPHIY2/LENGTH
      UPHIZ2=UPHIZ2/LENGTH
C
      PHIDIFF=PHI2-PHI1
      IF(PHIDIFF.GT.180) PHIDIFF=-(360-PHIDIFF)
      IF(PHIDIFF.LT.-180) PHIDIFF=360+PHIDIFF
C
      PSIDIFF=PSI2-PSI1
      IF(PSIDIFF.GT.180) PSIDIFF=-(360-PSIDIFF)
      IF(PSIDIFF.LT.-180) PSIDIFF=360+PSIDIFF
C
      SCALARPH1=UX*UPHIX1+UY*UPHIY1+UZ*UPHIZ1
      SCALARPS1=UX*UPSIX1+UY*UPSIY1+UZ*UPSIZ1
      SCALARPH2=UX*UPHIX2+UY*UPHIY2+UZ*UPHIZ2
      SCALARPS2=UX*UPSIX2+UY*UPSIY2+UZ*UPSIZ2
C
      WRITE(IOUT7,'(A)')'phi and psi rotations and comparison of dihedra
     &l axes with screw axis'
      WRITE(IOUT7,'(A)')'      A        B       F        G        H     
     &   I'
      WRITE(IOUT7,'(6(1X,F8.3))') PSIDIFF,PHIDIFF,SCALARPS1,SCALARPH1,
     &SCALARPS2,SCALARPH2 
C
      RETURN
      END
C
C ROUTINE TO CALCULATE VECTOR PRODUCT BETWEEN TWO VECTORS
C
        SUBROUTINE VECPROD(X1,Y1,Z1,X2,Y2,Z2,X,Y,Z)
C
        REAL*8 X1,Y1,Z1,X2,Y2,Z2,X,Y,Z
C
        X=Y1*Z2-Z1*Y2
        Y=Z1*X2-X1*Z2
        Z=X1*Y2-Y1*X2
C
        RETURN
        END
C
C ROUTINE TO WRITE OUT DOMAINS FOR COLOURING IN RASMOL
C
      SUBROUTINE WRITECON_RAS(IPAIR,NSEG,IRESBEG,IRESEND,RESPDBNUM,
     &  CHAINID,IOUT3,COLOUR)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER IRESBEG(NPAIRMX,*),IRESEND(NPAIRMX,*),NSEG(*)
      INTEGER IPAIR,IOUT3,I
      CHARACTER*5 RESPDBNUM(*)
      CHARACTER*19 COLOUR
      CHARACTER*1 CHAINID
C
C SELECT AND COLOUR DOMAINS
C
C
      WRITE(IOUT3,1000)'select ',(RESPDBNUM(IRESBEG(IPAIR,I)),'-',
     & RESPDBNUM(IRESEND(IPAIR,I)),CHAINID,','
     & ,I=1,NSEG(IPAIR)-1),RESPDBNUM(IRESBEG(IPAIR,NSEG(IPAIR))),'-',
     & RESPDBNUM(IRESEND(IPAIR,NSEG(IPAIR))),CHAINID
      WRITE(IOUT3,2000)COLOUR
C
1000  FORMAT(A7,50(A4,A1,A4,A1,A1))
2000  FORMAT(A19)
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
C
C ROUTINE TO WRITE OUT DOMAINS FOR COLOURING IN RASMOL
C
      SUBROUTINE WRITEDOM_RAS(IDOM,NSEG,IRESBEG,IRESEND,RESPDBNUM,
     &  CHAINID,IOUT3,COLOUR)
C
      IMPLICIT NONE
C
      include 'DynDom.param'
C
      INTEGER IRESBEG(NDOMX,*),IRESEND(NDOMX,*),NSEG(*)
      INTEGER IDOM,IOUT3,I
      CHARACTER*5 RESPDBNUM(*)
      CHARACTER*19 COLOUR
      CHARACTER*1 CHAINID
C
C SELECT AND COLOUR DOMAINS
C
C
      WRITE(IOUT3,1000)'select ',(RESPDBNUM(IRESBEG(IDOM,I)),'-',
     & RESPDBNUM(IRESEND(IDOM,I)),CHAINID,','
     & ,I=1,NSEG(IDOM)-1),RESPDBNUM(IRESBEG(IDOM,NSEG(IDOM))),'-',
     & RESPDBNUM(IRESEND(IDOM,NSEG(IDOM))),CHAINID
      WRITE(IOUT3,2000)COLOUR
C
1000  FORMAT(A7,50(A4,A1,A4,A1,A1))
2000  FORMAT(A19)
C
      RETURN
      END
C
C-------------------------------------------------------------
C
C     Copyright by Steven Hayward, 2002.
C     DynDom Version 1.5
C
C-------------------------------------------------------------
C
