C
C     MLPHARE
C     Copyright (C) 1994-2004 Eleanor Dodson, Kim Henrick
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C     ===============
      PROGRAM MLPHARE
C     ===============
C
C
C  Correction to mlphare: anomalous parameter.
C   Dimensions extended by Doug Ohlendorf <OHLEN@dccc.med.umn.edu>
C  Also now outputs zero FPs.
C
C Kim: Modified on  Mon Jul 14 09:02:44 BST 1997
C for harvest sub calls for deposition to PDB
C
C This program will refine heavy atom positions and use these  for
C generating phase information.
C
C The main change from existing versions consists of different weighting
C schemes, which have greatly contributed to improve the accuracy of the
C refined parameters.
C
C FILE STRUCTURE:
C
C Input cards are read on unit 5
C Output is generated on unit 6
C The last part of the output to unit 6 is the error and coordinates
C  for each derivative in a format suitable for input to another cycle.
C  Edit it out if you need it...
C
C Structure factors are read from HKLIN in the usual way for MTZ files.
C   It is  possible to input external phase information as
C   PHIext Wext where PHIext is the phase in degrees and Wext is a weight.
C
C HKLOUT may contain all information you will need for various types of map.
C     All output files writeen to HKLOUT have
C    h k l s Fp Sigfp   Phib Fom
C You may ask for information about a particular derivative to be
C output. This will be needed if you want to do any sort of difference
C fourier involving this derivative.
C
C        Hendrickson_Lattman coefficients are output if requested.
C
C       Columns may be copied from HKLIN to HKLOUT. ( See Fo=..  )
C
C
C
C    See documention for definition of input cards.
C
C             EXAMPLE
C  #
C  pharenew                  \
C  HKLIN ../data/anisoscall_new.mtz     \
C  HKLOUT {$SCRATCH}junk.mtz    \
C  << 'END-phare'
C  TITLE Penicllin acylase pt2 and khg phases
C  !
C  !----  general keywords
C  !
C  SYMMETRY 1
C  RESO 100.0 3.0
C  ANGLE 10
C  THRESHOLD 2.5 0.5
C  HLOUT
C  CYCLES 10
C  !
C  !---- Definition of LABELS in Input and output files FILES
C  !
C  LABI FP=F_V2 SIGFP=SIGF_V2 FPH1=F_KHG SIGFPH1=SIGF_KHG  -
C  DPH1=DELANO_KHG SIGDPH1=SIGDPHANO_KHG FPH2=F_PT2 SIGFPH2=SIGF_PT2   -
C  DPH2=DELANO_PT2 SIGDPH2=SIGDPHANO_PT2 FPH3=FSHHG_V2 -
C  SIGFPH3=SIGFSHHG_V2 DPH3=DELANOSHHG_V2 SIGDPH3=SIGDPHANOSHHG_V2
C  !
C  !
C  LABO PHIB=PHI_BN FOM=FOM_BN  HLA=A HLB=B HLC=C DP=D
C  !
C  END
C
C  FP=F_V2 SIGFP=SIGF_V2
C  FPH1=F_KHG SIGFPH1=SIGF_KHG
C  DPH1=DELANO_KHG SIGDPH1=SIGDPHANO_KHG
C  FPH2=F_PT2 SIGFPH2=SIGF_PT2
C  DPH2=DELANO_PT2 SIGDPH2=SIGDPHANO_PT2
C  FPH3=FSHHG_V2 SIGFPH3=SIGFSHHG_V2
C  DPH3=DELANOSHHG_V2 SIGDPH3=SIGDPHANOSHHG_V2 ##
C  !
C  !----    Keywords for derivative 1
C  !
C  DERIVATIVE KHG 1
C  RESO 100 3.1
C  DCYCLE PHASE ALL REFCYC ALL KBOV ALL
C  ISOE 298 257 239 180 152 164 174 180 205 -
C       209 214 210 211 188 174 174 174 174
C  ANOE 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40
C  ATOM HG          0.1 0.26 0.5 1.5 1.5  BFAC   25.
C  ATREF X ALL Y ALL Z ALL OCC ALL   AOCC ALL
C  !
C  !----   Keywords for derivative 2
C  !
C  DERIVATIVE PT2 1
C  RESO 100 3.1
C  DCYCLE PHASE ALL REFCYC ALL KBOV ALL
C  ISOE 298 257 239 180 152 164 174 180 205 209 -
C       214 210 211 188 174 174 174 174
C  ANOE 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40
C  ATOM PT  0.000 0.000 0.000 1.925 1.925 BFAC 25.
C  ATREF OCC ALL   AOCC ALL
C  ATOM PT      -0.381 -0.013 -0.904 1.130 1.130 BFAC 25.
C  ATREF X ALL Y ALL Z ALL OCC ALL   AOCC ALL
C  ATOM PT      -0.356 -0.294 -0.414 1.832 1.832 BFAC 25.
C  ATREF X ALL Y ALL Z ALL OCC ALL   AOCC ALL
C  ATOM PT      -0.440 -0.872 -0.665 1.079 1.079 BFAC 25.
C  ATREF X ALL Y ALL Z ALL OCC ALL   AOCC ALL
C  !
C  !---- Keywords for derivative 3
C  !
C  DERIVATIVE SHHG2 1
C  RESO 100 5.0
C  DCYCLE PHASE ALL REFCYC ALL KBOV ALL
C  ISOE 298 257 239 180 152 164 174 180 205 -
C       209 214 210 211 188 174 174 174 174
C  ANOE 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40
C  ATOM HG        0.000 0.000 0.000 2.00 2.96 BFAC 25.
C  ATREF X ALL Y ALL Z ALL OCC ALL   AOCC ALL
C  ATOM HG       -0.384 -0.024 -0.907 1.004 1.510 BFAC 25.
C  ATREF X ALL Y ALL Z ALL OCC ALL   AOCC ALL
C  ATOM HG       -0.344 -0.302 -0.421 1.811 2.651 BFAC 25.
C  ATREF X ALL Y ALL Z ALL OCC ALL   AOCC ALL
C  ATOM HG       -0.431 -0.877 -0.674 1.530 1.526 BFAC 25.
C  ATREF X ALL Y ALL Z ALL OCC ALL   AOCC ALL
C
C END
C
C
C
C---- Program organization:
C     =====================
C
C  The main program call immediately subroutine RCARDS.
C  The input card data is read in by subroutine RCARDS
C  and it calls subroutine SFREAD2 to read the
C  atomic form factors from the libray file Atomsf.lib.
C
C  Upon return to main, subroutine FLAGS_MLP is called to set the phase and
C  refinement flags for this cycle.
C  All statistical variables are cleared to zero  and
C  estimates of the mean square lack of isomorphism are set
C  to the input values (on the first cycle) or to the values
C  calculated during the previous cycle.
C
C  Main reflection loop starts with statement number 200
C  in the main program.
C
C  For each reflection:
C
C  The data are read in and scaled and copied into arrays
C    ScaledFPH,ScaledVPH,ScaledDPH  and ScaledSigmaDPH,
C   and variables 
C   FNativeScaled,SigmaNative and FCALCA,FCALCB and FCALCW.
C
C  Subroutine FHCALC then calculates the heavy atom structure factors
C  as real and imaginary parts, anomalous scattering structure factors
C  if asked for, and derivatives of the structure factors with respect
C  to refined parameters.
C
C    At the end of the subroutine reflection is checked for being
C       centrosymmetric.
C
C  Subroutine PHASE calculates phase probabilities, by
C  multiplying phase probabilities for each derivative used
C  in refinement and Sym probability if outside phase information
C  is supplied.
C
C   Variable NOPHAS is set to .TRUE. if there
C   is no source of phase information for this reflection.
C   Derivates with no heavy atom sites count as the source
C   of phase information in the definition of variable NOPHAS.
C
C  Subroutine REFINE accumulates left and rigth hand side
C  of the heavy atom refining equation. It also accumulates
C  various refinement statistics.
C
C  On the last cycle subroutine OUTHKL writes native and
C  derivative structure  factors. It calls also subroutine
C  HLCOEFFS to calculate and output  A,B,C,D coefficients.
C  The error in calculating A,B,C,D existing in some old
C  versions of program PHARE has been fixed.
C
C  This ends the reflection loop, the only GO TO loop in the program.
C
C  Subroutine MATSOL solves system of equations, separatelly
C  for real and  anomalous differences.
C
C  EJD  Subroutine FINAL split into SHIFTS and FSTATS
C       There are several options for collecting statistics and
C       EJD does not know which is best.
C
C    In all cycles EXCEPT the last, some reflections
C    may be rejected from  the  calculation - only
C    those used for REFINEMENT will be included in
C    the statistical analysis.
C
C  On the last ( phasing) cycle all reflections within
C  the resolution limits  are included.
C
C  EJD has collected MEAN and RMS values for all terms.
C  there are 3 options for weighting these terms.
C
C   1)  a straight MEAN or RMS divided by
C       the number of reflections included.
C
C   2)  a weighted value using a NEW weight
C    This is equal to  FOM/(SIGFP**2 + SIGFPH**2)
C     where SIGFP = sig(Fp) and SIGFPH = sig(Fph)
C
C   3)  a weighted value using the old weight
C      EJD is not clear why this is used but here is the definition!
C   W = SIGFPH**2 + VCALC + Esq for this Derivative at this resolution.
C       VCALC = SIG(Fp)**2 *
C           ((FPSQ + FPA * FHA + FPB * FHB) / (FP * FPH))**2
C             FPA = FP * COS(PHIx) , FPB = FP * SIN(PHIx)
C              PHIx takes all values round the phase circle
C             FHA = FH * COS(PHIH)   FHB = FH * SIN(PHIH)
C
C
C    At THEEND the final coordinates and errors are output 
C    to the log file in a format suitable for input to another cycle.
C
C      MAIN PROGRAM
C      ============
C
C
C     Phase and refinement program
C
C   The following are defined in mlphare.fh
C
C  MaxNumResoBins       for  analysis - maximum is 8..
C  MaxNumRefCycles      for refinement - maximum is 10..
C  MaxNumHeavyAtoms     No. of heavy atoms - maximum 130
C  MaxNumDerivatives    No of derivatives allowed - maximum 20
C  MaxNumRefVariables   No of parameters to refine =
C                        11*MaxNumHeavyAtoms + 2*MaxNumDerivatives
C  MaxDataBatches       No batches of data sets per derivative; maximum = 8
C  MaxSizeMatrix        Size of correlation matrix - maximum is 99960
C                                            may be too small !!
C  MaxRefineFlags       flags for refine - 5 for real ( x y z  occ b ) -
C                                          5 anom...
C  NumExtraMtzCols      Extra columns of input carried to output file.
C
C
C   All output will have H K L S FP SIGFP PHIB  FOM
C  Flags for optional output
C  If IDFP  ne 0 output DP SIGDP
C  If IFC  ne 0 output FC
C  If IPC  ne 0 output  PHIC
C  If IWC  ne 0 output  WC
C  If IHLA ne 0 output A B C D:
C   IF IFPH(Kderiv) ne 0 Output FPH(Kderiv) SIGFPH(Kderiv)
C   IF IDPH(Kderiv) ne 0 Output DPH(Kderiv) SIGDPH(Kderiv)
C   IF IFH(Kderiv) ne 0 Output FH(Kderiv) PHIH(Kderiv)
C   IF IFHA(Kderiv) ne 0 Output FH"(Kderiv) PHIH"(Kderiv)
C
C   D3 is never used..
C   WT3(..) is the same as NumPhasedperDeriv(..) ( I have checked..)
C  R1(..) to R7(..) WT4(..) and WT5(..) are statistics collected on the
c   on the input FPH scale - this seems pointless!!
C R11 is exactly the same as d11(..)!
C
C
C  D1-SFPH,  Sum( FPHobs(i) )
C  D2-SALOC  Sum( Pr(phase)*(FPHobs(i)-FPHcalc(i)) )
C  D3 out
c  WT1 - SW  Sum( W1(i) )  W1 is mod of Pr(phase)
C  WT2 - SWT2  Sum( W2(i) )  W2 is mod of Pr(phase) or perhaps not???
C  D4-SumFHcalc  Sum( FHcalc(i) )
C  D5-SumWghtFPHobsFPHcalc  Sum( W1*(FPHobs(i)-FPHcalc(i)) )
C  D6-SumSqrdPrFPHobsFPHcalc  Sum( Pr(phase)*(FPHobs(i)-FPHcalc(i))**2 )
C  D7-SFHSQ  Sum( FHobs(i)**2 )
c  D8-SumWgt2FPHobsSqrd Sum( W2*FPHobs(i)**2 )
C  D9-SumW1SqrdLackClosure Sum( W1*(FPHobs(i)-FPHcalc(i))**2 )
C  D10-SumSqrdFPHobsFnat Sum( (FPHobs(i)-FPobs)**2 )
C  WT3 out
C  Add SumFigMerit  
C  SumDeltaPhi  ( phase difference between protein and Alph(h)
C  SumFigMerit      Sum( (FOM )
C  SumDeltaPhi     Sum( ABS(PHIH(i)-PHIBest) )
C  Seperate information for anomalous data
c  WT6 - SWA  Sum( WA(i) )  WA is mod of Pr(phase) for anom data
C  D11-SADCSQ Sum( (FPHcalc+(i)-FPHcalc-)**2 )
C  D12-SWLCA Sum(WA*((FPHobs(i)-FPobs) - (FPHobs+(i)-FPHobs-))**2 )
C  D13-SADOBS Sum( (FPHobs+(i)-FPHobs-)**2 )
C   ??? ESQ() ?? ASQ() ???
C
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
C     ..
C     .. Scalars in Common ..
      REAL CentricTestFlag,     CutOffNatSigma,
     +      FcalcA,
     +       FcalcB,              FcalcW,
     +        FNativeScaled,       VarNativeSc,
     +         SigmaNatScale
      REAL SMAXP,SMINP,SSQOL4,STMAX,STMIN,THR,
     +     ABEST,ACL,CBEST,FOM,SBEST,SCALE
      INTEGER IAngleStep,       ICurrentCycle,
     +         Ifom,             NumDerivatives,
     +          NumhklMonitored,  NumMatrixElements,
     +           NumRefCycles,     NumRefVariables, Nskip,
     +            NumResoBins,      KRefineCycleFlag
      INTEGER ICENFLG,IDFP,IFC,IAVE,IAVF,ICOR,IHLA,IIN,INC,IOUT,IPC,
     +        IPHIB,IRMSE,IRMSF,ISTAT,IW1AVE,IW1RMS,IW2AVE,
     +        IW2RMS,IWC,ISCRUN
      LOGICAL LAST,LAST1,LCOR,LELEC,LAPPLY,LSTAT,NOPHAS,
     +        Lscript,LCoord
C     ..
C     .. Arrays in Common ..
      REAL ScaledFPH,
     +      ScaledDPH,
     +       ScaledSigmaDPH,
     +         RmsAnomalError,
     +          RmsIsomorphError
      REAL
     +     DerivativeNativeScale,
     +      DerivMaxResol,
     +       DerivMinResol,
     +        DerivIsoLimit,
     +         DerivAnomLimits,
     +          DerivSigmaLimit,
     +           DerivSigmaScale,
     +            DerivOverallBfact,
     +             DerivScaleToNative
      REAL 
     +  SumAbsFPHobsFnat,         SumPrFPHobsFPHcalc,
     +   SumSqrdFPHobsFnat,        SumFHcalc,SumFHA,
     +    SumFigMerit,              SumFNativeScaled,
     +     SumFPHobs,                SumSqrdPrFPHobsFPHcalc,
     +      SumDeltaPhi,              SumSqrdDeltaPhi,
     +       SumWsig,                  SumWsigA,
     +        SumWsigAADO,              SumWsigADOS,
     +         SumWsigFPHobsFnat,        SumSqrdWsigFPHobsFnat,
     +          SumWsigLCA,               SumWsigLCAQ,
     +           SumWsigLackClosure,       SumLackClosureWgtSqrd,
     +            SumAnomWgtModPrPhase,     SumAnomWgtModPrPhaseADO,
     +             SumAnomWgtModPrPhaseDOS,  SumW1FPHobsFnat,
     +              SumW1FPHobsFnatSqrd,      SumWghtFPHobsFPHcalc,
     +               SumW1SqrdLackClosure
      REAL FHAim,AFM,AMAT,AOCC,FHArl,ASQ,B1,B2,B3,B4,B5,B6,BFM,
     +     CFM,DERIV1,DERIV2,FHim,ESQ,FPP,OCC,P,PNORM,
     +     RECSQ,RMAT,FHrl,SAADC,SAADO,SADCSQ,SADOSQ,SASQ,SESQ,
     +     SLCA,SLCAQ,STAB,SW,SWLCA,SWLCAQ,TCELL,ScaledVPH,X,Y,Z
      INTEGER IDPH,IFADD,IFH,IFHA,IFPH,IndexRefFlags,JNDEX,JPOS,
     +        Mcount,NumPhasedperDeriv,NumAnomPhasesPerDeriv,
     +        NAtomsPerDeriv,NDAT,NTROP
      LOGICAL CALAFF,LANOM,LBOV,LEAVE,
     +        LPhaseFlagPerDerivative,LRefineFlagPerDerivative
      CHARACTER ATNAME*4,DerivTitle*80
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION DET1,DET2
      REAL ACALC,CONV,DDD,DST,FCALC,FPRO,HH,HK,HL,RR1,RR2,SDSUM,
     +     SIGFPRO,XX
      INTEGER I,IAT,ICEN,ICHK,ICYCL,Kderiv,IHATOM,IHH,IHK,IHL,II,J,J1,
     +        J2,JA,JB,JJ,KA,KB,MM,MTZIN,MTZOUT,NA,NB,NCYCL1,NN,
     +        NREFL,NREJ,IXYZOUT,IZ
      LOGICAL EOF
      CHARACTER TITLE*80,ATLAB*8,RESNO*2
C     ..
C     .. Local Arrays ..
      DOUBLE PRECISION RHS(MaxNumRefVariables),
     +                 TRIX(MaxSizeMatrix)
      REAL ADATA(MaxMtzCols),
     +     DPH(MaxNumDerivatives),
     +     FPH(MaxNumDerivatives),
     +     SIGMA(MaxNumDerivatives),
     +     BOUT(6)
      INTEGER JH(3)
      LOGICAL LOGMSS(MaxMtzCols)

C Variables for harvesting
      REAL OccESD(MaxNumHeavyAtoms),AoccESD(MaxNumHeavyAtoms)
      REAL Power(2,MaxNumDerivatives),Rcullis(3,MaxNumDerivatives)
      INTEGER KReflns(3,MaxNumDerivatives)
      INTEGER IvalueNotDet
      REAL    ValueNotDet
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      LOGICAL VAXVMS
      EXTERNAL LENSTR,VAXVMS
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR,CCPFYP,CCPRCS,CENTR,FHCALC,FLAGS_MLP,FSTATS,
     +  LRREFF,LRREWD,LWCLOS,MATSOL,MTZINI,OUTHKL,PHASE,RCARDS,REFINE,
     +         SHIFTS,XYZINIT,XYZOPEN,XYZATOM,XYZCOORD,XYZADVANCE,
     +         XYZCLOSE
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,COS,EXP,INT,MOD,NINT,SIN,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANALYS/ICOR,ISTAT,IAVF,IRMSF,IAVE,IRMSE,IW1AVE,IW1RMS,
     +       IW2AVE,IW2RMS,Ifom,NumhklMonitored
      COMMON /CENZON/ICENFLG
      COMMON /CURVE/P(360),PNORM(360),IIN,INC
      COMMON /DERIV/  DERIV1(MaxNumRefVariables),
     +                 DERIV2(MaxNumRefVariables),
     +                  JNDEX(2*MaxNumDerivatives+1),
     +                   NumRefVariables,SSQOL4
      COMMON /FASE/  
     +  RmsIsomorphError(MaxNumDerivatives,MaxNumResoBins),
     +   RmsAnomalError(MaxNumDerivatives,MaxNumResoBins),
     +     DerivSigmaLimit(MaxNumDerivatives),
     +      DerivIsoLimit(MaxNumDerivatives),
     +       DerivAnomLimits(2,MaxNumDerivatives),
     +        DerivMinResol(2,MaxNumDerivatives),
     +         DerivMaxResol(2,MaxNumDerivatives),
     +          KRefineCycleFlag(MaxNumRefCycles),
     +           ScaledFPH(MaxNumDerivatives),
     +            ScaledDPH(MaxNumDerivatives),
     +             ScaledVPH(MaxNumDerivatives),
     +              ScaledSigmaDPH(MaxNumDerivatives),
     +               FHrl(MaxNumDerivatives),
     +                FHim(MaxNumDerivatives),
     +                 FHArl(MaxNumDerivatives),
     +                  FHAim(MaxNumDerivatives),
     +                   LPhaseFlagPerDerivative(MaxNumDerivatives+1),
     +                    CentricTestFlag,FNativeScaled,
     +                     VarNativeSc,NumDerivatives,
     +                      IAngleStep,NumResoBins,ICurrentCycle,
     +                       LAST,LAST1
      COMMON /FIRST/
     +    SCALE,SigmaNatScale,CutOffNatSigma,SMAXP,SMINP,
     +     NumMatrixElements,NumRefCycles,Nskip,
     +      JPOS(2*MaxNumDerivatives),
     +       AMAT(3,3),
     +        RMAT(3,3),
     +         RECSQ(6),
     +          TCELL(6)
      COMMON /HEAVY/
     +  DerivSigmaScale(MaxNumDerivatives),    
     +  DerivScaleToNative(MaxNumDerivatives),
     +   DerivativeNativeScale(MaxNumDerivatives),   
     +    DerivOverallBfact(MaxNumDerivatives),
     +    IndexRefFlags(MaxNumDerivatives+1),  
     +     NAtomsPerDeriv(MaxNumDerivatives),
     +     OCC(MaxNumHeavyAtoms,MaxDataBatches),
     +      AOCC(MaxNumHeavyAtoms,MaxDataBatches),
     +       AFM(MaxNumHeavyAtoms,4),   BFM(MaxNumHeavyAtoms,4),
     +        CFM(MaxNumHeavyAtoms),     FPP(MaxNumHeavyAtoms),
     +         NTROP(MaxNumHeavyAtoms),   B1(MaxNumHeavyAtoms),
     +          B2(MaxNumHeavyAtoms),      B3(MaxNumHeavyAtoms),
     +           B4(MaxNumHeavyAtoms),      B5(MaxNumHeavyAtoms),
     +            B6(MaxNumHeavyAtoms),      X(MaxNumHeavyAtoms),
     +             Y(MaxNumHeavyAtoms),       Z(MaxNumHeavyAtoms),
     +              NDAT(MaxNumDerivatives),   
     +               CALAFF(MaxNumHeavyAtoms),
     +                LRefineFlagPerDerivative(MaxNumDerivatives),
     +                 LANOM(MaxNumDerivatives),
     +                  LBOV(MaxNumDerivatives),
     +                   LEAVE(MaxRefineFlags,MaxNumHeavyAtoms),
     +                    LELEC,LAPPLY
      COMMON /HEAVYC/ATNAME(MaxNumHeavyAtoms)
      COMMON /IRHARV/ IvalueNotDet, ValueNotDet 
      COMMON /OUTPT/
     +   IDFP,IFC,IPC,IWC,IPHIB,IHLA,IOUT,ISCRUN,
     +    IFPH(MaxNumDerivatives),
     +     IDPH(MaxNumDerivatives),
     +      IFH(MaxNumDerivatives),
     +       IFHA(MaxNumDerivatives),
     +        IFADD(MaxMtzCols),
     +         Lscript,LCoord
      COMMON /PHAS/
     +     FOM,ABEST,CBEST,SBEST,
     +      FcalcA,FcalcB,FcalcW,
     +       NOPHAS
      COMMON /STATA1/
     + Mcount(MaxNumResoBins,2),
     + SumFigMerit(MaxNumResoBins,2),
     + NumPhasedperDeriv(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumDeltaPhi(MaxNumDerivatives,MaxNumResoBins,
     +              MaxNumFigMeritBins,2),
     + SumSqrdDeltaPhi(MaxNumDerivatives,MaxNumResoBins,
     +                  MaxNumFigMeritBins,2),
     + SumFNativeScaled(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumFPHobs(MaxNumDerivatives,MaxNumResoBins,
     +            MaxNumFigMeritBins,2),
     + SumFHcalc(MaxNumDerivatives,MaxNumResoBins,
     +            MaxNumFigMeritBins,2),
     + SumFHA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAbsFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumPrFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                     MaxNumFigMeritBins,2),
     + SumWsigFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2)
      COMMON /STATA3/
     + SumWsigLackClosure(MaxNumDerivatives,MaxNumResoBins,
     +                     MaxNumFigMeritBins,2),
     + SumW1FPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                  MaxNumFigMeritBins,2),
     + SumWghtFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins,2),
     + SumSqrdFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumSqrdPrFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                         MaxNumFigMeritBins,2),
     + SumSqrdWsigFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                        MaxNumFigMeritBins,2),
     + SumLackClosureWgtSqrd(MaxNumDerivatives,MaxNumResoBins,
     +                        MaxNumFigMeritBins,2),
     + SumW1FPHobsFnatSqrd(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins,2),
     + SumW1SqrdLackClosure(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins,2),
     + SW(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SumWsig(MaxNumDerivatives,MaxNumResoBins,
     +          MaxNumFigMeritBins,2),
     + NumAnomPhasesPerDeriv(MaxNumDerivatives,MaxNumResoBins,
     +                        MaxNumFigMeritBins),
     + SAADC(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins)
      COMMON /STATB2/
     + SADCSQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SAADO(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SLCA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SADOSQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SLCAQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumWsigAADO(MaxNumDerivatives,MaxNumResoBins,
     +              MaxNumFigMeritBins),
     + SumWsigLCA(MaxNumDerivatives,MaxNumResoBins,
     +             MaxNumFigMeritBins),
     + SumWsigADOS(MaxNumDerivatives,MaxNumResoBins,
     +              MaxNumFigMeritBins),
     + SumWsigLCAQ(MaxNumDerivatives,MaxNumResoBins,
     +              MaxNumFigMeritBins),
     + SumAnomWgtModPrPhaseADO(MaxNumDerivatives,MaxNumResoBins,
     +                          MaxNumFigMeritBins)
      COMMON /STATB4/
     + SWLCA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhaseDOS(MaxNumDerivatives,MaxNumResoBins,
     +                          MaxNumFigMeritBins),
     + SWLCAQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhase(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins),
     + SumWsigA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SESQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SASQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + ESQ(MaxNumDerivatives,MaxNumResoBins),
     + ASQ(MaxNumDerivatives,MaxNumResoBins),
     + STMIN,STMAX,THR,ACL,LCOR,LSTAT
      COMMON /STATC/DerivTitle(MaxNumDerivatives+1)
      COMMON /TABLES/STAB(451)
C
C          **************************************************
      CALL CCPFYP
      CALL MTZINI
      CALL CCPRCS(6,'MLPHARE','$Date: 2008/04/28 14:18:57 $')
C          **************************************************
C
      XX = TWOPI/360.0
      MTZIN = 1
      MTZOUT = 1
C
C
      DO 10 I = 1,451
        STAB(I) = SIN((I-1)*XX)
   10 CONTINUE
C
C
      CONV = 360.0/TWOPI
C
C          **********************************
      CALL RCARDS(TITLE,MTZIN,MTZOUT,IXYZOUT)
C          **********************************
C
      DO 11 I=1,MaxNumHeavyAtoms
        OccESD(I) = ValueNotDet
        AoccESD(I) = ValueNotDet
 11   CONTINUE
      DO 12 I=1,MaxNumDerivatives
        Power(1,I)= ValueNotDet
        Power(2,I)= ValueNotDet
        Rcullis(1,I) = IvalueNotDet
        Rcullis(2,I) = IvalueNotDet
        Rcullis(3,I) = IvalueNotDet
        KReflns(1,I) = IvalueNotDet
        KReflns(2,I) = IvalueNotDet
        KReflns(3,I) = IvalueNotDet
 12   CONTINUE
C
      IIN = 1
      INC = IAngleStep
C
      WRITE(6,FMT=9010)
 9010 FORMAT (/,/,
     + 4X,'*********************************************************',/,
     + 4X,'*               START OF MLPHARE PROCEDURE              *',/,
     + 4X,'*********************************************************',
     + /,/)
C
        WRITE (6,FMT=9020) TITLE(1:LENSTR(TITLE))
 9020   FORMAT (' Title : "',A,'"',/)
C
C---- each new cycle starts here
C
      NCYCL1 = NumRefCycles - 1
C
C
      DO 170 ICYCL = 1,NumRefCycles
        ICurrentCycle = ICYCL
C
C----  last=true for last cycle only
C
        LAST = NumRefCycles .EQ. ICurrentCycle
        LAST1 = NCYCL1 .EQ. ICurrentCycle
C
C
        WRITE (6,FMT=6000) ICurrentCycle
 6000   FORMAT (/,
     +  ' ====== CYCLE ',I3,
     +  ' ===========================================================')
C
        IF (LAST1) THEN
          WRITE(6,FMT='(/,1X,A)')'This is the last REFINEMENT cycle'
        END IF
        IF (LAST) THEN
          WRITE(6,FMT='(/,1X,A)')'This is the last cycle - PHASING ONLY'
        END IF
C
C----   FLAGS_MLP sets up the  refinement flags for this cycle.
C
C            ***************************************************
        CALL FLAGS_MLP(JNDEX,JPOS,NumMatrixElements,NumRefVariables)
C            ***************************************************
C
        DO 30 I = 1,NumDerivatives
          WRITE (6,FMT=6002) I, 
     +               (SQRT(ABS(ESQ(I,J))),J=1,MaxNumResoBins)
 6002     FORMAT (/,2X,
     +'Compound',I3,/,2X,
     +'-----------',/,2X,
     +'Rms isomorphous error:',/,
     +5X,8F9.2)
          IF (LANOM(I)) WRITE (6,FMT=6004) 
     +                  (SQRT(ABS(ASQ(I,J))),J=1,MaxNumResoBins)
 6004     FORMAT (2X,
     +'Rms anomalous error:',/,
     +5X,8F9.2)
C
C
          DO 20 J = 1,MaxNumResoBins
            RmsIsomorphError(I,J) = ESQ(I,J)
            RmsAnomalError(I,J)   = ASQ(I,J)
   20     CONTINUE
C
C
   30   CONTINUE
C
C
        DO 40 I = 1,NumMatrixElements
          TRIX(I) = 0.0D0
   40   CONTINUE
C
C
        DO 50 I = 1,NumRefVariables
          RHS(I) = 0.0D0
   50   CONTINUE
C
C---- ICL sets common/stat/ to zero from Mcount through nfig
C
        DO 80 J = 1,MaxNumFigMeritBins
          DO 70 I = 1,MaxNumResoBins
            Mcount(I,1)      = 0
            Mcount(I,2)      = 0
            SumFigMerit(I,1) = 0.0
            SumFigMerit(I,2) = 0.0
C
C
            DO 60 II = 1,MaxNumDerivatives
              NumAnomPhasesPerDeriv(II,I,J)    = 0
              NumPhasedperDeriv(II,I,J,1)      = 0
              NumPhasedperDeriv(II,I,J,2)      = 0
              ESQ(II,I)                        = 0.0
              ASQ(II,I)                        = 0.0
              SumFNativeScaled(II,I,J,1)       = 0.0
              SumFNativeScaled(II,I,J,2)       = 0.0
              SumFPHobs(II,I,J,1)              = 0.0
              SumFPHobs(II,I,J,2)              = 0.0
              SumFHcalc(II,I,J,1)              = 0.0
              SumFHcalc(II,I,J,2)              = 0.0
              SumFHA(II,I,J)                   = 0.0
              SumAbsFPHobsFnat(II,I,J,1)       = 0.0
              SumAbsFPHobsFnat(II,I,J,2)       = 0.0
              SumSqrdFPHobsFnat(II,I,J,1)      = 0.0
              SumSqrdFPHobsFnat(II,I,J,2)      = 0.0
              SumWsigFPHobsFnat(II,I,J,1)      = 0.0
              SumWsigFPHobsFnat(II,I,J,2)      = 0.0
              SumSqrdWsigFPHobsFnat(II,I,J,1)  = 0.0
              SumSqrdWsigFPHobsFnat(II,I,J,2)  = 0.0
              SumW1FPHobsFnat(II,I,J,1)        = 0.0
              SumW1FPHobsFnat(II,I,J,2)        = 0.0
              SumW1FPHobsFnatSqrd(II,I,J,1)    = 0.0
              SumW1FPHobsFnatSqrd(II,I,J,2)    = 0.0
              SumPrFPHobsFPHcalc(II,I,J,1)     = 0.0
              SumPrFPHobsFPHcalc(II,I,J,2)     = 0.0
              SumSqrdPrFPHobsFPHcalc(II,I,J,2) = 0.0
              SumSqrdPrFPHobsFPHcalc(II,I,J,1) = 0.0
              SumWsigLackClosure(II,I,J,1)     = 0.0
              SumWsigLackClosure(II,I,J,2)     = 0.0
              SumLackClosureWgtSqrd(II,I,J,1)  = 0.0
              SumLackClosureWgtSqrd(II,I,J,2)  = 0.0
              SumWghtFPHobsFPHcalc(II,I,J,1)   = 0.0
              SumWghtFPHobsFPHcalc(II,I,J,2)   = 0.0
              SumW1SqrdLackClosure(II,I,J,1)   = 0.0
              SumW1SqrdLackClosure(II,I,J,2)   = 0.0
              SumSqrdDeltaPhi(II,I,J,1)        = 0.0
              SumSqrdDeltaPhi(II,I,J,2)        = 0.0
              SumDeltaPhi(II,I,J,1)            = 0.0
              SumDeltaPhi(II,I,J,2)            = 0.0
              SW(II,I,J,1)                     = 0.0
              SW(II,I,J,2)                     = 0.0
              SumWsig(II,I,J,1)                = 0.0
              SumWsig(II,I,J,2)                = 0.0
              SAADC(II,I,J)                    = 0.0 
              SADCSQ(II,I,J)                   = 0.0
              SAADO(II,I,J)                    = 0.0
              SADOSQ(II,I,J)                   = 0.0
              SumWsigAADO(II,I,J)              = 0.0
              SumWsigADOS(II,I,J)              = 0.0
              SumAnomWgtModPrPhaseADO(II,I,J)  = 0.0
              SumAnomWgtModPrPhaseDOS(II,I,J)  = 0.0
              SLCA(II,I,J)                     = 0.0
              SLCAQ(II,I,J)                    = 0.0
              SumWsigLCA(II,I,J)               = 0.0
              SumWsigLCAQ(II,I,J)              = 0.0
              SWLCA(II,I,J)                    = 0.0
              SWLCAQ(II,I,J)                   = 0.0
              SumAnomWgtModPrPhase(II,I,J)     = 0.0
              SumWsigA(II,I,J)                 = 0.0
              SESQ(II,I,J,1)                   = 0.0
              SESQ(II,I,J,2)                   = 0.0
              SASQ(II,I,J)                     = 0.0
   60       CONTINUE
   70     CONTINUE
   80   CONTINUE
C
C
        NREJ   = 0
        NREFR  = 0
        NREFL  = 0
C
C---- Start each block here
C
C       FcalcA and FcalcB are Fc cos(phic) Fc sin(phic)
C          FCALCE  = rms(<Fobs -Fcalc) ( sintheta)
C
   90   CONTINUE
C
C
C  LOGMSS(I) returned FALSE if no magic_no set or if ADATA(I) = magic_no
C
C            ******************************
        CALL LRREFF(MTZIN,SSQOL4,ADATA,EOF)
        CALL LRREFM(MTZIN,LOGMSS)
C            ******************************
C
        IF (EOF) GO TO 130
C
C  Dont do refinement if reflection outside resolution limits.
C  Dont do phasing    if reflection above maximum resolution.
C
        IF (.NOT.LAST .AND. (SSQOL4.GT.SMAXP.OR.
     +      SSQOL4.LT.SMINP)) GO TO 90
        IF (LAST .AND. (SSQOL4.GT.SMAXP)) GO TO 90
        NREFR  = NREFR + 1
         IF(.NOT.LAST .AND. NSKIP.GT.1) THEN
            ICHK = MOD( NREFR+ICYCL,NSKIP)
            IF(ICHK.NE.0) GO TO 90
         END IF

C
C
        DST = SQRT(SSQOL4)
        NumResoBins = 
     +    INT((DST-STMIN)*MaxNumResoBins/ (STMAX-STMIN)) + 1
        IF (NumResoBins.GT.MaxNumResoBins) 
     +      NumResoBins = MaxNumResoBins
        IF (NumResoBins.LT.1) NumResoBins = 1
C
C
        IHH   = NINT(ADATA(1))
        IHK   = NINT(ADATA(2))
        IHL   = NINT(ADATA(3))
        JH(1) = NINT(ADATA(1))
        JH(2) = NINT(ADATA(2))
        JH(3) = NINT(ADATA(3))
C
C
        FPRO    = 0.0
        SIGFPRO = 0.0
        NOPHAS        = .TRUE.
        FOM           = 0.0
        CBEST         = 1.0
        SBEST         = 0.0
        ABEST         = -99999.0
        SDSUM  = 0.0
C
C---- Dont do anything if FP = 0.0 except output 
C     reflection on last cycle
C
        IF (LOGMSS(4) .OR. LOGMSS(5) ) GO TO 120
        IF (ADATA(4).LT.0.000001) GO TO 120
        FPRO    = ADATA(4)
        SIGFPRO = ADATA(5)
C
C----   If cenflg set only use centric data for refinement
C       PHASE on all reflections
C
        IF (.NOT.LAST .OR. IOUT.EQ.0) THEN
          IF (ICENFLG.NE.0) THEN
C
C               ***************
            CALL CENTR(JH,ICEN)
C               ***************
C
            IF (ICEN.EQ.0) GO TO 90
          END IF
        END IF
C
C----  If CutOffNatSigma set only use terms
C      where fp > CutOffNatSigma*SIGFP  for refinement
C      PHASE on all reflections
C
        IF (.NOT.LAST .OR. IOUT.EQ.0) THEN
          IF (ABS(CutOffNatSigma).GT.0.00001) THEN
            IF (FPRO.LT.CutOffNatSigma*SIGFPRO) GO TO 90
          END IF
        END IF
C
        DO 100 Kderiv = 1,NumDerivatives
C
C----  IXL(..)  is the " Data number ..- always 1 for us.. 
ccx                       THEN GET RID OF IT
C
          FPH(Kderiv)                    = 0.0
          SIGMA(Kderiv)                  = 0.0
          DPH(Kderiv)            = 0.0
          ScaledSigmaDPH(Kderiv) = 0.0
C
C
          IF (LOGMSS(4*Kderiv+4) .OR. LOGMSS(4*Kderiv+5))  GO TO 100
          IF (.NOT.LAST ) THEN
            IF (SSQOL4.LT.DerivMinResol(1,Kderiv) .OR.
     +         SSQOL4.GT.DerivMaxResol(1,Kderiv)) GO TO 100
          END IF
C
          IF (LAST .AND. 
     +        (SSQOL4.GT.DerivMaxResol(1,Kderiv))) GO TO 100
          FPH(Kderiv)   = ADATA(4*Kderiv+4)
          SIGMA(Kderiv) = ADATA(4*Kderiv+5)
C
C
          IF (LOGMSS(4*Kderiv+6).OR. LOGMSS(4*Kderiv+7))  GO TO 100
          IF (ABS(ADATA(4*Kderiv+7)).GE.0.00001) THEN
            DPH(Kderiv)            = ADATA(4*Kderiv+6)
            ScaledSigmaDPH(Kderiv) = ADATA(4*Kderiv+7)
          END IF
C
C---- Set ScaledSigmaDPH(..) = 0 
C          if reflection outside anom data range.
C
          IF (SSQOL4.LT.DerivMinResol(2,Kderiv) .OR.
     +        SSQOL4.GT.DerivMaxResol(2,Kderiv)) 
     +         ScaledSigmaDPH(Kderiv) = 0.0
  100   CONTINUE
        ACALC  = 0.
        FcalcA = 0.
        FcalcB = 0.
        FcalcW = 1.
        FCALC = 0.0
C
C
        IF (KRefineCycleFlag(ICYCL).NE.0) THEN
          IF (IFC.EQ.0) FCALC = FPRO
          IF (.NOT. LOGMSS(88)) THEN
            IF (IFC.NE.0) FCALC = ADATA(88)
          END IF
          IF (.NOT. LOGMSS(90)) THEN
            IF (IWC.GT.0) FcalcW = ADATA(90)
          END IF
          IF(.NOT. LOGMSS(89)) THEN
            ACALC  = ADATA(89)
            FcalcA = COS(ACALC/CONV)*FCALC*FcalcW
            FcalcB = SIN(ACALC/CONV)*FCALC*FcalcW
          ELSE
            ACALC  = 0.
            FcalcA = 0.
            FcalcB = 0.
          END IF
C
C----  Is FcalcW = wt?
C
        END IF
C
C
        NREFL = NREFL + 1
        ICHK  = 0
        IF (NumhklMonitored.GT.0) ICHK = MOD(NREFL,NumhklMonitored)
        HH = IHH
        HK = IHK
        HL = IHL
C
C
        IF (.NOT.LAST .OR. IOUT.EQ.0) THEN
          IF (FPRO.LE.0.0) GO TO 90
        END IF
C
C
        FNativeScaled = SCALE*FPRO
        VarNativeSc   = (SCALE*SigmaNatScale*SIGFPRO)**2
C
C
C---- copy data into working area
C
        FcalcA = FcalcA*SCALE
        FcalcB = FcalcB*SCALE
        SDSUM  = 0.0
C
C---- MONITORED REFLECTIONS
C
      IF (ICHK.EQ.1) THEN
        WRITE(6,FMT='(/,X,A,I5,A,3I4,/,X,A)')
     +   '*** Monitoring: reflection no.',NREFL,'   HKL = ',ihh,ihk,ihl,
     +   '------------------------------------------------------------'
        WRITE(6,FMT='(A,A)')
     +   '   FNAT sdFNAT    FcalcA FcalcB       Fph  sdFph',
     +   '  REF   FCALC   ACALC  FCALCW'
        WRITE (6,FMT='(2F7.1,3x,2F7.1,3x,2F7.1,I5,3F8.2)')
     +  FNativeScaled,VarNativeSc,FcalcA,FcalcB,
     +  FPH(1),SIGMA(1),KRefineCycleFlag(ICYCL),FCALC,ACALC,FCALCW
      END IF
C
        DO 110 Kderiv = 1,NumDerivatives
C
C----  If DerivSigmaLimit set only use terms
C      where fph > DerivSigmaLimit*SIGFPh  for refinement
C      PHASE on all reflections
C
C      Use ScaledFPH etc = 0 to ecxlude reflections later on
C
C   Add all SD  - if all = 0.0 no point in phasing.
C
          ScaledFPH(Kderiv) = 0.0
          ScaledVPH(Kderiv) = 0.0
          ScaledDPH(Kderiv) = 0.0
          IF (FPH(Kderiv).LE.0.0 .OR. SIGMA(Kderiv).LE.0.0) GO TO 110
C
C----  If DerivSigmaLimit set only use terms
C      where fph > DerivSigmaLimit*SIGFPh  for refinement
C
C
          IF (.NOT.LAST .OR. IOUT.EQ.0) THEN
            IF (DerivSigmaLimit(Kderiv).GT.0.00001) THEN
              IF (FPH(Kderiv).LT.
     +             DerivSigmaLimit(Kderiv)*SIGMA(Kderiv)) 
     +              GO TO 110
            END IF
          END IF
C
C
          DerivativeNativeScale(Kderiv) = 
     +       EXP(-DerivOverallBfact(Kderiv)*SSQOL4/4.0)/
     +            DerivScaleToNative(Kderiv)
          XX = DerivativeNativeScale(Kderiv)*SCALE
          ScaledFPH(Kderiv)   = FPH(Kderiv)*XX
          ScaledVPH(Kderiv)   = (DerivSigmaScale(Kderiv)*XX*
     +                     SIGMA(Kderiv))**2
C
C----  If DerivIsoLimit set only use terms
C      where fph-fp  < DerivIsoLimit for refinement
C
          IF (.NOT.LAST .OR. IOUT.EQ.0) THEN
            IF (DerivIsoLimit(Kderiv).GT.0.00001) THEN
              DDD = ABS(ScaledFPH(Kderiv)-FNativeScaled)
              IF (DDD.GT.DerivIsoLimit(Kderiv)) THEN
                ScaledFPH(Kderiv) = 0.0
                ScaledVPH(Kderiv) = 0.0
              END IF
            END IF
          END IF
C
C
          IF (LANOM(Kderiv)) THEN
            IF (.NOT.LOGMSS(4*Kderiv+6)) THEN
              ScaledSigmaDPH(Kderiv) = 
     +          ScaledSigmaDPH(Kderiv)*XX
              ScaledDPH(Kderiv)   = DPH(Kderiv)*XX
C
C----  If DerivAnomLimits(1,..)  set only use terms
C      where fph(+)-fph(-)  < DerivAnomLimits(1,  for refinement
C
              IF (.NOT.LAST .OR. IOUT.EQ.0) THEN
                IF (DerivAnomLimits(1,Kderiv).GT.0.00001) THEN
                  DDD = ABS(DPH(Kderiv))
C
C----  If DerivAnomLimits(1,..)  set only use terms
C      where fph(+)-fph(-)  < DerivAnomLimits for refinement
C
                  IF (DDD.GT.DerivAnomLimits(1,Kderiv)) THEN
                    ScaledSigmaDPH(Kderiv) = 0.0
                    ScaledDPH(Kderiv)      = 0.0
                  END IF
C
C----   only use terms
C      where fph(+)-fph(-)  < DerivAnomLimits(2,  for refinement
C  Default DerivAnomLimits(2..) = -100.0
C
                  IF (DDD.LT.DerivAnomLimits(2,Kderiv)) THEN
                    ScaledSigmaDPH(Kderiv) = 0.0
                    ScaledDPH(Kderiv)      = 0.0
                  END IF
                END IF
              END IF
            END IF
          END IF
C
C
          SDSUM = ScaledVPH(Kderiv) + SDSUM + ScaledSigmaDPH(Kderiv)
  110   CONTINUE
C
C----   No phase information here.
C
        IF (SDSUM.LE.0.0001) THEN
          IF (ICHK.EQ.1 .AND. NOPHAS)
     +         WRITE(6,FMT='(/,A)')
     +         ' ** No phase information for this reflection'
          GO TO 120
        END IF
C
C---- calculates FH parameters -  returned in COMMON /FASE/
C
C            ******************
        CALL FHCALC(HH,HK,HL)
C            ******************
C
C---- Obtain phase angle for protein
C
C       uses FH data   from COMMON /FASE/ -
C       fills COMMON /PHAS/ and CURV (probability curve)
C
C       Call first to set phases from all derivatives assigned for "PHASE ALL"
C
        IF (.NOT.LAST) THEN
C              **********************
          CALL PHASE(HH,HK,HL,ICHK,1)
C              **********************
C
C---- This sr gets refinement sums and accumulates statistics.
C
          IF (.NOT.NOPHAS) THEN
C                ********************************************
            CALL REFINE(TRIX,RHS,JPOS,NREJ,DST,HH,HK,HL,ICHK)
C                ********************************************
          END IF
        END IF 
C
C
C----  fourier output
C
  120   CONTINUE
C  For last cycle phase on everything and output results; 
        IF (LAST .AND. ( IOUT.NE.0 .OR. ISTAT.NE.0)) THEN
C                      no point phasing id SDSUM 0.0, just output
C              **********************
          IF(SDSUM.GE.0.0001) CALL PHASE(HH,HK,HL,ICHK,2)
C              **********************
C
C     Call SR REFINE only to accumulate final statistics
C              ********************************************
          IF(SDSUM.GE.0.0001 .AND. ISTAT.NE.0)  
     +     CALL REFINE(TRIX,RHS,JPOS,NREJ,DST,HH,HK,HL,ICHK)
C              ********************************************
C
C              *********************************************
          IF(IOUT.NE.0)
     +    CALL OUTHKL(MTZIN,MTZOUT,ADATA,LOGMSS,SSQOL4,ICHK)
C              *********************************************
C
        END IF
C  -- return for next reflection
C
        GO TO 90
C
C---- end of refinement cycle
C
  130   CONTINUE
        IF(LAST) WRITE(6,'(A)') '  *** Finished phasing cycle ***'
C
        IF(.NOT.LAST) WRITE (6,FMT=9030) ICYCL
 9030   FORMAT (/,'  *** Finished refinement cycle ',I3)
C
C            *************
        CALL LRREWD(MTZIN)
C            *************
C
        WRITE (6,FMT=6006) NREJ
 6006   FORMAT (1X,I5,' reflections were rejected for refinement')
C
C---- close phase i/o unit if phases were written this cycle
C
        DO 160 Kderiv = 1,NumDerivatives
          JA = JPOS(2*Kderiv-1)
          KA = JNDEX(2*Kderiv-1)
          JB = JPOS(2*Kderiv)
          KB = JNDEX(2*Kderiv)
          NA = KB - KA
          NB = JNDEX(2*Kderiv+1) - KB
          MM = 0
          NN = 0
C
C
          DO 150 J = 1,MaxNumResoBins
            DO 140 JJ = 1,MaxNumFigMeritBins
              MM = NumPhasedperDeriv(Kderiv,J,JJ,1) + 
     +              NumPhasedperDeriv(Kderiv,J,JJ,2) +
     +               MM
              NN = NumAnomPhasesPerDeriv(Kderiv,J,JJ) + NN
  140       CONTINUE
  150     CONTINUE
C
C----   This sr solves refinement matrices.
C
          IF (LANOM(Kderiv) .AND. NN.GT.0) THEN
C
C                ***********************************
            CALL MATSOL(TRIX(JA),RHS(KA),NA,DET1,J1)
C                ***********************************
C
          END IF
C
C
          IF (MM.GT.0) THEN
C
C                **********************************
            CALL MATSOL(TRIX(JB),RHS(KB),NB,DET2,J2)
C                **********************************
C
          END IF
C
C----   This sr applies shifts and calculates some statistics
C
C              ********************************************************
          CALL SHIFTS(TRIX(JA),RHS(KA),DET1,J1,NA,TRIX(JB),RHS(KB),DET2,
     +                J2,NB,Kderiv,OccESD,AoccESD,CutOffNatSigma)
C              ********************************************************
C
C----  This is the end of  a "deriv" loop.
C
  160   CONTINUE
C
C----   Print out ststistics for all derivatives if wanted..
C----   ISTAT .EQ. 0 - no printing
C----   ISTAT .EQ. 2 - print on last refinement cycle and final phasing cycle
C----   ISTAT .EQ. 1 - print after final phasing cycle
C----   ISTAT > 2 - print after every cycle
C
        IF (ISTAT.EQ.0) GO TO 170
        IF (ISTAT.NE.0 .AND. LAST) THEN
C
C----   This sr  writes out statistics.
C
C            ********************************************************
        CALL FSTATS(power,Rcullis,Kreflns)
C            ********************************************************
        END IF
C
        IF (ISTAT.EQ.2 .AND. LAST1) CALL FSTATS(power,Rcullis,Kreflns)
C
C----  This is the end of "cycle" loop.
C
  170 CONTINUE
C
C
      WRITE(6,FMT=9040)
 9040 FORMAT (/,/,
     + 4X,'*********************************************************',/,
     + 4X,'*                END OF MLPHARE PROCEDURE               *',/,
     + 4X,'*********************************************************',
     + /,/)
C
C                         ****************
      IF (IOUT.GT.0) CALL LWCLOS(MTZOUT,1)
C                         ****************
C
      IHATOM = 0
C
      DO 190 Kderiv = 1,NumDerivatives
        RR1 = 1000
        IF (DerivMinResol(1,Kderiv).GT.0.00001) 
     +      RR1 = SQRT(1.0/DerivMinResol(1,Kderiv))
        RR2 = 1
        IF (DerivMaxResol(1,Kderiv).GT.0.00001) 
     +      RR2 = SQRT(1.0/DerivMaxResol(1,Kderiv))
C
C
c-harvest
C
C---- send selected information for each heavy atom site
C
C                         _phasing_MIR_der_site.id
C  DerivTitle(Kderiv)     _phasing_MIR_der_site.der_id
C  ATNAME(IHATOM + 1)     _phasing_MIR_der_site.atom_type_symbol
C  X(IHATOM + 1)          _phasing_MIR_der_site.fract_x
C  Y(IHATOM + 1)          _phasing_MIR_der_site.fract_y
C  Z(IHATOM + 1)          _phasing_MIR_der_site.fract_z
C  B1(IHATOM + 1)         _phasing_MIR_der_site.B_iso
C  OCC(IHATOM + 1 , 1)    _phasing_MIR_der_site.Occupancy_iso
C  OccESD(IHATOM + 1)     _phasing_MIR_der_site.Occupancy_iso_esd
C  AOCC(IHATOM + 1 , 1)   _phasing_MIR_der_site.Occupancy_anom
C  AoccESD(IHATOM + 1)    _phasing_MIR_der_site.Occupancy_anom_esd
C
      CALL Hphasing_mir_der_site(DerivTitle(Kderiv),
     +                     NAtomsPerDeriv(Kderiv),
     + B1(IHATOM + 1),     ATNAME(IHATOM + 1),
     + X(IHATOM + 1),      Y(IHATOM + 1),
     + Z(IHATOM + 1),      OCC(IHATOM + 1 , 1),
     + OccESD(IHATOM + 1), AOCC(IHATOM + 1 , 1),
     + AoccESD(IHATOM + 1)   )
C
C---- send selected stats
C        _phasing_MIR_der.power_centric  
C        _phasing_MIR_der.power_acentric 
C        _phasing_MIR_der.Rcullis_centric 
C        _phasing_MIR_der.Rcullis_acentric 
C        _phasing_MIR_der.Rcullis_anomalous 
C        _phasing_MIR_der.reflns_acentric 
C        _phasing_MIR_der.reflns_anomalous 
C        _phasing_MIR_der.reflns_centric 
C
      CALL Hphasing_mir_der_p2(Power(1,Kderiv),
     +                     Rcullis(1,Kderiv),
     +                     KReflns(1,Kderiv) )
C
C
        WRITE (6,FMT='(//,A,4X,A,/,A,/,A,2F10.2)') ' DERIV ',
     +    DerivTitle(Kderiv) (1:LENSTR(DerivTitle(Kderiv))),
     +    ' DCYCLE PHASE ALL REFCYC ALL KBOV ALL',' RESO ',RR1,RR2
        IF (Kderiv.LE.9) WRITE (6,FMT='(A,4X,A,I1,2F10.4)') ' SCALE',
     +      'FPH',Kderiv,DerivScaleToNative(Kderiv),
     +                   DerivOverallBfact(Kderiv)
        IF (Kderiv.GT.9) WRITE (6,FMT='(A,4X,A,I2,2F10.4)') ' SCALE',
     +      'FPH',Kderiv,DerivScaleToNative(Kderiv),
     +                   DerivOverallBfact(Kderiv)
          write(6,'(A,4X,8F8.2)') ' ISOE',
     +  ( sqrt(abs(RmsIsomorphError(Kderiv,J))), J=1,MaxNumResoBins)
C
C
        IF (LANOM(Kderiv)) THEN
          RR1 = 1000
          IF (DerivMinResol(2,Kderiv).GT.0.00001) 
     +        RR1 = SQRT(1.0/DerivMinResol(2,Kderiv))
          RR2 = 1
          IF (DerivMaxResol(2,Kderiv).GT.0.00001) 
     +        RR2 = SQRT(1.0/DerivMaxResol(2,Kderiv))
          WRITE (6,FMT='(A,4X,2F8.2)') ' RESO ANO',RR1,RR2
          write(6,'(A,4X,8F8.2)') ' ANOE',
     +  ( sqrt(abs(RmsAnomalError(Kderiv,J))), J=1,MaxNumResoBins)
        END IF
C
       IF (Lscript) THEN
        WRITE (ISCRUN,FMT='(//,A,4X,A,/,A,/,A,2F10.2)') ' DERIV ',
     +    DerivTitle(Kderiv) (1:LENSTR(DerivTitle(Kderiv))),
     +    ' DCYCLE PHASE ALL REFCYC ALL KBOV ALL',' RESO ',RR1,RR2
        IF (Kderiv.LE.9) WRITE (ISCRUN,FMT='(A,4X,A,I1,2F10.4)')
     +      ' SCALE','FPH',Kderiv,DerivScaleToNative(Kderiv),
     +                   DerivOverallBfact(Kderiv)
        IF (Kderiv.GT.9) WRITE (ISCRUN,FMT='(A,4X,A,I2,2F10.4)') 
     +      ' SCALE','FPH',Kderiv,DerivScaleToNative(Kderiv),
     +                   DerivOverallBfact(Kderiv)
          write(ISCRUN,'(A,4X,8F8.2)') ' ISOE',
     +  ( sqrt(abs(RmsIsomorphError(Kderiv,J))), J=1,MaxNumResoBins)
C
C
        IF (LANOM(Kderiv)) THEN
          RR1 = 1000
          IF (DerivMinResol(2,Kderiv).GT.0.00001) 
     +        RR1 = SQRT(1.0/DerivMinResol(2,Kderiv))
          RR2 = 1
          IF (DerivMaxResol(2,Kderiv).GT.0.00001) 
     +        RR2 = SQRT(1.0/DerivMaxResol(2,Kderiv))
          WRITE (ISCRUN,FMT='(A,4X,2F8.2)') ' RESO ANO',RR1,RR2
          write(ISCRUN,'(A,4X,8F8.2)') ' ANOE',
     +  ( sqrt(abs(RmsAnomalError(Kderiv,J))), J=1,MaxNumResoBins)
        END IF
       END IF 
C
C
        DO 180 IAT = IHATOM + 1,IHATOM + NAtomsPerDeriv(Kderiv)
          IAT1    = IAT - IHATOM
          ATLAB = ' '
          IF(IAT1.LE.9)WRITE(ATLAB,'(A5,I1)')' ATOM',IAT1
          IF(IAT1.GT.9.AND.IAT1.LE.99)WRITE(ATLAB,'(A5,I2)')' ATOM',IAT1
          IF(IAT1.GT.99)WRITE(ATLAB,'(A5,I3)')' ATOM',IAT1
C
C----  Isotropic b - No anomalous occupancy
C
          IF (NTROP(IAT).EQ.1 .AND. .NOT.LANOM(Kderiv)) WRITE (6,
     +        FMT='(a,2x,a4,3f7.3,1f9.3,1x,a4,1x,1f8.3)') ATLAB,
     +        ATNAME(IAT),X(IAT),Y(IAT),Z(IAT),OCC(IAT,1),'BFAC',B1(IAT)
C
C----     Isotropic b - Anomalous occupancy
C
          IF (NTROP(IAT).EQ.1 .AND. LANOM(Kderiv)) WRITE (6,
     +        FMT='(a,2x,a4,3f7.3,2f9.3,1x,a4,1x,6f8.3)') ATLAB,
     +        ATNAME(IAT),X(IAT),Y(IAT),Z(IAT),OCC(IAT,1),AOCC(IAT,1),
     +        'BFAC',B1(IAT)
C
C----     ANisotropic b - No anomalous occupancy
C
          IF (NTROP(IAT).EQ.6 )THEN
C            ******************************************************
        CALL BTOANG(B1(IAT),B2(IAT),B3(IAT),
     +              B4(IAT),B5(IAT),B6(IAT),RMAT,BOUT(1))
          ELSE
             BOUT(1) = B1(IAT)
             BOUT(2) = 0
             BOUT(3) = 0
             BOUT(4) = 0
             BOUT(5) = 0
             BOUT(6) = 0
          END IF 

          IF (NTROP(IAT).EQ.6 .AND. .NOT.LANOM(Kderiv)) WRITE (6,
     +        FMT='(a,2x,a4,3f7.3,1f9.3,1x,a4,1x,6f10.5)') ATLAB,
     +        ATNAME(IAT),X(IAT),Y(IAT),Z(IAT),OCC(IAT,1),'BFAC',
     +        BOUT(1),BOUT(2),BOUT(3),BOUT(4),BOUT(5),BOUT(6)
C     +        B1(IAT),B2(IAT),B3(IAT),B4(IAT),B5(IAT),B6(IAT)
C
C----     ANisotropic b - Anomalous occupancy
C
          IF (NTROP(IAT).EQ.6 .AND. LANOM(Kderiv)) WRITE (6,
     +     FMT='(a,2x,a4,3f7.3,2f9.3,1x,a4,1x,6f10.5)') ATLAB,
     +     ATNAME(IAT),X(IAT),Y(IAT),Z(IAT),OCC(IAT,1),AOCC(IAT,1),
     +     'BFAC',BOUT(1),BOUT(2),BOUT(3),BOUT(4),BOUT(5),BOUT(6)
C     +     'BFAC',B1(IAT),B2(IAT),B3(IAT),B4(IAT),B5(IAT),B6(IAT)
          WRITE (6,FMT='(a)')
     +      ' ATREF X ALL Y ALL Z ALL OCC ALL AOCC ALL B ALL'
C
         IF (Lscript) THEN
          IF (NTROP(IAT).EQ.1 .AND. .NOT.LANOM(Kderiv)) WRITE (ISCRUN,
     +        FMT='(a,2x,a4,3f7.3,1f9.3,1x,a4,1x,1f8.3)') ATLAB,
     +        ATNAME(IAT),X(IAT),Y(IAT),Z(IAT),OCC(IAT,1),'BFAC',B1(IAT)
C
C----     Isotropic b - Anomalous occupancy
C
          IF (NTROP(IAT).EQ.1 .AND. LANOM(Kderiv)) WRITE (ISCRUN,
     +        FMT='(a,2x,a4,3f7.3,2f9.3,1x,a4,1x,6f8.3)') ATLAB,
     +        ATNAME(IAT),X(IAT),Y(IAT),Z(IAT),OCC(IAT,1),AOCC(IAT,1),
     +        'BFAC',B1(IAT)
C
C----     ANisotropic b - No anomalous occupancy
C

          IF (NTROP(IAT).EQ.6 .AND. .NOT.LANOM(Kderiv)) WRITE (ISCRUN,
     +        FMT='(a,2x,a4,3f7.3,1f9.3,1x,a4,1x,6f10.5)') ATLAB,
     +        ATNAME(IAT),X(IAT),Y(IAT),Z(IAT),OCC(IAT,1),'BFAC',
     +        BOUT(1),BOUT(2),BOUT(3),BOUT(4),BOUT(5),BOUT(6)
C     +        B1(IAT),B2(IAT),B3(IAT),B4(IAT),B5(IAT),B6(IAT)
C
C----     ANisotropic b - Anomalous occupancy
C
          IF (NTROP(IAT).EQ.6 .AND. LANOM(Kderiv)) WRITE (ISCRUN,
     +     FMT='(a,2x,a4,3f7.3,2f9.3,1x,a4,1x,6f10.5)') ATLAB,
     +     ATNAME(IAT),X(IAT),Y(IAT),Z(IAT),OCC(IAT,1),AOCC(IAT,1),
     +     'BFAC',BOUT(1),BOUT(2),BOUT(3),BOUT(4),BOUT(5),BOUT(6)
C     +     'BFAC',B1(IAT),B2(IAT),B3(IAT),B4(IAT),B5(IAT),B6(IAT)
          WRITE (ISCRUN,FMT='(a)')
     +      ' ATREF X ALL Y ALL Z ALL OCC ALL AOCC ALL B ALL'
         END IF 
C
C----    Output pseudo-PDB list of HA sites
C
         IF (LCoord) THEN
           CALL XYZATOM(IXYZOUT,IAT,ATNAME(IAT),' ',' ',Kderiv,RESNO,
     +                  ' ',' ',' ',IZ,' ')
           CALL XYZCOORD(IXYZOUT,'F','U',X(IAT),Y(IAT),Z(IAT),
     +                   OCC(IAT,1),BISO,BOUT)
           CALL XYZADVANCE(IXYZOUT,0,0,*200,*200)
         END IF
C
  180   CONTINUE
C
C
        IHATOM = NAtomsPerDeriv(Kderiv) + IHATOM
  190 CONTINUE
C
C----  close script file
C
      IF (LScript) THEN
        WRITE (ISCRUN,FMT='('' END'')')
C       DL: lose under traditional carriage control assumptions (but
C       fortunately there's an END beforehand)
        IF(.NOT.VAXVMS()) WRITE(ISCRUN,FMT='(''eof'')')
        CLOSE (UNIT=ISCRUN,STATUS='KEEP')
      ENDIF
C
C----  close output pseudo-pdb file
C
      IF (LCoord) THEN
        CALL XYZCLOSE(IXYZOUT)
      END IF
C
C
C----  end of job
C
      CLOSE (UNIT=45,STATUS='KEEP')
C          ***********************
      CALL LRCLOS(MTZIN)

C----- every harvesting program must call Hclose
C      only with this call is the deposit file written
C
      CALL Hclose

      CALL CCPERR(0,'Normal termination')
C          ***********************
C
C----  error during read of input hkl data
C
  200 CONTINUE
C
C          *****************************************************
      CALL CCPERR(1,
     + ' **** ERROR OCCURRED DURING READ OF INPUT DATA TAPE ****')
C          *****************************************************
C
C
      END
C
C
C
C     =============================================
      SUBROUTINE RCARDS(TITLE,MTZIN,MTZOUT,IXYZOUT)
C     =============================================
C
C        implicit none
C
C
C
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
      INTEGER NPARS
      PARAMETER (NPARS=360)
      INTEGER NKEYS
      PARAMETER (NKEYS=34)
      INTEGER MSETS
      PARAMETER (MSETS=MaxMtzCols)
      INTEGER MAXNUMEXTRACOLLABS
      PARAMETER (MAXNUMEXTRACOLLABS=20)
      INTEGER MAXSCRLINES
      PARAMETER (MAXSCRLINES=450)
C     ..
C     .. Arguments ..
      INTEGER MTZIN,MTZOUT,IXYZOUT
      CHARACTER*80 TITLE
C     ..
C     .. Scalars in Common ..
      REAL ABEST,ACL,CBEST,CentricTestFlag,CutOffNatSigma,
     +     FcalcA,FcalcB,FcalcW,FNativeScaled,FOM,SBEST,SCALE,
     +     VarNativeSc,SigmaNatScale,SMAXP,SMINP,STMAX,STMIN,THR
      INTEGER IAngleStep,IAVE,IAVF,ICENFLG,ICOR,ICurrentCycle,IDFP,
     +        IFC,Ifom,IHLA,IOUT,IPC,IPHIB,IRMSE,IRMSF,ISTAT,ISCRUN,
     +        IW1AVE,IW1RMS,IW2AVE,IW2RMS,IWC,NumDerivatives,nskip,
     +        NumhklMonitored,NumMatrixElements,NumPrimSymmetry,
     +        NumRefCycles,NumResoBins,NumSpaceGroup,NumSymmetry
      LOGICAL LAST,LAST1,LCOR,LELEC,LAPPLY,LSTAT,NOPHAS,
     +        Lscript,Lcoord
C     ..
C     .. Arrays in Common ..
      REAL FHAim,AFM,AMAT,AOCC,ScaledDPH,
     +     FHArl,ASQ,B1,B2,B3,B4,B5,B6,BFM,
     +     DerivOverallBfact,CFM,DerivAnomLimits,
     +     DerivIsoLimit,DerivMaxResol,
     +     DerivMinResol,RmsAnomalError,RmsIsomorphError,
     +     FHim,ESQ,ScaledFPH,
     +     FPP,OCC,PERM,DerivScaleToNative,DerivativeNativeScale,
     +     RECSQ,RMAT,FHrl,RSYM,RSYMT,SASQ,DerivSigmaScale,
     +     ScaledSigmaDPH,SESQ,DerivSigmaLimit,SumWsigA,
     +     SumAnomWgtModPrPhase,SumAnomWgtModPrPhaseDOS,
     +     SWLCA,SWLCAQ,TCELL,ScaledVPH,X,
     +     Y,Z
      INTEGER IDPH,IFADD,IFBOV,IFH,IFHA,IFPH,IndexRefFlags,JPOS,
     +        KRefineCycleFlag,
     +        LABIN,NAtomsPerDeriv,NDAT,NPHASE,NREFIN,NSMFLG,NTROP
      LOGICAL CALAFF,LANOM,LBOV,LEAVE,
     +        LPhaseFlagPerDerivative,LRefineFlagPerDerivative
      CHARACTER ATNAME*4,DerivTitle*80
C     ..
C     .. Local Scalars ..
      REAL BB,CF,DMAX,DMIN,FPB,HLFLAG,OUTFLG,RR1,RR2,SCAL,SIGCT2,
     +     SIGCUT,SMAX,SMIN,VOLUME,XA,YA,ZA,WAV,FFFA,VAL_MAGIC,
     +     ORIG(3,8), XTEST(3,MaxNumHeavyAtoms)
      INTEGER I,IAEND,DFLAG,IAPPND,IAT,IB,ICHA,IDD,Kderiv,IELEC,IEXTRA,
     +        IFAIL,IFIN,IHATOM,II,IID,IINH,IKB,IKEY0,IKEY1,ILEN1,ILEN2,
     +        ILPRGI,IOUTH,IPARAM,IPH,IPRINT,IRF,IRNFLG,ISYSW,ITOK,
     +        IWT,J,Jderiv,JREF,K,KAY,KCYCS,LEN,LSPGRX,MU,
     +        NATOMS,NB,NCOLS,NG5,NLINES,NLPRGI,NLPRGO,NN,NPH,NSMP,
     +        NTOK,NumExtraMtzCols,NscrLine,IXFAIL,NORIG,JSITE,
     +        LABTOT(MaxRefineFlags, MaxNumRefCycles)
      LOGICAL IFILE,LEND,ONLY_PHASE,SETVAL,LPAXISX,LPAXISY,LPAXISZ,
     +        LAnoOnly(MaxNumDerivatives)
      CHARACTER LTYPE*1,CWORK*4,KEY*4,WORD*8,NAMSPG*10,PGNAME*10,
     +          MTZTIT*70,DTITL*80,LABOUT_SAVE*1200,LINE*1200,
     +          INFLE*80,OUTFLE*80,PARFLE*80,SLASH*2,ERRLINE*200
C
C     ..
C     .. Local Arrays ..
      REAL AF(4),BF(4),BREAD(6),CELL(6),CU(2),FVALUE(NPARS),MO(2),
     +     PARAM(6),
     +     Fprime(MaxNumDerivatives),Fdoubleprime(MaxNumDerivatives)
      INTEGER IBEG(NPARS),IDEC(NPARS),IEND(NPARS),ITYPE(NPARS),
     +        JPOINT(MaxMtzCols),KPOINT(MaxMtzCols),MTZSORT(5)
      CHARACTER CTPRGI(MaxMtzCols)*1,CTPRGO(MaxMtzCols)*1,
     +          CTUSRK(MaxMtzCols)*1,CVALUE(NPARS)*4,KEYWRD(NKEYS)*4,
     +          LSPRGI(MaxMtzCols)*30,LSPRGO(MaxMtzCols)*30,
     +          LSUSRJ(MaxMtzCols)*30,LSUSRK(MaxMtzCols)*30,
     +          HISTORY(50)*80,ScrLine(MaxScrLines)*1200
C 
C----Harvesting stuff
C
      INTEGER NDATASETS,ISETS(MSETS),ISET,CSETID(MaxMtzCols),
     +         CSETOUT(MaxMtzCols),SETID,IDUMMY
      REAL DATCELL(6,MSETS),DATWAVE(MSETS)
      CHARACTER*64 PNAME(MSETS),XNAME(MSETS),DNAME(MSETS),   
     +         XNAME_OUT(MaxMtzCols),DNAME_OUT(MaxMtzCols)
      LOGICAL PRIVATE,USECWD,NOHARVEST
      CHARACTER PROJECTNAME*64,DATASETNAME*64,Hversion*30
      INTEGER NROWLIMIT,IvalueNotDet
      REAL    ValueNotDet
C     ..
C     .. External Functions ..
      INTEGER LENSTR,CCPNUN
      LOGICAL VAXVMS
      EXTERNAL LENSTR,VAXVMS,CCPNUN
C     ..
C     .. External Subroutines ..
      EXTERNAL BTOHKL,CCPERR,CCPUPC,CENTRIC,EPSLN,GTPINT,GTPREA,INICAL,
     +         LKYIN,LKYOUT,LKYSET,LRASSN,LRCELL,LRCLAB,LRHIST,LROPEN,
     +         LRRSOL,LRSORT,LRSYMI,LRSYMM,LRTITL,LWASSN,LWCELL,LWHIST,
     +         LWHSTL,LWOPEN,LWSORT,LWSYMM,LWTITL,PARSER,RDRESO,RDSCAL,
     +         RDSYMM,SFREAD2,UGTENV,LRIDX,LWIDX,LRCLID,LWIDASX,
     +         XYZINIT,XYZOPEN,WBCELL
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANALYS/ICOR,ISTAT,IAVF,IRMSF,IAVE,IRMSE,IW1AVE,IW1RMS,
     +       IW2AVE,IW2RMS,Ifom,NumhklMonitored
      COMMON /ATSYM_MLP/RSYM(4,4,MaxSymmetry),RSYMT(4,4,MaxSymmetry),
     +       NumSymmetry,PERM(4,4),NumSpaceGroup,NSMFLG(MaxSymmetry),
     +       NumPrimSymmetry
      COMMON /CENZON/ICENFLG
      COMMON /FASE/  
     +  RmsIsomorphError(MaxNumDerivatives,MaxNumResoBins),
     +   RmsAnomalError(MaxNumDerivatives,MaxNumResoBins),
     +     DerivSigmaLimit(MaxNumDerivatives),
     +      DerivIsoLimit(MaxNumDerivatives),
     +       DerivAnomLimits(2,MaxNumDerivatives),
     +        DerivMinResol(2,MaxNumDerivatives),
     +         DerivMaxResol(2,MaxNumDerivatives),
     +          KRefineCycleFlag(MaxNumRefCycles),
     +           ScaledFPH(MaxNumDerivatives),
     +            ScaledDPH(MaxNumDerivatives),
     +             ScaledVPH(MaxNumDerivatives),
     +              ScaledSigmaDPH(MaxNumDerivatives),
     +               FHrl(MaxNumDerivatives),
     +                FHim(MaxNumDerivatives),
     +                 FHArl(MaxNumDerivatives),
     +                  FHAim(MaxNumDerivatives),
     +                   LPhaseFlagPerDerivative(MaxNumDerivatives+1),
     +                    CentricTestFlag,FNativeScaled,
     +                     VarNativeSc,NumDerivatives,
     +                      IAngleStep,NumResoBins,ICurrentCycle,
     +                       LAST,LAST1
      COMMON /FIRST/
     +    SCALE,SigmaNatScale,CutOffNatSigma,SMAXP,SMINP,
     +     NumMatrixElements,NumRefCycles,Nskip,
     +      JPOS(2*MaxNumDerivatives),
     +       AMAT(3,3),
     +        RMAT(3,3),
     +         RECSQ(6),
     +          TCELL(6)
      COMMON /FLAG/LABIN(MaxRefineFlags,MaxNumHeavyAtoms,
     +       MaxNumRefCycles),IFBOV(MaxNumDerivatives,MaxNumRefCycles),
     +       NREFIN(MaxNumDerivatives,MaxNumRefCycles),
     +       NPHASE(MaxNumDerivatives,MaxNumRefCycles)
      COMMON /HEAVY/
     +  DerivSigmaScale(MaxNumDerivatives),    
     +   DerivScaleToNative(MaxNumDerivatives),
     +   DerivativeNativeScale(MaxNumDerivatives),   
     +   DerivOverallBfact(MaxNumDerivatives),
     +    IndexRefFlags(MaxNumDerivatives+1),  
     +    NAtomsPerDeriv(MaxNumDerivatives),
     +     OCC(MaxNumHeavyAtoms,MaxDataBatches),
     +      AOCC(MaxNumHeavyAtoms,MaxDataBatches),
     +       AFM(MaxNumHeavyAtoms,4),   BFM(MaxNumHeavyAtoms,4),
     +        CFM(MaxNumHeavyAtoms),     FPP(MaxNumHeavyAtoms),
     +         NTROP(MaxNumHeavyAtoms),   B1(MaxNumHeavyAtoms),
     +          B2(MaxNumHeavyAtoms),      B3(MaxNumHeavyAtoms),
     +           B4(MaxNumHeavyAtoms),      B5(MaxNumHeavyAtoms),
     +            B6(MaxNumHeavyAtoms),      X(MaxNumHeavyAtoms),
     +             Y(MaxNumHeavyAtoms),       Z(MaxNumHeavyAtoms),
     +              NDAT(MaxNumDerivatives),   
     +               CALAFF(MaxNumHeavyAtoms),
     +                LRefineFlagPerDerivative(MaxNumDerivatives),
     +                 LANOM(MaxNumDerivatives),
     +                  LBOV(MaxNumDerivatives),
     +                   LEAVE(MaxRefineFlags,MaxNumHeavyAtoms),
     +                    LELEC,LAPPLY
      COMMON /HEAVYC/ATNAME(MaxNumHeavyAtoms)
      COMMON /IRHARV/ IvalueNotDet, ValueNotDet 
      COMMON /OUTPT/
     +   IDFP,IFC,IPC,IWC,IPHIB,IHLA,IOUT,ISCRUN,
     +    IFPH(MaxNumDerivatives),
     +     IDPH(MaxNumDerivatives),
     +      IFH(MaxNumDerivatives),
     +       IFHA(MaxNumDerivatives),
     +        IFADD(MaxMtzCols),
     +         Lscript,LCoord
      COMMON /PHAS/
     +     FOM,ABEST,CBEST,SBEST,
     +      FcalcA,FcalcB,FcalcW,
     +       NOPHAS
      COMMON /STATB4/
     + SWLCA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhaseDOS(MaxNumDerivatives,MaxNumResoBins,
     +                         MaxNumFigMeritBins),
     + SWLCAQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhase(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins),
     + SumWsigA(MaxNumDerivatives,MaxNumResoBins,
     +          MaxNumFigMeritBins),
     + SESQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SASQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + ESQ(MaxNumDerivatives,MaxNumResoBins),
     + ASQ(MaxNumDerivatives,MaxNumResoBins),
     + STMIN,STMAX,THR,ACL,LCOR,LSTAT
      COMMON /STATC/DerivTitle(MaxNumDerivatives+1)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C     .. Data statements ..
C
C----      Overall info: TITL','RESO', 'SYMM', 'CENT',  'LABI', 'LABO',
C                        ANGLE PRINT
C
C---- what about EXCLUDE SIGFP ????
C
C     For Fp  SCALE FP,    SCALE SIGFP.
C     For each derivative
C     Deriv  NATOMS DERIVid Fourier output
C     For FPH  SCALE FPH,  SIGCUT,  SCALE SIGFPH.
C
C---- what about EXCLUDE SIGFPH  DISO DANO  ????
C
C           Fhoutput
C           Phasecycles i .. Refinecycles j... Refsc and b cycles
C           ESQ   ASQ  ( MaxNumResoBins terms)
C
C     For each atom
C      ATOM  x y z occ anoocc BFAC b ( ij)
C      Refinement flags XREF ... YREF ... ZREF... OCCREF... BREF...
C
C---- Key words
C
c
      DATA NLPRGI/110/
      DATA LSPRGI/'H','K','L','FP','SIGFP','DP','SIGDP','FPH1 ',
     +     'SIGFPH1 ','DPH1 ','SIGDPH1 ','FPH2 ','SIGFPH2 ','DPH2 ',
     +     'SIGDPH2 ','FPH3 ','SIGFPH3 ','DPH3 ','SIGDPH3 ','FPH4 ',
     +     'SIGFPH4 ','DPH4 ','SIGDPH4 ','FPH5 ','SIGFPH5 ','DPH5 ',
     +     'SIGDPH5 ','FPH6 ','SIGFPH6 ','DPH6 ','SIGDPH6 ','FPH7 ',
     +     'SIGFPH7 ','DPH7 ','SIGDPH7 ','FPH8 ','SIGFPH8 ','DPH8 ',
     +     'SIGDPH8 ','FPH9 ','SIGFPH9 ','DPH9 ','SIGDPH9 ','FPH10',
     +     'SIGFPH10','DPH10','SIGDPH10','FPH11','SIGFPH11','DPH11',
     +     'SIGDPH11','FPH12','SIGFPH12','DPH12','SIGDPH12','FPH13',
     +     'SIGFPH13','DPH13','SIGDPH13','FPH14','SIGFPH14','DPH14',
     +     'SIGDPH14','FPH15','SIGFPH15','DPH15','SIGDPH15','FPH16',
     +     'SIGFPH16','DPH16','SIGDPH16','FPH17','SIGFPH17','DPH17',
     +     'SIGDPH17','FPH18','SIGFPH18','DPH18','SIGDPH18','FPH19',
     +     'SIGFPH19','DPH19','SIGDPH19','FPH20','SIGFPH20','DPH20',
     +     'SIGDPH20','FC ','PHIC ','WC ','F0 ',
     +     'F1 ','F2 ','F3 ','F4 ','F5 ','F6 ','F7 ','F8 ','F9 ','F10',
     +     'F11','F12','F13','F14','F15','F16','F17','F18','F19',
     +     90*' '/
      DATA CTPRGI/'H','H','H','F','Q','D','Q','F','Q','D','Q','F','Q',
     +     'D','Q','F','Q','D','Q','F','Q','D','Q','F','Q','D','Q','F',
     +     'Q','D','Q','F','Q','D','Q','F','Q','D','Q','F','Q','D','Q',
     +     'F','Q','D','Q','F','Q','D','Q','F','Q',
     +     'D','Q','F','Q','D','Q','F','Q','D','Q','F','Q','D','Q','F',
     +     'Q','D','Q','F','Q','D','Q','F','Q','D','Q','F','Q','D','Q',
     +     'F','Q','D','Q','F','P','W',110*' '/
      DATA NLPRGO/176/
      DATA (LSPRGO(I),I=1,77)/'H','K','L','FP','SIGFP','DP','SIGDP',
     +     'PHIB','FOM ','HLA','HLB','HLC','HLD','FPH1 ','SIGFPH1 ',
     +     'DPH1 ','SIGDPH1 ','FH1 ','PHIH1','FHA1','PHIHA1','FPH2 ',
     +     'SIGFPH2 ','DPH2 ','SIGDPH2 ','FH2 ','PHIH2','FHA2','PHIHA2',
     +     'FPH3 ','SIGFPH3 ','DPH3 ','SIGDPH3 ','FH3 ','PHIH3','FHA3',
     +     'PHIHA3','FPH4 ','SIGFPH4 ','DPH4 ','SIGDPH4 ','FH4 ',
     +     'PHIH4','FHA4','PHIHA4','FPH5 ','SIGFPH5 ','DPH5 ',
     +     'SIGDPH5 ','FH5 ','PHIH5','FHA5','PHIHA5','FPH6 ','SIGFPH6 ',
     +     'DPH6 ','SIGDPH6 ','FH6 ','PHIH6','FHA6','PHIHA6','FPH7 ',
     +     'SIGFPH7 ','DPH7 ','SIGDPH7 ','FH7 ','PHIH7','FHA7','PHIHA7',
     +     'FPH8 ','SIGFPH8 ','DPH8 ','SIGDPH8 ','FH8 ','PHIH8','FHA8',
     +     'PHIHA8'/
      DATA (LSPRGO(I),I=78,200)/'FPH9 ','SIGFPH9 ','DPH9 ','SIGDPH9 ',
     +     'FH9 ','PHIH9','FHA9','PHIHA9','FPH10','SIGFPH10','DPH10',
     +     'SIGDPH10 ','FH10 ','PHIH10','FHA10','PHIHA10',
     +     'FPH11','SIGFPH11','DPH11','SIGDPH11',
     +     'FH11','PHIH11','FHA11','PHIHA11','FPH12','SIGFPH12','DPH12',
     +     'SIGDPH12 ','FH12 ','PHIH12','FHA12','PHIHA12',
     +     'FPH13','SIGFPH13','DPH13','SIGDPH13',
     +     'FH13','PHIH13','FHA13','PHIHA13','FPH14','SIGFPH14','DPH14',
     +     'SIGDPH14 ','FH14 ','PHIH14','FHA14','PHIHA14',
     +     'FPH15','SIGFPH15','DPH15','SIGDPH15',
     +     'FH15','PHIH15','FHA15','PHIHA15','FPH16','SIGFPH16','DPH16',
     +     'SIGDPH16 ','FH16 ','PHIH16','FHA16','PHIHA16',
     +     'FPH17','SIGFPH17','DPH17','SIGDPH17',
     +     'FH17','PHIH17','FHA17','PHIHA17','FPH18','SIGFPH18','DPH18',
     +     'SIGDPH18 ','FH18 ','PHIH18','FHA18','PHIHA18',
     +     'FPH19','SIGFPH19','DPH19','SIGDPH19',
     +     'FH19','PHIH19','FHA19','PHIHA19','FPH20','SIGFPH20','DPH20',
     +     'SIGDPH20 ','FH20 ','PHIH20','FHA20','PHIHA20',
     +     'FC ','PHIC ','WC ',24*' '/
      DATA (CTPRGO(I),I=1,73)/'H','H','H','F','Q','D','Q','P','W','A',
     +     'A','A','A','F','Q','D','Q','F','P','F','P','F','Q','D','Q',
     +     'F','P','F','P','F','Q','D','Q','F','P','F','P','F','Q','D',
     +     'Q','F','P','F','P','F','Q','D','Q','F','P','F','P','F','Q',
     +     'D','Q','F','P','F','P','F','Q','D','Q','F','P','F','P','F',
     +     'Q','D','Q'/
      DATA (CTPRGO(I),I=74,200)/'F','P','F','P','F','Q','D','Q','F','P',
     +  'F','P','F','Q','D','Q','F','P','F','P','F','Q','D','Q','F','P',
     +  'F','P','F','Q','D','Q','F','P','F','P','F','Q','D','Q','F','P',
     +  'F','P','F','Q','D','Q','F','P','F','P','F','Q','D','Q','F','P',
     +  'F','P','F','Q','D','Q','F','P','F','P','F','Q','D','Q','F','P',
     +  'F','P','F','Q','D','Q','F','P','F','P','F','Q','D','Q','F','P',
     +  'F','P','F','Q','D','Q','F','P','F','P','F','P','W',24*' '/
      DATA JPOINT/-1,-1,-1,-1,-1,0,0,-1,-1,0,0,189*0/
      DATA KEYWRD/'TITL','RESO','SYMM','CYCL','CENT','SKIP','LABI',
     +     'LABO',
     +     'ANGL','PRIN','PHAS','SCAL','EXCL','THRE','HLOU','FHOU',
     +     'SCRI','APPL','RUN ','DERI','DCYC','WAVE','ISOE','ANOE',
     +     'ATOM','ATRE','END ','COOR','PRIV','USEC','PNAM','DNAM',
     +     'RSIZ','NOHA'/
C     ..
C
C----   Set up defaults
C
      NSKIP         = 0
      ISYSW         = 6
      NumSymmetry   = 0
      SCALE         = 1.0
      SigmaNatScale = 1.0
      FPB           = 0
      THR           = 1.0E6
      ACL           = 1.0
      DMIN          = 1000.0
      DMAX          = 1.0000
      STMIN         = 1.0/DMIN
      STMAX         = 1.0/DMAX
      SMINP         = STMIN**2
      SMAXP         = STMAX**2
      NumRefCycles  = 0
      KCYCS         = 0
      JREF          = 0
      Lscript       = .FALSE.
      Lcoord        = .FALSE.
      LAPPLY        = .FALSE.
      NscrLine      = 1
      SLASH         = '\\'
      ICENFLG       = 0

C   Init variables for harvest deposit files
C
      PRIVATE       = .false.
      USECWD        = .false.
      NOHARVEST     = .false.
      PROJECTNAME   = ' '
      DATASETNAME   = ' '
      NROWLIMIT     = 80
C
C
      DO 10 I = 1,MaxNumRefCycles
        KRefineCycleFlag(I) = 0
         DO MU = 1,10
C  Use this array to check that restrictions hold for polar spacegroups
          LabTot(MU,I) = 1
         END DO 
   10 CONTINUE
C
C---- LELEC = .TRUE. and IELEC= 1
C
C---- occupancies are divides by atomic number, and therefore if
C     the data is in an absolute scale they are 0 to 1.
C
C   EJD - this option is withdrawn....
C         0 occupancies are in an arbitrary scale; if
C           the data is in an absolute scale they are in electrons.
C
      IELEC = 1
      LELEC = .TRUE.
C
C----  Default print - no correlation matrix; all statistics
C
C LCOR = .FALSE. and ICOR= 0
C LSTAT = .TRUE. and ISTAT= 1
C  EJD  LSTAT not used yet....
C
      ICOR            = 0
      ISTAT           = 1
      IAVF            = 0
      IRMSF           = 0
      IAVE            = 1
      IRMSE           = 0
      IW1AVE          = 0
      IW1RMS          = 0
      IW2AVE          = 0
      IW2RMS          = 0
      Ifom            = 0
      NumhklMonitored = 0
      IFIN            = 0
      CutOffNatSigma  = 0.0
      DFLAG           = 0
      Jderiv          = 0
C
C----   Do not output HL coefficients if HLFLAG = 0
C
      HLFLAG     = 0
      IFILE      = .TRUE.
      LCOR       = .FALSE.
      LSTAT      = .TRUE.
      IRNFLG     = 0
      IAngleStep = 10
      OUTFLG     = 0
      IDFP       = 0
      IFC        = 0
      IPC        = 0
      IWC        = 0
      IPHIB      = 0
      IHLA       = 0
      IHATOM     = 0
C
C
      DO 20 Kderiv = 1,MaxNumDerivatives
        DerivMinResol(1,Kderiv) = SMINP
        DerivMaxResol(1,Kderiv) = SMAXP
        DerivMinResol(2,Kderiv) = SMINP
        DerivMaxResol(2,Kderiv) = SMAXP
C
C----   Do not output FPHi FHi   if IFH(Kderiv) = 0
C
        IFH(Kderiv) = 0
C
C----   Do not output DPHi FH"i  if IFHA(Kderiv) = 0
C
        IFHA(Kderiv)              = 0
        NAtomsPerDeriv(Kderiv)    = 0
        IndexRefFlags(Kderiv)     = 0
        DerivIsoLimit(Kderiv)     = 0.0
        DerivAnomLimits(1,Kderiv) = 0.0
        DerivAnomLimits(2,Kderiv) = -100.0
        DerivSigmaLimit(Kderiv)   = 0.0
        Fprime(Kderiv)   = -99999.0
        Fdoubleprime(Kderiv)   = -99999.0
   20 CONTINUE
C
C
      IndexRefFlags(MaxNumDerivatives+1) = 0
C
C
      DO 30 II = 1,MaxMtzCols
        IFADD(II)  = 0
        LSUSRK(II) = ' '
        LSUSRJ(II) = ' '
   30 CONTINUE
   40 CONTINUE
C
C
      LINE = '   '
      KEY  = ' '
      NTOK = NPARS
C
C          *************************************************************
      CALL PARSER(KEY,LINE,IBEG,IEND,ITYPE,FVALUE,CVALUE,IDEC,NTOK,LEND,
     +            .TRUE.)
C          *************************************************************
C
C---- End of file?
C
      IF (LEND) GO TO 620
C
C---- Loop over possible key-words
C
      DO 50 I = 1,NKEYS
        IF (KEY.EQ.KEYWRD(I)) GO TO 60
   50 CONTINUE
C
C
      GO TO 690
C
   60 CONTINUE
C
C     GRAB LINE FOR SCRIPT LATER
C
      NScrLine = NScrLine + 1
      IF (NScrLine.GT.MaxScrLines) THEN
         WRITE(6,'(//,A,I4,A,/,A,/,A)')
     +        ' ** ERROR ** There are ',MaxScrLines,
     +        ' lines allocated to store the keyworded',
     +        ' input script, but this script is longer.',
     +        ' Increase the parameter MaxScrLines in s/r RCARDS.'
         CALL CCPERR(1,'Script length exceeded (see above)')
      END IF
      SCRLINE(NSCRLINE) = LINE(IBEG(1):IEND(NTOK))
C
C     DATA KEYWRD/
C    +     'TITL','RESO','SYMM','CYCL','CENT','SKIP','LABI','LABO','ANGL',
C    +     'PRIN','PHAS','SCAL','EXCL','THRE','HLOU','FHOU','SCRI','APPL','RUN ',
C    +     'DERIV','DCYCLe','WAVE','ISOE','ANOE','ATOM','ATRE','END','COOR',
C    +     'PRIV','USEC','PNAM','DNAM','RSIZ','NOHA'/
C
      GO TO ( 70, 80,100,110,140,144,150,170,190,
     +       200,110,220,230,250,260,270,280,285,290,
     +       390,440,460,480,510,540,580,620,700,
     +       901,902,903,904,905,906) I
C
C---- PRIVATE   [priv]   flag only
C     =======
C                 if present sets dir access for first
C                 open of $HOME/DepositFiles to    drwx------
C                                       default is drwxr-xr-x 
C
C
 901  CONTINUE
      PRIVATE = .true.
      GO TO 40
C
C---- USECWD [usec]   Flag only
C     ======
C                 if present file is opened in current working directory
C                 default is o/p file to
C                 $HOME/DepositFiles/ProjectName/DataSetName.ProgramName
C
 902  CONTINUE
      USECWD = .true.
      GO TO 40
C
C---- PROJECTNAME [pname]  <string>
C     ===========
C     
C             if given with DATASET then harvest will o/p a file
C             this project_name should be always used for the
C             one structure determination
C             no default
C
 903  CONTINUE
      PROJECTNAME = LINE(IBEG(2) :IEND(2))
      GO TO 40
C
C---- DATASETNAME  [dname]  <string>
C     ===========
C     
C             if given with PROJECT then harvest will o/p a file
C             this dataset_name is the name of one of the diffraction
C             data sets used in a particular project
C             no default
C
 904  CONTINUE
      DATASETNAME = LINE(IBEG(2) :IEND(2))
      GO TO 40
C
C---- ROWLIMIT   [rsize]  <int>
C     ========
C     
C              if given sets the number of characters in a row
C              for the output file, default is 132
C              TRUE mmcif default is 80
C
 905  CONTINUE
      NROWLIMIT = 80
      IF (NTOK.GE.2) CALL GTPINT(2,NROWLIMIT,NTOK,ITYPE,FVALUE)
      GO TO 40
C
C---- NOHARVEST
C     ========
C     
C              disable writing of harvest files
C
 906  CONTINUE
      NOHARVEST = .true.
      GO TO 40
C
C---- TITLE
C     =====
C
C   TITLE <title>
C       The  specified  title  is written to the HKLOUT file.  The
C       default is the title from the MTZ file.
C
   70 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword TITLE cannot be used after DERIV')
      TITLE = LINE(IBEG(2) :IEND(NTOK))
      GO TO 40
C
C---- RESOLUTION
C     ==========
C
C   RESOLUTION  [ <rmin> ] <rmax>
C       Overall resolution range for all refinement and phasing in
C       Angstroms  (or as 4sin(theta)**2/lambda**2 limits iff both
C       are <1.0).  If only one limit is given, it  is  the  upper
C       limit;  otherwise  the limits can be in either order.  The
C       default is to use the resolution from the MTZ file.   Data
C       for  derivatives  can each be limited by a further RESOLU-
C       TION keyword after the DERIVATIVE definitions.
C
   80 CONTINUE
      ITOK = 2
C
C     RESOLUTION ( ANO )       x1,x2
C     ==============================
C
C     NOTE:    Default =  0.1 and 1000.0 Angstrom
C
C    DMAX, DMIN are the resolution limits for  the  data  to  be
C    included, i.e. data are included for which
C
C    (1/DMAX)**2 >= 4 sin**2theta/lambda**2 >= (1/DMIN)**2
C
      IF (NTOK.LE.2) THEN
C
C---- test if enough arguments
C
        WRITE (ISYSW,FMT='(a,a)')
     +    ' Key_Word Error, Not Enough Tokens for  RESOLUTION ',
     +    'line, Ignoring this line.'
        GO TO 40
      END IF
C
C
C---- see whether second arguement = 'ANO'
C
      IF (ITYPE(2).EQ.1) THEN
        CWORK = LINE(IBEG(2) :IEND(2))
C
C            *************
        CALL CCPUPC(CWORK)
C            *************
C
        IF (CWORK(1:1).EQ.'A') ITOK = 3
      END IF
C
C          **************************************************
      CALL RDRESO(ITOK,ITYPE,FVALUE,NTOK,DMIN,DMAX,SMIN,SMAX)
C          **************************************************
C
C----   Set up PHARE things.. Too lazy to change all this.
C       If Jderiv EQ 0 THIS info relates to all derivative.
C
      IF (Jderiv.EQ.0) THEN
C
C
        DO 90 IID = 1,MaxNumDerivatives
          DerivMinResol(1,IID) = SMIN
          DerivMaxResol(1,IID) = SMAX
   90   CONTINUE
C
C
        IF (DMIN.LE.1.5418) DMIN = 1000.0
        IF (DMAX.LT.1.0000) DMAX = 1.0000
        STMIN = 1.0/DMIN
        STMAX = 1.0/DMAX
        SMINP = STMIN**2
        SMAXP = STMAX**2
        GO TO 40
      END IF
C
C----  If Jderiv GT 0 THIS info relates to this derivative.
C
      IF (Jderiv.GT.0 .AND. ITOK.EQ.2) THEN
        DerivMinResol(1,Jderiv) = SMIN
        DerivMaxResol(1,Jderiv) = SMAX
        GO TO 40
      END IF
C
C----  If Jderiv GT 0 and ITOK = 3 THIS info relates to ano disp for
C      this derivative.
C
      IF (Jderiv.GT.0 .AND. ITOK.EQ.3) THEN
        DerivMinResol(2,Jderiv) = SMIN
        DerivMaxResol(2,Jderiv) = SMAX
        GO TO 40
      END IF
C
C---- SYMMETRY
C     ========
C
  100 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword SYMM cannot be used after DERIV')
      ITOK = 2
C
C          **********************************************************
      CALL RDSYMM(ITOK,LINE,IBEG,IEND,ITYPE,FVALUE,NTOK,NAMSPG,
     +            NumSpaceGroup,PGNAME,NumSymmetry,NumPrimSymmetry,RSYM)
C          **********************************************************
C
      IF (NumSymmetry.GT.MaxSymmetry) GO TO 680
      GO TO 40
C
C---- CYCLE  or PHASe  :  PHASe is equivalent to NumRefCycles = 0.
C     ========================================================
C
C   CYCLE   <ncycle> [ <kcycle1> <kcycle2> ...]
C       <ncycle>  sets  the number of cycles that the program will
C       run (default 10).  The first (<ncycle>-1) cycles are  used
C       for  refinement of the heavy atom parameters and the error
C       estimates.
C The phases for ALL reflections in the file to  the  outer
C       resolution  limit  are  calculated  on  the  final  cycle.
C       Statistics are collected  for  both  the  final cycle  of
C       refinement, and the phasing cycle.
C
C       <kcycle1>  <kcycle2>  ...  are flags for externally calcu-
C       lated phases and need only be  set  if  you  want  to  use
C       these. In general the refinement procedure works out the
C       likely weighting of all possible  protein  phases  sampled
C       round  the  phase circle and uses this information to do a
C       phased refinement.  Any particular derivative contribution
C       will  be  controlled by the parameters on the DCYCLE input
C       line.  (See below.)
C
C       If you want to input phases calculated elsewhere  and  use
C       them  in refinement for some cycles, list these cycle num-
C       bers here. E.g.:
C   CYCLE 10   2 3 5 7 9
C       would mean that 10 cycles will be run,  9  for  refinement
C       and  a final phasing cycle, and that external phases would
C       be used during refinement on cycles 2, 3, 5, 7 and 9.   If
C       these flags are set you must assign a column for PHIC, and
C       for either WC or FC.  See NOTES ON PHIC for details of how
C       these  are used.  A contribution may be added to the phase
C       likelihood  calculated  from  derivatives  to  favour  the
C       external phase or it may be used alone.
C
  110 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword CYCL/PHAS cannot be used after DERIV')
      NumRefCycles = 1
      ONLY_PHASE   = .FALSE.
      IF (KEY.EQ.'PHAS') ONLY_PHASE = .TRUE.
C
C                         ***************************************
      IF (NTOK.GE.2) CALL GTPINT(2,NumRefCycles,NTOK,ITYPE,FVALUE)
C                         ***************************************
      IF (NumRefCycles.EQ.1) ONLY_PHASE   = .TRUE.
C
      IF (NumRefCycles.GT.MaxNumRefCycles)
     +    NumRefCycles = MaxNumRefCycles
C
C----  Set KRefineCycleFlag(K) = 1 for refinement
C                        including external (input) phases
C
      DO 120 K = 1,NumRefCycles
        KRefineCycleFlag(K) = 0
  120 CONTINUE
C
C
      IF (NTOK.GE.3) THEN
        DO 130 ITOK = 3,NTOK
          IF (ITYPE(ITOK).EQ.2) THEN
C
C                ********************************
            CALL GTPINT(ITOK,K,NTOK,ITYPE,FVALUE)
C                ********************************
C
            KRefineCycleFlag(K) = K
            KCYCS = KCYCS + K
          END IF
  130   CONTINUE
      END IF
      GO TO 40
C
C----  CENTRIC refinement only.
C     ========================
C
C   CENTRIC
C       This restricts the program to use only centric reflections
C       for  refinement.  This is sensible if you have enough cen-
C       tric data. In general there are many  many  more  observa-
C       tions  than heavy atom parameters to refine, and the coor-
C       dinates and relative real occupancies can often be  accu-
C       rately  refined from the centric data alone. You will have
C       to use acentric data to refine the "anomalous  occupancy".
C
  140 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword CENT cannot be used after DERIV')
      ICENFLG = 1
      WRITE (6,FMT=*) ' **** CENTRIC Reflections only used ***'
      GO TO 40
C
C----  Skip some reflections during refinement to speed it up 
C     ========================
C
C   SKIP
C       This restricts the program to use the nskip-th reflectons 
C       It advances by 1 at each cycle.
C       This is sensible if you have a lot more data than parameters.
C       In general there are many  many  more  observa-
C       tions  than heavy atom parameters to refine. 
C       All reflections are phased in the final cycle
C
  144 CONTINUE
C                ********************************
      IF (ITYPE(2).EQ.2) CALL GTPINT(2,NSKIP,NTOK,ITYPE,FVALUE)
C                ********************************
      WRITE (6,'(A,I3,A)') 
     +  ' **** Every ',NSKIP,'-th Reflection used for refinement***'
      GO TO 40
C
C---- "LABI"     i.e. set input labels
C     =================================
C
C   LABIN   <program label>=<file label> ...
C       Associates the column labels that the program expects with
C       column  labels  in the input file.  The following <program
C       label>s can be assigned:
C
C        FP      SIGFP
C        FPH1    SIGFPH1   DPH1   SIGDPH1
C        FPH2    SIGFPH2   DPH2   SIGDPH2
C        FPH3    SIGFPH3   DPH3   SIGDPH3
C        FPH4    SIGFPH4   DPH4   SIGDPH4
C        FPH5    SIGFPH5   DPH5   SIGDPH5
C        FPH6    SIGFPH6   DPH6   SIGDPH6
C        FPH7    SIGFPH7   DPH7   SIGDPH7
C        FPH8    SIGFPH8   DPH8   SIGDPH8
C        FPH9    SIGFPH9   DPH9   SIGDPH9
C        FPH10   SIGFPH10   DPH10   SIGDPH10
C        FC      PHIC  WC
C        F0      F1  F2   F3   ..F19
C       Where:
C
C       H, K, L
C
C       FP     Native F
C
C       SIGFP  sigma(FP)
C
C       Then for each derivative (i=derivative number)
C
C       FPHi   Derivative F
C
C       SIGFPHi      sigma(FPHi)
C
C       [DPHi] Anomalous difference (if anomalous data are used)
C
C       [SIGDPHi]      sigma(DELi)
C
C       For externally calculated phases
C
C       PHIC   The phases to be used in refinement. This  is  only
C       needed  if  the  <kcycle> flags have been set.  See
C       keyword CYCLE.
C
C       [WC]   Weight for these phases. Defaults to 1.0.
C
C       [FC]   Fcalc value. Used to estimate Sim Weight for calcu-
C       lated phases.
C
C       F0  F1  ..  Assignments for  selected extra columns to be
C       copied to the output file
C
C       Assignments are required for FP, SIGFP, and at  least  one
C       derivative  (FPH1, SIGFPH1).  The number of derivatives is
C       deduced from the FPHi assignments.
C
C       If you wish to copy all columns from input to output file,
C       specify ALLIN  on  the LABOUT line.  If you wish to copy
C       selected columns from input to output file, you may assign
C       up to 19 columns, using F0 F1 ... F19
C
  150 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword LABI cannot be used after DERIV')
C
C
C          **********************************************
      CALL LKYIN(MTZIN,LSPRGI,NLPRGI,NTOK,LINE,IBEG,IEND)
C          **********************************************
C
      ITOK = 2
C
C----   JPOINT(II) will come back set to -1 for any LSPRGI set.
C
      DO 160 II = 4,NLPRGI
        JPOINT(II) = 0
        KPOINT(II) = 0
  160 CONTINUE
C
C          ***********************************************************
      CALL LKYSET(LSPRGI,NLPRGI,LSUSRJ,JPOINT,ITOK,NTOK,LINE,IBEG,IEND)
C
C----   Ejd - problem with someone having 
C        DP SIGDP F1 .. in MTZ file; if these
C        labels are not specifically requested reset LSPRGI(6) and (7)
C        I will use @@@@ - what chance some one will use that !!
C          ************************************************************
C
      IF (JPOINT(6).EQ.0) LSPRGI(6) = '@@'
      IF (JPOINT(7).EQ.0) LSPRGI(7) = '@@@'
      IF (JPOINT(6).EQ.0) LSPRGO(6) = '@@'
      IF (JPOINT(7).EQ.0) LSPRGO(7) = '@@@'
      IF (JPOINT(91).EQ.0) LSPRGI(91) = '@91'
      IF (JPOINT(92).EQ.0) LSPRGI(92) = '@92'
      IF (JPOINT(93).EQ.0) LSPRGI(93) = '@93'
      IF (JPOINT(94).EQ.0) LSPRGI(94) = '@94'
      IF (JPOINT(95).EQ.0) LSPRGI(95) = '@95'
      IF (JPOINT(96).EQ.0) LSPRGI(96) = '@96'
      IF (JPOINT(97).EQ.0) LSPRGI(97) = '@97'
      IF (JPOINT(98).EQ.0) LSPRGI(98) = '@98'
      IF (JPOINT(99).EQ.0) LSPRGI(99) = '@99'
      IF (JPOINT(100).EQ.0) LSPRGI(100) = '@100'
      IF (JPOINT(101).EQ.0) LSPRGI(101) = '@101'
      IF (JPOINT(102).EQ.0) LSPRGI(102) = '@102'
      IF (JPOINT(103).EQ.0) LSPRGI(103) = '@103'
      IF (JPOINT(104).EQ.0) LSPRGI(104) = '@104'
      IF (JPOINT(105).EQ.0) LSPRGI(105) = '@105'
      IF (JPOINT(106).EQ.0) LSPRGI(106) = '@106'
      IF (JPOINT(107).EQ.0) LSPRGI(107) = '@107'
      IF (JPOINT(108).EQ.0) LSPRGI(108) = '@108'
      IF (JPOINT(109).EQ.0) LSPRGI(109) = '@109'
      IF (JPOINT(110).EQ.0) LSPRGI(110) = '@110'
C
      GO TO 40
C
C---- LABO
C   =======
C
C   LABOUT [ ALLIN | [ <program label>=<file label> ... ] ]
C       Associates  column  labels  in the output file with labels
C       used by the program.
C
C       Specifying ALLIN copies all input columns to output.
C
C       The following extra labels can be assigned.
C        PHIP    FOM
C        HLA     HLB   HLC   HLD
C        FH1     PHIH1   FHA1   PHIHA1
C        FH2     PHIH2   FHA2   PHIHA2
C        .....
C        FH10    PHIH10   FHA10   PHIHA10
C       where
C
C       PHIB   maximum likelihood phase
C
C       FOM    figure of merit
C
C       HLA,HLB,HLC,HLD
C       Hendrickson-Lattman coefficients output if  HLOUT
C       requested
C
C       FHi PHIHi FHAi PHIHAi
C       give  the  heavy atom real and imaginary structure
C       factors. Output if FHOUT  is  requested for  this
C       derivative.   (The  FPHi SIGFPHi  [ DPHi SIGDPHi ]
C       will also be copied  to  the  output  file.)   This
C       information  is  needed  if  you want to do "double
C       difference" Fourier to find more heavy atom  sites.
C       See the FFT documentation.
C
C       FP SIGFP PHIB and FOM
C       are always output.
C
C       The  following are copied from the input file if they have
C       been assigned.
C        FC      PHIC  WC
C        F0      F1  F2   F3   ..F11
C       If LABOUT is specified the program outputs a file assigned
C       to  HKLOUT containing at least H K L FP SIGFP PHIB FOM and
C       other optional columns FOR ALL REFLECTIONS  to  the  outer
C       resolution cut off.  IF LABOUT is NOT specified you get no
C       output file.
C
C       For certain problems it is convenient  to  assign  FP  and
C       FPHi  to the same column (see example using anomalous mea-
C       surements for phasing).
C
  170 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword LABO cannot be used after DERIV')
C
C----   Sort all this out after END card read;
C       Maybe LABO precedes LABI..
C
      OUTFLG = 1.0
C
C---- see whether second arguement = 'ALLIN'
C
      CWORK = LINE(IBEG(2) :IEND(2))
C
C            *************
      CALL CCPUPC(CWORK)
C            *************
C
      IF (CWORK(1:3).EQ.'ALL') THEN
        WRITE (6,FMT=*) ' All input columns to go to output???'
        OUTFLG = 2.0
        MTZOUT = 2
C
C----  Clear  keyword ALL...
C
        DO 180 II = IBEG(2),IEND(2)
          LINE(II:II) = ' '
  180   CONTINUE
      END IF
C
C
      LABOUT_SAVE = LINE
      GO TO 40
C
C---- ANGLE STEP - default = 10
C     =========================
C
C   ANGLE <iangle>
C       <iangle> is the angle interval in degrees for  calculation
C       of the phase probability curve. ( Default 10)
C
C       NB: The program speed is proportional to 360/<iangle>.  ZO
C       recommends <iangle>=20 except when the derivative has high
C       phasing power, then  <iangle>=10.  EJD always uses <ian-
C       gle>=10 - time is not so valuable...
C
  190 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword ANGL cannot be used after DERIV')
C
C          **********************************
      CALL GTPINT(2,IAngleStep,NTOK,ITYPE,FVALUE)
C          **********************************
C
      GO TO 40
C
C---- ICOR is a flag for printing of the correlation matrices
C     if .ne. 0 the matrices are printed
C
C     ISTAT is a flag for printing of statistics on the derivative scale
C     if .ne. 0 these statistics will be printed
C
C   Default is : Print Statistics for phasing cycle, do Not print Correlation matrices
C    PRINT   COR   NOSTAT
C
C---- PRINT commands
C     ==============
C
C   PRINT [STATS] [AVF] [AVE] .... [NOSTATS] [MON <nmon>] [COR]
C       The  subsidiary keywords  control  the type  of  output.
C       Default is to output statistics for the  final phasing cycle only: 
C       Refinement
C       statistics only include reflections used for REFINEMENT of
C       that  derivative.   Phasing  statistics will  include all
C       reflections.
C
C       Possible key words are:
C
C       STATS  statistics output on last refinement AND phasing cycles.
C
C       NOSTATS       no statistics output.
C
C       MON <nmon>
C       Set this if you want  to monitor  every <nmon>-th
C       reflection.  The default is every 10-th reflection.
C
C       COR    Output correlation matrix  (default: do not)
C
C       Key words to control type of statistical analysis.
C
C       AVF    gives unweighted Average FP FPH FH
C
C       AVE    gives unweighted Average Lack_of_closure terms.
C
C       RMSF   gives unweighted rms FP FPH FH
C
C       RMSE   gives unweighted rms Lack_of_closure terms.
C
C       WiAVF  gives weighted Average FP FPH FH summed over  the
C       phase circle
C
C       WiAVE  gives weighted Average Lack_of_closures summed over
C       the phase circle
C
C       WiRMSF gives weighted rms FP FPH FH summed over the  phase
C       circle
C
C       WiRMSE gives weighted rms Lack_of_closures summed over the
C       phase circle
C
C       There is some debate over which type of statistic  is  the
C       most  useful.   EJD  uses AVE and AVF.  It is important to
C
C       use only ONE option, otherwise you are swamped with infor-
C       mation, and  to  stick to that option. To assess whether
C       new sites are contributing EJD looks for  a  reduction  in
C       the Cullis R-factors as new sites are added.  See NOTES on
C       USAGE for hints on using this information.
C
C       W1 refers to this weight:
C  W1 = phase prob(PHIx) / ( SIGFPH**2 + VCALC + ISOERROR**2 )
C       for this derivative at this resolution for each possible phase, where
C
C  VCALC = SIGFP**2 *
C        ((FPSQ + FPA * FHA + FPB * FHB) / (FP * FPH))**2
C
C  FPA = FP * COS(PHIx) , FPB = FP * SIN(PHIx)
C    where PHIx takes all values round the phase circle
C
C    and FHA = FH * COS(PHIH)   FHB = FH * SIN(PHIH)
C  This seems the best error.
C
C       W2 refers to this weight:
C  W2 =  phase_prob(PHIx) /(SIGFP**2 + SIGFPH**2)
C        where SIGFP = sig(Fp) and SIGFPH = sig(Fph)
C
  200 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword PRINT cannot be used after DERIV')
C
C          ************
      CALL CCPUPC(LINE)
C          ************
C
      ITOK = 1
  210 ITOK = ITOK + 1
      IKEY0 = IBEG(ITOK)
      IKEY1 = IBEG(ITOK) + 3
      IF (IEND(ITOK).LT.IKEY1) IKEY1 = IEND(ITOK)
      KEY = LINE(IKEY0:IKEY1)
C
C          *************
      CALL CCPUPC(KEY)
C          *************
C
      IF (KEY.EQ.'COR') ICOR = 1
      IF (KEY.EQ.'COR') LCOR = .TRUE.
      IF (KEY.EQ.'STA') ISTAT = 2
      IF (KEY.EQ.'NOS') ISTAT = 0
      IF (KEY.EQ.'NOS') LSTAT = .FALSE.
C
C----  Key word all means statistics printed after every cycle.
C      Default is last cycle only:
C
C      Last refinement statistics only include reflections
C      used for REFINEMENT.
C
C      Last phase statistics include all reflections.
C
      IF (KEY.EQ.'ALL') ISTAT = 10
      IF (KEY.EQ.'AVF') IAVF = 1
      IF (KEY.EQ.'RMSF') IRMSF = 1
      IF (KEY.EQ.'AVE') IAVE = 1
      IF (KEY.EQ.'RMSE') IRMSE = 1
      IF (KEY.EQ.'W1AV') IW1AVE = 1
      IF (KEY.EQ.'W1RM') IW1RMS = 1
      IF (KEY.EQ.'W2AV') IW2AVE = 1
      IF (KEY.EQ.'W2RM') IW2RMS = 1
cpjx      IF (KEY.EQ.'FOM') Ifom = 1
      IF (KEY.EQ.'FOM') CALL CCPERR(2,
     +     'FOM subkeyword is undocumented and has no functionality')
C
C----  Do you want to monitor some reflections?
C
      IF (KEY.EQ.'MON') THEN
        ITOK = ITOK + 1
C
C            ***********************************
        CALL GTPINT(ITOK,NumhklMonitored,NTOK,ITYPE,FVALUE)
C            ***********************************
        write(6,'(a,i4,a)')' Every ',NumhklMonitored,
     +                             ' reflection monitored'
C
      END IF
C
C
      IF (ITOK.LT.NTOK) GO TO 210
      GO TO 40
C
C---- SCALE  FP or SIGFP or FPHi... ( Ejd - why bother???)
C     =====================================================
C
C   SCALE  <SIGFP scale>
C       Specifies the scale factor by which to multiply SIGFP.
C
  220 CONTINUE
      ITOK = 2
C
C          **********************************************************
      CALL RDSCAL(ITOK,LINE,IBEG,IEND,ITYPE,FVALUE,NTOK,NLPRGI,LSPRGI,
     +            ILPRGI,SCAL,BB)
C          **********************************************************
C
      WORD = LSPRGI(ILPRGI)
C
C
C---- Fph scale and b factor
C
      IF (WORD(1:3).EQ.'FPH') THEN
        DerivScaleToNative(Jderiv) = SCAL
        DerivOverallBfact(Jderiv) = BB
        WORD = ' '
      END IF
C
C---- Fph sigma scale
C
      IF (WORD(1:6).EQ.'SIGFPH') THEN
        DerivSigmaScale(Jderiv) = SCAL
        WORD = ' '
      END IF
C
C
      IF (WORD(1:5).EQ.'SIGFP') THEN
        SigmaNatScale = SCAL
      END IF
C
      IF (WORD(1:2).EQ.'FP') THEN
        WRITE (6,FMT=*)
     +    '  ****  Option removed to rescale all data ****'
C        SCALE = SCAL
C        FPB = BB
      END IF
C
C
      GO TO 40
C
C---- EXCLUD SIGFP cutoff SIGFPHi cutoff DISO .. DANO ..
C     ===================================================
C
C   EXCLUDE [SIGFPH <siglim>]  [DISO <isolim>] [DANO <anolim1 ano-
C       lim2>]
C       SIGFPHi <siglim>
C       Reflections are excluded if FPHi <  siglim*SIGFPHi.
C       Default is <siglim>=0.
C
C       DISO <isolim>
C       Reflections   are   excluded   if   abs(FPHi-FP) >
C       <isolim>.   The  default is  <isolim>  unset   and
C       unused.
C
C       DANO <anolim1> [ <anolim2> ]
C       Reflections  are excluded if  abs(FPHi(+) -FPHi(-))
C       > <anolim1>.  The default is unset. Reflections can
C       also  be excluded if abs(FPHi(+) -FPHi(-)) < <ano-
C       lim2>. EJD feels it is very unwise to use this.
C
  230 CONTINUE
      ITOK = 2
  240 CONTINUE
      WORD = LINE(IBEG(ITOK) :IEND(ITOK))
c
C            *************
      CALL CCPUPC(WORD)
C            *************
C
C          ***************************************
      CALL GTPREA(ITOK+1,SIGCUT,NTOK,ITYPE,FVALUE)
C          ***************************************
C
C
C---- Fph sigma cutoff
C
      IF (WORD(1:6).EQ.'SIGFPH') DerivSigmaLimit(Jderiv) = SIGCUT
      IF (WORD(1:6).EQ.'SIGFPH') WORD = ' '
C
C---- Fp  sigma cutoff
C
      IF (WORD(1:5).EQ.'SIGFP') CutOffNatSigma = SIGCUT
C
C---- Mod(Fp - Fph)  cutoff
C
      IF (WORD(1:4).EQ.'DISO') DerivIsoLimit(Jderiv) = SIGCUT
C
C---- Mod(Fph(+) - Fph(-) )  cutoff
C
      IF (WORD(1:4).EQ.'DANO') THEN
        DerivAnomLimits(1,Jderiv) = SIGCUT
        IF (ITYPE(ITOK+2).EQ.2) THEN
          CALL GTPREA(ITOK+2,SIGCT2,NTOK,ITYPE,FVALUE)
          ITOK = ITOK + 1
          DerivAnomLimits(2,Jderiv) = SIGCT2
        END IF
        IF (DerivAnomLimits(2,Jderiv).GT.
     +      DerivAnomLimits(1,Jderiv)) THEN
             DerivAnomLimits(1,Jderiv) = SIGCT2
             DerivAnomLimits(2,Jderiv) = SIGCUT
        END IF
      END IF
C
C
      ITOK = ITOK + 2
      IF (ITOK.LT.NTOK) GO TO 240
      GO TO 40
C
C---- Threshhold
C     ==========
C
C   THRESHOLD  <thr> <acl>
C       These parameters allow you to modify large shifts  in  any
C       parameter. If any  parameter_shift   exceeds
C       <thr>*SD_parameter_shift then the shift is  "dampened"  by
C       <acl>.  The default is <ac1>=1, <thr> not set.
C
  250 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword THRE cannot be used after DERIV')
      IF (THR.LE.0.0) THR = 1.0E4
      IF (ACL.LE.0.0) ACL = 1.0
C
C          *******************************
      CALL GTPREA(2,THR,NTOK,ITYPE,FVALUE)
C          *******************************
C
C                    ************************************
      IF (NTOK.GE.3) CALL GTPREA(3,ACL,NTOK,ITYPE,FVALUE)
C                    ************************************
C
      GO TO 40
C
C---- HLOUT  - Hendrickson-Lattman coefficients output
C     =========================================
C
  260 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword HLOUT cannot be used after DERIV')
      HLFLAG = 1
      GO TO 40
C
C
C---- Output
C      FPHi ( DPHi) FHi ( FH"i)  Set IFH(Kderiv) ( IFHA(Kderiv)= 1
C      DPH etc output if this derivative has anomalous data.
C
C
  270 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword FHOUT cannot be used after DERIV')
      WORD = LINE(IBEG(2) :IEND(2))
      ITOK = 2
      IF (ITYPE(2).EQ.2) ITOK = 1
  275 ITOK = ITOK + 1
C
C          **********************************
      CALL GTPINT(ITOK,IDD,NTOK,ITYPE,FVALUE)
C          **********************************
C
      IFH(IDD) = 1
      IFHA(IDD) = 1
      IF (ITOK.LT.NTOK) GO TO 275
      GO TO 40
C
C---- SCRIPT KEYWORD
C     =============
C
  280 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword SCRIPT cannot be used after DERIV')
      LScript = .TRUE.
      GOTO 40
C
C---- COORD KEYWORD
C     =============
C
  700 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword COORD cannot be used after DERIV')
      LCoord = .TRUE.
      GOTO 40
C
C---- APPLY KEYWORD
C     =============
C
  285 CONTINUE
      IF (DFLAG.EQ.1)
     +   CALL CCPERR(1,' keyword APPLY cannot be used after DERIV')
      LAPPLY  = .TRUE.
      WRITE (6,'(3X,A,A)') 
     +   ' Refined derivative scale factors ',
     +   ' will be applied to output columns.'
      GOTO 40
C
C---- RUN KEYWORD - now open HKLIN
C     ==========================================
C
  290 CONTINUE
      IRNFLG = 1
C
C----   How many derivative thingies assigned?
C       Must have first 5 labels h k l FP SIG
C       Labels 6 and 7 for Anomalous Native data
C
      NumDerivatives = 0
C
      DO 300 ILPRGI = 8, (MaxNumDerivatives-1)*4+8, 4
        IF (JPOINT(ILPRGI).NE.0) THEN
          NumDerivatives = NumDerivatives + 1
C
C----  check Sig(Fhp) label - MUST be here...
C
          IF (JPOINT(ILPRGI+1).EQ.0) THEN
C
C                **************************************************
            CALL CCPERR(1,' **** Give input label for SIG(Fph) **')
C                **************************************************
C
          END IF
C
C
C
C----  check is there anomalous data?
C
          LANOM(NumDerivatives) = .FALSE.
C
C
          IF (JPOINT(ILPRGI+2).NE.0) THEN
            LANOM(NumDerivatives) = .TRUE.
C
C----  check Sig(DELhp) label -
C      MUST be here  ( maybe not ?? Set = 2*SIGFPh?)
C
            IF (JPOINT(ILPRGI+3).EQ.0) THEN
C
C                  **************************************************
              CALL CCPERR(1,' **** Give input label for SIG(DPh) **')
C                  **************************************************
C
            END IF
          END IF
        END IF
C
C
  300 CONTINUE
C
C
C----   First write out what you know...
C
      WRITE (6,FMT=6000) TITLE(1:LENSTR(TITLE))
 6000 FORMAT (//,
     +       7X,'**                  MLPHARE                  **',/,
     +       7X,'** Heavy Atom Phasing and Refinement Program **',/,
     +       7X,'**                                           **',//,
     +       7X,'Title for this run: "',A,'"',/)
C
C
      LELEC  = IELEC .NE. 0
      LCOR   = ICOR .NE. 0
      LSTAT  = ISTAT .NE. 0
      IPRINT = 1
C
C          **********************************
      CALL LROPEN(MTZIN,'HKLIN',IPRINT,IFAIL)
C          **********************************
C
      IF (IFAIL.EQ.1) THEN
        WRITE (ISYSW,FMT='(A)') ' Cannot find input file HKLIN'
C
C            *****************************
        CALL CCPERR(1,' Execution Halted')
C            *****************************
C
      END IF

C----  Read symmetry and check
C
      CALL LRSYMI(MTZIN,NSMP,LTYPE,LSPGRX,NAMSPG,PGNAME)
      IF (NumSymmetry.GT.0) THEN
        IF (NSMP.NE.NumPrimSymmetry .OR.
     +      LSPGRX.NE.NumSpaceGroup) CALL CCPERR(1,
     +      '  Inconsistent symmetry information')
      END IF
C
C
      NumPrimSymmetry = NSMP
      NumSpaceGroup   = LSPGRX
      CALL LRSYMM(MTZIN,NumSymmetry,RSYM)
C   Check whether this is a polar spacegroup.
       CALL CALC_ORIG_PS(NAMSPG,NumSymmetry,RSYM,NORIG,ORIG,
     +                         LPAXISX,LPAXISY,LPAXISZ)
C     =========================================================
C
C -P- CALC_ORIG_PS - creates list of equivalent origins for the named spacegroup.
C       And returns flag indicating whether spacegroup Polar
C
C                  ARGUMENTS
C                  ---------
C                    (I) NAMSPG_CIF - spacegroup name (character)
C                    (I) NSYM - number of symmetry operations
C                    (I) RSYM(4,4,NSYM) - symmetry ops stored as 4x4 matrices
C                    (O) NORIG - number of origins.
C                    (O) ORIG(3,i) - vector of alternate origin
C                               (for example : 0.5,0.0,0.5)
C                               only positive components.
C                               include vector: (0,0,0)
C                    (O) LPAXISX - logical; set true if s/grp is polar along x axis
C                    (O) LPAXISY - logical; set true if s/grp is polar along y axis
C                    (O) LPAXISZ - logical; set true if s/grp is polar along z axis
C
C
C   Find the MTZ "Missing value" flag
       SETVAL = .FALSE.
       CALL SET_MAGIC(MTZIN,VAL_MAGIC,SETVAL)
C
C----    Set up Centric and LOClon tests
C
      IPRINT = 1
C
C          ***************************
      CALL CENTRIC(NumSymmetry,RSYM,IPRINT)
      CALL EPSLN(NumSymmetry,NumPrimSymmetry,RSYM,IPRINT)
C          *****************************
C
      IF (NumSymmetry.GT.MaxSymmetry) GO TO 680
C

C       JPOINT (..) set to -1 for requested columns
C      CALL LKYSET(LSPRGI,NLPRGI,LSUSRJ,JPOINT,ITOK,NTOK,LINE,IBEG,IEND)
C   If you want to output all columns you need this complicated junk..
C      Check wht labels haven't been used yet?
C
      IF (OUTFLG.GT.1.1) THEN
        NumExtraMtzCols = 0
        IEXTRA = 110
        CALL LRCLAB(MTZIN,LSUSRK,CTUSRK,NCOLS)
C
C
        DO 320 I = 4,NCOLS
          ILEN1 = LENSTR(LSUSRK(I))
          IF (ILEN1.GT.0) THEN
          DO 310 J = 4,NLPRGI
            ILEN2 = LENSTR(LSUSRJ(J))
            IF (ILEN2.GT.0) THEN
            IF (LSUSRK(I) (1:ILEN1).EQ.LSUSRJ(J) (1:ILEN2)) GO TO 320
            ENDIF
  310     CONTINUE
C
C
          IEXTRA = IEXTRA + 1
          LSPRGI(IEXTRA) = LSUSRK(I)
          CTPRGI(IEXTRA) = CTUSRK(I)
          JPOINT(IEXTRA)=-1
          ENDIF
  320   CONTINUE
C
C
        NumExtraMtzCols = MAXNUMEXTRACOLLABS + IEXTRA - 110
        NLPRGI = NLPRGI + IEXTRA - 110
      END IF
C
C          ****************************************
      CALL LRASSN(MTZIN,LSPRGI,NLPRGI,JPOINT,CTPRGI)
C     Notify available space
      NDATASETS = MSETS
      CALL LRIDX(MTZIN,PNAME,XNAME,DNAME,ISETS,
     +             DATCELL,DATWAVE,NDATASETS)

C---- Get dataset ID for column and match to dataset header info.
      IF (NDATASETS.GT.0) 
     +  CALL LRCLID(MTZIN,CSETID,IDUMMY)
C
C----   Set KPOINT = II if label called twice
C
      DO 340 II = 4,NLPRGI - 1
        DO 330 I = II + 1,NLPRGI
          IF (JPOINT(I).EQ.JPOINT(II)) KPOINT(I) = II
          IF (JPOINT(I).EQ.JPOINT(II)) KPOINT(II) = I
  330   CONTINUE
  340 CONTINUE
      CALL LRCELL(MTZIN,CELL)
C          ****************************************
C
C-----   Use CELL to set  up PARAM array
C
      DO 350 I = 1,6
        PARAM(I) = CELL(I)
  350 CONTINUE
C
C---- Initialise and open pdb file for output of HA coords
C     Use information in CELL to write CRYST1 and SCALE cards
C     and to set up orthogonalising/fractionalising matrices
C
      IF (LCoord) THEN
        WRITE (6,FMT='(/a,a/)') ' Opening Brookhaven file for refined ',
     +                          'coordinates ....'
        CALL XYZINIT
        IXFAIL  = 0
        IXYZOUT = 0
        CALL XYZOPEN('XYZOUT','OUTPUT',' ',IXYZOUT,IXFAIL)
        IF (IXFAIL.LT.0) CALL CCPERR
     +          (1,'RCARDS: error when opening output COORDinate file')
        CALL WREMARK(IXYZOUT,
     +  'REMARK This is output from MLPHARE in a pseudo-PDB format')
        CALL WREMARK(IXYZOUT,
     +  'REMARK List of refined heavy atom coordinates (orthogonal')
        CALL WREMARK(IXYZOUT,
     +  'REMARK axes) for each derivative')
        CALL WBCELL(IXYZOUT,CELL,1)
        CALL RBFRAC2(CELL(1),CELL(2),CELL(3),CELL(4),CELL(5),CELL(6),1)
      END IF
C
C   Check resolution limits
C
      CALL LRRSOL(MTZIN,SMIN,SMAX)
      IF (SMIN.GT.SMINP) SMINP = SMIN
      IF (SMAX.LT.SMAXP) SMAXP = SMAX
      STMIN = SQRT(SMINP)
      STMAX = SQRT(SMAXP)
C
C----   Set up PHARE things..
C
C
      DO 360 IID = 1,MaxNumDerivatives
        DerivMinResol(1,IID) = SMINP
        DerivMaxResol(1,IID) = SMAXP
        DerivMinResol(2,IID) = SMINP
        DerivMaxResol(2,IID) = SMAXP
  360 CONTINUE
      DMIN = 1.0/STMIN
      DMAX = 1.0/STMAX
C
C
      call ccp4h_summary_beg()
      WRITE (6,FMT=6002) DMIN,DMAX,SigmaNatScale,THR,ACL
 6002 FORMAT (/,
     +' SUMMARY INFORMATION FOR INPUT PARAMETERS:',/,
     +' =========================================',//,
     +' Protein Resolution Limits are from ',F8.2,' to',F5.2,
     +       ' Angstroms',/,
     +' Native Sigmaas will be scaled by ',F10.3,/,
     +' Parameter Shifts greater than ',F10.3,/,
     +' Sigma will be scaled by',F10.3,/)
      WRITE (6,FMT=6004) NumRefCycles,
     +          (KRefineCycleFlag(I),I=1,NumRefCycles)
 6004 FORMAT (
     +' Number of Phasing and Refinement Cycles = ',I3,/,
     +3X,'Input Phasing Flags for each Cycle are ',/,
     +3X,30I2)
      WRITE (6,FMT='(A,A)') ' If phasing flag NE 0 - input phases will'
     +  ,' be combined with calculated phases.'
      WRITE (6,FMT=6006) IAngleStep,IELEC,ICOR,ISTAT
 6006 FORMAT (
     +' Phase Probabilities will be calculated every ',I3,
     +         ' degrees',/,
     +' Flag for Calculation of Atomic form factors in electrons = ',
     +         I5,/,
     +' Flag for printing of Correlation Matrices = ',I5,/,
     +' Flag for printing of Statistics on the Derivative Scale = ',
     +         I5,/)
C
C
      IF (CutOffNatSigma.GT.0) WRITE (6,
     +    FMT='(A,F7.1,A,/)') ' EXCLUDE Reflections if FP < ',
     +    CutOffNatSigma,'SIGFP'
C
      call ccp4h_summary_end()
C
C
      PARAM(4) = PARAM(4)/180.0*3.141592654
      PARAM(5) = PARAM(5)/180.0*3.141592654
      PARAM(6) = PARAM(6)/180.0*3.141592654
C
C          ******************************************
      CALL INICAL(PARAM,TCELL,AMAT,RMAT,RECSQ,VOLUME)
C          ******************************************
C
      PARAM(4) = PARAM(4)*180.0/3.141592654
      PARAM(5) = PARAM(5)*180.0/3.141592654
      PARAM(6) = PARAM(6)*180.0/3.141592654
C
C---- Open the output fle if LABOUT given.
C
C
C----   Organise output flags if outflg set
C
C       If IDFP  ne 0 output DP SIGDP
C       If IFC  ne 0 output FC
C       If IPC  ne 0 output PHIC
C       If IWC  ne 0 output WC
C       If IHLA ne 0 output A B C D:
C       If ifph(Kderiv) NE 0 output fph(Kderiv) sigfph(Kderiv)
C       If idph(Kderiv) NE 0 output dph(Kderiv) sigdph(Kderiv)
C       If ifh(Kderiv) NE 0 output fh(Kderiv) phih(Kderiv)
C       If ifha(Kderiv) NE 0 output fh"(Kderiv) phih"(Kderiv)
C
      IOUT = 0
      IF (HLFLAG.NE.0 .AND. OUTFLG.LT.0.1) CALL CCPERR(1,
     +'  No output LABELS requested, AND HL coefficients requested??')
C
C
      IF (OUTFLG.GT.0.1) THEN
        IOUT = 5
        IF (OUTFLG .GT. 1.1) THEN
          LSPRGO(4) = LSUSRK(JPOINT(4))
          LSPRGO(5) = LSUSRK(JPOINT(5))
          IF (NDATASETS.GT.0) THEN
            CSETOUT(1) = CSETID(JPOINT(1))
            CSETOUT(2) = CSETID(JPOINT(2))
            CSETOUT(3) = CSETID(JPOINT(3))
            CSETOUT(4) = CSETID(JPOINT(4))
            CSETOUT(5) = CSETID(JPOINT(5))
          ENDIF
        ENDIF
C
C----   Is there DP ..?
C
        IF (JPOINT(6).NE.0) THEN
          IDFP = 6
          IF (OUTFLG .GT. 1.1) THEN
            LSPRGO(IDFP) = LSUSRK(JPOINT(IDFP))
            LSPRGO(IDFP+1) = LSUSRK(JPOINT(IDFP+1))
            IF (NDATASETS.GT.0) THEN
              CSETOUT(IDFP) = CSETID(JPOINT(IDFP))
              CSETOUT(IDFP+1) = CSETID(JPOINT(IDFP+1))
            ENDIF
          ENDIF
          IOUT = IOUT + 2
        END IF
C
C----   You want to output PHIB and FOM?
C
        IPHIB           = IOUT + 1
        LSPRGO(IPHIB)   = LSPRGO(8)
        CTPRGO(IPHIB)   = CTPRGO(8)
        LSPRGO(IPHIB+1) = LSPRGO(9)
        CTPRGO(IPHIB+1) = CTPRGO(9)
        IF (NDATASETS.GT.0) THEN
C         Give PHI/FOM dataset of native
          CSETOUT(IPHIB)   = CSETID(JPOINT(4))
          CSETOUT(IPHIB+1) = CSETID(JPOINT(4))
        ENDIF
        IOUT            = IOUT + 2
C
C----   Do you want to output HLA HLB HLC and HLD?
C
        IF (HLFLAG.NE.0) THEN
          IHLA           = IOUT + 1
          LSPRGO(IHLA)   = LSPRGO(10)
          LSPRGO(IHLA+1) = LSPRGO(11)
          LSPRGO(IHLA+2) = LSPRGO(12)
          LSPRGO(IHLA+3) = LSPRGO(13)
          CTPRGO(IHLA)   = CTPRGO(10)
          CTPRGO(IHLA+1) = CTPRGO(11)
          CTPRGO(IHLA+2) = CTPRGO(12)
          CTPRGO(IHLA+3) = CTPRGO(13)
          IF (NDATASETS.GT.0) THEN
C           Give HLx dataset of native
            CSETOUT(IHLA)   = CSETID(JPOINT(4))
            CSETOUT(IHLA+1) = CSETID(JPOINT(4))
            CSETOUT(IHLA+2) = CSETID(JPOINT(4))
            CSETOUT(IHLA+3) = CSETID(JPOINT(4))
          ENDIF
          IOUT           = IOUT + 4
        END IF
C
C---- Do you want to output FHi PHIHi ?  ifh(Kderiv) is the flag
C     ifh(Kderiv) reset here to output column number.
C
C   You will get FHPi SIGFPHi ( DPHi SIGDPHi) FHi PHIHi
C
        DO 370 Kderiv = 1,NumDerivatives
          IOUTH = 8*Kderiv + 10
          IINH  = 4*Kderiv + 8 - 4
          LANOONLY(KDERIV) = .FALSE.
          IF (KPOINT(IINH).NE.0) LANOONLY(KDERIV) = .TRUE.
          IF (IFH(Kderiv).NE.0 .OR. OUTFLG.GT.1.1) THEN
C
C----    Pick up FHPi  SIGHPi
C
C  Check if this label used for FP - do not add it in that case
C
            IF (KPOINT(IINH).EQ.0) THEN
              IFPH(Kderiv)   = IOUT + 1
              LSPRGO(IOUT+1) = LSUSRK(JPOINT(IINH))
              LSPRGO(IOUT+2) = LSUSRK(JPOINT(IINH+1))
              CTPRGO(IOUT+1) = CTUSRK(JPOINT(IINH))
              CTPRGO(IOUT+2) = CTUSRK(JPOINT(IINH+1))
              IF (NDATASETS.GT.0) THEN
                CSETOUT(IOUT+1) = CSETID(JPOINT(IINH))
                CSETOUT(IOUT+2) = CSETID(JPOINT(IINH+1))
              ENDIF
              IOUT           = IOUT + 2
            END IF
C
C----    Pick up DHP if present...
C
            IF (JPOINT(IINH+2).NE.0) THEN
              IDPH(Kderiv)   = IOUT + 1
              LSPRGO(IOUT+1) = LSUSRK(JPOINT(IINH+2))
              LSPRGO(IOUT+2) = LSUSRK(JPOINT(IINH+3))
              CTPRGO(IOUT+1) = CTUSRK(JPOINT(IINH+2))
              CTPRGO(IOUT+2) = CTUSRK(JPOINT(IINH+3))
              IF (NDATASETS.GT.0) THEN
                CSETOUT(IOUT+1) = CSETID(JPOINT(IINH+2))
                CSETOUT(IOUT+2) = CSETID(JPOINT(IINH+3))
              ENDIF
              IOUT           = IOUT + 2
            END IF
          END IF
C
C----    Add FH PHIH
C
          IF (IFH(Kderiv).NE.0) THEN
            IFH(Kderiv)    = IOUT + 1
            LSPRGO(IOUT+1) = LSPRGO(IOUTH)
            LSPRGO(IOUT+2) = LSPRGO(IOUTH+1)
            CTPRGO(IOUT+1) = CTPRGO(IOUTH)
            CTPRGO(IOUT+2) = CTPRGO(IOUTH+1)
            IF (NDATASETS.GT.0) THEN
C             Give FH/PHIH dataset of derivative
              CSETOUT(IOUT+1) = CSETID(JPOINT(IINH))
              CSETOUT(IOUT+2) = CSETID(JPOINT(IINH))
            ENDIF
            IOUT           = IOUT + 2
C
C----   Do you want to output FHAi PHIHAi ?
C       Automatic if you use ano data.
C ---  Turn off IFHA flag now if there is no anomalous data input.

            IF (JPOINT(IINH+2).EQ.0) IFHA(Kderiv) = 0
            IF (JPOINT(IINH+2).NE.0) THEN
              IFHA(Kderiv)   = IOUT + 1
              LSPRGO(IOUT+1) = LSPRGO(IOUTH+2)
              LSPRGO(IOUT+2) = LSPRGO(IOUTH+3)
              CTPRGO(IOUT+1) = CTPRGO(IOUTH+2)
              CTPRGO(IOUT+2) = CTPRGO(IOUTH+3)
              IF (NDATASETS.GT.0) THEN
C             Give FHA/PHIHA dataset of derivative
                CSETOUT(IOUT+1) = CSETID(JPOINT(IINH))
                CSETOUT(IOUT+2) = CSETID(JPOINT(IINH))
              ENDIF
              IOUT           = IOUT + 2
            END IF
          END IF
  370   CONTINUE
C
C----   Is there FC ..?
C
        IF (JPOINT(88).NE.0) THEN
          IFC            = IOUT + 1
          LSPRGO(IOUT+1) = LSPRGI(88)
          CTPRGO(IOUT+1) = CTPRGI(88)
          IF (NDATASETS.GT.0) THEN
            CSETOUT(IOUT+1) = CSETID(JPOINT(88))
          ENDIF
          IOUT           = IOUT + 1
        END IF
C
C
        IF (JPOINT(89).NE.0) THEN
          IPC            = IOUT + 1
          LSPRGO(IOUT+1) = LSPRGI(89)
          CTPRGO(IOUT+1) = CTPRGI(89)
          IF (NDATASETS.GT.0) THEN
            CSETOUT(IOUT+1) = CSETID(JPOINT(89))
          ENDIF
          IOUT           = IOUT + 1
        END IF
C
C
        IF (JPOINT(90).NE.0) THEN
          IWC            = IOUT + 1
          LSPRGO(IOUT+1) = LSPRGI(90)
          CTPRGO(IOUT+1) = CTPRGI(90)
          IF (NDATASETS.GT.0) THEN
            CSETOUT(IOUT+1) = CSETID(JPOINT(90))
          ENDIF
          IOUT           = IOUT + 1
        END IF
C
C----   Do you want to carry over F0 F1 etc?
C----   First check F0 F1 ... then ALLIN assignments...
C ----  NumExtraMtzCols = MaxNumExtraColLabs ( 20) + all addins...
C
        IF (NumExtraMtzCols.EQ.0) NumExtraMtzCols = MAXNUMEXTRACOLLABS
C
C
        DO 380 IEXTRA = 1,NumExtraMtzCols
          IF (JPOINT(90+IEXTRA).NE.0) THEN
            IFADD(IEXTRA)  = IOUT + 1
            LSPRGO(IOUT+1) = LSPRGI(90+IEXTRA)
            CTPRGO(IOUT+1) = CTPRGI(90+IEXTRA)
            IF (NDATASETS.GT.0) THEN
              CSETOUT(IOUT+1) = CSETID(JPOINT(90+IEXTRA))
            ENDIF
            IOUT           = IOUT + 1
          END IF
  380   CONTINUE
C
C
        NLPRGO = IOUT
        LINE = LABOUT_SAVE
C
C
        II = LENSTR(LINE)
        IF (II.GT.0) THEN
          CALL PARSER(KEY,LINE,IBEG,IEND,ITYPE,FVALUE,CVALUE,IDEC,NTOK,
     +                LEND,.TRUE.)
          CALL LKYOUT(MTZOUT,LSPRGO,NLPRGO,NTOK,LINE,IBEG,IEND)
        END IF
C
C
      END IF
C
C
      IF (OUTFLG.GT.0.1) THEN
C
C          *************************
        CALL LWOPEN(MTZOUT,'HKLOUT')
C          *************************
C
C
        IAPPND = 0
C
C            ******************************************
        CALL LWASSN(MTZOUT,LSPRGO,NLPRGO,CTPRGO,IAPPND)
C            ******************************************
C
C---- Copy over the header stuff to output file, what a pain.
C
        IF (MTZOUT .EQ. 2) THEN
          NLINES = 50
C
C              ****************************************************
          CALL LRTITL(MTZIN,MTZTIT,LEN)
          CALL LWTITL(MTZOUT,MTZTIT,0)

          IF(.NOT.SETVAL) CALL SET_MAGIC(MTZOUT,VAL_MAGIC,SETVAL)
          CALL LRHIST(MTZIN,HISTORY,NLINES)
          CALL LWHIST(MTZOUT,HISTORY,NLINES)
          CALL LWHSTL(MTZOUT,' ')
          CALL LWCELL(MTZOUT,CELL)

          CALL LWSYMM(MTZOUT,NumSymmetry,NumPrimSymmetry,RSYM,LTYPE,
     +                 NumSpaceGroup,NAMSPG,PGNAME)
          CALL LRSORT(MTZIN,MTZSORT)
          CALL LWSORT(MTZOUT,MTZSORT)

C Store the project name and dataset name in the mtz header:
          DO 286 ISET = 1,NDATASETS
            CALL LWIDX(MTZOUT,PNAME(ISET),XNAME(ISET),DNAME(ISET),
     +                      DATCELL(1,ISET),DATWAVE(ISET))
 286      CONTINUE
C              ****************************************************
C
        ENDIF

        IF (NDATASETS.GT.0) THEN
          DO 115 JDO115 = 1,NLPRGO
            SETID = CSETOUT(JDO115)
            DO ISET = 1,NDATASETS
              IF (ISETS(ISET).EQ.SETID) THEN
                XNAME_OUT(JDO115) = XNAME(ISET)
                DNAME_OUT(JDO115) = DNAME(ISET)
              END IF
            ENDDO
 115      CONTINUE

          CALL LWIDASX(MTZOUT,NLPRGO,XNAME_OUT,DNAME_OUT,IAppnd)
        ENDIF

      END IF
C
C----  Set DERIV count back to 0
C
      Jderiv = 0
C
C----  Have you just read a DERIV card - or RUN??
C
      IF (DFLAG.EQ.0) GO TO 40
      IF (DFLAG.EQ.1) GO TO 420
C
C---- Derivative card - followed by ID and derivative title.
C     ======================================================
C
C   DERIV <title>
C       <title> is used to flag the output. Be informative!  (Com-
C       pulsory for each derivative assigned on the LABIN line.)
C
  390 CONTINUE
C
C----  If a derivative has been input write out info..
C      Set DERIV flag -
C      all keywords from now on relate to this derivative.
C  Fill in title straight away - line may be overwritten
C
cpjx      DerivTitle(Jderiv+1) = ' '
      DerivTitle(Jderiv+1) = '[unnamed]'
      IF (NTOK.GT.1) 
     +      DerivTitle(Jderiv+1) = LINE(IBEG(2) :IEND(NTOK))
      DFLAG = 1
C
C----   No RUN keyword..
C
      IF (IRNFLG.EQ.0 .AND. Jderiv.EQ.0) GO TO 290
C
C----    RUN keyword read already ..
C
      IF (Jderiv.EQ.0) GO TO 420
      NATOMS = IHATOM - IndexRefFlags(Jderiv) + 1
      RR1 = 1000
      IF (DerivMinResol(1,Jderiv).GT.0.00001) 
     +    RR1 = SQRT(1.0/DerivMinResol(1,Jderiv))
      RR2 = 1
      IF (DerivMaxResol(1,Jderiv).GT.0.00001) 
     +    RR2 = SQRT(1.0/DerivMaxResol(1,Jderiv))
          RR2J = RR2
C
C---- Print out details for each derivative
C
      call ccp4h_summary_beg()
      WRITE (6,FMT=6008) Jderiv,
     +     DerivTitle(Jderiv)(1:LENSTR(DerivTitle(Jderiv))),RR1,RR2,
     +     NATOMS
 6008 FORMAT (///,
     + ' Summary of input for Compound ',I2,': "',A,'"',/,
     + ' ----------------------------------------------------',/,
     + ' Resolution limits ',2f8.2,/,
     + '     Number of sites = ',I3)
C
C
      IF (DerivSigmaLimit(Jderiv).GT.0.00001) WRITE (6,
     +    FMT='(/,a,f7.1,a)') ' EXCLUDE Reflections if FPH < ',
     +    DerivSigmaLimit(Jderiv),'SIGFPH'
      IF (DerivIsoLimit(Jderiv).GT.0.00001) 
     +    WRITE (6,FMT='(/,a,f7.1,a)') 
     +    ' EXCLUDE Reflections if abs(FPH -FP) > ',
     +    DerivIsoLimit(Jderiv)
      IF (DerivAnomLimits(1,Jderiv).GT.0.00001) 
     +    WRITE (6,FMT='(/,a,f7.1,a)')
     +    ' EXCLUDE Reflections if abs(FPH(+) -FPH(-)) > ',
     +    DerivAnomLimits(1,Jderiv)
      IF (DerivAnomLimits(2,Jderiv).NE.-100.0) 
     +    WRITE (6,FMT='(/,a,f7.1,a)')
     +    ' EXCLUDE Reflections if abs(FPH(+) -FPH(-)) < ',
     +    DerivAnomLimits(2,Jderiv)
C
C
      KAY = 0
C
C
      IF (LANOM(Jderiv)) THEN
C
C---- Reset anom resolution limits to real if no limits input.
C
        IF (DerivMinResol(2,Jderiv).EQ.SMINP) 
     +      DerivMinResol(2,Jderiv) = DerivMinResol(1,Jderiv)
        IF (DerivMaxResol(2,Jderiv).EQ.SMAXP) 
     +      DerivMaxResol(2,Jderiv) = DerivMaxResol(1,Jderiv)
        RR1 = 1000
        IF (DerivMinResol(2,Jderiv).GT.0.00001) 
     +      RR1 = SQRT(1.0/DerivMinResol(2,Jderiv))
        RR2 = 1
        IF (DerivMaxResol(2,Jderiv).GT.0.00001) 
     +      RR2 = SQRT(1.0/DerivMaxResol(2,Jderiv))
C
C
        WRITE (6,FMT='(/,a,2f8.2)')
     +    ' Resolution limits for anomalous data',RR1,RR2
        IF (DerivSigmaLimit(Jderiv).GT.0.00001) 
     +    WRITE (6,FMT='(/,a,f5.1,a)')
C
C
        KAY = 1
      END IF
C
C
      WRITE (6,FMT=6010) KAY
 6010 FORMAT (5X,'Anomalous Dispersion Flag = ',I3)
      WRITE (6,FMT=6012) DerivScaleToNative(Jderiv),
     +                    DerivOverallBfact(Jderiv),
     +                     DerivSigmaScale(Jderiv)
 6012 FORMAT (
     +5X,'Dividing Scale Factor for FPH and SIGFPH= ',F12.5,/,
     +5X,'Overall Temperature Factor = ',F12.5,/,
     +5X,'Sigmas also will be multiplied by ',F10.3)
C
C----  iflag(1 -10) = nphase(i), iflag(11-20) = nrefin(i), iflag(21-30)
C     = IFBOV(i)
C
      WRITE (6,FMT=6014) (NPHASE(Jderiv,II),II=1,NumRefCycles)
 6014 FORMAT (5X,'Phasing Flags        = ',30I1)
      WRITE (6,FMT=6016) (NREFIN(Jderiv,II),II=1,NumRefCycles)
 6016 FORMAT (5X,'Refinement Flags     = ',30I1)
      WRITE (6,FMT=6018) (IFBOV(Jderiv,II),II=1,NumRefCycles)
 6018 FORMAT (5X,'Refinement Overall B = ',30I1)
C
C----   Check if refinment requested.
C
      DO 400 II = 1,NumRefCycles
        JREF = NREFIN(Jderiv,II) + JREF
  400 CONTINUE
C
C
      WRITE (6,FMT=6020) (ESQ(Jderiv,J),J=1,MaxNumResoBins)
 6020 FORMAT (5X,'Estimated RMS Lack of Closure (for each resln shell)',
     +     /5X,8F7.2)
C
C
      IF (LANOM(Jderiv)) THEN
        WRITE (6,FMT=6022) (ASQ(Jderiv,J),J=1,MaxNumResoBins)
 6022   FORMAT (5X,'Estimated RMS Error in Anomalous Dispersion',/5X,
     +         8F7.2)
      END IF
C
      JSITE = 1
      DO 410 IAT = IHATOM - NATOMS + 1,IHATOM
        XA = RMAT(1,1)*X(IAT) + RMAT(1,2)*Y(IAT) + RMAT(1,3)*Z(IAT)
        YA = RMAT(2,1)*X(IAT) + RMAT(2,2)*Y(IAT) + RMAT(2,3)*Z(IAT)
        ZA = RMAT(3,1)*X(IAT) + RMAT(3,2)*Y(IAT) + RMAT(3,3)*Z(IAT)
        XTEST(1,IAT) = X(IAT)
        XTEST(2,IAT) = Y(IAT)
        XTEST(3,IAT) = Z(IAT)
C
C        XA = X(IAT)*TCELL(1)
C        YA = Y(IAT)*TCELL(2)
C        ZA = Z(IAT)*TCELL(3)
        WRITE (6,FMT=6024) JSITE,ATNAME(IAT),X(IAT),Y(IAT),Z(IAT),XA,YA,
     +    ZA
 6024   FORMAT (/5X,
     +   'Site Number ',I3,2X,A4,/,5X,
     +   '------------------------',/,7X,
     +   'Coordinates in Fractions ',3F10.5,/20X,
     +   'in Angstroms ',3F8.2)
C
C   Check if this is only Anomalous - if so set "Real occ" = 0.0
        IF(LAnoOnly(Jderiv)) then
           CALL CCPERR(2,
     +    ' All real occupancies must be 0.00 for this derivative')
          Do K = 1,NDAT(Jderiv)
           OCC(IAT,K) = 0.00
          End Do
        End if
C
        WRITE (6,FMT=6026) IAT,(OCC(IAT,K),K=1,NDAT(Jderiv))
 6026   FORMAT (7X,'Real Occupancy   Atom',I4,8F10.3)
C
C
        IF (LANOM(Jderiv)) THEN
C  Check if refinement flags reasonable
          WRITE (6,FMT=6028) Iat,(AOCC(IAT,K),K=1,NDAT(Jderiv))
 6028     FORMAT (7X,'Anom Occupancy   Atom',I4,8F10.3)
C      IF ( Some of LABIN(6/7/8/9/10,IAT,1) ne 0  AND All AOCC = 0.0 something wrong
          LABCHK = 0
          OCCCHK = 0.0
          DO K = 6,10 
           LABCHK = LABCHK + LABIN(K,IAT,1) 
          END DO 
          Do K = 1,NDAT(Jderiv)
           OCCCHK = OCCCHK + ABS( AOCC(IAT,K))
          End Do
C If refinement of anomalous occupancy requested when aocc = 0
C then alert user and terminate 
          IF(LABCHK.GT.0 .AND. OCCCHK .LT. 0.0000001) THEN
            WRITE (6, FMT=6029)
 6029       FORMAT (/,1X,'** Refinement of anom occ requested for this',
     +           ' site',/,1X,'** but its anom occ is already zero',/)
            WRITE(ERRLINE,'(A,A)')
     +    ' Cannot refine any parameters if occupancies are zero -',
     +    ' reset them'
            CALL CCPERR(1,ERRLINE)
          END IF
        END IF
C
C
        WRITE (6,FMT=6030) (AFM(IAT,K),BFM(IAT,K),K=1,4),CFM(IAT)
 6030   FORMAT (7X,
     +'Form Factor Gaussian   ( C modified to include Fprime)',/5X,
     +          5 (2X,2F8.4))
C
C
        IF (LANOM(Jderiv)) THEN
          WRITE (6,FMT=6032) FPP(IAT)
 6032     FORMAT (7X,'Anomalous F"         ',F8.4)
        END IF
C
C
        IF (NTROP(IAT).EQ.6) WRITE (6,FMT=6034) NTROP(IAT),B1(IAT),
     +      B2(IAT),B3(IAT),B4(IAT),B5(IAT),B6(IAT)
 6034   FORMAT (7X,'Number of B values used = ',I2,/7X,'B Values are',
     +         3X,6F12.6)
        IF (NTROP(IAT).EQ.1) WRITE (6,FMT=6034) NTROP(IAT),B1(IAT)
C
C  Check if refinement flags reasonable
      IF (ICENFLG.EQ.1 )THEN
C  Xpolar?
       IF(LPAXISX) THEN
        IF(IAT.EQ.1) THEN
          WRITE(ERRLINE,'(A,A)')
     +    ' Cannot refine X parameters with CENTRIC data only in this',
     +    ' Polar  spacegroup!'
          CALL CCPERR(2,ERRLINE)
        ENDIF
C  Turn off refinement / flag coordinate as undefined
        DO II=1,NumRefCycles
          LABIN(3,IAT,II) = 0
          XTEST(1,IAT) = -99999.0
        END DO 
       END IF
C  Ypolar?
       IF(LPAXISY) THEN
        IF(IAT.EQ.1) THEN
          WRITE(ERRLINE,'(A,A)')
     +    ' Cannot refine Y parameters with CENTRIC data only in this',
     +    ' Polar spacegroup!'
          CALL CCPERR(2,ERRLINE)
        ENDIF
        DO II=1,NumRefCycles
          LABIN(4,IAT,II) = 0
          XTEST(2,IAT) = -99999.0
        END DO 
       END IF
C  Zpolar?
       IF(LPAXISZ) THEN
        IF(IAT.EQ.1) THEN
          WRITE(ERRLINE,'(A,A)')
     +    ' Cannot refine Z parameters with CENTRIC data only in this',
     +    ' Polar  spacegroup!'
          CALL CCPERR(2,ERRLINE)
        ENDIF
        DO II=1,NumRefCycles
          LABIN(5,IAT,II) = 0
          XTEST(3,IAT) = -99999.0
        END DO 
       END IF
      END IF 
C
C  Check some coordinate fixed for Polar spacegroups
        DO II=1,NumRefCycles
         DO MU=1,10
          LABTOT(MU,II) =  LABTOT(MU,II)*LABIN(MU,IAT,II)
         END DO 
        END DO 
C
        WRITE (6,FMT=9035)
        WRITE (6,FMT=9036) (LABIN(1,IAT,II),II=1,NumRefCycles)
        WRITE (6,FMT=9037) (LABIN(2,IAT,II),II=1,NumRefCycles)
        WRITE (6,FMT=9038) (LABIN(3,IAT,II),II=1,NumRefCycles)
        WRITE (6,FMT=9039) (LABIN(4,IAT,II),II=1,NumRefCycles)
        WRITE (6,FMT=9040) (LABIN(5,IAT,II),II=1,NumRefCycles)
 9035   FORMAT (/,7X,'Isomorphous refinement flags at each cycle for:')
 9036   FORMAT (7X,'                      OCC',1X,30I1)
 9037   FORMAT (7X,'                        B',1X,30I1)
 9038   FORMAT (7X,'                        X',1X,30I1)
 9039   FORMAT (7X,'                        Y',1X,30I1)
 9040   FORMAT (7X,'                        Z',1X,30I1)
C
C-----  anomalous refinement flags
C
        IF (LANOM(Jderiv)) THEN
          WRITE (6,FMT=9046) (LABIN(6,IAT,II),II=1,NumRefCycles)
          WRITE (6,FMT=9047) (LABIN(7,IAT,II),II=1,NumRefCycles)
          WRITE (6,FMT=9048) (LABIN(8,IAT,II),II=1,NumRefCycles)
          WRITE (6,FMT=9049) (LABIN(9,IAT,II),II=1,NumRefCycles)
          WRITE (6,FMT=9050) (LABIN(10,IAT,II),II=1,NumRefCycles)
        END IF
 9046   FORMAT (/,7X,'Refinement flags for ANOMALOUS dispersion',/,
     +          7X,'at each cycle for:    OCC',1X,30I1)
 9047   FORMAT (7X,'                        B',1X,30I1)
 9048   FORMAT (7X,'                        X',1X,30I1)
 9049   FORMAT (7X,'                        Y',1X,30I1)
 9050   FORMAT (7X,'                        Z',1X,30I1)
C
C
        WRITE (6,FMT='(/)')
C
C----  End of previous derivative output
C
        JSITE = JSITE + 1
  410 CONTINUE
C    Check distances
C  Check distance: get rid of this atom if distance to any other < 0.5*Reso A
      IF( NATOMS.GT.1) THEN
        DO IAT = IHATOM - NATOMS + 1,IHATOM-1
         DO JAT = IAT + 1,IHATOM
          DO ISYM = 1,NumSymmetry
           IF(XTEST(1,IAT).LT.-99998.0) THEN
             DISTX = 0.0
           ELSE 
           XA = RSYM(1,1,ISYM)*XTEST(1,JAT)+RSYM(1,2,ISYM)*XTEST(2,JAT) 
     $        + RSYM(1,3,ISYM)*XTEST(3,JAT)+RSYM(1,4,ISYM)
           DISTX = X(IAT) - XA + 999.0
           NDIST = NINT(DISTX)
           DISTX = DISTX - NDIST
           END IF
           IF(XTEST(2,IAT).LT.-99998.0) THEN
             DISTY = 0.0
           ELSE 
           YA = RSYM(2,1,ISYM)*XTEST(1,JAT)+RSYM(2,2,ISYM)*XTEST(2,JAT) 
     $        + RSYM(2,3,ISYM)*XTEST(3,JAT)+RSYM(2,4,ISYM)
           DISTY = Y(IAT) - YA + 999.0
           NDIST = NINT(DISTY)
           DISTY = DISTY - NDIST
           END IF
           IF(XTEST(3,IAT).LT.-99998.0) THEN
             DISTZ = 0.0
           ELSE 
           ZA = RSYM(3,1,ISYM)*XTEST(1,JAT)+RSYM(3,2,ISYM)*XTEST(2,JAT) 
     $        + RSYM(3,3,ISYM)*XTEST(3,JAT)+RSYM(3,4,ISYM)
           DISTZ = Z(IAT) - ZA + 999.0
           NDIST = NINT(DISTZ)
           DISTZ = DISTZ - NDIST
           END IF
           D1 = RMAT(1,1)*DISTX + RMAT(1,2)*DISTY + RMAT(1,3)*DISTZ
           D2 = RMAT(2,1)*DISTX + RMAT(2,2)*DISTY + RMAT(2,3)*DISTZ
           D3 = RMAT(3,1)*DISTX + RMAT(3,2)*DISTY + RMAT(3,3)*DISTZ
           DIST = D1*D1 + D2*D2 + D3*D3
           DIST = SQRT(ABS(DIST))
C            write(6,'(a,3i4,4f9.3)')' iat,jat,isym,distx..y z,dist',
C     $  iat,jat,isym,distx,disty,distz,dist
C
           IF(DIST.LT. RR2J/2.0) THEN
              DO K=1,NDAT(Jderiv)
                OCC(JAT,K)  = 0.0
                AOCC(JAT,K) = 0.0
              END DO 

              DO K=1,NumRefCycles
               DO KK=1,10
                LABIN(KK,JAT,K) = 0
               END DO 
              END DO 
              WRITE(6,'(A,I3,a,I3,a,F8.2)') ' Atoms' ,Iat,' and', JAT,
     +        ' too close together - Distance:',DIST
              CALL CCPERR(2,
     +         ' Atoms too close together - 2nd occupancy set to 0.0')
           END IF
C
          END DO 
         END DO 
        END DO 
      END IF
C
        call ccp4h_summary_end()
C
C
C     
  420 CONTINUE
C
C
      IndexRefFlags(Jderiv+1) = IHATOM + 1
      IF (IFIN.EQ.1) THEN
C  Check fixed coordinates
C  Xpolar?
       IF(LPAXISX)THEN
        DO II=1,NumRefCycles
          IF( LABTOT(3,II).NE.0) THEN
           LABIN(3,1,II) = 0
           IF(II.EQ.1) CALL CCPERR(2,
     +     ' Fixing first X coordinate for Polar spacegroup')
          END IF
          IF( LABTOT(8,II).NE.0) THEN
           LABIN(8,1,II) = 0
           IF(II.EQ.1) CALL CCPERR(2,
     +     ' Fixing first AX coordinate for Polar spacegroup')
          END IF
        END DO
       END IF

C  Ypolar?
       IF(LPAXISY)THEN
        DO II=1,NumRefCycles
          IF( LABTOT(4,II).NE.0) THEN
           LABIN(4,1,II) = 0
           IF(II.EQ.1) CALL CCPERR(2,
     +     ' Fixing first Y coordinate for Polar spacegroup')
          END IF
          IF( LABTOT(9,II).NE.0) THEN
           LABIN(9,1,II) = 0
           IF(II.EQ.1) CALL CCPERR(2,
     +     ' Fixing first AY coordinate for Polar spacegroup')
          END IF
        END DO
       END IF

C  Zpolar?
       IF(LPAXISZ)THEN
        DO II=1,NumRefCycles
          IF( LABTOT(5,II).NE.0) THEN
           LABIN(5,1,II) = 0
           IF(II.EQ.1) CALL CCPERR(2,
     +     ' Fixing first Z coordinate for Polar spacegroup')
          END IF
          IF( LABTOT(10,II).NE.0) THEN
           LABIN(10,1,II) = 0
           IF(II.EQ.1) CALL CCPERR(2,
     +     ' Fixing first AZ coordinate for Polar spacegroup')
          END IF
        END DO
       END IF
C
         GO TO 630
      END IF 
      Jderiv = 1 + Jderiv
      NAtomsPerDeriv(Jderiv) = 0
C
C----  set nDAT(Jderiv) =1
C
      NDAT(Jderiv) = 1
C
C----  Set defaults
C
      DerivScaleToNative(Jderiv) = 1.0
      DerivOverallBfact(Jderiv) = 0.0
      DerivSigmaScale(Jderiv)   = 1.0
C
C
      DO 430 I = 1,MaxNumRefCycles
        NPHASE(Jderiv,I) = 0
        NREFIN(Jderiv,I) = 0
        IFBOV(Jderiv,I)  = 0
  430 CONTINUE
C
C
      IF (ONLY_PHASE) NPHASE(Jderiv,1) = 1
C
C
      GO TO 40
C
C---- Fph scale and b factor, SIGFPh scale - see label 130
C     Fph sigma cutoff - Mod(Fp - Fph)
C       cutoff- Mod(Fph(+) - Fph(-) )  cutoff
C       all set with EXCLUDE keyword ( Label 140)
C
C  dcycle phase all ref 1 3 5 7 9 kbov 1 2 3 4 5 6 7 8 9 10
C
C       Derivative cycle information.
C---- Phase on some cycles: Refine on some cycles Refine overall scale
C                                                 and B on some cycles
C
C
C   DCYCLE [PHASE] i1 i2  [REFCYCLE] j1 j2  [KBOVERALL] k1 k2
C       Subsidiary keywords PHASE, REFCYCLE, KBOVERALL control the
C       use  of  this  derivative.  Default  is  NOT  to  use  the
C       derivative for PHASE, REFC and KBOV.
C         PHASE [ALL] or i1 i2 ...
C         REFCYCLE [ALL] or j1 j2 ...
C         KBOVERALL [ALL] or k1 k2 ...
C       Then the  derivative is used for:
C         phasing  on cycles i1 i2 ...
C         refining on cycles j1 j2 ...
C       The overall scale and B are refined on cycles k1 k2 ...
C       (The word ALL means act on all cycles...)
C
  440 CONTINUE
      IPH = 0
      SUMPH=KCYCS
      IRF = 0
      IKB = 0
      ITOK = 2
  445 CONTINUE
      IF (ITOK.GT.NTOK.AND.SUMPH.GT.0) GO TO 40
C    Check some phase flags set.
        IF ( ITOK.GT.NTOK.AND.SUMPH.EQ.0) THEN
           WRITE(6,*)' You are not using this derivative for phasing'
           WRITE(6,*)' Resetting the phasing flags to include it'
           CALL CCPERR(2,
     +     'Resetting the phasing flags to include this derivative')
           DO  II = 1,NumRefCycles
             NPHASE(Jderiv,II) = 1
           END DO
           GO TO 40
        END IF 
C
C
      IF (ITYPE(ITOK).EQ.2) CALL CCPERR(1,
     +    ' ***Error - should have word PHASE or REF or KBOV**')
C
C----  Next word PHASE or REF or KDerivOverallBfactall
C
      WORD = LINE(IBEG(ITOK) :IEND(ITOK))

      CALL CCPUPC(WORD)
C
C---- reset flags so that a line such as
C        PHASE ALL REFCYC 1 4 7 KDerivOverallBfact ALL
C     previously didnt reset IRF = 0 so that it set all refinement
C     cycle flags to all while setting KDerivOverallBfact for all cycles
C
C    old code required order PHASE ALL KDerivOverallBfact ALL REFCYCLE 1 4 7
C
      IPH = 0
      IRF = 0
      IKB = 0
      IF (WORD.EQ.'PHASE') IPH = 1
      IF (WORD(1:3).EQ.'REF') IRF = 1
      IF (WORD(1:4).EQ.'KBOV') IKB = 1
      ITOK = ITOK + 1
C
C----  Next word ALL ???
C
      IF (ITYPE(ITOK).NE.2) THEN
        WORD = LINE(IBEG(ITOK) :IEND(ITOK))
        CALL CCPUPC(WORD)
C
C                               **********************************
        IF (WORD(1:3).NE.'ALL') CALL CCPERR(1,
     +                               '  **  Error in KEYWORD ** ')
C                               **********************************
C
        DO 450 II = 1,NumRefCycles
          IF (IPH.EQ.1) NPHASE(Jderiv,II) = 1
          IF (IPH.EQ.1) SUMPH = SUMPH + 1
          IF (IRF.EQ.1) NREFIN(Jderiv,II) = 1
          IF (IKB.EQ.1) IFBOV(Jderiv,II) = 1
  450   CONTINUE
C
C
        ITOK = ITOK + 1
Cejd    IF (ITOK.GT.NTOK) GO TO 40
        GO TO 445
      END IF
C
C----    read cycles to act upon..
C        Otherwise ITYPE(ITOK) .EQ.2)
C
C          **********************************
  455 CALL GTPINT(ITOK,NPH,NTOK,ITYPE,FVALUE)
C          **********************************
C
C
      IF (NPH.GT.NumRefCycles) CALL CCPERR(1,
     +        ' **  request number > NumRefCycles **')
C
      IF (IPH.EQ.1 .AND. NPH.GT.0) NPHASE(Jderiv,NPH) = 1
      IF (IPH.EQ.1 .AND. NPH.GT.0) SUMPH = SUMPH + 1
      IF (IRF.EQ.1 .AND. NPH.GT.0) NREFIN(Jderiv,NPH) = 1
      IF (IKB.EQ.1 .AND. NPH.GT.0) IFBOV(Jderiv,NPH) = 1
      ITOK = ITOK + 1
Cejd   IF (ITOK.GT.NTOK) GO TO 40
C
C----  another number.
C
      IF (ITYPE(ITOK).EQ.2) GO TO 455
C
C----  Otherwise another word..
C
      GO TO 445
C
C
C   WAVELENGTH w1 FPRIME f FDOUBLEPRIME ff
C       Subsidiary keywords FPRIME FDOUBLEPRIME
C        The F' and F" values overwrite those read from $CLIBD/atomsf.lib
C
  460 CONTINUE
C   Add this information to the DERIV title
        WRITE(DTITL,'(A,3x,A)')
     +  DerivTitle(Jderiv)(1:LENSTR(DerivTitle(Jderiv))),
     +  LINE(IBEG(1) :IEND(NTOK))
        DerivTitle(Jderiv) = DTITL
C
           ITOK = 2
C          **********************************
           CALL GTPREA(ITOK,WAV,NTOK,ITYPE,FVALUE)
C          **********************************
  465 CONTINUE
      ITOK = ITOK + 1
           IF (ITOK.GT.NTOK) GO TO 40
C
C
           IF (ITYPE(ITOK).EQ.2) CALL CCPERR(1,
     +    ' ***Error - should have word FPRIME or FDOUBLEPRIME **')
C
C----  Next word FPRIME or FDOUBLEPRIME
C
            WORD = LINE(IBEG(ITOK) :IEND(ITOK))
            ITOK = ITOK + 1
C          **********************************
           CALL GTPREA(ITOK,FFFA,NTOK,ITYPE,FVALUE)
C          **********************************
            IF ( WORD(1:2) .EQ.'FP') FPRIME(JDERIV) = FFFA  
            IF ( WORD(1:2) .EQ.'FD') FDOUBLEPRIME(JDERIV) = FFFA  
       GO TO 465
C


C----     ISOError
C         =========
C
C         Input Estimated error for Fhp -Fp
C
C   ISOERROR <ierr1> <ierr2> ... <ierr8>
C       Eight numbers giving the  estimated  isomorphous  lack  of
C       closure  error  as  a function of resolution.  For initial
C       refinements do not give these, and allow  the  program  to
C       evaluate  them.  If running a final phasing pass, take the
C       values output at the end of the refinement cycle.
C
  480 CONTINUE
      NN = NTOK - 1
      IF (NN.GE.MaxNumResoBins) NN = MaxNumResoBins
C
C
      DO 490 ITOK = 2,NN + 1
C
C            *************************************************
        CALL GTPREA(ITOK,ESQ(Jderiv,ITOK-1),NTOK,ITYPE,FVALUE)
C            *************************************************
C
  490 CONTINUE
C
C
C----   If too few terms read pad out esq array..
C
      IF (NN.LT.MaxNumResoBins) THEN
        DO 500 II = NN + 1,MaxNumResoBins
          ESQ(Jderiv,II) = ESQ(Jderiv,NN)
  500   CONTINUE
      END IF
C
C
      GO TO 40
C
C     ANOError
C---- Input Estimated error for Fhp(+) -Fhp(-)
C     ========================================
C
C   ANOERROR  <aerr1> <aerr2> ... <aerr8>
C       Eight numbers giving the estimated anomalous lack of  clo-
C       sure  error  as  a  function  of  resolution.  For initial
C       refinements allow the program to evaluate  these.   For  a
C       final phasing pass, take the values output at the end of a
C       refinement cycle.
C
  510 CONTINUE
      NN = NTOK - 1
      IF (NN.GE.MaxNumResoBins) NN = MaxNumResoBins
C
C
      DO 520 ITOK = 2,NN + 1
C
C            *************************************************
        CALL GTPREA(ITOK,ASQ(Jderiv,ITOK-1),NTOK,ITYPE,FVALUE)
C            *************************************************
C
  520 CONTINUE
C
C----   If too few terms read pad out asq array..
C
      IF (NN.LT.MaxNumResoBins) THEN
        DO 530 II = NN + 1,MaxNumResoBins
          ASQ(Jderiv,II) = ASQ(Jderiv,NN)
  530   CONTINUE
      END IF
      GO TO 40
C
C---- Atom card - contains ID xf yf zf occf anoocc BFAC b(ii) ...
C
C NB If you want to enter B value(s) you MUST give an Anom occupanvcy ,
C       even if it is not used.
C
Cejd - I don't know what to do about the ID ??? CA or Ca (calpha)??
C
C   ATOM <ID> <Xfrac> <Yfrac> <Zfrac>  <occ>  [<aocc>]  BFAC  <b1>
C       [<b2> <b3> <b4> <b5> <b6>]
C       One  for  each site.  (At least one site must be given for
C       each derivative.)
C
C       <ID>   Atom identifier which  must  match  a  form  factor
C              given  in  the  file  assigned  to  ATOMSF (default
C              $CLIBD/atomsf.lib).  The standard form factors  are
C              given  for Cu wavelength, so the values of f'', and
C              f' may not be appropriate for other  wave  lengths.
C              You  will  need  to  interpret  your  "occupancies"
C              intelligently.
C
C       <Xfrac> <Yfrac> <Zfrac>
C              atomic coordinates given as fractions of unit cell.
C
C       <occ>  "atom occupancy". Remember this will probably be on
C              an arbitrary scale. At this stage you are  unlikely
C              to have amplitudes on the absolute scale.
C
C       <aocc> "anomalous occupancy".  Remember this will probably
C              be on an arbitrary scale too.  See NOTES  ON  USAGE
C              for interpretation of sign.
C
C       <b1> [<b2> <b3> <b4> <b5> <b6>]
C              If only <b1> is set, <b1> is the isotropic tempera-
C              ture factor If <b1> <b2> <b3> <b4>  <b5>  <b6>  are
C              set,   they define the anisotropic <b> factor.  The
C              temperature factor is defined as:
C               exp(-(h*h*<b1> + h*k*<b2> + h*l*<b3> + k*k*<b4>  +
C              k*l*<b5> + l*l*<b6>))
C              For  a rough approximation to give an anisotropic B
C              factor take <b1> = <b4> = <b6> = <b>, <b2> = <b3> =
C              <b5> = 0.
C
C       The isotropic B factor is approximated by 1/3(a+d+f).
C
C       Following Willis and Pryor conventions, I think
C                  b1 = k*beta11, b4 = k*beta22, b6=k*beta33
C                  b2 = k*beta12, b3 = k*beta31, b5=k*beta23
C       where their temperature factor is expressed as:
C
C        exp(-0.25(  h**2 * (a*)**2 * beta11 + k**2 * (b*)**2 * beta22
C                  + l**2 * (c*)**2 * beta33  + 2*k*l*(b*)*(c*)*beta23
C                  + 2*l*h*(c*)*(a*) *beta31 + 2*h*k*(a*)*(b*) *beta12))
C       This  means  the  Uij  terms of an anisotropic temperature
C       factor is equal to betai */(8*pi**2).
C
  540 CONTINUE
      NAtomsPerDeriv(Jderiv) = NAtomsPerDeriv(Jderiv) + 1
C
C----ejd What a mess -
C    Phare counts IHATOM through all heavy atom derivatives.
C
      IHATOM = IHATOM + 1
C
C
      IF (IHATOM.GT.MaxNumHeavyAtoms) THEN
        WRITE (6,FMT=6040)IHATOM
 6040   FORMAT (/' More than ',I3,' ATOMS - Change parameter MaxNumHea',
     +         'vyAtoms')
C
C            *****************************
        CALL CCPERR(1,' Execution Halted')
C            *****************************
C
      END IF
C
C
      IAEND = IBEG(2) + 3
      ATNAME(IHATOM) = LINE(IBEG(2) :IAEND)
C
C----  What if ATNAME < 4 characters?
C
      IF (IEND(2).LT.IAEND) THEN
        ICHA = IEND(2) - IBEG(2) + 1
        IAEND = IEND(2)
        ATNAME(IHATOM) (1:ICHA) = LINE(IBEG(2) :IAEND)
        ATNAME(IHATOM) (ICHA+1:4) = '   '
      END IF
C
C----  ATOMIC replaced by SFREAD2
C
C     Atomic form factors are calculated by subroutine atomic
C     REF: J.D. LEE, H.W. PAKES, ACTA CRYST., A25, 712(1969)
C
C     The anomalous form factors are those calculated by
C     D.T. CROMER  ACTA CRYST., 18, 17(1965)
C
C     ATNAME is the chemical symbol for the heavy atom - it must be left
C     justified on the card, i.e., in  columns 1 and 2
C
      NG5 = 5
C
C          **********************************************************
      CALL SFREAD2(ATNAME(IHATOM),NG5,AF,BF,CF,IWT,IELEC,CU,MO,IFAIL)
C          **********************************************************
C  Reset F' F" for different wavelengths
      IF( FPRIME(JDERIV).GT.-99999.0) CU(1) = FPRIME(JDERIV)
      IF( FDOUBLEPRIME(JDERIV).GT.-99999.0) CU(2) = FDOUBLEPRIME(JDERIV)
C
C
C                      *****************************************
      IF (IFAIL.EQ.-1) CALL CCPERR(1,' No match for atom label')
C                      *****************************************
C
      AFM(IHATOM,1) = AF(1)
      AFM(IHATOM,2) = AF(2)
      AFM(IHATOM,3) = AF(3)
      AFM(IHATOM,4) = AF(4)
      BFM(IHATOM,1) = BF(1)
      BFM(IHATOM,2) = BF(2)
      BFM(IHATOM,3) = BF(3)
      BFM(IHATOM,4) = BF(4)
      CFM(IHATOM) = CU(1) + CF
      FPP(IHATOM) = CU(2)
C
C          *****************************************************
      CALL GTPREA(3,X(IHATOM),NTOK,ITYPE,FVALUE)
      CALL GTPREA(4,Y(IHATOM),NTOK,ITYPE,FVALUE)
      CALL GTPREA(5,Z(IHATOM),NTOK,ITYPE,FVALUE)
      CALL GTPREA(6,OCC(IHATOM,NDAT(Jderiv)),NTOK,ITYPE,FVALUE)
C          *****************************************************
C
      AOCC(IHATOM,NDAT(Jderiv)) = 0.0
C
C----  Is there an anomalous occupanvy?
C
      ITOK = 7
      IF (NTOK.GE.ITOK .AND. ITYPE(ITOK).EQ.2) THEN
C
C            *******************************************************
        CALL GTPREA(ITOK,AOCC(IHATOM,NDAT(Jderiv)),NTOK,ITYPE,FVALUE)
C            *******************************************************
C
        ITOK = ITOK + 1
      END IF
C
C----  Check for word BFAC
C
      B1(IHATOM) = 10.0
      BREAD(1) = B1(IHATOM)
      NTROP(IHATOM) = 1
C
C
      IF (NTOK.GT.ITOK .AND. ITYPE(ITOK).NE.2) THEN
        WORD = LINE(IBEG(ITOK) :IEND(ITOK))
C
        CALL CCPUPC(WORD)
C                           ******************************
        IF (WORD(1:4).NE.'BFAC') CALL CCPERR(1,'  No BFAC??? ')
C                           ******************************
C
        NB = NTOK - ITOK + 1
C
C
        IF (NB.GT.0) THEN
          IF (NB.LT.6) NB = 1
          IF (NB.GT.6) NB = 6
          NTROP(IHATOM) = NB
C
C
          DO 550 IB = 1,NB
C
C                *******************************************
            CALL GTPREA(ITOK+IB,BREAD(IB),NTOK,ITYPE,FVALUE)
C                *******************************************
C
  550     CONTINUE
C
C
        END IF
      END IF
C
C
      IF (NTROP(IHATOM).EQ.1) THEN
        B1(IHATOM) = BREAD(1)
      ELSE
C
C----  I think bread(1) = beta11, bread(4) = beta22, bread(6)=beta33
C       bread(2) = 2*beta12, bread(3) = 2*beta31, bread(5)=2*beta23
C
C     where the temperature factor is expressed as:
C
C      exp(-0.25(  h**2 * (a*)**2 * beta11 + k**2 * (b*)**2 * beta22
C                + l**2 * (c*)**2 * beta33  + 2*k*l*(b*)*(c*)*beta23
C                + 2*l*h*(c*)*(a*) *beta31 + 2*h*k*(a*)*(b*) *beta12))
C
C      (This means the Uij terms of an anistropic temperature
C       factor is equal to betaij */(8*pi**2.)
C
C    Temperature factor is actually refined as ;
C    exp( -(h*h*B1 + h*k*B2 + h*l*B3 + k*k*B4 + k*l*B5 + l*l*B6) )
C
C            ******************************************************
        CALL BTOHKL(BREAD(1),BREAD(2),BREAD(3),BREAD(4),BREAD(5),
     +              BREAD(6),AMAT,B1(IHATOM),B2(IHATOM),B3(IHATOM),
     +              B4(IHATOM),B5(IHATOM),B6(IHATOM))
C            ******************************************************
C
      END IF
C
C----   Set all refinement flags to zero
C
C LABIN(1..5,IHATOM,ICurrentCycle) relate to REAL isomorphous differences.
C LABIN(6..10,IHATOM,ICurrentCycle) relate to Anomalous differences.
C
      DO 570 ICurrentCycle = 1,NumRefCycles
        DO 560 MU = 1,10
          LABIN(MU,IHATOM,ICurrentCycle) = 0
  560   CONTINUE
  570 CONTINUE
C
C
      GO TO 40
C
C---- Atom refinement instructions - subsibuary keywords
C     ATREF  X ALL or i j k .. Y..  Z..  OCC..  AOCC..  B......
C     =========================================================
C
C
C    Must follow atom ca
C     iflag(1 - 10) = labin(1,ihatom,ICurrentCycle)
C     iflag(11 - 20) = labin(2,ihatom,ICurrentCycle), etc.
C
C     Anomalous refinement flags
C
C     iflag(1 - 10) = labin(6,ihatom,ICurrentCycle)
C     iflag(11 - 20) = labin(7,ihatom,ICurrentCycle), etc.
C
C   ATREF [OCC [ALL | <i1> <i2>... ]]  [AOCC  [ALL]  |  <j1>  <j2>
C       ...]]  [[X  | AX] [ALL] | <k1> <k2>...] [Y | AY ... Z | AZ
C       ...]
C       The keywords OCC, AOCC,  X or AX,  Y or AY,  Z or  AZ,   B
C       flag which parameter should be refined.  X Y Z mean refine
C       coordinate to fit the isomorphous differences.  AX  AY  AZ
C       mean  refine  coordinate to fit the anomalous differences.
C       ( Only one of X or AX can be used.)  The keyword ALL means
C       refine  parameter  on  all cycles.  Numbers <i1> <i2> etc.
C       mean refine parameters on the numbered cycles only.
C
C       Each DERIVATIVE set finishes with another  DERIV  card  or
C       END.
C
  580 CONTINUE
C
C
      ITOK = 2
  590 CONTINUE
      IF (ITOK.GT.NTOK) GO TO 40
C
C
      IF (ITYPE(ITOK).EQ.2) CALL CCPERR(1,
     + ' Execution Halted - Error - should have word B OCC X Y Z etc ')
C
C----  Next word PHASE or REF or KDerivOverallBfactall
C
      WORD = LINE(IBEG(ITOK) :IEND(ITOK))
      CALL CCPUPC(WORD)
      IF (WORD(1:3).EQ.'OCC') IPARAM = 1
      IF (WORD(1:1).EQ.'B') IPARAM = 2
      IF (WORD(1:1).EQ.'X') IPARAM = 3
      IF (WORD(1:1).EQ.'Y') IPARAM = 4
      IF (WORD(1:1).EQ.'Z') IPARAM = 5
      IF (WORD(1:4).EQ.'AOCC') IPARAM = 6
      IF (WORD(1:2).EQ.'AB') IPARAM = 7
      IF (WORD(1:2).EQ.'AX') IPARAM = 8
      IF (WORD(1:2).EQ.'AY') IPARAM = 9
      IF (WORD(1:2).EQ.'AZ') IPARAM = 10
      IF (ICENFLG.EQ.1 .AND. IPARAM.GT.5) CALL CCPERR(1,
     +    ' Cannot refine anomalous parameters with CENTRIC data!')
      ITOK = ITOK + 1
C
C----  Next word ALL ???
C
      IF (ITYPE(ITOK).NE.2) THEN
        WORD = LINE(IBEG(ITOK) :IEND(ITOK))
        CALL CCPUPC(WORD)
C
C
        IF (WORD(1:3).NE.'ALL') CALL CCPERR(1,
     +   ' Execution Halted - **  Error in KEYWORD ** ')
C
        DO 600 ICurrentCycle = 1,NumRefCycles
          LABIN(IPARAM,IHATOM,ICurrentCycle) = 1
  600   CONTINUE
C
C
        ITOK = ITOK + 1
        IF (ITOK.GT.NTOK) GO TO 40
        GO TO 590
      END IF
C
C----    read cycles to act upon..
C        Otherwise ITYPE(ITOK) .EQ.2)
C
C          **********************************
  610 CALL GTPINT(ITOK,NPH,NTOK,ITYPE,FVALUE)
C          **********************************
C
C
      IF (NPH.GT.NumRefCycles) CALL CCPERR(1,
     +  ' Execution Halted - request number > NumRefCycles')
C
      LABIN(IPARAM,IHATOM,NPH) = 1
      ITOK = ITOK + 1
      IF (ITOK.GT.NTOK) GO TO 40
C
C----  another number.
C
      IF (ITYPE(ITOK).EQ.2) GO TO 610
C
C----  Otherwise another word..
C
      GO TO 590
C
C
  620 IFIN = 1
C
C----   Write out information about last derivative.
C
      GO TO 390
  630 CONTINUE
C
C   Are you trying to do ANYTHING?
      IF (JREF.EQ.0 .AND. OUTFLG.LT.0.1) CALL CCPERR(1,
     +    ' You are neither REFINING nor OUTPUTTING PHASES??? ')
C
C   Set ISTAT = 0 if ONLY_PHASE  and no refinement
      IF(ONLY_PHASE .AND.JREF.EQ.0) ISTAT = 0
C----     square input isomorphous errors
C
      DO 650 Kderiv = 1,NumDerivatives
        DO 640 J = 1,MaxNumResoBins
          ESQ(Kderiv,J) = ESQ(Kderiv,J)**2
          IF (.NOT.LANOM(Kderiv)) GO TO 640
          ASQ(Kderiv,J) = ASQ(Kderiv,J)**2
          IF (IFH(Kderiv).GT.0) IFHA(Kderiv) = IFH(Kderiv) + 2
  640   CONTINUE
  650 CONTINUE
C
C
C    OUTPUT SCRIPT FILE UPTO DERIV CARD
C
      IF (LScript) THEN
        WRITE(ISYSW, FMT=9220)
        ISCRUN=CCPNUN()
        CALL CCPDPN(ISCRUN,'NEWPARM','UNKNOWN','F',0,0)
        CALL UGTENV('HKLIN',INFLE)
        CALL UGTENV('HKLOUT',OUTFLE)
        CALL UGTENV('NEWPARM',PARFLE)
        IF (VAXVMS()) THEN
          SCRLINE(1) = '$MLPHARE'//' HKLIN '//INFLE(1:LENSTR(INFLE))
     .    //' HKLOUT '//OUTFLE(1:LENSTR(OUTFLE))//' NEWPARM '
     .    //PARFLE(1:LENSTR(PARFLE))
        ELSE
C         Who knows what shell we're running...
          WRITE (ISCRUN,'(''#!/bin/sh'')')
C         DL: note that his sort of thing with here documents is
C         subject to lossage unless we know traditional unix (non)-
C         carriagecontrol is in effect.  (Can't have leading space for
C         terminator.)
          SCRLINE(1) = 'mlphare'//' HKLIN '//INFLE(1:LENSTR(INFLE))
     .    //' HKLOUT '//OUTFLE(1:LENSTR(OUTFLE))//' NEWPARM '
     .    //PARFLE(1:LENSTR(PARFLE))//' << eof'
        ENDIF

        DO 660 I=1,NSCRLINE
          KEY = SCRLINE(I)(1:4)
          IF (KEY.NE.'DERI') THEN
            ILEN = LENSTR(SCRLINE(I))
            IF (ILEN.LE.132) THEN
              WRITE (ISCRUN,'(A)') SCRLINE(I)(1:ILEN)
            ELSE
              IF (I.EQ.1 .AND. .NOT.VAXVMS()) THEN
                WRITE(ISCRUN,FMT='(A)') SCRLINE(I)(1:130)//SLASH(1:1)
              ELSE
                WRITE(ISCRUN,FMT='(A)') SCRLINE(I)(1:130)//'-'
              ENDIF
              IF (ILEN.GT.263) THEN
                WRITE(ISCRUN,FMT='(A)')
     +               ' ! Line was too long so it was truncated'
                WRITE(ISCRUN,FMT='(A)') SCRLINE(I)(131:263)
              ELSE
                WRITE(ISCRUN,FMT='(A)') SCRLINE(I)(131:ILEN)
              ENDIF
            ENDIF
          ELSE
            GOTO 670
          ENDIF
  660   CONTINUE
      ENDIF

 9220 FORMAT(/,' A script will be written at the end of refinement',/)
  670 CONTINUE
C   Check that ATREF restrictions are obeyed; monoclinic have at least one Y fixed;
C   polar Z have at least one Z fixed; P1 has one XYZ fixed
C

C  Prepare for harvesting
C  If ProjectName or DataSetName haven't been given as keywords, try
C  to derive from HKLIN datasets.
C  Specifically that assigned to PHASE column. 
      IF (ProjectName.EQ.' ' .AND. NDATASETS.GT.0) THEN
        SETID = CSETOUT(IPHIB)
        DO ISET = 1,NDATASETS
          IF (ISETS(ISET).EQ.SETID) THEN
            ProjectName = PNAME(ISET)
          END IF
        ENDDO      
      ENDIF
      IF (DataSetName.EQ.' ' .AND. NDATASETS.GT.0) THEN
        SETID = CSETOUT(IPHIB)
        DO ISET = 1,NDATASETS
          IF (ISETS(ISET).EQ.SETID) THEN
            DataSetName = DNAME(ISET)
          END IF
        ENDDO      
      ENDIF

C  If NOHARVEST keyword specified, switch off harvesting by setting
C  ProjectName and DataSetName to ' '
      IF (NOHARVEST) THEN
        ProjectName = ' '
        DataSetName = ' '
      ENDIF
C 
C---- Hinitialise
C
C     SoftwareClass  = <string> description of program function
C     Package        = <string> CCP4
C     ProgramName    = <string> mlphare
C     ProgramVersion = <string> 'CCP4_3.1 of 1996/11/01'
C     ProjectName = <string> Name of protein/complex under study
C     DataSetName = <string> Name of key data set for which cell etc apply to
C     useCWD      <logical> if true write to current working directory
C     Private     <logical> if true chmod DepositFiles directory "drwx------"
C     IvalueNotDet <int>    value to which int variables are initialised
C                           and if unchanged no data_item written
C     ValueNotDet  <real>   value to which real variables are initialised
C                           and if unchanged no data_item written
C     NRowLimit   <int>     either 80 or 132 is max width of a row on o/p
C
C  writes
C
C      _entry.id                 ProjectName
C      _entry.data_set_id        DataSetName
C      _audit.creation_DayTime   as fortran fdate string
C      _software.name            ProgramName
C      _software.version         ProgramVersion
C
C    If useCWD false then
C    if directory $HOME/DepositFiles  doesnt exist it will be created
C        with protection drwxr-xr-x 
C     or if Private set  drwx-----
C    if directory $HOME/DepositFiles/ProjectName doesnt exist it will
C        be created
C    harvest file then written to
C     $HOME/DepositFiles/ProjectName/DataSetName.ProgramName
C    overwritting any file that exists with this name
C    else if useCWD true
C    the harvest file written to
C      ./DataSetName.ProgramName
C
C    IvalueNotDet and ValueNotDet used to decide if a data_item
C    is to be written
C
C    Internal check done on if a calculated value is finite
C    if not no data_item written
C
      CALL CCP4_VERSION(Hversion)
      Hversion = 'CCP4_' // Hversion(1:lenstr(Hversion))

      CALL Hinitialise(
     +  'CCP4',
     +   'mlphare',
     +    Hversion,
     +      ProjectName,DataSetName,
     +       useCWD,
     +        Private,
     +         IvalueNotDet,
     +          ValueNotDet,
     +           NRowLimit)
C
C  _software.classification  SoftwareClass
C    _item_enumeration.value      'data collection'
C                                 'data reduction'
C                                 'phasing'
C                                 'model building'
C                                 'refinement' 
C                                 'validation'
C                                 'other'
C  _software.contact_author
C  _software.contact_author_email       
C  _software.description   
C
      CALL Hsoftware('phasing','E.Dodson',
     +   'ccp4@dl.ac.uk, ccp4@ysbl.york.ac.uk',
     +'maximum likelihood heavy atom refinement & phase calculation')
C
C   _cell.length_a
C   _cell.length_b
C   _cell.length_c
C   _cell.angle_alpha
C   _cell.angle_beta
C   _cell.angle_gamma
C
      CALL HCell(cell)
C
C---- if a standard symmetry setting -only need IntTabNum
C     else send SpaceGrpNam, number_equivalent_positions,
C     and symmetry operations, and in this case IntTabNum
C     must be greater than 230
C
C     if non-standard number is given AND it is a known ccp4
C     number then you dont need any more info, current 
C     known non-standard ones are
C          1003, 3004, 1004,
C          2005, 1005, 1018,
C          1020, 1021, 1022,
C          1023, 1059, 1094,
C          1197
C
C     _Symmetry.Int_Tables_number 
C     _Symmetry.space_group_name_H-M 
C
C     loop_
C     _Symmetry_equiv.id
C     _Symmetry_equiv.pos_as_xyz
C
      CALL HSymmetry(NumSpaceGroup,NAMSPG,NumSymmetry,RSYM)
C
C---- sending
C
C        _phasing_MIR_der.id   
C        _phasing_MIR_der.number_of_sites 
C        _phasing_MIR_der.d_res_high  
C        _phasing_MIR_der.d_res_low  
C        _phasing_MIR_der.reflns_criteria 
C
      CALL Hphasing_mir_der_p1(NumDerivatives,
     +                    DerivTitle,
     +                     NAtomsPerDeriv,
     +                      DerivSigmaLimit,
     +                       DerivMinResol,
     +                        DerivMaxResol)
C
      RETURN
  680 WRITE (ISYSW,FMT=6042) MaxSymmetry
 6042 FORMAT (//'  Too many Symmetry cards - only ',I4,' Allowed chang',
     +       'e COMMON/ATSYM_MLP/ Throughout PROGRAM.')
C
C          ******************************
      CALL CCPERR(1,' Execution Halted ')
C          ******************************
C
C
C          ***********************************************
  690 CALL CCPERR(1,' Execution Halted - error in KEYWORD ')
C          ***********************************************
C
      END
C
C
C
C     ===============================================
      SUBROUTINE ANALBS(B1,B2,B3,B4,B5,B6,LAST1,X,Y,Z)
C     ===============================================
C
C
C        implicit none
C
C
C
C
C  I think bread(1) = beta11, bread(4) = beta22, bread(6)=beta33
C       bread(2) = 2*beta12, bread(3) = 2*beta31, bread(5)=2*beta23
C     where the temperature factor is expressed as:
C      exp(-0.25(  h**2 * (a*)**2 * beta11 + k**2 * (b*)**2 * beta22
C                + l**2 * (c*)**2 * beta33  + 2*k*l*(b*)*(c*)*beta23
C                + 2*l*h*(c*)*(a*) *beta31 + 2*h*k*(a*)*(b*) *beta12))
C
C      (This means the Uij terms of an anistropic temperature
C     factor is equal to betaij */(8*pi**2.)
C
C    Temperature factor is actually refined as ;
C    exp( -(h*h*B1 + h*k*B2 + h*l*B3 + k*k*B4 + k*l*B5 + l*l*B6) )
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
C     ..
C     .. Scalar Arguments ..
      REAL B1,B2,B3,B4,B5,B6,X,Y,Z
      LOGICAL LAST1
C     ..
C     .. Scalars in Common ..
      REAL CutOffNatSigma,SCALE,SigmaNatScale,SMAXP,SMINP
      INTEGER NumMatrixElements,NumRefCycles,nskip
C     ..
C     .. Arrays in Common ..
      REAL AMAT,RECSQ,RMAT,TCELL
      INTEGER JPOS
C     ..
C     .. Local Scalars ..
      REAL DISP,XDISPA,XDISPF,YDISPA,YDISPF,ZDISPA,ZDISPF
      INTEGER I,J
C     ..
C     .. Local Arrays ..
      DOUBLE PRECISION A(3,3),EIG(3)
      REAL BB(6)
C     ..
C     .. External Subroutines ..
      EXTERNAL BTOANG,EIGN1M
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS, DBLE, SNGL, SQRT
C     ..
C     .. Common blocks ..
      COMMON /FIRST/
     +    SCALE,SigmaNatScale,CutOffNatSigma,SMAXP,SMINP,
     +     NumMatrixElements,NumRefCycles,Nskip,
     +      JPOS(2*MaxNumDerivatives),
     +       AMAT(3,3),
     +        RMAT(3,3),
     +         RECSQ(6),
     +          TCELL(6)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C          *********************************
      CALL BTOANG(B1,B2,B3,B4,B5,B6,RMAT,BB)
C          *********************************
C
      A(1,1) = DBLE(BB(1))
      A(2,1) = DBLE(BB(2))/2.0D0
      A(1,2) = A(2,1)
      A(3,1) = DBLE(BB(3))/2.0D0
      A(1,3) = A(3,1)
      A(2,2) = DBLE(BB(4))
      A(2,3) = DBLE(BB(5))/2.0D0
      A(3,2) = A(2,3)
      A(3,3) = DBLE(BB(6))
C
C          *****************
      CALL EIGN1M(3,3,A,EIG)
C          *****************
C
      WRITE (6,FMT=6000) EIG
 6000 FORMAT (5X,'Eigen values of Symmetric B Matrix:',11X,3F10.2)
C
C
      IF (LAST1) THEN
        WRITE (6,FMT=6002) ((A(I,J),I=1,3),J=1,3)
 6002   FORMAT (5X,'Eigen vectors of Symmetric B Matrix:',10X,3F10.3,
     +         / (51X,3F10.3))
C
C
        IF (EIG(3).GT.0.00001D0) THEN
          DISP = SNGL(SQRT(ABS(EIG(3)/ (3.141592654D0**2*8.0D0))))
C
C
          IF (DISP.GT.1.0) THEN
            XDISPA = REAL(A(1,3)*DISP)
            YDISPA = REAL(A(2,3)*DISP)
            ZDISPA = REAL(A(3,3)*DISP)
            XDISPF = AMAT(1,1)*XDISPA + 
     +                AMAT(2,1)*YDISPA +
     +                 AMAT(3,1)*ZDISPA
            YDISPF = AMAT(1,2)*XDISPA + 
     +                AMAT(2,2)*YDISPA +
     +                 AMAT(3,2)*ZDISPA
            ZDISPF = AMAT(1,3)*XDISPA + 
     +                AMAT(2,3)*YDISPA +
     +                 AMAT(3,3)*ZDISPA
            WRITE (6,FMT=6004) 
     +          DISP,
     +           X + XDISPF/2.0,
     +            Y + YDISPF/2.0,
     +             Z + ZDISPF/2.0,
     +              X - XDISPF/2.0,
     +               Y - YDISPF/2.0,
     +                Z - ZDISPF/2.0
 6004       FORMAT (
     +5X,'Possible indication for splitting of site',/,
     +5X,'The largest eigenvalue corresponds to separartion of'
     +             ,F8.2,' Angstroms',/,
     +5X,'Coordinates for the two sites:',/,
     +5X,3F10.5,/,
     +5X,3F10.5)
          END IF
        END IF
      END IF
C
C
      RETURN
      END
C
C     =================================================
      SUBROUTINE BTOANG(BA1,BA2,BA3,BA4,BA5,BA6,RMAT,B)
C     =================================================
C
C        implicit none
C
C     .. Scalar Arguments ..
      REAL BA1,BA2,BA3,BA4,BA5,BA6
C     ..
C     .. Array Arguments ..
      REAL RMAT(3,3), B(6)
C     ..
C     .. Local Arrays ..
      REAL BANGST(3,3),BANGST1(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL MATMUL,MATMULTRANS
C     ..
      BANGST(1,1) = BA1
      BANGST(1,2) = BA2/2.0
      BANGST(2,1) = BA2/2.0
      BANGST(1,3) = BA3/2.0
      BANGST(3,1) = BA3/2.0
      BANGST(2,2) = BA4
      BANGST(2,3) = BA5/2.0
      BANGST(3,2) = BA5/2.0
      BANGST(3,3) = BA6
C
C          **************************
      CALL MATMUL(BANGST1,RMAT,BANGST)
      CALL MATMULTRANS(BANGST,BANGST1,RMAT)
C          **************************
C
      B(1) = BANGST(1,1)*4
      B(2) = BANGST(1,2)*8.0
      B(3) = BANGST(1,3)*8.0
      B(4) = BANGST(2,2)*4.0
      B(5) = BANGST(2,3)*8.0
      B(6) = BANGST(3,3)*4.0
      END
C
C
C
C     ================================================================
      SUBROUTINE BTOHKL(BA1,BA2,BA3,BA4,BA5,BA6,AMAT,B1,B2,B3,B4,B5,B6)
C      ================================================================
C        implicit none
C
C
C
C    Temperature factor is actually refined as ;
C    exp( -(h*h*B1 + h*k*B2 + h*l*B3 + k*k*B4 + k*l*B5 + l*l*B6) )
C
C
C
C
C
C
C
C
C     .. Scalar Arguments ..
      REAL B1,B2,B3,B4,B5,B6,BA1,BA2,BA3,BA4,BA5,BA6
C     ..
C     .. Array Arguments ..
      REAL AMAT(3,3)
C     ..
C     .. Local Arrays ..
      REAL BANGST(3,3),BANGST1(3,3)
C     ..
C     .. External Subroutines ..
      EXTERNAL MATMUL,MATMULTRANS
C     ..
C
C
C
      BANGST(1,1) = BA1/4.0
      BANGST(1,2) = BA2/8.0
      BANGST(2,1) = BA2/8.0
      BANGST(1,3) = BA3/8.0
      BANGST(3,1) = BA3/8.0
      BANGST(2,2) = BA4/4.0
      BANGST(2,3) = BA5/8.0
      BANGST(3,2) = BA5/8.0
      BANGST(3,3) = BA6/4.0
C
C----      bangst(1) = [amat]*[bangst(0)]
C          a = b*c
C
C          **************************
      CALL MATMUL(BANGST1,AMAT,BANGST)
C          **************************
C
C----   bangst(2) = [amat]*[bangst(1(TRANSPOSE)]
C                 = [amat]*[bangst(0)(TRANSPOSE)]*[amat(TRANSPOSE)]
C
C   a = b*c(TRANSPOSE)
C
C          ***************************
      CALL MATMULTRANS(BANGST,BANGST1,AMAT)
C          ***************************
C
      B1 = BANGST(1,1)
      B2 = BANGST(1,2)*2.0
      B3 = BANGST(1,3)*2.0
      B4 = BANGST(2,2)
      B5 = BANGST(2,3)*2.0
      B6 = BANGST(3,3)
C
C
      RETURN
      END
C
C
C
C     ====================================
      SUBROUTINE HLCOEFFS(A,B,C,D)
C     ===================================
C
C   calculates A B C D coefficients.
C
C        implicit none
C
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
C     ..
C     .. Scalar Arguments ..
      REAL A,B,C,D
C     ..
C     .. Scalars in Common ..
      REAL ABEST,CBEST,CentricTestFlag,FcalcA,FcalcB,FcalcW,
     +     FNativeScaled,FOM,SBEST,VarNativeSc
      INTEGER IAngleStep,ICurrentCycle,IIN,INC,NumDerivatives,
     +        NumResoBins
      LOGICAL LAST,LAST1,NOPHAS
C     ..
C     .. Arrays in Common ..
      REAL FHAim,ScaledDPH,ScaledFPH,
     +     RmsAnomalError,RmsIsomorphError,
     +     FHArl,DerivAnomLimits,DerivIsoLimit,
     +     DerivMaxResol,DerivMinResol,FHim,
     +     P,PNORM,FHrl,ScaledSigmaDPH,
     +     DerivSigmaLimit,STAB,ScaledVPH
      INTEGER KRefineCycleFlag
      LOGICAL LPhaseFlagPerDerivative
C     ..
C     .. Local Scalars ..
      REAL POINTS,PP
      INTEGER I,II
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MOD,REAL
C     ..
C     .. Common blocks ..
      COMMON /CURVE/P(360),PNORM(360),IIN,INC
      COMMON /FASE/  
     +  RmsIsomorphError(MaxNumDerivatives,MaxNumResoBins),
     +   RmsAnomalError(MaxNumDerivatives,MaxNumResoBins),
     +     DerivSigmaLimit(MaxNumDerivatives),
     +      DerivIsoLimit(MaxNumDerivatives),
     +       DerivAnomLimits(2,MaxNumDerivatives),
     +        DerivMinResol(2,MaxNumDerivatives),
     +         DerivMaxResol(2,MaxNumDerivatives),
     +          KRefineCycleFlag(MaxNumRefCycles),
     +           ScaledFPH(MaxNumDerivatives),
     +            ScaledDPH(MaxNumDerivatives),
     +             ScaledVPH(MaxNumDerivatives),
     +              ScaledSigmaDPH(MaxNumDerivatives),
     +               FHrl(MaxNumDerivatives),
     +                FHim(MaxNumDerivatives),
     +                 FHArl(MaxNumDerivatives),
     +                  FHAim(MaxNumDerivatives),
     +                   LPhaseFlagPerDerivative(MaxNumDerivatives+1),
     +                    CentricTestFlag,FNativeScaled,
     +                     VarNativeSc,NumDerivatives,
     +                      IAngleStep,NumResoBins,ICurrentCycle,
     +                       LAST,LAST1
      COMMON /PHAS/
     +     FOM,ABEST,CBEST,SBEST,
     +      FcalcA,FcalcB,FcalcW,
     +       NOPHAS
      COMMON /TABLES/STAB(451)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C
C
      IF (NOPHAS) THEN
        DO 10 I = IIN,360,INC
          P(I) = 0.0
   10   CONTINUE
      END IF
C
C
      IF (MOD(180,INC).NE.0) THEN
        WRITE (6,FMT=6000) INC
 6000   FORMAT (//10X,'ERROR : IAngleStep  SHOULD  DIVIDE  180    PHAS',
     +         'E INCREMENT = ',I10)
C
C            ****************************
        CALL CCPERR(1,' Execution Halted ')
C            ****************************
C
      END IF
C
C
      POINTS = 360.0/REAL(INC)
      A = 0.0
      B = 0.0
      C = 0.0
      D = 0.0
C
C
      DO 20 I = IIN,360,INC
        PP = P(I)
C
C
        IF (I.LE.180) THEN
          II = 2*I - 1
        ELSE
          II = 2*I - 361
        END IF
C
C
        A = A - STAB(I+90)*PP
        B = B - STAB(I)*PP
        C = C - STAB(II+90)*PP
        D = D - STAB(II)*PP
   20 CONTINUE
C
C
      A = A/POINTS
      B = B/POINTS
C
C---- For centric terms,  A,B must be divided by 2
C
      IF (CentricTestFlag.NE.0.0) THEN
        A = 0.5*A
        B = 0.5*B
      END IF
C
C
      IF (INC.NE.180) THEN
        C = C/POINTS
        D = D/POINTS
      ELSE
        C = 0.0
        D = 0.0
      END IF
C
C
      RETURN
      END
C
C
C
C     ===============================
      SUBROUTINE EIGN1M(N,NDIM,A,EIG)
C     ===============================
C
C
C        implicit none
C
C
C----  This routine is a variant of eign which diagonalizes a matrix
C      within itself.
C
C      The input array, a, is a symmetric array.
C        A is a symmetric n x n matrix
C
C      The array a is totally destroyed
C
C      RHO= upper limit for off-diagonal element
C
C      N    is the size of the matrix
C      EIG = Returned eigenvalues in algebraic ascending order
C            the eigen vectors are returned by columns in a
C
C          Modified from an existing routine of uncertain parentage
C          Modifications made by robert charles ladner, september 1972
C
C          WRITTEN AT C.E.C.A.M./C.I.R.C.E.
C                     BATIMENT 506
C                     91 CAMPUS D'ORSAY
C                     FRANCE
C
C
C
C
C     .. Parameters ..
      INTEGER NUMPAR
      PARAMETER (NUMPAR=3)
C     ..
C     .. Scalar Arguments ..
      INTEGER N,NDIM
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION A(NDIM,N),EIG(N)
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION A2,AKKM,B,C2AKKM,COSA,COSAP,D,DIA,DIF,G,PP,PPBR,
     +                 PPBS,QJ,R1,R12,R2,RHOSQ,S,SGN,SHIFT,SINA,SINA2,
     +                 SQRTS,SUM,TEMP,U,VJTEMP,VTEMP,WJ,WTAW
      INTEGER I,I1,ITEMP,J,K,KM,KP,L,LV,M,N1,N2,NP,NR,NV
C     ..
C     .. Local Arrays ..
      DOUBLE PRECISION BETASQ(NUMPAR),GAMMA(NUMPAR),Q(NUMPAR),W(NUMPAR)
      INTEGER IORD(NUMPAR),IPOSV(NUMPAR),IVPOS(NUMPAR)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,SQRT
C     ..
C     .. Data statements ..
      DATA RHOSQ/1.0D-20/
C     ..
C
C
C
      IF (N.LE.0) RETURN
C
C
      N1 = N - 1
      N2 = N - 2
C
C----  Section unpack
C      if the matrix is a linear triangular matrix it must be unpacked
C
C     A is now unpacked, start diagonalization
C
      GAMMA(1) = A(1,1)
C
C
      IF (N2.GT.0) THEN
C
C
        DO 130 NR = 1,N2
          B = A(NR+1,NR)
          S = 0.0
C
C
          DO 10 I = NR,N2
            S = A(I+2,NR)**2 + S
   10     CONTINUE
C
C----  prepare for possible bypass of transformation
C
          A(NR+1,NR) = 0.0
C
C
          IF (S.GT.0.00001) THEN
            S = B*B + S
            SGN = 1.0
            IF (B.GE.0.0D0) GO TO 30
   20       CONTINUE
            SGN = -1.0
   30       SQRTS = SQRT(S)
            D = SGN/ (SQRTS+SQRTS)
            TEMP = SQRT(B*D+0.5D0)
            W(NR) = TEMP
            A(NR+1,NR) = TEMP
            D = D/TEMP
            B = -SGN*SQRTS
C
C---- D is factor of proportionality. now compute and save w vector.
C     extra singly subscripted w vector used for speed.
C
            DO 40 I = NR,N2
              TEMP = A(I+2,NR)*D
              W(I+1) = TEMP
              A(I+2,NR) = TEMP
   40       CONTINUE
C
C----  premultiply vector w by matrix a to obtain p vector.
C      simultaneously accumulate dot product wp,(the scalar k)
C
            WTAW = 0.0
C
C
            DO 90 I = NR,N1
              SUM = 0.0
C
C
              DO 50 J = NR,I
                SUM = A(I+1,J+1)*W(J) + SUM
   50         CONTINUE
C
C
              I1 = I + 1
              IF ((N1-I1).LT.0.0D0) GO TO 80
   60         CONTINUE
C
C
              DO 70 J = I1,N1
                SUM = A(J+1,I+1)*W(J) + SUM
   70         CONTINUE
C
C
   80         Q(I) = SUM
              WTAW = W(I)*SUM + WTAW
   90       CONTINUE
C
C----  p vector and scalar k  now stored. next compute q vector
C
            DO 100 I = NR,N1
              Q(I) = Q(I) - W(I)*WTAW
  100       CONTINUE
C
C----  now form pap matrix, required part
C
            DO 120 J = NR,N1
              QJ = Q(J)
              WJ = W(J)
C
C
              DO 110 I = J,N1
                A(I+1,J+1) = A(I+1,J+1) - (W(I)*QJ+Q(I)*WJ)*2.0
  110         CONTINUE
  120       CONTINUE
          END IF
C
C
          Q(NR) = B
          BETASQ(NR) = B*B
          GAMMA(NR+1) = A(NR+1,NR+1)
  130   CONTINUE
      END IF
C
C
      IF (N2.GE.0) THEN
        B = A(N,N-1)
        Q(N-1) = B
        BETASQ(N-1) = B*B
        GAMMA(N) = A(N,N)
      END IF
C
C
      BETASQ(N) = 0.0
C
C
      DO 150 I = 1,N
        DO 140 J = I,N
          A(I,J) = 0.0
  140   CONTINUE
        A(I,I) = 1.0
  150 CONTINUE
C
C----   form product p1*p2*...*pn-2
C
      IF (N.GT.2) THEN
        W(N) = A(N,N2)
        K = N
C
C
        DO 210 KP = N,3,-1
          K = KP - 1
          KM = K - 1
          AKKM = A(K,KM)
          C2AKKM = - (AKKM+AKKM)
          W(K) = A(K,KM)
C
C
          DO 180 J = KP,N
            SUM = 0.0
C
C
            DO 160 L = K,N
              SUM = W(L)*A(L,J) + SUM
  160       CONTINUE
C
C
            SUM = SUM + SUM
C
C
            DO 170 I = K,N
              A(I,J) = A(I,J) - W(I)*SUM
  170       CONTINUE
C
C
  180     CONTINUE
C
C
          DO 190 I = K,N
            A(I,K) = W(I)*C2AKKM
C
C----  load w for the next loop, (there is 1. extra element  needed)
C
  190     CONTINUE
C
C
          IF (KP.GT.3) THEN
            DO 200 I = K,N
              W(I) = A(I,KM-1)
  200       CONTINUE
          END IF
C
C
          A(K,K) = A(K,K) + 1.0
  210   CONTINUE
C
C
      END IF
C
C
      DO 220 I = 2,N
        A(I,1) = 0.0
  220 CONTINUE
C
C
      SUM = 0.0
      Q(N) = 0.0
      BETASQ(N) = 0.0
C
C
      DO 260 M = N1,1,-1
  230   CONTINUE
        A2 = GAMMA(M+1)
        R2 = 0.5D0*A2
        R1 = GAMMA(M)*0.5D0
        R12 = R1 + R2
        DIF = R1 - R2
        TEMP = SQRT(ABS(DIF*DIF+BETASQ(M)))
        R1 = R12 + TEMP
        R2 = R12 - TEMP
C
C
        IF (ABS(A2-R1).GE.ABS(A2-R2)) THEN
          SHIFT = R2
        ELSE
          SHIFT = R1
        END IF
C
C
        SUM = SUM + SHIFT
        COSA = 1.0
        G = GAMMA(1) - SHIFT
        PP = G
        PPBS = PP*PP + BETASQ(1)
        PPBR = SQRT(ABS(PPBS))
C
C
        DO 250 J = 1,M
          COSAP = COSA
C
C
          IF (PPBS.EQ.0.0) THEN
            SINA = 0.0
            SINA2 = 0.0
            COSA = 1.0
          ELSE
            SINA = Q(J)/PPBR
            SINA2 = BETASQ(J)/PPBS
            COSA = PP/PPBR
C
C----  postmultiply p1*...*pn-2 by rotation matrix   (p-transpose)
C
            DO 240 I = 1,N
              VTEMP = A(I,J)
              VJTEMP = A(I,J+1)
              A(I,J) = COSA*VTEMP + SINA*VJTEMP
              A(I,J+1) = -SINA*VTEMP + COSA*VJTEMP
  240       CONTINUE
          END IF
C
C
          DIA = GAMMA(J+1) - SHIFT
          U = (G+DIA)*SINA2
          GAMMA(J) = G + U
          G = DIA - U
          PP = DIA*COSA - SINA*COSAP*Q(J)
C
C
          IF (J.EQ.M) THEN
            Q(J) = SINA*PP
            BETASQ(J) = SINA2*PP*PP
          ELSE
            PPBS = BETASQ(J+1) + PP*PP
            PPBR = SQRT(ABS(PPBS))
            Q(J) = SINA*PPBR
            BETASQ(J) = SINA2*PPBS
          END IF
  250   CONTINUE
C
C
        GAMMA(M+1) = G
C
C----  test for convergence of last diagonal element
C
        IF (BETASQ(M).GT.RHOSQ) GO TO 230
        EIG(M+1) = GAMMA(M+1) + SUM
  260 CONTINUE
C
C---- take root of corner 2 by 2 nearest to lower diagonal in value
C     as estimate of eigenvalue to use for shift
C
      EIG(1) = GAMMA(1) + SUM
C
C---- initialize auxiliary tables required for rearranging the vectors
C
      DO 270 J = 1,N
        IPOSV(J) = J
        IVPOS(J) = J
        IORD(J) = J
  270 CONTINUE
C
C----  use a transposition sort to order the eigenvalues
C
      DO 290 M = N1,1,-1
        DO 280 J = 1,M
          IF (EIG(J).GT.EIG(J+1)) THEN
            TEMP = EIG(J)
            EIG(J) = EIG(J+1)
            EIG(J+1) = TEMP
            ITEMP = IORD(J)
            IORD(J) = IORD(J+1)
            IORD(J+1) = ITEMP
          END IF
  280   CONTINUE
  290 CONTINUE
C
C
      IF (N1.NE.0) THEN
        DO 310 L = 1,N1
          NV = IORD(L)
          NP = IPOSV(NV)
          IF (NP.NE.L) THEN
            LV = IVPOS(L)
            IVPOS(NP) = LV
            IPOSV(LV) = NP
C
C
            DO 300 I = 1,N
              TEMP = A(I,L)
              A(I,L) = A(I,NP)
              A(I,NP) = TEMP
  300       CONTINUE
          END IF
  310   CONTINUE
      END IF
      RETURN
      END
C
C
C
C     ==============================================================
      SUBROUTINE FLAGS_MLP(JNDEX,JPOS,NumMatrixElements,NumRefVariables)
C     =============================================================
C
C        implicit none
C
C----  This subroutine sets the refinement and
C      phasing flags for each cycle
C
C
C
C
C
C
C
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
C     ..
C     .. Scalar Arguments ..
      INTEGER NumMatrixElements,NumRefVariables
C     ..
C     .. Array Arguments ..
      INTEGER JNDEX(*),JPOS(*)
C     ..
C     .. Scalars in Common ..
      REAL ABEST,ACL,CBEST,CentricTestFlag,DT11,DT12,DT21,
     +     DT22,DT31,DT32,DT41,DT42,DT51,DT52,DT61,DT62,DX1,DX2,DY1,DY2,
     +     DZ1,DZ2,FcalcA,FcalcB,FcalcW,FNativeScaled,FOM,SBEST,
     +     VarNativeSc,STMAX,STMIN,THR
      INTEGER IAngleStep,ICENFLG,ICurrentCycle,IIN,INC,NumDerivatives,
     +        NumPrimSymmetry,NumResoBins,NumSpaceGroup,NumSymmetry
      LOGICAL LAST,LAST1,LCOR,LELEC,LAPPLY,LSTAT,NOPHAS
C     ..
C     .. Arrays in Common ..
      REAL FHAim,AFM,AOCC,ScaledDPH,
     +     RmsAnomalError,RmsIsomorphError,
     +     FHArl,ASQ,B1,B2,B3,B4,B5,B6,BFM,DerivOverallBfact,
     +     CFM,DerivAnomLimits,DerivIsoLimit,
     +     DerivMaxResol,DerivMinResol,FHim,
     +     ESQ,ScaledFPH,FPP,OCC,
     +     P,PERM,PNORM,DerivScaleToNative,DerivativeNativeScale,
     +     FHrl,RSYM,RSYMT,SAADC,SAADO,SADCSQ,
     +     SumAbsFPHobsFnat,SADOSQ,SumPrFPHobsFPHcalc,
     +     SASQ,DerivSigmaScale,ScaledSigmaDPH,
     +     SumSqrdFPHobsFnat,SESQ,SumFHcalc,SumFHA,
     +     SumFigMerit,SumFNativeScaled,SumFPHobs,
     +     DerivSigmaLimit,SLCA,SLCAQ,SumSqrdPrFPHobsFPHcalc,
     +     SumDeltaPhi,SumSqrdDeltaPhi,SumWsig,SumWsigA,
     +     SumWsigAADO,SumWsigADOS,SumWsigFPHobsFnat,
     +     SumSqrdWsigFPHobsFnat,SumWsigLCA,
     +     SumWsigLCAQ,SumWsigLackClosure,
     +     SumLackClosureWgtSqrd,SW,SumAnomWgtModPrPhase,
     +     SumAnomWgtModPrPhaseADO,SumAnomWgtModPrPhaseDOS,
     +     SumW1FPHobsFnat,SumW1FPHobsFnatSqrd,SWLCA,SWLCAQ,
     +     SumWghtFPHobsFPHcalc,SumW1SqrdLackClosure,ScaledVPH,X,
     +     Y,Z
      INTEGER IFBOV,IndexRefFlags,KRefineCycleFlag,LABIN,Mcount,
     +        NumPhasedperDeriv,NumAnomPhasesPerDeriv,
     +        NDAT,NPHASE,NREFIN,NSMFLG,NTROP,NAtomsPerDeriv
      LOGICAL CALAFF,LANOM,LBOV,LEAVE,
     +        LPhaseFlagPerDerivative,LRefineFlagPerDerivative
      CHARACTER ATNAME*4,DerivTitle*80
C     ..
C     .. Local Scalars ..
      INTEGER K,L,LHIGH,LOW,M,MU,N,NT,NV
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR
C     ..
C     .. Common blocks ..
      COMMON /ATSYM_MLP/RSYM(4,4,MaxSymmetry),RSYMT(4,4,MaxSymmetry),
     +       NumSymmetry,PERM(4,4),NumSpaceGroup,NSMFLG(MaxSymmetry),
     +       NumPrimSymmetry
      COMMON /CENZON/ICENFLG
      COMMON /CURVE/P(360),PNORM(360),IIN,INC
      COMMON /FASE/  
     +  RmsIsomorphError(MaxNumDerivatives,MaxNumResoBins),
     +   RmsAnomalError(MaxNumDerivatives,MaxNumResoBins),
     +     DerivSigmaLimit(MaxNumDerivatives),
     +      DerivIsoLimit(MaxNumDerivatives),
     +       DerivAnomLimits(2,MaxNumDerivatives),
     +        DerivMinResol(2,MaxNumDerivatives),
     +         DerivMaxResol(2,MaxNumDerivatives),
     +          KRefineCycleFlag(MaxNumRefCycles),
     +           ScaledFPH(MaxNumDerivatives),
     +            ScaledDPH(MaxNumDerivatives),
     +             ScaledVPH(MaxNumDerivatives),
     +              ScaledSigmaDPH(MaxNumDerivatives),
     +               FHrl(MaxNumDerivatives),
     +                FHim(MaxNumDerivatives),
     +                 FHArl(MaxNumDerivatives),
     +                  FHAim(MaxNumDerivatives),
     +                   LPhaseFlagPerDerivative(MaxNumDerivatives+1),
     +                    CentricTestFlag,FNativeScaled,
     +                     VarNativeSc,NumDerivatives,
     +                      IAngleStep,NumResoBins,ICurrentCycle,
     +                       LAST,LAST1
      COMMON /FLAG/LABIN(MaxRefineFlags,MaxNumHeavyAtoms,
     +       MaxNumRefCycles),IFBOV(MaxNumDerivatives,MaxNumRefCycles),
     +       NREFIN(MaxNumDerivatives,MaxNumRefCycles),
     +       NPHASE(MaxNumDerivatives,MaxNumRefCycles)
      COMMON /HEAVY/
     +  DerivSigmaScale(MaxNumDerivatives),    
     +   DerivScaleToNative(MaxNumDerivatives),
     +   DerivativeNativeScale(MaxNumDerivatives),   
     +    DerivOverallBfact(MaxNumDerivatives),
     +    IndexRefFlags(MaxNumDerivatives+1),  
     +    NAtomsPerDeriv(MaxNumDerivatives),
     +     OCC(MaxNumHeavyAtoms,MaxDataBatches),
     +      AOCC(MaxNumHeavyAtoms,MaxDataBatches),
     +       AFM(MaxNumHeavyAtoms,4),   BFM(MaxNumHeavyAtoms,4),
     +        CFM(MaxNumHeavyAtoms),     FPP(MaxNumHeavyAtoms),
     +         NTROP(MaxNumHeavyAtoms),   B1(MaxNumHeavyAtoms),
     +          B2(MaxNumHeavyAtoms),      B3(MaxNumHeavyAtoms),
     +           B4(MaxNumHeavyAtoms),      B5(MaxNumHeavyAtoms),
     +            B6(MaxNumHeavyAtoms),      X(MaxNumHeavyAtoms),
     +             Y(MaxNumHeavyAtoms),       Z(MaxNumHeavyAtoms),
     +              NDAT(MaxNumDerivatives),   
     +               CALAFF(MaxNumHeavyAtoms),
     +                LRefineFlagPerDerivative(MaxNumDerivatives),
     +                 LANOM(MaxNumDerivatives),
     +                  LBOV(MaxNumDerivatives),
     +                   LEAVE(MaxRefineFlags,MaxNumHeavyAtoms),
     +                    LELEC,LAPPLY
      COMMON /HEAVYC/ATNAME(MaxNumHeavyAtoms)
      COMMON /PHAS/
     +     FOM,ABEST,CBEST,SBEST,
     +      FcalcA,FcalcB,FcalcW,
     +       NOPHAS
      COMMON /STATA1/
     + Mcount(MaxNumResoBins,2),
     + SumFigMerit(MaxNumResoBins,2),
     + NumPhasedperDeriv(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumDeltaPhi(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumSqrdDeltaPhi(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumFNativeScaled(MaxNumDerivatives,MaxNumResoBins,
     +                  MaxNumFigMeritBins,2),
     + SumFPHobs(MaxNumDerivatives,MaxNumResoBins,
     +           MaxNumFigMeritBins,2),
     + SumFHcalc(MaxNumDerivatives,MaxNumResoBins,
     +           MaxNumFigMeritBins,2),
     + SumFHA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAbsFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                  MaxNumFigMeritBins,2),
     + SumPrFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumWsigFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2)
      COMMON /STATA3/
     + SumWsigLackClosure(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumW1FPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                 MaxNumFigMeritBins,2),
     + SumWghtFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins,2),
     + SumSqrdFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumSqrdPrFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                        MaxNumFigMeritBins,2),
     + SumSqrdWsigFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins,2),
     + SumLackClosureWgtSqrd(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins,2),
     + SumW1FPHobsFnatSqrd(MaxNumDerivatives,MaxNumResoBins,
     +                     MaxNumFigMeritBins,2),
     + SumW1SqrdLackClosure(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins,2),
     + SW(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SumWsig(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + NumAnomPhasesPerDeriv(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins),
     + SAADC(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins)
      COMMON /STATB2/
     + SADCSQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SAADO(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SLCA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SADOSQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SLCAQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumWsigAADO(MaxNumDerivatives,MaxNumResoBins,
     +             MaxNumFigMeritBins),
     + SumWsigLCA(MaxNumDerivatives,MaxNumResoBins,
     +            MaxNumFigMeritBins),
     + SumWsigADOS(MaxNumDerivatives,MaxNumResoBins,
     +             MaxNumFigMeritBins),
     + SumWsigLCAQ(MaxNumDerivatives,MaxNumResoBins,
     +             MaxNumFigMeritBins),
     + SumAnomWgtModPrPhaseADO(MaxNumDerivatives,MaxNumResoBins,
     +                         MaxNumFigMeritBins)
      COMMON /STATB4/
     + SWLCA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhaseDOS(MaxNumDerivatives,MaxNumResoBins,
     +                         MaxNumFigMeritBins),
     + SWLCAQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhase(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins),
     + SumWsigA(MaxNumDerivatives,MaxNumResoBins,
     +          MaxNumFigMeritBins),
     + SESQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SASQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + ESQ(MaxNumDerivatives,MaxNumResoBins),
     + ASQ(MaxNumDerivatives,MaxNumResoBins),
     + STMIN,STMAX,THR,ACL,LCOR,LSTAT
      COMMON /STATC/DerivTitle(MaxNumDerivatives+1)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C
C
      NT = 1
      NV = 1
C
C
      DO 40 K = 1,NumDerivatives
        M = 0
        N = 0
C
C---- set phase flag for each derivative
C
        LPhaseFlagPerDerivative(K) = NPHASE(K,ICurrentCycle) .NE. 0
C
C---- set refine flag for each derivative
C
        LRefineFlagPerDerivative(K) = NREFIN(K,ICurrentCycle) .NE. 0
C
C
        IF (LRefineFlagPerDerivative(K)) THEN
          N = 1
C
C----  set b overall refine flag for each derivative
C
          LBOV(K) = IFBOV(K,ICurrentCycle) .NE. 0
          IF (LBOV(K)) N = 2
          LOW = IndexRefFlags(K)
          LHIGH = IndexRefFlags(K+1) - 1
C
C
          DO 30 L = LOW,LHIGH
C
C----  set flags for refinement of heavy atom parameters
C
            DO 10 MU = 1,10
              LEAVE(MU,L) = LABIN(MU,L,ICurrentCycle) .EQ. 0
   10       CONTINUE
C
C----  eliminate possible requests for refinement of b or position with
C      both real and anomalous
C
            DO 20 MU = 2,5
              IF (.NOT.LEAVE(MU,L)) LEAVE(MU+5,L) = .TRUE.
   20       CONTINUE
C
C
            IF (LANOM(K)) THEN
              IF (.NOT.LEAVE(6,L)) M = M + NDAT(K)
              IF (.NOT.LEAVE(7,L)) M = M + NTROP(L)
              IF (.NOT.LEAVE(8,L)) M = M + 1
              IF (.NOT.LEAVE(9,L)) M = M + 1
              IF (.NOT.LEAVE(10,L)) M = M + 1
            END IF
C
C
            IF (.NOT.LEAVE(1,L)) N = N + NDAT(K)
            IF (.NOT.LEAVE(2,L)) N = N + NTROP(L)
            IF (.NOT.LEAVE(3,L)) N = N + 1
            IF (.NOT.LEAVE(4,L)) N = N + 1
            IF (.NOT.LEAVE(5,L)) N = N + 1
   30     CONTINUE
        END IF
C
C
        JNDEX(2*K-1) = NV
        NV = NV + M
        JNDEX(2*K) = NV
        JPOS(2*K-1) = NT
        NT = ((M+1)*M)/2 + NT
        JPOS(2*K) = NT
        NV = NV + N
        NT = ((N+1)*N)/2 + NT
   40 CONTINUE
C
C
      LPhaseFlagPerDerivative(MaxNumDerivatives+1) = 
     +         KRefineCycleFlag(ICurrentCycle) .NE. 0
      JNDEX(2*NumDerivatives+1) = NV
      NumRefVariables = NV - 1
      NumMatrixElements = NT - 1
      IF (NumRefVariables.EQ.0) NumRefVariables = 1
      IF (NumMatrixElements.EQ.0) NumMatrixElements = 1
C
C
      IF (NumRefVariables.GT.MaxNumRefVariables .OR.
     +    NumMatrixElements.GT.MaxSizeMatrix) THEN
        WRITE (6,FMT=6000) NumRefVariables,MaxNumRefVariables,
     +                     NumMatrixElements,MaxSizeMatrix
C
C            ****************************
        CALL CCPERR(1,' Execution Halted 35')
C            ****************************
C
      END IF
      RETURN
C
 6000 FORMAT (' ',I10,' Variables, Limit is MaxNumRefVariables',I10,/,
     +       I11,
     + ' Locations required for Matrices, Limit is MaxSizeMatrix',I11)
      END
C
C
C
C     ========================================================
      SUBROUTINE OUTHKL(MTZIN,MTZOUT,ADATA,LOGMSS,SSQOL4,ICHK)
C     ========================================================
        implicit none
C
C     Subroutine forms the requested fourier coefficients and writes
C     them in the form suitable for fft
C
C     The f part of the fourier coefficients is kept positive
C     phase information
C
C
C
C
C
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
C     ..
C     .. Scalar Arguments ..
      INTEGER ICHK,MTZIN,MTZOUT
C     ..
C     .. Array Arguments ..
      REAL ADATA(*),SSQOL4
      LOGICAL LOGMSS(*)
C     ..
C     .. Scalars in Common ..
      REAL ABEST,CBEST,CentricTestFlag,FcalcA,FcalcB,FcalcW,
     +     FNativeScaled,FOM,SBEST,VarNativeSc,
     +     SCALE,SigmaNatScale,CutOffNatSigma,SMAXP,SMINP
      INTEGER IAngleStep,ICurrentCycle,IDFP,IFC,IHLA,IOUT,IPC,IPHIB,IWC,
     +        ISCRUN,
     +        NumDerivatives,NumResoBins,NumMatrixElements,NumRefCycles
      LOGICAL LAST,LAST1,NOPHAS,LELEC,LAPPLY,Lscript,LCoord
C     ..
C     .. Arrays in Common ..
      REAL FHAim,ScaledDPH,ScaledFPH,
     +     FHArl,DerivAnomLimits,DerivIsoLimit,
     +     DerivMaxResol,DerivMinResol,
     +     RmsAnomalError,RmsIsomorphError,FHim,
     +     FHrl,ScaledSigmaDPH,DerivSigmaLimit,ScaledVPH
      REAL Amat,Rmat,RECSQ,TCELL,DerivSigmaScale,DerivScaleToNative,
     +     DerivativeNativeScale,DerivOverallBfact,Occ,Aocc,Afm,Bfm,Cfm,
     +     FPP,B1,B2,B3,B4,B5,B6,X,Y,Z
      INTEGER IDPH,IFADD,IFH,IFHA,IFPH,KRefineCycleFlag,
     +     JPOS,IndexRefFlags,NAtomsPerDeriv,NTROP,NDAT
      LOGICAL LPhaseFlagPerDerivative,
     +     CALAFF,LRefineFlagPerDerivative,LANOM,LBOV,LEAVE
C     ..
C     .. Local Scalars ..
      REAL AHL,ANGLE,BHL,CHL,DHL,FH,FHA,HH,HK,HL,OUTPUTSCALE
      INTEGER Kderiv,IEXTRA,IFAD,JDPH,JFH,JFHA,JFPH,JJ,nskip
C     ..
C     .. Local Arrays ..
      REAL BDATA(MaxMtzCols)
C     ..
C     .. External Subroutines ..
      EXTERNAL HLCOEFFS,LWREFL
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ATAN2,EXP,SQRT
C     ..
C     .. Common blocks ..
      COMMON /FIRST/
     +    SCALE,SigmaNatScale,CutOffNatSigma,SMAXP,SMINP,
     +     NumMatrixElements,NumRefCycles,Nskip,
     +      JPOS(2*MaxNumDerivatives),
     +       AMAT(3,3),
     +        RMAT(3,3),
     +         RECSQ(6),
     +          TCELL(6)
      COMMON /HEAVY/
     +  DerivSigmaScale(MaxNumDerivatives),
     +  DerivScaleToNative(MaxNumDerivatives),
     +   DerivativeNativeScale(MaxNumDerivatives),
     +    DerivOverallBfact(MaxNumDerivatives),
     +    IndexRefFlags(MaxNumDerivatives+1),
     +     NAtomsPerDeriv(MaxNumDerivatives),
     +     OCC(MaxNumHeavyAtoms,MaxDataBatches),
     +      AOCC(MaxNumHeavyAtoms,MaxDataBatches),
     +       AFM(MaxNumHeavyAtoms,4),   BFM(MaxNumHeavyAtoms,4),
     +        CFM(MaxNumHeavyAtoms),     FPP(MaxNumHeavyAtoms),
     +         NTROP(MaxNumHeavyAtoms),   B1(MaxNumHeavyAtoms),
     +          B2(MaxNumHeavyAtoms),      B3(MaxNumHeavyAtoms),
     +           B4(MaxNumHeavyAtoms),      B5(MaxNumHeavyAtoms),
     +            B6(MaxNumHeavyAtoms),      X(MaxNumHeavyAtoms),
     +             Y(MaxNumHeavyAtoms),       Z(MaxNumHeavyAtoms),
     +              NDAT(MaxNumDerivatives),
     +               CALAFF(MaxNumHeavyAtoms),
     +                LRefineFlagPerDerivative(MaxNumDerivatives),
     +                 LANOM(MaxNumDerivatives),
     +                  LBOV(MaxNumDerivatives),
     +                   LEAVE(MaxRefineFlags,MaxNumHeavyAtoms),
     +                    LELEC,LAPPLY
      COMMON /FASE/  
     +  RmsIsomorphError(MaxNumDerivatives,MaxNumResoBins),
     +   RmsAnomalError(MaxNumDerivatives,MaxNumResoBins),
     +     DerivSigmaLimit(MaxNumDerivatives),
     +      DerivIsoLimit(MaxNumDerivatives),
     +       DerivAnomLimits(2,MaxNumDerivatives),
     +        DerivMinResol(2,MaxNumDerivatives),
     +         DerivMaxResol(2,MaxNumDerivatives),
     +          KRefineCycleFlag(MaxNumRefCycles),
     +           ScaledFPH(MaxNumDerivatives),
     +            ScaledDPH(MaxNumDerivatives),
     +             ScaledVPH(MaxNumDerivatives),
     +              ScaledSigmaDPH(MaxNumDerivatives),
     +               FHrl(MaxNumDerivatives),
     +                FHim(MaxNumDerivatives),
     +                 FHArl(MaxNumDerivatives),
     +                  FHAim(MaxNumDerivatives),
     +                   LPhaseFlagPerDerivative(MaxNumDerivatives+1),
     +                    CentricTestFlag,FNativeScaled,
     +                     VarNativeSc,NumDerivatives,
     +                      IAngleStep,NumResoBins,ICurrentCycle,
     +                       LAST,LAST1
      COMMON /OUTPT/
     +   IDFP,IFC,IPC,IWC,IPHIB,IHLA,IOUT,ISCRUN,
     +    IFPH(MaxNumDerivatives),
     +     IDPH(MaxNumDerivatives),
     +      IFH(MaxNumDerivatives),
     +       IFHA(MaxNumDerivatives),
     +        IFADD(MaxMtzCols),
     +         Lscript,LCoord
      COMMON /PHAS/
     +     FOM,ABEST,CBEST,SBEST,
     +      FcalcA,FcalcB,FcalcW,
     +       NOPHAS
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C
C
C
      HH = ADATA(1)
      HK = ADATA(2)
      HL = ADATA(3)
C
C
      IF (ICHK.EQ.1) THEN
        IF (.NOT.(LOGMSS(4) .OR. LOGMSS(5))) 
     +    WRITE (6,FMT='(a,/,3F4.0,2F7.1,/,a,2F10.4)')
     +    ' OUTHKL ', (ADATA(JJ),JJ=1,5),' abest fom ',ABEST,FOM
      ENDIF
C
C
C            ***********************************
        CALL EQUAL_MAGIC(MTZIN,BDATA,MaxMtzCols)
C            ***********************************
C
C
      BDATA(1) = ADATA(1)
      BDATA(2) = ADATA(2)
      BDATA(3) = ADATA(3)
      IF(.NOT. LOGMSS(4)) BDATA(4) = ADATA(4)
      IF(.NOT. LOGMSS(5)) BDATA(5) = ADATA(5)
C
C----   DP etc??
C
      IF (IDFP.GT.0) THEN
        IF(.NOT. LOGMSS(6)) BDATA(IDFP) = ADATA(6)
        IF(.NOT. LOGMSS(7)) BDATA(IDFP+1) = ADATA(7)
      END IF
C
C----   FC PHIC etc??
C
      IF (.NOT. LOGMSS(48)) THEN
        IF (IFC.GT.0) BDATA(IFC) = ADATA(88)
      END IF
      IF (.NOT. LOGMSS(49)) THEN
        IF (IPC.GT.0) BDATA(IPC) = ADATA(89)
      END IF
      IF (.NOT. LOGMSS(50)) THEN
        IF (IWC.GT.0) BDATA(IWC) = ADATA(90)
      END IF
C
C----   F0 etc??
C
      DO 20 IEXTRA = 1,MaxMtzCols
        IF (IFADD(IEXTRA).GT.0) THEN
          IFAD = IFADD(IEXTRA)
          IF(.NOT. LOGMSS(90+IEXTRA)) BDATA(IFAD) = ADATA(90+IEXTRA)
        END IF
   20 CONTINUE
C
C---- phib fom, HLA, HLB HLC HLD and FJH info only to be output if there is an FP
C
      IF(ABS(ABEST +99999.0) .GT.0.0001 .AND. (.NOT. LOGMSS(4)) ) THEN
C      IF(ABEST.NE.-99999.0) THEN
       BDATA(IPHIB) = MOD(RADDEG*ABEST,360.0)
       BDATA(IPHIB+1) = MIN(FOM,1.0)
       IF (FOM .LT. 0.0) BDATA(IPHIB+1) = 0.0
C
C----   IHLA etc??
C
        IF (IHLA.GT.0) THEN
C
C            *************************
          CALL HLCOEFFS(AHL,BHL,CHL,DHL)
C            *************************
C
C        IF(ABEST.GT.-99999.0) THEN
            BDATA(IHLA) = AHL
            BDATA(IHLA+1) = BHL
            BDATA(IHLA+2) = CHL
            BDATA(IHLA+3) = DHL
            AHL = 0.00
            BHL = 0.00
            CHL = 0.00
            DHL = 0.00
        END IF
C
          FOM = 0.00
          ABEST = -99999.0
          OUTPUTSCALE = 1.0
          FH = 0.00
          FHA = 0.00
          ANGLE = 0.00
      ENDIF
C
      DO 30 Kderiv = 1,NumDerivatives

        IF (LAPPLY) THEN
          DerivativeNativeScale(Kderiv) = 
     +       EXP(-DerivOverallBfact(Kderiv)*SSQOL4/4.0)/
     +            DerivScaleToNative(Kderiv)
          OUTPUTSCALE = DerivativeNativeScale(Kderiv)*SCALE
        ENDIF
C
C----   if ifph(Kderiv) ne 0 Output fph(Kderiv) sigfph(Kderiv)
C
        IF (IFPH(Kderiv).GT.0) THEN
          JFPH = IFPH(Kderiv)
          IF(.NOT. LOGMSS(4*Kderiv+4)) 
     +        BDATA(JFPH) = OUTPUTSCALE*ADATA(4*Kderiv+4)
          IF(.NOT. LOGMSS(4*Kderiv+5)) 
     +        BDATA(JFPH+1) = OUTPUTSCALE*ADATA(4*Kderiv+5)
        END IF
C
C----   if idph(Kderiv) ne 0 Output dph(Kderiv) sigdph(Kderiv)
C
        IF (IDPH(Kderiv).GT.0) THEN
          JDPH = IDPH(Kderiv)
          IF(.NOT. LOGMSS(4*Kderiv+6)) 
     +        BDATA(JDPH) = OUTPUTSCALE*ADATA(4*Kderiv+6)
          IF(.NOT. LOGMSS(4*Kderiv+7)) 
     +        BDATA(JDPH+1) = OUTPUTSCALE*ADATA(4*Kderiv+7)
        END IF
C
C----   if ifh(Kderiv) ne 0 Output fh(Kderiv) phih(Kderiv)
C
        IF (IFH(Kderiv).GT.0) THEN
          JFH = IFH(Kderiv)
          ANGLE = 0.0
          FH = SQRT(ABS(FHim(Kderiv)**2+FHrl(Kderiv)**2))
          IF (FH.GE.0.00001) ANGLE = ATAN2(FHim(Kderiv),FHrl(Kderiv))
          BDATA(JFH) = FH
          BDATA(JFH+1) = RADDEG*ANGLE
          FH = 0.00
          ANGLE = 0.00
        END IF
C
C----   if ifha(Kderiv) ne 0 Output fh"(Kderiv) phih"(Kderiv)
C
        IF (IFHA(Kderiv).GT.0) THEN
          JFHA = IFHA(Kderiv)
          ANGLE = 0.0
          FHA = SQRT(ABS(FHAim(Kderiv)**2+FHArl(Kderiv)**2))
          IF (FHA.GE.0.00001) ANGLE = ATAN2(FHAim(Kderiv),FHArl(Kderiv))
          BDATA(JFHA) = FHA
          BDATA(JFHA+1) = RADDEG*ANGLE
          FHA = 0.00
          ANGLE = 0.00
        END IF
   30 CONTINUE
          AHL = 0.00
          BHL = 0.00
          CHL = 0.00
          DHL = 0.00
          FOM = 0.00
          ABEST = -99999.0
          OUTPUTSCALE = 1.0
          FH = 0.00
          FHA = 0.00
          ANGLE = 0.00
C
C          *******************
      CALL LWREFL(MTZOUT,BDATA)
C          *******************
C
      RETURN
      END
C
C
C
C
C     ================================================
      SUBROUTINE FSTATS(power,Rcullis,Kreflns)
C     ================================================
C
C
C        implicit none
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
C
      REAL power(2,*),Rcullis(3,*)
      INTEGER Kreflns(3,*)
C     ..
C     .. Scalar Arguments ..
C      DOUBLE PRECISION DA,DB
C      INTEGER IDA,IDB,NA,NB
C     ..
C     .. Array Arguments ..
C      DOUBLE PRECISION A(*),B(*),RA(*),RB(*)
C     ..
C     .. Scalars in Common ..
      REAL ACL,CentricTestFlag,FNativeScaled,VarNativeSc,STMAX,
     +     STMIN,THR
      INTEGER IAngleStep,IAVE,IAVF,ICOR,ICurrentCycle,Ifom,IRMSE,IRMSF,
     +        ISTAT,IW1AVE,IW1RMS,IW2AVE,IW2RMS,NumDerivatives,
     +        NumhklMonitored,NumResoBins,Ilen
      LOGICAL LAST,LAST1,LCOR,LELEC,LAPPLY,LSTAT
C     ..
C     .. Arrays in Common ..
      REAL FHAim,AFM,AOCC,ScaledDPH,
     +     FHArl,ASQ,B1,B2,B3,B4,B5,B6,BFM,DerivOverallBfact,
     +     CFM,DerivAnomLimits,DerivIsoLimit,
     +     DerivMaxResol,DerivMinResol,
     +     RmsAnomalError,RmsIsomorphError,FHim,
     +     ESQ,ScaledFPH,FPP,OCC,
     +     DerivativeNativeScale,FHrl,SAADC,
     +     SAADO,SADCSQ,SumAbsFPHobsFnat,SADOSQ,
     +     SumPrFPHobsFPHcalc,SASQ,SumSqrdFPHobsFnat,
     +     DerivSigmaScale,ScaledSigmaDPH,
     +     SESQ,SumFHcalc,SumFHA,SumFigMerit,
     +     SumFNativeScaled,SumFPHobs,
     +     DerivSigmaLimit,SLCA,
     +     SLCAQ,SumSqrdPrFPHobsFPHcalc,
     +     SumDeltaPhi,SumSqrdDeltaPhi,
     +     SumWsig,SumWsigA,SumWsigAADO,
     +     SumWsigADOS,SumWsigFPHobsFnat,
     +     SumSqrdWsigFPHobsFnat,
     +     SumWsigLCA,SumWsigLCAQ,
     +     SumWsigLackClosure,SumLackClosureWgtSqrd,
     +     SW,SumAnomWgtModPrPhase,SumAnomWgtModPrPhaseADO,
     +     SumAnomWgtModPrPhaseDOS,SumW1FPHobsFnat,
     +     SumW1FPHobsFnatSqrd,
     +     SWLCA,SWLCAQ,SumWghtFPHobsFPHcalc,
     +     SumW1SqrdLackClosure,ScaledVPH,X,Y,Z
      INTEGER IndexRefFlags,KRefineCycleFlag,
     +        Mcount,NumPhasedperDeriv,
     +        NumAnomPhasesPerDeriv,NAtomsPerDeriv,NDAT,NTROP
      LOGICAL CALAFF,LANOM,LBOV,LEAVE,
     +        LPhaseFlagPerDerivative,LRefineFlagPerDerivative
C     ..
C     .. Local Scalars ..
      REAL BUFAT,U
      INTEGER I,I1,I2,Kderiv,MBUFAT
      CHARACTER LAB*40,DerivTitle*80
C     ..
C     .. Local Arrays ..
      REAL AVFH(MaxNumResoBins+1,2),AVFHA(MaxNumResoBins+1),
     +     Buff(MaxNumResoBins+1,2),BuffA(MaxNumResoBins+1,2),
     +     BuffB(MaxNumResoBins+1,2),FomB(MaxNumResoBins),
     +     RES(MaxNumResoBins),
     +     VBuff(MaxNumResoBins+1,2),VBuffA(MaxNumResoBins+1),
     +     WBuff(MaxNumResoBins+1,2),WBuffA(MaxNumResoBins+1),
     +     Xlogg(14,MaxNumResoBins+1)
      INTEGER MBuff(MaxNumResoBins+1,2),MBuffA(MaxNumResoBins+1)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,NINT,REAL,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANALYS/ICOR,ISTAT,IAVF,IRMSF,IAVE,IRMSE,IW1AVE,IW1RMS,
     +       IW2AVE,IW2RMS,Ifom,NumhklMonitored
      COMMON /FASE/  
     +  RmsIsomorphError(MaxNumDerivatives,MaxNumResoBins),
     +   RmsAnomalError(MaxNumDerivatives,MaxNumResoBins),
     +     DerivSigmaLimit(MaxNumDerivatives),
     +      DerivIsoLimit(MaxNumDerivatives),
     +       DerivAnomLimits(2,MaxNumDerivatives),
     +        DerivMinResol(2,MaxNumDerivatives),
     +         DerivMaxResol(2,MaxNumDerivatives),
     +          KRefineCycleFlag(MaxNumRefCycles),
     +           ScaledFPH(MaxNumDerivatives),
     +            ScaledDPH(MaxNumDerivatives),
     +             ScaledVPH(MaxNumDerivatives),
     +              ScaledSigmaDPH(MaxNumDerivatives),
     +               FHrl(MaxNumDerivatives),
     +                FHim(MaxNumDerivatives),
     +                 FHArl(MaxNumDerivatives),
     +                  FHAim(MaxNumDerivatives),
     +                   LPhaseFlagPerDerivative(MaxNumDerivatives+1),
     +                    CentricTestFlag,FNativeScaled,
     +                     VarNativeSc,NumDerivatives,
     +                      IAngleStep,NumResoBins,ICurrentCycle,
     +                       LAST,LAST1
      COMMON /HEAVY/
     +  DerivSigmaScale(MaxNumDerivatives),    
     +   DerivScaleToNative(MaxNumDerivatives),
     +   DerivativeNativeScale(MaxNumDerivatives),   
     +    DerivOverallBfact(MaxNumDerivatives),
     +    IndexRefFlags(MaxNumDerivatives+1),  
     +     NAtomsPerDeriv(MaxNumDerivatives),
     +     OCC(MaxNumHeavyAtoms,MaxDataBatches),
     +      AOCC(MaxNumHeavyAtoms,MaxDataBatches),
     +       AFM(MaxNumHeavyAtoms,4),   BFM(MaxNumHeavyAtoms,4),
     +        CFM(MaxNumHeavyAtoms),     FPP(MaxNumHeavyAtoms),
     +         NTROP(MaxNumHeavyAtoms),   B1(MaxNumHeavyAtoms),
     +          B2(MaxNumHeavyAtoms),      B3(MaxNumHeavyAtoms),
     +           B4(MaxNumHeavyAtoms),      B5(MaxNumHeavyAtoms),
     +            B6(MaxNumHeavyAtoms),      X(MaxNumHeavyAtoms),
     +             Y(MaxNumHeavyAtoms),       Z(MaxNumHeavyAtoms),
     +              NDAT(MaxNumDerivatives),   
     +               CALAFF(MaxNumHeavyAtoms),
     +                LRefineFlagPerDerivative(MaxNumDerivatives),
     +                 LANOM(MaxNumDerivatives),
     +                  LBOV(MaxNumDerivatives),
     +                   LEAVE(MaxRefineFlags,MaxNumHeavyAtoms),
     +                    LELEC,LAPPLY
      COMMON /STATA1/
     + Mcount(MaxNumResoBins,2),
     + SumFigMerit(MaxNumResoBins,2),
     + NumPhasedperDeriv(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumDeltaPhi(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumSqrdDeltaPhi(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumFNativeScaled(MaxNumDerivatives,MaxNumResoBins,
     +                  MaxNumFigMeritBins,2),
     + SumFPHobs(MaxNumDerivatives,MaxNumResoBins,
     +           MaxNumFigMeritBins,2),
     + SumFHcalc(MaxNumDerivatives,MaxNumResoBins,
     +           MaxNumFigMeritBins,2),
     + SumFHA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAbsFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                  MaxNumFigMeritBins,2),
     + SumPrFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumWsigFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2)
      COMMON /STATA3/
     + SumWsigLackClosure(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumW1FPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                 MaxNumFigMeritBins,2),
     + SumWghtFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins,2),
     + SumSqrdFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumSqrdPrFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                        MaxNumFigMeritBins,2),
     + SumSqrdWsigFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins,2),
     + SumLackClosureWgtSqrd(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins,2),
     + SumW1FPHobsFnatSqrd(MaxNumDerivatives,MaxNumResoBins,
     +                     MaxNumFigMeritBins,2),
     + SumW1SqrdLackClosure(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins,2),
     + SW(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SumWsig(MaxNumDerivatives,MaxNumResoBins,
     +         MaxNumFigMeritBins,2),
     + NumAnomPhasesPerDeriv(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins),
     + SAADC(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins)
      COMMON /STATB2/
     + SADCSQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SAADO(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SLCA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SADOSQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SLCAQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumWsigAADO(MaxNumDerivatives,MaxNumResoBins,
     +             MaxNumFigMeritBins),
     + SumWsigLCA(MaxNumDerivatives,MaxNumResoBins,
     +            MaxNumFigMeritBins),
     + SumWsigADOS(MaxNumDerivatives,MaxNumResoBins,
     +             MaxNumFigMeritBins),
     + SumWsigLCAQ(MaxNumDerivatives,MaxNumResoBins,
     +             MaxNumFigMeritBins),
     + SumAnomWgtModPrPhaseADO(MaxNumDerivatives,MaxNumResoBins,
     +                         MaxNumFigMeritBins)
      COMMON /STATB4/
     + SWLCA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhaseDOS(MaxNumDerivatives,MaxNumResoBins,
     +                         MaxNumFigMeritBins),
     + SWLCAQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhase(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins),
     + SumWsigA(MaxNumDerivatives,MaxNumResoBins,
     +          MaxNumFigMeritBins),
     + SESQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SASQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + ESQ(MaxNumDerivatives,MaxNumResoBins),
     + ASQ(MaxNumDerivatives,MaxNumResoBins),
     + STMIN,STMAX,THR,ACL,LCOR,LSTAT
      COMMON /STATC/DerivTitle(MaxNumDerivatives+1)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C
C
C
      U = (STMAX-STMIN)/REAL(MaxNumResoBins)
C
C
      DO 20 I = 1,MaxNumResoBins
        RES(I) = 1.0/ (REAL(I)*U+STMIN)
        Xlogg(1,I) = (REAL(I)*U+STMIN)**2
        DO 10 I1 = 2,14
          Xlogg(I1,I) = 0.0
   10   CONTINUE
   20 CONTINUE
C
C----  If istat = 0 - no statistics
C      If istat = 1 - statistics on last cycle
C      If istat =10 - statistics on all cycles
C
C           There are several options for collecting statistics and
C           EJD does not know which is best.
C
C----  In all cycles EXCEPT the last, some reflections may
C      be rejected from  the  calculation - only those
C      used for REFINEMENT will be included in
C      the statistical analysis.
C
C      On the last ( phasing) cycle all reflections within
C      the resolution limits  are included.
C
C      EJD has collected MEAN and RMS values for all terms.
C
C       there are 3 options for weighting these terms.
C
C   1)  a straight MEAN or RMS divided by
C       the number of reflections included.
C
C   2)  a weighted value using a NEW weight
C       This is equal to  FOM/(SIGFP**2 + SIGFPH**2)
C
C       where FOM =
C         figure of merit SIGFP = sig(Fp) and SIGFPH = sig(Fph)
C
C
C   3)  a weighted value using the old weight
C        EJD is not clear why this is used but here is the definition!
C      W = Phase Prob /
C     ( SIGFPH**2 + VCALC + Esq for this Derivative at this resolution.)
C           VCALC = SIG(Fp)**2 *
C           ((FP**2 + FPA * FHA + FPB * FHB) / (FP * FPH))**2
C             FPA = FP * COS(PHIx) , FPB = FP * SIN(PHIx)
C              PHIx takes all values round the phase circle
C             FHA = FH * COS(PHIH)   FHB = FH * SIN(PHIH)
C
C
C
cpjx      WRITE (6,FMT=6000)
cpjx      WRITE (6,FMT=6002)
cpjx 6000 FORMAT (
cpjx     +//2X,
cpjx     +'**********************************************************',/,
cpjx     +' The following analyses are given for each derivative:',/,
cpjx     +' 1) Analysis of Differences between Heavy Atom and ',
cpjx     +             'Protein Phases',/11X,
cpjx     +'as a Function of Figure of merit',//,
cpjx     +' 2) Analysis of Differences between Heavy Atom and ',
cpjx     +             'Protein Phases',/11X,
cpjx     +'as a Function of Resolution',/,
cpjx     +' Note: Standard deviation of random distribution should',
cpjx     +            ' be:  acentric: 51.96  - centric: 90 ',//,
cpjx     +' 3)  Mean calculated FP , FPH,  and FH   Each for ',
cpjx     +            'ACENTRIC and CENTRIC terms;',/,
cpjx     +'  ACENTRIC FH a) from real f  and b) from f" ',
cpjx     +            'scattering.',//,
cpjx     +' 4) Lack of closure analysis: as requested on input: ',/,
cpjx     +' This includes the isomorphous difference between FP ',
cpjx     +            'and FPH,',/,
cpjx     +'  the lack of closure - difference between FP+FHcalc and FPH,',
cpjx     +/,
cpjx     +' calclated for Mean differences, and Rms differences,')
cpjx 6002 FORMAT (
cpjx     +' each using 3 different weighting schemes.',/,
cpjx     +'  a) division by the number of reflections in the range:',/,
cpjx     +'  b) a weighted sum using Weight 1( see definition below):',/,
cpjx     +'  c) a weighted sum using Weight 2( see definition below):',/,
cpjx     +'  These are used to calculate PHASING POWER, defined as:',/,
cpjx     +'   Mean FH / Lack of closure',/,
cpjx     +' and  a " Cullis Rfactor"  extended from the old definition ',
cpjx     +/,
cpjx     +'   to be   Lack_of_closure/ Isomorphous_difference',//,
cpjx     +' 5) Lack of closure analysis on anomalous differences: ',/,
cpjx     +'  This includes the anomalous difference ,',/,
cpjx     +'  the expected calculated anomalous lack of closure , ',/,
cpjx     +'  the anomalous lack of closure , ie: the difference ',
cpjx     +        'between DPH and DPHcalc',/,
cpjx     +' and  a "Cullis Rfactor" extended from the old definition ',
cpjx     +/,
cpjx     +'   to be   Lack_of_closure/ Anomalous_difference.')
C
C
      IF (IW1AVE.NE.0 .OR. IW1RMS.NE.0) THEN
        WRITE (6,FMT='(///)')
        WRITE (6,FMT=*) ' Definition of " OLD WEIGHT ( W1)"'
        WRITE (6,FMT=*)
     + ' W1 = Phase Prob /(SIGFPH**2 + VCALC + Esq  at this resolution)'
        WRITE (6,FMT=*) ' VCALC = SIG(Fp)**2 * '
ccx FPB option removed why write it out ?????
        WRITE (6,FMT=*)
     +    ' ((FP**2 + FPA * FHA + FPB * FHB) / (FP * FPH))**2'
        WRITE (6,FMT=*) ' FPA = FP * COS(PHIx) , FPB = FP * SIN(PHIx)'
        WRITE (6,FMT=*) ' PHIx takes all values round the phase circle'
        WRITE (6,FMT=*) ' FHA = FH * COS(PHIH)   FHB = FH * SIN(PHIH)'
      END IF
C
C
      IF (IW2AVE.NE.0 .OR. IW2RMS.NE.0) THEN
        WRITE (6,FMT='(///)')
        WRITE (6,FMT=*) ' Definition of " NEW WEIGHT" ( W2)'
        WRITE (6,FMT=*) ' W2 = FOM/( SIGFP**2 + SIGFPH**2)'
      END IF
C
C----   Sum up various weighting schemes
C
      DO 1390 Kderiv = 1,NumDerivatives
C     +    ' last refinement cycle'
C        IF (LAST) LAB = ' last phasing cycle'
cpjx        WRITE (6,FMT=6004) Kderiv,LAB
cpjx 6004   FORMAT (///' *************************************************',
cpjx     +         '*********',/' *** Analysis of Derivative',I3,A,'  ***',/
cpjx     +' **********************************************************')
        If(LAST) WRITE (6,FMT=6004) Kderiv
 6004   FORMAT (//,
     +  ' ************************************************************',
     +  /,' Phasing cycle: Analysis of Derivative',I3,/,
     +  ' ************************************************************')
C
C
        ILEN = LENSTR(DerivTitle(Kderiv))
        IF(ILEN.GT.14) ILEN = 14
        IF (.NOT.LAST) WRITE(LAB,'(3A)')' Refining cycle, ',
     +  DerivTitle(Kderiv) (1:ILEN),
     + ', deriv'  
        IF (LAST)      WRITE(LAB,'(3A)')' Phasing cycle,  ',
     +  DerivTitle(Kderiv) (1:ILEN),
     + ', deriv'  
C        IF (.NOT.LAST) LAB = ' Refinement cycle:'
C        IF (LAST) LAB = ' Phasing    cycle:''
C
C
        DO 30 I = 1,2
          VBuff(1+MaxNumResoBins,I) = 0
          WBuff(1+MaxNumResoBins,I) = 0
          MBuff(1+MaxNumResoBins,I) = 0
          BuffA(1+MaxNumResoBins,I) = 0
          Buff(1+MaxNumResoBins,I)  = 0
   30   CONTINUE
C
C
        MBuffA(1+MaxNumResoBins) = 0
        VBuffA(1+MaxNumResoBins) = 0
        WBuffA(1+MaxNumResoBins) = 0
        MBUFAT = 0
C
C   Phase analysis v Figure of merit
C   MaxNumFigMeritBins = MaxNumResoBins = 8..
C
        DO 90 Ifom = 1,MaxNumFigMeritBins
          DO 40 I = 1,2
            MBuff(Ifom,I) = 0
            VBuff(Ifom,I) = 0
            WBuff(Ifom,I) = 0
            Buff(Ifom,I)  = 0.0
            BuffA(Ifom,I) = 0.0
   40     CONTINUE
C
C
          MBuffA(Ifom) = 0
          VBuffA(Ifom) = 0
          WBuffA(Ifom) = 0
C
C
          DO 70 NumResoBins = 1,MaxNumResoBins
            DO 50 I = 1,2
              MBuff(Ifom,I) = MBuff(Ifom,I) +
     +         NumPhasedperDeriv(Kderiv,NumResoBins,Ifom,I)
              VBuff(Ifom,I) = VBuff(Ifom,I) +
     +         SumWsig(Kderiv,NumResoBins,Ifom,I)
              WBuff(Ifom,I) = WBuff(Ifom,I) +
     +         SW(Kderiv,NumResoBins,Ifom,I)
   50       CONTINUE
C
C----   Sums for ano data
C
            MBuffA(Ifom) = MBuffA(Ifom) +
     +       NumAnomPhasesPerDeriv(Kderiv,NumResoBins,Ifom)
            VBuffA(Ifom) = VBuffA(Ifom) + 
     +       SumWsigA(Kderiv,NumResoBins,Ifom)
            WBuffA(Ifom) = WBuffA(Ifom) + 
     +       SumAnomWgtModPrPhase(Kderiv,NumResoBins,Ifom)
C
C----  Sum phase differences
C
            DO 60 I = 1,2
              Buff(Ifom,I) = Buff(Ifom,I) +
     +           SumDeltaPhi(Kderiv,NumResoBins,Ifom,I)
              BuffA(Ifom,I) = BuffA(Ifom,I) +
     +           SumSqrdDeltaPhi(Kderiv,NumResoBins,Ifom,I)
   60       CONTINUE
   70     CONTINUE
C
C
          DO 80 I = 1,2
            VBuff(1+MaxNumFigMeritBins,I) = 
     +          VBuff(1+MaxNumFigMeritBins,I) + VBuff(Ifom,I)
            WBuff(1+MaxNumFigMeritBins,I) = 
     +          WBuff(1+MaxNumFigMeritBins,I) + WBuff(Ifom,I)
            MBuff(1+MaxNumFigMeritBins,I) = 
     +          MBuff(1+MaxNumFigMeritBins,I) + MBuff(Ifom,I)
            VBuffA(1+MaxNumFigMeritBins) = 
     +          VBuffA(1+MaxNumFigMeritBins) + VBuffA(Ifom)
            WBuffA(1+MaxNumFigMeritBins) = 
     +          WBuffA(1+MaxNumFigMeritBins) + WBuffA(Ifom)
            MBuffA(1+MaxNumFigMeritBins) = 
     +          MBuffA(1+MaxNumFigMeritBins) + MBuffA(Ifom)
            MBUFAT = MBuffA(Ifom) + MBUFAT
            Buff(1+MaxNumFigMeritBins,I) = 
     +          Buff(1+MaxNumFigMeritBins,I) + Buff(Ifom,I)
            BuffA(1+MaxNumFigMeritBins,I) = 
     +          BuffA(1+MaxNumFigMeritBins,I) + BuffA(Ifom,I)
            BUFAT = MBuffA(Ifom) + BUFAT
C
C
            IF (MBuff(Ifom,I).GT.0) THEN
              Buff(Ifom,I) = Buff(Ifom,I)/MBuff(Ifom,I)
C
C----  Check Standard deviation   = sqrt( sum(x*x)/n  - Xmean*Xmean)
C
              BuffA(Ifom,I) = BuffA(Ifom,I)/MBuff(Ifom,I) -
     +                        Buff(Ifom,I)**2
              BuffA(Ifom,I) = SQRT(ABS(BuffA(Ifom,I)))
            END IF
   80     CONTINUE

C
C----  Use FomB array to store FOM steps 0.0625 0.1875 ...
C
          FomB(Ifom) = 0.125*Ifom - 0.0625
          Xlogg(2,Ifom) = MBuff(Ifom,1)
          Xlogg(3,Ifom) = MBuff(Ifom,2)
          Xlogg(4,Ifom) = Buff(Ifom,1)
          Xlogg(5,Ifom) = BuffA(Ifom,1)
          Xlogg(6,Ifom) = Buff(Ifom,2)
          Xlogg(7,Ifom) = BuffA(Ifom,2)
   90   CONTINUE
C
C
        DO 100 I = 1,2
          IF (MBuff(1+MaxNumFigMeritBins,I).GT.0) THEN
            Buff(1+MaxNumFigMeritBins,I) = 
     +             Buff(1+MaxNumFigMeritBins,I)/
     +            MBuff(1+MaxNumFigMeritBins,I)
            BuffA(1+MaxNumFigMeritBins,I) = 
     +             BuffA(1+MaxNumFigMeritBins,I)/
     +            MBuff(1+MaxNumFigMeritBins,I) -
     +             Buff(1+MaxNumFigMeritBins,I)**2
            BuffA(1+MaxNumFigMeritBins,I) = 
     +            SQRT(ABS(BuffA(1+MaxNumFigMeritBins,I)))
          END IF
  100   CONTINUE
C
C
        Xlogg(2,MaxNumFigMeritBins+1) = MBuff(MaxNumFigMeritBins+1,1)
        Xlogg(3,MaxNumFigMeritBins+1) = MBuff(MaxNumFigMeritBins+1,2)
        Xlogg(4,MaxNumFigMeritBins+1) = Buff(MaxNumFigMeritBins+1,1)
        Xlogg(5,MaxNumFigMeritBins+1) = BuffA(MaxNumFigMeritBins+1,1)
        Xlogg(6,MaxNumFigMeritBins+1) = Buff(MaxNumFigMeritBins+1,2)
        Xlogg(7,MaxNumFigMeritBins+1) = BuffA(MaxNumFigMeritBins+1,2)
C
C
C---- Table of Phase differences as a function of FoM
C
        WRITE (6,FMT=9006)
        WRITE (6,FMT=6006) LAB,Kderiv,LAB,Kderiv,LAB,Kderiv
 9006   FORMAT (/,
     +  ' =====================================================',/,
     +  ' 1. Analysis of differences between Heavy Atom and',/,
     +  '    Protein phases, as a function of Figure of Merit',/,
     +  ' =====================================================')
cpjx 6006   FORMAT (///2X,
cpjx     +'********************************************************',/,
cpjx     +' ********************************************************',/,
 6006   FORMAT (/,
     +' $TABLE:Phase_diffs v FOM - acentric,centric',A,I3,':',/,
     +' $GRAPHS',
     +' :Phase_diffs - standard deviations - ',A,I3,':N:1,3,4,6,7:',/,
     +' :Number of reflections - ',A,I3,':N:1,2,5:',/,
     +' $$ <FOM> ',/,
     +' Number_acentric_reflections  ',/,
     +' Phase_difference_acentric(?90) ',/,
     +' St.D.-of-Phase_difference_acentric(?52) ',/,
     +' Number_centric_reflections',/,
     +' Phase_difference_centric(?90)',/,
     +' St.D.-of-Phase_difference_centric(?90) $$ ',//,
     +'     <FOM> Nref_a DPHI_a SD_a    Nref_c DPHI_c  SD_c $$ ')
C
C
        DO 120 Ifom = 1,MaxNumFigMeritBins
          I1 = NINT(Xlogg(2,Ifom))
          I2 = NINT(Xlogg(3,Ifom))
          WRITE (6,FMT='(3x,F5.3,I7,2F7.1,I8,2f7.1)') 
     +      FomB(Ifom),I1,
     +       Xlogg(4,Ifom),
     +        Xlogg(5,Ifom),I2, 
     +         (Xlogg(I,Ifom),I=6,7)
C
C
          DO 110 I1 = 2,7
            Xlogg(I1,Ifom) = 0.0
  110     CONTINUE
  120   CONTINUE
C
C
        WRITE (6,FMT=*) ' $$'
        I1 = NINT(Xlogg(2,MaxNumFigMeritBins+1))
        I2 = NINT(Xlogg(3,MaxNumFigMeritBins+1))
        WRITE (6,FMT='(3x,A,I7,2F7.1,I8,2f7.1)') 
     +    'TOTAL',I1,
     +     Xlogg(4,MaxNumFigMeritBins+1),
     +      Xlogg(5,MaxNumFigMeritBins+1),I2, 
     +       (Xlogg(I,MaxNumFigMeritBins+1),I=6,7)
C
C
        DO 130 I1 = 2,7
          Xlogg(I1,1+MaxNumFigMeritBins) = 0.0
  130   CONTINUE
C
C---- Phase analysis v resolution
C
        DO 140 I = 1,2
          VBuff(1+MaxNumResoBins,I) = 0
          WBuff(1+MaxNumResoBins,I) = 0
          MBuff(1+MaxNumResoBins,I) = 0
          BuffA(1+MaxNumResoBins,I) = 0
          Buff(1+MaxNumResoBins,I)  = 0
  140   CONTINUE
C
C
        MBuffA(1+MaxNumResoBins) = 0
        VBuffA(1+MaxNumResoBins) = 0
        WBuffA(1+MaxNumResoBins) = 0
        MBUFAT = 0
C
C
        DO 190 NumResoBins = 1,MaxNumResoBins
          DO 150 I = 1,2
            MBuff(NumResoBins,I) = 0
            VBuff(NumResoBins,I) = 0
            WBuff(NumResoBins,I) = 0
            Buff(NumResoBins,I)  = 0.0
            BuffA(NumResoBins,I) = 0.0
  150     CONTINUE
C
C
          MBuffA(NumResoBins) = 0
          VBuffA(NumResoBins) = 0
          WBuffA(NumResoBins) = 0
C
C
          DO 170 Ifom = 1,MaxNumFigMeritBins
            DO 160 I = 1,2
              MBuff(NumResoBins,I) = MBuff(NumResoBins,I) +
     +         NumPhasedperDeriv(Kderiv,NumResoBins,Ifom,I)
              VBuff(NumResoBins,I) = VBuff(NumResoBins,I) +
     +         SumWsig(Kderiv,NumResoBins,Ifom,I)
              WBuff(NumResoBins,I) = WBuff(NumResoBins,I) +
     +         SW(Kderiv,NumResoBins,Ifom,I)
C
C
C----  Sum phase differences
C
              Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +          SumDeltaPhi(Kderiv,NumResoBins,Ifom,I)
              BuffA(NumResoBins,I) = BuffA(NumResoBins,I) +
     +          SumSqrdDeltaPhi(Kderiv,NumResoBins,Ifom,I)
  160       CONTINUE
C
C----   Sums for ano data
C
            MBuffA(NumResoBins) = MBuffA(NumResoBins) +
     +       NumAnomPhasesPerDeriv(Kderiv,NumResoBins,Ifom)
            VBuffA(NumResoBins) = VBuffA(NumResoBins) +
     +        SumWsigA(Kderiv,NumResoBins,Ifom)
            WBuffA(NumResoBins) = WBuffA(NumResoBins) +
     +               SumAnomWgtModPrPhase(Kderiv,NumResoBins,Ifom)
  170     CONTINUE
C
C
          DO 180 I = 1,2
            VBuff(1+MaxNumResoBins,I) = VBuff(1+MaxNumResoBins,I) +
     +                                  VBuff(NumResoBins,I)
            WBuff(1+MaxNumResoBins,I) = WBuff(1+MaxNumResoBins,I) +
     +                                  WBuff(NumResoBins,I)
            MBuff(1+MaxNumResoBins,I) = MBuff(1+MaxNumResoBins,I) +
     +                                  MBuff(NumResoBins,I)
            Buff(1+MaxNumResoBins,I)  = Buff(1+MaxNumResoBins,I) +
     +                                  Buff(NumResoBins,I)
            BuffA(1+MaxNumResoBins,I) = BuffA(1+MaxNumResoBins,I) +
     +                                  BuffA(NumResoBins,I)
C
C
            IF (MBuff(NumResoBins,I).GT.0) THEN
              Buff(NumResoBins,I) = Buff(NumResoBins,I)/
     +                              MBuff(NumResoBins,I)
C
C----  Check Standard deviation   = sqrt( sum(x*x)/n  - Xmean*Xmean)
C
              BuffA(NumResoBins,I) = BuffA(NumResoBins,I)/
     +                               MBuff(NumResoBins,I) -
     +                               Buff(NumResoBins,I)**2
              BuffA(NumResoBins,I) = SQRT(ABS(BuffA(NumResoBins,I)))
            END IF
  180     CONTINUE
C
C
          VBuffA(1+MaxNumResoBins) = VBuffA(1+MaxNumResoBins) +
     +                               VBuffA(NumResoBins)
          WBuffA(1+MaxNumResoBins) = WBuffA(1+MaxNumResoBins) +
     +                               WBuffA(NumResoBins)
          MBuffA(1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins) +
     +                               MBuffA(NumResoBins)
          MBUFAT = MBuffA(NumResoBins) + MBUFAT
          BUFAT  = MBuffA(NumResoBins) + BUFAT
C
C
          Xlogg(2,NumResoBins) = MBuff(NumResoBins,1)
          Xlogg(3,NumResoBins) = MBuff(NumResoBins,2)
          Xlogg(4,NumResoBins) = Buff(NumResoBins,1)
          Xlogg(5,NumResoBins) = BuffA(NumResoBins,1)
          Xlogg(6,NumResoBins) = Buff(NumResoBins,2)
          Xlogg(7,NumResoBins) = BuffA(NumResoBins,2)
  190   CONTINUE
C
C
        DO 200 I = 1,2
          IF (MBuff(1+MaxNumResoBins,I).GT.0) THEN
            Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I)/
     +                                 MBuff(1+MaxNumResoBins,I)
            BuffA(1+MaxNumResoBins,I) = BuffA(1+MaxNumResoBins,I)/
     +                                  MBuff(1+MaxNumResoBins,I) -
     +                                  Buff(1+MaxNumResoBins,I)**2
            BuffA(1+MaxNumResoBins,I) = SQRT(ABS(BuffA(1+MaxNumResoBins,
     +                                  I)))
          END IF
  200   CONTINUE
C
C
        Xlogg(2,MaxNumResoBins+1) = MBuff(MaxNumResoBins+1,1)
        Xlogg(3,MaxNumResoBins+1) = MBuff(MaxNumResoBins+1,2)
        Xlogg(4,MaxNumResoBins+1) = Buff(MaxNumResoBins+1,1)
        Xlogg(5,MaxNumResoBins+1) = BuffA(MaxNumResoBins+1,1)
        Xlogg(6,MaxNumResoBins+1) = Buff(MaxNumResoBins+1,2)
        Xlogg(7,MaxNumResoBins+1) = BuffA(MaxNumResoBins+1,2)
C
        WRITE (6,FMT=9008)
        WRITE (6,FMT=6008) LAB,Kderiv,LAB,Kderiv,LAB,Kderiv
 9008   FORMAT (//,
     +  ' =====================================================',/,
     +  ' 2. Analysis of differences between Heavy Atom and',/,
     +  '    Protein phases, as a function of Resolution',/,
     +  '    Note: standard deviation of a random distribution',/,
     +  '    should be 51.96 (acentric) - 90 (centric)',/,
     +  ' =====================================================')
 6008   FORMAT (/,
     +' $TABLE: Resln v Phase_diffs - ',A,I3,':',/,
     +' $GRAPHS',
     +' :Phase_diffs - standard deviations - ',A,I3,':N',
     +         ':1,4,5,7,8:',/,
     +' :Number of reflections -  ',A,I3,':N:1,3,6:',/,
     +' $$ 1/resol^2 ',/,' Resolution(Angstroms)  ',/,
     +' Number_acentric_reflections  ',/,
     +' Phase_difference_acentric(?90) ',/,
     +' St.D.-of-Phase_difference_acentric(?52) ',/,
     +' Number_centric_reflections',/,
     +' Phase_difference_centric(?90)',/,
     +' St.D.-of-Phase_difference_centric(?90) $$ ',//,
     +' 1/resol^2  Resol   Nref_a DPHI_a SD_a    Nref_c DPHI_c  SD_c',
     +' $$ ')
C
C
        DO 220 NumResoBins = 1,MaxNumResoBins
          I1 = NINT(Xlogg(2,NumResoBins))
          I2 = NINT(Xlogg(3,NumResoBins))
          WRITE (6,FMT='(3x,F5.3,3x,F6.2,I7,2F7.1,I8,2f7.1)') 
     +      Xlogg(1,NumResoBins),Res(NumResoBins),I1,
     +       Xlogg(4,NumResoBins),
     +        Xlogg(5,NumResoBins),I2, 
     +         (Xlogg(I,NumResoBins),I=6,7)
C
C
          DO 210 I1 = 4,7
            Xlogg(I1,NumResoBins) = 0.0
  210     CONTINUE
  220   CONTINUE
C
C
        WRITE (6,FMT=*) ' $$'
        I1 = NINT(Xlogg(2,1+MaxNumResoBins))
        I2 = NINT(Xlogg(3,1+MaxNumResoBins))
        WRITE (6,FMT='(3x,A,9X,I7,2F7.1,I8,2f7.1)') 
     +    'TOTAL',I1,
     +     Xlogg(4,MaxNumFigMeritBins+1),
     +      Xlogg(5,MaxNumFigMeritBins+1),I2, 
     +       (Xlogg(I,1+MaxNumResoBins),I=6,7)
C
C
        DO 230 I1 = 4,7
          Xlogg(I1,1+MaxNumResoBins) = 0.0
  230   CONTINUE
C
C  Totals
C----    Average FP FPH FH  v resln
C
        IF (IAVF.GT.0) THEN
C
C----  FP
C
          Buff(1+MaxNumResoBins,1) = 0.0
          Buff(1+MaxNumResoBins,2) = 0.0
C
C
          DO 260 NumResoBins = 1,MaxNumResoBins
            DO 250 I = 1,2
              Buff(NumResoBins,I) = 0.0
C
C
              DO 240 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +           SumFNativeScaled(Kderiv,NumResoBins,Ifom,I)
  240         CONTINUE
C
C
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
              IF (MBuff(NumResoBins,I).GT.0) 
     +             Buff(NumResoBins,I) = (Buff(NumResoBins,I)/
     +                                   MBuff(NumResoBins,I))
  250       CONTINUE
C
C
            Xlogg(4,NumResoBins) = Buff(NumResoBins,1)
            Xlogg(5,NumResoBins) = Buff(NumResoBins,2)
  260     CONTINUE
C
C----  Av FP
C
          IF (MBuff(1+MaxNumResoBins,1).GT.0) 
     +        Xlogg(4,1+MaxNumResoBins) = 
     +                  (Buff(1+MaxNumResoBins,1)/
     +                  MBuff(1+MaxNumResoBins,1))
          IF (MBuff(1+MaxNumResoBins,2).GT.0) 
     +        Xlogg(5,1+MaxNumResoBins) = 
     +                  (Buff(1+MaxNumResoBins,2)/
     +                  MBuff(1+MaxNumResoBins,2))
C
C----  FPH
C
          Buff(1+MaxNumResoBins,1) = 0.0
          Buff(1+MaxNumResoBins,2) = 0.0
C
C
          DO 290 NumResoBins = 1,MaxNumResoBins
            DO 280 I = 1,2
              Buff(NumResoBins,I) = 0.0
              DO 270 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +               SumFPHobs(Kderiv,NumResoBins,Ifom,I)
  270         CONTINUE
C
C
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
              IF (MBuff(NumResoBins,I).GT.0) 
     +             Buff(NumResoBins,I) = (Buff(NumResoBins,I)/
     +                                   MBuff(NumResoBins,I))
C
C
  280       CONTINUE
            Xlogg(6,NumResoBins) = Buff(NumResoBins,1)
            Xlogg(7,NumResoBins) = Buff(NumResoBins,2)
  290     CONTINUE
C
C----  Av FPH
C
          IF (MBuff(1+MaxNumResoBins,1).GT.0) 
     +        Xlogg(6,1+MaxNumResoBins) = 
     +                  (Buff(1+MaxNumResoBins,1)/
     +                  MBuff(1+MaxNumResoBins,1))
          IF (MBuff(1+MaxNumResoBins,2).GT.0) 
     +        Xlogg(7,1+MaxNumResoBins) = 
     +                  (Buff(1+MaxNumResoBins,2)/
     +                  MBuff(1+MaxNumResoBins,2))
C
        END IF
C
C----  Average FH
C
        DO 300 I = 1,2
          AVFH(1+MaxNumResoBins,I)  = 0.0
          AVFHA(1+MaxNumResoBins)   = 0.0
          Buff(1+MaxNumResoBins,I)  = 0.0
          BuffA(1+MaxNumResoBins,I) = 0.0
  300   CONTINUE
C
        DO 330 NumResoBins = 1,MaxNumResoBins
          DO 320 I = 1,2
            Buff(NumResoBins,I)  = 0.0
            BuffA(NumResoBins,I) = 0.0
C
            DO 310 Ifom = 1,MaxNumFigMeritBins
              Buff(NumResoBins,I)  = Buff(NumResoBins,I) +
     +             SumFHcalc(Kderiv,NumResoBins,Ifom,I)
              BuffA(NumResoBins,I) = BuffA(NumResoBins,I) +
     +             SumFHA(Kderiv,NumResoBins,Ifom)
  310       CONTINUE
C
C---- Increment total
C
            AVFH(1+MaxNumResoBins,I) = AVFH(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
C
            IF (MBuff(NumResoBins,I).GT.0) THEN
              Buff(NumResoBins,I)  = (Buff(NumResoBins,I)/
     +                               MBuff(NumResoBins,I))
            END IF
C
            AVFH(NumResoBins,I) = Buff(NumResoBins,I)
  320     CONTINUE
C
C---- Increment total
C
          AVFHA(1+MaxNumResoBins) = AVFHA(1+MaxNumResoBins) +
     +                              BuffA(NumResoBins,1)

          DO I = 1,2
            IF (MBuff(NumResoBins,I).GT.0) THEN
              BuffA(NumResoBins,I) = (BuffA(NumResoBins,I)/
     +                               MBuff(NumResoBins,I))
            END IF
          ENDDO

          AVFHA(NumResoBins)      = BuffA(NumResoBins,1)

          IF (IAVF.GT.0) THEN
            Xlogg(8,NumResoBins)    = Buff(NumResoBins,1)
            Xlogg(9,NumResoBins)    = BuffA(NumResoBins,1)
            Xlogg(10,NumResoBins)   = Buff(NumResoBins,2)
          END IF
  330   CONTINUE
C
        IF (MBuff(1+MaxNumResoBins,1).GT.0) THEN
          AVFH(1+MaxNumResoBins,1) = (AVFH(1+MaxNumResoBins,1)/
     +                               MBuff(1+MaxNumResoBins,1))
          AVFHA(1+MaxNumResoBins)  = (AVFHA(1+MaxNumResoBins)/
     +                               MBuff(1+MaxNumResoBins,1))
        END IF
C
        IF (MBuff(1+MaxNumResoBins,2).GT.0) AVFH(1+MaxNumResoBins,
     +      2) = (AVFH(1+MaxNumResoBins,2)/MBuff(1+MaxNumResoBins,2))
C
C
        IF (IAVF.GT.0) THEN
          WRITE (6,FMT=9010)
          WRITE (6,FMT=6010) LAB,Kderiv,LAB,Kderiv,LAB,Kderiv
 9010     FORMAT (//,
     +' ========================================================',/,
     +' 3. Mean calculated FP, FPH and FH for ACENTRIC and',/,
     +'    CENTRIC terms;',/,
     +'    ACENTRIC FH a) from real f and b) from f" scattering',/,
     +' ========================================================')
 6010     FORMAT (/,
     +' $TABLE: Resln v Mean FP,FPH,FH - ',A,I3,':',/,
     +' $GRAPHS',
     +' :<FP> <FPH> <FH> - ',A,I3,':N:1,4',
     +           ',5,6,7,9,10,11:',/,
     +' :Number of reflections -  ',A,I3,':N:1,3,8:',/,
     +' $$ 1/resol^2 ',/,
     +' Resolution(Angstroms)  ',/,
     +' Number_acentric_reflections  ',/,
     +' FP_acentric  ',/,
     +' FPH_acentric',/,
     +' FH_acentric_real FH_acentric_imag ',/,
     +' Number_centric_reflections',/,
     +' FP_centric ',/,
     +' FPH_centric',/,
     +' FH_centric $$',//,
     +' 1/resol^2  Resol   Nref_a FP_a   FPH_a  ',
     +    'FH_a_rl FH_a_imag  Nref_c  FP_c   FPH_c  FH_cen $$')
C
          DO 350 NumResoBins = 1,MaxNumResoBins
            I1 = NINT(Xlogg(2,NumResoBins))
            I2 = NINT(Xlogg(3,NumResoBins))
            WRITE (6,FMT='(3x,F5.3,3x,F6.2,I7,2F8.1,2f7.1,3x,I8,3F8.1)')
     +        Xlogg(1,NumResoBins),Res(NumResoBins),I1,
     +         Xlogg(4,NumResoBins),
     +          Xlogg(6,NumResoBins),
     +           Xlogg(8,NumResoBins),
     +            Xlogg(9,NumResoBins),I2,
     +             Xlogg(5,NumResoBins),
     +              Xlogg(7,NumResoBins),
     +               Xlogg(10,NumResoBins)
C
C
            DO 340 I1 = 4,10
              Xlogg(I1,NumResoBins) = 0.0
  340       CONTINUE
  350     CONTINUE
C
C
          WRITE (6,FMT=*) ' $$'
          I1 = MBuff(1+MaxNumResoBins,1)
          I2 = MBuff(1+MaxNumResoBins,2)
C
C
          WRITE (6,FMT='(3x,A,9X,I7,2F8.1,2F7.1,3x,I8,3f8.1)') 
     +      'TOTAL',I1,
     +       Xlogg(4,MaxNumResoBins+1),
     +        Xlogg(6,MaxNumResoBins+1),
     +         AVFH(1+MaxNumResoBins,1),
     +          AVFHA(1+MaxNumResoBins),I2,
     +           Xlogg(5,1+MaxNumResoBins),
     +            Xlogg(7,1+MaxNumResoBins),
     +             AVFH(1+MaxNumResoBins,2)
C
C
          Xlogg(4,1+MaxNumResoBins) = 0.0
          Xlogg(5,1+MaxNumResoBins) = 0.0
          Xlogg(6,1+MaxNumResoBins) = 0.0
          Xlogg(7,1+MaxNumResoBins) = 0.0
        END IF
C
C---- Header for any lack of closure analysis requested by
C     the user
C
        IF (IAVE.GT.0 .OR. IRMSE.GT.0 .OR. IW1RMS.GT.0
     +       .OR. IW2RMS.GT.0 .OR. IW1AVE.GT.0 .OR.
     +       IW2AVE.GT.0 ) THEN
          WRITE (6,FMT=9012)
 9012     FORMAT (//,
     +' ========================================================',/,
     +' 4. Lack of closure analyses',//,
     +' This includes the isomorphous difference between FP and FPH,',/,
     +' the lack of closure - difference between FP+FHcalc and FPH,',/,
     +' calclated for Mean differences, and Rms differences',/,
     +' each using 3 different weighting schemes:',/,
     +'  a) division by the number of reflections in the range:',/,
     +'  b) a weighted sum using Weight 1( see definition below):',/,
     +'  c) a weighted sum using Weight 2( see definition below):',/,
     +' These are used to calculate PHASING POWER, defined as:',/,
     +' (Mean FH / Lack of closure) and  a "Cullis Rfactor"',/,
     +' extended from the old definition to be:',/,
     +' (Lack_of_closure / Isomorphous_difference)')
        END IF
C
C
        IF (IAVE.GT.0) THEN
C
C----  Av (ABS( Diso)
C
          Buff(1+MaxNumResoBins,1) = 0.0
          Buff(1+MaxNumResoBins,2) = 0.0
C
C
          DO 380 NumResoBins = 1,MaxNumResoBins
            DO 370 I = 1,2
              Buff(NumResoBins,I) = 0.0
C
C
              DO 360 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +           SumAbsFPHobsFnat(Kderiv,NumResoBins,Ifom,I)
C
C----  Ready for Rcullis - use BuffA to store info
C
  360         CONTINUE
C
C
              BuffA(NumResoBins,I)      = Buff(NumResoBins,I)
              Buff(1+MaxNumResoBins,I)  = Buff(1+MaxNumResoBins,I) +
     +                                    Buff(NumResoBins,I)
              BuffA(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I)
C
C
              IF (MBuff(NumResoBins,I).GT.0) 
     +             Buff(NumResoBins,I) = (Buff(NumResoBins,I)/
     +                                   MBuff(NumResoBins,I))
  370       CONTINUE
C
            Xlogg(4,NumResoBins) = Buff(NumResoBins,1)
            Xlogg(5,NumResoBins) = Buff(NumResoBins,2)
  380     CONTINUE
C
C
          IF (MBuff(1+MaxNumResoBins,1).GT.0) 
     +         Buff(1+MaxNumResoBins,1) = 
     +                   Buff(1+MaxNumResoBins,1)/
     +                  MBuff(1+MaxNumResoBins,1)
          IF (MBuff(1+MaxNumResoBins,2).GT.0) 
     +         Buff(1+MaxNumResoBins,2) = 
     +                   Buff(1+MaxNumResoBins,2)/
     +                  MBuff(1+MaxNumResoBins,2)
C
C
          Xlogg(4,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
          Xlogg(5,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,2)
C
C----  Av (ABS( lack of closure)
C
          Buff(1+MaxNumResoBins,1)  = 0.0
          Buff(1+MaxNumResoBins,2)  = 0.0
          BuffB(1+MaxNumResoBins,1) = 0.0
          BuffB(1+MaxNumResoBins,2) = 0.0
C
C
          DO 410 NumResoBins = 1,MaxNumResoBins
            DO 400 I = 1,2
              Buff(NumResoBins,I)  = 0.0
              BuffB(NumResoBins,I) = 0.0
C
C
              DO 390 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +              SumPrFPHobsFPHcalc(Kderiv,NumResoBins,Ifom,I)
  390         CONTINUE
C
C
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
C
C----  Ready for Rcullis and Phasing power
C
              IF (BuffA(NumResoBins,I).GT.0.00001) 
     +            BuffA(NumResoBins,I) = (Buff(NumResoBins,I)/
     +                                    BuffA(NumResoBins,I))
              IF (MBuff(NumResoBins,I).GT.0) 
     +             Buff(NumResoBins,I) = (Buff(NumResoBins,I)/
     +                                   MBuff(NumResoBins,I))
              IF (Buff(NumResoBins,I).GT.0.00001) 
     +            BuffB(NumResoBins,I) = (AVFH(NumResoBins,I)/
     +                                    Buff(NumResoBins,I))
  400       CONTINUE
C
C
            Xlogg(6,NumResoBins)  = Buff(NumResoBins,1)
            Xlogg(7,NumResoBins)  = Buff(NumResoBins,2)
            Xlogg(8,NumResoBins)  = BuffB(NumResoBins,1)
            Xlogg(9,NumResoBins)  = BuffB(NumResoBins,2)
            Xlogg(10,NumResoBins) = BuffA(NumResoBins,1)
            Xlogg(11,NumResoBins) = BuffA(NumResoBins,2)
  410     CONTINUE
C
C
          DO 420 I = 1,2
            IF (BuffA(1+MaxNumResoBins,I).GT.0.00001) 
     +          BuffA(1+MaxNumResoBins,I) = (Buff(1+MaxNumResoBins,I)/
     +                                      BuffA(1+MaxNumResoBins,I))
            IF (MBuff(1+MaxNumResoBins,I).GT.0) 
     +           Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I)/
     +                                     MBuff(1+MaxNumResoBins,I)
            IF (Buff(1+MaxNumResoBins,I).GT.0.00001) 
     +          BuffB(1+MaxNumResoBins,I) = (AVFH(1+MaxNumResoBins,I)/
     +                                       Buff(1+MaxNumResoBins,I))
  420     CONTINUE
C
          Xlogg(6,1+MaxNumResoBins)  = Buff(1+MaxNumResoBins,1)
          Xlogg(7,1+MaxNumResoBins)  = Buff(1+MaxNumResoBins,2)
          Xlogg(8,1+MaxNumResoBins)  = BuffB(1+MaxNumResoBins,1)
          Xlogg(9,1+MaxNumResoBins)  = BuffB(1+MaxNumResoBins,2)
          Xlogg(10,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
          Xlogg(11,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,2)
C
C----  Xloggraph stuff now.
C
C  OK
C
C---- Lack of closure analyses using MEAN
C
          WRITE (6,FMT=9014)
 9014     FORMAT (/,
     +' Unweighted MEAN lack-of-closure analysis',/,
     +' ========================================')
          WRITE (6,FMT=6012) LAB,Kderiv
 6012     FORMAT (/,
     +' $TABLE: Lack of closure analysis  v resln using MEANS - ',
     +  A,I3,':')
          WRITE (6,FMT=6014) LAB,Kderiv,LAB,Kderiv,LAB,Kderiv,LAB,
     +      Kderiv
 6014     FORMAT (
     +' $GRAPHS',
     +' :Phasing power=(FH/Lack_of_closure) - ',A,I3,':N:1,6,11:',/,
     +' :"Cullis Rfactor"=(Lack_of_closure/Iso Diff) ',
     +       A,I3,':N:1,7,12:',/,
     +' :Isomorphous difference,lack_of_closure - ',A,I3,
     +           ':N:1,4,5,9,10:',/,
     +' :Number of refs - ',A,I3,':N:1,3,8:',/,
     +' $$ 1/resol^2',/,' Resolution(Angstroms) ',/,
     +' Number_acentric_reflections ',/,
     +' Isomorphous_difference_acentric ',/,
     +' Lack_of_closure_acentric  ',/,
     +' Phasing_power_acentric ',/,
     +' Cullis_R_acentric(?<1.0) ',/,
     +' Number_centric_reflections ',/,
     +' Isomorphous_difference_centric ',/,
     +' Lack_of_closure_centric ',/,
     +' Phasing_power_centric',/,
     +' Cullis_R_centric(?<1.0) $$ ',/,
     +' 1/resol^2  Resol   Nref_a DISO_a LOC_a PhP_a CullR_a ',
     +'Nref_c DISO_c LOC_cPhP_c CullR_c $$')
C
C
          DO 440 NumResoBins = 1,MaxNumResoBins
            I1 = NINT(Xlogg(2,NumResoBins))
            I2 = NINT(Xlogg(3,NumResoBins))
            WRITE (6,FMT='(3x,F5.3,3x,F6.2,2(I8,2F7.1,F5.2,f7.2))') 
     +         Xlogg(1,NumResoBins),Res(NumResoBins),I1, 
     +          (Xlogg(I,NumResoBins),I=4,10,2),I2,
     +           (Xlogg(I,NumResoBins),I=5,11,2)
C
C
            DO 430 I1 = 4,12
              Xlogg(I1,NumResoBins) = 0.0
  430       CONTINUE
  440     CONTINUE
C
C
          WRITE (6,FMT=*) ' $$'
          I1 = NINT(Xlogg(2,1+MaxNumResoBins))
          I2 = NINT(Xlogg(3,1+MaxNumResoBins))
          WRITE (6,FMT='(3x,A,9x,2(I8,2F7.1,F5.2,f7.2))') 
     +      'TOTAL',I1,
     +       (Xlogg(I,1+MaxNumResoBins),I=4,10,2),I2,
     +        (Xlogg(I,1+MaxNumResoBins),I=5,11,2)
C
C    Save selected stats per derivative
          IF (LAST) THEN
C
C    _phasing_MIR_der.Power_centric     Phasing_power_centric
C    _phasing_MIR_der.Power_acentric    Phasing_power_acentric 
C    _phasing_MIR_der.RCullis_centric   Cullis_R_centric(?<1.0)
C    _phasing_MIR_der.RCullis_acentric  Cullis_R_acentric(?<1.0) 
C    _phasing_MIR_der.Reflns_centric    Number_centric_reflections
C    _phasing_MIR_der.Reflns_acentric   Number_acentric_reflections 
C
           Power(1,Kderiv) = Xlogg(9,1+MaxNumResoBins)
           Power(2,Kderiv) = Xlogg(8,1+MaxNumResoBins)
           Rcullis(1,Kderiv)=Xlogg(11,1+MaxNumResoBins)
           Rcullis(2,Kderiv)=Xlogg(10,1+MaxNumResoBins)
           KReflns(1,Kderiv)=I2
           KReflns(2,Kderiv)=I1
          END IF
C
          DO 450 I1 = 4,12
            Xlogg(I1,1+MaxNumResoBins) = 0.0
  450     CONTINUE
        END IF
C
C
        IF (IRMSE.GT.0) THEN
C
C----  RMS Diso
C
          Buff(1+MaxNumResoBins,1) = 0.0
          Buff(1+MaxNumResoBins,2) = 0.0
C
C
          DO 480 NumResoBins = 1,MaxNumResoBins
            DO 470 I = 1,2
              Buff(NumResoBins,I) = 0.0
C
C
              DO 460 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +           SumSqrdFPHobsFnat(Kderiv,NumResoBins,Ifom,I)
  460         CONTINUE
C
C----  Ready for Rcullis
C
              BuffA(NumResoBins,I) = Buff(NumResoBins,I)
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
              BuffA(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I)
C
C
              IF (MBuff(NumResoBins,I).GT.0) 
     +             Buff(NumResoBins,I) = 
     +                  SQRT(ABS(Buff(NumResoBins,I)/
     +                          MBuff(NumResoBins,I)))
  470       CONTINUE
C
C
            Xlogg(4,NumResoBins) = Buff(NumResoBins,1)
            Xlogg(5,NumResoBins) = Buff(NumResoBins,2)
  480     CONTINUE
C
C
          IF (MBuff(1+MaxNumResoBins,1).GT.0) 
     +         Buff(1+MaxNumResoBins,1) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,1)/
     +                        MBuff(1+MaxNumResoBins,1)))
          IF (MBuff(1+MaxNumResoBins,2).GT.0) 
     +         Buff(1+MaxNumResoBins,2) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,2)/
     +                        MBuff(1+MaxNumResoBins,2)))
C
C
          Xlogg(4,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
          Xlogg(5,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,2)
C
C----  RMS lack of closure
C
          Buff(1+MaxNumResoBins,1)  = 0.0
          Buff(1+MaxNumResoBins,2)  = 0.0
          BuffB(1+MaxNumResoBins,1) = 0.0
          BuffB(1+MaxNumResoBins,2) = 0.0
C
C
          DO 510 NumResoBins = 1,MaxNumResoBins
            DO 500 I = 1,2
              Buff(NumResoBins,I)  = 0.0
              BuffB(NumResoBins,I) = 0.0
C
C
              DO 490 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +             SumSqrdPrFPHobsFPHcalc(Kderiv,NumResoBins,Ifom,I)
  490         CONTINUE
C
C
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
C
C----  Ready for Rcullis
C
              IF (BuffA(NumResoBins,I).GT.0.00001) 
     +            BuffA(NumResoBins,I) = 
     +                  SQRT(ABS(Buff(NumResoBins,I)/
     +                           BuffA(NumResoBins,I)))
              IF (MBuff(NumResoBins,I).GT.0) 
     +             Buff(NumResoBins,I) = 
     +                  SQRT(ABS(Buff(NumResoBins,I)/
     +                          MBuff(NumResoBins,I)))
              IF (Buff(NumResoBins,I).GT.0.00001) 
     +            BuffB(NumResoBins,I) = 
     +                  (AVFH(NumResoBins,I)/
     +                   Buff(NumResoBins,I))
  500       CONTINUE
C
C
            Xlogg(6,NumResoBins)  = Buff(NumResoBins,1)
            Xlogg(7,NumResoBins)  = Buff(NumResoBins,2)
            Xlogg(8,NumResoBins)  = BuffB(NumResoBins,1)
            Xlogg(9,NumResoBins)  = BuffB(NumResoBins,2)
            Xlogg(10,NumResoBins) = BuffA(NumResoBins,1)
            Xlogg(11,NumResoBins) = BuffA(NumResoBins,2)
  510     CONTINUE
C
C
          DO 520 I = 1,2
            IF (BuffA(1+MaxNumResoBins,I).GT.0.00001) 
     +          BuffA(1+MaxNumResoBins,I) = 
     +                  SQRT(ABS(Buff(1+MaxNumResoBins,I)/
     +                           BuffA(1+MaxNumResoBins,I)))
            IF (MBuff(1+MaxNumResoBins,I).GT.0) 
     +           Buff(1+MaxNumResoBins,I) = 
     +                  SQRT(ABS(Buff(1+MaxNumResoBins,I)/
     +                          MBuff(1+MaxNumResoBins,I)))
            IF (Buff(1+MaxNumResoBins,I).GT.0.00001) 
     +          BuffB(1+MaxNumResoBins,I) = 
     +                  (AVFH(1+MaxNumResoBins,I)/
     +                   Buff(1+MaxNumResoBins,I))
  520     CONTINUE
C
C
          Xlogg(6,1+MaxNumResoBins)  = Buff(1+MaxNumResoBins,1)
          Xlogg(7,1+MaxNumResoBins)  = Buff(1+MaxNumResoBins,2)
          Xlogg(8,1+MaxNumResoBins)  = BuffB(1+MaxNumResoBins,1)
          Xlogg(9,1+MaxNumResoBins)  = BuffB(1+MaxNumResoBins,2)
          Xlogg(10,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
          Xlogg(11,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,2)
C
C---- Lack of closure analysis using RMS
C
C----  Xloggraph stuff now.
C
          WRITE (6,FMT=9016)
 9016     FORMAT (/,
     +' Unweighted RMS lack-of-closure analysis',/,
     +' =======================================')   
          WRITE (6,FMT=6016) LAB,Kderiv
 6016     FORMAT (/,
     +' $TABLE: Lack of closure analysis  v resln using RMS - ',
     +  A,I3,':')
          WRITE (6,FMT=6014) LAB,Kderiv,LAB,Kderiv,LAB,Kderiv,LAB,
     +         Kderiv
C
C
          DO 540 NumResoBins = 1,MaxNumResoBins
            I1 = NINT(Xlogg(2,NumResoBins))
            I2 = NINT(Xlogg(3,NumResoBins))
            WRITE (6,FMT='(3x,F5.3,3x,F6.2,2(I8,2F7.1,F5.1,f7.2))') 
     +        Xlogg(1,NumResoBins),Res(NumResoBins),I1, 
     +         (Xlogg(I,NumResoBins),I=4,10,2),I2,
     +          (Xlogg(I,NumResoBins),I=5,11,2)
C
C
            DO 530 I1 = 4,12
              Xlogg(I1,NumResoBins) = 0.0
  530       CONTINUE
  540     CONTINUE
C
C
          WRITE (6,FMT=*) ' $$'
          I1 = NINT(Xlogg(2,1+MaxNumResoBins))
          I2 = NINT(Xlogg(3,1+MaxNumResoBins))
          WRITE (6,FMT='(3x,A,9x,2(I8,2F7.1,F5.1,f7.2))') 
     +       'TOTAL',I1,
     +        (Xlogg(I,1+MaxNumResoBins),I=4,10,2),I2,
     +         (Xlogg(I,1+MaxNumResoBins),I=5,11,2)
C
C
          DO 550 I1 = 4,11
            Xlogg(I1,1+MaxNumResoBins) = 0.0
  550     CONTINUE
        END IF
C
C
        IF (IW2AVE.GT.0) THEN
C
C----  Av (ABS( Diso) weighted by 1/SIGFP**2 + SIGFPh**2
C
          Buff(1+MaxNumResoBins,1) = 0.0
          Buff(1+MaxNumResoBins,2) = 0.0
C
C
          DO 580 NumResoBins = 1,MaxNumResoBins
            DO 570 I = 1,2
              Buff(NumResoBins,I) = 0.0
              DO 560 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +           SumWsigFPHobsFnat(Kderiv,NumResoBins,Ifom,I)
  560         CONTINUE
C
C----  Ready for Rcullis
C
              BuffA(NumResoBins,I) = Buff(NumResoBins,I)
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
              BuffA(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I)
C
C
              IF (VBuff(NumResoBins,I).GT.0.00001) 
     +             Buff(NumResoBins,I) = 
     +                  (Buff(NumResoBins,I)/
     +                  VBuff(NumResoBins,I))
  570       CONTINUE
            Xlogg(4,NumResoBins) = Buff(NumResoBins,1)
            Xlogg(5,NumResoBins) = Buff(NumResoBins,2)
  580     CONTINUE
C
C
          IF (VBuff(1+MaxNumResoBins,1).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,1) = 
     +                Buff(1+MaxNumResoBins,1)/
     +               VBuff(1+MaxNumResoBins,1)
          IF (VBuff(1+MaxNumResoBins,2).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,2) = 
     +                Buff(1+MaxNumResoBins,2)/
     +               VBuff(1+MaxNumResoBins,2)
C
C
          Xlogg(4,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
          Xlogg(5,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,2)
C
C----  Av (ABS( lack of closure) weighted by 1/SIGFP**2 + SIGFPh**2
C
          Buff(1+MaxNumResoBins,1)  = 0.0
          Buff(1+MaxNumResoBins,2)  = 0.0
          BuffB(1+MaxNumResoBins,1) = 0.0
          BuffB(1+MaxNumResoBins,2) = 0.0
C
C
          DO 610 NumResoBins = 1,MaxNumResoBins
            DO 600 I = 1,2
              Buff(NumResoBins,I) = 0.0
              BuffB(NumResoBins,I) = 0.0
C
C
              DO 590 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +           SumWsigLackClosure(Kderiv,NumResoBins,Ifom,I)
  590         CONTINUE
C
C
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
C
C----  Ready for Rcullis
C
              IF (BuffA(NumResoBins,I).GT.0.00001) 
     +            BuffA(NumResoBins,I) = 
     +                  (Buff(NumResoBins,I)/
     +                   BuffA(NumResoBins,I))
              IF (VBuff(NumResoBins,I).GT.0.00001) 
     +             Buff(NumResoBins,I) = 
     +                  (Buff(NumResoBins,I)/
     +                  VBuff(NumResoBins,I))
              IF (Buff(NumResoBins,I).GT.0.00001) 
     +            BuffB(NumResoBins,I) = 
     +                  (AVFH(NumResoBins,I)/
     +                   Buff(NumResoBins,I))
  600       CONTINUE
C
C
            Xlogg(6,NumResoBins)  = Buff(NumResoBins,1)
            Xlogg(7,NumResoBins)  = Buff(NumResoBins,2)
            Xlogg(8,NumResoBins)  = BuffB(NumResoBins,1)
            Xlogg(9,NumResoBins)  = BuffB(NumResoBins,2)
            Xlogg(10,NumResoBins) = BuffA(NumResoBins,1)
            Xlogg(11,NumResoBins) = BuffA(NumResoBins,2)
  610     CONTINUE
C
C
          DO 620 I = 1,2
            IF (BuffA(1+MaxNumResoBins,I).GT.0.00001) 
     +          BuffA(1+MaxNumResoBins,I) = 
     +                 (Buff(1+MaxNumResoBins,I)/
     +                  BuffA(1+MaxNumResoBins,I))
            IF (VBuff(1+MaxNumResoBins,I).GT.0.00001) 
     +           Buff(1+MaxNumResoBins,I) = 
     +                  Buff(1+MaxNumResoBins,I)/
     +                 VBuff(1+MaxNumResoBins,I)
            IF (Buff(1+MaxNumResoBins,I).GT.0.00001) 
     +          BuffB(1+MaxNumResoBins,I) = 
     +                 (AVFH(1+MaxNumResoBins,I)/
     +                  Buff(1+MaxNumResoBins,I))
  620     CONTINUE
C
C
          Xlogg(6,1+MaxNumResoBins)  = Buff(1+MaxNumResoBins,1)
          Xlogg(7,1+MaxNumResoBins)  = Buff(1+MaxNumResoBins,2)
          Xlogg(8,1+MaxNumResoBins)  = BuffB(1+MaxNumResoBins,1)
          Xlogg(9,1+MaxNumResoBins)  = BuffB(1+MaxNumResoBins,2)
          Xlogg(10,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
          Xlogg(11,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,2)
C
C----  Xloggraph stuff now.
C
C      Weighted MEAN lack-of-closure
C
          WRITE (6,FMT=9018)
 9018     FORMAT (/,
     +' Weighted (W2) MEAN lack-of-closure analysis',/,
     +' ===========================================')
             WRITE (6,FMT=6018) LAB,Kderiv
 6018     FORMAT (/,
     +' $TABLE: Lack of closure analysis  v resln using MEAN_W2 - ',
     +  A,I3,':')
          WRITE (6,FMT=6014) LAB,Kderiv,LAB,Kderiv,LAB,Kderiv,LAB,
     +         Kderiv
C
C
          DO 640 NumResoBins = 1,MaxNumResoBins
            I1 = NINT(Xlogg(2,NumResoBins))
            I2 = NINT(Xlogg(3,NumResoBins))
            WRITE (6,FMT='(3x,F5.3,3x,F6.2,2(I8,2F7.1,F5.1,f7.2))') 
     +         Xlogg(1,NumResoBins),Res(NumResoBins),I1, 
     +         (Xlogg(I,NumResoBins),I=4,10,2),I2,
     +          (Xlogg(I,NumResoBins),I=5,11,2)
C
C
            DO 630 I1 = 4,12
              Xlogg(I1,NumResoBins) = 0.0
  630       CONTINUE
  640     CONTINUE
C
C
          WRITE (6,FMT=*) ' $$'
          I1 = NINT(Xlogg(2,1+MaxNumResoBins))
          I2 = NINT(Xlogg(3,1+MaxNumResoBins))
          WRITE (6,FMT='(3x,A,9x,2(I8,2F7.1,F5.1,f7.2))') 
     +      'TOTAL',I1,
     +       (Xlogg(I,1+MaxNumResoBins),I=4,10,2),I2,
     +        (Xlogg(I,1+MaxNumResoBins),I=5,11,2)
C
C
          DO 650 I1 = 4,11
            Xlogg(I1,1+MaxNumResoBins) = 0.0
  650     CONTINUE
        END IF
C
C
        IF (IW2RMS.GT.0) THEN
C
C----  Rms ( Diso) weighted by 1/SIGFP**2 + SIGFPh**2
C
          Buff(1+MaxNumResoBins,1) = 0.0
          Buff(1+MaxNumResoBins,2) = 0.0
C
C
          DO 680 NumResoBins = 1,MaxNumResoBins
            DO 670 I = 1,2
              Buff(NumResoBins,I) = 0.0
C
C
              DO 660 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +           SumSqrdWsigFPHobsFnat(Kderiv,NumResoBins,Ifom,I)
  660         CONTINUE
C
C----  Ready for Rcullis
C
              BuffA(NumResoBins,I) = Buff(NumResoBins,I)
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
              BuffA(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I)
C
C
              IF (VBuff(NumResoBins,I).GT.0.00001) 
     +             Buff(NumResoBins,I) = 
     +                  SQRT(ABS(Buff(NumResoBins,I)/
     +                          VBuff(NumResoBins,I)))
  670       CONTINUE
C
C
            Xlogg(4,NumResoBins) = Buff(NumResoBins,1)
            Xlogg(5,NumResoBins) = Buff(NumResoBins,2)
  680     CONTINUE
C
C
          IF (VBuff(1+MaxNumResoBins,1).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,1) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,1)/
     +                        VBuff(1+MaxNumResoBins,1)))
          IF (VBuff(1+MaxNumResoBins,2).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,2) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,2)/
     +                        VBuff(1+MaxNumResoBins,2)))
C
C
          Xlogg(4,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
          Xlogg(5,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,2)
C
C----  RMS ( lack of closure) weighted by 1/SIGFP**2 + SIGFPh**2
C
          Buff(1+MaxNumResoBins,1) = 0.0
          Buff(1+MaxNumResoBins,2) = 0.0
          BuffB(1+MaxNumResoBins,1) = 0.0
          BuffB(1+MaxNumResoBins,2) = 0.0
C
C
          DO 710 NumResoBins = 1,MaxNumResoBins
            DO 700 I = 1,2
              Buff(NumResoBins,I) = 0.0
              BuffB(NumResoBins,I) = 0.0
C
C
              DO 690 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +           SumLackClosureWgtSqrd(Kderiv,NumResoBins,Ifom,I)
  690         CONTINUE
C
C
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
C
C----  Ready for Rcullis
C
              IF (BuffA(NumResoBins,I).GT.0.00001) 
     +            BuffA(NumResoBins,I) = 
     +                  SQRT(ABS(Buff(NumResoBins,I)/
     +                           BuffA(NumResoBins,I)))
              IF (VBuff(NumResoBins,I).GT.0.00001) 
     +             Buff(NumResoBins,I) = 
     +                  SQRT(ABS(Buff(NumResoBins,I)/
     +                          VBuff(NumResoBins,I)))
              IF (Buff(NumResoBins,I).GT.0.00001) 
     +            BuffB(NumResoBins,I) = 
     +                  (AVFH(NumResoBins,I)/
     +                   Buff(NumResoBins,I))
  700       CONTINUE
C
C
            Xlogg(6,NumResoBins)  = Buff(NumResoBins,1)
            Xlogg(7,NumResoBins)  = Buff(NumResoBins,2)
            Xlogg(8,NumResoBins)  = BuffB(NumResoBins,1)
            Xlogg(9,NumResoBins)  = BuffB(NumResoBins,2)
            Xlogg(10,NumResoBins) = BuffA(NumResoBins,1)
            Xlogg(11,NumResoBins) = BuffA(NumResoBins,2)
  710     CONTINUE
C
C
          IF (BuffA(1+MaxNumResoBins,1).GT.0.00001) 
     +        BuffA(1+MaxNumResoBins,1) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,1)/
     +                         BuffA(1+MaxNumResoBins,1)))
          IF (BuffA(1+MaxNumResoBins,2).GT.0.00001) 
     +        BuffA(1+MaxNumResoBins,2) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,2)/
     +                         BuffA(1+MaxNumResoBins,2)))
          IF (VBuff(1+MaxNumResoBins,1).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,1) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,1)/
     +                        VBuff(1+MaxNumResoBins,1)))
          IF (VBuff(1+MaxNumResoBins,2).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,2) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,2)/
     +                        VBuff(1+MaxNumResoBins,2)))
          IF (Buff(1+MaxNumResoBins,1).GT.0.00001) 
     +        BuffB(1+MaxNumResoBins,1) = 
     +               (AVFH(1+MaxNumResoBins,1)/
     +                Buff(1+MaxNumResoBins,1))
          IF (Buff(1+MaxNumResoBins,2).GT.0.00001) 
     +        BuffB(1+MaxNumResoBins,2) = 
     +                (AVFH(1+MaxNumResoBins,2)/
     +                 Buff(1+MaxNumResoBins,2))
C
C
          Xlogg(6,1+MaxNumResoBins)  = Buff(1+MaxNumResoBins,1)
          Xlogg(7,1+MaxNumResoBins)  = Buff(1+MaxNumResoBins,2)
          Xlogg(8,1+MaxNumResoBins)  = BuffB(1+MaxNumResoBins,1)
          Xlogg(9,1+MaxNumResoBins)  = BuffB(1+MaxNumResoBins,2)
          Xlogg(10,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
          Xlogg(11,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,2)
C
C----  Xloggraph stuff now.
C
C      Weighted RMS lack-of-closure
C
          WRITE (6,FMT=9020)
 9020     FORMAT (/,
     +' Weighted (W2) RMS lack-of-closure analysis',/,
     +' ===========================================')

          WRITE (6,FMT=6020) LAB,Kderiv
 6020     FORMAT (/,
     +' $TABLE: Lack of closure analysis  v resln using RMS_W2 - ',
     +  A,I3,':')
          WRITE (6,FMT=6014) LAB,Kderiv,
     +                        LAB,Kderiv,
     +                         LAB,Kderiv,
     +                          LAB,Kderiv
C
C
          DO 730 NumResoBins = 1,MaxNumResoBins
            I1 = NINT(Xlogg(2,NumResoBins))
            I2 = NINT(Xlogg(3,NumResoBins))
            WRITE (6,FMT='(3x,F5.3,3x,F6.2,2(I8,2F7.1,F5.1,f7.2))') 
     +         Xlogg(1,NumResoBins),Res(NumResoBins),I1, 
     +          (Xlogg(I,NumResoBins),I=4,10,2),I2,
     +           (Xlogg(I,NumResoBins),I=5,11,2)
C
C
            DO 720 I1 = 4,12
              Xlogg(I1,NumResoBins) = 0.0
  720       CONTINUE
  730     CONTINUE
C
C
          WRITE (6,FMT=*) ' $$'
          I1 = NINT(Xlogg(2,1+MaxNumResoBins))
          I2 = NINT(Xlogg(3,1+MaxNumResoBins))
          WRITE (6,FMT='(3x,A,9x,2(I8,2F7.1,F5.1,f7.2))') 
     +      'TOTAL',I1,
     +       (Xlogg(I,1+MaxNumResoBins),I=4,10,2),I2,
     +        (Xlogg(I,1+MaxNumResoBins),I=5,11,2)
C
C
          DO 740 I1 = 4,11
            Xlogg(I1,1+MaxNumResoBins) = 0.0
  740     CONTINUE
        END IF
C
C----  Av ABS( Diso) weighted by old weight  ( W1)
C
        IF (IW1AVE.GT.0) THEN
          Buff(1+MaxNumResoBins,1) = 0.0
          Buff(1+MaxNumResoBins,2) = 0.0
C
C
          DO 770 NumResoBins = 1,MaxNumResoBins
            DO 760 I = 1,2
              Buff(NumResoBins,I) = 0.0
              DO 750 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +           SumW1FPHobsFnat(Kderiv,NumResoBins,Ifom,I)
  750         CONTINUE
C
C----  Ready for Rcullis
C
              BuffA(NumResoBins,I) = Buff(NumResoBins,I)
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
              BuffA(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I)
C
C
              IF (WBuff(NumResoBins,I).GT.0.00001) 
     +             Buff(NumResoBins,I) = 
     +                  (Buff(NumResoBins,I)/WBuff(NumResoBins,I))
  760       CONTINUE
            Xlogg(4,NumResoBins) = Buff(NumResoBins,1)
            Xlogg(5,NumResoBins) = Buff(NumResoBins,2)
  770     CONTINUE
C
C
          IF (WBuff(1+MaxNumResoBins,1).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,1) = 
     +                Buff(1+MaxNumResoBins,1)/
     +               WBuff(1+MaxNumResoBins,1)
          IF (WBuff(1+MaxNumResoBins,2).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,2) = 
     +                Buff(1+MaxNumResoBins,2)/
     +               WBuff(1+MaxNumResoBins,2)
C
C
          Xlogg(4,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
          Xlogg(5,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,2)
C
C----  Av Abs( lack of closure) weighted by old weight  ( W1)
C
          Buff(1+MaxNumResoBins,1)  = 0.0
          Buff(1+MaxNumResoBins,2)  = 0.0
          BuffB(1+MaxNumResoBins,1) = 0.0
          BuffB(1+MaxNumResoBins,2) = 0.0
C
C
          DO 800 NumResoBins = 1,MaxNumResoBins
            DO 790 I = 1,2
              Buff(NumResoBins,I) = 0.0
              BuffB(NumResoBins,I) = 0.0
              DO 780 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +             SumWghtFPHobsFPHcalc(Kderiv,NumResoBins,Ifom,I)
  780         CONTINUE
C
C
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
C
C----  Ready for Rcullis
C
              IF (BuffA(NumResoBins,I).GT.0.00001) 
     +            BuffA(NumResoBins,I) = 
     +                  (Buff(NumResoBins,I)/BuffA(NumResoBins,I))
              IF (WBuff(NumResoBins,I).GT.0.00001) 
     +             Buff(NumResoBins,I) = 
     +                  (Buff(NumResoBins,I)/WBuff(NumResoBins,I))
              IF (Buff(NumResoBins,I).GT.0.00001) 
     +            BuffB(NumResoBins,I) = 
     +                  (AVFH(NumResoBins,I)/Buff(NumResoBins,I))
  790       CONTINUE
C
C
            Xlogg(6,NumResoBins) = Buff(NumResoBins,1)
            Xlogg(7,NumResoBins) = Buff(NumResoBins,2)
            Xlogg(8,NumResoBins) = BuffB(NumResoBins,1)
            Xlogg(9,NumResoBins) = BuffB(NumResoBins,2)
            Xlogg(10,NumResoBins) = BuffA(NumResoBins,1)
            Xlogg(11,NumResoBins) = BuffA(NumResoBins,2)
  800     CONTINUE
C
C
          IF (BuffA(1+MaxNumResoBins,1).GT.0.00001) 
     +        BuffA(1+MaxNumResoBins,1) = 
     +               (Buff(1+MaxNumResoBins,1)/
     +                BuffA(1+MaxNumResoBins,1))
          IF (BuffA(1+MaxNumResoBins,2).GT.0.00001) 
     +        BuffA(1+MaxNumResoBins,2) = 
     +               (Buff(1+MaxNumResoBins,2)/
     +                BuffA(1+MaxNumResoBins,2))
          IF (WBuff(1+MaxNumResoBins,1).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,1) = 
     +               (Buff(1+MaxNumResoBins,1)/
     +               WBuff(1+MaxNumResoBins,1))
          IF (WBuff(1+MaxNumResoBins,2).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,2) = 
     +                Buff(1+MaxNumResoBins,2)/
     +               WBuff(1+MaxNumResoBins,2)
          IF (Buff(1+MaxNumResoBins,1).GT.0.00001) 
     +        BuffB(1+MaxNumResoBins,1) = 
     +               (AVFH(1+MaxNumResoBins,1)/
     +                Buff(1+MaxNumResoBins,1))
          IF (Buff(1+MaxNumResoBins,2).GT.0.00001) 
     +        BuffB(1+MaxNumResoBins,2) = 
     +                (AVFH(1+MaxNumResoBins,2)/
     +                 Buff(1+MaxNumResoBins,2))
C
C
          Xlogg(6,1+MaxNumResoBins)  = Buff(1+MaxNumResoBins,1)
          Xlogg(7,1+MaxNumResoBins)  = Buff(1+MaxNumResoBins,2)
          Xlogg(8,1+MaxNumResoBins)  = BuffB(1+MaxNumResoBins,1)
          Xlogg(9,1+MaxNumResoBins)  = BuffB(1+MaxNumResoBins,2)
          Xlogg(10,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
          Xlogg(11,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,2)
C
C
C
C----  Xloggraph stuff now.
C
C      Weighted MEAN lack-of-closure
C
          WRITE (6,FMT=9022)
 9022     FORMAT (/,
     +' Weighted (W1) MEAN lack-of-closure analysis',/,
     +' ===========================================')
          WRITE (6,FMT=6022) LAB,Kderiv
 6022     FORMAT (/,
     +' $TABLE: Lack of closure analysis  v resln using MEAN_W1 - ',
     +      A,I3,':')
          WRITE (6,FMT=6014) LAB,Kderiv,LAB,Kderiv,LAB,Kderiv,LAB,
     +         Kderiv
C
C
          DO 820 NumResoBins = 1,MaxNumResoBins
            I1 = NINT(Xlogg(2,NumResoBins))
            I2 = NINT(Xlogg(3,NumResoBins))
            WRITE (6,FMT='(3x,F5.3,3x,F6.2,2(I8,2F7.1,F5.1,f7.2))') 
     +         Xlogg(1,NumResoBins),Res(NumResoBins),I1, 
     +          (Xlogg(I,NumResoBins),I=4,10,2),I2,
     +           (Xlogg(I,NumResoBins),I=5,11,2)
C
C
            DO 810 I1 = 4,12
              Xlogg(I1,NumResoBins) = 0.0
  810       CONTINUE
  820     CONTINUE
C
C
          WRITE (6,FMT=*) ' $$'
          I1 = NINT(Xlogg(2,1+MaxNumResoBins))
          I2 = NINT(Xlogg(3,1+MaxNumResoBins))
          WRITE (6,FMT='(3x,A,9x,2(I8,2F7.1,F5.1,f7.2))') 
     +       'TOTAL',I1,
     +        (Xlogg(I,1+MaxNumResoBins),I=4,10,2),I2,
     +         (Xlogg(I,1+MaxNumResoBins),I=5,11,2)
C
C
          DO 830 I1 = 4,11
            Xlogg(I1,1+MaxNumResoBins) = 0.0
  830     CONTINUE
        END IF
C
C
        IF (IW1RMS.GT.0) THEN
C
C----  RMS ( Diso) weighted by old weight  ( W1)
C
          Buff(1+MaxNumResoBins,1) = 0.0
          Buff(1+MaxNumResoBins,2) = 0.0
C
C
          DO 860 NumResoBins = 1,MaxNumResoBins
            DO 850 I = 1,2
              Buff(NumResoBins,I) = 0.0
C
C
              DO 840 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +           SumW1FPHobsFnatSqrd(Kderiv,NumResoBins,Ifom,I)
  840         CONTINUE
C
C----  Ready for Rcullis
C
              BuffA(NumResoBins,I) = Buff(NumResoBins,I)
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
              BuffA(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I)
C
C
              IF (WBuff(NumResoBins,I).GT.0.00001) 
     +             Buff(NumResoBins,I) = 
     +                  SQRT(ABS(Buff(NumResoBins,I)/
     +                          WBuff(NumResoBins,I)))
  850       CONTINUE
C
C
            Xlogg(4,NumResoBins) = Buff(NumResoBins,1)
            Xlogg(5,NumResoBins) = Buff(NumResoBins,2)
  860     CONTINUE
C
C
          IF (WBuff(1+MaxNumResoBins,1).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,1) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,1)/
     +                        WBuff(1+MaxNumResoBins,1)))
          IF (WBuff(1+MaxNumResoBins,2).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,2) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,2)/
     +                        WBuff(1+MaxNumResoBins,2)))
C
C
          Xlogg(4,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
          Xlogg(5,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,2)
C
C
C----  RMS ( lack of closure) weighted by old weight  ( W1)
C
          Buff(1+MaxNumResoBins,1)  = 0.0
          Buff(1+MaxNumResoBins,2)  = 0.0
          BuffB(1+MaxNumResoBins,1) = 0.0
          BuffB(1+MaxNumResoBins,2) = 0.0
C
C
          DO 890 NumResoBins = 1,MaxNumResoBins
            DO 880 I = 1,2
              Buff(NumResoBins,I) = 0.0
              BuffB(NumResoBins,I) = 0.0
C
C
              DO 870 Ifom = 1,MaxNumFigMeritBins
                Buff(NumResoBins,I) = Buff(NumResoBins,I) +
     +           SumW1SqrdLackClosure(Kderiv,NumResoBins,Ifom,I)
  870         CONTINUE
C
C
              Buff(1+MaxNumResoBins,I) = Buff(1+MaxNumResoBins,I) +
     +                                   Buff(NumResoBins,I)
C
C----  Ready for Rcullis
C
              IF (BuffA(NumResoBins,I).GT.0.00001) 
     +            BuffA(NumResoBins,I) = 
     +                  SQRT(ABS(Buff(NumResoBins,I)/
     +                           BuffA(NumResoBins,I)))
              IF (WBuff(NumResoBins,I).GT.0.00001) 
     +            Buff(NumResoBins,I) = 
     +                 SQRT(ABS(Buff(NumResoBins,I)/
     +                         WBuff(NumResoBins,I)))
              IF (Buff(NumResoBins,I).GT.0.00001) 
     +            BuffB(NumResoBins,I) = 
     +                  (AVFH(NumResoBins,I)/
     +                   Buff(NumResoBins,I))
  880       CONTINUE
C
C
            Xlogg(6,NumResoBins)  = Buff(NumResoBins,1)
            Xlogg(7,NumResoBins)  = Buff(NumResoBins,2)
            Xlogg(8,NumResoBins)  = BuffB(NumResoBins,1)
            Xlogg(9,NumResoBins)  = BuffB(NumResoBins,2)
            Xlogg(10,NumResoBins) = BuffA(NumResoBins,1)
            Xlogg(11,NumResoBins) = BuffA(NumResoBins,2)
  890     CONTINUE
C
C
          IF (BuffA(1+MaxNumResoBins,1).GT.0.00001) 
     +        BuffA(1+MaxNumResoBins,1) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,1)/
     +                         BuffA(1+MaxNumResoBins,1)))
          IF (BuffA(1+MaxNumResoBins,2).GT.0.00001) 
     +        BuffA(1+MaxNumResoBins,2) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,2)/
     +                         BuffA(1+MaxNumResoBins,2)))
          IF (WBuff(1+MaxNumResoBins,1).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,1) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,1)/
     +                        WBuff(1+MaxNumResoBins,1)))
          IF (WBuff(1+MaxNumResoBins,2).GT.0.00001) 
     +         Buff(1+MaxNumResoBins,2) = 
     +                SQRT(ABS(Buff(1+MaxNumResoBins,2)/
     +                        WBuff(1+MaxNumResoBins,2)))
          IF (Buff(1+MaxNumResoBins,1).GT.0.00001) 
     +        BuffB(1+MaxNumResoBins,1) = 
     +                (AVFH(1+MaxNumResoBins,1)/
     +                 Buff(1+MaxNumResoBins,1))
          IF (Buff(1+MaxNumResoBins,2).GT.0.00001) 
     +        BuffB(1+MaxNumResoBins,2) = 
     +                (AVFH(1+MaxNumResoBins,2)/
     +                 Buff(1+MaxNumResoBins,2))
C
C
          Xlogg(6,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
          Xlogg(7,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,2)
          Xlogg(8,1+MaxNumResoBins) = BuffB(1+MaxNumResoBins,1)
          Xlogg(9,1+MaxNumResoBins) = BuffB(1+MaxNumResoBins,2)
          Xlogg(10,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
          Xlogg(11,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,2)
C
C----  Xloggraph stuff now.
C
C      Weighted MEAN lack-of-closure
C
          WRITE (6,FMT=9024)
 9024     FORMAT (/,
     +' Weighted (W1) RMS lack-of-closure analysis',/,
     +' ===========================================')
          WRITE (6,FMT=6024) LAB,Kderiv
 6024     FORMAT (/,
     +' $TABLE: Lack of closure analysis  v resln using RMS_W1 - ',
     +       A,I3,':')
          WRITE (6,FMT=6014) LAB,Kderiv,LAB,Kderiv,LAB,Kderiv,LAB,
     +         Kderiv
C
C
          DO 910 NumResoBins = 1,MaxNumResoBins
            I1 = NINT(Xlogg(2,NumResoBins))
            I2 = NINT(Xlogg(3,NumResoBins))
            WRITE (6,FMT='(3x,F5.3,3x,F6.2,2(I8,2F7.1,F5.1,f7.2))') 
     +         Xlogg(1,NumResoBins),Res(NumResoBins),I1, 
     +          (Xlogg(I,NumResoBins),I=4,10,2),I2,
     +           (Xlogg(I,NumResoBins),I=5,11,2)
C
C
            DO 900 I1 = 4,12
              Xlogg(I1,NumResoBins) = 0.0
  900       CONTINUE
  910     CONTINUE
C
C
          WRITE (6,FMT=*) ' $$'
          I1 = NINT(Xlogg(2,1+MaxNumResoBins))
          I2 = NINT(Xlogg(3,1+MaxNumResoBins))
          WRITE (6,FMT='(3x,A,9x,2(I8,2F7.1,F5.1,f7.2))') 
     +      'TOTAL',I1,
     +       (Xlogg(I,1+MaxNumResoBins),I=4,10,2),I2,
     +        (Xlogg(I,1+MaxNumResoBins),I=5,11,2)
C
C
          DO 920 I1 = 4,11
            Xlogg(I1,1+MaxNumResoBins) = 0.0
  920     CONTINUE
        END IF
C
C----   Finished Iso terms??
C       Check anomalous errors
C
C     Process anomalous dispersion if any
C
C  Av (ABS( anomalous differenc of closure)
C
        IF (LANOM(Kderiv)) THEN

          WRITE (6,FMT='(/,a,/,a,i3,/,a)')
     +      ' *******************************************************',
     +      ' Analysis of anomalous phasing for Derivative',Kderiv,
     +      ' *******************************************************'
C
C---- Header for any lack of closure analysis requested by
C     the user
C
          IF (IAVE.GT.0 .OR. IRMSE.GT.0 .OR. IW1RMS.GT.0
     +       .OR. IW2RMS.GT.0 .OR. IW1AVE.GT.0 .OR.
     +       IW2AVE.GT.0 ) THEN
            WRITE (6,FMT=9100)
 9100       FORMAT (//,
     +' ========================================================',/,
     +' 5. Lack of closure analyses on anomalous differences',//,
     +' This includes the anomalous difference, the expected',/,
     +' calculated anomalous lack of closure, the anomalous',/,
     +' lack of closure (i.e. the difference between DPH and',/,
     +' DPHcalc, and a "Cullis Rfactor" extended from the old',/,
     +' definition to be:',/,
     +' (Lack_of_closure / Anomalous_difference)')
          END IF
C
C
          IF (IAVE.NE.0) THEN
            MBuffA(1+MaxNumResoBins) = 0
            BuffA(1+MaxNumResoBins,1) = 0.0
C
C
            DO 940 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
C
C
              DO 930 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                                 SAADO(Kderiv,NumResoBins,Ifom)
  930         CONTINUE
C
C
              MBuffA(1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins) +
     +                                   MBuffA(NumResoBins)
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
C
C
              IF (MBuffA(NumResoBins).GT.0) 
     +             BuffA(NumResoBins,1) = 
     +                   (BuffA(NumResoBins,1)/
     +                   MBuffA(NumResoBins))
C
C
              Xlogg(2,NumResoBins) = MBuffA(NumResoBins)
              Xlogg(3,NumResoBins) = BuffA(NumResoBins,1)
  940       CONTINUE
C
C
            IF (MBuffA(1+MaxNumResoBins).GT.0) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                  (BuffA(1+MaxNumResoBins,1)/
     +                  MBuffA(1+MaxNumResoBins))
            Xlogg(2,1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins)
            Xlogg(3,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
C
C-----  Av (ABS( calculated anomalous difference)
C
            BuffA(1+MaxNumResoBins,1) = 0.0
C
C
            DO 960 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
C
C
              DO 950 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                                 SAADC(Kderiv,NumResoBins,Ifom)
  950         CONTINUE
C
C
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
C
C
              IF (MBuffA(NumResoBins).GT.0) 
     +             BuffA(NumResoBins,1) = 
     +                   (BuffA(NumResoBins,1)/
     +                   MBuffA(NumResoBins))
              Xlogg(4,NumResoBins) = BuffA(NumResoBins,1)
  960       CONTINUE
C
C
            IF (MBuffA(1+MaxNumResoBins).GT.0) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                  (BuffA(1+MaxNumResoBins,1)/
     +                  MBuffA(1+MaxNumResoBins))
            Xlogg(4,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
C
C----   (Average( anomalous error
C
            BuffA(1+MaxNumResoBins,1) = 0.0
            Buff(1+MaxNumResoBins,1) = 0.0
C
C
            DO 980 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
              Buff(NumResoBins,1) = 0.0
C
C
              DO 970 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                                 SLCA(Kderiv,NumResoBins,Ifom)
C
C---- Pseudo Anom "Cullis Rfactor"
C
                Buff(NumResoBins,1) = Buff(NumResoBins,1) +
     +                                SAADO(Kderiv,NumResoBins,Ifom)
  970         CONTINUE
C
C
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
              Buff(1+MaxNumResoBins,1) = Buff(1+MaxNumResoBins,1) +
     +                                   Buff(NumResoBins,1)
C
C
              IF (Buff(NumResoBins,1).GT.0.00001) 
     +            Buff(NumResoBins,1) = 
     +                 (BuffA(NumResoBins,1)/Buff(NumResoBins,1))
              IF (MBuffA(NumResoBins).GT.0) 
     +             BuffA(NumResoBins,1) = 
     +                   (BuffA(NumResoBins,1)/MBuffA(NumResoBins))
C
C
              Xlogg(5,NumResoBins) = BuffA(NumResoBins,1)
              Xlogg(6,NumResoBins) = Buff(NumResoBins,1)
  980       CONTINUE
C
C
            IF (Buff(1+MaxNumResoBins,1).GT.0.00001) 
     +          Buff(1+MaxNumResoBins,1) = 
     +                (BuffA(1+MaxNumResoBins,1)/
     +                 Buff(1+MaxNumResoBins,1))
            IF (MBuffA(1+MaxNumResoBins).GT.0) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                   (BuffA(1+MaxNumResoBins,1)/
     +                   MBuffA(1+MaxNumResoBins))
C
C
            Xlogg(5,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
            Xlogg(6,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
C
C
C---- Anomalous lack of closure analyses using MEAN
C
          WRITE (6,FMT=9026)
 9026     FORMAT (/,
     +' Unweighted MEAN anomalous lack-of-closure analysis',/,
     +' ==================================================')
            WRITE (6,FMT=6026) LAB,Kderiv
 6026       FORMAT (/,
     +' $TABLE: Anomalous lack of closure  analysis  v resln ',
     +         'using MEANS- ',A,I3,':',/)
            WRITE (6,FMT=6028) LAB,Kderiv,LAB,Kderiv
 6028       FORMAT (
     +' $GRAPHS ',
     +':Ano "Cullis Rfactor"  for ',A,I3,':N:1,6:',/,
     +' :<Ano_diffs - obs and calc >',/,
     +'-< Ano_lack_of_Closure -  ',A,I3,':N:1,3,4,5:',/,
     +' $$ 1/resol^2 ',/' Number_acentric_reflections ',/,
     +' Anomalous_difference_obs ',/,
     +' Anomalous_difference_calc ',/,
     +'  Lack_of_ano_closure ',/,
     +' Cullis_R_anomalous $$ ',/,
     +' 1/resol^2 Nref_a DANO_obs DANO_calc LOC_ano CullR_ano $$')
C
C
            DO 1000 NumResoBins = 1,MaxNumResoBins
              I1 = NINT(Xlogg(2,NumResoBins))
              WRITE (6,FMT='(3x,F5.3,I8,2F8.1,2x,2F8.2)') 
     +          Xlogg(1,NumResoBins),I1, 
     +           (Xlogg(I,NumResoBins),I=3,6)
              DO 990 I1 = 3,11
                Xlogg(I1,NumResoBins) = 0.0
  990         CONTINUE
 1000       CONTINUE
C
C
            WRITE (6,FMT=*) ' $$'
            I1 = NINT(Xlogg(2,1+MaxNumResoBins))
            WRITE (6,FMT='(3x,a,I8,2F8.1,2x,2F8.2)') 
     +        'TOTAL',I1,
     +         (Xlogg(I,1+MaxNumResoBins),I=3,6)
C
C    Save selected stats per derivative
            IF (LAST) THEN
C     _phasing_MIR_der.RCullis_anomalous
C     _phasing_MIR_der.Reflns_acentric  (anomalous ?)
              Rcullis(3,Kderiv)=Xlogg(6,1+MaxNumResoBins)
              KReflns(3,Kderiv)=I1
            END IF
C
            DO 1010 I1 = 3,11
              Xlogg(I1,1+MaxNumResoBins) = 0.0
 1010       CONTINUE
          END IF
C
C----  RMS anomalous difference
C
          IF (IRMSE.GT.0) THEN
            MBuffA(1+MaxNumResoBins) = 0
            BuffA(1+MaxNumResoBins,1) = 0.0
C
C
            DO 1030 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
              DO 1020 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                                 SADOSQ(Kderiv,NumResoBins,Ifom)
 1020         CONTINUE
C
C
              MBuffA(1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins) +
     +                                   MBuffA(NumResoBins)
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
C
C
              IF (MBuffA(NumResoBins).GT.0) 
     +             BuffA(NumResoBins,1) = 
     +                   SQRT(ABS(BuffA(NumResoBins,1)/
     +                           MBuffA(NumResoBins)))
              Xlogg(2,NumResoBins) = MBuffA(NumResoBins)
              Xlogg(3,NumResoBins) = BuffA(NumResoBins,1)
 1030       CONTINUE
C
C
            IF (MBuffA(1+MaxNumResoBins).GT.0) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                   SQRT(ABS(BuffA(1+MaxNumResoBins,1)/
     +                           MBuffA(1+MaxNumResoBins)))
            Xlogg(2,1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins)
            Xlogg(3,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
C
C----  RMS calculated anomalous difference
C
            BuffA(1+MaxNumResoBins,1) = 0.0
C
C
            DO 1050 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
C
C
              DO 1040 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                                 SADCSQ(Kderiv,NumResoBins,Ifom)
 1040         CONTINUE
C
C
              MBuffA(1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins) +
     +                                   MBuffA(NumResoBins)
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
C
C
              IF (MBuffA(NumResoBins).GT.0) 
     +             BuffA(NumResoBins,1) = 
     +                   SQRT(ABS(BuffA(NumResoBins,1)/
     +                           MBuffA(NumResoBins)))
              Xlogg(4,NumResoBins) = BuffA(NumResoBins,1)
 1050       CONTINUE
C
C
            IF (MBuffA(1+MaxNumResoBins).GT.0) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                   SQRT(ABS(BuffA(1+MaxNumResoBins,1)/
     +                           MBuffA(1+MaxNumResoBins)))
            Xlogg(4,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
C
C----   (Rms( anomalous error
C
            BuffA(1+MaxNumResoBins,1) = 0.0
            Buff(1+MaxNumResoBins,1)  = 0.0
C
C
            DO 1070 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
              Buff(NumResoBins,1)  = 0.0
C
C
              DO 1060 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                                 SLCAQ(Kderiv,NumResoBins,Ifom)
C
C---- Pseudo Anom "Cullis Rfactor"
C
                Buff(NumResoBins,1) = Buff(NumResoBins,1) +
     +                                SADOSQ(Kderiv,NumResoBins,Ifom)
 1060         CONTINUE
C
C
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
              Buff(1+MaxNumResoBins,1) = Buff(1+MaxNumResoBins,1) +
     +                                   Buff(NumResoBins,1)
C
C
              IF (Buff(NumResoBins,1).GT.0.00001) 
     +            Buff(NumResoBins,1) = 
     +                 SQRT(ABS(BuffA(NumResoBins,1)/
     +                          Buff(NumResoBins,1)))
              IF (MBuffA(NumResoBins).GT.0) 
     +             BuffA(NumResoBins,1) = 
     +                   SQRT(ABS(BuffA(NumResoBins,1)/
     +                           MBuffA(NumResoBins)))
C
C
              Xlogg(5,NumResoBins) = BuffA(NumResoBins,1)
              Xlogg(6,NumResoBins) = Buff(NumResoBins,1)
 1070       CONTINUE
C
C
            IF (Buff(1+MaxNumResoBins,1).GT.0.00001) 
     +          Buff(1+MaxNumResoBins,1) = 
     +                 SQRT(ABS(BuffA(1+MaxNumResoBins,1)/
     +                          Buff(1+MaxNumResoBins,1)))
            IF (MBuffA(1+MaxNumResoBins).GT.0) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                   SQRT(ABS(BuffA(1+MaxNumResoBins,1)/
     +                           MBuffA(1+MaxNumResoBins)))
C
C
            Xlogg(5,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
            Xlogg(6,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
C
C
C---- Anomalous lack of closure analyses using RMS
C
          WRITE (6,FMT=9030)
 9030     FORMAT (/,
     +' Unweighted RMS anomalous lack-of-closure analysis',/,
     +' =================================================')
            WRITE (6,FMT=6030) LAB,Kderiv
 6030       FORMAT (/,
     +' $TABLE: Anomalous lack of closure  analysis  v resln ',
     +       'using RMS- ',A,I3,':',/)
            WRITE (6,FMT=6028) LAB,Kderiv,LAB,Kderiv
C
C
            DO 1090 NumResoBins = 1,MaxNumResoBins
              I1 = NINT(Xlogg(2,NumResoBins))
              WRITE (6,FMT='(3x,F5.3,I8,2F8.1,2x,2F8.1)') 
     +           Xlogg(1,NumResoBins),I1, 
     +            (Xlogg(I,NumResoBins),I=3,6)
              DO 1080 I1 = 3,11
                Xlogg(I1,NumResoBins) = 0.0
 1080         CONTINUE
 1090       CONTINUE
C
C
            WRITE (6,FMT=*) ' $$'
            I1 = NINT(Xlogg(2,1+MaxNumResoBins))
            WRITE (6,FMT='(3x,a,I8,2F8.1,2x,2F8.1)') 
     +        'TOTAL',I1,
     +         (Xlogg(I,1+MaxNumResoBins),I=3,6)
C
C
            DO 1100 I1 = 3,11
              Xlogg(I1,1+MaxNumResoBins) = 0.0
 1100       CONTINUE
          END IF
C
C
          IF (IW2AVE.GT.0) THEN
            BuffA(1+MaxNumResoBins,1) = 0.0
            MBuffA(1+MaxNumResoBins) = 0
C
C
            DO 1120 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
C
C
              DO 1110 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                         SumWsigAADO(Kderiv,NumResoBins,Ifom)
 1110         CONTINUE
C
C
              MBuffA(1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins) +
     +                                   MBuffA(NumResoBins)
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
C
C
              IF (VBuffA(NumResoBins).GT.0.00001) 
     +             BuffA(NumResoBins,1) = 
     +                   (BuffA(NumResoBins,1)/
     +                    VBuffA(NumResoBins))
C
C
              Xlogg(2,NumResoBins) = MBuffA(NumResoBins)
              Xlogg(3,NumResoBins) = BuffA(NumResoBins,1)
 1120       CONTINUE
C
C
            IF (VBuffA(1+MaxNumResoBins).GT.0.00001) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                   (BuffA(1+MaxNumResoBins,1)/
     +                   VBuffA(1+MaxNumResoBins))
C
C
            Xlogg(2,1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins)
            Xlogg(3,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
C
C----   (Av( anomalous error weighted by 1/SIGFP**2 + SIGFPh**2
C
            BuffA(1+MaxNumResoBins,1) = 0.0
            Buff(1+MaxNumResoBins,1) = 0.0
C
C
            DO 1140 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
              Buff(NumResoBins,1) = 0.0
C
C
              DO 1130 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                           SumWsigLCA(Kderiv,NumResoBins,Ifom)
C
C---- Pseudo Anom "Cullis Rfactor"
C
                Buff(NumResoBins,1) = Buff(NumResoBins,1) +
     +                          SumWsigAADO(Kderiv,NumResoBins,Ifom)
 1130         CONTINUE
C
C
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
              Buff(1+MaxNumResoBins,1) = Buff(1+MaxNumResoBins,1) +
     +                                   Buff(NumResoBins,1)
C
C
              IF (Buff(NumResoBins,1).GT.0.00001) 
     +            Buff(NumResoBins,1) = 
     +                 (BuffA(NumResoBins,1)/Buff(NumResoBins,1))
              IF (VBuffA(NumResoBins).GT.0.00001) 
     +             BuffA(NumResoBins,1) = 
     +                   (BuffA(NumResoBins,1)/VBuffA(NumResoBins))
              Xlogg(5,NumResoBins) = BuffA(NumResoBins,1)
              Xlogg(6,NumResoBins) = Buff(NumResoBins,1)
 1140       CONTINUE
C
C
            IF (Buff(1+MaxNumResoBins,1).GT.0.00001) 
     +          Buff(1+MaxNumResoBins,1) = 
     +                 (BuffA(1+MaxNumResoBins,1)/
     +                  Buff(1+MaxNumResoBins,1))
            IF (VBuffA(1+MaxNumResoBins).GT.0.00001) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                  (BuffA(1+MaxNumResoBins,1)/
     +                  VBuffA(1+MaxNumResoBins))
C
C
            Xlogg(5,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
            Xlogg(6,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
C
C
C---- Weighted MEAN Anomalous lack of closure
C
          WRITE (6,FMT=9032)
 9032     FORMAT (/,
     +' Weighted (W2) MEAN anomalous lack-of-closure analysis',/,
     +' =====================================================')
            WRITE (6,FMT=6032) LAB,Kderiv
 6032       FORMAT (/,
     +' $TABLE: Anomalous lack of closure  analysis  v resln ',
     +        'using MEAN_W2',A,I3,':',/)
            WRITE (6,FMT=6034) LAB,Kderiv,LAB,Kderiv
 6034       FORMAT (
     +' $GRAPHS ',
     +':Ano "Cullis Rfactor"  for ',A,I3,':N:1,5:',/,
     +' :<Ano_diffs - obs >',/,
     +'-< Ano_lack_of_Closure -  ',A,I3,':N:1,3,4:',/,
     +' $$ 1/resol^2 ',/,
     +' Number_acentric_reflections ',/,
     +' Anomalous_difference_obs ',/,
     +'  Lack_of_ano_closure ',/,
     +' Cullis_R_anomalous $$ ',/,
     +' 1/resol^2 Nref_a DANO_obs  LOC_ano CullR_ano $$')
C
C
            DO 1160 NumResoBins = 1,MaxNumResoBins
              I1 = NINT(Xlogg(2,NumResoBins))
              WRITE (6,FMT='(3x,F5.3,I8,1F8.1,2x,2F8.2)') 
     +          Xlogg(1,NumResoBins),I1,
     +           Xlogg(3,NumResoBins),
     +            Xlogg(5,NumResoBins),
     +             Xlogg(6,NumResoBins)
              DO 1150 I1 = 3,11
                Xlogg(I1,NumResoBins) = 0.0
 1150         CONTINUE
 1160       CONTINUE
C
C
            WRITE (6,FMT=*) ' $$'
            I1 = NINT(Xlogg(2,1+MaxNumResoBins))
            WRITE (6,FMT='(3x,a,I8,1F8.1,2x,2F8.2)') 
     +         'TOTAL',I1,
     +           Xlogg(3,1+MaxNumResoBins),
     +            Xlogg(5,1+MaxNumResoBins),
     +             Xlogg(6,1+MaxNumResoBins)
C
C    Save selected stats per derivative
C     _phasing_MIR_der.RCullis_anomalous
C     _phasing_MIR_der.Reflns_acentric  (anomalous ?)
              Rcullis(3,Kderiv)=Xlogg(6,1+MaxNumResoBins)
              KReflns(3,Kderiv)=I1
C
            DO 1170 I1 = 3,11
              Xlogg(I1,1+MaxNumResoBins) = 0.0
 1170       CONTINUE
          END IF
C
C----   (Rms( anomalous difference weighted by 1/SIGFP**2 + SIGFPh**2
C
          IF (IW2RMS.GT.0) THEN
            BuffA(1+MaxNumResoBins,1) = 0.0
            MBuffA(1+MaxNumResoBins) = 0
C
C
            DO 1190 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
C
C
              DO 1180 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                           SumWsigADOS(Kderiv,NumResoBins,Ifom)
 1180         CONTINUE
C
C
              MBuffA(1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins) +
     +                                   MBuffA(NumResoBins)
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
C
C
              IF (VBuffA(NumResoBins).GT.0.00001) 
     +             BuffA(NumResoBins,1) = 
     +                   SQRT(ABS(BuffA(NumResoBins,1)/
     +                           VBuffA(NumResoBins)))
              Xlogg(2,NumResoBins) = MBuffA(NumResoBins)
              Xlogg(3,NumResoBins) = BuffA(NumResoBins,1)
 1190       CONTINUE
C
C
            IF (VBuffA(1+MaxNumResoBins).GT.0.00001) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +               SQRT(ABS(BuffA(1+MaxNumResoBins,1)/
     +                       VBuffA(1+MaxNumResoBins)))
C
C
            Xlogg(2,1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins)
            Xlogg(3,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
C
C----   (Rms( anomalous error weighted by 1/SIGFP**2 + SIGFPh**2
C
            BuffA(1+MaxNumResoBins,1) = 0.0
            Buff(1+MaxNumResoBins,1) = 0.0
C
C
            DO 1210 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
              Buff(NumResoBins,1) = 0.0
C
C
              DO 1200 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                           SumWsigLCAQ(Kderiv,NumResoBins,Ifom)
C
C---- Pseudo Anom "Cullis Rfactor"
C
                Buff(NumResoBins,1) = Buff(NumResoBins,1) +
     +                          SumWsigADOS(Kderiv,NumResoBins,Ifom)
 1200         CONTINUE
C
C
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
              Buff(1+MaxNumResoBins,1) = Buff(1+MaxNumResoBins,1) +
     +                                   Buff(NumResoBins,1)
C
C
              IF (Buff(NumResoBins,1).GT.0.00001) 
     +            Buff(NumResoBins,1) = 
     +                 SQRT(ABS(BuffA(NumResoBins,1)/
     +                          Buff(NumResoBins,1)))
              IF (VBuffA(NumResoBins).GT.0.00001) 
     +             BuffA(NumResoBins,1) = 
     +                   SQRT(ABS(BuffA(NumResoBins,1)/
     +                           VBuffA(NumResoBins)))
C
C
              Xlogg(5,NumResoBins) = BuffA(NumResoBins,1)
              Xlogg(6,NumResoBins) = Buff(NumResoBins,1)
 1210       CONTINUE
C
C
            IF (Buff(1+MaxNumResoBins,1).GT.0.00001) 
     +          Buff(1+MaxNumResoBins,1) = 
     +                (BuffA(1+MaxNumResoBins,1)/
     +                 Buff(1+MaxNumResoBins,1))
            IF (VBuffA(1+MaxNumResoBins).GT.0.00001) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                 SQRT(ABS(BuffA(1+MaxNumResoBins,1)/
     +                         VBuffA(1+MaxNumResoBins)))
C
C
            Xlogg(5,1+MaxNumResoBins) = BuffA(NumResoBins,1)
            Xlogg(6,1+MaxNumResoBins) = Buff(NumResoBins,1)
C
C
C---- Weighted RMS Anomalous lack of closure
C
          WRITE (6,FMT=9036)
 9036     FORMAT (/,
     +' Weighted (W2) RMS anomalous lack-of-closure analysis',/,
     +' =====================================================')
            WRITE (6,FMT=6036) LAB,Kderiv
 6036       FORMAT (/,
     +' $TABLE: Anomalous lack of closure  analysis  v resln ',
     +       'using RMS_W2 ',A,I3,':',/)
            WRITE (6,FMT=6034) LAB,Kderiv,LAB,Kderiv
C
C
            DO 1230 NumResoBins = 1,MaxNumResoBins
              I1 = NINT(Xlogg(2,NumResoBins))
              WRITE (6,FMT='(3x,F5.3,I8,1F8.1,2x,2F8.1)') 
     +           Xlogg(1,NumResoBins),I1,
     +            Xlogg(3,NumResoBins),
     +             Xlogg(5,NumResoBins),
     +              Xlogg(6,NumResoBins)
              DO 1220 I1 = 3,11
                Xlogg(I1,NumResoBins) = 0.0
 1220         CONTINUE
 1230       CONTINUE
C
C
            WRITE (6,FMT=*) ' $$'
            I1 = NINT(Xlogg(2,1+MaxNumResoBins))
            WRITE (6,FMT='(3x,a,I8,1F8.1,2x,2F8.1)') 
     +        'TOTAL',I1,
     +          Xlogg(3,1+MaxNumResoBins),
     +           Xlogg(5,1+MaxNumResoBins),
     +            Xlogg(6,1+MaxNumResoBins)
C
C
            DO 1240 I1 = 3,11
              Xlogg(I1,1+MaxNumResoBins) = 0.0
 1240       CONTINUE
C
C
          END IF
C
C----   (Av( anomalous difference weighted by old weight  ( W1)
C
          IF (IW1AVE.GT.0) THEN
            MBuffA(1+MaxNumResoBins) = 0
            BuffA(1+MaxNumResoBins,1) = 0.0
C
C
            DO 1260 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
C
C
              DO 1250 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +            SumAnomWgtModPrPhaseADO(Kderiv,NumResoBins,Ifom)
 1250         CONTINUE
C
C
              MBuffA(1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins) +
     +                                   MBuffA(NumResoBins)
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
C
C
              IF (WBuffA(NumResoBins).GT.0.00001) 
     +             BuffA(NumResoBins,1) = (BuffA(NumResoBins,1)/
     +                                    WBuffA(NumResoBins))
              Xlogg(2,NumResoBins) = MBuffA(NumResoBins)
              Xlogg(3,NumResoBins) = BuffA(NumResoBins,1)
 1260       CONTINUE
C
C
            IF (WBuffA(1+MaxNumResoBins).GT.0.00001) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                   (BuffA(1+MaxNumResoBins,1)/
     +                   WBuffA(1+MaxNumResoBins))
            Xlogg(2,1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins)
            Xlogg(3,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
C
C
C----   (Av( anomalous error weighted by old weight (W1)
C
            BuffA(1+MaxNumResoBins,1) = 0.0
            Buff(1+MaxNumResoBins,1) = 0.0
C
C
            DO 1280 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
              Buff(NumResoBins,1) = 0.0
C
C
              DO 1270 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                                 SWLCA(Kderiv,NumResoBins,Ifom)
C
C---- Pseudo Anom "Cullis Rfactor"
C
                Buff(NumResoBins,1) = Buff(NumResoBins,1) +
     +           SumAnomWgtModPrPhaseADO(Kderiv,NumResoBins,Ifom)
 1270         CONTINUE
C
C
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
C
C
              IF (Buff(NumResoBins,1).GT.0.00001) THEN
                Buff(1+MaxNumResoBins,1) = Buff(1+MaxNumResoBins,1) +
     +                                     Buff(NumResoBins,1)
                Buff(NumResoBins,1) = (BuffA(NumResoBins,1)/
     +                                Buff(NumResoBins,1))
              END IF
C
C
              IF (WBuffA(NumResoBins).GT.0.00001) 
     +             BuffA(NumResoBins,1) = 
     +                    (BuffA(NumResoBins,1)/
     +                    WBuffA(NumResoBins))
C
C
              Xlogg(5,NumResoBins) = BuffA(NumResoBins,1)
              Xlogg(6,NumResoBins) = Buff(NumResoBins,1)
 1280       CONTINUE
C
C
            IF (Buff(1+MaxNumResoBins,1).GT.0.00001) 
     +          Buff(1+MaxNumResoBins,1) = 
     +                 (BuffA(1+MaxNumResoBins,1)/
     +                  Buff(1+MaxNumResoBins,1))
            IF (WBuffA(1+MaxNumResoBins).GT.0.00001) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                  (BuffA(1+MaxNumResoBins,1)/
     +                  WBuffA(1+MaxNumResoBins))
C
C
            Xlogg(5,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
            Xlogg(6,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
C
C
C---- Weighted RMS Anomalous lack of closure
C
          WRITE (6,FMT=9038)
 9038     FORMAT (/,
     +' Weighted (W1) MEAN anomalous lack-of-closure analysis',/,
     +' =====================================================')
            WRITE (6,FMT=6038) LAB,Kderiv
 6038       FORMAT (/,
     +' $TABLE: Anomalous lack of closure  analysis  v resln ',
     +         'using MEAN_W1',A,I3,':',/)
            WRITE (6,FMT=6034) LAB,Kderiv,LAB,Kderiv
C
C
            DO 1300 NumResoBins = 1,MaxNumResoBins
              I1 = NINT(Xlogg(2,NumResoBins))
              WRITE (6,FMT='(3x,F5.3,I8,1F8.1,2x,2F8.1)') 
     +          Xlogg(1,NumResoBins),I1,
     +           Xlogg(3,NumResoBins),
     +            Xlogg(5,NumResoBins),
     +             Xlogg(6,NumResoBins)
              DO 1290 I1 = 3,11
                Xlogg(I1,NumResoBins) = 0.0
 1290         CONTINUE
 1300       CONTINUE
C
C
            WRITE (6,FMT=*) ' $$'
            I1 = NINT(Xlogg(2,1+MaxNumResoBins))
            WRITE (6,FMT='(3x,a,I8,1F8.1,2x,2F8.1)') 
     +        'TOTAL',I1,
     +          Xlogg(3,1+MaxNumResoBins),
     +           Xlogg(5,1+MaxNumResoBins),
     +            Xlogg(6,1+MaxNumResoBins)
            DO 1310 I1 = 3,11
              Xlogg(I1,1+MaxNumResoBins) = 0.0
 1310       CONTINUE
C
C
          END IF
C
C----   (Rms( anomalous difference weighted by old weight (W1)
C
          IF (IW1RMS.GT.0) THEN
            MBuffA(1+MaxNumResoBins) = 0
            BuffA(1+MaxNumResoBins,1) = 0.0
C
C
            DO 1330 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
C
C
              DO 1320 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +           SumAnomWgtModPrPhaseDOS(Kderiv,NumResoBins,Ifom)
 1320         CONTINUE
C
C
              MBuffA(1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins) +
     +                                   MBuffA(NumResoBins)
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
C
C
              IF (WBuffA(NumResoBins).GT.0.00001) 
     +             BuffA(NumResoBins,1) = 
     +                   SQRT(ABS(BuffA(NumResoBins,1)/
     +                           WBuffA(NumResoBins)))
C
C
              Xlogg(2,NumResoBins) = MBuffA(NumResoBins)
              Xlogg(3,NumResoBins) = BuffA(NumResoBins,1)
 1330       CONTINUE
C
C
            IF (WBuffA(1+MaxNumResoBins).GT.0.00001) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                   SQRT(ABS(BuffA(1+MaxNumResoBins,1)/
     +                           WBuffA(1+MaxNumResoBins)))
C
C
            Xlogg(2,1+MaxNumResoBins) = MBuffA(1+MaxNumResoBins)
            Xlogg(3,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
C
C
C----   (Rms( anomalous error weighted by old weight
C
            BuffA(1+MaxNumResoBins,1) = 0.0
            Buff(1+MaxNumResoBins,1) = 0.0
C
C
            DO 1350 NumResoBins = 1,MaxNumResoBins
              BuffA(NumResoBins,1) = 0.0
              Buff(NumResoBins,1) = 0.0
C
C
              DO 1340 Ifom = 1,MaxNumFigMeritBins
                BuffA(NumResoBins,1) = BuffA(NumResoBins,1) +
     +                                 SWLCAQ(Kderiv,NumResoBins,Ifom)
C
C---- Pseudo Anom "Cullis Rfactor"
C
                Buff(NumResoBins,1) = Buff(NumResoBins,1) +
     +           SumAnomWgtModPrPhaseDOS(Kderiv,NumResoBins,Ifom)
 1340         CONTINUE
C
C
              BuffA(1+MaxNumResoBins,1) = BuffA(1+MaxNumResoBins,1) +
     +                                    BuffA(NumResoBins,1)
              Buff(1+MaxNumResoBins,1) = Buff(1+MaxNumResoBins,1) +
     +                                   Buff(NumResoBins,1)
C
C
              IF (Buff(NumResoBins,1).GT.0.00001) 
     +            Buff(NumResoBins,1) = 
     +                    SQRT(ABS(BuffA(NumResoBins,1)/
     +                             Buff(NumResoBins,1)))
              IF (WBuffA(NumResoBins).GT.0.00001) 
     +             BuffA(NumResoBins,1) = 
     +                      SQRT(ABS(BuffA(NumResoBins,1)/
     +                              WBuffA(NumResoBins)))
C
C
              Xlogg(5,NumResoBins) = BuffA(NumResoBins,1)
              Xlogg(6,NumResoBins) = Buff(NumResoBins,1)
 1350       CONTINUE
C
C
            IF (Buff(1+MaxNumResoBins,1).GT.0.00001) 
     +          Buff(1+MaxNumResoBins,1) = 
     +                       BuffA(1+MaxNumResoBins,1)/
     +                       Buff(1+MaxNumResoBins,1)
            IF (WBuffA(1+MaxNumResoBins).GT.0.00001) 
     +           BuffA(1+MaxNumResoBins,1) = 
     +                      SQRT(ABS(BuffA(1+MaxNumResoBins,1)/
     +                              WBuffA(1+MaxNumResoBins)))
C
C
            Xlogg(5,1+MaxNumResoBins) = BuffA(1+MaxNumResoBins,1)
            Xlogg(6,1+MaxNumResoBins) = Buff(1+MaxNumResoBins,1)
C
C
C---- Weighted RMS Anomalous lack of closure
C
          WRITE (6,FMT=9040)
 9040     FORMAT (/,
     +' Weighted (W1) RMS anomalous lack-of-closure analysis',/,
     +' ====================================================')
            WRITE (6,FMT=6040) LAB,Kderiv
 6040       FORMAT (/,
     +' $TABLE: Anomalous lack of closure  analysis  v resln ',
     +         'using RMS_W1 ',A,I3,':',/)
            WRITE (6,FMT=6034) LAB,Kderiv,LAB,Kderiv
C
C
            DO 1370 NumResoBins = 1,MaxNumResoBins
              I1 = NINT(Xlogg(2,NumResoBins))
              WRITE (6,FMT='(3x,F5.3,I8,1F8.1,2x,2F8.1)') 
     +           Xlogg(1,NumResoBins),I1,
     +            Xlogg(3,NumResoBins),
     +             Xlogg(5,NumResoBins),
     +              Xlogg(6,NumResoBins)
              DO 1360 I1 = 3,11
                Xlogg(I1,NumResoBins) = 0.0
 1360         CONTINUE
 1370       CONTINUE
C
C
            WRITE (6,FMT=*) ' $$'
            I1 = NINT(Xlogg(2,1+MaxNumResoBins))
            WRITE (6,FMT='(3x,a,I8,1F8.1,2x,2F8.1)') 
     +        'TOTAL',I1,
     +         Xlogg(3,1+MaxNumResoBins),
     +          Xlogg(5,1+MaxNumResoBins),
     +           Xlogg(6,1+MaxNumResoBins)
            DO 1380 I1 = 3,11
              Xlogg(I1,1+MaxNumResoBins) = 0.0
 1380       CONTINUE
          END IF
        END IF
C
C
 1390 CONTINUE
C
C----  Finished??
C
      RETURN
C
C
      END
C
C
C
C     ====================================================
      SUBROUTINE INICAL(PARAM,TCELL,AMAT,RMAT,RECSQ,VOLUME)
C     ====================================================
C
C
C        implicit none
C
C
C     .. Parameters ..
      INTEGER ISYSW
      PARAMETER (ISYSW=6)
C     ..
C     .. Scalar Arguments ..
      REAL VOLUME
C     ..
C     .. Array Arguments ..
      REAL AMAT(3,3),PARAM(6),RECSQ(6),RMAT(3,3),TCELL(6)
C     ..
C     .. Local Scalars ..
      REAL A13,A33,TAS,TMP,VST,VST2
      INTEGER I,J,NERROR
C     ..
C     .. Local Arrays ..
      REAL TCOS(3),TSIN(3)
      INTEGER INDX(3)
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR,MATIN1
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ACOS,COS,SIN,SQRT
C     ..
C
C
C
C
      TSIN(1) = SIN(PARAM(4))
      TSIN(2) = SIN(PARAM(5))
      TSIN(3) = SIN(PARAM(6))
      IF (TSIN(1).LE.0.0001) GO TO 50
      IF (TSIN(2).LE.0.0001) GO TO 50
      IF (TSIN(3).LE.0.0001) GO TO 50
      TCOS(1) = COS(PARAM(4))
      TCOS(2) = COS(PARAM(5))
      TCOS(3) = COS(PARAM(6))
C
C
      VST2 = 1.0 - TCOS(1)**2 - TCOS(2)**2 - TCOS(3)**2 +
     +       TCOS(1)*2.0*TCOS(2)*TCOS(3)
C
C
      IF (VST2.LE.0.000000001) GO TO 50
      VST = SQRT(ABS(VST2))
      IF (PARAM(1).LE.0.0) GO TO 40
      IF (PARAM(2).LE.0.0) GO TO 40
      IF (PARAM(3).LE.0.0) GO TO 40
C
C
      TCELL(1) = TSIN(1)/PARAM(1)/VST
      TCELL(2) = TSIN(2)/PARAM(2)/VST
      TCELL(3) = TSIN(3)/PARAM(3)/VST
      TCELL(4) = ACOS((TCOS(2)*TCOS(3)-TCOS(1))/ (TSIN(2)*TSIN(3)))
      TCELL(5) = ACOS((TCOS(1)*TCOS(3)-TCOS(2))/ (TSIN(1)*TSIN(3)))
      TCELL(6) = ACOS((TCOS(1)*TCOS(2)-TCOS(3))/ (TSIN(1)*TSIN(2)))
C
C
      IF (TCELL(1).LE.PARAM(1)) THEN
        IF (TCELL(2).GT.PARAM(2)) GO TO 40
        IF (TCELL(3).GT.PARAM(3)) GO TO 40
C
C
        DO 10 I = 1,6
          TMP = TCELL(I)
          TCELL(I) = PARAM(I)
          PARAM(I) = TMP
   10   CONTINUE
C
C
        TSIN(1) = SIN(PARAM(4))
        TSIN(2) = SIN(PARAM(5))
        TSIN(3) = SIN(PARAM(6))
        TCOS(1) = COS(PARAM(4))
        TCOS(2) = COS(PARAM(5))
        TCOS(3) = COS(PARAM(6))
      END IF
C
C
      IF (TCELL(2).LT.PARAM(2)) GO TO 40
      IF (TCELL(3).LT.PARAM(3)) GO TO 40
      RECSQ(1) = PARAM(1)**2
      RECSQ(2) = PARAM(2)**2
      RECSQ(3) = PARAM(3)**2
      RECSQ(4) = TCOS(1)*2.0*PARAM(2)*PARAM(3)
      RECSQ(5) = TCOS(2)*2.0*PARAM(3)*PARAM(1)
      RECSQ(6) = TCOS(3)*2.0*PARAM(1)*PARAM(2)
      AMAT(1,1) = PARAM(1)*TSIN(3)
      AMAT(1,2) = PARAM(1)*TCOS(3)
      AMAT(1,3) = 0.0
      AMAT(2,1) = 0.0
      AMAT(2,2) = PARAM(2)
      AMAT(2,3) = 0.0
      A13 = (TCOS(2)-TCOS(3)*TCOS(1))/TSIN(3)
      AMAT(3,1) = PARAM(3)*A13
      AMAT(3,2) = PARAM(3)*TCOS(1)
      TAS = TSIN(1)**2 - A13**2
      IF (TAS.LE.0.0) GO TO 50
      A33 = SQRT(ABS(TAS))
      AMAT(3,3) = PARAM(3)*A33
C
C
      DO 30 I = 1,3
        DO 20 J = 1,3
          RMAT(J,I) = AMAT(J,I)
   20   CONTINUE
   30 CONTINUE
C
C          ***************************************
      CALL MATIN1(RMAT,3,3,9,0,INDX,NERROR,VOLUME)
C          ***************************************
C
      WRITE (ISYSW,FMT=6000) ((AMAT(I,J),J=1,3), (RMAT(I,J),J=1,3),
     +  I=1,3)
 6000 FORMAT (1X,'Reciprocal matrix               Real matrix',
     +       3 (/1X,3F8.5,8X,3F8.2))
      WRITE (ISYSW,FMT='(/,a,/,a,/,a,/,a,/,a,/,a,/,a)')
     +  '  The orthogonalisation code is:',
     +  '          B     PARALLEL TO KO       C* PARALLEL TO LO',
     +  '          B*    PARALLEL TO YO       C  PARALLEL TO ZO',
     +  ' The real matrix pre-multiplies column vector {x y z} in',
     +  ' fractional coordinates to get orthogonal coordinates. The',
     +  ' reciprocal matrix is its inverse. This is not the same as',
     +  ' PDB standard NCODE 1. These matrices are used when',
     +  ' refining anisotropic temperature factors, although the',
     +  ' orthogonal axis definition is irrelevant.'
C
C
      RETURN
   40 WRITE (ISYSW,FMT=6002)
 6002 FORMAT (//1X,'FATAL ERROR, ILLEGAL CRYSTAL LATTICE LENGHTS')
C
C            ****************************
      CALL CCPERR(1,' Execution Halted ')
C            ****************************
C
   50 WRITE (ISYSW,FMT=6004)
 6004 FORMAT (//1X,'FATAL ERROR, ILLEGAL CRYSTAL LATTICE ANGLES')
C
C            ****************************
      CALL CCPERR(1,' Execution Halted ')
C            ****************************
C
      END
C
C
C
C
C     ======================================================
      SUBROUTINE MATIN1(A,DIM1,N1,DIM2,N2,INDX,NERROR,DETERM)
C     =======================================================
C
C        implicit none
C
C
C
C---- Matrix inversion with accompanying solution of linear equations.
C
C     .. Parameters ..
      INTEGER ISYSW
      PARAMETER (ISYSW=6)
C     ..
C     .. Scalar Arguments ..
      REAL DETERM
      INTEGER DIM1,DIM2,N1,N2,NERROR
C     ..
C     .. Array Arguments ..
      REAL A(DIM2)
      INTEGER INDX(DIM1)
C     ..
C     .. Local Scalars ..
      REAL DETER,PIVOT,SWAP
      INTEGER DIM,EMAT,I,I1,I2,I3,ICOL,JCOL,LPIV,MAIN,N,NMIN1,PIVCO1,
     +        PIVCO2,PIVCOL
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C     ..
C
C
C
C
      DETER = 1.0
      N = N1
      EMAT = N + N2
      DIM = DIM1
      NMIN1 = N - 1
C
C---- The routine does its own evaluation for double subscripting of
C     array a.
C
      PIVCOL = 1 - DIM
C
C----  main loop to invert the matrix
C
      DO 110 MAIN = 1,N
        PIVOT = 0.0
        PIVCOL = PIVCOL + DIM
C
C---- search for next pivot in column main.
C
        PIVCO1 = PIVCOL + MAIN - 1
        PIVCO2 = PIVCOL + NMIN1
C
C
        DO 20 I = PIVCO1,PIVCO2
          IF ((ABS(A(I))-ABS(PIVOT)).LE.0.0) GO TO 20
   10     PIVOT = A(I)
          LPIV = I
   20   CONTINUE
C
C---- is pivot different from zero
C
        IF (PIVOT.EQ.0.0) GO TO 150
C
C----  get the pivot-line indicator and swap lines if necessary
C
   30   ICOL = LPIV - PIVCOL + 1
        INDX(MAIN) = ICOL
C
C
        IF ((ICOL-MAIN).LE.0) GO TO 60
C
C---- complement the determinant
C
   40   DETER = -DETER
C
C----  pointer to line pivot found
C
        ICOL = ICOL - DIM
C
C----  pointer to exact pivot line
C
        I3 = MAIN - DIM
C
C
        DO 50 I = 1,EMAT
          ICOL = ICOL + DIM
          I3 = I3 + DIM
          SWAP = A(I3)
          A(I3) = A(ICOL)
          A(ICOL) = SWAP
   50   CONTINUE
C
C----  compute determinant
C
   60   DETER = DETER*PIVOT
        PIVOT = 1.0/PIVOT
C
C----  transform pivot column
C
        I3 = PIVCOL + NMIN1
C
C
        DO 70 I = PIVCOL,I3
          A(I) = -A(I)*PIVOT
   70   CONTINUE
C
C
        A(PIVCO1) = PIVOT
C
C---- pivot element transformed
C     now convert rest of the matrix
C
        I1 = MAIN - DIM
C
C---- pointer to pivot line elements
C
        ICOL = 1 - DIM
C
C---- general column pointer
C
        DO 100 I = 1,EMAT
          ICOL = ICOL + DIM
          I1 = I1 + DIM
C
C----  pointers moved
C
          IF ((I-MAIN).EQ.0) GO TO 100
C
C----  pivot column excluded
C
   80     JCOL = ICOL + NMIN1
          SWAP = A(I1)
          I3 = PIVCOL - 1
C
C
          DO 90 I2 = ICOL,JCOL
            I3 = I3 + 1
            A(I2) = A(I3)*SWAP + A(I2)
   90     CONTINUE
C
C
          A(I1) = SWAP*PIVOT
  100   CONTINUE
  110 CONTINUE
C
C----  now rearrange the matrix to get right invers
C
      DO 140 I1 = 1,N
        MAIN = N + 1 - I1
        LPIV = INDX(MAIN)
        IF ((LPIV-MAIN).EQ.0) GO TO 140
  120   ICOL = (LPIV-1)*DIM + 1
        JCOL = ICOL + NMIN1
        PIVCOL = (MAIN-1)*DIM + 1 - ICOL
C
C
        DO 130 I2 = ICOL,JCOL
          I3 = I2 + PIVCOL
          SWAP = A(I2)
          A(I2) = A(I3)
          A(I3) = SWAP
  130   CONTINUE
  140 CONTINUE
C
C
      DETERM = DETER
      NERROR = 0
      RETURN
  150 NERROR = -1
      DETERM = DETER
      WRITE (ISYSW,FMT=6000) MAIN,MAIN
 6000 FORMAT (' MATIN1 .. the ',I5,' Column of the Matrix contains onl',
     +       'y zeros at the ',I5,' eleminationsstep.')
      END
C
C
C
C     =================================
      SUBROUTINE MATSOL(A,B,N,DET,IDET)
C     =================================
C
C
C        implicit none
C
C
C     Refference . . . MARTIN, PETERS, AND WILKINSON, NUM. MATH 7,
C     PPS. 362-383 (1965)
C
C     Uses a modified cholesky method to solve the matrix system ax = b
C     returning x in b.
C
C     A is assumed to be a real symmetric positive definite matrix
C     with only the unique elements stored by columns in a.  thus the
C     actual size of a is n(n+1)/2.
C
C  The lower trIAngleStep of a inverse is stored in a on return and the
C     determinant of a is returned in det.
C
C
C
C
C
C
C     .. Scalar Arguments ..
      DOUBLE PRECISION DET
      INTEGER IDET,N
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION A(*),B(*)
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION R,S,T
C      REAL R,S,T
      INTEGER I,II,IJ,IK,IL,J,JI,JJ,JK,JL,K,KI,KJ,KK
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPERR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,DABS
C     ..
C
C
C
C
      DET = 0.0D0
      IDET = 0
      IF (N.LE.0) GO TO 260
      IF (N.GT.1) GO TO 10
      IF (A(1).NE.0.0D0) GO TO 10
      B(1) = 0.0D0
      RETURN
C
   10 CONTINUE
      DET = 0.5D0
      IDET = 1
C
C----  reduce a to (l)(d)(l transpose) = a
C      l has a unit diagonal
C      store 1.0/d on the diagonal of a
C
      II = 1
C
C
      DO 110 I = 1,N
        IL = I - 1
        IF (I.EQ.1) GO TO 50
        IJ = I
C
C
        DO 40 J = 1,IL
          R = A(IJ)
C          R = REAL(A(IJ))
          IF (J.EQ.1) GO TO 30
          IK = I
          JK = J
          JL = J - 1
C
C
          DO 20 K = 1,JL
C            R = R - REAL(A(IK)*A(JK))
            R = R - A(IK)*A(JK)
            IK = N - K + IK
            JK = N - K + JK
   20     CONTINUE
   30     A(IJ) = R
          IJ = N - J + IJ
   40   CONTINUE
C
C
C   50   R = REAL(A(II))
   50   R = A(II)
C
C
        IF (I.EQ.1) GO TO 70
        KK = 1
        IK = I
C
C
        DO 60 K = 1,IL
C          S = REAL(A(IK))
C          T = A(KK))*S
          S = A(IK)
          T = A(KK)*S
          A(IK) = T
          R = R - S*T
          IK = N - K + IK
          KK = N - K + 1 + KK
   60   CONTINUE
C
C
   70   DET = DET*R
        IF (DABS(DET).GT.1.0D-30) GO TO 80
        WRITE (6,FMT=6000)
C  Try this - 28-1-92
        B(1) = 0.0D0
C
C            ****************************
        CALL CCPERR(1,' Execution Halted 30')
C            ****************************
        RETURN
C
   80   IF (DABS(DET).LT.1.0) GO TO 90
        DET = DET/2.0
        IDET = IDET + 1
        GO TO 80
   90   IF (DABS(DET).GE.0.5) GO TO 100
        DET = DET*2.0
        IDET = IDET - 1
        GO TO 90
  100   CONTINUE
        A(II) = 1.0D0/R
        II = N - I + 1 + II
  110 CONTINUE
C
C---- solution of linear equations
C     first solve ly = b
C
      DO 130 I = 1,N
        IF (I.EQ.1) GO TO 130
        IK = I
        IL = I - 1
C        R = REAL(B(I))
        R = B(I)
C
C
        DO 120 K = 1,IL
C          R = R - REAL(B(K)*A(IK))
          R = R - B(K)*A(IK)
          IK = N - K + IK
  120   CONTINUE
C
C
        B(I) = R
  130 CONTINUE
C
C----  now solve (d)(l transpose)(x) = y for x
C
      II = (N+1)*N/2
C
C
      DO 160 J = 1,N
        I = N + 1 - J
C        R = REAL(B(I)*A(II))
        R = B(I)*A(II)
        IF (J.EQ.1) GO TO 150
        IL = I + 1
        KI = II + 1
C
C
        DO 140 K = IL,N
C          R = R - REAL(A(KI)*B(K))
          R = R - A(KI)*B(K)
          KI = KI + 1
  140   CONTINUE
  150   B(I) = R
        II = II - J - 1
  160 CONTINUE
C
C----  matrix inversion
C      first calculate l inverse
C
      II = (N+1)*N/2
C
C
      DO 210 I = 1,N
        IF (I.EQ.N) GO TO 200
        IJ = II - I
        IL = N - I
        J = IL
        JJ = IJ - 1
C
C
        DO 190 JK = 1,IL
C          R = -REAL(A(IJ))
          R = -A(IJ)
          IF (JK.EQ.1) GO TO 180
          IK = IJ + N - J
          JL = J + 1
          KJ = JJ + 1
C
C
          DO 170 K = JL,IL
C            R = R - REAL(A(IK)*A(KJ))
            R = R - A(IK)*A(KJ)
            IK = IK + N - K
            KJ = KJ + 1
  170     CONTINUE
  180     A(IJ) = R
          J = J - 1
          JJ = JJ - N + J - 1
          IJ = IJ - N + J
  190   CONTINUE
  200   II = II - I - 1
  210 CONTINUE
C
C----  calculate a inverse = (l transpose inverse)(d inverse)(l inverse)
C
      IL = N - 1
      IF (IL.LE.0) GO TO 260
      II = 1
C
C
      DO 250 I = 1,IL
        JI = II
        JJ = II
C
C
        DO 240 J = I,N
C          R = REAL(A(JI))
C          IF (J.NE.I) R = R*REAL(A(JJ))
          R = A(JI)
          IF (J.NE.I) R = R*A(JJ)
          IF (J.EQ.N) GO TO 230
          JL = J + 1
          KI = JI + 1
          KJ = JJ + 1
          KK = JJ + N - J + 1
C
C
          DO 220 K = JL,N
C            R = REAL(A(KI)*A(KJ)*A(KK)) + R
            R = A(KI)*A(KJ)*A(KK) + R
            KI = KI + 1
            KJ = KJ + 1
            KK = KK + N - K + 1
  220     CONTINUE
  230     A(JI) = R
          JI = JI + 1
          JJ = JJ + N - J + 1
  240   CONTINUE
        II = II + N - I + 1
  250 CONTINUE
C
C
  260 CONTINUE
      RETURN
 6000 FORMAT (' **** IN SUBROUTINE MATSOL: DET IS LESS THAN 10E-30****',
     + /,' **** Possible causes: *****',
     + /,' You have an atom on a special position ',
     + 'where one parameter must be fixed?;',/,
     + /,' You have not fixed one  coordinate  in a polar spacegroup?',
     +  ' eg: one XYZ in P1, one Y in P21; one Z in P3',
     + /,/,' You are refining a property whch is indeterminate?',
     + /,'  eg: AX or AOCC without setting DPH; ',
     +   'AX when AOCC equals zero')
      END
C
C
C
C     =====================================
      SUBROUTINE PHASE(HH,HK,HL,ICHK,IFLAG)
C     =====================================
C
C
C
C        implicit none
C
C
C
C
C
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
C     ..
C     .. Scalar Arguments ..
      REAL HH,HK,HL
      INTEGER ICHK,iflag
C     ..
C     .. Scalars in Common ..
      REAL ABEST,CBEST,CentricTestFlag,FcalcA,FcalcB,FcalcW,
     +     FNativeScaled,FOM,SBEST,VarNativeSc
      INTEGER IAngleStep,ICurrentCycle,IIN,INC,NumDerivatives,
     +        NumResoBins
      LOGICAL LAST,LAST1,NOPHAS
C     ..
C     .. Arrays in Common ..
      REAL FHAim,ScaledDPH,ScaledFPH,
     +     FHArl,DerivAnomLimits,DerivIsoLimit,
     +     DerivMaxResol,DerivMinResol,
     +     RmsAnomalError,RmsIsomorphError,FHim,
     +     P,PNORM,FHrl,ScaledSigmaDPH,
     +     DerivSigmaLimit,STAB,ScaledVPH
      INTEGER KRefineCycleFlag
      LOGICAL LPhaseFlagPerDerivative,LRefineFlagPerDerivative
C     ..
C     .. Local Scalars ..
      REAL ADC,C,D,E22,FCC,FHAK,FHBK,FHCK,FHDK,FNEG,FPH,FPOS,PC,PMIN,PP,
     +     R,S,SUM,T,U,V,W,WP
      INTEGER I,K,KK,M
      LOGICAL LDerivFlag
      CHARACTER INDICT*10
C     ..
C     .. Local Arrays ..
      REAL FCO(360),FSI(360)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ATAN2,COS,EXP,INT,MOD,NINT,SIN,SQRT
C     ..
C     .. External Functions ..
      INTEGER  LENSTR
      EXTERNAL LENSTR
C     ..
C     .. Common blocks ..
      COMMON /CURVE/P(360),PNORM(360),IIN,INC
      COMMON /FASE/  
     +  RmsIsomorphError(MaxNumDerivatives,MaxNumResoBins),
     +   RmsAnomalError(MaxNumDerivatives,MaxNumResoBins),
     +     DerivSigmaLimit(MaxNumDerivatives),
     +      DerivIsoLimit(MaxNumDerivatives),
     +       DerivAnomLimits(2,MaxNumDerivatives),
     +        DerivMinResol(2,MaxNumDerivatives),
     +         DerivMaxResol(2,MaxNumDerivatives),
     +          KRefineCycleFlag(MaxNumRefCycles),
     +           ScaledFPH(MaxNumDerivatives),
     +            ScaledDPH(MaxNumDerivatives),
     +             ScaledVPH(MaxNumDerivatives),
     +              ScaledSigmaDPH(MaxNumDerivatives),
     +               FHrl(MaxNumDerivatives),
     +                FHim(MaxNumDerivatives),
     +                 FHArl(MaxNumDerivatives),
     +                  FHAim(MaxNumDerivatives),
     +                   LPhaseFlagPerDerivative(MaxNumDerivatives+1),
     +                    CentricTestFlag,FNativeScaled,
     +                     VarNativeSc,NumDerivatives,
     +                      IAngleStep,NumResoBins,ICurrentCycle,
     +                       LAST,LAST1
      COMMON /HEAVY/
     +  DerivSigmaScale(MaxNumDerivatives),    
     +   DerivScaleToNative(MaxNumDerivatives),
     +   DerivativeNativeScale(MaxNumDerivatives),   
     +    DerivOverallBfact(MaxNumDerivatives),
     +    IndexRefFlags(MaxNumDerivatives+1),  
     +    NAtomsPerDeriv(MaxNumDerivatives),
     +     OCC(MaxNumHeavyAtoms,MaxDataBatches),
     +      AOCC(MaxNumHeavyAtoms,MaxDataBatches),
     +       AFM(MaxNumHeavyAtoms,4),   BFM(MaxNumHeavyAtoms,4),
     +        CFM(MaxNumHeavyAtoms),     FPP(MaxNumHeavyAtoms),
     +         NTROP(MaxNumHeavyAtoms),   B1(MaxNumHeavyAtoms),
     +          B2(MaxNumHeavyAtoms),      B3(MaxNumHeavyAtoms),
     +           B4(MaxNumHeavyAtoms),      B5(MaxNumHeavyAtoms),
     +            B6(MaxNumHeavyAtoms),      X(MaxNumHeavyAtoms),
     +             Y(MaxNumHeavyAtoms),       Z(MaxNumHeavyAtoms),
     +              NDAT(MaxNumDerivatives),   
     +               CALAFF(MaxNumHeavyAtoms),
     +                LRefineFlagPerDerivative(MaxNumDerivatives),
     +                 LANOM(MaxNumDerivatives),
     +                  LBOV(MaxNumDerivatives),
     +                   LEAVE(MaxRefineFlags,MaxNumHeavyAtoms),
     +                    LELEC,LAPPLY
      COMMON /PHAS/
     +     FOM,ABEST,CBEST,SBEST,
     +      FcalcA,FcalcB,FcalcW,
     +       NOPHAS
      COMMON /TABLES/STAB(451)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C
C
C
      M = 0
      KK = (NumResoBins-1)*10
      FOM = 0.0
      ABEST = -99999.0
C
C----   Check for centric  -  CentricTestFlag ne 0.0
C               allowed phase = CentricTestFlag  or CentricTestFlag +180
C
      IF (CentricTestFlag.EQ.0.0) THEN
        IIN = 1
        INC = IAngleStep
      ELSE
        INC = 180
        IIN = MOD(NINT(CentricTestFlag)+18000000,180) + 1
        IF (IIN.LE.0) IIN = IIN + 180
        IF (IIN.GT.180) IIN = IIN - 180
      END IF
C
C
      DO 10 I = IIN,360,INC
        FCO(I) = STAB(I+90)*FNativeScaled
        FSI(I) = STAB(I)*FNativeScaled
        P(I) = 0.0
   10 CONTINUE
C
C
      DO 40 K = 1,NumDerivatives
        KK = KK + 1
C
C----   iflag indicates whether we are setting up info for refinement
C       (iflag=1) or for phasing (iflag=2)
C
        IF (IFLAG.EQ.1) THEN
          LDerivFlag = LRefineFlagPerDerivative(K)
        ELSE IF (IFLAG.EQ.2) THEN
          LDerivFlag = LPhaseFlagPerDerivative(K)
        ELSE
          CALL CCPERR(1, 'S/R PHASE: IFLAG OUT OF RANGE')
        END IF
C
        IF (ScaledFPH(K).GT.0.00001 .AND. LDerivFlag) THEN
            FHBK = RmsIsomorphError(K,NumResoBins) + 
     +              ScaledVPH(K) + VarNativeSc
C
C
          IF (FHBK.EQ.0.0) THEN
            WRITE (6,FMT=6002) K,HH,HK,HL,KK
            GO TO 40
          END IF
C
C
          M = M + 1
          FHAK = ScaledFPH(K)
          FHCK = ScaledDPH(K)
          WP = 1.0
C
C
          IF (ScaledSigmaDPH(K).GE.0.00001) THEN
C
C----  anomalous dispersion
C
            FHDK = ScaledVPH(K)*4.0 + RmsAnomalError(K,NumResoBins)
C
C
            IF (FHDK.EQ.0.0) THEN
              WRITE (6,FMT=6004) K,HH,HK,HL,KK
              GO TO 40
            END IF
C
C
            M = M + 1
            T = FHrl(K) - FHArl(K)
            U = FHim(K) - FHAim(K)
            R = FHrl(K) + FHArl(K)
            S = FHim(K) + FHAim(K)
C
C
            DO 20 I = IIN,360,INC
              V = FCO(I)
              W = FSI(I)
              FPOS = SQRT(ABS((R+V)**2+ (S+W)**2))
              FNEG = SQRT(ABS((T+V)**2+ (U+W)**2))
              ADC = FPOS - FNEG
              FPH = (FPOS+FNEG)/2.0
              P(I) = ((FHAK-FPH)**2/FHBK + 
     +                (FHCK-ADC)**2/FHDK)*WP + P(I)
   20       CONTINUE
C
C
          ELSE
            R = FHrl(K)
            S = FHim(K)
C
C
            DO 30 I = IIN,360,INC
              FPH = SQRT(ABS((FCO(I)+R)**2+ (FSI(I)+S)**2))
              P(I) = ((FHAK-FPH)**2/FHBK)*WP + P(I)
   30       CONTINUE
C
C
          END IF
        END IF
C
C
   40 CONTINUE
C
C
      IF (LPhaseFlagPerDerivative(MaxNumDerivatives+1) .AND. 
     +    FcalcW.GT.0.00001) THEN
C
C---- ejd  I can't see a sensible way to
C          use the PHASE WEIGHT ( SIM?? SIGMAA??) here.
C          Low weight phases neeed to be " smeared" by a large
C          value of E22  .
C
C              FcalcW  = Weight
C
        M = M + 1
        FCC = SQRT(ABS(FcalcA**2+FcalcB**2))
        E22 = ((1.0-FcalcW)*FCC)**2 + VarNativeSc
C
C
        DO 50 I = IIN,360,INC
          FPH = (FcalcA-FCO(I))**2 + (FcalcB-FSI(I))**2
          P(I) = P(I) + FPH/E22
   50   CONTINUE
C
C
      END IF
C
C
      NOPHAS = M .EQ. 0
C
C
      IF (.NOT.NOPHAS) THEN
        C = 0.0
        D = 0.0
        SUM = 0.0
        PMIN = 1.0E20
C
C
        DO 60 I = IIN,360,INC
          IF (P(I).LT.PMIN) THEN
            PMIN = P(I)
          END IF
   60   CONTINUE
C
C
        IF (PMIN.GT.10000.0) THEN
          NOPHAS = .TRUE.
          WRITE (6,FMT='(a,3f10.2)') ' check ',HH,HK,HL
          WRITE (6,FMT=6000) INT(HH),INT(HK),INT(HL),PMIN
 6000     FORMAT (1X,'Reflection HKL:',3I4,' has inconsistent phase li',
     +           'kelihood, log Pmax=',E10.2)
          RETURN
        END IF
C
C
        DO 70 I = IIN,360,INC
          PC = P(I) - PMIN
C
C
          IF (PC.LT.30.0) THEN
            PP = EXP(PC/ (-2.0))
          ELSE
            PP = 0.0
          END IF
C
C
          C = STAB(I+90)*PP + C
          D = STAB(I)*PP + D
          PNORM(I) = PP
          SUM = SUM + PP
   70   CONTINUE
C
C
        DO 80 I = IIN,360,INC
          PNORM(I) = PNORM(I)/SUM
   80   CONTINUE
C
C---- determine figure of merit, centroid phase,
C     and most probable phase
C
        FOM = SQRT(ABS(C**2+D**2))/SUM
        ABEST = 0.0
        IF (FOM.GT.0.0001)   ABEST = ATAN2(D,C)
C
C
        IF (ABEST.LT.0.0) ABEST = ABEST + TWOPI
        CBEST = COS(ABEST)
        SBEST = SIN(ABEST)
      ELSE
        FOM = 0.0
        CBEST = 1.0
        SBEST = 0.0
      END IF
C
C
      IF (ICHK.EQ.1) THEN
        IF (IFLAG.EQ.1) THEN
          INDICT = 'refinement'
        ELSE
          INDICT = 'phasing'
        END IF
        WRITE (6,FMT=6006) INDICT(1:LENSTR(INDICT)),FOM,C,D,ABEST
        RETURN
      END IF
C
 6002 FORMAT (
     +' NOTE: The Mean square isomorphous error for compound ',I4,
     +' is 0.0 for HKL = ',3F5.0,' i.e.  EIS(',I3,') = 0.0')
 6004 FORMAT (
     +' NOTE:  The Mean square anomalous error for compound ',I4,
     +' is 0.0 for HKL =',3F5.0,'  i.e.  EAD(',I3,') = 0.0')
 6006 FORMAT (/,
     +' In PHASE (',A,'): FoM=',F7.4,' c=',F7.4,' d=',F7.4,
     +' A_best=',F7.4)
C
C
      END
C
C
C
C     ==============================================================
      SUBROUTINE REFINE(TRIX,RHS,JPOS,NREJ,DST,HH,HK,HL,ICHK)
C     ================================================================
C
C  MaxNumFigMeritBins  for  figure of merit analysis - maximum is 8 now.
C  Changed to fit format statements for resolution analysis output
C
C        implicit none
C
C
C
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
C     ..
C     .. Scalar Arguments ..
      REAL DST,HH,HK,HL
      INTEGER ICHK,NREJ
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION RHS(MaxNumRefVariables),TRIX(MaxSizeMatrix)
      INTEGER JPOS(*)
C     ..
C     .. Scalars in Common ..
      REAL ABEST,ACL,CBEST,CentricTestFlag,FcalcA,FcalcB,
     +     FcalcW,FNativeScaled,FOM,SBEST,VarNativeSc,SSQOL4,STMAX,
     +     STMIN,THR
      INTEGER IAngleStep,IAVE,IAVF,ICOR,ICurrentCycle,Ifom,IIN,INC,
     +        IRMSE,IRMSF,ISTAT,IW1AVE,IW1RMS,IW2AVE,IW2RMS,
     +        NumDerivatives,NumhklMonitored,NumRefVariables,NumResoBins
      LOGICAL LAST,LAST1,LCOR,LELEC,LAPPLY,LSTAT,NOPHAS
C     ..
C     .. Arrays in Common ..
      REAL FHAim,AFM,AOCC,ScaledDPH,
     +     FHArl,ASQ,B1,B2,B3,B4,B5,B6,BFM,DerivOverallBfact,
     +     CFM,DerivAnomLimits,DERIV1,DERIV2,
     +     DerivIsoLimit,DerivMaxResol,
     +     DerivMinResol,RmsAnomalError,RmsIsomorphError,FHim,ESQ,
     +     ScaledFPH,FPP,OCC,P,PNORM,
     +     DerivScaleToNative,DerivativeNativeScale,
     +     FHrl,SAADC,SAADO,SADCSQ,
     +     SumAbsFPHobsFnat,SADOSQ,SumPrFPHobsFPHcalc,
     +     SASQ,DerivSigmaScale,ScaledSigmaDPH,
     +     SumSqrdFPHobsFnat,SESQ,SumFHcalc,SumFHA,
     +     SumFigMerit,SumFNativeScaled,SumFPHobs,
     +     DerivSigmaLimit,SLCA,SLCAQ,SumSqrdPrFPHobsFPHcalc,
     +     SumDeltaPhi,SumSqrdDeltaPhi,STAB,SumWsig,
     +     SumWsigA,SumWsigAADO,SumWsigADOS,SumWsigFPHobsFnat,
     +     SumSqrdWsigFPHobsFnat,SumWsigLCA,
     +     SumWsigLCAQ,SumWsigLackClosure,
     +     SumLackClosureWgtSqrd,SW,
     +     SumAnomWgtModPrPhase,SumAnomWgtModPrPhaseADO,
     +     SumAnomWgtModPrPhaseDOS,SumW1FPHobsFnat,
     +     SumW1FPHobsFnatSqrd,SWLCA,SWLCAQ,
     +     SumWghtFPHobsFPHcalc,SumW1SqrdLackClosure,
     +     ScaledVPH,X,Y,Z
      INTEGER IndexRefFlags,JNDEX,KRefineCycleFlag,Mcount,
     +        NumPhasedperDeriv,NumAnomPhasesPerDeriv,
     +        NAtomsPerDeriv,NDAT,NTROP
      LOGICAL CALAFF,LANOM,LBOV,LEAVE,
     +        LPhaseFlagPerDerivative,LRefineFlagPerDerivative
C     ..
C     .. Local Scalars ..
      REAL ADC,ADCSQ,ADO,ADOBS,AEM,ALHVY,ALOC,ARE,AX,BY,EDER,EM,ENAT,FH,
     +     FHA,FHSQ,FNEG,FPA,FPB,FPH,FPHOBS,
     +     FPHSQ,FPOS,FPSQ,LCA,LCAQ,
     +     LOC,LOCQ,PHIDEL,QT,RE,RES,VCALC,VOBS,W1,W2,WA,WSIG,XX,YY,
     +     ZZ
      INTEGER I,IABEST,Kderiv,IHH,IHK,IHL,IPHAS,J,J1,J2,JCEN,M,N
C     ..
C     .. Local Arrays ..
      REAL DER(MaxNumRefVariables)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,ATAN2,DBLE,INT,MOD,NINT,REAL,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANALYS/ICOR,ISTAT,IAVF,IRMSF,IAVE,IRMSE,IW1AVE,IW1RMS,
     +       IW2AVE,IW2RMS,Ifom,NumhklMonitored
      COMMON /CURVE/P(360),PNORM(360),IIN,INC
      COMMON /DERIV/  DERIV1(MaxNumRefVariables),
     +                 DERIV2(MaxNumRefVariables),
     +                  JNDEX(2*MaxNumDerivatives+1),
     +                   NumRefVariables,SSQOL4
      COMMON /FASE/  
     +  RmsIsomorphError(MaxNumDerivatives,MaxNumResoBins),
     +   RmsAnomalError(MaxNumDerivatives,MaxNumResoBins),
     +     DerivSigmaLimit(MaxNumDerivatives),
     +      DerivIsoLimit(MaxNumDerivatives),
     +       DerivAnomLimits(2,MaxNumDerivatives),
     +        DerivMinResol(2,MaxNumDerivatives),
     +         DerivMaxResol(2,MaxNumDerivatives),
     +          KRefineCycleFlag(MaxNumRefCycles),
     +           ScaledFPH(MaxNumDerivatives),
     +            ScaledDPH(MaxNumDerivatives),
     +             ScaledVPH(MaxNumDerivatives),
     +              ScaledSigmaDPH(MaxNumDerivatives),
     +               FHrl(MaxNumDerivatives),
     +                FHim(MaxNumDerivatives),
     +                 FHArl(MaxNumDerivatives),
     +                  FHAim(MaxNumDerivatives),
     +                   LPhaseFlagPerDerivative(MaxNumDerivatives+1),
     +                    CentricTestFlag,FNativeScaled,
     +                     VarNativeSc,NumDerivatives,
     +                      IAngleStep,NumResoBins,ICurrentCycle,
     +                       LAST,LAST1
      COMMON /HEAVY/
     +  DerivSigmaScale(MaxNumDerivatives),    
     +   DerivScaleToNative(MaxNumDerivatives),
     +   DerivativeNativeScale(MaxNumDerivatives),   
     +   DerivOverallBfact(MaxNumDerivatives),
     +    IndexRefFlags(MaxNumDerivatives+1),  
     +    NAtomsPerDeriv(MaxNumDerivatives),
     +     OCC(MaxNumHeavyAtoms,MaxDataBatches),
     +      AOCC(MaxNumHeavyAtoms,MaxDataBatches),
     +       AFM(MaxNumHeavyAtoms,4),   BFM(MaxNumHeavyAtoms,4),
     +        CFM(MaxNumHeavyAtoms),     FPP(MaxNumHeavyAtoms),
     +         NTROP(MaxNumHeavyAtoms),   B1(MaxNumHeavyAtoms),
     +          B2(MaxNumHeavyAtoms),      B3(MaxNumHeavyAtoms),
     +           B4(MaxNumHeavyAtoms),      B5(MaxNumHeavyAtoms),
     +            B6(MaxNumHeavyAtoms),      X(MaxNumHeavyAtoms),
     +             Y(MaxNumHeavyAtoms),       Z(MaxNumHeavyAtoms),
     +              NDAT(MaxNumDerivatives),   
     +               CALAFF(MaxNumHeavyAtoms),
     +                LRefineFlagPerDerivative(MaxNumDerivatives),
     +                 LANOM(MaxNumDerivatives),
     +                  LBOV(MaxNumDerivatives),
     +                   LEAVE(MaxRefineFlags,MaxNumHeavyAtoms),
     +                    LELEC,LAPPLY
      COMMON /PHAS/
     +     FOM,ABEST,CBEST,SBEST,
     +      FcalcA,FcalcB,FcalcW,
     +       NOPHAS
      COMMON /STATA1/ Mcount(MaxNumResoBins,2), 
     + SumFigMerit(MaxNumResoBins,2),
     + NumPhasedperDeriv(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumDeltaPhi(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumSqrdDeltaPhi(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumFNativeScaled(MaxNumDerivatives,MaxNumResoBins,
     +                  MaxNumFigMeritBins,2),
     + SumFPHobs(MaxNumDerivatives,MaxNumResoBins,
     +           MaxNumFigMeritBins,2),
     + SumFHcalc(MaxNumDerivatives,MaxNumResoBins,
     +           MaxNumFigMeritBins,2),
     + SumFHA(MaxNumDerivatives,MaxNumResoBins,
     +        MaxNumFigMeritBins),
     + SumAbsFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                  MaxNumFigMeritBins,2),
     + SumPrFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumWsigFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2)
      COMMON /STATA3/
     + SumWsigLackClosure(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumW1FPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                 MaxNumFigMeritBins,2),
     + SumWghtFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins,2),
     + SumSqrdFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumSqrdPrFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                        MaxNumFigMeritBins,2),
     + SumSqrdWsigFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins,2),
     + SumLackClosureWgtSqrd(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins,2),
     + SumW1FPHobsFnatSqrd(MaxNumDerivatives,MaxNumResoBins,
     +                     MaxNumFigMeritBins,2),
     + SumW1SqrdLackClosure(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins,2),
     + SW(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SumWsig(MaxNumDerivatives,MaxNumResoBins,
     +         MaxNumFigMeritBins,2),
     + NumAnomPhasesPerDeriv(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins),
     + SAADC(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins)
      COMMON /STATB2/
     + SADCSQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SAADO(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SLCA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SADOSQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SLCAQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumWsigAADO(MaxNumDerivatives,MaxNumResoBins,
     +             MaxNumFigMeritBins),
     + SumWsigLCA(MaxNumDerivatives,MaxNumResoBins,
     +            MaxNumFigMeritBins),
     + SumWsigADOS(MaxNumDerivatives,MaxNumResoBins,
     +             MaxNumFigMeritBins),
     + SumWsigLCAQ(MaxNumDerivatives,MaxNumResoBins,
     +             MaxNumFigMeritBins),
     + SumAnomWgtModPrPhaseADO(MaxNumDerivatives,MaxNumResoBins,
     +                         MaxNumFigMeritBins)
      COMMON /STATB4/
     + SWLCA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhaseDOS(MaxNumDerivatives,MaxNumResoBins,
     +                         MaxNumFigMeritBins),
     + SWLCAQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhase(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins),
     + SumWsigA(MaxNumDerivatives,MaxNumResoBins,
     +          MaxNumFigMeritBins),
     + SESQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SASQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + ESQ(MaxNumDerivatives,MaxNumResoBins),
     + ASQ(MaxNumDerivatives,MaxNumResoBins),
     + STMIN,STMAX,THR,ACL,LCOR,LSTAT
      COMMON /TABLES/STAB(451)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C
C
C
      IF (ICHK.EQ.1) THEN
        IHH = INT(HH)
        IHK = INT(HK)
        IHL = INT(HL)
        IABEST = NINT(ABEST*RADDEG)
C
        WRITE (6,FMT=6004)
     +    'In REFINE: No of resoln shells:',NumResoBins,
     +    'FNativeScaled  SIGNAT   ABEST     FOM',
     +    FNativeScaled,VarNativeSc,IABEST,FOM,
     +    (' DERIV F D SIG ',ScaledFPH(I),ScaledDPH(I),
     +    ScaledVPH(I),I=1,NumDerivatives),
     +    ' FCALC',FcalcA,FcalcB,FcalcW
 6004     FORMAT(/,1x,a,i6,/,5x,a,/,11x,2f8.1,I8,f8.4,/,
     +         9(/,a,3x,3f8.1),/,a,3x,3f8.3)
C
C
        WRITE (6,FMT='(a,i6,9(/,a,3x,4f8.1))')
     +  ' In REFINE: No of resoln shells:',NumResoBins,
     + (' FHCALC A B Aano Bano',FHrl(I),FHim(I),
     +    FHArl(I),FHAim(I),I=1,NumDerivatives)
      END IF
C
C
      Ifom = INT(REAL(MaxNumFigMeritBins)*FOM) + 1
      IF (Ifom.GT.MaxNumFigMeritBins) Ifom = MaxNumFigMeritBins
C
C----  Statistics seperate for each  resolution, fom, centric shell...
C      JCEN = 1 for acentrics: =2 for centric reflection.
C
      JCEN = 1
      IF (CentricTestFlag.NE.0.0) JCEN = 2
C
C----   Include FOM analysis
C
      Mcount(NumResoBins,JCEN) = Mcount(NumResoBins,JCEN) + 1
      SumFigMerit(NumResoBins,JCEN) = 
     + SumFigMerit(NumResoBins,JCEN) + FOM
C
C
      DO 90 IPHAS = IIN,360,INC
C
C
        DO 10 I = 1,NumRefVariables
          DER(I) = 0.0
   10   CONTINUE
C
C
        FPA = STAB(IPHAS+90)*FNativeScaled
        FPB = STAB(IPHAS)*FNativeScaled
        FPSQ = FNativeScaled**2
C
C
        DO 80 Kderiv = 1,NumDerivatives
C
C---  Check should be on Sigma
C
          ARE = 0.0
          AEM = 0.0
          ADC = 0.0
          ALHVY = -999.0
C
C
          IF (ScaledVPH(Kderiv).GT.0.0001) THEN
            FPHOBS = ScaledFPH(Kderiv)
            VOBS = ScaledVPH(Kderiv)
            RE = FHrl(Kderiv)
            EM = FHim(Kderiv)
            ARE = FHArl(Kderiv)
            AEM = FHAim(Kderiv)
C
C---- work out anomalous contribution to FH here
C     It matters a lot for multi wave length stats!!
C
            FHSQ = (ARE)**2 + (AEM)**2
            FHA = SQRT(ABS(FHSQ))
            FHSQ = (RE)**2 + (EM)**2
            FH = SQRT(ABS(FHSQ))
            IF (FH.GT.0.00000001) ALHVY = ATAN2(EM,RE)
            AX = FPA + RE
            BY = FPB + EM
C
C
            IF (ScaledSigmaDPH(Kderiv).GE.0.0000001) THEN
              FPOS = SQRT(ABS((AX+ARE)**2+ (BY+AEM)**2))
              FNEG = SQRT(ABS((AX-ARE)**2+ (BY-AEM)**2))
              ADC = FPOS - FNEG
              FPH = (FPOS+FNEG)/2.0
              FPHSQ = FPH**2
            ELSE
              FPHSQ = AX**2 + BY**2
              FPH = SQRT(ABS(FPHSQ))
            END IF
C
C
            LOC = FPHOBS - FPH
            LOCQ = LOC**2
C
C----  I can't see the point of this:  VCALC is approx VarNativeSc
C
C  Avoid division by zero
C
            VCALC = 0.00
C
C
            IF (ABS(FNativeScaled*FPH).GE.0.0001) 
     +          VCALC = ((FPA*RE+FPSQ+FPB*EM)/
     +                (FNativeScaled*FPH))**2*VarNativeSc
C
C
C  VCALC = ((FPA*RE+FPSQ+FPB*EM)/ (FNativeScaled*FPH))**2*VarNativeSc
C
C----EJD  Centric terms have (error)**2 = 2 * that of acentrics.
C       SHOULD this all be doubled?
C      - make sure RmsIsomorphError is obtained from acentrics and
C        double it for centrics
C
C             VOBS = SD(FPH(..)) **2
C
ccx ????? W2 never used why set it
ccx
            IF (VOBS.LE.0.00001) THEN
              W2 = PNORM(IPHAS)/RmsIsomorphError(Kderiv,NumResoBins)
            ELSE
              W2 = PNORM(IPHAS)/VOBS
            END IF
C
C
            WSIG = 0.0
C
C
            IF (VOBS.LE.0.00001 .OR. VarNativeSc.LE.0.00001) THEN
              XX = RmsIsomorphError(Kderiv,NumResoBins)
            ELSE
              WSIG = FOM/ (VOBS+VarNativeSc)
              XX = VOBS + VCALC + RmsIsomorphError(Kderiv,NumResoBins)
            END IF
C
C
            W1 = PNORM(IPHAS)/XX
C
C
            IF (W1.GT.16000.0) THEN
C
C----  reject reflection for refinement if lack of
C      closure greater than  four sigma
C
C     nrej 'counts' rejected reflections and controls their printout
C
              NREJ = NREJ + 1
C
C
              IF (LAST) THEN
                IF (MOD(NREJ,50).EQ.1) THEN
                  WRITE (6,FMT=6000)
                END IF
                ENAT = SQRT(ABS(VarNativeSc))
                EDER = SQRT(ABS(VOBS))
C
C
                ZZ = SQRT(ABS(EM*EM+RE*RE))
                IF (ZZ.GT.0.0001) ZZ = ATAN2(EM,RE)*360.0/TWOPI
                IF (ZZ.LT.0.0) ZZ = ZZ + 360.0
                J = NINT(ZZ + 0.5)
                RES = 1.0/DST
                WRITE (6,FMT=6002) Kderiv,HH,HK,HL,RES,FNativeScaled,
     +            ENAT,FPHOBS,EDER,FPH,LOC,FH,J,FOM
              END IF
              ScaledFPH(Kderiv) = 0.0
              GO TO 80
            END IF
C
C
            YY = LOCQ - VOBS - VCALC
C
C
            IF (YY.GT.0.00001) THEN
              ESQ(Kderiv,NumResoBins) = PNORM(IPHAS)*YY +
     +                                  ESQ(Kderiv,NumResoBins)
              SESQ(Kderiv,NumResoBins,Ifom,JCEN) = PNORM(IPHAS)*YY +
     +          SESQ(Kderiv,NumResoBins,Ifom,JCEN)
            END IF
C
C----EJD    We don't really need to sum all this stuff for cycles
C           where there is to be no output.  ESQ and ASQ are used to
C           reset the errors and we need NumPhasedperDeriv(..)
C
C           LOC is the lack of closure at this phase value.
C
            ALOC = ABS(LOC)
C
C----   Count once round the phase circle
C       All statistics summed by PNORM(..) are using the fact that
C       Sum(PNORM(..) = 1.0!! ) - only need to be summed once.
C       D1-SumFPHobs, 
C       D2-SumPrFPHobsFPHcalc 
C       D3 out 
C       D4-SumFHcalc 
C       D5-SumWghtFPHobsFPHcalc 
C       D6-SumSqrdPrFPHobsFPHcalc 
C       D7-SFHSQ
C       D8-SumWgt2FPHobsSqrd 
C       D9-SumW1SqrdLackClosure 
C       D10-SumSqrdFPHobsFnat
C       WT1 - SW   
C       WT2 - SWT2  
C       WT3 out
C
            IF (IPHAS.EQ.IIN) THEN
              NumPhasedperDeriv(Kderiv,NumResoBins,Ifom,JCEN) = 
     +        NumPhasedperDeriv(Kderiv,NumResoBins,Ifom,JCEN) + 1
C
C----  I think I want FP**2;
C                     FHPOBS**2;
C                     FH**2;
C                     DISO**2/SIGS**2;
C                     WSIG*LOCQ
C
C      (Remember:
C         DISO**2 /SIGS**2 = DISO**2*WSIG since  Sum((PNORM(IPHAS))
C
C        round phase circle = 1 and wSIG = pnorm/SIGS**2..)
C
C
              SumFNativeScaled(Kderiv,NumResoBins,Ifom,JCEN) = 
     +          SumFNativeScaled(Kderiv,NumResoBins,Ifom,JCEN) + 
     +           FNativeScaled
              SumFPHobs(Kderiv,NumResoBins,Ifom,JCEN) = 
     +          SumFPHobs(Kderiv,NumResoBins,Ifom,JCEN) + FPHOBS
              SumFHcalc(Kderiv,NumResoBins,Ifom,JCEN) = 
     +          SumFHcalc(Kderiv,NumResoBins,Ifom,JCEN) + FH
              SumFHA(Kderiv,NumResoBins,Ifom) = 
     +          SumFHA(Kderiv,NumResoBins,Ifom) + FHA
C
C----   Include FOM analysis  and Phase difference
C          Add up phase differences
C
              IF (ALHVY.NE.-999.0) THEN
                PHIDEL = ABS((360.0/TWOPI)* (ALHVY-ABEST))
                PHIDEL = MOD((PHIDEL+3600.0),360.0)
                IF (PHIDEL.GT.180.0) PHIDEL = 360.0 - PHIDEL
C
C
                SumDeltaPhi(Kderiv,NumResoBins,Ifom,JCEN) = 
     +            SumDeltaPhi(Kderiv,NumResoBins,Ifom,JCEN) + 
     +             PHIDEL
                SumSqrdDeltaPhi(Kderiv,NumResoBins,Ifom,JCEN) = 
     +            SumSqrdDeltaPhi(Kderiv,NumResoBins,Ifom,JCEN) + 
     +             PHIDEL*PHIDEL
              END IF
C
C----  Leave these here although I don't think they are useful.
C
              SumAbsFPHobsFnat(Kderiv,NumResoBins,Ifom,JCEN) = 
     +          SumAbsFPHobsFnat(Kderiv,NumResoBins,Ifom,JCEN) +
     +           ABS(FPHOBS-FNativeScaled) 
              SumSqrdFPHobsFnat(Kderiv,NumResoBins,Ifom,JCEN) = 
     +         SumSqrdFPHobsFnat(Kderiv,NumResoBins,Ifom,JCEN) +
     +          (FPHOBS-FNativeScaled)**2 
            END IF
C
C---- Two more summed over phase circle..
C     Oops WSIG ones do not need it..
C
            SumWsigFPHobsFnat(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumWsigFPHobsFnat(Kderiv,NumResoBins,Ifom,JCEN) +
     +        ABS(FPHOBS-FNativeScaled)*WSIG 
            SumSqrdWsigFPHobsFnat(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumSqrdWsigFPHobsFnat(Kderiv,NumResoBins,Ifom,JCEN) +
     +        (FPHOBS-FNativeScaled)**2*WSIG 
            SumW1FPHobsFnat(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumW1FPHobsFnat(Kderiv,NumResoBins,Ifom,JCEN) +
     +        ABS(FPHOBS-FNativeScaled)*W1 
            SumW1FPHobsFnatSqrd(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumW1FPHobsFnatSqrd(Kderiv,NumResoBins,Ifom,JCEN) +
     +        (FPHOBS-FNativeScaled)**2*W1 
            SumPrFPHobsFPHcalc(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumPrFPHobsFPHcalc(Kderiv,NumResoBins,Ifom,JCEN) +
     +        PNORM(IPHAS)*ALOC 
            SumSqrdPrFPHobsFPHcalc(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumSqrdPrFPHobsFPHcalc(Kderiv,NumResoBins,Ifom,JCEN) +
     +        PNORM(IPHAS)*LOCQ 
            SumWsigLackClosure(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumWsigLackClosure(Kderiv,NumResoBins,Ifom,JCEN) +
     +        ABS(LOC)*WSIG 
            SumLackClosureWgtSqrd(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumLackClosureWgtSqrd(Kderiv,NumResoBins,Ifom,JCEN) + 
     +        WSIG*LOCQ
            SumWghtFPHobsFPHcalc(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumWghtFPHobsFPHcalc(Kderiv,NumResoBins,Ifom,JCEN) +
     +        ABS(LOC)*W1
            SumW1SqrdLackClosure(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumW1SqrdLackClosure(Kderiv,NumResoBins,Ifom,JCEN) + 
     +        W1*LOCQ
            SumWsig(Kderiv,NumResoBins,Ifom,JCEN) = 
     +       SumWsig(Kderiv,NumResoBins,Ifom,JCEN) + WSIG
C
C----  Leave these here although I don't think they are useful.
C
            SW(Kderiv,NumResoBins,Ifom,JCEN) = 
     +         SW(Kderiv,NumResoBins,Ifom,JCEN) + W1
C
C----  shift to input derivative scale
C      EJD I can see no point in this...
C
            QT = 1.0/DerivativeNativeScale(Kderiv)
C
C----  anomalous scattering if any
C
            WSIG = 0.0
C
C
            IF (ScaledSigmaDPH(Kderiv).GE.0.00001) THEN
              XX = 4.0*VOBS + RmsAnomalError(Kderiv,NumResoBins)
              WA = PNORM(IPHAS)/XX
              WSIG = PNORM(IPHAS)/ (4.0*VOBS)
              ADO = ScaledDPH(Kderiv)
              ADOBS = ScaledDPH(Kderiv)
C
C----  ADC is calculated ano diff
C
              ADCSQ = ADC**2
              LCA = ADOBS - ADC
              LCAQ = LCA**2
C
C
              IF (LCAQ.LT.1.0E16*XX) THEN
                YY = LCAQ - 4.0*VOBS
                IF (YY.GT.0.00001) THEN
                  ASQ(Kderiv,NumResoBins) = PNORM(IPHAS)*YY +
     +                                      ASQ(Kderiv,NumResoBins)
                  SASQ(Kderiv,NumResoBins,Ifom) = PNORM(IPHAS)*YY +
     +                               SASQ(Kderiv,NumResoBins,Ifom)
                END IF
C
C----  I think I want ABS(ADO) ABS(ADC)   ... ccx ado never used ?????
C
C        ADOBS**2/SIGSQ; ADCSQ**2; (ADOBS-ADC)**2/W;
C        Count once round the phase circle
C
                IF (IPHAS.EQ.IIN) THEN
                  NumAnomPhasesPerDeriv(Kderiv,NumResoBins,Ifom) = 
     +             NumAnomPhasesPerDeriv(Kderiv,NumResoBins,Ifom) + 1
                  SAADO(Kderiv,NumResoBins,Ifom) = 
     +             SAADO(Kderiv,NumResoBins,Ifom) + ABS(ADOBS)
                  SADOSQ(Kderiv,NumResoBins,Ifom) = 
     +             SADOSQ(Kderiv,NumResoBins,Ifom) + ADOBS**2
                END IF
C
C
                SAADC(Kderiv,NumResoBins,Ifom) = 
     +           PNORM(IPHAS)*ABS(ADC) +
     +            SAADC(Kderiv,NumResoBins,Ifom)
                SADCSQ(Kderiv,NumResoBins,Ifom) = 
     +           PNORM(IPHAS)*ADCSQ +
     +            SADCSQ(Kderiv,NumResoBins,Ifom)
                SumWsigAADO(Kderiv,NumResoBins,Ifom) = 
     +           SumWsigAADO(Kderiv,NumResoBins,Ifom) +
     +            ABS(ADOBS)*WSIG 
                SumWsigADOS(Kderiv,NumResoBins,Ifom) = 
     +           SumWsigADOS(Kderiv,NumResoBins,Ifom) +
     +            ADOBS**2*WSIG 
                SumAnomWgtModPrPhaseADO(Kderiv,NumResoBins,Ifom) = 
     +           SumAnomWgtModPrPhaseADO(Kderiv,NumResoBins,Ifom) +
     +            ABS(ADOBS)*WA 
                SumAnomWgtModPrPhaseDOS(Kderiv,NumResoBins,Ifom) = 
     +           SumAnomWgtModPrPhaseDOS(Kderiv,NumResoBins,Ifom) +
     +            ADOBS**2*WA 
                SLCA(Kderiv,NumResoBins,Ifom) = 
     +           PNORM(IPHAS)*ABS(LCA) +
     +            SLCA(Kderiv,NumResoBins,Ifom)
                SLCAQ(Kderiv,NumResoBins,Ifom) = 
     +           PNORM(IPHAS)*LCAQ +
     +            SLCAQ(Kderiv,NumResoBins,Ifom)
                SumWsigLCA(Kderiv,NumResoBins,Ifom) = 
     +           SumWsigLCA(Kderiv,NumResoBins,Ifom) +
     +            ABS(LCA)*WSIG 
                SumWsigLCAQ(Kderiv,NumResoBins,Ifom) = 
     +           SumWsigLCAQ(Kderiv,
     +            NumResoBins,Ifom) + WSIG*LCAQ
                SWLCA(Kderiv,NumResoBins,Ifom) = 
     +           ABS(LCA)*WA +
     +            SWLCA(Kderiv,NumResoBins,Ifom)
                SWLCAQ(Kderiv,NumResoBins,Ifom) = 
     +           SWLCAQ(Kderiv,NumResoBins,Ifom) + 
     +            WA*LCAQ
                SumWsigA(Kderiv,NumResoBins,Ifom) = 
     +           SumWsigA(Kderiv,NumResoBins,Ifom) + 
     +            WSIG
                SumAnomWgtModPrPhase(Kderiv,NumResoBins,Ifom) = 
     +           SumAnomWgtModPrPhase(Kderiv,NumResoBins,Ifom) + WA
C
C----   derivative scale
C
C  Take this out same as d11 - SADCSQ
C r11(Kderiv,NumResoBins) = r11(Kderiv,NumResoBins) + adcsq * pnorm(iphas)
C
C     Refinement
C
                IF (LRefineFlagPerDerivative(Kderiv)) THEN
                  XX = (AX+ARE)/FPOS + (AX-ARE)/FNEG
                  YY = (BY+AEM)/FPOS + (BY-AEM)/FNEG
                  J1 = JNDEX(2*Kderiv-1)
                  J2 = JNDEX(2*Kderiv) - 1
C
C
                  IF (J2.GE.J1) THEN
                    DO 20 J = J1,J2
                      DER(J) = DERIV1(J)*XX + DERIV2(J)*YY
   20               CONTINUE
                    M = JPOS(2*Kderiv-1)
C
C
                    DO 40 J = J1,J2
                      XX = DER(J)*WA
                      DO 30 N = J,J2
                        TRIX(M) = DBLE(DER(N)*XX) + TRIX(M)
                        M = M + 1
   30                 CONTINUE
                      RHS(J) = RHS(J) + DBLE(XX*LCA)
   40               CONTINUE
C
C
                  END IF
                END IF
              END IF
            END IF
C
C
            IF (LRefineFlagPerDerivative(Kderiv)) THEN
              J1 = JNDEX(2*Kderiv)
              DER(J1) = FPH/DerivScaleToNative(Kderiv)
              J1 = J1 + 1
C
C
              IF (LBOV(Kderiv)) THEN
                DER(J1) = FPH*SSQOL4/4.0
                J1 = J1 + 1
              END IF
C
C
              J2 = JNDEX(2*Kderiv+1) - 1
C
C
              IF (J2.GE.J1) THEN
                XX = AX/FPH
                YY = BY/FPH
C
C
                DO 50 J = J1,J2
                  DER(J) = DERIV1(J)*XX + DERIV2(J)*YY
   50           CONTINUE
              END IF
              J1 = JNDEX(2*Kderiv)
              M = JPOS(2*Kderiv)
C
C
              DO 70 J = J1,J2
                XX = DER(J)*W1
                DO 60 N = J,J2
                  TRIX(M) = DBLE(DER(N)*XX) + TRIX(M)
                  M = M + 1
   60           CONTINUE
                RHS(J) = RHS(J) + DBLE(XX*LOC)
   70         CONTINUE
C
C
            END IF
          END IF
C
C
   80   CONTINUE
   90 CONTINUE
      RETURN
C
C
 6000 FORMAT (' Rejected Reflections',/'  N   H    K    L   RES',6X,
     +       'FNativeScaled   SIGMA',6X,'FPHS   SIGMA',6X,'FPHC',6X,
     +       'LOC',7X,'FH  PHI H   FOM',/)
 6002 FORMAT (I3,3F5.0,F5.1,2 (F10.2,F8.2),3F10.2,I5,F6.2)
C
      END
C
C
C
C     =======================================================
      SUBROUTINE SHIFTS(A,RA,DA,IDA,NA,B,RB,DB,IDB,NB,Kderiv,
     +                   OccESD,AoccESD,CutOffNatSigma)
C     =======================================================
C
C        implicit none
C
C
C----  Work out ESQ for this derivative
C      ESQ from old program
C
C     This is the rms iso error used for the next cycle in
C     the ZO version Store esq here instead of recalculating
C     it in MAIN
C
C
C
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
C     ..
C     .. Scalar Arguments ..
      DOUBLE PRECISION DA,DB
      INTEGER IDA,IDB,Kderiv,NA,NB
C     ..
C     .. Array Arguments ..
      DOUBLE PRECISION A(*),B(*),RA(*),RB(*)
C
      REAL   OccESD(*),AoccESD(*)
      REAL   CutOffNatSigma
C     ..
C     .. Scalars in Common ..
      REAL ACL,CentricTestFlag,FNativeScaled,VarNativeSc,STMAX,
     +     STMIN,THR
      INTEGER IAngleStep,IAVE,IAVF,ICOR,ICurrentCycle,Ifom,IRMSE,IRMSF,
     +        ISTAT,IW1AVE,IW1RMS,IW2AVE,IW2RMS,NumDerivatives,
     +        NumhklMonitored,NumResoBins
      LOGICAL LAST1,LCOR,LELEC,LAPPLY,LAST,LSTAT
C     ..
C     .. Arrays in Common ..
      REAL FHAim,AFM,AOCC,ScaledDPH,
     +     FHArl,ASQ,B1,B2,B3,B4,B5,B6,BFM,DerivOverallBfact,
     +     CFM,DerivAnomLimits,DerivIsoLimit,
     +     DerivMaxResol,DerivMinResol,
     +     RmsAnomalError,RmsIsomorphError,
     +     FHim,ESQ,ScaledFPH,FPP,OCC,
     +     DerivativeNativeScale,SumSqrdFPHobsFnat,
     +     FHrl,SAADC,SumAbsFPHobsFnat,SumPrFPHobsFPHcalc,
     +     SASQ,DerivSigmaScale,ScaledSigmaDPH,
     +     SESQ,SumFHcalc,SumFHA,SumFigMerit,
     +     SumFNativeScaled,SumFPHobs,
     +     DerivSigmaLimit,SumSqrdPrFPHobsFPHcalc,SumDeltaPhi,
     +     SumSqrdDeltaPhi,SumWsig,SumWsigA,
     +     SumWsigFPHobsFnat,
     +     SumSqrdWsigFPHobsFnat,
     +     SumWsigLackClosure,SumLackClosureWgtSqrd,
     +     SW,SumAnomWgtModPrPhase,SumAnomWgtModPrPhaseDOS,
     +     SumW1FPHobsFnat,SumW1FPHobsFnatSqrd,SWLCA,
     +     SWLCAQ,SumWghtFPHobsFPHcalc,
     +     SumW1SqrdLackClosure,ScaledVPH,X,Y,Z
      INTEGER IndexRefFlags,KRefineCycleFlag,Mcount,
     +        NumPhasedperDeriv,NumAnomPhasesPerDeriv,
     +        NAtomsPerDeriv,NDAT,NTROP
      LOGICAL CALAFF,LANOM,LBOV,LEAVE,
     +        LPhaseFlagPerDerivative,LRefineFlagPerDerivative
      CHARACTER ATNAME*4,DerivTitle*80
C     ..
C     .. Local Scalars ..
      DOUBLE PRECISION ACONS,CONST,TT
      REAL SumFigMeritTA,SumFigMeritTC,SumFigMeritTT,
     +     SHIFT,SIGMA,SSL,T,U
      INTEGER I,IA,IB,J,JA,JB,JJ,L,LHIGH,LOW,M,MCOUTA,MCOUTC,MCOUTT,MM,
     +        MU,NDA,NN
      CHARACTER LINEO1*80,LINEO2*80,LAB*40
C     ..
C     .. Local Arrays ..
      REAL BUF(9,11),Buff(MaxNumDerivatives+1,2),
     +     BuffA(MaxNumDerivatives+1),BUFT(MaxNumDerivatives+1),
     +     COR(MaxNumRefVariables),RES(8),S(9),SH(8),SI(8)
      INTEGER MBuff(MaxNumDerivatives+1,2),MBuffA(MaxNumDerivatives+1),
     +        MBUFT(MaxNumDerivatives+1)
C     ..
C     .. External Functions ..
      INTEGER LENSTR
      EXTERNAL LENSTR
C     ..
C     .. External Subroutines ..
      EXTERNAL ANALBS
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,AINT,DBLE,INT,LOG10,REAL,SQRT
C     ..
C     .. Common blocks ..
      COMMON /ANALYS/ICOR,ISTAT,IAVF,IRMSF,IAVE,IRMSE,IW1AVE,IW1RMS,
     +       IW2AVE,IW2RMS,Ifom,NumhklMonitored
      COMMON /FASE/  
     +  RmsIsomorphError(MaxNumDerivatives,MaxNumResoBins),
     +   RmsAnomalError(MaxNumDerivatives,MaxNumResoBins),
     +     DerivSigmaLimit(MaxNumDerivatives),
     +      DerivIsoLimit(MaxNumDerivatives),
     +       DerivAnomLimits(2,MaxNumDerivatives),
     +        DerivMinResol(2,MaxNumDerivatives),
     +         DerivMaxResol(2,MaxNumDerivatives),
     +          KRefineCycleFlag(MaxNumRefCycles),
     +           ScaledFPH(MaxNumDerivatives),
     +            ScaledDPH(MaxNumDerivatives),
     +             ScaledVPH(MaxNumDerivatives),
     +              ScaledSigmaDPH(MaxNumDerivatives),
     +               FHrl(MaxNumDerivatives),
     +                FHim(MaxNumDerivatives),
     +                 FHArl(MaxNumDerivatives),
     +                  FHAim(MaxNumDerivatives),
     +                   LPhaseFlagPerDerivative(MaxNumDerivatives+1),
     +                    CentricTestFlag,FNativeScaled,
     +                     VarNativeSc,NumDerivatives,
     +                      IAngleStep,NumResoBins,ICurrentCycle,
     +                       LAST,LAST1
      COMMON /HEAVY/
     +  DerivSigmaScale(MaxNumDerivatives),    
     +   DerivScaleToNative(MaxNumDerivatives),
     +   DerivativeNativeScale(MaxNumDerivatives),   
     +   DerivOverallBfact(MaxNumDerivatives),
     +    IndexRefFlags(MaxNumDerivatives+1),  
     +     NAtomsPerDeriv(MaxNumDerivatives),
     +     OCC(MaxNumHeavyAtoms,MaxDataBatches),
     +      AOCC(MaxNumHeavyAtoms,MaxDataBatches),
     +       AFM(MaxNumHeavyAtoms,4),   BFM(MaxNumHeavyAtoms,4),
     +        CFM(MaxNumHeavyAtoms),     FPP(MaxNumHeavyAtoms),
     +         NTROP(MaxNumHeavyAtoms),   B1(MaxNumHeavyAtoms),
     +          B2(MaxNumHeavyAtoms),      B3(MaxNumHeavyAtoms),
     +           B4(MaxNumHeavyAtoms),      B5(MaxNumHeavyAtoms),
     +            B6(MaxNumHeavyAtoms),      X(MaxNumHeavyAtoms),
     +             Y(MaxNumHeavyAtoms),       Z(MaxNumHeavyAtoms),
     +              NDAT(MaxNumDerivatives),   
     +               CALAFF(MaxNumHeavyAtoms),
     +                LRefineFlagPerDerivative(MaxNumDerivatives),
     +                 LANOM(MaxNumDerivatives),
     +                  LBOV(MaxNumDerivatives),
     +                   LEAVE(MaxRefineFlags,MaxNumHeavyAtoms),
     +                    LELEC,LAPPLY
      COMMON /HEAVYC/ATNAME(MaxNumHeavyAtoms)
      COMMON /STATA1/
     + Mcount(MaxNumResoBins,2),
     + SumFigMerit(MaxNumResoBins,2),
     + NumPhasedperDeriv(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumDeltaPhi(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumSqrdDeltaPhi(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumFNativeScaled(MaxNumDerivatives,MaxNumResoBins,
     +                  MaxNumFigMeritBins,2),
     + SumFPHobs(MaxNumDerivatives,MaxNumResoBins,
     +           MaxNumFigMeritBins,2),
     + SumFHcalc(MaxNumDerivatives,MaxNumResoBins,
     +           MaxNumFigMeritBins,2),
     + SumFHA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAbsFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                  MaxNumFigMeritBins,2),
     + SumPrFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumWsigFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2)
      COMMON /STATA3/
     + SumWsigLackClosure(MaxNumDerivatives,MaxNumResoBins,
     +                    MaxNumFigMeritBins,2),
     + SumW1FPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                 MaxNumFigMeritBins,2),
     + SumWghtFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins,2),
     + SumSqrdFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                   MaxNumFigMeritBins,2),
     + SumSqrdPrFPHobsFPHcalc(MaxNumDerivatives,MaxNumResoBins,
     +                        MaxNumFigMeritBins,2),
     + SumSqrdWsigFPHobsFnat(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins,2),
     + SumLackClosureWgtSqrd(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins,2),
     + SumW1FPHobsFnatSqrd(MaxNumDerivatives,MaxNumResoBins,
     +                     MaxNumFigMeritBins,2),
     + SumW1SqrdLackClosure(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins,2),
     + SW(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SumWsig(MaxNumDerivatives,MaxNumResoBins,
     +         MaxNumFigMeritBins,2),
     + NumAnomPhasesPerDeriv(MaxNumDerivatives,MaxNumResoBins,
     +                       MaxNumFigMeritBins),
     + SAADC(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins)
      COMMON /STATB4/
     + SWLCA(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhaseDOS(MaxNumDerivatives,MaxNumResoBins,
     +                         MaxNumFigMeritBins),
     + SWLCAQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + SumAnomWgtModPrPhase(MaxNumDerivatives,MaxNumResoBins,
     +                      MaxNumFigMeritBins),
     + SumWsigA(MaxNumDerivatives,MaxNumResoBins,
     +          MaxNumFigMeritBins),
     + SESQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins,2),
     + SASQ(MaxNumDerivatives,MaxNumResoBins,MaxNumFigMeritBins),
     + ESQ(MaxNumDerivatives,MaxNumResoBins),
     + ASQ(MaxNumDerivatives,MaxNumResoBins),
     + STMIN,STMAX,THR,ACL,LCOR,LSTAT
      COMMON /STATC/DerivTitle(MaxNumDerivatives+1)
C     ..
C     .. Equivalences ..
      EQUIVALENCE (SH(1),COR(1)), (SI(1),COR(9)), (RES(1),COR(17)),
     +            (S(1),COR(25),BUF(1,1))
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C
C
      DO 20 NumResoBins = 1,MaxNumResoBins
        MBuffA(NumResoBins) = 0
        MBuff(NumResoBins,1) = 0
        MBuff(NumResoBins,2) = 0
C
C
        DO 10 Ifom = 1,MaxNumFigMeritBins
          MBuff(NumResoBins,1) = MBuff(NumResoBins,1) +
     +     NumPhasedperDeriv(Kderiv,NumResoBins,Ifom,1)
          MBuff(NumResoBins,2) = MBuff(NumResoBins,2) +
     +     NumPhasedperDeriv(Kderiv,NumResoBins,Ifom,2)
          MBuffA(NumResoBins) = MBuffA(NumResoBins) +
     +     NumAnomPhasesPerDeriv(Kderiv,NumResoBins,Ifom)
   10   CONTINUE
   20 CONTINUE
C
C
      DO 30 NumResoBins = 1,MaxNumResoBins
        IF (MBuff(NumResoBins,1).GT.0 .OR.
     +      MBuff(NumResoBins,2).GT.0) THEN
          ESQ(Kderiv,NumResoBins) = ESQ(Kderiv,NumResoBins)/
     +                              (MBuff(NumResoBins,1)+
     +                              MBuff(NumResoBins,2))
          Buff(NumResoBins,1) = SQRT(ABS(ESQ(Kderiv,NumResoBins)))
        END IF
   30 CONTINUE
C
C----   ASQ from old program
C       This is the rms ano error used for the next cycle
C       in the ZO version
C       Store ano here instead of recalculating it in MAIN
C
      IF (LANOM(Kderiv)) THEN
        DO 40 NumResoBins = 1,MaxNumResoBins
          IF (MBuffA(NumResoBins).GT.0) THEN
            ASQ(Kderiv,NumResoBins) = ASQ(Kderiv,NumResoBins)/
     +                                MBuffA(NumResoBins)
ccx ???? BuffA set but not used ?????
            BuffA(NumResoBins) = SQRT(ABS(ASQ(Kderiv,NumResoBins)))
          END IF
   40   CONTINUE
      END IF
C
C
      U = (STMAX-STMIN)/REAL(MaxNumResoBins)
C
C
      DO 50 I = 1,MaxNumResoBins
        RES(I) = 1.0/ (REAL(I)*U+STMIN)
   50 CONTINUE
C
C----   Write out figure of merit for this cycle
C
      IF (Kderiv.EQ.1) THEN
C
       IF (LAST)  THEN
        ILEN = LENSTR(DerivTitle(Kderiv))
        IF(ILEN.GT.14) ILEN = 14
        WRITE(LAB,'(3A)')' Phasing cycle,  ',
     +  DerivTitle(Kderiv) (1:ILEN),'etc'
C
        WRITE (6,FMT=6002) LAB,LAB
 6002   FORMAT (/2X,
     +'$TABLE:Figure_of_merit analysis v resln :',/,
     +' $GRAPHS',/,
     +':<Figure_of_merit>',A,':N:1,3,5,7:',/,
     +': Number of refs -',A,':N:1,2,4:',/,
     +' $$',/,
     +' 1/resol^2 NO_OF_REF_acen acentric_FOM NO_OF_REF_cen ',
     +         'centric_FOM NO_OF_REF_tot  total_FOM $$',/' $$')
       END IF 
C
C----   Figure of merit
C
        SumFigMeritTA = 0.0
        SumFigMeritTC = 0.0
        SumFigMeritTT = 0.0
        MCOUTA = 0
        MCOUTC = 0
        MCOUTT = 0
C
C
        DO 60 NumResoBins = 1,MaxNumResoBins
          Buff(NumResoBins,1) = 0.0
          Buff(NumResoBins,2) = 0.0
          BUFT(NumResoBins) = SumFigMerit(NumResoBins,1) + 
     +                         SumFigMerit(NumResoBins,2)
          MBUFT(NumResoBins) = Mcount(NumResoBins,1) +
     +                         Mcount(NumResoBins,2)
          SumFigMeritTT = BUFT(NumResoBins) + SumFigMeritTT
          MCOUTT = MBUFT(NumResoBins) + MCOUTT
          IF (MBUFT(NumResoBins).GT.0) BUFT(NumResoBins)
     +        = BUFT(NumResoBins)/MBUFT(NumResoBins)
C
C
          IF (Mcount(NumResoBins,1).GT.0) THEN
            Buff(NumResoBins,1) = SumFigMerit(NumResoBins,1)/
     +                            Mcount(NumResoBins,1)
            SumFigMeritTA = SumFigMerit(NumResoBins,1) + 
     +                       SumFigMeritTA
            MCOUTA = Mcount(NumResoBins,1) + MCOUTA
          END IF
C
C
          IF (Mcount(NumResoBins,2).GT.0) THEN
            Buff(NumResoBins,2) = SumFigMerit(NumResoBins,2)/
     +                            Mcount(NumResoBins,2)
            SumFigMeritTC = SumFigMerit(NumResoBins,2) + 
     +                       SumFigMeritTC
            MCOUTC = Mcount(NumResoBins,2) + MCOUTC
          END IF
          IF (LAST) THEN
C
C  Write out Xloggraph stuff
C
            SSL = (REAL(NumResoBins)*U+STMIN)**2
            WRITE (6,FMT='(3x,F5.3,I8,F8.4,I8,f8.4,I8,F8.4)') SSL,
     +        Mcount(NumResoBins,1),Buff(NumResoBins,1),
     +        Mcount(NumResoBins,2),Buff(NumResoBins,2),
     +        MBUFT(NumResoBins),BUFT(NumResoBins)

C    _PHASING_MIR_NATIVE_SHELL
C            _phasing_MIR_native_shell.d_res_high
C            _phasing_MIR_native_shell.d_res_low
C            _phasing_MIR_native_shell.fom
C            _phasing_MIR_native_shell.fom_centric
C            _phasing_MIR_native_shell.fom_acentric
C            _phasing_MIR_native_shell.reflns
C            _phasing_MIR_native_shell.reflns_centric
C            _phasing_MIR_native_shell.reflns_acentric
C
C
            Rhar2 = Res(NumResoBins)
            IF (NumResoBins .eq. 1) THEN
              Rhar1 = 1.0/STMIN
            ELSE 
              Rhar1 = Res(NumResoBins-1)
            END IF
            CALL Hphasing_mir_native_shell( Rhar1,Rhar2,
     +        Mcount(NumResoBins,1),Buff(NumResoBins,1),
     +        Mcount(NumResoBins,2),Buff(NumResoBins,2),
     +        MBUFT(NumResoBins),BUFT(NumResoBins)  )
C
          END IF
   60   CONTINUE
        IF (LAST) WRITE (6,FMT=*) ' $$'
C
C
        IF (MCOUTA.GT.0) SumFigMeritTA = SumFigMeritTA/MCOUTA
        IF (MCOUTC.GT.0) SumFigMeritTC = SumFigMeritTC/MCOUTC
        IF (MCOUTT.GT.0) SumFigMeritTT = SumFigMeritTT/MCOUTT

C           _phasing_MIR_native.id  
C           _phasing_MIR_native.d_res_high             1.0/STMIN
C           _phasing_MIR_native.d_res_low              1.0/STMAX
C           _phasing_MIR_native.reflns_criteria        CutOffNatSigma
C           _phasing_MIR_native.fom                    SumFigMeritTT
C           _phasing_MIR_native.fom_centric            SumFigMeritTC
C           _phasing_MIR_native.fom_acentric           SumFigMeritTA
C           _phasing_MIR_native.reflns                 MCOUTT
C           _phasing_MIR_native.reflns_centric         MCOUNTC
C           _phasing_MIR_native.reflns_acentric        MCOUNTA          
C
        IF (LAST) THEN
          R1 = 1.0/STMIN
          R2 = 1.0/STMAX
        CALL Hphasing_mir_native(R1,R2,CutOffNatSigma,
     +                            SumFigMeritTT,SumFigMeritTC,
     +                            SumFigMeritTA,MCOUTT,
     +                            MCOUNTC,MCOUNTA)
       END IF
C
       WRITE(6,FMT=9010)
 9010  FORMAT (/,'Figures of merit as functions of resolution shell',
     +         /,'-------------------------------------------------')
C
        WRITE (6,FMT=6000) RES
 6000   FORMAT (' Resolution of each shell in angstroms:',/8F8.2)
C
        IF (MCOUTA.GT.0) THEN
        WRITE (6,FMT='(/,a,29x,a,/,8i8,4x,i8,/,a,/,8f8.4,4x,f8.4)')
     +    ' Number of Measurements phased -ACENTRIC ',' TOTAL',
     +    (Mcount(NumResoBins,1),NumResoBins=1,MaxNumResoBins),MCOUTA,
     +    ' Mean Figure of Merit  ', (Buff(NumResoBins,1),NumResoBins=1,
     +    MaxNumResoBins),SumFigMeritTA
        ELSE
        WRITE (6,FMT='(/,a)')
     +    ' No ACENTRIC reflections were phased'
        END IF
C
        IF (MCOUTC.GT.0) THEN
        WRITE (6,FMT='(/,a,29x,a,/,8i8,4x,i8,/,a,/,8f8.4,4x,f8.4)')
     +    ' Number of Measurements phased -CENTRIC  ',' TOTAL',
     +    (Mcount(NumResoBins,2),NumResoBins=1,MaxNumResoBins),MCOUTC,
     +    ' Mean Figure of Merit  ', (Buff(NumResoBins,2),NumResoBins=1,
     +    MaxNumResoBins),SumFigMeritTC
        ELSE
        WRITE (6,FMT='(/,a)')
     +    ' No CENTRIC reflections were phased'
        END IF
C
        IF (MCOUTC.GT.0 .AND. MCOUTA.GT.0)
     +  WRITE (6,FMT='(/,a,29x,a,/,8i8,4x,i8,/,a,/,8f8.4,4x,f8.4)')
     +    ' Number of Measurements phased -ALL      ',' TOTAL',
     +    (MBUFT(NumResoBins),NumResoBins=1,MaxNumResoBins),MCOUTT,
     +    ' Mean Figure of Merit  ', (BUFT(NumResoBins),NumResoBins=1,
     +    MaxNumResoBins),SumFigMeritTT
C
      END IF
C
C---- No shifts should be applied on last cycle. 
C     All "last" stuff commented out
C
      IF (LAST .AND. KDERIV.EQ.NumDerivatives) THEN
        WRITE (6,FMT='(/,A)')
     +       ' *** No shifts are applied on the last cycle ***'
        RETURN
      END IF
      IF ((NA.GT.0) .OR. (NB.GT.0)) THEN
        WRITE (6,FMT=6004) Kderiv,
     +           DerivTitle(Kderiv)(1:LENSTR(DerivTitle(Kderiv)))
 6004   FORMAT (//,1X,'Compound',I2,3X,'"',A,'"',/,1X,
     +  '-----------------------------')
        IF (DerivSigmaScale(Kderiv).NE.1.0) 
     +    WRITE (6,FMT=6006) DerivSigmaScale(Kderiv)
 6006     FORMAT (/1X,'Standard Deviations Scaled by ',F10.3)
      END IF
C
C
      CONST = 0.0D0
      ACONS = 0.0D0
      MM = -NB
      NN = -NA
C
C
      DO 80 J = 1,MaxNumResoBins
        DO 70 JJ = 1,MaxNumFigMeritBins
          MM = NumPhasedperDeriv(Kderiv,J,JJ,1) + 
     +          NumPhasedperDeriv(Kderiv,J,JJ,2) +
     +           MM
          NN = NumAnomPhasesPerDeriv(Kderiv,J,JJ) + NN
          CONST = DBLE(SumW1SqrdLackClosure(Kderiv,J,JJ,1)) + 
     +             DBLE(SumW1SqrdLackClosure(Kderiv,J,JJ,2)) +
     +              CONST 
          ACONS = DBLE(SWLCAQ(Kderiv,J,JJ)) + ACONS
   70   CONTINUE
   80 CONTINUE
C
C
      NDA = NDAT(Kderiv)
      IF (MM.NE.0) CONST = CONST/DBLE(MM)
      IF (NN.NE.0) ACONS = ACONS/DBLE(NN)
C
C----  compute standard deviations
C
      IF (NA.GT.0) THEN
        IA = 1
        DO 90 I = 1,NA
          A(IA) = SQRT(ABS(A(IA)*ACONS))
          IA = IA + NA - I + 1
   90   CONTINUE
      END IF
C
C
      IF (NB.GT.0) THEN
        IB = 1
        DO 100 I = 1,NB
          B(IB) = SQRT(ABS(B(IB)*CONST))
          IB = IB + NB - I + 1
  100   CONTINUE
      END IF
C
C
      IA = 1
      IB = 1
      JA = 1
      JB = 1
      LOW = IndexRefFlags(Kderiv)
      LHIGH = IndexRefFlags(Kderiv+1) - 1
      I = 1
C
C
      IF (NB.LE.0) THEN
C       IF (LAST) THEN
C
C----  not refined
C
        WRITE (6,FMT=6008) DerivScaleToNative(Kderiv),
     +                     DerivOverallBfact(Kderiv)
 6008   FORMAT (/1X,'This Derivative was Not Refined',/,
     +1X,'Scale Factor  ',F10.3,5X,'Overall B  ',F10.3)
C
C
        DO 110 L = LOW,LHIGH
          WRITE (6,FMT=6010) I,ATNAME(L)
 6010     FORMAT (/,1X,'Site: ',I3,3X,A4)
          WRITE (6,FMT=6012) L,(OCC(L,MU),MU=1,NDA)
 6012     FORMAT (5X,'Real Occupancy   Atom',I4,8F10.3)
          IF (LANOM(Kderiv)) WRITE (6,FMT=6014) L,(AOCC(L,MU),MU=1,NDA)
 6014     FORMAT (5X,'Anom Occupancy   Atom',I4,8F10.3)
C
C
          IF (NTROP(L).EQ.1) THEN
            WRITE (6,FMT=6030) B1(L)
          ELSE
            WRITE (6,FMT=6034) B1(L),B2(L),B3(L),B4(L),B5(L),B6(L)
C
C                   ************************************************
            CALL ANALBS(B1(L),B2(L),B3(L),B4(L),B5(L),B6(L),LAST1,X(L),
     +                  Y(L),Z(L))
C                   ************************************************
C
          END IF
C
C
          WRITE (6,FMT=6040) X(L),Y(L),Z(L)
          I = I + 1
  110   CONTINUE
C       END IF
      ELSE
C
C----  Refined
C
c        IF (LAST .AND. ACL.NE.1.0) WRITE (6,FMT=6024) THR,ACL
        IF (ACL.NE.1.0) WRITE (6,FMT=6016) THR,ACL
 6016   FORMAT (1X,'Shifts greater than ',F10.3,'*sigma will be scaled',
     +         ' by',F10.3,/1X,'NB: shifts are printed after scaling')
C
        IF (LBOV(Kderiv)) THEN
          SHIFT = SNGL(RB(1))
          SIGMA = SNGL(B(1))
          IF (ABS(SHIFT).GT.THR*SIGMA) SHIFT = ACL*SHIFT
          DerivScaleToNative(Kderiv) = DerivScaleToNative(Kderiv) + 
     +                                SHIFT
          WRITE (6,FMT=6018) DerivScaleToNative(Kderiv),SHIFT,SIGMA
 6018     FORMAT (1X,'Scale Factor                ',F10.4,'   Shift',
     +           F10.4,'    S. D.',F10.4)
        ELSE
          WRITE (6,FMT=6020) DerivScaleToNative(Kderiv)
 6020     FORMAT (5X,'Overall Scale factor (Not refined) ',F10.4)
        END IF
C
        IB = IB + NB
        JB = 2
C
        IF (LBOV(Kderiv)) THEN
          SHIFT = SNGL(RB(2))
          SIGMA = SNGL(B(IB))
          IF (ABS(SHIFT).GT.THR*SIGMA) SHIFT = ACL*SHIFT
          DerivOverallBfact(Kderiv) = DerivOverallBfact(Kderiv) + 
     +                                SHIFT
          IB = IB + NB - JB + 1
          JB = JB + 1
          WRITE (6,FMT=6022) DerivOverallBfact(Kderiv),SHIFT,SIGMA
 6022     FORMAT (1X,'Overall B                   ',F10.4,'   Shift',
     +           F10.4,'    S. D.',F10.3)
        ELSE
          WRITE (6,FMT=6024) DerivOverallBfact(Kderiv)
 6024     FORMAT (5X,'Overall B (Not refined) ',F10.4)
        END IF
C
C
        DO 160 L = LOW,LHIGH
          WRITE (6,FMT=6010) I,ATNAME(L)
          IF (LEAVE(1,L)) THEN
            WRITE (6,FMT=6012) L,(OCC(L,M),M=1,NDA)
          ELSE
C
C
            DO 120 M = 1,NDA
              SH(M) = SNGL(RB(JB))
              SI(M) = SNGL(B(IB))
              IF (ABS(SH(M)).GT.THR*SI(M)) SH(M) = ACL*SH(M)
              OCC(L,M) = OCC(L,M) + SH(M)
              IB = IB + NB - JB + 1
              JB = JB + 1
  120       CONTINUE
C
C    Save selected stats per derivative
             OccESD(L)=si(1)
C
            WRITE (6,FMT=6026) L,(OCC(L,M),SH(M),SI(M),M=1,NDA)
 6026       FORMAT   (5X,'Real Occupancy   Atom',I4,F10.3,'   Shift ',
     +             F10.4,'   S. D.',F10.3)
          END IF
C
C
          IF (LANOM(Kderiv)) THEN
            IF (LEAVE(6,L)) THEN
              WRITE (6,FMT=6014) L,(AOCC(L,M),M=1,NDA)
            ELSE
C
C
              DO 130 M = 1,NDA
                SH(M) = SNGL(RA(JA))
                SI(M) = SNGL(A(IA))
                IF (ABS(SH(M)).GT.THR*SI(M)) SH(M) = ACL*SH(M)
                AOCC(L,M) = AOCC(L,M) + SH(M)
                IA = IA + NA - JA + 1
                JA = JA + 1
  130         CONTINUE

C    Save selected stats per derivative
              AoccESD(L)=si(1)

              WRITE (6,FMT=6028) L,(AOCC(L,M),SH(M),SI(M),M=1,NDA)
 6028       FORMAT(5X,'Anom Occupancy   Atom',I4,F10.3,'   Shift ',
     +               F10.4,'   S. D.',F10.3)
            END IF
          END IF
C
C
          IF (LEAVE(2,L) .AND. LEAVE(7,L)) THEN
C           IF (LAST) THEN
            IF (NTROP(L).EQ.6) THEN
              WRITE (6,FMT=6034) B1(L),B2(L),B3(L),B4(L),B5(L),B6(L)
C
C                    *************************************************
              CALL ANALBS(B1(L),B2(L),B3(L),B4(L),B5(L),B6(L),LAST1,
     +                    X(L),Y(L),Z(L))
C                    *************************************************
C
            ELSE
              WRITE (6,FMT=6030) B1(L)
 6030         FORMAT (5X,'Temp. Factor            ',8F10.3)
            END IF
C           END IF
          ELSE
C
C
            IF (NTROP(L).NE.6) THEN
              IF (LEAVE(7,L)) THEN
                SHIFT = SNGL(RB(JB))
                SIGMA = SNGL(B(IB))
                IB = IB + NB - JB + 1
                JB = JB + 1
              ELSE
                SHIFT = SNGL(RA(JA))
                SIGMA = SNGL(A(IA))
                IA = IA + NA - JA + 1
                JA = JA + 1
              END IF
C
C
              IF (ABS(SHIFT).GT.THR*SIGMA) SHIFT = ACL*SHIFT
              B1(L) = B1(L) + SHIFT
              WRITE (6,FMT=6032) B1(L),SHIFT,SIGMA
 6032         FORMAT (5X,'Temp. Factor            ',F10.3,'   Shift: ',
     +               F10.4,'  S. D.',F10.3)
            ELSE
              IF (LEAVE(7,L)) THEN
C
C
                DO 140 M = 1,6
                  SH(M) = SNGL(RB(JB))
                  SI(M) = SNGL(B(IB))
                  IF (ABS(SH(M)).GT.THR*SI(M)) SH(M) = ACL*SH(M)
                  IB = IB + NB - JB + 1
                  JB = JB + 1
  140           CONTINUE
              ELSE
C
C
                DO 150 M = 1,6
                  SH(M) = SNGL(RA(JA))
                  SI(M) = SNGL(A(IA))
                  IF (ABS(SH(M)).GT.THR*SI(M)) SH(M) = ACL*SH(M)
                  IA = IA + NA - JA + 1
                  JA = JA + 1
  150           CONTINUE
              END IF
C
C
              B1(L) = B1(L) + SH(1)
              B2(L) = B2(L) + SH(2)
              B3(L) = B3(L) + SH(3)
              B4(L) = B4(L) + SH(4)
              B5(L) = B5(L) + SH(5)
              B6(L) = B6(L) + SH(6)
              WRITE (6,FMT=6034) B1(L),B2(L),B3(L),B4(L),B5(L),B6(L)
 6034         FORMAT (5X,'Anis. Temp. Factors     ',6F10.5)
              WRITE (6,FMT=6036) (SH(M),M=1,6)
 6036         FORMAT (5X,'Anis. Temp. Factor Shift',6F10.5)
              WRITE (6,FMT=6038) (SI(M),M=1,6)
 6038         FORMAT (5X,'S. D. of Temp. Factor   ',6F10.5)
C
C                      ***********************************************
              CALL ANALBS(B1(L),B2(L),B3(L),B4(L),B5(L),B6(L),LAST1,
     +                    X(L),Y(L),Z(L))
C                      ***********************************************
C
            END IF
          END IF
C
C
          IF (.NOT.LEAVE(3,L)) THEN
            SH(1) = SNGL(RB(JB))
            SI(1) = SNGL(B(IB))
            IF (ABS(SH(1)).GT.THR*SI(1)) SH(1) = ACL*SH(1)
            X(L) = X(L) + SH(1)
            IB = IB + NB - JB + 1
            JB = JB + 1
          ELSE IF (.NOT.LEAVE(8,L)) THEN
            SH(1) = SNGL(RA(JA))
            SI(1) = SNGL(A(IA))
            IF (ABS(SH(1)).GT.THR*SI(1)) SH(1) = ACL*SH(1)
            X(L) = X(L) + SH(1)
            IA = IA + NA - JA + 1
            JA = JA + 1
          END IF
C
C
          IF (.NOT.LEAVE(9,L)) THEN
            SH(2) = SNGL(RA(JA))
            SI(2) = SNGL(A(IA))
            IF (ABS(SH(2)).GT.THR*SI(2)) SH(2) = ACL*SH(2)
            Y(L) = Y(L) + SH(2)
            IA = IA + NA - JA + 1
            JA = JA + 1
          ELSE IF (.NOT.LEAVE(4,L)) THEN
            SH(2) = SNGL(RB(JB))
            SI(2) = SNGL(B(IB))
            IF (ABS(SH(2)).GT.THR*SI(2)) SH(2) = ACL*SH(2)
            Y(L) = Y(L) + SH(2)
            IB = IB + NB - JB + 1
            JB = JB + 1
          END IF
C
C
          IF (.NOT.LEAVE(10,L)) THEN
            SH(3) = SNGL(RA(JA))
            SI(3) = SNGL(A(IA))
            IF (ABS(SH(3)).GT.THR*SI(3)) SH(3) = ACL*SH(3)
            Z(L) = Z(L) + SH(3)
            IA = IA + NA - JA + 1
            JA = JA + 1
          ELSE IF (.NOT.LEAVE(5,L)) THEN
            SH(3) = SNGL(RB(JB))
            SI(3) = SNGL(B(IB))
            IF (ABS(SH(3)).GT.THR*SI(3)) SH(3) = ACL*SH(3)
            Z(L) = Z(L) + SH(3)
            IB = IB + NB - JB + 1
            JB = JB + 1
          END IF
C
C
          IF (LEAVE(3,L) .AND. LEAVE(4,L) .AND. LEAVE(5,L) .AND.
     +        LEAVE(8,L) .AND. LEAVE(9,L) .AND. LEAVE(10,L)) THEN
C
C----   if not refining any coordinates
C
C           IF (LAST) WRITE (6,FMT=6016) X(L),Y(L),Z(L)
 6040       FORMAT (5X,'Atomic Coordinates      ',3F10.5)
          ELSE
            WRITE (6,FMT=6040) X(L),Y(L),Z(L)
            WRITE (LINEO1,FMT=6042)
 6042       FORMAT (4X,'Coordinate Shift')
            WRITE (LINEO2,FMT=6044)
 6044       FORMAT (3X,'S. D. of Coordinate Shift')
C
C
            IF (.NOT.LEAVE(3,L) .OR. .NOT.LEAVE(8,L)) THEN
              WRITE (LINEO1(29:38),FMT=6046) SH(1)
 6046         FORMAT (F10.5)
              WRITE (LINEO2(29:38),FMT=6046) SI(1)
            END IF
C
C
            IF (.NOT.LEAVE(4,L) .OR. .NOT.LEAVE(9,L)) THEN
              WRITE (LINEO1(39:48),FMT=6046) SH(2)
              WRITE (LINEO2(39:48),FMT=6046) SI(2)
            END IF
C
C
            IF (.NOT.LEAVE(5,L) .OR. .NOT.LEAVE(10,L)) THEN
              WRITE (LINEO1(49:58),FMT=6046) SH(3)
              WRITE (LINEO2(49:58),FMT=6046) SI(3)
            END IF
C
C
            WRITE (6,FMT=6048) LINEO1
 6048       FORMAT (1X,A)
            WRITE (6,FMT=6048) LINEO2
          END IF
C
C
          I = I + 1
  160   CONTINUE
C
C---  print correlation matrices
C
        IF (LCOR) WRITE (6,FMT=6050) NB
 6050   FORMAT (/1X,'Correlation Matrix for REAL Parameters of order',
     +         I4)
        IB = 1
C
C
        DO 190 I = 1,NB
          DO 170 J = 1,I
            COR(J) = 0.0
  170     CONTINUE
          COR(I) = 1.0
C
C
          IF (I.NE.NB) THEN
            TT = CONST/B(IB)
            JB = IB + 1
            JJ = IB + NB - I + 1
            M = I + 1
C
C
            DO 180 J = M,NB
              COR(J) = REAL(B(JB)*TT/B(JJ))
              JB = JB + 1
              JJ = JJ + NB - J + 1
  180       CONTINUE
          END IF
C
C
          IF (LCOR) WRITE (6,FMT=6052) (COR(J),J=1,NB)
 6052     FORMAT (/22F6.2)
          IB = IB + NB - I + 1
  190   CONTINUE
        T = REAL(IDB)*LOG10(2.0) + SNGL(LOG10(DB))
        U = AINT(T)
        T = T - U
C
C
        IF (T.LT.0.0) THEN
          U = U - 1.0
          T = 1.0 - T
        END IF
C
C
        I = INT(U)
        T = 10.0**T
        IF (LCOR) WRITE (6,FMT=6054) T,I
 6054   FORMAT (/1X,'Determinant of Normal Matrix was ',F8.4,' Times 1',
     +         '0 to the',I4)
C
C----  anomalous matrix
C
        IF (NA.GT.0) THEN
          IF (LCOR) WRITE (6,FMT=6056) NA
 6056     FORMAT (/1X,'Correlation Matrix for Anomalous parameters of ',
     +           'order',I4)
          IA = 1
C
C
          DO 220 I = 1,NA
            DO 200 J = 1,I
              COR(J) = 0.0
  200       CONTINUE
            COR(I) = 1.0
C
C
            IF (I.NE.NA) THEN
              TT = ACONS/A(IA)
              JA = IA + 1
              JJ = IA + NA - I + 1
              M = I + 1
C
C
              DO 210 J = M,NA
                COR(J) = REAL(A(JA)*TT/A(JJ))
                JA = JA + 1
                JJ = JJ + NA - J + 1
  210         CONTINUE
            END IF
C
C
            IF (LCOR) WRITE (6,FMT=6052) (COR(J),J=1,NA)
            IA = IA + NA - I + 1
  220     CONTINUE
          T = REAL(IDA)*LOG10(2.0) + LOG10(DA)
          U = AINT(T)
          T = T - U
C
C
          IF (T.LT.0.0) THEN
            U = U - 1.0
            T = 1.0 - T
          END IF
C
C
          I = INT(U)
          T = 10.0**T
          IF (LCOR) WRITE (6,FMT=6054) T,I
        END IF
      END IF
C
C
C----  Finished??
C
      WRITE (6,FMT=9020)
 9020 FORMAT (1X,'-----------------------------------------------')
      WRITE (6,FMT=6058) CONST
 6058 FORMAT (1X,'Refinement Parameter           = ',F14.6)
      WRITE (6,FMT=6060) ACONS
 6060 FORMAT (1X,'Anomalous Refinement Parameter = ',F14.6)
      WRITE (6,FMT=9020)
C
C
      RETURN
      END
C
C
C
C     ================================
      SUBROUTINE FHCALC(HH,HK,HL)
C     ================================
C
C
C        implicit none
C
C   What a silly name for a subroutine...
C   This subroutine calculate the FHs and derivatives if required.
C
C
C     LRefineFlagPerDerivative = false = no refining for this derivative
C     LRefineFlagPerDerivative = true = refine this derivative
C     LEAVE = true = do not refine this derivative
C     LEAVE = false = refine this derivative
C
C
C
C
C----  space group expansion
C
C
C
C
C
C     .. Parameters ..
      INCLUDE 'mlphare.fh'
C     ..
C     .. Scalar Arguments ..
      REAL HH,HK,HL
C     ..
C     .. Scalars in Common ..
      REAL CentricTestFlag,DT11,DT12,DT21,DT22,DT31,DT32,DT41,DT42,DT51,
     +     DT52,DT61,DT62,DX1,DX2,DY1,DY2,DZ1,DZ2,FNativeScaled,
     +     VarNativeSc,SSQOL4
      INTEGER IAngleStep,ICurrentCycle,NumDerivatives,NumPrimSymmetry,
     +        NumRefVariables,NumResoBins,NumSpaceGroup,NumSymmetry
      LOGICAL LAST,LAST1,LELEC,LAPPLY
C     ..
C     .. Arrays in Common ..
      REAL FHAim,AFM,AOCC,ScaledDPH,
     +     FHArl,B1,B2,B3,B4,B5,B6,BFM,DerivOverallBfact,CFM,
     +     DerivAnomLimits,DERIV1,DERIV2,
     +     DerivIsoLimit,DerivMaxResol,DerivMinResol,
     +     RmsAnomalError,RmsIsomorphError,FHim,ScaledFPH,
     +     FPP,OCC,PERM,DerivScaleToNative,DerivativeNativeScale,
     +     FHrl,RSYM,RSYMT,DerivSigmaScale,
     +     ScaledSigmaDPH,DerivSigmaLimit,
     +     ScaledVPH,X,Y,Z
      INTEGER IndexRefFlags,JNDEX,KRefineCycleFlag,
     +        NAtomsPerDeriv,NDAT,NSMFLG,NTROP
      LOGICAL CALAFF,LANOM,LBOV,LEAVE,
     +        LPhaseFlagPerDerivative,LRefineFlagPerDerivative
C     ..
C     .. Local Scalars ..
      REAL A,ANGLE,B,C,HD1,HD2,HD3,S,SCFAC,SUMC,SUMS,T1,T2,T3,T4,T5,T6,
     +     TEMP,U1,U2,U3,U4,U5,U6,XX,YY,ZZ
      INTEGER I,ICEN,II,ISYM,JF,K,KAO,KK,KRO,L,N,NB,NMULT,NT,NV
C     ..
C     .. Local Arrays ..
      REAL H1(MaxSymmetry),H2(MaxSymmetry),H3(MaxSymmetry),
     +     H4(MaxSymmetry)
      INTEGER IH(3)
C     ..
C     .. External Subroutines ..
      EXTERNAL CENTR
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,COS,EXP,MOD,NINT,SIN
C     ..
C     .. Common blocks ..
      COMMON /ATSYM_MLP/RSYM(4,4,MaxSymmetry),RSYMT(4,4,MaxSymmetry),
     +       NumSymmetry,PERM(4,4),NumSpaceGroup,NSMFLG(MaxSymmetry),
     +       NumPrimSymmetry
      COMMON /DERIV/  DERIV1(MaxNumRefVariables),
     +                 DERIV2(MaxNumRefVariables),
     +                  JNDEX(2*MaxNumDerivatives+1),
     +                   NumRefVariables,SSQOL4
      COMMON /FASE/  
     +  RmsIsomorphError(MaxNumDerivatives,MaxNumResoBins),
     +   RmsAnomalError(MaxNumDerivatives,MaxNumResoBins),
     +     DerivSigmaLimit(MaxNumDerivatives),
     +      DerivIsoLimit(MaxNumDerivatives),
     +       DerivAnomLimits(2,MaxNumDerivatives),
     +        DerivMinResol(2,MaxNumDerivatives),
     +         DerivMaxResol(2,MaxNumDerivatives),
     +          KRefineCycleFlag(MaxNumRefCycles),
     +           ScaledFPH(MaxNumDerivatives),
     +            ScaledDPH(MaxNumDerivatives),
     +             ScaledVPH(MaxNumDerivatives),
     +              ScaledSigmaDPH(MaxNumDerivatives),
     +               FHrl(MaxNumDerivatives),
     +                FHim(MaxNumDerivatives),
     +                 FHArl(MaxNumDerivatives),
     +                  FHAim(MaxNumDerivatives),
     +                   LPhaseFlagPerDerivative(MaxNumDerivatives+1),
     +                    CentricTestFlag,FNativeScaled,
     +                     VarNativeSc,NumDerivatives,
     +                      IAngleStep,NumResoBins,ICurrentCycle,
     +                       LAST,LAST1
      COMMON /HEAVY/
     +  DerivSigmaScale(MaxNumDerivatives),    
     +   DerivScaleToNative(MaxNumDerivatives),
     +   DerivativeNativeScale(MaxNumDerivatives),   
     +   DerivOverallBfact(MaxNumDerivatives),
     +    IndexRefFlags(MaxNumDerivatives+1),  
     +     NAtomsPerDeriv(MaxNumDerivatives),
     +     OCC(MaxNumHeavyAtoms,MaxDataBatches),
     +      AOCC(MaxNumHeavyAtoms,MaxDataBatches),
     +       AFM(MaxNumHeavyAtoms,4),   BFM(MaxNumHeavyAtoms,4),
     +        CFM(MaxNumHeavyAtoms),     FPP(MaxNumHeavyAtoms),
     +         NTROP(MaxNumHeavyAtoms),   B1(MaxNumHeavyAtoms),
     +          B2(MaxNumHeavyAtoms),      B3(MaxNumHeavyAtoms),
     +           B4(MaxNumHeavyAtoms),      B5(MaxNumHeavyAtoms),
     +            B6(MaxNumHeavyAtoms),      X(MaxNumHeavyAtoms),
     +             Y(MaxNumHeavyAtoms),       Z(MaxNumHeavyAtoms),
     +              NDAT(MaxNumDerivatives),   
     +               CALAFF(MaxNumHeavyAtoms),
     +                LRefineFlagPerDerivative(MaxNumDerivatives),
     +                 LANOM(MaxNumDerivatives),
     +                  LBOV(MaxNumDerivatives),
     +                   LEAVE(MaxRefineFlags,MaxNumHeavyAtoms),
     +                    LELEC,LAPPLY
C     ..
C     .. Equivalences ..
C
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C
C
C
      IH(1) = NINT(HH)
      IH(2) = NINT(HK)
      IH(3) = NINT(HL)
C
C
      NMULT = NumSymmetry/NumPrimSymmetry
C
C
      DO 10 ISYM = 1,NumPrimSymmetry
        H1(ISYM) = RSYM(1,1,ISYM)*HH + RSYM(2,1,ISYM)*HK +
     +             RSYM(3,1,ISYM)*HL
        H2(ISYM) = RSYM(1,2,ISYM)*HH + RSYM(2,2,ISYM)*HK +
     +             RSYM(3,2,ISYM)*HL
        H3(ISYM) = RSYM(1,3,ISYM)*HH + RSYM(2,3,ISYM)*HK +
     +             RSYM(3,3,ISYM)*HL
        H4(ISYM) = RSYM(1,4,ISYM)*HH + RSYM(2,4,ISYM)*HK +
     +             RSYM(3,4,ISYM)*HL
   10 CONTINUE
C
C
C----  calculate structure factors and derivatives
C
      DO 20 I = 1,NumRefVariables
        DERIV1(I) = 0.0
        DERIV2(I) = 0.0
   20 CONTINUE
C
C
      DO 70 II = 1,NumDerivatives
        FHrl(II) = 0.0
        FHim(II) = 0.0
        FHArl(II) = 0.0
        FHAim(II) = 0.0
        L = IndexRefFlags(II)
        N = IndexRefFlags(II+1) - 1
        NT = JNDEX(2*II-1)
        NV = JNDEX(2*II) + 1
        IF (LBOV(II)) NV = NV + 1
C
C---- loop over sites for this derivative
C
        DO 60 I = L,N
          NB = NTROP(I)
          XX = X(I)
          YY = Y(I)
          ZZ = Z(I)
C
C----  scfac altered to use atomsf stuff...
C
          SCFAC = CFM(I)
C
C
          DO 30 JF = 1,4
            SCFAC = EXP(-BFM(I,JF)*SSQOL4/4.0)*AFM(I,JF) + SCFAC
   30     CONTINUE
C
C
          A = OCC(I,1)*SCFAC
C
C
          IF (LANOM(II)) THEN
            B = AOCC(I,1)*FPP(I)
          ELSE
            B = 0.0
          END IF
C
C
          IF (NB.EQ.6) THEN
            T1 = B1(I)
            T2 = B2(I)
            T3 = B3(I)
            T4 = B4(I)
            T5 = B5(I)
            T6 = B6(I)
          ELSE
            TEMP = EXP(-B1(I)*SSQOL4/4.0)
          END IF
C
C
          SUMC = 0.0
          SUMS = 0.0
C
C
          IF (LRefineFlagPerDerivative(II)) THEN
C
C----     initialise values
            DX1 = 0.0
            DX2 = 0.0
            DY1 = 0.0
            DY2 = 0.0
            DZ1 = 0.0
            DZ2 = 0.0
            DT11 = 0.0
            DT12 = 0.0
            DT21 = 0.0
            DT22 = 0.0
            DT31 = 0.0
            DT32 = 0.0
            DT41 = 0.0
            DT42 = 0.0
            DT51 = 0.0
            DT52 = 0.0
            DT61 = 0.0
            DT62 = 0.0
C
C
          END IF
C
C----  sum over equivalent positions
C
          DO 50 K = 1,NumPrimSymmetry
            HD1 = H1(K)
            HD2 = H2(K)
            HD3 = H3(K)
            ANGLE = (HD1*XX+HD2*YY+HD3*ZZ+H4(K))*TWOPI
            C = COS(ANGLE)*NMULT
            S = SIN(ANGLE)*NMULT
C
C
            IF (NB.EQ.6) THEN
              U1 = HD1**2
              U2 = HD1*HD2
              U3 = HD1*HD3
              U4 = HD2**2
              U5 = HD2*HD3
              U6 = HD3**2
              TEMP = EXP(-U1*T1-U2*T2-U3*T3-U4*T4-U5*T5-U6*T6)
            END IF
C
C
            C = C*TEMP
            S = S*TEMP
            SUMC = SUMC + C
            SUMS = SUMS + S
C
C
            IF (LRefineFlagPerDerivative(II)) THEN
              IF (.NOT. (LEAVE(2,I).AND.LEAVE(7,I))) THEN
                IF (NB.EQ.6) THEN
                  DT11 = DT11 - C*U1
                  DT12 = DT12 - S*U1
                  DT21 = DT21 - C*U2
                  DT22 = DT22 - S*U2
                  DT31 = DT31 - C*U3
                  DT32 = DT32 - S*U3
                  DT41 = DT41 - C*U4
                  DT42 = DT42 - S*U4
                  DT51 = DT51 - C*U5
                  DT52 = DT52 - S*U5
                  DT61 = DT61 - C*U6
                  DT62 = DT62 - S*U6
                END IF
              END IF
C
C
              IF (.NOT. (LEAVE(3,I).AND.LEAVE(8,I))) THEN
                DX1 = DX1 - HD1*S
                DX2 = HD1*C + DX2
              END IF
C
C
              IF (.NOT. (LEAVE(4,I).AND.LEAVE(9,I))) THEN
                DY1 = DY1 - HD2*S
                DY2 = HD2*C + DY2
              END IF
C
C
              IF (.NOT. (LEAVE(5,I).AND.LEAVE(10,I))) THEN
                DZ1 = DZ1 - HD3*S
                DZ2 = HD3*C + DZ2
              END IF
C
C
            END IF
   50     CONTINUE
C
C
          FHrl(II) = FHrl(II) + A*SUMC
          FHim(II) = FHim(II) + A*SUMS
          FHArl(II) = FHArl(II) - B*SUMS
          FHAim(II) = FHAim(II) + B*SUMC
C
C
          IF (LRefineFlagPerDerivative(II)) THEN
C
C---- compute derivatives for site i
C
            KK = NT
C
C
            IF (.NOT.LEAVE(6,I)) THEN
              KAO = KK 
              DERIV1(KAO) = -FPP(I)*SUMS
              DERIV2(KAO) = FPP(I)*SUMC
              KK = NDAT(II) + KK
            END IF
C
C
            K = NV
C
C
            IF (.NOT.LEAVE(1,I)) THEN
              KRO = K 
              DERIV1(KRO) = SUMC*SCFAC
              DERIV2(KRO) = SUMS*SCFAC
              K = NDAT(II) + K
            END IF
C
C
            IF (.NOT. (LEAVE(2,I).AND.LEAVE(7,I))) THEN
              IF (NB.EQ.6) THEN
                IF (.NOT.LEAVE(7,I)) THEN
                  DERIV1(KK) = -B*DT12
                  DERIV1(KK+1) = -B*DT22
                  DERIV1(KK+2) = -B*DT32
                  DERIV1(KK+3) = -B*DT42
                  DERIV1(KK+4) = -B*DT52
                  DERIV1(KK+5) = -B*DT62
                  DERIV2(KK) = B*DT11
                  DERIV2(KK+1) = B*DT21
                  DERIV2(KK+2) = B*DT31
                  DERIV2(KK+3) = B*DT41
                  DERIV2(KK+4) = B*DT51
                  DERIV2(KK+5) = B*DT61
                  KK = KK + 6
                ELSE
                  DERIV1(K) = A*DT11
                  DERIV2(K) = A*DT12
                  DERIV1(K+1) = A*DT21
                  DERIV2(K+1) = A*DT22
                  DERIV1(K+2) = A*DT31
                  DERIV2(K+2) = A*DT32
                  DERIV1(K+3) = A*DT41
                  DERIV2(K+3) = A*DT42
                  DERIV1(K+4) = A*DT51
                  DERIV2(K+4) = A*DT52
                  DERIV1(K+5) = A*DT61
                  DERIV2(K+5) = A*DT62
                  K = K + 6
                END IF
C
C
              ELSE
C
C
                IF (.NOT.LEAVE(7,I)) THEN
                  DERIV1(KK) = B*SUMS*SSQOL4/4.0
                  DERIV2(KK) = -B*SUMC*SSQOL4/4.0
                  KK = KK + 1
                ELSE
                  DERIV1(K) = -A*SUMC*SSQOL4/4.0
                  DERIV2(K) = -A*SUMS*SSQOL4/4.0
                  K = K + 1
                END IF
              END IF
            END IF
C
C
            IF (.NOT.LEAVE(8,I)) THEN
              DERIV1(KK) = -B*TWOPI*DX2
              DERIV2(KK) = B*TWOPI*DX1
              KK = KK + 1
            END IF
C
C
            IF (.NOT.LEAVE(3,I)) THEN
              DERIV1(K) = TWOPI*A*DX1
              DERIV2(K) = TWOPI*A*DX2
              K = K + 1
            END IF
C
C
            IF (.NOT.LEAVE(9,I)) THEN
              DERIV1(KK) = -B*TWOPI*DY2
              DERIV2(KK) = B*TWOPI*DY1
              KK = KK + 1
            END IF
C
C
            IF (.NOT.LEAVE(4,I)) THEN
              DERIV1(K) = TWOPI*A*DY1
              DERIV2(K) = TWOPI*A*DY2
              K = K + 1
            END IF
C
C
            IF (.NOT.LEAVE(10,I)) THEN
              DERIV1(KK) = -B*TWOPI*DZ2
              DERIV2(KK) = B*TWOPI*DZ1
              KK = KK + 1
            END IF
C
C
            IF (.NOT.LEAVE(5,I)) THEN
              DERIV1(K) = TWOPI*A*DZ1
              DERIV2(K) = TWOPI*A*DZ2
              K = K + 1
            END IF
C
C
            NV = K
            NT = KK
          END IF
C
C
   60   CONTINUE
   70 CONTINUE
C
C----  test for centrosymmetric projection
C
      CentricTestFlag = 0.0
C
CEJD  Use library routine centric to find centric zone.
CEJD   get centric phase from any heavy atom phase.
CEJD   Add 720 so that later we can check whether
C         CentricTestFlag = 0 ( acentric)
C  June 1994 _ oops - only works if FHim,FHrl  exist!
C
C          **************
      CALL CENTR(IH,ICEN)
C          **************
C
      IF (ICEN.NE.0) THEN
        T2 = 0.0
        DO 80 ISYM = 2,NumPrimSymmetry
          IF (ABS(H1(1)+H1(ISYM)).GT.0.5 .OR.
     +        ABS(H2(1)+H2(ISYM)).GT.0.5 .OR.
     +        ABS(H3(1)+H3(ISYM)).GT.0.5) GO TO 80
C  h4(isym) = rsym(1,4,isym)*hh + rsym(2,4,isym)*hk + rsym(3,4,isym)*hl
          T2 = MOD(H4(ISYM)*180.0+360000.0,360.0)
          GO TO 90
   80   CONTINUE
   90   CentricTestFlag = 720.0 + T2
      END IF
  100 CONTINUE
      RETURN
C
C
      END
