C
C     SCALEIT
C     Copyright (C) 1989-1991 Phil Evans, Eleanor Dodson, Richard Dodson
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
      PROGRAM SCALEIT
C     ===============
C
C
C     This program used to be called ANISOSC
C
C     Options for isotropic scale factor, etc
C     Renamed SCALEIT                           Phil Evans, Nov 1991
C
C     MTZ version 1991, Eleanor Dodson, York
C
C     Key Worded input  added and  program Toolpacked 18th August, 1989.
C     Keywords available are: (ANOM now found by checking for values,)
C     C     ..DIFFer, TITLe, NCYC, CONV, SYMM, RESO and END and can
C     be input in any order  - the Keywords  NCYC, CONV, and END MUST
C     be given. See the
C     documents anisosc.utx and anisosc.ptx for further details.     PJD
C
C
C     EJD February 1991   Paul Tucker wants analysis v MODF
C
C     RGD February 1990
C     Problems with eigen vectors / values for matrices with rank lt 8
C     solved (???) by calling NAG library.
C     RGD December 1989
C     Ian Tickle's LCFDIFFER which monitors unlikely differences
C     incorporated.
C     EJD November 1989
C     This program assumes that all equivalent reflections are the same;
C     ie the correction is not truly anisotropic but for axes where
C     h2 is some factor of k1 or l1 it is incorrect to omit the
C     reflection.
C
C     We must sum DG(i) over all such symmetry equivalents of h k l.
C     See SR  SCAREF.
C
C================================================================
C
C     SCALE DERIVATIVE TO NATIVE USING ANISOTROPIC TEMPERATURE FACTOR
C     ON INTENSITIES
C     METHOD MODIFIED FOX & HOLMES
C     MINIMIZE  SUM( W (II - GI IH)**2) WRT 2 SCALE FACTORS (SCALE 1=
C     & 6 BETA VALUES
C
C     PHIL EVANS  MRC CAMBRIDGE  MARCH 1978
C
C===================================================================
C
C     Parameters
C     NDER number of derivative sets that can be coped with
C
C     .. Parameters ..
      INTEGER NDER
      PARAMETER (NDER=20)
      INTEGER MaxSym
      PARAMETER (MaxSym=192)
      INTEGER MCOLS
      PARAMETER (MCOLS=500)
C     ..
C     .. Scalars in COMMON ..
      REAL CONV,RMSF2
      INTEGER ISOUT,JAN,LUNIN,LUNOUT,NCYC,NSYM,LSCALE,NOWT
      DOUBLE PRECISION TOL
      LOGICAL ANALYSE,OUTPUT,WILSON,NORMAN,SCATPLT
C     ..
C     .. Arrays in COMMON ..
      REAL BET,BETA,CELL,CELLAS,PERM,RSYM,RSYMT,SC,SCL,SIGM,FMAX,
     +     DMAX,DIFFS,DIF,DIFDAT
      INTEGER ISEE,JJJNK,INTER,NREF,IMIN,IMAX,IPOINT
      LOGICAL REFSCL
C     ..
C     .. Local Scalars ..
      REAL SMIN,SMAX
      INTEGER IFAIL,JDO220,JDO210,JDO240,LDUM
      INTEGER IFIL1,JDER,JDO241,JDO242
      CHARACTER*11 SCLTYP
C     ..
C     .. External Subroutines ..
      EXTERNAL CCPOPN,CCPRCS,LRREWD,SCAPLY,SCAREF,SCINIT
C     Hint to linker for block data:
      EXTERNAL SCBLK
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC NINT,SQRT
C     ..
C     .. COMMON blocks ..
      COMMON /ATSYM/RSYM(4,4,MaxSym),RSYMT(4,4,MaxSym),NSYM,PERM(4,4),
     +             JJJNK(9)
      CHARACTER DTITLE*80
      COMMON /CDIF2/DTITLE(NDER)
      COMMON /DIF2/INTER(NDER,2),DIF(NDER,2),NREF(NDER,2),
     + DIFDAT(NDER,3,2)
      COMMON /INOUT/LUNIN,LUNOUT,ISOUT
      COMMON /SI_INPUT/TOL,NCYC,CONV,JDER,SIGM(NDER+1),FMAX(NDER+1),
     $              DMAX(NDER+1),DIFFS(NDER+1),NOWT,REFSCL(NDER),
     $              OUTPUT,LSCALE,WILSON,NORMAN,ANALYSE,scatplt
      COMMON /POINTS/IPOINT(MCOLS)
      COMMON /RANGES/IMIN(4),IMAX(4),RMSF2,SMIN,SMAX
      COMMON /SCALES/SC(2),BETA(6),SCL(2,NDER),BET(6,NDER),ISEE(4),
     +     CELL(6),CELLAS(6)
C
      LUNIN = 5
      LUNOUT = 6
      IFIL1 = 1
      IFAIL = 0
C
C     ****************************************
      CALL CCPFYP
      call ccp4h_init()
      CALL MTZINI
      CALL CCPOPN(LUNIN,'DATA',5,1,LDUM,IFAIL)
      CALL CCPOPN(LUNOUT,'PRINTER',6,1,LDUM,IFAIL)
      call ccp4h_header('SCALEIT','scaleit',2)
      CALL CCPRCS(LUNOUT,'SCALEIT','$Date: 2008/04/02 13:38:52 $')
      call ccp4h_summary_beg()
      call ccp4h_toc_beg()
      call ccp4h_toc_ent('Command Input','#command')
      call ccp4h_toc_ent('Input MTZ File','#inp')
      call ccp4h_toc_ent('Output File','#out')
      call ccp4h_toc_ent('Application of scales and analysis','#appsca')
      call ccp4h_toc_end()
      call ccp4h_rule()
      call ccp4h_header('Command Input','command',3)
      call ccp4h_link('TITLE    ','scaleit.html#title')
      call ccp4h_link('ANALYSE ','scaleit.html#analyse')
      call ccp4h_link('CONVERGE ','scaleit.html#converge')
      call ccp4h_link('LABIN ','scaleit.html#labin')
      call ccp4h_link('EXCLUDE ','scaleit.html#exclude')
      call ccp4h_link('GRAPH ','scaleit.html#graph')
      call ccp4h_link('RESOLUTION','scaleit.html#resolution')
      call ccp4h_link('WEIGHT','scaleit.html#weight')
      call ccp4h_link('NOWT','scaleit.html#nowt')
      call ccp4h_link('REFINE ','scaleit.html#refine')
      call ccp4h_link('SCALE ','scaleit.html#scale')
      call ccp4h_link('SCATTER','scaleit.html#scatter')
      call ccp4h_link('SYMMETRY','scaleit.html#symmetry')
      call ccp4h_link('END','scaleit.html#end')
      call ccp4h_summary_end()
      CALL RCARDS
C     ****************************************
C
C     initialise control variables and read input
C
C Flow of program is controlled by 3 flags:-
C
C     REFSCL     .true. if scales are to be refined
C     OUTPUT     .true. if output file is to be written
C     LSCALE     type of scaling
C                = 1  overall scale
C                = 2  isotropic
C                = 3  anisotropic
C
      DO 240 JDO240 = 1,JDER
         JAN = 0
C        PJX: changed for new labels
         IF (IPOINT(14*JDO240-6).NE.0) JAN = 1
         IF (.NOT.ANALYSE) THEN
           IF (LSCALE .EQ. 1) SCLTYP = '    OVERALL'
           IF (LSCALE .EQ. 2) SCLTYP = '  ISOTROPIC'
           IF (LSCALE .EQ. 3) SCLTYP = 'ANISOTROPIC'
C        PJX: changed for new labels
      call ccp4h_summary_beg()
            WRITE (LUNOUT,FMT=6006) SCLTYP
 6006 FORMAT (/////31X,A11,
     +' DERIVATIVE TO NATIVE SCALING',/,31X,
     +'========================================',/)
      call ccp4h_summary_end()
          write (lunout,fmt=6007)IPOINT(4),
     +           IPOINT(14*JDO240-8),NCYC,CONV
 6007  format (/,/,
     +' Position of Native F     ',I5,/,
     +' Position of Derivative F ',I5,/,
     +' Number of Cycles         ',I5,/,
     +' Convergence Limit        ',F10.6,/,/)
            IF (JAN.EQ.1) WRITE (LUNOUT,FMT=6008)
 6008 FORMAT (/' Derivative has Anomalous Difference to be Scaled',/)
         ENDIF
C
C---- Initialize scales and b's
C
            DO 220 JDO220 = 1,2
               SC(JDO220) = SCL(JDO220,JDO240)
 220        CONTINUE
C
            DO 230 JDO210 = 1,6
               BETA(JDO210) = BET(JDO210,JDO240)
 230        CONTINUE
C
C---- Find initial scales and refine (only if specified for this deriv.)
C
C
C                **************
            CALL SCINIT(JDO240)
C                **************
C
C                ******************
            CALL SCAREF(JDO240,JAN)
C                ******************
C
C                *************
            CALL LRREWD(IFIL1)
C                *************
C
C----  Store scales & B-factors, scales (scales apply to F)
C
            SCL(1,JDO240) = SC(1)
            SCL(2,JDO240) = SC(2)
            BET(1,JDO240) = BETA(1)
            BET(2,JDO240) = BETA(2)
            BET(3,JDO240) = BETA(3)
            BET(4,JDO240) = BETA(4)
            BET(5,JDO240) = BETA(5)
            BET(6,JDO240) = BETA(6)
C
C---- Repeat for all derivatives
C
 240  CONTINUE
C
      IF (LSCALE.EQ.3 .AND. (.NOT.ANALYSE)) THEN
C
C---- Workout isotropic equivalent temperature factor.
C
         DO 241 JDO241 = 1,JDER
            DO 242 JDO242 = 1,6
               BETA(JDO242) = BET(JDO242,JDO241)
 242        CONTINUE
C
C                **************************
            CALL ISOEQUIV(CELL,BETA,JDO241)
C                **************************
C
 241     CONTINUE
      END IF
C
C---- Apply scales and write new file
C
C     ***********
      CALL SCAPLY
      CALL CCPERR(0,' Normal termination of SCALEIT')
C     ***********
C
      END
C
C
      BLOCK DATA SCBLK
      INTEGER MCOLS
      PARAMETER (MCOLS=500)
      INTEGER IPOINT
      COMMON /POINTS/IPOINT(MCOLS)
      SAVE /POINTS/
C     This code signs which input columns are essential
      DATA IPOINT
     1     /         -1,  -1,  -1,
     1     -1,  -1,
     1     -1,  -1,   0,   0,
     1     0,   0,   0,   0,
     1     0,   0,   0,   0,
     1     0,   0,   0,   0,
     1     0,   0,   0,   0,
     1     0,   0,   0,   0,
     1     0,   0,   0,   0,
     1     0,   0,   0,   0,
     1     0,   0,   0,   0,
     1     0,   0,   0,   0,
     1  455    *0/
      END
C
C
C     ===============================
      SUBROUTINE DIFFER1(IDER)
C     ===============================
C
C---- DIFFER -- stolen to incorporate in anisosc 8/12/89 rgd
C    This program incorporates Ian Tickle's thoughts on this problem.
C    October 1989.
C
C   What is a sensible threshhold x for suspecting differences between
C   "Fp" and "Fph"  greater than x*rmsdif ?   This ia a function of N,
C    the number of observations. Assume x = 4 as a first approximation
C    and iterate till convergence.
C
C    Fixed point iteration to solve equation:
C
C         infinity
C    2.integral        p(t).dt = 1/(2.N)
C               x
C
C  where N = number of observations, x is the threshold above which
C  the probability of finding observations is 1/(2.N), and
C  p(t) = exp(-t**2/2)/sqrt(2.pi)  ... the normal distribution
C
C  In the limit of large x, the integral of p(t) is just p(x)/x
C  Therefore rearranging:
C
C     x = sqrt(2.ln(C.N/x))     where C = 4/sqrt(2.pi)
C
C
C---- intv is now used 12/12/89
C
C----  find the allowable difference
C
C Note that the histogram stuff is now inactive, but has not been removed
C
C      IMPLICIT NONE
C
C     .. Parameters ..
      INTEGER NDER,MXHIS,MX2HIS,MAXINX
      PARAMETER (NDER=20)
      PARAMETER (MXHIS=8, MX2HIS=2*MXHIS+1)
      PARAMETER (MAXINX=1000)
C HISWID = half width of histogram in multiples of RMS
      REAL HISWID
      PARAMETER (HISWID=4.0)
C     ..
C     .. Scalar Arguments ..
      INTEGER IDER
C     ..
C     .. Array Arguments ..
C     ..
C     .. Arrays in COMMON ..
      REAL DIF,DIFDAT
      INTEGER INTER,NREF,JHIST
C     ..
C     .. Local Scalars ..
      REAL MAXD,RMSDIF,W,XDEL,XNEW,CONST,X4
      INTEGER I,IJAN
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,LOG,NINT,SQRT
C     ..
C     .. COMMON blocks ..
      COMMON /DIF2/INTER(NDER,2),DIF(NDER,2),NREF(NDER,2),
     + DIFDAT(NDER,3,2)
      COMMON /DIFF/JHIST(MAXINX,NDER,MX2HIS,2)
      CHARACTER DTITLE*80
      COMMON /CDIF2/DTITLE(NDER)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      CONST = 4.0/SQRT(2.0*3.141592654)
C
      call ccp4h_summary_beg()
      write(6,'(//,a,/,a)') 
     + '    ----------------------------------------------------------',
     + '    ----------------------------------------------------------'
      DO 30 IJAN = 1,2
        NREF(IDER,IJAN) = NINT(DIFDAT(IDER,2,IJAN))
        IF (NREF(IDER,IJAN).NE.0) THEN
C          INTER(IDER,IJAN) = KINTER
C          RMSDIF = DIFDAT(3*IJAN-2)
          RMSDIF = DIFDAT(IDER,1,IJAN)
          MAXD = NINT(DIFDAT(IDER,3,IJAN))
          IF (IJAN.EQ.1) WRITE (6,FMT='(A,/,A,A)')
     +        '   Isomorphous Differences',
     1   ' Derivative title: ',DTITLE(IDER)
          IF (IJAN.EQ.2) WRITE (6,FMT='(//,A,/,A)')
     + '    ----------------------------------------------------------',
     +        '     Anomalous Differences'
          I = 0
          X4 = 4.0
   10     CONTINUE
C
          I = I + 1
          W = LOG(NREF(IDER,IJAN)*CONST/X4)
          IF (W.GT.0.0) THEN
C
            XNEW = SQRT(2.0*W)
            XDEL = ABS(XNEW-X4)/X4
            X4 = XNEW
            IF (XDEL.GT.0.01) THEN
              GO TO 10
            ELSE
              GO TO 20
            END IF
          END IF
          WRITE (6,FMT='(A)')
     + '  **  Problems - not enough observations for statistical test**'
C
   20     CONTINUE
C
          DIF(IDER,IJAN) = X4*RMSDIF
          WRITE (6,FMT='(A,F8.4,A,/,A,F8.2,/,A,F8.2)')
     +      ' Differences greater than ',X4,' * RMSDIF are unlikely,',
     +      ' ie  acceptable differences are less than ',
     +      DIF(IDER,IJAN),' Maximum difference ',MAXD
C
          INTER(IDER,IJAN) = NINT(RMSDIF*HISWID/REAL(MXHIS))
          WRITE (6,FMT='(/,A,I5)')
     +      ' Difference interval for Histogram ',INTER(IDER,IJAN)
        END IF
   30 CONTINUE
      call ccp4h_summary_end()
C
C
      END
      SUBROUTINE DIFFER2(IN,FN,FD,FDIFF,IDER,JAN,JRESLN,IFLG)
C     =======================================================
C
C     Check for larger differences & accumulate histogram
C
C     IN      h,k,l
C     FN      native F
C     FD      derivative F
C     FDIFF   anomalous difference
C     IDER    derivative number
C     JAN     = 1 if anomalous present, = 0 if absent
C     JRESLN  resolution shell number
C
C Returns IFLG = 1  if large isomorphous difference
C              = 2  if large anomalous difference
C              = 3  if both large
C              = 0  OK
C
C      IMPLICIT NONE
C
C     .. Parameters ..
      INTEGER NDER,MXHIS,MX2HIS,MAXINX
      PARAMETER (NDER=20)
      PARAMETER (MXHIS=8, MX2HIS=2*MXHIS+1)
      PARAMETER (MAXINX=1000)
C     ..
C     .. Scalar Arguments ..
      REAL FD,FDIFF,FN
      INTEGER JAN,IDER,JRESLN,IFLG
C     ..
C     .. Array Arguments ..
      INTEGER IN(3)
C     ..
C     .. Arrays in COMMON ..
      REAL DIF,DIFDAT
      INTEGER INTER,JHIST,NREF
C     ..
C     .. Local Scalars ..
      INTEGER IHIST,IJAN,J,I
      REAL DIFF
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS,NINT,REAL,SQRT
C     ..
C     .. COMMON blocks ..
      CHARACTER DTITLE*80
      COMMON /CDIF2/DTITLE(NDER)
      COMMON /DIF2/INTER(NDER,2),DIF(NDER,2),NREF(NDER,2),
     + DIFDAT(NDER,3,2)
      COMMON /DIFF/JHIST(MAXINX,NDER,MX2HIS,2)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C Clear histogram arrays
      DO 10 IJAN=1,2
         NREF(IDER,IJAN) = 0
         DO 11 J=1,MX2HIS
            DO 12 I=1,MAXINX
               JHIST(I,IDER,J,IJAN) = 0
 12         CONTINUE
 11      CONTINUE
 10   CONTINUE
C
      IFLG = 0
      DO 120 IJAN = 1, (JAN+1)
         DIFF = FN-FD
         IF (IJAN.EQ.2) DIFF = FDIFF
         IF (ABS(DIFF).GT.DIF(IDER,IJAN)) IFLG = IFLG + IJAN
C
C---- for histogram of data distribution
C
         IHIST = 1
         IF(INTER(IDER,IJAN).GT.0)
     1        IHIST = NINT(DIFF/REAL(INTER(IDER,IJAN))) + MXHIS + 1
         IHIST = MAX(MIN(IHIST,MX2HIS),1)
         NREF(IDER,IJAN) = NREF(IDER,IJAN) + 1
C
         JHIST(JRESLN,IDER,IHIST,IJAN) =
     $        JHIST(JRESLN,IDER,IHIST,IJAN) + 1
C
 120  CONTINUE
C
      END
      SUBROUTINE DIFFER3(IDER,NBIN,DS)
C     ===============================
C
C---- writes out the JHIST array as a number of stars
C
C      IMPLICIT NONE
C
C     .. Parameters ..
      INTEGER NDER,MXHIS,MX2HIS,MAXINX
      PARAMETER (NDER=20)
      PARAMETER (MXHIS=8, MX2HIS=2*MXHIS+1)
      PARAMETER (MAXINX=1000)
C     ..
C     .. Scalar Arguments ..
      INTEGER IDER,NBIN
      REAL DS
C     ..
C     .. Arrays in COMMON ..
      REAL DIF,DIFDAT
      INTEGER INTER,JHIST,NREF
C     ..
C     .. Local Scalars ..
      INTEGER IJAN,I,JDO10,JDO20,JDO30
      REAL S
C     ..
C     .. Local Arrays ..
      INTEGER IRANGE(MX2HIS),ITHIST(MX2HIS)
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C     ..
C     .. COMMON blocks ..
      CHARACTER DTITLE*80
      COMMON /CDIF2/DTITLE(NDER)
      COMMON /DIF2/INTER(NDER,2),DIF(NDER,2),NREF(NDER,2),
     + DIFDAT(NDER,3,2)
      COMMON /DIFF/JHIST(MAXINX,NDER,MX2HIS,2)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
C---- Write out results
C
          WRITE (6,FMT=6002)
 6002 FORMAT (//' Histogram showing distribution of differences'//
     $        5X,'Table shows the number of reflections in bins',
     $         ' of difference, for each resolution shell',/,
     $        5X,'Bins are headed by the difference corresponding',
     $         ' to the mid-point of each bin'/)
C
      DO 40 IJAN = 1,2
        IF (INTER(IDER,IJAN).GT.0 .AND. NREF(IDER,IJAN).NE.0) THEN
          IF (IJAN.EQ.1) WRITE (6,FMT='(///,A,/,A,/,A,A)')
     +        '   Isomorphous Differences',
     $        '   -----------------------'
     1   ,' Derivative title: ',DTITLE(IDER)
          IF (IJAN.EQ.2) WRITE (6,FMT='(///,A,/,A)')
     +        '     Anomolous Differences',
     $        '     ---------------------'
C
          DO 10, JDO10 = 1,MX2HIS
             IRANGE(JDO10) = INTER(IDER,IJAN)*(JDO10-MXHIS-1)
             ITHIST(JDO10) = 0
 10       CONTINUE
C
          WRITE (6, FMT=6020) IRANGE
 6020     FORMAT(/1X,'    d   ',17I6/)
C
          DO 20, JDO20 = 1,NBIN
             S = SQRT(DS/(REAL(JDO20)-0.5))
             WRITE (6, FMT=6025)
     $            S,(JHIST(JDO20,IDER,I,IJAN),I=1,MX2HIS)
 6025        FORMAT(1X,F8.2,17I6)
             DO 30, JDO30 = 1,MX2HIS
                ITHIST(JDO30) = ITHIST(JDO30) +
     $               JHIST(JDO20,IDER,JDO30,IJAN)
 30          CONTINUE
 20       CONTINUE
C
          WRITE (6, FMT=6030) ITHIST
 6030     FORMAT(/1X,'   Total',17I6/)
C
       END IF
 40   CONTINUE
C
      END
      SUBROUTINE EIGEN(A, R, N, MV)
C     =============================
C
C Purpose
C
C    Compute EIGENvalues and EIGENvectors of a real symmetric
C    matrix
C---- FROM IBM SSP MANUAL (SEE P165).
C
C Usage
C    call EIGEN(a,r,n,mv)
C
C Description of parameters
C
C    A - Original matrix (symmetric), destroyed in computation.
C        resultant EIGENvalues are developed in diagonal of
C        matrix A in descending order.
C
C    R - Resultant matrix of EIGENvectors (stored columnwise,
C        in same sequence as EIGENvalues)
C
C    N - Order of matrices A and R
C
C    MV- Input code
C     0   Compute EIGENvalues and EIGENvectors
C     1   Compute EIGENvalues only (R need not be
C         dimensioned but must still appear in calling
C         sequence)
C
C Remarks
C
C    Original matrix A must be real symmetric (storage mode=1)
C    Matrix A cannot be in the same location as matrix R
C
C Subroutines and function subprograms required
C    NONE
C
C Method
C
C    Diagonalization method originated by jacobi and adapted
C    by von neumann for large computers as found in 'mathematical
C    methods for digital computers', edited by a. ralston and
C    h.s. wilf, john wiley and sons, new york, 1962, chapter 7
C
C If a double precision version of this routine is desired, the
C c in column 1 should be removed from the double precision
C statement which follows.
C
C The c must also be removed from double precision statements
C appearing in other routines used in conjunction with this
C routine.
C
C The double precision version of this subroutine must also
C contain double precision fortran functions.  sqrt in statements
C 40, 68, 75, and 78 must be changed to dsqrt.  abs in statement
C 62 must be changed to dabs. the constant in statement 5 should
C be changed to 1.0d-12.
C
C     REAL    A(*), R(*)
      INTEGER         N, MV
C
      INTEGER         IQ, J, I, IJ, IA, IND, L, M, MQ, LQ, LM, LL, MM
      INTEGER         ILQ, IMQ, IM, IL, ILR, IMR
C     REAL            ANORM, ANRMX, RANGE, THR, X, Y, SINX, SINX2,
C     &                         COSX, COSX2, SINCS
C
C               DOUBLE PRECISION A(*), R(*)
C               DOUBLE PRECISION ANORM, ANRMX, RANGE, THR, X, Y, SINX, SINX2,
C           &                   COSX, COSX2, SINCS
         REAL  A(*), R(*)
         REAL  ANORM, ANRMX, RANGE, THR, X, Y, SINX, SINX2,
     &                  COSX, COSX2, SINCS
C---- FOR DOUBLE PRECISION, "RANGE" MUST BE 1.D-12 .
C       DATA RANGE/1.D-12/
      DATA RANGE/1.E-6/
C
      IF (MV.EQ.0) THEN
          IQ=-N
          DO 20 J=1,N
            IQ=IQ+N
            DO 20 I=1,N
              IJ=IQ+I
              IF (I.EQ.J) THEN
                R(IJ)=1.
              ELSE
                R(IJ)=0.
              END IF
20      CONTINUE
      END IF
C
C---- INITIAL AND FINAL NORMS (ANORM & ANRMX)
      ANORM=0.
      DO 35 I=1,N
          DO 35 J=I,N
            IF (I.NE.J) THEN
              IA=I+(J*J-J)/2
              ANORM=ANORM+A(IA)**2
            ENDIF
35    CONTINUE
C
      IF (ANORM.LE.0.) GOTO 165
      ANORM=SQRT(2.*ANORM)
      ANRMX=ANORM*RANGE/N
C
C---- INITIALIZE INDICATORS AND COMPUTE THRESHOLD
      IND=0
      THR=ANORM
45    THR=THR/N
50    L=1
55    M=L+1
C
C---- COMPUTE SIN & COS
60    MQ=(M*M-M)/2
      LQ=(L*L-L)/2
      LM=L+MQ
      IF (ABS(A(LM))-THR.LT.0.) GOTO 130
      IND=1
      LL=L+LQ
      MM=M+MQ
      X=.5*(A(LL)-A(MM))
      Y=-A(LM)/SQRT(A(LM)**2+X*X)
C---- Protect against rounding error. C. Flensburg 20080307.
      IF (ABS(Y).GT.1.0) Y=SIGN(1.0,Y)
      IF (X.LT.0.) Y=-Y
      SINX=Y/SQRT(2.*(1.+(SQRT(1.-Y*Y))))
      SINX2=SINX**2
      COSX=SQRT(1.-SINX2)
      COSX2=COSX**2
      SINCS=SINX*COSX
C
C---- ROTATE L & M COLUMNS
      ILQ=N*(L-1)
      IMQ=N*(M-1)
      DO 125 I=1,N
          IQ=(I*I-I)/2
          IF (I.NE.L .AND. I.NE.M) THEN
            IF(I.LT.M) THEN
              IM=I+MQ
            ELSE
              IM=M+IQ
            ENDIF
            IF (I.LT.L) THEN
              IL=I+LQ
            ELSE
              IL=L+IQ
            ENDIF
            X=A(IL)*COSX-A(IM)*SINX
            A(IM)=A(IL)*SINX+A(IM)*COSX
            A(IL)=X
          ENDIF
          IF (MV.EQ.0) THEN
            ILR=ILQ+I
            IMR=IMQ+I
            X=R(ILR)*COSX-R(IMR)*SINX
            R(IMR)=R(ILR)*SINX+R(IMR)*COSX
            R(ILR)=X
          ENDIF
125   CONTINUE
C
      X=2.*A(LM)*SINCS
      Y=A(LL)*COSX2+A(MM)*SINX2-X
      X=A(LL)*SINX2+A(MM)*COSX2+X
      A(LM)=(A(LL)-A(MM))*SINCS+A(LM)*(COSX2-SINX2)
      A(LL)=Y
      A(MM)=X
C
C---- TESTS FOR COMPLETION
C---- TEST FOR M = LAST COLUMN
130   IF (M.NE.N) THEN
          M=M+1
          GOTO 60
      ENDIF
C
C---- TEST FOR L =PENULTIMATE COLUMN
      IF (L.NE.N-1) THEN
          L=L+1
          GOTO 55
      ENDIF
      IF (IND.EQ.1) THEN
          IND=0
          GOTO 50
      ENDIF
C
C---- COMPARE THRESHOLD WITH FINAL NORM
      IF (THR.GT.ANRMX) GOTO 45
165   RETURN
      END
      SUBROUTINE EIGSOL
     &  (ELIM, SWES, NOB, DBUG, NVAR, BV, NA, AM, DV, ESD)
C
C====   Solution of linear equations by eigenvalue filtering.
C
C       Ian J. Tickle           Birkbeck
C
C       Imported arguments:
C       ==================
C
C       ELIM    Eigenvalue limit for filtering.  This should be at least
C               the square root of the relative machine precision,
C               ie 0.00035 for single precision, 5.E-9 for double
C               (of course to get double precision you will have to
C               compile this with auto-double on).
C
C       SWES    Sum of weighted squared differences.
C
C       NOB     Number of observations.
C
C       DBUG    Flag to turn on some debugging output (LOGICAL).
C
C       NVAR    Number of variables.
C
C       BV      Normal equation vector.
C
C       NA      Dimension of matrix AM.
C
C       Modified arguments.
C       ==================
C
C       AM      Array used to store normal matrix and to return the
C               variance/covariance matrix.  Only one triangle is stored,
C               so the dimension of A must be at least NVAR * (NVAR + 1) / 2 .
C               The storage order is ((AM(I,J), J = 1, I), I = 1, NVAR) .
C
C       Exported arguments.
C       ==================
C
C       DV      Parameter shift vector.
C
C       ESD     Standard deviation vector.
C
C****   Change value of MVAR in PARAMETER statement if you need more
C       variables.
C
      INTEGER         MVAR
      PARAMETER      (MVAR=250)
      INTEGER         NOB, NVAR, NA
      LOGICAL         DBUG
      REAL            ELIM, SWES,ZERO,SMALL
      REAL            BV(NVAR), AM(NA), DV(NVAR), ESD(NVAR)
C       DOUBLE PRECISION ELIM, SWES,DZERO,DSMALL
C               DOUBLE PRECISION   BV(NVAR), AM(NA), DV(NVAR), ESD(NVAR)
C
C               DOUBLE PRECISION RM(MVAR*MVAR), SV(MVAR), EV(MVAR)
        REAL RM(MVAR*MVAR), SV(MVAR), EV(MVAR)
      INTEGER         IB(10), JB(10)
C     DOUBLE PRECISION CB(10)
                REAL CB(10)
      INTEGER         IA, IV, JA, JV, J, I, NNZ, K, KV, KB
C               double precision DM, SUMP, AIJ, RMSWD, CC
         REAL  DM, SUMP, AIJ, RMSWD, CC
C
      IF (NVAR.GT.MVAR) CALL CCPERR(1,
     +  '*** TOO MANY VARIABLES - INCREASE MVAR')
C
C       Solve matrix equation.  First get the diagonal elements of the normal
C       matrix and use them to pre-condition the vector and matrix to minimise
C       the effects of round-off errors due to large differences in the
C       magnitudes of the eigenvalues.
C
      DM = 0.
      IA = 0
      DO 10 IV = 1, NVAR
          IA = IA + IV
10      DM = MAX(DM, AM(IA))
      DM = DM * 1.E-12
C
      IF(DBUG)WRITE(6,'(/A)') ' VECTOR AND MATRIX'
      IA = 0
      DO 20 IV = 1, NVAR
          JA = IA + IV
           IF(DBUG)
     +  WRITE(6,'(1X,I2,(1X,10(1PE11.3)))') IV,BV(IV),(AM(I),I=IA+1,JA)
          IF (AM(JA) .LE. DM) THEN
            SV(IV) = 0.
          ELSE
            SV(IV) = 1. / SQRT(AM(JA))
          ENDIF
          BV(IV) = SV(IV) * BV(IV)
          DO 20 JV = 1, IV
            IA = IA + 1
20        AM(IA) = SV(IV) * SV(JV) * AM(IA)
C
      IF(DBUG)WRITE(6,'(/A)') ' SCALED VECTOR AND MATRIX'
      IA = 0
      DO 30 IV = 1, NVAR
          JA = IA + IV
          IF(DBUG)
     + WRITE(6,'(1X,I2,(1X,10(1PE11.3)))') IV,BV(IV),(AM(I),I=IA+1,JA)
30      IA = JA
C
C       Now calc eigenvalues & eigenvectors.
C
      CALL EIGEN(AM, RM, NVAR, 0)
C
C       Find largest eigenvalue.
C
      DM = 0.
      IA = 0
      DO 40 IV = 1, NVAR
          IA =IA + IV
          EV(IV) = AM(IA)
40      DM = MAX(DM, ABS(EV(IV)))
      DM=ELIM*DM
C
      IF (DBUG) THEN
          WRITE(6,'(/A)') ' EIGENVALUES'
          WRITE(6,'((1X,10(1PE11.3)))') (EV(IV), IV = 1, NVAR)
          WRITE(6,'(/A)') ' EIGENVECTORS'
          DO 50 J = 0, NVAR-1
50        WRITE(6,'(1X,10F11.4)') (RM(I+J), I=1,NVAR**2,NVAR)
      ENDIF
C
C       Invert the eigenvalues with filtering.
C
      NNZ = 0
      DO 60 IV = 1, NVAR
          IF (ABS(EV(IV)) .LE. DM) THEN
            EV(IV) = 0.
          ELSE
            EV(IV) = 1. / EV(IV)
            NNZ = NNZ + 1
      ENDIF
60    CONTINUE
C
      IF (DBUG) THEN
          WRITE(6,'(/A)') ' INVERSE EIGENVALUES'
          WRITE(6,'((1X,10(1PE11.3)))') (EV(IV), IV = 1, NVAR)
      ENDIF
C
C       Form the elements of the inverse normal matrix.
C
      SUMP = 0.
      IA = 0
      DO 90 IV = 1, NVAR
          DV(IV) = 0.
          DO 80 JV = 1, NVAR
            AIJ = 0.
            K = 0
            DO 70 KV = 1, NVAR
              AIJ = AIJ + RM(IV + K) * EV(KV) * RM(JV + K)
70          K= K + NVAR
C
C       Save inverse normal matrix for correlations and e.s.d.'s
C
            IF (IV .GE. JV) THEN
              IA = IA + 1
              AM(IA) = AIJ
            ENDIF
C
C       Shift vector = inverse matrix . difference vector
C
80        DV(IV) = DV(IV) + AIJ * BV(JV)
C
          SUMP = SUMP + DV(IV) * BV(IV)
90      DV(IV) = SV(IV) * DV(IV)
C
C       Calculate standard error of fit.
C
        ZERO = 0.0
CPB        DZERO = 0.0
CDP     RMSWD = DSQRT(MAX(SWES - SUMP,DZERO) / MAX(NOB - NNZ,1))
      RMSWD =  SQRT(MAX(SWES - SUMP, ZERO) / MAX(NOB - NNZ,1))
C
      IF(DBUG)THEN
        WRITE(6,'(/A)') ' INVERSE MATRIX'
      IA = 0
      DO 100 IV = 1, NVAR
          JA = IA + IV
          WRITE(6,'(1X,I2,(1X,10F10.4))') IV,(AM(I),I=IA+1,JA)
100     IA = JA
         END IF
C
C       Calculate e.s.d.'s and the correlation matrix.
C
      IA = 0
      KB = -1
      DO 110 IV = 1, NVAR
          SMALL = 1.E-6
CPB          DSMALL = 1.E-12
CDP       ESD(IV) = MAX( DSQRT(AM(IA + IV)), DSMALL)
          ESD(IV) = MAX(  SQRT(AM(IA + IV)),  SMALL)
          DO 110 JV = 1, IV
            IA = IA + 1
            CC = AM(IA) / (ESD(IV) * ESD(JV))
            IF (IV .NE. JV .AND. ABS(CC) .GT. 0.7) THEN
              IF ( KB .LT. 0) THEN
                WRITE(6,'(/A)') ' CORRELATION MATRIX ELEMENTS > 0.7'
                KB = 0
              ENDIF
              KB = KB + 1
              IB(KB) = IV
              JB(KB) = JV
              CB(KB) = CC
              IF ( KB .EQ. 6) THEN
                WRITE(6, '(1X,6(4X,2I4,F9.4))')
     &          (JB(KB), IB(KB), CB(KB), KB = 1, 6)
                KB = 0
              ENDIF
            ENDIF
110   CONTINUE
      IF (DBUG .AND. KB .GT. 0) WRITE(6, '(1X,6(4X,2I4,F9.4))')
     &  (JB(I), IB(I), CB(I), I = 1, KB)
C
C       Scale the variance / covariance matrix.
C
      IA = 0
      DO 120 IV = 1, NVAR
          SV(IV) = RMSWD * SV(IV)
          ESD(IV) = SV(IV) * ESD(IV)
          DO 120 JV = 1, IV
            IA = IA + 1
120       AM(IA) = SV(IV) * SV(JV) * AM(IA)
      END
       SUBROUTINE ISOEQUIV(CEL,BET,IDER)
C      ==========================
C   CELL  - real unit cell
C
C   BET  - the anisotropic numbers B11 B22  B33 B12 B13 B23 which
C  generate this scale factor to be  applied to the derivative F as
C  (derivative scale)*
C  exp( - (B11*H**2 + B22*K**2 + B33*L**2 +  2*(B12*H*K + B13*H*L + B23*K*L) )
C
      INTEGER IDER,I,J,K,ISGN
      REAL BET(6),CEL(6)
      REAL BETA(3,3),FT(3,3),F(3,3),AJUNK(3,3),B(3,3)
      REAL RRR(4,4),RRINV(4,4)
      REAL VECT(3,3),VAL(3),WEIGHT(15)
      REAL RR(3,3,6),CELLAS(6)
      REAL VOL,RVOL,PRDVAL,DE
      EXTERNAL MATMUL
C..
       SAVE
C...
C
C    First time through....
C
            IF(IDER.EQ.1) THEN
C   We will want an orthogonal set of axes - use RBFRO1 to get them
C   RR(...,1)  corresponds to   axial system a,c*xa c*   ie Matrix F
      CALL RBFRO1(CEL,VOL,RR)
C
C   Return reciprocal cell too.
        CALL RBRCEL(CELLAS,RVOL)
C
C    Invert RR(...,1)
      RRR(4,4)= 1.0
      DO 2 I=1,3
       RRR(I,4)= 0.0
       RRR(4,I)= 0.0
      DO 2 J=1,3
2      RRR(J,I)= RR(J,I,1)
       CALL RBRINV(RRR,RRINV)
C   RRinv  corresponds to   axial system a*,cxa* c   (ncode = 1)
C  ie Matrix C in Willis and Pryer  p 100
C
          WRITE(6,6005)
 6005 FORMAT(//,
     - ' *****************************************************',/,
     - ' ***  ANALYSIS OF TEMPERATURE FACTORS  *** ',/,
     - ' *****************************************************',/,
     - ' Remember: the scale is applied to the derivative F as',/,
     - ' (derivative scale)*',
     - ' exp( - (B11*H**2 + B22*K**2 + B33*L**2 + ',
     - ' 2*(B12*H*K + B13*H*L + B23*K*L) )  )')
C
       WRITE(6,'(//,10X,A)')
     1 ' An equivalent  form of the anisotropic temperature factor is '
       WRITE(6,'(/,a,a)')
     1 ' exp(-0.25(  h**2 * (a*)**2 * beta11 + k**2 * (b*)**2 * beta22',
     1 ' + l**2 * (c*)**2 * beta33 '
       WRITE(6,'(A,A)')
     1  '           + 2*k*l*(b*)*(c*)*beta23 + ',
     1 '2*l*h*(c*)*(a*) *beta31 + 2*h*k*(a*)*(b*) *beta12))'
       WRITE(6,'(//,a,a)')
     1 ' (This means the Uij terms of an anisotropic temperature',
     1 '  factor is equal to betaij/(8*pi**2.)'
       write(6,'(//,a)')
     +   '  Note: REFMAC5 outputs betaij/4 '
C
       WRITE(6,'(//,A)')
     1 '    The isotropic equivalent is ::'
C
       WRITE(6,*)
     1 ' exp(-B (sin**2(theta)/lamda**2) )  =  '
C
       WRITE(6,'(/,A,A,/,A,A)')
     1 ' exp(-0.25( h**2 * (a*)**2 * B       + k**2 * (b*)**2 * B   ',
     1 '  +  l**2 * (c*)**2 * B ',
     1 '         + 2*k*l*(b*)*(c*)*cosAS*B  + ',
     1 ' 2*l*h*(c*)*(a*)*cosBS*B  + 2*h*k*(a*)*(b*)*cosGS*B))'
C
        END IF
C
C  Set up B matrix
         B(1,1) = BET(1)
         B(2,2) = BET(2)
         B(3,3) = BET(3)
         B(1,2) = BET(4)
         B(2,1) = BET(4)
         B(1,3) = BET(5)
         B(3,1) = BET(5)
         B(3,2) = BET(6)
         B(2,3) = BET(6)
C
C   RR(...,1)  corresponds to   axial system a,c*xa c*   ie Matrix F
C
C  Referring to  Willis and Pryer  p 100 to find the beta ellipsoid.
       DO 10 I=1,3
       DO 10 J=1,3
C       F transpose is equivalent to RO = rr(...,1)
C 14-3-90   No I think     F transpose is equivalent to rrr
      FT(I,J)=RRR(I,J)
C       F
10    F(J,I)=RRR(I,J)
C put beta on ortho-normal axes
C   Matrix product  BETA = F(trans) * BETA * F
      CALL MATMUL(AJUNK,FT,B)
      CALL MATMUL(BETA,AJUNK,F)
C
      call ccp4h_pre_beg()
      WRITE(6,'(///,A,I3,/,A,/A,/A)')
     1 ' For derivative :',IDER,
     1 ' beta matrix - array elements beta11 beta12 beta13',
     1 '                              beta21 beta22 beta23,',
     1 '                              beta31 beta32 beta33'
       WRITE(6,'(3(/10x,3f14.4))')BETA(1,1)*4,BETA(1,2)*4,BETA(1,3)*4,
     1       BETA(2,1)*4,BETA(2,2)*4,BETA(2,3)*4,
     1       BETA(3,1)*4,BETA(3,2)*4,BETA(3,3)*4
C
C   call ea06c(A(matrix),v(alue),v(ector),3(size),3(a size),3(v size),w)
      CALL EA06C(BETA,VAL,VECT,3,3,3,WEIGHT)
C  Multiply latent roots by 4 now
      WRITE(6,952)
 952  FORMAT(//' Latent roots and vectors of "BETA" - '/,
     1  ' Vectors are relative to orthogonal axial system parallel to',
     1  '  a*   cXa*   c',/)
      PRDVAL=1
      DO 404 K=1,3
      DE=VECT(1,K)**2 + VECT(2,K)**2 + VECT(3,K)**2
      DE=SQRT(DE)
      WRITE(6,953)K,VAL(K)*4,VECT(1,K),VECT(2,K),VECT(3,K),DE
  953 FORMAT(//' LAMBDA',I3,5X,F15.8,5X,3(/35X,F15.3),'   length',F8.4)
       PRDVAL = PRDVAL * VAL(K)*4
  404 CONTINUE
          ISGN = -1
          IF(PRDVAL.GT.0.0001) ISGN = 1
       IF(ABS(PRDVAL).GT.0.0001)PRDVAL = ISGN*ABS(PRDVAL)**0.3333
       WRITE(6,'(//A,F14.4)')
     +  '  The equivalent isotropic temperature factor is ',PRDVAL
       WRITE(6,'(A,A)')
     +  '  This gives a spherical temperature "volume" equal to',
     +  '  the ellipsoidal "volume",'
        RETURN
C
      END
      SUBROUTINE LABDER(LABEL, NDER)
C     ==============================
C
C Check is label is "FP" (native) or "FPHn" (derivative)
C
C On entry:
C     label     string, may be FP, FPHn or other
C
C On exit:
C     nder  = 0 if label = "FP"
C           = n if label = "FPHn"
C           =-1 if neither
C
      CHARACTER*(*) LABEL
      INTEGER       NDER
C
      CHARACTER*20 LAB
      INTEGER NTOK
      PARAMETER (NTOK=5)
      INTEGER IBEG(NTOK),IEND(NTOK),ITYP(NTOK),IDEC(NTOK),N
      REAL FVALUE(NTOK)
      CHARACTER*4 CVALUE(NTOK)
C
C copy to local string
      LAB = LABEL
C uppercase
      CALL CCPUPC(LAB)
C
      IF (LAB(1:3) .EQ. 'FPH') THEN
         LAB = LAB(4:)
         N = -NTOK
         CALL PARSE(LAB,IBEG,IEND,ITYP,FVALUE,CVALUE,IDEC,N)
         IF (ITYP(1) .NE. 2) THEN
            NDER = -2
         ELSE
            NDER = NINT(FVALUE(1))
         ENDIF
      ELSEIF (LAB(1:2) .EQ. 'FP') THEN
         NDER = 0
      ELSE
         NDER = -1
      ENDIF
      RETURN
      END
C
      SUBROUTINE RCARDS
C     ==================
C     new keywords added
      IMPLICIT NONE
C
C     .. Parameters ..
      INTEGER NDER
      PARAMETER (NDER=20)
      INTEGER NKEYWD
      PARAMETER (NKEYWD=200)
      INTEGER NKEY
      PARAMETER (NKEY=15)
      INTEGER NBIN
      PARAMETER (NBIN=20)
      INTEGER MaxSym
      PARAMETER (MaxSym=192)
      INTEGER MaxSets
      PARAMETER (Maxsets=20)
C     ..
C     .. Scalars in COMMON ..
      INTEGER MCOLS
      PARAMETER (MCOLS=500)
      REAL CONV
      INTEGER ISOUT,JDER,LUNIN,LUNOUT,NCYC,NSYM,LSCALE
      LOGICAL ANALYSE,OUTPUT,WILSON,NORMAN,SCATPLT
      DOUBLE PRECISION TOL
C     ..
C     .. Arrays in COMMON ..
      REAL BET,BETA,PERM,RSYM,RSYMT,SC,SCL,SIGM,FMAX,
     +     DMAX,DIFFS,DIF,DIFDAT
      INTEGER IMIN,IMAX,IPOINT,ISEE,JJJNK,INTER,NREF
      LOGICAL REFSCL
C     ..
C     .. Local Scalars ..
      REAL RESMAX,RESMIN,SMAX,SMIN,TEMP,RMSF2
      REAL VOL,RVOL
      INTEGER ISET,J,JDO10,JDO30,NERR,NSPGRP,NSYMP,NTOK,JDO91,JDO210
      INTEGER NLPRGI,ILAB,NDERIV,ILPRGI,JLEN,KLEN,LLEN,ILEN,MLEN,IFLAG
      INTEGER IFIL1,IPRINT,I,LSCTMP,LSCLST,NOWT,ITOK,IDER,IFAIL
      LOGICAL LEND,LTITLE,LWARN,LAUTO,LSWITCHED,LREFINE
      CHARACTER KEY*4,PGNAM*10,NAMSPG*10,THIS_TYPE*1,LAST_TYPE*1,
     +     TITLE*80,LINE*3000,LTYPEX*1
      INTEGER NDATASETS,NCOL,THIS_SET,ii,jj,kk,THIS_DERIV,ifirst,ilast
C     ..
C     .. Local Arrays ..
      REAL CELL,CELLAS,FVALUE(NKEYWD),RR(3,3,6)
      INTEGER IBEG(NKEYWD),IDEC(NKEYWD),IEND(NKEYWD),ITYPE(NKEYWD)
      CHARACTER CVALUE(NKEYWD)*4,KEYS(NKEY)*4
      REAL CRANGE(2,MCOLS)
      INTEGER NREFLS,NCOLS,SETID,SET_INDEX
      CHARACTER PNAME(MaxSets)*64,XNAME(MaxSets)*64,DNAME(MaxSets)*64
      CHARACTER CTYPS(MCOLS)*1,CLABS(MCOLS)*30
      REAL DATCELL(6,MaxSets),DATWAVE(MaxSets)
      INTEGER ISETS(MaxSets),IUNSCALD(0:MaxSets,20),CSETID(MCOLS)
      INTEGER INDERIV(MaxSets)
      LOGICAL LDSCALE(MaxSets),LINTENS(MaxSets),LANOMAL(MaxSets)
C     ..
      COMMON /ATSYM/RSYM(4,4,MaxSym),RSYMT(4,4,MaxSym),NSYM,PERM(4,4),
     +             JJJNK(9)
      CHARACTER DTITLE*80
      COMMON /CDIF2/DTITLE(NDER)
      COMMON /DIF2/INTER(NDER,2),DIF(NDER,2),NREF(NDER,2),
     + DIFDAT(NDER,3,2)
      COMMON /INOUT/LUNIN,LUNOUT,ISOUT
      COMMON /SI_INPUT/TOL,NCYC,CONV,JDER,SIGM(NDER+1),FMAX(NDER+1),
     $              DMAX(NDER+1),DIFFS(NDER+1),NOWT,REFSCL(NDER),
     $              OUTPUT,LSCALE,WILSON,NORMAN,ANALYSE,scatplt
      COMMON /POINTS/IPOINT(MCOLS)
      COMMON /RANGES/IMIN(4),IMAX(4),RMSF2,SMIN,SMAX
      COMMON /SCALES/SC(2),BETA(6),SCL(2,NDER),BET(6,NDER),ISEE(4),
     +     CELL(6),CELLAS(6)
C     Stuff for LABI / LABO
C
C     .. Intrinsic Functions ..
      INTEGER LENSTR
      INTRINSIC NINT
C     ..
      CHARACTER*1 CTPRGI(MCOLS)
      CHARACTER*30 LSPRGI(MCOLS),LSUSRJ(MCOLS)
      CHARACTER*200 DUMMY
      SAVE /CDIF2/, /DIF2/, /POINTS/, /INOUT/, /SI_INPUT/, /RANGES/,
     +     /SCALES/, /ATSYM/
C     .. Data statements ..
      DATA KEYS/'TITL','RESO','SYMM','CONV','GRAP','EXCL','LABI','ANAL',
     +          'NOWT','REFI','SCAL','WEIG','SCAT','AUTO','END' /
C
C
      DATA NLPRGI / 285 /
      DATA LSPRGI / 'H','K','L', 'FP','SIGFP',
     +     'FPH1 ','SIGFPH1 ','DPH1 ','SIGDPH1 ',
     +     'FPH1(+)','SIGFPH1(+)','FPH1(-)','SIGFPH1(-)',
     +     'IMEAN1','SIGIMEAN1','I1(+)','SIGI1(+)','I1(-)','SIGI1(-)',
     +     'FPH2 ','SIGFPH2 ','DPH2 ','SIGDPH2 ',
     +     'FPH2(+)','SIGFPH2(+)','FPH2(-)','SIGFPH2(-)',
     +     'IMEAN2','SIGIMEAN2','I2(+)','SIGI2(+)','I2(-)','SIGI2(-)',
     +     'FPH3 ','SIGFPH3 ','DPH3 ','SIGDPH3 ',
     +     'FPH3(+)','SIGFPH3(+)','FPH3(-)','SIGFPH3(-)',
     +     'IMEAN3','SIGIMEAN3','I3(+)','SIGI3(+)','I3(-)','SIGI3(-)',
     +     'FPH4 ','SIGFPH4 ','DPH4 ','SIGDPH4 ',
     +     'FPH4(+)','SIGFPH4(+)','FPH4(-)','SIGFPH4(-)',
     +     'IMEAN4','SIGIMEAN4','I4(+)','SIGI4(+)','I4(-)','SIGI4(-)',
     +     'FPH5 ','SIGFPH5 ','DPH5 ','SIGDPH5 ',
     +     'FPH5(+)','SIGFPH5(+)','FPH5(-)','SIGFPH5(-)',
     +     'IMEAN5','SIGIMEAN5','I5(+)','SIGI5(+)','I5(-)','SIGI5(-)',
     +     'FPH6 ','SIGFPH6 ','DPH6 ','SIGDPH6 ',
     +     'FPH6(+)','SIGFPH6(+)','FPH6(-)','SIGFPH6(-)',
     +     'IMEAN6','SIGIMEAN6','I(+)6','SIGI6(+)','I6(-)','SIGI6(-)',
     +     'FPH7 ','SIGFPH7 ','DPH7 ','SIGDPH7 ',
     +     'FPH7(+)','SIGFPH7(+)','FPH7(-)','SIGFPH7(-)',
     +     'IMEAN7','SIGIMEAN7','I7(+)','SIGI7(+)','I7(-)','SIGI7(-)',
     +     'FPH8 ','SIGFPH8 ','DPH8 ','SIGDPH8 ',
     +     'FPH8(+)','SIGFPH8(+)','FPH8(-)','SIGFPH8(-)',
     +     'IMEAN8','SIGIMEAN8','I8(+)','SIGI8(+)','I8(-)','SIGI8(-)',
     +     'FPH9 ','SIGFPH9 ','DPH9 ','SIGDPH9 ',
     +     'FPH9(+)','SIGFPH9(+)','FPH9(-)','SIGFPH9(-)',
     +     'IMEAN9','SIGIMEAN9','I9(+)','SIGI9(+)','I9(-)','SIGI9(-)',
     +     'FPH10','SIGFPH10','DPH10','SIGDPH10',
     +     'FPH10(+)','SIGFPH10(+)','FPH10(-)','SIGFPH10(-)',
     +     'IMEAN10','SIGIMEAN10',
     +     'I10(+)','SIGI10(+)','I10(-)','SIGI10(-)',
     +     'FPH11','SIGFPH11','DPH11','SIGDPH11',
     +     'FPH11(+)','SIGFPH11(+)','FPH11(-)','SIGFPH11(-)',
     +     'IMEAN11','SIGIMEAN11',
     +     'I11(+)','SIGI11(+)','I11(-)','SIGI11(-)',
     +     'FPH12','SIGFPH12','DPH12','SIGDPH12',
     +     'FPH12(+)','SIGFPH12(+)','FPH12(-)','SIGFPH12(-)',
     +     'IMEAN12','SIGIMEAN12',
     +     'I12(+)','SIGI12(+)','I12(-)','SIGI12(-)',
     +     'FPH13','SIGFPH13','DPH13','SIGDPH13',
     +     'FPH13(+)','SIGFPH13(+)','FPH13(-)','SIGFPH13(-)',
     +     'IMEAN13','SIGIMEAN13',
     +     'I13(+)','SIGI13(+)','I13(-)','SIGI13(-)',
     +     'FPH14','SIGFPH14','DPH14','SIGDPH14',
     +     'FPH14(+)','SIGFPH14(+)','FPH14(-)','SIGFPH14(-)',
     +     'IMEAN14','SIGIMEAN14',
     +     'I14(+)','SIGI14(+)','I14(-)','SIGI14(-)',
     +     'FPH15','SIGFPH15','DPH15','SIGDPH15',
     +     'FPH15(+)','SIGFPH15(+)','FPH15(-)','SIGFPH15(-)',
     +     'IMEAN15','SIGIMEAN15',
     +     'I15(+)','SIGI15(+)','I15(-)','SIGI15(-)',
     +     'FPH16','SIGFPH16','DPH16','SIGDPH16',
     +     'FPH16(+)','SIGFPH16(+)','FPH16(-)','SIGFPH16(-)',
     +     'IMEAN16','SIGIMEAN16',
     +     'I16(+)','SIGI16(+)','I16(-)','SIGI16(-)',
     +     'FPH17','SIGFPH17','DPH17','SIGDPH17',
     +     'FPH17(+)','SIGFPH17(+)','FPH17(-)','SIGFPH17(-)',
     +     'IMEAN17','SIGIMEAN17',
     +     'I17(+)','SIGI17(+)','I17(-)','SIGI17(-)',
     +     'FPH18','SIGFPH18','DPH18','SIGDPH18',
     +     'FPH18(+)','SIGFPH18(+)','FPH18(-)','SIGFPH18(-)',
     +     'IMEAN18','SIGIMEAN18',
     +     'I18(+)','SIGI18(+)','I18(-)','SIGI18(-)',
     +     'FPH19','SIGFPH19','DPH19','SIGDPH19',
     +     'FPH19(+)','SIGFPH19(+)','FPH19(-)','SIGFPH19(-)',
     +     'IMEAN19','SIGIMEAN19',
     +     'I19(+)','SIGI19(+)','I19(-)','SIGI19(-)',
     +     'FPH20','SIGFPH20','DPH20','SIGDPH20',
     +     'FPH20(+)','SIGFPH20(+)','FPH20(-)','SIGFPH20(-)',
     +     'IMEAN20','SIGIMEAN20',
     +     'I20(+)','SIGI20(+)','I20(-)','SIGI20(-)', 215*' '/
C
      DATA CTPRGI
     +     /'H', 'H', 'H',
     +     'F', 'Q',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     'F', 'Q', 'D', 'Q', 'G', 'L', 'G', 'L',
     +     'J', 'Q', 'K', 'M', 'K', 'M',
     +     215*' '/
C
C---- Set defaults
C
      IFIL1 = 1
      CALL CCPZR(RSYM(1,1,1),16)
      DO 10 JDO10 = 1,4
         ISEE(JDO10) = 0
         IMAX(JDO10) = 0
         IMIN(JDO10) = 0
C     initialise RSYM to NSYM 1
         RSYM (JDO10,JDO10,1) = 1.0
 10   CONTINUE
      SMAX =-1.
      RMSF2 =0.0
C
      TITLE = '  Run through SCALEIT '
      LTITLE = .FALSE.
      PGNAM = ' '
      NERR = 0
C Default refine anisotropic
      LSCALE = 3
      LSCTMP = -1
      LREFINE = .FALSE.
      ANALYSE = .FALSE.
      NORMAN = .FALSE.
      WILSON = .FALSE.
      SCATPLT = .FALSE.
      LAUTO  = .FALSE.
      LWARN  = .FALSE.
      OUTPUT = .TRUE.
      CONV = 0.001
      TOL = 0.00000001
      NCYC = 4
      NSYM = -1
C     If NOWT = 0 - scales calculated with SIGMA weighting
      NOWT = 1
      IFIL1 = 1
      DO 5, I=1,NDER+1
         SIGM(I) = 0.0
         FMAX(I) = 1.0E+10
         DMAX(I) = 1.0E+10
         DIFFS(I) = 1.0E+10
 5    CONTINUE
      DO 6, J=1,NDER
         REFSCL(J) = .FALSE.
         DO 7, I=1,2
 7          SCL(I,J) = 1.0
         DO 8, I=1,6
 8          BET(I,J) = 0.0
 6    CONTINUE
C     For detecting which datasets are being scaled
      DO 19 J=1,MAXSETS
        LDSCALE(J) = .FALSE.
        IUNSCALD(0,J) = 0
        LINTENS(J) = .FALSE.
        LANOMAL(J) = .FALSE.
 19   CONTINUE
C
C     loop to read in all keywords
 20   CONTINUE
      LINE = ' '
C     Reset number of words on line from 20 to NKEYWD
C     Need lots for LABI lines
      NTOK = NKEYWD
C
C          **********************************************************
      CALL PARSER(KEY,LINE,IBEG,IEND,ITYPE,FVALUE,CVALUE,IDEC,NTOK,LEND,
     +     .TRUE.)
C          **********************************************************
C
      IF (LEND) GO TO 200
C
      DO 30 JDO30 = 1,NKEY
         IF (KEY.EQ.KEYS(JDO30)) GO TO 40
 30   CONTINUE
C
      WRITE (6,FMT=6000)
      NERR = NERR + 1
      GO TO 20
C
C      DATA KEYS/'TITL','RESO','SYMM','CONV',
C     +     'GRAP','EXCL','LABI','ANAL','NOWT','REFI','SCAL',
C     +     'WEIGHT','SCAT','AUTO','END'/
 40   GO TO (     50,     60,    70,     80,
     1     90, 100, 110, 130, 140, 150, 160, 161, 167, 169, 200), JDO30
C
C     TITLE  read title
C     =================
C
 50   CONTINUE
      IF(NTOK.GT.1) TITLE = LINE(IBEG(2) :80)
      LTITLE = .TRUE.
      GO TO 20
C
 60   CONTINUE
C
C---- RESOLUTION
C     ==========
C
C     read resolution limits in A, if only one treat as high
C     resolution limit
      ITOK = 2
C     ********************************************************
      CALL RDRESO(ITOK,ITYPE,FVALUE,NTOK,RESMIN,
     +     RESMAX,SMIN,SMAX)
C     ********************************************************
      GO TO 20
C
C---- SYMMETRY nspgrp
C     ========
C
 70   CONTINUE
      ITOK = 2
C
C     ************************************************************
      CALL RDSYMM(ITOK,LINE,IBEG,IEND,ITYPE,FVALUE,NTOK,NAMSPG,
     +     NSPGRP,PGNAM,NSYM,NSYMP,RSYM)
C     ************************************************************
C
      GO TO  20
C
C---- CONVERGE
C     ========
C
C     get subsiduary keywords
C     NCYC(integer) TOLR(real) , ABS (real)
C
 80   CONTINUE
      ITOK = 1
 85   CONTINUE
C
      ITOK = ITOK + 1
      IF (ITOK .GT. NTOK) GO TO 20
      KEY = LINE(IBEG(ITOK) : IEND(ITOK))
      CALL CCPUPC(KEY)
      ITOK = ITOK + 1
C
      IF (KEY.EQ.'NCYC') THEN
         CALL GTPINT (ITOK,NCYC,NTOK,ITYPE,FVALUE)
         WRITE(6,FMT ='(A,I4)') ' Maximum number of cycles ',NCYC
         GOTO 85
C
      ELSE IF (KEY.EQ.'TOLR') THEN
         CALL GTPREA(ITOK,TEMP,NTOK,ITYPE,FVALUE)
         TOL = TEMP
         WRITE (6,FMT='(A,F8.5)') '  Tolerance ',TOL
         GOTO 85
C
      ELSE IF (KEY.EQ.'ABS') THEN
         CALL GTPREA (ITOK,CONV,NTOK,ITYPE,FVALUE)
         WRITE(6,FMT='(A,F10.4)')'Absolute convergence limit', CONV
         GO TO 85
C
      ELSE
         WRITE (6,FMT='(A,A4)') 'Invalid subsidary keyword CONV ',KEY
      END IF
C
C---- GRAPH  to plot on printer if isee flag gt 0
C     ===================================================
C
C     GRAPH H K L   FMOD
C
C---- if character at ibeg(num) eq to H/K/L flag set isee(i) to 1
C
 90   CONTINUE
      DO 91 JDO91 = 2,NTOK
         KEY = CVALUE(JDO91)
         CALL CCPUPC(KEY)
         IF (KEY.EQ.'H') ISEE(1) = 1
         IF (KEY.EQ.'K') ISEE(2) = 1
         IF (KEY.EQ.'L') ISEE(3) = 1
         IF (KEY.EQ.'MODF') ISEE(4)=1
C
 91   CONTINUE
C
      GO TO 20
C
C---- EXCLUDE FP[Hn]  SIG nsig  FMAX fmax
C
C     - set cut off for reflections used for scaling and statistics.
C     =================================
C
 100  CONTINUE
C
C 1st token may be FP or FPHn: is it?
C   J  returns = 0 for FP, = n for FPHn, = -2 for FPHjunk, else = -1
      CALL LABDER(LINE(IBEG(2):IEND(2)), J)
      IF (J .LE. -2) THEN
C  format error
         WRITE(LUNOUT,'(1X,A)')
     $        ' **** Illegal derivative specification in EXCLUDE ****'
         NERR = NERR+1
         GO TO 20
      ENDIF
C
C---- Now parse rest of line
C
      IF (J .EQ. -1) THEN
         ITOK = 1
      ELSE
         ITOK = 2
      ENDIF
 105  ITOK = ITOK+1
      IF (ITOK .GT. NTOK) GO TO 20
      CALL CCPUPC(CVALUE(ITOK))
      IF (CVALUE(ITOK) .EQ. 'SIG') THEN
C
C---- Read sigma cutoff
C
         ITOK = ITOK+1
         CALL GTPREA(ITOK,TEMP,NTOK,ITYPE,FVALUE)
         IF (J .EQ. -1) THEN
C
C----  cutoff for all F's
C
            DO 106, I=1,NDER+1
               SIGM(I) = TEMP
 106        CONTINUE
            WRITE (LUNOUT,FMT=6101) ' Sigma','all Fs: FP or FPHn <',
     $           TEMP,' * F '
 6101 FORMAT(1X,A,' cutoff, for ',A,G10.2,A,'excluded')
         ELSE
C
C----  cutoff for derivative J (=0 for native)
C
            SIGM(J+1) = TEMP
            WRITE (LUNOUT,FMT=6101)
     $           ' Sigma',LINE(IBEG(2):IEND(2))//' <',TEMP,' * F '
         ENDIF
      END IF
C
C---- Read Fmax cutoff
C
      IF (CVALUE(ITOK) .EQ. 'FMAX') THEN
         ITOK = ITOK+1
         CALL GTPREA(ITOK,TEMP,NTOK,ITYPE,FVALUE)
         IF (J .EQ. -1) THEN
C
C----  cutoff for all F's
C
            DO 107, I=1,NDER+1
               FMAX(I) = TEMP
 107        CONTINUE
            WRITE (LUNOUT,FMT=6101) ' Fmax ','all Fs: FP or FPHn <',
     $           TEMP,' '
         ELSE
C
C----  cutoff for derivative J (=0 for native)
C
C            SIGM(J+1) = TEMP
            FMAX(J+1) = TEMP
            WRITE (LUNOUT,FMT=6101)
     $           ' Fmax ',LINE(IBEG(2):IEND(2))//' <',TEMP,' '
         ENDIF
      END IF
C
C---- Read Dmax cutoff
      IF (CVALUE(ITOK) .EQ. 'DMAX') THEN
         IF (J .EQ. -1) THEN
         WRITE(LUNOUT,'(a)')
     +      ' Error?? - do you want anom cutoff for FP?'
         ELSE
C
         ITOK = ITOK+1
         CALL GTPREA(ITOK,TEMP,NTOK,ITYPE,FVALUE)
         DMAX(J+1) = TEMP
            WRITE (LUNOUT,FMT=6101)
     $           ' Abs(Dmax) ',LINE(IBEG(2):IEND(2))//' <',TEMP,' '
         ENDIF
      END IF
C
C---- Read Difference cutoff
      IF (CVALUE(ITOK) .EQ. 'DIFF') THEN
         IF (J .EQ. -1) THEN
         WRITE(LUNOUT,'(a)')
     +      ' Error?? - you cannot have a DIFF cutoff for FP!'
         ELSE
C
         ITOK = ITOK+1
         CALL GTPREA(ITOK,TEMP,NTOK,ITYPE,FVALUE)
         DIFFS(J+1) = TEMP
            WRITE (LUNOUT,FMT=6101)
     $           ' Abs(Diff) ',LINE(IBEG(2):IEND(2))//' <',TEMP,' '
         ENDIF
      END IF
      GO TO 105
C
C---- LABIN     i.e. set input labels
C
 110  CONTINUE
C
C     *****************************************
      CALL LKYIN(1,LSPRGI,NLPRGI,NTOK,LINE,IBEG,IEND)
C     *****************************************
C
C----     How many assigned?
C
      ITOK = 2
C
C----     this subroutine returns ipoint(kk) = 1 if label kk is set.
C
      CALL LKYSET(LSPRGI,NLPRGI,LSUSRJ,IPOINT,ITOK,NTOK,LINE,IBEG,
     +     IEND)
C
C----     Must have first 5 labels h k l  FP SIG
C
      ILAB = 5
      NDERIV=0
            ILEN  = LENSTR(LSUSRJ(4))
C     PJX: increased steps to 14 (=no. of lables per derivative)
C     for adding new input labels
      DO 111 ILPRGI = 6,NLPRGI,14
         IF(IPOINT(ILPRGI).EQ.-1 )THEN
            IF(IPOINT(ILPRGI+1).NE.-1 )THEN
C
C----     check Sig(Fhp) label - MUST be here...
C
               WRITE(LUNOUT,'(A,A)')
     +          ' F assigned without a SIGMA: label ',LSPRGI(ILPRGI+1)
               CALL CCPERR(1,' **** PROGRAM TERMINATED **')
            END IF
            NDERIV = NDERIV + 1
C
C----     Build DTITLE from these labels:
C
            JLEN  = LENSTR(LSUSRJ(ILPRGI))
            KLEN  = LENSTR(LSUSRJ(ILPRGI+1))
            DTITLE(NDERIV) =
     1           ' FP=  '
            write(6,*)DTITLE(NDERIV)
            DTITLE(NDERIV) =
     1           ' FP=  '// LSUSRJ(4)(1:ILEN)//'  '
            write(6,*)DTITLE(NDERIV)
            DTITLE(NDERIV) =
     1           ' FP=  '// LSUSRJ(4)(1:ILEN)//
     1           '   FPH= '// LSUSRJ(ILPRGI)(1:JLEN)//'  '
     1           // LSUSRJ(ILPRGI+1)(1:KLEN)//'  '
            write(6,*)DTITLE(NDERIV)
            ILAB = ILAB + 2
         END IF
C
C----     check is there anomalous data?
C
         IF(IPOINT(ILPRGI+2).EQ.-1 )THEN
            IF(IPOINT(ILPRGI+3).NE.-1 )THEN
               WRITE(LUNOUT,'(A,A)')
     +          ' DP assigned without a SIGMA: label ',LSPRGI(ILPRGI+3) 
               CALL CCPERR(1,' **** PROGRAM TERMINATED **')
            END IF
            JLEN  = LENSTR(DTITLE(NDERIV))
            LLEN  = LENSTR(LSUSRJ(ILPRGI+2))
            MLEN  = LENSTR(LSUSRJ(ILPRGI+3))
            DTITLE(NDERIV) =
     1        DTITLE(NDERIV)(1:JLEN)//' '// LSUSRJ(ILPRGI+2)(1:LLEN)//
     1           '  '// LSUSRJ(ILPRGI+3)(1:MLEN)//'  '
            ILAB = ILAB + 2
         END IF
 111  CONTINUE
C      NLPRGI = ILAB
C     PJX: changed for adding extra labels
      NLPRGI = 5 + 14*NDERIV
      GO TO 20
C
C---- ANALYSE  -
C
 130  CONTINUE
      ANALYSE = .TRUE.
      DO 135 J=1,NDER
        IF (REFSCL(J)) THEN
          WRITE(LUNOUT,*) 
     .            ' *** Cannot use REFINE and ANALYSE together ***'
          NERR = NERR + 1
          GOTO 140
        ENDIF
 135  CONTINUE
      OUTPUT = .FALSE.
      GO TO 20
C
C---- NOWT No weight  -
C
 140  CONTINUE
      NOWT = 1
      WRITE(6,*)
     1     ' Calculate scales WITHOUT any sigma weighting.'
      GO TO 20
C
C---- REFINE  scale type, Wilson option
C
 150  IF (ANALYSE) THEN
         WRITE(LUNOUT,*) 
     .      ' *** You CANNOT use REFINE and ANALYSE together ***'
         NERR = NERR + 1
      ENDIF
      LREFINE = .TRUE.
      DO 153 J=1,NDER
        REFSCL(J) = .TRUE.
 153  CONTINUE
      ITOK = 1
 155  ITOK = ITOK+1
      IF (ITOK .GT. NTOK) GO TO 20
      CALL CCPUPC(CVALUE(ITOK))
      IF (CVALUE(ITOK) .EQ. 'SCAL') THEN
         LSCALE = 1
      ELSEIF (CVALUE(ITOK) .EQ. 'ISOT') THEN
         LSCALE = 2
      ELSEIF (CVALUE(ITOK) .EQ. 'ANIS') THEN
         LSCALE = 3
      ELSEIF (CVALUE(ITOK) .EQ. 'WILS') THEN
         WILSON = .TRUE.
      ENDIF
      GO TO 155
C
C---- SCALE  input scale factor
C
 160  CONTINUE
C
C---- Store scale type
C
      LSCTMP = 1
C
C---- 1st token may be FP or FPHn: is it?
C   J  returns = 0 for FP, = n for FPHn, = -2 for FPHjunk, else = -1
C
      CALL LABDER(LINE(IBEG(2):IEND(2)), J)
      IF (J .LE. -2) THEN
C
C----  format error
C
         WRITE(LUNOUT,'(1X,A)')
     $        ' **** Illegal derivative specification in SCALE ****'
         NERR = NERR+1
         GO TO 20
      ENDIF
C
C---- Now parse rest of line
C
      IF (J .EQ. -1) THEN
C
C---- no derivative name given, set derivative 1
C
         ITOK = 1
         J = 1
      ELSE
         ITOK = 2
      ENDIF
      REFSCL(J) = .FALSE.
      I = 0
 165  ITOK = ITOK+1
      IF (ITOK .GT. NTOK) THEN
C
C---- we've just set scale type LSCTMP:
C     last time we had a SCALE command, it
C     was stored in LSCLST. Check they are compatible
C
         IF (LSCLST .GT. 0) THEN
            IF (LSCLST .NE. LSCTMP) THEN
               WRITE(LUNOUT,'(1X,A)')
     $           ' **** Illegal to mix different SCALE types ****'
               NERR = NERR+1
               GO TO 20
            ENDIF
         ENDIF
         LSCALE = LSCTMP
         LSCLST = LSCTMP
         GO TO 20
      ENDIF
      CALL GTPREA(ITOK,TEMP,NTOK,ITYPE,FVALUE)
      IF (J .EQ. 0) THEN
C
C---- FP, not allowed
C
         WRITE (LUNOUT,'(1X,A)')
     $        ' **** Illegal to give scale factor for FP ****'
         NERR = NERR+1
         GO TO 20
      ELSE
         IF (I .EQ. 0) THEN
            SCL(2,J) = TEMP
         ELSE
            BET(I,J) = TEMP
            LSCTMP = 2
            IF (I .GT. 1) LSCTMP = 3
         ENDIF
      ENDIF
      I = I+1
      GO TO 165
C     WEIGHT -- use SDs 
 161  CONTINUE
      NOWT = 0
      WRITE(6,*) 'Calculate scales WITH sigma weighting.'
      GO TO 20
C
C     Do Scatter plots
 167  CONTINUE
      SCATPLT = .TRUE.
      WRITE(6,*) ' Do Scatter plots of scales'
      GO TO 20
C
C     Automatic scaling of all columns in given dataset
 169  CONTINUE
      LAUTO = .TRUE.
      WRITE(6,*) ' Automatic scaling of all columns in given datasets'
      GO TO 20
C
C     END or EOF
C
 200  IF (NERR.GT.0) THEN
         WRITE (6,FMT=6002) NERR
         CALL CCPERR(1,' ** Input error **')
      ENDIF
C
C     Set REFINE ANISto be the default if ANALYSE/REFINE weren't specified
      IF (.NOT.ANALYSE .AND. .NOT.LREFINE) THEN
        WRITE(6,*) ' ** REFINE ANISO set as default **'
C
C     Set flags for derivatives
        DO J=1,NDER
          REFSCL(J) = .TRUE.
        END DO
        LSCALE = 3
      END IF
C
      IPRINT = 1
      call ccp4h_summary_beg()
      call ccp4h_header('Input MTZ File','inp',3)   
      call ccp4h_summary_end()   
C          **********************************
      CALL LROPEN(IFIL1,'HKLIN',IPRINT,IFAIL)
C          **********************************
      IF(IFAIL.EQ.1) THEN
         CALL CCPERR(1, ' No input file???????')
      END IF
C
C---- IPOINT (..) = -1 This has been set by call to LKYSET.
C     Must have H K L  FP SIGFP FPH1 SIGHP1
C
C     ****************************************
      CALL LRASSN(IFIL1,LSPRGI,NLPRGI,IPOINT,CTPRGI)
C
C---- PJX: The next section does some checking to warn the user
C     if the whole dataset has not been scaled together.
C
C---- Get dataset info using LRIDX:
C     Notify available space
      NDATASETS = MaxSets
      CALL LRIDX(IFIL1,PNAME,XNAME,DNAME,ISETS,
     +                     DATCELL,DATWAVE,NDATASETS)
C
C---- We can only check the datasets if there is dataset
C     information in the mtz file
C
      IF (NDATASETS.GT.0) THEN
C
C---- Get the complete list of labels and types and the
C     datasets to which they belong
C
        NCOL = MCOLS
C
C       ****************************************
        CALL LRCLAB(IFIL1,CLABS,CTYPS,NCOL)
        CALL LRCLID(IFIL1,CSETID,NCOL)
C       ****************************************
C
C---- Get setid of FP column and use that DATCELL as master for
C     anisotropic analysis
        CELL(1) = 0.0
        SET_INDEX = 0
        SETID = 0
        IF (IPOINT(4).GT.0) THEN
          SETID = CSETID(IPOINT(4))
          DO ISET = 1,NDATASETS
            IF (ISETS(ISET).EQ.SETID) THEN
              SET_INDEX = ISET
            END IF
          ENDDO
        ENDIF
C     Set output dataset and correct choice of cell
        IF (SET_INDEX.GT.0) THEN
          DO I=1,6
            CELL(I) = DATCELL(I,SET_INDEX)
          ENDDO
        ENDIF

C
C---- For each column, get the dataset and then compile a list
C     of the columns in each dataset which are scaleable but
C     which have not been set by LABIN;
C     Set a logical variable for each dataset with columns which
C     were specified by LABIN.
C     Determine which "derivative" each dataset will be.
C
C     LDSCALE(I) is true if dataset I is going to be scaled
C     IUNSCALD(0,I) holds the number of unspecified scaleable
C                   columns for dataset I
C     IUNSCALD(J,I) holds the pointer to the Jth unspecified
C                   scalable column for dataset I
C
        do 9990 ii = 1,ncol
c
C         csetid(ii) is dataset ID, want numerical place of this dataset
          do kk = 1,NDATASETS
            if (ISETS(kk).eq.csetid(ii)) then
              this_set = kk
            endif
          enddo

          do 9991 jj = 6,nlprgi
c
            if ((ipoint(jj).ne.0).and.(clabs(ii).eq.lsusrj(jj))) then
              if (.not.ldscale(this_set)) then
                ldscale(this_set) = .true.
                inderiv(this_set) = int(real(jj-5)/14.0) + 1
              end if
              go to 9990
            end if
 9991     continue
c
          if (ctyps(ii).eq.'F' .or. ctyps(ii).eq.'J' .or.
     1        ctyps(ii).eq.'D' .or. ctyps(ii).eq.'G' .or.
     2        ctyps(ii).eq.'L' .or. ctyps(ii).eq.'K' .or.
     3        ctyps(ii).eq.'M' .or. ctyps(ii).eq.'Q') then
            iunscald(0,this_set) = iunscald(0,this_set) + 1
            iunscald(iunscald(0,this_set),this_set) = ii
            if (ctyps(ii).eq.'J') lintens(this_set) = .true.
            if (ctyps(ii).eq.'D') lanomal(this_set) = .true.
          end if
 9990   continue
c
c---- AUTO mode
c     Automatic selection of all scalable columns in each dataset
c
        if (lauto) then
c
          write(6,fmt='(//,2(1x,a,/),/,4(1x,a,/),/,3(1x,a,/))')
     1    'AUTOMATIC COLUMN SELECTION',
     2    '==========================',
     3    'The program will use DATASET information from the MTZ file',
     4    'to identify all scalable columns for each specified',
     5    'derivative i.e. FPH, DPH, IMEAN etc and apply the scale',
     6    'factor to all these columns.',
     7    'This is a new feature and there may be problems -',
     8    'check the information below for warnings or errors',
     9    'and report any problems to ccp4@dl.ac.uk'
c
c---- Try to assign the labels.
c
          do ii = 1,ndatasets
            if (ldscale(ii) .and. iunscald(0,ii).gt.0) then
c
              this_deriv = inderiv(ii)
              write (6,fmt='(/,1x,a,i2,a,a,a,a,/,1x,a,i2,/)')
     1           'Dataset ',ISETS(ii),' is ',
     1           dname(ii)(1:lenstr(dname(ii))),
     1           ' in crystal ',xname(ii)(1:lenstr(xname(ii))),
     2           'and is assigned to be derivative ',this_deriv
c
c---- List the labels specified with LABIN first
c
              write (6,fmt='(3x,a)')
     1           'The following columns were defined by LABIN:'
              ifirst = (this_deriv-1)*14 + 6
              ilast  = (this_deriv)*14 + 5
              do jj = ifirst,ilast
                if (ipoint(jj).ne.0)
     1             write(6,fmt='(7x,a20)')lsusrj(jj)
              end do
c
c---- For each unspecified label, do the label assignment
c
              write(6,fmt='(2(/,3x,a))')
     1          'The following additional columns will have the same',
     2          'scale factor applied automatically:'
c
              last_type = "?"
              do jj = 1,iunscald(0,ii)
                write (6,fmt='(7x,a,1x,a20,5x,3a)')
     1            'Column',clabs(iunscald(jj,ii)),
     1            '(type ',ctyps(iunscald(jj,ii)),')'
c
                this_type=ctyps(iunscald(jj,ii))
c
c             Before looping over all prog labels to look for a match
c             check if this is a sigma of type Q
c             'Q' sigmas need special treatment...
c
                if (this_type.eq.'Q') then
c
c             I don't think this can ever happen, but...
c
                  if (ipoint(ifirst + 1).eq.0) then
                    write(6,fmt='(2(1x,a,/))')
     1              'You haven''t set SIGFPH for this derivative ',
     2              'and this is likely to cause a problem'
                  end if
c
                  kk = -1
c
c             Easiest case first: if the dataset contains D but no I then
c             this must be sigDPH; if there is J but no D then it must be
c             sigImean:
c
                  if (lanomal(ii).and.(.not.lintens(ii))) then
                     if (ipoint(ifirst+3).eq.0) then
                        write(6,fmt='(7x,2a)')
     1                  'Must be the sigma of an anomalous',
     2                  '  difference DPH'
                        kk = ifirst + 3
                     end if
                  else if ((.not.lanomal(ii)).and.lintens(ii)) then
                     if (ipoint(ifirst+9).eq.0) then
                        write(6,fmt='(7x,2a)')
     1                  'Must be the sigma of an average',
     2                  ' intensity Imean'
                        kk = ifirst + 9
                     end if
                  else if (lanomal(ii).and.lintens(ii)) then
c
c             If we have both D and J then check if either have been
c             explicitly set
c
                     if ((ipoint(ifirst + 3).ne.0).and.
     1                  (ipoint(ifirst + 9).eq.0)) then
                        write(6,fmt='(7x,a)') 'This must be sigImean...'
                        kk = ifirst + 9
                     else if ((ipoint(ifirst + 9).ne.0).and.
     1                  (ipoint(ifirst + 3).eq.0)) then
                        write(6,fmt='(7x,a)') 'This must be sigDPH...'
                        kk = ifirst + 3
                     else if ((ipoint(ifirst + 9).ne.0).and.
     1                  (ipoint(ifirst + 3).ne.0)) then
                        write(6,fmt='(1x,2a,/,1x,2a)')
     1                  'WARNING: both sigImean and ',
     1                  'sigDPH have been set','So this must be the ',
     2                  'sigma of something else.'
                     end if
                  end if
c
c             At this point, if we haven't been able to assign a label
c             then all we can do is make an educated guess.
c
c             First assumption is that the columns have been arranged
c             pairwise, ie. sigmas follow values.
c             Check the last type assigned:
c
                  if (kk.lt.0) then
                    if (last_type.eq.'D') then
                       write(6,fmt='(7x,a,/,7x,2a,/,7x,2a)')
     1                 'The last assigned column was type D',
     2                 'Guessing that this is the sigma of ',
     3                 'DPH','It will be ',
     4                 'multiplied by the calculated scale factor'
                       kk = ifirst + 3
                       if (ipoint(kk).ne.0) then
                         call ccperr(1, 'SIGDPH is already assigned')
                       end if
                    else if (last_type.eq.'J') then
                       write(6,fmt='(2(7x,a,/),7x,a,/,7x,3a)')
     1                 'The last assigned column was type J',
     2                 'Guessing that this is the sigma of the ',
     3                 'average intensity Imean','It will be ',
     4                 'multiplied by the calculated ',
     5                 'scale factor squared'
                       kk = ifirst + 9
                       if (ipoint(kk).ne.0) then
                         call ccperr(1, 'SIGIMEAN is already assigned')
                       end if
                    else
c
c             Last ditch attempt - has DPH been assigned without a sigma?
c                                  Or, has IMEAN been assigned without one?
c
                       if ((ipoint(ifirst+8).eq.0).and.
     1                     (ipoint(ifirst+9).eq.0)) then
                         if ((ipoint(ifirst+2).ne.0).and.
     1                       (ipoint(ifirst+3).eq.0)) then
                            write(6,fmt='(7x,a,/,7x,a)')
     1                      'DPH has not yet been assigned a sigma..',
     2                      'Guessing that this is SIGDPH'
                            kk = ifirst + 3
                         end if
                       else if ((ipoint(ifirst+2).eq.0).and.
     1                     (ipoint(ifirst+3).eq.0)) then
                         if ((ipoint(ifirst+8).ne.0).and.
     1                       (ipoint(ifirst+9).eq.0)) then
                            write(6,fmt='(7x,a,/,7x,a)')
     1                      'IMEAN has not yet been assigned a sigma..',
     2                      'Guessing that this is SIGIMEAN'
                            kk = ifirst + 9
                         end if
                       end if
                    end if
                  end if
c
c              Set the label, if assigned - print message otherwise 
c
                  if (kk.gt.0) then
                     write(6,fmt='(10x,a,a,/)')
     1               'Assigned to label ',lsprgi(kk)
                     ipoint(kk) = -1
                     lsprgi(kk) = clabs(iunscald(jj,ii))
                     last_type  = this_type
                     go to 9989
                  else
                     write(6,fmt='(1x,a)')
     1               'What is this the sigma of? I need some clues!'
                     go to 9060
                  end if
c
c             End of dealing with sigmas of type Q
                end if
c
c             For other types of columns:
c             Loop through the prog labels for this derivative until
c             you find an unassigned one of the correct type
c
                lswitched = .false.
 9980           continue
c
                do kk = ifirst,ilast
c
c             Assign the labels as follows: set the lookup array to
c             -1 (to declare it as a compulsory label) and set the
c             program label to the file label
c
c             This is a bit clumsy but it seems to work!
c
c             Look for an exact match first
c
c                  write(6,*)kk,' ',lsprgi(kk),ctprgi(kk),ipoint(kk)
                   if ((ipoint(kk).eq.0).and.
     1                (this_type.eq.ctprgi(kk))) then
                      write(6,fmt='(10x,a,a,/)')
     1                  'Ok - assigned to label ',lsprgi(kk)
                      ipoint(kk) = -1
                      lsprgi(kk) = clabs(iunscald(jj,ii))
                      last_type  = this_type
                      go to 9989
                   end if
                end do
c
c             Couldn't find an exact match
c
                write(6,fmt='(/,1x,a,a1,a,/,1x,a)')
     1          '** All the labels with column type ',
     2          this_type,' have already',
     3          'been assigned for this derivative'
c
c             What's gone wrong?
c             Could be a dataset with more than one derivative?
c             Could be mis-assigned column types? e.g.
c             Might have an F+/- defined as type F instead of G
c                           I+/- defined as type J instead of K
c                           SIGF+/- or SIGI+/- defined as type Q
c                           instead of L or M respectively.
c
c             Do some simple checking on other types
c             If there are too many of these then something has
c             gone irretrievably wrong
c
                if (this_type.eq.'D') then
                 write(6,fmt='(1x,2a)')'Too many anomalous differences',
     1            ' in this dataset?'
                  go to 9070
                elseif (this_type.eq.'G') then
                  write(6,fmt='(1x,2a)')'Too many F(+) and/or F(-)s in',
     1            ' this dataset?'
                  go to 9070
                elseif (this_type.eq.'L') then
                  write(6,fmt='(1x,a)')'Too many sigma F(+) and/or',
     1            ' sigma F(-)s in this dataset?'
                  go to 9070
                elseif (this_type.eq.'K') then
                  write(6,fmt='(1x,2a)')'Too many I(+) and/or I(-)s',
     1            ' in this dataset?'
                  go to 9070
                elseif (this_type.eq.'M') then
                  write(6,fmt='(1x,2a)')'Too many sigma I(+) and/or',
     1            ' sigma I(-)s in this dataset?'
                  go to 9070
                end if
c
c             Assume it's a mis-labelled column type
c             At this point we're really just guessing.
c
 9060           continue
c
                write(6,fmt='(1x,a)')
     1          'Could it be a misassigned column type?'
                lswitched = .true.
c
                if (this_type.eq.'F') then
                  write(6,fmt='(1x,a,/,1x,a)')
     1            'This might be an FPH(+) or FPH(-) mis-labelled as',
     2            'an FPH - looking for spare labels of type G ...'
                  this_type = 'G'
                  lwarn = .true.
                  go to 9980
                elseif (this_type.eq.'J') then
                  write(6,fmt='(1x,a,/,1x,a)')
     1            'This might be an I(+) or I(-) mis-labelled as an',
     2            ' IMEAN - looking for spare labels of type K ...'
                  this_type = 'K'
                  lwarn = .true.
                  go to 9980
                elseif (this_type.eq.'Q') then
                  if (last_type.eq.'G') then
                    write(6,fmt='(2(1x,a,/),1x,a)')
     1              'The last column I looked at was assigned as an',
     2              'FPH(+) or FPH(-) - maybe this is its sigma?',
     3              'Looking for spare labels of type L ...'
                    this_type = 'L'
                    lwarn = .true.
                    go to 9980
                  elseif (last_type.eq.'K') then
                    write(6,fmt='(2(1x,a,/),1x,a)')
     1              'The last column I looked at was assigned as an',
     2              'I(+) or I(-) - maybe this is its sigma?',
     3              'Looking for spare labels of type M ...'
                    this_type = 'M'
                    lwarn = .true.
                    go to 9980
                  else

                  endif
                end if
c
c             Fatal errors take you here for a last word
c
 9070           write(6,fmt='(5(1x,a,/))')
     1          'The automatic column selection has failed.',
     2          'This may be because some columns in the MTZ file',
     3          'have the wrong type, or because a single dataset',
     4          'contains more than one derivative.',
     5          'Examine the messages above for more information.'
                call ccperr(1, 'Error in AUTOmatic column selection')
c
 9989           continue
c
c             Warning if we have assigned SIGIMEAN automatically
c
                if (kk.eq.(ifirst + 9)) then
                  write(6,fmt='(2x,a,a20,2(/,2x,a),/)')
     1            '** SIGIMEAN has been assigned to column ',lsprgi(kk),
     2            'So it will be multiplied by the SQUARE of',
     3            'the scale factor - check that this is correct.'
                  lwarn = .true.
                end if
c
              end do
            end if
          end do
c
c     End of automatic column selection
c     Print final warnings if necessary
c
          write(6,fmt='(/,2(1x,a,/))')
     1    '* Automatic column selection completed *',
     2    '* You should check the above output for errors'
c
          if (lwarn) then
             write(6,fmt='(3(1x,a,/))')
     1       'The selection may not be correct - for example, sigmas',
     2       'maybe wrongly assigned, or some columns may have been',
     3       'selected against type.'
             call ccperr (2,
     1       'Check automatic selection output carefully for errors!')
          end if
c
c---- Otherwise, not in AUTO mode so just print some warnings
c     and information about any datasets which will have a mixture
c     of scaled and unscaled columns
c
        else
c
          do 9992 ii = 1,ndatasets
            if (ldscale(ii) .and. iunscald(0,ii).gt.0) then
c
              if (.not.lwarn) then
                call ccperr(2,
     1          '** INCONSISTENT SCALING WITHIN DATASETS(S)')
                write(6,fmt='(2(1x,a,/),/,3(1x,a,/))')
     1          'You are applying the scale factor to some columns but',
     2          'not to others within the following dataset(s).',
     3          'This is not advised - use the AUTO keyword to',
     4          'automatically scale all the columns in a single',
     5          'dataset, or else specify them explicitly using LABIN.'
                lwarn = .true.
              end if
c
              write (6,fmt='(1x,a,i2,a,a,a,a,/,1x,a)')
     1          '** Dataset ',ISETS(ii),' = ',
     1          dname(ii)(1:lenstr(dname(ii))),
     1          ' in crystal ',xname(ii)(1:lenstr(xname(ii))),
     2             'is not being scaled consistently'
              write (6,fmt='(1x,a,/,1x,a)')
     1             'It is recommended that the following columns in',
     2             'this dataset are also scaled:'
c
C----    Print a list of the unspecified (=unscaled) columns
c
              do 9993 jj = 1,iunscald(0,ii)
                 write (6,fmt='(5x,a20,5x,a,a)')clabs(iunscald(jj,ii)),
     1              'type ',ctyps(iunscald(jj,ii))
 9993         continue
              write (6,fmt='(/)')
            end if
 9992     continue
c
        end if
C
C---- Print a message if no datasets found
      ELSE
        write (6,fmt='(/,1x,a,/)')
     1    'No dataset information was found in the input MTZ file'
        if (lauto) then
          write (6,fmt='(2(1x,a,/))')
     1    'Automatic scaling of datasets cannot be performed without',
     2    'this information'
          call ccperr(1,' No dataset info for AUTO keyword')
        end if
      END IF
C  CALL lRCELL only if no data se IDS available
      IF(SET_INDEX.EQ.0) CALL LRCELL(IFIL1,CELL)
C  Get recip cell for aniso analysis
      CALL RBFRO1(CELL,VOL,RR)
C
C   Return reciprocal cell too.
        CALL RBRCEL(CELLAS,RVOL)
C     *****************************************
C
      IF (NSYM .LT. 0) THEN
C        *********************************************
         CALL LRSYMI(IFIL1,NSYMP,LTYPEX,NSPGRP,NAMSPG,PGNAM)
         CALL LRSYMM(IFIL1,NSYM,RSYM)
C        ***********************
      ENDIF
         CALL CENTRIC(NSYM,RSYM,IPRINT)
C
C---- Set resolution limits if not set
C
      IF (SMAX .LT. 0.0) THEN
         CALL LRRSOL(IFIL1,SMIN,SMAX)
         RESMIN = 10000
         RESMAX = 0.5
         IF (SMIN.GT.0.0) RESMIN = 1.0/SQRT(SMIN)
         IF (SMAX.GT.0.0) RESMAX = 1.0/SQRT(SMAX)
      ENDIF
C
C---- Read file info, mostly to get hkl range
C
      CALL LRINFO(IFIL1,DUMMY,NCOLS,NREFLS,CRANGE)
C
C---- Set HMIN KMIN LMIN
C
      IMAX(1) = NINT(CRANGE(2,IPOINT(1)))
      IMIN(1) = NINT(CRANGE(1,IPOINT(1)))
      IMAX(2) = NINT(CRANGE(2,IPOINT(2)))
      IMIN(2) = NINT(CRANGE(1,IPOINT(2)))
      IMAX(3) = NINT(CRANGE(2,IPOINT(3)))
      IMIN(3) = NINT(CRANGE(1,IPOINT(3)))
C
      IF (OUTPUT) THEN
C
      call ccp4h_summary_beg()
      call ccp4h_header('Output File','out',3)   
      call ccp4h_summary_end()   
C             **********************
         CALL LWOPEN(IFIL1,'HKLOUT')
C             **********************
C
C----  Iflag = 0 means replace old title.. What old title????!!!
C
         IFLAG = 0
C
C                    ******************************
         IF (LTITLE) CALL LWTITL(IFIL1,TITLE,IFLAG)
C                    ******************************
C
C---- Append history line
C
         IF (LSCALE.EQ.1) THEN
           CALL LWHSTL (IFIL1, 'overall scale')
         ELSEIF (LSCALE.EQ.2) THEN
           CALL LWHSTL (IFIL1, 'isotropic scale')
         ELSEIF (LSCALE.EQ.3) THEN
           CALL LWHSTL (IFIL1, 'anisotropic scale')
         ENDIF
C
      ENDIF
C
C---- How many derivative sets?
C
      IDER = 0
C
C	Was originally 6,46,4 when NDER=10.  Change in this
C	manner to make more flexible  -- DHO  12/17
C
C       PJX: need to change loop limits for new input labels
C
      DO 210 JDO210 = 6,6+NDER*14,14
         IF (IPOINT(JDO210).EQ.0) GO TO 220
         IF (IPOINT(JDO210+1).EQ.0)  GO TO 250
         IDER = IDER + 1
 210  CONTINUE
 220  CONTINUE
C
C----  Set JDER to include in COMMON/SI_INPUT/, = number of derivatives
C
      JDER = IDER
      IF(JDER.EQ.1) NORMAN = .TRUE.
C
C---- Check to see if neither REFINE or ANALYSE specified
C
      IF (.NOT.ANALYSE) THEN
        DO 230 J = 1,JDER
          IF (REFSCL(J)) GOTO 240
 230    CONTINUE
        WRITE(LUNOUT,FMT='(/,A,/)') 
     .               ' *** WARNING: no scales will be refined ***'
      ENDIF
C
 240  IF (NSYM .LE. 0) GO TO 300
      WRITE(6,6012) NSPGRP,NAMSPG,PGNAM,NSYM,NSYMP
 6012 FORMAT ( '  SPACE GROUP NUMBER ',I5,/,
     .     '  SPACE GROUP NAME  ',A10,/,
     .     '  POINT GROUP NAME  ',A10,/,
     .     '  NUMBER OF SYMMETRY OPERATORS',I4,/,
     .     '  NUMBER OF PRIMITIVE SYMMETRY OPERATORS',I4)
      NSYM = NSYMP
C
      RETURN
C
 250  CALL CCPERR(1,
     +     '   ***    No SIG column for this derivative ***')
 300  CALL CCPERR(1, '  ***   No symmetry defined *** ')
C
C---- Format statements
C
 6000 FORMAT (/' Unrecognized keyword',/)
 6002 FORMAT (/1X,I6,' errors in input, see above !!!!',/)
C
       END
      SUBROUTINE RJSTFY(A,B)
C     ======================
C
C Right justify string b into a
C
      CHARACTER*(*) A,B
      INTEGER I,J,LA,LB,LENSTR,MA
      EXTERNAL LENSTR
C
      LA=LEN(A)
      LB=LENSTR(B)
      A = ' '
C
      MA = MAX(1,LA-LB+1)
      J = LB
      DO 1, I=LA,MA,-1
         A(I:I) = B(J:J)
         J = J-1
 1    CONTINUE
      RETURN
      END
C
      SUBROUTINE SCAPLY
C     =================
C
C---- Apply scales & temperature factors
C     write new file, analyse output scale against h,k,l,
C     4(sintheta/lambda
C
C     .. Parameters ..
C     NANAL - number of things to analyse - currently v H K L
C     MOD(Fnat) 4s**2/L**2
C       IMPLICIT NONE
       INTEGER NDER,NANAL ,NBIN, MAXINX, MCOLS
       INTEGER MXHIS,MX2HIS
       PARAMETER (NDER=20,NANAL=5,NBIN=20)
       PARAMETER (MAXINX=1000, MCOLS=500)
       PARAMETER (MXHIS=8, MX2HIS=2*MXHIS+1)
C     ..
C     .. Parameters for sort..
      INTEGER EOF,SORTYP,KEYSIZ
      PARAMETER (EOF=-1,SORTYP=7,KEYSIZ=4)
C     ..
C  things for NORMAN
       REAL PROB(512)
      DOUBLE PRECISION  DEN(27), P, PSUM, SUM
C   Lslines - done v resolution for al data and ??95% cutoff
       DOUBLE PRECISION SLOP(MAXINX,2),TERCEP(MAXINX,2),SUMDEL(MAXINX,2)
C      SUMS v resolution
C     .. Scalar Arguments ..
       INTEGER ISUM(MAXINX,2,2)
       DOUBLE PRECISION SUMX(MAXINX,2,2),SUMXX(MAXINX,2,2),
     $  SUMXY(MAXINX,2,2),SUMY(MAXINX,2,2),SUMYY(MAXINX,2,2)
C
       INTEGER IDER
C     ..
C     .. Array Arguments ..
C     ..
C     .. Scalars in COMMON ..
       REAL A,CONV,SMAX,SSS,FFMEAN,PX,X
       DOUBLE PRECISION SLPNUM,TERNUM
       INTEGER ISOUT,JAN,LUNIN,LUNOUT,NCYC,LSCALE,
     $      IPRINT,IFLG
       LOGICAL ANALYSE,OUTPUT,WILSON,NORMAN,SCATPLT
       DOUBLE PRECISION TOL
C     ..
C     .. Arrays in COMMON ..
       REAL BET,BETA,SC,SCL,DIF,DIFDAT
       INTEGER IMAX,IMIN,ISEE
       INTEGER IFIL1,INTER,JHIST,NREF
       LOGICAL REFSCL
C     ..
C     .. Local Scalars ..
       REAL SIGM,FMAX,DMAX,DIFFS,RMSF2,CELL,DEL,SMIN,SFKAT,SFKBT,
     $      SFKCT,SKRAUT,DIFF
C     .. Local Scalars ..
       REAL AH,AK,AL,AVAN1,AVAN2,AVAN4,DF,DS,DPH,FPH,DDPH,
     $      FFPH,FFP,FP,KEMP,R,R2,S,S1,S2,SFPH,SIGP,T,U,WRF,ZERO,DISO,
     $      RES,WFFP,WFFPH,S2SQ
       INTEGER NCHAR,NOWT,IPOINT,NCOL,NSCL,ID,NOUT,JDO31,II,I1,IC,
     $ IORMSUM,NORMSUM,JOUT,IPFPH,IPSFPH,IPDPH,IPSDPH,NNO,NOUT0,NOUT1,
     $ NORMSUMA,NORMSUMC,IORMSUMA,IORMSUMC
       INTEGER I,III,IND,ISET,IWRT,J,JSET,JDER,JDO10,JDO130,JDO140,
     +      JDO160,JDO20,JDO30,JDO50,JDO80,JPOINT,K,
     +      NHKL,NREFS,NTOT,IZERO,IJAN,JRESLN,IHIST
       INTEGER IPFPLUS,IPSFPLUS,IPFMINUS,IPSFMINUS,IPIMEAN,IPSIMEAN,
     +      IPIPLUS,IPSIPLUS,IPIMINUS,IPSIMINUS,JDO38,JDO39,INDX
C     .. Local Scalars for sort ..
      INTEGER ISTAT,LASCND,LRECL, NKEYS,KEYBUF(51),KEYS(10)
C
       LOGICAL ENDFIL
       CHARACTER LIN*600
C     ..
C     .. Local Arrays ..
       REAL RF(MAXINX,NANAL,NDER),RFF(MAXINX,NANAL,NDER),
     +      SANO(MAXINX,NANAL,NDER,4),SCALEX(2),
     +      SCALEY(2),SFFPH(MAXINX,NANAL,NDER),
     +      SHSN2(MAXINX,NANAL+1),SFP(MAXINX,NANAL,NDER),
     +      SFFP(MAXINX,NANAL+1,NDER),TOTALS(14),
     +      SFKA(MAXINX,NDER),SFKB(MAXINX,NDER),SFKC(MAXINX,NDER),
     +      WR(MAXINX,NANAL,NDER),WSM(MAXINX,NANAL,NDER)
       INTEGER IDATA(3)
       INTEGER IAMX(MAXINX,NANAL,NDER),IDMX(MAXINX,NANAL,NDER),ICY(1),
     +  IN(3),NR(MAXINX,NANAL,NDER),NRANO(MAXINX,NANAL,NDER),IOUT(MCOLS)
       CHARACTER JHKL(3)*1,COLLAB(MCOLS)*7,COLOUT(MCOLS)*7
C     ..
C     .. External Subroutines ..
       EXTERNAL LWCLOS,DIFFER1,DIFFER3,LRREWD,LRREFL,LRREFM,SCATPL
C     ..
       INTEGER LENSTR
       REAL LSTLSQ
       EXTERNAL LENSTR,LSTLSQ
C     .. Intrinsic Functions ..
       INTRINSIC ABS,EXP,INT,MAX,MIN,NINT,REAL,SQRT
C     ..
C     .. Local Arrays ..
      REAL ADATA(MCOLS),BDATA(9),RMETRIC(6)
      LOGICAL LOGMSS(MCOLS)
C     ..
C     .. External Functions ..
      INTEGER SRTBEG,SRTMRG,SRTRET,SRTRLS
      EXTERNAL SRTBEG,SRTMRG,SRTRET,SRTRLS
CC     ..
C     .. COMMON blocks ..
       CHARACTER DTITLE*80
       COMMON /CDIF2/DTITLE(NDER)
      COMMON /DIF2/INTER(NDER,2),DIF(NDER,2),NREF(NDER,2),
     + DIFDAT(NDER,3,2)
      COMMON /DIFF/JHIST(MAXINX,NDER,MX2HIS,2)
       COMMON /INOUT/LUNIN,LUNOUT,ISOUT
      COMMON /SI_INPUT/TOL,NCYC,CONV,JDER,SIGM(NDER+1),FMAX(NDER+1),
     $              DMAX(NDER+1),DIFFS(NDER+1),NOWT,REFSCL(NDER),
     $              OUTPUT,LSCALE,WILSON,NORMAN,ANALYSE,scatplt
       COMMON /POINTS/IPOINT(MCOLS)
       COMMON /RANGES/IMIN(4),IMAX(4),RMSF2,SMIN,SMAX
       COMMON /SCALES/SC(2),BETA(6),SCL(2,NDER),BET(6,NDER),ISEE(4),
     +      CELL(6),CELLAS(6)
C     ..
C     .. Save statement ..
       SAVE
       CHARACTER*10 PARLAB(7)
C
C     .. Data statements ..
      DATA LASCND/0/,NCOL/9/,NKEYS/1/
C     ..
       DATA PARLAB/
     $      ' SCALE (F)','      B11 ','      B22 ',
     +      '      B33 ','      B12 ','      B13 ','      B23 '/
C     ..
C     .. Data statements ..
       DATA JHKL/'H','K','L'/
C X here since last character of FPHi and DPHi labels is lost..
       DATA COLLAB/'FP', 'SIGPX',
     +     'FPH1X','SIGF1','DPH1X','SIGD1',
     +     'FPH1+','SIGF1+','FPH1-','SIGF1-',
     +     'I1X',  'SIGI1','I1+','SIGI1+','I1-','SIGI1-',
     +     'FPH2X','SIGF2','DPH2X','SIGD2',
     +     'FPH2+','SIGF2+','FPH2-','SIGF2-',
     +     'I2X',  'SIGI2','I2+','SIGI2+','I2-','SIGI2-',
     +     'FPH3X','SIGF3','DPH3X','SIGD3',
     +     'FPH3+','SIGF3+','FPH3-','SIGF3-',
     +     'I3X',  'SIGI3','I3+','SIGI3+','I3-','SIGI3-',
     +     'FPH4X','SIGF4','DPH4X','SIGD4',
     +     'FPH4+','SIGF4+','FPH4-','SIGF4-',
     +     'I4X',  'SIGI4','I4+','SIGI4+','I4-','SIGI4-',
     +     'FPH5X','SIGF5','DPH5X','SIGD5',
     +     'FPH5+','SIGF5+','FPH5-','SIGF5-',
     +     'I5X',  'SIGI5','I5+','SIGI5+','I5-','SIGI5-',
     +     'FPH6X','SIGF6','DPH6X','SIGD6',
     +     'FPH6+','SIGF6+','FPH6-','SIGF6-',
     +     'I6X',  'SIGI6','I6+','SIGI6+','I6-','SIGI6-',
     +     'FPH7X','SIGF7','DPH7X','SIGD7',
     +     'FPH7+','SIGF7+','FPH7-','SIGF7-',
     +     'I7X',  'SIGI7','I7+','SIGI7+','I7-','SIGI7-',
     +     'FPH8X','SIGF8','DPH8X','SIGD8',
     +     'FPH8+','SIGF8+','FPH8-','SIGF8-',
     +     'I8X',  'SIGI8','I8+','SIGI8+','I8-','SIGI8-',
     +     'FPH9X','SIGF9','DPH9X','SIGD9',
     +     'FPH9+','SIGF9+','FPH9-','SIGF9-',
     +     'I9X',  'SIGI9','I9+','SIGI9+','I9-','SIGI9-',
     +     'FPH10X','SIGF10','DPH10X','SIGD10',
     +     'FPH10+','SIGF10+','FPH10-','SIGF10-',
     +     'I10X',  'SIGI10','I10+','SIGI10+','I10-','SIGI10-',
     +     'FPH11X','SIGF11','DPH11X','SIGD11',
     +     'FPH11+','SIGF11+','FPH11-','SIGF11-',
     +     'I11X',  'SIGI11','I11+','SIGI11+','I11-','SIGI11-',
     +     'FPH12X','SIGF12','DPH12X','SIGD12',
     +     'FPH12+','SIGF12+','FPH12-','SIGF12-',
     +     'I12X',  'SIGI12','I12+','SIGI12+','I12-','SIGI12-',
     +     'FPH13X','SIGF13','DPH13X','SIGD13',
     +     'FPH13+','SIGF13+','FPH13-','SIGF13-',
     +     'I13X',  'SIGI13','I13+','SIGI13+','I13-','SIGI13-',
     +     'FPH14X','SIGF14','DPH14X','SIGD14',
     +     'FPH14+','SIGF14+','FPH14-','SIGF14-',
     +     'I14X',  'SIGI14','I14+','SIGI14+','I14-','SIGI14-',
     +     'FPH15X','SIGF15','DPH15X','SIGD15',
     +     'FPH15+','SIGF15+','FPH15-','SIGF15-',
     +     'I15X',  'SIGI15','I15+','SIGI15+','I15-','SIGI15-',
     +     'FPH16X','SIGF16','DPH16X','SIGD16',
     +     'FPH16+','SIGF16+','FPH16-','SIGF16-',
     +     'I16X',  'SIGI16','I16+','SIGI16+','I16-','SIGI16-',
     +     'FPH17X','SIGF17','DPH17X','SIGD17',
     +     'FPH17+','SIGF17+','FPH17-','SIGF17-',
     +     'I17X',  'SIGI17','I17+','SIGI17+','I17-','SIGI17-',
     +     'FPH18X','SIGF18','DPH18X','SIGD18',
     +     'FPH18+','SIGF18+','FPH18-','SIGF18-',
     +     'I18X',  'SIGI18','I18+','SIGI18+','I18-','SIGI18-',
     +     'FPH19X','SIGF19','DPH19X','SIGD19',
     +     'FPH19+','SIGF19+','FPH19-','SIGF19-',
     +     'I19X',  'SIGI19','I19+','SIGI19+','I19-','SIGI19-',
     +     'FPH20X','SIGF20','DPH20X','SIGD20',
     +     'FPH20+','SIGF20+','FPH20-','SIGF20-',
     +     'I20X',  'SIGI20','I20+','SIGI20+','I20-','SIGI20-',
     +     218*' '/
C
       DATA ZERO,IZERO/0.0,0/
C     ..
C
C Conversion to get other aniso scale form
         RMETRIC(1) = 0.25/(CELLAS(1)*CELLAS(1))
         RMETRIC(2) = 0.25/(CELLAS(2)*CELLAS(2))
         RMETRIC(3) = 0.25/(CELLAS(3)*CELLAS(3))
         RMETRIC(4) = 0.25/(CELLAS(1)*CELLAS(2))
         RMETRIC(5) = 0.25/(CELLAS(1)*CELLAS(3))
         RMETRIC(6) = 0.25/(CELLAS(2)*CELLAS(3))
C Clear histogram arrays
      DO 13 IDER=1,NDER
      DO 13 IJAN=1,2
         NREF(IDER,IJAN) = 0
         DO 11 J=1,MX2HIS
            DO 12 I=1,MAXINX
               JHIST(I,IDER,J,IJAN) = 0
 12         CONTINUE
 11      CONTINUE
 13   CONTINUE
C
       NORMSUM = 0
       NORMSUMC = 0
       NORMSUMA = 0
C
      call ccp4h_summary_beg()
C---- Check index limits
           DO 3, I = 1,3
          IF (IMAX(I)-IMIN(I)+1 .GT. MAXINX) THEN
             WRITE(LUNOUT,'(//1X,A)')
     $        ' **** Too many indices: increase MAXINX in SCAPLY ****'
             CALL CCPERR(1,' ** Array too small in SCAPLY (MAXINX) **')
          ENDIF
 3     CONTINUE
C
       IF (LSCALE .EQ. 1) NSCL = 1
       IF (LSCALE .EQ. 2) NSCL = 2
       IF (LSCALE .EQ. 3) NSCL = 7

       call ccp4h_rule()
       call ccp4h_header(
     + 'APPLICATION OF SCALES AND ANALYSIS OF DIFFERENCES','appsca',2) 

       IF(LSCALE.EQ.3) 
     +   WRITE(LUNOUT,*) ' Both forms for Anisotropic scales listed'
       WRITE(LUNOUT,5080) (PARLAB(I),I=1,NSCL)
       DO 4,IDER=1,JDER
          WRITE(LUNOUT,5081) IDER,SCL(2,IDER),(BET(I,IDER)*4,I=1,NSCL-1)
          IF(LSCALE.EQ.3) WRITE(LUNOUT,5081) IDER,SCL(2,IDER),
     +                             (BET(I,IDER)*4*RMETRIC(I),I=1,NSCL-1)
          IF(LSCALE.EQ.2) WRITE(6,'(//A,F14.4)')
     +  '  The equivalent isotropic temperature factor is ',BET(1,IDER)
 4     CONTINUE
C
       call ccp4h_summary_end()
       DO 5,IDER=1,JDER
          CALL DIFFER1(IDER)
 5     CONTINUE
C
       IFIL1 = 1
C
C---- Initialise sort for NORMAN analyses of derivative, set parameters, etc
C ---  Only possible for a single derivative.
C
      IF(NORMAN) THEN
C
C   Build probability array
C
C     Build probability integral for X = 0 to 4.0 in
C     increments of 0.007827789.
C
      P = 1.0D0
      DO 6 I=1,27
      P = P * I
 6     DEN(I) = DLOG10(P * (2 * I + 1) * 2.0**I)
      ID = 0
      PROB(1) = 0.0
      DO 7 I=2,512
      ID = ID + 1
      DEL = ID
      P = DBLE(DEL) * 0.7827789D-02
      SUM = 1.0D0
      DO 8 J=1,27
      K = MOD(J+1,2) - MOD(J,2)
      PSUM = (2 * J) * DLOG10(P) - DEN(J)
      IF (PSUM + 7.0D0) 7,9,9
 9     PSUM = 1.0D+01**PSUM
 8     SUM = SUM + K * PSUM
C
 7     PROB(I) = 0.7978845608D0 * P * SUM
C
C---- Get Record length and keys to sort on differences
C
      LRECL = NCOL*KEYSIZ
C  NKEYS = 1 - sort output record h k l Fp SIGFP FPHi SIGFPHi (FPHi-FP)
C   on (FPHi-FP)
      DO 1  I = 1,NKEYS
      KEYS(1) = 8
   1  CONTINUE
C
C---- Set up key buffer for number of keys. A descriptor consists of:
C     2-byte length (in bytes)
C     2-byte class & type (probably not used)
C     4-byte address of array
C
      DO 2 I = 1,NKEYS
        J = (I-1)*5 + 1
C
C---- Sort Type is REAL (SORTYP set up in PARAMETER statement)
C
        KEYBUF(J) = SORTYP
C
C---- Sort Order ascending/descending
C
        KEYBUF(J+1) = LASCND
C
C---- position of 1st byte in key
C
        KEYBUF(J+2) = (KEYS(I)-1)*KEYSIZ
C
C---- keylength in data units (1)
C
        KEYBUF(J+3) = 1
   2  CONTINUE
      WRITE (LUNOUT,FMT=5002) NKEYS, (KEYS(I),I=1,NKEYS)
 5002 FORMAT (//,1X,I8,' sort keys, in columns ', (3I4),/)
        ISTAT = SRTBEG(NKEYS,KEYBUF,LRECL,0)
        IF (ISTAT.NE.0) THEN
          WRITE (LUNOUT,FMT=5004) ISTAT
 5004     FORMAT (/,' Sort fail : INIT, status = ',I8,/)
C
C          ******************************
          CALL CCPERR(1,' ERROR Termination')
C          ******************************
C
        END IF
      END IF
C
       DO 30 JDO30 = 1,JDER
C
          DO 20 JDO20 = 1,MAXINX
             ISUM(JDO20,1,1) = 0
             ISUM(JDO20,2,1) = 0
             SUMX(JDO20,1,1) = 0.0
             SUMX(JDO20,2,1) = 0.0
             SUMXX(JDO20,1,1) = 0.0
             SUMXX(JDO20,2,1) = 0.0
             SUMXY(JDO20,1,1) = 0.0
             SUMXY(JDO20,2,1) = 0.0
             SUMY(JDO20,1,1) = 0.0
             SUMY(JDO20,2,1) = 0.0
             SUMYY(JDO20,1,1) = 0.0
             ISUM(JDO20,1,2) = 0
             ISUM(JDO20,2,2) = 0
             SUMX(JDO20,1,2) = 0.0
             SUMX(JDO20,2,2) = 0.0
             SUMXX(JDO20,1,2) = 0.0
             SUMXX(JDO20,2,2) = 0.0
             SUMXY(JDO20,1,2) = 0.0
             SUMXY(JDO20,2,2) = 0.0
             SUMY(JDO20,1,2) = 0.0
             SUMY(JDO20,2,2) = 0.0
             SUMYY(JDO20,1,2) = 0.0
             SFKA(JDO20,JDO30) = 0.0
             SFKB(JDO20,JDO30) = 0.0
             SFKC(JDO20,JDO30) = 0.0
C
             SFFP(JDO20,NANAL+1,JDO30) = 0.0
C
             DO 10 JDO10 = 1,NANAL
                SFFP(JDO20,JDO10,JDO30) = 0.0
                SFP(JDO20,JDO10,JDO30) = 0.0
                SFFPH(JDO20,JDO10,JDO30) = 0.0
                RFF(JDO20,JDO10,JDO30) = 0.0
                RF(JDO20,JDO10,JDO30) = 0.0
                SANO(JDO20,JDO10,JDO30,1) = 0.0
                SANO(JDO20,JDO10,JDO30,2) = 0.0
                SANO(JDO20,JDO10,JDO30,3) = 0.0
                SANO(JDO20,JDO10,JDO30,4) = 0.0
                WR(JDO20,JDO10,JDO30) = 0.0
                WSM(JDO20,JDO10,JDO30) = 0.0
                NR(JDO20,JDO10,JDO30) = 0
                NRANO(JDO20,JDO10,JDO30) = 0
                IAMX(JDO20,JDO10,JDO30) = 0
                IDMX(JDO20,JDO10,JDO30) = 0
 10          CONTINUE
 20       CONTINUE
 30    CONTINUE
C
       DS = REAL(NBIN)/SMAX
       DF = REAL(NBIN)/RMSF2
       NREFS = 0
C
       NOUT = 0
C      PJX: change loop limits here when adding extra labels
C      Also: we only want to output FP,FPH and DPH (+ sigmas)
C      in the table of differences i.e. no intensities or
C      F+/- s etc.
C      NOUT is the number of output columns in the table
C      We need to check: 4-5 (FP,SIGFP) 6-9 (FPH1,etc) 20-23,(FPH2 etc)
C
C      Check FP,SIGFP first
       DO 38 JDO38 = 4,5
          JPOINT = IPOINT(JDO38)
          IF (JPOINT.GT.0) THEN
             NOUT = NOUT + 1
C  right-justify labels for heading table
             CALL RJSTFY(COLOUT(NOUT), COLLAB(JDO38-3))
          END IF
 38    CONTINUE
C
C      Now check each derivative
       DO 31 JDO31 = 6,(NDER-1)*14+6,14
          DO 39 JDO39 = 0,3
            INDX   = JDO31 + JDO39
            JPOINT = IPOINT(INDX)
            IF (JPOINT.GT.0) THEN
               NOUT = NOUT + 1
C  right-justify labels for heading table
               CALL RJSTFY(COLOUT(NOUT), COLLAB(INDX-3))
            END IF
 39       CONTINUE
 31    CONTINUE
C
       IWRT = 0
C     Starting point for line
       I1 = 33
       IF(NOUT.GT.18)I1   = 3
       LIN = ' '
C
      call ccp4h_summary_beg()
      call ccp4h_pre_beg()
       IF(NOUT.LE.18) THEN
         WRITE (LUNOUT,FMT=5090)(COLOUT(II),II=1,NOUT)
       ELSE
         WRITE (LUNOUT,FMT=6000)(COLOUT(II),II=1,NOUT)
       ENDIF
       WRITE (LUNOUT,'(/)')
C
C           *************
       CALL LRREWD(IFIL1)
C           *************
40    CONTINUE
C
C---- Loop for reflections - this time read ALL data and use ipoint
C
C           **************************
       CALL LRREFL(IFIL1,S,ADATA,ENDFIL)
       IF (ENDFIL) GO TO 100
       CALL LRREFM(IFIL1,LOGMSS)
C           **************************
C
C
          IN(1) = NINT(ADATA(1))
          IN(2) = NINT(ADATA(2))
          IN(3) = NINT(ADATA(3))
         CALL CENTR(IN,IC)
         IF(IC.EQ.0) IC = 2
C
       DO 50 JDO50 = 1,3
          IOUT(JDO50) = NINT(ADATA(JDO50))
          IN(JDO50) = NINT(ADATA(JDO50))
          BDATA(JDO50) = ADATA(JDO50)
 50    CONTINUE
C
C  May want BDATA if NORMAN true - ie only one data set being scaled
       IF(NORMAN) THEN
           BDATA(4) = 0
           BDATA(5) = 0
           BDATA(6) = 0
           BDATA(7) = 0
           BDATA(8) = 0
           BDATA(9) = 0
         IF(.NOT.(LOGMSS(IPOINT(4)) .OR. LOGMSS(IPOINT(5))))THEN
           BDATA(4) = ADATA(IPOINT(4))
           BDATA(5) = ADATA(IPOINT(5))
         END IF
       END IF
C-----set all other iouts back to 0
C     PJX: change this loop when adding new labels
       DO 61 J = 4,JDER*14+5
          IOUT (J) = 0
 61    CONTINUE
       FP = 0.0
       SIGP = 0.0
       IF(.NOT.(LOGMSS(IPOINT(4)) .OR. LOGMSS(IPOINT(5))))THEN
        IOUT(4) = NINT(ADATA(IPOINT(4)))
        IOUT(5) = NINT(ADATA(IPOINT(5)))
        FP = ADATA(IPOINT(4))
        SIGP = ADATA(IPOINT(5))
       END IF
       FFP = FP*FP
       SSS = (SIGP*SIGP*4.0*FFP)
       IF(SSS.NE.0.0) WFFP = 1.0/ SSS
C
       JOUT = 5
       DO 90 IDER = 1,JDER
C
C---- deriv pointer to (Fph) for arrays IPOINT/IDATA  and IA
C
C     PJX: change index for ipoint to get the correct columns...
          IPFPH =  IPOINT(14*IDER - 8)
          IPSFPH =  IPOINT(14*IDER - 7)
C---- Check DELFPH pointer to see if there is anom
C
          JAN = 0
          IPDPH =  IPOINT(14*IDER-6)
          IPSDPH =  0
          IF (IPDPH.GT.0) THEN
             IPSDPH =  IPOINT(14*IDER - 5)
             JAN = 1
          END IF
C
C---- PJX: Check FPH(+) pointer...
C
          IPFPLUS = IPOINT(14*IDER - 4)
          IPSFPLUS = 0
          IF (IPFPLUS.GT.0) THEN
             IPSFPLUS = IPOINT(14*IDER - 3)
          END IF
C
C---- PJX: Check FPH(-) pointer...
C
          IPFMINUS = IPOINT(14*IDER - 2)
          IPSFMINUS = 0
          IF (IPFMINUS.GT.0) THEN
             IPSFMINUS = IPOINT(14*IDER - 1)
          END IF
C
C---- PJX: Check IMEAN pointer...
C
          IPIMEAN = IPOINT(14*IDER)
          IPSIMEAN = 0
          IF (IPIMEAN.GT.0) THEN
             IPSIMEAN = IPOINT(14*IDER + 1)
          END IF
C
C---- PJX: Check I(+) pointer...
C
          IPIPLUS = IPOINT(14*IDER + 2)
          IPSIPLUS = 0
          IF (IPIPLUS.GT.0) THEN
             IPSIPLUS = IPOINT(14*IDER + 3)
          END IF
C
C---- PJX: Check I(-) pointer...
C
          IPIMINUS = IPOINT(14*IDER + 4)
          IPSIMINUS = 0
          IF (IPIMINUS.GT.0) THEN
             IPSIMINUS = IPOINT(14*IDER + 5)
          END IF
C
C
C
C     Calculate scales.
C
          SC(1) = SCL(1,IDER)
          SC(2) = SCL(2,IDER)
          BETA(1) = BET(1,IDER)
          BETA(2) = BET(2,IDER)
          BETA(3) = BET(3,IDER)
          BETA(4) = BET(4,IDER)
          BETA(5) = BET(5,IDER)
          BETA(6) = BET(6,IDER)
C
C---- arrays for analysis
C
          DPH = 0.0
C     Only calculate scale if sd(Fph) gt.0)
          S2 = 1.0
          IF (.NOT. LOGMSS(IPSFPH)) THEN
          IF (ADATA(IPSFPH).GT.0.0001) THEN
             NREFS = NREFS + 1
             IF (LSCALE .EQ. 1) THEN
                S2 = SC(2)
             ELSEIF (LSCALE .EQ. 2) THEN
                S2 = EXP(-BETA(1)*S*0.25) * SC(2)
             ELSEIF (LSCALE .EQ. 3) THEN
                AH = ADATA(1)
                AK = ADATA(2)
                AL = ADATA(3)
                T = (BETA(1)*AH+2.0*AK*BETA(4))*AH +
     +               (BETA(2)*AK+2.0*AL*BETA(6))*AK +
     +               (BETA(3)*AL+2.0*AH*BETA(5))*AL
                S2 = EXP(-T)*SC(2)
             ENDIF
          END IF
          END IF
C
C---- Apply scales
C
C---- align with the actual col in input file
C
        IF (.NOT. LOGMSS(IPFPH)) THEN
          ADATA(IPFPH) = ADATA(IPFPH)*S2
          IOUT(JOUT + 1) = NINT(ADATA(IPFPH))
          IF(NORMAN) BDATA(6) = ADATA(IPFPH)
        END IF
        IF (.NOT. LOGMSS(IPSFPH)) THEN
          ADATA(IPSFPH) = ADATA(IPSFPH)*S2
          IF(NORMAN) BDATA(7 ) = ADATA(IPSFPH)
          IOUT(JOUT + 2) = NINT(ADATA(IPSFPH))
        END IF
          JOUT = JOUT + 2
          IF (IPDPH.GT.0) THEN
            IF (.NOT. LOGMSS(IPDPH)) THEN
             ADATA(IPDPH) = ADATA(IPDPH)*S2
             IOUT(JOUT + 1) = NINT(ADATA(IPDPH))
            END IF 
C   Store weighted ano diff
             IF (.NOT. LOGMSS(IPSDPH)) THEN
             ADATA(IPSDPH) = ADATA(IPSDPH)*S2
             IF(ADATA(IPSDPH).GT.0.0001
     +              .AND. NORMAN) BDATA(9 ) = (ADATA(IPDPH)/ADATA(IPSDPH
     +              ))
             IOUT(JOUT + 2) = NINT(ADATA(IPSDPH))
             END IF
             JOUT = JOUT + 2
          END IF
C
C   PJX: apply scales to FP(+) and FP(-), if set
C        F(+) first:
          IF (IPFPLUS.GT.0) THEN
            IF (.NOT. LOGMSS(IPFPLUS)) THEN
              ADATA(IPFPLUS) = ADATA(IPFPLUS)*S2
C             IOUT(JOUT + 1) = NINT(ADATA(IPFPLUS))
            END IF
            IF (.NOT. LOGMSS(IPSFPLUS)) THEN
              ADATA(IPSFPLUS) = ADATA(IPSFPLUS)*S2
C             IOUT(JOUT + 2) = NINT(ADATA(IPSFPLUS))
            END IF
C           JOUT = JOUT + 2
          END IF
C
C        F(-) next:
          IF (IPFMINUS.GT.0) THEN
            IF (.NOT. LOGMSS(IPFMINUS)) THEN
              ADATA(IPFMINUS) = ADATA(IPFMINUS)*S2
C             IOUT(JOUT + 1) = NINT(ADATA(IPFMINUS))
            END IF
            IF (.NOT. LOGMSS(IPSFMINUS)) THEN
              ADATA(IPSFMINUS) = ADATA(IPSFMINUS)*S2
C             IOUT(JOUT + 2) = NINT(ADATA(IPSFMINUS))
            END IF
C           JOUT = JOUT + 2
          END IF
C
C   PJX: apply scales to IMEAN etc, if set
C   For the intensities apply scalefactor**2:
C
          S2SQ = S2*S2
C
C        IMEAN first:
          IF (IPIMEAN.GT.0) THEN
            IF (.NOT. LOGMSS(IPIMEAN)) THEN
              ADATA(IPIMEAN) = ADATA(IPIMEAN)*S2SQ
C             IOUT(JOUT + 1) = NINT(ADATA(IPIMEAN))
            END IF
            IF (.NOT. LOGMSS(IPSIMEAN)) THEN
              ADATA(IPSIMEAN) = ADATA(IPSIMEAN)*S2SQ
C             IOUT(JOUT + 2) = NINT(ADATA(IPSIMEAN))
            END IF
C           JOUT = JOUT + 2
          END IF
C
C        I(+) next:
          IF (IPIPLUS.GT.0) THEN
            IF (.NOT. LOGMSS(IPIPLUS)) THEN
              ADATA(IPIPLUS) = ADATA(IPIPLUS)*S2SQ
C             IOUT(JOUT + 1) = NINT(ADATA(IPIPLUS))
            END IF
            IF (.NOT. LOGMSS(IPSIPLUS)) THEN
              ADATA(IPSIPLUS) = ADATA(IPSIPLUS)*S2SQ
C             IOUT(JOUT + 2) = NINT(ADATA(IPSIPLUS))
            END IF
C           JOUT = JOUT + 2
          END IF
C
C        I(-) last:
          IF (IPIMINUS.GT.0) THEN
            IF (.NOT. LOGMSS(IPIMINUS)) THEN
              ADATA(IPIMINUS) = ADATA(IPIMINUS)*S2
C             IOUT(JOUT + 1) = NINT(ADATA(IPIMINUS))
            END IF
            IF (.NOT. LOGMSS(IPSIMINUS)) THEN
              ADATA(IPSIMINUS) = ADATA(IPSIMINUS)*S2
C             IOUT(JOUT + 2) = NINT(ADATA(IPSIMINUS))
            END IF
C           JOUT = JOUT + 2
          END IF
C
C---- skip analyses if data missing or outside resolution limits
C---- Pick up native data
C
C
          IF(S.GT.SMAX .OR. S.LT.SMIN) GO TO 90
          IF (LOGMSS(IPOINT(4)) .OR. LOGMSS(IPOINT(5))) GO TO 89
           IF (FP.LT.0.00001.OR.SIGP.LT.0.00001) GO TO 89
C
          IF (LOGMSS(IPFPH) .OR. LOGMSS(IPSFPH)) GO TO 88
          IF (ADATA(IPSFPH).LE.0.00001) GO TO 88
C
          FPH = ADATA(IPFPH)
          FFPH = FPH*FPH
          SFPH = ADATA(IPSFPH)
          SSS =  (SFPH*SFPH*4.0*FFPH)
          IF(ABS(SSS) .LE. 0.0000001) GO TO 89
          IF(SSS.NE.0.0) WFFPH = 1.0/ SSS
C   Work out weighted difference
          WRF = (FPH-FP)/SQRT(SIGP*SIGP + SFPH*SFPH)
          IF(NORMAN) BDATA(8) = WRF
          DPH = 0.0
          DDPH = 0.0
          IF (IPDPH.GT.0.AND. .NOT.LOGMSS(IPDPH)) THEN
            DPH = ADATA(IPDPH)
            DDPH = DPH*DPH
          END IF
          SSS =  (WFFP+WFFPH)
          FFMEAN = 0.0
          FFMEAN = (WFFP*FFP+WFFPH*FFPH)/ SSS
C
C---- Writeout list of h k l FP SIGP FPH SIGPH (FPH-FP) ready for NORMAN
C----  Dont include anything with BDATA(5) ( SIGFP) = 0
C----
      IF(NORMAN .AND. BDATA(5).GT.0.00001) THEN
C
C---- Pass keys and record to sort
C
        ISTAT = SRTRLS(BDATA)
        NORMSUM = NORMSUM + 1
        IF(IC.EQ.1)NORMSUMC = NORMSUMC + 1
        IF(IC.NE.1)NORMSUMA = NORMSUMA + 1
C---- Loop reflections if ok
C
        IF (ISTAT.NE.0) THEN
        WRITE (LUNOUT,FMT=5006) ISTAT
 5006   FORMAT (' Sort fail : RELEASE, status = ',I8,/)
C
C            ********************************
        CALL CCPERR(1,' ERROR - Termination')
C            ********************************
C
        END IF
      END IF
C
C---- Sums for analyses
C
C     Store   the summed values in a array point
C     i=index (h/k/l) j is the index value (h=/k=/l=)
C
          DO 80 JDO80 = 1,3
             J = NINT(ADATA(JDO80)) - IMIN(JDO80) + 1
C
C---- sum of natives
C
             SFP(J,JDO80,IDER) = SFP(J,JDO80,IDER) + FP
             SFFP(J,JDO80,IDER) = SFFP(J,JDO80,IDER) + FFP
C
C---- sum of weight
C
             WSM(J,JDO80,IDER) = WSM(J,JDO80,IDER) + FFP*WFFP +
     +            FFPH*WFFPH
C
C---- sum of derivatives
C
             SFFPH(J,JDO80,IDER) = SFFPH(J,JDO80,IDER) + FFPH
C
C---- r factors
C
C     for f squared
C
             RFF(J,JDO80,IDER) = ABS(FFP-FFPH) + RFF(J,JDO80,IDER)
C
C---- for f
C
             RF(J,JDO80,IDER) = ABS(FP-FPH) + RF(J,JDO80,IDER)
C
C---- max difference
C
             IF (ABS(FP-FPH).GT.IDMX(J,JDO80,IDER)) IDMX(J,JDO80,
     +            IDER) = ABS(FP-FPH)
C
C---- weighted r factor on f squared
C
             WR(J,JDO80,IDER) = ABS(FFP-FFMEAN)*WFFP +
     +            WR(J,JDO80,IDER) + ABS(FFPH-FFMEAN)*WFFPH
C
C---- number of reflections
C
             NR(J,JDO80,IDER) = NR(J,JDO80,IDER) + 1
C
C---- anomalous number
C
             IF (JAN.GT.0 .AND. .NOT.LOGMSS(IPSDPH)) THEN
               IF (ADATA(IPSDPH).GE.0.0001) THEN
                 NRANO(J,JDO80,IDER) = NRANO(J,JDO80,IDER) + 1
C
C---- anom  array set
C
C     sum of anom magnitude - should be zero
C
                 SANO(J,JDO80,IDER,1) =
     $               SANO(J,JDO80,IDER,1) + DPH
C
C---- sum of absolute anom magnitude
C
                 SANO(J,JDO80,IDER,2) =
     $               SANO(J,JDO80,IDER,2) + ABS(DPH)
C
C---- sum of anom intensity
C
                 SANO(J,JDO80,IDER,3) =
     $               SANO(J,JDO80,IDER,3) + DDPH
C
C---- sum of FP - FPH difference for examples with anom data
C
                 SANO(J,JDO80,IDER,4) =
     $               ABS(FP-FPH) + SANO(J,JDO80,IDER,4)
C
C---- max anom magnitude
C
                 IAMX(J,JDO80,IDER) =
     $               MAX(INT(ABS(DPH)),IAMX(J,JDO80,IDER))
               END IF
             END IF
 80       CONTINUE
C
C---- Analysis against MOD(FPat)
C
          J = NINT(ABS(FP)*DF+1.0)
          J = MAX(1,J)
          J = MIN(J,NBIN)
          SFP(J,4,IDER) = SFP(J,4,IDER) + FP
          SFFP(J,4,IDER) = SFFP(J,4,IDER) + FFP
          SFFPH(J,4,IDER) = SFFPH(J,4,IDER) + FFPH
          RFF(J,4,IDER) = ABS(FFP-FFPH) + RFF(J,4,IDER)
          RF(J,4,IDER) = ABS(FP-FPH) + RF(J,4,IDER)
          IF (ABS(FP-FPH).GT.IDMX(J,4,IDER))
     +         IDMX(J,4,IDER) = ABS(FP-FPH)
          WR(J,4,IDER) = ABS(FFP-FFMEAN)*WFFP + WR(J,4,IDER) +
     +         ABS(FFPH-FFMEAN)*WFFPH
          WSM(J,4,IDER) = WSM(J,4,IDER) + FFP*WFFP + FFPH*WFFPH
          NR(J,4,IDER) = NR(J,4,IDER) + 1
          IF (JAN.GT.0 .AND. .NOT. LOGMSS(IPSDPH)) THEN
            IF (ADATA(IPSDPH).GE.0.0001) THEN
              NRANO(J,4,IDER) = NRANO(J,4,IDER) + 1
              SANO(J,4,IDER,1) = SANO(J,4,IDER,1) + DPH
              SANO(J,4,IDER,2) = SANO(J,4,IDER,2) + ABS(DPH)
              SANO(J,4,IDER,3) = SANO(J,4,IDER,3) + DDPH
              SANO(J,4,IDER,4) = ABS(FP-FPH) + SANO(J,4,IDER,4)
              IAMX(J,4,IDER) = MAX(INT(ABS(DPH)),IAMX(J,4,IDER))
            END IF
          END IF
C
C---- Analysis against 4(sin theta/lambda)**2
C
          J = NINT(S*DS+1.0)
          J = MAX(1,J)
          J = MIN(J,NBIN)
          SFP(J,5,IDER) = SFP(J,5,IDER) + FP
          SFFP(J,5,IDER) = SFFP(J,5,IDER) + FFP
          SFFPH(J,5,IDER) = SFFPH(J,5,IDER) + FFPH
          RFF(J,5,IDER) = ABS(FFP-FFPH) + RFF(J,5,IDER)
          RF(J,5,IDER) = ABS(FP-FPH) + RF(J,5,IDER)
          IF (ABS(FP-FPH).GT.IDMX(J,5,IDER))
     +         IDMX(J,5,IDER) = ABS(FP-FPH)
          WR(J,5,IDER) = ABS(FFP-FFMEAN)*WFFP + WR(J,5,IDER) +
     +         ABS(FFPH-FFMEAN)*WFFPH
          WSM(J,5,IDER) = WSM(J,5,IDER) + FFP*WFFP + FFPH*WFFPH
          NR(J,5,IDER) = NR(J,5,IDER) + 1
          IF (JAN.GT.0 .AND. .NOT. LOGMSS(IPSDPH)) THEN
            IF (ADATA(IPSDPH).GE.0.0001) THEN
              NRANO(J,5,IDER) = NRANO(J,5,IDER) + 1
              SANO(J,5,IDER,1) = SANO(J,5,IDER,1) + DPH
              SANO(J,5,IDER,2) = SANO(J,5,IDER,2) + ABS(DPH)
              SANO(J,5,IDER,3) = SANO(J,5,IDER,3) + DDPH
              SANO(J,5,IDER,4) = ABS(FP-FPH) + SANO(J,5,IDER,4)
              IAMX(J,5,IDER) = MAX(INT(ABS(DPH)),IAMX(J,5,IDER))
            END IF
          END IF
C
C---- Analysis for Kraut scale Kr - taken from Ian Tickle
C  Daresbury book 1991 p 91
C  SFKA SFKB SFKC are the cooefficients of the quadratic solved for Kr
          SFKA(J,IDER) = SFKA(J,IDER) + (IC + 1) *FFP - IC*SIGP*SIGP
          SFKB(J,IDER) = SFKB(J,IDER) + IC  *FP * FPH
          SFKC(J,IDER) = SFKC(J,IDER) + (IC - 1) *FFPH - IC*SFPH*SFPH
C
C---- call differ
C
          IFLG = 0
          JRESLN = J
          IFLG = 0
          DO 14 IJAN = 1, (JAN+1)
            DIFF = FP-FPH
            IF (IJAN.EQ.2) DIFF = DPH
            IF (ABS(DIFF).GT.DIF(IDER,IJAN)) IFLG = IFLG + IJAN
C
C---- for histogram of data distribution
C
            IHIST = 1
            IF(INTER(IDER,IJAN).GT.0)
     1        IHIST = NINT(DIFF/REAL(INTER(IDER,IJAN))) + MXHIS + 1
            IHIST = MAX(MIN(IHIST,MX2HIS),1)
            NREF(IDER,IJAN) = NREF(IDER,IJAN) + 1
C
            JHIST(JRESLN,IDER,IHIST,IJAN) =
     $           JHIST(JRESLN,IDER,IHIST,IJAN) + 1
C
 14       CONTINUE
C
C                 ***************************************
C
          IF(IFLG.NE.0) IWRT = 1
C
          IF(IFLG.EQ.1)THEN
            LIN(I1:I1+10) = ' ========= '
          END IF
C
          IF(IFLG.EQ.2)THEN
            LIN(I1:I1+21) = '            ========= '
          END IF
C
          IF(IFLG.EQ.3)THEN
            LIN(I1:I1+21) = ' =========   ========= '
          END IF
C
C
 88       I1 = I1 + 11 + JAN*11
 89       CONTINUE
C
 90    CONTINUE
       IDATA(1) = NINT(ADATA(1))
       IDATA(2) = NINT(ADATA(2))
       IDATA(3) = NINT(ADATA(3))
C
       IF(IWRT.GT.0) THEN
          IF(NOUT.LE.18)  THEN
             WRITE (LUNOUT,FMT=5091) IDATA(1),IDATA(2),IDATA(3),
     +            S,(IOUT(II),II=4,NOUT+3)
          WRITE (LUNOUT,FMT=6003) LIN
          ELSE
             NCHAR = 1
             DO NNO = 4,NOUT+3,28
             NOUT0 = NNO
             NOUT1 = MIN(NNO+23,NOUT+3)
               IF(NNO.EQ.4)WRITE (LUNOUT,FMT=6001) IDATA(1),IDATA(2),
     +            IDATA(3),S,(IOUT(II),II=NOUT0,NOUT1)
               IF(NNO.GT.4)WRITE (LUNOUT,FMT=6011)
     +                           (IOUT(II),II=NOUT0,NOUT1)
               WRITE (LUNOUT,FMT=6003) LIN(NCHAR:NCHAR+131)
             NCHAR = NCHAR + 132
            END DO
          ENDIF
          LIN = '   '
          IWRT = 0
       ENDIF
C     Starting point for line
       I1 = 33
       IF(NOUT.GT.18)I1   = 3
       LIN = ' '
C
       IF (OUTPUT) THEN
C---- Output record
C
C              *******************
          CALL LWREFL(IFIL1,ADATA)
C              *******************
       ENDIF
C
       GO TO 40
C
C---- End of file
C
 100   CONTINUE
cpjx commented out to stop the rest of the html log file going belly-up
cpjx      call ccp4h_pre_end()
      Call ccp4h_summary_end()
C
      IF (OUTPUT) THEN
          WRITE(LUNOUT,'(//)')
          IPRINT = 1
C              ********************
          CALL LWCLOS(IFIL1,IPRINT)
C              ********************
       ENDIF
C
      CALL ccp4h_summary_beg() 
       IF (.NOT.ANALYSE) WRITE (LUNOUT,FMT=6002) NREFS
      CALL CCP4H_SUMMARY_END()
       if (.NOT.ANALYSE) WRITE (LUNOUT,FMT=6666)
C
C****************************************************************
C****************************************************************
C     NORMAL PROBABILITY  Analysis taken from Dave Smiths program.
C****************************************************************
C****************************************************************
      IF(NORMAN) THEN
C  Is this best??       CALL NORMANAL
C
C---- All records passed, now sort them
      call ccp4h_summary_beg()
C
      WRITE (LUNOUT,FMT=5008) NORMSUM,NORMSUMA,NORMSUMC
 5008 FORMAT (1X,I8,' records passed to sort',/,
     + I8,' acentric,',i8,' centric.')
      ISTAT = SRTMRG()
C
      IF (ISTAT.NE.0) THEN
        WRITE (LUNOUT,FMT=5010) ISTAT
 5010   FORMAT (/' Sort fail : MERGE, status = ',I8,/)
C
C                  ********************************
        CALL CCPERR(1,' ERROR - Termination')
C                  ********************************
C
      END IF
      IORMSUM = 0
      IORMSUMA = 0
      IORMSUMC = 0
C
C---- Now pick up records and output
C
  105 ISTAT = SRTRET(BDATA)
C
C---- End of file
C
      IF (ISTAT.EQ.EOF) GO TO 106
C
      IF (ISTAT.NE.0) THEN
        WRITE (LUNOUT,FMT=5012) ISTAT
 5012   FORMAT (/' Sort fail : RETURN , status = ',I8,/)
C
C                  *********************************
        CALL CCPERR(1,' ERROR - Termination ')
C                  *********************************
C
      END IF
C
C  Get summs
C
      IORMSUM = IORMSUM + 1
C---- Analysis against 4(sin theta/lambda)**2
           IN(1) = NINT(BDATA(1))
           IN(2) = NINT(BDATA(2))
           IN(3) = NINT(BDATA(3))
          S = 4.0* LSTLSQ(IFIL1,IN(1),IN(2),IN(3))
C     Test whether a reflection is centric (return ic=1)
C     or not (ic=0) - needed for Anom observations
      CALL CENTR(IN,IC)
      IF(IC.EQ.0)IC=2
      IF(IC.EQ.1) IORMSUMC = IORMSUMC + 1
      IF(IC.NE.1) IORMSUMA = IORMSUMA + 1
C
C
          J = NINT(S*DS+1.0)
          J = MAX(1,J)
          J = MIN(J,NBIN)
C     Calculate Delta(expected)
C
      PX = 0.00
      IF(IC.EQ.1 .AND. NORMSUMC.GT.0)
     + PX = ABS(REAL(NORMSUMC- 2 * IORMSUMC+ 1) / REAL(NORMSUMC))
      IF(IC.NE.1 .AND. NORMSUMA.GT.0)
     + PX = ABS(REAL(NORMSUMA- 2 * IORMSUMA+ 1) / REAL(NORMSUMA))
C      CALL BSRCH (PX, X)
C
C     Interpolate from probability table
C
      I = 256
      ID =I / 2
C
C     Start of binary search loop
C
      DO 200 K=1,8
      DEL = PX - PROB(I)
      IF (DEL .GT. 0.0) GO TO 290
      I = I - ID
      GO TO 295
 290  I = I + ID
 295  ID = ID / 2
 200  CONTINUE
      IF (PX .LT. PROB(I)) I = I - 1
C
      DEL = (PX - PROB(I)) / (PROB(I+1) - PROB(I))
      X   = 0.7827789E-02 * (REAL(I-1) + DEL)
C
      IF (IC.EQ.1 .AND. IORMSUMC .LT. NORMSUMC/2) X = -X
      IF (IC.EQ.2 .AND. IORMSUMA .LT. NORMSUMA/2) X = -X
C      DREL(J) = DELREL
C      DEX(J)  = X
C      RESOL(J) = DRES
C
      SUMXX(J,1,IC) = SUMXX(J,1,IC) + X**2
      ISUM(J,1,IC)  = ISUM(J,1,IC) + 1
      SUMX(J,1,IC)  = SUMX(J,1,IC) + X
      SUMXY(J,1,IC) = SUMXY(J,1,IC) + X * BDATA(8)
      SUMY(J,1,IC)  = SUMY(J,1,IC) + BDATA(8)
      SUMYY(J,1,IC)  = SUMYY(J,1,IC) + BDATA(8)*BDATA(8)
C   Accumulate totals
      SUMXX(MAXINX,1,IC) = SUMXX(MAXINX,1,IC) + X**2
      ISUM(MAXINX,1,IC)  = ISUM(MAXINX,1,IC) + 1
      SUMX(MAXINX,1,IC)  = SUMX(MAXINX,1,IC) + X
      SUMXY(MAXINX,1,IC) = SUMXY(MAXINX,1,IC) + X * BDATA(8)
      SUMY(MAXINX,1,IC)  = SUMY(MAXINX,1,IC) + BDATA(8)
      SUMYY(MAXINX,1,IC)  = SUMYY(MAXINX,1,IC) + BDATA(8)*BDATA(8)
C
C     Accumulate sums for L.S. line for all data
C
      IF(ABS(X).LT.0.9)THEN
        ISUM(J,2,IC)  = ISUM(J,2,IC) + 1
        SUMX(J,2,IC)  = SUMX(J,2,IC) + X
        SUMXX(J,2,IC) = SUMXX(J,2,IC) + X**2
        SUMXY(J,2,IC) = SUMXY(J,2,IC) + X * BDATA(8)
        SUMY(J,2,IC)  = SUMY(J,2,IC) + BDATA(8)
        SUMYY(J,2,IC)  = SUMYY(J,2,IC) + BDATA(8)*BDATA(8)
C   Accumulate totals
        SUMXX(MAXINX,2,IC) = SUMXX(MAXINX,2,IC) + X**2
        ISUM(MAXINX,2,IC)  = ISUM(MAXINX,2,IC) + 1
        SUMX(MAXINX,2,IC)  = SUMX(MAXINX,2,IC) + X
        SUMXY(MAXINX,2,IC) = SUMXY(MAXINX,2,IC) + X * BDATA(8)
        SUMY(MAXINX,2,IC)  = SUMY(MAXINX,2,IC) + BDATA(8)
        SUMYY(MAXINX,2,IC)  = SUMYY(MAXINX,2,IC) + BDATA(8)*BDATA(8)
C
      END IF
       GO TO 105
C
106   CONTINUE
C        CALL LSLIN....
C     Subroutine to calculate the equation of a
C     Least-Squares straight line
C
      WRITE(6,'(////,a,/,a,/,a)')
     1 ' Least squares line : Gradient - intercept SUMDEL Npoints',
     1 '  Gradient should be 1 for 2 equivalent data sets',
     1 '  Gradient should be >> 1 for derivative v native data sets'
         WRITE(6,*)' $TEXT:reference:'
         WRITE(6,'(a,/,a)') '  $$ Normal probability $$',
     + ' Dave Smith and Lynne Howell ( J.Appl. Cryst 1992 25 81-86) $$'
      call ccp4h_summary_end()
C
      IF(NORMSUMC.GT.0) THEN
        call ccp4h_graph_beg(0,0) 
        WRITE (LUNOUT,FMT=6022)DTITLE(1)(1:LENSTR(DTITLE(1)))
 6022   FORMAT 
     + (///' $TABLE: Centric Normal probability v resolution ',
     +            3x,A,' :',/,
     +  ' $GRAPHS :',
     + ' Gradient/intercept v resolution ',
     + '(centric data; 0.9 prob cutoff):A:1,4,5,8,9: :',
     + ' Nref(all data; 0.9 prob cutoff) v resolution :N:1,3,7:',
     $  ' $$ 1/resol^2 ',/,
     $  ' Resolution  ',/,
     $  ' Total_Number_reflections  ',/,
     $  ' Gradient_on_all_reflections(>1?) ',/,
     $  ' Intercept_on_all_reflections(=0?) ',/,
     $  ' Sum_of_diffs_on_all_reflections ',/,
     $  ' Number_reflections_prob.lt.0.9  ',/,
     $  ' Gradient_on_reflections_prob.lt.0.9(>1?) ',/,
     $  ' Intercept_on_reflections_prob.lt.0.9(=0?) ',/,
     $  ' Sum_of_diffs_on_reflections_prob.lt.0.9  $$ ',/,
     +  ' 1/resol^2  Resn  NRef    Gradient  Intercept   SUMDEL ',
     +      '  Nref2  Gradient2  Intercept2  SUMDEL2  $$ ')
C
      DO 108 J = 1,NBIN
       SLOP(J,1) = 0.0
       SLOP(J,2) = 0.0
       TERCEP(J,1) = 0.0
       TERCEP(J,2) = 0.0
       SUMDEL(J,1) = 0.0
       SUMDEL(J,2) = 0.0
      DO 107 I = 1,2
      IF(ISUM(J,I,1) .EQ.0) GO TO 107
      A = ISUM(J,I,1) * SUMXX(J,I,1) - SUMX(J,I,1)*2
      SLPNUM = ISUM(J,I,1) * SUMXY(J,I,1) - SUMX(J,I,1) * SUMY(J,I,1)
      TERNUM = SUMXX(J,I,1) * SUMY(J,I,1) - SUMX(J,I,1) * SUMXY(J,I,1)
      IF (A.GT.0.000) THEN
        SLOP(J,I)   = SLPNUM / A
        TERCEP(J,I)  = TERNUM / A
      ENDIF
      SUMDEL(J,I) = SLOP(J,I)**2 * SUMXX(J,I,1) +
     .            2.0 * SLOP(J,I) * TERCEP(J,I) * SUMX(J,I,1)
     .           -2.0 * SLOP(J,I) * SUMXY(J,I,1)
     .           -2.0 * TERCEP(J,I) * SUMY(J,I,1)
     .           + SUMYY(J,I,1)+ ISUM(J,I,1) * TERCEP(J,I)**2
107    CONTINUE
                S = (REAL(J)-0.5)/DS
                RES = 1.0/SQRT(S)
       IF(ISUM(J,1,1).GT.0)WRITE( LUNOUT,6024)
     1  S,RES,ISUM(J,1,1),SLOP(J,1),TERCEP(J,1),SUMDEL(J,1),
     1 ISUM(J,2,1),SLOP(J,2),TERCEP(J,2),SUMDEL(J,2)
6024  FORMAT(1X,F6.3,F7.1,2(I8,2X,2F10.3,F10.1))
108    CONTINUE
      WRITE(LUNOUT,'(A)')' $$ '
        call ccp4h_graph_end()
C  Totals
      DO 109 I = 1,2
      IF(ISUM(MAXINX,I,1) .EQ.0) GO TO 109
      A = ISUM(MAXINX,I,1) * SUMXX(MAXINX,I,1) - SUMX(MAXINX,I,1)*2
      SLPNUM = ISUM(MAXINX,I,1) * SUMXY(MAXINX,I,1)
     1       - SUMX(MAXINX,I,1) * SUMY(MAXINX,I,1)
      TERNUM = SUMXX(MAXINX,I,1) * SUMY(MAXINX,I,1)
     1        - SUMX(MAXINX,I,1) * SUMXY(MAXINX,I,1)
      SLOP(MAXINX,I)   = SLPNUM / A
      TERCEP(MAXINX,I)  = TERNUM / A
      SUMDEL(MAXINX,I) = SLOP(MAXINX,I)**2 * SUMXX(MAXINX,I,1) +
     .        2.0 * SLOP(MAXINX,I) * TERCEP(MAXINX,I) * SUMX(MAXINX,I,1)
     .       -2.0 * SLOP(MAXINX,I) * SUMXY(MAXINX,I,1)
     .       -2.0 * TERCEP(MAXINX,I) * SUMY(MAXINX,I,1)
     .       + SUMYY(MAXINX,I,1)+ ISUM(MAXINX,I,1) * TERCEP(MAXINX,I)**2
109    CONTINUE
       IF(ISUM(MAXINX,1,1).GT.0)WRITE( LUNOUT,6025)
     1ISUM(MAXINX,1,1),SLOP(MAXINX,1),TERCEP(MAXINX,1),SUMDEL(MAXINX,1),
     1ISUM(MAXINX,2,1),SLOP(MAXINX,2),TERCEP(MAXINX,2),SUMDEL(MAXINX,2)
6025    FORMAT(1X,' Total (cent)',2(I8,2X,2F10.3,F10.1))
      END IF
C
C   Acentric analysis nw
      IF(NORMSUMA.GT.0) THEN
        call ccp4h_graph_beg(0,0) 
        WRITE (LUNOUT,FMT=6023)DTITLE(1)(1:LENSTR(DTITLE(1)))
 6023   FORMAT 
     + (///' $TABLE: Acentric Normal probability v resolution ',
     +            3x,A,' :',/,
     +  ' $GRAPHS :',
     + ' Gradient/intercept v resolution ',
     + '(acentric data; 0.9 prob cutoff):A:1,4,5,8,9: :',
     + ' Nref(all data; 0.9 prob cutoff) v resolution :N:1,3,7:',
     $  ' $$ 1/resol^2 ',/,
     $  ' Resolution  ',/,
     $  ' Total_Number_reflections  ',/,
     $  ' Gradient_on_all_reflections(>1?) ',/,
     $  ' Intercept_on_all_reflections(=0?) ',/,
     $  ' Sum_of_diffs_on_all_reflections ',/,
     $  ' Number_reflections_prob.lt.0.9  ',/,
     $  ' Gradient_on_reflections_prob.lt.0.9(>1?) ',/,
     $  ' Intercept_on_reflections_prob.lt.0.9(=0?) ',/,
     $  ' Sum_of_diffs_on_reflections_prob.lt.0.9  $$ ',/,
     +  ' 1/resol^2  Resn  NRef    Gradient  Intercept   SUMDEL ',
     +      '  Nref2  Gradient2  Intercept2  SUMDEL2  $$ ')
C
      DO 118 J = 1,NBIN
       SLOP(J,1) = 0.0
       SLOP(J,2) = 0.0
       TERCEP(J,1) = 0.0
       TERCEP(J,2) = 0.0
       SUMDEL(J,1) = 0.0
       SUMDEL(J,2) = 0.0
      DO 117 I = 1,2
      IF(ISUM(J,I,2) .EQ.0) GO TO 117
      A = ISUM(J,I,2) * SUMXX(J,I,2) - SUMX(J,I,2)*2
      SLPNUM = ISUM(J,I,2) * SUMXY(J,I,2) - SUMX(J,I,2) * SUMY(J,I,2)
      TERNUM = SUMXX(J,I,2) * SUMY(J,I,2) - SUMX(J,I,2) * SUMXY(J,I,2)
      IF(A.GT.0.000) THEN
        SLOP(J,I)   = SLPNUM / A
        TERCEP(J,I)  = TERNUM / A
      ENDIF
      SUMDEL(J,I) = SLOP(J,I)**2 * SUMXX(J,I,2) +
     .            2.0 * SLOP(J,I) * TERCEP(J,I) * SUMX(J,I,2)
     .           -2.0 * SLOP(J,I) * SUMXY(J,I,2)
     .           -2.0 * TERCEP(J,I) * SUMY(J,I,2)
     .           + SUMYY(J,I,2)+ ISUM(J,I,2) * TERCEP(J,I)**2
117    CONTINUE
                S = (REAL(J)-0.5)/DS
                RES = 1.0/SQRT(S)
       IF(ISUM(J,1,2).GT.0)WRITE( LUNOUT,6024)
     1  S,RES,ISUM(J,1,2),SLOP(J,1),TERCEP(J,1),SUMDEL(J,1),
     1 ISUM(J,2,2),SLOP(J,2),TERCEP(J,2),SUMDEL(J,2)
118    CONTINUE
      WRITE(LUNOUT,'(A)')' $$ '
        call ccp4h_graph_end()
C  Totals
      DO 119 I = 1,2
      IF(ISUM(MAXINX,I,2) .EQ.0) GO TO 119
      A = ISUM(MAXINX,I,2) * SUMXX(MAXINX,I,2) - SUMX(MAXINX,I,2)*2
      SLPNUM = ISUM(MAXINX,I,2) * SUMXY(MAXINX,I,2)
     1       - SUMX(MAXINX,I,2) * SUMY(MAXINX,I,2)
      TERNUM = SUMXX(MAXINX,I,2) * SUMY(MAXINX,I,2)
     1        - SUMX(MAXINX,I,2) * SUMXY(MAXINX,I,2)
      SLOP(MAXINX,I)   = SLPNUM / A
      TERCEP(MAXINX,I)  = TERNUM / A
      SUMDEL(MAXINX,I) = SLOP(MAXINX,I)**2 * SUMXX(MAXINX,I,2) +
     .        2.0 * SLOP(MAXINX,I) * TERCEP(MAXINX,I) * SUMX(MAXINX,I,2)
     .       -2.0 * SLOP(MAXINX,I) * SUMXY(MAXINX,I,2)
     .       -2.0 * TERCEP(MAXINX,I) * SUMY(MAXINX,I,2)
     .       + SUMYY(MAXINX,I,2)+ ISUM(MAXINX,I,2) * TERCEP(MAXINX,I)**2
119    CONTINUE
       IF(ISUM(MAXINX,1,2).GT.0)WRITE( LUNOUT,6035)
     1ISUM(MAXINX,1,2),SLOP(MAXINX,1),TERCEP(MAXINX,1),SUMDEL(MAXINX,1),
     1ISUM(MAXINX,2,2),SLOP(MAXINX,2),TERCEP(MAXINX,2),SUMDEL(MAXINX,2)
6035  FORMAT(1X,' Total (acen)',2(I8,2X,2F10.3,F10.1))
         END IF

      END IF
C
C---- Analyses against indices
C
       DO 170 IDER = 1,JDER
          WRITE (LUNOUT,FMT=6014) IDER,DTITLE(IDER)
C
C---- output histogram of difference RANGES
C
C              ********************
          CALL DIFFER3(IDER,NBIN,DS)
C              ********************
C
C---- Shortened SFP array for scatpl
C
          DO 120 ISET = 1,MAXINX
             SHSN2(ISET,NANAL +1) = SFFP(ISET,NANAL+1,IDER)
C
             DO 110 JSET = 1,NANAL
                SHSN2(ISET,JSET) = SFFP(ISET,JSET,IDER)
 110         CONTINUE
 120      CONTINUE
C
          DO 140 JDO140 = 1,4
             IF (ISEE(JDO140).NE.0) THEN
                WRITE (LUNOUT,FMT=6016)
C     Seperate messages for H K L from Frange
                IF(JDO140.LE.3) THEN
                   call ccp4h_graph_beg(0,0) 
                   WRITE (LUNOUT,FMT=6004) JHKL(JDO140),
     +                  DTITLE(IDER)(1:LENSTR(DTITLE(IDER))),
     $            JHKL(JDO140),JHKL(JDO140),JHKL(JDO140),JHKL(JDO140)
C                   WRITE (LUNOUT,FMT=6005)
                   S2 = 0.0
                   NHKL = IMAX(JDO140) - IMIN(JDO140) + 1
                END IF
C     MODF stuff
C
                IF(JDO140.EQ.4) THEN
                   call ccp4h_graph_beg(0,0) 
                   WRITE(LUNOUT,FMT=6020)
     $                  DTITLE(IDER)(1:LENSTR(DTITLE(IDER)))
                   S2 = 0.0
                   NHKL = NBIN
                END IF
C
                DO 130 JDO130 = 1,NHKL
                   IF( NR(JDO130,JDO140,IDER) .EQ. 0) GO TO 130
                   K = IMIN(JDO140) + JDO130 - 1
                   S = SFFP(JDO130,JDO140,IDER)
                   IF( SFFPH(JDO130,JDO140,IDER) .NE. 0.0)
     +        SHSN2(JDO130,JDO140) = SQRT(S/SFFPH(JDO130,JDO140,IDER))
                   S2 = MAX(S2,SHSN2(JDO130,JDO140))
                   SHSN2(JDO130,NANAL+1) = K
                   IF(JDO140.EQ.4) THEN
                      SHSN2(JDO130,NANAL+1) = ( REAL(JDO130) -0.5)/DF
                   END IF
                   T = NR(JDO130,JDO140,IDER)
                   IF( SFP(JDO130,JDO140,IDER) .NE. 0.0)
     +               R = RF(JDO130,JDO140,IDER)/SFP(JDO130,JDO140,IDER)
C
                   IF(S.NE.0.0)R2 = RFF(JDO130,JDO140,IDER)/S
                   IF(T.NE.0.0) THEN
                      S = S/T
                      U = SFFPH(JDO130,JDO140,IDER)/T
                   END IF
                   IF( WSM(JDO130,JDO140,IDER) .NE. 0.0) WRF =
     $                  WR(JDO130,JDO140,IDER)/WSM(JDO130,JDO140,IDER)
                   AVAN1 = 0.0
                   AVAN2 = 0.0
                   AVAN4 = 0.0
                   IF( NR(JDO130,JDO140,IDER) .NE. 0) AVAN4 =
     $                  RF(JDO130,JDO140,IDER)/NR(JDO130,JDO140,IDER)
                   KEMP = 0.0
C
                   IF (NRANO(JDO130,JDO140,IDER).GT.0) THEN
                      AVAN1 = SANO(JDO130,JDO140,IDER,1)/
     +                     REAL(NRANO(JDO130,JDO140,IDER))
                      AVAN2 = SANO(JDO130,JDO140,IDER,2)/
     +                     REAL(NRANO(JDO130,JDO140,IDER))
                      AVAN4 = SANO(JDO130,JDO140,IDER,4)/
     +                     REAL(NRANO(JDO130,JDO140,IDER))
C
C---- k empirical:: sum of isomorphous/0.5*sum of anomolous
C
                      KEMP = 0
                      IF(AVAN2 .NE. 0.0) KEMP = 2.0*AVAN4/AVAN2
                   END IF
C
                   IF (NRANO(JDO130,JDO140,IDER).GT.0) THEN
                      WRITE (LUNOUT,FMT=6006)
     $                     K,NR(JDO130,JDO140,IDER),S,U,
     +                     SHSN2(JDO130,JDO140),R,R2,WRF,
     +                     AVAN4,IDMX(JDO130,JDO140,IDER),
     +                     NRANO(JDO130,JDO140,IDER),AVAN1,AVAN2,
     +                     IAMX(JDO130,JDO140,IDER),
     +                     KEMP
                   ELSE
                      WRITE (LUNOUT,FMT=6006)
     $                     K,NR(JDO130,JDO140,IDER),S,U,
     +                     SHSN2(JDO130,JDO140),R,R2,WRF,
     +                     AVAN4,IDMX(JDO130,JDO140,IDER),
     $                     IZERO,ZERO,ZERO,IZERO,ZERO
                   END IF
 130            CONTINUE
                WRITE(LUNOUT,'(a)')' $$'
                call ccp4h_graph_end()
                call ccp4h_summary_beg()
C
                WRITE (LUNOUT,FMT=6008)
                call ccp4h_summary_end()
                IF(JDO140.LE.3) THEN
                   SCALEX(1) = IMIN(JDO140)
                   SCALEX(2) = IMAX(JDO140)
                END IF
                IF(JDO140.EQ.4) THEN
                   SCALEX(1) = 0.0
                   SCALEX(2) = RMSF2
                END IF
                SCALEY(1) = 0.0
                SCALEY(2) = S2*1.3
                ICY(1) = JDO140
                IND = 2
C
C     *******************************************************
                IF(SCATPLT) CALL SCATPL(
     $               SHSN2,MAXINX,NANAL+1,NHKL,ICY,1,NANAL+1,50,
     $               110,SCALEX,SCALEY,IND)
C     *******************************************************
C
             END IF
 140      CONTINUE
C
C---- Analysis against 4(sin theta/lambda)**2
C
          call ccp4h_graph_beg(0,0) 
          WRITE (LUNOUT,FMT=6010) DTITLE(IDER)(1:LENSTR(DTITLE(IDER)))
          S2 = 0.0
C
C---- total arrays
C
          DO 150 ISET = 1,14
             TOTALS(ISET) = 0.0
 150      CONTINUE
          SFKAT = 0.0
          SFKBT = 0.0
          SFKCT = 0.0
C
          DO 160 JDO160 = 1,NBIN
             IF (NR(JDO160,5,IDER).GT.0) THEN
                TOTALS(1) = REAL(NR(JDO160,5,IDER)) + TOTALS(1)
                S1 = SHSN2(JDO160,5)
                TOTALS(2) = TOTALS(2) + SHSN2(JDO160,5)
                TOTALS(3) = TOTALS(3) + SFFPH(JDO160,5,IDER)
                SHSN2(JDO160,5) = SQRT(S1/SFFPH(JDO160,5,IDER))
                S2 = MAX(S2,SHSN2(JDO160,5))
                S = (REAL(JDO160)-0.5)/DS
                RES = 1.0/SQRT(S)
                SHSN2(JDO160,NANAL+1) = S
                T = NR(JDO160,5,IDER)
                TOTALS(5) = TOTALS(5) + RF(JDO160,5,IDER)
                R = RF(JDO160,5,IDER)/SFP(JDO160,5,IDER)
                TOTALS(4) = TOTALS(4) + SFP(JDO160,5,IDER)
                TOTALS(6) = TOTALS(6) + RFF(JDO160,5,IDER)
                R2 = RFF(JDO160,5,IDER)/S1
                S1 = S1/T
                U = SFFPH(JDO160,5,IDER)/T
                WRF = WR(JDO160,5,IDER)/WSM(JDO160,5,IDER)
                TOTALS(7) = TOTALS(7) + WR(JDO160,5,IDER)
                TOTALS(13) = MAX(TOTALS(13),REAL(IDMX(JDO160,5,IDER)))
                TOTALS(14) = TOTALS(14) + WSM(JDO160,5,IDER)
                AVAN1 = 0.0
                AVAN2 = 0.0
                AVAN4 = 0.0
C
                IF( NR(JDO160,5,IDER) .NE. 0)
     +               DISO = RF(JDO160,5,IDER)/NR(JDO160,5,IDER)
                KEMP = 0.0
C
                IF (NRANO(JDO160,5,IDER).NE.0) THEN
                   TOTALS(8) = REAL(NRANO(JDO160,5,IDER)) + TOTALS(8)
                   AVAN1 = SANO(JDO160,5,IDER,1)/
     $                  REAL(NRANO(JDO160,5,IDER))
                   TOTALS(9) = TOTALS(9) + SANO(JDO160,5,IDER,1)
                   AVAN2 = SANO(JDO160,5,IDER,2)/
     $                  REAL(NRANO(JDO160,5,IDER))
                   TOTALS(10) = TOTALS(10) + SANO(JDO160,5,IDER,2)
C     Recalculate <Diso> for terms with anom diffs only
                   AVAN4 = SANO(JDO160,5,IDER,4)/
     $                  REAL(NRANO(JDO160,5,IDER))
                   TOTALS(12) = TOTALS(12) + SANO(JDO160,5,IDER,4)
C
C---- k empirical:: sum of isomorphous/sum of anomolous
C
                   KEMP = 2.0*AVAN4/AVAN2
                   TOTALS(11) =
     $                  MAX(TOTALS(11),REAL(IAMX(JDO160,5,IDER)))
                END IF
C  Work out Kraut R
                IF( SFKA(JDO160,IDER).GT.0.0) THEN
                 SKRAUT = SFKA(JDO160,IDER) / ( SFKB(JDO160,IDER) +
     $   SQRT( ABS( SFKB(JDO160,IDER)**2 -
     $              SFKA(JDO160,IDER)*SFKC(JDO160,IDER))) )
                END IF
          SFKAT = SFKAT +  SFKA(JDO160,IDER)
          SFKBT = SFKBT +  SFKB(JDO160,IDER)
          SFKCT = SFKCT +  SFKC(JDO160,IDER)
C
                IF (TOTALS(8).GT.0.0) THEN
                   WRITE (LUNOUT,FMT=6012) S,RES,NR(JDO160,5,IDER),S1,
     +                  SKRAUT,SHSN2(JDO160,5),R,R2,WRF,
     +                  DISO,IDMX(JDO160,5,IDER),
     +                  NRANO(JDO160,5,IDER),AVAN1,
     +                  AVAN2,IAMX(JDO160,5,IDER),KEMP
                ELSE
                   WRITE (LUNOUT,FMT=6012) S,RES,NR(JDO160,5,IDER),S1,
     +                  SKRAUT,SHSN2(JDO160,5),R,R2,WRF,
     +                  DISO,IDMX(JDO160,5,IDER),
     $                  IZERO,ZERO,ZERO,IZERO,ZERO
                END IF
             END IF
 160      CONTINUE
          WRITE(LUNOUT,'(a)')' $$'
          call ccp4h_graph_end()
          NTOT = 7
C
C---- totals
C
C     1.     no reflections
C     2.     aver Fnative
C     3.     av Fder
C     4.     sum Fnat**2
C     5.     R fact(F)
C     6.     R fact(F**2)
C     7.     weighted R fact
C     12.     av Fn-FPH
C     13.     max diff
C     8.     No anom
C     9.     averaged sum Fanom
C     10.     aver sum abs(Fanom)
C     11.     maximum Fanom
C
          IF (TOTALS(1).NE.0.0) THEN
C
C---- average FP - FPH
C
             DISO = TOTALS(5)/TOTALS(1)
C
C---- R Factors
C
             TOTALS(5) = TOTALS(5)/TOTALS(4)
             TOTALS(6) = TOTALS(6)/TOTALS(2)
             TOTALS(7) = TOTALS(7)/TOTALS(14)
C
C---- average F values
C
             TOTALS(2) = TOTALS(2)/TOTALS(1)
             TOTALS(3) = TOTALS(3)/TOTALS(1)
             TOTALS(4) = SQRT(TOTALS(2)/TOTALS(3))
C work out total Kraut scal
                 SKRAUT = SFKAT / ( SFKBT +
     $   SQRT( ABS( SFKBT**2 - SFKAT*SFKCT)) )
             TOTALS(3) = SKRAUT
          END IF
C
C---- anomolous data
C
          KEMP = 0.0
          IF (TOTALS(8).GT.0.0) THEN
             NTOT = 14
             KEMP = 2.*TOTALS(12)/TOTALS(10)
             TOTALS(9) = TOTALS(9)/TOTALS(8)
             TOTALS(10) = TOTALS(10)/TOTALS(8)
          END IF
C
          IF(NTOT.EQ.7) THEN
             WRITE (LUNOUT,FMT=6018)
     $         ((TOTALS(III)),III=1,NTOT),
     1            DISO,TOTALS(13)
          ELSE
             WRITE (LUNOUT,FMT=6018)
     1            ((TOTALS(III)),III=1,7),
     1            DISO,TOTALS(13),
     1            ((TOTALS(III)),III=8,11),KEMP
          END IF
          WRITE (LUNOUT,FMT=6008)
          SCALEX(1) = 0.0
          SCALEX(2) = SMAX
          SCALEY(1) = 0.0
          SCALEY(2) = S2*1.3
          ICY(1) = 5
          IND = 2
C
C     *******************************************************
          IF(SCATPLT)
     $   CALL SCATPL(SHSN2,MAXINX,NANAL+1,NBIN,ICY,1,NANAL+1,50,110,
     $         SCALEX,SCALEY,IND)
C     *******************************************************
C
 170   CONTINUE
C
C---- Format statements
C
 5080  FORMAT(//'            ',3X,7A10/)
 5081  FORMAT(' Derivative ',I3,F10.3,6F10.5)
 5090  FORMAT (/1X,120('*')//
     $      '  Large differences (isomorphous & anomalous)'//
     +      '    H   K   L   RES',A7,A6,1X,8(A6,A7))
 5091  FORMAT (1X,3I4,F6.3,I6,I5,1X,8(I6,I5))
 6000  FORMAT (///
     $      '  Large differences (isomorphous & anomalous)'//
     +      '    H   K   L   RES',A7,A6,10(/1X,12(A6,A7)))
 6001  FORMAT (1X,3I4,F6.3,I6,I5,10(/1X,12(I6,I5)))
 6011  FORMAT (1X,12(I6,I5))
 6003  FORMAT (A132)
C
 6002  FORMAT (///1X,I8,
     $      ' STRUCTURE FACTORS SCALED AND WRITTEN TO OUTPUT FILE')
 6666  format (/////31X,'ANALYSES OF SCALE FACTOR ON INTENSITIES',
     +   'AFTER CORRECTION',/31X,'===============================',
     +      '=========================',///)
C
 6004  FORMAT (/' $TABLE :Analysis against Index ',A1,2X,A,':',/,
     +      ' $GRAPHS: Scale v Index ',A1,':N:1,5:',/,
     $           ' :  Rfac v Index ',A1,':N:1,6: ',/,
     +           ' : <diso> and Max(diso) v Index ',A1,':N:1,9,10:',/,
     +           ' : <dano> and Max(dano) v Index ',A1,':N:1,13,14:$$'/
     $  '  INDEX  ',/,
     $  ' Number_reflections  ',/,
     $  ' Mean_FP_squared ',/,
     $  ' Mean_FPH_squared ',/,
     $  ' Sqrt(Mean_FP_squared/Mean_FPH_squared)',/,
     $  ' Rfactor ',/,  ' Rfactor_I ',/,
     $  ' Rfactor_W ',/,  ' Mean_Abs(Diso) ',/,
     $  ' Maximum_Diso ',/,
     $  ' Number_reflections_with_anomalous_differences  ',/,
     $  ' Mean_Dano(=0?) ',/,  ' Mean_Abs(Dano) ',/,
     $  ' Maximum_Dano ',/,
     $  ' Mean_Diso/0.5*Mean_Dano(Kemp) $$ ',/,
     $ '    INDEX  NRef    <FP**2>  <FPH**2>   SCALE   RFAC',
     +      '  RF_I  Wted_R  <diso> max(diso) ',
     +      'N(ano) <ano> <|ano|> max(ano)    Kemp $$ ')
C
 6006  FORMAT (1X,I6,I8,2X,2F10.0,4F7.3,F8.1,I8,I6,2F8.1,I8,3X,F8.4)
 6008  FORMAT ('1',////)
 6010  FORMAT (///' $TABLE:Analysis v resolution',
     +      3X,A,' :',/,  ' $GRAPHS ',
     $  ' :     Kraut_sc and RMS(FP/FHP)  v resolution :N:1,5,6 :',/,
     $            ' : Rfac/Wted_R v resolution :N:1,7,9 :',/,
     +           ' : <diso> and Max(diso) v resolution :N:1,10,11:',/,
     +           ' : <dano> and Max(dano) v resolution :N:1,14,15:$$',/,
     $  ' 1/resol^2 ',/,  ' Resolution  ',/,
     $  ' Number_reflections  ',/,  ' Mean_FP_squared ',/,
     $  ' Kraut_scale ',/,
     $  ' Sqrt(Mean_FP_squared/Mean_FPH_squared)',/,
     $  ' Rfactor ',/,  ' Rfactor_I ',/,
     $  ' Rfactor_W ',/,  ' Mean_Abs(Diso) ',/,
     $  ' Maximum_Diso ',/,
     $  ' Number_reflections_with_anomalous_differences  ',/,
     $  ' Mean_Dano(=0?) ',/,  ' Mean_Abs(Dano) ',/,
     $  ' Maximum_Dano ',/,
     $  ' Mean_Diso/0.5*Mean_Dano(Kemp) $$ ',/,
     +  //' 1/resol^2  Res   NRef    <FP**2>  Sc_kraut SCALE   RFAC',
     +      '  RF_I  Wted_R  <diso> max(diso) ',
     +      'N(ano) <ano> <|ano|> max(ano) Kemp  $$ ')
 6012  FORMAT(1X,F6.3,F7.1,I8,2X,F10.0,5F7.3,F8.1,I8,I6,2F8.1,I8,F8.4)
 6020  FORMAT (///' $TABLE:Analysis against |Fnative|',2X,A,' :',/,
     +      ' $GRAPHS: Scale v |F|:N:1,5: ',/,
     $               ' :   Rfac v |F|:N:1,6 :',/,
     +           ' : <diso> and Max(diso) v Fnative :N:1,9,10:',/,
     +           ' : <dano> and Max(dano) v Fnative :N:1,12,13:$$',/,
     $  ' Frange  ',/,  ' Number_reflections  ',/,
     $  ' Mean_FP_squared ',/,  ' Mean_FPH_squared ',/,
     $  ' Sqrt(Mean_FP_squared/Mean_FPH_squared)',/,
     $  ' Rfactor ',/,  ' Rfactor_I ',/,
     $  ' Rfactor_W ',/,  ' Mean_Abs(Diso) ',/,
     $  ' Maximum_Diso ',/,
     $  ' Number_reflections_with_anomalous_differences  ',/,
     $  ' Mean_Dano(=0?) ',/,  ' Mean_Abs(Dano) ',/,
     $  ' Maximum_Dano ',/,
     $  ' Mean_Diso/0.5*Mean_Dano(Kemp) $$ ',/,
     +     //' Frange    NRef    <FP**2>  <FPH**2>   SCALE   RFAC',
     +      '  RF**2 Wted_R  <diso> max(diso) ',
     +      'N(ano) <ano> <|ano|> max(ano)    Kemp $$ ')
C
 6014  FORMAT (//
     $      1X,30('----')//
     1      '    Scaling for derivative no.',I2,
     1      ' Derivative title: ',A)
 6016  FORMAT (//8X,'Scale = <Fp>/<Fph> should be approx 1',
     $      11X,'(SCALE applies to F)',
     +      /8X,'K Emp(irical) = <DIso>/0.5*<abs(Ano)>',/,
     +      8X,'<ano> should be near zero',/)
 6018  FORMAT (/'    THE TOTALS',F9.0,1X,F10.0,5F7.3,
     +      F8.1,F8.0,F8.0,F6.1,F8.1,F8.0,F8.4)
C
       END
       SUBROUTINE SCAREF(IDER,JAN)
C     ===========================
C
C---- Refine scales & anisotropic temperature factors
C     recycle till convergence or ncyc
C
C     .. Parameters ..
       INTEGER NDER
       PARAMETER (NDER=20)
      INTEGER MaxSym
      PARAMETER (MaxSym=192)
      INTEGER MCOLS
      PARAMETER (MCOLS=500)
C     ..
C     .. Scalar Arguments ..
       DOUBLE PRECISION TOL
       INTEGER IDER
C     ..
C     .. Scalar Arguments for Eigsol..
       REAL ELIM,BV(8),AM(36),DV(8),ESD(8)
C     DOUBLE PRECISION ELIM,BV(8),AM(36),DV(8),ESD(8)
       LOGICAL DBUG
C
C     .. Scalars in COMMON ..
       REAL CONV,SSQ,SMAX,SMIN,RMSF2
       INTEGER ISOUT,JAN,LUNIN,LUNOUT,NCYC,NSYM,LSCALE,JDER,NOWT
       LOGICAL OUTPUT,WILSON,NORMAN,ANALYSE,SCATPLT
C     ..
C     .. Arrays in COMMON ..
       REAL DIF,DIFDAT
       INTEGER INTER,NREF,ISEE,JJJNK,IMIN,IMAX
       REAL BET,BETA,PERM,RSYM,RSYMT,SC,SCL,SIGM,DMAX,FMAX,DIFFS,CELL,
     +      CELLAS
       LOGICAL REFSCL
C     ..
C     .. Local Scalars ..
       DOUBLE PRECISION S,V,WD2
       REAL    SWES,SIGCHK,S2,ADIFF,F,DD1G1,DD1G2,DD2G1,DD2G2
       LOGICAL ENDFIL,WILSCL,LDIFF
       REAL AH,AK,AL,ASUM,D1,D2,DIFARMS,DIFRMS,FFD,FFN,
     $      G1,G2,H11,H12,H22,HD,SD,SN,DDIFF,DSUM,T,SP2,SPH2
       INTEGER I,IDP,IFIL1,IFPH,ISIGDP,ISIGFPH,ISYM,JDO10,JDO100,
     +      JDO130,JDO140,JDO20,JDO30,JDO80,JDO90,IAM,NOB,NVAR,NAA,
     +      JDO331,MAXA,MAXD,N,NA,NR,NRA,NTEST,NPARM,NSLOOP,NOBS,
     $      NCLOOP
C     ..
C     .. Local Arrays ..
       DOUBLE PRECISION A(8,8),DG(8),R(8),WK(40)
       REAL PAR(8)
       INTEGER IHKL2(8)
       REAL ADATA(MCOLS)
       LOGICAL LOGMSS(MCOLS)
C     ..
C     .. External Subroutines ..
       EXTERNAL DIFFER1,LRREFF,LRREFM,LRREWD
C     ..
C     .. Intrinsic Functions ..
       INTRINSIC ABS,EXP,NINT,REAL,SQRT
C     ..
C     .. COMMON blocks ..
       COMMON /ATSYM/RSYM(4,4,MaxSym),RSYMT(4,4,MaxSym),NSYM,PERM(4,4),
     + JJJNK(9)
      COMMON /DIF2/INTER(NDER,2),DIF(NDER,2),NREF(NDER,2),
     + DIFDAT(NDER,3,2)
       COMMON /INOUT/LUNIN,LUNOUT,ISOUT
       COMMON /SI_INPUT/TOL,NCYC,CONV,JDER,SIGM(NDER+1),FMAX(NDER+1),
     $               DMAX(NDER+1),DIFFS(NDER+1),NOWT,REFSCL(NDER),
     $               OUTPUT,LSCALE,WILSON,NORMAN,ANALYSE,scatplt
       COMMON /RANGES/IMIN(4),IMAX(4),RMSF2,SMIN,SMAX
       COMMON /SCALES/SC(2),BETA(6),SCL(2,NDER),BET(6,NDER),ISEE(4),
     +      CELL(6),CELLAS(6)
C     ..
C
C     Equivalences .. - THIS MEANS SC(1)=PAR(1)..BETA(1)=PAR(3)...
C     equivalence (par(1),sc(1))
C
C     .. Equivalences ..
       EQUIVALENCE (PAR(1),SC(1))
C     ..
       CHARACTER*10 PARLAB(8)
C
C     .. Save statement ..
       SAVE
C     ..
       DATA PARLAB/
     $      '  NATIVE  ','DERIVATIVE','      B11 ','      B22 ',
     +      '      B33 ','      B12 ','      B13 ','      B23 '/
C     Fran Young/EJD -  Work out JD from IDER - We chopped it out of
C     COMMON/SI_INPUT/  Feb 1991
C     PJX: changes to IFPH,ISIGFH,IDP,ISIGDP for new labels
       IFIL1 = 1
       IFPH = 14*IDER - 8
       ISIGFPH = 14*IDER - 7
       IDP = 14*IDER - 6
       ISIGDP = 14*IDER - 5
       IF (REFSCL(IDER)) THEN
         NCYCLE = NCYC
       ELSE
         NCYCLE = 0
       ENDIF
C
C Set up things depending on type of scaling
C     NPARM   number of parameters
C     NSLOOP  = NSYM for anisotropic (must sum over hemisphere), else = 1
       IF (LSCALE .EQ. 1) THEN
          NPARM  = 2
          NSLOOP = 1
       ELSEIF (LSCALE .EQ. 2) THEN
          NPARM  = 3
          NSLOOP = 1
       ELSEIF (LSCALE .EQ. 3) THEN
          NPARM  = 8
          NSLOOP = NSYM
       ELSE
          CALL CCPERR(1,' ** Illegal scale type **')
       ENDIF
C
       IF(IDER.EQ.1) THEN
          IF (LSCALE .EQ. 1) WRITE (LUNOUT,FMT=6003)
          IF (LSCALE .EQ. 2) WRITE (LUNOUT,FMT=6004)
          IF (LSCALE .EQ. 3) WRITE (LUNOUT,FMT=6005)
       ENDIF
C
       WILSCL = .FALSE.
       LDIFF  = .FALSE.
       NCLOOP = 0
C
C---- Loop for cycles -------------------------------------------
C
C  Cycles start here:
C    1)  NCYC refinement cycles (NCYC can be = 0)
C    2)  If WILSON flag set, 1 cycle of Wilson rescaling (WILSCL = .true.)
C    3)  Final cycle to collect statistics on differences (RMS & maximum)
C         (LDIFF = .true.)
C  NCLOOP is loop counter
C
 240   CONTINUE
          IF (NCYCLE .GT. 0) THEN
             NCLOOP = NCLOOP + 1
          ELSE
C No cycles, so go straight into Wilson rescaling or difference statistics
             IF (WILSON) THEN
                WILSCL = .TRUE.
             ELSE
                LDIFF = .TRUE.
             ENDIF
          ENDIF
C
          MAXA = 0
          MAXD = 0
          ASUM = 0
          DSUM = 0
          NOBS = 0
          SP2 = 0.0
          SPH2 = 0.0
C
C          DO 10 JDO10 = 1,6
          DO 10 JDO10 = 1,3
C             DIFDAT(JDO10) = 0.0
             DIFDAT(IDER,JDO10,1) = 0.0
             DIFDAT(IDER,JDO10,2) = 0.0
 10       CONTINUE
C
C---- Clear matrix etc
C
          DO 30 JDO30 = 1,8
             R(JDO30) = 0.0D00
             DO 20 JDO20 = 1,8
                A(JDO30,JDO20) = 0.0D00
 20          CONTINUE
 30       CONTINUE
C
          G1 = 1.0/SC(1)**2
          WD2 = 0.0D00
          NR = 0
          NA = 0
C
C---- Start reading file
C
C              *************
          CALL LRREWD(IFIL1)
C              *************
C
C---- Reflection loop
 50       CONTINUE
C
C              *****************************
          CALL LRREFF(IFIL1,SSQ,ADATA,ENDFIL)
          CALL LRREFM(IFIL1,LOGMSS)
C              *****************************
C
          IF (ENDFIL) GO TO 120
C
          IF(SSQ.GT.SMAX .OR. SSQ.LT.SMIN) GO TO 50
C
C---- Check that both native & derivative measurements are present
C
C---- Also omit reflns with zero f values from scaling
C
          IF (LOGMSS(IFPH).OR.LOGMSS(4) ) GO TO 50
          IF (ADATA(IFPH).LE.0.001)  GO TO 50
          IF (ADATA(4).LE.0.001) GO TO 50
C
C     Check if Fph and Fp >  sd(Fph) and sd(Fp)
          IF(LOGMSS(ISIGFPH) .OR. LOGMSS(5) ) GO TO 50
          IF(ADATA(ISIGFPH).LE.0.001 .OR.
     1         ADATA(5) .LE.0.001) GO TO 50
          SIGCHK = SIGM(IDER+1)*ADATA(ISIGFPH)
          IF (ADATA(IFPH).LE.SIGCHK) GO TO 50
          SIGCHK = SIGM(1)*ADATA(5)
          IF (ADATA(4).LE.SIGCHK) GO TO 50
C
C---- Check on Fmax
          IF (ADATA(4) .GT. FMAX(1) .OR.
     $         ADATA(IFPH) .GT. FMAX(IDER+1)) GO TO 50
C
C---- Check on Dmax if appropriate
          IF (JAN.EQ.1 .AND. .NOT.LOGMSS(IDP)) THEN
               IF (ABS(ADATA(IDP)).GT.DMAX(IDER+1)) GO TO 50
          END IF 
C
C---- Check on Differences if appropriate
          IF ( ABS(ADATA(IFPH) - ADATA(4)).GT.DIFFS(IDER+1)) GO TO 50
C
          NR = NR + 1
C
          IF (LSCALE .EQ. 1) THEN
             S2 = SC(2)
          ELSEIF (LSCALE .EQ. 2) THEN
             S2 = EXP(- BETA(1)*SSQ*0.25) * SC(2)
          ELSEIF (LSCALE .EQ. 3) THEN
             AH = ADATA(1)
             AK = ADATA(2)
             AL = ADATA(3)
             T =  (BETA(1)*AH+2.0*AK*BETA(4))*AH +
     +            (BETA(2)*AK+2.0*AL*BETA(6))*AK +
     +            (BETA(3)*AL+2.0*AH*BETA(5))*AL
             S2 = EXP(-T)*SC(2)
          ENDIF
C
C---- G1 always = 1.0
C G2 = 1/scaleF**2,   S2 = ScaleF
          G2 = 1.0/S2**2
C
C----  keep track of unusually large differences, just on final
C     difference cycle
          IF (LDIFF) THEN
C     Isomorphous difference
             DDIFF = ADATA(4) - S2*ADATA(IFPH)
             IF (ABS(DDIFF).GT.MAXD) MAXD = ABS(DDIFF)
             DSUM = DDIFF*DDIFF + DSUM
C
             IF (JAN.EQ.1) THEN
               IF (.NOT.(LOGMSS(IDP) .OR. LOGMSS(ISIGDP))) THEN
                 IF (ADATA(ISIGDP) .GE. 0.001) THEN
                   ADIFF = S2*ADATA(IDP)
                   IF(ABS(ADIFF).GT.MAXA) MAXA = ABS(ADIFF)
                   ASUM = ADIFF**2 + ASUM
                   NA = NA + 1
                 END IF
               END IF
             END IF
             GO TO 50
          END IF
C
C---- Get observations
C
          FFN = ADATA(4)
          FFN = FFN*FFN
          SN = ADATA(5)
          SN = 1.0/ (SN*SN*4.0*FFN)
          FFD = ADATA(IFPH)
          FFD = FFD*FFD
          SD = ADATA(ISIGFPH)
          SD = 1.0/ (SD*SD*4.0*FFD)
          IF(NOWT.EQ.1) THEN
             SN = 1.0
             SD = 1.0
          END IF
C
C---- If WILSCL cycle, just accumulate sums for Wilson scaling
          IF (WILSCL) THEN
             SP2 = SP2 + FFN/G1
             SPH2 = SPH2 + FFD/G2
             GO TO 50
          ENDIF
C
C---- Now FFN is FP**2   SN  = 1/(sig(FP**2)) ( = 1/(2*sig(FP)*FP)**2)
C     and FFD is FPH**2  SD  = 1/(sig(FPH**2)) etc
C     G1 is inverse scale for FP**2 = 1/sc(1)
C     G2 is inverse scale for FPH**2= exp(2*(b11h**2+...) /sc(2)
C     remember   exponential is squared ie *2 .
C
          F = 0.5*( FFN/G1 + FFD/G2)
C
C---- Terms for matrix & rhs
C
C---- wd2 = sum( sn*(ffn-mean(f))**2 + sd*(ffd-mean(f)**2 )
C
          D1 = FFN - G1*F
C     ie          D1 = 0.5*(FFN - G1*FFD/G2)
          D2 = FFD - G2*F
C     ie          D2 = 0.5*(FFD - G2*FFN/G1)
          WD2 = SN*D1*D1 + WD2 + SD*D2*D2
C
          DD1G1 = -0.5*FFD/G2
          DD2G2 = -0.5*FFN/G1
          DD1G2 =  0.5*FFD*G1/G2**2
          DD2G1 =  0.5*FFN*G2/G1**2
C     SUM( W * d(del)/dp(i) * d(del)/dp(j))
C     = - SUM( W*DEL*d(del)/dp(i))
          H11 = SN*DD1G1**2 + SD*DD2G1**2
          H22 = SN*DD1G2**2 + SD*DD2G2**2
          H12 = SN*DD1G1*DD1G2 + SD*DD2G1*DD2G2
C
C---- Partial derivatives dg1/dp(i) dg2/dp(i) where p(i) are
C     sc(1)(for FP)   sc(2)(for FPH)
C     b11 b22 b33 b12 b23 b31 where exp(b11h**2+...) is
C     temperature factor for FPH.
C
C     This program assumes that all equivalent reflections are the same;
C     ie the correction is not truly anisotropic.
C
C     We must sum DG(i) over all such symmetry equivalents of h k l.
C
          DO 110 ISYM = 1,NSLOOP
           IF (LSCALE .EQ. 3) THEN
             AH = ADATA(1)*RSYM(1,1,ISYM) + ADATA(2)*RSYM(2,1,ISYM) +
     +            ADATA(3)*RSYM(3,1,ISYM)
             AK = ADATA(1)*RSYM(1,2,ISYM) + ADATA(2)*RSYM(2,2,ISYM) +
     +            ADATA(3)*RSYM(3,2,ISYM)
             AL = ADATA(1)*RSYM(1,3,ISYM) + ADATA(2)*RSYM(2,3,ISYM) +
     +            ADATA(3)*RSYM(3,3,ISYM)
C
C---- Integerise  to reduce rounding errors
C     The terms are from (h,k,l)*(h,k,l)
C
             IHKL2(1) = 1
             IHKL2(2) = 1
             IHKL2(3) = NINT(AH)**2
             IHKL2(4) = NINT(AK)**2
             IHKL2(5) = NINT(AL)**2
             IHKL2(6) = NINT(AH)*2*NINT(AK)
             IHKL2(7) = NINT(AH)*2*NINT(AL)
             IHKL2(8) = NINT(AK)*2*NINT(AL)
           ENDIF
C
C---- G1 = 1/sc(1)**2  G2 = exp(2*b11h**2 + ...)/sc(2)**2
C
C     Partial derivatives dg1/d(sc(1)) = -1/sc(1)**2 = -2 g1/sc(1) (sc(1)=1.0)
C
             DG(1) = -2.0*G1/SC(1)
C
C---- Partial derivatives dg2/d(sc(2)) = -2exp(...)/sc(2)**3 = -2g2/sc(2)
C
             DG(2) = -2.0*G2/SC(2)
C
             IF (LSCALE .EQ. 2) THEN
C
C---- Partial derivatives dg2/dBiso   = 2 * G2 *  (sintheta/lambda)**2
                DG(3) = 2.*0.25*SSQ*G2
C
             ELSEIF (LSCALE .EQ. 3) THEN
C
C---- Partial derivatives dg2/d(b11)  = 2*h*h*exp(...)/sc(2) = 2*h*h*g2
C
                DG(3) = 2.*G2*IHKL2(3)
C
C---- Partial derivatives dg2/d(b22)  = 2*k*k*exp(...)/sc(2)
C
                DG(4) = 2.*G2*IHKL2(4)
C
C---- Partial derivatives dg2/d(b33)  = 2*l*l*exp(...)/sc(2)
C
                DG(5) = 2.*G2*IHKL2(5)
C
C---- Partial derivatives dg2/d(b12)  = 2*2*h*k*exp(...)/sc(2) - etc
C
                DG(6) = 2.*G2*IHKL2(6)
                DG(7) = 2.*G2*IHKL2(7)
                DG(8) = 2.*G2*IHKL2(8)
             ENDIF
C
C---- Set up matrix a (lower triangle) & rhs r
C
             DO 100 JDO100 = 1,NPARM
                IF (JDO100.GT.1) THEN
C
C---- J.gt.1  rest of matrix & rhs
C
C     dD1G1 = -0.5*FFD/G2
C     dD2G2 = -0.5*FFN/G1
C     dD1G2 =  0.5*FFD*G1/G2**2
C     dD2G1 =  0.5*FFN*G2/G1**2
C     SUM( W * d(del)/dp(i) * d(del)/dp(j))
C     = - SUM( W*DEL*d(del)/dp(i))
C
                   R(JDO100) = -DG(JDO100)*(SN*D1*DD1G2 +SD*D2*DD2G2)
     1                  + R(JDO100)
                   HD = DG(JDO100)*H22
C
                   DO 80 JDO80 = JDO100,NPARM
                      A(JDO80,JDO100) = DG(JDO80)*HD + A(JDO80,JDO100)
 80                CONTINUE
                ELSE
C
C---- J=1, relations to scale 1
C
                   R(1) = -DG(1)*(SN*D1*DD1G1 +SD*D2*DD2G1)
     1                  + R(1)
                   A(1,1) = DG(1)*H11*DG(1) + A(1,1)
                   HD = DG(1)*H12
C
                   DO 90 JDO90 = 2,NPARM
                      A(JDO90,1) = DG(JDO90)*HD + A(JDO90,1)
 90                CONTINUE
C
                END IF
 100         CONTINUE
             NOBS = NOBS+1
 110      CONTINUE
C
C---- end of symmetry loop
C
C---- End reflection loop
C
          GO TO 50
C
C---- Solve equations
C
 120      CONTINUE
C*C          WRITE(LUNOUT,'(/1X,A)') ' Finished reading input reflection file '
C
C              *************
          CALL LRREWD(IFIL1)
C              *************
          IF (LDIFF) GO TO 250
C
          IF (WILSCL) THEN
C  Adjust scale factor by Wilson scale
             T = SQRT(SP2/SPH2)
             SC(2) = SC(2)*T
             WRITE(LUNOUT, FMT=6101) T,SC(2)
 6101        FORMAT(/'  Scale adjusted by "Wilson" scaling:',
     $            ' multiplied by ',F10.5,' to give Scale = ',F10.5/)
             IF (REFSCL(IDER)) THEN
                LDIFF = .TRUE.
                GO TO 240
             ELSE
                GO TO 250
             ENDIF
          ENDIF
C
C---- Solve equations without!! NAG library
C    when this program was expanded to take all symms
C    we ran into loadsa problems with the matrix nolonger
C    being independant in all NPARM varibles
C     f04jaf solves linear equns AND gives the rank
C    this is used to reject the "zero" eigen values,
C    which actually come back as nearish to  zero...approximately
C
          IAM = 1
C
          DO 140 JDO140 = 1,NPARM
             BV(JDO140) = R(JDO140)
C
             DO 130 JDO130 = 1,JDO140
C               so the dimension of A must be at least NVAR * (NVAR + 1) / 2 .
C               The storage order is ((AM(I,J), J = 1, I), I = 1, NVAR) .
C            AM (JDO130,JDO140) = A(JDO140,JDO130)
C
                AM (IAM ) = A(JDO140,JDO130)
                IAM = IAM + 1
 130         CONTINUE
 140      CONTINUE
C
C          N = NAPRM
          N = NPARM
          NRA = NPARM
C
C---- if number of degrees of freedom wrong change TOL
C
C     Ian Tickle's call
          ELIM = 0.00035
          SWES = WD2
          NOB = NR
          DBUG = .FALSE.
          NVAR = NRA
          NAA = N*(N+1)/2
C
C     DOUBLE PRECISION ELIM,BV(8),AM(8,8),DV(8),ESD(8)
C     DP     DP  I   log   I  dp(8) I dp(36) dp(8) dp(8)
C              *************************************************
          CALL EIGSOL( ELIM,SWES,NOB,DBUG,NVAR,BV,NAA,AM,DV,ESD)
C              *************************************************
C
C---- Scale factor for shifts so that sc(1) == 1.0 using EIGSOL DVs
C
          V = SC(1)/ (SC(1)+DV(1))
          DV(1) = 0.0D00
          NTEST = 0
          PAR(1) = 1.0
          SC(1) = PAR(1)
          R(1) = DV(1)
          WK(1) = ESD(1)
C
          DO 331 JDO331 = 2,NPARM
             S = (PAR(JDO331)+DV(JDO331))*V
             DV(JDO331) = S - PAR(JDO331)
             PAR(JDO331) = S
C     Use same names as old prog to avoid errors...
             R(JDO331) = DV(JDO331)
             WK(JDO331) = ESD(JDO331)
             IF (ABS(DV(JDO331)).GT.CONV*ESD(JDO331)) NTEST = NTEST + 1
 331      CONTINUE
          WD2 = WD2 / REAL(NOBS-NPARM)
C
C---- End refinement if converged
C
          IF (NTEST.EQ.0 .OR. NCLOOP.EQ.NCYCLE) THEN
             WRITE (LUNOUT,FMT='(/A,I8)') '   -- Cycle  Number:',NCLOOP
             call ccp4h_summary_beg()
             call ccp4h_pre_beg()
             WRITE (LUNOUT,FMT=6000)  WD2,NR
             WRITE (LUNOUT,FMT=6001) (PARLAB(I),I=1,NPARM)
             WRITE (LUNOUT,FMT=6012) (R(I),I=1,NPARM)
             WRITE (LUNOUT,FMT=6022) (WK(I),I=1,NPARM)
             call ccp4h_summary_end()
C Set WILSCL loop is Wilson flag turned on
             IF (WILSON) THEN
                WILSCL = .TRUE.
                GO TO 240
             ELSE
                IF (REFSCL(IDER)) THEN
                   LDIFF = .TRUE.
                   GO TO 240
                ELSE
                   GO TO 250
                ENDIF
             ENDIF
          ENDIF
          GO TO 240
C
C---- find rms difference and iterate to find d, the allowable diff
C
 250      DIFRMS = SQRT(DSUM/ (REAL(NR)))
          DIFDAT(IDER,1,1) = DIFRMS
          DIFDAT(IDER,2,1) = REAL(NR)
          DIFDAT(IDER,3,1) = REAL(MAXD)
          call ccp4h_summary_beg()
          IF (WILSON) WRITE (LUNOUT,6007)
          WRITE (LUNOUT,FMT=6006) IDER,DIFRMS,NR
          call ccp4h_summary_end()
          IF (JAN.EQ.1) THEN
             IF(NA.NE.0) DIFARMS = SQRT(ASUM/(REAL(NA)))
             DIFDAT(IDER,1,2) = DIFARMS
             DIFDAT(IDER,2,2) = REAL(NA)
             DIFDAT(IDER,3,2) = REAL(MAXA)
             call ccp4h_summary_beg()
             WRITE (LUNOUT,FMT=6008) IDER,DIFARMS,NA
             call ccp4h_summary_end()
          END IF
C
       RETURN
C
C---- Format statements
C
 6000 FORMAT (
     + /' MEAN RESIDUAL  W D**2/( M - N) :',F20.5,17X,'FOR ',I8,
     +       '   REFLECTIONS',//)
 6001 FORMAT (17X,'SCALES (for F)',//12X,8A10)
 6002 FORMAT(' NEW VALUES',2F10.4,6F10.6)
 6012 FORMAT(' SHIFTS    ',2F10.4,6F10.6)
 6022 FORMAT(' SD ''S     ',2F10.4,6F10.6,/)
 6003 FORMAT (
     + //' The overall scale is applied to the derivative F')
 6004 FORMAT (
     + //' The isotropic scale is applied to the derivative F as',/,
     + ' (derivative scale)* exp( - B (sin theta/lambda)**2)')
 6005 FORMAT (
     + //' The anisotropic scale is applied to the derivative F as',/,
     + ' (derivative scale)* exp( - (B11*H**2 + B22*K**2 + B33*L*',
     +       '*2 +  2*(B12*H*K + B13*H*L + B23*K*L) )  )')
 6007 FORMAT (//
     $     '  ---- RMS differences calculated BEFORE Wilson',
     $     ' rescaling ----'/)
 6006 FORMAT (/' RMS  isomorphous difference for derivative ',
     +              I3,' is',F8.2,/'  Number of observations:',I6)
 6008 FORMAT (    ' RMS  anomalous   difference for derivative ',
     +              I3,' is',F8.2,/'  Number of observations:',I6)
C
      END
      SUBROUTINE SCATPL(A,N,M,N1,ICY,NCY,ICX,NY,NX,SCALEX,SCALEY,IND)
C     ===============================================================
C
C     .. Scalar Arguments ..
      INTEGER ICX,IND,M,N,N1,NCY,NX,NY
C     ..
C     .. Array Arguments ..
      REAL A(N,M),SCALEX(2),SCALEY(2)
      INTEGER ICY(NCY)
C     ..
C     .. Local Scalars ..
      REAL AI,B,C,ETA,ETAX,ETAY,FM,FMAX,FMIN,FSTEP,R,RATIO,RKN,RLY,
     +     XAXIS,XINT,XMIN,XSTEP,YAXIS,YINT,YMIN,YPR,YSTEP
      INTEGER I,I1,ILY,INDEX,INDX,INDY,IWIDTH,IWRITE,IX,JDO110,JDO130,
     +        JDO160,JDO190,JDO30,JDO60,JDO70,K,KEY,KN,KOUNT,LX,LY,NLX,
     +        NLY
C     ..
C     .. Local Arrays ..
      REAL XPR(17)
      CHARACTER ICHAR(12)*1,IOUT(161)*1
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC AINT,MOD,NINT,REAL
C     ..
C     .. Data statements ..
      DATA ICHAR/'*','+','X','-','=','1','2','3','4',' ','0','.'/
      DATA IWRITE/6/,ETA/0.0/,IWIDTH/125/
C     ..
C
      IF (N.LE.1) GO TO 290
      NLY = (NY/10)*10
      IF (NLY.LE.0) NLY = 50
      NLX = (NX/10)*10
      IX = IWIDTH - 20
      IF (NLX.LE.0 .OR. NLX.GT.IX) NLX = IX
      LX = (NLX/10)
      LY = (NLY/10)
      XAXIS = IX
      ETAX = REAL(NX)*ETA
      ETAY = REAL(NY)*ETA
      IF (IND.LE.1) GO TO 20
      XMIN = SCALEX(1)
      XAXIS = SCALEX(2) - XMIN
      IF (XAXIS.LT.ETAX) GO TO 270
      XSTEP = XAXIS/REAL(LX)
      IF (IND.EQ.3) GO TO 50
   10 YMIN = SCALEY(1)
      YAXIS = SCALEY(2) - YMIN
      IF (YAXIS.LT.ETAY) GO TO 280
      YSTEP = YAXIS/REAL(LY)
      GO TO 90
   20 FMIN = A(1,ICX)
      FMAX = FMIN
C
      DO 30 JDO30 = 2,N1
        AI = A(JDO30,ICX)
        IF (AI.LT.FMIN) FMIN = AI
        IF (AI.GT.FMAX) FMAX = AI
   30 CONTINUE
C
      IF (FMAX-FMIN.LT.ETAX) GO TO 270
      INDEX = 1
      FM = REAL(LX)
      GO TO 200
   40 XMIN = FMIN
      XSTEP = FSTEP
      IF (IND.EQ.1) GO TO 10
   50 K = ICY(1)
      FMIN = A(1,K)
      FMAX = FMIN
C
      DO 70 JDO70 = 1,NCY
        K = ICY(JDO70)
C
        DO 60 JDO60 = 1,N1
          AI = A(JDO60,K)
          IF (AI.LT.FMIN) FMIN = AI
          IF (AI.GT.FMAX) FMAX = AI
   60   CONTINUE
   70 CONTINUE
C
      IF (FMAX-FMIN.LT.ETAY) GO TO 280
      INDEX = 2
      FM = REAL(LY)
      GO TO 200
   80 YSTEP = FSTEP
      YMIN = FMIN
   90 YINT = 10.0/YSTEP
      XINT = 10.0/XSTEP
      NLY = NLY + 1
      NLX = NLX + 1
      LX = LX + 1
      RKN = 0.0
C
      DO 100 KN = 1,LX
        XPR(KN) = RKN*XSTEP + XMIN
        RKN = RKN + 1.0
  100 CONTINUE
C
      DO 190 JDO190 = 1,NLY
        I1 = JDO190 - 1
        ILY = NLY - I1
C
        DO 110 JDO110 = 1,NLX
          IOUT(JDO110) = ICHAR(10)
  110   CONTINUE
C
        DO 160 JDO160 = 1,N1
          INDX = NINT(((A(JDO160,ICX)-XMIN)*XINT)+1.0)
          IF (INDX.LT.1 .OR. INDX.GT.NLX) GO TO 150
C
          DO 130 JDO130 = 1,NCY
            K = ICY(JDO130)
            INDY = NINT(((A(JDO160,K)-YMIN)*YINT)+1.0)
            IF (INDY.NE.ILY) GO TO 120
            IF (IOUT(INDX).NE.ICHAR(10)) GO TO 140
            IOUT(INDX) = ICHAR(JDO130)
  120       CONTINUE
  130     CONTINUE
C
          GO TO 150
  140     IOUT(INDX) = ICHAR(11)
  150     CONTINUE
  160   CONTINUE
C
        call ccp4h_summary_beg()
        IF (MOD(I1,10).NE.0) GO TO 170
        RLY = LY - I1/10
        YPR = RLY*YSTEP + YMIN
        WRITE (IWRITE,FMT=6000) YPR, (IOUT(IX),IX=1,NLX)
        GO TO 180
  170   WRITE (IWRITE,FMT=6002) (IOUT(IX),IX=1,NLX)
  180   CONTINUE
        call ccp4h_summary_end()
  190 CONTINUE
C
      WRITE (IWRITE,FMT=6002) (ICHAR(2),I=1,NLX)
      WRITE (IWRITE,FMT=6004) (ICHAR(12),I=1,LX)
      WRITE (IWRITE,FMT=6006) XPR(1), (ICHAR(12),XPR(I),I=3,LX,2)
      WRITE (IWRITE,FMT=6008) (XPR(I),I=2,LX,2)
      IND = 0
      RETURN
C
  200 KEY = 1
      KOUNT = 0
  210 R = FMAX - FMIN
      B = FMIN
  220 IF (R.GT.1.0) GO TO 230
      KOUNT = KOUNT + 1
      R = R*10.0
      GO TO 220
  230 IF (R.LE.10.0) GO TO 240
      KOUNT = KOUNT - 1
      R = R/10.0
      GO TO 230
  240 IF (KEY.GT.2) GO TO 250
      B = 10.0**KOUNT*B
      IF (B.LT.0.0 .AND. B.NE.AINT(B)) B = B - 1.0
      B = AINT(B)/ (10.0**KOUNT)
      R = (FMAX-B)/FM
      KOUNT = 0
      KEY = KEY + 2
      GO TO 220
  250 FSTEP = AINT(R)
      IF (FSTEP.NE.R) FSTEP = FSTEP + 1.0
      IF (R.LT.1.5) FSTEP = FSTEP - 0.5
      FSTEP = FSTEP/ (10.0**KOUNT)
      IF (KEY.EQ.4) GO TO 260
      RATIO = (FMAX-FMIN)/ (FM*FSTEP)
      IF (RATIO.GT.0.8) GO TO 260
      KOUNT = 1
      KEY = 2
      GO TO 210
  260 FMIN = B
      C = AINT(B/FSTEP)*FSTEP
      IF (C.LT.0.0 .AND. C.NE.B) C = C - FSTEP
      IF ((C+FM*FSTEP).GE.FMAX) FMIN = C
      GO TO (40,80) INDEX
  270 IND = 1
      RETURN
  280 IND = 2
      RETURN
  290 IND = 3
      RETURN
C
C---- Format statements
C
 6000 FORMAT (' ',G13.6,'+',141A1)
 6002 FORMAT (14X,'+',141A1)
 6004 FORMAT (6X,15 (9X,A1))
 6006 FORMAT (' ',G22.6,7 (2X,A1,G17.6))
 6008 FORMAT (13X,7 (G20.6))
C
      END
      SUBROUTINE SCINIT(IDER)
C     =======================
C
C---- Get initial scale factor by making sum(fp**2) = sum(fph**2)
C     for derivataive number IDER
C
      INTEGER IDER
C
C     .. Parameters ..
      INTEGER NDER, MCOLS
      PARAMETER (NDER=20, MCOLS=500)
C     ..
C     .. Scalars in COMMON ..
      REAL CONV,SMAX,SMIN
      DOUBLE PRECISION TOL
      INTEGER ISOUT,LUNIN,LUNOUT,NCYC,LSCALE,JDER,NOWT
      LOGICAL ANALYSE,OUTPUT,WILSON,NORMAN,SCATPLT
C     ..
C     .. Arrays in COMMON ..
      REAL BET,BETA,SC,SCL,SIGM,DMAX,DIFFS,CELL,CELLAS,FMAX
      INTEGER IMAX,IMIN,ISEE
      LOGICAL REFSCL
C     ..
C     .. Local Scalars ..
      REAL FFD,FFN,S,SD,SN,SIGF,SIGCHK,RMSF2
      INTEGER IFIL1,IFPH,ISIGFPH,J,JDO50,NR
      LOGICAL ENDFIL
C     ..
C     .. Local Arrays ..
      REAL ADATA(MCOLS)
      LOGICAL LOGMSS(MCOLS)
C     ..
C     .. External Subroutines ..
      EXTERNAL LRREFF,LRREFM
C     ..
C     .. Intrinsic Functions ..
      INTRINSIC MAX,MIN,REAL
C     ..
C     .. COMMON blocks ..
      CHARACTER DTITLE*80
      COMMON /CDIF2/DTITLE(NDER)
      COMMON /INOUT/LUNIN,LUNOUT,ISOUT
      COMMON /SI_INPUT/TOL,NCYC,CONV,JDER,SIGM(NDER+1),FMAX(NDER+1),
     $              DMAX(NDER+1),DIFFS(NDER+1),NOWT,REFSCL(NDER),
     $              OUTPUT,LSCALE,WILSON,NORMAN,ANALYSE,scatplt
      COMMON /RANGES/IMIN(4),IMAX(4),RMSF2,SMIN,SMAX
      COMMON /SCALES/SC(2),BETA(6),SCL(2,NDER),BET(6,NDER),ISEE(4),
     +     CELL(6),CELLAS(6)
C     ..
C     .. Save statement ..
      SAVE
C     ..
C
      IFIL1 = 1
      SN = 0.0
      SD = 0.0
      NR = 0
C     PJX: changed for new extra labels...
      IFPH = 14*IDER - 8
      ISIGFPH = 14*IDER - 7
C
 20   CONTINUE
C
C---- Loop for reflections
C
C     ***************************
      CALL LRREFF(IFIL1,S,ADATA,ENDFIL)
      CALL LRREFM(IFIL1,LOGMSS)
C     ***************************
C
      IF (ENDFIL) GO TO 60
C
      IF(S.GT.SMAX .OR. S.LT.SMIN) GO TO 20
C
C     Check if Fph and Fp >  sd(Fph) and sd(Fp)
      IF (LOGMSS(IFPH) .OR. LOGMSS(4)) GOTO 20
      IF (ADATA(IFPH).LE.0.001 .OR. ADATA(4).LE.0.001) GOTO 20 
      IF(LOGMSS(ISIGFPH) .OR. LOGMSS(5) ) GO TO 20
      IF(ADATA(ISIGFPH).LE.0.001 .OR. ADATA(5) .LE.0.001) GO TO 20
      SIGF = ADATA(IFPH)
      SIGCHK = SIGM(IDER+1)*ADATA(ISIGFPH)
      IF (SIGF.LE.SIGCHK) GO TO 20
      SIGF = ADATA(4)
      SIGCHK = SIGM(1)*ADATA(5)
      IF (SIGF.LE.SIGCHK) GO TO 20
C
C---- Get  4(sintheta/lambda)**2 limits
C
      SMAX = MAX(SMAX,S)
C
C---- Index limits
      DO 50 JDO50 = 1,3
         J = NINT(ADATA(JDO50))
         IMIN(JDO50) = MIN(IMIN(JDO50),J)
         IMAX(JDO50) = MAX(IMAX(JDO50),J)
 50   CONTINUE
C
      NR = NR + 1
      FFN = ADATA(4)
      FFD = ADATA(IFPH)
      SN = FFN*FFN + SN
      SD = FFD*FFD + SD
      GO TO 20
C
C---- End of file
C
 60   CONTINUE
C
      IF (NR .LE. 0) THEN
         WRITE (LUNOUT, FMT='(/A/)')
     $        ' **** No reflections accepted ****'
         CALL CCPERR(1,'** No reflections **')
      ENDIF
C
      RMSF2= 2.0*SQRT(SN/NR)
      IF (REFSCL(IDER)) SC(2) = SQRT(SN/SD)
C
C     *************
      CALL LRREWD(IFIL1)
C     *************
C
      IF (REFSCL(IDER)) WRITE (LUNOUT,FMT=6001) DTITLE(IDER),SC(2),NR
C
 6001 FORMAT (//' Derivative: ',5X,A,/,
     +     ' Initial derivative scale factor (for F)  = ',F10.4,
     +     '  from',I8,'  reflections',//)
C
      END
C
