C
C     TOP
C     Copyright (C) 1998 Guoguang Lu
C
C     This code is distributed under the terms and conditions of the
C     CCP4 Program Suite Licence Agreement as a CCP4 Application.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
C
      PROGRAM TOPV6
c----------------------------------------------------------------------
C Made by Guoguang Lu 91-12-20 V1.0
c----------------------------------------------------------------------
C Updated by Guoguang Lu 92-01-25 2.0
c  In V2.0 following things will be done.
c * make a parameter list on the output for every match
c * make different similarity parameter for beta and alpha. Beta is more 
c    strict. Alpha keep same with v1.0
c * search for gaps, if they are helix and midpoint distances located within 
c   the distance between midpoint of gap-forming elements and max(midofgap)
c   they will be a match.
c * Occasionally, I found when match-1, one have to recenter xmh1 before 
c   search next 2nd queue.
c----------------------------------------------------------------------
c Updated by Guoguang Lu 94-10-26 v2.1
c  add command 'library' directory of the library
c----------------------------------------------------------------------
c Version 3.0
c Add function of vector library making and searching
c The program can read a group of file names and make a vector library
c for these pdb files. Program can read such vector library file and
c compare with a known molecule. This makes it possible to search the protein
c data bank without a protein data bank on the disk.
c Guoguang 950322 Purdue Univ, USA
c
c----------------------------------------------------------------------
c Version 4.0
c Now changes are brought into the program 950927
c  1) After the program not only compares the topology, it carries out a
c     Ca comparison. If the two proteins are homologous, this improves the 
c     comparison matrix. The sequence comparisons were also performed.
c  2) The secondary structure assignment can be carried out inside program
c     by merge a program SECSTR from PROCHECK packages (originally written
c     by David Keith Smith, updated by Roman Laskowski)
c----------------------------------------------------------------------
c Version 5.1 --- Guoguang at Karolinska institute 970910
c Now I want change
c  1) fix the repeated comparison bugs (repeated output)
c  2) give an option of best fit or all the fit
c  3) introduce a new score for topology similarities
c     Topological diversity score = NSND1*(ANGLE+RMS)/2*.MREAL0
C	where 	NSND1 is the number of Secondary Structures in MOL1
c		ANGLE is the averaged angle of directions superimposed SS 
c		RMS is calculated with all groups of the two points
c 
c	MREAL0 is # of all the superimposable SS elements (within cretiro)
c  4) introduce a new score for structure similarities
c      Structure diversity score = NATM1*RMS/MATCH
c	where	NMATCH is the matched Ca atoms (residues)
c		NATM1 is residue number of MOL1
c		
c  5) to make NMATCH less important or not important
c 
c Version 5.3 --- Guoguang at Karolinska institute 980129
c   fix a small bug in morefit in scanning mode
c
c   If there is more than one way to superimpose structures, all the
c   superimposed structures will be output. (if the two files are called mol1 and
c   mol2, the output files will be called mol2_mol1.pdb, mol2_mol1.pdb_2, 
c   mol2_mol1.pdb_3,.......).
c----------------------------------------------------------------------
c Version V6.0 -- Internet Version !!!! --Guoguang @ KI 9790212
c   Since this version, the program is designed for 
c	- fully automatic mode.
c	 Use MATCH AUTO or MATCH RATE rat1, rat2 [default 0.35 0.8]
c         The program will use 30% of the maximum SS number of 
c	  the two structures as old MATCH. When there is a hit,
c	  the program will limit rest hits with SS no less than 
c	  70% of the best hit.
c	- read coordinates via internet (part of top3d)
c	- keyword searching in LIB to skip un-related molecules
c	- 3DB interface to perform a lot of new functions.
c	- cope Ca-only atoms
c       - ready to distribute as bioinformatics programs
c
c V 6.1 980618 bugs fixed for SSE assignment to Ca only files
c       for Web driving process, wget does not work properly.
c      3DB browsing can work together with local PDB library
c
c V 6.2 980701 
c       add ZONE command: add SCOP command (replace mol2)
c       if the second argument of MOLVEC is empty, searchall
c      Other, the second argument of can be a file name or PDB code list
c
c V6.3 981008
c      1) introduce an option of single mutual and minimum Str.Div.
c
c       Structure diversity = RMS*(N0/MATCH)^A
c       when minimum Structure diversity N0 = min(N1,N2)
c            single Structure diversity  N0 = N1
c            mutual Structure diversity  N0 = (N1+N2)/2
c
c      2)introduce permutation factor to structure diversity
c      SD = SDold * Pf
c      where Pf = Pa^^(P(P-1))
c      P is the number of sequence permutation, when P=0 and P=1, Pf=1
c      Pa is an input amplification factor. [Default 1]
C      3) KEYWORD: STRDIV ISTR1 STRPA
c       ISTR1 = 0 Minimum  Structure diversity (mapping proteins without size)
c       ISTR1 = 1 single Structure diversity (for database search)
c       ISTR1 = 2 Mutual Structure diversity (mapping proteins with size)
c       STRPA = Pa <= 1 no permutation consideration
c                  > = permutation base
c       
c V6.4 9811218
c according to Carl-Ivar Branden, I add Cb examination as an option for
c more reliable alignment
c
c 
c v6.5 990824 g77 compactable
c 
c v6.6 990826 RCSB compactable
c use config.inc to control the different configurations
c 
c
      CHARACTER*80 OFM,OBJ1,OBJ2
c
      CHARACTER*80 INP,INP0
      PARAMETER (MAXSND=1500,MAXSAVE=100)
C	PARAMETER (MAXATM=MAXSND*3+MAXSND*(MAXSND-1)/2)
      PARAMETER (MAXATM=MAXSND*3)
      PARAMETER (NSCOPUNIT=3000)
c
      REAL*4 HLXRMS,BTARMS
      COMMON/RMSTOP/ RMSA,RMSANG,NREF
      COMMON/TOPDUMP/ DUMP,LIST
      COMMON/SNDWARN/ MOLWARN
      COMMON/TOPRMS/ HLXRMS,BTARMS
      COMMON/TOPLIB/ LIB,ERR
      COMMON/MODES/ MODE,NCOMP
      common/moreflag/ writ,comp
      COMMON/SNDASS/ SNDASS,APPE
      common/sndf/  sndf1,sndf2,sndf
      common/natmmatch/ natm,natm1,natm2
c this is to fix a bug from NMR structure, autosnd does not work properly
      logical*1 nmr
      common/nmrs/ nmr
      data nmr/.false./
      COMMON/STGCON/ STRPA,FPUM
      COMMON/NUMPUM/ NPUM
      common/outfil/ filout0
c
      CHARACTER TXT(MAXATM)*66
      CHARACTER*80 FILE1,FILE2,LIBNAM,DIRNAME
      CHARACTER*80 FILE1Z,FILE2Z,LIBNAM0
      CHARACTER*80 FILE2A,VECNAM,FILOUT,file2b*11,FILOUT0
      CHARACTER*80 SPS
      data FILE1/' '/,FILE2/' '/,LIBNAM/' '/,DIRNAME/' '/,FILE1Z/' '/,
     .  FILE2Z/' '/,SPS/' '/
      CHARACTER*4 SNDNAME1(maxsnd)
      CHARACTER*1   ESND1(MAXSND)
      CHARACTER*5 NST1(MAXSND),NEND1(MAXSND)
      REAL*4 XSND1(3,2,MAXSND)
      INTEGER IE(MAXSND)
      CHARACTER*4 SNDNAME2(maxsnd)
      CHARACTER*1   ESND2(MAXSND)
      CHARACTER*5 NST2(MAXSND),NEND2(MAXSND)
      REAL*4 XSND2S(3,2,MAXSND)
      CHARACTER*4 SNDNAME2S(maxsnd)
      CHARACTER*1   ESND2S(MAXSND)
      CHARACTER*5 NST2S(MAXSND),NEND2S(MAXSND)
      CHARACTER*6 NAMSND,KEYA
      CHARACTER   DAT*9
      character*200 comd
      INTEGER LNDIR
      data LNDIR/0/
      REAL*4 XSND2(3,2,MAXSND)
      REAL*4 XMCH1(3,2,MAXSND),XMCH2(3,2,MAXSND)
      REAL*4 XMH1(3,MAXATM),XMH2(3,MAXATM)
      REAL*4 XTP1(3,MAXATM),XTP2(3,MAXATM)
      REAL*4 XMH1C(3,MAXSND)
      REAL*4 XSE1(3,MAXSND),XSE2(3,MAXSND)
C	REAL*4 XLL1(3,MAXATM),XLL2(3,MAXATM)
C	REAL*4 DLL1(MAXATM),DLL2(MAXATM)
      REAL*4 CEN1(3),CEN2(3)
      REAL*4 CEN1OLD(3),CEN2OLD(3)
      REAL*4 ERRDLL(2),ERRANG(2)
      data   ERRDLL/4.,2./,ERRANG/30.,30./
      REAL*4 ERRDMM,ERRRMSA
      data   ERRDMM/10./,ERRRMSA/8.5/
      REAL*4 MAXDLL,MAXANG
      data   MAXDLL/2./,MAXANG/25./
c	REAL*4 ERRDLL/3.0/
      REAL*4 WANG
      data   WANG/1./
      REAL*4 B1(3),B2(3),B3(3),B4(3),B5(3)
      REAL*4 XTM1(3,2),XTM2(3,2)
      REAL*4 CG0(3),CG(3,2)
      REAL*4 VT(3*MAXATM),DIS(MAXATM),ROT(3,3),TR(3)
      REAL*4 ROTOLD(3,3)
      REAL*4 B0(3)
      data   B0/0.,0.,0./
      REAL*4 TIMER
      data   TIMER/2.0/
      REAL*4 REFW(2)
      data   REFW/1.,1.2/
      real*4  dstmin,rat1,rat2
      data    dstmin/3.8/,rat1/0.33/,rat2/0.9/
      real*4  ampl,ampltop
      data    ampl/2.0/,ampltop/1.5/
      integer lstres,maxcyc
      data    lstres/4/,maxcyc/20/
      logical*1 fit
      data      fit/.true./
      logical*1 writ,comp
      data      writ/.false./,comp/.false./
      character*2 sndf1,sndf2,sndf
      data        sndf1/'  '/,sndf2/'  '/,sndf/'  '/
      INTEGER ICHS(MAXSND),ICHE(MAXSND)
      INTEGER IM1(MAXSND),IM2(MAXSND)
      INTEGER IM1SAVE(MAXSND,MAXSAVE),IM2SAVE(MAXSND,MAXSAVE)
      INTEGER MATSAVE(MAXSAVE)
      INTEGER NRMCH,NRMCH0,MAXGAP
      data    NRMCH/4/,NRMCH0/4/,MAXGAP/8/
      INTEGER MODE
      data    MODE/0/
      logical*1 markfam
      data      markfam/.false./
      character zonstr*50,fam*70
      character*5 ress1, rese1
      data        ress1/' '/, rese1/' '/
      character*5 ress2, rese2
      data        ress2/' '/, rese2/' '/
      character*5 ress, rese
      data        ress /' '/, rese /' '/
      integer nkey
      data    nkey/0/
c      real cbeta/0.92349723/,agbeta/55./
      real cbeta,agbeta
      logical*1 dump,single,list,auto
      logical*1 fast,lib,err
      LOGICAL*1 SNDASS,ASS1,ASS2,
     +            appe
      logical*1 skip,fw,curr
      logical*1 net,bspdb,fbrows,actbrs
      logical*1 pnet
      data      dump/.false./,single/.true./,list/.false./,auto/.true./
      data      fast/.true./,lib/.false./,err/.false./
      data      SNDASS/.FALSE./,ASS1/.false./,ASS2/.false./,
     +            appe/.false./
      data      skip/.false./,fw/.false./,curr/.false./
      data      net/.false./,fbrows/.true./,actbrs/.false./
      data      pnet/.false./
      character site*120,site2*120,code1*4,code2*4
      character psite*120
      data      site/' '/,site2/' '/,code1/' '/,code2/' '/,psite/' '/
      character*1 asi
c--- 3db parameters
      character*80 sit3db
      data         sit3db/'http://www.pdb.bnl.gov'/
      character*80 key3db,text3db,reso3db,cmd
      character*180 cmd2
      character*3 dat3db
      character*80 upp3db,low3db,ev3db,het3db
      data upp3db/' '/,low3db/' '/,ev3db/' '/,het3db/' '/
      character*4900 seq3db,seqold
      data seq3db/' '/,seqold/' '/
      character scopunit(NSCOPUNIT)*25,scopskip(NSCOPUNIT)*4
      logical*1 zone1,zone2,scop
      data zone1/.false./,zone2/.false./,scop/.false./
      integer lsit3db,lkey3db,ltext3db,lreso3db
      data lsit3db/22/,lkey3db/0/,ltext3db/0/,lreso3db/0/
      integer lupp3db,llow3db,lsite,lhet3db,lpsite,
     +        l3db
      data lupp3db/0/,llow3db/0/,lsite/0/,lhet3db/0/,lpsite/0/,
     +        l3db/0/
      integer ISTR1
      data ISTR1/1/
      real STRPA
      data STRPA/1./
      real scut,sthigh
      data scut/30./,sthigh/10000./
      common/cb/ cbeta,agbeta
      external acosd, asind, sind
      include 'config_top.inc'
c
        CALL CCPFYP
        CALL CCPRCS(6,'TOP','$Date: 2006/11/22 16:46:07 $')

      write(6,'(a)')
     1 ' *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*='
      write(6,'(a)')
     1 '  Program:  TOP --- Version 6.5 (Internet) Sep 1999'
        write(6,'(a)')
     1 '   Author:  Guoguang Lu, Ph.D'
        write(6,'(a)')
     1 '   Address: Department of Molecular Biophysics'
        write(6,'(a)')
     1 '            Lund University'
        write(6,'(a)')
     1 '            Box 124, 221 00, Lund, Sweden'
        write(6,'(a)')
     1 '   E-mail:  Guoguang.Lu@mbfys.lu.se'
        write(6,'(a)')
     1 '   ftp:     ftp://bioinfo1.mbfys.lu.se/pub/guoguang/top.tar.Z'
        write(6,'(a)')
     1 '   WWW:     http://bioinfo1.mbfys.lu.se/TOP'
      write(6,'(a)')
     1 '   Date:    Dec 1991, BMC, Uppsala, Sweden (V1,V2)'
      write(6,'(a)')
     1 '            Sep 1995, Purdue Univ, USA (V3,V4)'
      write(6,'(a)')
     1 '            Jul 1996, Karolinska Inst., Sweden (V5,V6)'
        write(6,'(a)')
     1 '            Sep 1999, Lund University (V6.5 for g77)'
        write(6,'(a)')
     1 ' *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*='
      write (6,'(a)')
c
      NSTR = 0
      NVEC = 0
      NSIM = 0
      NSKIP = 0
      NCURR = 0
      NKEY = 0
      NSC = 0
      NSC0 = 0
      NDSCOP = 0
      LLFAM = 0
c
      CALL CCPDPN(13,'CHAR.CHA','UNKNOWN','F',0,0)
      CALL CCPDPN(14,'SEQ.CHA','UNKNOWN','F',0,0)
      HLXRMS = 2.0
      BTARMS = 4.0
c      real cbeta/0.92349723/,agbeta/55./
      cbeta = 0.92349723
      agbeta = 55.
c
      DO I = 1,80
       SPS(I:I) = ' '
      END DO
      NATM = 0
c
5	READ(5,'(A)',END=10) INP
      IF (INP(1:1).EQ.'!'.OR.INP(1:1).EQ.';'.OR.INP(1:1).EQ.'#')
     1 GOTO 5
C
      I = INDEX(INP,' ')
      CALL UP(INP(1:I),I)
      LN = LENSTR(INP)
      IF (INP(1:3).NE.'MOL'.AND.INP(1:3).NE.'LIB'.and.
     +      INP(1:3).NE.'OMA'.and.INP(1:3).NE.'MAK'.AND.
     +      INP(1:3).NE.'GET'.and.INP(1:3).NE.'3DB'.AND.
     +      INP(1:3).NE.'SER'.AND.INP(1:3).NE.'WEB'.AND.
     +      INP(1:3).NE.'SIT'.AND.INP(1:3).NE.'PDB'.AND.
     +      INP(1:8).NE.'RESEARCH'.AND.INP(1:3).NE.'CHA') 
     +   CALL UP(INP(1:LN),LN)
c
      IF (INP(1:4).EQ.'MATC') THEN
       I = INDEX(INP,' ')
       rewind (13)
       call redstrin(13,ln-i,INP(I+1:80),npar)
       READ(13,'(A)',END=20) KEYA
       IF (KEYA(1:4).EQ.'AUTO') then
        auto = .true.
        write(6,'(a)')  'Automatic mode of the program:'
 	  write(6,'(a,f6.2)') 
     +     'Least matching rate for the two molecules', rat1
        write(6,'(a,f6.2)') 
     +     'Least second matching rate', rat2
       else if (KEYA(1:4).EQ.'RATE') then
        auto = .true.
        read(13,*,ERR=20,END=20) rat1
        if (npar.ge.3) read(13,*,ERR=20,END=20) rat2
        if (dump.or.list) then
         write(6,'(a,f6.2)') 
     +     'Least matching rate for the two molecules', rat1
         write(6,'(a,f6.2)') 
     +     'Least second matching rate', rat2
        end if
       else
        READ(INP(I+1:LN),*,ERR=20,END=20) NRMCH
        NRMCH0 = NRMCH
        auto = .false.
        IF (LIST)
     1  WRITE(6,*) 'Print out when match is more than',NRMCH
       end if
       GOTO 5
      END IF
c
      IF (INP(1:4).EQ.'REFW') THEN
       I = INDEX(INP,' ')
       READ(INP(I+1:LN),*,ERR=20,END=20) REFW
       IF (LIST)
     1 WRITE(6,*) 'Weight of fit for alpha and beta',REFW
       GOTO 5
      END IF
c
      IF (INP(1:4).EQ.'PDBS') THEN
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       READ(13,'(a)',ERR=20,END=20) PSITE
       LPSITE = LENSTR(PSITE)
       IF (psite(lpsite:lpsite).eq.char(47)) then
        psite(lpsite:lpsite) = ' '
        lpsite = lpsite - 1
       end if
       if (lpsite.gt.0) then
        call getinfo(psite,site,sit3db)
        lsite = lenstr(site)
        lsit3db = lenstr(sit3db)
        write(6,'(a)') ' PDB mirror site: '//psite(1:lpsite)
        write(6,'(a)') ' corresponding FTP site: '//site(1:lsite)
        write(6,'(a)') 
     +         ' corresponding 3DB browsing: '//sit3db(1:lsit3db)
        net = .true.
        pnet = .true.
       end if
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'SERVER'.or.INP(1:4).EQ.'SITE'
     +     .or.INP(1:3).EQ.'WEB') THEN
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       READ(13,'(a)',ERR=20,END=20) SITE
       LSITE = LENSTR(SITE)
       if (lsite.gt.0) then
        net = .true.
        if (site(lsite:lsite).ne.char(47).and.site(1:4).eq.'ftp:') then
         site(lsite+1:lsite+1)=char(47)
         lsite = lsite + 1
        end if
       end if
       IF (LIST)
     1 WRITE(6,*) 'Site of Web Server:',SITE(1:LSITE)
       GOTO 5
      END IF
c
      IF (INP(1:4).EQ.'CHEC') THEN
       STOP  'Check finished'
      END IF
c
      IF (INP(1:6).EQ.'STRDIV') THEN
       call redstrin(13,ln-I,inp(i+1:ln),npar)
       READ(13,*,ERR=20,END=20) ISTR1
       READ(13,*,ERR=20,END=20) STRPA
       WRITE(6,*) 'Algorithm for st.div and permutation:',ISTR1,STRPA
c       IF (LIST.OR.DUMP) then
        if (ISTR1.eq.2) then
         WRITE(6,*) 'Use mutual structure diversity'
        else if (ISTR1.eq.0) then
         WRITE(6,*) 'Use minimum structure diversity'
        else
         WRITE(6,*) 'Use single structure diversity'
        end if
        if (STRPA.le.1.) then
         write(6,*) 'do not consider sequence permutation in ',
     +       'the diversity ranking'
        else
         WRITE(6,*) 'Amplification factor for permutation ',STRPA
        END IF
c       END IF 
       GOTO 5
      END IF
c
      IF (INP(1:4).EQ.'DIRW') THEN
       I = INDEX(INP,' ')
       READ(INP(I+1:LN),*,ERR=20,END=20) WANG
       IF (LIST)
     1 WRITE(6,*) 'Direction weight is',wang
       GOTO 5
      END IF
c
      IF (INP(1:4).EQ.'FAST') THEN
       I = INDEX(INP,' ')
       IF (LN.LT.I) THEN
        FAST = .true.
       ELSE 
        CALL SPSTRUNCT(INP(I+1:LN))
        IF (INP(I+1:I+1).EQ.'Y') THEN
         FAST = .TRUE.
        IF (LIST) WRITE(6,*) 'Program will do a fast search '
        ELSE
         FAST = .FALSE.
         IF (LIST) WRITE(6,*) 'Program will do a careful search '
        END IF
       END IF
       GOTO 5
      END IF
c
c
      IF (INP(1:4).EQ.'DUMP') THEN
       I = INDEX(INP,' ')
       IF (LN.LT.I) THEN
        DUMP = .FALSE.
       ELSE 
        CALL SPSTRUNCT(INP(I+1:LN))
        IF (INP(I+1:I+1).EQ.'Y') THEN
         DUMP = .TRUE.
         LIST = .TRUE.
         WRITE(6,*) 'Dump out all the rubbish'
        ELSE
         DUMP = .FALSE.
        END IF
       END IF
       GOTO 5
      END IF
c
      IF (INP(1:4).EQ.'LIST') THEN
       I = INDEX(INP,' ')
       IF (LN.LT.I) THEN
        DUMP = .FALSE.
       ELSE 
        CALL SPSTRUNCT(INP(I+1:LN))
        IF (INP(I+1:I+1).EQ.'Y') THEN
         LIST = .TRUE.
         WRITE(6,*) 'List out some useful information'
        ELSE
         LIST = .FALSE.
        END IF
       END IF
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'HLXRMS') THEN
       I = INDEX(INP,' ')
       READ(INP(I:LN),*,END=20,ERR=20) HLXRMS	 
       IF (LIST)
     1 WRITE(6,*) 'Maximum helix rms is:',HLXRMS
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'BTARMS') THEN
       I = INDEX(INP,' ')
       READ(INP(I:LN),*,END=20,ERR=20) BTARMS	 
       IF (LIST)
     1 WRITE(6,*) 'Maximum helix rms is:',BTARMS
       GOTO 5
      END IF
c
      IF (INP(1:7).EQ.'ERRRMSA') THEN
       I = INDEX(INP,' ')
       READ(INP(I+1:LN),*,ERR=20,END=20) ERRRMSA
       IF (LIST)
     1 WRITE(6,*) 'Max allowed RMSA:',ERRRMSA
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'MAXDLL') THEN
       I = INDEX(INP,' ')
       READ(INP(I+1:LN),*,ERR=20,END=20) MAXDLL
       IF (LIST)
     1 WRITE(6,*) 'Max allowed mean L-L distance:',MAXDLL
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'MAXANG') THEN
       I = INDEX(INP,' ')
       READ(INP(I+1:LN),*,ERR=20,END=20) MAXANG
       IF (LIST)
     1 WRITE(6,*) 'Max allowed mean direction error',MAXANG
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'ERRDMM') THEN
       I = INDEX(INP,' ')
       READ(INP(I+1:LN),*,ERR=20,END=20) errdmm
       IF (LIST)
     1 WRITE(6,*) 'Max allowed error of mean vector length',errdmm
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'ERRDLL') THEN
       I = INDEX(INP,' ')
       READ(INP(I+1:LN),*,ERR=20,END=20) errdll
       IF (LIST)
     1 WRITE(6,*) 'Max allowed error of l-l distance',errdll
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'ERRANG') THEN
       I = INDEX(INP,' ')
       READ(INP(I+1:LN),*,ERR=20,END=20) ERRANG
       IF (LIST)
     1 WRITE(6,*) 'Max allowed angle error of the direction',ERRANG
       GOTO 5
      END IF
c
      IF (INP(1:3).EQ.'LIB') THEN
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,'(a)') dirname
       LNDIR = LENSTR(dirname)
       IF (dirname(lndir:lndir).ne.'/') then
        LNDIR = LNDIR + 1
        DIRNAME(LNDIR:LNDIR) = '/'
       END IF
       FILE2 = dirname
       curr = (index(file2(1:lndir),'current_').gt.0)
       if (curr) ncurr = 3
       write(6,*) 'Library directory is: ',FILE2(1:LNDIR)
       GOTO 5
      END IF
c
      IF (INP(1:5).EQ.'ZONE1') THEN
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,'(a)') zonstr
       lz = lenstr(zonstr)
       write(6,'(2a)') 'The selected Zone of Mol1: ',zonstr(1:lz)
       call rangscop(file1,file1z,zonstr,nsel)
       if (nsel.eq.0) then
        write(6,*) 'No atoms in Mol1 after zone selection'
        stop 'ERROR STOP'
       end if
       zone1 = .true.
       goto 5
      END IF
c
      IF (INP(1:5).EQ.'ZONE2') THEN
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,'(a)') zonstr
       lz = lenstr(zonstr)
       write(6,'(2a)') 'The selected Zone of Mol2: ',zonstr(1:lz)
       call rangscop(file2,file2z,zonstr,nsel)
       if (nsel.eq.0) then
        write(6,*) 'No atoms in Mol2 after zone selection'
        stop 'ERROR STOP'
       end if
       zone2 = .true.
       goto 5
      END IF
c
      if (inp(1:4).eq.'SND1') then
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,'(a)') asi
       if (ASI.EQ.'Y') then
        ass1 = .true.
        IF (LIST.or.DUMP) write(6,*) 
     +     'The program will assign secondary structure for Mol1' 
       else
        ass1 = .false.
        IF (LIST.or.DUMP)
     +     write(6,*) 'The program will read the secondary structure',
     + ' from Mol1 first'
       END IF
       if (npar.ge.2) then
        read(13,'(a)') sndf1
        if (sndf1(1:2).eq.'CA') then
         write(6,'(a)') 'The SSE1 will be based only on Ca atoms'
        else 
         write(6,'(a)') 
     +      'The SSE1 assignment will be based on all mainchains'
        end if
       end if
       goto 5
      end if
c
      if (inp(1:4).eq.'SND2') then
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,'(a)') asi
       if (ASI.EQ.'Y') then
        ass2 = .true.
        IF (LIST.or.DUMP) write(6,*) 
     +   'The program will assign secondary structure for Mol2' 
       else
        ass2 = .false.
        IF (LIST.or.DUMP)
     +     write(6,*) 'The program will read the secondary structure ',
     +    ' from Mol2 fisrt'
       END IF
       if (npar.ge.2) then
        read(13,'(a)') sndf2
        if (sndf2(1:2).eq.'CA') then
         write(6,'(a)') 'The SSE2 will be based only on Ca atoms'
        else 
         write(6,'(a)') 'The SSE2 will be based on all mainchains'
        end if
       end if
       goto 5
      end if
c
      if (inp(1:4).eq.'APPE') then
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,'(a)') asi
       if (ASI.EQ.'Y') then
        appe = .true.
        if (list)
     1  write(6,*) 'The program will append secondary structure ',
     2 'assignment to the coordinates file'
       else
        appe = .false.
        if (list)
     1 write(6,*) 'The program will not append secondary structure ',
     2 'assignment to the coordinates file'
       end if
       goto 5
      end if
c
      if (inp(1:10).eq.'CHANGENAME') then
       ISP = INDEX(INP,' ')
C       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(INP(ISP+1:LN),*) nameadd1,nameadd2
c       print*, nameadd1,' ',nameadd2
       nadd1 = lenstr(nameadd1)
       nadd2 = lenstr(nameadd2)
       if (nadd1.gt.0 .or. nadd2.gt.0) then
        write(6,*) 'the original file name %%%% will be changed into ',
     +    nameadd1(1:nadd1),'%%%%', nameadd2(1:nadd2)
       end if
       goto 5
      end if
c
      if (inp(1:5).eq.'CBETA') then
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,*) agbeta
       if (agbeta.gt.0) then
        cbeta = 2.*sind(agbeta/2.)
        write(6,*) 'Consistent angle and unit for Cbeta atoms'
     +       ,agbeta,cbeta
       else
        cbeta = 0.
        write(6,*) 'Cbeta atoms are not used for alignment'
       end if
       goto 5
      end if
c
      if (inp(1:4).eq.'DIST') then
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,*) dstmin
       IF (LIST) write(6,*) 'Shortest distance for alignment',dstmin
       goto 5
      end if
c
      if (inp(1:4).eq.'RESI') then
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,*) lstres
       IF (lstres.GT.0) THEN
        fit = .true.
        IF (LIST) write(6,*) 'Shortest residues of one fragment',lstres
       END IF
       goto 5
      end if
c
      if (inp(1:4).eq.'AMPL') then
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,*) ampl,ampltop
       IF (LIST) then
        write(6,*) 'Amplification order for structural diversity',ampl
        write(6,*) 'Amplification order for topological diversity',
     1       ampltop
       end if
       goto 5
      end if
c
      if (inp(1:4).eq.'WRIT') then
       writ = .true.
       IF (LIST) write(6,*) 'Superimposed structure will be written out'
       goto 5
      end if
c
      IF (INP(1:6).EQ.'SINGLE') THEN
       SINGLE = .TRUE.
       IF (LIST)
     1 WRITE(6,*) 'New structure has single chain.'
       GOTO 5
      END IF
c
      IF (INP(1:7).EQ.'3DBSITE') THEN
       call redstrin(13,ln,inp(1:ln),npar)
       read(13,'(a)')
       read(13,'(a)') sit3db
       lsit3db = lenstr(sit3db)
       call b3dbsite(sit3db(1:lsit3db))
       print*, '3DB service will be browsed from site: ',
     +           sit3db(1:lsit3db)
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'3DBKEY') THEN
       call redstrin(13,ln,inp(1:ln),npar)
       read(13,'(a)') 
       lkey3db = 0
       do i = 1,npar-1
        read(13,'(a)') inp0
        il = lenstr(inp0)
        if (il.eq.4.and.inp0(1:il).eq.'.or.') then
         inp0(1:4) = 'or'
         il = 2
        else if (il.eq.1.and.inp0(1:1).eq.'+') then
         inp0(1:4) = 'or'
         il = 2
        end if
        if (lkey3db.gt.0) then
         key3db = key3db(1:lkey3db)//'+'//inp0(1:il)
         lkey3db = lkey3db+il+1
        else
         key3db = inp0
         lkey3db = il
        end if
       end do
       print*, '3DB keyword: ',key3db(1:lkey3db)
       call b3dbcmd('kw='//key3db(1:lkey3db))
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'3DBHET') THEN
       call redstrin(13,ln,inp(1:ln),npar)
       read(13,'(a)') 
       lhet3db = 0
       do i = 1,npar-1
        read(13,'(a)') inp0
        il = lenstr(inp0)
        if (lhet3db.gt.0) then
         het3db = het3db(1:lhet3db)//'+'//inp0(1:il)
         lhet3db = lhet3db+il+1
        else
         het3db = inp0
         lhet3db = il
        end if
       end do
       print*, '3DB HET associated group: ',het3db(1:lhet3db)
       call b3dbcmd('ht='//het3db(1:lhet3db))
       GOTO 5
      END IF
c
      IF (INP(1:7).EQ.'3DBTEXT') THEN
       call redstrin(13,ln,inp(1:ln),npar)
       read(13,'(a)')
       ltext3db = 0
       do i = 1,npar-1
        read(13,'(a)') inp0
        il = lenstr(inp0)
        if (il.eq.4.and.inp0(1:il).eq.'.or.') then
         inp0(1:4) = 'or'
         il = 2
        else if (il.eq.1.and.inp0(1:1).eq.'+') then
         inp0(1:4) = 'or'
         il = 2
        end if
        if (ltext3db.gt.0) then
         text3db = text3db(1:ltext3db)//'+'//inp0(1:il)
         ltext3db = ltext3db+il+1
        else
         text3db = inp0
         ltext3db = il
        end if
       end do
       print*, '3DB text query: ',text3db(1:ltext3db)
       call b3dbcmd('tx='//text3db(1:ltext3db))
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'3DBDAT') THEN
       call redstrin(13,ln,inp(1:ln),npar)
       read(13,'(a)')
       read(13,'(a)',err=20) dat3db
       l3db = lenstr(upp3db)
       print*, 'The date limit form is : ',dat3db(1:l3db)
       call b3dbdat(dat3db(1:3))
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'3DBUPP'.or.INP(1:6).EQ.'3DBBEF') THEN
       read(inp(i+1:ln),'(a)',err=20) upp3db
       call spstrunct(upp3db)
       l3db = lenstr(upp3db)
       print*, 'PDB entries deposited before: ',upp3db(1:l3db)
       call b3dbcmd('upper='//upp3db(1:l3db))
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'3DBLOW'.or.INP(1:6).EQ.'3DBAFT') THEN
       read(inp(i+1:ln),'(a)',err=20) low3db
       call spstrunct(low3db)
       l3db = lenstr(low3db)
       print*, 'PDB entries deposited after: ',low3db(1:l3db)
       call b3dbcmd('lower='//low3db(1:l3db))
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'3DBSEQ'.or.INP(1:6).EQ.'3DBFAS') THEN
       call redstrin(13,ln,inp(1:ln),npar)
       read(13,'(a)')
       read(13,'(a)') ev3db
       l3db = lenstr(ev3db)
       call b3dbcmd('ev='//ev3db)
       read(13,'(a)',err=20,end=20) inp0
       i0 = lenstr(inp0)
       if (inp0(1:1).eq.'@'.and.i0.ge.2) then
        call ccpdpn(8,inp0(2:i0),'old','F',0,0)
        lseq = 0
233	  read(8,'(a)',end=234) inp
        il = lenstr(inp)
        if (lseq.eq.0) then
         seq3db(1:il) = inp(1:il)
         seqold = seq3db
         lseq = il
        else
         seq3db = seqold(1:lseq)//inp(1:il)
         seqold = seq3db
         lseq= lseq + il
        end if
        goto 233
234	  continue
        close (8)
        print*,'3DB FASTA long sequence searching  ',inp0(2:i0)
        print*,'Total ',lseq,' residues'
        call b3dbcmd('fa='//seq3db(1:lseq))
       else if (i0.gt.0) then
        read(inp0(1:i0),'(a)') seq3db
        call b3dbcmd('fa='//seq3db(1:i0))
        print*, '3DB short FASTA sequence searching  ',seq3db(1:i0)
       else
        goto 20
       end if
c	 print*, 'PDB entries deposited after: ',low3db(1:l3db)
c       call b3dbcmd('lower='//low3db(1:l3db))
       GOTO 5
      END IF
c
      IF (INP(1:7).EQ.'3DBRESO') THEN
       call redstrin(13,ln,inp(1:ln),npar)	
       read(13,'(a)')
       if (npar.eq.2) then
        read(13,'(a)') reso3db
        lreso3db=lenstr(reso3db)
       else if (npar.gt.2) then
        ims = index(inp(i+1:ln),'-')
        if (ims.gt.0) then
          read(inp(i+1:ln),'(a)') reso3db
          call spstrunct(reso3db) 
          lreso3db=lenstr(reso3db)
        else 
          read(13,'(a)') inp
          i1 = lenstr(inp)
          read(13,'(a)') inp0
          i0 = lenstr(inp0)
c	    write(6,*) inp(1:i1),'-',inp0(1:i0)
          reso3db = inp(1:i1)//'-'//inp0(1:i0)
          lreso3db = i1+i0+1
        end if
       else
        goto 20
       end if
       print*, '3DB resolution range: ',reso3db(1:lreso3db)
       call b3dbcmd('rs='//reso3db(1:lreso3db))
       GOTO 5
      END IF
c
      IF (INP(1:8).EQ.'RESEARCH') THEN
       ISP = INDEX(INP,' ')
       call redstrin(13,ln-isp,inp(isp+1:ln),npar)
       read(13,'(a)') FILOUT
       IL = LENSTR(FILOUT)
       WRITE(6,'(2a)') ' Research all the structures in the same scop ',
     +    ' classification units listed in file '
       WRITE(6,'(1x,2a)') filout(1:il)
       if (npar.gt.1) then
        read(13,*) scut
       end if
       write(6,*) 'Threshold:',scut
       sthigh = scut
       call ccpdpn(40,filout(1:il),'old','F',0,0)
       nsc = 0
2210       read(40,'(a)',end=2220) inp
       nsc0 = nsc0 + 1
       if (nsc0.eq.1) then
        ndscop0=index(inp,'-pdb')
        istr0 = index(inp,'str.div.')
        if (ndscop0.eq.0) then
         write(6,*) 'Something wrong in the scop List file',filout(1:il)
         stop 'ERROR STOP'
        else if (istr0.eq.0) then
         write(6,*) 'Something wrong with str.div in the file'
         stop 'ERROR STOP'
        else 
         ndscop = ndscop0 - 6
         istr = istr0+8
         if (list.or.dump) then
          write(6,*) 'Length of the classification unit',ndscop
          write(6,*) 'region for strdiv ',inp(istr:istr+6)
         end if
        end if
       end if
       read(inp(istr:istr+6),'(f7.2)',err=2210) stn
c       if (list.or.dump) then
c        write(6,*) 'scop-',scopunit(nsc)(1:ndscop),
c      1  ' but skip ',scopskip(nsc),stn
c       end if
       if (stn.le.scut) then
        nsc = nsc + 1
        scopunit(nsc) = inp(6:ndscop0-1)
        scopskip(nsc) = inp(ndscop0+4:ndscop0+7)
       end if
       goto 2210
2220       continue
       write(6,*) 'Total ',nsc,
     +   ' scop classification units will be researched'
       if (list.or.dump) then
        do isc = 1, nsc
         write(6,'(4a)') 'scop-',scopunit(isc)(1:ndscop),
     +    ' but skip ',scopskip(isc)
        end do
       end if
       close (40)
       if (nsc.eq.0) then
        write(6,*) 'No structures will be re-searched'
        stop
       end if
       GOTO 5
2250       continue
       write(6,*) 'ERROR File for the re-search does not exist'
       stop 'ERROR STOP'
      END IF
c
      IF (INP(1:4).EQ.'KEYW') THEN
       NKEY = NKEY+1
       IL = LENSTR(INP)
       IS = INDEX(INP,' ')
       CALL getword(inp(is:il))
c	 print*,inp(is:il)
       IF (LIST.or.DUMP)
     1 WRITE(6,*) 'Check structures with keyword ',inp(is:il)
       GOTO 5
      END IF
c
      IF (INP(1:6).EQ.'NOSING'.OR.INP(1:4).EQ.'MULT') THEN
       SINGLE = .FALSE.
       IF (LIST)
     1 WRITE(6,*) 'New structure has multiple chains.'
       GOTO 5
      END IF
c
      IF (INP(1:4).EQ.'MOL1') THEN
       ISP = INDEX(INP,' ')
       indpdb=INDEX(INP,'pdb')
       i=isp
       do i=isp,indpdb
        if(inp(i:i).ne.' ') goto 2255
       enddo
 2255  continue 

       FILE1=INP(i:indpdb+2)
       call redstrin(13,ln-(indpdb+2),inp(indpdb+3:ln),npar)
       lnf1 = lenstr(file1)
       if ((lnf1.eq.8).and.(file1(5:8).eq.'@pdb')
     +                   .or.(file1(5:8).eq.'@PDB')) then
        call down(file1,lnf1)
        code1 = file1(1:4)
        print*, 'Browse ',code1,' from Protein Data Bank server'
        actbrs = bspdb(site,code1,file1)
        if (actbrs) then
         print*, code1,' has been browsed from ',site(1:lsite)
        else
         stop 'Error in browsing PDB'
        end if
       end if
       if (npar.ge.1) then
        file1z = file1
        read(13,'(a)') zonstr
        lz = lenstr(zonstr)
        call up(zonstr(1:lz),lz)
        write(6,'(2a)') 'The selected Zone of Mol1: ',zonstr(1:lz)
        call rangscop(file1,file1z,zonstr,nsel)
        if (nsel.eq.0) then
         write(6,*) 'No atoms in Mol1 after zone selection'
         stop 'ERROR STOP'
        end if
        zone1 = .true.
       else 
        zone1 = .false.
        file1z = ' '
       end if 
       GOTO 5
      END IF
c
60	FORMAT(1X,3F6.1,A,1X,A,1X,A)
C
      IF (INP(1:4).EQ.'MOL2') THEN
       CALL REDSTRIN(13,80,INP,NPAR)
       read(13,'(a)')
       if (npar.ge.2) then
        read(13,'(a)') LIBNAM
        llibnam = lenstr(libnam)
       else
        llibnam = 0
       end if
       IF (LIBNAM(1:1).NE.'@'.and.( (llibnam.gt.1).or.
     +       (llibnam.eq.1.and.(.not.pnet)) ) ) THEN
        MODE = 0
        LIB = .FALSE.
        ISP = INDEX(INP,' ')
        indpdb=INDEX(INP,'pdb')
        i=isp
        do i=isp,indpdb
         if(inp(i:i).ne.' ') goto 2256
        enddo
 2256   continue 

        FILE2=INP(i:indpdb+2)
        call redstrin(13,ln-(indpdb+2),inp(indpdb+3:ln),npar)
c        FILE2 = LIBNAM
        lnf2 = lenstr(file2)
        if (dump) write(6,*) 'Coordinate file for MOl2 '//
     +     libnam(1:llibnam)
        if ((lnf2.eq.8).and.(file2(5:8).eq.'@pdb')
     +                    .or.(file2(5:8).eq.'@PDB')) then
         call down(file2,lnf2)
         code2 = file2(1:4)
         print*, 'Browse ',code2,' from Protein Data Bank server'
         actbrs = bspdb(site,code2,file2)
         if (actbrs) then
          print*, code2,' has been browsed from ',site(1:lsite)
         else
          stop 'Error in browsing PDB'
         end if
        end if
        if (npar.ge.1) then
         file2z = file2
         read(13,'(a)') zonstr
         lz = lenstr(zonstr)
         call up(zonstr(1:lz),lz)
         write(6,'(2a)') 'The selected Zone of Mol2: ',zonstr(1:lz)
         call rangscop(file2,file2z,zonstr,nsel)
         if (nsel.eq.0) then
          write(6,*) 'No atoms in Mol2 after zone selection'
          stop 'ERROR STOP'
         end if
         zone2 = .true.
        else 
         zone2 = .false.
         file2z = ' '
        end if 
       ELSE IF (pnet.and.llibnam.lt.2) THEN
        call getidall(sit3db(1:lsit3db),libnam)
        if (dump) write(6,*) 'Get entry list from '//site(1:lsite)
        LIB = .TRUE.
        WRIT =.FALSE.
        ILIB = LENSTR(LIBNAM)
c	  OPEN (2,FILE=LIBNAM(1:ILIB),STATUS='OLD',READONLY)
        CALL CCPDPN(2,LIBNAM(1:ILIB),'READONLY','F',0,0)
        WRITE(6,*) 'library ',LIBNAM(1:ILIB),' is searched'
       ELSE IF (LIBNAM(2:6).EQ.'http:') then
        READ(libnam(2:ln-i),'(A)') site2
        call spstrunct(site2)
        il = lenstr(site2)
        call getidall(site2(1:il),libnam)
        LIB = .TRUE.
        WRIT =.FALSE.
        ILIB = LENSTR(LIBNAM)
        CALL CCPDPN(2,LIBNAM(1:ILIB),'READONLY','F',0,0)
        WRITE(6,*) 'Library ',LIBNAM(1:ILIB),' is searched'
       ELSE
        if (libnam(2:5).eq.'ftp:') then
         READ(libnam(2:ln-i),'(A)') site2
         call getlis(site2(1:ln-i-1),libnam)
        end if
        if (NPAR.GE.3.and.lndir.gt.0) then
         READ(13,'(A)',END=20) INP
         li = lenstr(inp)
         call up(inp(1:4),4)
         if (INP(1:2).eq.'ZO') then
          write(6,'(a)')
     +      ' Zone of each entry is specified in '//libnam(1:ilib)
          scop = .true.
         else if (INP(1:2).eq.'SC') then
          write(6,'(a)')
     +      ' Zone of each entry is specified in '//libnam(1:ilib)
          scop = .true.
          markfam = .true.
         else 
          write(6,'(a)') 'Unrecognized substring: '//inp(1:li)
         end if
        else
         scop = .false.
        end if
        LIB = .TRUE.
        WRIT =.FALSE.
        ILIB = LENSTR(LIBNAM)
        CALL CCPDPN(2,LIBNAM(2:ILIB),'READONLY','F',0,0)
        WRITE(6,*) 'Library ',LIBNAM(1:ILIB),' is searched'
       END IF
       GOTO 5
      END IF
c
      IF (INP(1:4).EQ.'MAKE') THEN
       CALL REDSTRIN(13,80,INP,NPAR)
       READ(13,'(A)',ERR=20)
       READ(13,'(A)',ERR=20) VECNAM
       if (NPAR.GT.2) then
        READ(13,'(A)',END=20) LIBNAM
        libnam0 = libnam
        ILIB = LENSTR(LIBNAM)
        if (NPAR.GT.3) then
         READ(13,'(A)',END=20) INP
         li = lenstr(inp)
         call up(inp(1:4),4)
         if (INP(1:2).eq.'ZO') then
          write(6,'(a)')
     +      ' Zone of each entry is specified in '//libnam(1:ilib)
          scop = .true.
         else if (INP(1:2).eq.'SC') then
          write(6,'(a)')
     +      ' Zone of each entry is specified in '//libnam(1:ilib)
          scop = .true.
          markfam = .true.
         else 
          write(6,'(a)') 'Unrecognized substring: '//inp(1:li)
         end if
        else
         scop = .false.
        end if
       ELSE
        ILIB = 0
       END IF
       ILIB1 = LENSTR(VECNAM)
       CALL CCPDPN(9,VECNAM(1:ILIB1),'UNKNOWN','F',0,0)
       if ((pnet.and.npar.lt.2).or.ilib.lt.2) then
        call getidall(sit3db(1:lsit3db),libnam)
        write(6,*) 'Get entry list from '//site(1:lsite)
        ILIB = LENSTR(LIBNAM)
        libnam0 = libnam
       else if (libnam(1:5).eq.'@ftp:') then
        READ(libnam(2:ilib),'(A)') site2
        call getlis(site2(1:ilib-1),libnam)
        ILIB = LENSTR(LIBNAM)
       else if (libnam(1:5).eq.'http:') then
        READ(libnam(1:ilib),'(A)') site2
        write(6,'(a)') 'Get the PDB list from site: '//site2(1:ilib)
        call getlist(site2(1:ilib),libnam)
        ILIB = LENSTR(LIBNAM)
       else if (libnam(1:4).eq.'ftp:') then
        READ(libnam(1:ilib),'(A)') site2
        if (site2(ilib:ilib).eq.char(47)) then
         write(6,'(a)') 'Search all the files in '//site2(1:ilib)
         call getentidx(site2(1:ilib),libnam)
         ILIB = LENSTR(LIBNAM)
        else
         write(6,'(a)') 'Get the PDB list from '//site2(1:ilib)
         call getlist(site2(1:ilib),libnam)
         ILIB = LENSTR(LIBNAM)
        end if
       end if
       CALL CCPDPN(2,LIBNAM(1:ILIB),'READONLY','F',0,0)
       MODE = 1
       LIB = .TRUE.
       CALL CCPDAT(DAT)
       WRITE(9,'(3A)') 'REMARK SSE database compressed from '//
     +   'Protein Data Bank',
     +   ' -- Date: ', DAT
c	 if (scop) then
        ilib0=lenstr(libnam0)
        WRITE(9,'(3A)') 'REMARK From List file: ',libnam0(1:ilib0)
c	 end if
       WRITE(6,'(2a)') ' Read a list file: ',libnam(1:ilib)
       WRITE(6,'(2a)') ' and make a SSE library ',vecnam(1:ilib1)//
     +    ' without comparison'
c	 WRITE(6,'(a)') '   without comparison'
       goto 5
      end if
c
      IF (INP(1:4).EQ.'GETV'.OR.INP(1:4).EQ.'MOLV') THEN
       CALL REDSTRIN(13,80,INP,NPAR)
       READ(13,'(A)')
       READ(13,'(A)') LIBNAM
       ILIB = LENSTR(LIBNAM)
       MODE = 2
       LIB = .TRUE.
       if (lndir.gt.0) FIT = .FALSE.
       WRIT =.FALSE.
       CALL CCPDPN(9,LIBNAM(1:ILIB),'UNKNOWN','F',0,0)
       WRITE(6,'(3a)') 'Read SSE library: ',libnam(1:ilib),
     1  ' and perform the comparison'
       goto 5
      end if
c
      IF (INP(1:4).EQ.'OMAT') THEN
       CALL REDSTRIN(13,80,INP,NPAR)
       READ(13,'(A)')
       READ(13,'(A)') LIBNAM
       ILIB = LENSTR(LIBNAM)
       CALL CCPDPN(10,LIBNAM(1:ILIB),'UNKNOWN','F',0,0)
       WRITE(6,'(3a)') 'Matrix for the O program will be written to',
     1 LIBNAM(1:ILIB)
       goto 5
      END IF
      if (inp(1:3).eq.'END') goto 10
c
20	WRITE(6,*) 'UNKNOWN COMMAND:',INP
      GOTO 5
C	STOP 'ERROR STOP'
10	CONTINUE
c
c check if you need 3db browsing
c
      if (lsit3db.gt.0.and.(l3db.gt.0.or.lhet3db.gt.0.or.
     +  lkey3db.gt.0.or.ltext3db.gt.0.or.lreso3db.gt.0) ) then
       print*, 'Searching PDB entries from 3DB browser..'
       libnam='3db.list'
       call b3dbgo(libnam(1:8))
       ILIB = 8
       mode = 0
       lib=.true.
       net = .true.
       if (lsite.eq.0) site = sit3db
       print*, 'Please check '//libnam(1:8)
     +    //' to see if there are missing structures if necessary'
       CALL CCPDPN(2,LIBNAM(1:ILIB),'READONLY','F',0,0)
      end if
C
c -- Get vector of Molecule 1
c
      if (MODE.NE.1) then
      sndass = ass1
       sndf = sndf1
       MOLWARN = 1
       if (zone1) then
        CALL ALFBTA(file1z,NSND1,XSND1,SNDNAME1,ESND1,NST1,NEND1)
       else
        CALL ALFBTA(FILE1,NSND1,XSND1,SNDNAME1,ESND1,NST1,NEND1)
       end if
       if (NSND1.lt.2) then
        write(6,'(2a)') 'ERROR -- the number of SSEs less than 2,',
     +     ' not able to process '
        stop 'ERROR STOP'
       end if
         if (nmr) then
          open(11,err=214,status='unknown')
         end if
       WRITE(11,'(A,I4,I3)')'.snd1                    t    '
     +      ,2*NSND1+3,31
       write(11,'(a)') 'begin snd1'
       write(11,'(a)') 'colour    16711680'
       DO I =1, NSND1
        write(11,210) 'M',(XSND1(J,1,I),J=1,3)
        write(11,210) 'L',(XSND1(J,2,I),J=1,3)
       END DO
       write(11,'(a)') 'end_object'
          if (nmr) then
           close(11)
           nmr=.false.
          end if
214      continue
      end if
210	FORMAT(A,3F10.5)
C
c -- Get vector of Molecule 2
c
      if (.not.lib) then
        sndass = ass2
        sndf = sndf2
        MOLWARN = 2
        if (zone2) then
         CALL ALFBTA(FILE2Z,NSND2S,XSND2S,SNDNAME2S,ESND2S,NST2S,NEND2S)
        else
         CALL ALFBTA(FILE2,NSND2S,XSND2S,SNDNAME2S,ESND2S,NST2S,NEND2S)
        end if
        if (NSND2S.lt.2) then
         write(6,'(2a)') 'Warning -- the number of SSEs less than 2 ',
     +      '-- skipped'
         stop 'ERROR STOP'
        end if
        WRITE(12,'(A,I4,I3)')'.snd2                    t    '
     1  ,2*Nsnd2S+3,31
        write(12,'(a)') 'begin snd2'
        write(12,'(a)') 'colour    255'
        DO I =1, Nsnd2S
         write(12,210) 'M',(XSND2S(J,1,I),J=1,3)
         write(12,210) 'L',(XSND2S(J,2,I),J=1,3)
        END DO
        write(12,'(a)') 'end_object'
      end if
C
5010	CONTINUE
c
c MODE = 0	Read PDB and do the comparison
c MODE = 1	Read PDB and make a vector library file
c MODE = 2	Read a vector library file and do the comparison.
c
      IF (LIB) THEN
       IF (MODE.EQ.1.OR.MODE.EQ.0) THEN
5020	  READ(2,'(A)',END=5000) inp
        isp = index(file2a,' ')
        if (isp.eq.1) goto 5020
        il = lenstr(inp)
        CALL REDSTRIN(13,80,INP,NPAR)	  
        read(13,'(a)') file2a
c5020	  READ(2,'(A)',END=5000) FILE2A
        if (dump) write(6,*) file2a
        if (file2a(1:1).eq.'!'.or.file2a(1:1).eq.' ') goto 5020
        LN2 = LENSTR(FILE2A)
        lnf2 = ln2
        if (net) then
         if (ichar(file2a(1:1)).le.48.or.ichar(file2a(1:1)).gt.57)
     +     goto 5020
         call down(file2a,lnf2)
         if (file2a(1:3).eq.'pdb') then
          code2 = file2a(4:7)
          file2b=file2a(1:7)
          ln2 = 7
         else
          code2 = file2a(1:4)
          file2b = 'pdb'//code2//'.ent'
          ln2 = 11
         end if
c	   print*, 'Browse ',code2,' from Protein Data Bank server'
         if (lndir.eq.0) then
          actbrs = bspdb(site,code2,file2)
          if (actbrs) then
           print*, code2,' has been browsed from ',site(1:lsite)
          else if (lib) then
           print*, 'ERROR: can not get '//code2//' from the website'
           goto 5020
          else
           stop 'Error in PDB browsing'
          end if
         else
          if (curr) then
           file2(lndir+1:lndir+3) = code2(2:3)//char(47)
          end if
          if (dump) print*, file2(1:lndir+ln2+ncurr)
          FILE2(LNDIR+1+ncurr:LNDIR+LN2+ncurr) = FILE2B(1:LN2)
          FILE2(LNDIR+LN2+1+ncurr:80) = SPS(1:80-(LNDIR+LN2+ncurr))
          CALL SPSTRUNCT(FILE2(1:lndir+ln2+ncurr))
          if (list) print*, file2(1:lndir+ln2+ncurr)
         end if
        else
         lfil2 = lenstr(file2a)
         if (lndir.eq.0) then
          file2 = file2a
         else if (curr) then
          if (file2a(1:3).eq.'pdb'.and.lfil2.eq.11) then
           code2 = file2a(4:7)
           file2b=file2a(1:7)
           ln2 = 7
          else 
           code2 = file2a(1:4)
           file2b = 'pdb'//code2//'.ent'
           ln2 = 11
          end if 
          if (ichar(code2(1:1)).gt.48.and.ichar(code2(1:1)).lt.58) then
           file2=dirname(1:lndir)//code2(2:3)//char(47)//file2b
          else
c	     write(6,'(a)') 'Warning: '//code2//' is a PDB code with data'
           goto 5020
          end if
          if (list) print*, file2(1:lndir+ln2+ncurr)
         else
          if ((nadd1.eq.0.and.nadd2.eq.0).or.
     +        (file2a(1:3).eq.'pdb'.and.file2a(9:11).eq.'ent').or.
     +         index(file2a,'/').ne.0) then
           file2=dirname(1:lndir)//file2a(1:lfil2)
          else if (nadd1.gt.0) then
           code2 = file2a(1:4)
           call down(code2,4)
           file2=dirname(1:lndir)//nameadd1(1:nadd1)//
     +		code2//nameadd2(1:nadd2)
          else 
           code2 = file2a(1:4)
           call down(code2,4)
           file2=dirname(1:lndir)//code2//nameadd2(1:nadd2)
          end if
         end if
        end if
c	  print*, 'File used: ',file2
        if (scop) then
         if (npar.gt.1) then
          read(13,'(a)') zonstr
          lz = lenstr(zonstr)
          if (lz.eq.1.and.zonstr(1:1).eq.'-') then
           zone2 = .false.
           write(6,'(2a)') ' All the residues are selected'
          else
           call up(zonstr(1:lz),lz)
           write(6,'(2a)') ' The selected Zone of Mol2: ',zonstr(1:lz)
           call rangscop(file2,file2z,zonstr,nsel)
           if (nsel.eq.0) then
            write(6,*) 'No atoms in Mol1 after zone selection'
            goto 5020
           end if
           zone2 = .true.
          end if
C Here get family mark 
          if (npar.gt.2) then
           read(13,'(a)') fam
           if (dump.or.list) write(6,*) 'Family mark:'//fam
          end if
         else
          print*, 'Warning: No zone specified:',inp(1:il)
          file2z = ' '
          zone2 = .false.
         end if
        else
         file2z = ' '
         zone2 =.false.
         file2z = ' '
        end if
        NSTR = NSTR + 1
c	  CALL CCPDPN(1,FILE2(1:LNDIR+LN2),'READONLY','F',0,0)
        sndass = ass2
        sndf = sndf2
        MOLWARN = 2
c
C for some strange reason I have to test if the file exists first
        lff2 = lenstr(file2)
c	  OPEN (41,FILE=FILE2(1:lff2),STATUS='OLD',READONLY,err=343)
        CALL CCPDPN(41,FILE2(1:lff2),'READONLY','F',0,0)
        close (41)
        goto 344
343	  continue
        write(6,'(2a)') 'ERROR: can not open file:',  FILE2(1:lff2)
        goto 5020
344	  continue
        if (zone2) then
         CALL ALFBTA(FILE2Z,NSND2S,XSND2S,SNDNAME2S,ESND2S,NST2S,NEND2S)
         if (file2z.ne.file2) then
c	    open(20,file=file2z,status='unknown',disp='delete')
          CALL CCPDPN(20,file2z,'UNKNOWN','F',0,0)
          close(20,status='delete')
c	    cmd2='rm '//file2z
c	    lcmd = lenstr(cmd2)
c	    call ccpspw(cmd2(1:lcmd))
c	    print*,'executed command:  cmd2(1:lcmd)'
         end if
        else
         CALL ALFBTA(FILE2,NSND2S,XSND2S,SNDNAME2S,ESND2S,NST2S,NEND2S)
        end if
        if (NSND2S.lt.2) then
         write(6,'(2a)') 'Warning -- the number of SSEs less than 2 ',
     +     '-- skipped'
         if (actbrs) then
          CALL CCPDPN(20,file2,'UNKNOWN','F',0,0)
          close(20,status='delete')
         end if
         goto 5010
        end if
        IF (ERR) THEN
         ERR = .FALSE.
         WRITE(6,*) '>>>ERROR STOP'
         if (actbrs) then
c	    print*, 'delete the browsed file ',file2
          call ccpdpn(20,file2,'scratch','F',0,0)
          close(20)
          cmd2='rm '//file2
c	    lcmd = lenstr(cmd2)
c	    call ccpspw(cmd2(1:lcmd))
c	    print*,'executed command:  cmd2(1:lcmd)'
         end if
c	   WRITE(9,'(4A)') 'ENTRY ',FILE2A(1:LN),
c     +          '    -- Entry_Zone: ',zonstr
c	   WRITE(9,'(A,I5)') 'NSND  ',0
         GOTO 5020
        END IF
        IF (MODE.EQ.1) THEN
c	   CALL MAKEVEC(NSND2S,XSND2S,SNDNAME2S,ESND2S,NST2S,NEND2S)
         if (net) then
c	    WRITE(9,'(2A)') 'ENTRY ',CODE2
          if (markfam) then
           lfam = lenstr(fam)
           WRITE(9,'(4A)') 'ENTRY ',CODE2,'  -- Entry_Zone: ',zonstr
           WRITE(9,'(2A)') 'CLASS ',fam(1:lfam)
          else
           WRITE(9,'(2A)') 'ENTRY ',CODE2
          end if
         else
          ln = lenstr(file2a)
          call nodir(file2a,obj2,nobj2)
c	    WRITE(9,'(2A)') 'ENTRY ',obj2(1:nobj2)
          if (markfam) then
           lfam = lenstr(fam)
           WRITE(9,'(4A)') 'ENTRY ',obj2(1:nobj2),
     +          '  -- Entry_Zone: ',zonstr
           WRITE(9,'(2A)') 'CLASS ',fam(1:lfam)
          else
           WRITE(9,'(2A)') 'ENTRY ',obj2(1:nobj2)
          end if
         end if
c	   WRITE(9,'(2A)') 'ENTRY ',FILE2A(1:LN)
         REWIND (13)
         DO I = 1, NCOMP
          READ(13,'(A)') INP
          WRITE(9,'(A)') INP(1:LENSTR(INP))
         END DO
         WRITE(9,'(A,I5)') 'NSND  ',NSND2S
         DO I = 1, NSND2S
          WRITE(9,215) ESND2S(i),SNDNAME2S(i),NST2S(I),NEND2S(I),
     1   (XSND2S(J,1,I),J=1,3),(XSND2S(J,2,I),J=1,3)
215	    FORMAT(A,1X,A,1X,A,1X,A,2(1X,3F6.1))
         END DO
         if (actbrs) then
c	    print*, 'delete the browsed file ',file2
          call ccpdpn(20,file2,'scratch','F',0,0)
          close(20)
         end if
         NVEC = NVEC + 1
         GOTO 5020
        END IF
c	  INQUIRE (1,NAME=FILE2)
        CLOSE (1)
       ELSE IF (MODE.EQ.2) THEN
c	  CALL GETVEC(NSND2S,XSND2S,SNDNAME2S,ESND2S,NST2S,NEND2S)
        if (nkey.gt.0) skip = .true.
        if ((net.or.lndir.gt.0).and.lstres.gt.0) then
         fit=.true.
        else
         fit = .false.
        end if
        fam = ' '
        llfam = 0
5030	  READ(9,'(a)',end=5000) INP
c
        ln = lenstr(inp)
c
        if (inp(1:4).eq.'REMA') then
         if (nsc.eq.0.or.list.or.dump) write(6,'(a)') inp(1:ln)
         goto 5030
        end if
c
        if (inp(1:4).eq.'CLAS') then
         if (nsc.eq.0.or.list.or.dump) write(6,'(a)') inp(1:ln)
         fam = inp(7:ln)
         llfam = ln-6
         lcomp = min(llfam,ndscop)
         if (nsc.gt.0) then
          do isc = 1, nsc
c	     ifit = index(fam(1:llfam),scopunit(isc)(1:ndscop))
c	     if (ifit.gt.0) then
           if (scopunit(isc)(1:lcomp).eq.fam(1:lcomp)) then
            skip = .false.
            write(6,'(2a)') 'ENTRY ',code2
            write(6,'(2a)') 'CLASS ',fam(1:llfam)
cv            if (dump) then
cv             write(6,*) fam(1:llfam),ifit,scopunit(isc)(1:ndscop)
cv            end if
            if (scopskip(isc).eq.code2) then
             write(6,'(2a)') 'PDB entry already searched, skip'
             skip = .true.
            end if
            goto 5030
           end if
          end do
          skip = .true.
          goto 5030
         end if
         goto 5030
        end if
c
        if (inp(1:4).eq.'ENTR') THEN
         fbrows = .false.
         NSTR = NSTR + 1
         call redstrin(13,ln-6,INP(7:ln),npar)
         read(13,'(a)') file2a
c	   file2a(1:ln-6) = inp(7:ln)
         ln2 = lenstr(file2a)
c	   file2(1:ln-6) = inp(7:ln)
         if (file2a(1:3).eq.'pdb') then
          code2=file2a(4:7)
          if (nsc.eq.0.or.list.or.dump) write(6,'(2a)') 'ENTRY ',code2
         else if (ichar(file2a(1:1)).GT.48.or.
     +              ichar(file2a(1:1)).LE.57) then
          code2=file2a(1:4)
          if (nsc.eq.0.or.list.or.dump) write(6,'(2A)') 'ENTRY ',code2
         else
          print*,'Cannot browse',file2a(1:ln-6)
          skip = .true.
         end if
         IF (LNDIR.GT.0.and.fit) THEN
          if (curr) then
           file2(lndir+1:lndir+3) = code2(2:3)//char(47)
           FILE2 = 'p(LNDIR+1+ncurr:80)db'//code2//'.ent'
          else if (NADD1.gt.0.and.NADD2.gt.0) then
           FILE2(LNDIR+1:LNDIR+nadd1+nadd2+5) = 
     +        NAMEADD1(1:NADD1)//code2//NAMEADD2(1:NADD2)
          else
           FILE2(LNDIR+1+ncurr:LNDIR+LN2+ncurr) = FILE2A(1:LN2)
           FILE2(LNDIR+LN2+1+ncurr:80) = SPS(1:80-(LNDIR+LN2+ncurr))
          end if
          CALL SPSTRUNCT(FILE2(1:lndir+ln2+ncurr))
         else
          file2(1:ln-6) = inp(7:ln)
          do iln = ln-5 , 80
           file2(iln:iln) = ' '
          end do
         end if
         goto 5030
        END IF
c
        if (inp(1:4).eq.'COMP'.or.inp(1:4).eq.'TITL') then
         if (nsc.eq.0.or.(.not.skip).or.list.or.dump) then
          write(6,'(a)') INP(1:ln)
         end if
C - to see whether the keyword is located
         if (nkey.gt.0) then
          call findword(inp(8:ln),fw)
          if (fw) skip = .false.
         end if
         goto 5030
        end if
C
        if (inp(1:4).eq.'NSND') THEN
         READ(INP(5:LN),*) NSND2S
         IF (NSND2S.EQ.0.and.nsc.eq.0) THEN
          WRITE(6,'(3A)') 'Warning: ',file2(1:8),' has no ',
     1 'secondary structure ',
     1 'alignment'
          goto 5030
         END IF
         nhlx = 0
         nbta = 0
         DO I = 1, NSND2S
          READ(9,215,err=5040) ESND2S(i),SNDNAME2S(i),
     1   NST2S(I),NEND2S(I),
     2   (XSND2S(J,1,I),J=1,3),(XSND2S(J,2,I),J=1,3)
          if (esnd2s(i).eq.'a') nhlx = nhlx + 1
          if (esnd2s(i).eq.'b') nbta = nbta + 1
         END DO
c         ln = lenstr(file2)
         if (nsc.eq.0.or.(.not.skip).or.list.or.dump) 
     1    write(6,'(2(i5,a),a)') 
     2    nhlx,' helixes',nbta,' strands from entry '
     3   ,code2
        end if
       END IF
      END IF
c
      if (skip) then
       if (nsc.eq.0.or.list.or.dump) then
        write(6,*) 'SKIP ',file2(1:ln),' -- key words not found'
       end if
        nskip = nskip + 1
c	  write(6,*)
       goto 5010
      END IF
c reset 
      NMATCH = 0
      NOFM = 0
      MAXTOP=1
      MAXTOPO=1
      sdsmin = 99999.
      itotmax = 0
      tdsmin = 99999.
      MREAL0MAX = 0
c	 
      call nodir(file2,obj2,nobj2)
      call nodir(file1,obj1,nobj1)
      ofm(1:47)='.LSQ_RT_S                 R         12 (3F10.5)'
       iobj2 = index(obj2(1:nobj2),'.pdb') - 1
       if (iobj2.le.0) iobj2 = nobj2
       if (iobj2.gt.7) iobj2 = 7
       ofm(9:8+iobj2) = obj2(1:iobj2)
       call up(ofm(9:8+iobj2),iobj2)
C
C CHECK THE NUMBER OF CHAINS IN OLD STRUCTURE
C
      IF (SINGLE) THEN
       NCH = 0
       IST = 1
120	 DO I = IST+1, NSND2S
        IF (NST2S(I)(1:1).NE.NST2S(I-1)(1:1)) GOTO 110
       END DO
       I = NSND2S + 1
110	 NCH = NCH + 1
       ICHS(NCH) = IST
       ICHE(NCH) = I - 1
       IF (I.LT.NSND2S) THEN
        IST = I
        GOTO 120
       END IF
      ELSE
       NCH = 1
       ICHS(1) = 1
       ICHE(1) = NSND2S
      END IF
C
C	IF (DUMP) THEN
       WRITE(6,*) NCH,' chains in Mol2 '
C	END IF
C
C align the structure
      DO 4000 ICH = 1, NCH
c
      NSND2 = ICHE(ICH) - ICHS(ICH) + 1
      if (NSND2.LT.2) THEN
       WRITE(6,*) 'Chain ',
     +    NST2S(ICHS(ICH))(1:1),': SSE less than 2, skipped'
       goto 4000
      END IF
C	IF (DUMP) THEN
       WRITE(6,*) 'Chain ',NST2S(ICHS(ICH))(1:1),' Nr',ICH,NSND2
C	END IF
c
c Here I set up the NRMCH in auto mode
      if (auto) then
       if (lib) then
        NRMCH0 = MIN(NSND1,MAX(INT(float(nsnd1)*rat1+0.5),2))
       else
        NRMCH0 = 
     + MIN(NSND1,NSND2,MAX(INT(float(min(nsnd1,nsnd2))*rat1+0.5),2))
       end if
       if (list.or.dump) 
     +    write(6,*) 
     +    'minimum number for matching secondary structure',NRMCH0
       NRMCH = NRMCH0
      end if
c
      CALL ARRGIVE(NSND2*6,XSND2S(1,1,ICHS(ICH)),XSND2)
      DO I = 1, NSND2
       IS = I + ICHS(ICH) - 1
       SNDNAME2(I) = SNDNAME2S(IS)
       ESND2(I) = ESND2S(IS)
       NST2(I) = NST2S(IS)
       NEND2(I) = NEND2S(IS)
       IF (DUMP) THEN
        write(6,55) 'Nr.',i,namsnd(esnd2(i)),': ',nst2(i),' - '
     1, nend2(i),' name ',sndname2(i)
     2, ((xsnd2(i1,i2,i),i1=1,3),i2=1,2)
       END IF
      END DO	 	   
55	format(1x,a,i3,7a,6f6.1)
C
      MAXMATCH = MIN(NSND1,NSND2)
      IF (MAXMATCH.LT.NRMCH) GOTO 4000
c	MAXTOP = 1
      RANGMAX = 0.
C
      NSTART1 = 0
      NSTART2 = 0
      MATCH = 0
      IADD = - 1
c
1010	MATCH = MATCH + 1
      MAXTOP = MAX(MATCH-1,MAXTOP)
      IADD = IADD + 1
      IF (IADD.GT.1) IADD = 1
      IF (MATCH.GE.2) NSTART1 = IM1(MATCH-1) 
      IF (NSTART1.GE.NSND1) GOTO 2010
      IM1(MATCH) = NSTART1
1020	IM1(MATCH) = IM1(MATCH) + 1
      I1 = IM1(MATCH)
C
      CALL ARRGIVE(3*2,XSND1(1,1,I1),XMCH1(1,1,MATCH))
      CALL ARRPS(3,1,XSND1(1,2,I1),XSND1(1,1,I1),XSE1(1,MATCH) )
C
1025   CONTINUE
       DM1 = 0.
       D1 = 0.        
       IF (MATCH.GE.2) THEN
       CALL AVERG(3,2*MATCH,XMCH1,CEN1)
       CALL TMOVE(3,2*MATCH,XMCH1,CEN1,-1.,XMH1)
       DO I = 1, MATCH
        DM1 = DM1 + VEM(3,XMH1(1,(I-1)*2+1) )
        DM1 = DM1 + VEM(3,XMH1(1,(I-1)*2+2) )
       END DO
       DM1 = DM1/(MATCH*2) 
       D1 = DM1 * WANG
C
      END IF
C
      DO I = 1, MATCH
       CALL ARRMC(3,1,XSE1(1,I),D1/VEM(3,XSE1(1,I))
     1 ,XMH1(1,MATCH*2+I))
      END DO
C	 CALL ARRGIVE(3*MATCH,XSE1(1,1),XMH1(1,MATCH*2+1))
C
      IF (MATCH.GE.2) THEN
       NSTART2 = IM2(MATCH-1) 
      ELSE
       NSTART2 = 0
      END IF
      IF (NSTART2.GE.NSND2) GOTO 2020
      IM2(MATCH) = NSTART2
1030	IM2(MATCH) = IM2(MATCH) + 1
      I1 = IM1(MATCH)
      I2 = IM2(MATCH)
c	if (dump) then
c	 WRITE(6,*) 'MATCH ,I1,I2',MATCH,I1,I2,ESND1(I1),ESND2(I2)
c	 WRITE(6,*) 'IM1',(IM1(J),J=1,MATCH)
c	 WRITE(6,*) 'IM2',(IM2(J),J=1,MATCH)
c	end if
      IF (ESND1(I1).NE.ESND2(I2)) then
       IF (DUMP) THEN
        WRITE(6,*) 'IM1',esnd1(i1),(IM1(J),J=1,MATCH)
        WRITE(6,*) 'IM2',esnd2(i2),(IM2(J),J=1,MATCH)
       END IF
       GOTO 2030
      end if
c
      if (esnd1(i1).eq.'a') then
       ie(match) = 1
      else if (esnd1(i1).eq.'b') then
       ie(match) = 2
      else 
       write(6,*) 'Strange element ',ESND1(I1),ESND2(I2),I1,I2
      end if
C
      CALL ARRGIVE(3*2,XSND2(1,1,I2),XMCH2(1,1,MATCH))
      CALL ARRPS(3,1,XSND2(1,2,I2),XSND2(1,1,I2),XSE2(1,MATCH) )
      if (VEM(3,XSE2(1,MATCH)).lt.1.e-2) goto 2030
C
      IF (MATCH.EQ.1) GOTO 1010
       CALL AVERG(3,2*MATCH,XMCH2,CEN2)
       CALL TMOVE(3,2*MATCH,XMCH2,CEN2,-1.,XMH2)
       DM2 = 0.
       DO I = 1, MATCH
        DM2 = DM2 + VEM(3,XMH2(1,(I-1)*2+1) )
        DM2 = DM2 + VEM(3,XMH2(1,(I-1)*2+2) )
       END DO
       DM2 = DM2/(MATCH*2)
       D2 = DM2 * WANG
c	WRITE(6,*)'D2',D2
C
       IF (ABS(DM2-DM1).GT.ERRDMM) THEN
        IF (DUMP) THEN
         WRITE(6,*) 'IM1',(IM1(J),J=1,MATCH)
         WRITE(6,*) 'IM2',(IM2(J),J=1,MATCH)
         WRITE(6,*)'DM1,DM2',DM1,DM2
        END IF
        GOTO 2030
       ELSE IF (DUMP) THEN
        WRITE(6,*)'DM1,DM2,DETA--',DM1,DM2,ABS(DM2-DM1)
       END IF
C
      DO I = 1, MATCH
c	 if (dump) then
c	  write(6,*) '|xse2|',VEM(3,XSE2(1,I))
c	 end if
       CALL ARRMC(3,1,XSE2(1,I),D1/VEM(3,XSE2(1,I))
     1 ,XMH2(1,MATCH*2+I) )
      END DO
C	 CALL ARRGIVE(3*MATCH,XSE2(1,1),XMH2(1,MATCH*2+1))
C
C	IDD = MATCH*(MATCH-1)/2
c Compute the initial matrix.
      IF (MATCH.EQ.2) THEN
C	 CALL ORIEN1(3*MATCH+IDD,XMH2,XMH1,ROT)
       CALL ORIEN1(2*MATCH,XMH2,XMH1,ROT)
      ELSE
C	 CALL ORIEN1(2*(MATCH-1),XMH2,XMH1,ROT)
       CALL ARRGIVE(9,ROTOLD,ROT)
      END IF	 

C Refine the orientation by vector method.
C
C	CALL REFTOP ( 3*MATCH+IDD, XMH2, XMH1, ROT, VT, DIS)
C	CALL REFTOP ( 2*MATCH , XMH2, XMH1, ROT, VT, DIS)
C
      SWD = 0
      DO I = 1, MATCH
       CALL ARRMC(3,2,XMH1(1,2*I-1),REFW(IE(I)),XTP1(1,2*I-1))
       CALL ARRMC(3,2,XMH2(1,2*I-1),REFW(IE(I)),XTP2(1,2*I-1))
       SWD = SWD + REFW(IE(I))*2
      END DO 
      SWA = 0
      DO I = 1, MATCH
      CALL ARRMC(3,1,XMH1(1,2*MATCH+I),REFW(IE(I)),XTP1(1,2*MATCH+I))
      CALL ARRMC(3,1,XMH2(1,2*MATCH+I),REFW(IE(I)),XTP2(1,2*MATCH+I))
       SWA = SWA + REFW(IE(I))
      END DO
       IF (DUMP) THEN
        do jk2 = 1,match
         write(6,*) (xtp1(jk1,jk2),jk1=1,3),'xtp1'
         write(6,*) (xtp2(jk1,jk2),jk1=1,3),'xtp2'
        end do
       END IF
      CALL REFTOP ( 3*MATCH , XTP2, XTP1, ROT, VT, DIS)
C	CALL REFTOP ( 3*MATCH , XMH2, XMH1, ROT, VT, DIS)
      RMSA = SQRT( DOSQ(3*2*MATCH,DIS)/SWD )
c	RMSANG=SQRT(DOSQ(3*(MATCH+IDD),DIS(3*2*MATCH+1))/(MATCH+IDD))
       IF (DUMP) THEN
        WRITE(6,*) 'MATCH: ',MATCH,'I1,I2,--',I1,I2
        WRITE(6,*) 'IM1-',(IM1(J),J=1,MATCH)
        WRITE(6,*) 'IM2-',(IM2(J),J=1,MATCH)
        WRITE(6,*) 'RMSA:',RMSA,'   CYCLE',NREF
C	  WRITE(6,*) 'CEN1',CEN1
C	  WRITE(6,*) 'CEN2',CEN2
       END IF
      IF (RMSA.GT.ERRRMSA) GOTO 2030
C	WRITE(6,*) 'RMSANG:',RMSANG
C	RMSANG=RMSANG/D1
C	RANG = 2.* ASIND(RMSANG/2.)
C	WRITE(6,*) 'RANG',RANG
C	IF (RANG.GT.ERRANG) GOTO 2030
C
      RANGMAX = 0.
      RALL = 0
C	DO I = 3*2*MATCH+1, 3*3*MATCH,3
      DO IME = 1, MATCH
       I = 3*IME + 3*2*MATCH - 2
C	 RANG = 2.* ASIND( VEM(3, DIS(I) )/2./D1 )
       RANG = VEM(3, DIS(I) )/(2.*D1*REFW(IE(IME)))
       IF (RANG.GT.1.) THEN
        IF (DUMP) WRITE(6,*)'Warning: arcsin(R)=',RANG,' Set to 1'
        RANG = 1.
       ELSE IF (RANG.LT.0) THEN
        WRITE(6,*)'Warning: arcsin(R)=',RANG,' Set to 0'
        RANG = 0.
       END IF
       RANG= 2.* ASIND( RANG )
       RALL = RALL + RANG
       RANGMAX = MAX(RANGMAX,RANG)
       IF (DUMP) THEN
        WRITE(6,*) 'MATCH',IME,'  ANGLE FIT:',RANG,(DIS(I+J),J=0,2)
       END IF
       IF (RANG.GT. ERRANG(IE(IME)) ) GOTO 2030
      END DO
       RALL = RALL/MATCH
      IF (DUMP) THEN
       WRITE(6,*)'Mean direction error = ',RALL,' Max:',RANGMAX
      END IF
      IF (RALL.GT.MAXANG) GOTO 2030
C
C
      CALL MATMULT(3,3,3,MATCH*2,ROT,XMH2,XMH1C)
C
      DLLMAX = 0.
      DALL = 0
      DO I = 1, MATCH
       DLL = abs(DSTLL2( XMH1(1,(2*(I-1)+1)), XMH1(1, (2*(I-1)+2) ),
     1 XMH1C(1,(2*(I-1)+1) ),XMH1C(1,(2*(I-1)+2)) ))
       DALL = DALL + DLL
       DLLMAX = MAX(DLL,DLLMAX)
       IF (DUMP) THEN
        WRITE(6,*) 'LINE-LINE DISTANCE',DLL
       END IF
      IF (DLL.GT.ERRDLL(IE(I))) GOTO 2030
      END DO
c
      DALL = DALL/MATCH
      if (dump) then
       WRITE(6,*)'MEAN L-L DISTANCE:',DALL,' Max:',DLLMAX
      end if
      IF (DALL.GT.MAXDLL) GOTO 2030
C
      CALL ARRGIVE(9,ROT,ROTOLD)
      CALL ARRGIVE(3,CEN1,CEN1OLD)
      CALL ARRGIVE(3,CEN2,CEN2OLD)
      RMSAOLD = RMSA
      RALLOLD = RALL
      RANGMAXO = RANGMAX
      DALLOLD = DALL
      DLLMAXO = DLLMAX
C
      if (match.lt.maxmatch) then
       goto 1010
      else 
        NMATCH = NMATCH + 1
c save these matching pairs
        MATSAVE(NMATCH) = MATCH
        DO I = 1, MATCH
         IM1SAVE(I,NMATCH) = IM1(I) 
           IM2SAVE(I,NMATCH) = IM2(I)
c	   write(6,*)
        END DO
        MAXTOP = MAX(MATCH,MAXTOP)
c here for the second SS match number
        NRMCH = MIN(NSND1,NSND2,MAX(INT(float(MAXTOP)*rat2+0.5),NRMCH))
        if (list.or.dump) write(6,*) 'Reset NRMCH to',NRMCH 
        write(6,'(1x,70a1)') ('-',I=1,70)
        WRITE(6,1022) MATCH,' of (',NSND1,',',NSND2,
     1 ') secondary structure could be aligned'
        WRITE(6,'(1X,A)') '------------------------------'//
     1'---------------------+-----+-----+------'
        WRITE(6,'(1X,A)') ' Nr.E  Mol1 start  end '//
     1'match Nr.E  Mol2 start  end !angle! dst ! r.m.s'
        WRITE(6,'(1X,A)') '------------------------------'//
     1'---------------------+-----+-----+------'
1022	FORMAT(1X,I3,A,I3,A,I3,A)
        CALL MATMULT(3,3,3,1,ROTOLD,CEN2OLD,B1)
        CALL ARRPS(3,1,CEN1OLD,B1,TR)
        DO I =1, MATCH
         CALL RTMOV(2,XSND2(1,1,IM2(I)),ROTOLD,TR,XTM1)
         CALL ARRPS(3,2,XTM1,XSND1(1,1,IM1(I)),XTM2)
         RMSE = SQRT((DOSQ(3,XTM2(1,1))+DOSQ(3,XTM2(1,2)))/2.)
         CALL ARRPS(3,1,XSND1(1,2,IM1(I)),XSND1(1,1,IM1(I)),B1)
         CALL ARRPS(3,1,XTM1(1,2),XTM1(1,1),B2)
         ANGE = ANGLE(B1,B2)
         DLLE = abs(DSTLL2(
     1   XSND1(1,1,IM1(I)),XSND1(1,2,IM1(I)), XTM1(1,1),XTM1(1,2)))
C
         WRITE(6,3010) 
     1   IM1(I),ESND1(IM1(I)),SNDNAME1(IM1(I)),
     2   NST1(IM1(I)),NEND1(IM1(I)),
     3   IM2(I),ESND2(IM2(I)),SNDNAME2(IM2(I)),
     4   NST2(IM2(I)),NEND2(IM2(I)),
     5   ANGE,DLLE,RMSE
        END DO
c	  MREAL = MADD + MATCH
        MREAL = MATCH
        MREAL0 = MATCH
        MAXTOPO = MAX(MREAL0,MAXTOPO)
c	  TDSCORE = (RALLOLD+RMSAOLD)*NSND1/FLOAT(MREAL0)/2.
        TDSCORE = 
     +     (RALLOLD+RMSAOLD)/(FLOAT(MREAL0)/FLOAT(NSND1))**ampltop/2.
        WRITE(6,'(1X,A)') '------------------------------'//
     1'---------------------+-----+-----+------'
        WRITE(6,3011)
     1 ' Mean Angle:   ',RALLOLD, ' Mean Distance:',DALLOLD,
     2 ' RMS:     ',RMSAOLD,
     3 ' Max Angle:    ',RANGMAXO,' Max Distance: ',DLLMAXO
        write(6,'(1x,a,I3,2x,a,f6.1,2x,a,i3,2a)') 
     1 'SS match #',MREAL0,
     2 'topological diversity',tdscore,
     3 'in match',nmatch,' of ',obj2(1:iobj2)
        tdsmin = min(tdsmin,tdscore)
        if (tdsmin.eq.tdscore) MREAL0MAX = MREAL0
c	  MREAL0MAX = MAX(MREAL0MAX,MREAL0)
        if (fit) then
c	   print*,net,fbrows
         if (net.and.(.not.fbrows)) then
c	    print*, 'Browse ',code1,' from Protein Data Bank server'
          actbrs = bspdb(site,code2,file2)
          if (actbrs) then
c	     print*, code2,' has been browsed from ',site(1:lsite)
          else if (lib) then
           print*, 'Warning: failed to get '//code2//' from the website'
           goto 1710
          else
           stop 'Error in browsing PDB'
          end if
          fbrows = .true.
         end if
         call morefit(file1,file2,rotold,tr,dstmin,lstres,
     1   mfit,frate,rmsf,smf,filout,l4)
        end if
1710	  continue
        write(6,'(1x,70a1)') ('-',I=1,70)
        WRITE(6,*) 'MATRIX'
        write(6,3012) ROTOLD
c	  write(6,'(1x,70a1)') ('-',I=1,70)
        WRITE(6,*) 'TRANSLATION'
        write(6,3012) TR
C	  write(6,'(1x,60a1)') ('-',I=1,60)
        MREAL = MATCH
        MAXTOPO = MAX(MREAL,MAXTOPO)
C	  write(6,'(1x,60a1)') ('-',I=1,60)
c	 WRITE(10,'(A)') '.LSQ_RT_SND               R         12 (3F10.5)'
       nofm = nofm + 1
       if (nofm.gt.1) then
        write(ofm(9+iobj2:11+iobj2),'(i3)') nofm
        call spstrunct(ofm(9+iobj2:11+iobj2))
       end if
       write(6,'(2a)') ' O_Matrix name: ',ofm(1:11+iobj2)
       if (fit) then
        if (natm.ge.6) then
c	   write(6,*) 'Sequence matching:'
         call showfit(14,itot,isame,per)
c	   sdscore = natm2*rmsf/float(mfit)
C	   sdscore = rmsf/(float(mfit)/float(natm2))**ampl
         IF (ISTR1.EQ.2) THEN
          n0 = natm1+natm2
         ELSE IF (ISTR1.EQ.0) THEN
          n0 = min(natm1,natm2)
         ELSE
          n0 = natm2
         END IF
         sdscore = fpum*rmsf/(float(mfit)/float(N0))**ampl
         write(6,'(1x,70a1)') ('-',I=1,70)
         write(6,3111) 'Matching residues',itot,'Identical residues',
     +       isame,'Identity   ',per,'%'
         write(6,3112) 'Match Rate(1)',frate,'r.m.s. of atoms',rmsf,
     1   'Mean distance',smf
         write(6,'(a,f6.2,a,i5,a,i2,2a)') 
     1   ' structure diversity ',sdscore, '    with',itot,
     1   ' residues in match',nmatch,' of ',obj2(1:iobj2)
         if (WRIT)
     +      write(6,'(2a)') ' Superimposed coordinates of this match: ',
     +      filout(1:l4)
         write(6,*)
         sdsmin = min(sdsmin,sdscore)
         if (sdsmin.eq.sdscore) then
          itotmax = itot
          rmsfout = rmsf
          sfmout = smf
          mchmin = nmatch
         end if
        else
         write(6,*) 'No feasible residue alignment'
        end if
       end if
       write(10,'(a)') ofm(1:47)
       WRITE(10,'(3F10.5)') ROTOLD,TR
C	  IF (DUMP) THEN
C	   WRITE(6,*) 'CEN1OLD',CEN1OLD
C	   WRITE(6,*) 'CEN2OLD',CEN2OLD
C	  END IF
3011	FORMAT(2(A15,F6.1,3X),A10,F3.1)
c	 WRITE(10,'(A)') '.LSQ_RT_SND               R         12 (3F10.5)'
c	 WRITE(10,'(3F10.5)') ROTOLD,TR
       goto 4000
      END IF

C2030	IF (IM2(MATCH).LT.(NSND2-MAX(NRMCH-MATCH,0))) GOTO 1030
C2020	IF (IM1(MATCH).LT.(NSND1-MAX(NRMCH-MATCH,0))) GOTO 1020
2030	MOVE = MIN(0,MATCH-MAX(NRMCH,MAXTOP)+1)
      IF (IM2(MATCH).LT.(NSND2+MOVE)) GOTO 1030
2020	MOVE = MIN(0,MATCH-MAX(NRMCH,MAXTOP)+1)
      IF (IM1(MATCH).LT.(NSND1+MOVE)) GOTO 1020
2010	IF (MATCH.GT.1) THEN
C	 IF (IADD.LT.1) MATCH = MATCH - 1
       MATCH = MATCH - 1
       IADD = IADD - 1
c	 CALL ARRGIVE(3,CEN1OLD,CEN1)
C	 MAXTOP = MAX(MATCH,MAXTOP)
C One has to resume the center of the data set.
3025	 IF (MATCH.GE.2) THEN
        CALL AVERG(3,2*MATCH,XMCH1,CEN1)
        CALL TMOVE(3,2*MATCH,XMCH1,CEN1,-1.,XMH1)
        DM1 = 0.
        DO I = 1, MATCH
         DM1 = DM1 + VEM(3,XMH1(1,(I-1)*2+1) )
         DM1 = DM1 + VEM(3,XMH1(1,(I-1)*2+2) )
        END DO
        DM1 = DM1/(MATCH*2) 
        D1 = DM1 * WANG
C	  WRITE(6,*)'D1',D1
C
       END IF
C
       DO I = 1, MATCH
        CALL ARRMC(3,1,XSE1(1,I),D1/VEM(3,XSE1(1,I))
     1  ,XMH1(1,MATCH*2+I))
       END DO

       IF (IADD.LT.-1) IADD = - 1
       IF (MATCH.GE.NRMCH.AND.IADD.GE.0) THEN
        IADD = IADD - 1
c check if this match is included in an old one
        IF (NMATCH.GE.0) THEN
         DO ICHK = 1, NMATCH
          IF (MATCH.GE.MATSAVE(ICHK)) GOTO 1410
          DO ICHKNEW = 1,MATCH
           DO ICHKOLD = 1,MATSAVE(ICHK)
            IF ( IM1(ICHKNEW).eq.IM1SAVE(ICHKOLD,ICHK) .and. 
     1          IM2(ICHKNEW).EQ.IM2SAVE(ICHKOLD,ICHK) ) goto 1420
1430	     END DO
             GOTO 1410
1420	    END DO
          if (dump) then
           write(6,*) 'This match is included in match ',ichk
          end if
          goto 2030
1410	   END DO
        END IF
1400	  CONTINUE
cc
        NMATCH = NMATCH + 1
c save these matching pairs
        MATSAVE(NMATCH) = MATCH
        DO I = 1, MATCH
         IM1SAVE(I,NMATCH) = IM1(I) 
           IM2SAVE(I,NMATCH) = IM2(I)
c	   write(6,*)
        END DO
        MAXTOP = MAX(MATCH,MAXTOP)
c here for the second SS match number
        NRMCH = MIN(NSND1,NSND2,MAX(INT(float(MAXTOP)*rat2+0.5),NRMCH))
        write(6,'(1x,70a1)') ('-',I=1,70)
        WRITE(6,1022) MATCH,' of (',NSND1,',',NSND2,
     1 ') secondary structure could be aligned'
        WRITE(6,'(1X,A)') '------------------------------'//
     1'---------------------+-----+-----+------'
        WRITE(6,'(1X,A)') ' Nr.E  Mol1 start  end'// 
     1' match Nr.E  Mol2 start  end !angle! dst ! r.m.s'
        WRITE(6,'(1X,A)') '------------------------------'//
     1'---------------------+-----+-----+------'
        CALL MATMULT(3,3,3,1,ROTOLD,CEN2OLD,B1)
        CALL ARRPS(3,1,CEN1OLD,B1,TR)
        MADD = 0
        MADD0 = 0
           
        DO I =1, MATCH
         CALL RTMOV(2,XSND2(1,1,IM2(I)),ROTOLD,TR,XTM1)
         CALL ARRPS(3,2,XTM1,XSND1(1,1,IM1(I)),XTM2)
         RMSE = SQRT((DOSQ(3,XTM2(1,1))+DOSQ(3,XTM2(1,2)))/2.)
         CALL ARRPS(3,1,XSND1(1,2,IM1(I)),XSND1(1,1,IM1(I)),B1)
         CALL ARRPS(3,1,XTM1(1,2),XTM1(1,1),B2)
         ANGE = ANGLE(B1,B2)
         DLLE = abs(DSTLL2(
     1   XSND1(1,1,IM1(I)),XSND1(1,2,IM1(I)), XTM1(1,1),XTM1(1,2)))
C
         WRITE(6,3010) 
     1   IM1(I),ESND1(IM1(I)),SNDNAME1(IM1(I)),
     2   NST1(IM1(I)),NEND1(IM1(I)),
     3   IM2(I),ESND2(IM2(I)),SNDNAME2(IM2(I)),
     4   NST2(IM2(I)),NEND2(IM2(I)),
     5   ANGE,DLLE,RMSE
c Now I try to find some gap between aligned elements.
         IF (I.NE.MATCH) THEN
          IG1 = IM1(I+1)-IM1(I) - 1
          IG2 = IM2(I+1)-IM2(I) - 1
c	    IF (IG1.NE.IG2.OR.IG1.EQ.0) GOTO 3050
          IF (MIN(IG1,IG2).GT.MAXGAP) GOTO 3050
C	    DO IG = 1, IG1
C	     IF (ESND1(IM1(I)+IG).NE.ESND2(IM2(I)+IG) ) GOTO 3050
C	    END DO
          CALL AVERG(3,4,XMCH1(1,1,I),CG(1,1))
          CALL AVERG(3,4,XMCH2(1,1,I),CG(1,2))
          CALL AVERG(3,2,XMCH1(1,1,I),CG0)
          DO IGA1 = 1, IG1
           IGP1 = IM1(I)+IGA1
           DO IGA2 = 1, IG2
            IGP2 = IM2(I)+IGA2
            IF (ESND1(IGP1).NE.ESND2(IGP2)) GOTO 3040
            IF (ESND1(IGP1).EQ.'a') ie0 = 1
            IF (ESND1(IGP1).EQ.'b') ie0 = 2
            CALL RTMOV(2,XSND2(1,1,IGP2),ROTOLD,TR,XTM1)
            CALL ARRPS(3,2,XTM1,XSND1(1,1,IGP1),XTM2)
            RMSE = SQRT((DOSQ(3,XTM2(1,1))+DOSQ(3,XTM2(1,2)))/2.)
            CALL ARRPS(3,1,XSND1(1,2,IGP1)
     1       ,XSND1(1,1,IGP1),B1)
            CALL ARRPS(3,1,XTM1(1,2),XTM1(1,1),B2)
            ANGE = ANGLE(B1,B2)
            DLLE = abs(DSTLL2(XSND1(1,1,IGP1)
     1     ,XSND1(1,2,IGP1), XTM1(1,1),XTM1(1,2)))
C
            IF (RMSE.LE.ERRRMSA.AND.ANGE.LE.ERRANG(IE0).
     1      AND.DLLE.LE.ERRDLL(IE0)) THEN
             WRITE(6,3014) 
     1      IGP1,ESND1(IGP1),SNDNAME1(IGP1),
     2      NST1(IGP1),NEND1(IGP1),
     3      IGP2,ESND2(IGP2),SNDNAME2(IGP2),
     4      NST2(IGP2),NEND2(IGP2),
     5      ANGE,DLLE,RMSE
             MADD = MADD + 1
             MADD0 = MADD0 + 1
             GOTO 3040	        
            ELSE IF (RMSE.LE.ERRRMSA*TIMER.AND
     1     .ANGE.LE.ERRANG(IE0)*TIMER.
     2      AND.DLLE.LE.ERRDLL(IE0)*TIMER) THEN
             WRITE(6,3015) 
     1      IGP1,ESND1(IGP1),SNDNAME1(IGP1),
     2      NST1(IGP1),NEND1(IGP1),
     3      IGP2,ESND2(IGP2),SNDNAME2(IGP2),
     4      NST2(IGP2),NEND2(IGP2),
     5      ANGE,DLLE,RMSE
             MADD = MADD + 1
             GOTO 3040	        
            ELSE 
             CALL AVERG(3,2,XSND1(1,1,IM1(I)+IGA2),B1)
             CALL AVERG(3,2,XTM1,B2)
             CALL ARRPS(3,1,B1,CG,B3)
             CALL ARRPS(3,1,B2,CG,B4)
             CALL ARRPS(3,1,B4,B3,B5)
             IF (VEM(3,B5).LT.MAX(VEM(3,B4),VEM(3,B3))) THEN
              WRITE(6,3016) 
     1       IGP1,ESND1(IGP1),SNDNAME1(IGP1),
     2       NST1(IGP1),NEND1(IGP1),
     3       IGP2,ESND2(IGP2),SNDNAME2(IGP2),
     4       NST2(IGP2),NEND2(IGP2),
     5       ANGE,DLLE,RMSE
              MADD = MADD + 1
      	GOTO 3040	        
             END IF	
            END IF
3030	     END DO
3040	    END DO
         END IF
3050	  END DO
        MREAL = MADD + MATCH
        MREAL0 = MADD0 + MATCH
        MAXTOPO = MAX(MREAL0,MAXTOPO)
c	  TDSCORE = (RALLOLD+RMSAOLD)*NSND1/FLOAT(MREAL0)/2.
        TDSCORE = 
     +     (RALLOLD+RMSAOLD)/(FLOAT(MREAL0)/FLOAT(NSND1))**ampltop/2.
        WRITE(6,'(1X,A)') '------------------------------'//
     1'---------------------+-----+-----+------'
        WRITE(6,3011) 
     1 ' Mean Angle:   ',RALLOLD, ' Mean Distance:',DALLOLD,
     2 ' RMS:     ',RMSAOLD,
     3 ' Max Angle:    ',RANGMAXO,' Max Distance: ',DLLMAXO
c	  write(6,'(1x,70a1)') ('-',I=1,70)
        write(6,'(1x,a,I3,2x,a,f6.1,2x,a,i3,2a)') 
     1 'SS match #',MREAL0,
     2 'topological diversity',tdscore,
     3 'in match',nmatch,' of ',obj2(1:iobj2)
        tdsmin = min(tdsmin,tdscore)
        if (tdsmin.eq.tdscore) MREAL0MAX = MREAL0
        if (fit) then
c	   print*,net,fbrows
         if (net.and.(.not.fbrows)) then
c	    print*, 'Browse ',code1,' from Protein Data Bank server'
          actbrs = bspdb(site,code2,file2)
          if (actbrs) then
c	     print*, code2,' has been browsed from ',site(1:lsite)
          else if (lib) then
           print*, 'Warning: failed to get '//code2//' from the website'
           goto 1720
          else
           stop 'Error in browsing PDB'
          end if
          fbrows = .true.
         end if
         call morefit(file1,file2,rotold,tr,dstmin,lstres,
     1   mfit,frate,rmsf,smf,filout,l4)
        end if
1720	  continue
        write(6,'(1x,70a1)') ('-',I=1,70)
        WRITE(6,*) 'MATRIX'
        write(6,3012) ROTOLD
c	  write(6,'(1x,70a1)') ('-',I=1,70)
        WRITE(6,*) 'TRANSLATION'
        write(6,3012) TR
c	  write(6,*)
c	 WRITE(10,'(A)') '.LSQ_RT_SND               R         12 (3F10.5)'
       nofm = nofm + 1
       if (nofm.gt.1) then
        write(ofm(9+iobj2:11+iobj2),'(i3)') nofm
        call spstrunct(ofm(9+iobj2:11+iobj2))
       end if
       write(6,'(2a)') ' O_Matrix name: ',ofm(1:11+iobj2)
       if (fit) then
        if (natm.ge.6) then
c	   write(6,*) 'Sequence matching:'
         call showfit(14,itot,isame,per)
c	   sdscore = natm2*rmsf/float(mfit)
C	   sdscore = rmsf/(float(mfit)/float(natm2))**ampl
         IF (ISTR1.EQ.2) THEN
          n0 = natm1+natm2
         ELSE IF (ISTR1.EQ.0) THEN
          n0 = min(natm1,natm2)
         ELSE
          n0 = natm2
         END IF
         sdscore = fpum*rmsf/(float(mfit)/float(N0))**ampl
         write(6,'(1x,70a1)') ('-',I=1,70)
         write(6,3111) 'Matching residues',itot,'Identical residues',
     +      isame,'Identity   ',per,'%'
         write(6,3112) 'Match Rate(1)',frate,'r.m.s. of atoms',rmsf,
     1   'Mean distance',smf
         write(6,'(a,f6.2,a,i5,a,i2,2a)') 
     1   ' structure diversity ',sdscore, '    with',itot,
     1   ' residues in match',nmatch,' of ',obj2(1:iobj2)
         if (WRIT)
     +      write(6,'(2a)') ' Superimposed coordinates of this match: ',
     +      filout(1:l4)
         write(6,*)
 	   sdsmin = min(sdsmin,sdscore)
         if (sdsmin.eq.sdscore) then
          itotmax = itot
          rmsfout = rmsf
          sfmout = smf
          mchmin = nmatch
         end if
        else 
         write(6,*) 'No feasible residue alignment'
        end if
       end if
3111	 format(1x,a,i4,3x,a,i4,3x,a,f8.1,a)
3112	 format(1x,a,f7.1,'%',3x,a,f7.2,3x,a,f7.2)
       write(6,*)
       write(10,'(a)') ofm(1:47)
       WRITE(10,'(3F10.5)') ROTOLD,TR
3012	format(3f14.7)
3010	  FORMAT(1X,I3,'-',A,':',A,1X,A,'-',A,' ====',
     1           I4,'-',A,':',A,1X,A,'-',A,1X,3('!',f5.1))
3014	  FORMAT(1X,I3,'-',A,':',A,1X,A,'-',A,' .==.',
     1           I4,'-',A,':',A,1X,A,'-',A,1X,3('!',f5.1))
3015	  FORMAT(1X,I3,'-',A,':',A,1X,A,'-',A,' ....',
     1           I4,'-',A,':',A,1X,A,'-',A,1X,3('!',f5.1))
3016	  FORMAT(1X,I3,'-',A,':',A,1X,A,'-',A,'  .. ',
     1           I4,'-',A,':',A,1X,A,'-',A,1X,3('!',f5.1))
C	  IM2(1) = IM2(MATCH)
        IF (DUMP) THEN
         WRITE(6,*) 'CEN1OLD',CEN1OLD
         WRITE(6,*) 'CEN2OLD',CEN2OLD
        END IF
C In fast option, if helix disturbs the beta match, then delete the
c very first helix and re-search for match
        IF(FAST)  THEN
         DO I = 1, MATCH
          IF (IE(I).EQ.1) THEN
           MATCH = I
           GOTO 2030
          END IF
         END DO
         MATCH = 1
        END IF	   
       ELSE IF(FAST)  THEN
        DO I = MATCH, 1, -1
         IF (IE(I).EQ.1) THEN
          MATCH = I
          GOTO 2030
         END IF
        END DO
       END IF	   
       GOTO 2030
      END IF
4000	continue
c	write(6,*) 'Total ',nmatch,' ways to align the structure'
c	ien1 = lenstr(file1)
c	is1 = index(file1(1:ien1),']') + 1
c	if (is1.le.0.or.is.gt.ien1) is1 = 1
c	ien2 = lenstr(file2) + 1
c	is2 = index(file2(1:ien2),']') + 1
c	if (is2.le.0.or.is.gt.ien2) is2 = 1
      IF (NMATCH.GT.0) THEN
       WRITE(6,'(A,I3,2A)') ' <<<Total ',nmatch,
     1 ' ways to align the new structure to ',obJ2(1:nobj2)
       write(6,'(1x,3a,2(a,i3))')obj2(1:nobj2),'<->',obj1(1:nobj1),
     1 '  Max Align:',MAXTOP, '  Max Match:',MAXTOPO
C	 if (lib) then
        write(6,'(1x,a,f6.1,2x,a,I3,2a)') 
     1 'Best Topological Diversity',tdsmin,
     2 'with',MREAL0MAX,' matched SS to  ',
     3 obj2(1:iobj2)
c          if (llfam.gt.0)
c	1  write(6,'(1x,a,f6.1,2x,a,I3,2a)') 
c	1 'Least topological diversity',tdsmin,
c	2 'with',MREAL0MAX,' matched SSE to class ',
c	3 fam(1:llfam)
c	  MREAL0MAX = 0
        if (fit.and.itotmax.gt.5.and.sdsmin.lt.sthigh) then
         write(6,'(a,f7.2,a,i5,2a)') 
     +   ' Best Structure Diversity ',sdsmin, ' with',itotmax,
     +   ' matched residues to ',obj2(1:iobj2)
c	   
         if (WRIT) then
          l40 = lenstr(filout0)
            write(6,'(2a)') ' Superimposed Model with least SD: ',
     +      filout0(1:l40)
          write(6,'(a)')
          filout=filout0(1:l40)//'_'
          write(filout(l40+2:l40+6),'(i4)') mchmin
          call spstrunct(filout(l40+2:l40+6))
c	    if (dump) print*, 'real file:',filout(1:l40+6)
          comd='cp '//filout(1:l40+6)//' '//filout0(1:l40)
          icomd = lenstr(comd)
c	    if (dump) print*, comd(1:icomd)
          call ccpspw(comd(1:icomd))
         end if
c           if (llfam.gt.0)
c	1   write(6,'(a,f6.2,a,i5,2a)') 
c	1   ' Least structure diversity ',sdsmin, '  with',itotmax,
c	1   ' matched residues to class ',fam(1:llfam)
           if (llfam.gt.0.and.sdsmin.lt.sthigh) then
          write(6,'(4a,(a,f7.2,a,i4,a,f6.1,a,i3))') 
     +    'SCOP-',fam(1:llfam),'-',obj2(1:iobj2),
     +    ' str.div.',sdsmin, ' #Ca',itotmax,
     +    ' top.div.',tdsmin,' #SSE',MREAL0MAX
         else
          write(6,'(1x,a,i4,a,f4.1,a,f4.1,a,f6.1,a,f6.1,2a)')
     +     '#Ca',itotmax,' RMS:',rmsfout,' dist.',sfmout,
     +    ' str.div:',sdsmin,' top.div',tdsmin
c	1  ,' name:',obj2(1:iobj2) 
         end if
        end if
        sdsmin = 99999.
        itotmax = 0
        tdsmin = 99999.
        MREAL0MAX = 0
C	 end if
       NSIM = NSIM + 1
       write(6,'(1x,70a1)') ('~',I=1,60)
       write(6,*)
       write(6,*)
      ELSE
       WRITE(6,'(2A,2(A,I3))') ' ... No way to align in ',obj2(1:nobj2),
     1 ' maximum match :',MAXTOP,' Minimum Align:',NRMCH
      END IF
C
      IF (LIB) THEN
       if (actbrs) then
        call ccpdpn(20,file2,'scratch','F',0,0)
        close(20)
       end if
       GOTO 5010
      END IF
5000	CONTINUE
      IF (LIB.and.mode.ne.1) THEN
       WRITE(6,*) NSTR,' structures have been searched'
       if (nskip.gt.0) WRITE(6,*) nskip, ' structures were skipped'
       WRITE(6,*) NSIM,' structures are found to be similar under',
     1 ' the given criteria'
      ELSE IF (LIB) THEN
       WRITE(6,'(I6,A)') NSTR,' PDB entries have been browsed'
       WRITE(6,'(I6,A)') NVEC,' entries have been compressed into the '
     +  //'compact SSE library'
      END IF
c
        CALL CCPERR(0,'Normal termination')

5040	WRITE(6,*) '>>>ERROR: something wrong in the vector file'
      GOTO 5010
      END
c
      subroutine alfbta(filename,nsnd,xsnd,sndname,esnd,nst,nend)
c
      PARAMETER (MAXATM=20000)
      PARAMETER (MAXSND=1500)
      PARAMETER (MAXIEXT=1500)
      CHARACTER TXT(MAXATM)*72
      CHARACTER FILENAME*80,OBJ*40
      character*5 hst(MAXSND),hend(MAXSND)
      character*5 bst(MAXSND),bend(MAXSND)
      character*6 namsnd
      character*4 btaname(MAXSND)
      character*4 hlxname(MAXSND)
      character*4 sndname(2*MAXSND),tmpname
      character*1   esnd(2*maxsnd),etmp
      INTEGER IST(2*MAXSND),IEND(2*MAXSND)
      CHARACTER*5 NST(2*MAXSND),NEND(2*MAXSND),ntmp
      REAL*4 XYZ(3,MAXATM),XSND(3,2,2*MAXSND),xtmp(3,2)
      real*4 b1(3),b2(3)
      real*4 rms(maxsnd)
c     real*4 hrms/2.0/,brms/4.5/
      real*4 hrms,brms
      logical*1 mtvin
      LOGICAL*1 LIB,ERR
      LOGICAL*1 DUMP,LIST
      LOGICAL*1 SNDASS,APPE,SASS
      COMMON/TOPDUMP/ DUMP,LIST
      COMMON/TOPSND/ RMST
      COMMON/TOPRMS/ HRMS,BRMS
      COMMON/TOPLIB/ LIB,ERR
      COMMON/MODES/ MODE,NCOMP
      COMMON/SNDASS/ SNDASS,APPE
      COMMON/RANG/ RANGS,RANGE

      nsnd = 0
      nbta = 0
      nhlx = 0
      NATM = 1
      nrej = 0
      iass = 0
      err = .false.
      sass = .false.
c
      if (mode.eq.1) then
       rewind (13)
       ncomp = 0
      end if
c
      il = LENSTR(FILENAME)
      is = 1
c	call spstrunct(filename)
      CALL CCPDPN(1,FILENAME(1:il),'READONLY','F',0,0)
c      if (dump) write(6,*) FILENAME(1:il),' opened'
c
10	READ(1,'(A)',END=20) TXT(NATM)
C
      IF (TXT(NATM)(1:4).NE.'ATOM') then
c	1 .AND.TXT(NATM)(1:6).NE.'HETATM') then
       if (txt(natm)(1:5).eq.'HELIX'.and.(.not.sndass)) THEN
c	  read(txt(natm)(7:10),'(i4)') nhlx
        nhlx = nhlx + 1
        hlxname(nhlx)=txt(natm)(11:14)
        hst(nhlx) = txt(natm)(21:25)
        hst(nhlx)(1:1) = txt(natm)(20:20)
        hend(nhlx)= txt(natm)(33:37)
        hend(nhlx)(1:1) = txt(natm)(32:32)
       else if (txt(natm)(1:5).eq.'SHEET'.and.(.not.sndass)) THEN
        nbta = nbta + 1
        btaname(nbta)=txt(natm)(12:15)
        btaname(nbta)(4:4)=txt(natm)(10:10)
        bst(nbta) = txt(natm)(22:26)
        bend(nbta)= txt(natm)(33:37)
       else if (txt(natm)(1:3).eq.'END') then
        goto 20
       else if (txt(natm)(1:6).eq.'COMPND'.or.
     +            txt(natm)(1:4).eq.'TITL') THEN
        write(6,'(1x,a)') txt(natm)(1:lenstr(txt(natm)))
        if (mode.eq.1) then
         write(13,'(a)') txt(natm)(1:lenstr(txt(natm)))
         ncomp = ncomp + 1
        end if
       end if
       goto 10
      else
       IF (TXT(NATM)(14:17).NE.'CA  '
     1 .AND.TXT(NATM)(13:16).NE.'CA  ') GOTO 10
      end if
c
c	print*,txt(natm)
      READ(TXT(NATM)(31:54),'(3F8.3)',ERR=10) (XYZ(I,NATM),I=1,3)
      NATM = NATM + 1
      GOTO 10
c
20	CONTINUE
      NATM = NATM - 1

      if (natm.eq.0) then
C	 inquire (1,name=filename)
       write(6,'(2a)') ' <<<No Ca atoms in file '
     1 ,filename(is:il)
       if (.not.lib) stop '>>>Error stop'
       err = .true.
       return
      else if (natm.gt.maxatm) then
       write(6,'(a,i4,2a)') ' <<<Atoms more than',maxatm,' in file '
     1 ,filename(is:il)
       if (.not.lib) stop '>>>Error stop'
       err = .true.
       return
      end if
c
c	inquire (1,name=filename)
      close (1)
      il = lenstr(filename)
      is = index(filename(1:il),']') + 1
      if (is.gt.il) is = 1
21	if (sndass.or.(nhlx.eq.0.and.nbta.eq.0)) then
       call autosnd(filename,
     +    nhlx,hlxname,hst,hend,nbta,btaname,bst,bend)
       sass = .true.
c	 if (err) return
       iass = 1
      end if
      write(6,'(3(i5,a),a)') natm,' Ca atoms read '
     + ,nhlx,' helixes',nbta,' strands in file '
     +  ,filename(is:il)
c
      if ((nhlx+nbta).gt.2*maxsnd) then
       write(6,'(a,i4,2a)') ' <<<Secondary structure elements'//
     1 ' more than',maxsnd,' in file '
     2 ,filename(is:il)
       if (.not.lib) stop '>>>Error stop'
       err = .true.
       return
      else if (nhlx.eq.0.and.nbta.eq.0) then
C	 inquire (1,name=filename)
       if (iass.eq.0) goto 21
       write(6,'(2a)') ' <<<No Secondary structure assigned in file '
     1 ,filename(is:il)
       if (.not.lib) stop '>>>Error stop'
       err = .true.
       return
      end if

      if (dump) then
       write(6,*) nhlx,' pre-assigned alfa helixes'
       write(6,'(1x,i4,2x,a,a,a,a,a)') 
     1 (i,hlxname(i),' from ',hst(i),'  to ',hend(i),i=1,nhlx)
      end if
c
      mtvin = .false.
      nstart = 1
      do ihlx = 1, nhlx
       do iatm = nstart, natm
c	  write(6,'(3a)') txt(iatm),hst(ihlx),hend(ihlx)
        if (.not.mtvin) then 
         if (hst(ihlx) .eq. txt(iatm)(22:26) ) then
          mtvin = .true.
          istart = iatm
          nsnd = nsnd + 1
          ist(nsnd) = istart
          nst(nsnd) = hst(ihlx)
          iext=1
         end if
        else
         iext = iext + 1
         if  (txt(iatm)(22:26) .eq. hend(ihlx)) then
          if (iext.lt.3) then
           nsnd = nsnd - 1
           nrej = nrej + 1
           iext = 0
           mtvin = .false.
           write(6,*) 'helix ',hlxname(ihlx)
     1    ,' not more than 2 atoms, rejected'
           goto 40
          end if
          iend(nsnd) = iatm
          nend(nsnd) = hend(ihlx)
          esnd(nsnd) = 'a'
          sndname(nsnd) = hlxname(ihlx)
          mtvin = .false.
          if (dump)
     1    write(6,*) iext,' atoms in helix',hlxname(ihlx),' No',ihlx
          if (iext.le.maxiext) then
           call refalfa(IEXT,xyz(1,istart),xsnd(1,1,nsnd))
           if (rmst.gt.2*hrms) then
            write(6,*) 'helix:',hlxname(ihlx),' have rms',rmst,
     +           ' rejected'
            nsnd = nsnd -1
            nrej = nrej + 1
            goto 40
           end if
          else
           nsnd = nsnd - 1
           nrej = nrej + 1
           iext = 0
           mtvin = .false.
           write(6,*) 'helix:',hlxname(ihlx),' have residues',iext,
     +           'rejected'
           goto 40
          end if
          if (rmst.gt.hrms.and.(.not.sass)) then
           nsnd = nsnd - 1
           nrej = nrej + 1
           iext = 0
           mtvin = .false.
           write(6,'(3a,f5.1,a,f5.1,a)') ' Helix ',hlxname(ihlx)
     1    ,' rms is ',rmst,' more than ',hrms,' rejected'
           goto 40
          end if
          rms(nsnd) = rmst
c	    nstart = iatm
          goto 40
         end if
        end if
       end do
       write(6,*) 'Warning: helix ',hlxname(ihlx),
     1  ' not find in Ca coordinate of ',filename(1:lenstr(filename))
       if (mtvin) then
        write(6,*) 'Only find start ',hst(ihlx)
     1 ,' not find end ',hend(ihlx), ' rejected'
        nsnd = nsnd - 1
       end if
       nrej = nrej + 1
       mtvin = .false.
40	end do
c
c	do ihlx = 1, nhlx
c	 write(3,'(a,3f10.5)') 'M',(xsnd(j,1,ihlx),j=1,3)
c	 write(3,'(a,3f10.5)') 'L',(xsnd(j,2,ihlx),j=1,3)
c	end do
      if (dump) then
       write(6,*) nbta,' pre-assigned beta strand'
       write(6,'(1x,i4,2x,a,a,a,a,a)') 
     1 (i,btaname(i),' from ',bst(i),'  to ',bend(i),i=1,nbta)
      end if
c
      mtvin = .false.
      nstart = 1
      do ibta = 1, nbta
       do iatm = nstart, natm
c	  write(6,'(3a)') txt(iatm),bst(ibta),bend(ibta)
        if (.not.mtvin) then 
         if (bst(ibta) .eq. txt(iatm)(22:26) ) then
          mtvin = .true.
          istart = iatm
          nsnd = nsnd + 1
          ist(nsnd) = istart
          nst(nsnd) = bst(ibta)
          iext=1
         end if
        else
         iext = iext + 1
         if  (txt(iatm)(22:26) .eq. bend(ibta)) then
          iend(nsnd) = iatm
          nend(nsnd) = bend(ibta)
          esnd(nsnd) = 'b'
          sndname(nsnd) = btaname(ibta)
          mtvin = .false.
          if (dump)
     1     write(6,*) 'Beta strand ', btaname(ibta),' No.',ibta,
     2   ' contains',iext,' atoms'
          call refbeta(iext,xyz(1,istart),xsnd(1,1,nsnd))
          if (rmst.gt.brms.and.(.not.sass)) then
           nsnd = nsnd - 1
           nrej = nrej + 1
           iext = 0
           mtvin = .false.
           write(6,'(3a,f5.1,a,f5.1,a)') ' Sheet ',btaname(ibta)
     1    ,' rms is ',rmst,' more than ',brms,' rejected'
           goto 140
          end if
          rms(nsnd)=rmst
c	    nstart = iatm
          goto 140
         end if
        end if
       end do
      write(6,*) 'Warning: strand ',btaname(ibta),
     1 ' not find in Ca coordinate of',filename(1:lenstr(filename))
      if (mtvin) then 
       write(6,*) 'Only find start ',bst(ibta)
     1 ,' not find end ',bend(ibta), ' rejected'
       nsnd = nsnd - 1
      end if
      nrej = nrej + 1
      mtvin = .false.
140	end do
c
c	do ibta = 1, nbta
c	 write(3,'(a,3f10.5)') 'M',(xsnd(j,1,ibta+nhlx),j=1,3)
c	 write(3,'(a,3f10.5)') 'L',(xsnd(j,2,ibta+nhlx),j=1,3)
c	end do
c
c Re-order the secondary element
c
c	inquire (1,name=filename)
      if (list)
     1 write(6,'(1x,a,i3,2a)') 'Total', nsnd,
     2 ' secondary elements in file ',filename(is:il)
      if (nsnd.ne.(nhlx+nbta-nrej)) then
       write(6,*)'nsnd,nhlx,nbta,nrej',nsnd,nhlx,nbta,nrej
       if (.not.lib) stop 'Strange nsnd'
       write(6,*) 'Strange nsnd'
       err = .true.
       return
      end if
      do i1 = 1, nsnd-1
       do i2 = i1+1, nsnd
300	  if (ist(i1).gt.ist(i2).and.iend(i1).gt.iend(i2)) then
         ntmp = nst(i2)
         nst(i2) = nst(i1)
         nst(i1) = ntmp
         ntmp = nend(i2)
         nend(i2) = nend(i1)
         nend(i1) = ntmp
         i = ist(i2)
         ist(i2) = ist(i1)
         ist(i1) = i
         i = iend(i2)
         iend(i2) = iend(i1)
         iend(i1) = i
         etmp = esnd(i2)
         esnd(i2) = esnd(i1)
         esnd(i1) = etmp
         call arrgive(3*2,xsnd(1,1,i2),xtmp)
         call arrgive(3*2,xsnd(1,1,i1),xsnd(1,1,i2))
         call arrgive(3*2,xtmp,xsnd(1,1,i1))
         tmpname  = sndname(i2)
         sndname(i2) = sndname(i1)
         sndname(i1) = tmpname
         rtmp = rms(i2)
         rms(i2) = rms(i1)
         rms(i1) = rtmp
        else if(ist(i1).eq.ist(i2).and.iend(i1).eq.iend(i2)) then
         if (list) then
          write(6,'(a,a)') ' Repeated assignment in ',
     1    filename(is:il)
          write(6,65) namsnd(esnd(i1)),sndname(i1),nst(i1),nend(i1),
     1               namsnd(esnd(i2)),sndname(i2),nst(i2),nend(i2)
     2              ,'<--second one throw away'
         end if
65	   format(2(6x,a,1x,a,':',2a),a)
         if (i2.lt.nsnd) then
          do im = i2, nsnd-1
           nst(im) = nst(im+1)
           nend(im) = nend(im+1)
           ist(im) = ist(im+1)
           iend(im) = iend(im+1)
           esnd(im) = esnd(im+1)
           call arrgive(3*2,xsnd(1,1,im+1),xsnd(1,1,im))
           sndname(im) = sndname(im+1)
           rms(im) = rms(im+1)
          end do
          nsnd = nsnd - 1
          goto 300
         else
          nsnd = nsnd - 1
         end if
        else if 
     1  (.not. (iend(i1).le.ist(i2).and.iend(i1).lt.iend(i2)) ) then
         write(6,'(2a)') ' Warning: Secondary elements mis-assigned in '
     1   ,filename(is:il)
         write(6,65) namsnd(esnd(i1)),sndname(i1),nst(i1),nend(i1),
     1              namsnd(esnd(i2)),sndname(i2),nst(i2),nend(i2)
         if (iass.eq.0) then
         write(6,'(a)') ' The program re-assign the secondary structure'
c TOP version 4.0 --- assign structure my self
          sndass = .true.
          nsnd = 0
          nbta = 0
          nhlx = 0
            nrej = 0
          goto 21
         end if
         if (.not.lib) stop 
     1  'Error>>>check your pdb file and re-assgine these elements'
         err = .true.
         return
        end if
       end do
      end do
      do i1 = 1, nsnd
       if (list) then
        write(6,55) 'Nr.',i1,namsnd(esnd(i1)),':',nst(i1),'-'
     1,nend(i1),'entry',ist(i1),'to',iend(i1),' name ',sndname(i1),
     2'rms',rms(i1)
       end if
      end do
c
55	format(1x,a,i3,6a,i4,a,i4,a,a,2x,a,f5.2)
      return
333	continue
c	write(6,'(a)') 'ERROR>>> cannot open file '//FILENAME(1:IL)
      il = lenstr(filename)
      call nodir(filename(1:il),obj,nobj)
      write(6,'(2a)') 'ERROR>>> can not open file: ',obj(1:nobj)
      ERR=.true.
      if (.not.lib) stop 'ERROR STOP>>>'
      return
      end
c
      SUBROUTINE FITCA( NATM, XYZ1, XYZ2, A, T )
C This subroutine is used in package TOP which only to refine 
c superimposition of  CA in one helix others same with SUPRIMP
c Guoguang 91/12/12
c
      COMMON/RMS/ RMS,SMEAN,NREF,NREF1
c	COMMON/SHIFS/ SCALR,SCALS
      COMMON/IAT/ IAT1,IAT2,IAT3,IAT
      COMMON/TOPDUMP/ DUMP,LIST
      logical*1 dump,list
c	DATA SCALR/1./,SCALS/1./
C	DATA IAT/0/,IAT1/1/,IAT2/2/,IAT3/3/
      PARAMETER (NATM0 = 20000)
c   NATM0 is the largest number of atoms.
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3), T(3)
      DIMENSION X1(3,NATM0),X2(3,NATM0)
      real*4 VT(3*6*NATM0),DIS(3*NATM0)
      DIMENSION CEN1(3),CEN2(3)
      DIMENSION B1(3),B2(3),B3(3),T0(3)
c
c	DEG=180./3.14159265359
c
C Number of atoms cannot be more than NATM0 or less than 3.
c
c	if (dump) print*, NATM,' atoms are refined'
      itat = 0
      IF (NATM.GT.NATM0) THEN
      WRITE(6,*) 'ERROR> Atom is more than ',NATM0
      STOP 
      ELSE IF (NATM.LT.3) THEN
      STOP 'ERROR> Atom is less than 3.'
      END IF

c Compute the initial matrix.
c	if (dump) then
c	 print*, 'xyz1',natm
c	 write(6,'(3f10.4)') ((xyz1(i,j),i=1,3),j=1,natm)
c	 print*, 'xyz2'
c	 write(6,'(3f10.4)') ((xyz2(i,j),i=1,3),j=1,natm)
c	end if
      CALL ORIEN1(NATM,XYZ1,XYZ2,A)
c	if (dump) print*,'NATM,a,t',natm,a,t
c	NREF1 = NREF
C
C Refine the orientation by vector method.
C
      CALL REFORN ( NATM, XYZ1, XYZ2, A, VT, DIS)
c	if (dump) print*,'NATM',natm,a,t
C
C compute the  gravity of mol1 and mol2 to CEN1 and CEN2
      CALL AVERG(3,NATM,XYZ1,CEN1)
      CALL AVERG(3,NATM,XYZ2,CEN2)
C T is the initial translation vector
      CALL ARRPS(3,1,CEN2,CEN1,T0)
c Change the origin to CEN1.
      CALL TMOVE(3,NATM,XYZ1,CEN1,-1.,X1)
      CALL TMOVE(3,NATM,XYZ2,CEN1,-1.,X2)
c
C Refine th1, th2, th3, tx, ty and tz
c
      CALL REFRT( NATM, X1, X2, A, T0, VT, DIS)
c
c	WRITE(6,*)
c	WRITE(6,*) 'R.M.S.'
c	WRITE(6,*) '       natm'
c	WRITE(6,*) 'SQRT( SIGMA (Distance(i)^2)/natm ) = ',RMS
c	WRITE(6,*) '       i=1'
C
c	WRITE(6,*)
c	WRITE(6,*) 'Mean Distance:'
c	WRITE(6,*) ' natm'
c	WRITE(6,*) 'SIGMA (Distance(i)) /natm = ',SMEAN
c	WRITE(6,*) ' i=1'
C
c	WRITE(6,*)
c	WRITE(6,*) 'Mol1 is superposed to Mol2.'
c	WRITE(6,*) 'The matrix and the vector are:'
c	WRITE(6,*) 
c	WRITE(6,1) (A(1,J),J=1,3),CEN1(1),T0(1)
c	WRITE(6,2) (A(2,J),J=1,3),CEN1(2),T0(2)
c	WRITE(6,1) (A(3,J),J=1,3),CEN1(3),T0(3)
c1	FORMAT(1X,'      (',3F10.6,' )   (     ',f10.5,' )   ('
c	1 ,f10.5,' )')
c2	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 -',f10.5,' ) + ('
c	1 ,f10.5,' )')

      CALL MATMULT(3,3,3,1,A,CEN1,B3)
      CALL ARRPS(3,1,T0,B3,B3)
      CALL ARRAD(3,1,CEN1,B3,T)
cC
c	WRITE(6,*) 
c	WRITE(6,*) 
c	WRITE(6,4) (A(1,J),J=1,3),T(1)
c	WRITE(6,5) (A(2,J),J=1,3),T(2)
c	WRITE(6,4) (A(3,J),J=1,3),T(3)
c4	FORMAT(1X,'      (',3F10.6,' )   (    )   (',f10.5,' )')
c5	FORMAT(1X,' X2 = (',3F10.6,' ) * ( X1 ) + (',f10.5,' )')
C
      END 
c
      function namsnd(e)
      character*6 namsnd
      character*1 e,ea,eb
      data ea/'a'/,eb/'b'/
      ea = 'a'
      eb = 'b'
      if (e.eq.ea) then
       namsnd = 'helix'
      else if (e.eq.eb) then
       namsnd = 'strand'
      else
       write(6,*) e,ea,eb
       stop 'Error Stop>>> What namsnd???'
      end if
      end
c
 	SUBROUTINE REFALFA ( NATMIN, XYZ0, xalfa)
c This is a program to refine the parameter of a ideal helix to fit with
c real alpha helix of protein . The idea is: if we have a helix of protein 
c which x,y,z of ca c fit  the following equation
c	xn = r*cos( (n-1)*alfa + alfa0)
c	yn = r*sin( (n-1)*alfa + alfa0)
c	zn = vz * (n-1) * alfa0
c where alpha is turning angle per residue (which is reported 3.6deg)
c       vz   is distance go alone helix direction residue (which is 
c               reported 1.5 )
c       r is the radii of CA to direction axis.
c then r, alfa, alfa0, and vz could be refined by least square method to
c let left side and right side of the above equation have minimum error.
c 
c The input parameter:
c NATM	number of Ca atoms of a alpha helix
c XYZ	3*NATM array, coordinate of the alpha helix.
C xalfa 3*2 array contains the start and end position of a line which
c overlap in the axis of helix and representing the helix vector.
c 
c
      COMMON/RMS/ RMS,SMEAN,NREF,NREF1
      COMMON/TOPDUMP/ DUMP,LIST
      COMMON/TOPSND/ RMST
      COMMON/TOPRMS/ HRMS,BRMS
c	COMMON/SHIFS/ SCALR,SCALS
      LOGICAL*1 DUMP,LIST
      PARAMETER (NATM0 = 1500)
c   NATM0 is the largest number of atoms.
      real*4 hrms,brms
      REAL XYZ0(3,NATMIN),xalfa(3,2)
      REAL XYZ1(3,NATM0),XYZ2(3,NATM0)
      REAL ra(2),DETA(2),raold(2)
      REAL VT(natm0*4),dis(natm0)
      real r0,al0,vz0
      data r0/2.28/,al0/100./,vz0/1.5/
      real rot(3,3),tr(3)
      real rot0(3,3),rch(3,3)
      
C ra(1) is R		DETA(1) is deta R
C ra(2) is alfa		DETA(2) is deta alfa
      REAL VVV(2,2),b1(3),b2(3)
      integer me(3)
c
      DEG=180./3.14159265359
      nrefall = 0
      NREFRA = 0 
      NREFVZ = 0
c The refinement has something wrong!
c so take a smaller number -- 950929
      NATM = NATMIN
      IF (NATM.GT.50) NATM = 50
c
c put the coordinate to xyz1
c	CALL ARRGIVE(3*NATM,XYZ0,XYZ1)
c
c Generate an ideal alpha helix
      ra(1) = r0
      ra(2) = al0/DEG
      VZ = vz0
      do i = 1, natm
       n = i -1
       xyz2(1,i) = ra(1)*cos( n*ra(2) )
       xyz2(2,i) = ra(1)*sin( n*ra(2) )
       xyz2(3,i) = n*vz
c	 if (dump) write(43,14) i,i,(xyz2(j,i),j=1,3),1.,0.
14	 format('ATOM  ',i5,'  CA  ALA  ',i4,4x,3f8.3,2f6.2)
      end do
      call fitca(natm,xyz0,xyz2,rot,tr)
      call rtmov(natm,xyz0,rot,tr,xyz1)
      call arrgive(9,rot,rot0)
c	write(6,*) 'rot',rot
c	write(6,*) 'tr',tr
c
c	write(6,*) 'rot',rot
c	if (dump) then
c	 do i = 1, natm
c	  type 15, (xyz1(j,i),j=1,3), (xyz2(j,i),j=1,3)
c	 end do
c	end if
c15	format(2(4x,3f8.3))
c
      if (rms.gt.2.*hrms) then
       rmst = rms
       return
      end if
      rmsold1 = rms
      rmsold = rms
c	write(6,*) 'start rms',rmsold

c calculate the error vz
      do i = 1, natm
       n = i - 1
       dis(i) = xyz2(3,i) - xyz1(3,i)
      end do
      rmsvz = vem(natm,dis)/natm
      vzold = vz
      rmsvzold = rmsvz

10	continue
c calculate the refine matrix of vz
      do i = 1, natm
       n = i - 1
       vt(i) = n
      end do
c
c	do i = 1, natm
c	 write(6,*) 'vt ',(vt(i),i=1,natm)
c	 write(6,*) 'dis',(dis(i),i=1,natm)
c	end do
      CALL LSQEQ(NATM,1,VT,DIS,dt,VVV,b1)
c
      vz = vz - dt
      do i = 1, natm
       n = i - 1
       dis(i) = vz*n - xyz1(3,i)
      end do
      rmsvz = vem(natm,dis)/natm
c
       nrefvz = nrefvz + 1
c	 write(6,*) 'rmsvzold, rmsvz, dt, ',rmsvzold, rmsvz,dt
c	 write(6,*) 'new and old vz,cycle', vz, vzold ,nrefvz
      if ((rmsvzold-rmsvz).gt.0.0005) then
       rmsvzold = rmsvz
       vzold = vz
       goto 10
      end if
       nrefvz = nrefvz - 1
      vz = vzold
      rmsvz = rmsvzold
c
c	write(6,*) 'final vz and rms of vz', vz, rmsvz
c
c calculate the error r and alfa
      do i = 1, natm
       n = i - 1
       dis(2*n+1) = xyz2(1,i) - xyz1(1,i)
       dis(2*n+2) = xyz2(2,i) - xyz1(2,i)
      end do
      call arrgive(2,ra,raold)
      rmsra = vem(2*natm,dis)/(2*sqrt(float(natm)))
      rmsraold = rmsra
c	write(6,*)' rmsra',rmsra

20	continue
c calculate the refine matrix of r and alfa
      do i = 1, natm
       n = i - 1
       vt( 2*n+1 ) = cos(n*ra(2))
       vt( 2*n+2 ) = sin(n*ra(2))
       vt( 2*n+1 + natm*2 ) = - n * ra(1) * sin(n*ra(2))
       vt( 2*n+2 + natm*2 ) =   n * ra(1) * cos(n*ra(2))
c	 write(6,*) 'vt:',vt(2*n+1),vt(2*n+1+2*natm),'dis',dis(2*n+1)
c	 write(6,*) 'vt:',vt(2*n+2),vt(2*n+2+2*natm),'dis',dis(2*n+2)
      end do
c
      call lsqeq(2*natm,2,vt,dis,deta,vvv,b1)

      call arrps(2,1,raold,deta,ra)
c calculate the error r and alfa
      do i = 1, natm
       n = i - 1
       xyz2(1,i) = ra(1)*cos( n*ra(2) )
       xyz2(2,i) = ra(1)*sin( n*ra(2) )
c	 xyz2(3,i) = n*vz
       dis(2*n+1) = xyz2(1,i) - xyz1(1,i)
       dis(2*n+2) = xyz2(2,i) - xyz1(2,i)
      end do
      rmsra = vem(2*natm,dis)/(2*sqrt(float(natm)))
c
       nrefra = nrefra + 1
      if (dump) then
        write(6,*)'rmsraold, rmsra',rmsraold,rmsra
        write(6,*)'new and old ra', ra(1),ra(2)*deg,raold(1),
     1       raold(2)*deg
        write(6,*)'cycle and deta ',nrefra,deta(1),deta(2)*deg
      end if
      if (rmsraold.gt.rmsra) then
       rmsraold=rmsra	
       call arrgive(2,ra,raold)
       goto 20
      end if
      nrefra = nrefra - 1
      rmsra = rmsraold
      call arrgive(2,raold,ra)
c	write(6,*) 'with cycle',nrefra
c	write(6,*) 'Final ra and rms of ra', ra(1), ra(2)*deg, rmsra
c
c
c Generate an ideal alpha helix
      do i = 1, natm
       n = i -1
       xyz2(1,i) = ra(1)*cos( n*ra(2) )
       xyz2(2,i) = ra(1)*sin( n*ra(2) )
       xyz2(3,i) = n*vz
      end do
c
      call fitca(natm,xyz0,xyz2,rot,tr)
      call rtmov(natm,xyz0,rot,tr,xyz1)
c
c	write(6,*)'Nref, Nref1', Nref,Nref1
c
       nrefall = nrefall + 1
c	 write(6,*) 'rmsold, rms cycle',rmsold, rms, nrefall
      if (rmsold.gt.rms) then
       if (rmsold-rms.ge.0.005) then
        rmsold=rms	
        goto 10
       end if
      end if
       nrefall = nrefall - 1
c	call ivsn(3,rot0,b1,b2,me,de,1e-2)
c	call matmult(3,3,3,3,rot,rot0,rch)
c	call mtopolorz(rch,b1,b2)
      call arri(3,3,rot,b1,3)
      call arri(3,3,rot0,b2,3)
      if (dump) then
       write(40,*) 'old rms',rmsold1,'final rms',rms,'cycle',nrefall
       write(50,*) 'radiu',ra(1),'rot/Ca',ra(2)*deg
     1 ,'Go/Ca', vz,'angle chg',angle(b1,b2)
      end if
      rmst = rms
40	format(1x,2(a10,f7.2),a10,i4)
50	format(1x,4(a10,f7.2))
c	write(6,*) 'changed angle between axis:',angle(b1,b2)
      call antiarr(3,3,rot,rch)
      call arrvalue(3,b1,0.)
      b1(3) = xyz1(3,1)
      call arrps(3,1,b1,tr,b2)
      call matmult(3,3,3,1,rch,b2,xalfa(1,1))
      b1(3) = xyz1(3,natm)
      call arrps(3,1,b1,tr,b2)
      call matmult(3,3,3,1,rch,b2,xalfa(1,2))
C	write(6,'(6f10.5)') xalfa
      END
c
 	SUBROUTINE REFBETA ( NATM, XYZ0, XBETA)
c This is a program to get the direction vector of a line expressed as:
c
C	x-x0     y-y0     z-z0
c      ------ = ------ = ------
c        a        b        c
c
c where (x0,y0,z0) is the center of all the Ca atoms on the strand
c (a,b,c) is the vector of the line equation and |a,b,c| is 1.
c
c Refine (a,b,c) to fit the line with a real beta strand of protein i.e.
c let Sigma( dist(Ca--line) ^4 ) =minimum
c Finally it get out the start and ending position which one line 
c of this strand.
c
c Parameter description:
c  NATM, number of the Ca atoms of this beta strand.
c  XYZ0,  3*NATM dimension array contains coordinates of the Ca atoms.
c  XBETA(3,2) the output 2 position of which, a straight line was setup
c  to which Sigma(distance^4) of all Ca atoms was minimum
c syntax:
c 	SUBROUTINE REFBETA ( NATM, XYZ0, XBETA)
c	REAL XYZ0(3,NATM), xbeta(3,2)
c
c Written by Guoguang 91-12-16
c

C	COMMON/RMS/ RMS,SMEAN,NREF,NREF1
      COMMON/TOPDUMP/ DUMP,LIST
      COMMON/TOPSND/ RMS
c	COMMON/SHIFS/ SCALR,SCALS
      PARAMETER (NATM0 = 1500)
c   NATM0 is the largest number of atoms.
      LOGICAL*1 DUMP,LIST
      REAL XYZ0(3,NATM), XBETA(3,2)
      REAL VEC(3,NATM0),CEN(3),BT(3)
      REAL VT(3*NATM0),DIS(NATM0)
      REAL ATA(3,3),B1(3),DETA(3)
      integer nb
c
      nb = 1
      if (natm.eq.2) then
       call arrgive(3*2,xyz0, xbeta)
       rms = 0.
       IF (DUMP) WRITE(6,*)'rms',rms
       return
      end if
      CALL AVERG(3,NATM,XYZ0,CEN)
      CALL POS2VEC(NATM,XYZ0,VEC)
c
      CALL ARRPS(3,1,VEC(1,NATM),VEC(1,1),BT)
      CALL ARRMC(3,1,BT,1./VEM(3,BT),BT)
      CALL ARRMC(3,1,BT,POIMULT(3,3,VEC(1,1),BT),B1)
      CALL ARRAD(3,1,B1,CEN,XBETA(1,1))
      CALL ARRMC(3,1,BT,POIMULT(3,3,VEC(1,NATM),BT),B1)
      CALL ARRAD(3,1,B1,CEN,XBETA(1,2))
10	DO I = 1, NATM
       P = POIMULT(3,3,VEC(1,I),BT)
       DIS(I) = DOSQ(3,VEC(1,I)) - P*P
      END DO
      RMS = SQRT(SQRT(DOSQ(NATM,DIS)/NATM))
      IF (DUMP) WRITE(6,*)'rms',rms
      return
c	write(4,'(A1,3f10.2)') 'M',(XBETA(I,1),I=1,3)
c	write(4,'(A1,3f10.2)') 'L',(XBETA(I,2),I=1,3)
c
c
c	if (natm.eq.3) goto 10
C
c	DO I = 1, NATM
c	 P = POIMULT(3,3,VEC(1,I),BT)
c	 DIS(I) = DOSQ(3,VEC(1,I)) - P*P
cc	  DO J = 1, 3
c	   VT( I+(J-1)*NATM ) = -2. * P * VEC(J,I)
c	  END DO
c	END DO
c	RMSOLD = SQRT(SQRT(DOSQ(NATM,DIS)/NATM))
cC
c	CALL LSQEQ(NATM,3,VT,DIS,DETA,ATA,B1)
cC
c	CALL ARRPS(3,1,BT,DETA,BT)
cC
cc10	DO I = 1, NATM
c	 P = POIMULT(3,3,VEC(1,I),BT)
c	 DIS(I) = DOSQ(3,VEC(1,I)) - P*P
c	END DO
c	RMS = SQRT(SQRT(DOSQ(NATM,DIS)/NATM))
c	if (natm.eq.3) rmsold=rms
cC
c	WRITE(6,*)'rmsold,rms',rmsold,rms
c	CALL ARRMC(3,1,BT,POIMULT(3,3,VEC(1,1),BT),B1)
c	CALL ARRAD(3,1,B1,CEN,XBETA(1,1))
c	CALL ARRMC(3,1,BT,POIMULT(3,3,VEC(1,NATM),BT),B1)
c	CALL ARRAD(3,1,B1,CEN,XBETA(1,2))
cC
c	WRITE(6,'(6F10.5)') XBETA
cC
      END
c
      SUBROUTINE REFTOP ( NATM, XYZ1, XYZ2, A, VT, DIS )
C	DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3)
C	DIMENSION VT(3*NATM,3), DIS(NATM,3)
C
C This subroutine to refine the superimpose matrix and vector from MOL1 to 
c MOL2 i.e. XYZ2(3*NATM) = A(3*3) * XYZ1(3*NATM) + T(3)
c
C Where    NATM represents the number of the atoms in each molecule
c                which will be superimposed.
c          XYZ1(3,NATM) represents the coordinates of MOL1
c          XYZ2(3,NATM) represents the coordinates of MOL2
C          A(3*3)       represents the input initial matrix and 
c                       output matrix.
C          VT(3*6*NATM)   is a 6*NATM-dimensional buffer array
C          DIS(3*NATM)  is a 3*NATM-dimensional buffer array
c
c The program use atom-atom vector to proceed the Eulerian angle least 
c square refinement. It has been tested that this method might be more
c accurate than others at least in orientation.
c
c                                           by Guoguang Lu
c                                               30/01/1989
c This is specially modified for program package TOP, the following things 
c have been changed:
C 1. real matched number natm = MATCH*3 + MATCH*(MATCH-1)/2
c    a.  The first 2*match are atoms
c    b.  The second match are vectors
c    c.  the rest are line-line vector
c  where  b. and c. are in the same modula so to be used as angle.
c 2 common/rmstop/rmsa,rmsang,nref
c    rmsa represent rms of term a.
c    rmsang represent rms of term b and c.
c    nref is the number of cycle of refine.
c updated by guoguang 91-12-17 bmc
c
      PARAMETER (MAXMATCH = 1500)
      PARAMETER (NATM0 = MAXMATCH*3+MAXMATCH*(MAXMATCH-1)/2 )
c   NATM0 is the largest number of atoms.
      COMMON/RMSTOP/ RMSA,RMSANG,NREF
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3)
      DIMENSION VT(3*NATM,3), DIS(3,NATM)
      DIMENSION VEC1(3,NATM0),VEC2(3,NATM0),VEC1P(3,NATM0)
C
      DIMENSION DA(3,3,3),VVV(3,3)
      DIMENSION B1(3),B2(3),ROHOLD(3),ROH(3),DETAROH(3),TOLD(3)
      REAL*4 SCALR
      data SCALR/1./
C
      DEG=180./3.14159265359
      NREF=0
c	NREF1=0
C
      CALL MTOHUBER(A,ROH,B1)
c
c calculate the atom-atom vector
c
c	CALL POS2VEC(NATM,XYZ1,VEC1)
c	CALL POS2VEC(NATM,XYZ2,VEC2)
      call arrgive(3*natm,xyz1,vec1)
      call arrgive(3*natm,xyz2,vec2)
C
      CALL MATMULT(3,3,3,NATM,A,VEC1,VEC1P)
      CALL ARRPS(3,NATM,VEC1P,VEC2,DIS)
C                                  A*V1 - V2
      RMS1= DOSQ( 3*NATM, DIS )
      RMS = RMS1
C
50	CONTINUE
C 
C  Refine the superimposing Eulerian Angle'
c
C	WRITE(6,'(1H0)')
C	WRITE(6,*) 'Cycle of Eulerian angle refinement ',NREF
C	WRITE(6,*) 'Superimposing matrix'
C	WRITE(6,10) ((A(I,J),J=1,3),I=1,3)
C	WRITE(6,*) 'Eulerian Angle', ROH
C10	format (3F10.5)
C	WRITE(6,*) 'SIGMA (Deta vector)^2 =', RMS
C
C
c
C COMPUTE THE DETATH1,DETATH2,DETATH3 than the normal matrix
C
      DO I = 1, 3
      CALL DRVROHTH(I,ROH,DA(1,1,I))
      CALL MATMULT(3,3,3,NATM,DA(1,1,I),VEC1,VT(1,I))
C                                (DERIV(A)/DERIV(THETAi))*VEC1
      END DO
c
      CALL LSQEQ(NATM*3,3,VT,DIS,DETAROH,VVV,B1)
C To change it into degree from arc unit
      CALL ARRMC(3,1,DETAROH,DEG,DETAROH)
C
      CALL ARRMC(3,1,DETAROH,-SCALR,DETAROH)
C	WRITE(6,*) 'DetaROH = ',DETAROH	
      CALL ARRMC(3,1,ROH,1.,ROHOLD)
C                            SAVE THE PREVIOUS ROH
      CALL ARRAD(3,1,ROHOLD,DETAROH,ROH)
C                                     ROH=ROHOLD+DETAROH
      CALL HUBER(ROH,A)
C                       NEW MATRIX
      CALL MATMULT(3,3,3,NATM,A,VEC1,VEC1P)
      CALL ARRPS(3,NATM,VEC1P,VEC2,DIS)
C                                  A*V1 - V2
      RMS=dosq(3*NATM,DIS)
C
      IF (RMS.LT.RMS1) THEN
      RMS1=RMS
      NREF=NREF+1
      GOTO 50
      END IF

C	WRITE(6,'(1H0)')
C	WRITE(6,*) 'That is the final rotation result.'
C	WRITE(6,'(1H0)')
      CALL ARRMC(3,1,ROHOLD,1.,ROH)
      CALL HUBER(ROH,A)
C                       NEW MATRIX
      CALL MATMULT(3,3,3,NATM,A,VEC1,VEC1P)
      CALL ARRPS(3,NATM,VEC1P,VEC2,DIS)
C                                  A*V1 - V2
c rmsa and rmsang will be calculated outside
c	rmsa = sqrt(dosq(2*3*match,dis)/match)
      END 
c
      SUBROUTINE 
     +   morefit(FILE1,FILE2,A,T,DSTMIN,LSTRES,mfit,rate,rmsf,smf,
     +  filout,l4)
c original is SUPOS --> FIT ---> FITMORE
C!                      by Guoguang LU    *** 30/01/1989/ ***
c	updated at Purdue by Guoguang into free card format input
c!	add omit option!
c	add no refine option (just check how much changed)
c
c 	Now this is a subroutine morefit serving TOP -- 950925
c	In this subroutine, file 2 is superimposed to file 1
c
      PARAMETER (MAXATM=20000,MAXFR=1500)
      COMMON/RMS/ RMS,SMEAN,NREF,NREF1
      common/moreflag/ writ,comp
      character*80 file1,file2,filout,fileold1,filout0,fileold2
      common/outfil/ filout0
c	real A(3,3)/1.,0.,0.,0.,1.,0.,0.,0.,1./,T(3)/0.,0.,0./,ROH(3)
      real A(3,3),T(3),ROH(3),AOLD0(3,3),TOLD0(3,3)
      real diff(MAXATM) , diff2(MAXATM)
      integer ir(MAXATM),len(MAXFR),nfile2
      data nfile2/1/
      REAL XALL1(3,MAXATM),XALL2(3,MAXATM),XALL1P(3,MAXATM)
      REAL XCB1(3,MAXATM),XCB2(3,MAXATM),XCB0(3,MAXATM)
      real dstmin,SCALR,SCALT,rmsold,smeanold
      integer lstres,maxcyc,ncycle,natmold
      data maxcyc/20/
      DIMENSION XYZ1(3,MAXATM),XYZ1P(3,MAXATM),XYZ12(3,MAXATM)
      DIMENSION XYZ2(3,MAXATM),B1(3),B2(3)
      CHARACTER*4 ATOM,TYPE(20),RES1*5, RES2*5,RES*5,RES0*5
      CHARACTER ATEXCL(20)*4,SEQEX1(20)*5,SEQEX2(20)*5
      CHARACTER TITLE*80,key*80,gg_res3to1*1
      character satm1(MAXATM)*4,sres1(MAXATM)*4,sseq1(MAXATM)*4
      character satm2(MAXATM)*4,sres2(MAXATM)*4,sseq2(MAXATM)*4
      character seq2last*4,rnam*4,namnow*6,ch*1,chold*1
      data chold/' '/
      character atmnam1(MAXATM)*4,resnam1(MAXATM)*4,seqnam1(MAXATM)*4
      character atmnam2(MAXATM)*4,resnam2(MAXATM)*4,seqnam2(MAXATM)*4
      LOGICAL*1 IN,ALLATM,ALLRES
      logical*1 cbb1(maxatm),
     +          cbb2(maxatm)
      data cbb1/maxatm*.false./,cbb2/maxatm*.false./
      logical*1 writ,comp
      character*5 RES11(20),RES12(20),RES21(20),RES22(20)
      logical*1 dump,list
      COMMON/TOPDUMP/ DUMP,LIST
      common/natmmatch/ natm,natm1,natm2
      COMMON/STGCON/ STRPA,FPUM
      COMMON/NUMPUM/ NPUM
      common/cb/ cbeta,agbeta
      COMMON/SHIFS/ SCALR,SCALS
      save fileold1,fileold2
      save xall1,xall2
      save xcb1,xcb2
      save seqnam1,resnam1
      save seqnam2,resnam2
c	save natm1,natm2
c
c	write(6,'(a)')
c	1 '  ======================================================'
c	write(6,'(a)')
c	1 '   Extending the comparisons......'
      if (dump) write(6,*) file1,file2
c
c      NATM = 0
c      NATM2 = 0

c	WRITE(6,*) 'how many types of atoms to be compared? '
      SCALR=1.
      SCALT=1.
C
      IN = .false.
      ifrag1 = 0
      ifrag2 = 0
      natexcl = 0
      nresexcl1 = 0
      nresexcl2 = 0
      rms = 999.99
      rmsold = rms
      smean = 999.99
      smeanold = smean
      ncycle = 0
      natmold = natm
c
C
      if (file2.ne.fileold2) then
       nfile2 = 1
      else
       nfile2 = nfile2 + 1
      end if
c
      if (fileold2.ne.file2) then
       if (cbeta.gt.0) then
       call getpdbcacb(xall1,xcb1,cbb1,seqnam1,resnam1,natm1,ncb1,file2)
       else
        call getpdbca(xall1,atmnam1,seqnam1,resnam1,natm1,file2)
       end if
       if (dump) then
        write(6,*) natm1, ' residues in MOL1'
        if (cbeta.gt.0) write(6,*) ncb1,' Cbeta atoms read in'
       end if
      end if
      if (fileold1.ne.file1) then
       if (cbeta.gt.0) then
       call getpdbcacb(xall2,xcb2,cbb2,seqnam2,resnam2,natm2,ncb2,file1)
       else
        call getpdbca(xall2,atmnam2,seqnam2,resnam2,natm2,file1)
       end if
       if (dump) then
        write(6,*) natm2, ' residues in MOL2'
        if (cbeta.gt.0) write(6,*) ncb2,' Cbeta atoms read in'
       end if
      end if
      fileold1 = file1
      fileold2 = file2
      if (natm1.eq.0) then
c	 write(6,*) 'ERROR>>> failed to open file ',file2
       return
      else if (natm2.eq.0) then
c	 write(6,*) 'ERROR>>> failed to open file ',file1
       return	
      end if
c
6000	continue
      NPUM = 0
      seq2last = '    '
      chold = ' '
      rewind (14)
      call rtmov(natm1,xall1,a,t,xall1p)
      if (cbeta.gt.0) then
       call matmult(3,3,3,natm1,a,xcb1,xcb0)
      end if
c
c	print*,'a,t',a,t
c	do i =1, 10
c	 print*, (xall1(j,i),j=1,3),(xcb1(j,i),j=1,3)
c	 print*, (xall1p(j,i),j=1,3),(xcb0(j,i),j=1,3)
c	 print*, (xall2(j,i),j=1,3),(xcb2(j,i),j=1,3)
c	end do
c
      if (cbeta.gt.0) then
       do i1 = 1, natm1
        ir(i1) = 0
        diff(i1) = 100.
        if (cbb1(i1)) then
         do i2 = 1, natm2
          d0 = dist(xall1p(1,i1),xall2(1,i2))
          if (d0.lt.diff(i1)) then
           if (cbb2(i2)) then
            dss = dist(xcb0(1,i1),xcb2(1,i2))
            if (dss.lt.cbeta) then
             ir(i1) = i2
             diff(i1) = d0
            end if
           else 
            ir(i1) = i2
            diff(i1) = d0
           end if
          end if
         end do
        else
         do i2 = 1, natm2
          d0 = dist(xall1p(1,i1),xall2(1,i2))
          if (d0.lt.diff(i1)) then
           ir(i1) = i2
           diff(i1) = d0
          end if
         end do
        end if
       end do
      else
       do i1 = 1, natm1
        ir(i1) = 0
        diff(i1) = 100.
        do i2 = 1, natm2
         d0 = dist(xall1p(1,i1),xall2(1,i2))
         if (d0.lt.diff(i1)) then
          ir(i1) = i2
          diff(i1) = d0
         end if
        end do
       end do
      end if
c Now let's find matching fragments
      ien1 = 0
      natm = 0
      nfr = 0
6001	ien1 = ien1 + 1
      if (diff(ien1).lt.dstmin) then
       nfr = nfr + 1
       do imr = ien1 + 1, natm1
        if (.not.(diff(imr).lt.dstmin.and.
     1     (imr-ien1).eq.(ir(imr)-ir(ien1))) ) goto 6002
       end do 
       imr = natm1 + 1
6002	 len(nfr) = imr - ien1
       if (len(nfr).lt.lstres) then
        nfr = nfr -1
        goto 6003
       end if
       call arrgive(3*len(nfr),xall1(1,ien1),xyz1(1,natm+1))
       call arrgive(3*len(nfr),xall2(1,ir(ien1)),xyz2(1,natm+1))
       do i = 1, len(nfr)
c	  satm1(natm+i) = atmnam1(ien1+i-1)
        sres1(natm+i) = resnam1(ien1+i-1)
        sseq1(natm+i) = seqnam1(ien1+i-1)
c	  satm2(natm+i) = atmnam2(ir(ien1+i-1))
        sres2(natm+i) = resnam2(ir(ien1+i-1))
        sseq2(natm+i) = seqnam2(ir(ien1+i-1))
       end do
        write(14,6011) 'Fragment',nfr,'   length',len(nfr),
     1      sseq1(natm+1),sseq1(natm+len(nfr)),
     2 '--',sseq2(natm+1),sseq2(natm+len(nfr))
6011	 format(2(a,i4),4x,2(1x,a),1x,a,1x,2(1x,a))
       write(14,'(50a)') (gg_res3to1(sres1(natm+i)(1:3)),i=1,len(nfr))
       write(14,'(50a)') (gg_res3to1(sres2(natm+i)(1:3)),i=1,len(nfr))
       if (dump) then
        write(6,'(20a)') (sres1(natm+i),i=1,len(nfr))
        write(6,'(20a)') (sres2(natm+i),i=1,len(nfr))
        write(6,'(20a)') (sseq1(natm+i),i=1,len(nfr))
        write(6,'(20a)') (sseq2(natm+i),i=1,len(nfr))
        write(6,*) 'nfr,ien1,imr,natm',nfr,ien1,imr,natm
       end if
c permutation consideration
       if (STRPA.gt.1) then
        namnow=sseq2(natm+1)//'  '
        call namreset2(namnow,ch,rnam)
c	  if (dump) write(6,*) nfr,rnam,seq2last,ch,chold
        if (nfr.gt.1.and.rnam.lt.seq2last.and.ch.eq.chold) then
         npum = npum + 1
         if (dump) write(6,*) 'Sequence permutation is found',npum
        end if
       end if
       seq2last = rnam
       chold = ch
       ien1 = imr -1
       natm = natm + len(nfr)
      end if
6003	if (ien1.lt.natm1) goto 6001
c
      ncycle = ncycle + 1
c Now let's use new alignment to superimpose
      if (dump) write(6,*) 'Lets refine',natm,' atoms'
      IF (NATM.GE.6) THEN
       call rtmov(natm,xyz1,a,t,xyz12)
       call arrps(3,natm,xyz12,xyz2,xyz1p)
       tmprms = 0.
       tmpmean = 0.
       do iatmp = 1,natm
        diff(iatmp) = vem(3,xyz1p(1,iatmp))
        tmprms = tmprms + diff(iatmp)*diff(iatmp)
        tmpmean = tmpmean + diff(iatmp)
       end do
       d2rms = sqrt(tmprms/float(natm))
       d2mean = tmpmean/float(natm)
c	 call STATIS(natm,diff,d2mean,d2rms,df2mean)
c	 write(6,*) 'beforeL dmean,rms',d2mean,d2rms
       call arrgive(9,a,aold0)
       call arrgive(3,t,told0)
       CALL FITCA(NATM,XYZ1,XYZ2,A,T)
       if (d2mean.lt.smean.and.d2rms.lt.rms) THEN
        call arrgive(9,aold0,a)
        call arrgive(3,told0,t)
        rms = d2rms
        smean = d2mean
        goto 6015
       end if
c	 write(6,*) 'after: Dmean,rms',smean,rms
      ELSE
       rms = 999.99
       rmsold = rms
       smean = 999.99
       smeanold = smean
       natmold = natm
      END IF
      if (dump) then
       write(6,3010) ncycle,natm,nfr,rms
      end if
       
3010	format(1x,'Cycle=',i3,4x,'Residues=',i4
     1 ,4x,'fragment=',i4,4x,'r.m.s.=',f5.2)
c	 write(6,*) 'nfr,ien1,imr,natm',nfr,ien1,imr,natm
c	if ((rms.ne.rmsold .or. smean.ne.smeanold .or. natm.ne.natmold)
c	1 .and. (ncycle.lt.maxcyc)) then
      if ( (abs(rms-rmsold).gt.1.e-3 .or. 
     1 abs(smean-smeanold).gt.1.e-3 .or. natm.ne.natmold)
     2 .and. (ncycle.lt.maxcyc)) then
       rmsold = rms
       smeanold = smean
       natmold = natm
       goto 6000
      end if
6015	continue
      rate = 100.*float(natm)/float(natm2)
      if (natm.lt.3) then
       write(6,*) 'No Ca atoms match in this superimposition'
      end if
      mfit = natm
      rmsf=rms
      smf=smean
      if (STRPA.gt.1.and.npum.gt.1) then
       FPUM = STRPA**(FLOAT(NPUM*(NPUM-1)))
      else 
       FPUM = 1.
      end if
c
10	FORMAT(3F10.5)
c11	FORMAT(2(3F10.5,5X), F10.5)
11	FORMAT(2(2x,A,1x,A,1x,A,2x),f8.3)
12	FORMAT(3F10.5,38X,A4,3X,A4)
      IF (WRIT.and.natm.ge.6) THEN
       CALL CCPDPN(1,FILE2,'READONLY','F',0,0)
       il = lenstr(file2)
       call getnamstem(file1(1:78),istart1,iend1,ierr)
       call getnamstem(file2(1:78),istart2,iend2,ierr)
       filout = file2(istart2:iend2)//'_'//file1(istart1:iend1)//
     +            file2(iend2+1:il)
c	 l4 = (iend1-istart1+1)+(iend2-istart2+1)+(il-iend2)
       l4 = il-istart2+(iend1-istart1)+3
       filout0 = filout(1:l4)
       if (nfile2.ge.1) then
        filout(l4+1:l4+1) = '_'
        write(filout(l4+2:l4+4),'(i3)') nfile2
        call spstrunct(filout(l4+2:l4+4))
        l4 = l4+4
       end if
       CALL CCPDPN(4,filout(1:l4),'UNKNOWN','F',0,0)
c	 REWIND 1
99	 READ (1,'(A70)',END =100) Title
       if (title(1:4).ne.'ATOM'.and.title(1:6).ne.'HETATM') then
        il = lenstr(title)
        WRITE(4,'(A)') TITLE(1:il)
        GOTO 99
       end if
       READ(title(31:54),'(3F8.3)') B1
       CALL RTMOV(1,B1,A,T,B2)
       WRITE(title(31:54),'(3F8.3)') B2
       il = lenstr(title)
       WRITE(4,'(A)') TITLE(1:il)
       GOTO 99
100	 CONTINUE
       CLOSE (1)
       CLOSE (4)
      END IF
C
      RETURN 
      END
c
      subroutine showfit(iunit,itot,isame,per)
      character*80 key
      character*50 seq1(100),seq2(100),iden(100),iden0
      character*4 rbeg1,rend1,rbeg2,rend2
      character*14 wtab1,wtab2
      data wtab1/'              '/,wtab2/'              '/
      common/natmmatch/ natm,natm1,natm2
c
      if (natm.lt.3) return
      rewind (iunit)
      write(6,1002)
      write(6,'(1x,a)') 'begin end     Sequence Matching'
      write(6,1002)
1002	format(1x,70('-'))
c
      itot = 0
      isame = 0
      if (natm.lt.3) return
      iden0 = '                                                  '
1	read(iunit,1001,end=2) nfr,lfr,rbeg1,rend1,rbeg2,rend2
      itot = itot + lfr
1001	format(8x,i4,9x,i4,4x,2(1x,a),1x,2x,1x,2(1x,a))
      line = int(float(lfr-1)/50.) + 1
      do iline = 1, line
       read(iunit,'(a)') seq1(iline)
      end do
      do iline = 1, line
       read(iunit,'(a)') seq2(iline)
      end do
c
      do iline = 1, line
       iden(iline) = 
     +     '                                                  '
       do is = 1, 50
        if (seq1(iline)(is:is).ne.' '.and.
     1  seq1(iline)(is:is).eq.seq2(iline)(is:is)) then
         iden(iline)(is:is)='|'
         isame = isame + 1
        end if
       end do
       if (iline.eq.1) then
        wtab1(2:5) = rbeg1
        wtab2(2:5) = rbeg2
       else
        wtab1(2:5) = '   '
        wtab2(2:5) = '   '
       end if
       if (iline.eq.1) then
        wtab1(7:10) = rend1
        wtab2(7:10) = rend2
       else
        wtab1(7:10) = '   '
        wtab2(7:10) = '   '
       end if
c
       write(6,'(1x,a,a)') wtab2,seq2(iline)
       if (iden(iline).ne.iden0) write(6,'(15x,a)') iden(iline)
       write(6,'(1x,a,a)') wtab1,seq1(iline)
       write(6,*)
      end do
c
      goto 1
2	continue
      if (isame.gt.0) then
       per = 100.*float(isame)/float(itot)
c	 write(6,1002)
c	 write(6,1003) 'Matching residues=',itot,'Identical residues=',isame,
c	1 'Identity=',per,'%'
      else
       per = 0.
      end if
1003	format(1x,a,i4,4x,a,i4,4x,a,f5.1,a)
      end
      SUBROUTINE ORIEN1 ( NATM, XYZ1, XYZ2, A )
c The subroutine selects three atoms to calculate the initial superposing
c matrix A from two molecules in 3*4 array XYZ1 and XYZ2 individually.
c Parameter description:
c NATM is the number of the atoms
c	DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3)
c XYZ1(3,NATM) represent the XYZ of molecule 1
c XYZ2(3,NATM) represent the XYZ of molecule 2
c A is the output superposing matrix.
c	COMMON/IAT/ IAT1,IAT2,IAT3,IAT
c	DATA IAT/0/
c Atoms IAT1, IAT2 and IAT3 are used to calculate the matrix. It could be
c decided outside the routine if IAT are less than 0.
c
c 
      COMMON/IAT/ IAT1,IAT2,IAT3,IAT
      DATA IAT/0/,IAT1/1/,IAT2/2/,IAT3/3/
      DIMENSION XYZ1(3,NATM), XYZ2(3,NATM), A(3,3)
      DIMENSION V11(3),V12(3)
      DIMENSION V21(3),V22(3)
      DIMENSION C1(3,3),C2(3,3),C1P(3,3)
      DIMENSION B1(3),B2(3),AOLD(3,3)
      EXTERNAL  ACOSD
c
c If IAT = 0, define the three atoms which are used to calculate the 
c  initial orientational matrix
c
      ang0 = 10.
      CALL ARRGIVE(9,A,AOLD)
      IF (IAT.EQ.0) THEN
       IAT1 = 1
       IF (NATM.GE.6) THEN
        IAT2 = INT(FLOAT(NATM)/3.) + 1
        IAT3 = 2*INT(FLOAT(NATM)/3.) + 1
       ELSE
        IAT2 = 2
c	  IAT3 = 3
        IAT3 = NATM
       END IF
      ELSE IF (IAT.EQ.1) THEN
       IAT1 = 1
       NNATM = INT(FLOAT(NATM)*2./3.)
       IF (NNATM.GE.6) THEN
        IAT2 = INT(FLOAT(NNATM)/3.) + 1
        IAT3 = 2*INT(FLOAT(NNATM)/3.) + 1
       ELSE
        IAT1 = NATM
        IAT2 = NATM - 1 
        IAT3 = 1 
       END IF	 
      END IF
      iat20 = iat2
14	continue
      call arrps(3,1,xyz1(1,iat2),xyz1(1,iat1),b1)
      call arrps(3,1,xyz1(1,iat3),xyz1(1,iat1),b2)
      vb1 = vem(3,b1) 
      if (vb1.lt.1e-2) goto 60
      vb2 = vem(3,b2) 
      if (vb2.lt.1e-2) goto 60
      call arrmc(3,1,b1,1./vb1,v11)
      call arrmc(3,1,b2,1./vb2,v12)
      ang = acosd(abs(poimult(3,3,v11,v12)))
      if (ang.lt.ang0) goto 60
c	
c	
15	if (dist(xyz1(1,iat1),xyz1(1,iat2)).lt.1.e-3.or.
     +      dist(xyz2(1,iat1),xyz2(1,iat2)).lt.1.e-3) then
       iat1=iat1+1
       if (iat1.lt.iat2) goto 14
C	 call elize(3,a)
       CALL ARRGIVE(9,AOLD,A)
       print*, 'Warning: not give any matrix: -orien'
       return
      end if
16	if (dist(xyz1(1,iat2),xyz1(1,iat3)).lt.1.e-3.or.
     +      dist(xyz2(1,iat2),xyz2(1,iat3)).lt.1.e-3) then
       iat2=iat2+1
       if (iat2.lt.iat3) goto 14
c	 call elize(3,a)
       call arrgive(9,aold,a)
       print*, 'Warning: not give any matrix: -orien'
      end if
17	if (dist(xyz1(1,iat1),xyz1(1,iat3)).lt.1.e-3.or.
     +      dist(xyz2(1,iat1),xyz2(1,iat3)).lt.1.e-3) then
       iat1=iat1+1
c	 if (iat1.eq.iat2) iat1=iat1+1
       if (iat1.lt.iat2) goto 14
c	 call elize(3,a)
       call arrgive(9,aold,a)
       print*, 'Warning: not give any matrix: -orien'
      end if
C
C Calculate the initial matrix and the Eulerian angle.
c 
C
C  calculate the matrix 1
20	continue
      CALL ARRPS(3,1,XYZ1(1,IAT2),XYZ1(1,IAT1),V11)  
      CALL ARRPS(3,1,XYZ1(1,IAT2),XYZ1(1,IAT3),V12)
      IF (VEM(3,V12).LT.1E-2) GOTO 50
      CALL ARRMC (3,1,V12,1./VEM(3,V12),C1(1,1))
      CALL VECCRSMLT (V12,V11,B1)
      IF (VEM(3,B1).LT.1E-2) GOTO 50
      CALL ARRMC(3,1,B1,1./VEM(3,B1),C1(1,3))
      CALL VECCRSMLT (C1(1,3),C1(1,1),C1(1,2))

C  calculate the matrix 2
      CALL ARRPS(3,1,XYZ2(1,IAT2),XYZ2(1,IAT1),V21)
      CALL ARRPS(3,1,XYZ2(1,IAT2),XYZ2(1,IAT3),V22)
      IF (VEM(3,V22).LT.1E-2) GOTO 50
      CALL ARRMC (3,1,V22,1./VEM(3,V22),C2(1,1))
      CALL VECCRSMLT (V22,V21,B1)
      IF (VEM(3,B1).LT.1E-2) GOTO 50
      CALL ARRMC(3,1,B1,1./VEM(3,B1),C2(1,3))
      CALL VECCRSMLT (C2(1,3),C2(1,1),C2(1,2))

c calculate the matrix A = c2 * c1^-1  (x2= A * x1)
      call ANTIARR(3,3,C1,C1P)
c	print*, 'iat1,iat2,iat3',iat1,iat2,iat3
      CALL MATMULT(3,3,3,3,C2,C1P,A)
C
      return
50	iat2 = iat2 + 1
      if (iat2.eq.iat3) iat2 = iat2 + 1
      if (iat2.le.natm) goto 14
      print*,'warning: cannot give the orientation here'
      print*,'natm,iat,iat1,iat2,iat3',natm,iat,iat1,iat2,iat3
      call elize(3,a)
      call arrvalue(3,t,0.)
      return
60	continue
      iat2 = iat2 + 1
      if (iat2.eq.iat3) iat2=iat2+1
      if (iat2.le.natm.and.iat2.gt.iat20) goto 14
      if (iat2.gt.natm) iat2=iat1+1
      if (iat2.lt.iat20) goto 14
      ang0=ang0*0.7
      if (ang0.gt.2.5) goto 14
c	print*,'warning: cannot calculate the orientation here ang=',ang
c	print*,'natm,iat,iat1,iat2,iat3',natm,iat,iat1,iat2,iat3
      call elize(3,a)
      call arrvalue(3,t,0.)
      END
c
      subroutine getword(keyw)
c this subroutine tries to find if key word exist in the text
c if yes, return a true, otherwise return a false
c   txt is the text to be searched
c   npar is how many line of words
c   keyw is the search words with npar lines
c the program will search if there are word in keyw is in txt too.
c
      logical*1 fw
      character*(*) keyw,txt
      character*80 word(5000)
      integer nkey,nword(100),lw(1000),ntotal
      data nkey/0/,ntotal/0/
      integer nst(100)
      data nst/100*0/
      save nkey,ntotal
      save nword,lw
c
      nkey = nkey + 1
      nst(nkey) = ntotal+1
c
      ln = lenstr(keyw)
c	print*,'word: ',keyw(1:ln)
      call redstrin(13,ln,keyw(1:ln),nword(nkey))
      do iw = 1, nword(nkey)
       ntotal = ntotal + 1
       read(13,'(a)') word(ntotal)
       lw(ntotal) = lenstr(word(ntotal))
      end do
c	print*, nkey,' lines ', nword(nkey),' words in this line',nst(nkey),
c	1 ' start ',ntotal,
c	2 ' words in total'
      return
c
      entry findword(txt,fw)
c	itotal = 0
c	write(6,*) txt
c	write(6,*) nkey
      do ikey = 1, nkey
c	 print*, ikey, nst(ikey)
       do iword = nst(ikey), nst(ikey)+nword(ikey)-1
c	  itotal = itotal + 1
c	  print*, word(iword)(1:lw(iword))
c	  print*, txt
c	  in = index(txt,word(iword)(1:lw(iword)))
c	  print*, 'ikey,iwordnst(ikey),nword(ikey)'
c	1 ,ikey,iword,nst(ikey),nword(ikey),'--',
c	2 nst(ikey),nst(ikey)+nword(ikey)-1
c	  print*, 'in,itotal',in,itotal
        if (index(txt,word(iword)(1:lw(iword))).le.0) goto 10
20	 end do
       fw = .true.
c	 print*, itotal-nword(ikey)+1,itotal
       print*, 
     +    (' ',word(it)(1:lw(it)),it=nst(ikey),nst(ikey)+nword(ikey)-1),
     +    ' ---  found'
       return
10	end do
      fw = .false.
c	print*, 'Words not found in total',itotal,' words'
c	print*, 'Words not found in',txt
c	print*, (word(j)(1:lw(j)),' ',j=1,itotal)
c	print*, 'nkey,ntotal',nkey,ntotal
      return
      end
      function bspdb(site,code,name)
      logical*1 bspdb
      character site*120,code*4
      character name*80
      logical*1 ftppdb,httppdb
c input side, code
c output name
c	read(5,'(a)') site
      isite = lenstr(site)
c	read(5,'(a)') code
      name = code//'.pdb'
      iname = lenstr(name)

        tmd0 = 0.0
        CALL UCPUTM(tmd0)
      if (site(1:3).eq.'ftp') then
       bspdb = ftppdb(site(1:isite),code,name(1:iname))
c	 if (ftppdb(site(1:isite),code,name(1:iname))) then
c         CALL UCPUTM(tmd0)
c	  print*, 'OK, --- CPU: ',tmd0
c	 end if
      else
       bspdb = httppdb(site(1:isite),code,name(1:iname))
c	 if (httppdb(site(1:isite),code,name(1:iname))) then
c         CALL UCPUTM(tmd0)
c	  print*, 'OK, --- CPU: ',tmd0
c	 end if
      end if
      end
c
      subroutine rangscop(file,fileout,text,nsel)
c select zone range (SCOP format)
c file: name of a pdb file
c text is a text string in SCOP format e.g.
c   - a:,	a:11-256, 
c
      COMMON/TOPDUMP/ DUMP,LIST
      parameter (mseg = 10)
      logical*1 dump,list
      character*(*) file,text
      character*5 z1(mseg),z2(mseg)
      character*1,ch1,ch2,chold
      character*4 res1,res2,rrr,rold
      character*80 fileout,str
      logical*1 getin
      il = lenstr(file)
      lff1 = il
      lg = lenstr(text)
      ist = 1
      ien = 1
      nseg = 0
      nsel = 0
      rold = '   '
      chold = ' '
c	if (dump) write(6,*) 'zone: '//text(1:lg)
      if (text(1:lg).eq.'-') then
       nseg = nseg+1
       z1(nseg) = 'ALL'
       z2(nseg) = 'ALL'
       fileout = file
       nseg = 1
       return
      end if
       call nodir(file,str,nf)
       id = index(str(1:nf),'.')-1
       if (id.le.0) id=nf
       fileout = str(1:id)//'_z.pdb'
       call spstrunct(fileout)
       il = lenstr(fileout)
       if (dump.or.list) then
        write(6,'(2a)') 'The actual file is changed to ',fileout(1:il)
       end if
c         OPEN (23,FILE=FILE, STATUS='OLD',READONLY,err=300)
       CALL CCPDPN(23,FILE,'OLD','F',0,0)
       CALL CCPDPN(24,FILEOUT(1:il),'UNKNOWN','F',0,0)
       write(24,'(4a)') 
     +    'REMARK Zone:',text(1:lg),' File:',file(1:il)
10	 continue
       if (ist.ge.lg) goto 200
       nseg = nseg + 1
       ien = index(text(ist:lg),',')+ist-1
       if (ien.le.ist-1) ien = lg+1
       if (dump) write(6,*) 'zone:',text(ist:ien),nseg
       ch1 = ' '
       ch2 = ' '
       if (text(ist+1:ist+1).eq.':') then
        ch1= text(ist:ist)
        ch2= text(ist:ist)
        ist = ist+2
       end if
       if (ist.ge.ien) then
        ist = ien+1
        rewind (23)
231	  read(23,'(a)',end=10) str
        if ((str(1:6).eq.'HEADER'.or.str(1:6).eq.'TITLE'.or.
     +       str(1:6).eq.'COMPND').and.nseg.le.1) then
         lstr = lenstr(str)
         write(24,'(a)') str(1:lstr)
         nsel = nsel + 1
        else if (str(1:3).eq.'END') then
         goto 10
        else if (str(1:4).eq.'ATOM') then
         if (
     +     (ch1.eq.' '.or.ch1.eq.str(22:22) ) .and. 
     +     (ch2.eq.' '.or.ch1.eq.str(22:22) ) ) then
          lstr = lenstr(str)
          write(24,'(a)') str(1:lstr)
          nsel = nsel + 1
         end if
        end if
        goto 231
       end if
       ims = index(text(ist:ien-1),'-')+ist-1
       if (ims.eq.0.or.ims.le.ist.or.ims.ge.ien) then
        print *,'Some thing wrong in Zone definition:',text(1:lg)
        nseg = 0
        return
       end if
       res1 = text(ist:ims-1)
       res2 = text(ims+1:ien-1)
       ist = ien+1
       rewind (23)
       getin = .false.
232	 read(23,'(a)',end=10) str
       if (str(1:4).ne.'ATOM') then
        if ((str(1:6).eq.'HEADER'.or.str(1:6).eq.'TITLE'.or.
     +       str(1:6).eq.'COMPND').and.nseg.le.1) then
         lstr = lenstr(str)
         write(24,'(a)') str(1:lstr)
        else if (str(1:3).eq.'END') then
         goto 10
        end if
        goto 232
       else
        rrr = str(23:26)
        call spstrunct(rrr)
        if (.not.getin) then
     	   if ( (ch1.eq.' '.or.ch1.eq.str(22:22) ) .and. 
     +          (res1.eq.rrr) ) then
          lstr = lenstr(str)
          write(24,'(a)') str(1:lstr)
          nsel = nsel + 1
          getin =.true.
         end if
         goto 232
        else
         if ( (ch2.eq.' '.or.chold.eq.ch2) .and.
     +          (rold.ne.rrr ).and.(rold.eq.res2) ) then
          getin = .false.
          goto 10
         end if
         chold = str(22:22)
         rold = rrr
         lstr = lenstr(str)
         write(24,'(a)') str(1:lstr)
         nsel = nsel + 1
         goto 232
        end if
        goto 232
       end if
200	continue
      write(6,*) 'Total ',nsel,' atoms selected from ',file(1:lff1)
      close (23)
      close (24)
      return
c
300	continue
c	il = lenstr(file)
      write(6,*) 'ERROR: Can not open file ',file(1:lff1)
      nsel = 0
      return
      end
c --
      function ftppdb(site,code,filename)
      logical*1 ftppdb
      character*(*) site,filename
      character*4 code
      character tmp*12,tmpk*80
      character*180 cmd
c
      itry = 0
      ntry = 10
      tmp = code//'wget.tmp'
      ln= lenstr(site)
10	continue
c	inc = index(site
      if (index(site,'current_').ne.0.and.
     +      index(site,'uncompress').eq.0) then
       cmd = 'wget -o '//tmp//' -O '//filename//'.Z '//site(1:6)
     +   //site(7:ln)
     +   //char(47)//code(2:3)//char(47)
     +   //'pdb'//code//'.ent.Z '
       il = lenstr(cmd)
c	 write(6,'(a)') cmd(1:il)
       call ccpspw(cmd(1:il))
       CALL CCPDPN(24,tmp,'OLD','F',0,0)
20	 read (24,'(a)',end=40) tmpk
       lk = lenstr(tmpk)
c	 print*, tmpk(1:lk)
       if (index(tmpk,'No such').ne.0) then
        itry = ntry
        close (24,status='delete')
        goto 50
       end if
       if (index(tmpk,'saved').eq.0) goto 20
c
       close (24,status='delete')
       cmd = 'uncompress -f '//filename//'.Z '//filename
c	1 //' ; chmod 755 '//filename
       il = lenstr(cmd)
c	 write(6,'(a)') cmd(1:il)
       call ccpspw(cmd)
       ftppdb = .true.	
      else if (index(site,'current_').ne.0) then
       cmd = 'wget --tries=10 -O '//filename//' '//site
     +   //char(47)//code(2:3)//char(47)
     +   //'pdb'//code//'.ent'
c    +   //' ; chmod 755 '//'pdb'//code//'.ent'
       il = lenstr(cmd)
c	 write(6,'(a)') cmd(1:il)
       call ccpspw(cmd)
       ftppdb = .true.
      else if (index(site,'uncompress').eq.0) then
c	 cmd = 'wget --tries=10 -O - '//site(1:6)
c     +   //'anonymous:top%40internet@'//site(7:ln)
c     +   //'pdb'//code//'.ent.Z '//char(124)
c     +   //' uncompress >'//filename
       cmd = 'wget --tries=10 -O - '//site(1:6)
     +   //site(7:ln)
     +   //'pdb'//code//'.ent.Z '//char(124)
     +   //' uncompress >'//filename
c     +   //' ; chmod 755 '//filename
       il = lenstr(cmd)
c	 write(6,'(a)') cmd(1:il)
       call ccpspw(cmd)
       ftppdb = .true.
      else
       cmd = 'wget --tries=10 -O '//filename//' '//site
     +    //'pdb'//code//'.ent'
c     +    //' ; chmod 755 '//'pdb'//code//'.ent'
       il = lenstr(cmd)
c	 write(6,'(a)') cmd(1:il)
       call ccpspw(cmd)
       ftppdb = .true.
      end if
c	write(6,'(a)') cmd(1:il)
      return
c try again
40	continue
      write(6,*) 'No saved?'
      close (24,status='delete')
50	continue
      itry = itry + 1
      if (itry.ge.ntry) then
       ftppdb = .false.
       write(6,'(a)') 'Fail to get '//code//' from the site '
       return
      end if
      goto 10
      end
c
      function httppdb(site,code,filename)
      logical*1 httppdb
      character*(*) site,filename
      character*4 code
      character*180 cmd
c
      ln= lenstr(site)
      cmd = 'wget --tries=10 -O - '//site
     +  //char(47)//'pdb-bin'//char(47)
     +  //'send-pdb'//char(37)//'3Ffilename'//char(37)//'3D'//code
     +  //' | pdbhtf > '//filename
c     +//' ; chmod 755 '//filename
      il = lenstr(cmd)
c	write(6,'(a)') cmd(1:il)
      print*, ' '
      call ccpspw(cmd)
      httppdb = .true.
      end
c
      subroutine getinfo(psite,site,sit3db)
      character*(*) psite,site,sit3db
      character*180 cmd
      character file*20,txt*80
      data file/'pdbtmp'/,txt/' '/
      character*1 sl
      sl = char(47)
      ln= lenstr(psite)
      sit3db = psite(1:ln)
      l1 = index(psite(1:ln),'//')
      l2 = index(psite(l1+2:ln),'/')
      if (l2.eq.0) then
       l2 = ln
      end if
      ln = l2
      cmd = 'wget --tries=10 -O - '//psite(1:ln)//char(47)//
     +   'pdb-bin'//sl//
     +   'info%3Fftp > '//file(1:6)
      il = lenstr(cmd)
c	write(6,'(a)') cmd(1:il)
      call ccpspw(cmd(1:il))
      CALL CCPDPN(17,file(1:6),'UNKNOWN','F',0,0)
      read(17,'(a)') txt
      close (17,status='delete')
      is = index(txt,'ftp')
      ls = lenstr(txt)
      if (is.ge.0.) then
       site = txt(is:ls)//sl//'current_release'//sl//'compressed_files'
     +    //sl
      else
       write(6,*) 'ERROR STOP>>> This PDB mirror site does not work'//
     +  ' properly'
       stop 'ERROR STOP>>>'
      end if
      end 
c
      subroutine getlis(site,filename)
      character*(*) site,filename
      character*180 cmd
      character gt*3
      ln= lenstr(site)
      if (site(ln:ln).ne.char(47)) then
       ln = ln + 1
       site(ln:ln) = char(47)
c	 write(6,*) 'ERROR in site name',site
c	 write(6,*) 'last character of a site name must be ',char(47)
c	 stop ' ERROR STOP'
      end if
c
      gt = char(34)//char(62)//char(34)
c	lt = char(34)//char(60)//char(34)
c
      filename = 'entries.all'
      if (index(site,'uncomp').gt.0) then
       cmd = 'wget --tries=10 -O - '//site(1:ln)//
     +  ' | grep ent '//
     +  '| cut -f 2 -d '//gt//' | cut -c4-7 > '//filename
      else
       cmd = 'wget --tries=10 -O - '//site(1:ln)//
     +  ' | grep ent.Z '//
     +  '| cut -f 2 -d '//gt//' | cut -c4-7 > '//filename
      end if
c
c	write(6,'(a)') cmd
      call ccpspw(cmd)
      end
c
      subroutine getlist(site,filename)
      character*(*) site,filename
      character*180 cmd
      character gt*3
      ln= lenstr(site)
      if (site(ln:ln).ne.char(47)) then
       do j = ln, 1, -1
        if (site(j:j).eq.char(47)) goto 10
       end do
       write(6,'(2a)') 'Strange site  name: ',site(1:ln)
       stop 'ERROR STOP'
10	 continue
       ll = ln
       if (site(ln-1:ln).eq.'.Z') ll = ln-2
       filename=site(j+1:ll)
      else
        filename='index.lis'
      endif
c
      gt = char(34)//char(62)//char(34)
c	lt = char(34)//char(60)//char(34)
c
      if (site(1:4).eq.'ftp:'.and.site(ln:ln).ne.'Z') then
       cmd = 'wget --tries=10 -O - '//site(1:ln)//
     +  ' > '//filename
c     +  //' ; chmod 755 '//filename
      else if (site(1:4).eq.'ftp:'.and.site(ln:ln).eq.'Z') then
       cmd = 'wget --tries=10 -O - '//site(1:ln)//
     +  ' | uncompress > '//filename
c     + //' ; chmod 755 '//filename
      else
       cmd = 'wget --tries=10 -O - '//site(1:ln)//
     +  ' | pdbhtf > '//filename
c     +  //' ; chmod 755 '//filename
      end if
c
      il = lenstr(cmd)
c	write(6,'(a)') cmd(1:il)
      call ccpspw(cmd(1:il))
      end

      subroutine getentidx(site,filename)
      character*(*) site,filename
      character*180 cmd
      character gt*3
      ln= lenstr(site)
c	if (site(ln:ln).ne.char(47)) then
c	 write(6,*) 'ERROR in site name',site
c	 write(6,*) 'last character of a site name must be ',char(47)
c	 stop ' ERROR STOP'
c	end if
      gt = char(34)//char(62)//char(34)
c	lt = char(34)//char(60)//char(34)
c
      filename = 'entries.idx'
      cmd = 'wget --tries=10 -O - '//site(1:ln)//
     + ' | tail +4'//
     + ' | cut -c1-4 > '//filename
c	write(6,'(a)') cmd
      call ccpspw(cmd)
      end
c
      subroutine getidall(site,filename)
      character*(*) site,filename
      character*180 cmd
      character dte*9
      call ccpdat (dte)
c	write(6,'(a)') dte
      read(dte(1:2),'(i2)') idate
      iy = idate -1
      write(dte(1:2),'(i2)') iy
      call spstrunct(dte)
      ldte = lenstr(dte)
c	write(6,'(a)') dte

c
      ln= lenstr(site)
      filename = 'pdbid.all'
      print*, 'Request list all PDB entries from ',site(1:ln), 
     +  ' and save in '//filename(1:9)
c	cmd = 'wget -O - '//site(1:ln)//char(47)//'pdb-bin'//
c     + char(47)//'pdbids%3Fid=all%26m=du | tail +5 > '
c     + //filename(1:9)
      cmd = 'wget -o b.tmp -O - '//site(1:ln)//char(47)//'pdb-bin'//
     + char(47)//'pdbids%3Fex=xrd+or+nmr%26dat=rel%26'//
     + 'upper='//dte(1:ldte)//'%26m=du | tail +8 > '
     + //filename(1:9)
      il = lenstr(cmd)
c	print*, cmd(1:il)
      call ccpspw(cmd(1:il))
      end
c
      subroutine b3dbsite(text)
      character*5000 cmd,cmd1,cmdold
      data cmd1/' '/,cmdold/' '/
      character*80 site3db
      data site3db/'http://www.pdb.bnl.gov'/
      character*(*) text,filename
      character*3 dat3db,datform
      data dat3db/'rel'/
      integer lcmd,lsite3db
      data lcmd/0/,lsite3db/22/
      save site3db,dat3db
      save lsite3db
c
      lsite3db = lenstr(text)
      site3db(1:lsite3db)=text(1:lsite3db)
c
      return
c
      entry b3dbcmd(text)
      ltxt = lenstr(text)
      il = lenstr(cmdold)
      if (il.eq.0) then
       cmd1(1:ltxt) = text(1:ltxt)
      else
       cmd1 = cmdold(1:il)//'%26'//text(1:ltxt)
      end if
      il2 = lenstr(cmd1)
c	print*, cmd1(1:il2)
      cmdold = cmd1
      return
c
      entry b3dbdat(datform)
      dat3db=datform
      return
c
      entry b3dbgo(filename)
      lf = lenstr(filename)
      if (lf.eq.0) then
       filename = '3db.list'
       lf = 8
      end if
c default dat=rel
      il = lenstr(cmd1)
      if (index(cmd1,'upper').ne.0.or.index(cmd1,'lower').ne.0) then
       cmd1 = cmdold(1:il)//'dat='//dat3db
       il = il + 7
       cmdold = cmd1(1:il)
      end if
c
      il = lenstr(cmd1)
      cmd = 'wget --tries=10 -O - '//site3db(1:lsite3db)//
     + char(47)//'pdb-bin'
     +  //char(47)//'pdbids%3F'//cmd1(1:il)//'%26'
     +  //'ex=xrd+or+nmr%26m=du%26lim=2000 | tail +8  > '
     +  //filename(1:lf)
      ic = lenstr(cmd)
c	write(6,'(a)') cmd(1:ic)
      call ccpspw(cmd(1:ic))
c	print*, '3DB Query file is written to',filename(1:lf)//
c    + ' with following structures'
c	call ccpspw('cat '//,filename(1:lf))
c
      end
c
      subroutine getpdbcacb(x,xcb,cbb,res,seq,natm,ncb,filnam)
C A subroutine to read the Protein data bank format coordinate file
c In this version only Ca atoms are read. -- Guoguang 950922
c X 3*20000 arrays, output xyz coordinates
c ATOM 20000 character*4 arrays, output atom names
c RES 20000 character*4 arrays, output residue number e.g. A101 A103...
C  If residue number is like A   1 then it will become A1
c SEQ 20000 character*4 arrays, output peptide name. e.g. PHE TRY ....
C NATM is the number of atoms in the coordinate file
c FILNAT is the file name of the coordinate.
c
      PARAMETER (MAXATM=20000)
c	include 'maps.inc'
C
      DIMENSION X(3,MAXATM),xcb(3,MAXATM),x0(3),x1(3),x2(3)
C	CHARACTER*4 ATOM(MAXATM)
      CHARACTER*4 ATM
      CHARACTER*4 RES(MAXATM),SEQ(MAXATM),RES2
      CHARACTER FILNAM*80,HEAD*6,RES1*5,res1old*5
      character*66 txt
      logical*1 rca,rcb,cbb(maxatm)
C	DATA FILNAM/'DIAMOND'/
C
c      CALL SPSTRUNCT(FILNAM)
c	OPEN (3,FILE=FILNAM, STATUS='OLD',READONLY,ERR=400)
      CALL CCPDPN(3,FILNAM,'OLD','F',0,0)
C
      res1old = 'XYZWV'
      ncb = 0
      NATM = 0
c	NATM2 = 0
c	call arrvalue(3,xcb(1,1),0.)
      rca = .false.
      rcb = .false.
      cbb(1) = .false.
c5	READ(3,10,ERR=5,END=20) HEAD, ATOM(NATM), SEQ(NATM), RES1
c	1 , (X(I,NATM),I=1,3)
5	read(3,'(a)',END=20) txt
c	NATM2 = NATM2 + 1
c10	FORMAT(A6,7X,2A4,A5,4X,3F8.3)
      IF (TXT(1:3).EQ.'END') GOTO 20
      IF (TXT(1:4).NE.'ATOM') GOTO 5
      READ(TXT(31:54),10,ERR=5) (X0(I),I=1,3)
10	FORMAT(3F8.3)
      RES1 = TXT(22:26)
      if (res1old.ne.res1) then
       if (natm.gt.0.and.rca.and.rcb) then
        call arrps(3,1,x1,x(1,natm),x2)
        call arrmc(3,1,x2,1./vem(3,x2),xcb(1,natm))
c	  write(6,*) 'xca',natm,(x(j,natm),j=1,3)
c	  write(6,*) 'xcb',natm,(x1(j),j=1,3)
c	  write(6,*) 'vcb',natm,(xcb(j,natm),j=1,3)
        cbb(natm)=.true.
        ncb = ncb + 1
        rca = .false.
        rcb = .false.
       end if
       NATM = NATM + 1
       IF (NATM.GT.MAXATM) THEN
        WRITE(6,*) 'MAXATM = ',MAXATM
        STOP 'Atoms can not be more than MAXATM'
       END IF
       cbb(natm)=.false.
      end if
      res1old = res1
c	call arrvalue(3,xcb(1,natm),0.)
      IF (TXT(14:16).NE.'CA '.AND.TXT(14:16).NE.'CB ')  GOTO 5
      ATM = TXT(14:17)
      IF (ATM.EQ.'CA A') ATM='CA  '
      IF (ATM.EQ.'CB A') ATM='CB  '
C
c	write(6,*) natm,atm
      IF (ATM.EQ.'CA  ') THEN
       call arrgive(3,x0,x(1,natm))
       rca = .true.
       SEQ(NATM) = TXT(18:21)
c	 write(6,*) 'ca ',natm,seq(natm),res1,natm2,res1old
       IF (RES1(1:1).NE.' '.AND.RES1(2:2).EQ.' ') THEN
        RES2(1:1) = RES1(1:1)
        RES2(2:4) = RES1(3:5)
       ELSE
        RES2 = RES1(2:5)
       END IF
c	 call spstrunct(atm)
       call spstrunct(seq(natm))
       call spstrunct(RES2)
       res(natm)=res2
c	 write(6,*) 'ca ',natm,atm,res(natm),res1
c	 write(6,*) 'ca ',(x(j,natm),j=1,3)
C
      ELSE IF (ATM.EQ.'CB  ') THEN
       call arrgive(3,x0,x1)
       rcb = .true.
c	 write(6,*) 'cb ',natm,atm,res1
c	 write(6,*) 'ca ',x1
      END IF
C
12	CONTINUE
C
      GOTO 5
20	CONTINUE
c	NATM = NATM - 1
       if (natm.gt.0.and.rca.and.rcb) then
        call arrps(3,1,x1,x(1,natm),x2)
        call arrmc(3,1,x2,1./vem(3,x2),xcb(1,natm))
c	  write(6,*) 'xcb',natm,(xcb(j,natm),j=1,3)
        cbb(natm)=.true.
        ncb = ncb + 1
        rca = .false.
        rcb = .false.
       end if
      CLOSE (3)
      return
400	write(6,*) 'ERROR -- cannot open file: ',filnam
      natm = 0
      return
C
      END
c
      subroutine namreset2(rname2,ch,rnam)
      character rname*6,rname2*6,ch*1,rnam*4
      character*10 num
      data num/'1234567890'/
c
      rname = rname2
      do i = 1, 10
       if (rname(1:1).eq.num(i:i)) then
        ch = ' '
        goto 20
       end if
      end do
      ch = rname(1:1)
      rname(1:1) = ' '

20	continue
      if (rname(6:6).eq.' ') then
       do i = 6,2,-1
        rname(i:i) = rname(i-1:i-1)
       end do
       rname(1:1) = ' '
       goto 20
      end if
      rnam(1:4) = rname(3:6)

      END
